CREATE DATABASE dicom_dd WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';

\connect dicom_dd

create table dicom_element(
  tag text unique,
  name text,
  keyword text unique,
  vr text,
  vm text,
  is_retired boolean,
  comments text
);
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: dicom_roots; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE dicom_roots WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect dicom_roots

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: db_version; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA db_version;


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: version; Type: TABLE; Schema: db_version; Owner: -
--

CREATE TABLE db_version.version (
    version integer
);


--
-- Name: collection; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.collection (
    collection_id integer NOT NULL,
    collection_code text
);


--
-- Name: collection_collection_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.collection_collection_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: collection_collection_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.collection_collection_id_seq OWNED BY public.collection.collection_id;


--
-- Name: site; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.site (
    site_id integer NOT NULL,
    site_code text
);


--
-- Name: site_site_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.site_site_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: site_site_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.site_site_id_seq OWNED BY public.site.site_id;


--
-- Name: submission; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.submission (
    submission_id integer NOT NULL,
    collection_id integer NOT NULL,
    site_id integer NOT NULL,
    collection_name text,
    site_name text,
    body_part_entered text,
    patient_id_prefix text,
    access_type text,
    date_inc text,
    extra text
);


--
-- Name: submission_submission_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.submission_submission_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: submission_submission_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.submission_submission_id_seq OWNED BY public.submission.submission_id;


--
-- Name: submissionevent; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.submissionevent (
    submission_id integer NOT NULL,
    event_type text,
    occurance_date_time timestamp with time zone,
    reporting_user text,
    comment text
);


--
-- Name: collection collection_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.collection ALTER COLUMN collection_id SET DEFAULT nextval('public.collection_collection_id_seq'::regclass);


--
-- Name: site site_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.site ALTER COLUMN site_id SET DEFAULT nextval('public.site_site_id_seq'::regclass);


--
-- Name: submission submission_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.submission ALTER COLUMN submission_id SET DEFAULT nextval('public.submission_submission_id_seq'::regclass);


--
-- Name: collection collection_collection_code_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.collection
    ADD CONSTRAINT collection_collection_code_key UNIQUE (collection_code);


--
-- Name: site site_site_code_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.site
    ADD CONSTRAINT site_site_code_key UNIQUE (site_code);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_appstats; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_appstats WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_appstats

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: app_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.app_instance (
    app_instance_id integer NOT NULL,
    started_at timestamp with time zone,
    pid integer
);


--
-- Name: app_instance_app_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.app_instance_app_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: app_instance_app_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.app_instance_app_instance_id_seq OWNED BY public.app_instance.app_instance_id;


--
-- Name: app_measurement; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.app_measurement (
    app_instance_id integer NOT NULL,
    at timestamp with time zone,
    pcpu double precision,
    sz integer,
    vsz bigint,
    num_rcv_sessions integer,
    num_running_apps integer,
    files_in_db_backlog integer,
    dirs_in_receive_backlog integer,
    running_edits_extracts integer,
    queued_edits_extracts integer,
    running_sends integer,
    queued_sends integer,
    running_discards integer,
    num_locks integer,
    num_sessions integer,
    total_transactions integer,
    avg_import_time integer
);


--
-- Name: app_instance app_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.app_instance ALTER COLUMN app_instance_id SET DEFAULT nextval('public.app_instance_app_instance_id_seq'::regclass);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_auth; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_auth WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_auth

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: db_version; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA db_version;


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: version; Type: TABLE; Schema: db_version; Owner: -
--

CREATE TABLE db_version.version (
    version integer
);


--
-- Name: apps; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.apps (
    app_id integer NOT NULL,
    app_name text NOT NULL
);


--
-- Name: apps_app_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.apps_app_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: apps_app_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.apps_app_id_seq OWNED BY public.apps.app_id;


--
-- Name: permissions; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.permissions (
    permission_id integer NOT NULL,
    app_id integer,
    permission_name text NOT NULL
);


--
-- Name: permissions_permission_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.permissions_permission_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: permissions_permission_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.permissions_permission_id_seq OWNED BY public.permissions.permission_id;


--
-- Name: user_permissions; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_permissions (
    user_id integer,
    permission_id integer
);


--
-- Name: users; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.users (
    user_id integer NOT NULL,
    user_name text NOT NULL,
    full_name text NOT NULL,
    password text
);


--
-- Name: users_user_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.users_user_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: users_user_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.users_user_id_seq OWNED BY public.users.user_id;


--
-- Name: apps app_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.apps ALTER COLUMN app_id SET DEFAULT nextval('public.apps_app_id_seq'::regclass);


--
-- Name: permissions permission_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.permissions ALTER COLUMN permission_id SET DEFAULT nextval('public.permissions_permission_id_seq'::regclass);


--
-- Name: users user_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.users ALTER COLUMN user_id SET DEFAULT nextval('public.users_user_id_seq'::regclass);


--
-- Name: apps apps_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.apps
    ADD CONSTRAINT apps_pkey PRIMARY KEY (app_id);


--
-- Name: permissions permissions_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.permissions
    ADD CONSTRAINT permissions_pkey PRIMARY KEY (permission_id);


--
-- Name: users users_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_pkey PRIMARY KEY (user_id);


--
-- Name: users users_user_name_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_user_name_key UNIQUE (user_name);


--
-- Name: permissions permissions_app_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.permissions
    ADD CONSTRAINT permissions_app_id_fkey FOREIGN KEY (app_id) REFERENCES public.apps(app_id) ON DELETE CASCADE;


--
-- Name: user_permissions user_permissions_permission_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_permissions
    ADD CONSTRAINT user_permissions_permission_id_fkey FOREIGN KEY (permission_id) REFERENCES public.permissions(permission_id) ON DELETE CASCADE;


--
-- Name: user_permissions user_permissions_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_permissions
    ADD CONSTRAINT user_permissions_user_id_fkey FOREIGN KEY (user_id) REFERENCES public.users(user_id) ON DELETE CASCADE;


--
-- PostgreSQL database dump complete
--

COPY public.apps (app_id, app_name) FROM stdin;
1	UserAdmin
2	PosdaCuration
3	PhiFixer
4	ReviewPhi
5	SubmissionSender
6	CountGetter
7	FileDist
8	DicomProxy
9	DicomProxyAnalysis
10	DbIf
11	Kaleidoscope
12	NewItcTools
\.

SELECT pg_catalog.setval('public.apps_app_id_seq', 12, true);

COPY public.permissions (permission_id, app_id, permission_name) FROM stdin;
1	1	launch
2	2	launch
3	3	launch
4	4	launch
5	5	launch
6	6	launch
7	7	launch
8	8	launch
9	9	launch
10	10	launch
11	1	debug
12	2	debug
13	3	debug
14	4	debug
15	5	debug
16	6	debug
17	7	debug
18	8	debug
19	9	debug
20	10	debug
22	11	launch
23	11	debug
38	10	superuser
44	12	debug
45	12	launch
46	10	curator
47	10	workflow_1
48	10	legacy_bbennett
\.

SELECT pg_catalog.setval('public.permissions_permission_id_seq', 49, true);

COPY public.users (user_id, user_name, full_name, password) FROM stdin;
1	admin	Default Admin Account	aJE5lY8D,2wUueoiymAn8HsfbdAp0kPfTiODV7kpeNUttYTgQGbE
\.

SELECT pg_catalog.setval('public.users_user_id_seq', 2, true);

COPY public.user_permissions (user_id, permission_id) FROM stdin;
1	20
1	1
1	11
1	10
1	22
1	23
1	48
1	47
1	46
\.
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_backlog; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_backlog WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_backlog

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: collection_count_per_round; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.collection_count_per_round (
    collection text NOT NULL,
    file_count integer NOT NULL
);


--
-- Name: control_status; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.control_status (
    status text NOT NULL,
    processor_pid text,
    idle_poll_interval interval,
    last_service timestamp without time zone,
    pending_change_request text,
    source_pending_change_request text,
    request_time timestamp without time zone,
    num_files_per_round integer,
    target_queue_size integer
);


--
-- Name: request; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.request (
    request_id integer NOT NULL,
    submitter_id integer NOT NULL,
    received_file_path text,
    copied_file_path text,
    file_copied boolean,
    copy_error boolean,
    copy_path text,
    file_digest text,
    file_in_posda boolean,
    import_error boolean,
    time_received timestamp without time zone,
    time_copied timestamp without time zone,
    time_entered timestamp without time zone,
    size integer,
    posda_file_id integer
);


--
-- Name: request_error; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.request_error (
    request_id integer NOT NULL,
    error_time timestamp without time zone,
    error_description text
);


--
-- Name: request_request_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.request_request_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: request_request_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.request_request_id_seq OWNED BY public.request.request_id;


--
-- Name: round; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.round (
    round_id integer NOT NULL,
    round_start timestamp without time zone,
    round_end timestamp without time zone,
    round_created timestamp without time zone,
    round_aborted timestamp without time zone,
    wait_count integer,
    process_count integer
);


--
-- Name: round_collection; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.round_collection (
    round_id integer NOT NULL,
    collection text NOT NULL,
    num_entered integer,
    num_failed integer,
    num_dups integer
);


--
-- Name: round_counts; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.round_counts (
    round_id integer NOT NULL,
    collection text NOT NULL,
    num_requests integer,
    priority integer
);


--
-- Name: round_round_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.round_round_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: round_round_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.round_round_id_seq OWNED BY public.round.round_id;


--
-- Name: submitter; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.submitter (
    submitter_id integer NOT NULL,
    collection text NOT NULL,
    site text NOT NULL,
    subj text NOT NULL,
    priority integer
);


--
-- Name: submitter_submitter_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.submitter_submitter_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: submitter_submitter_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.submitter_submitter_id_seq OWNED BY public.submitter.submitter_id;


--
-- Name: request request_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.request ALTER COLUMN request_id SET DEFAULT nextval('public.request_request_id_seq'::regclass);


--
-- Name: round round_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.round ALTER COLUMN round_id SET DEFAULT nextval('public.round_round_id_seq'::regclass);


--
-- Name: submitter submitter_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.submitter ALTER COLUMN submitter_id SET DEFAULT nextval('public.submitter_submitter_id_seq'::regclass);


--
-- Name: collection_count_per_round collection_count_per_round_collection_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.collection_count_per_round
    ADD CONSTRAINT collection_count_per_round_collection_key UNIQUE (collection);


--
-- Name: posda_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX posda_file_id_index ON public.request USING btree (posda_file_id);


--
-- Name: request_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX request_lookup ON public.request USING btree (submitter_id, file_in_posda, file_copied, copy_error, import_error);


--
-- Name: submitter_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX submitter_lookup ON public.submitter USING btree (collection, site, subj);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_counts; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_counts WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_counts

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: count_report; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.count_report (
    count_report_id integer NOT NULL,
    at timestamp with time zone
);


--
-- Name: count_report_count_report_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.count_report_count_report_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: count_report_count_report_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.count_report_count_report_id_seq OWNED BY public.count_report.count_report_id;


--
-- Name: totals_by_collection_site; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.totals_by_collection_site (
    count_report_id integer NOT NULL,
    collection_name text,
    site_name text,
    num_subjects integer,
    num_studies integer,
    num_series integer,
    num_sops integer
);


--
-- Name: count_report count_report_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.count_report ALTER COLUMN count_report_id SET DEFAULT nextval('public.count_report_count_report_id_seq'::regclass);


--
-- PostgreSQL database dump complete
--

CREATE DATABASE posda_files WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_files
--
-- PostgreSQL database dump
--

-- Dumped from database version 10.1
-- Dumped by pg_dump version 11.3

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: db_version; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA db_version;


--
-- Name: dbif_config; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA dbif_config;


--
-- Name: dicom_conv; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA dicom_conv;


--
-- Name: quasar; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA quasar;


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: version; Type: TABLE; Schema: db_version; Owner: -
--

CREATE TABLE db_version.version (
    version integer
);


--
-- Name: background_buttons; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.background_buttons (
    background_button_id integer NOT NULL,
    operation_name text,
    object_class text,
    button_text text,
    tags text[]
);


--
-- Name: background_buttons_background_button_id_seq; Type: SEQUENCE; Schema: dbif_config; Owner: -
--

CREATE SEQUENCE dbif_config.background_buttons_background_button_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: background_buttons_background_button_id_seq; Type: SEQUENCE OWNED BY; Schema: dbif_config; Owner: -
--

ALTER SEQUENCE dbif_config.background_buttons_background_button_id_seq OWNED BY dbif_config.background_buttons.background_button_id;


--
-- Name: chained_query; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.chained_query (
    chained_query_id integer NOT NULL,
    from_query text NOT NULL,
    to_query text NOT NULL,
    caption text
);


--
-- Name: chained_query_chained_query_id_seq; Type: SEQUENCE; Schema: dbif_config; Owner: -
--

CREATE SEQUENCE dbif_config.chained_query_chained_query_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: chained_query_chained_query_id_seq; Type: SEQUENCE OWNED BY; Schema: dbif_config; Owner: -
--

ALTER SEQUENCE dbif_config.chained_query_chained_query_id_seq OWNED BY dbif_config.chained_query.chained_query_id;


--
-- Name: chained_query_cols_to_params; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.chained_query_cols_to_params (
    chained_query_id integer NOT NULL,
    from_column_name text NOT NULL,
    to_parameter_name text NOT NULL
);


--
-- Name: popup_buttons; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.popup_buttons (
    popup_button_id integer NOT NULL,
    name text,
    object_class text,
    btn_col text,
    is_full_table boolean,
    btn_name text
);


--
-- Name: popup_buttons_popup_button_id_seq1; Type: SEQUENCE; Schema: dbif_config; Owner: -
--

CREATE SEQUENCE dbif_config.popup_buttons_popup_button_id_seq1
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: popup_buttons_popup_button_id_seq1; Type: SEQUENCE OWNED BY; Schema: dbif_config; Owner: -
--

ALTER SEQUENCE dbif_config.popup_buttons_popup_button_id_seq1 OWNED BY dbif_config.popup_buttons.popup_button_id;


--
-- Name: queries; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.queries (
    name text,
    query text,
    args text[],
    columns text[],
    tags text[],
    schema text,
    description text
);


--
-- Name: query_tabs; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.query_tabs (
    query_tab_name text,
    query_tab_description text,
    defines_dropdown boolean,
    sort_order integer,
    defines_search_engine boolean
);


--
-- Name: query_tabs_query_tag_filter; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.query_tabs_query_tag_filter (
    query_tab_name text NOT NULL,
    filter_name text NOT NULL,
    sort_order integer NOT NULL
);


--
-- Name: query_tag_filter; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.query_tag_filter (
    filter_name text,
    tags_enabled text[]
);


--
-- Name: role; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.role (
    role_name text NOT NULL
);


--
-- Name: role_tabs; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.role_tabs (
    role_name text,
    query_tab_name text,
    sort_order integer
);


--
-- Name: spreadsheet_operation; Type: TABLE; Schema: dbif_config; Owner: -
--

CREATE TABLE dbif_config.spreadsheet_operation (
    operation_name text NOT NULL,
    command_line text,
    operation_type text,
    input_line_format text,
    tags text[],
    can_chain boolean
);


--
-- Name: dicom_module_to_posda_table; Type: TABLE; Schema: dicom_conv; Owner: -
--

CREATE TABLE dicom_conv.dicom_module_to_posda_table (
    dicom_module_name text,
    create_row_query text,
    table_name text
);


--
-- Name: dicom_tag_parm_column_table; Type: TABLE; Schema: dicom_conv; Owner: -
--

CREATE TABLE dicom_conv.dicom_tag_parm_column_table (
    tag text,
    tag_cannonical_name text,
    posda_table_name text,
    column_name text
);


--
-- Name: tag_preparation; Type: TABLE; Schema: dicom_conv; Owner: -
--

CREATE TABLE dicom_conv.tag_preparation (
    tag_cannonical_name text,
    preparation_description text
);


--
-- Name: activity; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity (
    activity_id integer NOT NULL,
    brief_description text,
    when_created timestamp with time zone,
    who_created text,
    when_closed timestamp with time zone
);


--
-- Name: activity_activity_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.activity_activity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: activity_activity_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.activity_activity_id_seq OWNED BY public.activity.activity_id;


--
-- Name: activity_inbox_content; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity_inbox_content (
    activity_id integer NOT NULL,
    user_inbox_content_id integer NOT NULL
);


--
-- Name: activity_posda_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity_posda_file (
    activity_id integer NOT NULL,
    file_id_in_posda integer NOT NULL,
    association_description text
);


--
-- Name: activity_task_status; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity_task_status (
    activity_id integer NOT NULL,
    subprocess_invocation_id integer NOT NULL,
    status_text text,
    start_time timestamp without time zone NOT NULL,
    end_time timestamp without time zone,
    last_updated timestamp without time zone,
    expected_remaining_time interval,
    dismissed_time timestamp without time zone,
    dismissed_by text
);


--
-- Name: activity_timepoint; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity_timepoint (
    activity_timepoint_id integer NOT NULL,
    activity_id integer NOT NULL,
    when_created timestamp without time zone,
    who_created text,
    comment text,
    creating_user text
);


--
-- Name: activity_timepoint_activity_timepoint_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.activity_timepoint_activity_timepoint_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: activity_timepoint_activity_timepoint_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.activity_timepoint_activity_timepoint_id_seq OWNED BY public.activity_timepoint.activity_timepoint_id;


--
-- Name: activity_timepoint_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.activity_timepoint_file (
    activity_timepoint_id integer NOT NULL,
    file_id integer NOT NULL
);


--
-- Name: adverse_file_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.adverse_file_event (
    adverse_file_event_id integer NOT NULL,
    file_id integer NOT NULL,
    event_description text,
    when_occured timestamp with time zone
);


--
-- Name: adverse_file_event_adverse_file_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.adverse_file_event_adverse_file_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: adverse_file_event_adverse_file_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.adverse_file_event_adverse_file_event_id_seq OWNED BY public.adverse_file_event.adverse_file_event_id;


--
-- Name: association; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association (
    association_id integer NOT NULL,
    called_ae_title text,
    calling_ae_title text,
    start_time timestamp with time zone,
    duration integer,
    originating_ip_addr text,
    processing text,
    session_info_file text
);


--
-- Name: association_association_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.association_association_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: association_association_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.association_association_id_seq OWNED BY public.association.association_id;


--
-- Name: association_errors; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association_errors (
    association_id integer NOT NULL,
    error_type text,
    error_line text
);


--
-- Name: association_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association_file (
    association_id integer NOT NULL,
    file_id integer NOT NULL,
    file_path text NOT NULL,
    assoc_sop_class text NOT NULL,
    assoc_sop_inst text NOT NULL,
    assoc_xfr_stx text NOT NULL,
    assoc_path text NOT NULL
);


--
-- Name: association_import; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association_import (
    association_id integer NOT NULL,
    import_event_id integer NOT NULL
);


--
-- Name: association_pc; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association_pc (
    association_pc_id integer NOT NULL,
    association_id integer NOT NULL,
    abstract_syntax_uid text,
    accepted boolean NOT NULL,
    not_accepted_reason integer,
    accepted_ts text
);


--
-- Name: association_pc_association_pc_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.association_pc_association_pc_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: association_pc_association_pc_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.association_pc_association_pc_id_seq OWNED BY public.association_pc.association_pc_id;


--
-- Name: association_pc_proposed_ts; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.association_pc_proposed_ts (
    association_pc_id integer NOT NULL,
    proposed_ts_uid text NOT NULL
);


--
-- Name: background_input_line; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.background_input_line (
    background_subprocess_id integer NOT NULL,
    line_number integer,
    line text
);


--
-- Name: background_subprocess; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.background_subprocess (
    background_subprocess_id integer NOT NULL,
    subprocess_invocation_id integer,
    input_rows_processed integer,
    command_executed text,
    foreground_pid integer,
    background_pid integer,
    when_script_started timestamp with time zone,
    when_background_entered timestamp with time zone,
    when_script_ended timestamp with time zone,
    user_to_notify text,
    process_error text,
    crash text,
    crash_date timestamp without time zone
);


--
-- Name: COLUMN background_subprocess.crash; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN public.background_subprocess.crash IS 'Text stored if the subprocess crashes';


--
-- Name: background_subprocess_background_subprocess_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.background_subprocess_background_subprocess_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: background_subprocess_background_subprocess_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.background_subprocess_background_subprocess_id_seq OWNED BY public.background_subprocess.background_subprocess_id;


--
-- Name: background_subprocess_params; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.background_subprocess_params (
    background_subprocess_id integer NOT NULL,
    param_index integer,
    param_value text
);


--
-- Name: background_subprocess_report; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.background_subprocess_report (
    background_subprocess_report_id integer NOT NULL,
    background_subprocess_id integer,
    file_id integer NOT NULL,
    name text NOT NULL
);


--
-- Name: background_subprocess_report_background_subprocess_report_i_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.background_subprocess_report_background_subprocess_report_i_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: background_subprocess_report_background_subprocess_report_i_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.background_subprocess_report_background_subprocess_report_i_seq OWNED BY public.background_subprocess_report.background_subprocess_report_id;


--
-- Name: beam_applicator; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_applicator (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    applicator_id text NOT NULL,
    applicator_accessory_code text,
    applicator_type text,
    applicator_description text
);


--
-- Name: beam_block; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_block (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    block_number integer NOT NULL,
    block_tray_id text,
    block_accessory_code text,
    source_to_block_tray_distance text,
    block_type text,
    block_divergence text,
    block_mounting_position text,
    block_name text,
    material_id text,
    block_thickness text,
    block_transmission text,
    block_number_of_points integer,
    block_data text
);


--
-- Name: beam_bolus; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_bolus (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    referenced_roi_number integer NOT NULL,
    bolus_id text,
    bolus_accessory_code text,
    bolus_description text
);


--
-- Name: beam_compensator; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_compensator (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    compensator_number integer NOT NULL,
    compensator_type text,
    compensator_description text,
    material_id text,
    compensator_id text,
    compensator_accessory_code text,
    source_to_compensator_tray_distance text,
    compensator_divergence text,
    compensator_mounting_position text,
    compensator_rows text,
    compensator_cols text,
    compensator_pixel_spacing text,
    compensator_position text,
    compensator_transmission_data text,
    compensator_thickness_data text,
    source_to_compensator_distance text
);


--
-- Name: beam_control_point; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_control_point (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    control_point_index integer NOT NULL,
    cumulative_meterset_weight text,
    nominal_beam_energy text,
    dose_rate_set text,
    gantry_angle text,
    gantry_rotation_direction text,
    gantry_pitch_angle text,
    gantry_pitch_rotation_direction text,
    beam_limiting_device_angle text,
    beam_limiting_device_rotation_direction text,
    patient_support_angle text,
    patient_support_rotation_direction text,
    table_top_eccentric_axis_distance text,
    table_top_eccentric_angle text,
    table_top_eccentric_rotation_direction text,
    table_top_pitch_angle text,
    table_top_pitch_rotation_direction text,
    table_top_roll_angle text,
    table_top_roll_rotation_direction text,
    table_top_vertical_position text,
    table_top_longitudinal_position text,
    table_top_lateral_position text,
    isocenter_position text,
    surface_entry_point text,
    source_to_surface_distance text
);


--
-- Name: beam_general_accessory; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_general_accessory (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    general_accessory_number integer NOT NULL,
    general_accessory_id text NOT NULL,
    general_accessory_description text,
    general_accessory_type text,
    general_accessory_code text
);


--
-- Name: beam_limiting_device; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_limiting_device (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    bld_type text NOT NULL,
    source_to_bld_distance text,
    number_of_leaf_jaw_pairs integer NOT NULL,
    leaf_position_boundries text
);


--
-- Name: beam_wedge; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.beam_wedge (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    wedge_number integer NOT NULL,
    wedge_type text,
    wedge_id text,
    wedge_accessory_code text,
    wedge_angle text,
    wedge_factor text,
    wedge_orientation text,
    source_to_wedge_tray_distance text
);


--
-- Name: clinical_trial_qualified_patient_id; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.clinical_trial_qualified_patient_id (
    collection text,
    site text,
    patient_id text,
    qualified boolean
);


--
-- Name: collection_codes; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.collection_codes (
    collection_name text NOT NULL,
    collection_code text NOT NULL
);


--
-- Name: compare_public_to_posda_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.compare_public_to_posda_instance (
    compare_public_to_posda_instance_id integer NOT NULL,
    when_compare_started timestamp without time zone,
    when_compare_completed timestamp without time zone,
    status_of_compare text,
    number_of_sops integer,
    number_compares_completed integer,
    num_failed integer,
    last_updated timestamp without time zone
);


--
-- Name: compare_public_to_posda_insta_compare_public_to_posda_insta_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.compare_public_to_posda_insta_compare_public_to_posda_insta_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: compare_public_to_posda_insta_compare_public_to_posda_insta_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.compare_public_to_posda_insta_compare_public_to_posda_insta_seq OWNED BY public.compare_public_to_posda_instance.compare_public_to_posda_instance_id;


--
-- Name: contour_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.contour_image (
    roi_contour_id integer NOT NULL,
    sop_class text NOT NULL,
    sop_instance text NOT NULL,
    frame_number integer
);


--
-- Name: control_point_bld_position; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.control_point_bld_position (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    control_point_index integer NOT NULL,
    bld_type text NOT NULL,
    leaf_jaw_positions text NOT NULL
);


--
-- Name: control_point_dose_reference; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.control_point_dose_reference (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    control_point_index integer NOT NULL,
    sop_class_uid text NOT NULL,
    sop_instance_uid text NOT NULL
);


--
-- Name: control_point_reference_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.control_point_reference_dose (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    control_point_index integer NOT NULL,
    referenced_dose_reference_number integer NOT NULL,
    cumulative_dose_ref_coefficent text
);


--
-- Name: control_point_wedge_position; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.control_point_wedge_position (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    control_point_index integer NOT NULL,
    wedge_number integer NOT NULL,
    wedge_position text NOT NULL
);


--
-- Name: conversion_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.conversion_event (
    conversion_event_id integer NOT NULL,
    time_of_conversion timestamp with time zone,
    who_invoked_conversion text,
    conversion_program text
);


--
-- Name: conversion_event_conversion_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.conversion_event_conversion_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: conversion_event_conversion_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.conversion_event_conversion_event_id_seq OWNED BY public.conversion_event.conversion_event_id;


--
-- Name: copy_from_public; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.copy_from_public (
    copy_from_public_id integer NOT NULL,
    when_row_created timestamp without time zone,
    who text,
    why text,
    when_file_rows_populated timestamp without time zone,
    num_file_rows_populated integer,
    status_of_copy text,
    pid_of_running_process integer
);


--
-- Name: copy_from_public_copy_from_public_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.copy_from_public_copy_from_public_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: copy_from_public_copy_from_public_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.copy_from_public_copy_from_public_id_seq OWNED BY public.copy_from_public.copy_from_public_id;


--
-- Name: ctp_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ctp_file (
    file_id integer NOT NULL,
    project_name text,
    trial_name text,
    site_name text,
    site_id text,
    visibility text,
    file_visibility text,
    batch text,
    study_year text
);


--
-- Name: ctp_file_new; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ctp_file_new (
    file_id integer NOT NULL,
    project_name text,
    trial_name text,
    site_name text,
    site_id text,
    visibility text
);


--
-- Name: ctp_filex; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ctp_filex (
    file_id integer,
    project_name text,
    trial_name text,
    site_name text,
    site_id text,
    visibility text
);


--
-- Name: ctp_manifest_row; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ctp_manifest_row (
    file_id integer NOT NULL,
    cm_index integer,
    cm_collection text,
    cm_site text,
    cm_patient_id text,
    cm_study_date text,
    cm_series_instance_uid text,
    cm_study_description text,
    cm_series_description text,
    cm_modality text,
    cm_num_files integer
);


--
-- Name: ctp_upload_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ctp_upload_event (
    file_id integer NOT NULL,
    rcv_timestamp timestamp with time zone NOT NULL
);


--
-- Name: dbif_query_args; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dbif_query_args (
    query_invoked_by_dbif_id integer NOT NULL,
    arg_index integer,
    arg_name text,
    arg_value text
);


--
-- Name: dicom_dir; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_dir (
    file_id integer NOT NULL,
    fs_id text,
    fs_desc text,
    spec_char_set_of_desc text
);


--
-- Name: dicom_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    is_root boolean,
    is_active boolean,
    child_of integer,
    offset_in_file integer,
    length_in_file integer,
    rec_type text
);


--
-- Name: dicom_dir_rec_dicom_dir_rec_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dicom_dir_rec_dicom_dir_rec_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dicom_dir_rec_dicom_dir_rec_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dicom_dir_rec_dicom_dir_rec_id_seq OWNED BY public.dicom_dir_rec.dicom_dir_rec_id;


--
-- Name: dicom_edit_compare; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_edit_compare (
    from_file_digest text NOT NULL,
    to_file_digest text NOT NULL,
    short_report_file_id integer NOT NULL,
    long_report_file_id integer NOT NULL,
    to_file_path text,
    subprocess_invocation_id integer NOT NULL
);


--
-- Name: dicom_edit_compare_disposition; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_edit_compare_disposition (
    subprocess_invocation_id integer NOT NULL,
    start_creation_time timestamp without time zone,
    end_creation_time timestamp without time zone,
    number_edits_scheduled integer,
    number_compares_with_diffs integer,
    number_compares_without_diffs integer,
    current_disposition text,
    process_pid text,
    last_updated timestamp without time zone,
    dest_dir text
);


--
-- Name: dicom_edit_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_edit_event (
    dicom_edit_event_id integer NOT NULL,
    edit_desc_file integer,
    time_started timestamp with time zone,
    time_completed timestamp with time zone,
    report_file integer,
    notification_sent text,
    num_files integer,
    edits_done integer,
    process_id integer,
    edit_comment text
);


--
-- Name: dicom_edit_event_adverse_file_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_edit_event_adverse_file_event (
    dicom_edit_event_id integer NOT NULL,
    adverse_file_event_id integer NOT NULL
);


--
-- Name: dicom_edit_event_dicom_edit_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dicom_edit_event_dicom_edit_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dicom_edit_event_dicom_edit_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dicom_edit_event_dicom_edit_event_id_seq OWNED BY public.dicom_edit_event.dicom_edit_event_id;


--
-- Name: dicom_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_file (
    file_id integer NOT NULL,
    dataset_digest text,
    xfr_stx text,
    has_meta boolean,
    is_dicom_dir boolean,
    has_sop_common boolean,
    dicom_file_type text,
    has_pixel_data boolean,
    pixel_data_digest text,
    pixel_data_offset integer,
    pixel_data_length integer,
    has_no_roi_linkages boolean
);


--
-- Name: dicom_file_edit; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_file_edit (
    dicom_edit_event_id integer NOT NULL,
    from_file_digest text NOT NULL,
    to_file_digest text NOT NULL
);


--
-- Name: dicom_file_errors; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_file_errors (
    file_id integer NOT NULL,
    error_msg text
);


--
-- Name: dicom_file_send; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_file_send (
    dicom_send_event_id integer NOT NULL,
    file_path text,
    status text,
    file_id_sent integer
);


--
-- Name: dicom_icon_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_icon_image (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    image_id integer NOT NULL
);


--
-- Name: dicom_image_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_image_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_image_spec_char_set text,
    instance_number integer
);


--
-- Name: dicom_patient_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_patient_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_patient_spec_char_set text,
    patients_name text,
    patient_id text
);


--
-- Name: dicom_process_errors; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_process_errors (
    file_id integer NOT NULL,
    error_msg text
);


--
-- Name: dicom_rt_dose_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_rt_dose_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_rt_dose_spec_char_set text,
    instance_number integer,
    dose_summation_type text,
    dose_comment text
);


--
-- Name: dicom_rt_plan_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_rt_plan_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_rt_plan_spec_char_set text,
    instance_number integer,
    rt_plan_label text,
    rt_plan_date date,
    rt_plan_time time without time zone
);


--
-- Name: dicom_rt_structure_set_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_rt_structure_set_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_rt_structure_set_spec_char_set text,
    instance_number integer,
    structure_set_label text,
    structure_set_date date,
    structure_set_time time without time zone
);


--
-- Name: dicom_rt_treatment_rec_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_rt_treatment_rec_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_rt_treatment_rec_spec_char_set text,
    instance_number integer,
    rt_treatment_rec_date date,
    rt_treatment_rec_time time without time zone
);


--
-- Name: dicom_send_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_send_event (
    dicom_send_event_id integer NOT NULL,
    destination_host text NOT NULL,
    destination_port text NOT NULL,
    called_ae text NOT NULL,
    calling_ae text NOT NULL,
    send_started timestamp with time zone,
    send_ended timestamp with time zone,
    number_of_files integer,
    invoking_user text,
    reason_for_send text,
    is_series_send boolean,
    series_to_send text
);


--
-- Name: dicom_send_event_dicom_send_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dicom_send_event_dicom_send_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dicom_send_event_dicom_send_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dicom_send_event_dicom_send_event_id_seq OWNED BY public.dicom_send_event.dicom_send_event_id;


--
-- Name: dicom_series_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_series_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_series_spec_char_set text,
    modality text,
    series_instance_uid text,
    series_number text
);


--
-- Name: dicom_study_dir_rec; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dicom_study_dir_rec (
    file_id integer NOT NULL,
    dicom_dir_rec_id integer NOT NULL,
    dicom_study_spec_char_set text,
    study_date date,
    study_time time without time zone,
    accession_number text,
    study_description text,
    study_instance_uid text,
    study_id text
);


--
-- Name: distinguished_pixel_digest_pixel_value; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.distinguished_pixel_digest_pixel_value (
    pixel_digest text NOT NULL,
    pixel_value integer NOT NULL,
    num_occurances integer NOT NULL
);


--
-- Name: distinguished_pixel_digests; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.distinguished_pixel_digests (
    pixel_digest text NOT NULL,
    type_of_pixel_data text,
    sample_per_pixel integer,
    number_of_frames integer,
    pixel_rows integer,
    pixel_columns integer,
    bits_stored integer,
    bits_allocated integer,
    high_bit integer,
    pixel_mask integer,
    num_distinct_pixel_values integer
);


--
-- Name: dose_referenced_from_beam; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dose_referenced_from_beam (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    sop_class_uid text NOT NULL,
    sop_instance_uid text NOT NULL
);


--
-- Name: dose_referenced_from_plan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dose_referenced_from_plan (
    plan_id integer NOT NULL,
    dose_sop_instance_uid text
);


--
-- Name: downloadable_dir; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.downloadable_dir (
    downloadable_dir_id integer NOT NULL,
    security_hash text NOT NULL,
    creation_date timestamp without time zone NOT NULL,
    path text NOT NULL
);


--
-- Name: downloadable_dir_downloadable_dir_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.downloadable_dir_downloadable_dir_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: downloadable_dir_downloadable_dir_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.downloadable_dir_downloadable_dir_id_seq OWNED BY public.downloadable_dir.downloadable_dir_id;


--
-- Name: downloadable_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.downloadable_file (
    downloadable_file_id integer NOT NULL,
    file_id integer NOT NULL,
    security_hash text NOT NULL,
    creation_date timestamp without time zone DEFAULT now() NOT NULL,
    valid_until date,
    mime_type text
);


--
-- Name: downloadable_file_downloadable_file_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.downloadable_file_downloadable_file_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: downloadable_file_downloadable_file_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.downloadable_file_downloadable_file_id_seq OWNED BY public.downloadable_file.downloadable_file_id;


--
-- Name: file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file (
    file_id integer NOT NULL,
    digest text NOT NULL,
    size integer,
    is_dicom_file boolean,
    file_type text,
    processing_priority integer,
    ready_to_process boolean
);


--
-- Name: file_copy_from_public; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_copy_from_public (
    copy_from_public_id integer NOT NULL,
    sop_instance_uid text,
    replace_file_id integer,
    inserted_file_id integer,
    copy_file_path text
);


--
-- Name: file_ct_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_ct_image (
    file_id integer NOT NULL,
    kvp text,
    instance_number text,
    scan_options text,
    data_collection_diameter text,
    reconstruction_diameter text,
    dist_source_to_detect text,
    dist_source_to_pat text,
    gantry_tilt text,
    table_height text,
    rotation_dir text,
    exposure_time text,
    xray_tube_current text,
    exposure text,
    filter_type text,
    generator_power text,
    convolution_kernal text,
    table_feed_per_rot text
);


--
-- Name: file_ct_image__old; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_ct_image__old (
    file_id integer NOT NULL,
    kvp text,
    instance_number text,
    scan_options text,
    data_collection_diameter text,
    reconstruction_diameter text,
    dist_source_to_detect text,
    dist_source_to_pat text,
    gantry_tilt text,
    table_height text,
    rotation_dir text,
    exposure_time text,
    xray_tube_current text,
    exposure text,
    filter_type text,
    generator_power text,
    convolution_kernal text,
    table_feed_per_rot text
);


--
-- Name: file_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_dose (
    rt_dose_id integer NOT NULL,
    file_id integer NOT NULL
);


--
-- Name: file_ele_ref; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_ele_ref (
    file_ele_ref_id integer NOT NULL,
    file_id integer,
    ele_sig text
);


--
-- Name: file_ele_ref_file_ele_ref_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.file_ele_ref_file_ele_ref_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_ele_ref_file_ele_ref_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.file_ele_ref_file_ele_ref_id_seq OWNED BY public.file_ele_ref.file_ele_ref_id;


--
-- Name: file_ele_ref_text_value; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_ele_ref_text_value (
    file_ele_ref_id integer NOT NULL,
    text_value text
);


--
-- Name: file_equipment; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_equipment (
    file_id integer NOT NULL,
    manufacturer text,
    institution_name text,
    institution_addr text,
    station_name text,
    inst_dept_name text,
    manuf_model_name text,
    dev_serial_num text,
    software_versions text,
    spatial_resolution text,
    last_calib_date text,
    last_calib_time text,
    pixel_pad integer
);


--
-- Name: file_file_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.file_file_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_file_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.file_file_id_seq OWNED BY public.file.file_id;


--
-- Name: file_for; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_for (
    file_id integer NOT NULL,
    for_uid text,
    position_ref_indicator text
);


--
-- Name: file_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_image (
    file_id integer NOT NULL,
    image_id integer NOT NULL,
    content_date date,
    content_time time without time zone
);


--
-- Name: file_image_geometry; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_image_geometry (
    file_id integer NOT NULL,
    image_geometry_id integer NOT NULL
);


--
-- Name: file_import; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_import (
    import_event_id integer NOT NULL,
    file_id integer NOT NULL,
    rel_path text,
    rel_dir text,
    file_name text,
    file_import_time timestamp with time zone
);


--
-- Name: file_import_series; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_import_series (
    file_import_series_id integer NOT NULL,
    file_id integer NOT NULL,
    import_event_id integer NOT NULL,
    series_instance_uid text NOT NULL,
    modality text NOT NULL
);


--
-- Name: file_import_series_file_import_series_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.file_import_series_file_import_series_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_import_series_file_import_series_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.file_import_series_file_import_series_id_seq OWNED BY public.file_import_series.file_import_series_id;


--
-- Name: file_import_study; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_import_study (
    file_import_study_id integer NOT NULL,
    file_id integer NOT NULL,
    import_event_id integer NOT NULL,
    study_instance_uid text NOT NULL
);


--
-- Name: file_import_study_file_import_study_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.file_import_study_file_import_study_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_import_study_file_import_study_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.file_import_study_file_import_study_id_seq OWNED BY public.file_import_study.file_import_study_id;


--
-- Name: file_location; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_location (
    file_id integer NOT NULL,
    file_storage_root_id integer NOT NULL,
    rel_path text NOT NULL,
    is_home text,
    file_is_present boolean
);


--
-- Name: file_locationx; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_locationx (
    file_id integer,
    file_storage_root_id integer,
    rel_path text,
    is_home text
);


--
-- Name: file_meta; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_meta (
    file_id integer NOT NULL,
    file_meta integer,
    data_set_size integer,
    data_set_start integer,
    media_storage_sop_class text,
    media_storage_sop_instance text,
    xfer_syntax text,
    imp_class_uid text,
    imp_version_name text,
    source_ae_title text,
    private_info_uid text,
    private_info text
);


--
-- Name: file_mr; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_mr (
    file_id integer NOT NULL,
    mr_scanning_seq text,
    mr_scanning_var text,
    mr_scan_options text,
    mr_acq_type text,
    mr_slice_thickness text,
    mr_repetition_time text,
    mr_echo_time text,
    mr_magnetic_field_strength text,
    mr_spacing_between_slices text,
    mr_echo_train_length text,
    mr_software_version text,
    mr_flip_angle text,
    mr_nominal_pixel_spacing text,
    mr_patient_position text,
    mr_acquisition_number text,
    mr_instance_number text,
    mr_smallest_pixel text,
    mr_largest_value text,
    mr_window_center text,
    mr_window_width text,
    mr_rescale_intercept text,
    mr_rescale_slope text,
    mr_rescale_type text
);


--
-- Name: file_patient; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_patient (
    file_id integer NOT NULL,
    patient_name text,
    patient_id text,
    id_issuer text,
    dob date,
    sex text,
    time_ob time without time zone,
    other_ids text,
    other_names text,
    ethnic_group text,
    comments text,
    patient_age text
);


--
-- Name: file_plan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_plan (
    plan_id integer NOT NULL,
    file_id integer NOT NULL
);


--
-- Name: file_pt_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_pt_image (
    file_id integer NOT NULL,
    pti_trigger_time text,
    pti_frame_time text,
    pti_intervals_acquired text,
    pti_intervals_rejected text,
    pti_reconstruction_diameter text,
    pti_gantry_detector_tilt text,
    pti_table_height text,
    pti_fov_shape text,
    pti_fov_dimensions text,
    pti_collimator_type text,
    pti_convoution_kernal text,
    pti_actual_frame_duration text,
    pti_energy_range_lower_limit text,
    pti_energy_range_upper_limit text,
    pti_radiopharmaceutical text,
    pti_radiopharmaceutical_volume text,
    pti_radiopharmaceutical_start_time text,
    pti_radiopharmaceutical_stop_time text,
    pti_radionuclide_total_dose text,
    pti_radionuclide_half_life text,
    pti_radionuclide_positron_fraction text,
    pti_number_of_slices text,
    pti_number_of_time_slices text,
    pti_type_of_detector_motion text,
    pti_image_id text,
    pti_series_type text,
    pti_units text,
    pti_counts_source text,
    pti_reprojection_method text,
    pti_randoms_correction_method text,
    pti_attenuation_correction_method text,
    pti_decay_correction text,
    pti_reconstruction_method text,
    pti_detector_lines_of_response_used text,
    pti_scatter_correction_method text,
    pti_axial_mash text,
    pti_transverse_mash text,
    pti_coincidence_window_width text,
    pti_secondary_counts_type text,
    pti_frame_reference_time text,
    pti_primary_counts_accumulated text,
    pti_secondary_counts_accumulated text,
    pti_slice_sensitivity_factor text,
    pti_decay_factor text,
    pti_dose_calibration_factor text,
    pti_scatter_fraction_factor text,
    pti_dead_time_factor text,
    pti_image_index text
);


--
-- Name: file_roi_image_linkage; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_roi_image_linkage (
    file_id integer NOT NULL,
    roi_id integer NOT NULL,
    linked_sop_instance_uid text NOT NULL,
    linked_sop_class_uid text NOT NULL,
    contour_file_offset integer NOT NULL,
    contour_length integer NOT NULL,
    contour_digest text NOT NULL,
    num_points integer NOT NULL,
    contour_type text NOT NULL
);


--
-- Name: file_series; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_series (
    file_id integer NOT NULL,
    modality text NOT NULL,
    series_instance_uid text NOT NULL,
    series_number integer,
    laterality text,
    series_date date,
    series_time time without time zone,
    performing_phys text,
    protocol_name text,
    series_description text,
    operators_name text,
    body_part_examined text,
    patient_position text,
    smallest_pixel_value integer,
    largest_pixel_value integer,
    performed_procedure_step_id text,
    performed_procedure_step_start_date date,
    performed_procedure_step_start_time time without time zone,
    performed_procedure_step_desc text,
    performed_procedure_step_comments text,
    date_fixed boolean
);


--
-- Name: file_slope_intercept; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_slope_intercept (
    file_id integer NOT NULL,
    slope_intercept_id integer NOT NULL
);


--
-- Name: file_sop_common; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_sop_common (
    file_id integer NOT NULL,
    sop_class_uid text NOT NULL,
    sop_instance_uid text NOT NULL,
    specific_character_set text,
    creation_date date,
    creation_time time without time zone,
    creator_uid text,
    related_general_sop_class text,
    original_specialized_sop_class text,
    offset_from_utc integer,
    instance_number text,
    instance_status text,
    auth_date_time time with time zone,
    auth_comment text,
    auth_cert_num text
);


--
-- Name: file_storage_root; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_storage_root (
    file_storage_root_id integer NOT NULL,
    root_path text,
    current boolean,
    storage_class text
);


--
-- Name: file_storage_root_file_storage_root_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.file_storage_root_file_storage_root_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_storage_root_file_storage_root_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.file_storage_root_file_storage_root_id_seq OWNED BY public.file_storage_root.file_storage_root_id;


--
-- Name: file_structure_set; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_structure_set (
    file_id integer NOT NULL,
    structure_set_id integer NOT NULL,
    instance_number text
);


--
-- Name: file_study; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_study (
    file_id integer NOT NULL,
    study_instance_uid text NOT NULL,
    study_date date,
    study_time time without time zone,
    referring_phy_name text,
    study_id text,
    accession_number text,
    study_description text,
    phys_of_record text,
    phys_reading text,
    admitting_diag text
);


--
-- Name: file_visibility_change; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_visibility_change (
    file_id integer NOT NULL,
    user_name text NOT NULL,
    time_of_change timestamp with time zone,
    prior_visibility text,
    new_visibility text,
    reason_for text
);


--
-- Name: file_win_lev; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_win_lev (
    file_id integer NOT NULL,
    window_level_id integer NOT NULL,
    wl_index integer NOT NULL
);


--
-- Name: for_registration; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.for_registration (
    ss_for_id integer NOT NULL,
    from_for_uid text NOT NULL,
    xform_type text,
    xform text,
    xform_comment text
);


--
-- Name: foreign_keys_view; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.foreign_keys_view AS
 SELECT tc.table_name,
    kcu.column_name,
    ccu.table_name AS foreign_table_name,
    ccu.column_name AS foreign_column_name
   FROM ((information_schema.table_constraints tc
     JOIN information_schema.key_column_usage kcu ON (((tc.constraint_name)::text = (kcu.constraint_name)::text)))
     JOIN information_schema.constraint_column_usage ccu ON (((ccu.constraint_name)::text = (tc.constraint_name)::text)))
  WHERE ((tc.constraint_type)::text = 'FOREIGN KEY'::text);


--
-- Name: fraction_reference_beam; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.fraction_reference_beam (
    plan_id integer NOT NULL,
    fraction_group_number integer NOT NULL,
    beam_number integer NOT NULL,
    beam_dose_specification_point text,
    beam_dose text,
    beam_dose_point_depth text,
    beam_dose_point_equivalent_depth text,
    beam_dose_point_ssd text,
    beam_meterset text
);


--
-- Name: fraction_reference_brachy; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.fraction_reference_brachy (
    plan_id integer NOT NULL,
    fraction_group_number integer NOT NULL,
    brachy_application_setup_number integer NOT NULL,
    brachy_application_setup_dose_specification_point text,
    brachy_application_setup_dose text
);


--
-- Name: fraction_reference_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.fraction_reference_dose (
    plan_id integer NOT NULL,
    fraction_group_number integer NOT NULL,
    dose_reference_number integer NOT NULL,
    constraint_weight text,
    delivery_warning_dose text,
    delivery_maximum_dose text,
    target_minimum_dose text,
    target_prescription_dose text,
    target_maximum_dose text,
    target_underdose_volume_fraction text,
    organ_at_risk_full_volume_dose text,
    organ_at_risk_limit_dose text,
    organ_at_risk_maximum_dose text,
    organ_at_risk_overdose_volume_fraction text
);


--
-- Name: fraction_related_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.fraction_related_dose (
    plan_id integer NOT NULL,
    fraction_group_number integer NOT NULL,
    sop_class_uid text NOT NULL,
    sop_instance_uid text NOT NULL
);


--
-- Name: image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image (
    image_id integer NOT NULL,
    image_type text,
    samples_per_pixel integer,
    pixel_spacing text,
    photometric_interpretation text,
    pixel_rows integer,
    pixel_columns integer,
    bits_allocated integer,
    bits_stored integer,
    high_bit integer,
    pixel_representation integer,
    planar_configuration integer,
    number_of_frames integer,
    unique_pixel_data_id integer,
    row_spacing double precision,
    col_spacing double precision
);


--
-- Name: image_equivalence_class; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_equivalence_class (
    image_equivalence_class_id integer NOT NULL,
    series_instance_uid text NOT NULL,
    equivalence_class_number integer,
    processing_status text,
    review_status text,
    update_user text,
    update_date timestamp without time zone,
    hidden boolean DEFAULT false NOT NULL,
    visual_review_instance_id integer
);


--
-- Name: image_equivalence_class_image_equivalence_class_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.image_equivalence_class_image_equivalence_class_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: image_equivalence_class_image_equivalence_class_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.image_equivalence_class_image_equivalence_class_id_seq OWNED BY public.image_equivalence_class.image_equivalence_class_id;


--
-- Name: image_equivalence_class_input_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_equivalence_class_input_image (
    image_equivalence_class_id integer NOT NULL,
    file_id integer NOT NULL
);


--
-- Name: image_equivalence_class_out_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_equivalence_class_out_image (
    image_equivalence_class_id integer NOT NULL,
    projection_type text NOT NULL,
    file_id integer NOT NULL
);


--
-- Name: image_frame_offset; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_frame_offset (
    image_id integer NOT NULL,
    frame_index integer,
    frame_offset text
);


--
-- Name: image_geometry; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_geometry (
    image_geometry_id integer NOT NULL,
    image_id integer NOT NULL,
    iop text,
    ipp text,
    for_uid text,
    normalized_iop text,
    iop_error text,
    row_x double precision,
    row_y double precision,
    row_z double precision,
    col_x double precision,
    col_y double precision,
    col_z double precision,
    pos_x double precision,
    pos_y double precision,
    pos_z double precision
);


--
-- Name: image_geometry_image_geometry_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.image_geometry_image_geometry_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: image_geometry_image_geometry_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.image_geometry_image_geometry_id_seq OWNED BY public.image_geometry.image_geometry_id;


--
-- Name: image_image_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.image_image_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: image_image_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.image_image_id_seq OWNED BY public.image.image_id;


--
-- Name: image_referenced_from_beam; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_referenced_from_beam (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    sop_class_uid text NOT NULL,
    sop_instance_uid text NOT NULL,
    reference_image_number text NOT NULL,
    start_cum_meterset_weight text,
    end_cum_meterset_weight text
);


--
-- Name: image_slope_intercept; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_slope_intercept (
    image_id integer NOT NULL,
    slope_intercept_id integer NOT NULL
);


--
-- Name: image_window_level; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.image_window_level (
    window_level_id integer NOT NULL,
    image_id integer NOT NULL
);


--
-- Name: import_control; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.import_control (
    status text,
    processor_pid integer,
    idle_seconds integer,
    pending_change_request text,
    files_per_round integer
);


--
-- Name: import_ct_series; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.import_ct_series (
    import_event_id integer NOT NULL,
    series_instance_uid text NOT NULL,
    series_type text,
    patient_position text,
    is_axial boolean,
    consistent_series_geometry boolean,
    normalized_iop text,
    number_of_slices integer,
    avg_slice_spacing double precision,
    max_slice_spacing double precision,
    min_slice_spacing double precision,
    minimum_z double precision,
    maximum_z double precision,
    total_file_size bigint,
    max_file_size integer,
    min_file_size integer,
    avg_file_size double precision,
    processing_errors text
);


--
-- Name: import_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.import_event (
    import_event_id integer NOT NULL,
    import_type text,
    importing_user text,
    originating_ip_addr text,
    import_comment text,
    import_time timestamp with time zone,
    remote_file text,
    volume_name text,
    import_close_time timestamp with time zone,
    related_id_1 integer,
    related_id_2 integer
);


--
-- Name: import_event_import_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.import_event_import_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: import_event_import_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.import_event_import_event_id_seq OWNED BY public.import_event.import_event_id;


--
-- Name: log_iec_hide; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.log_iec_hide (
    user_name text,
    project text NOT NULL,
    site text NOT NULL,
    patient text,
    hidden boolean,
    date timestamp without time zone DEFAULT now() NOT NULL
);


--
-- Name: missing_files; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.missing_files (
    file_path character varying(200),
    missing character varying(3)
);


--
-- Name: missing_from_db; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.missing_from_db (
    file_path character varying(200),
    missing character varying(3)
);


--
-- Name: missing_from_fs; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.missing_from_fs (
    filename text,
    is_dicom_file boolean,
    file_type text
);


--
-- Name: non_dicom_attachments; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_attachments (
    non_dicom_file_id integer NOT NULL,
    dicom_file_id integer NOT NULL,
    patient_id text NOT NULL,
    manifest_uid text NOT NULL,
    study_instance_uid text NOT NULL,
    series_instance_uid text NOT NULL,
    manifest_date timestamp without time zone NOT NULL,
    version text NOT NULL
);


--
-- Name: non_dicom_conversion; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_conversion (
    from_file_id integer NOT NULL,
    to_file_id integer NOT NULL,
    conversion_event_id integer NOT NULL
);


--
-- Name: non_dicom_edit_compare; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_edit_compare (
    from_file_digest text NOT NULL,
    to_file_digest text NOT NULL,
    report_file_id integer NOT NULL,
    to_file_path text,
    subprocess_invocation_id integer NOT NULL
);


--
-- Name: non_dicom_edit_compare_disposition; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_edit_compare_disposition (
    subprocess_invocation_id integer NOT NULL,
    start_creation_time timestamp without time zone,
    end_creation_time timestamp without time zone,
    num_edits_scheduled integer,
    num_compares_with_diffs integer,
    num_compares_without_diffs integer,
    current_disposition text,
    process_pid integer,
    last_updated timestamp without time zone,
    dest_dir text
);


--
-- Name: non_dicom_file; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_file (
    file_id integer NOT NULL,
    file_type text NOT NULL,
    file_sub_type text NOT NULL,
    collection text NOT NULL,
    site text NOT NULL,
    subject text,
    visibility text,
    date_last_categorized timestamp with time zone
);


--
-- Name: non_dicom_file_change; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_file_change (
    file_id integer NOT NULL,
    file_type text NOT NULL,
    file_sub_type text NOT NULL,
    collection text NOT NULL,
    site text NOT NULL,
    subject text,
    visibility text,
    when_categorized timestamp with time zone,
    when_recategorized timestamp with time zone,
    who_recategorized text,
    why_recategorized text
);


--
-- Name: patient_import_status; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.patient_import_status (
    patient_id text NOT NULL,
    patient_import_status text
);


--
-- Name: patient_import_status_change; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.patient_import_status_change (
    patient_id text NOT NULL,
    when_pat_stat_changed timestamp with time zone,
    old_pat_status text,
    new_pat_status text,
    pat_stat_change_who text,
    pat_stat_change_why text
);


--
-- Name: patient_mapping; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.patient_mapping (
    from_patient_id text NOT NULL,
    to_patient_id text NOT NULL,
    to_patient_name text NOT NULL,
    collection_name text NOT NULL,
    site_name text NOT NULL,
    batch_number integer,
    diagnosis_date timestamp without time zone,
    baseline_date timestamp without time zone,
    date_shift interval,
    uid_root text,
    site_code integer
);


--
-- Name: pixel_location; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pixel_location (
    unique_pixel_data_id integer NOT NULL,
    file_id integer NOT NULL,
    file_offset integer NOT NULL
);


--
-- Name: plan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.plan (
    plan_id integer NOT NULL,
    plan_label text NOT NULL,
    plan_name text,
    plan_description text,
    instance_number integer,
    operators_name text,
    rt_plan_date date,
    rt_plan_time time without time zone,
    rt_treatment_protocols text,
    plan_intent text,
    treatment_sites text,
    rt_plan_geometry text NOT NULL,
    ss_referenced_from_plan text
);


--
-- Name: plan_plan_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.plan_plan_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: plan_plan_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.plan_plan_id_seq OWNED BY public.plan.plan_id;


--
-- Name: plan_related_plans; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.plan_related_plans (
    plan_id integer NOT NULL,
    related_plan_instance_uid text,
    plan_relationship text
);


--
-- Name: planned_verification_images; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.planned_verification_images (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    start_cum_meterset_weight text,
    meterset_exposure text,
    end_cum_meterset_weight text,
    rt_image_plane text,
    xray_image_receptor_angle text,
    rt_image_orientation text,
    rt_image_position text,
    rt_image_sid text,
    image_device_specific_acquisition_params text,
    referenced_reference_image_number integer
);


--
-- Name: popup_buttons_popup_button_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.popup_buttons_popup_button_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: posda_public_compare; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.posda_public_compare (
    background_subprocess_id integer NOT NULL,
    sop_instance_uid text NOT NULL,
    from_file_id integer NOT NULL,
    short_report_file_id integer NOT NULL,
    long_report_file_id integer NOT NULL,
    to_file_path text NOT NULL
);


--
-- Name: public_to_posda_file_comparison; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_to_posda_file_comparison (
    public_to_posda_file_comparison_id integer NOT NULL,
    compare_public_to_posda_instance_id integer NOT NULL,
    sop_instance_uid text NOT NULL,
    posda_file_id integer,
    posda_file_path text,
    public_file_path text,
    short_report_file_id integer,
    long_report_file_id integer
);


--
-- Name: public_to_posda_file_comparis_public_to_posda_file_comparis_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.public_to_posda_file_comparis_public_to_posda_file_comparis_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: public_to_posda_file_comparis_public_to_posda_file_comparis_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.public_to_posda_file_comparis_public_to_posda_file_comparis_seq OWNED BY public.public_to_posda_file_comparison.public_to_posda_file_comparison_id;


--
-- Name: query_invoked_by_dbif; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.query_invoked_by_dbif (
    query_invoked_by_dbif_id integer NOT NULL,
    query_name text,
    invoking_user text,
    query_start_time timestamp with time zone,
    query_end_time timestamp with time zone,
    number_of_rows integer
);


--
-- Name: query_invoked_by_dbif_query_invoked_by_dbif_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.query_invoked_by_dbif_query_invoked_by_dbif_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: query_invoked_by_dbif_query_invoked_by_dbif_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.query_invoked_by_dbif_query_invoked_by_dbif_id_seq OWNED BY public.query_invoked_by_dbif.query_invoked_by_dbif_id;


--
-- Name: related_roi_observations; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.related_roi_observations (
    roi_observation_id integer NOT NULL,
    related_roi_observation_num integer NOT NULL
);


--
-- Name: report_inserted; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.report_inserted (
    report_inserted_id integer NOT NULL,
    report_file_in_posda integer,
    report_rows_generated integer,
    background_subprocess_id integer
);


--
-- Name: report_inserted_report_inserted_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.report_inserted_report_inserted_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: report_inserted_report_inserted_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.report_inserted_report_inserted_id_seq OWNED BY public.report_inserted.report_inserted_id;


--
-- Name: roi; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi (
    roi_id integer NOT NULL,
    structure_set_id integer NOT NULL,
    for_uid text NOT NULL,
    roi_num integer NOT NULL,
    roi_name text,
    roi_description text,
    roi_volume text,
    gen_alg text,
    gen_desc text,
    roi_color text,
    max_x double precision,
    max_y double precision,
    max_z double precision,
    min_x double precision,
    min_y double precision,
    min_z double precision,
    roi_interpreted_type text,
    roi_obser_desc text,
    roi_obser_label text
);


--
-- Name: roi_contour; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi_contour (
    roi_contour_id integer NOT NULL,
    roi_id integer NOT NULL,
    contour_num integer,
    geometric_type text,
    slab_thickness text,
    offset_vector text,
    number_of_points integer,
    roi_contour_attachment text,
    contour_data text
);


--
-- Name: roi_contour_roi_contour_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.roi_contour_roi_contour_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: roi_contour_roi_contour_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.roi_contour_roi_contour_id_seq OWNED BY public.roi_contour.roi_contour_id;


--
-- Name: roi_elemental_composition; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi_elemental_composition (
    roi_phyical_properties_id integer NOT NULL,
    roi_elemental_composition_atomic_number text,
    roi_elemental_composition_atomic_mass_fraction text
);


--
-- Name: roi_observation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi_observation (
    roi_observation_id integer NOT NULL,
    roi_id integer NOT NULL,
    roi_obs_num integer,
    observation_label text,
    observation_description text,
    interpreted_type text,
    interpreter text,
    material_id text
);


--
-- Name: roi_observation_roi_observation_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.roi_observation_roi_observation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: roi_observation_roi_observation_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.roi_observation_roi_observation_id_seq OWNED BY public.roi_observation.roi_observation_id;


--
-- Name: roi_physical_properties; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi_physical_properties (
    roi_phyical_properties_id integer NOT NULL,
    roi_observation_id integer NOT NULL,
    property text,
    property_value text
);


--
-- Name: roi_physical_properties_roi_phyical_properties_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.roi_physical_properties_roi_phyical_properties_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: roi_physical_properties_roi_phyical_properties_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.roi_physical_properties_roi_phyical_properties_id_seq OWNED BY public.roi_physical_properties.roi_phyical_properties_id;


--
-- Name: roi_related_roi; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.roi_related_roi (
    roi_id integer NOT NULL,
    related_roi_id integer NOT NULL,
    relationship text
);


--
-- Name: roi_roi_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.roi_roi_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: roi_roi_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.roi_roi_id_seq OWNED BY public.roi.roi_id;


--
-- Name: rt_beam; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_beam (
    plan_id integer NOT NULL,
    beam_number integer NOT NULL,
    beam_name text,
    beam_description text,
    beam_type text,
    radiation_type text,
    high_dose_technique text,
    treatement_machine_name text,
    manufacturer text,
    institution_name text,
    institution_address text,
    institution_department_name text,
    manufacturers_model_name text,
    device_serial_number text,
    primary_dosimeter_unit text,
    tolerance_table_number integer,
    source_axis_distance text,
    patient_setup_number integer,
    treatment_delivery_type text,
    number_of_wedges integer,
    number_of_compensators integer,
    total_compensator_tray_factor text,
    number_of_boli integer,
    number_of_blocks integer,
    total_block_tray_factor text,
    final_cumulative_meterset_weight text,
    number_of_control_points integer
);


--
-- Name: rt_beam_limit_dev_tolerance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_beam_limit_dev_tolerance (
    plan_id integer NOT NULL,
    tolerance_table_number integer NOT NULL,
    beam_limit_dev_type text,
    beam_limit_dev_pos_tolerance text
);


--
-- Name: rt_beam_tolerance_table; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_beam_tolerance_table (
    plan_id integer NOT NULL,
    tolerance_table_number integer NOT NULL,
    tolerance_table_label text,
    gantry_angle_tolerance text,
    gantry_angle_pitch_tolerance text,
    beam_limiting_device_angle_tolerance text,
    patient_support_angle_tolerance text,
    table_top_eccentric_angle_tolerance text,
    table_top_pitch_angle_tolerance text,
    table_top_roll_angle_tolerance text,
    table_top_vert_pos_tolerance text,
    table_top_log_pos_tolerance text,
    table_top_lat_pos_tolerance text
);


--
-- Name: rt_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dose (
    rt_dose_id integer NOT NULL,
    rt_dose_units text,
    rt_dose_type text,
    rt_dose_instance_number text,
    rt_dose_comment text,
    rt_dose_normalization_point text,
    rt_dose_summation_type text,
    rt_dose_referenced_plan_class text,
    rt_dose_referenced_plan_uid text,
    rt_dose_tissue_heterogeneity text
);


--
-- Name: rt_dose_gfov; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dose_gfov (
    rt_dose_id integer NOT NULL,
    rt_gfov_index integer NOT NULL,
    gfov_offset double precision
);


--
-- Name: rt_dose_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dose_image (
    rt_dose_id integer NOT NULL,
    image_id integer NOT NULL,
    rt_dose_grid_frame_offset_vector text,
    rt_dose_grid_scaling double precision,
    rt_dose_max_slice_spacing double precision,
    rt_dose_min_slice_spacing double precision
);


--
-- Name: rt_dose_ref_beam; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dose_ref_beam (
    rt_dose_id integer NOT NULL,
    rt_dose_frac_group_number integer NOT NULL,
    rt_dose_beam_number integer NOT NULL,
    rt_dose_cp_start integer,
    rt_dose_cp_stop integer
);


--
-- Name: rt_dose_ref_brachy; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dose_ref_brachy (
    rt_dose_id integer NOT NULL,
    rt_dose_ref_bracy_setup_number integer NOT NULL
);


--
-- Name: rt_dose_rt_dose_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rt_dose_rt_dose_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: rt_dose_rt_dose_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rt_dose_rt_dose_id_seq OWNED BY public.rt_dose.rt_dose_id;


--
-- Name: rt_dvh; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh (
    rt_dvh_id integer NOT NULL,
    rt_dvh_source text NOT NULL,
    rt_dvh_referenced_ss_class text,
    rt_dvh_referenced_ss_uid text,
    rt_dvh_normalization_point text,
    rt_dvh_normalization_value text
);


--
-- Name: rt_dvh_available_rois; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_available_rois (
    rt_dvh_dvh_id integer NOT NULL,
    available_rois text
);


--
-- Name: rt_dvh_dvh; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_dvh (
    rt_dvh_dvh_id integer NOT NULL,
    rt_dvh_id integer NOT NULL,
    rt_dvh_dvh_type text,
    rt_dvh_dvh_roi_alt_name text,
    rt_dvh_dvh_roi_alt_desc text,
    rt_dvh_dvh_plan_id text,
    rt_dvh_dvh_plan_desc text,
    rt_dvh_dvh_arm integer,
    rt_dvh_dvh_prescription double precision,
    rt_dvh_dvh_specified_heterogeneity text,
    rt_dvh_dvh_dose_summation_id text,
    rt_dvh_dvh_dose_manufacturer text,
    rt_dvh_dvh_dose_model_name text,
    rt_dvh_dvh_referenced_dose_grid_class text,
    rt_dvh_dvh_referenced_dose_grid_uid text,
    rt_dvh_dvh_dose_units text,
    rt_dvh_dvh_dose_type text,
    rt_dvh_dvh_dose_scaling text,
    rt_dvh_dvh_dose_volume_units text,
    rt_dvh_dvh_dose_number_of_bins text,
    rt_dvh_dvh_minimum_dose double precision,
    rt_dvh_dvh_maximum_dose double precision,
    rt_dvh_dvh_mean_dose double precision,
    rt_dvh_dvh_text_data text
);


--
-- Name: rt_dvh_dvh_data; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_dvh_data (
    rt_dvh_dvh_id integer NOT NULL,
    rt_dvh_dvh_index integer NOT NULL,
    rt_dvh_dvh_data double precision
);


--
-- Name: rt_dvh_dvh_dose_bins; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_dvh_dose_bins (
    rt_dvh_dvh_id integer NOT NULL,
    bin_dose_cgy double precision NOT NULL,
    cum_percent_vol double precision NOT NULL,
    cum_cm3_vol double precision NOT NULL,
    cum_percent_prescription_dose double precision
);


--
-- Name: rt_dvh_dvh_roi; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_dvh_roi (
    rt_dvh_dvh_id integer NOT NULL,
    rt_dvh_dvh_ref_roi_number integer,
    rt_dvh_dvh_roi_cont_type text
);


--
-- Name: rt_dvh_dvh_rt_dvh_dvh_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rt_dvh_dvh_rt_dvh_dvh_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: rt_dvh_dvh_rt_dvh_dvh_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rt_dvh_dvh_rt_dvh_dvh_id_seq OWNED BY public.rt_dvh_dvh.rt_dvh_dvh_id;


--
-- Name: rt_dvh_protocol_case_roi; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_protocol_case_roi (
    rt_dvh_dvh_id integer NOT NULL,
    roi_construct_name text,
    protocol text,
    case_no text,
    ss_file_id integer,
    dose_file_id integer
);


--
-- Name: rt_dvh_rt_dose; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_dvh_rt_dose (
    rt_dose_id integer NOT NULL,
    rt_dvh_id integer NOT NULL
);


--
-- Name: rt_dvh_rt_dvh_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rt_dvh_rt_dvh_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: rt_dvh_rt_dvh_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rt_dvh_rt_dvh_id_seq OWNED BY public.rt_dvh.rt_dvh_id;


--
-- Name: rt_plan_fraction_group; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_fraction_group (
    plan_id integer NOT NULL,
    fraction_group_number integer NOT NULL,
    fraction_group_descripton text,
    number_of_fractions_planned integer,
    number_of_fraction_digits_per_day integer,
    repeat_fraction_cycle_length integer,
    fraction_pattern text,
    number_of_beams integer,
    number_of_brachy_application_setups integer
);


--
-- Name: rt_plan_patient_setup; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_patient_setup (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    patient_setup_label text,
    patient_position text,
    patient_addl_pos text,
    setup_technique text,
    setup_technique_description text,
    table_top_vert_disp text,
    table_top_long_disp text,
    table_top_lat_disp text
);


--
-- Name: rt_plan_respiratory_motion_comp; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_respiratory_motion_comp (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    sequence_index integer NOT NULL,
    respiratory_motion_comp_technique text,
    respiratory_signal_source text,
    respiratory_motion_com_tech_desc text,
    respiratory_signal_source_id text
);


--
-- Name: rt_plan_setup_device; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_setup_device (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    setup_device_type text NOT NULL,
    setup_device_label text,
    setup_device_description text,
    setup_device_parameter text,
    setup_reference_description text
);


--
-- Name: rt_plan_setup_fixation_device; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_setup_fixation_device (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    fixation_device_type text NOT NULL,
    fixaction_device_label text,
    fixation_device_description text,
    fixation_device_position text,
    fixation_device_pitch_angle text,
    fixation_device_roll_angle text,
    fixation_device_accessory_code text
);


--
-- Name: rt_plan_setup_image; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_setup_image (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    setup_image_comment text,
    image_sop_class_uid text,
    image_sop_instance_uid text
);


--
-- Name: rt_plan_setup_shielding_device; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_plan_setup_shielding_device (
    plan_id integer NOT NULL,
    patient_setup_num integer NOT NULL,
    shielding_device_type text NOT NULL,
    shielding_device_label text,
    shielding_device_description text,
    shielding_device_accessory_code text
);


--
-- Name: rt_prescription; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_prescription (
    rt_prescription_id integer NOT NULL,
    plan_id integer NOT NULL,
    rt_prescription_description text
);


--
-- Name: rt_prescription_dose_ref; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rt_prescription_dose_ref (
    rt_prescription_id integer NOT NULL,
    dose_reference_number integer NOT NULL,
    dose_reference_uid text,
    dose_reference_structure_type text NOT NULL,
    referenced_roi_number integer,
    dose_reference_point text,
    nominal_prior_dose text,
    dose_reference_type text NOT NULL,
    constraint_weight text,
    delivery_warning_dose text,
    delivery_maximum_dose text,
    target_minimum_dose text,
    target_prescription_dose text,
    target_maximum_dose text,
    target_underdose_volume_fraction text,
    organ_at_risk_full_volume_dose text,
    organ_at_risk_limit_dose text,
    organ_at_risk_maximum_dose text,
    organ_at_overdose_volume_fraction text
);


--
-- Name: rt_prescription_rt_prescription_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rt_prescription_rt_prescription_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: rt_prescription_rt_prescription_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rt_prescription_rt_prescription_id_seq OWNED BY public.rt_prescription.rt_prescription_id;


--
-- Name: site_codes; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.site_codes (
    site_name text NOT NULL,
    site_code text NOT NULL
);


--
-- Name: slope_intercept; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.slope_intercept (
    slope_intercept_id integer NOT NULL,
    slope text NOT NULL,
    intercept text NOT NULL,
    si_units text,
    slopef double precision,
    interceptf double precision
);


--
-- Name: slope_intercept_slope_intercept_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.slope_intercept_slope_intercept_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: slope_intercept_slope_intercept_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.slope_intercept_slope_intercept_id_seq OWNED BY public.slope_intercept.slope_intercept_id;


--
-- Name: spreadsheet_uploaded; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.spreadsheet_uploaded (
    spreadsheet_uploaded_id integer NOT NULL,
    time_uploaded timestamp with time zone,
    is_executable boolean,
    uploading_user text,
    file_id_in_posda integer,
    number_rows integer
);


--
-- Name: spreadsheet_uploaded_spreadsheet_uploaded_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.spreadsheet_uploaded_spreadsheet_uploaded_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: spreadsheet_uploaded_spreadsheet_uploaded_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.spreadsheet_uploaded_spreadsheet_uploaded_id_seq OWNED BY public.spreadsheet_uploaded.spreadsheet_uploaded_id;


--
-- Name: ss_for; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ss_for (
    ss_for_id integer NOT NULL,
    structure_set_id integer NOT NULL,
    for_uid text NOT NULL
);


--
-- Name: ss_for_ss_for_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.ss_for_ss_for_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ss_for_ss_for_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.ss_for_ss_for_id_seq OWNED BY public.ss_for.ss_for_id;


--
-- Name: ss_volume; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ss_volume (
    ss_for_id integer NOT NULL,
    study_instance_uid text NOT NULL,
    series_instance_uid text NOT NULL,
    sop_class text NOT NULL,
    sop_instance text NOT NULL
);


--
-- Name: structure_set; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.structure_set (
    structure_set_id integer NOT NULL,
    ss_label text,
    ss_description text,
    ss_date date,
    ss_time time without time zone,
    ss_name text
);


--
-- Name: structure_set_structure_set_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.structure_set_structure_set_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: structure_set_structure_set_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.structure_set_structure_set_id_seq OWNED BY public.structure_set.structure_set_id;


--
-- Name: submission; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.submission (
    import_event_id integer NOT NULL,
    institution text,
    year integer,
    month_i integer,
    month text
);


--
-- Name: subprocess_invocation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.subprocess_invocation (
    subprocess_invocation_id integer NOT NULL,
    from_spreadsheet boolean,
    from_button boolean,
    spreadsheet_uploaded_id integer,
    query_invoked_by_dbif_id integer,
    button_name text,
    command_line text,
    process_pid integer,
    invoking_user text,
    when_invoked timestamp with time zone,
    operation_name text,
    scrash text,
    scrash_date timestamp without time zone
);


--
-- Name: subprocess_invocation_subprocess_invocation_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.subprocess_invocation_subprocess_invocation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: subprocess_invocation_subprocess_invocation_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.subprocess_invocation_subprocess_invocation_id_seq OWNED BY public.subprocess_invocation.subprocess_invocation_id;


--
-- Name: subprocess_lines; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.subprocess_lines (
    subprocess_invocation_id integer NOT NULL,
    line_number integer NOT NULL,
    line text NOT NULL
);


--
-- Name: unique_pixel_data; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.unique_pixel_data (
    unique_pixel_data_id integer NOT NULL,
    digest text NOT NULL,
    size integer
);


--
-- Name: unique_pixel_data_unique_pixel_data_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.unique_pixel_data_unique_pixel_data_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: unique_pixel_data_unique_pixel_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.unique_pixel_data_unique_pixel_data_id_seq OWNED BY public.unique_pixel_data.unique_pixel_data_id;


--
-- Name: user_activity; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_activity (
    user_activity_id integer NOT NULL,
    user_name text NOT NULL,
    description text NOT NULL,
    when_activity_created timestamp with time zone,
    when_activity_closed timestamp with time zone
);


--
-- Name: user_activity_messages; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_activity_messages (
    user_activity_id integer NOT NULL,
    background_subprocess_report_id integer NOT NULL
);


--
-- Name: user_activity_user_activity_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.user_activity_user_activity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_activity_user_activity_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.user_activity_user_activity_id_seq OWNED BY public.user_activity.user_activity_id;


--
-- Name: user_inbox; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_inbox (
    user_inbox_id integer NOT NULL,
    user_name text,
    user_email_addr text
);


--
-- Name: user_inbox_content; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_inbox_content (
    user_inbox_content_id integer NOT NULL,
    user_inbox_id integer,
    background_subprocess_report_id integer,
    current_status text,
    statuts_note text,
    date_entered timestamp without time zone,
    date_dismissed timestamp without time zone
);


--
-- Name: user_inbox_content_operation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_inbox_content_operation (
    user_inbox_content_id integer,
    operation_type text,
    when_occurred timestamp without time zone,
    how_invoked text,
    invoking_user text
);


--
-- Name: user_inbox_content_user_inbox_content_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.user_inbox_content_user_inbox_content_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_inbox_content_user_inbox_content_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.user_inbox_content_user_inbox_content_id_seq OWNED BY public.user_inbox_content.user_inbox_content_id;


--
-- Name: user_inbox_user_inbox_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.user_inbox_user_inbox_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_inbox_user_inbox_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.user_inbox_user_inbox_id_seq OWNED BY public.user_inbox.user_inbox_id;


--
-- Name: user_variable_binding; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.user_variable_binding (
    binding_user text NOT NULL,
    bound_variable_name text NOT NULL,
    bound_value text
);


--
-- Name: visible_file_totals_at_time; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.visible_file_totals_at_time (
    time_of_reading timestamp without time zone,
    number_of_visible_dicom_files integer,
    number_of_bytes bigint
);


--
-- Name: visual_review_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.visual_review_instance (
    visual_review_instance_id integer NOT NULL,
    subprocess_invocation_id integer,
    visual_review_reason text,
    visual_review_scheduler text,
    visual_review_num_series integer,
    when_visual_review_scheduled timestamp without time zone,
    visual_review_num_series_done integer,
    visual_review_num_equiv_class integer,
    when_visual_review_sched_complete timestamp without time zone
);


--
-- Name: visual_review_instance_visual_review_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.visual_review_instance_visual_review_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: visual_review_instance_visual_review_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.visual_review_instance_visual_review_instance_id_seq OWNED BY public.visual_review_instance.visual_review_instance_id;


--
-- Name: window_level; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.window_level (
    window_level_id integer NOT NULL,
    window_width text NOT NULL,
    window_center text NOT NULL,
    win_lev_desc text
);


--
-- Name: window_level_window_level_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.window_level_window_level_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: window_level_window_level_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.window_level_window_level_id_seq OWNED BY public.window_level.window_level_id;


--
-- Name: ldct_all; Type: TABLE; Schema: quasar; Owner: -
--

CREATE TABLE quasar.ldct_all (
    file_id integer,
    file_name text
);


--
-- Name: ldct_and_projection; Type: TABLE; Schema: quasar; Owner: -
--

CREATE TABLE quasar.ldct_and_projection (
    filename text
);


--
-- Name: ldct_missing; Type: TABLE; Schema: quasar; Owner: -
--

CREATE TABLE quasar.ldct_missing (
    filename text,
    import_event_id integer,
    file_id integer,
    rel_path text,
    rel_dir text,
    file_name text,
    file_import_time timestamp with time zone
);


--
-- Name: mvtest; Type: MATERIALIZED VIEW; Schema: quasar; Owner: -
--

CREATE MATERIALIZED VIEW quasar.mvtest AS
 SELECT DISTINCT ctp_file.project_name,
    ctp_file.site_name
   FROM public.ctp_file
  WITH NO DATA;


--
-- Name: phantom_files; Type: TABLE; Schema: quasar; Owner: -
--

CREATE TABLE quasar.phantom_files (
    file_id integer
);


--
-- Name: background_buttons background_button_id; Type: DEFAULT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.background_buttons ALTER COLUMN background_button_id SET DEFAULT nextval('dbif_config.background_buttons_background_button_id_seq'::regclass);


--
-- Name: chained_query chained_query_id; Type: DEFAULT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.chained_query ALTER COLUMN chained_query_id SET DEFAULT nextval('dbif_config.chained_query_chained_query_id_seq'::regclass);


--
-- Name: popup_buttons popup_button_id; Type: DEFAULT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.popup_buttons ALTER COLUMN popup_button_id SET DEFAULT nextval('dbif_config.popup_buttons_popup_button_id_seq1'::regclass);


--
-- Name: activity activity_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.activity ALTER COLUMN activity_id SET DEFAULT nextval('public.activity_activity_id_seq'::regclass);


--
-- Name: activity_timepoint activity_timepoint_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.activity_timepoint ALTER COLUMN activity_timepoint_id SET DEFAULT nextval('public.activity_timepoint_activity_timepoint_id_seq'::regclass);


--
-- Name: adverse_file_event adverse_file_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.adverse_file_event ALTER COLUMN adverse_file_event_id SET DEFAULT nextval('public.adverse_file_event_adverse_file_event_id_seq'::regclass);


--
-- Name: association association_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.association ALTER COLUMN association_id SET DEFAULT nextval('public.association_association_id_seq'::regclass);


--
-- Name: association_pc association_pc_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.association_pc ALTER COLUMN association_pc_id SET DEFAULT nextval('public.association_pc_association_pc_id_seq'::regclass);


--
-- Name: background_subprocess background_subprocess_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.background_subprocess ALTER COLUMN background_subprocess_id SET DEFAULT nextval('public.background_subprocess_background_subprocess_id_seq'::regclass);


--
-- Name: background_subprocess_report background_subprocess_report_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.background_subprocess_report ALTER COLUMN background_subprocess_report_id SET DEFAULT nextval('public.background_subprocess_report_background_subprocess_report_i_seq'::regclass);


--
-- Name: compare_public_to_posda_instance compare_public_to_posda_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.compare_public_to_posda_instance ALTER COLUMN compare_public_to_posda_instance_id SET DEFAULT nextval('public.compare_public_to_posda_insta_compare_public_to_posda_insta_seq'::regclass);


--
-- Name: conversion_event conversion_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.conversion_event ALTER COLUMN conversion_event_id SET DEFAULT nextval('public.conversion_event_conversion_event_id_seq'::regclass);


--
-- Name: copy_from_public copy_from_public_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.copy_from_public ALTER COLUMN copy_from_public_id SET DEFAULT nextval('public.copy_from_public_copy_from_public_id_seq'::regclass);


--
-- Name: dicom_dir_rec dicom_dir_rec_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dicom_dir_rec ALTER COLUMN dicom_dir_rec_id SET DEFAULT nextval('public.dicom_dir_rec_dicom_dir_rec_id_seq'::regclass);


--
-- Name: dicom_edit_event dicom_edit_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dicom_edit_event ALTER COLUMN dicom_edit_event_id SET DEFAULT nextval('public.dicom_edit_event_dicom_edit_event_id_seq'::regclass);


--
-- Name: dicom_send_event dicom_send_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dicom_send_event ALTER COLUMN dicom_send_event_id SET DEFAULT nextval('public.dicom_send_event_dicom_send_event_id_seq'::regclass);


--
-- Name: downloadable_dir downloadable_dir_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.downloadable_dir ALTER COLUMN downloadable_dir_id SET DEFAULT nextval('public.downloadable_dir_downloadable_dir_id_seq'::regclass);


--
-- Name: downloadable_file downloadable_file_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.downloadable_file ALTER COLUMN downloadable_file_id SET DEFAULT nextval('public.downloadable_file_downloadable_file_id_seq'::regclass);


--
-- Name: file file_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file ALTER COLUMN file_id SET DEFAULT nextval('public.file_file_id_seq'::regclass);


--
-- Name: file_ele_ref file_ele_ref_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_ele_ref ALTER COLUMN file_ele_ref_id SET DEFAULT nextval('public.file_ele_ref_file_ele_ref_id_seq'::regclass);


--
-- Name: file_import_series file_import_series_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_import_series ALTER COLUMN file_import_series_id SET DEFAULT nextval('public.file_import_series_file_import_series_id_seq'::regclass);


--
-- Name: file_import_study file_import_study_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_import_study ALTER COLUMN file_import_study_id SET DEFAULT nextval('public.file_import_study_file_import_study_id_seq'::regclass);


--
-- Name: file_storage_root file_storage_root_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_storage_root ALTER COLUMN file_storage_root_id SET DEFAULT nextval('public.file_storage_root_file_storage_root_id_seq'::regclass);


--
-- Name: image image_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.image ALTER COLUMN image_id SET DEFAULT nextval('public.image_image_id_seq'::regclass);


--
-- Name: image_equivalence_class image_equivalence_class_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.image_equivalence_class ALTER COLUMN image_equivalence_class_id SET DEFAULT nextval('public.image_equivalence_class_image_equivalence_class_id_seq'::regclass);


--
-- Name: image_geometry image_geometry_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.image_geometry ALTER COLUMN image_geometry_id SET DEFAULT nextval('public.image_geometry_image_geometry_id_seq'::regclass);


--
-- Name: import_event import_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.import_event ALTER COLUMN import_event_id SET DEFAULT nextval('public.import_event_import_event_id_seq'::regclass);


--
-- Name: plan plan_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.plan ALTER COLUMN plan_id SET DEFAULT nextval('public.plan_plan_id_seq'::regclass);


--
-- Name: public_to_posda_file_comparison public_to_posda_file_comparison_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_to_posda_file_comparison ALTER COLUMN public_to_posda_file_comparison_id SET DEFAULT nextval('public.public_to_posda_file_comparis_public_to_posda_file_comparis_seq'::regclass);


--
-- Name: query_invoked_by_dbif query_invoked_by_dbif_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.query_invoked_by_dbif ALTER COLUMN query_invoked_by_dbif_id SET DEFAULT nextval('public.query_invoked_by_dbif_query_invoked_by_dbif_id_seq'::regclass);


--
-- Name: report_inserted report_inserted_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.report_inserted ALTER COLUMN report_inserted_id SET DEFAULT nextval('public.report_inserted_report_inserted_id_seq'::regclass);


--
-- Name: roi roi_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.roi ALTER COLUMN roi_id SET DEFAULT nextval('public.roi_roi_id_seq'::regclass);


--
-- Name: roi_contour roi_contour_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.roi_contour ALTER COLUMN roi_contour_id SET DEFAULT nextval('public.roi_contour_roi_contour_id_seq'::regclass);


--
-- Name: roi_observation roi_observation_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.roi_observation ALTER COLUMN roi_observation_id SET DEFAULT nextval('public.roi_observation_roi_observation_id_seq'::regclass);


--
-- Name: roi_physical_properties roi_phyical_properties_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.roi_physical_properties ALTER COLUMN roi_phyical_properties_id SET DEFAULT nextval('public.roi_physical_properties_roi_phyical_properties_id_seq'::regclass);


--
-- Name: rt_dose rt_dose_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rt_dose ALTER COLUMN rt_dose_id SET DEFAULT nextval('public.rt_dose_rt_dose_id_seq'::regclass);


--
-- Name: rt_dvh rt_dvh_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rt_dvh ALTER COLUMN rt_dvh_id SET DEFAULT nextval('public.rt_dvh_rt_dvh_id_seq'::regclass);


--
-- Name: rt_dvh_dvh rt_dvh_dvh_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rt_dvh_dvh ALTER COLUMN rt_dvh_dvh_id SET DEFAULT nextval('public.rt_dvh_dvh_rt_dvh_dvh_id_seq'::regclass);


--
-- Name: rt_prescription rt_prescription_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rt_prescription ALTER COLUMN rt_prescription_id SET DEFAULT nextval('public.rt_prescription_rt_prescription_id_seq'::regclass);


--
-- Name: slope_intercept slope_intercept_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.slope_intercept ALTER COLUMN slope_intercept_id SET DEFAULT nextval('public.slope_intercept_slope_intercept_id_seq'::regclass);


--
-- Name: spreadsheet_uploaded spreadsheet_uploaded_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.spreadsheet_uploaded ALTER COLUMN spreadsheet_uploaded_id SET DEFAULT nextval('public.spreadsheet_uploaded_spreadsheet_uploaded_id_seq'::regclass);


--
-- Name: ss_for ss_for_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.ss_for ALTER COLUMN ss_for_id SET DEFAULT nextval('public.ss_for_ss_for_id_seq'::regclass);


--
-- Name: structure_set structure_set_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.structure_set ALTER COLUMN structure_set_id SET DEFAULT nextval('public.structure_set_structure_set_id_seq'::regclass);


--
-- Name: subprocess_invocation subprocess_invocation_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.subprocess_invocation ALTER COLUMN subprocess_invocation_id SET DEFAULT nextval('public.subprocess_invocation_subprocess_invocation_id_seq'::regclass);


--
-- Name: unique_pixel_data unique_pixel_data_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.unique_pixel_data ALTER COLUMN unique_pixel_data_id SET DEFAULT nextval('public.unique_pixel_data_unique_pixel_data_id_seq'::regclass);


--
-- Name: user_activity user_activity_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_activity ALTER COLUMN user_activity_id SET DEFAULT nextval('public.user_activity_user_activity_id_seq'::regclass);


--
-- Name: user_inbox user_inbox_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox ALTER COLUMN user_inbox_id SET DEFAULT nextval('public.user_inbox_user_inbox_id_seq'::regclass);


--
-- Name: user_inbox_content user_inbox_content_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox_content ALTER COLUMN user_inbox_content_id SET DEFAULT nextval('public.user_inbox_content_user_inbox_content_id_seq'::regclass);


--
-- Name: visual_review_instance visual_review_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.visual_review_instance ALTER COLUMN visual_review_instance_id SET DEFAULT nextval('public.visual_review_instance_visual_review_instance_id_seq'::regclass);


--
-- Name: window_level window_level_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.window_level ALTER COLUMN window_level_id SET DEFAULT nextval('public.window_level_window_level_id_seq'::regclass);


--
-- Name: background_buttons background_buttons_pkey; Type: CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.background_buttons
    ADD CONSTRAINT background_buttons_pkey PRIMARY KEY (background_button_id);


--
-- Name: popup_buttons popup_buttons_pkey; Type: CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.popup_buttons
    ADD CONSTRAINT popup_buttons_pkey PRIMARY KEY (popup_button_id);


--
-- Name: query_tabs query_tabs_query_tab_name_key; Type: CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.query_tabs
    ADD CONSTRAINT query_tabs_query_tab_name_key UNIQUE (query_tab_name);


--
-- Name: role role_pkey; Type: CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.role
    ADD CONSTRAINT role_pkey PRIMARY KEY (role_name);


--
-- Name: spreadsheet_operation spreadsheet_operation_operation_name_key; Type: CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.spreadsheet_operation
    ADD CONSTRAINT spreadsheet_operation_operation_name_key UNIQUE (operation_name);


--
-- Name: background_subprocess background_subprocess_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.background_subprocess
    ADD CONSTRAINT background_subprocess_pkey PRIMARY KEY (background_subprocess_id);


--
-- Name: background_subprocess_report background_subprocess_report_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.background_subprocess_report
    ADD CONSTRAINT background_subprocess_report_pkey PRIMARY KEY (background_subprocess_report_id);


--
-- Name: collection_codes collection_codes_collection_code_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.collection_codes
    ADD CONSTRAINT collection_codes_collection_code_key UNIQUE (collection_code);


--
-- Name: collection_codes collection_codes_collection_name_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.collection_codes
    ADD CONSTRAINT collection_codes_collection_name_key UNIQUE (collection_name);


--
-- Name: ctp_file_new ctp_file_new_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.ctp_file_new
    ADD CONSTRAINT ctp_file_new_pkey PRIMARY KEY (file_id);


--
-- Name: ctp_file ctp_file_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.ctp_file
    ADD CONSTRAINT ctp_file_pkey PRIMARY KEY (file_id);


--
-- Name: dicom_edit_compare_disposition dicom_edit_compare_disposition_subprocess_invocation_id_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dicom_edit_compare_disposition
    ADD CONSTRAINT dicom_edit_compare_disposition_subprocess_invocation_id_key UNIQUE (subprocess_invocation_id);


--
-- Name: distinguished_pixel_digests distinguished_pixel_digests_pixel_digest_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.distinguished_pixel_digests
    ADD CONSTRAINT distinguished_pixel_digests_pixel_digest_key UNIQUE (pixel_digest);


--
-- Name: downloadable_dir downloadable_dir_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.downloadable_dir
    ADD CONSTRAINT downloadable_dir_pkey PRIMARY KEY (downloadable_dir_id);


--
-- Name: downloadable_file downloadable_file_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.downloadable_file
    ADD CONSTRAINT downloadable_file_pkey PRIMARY KEY (downloadable_file_id);


--
-- Name: file_ct_image file_ct_image__new_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_ct_image
    ADD CONSTRAINT file_ct_image__new_pkey PRIMARY KEY (file_id);


--
-- Name: file_equipment file_equipment_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_equipment
    ADD CONSTRAINT file_equipment_pkey PRIMARY KEY (file_id);


--
-- Name: file_for file_for_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_for
    ADD CONSTRAINT file_for_pkey PRIMARY KEY (file_id);


--
-- Name: file_meta file_meta_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_meta
    ADD CONSTRAINT file_meta_pkey PRIMARY KEY (file_id);


--
-- Name: file_mr file_mr_file_id_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_mr
    ADD CONSTRAINT file_mr_file_id_key UNIQUE (file_id);


--
-- Name: file_patient file_patient_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_patient
    ADD CONSTRAINT file_patient_pkey PRIMARY KEY (file_id);


--
-- Name: file_pt_image file_pt_image_file_id_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_pt_image
    ADD CONSTRAINT file_pt_image_file_id_key UNIQUE (file_id);


--
-- Name: file_series file_series_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_series
    ADD CONSTRAINT file_series_pkey PRIMARY KEY (file_id);


--
-- Name: file_sop_common file_sop_common_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_sop_common
    ADD CONSTRAINT file_sop_common_pkey PRIMARY KEY (file_id);


--
-- Name: file_study file_study_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_study
    ADD CONSTRAINT file_study_pkey PRIMARY KEY (file_id);


--
-- Name: image_equivalence_class_input_image image_equivalence_class_input_image_uniq; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.image_equivalence_class_input_image
    ADD CONSTRAINT image_equivalence_class_input_image_uniq UNIQUE (image_equivalence_class_id, file_id);


--
-- Name: non_dicom_edit_compare_disposition non_dicom_edit_compare_disposition_subprocess_invocation_id_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.non_dicom_edit_compare_disposition
    ADD CONSTRAINT non_dicom_edit_compare_disposition_subprocess_invocation_id_key UNIQUE (subprocess_invocation_id);


--
-- Name: patient_import_status patient_import_status_patient_id_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.patient_import_status
    ADD CONSTRAINT patient_import_status_patient_id_key UNIQUE (patient_id);


--
-- Name: site_codes site_codes_site_code_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.site_codes
    ADD CONSTRAINT site_codes_site_code_key UNIQUE (site_code);


--
-- Name: site_codes site_codes_site_name_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.site_codes
    ADD CONSTRAINT site_codes_site_name_key UNIQUE (site_name);


--
-- Name: user_inbox_content user_inbox_content_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox_content
    ADD CONSTRAINT user_inbox_content_pkey PRIMARY KEY (user_inbox_content_id);


--
-- Name: user_inbox user_inbox_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox
    ADD CONSTRAINT user_inbox_pkey PRIMARY KEY (user_inbox_id);


--
-- Name: user_inbox user_inbox_user_name_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox
    ADD CONSTRAINT user_inbox_user_name_key UNIQUE (user_name);


--
-- Name: queries_name_index; Type: INDEX; Schema: dbif_config; Owner: -
--

CREATE UNIQUE INDEX queries_name_index ON dbif_config.queries USING btree (name);


--
-- Name: role_tabs_uidx; Type: INDEX; Schema: dbif_config; Owner: -
--

CREATE UNIQUE INDEX role_tabs_uidx ON dbif_config.role_tabs USING btree (role_name, query_tab_name);


--
-- Name: assocation_import_event_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX assocation_import_event_id_idx ON public.association_import USING btree (import_event_id);


--
-- Name: assocation_import_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX assocation_import_id ON public.association_import USING btree (association_id);


--
-- Name: association_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX association_pk ON public.association USING btree (association_id);


--
-- Name: beam_applicator_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX beam_applicator_plan_idx ON public.beam_applicator USING btree (plan_id, beam_number, applicator_id);


--
-- Name: beam_block_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX beam_block_idx ON public.beam_block USING btree (plan_id, beam_number, block_number);


--
-- Name: beam_control_point_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX beam_control_point_idx ON public.beam_control_point USING btree (plan_id, beam_number, control_point_index);


--
-- Name: beam_limiting_device_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX beam_limiting_device_idx ON public.beam_limiting_device USING btree (plan_id, beam_number);


--
-- Name: clinical_trial_qualified_patient_collection_site_patient_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX clinical_trial_qualified_patient_collection_site_patient_id_idx ON public.clinical_trial_qualified_patient_id USING btree (collection, site, patient_id);


--
-- Name: contour_image_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX contour_image_id_idx ON public.contour_image USING btree (roi_contour_id);


--
-- Name: contour_image_rev_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX contour_image_rev_idx ON public.contour_image USING btree (sop_instance, roi_contour_id);


--
-- Name: control_point_bld_position_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX control_point_bld_position_idx ON public.control_point_bld_position USING btree (plan_id, beam_number, control_point_index);


--
-- Name: ctp_file_all_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_file_all_idx ON public.ctp_file_new USING btree (file_id, project_name, site_name);


--
-- Name: ctp_file_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_file_file_id_index ON public.ctp_file USING btree (file_id);


--
-- Name: ctp_file_project_site_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_file_project_site_idx ON public.ctp_file_new USING btree (project_name, site_name);


--
-- Name: ctp_file_vis_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_file_vis_idx ON public.ctp_file USING btree (visibility);


--
-- Name: ctp_proj_site_file_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_proj_site_file_index ON public.ctp_file USING btree (file_id, project_name, site_name);


--
-- Name: ctp_proj_site_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ctp_proj_site_index ON public.ctp_file USING btree (project_name, site_name);


--
-- Name: ctp_upload_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX ctp_upload_index ON public.ctp_upload_event USING btree (file_id, rcv_timestamp);


--
-- Name: dec_from_file_dig_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dec_from_file_dig_index ON public.dicom_edit_compare USING btree (from_file_digest);


--
-- Name: dec_to_file_dig_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dec_to_file_dig_index ON public.dicom_edit_compare USING btree (to_file_digest);


--
-- Name: dicom_edit_compare_subprocess_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dicom_edit_compare_subprocess_index ON public.dicom_edit_compare USING btree (subprocess_invocation_id);


--
-- Name: dicom_file_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dicom_file_file_id_index ON public.dicom_file USING btree (file_id);


--
-- Name: dicom_file_send_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dicom_file_send_idx ON public.dicom_file_send USING btree (dicom_send_event_id);


--
-- Name: dicom_process_errors_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dicom_process_errors_file_id_idx ON public.dicom_process_errors USING btree (file_id);


--
-- Name: dicom_send_event_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX dicom_send_event_pk ON public.dicom_send_event USING btree (dicom_send_event_id);


--
-- Name: file_ct_image_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_ct_image_file_id_index ON public.file_ct_image__old USING btree (file_id);


--
-- Name: file_digest_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX file_digest_index ON public.file USING btree (digest);


--
-- Name: file_dose_file_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_dose_file_idx ON public.file_dose USING btree (file_id);


--
-- Name: file_dose_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_dose_idx ON public.file_dose USING btree (rt_dose_id);


--
-- Name: file_ele_ref_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX file_ele_ref_pk ON public.file_ele_ref USING btree (file_ele_ref_id);


--
-- Name: file_equipment_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_equipment_file_id_idx ON public.file_equipment USING btree (file_id);


--
-- Name: file_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX file_file_id_idx ON public.file USING btree (file_id);


--
-- Name: file_for_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_for_file_id_idx ON public.file_for USING btree (file_id);


--
-- Name: file_image_geometry_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_image_geometry_file_id_idx ON public.file_image_geometry USING btree (file_id);


--
-- Name: file_image_geometry_image_geometry_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_image_geometry_image_geometry_id_idx ON public.file_image_geometry USING btree (image_geometry_id);


--
-- Name: file_image_main_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_image_main_idx ON public.file_image USING btree (file_id, image_id);


--
-- Name: file_import_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_import_file_id_idx ON public.file_import USING btree (file_id);


--
-- Name: file_import_import_event_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_import_import_event_id_idx ON public.file_import USING btree (import_event_id);


--
-- Name: file_import_import_event_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_import_import_event_index ON public.file_import USING btree (import_event_id);


--
-- Name: file_import_series_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_import_series_file_id_idx ON public.file_import_series USING btree (file_id);


--
-- Name: file_import_series_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX file_import_series_pk ON public.file_import_series USING btree (file_import_series_id);


--
-- Name: file_location_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_location_file_id_idx ON public.file_location USING btree (file_id);


--
-- Name: file_patient_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_patient_file_id_index ON public.file_patient USING btree (file_id);


--
-- Name: file_patient_patient_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_patient_patient_id_index ON public.file_patient USING btree (patient_id);


--
-- Name: file_plan_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_plan_file_id_idx ON public.file_plan USING btree (file_id);


--
-- Name: file_plan_plan_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_plan_plan_id_idx ON public.file_plan USING btree (plan_id);


--
-- Name: file_roi_image_linkage_linked_sop_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_roi_image_linkage_linked_sop_idx ON public.file_roi_image_linkage USING btree (linked_sop_instance_uid);


--
-- Name: file_series_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_series_file_id_index ON public.file_series USING btree (file_id);


--
-- Name: file_series_uid_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_series_uid_idx ON public.file_series USING btree (series_instance_uid);


--
-- Name: file_slope_intercept_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_slope_intercept_file_id_idx ON public.file_slope_intercept USING btree (file_id);


--
-- Name: file_slope_intercept_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_slope_intercept_id_idx ON public.file_slope_intercept USING btree (slope_intercept_id);


--
-- Name: file_sop_common_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_sop_common_file_id_idx ON public.file_sop_common USING btree (file_id);


--
-- Name: file_sop_common_sop_instance_uid_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_sop_common_sop_instance_uid_index ON public.file_sop_common USING btree (sop_instance_uid);


--
-- Name: file_storage_root_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX file_storage_root_pk ON public.file_storage_root USING btree (file_storage_root_id);


--
-- Name: file_structure_set_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_structure_set_idx ON public.file_structure_set USING btree (file_id, structure_set_id);


--
-- Name: file_study_file_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_study_file_id_index ON public.file_study USING btree (file_id);


--
-- Name: file_visibility_change_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_visibility_change_idx ON public.file_visibility_change USING btree (file_id);


--
-- Name: file_win_lev_main_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_win_lev_main_idx ON public.file_win_lev USING btree (file_id, window_level_id, wl_index);


--
-- Name: fraction_reference_beam_beam_number; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX fraction_reference_beam_beam_number ON public.fraction_reference_beam USING btree (beam_number);


--
-- Name: fraction_reference_beam_fraction_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX fraction_reference_beam_fraction_idx ON public.fraction_reference_beam USING btree (fraction_group_number);


--
-- Name: fraction_reference_beam_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX fraction_reference_beam_plan_idx ON public.fraction_reference_beam USING btree (plan_id);


--
-- Name: image_equivalence_class_input_image_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_equivalence_class_input_image_file_id_idx ON public.image_equivalence_class_input_image USING btree (file_id);


--
-- Name: image_equivalence_class_input_image_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_equivalence_class_input_image_id_idx ON public.image_equivalence_class_input_image USING btree (image_equivalence_class_id);


--
-- Name: image_equivalence_class_out_image_file_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_equivalence_class_out_image_file_idx ON public.image_equivalence_class_out_image USING btree (file_id);


--
-- Name: image_equivalence_class_out_image_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_equivalence_class_out_image_idx ON public.image_equivalence_class_out_image USING btree (image_equivalence_class_id);


--
-- Name: image_equivalence_class_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX image_equivalence_class_pk ON public.image_equivalence_class USING btree (image_equivalence_class_id);


--
-- Name: image_equivalence_class_vri; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_equivalence_class_vri ON public.image_equivalence_class USING btree (visual_review_instance_id);


--
-- Name: image_geometry_image_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_geometry_image_id_index ON public.image_geometry USING btree (image_id);


--
-- Name: image_geometry_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX image_geometry_pk ON public.image_geometry USING btree (image_geometry_id);


--
-- Name: image_image_id_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX image_image_id_pk ON public.image USING btree (image_id);


--
-- Name: image_slope_intercept_image_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_slope_intercept_image_idx ON public.image_slope_intercept USING btree (image_id);


--
-- Name: image_slope_intercept_slope_intercept_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_slope_intercept_slope_intercept_idx ON public.image_slope_intercept USING btree (slope_intercept_id);


--
-- Name: image_window_level_image_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_window_level_image_idx ON public.image_window_level USING btree (image_id);


--
-- Name: image_window_level_window_level_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX image_window_level_window_level_idx ON public.image_window_level USING btree (window_level_id);


--
-- Name: import_event_import_event_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX import_event_import_event_id_idx ON public.import_event USING btree (import_event_id);


--
-- Name: import_event_import_time_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX import_event_import_time_idx ON public.import_event USING btree (import_time);


--
-- Name: pixel_location_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pixel_location_file_id_idx ON public.pixel_location USING btree (file_id);


--
-- Name: pixel_location_unique_pixel_data_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pixel_location_unique_pixel_data_id_idx ON public.pixel_location USING btree (unique_pixel_data_id);


--
-- Name: plan_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX plan_pk ON public.plan USING btree (plan_id);


--
-- Name: query_by_user_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX query_by_user_index ON public.query_invoked_by_dbif USING btree (invoking_user);


--
-- Name: queue_size; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX queue_size ON public.file USING btree (is_dicom_file, ready_to_process, processing_priority);


--
-- Name: roi_contour_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX roi_contour_idx ON public.roi_contour USING btree (roi_id);


--
-- Name: roi_contour_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX roi_contour_pk ON public.roi_contour USING btree (roi_contour_id);


--
-- Name: roi_observation_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX roi_observation_id_idx ON public.roi_observation USING btree (roi_id);


--
-- Name: roi_observation_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX roi_observation_pk ON public.roi_observation USING btree (roi_observation_id);


--
-- Name: roi_physical_properties_observation_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX roi_physical_properties_observation_idx ON public.roi_physical_properties USING btree (roi_observation_id);


--
-- Name: roi_physical_properties_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX roi_physical_properties_pk ON public.roi_physical_properties USING btree (roi_phyical_properties_id);


--
-- Name: roi_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX roi_pk ON public.roi USING btree (roi_id);


--
-- Name: roi_structure_set_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX roi_structure_set_idx ON public.roi USING btree (structure_set_id);


--
-- Name: rt_beam_number_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_beam_number_idx ON public.rt_beam USING btree (beam_number);


--
-- Name: rt_beam_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_beam_plan_idx ON public.rt_beam USING btree (plan_id);


--
-- Name: rt_beam_tolerance_table_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_beam_tolerance_table_plan_idx ON public.rt_beam_tolerance_table USING btree (plan_id);


--
-- Name: rt_beam_tolerance_table_table_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_beam_tolerance_table_table_idx ON public.rt_beam_tolerance_table USING btree (tolerance_table_number);


--
-- Name: rt_dose_image_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_dose_image_idx ON public.rt_dose_image USING btree (rt_dose_id);


--
-- Name: rt_dose_image_image_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_dose_image_image_idx ON public.rt_dose_image USING btree (image_id);


--
-- Name: rt_dose_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX rt_dose_pk ON public.rt_dose USING btree (rt_dose_id);


--
-- Name: rt_dvh_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX rt_dvh_pk ON public.rt_dvh USING btree (rt_dvh_id);


--
-- Name: rt_plan_fraction_group_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_plan_fraction_group_idx ON public.rt_plan_fraction_group USING btree (plan_id);


--
-- Name: rt_plan_patient_setup_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_plan_patient_setup_plan_idx ON public.rt_plan_patient_setup USING btree (plan_id);


--
-- Name: rt_prescription_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX rt_prescription_pk ON public.rt_prescription USING btree (rt_prescription_id);


--
-- Name: rt_prescription_plan_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rt_prescription_plan_idx ON public.rt_prescription USING btree (plan_id);


--
-- Name: slope_intercept_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX slope_intercept_pk ON public.slope_intercept USING btree (slope_intercept_id);


--
-- Name: ss_for_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX ss_for_pk ON public.ss_for USING btree (ss_for_id);


--
-- Name: ss_volume_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_volume_id_idx ON public.ss_volume USING btree (ss_for_id);


--
-- Name: structure_set_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX structure_set_pk ON public.structure_set USING btree (structure_set_id);


--
-- Name: unique_pixel_data_digest; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX unique_pixel_data_digest ON public.unique_pixel_data USING btree (digest);


--
-- Name: unique_pixel_data_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX unique_pixel_data_pk ON public.unique_pixel_data USING btree (unique_pixel_data_id);


--
-- Name: unique_pixel_date_image; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX unique_pixel_date_image ON public.image USING btree (unique_pixel_data_id);


--
-- Name: user_variable_binding_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX user_variable_binding_index ON public.user_variable_binding USING btree (binding_user, bound_variable_name);


--
-- Name: window_level_pk; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX window_level_pk ON public.window_level USING btree (window_level_id);


--
-- Name: phantom_files_idx; Type: INDEX; Schema: quasar; Owner: -
--

CREATE INDEX phantom_files_idx ON quasar.phantom_files USING btree (file_id);


--
-- Name: role_tabs role_tabs_query_tab_name_fkey; Type: FK CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.role_tabs
    ADD CONSTRAINT role_tabs_query_tab_name_fkey FOREIGN KEY (query_tab_name) REFERENCES dbif_config.query_tabs(query_tab_name);


--
-- Name: role_tabs role_tabs_role_name_fkey; Type: FK CONSTRAINT; Schema: dbif_config; Owner: -
--

ALTER TABLE ONLY dbif_config.role_tabs
    ADD CONSTRAINT role_tabs_role_name_fkey FOREIGN KEY (role_name) REFERENCES dbif_config.role(role_name);


--
-- Name: background_subprocess_report background_subprocess_report_background_subprocess_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.background_subprocess_report
    ADD CONSTRAINT background_subprocess_report_background_subprocess_id_fkey FOREIGN KEY (background_subprocess_id) REFERENCES public.background_subprocess(background_subprocess_id);


--
-- Name: downloadable_file downloadable_file_file_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.downloadable_file
    ADD CONSTRAINT downloadable_file_file_id_fkey FOREIGN KEY (file_id) REFERENCES public.file(file_id);


--
-- Name: user_inbox_content user_inbox_content_background_subprocess_report_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox_content
    ADD CONSTRAINT user_inbox_content_background_subprocess_report_id_fkey FOREIGN KEY (background_subprocess_report_id) REFERENCES public.background_subprocess_report(background_subprocess_report_id);


--
-- Name: user_inbox_content_operation user_inbox_content_operation_user_inbox_content_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox_content_operation
    ADD CONSTRAINT user_inbox_content_operation_user_inbox_content_id_fkey FOREIGN KEY (user_inbox_content_id) REFERENCES public.user_inbox_content(user_inbox_content_id);


--
-- Name: user_inbox_content user_inbox_content_user_inbox_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.user_inbox_content
    ADD CONSTRAINT user_inbox_content_user_inbox_id_fkey FOREIGN KEY (user_inbox_id) REFERENCES public.user_inbox(user_inbox_id);


--
-- PostgreSQL database dump complete
--

--
-- Name: file_imports_over_time; Type: MATERIALIZED VIEW; Schema: public; Owner: -
--

CREATE MATERIALIZED VIEW public.file_imports_over_time AS
 SELECT count(file.file_id) AS count,
    date_part('month'::text, import_event.import_time) AS importmonth,
    date_part('year'::text, import_event.import_time) AS importyear
   FROM ((public.file
     JOIN public.file_import USING (file_id))
     JOIN public.import_event USING (import_event_id))
  GROUP BY (date_part('year'::text, import_event.import_time)), (date_part('month'::text, import_event.import_time))
  WITH NO DATA;


--
-- Name: files_without_type; Type: MATERIALIZED VIEW; Schema: public; Owner: -
--

CREATE MATERIALIZED VIEW public.files_without_type AS
 SELECT file.file_id,
    file.digest,
    file.size,
    file.is_dicom_file,
    file.file_type,
    file.processing_priority,
    file.ready_to_process
   FROM public.file
  WHERE (file.file_type IS NULL)
  WITH NO DATA;


--
-- Name: activity_timpepoint_file_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX activity_timpepoint_file_idx ON public.activity_timepoint_file USING btree (activity_timepoint_id, file_id);


--
-- Name: files_without_type_file_id_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX files_without_type_file_id_idx ON public.files_without_type USING btree (file_id);
-- This file is for default values that should be set for a new install,
-- but are not part of the UI configuration or queries themselves.
\connect posda_files

COPY user_inbox (user_inbox_id, user_name, user_email_addr) FROM stdin;
1	admin	admin@admin.bogus
\.

SELECT pg_catalog.setval('user_inbox_user_inbox_id_seq', 1, true);
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_nicknames; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_nicknames WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_nicknames

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: db_version; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA db_version;


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: version; Type: TABLE; Schema: db_version; Owner: -
--

CREATE TABLE db_version.version (
    version integer
);


--
-- Name: file_nickname; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.file_nickname (
    project_name text,
    site_name text,
    subj_id text,
    sop_instance_uid text,
    sop_nickname_copy text,
    version_number integer,
    file_digest text
);


--
-- Name: for_nickname; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.for_nickname (
    project_name text,
    site_name text,
    subj_id text,
    for_nickname text,
    for_instance_uid text
);


--
-- Name: nickname_sequence; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.nickname_sequence (
    project_name text,
    site_name text,
    subj_id text,
    nickname_type text,
    next_value integer
);


--
-- Name: series_nickname; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.series_nickname (
    project_name text,
    site_name text,
    subj_id text,
    series_nickname text,
    series_instance_uid text
);


--
-- Name: sop_nickname; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sop_nickname (
    project_name text,
    site_name text,
    subj_id text,
    sop_nickname text,
    modality text,
    has_modality_conflict boolean,
    sop_instance_uid text
);


--
-- Name: study_nickname; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.study_nickname (
    project_name text,
    site_name text,
    subj_id text,
    study_nickname text,
    study_instance_uid text
);


--
-- Name: file_nickname file_nickname_file_digest_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.file_nickname
    ADD CONSTRAINT file_nickname_file_digest_key UNIQUE (file_digest);


--
-- Name: file_nickname_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX file_nickname_lookup ON public.file_nickname USING btree (project_name, site_name, subj_id, sop_instance_uid);


--
-- Name: for_nickname_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX for_nickname_lookup ON public.for_nickname USING btree (project_name, site_name, subj_id, for_nickname);


--
-- Name: for_nickname_lookup_by_uid; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX for_nickname_lookup_by_uid ON public.for_nickname USING btree (project_name, site_name, subj_id, for_instance_uid);


--
-- Name: series_nickname_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX series_nickname_lookup ON public.series_nickname USING btree (project_name, site_name, subj_id, series_nickname);


--
-- Name: series_nickname_lookup_by_uid; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX series_nickname_lookup_by_uid ON public.series_nickname USING btree (project_name, site_name, subj_id, series_instance_uid);


--
-- Name: sop_nickname_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX sop_nickname_lookup ON public.sop_nickname USING btree (project_name, site_name, subj_id, sop_nickname);


--
-- Name: sop_nickname_lookup_by_uid; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX sop_nickname_lookup_by_uid ON public.sop_nickname USING btree (project_name, site_name, subj_id, sop_instance_uid);


--
-- Name: study_nickname_lookup; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX study_nickname_lookup ON public.study_nickname USING btree (project_name, site_name, subj_id, study_nickname);


--
-- Name: study_nickname_lookup_by_uid; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX study_nickname_lookup_by_uid ON public.study_nickname USING btree (project_name, site_name, subj_id, study_instance_uid);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_phi; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_phi WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_phi

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: element_signature; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.element_signature (
    element_signature_id integer NOT NULL,
    element_signature text NOT NULL,
    is_private boolean NOT NULL,
    vr text NOT NULL,
    private_disposition text,
    name_chain text
);


--
-- Name: element_signature_change; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.element_signature_change (
    element_signature_id integer NOT NULL,
    when_sig_changed timestamp with time zone,
    who_changed_sig text,
    old_disposition text,
    old_name_chain text,
    new_disposition text,
    new_name_chain text,
    why_sig_changed text
);


--
-- Name: element_signature_element_signature_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.element_signature_element_signature_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: element_signature_element_signature_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.element_signature_element_signature_id_seq OWNED BY public.element_signature.element_signature_id;


--
-- Name: equipment_signature; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.equipment_signature (
    equipment_signature_id integer NOT NULL,
    equipment_signature text NOT NULL
);


--
-- Name: equipment_signature_equipment_signature_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.equipment_signature_equipment_signature_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: equipment_signature_equipment_signature_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.equipment_signature_equipment_signature_id_seq OWNED BY public.equipment_signature.equipment_signature_id;


--
-- Name: private_disposition_interpretation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.private_disposition_interpretation (
    disposition text,
    meaning text
);


--
-- Name: public_disposition; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_disposition (
    element_signature_id integer NOT NULL,
    sop_class_uid text NOT NULL,
    disposition text,
    name text
);


--
-- Name: public_disposition_interpretation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_disposition_interpretation (
    disposition text,
    meaning text
);


--
-- Name: scan_element; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.scan_element (
    scan_element_id integer NOT NULL,
    element_signature_id integer NOT NULL,
    series_scan_id integer NOT NULL,
    seen_value_id integer NOT NULL
);


--
-- Name: scan_element_scan_element_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.scan_element_scan_element_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: scan_element_scan_element_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.scan_element_scan_element_id_seq OWNED BY public.scan_element.scan_element_id;


--
-- Name: scan_event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.scan_event (
    scan_event_id integer NOT NULL,
    scan_started timestamp with time zone,
    scan_ended timestamp with time zone,
    scan_status text,
    scan_description text,
    num_series_to_scan integer,
    num_series_scanned integer
);


--
-- Name: scan_event_scan_event_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.scan_event_scan_event_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: scan_event_scan_event_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.scan_event_scan_event_id_seq OWNED BY public.scan_event.scan_event_id;


--
-- Name: seen_value; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.seen_value (
    seen_value_id integer NOT NULL,
    value text
);


--
-- Name: seen_value_seen_value_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.seen_value_seen_value_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: seen_value_seen_value_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.seen_value_seen_value_id_seq OWNED BY public.seen_value.seen_value_id;


--
-- Name: sequence_index; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sequence_index (
    scan_element_id integer NOT NULL,
    sequence_level integer NOT NULL,
    item_number integer NOT NULL
);


--
-- Name: series_scan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.series_scan (
    series_scan_id integer NOT NULL,
    scan_event_id integer NOT NULL,
    equipment_signature_id integer NOT NULL,
    series_instance_uid text NOT NULL,
    series_scanned_file text,
    series_scan_status text
);


--
-- Name: series_scan_series_scan_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.series_scan_series_scan_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: series_scan_series_scan_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.series_scan_series_scan_id_seq OWNED BY public.series_scan.series_scan_id;


--
-- Name: element_signature element_signature_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.element_signature ALTER COLUMN element_signature_id SET DEFAULT nextval('public.element_signature_element_signature_id_seq'::regclass);


--
-- Name: equipment_signature equipment_signature_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.equipment_signature ALTER COLUMN equipment_signature_id SET DEFAULT nextval('public.equipment_signature_equipment_signature_id_seq'::regclass);


--
-- Name: scan_element scan_element_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.scan_element ALTER COLUMN scan_element_id SET DEFAULT nextval('public.scan_element_scan_element_id_seq'::regclass);


--
-- Name: scan_event scan_event_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.scan_event ALTER COLUMN scan_event_id SET DEFAULT nextval('public.scan_event_scan_event_id_seq'::regclass);


--
-- Name: seen_value seen_value_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.seen_value ALTER COLUMN seen_value_id SET DEFAULT nextval('public.seen_value_seen_value_id_seq'::regclass);


--
-- Name: series_scan series_scan_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.series_scan ALTER COLUMN series_scan_id SET DEFAULT nextval('public.series_scan_series_scan_id_seq'::regclass);


--
-- Name: private_disposition_interpretation private_disposition_interpretation_disposition_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.private_disposition_interpretation
    ADD CONSTRAINT private_disposition_interpretation_disposition_key UNIQUE (disposition);


--
-- Name: public_disposition_interpretation public_disposition_interpretation_disposition_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_disposition_interpretation
    ADD CONSTRAINT public_disposition_interpretation_disposition_key UNIQUE (disposition);


--
-- Name: ele_signature_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX ele_signature_index ON public.element_signature USING btree (element_signature, vr);


--
-- Name: scan_element_element_signature_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX scan_element_element_signature_id_index ON public.scan_element USING btree (element_signature_id);


--
-- Name: scan_element_series_scan_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX scan_element_series_scan_id_index ON public.scan_element USING btree (series_scan_id);


--
-- Name: series_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX series_index ON public.series_scan USING btree (series_instance_uid, scan_event_id);


--
-- Name: series_scan_equipment_signature_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX series_scan_equipment_signature_id_index ON public.series_scan USING btree (equipment_signature_id);


--
-- Name: series_scan_scan_event_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX series_scan_scan_event_id_index ON public.series_scan USING btree (scan_event_id);


--
-- Name: value_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX value_index ON public.seen_value USING btree (value);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: posda_phi_simple; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE posda_phi_simple WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect posda_phi_simple

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: dciodvfy_error; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_error (
    dciodvfy_error_id integer NOT NULL,
    error_type text NOT NULL,
    error_tag text,
    error_value text,
    error_subtype text,
    error_module text,
    error_reason text,
    error_index text,
    error_text text
);


--
-- Name: dciodvfy_error_dciodvfy_error_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dciodvfy_error_dciodvfy_error_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dciodvfy_error_dciodvfy_error_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dciodvfy_error_dciodvfy_error_id_seq OWNED BY public.dciodvfy_error.dciodvfy_error_id;


--
-- Name: dciodvfy_scan_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_scan_instance (
    dciodvfy_scan_instance_id integer NOT NULL,
    type_of_unit text,
    description_of_scan text,
    number_units integer,
    scanned_so_far integer,
    start_time timestamp with time zone,
    end_time timestamp with time zone
);


--
-- Name: dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq OWNED BY public.dciodvfy_scan_instance.dciodvfy_scan_instance_id;


--
-- Name: dciodvfy_unit_scan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_unit_scan (
    dciodvfy_unit_scan_id integer NOT NULL,
    type_of_unit text,
    unit_uid text,
    unit_id integer,
    num_file_in_unit integer,
    num_errors_in_unit integer,
    num_warnings_in_unit integer,
    start_time timestamp with time zone,
    end_time timestamp with time zone
);


--
-- Name: dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq OWNED BY public.dciodvfy_unit_scan.dciodvfy_unit_scan_id;


--
-- Name: dciodvfy_unit_scan_error; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_unit_scan_error (
    dciodvfy_scan_instance_id integer NOT NULL,
    dciodvfy_unit_scan_id integer NOT NULL,
    dciodvfy_error_id integer NOT NULL
);


--
-- Name: dciodvfy_unit_scan_warning; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_unit_scan_warning (
    dciodvfy_scan_instance_id integer NOT NULL,
    dciodvfy_unit_scan_id integer NOT NULL,
    dciodvfy_warning_id integer NOT NULL
);


--
-- Name: dciodvfy_warning; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dciodvfy_warning (
    dciodvfy_warning_id integer NOT NULL,
    warning_type text NOT NULL,
    warning_tag text,
    warning_desc text,
    warning_iod text,
    warning_comment text,
    warning_value text,
    warning_reason text,
    warning_index text,
    warning_text text
);


--
-- Name: dciodvfy_warning_dciodvfy_warning_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dciodvfy_warning_dciodvfy_warning_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: dciodvfy_warning_dciodvfy_warning_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dciodvfy_warning_dciodvfy_warning_id_seq OWNED BY public.dciodvfy_warning.dciodvfy_warning_id;


--
-- Name: element_disposition_changed; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.element_disposition_changed (
    element_seen_id integer NOT NULL,
    when_changed timestamp with time zone,
    who_changed text,
    why_changed text,
    new_disposition text
);


--
-- Name: element_seen; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.element_seen (
    element_seen_id integer NOT NULL,
    element_sig_pattern text,
    vr text,
    is_private boolean,
    tag_name text,
    private_disposition text
);


--
-- Name: element_seen_element_seen_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.element_seen_element_seen_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: element_seen_element_seen_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.element_seen_element_seen_id_seq OWNED BY public.element_seen.element_seen_id;


--
-- Name: element_value_occurance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.element_value_occurance (
    element_seen_id integer NOT NULL,
    value_seen_id integer NOT NULL,
    series_scan_instance_id integer NOT NULL,
    phi_scan_instance_id integer NOT NULL
);


--
-- Name: non_dicom_file_scan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_file_scan (
    non_dicom_file_scan_id integer NOT NULL,
    phi_non_dicom_scan_instance_id integer NOT NULL,
    file_type text NOT NULL,
    file_in_posda boolean,
    file_in_wrapped_tgz boolean,
    posda_file_id integer,
    rel_path text,
    sop_instance_uid text
);


--
-- Name: non_dicom_file_scan_non_dicom_file_scan_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.non_dicom_file_scan_non_dicom_file_scan_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: non_dicom_file_scan_non_dicom_file_scan_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.non_dicom_file_scan_non_dicom_file_scan_id_seq OWNED BY public.non_dicom_file_scan.non_dicom_file_scan_id;


--
-- Name: non_dicom_path_seen; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_path_seen (
    non_dicom_path_seen_id integer NOT NULL,
    non_dicom_file_type text,
    non_dicom_path text
);


--
-- Name: non_dicom_path_seen_non_dicom_path_seen_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.non_dicom_path_seen_non_dicom_path_seen_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: non_dicom_path_seen_non_dicom_path_seen_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.non_dicom_path_seen_non_dicom_path_seen_id_seq OWNED BY public.non_dicom_path_seen.non_dicom_path_seen_id;


--
-- Name: non_dicom_path_value_occurrance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.non_dicom_path_value_occurrance (
    non_dicom_path_seen_id integer NOT NULL,
    value_seen_id integer NOT NULL,
    non_dicom_file_scan_id integer NOT NULL
);


--
-- Name: phi_non_dicom_scan_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.phi_non_dicom_scan_instance (
    phi_non_dicom_scan_instance_id integer NOT NULL,
    pndsi_description text,
    pndsi_start_time timestamp with time zone,
    pndsi_num_files integer,
    pndsi_num_files_scanned integer,
    pndsi_end_time timestamp with time zone,
    pndsi_process_pid integer
);


--
-- Name: phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq OWNED BY public.phi_non_dicom_scan_instance.phi_non_dicom_scan_instance_id;


--
-- Name: phi_scan_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.phi_scan_instance (
    phi_scan_instance_id integer NOT NULL,
    description text NOT NULL,
    start_time timestamp with time zone,
    num_series integer,
    num_series_scanned integer,
    end_time timestamp with time zone,
    file_query text
);


--
-- Name: phi_scan_instance_phi_scan_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.phi_scan_instance_phi_scan_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: phi_scan_instance_phi_scan_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.phi_scan_instance_phi_scan_instance_id_seq OWNED BY public.phi_scan_instance.phi_scan_instance_id;


--
-- Name: series_scan_instance; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.series_scan_instance (
    series_scan_instance_id integer NOT NULL,
    scan_instance_id integer NOT NULL,
    series_instance_uid text NOT NULL,
    num_files integer,
    start_time timestamp with time zone,
    end_time timestamp with time zone
);


--
-- Name: series_scan_instance_series_scan_instance_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.series_scan_instance_series_scan_instance_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: series_scan_instance_series_scan_instance_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.series_scan_instance_series_scan_instance_id_seq OWNED BY public.series_scan_instance.series_scan_instance_id;


--
-- Name: value_seen; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.value_seen (
    value_seen_id integer NOT NULL,
    value text NOT NULL
);


--
-- Name: value_seen_value_seen_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.value_seen_value_seen_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: value_seen_value_seen_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.value_seen_value_seen_id_seq OWNED BY public.value_seen.value_seen_id;


--
-- Name: dciodvfy_error dciodvfy_error_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dciodvfy_error ALTER COLUMN dciodvfy_error_id SET DEFAULT nextval('public.dciodvfy_error_dciodvfy_error_id_seq'::regclass);


--
-- Name: dciodvfy_scan_instance dciodvfy_scan_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dciodvfy_scan_instance ALTER COLUMN dciodvfy_scan_instance_id SET DEFAULT nextval('public.dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq'::regclass);


--
-- Name: dciodvfy_unit_scan dciodvfy_unit_scan_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dciodvfy_unit_scan ALTER COLUMN dciodvfy_unit_scan_id SET DEFAULT nextval('public.dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq'::regclass);


--
-- Name: dciodvfy_warning dciodvfy_warning_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dciodvfy_warning ALTER COLUMN dciodvfy_warning_id SET DEFAULT nextval('public.dciodvfy_warning_dciodvfy_warning_id_seq'::regclass);


--
-- Name: element_seen element_seen_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.element_seen ALTER COLUMN element_seen_id SET DEFAULT nextval('public.element_seen_element_seen_id_seq'::regclass);


--
-- Name: non_dicom_file_scan non_dicom_file_scan_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.non_dicom_file_scan ALTER COLUMN non_dicom_file_scan_id SET DEFAULT nextval('public.non_dicom_file_scan_non_dicom_file_scan_id_seq'::regclass);


--
-- Name: non_dicom_path_seen non_dicom_path_seen_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.non_dicom_path_seen ALTER COLUMN non_dicom_path_seen_id SET DEFAULT nextval('public.non_dicom_path_seen_non_dicom_path_seen_id_seq'::regclass);


--
-- Name: phi_non_dicom_scan_instance phi_non_dicom_scan_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.phi_non_dicom_scan_instance ALTER COLUMN phi_non_dicom_scan_instance_id SET DEFAULT nextval('public.phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq'::regclass);


--
-- Name: phi_scan_instance phi_scan_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.phi_scan_instance ALTER COLUMN phi_scan_instance_id SET DEFAULT nextval('public.phi_scan_instance_phi_scan_instance_id_seq'::regclass);


--
-- Name: series_scan_instance series_scan_instance_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.series_scan_instance ALTER COLUMN series_scan_instance_id SET DEFAULT nextval('public.series_scan_instance_series_scan_instance_id_seq'::regclass);


--
-- Name: value_seen value_seen_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.value_seen ALTER COLUMN value_seen_id SET DEFAULT nextval('public.value_seen_value_seen_id_seq'::regclass);


--
-- Name: value_seen value_seen_value_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.value_seen
    ADD CONSTRAINT value_seen_value_key UNIQUE (value);


--
-- Name: element_seen_and_value_seen_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX element_seen_and_value_seen_index ON public.element_value_occurance USING btree (element_seen_id, value_seen_id);


--
-- Name: element_seen_vr_pair_index; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX element_seen_vr_pair_index ON public.element_seen USING btree (element_sig_pattern, vr);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: private_tag_kb; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE private_tag_kb WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect private_tag_kb

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: db_version; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA db_version;


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: version; Type: TABLE; Schema: db_version; Owner: -
--

CREATE TABLE db_version.version (
    version integer
);


--
-- Name: pt; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt (
    pt_id integer NOT NULL,
    pt_signature text NOT NULL,
    pt_short_signature text NOT NULL,
    pt_owner text NOT NULL,
    pt_group text NOT NULL,
    pt_element text NOT NULL,
    pt_is_specific_to_block boolean,
    pt_specific_block text,
    pt_consensus_vr text,
    pt_consensus_vm text,
    pt_consensus_name text,
    pt_consensus_disposition text
);


--
-- Name: pt_dcmtk; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt_dcmtk (
    pt_dcmtk_is_repeating boolean,
    pt_id integer,
    ptrg_id integer,
    pt_dcmtk_signature text,
    pt_dcmtk_vr text,
    pt_dcmtk_vm text,
    pt_dcmtk_name text
);


--
-- Name: pt_dicom3; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt_dicom3 (
    pt_dicom3_is_repeating boolean,
    pt_id integer,
    ptrg_id integer,
    pt_dicom3_tag text,
    pt_dicom3_vr text,
    pt_dicom3_vm text,
    pt_dicom3_name text,
    pt_dicom3_keyword text,
    pt_dicom3_owner text,
    pt_dicom3_vers text,
    pt_dicom3_comment text,
    pt_dicom3_assumption text,
    pt_dicom3_private_block text
);


--
-- Name: pt_gdcm; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt_gdcm (
    pt_gdcm_is_repeating boolean,
    pt_id integer,
    ptrg_id integer,
    pt_gdcm_signature text,
    pt_gdcm_vr text,
    pt_gdcm_vm text,
    pt_gdcm_name text
);


--
-- Name: pt_observation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt_observation (
    pt_id integer NOT NULL,
    pt_obs_observer text,
    pt_obs_value text,
    pt_obs_comment text,
    pt_obs_time timestamp with time zone
);


--
-- Name: pt_pt_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.pt_pt_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: pt_pt_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.pt_pt_id_seq OWNED BY public.pt.pt_id;


--
-- Name: pt_wustl; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pt_wustl (
    pt_id integer,
    pt_wustl_vr text,
    pt_wustl_vm text,
    pt_wustl_vm_second text,
    pt_wustl_name text,
    pt_wustl_name_second text,
    pt_wustl_disposition text,
    pt_wustl_disposition_second text,
    pt_wustl_is_specific_to_block boolean,
    pt_wustl_private_block text,
    pt_wustl_signature text,
    pt_wustl_device_sig text
);


--
-- Name: ptrg; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ptrg (
    ptrg_id integer NOT NULL,
    ptrg_signature_masked text NOT NULL,
    ptrg_owner text NOT NULL,
    ptrg_base_grp integer NOT NULL,
    ptrg_grp_mask integer NOT NULL,
    ptrg_grp_ext_mask integer NOT NULL,
    ptrg_grp_ext_shift integer NOT NULL,
    ptrg_element text NOT NULL,
    ptrg_is_specific_to_block boolean,
    ptrg_specific_block text,
    ptrg_consensus_vr text,
    ptrg_consensus_vm text,
    ptrg_consensus_name text,
    ptrg_consensus_disposition text
);


--
-- Name: ptrg_observation; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.ptrg_observation (
    ptrg_id integer NOT NULL,
    ptrg_obs_observer text,
    ptrg_obs_value text,
    ptrg_obs_comment text,
    ptrg_obs_time timestamp with time zone
);


--
-- Name: ptrg_ptrg_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.ptrg_ptrg_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ptrg_ptrg_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.ptrg_ptrg_id_seq OWNED BY public.ptrg.ptrg_id;


--
-- Name: pt pt_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pt ALTER COLUMN pt_id SET DEFAULT nextval('public.pt_pt_id_seq'::regclass);


--
-- Name: ptrg ptrg_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.ptrg ALTER COLUMN ptrg_id SET DEFAULT nextval('public.ptrg_ptrg_id_seq'::regclass);


--
-- Name: pt pt_pt_signature_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pt
    ADD CONSTRAINT pt_pt_signature_key UNIQUE (pt_signature);


--
-- Name: ptrg ptrg_ptrg_signature_masked_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.ptrg
    ADD CONSTRAINT ptrg_ptrg_signature_masked_key UNIQUE (ptrg_signature_masked);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: public_tag_disposition; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE public_tag_disposition WITH TEMPLATE = template0 ENCODING = 'UTF8' LC_COLLATE = 'en_US.UTF-8' LC_CTYPE = 'en_US.UTF-8';


\connect public_tag_disposition

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: public_tag_disposition; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.public_tag_disposition (
    tag_name text,
    name text,
    disposition text
);


--
-- Name: public_tag_disposition public_tag_disposition_tag_name_key; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.public_tag_disposition
    ADD CONSTRAINT public_tag_disposition_tag_name_key UNIQUE (tag_name);


--
-- PostgreSQL database dump complete
--

\connect dicom_dd
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.7 (Ubuntu 10.7-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- Data for Name: dicom_element; Type: TABLE DATA; Schema: public; Owner: posda
--

COPY public.dicom_element (tag, name, keyword, vr, vm, is_retired, comments) FROM stdin;
(0008,0001)	Length to End	LengthToEnd	UL	1	t	
(0008,0005)	Specific Character Set	SpecificCharacterSet	CS	1-n	f	
(0008,0006)	Language Code Sequence	LanguageCodeSequence	SQ	1	f	
(0008,0008)	Image Type	ImageType	CS	2-n	f	
(0008,0010)	Recognition Code	RecognitionCode	SH	1	t	
(0008,0012)	Instance Creation Date	InstanceCreationDate	DA	1	f	
(0008,0013)	Instance Creation Time	InstanceCreationTime	TM	1	f	
(0008,0014)	Instance Creator UID	InstanceCreatorUID	UI	1	f	
(0008,0015)	Instance Coercion DateTime	InstanceCoercionDateTime	DT	1	f	
(0008,0016)	SOP Class UID	SOPClassUID	UI	1	f	
(0008,0018)	SOP Instance UID	SOPInstanceUID	UI	1	f	
(0008,001a)	Related General SOP Class UID	RelatedGeneralSOPClassUID	UI	1-n	f	
(0008,001b)	Original Specialized SOP Class UID	OriginalSpecializedSOPClassUID	UI	1	f	
(0008,0020)	Study Date	StudyDate	DA	1	f	
(0008,0021)	Series Date	SeriesDate	DA	1	f	
(0008,0022)	Acquisition Date	AcquisitionDate	DA	1	f	
(0008,0023)	Content Date	ContentDate	DA	1	f	
(0008,0024)	Overlay Date	OverlayDate	DA	1	t	
(0008,0025)	Curve Date	CurveDate	DA	1	t	
(0008,002a)	Acquisition DateTime	AcquisitionDateTime	DT	1	f	
(0008,0030)	Study Time	StudyTime	TM	1	f	
(0008,0031)	Series Time	SeriesTime	TM	1	f	
(0008,0032)	Acquisition Time	AcquisitionTime	TM	1	f	
(0008,0033)	Content Time	ContentTime	TM	1	f	
(0008,0034)	Overlay Time	OverlayTime	TM	1	t	
(0008,0035)	Curve Time	CurveTime	TM	1	t	
(0008,0040)	Data Set Type	DataSetType	US	1	t	
(0008,0041)	Data Set Subtype	DataSetSubtype	LO	1	t	
(0008,0042)	Nuclear Medicine Series Type	NuclearMedicineSeriesType	CS	1	t	
(0008,0050)	Accession Number	AccessionNumber	SH	1	f	
(0008,0051)	Issuer of Accession Number Sequence	IssuerOfAccessionNumberSequence	SQ	1	f	
(0008,0052)	Query/Retrieve Level	QueryRetrieveLevel	CS	1	f	
(0008,0053)	Query/Retrieve View	QueryRetrieveView	CS	1	f	
(0008,0054)	Retrieve AE Title	RetrieveAETitle	AE	1-n	f	
(0008,0055)	Station AE Title	StationAETitle	AE	1	f	
(0008,0056)	Instance Availability	InstanceAvailability	CS	1	f	
(0008,0058)	Failed SOP Instance UID List	FailedSOPInstanceUIDList	UI	1-n	f	
(0008,0060)	Modality	Modality	CS	1	f	
(0008,0061)	Modalities in Study	ModalitiesInStudy	CS	1-n	f	
(0008,0062)	SOP Classes in Study	SOPClassesInStudy	UI	1-n	f	
(0008,0064)	Conversion Type	ConversionType	CS	1	f	
(0008,0068)	Presentation Intent Type	PresentationIntentType	CS	1	f	
(0008,0070)	Manufacturer	Manufacturer	LO	1	f	
(0008,0080)	Institution Name	InstitutionName	LO	1	f	
(0008,0081)	Institution Address	InstitutionAddress	ST	1	f	
(0008,0082)	Institution Code Sequence	InstitutionCodeSequence	SQ	1	f	
(0008,0090)	Referring Physician's Name	ReferringPhysicianName	PN	1	f	
(0008,0092)	Referring Physician's Address	ReferringPhysicianAddress	ST	1	f	
(0008,0094)	Referring Physician's Telephone Numbers	ReferringPhysicianTelephoneNumbers	SH	1-n	f	
(0008,0096)	Referring Physician Identification Sequence	ReferringPhysicianIdentificationSequence	SQ	1	f	
(0008,009c)	Consulting Physician's Name	ConsultingPhysicianName	PN	1-n	f	
(0008,009d)	Consulting Physician Identification Sequence	ConsultingPhysicianIdentificationSequence	SQ	1	f	
(0008,0100)	Code Value	CodeValue	SH	1	f	
(0008,0101)	Extended Code Value	ExtendedCodeValue	LO	1	f	DICOS
(0008,0102)	Coding Scheme Designator	CodingSchemeDesignator	SH	1	f	
(0008,0103)	Coding Scheme Version	CodingSchemeVersion	SH	1	f	
(0008,0104)	Code Meaning	CodeMeaning	LO	1	f	
(0008,0105)	Mapping Resource	MappingResource	CS	1	f	
(0008,0106)	Context Group Version	ContextGroupVersion	DT	1	f	
(0008,0107)	Context Group Local Version	ContextGroupLocalVersion	DT	1	f	
(0008,0108)	Extended Code Meaning	ExtendedCodeMeaning	LT	1	f	DICOS
(0008,010b)	Context Group Extension Flag	ContextGroupExtensionFlag	CS	1	f	
(0008,010c)	Coding Scheme UID	CodingSchemeUID	UI	1	f	
(0008,010d)	Context Group Extension Creator UID	ContextGroupExtensionCreatorUID	UI	1	f	
(0008,010f)	Context Identifier	ContextIdentifier	CS	1	f	
(0008,0110)	Coding Scheme Identification Sequence	CodingSchemeIdentificationSequence	SQ	1	f	
(0008,0112)	Coding Scheme Registry	CodingSchemeRegistry	LO	1	f	
(0008,0114)	Coding Scheme External ID	CodingSchemeExternalID	ST	1	f	
(0008,0115)	Coding Scheme Name	CodingSchemeName	ST	1	f	
(0008,0116)	Coding Scheme Responsible Organization	CodingSchemeResponsibleOrganization	ST	1	f	
(0008,0117)	Context UID	ContextUID	UI	1	f	
(0008,0118)	Mapping Resource UID	MappingResourceUID	UI	1	f	
(0008,0119)	Long Code Value	LongCodeValue	UC	1	f	
(0008,0120)	URN Code Value	URNCodeValue	UR	1	f	
(0008,0121)	Equivalent Code Sequence	EquivalentCodeSequence	SQ	1	f	
(0008,0122)	Mapping Resource Name	MappingResourceName	LO	1	f	
(0008,0123)	Context Group Identification Sequence	ContextGroupIdentificationSequence	SQ	1	f	
(0008,0124)	Mapping Resource Identification Sequence	MappingResourceIdentificationSequence	SQ	1	f	
(0008,0201)	Timezone Offset From UTC	TimezoneOffsetFromUTC	SH	1	f	
(0008,0300)	Private Data Element Characteristics Sequence	PrivateDataElementCharacteristicsSequence	SQ	1	f	
(0008,0301)	Private Group Reference	PrivateGroupReference	US	1	f	
(0008,0302)	Private Creator Reference	PrivateCreatorReference	LO	1	f	
(0008,0303)	Block Identifying Information Status	BlockIdentifyingInformationStatus	CS	1	f	
(0008,0304)	Nonidentifying Private Elements	NonidentifyingPrivateElements	US	1-n	f	
(0008,0306)	Identifying Private Elements	IdentifyingPrivateElements	US	1-n	f	
(0008,0305)	Deidentification Action Sequence	DeidentificationActionSequence	SQ	1	f	
(3004,0001)	DVH Type	DVHType	CS	1	f	
(0008,0307)	Deidentification Action	DeidentificationAction	CS	1	f	
(0008,1000)	Network ID	NetworkID	AE	1	t	
(0008,1010)	Station Name	StationName	SH	1	f	
(0008,1030)	Study Description	StudyDescription	LO	1	f	
(0008,1032)	Procedure Code Sequence	ProcedureCodeSequence	SQ	1	f	
(0008,103e)	Series Description	SeriesDescription	LO	1	f	
(0008,103f)	Series Description Code Sequence	SeriesDescriptionCodeSequence	SQ	1	f	
(0008,1040)	Institutional Department Name	InstitutionalDepartmentName	LO	1	f	
(0008,1048)	Physician(s) of Record	PhysiciansOfRecord	PN	1-n	f	
(0008,1049)	Physician(s) of Record Identification Sequence	PhysiciansOfRecordIdentificationSequence	SQ	1	f	
(0008,1050)	Performing Physician's Name	PerformingPhysicianName	PN	1-n	f	
(0008,1052)	Performing Physician Identification Sequence	PerformingPhysicianIdentificationSequence	SQ	1	f	
(0008,1060)	Name of Physician(s) Reading Study	NameOfPhysiciansReadingStudy	PN	1-n	f	
(0008,1062)	Physician(s) Reading Study Identification Sequence	PhysiciansReadingStudyIdentificationSequence	SQ	1	f	
(0008,1070)	Operators' Name	OperatorsName	PN	1-n	f	
(0008,1072)	Operator Identification Sequence	OperatorIdentificationSequence	SQ	1	f	
(0008,1080)	Admitting Diagnoses Description	AdmittingDiagnosesDescription	LO	1-n	f	
(0008,1084)	Admitting Diagnoses Code Sequence	AdmittingDiagnosesCodeSequence	SQ	1	f	
(0008,1090)	Manufacturer's Model Name	ManufacturerModelName	LO	1	f	
(0008,1100)	Referenced Results Sequence	ReferencedResultsSequence	SQ	1	t	
(0008,1110)	Referenced Study Sequence	ReferencedStudySequence	SQ	1	f	
(0008,1111)	Referenced Performed Procedure Step Sequence	ReferencedPerformedProcedureStepSequence	SQ	1	f	
(0008,1115)	Referenced Series Sequence	ReferencedSeriesSequence	SQ	1	f	
(0008,1120)	Referenced Patient Sequence	ReferencedPatientSequence	SQ	1	f	
(0008,1125)	Referenced Visit Sequence	ReferencedVisitSequence	SQ	1	f	
(0008,1130)	Referenced Overlay Sequence	ReferencedOverlaySequence	SQ	1	t	
(0008,1134)	Referenced Stereometric Instance Sequence	ReferencedStereometricInstanceSequence	SQ	1	f	
(0008,113a)	Referenced Waveform Sequence	ReferencedWaveformSequence	SQ	1	f	
(0008,1140)	Referenced Image Sequence	ReferencedImageSequence	SQ	1	f	
(0008,1145)	Referenced Curve Sequence	ReferencedCurveSequence	SQ	1	t	
(0008,114a)	Referenced Instance Sequence	ReferencedInstanceSequence	SQ	1	f	
(0008,114b)	Referenced Real World Value Mapping Instance Sequence	ReferencedRealWorldValueMappingInstanceSequence	SQ	1	f	
(0008,1150)	Referenced SOP Class UID	ReferencedSOPClassUID	UI	1	f	
(0008,1155)	Referenced SOP Instance UID	ReferencedSOPInstanceUID	UI	1	f	
(0008,115a)	SOP Classes Supported	SOPClassesSupported	UI	1-n	f	
(0008,1160)	Referenced Frame Number	ReferencedFrameNumber	IS	1-n	f	
(0008,1161)	Simple Frame List	SimpleFrameList	UL	1-n	f	
(0008,1162)	Calculated Frame List	CalculatedFrameList	UL	3-3n	f	
(0008,1163)	Time Range	TimeRange	FD	2	f	
(0008,1164)	Frame Extraction Sequence	FrameExtractionSequence	SQ	1	f	
(0008,1167)	Multi-frame Source SOP Instance UID	MultiFrameSourceSOPInstanceUID	UI	1	f	
(0008,1190)	Retrieve URL	RetrieveURL	UR	1	f	
(0008,1195)	Transaction UID	TransactionUID	UI	1	f	
(0008,1196)	Warning Reason	WarningReason	US	1	f	
(0008,1197)	Failure Reason	FailureReason	US	1	f	
(0008,1198)	Failed SOP Sequence	FailedSOPSequence	SQ	1	f	
(0008,1199)	Referenced SOP Sequence	ReferencedSOPSequence	SQ	1	f	
(0008,119a)	Other Failures Sequence	OtherFailuresSequence	SQ	1	f	
(0008,1200)	Studies Containing Other Referenced Instances Sequence	StudiesContainingOtherReferencedInstancesSequence	SQ	1	f	
(0008,1250)	Related Series Sequence	RelatedSeriesSequence	SQ	1	f	
(0008,2110)	Lossy Image Compression (Retired)	LossyImageCompressionRetired	CS	1	t	
(0008,2111)	Derivation Description	DerivationDescription	ST	1	f	
(0008,2112)	Source Image Sequence	SourceImageSequence	SQ	1	f	
(0008,2120)	Stage Name	StageName	SH	1	f	
(0008,2122)	Stage Number	StageNumber	IS	1	f	
(0008,2124)	Number of Stages	NumberOfStages	IS	1	f	
(0008,2127)	View Name	ViewName	SH	1	f	
(0008,2128)	View Number	ViewNumber	IS	1	f	
(0008,2129)	Number of Event Timers	NumberOfEventTimers	IS	1	f	
(0008,212a)	Number of Views in Stage	NumberOfViewsInStage	IS	1	f	
(0008,2130)	Event Elapsed Time(s)	EventElapsedTimes	DS	1-n	f	
(0008,2132)	Event Timer Name(s)	EventTimerNames	LO	1-n	f	
(0008,2133)	Event Timer Sequence	EventTimerSequence	SQ	1	f	
(0008,2134)	Event Time Offset	EventTimeOffset	FD	1	f	
(0008,2135)	Event Code Sequence	EventCodeSequence	SQ	1	f	
(0008,2142)	Start Trim	StartTrim	IS	1	f	
(0008,2143)	Stop Trim	StopTrim	IS	1	f	
(0008,2144)	Recommended Display Frame Rate	RecommendedDisplayFrameRate	IS	1	f	
(0008,2200)	Transducer Position	TransducerPosition	CS	1	t	
(0008,2204)	Transducer Orientation	TransducerOrientation	CS	1	t	
(0008,2208)	Anatomic Structure	AnatomicStructure	CS	1	t	
(0008,2218)	Anatomic Region Sequence	AnatomicRegionSequence	SQ	1	f	
(0008,2220)	Anatomic Region Modifier Sequence	AnatomicRegionModifierSequence	SQ	1	f	
(0008,2228)	Primary Anatomic Structure Sequence	PrimaryAnatomicStructureSequence	SQ	1	f	
(0008,2229)	Anatomic Structure Space or Region Sequence	AnatomicStructureSpaceOrRegionSequence	SQ	1	f	
(0008,2230)	Primary Anatomic Structure Modifier Sequence	PrimaryAnatomicStructureModifierSequence	SQ	1	f	
(0008,2240)	Transducer Position Sequence	TransducerPositionSequence	SQ	1	t	
(0008,2242)	Transducer Position Modifier Sequence	TransducerPositionModifierSequence	SQ	1	t	
(0008,2244)	Transducer Orientation Sequence	TransducerOrientationSequence	SQ	1	t	
(0008,2246)	Transducer Orientation Modifier Sequence	TransducerOrientationModifierSequence	SQ	1	t	
(0008,2251)	Anatomic Structure Space Or Region Code Sequence (Trial)	AnatomicStructureSpaceOrRegionCodeSequenceTrial	SQ	1	t	
(0008,2253)	Anatomic Portal Of Entrance Code Sequence (Trial)	AnatomicPortalOfEntranceCodeSequenceTrial	SQ	1	t	
(0008,2255)	Anatomic Approach Direction Code Sequence (Trial)	AnatomicApproachDirectionCodeSequenceTrial	SQ	1	t	
(0008,2256)	Anatomic Perspective Description (Trial)	AnatomicPerspectiveDescriptionTrial	ST	1	t	
(0008,2257)	Anatomic Perspective Code Sequence (Trial)	AnatomicPerspectiveCodeSequenceTrial	SQ	1	t	
(0008,2258)	Anatomic Location Of Examining Instrument Description (Trial)	AnatomicLocationOfExaminingInstrumentDescriptionTrial	ST	1	t	
(0008,2259)	Anatomic Location Of Examining Instrument Code Sequence (Trial)	AnatomicLocationOfExaminingInstrumentCodeSequenceTrial	SQ	1	t	
(0008,225a)	Anatomic Structure Space Or Region Modifier Code Sequence (Trial)	AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial	SQ	1	t	
(0008,225c)	On Axis Background Anatomic Structure Code Sequence (Trial)	OnAxisBackgroundAnatomicStructureCodeSequenceTrial	SQ	1	t	
(0008,3001)	Alternate Representation Sequence	AlternateRepresentationSequence	SQ	1	f	
(0008,3010)	Irradiation Event UID	IrradiationEventUID	UI	1-n	f	
(0008,3011)	Source Irradiation Event Sequence	SourceIrradiationEventSequence	SQ	1	f	
(0008,3012)	Radiopharmaceutical Administration Event UID	RadiopharmaceuticalAdministrationEventUID	UI	1	f	
(0008,4000)	Identifying Comments	IdentifyingComments	LT	1	t	
(0008,9007)	Frame Type	FrameType	CS	4	f	
(0008,9092)	Referenced Image Evidence Sequence	ReferencedImageEvidenceSequence	SQ	1	f	
(0008,9121)	Referenced Raw Data Sequence	ReferencedRawDataSequence	SQ	1	f	
(0008,9123)	Creator-Version UID	CreatorVersionUID	UI	1	f	
(0008,9124)	Derivation Image Sequence	DerivationImageSequence	SQ	1	f	
(0008,9154)	Source Image Evidence Sequence	SourceImageEvidenceSequence	SQ	1	f	
(0008,9205)	Pixel Presentation	PixelPresentation	CS	1	f	
(0008,9206)	Volumetric Properties	VolumetricProperties	CS	1	f	
(0008,9207)	Volume Based Calculation Technique	VolumeBasedCalculationTechnique	CS	1	f	
(0008,9208)	Complex Image Component	ComplexImageComponent	CS	1	f	
(0008,9209)	Acquisition Contrast	AcquisitionContrast	CS	1	f	
(0008,9215)	Derivation Code Sequence	DerivationCodeSequence	SQ	1	f	
(0008,9237)	Referenced Presentation State Sequence	ReferencedPresentationStateSequence	SQ	1	f	
(0008,9410)	Referenced Other Plane Sequence	ReferencedOtherPlaneSequence	SQ	1	f	
(0008,9458)	Frame Display Sequence	FrameDisplaySequence	SQ	1	f	
(0008,9459)	Recommended Display Frame Rate in Float	RecommendedDisplayFrameRateInFloat	FL	1	f	
(0008,9460)	Skip Frame Range Flag	SkipFrameRangeFlag	CS	1	f	
(0010,0010)	Patient's Name	PatientName	PN	1	f	
(0010,0020)	Patient ID	PatientID	LO	1	f	
(0010,0021)	Issuer of Patient ID	IssuerOfPatientID	LO	1	f	
(0010,0022)	Type of Patient ID	TypeOfPatientID	CS	1	f	
(0010,0024)	Issuer of Patient ID Qualifiers Sequence	IssuerOfPatientIDQualifiersSequence	SQ	1	f	
(0010,0026)	Source Patient Group Identification Sequence	SourcePatientGroupIdentificationSequence	SQ	1	f	
(0010,0027)	Group of Patients Identification Sequence	GroupOfPatientsIdentificationSequence	SQ	1	f	
(0010,0028)	Subject Relative Position in Image	SubjectRelativePositionInImage	US	3	f	
(0010,0030)	Patient's Birth Date	PatientBirthDate	DA	1	f	
(0010,0032)	Patient's Birth Time	PatientBirthTime	TM	1	f	
(0010,0033)	Patient's Birth Date in Alternative Calendar	PatientBirthDateInAlternativeCalendar	LO	1	f	
(0010,0034)	Patient's Death Date in Alternative Calendar	PatientDeathDateInAlternativeCalendar	LO	1	f	
(0010,0035)	Patient's Alternative Calendar	PatientAlternativeCalendar	CS	1	f	
(0010,0040)	Patient's Sex	PatientSex	CS	1	f	
(0010,0050)	Patient's Insurance Plan Code Sequence	PatientInsurancePlanCodeSequence	SQ	1	f	
(0010,0101)	Patient's Primary Language Code Sequence	PatientPrimaryLanguageCodeSequence	SQ	1	f	
(0010,0102)	Patient's Primary Language Modifier Code Sequence	PatientPrimaryLanguageModifierCodeSequence	SQ	1	f	
(0010,0200)	Quality Control Subject	QualityControlSubject	CS	1	f	
(0010,0201)	Quality Control Subject Type Code Sequence	QualityControlSubjectTypeCodeSequence	SQ	1	f	
(0010,0212)	Strain Description	StrainDescription	UC	1	f	
(0010,0213)	Strain Nomenclature	StrainNomenclature	LO	1	f	
(0010,0214)	Strain Stock Number	StrainStockNumber	LO	1	f	
(0010,0215)	Strain Source Registry Code Sequence	StrainSourceRegistryCodeSequence	SQ	1	f	
(0010,0216)	Strain Stock Sequence	StrainStockSequence	SQ	1	f	
(0010,0217)	Strain Source	StrainSource	LO	1	f	
(0010,0218)	Strain Additional Information	StrainAdditionalInformation	UT	1	f	
(0010,0219)	Strain Code Sequence	StrainCodeSequence	SQ	1	f	
(0010,1000)	Other Patient IDs	OtherPatientIDs	LO	1-n	f	
(0010,1001)	Other Patient Names	OtherPatientNames	PN	1-n	f	
(0010,1002)	Other Patient IDs Sequence	OtherPatientIDsSequence	SQ	1	f	
(0010,1005)	Patient's Birth Name	PatientBirthName	PN	1	f	
(0010,1010)	Patient's Age	PatientAge	AS	1	f	
(0010,1020)	Patient's Size	PatientSize	DS	1	f	
(0010,1021)	Patient's Size Code Sequence	PatientSizeCodeSequence	SQ	1	f	
(0010,1030)	Patient's Weight	PatientWeight	DS	1	f	
(0010,1040)	Patient's Address	PatientAddress	LO	1	f	
(0010,1050)	Insurance Plan Identification	InsurancePlanIdentification	LO	1-n	t	
(0010,1060)	Patient's Mother's Birth Name	PatientMotherBirthName	PN	1	f	
(0010,1080)	Military Rank	MilitaryRank	LO	1	f	
(0010,1081)	Branch of Service	BranchOfService	LO	1	f	
(0010,1090)	Medical Record Locator	MedicalRecordLocator	LO	1	f	
(0010,1100)	Referenced Patient Photo Sequence	ReferencedPatientPhotoSequence	SQ	1	f	
(0010,2000)	Medical Alerts	MedicalAlerts	LO	1-n	f	
(0010,2110)	Allergies	Allergies	LO	1-n	f	
(0010,2150)	Country of Residence	CountryOfResidence	LO	1	f	
(3004,0002)	Dose Units	DoseUnits	CS	1	f	
(0010,2152)	Region of Residence	RegionOfResidence	LO	1	f	
(0010,2154)	Patient's Telephone Numbers	PatientTelephoneNumbers	SH	1-n	f	
(0010,2155)	Patient's Telecom Information	PatientTelecomInformation	LT	1	f	
(0010,2160)	Ethnic Group	EthnicGroup	SH	1	f	
(0010,2180)	Occupation	Occupation	SH	1	f	
(0010,21a0)	Smoking Status	SmokingStatus	CS	1	f	
(0010,21b0)	Additional Patient History	AdditionalPatientHistory	LT	1	f	
(0010,21c0)	Pregnancy Status	PregnancyStatus	US	1	f	
(0010,21d0)	Last Menstrual Date	LastMenstrualDate	DA	1	f	
(0010,21f0)	Patient's Religious Preference	PatientReligiousPreference	LO	1	f	
(0010,2201)	Patient Species Description	PatientSpeciesDescription	LO	1	f	
(0010,2202)	Patient Species Code Sequence	PatientSpeciesCodeSequence	SQ	1	f	
(0010,2203)	Patient's Sex Neutered	PatientSexNeutered	CS	1	f	
(0010,2210)	Anatomical Orientation Type	AnatomicalOrientationType	CS	1	f	
(0010,2292)	Patient Breed Description	PatientBreedDescription	LO	1	f	
(0010,2293)	Patient Breed Code Sequence	PatientBreedCodeSequence	SQ	1	f	
(0010,2294)	Breed Registration Sequence	BreedRegistrationSequence	SQ	1	f	
(0010,2295)	Breed Registration Number	BreedRegistrationNumber	LO	1	f	
(0010,2296)	Breed Registry Code Sequence	BreedRegistryCodeSequence	SQ	1	f	
(0010,2297)	Responsible Person	ResponsiblePerson	PN	1	f	
(0010,2298)	Responsible Person Role	ResponsiblePersonRole	CS	1	f	
(0010,2299)	Responsible Organization	ResponsibleOrganization	LO	1	f	
(0010,4000)	Patient Comments	PatientComments	LT	1	f	
(0010,9431)	Examined Body Thickness	ExaminedBodyThickness	FL	1	f	
(0012,0010)	Clinical Trial Sponsor Name	ClinicalTrialSponsorName	LO	1	f	
(0012,0020)	Clinical Trial Protocol ID	ClinicalTrialProtocolID	LO	1	f	
(0012,0021)	Clinical Trial Protocol Name	ClinicalTrialProtocolName	LO	1	f	
(0012,0030)	Clinical Trial Site ID	ClinicalTrialSiteID	LO	1	f	
(0012,0031)	Clinical Trial Site Name	ClinicalTrialSiteName	LO	1	f	
(0012,0040)	Clinical Trial Subject ID	ClinicalTrialSubjectID	LO	1	f	
(0012,0042)	Clinical Trial Subject Reading ID	ClinicalTrialSubjectReadingID	LO	1	f	
(0012,0050)	Clinical Trial Time Point ID	ClinicalTrialTimePointID	LO	1	f	
(0012,0051)	Clinical Trial Time Point Description	ClinicalTrialTimePointDescription	ST	1	f	
(0012,0060)	Clinical Trial Coordinating Center Name	ClinicalTrialCoordinatingCenterName	LO	1	f	
(0012,0062)	Patient Identity Removed	PatientIdentityRemoved	CS	1	f	
(0012,0063)	De-identification Method	DeidentificationMethod	LO	1-n	f	
(0012,0064)	De-identification Method Code Sequence	DeidentificationMethodCodeSequence	SQ	1	f	
(0012,0071)	Clinical Trial Series ID	ClinicalTrialSeriesID	LO	1	f	
(0012,0072)	Clinical Trial Series Description	ClinicalTrialSeriesDescription	LO	1	f	
(0012,0081)	Clinical Trial Protocol Ethics Committee Name	ClinicalTrialProtocolEthicsCommitteeName	LO	1	f	
(0012,0082)	Clinical Trial Protocol Ethics Committee Approval Number	ClinicalTrialProtocolEthicsCommitteeApprovalNumber	LO	1	f	
(0012,0083)	Consent for Clinical Trial Use Sequence	ConsentForClinicalTrialUseSequence	SQ	1	f	
(0012,0084)	Distribution Type	DistributionType	CS	1	f	
(0012,0085)	Consent for Distribution Flag	ConsentForDistributionFlag	CS	1	f	
(0014,0023)	CAD File Format	CADFileFormat	ST	1	t	
(0014,0024)	Component Reference System	ComponentReferenceSystem	ST	1	t	
(0014,0025)	Component Manufacturing Procedure	ComponentManufacturingProcedure	ST	1	f	DICONDE
(0014,0028)	Component Manufacturer	ComponentManufacturer	ST	1	f	DICONDE
(0014,0030)	Material Thickness	MaterialThickness	DS	1-n	f	DICONDE
(0014,0032)	Material Pipe Diameter	MaterialPipeDiameter	DS	1-n	f	DICONDE
(0014,0034)	Material Isolation Diameter	MaterialIsolationDiameter	DS	1-n	f	DICONDE
(0014,0042)	Material Grade	MaterialGrade	ST	1	f	DICONDE
(0014,0044)	Material Properties Description	MaterialPropertiesDescription	ST	1	f	DICONDE
(0014,0045)	Material Properties File Format (Retired)	MaterialPropertiesFileFormatRetired	ST	1	t	
(0014,0046)	Material Notes	MaterialNotes	LT	1	f	DICONDE
(0014,0050)	Component Shape	ComponentShape	CS	1	f	DICONDE
(0014,0052)	Curvature Type	CurvatureType	CS	1	f	DICONDE
(0014,0054)	Outer Diameter	OuterDiameter	DS	1	f	DICONDE
(0014,0056)	Inner Diameter	InnerDiameter	DS	1	f	DICONDE
(0014,0100)	Component Welder IDs	ComponentWelderIDs	LO	1-n	f	DICONDE
(0014,0101)	Secondary Approval Status	SecondaryApprovalStatus	CS	1	f	DICONDE
(0014,0102)	Secondary Review Date	SecondaryReviewDate	DA	1	f	DICONDE
(0014,0103)	Secondary Review Time	SecondaryReviewTime	TM	1	f	DICONDE
(0014,0104)	Secondary Reviewer Name	SecondaryReviewerName	PN	1	f	DICONDE
(0014,0105)	Repair ID	RepairID	ST	1	f	DICONDE
(0014,0106)	Multiple Component Approval Sequence	MultipleComponentApprovalSequence	SQ	1	f	DICONDE
(0014,0107)	Other Approval Status	OtherApprovalStatus	CS	1-n	f	DICONDE
(0014,0108)	Other Secondary Approval Status	OtherSecondaryApprovalStatus	CS	1-n	f	DICONDE
(0014,1010)	Actual Environmental Conditions	ActualEnvironmentalConditions	ST	1	f	DICONDE
(0014,1020)	Expiry Date	ExpiryDate	DA	1	f	DICONDE
(0014,1040)	Environmental Conditions	EnvironmentalConditions	ST	1	f	DICONDE
(0014,2002)	Evaluator Sequence	EvaluatorSequence	SQ	1	f	DICONDE
(0014,2004)	Evaluator Number	EvaluatorNumber	IS	1	f	DICONDE
(0014,2006)	Evaluator Name	EvaluatorName	PN	1	f	DICONDE
(0014,2008)	Evaluation Attempt	EvaluationAttempt	IS	1	f	DICONDE
(0014,2012)	Indication Sequence	IndicationSequence	SQ	1	f	DICONDE
(0014,2014)	Indication Number	IndicationNumber	IS	1	f	DICONDE
(0014,2016)	Indication Label	IndicationLabel	SH	1	f	DICONDE
(0014,2018)	Indication Description	IndicationDescription	ST	1	f	DICONDE
(0014,201a)	Indication Type	IndicationType	CS	1-n	f	DICONDE
(0014,201c)	Indication Disposition	IndicationDisposition	CS	1	f	DICONDE
(0014,201e)	Indication ROI Sequence	IndicationROISequence	SQ	1	f	DICONDE
(0014,2030)	Indication Physical Property Sequence	IndicationPhysicalPropertySequence	SQ	1	f	DICONDE
(0014,2032)	Property Label	PropertyLabel	SH	1	f	DICONDE
(0014,2202)	Coordinate System Number of Axes	CoordinateSystemNumberOfAxes	IS	1	f	DICONDE
(0014,2204)	Coordinate System Axes Sequence	CoordinateSystemAxesSequence	SQ	1	f	DICONDE
(0014,2206)	Coordinate System Axis Description	CoordinateSystemAxisDescription	ST	1	f	DICONDE
(0014,2208)	Coordinate System Data Set Mapping	CoordinateSystemDataSetMapping	CS	1	f	DICONDE
(0014,220a)	Coordinate System Axis Number	CoordinateSystemAxisNumber	IS	1	f	DICONDE
(0014,220c)	Coordinate System Axis Type	CoordinateSystemAxisType	CS	1	f	DICONDE
(0014,220e)	Coordinate System Axis Units	CoordinateSystemAxisUnits	CS	1	f	DICONDE
(0014,2210)	Coordinate System Axis Values	CoordinateSystemAxisValues	OB	1	f	DICONDE
(0014,2220)	Coordinate System Transform Sequence	CoordinateSystemTransformSequence	SQ	1	f	DICONDE
(0014,2222)	Transform Description	TransformDescription	ST	1	f	DICONDE
(0014,2224)	Transform Number of Axes	TransformNumberOfAxes	IS	1	f	DICONDE
(0014,2226)	Transform Order of Axes	TransformOrderOfAxes	IS	1-n	f	DICONDE
(0014,2228)	Transformed Axis Units	TransformedAxisUnits	CS	1	f	DICONDE
(0014,222a)	Coordinate System Transform Rotation and Scale Matrix	CoordinateSystemTransformRotationAndScaleMatrix	DS	1-n	f	DICONDE
(0014,222c)	Coordinate System Transform Translation Matrix	CoordinateSystemTransformTranslationMatrix	DS	1-n	f	DICONDE
(0014,3011)	Internal Detector Frame Time	InternalDetectorFrameTime	DS	1	f	DICONDE
(0014,3012)	Number of Frames Integrated	NumberOfFramesIntegrated	DS	1	f	DICONDE
(0014,3020)	Detector Temperature Sequence	DetectorTemperatureSequence	SQ	1	f	DICONDE
(0014,3022)	Sensor Name	SensorName	ST	1	f	DICONDE
(0014,3024)	Horizontal Offset of Sensor	HorizontalOffsetOfSensor	DS	1	f	DICONDE
(0014,3026)	Vertical Offset of Sensor	VerticalOffsetOfSensor	DS	1	f	DICONDE
(0014,3028)	Sensor Temperature	SensorTemperature	DS	1	f	DICONDE
(0014,3040)	Dark Current Sequence	DarkCurrentSequence	SQ	1	f	DICONDE
(0014,3050)	Dark Current Counts	DarkCurrentCounts	OB or OW	1	f	DICONDE
(0014,3060)	Gain Correction Reference Sequence	GainCorrectionReferenceSequence	SQ	1	f	DICONDE
(0014,3070)	Air Counts	AirCounts	OB or OW	1	f	DICONDE
(0014,3071)	KV Used in Gain Calibration	KVUsedInGainCalibration	DS	1	f	DICONDE
(0014,3072)	MA Used in Gain Calibration	MAUsedInGainCalibration	DS	1	f	DICONDE
(0014,3073)	Number of Frames Used for Integration	NumberOfFramesUsedForIntegration	DS	1	f	DICONDE
(0014,3074)	Filter Material Used in Gain Calibration	FilterMaterialUsedInGainCalibration	LO	1	f	DICONDE
(0014,3075)	Filter Thickness Used in Gain Calibration	FilterThicknessUsedInGainCalibration	DS	1	f	DICONDE
(0014,3076)	Date of Gain Calibration	DateOfGainCalibration	DA	1	f	DICONDE
(0014,3077)	Time of Gain Calibration	TimeOfGainCalibration	TM	1	f	DICONDE
(0014,3080)	Bad Pixel Image	BadPixelImage	OB	1	f	DICONDE
(0014,3099)	Calibration Notes	CalibrationNotes	LT	1	f	DICONDE
(0014,4002)	Pulser Equipment Sequence	PulserEquipmentSequence	SQ	1	f	DICONDE
(0014,4004)	Pulser Type	PulserType	CS	1	f	DICONDE
(0014,4006)	Pulser Notes	PulserNotes	LT	1	f	DICONDE
(0014,4008)	Receiver Equipment Sequence	ReceiverEquipmentSequence	SQ	1	f	DICONDE
(0014,400a)	Amplifier Type	AmplifierType	CS	1	f	DICONDE
(0014,400c)	Receiver Notes	ReceiverNotes	LT	1	f	DICONDE
(0014,400e)	Pre-Amplifier Equipment Sequence	PreAmplifierEquipmentSequence	SQ	1	f	DICONDE
(0014,400f)	Pre-Amplifier Notes	PreAmplifierNotes	LT	1	f	DICONDE
(0014,4010)	Transmit Transducer Sequence	TransmitTransducerSequence	SQ	1	f	DICONDE
(0014,4011)	Receive Transducer Sequence	ReceiveTransducerSequence	SQ	1	f	DICONDE
(0014,4012)	Number of Elements	NumberOfElements	US	1	f	DICONDE
(0014,4013)	Element Shape	ElementShape	CS	1	f	DICONDE
(0014,4014)	Element Dimension A	ElementDimensionA	DS	1	f	DICONDE
(0014,4015)	Element Dimension B	ElementDimensionB	DS	1	f	DICONDE
(0014,4016)	Element Pitch A	ElementPitchA	DS	1	f	DICONDE
(0014,4017)	Measured Beam Dimension A	MeasuredBeamDimensionA	DS	1	f	DICONDE
(0014,4018)	Measured Beam Dimension B	MeasuredBeamDimensionB	DS	1	f	DICONDE
(0014,4019)	Location of Measured Beam Diameter	LocationOfMeasuredBeamDiameter	DS	1	f	DICONDE
(0014,401a)	Nominal Frequency	NominalFrequency	DS	1	f	DICONDE
(0014,401b)	Measured Center Frequency	MeasuredCenterFrequency	DS	1	f	DICONDE
(0014,401c)	Measured Bandwidth	MeasuredBandwidth	DS	1	f	DICONDE
(0014,401d)	Element Pitch B	ElementPitchB	DS	1	f	DICONDE
(0014,4020)	Pulser Settings Sequence	PulserSettingsSequence	SQ	1	f	DICONDE
(0014,4022)	Pulse Width	PulseWidth	DS	1	f	DICONDE
(0014,4024)	Excitation Frequency	ExcitationFrequency	DS	1	f	DICONDE
(0014,4026)	Modulation Type	ModulationType	CS	1	f	DICONDE
(0014,4028)	Damping	Damping	DS	1	f	DICONDE
(0014,4030)	Receiver Settings Sequence	ReceiverSettingsSequence	SQ	1	f	DICONDE
(0014,4031)	Acquired Soundpath Length	AcquiredSoundpathLength	DS	1	f	DICONDE
(0014,4032)	Acquisition Compression Type	AcquisitionCompressionType	CS	1	f	DICONDE
(0014,4033)	Acquisition Sample Size	AcquisitionSampleSize	IS	1	f	DICONDE
(0014,4034)	Rectifier Smoothing	RectifierSmoothing	DS	1	f	DICONDE
(0014,4035)	DAC Sequence	DACSequence	SQ	1	f	DICONDE
(0014,4036)	DAC Type	DACType	CS	1	f	DICONDE
(0014,4038)	DAC Gain Points	DACGainPoints	DS	1-n	f	DICONDE
(0014,403a)	DAC Time Points	DACTimePoints	DS	1-n	f	DICONDE
(0014,403c)	DAC Amplitude	DACAmplitude	DS	1-n	f	DICONDE
(0014,4040)	Pre-Amplifier Settings Sequence	PreAmplifierSettingsSequence	SQ	1	f	DICONDE
(0018,0020)	Scanning Sequence	ScanningSequence	CS	1-n	f	
(0014,4050)	Transmit Transducer Settings Sequence	TransmitTransducerSettingsSequence	SQ	1	f	DICONDE
(0014,4051)	Receive Transducer Settings Sequence	ReceiveTransducerSettingsSequence	SQ	1	f	DICONDE
(0014,4052)	Incident Angle	IncidentAngle	DS	1	f	DICONDE
(0014,4054)	Coupling Technique	CouplingTechnique	ST	1	f	DICONDE
(0014,4056)	Coupling Medium	CouplingMedium	ST	1	f	DICONDE
(0014,4057)	Coupling Velocity	CouplingVelocity	DS	1	f	DICONDE
(0014,4058)	Probe Center Location X	ProbeCenterLocationX	DS	1	f	DICONDE
(0014,4059)	Probe Center Location Z	ProbeCenterLocationZ	DS	1	f	DICONDE
(0014,405a)	Sound Path Length	SoundPathLength	DS	1	f	DICONDE
(0014,405c)	Delay Law Identifier	DelayLawIdentifier	ST	1	f	DICONDE
(0014,4060)	Gate Settings Sequence	GateSettingsSequence	SQ	1	f	DICONDE
(0014,4062)	Gate Threshold	GateThreshold	DS	1	f	DICONDE
(0014,4064)	Velocity of Sound	VelocityOfSound	DS	1	f	DICONDE
(0014,4070)	Calibration Settings Sequence	CalibrationSettingsSequence	SQ	1	f	DICONDE
(0014,4072)	Calibration Procedure	CalibrationProcedure	ST	1	f	DICONDE
(0014,4074)	Procedure Version	ProcedureVersion	SH	1	f	DICONDE
(0014,4076)	Procedure Creation Date	ProcedureCreationDate	DA	1	f	DICONDE
(0014,4078)	Procedure Expiration Date	ProcedureExpirationDate	DA	1	f	DICONDE
(0014,407a)	Procedure Last Modified Date	ProcedureLastModifiedDate	DA	1	f	DICONDE
(0014,407c)	Calibration Time	CalibrationTime	TM	1-n	f	DICONDE
(0014,407e)	Calibration Date	CalibrationDate	DA	1-n	f	DICONDE
(0014,4080)	Probe Drive Equipment Sequence	ProbeDriveEquipmentSequence	SQ	1	f	DICONDE
(0014,4081)	Drive Type	DriveType	CS	1	f	DICONDE
(0014,4082)	Probe Drive Notes	ProbeDriveNotes	LT	1	f	DICONDE
(0014,4083)	Drive Probe Sequence	DriveProbeSequence	SQ	1	f	DICONDE
(0014,4084)	Probe Inductance	ProbeInductance	DS	1	f	DICONDE
(0014,4085)	Probe Resistance	ProbeResistance	DS	1	f	DICONDE
(0014,4086)	Receive Probe Sequence	ReceiveProbeSequence	SQ	1	f	DICONDE
(0014,4087)	Probe Drive Settings Sequence	ProbeDriveSettingsSequence	SQ	1	f	DICONDE
(0014,4088)	Bridge Resistors	BridgeResistors	DS	1	f	DICONDE
(0014,4089)	Probe Orientation Angle	ProbeOrientationAngle	DS	1	f	DICONDE
(0014,408b)	User Selected Gain Y	UserSelectedGainY	DS	1	f	DICONDE
(0014,408c)	User Selected Phase	UserSelectedPhase	DS	1	f	DICONDE
(0014,408d)	User Selected Offset X	UserSelectedOffsetX	DS	1	f	DICONDE
(0014,408e)	User Selected Offset Y	UserSelectedOffsetY	DS	1	f	DICONDE
(0014,4091)	Channel Settings Sequence	ChannelSettingsSequence	SQ	1	f	DICONDE
(0014,4092)	Channel Threshold	ChannelThreshold	DS	1	f	DICONDE
(0014,409a)	Scanner Settings Sequence	ScannerSettingsSequence	SQ	1	f	DICONDE
(0014,409b)	Scan Procedure	ScanProcedure	ST	1	f	DICONDE
(0014,409c)	Translation Rate X	TranslationRateX	DS	1	f	DICONDE
(0014,409d)	Translation Rate Y	TranslationRateY	DS	1	f	DICONDE
(0014,409f)	Channel Overlap	ChannelOverlap	DS	1	f	DICONDE
(0014,40a0)	Image Quality Indicator Type	ImageQualityIndicatorType	LO	1	f	DICONDE
(0014,40a1)	Image Quality Indicator Material	ImageQualityIndicatorMaterial	LO	1	f	DICONDE
(0014,40a2)	Image Quality Indicator Size	ImageQualityIndicatorSize	LO	1	f	DICONDE
(0014,5002)	LINAC Energy	LINACEnergy	IS	1	f	DICONDE
(0014,5004)	LINAC Output	LINACOutput	IS	1	f	DICONDE
(0014,5100)	Active Aperture	ActiveAperture	US	1	f	DICONDE
(0014,5101)	Total Aperture	TotalAperture	DS	1	f	DICONDE
(0014,5102)	Aperture Elevation	ApertureElevation	DS	1	f	DICONDE
(0014,5103)	Main Lobe Angle	MainLobeAngle	DS	1	f	DICONDE
(0014,5104)	Main Roof Angle	MainRoofAngle	DS	1	f	DICONDE
(0014,5105)	Connector Type	ConnectorType	CS	1	f	DICONDE
(0014,5106)	Wedge Model Number	WedgeModelNumber	SH	1	f	DICONDE
(0014,5107)	Wedge Angle Float	WedgeAngleFloat	DS	1	f	DICONDE
(0014,5108)	Wedge Roof Angle	WedgeRoofAngle	DS	1	f	DICONDE
(0014,5109)	Wedge Element 1 Position	WedgeElement1Position	CS	1	f	DICONDE
(0014,510a)	Wedge Material Velocity	WedgeMaterialVelocity	DS	1	f	DICONDE
(0014,510b)	Wedge Material	WedgeMaterial	SH	1	f	DICONDE
(0014,510c)	Wedge Offset Z	WedgeOffsetZ	DS	1	f	DICONDE
(0014,510d)	Wedge Origin Offset X	WedgeOriginOffsetX	DS	1	f	DICONDE
(0014,510e)	Wedge Time Delay	WedgeTimeDelay	DS	1	f	DICONDE
(0014,510f)	Wedge Name	WedgeName	SH	1	f	DICONDE
(0014,5110)	Wedge Manufacturer Name	WedgeManufacturerName	SH	1	f	DICONDE
(0014,5111)	Wedge Description	WedgeDescription	LO	1	f	DICONDE
(0014,5112)	Nominal Beam Angle	NominalBeamAngle	DS	1	f	DICONDE
(0014,5113)	Wedge Offset X	WedgeOffsetX	DS	1	f	DICONDE
(0014,5114)	Wedge Offset Y	WedgeOffsetY	DS	1	f	DICONDE
(0014,5115)	Wedge Total Length	WedgeTotalLength	DS	1	f	DICONDE
(0014,5116)	Wedge In Contact Length	WedgeInContactLength	DS	1	f	DICONDE
(0014,5117)	Wedge Front Gap	WedgeFrontGap	DS	1	f	DICONDE
(0014,5118)	Wedge Total Height	WedgeTotalHeight	DS	1	f	DICONDE
(0014,5119)	Wedge Front Height	WedgeFrontHeight	DS	1	f	DICONDE
(0014,511a)	Wedge Rear Height	WedgeRearHeight	DS	1	f	DICONDE
(0014,511b)	Wedge Total Width	WedgeTotalWidth	DS	1	f	DICONDE
(0014,511c)	Wedge In Contact Width	WedgeInContactWidth	DS	1	f	DICONDE
(0014,511d)	Wedge Chamfer Height	WedgeChamferHeight	DS	1	f	DICONDE
(0014,511e)	Wedge Curve	WedgeCurve	CS	1	f	DICONDE
(0014,511f)	Radius Along the Wedge	RadiusAlongWedge	DS	1	f	DICONDE
(0018,0010)	Contrast/Bolus Agent	ContrastBolusAgent	LO	1	f	
(0018,0012)	Contrast/Bolus Agent Sequence	ContrastBolusAgentSequence	SQ	1	f	
(0018,0013)	Contrast/Bolus T1 Relaxivity	ContrastBolusT1Relaxivity	FL	1	f	
(0018,0014)	Contrast/Bolus Administration Route Sequence	ContrastBolusAdministrationRouteSequence	SQ	1	f	
(0018,0015)	Body Part Examined	BodyPartExamined	CS	1	f	
(0018,0021)	Sequence Variant	SequenceVariant	CS	1-n	f	
(0018,0022)	Scan Options	ScanOptions	CS	1-n	f	
(0018,0023)	MR Acquisition Type	MRAcquisitionType	CS	1	f	
(0018,0024)	Sequence Name	SequenceName	SH	1	f	
(0018,0025)	Angio Flag	AngioFlag	CS	1	f	
(0018,0026)	Intervention Drug Information Sequence	InterventionDrugInformationSequence	SQ	1	f	
(0018,0027)	Intervention Drug Stop Time	InterventionDrugStopTime	TM	1	f	
(0018,0028)	Intervention Drug Dose	InterventionDrugDose	DS	1	f	
(0018,0029)	Intervention Drug Code Sequence	InterventionDrugCodeSequence	SQ	1	f	
(0018,002a)	Additional Drug Sequence	AdditionalDrugSequence	SQ	1	f	
(0018,0030)	Radionuclide	Radionuclide	LO	1-n	t	
(0018,0031)	Radiopharmaceutical	Radiopharmaceutical	LO	1	f	
(0018,0032)	Energy Window Centerline	EnergyWindowCenterline	DS	1	t	
(0018,0033)	Energy Window Total Width	EnergyWindowTotalWidth	DS	1-n	t	
(0018,0034)	Intervention Drug Name	InterventionDrugName	LO	1	f	
(0018,0035)	Intervention Drug Start Time	InterventionDrugStartTime	TM	1	f	
(0018,0036)	Intervention Sequence	InterventionSequence	SQ	1	f	
(0018,0037)	Therapy Type	TherapyType	CS	1	t	
(0018,0038)	Intervention Status	InterventionStatus	CS	1	f	
(0018,0039)	Therapy Description	TherapyDescription	CS	1	t	
(0018,003a)	Intervention Description	InterventionDescription	ST	1	f	
(0018,0040)	Cine Rate	CineRate	IS	1	f	
(0018,0042)	Initial Cine Run State	InitialCineRunState	CS	1	f	
(0018,0050)	Slice Thickness	SliceThickness	DS	1	f	
(0018,0060)	KVP	KVP	DS	1	f	
(0018,0061)			DS	1	t	
(0018,0070)	Counts Accumulated	CountsAccumulated	IS	1	f	
(0018,0071)	Acquisition Termination Condition	AcquisitionTerminationCondition	CS	1	f	
(0018,0072)	Effective Duration	EffectiveDuration	DS	1	f	
(0018,0073)	Acquisition Start Condition	AcquisitionStartCondition	CS	1	f	
(0018,0074)	Acquisition Start Condition Data	AcquisitionStartConditionData	IS	1	f	
(0018,0075)	Acquisition Termination Condition Data	AcquisitionTerminationConditionData	IS	1	f	
(0018,0080)	Repetition Time	RepetitionTime	DS	1	f	
(0018,0081)	Echo Time	EchoTime	DS	1	f	
(0018,0082)	Inversion Time	InversionTime	DS	1	f	
(0018,0083)	Number of Averages	NumberOfAverages	DS	1	f	
(0018,0084)	Imaging Frequency	ImagingFrequency	DS	1	f	
(0018,0085)	Imaged Nucleus	ImagedNucleus	SH	1	f	
(0018,0086)	Echo Number(s)	EchoNumbers	IS	1-n	f	
(0018,0087)	Magnetic Field Strength	MagneticFieldStrength	DS	1	f	
(0018,0088)	Spacing Between Slices	SpacingBetweenSlices	DS	1	f	
(0018,0089)	Number of Phase Encoding Steps	NumberOfPhaseEncodingSteps	IS	1	f	
(0018,0090)	Data Collection Diameter	DataCollectionDiameter	DS	1	f	
(0018,0091)	Echo Train Length	EchoTrainLength	IS	1	f	
(0018,0093)	Percent Sampling	PercentSampling	DS	1	f	
(0018,0094)	Percent Phase Field of View	PercentPhaseFieldOfView	DS	1	f	
(0018,0095)	Pixel Bandwidth	PixelBandwidth	DS	1	f	
(0018,1000)	Device Serial Number	DeviceSerialNumber	LO	1	f	
(0018,1002)	Device UID	DeviceUID	UI	1	f	
(0018,1003)	Device ID	DeviceID	LO	1	f	
(0018,1004)	Plate ID	PlateID	LO	1	f	
(0018,1005)	Generator ID	GeneratorID	LO	1	f	
(0018,1006)	Grid ID	GridID	LO	1	f	
(0018,1007)	Cassette ID	CassetteID	LO	1	f	
(0018,1008)	Gantry ID	GantryID	LO	1	f	
(0018,1010)	Secondary Capture Device ID	SecondaryCaptureDeviceID	LO	1	f	
(0018,1011)	Hardcopy Creation Device ID	HardcopyCreationDeviceID	LO	1	t	
(0018,1012)	Date of Secondary Capture	DateOfSecondaryCapture	DA	1	f	
(0018,1014)	Time of Secondary Capture	TimeOfSecondaryCapture	TM	1	f	
(0018,1016)	Secondary Capture Device Manufacturer	SecondaryCaptureDeviceManufacturer	LO	1	f	
(0018,1017)	Hardcopy Device Manufacturer	HardcopyDeviceManufacturer	LO	1	t	
(0018,1018)	Secondary Capture Device Manufacturer's Model Name	SecondaryCaptureDeviceManufacturerModelName	LO	1	f	
(0018,1019)	Secondary Capture Device Software Versions	SecondaryCaptureDeviceSoftwareVersions	LO	1-n	f	
(0018,101a)	Hardcopy Device Software Version	HardcopyDeviceSoftwareVersion	LO	1-n	t	
(0018,101b)	Hardcopy Device Manufacturer's Model Name	HardcopyDeviceManufacturerModelName	LO	1	t	
(0018,1020)	Software Version(s)	SoftwareVersions	LO	1-n	f	
(0018,1022)	Video Image Format Acquired	VideoImageFormatAcquired	SH	1	f	
(0018,1023)	Digital Image Format Acquired	DigitalImageFormatAcquired	LO	1	f	
(0018,1030)	Protocol Name	ProtocolName	LO	1	f	
(0018,1040)	Contrast/Bolus Route	ContrastBolusRoute	LO	1	f	
(0018,1041)	Contrast/Bolus Volume	ContrastBolusVolume	DS	1	f	
(0018,1042)	Contrast/Bolus Start Time	ContrastBolusStartTime	TM	1	f	
(0018,1043)	Contrast/Bolus Stop Time	ContrastBolusStopTime	TM	1	f	
(0018,1044)	Contrast/Bolus Total Dose	ContrastBolusTotalDose	DS	1	f	
(0018,1045)	Syringe Counts	SyringeCounts	IS	1	f	
(0018,1046)	Contrast Flow Rate	ContrastFlowRate	DS	1-n	f	
(0018,1047)	Contrast Flow Duration	ContrastFlowDuration	DS	1-n	f	
(0018,1048)	Contrast/Bolus Ingredient	ContrastBolusIngredient	CS	1	f	
(0018,1049)	Contrast/Bolus Ingredient Concentration	ContrastBolusIngredientConcentration	DS	1	f	
(0018,1050)	Spatial Resolution	SpatialResolution	DS	1	f	
(0018,1060)	Trigger Time	TriggerTime	DS	1	f	
(0018,1061)	Trigger Source or Type	TriggerSourceOrType	LO	1	f	
(0018,1062)	Nominal Interval	NominalInterval	IS	1	f	
(0018,1063)	Frame Time	FrameTime	DS	1	f	
(0018,1064)	Cardiac Framing Type	CardiacFramingType	LO	1	f	
(0018,1065)	Frame Time Vector	FrameTimeVector	DS	1-n	f	
(0018,1066)	Frame Delay	FrameDelay	DS	1	f	
(0018,1067)	Image Trigger Delay	ImageTriggerDelay	DS	1	f	
(3004,0004)	Dose Type	DoseType	CS	1	f	
(0018,1068)	Multiplex Group Time Offset	MultiplexGroupTimeOffset	DS	1	f	
(0018,1069)	Trigger Time Offset	TriggerTimeOffset	DS	1	f	
(0018,106a)	Synchronization Trigger	SynchronizationTrigger	CS	1	f	
(0018,106c)	Synchronization Channel	SynchronizationChannel	US	2	f	
(0018,106e)	Trigger Sample Position	TriggerSamplePosition	UL	1	f	
(0018,1070)	Radiopharmaceutical Route	RadiopharmaceuticalRoute	LO	1	f	
(0018,1071)	Radiopharmaceutical Volume	RadiopharmaceuticalVolume	DS	1	f	
(0018,1072)	Radiopharmaceutical Start Time	RadiopharmaceuticalStartTime	TM	1	f	
(0018,1073)	Radiopharmaceutical Stop Time	RadiopharmaceuticalStopTime	TM	1	f	
(0018,1074)	Radionuclide Total Dose	RadionuclideTotalDose	DS	1	f	
(0018,1075)	Radionuclide Half Life	RadionuclideHalfLife	DS	1	f	
(0018,1076)	Radionuclide Positron Fraction	RadionuclidePositronFraction	DS	1	f	
(0018,1077)	Radiopharmaceutical Specific Activity	RadiopharmaceuticalSpecificActivity	DS	1	f	
(0018,1078)	Radiopharmaceutical Start DateTime	RadiopharmaceuticalStartDateTime	DT	1	f	
(0018,1079)	Radiopharmaceutical Stop DateTime	RadiopharmaceuticalStopDateTime	DT	1	f	
(0018,1080)	Beat Rejection Flag	BeatRejectionFlag	CS	1	f	
(0018,1081)	Low R-R Value	LowRRValue	IS	1	f	
(0018,1082)	High R-R Value	HighRRValue	IS	1	f	
(0018,1083)	Intervals Acquired	IntervalsAcquired	IS	1	f	
(0018,1084)	Intervals Rejected	IntervalsRejected	IS	1	f	
(0018,1085)	PVC Rejection	PVCRejection	LO	1	f	
(0018,1086)	Skip Beats	SkipBeats	IS	1	f	
(0018,1088)	Heart Rate	HeartRate	IS	1	f	
(0018,1090)	Cardiac Number of Images	CardiacNumberOfImages	IS	1	f	
(0018,1094)	Trigger Window	TriggerWindow	IS	1	f	
(0018,1100)	Reconstruction Diameter	ReconstructionDiameter	DS	1	f	
(0018,1110)	Distance Source to Detector	DistanceSourceToDetector	DS	1	f	
(0018,1111)	Distance Source to Patient	DistanceSourceToPatient	DS	1	f	
(0018,1114)	Estimated Radiographic Magnification Factor	EstimatedRadiographicMagnificationFactor	DS	1	f	
(0018,1120)	Gantry/Detector Tilt	GantryDetectorTilt	DS	1	f	
(0018,1121)	Gantry/Detector Slew	GantryDetectorSlew	DS	1	f	
(0018,1130)	Table Height	TableHeight	DS	1	f	
(0018,1131)	Table Traverse	TableTraverse	DS	1	f	
(0018,1134)	Table Motion	TableMotion	CS	1	f	
(0018,1135)	Table Vertical Increment	TableVerticalIncrement	DS	1-n	f	
(0018,1136)	Table Lateral Increment	TableLateralIncrement	DS	1-n	f	
(0018,1137)	Table Longitudinal Increment	TableLongitudinalIncrement	DS	1-n	f	
(0018,1138)	Table Angle	TableAngle	DS	1	f	
(0018,113a)	Table Type	TableType	CS	1	f	
(0018,1140)	Rotation Direction	RotationDirection	CS	1	f	
(0018,1141)	Angular Position	AngularPosition	DS	1	t	
(0018,1142)	Radial Position	RadialPosition	DS	1-n	f	
(0018,1143)	Scan Arc	ScanArc	DS	1	f	
(0018,1144)	Angular Step	AngularStep	DS	1	f	
(0018,1145)	Center of Rotation Offset	CenterOfRotationOffset	DS	1	f	
(0018,1146)	Rotation Offset	RotationOffset	DS	1-n	t	
(0018,1147)	Field of View Shape	FieldOfViewShape	CS	1	f	
(0018,1149)	Field of View Dimension(s)	FieldOfViewDimensions	IS	1-2	f	
(0018,1150)	Exposure Time	ExposureTime	IS	1	f	
(0018,1151)	X-Ray Tube Current	XRayTubeCurrent	IS	1	f	
(0018,1152)	Exposure	Exposure	IS	1	f	
(0018,1153)	Exposure in ÂµAs	ExposureInuAs	IS	1	f	
(0018,1154)	Average Pulse Width	AveragePulseWidth	DS	1	f	
(0018,1155)	Radiation Setting	RadiationSetting	CS	1	f	
(0018,1156)	Rectification Type	RectificationType	CS	1	f	
(0018,115a)	Radiation Mode	RadiationMode	CS	1	f	
(0018,115e)	Image and Fluoroscopy Area Dose Product	ImageAndFluoroscopyAreaDoseProduct	DS	1	f	
(0018,1160)	Filter Type	FilterType	SH	1	f	
(0018,1161)	Type of Filters	TypeOfFilters	LO	1-n	f	
(0018,1162)	Intensifier Size	IntensifierSize	DS	1	f	
(0018,1164)	Imager Pixel Spacing	ImagerPixelSpacing	DS	2	f	
(0018,1166)	Grid	Grid	CS	1-n	f	
(0018,1170)	Generator Power	GeneratorPower	IS	1	f	
(0018,1180)	Collimator/grid Name	CollimatorGridName	SH	1	f	
(0018,1181)	Collimator Type	CollimatorType	CS	1	f	
(0018,1182)	Focal Distance	FocalDistance	IS	1-2	f	
(0018,1183)	X Focus Center	XFocusCenter	DS	1-2	f	
(0018,1184)	Y Focus Center	YFocusCenter	DS	1-2	f	
(0018,1190)	Focal Spot(s)	FocalSpots	DS	1-n	f	
(0018,1191)	Anode Target Material	AnodeTargetMaterial	CS	1	f	
(0018,11a0)	Body Part Thickness	BodyPartThickness	DS	1	f	
(0018,11a2)	Compression Force	CompressionForce	DS	1	f	
(0018,11a4)	Paddle Description	PaddleDescription	LO	1	f	
(0018,1200)	Date of Last Calibration	DateOfLastCalibration	DA	1-n	f	
(0018,1201)	Time of Last Calibration	TimeOfLastCalibration	TM	1-n	f	
(0018,1202)	DateTime of Last Calibration	DateTimeOfLastCalibration	DT	1	f	
(0018,1210)	Convolution Kernel	ConvolutionKernel	SH	1-n	f	
(0018,1240)	Upper/Lower Pixel Values	UpperLowerPixelValues	IS	1-n	t	
(0018,1242)	Actual Frame Duration	ActualFrameDuration	IS	1	f	
(0018,1243)	Count Rate	CountRate	IS	1	f	
(0018,1244)	Preferred Playback Sequencing	PreferredPlaybackSequencing	US	1	f	
(0018,1250)	Receive Coil Name	ReceiveCoilName	SH	1	f	
(0018,1251)	Transmit Coil Name	TransmitCoilName	SH	1	f	
(0018,1260)	Plate Type	PlateType	SH	1	f	
(0018,1261)	Phosphor Type	PhosphorType	LO	1	f	
(0018,1271)	Water Equivalent Diameter	WaterEquivalentDiameter	FD	1	f	
(0018,1272)	Water Equivalent Diameter Calculation Method Code Sequence	WaterEquivalentDiameterCalculationMethodCodeSequence	SQ	1	f	
(0018,1300)	Scan Velocity	ScanVelocity	DS	1	f	
(0018,1301)	Whole Body Technique	WholeBodyTechnique	CS	1-n	f	
(0018,1302)	Scan Length	ScanLength	IS	1	f	
(0018,1310)	Acquisition Matrix	AcquisitionMatrix	US	4	f	
(0018,1312)	In-plane Phase Encoding Direction	InPlanePhaseEncodingDirection	CS	1	f	
(0018,1314)	Flip Angle	FlipAngle	DS	1	f	
(0018,1315)	Variable Flip Angle Flag	VariableFlipAngleFlag	CS	1	f	
(0018,1316)	SAR	SAR	DS	1	f	
(0018,1318)	dB/dt	dBdt	DS	1	f	
(0018,1320)	B1rms	B1rms	FL	1	f	
(0018,1400)	Acquisition Device Processing Description	AcquisitionDeviceProcessingDescription	LO	1	f	
(0018,1401)	Acquisition Device Processing Code	AcquisitionDeviceProcessingCode	LO	1	f	
(0018,1402)	Cassette Orientation	CassetteOrientation	CS	1	f	
(0018,1403)	Cassette Size	CassetteSize	CS	1	f	
(0018,1404)	Exposures on Plate	ExposuresOnPlate	US	1	f	
(0018,1405)	Relative X-Ray Exposure	RelativeXRayExposure	IS	1	f	
(0018,1411)	Exposure Index	ExposureIndex	DS	1	f	
(0018,1412)	Target Exposure Index	TargetExposureIndex	DS	1	f	
(0018,1413)	Deviation Index	DeviationIndex	DS	1	f	
(0018,1450)	Column Angulation	ColumnAngulation	DS	1	f	
(0018,1460)	Tomo Layer Height	TomoLayerHeight	DS	1	f	
(0018,1470)	Tomo Angle	TomoAngle	DS	1	f	
(0018,1480)	Tomo Time	TomoTime	DS	1	f	
(0018,1490)	Tomo Type	TomoType	CS	1	f	
(0018,1491)	Tomo Class	TomoClass	CS	1	f	
(0018,1495)	Number of Tomosynthesis Source Images	NumberOfTomosynthesisSourceImages	IS	1	f	
(0018,1500)	Positioner Motion	PositionerMotion	CS	1	f	
(0018,1508)	Positioner Type	PositionerType	CS	1	f	
(0018,1510)	Positioner Primary Angle	PositionerPrimaryAngle	DS	1	f	
(0018,1511)	Positioner Secondary Angle	PositionerSecondaryAngle	DS	1	f	
(0018,1520)	Positioner Primary Angle Increment	PositionerPrimaryAngleIncrement	DS	1-n	f	
(0018,1521)	Positioner Secondary Angle Increment	PositionerSecondaryAngleIncrement	DS	1-n	f	
(0018,1530)	Detector Primary Angle	DetectorPrimaryAngle	DS	1	f	
(0018,1531)	Detector Secondary Angle	DetectorSecondaryAngle	DS	1	f	
(0018,1600)	Shutter Shape	ShutterShape	CS	1-3	f	
(0018,1602)	Shutter Left Vertical Edge	ShutterLeftVerticalEdge	IS	1	f	
(0018,1604)	Shutter Right Vertical Edge	ShutterRightVerticalEdge	IS	1	f	
(0018,1606)	Shutter Upper Horizontal Edge	ShutterUpperHorizontalEdge	IS	1	f	
(0018,1608)	Shutter Lower Horizontal Edge	ShutterLowerHorizontalEdge	IS	1	f	
(0018,1610)	Center of Circular Shutter	CenterOfCircularShutter	IS	2	f	
(0018,1612)	Radius of Circular Shutter	RadiusOfCircularShutter	IS	1	f	
(0018,1620)	Vertices of the Polygonal Shutter	VerticesOfThePolygonalShutter	IS	2-2n	f	
(0018,1622)	Shutter Presentation Value	ShutterPresentationValue	US	1	f	
(0018,1623)	Shutter Overlay Group	ShutterOverlayGroup	US	1	f	
(0018,1624)	Shutter Presentation Color CIELab Value	ShutterPresentationColorCIELabValue	US	3	f	
(0018,1700)	Collimator Shape	CollimatorShape	CS	1-3	f	
(0018,1702)	Collimator Left Vertical Edge	CollimatorLeftVerticalEdge	IS	1	f	
(0018,1704)	Collimator Right Vertical Edge	CollimatorRightVerticalEdge	IS	1	f	
(0018,1706)	Collimator Upper Horizontal Edge	CollimatorUpperHorizontalEdge	IS	1	f	
(0018,1708)	Collimator Lower Horizontal Edge	CollimatorLowerHorizontalEdge	IS	1	f	
(0018,1710)	Center of Circular Collimator	CenterOfCircularCollimator	IS	2	f	
(0018,1712)	Radius of Circular Collimator	RadiusOfCircularCollimator	IS	1	f	
(0018,1720)	Vertices of the Polygonal Collimator	VerticesOfThePolygonalCollimator	IS	2-2n	f	
(0018,1800)	Acquisition Time Synchronized	AcquisitionTimeSynchronized	CS	1	f	
(0018,1801)	Time Source	TimeSource	SH	1	f	
(0018,1802)	Time Distribution Protocol	TimeDistributionProtocol	CS	1	f	
(0018,1803)	NTP Source Address	NTPSourceAddress	LO	1	f	
(0018,2001)	Page Number Vector	PageNumberVector	IS	1-n	f	
(0018,2002)	Frame Label Vector	FrameLabelVector	SH	1-n	f	
(0018,2003)	Frame Primary Angle Vector	FramePrimaryAngleVector	DS	1-n	f	
(0018,2004)	Frame Secondary Angle Vector	FrameSecondaryAngleVector	DS	1-n	f	
(0018,2005)	Slice Location Vector	SliceLocationVector	DS	1-n	f	
(0018,2006)	Display Window Label Vector	DisplayWindowLabelVector	SH	1-n	f	
(0018,2010)	Nominal Scanned Pixel Spacing	NominalScannedPixelSpacing	DS	2	f	
(0018,2020)	Digitizing Device Transport Direction	DigitizingDeviceTransportDirection	CS	1	f	
(0018,2030)	Rotation of Scanned Film	RotationOfScannedFilm	DS	1	f	
(0018,2041)	Biopsy Target Sequence	BiopsyTargetSequence	SQ	1	f	
(0018,2042)	Target UID	TargetUID	UI	1	f	
(0018,2043)	Localizing Cursor Position	LocalizingCursorPosition	FL	2	f	
(0018,2044)	Calculated Target Position	CalculatedTargetPosition	FL	3	f	
(0018,2045)	Target Label	TargetLabel	SH	1	f	
(0018,2046)	Displayed Z Value	DisplayedZValue	FL	1	f	
(0018,3100)	IVUS Acquisition	IVUSAcquisition	CS	1	f	
(0018,3101)	IVUS Pullback Rate	IVUSPullbackRate	DS	1	f	
(0018,3102)	IVUS Gated Rate	IVUSGatedRate	DS	1	f	
(0018,3103)	IVUS Pullback Start Frame Number	IVUSPullbackStartFrameNumber	IS	1	f	
(0018,3104)	IVUS Pullback Stop Frame Number	IVUSPullbackStopFrameNumber	IS	1	f	
(0018,3105)	Lesion Number	LesionNumber	IS	1-n	f	
(0018,4000)	Acquisition Comments	AcquisitionComments	LT	1	t	
(0018,5000)	Output Power	OutputPower	SH	1-n	f	
(0018,5010)	Transducer Data	TransducerData	LO	1-n	f	
(0018,5012)	Focus Depth	FocusDepth	DS	1	f	
(0018,5020)	Processing Function	ProcessingFunction	LO	1	f	
(0018,5021)	Postprocessing Function	PostprocessingFunction	LO	1	t	
(0018,5022)	Mechanical Index	MechanicalIndex	DS	1	f	
(0018,5024)	Bone Thermal Index	BoneThermalIndex	DS	1	f	
(0018,5026)	Cranial Thermal Index	CranialThermalIndex	DS	1	f	
(0018,5027)	Soft Tissue Thermal Index	SoftTissueThermalIndex	DS	1	f	
(0018,5028)	Soft Tissue-focus Thermal Index	SoftTissueFocusThermalIndex	DS	1	f	
(0018,5029)	Soft Tissue-surface Thermal Index	SoftTissueSurfaceThermalIndex	DS	1	f	
(0018,5030)	Dynamic Range	DynamicRange	DS	1	t	
(0018,5040)	Total Gain	TotalGain	DS	1	t	
(0018,5050)	Depth of Scan Field	DepthOfScanField	IS	1	f	
(0018,5100)	Patient Position	PatientPosition	CS	1	f	
(0018,5101)	View Position	ViewPosition	CS	1	f	
(0018,5104)	Projection Eponymous Name Code Sequence	ProjectionEponymousNameCodeSequence	SQ	1	f	
(0018,5210)	Image Transformation Matrix	ImageTransformationMatrix	DS	6	t	
(0018,5212)	Image Translation Vector	ImageTranslationVector	DS	3	t	
(0018,6000)	Sensitivity	Sensitivity	DS	1	f	
(0018,6011)	Sequence of Ultrasound Regions	SequenceOfUltrasoundRegions	SQ	1	f	
(0018,6012)	Region Spatial Format	RegionSpatialFormat	US	1	f	
(0018,6014)	Region Data Type	RegionDataType	US	1	f	
(0018,6016)	Region Flags	RegionFlags	UL	1	f	
(0018,6018)	Region Location Min X0	RegionLocationMinX0	UL	1	f	
(0018,601a)	Region Location Min Y0	RegionLocationMinY0	UL	1	f	
(0018,601c)	Region Location Max X1	RegionLocationMaxX1	UL	1	f	
(0018,601e)	Region Location Max Y1	RegionLocationMaxY1	UL	1	f	
(0018,6020)	Reference Pixel X0	ReferencePixelX0	SL	1	f	
(0018,6022)	Reference Pixel Y0	ReferencePixelY0	SL	1	f	
(0018,6024)	Physical Units X Direction	PhysicalUnitsXDirection	US	1	f	
(0018,6026)	Physical Units Y Direction	PhysicalUnitsYDirection	US	1	f	
(0018,6028)	Reference Pixel Physical Value X	ReferencePixelPhysicalValueX	FD	1	f	
(0018,602a)	Reference Pixel Physical Value Y	ReferencePixelPhysicalValueY	FD	1	f	
(0018,602c)	Physical Delta X	PhysicalDeltaX	FD	1	f	
(0018,602e)	Physical Delta Y	PhysicalDeltaY	FD	1	f	
(0018,6030)	Transducer Frequency	TransducerFrequency	UL	1	f	
(0018,6031)	Transducer Type	TransducerType	CS	1	f	
(0018,6032)	Pulse Repetition Frequency	PulseRepetitionFrequency	UL	1	f	
(0018,6034)	Doppler Correction Angle	DopplerCorrectionAngle	FD	1	f	
(0018,6036)	Steering Angle	SteeringAngle	FD	1	f	
(0018,6038)	Doppler Sample Volume X Position (Retired)	DopplerSampleVolumeXPositionRetired	UL	1	t	
(0018,6039)	Doppler Sample Volume X Position	DopplerSampleVolumeXPosition	SL	1	f	
(0018,603a)	Doppler Sample Volume Y Position (Retired)	DopplerSampleVolumeYPositionRetired	UL	1	t	
(0018,603b)	Doppler Sample Volume Y Position	DopplerSampleVolumeYPosition	SL	1	f	
(0018,603c)	TM-Line Position X0 (Retired)	TMLinePositionX0Retired	UL	1	t	
(0018,603d)	TM-Line Position X0	TMLinePositionX0	SL	1	f	
(0018,603e)	TM-Line Position Y0 (Retired)	TMLinePositionY0Retired	UL	1	t	
(0018,603f)	TM-Line Position Y0	TMLinePositionY0	SL	1	f	
(0018,6040)	TM-Line Position X1 (Retired)	TMLinePositionX1Retired	UL	1	t	
(0018,6041)	TM-Line Position X1	TMLinePositionX1	SL	1	f	
(0018,6042)	TM-Line Position Y1 (Retired)	TMLinePositionY1Retired	UL	1	t	
(0018,6043)	TM-Line Position Y1	TMLinePositionY1	SL	1	f	
(0018,6044)	Pixel Component Organization	PixelComponentOrganization	US	1	f	
(0018,6046)	Pixel Component Mask	PixelComponentMask	UL	1	f	
(0018,6048)	Pixel Component Range Start	PixelComponentRangeStart	UL	1	f	
(0018,604a)	Pixel Component Range Stop	PixelComponentRangeStop	UL	1	f	
(0018,604c)	Pixel Component Physical Units	PixelComponentPhysicalUnits	US	1	f	
(0018,604e)	Pixel Component Data Type	PixelComponentDataType	US	1	f	
(0018,6050)	Number of Table Break Points	NumberOfTableBreakPoints	UL	1	f	
(0018,6052)	Table of X Break Points	TableOfXBreakPoints	UL	1-n	f	
(0018,6054)	Table of Y Break Points	TableOfYBreakPoints	FD	1-n	f	
(0018,6056)	Number of Table Entries	NumberOfTableEntries	UL	1	f	
(0018,6058)	Table of Pixel Values	TableOfPixelValues	UL	1-n	f	
(0018,605a)	Table of Parameter Values	TableOfParameterValues	FL	1-n	f	
(0018,6060)	R Wave Time Vector	RWaveTimeVector	FL	1-n	f	
(0018,7000)	Detector Conditions Nominal Flag	DetectorConditionsNominalFlag	CS	1	f	
(0018,7001)	Detector Temperature	DetectorTemperature	DS	1	f	
(0018,7004)	Detector Type	DetectorType	CS	1	f	
(0018,7005)	Detector Configuration	DetectorConfiguration	CS	1	f	
(0018,7006)	Detector Description	DetectorDescription	LT	1	f	
(0018,7008)	Detector Mode	DetectorMode	LT	1	f	
(0018,700a)	Detector ID	DetectorID	SH	1	f	
(0018,700c)	Date of Last Detector Calibration	DateOfLastDetectorCalibration	DA	1	f	
(0018,700e)	Time of Last Detector Calibration	TimeOfLastDetectorCalibration	TM	1	f	
(0018,7010)	Exposures on Detector Since Last Calibration	ExposuresOnDetectorSinceLastCalibration	IS	1	f	
(0018,7011)	Exposures on Detector Since Manufactured	ExposuresOnDetectorSinceManufactured	IS	1	f	
(0018,7012)	Detector Time Since Last Exposure	DetectorTimeSinceLastExposure	DS	1	f	
(0018,7014)	Detector Active Time	DetectorActiveTime	DS	1	f	
(0018,7016)	Detector Activation Offset From Exposure	DetectorActivationOffsetFromExposure	DS	1	f	
(0018,701a)	Detector Binning	DetectorBinning	DS	2	f	
(0018,7020)	Detector Element Physical Size	DetectorElementPhysicalSize	DS	2	f	
(0018,7022)	Detector Element Spacing	DetectorElementSpacing	DS	2	f	
(0018,7024)	Detector Active Shape	DetectorActiveShape	CS	1	f	
(0018,7026)	Detector Active Dimension(s)	DetectorActiveDimensions	DS	1-2	f	
(0018,7028)	Detector Active Origin	DetectorActiveOrigin	DS	2	f	
(0018,702a)	Detector Manufacturer Name	DetectorManufacturerName	LO	1	f	
(0018,702b)	Detector Manufacturer's Model Name	DetectorManufacturerModelName	LO	1	f	
(0018,7030)	Field of View Origin	FieldOfViewOrigin	DS	2	f	
(0018,7032)	Field of View Rotation	FieldOfViewRotation	DS	1	f	
(0018,7034)	Field of View Horizontal Flip	FieldOfViewHorizontalFlip	CS	1	f	
(0018,7036)	Pixel Data Area Origin Relative To FOV	PixelDataAreaOriginRelativeToFOV	FL	2	f	
(4010,1017)	Mass	Mass	FL	1	f	DICOS
(0018,7038)	Pixel Data Area Rotation Angle Relative To FOV	PixelDataAreaRotationAngleRelativeToFOV	FL	1	f	
(0018,7040)	Grid Absorbing Material	GridAbsorbingMaterial	LT	1	f	
(0018,7041)	Grid Spacing Material	GridSpacingMaterial	LT	1	f	
(0018,7042)	Grid Thickness	GridThickness	DS	1	f	
(0018,7044)	Grid Pitch	GridPitch	DS	1	f	
(0018,7046)	Grid Aspect Ratio	GridAspectRatio	IS	2	f	
(0018,7048)	Grid Period	GridPeriod	DS	1	f	
(0018,704c)	Grid Focal Distance	GridFocalDistance	DS	1	f	
(0018,7050)	Filter Material	FilterMaterial	CS	1-n	f	
(0018,7052)	Filter Thickness Minimum	FilterThicknessMinimum	DS	1-n	f	
(0018,7054)	Filter Thickness Maximum	FilterThicknessMaximum	DS	1-n	f	
(0018,7056)	Filter Beam Path Length Minimum	FilterBeamPathLengthMinimum	FL	1-n	f	
(0018,7058)	Filter Beam Path Length Maximum	FilterBeamPathLengthMaximum	FL	1-n	f	
(0018,7060)	Exposure Control Mode	ExposureControlMode	CS	1	f	
(0018,7062)	Exposure Control Mode Description	ExposureControlModeDescription	LT	1	f	
(0018,7064)	Exposure Status	ExposureStatus	CS	1	f	
(0018,7065)	Phototimer Setting	PhototimerSetting	DS	1	f	
(0018,8150)	Exposure Time in ÂµS	ExposureTimeInuS	DS	1	f	
(0018,8151)	X-Ray Tube Current in ÂµA	XRayTubeCurrentInuA	DS	1	f	
(0018,9004)	Content Qualification	ContentQualification	CS	1	f	
(0018,9005)	Pulse Sequence Name	PulseSequenceName	SH	1	f	
(0018,9006)	MR Imaging Modifier Sequence	MRImagingModifierSequence	SQ	1	f	
(0018,9008)	Echo Pulse Sequence	EchoPulseSequence	CS	1	f	
(0018,9009)	Inversion Recovery	InversionRecovery	CS	1	f	
(0018,9010)	Flow Compensation	FlowCompensation	CS	1	f	
(0018,9011)	Multiple Spin Echo	MultipleSpinEcho	CS	1	f	
(0018,9012)	Multi-planar Excitation	MultiPlanarExcitation	CS	1	f	
(0018,9014)	Phase Contrast	PhaseContrast	CS	1	f	
(0018,9015)	Time of Flight Contrast	TimeOfFlightContrast	CS	1	f	
(0018,9016)	Spoiling	Spoiling	CS	1	f	
(0018,9017)	Steady State Pulse Sequence	SteadyStatePulseSequence	CS	1	f	
(0018,9018)	Echo Planar Pulse Sequence	EchoPlanarPulseSequence	CS	1	f	
(0018,9019)	Tag Angle First Axis	TagAngleFirstAxis	FD	1	f	
(0018,9020)	Magnetization Transfer	MagnetizationTransfer	CS	1	f	
(0018,9021)	T2 Preparation	T2Preparation	CS	1	f	
(0018,9022)	Blood Signal Nulling	BloodSignalNulling	CS	1	f	
(0018,9024)	Saturation Recovery	SaturationRecovery	CS	1	f	
(0018,9025)	Spectrally Selected Suppression	SpectrallySelectedSuppression	CS	1	f	
(0018,9026)	Spectrally Selected Excitation	SpectrallySelectedExcitation	CS	1	f	
(0018,9027)	Spatial Pre-saturation	SpatialPresaturation	CS	1	f	
(0018,9028)	Tagging	Tagging	CS	1	f	
(0018,9029)	Oversampling Phase	OversamplingPhase	CS	1	f	
(0018,9030)	Tag Spacing First Dimension	TagSpacingFirstDimension	FD	1	f	
(0018,9032)	Geometry of k-Space Traversal	GeometryOfKSpaceTraversal	CS	1	f	
(0018,9033)	Segmented k-Space Traversal	SegmentedKSpaceTraversal	CS	1	f	
(0018,9034)	Rectilinear Phase Encode Reordering	RectilinearPhaseEncodeReordering	CS	1	f	
(0018,9035)	Tag Thickness	TagThickness	FD	1	f	
(0018,9036)	Partial Fourier Direction	PartialFourierDirection	CS	1	f	
(0018,9037)	Cardiac Synchronization Technique	CardiacSynchronizationTechnique	CS	1	f	
(0018,9041)	Receive Coil Manufacturer Name	ReceiveCoilManufacturerName	LO	1	f	
(0018,9042)	MR Receive Coil Sequence	MRReceiveCoilSequence	SQ	1	f	
(0018,9043)	Receive Coil Type	ReceiveCoilType	CS	1	f	
(0018,9044)	Quadrature Receive Coil	QuadratureReceiveCoil	CS	1	f	
(0018,9045)	Multi-Coil Definition Sequence	MultiCoilDefinitionSequence	SQ	1	f	
(0018,9046)	Multi-Coil Configuration	MultiCoilConfiguration	LO	1	f	
(0018,9047)	Multi-Coil Element Name	MultiCoilElementName	SH	1	f	
(0018,9048)	Multi-Coil Element Used	MultiCoilElementUsed	CS	1	f	
(0018,9049)	MR Transmit Coil Sequence	MRTransmitCoilSequence	SQ	1	f	
(0018,9050)	Transmit Coil Manufacturer Name	TransmitCoilManufacturerName	LO	1	f	
(0018,9051)	Transmit Coil Type	TransmitCoilType	CS	1	f	
(0018,9052)	Spectral Width	SpectralWidth	FD	1-2	f	
(0018,9053)	Chemical Shift Reference	ChemicalShiftReference	FD	1-2	f	
(0018,9054)	Volume Localization Technique	VolumeLocalizationTechnique	CS	1	f	
(0018,9058)	MR Acquisition Frequency Encoding Steps	MRAcquisitionFrequencyEncodingSteps	US	1	f	
(0018,9059)	De-coupling	Decoupling	CS	1	f	
(0018,9060)	De-coupled Nucleus	DecoupledNucleus	CS	1-2	f	
(0018,9061)	De-coupling Frequency	DecouplingFrequency	FD	1-2	f	
(0018,9062)	De-coupling Method	DecouplingMethod	CS	1	f	
(0018,9063)	De-coupling Chemical Shift Reference	DecouplingChemicalShiftReference	FD	1-2	f	
(0018,9064)	k-space Filtering	KSpaceFiltering	CS	1	f	
(0018,9065)	Time Domain Filtering	TimeDomainFiltering	CS	1-2	f	
(0018,9066)	Number of Zero Fills	NumberOfZeroFills	US	1-2	f	
(0018,9067)	Baseline Correction	BaselineCorrection	CS	1	f	
(0018,9069)	Parallel Reduction Factor In-plane	ParallelReductionFactorInPlane	FD	1	f	
(0018,9070)	Cardiac R-R Interval Specified	CardiacRRIntervalSpecified	FD	1	f	
(0018,9073)	Acquisition Duration	AcquisitionDuration	FD	1	f	
(0018,9074)	Frame Acquisition DateTime	FrameAcquisitionDateTime	DT	1	f	
(0018,9075)	Diffusion Directionality	DiffusionDirectionality	CS	1	f	
(0018,9076)	Diffusion Gradient Direction Sequence	DiffusionGradientDirectionSequence	SQ	1	f	
(0018,9077)	Parallel Acquisition	ParallelAcquisition	CS	1	f	
(0018,9078)	Parallel Acquisition Technique	ParallelAcquisitionTechnique	CS	1	f	
(0018,9079)	Inversion Times	InversionTimes	FD	1-n	f	
(0018,9080)	Metabolite Map Description	MetaboliteMapDescription	ST	1	f	
(0018,9081)	Partial Fourier	PartialFourier	CS	1	f	
(0018,9082)	Effective Echo Time	EffectiveEchoTime	FD	1	f	
(0018,9083)	Metabolite Map Code Sequence	MetaboliteMapCodeSequence	SQ	1	f	
(0018,9084)	Chemical Shift Sequence	ChemicalShiftSequence	SQ	1	f	
(0018,9085)	Cardiac Signal Source	CardiacSignalSource	CS	1	f	
(0018,9087)	Diffusion b-value	DiffusionBValue	FD	1	f	
(0018,9089)	Diffusion Gradient Orientation	DiffusionGradientOrientation	FD	3	f	
(0018,9090)	Velocity Encoding Direction	VelocityEncodingDirection	FD	3	f	
(0018,9091)	Velocity Encoding Minimum Value	VelocityEncodingMinimumValue	FD	1	f	
(0018,9092)	Velocity Encoding Acquisition Sequence	VelocityEncodingAcquisitionSequence	SQ	1	f	
(0018,9093)	Number of k-Space Trajectories	NumberOfKSpaceTrajectories	US	1	f	
(0018,9094)	Coverage of k-Space	CoverageOfKSpace	CS	1	f	
(0018,9095)	Spectroscopy Acquisition Phase Rows	SpectroscopyAcquisitionPhaseRows	UL	1	f	
(0018,9096)	Parallel Reduction Factor In-plane (Retired)	ParallelReductionFactorInPlaneRetired	FD	1	t	
(0018,9098)	Transmitter Frequency	TransmitterFrequency	FD	1-2	f	
(0018,9100)	Resonant Nucleus	ResonantNucleus	CS	1-2	f	
(0018,9101)	Frequency Correction	FrequencyCorrection	CS	1	f	
(0018,9103)	MR Spectroscopy FOV/Geometry Sequence	MRSpectroscopyFOVGeometrySequence	SQ	1	f	
(0018,9104)	Slab Thickness	SlabThickness	FD	1	f	
(0018,9105)	Slab Orientation	SlabOrientation	FD	3	f	
(0018,9106)	Mid Slab Position	MidSlabPosition	FD	3	f	
(0018,9107)	MR Spatial Saturation Sequence	MRSpatialSaturationSequence	SQ	1	f	
(0018,9112)	MR Timing and Related Parameters Sequence	MRTimingAndRelatedParametersSequence	SQ	1	f	
(0018,9114)	MR Echo Sequence	MREchoSequence	SQ	1	f	
(0018,9115)	MR Modifier Sequence	MRModifierSequence	SQ	1	f	
(0018,9117)	MR Diffusion Sequence	MRDiffusionSequence	SQ	1	f	
(0018,9118)	Cardiac Synchronization Sequence	CardiacSynchronizationSequence	SQ	1	f	
(0018,9119)	MR Averages Sequence	MRAveragesSequence	SQ	1	f	
(0018,9125)	MR FOV/Geometry Sequence	MRFOVGeometrySequence	SQ	1	f	
(0018,9126)	Volume Localization Sequence	VolumeLocalizationSequence	SQ	1	f	
(0018,9127)	Spectroscopy Acquisition Data Columns	SpectroscopyAcquisitionDataColumns	UL	1	f	
(0018,9147)	Diffusion Anisotropy Type	DiffusionAnisotropyType	CS	1	f	
(0018,9151)	Frame Reference DateTime	FrameReferenceDateTime	DT	1	f	
(0018,9152)	MR Metabolite Map Sequence	MRMetaboliteMapSequence	SQ	1	f	
(0018,9155)	Parallel Reduction Factor out-of-plane	ParallelReductionFactorOutOfPlane	FD	1	f	
(0018,9159)	Spectroscopy Acquisition Out-of-plane Phase Steps	SpectroscopyAcquisitionOutOfPlanePhaseSteps	UL	1	f	
(0018,9166)	Bulk Motion Status	BulkMotionStatus	CS	1	t	
(0018,9168)	Parallel Reduction Factor Second In-plane	ParallelReductionFactorSecondInPlane	FD	1	f	
(0018,9169)	Cardiac Beat Rejection Technique	CardiacBeatRejectionTechnique	CS	1	f	
(0018,9170)	Respiratory Motion Compensation Technique	RespiratoryMotionCompensationTechnique	CS	1	f	
(0018,9171)	Respiratory Signal Source	RespiratorySignalSource	CS	1	f	
(0018,9172)	Bulk Motion Compensation Technique	BulkMotionCompensationTechnique	CS	1	f	
(0018,9173)	Bulk Motion Signal Source	BulkMotionSignalSource	CS	1	f	
(0018,9174)	Applicable Safety Standard Agency	ApplicableSafetyStandardAgency	CS	1	f	
(0018,9175)	Applicable Safety Standard Description	ApplicableSafetyStandardDescription	LO	1	f	
(0018,9176)	Operating Mode Sequence	OperatingModeSequence	SQ	1	f	
(0018,9177)	Operating Mode Type	OperatingModeType	CS	1	f	
(0018,9178)	Operating Mode	OperatingMode	CS	1	f	
(0018,9179)	Specific Absorption Rate Definition	SpecificAbsorptionRateDefinition	CS	1	f	
(0018,9180)	Gradient Output Type	GradientOutputType	CS	1	f	
(0018,9181)	Specific Absorption Rate Value	SpecificAbsorptionRateValue	FD	1	f	
(0018,9182)	Gradient Output	GradientOutput	FD	1	f	
(0018,9183)	Flow Compensation Direction	FlowCompensationDirection	CS	1	f	
(0018,9184)	Tagging Delay	TaggingDelay	FD	1	f	
(0018,9185)	Respiratory Motion Compensation Technique Description	RespiratoryMotionCompensationTechniqueDescription	ST	1	f	
(0018,9186)	Respiratory Signal Source ID	RespiratorySignalSourceID	SH	1	f	
(0018,9195)	Chemical Shift Minimum Integration Limit in Hz	ChemicalShiftMinimumIntegrationLimitInHz	FD	1	t	
(0018,9196)	Chemical Shift Maximum Integration Limit in Hz	ChemicalShiftMaximumIntegrationLimitInHz	FD	1	t	
(0018,9197)	MR Velocity Encoding Sequence	MRVelocityEncodingSequence	SQ	1	f	
(0018,9198)	First Order Phase Correction	FirstOrderPhaseCorrection	CS	1	f	
(0018,9199)	Water Referenced Phase Correction	WaterReferencedPhaseCorrection	CS	1	f	
(0018,9200)	MR Spectroscopy Acquisition Type	MRSpectroscopyAcquisitionType	CS	1	f	
(0018,9214)	Respiratory Cycle Position	RespiratoryCyclePosition	CS	1	f	
(0018,9217)	Velocity Encoding Maximum Value	VelocityEncodingMaximumValue	FD	1	f	
(0018,9218)	Tag Spacing Second Dimension	TagSpacingSecondDimension	FD	1	f	
(0018,9219)	Tag Angle Second Axis	TagAngleSecondAxis	SS	1	f	
(0018,9220)	Frame Acquisition Duration	FrameAcquisitionDuration	FD	1	f	
(0018,9226)	MR Image Frame Type Sequence	MRImageFrameTypeSequence	SQ	1	f	
(0018,9227)	MR Spectroscopy Frame Type Sequence	MRSpectroscopyFrameTypeSequence	SQ	1	f	
(0018,9231)	MR Acquisition Phase Encoding Steps in-plane	MRAcquisitionPhaseEncodingStepsInPlane	US	1	f	
(0018,9232)	MR Acquisition Phase Encoding Steps out-of-plane	MRAcquisitionPhaseEncodingStepsOutOfPlane	US	1	f	
(0018,9234)	Spectroscopy Acquisition Phase Columns	SpectroscopyAcquisitionPhaseColumns	UL	1	f	
(0018,9236)	Cardiac Cycle Position	CardiacCyclePosition	CS	1	f	
(0018,9239)	Specific Absorption Rate Sequence	SpecificAbsorptionRateSequence	SQ	1	f	
(0018,9240)	RF Echo Train Length	RFEchoTrainLength	US	1	f	
(0018,9241)	Gradient Echo Train Length	GradientEchoTrainLength	US	1	f	
(0018,9250)	Arterial Spin Labeling Contrast	ArterialSpinLabelingContrast	CS	1	f	
(0018,9251)	MR Arterial Spin Labeling Sequence	MRArterialSpinLabelingSequence	SQ	1	f	
(0018,9252)	ASL Technique Description	ASLTechniqueDescription	LO	1	f	
(0018,9253)	ASL Slab Number	ASLSlabNumber	US	1	f	
(0018,9254)	ASL Slab Thickness	ASLSlabThickness	FD	1	f	
(0018,9255)	ASL Slab Orientation	ASLSlabOrientation	FD	3	f	
(0018,9256)	ASL Mid Slab Position	ASLMidSlabPosition	FD	3	f	
(0018,9257)	ASL Context	ASLContext	CS	1	f	
(0018,9258)	ASL Pulse Train Duration	ASLPulseTrainDuration	UL	1	f	
(0018,9259)	ASL Crusher Flag	ASLCrusherFlag	CS	1	f	
(0018,925a)	ASL Crusher Flow Limit	ASLCrusherFlowLimit	FD	1	f	
(0018,925b)	ASL Crusher Description	ASLCrusherDescription	LO	1	f	
(0018,925c)	ASL Bolus Cut-off Flag	ASLBolusCutoffFlag	CS	1	f	
(0018,925d)	ASL Bolus Cut-off Timing Sequence	ASLBolusCutoffTimingSequence	SQ	1	f	
(0018,925e)	ASL Bolus Cut-off Technique	ASLBolusCutoffTechnique	LO	1	f	
(0018,925f)	ASL Bolus Cut-off Delay Time	ASLBolusCutoffDelayTime	UL	1	f	
(0018,9260)	ASL Slab Sequence	ASLSlabSequence	SQ	1	f	
(0018,9295)	Chemical Shift Minimum Integration Limit in ppm	ChemicalShiftMinimumIntegrationLimitInppm	FD	1	f	
(0018,9296)	Chemical Shift Maximum Integration Limit in ppm	ChemicalShiftMaximumIntegrationLimitInppm	FD	1	f	
(0018,9297)	Water Reference Acquisition	WaterReferenceAcquisition	CS	1	f	
(0018,9298)	Echo Peak Position	EchoPeakPosition	IS	1	f	
(0018,9301)	CT Acquisition Type Sequence	CTAcquisitionTypeSequence	SQ	1	f	
(0018,9302)	Acquisition Type	AcquisitionType	CS	1	f	
(0018,9303)	Tube Angle	TubeAngle	FD	1	f	
(0018,9304)	CT Acquisition Details Sequence	CTAcquisitionDetailsSequence	SQ	1	f	
(0018,9305)	Revolution Time	RevolutionTime	FD	1	f	
(0018,9306)	Single Collimation Width	SingleCollimationWidth	FD	1	f	
(0018,9307)	Total Collimation Width	TotalCollimationWidth	FD	1	f	
(0018,9308)	CT Table Dynamics Sequence	CTTableDynamicsSequence	SQ	1	f	
(0018,9309)	Table Speed	TableSpeed	FD	1	f	
(0018,9310)	Table Feed per Rotation	TableFeedPerRotation	FD	1	f	
(0018,9311)	Spiral Pitch Factor	SpiralPitchFactor	FD	1	f	
(0018,9312)	CT Geometry Sequence	CTGeometrySequence	SQ	1	f	
(0018,9313)	Data Collection Center (Patient)	DataCollectionCenterPatient	FD	3	f	
(0018,9314)	CT Reconstruction Sequence	CTReconstructionSequence	SQ	1	f	
(0018,9315)	Reconstruction Algorithm	ReconstructionAlgorithm	CS	1	f	
(0018,9316)	Convolution Kernel Group	ConvolutionKernelGroup	CS	1	f	
(0018,9317)	Reconstruction Field of View	ReconstructionFieldOfView	FD	2	f	
(0018,9318)	Reconstruction Target Center (Patient)	ReconstructionTargetCenterPatient	FD	3	f	
(0018,9319)	Reconstruction Angle	ReconstructionAngle	FD	1	f	
(0018,9320)	Image Filter	ImageFilter	SH	1	f	
(0018,9321)	CT Exposure Sequence	CTExposureSequence	SQ	1	f	
(0018,9322)	Reconstruction Pixel Spacing	ReconstructionPixelSpacing	FD	2	f	
(0018,9323)	Exposure Modulation Type	ExposureModulationType	CS	1	f	
(0018,9324)	Estimated Dose Saving	EstimatedDoseSaving	FD	1	f	
(0018,9325)	CT X-Ray Details Sequence	CTXRayDetailsSequence	SQ	1	f	
(0018,9326)	CT Position Sequence	CTPositionSequence	SQ	1	f	
(0018,9327)	Table Position	TablePosition	FD	1	f	
(0018,9328)	Exposure Time in ms	ExposureTimeInms	FD	1	f	
(0018,9329)	CT Image Frame Type Sequence	CTImageFrameTypeSequence	SQ	1	f	
(0018,9330)	X-Ray Tube Current in mA	XRayTubeCurrentInmA	FD	1	f	
(0018,9332)	Exposure in mAs	ExposureInmAs	FD	1	f	
(0018,9333)	Constant Volume Flag	ConstantVolumeFlag	CS	1	f	
(0018,9334)	Fluoroscopy Flag	FluoroscopyFlag	CS	1	f	
(0018,9335)	Distance Source to Data Collection Center	DistanceSourceToDataCollectionCenter	FD	1	f	
(0018,9337)	Contrast/Bolus Agent Number	ContrastBolusAgentNumber	US	1	f	
(0018,9338)	Contrast/Bolus Ingredient Code Sequence	ContrastBolusIngredientCodeSequence	SQ	1	f	
(0018,9340)	Contrast Administration Profile Sequence	ContrastAdministrationProfileSequence	SQ	1	f	
(0018,9341)	Contrast/Bolus Usage Sequence	ContrastBolusUsageSequence	SQ	1	f	
(0018,9342)	Contrast/Bolus Agent Administered	ContrastBolusAgentAdministered	CS	1	f	
(0018,9343)	Contrast/Bolus Agent Detected	ContrastBolusAgentDetected	CS	1	f	
(0018,9344)	Contrast/Bolus Agent Phase	ContrastBolusAgentPhase	CS	1	f	
(0018,9345)	CTDIvol	CTDIvol	FD	1	f	
(0018,9346)	CTDI Phantom Type Code Sequence	CTDIPhantomTypeCodeSequence	SQ	1	f	
(0018,9351)	Calcium Scoring Mass Factor Patient	CalciumScoringMassFactorPatient	FL	1	f	
(0018,9352)	Calcium Scoring Mass Factor Device	CalciumScoringMassFactorDevice	FL	3	f	
(0018,9353)	Energy Weighting Factor	EnergyWeightingFactor	FL	1	f	
(0018,9360)	CT Additional X-Ray Source Sequence	CTAdditionalXRaySourceSequence	SQ	1	f	
(0018,9401)	Projection Pixel Calibration Sequence	ProjectionPixelCalibrationSequence	SQ	1	f	
(0018,9402)	Distance Source to Isocenter	DistanceSourceToIsocenter	FL	1	f	
(0018,9403)	Distance Object to Table Top	DistanceObjectToTableTop	FL	1	f	
(0018,9404)	Object Pixel Spacing in Center of Beam	ObjectPixelSpacingInCenterOfBeam	FL	2	f	
(0018,9405)	Positioner Position Sequence	PositionerPositionSequence	SQ	1	f	
(0018,9406)	Table Position Sequence	TablePositionSequence	SQ	1	f	
(0018,9407)	Collimator Shape Sequence	CollimatorShapeSequence	SQ	1	f	
(0018,9410)	Planes in Acquisition	PlanesInAcquisition	CS	1	f	
(0018,9412)	XA/XRF Frame Characteristics Sequence	XAXRFFrameCharacteristicsSequence	SQ	1	f	
(0018,9417)	Frame Acquisition Sequence	FrameAcquisitionSequence	SQ	1	f	
(0018,9420)	X-Ray Receptor Type	XRayReceptorType	CS	1	f	
(0018,9423)	Acquisition Protocol Name	AcquisitionProtocolName	LO	1	f	
(0018,9424)	Acquisition Protocol Description	AcquisitionProtocolDescription	LT	1	f	
(0018,9425)	Contrast/Bolus Ingredient Opaque	ContrastBolusIngredientOpaque	CS	1	f	
(0018,9426)	Distance Receptor Plane to Detector Housing	DistanceReceptorPlaneToDetectorHousing	FL	1	f	
(0018,9427)	Intensifier Active Shape	IntensifierActiveShape	CS	1	f	
(0018,9428)	Intensifier Active Dimension(s)	IntensifierActiveDimensions	FL	1-2	f	
(0018,9429)	Physical Detector Size	PhysicalDetectorSize	FL	2	f	
(0018,9430)	Position of Isocenter Projection	PositionOfIsocenterProjection	FL	2	f	
(0018,9432)	Field of View Sequence	FieldOfViewSequence	SQ	1	f	
(0018,9433)	Field of View Description	FieldOfViewDescription	LO	1	f	
(0018,9434)	Exposure Control Sensing Regions Sequence	ExposureControlSensingRegionsSequence	SQ	1	f	
(0018,9435)	Exposure Control Sensing Region Shape	ExposureControlSensingRegionShape	CS	1	f	
(0018,9436)	Exposure Control Sensing Region Left Vertical Edge	ExposureControlSensingRegionLeftVerticalEdge	SS	1	f	
(0018,9437)	Exposure Control Sensing Region Right Vertical Edge	ExposureControlSensingRegionRightVerticalEdge	SS	1	f	
(0018,9438)	Exposure Control Sensing Region Upper Horizontal Edge	ExposureControlSensingRegionUpperHorizontalEdge	SS	1	f	
(0018,9439)	Exposure Control Sensing Region Lower Horizontal Edge	ExposureControlSensingRegionLowerHorizontalEdge	SS	1	f	
(0018,9440)	Center of Circular Exposure Control Sensing Region	CenterOfCircularExposureControlSensingRegion	SS	2	f	
(0018,9441)	Radius of Circular Exposure Control Sensing Region	RadiusOfCircularExposureControlSensingRegion	US	1	f	
(0018,9442)	Vertices of the Polygonal Exposure Control Sensing Region	VerticesOfThePolygonalExposureControlSensingRegion	SS	2-n	f	
(0018,9447)	Column Angulation (Patient)	ColumnAngulationPatient	FL	1	f	
(0018,9449)	Beam Angle	BeamAngle	FL	1	f	
(0018,9451)	Frame Detector Parameters Sequence	FrameDetectorParametersSequence	SQ	1	f	
(0018,9452)	Calculated Anatomy Thickness	CalculatedAnatomyThickness	FL	1	f	
(0018,9455)	Calibration Sequence	CalibrationSequence	SQ	1	f	
(0018,9456)	Object Thickness Sequence	ObjectThicknessSequence	SQ	1	f	
(0018,9457)	Plane Identification	PlaneIdentification	CS	1	f	
(0018,9461)	Field of View Dimension(s) in Float	FieldOfViewDimensionsInFloat	FL	1-2	f	
(0018,9462)	Isocenter Reference System Sequence	IsocenterReferenceSystemSequence	SQ	1	f	
(0018,9463)	Positioner Isocenter Primary Angle	PositionerIsocenterPrimaryAngle	FL	1	f	
(0018,9464)	Positioner Isocenter Secondary Angle	PositionerIsocenterSecondaryAngle	FL	1	f	
(0018,9465)	Positioner Isocenter Detector Rotation Angle	PositionerIsocenterDetectorRotationAngle	FL	1	f	
(0018,9466)	Table X Position to Isocenter	TableXPositionToIsocenter	FL	1	f	
(0018,9467)	Table Y Position to Isocenter	TableYPositionToIsocenter	FL	1	f	
(0018,9468)	Table Z Position to Isocenter	TableZPositionToIsocenter	FL	1	f	
(0018,9469)	Table Horizontal Rotation Angle	TableHorizontalRotationAngle	FL	1	f	
(0018,9470)	Table Head Tilt Angle	TableHeadTiltAngle	FL	1	f	
(0018,9471)	Table Cradle Tilt Angle	TableCradleTiltAngle	FL	1	f	
(0018,9472)	Frame Display Shutter Sequence	FrameDisplayShutterSequence	SQ	1	f	
(0018,9473)	Acquired Image Area Dose Product	AcquiredImageAreaDoseProduct	FL	1	f	
(0018,9474)	C-arm Positioner Tabletop Relationship	CArmPositionerTabletopRelationship	CS	1	f	
(0018,9476)	X-Ray Geometry Sequence	XRayGeometrySequence	SQ	1	f	
(0018,9477)	Irradiation Event Identification Sequence	IrradiationEventIdentificationSequence	SQ	1	f	
(0018,9504)	X-Ray 3D Frame Type Sequence	XRay3DFrameTypeSequence	SQ	1	f	
(0018,9506)	Contributing Sources Sequence	ContributingSourcesSequence	SQ	1	f	
(0018,9507)	X-Ray 3D Acquisition Sequence	XRay3DAcquisitionSequence	SQ	1	f	
(0018,9508)	Primary Positioner Scan Arc	PrimaryPositionerScanArc	FL	1	f	
(0018,9509)	Secondary Positioner Scan Arc	SecondaryPositionerScanArc	FL	1	f	
(0018,9510)	Primary Positioner Scan Start Angle	PrimaryPositionerScanStartAngle	FL	1	f	
(0018,9511)	Secondary Positioner Scan Start Angle	SecondaryPositionerScanStartAngle	FL	1	f	
(0018,9514)	Primary Positioner Increment	PrimaryPositionerIncrement	FL	1	f	
(0018,9515)	Secondary Positioner Increment	SecondaryPositionerIncrement	FL	1	f	
(0018,9516)	Start Acquisition DateTime	StartAcquisitionDateTime	DT	1	f	
(0018,9517)	End Acquisition DateTime	EndAcquisitionDateTime	DT	1	f	
(0018,9518)	Primary Positioner Increment Sign	PrimaryPositionerIncrementSign	SS	1	f	
(0018,9519)	Secondary Positioner Increment Sign	SecondaryPositionerIncrementSign	SS	1	f	
(0018,9524)	Application Name	ApplicationName	LO	1	f	
(0018,9525)	Application Version	ApplicationVersion	LO	1	f	
(0018,9526)	Application Manufacturer	ApplicationManufacturer	LO	1	f	
(0018,9527)	Algorithm Type	AlgorithmType	CS	1	f	
(0018,9528)	Algorithm Description	AlgorithmDescription	LO	1	f	
(0018,9530)	X-Ray 3D Reconstruction Sequence	XRay3DReconstructionSequence	SQ	1	f	
(0018,9531)	Reconstruction Description	ReconstructionDescription	LO	1	f	
(0018,9538)	Per Projection Acquisition Sequence	PerProjectionAcquisitionSequence	SQ	1	f	
(0018,9541)	Detector Position Sequence	DetectorPositionSequence	SQ	1	f	
(0018,9542)	X-Ray Acquisition Dose Sequence	XRayAcquisitionDoseSequence	SQ	1	f	
(0018,9543)	X-Ray Source Isocenter Primary Angle	XRaySourceIsocenterPrimaryAngle	FD	1	f	
(0018,9544)	X-Ray Source Isocenter Secondary Angle	XRaySourceIsocenterSecondaryAngle	FD	1	f	
(0018,9545)	Breast Support Isocenter Primary Angle	BreastSupportIsocenterPrimaryAngle	FD	1	f	
(0018,9546)	Breast Support Isocenter Secondary Angle	BreastSupportIsocenterSecondaryAngle	FD	1	f	
(0018,9547)	Breast Support X Position to Isocenter	BreastSupportXPositionToIsocenter	FD	1	f	
(0018,9548)	Breast Support Y Position to Isocenter	BreastSupportYPositionToIsocenter	FD	1	f	
(0018,9549)	Breast Support Z Position to Isocenter	BreastSupportZPositionToIsocenter	FD	1	f	
(0018,9550)	Detector Isocenter Primary Angle	DetectorIsocenterPrimaryAngle	FD	1	f	
(0018,9551)	Detector Isocenter Secondary Angle	DetectorIsocenterSecondaryAngle	FD	1	f	
(0018,9552)	Detector X Position to Isocenter	DetectorXPositionToIsocenter	FD	1	f	
(0018,9553)	Detector Y Position to Isocenter	DetectorYPositionToIsocenter	FD	1	f	
(0018,9554)	Detector Z Position to Isocenter	DetectorZPositionToIsocenter	FD	1	f	
(0018,9555)	X-Ray Grid Sequence	XRayGridSequence	SQ	1	f	
(0018,9556)	X-Ray Filter Sequence	XRayFilterSequence	SQ	1	f	
(0018,9557)	Detector Active Area TLHC Position	DetectorActiveAreaTLHCPosition	FD	3	f	
(0018,9558)	Detector Active Area Orientation	DetectorActiveAreaOrientation	FD	6	f	
(0018,9559)	Positioner Primary Angle Direction	PositionerPrimaryAngleDirection	CS	1	f	
(0018,9601)	Diffusion b-matrix Sequence	DiffusionBMatrixSequence	SQ	1	f	
(0018,9602)	Diffusion b-value XX	DiffusionBValueXX	FD	1	f	
(0018,9603)	Diffusion b-value XY	DiffusionBValueXY	FD	1	f	
(0018,9604)	Diffusion b-value XZ	DiffusionBValueXZ	FD	1	f	
(0018,9605)	Diffusion b-value YY	DiffusionBValueYY	FD	1	f	
(0018,9606)	Diffusion b-value YZ	DiffusionBValueYZ	FD	1	f	
(0018,9607)	Diffusion b-value ZZ	DiffusionBValueZZ	FD	1	f	
(0018,9621)	Functional MR Sequence	FunctionalMRSequence	SQ	1	f	
(0018,9622)	Functional Settling Phase Frames Present	FunctionalSettlingPhaseFramesPresent	CS	1	f	
(0018,9623)	Functional Sync Pulse	FunctionalSyncPulse	DT	1	f	
(0018,9624)	Settling Phase Frame	SettlingPhaseFrame	CS	1	f	
(0018,9701)	Decay Correction DateTime	DecayCorrectionDateTime	DT	1	f	
(0018,9715)	Start Density Threshold	StartDensityThreshold	FD	1	f	
(0018,9716)	Start Relative Density Difference Threshold	StartRelativeDensityDifferenceThreshold	FD	1	f	
(0018,9717)	Start Cardiac Trigger Count Threshold	StartCardiacTriggerCountThreshold	FD	1	f	
(0018,9718)	Start Respiratory Trigger Count Threshold	StartRespiratoryTriggerCountThreshold	FD	1	f	
(0018,9719)	Termination Counts Threshold	TerminationCountsThreshold	FD	1	f	
(0018,9720)	Termination Density Threshold	TerminationDensityThreshold	FD	1	f	
(0018,9721)	Termination Relative Density Threshold	TerminationRelativeDensityThreshold	FD	1	f	
(0018,9722)	Termination Time Threshold	TerminationTimeThreshold	FD	1	f	
(0018,9723)	Termination Cardiac Trigger Count Threshold	TerminationCardiacTriggerCountThreshold	FD	1	f	
(0018,9724)	Termination Respiratory Trigger Count Threshold	TerminationRespiratoryTriggerCountThreshold	FD	1	f	
(0018,9725)	Detector Geometry	DetectorGeometry	CS	1	f	
(0018,9726)	Transverse Detector Separation	TransverseDetectorSeparation	FD	1	f	
(0018,9727)	Axial Detector Dimension	AxialDetectorDimension	FD	1	f	
(0018,9729)	Radiopharmaceutical Agent Number	RadiopharmaceuticalAgentNumber	US	1	f	
(0018,9732)	PET Frame Acquisition Sequence	PETFrameAcquisitionSequence	SQ	1	f	
(0018,9733)	PET Detector Motion Details Sequence	PETDetectorMotionDetailsSequence	SQ	1	f	
(0018,9734)	PET Table Dynamics Sequence	PETTableDynamicsSequence	SQ	1	f	
(0018,9735)	PET Position Sequence	PETPositionSequence	SQ	1	f	
(0018,9736)	PET Frame Correction Factors Sequence	PETFrameCorrectionFactorsSequence	SQ	1	f	
(0018,9737)	Radiopharmaceutical Usage Sequence	RadiopharmaceuticalUsageSequence	SQ	1	f	
(0018,9738)	Attenuation Correction Source	AttenuationCorrectionSource	CS	1	f	
(0018,9739)	Number of Iterations	NumberOfIterations	US	1	f	
(0018,9740)	Number of Subsets	NumberOfSubsets	US	1	f	
(0018,9749)	PET Reconstruction Sequence	PETReconstructionSequence	SQ	1	f	
(0018,9751)	PET Frame Type Sequence	PETFrameTypeSequence	SQ	1	f	
(0018,9755)	Time of Flight Information Used	TimeOfFlightInformationUsed	CS	1	f	
(0018,9756)	Reconstruction Type	ReconstructionType	CS	1	f	
(0018,9758)	Decay Corrected	DecayCorrected	CS	1	f	
(0018,9759)	Attenuation Corrected	AttenuationCorrected	CS	1	f	
(0018,9760)	Scatter Corrected	ScatterCorrected	CS	1	f	
(0018,9761)	Dead Time Corrected	DeadTimeCorrected	CS	1	f	
(0018,9762)	Gantry Motion Corrected	GantryMotionCorrected	CS	1	f	
(0018,9763)	Patient Motion Corrected	PatientMotionCorrected	CS	1	f	
(0018,9764)	Count Loss Normalization Corrected	CountLossNormalizationCorrected	CS	1	f	
(0018,9765)	Randoms Corrected	RandomsCorrected	CS	1	f	
(0018,9766)	Non-uniform Radial Sampling Corrected	NonUniformRadialSamplingCorrected	CS	1	f	
(0018,9767)	Sensitivity Calibrated	SensitivityCalibrated	CS	1	f	
(0018,9768)	Detector Normalization Correction	DetectorNormalizationCorrection	CS	1	f	
(0018,9769)	Iterative Reconstruction Method	IterativeReconstructionMethod	CS	1	f	
(0018,9770)	Attenuation Correction Temporal Relationship	AttenuationCorrectionTemporalRelationship	CS	1	f	
(0018,9771)	Patient Physiological State Sequence	PatientPhysiologicalStateSequence	SQ	1	f	
(0018,9772)	Patient Physiological State Code Sequence	PatientPhysiologicalStateCodeSequence	SQ	1	f	
(0018,9801)	Depth(s) of Focus	DepthsOfFocus	FD	1-n	f	
(0018,9803)	Excluded Intervals Sequence	ExcludedIntervalsSequence	SQ	1	f	
(0018,9804)	Exclusion Start DateTime	ExclusionStartDateTime	DT	1	f	
(0018,9805)	Exclusion Duration	ExclusionDuration	FD	1	f	
(0018,9806)	US Image Description Sequence	USImageDescriptionSequence	SQ	1	f	
(0018,9807)	Image Data Type Sequence	ImageDataTypeSequence	SQ	1	f	
(0018,9808)	Data Type	DataType	CS	1	f	
(0018,9809)	Transducer Scan Pattern Code Sequence	TransducerScanPatternCodeSequence	SQ	1	f	
(0018,980b)	Aliased Data Type	AliasedDataType	CS	1	f	
(0018,980c)	Position Measuring Device Used	PositionMeasuringDeviceUsed	CS	1	f	
(0018,980d)	Transducer Geometry Code Sequence	TransducerGeometryCodeSequence	SQ	1	f	
(0018,980e)	Transducer Beam Steering Code Sequence	TransducerBeamSteeringCodeSequence	SQ	1	f	
(0018,980f)	Transducer Application Code Sequence	TransducerApplicationCodeSequence	SQ	1	f	
(0018,9810)	Zero Velocity Pixel Value	ZeroVelocityPixelValue	US or SS	1	f	
(0018,a001)	Contributing Equipment Sequence	ContributingEquipmentSequence	SQ	1	f	
(0018,a002)	Contribution DateTime	ContributionDateTime	DT	1	f	
(0018,a003)	Contribution Description	ContributionDescription	ST	1	f	
(4010,1018)	Density	Density	FL	1	f	DICOS
(0020,000d)	Study Instance UID	StudyInstanceUID	UI	1	f	
(0020,000e)	Series Instance UID	SeriesInstanceUID	UI	1	f	
(0020,0010)	Study ID	StudyID	SH	1	f	
(0020,0011)	Series Number	SeriesNumber	IS	1	f	
(0020,0012)	Acquisition Number	AcquisitionNumber	IS	1	f	
(0020,0013)	Instance Number	InstanceNumber	IS	1	f	
(0020,0014)	Isotope Number	IsotopeNumber	IS	1	t	
(0020,0015)	Phase Number	PhaseNumber	IS	1	t	
(0020,0016)	Interval Number	IntervalNumber	IS	1	t	
(0020,0017)	Time Slot Number	TimeSlotNumber	IS	1	t	
(0020,0018)	Angle Number	AngleNumber	IS	1	t	
(0020,0019)	Item Number	ItemNumber	IS	1	f	
(0020,0020)	Patient Orientation	PatientOrientation	CS	2	f	
(0020,0022)	Overlay Number	OverlayNumber	IS	1	t	
(0020,0024)	Curve Number	CurveNumber	IS	1	t	
(0020,0026)	LUT Number	LUTNumber	IS	1	t	
(0020,0030)	Image Position	ImagePosition	DS	3	t	
(0020,0032)	Image Position (Patient)	ImagePositionPatient	DS	3	f	
(0020,0035)	Image Orientation	ImageOrientation	DS	6	t	
(0020,0037)	Image Orientation (Patient)	ImageOrientationPatient	DS	6	f	
(0020,0050)	Location	Location	DS	1	t	
(0020,0052)	Frame of Reference UID	FrameOfReferenceUID	UI	1	f	
(0020,0060)	Laterality	Laterality	CS	1	f	
(0020,0062)	Image Laterality	ImageLaterality	CS	1	f	
(0020,0070)	Image Geometry Type	ImageGeometryType	LO	1	t	
(0020,0080)	Masking Image	MaskingImage	CS	1-n	t	
(0020,00aa)	Report Number	ReportNumber	IS	1	t	
(0020,0100)	Temporal Position Identifier	TemporalPositionIdentifier	IS	1	f	
(0020,0105)	Number of Temporal Positions	NumberOfTemporalPositions	IS	1	f	
(0020,0110)	Temporal Resolution	TemporalResolution	DS	1	f	
(0020,0200)	Synchronization Frame of Reference UID	SynchronizationFrameOfReferenceUID	UI	1	f	
(0020,0242)	SOP Instance UID of Concatenation Source	SOPInstanceUIDOfConcatenationSource	UI	1	f	
(0020,1000)	Series in Study	SeriesInStudy	IS	1	t	
(0020,1001)	Acquisitions in Series	AcquisitionsInSeries	IS	1	t	
(0020,1002)	Images in Acquisition	ImagesInAcquisition	IS	1	f	
(0020,1003)	Images in Series	ImagesInSeries	IS	1	t	
(0020,1004)	Acquisitions in Study	AcquisitionsInStudy	IS	1	t	
(0020,1005)	Images in Study	ImagesInStudy	IS	1	t	
(0020,1020)	Reference	Reference	LO	1-n	t	
(0020,1040)	Position Reference Indicator	PositionReferenceIndicator	LO	1	f	
(0020,1041)	Slice Location	SliceLocation	DS	1	f	
(0020,1070)	Other Study Numbers	OtherStudyNumbers	IS	1-n	t	
(0020,1200)	Number of Patient Related Studies	NumberOfPatientRelatedStudies	IS	1	f	
(0020,1202)	Number of Patient Related Series	NumberOfPatientRelatedSeries	IS	1	f	
(0020,1204)	Number of Patient Related Instances	NumberOfPatientRelatedInstances	IS	1	f	
(0020,1206)	Number of Study Related Series	NumberOfStudyRelatedSeries	IS	1	f	
(0020,1208)	Number of Study Related Instances	NumberOfStudyRelatedInstances	IS	1	f	
(0020,1209)	Number of Series Related Instances	NumberOfSeriesRelatedInstances	IS	1	f	
(0020,31xx)	Source Image IDs	SourceImageIDs	CS	1-n	t	
(0020,3401)	Modifying Device ID	ModifyingDeviceID	CS	1	t	
(0020,3402)	Modified Image ID	ModifiedImageID	CS	1	t	
(0020,3403)	Modified Image Date	ModifiedImageDate	DA	1	t	
(0020,3404)	Modifying Device Manufacturer	ModifyingDeviceManufacturer	LO	1	t	
(0020,3405)	Modified Image Time	ModifiedImageTime	TM	1	t	
(0020,3406)	Modified Image Description	ModifiedImageDescription	LO	1	t	
(0020,4000)	Image Comments	ImageComments	LT	1	f	
(0020,5000)	Original Image Identification	OriginalImageIdentification	AT	1-n	t	
(0020,5002)	Original Image Identification Nomenclature	OriginalImageIdentificationNomenclature	LO	1-n	t	
(0020,9056)	Stack ID	StackID	SH	1	f	
(0020,9057)	In-Stack Position Number	InStackPositionNumber	UL	1	f	
(0020,9071)	Frame Anatomy Sequence	FrameAnatomySequence	SQ	1	f	
(0020,9072)	Frame Laterality	FrameLaterality	CS	1	f	
(0020,9111)	Frame Content Sequence	FrameContentSequence	SQ	1	f	
(0020,9113)	Plane Position Sequence	PlanePositionSequence	SQ	1	f	
(0020,9116)	Plane Orientation Sequence	PlaneOrientationSequence	SQ	1	f	
(0020,9128)	Temporal Position Index	TemporalPositionIndex	UL	1	f	
(0020,9153)	Nominal Cardiac Trigger Delay Time	NominalCardiacTriggerDelayTime	FD	1	f	
(0020,9154)	Nominal Cardiac Trigger Time Prior To R-Peak	NominalCardiacTriggerTimePriorToRPeak	FL	1	f	
(0020,9155)	Actual Cardiac Trigger Time Prior To R-Peak	ActualCardiacTriggerTimePriorToRPeak	FL	1	f	
(0020,9156)	Frame Acquisition Number	FrameAcquisitionNumber	US	1	f	
(0020,9157)	Dimension Index Values	DimensionIndexValues	UL	1-n	f	
(0020,9158)	Frame Comments	FrameComments	LT	1	f	
(0020,9161)	Concatenation UID	ConcatenationUID	UI	1	f	
(0020,9162)	In-concatenation Number	InConcatenationNumber	US	1	f	
(0020,9163)	In-concatenation Total Number	InConcatenationTotalNumber	US	1	f	
(0020,9164)	Dimension Organization UID	DimensionOrganizationUID	UI	1	f	
(0020,9165)	Dimension Index Pointer	DimensionIndexPointer	AT	1	f	
(0020,9167)	Functional Group Pointer	FunctionalGroupPointer	AT	1	f	
(0020,9170)	Unassigned Shared Converted Attributes Sequence	UnassignedSharedConvertedAttributesSequence	SQ	1	f	
(0020,9171)	Unassigned Per-Frame Converted Attributes Sequence	UnassignedPerFrameConvertedAttributesSequence	SQ	1	f	
(0020,9172)	Conversion Source Attributes Sequence	ConversionSourceAttributesSequence	SQ	1	f	
(0020,9213)	Dimension Index Private Creator	DimensionIndexPrivateCreator	LO	1	f	
(0020,9221)	Dimension Organization Sequence	DimensionOrganizationSequence	SQ	1	f	
(0020,9222)	Dimension Index Sequence	DimensionIndexSequence	SQ	1	f	
(0020,9228)	Concatenation Frame Offset Number	ConcatenationFrameOffsetNumber	UL	1	f	
(0020,9238)	Functional Group Private Creator	FunctionalGroupPrivateCreator	LO	1	f	
(0020,9241)	Nominal Percentage of Cardiac Phase	NominalPercentageOfCardiacPhase	FL	1	f	
(0020,9245)	Nominal Percentage of Respiratory Phase	NominalPercentageOfRespiratoryPhase	FL	1	f	
(0020,9246)	Starting Respiratory Amplitude	StartingRespiratoryAmplitude	FL	1	f	
(0020,9247)	Starting Respiratory Phase	StartingRespiratoryPhase	CS	1	f	
(0020,9248)	Ending Respiratory Amplitude	EndingRespiratoryAmplitude	FL	1	f	
(0020,9249)	Ending Respiratory Phase	EndingRespiratoryPhase	CS	1	f	
(0020,9250)	Respiratory Trigger Type	RespiratoryTriggerType	CS	1	f	
(0020,9251)	R-R Interval Time Nominal	RRIntervalTimeNominal	FD	1	f	
(0020,9252)	Actual Cardiac Trigger Delay Time	ActualCardiacTriggerDelayTime	FD	1	f	
(0020,9253)	Respiratory Synchronization Sequence	RespiratorySynchronizationSequence	SQ	1	f	
(0020,9254)	Respiratory Interval Time	RespiratoryIntervalTime	FD	1	f	
(0020,9255)	Nominal Respiratory Trigger Delay Time	NominalRespiratoryTriggerDelayTime	FD	1	f	
(0020,9256)	Respiratory Trigger Delay Threshold	RespiratoryTriggerDelayThreshold	FD	1	f	
(0020,9257)	Actual Respiratory Trigger Delay Time	ActualRespiratoryTriggerDelayTime	FD	1	f	
(0020,9301)	Image Position (Volume)	ImagePositionVolume	FD	3	f	
(0020,9302)	Image Orientation (Volume)	ImageOrientationVolume	FD	6	f	
(0020,9307)	Ultrasound Acquisition Geometry	UltrasoundAcquisitionGeometry	CS	1	f	
(0020,9308)	Apex Position	ApexPosition	FD	3	f	
(0020,9309)	Volume to Transducer Mapping Matrix	VolumeToTransducerMappingMatrix	FD	16	f	
(0020,930a)	Volume to Table Mapping Matrix	VolumeToTableMappingMatrix	FD	16	f	
(0020,930b)	Volume to Transducer Relationship	VolumeToTransducerRelationship	CS	1	f	
(0020,930c)	Patient Frame of Reference Source	PatientFrameOfReferenceSource	CS	1	f	
(0020,930d)	Temporal Position Time Offset	TemporalPositionTimeOffset	FD	1	f	
(0020,930e)	Plane Position (Volume) Sequence	PlanePositionVolumeSequence	SQ	1	f	
(0020,930f)	Plane Orientation (Volume) Sequence	PlaneOrientationVolumeSequence	SQ	1	f	
(0020,9310)	Temporal Position Sequence	TemporalPositionSequence	SQ	1	f	
(0020,9311)	Dimension Organization Type	DimensionOrganizationType	CS	1	f	
(0020,9312)	Volume Frame of Reference UID	VolumeFrameOfReferenceUID	UI	1	f	
(0020,9313)	Table Frame of Reference UID	TableFrameOfReferenceUID	UI	1	f	
(0020,9421)	Dimension Description Label	DimensionDescriptionLabel	LO	1	f	
(0020,9450)	Patient Orientation in Frame Sequence	PatientOrientationInFrameSequence	SQ	1	f	
(0020,9453)	Frame Label	FrameLabel	LO	1	f	
(0020,9518)	Acquisition Index	AcquisitionIndex	US	1-n	f	
(0020,9529)	Contributing SOP Instances Reference Sequence	ContributingSOPInstancesReferenceSequence	SQ	1	f	
(0020,9536)	Reconstruction Index	ReconstructionIndex	US	1	f	
(0022,0001)	Light Path Filter Pass-Through Wavelength	LightPathFilterPassThroughWavelength	US	1	f	
(0022,0002)	Light Path Filter Pass Band	LightPathFilterPassBand	US	2	f	
(0022,0003)	Image Path Filter Pass-Through Wavelength	ImagePathFilterPassThroughWavelength	US	1	f	
(0022,0004)	Image Path Filter Pass Band	ImagePathFilterPassBand	US	2	f	
(0022,0005)	Patient Eye Movement Commanded	PatientEyeMovementCommanded	CS	1	f	
(0022,0006)	Patient Eye Movement Command Code Sequence	PatientEyeMovementCommandCodeSequence	SQ	1	f	
(0022,0007)	Spherical Lens Power	SphericalLensPower	FL	1	f	
(0022,0008)	Cylinder Lens Power	CylinderLensPower	FL	1	f	
(0022,0009)	Cylinder Axis	CylinderAxis	FL	1	f	
(0022,000a)	Emmetropic Magnification	EmmetropicMagnification	FL	1	f	
(0022,000b)	Intra Ocular Pressure	IntraOcularPressure	FL	1	f	
(0022,000c)	Horizontal Field of View	HorizontalFieldOfView	FL	1	f	
(0022,000d)	Pupil Dilated	PupilDilated	CS	1	f	
(0022,000e)	Degree of Dilation	DegreeOfDilation	FL	1	f	
(0022,0010)	Stereo Baseline Angle	StereoBaselineAngle	FL	1	f	
(0022,0011)	Stereo Baseline Displacement	StereoBaselineDisplacement	FL	1	f	
(0022,0012)	Stereo Horizontal Pixel Offset	StereoHorizontalPixelOffset	FL	1	f	
(0022,0013)	Stereo Vertical Pixel Offset	StereoVerticalPixelOffset	FL	1	f	
(0022,0014)	Stereo Rotation	StereoRotation	FL	1	f	
(0022,0015)	Acquisition Device Type Code Sequence	AcquisitionDeviceTypeCodeSequence	SQ	1	f	
(0022,0016)	Illumination Type Code Sequence	IlluminationTypeCodeSequence	SQ	1	f	
(0022,0017)	Light Path Filter Type Stack Code Sequence	LightPathFilterTypeStackCodeSequence	SQ	1	f	
(0022,0018)	Image Path Filter Type Stack Code Sequence	ImagePathFilterTypeStackCodeSequence	SQ	1	f	
(0022,0019)	Lenses Code Sequence	LensesCodeSequence	SQ	1	f	
(0022,001a)	Channel Description Code Sequence	ChannelDescriptionCodeSequence	SQ	1	f	
(0022,001b)	Refractive State Sequence	RefractiveStateSequence	SQ	1	f	
(0022,001c)	Mydriatic Agent Code Sequence	MydriaticAgentCodeSequence	SQ	1	f	
(0022,001d)	Relative Image Position Code Sequence	RelativeImagePositionCodeSequence	SQ	1	f	
(0022,001e)	Camera Angle of View	CameraAngleOfView	FL	1	f	
(0022,0020)	Stereo Pairs Sequence	StereoPairsSequence	SQ	1	f	
(0022,0021)	Left Image Sequence	LeftImageSequence	SQ	1	f	
(0022,0022)	Right Image Sequence	RightImageSequence	SQ	1	f	
(0022,0028)	Stereo Pairs Present	StereoPairsPresent	CS	1	f	
(0022,0030)	Axial Length of the Eye	AxialLengthOfTheEye	FL	1	f	
(0022,0031)	Ophthalmic Frame Location Sequence	OphthalmicFrameLocationSequence	SQ	1	f	
(0022,0032)	Reference Coordinates	ReferenceCoordinates	FL	2-2n	f	
(0022,0035)	Depth Spatial Resolution	DepthSpatialResolution	FL	1	f	
(0022,0036)	Maximum Depth Distortion	MaximumDepthDistortion	FL	1	f	
(0022,0037)	Along-scan Spatial Resolution	AlongScanSpatialResolution	FL	1	f	
(0022,0038)	Maximum Along-scan Distortion	MaximumAlongScanDistortion	FL	1	f	
(0022,0039)	Ophthalmic Image Orientation	OphthalmicImageOrientation	CS	1	f	
(0022,0041)	Depth of Transverse Image	DepthOfTransverseImage	FL	1	f	
(0022,0042)	Mydriatic Agent Concentration Units Sequence	MydriaticAgentConcentrationUnitsSequence	SQ	1	f	
(0022,0048)	Across-scan Spatial Resolution	AcrossScanSpatialResolution	FL	1	f	
(0022,0049)	Maximum Across-scan Distortion	MaximumAcrossScanDistortion	FL	1	f	
(0022,004e)	Mydriatic Agent Concentration	MydriaticAgentConcentration	DS	1	f	
(0022,0055)	Illumination Wave Length	IlluminationWaveLength	FL	1	f	
(0022,0056)	Illumination Power	IlluminationPower	FL	1	f	
(0022,0057)	Illumination Bandwidth	IlluminationBandwidth	FL	1	f	
(0022,0058)	Mydriatic Agent Sequence	MydriaticAgentSequence	SQ	1	f	
(0022,1007)	Ophthalmic Axial Measurements Right Eye Sequence	OphthalmicAxialMeasurementsRightEyeSequence	SQ	1	f	
(0022,1008)	Ophthalmic Axial Measurements Left Eye Sequence	OphthalmicAxialMeasurementsLeftEyeSequence	SQ	1	f	
(0022,1009)	Ophthalmic Axial Measurements Device Type	OphthalmicAxialMeasurementsDeviceType	CS	1	f	
(0022,1010)	Ophthalmic Axial Length Measurements Type	OphthalmicAxialLengthMeasurementsType	CS	1	f	
(0022,1012)	Ophthalmic Axial Length Sequence	OphthalmicAxialLengthSequence	SQ	1	f	
(0022,1019)	Ophthalmic Axial Length	OphthalmicAxialLength	FL	1	f	
(0022,1024)	Lens Status Code Sequence	LensStatusCodeSequence	SQ	1	f	
(0022,1025)	Vitreous Status Code Sequence	VitreousStatusCodeSequence	SQ	1	f	
(0022,1028)	IOL Formula Code Sequence	IOLFormulaCodeSequence	SQ	1	f	
(0022,1029)	IOL Formula Detail	IOLFormulaDetail	LO	1	f	
(0022,1033)	Keratometer Index	KeratometerIndex	FL	1	f	
(0022,1035)	Source of Ophthalmic Axial Length Code Sequence	SourceOfOphthalmicAxialLengthCodeSequence	SQ	1	f	
(0022,1037)	Target Refraction	TargetRefraction	FL	1	f	
(0022,1039)	Refractive Procedure Occurred	RefractiveProcedureOccurred	CS	1	f	
(0022,1040)	Refractive Surgery Type Code Sequence	RefractiveSurgeryTypeCodeSequence	SQ	1	f	
(0022,1044)	Ophthalmic Ultrasound Method Code Sequence	OphthalmicUltrasoundMethodCodeSequence	SQ	1	f	
(0022,1050)	Ophthalmic Axial Length Measurements Sequence	OphthalmicAxialLengthMeasurementsSequence	SQ	1	f	
(0022,1053)	IOL Power	IOLPower	FL	1	f	
(0022,1054)	Predicted Refractive Error	PredictedRefractiveError	FL	1	f	
(0022,1059)	Ophthalmic Axial Length Velocity	OphthalmicAxialLengthVelocity	FL	1	f	
(0022,1065)	Lens Status Description	LensStatusDescription	LO	1	f	
(0022,1066)	Vitreous Status Description	VitreousStatusDescription	LO	1	f	
(0022,1090)	IOL Power Sequence	IOLPowerSequence	SQ	1	f	
(0022,1092)	Lens Constant Sequence	LensConstantSequence	SQ	1	f	
(0022,1093)	IOL Manufacturer	IOLManufacturer	LO	1	f	
(0022,1094)	Lens Constant Description	LensConstantDescription	LO	1	t	
(0022,1095)	Implant Name	ImplantName	LO	1	f	
(0022,1096)	Keratometry Measurement Type Code Sequence	KeratometryMeasurementTypeCodeSequence	SQ	1	f	
(0022,1097)	Implant Part Number	ImplantPartNumber	LO	1	f	
(0022,1100)	Referenced Ophthalmic Axial Measurements Sequence	ReferencedOphthalmicAxialMeasurementsSequence	SQ	1	f	
(0022,1101)	Ophthalmic Axial Length Measurements Segment Name Code Sequence	OphthalmicAxialLengthMeasurementsSegmentNameCodeSequence	SQ	1	f	
(0022,1103)	Refractive Error Before Refractive Surgery Code Sequence	RefractiveErrorBeforeRefractiveSurgeryCodeSequence	SQ	1	f	
(0022,1121)	IOL Power For Exact Emmetropia	IOLPowerForExactEmmetropia	FL	1	f	
(0022,1122)	IOL Power For Exact Target Refraction	IOLPowerForExactTargetRefraction	FL	1	f	
(0022,1125)	Anterior Chamber Depth Definition Code Sequence	AnteriorChamberDepthDefinitionCodeSequence	SQ	1	f	
(0022,1127)	Lens Thickness Sequence	LensThicknessSequence	SQ	1	f	
(0022,1128)	Anterior Chamber Depth Sequence	AnteriorChamberDepthSequence	SQ	1	f	
(0022,1130)	Lens Thickness	LensThickness	FL	1	f	
(0022,1131)	Anterior Chamber Depth	AnteriorChamberDepth	FL	1	f	
(0022,1132)	Source of Lens Thickness Data Code Sequence	SourceOfLensThicknessDataCodeSequence	SQ	1	f	
(0022,1133)	Source of Anterior Chamber Depth Data Code Sequence	SourceOfAnteriorChamberDepthDataCodeSequence	SQ	1	f	
(0022,1134)	Source of Refractive Measurements Sequence	SourceOfRefractiveMeasurementsSequence	SQ	1	f	
(0022,1135)	Source of Refractive Measurements Code Sequence	SourceOfRefractiveMeasurementsCodeSequence	SQ	1	f	
(0022,1140)	Ophthalmic Axial Length Measurement Modified	OphthalmicAxialLengthMeasurementModified	CS	1	f	
(0022,1150)	Ophthalmic Axial Length Data Source Code Sequence	OphthalmicAxialLengthDataSourceCodeSequence	SQ	1	f	
(0022,1153)	Ophthalmic Axial Length Acquisition Method Code Sequence	OphthalmicAxialLengthAcquisitionMethodCodeSequence	SQ	1	t	
(0022,1155)	Signal to Noise Ratio	SignalToNoiseRatio	FL	1	f	
(0022,1159)	Ophthalmic Axial Length Data Source Description	OphthalmicAxialLengthDataSourceDescription	LO	1	f	
(0022,1210)	Ophthalmic Axial Length Measurements Total Length Sequence	OphthalmicAxialLengthMeasurementsTotalLengthSequence	SQ	1	f	
(0022,1211)	Ophthalmic Axial Length Measurements Segmental Length Sequence	OphthalmicAxialLengthMeasurementsSegmentalLengthSequence	SQ	1	f	
(0022,1212)	Ophthalmic Axial Length Measurements Length Summation Sequence	OphthalmicAxialLengthMeasurementsLengthSummationSequence	SQ	1	f	
(0022,1220)	Ultrasound Ophthalmic Axial Length Measurements Sequence	UltrasoundOphthalmicAxialLengthMeasurementsSequence	SQ	1	f	
(0022,1225)	Optical Ophthalmic Axial Length Measurements Sequence	OpticalOphthalmicAxialLengthMeasurementsSequence	SQ	1	f	
(0022,1230)	Ultrasound Selected Ophthalmic Axial Length Sequence	UltrasoundSelectedOphthalmicAxialLengthSequence	SQ	1	f	
(0022,1250)	Ophthalmic Axial Length Selection Method Code Sequence	OphthalmicAxialLengthSelectionMethodCodeSequence	SQ	1	f	
(0022,1255)	Optical Selected Ophthalmic Axial Length Sequence	OpticalSelectedOphthalmicAxialLengthSequence	SQ	1	f	
(0022,1257)	Selected Segmental Ophthalmic Axial Length Sequence	SelectedSegmentalOphthalmicAxialLengthSequence	SQ	1	f	
(0024,0057)	Test Point Normals Data Flag	TestPointNormalsDataFlag	CS	1	f	
(0024,0058)	Test Point Normals Sequence	TestPointNormalsSequence	SQ	1	f	
(0022,1260)	Selected Total Ophthalmic Axial Length Sequence	SelectedTotalOphthalmicAxialLengthSequence	SQ	1	f	
(0022,1262)	Ophthalmic Axial Length Quality Metric Sequence	OphthalmicAxialLengthQualityMetricSequence	SQ	1	f	
(0022,1265)	Ophthalmic Axial Length Quality Metric Type Code Sequence	OphthalmicAxialLengthQualityMetricTypeCodeSequence	SQ	1	t	
(0022,1273)	Ophthalmic Axial Length Quality Metric Type Description	OphthalmicAxialLengthQualityMetricTypeDescription	LO	1	t	
(0022,1300)	Intraocular Lens Calculations Right Eye Sequence	IntraocularLensCalculationsRightEyeSequence	SQ	1	f	
(0022,1310)	Intraocular Lens Calculations Left Eye Sequence	IntraocularLensCalculationsLeftEyeSequence	SQ	1	f	
(0022,1330)	Referenced Ophthalmic Axial Length Measurement QC Image Sequence	ReferencedOphthalmicAxialLengthMeasurementQCImageSequence	SQ	1	f	
(0022,1415)	Ophthalmic Mapping Device Type	OphthalmicMappingDeviceType	CS	1	f	
(0022,1420)	Acquisition Method Code Sequence	AcquisitionMethodCodeSequence	SQ	1	f	
(0022,1423)	Acquisition Method Algorithm Sequence	AcquisitionMethodAlgorithmSequence	SQ	1	f	
(0022,1436)	Ophthalmic Thickness Map Type Code Sequence	OphthalmicThicknessMapTypeCodeSequence	SQ	1	f	
(0022,1443)	Ophthalmic Thickness Mapping Normals Sequence	OphthalmicThicknessMappingNormalsSequence	SQ	1	f	
(0022,1445)	Retinal Thickness Definition Code Sequence	RetinalThicknessDefinitionCodeSequence	SQ	1	f	
(0022,1450)	Pixel Value Mapping to Coded Concept Sequence	PixelValueMappingToCodedConceptSequence	SQ	1	f	
(0022,1452)	Mapped Pixel Value	MappedPixelValue	US or SS	1	f	
(0022,1454)	Pixel Value Mapping Explanation	PixelValueMappingExplanation	LO	1	f	
(0022,1458)	Ophthalmic Thickness Map Quality Threshold Sequence	OphthalmicThicknessMapQualityThresholdSequence	SQ	1	f	
(0022,1460)	Ophthalmic Thickness Map Threshold Quality Rating	OphthalmicThicknessMapThresholdQualityRating	FL	1	f	
(0022,1463)	Anatomic Structure Reference Point	AnatomicStructureReferencePoint	FL	2	f	
(0022,1465)	Registration to Localizer Sequence	RegistrationToLocalizerSequence	SQ	1	f	
(0022,1466)	Registered Localizer Units	RegisteredLocalizerUnits	CS	1	f	
(0022,1467)	Registered Localizer Top Left Hand Corner	RegisteredLocalizerTopLeftHandCorner	FL	2	f	
(0022,1468)	Registered Localizer Bottom Right Hand Corner	RegisteredLocalizerBottomRightHandCorner	FL	2	f	
(0022,1470)	Ophthalmic Thickness Map Quality Rating Sequence	OphthalmicThicknessMapQualityRatingSequence	SQ	1	f	
(0022,1472)	Relevant OPT Attributes Sequence	RelevantOPTAttributesSequence	SQ	1	f	
(0022,1512)	Transformation Method Code Sequence	TransformationMethodCodeSequence	SQ	1	f	
(0022,1513)	Transformation Algorithm Sequence	TransformationAlgorithmSequence	SQ	1	f	
(0022,1515)	Ophthalmic Axial Length Method	OphthalmicAxialLengthMethod	CS	1	f	
(0022,1517)	Ophthalmic FOV	OphthalmicFOV	FL	1	f	
(0022,1518)	Two Dimensional to Three Dimensional Map Sequence	TwoDimensionalToThreeDimensionalMapSequence	SQ	1	f	
(0022,1525)	Wide Field Ophthalmic Photography Quality Rating Sequence	WideFieldOphthalmicPhotographyQualityRatingSequence	SQ	1	f	
(0022,1526)	Wide Field Ophthalmic Photography Quality Threshold Sequence	WideFieldOphthalmicPhotographyQualityThresholdSequence	SQ	1	f	
(0022,1527)	Wide Field Ophthalmic Photography Threshold Quality Rating	WideFieldOphthalmicPhotographyThresholdQualityRating	FL	1	f	
(0022,1528)	X Coordinates Center Pixel View Angle	XCoordinatesCenterPixelViewAngle	FL	1	f	
(0022,1529)	Y Coordinates Center Pixel View Angle	YCoordinatesCenterPixelViewAngle	FL	1	f	
(0022,1530)	Number of Map Points	NumberOfMapPoints	UL	1	f	
(0022,1531)	Two Dimensional to Three Dimensional Map Data	TwoDimensionalToThreeDimensionalMapData	OF	1	f	
(0024,0010)	Visual Field Horizontal Extent	VisualFieldHorizontalExtent	FL	1	f	
(0024,0011)	Visual Field Vertical Extent	VisualFieldVerticalExtent	FL	1	f	
(0024,0012)	Visual Field Shape	VisualFieldShape	CS	1	f	
(0024,0016)	Screening Test Mode Code Sequence	ScreeningTestModeCodeSequence	SQ	1	f	
(0024,0018)	Maximum Stimulus Luminance	MaximumStimulusLuminance	FL	1	f	
(0024,0020)	Background Luminance	BackgroundLuminance	FL	1	f	
(0024,0021)	Stimulus Color Code Sequence	StimulusColorCodeSequence	SQ	1	f	
(0024,0024)	Background Illumination Color Code Sequence	BackgroundIlluminationColorCodeSequence	SQ	1	f	
(0024,0025)	Stimulus Area	StimulusArea	FL	1	f	
(0024,0028)	Stimulus Presentation Time	StimulusPresentationTime	FL	1	f	
(0024,0032)	Fixation Sequence	FixationSequence	SQ	1	f	
(0024,0033)	Fixation Monitoring Code Sequence	FixationMonitoringCodeSequence	SQ	1	f	
(0024,0034)	Visual Field Catch Trial Sequence	VisualFieldCatchTrialSequence	SQ	1	f	
(0024,0035)	Fixation Checked Quantity	FixationCheckedQuantity	US	1	f	
(0024,0036)	Patient Not Properly Fixated Quantity	PatientNotProperlyFixatedQuantity	US	1	f	
(0024,0037)	Presented Visual Stimuli Data Flag	PresentedVisualStimuliDataFlag	CS	1	f	
(0024,0038)	Number of Visual Stimuli	NumberOfVisualStimuli	US	1	f	
(0024,0039)	Excessive Fixation Losses Data Flag	ExcessiveFixationLossesDataFlag	CS	1	f	
(0024,0040)	Excessive Fixation Losses	ExcessiveFixationLosses	CS	1	f	
(0024,0042)	Stimuli Retesting Quantity	StimuliRetestingQuantity	US	1	f	
(0024,0044)	Comments on Patient's Performance of Visual Field	CommentsOnPatientPerformanceOfVisualField	LT	1	f	
(0024,0045)	False Negatives Estimate Flag	FalseNegativesEstimateFlag	CS	1	f	
(0024,0046)	False Negatives Estimate	FalseNegativesEstimate	FL	1	f	
(0024,0048)	Negative Catch Trials Quantity	NegativeCatchTrialsQuantity	US	1	f	
(0024,0050)	False Negatives Quantity	FalseNegativesQuantity	US	1	f	
(0024,0051)	Excessive False Negatives Data Flag	ExcessiveFalseNegativesDataFlag	CS	1	f	
(0024,0052)	Excessive False Negatives	ExcessiveFalseNegatives	CS	1	f	
(0024,0053)	False Positives Estimate Flag	FalsePositivesEstimateFlag	CS	1	f	
(0024,0054)	False Positives Estimate	FalsePositivesEstimate	FL	1	f	
(0024,0055)	Catch Trials Data Flag	CatchTrialsDataFlag	CS	1	f	
(0024,0056)	Positive Catch Trials Quantity	PositiveCatchTrialsQuantity	US	1	f	
(0024,0059)	Global Deviation Probability Normals Flag	GlobalDeviationProbabilityNormalsFlag	CS	1	f	
(0024,0060)	False Positives Quantity	FalsePositivesQuantity	US	1	f	
(0024,0061)	Excessive False Positives Data Flag	ExcessiveFalsePositivesDataFlag	CS	1	f	
(0024,0062)	Excessive False Positives	ExcessiveFalsePositives	CS	1	f	
(0024,0063)	Visual Field Test Normals Flag	VisualFieldTestNormalsFlag	CS	1	f	
(0024,0064)	Results Normals Sequence	ResultsNormalsSequence	SQ	1	f	
(0024,0065)	Age Corrected Sensitivity Deviation Algorithm Sequence	AgeCorrectedSensitivityDeviationAlgorithmSequence	SQ	1	f	
(0024,0066)	Global Deviation From Normal	GlobalDeviationFromNormal	FL	1	f	
(0024,0067)	Generalized Defect Sensitivity Deviation Algorithm Sequence	GeneralizedDefectSensitivityDeviationAlgorithmSequence	SQ	1	f	
(0024,0068)	Localized Deviation From Normal	LocalizedDeviationFromNormal	FL	1	f	
(0024,0069)	Patient Reliability Indicator	PatientReliabilityIndicator	LO	1	f	
(0024,0070)	Visual Field Mean Sensitivity	VisualFieldMeanSensitivity	FL	1	f	
(0024,0071)	Global Deviation Probability	GlobalDeviationProbability	FL	1	f	
(0024,0072)	Local Deviation Probability Normals Flag	LocalDeviationProbabilityNormalsFlag	CS	1	f	
(0024,0073)	Localized Deviation Probability	LocalizedDeviationProbability	FL	1	f	
(0024,0074)	Short Term Fluctuation Calculated	ShortTermFluctuationCalculated	CS	1	f	
(0024,0075)	Short Term Fluctuation	ShortTermFluctuation	FL	1	f	
(0024,0076)	Short Term Fluctuation Probability Calculated	ShortTermFluctuationProbabilityCalculated	CS	1	f	
(0024,0077)	Short Term Fluctuation Probability	ShortTermFluctuationProbability	FL	1	f	
(0024,0078)	Corrected Localized Deviation From Normal Calculated	CorrectedLocalizedDeviationFromNormalCalculated	CS	1	f	
(0024,0079)	Corrected Localized Deviation From Normal	CorrectedLocalizedDeviationFromNormal	FL	1	f	
(0024,0080)	Corrected Localized Deviation From Normal Probability Calculated	CorrectedLocalizedDeviationFromNormalProbabilityCalculated	CS	1	f	
(0024,0081)	Corrected Localized Deviation From Normal Probability	CorrectedLocalizedDeviationFromNormalProbability	FL	1	f	
(0024,0083)	Global Deviation Probability Sequence	GlobalDeviationProbabilitySequence	SQ	1	f	
(0024,0085)	Localized Deviation Probability Sequence	LocalizedDeviationProbabilitySequence	SQ	1	f	
(0024,0086)	Foveal Sensitivity Measured	FovealSensitivityMeasured	CS	1	f	
(0024,0087)	Foveal Sensitivity	FovealSensitivity	FL	1	f	
(0024,0088)	Visual Field Test Duration	VisualFieldTestDuration	FL	1	f	
(0024,0089)	Visual Field Test Point Sequence	VisualFieldTestPointSequence	SQ	1	f	
(0024,0090)	Visual Field Test Point X-Coordinate	VisualFieldTestPointXCoordinate	FL	1	f	
(0024,0091)	Visual Field Test Point Y-Coordinate	VisualFieldTestPointYCoordinate	FL	1	f	
(0024,0092)	Age Corrected Sensitivity Deviation Value	AgeCorrectedSensitivityDeviationValue	FL	1	f	
(0024,0093)	Stimulus Results	StimulusResults	CS	1	f	
(0024,0094)	Sensitivity Value	SensitivityValue	FL	1	f	
(0024,0095)	Retest Stimulus Seen	RetestStimulusSeen	CS	1	f	
(0024,0096)	Retest Sensitivity Value	RetestSensitivityValue	FL	1	f	
(0024,0097)	Visual Field Test Point Normals Sequence	VisualFieldTestPointNormalsSequence	SQ	1	f	
(0024,0098)	Quantified Defect	QuantifiedDefect	FL	1	f	
(0024,0100)	Age Corrected Sensitivity Deviation Probability Value	AgeCorrectedSensitivityDeviationProbabilityValue	FL	1	f	
(0024,0102)	Generalized Defect Corrected Sensitivity Deviation Flag	GeneralizedDefectCorrectedSensitivityDeviationFlag	CS	1	f	
(0024,0103)	Generalized Defect Corrected Sensitivity Deviation Value	GeneralizedDefectCorrectedSensitivityDeviationValue	FL	1	f	
(0024,0104)	Generalized Defect Corrected Sensitivity Deviation Probability Value	GeneralizedDefectCorrectedSensitivityDeviationProbabilityValue	FL	1	f	
(0024,0105)	Minimum Sensitivity Value	MinimumSensitivityValue	FL	1	f	
(0024,0106)	Blind Spot Localized	BlindSpotLocalized	CS	1	f	
(0024,0107)	Blind Spot X-Coordinate	BlindSpotXCoordinate	FL	1	f	
(0024,0108)	Blind Spot Y-Coordinate	BlindSpotYCoordinate	FL	1	f	
(0024,0110)	Visual Acuity Measurement Sequence	VisualAcuityMeasurementSequence	SQ	1	f	
(0024,0112)	Refractive Parameters Used on Patient Sequence	RefractiveParametersUsedOnPatientSequence	SQ	1	f	
(0024,0113)	Measurement Laterality	MeasurementLaterality	CS	1	f	
(0024,0114)	Ophthalmic Patient Clinical Information Left Eye Sequence	OphthalmicPatientClinicalInformationLeftEyeSequence	SQ	1	f	
(0024,0115)	Ophthalmic Patient Clinical Information Right Eye Sequence	OphthalmicPatientClinicalInformationRightEyeSequence	SQ	1	f	
(0024,0117)	Foveal Point Normative Data Flag	FovealPointNormativeDataFlag	CS	1	f	
(0024,0118)	Foveal Point Probability Value	FovealPointProbabilityValue	FL	1	f	
(0024,0120)	Screening Baseline Measured	ScreeningBaselineMeasured	CS	1	f	
(0024,0122)	Screening Baseline Measured Sequence	ScreeningBaselineMeasuredSequence	SQ	1	f	
(0024,0124)	Screening Baseline Type	ScreeningBaselineType	CS	1	f	
(0024,0126)	Screening Baseline Value	ScreeningBaselineValue	FL	1	f	
(0024,0202)	Algorithm Source	AlgorithmSource	LO	1	f	
(0024,0306)	Data Set Name	DataSetName	LO	1	f	
(0024,0307)	Data Set Version	DataSetVersion	LO	1	f	
(0024,0308)	Data Set Source	DataSetSource	LO	1	f	
(0024,0309)	Data Set Description	DataSetDescription	LO	1	f	
(0024,0317)	Visual Field Test Reliability Global Index Sequence	VisualFieldTestReliabilityGlobalIndexSequence	SQ	1	f	
(0024,0320)	Visual Field Global Results Index Sequence	VisualFieldGlobalResultsIndexSequence	SQ	1	f	
(0024,0325)	Data Observation Sequence	DataObservationSequence	SQ	1	f	
(0024,0338)	Index Normals Flag	IndexNormalsFlag	CS	1	f	
(0024,0341)	Index Probability	IndexProbability	FL	1	f	
(0024,0344)	Index Probability Sequence	IndexProbabilitySequence	SQ	1	f	
(0028,0002)	Samples per Pixel	SamplesPerPixel	US	1	f	
(0028,0003)	Samples per Pixel Used	SamplesPerPixelUsed	US	1	f	
(0028,0004)	Photometric Interpretation	PhotometricInterpretation	CS	1	f	
(0028,0005)	Image Dimensions	ImageDimensions	US	1	t	
(0028,0006)	Planar Configuration	PlanarConfiguration	US	1	f	
(0028,0008)	Number of Frames	NumberOfFrames	IS	1	f	
(0028,0009)	Frame Increment Pointer	FrameIncrementPointer	AT	1-n	f	
(0028,000a)	Frame Dimension Pointer	FrameDimensionPointer	AT	1-n	f	
(0028,0010)	Rows	Rows	US	1	f	
(0028,0011)	Columns	Columns	US	1	f	
(0028,0012)	Planes	Planes	US	1	t	
(0028,0014)	Ultrasound Color Data Present	UltrasoundColorDataPresent	US	1	f	
(0028,0030)	Pixel Spacing	PixelSpacing	DS	2	f	
(0028,0031)	Zoom Factor	ZoomFactor	DS	2	f	
(0028,0032)	Zoom Center	ZoomCenter	DS	2	f	
(0028,0034)	Pixel Aspect Ratio	PixelAspectRatio	IS	2	f	
(0028,0040)	Image Format	ImageFormat	CS	1	t	
(0028,0050)	Manipulated Image	ManipulatedImage	LO	1-n	t	
(0028,0051)	Corrected Image	CorrectedImage	CS	1-n	f	
(0028,005f)	Compression Recognition Code	CompressionRecognitionCode	LO	1	t	
(0028,0060)	Compression Code	CompressionCode	CS	1	t	
(0028,0061)	Compression Originator	CompressionOriginator	SH	1	t	
(0028,0062)	Compression Label	CompressionLabel	LO	1	t	
(0028,0063)	Compression Description	CompressionDescription	SH	1	t	
(0028,0065)	Compression Sequence	CompressionSequence	CS	1-n	t	
(0028,0066)	Compression Step Pointers	CompressionStepPointers	AT	1-n	t	
(0028,0068)	Repeat Interval	RepeatInterval	US	1	t	
(0028,0069)	Bits Grouped	BitsGrouped	US	1	t	
(0028,0070)	Perimeter Table	PerimeterTable	US	1-n	t	
(0028,0071)	Perimeter Value	PerimeterValue	US or SS	1	t	
(0028,0080)	Predictor Rows	PredictorRows	US	1	t	
(0028,0081)	Predictor Columns	PredictorColumns	US	1	t	
(0028,0082)	Predictor Constants	PredictorConstants	US	1-n	t	
(0028,0090)	Blocked Pixels	BlockedPixels	CS	1	t	
(0028,0091)	Block Rows	BlockRows	US	1	t	
(0028,0092)	Block Columns	BlockColumns	US	1	t	
(0028,0093)	Row Overlap	RowOverlap	US	1	t	
(0028,0094)	Column Overlap	ColumnOverlap	US	1	t	
(0028,0100)	Bits Allocated	BitsAllocated	US	1	f	
(0028,0101)	Bits Stored	BitsStored	US	1	f	
(0028,0102)	High Bit	HighBit	US	1	f	
(0028,0103)	Pixel Representation	PixelRepresentation	US	1	f	
(0028,0104)	Smallest Valid Pixel Value	SmallestValidPixelValue	US or SS	1	t	
(0028,0105)	Largest Valid Pixel Value	LargestValidPixelValue	US or SS	1	t	
(0028,0106)	Smallest Image Pixel Value	SmallestImagePixelValue	US or SS	1	f	
(0028,0107)	Largest Image Pixel Value	LargestImagePixelValue	US or SS	1	f	
(0028,0108)	Smallest Pixel Value in Series	SmallestPixelValueInSeries	US or SS	1	f	
(0028,0109)	Largest Pixel Value in Series	LargestPixelValueInSeries	US or SS	1	f	
(0028,0110)	Smallest Image Pixel Value in Plane	SmallestImagePixelValueInPlane	US or SS	1	t	
(0028,0111)	Largest Image Pixel Value in Plane	LargestImagePixelValueInPlane	US or SS	1	t	
(0028,0120)	Pixel Padding Value	PixelPaddingValue	US or SS	1	f	
(0028,0121)	Pixel Padding Range Limit	PixelPaddingRangeLimit	US or SS	1	f	
(0028,0122)	Float Pixel Padding Value	FloatPixelPaddingValue	FL	1	f	
(0028,0123)	Double Float Pixel Padding Value	DoubleFloatPixelPaddingValue	FD	1	f	
(0028,0124)	Float Pixel Padding Range Limit	FloatPixelPaddingRangeLimit	FL	1	f	
(0028,0125)	Double Float Pixel Padding Range Limit	DoubleFloatPixelPaddingRangeLimit	FD	1	f	
(0028,0200)	Image Location	ImageLocation	US	1	t	
(0028,0300)	Quality Control Image	QualityControlImage	CS	1	f	
(0028,0301)	Burned In Annotation	BurnedInAnnotation	CS	1	f	
(0028,0302)	Recognizable Visual Features	RecognizableVisualFeatures	CS	1	f	
(0028,0303)	Longitudinal Temporal Information Modified	LongitudinalTemporalInformationModified	CS	1	f	
(0028,0304)	Referenced Color Palette Instance UID	ReferencedColorPaletteInstanceUID	UI	1	f	
(0028,0400)	Transform Label	TransformLabel	LO	1	t	
(0028,0401)	Transform Version Number	TransformVersionNumber	LO	1	t	
(0028,0402)	Number of Transform Steps	NumberOfTransformSteps	US	1	t	
(0028,0403)	Sequence of Compressed Data	SequenceOfCompressedData	LO	1-n	t	
(0028,0404)	Details of Coefficients	DetailsOfCoefficients	AT	1-n	t	
(0028,04x0)	Rows For Nth Order Coefficients	RowsForNthOrderCoefficients	US	1	t	
(0028,04x1)	Columns For Nth Order Coefficients	ColumnsForNthOrderCoefficients	US	1	t	
(0028,04x2)	Coefficient Coding	CoefficientCoding	LO	1-n	t	
(0028,04x3)	Coefficient Coding Pointers	CoefficientCodingPointers	AT	1-n	t	
(0028,0700)	DCT Label	DCTLabel	LO	1	t	
(0028,0701)	Data Block Description	DataBlockDescription	CS	1-n	t	
(0028,0702)	Data Block	DataBlock	AT	1-n	t	
(0028,0710)	Normalization Factor Format	NormalizationFactorFormat	US	1	t	
(0028,0720)	Zonal Map Number Format	ZonalMapNumberFormat	US	1	t	
(0028,0721)	Zonal Map Location	ZonalMapLocation	AT	1-n	t	
(0028,0722)	Zonal Map Format	ZonalMapFormat	US	1	t	
(0028,0730)	Adaptive Map Format	AdaptiveMapFormat	US	1	t	
(0028,0740)	Code Number Format	CodeNumberFormat	US	1	t	
(0028,08x0)	Code Label	CodeLabel	CS	1-n	t	
(0028,08x2)	Number of Tables	NumberOfTables	US	1	t	
(0028,08x3)	Code Table Location	CodeTableLocation	AT	1-n	t	
(0028,08x4)	Bits For Code Word	BitsForCodeWord	US	1	t	
(0028,08x8)	Image Data Location	ImageDataLocation	AT	1-n	t	
(0028,0a02)	Pixel Spacing Calibration Type	PixelSpacingCalibrationType	CS	1	f	
(0028,0a04)	Pixel Spacing Calibration Description	PixelSpacingCalibrationDescription	LO	1	f	
(0028,1040)	Pixel Intensity Relationship	PixelIntensityRelationship	CS	1	f	
(0028,6120)	TID Offset	TIDOffset	SS	1	f	
(0028,1041)	Pixel Intensity Relationship Sign	PixelIntensityRelationshipSign	SS	1	f	
(0028,1050)	Window Center	WindowCenter	DS	1-n	f	
(0028,1051)	Window Width	WindowWidth	DS	1-n	f	
(0028,1052)	Rescale Intercept	RescaleIntercept	DS	1	f	
(0028,1053)	Rescale Slope	RescaleSlope	DS	1	f	
(0028,1054)	Rescale Type	RescaleType	LO	1	f	
(0028,1055)	Window Center & Width Explanation	WindowCenterWidthExplanation	LO	1-n	f	
(0028,1056)	VOI LUT Function	VOILUTFunction	CS	1	f	
(0028,1080)	Gray Scale	GrayScale	CS	1	t	
(0028,1090)	Recommended Viewing Mode	RecommendedViewingMode	CS	1	f	
(0028,1100)	Gray Lookup Table Descriptor	GrayLookupTableDescriptor	US or SS	3	t	
(0028,1101)	Red Palette Color Lookup Table Descriptor	RedPaletteColorLookupTableDescriptor	US or SS	3	f	
(0028,1102)	Green Palette Color Lookup Table Descriptor	GreenPaletteColorLookupTableDescriptor	US or SS	3	f	
(0028,1103)	Blue Palette Color Lookup Table Descriptor	BluePaletteColorLookupTableDescriptor	US or SS	3	f	
(0028,1104)	Alpha Palette Color Lookup Table Descriptor	AlphaPaletteColorLookupTableDescriptor	US	3	f	
(0028,1111)	Large Red Palette Color Lookup Table Descriptor	LargeRedPaletteColorLookupTableDescriptor	US or SS	4	t	
(0028,1112)	Large Green Palette Color Lookup Table Descriptor	LargeGreenPaletteColorLookupTableDescriptor	US or SS	4	t	
(0028,1113)	Large Blue Palette Color Lookup Table Descriptor	LargeBluePaletteColorLookupTableDescriptor	US or SS	4	t	
(0028,1199)	Palette Color Lookup Table UID	PaletteColorLookupTableUID	UI	1	f	
(0028,1200)	Gray Lookup Table Data	GrayLookupTableData	US or SS or OW	1-n or 1	t	
(0028,1201)	Red Palette Color Lookup Table Data	RedPaletteColorLookupTableData	OW	1	f	
(0028,1202)	Green Palette Color Lookup Table Data	GreenPaletteColorLookupTableData	OW	1	f	
(0028,1203)	Blue Palette Color Lookup Table Data	BluePaletteColorLookupTableData	OW	1	f	
(0028,1204)	Alpha Palette Color Lookup Table Data	AlphaPaletteColorLookupTableData	OW	1	f	
(0028,1211)	Large Red Palette Color Lookup Table Data	LargeRedPaletteColorLookupTableData	OW	1	t	
(0028,1212)	Large Green Palette Color Lookup Table Data	LargeGreenPaletteColorLookupTableData	OW	1	t	
(0028,1213)	Large Blue Palette Color Lookup Table Data	LargeBluePaletteColorLookupTableData	OW	1	t	
(0028,1214)	Large Palette Color Lookup Table UID	LargePaletteColorLookupTableUID	UI	1	t	
(0028,1221)	Segmented Red Palette Color Lookup Table Data	SegmentedRedPaletteColorLookupTableData	OW	1	f	
(0028,1222)	Segmented Green Palette Color Lookup Table Data	SegmentedGreenPaletteColorLookupTableData	OW	1	f	
(0028,1223)	Segmented Blue Palette Color Lookup Table Data	SegmentedBluePaletteColorLookupTableData	OW	1	f	
(0028,1224)	Segmented Alpha Palette Color Lookup Table Data	SegmentedAlphaPaletteColorLookupTableData	OW	1	f	
(0028,1300)	Breast Implant Present	BreastImplantPresent	CS	1	f	
(0028,1350)	Partial View	PartialView	CS	1	f	
(0028,1351)	Partial View Description	PartialViewDescription	ST	1	f	
(0028,1352)	Partial View Code Sequence	PartialViewCodeSequence	SQ	1	f	
(0028,135a)	Spatial Locations Preserved	SpatialLocationsPreserved	CS	1	f	
(0028,1401)	Data Frame Assignment Sequence	DataFrameAssignmentSequence	SQ	1	f	
(0028,1402)	Data Path Assignment	DataPathAssignment	CS	1	f	
(0028,1403)	Bits Mapped to Color Lookup Table	BitsMappedToColorLookupTable	US	1	f	
(0028,1404)	Blending LUT 1 Sequence	BlendingLUT1Sequence	SQ	1	f	
(0028,1405)	Blending LUT 1 Transfer Function	BlendingLUT1TransferFunction	CS	1	f	
(0028,1406)	Blending Weight Constant	BlendingWeightConstant	FD	1	f	
(0028,1407)	Blending Lookup Table Descriptor	BlendingLookupTableDescriptor	US	3	f	
(0028,1408)	Blending Lookup Table Data	BlendingLookupTableData	OW	1	f	
(0028,140b)	Enhanced Palette Color Lookup Table Sequence	EnhancedPaletteColorLookupTableSequence	SQ	1	f	
(0028,140c)	Blending LUT 2 Sequence	BlendingLUT2Sequence	SQ	1	f	
(0028,140d)	Blending LUT 2 Transfer Function	BlendingLUT2TransferFunction	CS	1	f	
(0028,140e)	Data Path ID	DataPathID	CS	1	f	
(0028,140f)	RGB LUT Transfer Function	RGBLUTTransferFunction	CS	1	f	
(0028,1410)	Alpha LUT Transfer Function	AlphaLUTTransferFunction	CS	1	f	
(0028,2000)	ICC Profile	ICCProfile	OB	1	f	
(0028,2002)	Color Space	ColorSpace	CS	1	f	
(0028,2110)	Lossy Image Compression	LossyImageCompression	CS	1	f	
(0028,2112)	Lossy Image Compression Ratio	LossyImageCompressionRatio	DS	1-n	f	
(0028,2114)	Lossy Image Compression Method	LossyImageCompressionMethod	CS	1-n	f	
(0028,3000)	Modality LUT Sequence	ModalityLUTSequence	SQ	1	f	
(0028,3002)	LUT Descriptor	LUTDescriptor	US or SS	3	f	
(0028,3003)	LUT Explanation	LUTExplanation	LO	1	f	
(0028,3004)	Modality LUT Type	ModalityLUTType	LO	1	f	
(0028,3006)	LUT Data	LUTData	US or OW	1-n or 1	f	
(0028,3010)	VOI LUT Sequence	VOILUTSequence	SQ	1	f	
(0028,3110)	Softcopy VOI LUT Sequence	SoftcopyVOILUTSequence	SQ	1	f	
(0028,4000)	Image Presentation Comments	ImagePresentationComments	LT	1	t	
(0028,5000)	Bi-Plane Acquisition Sequence	BiPlaneAcquisitionSequence	SQ	1	t	
(0028,6010)	Representative Frame Number	RepresentativeFrameNumber	US	1	f	
(0028,6020)	Frame Numbers of Interest (FOI)	FrameNumbersOfInterest	US	1-n	f	
(0028,6022)	Frame of Interest Description	FrameOfInterestDescription	LO	1-n	f	
(0028,6023)	Frame of Interest Type	FrameOfInterestType	CS	1-n	f	
(0028,6030)	Mask Pointer(s)	MaskPointers	US	1-n	t	
(0028,6040)	R Wave Pointer	RWavePointer	US	1-n	f	
(0028,6100)	Mask Subtraction Sequence	MaskSubtractionSequence	SQ	1	f	
(0028,6101)	Mask Operation	MaskOperation	CS	1	f	
(0028,6102)	Applicable Frame Range	ApplicableFrameRange	US	2-2n	f	
(0028,6110)	Mask Frame Numbers	MaskFrameNumbers	US	1-n	f	
(0028,6112)	Contrast Frame Averaging	ContrastFrameAveraging	US	1	f	
(0028,6114)	Mask Sub-pixel Shift	MaskSubPixelShift	FL	2	f	
(0028,6190)	Mask Operation Explanation	MaskOperationExplanation	ST	1	f	
(0028,7000)	Equipment Administrator Sequence	EquipmentAdministratorSequence	SQ	1	f	
(0028,7001)	Number of Display Subsystems	NumberOfDisplaySubsystems	US	1	f	
(0028,7002)	Current Configuration ID	CurrentConfigurationID	US	1	f	
(0028,7003)	Display Subsystem ID	DisplaySubsystemID	US	1	f	
(0028,7004)	Display Subsystem Name	DisplaySubsystemName	SH	1	f	
(0028,7005)	Display Subsystem Description	DisplaySubsystemDescription	LO	1	f	
(0028,7006)	System Status	SystemStatus	CS	1	f	
(0028,7007)	System Status Comment	SystemStatusComment	LO	1	f	
(0028,7008)	Target Luminance Characteristics Sequence	TargetLuminanceCharacteristicsSequence	SQ	1	f	
(0028,7009)	Luminance Characteristics ID	LuminanceCharacteristicsID	US	1	f	
(0028,700a)	Display Subsystem Configuration Sequence	DisplaySubsystemConfigurationSequence	SQ	1	f	
(0028,700b)	Configuration ID	ConfigurationID	US	1	f	
(0028,700c)	Configuration Name	ConfigurationName	SH	1	f	
(0028,700d)	Configuration Description	ConfigurationDescription	LO	1	f	
(0028,700e)	Referenced Target Luminance Characteristics ID	ReferencedTargetLuminanceCharacteristicsID	US	1	f	
(0028,700f)	QA Results Sequence	QAResultsSequence	SQ	1	f	
(0028,7010)	Display Subsystem QA Results Sequence	DisplaySubsystemQAResultsSequence	SQ	1	f	
(0028,7011)	Configuration QA Results Sequence	ConfigurationQAResultsSequence	SQ	1	f	
(0028,7012)	Measurement Equipment Sequence	MeasurementEquipmentSequence	SQ	1	f	
(0028,7013)	Measurement Functions	MeasurementFunctions	CS	1-n	f	
(0028,7014)	Measurement Equipment Type	MeasurementEquipmentType	CS	1	f	
(0028,7015)	Visual Evaluation Result Sequence	VisualEvaluationResultSequence	SQ	1	f	
(0028,7016)	Display Calibration Result Sequence	DisplayCalibrationResultSequence	SQ	1	f	
(0028,7017)	DDL Value	DDLValue	US	1	f	
(0028,7018)	CIExy White Point	CIExyWhitePoint	FL	2	f	
(0028,7019)	Display Function Type	DisplayFunctionType	CS	1	f	
(0028,701a)	Gamma Value	GammaValue	FL	1	f	
(0028,701b)	Number of Luminance Points	NumberOfLuminancePoints	US	1	f	
(0028,701c)	Luminance Response Sequence	LuminanceResponseSequence	SQ	1	f	
(0028,701d)	Target Minimum Luminance	TargetMinimumLuminance	FL	1	f	
(0028,701e)	Target Maximum Luminance	TargetMaximumLuminance	FL	1	f	
(0028,701f)	Luminance Value	LuminanceValue	FL	1	f	
(0028,7020)	Luminance Response Description	LuminanceResponseDescription	LO	1	f	
(0028,7021)	White Point Flag	WhitePointFlag	CS	1	f	
(0028,7022)	Display Device Type Code Sequence	DisplayDeviceTypeCodeSequence	SQ	1	f	
(0028,7023)	Display Subsystem Sequence	DisplaySubsystemSequence	SQ	1	f	
(0028,7024)	Luminance Result Sequence	LuminanceResultSequence	SQ	1	f	
(0028,7025)	Ambient Light Value Source	AmbientLightValueSource	CS	1	f	
(0028,7026)	Measured Characteristics	MeasuredCharacteristics	CS	1-n	f	
(0028,7027)	Luminance Uniformity Result Sequence	LuminanceUniformityResultSequence	SQ	1	f	
(0028,7028)	Visual Evaluation Test Sequence	VisualEvaluationTestSequence	SQ	1	f	
(0028,7029)	Test Result	TestResult	CS	1	f	
(0028,702a)	Test Result Comment	TestResultComment	LO	1	f	
(0028,702b)	Test Image Validation	TestImageValidation	CS	1	f	
(0028,702c)	Test Pattern Code Sequence	TestPatternCodeSequence	SQ	1	f	
(0028,702d)	Measurement Pattern Code Sequence	MeasurementPatternCodeSequence	SQ	1	f	
(0028,702e)	Visual Evaluation Method Code Sequence	VisualEvaluationMethodCodeSequence	SQ	1	f	
(0028,7fe0)	Pixel Data Provider URL	PixelDataProviderURL	UR	1	f	
(0028,9001)	Data Point Rows	DataPointRows	UL	1	f	
(0028,9002)	Data Point Columns	DataPointColumns	UL	1	f	
(0028,9003)	Signal Domain Columns	SignalDomainColumns	CS	1	f	
(0028,9099)	Largest Monochrome Pixel Value	LargestMonochromePixelValue	US	1	t	
(0028,9108)	Data Representation	DataRepresentation	CS	1	f	
(0028,9110)	Pixel Measures Sequence	PixelMeasuresSequence	SQ	1	f	
(0028,9132)	Frame VOI LUT Sequence	FrameVOILUTSequence	SQ	1	f	
(0028,9145)	Pixel Value Transformation Sequence	PixelValueTransformationSequence	SQ	1	f	
(0028,9235)	Signal Domain Rows	SignalDomainRows	CS	1	f	
(0028,9411)	Display Filter Percentage	DisplayFilterPercentage	FL	1	f	
(0028,9415)	Frame Pixel Shift Sequence	FramePixelShiftSequence	SQ	1	f	
(0028,9416)	Subtraction Item ID	SubtractionItemID	US	1	f	
(0028,9422)	Pixel Intensity Relationship LUT Sequence	PixelIntensityRelationshipLUTSequence	SQ	1	f	
(0028,9443)	Frame Pixel Data Properties Sequence	FramePixelDataPropertiesSequence	SQ	1	f	
(0028,9444)	Geometrical Properties	GeometricalProperties	CS	1	f	
(0028,9445)	Geometric Maximum Distortion	GeometricMaximumDistortion	FL	1	f	
(0028,9446)	Image Processing Applied	ImageProcessingApplied	CS	1-n	f	
(0028,9454)	Mask Selection Mode	MaskSelectionMode	CS	1	f	
(0028,9474)	LUT Function	LUTFunction	CS	1	f	
(0028,9478)	Mask Visibility Percentage	MaskVisibilityPercentage	FL	1	f	
(0028,9501)	Pixel Shift Sequence	PixelShiftSequence	SQ	1	f	
(0028,9502)	Region Pixel Shift Sequence	RegionPixelShiftSequence	SQ	1	f	
(0028,9503)	Vertices of the Region	VerticesOfTheRegion	SS	2-2n	f	
(0028,9505)	Multi-frame Presentation Sequence	MultiFramePresentationSequence	SQ	1	f	
(0028,9506)	Pixel Shift Frame Range	PixelShiftFrameRange	US	2-2n	f	
(0028,9507)	LUT Frame Range	LUTFrameRange	US	2-2n	f	
(0028,9520)	Image to Equipment Mapping Matrix	ImageToEquipmentMappingMatrix	DS	16	f	
(0028,9537)	Equipment Coordinate System Identification	EquipmentCoordinateSystemIdentification	CS	1	f	
(0032,000a)	Study Status ID	StudyStatusID	CS	1	t	
(0032,000c)	Study Priority ID	StudyPriorityID	CS	1	t	
(0032,0012)	Study ID Issuer	StudyIDIssuer	LO	1	t	
(0032,0032)	Study Verified Date	StudyVerifiedDate	DA	1	t	
(0032,0033)	Study Verified Time	StudyVerifiedTime	TM	1	t	
(0032,0034)	Study Read Date	StudyReadDate	DA	1	t	
(0032,0035)	Study Read Time	StudyReadTime	TM	1	t	
(0032,1000)	Scheduled Study Start Date	ScheduledStudyStartDate	DA	1	t	
(0032,1001)	Scheduled Study Start Time	ScheduledStudyStartTime	TM	1	t	
(0032,1010)	Scheduled Study Stop Date	ScheduledStudyStopDate	DA	1	t	
(0032,1011)	Scheduled Study Stop Time	ScheduledStudyStopTime	TM	1	t	
(0032,1020)	Scheduled Study Location	ScheduledStudyLocation	LO	1	t	
(0032,1021)	Scheduled Study Location AE Title	ScheduledStudyLocationAETitle	AE	1-n	t	
(0032,1030)	Reason for Study	ReasonForStudy	LO	1	t	
(0032,1031)	Requesting Physician Identification Sequence	RequestingPhysicianIdentificationSequence	SQ	1	f	
(0032,1032)	Requesting Physician	RequestingPhysician	PN	1	f	
(0032,1033)	Requesting Service	RequestingService	LO	1	f	
(0032,1034)	Requesting Service Code Sequence	RequestingServiceCodeSequence	SQ	1	f	
(0032,1040)	Study Arrival Date	StudyArrivalDate	DA	1	t	
(0032,1041)	Study Arrival Time	StudyArrivalTime	TM	1	t	
(0032,1050)	Study Completion Date	StudyCompletionDate	DA	1	t	
(0032,1051)	Study Completion Time	StudyCompletionTime	TM	1	t	
(0032,1055)	Study Component Status ID	StudyComponentStatusID	CS	1	t	
(0032,1060)	Requested Procedure Description	RequestedProcedureDescription	LO	1	f	
(0032,1064)	Requested Procedure Code Sequence	RequestedProcedureCodeSequence	SQ	1	f	
(0032,1070)	Requested Contrast Agent	RequestedContrastAgent	LO	1	f	
(0032,4000)	Study Comments	StudyComments	LT	1	t	
(0038,0004)	Referenced Patient Alias Sequence	ReferencedPatientAliasSequence	SQ	1	f	
(0038,0008)	Visit Status ID	VisitStatusID	CS	1	f	
(0038,0010)	Admission ID	AdmissionID	LO	1	f	
(0038,0011)	Issuer of Admission ID	IssuerOfAdmissionID	LO	1	t	
(0038,0014)	Issuer of Admission ID Sequence	IssuerOfAdmissionIDSequence	SQ	1	f	
(0038,0016)	Route of Admissions	RouteOfAdmissions	LO	1	f	
(0038,001a)	Scheduled Admission Date	ScheduledAdmissionDate	DA	1	t	
(0038,001b)	Scheduled Admission Time	ScheduledAdmissionTime	TM	1	t	
(0038,001c)	Scheduled Discharge Date	ScheduledDischargeDate	DA	1	t	
(0038,001d)	Scheduled Discharge Time	ScheduledDischargeTime	TM	1	t	
(0038,001e)	Scheduled Patient Institution Residence	ScheduledPatientInstitutionResidence	LO	1	t	
(0038,0020)	Admitting Date	AdmittingDate	DA	1	f	
(0038,0021)	Admitting Time	AdmittingTime	TM	1	f	
(0038,0030)	Discharge Date	DischargeDate	DA	1	t	
(0038,0032)	Discharge Time	DischargeTime	TM	1	t	
(0038,0040)	Discharge Diagnosis Description	DischargeDiagnosisDescription	LO	1	t	
(0038,0044)	Discharge Diagnosis Code Sequence	DischargeDiagnosisCodeSequence	SQ	1	t	
(0038,0050)	Special Needs	SpecialNeeds	LO	1	f	
(0038,0060)	Service Episode ID	ServiceEpisodeID	LO	1	f	
(0038,0061)	Issuer of Service Episode ID	IssuerOfServiceEpisodeID	LO	1	t	
(0038,0062)	Service Episode Description	ServiceEpisodeDescription	LO	1	f	
(0038,0064)	Issuer of Service Episode ID Sequence	IssuerOfServiceEpisodeIDSequence	SQ	1	f	
(0038,0100)	Pertinent Documents Sequence	PertinentDocumentsSequence	SQ	1	f	
(0038,0101)	Pertinent Resources Sequence	PertinentResourcesSequence	SQ	1	f	
(0038,0102)	Resource Description	ResourceDescription	LO	1	f	
(0038,0300)	Current Patient Location	CurrentPatientLocation	LO	1	f	
(0038,0400)	Patient's Institution Residence	PatientInstitutionResidence	LO	1	f	
(0038,0500)	Patient State	PatientState	LO	1	f	
(0038,0502)	Patient Clinical Trial Participation Sequence	PatientClinicalTrialParticipationSequence	SQ	1	f	
(0038,4000)	Visit Comments	VisitComments	LT	1	f	
(003a,0004)	Waveform Originality	WaveformOriginality	CS	1	f	
(003a,0005)	Number of Waveform Channels	NumberOfWaveformChannels	US	1	f	
(003a,0010)	Number of Waveform Samples	NumberOfWaveformSamples	UL	1	f	
(003a,001a)	Sampling Frequency	SamplingFrequency	DS	1	f	
(003a,0020)	Multiplex Group Label	MultiplexGroupLabel	SH	1	f	
(003a,0200)	Channel Definition Sequence	ChannelDefinitionSequence	SQ	1	f	
(003a,0202)	Waveform Channel Number	WaveformChannelNumber	IS	1	f	
(003a,0203)	Channel Label	ChannelLabel	SH	1	f	
(003a,0205)	Channel Status	ChannelStatus	CS	1-n	f	
(003a,0208)	Channel Source Sequence	ChannelSourceSequence	SQ	1	f	
(003a,0209)	Channel Source Modifiers Sequence	ChannelSourceModifiersSequence	SQ	1	f	
(003a,020a)	Source Waveform Sequence	SourceWaveformSequence	SQ	1	f	
(003a,020c)	Channel Derivation Description	ChannelDerivationDescription	LO	1	f	
(003a,0210)	Channel Sensitivity	ChannelSensitivity	DS	1	f	
(003a,0211)	Channel Sensitivity Units Sequence	ChannelSensitivityUnitsSequence	SQ	1	f	
(003a,0212)	Channel Sensitivity Correction Factor	ChannelSensitivityCorrectionFactor	DS	1	f	
(003a,0213)	Channel Baseline	ChannelBaseline	DS	1	f	
(003a,0214)	Channel Time Skew	ChannelTimeSkew	DS	1	f	
(003a,0215)	Channel Sample Skew	ChannelSampleSkew	DS	1	f	
(003a,0218)	Channel Offset	ChannelOffset	DS	1	f	
(003a,021a)	Waveform Bits Stored	WaveformBitsStored	US	1	f	
(003a,0220)	Filter Low Frequency	FilterLowFrequency	DS	1	f	
(003a,0221)	Filter High Frequency	FilterHighFrequency	DS	1	f	
(003a,0222)	Notch Filter Frequency	NotchFilterFrequency	DS	1	f	
(003a,0223)	Notch Filter Bandwidth	NotchFilterBandwidth	DS	1	f	
(003a,0230)	Waveform Data Display Scale	WaveformDataDisplayScale	FL	1	f	
(003a,0231)	Waveform Display Background CIELab Value	WaveformDisplayBackgroundCIELabValue	US	3	f	
(003a,0240)	Waveform Presentation Group Sequence	WaveformPresentationGroupSequence	SQ	1	f	
(003a,0241)	Presentation Group Number	PresentationGroupNumber	US	1	f	
(003a,0242)	Channel Display Sequence	ChannelDisplaySequence	SQ	1	f	
(003a,0244)	Channel Recommended Display CIELab Value	ChannelRecommendedDisplayCIELabValue	US	3	f	
(003a,0245)	Channel Position	ChannelPosition	FL	1	f	
(003a,0246)	Display Shading Flag	DisplayShadingFlag	CS	1	f	
(003a,0247)	Fractional Channel Display Scale	FractionalChannelDisplayScale	FL	1	f	
(003a,0248)	Absolute Channel Display Scale	AbsoluteChannelDisplayScale	FL	1	f	
(003a,0300)	Multiplexed Audio Channels Description Code Sequence	MultiplexedAudioChannelsDescriptionCodeSequence	SQ	1	f	
(003a,0301)	Channel Identification Code	ChannelIdentificationCode	IS	1	f	
(003a,0302)	Channel Mode	ChannelMode	CS	1	f	
(0040,0001)	Scheduled Station AE Title	ScheduledStationAETitle	AE	1-n	f	
(0040,0002)	Scheduled Procedure Step Start Date	ScheduledProcedureStepStartDate	DA	1	f	
(0040,0003)	Scheduled Procedure Step Start Time	ScheduledProcedureStepStartTime	TM	1	f	
(0040,0004)	Scheduled Procedure Step End Date	ScheduledProcedureStepEndDate	DA	1	f	
(0040,0005)	Scheduled Procedure Step End Time	ScheduledProcedureStepEndTime	TM	1	f	
(0040,0006)	Scheduled Performing Physician's Name	ScheduledPerformingPhysicianName	PN	1	f	
(0040,0007)	Scheduled Procedure Step Description	ScheduledProcedureStepDescription	LO	1	f	
(0040,0008)	Scheduled Protocol Code Sequence	ScheduledProtocolCodeSequence	SQ	1	f	
(0040,0009)	Scheduled Procedure Step ID	ScheduledProcedureStepID	SH	1	f	
(0040,000a)	Stage Code Sequence	StageCodeSequence	SQ	1	f	
(0040,000b)	Scheduled Performing Physician Identification Sequence	ScheduledPerformingPhysicianIdentificationSequence	SQ	1	f	
(0040,0010)	Scheduled Station Name	ScheduledStationName	SH	1-n	f	
(0040,0011)	Scheduled Procedure Step Location	ScheduledProcedureStepLocation	SH	1	f	
(0040,0012)	Pre-Medication	PreMedication	LO	1	f	
(0040,0020)	Scheduled Procedure Step Status	ScheduledProcedureStepStatus	CS	1	f	
(0040,0026)	Order Placer Identifier Sequence	OrderPlacerIdentifierSequence	SQ	1	f	
(0040,0027)	Order Filler Identifier Sequence	OrderFillerIdentifierSequence	SQ	1	f	
(0040,0031)	Local Namespace Entity ID	LocalNamespaceEntityID	UT	1	f	
(0040,0032)	Universal Entity ID	UniversalEntityID	UT	1	f	
(0040,0033)	Universal Entity ID Type	UniversalEntityIDType	CS	1	f	
(0040,0035)	Identifier Type Code	IdentifierTypeCode	CS	1	f	
(0040,0036)	Assigning Facility Sequence	AssigningFacilitySequence	SQ	1	f	
(0040,0039)	Assigning Jurisdiction Code Sequence	AssigningJurisdictionCodeSequence	SQ	1	f	
(0040,003a)	Assigning Agency or Department Code Sequence	AssigningAgencyOrDepartmentCodeSequence	SQ	1	f	
(0040,0100)	Scheduled Procedure Step Sequence	ScheduledProcedureStepSequence	SQ	1	f	
(0040,0220)	Referenced Non-Image Composite SOP Instance Sequence	ReferencedNonImageCompositeSOPInstanceSequence	SQ	1	f	
(0040,0241)	Performed Station AE Title	PerformedStationAETitle	AE	1	f	
(0040,0242)	Performed Station Name	PerformedStationName	SH	1	f	
(0040,0243)	Performed Location	PerformedLocation	SH	1	f	
(0040,0244)	Performed Procedure Step Start Date	PerformedProcedureStepStartDate	DA	1	f	
(0040,0245)	Performed Procedure Step Start Time	PerformedProcedureStepStartTime	TM	1	f	
(0040,0250)	Performed Procedure Step End Date	PerformedProcedureStepEndDate	DA	1	f	
(0040,0251)	Performed Procedure Step End Time	PerformedProcedureStepEndTime	TM	1	f	
(0040,0252)	Performed Procedure Step Status	PerformedProcedureStepStatus	CS	1	f	
(0040,0253)	Performed Procedure Step ID	PerformedProcedureStepID	SH	1	f	
(0040,0254)	Performed Procedure Step Description	PerformedProcedureStepDescription	LO	1	f	
(0040,0255)	Performed Procedure Type Description	PerformedProcedureTypeDescription	LO	1	f	
(0040,0260)	Performed Protocol Code Sequence	PerformedProtocolCodeSequence	SQ	1	f	
(0040,0261)	Performed Protocol Type	PerformedProtocolType	CS	1	f	
(0040,0270)	Scheduled Step Attributes Sequence	ScheduledStepAttributesSequence	SQ	1	f	
(0040,0275)	Request Attributes Sequence	RequestAttributesSequence	SQ	1	f	
(0040,0280)	Comments on the Performed Procedure Step	CommentsOnThePerformedProcedureStep	ST	1	f	
(0040,0281)	Performed Procedure Step Discontinuation Reason Code Sequence	PerformedProcedureStepDiscontinuationReasonCodeSequence	SQ	1	f	
(0040,0293)	Quantity Sequence	QuantitySequence	SQ	1	f	
(0040,0294)	Quantity	Quantity	DS	1	f	
(0040,0295)	Measuring Units Sequence	MeasuringUnitsSequence	SQ	1	f	
(0040,0296)	Billing Item Sequence	BillingItemSequence	SQ	1	f	
(0040,0300)	Total Time of Fluoroscopy	TotalTimeOfFluoroscopy	US	1	f	
(0040,0301)	Total Number of Exposures	TotalNumberOfExposures	US	1	f	
(0040,0302)	Entrance Dose	EntranceDose	US	1	f	
(0040,0303)	Exposed Area	ExposedArea	US	1-2	f	
(0040,0306)	Distance Source to Entrance	DistanceSourceToEntrance	DS	1	f	
(0040,0307)	Distance Source to Support	DistanceSourceToSupport	DS	1	t	
(0040,030e)	Exposure Dose Sequence	ExposureDoseSequence	SQ	1	f	
(0040,0310)	Comments on Radiation Dose	CommentsOnRadiationDose	ST	1	f	
(0040,0312)	X-Ray Output	XRayOutput	DS	1	f	
(0040,0314)	Half Value Layer	HalfValueLayer	DS	1	f	
(0040,0316)	Organ Dose	OrganDose	DS	1	f	
(0040,0318)	Organ Exposed	OrganExposed	CS	1	f	
(0040,0320)	Billing Procedure Step Sequence	BillingProcedureStepSequence	SQ	1	f	
(0040,0321)	Film Consumption Sequence	FilmConsumptionSequence	SQ	1	f	
(0040,0324)	Billing Supplies and Devices Sequence	BillingSuppliesAndDevicesSequence	SQ	1	f	
(0040,0330)	Referenced Procedure Step Sequence	ReferencedProcedureStepSequence	SQ	1	t	
(0040,0340)	Performed Series Sequence	PerformedSeriesSequence	SQ	1	f	
(0040,0400)	Comments on the Scheduled Procedure Step	CommentsOnTheScheduledProcedureStep	LT	1	f	
(0040,0440)	Protocol Context Sequence	ProtocolContextSequence	SQ	1	f	
(0040,0441)	Content Item Modifier Sequence	ContentItemModifierSequence	SQ	1	f	
(0040,0500)	Scheduled Specimen Sequence	ScheduledSpecimenSequence	SQ	1	f	
(0040,050a)	Specimen Accession Number	SpecimenAccessionNumber	LO	1	t	
(0040,0512)	Container Identifier	ContainerIdentifier	LO	1	f	
(0040,0513)	Issuer of the Container Identifier Sequence	IssuerOfTheContainerIdentifierSequence	SQ	1	f	
(0040,0515)	Alternate Container Identifier Sequence	AlternateContainerIdentifierSequence	SQ	1	f	
(0040,0518)	Container Type Code Sequence	ContainerTypeCodeSequence	SQ	1	f	
(0040,051a)	Container Description	ContainerDescription	LO	1	f	
(0040,0520)	Container Component Sequence	ContainerComponentSequence	SQ	1	f	
(0040,0550)	Specimen Sequence	SpecimenSequence	SQ	1	t	
(0040,0551)	Specimen Identifier	SpecimenIdentifier	LO	1	f	
(0040,0552)	Specimen Description Sequence (Trial)	SpecimenDescriptionSequenceTrial	SQ	1	t	
(0040,0553)	Specimen Description (Trial)	SpecimenDescriptionTrial	ST	1	t	
(0040,0554)	Specimen UID	SpecimenUID	UI	1	f	
(0040,0555)	Acquisition Context Sequence	AcquisitionContextSequence	SQ	1	f	
(0040,0556)	Acquisition Context Description	AcquisitionContextDescription	ST	1	f	
(0040,059a)	Specimen Type Code Sequence	SpecimenTypeCodeSequence	SQ	1	f	
(0040,0560)	Specimen Description Sequence	SpecimenDescriptionSequence	SQ	1	f	
(0040,0562)	Issuer of the Specimen Identifier Sequence	IssuerOfTheSpecimenIdentifierSequence	SQ	1	f	
(0040,0600)	Specimen Short Description	SpecimenShortDescription	LO	1	f	
(0040,0602)	Specimen Detailed Description	SpecimenDetailedDescription	UT	1	f	
(0040,0610)	Specimen Preparation Sequence	SpecimenPreparationSequence	SQ	1	f	
(0040,0612)	Specimen Preparation Step Content Item Sequence	SpecimenPreparationStepContentItemSequence	SQ	1	f	
(0040,0620)	Specimen Localization Content Item Sequence	SpecimenLocalizationContentItemSequence	SQ	1	f	
(0040,06fa)	Slide Identifier	SlideIdentifier	LO	1	t	
(0040,071a)	Image Center Point Coordinates Sequence	ImageCenterPointCoordinatesSequence	SQ	1	f	
(0040,072a)	X Offset in Slide Coordinate System	XOffsetInSlideCoordinateSystem	DS	1	f	
(0040,073a)	Y Offset in Slide Coordinate System	YOffsetInSlideCoordinateSystem	DS	1	f	
(0040,074a)	Z Offset in Slide Coordinate System	ZOffsetInSlideCoordinateSystem	DS	1	f	
(0040,08d8)	Pixel Spacing Sequence	PixelSpacingSequence	SQ	1	t	
(0040,08da)	Coordinate System Axis Code Sequence	CoordinateSystemAxisCodeSequence	SQ	1	t	
(0040,08ea)	Measurement Units Code Sequence	MeasurementUnitsCodeSequence	SQ	1	f	
(0040,09f8)	Vital Stain Code Sequence (Trial)	VitalStainCodeSequenceTrial	SQ	1	t	
(0040,1001)	Requested Procedure ID	RequestedProcedureID	SH	1	f	
(0040,1002)	Reason for the Requested Procedure	ReasonForTheRequestedProcedure	LO	1	f	
(0040,1003)	Requested Procedure Priority	RequestedProcedurePriority	SH	1	f	
(0040,1004)	Patient Transport Arrangements	PatientTransportArrangements	LO	1	f	
(0040,1005)	Requested Procedure Location	RequestedProcedureLocation	LO	1	f	
(0040,1006)	Placer Order Number / Procedure	PlacerOrderNumberProcedure	SH	1	t	
(0040,1007)	Filler Order Number / Procedure	FillerOrderNumberProcedure	SH	1	t	
(0040,1008)	Confidentiality Code	ConfidentialityCode	LO	1	f	
(0040,1009)	Reporting Priority	ReportingPriority	SH	1	f	
(0040,100a)	Reason for Requested Procedure Code Sequence	ReasonForRequestedProcedureCodeSequence	SQ	1	f	
(0040,1010)	Names of Intended Recipients of Results	NamesOfIntendedRecipientsOfResults	PN	1-n	f	
(0040,1011)	Intended Recipients of Results Identification Sequence	IntendedRecipientsOfResultsIdentificationSequence	SQ	1	f	
(0040,1012)	Reason For Performed Procedure Code Sequence	ReasonForPerformedProcedureCodeSequence	SQ	1	f	
(0040,1060)	Requested Procedure Description (Trial)	RequestedProcedureDescriptionTrial	LO	1	t	
(0040,1101)	Person Identification Code Sequence	PersonIdentificationCodeSequence	SQ	1	f	
(0040,1102)	Person's Address	PersonAddress	ST	1	f	
(0040,1103)	Person's Telephone Numbers	PersonTelephoneNumbers	LO	1-n	f	
(0040,1104)	Person's Telecom Information	PersonTelecomInformation	LT	1	f	
(0040,1400)	Requested Procedure Comments	RequestedProcedureComments	LT	1	f	
(0040,2001)	Reason for the Imaging Service Request	ReasonForTheImagingServiceRequest	LO	1	t	
(0040,2004)	Issue Date of Imaging Service Request	IssueDateOfImagingServiceRequest	DA	1	f	
(0040,2005)	Issue Time of Imaging Service Request	IssueTimeOfImagingServiceRequest	TM	1	f	
(0040,2006)	Placer Order Number / Imaging Service Request (Retired)	PlacerOrderNumberImagingServiceRequestRetired	SH	1	t	
(0040,2007)	Filler Order Number / Imaging Service Request (Retired)	FillerOrderNumberImagingServiceRequestRetired	SH	1	t	
(0040,2008)	Order Entered By	OrderEnteredBy	PN	1	f	
(0040,2009)	Order Enterer's Location	OrderEntererLocation	SH	1	f	
(0040,2010)	Order Callback Phone Number	OrderCallbackPhoneNumber	SH	1	f	
(0040,2011)	Order Callback Telecom Information	OrderCallbackTelecomInformation	LT	1	f	
(0040,2016)	Placer Order Number / Imaging Service Request	PlacerOrderNumberImagingServiceRequest	LO	1	f	
(0040,2017)	Filler Order Number / Imaging Service Request	FillerOrderNumberImagingServiceRequest	LO	1	f	
(0040,2400)	Imaging Service Request Comments	ImagingServiceRequestComments	LT	1	f	
(0040,3001)	Confidentiality Constraint on Patient Data Description	ConfidentialityConstraintOnPatientDataDescription	LO	1	f	
(0040,4001)	General Purpose Scheduled Procedure Step Status	GeneralPurposeScheduledProcedureStepStatus	CS	1	t	
(0040,4002)	General Purpose Performed Procedure Step Status	GeneralPurposePerformedProcedureStepStatus	CS	1	t	
(0040,4003)	General Purpose Scheduled Procedure Step Priority	GeneralPurposeScheduledProcedureStepPriority	CS	1	t	
(0040,4004)	Scheduled Processing Applications Code Sequence	ScheduledProcessingApplicationsCodeSequence	SQ	1	t	
(0040,4005)	Scheduled Procedure Step Start DateTime	ScheduledProcedureStepStartDateTime	DT	1	f	
(0040,4006)	Multiple Copies Flag	MultipleCopiesFlag	CS	1	t	
(0040,4007)	Performed Processing Applications Code Sequence	PerformedProcessingApplicationsCodeSequence	SQ	1	f	
(0040,4009)	Human Performer Code Sequence	HumanPerformerCodeSequence	SQ	1	f	
(0040,4010)	Scheduled Procedure Step Modification DateTime	ScheduledProcedureStepModificationDateTime	DT	1	f	
(0040,4011)	Expected Completion DateTime	ExpectedCompletionDateTime	DT	1	f	
(0040,4015)	Resulting General Purpose Performed Procedure Steps Sequence	ResultingGeneralPurposePerformedProcedureStepsSequence	SQ	1	t	
(0040,4016)	Referenced General Purpose Scheduled Procedure Step Sequence	ReferencedGeneralPurposeScheduledProcedureStepSequence	SQ	1	t	
(0040,4018)	Scheduled Workitem Code Sequence	ScheduledWorkitemCodeSequence	SQ	1	f	
(0040,4019)	Performed Workitem Code Sequence	PerformedWorkitemCodeSequence	SQ	1	f	
(0040,4020)	Input Availability Flag	InputAvailabilityFlag	CS	1	f	
(0040,4021)	Input Information Sequence	InputInformationSequence	SQ	1	f	
(0040,4022)	Relevant Information Sequence	RelevantInformationSequence	SQ	1	t	
(0040,4023)	Referenced General Purpose Scheduled Procedure Step Transaction UID	ReferencedGeneralPurposeScheduledProcedureStepTransactionUID	UI	1	t	
(0040,4025)	Scheduled Station Name Code Sequence	ScheduledStationNameCodeSequence	SQ	1	f	
(0040,4026)	Scheduled Station Class Code Sequence	ScheduledStationClassCodeSequence	SQ	1	f	
(0040,4027)	Scheduled Station Geographic Location Code Sequence	ScheduledStationGeographicLocationCodeSequence	SQ	1	f	
(0040,4028)	Performed Station Name Code Sequence	PerformedStationNameCodeSequence	SQ	1	f	
(0040,4029)	Performed Station Class Code Sequence	PerformedStationClassCodeSequence	SQ	1	f	
(0040,4030)	Performed Station Geographic Location Code Sequence	PerformedStationGeographicLocationCodeSequence	SQ	1	f	
(0040,4031)	Requested Subsequent Workitem Code Sequence	RequestedSubsequentWorkitemCodeSequence	SQ	1	t	
(0040,4032)	Non-DICOM Output Code Sequence	NonDICOMOutputCodeSequence	SQ	1	t	
(0040,4033)	Output Information Sequence	OutputInformationSequence	SQ	1	f	
(0040,4034)	Scheduled Human Performers Sequence	ScheduledHumanPerformersSequence	SQ	1	f	
(0040,4035)	Actual Human Performers Sequence	ActualHumanPerformersSequence	SQ	1	f	
(0040,4036)	Human Performer's Organization	HumanPerformerOrganization	LO	1	f	
(0040,4037)	Human Performer's Name	HumanPerformerName	PN	1	f	
(0040,4040)	Raw Data Handling	RawDataHandling	CS	1	f	
(0040,4041)	Input Readiness State	InputReadinessState	CS	1	f	
(0040,4050)	Performed Procedure Step Start DateTime	PerformedProcedureStepStartDateTime	DT	1	f	
(0040,4051)	Performed Procedure Step End DateTime	PerformedProcedureStepEndDateTime	DT	1	f	
(0040,4052)	Procedure Step Cancellation DateTime	ProcedureStepCancellationDateTime	DT	1	f	
(0040,4070)	Output Destination Sequence	OutputDestinationSequence	SQ	1	f	
(0040,4071)	DICOM Storage Sequence	DICOMStorageSequence	SQ	1	f	
(0040,4072)	STOW-RS Storage Sequence	STOWRSStorageSequence	SQ	1	f	
(0040,4073)	Storage URL	StorageURL	UR	1	f	
(0040,4074)	XDS Storage Sequence	XDSStorageSequence	SQ	1	f	
(0040,8302)	Entrance Dose in mGy	EntranceDoseInmGy	DS	1	f	
(0040,9092)	Parametric Map Frame Type Sequence	ParametricMapFrameTypeSequence	SQ	1	f	
(0040,9094)	Referenced Image Real World Value Mapping Sequence	ReferencedImageRealWorldValueMappingSequence	SQ	1	f	
(0040,9096)	Real World Value Mapping Sequence	RealWorldValueMappingSequence	SQ	1	f	
(0040,9098)	Pixel Value Mapping Code Sequence	PixelValueMappingCodeSequence	SQ	1	f	
(0040,9210)	LUT Label	LUTLabel	SH	1	f	
(0040,9211)	Real World Value Last Value Mapped	RealWorldValueLastValueMapped	US or SS	1	f	
(0040,9212)	Real World Value LUT Data	RealWorldValueLUTData	FD	1-n	f	
(0040,9213)	Double Float Real World Value Last Value Mapped	DoubleFloatRealWorldValueLastValueMapped	FD	1	f	
(0040,9214)	Double Float Real World Value First Value Mapped	DoubleFloatRealWorldValueFirstValueMapped	FD	1	f	
(0040,9216)	Real World Value First Value Mapped	RealWorldValueFirstValueMapped	US or SS	1	f	
(0040,9220)	Quantity Definition Sequence	QuantityDefinitionSequence	SQ	1	f	
(0040,9224)	Real World Value Intercept	RealWorldValueIntercept	FD	1	f	
(0040,9225)	Real World Value Slope	RealWorldValueSlope	FD	1	f	
(0040,a007)	Findings Flag (Trial)	FindingsFlagTrial	CS	1	t	
(0040,a010)	Relationship Type	RelationshipType	CS	1	f	
(0040,a020)	Findings Sequence (Trial)	FindingsSequenceTrial	SQ	1	t	
(0040,a021)	Findings Group UID (Trial)	FindingsGroupUIDTrial	UI	1	t	
(0040,a022)	Referenced Findings Group UID (Trial)	ReferencedFindingsGroupUIDTrial	UI	1	t	
(0040,a023)	Findings Group Recording Date (Trial)	FindingsGroupRecordingDateTrial	DA	1	t	
(0040,a024)	Findings Group Recording Time (Trial)	FindingsGroupRecordingTimeTrial	TM	1	t	
(0040,a026)	Findings Source Category Code Sequence (Trial)	FindingsSourceCategoryCodeSequenceTrial	SQ	1	t	
(0040,a027)	Verifying Organization	VerifyingOrganization	LO	1	f	
(0040,a028)	Documenting Organization Identifier Code Sequence (Trial)	DocumentingOrganizationIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a030)	Verification DateTime	VerificationDateTime	DT	1	f	
(0040,a032)	Observation DateTime	ObservationDateTime	DT	1	f	
(0040,a040)	Value Type	ValueType	CS	1	f	
(0040,a043)	Concept Name Code Sequence	ConceptNameCodeSequence	SQ	1	f	
(0040,a047)	Measurement Precision Description (Trial)	MeasurementPrecisionDescriptionTrial	LO	1	t	
(0040,a050)	Continuity Of Content	ContinuityOfContent	CS	1	f	
(0040,a057)	Urgency or Priority Alerts (Trial)	UrgencyOrPriorityAlertsTrial	CS	1-n	t	
(0040,a060)	Sequencing Indicator (Trial)	SequencingIndicatorTrial	LO	1	t	
(0040,a066)	Document Identifier Code Sequence (Trial)	DocumentIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a067)	Document Author (Trial)	DocumentAuthorTrial	PN	1	t	
(0040,a068)	Document Author Identifier Code Sequence (Trial)	DocumentAuthorIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a070)	Identifier Code Sequence (Trial)	IdentifierCodeSequenceTrial	SQ	1	t	
(0040,a073)	Verifying Observer Sequence	VerifyingObserverSequence	SQ	1	f	
(0040,a074)	Object Binary Identifier (Trial)	ObjectBinaryIdentifierTrial	OB	1	t	
(0040,a075)	Verifying Observer Name	VerifyingObserverName	PN	1	f	
(0046,0102)	Add Other Sequence	AddOtherSequence	SQ	1	f	
(0040,a076)	Documenting Observer Identifier Code Sequence (Trial)	DocumentingObserverIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a078)	Author Observer Sequence	AuthorObserverSequence	SQ	1	f	
(0040,a07a)	Participant Sequence	ParticipantSequence	SQ	1	f	
(0040,a07c)	Custodial Organization Sequence	CustodialOrganizationSequence	SQ	1	f	
(0040,a080)	Participation Type	ParticipationType	CS	1	f	
(0040,a082)	Participation DateTime	ParticipationDateTime	DT	1	f	
(0040,a084)	Observer Type	ObserverType	CS	1	f	
(0040,a085)	Procedure Identifier Code Sequence (Trial)	ProcedureIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a088)	Verifying Observer Identification Code Sequence	VerifyingObserverIdentificationCodeSequence	SQ	1	f	
(0040,a089)	Object Directory Binary Identifier (Trial)	ObjectDirectoryBinaryIdentifierTrial	OB	1	t	
(0040,a090)	Equivalent CDA Document Sequence	EquivalentCDADocumentSequence	SQ	1	t	
(0040,a0b0)	Referenced Waveform Channels	ReferencedWaveformChannels	US	2-2n	f	
(0040,a110)	Date of Document or Verbal Transaction (Trial)	DateOfDocumentOrVerbalTransactionTrial	DA	1	t	
(0040,a112)	Time of Document Creation or Verbal Transaction (Trial)	TimeOfDocumentCreationOrVerbalTransactionTrial	TM	1	t	
(0040,a120)	DateTime	DateTime	DT	1	f	
(0040,a121)	Date	Date	DA	1	f	
(0040,a122)	Time	Time	TM	1	f	
(0040,a123)	Person Name	PersonName	PN	1	f	
(0040,a124)	UID	UID	UI	1	f	
(0040,a125)	Report Status ID (Trial)	ReportStatusIDTrial	CS	2	t	
(0040,a130)	Temporal Range Type	TemporalRangeType	CS	1	f	
(0040,a132)	Referenced Sample Positions	ReferencedSamplePositions	UL	1-n	f	
(0040,a136)	Referenced Frame Numbers	ReferencedFrameNumbers	US	1-n	f	
(0040,a138)	Referenced Time Offsets	ReferencedTimeOffsets	DS	1-n	f	
(0040,a13a)	Referenced DateTime	ReferencedDateTime	DT	1-n	f	
(0040,a160)	Text Value	TextValue	UT	1	f	
(0040,a161)	Floating Point Value	FloatingPointValue	FD	1-n	f	
(0040,a162)	Rational Numerator Value	RationalNumeratorValue	SL	1-n	f	
(0040,a163)	Rational Denominator Value	RationalDenominatorValue	UL	1-n	f	
(0040,a167)	Observation Category Code Sequence (Trial)	ObservationCategoryCodeSequenceTrial	SQ	1	t	
(0040,a168)	Concept Code Sequence	ConceptCodeSequence	SQ	1	f	
(0040,a16a)	Bibliographic Citation (Trial)	BibliographicCitationTrial	ST	1	t	
(0040,a170)	Purpose of Reference Code Sequence	PurposeOfReferenceCodeSequence	SQ	1	f	See Note
(0040,a171)	Observation UID	ObservationUID	UI	1	f	
(0040,a172)	Referenced Observation UID (Trial)	ReferencedObservationUIDTrial	UI	1	t	
(0040,a173)	Referenced Observation Class (Trial)	ReferencedObservationClassTrial	CS	1	t	
(0040,a174)	Referenced Object Observation Class (Trial)	ReferencedObjectObservationClassTrial	CS	1	t	
(0040,a180)	Annotation Group Number	AnnotationGroupNumber	US	1	f	
(0040,a192)	Observation Date (Trial)	ObservationDateTrial	DA	1	t	
(0040,a193)	Observation Time (Trial)	ObservationTimeTrial	TM	1	t	
(0040,a194)	Measurement Automation (Trial)	MeasurementAutomationTrial	CS	1	t	
(0040,a195)	Modifier Code Sequence	ModifierCodeSequence	SQ	1	f	
(0040,a224)	Identification Description (Trial)	IdentificationDescriptionTrial	ST	1	t	
(0040,a290)	Coordinates Set Geometric Type (Trial)	CoordinatesSetGeometricTypeTrial	CS	1	t	
(0040,a296)	Algorithm Code Sequence (Trial)	AlgorithmCodeSequenceTrial	SQ	1	t	
(0040,a297)	Algorithm Description (Trial)	AlgorithmDescriptionTrial	ST	1	t	
(0040,a29a)	Pixel Coordinates Set (Trial)	PixelCoordinatesSetTrial	SL	2-2n	t	
(0040,a300)	Measured Value Sequence	MeasuredValueSequence	SQ	1	f	
(0040,a301)	Numeric Value Qualifier Code Sequence	NumericValueQualifierCodeSequence	SQ	1	f	
(0040,a307)	Current Observer (Trial)	CurrentObserverTrial	PN	1	t	
(0040,a30a)	Numeric Value	NumericValue	DS	1-n	f	
(0040,a313)	Referenced Accession Sequence (Trial)	ReferencedAccessionSequenceTrial	SQ	1	t	
(0040,a33a)	Report Status Comment (Trial)	ReportStatusCommentTrial	ST	1	t	
(0040,a340)	Procedure Context Sequence (Trial)	ProcedureContextSequenceTrial	SQ	1	t	
(0040,a352)	Verbal Source (Trial)	VerbalSourceTrial	PN	1	t	
(0040,a353)	Address (Trial)	AddressTrial	ST	1	t	
(0040,a354)	Telephone Number (Trial)	TelephoneNumberTrial	LO	1	t	
(0040,a358)	Verbal Source Identifier Code Sequence (Trial)	VerbalSourceIdentifierCodeSequenceTrial	SQ	1	t	
(0040,a360)	Predecessor Documents Sequence	PredecessorDocumentsSequence	SQ	1	f	
(0040,a370)	Referenced Request Sequence	ReferencedRequestSequence	SQ	1	f	
(0040,a372)	Performed Procedure Code Sequence	PerformedProcedureCodeSequence	SQ	1	f	
(0040,a375)	Current Requested Procedure Evidence Sequence	CurrentRequestedProcedureEvidenceSequence	SQ	1	f	
(0040,a380)	Report Detail Sequence (Trial)	ReportDetailSequenceTrial	SQ	1	t	
(0040,a385)	Pertinent Other Evidence Sequence	PertinentOtherEvidenceSequence	SQ	1	f	
(0040,a390)	HL7 Structured Document Reference Sequence	HL7StructuredDocumentReferenceSequence	SQ	1	f	
(0040,a402)	Observation Subject UID (Trial)	ObservationSubjectUIDTrial	UI	1	t	
(0040,a403)	Observation Subject Class (Trial)	ObservationSubjectClassTrial	CS	1	t	
(0040,a404)	Observation Subject Type Code Sequence (Trial)	ObservationSubjectTypeCodeSequenceTrial	SQ	1	t	
(0040,a491)	Completion Flag	CompletionFlag	CS	1	f	
(0040,a492)	Completion Flag Description	CompletionFlagDescription	LO	1	f	
(0040,a493)	Verification Flag	VerificationFlag	CS	1	f	
(0040,a494)	Archive Requested	ArchiveRequested	CS	1	f	
(0040,a496)	Preliminary Flag	PreliminaryFlag	CS	1	f	
(0040,a504)	Content Template Sequence	ContentTemplateSequence	SQ	1	f	
(0040,a525)	Identical Documents Sequence	IdenticalDocumentsSequence	SQ	1	f	
(0040,a600)	Observation Subject Context Flag (Trial)	ObservationSubjectContextFlagTrial	CS	1	t	
(0040,a601)	Observer Context Flag (Trial)	ObserverContextFlagTrial	CS	1	t	
(0040,a603)	Procedure Context Flag (Trial)	ProcedureContextFlagTrial	CS	1	t	
(0040,a730)	Content Sequence	ContentSequence	SQ	1	f	
(0040,a731)	Relationship Sequence (Trial)	RelationshipSequenceTrial	SQ	1	t	
(0040,a732)	Relationship Type Code Sequence (Trial)	RelationshipTypeCodeSequenceTrial	SQ	1	t	
(0040,a744)	Language Code Sequence (Trial)	LanguageCodeSequenceTrial	SQ	1	t	
(0040,a992)	Uniform Resource Locator (Trial)	UniformResourceLocatorTrial	ST	1	t	
(0040,b020)	Waveform Annotation Sequence	WaveformAnnotationSequence	SQ	1	f	
(0040,db00)	Template Identifier	TemplateIdentifier	CS	1	f	
(0040,db06)	Template Version	TemplateVersion	DT	1	t	
(0040,db07)	Template Local Version	TemplateLocalVersion	DT	1	t	
(0040,db0b)	Template Extension Flag	TemplateExtensionFlag	CS	1	t	
(0040,db0c)	Template Extension Organization UID	TemplateExtensionOrganizationUID	UI	1	t	
(0040,db0d)	Template Extension Creator UID	TemplateExtensionCreatorUID	UI	1	t	
(0040,db73)	Referenced Content Item Identifier	ReferencedContentItemIdentifier	UL	1-n	f	
(0040,e001)	HL7 Instance Identifier	HL7InstanceIdentifier	ST	1	f	
(0040,e004)	HL7 Document Effective Time	HL7DocumentEffectiveTime	DT	1	f	
(0040,e006)	HL7 Document Type Code Sequence	HL7DocumentTypeCodeSequence	SQ	1	f	
(0040,e008)	Document Class Code Sequence	DocumentClassCodeSequence	SQ	1	f	
(0040,e010)	Retrieve URI	RetrieveURI	UR	1	f	
(0040,e011)	Retrieve Location UID	RetrieveLocationUID	UI	1	f	
(0040,e020)	Type of Instances	TypeOfInstances	CS	1	f	
(0040,e021)	DICOM Retrieval Sequence	DICOMRetrievalSequence	SQ	1	f	
(0040,e022)	DICOM Media Retrieval Sequence	DICOMMediaRetrievalSequence	SQ	1	f	
(0040,e023)	WADO Retrieval Sequence	WADORetrievalSequence	SQ	1	f	
(0040,e024)	XDS Retrieval Sequence	XDSRetrievalSequence	SQ	1	f	
(0040,e025)	WADO-RS Retrieval Sequence	WADORSRetrievalSequence	SQ	1	f	
(0040,e030)	Repository Unique ID	RepositoryUniqueID	UI	1	f	
(0040,e031)	Home Community ID	HomeCommunityID	UI	1	f	
(0042,0010)	Document Title	DocumentTitle	ST	1	f	
(0042,0011)	Encapsulated Document	EncapsulatedDocument	OB	1	f	
(0042,0012)	MIME Type of Encapsulated Document	MIMETypeOfEncapsulatedDocument	LO	1	f	
(0042,0013)	Source Instance Sequence	SourceInstanceSequence	SQ	1	f	
(0042,0014)	List of MIME Types	ListOfMIMETypes	LO	1-n	f	
(0044,0001)	Product Package Identifier	ProductPackageIdentifier	ST	1	f	
(0044,0002)	Substance Administration Approval	SubstanceAdministrationApproval	CS	1	f	
(0044,0003)	Approval Status Further Description	ApprovalStatusFurtherDescription	LT	1	f	
(0044,0004)	Approval Status DateTime	ApprovalStatusDateTime	DT	1	f	
(0044,0007)	Product Type Code Sequence	ProductTypeCodeSequence	SQ	1	f	
(0044,0008)	Product Name	ProductName	LO	1-n	f	
(0044,0009)	Product Description	ProductDescription	LT	1	f	
(0044,000a)	Product Lot Identifier	ProductLotIdentifier	LO	1	f	
(0044,000b)	Product Expiration DateTime	ProductExpirationDateTime	DT	1	f	
(0044,0010)	Substance Administration DateTime	SubstanceAdministrationDateTime	DT	1	f	
(0044,0011)	Substance Administration Notes	SubstanceAdministrationNotes	LO	1	f	
(0044,0012)	Substance Administration Device ID	SubstanceAdministrationDeviceID	LO	1	f	
(0044,0013)	Product Parameter Sequence	ProductParameterSequence	SQ	1	f	
(0044,0019)	Substance Administration Parameter Sequence	SubstanceAdministrationParameterSequence	SQ	1	f	
(0046,0012)	Lens Description	LensDescription	LO	1	f	
(0046,0014)	Right Lens Sequence	RightLensSequence	SQ	1	f	
(0046,0015)	Left Lens Sequence	LeftLensSequence	SQ	1	f	
(0046,0016)	Unspecified Laterality Lens Sequence	UnspecifiedLateralityLensSequence	SQ	1	f	
(0046,0018)	Cylinder Sequence	CylinderSequence	SQ	1	f	
(0046,0028)	Prism Sequence	PrismSequence	SQ	1	f	
(0046,0030)	Horizontal Prism Power	HorizontalPrismPower	FD	1	f	
(0046,0032)	Horizontal Prism Base	HorizontalPrismBase	CS	1	f	
(0046,0034)	Vertical Prism Power	VerticalPrismPower	FD	1	f	
(0046,0036)	Vertical Prism Base	VerticalPrismBase	CS	1	f	
(0046,0038)	Lens Segment Type	LensSegmentType	CS	1	f	
(0046,0040)	Optical Transmittance	OpticalTransmittance	FD	1	f	
(0046,0042)	Channel Width	ChannelWidth	FD	1	f	
(0046,0044)	Pupil Size	PupilSize	FD	1	f	
(0046,0046)	Corneal Size	CornealSize	FD	1	f	
(0046,0050)	Autorefraction Right Eye Sequence	AutorefractionRightEyeSequence	SQ	1	f	
(0046,0052)	Autorefraction Left Eye Sequence	AutorefractionLeftEyeSequence	SQ	1	f	
(0046,0060)	Distance Pupillary Distance	DistancePupillaryDistance	FD	1	f	
(0046,0062)	Near Pupillary Distance	NearPupillaryDistance	FD	1	f	
(0046,0063)	Intermediate Pupillary Distance	IntermediatePupillaryDistance	FD	1	f	
(0046,0064)	Other Pupillary Distance	OtherPupillaryDistance	FD	1	f	
(0046,0070)	Keratometry Right Eye Sequence	KeratometryRightEyeSequence	SQ	1	f	
(0046,0071)	Keratometry Left Eye Sequence	KeratometryLeftEyeSequence	SQ	1	f	
(0046,0074)	Steep Keratometric Axis Sequence	SteepKeratometricAxisSequence	SQ	1	f	
(0046,0075)	Radius of Curvature	RadiusOfCurvature	FD	1	f	
(0046,0076)	Keratometric Power	KeratometricPower	FD	1	f	
(0046,0077)	Keratometric Axis	KeratometricAxis	FD	1	f	
(0046,0080)	Flat Keratometric Axis Sequence	FlatKeratometricAxisSequence	SQ	1	f	
(0046,0092)	Background Color	BackgroundColor	CS	1	f	
(0046,0094)	Optotype	Optotype	CS	1	f	
(0046,0095)	Optotype Presentation	OptotypePresentation	CS	1	f	
(0046,0097)	Subjective Refraction Right Eye Sequence	SubjectiveRefractionRightEyeSequence	SQ	1	f	
(0046,0098)	Subjective Refraction Left Eye Sequence	SubjectiveRefractionLeftEyeSequence	SQ	1	f	
(0046,0100)	Add Near Sequence	AddNearSequence	SQ	1	f	
(0046,0101)	Add Intermediate Sequence	AddIntermediateSequence	SQ	1	f	
(0046,0104)	Add Power	AddPower	FD	1	f	
(0046,0106)	Viewing Distance	ViewingDistance	FD	1	f	
(0046,0121)	Visual Acuity Type Code Sequence	VisualAcuityTypeCodeSequence	SQ	1	f	
(0046,0122)	Visual Acuity Right Eye Sequence	VisualAcuityRightEyeSequence	SQ	1	f	
(0046,0123)	Visual Acuity Left Eye Sequence	VisualAcuityLeftEyeSequence	SQ	1	f	
(0046,0124)	Visual Acuity Both Eyes Open Sequence	VisualAcuityBothEyesOpenSequence	SQ	1	f	
(0046,0125)	Viewing Distance Type	ViewingDistanceType	CS	1	f	
(0046,0135)	Visual Acuity Modifiers	VisualAcuityModifiers	SS	2	f	
(0046,0137)	Decimal Visual Acuity	DecimalVisualAcuity	FD	1	f	
(0046,0139)	Optotype Detailed Definition	OptotypeDetailedDefinition	LO	1	f	
(0046,0145)	Referenced Refractive Measurements Sequence	ReferencedRefractiveMeasurementsSequence	SQ	1	f	
(0046,0146)	Sphere Power	SpherePower	FD	1	f	
(0046,0147)	Cylinder Power	CylinderPower	FD	1	f	
(0046,0201)	Corneal Topography Surface	CornealTopographySurface	CS	1	f	
(0046,0202)	Corneal Vertex Location	CornealVertexLocation	FL	2	f	
(0046,0203)	Pupil Centroid X-Coordinate	PupilCentroidXCoordinate	FL	1	f	
(0046,0204)	Pupil Centroid Y-Coordinate	PupilCentroidYCoordinate	FL	1	f	
(0046,0205)	Equivalent Pupil Radius	EquivalentPupilRadius	FL	1	f	
(0046,0207)	Corneal Topography Map Type Code Sequence	CornealTopographyMapTypeCodeSequence	SQ	1	f	
(0046,0208)	Vertices of the Outline of Pupil	VerticesOfTheOutlineOfPupil	IS	2-2n	f	
(0046,0210)	Corneal Topography Mapping Normals Sequence	CornealTopographyMappingNormalsSequence	SQ	1	f	
(0046,0211)	Maximum Corneal Curvature Sequence	MaximumCornealCurvatureSequence	SQ	1	f	
(0046,0212)	Maximum Corneal Curvature	MaximumCornealCurvature	FL	1	f	
(0046,0213)	Maximum Corneal Curvature Location	MaximumCornealCurvatureLocation	FL	2	f	
(0046,0215)	Minimum Keratometric Sequence	MinimumKeratometricSequence	SQ	1	f	
(0046,0218)	Simulated Keratometric Cylinder Sequence	SimulatedKeratometricCylinderSequence	SQ	1	f	
(0046,0220)	Average Corneal Power	AverageCornealPower	FL	1	f	
(0046,0224)	Corneal I-S Value	CornealISValue	FL	1	f	
(0046,0227)	Analyzed Area	AnalyzedArea	FL	1	f	
(0046,0230)	Surface Regularity Index	SurfaceRegularityIndex	FL	1	f	
(0046,0232)	Surface Asymmetry Index	SurfaceAsymmetryIndex	FL	1	f	
(0046,0234)	Corneal Eccentricity Index	CornealEccentricityIndex	FL	1	f	
(0046,0236)	Keratoconus Prediction Index	KeratoconusPredictionIndex	FL	1	f	
(0046,0238)	Decimal Potential Visual Acuity	DecimalPotentialVisualAcuity	FL	1	f	
(0046,0242)	Corneal Topography Map Quality Evaluation	CornealTopographyMapQualityEvaluation	CS	1	f	
(0046,0244)	Source Image Corneal Processed Data Sequence	SourceImageCornealProcessedDataSequence	SQ	1	f	
(0046,0247)	Corneal Point Location	CornealPointLocation	FL	3	f	
(0046,0248)	Corneal Point Estimated	CornealPointEstimated	CS	1	f	
(0046,0249)	Axial Power	AxialPower	FL	1	f	
(0046,0250)	Tangential Power	TangentialPower	FL	1	f	
(0046,0251)	Refractive Power	RefractivePower	FL	1	f	
(0046,0252)	Relative Elevation	RelativeElevation	FL	1	f	
(0046,0253)	Corneal Wavefront	CornealWavefront	FL	1	f	
(0048,0001)	Imaged Volume Width	ImagedVolumeWidth	FL	1	f	
(0048,0002)	Imaged Volume Height	ImagedVolumeHeight	FL	1	f	
(0048,0003)	Imaged Volume Depth	ImagedVolumeDepth	FL	1	f	
(0048,0006)	Total Pixel Matrix Columns	TotalPixelMatrixColumns	UL	1	f	
(0048,0007)	Total Pixel Matrix Rows	TotalPixelMatrixRows	UL	1	f	
(0048,0008)	Total Pixel Matrix Origin Sequence	TotalPixelMatrixOriginSequence	SQ	1	f	
(0048,0010)	Specimen Label in Image	SpecimenLabelInImage	CS	1	f	
(0048,0011)	Focus Method	FocusMethod	CS	1	f	
(0048,0012)	Extended Depth of Field	ExtendedDepthOfField	CS	1	f	
(0048,0013)	Number of Focal Planes	NumberOfFocalPlanes	US	1	f	
(0048,0014)	Distance Between Focal Planes	DistanceBetweenFocalPlanes	FL	1	f	
(0048,0015)	Recommended Absent Pixel CIELab Value	RecommendedAbsentPixelCIELabValue	US	3	f	
(0048,0100)	Illuminator Type Code Sequence	IlluminatorTypeCodeSequence	SQ	1	f	
(0048,0102)	Image Orientation (Slide)	ImageOrientationSlide	DS	6	f	
(0048,0105)	Optical Path Sequence	OpticalPathSequence	SQ	1	f	
(0048,0106)	Optical Path Identifier	OpticalPathIdentifier	SH	1	f	
(0048,0107)	Optical Path Description	OpticalPathDescription	ST	1	f	
(0048,0108)	Illumination Color Code Sequence	IlluminationColorCodeSequence	SQ	1	f	
(0048,0110)	Specimen Reference Sequence	SpecimenReferenceSequence	SQ	1	f	
(0048,0111)	Condenser Lens Power	CondenserLensPower	DS	1	f	
(0048,0112)	Objective Lens Power	ObjectiveLensPower	DS	1	f	
(0048,0113)	Objective Lens Numerical Aperture	ObjectiveLensNumericalAperture	DS	1	f	
(0048,0120)	Palette Color Lookup Table Sequence	PaletteColorLookupTableSequence	SQ	1	f	
(0048,0200)	Referenced Image Navigation Sequence	ReferencedImageNavigationSequence	SQ	1	f	
(0048,0201)	Top Left Hand Corner of Localizer Area	TopLeftHandCornerOfLocalizerArea	US	2	f	
(0048,0202)	Bottom Right Hand Corner of Localizer Area	BottomRightHandCornerOfLocalizerArea	US	2	f	
(0048,0207)	Optical Path Identification Sequence	OpticalPathIdentificationSequence	SQ	1	f	
(0048,021a)	Plane Position (Slide) Sequence	PlanePositionSlideSequence	SQ	1	f	
(0048,021e)	Column Position In Total Image Pixel Matrix	ColumnPositionInTotalImagePixelMatrix	SL	1	f	
(0048,021f)	Row Position In Total Image Pixel Matrix	RowPositionInTotalImagePixelMatrix	SL	1	f	
(0048,0301)	Pixel Origin Interpretation	PixelOriginInterpretation	CS	1	f	
(0050,0004)	Calibration Image	CalibrationImage	CS	1	f	
(0050,0010)	Device Sequence	DeviceSequence	SQ	1	f	
(0050,0012)	Container Component Type Code Sequence	ContainerComponentTypeCodeSequence	SQ	1	f	
(0050,0013)	Container Component Thickness	ContainerComponentThickness	FD	1	f	
(0050,0014)	Device Length	DeviceLength	DS	1	f	
(0050,0015)	Container Component Width	ContainerComponentWidth	FD	1	f	
(0050,0016)	Device Diameter	DeviceDiameter	DS	1	f	
(0050,0017)	Device Diameter Units	DeviceDiameterUnits	CS	1	f	
(0050,0018)	Device Volume	DeviceVolume	DS	1	f	
(0050,0019)	Inter-Marker Distance	InterMarkerDistance	DS	1	f	
(0050,001a)	Container Component Material	ContainerComponentMaterial	CS	1	f	
(0050,001b)	Container Component ID	ContainerComponentID	LO	1	f	
(0050,001c)	Container Component Length	ContainerComponentLength	FD	1	f	
(0050,001d)	Container Component Diameter	ContainerComponentDiameter	FD	1	f	
(0050,001e)	Container Component Description	ContainerComponentDescription	LO	1	f	
(0050,0020)	Device Description	DeviceDescription	LO	1	f	
(0052,0001)	Contrast/Bolus Ingredient Percent by Volume	ContrastBolusIngredientPercentByVolume	FL	1	f	
(0052,0002)	OCT Focal Distance	OCTFocalDistance	FD	1	f	
(0052,0003)	Beam Spot Size	BeamSpotSize	FD	1	f	
(0052,0004)	Effective Refractive Index	EffectiveRefractiveIndex	FD	1	f	
(0052,0006)	OCT Acquisition Domain	OCTAcquisitionDomain	CS	1	f	
(0052,0007)	OCT Optical Center Wavelength	OCTOpticalCenterWavelength	FD	1	f	
(0052,0008)	Axial Resolution	AxialResolution	FD	1	f	
(0052,0009)	Ranging Depth	RangingDepth	FD	1	f	
(0052,0011)	A-line Rate	ALineRate	FD	1	f	
(0052,0012)	A-lines Per Frame	ALinesPerFrame	US	1	f	
(0052,0013)	Catheter Rotational Rate	CatheterRotationalRate	FD	1	f	
(0052,0014)	A-line Pixel Spacing	ALinePixelSpacing	FD	1	f	
(0052,0016)	Mode of Percutaneous Access Sequence	ModeOfPercutaneousAccessSequence	SQ	1	f	
(0052,0025)	Intravascular OCT Frame Type Sequence	IntravascularOCTFrameTypeSequence	SQ	1	f	
(0052,0026)	OCT Z Offset Applied	OCTZOffsetApplied	CS	1	f	
(0052,0027)	Intravascular Frame Content Sequence	IntravascularFrameContentSequence	SQ	1	f	
(0052,0028)	Intravascular Longitudinal Distance	IntravascularLongitudinalDistance	FD	1	f	
(0052,0029)	Intravascular OCT Frame Content Sequence	IntravascularOCTFrameContentSequence	SQ	1	f	
(0052,0030)	OCT Z Offset Correction	OCTZOffsetCorrection	SS	1	f	
(0052,0031)	Catheter Direction of Rotation	CatheterDirectionOfRotation	CS	1	f	
(0052,0033)	Seam Line Location	SeamLineLocation	FD	1	f	
(0052,0034)	First A-line Location	FirstALineLocation	FD	1	f	
(0052,0036)	Seam Line Index	SeamLineIndex	US	1	f	
(0052,0038)	Number of Padded A-lines	NumberOfPaddedALines	US	1	f	
(0052,0039)	Interpolation Type	InterpolationType	CS	1	f	
(0052,003a)	Refractive Index Applied	RefractiveIndexApplied	CS	1	f	
(0054,0010)	Energy Window Vector	EnergyWindowVector	US	1-n	f	
(0054,0011)	Number of Energy Windows	NumberOfEnergyWindows	US	1	f	
(0054,0012)	Energy Window Information Sequence	EnergyWindowInformationSequence	SQ	1	f	
(0054,0013)	Energy Window Range Sequence	EnergyWindowRangeSequence	SQ	1	f	
(0054,0014)	Energy Window Lower Limit	EnergyWindowLowerLimit	DS	1	f	
(0054,0015)	Energy Window Upper Limit	EnergyWindowUpperLimit	DS	1	f	
(0054,0016)	Radiopharmaceutical Information Sequence	RadiopharmaceuticalInformationSequence	SQ	1	f	
(0054,0017)	Residual Syringe Counts	ResidualSyringeCounts	IS	1	f	
(0054,0018)	Energy Window Name	EnergyWindowName	SH	1	f	
(0054,0020)	Detector Vector	DetectorVector	US	1-n	f	
(0054,0021)	Number of Detectors	NumberOfDetectors	US	1	f	
(0054,0022)	Detector Information Sequence	DetectorInformationSequence	SQ	1	f	
(0054,0030)	Phase Vector	PhaseVector	US	1-n	f	
(0054,0031)	Number of Phases	NumberOfPhases	US	1	f	
(0054,0032)	Phase Information Sequence	PhaseInformationSequence	SQ	1	f	
(0054,0033)	Number of Frames in Phase	NumberOfFramesInPhase	US	1	f	
(0054,0036)	Phase Delay	PhaseDelay	IS	1	f	
(0054,0038)	Pause Between Frames	PauseBetweenFrames	IS	1	f	
(0054,0039)	Phase Description	PhaseDescription	CS	1	f	
(0054,0050)	Rotation Vector	RotationVector	US	1-n	f	
(0054,0051)	Number of Rotations	NumberOfRotations	US	1	f	
(0054,0052)	Rotation Information Sequence	RotationInformationSequence	SQ	1	f	
(0054,0053)	Number of Frames in Rotation	NumberOfFramesInRotation	US	1	f	
(0054,0060)	R-R Interval Vector	RRIntervalVector	US	1-n	f	
(0054,0061)	Number of R-R Intervals	NumberOfRRIntervals	US	1	f	
(0054,0062)	Gated Information Sequence	GatedInformationSequence	SQ	1	f	
(0054,0063)	Data Information Sequence	DataInformationSequence	SQ	1	f	
(0054,0070)	Time Slot Vector	TimeSlotVector	US	1-n	f	
(0054,0071)	Number of Time Slots	NumberOfTimeSlots	US	1	f	
(0054,0072)	Time Slot Information Sequence	TimeSlotInformationSequence	SQ	1	f	
(0054,0073)	Time Slot Time	TimeSlotTime	DS	1	f	
(0054,0080)	Slice Vector	SliceVector	US	1-n	f	
(0054,0081)	Number of Slices	NumberOfSlices	US	1	f	
(0054,0090)	Angular View Vector	AngularViewVector	US	1-n	f	
(0054,0100)	Time Slice Vector	TimeSliceVector	US	1-n	f	
(0054,0101)	Number of Time Slices	NumberOfTimeSlices	US	1	f	
(0054,0200)	Start Angle	StartAngle	DS	1	f	
(0054,0202)	Type of Detector Motion	TypeOfDetectorMotion	CS	1	f	
(0054,0210)	Trigger Vector	TriggerVector	IS	1-n	f	
(0054,0211)	Number of Triggers in Phase	NumberOfTriggersInPhase	US	1	f	
(0054,0220)	View Code Sequence	ViewCodeSequence	SQ	1	f	
(0054,0222)	View Modifier Code Sequence	ViewModifierCodeSequence	SQ	1	f	
(0054,0300)	Radionuclide Code Sequence	RadionuclideCodeSequence	SQ	1	f	
(0054,0302)	Administration Route Code Sequence	AdministrationRouteCodeSequence	SQ	1	f	
(0054,0304)	Radiopharmaceutical Code Sequence	RadiopharmaceuticalCodeSequence	SQ	1	f	
(0054,0306)	Calibration Data Sequence	CalibrationDataSequence	SQ	1	f	
(0054,0308)	Energy Window Number	EnergyWindowNumber	US	1	f	
(0054,0400)	Image ID	ImageID	SH	1	f	
(0054,0410)	Patient Orientation Code Sequence	PatientOrientationCodeSequence	SQ	1	f	
(0054,0412)	Patient Orientation Modifier Code Sequence	PatientOrientationModifierCodeSequence	SQ	1	f	
(0054,0414)	Patient Gantry Relationship Code Sequence	PatientGantryRelationshipCodeSequence	SQ	1	f	
(0054,0500)	Slice Progression Direction	SliceProgressionDirection	CS	1	f	
(0054,0501)	Scan Progression Direction	ScanProgressionDirection	CS	1	f	
(0054,1000)	Series Type	SeriesType	CS	2	f	
(0054,1001)	Units	Units	CS	1	f	
(0054,1002)	Counts Source	CountsSource	CS	1	f	
(0054,1004)	Reprojection Method	ReprojectionMethod	CS	1	f	
(0054,1006)	SUV Type	SUVType	CS	1	f	
(0054,1100)	Randoms Correction Method	RandomsCorrectionMethod	CS	1	f	
(0054,1101)	Attenuation Correction Method	AttenuationCorrectionMethod	LO	1	f	
(0054,1102)	Decay Correction	DecayCorrection	CS	1	f	
(0054,1103)	Reconstruction Method	ReconstructionMethod	LO	1	f	
(0054,1104)	Detector Lines of Response Used	DetectorLinesOfResponseUsed	LO	1	f	
(0054,1105)	Scatter Correction Method	ScatterCorrectionMethod	LO	1	f	
(0054,1200)	Axial Acceptance	AxialAcceptance	DS	1	f	
(0054,1201)	Axial Mash	AxialMash	IS	2	f	
(0054,1202)	Transverse Mash	TransverseMash	IS	1	f	
(0054,1203)	Detector Element Size	DetectorElementSize	DS	2	f	
(0054,1210)	Coincidence Window Width	CoincidenceWindowWidth	DS	1	f	
(0054,1220)	Secondary Counts Type	SecondaryCountsType	CS	1-n	f	
(0054,1300)	Frame Reference Time	FrameReferenceTime	DS	1	f	
(0054,1310)	Primary (Prompts) Counts Accumulated	PrimaryPromptsCountsAccumulated	IS	1	f	
(0054,1311)	Secondary Counts Accumulated	SecondaryCountsAccumulated	IS	1-n	f	
(0054,1320)	Slice Sensitivity Factor	SliceSensitivityFactor	DS	1	f	
(0054,1321)	Decay Factor	DecayFactor	DS	1	f	
(0054,1322)	Dose Calibration Factor	DoseCalibrationFactor	DS	1	f	
(0054,1323)	Scatter Fraction Factor	ScatterFractionFactor	DS	1	f	
(0054,1324)	Dead Time Factor	DeadTimeFactor	DS	1	f	
(0054,1330)	Image Index	ImageIndex	US	1	f	
(0054,1400)	Counts Included	CountsIncluded	CS	1-n	t	
(0054,1401)	Dead Time Correction Flag	DeadTimeCorrectionFlag	CS	1	t	
(0060,3000)	Histogram Sequence	HistogramSequence	SQ	1	f	
(0060,3002)	Histogram Number of Bins	HistogramNumberOfBins	US	1	f	
(0060,3004)	Histogram First Bin Value	HistogramFirstBinValue	US or SS	1	f	
(0060,3006)	Histogram Last Bin Value	HistogramLastBinValue	US or SS	1	f	
(0060,3008)	Histogram Bin Width	HistogramBinWidth	US	1	f	
(0060,3010)	Histogram Explanation	HistogramExplanation	LO	1	f	
(0060,3020)	Histogram Data	HistogramData	UL	1-n	f	
(0062,0001)	Segmentation Type	SegmentationType	CS	1	f	
(0062,0002)	Segment Sequence	SegmentSequence	SQ	1	f	
(0062,0003)	Segmented Property Category Code Sequence	SegmentedPropertyCategoryCodeSequence	SQ	1	f	
(0062,0004)	Segment Number	SegmentNumber	US	1	f	
(0062,0005)	Segment Label	SegmentLabel	LO	1	f	
(0062,0006)	Segment Description	SegmentDescription	ST	1	f	
(0062,0008)	Segment Algorithm Type	SegmentAlgorithmType	CS	1	f	
(0062,0009)	Segment Algorithm Name	SegmentAlgorithmName	LO	1	f	
(0062,000a)	Segment Identification Sequence	SegmentIdentificationSequence	SQ	1	f	
(0062,000b)	Referenced Segment Number	ReferencedSegmentNumber	US	1-n	f	
(0062,000c)	Recommended Display Grayscale Value	RecommendedDisplayGrayscaleValue	US	1	f	
(0062,000d)	Recommended Display CIELab Value	RecommendedDisplayCIELabValue	US	3	f	
(0062,000e)	Maximum Fractional Value	MaximumFractionalValue	US	1	f	
(0062,000f)	Segmented Property Type Code Sequence	SegmentedPropertyTypeCodeSequence	SQ	1	f	
(0062,0010)	Segmentation Fractional Type	SegmentationFractionalType	CS	1	f	
(0062,0011)	Segmented Property Type Modifier Code Sequence	SegmentedPropertyTypeModifierCodeSequence	SQ	1	f	
(0062,0012)	Used Segments Sequence	UsedSegmentsSequence	SQ	1	f	
(0062,0020)	Tracking ID	TrackingID	UT	1	f	
(0062,0021)	Tracking UID	TrackingUID	UI	1	f	
(0064,0002)	Deformable Registration Sequence	DeformableRegistrationSequence	SQ	1	f	
(0064,0003)	Source Frame of Reference UID	SourceFrameOfReferenceUID	UI	1	f	
(0064,0005)	Deformable Registration Grid Sequence	DeformableRegistrationGridSequence	SQ	1	f	
(0064,0007)	Grid Dimensions	GridDimensions	UL	3	f	
(0064,0008)	Grid Resolution	GridResolution	FD	3	f	
(0064,0009)	Vector Grid Data	VectorGridData	OF	1	f	
(0064,000f)	Pre Deformation Matrix Registration Sequence	PreDeformationMatrixRegistrationSequence	SQ	1	f	
(0064,0010)	Post Deformation Matrix Registration Sequence	PostDeformationMatrixRegistrationSequence	SQ	1	f	
(0066,0001)	Number of Surfaces	NumberOfSurfaces	UL	1	f	
(0066,0002)	Surface Sequence	SurfaceSequence	SQ	1	f	
(0066,0003)	Surface Number	SurfaceNumber	UL	1	f	
(0066,0004)	Surface Comments	SurfaceComments	LT	1	f	
(0066,0009)	Surface Processing	SurfaceProcessing	CS	1	f	
(0066,000a)	Surface Processing Ratio	SurfaceProcessingRatio	FL	1	f	
(0066,000b)	Surface Processing Description	SurfaceProcessingDescription	LO	1	f	
(0066,000c)	Recommended Presentation Opacity	RecommendedPresentationOpacity	FL	1	f	
(0066,000d)	Recommended Presentation Type	RecommendedPresentationType	CS	1	f	
(0066,000e)	Finite Volume	FiniteVolume	CS	1	f	
(0066,0010)	Manifold	Manifold	CS	1	f	
(0066,0011)	Surface Points Sequence	SurfacePointsSequence	SQ	1	f	
(0066,0012)	Surface Points Normals Sequence	SurfacePointsNormalsSequence	SQ	1	f	
(0066,0013)	Surface Mesh Primitives Sequence	SurfaceMeshPrimitivesSequence	SQ	1	f	
(0066,0015)	Number of Surface Points	NumberOfSurfacePoints	UL	1	f	
(0066,0016)	Point Coordinates Data	PointCoordinatesData	OF	1	f	
(0066,0017)	Point Position Accuracy	PointPositionAccuracy	FL	3	f	
(0066,0018)	Mean Point Distance	MeanPointDistance	FL	1	f	
(0066,0019)	Maximum Point Distance	MaximumPointDistance	FL	1	f	
(0066,001a)	Points Bounding Box Coordinates	PointsBoundingBoxCoordinates	FL	6	f	
(0066,001b)	Axis of Rotation	AxisOfRotation	FL	3	f	
(0066,001c)	Center of Rotation	CenterOfRotation	FL	3	f	
(0066,001e)	Number of Vectors	NumberOfVectors	UL	1	f	
(0066,001f)	Vector Dimensionality	VectorDimensionality	US	1	f	
(0066,0020)	Vector Accuracy	VectorAccuracy	FL	1-n	f	
(0066,0021)	Vector Coordinate Data	VectorCoordinateData	OF	1	f	
(0066,0023)	Triangle Point Index List	TrianglePointIndexList	OW	1	t	
(0066,0024)	Edge Point Index List	EdgePointIndexList	OW	1	t	
(0066,0025)	Vertex Point Index List	VertexPointIndexList	OW	1	t	
(0066,0026)	Triangle Strip Sequence	TriangleStripSequence	SQ	1	f	
(0066,0027)	Triangle Fan Sequence	TriangleFanSequence	SQ	1	f	
(0066,0028)	Line Sequence	LineSequence	SQ	1	f	
(0066,0029)	Primitive Point Index List	PrimitivePointIndexList	OW	1	t	
(0066,002a)	Surface Count	SurfaceCount	UL	1	f	
(0066,002b)	Referenced Surface Sequence	ReferencedSurfaceSequence	SQ	1	f	
(0066,002c)	Referenced Surface Number	ReferencedSurfaceNumber	UL	1	f	
(0066,002d)	Segment Surface Generation Algorithm Identification Sequence	SegmentSurfaceGenerationAlgorithmIdentificationSequence	SQ	1	f	
(0066,002e)	Segment Surface Source Instance Sequence	SegmentSurfaceSourceInstanceSequence	SQ	1	f	
(0066,002f)	Algorithm Family Code Sequence	AlgorithmFamilyCodeSequence	SQ	1	f	
(0066,0030)	Algorithm Name Code Sequence	AlgorithmNameCodeSequence	SQ	1	f	
(0066,0031)	Algorithm Version	AlgorithmVersion	LO	1	f	
(0066,0032)	Algorithm Parameters	AlgorithmParameters	LT	1	f	
(0066,0034)	Facet Sequence	FacetSequence	SQ	1	f	
(0066,0035)	Surface Processing Algorithm Identification Sequence	SurfaceProcessingAlgorithmIdentificationSequence	SQ	1	f	
(0066,0036)	Algorithm Name	AlgorithmName	LO	1	f	
(0066,0037)	Recommended Point Radius	RecommendedPointRadius	FL	1	f	
(0066,0038)	Recommended Line Thickness	RecommendedLineThickness	FL	1	f	
(0066,0040)	Long Primitive Point Index List	LongPrimitivePointIndexList	OL	1	f	
(0066,0041)	Long Triangle Point Index List	LongTrianglePointIndexList	OL	1	f	
(0066,0042)	Long Edge Point Index List	LongEdgePointIndexList	OL	1	f	
(0066,0043)	Long Vertex Point Index List	LongVertexPointIndexList	OL	1	f	
(0066,0101)	Track Set Sequence	TrackSetSequence	SQ	1	f	
(0066,0102)	Track Sequence	TrackSequence	SQ	1	f	
(0066,0103)	Recommended Display CIELab Value List	RecommendedDisplayCIELabValueList	OW	1	f	
(0066,0104)	Tracking Algorithm Identification Sequence	TrackingAlgorithmIdentificationSequence	SQ	1	f	
(0066,0105)	Track Set Number	TrackSetNumber	UL	1	f	
(0066,0106)	Track Set Label	TrackSetLabel	LO	1	f	
(0066,0107)	Track Set Description	TrackSetDescription	UT	1	f	
(0066,0108)	Track Set Anatomical Type Code Sequence	TrackSetAnatomicalTypeCodeSequence	SQ	1	f	
(0066,0121)	Measurements Sequence	MeasurementsSequence	SQ	1	f	
(0066,0124)	Track Set Statistics Sequence	TrackSetStatisticsSequence	SQ	1	f	
(0066,0125)	Floating Point Values	FloatingPointValues	OF	1	f	
(0066,0129)	Track Point Index List	TrackPointIndexList	OL	1	f	
(0066,0130)	Track Statistics Sequence	TrackStatisticsSequence	SQ	1	f	
(0066,0132)	Measurement Values Sequence	MeasurementValuesSequence	SQ	1	f	
(0066,0133)	Diffusion Acquisition Code Sequence	DiffusionAcquisitionCodeSequence	SQ	1	f	
(0066,0134)	Diffusion Model Code Sequence	DiffusionModelCodeSequence	SQ	1	f	
(0068,6210)	Implant Size	ImplantSize	LO	1	f	
(0068,6221)	Implant Template Version	ImplantTemplateVersion	LO	1	f	
(0068,6222)	Replaced Implant Template Sequence	ReplacedImplantTemplateSequence	SQ	1	f	
(0068,6223)	Implant Type	ImplantType	CS	1	f	
(0068,6224)	Derivation Implant Template Sequence	DerivationImplantTemplateSequence	SQ	1	f	
(0068,6225)	Original Implant Template Sequence	OriginalImplantTemplateSequence	SQ	1	f	
(0068,6226)	Effective DateTime	EffectiveDateTime	DT	1	f	
(0068,6230)	Implant Target Anatomy Sequence	ImplantTargetAnatomySequence	SQ	1	f	
(0068,6260)	Information From Manufacturer Sequence	InformationFromManufacturerSequence	SQ	1	f	
(0068,6265)	Notification From Manufacturer Sequence	NotificationFromManufacturerSequence	SQ	1	f	
(0068,6270)	Information Issue DateTime	InformationIssueDateTime	DT	1	f	
(0068,6280)	Information Summary	InformationSummary	ST	1	f	
(0068,62a0)	Implant Regulatory Disapproval Code Sequence	ImplantRegulatoryDisapprovalCodeSequence	SQ	1	f	
(0068,62a5)	Overall Template Spatial Tolerance	OverallTemplateSpatialTolerance	FD	1	f	
(0068,62c0)	HPGL Document Sequence	HPGLDocumentSequence	SQ	1	f	
(0068,62d0)	HPGL Document ID	HPGLDocumentID	US	1	f	
(0068,62d5)	HPGL Document Label	HPGLDocumentLabel	LO	1	f	
(0068,62e0)	View Orientation Code Sequence	ViewOrientationCodeSequence	SQ	1	f	
(0068,62f0)	View Orientation Modifier	ViewOrientationModifier	FD	9	f	
(0068,62f2)	HPGL Document Scaling	HPGLDocumentScaling	FD	1	f	
(0068,6300)	HPGL Document	HPGLDocument	OB	1	f	
(0068,6310)	HPGL Contour Pen Number	HPGLContourPenNumber	US	1	f	
(0068,6320)	HPGL Pen Sequence	HPGLPenSequence	SQ	1	f	
(0068,6330)	HPGL Pen Number	HPGLPenNumber	US	1	f	
(0068,6340)	HPGL Pen Label	HPGLPenLabel	LO	1	f	
(0068,6345)	HPGL Pen Description	HPGLPenDescription	ST	1	f	
(0068,6346)	Recommended Rotation Point	RecommendedRotationPoint	FD	2	f	
(0068,6347)	Bounding Rectangle	BoundingRectangle	FD	4	f	
(0068,6350)	Implant Template 3D Model Surface Number	ImplantTemplate3DModelSurfaceNumber	US	1-n	f	
(0070,0101)	Presentation Pixel Spacing	PresentationPixelSpacing	DS	2	f	
(0068,6360)	Surface Model Description Sequence	SurfaceModelDescriptionSequence	SQ	1	f	
(0068,6380)	Surface Model Label	SurfaceModelLabel	LO	1	f	
(0068,6390)	Surface Model Scaling Factor	SurfaceModelScalingFactor	FD	1	f	
(0068,63a0)	Materials Code Sequence	MaterialsCodeSequence	SQ	1	f	
(0068,63a4)	Coating Materials Code Sequence	CoatingMaterialsCodeSequence	SQ	1	f	
(0068,63a8)	Implant Type Code Sequence	ImplantTypeCodeSequence	SQ	1	f	
(0068,63ac)	Fixation Method Code Sequence	FixationMethodCodeSequence	SQ	1	f	
(0068,63b0)	Mating Feature Sets Sequence	MatingFeatureSetsSequence	SQ	1	f	
(0068,63c0)	Mating Feature Set ID	MatingFeatureSetID	US	1	f	
(0068,63d0)	Mating Feature Set Label	MatingFeatureSetLabel	LO	1	f	
(0068,63e0)	Mating Feature Sequence	MatingFeatureSequence	SQ	1	f	
(0068,63f0)	Mating Feature ID	MatingFeatureID	US	1	f	
(0068,6400)	Mating Feature Degree of Freedom Sequence	MatingFeatureDegreeOfFreedomSequence	SQ	1	f	
(0068,6410)	Degree of Freedom ID	DegreeOfFreedomID	US	1	f	
(0068,6420)	Degree of Freedom Type	DegreeOfFreedomType	CS	1	f	
(0068,6430)	2D Mating Feature Coordinates Sequence	TwoDMatingFeatureCoordinatesSequence	SQ	1	f	
(0068,6440)	Referenced HPGL Document ID	ReferencedHPGLDocumentID	US	1	f	
(0068,6450)	2D Mating Point	TwoDMatingPoint	FD	2	f	
(0068,6460)	2D Mating Axes	TwoDMatingAxes	FD	4	f	
(0068,6470)	2D Degree of Freedom Sequence	TwoDDegreeOfFreedomSequence	SQ	1	f	
(0068,6490)	3D Degree of Freedom Axis	ThreeDDegreeOfFreedomAxis	FD	3	f	
(0068,64a0)	Range of Freedom	RangeOfFreedom	FD	2	f	
(0068,64c0)	3D Mating Point	ThreeDMatingPoint	FD	3	f	
(0068,64d0)	3D Mating Axes	ThreeDMatingAxes	FD	9	f	
(0068,64f0)	2D Degree of Freedom Axis	TwoDDegreeOfFreedomAxis	FD	3	f	
(0068,6500)	Planning Landmark Point Sequence	PlanningLandmarkPointSequence	SQ	1	f	
(0068,6510)	Planning Landmark Line Sequence	PlanningLandmarkLineSequence	SQ	1	f	
(0068,6520)	Planning Landmark Plane Sequence	PlanningLandmarkPlaneSequence	SQ	1	f	
(0068,6530)	Planning Landmark ID	PlanningLandmarkID	US	1	f	
(0068,6540)	Planning Landmark Description	PlanningLandmarkDescription	LO	1	f	
(0068,6545)	Planning Landmark Identification Code Sequence	PlanningLandmarkIdentificationCodeSequence	SQ	1	f	
(0068,6550)	2D Point Coordinates Sequence	TwoDPointCoordinatesSequence	SQ	1	f	
(0068,6560)	2D Point Coordinates	TwoDPointCoordinates	FD	2	f	
(0068,6590)	3D Point Coordinates	ThreeDPointCoordinates	FD	3	f	
(0068,65a0)	2D Line Coordinates Sequence	TwoDLineCoordinatesSequence	SQ	1	f	
(0068,65b0)	2D Line Coordinates	TwoDLineCoordinates	FD	4	f	
(0068,65d0)	3D Line Coordinates	ThreeDLineCoordinates	FD	6	f	
(0068,65e0)	2D Plane Coordinates Sequence	TwoDPlaneCoordinatesSequence	SQ	1	f	
(0068,65f0)	2D Plane Intersection	TwoDPlaneIntersection	FD	4	f	
(0068,6610)	3D Plane Origin	ThreeDPlaneOrigin	FD	3	f	
(0068,6620)	3D Plane Normal	ThreeDPlaneNormal	FD	3	f	
(0070,0001)	Graphic Annotation Sequence	GraphicAnnotationSequence	SQ	1	f	
(0070,0002)	Graphic Layer	GraphicLayer	CS	1	f	
(0070,0003)	Bounding Box Annotation Units	BoundingBoxAnnotationUnits	CS	1	f	
(0070,0004)	Anchor Point Annotation Units	AnchorPointAnnotationUnits	CS	1	f	
(0070,0005)	Graphic Annotation Units	GraphicAnnotationUnits	CS	1	f	
(0070,0006)	Unformatted Text Value	UnformattedTextValue	ST	1	f	
(0070,0008)	Text Object Sequence	TextObjectSequence	SQ	1	f	
(0070,0009)	Graphic Object Sequence	GraphicObjectSequence	SQ	1	f	
(0070,0010)	Bounding Box Top Left Hand Corner	BoundingBoxTopLeftHandCorner	FL	2	f	
(0070,0011)	Bounding Box Bottom Right Hand Corner	BoundingBoxBottomRightHandCorner	FL	2	f	
(0070,0012)	Bounding Box Text Horizontal Justification	BoundingBoxTextHorizontalJustification	CS	1	f	
(0070,0014)	Anchor Point	AnchorPoint	FL	2	f	
(0070,0015)	Anchor Point Visibility	AnchorPointVisibility	CS	1	f	
(0070,0020)	Graphic Dimensions	GraphicDimensions	US	1	f	
(0070,0021)	Number of Graphic Points	NumberOfGraphicPoints	US	1	f	
(0070,0022)	Graphic Data	GraphicData	FL	2-n	f	
(0070,0023)	Graphic Type	GraphicType	CS	1	f	
(0070,0024)	Graphic Filled	GraphicFilled	CS	1	f	
(0070,0040)	Image Rotation (Retired)	ImageRotationRetired	IS	1	t	
(0070,0041)	Image Horizontal Flip	ImageHorizontalFlip	CS	1	f	
(0070,0042)	Image Rotation	ImageRotation	US	1	f	
(0070,0050)	Displayed Area Top Left Hand Corner (Trial)	DisplayedAreaTopLeftHandCornerTrial	US	2	t	
(0070,0051)	Displayed Area Bottom Right Hand Corner (Trial)	DisplayedAreaBottomRightHandCornerTrial	US	2	t	
(0070,0052)	Displayed Area Top Left Hand Corner	DisplayedAreaTopLeftHandCorner	SL	2	f	
(0070,0053)	Displayed Area Bottom Right Hand Corner	DisplayedAreaBottomRightHandCorner	SL	2	f	
(0070,005a)	Displayed Area Selection Sequence	DisplayedAreaSelectionSequence	SQ	1	f	
(0070,0060)	Graphic Layer Sequence	GraphicLayerSequence	SQ	1	f	
(0070,0062)	Graphic Layer Order	GraphicLayerOrder	IS	1	f	
(0070,0066)	Graphic Layer Recommended Display Grayscale Value	GraphicLayerRecommendedDisplayGrayscaleValue	US	1	f	
(0070,0067)	Graphic Layer Recommended Display RGB Value	GraphicLayerRecommendedDisplayRGBValue	US	3	t	
(0070,0068)	Graphic Layer Description	GraphicLayerDescription	LO	1	f	
(0070,0080)	Content Label	ContentLabel	CS	1	f	
(0070,0081)	Content Description	ContentDescription	LO	1	f	
(0070,0082)	Presentation Creation Date	PresentationCreationDate	DA	1	f	
(0070,0083)	Presentation Creation Time	PresentationCreationTime	TM	1	f	
(0070,0084)	Content Creator's Name	ContentCreatorName	PN	1	f	
(0070,0086)	Content Creator's Identification Code Sequence	ContentCreatorIdentificationCodeSequence	SQ	1	f	
(0070,0087)	Alternate Content Description Sequence	AlternateContentDescriptionSequence	SQ	1	f	
(0070,0100)	Presentation Size Mode	PresentationSizeMode	CS	1	f	
(0070,0102)	Presentation Pixel Aspect Ratio	PresentationPixelAspectRatio	IS	2	f	
(0070,0103)	Presentation Pixel Magnification Ratio	PresentationPixelMagnificationRatio	FL	1	f	
(0070,0207)	Graphic Group Label	GraphicGroupLabel	LO	1	f	
(0070,0208)	Graphic Group Description	GraphicGroupDescription	ST	1	f	
(0070,0209)	Compound Graphic Sequence	CompoundGraphicSequence	SQ	1	f	
(0070,0226)	Compound Graphic Instance ID	CompoundGraphicInstanceID	UL	1	f	
(0070,0227)	Font Name	FontName	LO	1	f	
(0070,0228)	Font Name Type	FontNameType	CS	1	f	
(0070,0229)	CSS Font Name	CSSFontName	LO	1	f	
(0070,0230)	Rotation Angle	RotationAngle	FD	1	f	
(0070,0231)	Text Style Sequence	TextStyleSequence	SQ	1	f	
(0070,0232)	Line Style Sequence	LineStyleSequence	SQ	1	f	
(0070,0233)	Fill Style Sequence	FillStyleSequence	SQ	1	f	
(0070,0234)	Graphic Group Sequence	GraphicGroupSequence	SQ	1	f	
(0070,0241)	Text Color CIELab Value	TextColorCIELabValue	US	3	f	
(0070,0242)	Horizontal Alignment	HorizontalAlignment	CS	1	f	
(0070,0243)	Vertical Alignment	VerticalAlignment	CS	1	f	
(0070,0244)	Shadow Style	ShadowStyle	CS	1	f	
(0070,0245)	Shadow Offset X	ShadowOffsetX	FL	1	f	
(0070,0246)	Shadow Offset Y	ShadowOffsetY	FL	1	f	
(0070,0247)	Shadow Color CIELab Value	ShadowColorCIELabValue	US	3	f	
(0070,0248)	Underlined	Underlined	CS	1	f	
(0070,0249)	Bold	Bold	CS	1	f	
(0070,0250)	Italic	Italic	CS	1	f	
(0070,0251)	Pattern On Color CIELab Value	PatternOnColorCIELabValue	US	3	f	
(0070,0252)	Pattern Off Color CIELab Value	PatternOffColorCIELabValue	US	3	f	
(0070,0253)	Line Thickness	LineThickness	FL	1	f	
(0070,0254)	Line Dashing Style	LineDashingStyle	CS	1	f	
(0070,0255)	Line Pattern	LinePattern	UL	1	f	
(0070,0256)	Fill Pattern	FillPattern	OB	1	f	
(0070,0257)	Fill Mode	FillMode	CS	1	f	
(0070,0258)	Shadow Opacity	ShadowOpacity	FL	1	f	
(0070,0261)	Gap Length	GapLength	FL	1	f	
(0070,0262)	Diameter of Visibility	DiameterOfVisibility	FL	1	f	
(0070,0273)	Rotation Point	RotationPoint	FL	2	f	
(0070,0274)	Tick Alignment	TickAlignment	CS	1	f	
(0070,0278)	Show Tick Label	ShowTickLabel	CS	1	f	
(0070,0279)	Tick Label Alignment	TickLabelAlignment	CS	1	f	
(0070,0282)	Compound Graphic Units	CompoundGraphicUnits	CS	1	f	
(0070,0284)	Pattern On Opacity	PatternOnOpacity	FL	1	f	
(0070,0285)	Pattern Off Opacity	PatternOffOpacity	FL	1	f	
(0070,0287)	Major Ticks Sequence	MajorTicksSequence	SQ	1	f	
(0070,0288)	Tick Position	TickPosition	FL	1	f	
(0070,0289)	Tick Label	TickLabel	SH	1	f	
(0070,0294)	Compound Graphic Type	CompoundGraphicType	CS	1	f	
(0070,0295)	Graphic Group ID	GraphicGroupID	UL	1	f	
(0070,0306)	Shape Type	ShapeType	CS	1	f	
(0070,0308)	Registration Sequence	RegistrationSequence	SQ	1	f	
(0070,0309)	Matrix Registration Sequence	MatrixRegistrationSequence	SQ	1	f	
(0070,030a)	Matrix Sequence	MatrixSequence	SQ	1	f	
(0070,030b)	Frame of Reference to Displayed Coordinate System Transformation Matrix	FrameOfReferenceToDisplayedCoordinateSystemTransformationMatrix	FD	16	f	
(0070,030c)	Frame of Reference Transformation Matrix Type	FrameOfReferenceTransformationMatrixType	CS	1	f	
(0070,030d)	Registration Type Code Sequence	RegistrationTypeCodeSequence	SQ	1	f	
(0070,030f)	Fiducial Description	FiducialDescription	ST	1	f	
(0070,0310)	Fiducial Identifier	FiducialIdentifier	SH	1	f	
(0070,0311)	Fiducial Identifier Code Sequence	FiducialIdentifierCodeSequence	SQ	1	f	
(0070,0312)	Contour Uncertainty Radius	ContourUncertaintyRadius	FD	1	f	
(0070,0314)	Used Fiducials Sequence	UsedFiducialsSequence	SQ	1	f	
(0070,0318)	Graphic Coordinates Data Sequence	GraphicCoordinatesDataSequence	SQ	1	f	
(0070,031a)	Fiducial UID	FiducialUID	UI	1	f	
(0070,031c)	Fiducial Set Sequence	FiducialSetSequence	SQ	1	f	
(0070,031e)	Fiducial Sequence	FiducialSequence	SQ	1	f	
(0070,0401)	Graphic Layer Recommended Display CIELab Value	GraphicLayerRecommendedDisplayCIELabValue	US	3	f	
(0070,0402)	Blending Sequence	BlendingSequence	SQ	1	f	
(0070,0403)	Relative Opacity	RelativeOpacity	FL	1	f	
(0070,0404)	Referenced Spatial Registration Sequence	ReferencedSpatialRegistrationSequence	SQ	1	f	
(0070,0405)	Blending Position	BlendingPosition	CS	1	f	
(0070,1101)	Presentation Display Collection UID	PresentationDisplayCollectionUID	UI	1	f	
(0070,1102)	Presentation Sequence Collection UID	PresentationSequenceCollectionUID	UI	1	f	
(0070,1103)	Presentation Sequence Position Index	PresentationSequencePositionIndex	US	1	f	
(0070,1104)	Rendered Image Reference Sequence	RenderedImageReferenceSequence	SQ	1	f	
(0070,1201)	Volumetric Presentation State Input Sequence	VolumetricPresentationStateInputSequence	SQ	1	f	
(0070,1202)	Presentation Input Type	PresentationInputType	CS	1	f	
(0070,1203)	Input Sequence Position Index	InputSequencePositionIndex	US	1	f	
(0070,1204)	Crop	Crop	CS	1	f	
(0070,1205)	Cropping Specification Index	CroppingSpecificationIndex	US	1-n	f	
(0070,1206)	Compositing Method	CompositingMethod	CS	1	f	
(0070,1207)	Volumetric Presentation Input Number	VolumetricPresentationInputNumber	US	1	f	
(0070,1208)	Image Volume Geometry	ImageVolumeGeometry	CS	1	f	
(0070,1301)	Volume Cropping Sequence	VolumeCroppingSequence	SQ	1	f	
(0070,1302)	Volume Cropping Method	VolumeCroppingMethod	CS	1	f	
(0070,1303)	Bounding Box Crop	BoundingBoxCrop	FD	6	f	
(0070,1304)	Oblique Cropping Plane Sequence	ObliqueCroppingPlaneSequence	SQ	1	f	
(0070,1305)	Plane	Plane	FD	4	f	
(0070,1306)	Plane Normal	PlaneNormal	FD	3	f	
(0070,1309)	Cropping Specification Number	CroppingSpecificationNumber	US	1	f	
(0076,0055)	Component ID	ComponentID	US	1	f	
(0070,1501)	Multi-Planar Reconstruction Style	MultiPlanarReconstructionStyle	CS	1	f	
(0070,1502)	MPR Thickness Type	MPRThicknessType	CS	1	f	
(0070,1503)	MPR Slab Thickness	MPRSlabThickness	FD	1	f	
(0070,1505)	MPR Top Left Hand Corner	MPRTopLeftHandCorner	FD	3	f	
(0070,1507)	MPR View Width Direction	MPRViewWidthDirection	FD	3	f	
(0070,1508)	MPR View Width	MPRViewWidth	FD	1	f	
(0070,150c)	Number of Volumetric Curve Points	NumberOfVolumetricCurvePoints	UL	1	f	
(0070,150d)	Volumetric Curve Points	VolumetricCurvePoints	OD	1	f	
(0070,1511)	MPR View Height Direction	MPRViewHeightDirection	FD	3	f	
(0070,1512)	MPR View Height	MPRViewHeight	FD	1	f	
(0070,1801)	Presentation State Classification Component Sequence	PresentationStateClassificationComponentSequence	SQ	1	f	
(0070,1802)	Component Type	ComponentType	CS	1	f	
(0070,1803)	Component Input Sequence	ComponentInputSequence	SQ	1	f	
(0070,1804)	Volumetric Presentation Input Index	VolumetricPresentationInputIndex	US	1	f	
(0070,1805)	Presentation State Compositor Component Sequence	PresentationStateCompositorComponentSequence	SQ	1	f	
(0070,1806)	Weighting Transfer Function Sequence	WeightingTransferFunctionSequence	SQ	1	f	
(0070,1807)	Weighting Lookup Table Descriptor	WeightingLookupTableDescriptor	US	3	f	
(0070,1808)	Weighting Lookup Table Data	WeightingLookupTableData	OB	1	f	
(0070,1901)	Volumetric Annotation Sequence	VolumetricAnnotationSequence	SQ	1	f	
(0070,1903)	Referenced Structured Context Sequence	ReferencedStructuredContextSequence	SQ	1	f	
(0070,1904)	Referenced Content Item	ReferencedContentItem	UI	1	f	
(0070,1905)	Volumetric Presentation Input Annotation Sequence	VolumetricPresentationInputAnnotationSequence	SQ	1	f	
(0070,1907)	Annotation Clipping	AnnotationClipping	CS	1	f	
(0070,1a01)	Presentation Animation Style	PresentationAnimationStyle	CS	1	f	
(0070,1a03)	Recommended Animation Rate	RecommendedAnimationRate	FD	1	f	
(0070,1a04)	Animation Curve Sequence	AnimationCurveSequence	SQ	1	f	
(0070,1a05)	Animation Step Size	AnimationStepSize	FD	1	f	
(0072,0002)	Hanging Protocol Name	HangingProtocolName	SH	1	f	
(0072,0004)	Hanging Protocol Description	HangingProtocolDescription	LO	1	f	
(0072,0006)	Hanging Protocol Level	HangingProtocolLevel	CS	1	f	
(0072,0008)	Hanging Protocol Creator	HangingProtocolCreator	LO	1	f	
(0072,000a)	Hanging Protocol Creation DateTime	HangingProtocolCreationDateTime	DT	1	f	
(0072,000c)	Hanging Protocol Definition Sequence	HangingProtocolDefinitionSequence	SQ	1	f	
(0072,000e)	Hanging Protocol User Identification Code Sequence	HangingProtocolUserIdentificationCodeSequence	SQ	1	f	
(0072,0010)	Hanging Protocol User Group Name	HangingProtocolUserGroupName	LO	1	f	
(0072,0012)	Source Hanging Protocol Sequence	SourceHangingProtocolSequence	SQ	1	f	
(0072,0014)	Number of Priors Referenced	NumberOfPriorsReferenced	US	1	f	
(0072,0020)	Image Sets Sequence	ImageSetsSequence	SQ	1	f	
(0072,0022)	Image Set Selector Sequence	ImageSetSelectorSequence	SQ	1	f	
(0072,0024)	Image Set Selector Usage Flag	ImageSetSelectorUsageFlag	CS	1	f	
(0072,0026)	Selector Attribute	SelectorAttribute	AT	1	f	
(0072,0028)	Selector Value Number	SelectorValueNumber	US	1	f	
(0072,0030)	Time Based Image Sets Sequence	TimeBasedImageSetsSequence	SQ	1	f	
(0072,0032)	Image Set Number	ImageSetNumber	US	1	f	
(0072,0034)	Image Set Selector Category	ImageSetSelectorCategory	CS	1	f	
(0072,0038)	Relative Time	RelativeTime	US	2	f	
(0072,003a)	Relative Time Units	RelativeTimeUnits	CS	1	f	
(0072,003c)	Abstract Prior Value	AbstractPriorValue	SS	2	f	
(0072,003e)	Abstract Prior Code Sequence	AbstractPriorCodeSequence	SQ	1	f	
(0072,0040)	Image Set Label	ImageSetLabel	LO	1	f	
(0072,0050)	Selector Attribute VR	SelectorAttributeVR	CS	1	f	
(0072,0052)	Selector Sequence Pointer	SelectorSequencePointer	AT	1-n	f	
(0072,0054)	Selector Sequence Pointer Private Creator	SelectorSequencePointerPrivateCreator	LO	1-n	f	
(0072,0056)	Selector Attribute Private Creator	SelectorAttributePrivateCreator	LO	1	f	
(0072,005e)	Selector AE Value	SelectorAEValue	AE	1-n	f	
(0072,005f)	Selector AS Value	SelectorASValue	AS	1-n	f	
(0072,0060)	Selector AT Value	SelectorATValue	AT	1-n	f	
(0072,0061)	Selector DA Value	SelectorDAValue	DA	1-n	f	
(0072,0062)	Selector CS Value	SelectorCSValue	CS	1-n	f	
(0072,0063)	Selector DT Value	SelectorDTValue	DT	1-n	f	
(0072,0064)	Selector IS Value	SelectorISValue	IS	1-n	f	
(0072,0065)	Selector OB Value	SelectorOBValue	OB	1	f	
(0072,0066)	Selector LO Value	SelectorLOValue	LO	1-n	f	
(0072,0067)	Selector OF Value	SelectorOFValue	OF	1	f	
(0072,0068)	Selector LT Value	SelectorLTValue	LT	1	f	
(0072,0069)	Selector OW Value	SelectorOWValue	OW	1	f	
(0072,006a)	Selector PN Value	SelectorPNValue	PN	1-n	f	
(0072,006b)	Selector TM Value	SelectorTMValue	TM	1-n	f	
(0072,006c)	Selector SH Value	SelectorSHValue	SH	1-n	f	
(0072,006d)	Selector UN Value	SelectorUNValue	UN	1	f	
(0072,006e)	Selector ST Value	SelectorSTValue	ST	1	f	
(0072,006f)	Selector UC Value	SelectorUCValue	UC	1-n	f	
(0072,0070)	Selector UT Value	SelectorUTValue	UT	1	f	
(0072,0071)	Selector UR Value	SelectorURValue	UR	1	f	
(0072,0072)	Selector DS Value	SelectorDSValue	DS	1-n	f	
(0072,0073)	Selector OD Value	SelectorODValue	OD	1	f	
(0072,0074)	Selector FD Value	SelectorFDValue	FD	1-n	f	
(0072,0075)	Selector OL Value	SelectorOLValue	OL	1	f	
(0072,0076)	Selector FL Value	SelectorFLValue	FL	1-n	f	
(0072,0078)	Selector UL Value	SelectorULValue	UL	1-n	f	
(0072,007a)	Selector US Value	SelectorUSValue	US	1-n	f	
(0072,007c)	Selector SL Value	SelectorSLValue	SL	1-n	f	
(0072,007e)	Selector SS Value	SelectorSSValue	SS	1-n	f	
(0072,007f)	Selector UI Value	SelectorUIValue	UI	1-n	f	
(0072,0080)	Selector Code Sequence Value	SelectorCodeSequenceValue	SQ	1	f	
(0072,0100)	Number of Screens	NumberOfScreens	US	1	f	
(0072,0102)	Nominal Screen Definition Sequence	NominalScreenDefinitionSequence	SQ	1	f	
(0072,0104)	Number of Vertical Pixels	NumberOfVerticalPixels	US	1	f	
(0072,0106)	Number of Horizontal Pixels	NumberOfHorizontalPixels	US	1	f	
(0072,0108)	Display Environment Spatial Position	DisplayEnvironmentSpatialPosition	FD	4	f	
(0072,010a)	Screen Minimum Grayscale Bit Depth	ScreenMinimumGrayscaleBitDepth	US	1	f	
(0072,010c)	Screen Minimum Color Bit Depth	ScreenMinimumColorBitDepth	US	1	f	
(0072,010e)	Application Maximum Repaint Time	ApplicationMaximumRepaintTime	US	1	f	
(0072,0200)	Display Sets Sequence	DisplaySetsSequence	SQ	1	f	
(0072,0202)	Display Set Number	DisplaySetNumber	US	1	f	
(0072,0203)	Display Set Label	DisplaySetLabel	LO	1	f	
(0072,0204)	Display Set Presentation Group	DisplaySetPresentationGroup	US	1	f	
(0072,0206)	Display Set Presentation Group Description	DisplaySetPresentationGroupDescription	LO	1	f	
(0072,0208)	Partial Data Display Handling	PartialDataDisplayHandling	CS	1	f	
(0072,0210)	Synchronized Scrolling Sequence	SynchronizedScrollingSequence	SQ	1	f	
(0072,0212)	Display Set Scrolling Group	DisplaySetScrollingGroup	US	2-n	f	
(0072,0214)	Navigation Indicator Sequence	NavigationIndicatorSequence	SQ	1	f	
(0072,0216)	Navigation Display Set	NavigationDisplaySet	US	1	f	
(0072,0218)	Reference Display Sets	ReferenceDisplaySets	US	1-n	f	
(0072,0300)	Image Boxes Sequence	ImageBoxesSequence	SQ	1	f	
(0072,0302)	Image Box Number	ImageBoxNumber	US	1	f	
(0072,0304)	Image Box Layout Type	ImageBoxLayoutType	CS	1	f	
(0072,0306)	Image Box Tile Horizontal Dimension	ImageBoxTileHorizontalDimension	US	1	f	
(0072,0308)	Image Box Tile Vertical Dimension	ImageBoxTileVerticalDimension	US	1	f	
(0072,0310)	Image Box Scroll Direction	ImageBoxScrollDirection	CS	1	f	
(0072,0312)	Image Box Small Scroll Type	ImageBoxSmallScrollType	CS	1	f	
(0072,0314)	Image Box Small Scroll Amount	ImageBoxSmallScrollAmount	US	1	f	
(0072,0316)	Image Box Large Scroll Type	ImageBoxLargeScrollType	CS	1	f	
(0072,0318)	Image Box Large Scroll Amount	ImageBoxLargeScrollAmount	US	1	f	
(0072,0320)	Image Box Overlap Priority	ImageBoxOverlapPriority	US	1	f	
(0072,0330)	Cine Relative to Real-Time	CineRelativeToRealTime	FD	1	f	
(0072,0400)	Filter Operations Sequence	FilterOperationsSequence	SQ	1	f	
(0072,0402)	Filter-by Category	FilterByCategory	CS	1	f	
(0072,0404)	Filter-by Attribute Presence	FilterByAttributePresence	CS	1	f	
(0072,0406)	Filter-by Operator	FilterByOperator	CS	1	f	
(0072,0420)	Structured Display Background CIELab Value	StructuredDisplayBackgroundCIELabValue	US	3	f	
(0072,0421)	Empty Image Box CIELab Value	EmptyImageBoxCIELabValue	US	3	f	
(0072,0422)	Structured Display Image Box Sequence	StructuredDisplayImageBoxSequence	SQ	1	f	
(0072,0424)	Structured Display Text Box Sequence	StructuredDisplayTextBoxSequence	SQ	1	f	
(0072,0427)	Referenced First Frame Sequence	ReferencedFirstFrameSequence	SQ	1	f	
(0072,0430)	Image Box Synchronization Sequence	ImageBoxSynchronizationSequence	SQ	1	f	
(0072,0432)	Synchronized Image Box List	SynchronizedImageBoxList	US	2-n	f	
(0072,0434)	Type of Synchronization	TypeOfSynchronization	CS	1	f	
(0072,0500)	Blending Operation Type	BlendingOperationType	CS	1	f	
(0072,0510)	Reformatting Operation Type	ReformattingOperationType	CS	1	f	
(0072,0512)	Reformatting Thickness	ReformattingThickness	FD	1	f	
(0072,0514)	Reformatting Interval	ReformattingInterval	FD	1	f	
(0072,0516)	Reformatting Operation Initial View Direction	ReformattingOperationInitialViewDirection	CS	1	f	
(0072,0520)	3D Rendering Type	ThreeDRenderingType	CS	1-n	f	
(0072,0600)	Sorting Operations Sequence	SortingOperationsSequence	SQ	1	f	
(0072,0602)	Sort-by Category	SortByCategory	CS	1	f	
(0072,0604)	Sorting Direction	SortingDirection	CS	1	f	
(0072,0700)	Display Set Patient Orientation	DisplaySetPatientOrientation	CS	2	f	
(0072,0702)	VOI Type	VOIType	CS	1	f	
(0072,0704)	Pseudo-Color Type	PseudoColorType	CS	1	f	
(0072,0705)	Pseudo-Color Palette Instance Reference Sequence	PseudoColorPaletteInstanceReferenceSequence	SQ	1	f	
(0072,0706)	Show Grayscale Inverted	ShowGrayscaleInverted	CS	1	f	
(0072,0710)	Show Image True Size Flag	ShowImageTrueSizeFlag	CS	1	f	
(0072,0712)	Show Graphic Annotation Flag	ShowGraphicAnnotationFlag	CS	1	f	
(0072,0714)	Show Patient Demographics Flag	ShowPatientDemographicsFlag	CS	1	f	
(0072,0716)	Show Acquisition Techniques Flag	ShowAcquisitionTechniquesFlag	CS	1	f	
(0072,0717)	Display Set Horizontal Justification	DisplaySetHorizontalJustification	CS	1	f	
(0072,0718)	Display Set Vertical Justification	DisplaySetVerticalJustification	CS	1	f	
(0074,0120)	Continuation Start Meterset	ContinuationStartMeterset	FD	1	f	
(0074,0121)	Continuation End Meterset	ContinuationEndMeterset	FD	1	f	
(0074,1000)	Procedure Step State	ProcedureStepState	CS	1	f	
(0074,1002)	Procedure Step Progress Information Sequence	ProcedureStepProgressInformationSequence	SQ	1	f	
(0074,1004)	Procedure Step Progress	ProcedureStepProgress	DS	1	f	
(0074,1006)	Procedure Step Progress Description	ProcedureStepProgressDescription	ST	1	f	
(0074,1008)	Procedure Step Communications URI Sequence	ProcedureStepCommunicationsURISequence	SQ	1	f	
(0074,100a)	Contact URI	ContactURI	UR	1	f	
(0074,100c)	Contact Display Name	ContactDisplayName	LO	1	f	
(0074,100e)	Procedure Step Discontinuation Reason Code Sequence	ProcedureStepDiscontinuationReasonCodeSequence	SQ	1	f	
(0074,1020)	Beam Task Sequence	BeamTaskSequence	SQ	1	f	
(0074,1022)	Beam Task Type	BeamTaskType	CS	1	f	
(0074,1024)	Beam Order Index (Trial)	BeamOrderIndexTrial	IS	1	t	
(0074,1025)	Autosequence Flag	AutosequenceFlag	CS	1	f	
(0074,1026)	Table Top Vertical Adjusted Position	TableTopVerticalAdjustedPosition	FD	1	f	
(0074,1027)	Table Top Longitudinal Adjusted Position	TableTopLongitudinalAdjustedPosition	FD	1	f	
(0074,1028)	Table Top Lateral Adjusted Position	TableTopLateralAdjustedPosition	FD	1	f	
(0074,102a)	Patient Support Adjusted Angle	PatientSupportAdjustedAngle	FD	1	f	
(0074,102b)	Table Top Eccentric Adjusted Angle	TableTopEccentricAdjustedAngle	FD	1	f	
(0074,102c)	Table Top Pitch Adjusted Angle	TableTopPitchAdjustedAngle	FD	1	f	
(0074,102d)	Table Top Roll Adjusted Angle	TableTopRollAdjustedAngle	FD	1	f	
(0074,1030)	Delivery Verification Image Sequence	DeliveryVerificationImageSequence	SQ	1	f	
(0074,1032)	Verification Image Timing	VerificationImageTiming	CS	1	f	
(0074,1034)	Double Exposure Flag	DoubleExposureFlag	CS	1	f	
(0074,1036)	Double Exposure Ordering	DoubleExposureOrdering	CS	1	f	
(0074,1038)	Double Exposure Meterset (Trial)	DoubleExposureMetersetTrial	DS	1	t	
(0074,103a)	Double Exposure Field Delta (Trial)	DoubleExposureFieldDeltaTrial	DS	4	t	
(0074,1040)	Related Reference RT Image Sequence	RelatedReferenceRTImageSequence	SQ	1	f	
(0074,1042)	General Machine Verification Sequence	GeneralMachineVerificationSequence	SQ	1	f	
(0074,1044)	Conventional Machine Verification Sequence	ConventionalMachineVerificationSequence	SQ	1	f	
(0074,1046)	Ion Machine Verification Sequence	IonMachineVerificationSequence	SQ	1	f	
(0074,1048)	Failed Attributes Sequence	FailedAttributesSequence	SQ	1	f	
(0074,104a)	Overridden Attributes Sequence	OverriddenAttributesSequence	SQ	1	f	
(0074,104c)	Conventional Control Point Verification Sequence	ConventionalControlPointVerificationSequence	SQ	1	f	
(0074,104e)	Ion Control Point Verification Sequence	IonControlPointVerificationSequence	SQ	1	f	
(0074,1050)	Attribute Occurrence Sequence	AttributeOccurrenceSequence	SQ	1	f	
(0074,1052)	Attribute Occurrence Pointer	AttributeOccurrencePointer	AT	1	f	
(0074,1054)	Attribute Item Selector	AttributeItemSelector	UL	1	f	
(0074,1056)	Attribute Occurrence Private Creator	AttributeOccurrencePrivateCreator	LO	1	f	
(0074,1057)	Selector Sequence Pointer Items	SelectorSequencePointerItems	IS	1-n	f	
(0074,1200)	Scheduled Procedure Step Priority	ScheduledProcedureStepPriority	CS	1	f	
(0074,1202)	Worklist Label	WorklistLabel	LO	1	f	
(0074,1204)	Procedure Step Label	ProcedureStepLabel	LO	1	f	
(0074,1210)	Scheduled Processing Parameters Sequence	ScheduledProcessingParametersSequence	SQ	1	f	
(0074,1212)	Performed Processing Parameters Sequence	PerformedProcessingParametersSequence	SQ	1	f	
(0074,1216)	Unified Procedure Step Performed Procedure Sequence	UnifiedProcedureStepPerformedProcedureSequence	SQ	1	f	
(0074,1220)	Related Procedure Step Sequence	RelatedProcedureStepSequence	SQ	1	t	
(0074,1222)	Procedure Step Relationship Type	ProcedureStepRelationshipType	LO	1	t	
(0074,1224)	Replaced Procedure Step Sequence	ReplacedProcedureStepSequence	SQ	1	f	
(0074,1230)	Deletion Lock	DeletionLock	LO	1	f	
(0074,1234)	Receiving AE	ReceivingAE	AE	1	f	
(0074,1236)	Requesting AE	RequestingAE	AE	1	f	
(0074,1238)	Reason for Cancellation	ReasonForCancellation	LT	1	f	
(0074,1242)	SCP Status	SCPStatus	CS	1	f	
(0074,1244)	Subscription List Status	SubscriptionListStatus	CS	1	f	
(0074,1246)	Unified Procedure Step List Status	UnifiedProcedureStepListStatus	CS	1	f	
(0074,1324)	Beam Order Index	BeamOrderIndex	UL	1	f	
(0074,1338)	Double Exposure Meterset	DoubleExposureMeterset	FD	1	f	
(0074,133a)	Double Exposure Field Delta	DoubleExposureFieldDelta	FD	4	f	
(0074,1401)	Brachy Task Sequence	BrachyTaskSequence	SQ	1	f	
(0074,1402)	Continuation Start Total Reference Air Kerma	ContinuationStartTotalReferenceAirKerma	DS	1	f	
(0074,1403)	Continuation End Total Reference Air Kerma	ContinuationEndTotalReferenceAirKerma	DS	1	f	
(0074,1404)	Continuation Pulse Number	ContinuationPulseNumber	IS	1	f	
(0074,1405)	Channel Delivery Order Sequence	ChannelDeliveryOrderSequence	SQ	1	f	
(0074,1406)	Referenced Channel Number	ReferencedChannelNumber	IS	1	f	
(0074,1407)	Start Cumulative Time Weight	StartCumulativeTimeWeight	DS	1	f	
(0074,1408)	End Cumulative Time Weight	EndCumulativeTimeWeight	DS	1	f	
(0074,1409)	Omitted Channel Sequence	OmittedChannelSequence	SQ	1	f	
(0074,140a)	Reason for Channel Omission	ReasonForChannelOmission	CS	1	f	
(0074,140b)	Reason for Channel Omission Description	ReasonForChannelOmissionDescription	LO	1	f	
(0074,140c)	Channel Delivery Order Index	ChannelDeliveryOrderIndex	IS	1	f	
(0074,140d)	Channel Delivery Continuation Sequence	ChannelDeliveryContinuationSequence	SQ	1	f	
(0074,140e)	Omitted Application Setup Sequence	OmittedApplicationSetupSequence	SQ	1	f	
(0076,0001)	Implant Assembly Template Name	ImplantAssemblyTemplateName	LO	1	f	
(0076,0003)	Implant Assembly Template Issuer	ImplantAssemblyTemplateIssuer	LO	1	f	
(0076,0006)	Implant Assembly Template Version	ImplantAssemblyTemplateVersion	LO	1	f	
(0076,0008)	Replaced Implant Assembly Template Sequence	ReplacedImplantAssemblyTemplateSequence	SQ	1	f	
(0076,000a)	Implant Assembly Template Type	ImplantAssemblyTemplateType	CS	1	f	
(0076,000c)	Original Implant Assembly Template Sequence	OriginalImplantAssemblyTemplateSequence	SQ	1	f	
(0076,000e)	Derivation Implant Assembly Template Sequence	DerivationImplantAssemblyTemplateSequence	SQ	1	f	
(0076,0010)	Implant Assembly Template Target Anatomy Sequence	ImplantAssemblyTemplateTargetAnatomySequence	SQ	1	f	
(0076,0020)	Procedure Type Code Sequence	ProcedureTypeCodeSequence	SQ	1	f	
(0076,0030)	Surgical Technique	SurgicalTechnique	LO	1	f	
(0076,0032)	Component Types Sequence	ComponentTypesSequence	SQ	1	f	
(0076,0034)	Component Type Code Sequence	ComponentTypeCodeSequence	CS	1	f	
(0076,0036)	Exclusive Component Type	ExclusiveComponentType	CS	1	f	
(0076,0038)	Mandatory Component Type	MandatoryComponentType	CS	1	f	
(0076,0040)	Component Sequence	ComponentSequence	SQ	1	f	
(0076,0060)	Component Assembly Sequence	ComponentAssemblySequence	SQ	1	f	
(0076,0070)	Component 1 Referenced ID	Component1ReferencedID	US	1	f	
(0076,0080)	Component 1 Referenced Mating Feature Set ID	Component1ReferencedMatingFeatureSetID	US	1	f	
(0076,0090)	Component 1 Referenced Mating Feature ID	Component1ReferencedMatingFeatureID	US	1	f	
(0076,00a0)	Component 2 Referenced ID	Component2ReferencedID	US	1	f	
(0076,00b0)	Component 2 Referenced Mating Feature Set ID	Component2ReferencedMatingFeatureSetID	US	1	f	
(0076,00c0)	Component 2 Referenced Mating Feature ID	Component2ReferencedMatingFeatureID	US	1	f	
(0078,0001)	Implant Template Group Name	ImplantTemplateGroupName	LO	1	f	
(0078,0010)	Implant Template Group Description	ImplantTemplateGroupDescription	ST	1	f	
(0078,0020)	Implant Template Group Issuer	ImplantTemplateGroupIssuer	LO	1	f	
(0078,0024)	Implant Template Group Version	ImplantTemplateGroupVersion	LO	1	f	
(0078,0026)	Replaced Implant Template Group Sequence	ReplacedImplantTemplateGroupSequence	SQ	1	f	
(0078,0028)	Implant Template Group Target Anatomy Sequence	ImplantTemplateGroupTargetAnatomySequence	SQ	1	f	
(0078,002a)	Implant Template Group Members Sequence	ImplantTemplateGroupMembersSequence	SQ	1	f	
(0078,002e)	Implant Template Group Member ID	ImplantTemplateGroupMemberID	US	1	f	
(0078,0050)	3D Implant Template Group Member Matching Point	ThreeDImplantTemplateGroupMemberMatchingPoint	FD	3	f	
(0078,0060)	3D Implant Template Group Member Matching Axes	ThreeDImplantTemplateGroupMemberMatchingAxes	FD	9	f	
(0078,0070)	Implant Template Group Member Matching 2D Coordinates Sequence	ImplantTemplateGroupMemberMatching2DCoordinatesSequence	SQ	1	f	
(0078,0090)	2D Implant Template Group Member Matching Point	TwoDImplantTemplateGroupMemberMatchingPoint	FD	2	f	
(0078,00a0)	2D Implant Template Group Member Matching Axes	TwoDImplantTemplateGroupMemberMatchingAxes	FD	4	f	
(0078,00b0)	Implant Template Group Variation Dimension Sequence	ImplantTemplateGroupVariationDimensionSequence	SQ	1	f	
(0078,00b2)	Implant Template Group Variation Dimension Name	ImplantTemplateGroupVariationDimensionName	LO	1	f	
(0078,00b4)	Implant Template Group Variation Dimension Rank Sequence	ImplantTemplateGroupVariationDimensionRankSequence	SQ	1	f	
(0078,00b6)	Referenced Implant Template Group Member ID	ReferencedImplantTemplateGroupMemberID	US	1	f	
(0078,00b8)	Implant Template Group Variation Dimension Rank	ImplantTemplateGroupVariationDimensionRank	US	1	f	
(0080,0001)	Surface Scan Acquisition Type Code Sequence	SurfaceScanAcquisitionTypeCodeSequence	SQ	1	f	
(0080,0002)	Surface Scan Mode Code Sequence	SurfaceScanModeCodeSequence	SQ	1	f	
(0080,0003)	Registration Method Code Sequence	RegistrationMethodCodeSequence	SQ	1	f	
(0080,0004)	Shot Duration Time	ShotDurationTime	FD	1	f	
(0080,0005)	Shot Offset Time	ShotOffsetTime	FD	1	f	
(0080,0006)	Surface Point Presentation Value Data	SurfacePointPresentationValueData	US	1-n	f	
(0080,0007)	Surface Point Color CIELab Value Data	SurfacePointColorCIELabValueData	US	3-3n	f	
(0080,0008)	UV Mapping Sequence	UVMappingSequence	SQ	1	f	
(0080,0009)	Texture Label	TextureLabel	SH	1	f	
(0080,0010)	U Value Data	UValueData	OF	1-n	f	
(0080,0011)	V Value Data	VValueData	OF	1-n	f	
(0080,0012)	Referenced Texture Sequence	ReferencedTextureSequence	SQ	1	f	
(0080,0013)	Referenced Surface Data Sequence	ReferencedSurfaceDataSequence	SQ	1	f	
(0082,0001)	Assessment Summary	AssessmentSummary	CS	1	f	
(0082,0003)	Assessment Summary Description	AssessmentSummaryDescription	UT	1	f	
(0082,0004)	Assessed SOP Instance Sequence	AssessedSOPInstanceSequence	SQ	1	f	
(0082,0005)	Referenced Comparison SOP Instance Sequence	ReferencedComparisonSOPInstanceSequence	SQ	1	f	
(0082,0006)	Number of Assessment Observations	NumberOfAssessmentObservations	UL	1	f	
(0082,0007)	Assessment Observations Sequence	AssessmentObservationsSequence	SQ	1	f	
(0082,0008)	Observation Significance	ObservationSignificance	CS	1	f	
(0082,000a)	Observation Description	ObservationDescription	UT	1	f	
(0082,000c)	Structured Constraint Observation Sequence	StructuredContraintObservationSequence	SQ	1	f	
(0082,0010)	Assessed Attribute Value Sequence	AssessedAttributeValueSequence	SQ	1	f	
(0082,0016)	Assessment Set ID	AssessmentSetID	LO	1	f	
(0082,0017)	Assessment Requester Sequence	AssessmentRequesterSequence	SQ	1	f	
(0082,0018)	Selector Attribute Name	SelectorAttributeName	LO	1	f	
(0082,0019)	Selector Attribute Keyword	SelectorAttributeKeyword	LO	1	f	
(0082,0021)	Assessment Type Code Sequence	AssessmentTypeCodeSequence	SQ	1	f	
(0082,0022)	Observation Basis Code Sequence	ObservationBasisCodeSequence	SQ	1	f	
(0082,0023)	Assessment Label	AssessmentLabel	LO	1	f	
(0082,0032)	Constraint Type	ConstraintType	CS	1	f	
(0082,0033)	Specification Selection Guidance	SpecificationSelectionGuidance	UT	1	f	
(0082,0034)	Constraint Value Sequence	ConstraintValueSequence	SQ	1	f	
(0082,0035)	Recommended Default Value Sequence	RecommendedDefaultValueSequence	SQ	1	f	
(0082,0036)	Constraint Violation Significance	ConstraintViolationSignificance	CS	1	f	
(0082,0037)	Constraint Violation Condition	ConstraintViolationCondition	UT	1	f	
(0088,0130)	Storage Media File-set ID	StorageMediaFileSetID	SH	1	f	
(0088,0140)	Storage Media File-set UID	StorageMediaFileSetUID	UI	1	f	
(0088,0200)	Icon Image Sequence	IconImageSequence	SQ	1	f	
(0088,0904)	Topic Title	TopicTitle	LO	1	t	
(0088,0906)	Topic Subject	TopicSubject	ST	1	t	
(0088,0910)	Topic Author	TopicAuthor	LO	1	t	
(0088,0912)	Topic Keywords	TopicKeywords	LO	1-32	t	
(0100,0410)	SOP Instance Status	SOPInstanceStatus	CS	1	f	
(0100,0420)	SOP Authorization DateTime	SOPAuthorizationDateTime	DT	1	f	
(0100,0424)	SOP Authorization Comment	SOPAuthorizationComment	LT	1	f	
(0100,0426)	Authorization Equipment Certification Number	AuthorizationEquipmentCertificationNumber	LO	1	f	
(0400,0005)	MAC ID Number	MACIDNumber	US	1	f	
(0400,0010)	MAC Calculation Transfer Syntax UID	MACCalculationTransferSyntaxUID	UI	1	f	
(0400,0015)	MAC Algorithm	MACAlgorithm	CS	1	f	
(0400,0020)	Data Elements Signed	DataElementsSigned	AT	1-n	f	
(0400,0100)	Digital Signature UID	DigitalSignatureUID	UI	1	f	
(0400,0105)	Digital Signature DateTime	DigitalSignatureDateTime	DT	1	f	
(0400,0110)	Certificate Type	CertificateType	CS	1	f	
(0400,0115)	Certificate of Signer	CertificateOfSigner	OB	1	f	
(0400,0120)	Signature	Signature	OB	1	f	
(0400,0305)	Certified Timestamp Type	CertifiedTimestampType	CS	1	f	
(0400,0310)	Certified Timestamp	CertifiedTimestamp	OB	1	f	
(0400,0401)	Digital Signature Purpose Code Sequence	DigitalSignaturePurposeCodeSequence	SQ	1	f	
(0400,0402)	Referenced Digital Signature Sequence	ReferencedDigitalSignatureSequence	SQ	1	f	
(0400,0403)	Referenced SOP Instance MAC Sequence	ReferencedSOPInstanceMACSequence	SQ	1	f	
(0400,0404)	MAC	MAC	OB	1	f	
(0400,0500)	Encrypted Attributes Sequence	EncryptedAttributesSequence	SQ	1	f	
(0400,0510)	Encrypted Content Transfer Syntax UID	EncryptedContentTransferSyntaxUID	UI	1	f	
(0400,0520)	Encrypted Content	EncryptedContent	OB	1	f	
(0400,0550)	Modified Attributes Sequence	ModifiedAttributesSequence	SQ	1	f	
(0400,0561)	Original Attributes Sequence	OriginalAttributesSequence	SQ	1	f	
(0400,0562)	Attribute Modification DateTime	AttributeModificationDateTime	DT	1	f	
(0400,0563)	Modifying System	ModifyingSystem	LO	1	f	
(0400,0564)	Source of Previous Values	SourceOfPreviousValues	LO	1	f	
(0400,0565)	Reason for the Attribute Modification	ReasonForTheAttributeModification	CS	1	f	
(1000,xxx0)	Escape Triplet	EscapeTriplet	US	3	t	
(1000,xxx1)	Run Length Triplet	RunLengthTriplet	US	3	t	
(1000,xxx2)	Huffman Table Size	HuffmanTableSize	US	1	t	
(1000,xxx3)	Huffman Table Triplet	HuffmanTableTriplet	US	3	t	
(1000,xxx4)	Shift Table Size	ShiftTableSize	US	1	t	
(1000,xxx5)	Shift Table Triplet	ShiftTableTriplet	US	3	t	
(1010,xxxx)	Zonal Map	ZonalMap	US	1-n	t	
(2000,0010)	Number of Copies	NumberOfCopies	IS	1	f	
(2000,001e)	Printer Configuration Sequence	PrinterConfigurationSequence	SQ	1	f	
(2000,0020)	Print Priority	PrintPriority	CS	1	f	
(2000,0030)	Medium Type	MediumType	CS	1	f	
(2000,0040)	Film Destination	FilmDestination	CS	1	f	
(2000,0050)	Film Session Label	FilmSessionLabel	LO	1	f	
(2000,0060)	Memory Allocation	MemoryAllocation	IS	1	f	
(2000,0061)	Maximum Memory Allocation	MaximumMemoryAllocation	IS	1	f	
(2000,0062)	Color Image Printing Flag	ColorImagePrintingFlag	CS	1	t	
(2000,0063)	Collation Flag	CollationFlag	CS	1	t	
(2000,0065)	Annotation Flag	AnnotationFlag	CS	1	t	
(2000,0067)	Image Overlay Flag	ImageOverlayFlag	CS	1	t	
(2000,0069)	Presentation LUT Flag	PresentationLUTFlag	CS	1	t	
(2000,006a)	Image Box Presentation LUT Flag	ImageBoxPresentationLUTFlag	CS	1	t	
(2000,00a0)	Memory Bit Depth	MemoryBitDepth	US	1	f	
(2000,00a1)	Printing Bit Depth	PrintingBitDepth	US	1	f	
(2000,00a2)	Media Installed Sequence	MediaInstalledSequence	SQ	1	f	
(2000,00a4)	Other Media Available Sequence	OtherMediaAvailableSequence	SQ	1	f	
(2000,00a8)	Supported Image Display Formats Sequence	SupportedImageDisplayFormatsSequence	SQ	1	f	
(2000,0500)	Referenced Film Box Sequence	ReferencedFilmBoxSequence	SQ	1	f	
(2000,0510)	Referenced Stored Print Sequence	ReferencedStoredPrintSequence	SQ	1	t	
(2010,0010)	Image Display Format	ImageDisplayFormat	ST	1	f	
(2010,0030)	Annotation Display Format ID	AnnotationDisplayFormatID	CS	1	f	
(2010,0040)	Film Orientation	FilmOrientation	CS	1	f	
(2010,0050)	Film Size ID	FilmSizeID	CS	1	f	
(2010,0052)	Printer Resolution ID	PrinterResolutionID	CS	1	f	
(2010,0054)	Default Printer Resolution ID	DefaultPrinterResolutionID	CS	1	f	
(2010,0060)	Magnification Type	MagnificationType	CS	1	f	
(2010,0080)	Smoothing Type	SmoothingType	CS	1	f	
(2010,00a6)	Default Magnification Type	DefaultMagnificationType	CS	1	f	
(2010,00a7)	Other Magnification Types Available	OtherMagnificationTypesAvailable	CS	1-n	f	
(2010,00a8)	Default Smoothing Type	DefaultSmoothingType	CS	1	f	
(2010,00a9)	Other Smoothing Types Available	OtherSmoothingTypesAvailable	CS	1-n	f	
(2010,0100)	Border Density	BorderDensity	CS	1	f	
(2010,0110)	Empty Image Density	EmptyImageDensity	CS	1	f	
(2010,0120)	Min Density	MinDensity	US	1	f	
(2010,0130)	Max Density	MaxDensity	US	1	f	
(2010,0140)	Trim	Trim	CS	1	f	
(2010,0150)	Configuration Information	ConfigurationInformation	ST	1	f	
(2010,0152)	Configuration Information Description	ConfigurationInformationDescription	LT	1	f	
(2010,0154)	Maximum Collated Films	MaximumCollatedFilms	IS	1	f	
(2010,015e)	Illumination	Illumination	US	1	f	
(2010,0160)	Reflected Ambient Light	ReflectedAmbientLight	US	1	f	
(2010,0376)	Printer Pixel Spacing	PrinterPixelSpacing	DS	2	f	
(2010,0500)	Referenced Film Session Sequence	ReferencedFilmSessionSequence	SQ	1	f	
(2010,0510)	Referenced Image Box Sequence	ReferencedImageBoxSequence	SQ	1	f	
(2010,0520)	Referenced Basic Annotation Box Sequence	ReferencedBasicAnnotationBoxSequence	SQ	1	f	
(2020,0010)	Image Box Position	ImageBoxPosition	US	1	f	
(2020,0020)	Polarity	Polarity	CS	1	f	
(2020,0030)	Requested Image Size	RequestedImageSize	DS	1	f	
(2020,0040)	Requested Decimate/Crop Behavior	RequestedDecimateCropBehavior	CS	1	f	
(2020,0050)	Requested Resolution ID	RequestedResolutionID	CS	1	f	
(2020,00a0)	Requested Image Size Flag	RequestedImageSizeFlag	CS	1	f	
(2020,00a2)	Decimate/Crop Result	DecimateCropResult	CS	1	f	
(2020,0110)	Basic Grayscale Image Sequence	BasicGrayscaleImageSequence	SQ	1	f	
(2020,0111)	Basic Color Image Sequence	BasicColorImageSequence	SQ	1	f	
(3002,0052)	Fluence Mode ID	FluenceModeID	SH	1	f	
(2020,0130)	Referenced Image Overlay Box Sequence	ReferencedImageOverlayBoxSequence	SQ	1	t	
(2020,0140)	Referenced VOI LUT Box Sequence	ReferencedVOILUTBoxSequence	SQ	1	t	
(2030,0010)	Annotation Position	AnnotationPosition	US	1	f	
(2030,0020)	Text String	TextString	LO	1	f	
(2040,0010)	Referenced Overlay Plane Sequence	ReferencedOverlayPlaneSequence	SQ	1	t	
(2040,0011)	Referenced Overlay Plane Groups	ReferencedOverlayPlaneGroups	US	1-99	t	
(2040,0020)	Overlay Pixel Data Sequence	OverlayPixelDataSequence	SQ	1	t	
(2040,0060)	Overlay Magnification Type	OverlayMagnificationType	CS	1	t	
(2040,0070)	Overlay Smoothing Type	OverlaySmoothingType	CS	1	t	
(2040,0072)	Overlay or Image Magnification	OverlayOrImageMagnification	CS	1	t	
(2040,0074)	Magnify to Number of Columns	MagnifyToNumberOfColumns	US	1	t	
(2040,0080)	Overlay Foreground Density	OverlayForegroundDensity	CS	1	t	
(2040,0082)	Overlay Background Density	OverlayBackgroundDensity	CS	1	t	
(2040,0090)	Overlay Mode	OverlayMode	CS	1	t	
(2040,0100)	Threshold Density	ThresholdDensity	CS	1	t	
(2040,0500)	Referenced Image Box Sequence (Retired)	ReferencedImageBoxSequenceRetired	SQ	1	t	
(2050,0010)	Presentation LUT Sequence	PresentationLUTSequence	SQ	1	f	
(2050,0020)	Presentation LUT Shape	PresentationLUTShape	CS	1	f	
(2050,0500)	Referenced Presentation LUT Sequence	ReferencedPresentationLUTSequence	SQ	1	f	
(2100,0010)	Print Job ID	PrintJobID	SH	1	t	
(2100,0020)	Execution Status	ExecutionStatus	CS	1	f	
(2100,0030)	Execution Status Info	ExecutionStatusInfo	CS	1	f	
(2100,0040)	Creation Date	CreationDate	DA	1	f	
(2100,0050)	Creation Time	CreationTime	TM	1	f	
(2100,0070)	Originator	Originator	AE	1	f	
(2100,0140)	Destination AE	DestinationAE	AE	1	f	
(2100,0160)	Owner ID	OwnerID	SH	1	f	
(2100,0170)	Number of Films	NumberOfFilms	IS	1	f	
(2100,0500)	Referenced Print Job Sequence (Pull Stored Print)	ReferencedPrintJobSequencePullStoredPrint	SQ	1	t	
(2110,0010)	Printer Status	PrinterStatus	CS	1	f	
(2110,0020)	Printer Status Info	PrinterStatusInfo	CS	1	f	
(2110,0030)	Printer Name	PrinterName	LO	1	f	
(2110,0099)	Print Queue ID	PrintQueueID	SH	1	t	
(2120,0010)	Queue Status	QueueStatus	CS	1	t	
(2120,0050)	Print Job Description Sequence	PrintJobDescriptionSequence	SQ	1	t	
(2120,0070)	Referenced Print Job Sequence	ReferencedPrintJobSequence	SQ	1	t	
(2130,0010)	Print Management Capabilities Sequence	PrintManagementCapabilitiesSequence	SQ	1	t	
(2130,0015)	Printer Characteristics Sequence	PrinterCharacteristicsSequence	SQ	1	t	
(2130,0030)	Film Box Content Sequence	FilmBoxContentSequence	SQ	1	t	
(2130,0040)	Image Box Content Sequence	ImageBoxContentSequence	SQ	1	t	
(2130,0050)	Annotation Content Sequence	AnnotationContentSequence	SQ	1	t	
(2130,0060)	Image Overlay Box Content Sequence	ImageOverlayBoxContentSequence	SQ	1	t	
(2130,0080)	Presentation LUT Content Sequence	PresentationLUTContentSequence	SQ	1	t	
(2130,00a0)	Proposed Study Sequence	ProposedStudySequence	SQ	1	t	
(2130,00c0)	Original Image Sequence	OriginalImageSequence	SQ	1	t	
(2200,0001)	Label Using Information Extracted From Instances	LabelUsingInformationExtractedFromInstances	CS	1	f	
(2200,0002)	Label Text	LabelText	UT	1	f	
(2200,0003)	Label Style Selection	LabelStyleSelection	CS	1	f	
(2200,0004)	Media Disposition	MediaDisposition	LT	1	f	
(2200,0005)	Barcode Value	BarcodeValue	LT	1	f	
(2200,0006)	Barcode Symbology	BarcodeSymbology	CS	1	f	
(2200,0007)	Allow Media Splitting	AllowMediaSplitting	CS	1	f	
(2200,0008)	Include Non-DICOM Objects	IncludeNonDICOMObjects	CS	1	f	
(2200,0009)	Include Display Application	IncludeDisplayApplication	CS	1	f	
(2200,000a)	Preserve Composite Instances After Media Creation	PreserveCompositeInstancesAfterMediaCreation	CS	1	f	
(2200,000b)	Total Number of Pieces of Media Created	TotalNumberOfPiecesOfMediaCreated	US	1	f	
(2200,000c)	Requested Media Application Profile	RequestedMediaApplicationProfile	LO	1	f	
(2200,000d)	Referenced Storage Media Sequence	ReferencedStorageMediaSequence	SQ	1	f	
(2200,000e)	Failure Attributes	FailureAttributes	AT	1-n	f	
(2200,000f)	Allow Lossy Compression	AllowLossyCompression	CS	1	f	
(2200,0020)	Request Priority	RequestPriority	CS	1	f	
(3002,0002)	RT Image Label	RTImageLabel	SH	1	f	
(3002,0003)	RT Image Name	RTImageName	LO	1	f	
(3002,0004)	RT Image Description	RTImageDescription	ST	1	f	
(3002,000a)	Reported Values Origin	ReportedValuesOrigin	CS	1	f	
(3002,000c)	RT Image Plane	RTImagePlane	CS	1	f	
(3002,000d)	X-Ray Image Receptor Translation	XRayImageReceptorTranslation	DS	3	f	
(3002,000e)	X-Ray Image Receptor Angle	XRayImageReceptorAngle	DS	1	f	
(3002,0010)	RT Image Orientation	RTImageOrientation	DS	6	f	
(3002,0011)	Image Plane Pixel Spacing	ImagePlanePixelSpacing	DS	2	f	
(3002,0012)	RT Image Position	RTImagePosition	DS	2	f	
(3002,0020)	Radiation Machine Name	RadiationMachineName	SH	1	f	
(3002,0022)	Radiation Machine SAD	RadiationMachineSAD	DS	1	f	
(3002,0024)	Radiation Machine SSD	RadiationMachineSSD	DS	1	f	
(3002,0026)	RT Image SID	RTImageSID	DS	1	f	
(3002,0028)	Source to Reference Object Distance	SourceToReferenceObjectDistance	DS	1	f	
(3002,0029)	Fraction Number	FractionNumber	IS	1	f	
(3002,0030)	Exposure Sequence	ExposureSequence	SQ	1	f	
(3002,0032)	Meterset Exposure	MetersetExposure	DS	1	f	
(3002,0034)	Diaphragm Position	DiaphragmPosition	DS	4	f	
(3002,0040)	Fluence Map Sequence	FluenceMapSequence	SQ	1	f	
(3002,0041)	Fluence Data Source	FluenceDataSource	CS	1	f	
(3002,0042)	Fluence Data Scale	FluenceDataScale	DS	1	f	
(3002,0050)	Primary Fluence Mode Sequence	PrimaryFluenceModeSequence	SQ	1	f	
(3002,0051)	Fluence Mode	FluenceMode	CS	1	f	
(3004,0005)	Spatial Transform of Dose	SpatialTransformOfDose	CS	1	f	
(3004,0006)	Dose Comment	DoseComment	LO	1	f	
(3004,0008)	Normalization Point	NormalizationPoint	DS	3	f	
(3004,000a)	Dose Summation Type	DoseSummationType	CS	1	f	
(3004,000c)	Grid Frame Offset Vector	GridFrameOffsetVector	DS	2-n	f	
(3004,000e)	Dose Grid Scaling	DoseGridScaling	DS	1	f	
(3004,0010)	RT Dose ROI Sequence	RTDoseROISequence	SQ	1	f	
(3004,0012)	Dose Value	DoseValue	DS	1	f	
(3004,0014)	Tissue Heterogeneity Correction	TissueHeterogeneityCorrection	CS	1-3	f	
(3004,0040)	DVH Normalization Point	DVHNormalizationPoint	DS	3	f	
(3004,0042)	DVH Normalization Dose Value	DVHNormalizationDoseValue	DS	1	f	
(3004,0050)	DVH Sequence	DVHSequence	SQ	1	f	
(3004,0052)	DVH Dose Scaling	DVHDoseScaling	DS	1	f	
(3004,0054)	DVH Volume Units	DVHVolumeUnits	CS	1	f	
(3004,0056)	DVH Number of Bins	DVHNumberOfBins	IS	1	f	
(3004,0058)	DVH Data	DVHData	DS	2-2n	f	
(3004,0060)	DVH Referenced ROI Sequence	DVHReferencedROISequence	SQ	1	f	
(3004,0062)	DVH ROI Contribution Type	DVHROIContributionType	CS	1	f	
(3004,0070)	DVH Minimum Dose	DVHMinimumDose	DS	1	f	
(3004,0072)	DVH Maximum Dose	DVHMaximumDose	DS	1	f	
(3004,0074)	DVH Mean Dose	DVHMeanDose	DS	1	f	
(3006,0002)	Structure Set Label	StructureSetLabel	SH	1	f	
(3006,0004)	Structure Set Name	StructureSetName	LO	1	f	
(3006,0006)	Structure Set Description	StructureSetDescription	ST	1	f	
(3006,0008)	Structure Set Date	StructureSetDate	DA	1	f	
(3006,0009)	Structure Set Time	StructureSetTime	TM	1	f	
(3006,0010)	Referenced Frame of Reference Sequence	ReferencedFrameOfReferenceSequence	SQ	1	f	
(3006,0012)	RT Referenced Study Sequence	RTReferencedStudySequence	SQ	1	f	
(3006,0014)	RT Referenced Series Sequence	RTReferencedSeriesSequence	SQ	1	f	
(3006,0016)	Contour Image Sequence	ContourImageSequence	SQ	1	f	
(3006,0018)	Predecessor Structure Set Sequence	PredecessorStructureSetSequence	SQ	1	f	
(3006,0020)	Structure Set ROI Sequence	StructureSetROISequence	SQ	1	f	
(3006,0022)	ROI Number	ROINumber	IS	1	f	
(3006,0024)	Referenced Frame of Reference UID	ReferencedFrameOfReferenceUID	UI	1	f	
(3006,0026)	ROI Name	ROIName	LO	1	f	
(3006,0028)	ROI Description	ROIDescription	ST	1	f	
(3006,002a)	ROI Display Color	ROIDisplayColor	IS	3	f	
(3006,002c)	ROI Volume	ROIVolume	DS	1	f	
(3006,0030)	RT Related ROI Sequence	RTRelatedROISequence	SQ	1	f	
(3006,0033)	RT ROI Relationship	RTROIRelationship	CS	1	f	
(3006,0036)	ROI Generation Algorithm	ROIGenerationAlgorithm	CS	1	f	
(3006,0038)	ROI Generation Description	ROIGenerationDescription	LO	1	f	
(3006,0039)	ROI Contour Sequence	ROIContourSequence	SQ	1	f	
(3006,0040)	Contour Sequence	ContourSequence	SQ	1	f	
(3006,0042)	Contour Geometric Type	ContourGeometricType	CS	1	f	
(3006,0044)	Contour Slab Thickness	ContourSlabThickness	DS	1	f	
(3006,0045)	Contour Offset Vector	ContourOffsetVector	DS	3	f	
(3006,0046)	Number of Contour Points	NumberOfContourPoints	IS	1	f	
(3006,0048)	Contour Number	ContourNumber	IS	1	f	
(3006,0049)	Attached Contours	AttachedContours	IS	1-n	f	
(3006,0050)	Contour Data	ContourData	DS	3-3n	f	
(3006,0080)	RT ROI Observations Sequence	RTROIObservationsSequence	SQ	1	f	
(3006,0082)	Observation Number	ObservationNumber	IS	1	f	
(3006,0084)	Referenced ROI Number	ReferencedROINumber	IS	1	f	
(3006,0085)	ROI Observation Label	ROIObservationLabel	SH	1	f	
(3006,0086)	RT ROI Identification Code Sequence	RTROIIdentificationCodeSequence	SQ	1	f	
(3006,0088)	ROI Observation Description	ROIObservationDescription	ST	1	f	
(3006,00a0)	Related RT ROI Observations Sequence	RelatedRTROIObservationsSequence	SQ	1	f	
(3006,00a4)	RT ROI Interpreted Type	RTROIInterpretedType	CS	1	f	
(3006,00a6)	ROI Interpreter	ROIInterpreter	PN	1	f	
(3006,00b0)	ROI Physical Properties Sequence	ROIPhysicalPropertiesSequence	SQ	1	f	
(3006,00b2)	ROI Physical Property	ROIPhysicalProperty	CS	1	f	
(3006,00b4)	ROI Physical Property Value	ROIPhysicalPropertyValue	DS	1	f	
(3006,00b6)	ROI Elemental Composition Sequence	ROIElementalCompositionSequence	SQ	1	f	
(3006,00b7)	ROI Elemental Composition Atomic Number	ROIElementalCompositionAtomicNumber	US	1	f	
(3006,00b8)	ROI Elemental Composition Atomic Mass Fraction	ROIElementalCompositionAtomicMassFraction	FL	1	f	
(3006,00b9)	Additional RT ROI Identification Code Sequence	AdditionalRTROIIdentificationCodeSequence	SQ	1	f	
(3006,00c0)	Frame of Reference Relationship Sequence	FrameOfReferenceRelationshipSequence	SQ	1	t	
(3006,00c2)	Related Frame of Reference UID	RelatedFrameOfReferenceUID	UI	1	t	
(3006,00c4)	Frame of Reference Transformation Type	FrameOfReferenceTransformationType	CS	1	t	
(3006,00c6)	Frame of Reference Transformation Matrix	FrameOfReferenceTransformationMatrix	DS	16	f	
(3006,00c8)	Frame of Reference Transformation Comment	FrameOfReferenceTransformationComment	LO	1	f	
(3008,0010)	Measured Dose Reference Sequence	MeasuredDoseReferenceSequence	SQ	1	f	
(3008,0012)	Measured Dose Description	MeasuredDoseDescription	ST	1	f	
(3008,0014)	Measured Dose Type	MeasuredDoseType	CS	1	f	
(3008,0016)	Measured Dose Value	MeasuredDoseValue	DS	1	f	
(3008,0020)	Treatment Session Beam Sequence	TreatmentSessionBeamSequence	SQ	1	f	
(3008,0021)	Treatment Session Ion Beam Sequence	TreatmentSessionIonBeamSequence	SQ	1	f	
(3008,0022)	Current Fraction Number	CurrentFractionNumber	IS	1	f	
(3008,0024)	Treatment Control Point Date	TreatmentControlPointDate	DA	1	f	
(3008,0025)	Treatment Control Point Time	TreatmentControlPointTime	TM	1	f	
(3008,002a)	Treatment Termination Status	TreatmentTerminationStatus	CS	1	f	
(3008,002b)	Treatment Termination Code	TreatmentTerminationCode	SH	1	f	
(3008,002c)	Treatment Verification Status	TreatmentVerificationStatus	CS	1	f	
(3008,0030)	Referenced Treatment Record Sequence	ReferencedTreatmentRecordSequence	SQ	1	f	
(3008,0032)	Specified Primary Meterset	SpecifiedPrimaryMeterset	DS	1	f	
(3008,0033)	Specified Secondary Meterset	SpecifiedSecondaryMeterset	DS	1	f	
(3008,0036)	Delivered Primary Meterset	DeliveredPrimaryMeterset	DS	1	f	
(3008,0037)	Delivered Secondary Meterset	DeliveredSecondaryMeterset	DS	1	f	
(3008,003a)	Specified Treatment Time	SpecifiedTreatmentTime	DS	1	f	
(3008,003b)	Delivered Treatment Time	DeliveredTreatmentTime	DS	1	f	
(3008,0040)	Control Point Delivery Sequence	ControlPointDeliverySequence	SQ	1	f	
(3008,0041)	Ion Control Point Delivery Sequence	IonControlPointDeliverySequence	SQ	1	f	
(3008,0042)	Specified Meterset	SpecifiedMeterset	DS	1	f	
(3008,0044)	Delivered Meterset	DeliveredMeterset	DS	1	f	
(3008,0045)	Meterset Rate Set	MetersetRateSet	FL	1	f	
(3008,0046)	Meterset Rate Delivered	MetersetRateDelivered	FL	1	f	
(3008,0047)	Scan Spot Metersets Delivered	ScanSpotMetersetsDelivered	FL	1-n	f	
(3008,0048)	Dose Rate Delivered	DoseRateDelivered	DS	1	f	
(3008,0050)	Treatment Summary Calculated Dose Reference Sequence	TreatmentSummaryCalculatedDoseReferenceSequence	SQ	1	f	
(3008,0052)	Cumulative Dose to Dose Reference	CumulativeDoseToDoseReference	DS	1	f	
(3008,0054)	First Treatment Date	FirstTreatmentDate	DA	1	f	
(3008,0056)	Most Recent Treatment Date	MostRecentTreatmentDate	DA	1	f	
(3008,005a)	Number of Fractions Delivered	NumberOfFractionsDelivered	IS	1	f	
(3008,0060)	Override Sequence	OverrideSequence	SQ	1	f	
(3008,0061)	Parameter Sequence Pointer	ParameterSequencePointer	AT	1	f	
(3008,0062)	Override Parameter Pointer	OverrideParameterPointer	AT	1	f	
(3008,0063)	Parameter Item Index	ParameterItemIndex	IS	1	f	
(3008,0064)	Measured Dose Reference Number	MeasuredDoseReferenceNumber	IS	1	f	
(3008,0065)	Parameter Pointer	ParameterPointer	AT	1	f	
(3008,0066)	Override Reason	OverrideReason	ST	1	f	
(3008,0068)	Corrected Parameter Sequence	CorrectedParameterSequence	SQ	1	f	
(3008,006a)	Correction Value	CorrectionValue	FL	1	f	
(3008,0070)	Calculated Dose Reference Sequence	CalculatedDoseReferenceSequence	SQ	1	f	
(3008,0072)	Calculated Dose Reference Number	CalculatedDoseReferenceNumber	IS	1	f	
(3008,0074)	Calculated Dose Reference Description	CalculatedDoseReferenceDescription	ST	1	f	
(3008,0076)	Calculated Dose Reference Dose Value	CalculatedDoseReferenceDoseValue	DS	1	f	
(3008,0078)	Start Meterset	StartMeterset	DS	1	f	
(3008,007a)	End Meterset	EndMeterset	DS	1	f	
(3008,0080)	Referenced Measured Dose Reference Sequence	ReferencedMeasuredDoseReferenceSequence	SQ	1	f	
(3008,0082)	Referenced Measured Dose Reference Number	ReferencedMeasuredDoseReferenceNumber	IS	1	f	
(3008,0090)	Referenced Calculated Dose Reference Sequence	ReferencedCalculatedDoseReferenceSequence	SQ	1	f	
(3008,0092)	Referenced Calculated Dose Reference Number	ReferencedCalculatedDoseReferenceNumber	IS	1	f	
(3008,00a0)	Beam Limiting Device Leaf Pairs Sequence	BeamLimitingDeviceLeafPairsSequence	SQ	1	f	
(3008,00b0)	Recorded Wedge Sequence	RecordedWedgeSequence	SQ	1	f	
(3008,00c0)	Recorded Compensator Sequence	RecordedCompensatorSequence	SQ	1	f	
(3008,00d0)	Recorded Block Sequence	RecordedBlockSequence	SQ	1	f	
(3008,00e0)	Treatment Summary Measured Dose Reference Sequence	TreatmentSummaryMeasuredDoseReferenceSequence	SQ	1	f	
(3008,00f0)	Recorded Snout Sequence	RecordedSnoutSequence	SQ	1	f	
(3008,00f2)	Recorded Range Shifter Sequence	RecordedRangeShifterSequence	SQ	1	f	
(3008,00f4)	Recorded Lateral Spreading Device Sequence	RecordedLateralSpreadingDeviceSequence	SQ	1	f	
(3008,00f6)	Recorded Range Modulator Sequence	RecordedRangeModulatorSequence	SQ	1	f	
(3008,0100)	Recorded Source Sequence	RecordedSourceSequence	SQ	1	f	
(3008,0105)	Source Serial Number	SourceSerialNumber	LO	1	f	
(3008,0110)	Treatment Session Application Setup Sequence	TreatmentSessionApplicationSetupSequence	SQ	1	f	
(3008,0116)	Application Setup Check	ApplicationSetupCheck	CS	1	f	
(3008,0120)	Recorded Brachy Accessory Device Sequence	RecordedBrachyAccessoryDeviceSequence	SQ	1	f	
(3008,0122)	Referenced Brachy Accessory Device Number	ReferencedBrachyAccessoryDeviceNumber	IS	1	f	
(3008,0130)	Recorded Channel Sequence	RecordedChannelSequence	SQ	1	f	
(3008,0132)	Specified Channel Total Time	SpecifiedChannelTotalTime	DS	1	f	
(3008,0134)	Delivered Channel Total Time	DeliveredChannelTotalTime	DS	1	f	
(3008,0136)	Specified Number of Pulses	SpecifiedNumberOfPulses	IS	1	f	
(3008,0138)	Delivered Number of Pulses	DeliveredNumberOfPulses	IS	1	f	
(3008,013a)	Specified Pulse Repetition Interval	SpecifiedPulseRepetitionInterval	DS	1	f	
(3008,013c)	Delivered Pulse Repetition Interval	DeliveredPulseRepetitionInterval	DS	1	f	
(3008,0140)	Recorded Source Applicator Sequence	RecordedSourceApplicatorSequence	SQ	1	f	
(3008,0142)	Referenced Source Applicator Number	ReferencedSourceApplicatorNumber	IS	1	f	
(3008,0150)	Recorded Channel Shield Sequence	RecordedChannelShieldSequence	SQ	1	f	
(3008,0152)	Referenced Channel Shield Number	ReferencedChannelShieldNumber	IS	1	f	
(3008,0160)	Brachy Control Point Delivered Sequence	BrachyControlPointDeliveredSequence	SQ	1	f	
(3008,0162)	Safe Position Exit Date	SafePositionExitDate	DA	1	f	
(3008,0164)	Safe Position Exit Time	SafePositionExitTime	TM	1	f	
(3008,0166)	Safe Position Return Date	SafePositionReturnDate	DA	1	f	
(3008,0168)	Safe Position Return Time	SafePositionReturnTime	TM	1	f	
(3008,0171)	Pulse Specific Brachy Control Point Delivered Sequence	PulseSpecificBrachyControlPointDeliveredSequence	SQ	1	f	
(3008,0172)	Pulse Number	PulseNumber	US	1	f	
(3008,0173)	Brachy Pulse Control Point Delivered Sequence	BrachyPulseControlPointDeliveredSequence	SQ	1	f	
(3008,0200)	Current Treatment Status	CurrentTreatmentStatus	CS	1	f	
(3008,0202)	Treatment Status Comment	TreatmentStatusComment	ST	1	f	
(3008,0220)	Fraction Group Summary Sequence	FractionGroupSummarySequence	SQ	1	f	
(3008,0223)	Referenced Fraction Number	ReferencedFractionNumber	IS	1	f	
(3008,0224)	Fraction Group Type	FractionGroupType	CS	1	f	
(3008,0230)	Beam Stopper Position	BeamStopperPosition	CS	1	f	
(3008,0240)	Fraction Status Summary Sequence	FractionStatusSummarySequence	SQ	1	f	
(3008,0250)	Treatment Date	TreatmentDate	DA	1	f	
(3008,0251)	Treatment Time	TreatmentTime	TM	1	f	
(300a,0002)	RT Plan Label	RTPlanLabel	SH	1	f	
(300a,0003)	RT Plan Name	RTPlanName	LO	1	f	
(300a,0004)	RT Plan Description	RTPlanDescription	ST	1	f	
(300a,0006)	RT Plan Date	RTPlanDate	DA	1	f	
(300a,0007)	RT Plan Time	RTPlanTime	TM	1	f	
(300a,0009)	Treatment Protocols	TreatmentProtocols	LO	1-n	f	
(300a,000a)	Plan Intent	PlanIntent	CS	1	f	
(300a,000b)	Treatment Sites	TreatmentSites	LO	1-n	f	
(300a,000c)	RT Plan Geometry	RTPlanGeometry	CS	1	f	
(300a,000e)	Prescription Description	PrescriptionDescription	ST	1	f	
(300a,0010)	Dose Reference Sequence	DoseReferenceSequence	SQ	1	f	
(300a,0012)	Dose Reference Number	DoseReferenceNumber	IS	1	f	
(300a,0013)	Dose Reference UID	DoseReferenceUID	UI	1	f	
(300a,0014)	Dose Reference Structure Type	DoseReferenceStructureType	CS	1	f	
(300a,0015)	Nominal Beam Energy Unit	NominalBeamEnergyUnit	CS	1	f	
(300a,0016)	Dose Reference Description	DoseReferenceDescription	LO	1	f	
(300a,0018)	Dose Reference Point Coordinates	DoseReferencePointCoordinates	DS	3	f	
(300a,001a)	Nominal Prior Dose	NominalPriorDose	DS	1	f	
(300a,0020)	Dose Reference Type	DoseReferenceType	CS	1	f	
(300a,0021)	Constraint Weight	ConstraintWeight	DS	1	f	
(300a,0022)	Delivery Warning Dose	DeliveryWarningDose	DS	1	f	
(300a,0023)	Delivery Maximum Dose	DeliveryMaximumDose	DS	1	f	
(300a,0025)	Target Minimum Dose	TargetMinimumDose	DS	1	f	
(300a,0026)	Target Prescription Dose	TargetPrescriptionDose	DS	1	f	
(300a,0027)	Target Maximum Dose	TargetMaximumDose	DS	1	f	
(300a,0028)	Target Underdose Volume Fraction	TargetUnderdoseVolumeFraction	DS	1	f	
(300a,002a)	Organ at Risk Full-volume Dose	OrganAtRiskFullVolumeDose	DS	1	f	
(300a,002b)	Organ at Risk Limit Dose	OrganAtRiskLimitDose	DS	1	f	
(300a,002c)	Organ at Risk Maximum Dose	OrganAtRiskMaximumDose	DS	1	f	
(300a,002d)	Organ at Risk Overdose Volume Fraction	OrganAtRiskOverdoseVolumeFraction	DS	1	f	
(300a,0040)	Tolerance Table Sequence	ToleranceTableSequence	SQ	1	f	
(300a,0042)	Tolerance Table Number	ToleranceTableNumber	IS	1	f	
(300a,0043)	Tolerance Table Label	ToleranceTableLabel	SH	1	f	
(300a,0044)	Gantry Angle Tolerance	GantryAngleTolerance	DS	1	f	
(300a,0046)	Beam Limiting Device Angle Tolerance	BeamLimitingDeviceAngleTolerance	DS	1	f	
(300a,0048)	Beam Limiting Device Tolerance Sequence	BeamLimitingDeviceToleranceSequence	SQ	1	f	
(300a,004a)	Beam Limiting Device Position Tolerance	BeamLimitingDevicePositionTolerance	DS	1	f	
(300a,004b)	Snout Position Tolerance	SnoutPositionTolerance	FL	1	f	
(300a,004c)	Patient Support Angle Tolerance	PatientSupportAngleTolerance	DS	1	f	
(300a,004e)	Table Top Eccentric Angle Tolerance	TableTopEccentricAngleTolerance	DS	1	f	
(300a,004f)	Table Top Pitch Angle Tolerance	TableTopPitchAngleTolerance	FL	1	f	
(300a,0050)	Table Top Roll Angle Tolerance	TableTopRollAngleTolerance	FL	1	f	
(300a,0051)	Table Top Vertical Position Tolerance	TableTopVerticalPositionTolerance	DS	1	f	
(300a,0052)	Table Top Longitudinal Position Tolerance	TableTopLongitudinalPositionTolerance	DS	1	f	
(300a,0053)	Table Top Lateral Position Tolerance	TableTopLateralPositionTolerance	DS	1	f	
(300a,0055)	RT Plan Relationship	RTPlanRelationship	CS	1	f	
(300a,0070)	Fraction Group Sequence	FractionGroupSequence	SQ	1	f	
(300a,0071)	Fraction Group Number	FractionGroupNumber	IS	1	f	
(300a,0072)	Fraction Group Description	FractionGroupDescription	LO	1	f	
(300a,0078)	Number of Fractions Planned	NumberOfFractionsPlanned	IS	1	f	
(300a,0079)	Number of Fraction Pattern Digits Per Day	NumberOfFractionPatternDigitsPerDay	IS	1	f	
(300a,007a)	Repeat Fraction Cycle Length	RepeatFractionCycleLength	IS	1	f	
(300a,007b)	Fraction Pattern	FractionPattern	LT	1	f	
(300a,0080)	Number of Beams	NumberOfBeams	IS	1	f	
(300a,0082)	Beam Dose Specification Point	BeamDoseSpecificationPoint	DS	3	f	
(300a,0084)	Beam Dose	BeamDose	DS	1	f	
(300a,0086)	Beam Meterset	BeamMeterset	DS	1	f	
(300a,0088)	Beam Dose Point Depth	BeamDosePointDepth	FL	1	t	
(300a,0089)	Beam Dose Point Equivalent Depth	BeamDosePointEquivalentDepth	FL	1	t	
(300a,008a)	Beam Dose Point SSD	BeamDosePointSSD	FL	1	t	
(300a,008b)	Beam Dose Meaning	BeamDoseMeaning	CS	1	f	
(300a,008c)	Beam Dose Verification Control Point Sequence	BeamDoseVerificationControlPointSequence	SQ	1	f	
(300a,008d)	Average Beam Dose Point Depth	AverageBeamDosePointDepth	FL	1	f	
(300a,008e)	Average Beam Dose Point Equivalent Depth	AverageBeamDosePointEquivalentDepth	FL	1	f	
(300a,008f)	Average Beam Dose Point SSD	AverageBeamDosePointSSD	FL	1	f	
(300a,0090)	Beam Dose Type	BeamDoseType	CS	1	f	
(300a,0091)	Alternate Beam Dose	AlternateBeamDose	DS	1	f	
(300a,0092)	Alternate Beam Dose Type	AlternateBeamDoseType	CS	1	f	
(300a,00a0)	Number of Brachy Application Setups	NumberOfBrachyApplicationSetups	IS	1	f	
(300a,00a2)	Brachy Application Setup Dose Specification Point	BrachyApplicationSetupDoseSpecificationPoint	DS	3	f	
(300a,00a4)	Brachy Application Setup Dose	BrachyApplicationSetupDose	DS	1	f	
(300a,00b0)	Beam Sequence	BeamSequence	SQ	1	f	
(300a,00b2)	Treatment Machine Name	TreatmentMachineName	SH	1	f	
(300a,00b3)	Primary Dosimeter Unit	PrimaryDosimeterUnit	CS	1	f	
(300a,00b4)	Source-Axis Distance	SourceAxisDistance	DS	1	f	
(300a,00b6)	Beam Limiting Device Sequence	BeamLimitingDeviceSequence	SQ	1	f	
(300a,00b8)	RT Beam Limiting Device Type	RTBeamLimitingDeviceType	CS	1	f	
(300a,00ba)	Source to Beam Limiting Device Distance	SourceToBeamLimitingDeviceDistance	DS	1	f	
(300a,00bb)	Isocenter to Beam Limiting Device Distance	IsocenterToBeamLimitingDeviceDistance	FL	1	f	
(300a,00bc)	Number of Leaf/Jaw Pairs	NumberOfLeafJawPairs	IS	1	f	
(300a,00be)	Leaf Position Boundaries	LeafPositionBoundaries	DS	3-n	f	
(300a,00c0)	Beam Number	BeamNumber	IS	1	f	
(300a,00c2)	Beam Name	BeamName	LO	1	f	
(300a,00c3)	Beam Description	BeamDescription	ST	1	f	
(300a,00c4)	Beam Type	BeamType	CS	1	f	
(300a,00c5)	Beam Delivery Duration Limit	BeamDeliveryDurationLimit	FD	1	f	
(300a,00c6)	Radiation Type	RadiationType	CS	1	f	
(300a,00c7)	High-Dose Technique Type	HighDoseTechniqueType	CS	1	f	
(300a,00c8)	Reference Image Number	ReferenceImageNumber	IS	1	f	
(300a,00ca)	Planned Verification Image Sequence	PlannedVerificationImageSequence	SQ	1	f	
(300a,00cc)	Imaging Device-Specific Acquisition Parameters	ImagingDeviceSpecificAcquisitionParameters	LO	1-n	f	
(300a,00ce)	Treatment Delivery Type	TreatmentDeliveryType	CS	1	f	
(300a,00d0)	Number of Wedges	NumberOfWedges	IS	1	f	
(300a,00d1)	Wedge Sequence	WedgeSequence	SQ	1	f	
(300a,00d2)	Wedge Number	WedgeNumber	IS	1	f	
(300a,00d3)	Wedge Type	WedgeType	CS	1	f	
(300a,00d4)	Wedge ID	WedgeID	SH	1	f	
(300a,00d5)	Wedge Angle	WedgeAngle	IS	1	f	
(300a,00d6)	Wedge Factor	WedgeFactor	DS	1	f	
(300a,00d7)	Total Wedge Tray Water-Equivalent Thickness	TotalWedgeTrayWaterEquivalentThickness	FL	1	f	
(300a,00d8)	Wedge Orientation	WedgeOrientation	DS	1	f	
(300a,00d9)	Isocenter to Wedge Tray Distance	IsocenterToWedgeTrayDistance	FL	1	f	
(300a,00da)	Source to Wedge Tray Distance	SourceToWedgeTrayDistance	DS	1	f	
(300a,00db)	Wedge Thin Edge Position	WedgeThinEdgePosition	FL	1	f	
(300a,00dc)	Bolus ID	BolusID	SH	1	f	
(300a,00dd)	Bolus Description	BolusDescription	ST	1	f	
(300a,00de)	Effective Wedge Angle	EffectiveWedgeAngle	DS	1	f	
(300a,00e0)	Number of Compensators	NumberOfCompensators	IS	1	f	
(300a,00e1)	Material ID	MaterialID	SH	1	f	
(300a,00e2)	Total Compensator Tray Factor	TotalCompensatorTrayFactor	DS	1	f	
(300a,00e3)	Compensator Sequence	CompensatorSequence	SQ	1	f	
(300a,00e4)	Compensator Number	CompensatorNumber	IS	1	f	
(300a,00e5)	Compensator ID	CompensatorID	SH	1	f	
(300a,00e6)	Source to Compensator Tray Distance	SourceToCompensatorTrayDistance	DS	1	f	
(300a,00e7)	Compensator Rows	CompensatorRows	IS	1	f	
(300a,00e8)	Compensator Columns	CompensatorColumns	IS	1	f	
(300a,00e9)	Compensator Pixel Spacing	CompensatorPixelSpacing	DS	2	f	
(300a,00ea)	Compensator Position	CompensatorPosition	DS	2	f	
(300a,00eb)	Compensator Transmission Data	CompensatorTransmissionData	DS	1-n	f	
(300a,00ec)	Compensator Thickness Data	CompensatorThicknessData	DS	1-n	f	
(300a,00ed)	Number of Boli	NumberOfBoli	IS	1	f	
(300a,00ee)	Compensator Type	CompensatorType	CS	1	f	
(300a,00ef)	Compensator Tray ID	CompensatorTrayID	SH	1	f	
(300a,00f0)	Number of Blocks	NumberOfBlocks	IS	1	f	
(300a,00f2)	Total Block Tray Factor	TotalBlockTrayFactor	DS	1	f	
(300a,00f3)	Total Block Tray Water-Equivalent Thickness	TotalBlockTrayWaterEquivalentThickness	FL	1	f	
(300a,00f4)	Block Sequence	BlockSequence	SQ	1	f	
(300a,00f5)	Block Tray ID	BlockTrayID	SH	1	f	
(300a,00f6)	Source to Block Tray Distance	SourceToBlockTrayDistance	DS	1	f	
(300a,00f7)	Isocenter to Block Tray Distance	IsocenterToBlockTrayDistance	FL	1	f	
(300a,00f8)	Block Type	BlockType	CS	1	f	
(300a,00f9)	Accessory Code	AccessoryCode	LO	1	f	
(300a,00fa)	Block Divergence	BlockDivergence	CS	1	f	
(300a,00fb)	Block Mounting Position	BlockMountingPosition	CS	1	f	
(300a,00fc)	Block Number	BlockNumber	IS	1	f	
(300a,00fe)	Block Name	BlockName	LO	1	f	
(300a,0100)	Block Thickness	BlockThickness	DS	1	f	
(300a,0102)	Block Transmission	BlockTransmission	DS	1	f	
(300a,0104)	Block Number of Points	BlockNumberOfPoints	IS	1	f	
(300a,0106)	Block Data	BlockData	DS	2-2n	f	
(300a,0107)	Applicator Sequence	ApplicatorSequence	SQ	1	f	
(300a,0108)	Applicator ID	ApplicatorID	SH	1	f	
(300a,0109)	Applicator Type	ApplicatorType	CS	1	f	
(300a,010a)	Applicator Description	ApplicatorDescription	LO	1	f	
(300a,010c)	Cumulative Dose Reference Coefficient	CumulativeDoseReferenceCoefficient	DS	1	f	
(300a,010e)	Final Cumulative Meterset Weight	FinalCumulativeMetersetWeight	DS	1	f	
(300a,0110)	Number of Control Points	NumberOfControlPoints	IS	1	f	
(300a,0111)	Control Point Sequence	ControlPointSequence	SQ	1	f	
(300a,0112)	Control Point Index	ControlPointIndex	IS	1	f	
(300a,0114)	Nominal Beam Energy	NominalBeamEnergy	DS	1	f	
(300a,0115)	Dose Rate Set	DoseRateSet	DS	1	f	
(300a,0116)	Wedge Position Sequence	WedgePositionSequence	SQ	1	f	
(300a,0118)	Wedge Position	WedgePosition	CS	1	f	
(300a,011a)	Beam Limiting Device Position Sequence	BeamLimitingDevicePositionSequence	SQ	1	f	
(300a,011c)	Leaf/Jaw Positions	LeafJawPositions	DS	2-2n	f	
(300a,011e)	Gantry Angle	GantryAngle	DS	1	f	
(300a,011f)	Gantry Rotation Direction	GantryRotationDirection	CS	1	f	
(300a,0120)	Beam Limiting Device Angle	BeamLimitingDeviceAngle	DS	1	f	
(300a,0121)	Beam Limiting Device Rotation Direction	BeamLimitingDeviceRotationDirection	CS	1	f	
(300a,0122)	Patient Support Angle	PatientSupportAngle	DS	1	f	
(300a,0123)	Patient Support Rotation Direction	PatientSupportRotationDirection	CS	1	f	
(300a,0124)	Table Top Eccentric Axis Distance	TableTopEccentricAxisDistance	DS	1	f	
(300a,0125)	Table Top Eccentric Angle	TableTopEccentricAngle	DS	1	f	
(300a,0126)	Table Top Eccentric Rotation Direction	TableTopEccentricRotationDirection	CS	1	f	
(300a,0128)	Table Top Vertical Position	TableTopVerticalPosition	DS	1	f	
(300a,0129)	Table Top Longitudinal Position	TableTopLongitudinalPosition	DS	1	f	
(300a,012a)	Table Top Lateral Position	TableTopLateralPosition	DS	1	f	
(300a,012c)	Isocenter Position	IsocenterPosition	DS	3	f	
(300a,012e)	Surface Entry Point	SurfaceEntryPoint	DS	3	f	
(300a,0130)	Source to Surface Distance	SourceToSurfaceDistance	DS	1	f	
(300a,0131)	Average Beam Dose Point Source to External Contour Distance	AverageBeamDosePointSourceToExternalContourDistance	FL	1	f	
(300a,0132)	Source to External Contour Distance	SourceToExternalContourDistance	FL	1	f	
(300a,0133)	External Contour Entry Point	ExternalContourEntryPoint	FL	3	f	
(300a,0134)	Cumulative Meterset Weight	CumulativeMetersetWeight	DS	1	f	
(300a,0140)	Table Top Pitch Angle	TableTopPitchAngle	FL	1	f	
(300a,0142)	Table Top Pitch Rotation Direction	TableTopPitchRotationDirection	CS	1	f	
(300a,0144)	Table Top Roll Angle	TableTopRollAngle	FL	1	f	
(300a,0146)	Table Top Roll Rotation Direction	TableTopRollRotationDirection	CS	1	f	
(300a,0148)	Head Fixation Angle	HeadFixationAngle	FL	1	f	
(300a,014a)	Gantry Pitch Angle	GantryPitchAngle	FL	1	f	
(300a,014c)	Gantry Pitch Rotation Direction	GantryPitchRotationDirection	CS	1	f	
(300a,014e)	Gantry Pitch Angle Tolerance	GantryPitchAngleTolerance	FL	1	f	
(300a,0150)	Fixation Eye	FixationEye	CS	1	f	
(300a,0151)	Chair Head Frame Position	ChairHeadFramePosition	DS	1	f	
(300a,0152)	Head Fixation Angle Tolerance	HeadFixationAngleTolerance	DS	1	f	
(300a,0153)	Chair Head Frame Position Tolerance	ChairHeadFramePositionTolerance	DS	1	f	
(300a,0154)	Fixation Light Azimuthal Angle Tolerance	FixationLightAzimuthalAngleTolerance	DS	1	f	
(300a,0155)	Fixation Light Polar Angle Tolerance	FixationLightPolarAngleTolerance	DS	1	f	
(300a,0180)	Patient Setup Sequence	PatientSetupSequence	SQ	1	f	
(300a,0182)	Patient Setup Number	PatientSetupNumber	IS	1	f	
(300a,0183)	Patient Setup Label	PatientSetupLabel	LO	1	f	
(300a,0184)	Patient Additional Position	PatientAdditionalPosition	LO	1	f	
(300a,0190)	Fixation Device Sequence	FixationDeviceSequence	SQ	1	f	
(300a,0192)	Fixation Device Type	FixationDeviceType	CS	1	f	
(300a,0194)	Fixation Device Label	FixationDeviceLabel	SH	1	f	
(300a,0196)	Fixation Device Description	FixationDeviceDescription	ST	1	f	
(300a,0198)	Fixation Device Position	FixationDevicePosition	SH	1	f	
(300a,0199)	Fixation Device Pitch Angle	FixationDevicePitchAngle	FL	1	f	
(300a,019a)	Fixation Device Roll Angle	FixationDeviceRollAngle	FL	1	f	
(300a,01a0)	Shielding Device Sequence	ShieldingDeviceSequence	SQ	1	f	
(300a,01a2)	Shielding Device Type	ShieldingDeviceType	CS	1	f	
(300a,01a4)	Shielding Device Label	ShieldingDeviceLabel	SH	1	f	
(300a,01a6)	Shielding Device Description	ShieldingDeviceDescription	ST	1	f	
(300a,01a8)	Shielding Device Position	ShieldingDevicePosition	SH	1	f	
(300a,01b0)	Setup Technique	SetupTechnique	CS	1	f	
(300a,01b2)	Setup Technique Description	SetupTechniqueDescription	ST	1	f	
(300a,01b4)	Setup Device Sequence	SetupDeviceSequence	SQ	1	f	
(300a,01b6)	Setup Device Type	SetupDeviceType	CS	1	f	
(300a,01b8)	Setup Device Label	SetupDeviceLabel	SH	1	f	
(300a,01ba)	Setup Device Description	SetupDeviceDescription	ST	1	f	
(300a,01bc)	Setup Device Parameter	SetupDeviceParameter	DS	1	f	
(300a,01d0)	Setup Reference Description	SetupReferenceDescription	ST	1	f	
(300a,01d2)	Table Top Vertical Setup Displacement	TableTopVerticalSetupDisplacement	DS	1	f	
(300a,01d4)	Table Top Longitudinal Setup Displacement	TableTopLongitudinalSetupDisplacement	DS	1	f	
(300a,01d6)	Table Top Lateral Setup Displacement	TableTopLateralSetupDisplacement	DS	1	f	
(300a,0200)	Brachy Treatment Technique	BrachyTreatmentTechnique	CS	1	f	
(300a,0202)	Brachy Treatment Type	BrachyTreatmentType	CS	1	f	
(300a,0206)	Treatment Machine Sequence	TreatmentMachineSequence	SQ	1	f	
(300a,0210)	Source Sequence	SourceSequence	SQ	1	f	
(300a,0212)	Source Number	SourceNumber	IS	1	f	
(300a,0214)	Source Type	SourceType	CS	1	f	
(300a,0216)	Source Manufacturer	SourceManufacturer	LO	1	f	
(300a,0218)	Active Source Diameter	ActiveSourceDiameter	DS	1	f	
(300a,021a)	Active Source Length	ActiveSourceLength	DS	1	f	
(300a,021b)	Source Model ID	SourceModelID	SH	1	f	
(300a,021c)	Source Description	SourceDescription	LO	1	f	
(300a,0222)	Source Encapsulation Nominal Thickness	SourceEncapsulationNominalThickness	DS	1	f	
(300a,0224)	Source Encapsulation Nominal Transmission	SourceEncapsulationNominalTransmission	DS	1	f	
(300a,0226)	Source Isotope Name	SourceIsotopeName	LO	1	f	
(300a,0228)	Source Isotope Half Life	SourceIsotopeHalfLife	DS	1	f	
(300a,0229)	Source Strength Units	SourceStrengthUnits	CS	1	f	
(300a,022a)	Reference Air Kerma Rate	ReferenceAirKermaRate	DS	1	f	
(300a,022b)	Source Strength	SourceStrength	DS	1	f	
(300a,022c)	Source Strength Reference Date	SourceStrengthReferenceDate	DA	1	f	
(300a,022e)	Source Strength Reference Time	SourceStrengthReferenceTime	TM	1	f	
(300a,0230)	Application Setup Sequence	ApplicationSetupSequence	SQ	1	f	
(300a,0232)	Application Setup Type	ApplicationSetupType	CS	1	f	
(300a,0234)	Application Setup Number	ApplicationSetupNumber	IS	1	f	
(300a,0236)	Application Setup Name	ApplicationSetupName	LO	1	f	
(300a,0238)	Application Setup Manufacturer	ApplicationSetupManufacturer	LO	1	f	
(300a,0240)	Template Number	TemplateNumber	IS	1	f	
(300a,0242)	Template Type	TemplateType	SH	1	f	
(300a,0244)	Template Name	TemplateName	LO	1	f	
(300a,0250)	Total Reference Air Kerma	TotalReferenceAirKerma	DS	1	f	
(300a,0260)	Brachy Accessory Device Sequence	BrachyAccessoryDeviceSequence	SQ	1	f	
(300a,0262)	Brachy Accessory Device Number	BrachyAccessoryDeviceNumber	IS	1	f	
(300a,0263)	Brachy Accessory Device ID	BrachyAccessoryDeviceID	SH	1	f	
(300a,0264)	Brachy Accessory Device Type	BrachyAccessoryDeviceType	CS	1	f	
(300a,0266)	Brachy Accessory Device Name	BrachyAccessoryDeviceName	LO	1	f	
(300a,026a)	Brachy Accessory Device Nominal Thickness	BrachyAccessoryDeviceNominalThickness	DS	1	f	
(300a,026c)	Brachy Accessory Device Nominal Transmission	BrachyAccessoryDeviceNominalTransmission	DS	1	f	
(300a,0280)	Channel Sequence	ChannelSequence	SQ	1	f	
(300a,0282)	Channel Number	ChannelNumber	IS	1	f	
(300a,0284)	Channel Length	ChannelLength	DS	1	f	
(300a,0286)	Channel Total Time	ChannelTotalTime	DS	1	f	
(300a,0288)	Source Movement Type	SourceMovementType	CS	1	f	
(300a,028a)	Number of Pulses	NumberOfPulses	IS	1	f	
(300a,028c)	Pulse Repetition Interval	PulseRepetitionInterval	DS	1	f	
(300a,0290)	Source Applicator Number	SourceApplicatorNumber	IS	1	f	
(300a,0291)	Source Applicator ID	SourceApplicatorID	SH	1	f	
(300a,0292)	Source Applicator Type	SourceApplicatorType	CS	1	f	
(300a,0294)	Source Applicator Name	SourceApplicatorName	LO	1	f	
(300a,0296)	Source Applicator Length	SourceApplicatorLength	DS	1	f	
(300a,0298)	Source Applicator Manufacturer	SourceApplicatorManufacturer	LO	1	f	
(300a,029c)	Source Applicator Wall Nominal Thickness	SourceApplicatorWallNominalThickness	DS	1	f	
(300a,029e)	Source Applicator Wall Nominal Transmission	SourceApplicatorWallNominalTransmission	DS	1	f	
(300a,02a0)	Source Applicator Step Size	SourceApplicatorStepSize	DS	1	f	
(300a,02a2)	Transfer Tube Number	TransferTubeNumber	IS	1	f	
(300a,02a4)	Transfer Tube Length	TransferTubeLength	DS	1	f	
(300a,02b0)	Channel Shield Sequence	ChannelShieldSequence	SQ	1	f	
(300a,02b2)	Channel Shield Number	ChannelShieldNumber	IS	1	f	
(300a,02b3)	Channel Shield ID	ChannelShieldID	SH	1	f	
(300a,02b4)	Channel Shield Name	ChannelShieldName	LO	1	f	
(300a,02b8)	Channel Shield Nominal Thickness	ChannelShieldNominalThickness	DS	1	f	
(300a,02ba)	Channel Shield Nominal Transmission	ChannelShieldNominalTransmission	DS	1	f	
(300a,02c8)	Final Cumulative Time Weight	FinalCumulativeTimeWeight	DS	1	f	
(300a,02d0)	Brachy Control Point Sequence	BrachyControlPointSequence	SQ	1	f	
(300a,02d2)	Control Point Relative Position	ControlPointRelativePosition	DS	1	f	
(300a,02d4)	Control Point 3D Position	ControlPoint3DPosition	DS	3	f	
(300a,02d6)	Cumulative Time Weight	CumulativeTimeWeight	DS	1	f	
(300a,02e0)	Compensator Divergence	CompensatorDivergence	CS	1	f	
(300a,02e1)	Compensator Mounting Position	CompensatorMountingPosition	CS	1	f	
(300a,02e2)	Source to Compensator Distance	SourceToCompensatorDistance	DS	1-n	f	
(300a,02e3)	Total Compensator Tray Water-Equivalent Thickness	TotalCompensatorTrayWaterEquivalentThickness	FL	1	f	
(300a,02e4)	Isocenter to Compensator Tray Distance	IsocenterToCompensatorTrayDistance	FL	1	f	
(300a,02e5)	Compensator Column Offset	CompensatorColumnOffset	FL	1	f	
(300a,02e6)	Isocenter to Compensator Distances	IsocenterToCompensatorDistances	FL	1-n	f	
(300a,02e7)	Compensator Relative Stopping Power Ratio	CompensatorRelativeStoppingPowerRatio	FL	1	f	
(300a,02e8)	Compensator Milling Tool Diameter	CompensatorMillingToolDiameter	FL	1	f	
(300a,02ea)	Ion Range Compensator Sequence	IonRangeCompensatorSequence	SQ	1	f	
(300a,02eb)	Compensator Description	CompensatorDescription	LT	1	f	
(300a,0302)	Radiation Mass Number	RadiationMassNumber	IS	1	f	
(300a,0304)	Radiation Atomic Number	RadiationAtomicNumber	IS	1	f	
(300a,0306)	Radiation Charge State	RadiationChargeState	SS	1	f	
(300a,0308)	Scan Mode	ScanMode	CS	1	f	
(300a,0309)	Modulated Scan Mode Type	ModulatedScanModeType	CS	1	f	
(300a,030a)	Virtual Source-Axis Distances	VirtualSourceAxisDistances	FL	2	f	
(300a,030c)	Snout Sequence	SnoutSequence	SQ	1	f	
(300a,030d)	Snout Position	SnoutPosition	FL	1	f	
(300a,030f)	Snout ID	SnoutID	SH	1	f	
(300a,0312)	Number of Range Shifters	NumberOfRangeShifters	IS	1	f	
(300a,0314)	Range Shifter Sequence	RangeShifterSequence	SQ	1	f	
(300a,0316)	Range Shifter Number	RangeShifterNumber	IS	1	f	
(300a,0318)	Range Shifter ID	RangeShifterID	SH	1	f	
(300a,0320)	Range Shifter Type	RangeShifterType	CS	1	f	
(300a,0322)	Range Shifter Description	RangeShifterDescription	LO	1	f	
(300a,0330)	Number of Lateral Spreading Devices	NumberOfLateralSpreadingDevices	IS	1	f	
(300a,0332)	Lateral Spreading Device Sequence	LateralSpreadingDeviceSequence	SQ	1	f	
(300a,0334)	Lateral Spreading Device Number	LateralSpreadingDeviceNumber	IS	1	f	
(300a,0336)	Lateral Spreading Device ID	LateralSpreadingDeviceID	SH	1	f	
(300a,0338)	Lateral Spreading Device Type	LateralSpreadingDeviceType	CS	1	f	
(300a,033a)	Lateral Spreading Device Description	LateralSpreadingDeviceDescription	LO	1	f	
(300a,033c)	Lateral Spreading Device Water Equivalent Thickness	LateralSpreadingDeviceWaterEquivalentThickness	FL	1	f	
(300a,0340)	Number of Range Modulators	NumberOfRangeModulators	IS	1	f	
(300a,0342)	Range Modulator Sequence	RangeModulatorSequence	SQ	1	f	
(300a,0344)	Range Modulator Number	RangeModulatorNumber	IS	1	f	
(300a,0346)	Range Modulator ID	RangeModulatorID	SH	1	f	
(300a,0348)	Range Modulator Type	RangeModulatorType	CS	1	f	
(300a,034a)	Range Modulator Description	RangeModulatorDescription	LO	1	f	
(300a,034c)	Beam Current Modulation ID	BeamCurrentModulationID	SH	1	f	
(300a,0350)	Patient Support Type	PatientSupportType	CS	1	f	
(300a,0352)	Patient Support ID	PatientSupportID	SH	1	f	
(300a,0354)	Patient Support Accessory Code	PatientSupportAccessoryCode	LO	1	f	
(300a,0355)	Tray Accessory Code	TrayAccessoryCode	LO	1	f	
(300a,0356)	Fixation Light Azimuthal Angle	FixationLightAzimuthalAngle	FL	1	f	
(300a,0358)	Fixation Light Polar Angle	FixationLightPolarAngle	FL	1	f	
(300a,035a)	Meterset Rate	MetersetRate	FL	1	f	
(300a,0360)	Range Shifter Settings Sequence	RangeShifterSettingsSequence	SQ	1	f	
(300a,0362)	Range Shifter Setting	RangeShifterSetting	LO	1	f	
(300a,0364)	Isocenter to Range Shifter Distance	IsocenterToRangeShifterDistance	FL	1	f	
(300a,0366)	Range Shifter Water Equivalent Thickness	RangeShifterWaterEquivalentThickness	FL	1	f	
(300a,0370)	Lateral Spreading Device Settings Sequence	LateralSpreadingDeviceSettingsSequence	SQ	1	f	
(300a,0372)	Lateral Spreading Device Setting	LateralSpreadingDeviceSetting	LO	1	f	
(300a,0374)	Isocenter to Lateral Spreading Device Distance	IsocenterToLateralSpreadingDeviceDistance	FL	1	f	
(300a,0380)	Range Modulator Settings Sequence	RangeModulatorSettingsSequence	SQ	1	f	
(300a,0382)	Range Modulator Gating Start Value	RangeModulatorGatingStartValue	FL	1	f	
(300a,0384)	Range Modulator Gating Stop Value	RangeModulatorGatingStopValue	FL	1	f	
(300a,0386)	Range Modulator Gating Start Water Equivalent Thickness	RangeModulatorGatingStartWaterEquivalentThickness	FL	1	f	
(300a,0388)	Range Modulator Gating Stop Water Equivalent Thickness	RangeModulatorGatingStopWaterEquivalentThickness	FL	1	f	
(300a,038a)	Isocenter to Range Modulator Distance	IsocenterToRangeModulatorDistance	FL	1	f	
(300a,0390)	Scan Spot Tune ID	ScanSpotTuneID	SH	1	f	
(300a,0391)	Scan Spot Prescribed Indices	ScanSpotPrescribedIndices	IS	1-n	f	
(300a,0392)	Number of Scan Spot Positions	NumberOfScanSpotPositions	IS	1	f	
(300a,0393)	Scan Spot Reordered	ScanSpotReordered	CS	1	f	
(300a,0394)	Scan Spot Position Map	ScanSpotPositionMap	FL	1-n	f	
(300a,0395)	Scan Spot Reordering Allowed	ScanSpotReorderingAllowed	CS	1	f	
(300a,0396)	Scan Spot Meterset Weights	ScanSpotMetersetWeights	FL	1-n	f	
(300a,0398)	Scanning Spot Size	ScanningSpotSize	FL	2	f	
(300a,039a)	Number of Paintings	NumberOfPaintings	IS	1	f	
(300a,03a0)	Ion Tolerance Table Sequence	IonToleranceTableSequence	SQ	1	f	
(300a,03a2)	Ion Beam Sequence	IonBeamSequence	SQ	1	f	
(300a,03a4)	Ion Beam Limiting Device Sequence	IonBeamLimitingDeviceSequence	SQ	1	f	
(300a,03a6)	Ion Block Sequence	IonBlockSequence	SQ	1	f	
(300a,03a8)	Ion Control Point Sequence	IonControlPointSequence	SQ	1	f	
(300a,03aa)	Ion Wedge Sequence	IonWedgeSequence	SQ	1	f	
(300a,03ac)	Ion Wedge Position Sequence	IonWedgePositionSequence	SQ	1	f	
(300a,0401)	Referenced Setup Image Sequence	ReferencedSetupImageSequence	SQ	1	f	
(300a,0402)	Setup Image Comment	SetupImageComment	ST	1	f	
(300a,0410)	Motion Synchronization Sequence	MotionSynchronizationSequence	SQ	1	f	
(300a,0412)	Control Point Orientation	ControlPointOrientation	FL	3	f	
(300a,0420)	General Accessory Sequence	GeneralAccessorySequence	SQ	1	f	
(300a,0421)	General Accessory ID	GeneralAccessoryID	SH	1	f	
(300a,0422)	General Accessory Description	GeneralAccessoryDescription	ST	1	f	
(300a,0423)	General Accessory Type	GeneralAccessoryType	CS	1	f	
(300a,0424)	General Accessory Number	GeneralAccessoryNumber	IS	1	f	
(300a,0425)	Source to General Accessory Distance	SourceToGeneralAccessoryDistance	FL	1	f	
(300a,0431)	Applicator Geometry Sequence	ApplicatorGeometrySequence	SQ	1	f	
(300a,0432)	Applicator Aperture Shape	ApplicatorApertureShape	CS	1	f	
(300a,0433)	Applicator Opening	ApplicatorOpening	FL	1	f	
(300a,0434)	Applicator Opening X	ApplicatorOpeningX	FL	1	f	
(300a,0435)	Applicator Opening Y	ApplicatorOpeningY	FL	1	f	
(300a,0436)	Source to Applicator Mounting Position Distance	SourceToApplicatorMountingPositionDistance	FL	1	f	
(300a,0440)	Number of Block Slab Items	NumberOfBlockSlabItems	IS	1	f	
(300a,0441)	Block Slab Sequence	BlockSlabSequence	SQ	1	f	
(300a,0442)	Block Slab Thickness	BlockSlabThickness	DS	1	f	
(300a,0443)	Block Slab Number	BlockSlabNumber	US	1	f	
(300a,0450)	Device Motion Control Sequence	DeviceMotionControlSequence	SQ	1	f	
(300a,0451)	Device Motion Execution Mode	DeviceMotionExecutionMode	CS	1	f	
(300a,0452)	Device Motion Observation Mode	DeviceMotionObservationMode	CS	1	f	
(300a,0453)	Device Motion Parameter Code Sequence	DeviceMotionParameterCodeSequence	SQ	1	f	
(300a,0501)	Distal Depth Fraction	DistalDepthFraction	FL	1	f	
(300a,0502)	Distal Depth	DistalDepth	FL	1	f	
(300a,0503)	Nominal Range Modulation Fractions	NominalRangeModulationFractions	FL	2	f	
(300a,0504)	Nominal Range Modulated Region Depths	NominalRangeModulatedRegionDepths	FL	2	f	
(300a,0505)	Depth Dose Parameters Sequence	DepthDoseParametersSequence	SQ	1	f	
(300a,0506)	Delivered Depth Dose Parameters Sequence	DeliveredDepthDoseParametersSequence	SQ	1	f	
(300a,0507)	Delivered Distal Depth Fraction	DeliveredDistalDepthFraction	FL	1	f	
(300a,0508)	Delivered Distal Depth	DeliveredDistalDepth	FL	1	f	
(300a,0509)	Delivered Nominal Range Modulation Fractions	DeliveredNominalRangeModulationFractions	FL	2	f	
(300a,0510)	Delivered Nominal Range Modulated Region Depths	DeliveredNominalRangeModulatedRegionDepths	FL	2	f	
(300a,0511)	Delivered Reference Dose Definition	DeliveredReferenceDoseDefinition	CS	1	f	
(300a,0512)	Reference Dose Definition	ReferenceDoseDefinition	CS	1	f	
(300c,0002)	Referenced RT Plan Sequence	ReferencedRTPlanSequence	SQ	1	f	
(300c,0004)	Referenced Beam Sequence	ReferencedBeamSequence	SQ	1	f	
(300c,0006)	Referenced Beam Number	ReferencedBeamNumber	IS	1	f	
(300c,0007)	Referenced Reference Image Number	ReferencedReferenceImageNumber	IS	1	f	
(300c,0008)	Start Cumulative Meterset Weight	StartCumulativeMetersetWeight	DS	1	f	
(300c,0009)	End Cumulative Meterset Weight	EndCumulativeMetersetWeight	DS	1	f	
(300c,000a)	Referenced Brachy Application Setup Sequence	ReferencedBrachyApplicationSetupSequence	SQ	1	f	
(300c,000c)	Referenced Brachy Application Setup Number	ReferencedBrachyApplicationSetupNumber	IS	1	f	
(300c,000e)	Referenced Source Number	ReferencedSourceNumber	IS	1	f	
(300c,0020)	Referenced Fraction Group Sequence	ReferencedFractionGroupSequence	SQ	1	f	
(300c,0022)	Referenced Fraction Group Number	ReferencedFractionGroupNumber	IS	1	f	
(300c,0040)	Referenced Verification Image Sequence	ReferencedVerificationImageSequence	SQ	1	f	
(300c,0042)	Referenced Reference Image Sequence	ReferencedReferenceImageSequence	SQ	1	f	
(300c,0050)	Referenced Dose Reference Sequence	ReferencedDoseReferenceSequence	SQ	1	f	
(300c,0051)	Referenced Dose Reference Number	ReferencedDoseReferenceNumber	IS	1	f	
(300c,0055)	Brachy Referenced Dose Reference Sequence	BrachyReferencedDoseReferenceSequence	SQ	1	f	
(300c,0060)	Referenced Structure Set Sequence	ReferencedStructureSetSequence	SQ	1	f	
(300c,006a)	Referenced Patient Setup Number	ReferencedPatientSetupNumber	IS	1	f	
(300c,0080)	Referenced Dose Sequence	ReferencedDoseSequence	SQ	1	f	
(300c,00a0)	Referenced Tolerance Table Number	ReferencedToleranceTableNumber	IS	1	f	
(300c,00b0)	Referenced Bolus Sequence	ReferencedBolusSequence	SQ	1	f	
(300c,00c0)	Referenced Wedge Number	ReferencedWedgeNumber	IS	1	f	
(300c,00d0)	Referenced Compensator Number	ReferencedCompensatorNumber	IS	1	f	
(300c,00e0)	Referenced Block Number	ReferencedBlockNumber	IS	1	f	
(300c,00f0)	Referenced Control Point Index	ReferencedControlPointIndex	IS	1	f	
(300c,00f2)	Referenced Control Point Sequence	ReferencedControlPointSequence	SQ	1	f	
(300c,00f4)	Referenced Start Control Point Index	ReferencedStartControlPointIndex	IS	1	f	
(300c,00f6)	Referenced Stop Control Point Index	ReferencedStopControlPointIndex	IS	1	f	
(300c,0100)	Referenced Range Shifter Number	ReferencedRangeShifterNumber	IS	1	f	
(300c,0102)	Referenced Lateral Spreading Device Number	ReferencedLateralSpreadingDeviceNumber	IS	1	f	
(300c,0104)	Referenced Range Modulator Number	ReferencedRangeModulatorNumber	IS	1	f	
(300c,0111)	Omitted Beam Task Sequence	OmittedBeamTaskSequence	SQ	1	f	
(300c,0112)	Reason for Omission	ReasonForOmission	CS	1	f	
(300c,0113)	Reason for Omission Description	ReasonForOmissionDescription	LO	1	f	
(300e,0002)	Approval Status	ApprovalStatus	CS	1	f	
(300e,0004)	Review Date	ReviewDate	DA	1	f	
(300e,0005)	Review Time	ReviewTime	TM	1	f	
(300e,0008)	Reviewer Name	ReviewerName	PN	1	f	
(4000,0010)	Arbitrary	Arbitrary	LT	1	t	
(4000,4000)	Text Comments	TextComments	LT	1	t	
(4008,0040)	Results ID	ResultsID	SH	1	t	
(4008,0042)	Results ID Issuer	ResultsIDIssuer	LO	1	t	
(4008,0050)	Referenced Interpretation Sequence	ReferencedInterpretationSequence	SQ	1	t	
(4008,00ff)	Report Production Status (Trial)	ReportProductionStatusTrial	CS	1	t	
(4008,0100)	Interpretation Recorded Date	InterpretationRecordedDate	DA	1	t	
(4008,0101)	Interpretation Recorded Time	InterpretationRecordedTime	TM	1	t	
(4008,0102)	Interpretation Recorder	InterpretationRecorder	PN	1	t	
(4008,0103)	Reference to Recorded Sound	ReferenceToRecordedSound	LO	1	t	
(4008,0108)	Interpretation Transcription Date	InterpretationTranscriptionDate	DA	1	t	
(4008,0109)	Interpretation Transcription Time	InterpretationTranscriptionTime	TM	1	t	
(4008,010a)	Interpretation Transcriber	InterpretationTranscriber	PN	1	t	
(4008,010b)	Interpretation Text	InterpretationText	ST	1	t	
(4008,010c)	Interpretation Author	InterpretationAuthor	PN	1	t	
(4008,0111)	Interpretation Approver Sequence	InterpretationApproverSequence	SQ	1	t	
(4008,0112)	Interpretation Approval Date	InterpretationApprovalDate	DA	1	t	
(4008,0113)	Interpretation Approval Time	InterpretationApprovalTime	TM	1	t	
(4008,0114)	Physician Approving Interpretation	PhysicianApprovingInterpretation	PN	1	t	
(4008,0115)	Interpretation Diagnosis Description	InterpretationDiagnosisDescription	LT	1	t	
(4008,0117)	Interpretation Diagnosis Code Sequence	InterpretationDiagnosisCodeSequence	SQ	1	t	
(4008,0118)	Results Distribution List Sequence	ResultsDistributionListSequence	SQ	1	t	
(4008,0119)	Distribution Name	DistributionName	PN	1	t	
(4008,011a)	Distribution Address	DistributionAddress	LO	1	t	
(4008,0200)	Interpretation ID	InterpretationID	SH	1	t	
(4008,0202)	Interpretation ID Issuer	InterpretationIDIssuer	LO	1	t	
(4008,0210)	Interpretation Type ID	InterpretationTypeID	CS	1	t	
(4008,0212)	Interpretation Status ID	InterpretationStatusID	CS	1	t	
(4008,0300)	Impressions	Impressions	ST	1	t	
(4008,4000)	Results Comments	ResultsComments	ST	1	t	
(4010,0001)	Low Energy Detectors	LowEnergyDetectors	CS	1	f	DICOS
(4010,0002)	High Energy Detectors	HighEnergyDetectors	CS	1	f	DICOS
(4010,0004)	Detector Geometry Sequence	DetectorGeometrySequence	SQ	1	f	DICOS
(4010,1001)	Threat ROI Voxel Sequence	ThreatROIVoxelSequence	SQ	1	f	DICOS
(4010,1004)	Threat ROI Base	ThreatROIBase	FL	3	f	DICOS
(4010,1005)	Threat ROI Extents	ThreatROIExtents	FL	3	f	DICOS
(4010,1006)	Threat ROI Bitmap	ThreatROIBitmap	OB	1	f	DICOS
(4010,1007)	Route Segment ID	RouteSegmentID	SH	1	f	DICOS
(4010,1008)	Gantry Type	GantryType	CS	1	f	DICOS
(4010,1009)	OOI Owner Type	OOIOwnerType	CS	1	f	DICOS
(4010,100a)	Route Segment Sequence	RouteSegmentSequence	SQ	1	f	DICOS
(4010,1010)	Potential Threat Object ID	PotentialThreatObjectID	US	1	f	DICOS
(4010,1011)	Threat Sequence	ThreatSequence	SQ	1	f	DICOS
(4010,1012)	Threat Category	ThreatCategory	CS	1	f	DICOS
(4010,1013)	Threat Category Description	ThreatCategoryDescription	LT	1	f	DICOS
(4010,1014)	ATD Ability Assessment	ATDAbilityAssessment	CS	1	f	DICOS
(4010,1015)	ATD Assessment Flag	ATDAssessmentFlag	CS	1	f	DICOS
(4010,1016)	ATD Assessment Probability	ATDAssessmentProbability	FL	1	f	DICOS
(4010,1019)	Z Effective	ZEffective	FL	1	f	DICOS
(4010,101a)	Boarding Pass ID	BoardingPassID	SH	1	f	DICOS
(4010,101b)	Center of Mass	CenterOfMass	FL	3	f	DICOS
(4010,101c)	Center of PTO	CenterOfPTO	FL	3	f	DICOS
(4010,101d)	Bounding Polygon	BoundingPolygon	FL	6-n	f	DICOS
(4010,101e)	Route Segment Start Location ID	RouteSegmentStartLocationID	SH	1	f	DICOS
(4010,101f)	Route Segment End Location ID	RouteSegmentEndLocationID	SH	1	f	DICOS
(4010,1020)	Route Segment Location ID Type	RouteSegmentLocationIDType	CS	1	f	DICOS
(4010,1021)	Abort Reason	AbortReason	CS	1-n	f	DICOS
(4010,1023)	Volume of PTO	VolumeOfPTO	FL	1	f	DICOS
(4010,1024)	Abort Flag	AbortFlag	CS	1	f	DICOS
(4010,1025)	Route Segment Start Time	RouteSegmentStartTime	DT	1	f	DICOS
(4010,1026)	Route Segment End Time	RouteSegmentEndTime	DT	1	f	DICOS
(4010,1027)	TDR Type	TDRType	CS	1	f	DICOS
(4010,1028)	International Route Segment	InternationalRouteSegment	CS	1	f	DICOS
(4010,1029)	Threat Detection Algorithm and Version	ThreatDetectionAlgorithmandVersion	LO	1-n	f	DICOS
(4010,102a)	Assigned Location	AssignedLocation	SH	1	f	DICOS
(4010,102b)	Alarm Decision Time	AlarmDecisionTime	DT	1	f	DICOS
(4010,1031)	Alarm Decision	AlarmDecision	CS	1	f	DICOS
(4010,1033)	Number of Total Objects	NumberOfTotalObjects	US	1	f	DICOS
(4010,1034)	Number of Alarm Objects	NumberOfAlarmObjects	US	1	f	DICOS
(4010,1037)	PTO Representation Sequence	PTORepresentationSequence	SQ	1	f	DICOS
(4010,1038)	ATD Assessment Sequence	ATDAssessmentSequence	SQ	1	f	DICOS
(4010,1039)	TIP Type	TIPType	CS	1	f	DICOS
(4010,103a)	DICOS Version	DICOSVersion	CS	1	f	DICOS
(4010,1041)	OOI Owner Creation Time	OOIOwnerCreationTime	DT	1	f	DICOS
(4010,1042)	OOI Type	OOIType	CS	1	f	DICOS
(4010,1043)	OOI Size	OOISize	FL	3	f	DICOS
(4010,1044)	Acquisition Status	AcquisitionStatus	CS	1	f	DICOS
(4010,1045)	Basis Materials Code Sequence	BasisMaterialsCodeSequence	SQ	1	f	DICOS
(4010,1046)	Phantom Type	PhantomType	CS	1	f	DICOS
(4010,1047)	OOI Owner Sequence	OOIOwnerSequence	SQ	1	f	DICOS
(4010,1048)	Scan Type	ScanType	CS	1	f	DICOS
(4010,1051)	Itinerary ID	ItineraryID	LO	1	f	DICOS
(4010,1052)	Itinerary ID Type	ItineraryIDType	SH	1	f	DICOS
(4010,1053)	Itinerary ID Assigning Authority	ItineraryIDAssigningAuthority	LO	1	f	DICOS
(4010,1054)	Route ID	RouteID	SH	1	f	DICOS
(4010,1055)	Route ID Assigning Authority	RouteIDAssigningAuthority	SH	1	f	DICOS
(4010,1056)	Inbound Arrival Type	InboundArrivalType	CS	1	f	DICOS
(4010,1058)	Carrier ID	CarrierID	SH	1	f	DICOS
(4010,1059)	Carrier ID Assigning Authority	CarrierIDAssigningAuthority	CS	1	f	DICOS
(4010,1060)	Source Orientation	SourceOrientation	FL	3	f	DICOS
(4010,1061)	Source Position	SourcePosition	FL	3	f	DICOS
(4010,1062)	Belt Height	BeltHeight	FL	1	f	DICOS
(4010,1064)	Algorithm Routing Code Sequence	AlgorithmRoutingCodeSequence	SQ	1	f	DICOS
(4010,1067)	Transport Classification	TransportClassification	CS	1	f	DICOS
(4010,1068)	OOI Type Descriptor	OOITypeDescriptor	LT	1	f	DICOS
(4010,1069)	Total Processing Time	TotalProcessingTime	FL	1	f	DICOS
(4010,106c)	Detector Calibration Data	DetectorCalibrationData	OB	1	f	DICOS
(4010,106d)	Additional Screening Performed	AdditionalScreeningPerformed	CS	1	f	DICOS
(4010,106e)	Additional Inspection Selection Criteria	AdditionalInspectionSelectionCriteria	CS	1	f	DICOS
(4010,106f)	Additional Inspection Method Sequence	AdditionalInspectionMethodSequence	SQ	1	f	DICOS
(4010,1070)	AIT Device Type	AITDeviceType	CS	1	f	DICOS
(4010,1071)	QR Measurements Sequence	QRMeasurementsSequence	SQ	1	f	DICOS
(4010,1072)	Target Material Sequence	TargetMaterialSequence	SQ	1	f	DICOS
(4010,1073)	SNR Threshold	SNRThreshold	FD	1	f	DICOS
(4010,1075)	Image Scale Representation	ImageScaleRepresentation	DS	1	f	DICOS
(4010,1076)	Referenced PTO Sequence	ReferencedPTOSequence	SQ	1	f	DICOS
(4010,1077)	Referenced TDR Instance Sequence	ReferencedTDRInstanceSequence	SQ	1	f	DICOS
(4010,1078)	PTO Location Description	PTOLocationDescription	ST	1	f	DICOS
(4010,1079)	Anomaly Locator Indicator Sequence	AnomalyLocatorIndicatorSequence	SQ	1	f	DICOS
(4010,107a)	Anomaly Locator Indicator	AnomalyLocatorIndicator	FL	3	f	DICOS
(4010,107b)	PTO Region Sequence	PTORegionSequence	SQ	1	f	DICOS
(4010,107c)	Inspection Selection Criteria	InspectionSelectionCriteria	CS	1	f	DICOS
(4010,107d)	Secondary Inspection Method Sequence	SecondaryInspectionMethodSequence	SQ	1	f	DICOS
(4010,107e)	PRCS to RCS Orientation	PRCSToRCSOrientation	DS	6	f	DICOS
(4ffe,0001)	MAC Parameters Sequence	MACParametersSequence	SQ	1	f	
(50xx,0005)	Curve Dimensions	CurveDimensions	US	1	t	
(50xx,0010)	Number of Points	NumberOfPoints	US	1	t	
(50xx,0020)	Type of Data	TypeOfData	CS	1	t	
(50xx,0022)	Curve Description	CurveDescription	LO	1	t	
(50xx,0030)	Axis Units	AxisUnits	SH	1-n	t	
(50xx,0040)	Axis Labels	AxisLabels	SH	1-n	t	
(50xx,0103)	Data Value Representation	DataValueRepresentation	US	1	t	
(50xx,0104)	Minimum Coordinate Value	MinimumCoordinateValue	US	1-n	t	
(50xx,0105)	Maximum Coordinate Value	MaximumCoordinateValue	US	1-n	t	
(50xx,0106)	Curve Range	CurveRange	SH	1-n	t	
(50xx,0110)	Curve Data Descriptor	CurveDataDescriptor	US	1-n	t	
(50xx,0112)	Coordinate Start Value	CoordinateStartValue	US	1-n	t	
(50xx,0114)	Coordinate Step Value	CoordinateStepValue	US	1-n	t	
(50xx,1001)	Curve Activation Layer	CurveActivationLayer	CS	1	t	
(50xx,2000)	Audio Type	AudioType	US	1	t	
(50xx,2002)	Audio Sample Format	AudioSampleFormat	US	1	t	
(50xx,2004)	Number of Channels	NumberOfChannels	US	1	t	
(50xx,2006)	Number of Samples	NumberOfSamples	UL	1	t	
(50xx,2008)	Sample Rate	SampleRate	UL	1	t	
(50xx,200a)	Total Time	TotalTime	UL	1	t	
(50xx,200c)	Audio Sample Data	AudioSampleData	OB or OW	1	t	
(50xx,200e)	Audio Comments	AudioComments	LT	1	t	
(50xx,2500)	Curve Label	CurveLabel	LO	1	t	
(50xx,2600)	Curve Referenced Overlay Sequence	CurveReferencedOverlaySequence	SQ	1	t	
(50xx,2610)	Curve Referenced Overlay Group	CurveReferencedOverlayGroup	US	1	t	
(50xx,3000)	Curve Data	CurveData	OB or OW	1	t	
(5200,9229)	Shared Functional Groups Sequence	SharedFunctionalGroupsSequence	SQ	1	f	
(5200,9230)	Per-frame Functional Groups Sequence	PerFrameFunctionalGroupsSequence	SQ	1	f	
(5400,0100)	Waveform Sequence	WaveformSequence	SQ	1	f	
(5400,0110)	Channel Minimum Value	ChannelMinimumValue	OB or OW	1	f	
(5400,0112)	Channel Maximum Value	ChannelMaximumValue	OB or OW	1	f	
(5400,1004)	Waveform Bits Allocated	WaveformBitsAllocated	US	1	f	
(5400,1006)	Waveform Sample Interpretation	WaveformSampleInterpretation	CS	1	f	
(5400,100a)	Waveform Padding Value	WaveformPaddingValue	OB or OW	1	f	
(5400,1010)	Waveform Data	WaveformData	OB or OW	1	f	
(5600,0010)	First Order Phase Correction Angle	FirstOrderPhaseCorrectionAngle	OF	1	f	
(5600,0020)	Spectroscopy Data	SpectroscopyData	OF	1	f	
(60xx,0010)	Overlay Rows	OverlayRows	US	1	f	
(60xx,0011)	Overlay Columns	OverlayColumns	US	1	f	
(60xx,0012)	Overlay Planes	OverlayPlanes	US	1	t	
(60xx,0015)	Number of Frames in Overlay	NumberOfFramesInOverlay	IS	1	f	
(60xx,0022)	Overlay Description	OverlayDescription	LO	1	f	
(60xx,0040)	Overlay Type	OverlayType	CS	1	f	
(60xx,0045)	Overlay Subtype	OverlaySubtype	LO	1	f	
(60xx,0050)	Overlay Origin	OverlayOrigin	SS	2	f	
(60xx,0051)	Image Frame Origin	ImageFrameOrigin	US	1	f	
(60xx,0052)	Overlay Plane Origin	OverlayPlaneOrigin	US	1	t	
(60xx,0060)	Overlay Compression Code	OverlayCompressionCode	CS	1	t	
(60xx,0061)	Overlay Compression Originator	OverlayCompressionOriginator	SH	1	t	
(60xx,0062)	Overlay Compression Label	OverlayCompressionLabel	SH	1	t	
(60xx,0063)	Overlay Compression Description	OverlayCompressionDescription	CS	1	t	
(60xx,0066)	Overlay Compression Step Pointers	OverlayCompressionStepPointers	AT	1-n	t	
(60xx,0068)	Overlay Repeat Interval	OverlayRepeatInterval	US	1	t	
(60xx,0069)	Overlay Bits Grouped	OverlayBitsGrouped	US	1	t	
(60xx,0100)	Overlay Bits Allocated	OverlayBitsAllocated	US	1	f	
(60xx,0102)	Overlay Bit Position	OverlayBitPosition	US	1	f	
(60xx,0110)	Overlay Format	OverlayFormat	CS	1	t	
(60xx,0200)	Overlay Location	OverlayLocation	US	1	t	
(60xx,0800)	Overlay Code Label	OverlayCodeLabel	CS	1-n	t	
(60xx,0802)	Overlay Number of Tables	OverlayNumberOfTables	US	1	t	
(60xx,0803)	Overlay Code Table Location	OverlayCodeTableLocation	AT	1-n	t	
(60xx,0804)	Overlay Bits For Code Word	OverlayBitsForCodeWord	US	1	t	
(60xx,1001)	Overlay Activation Layer	OverlayActivationLayer	CS	1	f	
(60xx,1100)	Overlay Descriptor - Gray	OverlayDescriptorGray	US	1	t	
(60xx,1101)	Overlay Descriptor - Red	OverlayDescriptorRed	US	1	t	
(60xx,1102)	Overlay Descriptor - Green	OverlayDescriptorGreen	US	1	t	
(60xx,1103)	Overlay Descriptor - Blue	OverlayDescriptorBlue	US	1	t	
(60xx,1200)	Overlays - Gray	OverlaysGray	US	1-n	t	
(60xx,1201)	Overlays - Red	OverlaysRed	US	1-n	t	
(60xx,1202)	Overlays - Green	OverlaysGreen	US	1-n	t	
(60xx,1203)	Overlays - Blue	OverlaysBlue	US	1-n	t	
(60xx,1301)	ROI Area	ROIArea	IS	1	f	
(60xx,1302)	ROI Mean	ROIMean	DS	1	f	
(60xx,1303)	ROI Standard Deviation	ROIStandardDeviation	DS	1	f	
(60xx,1500)	Overlay Label	OverlayLabel	LO	1	f	
(60xx,3000)	Overlay Data	OverlayData	OB or OW	1	f	
(60xx,4000)	Overlay Comments	OverlayComments	LT	1	t	
(7fe0,0008)	Float Pixel Data	FloatPixelData	OF	1	f	
(7fe0,0009)	Double Float Pixel Data	DoubleFloatPixelData	OD	1	f	
(7fe0,0010)	Pixel Data	PixelData	OB or OW	1	f	
(7fe0,0020)	Coefficients SDVN	CoefficientsSDVN	OW	1	t	
(7fe0,0030)	Coefficients SDHN	CoefficientsSDHN	OW	1	t	
(7fe0,0040)	Coefficients SDDN	CoefficientsSDDN	OW	1	t	
(7fxx,0010)	Variable Pixel Data	VariablePixelData	OB or OW	1	t	
(7fxx,0011)	Variable Next Data Group	VariableNextDataGroup	US	1	t	
(7fxx,0020)	Variable Coefficients SDVN	VariableCoefficientsSDVN	OW	1	t	
(7fxx,0030)	Variable Coefficients SDHN	VariableCoefficientsSDHN	OW	1	t	
(7fxx,0040)	Variable Coefficients SDDN	VariableCoefficientsSDDN	OW	1	t	
(fffa,fffa)	Digital Signatures Sequence	DigitalSignaturesSequence	SQ	1	f	
(fffc,fffc)	Data Set Trailing Padding	DataSetTrailingPadding	OB	1	f	
(fffe,e000)	Item	Item	See Note	1	f	
(fffe,e00d)	Item Delimitation Item	ItemDelimitationItem	See Note	1	f	
(fffe,e0dd)	Sequence Delimitation Item	SequenceDelimitationItem	See Note	1	f	
\.


--
-- PostgreSQL database dump complete
--

\connect private_tag_kb
--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

--
-- Name: pt_pt_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('pt_pt_id_seq', 11166, true);


--
-- Name: ptrg_ptrg_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('ptrg_ptrg_id_seq', 27, true);


--
-- Data for Name: pt; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt (pt_id, pt_signature, pt_short_signature, pt_owner, pt_group, pt_element, pt_is_specific_to_block, pt_specific_block, pt_consensus_vr, pt_consensus_vm, pt_consensus_name, pt_consensus_disposition) FROM stdin;
1	(0019,"1.2.840.113681",10)	(0019,"1.2.840.113681",10)	1.2.840.113681	25	16	f	\N	ST	1	CRImageParamsCommon	\N
2	(0019,"1.2.840.113681",11)	(0019,"1.2.840.113681",11)	1.2.840.113681	25	17	f	\N	ST	1	CRImageIPParamsSingle	\N
3	(0019,"1.2.840.113681",12)	(0019,"1.2.840.113681",12)	1.2.840.113681	25	18	f	\N	ST	1	CRImageIPParamsLeft	\N
4	(0019,"1.2.840.113681",13)	(0019,"1.2.840.113681",13)	1.2.840.113681	25	19	f	\N	ST	1	CRImageIPParamsRight	\N
5	(0087,"1.2.840.113708.794.1.1.2.0",10)	(0087,"1.2.840.113708.794.1.1.2.0",10)	1.2.840.113708.794.1.1.2.0	135	16	f	\N	CS	1	MediaType	\N
6	(0087,"1.2.840.113708.794.1.1.2.0",20)	(0087,"1.2.840.113708.794.1.1.2.0",20)	1.2.840.113708.794.1.1.2.0	135	32	f	\N	CS	1	MediaLocation	\N
7	(0087,"1.2.840.113708.794.1.1.2.0",50)	(0087,"1.2.840.113708.794.1.1.2.0",50)	1.2.840.113708.794.1.1.2.0	135	80	f	\N	IS	1	EstimatedRetrieveTime	\N
8	(0009,"ACUSON",00)	(0009,"ACUSON",00)	ACUSON	9	0	f	\N	IS	1	Unknown	\N
9	(0009,"ACUSON",01)	(0009,"ACUSON",01)	ACUSON	9	1	f	\N	IS	1	Unknown	\N
10	(0009,"ACUSON",02)	(0009,"ACUSON",02)	ACUSON	9	2	f	\N	UN	1	Unknown	\N
11	(0009,"ACUSON",03)	(0009,"ACUSON",03)	ACUSON	9	3	f	\N	UN	1	Unknown	\N
12	(0009,"ACUSON",04)	(0009,"ACUSON",04)	ACUSON	9	4	f	\N	UN	1	Unknown	\N
13	(0009,"ACUSON",05)	(0009,"ACUSON",05)	ACUSON	9	5	f	\N	UN	1	Unknown	\N
14	(0009,"ACUSON",06)	(0009,"ACUSON",06)	ACUSON	9	6	f	\N	UN	1	Unknown	\N
15	(0009,"ACUSON",07)	(0009,"ACUSON",07)	ACUSON	9	7	f	\N	UN	1	Unknown	\N
16	(0009,"ACUSON",08)	(0009,"ACUSON",08)	ACUSON	9	8	f	\N	LT	1	Unknown	\N
17	(0009,"ACUSON",09)	(0009,"ACUSON",09)	ACUSON	9	9	f	\N	LT	1	Unknown	\N
18	(0009,"ACUSON",0a)	(0009,"ACUSON",0a)	ACUSON	9	10	f	\N	IS	1	Unknown	\N
19	(0009,"ACUSON",0b)	(0009,"ACUSON",0b)	ACUSON	9	11	f	\N	IS	1	Unknown	\N
20	(0009,"ACUSON",0c)	(0009,"ACUSON",0c)	ACUSON	9	12	f	\N	IS	1	Unknown	\N
21	(0009,"ACUSON",0d)	(0009,"ACUSON",0d)	ACUSON	9	13	f	\N	IS	1	Unknown	\N
22	(0009,"ACUSON",0e)	(0009,"ACUSON",0e)	ACUSON	9	14	f	\N	IS	1	Unknown	\N
23	(0009,"ACUSON",0f)	(0009,"ACUSON",0f)	ACUSON	9	15	f	\N	UN	1	Unknown	\N
24	(0009,"ACUSON",10)	(0009,"ACUSON",10)	ACUSON	9	16	f	\N	IS	1	Unknown	\N
25	(0009,"ACUSON",11)	(0009,"ACUSON",11)	ACUSON	9	17	f	\N	UN	1	Unknown	\N
26	(0009,"ACUSON",12)	(0009,"ACUSON",12)	ACUSON	9	18	f	\N	IS	1	Unknown	\N
27	(0009,"ACUSON",13)	(0009,"ACUSON",13)	ACUSON	9	19	f	\N	IS	1	Unknown	\N
28	(0009,"ACUSON",14)	(0009,"ACUSON",14)	ACUSON	9	20	f	\N	LT	1	Unknown	\N
29	(0009,"ACUSON",15)	(0009,"ACUSON",15)	ACUSON	9	21	f	\N	UN	1	Unknown	\N
30	(0003,"AEGIS_DICOM_2.00",00)	(0003,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	3	0	f	\N	US	1-n	Unknown	\N
31	(0005,"AEGIS_DICOM_2.00",00)	(0005,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	5	0	f	\N	US	1-n	Unknown	\N
32	(0009,"AEGIS_DICOM_2.00",00)	(0009,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	9	0	f	\N	US	1-n	Unknown	\N
33	(0019,"AEGIS_DICOM_2.00",00)	(0019,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	25	0	f	\N	US	1-n	Unknown	\N
34	(0029,"AEGIS_DICOM_2.00",00)	(0029,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	41	0	f	\N	US	1-n	Unknown	\N
35	(1369,"AEGIS_DICOM_2.00",00)	(1369,"AEGIS_DICOM_2.00",00)	AEGIS_DICOM_2.00	4969	0	f	\N	US	1-n	Unknown	\N
36	(0009,"AGFA",10)	(0009,"AGFA",10)	AGFA	9	16	f	\N	LO	1	Unknown	\N
37	(0009,"AGFA",11)	(0009,"AGFA",11)	AGFA	9	17	f	\N	LO	1	Unknown	\N
38	(0009,"AGFA",13)	(0009,"AGFA",13)	AGFA	9	19	f	\N	LO	1	Unknown	\N
39	(0009,"AGFA",14)	(0009,"AGFA",14)	AGFA	9	20	f	\N	LO	1	Unknown	\N
40	(0009,"AGFA",15)	(0009,"AGFA",15)	AGFA	9	21	f	\N	LO	1	Unknown	\N
41	(0029,"CAMTRONICS IP",10)	(0029,"CAMTRONICS IP",10)	CAMTRONICS IP	41	16	f	\N	LT	1	Unknown	\N
42	(0029,"CAMTRONICS IP",20)	(0029,"CAMTRONICS IP",20)	CAMTRONICS IP	41	32	f	\N	UN	1	Unknown	\N
43	(0029,"CAMTRONICS IP",30)	(0029,"CAMTRONICS IP",30)	CAMTRONICS IP	41	48	f	\N	UN	1	Unknown	\N
44	(0029,"CAMTRONICS IP",40)	(0029,"CAMTRONICS IP",40)	CAMTRONICS IP	41	64	f	\N	UN	1	Unknown	\N
45	(0029,"CAMTRONICS",10)	(0029,"CAMTRONICS",10)	CAMTRONICS	41	16	f	\N	LT	1	Commentline	\N
46	(0029,"CAMTRONICS",20)	(0029,"CAMTRONICS",20)	CAMTRONICS	41	32	f	\N	DS	1	EdgeEnhancementCoefficient	\N
47	(0029,"CAMTRONICS",50)	(0029,"CAMTRONICS",50)	CAMTRONICS	41	80	f	\N	LT	1	SceneText	\N
48	(0029,"CAMTRONICS",60)	(0029,"CAMTRONICS",60)	CAMTRONICS	41	96	f	\N	LT	1	ImageText	\N
49	(0029,"CAMTRONICS",70)	(0029,"CAMTRONICS",70)	CAMTRONICS	41	112	f	\N	IS	1	PixelShiftHorizontal	\N
50	(0029,"CAMTRONICS",80)	(0029,"CAMTRONICS",80)	CAMTRONICS	41	128	f	\N	IS	1	PixelShiftVertical	\N
51	(0029,"CAMTRONICS",90)	(0029,"CAMTRONICS",90)	CAMTRONICS	41	144	f	\N	IS	1	Unknown	\N
52	(0009,"CARDIO-D.R. 1.0",00)	(0009,"CARDIO-D.R. 1.0",00)	CARDIO-D.R. 1.0	9	0	f	\N	UL	1	FileLocation	\N
53	(0009,"CARDIO-D.R. 1.0",01)	(0009,"CARDIO-D.R. 1.0",01)	CARDIO-D.R. 1.0	9	1	f	\N	UL	1	FileSize	\N
54	(0009,"CARDIO-D.R. 1.0",40)	(0009,"CARDIO-D.R. 1.0",40)	CARDIO-D.R. 1.0	9	64	f	\N	SQ	1	AlternateImageSequence	\N
55	(0019,"CARDIO-D.R. 1.0",00)	(0019,"CARDIO-D.R. 1.0",00)	CARDIO-D.R. 1.0	25	0	f	\N	CS	1	ImageBlankingShape	\N
56	(0019,"CARDIO-D.R. 1.0",02)	(0019,"CARDIO-D.R. 1.0",02)	CARDIO-D.R. 1.0	25	2	f	\N	IS	1	ImageBlankingLeftVerticalEdge	\N
57	(0019,"CARDIO-D.R. 1.0",04)	(0019,"CARDIO-D.R. 1.0",04)	CARDIO-D.R. 1.0	25	4	f	\N	IS	1	ImageBlankingRightVerticalEdge	\N
58	(0019,"CARDIO-D.R. 1.0",06)	(0019,"CARDIO-D.R. 1.0",06)	CARDIO-D.R. 1.0	25	6	f	\N	IS	1	ImageBlankingUpperHorizontalEdge	\N
59	(0019,"CARDIO-D.R. 1.0",08)	(0019,"CARDIO-D.R. 1.0",08)	CARDIO-D.R. 1.0	25	8	f	\N	IS	1	ImageBlankingLowerHorizontalEdge	\N
60	(0019,"CARDIO-D.R. 1.0",10)	(0019,"CARDIO-D.R. 1.0",10)	CARDIO-D.R. 1.0	25	16	f	\N	IS	1	CenterOfCircularImageBlanking	\N
61	(0019,"CARDIO-D.R. 1.0",12)	(0019,"CARDIO-D.R. 1.0",12)	CARDIO-D.R. 1.0	25	18	f	\N	IS	1	RadiusOfCircularImageBlanking	\N
62	(0019,"CARDIO-D.R. 1.0",30)	(0019,"CARDIO-D.R. 1.0",30)	CARDIO-D.R. 1.0	25	48	f	\N	UL	1	MaximumImageFrameSize	\N
63	(0021,"CARDIO-D.R. 1.0",13)	(0021,"CARDIO-D.R. 1.0",13)	CARDIO-D.R. 1.0	33	19	f	\N	IS	1	ImageSequenceNumber	\N
11033	(0119,"MRSC",1502)	(0119,"MRSC",02)	MRSC	281	2	t	15	TM	1	SERTime	K
64	(0029,"CARDIO-D.R. 1.0",00)	(0029,"CARDIO-D.R. 1.0",00)	CARDIO-D.R. 1.0	41	0	f	\N	SQ	1	EdgeEnhancementSequence	\N
65	(0029,"CARDIO-D.R. 1.0",01)	(0029,"CARDIO-D.R. 1.0",01)	CARDIO-D.R. 1.0	41	1	f	\N	US	2	ConvolutionKernelSize	\N
66	(0029,"CARDIO-D.R. 1.0",02)	(0029,"CARDIO-D.R. 1.0",02)	CARDIO-D.R. 1.0	41	2	f	\N	DS	1-n	ConvolutionKernelCoefficients	\N
67	(0029,"CARDIO-D.R. 1.0",03)	(0029,"CARDIO-D.R. 1.0",03)	CARDIO-D.R. 1.0	41	3	f	\N	DS	1	EdgeEnhancementGain	\N
68	(0025,"CMR42 CIRCLECVI",1010)	(0025,"CMR42 CIRCLECVI",10)	CMR42 CIRCLECVI	37	16	t	0010	LO	1	WorkspaceID	\N
69	(0025,"CMR42 CIRCLECVI",1020)	(0025,"CMR42 CIRCLECVI",20)	CMR42 CIRCLECVI	37	32	t	0010	LO	1	WorkspaceTimeString	\N
70	(0025,"CMR42 CIRCLECVI",1030)	(0025,"CMR42 CIRCLECVI",30)	CMR42 CIRCLECVI	37	48	t	0010	OB	1	WorkspaceStream	\N
71	(0009,"DCMTK_ANONYMIZER",00)	(0009,"DCMTK_ANONYMIZER",00)	DCMTK_ANONYMIZER	9	0	f	\N	SQ	1	AnonymizerUIDMap	\N
72	(0009,"DCMTK_ANONYMIZER",10)	(0009,"DCMTK_ANONYMIZER",10)	DCMTK_ANONYMIZER	9	16	f	\N	UI	1	AnonymizerUIDKey	\N
73	(0009,"DCMTK_ANONYMIZER",20)	(0009,"DCMTK_ANONYMIZER",20)	DCMTK_ANONYMIZER	9	32	f	\N	UI	1	AnonymizerUIDValue	\N
74	(0009,"DCMTK_ANONYMIZER",30)	(0009,"DCMTK_ANONYMIZER",30)	DCMTK_ANONYMIZER	9	48	f	\N	SQ	1	AnonymizerPatientIDMap	\N
75	(0009,"DCMTK_ANONYMIZER",40)	(0009,"DCMTK_ANONYMIZER",40)	DCMTK_ANONYMIZER	9	64	f	\N	LO	1	AnonymizerPatientIDKey	\N
76	(0009,"DCMTK_ANONYMIZER",50)	(0009,"DCMTK_ANONYMIZER",50)	DCMTK_ANONYMIZER	9	80	f	\N	LO	1	AnonymizerPatientIDValue	\N
77	(0019,"DIDI TO PCR 1.1",22)	(0019,"DIDI TO PCR 1.1",22)	DIDI TO PCR 1.1	25	34	f	\N	UN	1	RouteAET	\N
78	(0019,"DIDI TO PCR 1.1",23)	(0019,"DIDI TO PCR 1.1",23)	DIDI TO PCR 1.1	25	35	f	\N	DS	1	PCRPrintScale	\N
79	(0019,"DIDI TO PCR 1.1",24)	(0019,"DIDI TO PCR 1.1",24)	DIDI TO PCR 1.1	25	36	f	\N	UN	1	PCRPrintJobEnd	\N
80	(0019,"DIDI TO PCR 1.1",25)	(0019,"DIDI TO PCR 1.1",25)	DIDI TO PCR 1.1	25	37	f	\N	IS	1	PCRNoFilmCopies	\N
81	(0019,"DIDI TO PCR 1.1",26)	(0019,"DIDI TO PCR 1.1",26)	DIDI TO PCR 1.1	25	38	f	\N	IS	1	PCRFilmLayoutPosition	\N
82	(0019,"DIDI TO PCR 1.1",27)	(0019,"DIDI TO PCR 1.1",27)	DIDI TO PCR 1.1	25	39	f	\N	UN	1	PCRPrintReportName	\N
83	(0019,"DIDI TO PCR 1.1",70)	(0019,"DIDI TO PCR 1.1",70)	DIDI TO PCR 1.1	25	112	f	\N	UN	1	RADProtocolPrinter	\N
84	(0019,"DIDI TO PCR 1.1",71)	(0019,"DIDI TO PCR 1.1",71)	DIDI TO PCR 1.1	25	113	f	\N	UN	1	RADProtocolMedium	\N
85	(0019,"DIDI TO PCR 1.1",90)	(0019,"DIDI TO PCR 1.1",90)	DIDI TO PCR 1.1	25	144	f	\N	LO	1	UnprocessedFlag	\N
86	(0019,"DIDI TO PCR 1.1",91)	(0019,"DIDI TO PCR 1.1",91)	DIDI TO PCR 1.1	25	145	f	\N	UN	1	KeyValues	\N
87	(0019,"DIDI TO PCR 1.1",92)	(0019,"DIDI TO PCR 1.1",92)	DIDI TO PCR 1.1	25	146	f	\N	UN	1	DestinationPostprocessingFunction	\N
88	(0019,"DIDI TO PCR 1.1",A0)	(0019,"DIDI TO PCR 1.1",A0)	DIDI TO PCR 1.1	25	160	f	\N	UN	1	Version	\N
89	(0019,"DIDI TO PCR 1.1",A1)	(0019,"DIDI TO PCR 1.1",A1)	DIDI TO PCR 1.1	25	161	f	\N	UN	1	RangingMode	\N
90	(0019,"DIDI TO PCR 1.1",A2)	(0019,"DIDI TO PCR 1.1",A2)	DIDI TO PCR 1.1	25	162	f	\N	UN	1	AbdomenBrightness	\N
91	(0019,"DIDI TO PCR 1.1",A3)	(0019,"DIDI TO PCR 1.1",A3)	DIDI TO PCR 1.1	25	163	f	\N	UN	1	FixedBrightness	\N
92	(0019,"DIDI TO PCR 1.1",A4)	(0019,"DIDI TO PCR 1.1",A4)	DIDI TO PCR 1.1	25	164	f	\N	UN	1	DetailContrast	\N
93	(0019,"DIDI TO PCR 1.1",A5)	(0019,"DIDI TO PCR 1.1",A5)	DIDI TO PCR 1.1	25	165	f	\N	UN	1	ContrastBalance	\N
94	(0019,"DIDI TO PCR 1.1",A6)	(0019,"DIDI TO PCR 1.1",A6)	DIDI TO PCR 1.1	25	166	f	\N	UN	1	StructureBoost	\N
95	(0019,"DIDI TO PCR 1.1",A7)	(0019,"DIDI TO PCR 1.1",A7)	DIDI TO PCR 1.1	25	167	f	\N	UN	1	StructurePreference	\N
96	(0019,"DIDI TO PCR 1.1",A8)	(0019,"DIDI TO PCR 1.1",A8)	DIDI TO PCR 1.1	25	168	f	\N	UN	1	NoiseRobustness	\N
97	(0019,"DIDI TO PCR 1.1",A9)	(0019,"DIDI TO PCR 1.1",A9)	DIDI TO PCR 1.1	25	169	f	\N	UN	1	NoiseDoseLimit	\N
98	(0019,"DIDI TO PCR 1.1",AA)	(0019,"DIDI TO PCR 1.1",AA)	DIDI TO PCR 1.1	25	170	f	\N	UN	1	NoiseDoseStep	\N
99	(0019,"DIDI TO PCR 1.1",AB)	(0019,"DIDI TO PCR 1.1",AB)	DIDI TO PCR 1.1	25	171	f	\N	UN	1	NoiseFrequencyLimit	\N
100	(0019,"DIDI TO PCR 1.1",AC)	(0019,"DIDI TO PCR 1.1",AC)	DIDI TO PCR 1.1	25	172	f	\N	UN	1	WeakContrastLimit	\N
101	(0019,"DIDI TO PCR 1.1",AD)	(0019,"DIDI TO PCR 1.1",AD)	DIDI TO PCR 1.1	25	173	f	\N	UN	1	StrongContrastLimit	\N
102	(0019,"DIDI TO PCR 1.1",AE)	(0019,"DIDI TO PCR 1.1",AE)	DIDI TO PCR 1.1	25	174	f	\N	UN	1	StructureBoostOffset	\N
103	(0019,"DIDI TO PCR 1.1",AF)	(0019,"DIDI TO PCR 1.1",AF)	DIDI TO PCR 1.1	25	175	f	\N	UN	1	SmoothGain	\N
104	(0019,"DIDI TO PCR 1.1",B0)	(0019,"DIDI TO PCR 1.1",B0)	DIDI TO PCR 1.1	25	176	f	\N	UN	1	MeasureField1	\N
105	(0019,"DIDI TO PCR 1.1",B1)	(0019,"DIDI TO PCR 1.1",B1)	DIDI TO PCR 1.1	25	177	f	\N	UN	1	MeasureField2	\N
106	(0019,"DIDI TO PCR 1.1",B2)	(0019,"DIDI TO PCR 1.1",B2)	DIDI TO PCR 1.1	25	178	f	\N	UN	1	KeyPercentile1	\N
107	(0019,"DIDI TO PCR 1.1",B3)	(0019,"DIDI TO PCR 1.1",B3)	DIDI TO PCR 1.1	25	179	f	\N	UN	1	KeyPercentile2	\N
108	(0019,"DIDI TO PCR 1.1",B4)	(0019,"DIDI TO PCR 1.1",B4)	DIDI TO PCR 1.1	25	180	f	\N	UN	1	DensityLUT	\N
109	(0019,"DIDI TO PCR 1.1",B5)	(0019,"DIDI TO PCR 1.1",B5)	DIDI TO PCR 1.1	25	181	f	\N	UN	1	Brightness	\N
110	(0019,"DIDI TO PCR 1.1",B6)	(0019,"DIDI TO PCR 1.1",B6)	DIDI TO PCR 1.1	25	182	f	\N	UN	1	Gamma	\N
111	(0089,"DIDI TO PCR 1.1",10)	(0089,"DIDI TO PCR 1.1",10)	DIDI TO PCR 1.1	137	16	f	\N	SQ	1	Unknown	\N
112	(0029,"DIGISCAN IMAGE",31)	(0029,"DIGISCAN IMAGE",31)	DIGISCAN IMAGE	41	49	f	\N	US	1-n	Unknown	\N
113	(0029,"DIGISCAN IMAGE",32)	(0029,"DIGISCAN IMAGE",32)	DIGISCAN IMAGE	41	50	f	\N	US	1-n	Unknown	\N
114	(0029,"DIGISCAN IMAGE",33)	(0029,"DIGISCAN IMAGE",33)	DIGISCAN IMAGE	41	51	f	\N	LT	1	Unknown	\N
115	(0029,"DIGISCAN IMAGE",34)	(0029,"DIGISCAN IMAGE",34)	DIGISCAN IMAGE	41	52	f	\N	LT	1	Unknown	\N
116	(0015,"DLX_EXAMS_01",01)	(0015,"DLX_EXAMS_01",01)	DLX_EXAMS_01	21	1	f	\N	DS	1	StenosisCalibrationRatio	\N
117	(0015,"DLX_EXAMS_01",02)	(0015,"DLX_EXAMS_01",02)	DLX_EXAMS_01	21	2	f	\N	DS	1	StenosisMagnification	\N
118	(0015,"DLX_EXAMS_01",03)	(0015,"DLX_EXAMS_01",03)	DLX_EXAMS_01	21	3	f	\N	DS	1	CardiacCalibrationRatio	\N
119	(0011,"DLX_PATNT_01",01)	(0011,"DLX_PATNT_01",01)	DLX_PATNT_01	17	1	f	\N	LT	1	PatientDOB	\N
120	(0019,"DLX_SERIE_01",01)	(0019,"DLX_SERIE_01",01)	DLX_SERIE_01	25	1	f	\N	DS	1	AngleValueLArm	\N
121	(0019,"DLX_SERIE_01",02)	(0019,"DLX_SERIE_01",02)	DLX_SERIE_01	25	2	f	\N	DS	1	AngleValuePArm	\N
122	(0019,"DLX_SERIE_01",03)	(0019,"DLX_SERIE_01",03)	DLX_SERIE_01	25	3	f	\N	DS	1	AngleValueCArm	\N
123	(0019,"DLX_SERIE_01",04)	(0019,"DLX_SERIE_01",04)	DLX_SERIE_01	25	4	f	\N	CS	1	AngleLabelLArm	\N
124	(0019,"DLX_SERIE_01",05)	(0019,"DLX_SERIE_01",05)	DLX_SERIE_01	25	5	f	\N	CS	1	AngleLabelPArm	\N
125	(0019,"DLX_SERIE_01",06)	(0019,"DLX_SERIE_01",06)	DLX_SERIE_01	25	6	f	\N	CS	1	AngleLabelCArm	\N
126	(0019,"DLX_SERIE_01",07)	(0019,"DLX_SERIE_01",07)	DLX_SERIE_01	25	7	f	\N	ST	1	ProcedureName	\N
127	(0019,"DLX_SERIE_01",08)	(0019,"DLX_SERIE_01",08)	DLX_SERIE_01	25	8	f	\N	ST	1	ExamName	\N
128	(0019,"DLX_SERIE_01",09)	(0019,"DLX_SERIE_01",09)	DLX_SERIE_01	25	9	f	\N	SH	1	PatientSize	\N
129	(0019,"DLX_SERIE_01",0a)	(0019,"DLX_SERIE_01",0a)	DLX_SERIE_01	25	10	f	\N	IS	1	RecordView	\N
130	(0019,"DLX_SERIE_01",10)	(0019,"DLX_SERIE_01",10)	DLX_SERIE_01	25	16	f	\N	DS	1	InjectorDelay	\N
131	(0019,"DLX_SERIE_01",11)	(0019,"DLX_SERIE_01",11)	DLX_SERIE_01	25	17	f	\N	CS	1	AutoInject	\N
132	(0019,"DLX_SERIE_01",14)	(0019,"DLX_SERIE_01",14)	DLX_SERIE_01	25	20	f	\N	IS	1	AcquisitionMode	\N
133	(0019,"DLX_SERIE_01",15)	(0019,"DLX_SERIE_01",15)	DLX_SERIE_01	25	21	f	\N	CS	1	CameraRotationEnabled	\N
134	(0019,"DLX_SERIE_01",16)	(0019,"DLX_SERIE_01",16)	DLX_SERIE_01	25	22	f	\N	CS	1	ReverseSweep	\N
135	(0019,"DLX_SERIE_01",17)	(0019,"DLX_SERIE_01",17)	DLX_SERIE_01	25	23	f	\N	IS	1	SpatialFilterStrength	\N
136	(0019,"DLX_SERIE_01",18)	(0019,"DLX_SERIE_01",18)	DLX_SERIE_01	25	24	f	\N	IS	1	ZoomFactor	\N
137	(0019,"DLX_SERIE_01",19)	(0019,"DLX_SERIE_01",19)	DLX_SERIE_01	25	25	f	\N	IS	1	XZoomCenter	\N
138	(0019,"DLX_SERIE_01",1a)	(0019,"DLX_SERIE_01",1a)	DLX_SERIE_01	25	26	f	\N	IS	1	YZoomCenter	\N
139	(0019,"DLX_SERIE_01",1b)	(0019,"DLX_SERIE_01",1b)	DLX_SERIE_01	25	27	f	\N	DS	1	Focus	\N
140	(0019,"DLX_SERIE_01",1c)	(0019,"DLX_SERIE_01",1c)	DLX_SERIE_01	25	28	f	\N	CS	1	Dose	\N
141	(0019,"DLX_SERIE_01",1d)	(0019,"DLX_SERIE_01",1d)	DLX_SERIE_01	25	29	f	\N	IS	1	SideMark	\N
142	(0019,"DLX_SERIE_01",1e)	(0019,"DLX_SERIE_01",1e)	DLX_SERIE_01	25	30	f	\N	IS	1	PercentageLandscape	\N
143	(0019,"DLX_SERIE_01",1f)	(0019,"DLX_SERIE_01",1f)	DLX_SERIE_01	25	31	f	\N	DS	1	ExposureDuration	\N
144	(00E1,"ELSCINT1",01)	(00E1,"ELSCINT1",01)	ELSCINT1	225	1	f	\N	US	1	DataDictionaryVersion	\N
145	(00E1,"ELSCINT1",14)	(00E1,"ELSCINT1",14)	ELSCINT1	225	20	f	\N	LT	1	Unknown	\N
146	(00E1,"ELSCINT1",22)	(00E1,"ELSCINT1",22)	ELSCINT1	225	34	f	\N	DS	2	Unknown	\N
147	(00E1,"ELSCINT1",23)	(00E1,"ELSCINT1",23)	ELSCINT1	225	35	f	\N	DS	2	Unknown	\N
148	(00E1,"ELSCINT1",24)	(00E1,"ELSCINT1",24)	ELSCINT1	225	36	f	\N	LT	1	Unknown	\N
149	(00E1,"ELSCINT1",25)	(00E1,"ELSCINT1",25)	ELSCINT1	225	37	f	\N	LT	1	Unknown	\N
150	(00E1,"ELSCINT1",40)	(00E1,"ELSCINT1",40)	ELSCINT1	225	64	f	\N	SH	1	OffsetFromCTMRImages	\N
151	(0601,"ELSCINT1",00)	(0601,"ELSCINT1",00)	ELSCINT1	1537	0	f	\N	SH	1	ImplementationVersion	\N
152	(0601,"ELSCINT1",20)	(0601,"ELSCINT1",20)	ELSCINT1	1537	32	f	\N	DS	1	RelativeTablePosition	\N
153	(0601,"ELSCINT1",21)	(0601,"ELSCINT1",21)	ELSCINT1	1537	33	f	\N	DS	1	RelativeTableHeight	\N
154	(0601,"ELSCINT1",30)	(0601,"ELSCINT1",30)	ELSCINT1	1537	48	f	\N	SH	1	SurviewDirection	\N
155	(0601,"ELSCINT1",31)	(0601,"ELSCINT1",31)	ELSCINT1	1537	49	f	\N	DS	1	SurviewLength	\N
156	(0601,"ELSCINT1",50)	(0601,"ELSCINT1",50)	ELSCINT1	1537	80	f	\N	SH	1	ImageViewType	\N
157	(0601,"ELSCINT1",70)	(0601,"ELSCINT1",70)	ELSCINT1	1537	112	f	\N	DS	1	BatchNumber	\N
158	(0601,"ELSCINT1",71)	(0601,"ELSCINT1",71)	ELSCINT1	1537	113	f	\N	DS	1	BatchSize	\N
159	(0601,"ELSCINT1",72)	(0601,"ELSCINT1",72)	ELSCINT1	1537	114	f	\N	DS	1	BatchSliceNumber	\N
165	(0009,"FDMS 1.0",0C)	(0009,"FDMS 1.0",0C)	FDMS 1.0	9	12	f	\N	OW	1	FilmUID	\N
170	(0009,"FDMS 1.0",F0)	(0009,"FDMS 1.0",F0)	FDMS 1.0	9	240	f	\N	CS	1	BlackeningProcessFlag	\N
180	(0019,"FDMS 1.0",90)	(0019,"FDMS 1.0",90)	FDMS 1.0	25	144	f	\N	SH	1	FilmAnnotationCharacterString1	\N
181	(0019,"FDMS 1.0",91)	(0019,"FDMS 1.0",91)	FDMS 1.0	25	145	f	\N	SH	1	FilmAnnotationCharacterString2	\N
161	(0009,"FDMS 1.0",05)	(0009,"FDMS 1.0",05)	FDMS 1.0	9	5	f	\N	OW	1	ImageUID	X
163	(0009,"FDMS 1.0",08)	(0009,"FDMS 1.0",08)	FDMS 1.0	9	8	f	\N	UL	1	ImageDisplayInformationVersionNo	KB
164	(0009,"FDMS 1.0",09)	(0009,"FDMS 1.0",09)	FDMS 1.0	9	9	f	\N	UL	1	PatientInformationVersionNo	X
166	(0009,"FDMS 1.0",10)	(0009,"FDMS 1.0",10)	FDMS 1.0	9	16	f	\N	CS	1	ExposureUnitTypeCode	K
167	(0009,"FDMS 1.0",80)	(0009,"FDMS 1.0",80)	FDMS 1.0	9	128	f	\N	LO	1	KanjiHospitalName	X
168	(0009,"FDMS 1.0",90)	(0009,"FDMS 1.0",90)	FDMS 1.0	9	144	f	\N	ST	1	DistributionCode	X
169	(0009,"FDMS 1.0",92)	(0009,"FDMS 1.0",92)	FDMS 1.0	9	146	f	\N	SH	1	KanjiDepartmentName	X
171	(0019,"FDMS 1.0",15)	(0019,"FDMS 1.0",15)	FDMS 1.0	25	21	f	\N	LO	1	KanjiBodyPartForExposure	X
172	(0019,"FDMS 1.0",32)	(0019,"FDMS 1.0",32)	FDMS 1.0	25	50	f	\N	LO	1	KanjiMenuName	X
173	(0019,"FDMS 1.0",40)	(0019,"FDMS 1.0",40)	FDMS 1.0	25	64	f	\N	CS	1	ImageProcessingType	KB
174	(0019,"FDMS 1.0",50)	(0019,"FDMS 1.0",50)	FDMS 1.0	25	80	f	\N	CS	1	EDRMode	K
175	(0019,"FDMS 1.0",60)	(0019,"FDMS 1.0",60)	FDMS 1.0	25	96	f	\N	SH	1	RadiographersCode	X
176	(0019,"FDMS 1.0",70)	(0019,"FDMS 1.0",70)	FDMS 1.0	25	112	f	\N	IS	1	SplitExposureFormat	K
177	(0019,"FDMS 1.0",71)	(0019,"FDMS 1.0",71)	FDMS 1.0	25	113	f	\N	IS	1	NoOfSplitExposureFrames	K
178	(0019,"FDMS 1.0",80)	(0019,"FDMS 1.0",80)	FDMS 1.0	25	128	f	\N	IS	1	ReadingPositionSpecification	K
179	(0019,"FDMS 1.0",81)	(0019,"FDMS 1.0",81)	FDMS 1.0	25	129	f	\N	IS	1	ReadingSensitivityCenter	K
182	(0021,"FDMS 1.0",10)	(0021,"FDMS 1.0",10)	FDMS 1.0	33	16	f	\N	CS	1	FCRImageID	X
183	(0021,"FDMS 1.0",30)	(0021,"FDMS 1.0",30)	FDMS 1.0	33	48	f	\N	CS	1	SetNo	X
10743	(0043,"GEMS_PARM_01",a8)	(0043,"GEMS_PARM_01",a8)	GEMS_PARM_01	67	168	f	\N	DS	3	Dual Drive Mode, Amplitude Attentuation and Phase Offset	K
187	(0023,"FDMS 1.0",10)	(0023,"FDMS 1.0",10)	FDMS 1.0	35	16	f	\N	SQ	1	Unknown	\N
188	(0023,"FDMS 1.0",20)	(0023,"FDMS 1.0",20)	FDMS 1.0	35	32	f	\N	SQ	1	Unknown	\N
189	(0023,"FDMS 1.0",30)	(0023,"FDMS 1.0",30)	FDMS 1.0	35	48	f	\N	SQ	1	Unknown	\N
193	(0025,"FDMS 1.0",13)	(0025,"FDMS 1.0",13)	FDMS 1.0	37	19	f	\N	US	1	Unknown	\N
194	(0025,"FDMS 1.0",15)	(0025,"FDMS 1.0",15)	FDMS 1.0	37	21	f	\N	CS	1	Unknown	\N
195	(0025,"FDMS 1.0",20)	(0025,"FDMS 1.0",20)	FDMS 1.0	37	32	f	\N	US	2	Unknown	\N
196	(0025,"FDMS 1.0",21)	(0025,"FDMS 1.0",21)	FDMS 1.0	37	33	f	\N	US	1	Unknown	\N
197	(0025,"FDMS 1.0",30)	(0025,"FDMS 1.0",30)	FDMS 1.0	37	48	f	\N	US	1	Unknown	\N
198	(0025,"FDMS 1.0",31)	(0025,"FDMS 1.0",31)	FDMS 1.0	37	49	f	\N	SS	1	Unknown	\N
199	(0025,"FDMS 1.0",32)	(0025,"FDMS 1.0",32)	FDMS 1.0	37	50	f	\N	US	1	Unknown	\N
200	(0025,"FDMS 1.0",33)	(0025,"FDMS 1.0",33)	FDMS 1.0	37	51	f	\N	SS	1	Unknown	\N
201	(0025,"FDMS 1.0",34)	(0025,"FDMS 1.0",34)	FDMS 1.0	37	52	f	\N	SS	1	Unknown	\N
202	(0025,"FDMS 1.0",40)	(0025,"FDMS 1.0",40)	FDMS 1.0	37	64	f	\N	US	1	Unknown	\N
203	(0025,"FDMS 1.0",41)	(0025,"FDMS 1.0",41)	FDMS 1.0	37	65	f	\N	US	1	Unknown	\N
204	(0025,"FDMS 1.0",42)	(0025,"FDMS 1.0",42)	FDMS 1.0	37	66	f	\N	US	1	Unknown	\N
205	(0025,"FDMS 1.0",43)	(0025,"FDMS 1.0",43)	FDMS 1.0	37	67	f	\N	US	1	Unknown	\N
206	(0025,"FDMS 1.0",50)	(0025,"FDMS 1.0",50)	FDMS 1.0	37	80	f	\N	US	1	Unknown	\N
207	(0025,"FDMS 1.0",51)	(0025,"FDMS 1.0",51)	FDMS 1.0	37	81	f	\N	US	1	Unknown	\N
208	(0025,"FDMS 1.0",52)	(0025,"FDMS 1.0",52)	FDMS 1.0	37	82	f	\N	US	1	Unknown	\N
209	(0025,"FDMS 1.0",53)	(0025,"FDMS 1.0",53)	FDMS 1.0	37	83	f	\N	US	1	Unknown	\N
210	(0025,"FDMS 1.0",60)	(0025,"FDMS 1.0",60)	FDMS 1.0	37	96	f	\N	US	1	Unknown	\N
211	(0025,"FDMS 1.0",61)	(0025,"FDMS 1.0",61)	FDMS 1.0	37	97	f	\N	US	1	Unknown	\N
212	(0025,"FDMS 1.0",62)	(0025,"FDMS 1.0",62)	FDMS 1.0	37	98	f	\N	US	1	Unknown	\N
213	(0025,"FDMS 1.0",63)	(0025,"FDMS 1.0",63)	FDMS 1.0	37	99	f	\N	CS	1	Unknown	\N
214	(0025,"FDMS 1.0",70)	(0025,"FDMS 1.0",70)	FDMS 1.0	37	112	f	\N	US	1	Unknown	\N
215	(0025,"FDMS 1.0",71)	(0025,"FDMS 1.0",71)	FDMS 1.0	37	113	f	\N	US	1	Unknown	\N
216	(0025,"FDMS 1.0",72)	(0025,"FDMS 1.0",72)	FDMS 1.0	37	114	f	\N	US	1	Unknown	\N
217	(0025,"FDMS 1.0",73)	(0025,"FDMS 1.0",73)	FDMS 1.0	37	115	f	\N	US	1-n	Unknown	\N
218	(0025,"FDMS 1.0",74)	(0025,"FDMS 1.0",74)	FDMS 1.0	37	116	f	\N	US	1-n	Unknown	\N
219	(0025,"FDMS 1.0",80)	(0025,"FDMS 1.0",80)	FDMS 1.0	37	128	f	\N	US	1	Unknown	\N
220	(0025,"FDMS 1.0",81)	(0025,"FDMS 1.0",81)	FDMS 1.0	37	129	f	\N	US	1	Unknown	\N
221	(0025,"FDMS 1.0",82)	(0025,"FDMS 1.0",82)	FDMS 1.0	37	130	f	\N	US	1	Unknown	\N
222	(0025,"FDMS 1.0",83)	(0025,"FDMS 1.0",83)	FDMS 1.0	37	131	f	\N	US	1-n	Unknown	\N
223	(0025,"FDMS 1.0",84)	(0025,"FDMS 1.0",84)	FDMS 1.0	37	132	f	\N	US	1-n	Unknown	\N
224	(0025,"FDMS 1.0",90)	(0025,"FDMS 1.0",90)	FDMS 1.0	37	144	f	\N	US	1	Unknown	\N
225	(0025,"FDMS 1.0",91)	(0025,"FDMS 1.0",91)	FDMS 1.0	37	145	f	\N	US	1	Unknown	\N
226	(0025,"FDMS 1.0",92)	(0025,"FDMS 1.0",92)	FDMS 1.0	37	146	f	\N	US	1	Unknown	\N
227	(0025,"FDMS 1.0",93)	(0025,"FDMS 1.0",93)	FDMS 1.0	37	147	f	\N	US	1	Unknown	\N
228	(0025,"FDMS 1.0",94)	(0025,"FDMS 1.0",94)	FDMS 1.0	37	148	f	\N	US	1	Unknown	\N
229	(0025,"FDMS 1.0",95)	(0025,"FDMS 1.0",95)	FDMS 1.0	37	149	f	\N	US	1	Unknown	\N
230	(0025,"FDMS 1.0",96)	(0025,"FDMS 1.0",96)	FDMS 1.0	37	150	f	\N	CS	1	Unknown	\N
231	(0025,"FDMS 1.0",a0)	(0025,"FDMS 1.0",a0)	FDMS 1.0	37	160	f	\N	US	1	Unknown	\N
232	(0025,"FDMS 1.0",a1)	(0025,"FDMS 1.0",a1)	FDMS 1.0	37	161	f	\N	SS	1	Unknown	\N
233	(0025,"FDMS 1.0",a2)	(0025,"FDMS 1.0",a2)	FDMS 1.0	37	162	f	\N	US	1	Unknown	\N
234	(0025,"FDMS 1.0",a3)	(0025,"FDMS 1.0",a3)	FDMS 1.0	37	163	f	\N	SS	1	Unknown	\N
235	(0027,"FDMS 1.0",10)	(0027,"FDMS 1.0",10)	FDMS 1.0	39	16	f	\N	SQ	1	Unknown	\N
236	(0027,"FDMS 1.0",20)	(0027,"FDMS 1.0",20)	FDMS 1.0	39	32	f	\N	SQ	1	Unknown	\N
237	(0027,"FDMS 1.0",30)	(0027,"FDMS 1.0",30)	FDMS 1.0	39	48	f	\N	SQ	1	Unknown	\N
238	(0027,"FDMS 1.0",40)	(0027,"FDMS 1.0",40)	FDMS 1.0	39	64	f	\N	SQ	1	Unknown	\N
239	(0027,"FDMS 1.0",50)	(0027,"FDMS 1.0",50)	FDMS 1.0	39	80	f	\N	SQ	1	Unknown	\N
240	(0027,"FDMS 1.0",60)	(0027,"FDMS 1.0",60)	FDMS 1.0	39	96	f	\N	SQ	1	Unknown	\N
241	(0027,"FDMS 1.0",70)	(0027,"FDMS 1.0",70)	FDMS 1.0	39	112	f	\N	SQ	1	Unknown	\N
242	(0027,"FDMS 1.0",80)	(0027,"FDMS 1.0",80)	FDMS 1.0	39	128	f	\N	SQ	1	Unknown	\N
243	(0027,"FDMS 1.0",a0)	(0027,"FDMS 1.0",a0)	FDMS 1.0	39	160	f	\N	IS	1	Unknown	\N
244	(0027,"FDMS 1.0",a1)	(0027,"FDMS 1.0",a1)	FDMS 1.0	39	161	f	\N	CS	2	Unknown	\N
245	(0027,"FDMS 1.0",a2)	(0027,"FDMS 1.0",a2)	FDMS 1.0	39	162	f	\N	CS	2	Unknown	\N
246	(0027,"FDMS 1.0",a3)	(0027,"FDMS 1.0",a3)	FDMS 1.0	39	163	f	\N	SS	1-n	Unknown	\N
247	(0029,"FDMS 1.0",20)	(0029,"FDMS 1.0",20)	FDMS 1.0	41	32	f	\N	CS	1	ImageScanningDirection	\N
248	(0029,"FDMS 1.0",30)	(0029,"FDMS 1.0",30)	FDMS 1.0	41	48	f	\N	CS	1	ExtendedReadingSizeValue	\N
249	(0029,"FDMS 1.0",34)	(0029,"FDMS 1.0",34)	FDMS 1.0	41	52	f	\N	US	1	MagnificationReductionRatio	\N
250	(0029,"FDMS 1.0",44)	(0029,"FDMS 1.0",44)	FDMS 1.0	41	68	f	\N	CS	1	LineDensityCode	\N
185	(0021,"FDMS 1.0",50)	(0021,"FDMS 1.0",50)	FDMS 1.0	33	80	f	\N	CS	1	PairProcessingInformation	K
186	(0021,"FDMS 1.0",80)	(0021,"FDMS 1.0",80)	FDMS 1.0	33	128	f	\N	OB	1	EquipmentTypeSpecificInformation	X
190	(0025,"FDMS 1.0",10)	(0025,"FDMS 1.0",10)	FDMS 1.0	37	16	f	\N	US	1	RelativeLightEmissionAmountSk	K
191	(0025,"FDMS 1.0",11)	(0025,"FDMS 1.0",11)	FDMS 1.0	37	17	f	\N	US	1	TermOfCorrectionForEachIPTypeSt	K
192	(0025,"FDMS 1.0",12)	(0025,"FDMS 1.0",12)	FDMS 1.0	37	18	f	\N	US	1	ReadingGainGp	K
251	(0029,"FDMS 1.0",50)	(0029,"FDMS 1.0",50)	FDMS 1.0	41	80	f	\N	CS	1	DataCompressionCode	K
252	(2011,"FDMS 1.0",11)	(2011,"FDMS 1.0",11)	FDMS 1.0	8209	17	f	\N	CS	1	ImagePosition SpecifyingFlag	\N
253	(50F1,"FDMS 1.0",06)	(50F1,"FDMS 1.0",06)	FDMS 1.0	20721	6	f	\N	CS	1	EnergySubtractionParam	\N
254	(50F1,"FDMS 1.0",07)	(50F1,"FDMS 1.0",07)	FDMS 1.0	20721	7	f	\N	CS	1	SubtractionRegistrationResult	\N
255	(50F1,"FDMS 1.0",08)	(50F1,"FDMS 1.0",08)	FDMS 1.0	20721	8	f	\N	CS	1	EnergySubtractionParam2	\N
256	(50F1,"FDMS 1.0",09)	(50F1,"FDMS 1.0",09)	FDMS 1.0	20721	9	f	\N	SL	1	AfinConversionCoefficient	\N
257	(50F1,"FDMS 1.0",10)	(50F1,"FDMS 1.0",10)	FDMS 1.0	20721	16	f	\N	CS	1	FilmOutputFormat	\N
258	(50F1,"FDMS 1.0",20)	(50F1,"FDMS 1.0",20)	FDMS 1.0	20721	32	f	\N	CS	1	ImageProcessingModificationFlag	\N
259	(0009,"FFP DATA",01)	(0009,"FFP DATA",01)	FFP DATA	9	1	f	\N	UN	1	CRHeaderInformation	\N
260	(0019,"GE ??? From Adantage Review CS",30)	(0019,"GE ??? From Adantage Review CS",30)	GE ??? From Adantage Review CS	25	48	f	\N	LO	1	CREDRMode	\N
261	(0019,"GE ??? From Adantage Review CS",40)	(0019,"GE ??? From Adantage Review CS",40)	GE ??? From Adantage Review CS	25	64	f	\N	LO	1	CRLatitude	\N
262	(0019,"GE ??? From Adantage Review CS",50)	(0019,"GE ??? From Adantage Review CS",50)	GE ??? From Adantage Review CS	25	80	f	\N	LO	1	CRGroupNumber	\N
263	(0019,"GE ??? From Adantage Review CS",70)	(0019,"GE ??? From Adantage Review CS",70)	GE ??? From Adantage Review CS	25	112	f	\N	LO	1	CRImageSerialNumber	\N
264	(0019,"GE ??? From Adantage Review CS",80)	(0019,"GE ??? From Adantage Review CS",80)	GE ??? From Adantage Review CS	25	128	f	\N	LO	1	CRBarCodeNumber	\N
265	(0019,"GE ??? From Adantage Review CS",90)	(0019,"GE ??? From Adantage Review CS",90)	GE ??? From Adantage Review CS	25	144	f	\N	LO	1	CRFilmOutputExposures	\N
266	(0009,"GEMS_ACQU_01",24)	(0009,"GEMS_ACQU_01",24)	GEMS_ACQU_01	9	36	f	\N	DS	1	Unknown	\N
267	(0009,"GEMS_ACQU_01",25)	(0009,"GEMS_ACQU_01",25)	GEMS_ACQU_01	9	37	f	\N	US	1	Unknown	\N
268	(0009,"GEMS_ACQU_01",3e)	(0009,"GEMS_ACQU_01",3e)	GEMS_ACQU_01	9	62	f	\N	US	1	Unknown	\N
269	(0009,"GEMS_ACQU_01",3f)	(0009,"GEMS_ACQU_01",3f)	GEMS_ACQU_01	9	63	f	\N	US	1	Unknown	\N
270	(0009,"GEMS_ACQU_01",42)	(0009,"GEMS_ACQU_01",42)	GEMS_ACQU_01	9	66	f	\N	US	1	Unknown	\N
271	(0009,"GEMS_ACQU_01",43)	(0009,"GEMS_ACQU_01",43)	GEMS_ACQU_01	9	67	f	\N	US	1	Unknown	\N
272	(0009,"GEMS_ACQU_01",f8)	(0009,"GEMS_ACQU_01",f8)	GEMS_ACQU_01	9	248	f	\N	US	1	Unknown	\N
273	(0009,"GEMS_ACQU_01",fb)	(0009,"GEMS_ACQU_01",fb)	GEMS_ACQU_01	9	251	f	\N	IS	1	Unknown	\N
274	(0019,"GEMS_ACQU_01",01)	(0019,"GEMS_ACQU_01",01)	GEMS_ACQU_01	25	1	f	\N	LT	1	Unknown	\N
10962	(0119,"MRSC",1126)	(0119,"MRSC",26)	MRSC	281	38	t	11	ST	1	PixelMaskSource	K
278	(0019,"GEMS_ACQU_01",05)	(0019,"GEMS_ACQU_01",05)	GEMS_ACQU_01	25	5	f	\N	LT	1	Unknown	\N
279	(0019,"GEMS_ACQU_01",06)	(0019,"GEMS_ACQU_01",06)	GEMS_ACQU_01	25	6	f	\N	UN	1	Unknown	\N
280	(0019,"GEMS_ACQU_01",0e)	(0019,"GEMS_ACQU_01",0e)	GEMS_ACQU_01	25	14	f	\N	US	1	Unknown	\N
294	(0019,"GEMS_ACQU_01",20)	(0019,"GEMS_ACQU_01",20)	GEMS_ACQU_01	25	32	f	\N	DS	1	Unknown	\N
295	(0019,"GEMS_ACQU_01",22)	(0019,"GEMS_ACQU_01",22)	GEMS_ACQU_01	25	34	f	\N	DS	1	Unknown	\N
304	(0019,"GEMS_ACQU_01",2d)	(0019,"GEMS_ACQU_01",2d)	GEMS_ACQU_01	25	45	f	\N	US	1	Unknown	\N
308	(0019,"GEMS_ACQU_01",3a)	(0019,"GEMS_ACQU_01",3a)	GEMS_ACQU_01	25	58	f	\N	IS	1	Unknown	\N
309	(0019,"GEMS_ACQU_01",3b)	(0019,"GEMS_ACQU_01",3b)	GEMS_ACQU_01	25	59	f	\N	LT	1	Unknown	\N
310	(0019,"GEMS_ACQU_01",3c)	(0019,"GEMS_ACQU_01",3c)	GEMS_ACQU_01	25	60	f	\N	UN	1	Unknown	\N
276	(0019,"GEMS_ACQU_01",03)	(0019,"GEMS_ACQU_01",03)	GEMS_ACQU_01	25	3	f	\N	DS	1	CellNumberAtTheta	KB
277	(0019,"GEMS_ACQU_01",04)	(0019,"GEMS_ACQU_01",04)	GEMS_ACQU_01	25	4	f	\N	DS	1	CellSpacing	KB
281	(0019,"GEMS_ACQU_01",0f)	(0019,"GEMS_ACQU_01",0f)	GEMS_ACQU_01	25	15	f	\N	DS	1	HorizontalFrameOfReference	KB
282	(0019,"GEMS_ACQU_01",11)	(0019,"GEMS_ACQU_01",11)	GEMS_ACQU_01	25	17	f	\N	SS	1	SeriesContrast	KB
283	(0019,"GEMS_ACQU_01",12)	(0019,"GEMS_ACQU_01",12)	GEMS_ACQU_01	25	18	f	\N	SS	1	LastPseq	KB
284	(0019,"GEMS_ACQU_01",13)	(0019,"GEMS_ACQU_01",13)	GEMS_ACQU_01	25	19	f	\N	SS	1	StartNumberForBaseline	KB
285	(0019,"GEMS_ACQU_01",14)	(0019,"GEMS_ACQU_01",14)	GEMS_ACQU_01	25	20	f	\N	SS	1	End NumberForBaseline	KB
286	(0019,"GEMS_ACQU_01",15)	(0019,"GEMS_ACQU_01",15)	GEMS_ACQU_01	25	21	f	\N	SS	1	StartNumberForEnhancedScans	KB
287	(0019,"GEMS_ACQU_01",16)	(0019,"GEMS_ACQU_01",16)	GEMS_ACQU_01	25	22	f	\N	SS	1	EndNumberForEnhancedScans	KB
288	(0019,"GEMS_ACQU_01",17)	(0019,"GEMS_ACQU_01",17)	GEMS_ACQU_01	25	23	f	\N	SS	1	SeriesPlane	KB
289	(0019,"GEMS_ACQU_01",18)	(0019,"GEMS_ACQU_01",18)	GEMS_ACQU_01	25	24	f	\N	LO	1	FirstScanRAS	R
290	(0019,"GEMS_ACQU_01",19)	(0019,"GEMS_ACQU_01",19)	GEMS_ACQU_01	25	25	f	\N	DS	1	FirstScanLocation	KB
291	(0019,"GEMS_ACQU_01",1a)	(0019,"GEMS_ACQU_01",1a)	GEMS_ACQU_01	25	26	f	\N	LO	1	LastScanRAS	R
292	(0019,"GEMS_ACQU_01",1b)	(0019,"GEMS_ACQU_01",1b)	GEMS_ACQU_01	25	27	f	\N	DS	1	LastScanLocation	KB
293	(0019,"GEMS_ACQU_01",1e)	(0019,"GEMS_ACQU_01",1e)	GEMS_ACQU_01	25	30	f	\N	DS	1	DisplayFieldOfView	KB
296	(0019,"GEMS_ACQU_01",23)	(0019,"GEMS_ACQU_01",23)	GEMS_ACQU_01	25	35	f	\N	DS	1	TableSpeed	KB
297	(0019,"GEMS_ACQU_01",24)	(0019,"GEMS_ACQU_01",24)	GEMS_ACQU_01	25	36	f	\N	DS	1	MidScanTime	R
299	(0019,"GEMS_ACQU_01",26)	(0019,"GEMS_ACQU_01",26)	GEMS_ACQU_01	25	38	f	\N	SL	1	DegreesOfAzimuth	KB
300	(0019,"GEMS_ACQU_01",27)	(0019,"GEMS_ACQU_01",27)	GEMS_ACQU_01	25	39	f	\N	DS	1	GantryPeriod	KB
301	(0019,"GEMS_ACQU_01",2a)	(0019,"GEMS_ACQU_01",2a)	GEMS_ACQU_01	25	42	f	\N	DS	1	XrayOnPosition	KB
302	(0019,"GEMS_ACQU_01",2b)	(0019,"GEMS_ACQU_01",2b)	GEMS_ACQU_01	25	43	f	\N	DS	1	XrayOffPosition	KB
303	(0019,"GEMS_ACQU_01",2c)	(0019,"GEMS_ACQU_01",2c)	GEMS_ACQU_01	25	44	f	\N	SL	1	NumberOfTriggers	KB
305	(0019,"GEMS_ACQU_01",2e)	(0019,"GEMS_ACQU_01",2e)	GEMS_ACQU_01	25	46	f	\N	DS	1	AngleOfFirstView	KB
306	(0019,"GEMS_ACQU_01",2f)	(0019,"GEMS_ACQU_01",2f)	GEMS_ACQU_01	25	47	f	\N	DS	1	TriggerFrequency	KB
307	(0019,"GEMS_ACQU_01",39)	(0019,"GEMS_ACQU_01",39)	GEMS_ACQU_01	25	57	f	\N	SS	1	ScanFOVType	KB
311	(0019,"GEMS_ACQU_01",3e)	(0019,"GEMS_ACQU_01",3e)	GEMS_ACQU_01	25	62	f	\N	UN	1	Unknown	\N
312	(0019,"GEMS_ACQU_01",3f)	(0019,"GEMS_ACQU_01",3f)	GEMS_ACQU_01	25	63	f	\N	UN	1	Unknown	\N
10963	(0119,"MRSC",1130)	(0119,"MRSC",30)	MRSC	281	48	t	11	DS	1-n	UpperFitLimit	K
319	(0019,"GEMS_ACQU_01",48)	(0019,"GEMS_ACQU_01",48)	GEMS_ACQU_01	25	72	f	\N	US	1	Unknown	\N
320	(0019,"GEMS_ACQU_01",49)	(0019,"GEMS_ACQU_01",49)	GEMS_ACQU_01	25	73	f	\N	US	1	Unknown	\N
324	(0019,"GEMS_ACQU_01",54)	(0019,"GEMS_ACQU_01",54)	GEMS_ACQU_01	25	84	f	\N	UN	1	Unknown	\N
328	(0019,"GEMS_ACQU_01",5d)	(0019,"GEMS_ACQU_01",5d)	GEMS_ACQU_01	25	93	f	\N	US	1	Unknown	\N
347	(0019,"GEMS_ACQU_01",82)	(0019,"GEMS_ACQU_01",82)	GEMS_ACQU_01	25	130	f	\N	US	1	Unknown	\N
348	(0019,"GEMS_ACQU_01",83)	(0019,"GEMS_ACQU_01",83)	GEMS_ACQU_01	25	131	f	\N	DS	1	Unknown	\N
351	(0019,"GEMS_ACQU_01",86)	(0019,"GEMS_ACQU_01",86)	GEMS_ACQU_01	25	134	f	\N	US	1	Unknown	\N
367	(0019,"GEMS_ACQU_01",99)	(0019,"GEMS_ACQU_01",99)	GEMS_ACQU_01	25	153	f	\N	US	1	Unknown	\N
315	(0019,"GEMS_ACQU_01",42)	(0019,"GEMS_ACQU_01",42)	GEMS_ACQU_01	25	66	f	\N	SS	1	SegmentNumber	KB
316	(0019,"GEMS_ACQU_01",43)	(0019,"GEMS_ACQU_01",43)	GEMS_ACQU_01	25	67	f	\N	SS	1	TotalSegmentsRequested	KB
317	(0019,"GEMS_ACQU_01",44)	(0019,"GEMS_ACQU_01",44)	GEMS_ACQU_01	25	68	f	\N	DS	1	InterscanDelay	KB
318	(0019,"GEMS_ACQU_01",47)	(0019,"GEMS_ACQU_01",47)	GEMS_ACQU_01	25	71	f	\N	SS	1	ViewCompressionFactor	KB
321	(0019,"GEMS_ACQU_01",4a)	(0019,"GEMS_ACQU_01",4a)	GEMS_ACQU_01	25	74	f	\N	SS	1	TotalNumberOfRefChannels	KB
322	(0019,"GEMS_ACQU_01",4b)	(0019,"GEMS_ACQU_01",4b)	GEMS_ACQU_01	25	75	f	\N	SL	1	DataSizeForScanData	KB
323	(0019,"GEMS_ACQU_01",52)	(0019,"GEMS_ACQU_01",52)	GEMS_ACQU_01	25	82	f	\N	SS	1	ReconPostProcessingFlag	KB
325	(0019,"GEMS_ACQU_01",57)	(0019,"GEMS_ACQU_01",57)	GEMS_ACQU_01	25	87	f	\N	SS	1	CTWaterNumber	KB
326	(0019,"GEMS_ACQU_01",58)	(0019,"GEMS_ACQU_01",58)	GEMS_ACQU_01	25	88	f	\N	SS	1	CTBoneNumber	KB
327	(0019,"GEMS_ACQU_01",5a)	(0019,"GEMS_ACQU_01",5a)	GEMS_ACQU_01	25	90	f	\N	FL	1	AcquisitionDuration	KB
329	(0019,"GEMS_ACQU_01",5e)	(0019,"GEMS_ACQU_01",5e)	GEMS_ACQU_01	25	94	f	\N	SL	1	NumberOfChannels1To512	KB
330	(0019,"GEMS_ACQU_01",5f)	(0019,"GEMS_ACQU_01",5f)	GEMS_ACQU_01	25	95	f	\N	SL	1	IncrementBetweenChannels	KB
331	(0019,"GEMS_ACQU_01",60)	(0019,"GEMS_ACQU_01",60)	GEMS_ACQU_01	25	96	f	\N	SL	1	StartingView	KB
332	(0019,"GEMS_ACQU_01",61)	(0019,"GEMS_ACQU_01",61)	GEMS_ACQU_01	25	97	f	\N	SL	1	NumberOfViews	KB
333	(0019,"GEMS_ACQU_01",62)	(0019,"GEMS_ACQU_01",62)	GEMS_ACQU_01	25	98	f	\N	SL	1	IncrementBetweenViews	KB
335	(0019,"GEMS_ACQU_01",6b)	(0019,"GEMS_ACQU_01",6b)	GEMS_ACQU_01	25	107	f	\N	SS	1	FieldOfViewInDetectorCells	KB
336	(0019,"GEMS_ACQU_01",70)	(0019,"GEMS_ACQU_01",70)	GEMS_ACQU_01	25	112	f	\N	SS	1	ValueOfBackProjectionButton	KB
337	(0019,"GEMS_ACQU_01",71)	(0019,"GEMS_ACQU_01",71)	GEMS_ACQU_01	25	113	f	\N	SS	1	SetIfFatqEstimatesWereUsed	KB
338	(0019,"GEMS_ACQU_01",72)	(0019,"GEMS_ACQU_01",72)	GEMS_ACQU_01	25	114	f	\N	DS	1	ZChannelAvgOverViews	KB
339	(0019,"GEMS_ACQU_01",73)	(0019,"GEMS_ACQU_01",73)	GEMS_ACQU_01	25	115	f	\N	DS	1	AvgOfLeftRefChannelsOverViews	KB
340	(0019,"GEMS_ACQU_01",74)	(0019,"GEMS_ACQU_01",74)	GEMS_ACQU_01	25	116	f	\N	DS	1	MaxLeftChannelOverViews	KB
341	(0019,"GEMS_ACQU_01",75)	(0019,"GEMS_ACQU_01",75)	GEMS_ACQU_01	25	117	f	\N	DS	1	AvgOfRightRefChannelsOverViews	KB
342	(0019,"GEMS_ACQU_01",76)	(0019,"GEMS_ACQU_01",76)	GEMS_ACQU_01	25	118	f	\N	DS	1	MaxRightChannelOverViews	KB
343	(0019,"GEMS_ACQU_01",7d)	(0019,"GEMS_ACQU_01",7d)	GEMS_ACQU_01	25	125	f	\N	DS	1	SecondEcho	KB
344	(0019,"GEMS_ACQU_01",7e)	(0019,"GEMS_ACQU_01",7e)	GEMS_ACQU_01	25	126	f	\N	SS	1	NumberOfEchos	KB
345	(0019,"GEMS_ACQU_01",7f)	(0019,"GEMS_ACQU_01",7f)	GEMS_ACQU_01	25	127	f	\N	DS	1	TableDelta	KB
346	(0019,"GEMS_ACQU_01",81)	(0019,"GEMS_ACQU_01",81)	GEMS_ACQU_01	25	129	f	\N	SS	1	Contiguous	KB
349	(0019,"GEMS_ACQU_01",84)	(0019,"GEMS_ACQU_01",84)	GEMS_ACQU_01	25	132	f	\N	DS	1	PeakSAR	KB
350	(0019,"GEMS_ACQU_01",85)	(0019,"GEMS_ACQU_01",85)	GEMS_ACQU_01	25	133	f	\N	SS	1	MonitorSAR	KB
352	(0019,"GEMS_ACQU_01",87)	(0019,"GEMS_ACQU_01",87)	GEMS_ACQU_01	25	135	f	\N	DS	1	CardiacRepetition Time	KB
353	(0019,"GEMS_ACQU_01",88)	(0019,"GEMS_ACQU_01",88)	GEMS_ACQU_01	25	136	f	\N	SS	1	ImagesPerCardiacCycle	KB
354	(0019,"GEMS_ACQU_01",8a)	(0019,"GEMS_ACQU_01",8a)	GEMS_ACQU_01	25	138	f	\N	SS	1	ActualReceiveGainAnalog	KB
355	(0019,"GEMS_ACQU_01",8b)	(0019,"GEMS_ACQU_01",8b)	GEMS_ACQU_01	25	139	f	\N	SS	1	ActualReceiveGainDigital	KB
356	(0019,"GEMS_ACQU_01",8d)	(0019,"GEMS_ACQU_01",8d)	GEMS_ACQU_01	25	141	f	\N	DS	1	DelayAfterTrigger	KB
357	(0019,"GEMS_ACQU_01",8f)	(0019,"GEMS_ACQU_01",8f)	GEMS_ACQU_01	25	143	f	\N	SS	1	SwapPhaseFrequency	KB
358	(0019,"GEMS_ACQU_01",90)	(0019,"GEMS_ACQU_01",90)	GEMS_ACQU_01	25	144	f	\N	SS	1	PauseInterval	KB
359	(0019,"GEMS_ACQU_01",91)	(0019,"GEMS_ACQU_01",91)	GEMS_ACQU_01	25	145	f	\N	DS	1	PulseTime	KB
361	(0019,"GEMS_ACQU_01",93)	(0019,"GEMS_ACQU_01",93)	GEMS_ACQU_01	25	147	f	\N	DS	1	CenterFrequency	K
362	(0019,"GEMS_ACQU_01",94)	(0019,"GEMS_ACQU_01",94)	GEMS_ACQU_01	25	148	f	\N	SS	1	TransmitGain	K
363	(0019,"GEMS_ACQU_01",95)	(0019,"GEMS_ACQU_01",95)	GEMS_ACQU_01	25	149	f	\N	SS	1	AnalogReceiverGain	K
364	(0019,"GEMS_ACQU_01",96)	(0019,"GEMS_ACQU_01",96)	GEMS_ACQU_01	25	150	f	\N	SS	1	DigitalReceiverGain	K
365	(0019,"GEMS_ACQU_01",97)	(0019,"GEMS_ACQU_01",97)	GEMS_ACQU_01	25	151	f	\N	SL	1	BitmapDefiningCVs	K
366	(0019,"GEMS_ACQU_01",98)	(0019,"GEMS_ACQU_01",98)	GEMS_ACQU_01	25	152	f	\N	SS	1	CenterFrequencyMethod	K
368	(0019,"GEMS_ACQU_01",9b)	(0019,"GEMS_ACQU_01",9b)	GEMS_ACQU_01	25	155	f	\N	SS	1	PulseSequenceMode	K
369	(0019,"GEMS_ACQU_01",9c)	(0019,"GEMS_ACQU_01",9c)	GEMS_ACQU_01	25	156	f	\N	LO	1	PulseSequenceName	R
370	(0019,"GEMS_ACQU_01",9d)	(0019,"GEMS_ACQU_01",9d)	GEMS_ACQU_01	25	157	f	\N	DT	1	PulseSequenceDate	Z
422	(0019,"GEMS_ACQU_01",d4)	(0019,"GEMS_ACQU_01",d4)	GEMS_ACQU_01	25	212	f	\N	US	1	Unknown	\N
372	(0019,"GEMS_ACQU_01",9f)	(0019,"GEMS_ACQU_01",9f)	GEMS_ACQU_01	25	159	f	\N	SS	1	TransmittingCoil	K
373	(0019,"GEMS_ACQU_01",a0)	(0019,"GEMS_ACQU_01",a0)	GEMS_ACQU_01	25	160	f	\N	SS	1	SurfaceCoilType	K
374	(0019,"GEMS_ACQU_01",a1)	(0019,"GEMS_ACQU_01",a1)	GEMS_ACQU_01	25	161	f	\N	SS	1	ExtremityCoilFlag	K
375	(0019,"GEMS_ACQU_01",a2)	(0019,"GEMS_ACQU_01",a2)	GEMS_ACQU_01	25	162	f	\N	SL	1	RawDataRunNumber	K
376	(0019,"GEMS_ACQU_01",a3)	(0019,"GEMS_ACQU_01",a3)	GEMS_ACQU_01	25	163	f	\N	UL	1	CalibratedFieldStrength	K
377	(0019,"GEMS_ACQU_01",a4)	(0019,"GEMS_ACQU_01",a4)	GEMS_ACQU_01	25	164	f	\N	SS	1	SATFatWaterBone	K
378	(0019,"GEMS_ACQU_01",a5)	(0019,"GEMS_ACQU_01",a5)	GEMS_ACQU_01	25	165	f	\N	DS	1	ReceiveBandwidth	K
379	(0019,"GEMS_ACQU_01",a7)	(0019,"GEMS_ACQU_01",a7)	GEMS_ACQU_01	25	167	f	\N	DS	1	UserData	R
380	(0019,"GEMS_ACQU_01",a8)	(0019,"GEMS_ACQU_01",a8)	GEMS_ACQU_01	25	168	f	\N	DS	1	UserData	R
381	(0019,"GEMS_ACQU_01",a9)	(0019,"GEMS_ACQU_01",a9)	GEMS_ACQU_01	25	169	f	\N	DS	1	UserData	R
382	(0019,"GEMS_ACQU_01",aa)	(0019,"GEMS_ACQU_01",aa)	GEMS_ACQU_01	25	170	f	\N	DS	1	UserData	R
383	(0019,"GEMS_ACQU_01",ab)	(0019,"GEMS_ACQU_01",ab)	GEMS_ACQU_01	25	171	f	\N	DS	1	UserData	R
384	(0019,"GEMS_ACQU_01",ac)	(0019,"GEMS_ACQU_01",ac)	GEMS_ACQU_01	25	172	f	\N	DS	1	UserData	R
385	(0019,"GEMS_ACQU_01",ad)	(0019,"GEMS_ACQU_01",ad)	GEMS_ACQU_01	25	173	f	\N	DS	1	UserData	R
386	(0019,"GEMS_ACQU_01",ae)	(0019,"GEMS_ACQU_01",ae)	GEMS_ACQU_01	25	174	f	\N	DS	1	UserData	R
387	(0019,"GEMS_ACQU_01",af)	(0019,"GEMS_ACQU_01",af)	GEMS_ACQU_01	25	175	f	\N	DS	1	UserData	R
388	(0019,"GEMS_ACQU_01",b0)	(0019,"GEMS_ACQU_01",b0)	GEMS_ACQU_01	25	176	f	\N	DS	1	UserData	R
389	(0019,"GEMS_ACQU_01",b1)	(0019,"GEMS_ACQU_01",b1)	GEMS_ACQU_01	25	177	f	\N	DS	1	UserData	R
391	(0019,"GEMS_ACQU_01",b3)	(0019,"GEMS_ACQU_01",b3)	GEMS_ACQU_01	25	179	f	\N	DS	1	UserData	R
392	(0019,"GEMS_ACQU_01",b4)	(0019,"GEMS_ACQU_01",b4)	GEMS_ACQU_01	25	180	f	\N	DS	1	UserData	R
393	(0019,"GEMS_ACQU_01",b5)	(0019,"GEMS_ACQU_01",b5)	GEMS_ACQU_01	25	181	f	\N	DS	1	UserData	R
394	(0019,"GEMS_ACQU_01",b6)	(0019,"GEMS_ACQU_01",b6)	GEMS_ACQU_01	25	182	f	\N	DS	1	UserData	R
395	(0019,"GEMS_ACQU_01",b7)	(0019,"GEMS_ACQU_01",b7)	GEMS_ACQU_01	25	183	f	\N	DS	1	UserData	R
396	(0019,"GEMS_ACQU_01",b8)	(0019,"GEMS_ACQU_01",b8)	GEMS_ACQU_01	25	184	f	\N	DS	1	UserData	R
397	(0019,"GEMS_ACQU_01",b9)	(0019,"GEMS_ACQU_01",b9)	GEMS_ACQU_01	25	185	f	\N	DS	1	UserData	R
398	(0019,"GEMS_ACQU_01",ba)	(0019,"GEMS_ACQU_01",ba)	GEMS_ACQU_01	25	186	f	\N	DS	1	UserData	R
399	(0019,"GEMS_ACQU_01",bb)	(0019,"GEMS_ACQU_01",bb)	GEMS_ACQU_01	25	187	f	\N	DS	1	UserData	R
400	(0019,"GEMS_ACQU_01",bc)	(0019,"GEMS_ACQU_01",bc)	GEMS_ACQU_01	25	188	f	\N	DS	1	UserData	R
401	(0019,"GEMS_ACQU_01",bd)	(0019,"GEMS_ACQU_01",bd)	GEMS_ACQU_01	25	189	f	\N	DS	1	UserData	R
402	(0019,"GEMS_ACQU_01",be)	(0019,"GEMS_ACQU_01",be)	GEMS_ACQU_01	25	190	f	\N	DS	1	ProjectionAngle	K
403	(0019,"GEMS_ACQU_01",c0)	(0019,"GEMS_ACQU_01",c0)	GEMS_ACQU_01	25	192	f	\N	SS	1	SaturationPlanes	K
404	(0019,"GEMS_ACQU_01",c1)	(0019,"GEMS_ACQU_01",c1)	GEMS_ACQU_01	25	193	f	\N	SS	1	SurfaceCoilIntensityCorrectionFlag	K
405	(0019,"GEMS_ACQU_01",c2)	(0019,"GEMS_ACQU_01",c2)	GEMS_ACQU_01	25	194	f	\N	SS	1	SATLocationR	K
406	(0019,"GEMS_ACQU_01",c3)	(0019,"GEMS_ACQU_01",c3)	GEMS_ACQU_01	25	195	f	\N	SS	1	SATLocationL	K
407	(0019,"GEMS_ACQU_01",c4)	(0019,"GEMS_ACQU_01",c4)	GEMS_ACQU_01	25	196	f	\N	SS	1	SATLocationA	K
408	(0019,"GEMS_ACQU_01",c5)	(0019,"GEMS_ACQU_01",c5)	GEMS_ACQU_01	25	197	f	\N	SS	1	SATLocationP	K
409	(0019,"GEMS_ACQU_01",c6)	(0019,"GEMS_ACQU_01",c6)	GEMS_ACQU_01	25	198	f	\N	SS	1	SATLocationH	K
410	(0019,"GEMS_ACQU_01",c7)	(0019,"GEMS_ACQU_01",c7)	GEMS_ACQU_01	25	199	f	\N	SS	1	SATLocationF	K
411	(0019,"GEMS_ACQU_01",c8)	(0019,"GEMS_ACQU_01",c8)	GEMS_ACQU_01	25	200	f	\N	SS	1	SATThicknessRL	K
412	(0019,"GEMS_ACQU_01",c9)	(0019,"GEMS_ACQU_01",c9)	GEMS_ACQU_01	25	201	f	\N	SS	1	SATThicknessAP	K
413	(0019,"GEMS_ACQU_01",ca)	(0019,"GEMS_ACQU_01",ca)	GEMS_ACQU_01	25	202	f	\N	SS	1	SATThicknessHF	K
415	(0019,"GEMS_ACQU_01",cc)	(0019,"GEMS_ACQU_01",cc)	GEMS_ACQU_01	25	204	f	\N	SS	1	VelocityEncoding	K
416	(0019,"GEMS_ACQU_01",cd)	(0019,"GEMS_ACQU_01",cd)	GEMS_ACQU_01	25	205	f	\N	SS	1	ThicknessDisclaimer	K
417	(0019,"GEMS_ACQU_01",ce)	(0019,"GEMS_ACQU_01",ce)	GEMS_ACQU_01	25	206	f	\N	SS	1	PrescanType	K
418	(0019,"GEMS_ACQU_01",cf)	(0019,"GEMS_ACQU_01",cf)	GEMS_ACQU_01	25	207	f	\N	SS	1	PrescanStatus	K
419	(0019,"GEMS_ACQU_01",d0)	(0019,"GEMS_ACQU_01",d0)	GEMS_ACQU_01	25	208	f	\N	SH	1	RawDataType	R
420	(0019,"GEMS_ACQU_01",d2)	(0019,"GEMS_ACQU_01",d2)	GEMS_ACQU_01	25	210	f	\N	SS	1	ProjectionAlgorithm	K
421	(0019,"GEMS_ACQU_01",d3)	(0019,"GEMS_ACQU_01",d3)	GEMS_ACQU_01	25	211	f	\N	SH	1	ProjectionAlgorithm	K
423	(0019,"GEMS_ACQU_01",d5)	(0019,"GEMS_ACQU_01",d5)	GEMS_ACQU_01	25	213	f	\N	SS	1	FractionalEcho	K
424	(0019,"GEMS_ACQU_01",d6)	(0019,"GEMS_ACQU_01",d6)	GEMS_ACQU_01	25	214	f	\N	SS	1	PrepPulse	K
425	(0019,"GEMS_ACQU_01",d7)	(0019,"GEMS_ACQU_01",d7)	GEMS_ACQU_01	25	215	f	\N	SS	1	CardiacPhases	K
426	(0019,"GEMS_ACQU_01",d8)	(0019,"GEMS_ACQU_01",d8)	GEMS_ACQU_01	25	216	f	\N	SS	1	VariableEchoFlag	K
427	(0019,"GEMS_ACQU_01",d9)	(0019,"GEMS_ACQU_01",d9)	GEMS_ACQU_01	25	217	f	\N	DS	1	ConcatenatedSAT	R
428	(0019,"GEMS_ACQU_01",da)	(0019,"GEMS_ACQU_01",da)	GEMS_ACQU_01	25	218	f	\N	SS	1	ReferenceChannelUsed	KB
429	(0019,"GEMS_ACQU_01",db)	(0019,"GEMS_ACQU_01",db)	GEMS_ACQU_01	25	219	f	\N	DS	1	BackProjectorCoefficient	KB
430	(0019,"GEMS_ACQU_01",dc)	(0019,"GEMS_ACQU_01",dc)	GEMS_ACQU_01	25	220	f	\N	SS	1	PrimarySpeedCorrectionUsed	KB
10964	(0119,"MRSC",1131)	(0119,"MRSC",31)	MRSC	281	49	t	11	DS	1-n	LowerFitLimit	K
435	(0019,"GEMS_ACQU_01",e1)	(0019,"GEMS_ACQU_01",e1)	GEMS_ACQU_01	25	225	f	\N	DS	1	Unknown	\N
437	(0019,"GEMS_ACQU_01",e3)	(0019,"GEMS_ACQU_01",e3)	GEMS_ACQU_01	25	227	f	\N	LT	1	Unknown	\N
438	(0019,"GEMS_ACQU_01",e4)	(0019,"GEMS_ACQU_01",e4)	GEMS_ACQU_01	25	228	f	\N	LT	1	Unknown	\N
439	(0019,"GEMS_ACQU_01",e5)	(0019,"GEMS_ACQU_01",e5)	GEMS_ACQU_01	25	229	f	\N	IS	1	Unknown	\N
440	(0019,"GEMS_ACQU_01",e6)	(0019,"GEMS_ACQU_01",e6)	GEMS_ACQU_01	25	230	f	\N	US	1	Unknown	\N
441	(0019,"GEMS_ACQU_01",e8)	(0019,"GEMS_ACQU_01",e8)	GEMS_ACQU_01	25	232	f	\N	DS	1	Unknown	\N
442	(0019,"GEMS_ACQU_01",e9)	(0019,"GEMS_ACQU_01",e9)	GEMS_ACQU_01	25	233	f	\N	DS	1	Unknown	\N
443	(0019,"GEMS_ACQU_01",eb)	(0019,"GEMS_ACQU_01",eb)	GEMS_ACQU_01	25	235	f	\N	DS	1	Unknown	\N
444	(0019,"GEMS_ACQU_01",ec)	(0019,"GEMS_ACQU_01",ec)	GEMS_ACQU_01	25	236	f	\N	US	1	Unknown	\N
445	(0019,"GEMS_ACQU_01",f0)	(0019,"GEMS_ACQU_01",f0)	GEMS_ACQU_01	25	240	f	\N	UN	1	Unknown	\N
446	(0019,"GEMS_ACQU_01",f1)	(0019,"GEMS_ACQU_01",f1)	GEMS_ACQU_01	25	241	f	\N	LT	1	Unknown	\N
448	(0019,"GEMS_ACQU_01",f3)	(0019,"GEMS_ACQU_01",f3)	GEMS_ACQU_01	25	243	f	\N	LT	1	Unknown	\N
449	(0019,"GEMS_ACQU_01",f4)	(0019,"GEMS_ACQU_01",f4)	GEMS_ACQU_01	25	244	f	\N	LT	1	Unknown	\N
451	(0023,"GEMS_ACRQA_1.0 BLOCK1",00)	(0023,"GEMS_ACRQA_1.0 BLOCK1",00)	GEMS_ACRQA_1.0 BLOCK1	35	0	f	\N	LO	1	CRExposureMenuCode	\N
452	(0023,"GEMS_ACRQA_1.0 BLOCK1",10)	(0023,"GEMS_ACRQA_1.0 BLOCK1",10)	GEMS_ACRQA_1.0 BLOCK1	35	16	f	\N	LO	1	CRExposureMenuString	\N
453	(0023,"GEMS_ACRQA_1.0 BLOCK1",20)	(0023,"GEMS_ACRQA_1.0 BLOCK1",20)	GEMS_ACRQA_1.0 BLOCK1	35	32	f	\N	LO	1	CREDRMode	\N
454	(0023,"GEMS_ACRQA_1.0 BLOCK1",30)	(0023,"GEMS_ACRQA_1.0 BLOCK1",30)	GEMS_ACRQA_1.0 BLOCK1	35	48	f	\N	LO	1	CRLatitude	\N
455	(0023,"GEMS_ACRQA_1.0 BLOCK1",40)	(0023,"GEMS_ACRQA_1.0 BLOCK1",40)	GEMS_ACRQA_1.0 BLOCK1	35	64	f	\N	LO	1	CRGroupNumber	\N
456	(0023,"GEMS_ACRQA_1.0 BLOCK1",50)	(0023,"GEMS_ACRQA_1.0 BLOCK1",50)	GEMS_ACRQA_1.0 BLOCK1	35	80	f	\N	US	1	CRImageSerialNumber	\N
457	(0023,"GEMS_ACRQA_1.0 BLOCK1",60)	(0023,"GEMS_ACRQA_1.0 BLOCK1",60)	GEMS_ACRQA_1.0 BLOCK1	35	96	f	\N	LO	1	CRBarCodeNumber	\N
458	(0023,"GEMS_ACRQA_1.0 BLOCK1",70)	(0023,"GEMS_ACRQA_1.0 BLOCK1",70)	GEMS_ACRQA_1.0 BLOCK1	35	112	f	\N	LO	1	CRFilmOutputExposure	\N
459	(0023,"GEMS_ACRQA_1.0 BLOCK1",80)	(0023,"GEMS_ACRQA_1.0 BLOCK1",80)	GEMS_ACRQA_1.0 BLOCK1	35	128	f	\N	LO	1	CRFilmFormat	\N
460	(0023,"GEMS_ACRQA_1.0 BLOCK1",90)	(0023,"GEMS_ACRQA_1.0 BLOCK1",90)	GEMS_ACRQA_1.0 BLOCK1	35	144	f	\N	LO	1	CRSShiftString	\N
461	(0023,"GEMS_ACRQA_1.0 BLOCK2",00)	(0023,"GEMS_ACRQA_1.0 BLOCK2",00)	GEMS_ACRQA_1.0 BLOCK2	35	0	f	\N	US	1	CRSShift	\N
462	(0023,"GEMS_ACRQA_1.0 BLOCK2",10)	(0023,"GEMS_ACRQA_1.0 BLOCK2",10)	GEMS_ACRQA_1.0 BLOCK2	35	16	f	\N	DS	1	CRCShift	\N
463	(0023,"GEMS_ACRQA_1.0 BLOCK2",20)	(0023,"GEMS_ACRQA_1.0 BLOCK2",20)	GEMS_ACRQA_1.0 BLOCK2	35	32	f	\N	DS	1	CRGT	\N
464	(0023,"GEMS_ACRQA_1.0 BLOCK2",30)	(0023,"GEMS_ACRQA_1.0 BLOCK2",30)	GEMS_ACRQA_1.0 BLOCK2	35	48	f	\N	DS	1	CRGA	\N
465	(0023,"GEMS_ACRQA_1.0 BLOCK2",40)	(0023,"GEMS_ACRQA_1.0 BLOCK2",40)	GEMS_ACRQA_1.0 BLOCK2	35	64	f	\N	DS	1	CRGC	\N
466	(0023,"GEMS_ACRQA_1.0 BLOCK2",50)	(0023,"GEMS_ACRQA_1.0 BLOCK2",50)	GEMS_ACRQA_1.0 BLOCK2	35	80	f	\N	DS	1	CRGS	\N
467	(0023,"GEMS_ACRQA_1.0 BLOCK2",60)	(0023,"GEMS_ACRQA_1.0 BLOCK2",60)	GEMS_ACRQA_1.0 BLOCK2	35	96	f	\N	DS	1	CRRT	\N
468	(0023,"GEMS_ACRQA_1.0 BLOCK2",70)	(0023,"GEMS_ACRQA_1.0 BLOCK2",70)	GEMS_ACRQA_1.0 BLOCK2	35	112	f	\N	DS	1	CRRE	\N
469	(0023,"GEMS_ACRQA_1.0 BLOCK2",80)	(0023,"GEMS_ACRQA_1.0 BLOCK2",80)	GEMS_ACRQA_1.0 BLOCK2	35	128	f	\N	US	1	CRRN	\N
470	(0023,"GEMS_ACRQA_1.0 BLOCK2",90)	(0023,"GEMS_ACRQA_1.0 BLOCK2",90)	GEMS_ACRQA_1.0 BLOCK2	35	144	f	\N	DS	1	CRDRT	\N
471	(0023,"GEMS_ACRQA_1.0 BLOCK3",00)	(0023,"GEMS_ACRQA_1.0 BLOCK3",00)	GEMS_ACRQA_1.0 BLOCK3	35	0	f	\N	DS	1	CRDRE	\N
472	(0023,"GEMS_ACRQA_1.0 BLOCK3",10)	(0023,"GEMS_ACRQA_1.0 BLOCK3",10)	GEMS_ACRQA_1.0 BLOCK3	35	16	f	\N	US	1	CRDRN	\N
473	(0023,"GEMS_ACRQA_1.0 BLOCK3",20)	(0023,"GEMS_ACRQA_1.0 BLOCK3",20)	GEMS_ACRQA_1.0 BLOCK3	35	32	f	\N	DS	1	CRORE	\N
474	(0023,"GEMS_ACRQA_1.0 BLOCK3",30)	(0023,"GEMS_ACRQA_1.0 BLOCK3",30)	GEMS_ACRQA_1.0 BLOCK3	35	48	f	\N	US	1	CRORN	\N
475	(0023,"GEMS_ACRQA_1.0 BLOCK3",40)	(0023,"GEMS_ACRQA_1.0 BLOCK3",40)	GEMS_ACRQA_1.0 BLOCK3	35	64	f	\N	US	1	CRORD	\N
476	(0023,"GEMS_ACRQA_1.0 BLOCK3",50)	(0023,"GEMS_ACRQA_1.0 BLOCK3",50)	GEMS_ACRQA_1.0 BLOCK3	35	80	f	\N	LO	1	CRCassetteSize	\N
477	(0023,"GEMS_ACRQA_1.0 BLOCK3",60)	(0023,"GEMS_ACRQA_1.0 BLOCK3",60)	GEMS_ACRQA_1.0 BLOCK3	35	96	f	\N	LO	1	CRMachineID	\N
478	(0023,"GEMS_ACRQA_1.0 BLOCK3",70)	(0023,"GEMS_ACRQA_1.0 BLOCK3",70)	GEMS_ACRQA_1.0 BLOCK3	35	112	f	\N	LO	1	CRMachineType	\N
479	(0023,"GEMS_ACRQA_1.0 BLOCK3",80)	(0023,"GEMS_ACRQA_1.0 BLOCK3",80)	GEMS_ACRQA_1.0 BLOCK3	35	128	f	\N	LO	1	CRTechnicianCode	\N
480	(0023,"GEMS_ACRQA_1.0 BLOCK3",90)	(0023,"GEMS_ACRQA_1.0 BLOCK3",90)	GEMS_ACRQA_1.0 BLOCK3	35	144	f	\N	LO	1	CREnergySubtractionParameters	\N
481	(0023,"GEMS_ACRQA_2.0 BLOCK1",00)	(0023,"GEMS_ACRQA_2.0 BLOCK1",00)	GEMS_ACRQA_2.0 BLOCK1	35	0	f	\N	LO	1	CRExposureMenuCode	\N
482	(0023,"GEMS_ACRQA_2.0 BLOCK1",10)	(0023,"GEMS_ACRQA_2.0 BLOCK1",10)	GEMS_ACRQA_2.0 BLOCK1	35	16	f	\N	LO	1	CRExposureMenuString	\N
483	(0023,"GEMS_ACRQA_2.0 BLOCK1",20)	(0023,"GEMS_ACRQA_2.0 BLOCK1",20)	GEMS_ACRQA_2.0 BLOCK1	35	32	f	\N	LO	1	CREDRMode	\N
484	(0023,"GEMS_ACRQA_2.0 BLOCK1",30)	(0023,"GEMS_ACRQA_2.0 BLOCK1",30)	GEMS_ACRQA_2.0 BLOCK1	35	48	f	\N	LO	1	CRLatitude	\N
485	(0023,"GEMS_ACRQA_2.0 BLOCK1",40)	(0023,"GEMS_ACRQA_2.0 BLOCK1",40)	GEMS_ACRQA_2.0 BLOCK1	35	64	f	\N	LO	1	CRGroupNumber	\N
432	(0019,"GEMS_ACQU_01",de)	(0019,"GEMS_ACQU_01",de)	GEMS_ACQU_01	25	222	f	\N	DS	1	DynamicZAlphaValue	KB
433	(0019,"GEMS_ACQU_01",df)	(0019,"GEMS_ACQU_01",df)	GEMS_ACQU_01	25	223	f	\N	DS	1	UserData	R
434	(0019,"GEMS_ACQU_01",e0)	(0019,"GEMS_ACQU_01",e0)	GEMS_ACQU_01	25	224	f	\N	DS	1	UserData	R
436	(0019,"GEMS_ACQU_01",e2)	(0019,"GEMS_ACQU_01",e2)	GEMS_ACQU_01	25	226	f	\N	DS	1	VelocityEncodeScale	K
447	(0019,"GEMS_ACQU_01",f2)	(0019,"GEMS_ACQU_01",f2)	GEMS_ACQU_01	25	242	f	\N	SS	1	FastPhases	K
450	(0019,"GEMS_ACQU_01",f9)	(0019,"GEMS_ACQU_01",f9)	GEMS_ACQU_01	25	249	f	\N	DS	1	TransmissionGain	K
486	(0023,"GEMS_ACRQA_2.0 BLOCK1",50)	(0023,"GEMS_ACRQA_2.0 BLOCK1",50)	GEMS_ACRQA_2.0 BLOCK1	35	80	f	\N	US	1	CRImageSerialNumber	\N
487	(0023,"GEMS_ACRQA_2.0 BLOCK1",60)	(0023,"GEMS_ACRQA_2.0 BLOCK1",60)	GEMS_ACRQA_2.0 BLOCK1	35	96	f	\N	LO	1	CRBarCodeNumber	\N
488	(0023,"GEMS_ACRQA_2.0 BLOCK1",70)	(0023,"GEMS_ACRQA_2.0 BLOCK1",70)	GEMS_ACRQA_2.0 BLOCK1	35	112	f	\N	LO	1	CRFilmOutputExposure	\N
489	(0023,"GEMS_ACRQA_2.0 BLOCK1",80)	(0023,"GEMS_ACRQA_2.0 BLOCK1",80)	GEMS_ACRQA_2.0 BLOCK1	35	128	f	\N	LO	1	CRFilmFormat	\N
490	(0023,"GEMS_ACRQA_2.0 BLOCK1",90)	(0023,"GEMS_ACRQA_2.0 BLOCK1",90)	GEMS_ACRQA_2.0 BLOCK1	35	144	f	\N	LO	1	CRSShiftString	\N
491	(0023,"GEMS_ACRQA_2.0 BLOCK2",00)	(0023,"GEMS_ACRQA_2.0 BLOCK2",00)	GEMS_ACRQA_2.0 BLOCK2	35	0	f	\N	US	1	CRSShift	\N
492	(0023,"GEMS_ACRQA_2.0 BLOCK2",10)	(0023,"GEMS_ACRQA_2.0 BLOCK2",10)	GEMS_ACRQA_2.0 BLOCK2	35	16	f	\N	LO	1	CRCShift	\N
493	(0023,"GEMS_ACRQA_2.0 BLOCK2",20)	(0023,"GEMS_ACRQA_2.0 BLOCK2",20)	GEMS_ACRQA_2.0 BLOCK2	35	32	f	\N	LO	1	CRGT	\N
494	(0023,"GEMS_ACRQA_2.0 BLOCK2",30)	(0023,"GEMS_ACRQA_2.0 BLOCK2",30)	GEMS_ACRQA_2.0 BLOCK2	35	48	f	\N	DS	1	CRGA	\N
495	(0023,"GEMS_ACRQA_2.0 BLOCK2",40)	(0023,"GEMS_ACRQA_2.0 BLOCK2",40)	GEMS_ACRQA_2.0 BLOCK2	35	64	f	\N	DS	1	CRGC	\N
496	(0023,"GEMS_ACRQA_2.0 BLOCK2",50)	(0023,"GEMS_ACRQA_2.0 BLOCK2",50)	GEMS_ACRQA_2.0 BLOCK2	35	80	f	\N	DS	1	CRGS	\N
497	(0023,"GEMS_ACRQA_2.0 BLOCK2",60)	(0023,"GEMS_ACRQA_2.0 BLOCK2",60)	GEMS_ACRQA_2.0 BLOCK2	35	96	f	\N	LO	1	CRRT	\N
498	(0023,"GEMS_ACRQA_2.0 BLOCK2",70)	(0023,"GEMS_ACRQA_2.0 BLOCK2",70)	GEMS_ACRQA_2.0 BLOCK2	35	112	f	\N	DS	1	CRRE	\N
499	(0023,"GEMS_ACRQA_2.0 BLOCK2",80)	(0023,"GEMS_ACRQA_2.0 BLOCK2",80)	GEMS_ACRQA_2.0 BLOCK2	35	128	f	\N	US	1	CRRN	\N
500	(0023,"GEMS_ACRQA_2.0 BLOCK2",90)	(0023,"GEMS_ACRQA_2.0 BLOCK2",90)	GEMS_ACRQA_2.0 BLOCK2	35	144	f	\N	DS	1	CRDRT	\N
501	(0023,"GEMS_ACRQA_2.0 BLOCK3",00)	(0023,"GEMS_ACRQA_2.0 BLOCK3",00)	GEMS_ACRQA_2.0 BLOCK3	35	0	f	\N	DS	1	CRDRE	\N
502	(0023,"GEMS_ACRQA_2.0 BLOCK3",10)	(0023,"GEMS_ACRQA_2.0 BLOCK3",10)	GEMS_ACRQA_2.0 BLOCK3	35	16	f	\N	US	1	CRDRN	\N
503	(0023,"GEMS_ACRQA_2.0 BLOCK3",20)	(0023,"GEMS_ACRQA_2.0 BLOCK3",20)	GEMS_ACRQA_2.0 BLOCK3	35	32	f	\N	DS	1	CRORE	\N
504	(0023,"GEMS_ACRQA_2.0 BLOCK3",30)	(0023,"GEMS_ACRQA_2.0 BLOCK3",30)	GEMS_ACRQA_2.0 BLOCK3	35	48	f	\N	US	1	CRORN	\N
505	(0023,"GEMS_ACRQA_2.0 BLOCK3",40)	(0023,"GEMS_ACRQA_2.0 BLOCK3",40)	GEMS_ACRQA_2.0 BLOCK3	35	64	f	\N	US	1	CRORD	\N
506	(0023,"GEMS_ACRQA_2.0 BLOCK3",50)	(0023,"GEMS_ACRQA_2.0 BLOCK3",50)	GEMS_ACRQA_2.0 BLOCK3	35	80	f	\N	LO	1	CRCassetteSize	\N
507	(0023,"GEMS_ACRQA_2.0 BLOCK3",60)	(0023,"GEMS_ACRQA_2.0 BLOCK3",60)	GEMS_ACRQA_2.0 BLOCK3	35	96	f	\N	LO	1	CRMachineID	\N
508	(0023,"GEMS_ACRQA_2.0 BLOCK3",70)	(0023,"GEMS_ACRQA_2.0 BLOCK3",70)	GEMS_ACRQA_2.0 BLOCK3	35	112	f	\N	LO	1	CRMachineType	\N
509	(0023,"GEMS_ACRQA_2.0 BLOCK3",80)	(0023,"GEMS_ACRQA_2.0 BLOCK3",80)	GEMS_ACRQA_2.0 BLOCK3	35	128	f	\N	LO	1	CRTechnicianCode	\N
510	(0023,"GEMS_ACRQA_2.0 BLOCK3",90)	(0023,"GEMS_ACRQA_2.0 BLOCK3",90)	GEMS_ACRQA_2.0 BLOCK3	35	144	f	\N	LO	1	CREnergySubtractionParameters	\N
511	(0023,"GEMS_ACRQA_2.0 BLOCK3",f0)	(0023,"GEMS_ACRQA_2.0 BLOCK3",f0)	GEMS_ACRQA_2.0 BLOCK3	35	240	f	\N	LO	1	CRDistributionCode	\N
512	(0023,"GEMS_ACRQA_2.0 BLOCK3",ff)	(0023,"GEMS_ACRQA_2.0 BLOCK3",ff)	GEMS_ACRQA_2.0 BLOCK3	35	255	f	\N	US	1	CRShuttersApplied	\N
513	(0047,"GEMS_ADWSoft_3D1",01)	(0047,"GEMS_ADWSoft_3D1",01)	GEMS_ADWSoft_3D1	71	1	f	\N	SQ	1	Reconstruction Parameters Sequence	\N
514	(0047,"GEMS_ADWSoft_3D1",50)	(0047,"GEMS_ADWSoft_3D1",50)	GEMS_ADWSoft_3D1	71	80	f	\N	UL	1	VolumeVoxelCount	\N
515	(0047,"GEMS_ADWSoft_3D1",51)	(0047,"GEMS_ADWSoft_3D1",51)	GEMS_ADWSoft_3D1	71	81	f	\N	UL	1	VolumeSegmentCount	\N
516	(0047,"GEMS_ADWSoft_3D1",53)	(0047,"GEMS_ADWSoft_3D1",53)	GEMS_ADWSoft_3D1	71	83	f	\N	US	1	VolumeSliceSize	\N
517	(0047,"GEMS_ADWSoft_3D1",54)	(0047,"GEMS_ADWSoft_3D1",54)	GEMS_ADWSoft_3D1	71	84	f	\N	US	1	VolumeSliceCount	\N
518	(0047,"GEMS_ADWSoft_3D1",55)	(0047,"GEMS_ADWSoft_3D1",55)	GEMS_ADWSoft_3D1	71	85	f	\N	SL	1	VolumeThresholdValue	\N
519	(0047,"GEMS_ADWSoft_3D1",57)	(0047,"GEMS_ADWSoft_3D1",57)	GEMS_ADWSoft_3D1	71	87	f	\N	DS	1	VolumeVoxelRatio	\N
520	(0047,"GEMS_ADWSoft_3D1",58)	(0047,"GEMS_ADWSoft_3D1",58)	GEMS_ADWSoft_3D1	71	88	f	\N	DS	1	VolumeVoxelSize	\N
521	(0047,"GEMS_ADWSoft_3D1",59)	(0047,"GEMS_ADWSoft_3D1",59)	GEMS_ADWSoft_3D1	71	89	f	\N	US	1	VolumeZPositionSize	\N
522	(0047,"GEMS_ADWSoft_3D1",60)	(0047,"GEMS_ADWSoft_3D1",60)	GEMS_ADWSoft_3D1	71	96	f	\N	DS	9	VolumeBaseLine	\N
523	(0047,"GEMS_ADWSoft_3D1",61)	(0047,"GEMS_ADWSoft_3D1",61)	GEMS_ADWSoft_3D1	71	97	f	\N	DS	3	VolumeCenterPoint	\N
524	(0047,"GEMS_ADWSoft_3D1",63)	(0047,"GEMS_ADWSoft_3D1",63)	GEMS_ADWSoft_3D1	71	99	f	\N	SL	1	VolumeSkewBase	\N
525	(0047,"GEMS_ADWSoft_3D1",64)	(0047,"GEMS_ADWSoft_3D1",64)	GEMS_ADWSoft_3D1	71	100	f	\N	DS	9	VolumeRegistrationTransformRotationMatrix	\N
526	(0047,"GEMS_ADWSoft_3D1",65)	(0047,"GEMS_ADWSoft_3D1",65)	GEMS_ADWSoft_3D1	71	101	f	\N	DS	3	VolumeRegistrationTransformTranslationVector	\N
527	(0047,"GEMS_ADWSoft_3D1",70)	(0047,"GEMS_ADWSoft_3D1",70)	GEMS_ADWSoft_3D1	71	112	f	\N	DS	1-n	KVPList	\N
528	(0047,"GEMS_ADWSoft_3D1",71)	(0047,"GEMS_ADWSoft_3D1",71)	GEMS_ADWSoft_3D1	71	113	f	\N	IS	1-n	XRayTubeCurrentList	\N
529	(0047,"GEMS_ADWSoft_3D1",72)	(0047,"GEMS_ADWSoft_3D1",72)	GEMS_ADWSoft_3D1	71	114	f	\N	IS	1-n	ExposureList	\N
530	(0047,"GEMS_ADWSoft_3D1",80)	(0047,"GEMS_ADWSoft_3D1",80)	GEMS_ADWSoft_3D1	71	128	f	\N	LO	1	AcquisitionDLXIdentifier	\N
531	(0047,"GEMS_ADWSoft_3D1",85)	(0047,"GEMS_ADWSoft_3D1",85)	GEMS_ADWSoft_3D1	71	133	f	\N	SQ	1	AcquisitionDLX2DSeriesSequence	\N
532	(0047,"GEMS_ADWSoft_3D1",89)	(0047,"GEMS_ADWSoft_3D1",89)	GEMS_ADWSoft_3D1	71	137	f	\N	DS	1-n	ContrastAgentVolumeList	\N
533	(0047,"GEMS_ADWSoft_3D1",8A)	(0047,"GEMS_ADWSoft_3D1",8A)	GEMS_ADWSoft_3D1	71	138	f	\N	US	1	NumberOfInjections	\N
534	(0047,"GEMS_ADWSoft_3D1",8B)	(0047,"GEMS_ADWSoft_3D1",8B)	GEMS_ADWSoft_3D1	71	139	f	\N	US	1	FrameCount	\N
535	(0047,"GEMS_ADWSoft_3D1",91)	(0047,"GEMS_ADWSoft_3D1",91)	GEMS_ADWSoft_3D1	71	145	f	\N	LO	1	XA3DReconstructionAlgorithmName	\N
536	(0047,"GEMS_ADWSoft_3D1",92)	(0047,"GEMS_ADWSoft_3D1",92)	GEMS_ADWSoft_3D1	71	146	f	\N	CS	1	XA3DReconstructionAlgorithmVersion	\N
537	(0047,"GEMS_ADWSoft_3D1",93)	(0047,"GEMS_ADWSoft_3D1",93)	GEMS_ADWSoft_3D1	71	147	f	\N	DA	1	DLXCalibrationDate	\N
538	(0047,"GEMS_ADWSoft_3D1",94)	(0047,"GEMS_ADWSoft_3D1",94)	GEMS_ADWSoft_3D1	71	148	f	\N	TM	1	DLXCalibrationTime	\N
539	(0047,"GEMS_ADWSoft_3D1",95)	(0047,"GEMS_ADWSoft_3D1",95)	GEMS_ADWSoft_3D1	71	149	f	\N	CS	1	DLXCalibrationStatus	\N
540	(0047,"GEMS_ADWSoft_3D1",96)	(0047,"GEMS_ADWSoft_3D1",96)	GEMS_ADWSoft_3D1	71	150	f	\N	IS	1-n	UsedFrames	\N
541	(0047,"GEMS_ADWSoft_3D1",98)	(0047,"GEMS_ADWSoft_3D1",98)	GEMS_ADWSoft_3D1	71	152	f	\N	US	1	TransformCount	\N
542	(0047,"GEMS_ADWSoft_3D1",99)	(0047,"GEMS_ADWSoft_3D1",99)	GEMS_ADWSoft_3D1	71	153	f	\N	SQ	1	TransformSequence	\N
543	(0047,"GEMS_ADWSoft_3D1",9A)	(0047,"GEMS_ADWSoft_3D1",9A)	GEMS_ADWSoft_3D1	71	154	f	\N	DS	9	TransformRotationMatrix	\N
544	(0047,"GEMS_ADWSoft_3D1",9B)	(0047,"GEMS_ADWSoft_3D1",9B)	GEMS_ADWSoft_3D1	71	155	f	\N	DS	3	TransformTranslationVector	\N
545	(0047,"GEMS_ADWSoft_3D1",9C)	(0047,"GEMS_ADWSoft_3D1",9C)	GEMS_ADWSoft_3D1	71	156	f	\N	LO	1	TransformLabel	\N
546	(0047,"GEMS_ADWSoft_3D1",B0)	(0047,"GEMS_ADWSoft_3D1",B0)	GEMS_ADWSoft_3D1	71	176	f	\N	SQ	1	WireframeList	\N
547	(0047,"GEMS_ADWSoft_3D1",B1)	(0047,"GEMS_ADWSoft_3D1",B1)	GEMS_ADWSoft_3D1	71	177	f	\N	US	1	WireframeCount	\N
548	(0047,"GEMS_ADWSoft_3D1",B2)	(0047,"GEMS_ADWSoft_3D1",B2)	GEMS_ADWSoft_3D1	71	178	f	\N	US	1	LocationSystem	\N
549	(0047,"GEMS_ADWSoft_3D1",B5)	(0047,"GEMS_ADWSoft_3D1",B5)	GEMS_ADWSoft_3D1	71	181	f	\N	LO	1	WireframeName	\N
550	(0047,"GEMS_ADWSoft_3D1",B6)	(0047,"GEMS_ADWSoft_3D1",B6)	GEMS_ADWSoft_3D1	71	182	f	\N	LO	1	WireframeGroupName	\N
551	(0047,"GEMS_ADWSoft_3D1",B7)	(0047,"GEMS_ADWSoft_3D1",B7)	GEMS_ADWSoft_3D1	71	183	f	\N	LO	1	WireframeColor	\N
552	(0047,"GEMS_ADWSoft_3D1",B8)	(0047,"GEMS_ADWSoft_3D1",B8)	GEMS_ADWSoft_3D1	71	184	f	\N	SL	1	WireframeAttributes	\N
553	(0047,"GEMS_ADWSoft_3D1",B9)	(0047,"GEMS_ADWSoft_3D1",B9)	GEMS_ADWSoft_3D1	71	185	f	\N	SL	1	WireframePointCount	\N
554	(0047,"GEMS_ADWSoft_3D1",BA)	(0047,"GEMS_ADWSoft_3D1",BA)	GEMS_ADWSoft_3D1	71	186	f	\N	SL	1	WireframeTimestamp	\N
555	(0047,"GEMS_ADWSoft_3D1",BB)	(0047,"GEMS_ADWSoft_3D1",BB)	GEMS_ADWSoft_3D1	71	187	f	\N	SQ	1	WireframePointList	\N
556	(0047,"GEMS_ADWSoft_3D1",BC)	(0047,"GEMS_ADWSoft_3D1",BC)	GEMS_ADWSoft_3D1	71	188	f	\N	DS	3	WireframePointsCoordinates	\N
557	(0047,"GEMS_ADWSoft_3D1",C0)	(0047,"GEMS_ADWSoft_3D1",C0)	GEMS_ADWSoft_3D1	71	192	f	\N	DS	3	VolumeUpperLeftHighCornerRAS	\N
558	(0047,"GEMS_ADWSoft_3D1",C1)	(0047,"GEMS_ADWSoft_3D1",C1)	GEMS_ADWSoft_3D1	71	193	f	\N	DS	9	VolumeSliceToRASRotationMatrix	\N
559	(0047,"GEMS_ADWSoft_3D1",C2)	(0047,"GEMS_ADWSoft_3D1",C2)	GEMS_ADWSoft_3D1	71	194	f	\N	DS	1	VolumeUpperLeftHighCornerTLOC	\N
560	(0047,"GEMS_ADWSoft_3D1",D1)	(0047,"GEMS_ADWSoft_3D1",D1)	GEMS_ADWSoft_3D1	71	209	f	\N	OB	1	VolumeSegmentList	\N
561	(0047,"GEMS_ADWSoft_3D1",D2)	(0047,"GEMS_ADWSoft_3D1",D2)	GEMS_ADWSoft_3D1	71	210	f	\N	OB	1	VolumeGradientList	\N
562	(0047,"GEMS_ADWSoft_3D1",D3)	(0047,"GEMS_ADWSoft_3D1",D3)	GEMS_ADWSoft_3D1	71	211	f	\N	OB	1	VolumeDensityList	\N
563	(0047,"GEMS_ADWSoft_3D1",D4)	(0047,"GEMS_ADWSoft_3D1",D4)	GEMS_ADWSoft_3D1	71	212	f	\N	OB	1	VolumeZPositionList	\N
564	(0047,"GEMS_ADWSoft_3D1",D5)	(0047,"GEMS_ADWSoft_3D1",D5)	GEMS_ADWSoft_3D1	71	213	f	\N	OB	1	VolumeOriginalIndexList	\N
565	(0039,"GEMS_ADWSoft_DPO",80)	(0039,"GEMS_ADWSoft_DPO",80)	GEMS_ADWSoft_DPO	57	128	f	\N	IS	1	PrivateEntityNumber	\N
566	(0039,"GEMS_ADWSoft_DPO",85)	(0039,"GEMS_ADWSoft_DPO",85)	GEMS_ADWSoft_DPO	57	133	f	\N	DA	1	PrivateEntityDate	\N
567	(0039,"GEMS_ADWSoft_DPO",90)	(0039,"GEMS_ADWSoft_DPO",90)	GEMS_ADWSoft_DPO	57	144	f	\N	TM	1	PrivateEntityTime	\N
568	(0039,"GEMS_ADWSoft_DPO",95)	(0039,"GEMS_ADWSoft_DPO",95)	GEMS_ADWSoft_DPO	57	149	f	\N	LO	1	PrivateEntityLaunchCommand	\N
569	(0039,"GEMS_ADWSoft_DPO",AA)	(0039,"GEMS_ADWSoft_DPO",AA)	GEMS_ADWSoft_DPO	57	170	f	\N	CS	1	PrivateEntityType	\N
570	(0033,"GEMS_CTHD_01",02)	(0033,"GEMS_CTHD_01",02)	GEMS_CTHD_01	51	2	f	\N	UN	1	Unknown	\N
571	(0037,"GEMS_DRS_1",10)	(0037,"GEMS_DRS_1",10)	GEMS_DRS_1	55	16	f	\N	LO	1	ReferringDepartment	\N
572	(0037,"GEMS_DRS_1",20)	(0037,"GEMS_DRS_1",20)	GEMS_DRS_1	55	32	f	\N	US	1	ScreenNumber	\N
573	(0037,"GEMS_DRS_1",40)	(0037,"GEMS_DRS_1",40)	GEMS_DRS_1	55	64	f	\N	SH	1	LeftOrientation	\N
574	(0037,"GEMS_DRS_1",42)	(0037,"GEMS_DRS_1",42)	GEMS_DRS_1	55	66	f	\N	SH	1	RightOrientation	\N
575	(0037,"GEMS_DRS_1",50)	(0037,"GEMS_DRS_1",50)	GEMS_DRS_1	55	80	f	\N	CS	1	Inversion	\N
576	(0037,"GEMS_DRS_1",60)	(0037,"GEMS_DRS_1",60)	GEMS_DRS_1	55	96	f	\N	US	1	DSA	\N
577	(0009,"GEMS_GENIE_1",10)	(0009,"GEMS_GENIE_1",10)	GEMS_GENIE_1	9	16	f	\N	LO	1	Unknown	\N
578	(0009,"GEMS_GENIE_1",11)	(0009,"GEMS_GENIE_1",11)	GEMS_GENIE_1	9	17	f	\N	SL	1	StudyFlags	\N
579	(0009,"GEMS_GENIE_1",12)	(0009,"GEMS_GENIE_1",12)	GEMS_GENIE_1	9	18	f	\N	SL	1	StudyType	\N
580	(0009,"GEMS_GENIE_1",1e)	(0009,"GEMS_GENIE_1",1e)	GEMS_GENIE_1	9	30	f	\N	UI	1	Unknown	\N
581	(0009,"GEMS_GENIE_1",20)	(0009,"GEMS_GENIE_1",20)	GEMS_GENIE_1	9	32	f	\N	LO	1	Unknown	\N
582	(0009,"GEMS_GENIE_1",21)	(0009,"GEMS_GENIE_1",21)	GEMS_GENIE_1	9	33	f	\N	SL	1	SeriesFlags	\N
583	(0009,"GEMS_GENIE_1",22)	(0009,"GEMS_GENIE_1",22)	GEMS_GENIE_1	9	34	f	\N	SH	1	UserOrientation	\N
584	(0009,"GEMS_GENIE_1",23)	(0009,"GEMS_GENIE_1",23)	GEMS_GENIE_1	9	35	f	\N	SL	1	InitiationType	\N
585	(0009,"GEMS_GENIE_1",24)	(0009,"GEMS_GENIE_1",24)	GEMS_GENIE_1	9	36	f	\N	SL	1	InitiationDelay	\N
586	(0009,"GEMS_GENIE_1",25)	(0009,"GEMS_GENIE_1",25)	GEMS_GENIE_1	9	37	f	\N	SL	1	InitiationCountRate	\N
587	(0009,"GEMS_GENIE_1",26)	(0009,"GEMS_GENIE_1",26)	GEMS_GENIE_1	9	38	f	\N	SL	1	NumberEnergySets	\N
588	(0009,"GEMS_GENIE_1",27)	(0009,"GEMS_GENIE_1",27)	GEMS_GENIE_1	9	39	f	\N	SL	1	NumberDetectors	\N
589	(0009,"GEMS_GENIE_1",29)	(0009,"GEMS_GENIE_1",29)	GEMS_GENIE_1	9	41	f	\N	SL	1	Unknown	\N
590	(0009,"GEMS_GENIE_1",2a)	(0009,"GEMS_GENIE_1",2a)	GEMS_GENIE_1	9	42	f	\N	SL	1	Unknown	\N
591	(0009,"GEMS_GENIE_1",2c)	(0009,"GEMS_GENIE_1",2c)	GEMS_GENIE_1	9	44	f	\N	LO	1	SeriesComments	\N
592	(0009,"GEMS_GENIE_1",2d)	(0009,"GEMS_GENIE_1",2d)	GEMS_GENIE_1	9	45	f	\N	SL	1	TrackBeatAverage	\N
593	(0009,"GEMS_GENIE_1",2e)	(0009,"GEMS_GENIE_1",2e)	GEMS_GENIE_1	9	46	f	\N	FD	1	DistancePrescribed	\N
594	(0009,"GEMS_GENIE_1",30)	(0009,"GEMS_GENIE_1",30)	GEMS_GENIE_1	9	48	f	\N	LO	1	Unknown	\N
595	(0009,"GEMS_GENIE_1",35)	(0009,"GEMS_GENIE_1",35)	GEMS_GENIE_1	9	53	f	\N	SL	1	GantryLocusType	\N
596	(0009,"GEMS_GENIE_1",37)	(0009,"GEMS_GENIE_1",37)	GEMS_GENIE_1	9	55	f	\N	SL	1	StartingHeartRate	\N
597	(0009,"GEMS_GENIE_1",38)	(0009,"GEMS_GENIE_1",38)	GEMS_GENIE_1	9	56	f	\N	SL	1	RRWindowWidth	\N
598	(0009,"GEMS_GENIE_1",39)	(0009,"GEMS_GENIE_1",39)	GEMS_GENIE_1	9	57	f	\N	SL	1	RRWindowOffset	\N
599	(0009,"GEMS_GENIE_1",3a)	(0009,"GEMS_GENIE_1",3a)	GEMS_GENIE_1	9	58	f	\N	SL	1	PercentCycleImaged	\N
600	(0009,"GEMS_GENIE_1",40)	(0009,"GEMS_GENIE_1",40)	GEMS_GENIE_1	9	64	f	\N	LO	1	Unknown	\N
601	(0009,"GEMS_GENIE_1",41)	(0009,"GEMS_GENIE_1",41)	GEMS_GENIE_1	9	65	f	\N	SL	1	PatientFlags	\N
602	(0009,"GEMS_GENIE_1",42)	(0009,"GEMS_GENIE_1",42)	GEMS_GENIE_1	9	66	f	\N	DA	1	PatientCreationDate	\N
603	(0009,"GEMS_GENIE_1",43)	(0009,"GEMS_GENIE_1",43)	GEMS_GENIE_1	9	67	f	\N	TM	1	PatientCreationTime	\N
604	(0011,"GEMS_GENIE_1",0a)	(0011,"GEMS_GENIE_1",0a)	GEMS_GENIE_1	17	10	f	\N	SL	1	SeriesType	\N
605	(0011,"GEMS_GENIE_1",0b)	(0011,"GEMS_GENIE_1",0b)	GEMS_GENIE_1	17	11	f	\N	SL	1	EffectiveSeriesDuration	\N
606	(0011,"GEMS_GENIE_1",0c)	(0011,"GEMS_GENIE_1",0c)	GEMS_GENIE_1	17	12	f	\N	SL	1	NumBeats	\N
607	(0011,"GEMS_GENIE_1",0d)	(0011,"GEMS_GENIE_1",0d)	GEMS_GENIE_1	17	13	f	\N	LO	1	RadioNuclideName	\N
608	(0011,"GEMS_GENIE_1",10)	(0011,"GEMS_GENIE_1",10)	GEMS_GENIE_1	17	16	f	\N	LO	1	Unknown	\N
609	(0011,"GEMS_GENIE_1",12)	(0011,"GEMS_GENIE_1",12)	GEMS_GENIE_1	17	18	f	\N	LO	1	DatasetName	\N
610	(0011,"GEMS_GENIE_1",13)	(0011,"GEMS_GENIE_1",13)	GEMS_GENIE_1	17	19	f	\N	SL	1	DatasetType	\N
611	(0011,"GEMS_GENIE_1",15)	(0011,"GEMS_GENIE_1",15)	GEMS_GENIE_1	17	21	f	\N	SL	1	DetectorNumber	\N
612	(0011,"GEMS_GENIE_1",16)	(0011,"GEMS_GENIE_1",16)	GEMS_GENIE_1	17	22	f	\N	SL	1	EnergyNumber	\N
613	(0011,"GEMS_GENIE_1",17)	(0011,"GEMS_GENIE_1",17)	GEMS_GENIE_1	17	23	f	\N	SL	1	RRIntervalWindowNumber	\N
614	(0011,"GEMS_GENIE_1",18)	(0011,"GEMS_GENIE_1",18)	GEMS_GENIE_1	17	24	f	\N	SL	1	MGBinNumber	\N
615	(0011,"GEMS_GENIE_1",19)	(0011,"GEMS_GENIE_1",19)	GEMS_GENIE_1	17	25	f	\N	FD	1	RadiusOfRotation	\N
616	(0011,"GEMS_GENIE_1",1a)	(0011,"GEMS_GENIE_1",1a)	GEMS_GENIE_1	17	26	f	\N	SL	1	DetectorCountZone	\N
617	(0011,"GEMS_GENIE_1",1b)	(0011,"GEMS_GENIE_1",1b)	GEMS_GENIE_1	17	27	f	\N	SL	1	NumEnergyWindows	\N
618	(0011,"GEMS_GENIE_1",1c)	(0011,"GEMS_GENIE_1",1c)	GEMS_GENIE_1	17	28	f	\N	SL	4	EnergyOffset	\N
619	(0011,"GEMS_GENIE_1",1d)	(0011,"GEMS_GENIE_1",1d)	GEMS_GENIE_1	17	29	f	\N	SL	1	EnergyRange	\N
620	(0011,"GEMS_GENIE_1",1f)	(0011,"GEMS_GENIE_1",1f)	GEMS_GENIE_1	17	31	f	\N	SL	1	ImageOrientation	\N
621	(0011,"GEMS_GENIE_1",23)	(0011,"GEMS_GENIE_1",23)	GEMS_GENIE_1	17	35	f	\N	SL	1	UseFOVMask	\N
622	(0011,"GEMS_GENIE_1",24)	(0011,"GEMS_GENIE_1",24)	GEMS_GENIE_1	17	36	f	\N	SL	1	FOVMaskYCutoffAngle	\N
623	(0011,"GEMS_GENIE_1",25)	(0011,"GEMS_GENIE_1",25)	GEMS_GENIE_1	17	37	f	\N	SL	1	FOVMaskCutoffAngle	\N
624	(0011,"GEMS_GENIE_1",26)	(0011,"GEMS_GENIE_1",26)	GEMS_GENIE_1	17	38	f	\N	SL	1	TableOrientation	\N
625	(0011,"GEMS_GENIE_1",27)	(0011,"GEMS_GENIE_1",27)	GEMS_GENIE_1	17	39	f	\N	SL	2	ROITopLeft	\N
626	(0011,"GEMS_GENIE_1",28)	(0011,"GEMS_GENIE_1",28)	GEMS_GENIE_1	17	40	f	\N	SL	2	ROIBottomRight	\N
627	(0011,"GEMS_GENIE_1",30)	(0011,"GEMS_GENIE_1",30)	GEMS_GENIE_1	17	48	f	\N	LO	1	Unknown	\N
628	(0011,"GEMS_GENIE_1",33)	(0011,"GEMS_GENIE_1",33)	GEMS_GENIE_1	17	51	f	\N	LO	1	EnergyCorrectName	\N
629	(0011,"GEMS_GENIE_1",34)	(0011,"GEMS_GENIE_1",34)	GEMS_GENIE_1	17	52	f	\N	LO	1	SpatialCorrectName	\N
630	(0011,"GEMS_GENIE_1",35)	(0011,"GEMS_GENIE_1",35)	GEMS_GENIE_1	17	53	f	\N	LO	1	TuningCalibName	\N
631	(0011,"GEMS_GENIE_1",36)	(0011,"GEMS_GENIE_1",36)	GEMS_GENIE_1	17	54	f	\N	LO	1	UniformityCorrectName	\N
632	(0011,"GEMS_GENIE_1",37)	(0011,"GEMS_GENIE_1",37)	GEMS_GENIE_1	17	55	f	\N	LO	1	AcquisitionSpecificCorrectName	\N
633	(0011,"GEMS_GENIE_1",38)	(0011,"GEMS_GENIE_1",38)	GEMS_GENIE_1	17	56	f	\N	SL	1	ByteOrder	\N
634	(0011,"GEMS_GENIE_1",3a)	(0011,"GEMS_GENIE_1",3a)	GEMS_GENIE_1	17	58	f	\N	SL	1	PictureFormat	\N
635	(0011,"GEMS_GENIE_1",3b)	(0011,"GEMS_GENIE_1",3b)	GEMS_GENIE_1	17	59	f	\N	FD	1	PixelScale	\N
636	(0011,"GEMS_GENIE_1",3c)	(0011,"GEMS_GENIE_1",3c)	GEMS_GENIE_1	17	60	f	\N	FD	1	PixelOffset	\N
637	(0011,"GEMS_GENIE_1",3e)	(0011,"GEMS_GENIE_1",3e)	GEMS_GENIE_1	17	62	f	\N	SL	1	FOVShape	\N
638	(0011,"GEMS_GENIE_1",3f)	(0011,"GEMS_GENIE_1",3f)	GEMS_GENIE_1	17	63	f	\N	SL	1	DatasetFlags	\N
639	(0011,"GEMS_GENIE_1",44)	(0011,"GEMS_GENIE_1",44)	GEMS_GENIE_1	17	68	f	\N	FD	1	ThresholdCenter	\N
640	(0011,"GEMS_GENIE_1",45)	(0011,"GEMS_GENIE_1",45)	GEMS_GENIE_1	17	69	f	\N	FD	1	ThresholdWidth	\N
641	(0011,"GEMS_GENIE_1",46)	(0011,"GEMS_GENIE_1",46)	GEMS_GENIE_1	17	70	f	\N	SL	1	InterpolationType	\N
642	(0011,"GEMS_GENIE_1",55)	(0011,"GEMS_GENIE_1",55)	GEMS_GENIE_1	17	85	f	\N	FD	1	Period	\N
643	(0011,"GEMS_GENIE_1",56)	(0011,"GEMS_GENIE_1",56)	GEMS_GENIE_1	17	86	f	\N	FD	1	ElapsedTime	\N
644	(0013,"GEMS_GENIE_1",10)	(0013,"GEMS_GENIE_1",10)	GEMS_GENIE_1	19	16	f	\N	FD	2	DigitalFOV	\N
645	(0013,"GEMS_GENIE_1",11)	(0013,"GEMS_GENIE_1",11)	GEMS_GENIE_1	19	17	f	\N	SL	1	Unknown	\N
646	(0013,"GEMS_GENIE_1",12)	(0013,"GEMS_GENIE_1",12)	GEMS_GENIE_1	19	18	f	\N	SL	1	Unknown	\N
647	(0013,"GEMS_GENIE_1",16)	(0013,"GEMS_GENIE_1",16)	GEMS_GENIE_1	19	22	f	\N	SL	1	AutoTrackPeak	\N
648	(0013,"GEMS_GENIE_1",17)	(0013,"GEMS_GENIE_1",17)	GEMS_GENIE_1	19	23	f	\N	SL	1	AutoTrackWidth	\N
649	(0013,"GEMS_GENIE_1",18)	(0013,"GEMS_GENIE_1",18)	GEMS_GENIE_1	19	24	f	\N	FD	1	TransmissionScanTime	\N
650	(0013,"GEMS_GENIE_1",19)	(0013,"GEMS_GENIE_1",19)	GEMS_GENIE_1	19	25	f	\N	FD	1	TransmissionMaskWidth	\N
651	(0013,"GEMS_GENIE_1",1a)	(0013,"GEMS_GENIE_1",1a)	GEMS_GENIE_1	19	26	f	\N	FD	1	CopperAttenuatorThickness	\N
652	(0013,"GEMS_GENIE_1",1c)	(0013,"GEMS_GENIE_1",1c)	GEMS_GENIE_1	19	28	f	\N	FD	1	Unknown	\N
653	(0013,"GEMS_GENIE_1",1d)	(0013,"GEMS_GENIE_1",1d)	GEMS_GENIE_1	19	29	f	\N	FD	1	Unknown	\N
654	(0013,"GEMS_GENIE_1",1e)	(0013,"GEMS_GENIE_1",1e)	GEMS_GENIE_1	19	30	f	\N	FD	1-n	TomoViewOffset	\N
655	(0013,"GEMS_GENIE_1",26)	(0013,"GEMS_GENIE_1",26)	GEMS_GENIE_1	19	38	f	\N	LT	1	StudyComments	\N
656	(0033,"GEMS_GNHD_01",01)	(0033,"GEMS_GNHD_01",01)	GEMS_GNHD_01	51	1	f	\N	UN	1	Unknown	\N
657	(0033,"GEMS_GNHD_01",02)	(0033,"GEMS_GNHD_01",02)	GEMS_GNHD_01	51	2	f	\N	UN	1	Unknown	\N
10965	(0119,"MRSC",1140)	(0119,"MRSC",40)	MRSC	281	64	t	11	LO	1	GradientMatrixMethod	K
672	(0009,"GEMS_IDEN_01",e8)	(0009,"GEMS_IDEN_01",e8)	GEMS_IDEN_01	9	232	f	\N	UL	1	Unknown	\N
659	(0009,"GEMS_IDEN_01",02)	(0009,"GEMS_IDEN_01",02)	GEMS_IDEN_01	9	2	f	\N	SH	1	SuiteId	K
660	(0009,"GEMS_IDEN_01",04)	(0009,"GEMS_IDEN_01",04)	GEMS_IDEN_01	9	4	f	\N	SH	1	ProductId	K
661	(0009,"GEMS_IDEN_01",17)	(0009,"GEMS_IDEN_01",17)	GEMS_IDEN_01	9	23	f	\N	LT	1	Unknown	X
662	(0009,"GEMS_IDEN_01",1a)	(0009,"GEMS_IDEN_01",1a)	GEMS_IDEN_01	9	26	f	\N	US	1	Unknown	X
663	(0009,"GEMS_IDEN_01",20)	(0009,"GEMS_IDEN_01",20)	GEMS_IDEN_01	9	32	f	\N	US	1	Unknown	X
664	(0009,"GEMS_IDEN_01",27)	(0009,"GEMS_IDEN_01",27)	GEMS_IDEN_01	9	39	f	\N	SL	1	ImageActualDate	X
665	(0009,"GEMS_IDEN_01",2f)	(0009,"GEMS_IDEN_01",2f)	GEMS_IDEN_01	9	47	f	\N	LT	1	Unknown	X
666	(0009,"GEMS_IDEN_01",30)	(0009,"GEMS_IDEN_01",30)	GEMS_IDEN_01	9	48	f	\N	SH	1	ServiceId	R
667	(0009,"GEMS_IDEN_01",31)	(0009,"GEMS_IDEN_01",31)	GEMS_IDEN_01	9	49	f	\N	SH	1	MobileLocationNumber	X
668	(0009,"GEMS_IDEN_01",e2)	(0009,"GEMS_IDEN_01",e2)	GEMS_IDEN_01	9	226	f	\N	LT	1	Unknown	X
669	(0009,"GEMS_IDEN_01",e3)	(0009,"GEMS_IDEN_01",e3)	GEMS_IDEN_01	9	227	f	\N	UI	1	EquipmentUID	X
670	(0009,"GEMS_IDEN_01",e6)	(0009,"GEMS_IDEN_01",e6)	GEMS_IDEN_01	9	230	f	\N	SH	1	GenesisVersionNow	R
671	(0009,"GEMS_IDEN_01",e7)	(0009,"GEMS_IDEN_01",e7)	GEMS_IDEN_01	9	231	f	\N	UL	1	ExamRecordChecksum	X
673	(0009,"GEMS_IDEN_01",e9)	(0009,"GEMS_IDEN_01",e9)	GEMS_IDEN_01	9	233	f	\N	SL	1	ActualSeriesDataTimeStamp	X
674	(0027,"GEMS_IMAG_01",06)	(0027,"GEMS_IMAG_01",06)	GEMS_IMAG_01	39	6	f	\N	SL	1	ImageArchiveFlag	X
675	(0027,"GEMS_IMAG_01",10)	(0027,"GEMS_IMAG_01",10)	GEMS_IMAG_01	39	16	f	\N	SS	1	ScoutType	KB
677	(0027,"GEMS_IMAG_01",1d)	(0027,"GEMS_IMAG_01",1d)	GEMS_IMAG_01	39	29	f	\N	SS	1	VmaPhase	KB
678	(0027,"GEMS_IMAG_01",1e)	(0027,"GEMS_IMAG_01",1e)	GEMS_IMAG_01	39	30	f	\N	SL	1	VmaMod	KB
679	(0027,"GEMS_IMAG_01",1f)	(0027,"GEMS_IMAG_01",1f)	GEMS_IMAG_01	39	31	f	\N	SL	1	VmaClip	KB
680	(0027,"GEMS_IMAG_01",20)	(0027,"GEMS_IMAG_01",20)	GEMS_IMAG_01	39	32	f	\N	SS	1	SmartScanOnOffFlag	KB
681	(0027,"GEMS_IMAG_01",30)	(0027,"GEMS_IMAG_01",30)	GEMS_IMAG_01	39	48	f	\N	SH	1	ForeignImageRevision	R
682	(0027,"GEMS_IMAG_01",31)	(0027,"GEMS_IMAG_01",31)	GEMS_IMAG_01	39	49	f	\N	SS	1	ImagingMode	K
683	(0027,"GEMS_IMAG_01",32)	(0027,"GEMS_IMAG_01",32)	GEMS_IMAG_01	39	50	f	\N	SS	1	PulseSequence	K
684	(0027,"GEMS_IMAG_01",33)	(0027,"GEMS_IMAG_01",33)	GEMS_IMAG_01	39	51	f	\N	SL	1	ImagingOptions	K
685	(0027,"GEMS_IMAG_01",35)	(0027,"GEMS_IMAG_01",35)	GEMS_IMAG_01	39	53	f	\N	SS	1	PlaneType	KB
686	(0027,"GEMS_IMAG_01",36)	(0027,"GEMS_IMAG_01",36)	GEMS_IMAG_01	39	54	f	\N	SL	1	ObliquePlane	K
687	(0027,"GEMS_IMAG_01",40)	(0027,"GEMS_IMAG_01",40)	GEMS_IMAG_01	39	64	f	\N	SH	1	RASLetterOfImageLocation	R
688	(0027,"GEMS_IMAG_01",41)	(0027,"GEMS_IMAG_01",41)	GEMS_IMAG_01	39	65	f	\N	FL	1	ImageLocation	KB
689	(0027,"GEMS_IMAG_01",42)	(0027,"GEMS_IMAG_01",42)	GEMS_IMAG_01	39	66	f	\N	FL	1	CenterRCoordOfPlaneImage	KB
690	(0027,"GEMS_IMAG_01",43)	(0027,"GEMS_IMAG_01",43)	GEMS_IMAG_01	39	67	f	\N	FL	1	CenterACoordOfPlaneImage	KB
692	(0027,"GEMS_IMAG_01",45)	(0027,"GEMS_IMAG_01",45)	GEMS_IMAG_01	39	69	f	\N	FL	1	NormalRCoord	KB
693	(0027,"GEMS_IMAG_01",46)	(0027,"GEMS_IMAG_01",46)	GEMS_IMAG_01	39	70	f	\N	FL	1	NormalACoord	KB
694	(0027,"GEMS_IMAG_01",47)	(0027,"GEMS_IMAG_01",47)	GEMS_IMAG_01	39	71	f	\N	FL	1	NormalSCoord	KB
695	(0027,"GEMS_IMAG_01",48)	(0027,"GEMS_IMAG_01",48)	GEMS_IMAG_01	39	72	f	\N	FL	1	RCoordOfTopRightCorner	KB
696	(0027,"GEMS_IMAG_01",49)	(0027,"GEMS_IMAG_01",49)	GEMS_IMAG_01	39	73	f	\N	FL	1	ACoordOfTopRightCorner	KB
697	(0027,"GEMS_IMAG_01",4a)	(0027,"GEMS_IMAG_01",4a)	GEMS_IMAG_01	39	74	f	\N	FL	1	SCoordOfTopRightCorner	KB
698	(0027,"GEMS_IMAG_01",4b)	(0027,"GEMS_IMAG_01",4b)	GEMS_IMAG_01	39	75	f	\N	FL	1	RCoordOfBottomRightCorner	KB
699	(0027,"GEMS_IMAG_01",4c)	(0027,"GEMS_IMAG_01",4c)	GEMS_IMAG_01	39	76	f	\N	FL	1	ACoordOfBottomRightCorner	KB
700	(0027,"GEMS_IMAG_01",4d)	(0027,"GEMS_IMAG_01",4d)	GEMS_IMAG_01	39	77	f	\N	FL	1	SCoordOfBottomRightCorner	KB
701	(0027,"GEMS_IMAG_01",50)	(0027,"GEMS_IMAG_01",50)	GEMS_IMAG_01	39	80	f	\N	FL	1	TableStartLocation	KB
702	(0027,"GEMS_IMAG_01",51)	(0027,"GEMS_IMAG_01",51)	GEMS_IMAG_01	39	81	f	\N	FL	1	TableEndLocation	KB
703	(0027,"GEMS_IMAG_01",52)	(0027,"GEMS_IMAG_01",52)	GEMS_IMAG_01	39	82	f	\N	SH	1	RASLetterForSideOfImage	R
704	(0027,"GEMS_IMAG_01",53)	(0027,"GEMS_IMAG_01",53)	GEMS_IMAG_01	39	83	f	\N	SH	1	RASLetterForAnteriorPosterior	R
705	(0027,"GEMS_IMAG_01",54)	(0027,"GEMS_IMAG_01",54)	GEMS_IMAG_01	39	84	f	\N	SH	1	RASLetterForScoutStartLoc	R
706	(0027,"GEMS_IMAG_01",55)	(0027,"GEMS_IMAG_01",55)	GEMS_IMAG_01	39	85	f	\N	SH	1	RASLetterForScoutEndLoc	R
707	(0027,"GEMS_IMAG_01",60)	(0027,"GEMS_IMAG_01",60)	GEMS_IMAG_01	39	96	f	\N	FL	1	ImageDimensionX	K
708	(0027,"GEMS_IMAG_01",61)	(0027,"GEMS_IMAG_01",61)	GEMS_IMAG_01	39	97	f	\N	FL	1	ImageDimensionY	K
709	(0027,"GEMS_IMAG_01",62)	(0027,"GEMS_IMAG_01",62)	GEMS_IMAG_01	39	98	f	\N	FL	1	NumberOfExcitations	K
710	(0029,"GEMS_IMPS_01",04)	(0029,"GEMS_IMPS_01",04)	GEMS_IMPS_01	41	4	f	\N	SL	1	LowerRangeOfPixels	KB
711	(0029,"GEMS_IMPS_01",05)	(0029,"GEMS_IMPS_01",05)	GEMS_IMPS_01	41	5	f	\N	DS	1	LowerRangeOfPixels	KB
713	(0029,"GEMS_IMPS_01",07)	(0029,"GEMS_IMPS_01",07)	GEMS_IMPS_01	41	7	f	\N	SL	1	LowerRangeOfPixels	KB
714	(0029,"GEMS_IMPS_01",08)	(0029,"GEMS_IMPS_01",08)	GEMS_IMPS_01	41	8	f	\N	SH	1	LowerRangeOfPixels	R
715	(0029,"GEMS_IMPS_01",09)	(0029,"GEMS_IMPS_01",09)	GEMS_IMPS_01	41	9	f	\N	SH	1	LowerRangeOfPixels	R
10966	(0119,"MRSC",1141)	(0119,"MRSC",41)	MRSC	281	65	t	11	DS	1-n	GradientMatrix	K
717	(0029,"GEMS_IMPS_01",15)	(0029,"GEMS_IMPS_01",15)	GEMS_IMPS_01	41	21	f	\N	SL	1	LowerRangeOfPixels	K
718	(0029,"GEMS_IMPS_01",16)	(0029,"GEMS_IMPS_01",16)	GEMS_IMPS_01	41	22	f	\N	SL	1	LowerRangeOfPixels	K
719	(0029,"GEMS_IMPS_01",17)	(0029,"GEMS_IMPS_01",17)	GEMS_IMPS_01	41	23	f	\N	SL	1	LowerRangeOfPixels	K
720	(0029,"GEMS_IMPS_01",18)	(0029,"GEMS_IMPS_01",18)	GEMS_IMPS_01	41	24	f	\N	SL	1	UpperRangeOfPixels	K
721	(0029,"GEMS_IMPS_01",1a)	(0029,"GEMS_IMPS_01",1a)	GEMS_IMPS_01	41	26	f	\N	SL	1	LengthOfTotalHeaderInBytes	X
722	(0029,"GEMS_IMPS_01",26)	(0029,"GEMS_IMPS_01",26)	GEMS_IMPS_01	41	38	f	\N	SS	1	VersionOfHeaderStructure	KB
723	(0029,"GEMS_IMPS_01",34)	(0029,"GEMS_IMPS_01",34)	GEMS_IMPS_01	41	52	f	\N	SL	1	AdvantageCompOverflow	KB
724	(0029,"GEMS_IMPS_01",35)	(0029,"GEMS_IMPS_01",35)	GEMS_IMPS_01	41	53	f	\N	SL	1	AdvantageCompUnderflow	KB
725	(0043,"GEMS_PARM_01",01)	(0043,"GEMS_PARM_01",01)	GEMS_PARM_01	67	1	f	\N	SS	1	BitmapOfPrescanOptions	K
726	(0043,"GEMS_PARM_01",02)	(0043,"GEMS_PARM_01",02)	GEMS_PARM_01	67	2	f	\N	SS	1	GradientOffsetInX	K
728	(0043,"GEMS_PARM_01",04)	(0043,"GEMS_PARM_01",04)	GEMS_PARM_01	67	4	f	\N	SS	1	GradientOffsetInZ	K
729	(0043,"GEMS_PARM_01",05)	(0043,"GEMS_PARM_01",05)	GEMS_PARM_01	67	5	f	\N	SS	1	ImageIsOriginalOrUnoriginal	K
730	(0043,"GEMS_PARM_01",06)	(0043,"GEMS_PARM_01",06)	GEMS_PARM_01	67	6	f	\N	SS	1	NumberOfEPIShots	K
731	(0043,"GEMS_PARM_01",07)	(0043,"GEMS_PARM_01",07)	GEMS_PARM_01	67	7	f	\N	SS	1	ViewsPerSegment	K
732	(0043,"GEMS_PARM_01",08)	(0043,"GEMS_PARM_01",08)	GEMS_PARM_01	67	8	f	\N	SS	1	RespiratoryRateInBPM	K
733	(0043,"GEMS_PARM_01",09)	(0043,"GEMS_PARM_01",09)	GEMS_PARM_01	67	9	f	\N	SS	1	RespiratoryTriggerPoint	K
734	(0043,"GEMS_PARM_01",0a)	(0043,"GEMS_PARM_01",0a)	GEMS_PARM_01	67	10	f	\N	SS	1	TypeOfReceiverUsed	K
735	(0043,"GEMS_PARM_01",0b)	(0043,"GEMS_PARM_01",0b)	GEMS_PARM_01	67	11	f	\N	DS	1	PeakRateOfChangeOfGradientField	K
736	(0043,"GEMS_PARM_01",0c)	(0043,"GEMS_PARM_01",0c)	GEMS_PARM_01	67	12	f	\N	DS	1	LimitsInUnitsOfPercent	KB
737	(0043,"GEMS_PARM_01",0d)	(0043,"GEMS_PARM_01",0d)	GEMS_PARM_01	67	13	f	\N	DS	1	PSDEstimatedLimit	KB
738	(0043,"GEMS_PARM_01",0e)	(0043,"GEMS_PARM_01",0e)	GEMS_PARM_01	67	14	f	\N	DS	1	PSDEstimatedLimitInTeslaPerSecond	KB
739	(0043,"GEMS_PARM_01",0f)	(0043,"GEMS_PARM_01",0f)	GEMS_PARM_01	67	15	f	\N	DS	1	SARAvgHead	KB
740	(0043,"GEMS_PARM_01",10)	(0043,"GEMS_PARM_01",10)	GEMS_PARM_01	67	16	f	\N	US	1	WindowValue	KB
741	(0043,"GEMS_PARM_01",11)	(0043,"GEMS_PARM_01",11)	GEMS_PARM_01	67	17	f	\N	US	1	TotalInputViews	KB
742	(0043,"GEMS_PARM_01",12)	(0043,"GEMS_PARM_01",12)	GEMS_PARM_01	67	18	f	\N	SS	3	XrayChain	KB
743	(0043,"GEMS_PARM_01",13)	(0043,"GEMS_PARM_01",13)	GEMS_PARM_01	67	19	f	\N	SS	5	ReconKernelParameters	KB
744	(0043,"GEMS_PARM_01",14)	(0043,"GEMS_PARM_01",14)	GEMS_PARM_01	67	20	f	\N	SS	3	CalibrationParameters	KB
745	(0043,"GEMS_PARM_01",15)	(0043,"GEMS_PARM_01",15)	GEMS_PARM_01	67	21	f	\N	SS	3	TotalOutputViews	KB
746	(0043,"GEMS_PARM_01",16)	(0043,"GEMS_PARM_01",16)	GEMS_PARM_01	67	22	f	\N	SS	5	NumberOfOverranges	KB
748	(0043,"GEMS_PARM_01",18)	(0043,"GEMS_PARM_01",18)	GEMS_PARM_01	67	24	f	\N	DS	3	BBH Coefficients	KB
749	(0043,"GEMS_PARM_01",19)	(0043,"GEMS_PARM_01",19)	GEMS_PARM_01	67	25	f	\N	SS	1	NumberOfBBHChainsToBlend	KB
750	(0043,"GEMS_PARM_01",1a)	(0043,"GEMS_PARM_01",1a)	GEMS_PARM_01	67	26	f	\N	SL	1	StartingChannelNumber	KB
751	(0043,"GEMS_PARM_01",1b)	(0043,"GEMS_PARM_01",1b)	GEMS_PARM_01	67	27	f	\N	SS	1	PPScanParameters	KB
752	(0043,"GEMS_PARM_01",1c)	(0043,"GEMS_PARM_01",1c)	GEMS_PARM_01	67	28	f	\N	SS	1	GEImageIntegrity	KB
753	(0043,"GEMS_PARM_01",1d)	(0043,"GEMS_PARM_01",1d)	GEMS_PARM_01	67	29	f	\N	SS	1	LevelValue	KB
754	(0043,"GEMS_PARM_01",1e)	(0043,"GEMS_PARM_01",1e)	GEMS_PARM_01	67	30	f	\N	DS	1	DeltaStartTime	R
755	(0043,"GEMS_PARM_01",1f)	(0043,"GEMS_PARM_01",1f)	GEMS_PARM_01	67	31	f	\N	SL	1	MaxOverrangesInAView	KB
756	(0043,"GEMS_PARM_01",20)	(0043,"GEMS_PARM_01",20)	GEMS_PARM_01	67	32	f	\N	DS	1	AvgOverrangesAllViews	KB
757	(0043,"GEMS_PARM_01",21)	(0043,"GEMS_PARM_01",21)	GEMS_PARM_01	67	33	f	\N	SS	1	CorrectedAfterglowTerms	KB
758	(0043,"GEMS_PARM_01",25)	(0043,"GEMS_PARM_01",25)	GEMS_PARM_01	67	37	f	\N	SS	6	ReferenceChannels	KB
759	(0043,"GEMS_PARM_01",26)	(0043,"GEMS_PARM_01",26)	GEMS_PARM_01	67	38	f	\N	US	6	NoViewsRefChannelsBlocked	KB
760	(0043,"GEMS_PARM_01",27)	(0043,"GEMS_PARM_01",27)	GEMS_PARM_01	67	39	f	\N	SH	1	ScanPitchRatio	KB
761	(0043,"GEMS_PARM_01",28)	(0043,"GEMS_PARM_01",28)	GEMS_PARM_01	67	40	f	\N	OB	1	UniqueImageIdentifier	X
762	(0043,"GEMS_PARM_01",29)	(0043,"GEMS_PARM_01",29)	GEMS_PARM_01	67	41	f	\N	OB	1	HistogramTables	X
763	(0043,"GEMS_PARM_01",2a)	(0043,"GEMS_PARM_01",2a)	GEMS_PARM_01	67	42	f	\N	OB	1	UserDefinedData	X
764	(0043,"GEMS_PARM_01",2b)	(0043,"GEMS_PARM_01",2b)	GEMS_PARM_01	67	43	f	\N	SS	4	PrivateScanOptions	R
765	(0043,"GEMS_PARM_01",2c)	(0043,"GEMS_PARM_01",2c)	GEMS_PARM_01	67	44	f	\N	SS	1	EffectiveEchoSpacing	K
767	(0043,"GEMS_PARM_01",2e)	(0043,"GEMS_PARM_01",2e)	GEMS_PARM_01	67	46	f	\N	SH	1	StringSlopField2	R
768	(0043,"GEMS_PARM_01",2f)	(0043,"GEMS_PARM_01",2f)	GEMS_PARM_01	67	47	f	\N	SS	1	RawDataType	K
769	(0043,"GEMS_PARM_01",30)	(0043,"GEMS_PARM_01",30)	GEMS_PARM_01	67	48	f	\N	SS	1	RawDataType	K
770	(0043,"GEMS_PARM_01",31)	(0043,"GEMS_PARM_01",31)	GEMS_PARM_01	67	49	f	\N	DS	2	RACoordOfTargetReconCentre	KB
771	(0043,"GEMS_PARM_01",32)	(0043,"GEMS_PARM_01",32)	GEMS_PARM_01	67	50	f	\N	SS	1	RawDataType	K
772	(0043,"GEMS_PARM_01",33)	(0043,"GEMS_PARM_01",33)	GEMS_PARM_01	67	51	f	\N	FL	1	NegScanSpacing	K
773	(0043,"GEMS_PARM_01",34)	(0043,"GEMS_PARM_01",34)	GEMS_PARM_01	67	52	f	\N	IS	1	OffsetFrequency	K
774	(0043,"GEMS_PARM_01",35)	(0043,"GEMS_PARM_01",35)	GEMS_PARM_01	67	53	f	\N	UL	1	UserUsageTag	K
10967	(0119,"MRSC",1180)	(0119,"MRSC",80)	MRSC	281	128	t	11	SQ	1	FitMapSQ	K
802	(0021,"GEMS_RELA_01",15)	(0021,"GEMS_RELA_01",15)	GEMS_RELA_01	33	21	f	\N	US	1	Unknown	\N
803	(0021,"GEMS_RELA_01",16)	(0021,"GEMS_RELA_01",16)	GEMS_RELA_01	33	22	f	\N	SS	1	Unknown	\N
811	(0021,"GEMS_RELA_01",4e)	(0021,"GEMS_RELA_01",4e)	GEMS_RELA_01	33	78	f	\N	US	1	Unknown	\N
829	(0021,"GEMS_RELA_01",70)	(0021,"GEMS_RELA_01",70)	GEMS_RELA_01	33	112	f	\N	LT	1	Unknown	\N
830	(0021,"GEMS_RELA_01",71)	(0021,"GEMS_RELA_01",71)	GEMS_RELA_01	33	113	f	\N	LT	1	Unknown	\N
1847	(0019,"SIEMENS RA GEN",52)	(0019,"SIEMENS RA GEN",52)	SIEMENS RA GEN	25	82	f	\N	SS	1	TableTilt	\N
800	(0021,"GEMS_RELA_01",05)	(0021,"GEMS_RELA_01",05)	GEMS_RELA_01	33	5	f	\N	SH	1	GenesisVersionNow	R
801	(0021,"GEMS_RELA_01",07)	(0021,"GEMS_RELA_01",07)	GEMS_RELA_01	33	7	f	\N	UL	1	SeriesRecordChecksum	X
804	(0021,"GEMS_RELA_01",18)	(0021,"GEMS_RELA_01",18)	GEMS_RELA_01	33	24	f	\N	SH	1	GenesisVersionNow	R
805	(0021,"GEMS_RELA_01",19)	(0021,"GEMS_RELA_01",19)	GEMS_RELA_01	33	25	f	\N	UL	1	AcqReconRecordChecksum	X
806	(0021,"GEMS_RELA_01",20)	(0021,"GEMS_RELA_01",20)	GEMS_RELA_01	33	32	f	\N	DS	1	TableStartLocation	K
807	(0021,"GEMS_RELA_01",35)	(0021,"GEMS_RELA_01",35)	GEMS_RELA_01	33	53	f	\N	SS	1	SeriesFromWhichPrescribed	R
808	(0021,"GEMS_RELA_01",36)	(0021,"GEMS_RELA_01",36)	GEMS_RELA_01	33	54	f	\N	SS	1	ImageFromWhichPrescribed	R
809	(0021,"GEMS_RELA_01",37)	(0021,"GEMS_RELA_01",37)	GEMS_RELA_01	33	55	f	\N	SS	1	ScreenFormat	KB
810	(0021,"GEMS_RELA_01",4a)	(0021,"GEMS_RELA_01",4a)	GEMS_RELA_01	33	74	f	\N	LO	1	AnatomicalReferenceForScout	R
812	(0021,"GEMS_RELA_01",4f)	(0021,"GEMS_RELA_01",4f)	GEMS_RELA_01	33	79	f	\N	SS	1	LocationsInAcquisition	K
813	(0021,"GEMS_RELA_01",50)	(0021,"GEMS_RELA_01",50)	GEMS_RELA_01	33	80	f	\N	SS	1	GraphicallyPrescribed	K
814	(0021,"GEMS_RELA_01",51)	(0021,"GEMS_RELA_01",51)	GEMS_RELA_01	33	81	f	\N	DS	1	RotationFromSourceXRot	K
815	(0021,"GEMS_RELA_01",52)	(0021,"GEMS_RELA_01",52)	GEMS_RELA_01	33	82	f	\N	DS	1	RotationFromSourceYRot	K
816	(0021,"GEMS_RELA_01",53)	(0021,"GEMS_RELA_01",53)	GEMS_RELA_01	33	83	f	\N	DS	1	RotationFromSourceZRot	K
817	(0021,"GEMS_RELA_01",54)	(0021,"GEMS_RELA_01",54)	GEMS_RELA_01	33	84	f	\N	SH	3	ImagePosition	R
818	(0021,"GEMS_RELA_01",55)	(0021,"GEMS_RELA_01",55)	GEMS_RELA_01	33	85	f	\N	SH	6	ImageOrientation	R
819	(0021,"GEMS_RELA_01",56)	(0021,"GEMS_RELA_01",56)	GEMS_RELA_01	33	86	f	\N	SL	1	IntegerSlop	K
820	(0021,"GEMS_RELA_01",57)	(0021,"GEMS_RELA_01",57)	GEMS_RELA_01	33	87	f	\N	SL	1	IntegerSlop	K
821	(0021,"GEMS_RELA_01",58)	(0021,"GEMS_RELA_01",58)	GEMS_RELA_01	33	88	f	\N	SL	1	IntegerSlop	K
822	(0021,"GEMS_RELA_01",59)	(0021,"GEMS_RELA_01",59)	GEMS_RELA_01	33	89	f	\N	SL	1	IntegerSlop	K
823	(0021,"GEMS_RELA_01",5a)	(0021,"GEMS_RELA_01",5a)	GEMS_RELA_01	33	90	f	\N	SL	1	IntegerSlop	K
824	(0021,"GEMS_RELA_01",5b)	(0021,"GEMS_RELA_01",5b)	GEMS_RELA_01	33	91	f	\N	DS	1	FloatSlop	K
825	(0021,"GEMS_RELA_01",5c)	(0021,"GEMS_RELA_01",5c)	GEMS_RELA_01	33	92	f	\N	DS	1	FloatSlop	K
826	(0021,"GEMS_RELA_01",5d)	(0021,"GEMS_RELA_01",5d)	GEMS_RELA_01	33	93	f	\N	DS	1	FloatSlop	K
827	(0021,"GEMS_RELA_01",5e)	(0021,"GEMS_RELA_01",5e)	GEMS_RELA_01	33	94	f	\N	DS	1	FloatSlop	K
828	(0021,"GEMS_RELA_01",5f)	(0021,"GEMS_RELA_01",5f)	GEMS_RELA_01	33	95	f	\N	DS	1	FloatSlop	K
831	(0021,"GEMS_RELA_01",81)	(0021,"GEMS_RELA_01",81)	GEMS_RELA_01	33	129	f	\N	DS	1	AutoWindowLevelAlpha	K
833	(0021,"GEMS_RELA_01",83)	(0021,"GEMS_RELA_01",83)	GEMS_RELA_01	33	131	f	\N	DS	1	AutoWindowLevelWindow	K
834	(0021,"GEMS_RELA_01",84)	(0021,"GEMS_RELA_01",84)	GEMS_RELA_01	33	132	f	\N	DS	1	AutoWindowLevelLevel	K
775	(0043,"GEMS_PARM_01",36)	(0043,"GEMS_PARM_01",36)	GEMS_PARM_01	67	54	f	\N	UL	1	UserFillMapMSW	K
776	(0043,"GEMS_PARM_01",37)	(0043,"GEMS_PARM_01",37)	GEMS_PARM_01	67	55	f	\N	UL	1	UserFillMapLSW	K
777	(0043,"GEMS_PARM_01",38)	(0043,"GEMS_PARM_01",38)	GEMS_PARM_01	67	56	f	\N	FL	24	User25ToUser48	K
778	(0043,"GEMS_PARM_01",39)	(0043,"GEMS_PARM_01",39)	GEMS_PARM_01	67	57	f	\N	IS	4	SlopInteger6ToSlopInteger9	K
779	(0043,"GEMS_PARM_01",40)	(0043,"GEMS_PARM_01",40)	GEMS_PARM_01	67	64	f	\N	FL	4	TriggerOnPosition	KB
780	(0043,"GEMS_PARM_01",41)	(0043,"GEMS_PARM_01",41)	GEMS_PARM_01	67	65	f	\N	FL	4	DegreeOfRotation	KB
781	(0043,"GEMS_PARM_01",42)	(0043,"GEMS_PARM_01",42)	GEMS_PARM_01	67	66	f	\N	SL	4	DASTriggerSource	KB
782	(0043,"GEMS_PARM_01",43)	(0043,"GEMS_PARM_01",43)	GEMS_PARM_01	67	67	f	\N	SL	4	DASFpaGain	KB
783	(0043,"GEMS_PARM_01",44)	(0043,"GEMS_PARM_01",44)	GEMS_PARM_01	67	68	f	\N	SL	4	DASOutputSource	KB
784	(0043,"GEMS_PARM_01",45)	(0043,"GEMS_PARM_01",45)	GEMS_PARM_01	67	69	f	\N	SL	4	DASAdInput	KB
785	(0043,"GEMS_PARM_01",46)	(0043,"GEMS_PARM_01",46)	GEMS_PARM_01	67	70	f	\N	SL	4	DASCalMode	KB
786	(0043,"GEMS_PARM_01",47)	(0043,"GEMS_PARM_01",47)	GEMS_PARM_01	67	71	f	\N	SL	4	DASCalFrequency	KB
787	(0043,"GEMS_PARM_01",48)	(0043,"GEMS_PARM_01",48)	GEMS_PARM_01	67	72	f	\N	SL	4	DASRegXm	KB
788	(0043,"GEMS_PARM_01",49)	(0043,"GEMS_PARM_01",49)	GEMS_PARM_01	67	73	f	\N	SL	4	DASAutoZero	KB
789	(0043,"GEMS_PARM_01",4a)	(0043,"GEMS_PARM_01",4a)	GEMS_PARM_01	67	74	f	\N	SS	4	StartingChannelOfView	KB
790	(0043,"GEMS_PARM_01",4b)	(0043,"GEMS_PARM_01",4b)	GEMS_PARM_01	67	75	f	\N	SL	4	DASXmPattern	KB
791	(0043,"GEMS_PARM_01",4c)	(0043,"GEMS_PARM_01",4c)	GEMS_PARM_01	67	76	f	\N	SS	4	TGGCTriggerMode	KB
792	(0043,"GEMS_PARM_01",4d)	(0043,"GEMS_PARM_01",4d)	GEMS_PARM_01	67	77	f	\N	FL	4	StartScanToXrayOnDelay	R
794	(0043,"GEMS_PARM_01",60)	(0043,"GEMS_PARM_01",60)	GEMS_PARM_01	67	96	f	\N	IS	8	Unknown	K
795	(0043,"GEMS_PARM_01",61)	(0043,"GEMS_PARM_01",61)	GEMS_PARM_01	67	97	f	\N	UI	1	Unknown	R
796	(0043,"GEMS_PARM_01",62)	(0043,"GEMS_PARM_01",62)	GEMS_PARM_01	67	98	f	\N	SH	1	Unknown	X
797	(0043,"GEMS_PARM_01",6f)	(0043,"GEMS_PARM_01",6f)	GEMS_PARM_01	67	111	f	\N	DS	3	Unknown	K
839	(0045,"GEMS_SENO_02",04)	(0045,"GEMS_SENO_02",04)	GEMS_SENO_02	69	4	f	\N	CS	1	AES	\N
840	(0045,"GEMS_SENO_02",06)	(0045,"GEMS_SENO_02",06)	GEMS_SENO_02	69	6	f	\N	DS	1	Angulation	\N
841	(0045,"GEMS_SENO_02",09)	(0045,"GEMS_SENO_02",09)	GEMS_SENO_02	69	9	f	\N	DS	1	RealMagnificationFactor	\N
842	(0045,"GEMS_SENO_02",0b)	(0045,"GEMS_SENO_02",0b)	GEMS_SENO_02	69	11	f	\N	CS	1	SenographType	\N
843	(0045,"GEMS_SENO_02",0c)	(0045,"GEMS_SENO_02",0c)	GEMS_SENO_02	69	12	f	\N	DS	1	IntegrationTime	\N
844	(0045,"GEMS_SENO_02",0d)	(0045,"GEMS_SENO_02",0d)	GEMS_SENO_02	69	13	f	\N	DS	1	ROIOriginXY	\N
845	(0045,"GEMS_SENO_02",11)	(0045,"GEMS_SENO_02",11)	GEMS_SENO_02	69	17	f	\N	DS	2	ReceptorSizeCmXY	\N
846	(0045,"GEMS_SENO_02",12)	(0045,"GEMS_SENO_02",12)	GEMS_SENO_02	69	18	f	\N	IS	2	ReceptorSizePixelsXY	\N
847	(0045,"GEMS_SENO_02",13)	(0045,"GEMS_SENO_02",13)	GEMS_SENO_02	69	19	f	\N	ST	1	Screen	\N
848	(0045,"GEMS_SENO_02",14)	(0045,"GEMS_SENO_02",14)	GEMS_SENO_02	69	20	f	\N	DS	1	PixelPitchMicrons	\N
849	(0045,"GEMS_SENO_02",15)	(0045,"GEMS_SENO_02",15)	GEMS_SENO_02	69	21	f	\N	IS	1	PixelDepthBits	\N
850	(0045,"GEMS_SENO_02",16)	(0045,"GEMS_SENO_02",16)	GEMS_SENO_02	69	22	f	\N	IS	2	BinningFactorXY	\N
851	(0045,"GEMS_SENO_02",1B)	(0045,"GEMS_SENO_02",1B)	GEMS_SENO_02	69	27	f	\N	CS	1	ClinicalView	\N
852	(0045,"GEMS_SENO_02",1D)	(0045,"GEMS_SENO_02",1D)	GEMS_SENO_02	69	29	f	\N	DS	1	MeanOfRawGrayLevels	\N
853	(0045,"GEMS_SENO_02",1E)	(0045,"GEMS_SENO_02",1E)	GEMS_SENO_02	69	30	f	\N	DS	1	MeanOfOffsetGrayLevels	\N
854	(0045,"GEMS_SENO_02",1F)	(0045,"GEMS_SENO_02",1F)	GEMS_SENO_02	69	31	f	\N	DS	1	MeanOfCorrectedGrayLevels	\N
855	(0045,"GEMS_SENO_02",20)	(0045,"GEMS_SENO_02",20)	GEMS_SENO_02	69	32	f	\N	DS	1	MeanOfRegionGrayLevels	\N
856	(0045,"GEMS_SENO_02",21)	(0045,"GEMS_SENO_02",21)	GEMS_SENO_02	69	33	f	\N	DS	1	MeanOfLogRegionGrayLevels	\N
857	(0045,"GEMS_SENO_02",22)	(0045,"GEMS_SENO_02",22)	GEMS_SENO_02	69	34	f	\N	DS	1	StandardDeviationOfRawGrayLevels	\N
858	(0045,"GEMS_SENO_02",23)	(0045,"GEMS_SENO_02",23)	GEMS_SENO_02	69	35	f	\N	DS	1	StandardDeviationOfCorrectedGrayLevels	\N
859	(0045,"GEMS_SENO_02",24)	(0045,"GEMS_SENO_02",24)	GEMS_SENO_02	69	36	f	\N	DS	1	StandardDeviationOfRegionGrayLevels	\N
860	(0045,"GEMS_SENO_02",25)	(0045,"GEMS_SENO_02",25)	GEMS_SENO_02	69	37	f	\N	DS	1	StandardDeviationOfLogRegionGrayLevels	\N
861	(0045,"GEMS_SENO_02",26)	(0045,"GEMS_SENO_02",26)	GEMS_SENO_02	69	38	f	\N	OB	1	MAOBuffer	\N
862	(0045,"GEMS_SENO_02",27)	(0045,"GEMS_SENO_02",27)	GEMS_SENO_02	69	39	f	\N	IS	1	SetNumber	\N
863	(0045,"GEMS_SENO_02",28)	(0045,"GEMS_SENO_02",28)	GEMS_SENO_02	69	40	f	\N	CS	1	WindowingType	\N
864	(0045,"GEMS_SENO_02",29)	(0045,"GEMS_SENO_02",29)	GEMS_SENO_02	69	41	f	\N	DS	1-n	WindowingParameters	\N
865	(0045,"GEMS_SENO_02",2a)	(0045,"GEMS_SENO_02",2a)	GEMS_SENO_02	69	42	f	\N	IS	1	CrosshairCursorXCoordinates	\N
866	(0045,"GEMS_SENO_02",2b)	(0045,"GEMS_SENO_02",2b)	GEMS_SENO_02	69	43	f	\N	IS	1	CrosshairCursorYCoordinates	\N
867	(0045,"GEMS_SENO_02",39)	(0045,"GEMS_SENO_02",39)	GEMS_SENO_02	69	57	f	\N	US	1	VignetteRows	\N
868	(0045,"GEMS_SENO_02",3a)	(0045,"GEMS_SENO_02",3a)	GEMS_SENO_02	69	58	f	\N	US	1	VignetteColumns	\N
869	(0045,"GEMS_SENO_02",3b)	(0045,"GEMS_SENO_02",3b)	GEMS_SENO_02	69	59	f	\N	US	1	VignetteBitsAllocated	\N
870	(0045,"GEMS_SENO_02",3c)	(0045,"GEMS_SENO_02",3c)	GEMS_SENO_02	69	60	f	\N	US	1	VignetteBitsStored	\N
871	(0045,"GEMS_SENO_02",3d)	(0045,"GEMS_SENO_02",3d)	GEMS_SENO_02	69	61	f	\N	US	1	VignetteHighBit	\N
872	(0045,"GEMS_SENO_02",3e)	(0045,"GEMS_SENO_02",3e)	GEMS_SENO_02	69	62	f	\N	US	1	VignettePixelRepresentation	\N
873	(0045,"GEMS_SENO_02",3f)	(0045,"GEMS_SENO_02",3f)	GEMS_SENO_02	69	63	f	\N	OB	1	VignettePixelData	\N
890	(0033,"GEMS_YMHD_01",05)	(0033,"GEMS_YMHD_01",05)	GEMS_YMHD_01	51	5	f	\N	UN	1	Unknown	\N
891	(0033,"GEMS_YMHD_01",06)	(0033,"GEMS_YMHD_01",06)	GEMS_YMHD_01	51	6	f	\N	UN	1	Unknown	\N
892	(0019,"GE_GENESIS_REV3.0",39)	(0019,"GE_GENESIS_REV3.0",39)	GE_GENESIS_REV3.0	25	57	f	\N	SS	1	AxialType	\N
2638	(0019,"SVISION",78)	(0019,"SVISION",78)	SVISION	25	120	f	\N	DS	1	FilterThickness1	\N
836	(0021,"GEMS_RELA_01",91)	(0021,"GEMS_RELA_01",91)	GEMS_RELA_01	33	145	f	\N	SS	1	BiopsyPosition	KB
838	(0021,"GEMS_RELA_01",93)	(0021,"GEMS_RELA_01",93)	GEMS_RELA_01	33	147	f	\N	FL	1	BiopsyRefLocation	KB
883	(0023,"GEMS_STDY_01",01)	(0023,"GEMS_STDY_01",01)	GEMS_STDY_01	35	1	f	\N	SL	1	NumberOfSeriesInStudy	X
884	(0023,"GEMS_STDY_01",02)	(0023,"GEMS_STDY_01",02)	GEMS_STDY_01	35	2	f	\N	SL	1	NumberOfUnarchivedSeries	X
885	(0023,"GEMS_STDY_01",10)	(0023,"GEMS_STDY_01",10)	GEMS_STDY_01	35	16	f	\N	SS	1	ReferenceImageField	X
886	(0023,"GEMS_STDY_01",50)	(0023,"GEMS_STDY_01",50)	GEMS_STDY_01	35	80	f	\N	SS	1	SummaryImage	X
887	(0023,"GEMS_STDY_01",70)	(0023,"GEMS_STDY_01",70)	GEMS_STDY_01	35	112	f	\N	FD	1	StartTimeSecsInFirstAxial	X
888	(0023,"GEMS_STDY_01",74)	(0023,"GEMS_STDY_01",74)	GEMS_STDY_01	35	116	f	\N	SL	1	NumberOfUpdatesToHeader	X
889	(0023,"GEMS_STDY_01",7d)	(0023,"GEMS_STDY_01",7d)	GEMS_STDY_01	35	125	f	\N	SS	1	IndicatesIfStudyHasCompleteInfo	X
874	(0025,"GEMS_SERS_01",06)	(0025,"GEMS_SERS_01",06)	GEMS_SERS_01	37	6	f	\N	SS	1	LastPulseSequenceUsed	KB
875	(0025,"GEMS_SERS_01",07)	(0025,"GEMS_SERS_01",07)	GEMS_SERS_01	37	7	f	\N	SL	1	ImagesInSeries	KB
876	(0025,"GEMS_SERS_01",10)	(0025,"GEMS_SERS_01",10)	GEMS_SERS_01	37	16	f	\N	SL	1	LandmarkCounter	KB
877	(0025,"GEMS_SERS_01",11)	(0025,"GEMS_SERS_01",11)	GEMS_SERS_01	37	17	f	\N	SS	1	NumberOfAcquisitions	KB
878	(0025,"GEMS_SERS_01",14)	(0025,"GEMS_SERS_01",14)	GEMS_SERS_01	37	20	f	\N	SL	1	IndicatesNumberOfUpdatesToHeader	X
879	(0025,"GEMS_SERS_01",17)	(0025,"GEMS_SERS_01",17)	GEMS_SERS_01	37	23	f	\N	SL	1	SeriesCompleteFlag	X
880	(0025,"GEMS_SERS_01",18)	(0025,"GEMS_SERS_01",18)	GEMS_SERS_01	37	24	f	\N	SL	1	NumberOfImagesArchived	X
881	(0025,"GEMS_SERS_01",19)	(0025,"GEMS_SERS_01",19)	GEMS_SERS_01	37	25	f	\N	SL	1	LastImageNumberUsed	X
882	(0025,"GEMS_SERS_01",1a)	(0025,"GEMS_SERS_01",1a)	GEMS_SERS_01	37	26	f	\N	SH	1	PrimaryReceiverSuiteAndHost	X
893	(0019,"GE_GENESIS_REV3.0",8f)	(0019,"GE_GENESIS_REV3.0",8f)	GE_GENESIS_REV3.0	25	143	f	\N	SS	1	SwapPhaseFrequency	\N
894	(0019,"GE_GENESIS_REV3.0",9c)	(0019,"GE_GENESIS_REV3.0",9c)	GE_GENESIS_REV3.0	25	156	f	\N	SS	1	PulseSequenceName	\N
895	(0019,"GE_GENESIS_REV3.0",9f)	(0019,"GE_GENESIS_REV3.0",9f)	GE_GENESIS_REV3.0	25	159	f	\N	SS	1	CoilType	\N
896	(0019,"GE_GENESIS_REV3.0",a4)	(0019,"GE_GENESIS_REV3.0",a4)	GE_GENESIS_REV3.0	25	164	f	\N	SS	1	SATFatWaterBone	\N
897	(0019,"GE_GENESIS_REV3.0",c0)	(0019,"GE_GENESIS_REV3.0",c0)	GE_GENESIS_REV3.0	25	192	f	\N	SS	1	BitmapOfSATSelections	\N
898	(0019,"GE_GENESIS_REV3.0",c1)	(0019,"GE_GENESIS_REV3.0",c1)	GE_GENESIS_REV3.0	25	193	f	\N	SS	1	SurfaceCoilIntensityCorrectionFlag	\N
899	(0019,"GE_GENESIS_REV3.0",cb)	(0019,"GE_GENESIS_REV3.0",cb)	GE_GENESIS_REV3.0	25	203	f	\N	SS	1	PhaseContrastFlowAxis	\N
900	(0019,"GE_GENESIS_REV3.0",cc)	(0019,"GE_GENESIS_REV3.0",cc)	GE_GENESIS_REV3.0	25	204	f	\N	SS	1	PhaseContrastVelocityEncoding	\N
901	(0019,"GE_GENESIS_REV3.0",d5)	(0019,"GE_GENESIS_REV3.0",d5)	GE_GENESIS_REV3.0	25	213	f	\N	SS	1	FractionalEcho	\N
902	(0019,"GE_GENESIS_REV3.0",d8)	(0019,"GE_GENESIS_REV3.0",d8)	GE_GENESIS_REV3.0	25	216	f	\N	SS	1	VariableEchoFlag	\N
903	(0019,"GE_GENESIS_REV3.0",d9)	(0019,"GE_GENESIS_REV3.0",d9)	GE_GENESIS_REV3.0	25	217	f	\N	DS	1	ConcatenatedSat	\N
904	(0019,"GE_GENESIS_REV3.0",f2)	(0019,"GE_GENESIS_REV3.0",f2)	GE_GENESIS_REV3.0	25	242	f	\N	SS	1	NumberOfPhases	\N
905	(0043,"GE_GENESIS_REV3.0",1e)	(0043,"GE_GENESIS_REV3.0",1e)	GE_GENESIS_REV3.0	67	30	f	\N	DS	1	DeltaStartTime	\N
906	(0043,"GE_GENESIS_REV3.0",27)	(0043,"GE_GENESIS_REV3.0",27)	GE_GENESIS_REV3.0	67	39	f	\N	SH	1	ScanPitchRatio	\N
907	(0029,"INTELERAD MEDICAL SYSTEMS",01)	(0029,"INTELERAD MEDICAL SYSTEMS",01)	INTELERAD MEDICAL SYSTEMS	41	1	f	\N	FD	1	ImageCompressionFraction	\N
908	(0029,"INTELERAD MEDICAL SYSTEMS",02)	(0029,"INTELERAD MEDICAL SYSTEMS",02)	INTELERAD MEDICAL SYSTEMS	41	2	f	\N	FD	1	ImageQuality	\N
909	(0029,"INTELERAD MEDICAL SYSTEMS",03)	(0029,"INTELERAD MEDICAL SYSTEMS",03)	INTELERAD MEDICAL SYSTEMS	41	3	f	\N	FD	1	ImageBytesTransferred	\N
910	(0029,"INTELERAD MEDICAL SYSTEMS",10)	(0029,"INTELERAD MEDICAL SYSTEMS",10)	INTELERAD MEDICAL SYSTEMS	41	16	f	\N	SH	1	J2cParameterType	\N
911	(0029,"INTELERAD MEDICAL SYSTEMS",11)	(0029,"INTELERAD MEDICAL SYSTEMS",11)	INTELERAD MEDICAL SYSTEMS	41	17	f	\N	US	1	J2cPixelRepresentation	\N
912	(0029,"INTELERAD MEDICAL SYSTEMS",12)	(0029,"INTELERAD MEDICAL SYSTEMS",12)	INTELERAD MEDICAL SYSTEMS	41	18	f	\N	US	1	J2cBitsAllocated	\N
913	(0029,"INTELERAD MEDICAL SYSTEMS",13)	(0029,"INTELERAD MEDICAL SYSTEMS",13)	INTELERAD MEDICAL SYSTEMS	41	19	f	\N	US	1	J2cPixelShiftValue	\N
914	(0029,"INTELERAD MEDICAL SYSTEMS",14)	(0029,"INTELERAD MEDICAL SYSTEMS",14)	INTELERAD MEDICAL SYSTEMS	41	20	f	\N	US	1	J2cPlanarConfiguration	\N
915	(0029,"INTELERAD MEDICAL SYSTEMS",15)	(0029,"INTELERAD MEDICAL SYSTEMS",15)	INTELERAD MEDICAL SYSTEMS	41	21	f	\N	DS	1	J2cRescaleIntercept	\N
916	(0029,"INTELERAD MEDICAL SYSTEMS",20)	(0029,"INTELERAD MEDICAL SYSTEMS",20)	INTELERAD MEDICAL SYSTEMS	41	32	f	\N	LO	1	PixelDataMD5SumPerFrame	\N
917	(0029,"INTELERAD MEDICAL SYSTEMS",21)	(0029,"INTELERAD MEDICAL SYSTEMS",21)	INTELERAD MEDICAL SYSTEMS	41	33	f	\N	US	1	HistogramPercentileLabels	\N
918	(0029,"INTELERAD MEDICAL SYSTEMS",22)	(0029,"INTELERAD MEDICAL SYSTEMS",22)	INTELERAD MEDICAL SYSTEMS	41	34	f	\N	FD	1	HistogramPercentileValues	\N
919	(3f01,"INTELERAD MEDICAL SYSTEMS",01)	(3f01,"INTELERAD MEDICAL SYSTEMS",01)	INTELERAD MEDICAL SYSTEMS	16129	1	f	\N	LO	1	InstitutionCode	\N
920	(3f01,"INTELERAD MEDICAL SYSTEMS",02)	(3f01,"INTELERAD MEDICAL SYSTEMS",02)	INTELERAD MEDICAL SYSTEMS	16129	2	f	\N	LO	1	RoutedTransferAE	\N
921	(3f01,"INTELERAD MEDICAL SYSTEMS",03)	(3f01,"INTELERAD MEDICAL SYSTEMS",03)	INTELERAD MEDICAL SYSTEMS	16129	3	f	\N	LO	1	SourceAE	\N
922	(3f01,"INTELERAD MEDICAL SYSTEMS",04)	(3f01,"INTELERAD MEDICAL SYSTEMS",04)	INTELERAD MEDICAL SYSTEMS	16129	4	f	\N	SH	1	DeferredValidation	\N
923	(3f01,"INTELERAD MEDICAL SYSTEMS",05)	(3f01,"INTELERAD MEDICAL SYSTEMS",05)	INTELERAD MEDICAL SYSTEMS	16129	5	f	\N	LO	1	SeriesOwner	\N
924	(3f01,"INTELERAD MEDICAL SYSTEMS",06)	(3f01,"INTELERAD MEDICAL SYSTEMS",06)	INTELERAD MEDICAL SYSTEMS	16129	6	f	\N	LO	1	OrderGroupNumber	\N
925	(3f01,"INTELERAD MEDICAL SYSTEMS",07)	(3f01,"INTELERAD MEDICAL SYSTEMS",07)	INTELERAD MEDICAL SYSTEMS	16129	7	f	\N	SH	1	StrippedPixelData	\N
926	(3f01,"INTELERAD MEDICAL SYSTEMS",08)	(3f01,"INTELERAD MEDICAL SYSTEMS",08)	INTELERAD MEDICAL SYSTEMS	16129	8	f	\N	SH	1	PendingMoveRequest	\N
927	(0041,"INTEGRIS 1.0",20)	(0041,"INTEGRIS 1.0",20)	INTEGRIS 1.0	65	32	f	\N	FL	1	AccumulatedFluoroscopyDose	\N
928	(0041,"INTEGRIS 1.0",30)	(0041,"INTEGRIS 1.0",30)	INTEGRIS 1.0	65	48	f	\N	FL	1	AccumulatedExposureDose	\N
929	(0041,"INTEGRIS 1.0",40)	(0041,"INTEGRIS 1.0",40)	INTEGRIS 1.0	65	64	f	\N	FL	1	TotalDose	\N
930	(0041,"INTEGRIS 1.0",41)	(0041,"INTEGRIS 1.0",41)	INTEGRIS 1.0	65	65	f	\N	FL	1	TotalNumberOfFrames	\N
931	(0041,"INTEGRIS 1.0",50)	(0041,"INTEGRIS 1.0",50)	INTEGRIS 1.0	65	80	f	\N	SQ	1	ExposureInformationSequence	\N
932	(0009,"INTEGRIS 1.0",08)	(0009,"INTEGRIS 1.0",08)	INTEGRIS 1.0	9	8	f	\N	CS	1-n	ExposureChannel	\N
933	(0009,"INTEGRIS 1.0",32)	(0009,"INTEGRIS 1.0",32)	INTEGRIS 1.0	9	50	f	\N	TM	1	ExposureStartTime	\N
934	(0019,"INTEGRIS 1.0",00)	(0019,"INTEGRIS 1.0",00)	INTEGRIS 1.0	25	0	f	\N	LO	1	APRName	\N
935	(0019,"INTEGRIS 1.0",40)	(0019,"INTEGRIS 1.0",40)	INTEGRIS 1.0	25	64	f	\N	DS	1	FrameRate	\N
936	(0021,"INTEGRIS 1.0",12)	(0021,"INTEGRIS 1.0",12)	INTEGRIS 1.0	33	18	f	\N	IS	1	ExposureNumber	\N
937	(0029,"INTEGRIS 1.0",08)	(0029,"INTEGRIS 1.0",08)	INTEGRIS 1.0	41	8	f	\N	IS	1	NumberOfExposureResults	\N
938	(0029,"ISG shadow",70)	(0029,"ISG shadow",70)	ISG shadow	41	112	f	\N	IS	1	Unknown	\N
939	(0029,"ISG shadow",80)	(0029,"ISG shadow",80)	ISG shadow	41	128	f	\N	IS	1	Unknown	\N
940	(0029,"ISG shadow",90)	(0029,"ISG shadow",90)	ISG shadow	41	144	f	\N	IS	1	Unknown	\N
941	(0009,"ISI",01)	(0009,"ISI",01)	ISI	9	1	f	\N	UN	1	SIENETGeneralPurposeIMGEF	\N
942	(0009,"MERGE TECHNOLOGIES, INC.",00)	(0009,"MERGE TECHNOLOGIES, INC.",00)	MERGE TECHNOLOGIES, INC.	9	0	f	\N	OB	1	Unknown	\N
943	(0029,"OCULUS Optikgeraete GmbH",1010)	(0029,"OCULUS Optikgeraete GmbH",10)	OCULUS Optikgeraete GmbH	41	16	t	0010	OB	1	OriginalMeasuringData	\N
2639	(0019,"SVISION",79)	(0019,"SVISION",79)	SVISION	25	121	f	\N	DS	1	FilterThickness2	\N
944	(0029,"OCULUS Optikgeraete GmbH",1012)	(0029,"OCULUS Optikgeraete GmbH",12)	OCULUS Optikgeraete GmbH	41	18	t	0010	UL	1	OriginalMeasuringDataLength	\N
945	(0029,"OCULUS Optikgeraete GmbH",1020)	(0029,"OCULUS Optikgeraete GmbH",20)	OCULUS Optikgeraete GmbH	41	32	t	0010	OB	1	OriginalMeasuringRawData	\N
946	(0029,"OCULUS Optikgeraete GmbH",1022)	(0029,"OCULUS Optikgeraete GmbH",22)	OCULUS Optikgeraete GmbH	41	34	t	0010	UL	1	OriginalMeasuringRawDataLength	\N
947	(0041,"PAPYRUS 3.0",00)	(0041,"PAPYRUS 3.0",00)	PAPYRUS 3.0	65	0	f	\N	LT	1	PapyrusComments	\N
948	(0041,"PAPYRUS 3.0",10)	(0041,"PAPYRUS 3.0",10)	PAPYRUS 3.0	65	16	f	\N	SQ	1	PointerSequence	\N
949	(0041,"PAPYRUS 3.0",11)	(0041,"PAPYRUS 3.0",11)	PAPYRUS 3.0	65	17	f	\N	UL	1	ImagePointer	\N
950	(0041,"PAPYRUS 3.0",12)	(0041,"PAPYRUS 3.0",12)	PAPYRUS 3.0	65	18	f	\N	UL	1	PixelOffset	\N
951	(0041,"PAPYRUS 3.0",13)	(0041,"PAPYRUS 3.0",13)	PAPYRUS 3.0	65	19	f	\N	SQ	1	ImageIdentifierSequence	\N
952	(0041,"PAPYRUS 3.0",14)	(0041,"PAPYRUS 3.0",14)	PAPYRUS 3.0	65	20	f	\N	SQ	1	ExternalFileReferenceSequence	\N
953	(0041,"PAPYRUS 3.0",15)	(0041,"PAPYRUS 3.0",15)	PAPYRUS 3.0	65	21	f	\N	US	1	NumberOfImages	\N
954	(0041,"PAPYRUS 3.0",21)	(0041,"PAPYRUS 3.0",21)	PAPYRUS 3.0	65	33	f	\N	UI	1	ReferencedSOPClassUID	\N
955	(0041,"PAPYRUS 3.0",22)	(0041,"PAPYRUS 3.0",22)	PAPYRUS 3.0	65	34	f	\N	UI	1	ReferencedSOPInstanceUID	\N
956	(0041,"PAPYRUS 3.0",31)	(0041,"PAPYRUS 3.0",31)	PAPYRUS 3.0	65	49	f	\N	LT	1	ReferencedFileName	\N
957	(0041,"PAPYRUS 3.0",32)	(0041,"PAPYRUS 3.0",32)	PAPYRUS 3.0	65	50	f	\N	LT	1-n	ReferencedFilePath	\N
958	(0041,"PAPYRUS 3.0",41)	(0041,"PAPYRUS 3.0",41)	PAPYRUS 3.0	65	65	f	\N	UI	1	ReferencedImageSOPClassUID	\N
959	(0041,"PAPYRUS 3.0",42)	(0041,"PAPYRUS 3.0",42)	PAPYRUS 3.0	65	66	f	\N	UI	1	ReferencedImageSOPInstanceUID	\N
960	(0041,"PAPYRUS 3.0",50)	(0041,"PAPYRUS 3.0",50)	PAPYRUS 3.0	65	80	f	\N	SQ	1	ImageSequence	\N
961	(0009,"PAPYRUS",00)	(0009,"PAPYRUS",00)	PAPYRUS	9	0	f	\N	LT	1	OriginalFileName	\N
962	(0009,"PAPYRUS",10)	(0009,"PAPYRUS",10)	PAPYRUS	9	16	f	\N	LT	1	OriginalFileLocation	\N
963	(0009,"PAPYRUS",18)	(0009,"PAPYRUS",18)	PAPYRUS	9	24	f	\N	LT	1	DataSetIdentifier	\N
964	(0041,"PAPYRUS",00)	(0041,"PAPYRUS",00)	PAPYRUS	65	0	f	\N	LT	1-n	PapyrusComments	\N
965	(0041,"PAPYRUS",10)	(0041,"PAPYRUS",10)	PAPYRUS	65	16	f	\N	US	1	FolderType	\N
966	(0041,"PAPYRUS",11)	(0041,"PAPYRUS",11)	PAPYRUS	65	17	f	\N	LT	1	PatientFolderDataSetID	\N
967	(0041,"PAPYRUS",20)	(0041,"PAPYRUS",20)	PAPYRUS	65	32	f	\N	LT	1	FolderName	\N
968	(0041,"PAPYRUS",30)	(0041,"PAPYRUS",30)	PAPYRUS	65	48	f	\N	DA	1	CreationDate	\N
969	(0041,"PAPYRUS",32)	(0041,"PAPYRUS",32)	PAPYRUS	65	50	f	\N	TM	1	CreationTime	\N
970	(0041,"PAPYRUS",34)	(0041,"PAPYRUS",34)	PAPYRUS	65	52	f	\N	DA	1	ModifiedDate	\N
971	(0041,"PAPYRUS",36)	(0041,"PAPYRUS",36)	PAPYRUS	65	54	f	\N	TM	1	ModifiedTime	\N
972	(0041,"PAPYRUS",40)	(0041,"PAPYRUS",40)	PAPYRUS	65	64	f	\N	LT	1-n	OwnerName	\N
973	(0041,"PAPYRUS",50)	(0041,"PAPYRUS",50)	PAPYRUS	65	80	f	\N	LT	1	FolderStatus	\N
974	(0041,"PAPYRUS",60)	(0041,"PAPYRUS",60)	PAPYRUS	65	96	f	\N	UL	1	NumberOfImages	\N
975	(0041,"PAPYRUS",62)	(0041,"PAPYRUS",62)	PAPYRUS	65	98	f	\N	UL	1	NumberOfOther	\N
976	(0041,"PAPYRUS",a0)	(0041,"PAPYRUS",a0)	PAPYRUS	65	160	f	\N	LT	1-n	ExternalFolderElementDSID	\N
977	(0041,"PAPYRUS",a1)	(0041,"PAPYRUS",a1)	PAPYRUS	65	161	f	\N	US	1-n	ExternalFolderElementDataSetType	\N
978	(0041,"PAPYRUS",a2)	(0041,"PAPYRUS",a2)	PAPYRUS	65	162	f	\N	LT	1-n	ExternalFolderElementFileLocation	\N
979	(0041,"PAPYRUS",a3)	(0041,"PAPYRUS",a3)	PAPYRUS	65	163	f	\N	UL	1-n	ExternalFolderElementLength	\N
980	(0041,"PAPYRUS",b0)	(0041,"PAPYRUS",b0)	PAPYRUS	65	176	f	\N	LT	1-n	InternalFolderElementDSID	\N
981	(0041,"PAPYRUS",b1)	(0041,"PAPYRUS",b1)	PAPYRUS	65	177	f	\N	US	1-n	InternalFolderElementDataSetType	\N
982	(0041,"PAPYRUS",b2)	(0041,"PAPYRUS",b2)	PAPYRUS	65	178	f	\N	UL	1-n	InternalOffsetToDataSet	\N
983	(0041,"PAPYRUS",b3)	(0041,"PAPYRUS",b3)	PAPYRUS	65	179	f	\N	UL	1-n	InternalOffsetToImage	\N
999	(2001,"Philips Imaging DD 001",17)	(2001,"Philips Imaging DD 001",17)	Philips Imaging DD 001	8193	23	f	\N	SL	1	NumberOfPhasesMR	KB
1000	(2001,"Philips Imaging DD 001",18)	(2001,"Philips Imaging DD 001",18)	Philips Imaging DD 001	8193	24	f	\N	SL	1	NumberOfSlicesMR	KB
1016	(2001,"Philips Imaging DD 001",3f)	(2001,"Philips Imaging DD 001",3f)	Philips Imaging DD 001	8193	63	f	\N	CS	1	ZoomMode	\N
1020	(2001,"Philips Imaging DD 001",62)	(2001,"Philips Imaging DD 001",62)	Philips Imaging DD 001	8193	98	f	\N	CS	1	SeriesCommitted	\N
1024	(2001,"PHILIPS IMAGING DD 001",01)	(2001,"PHILIPS IMAGING DD 001",01)	PHILIPS IMAGING DD 001	8193	1	f	\N	FL	1	ChemicalShift	\N
1025	(2001,"PHILIPS IMAGING DD 001",02)	(2001,"PHILIPS IMAGING DD 001",02)	PHILIPS IMAGING DD 001	8193	2	f	\N	IS	1	ChemicalShiftNumberMR	\N
1026	(2001,"PHILIPS IMAGING DD 001",03)	(2001,"PHILIPS IMAGING DD 001",03)	PHILIPS IMAGING DD 001	8193	3	f	\N	FL	1	DiffusionB-Factor	\N
1027	(2001,"PHILIPS IMAGING DD 001",04)	(2001,"PHILIPS IMAGING DD 001",04)	PHILIPS IMAGING DD 001	8193	4	f	\N	CS	1	DiffusionDirection	\N
1028	(2001,"PHILIPS IMAGING DD 001",06)	(2001,"PHILIPS IMAGING DD 001",06)	PHILIPS IMAGING DD 001	8193	6	f	\N	CS	1	ImageEnhanced	\N
1029	(2001,"PHILIPS IMAGING DD 001",07)	(2001,"PHILIPS IMAGING DD 001",07)	PHILIPS IMAGING DD 001	8193	7	f	\N	CS	1	ImageTypeEDES	\N
1030	(2001,"PHILIPS IMAGING DD 001",08)	(2001,"PHILIPS IMAGING DD 001",08)	PHILIPS IMAGING DD 001	8193	8	f	\N	IS	1	PhaseNumber	\N
1031	(2001,"PHILIPS IMAGING DD 001",0a)	(2001,"PHILIPS IMAGING DD 001",0a)	PHILIPS IMAGING DD 001	8193	10	f	\N	IS	1	SliceNumberMR	\N
1032	(2001,"PHILIPS IMAGING DD 001",0b)	(2001,"PHILIPS IMAGING DD 001",0b)	PHILIPS IMAGING DD 001	8193	11	f	\N	CS	1	SliceOrientation	\N
1033	(2001,"PHILIPS IMAGING DD 001",11)	(2001,"PHILIPS IMAGING DD 001",11)	PHILIPS IMAGING DD 001	8193	17	f	\N	FL	1	DiffusionEchoTime	\N
1034	(2001,"PHILIPS IMAGING DD 001",12)	(2001,"PHILIPS IMAGING DD 001",12)	PHILIPS IMAGING DD 001	8193	18	f	\N	CS	1	DynamicSeries	\N
1035	(2001,"PHILIPS IMAGING DD 001",13)	(2001,"PHILIPS IMAGING DD 001",13)	PHILIPS IMAGING DD 001	8193	19	f	\N	SL	1	EPIFactor	\N
1036	(2001,"PHILIPS IMAGING DD 001",14)	(2001,"PHILIPS IMAGING DD 001",14)	PHILIPS IMAGING DD 001	8193	20	f	\N	SL	1	NumberOfEchoes	\N
1037	(2001,"PHILIPS IMAGING DD 001",15)	(2001,"PHILIPS IMAGING DD 001",15)	PHILIPS IMAGING DD 001	8193	21	f	\N	SS	1	NumberOfLocations	\N
1038	(2001,"PHILIPS IMAGING DD 001",16)	(2001,"PHILIPS IMAGING DD 001",16)	PHILIPS IMAGING DD 001	8193	22	f	\N	SS	1	NumberOfPCDirections	\N
1039	(2001,"PHILIPS IMAGING DD 001",17)	(2001,"PHILIPS IMAGING DD 001",17)	PHILIPS IMAGING DD 001	8193	23	f	\N	SL	1	NumberOfPhasesMR	\N
1040	(2001,"PHILIPS IMAGING DD 001",18)	(2001,"PHILIPS IMAGING DD 001",18)	PHILIPS IMAGING DD 001	8193	24	f	\N	SL	1	NumberOfSlicesMR	\N
1041	(2001,"PHILIPS IMAGING DD 001",19)	(2001,"PHILIPS IMAGING DD 001",19)	PHILIPS IMAGING DD 001	8193	25	f	\N	CS	1	PartialMatrixScanned	\N
1042	(2001,"PHILIPS IMAGING DD 001",1a)	(2001,"PHILIPS IMAGING DD 001",1a)	PHILIPS IMAGING DD 001	8193	26	f	\N	FL	1-n	PCVelocity	\N
1043	(2001,"PHILIPS IMAGING DD 001",1b)	(2001,"PHILIPS IMAGING DD 001",1b)	PHILIPS IMAGING DD 001	8193	27	f	\N	FL	1	PrepulseDelay	\N
1044	(2001,"PHILIPS IMAGING DD 001",1c)	(2001,"PHILIPS IMAGING DD 001",1c)	PHILIPS IMAGING DD 001	8193	28	f	\N	CS	1	PrepulseType	\N
1045	(2001,"PHILIPS IMAGING DD 001",1d)	(2001,"PHILIPS IMAGING DD 001",1d)	PHILIPS IMAGING DD 001	8193	29	f	\N	IS	1	ReconstructionNumberMR	\N
1046	(2001,"PHILIPS IMAGING DD 001",1f)	(2001,"PHILIPS IMAGING DD 001",1f)	PHILIPS IMAGING DD 001	8193	31	f	\N	CS	1	RespirationSync	\N
1047	(2001,"PHILIPS IMAGING DD 001",21)	(2001,"PHILIPS IMAGING DD 001",21)	PHILIPS IMAGING DD 001	8193	33	f	\N	CS	1	SPIR	\N
1048	(2001,"PHILIPS IMAGING DD 001",22)	(2001,"PHILIPS IMAGING DD 001",22)	PHILIPS IMAGING DD 001	8193	34	f	\N	FL	1	WaterFatShift	\N
1049	(2001,"PHILIPS IMAGING DD 001",23)	(2001,"PHILIPS IMAGING DD 001",23)	PHILIPS IMAGING DD 001	8193	35	f	\N	DS	1	FlipAnglePhilips	\N
1002	(2001,"Philips Imaging DD 001",1a)	(2001,"Philips Imaging DD 001",1a)	Philips Imaging DD 001	8193	26	f	\N	FL	1-n	PCVelocity	KB
1050	(2001,"PHILIPS IMAGING DD 001",25)	(2001,"PHILIPS IMAGING DD 001",25)	PHILIPS IMAGING DD 001	8193	37	f	\N	SH	1	EchoTimeDisplayMR	\N
1051	(2001,"PHILIPS IMAGING DD 001",2d)	(2001,"PHILIPS IMAGING DD 001",2d)	PHILIPS IMAGING DD 001	8193	45	f	\N	SS	1	StackNumberOfSlices	\N
1052	(2001,"PHILIPS IMAGING DD 001",32)	(2001,"PHILIPS IMAGING DD 001",32)	PHILIPS IMAGING DD 001	8193	50	f	\N	FL	1	StackRadialAngle	\N
1053	(2001,"PHILIPS IMAGING DD 001",33)	(2001,"PHILIPS IMAGING DD 001",33)	PHILIPS IMAGING DD 001	8193	51	f	\N	CS	1	StackRadialAxis	\N
1054	(2001,"PHILIPS IMAGING DD 001",35)	(2001,"PHILIPS IMAGING DD 001",35)	PHILIPS IMAGING DD 001	8193	53	f	\N	SS	1	StackSliceNumber	\N
1055	(2001,"PHILIPS IMAGING DD 001",36)	(2001,"PHILIPS IMAGING DD 001",36)	PHILIPS IMAGING DD 001	8193	54	f	\N	CS	1	StackType	\N
1056	(2001,"PHILIPS IMAGING DD 001",3f)	(2001,"PHILIPS IMAGING DD 001",3f)	PHILIPS IMAGING DD 001	8193	63	f	\N	CS	1	ZoomMode	\N
1057	(2001,"PHILIPS IMAGING DD 001",5f)	(2001,"PHILIPS IMAGING DD 001",5f)	PHILIPS IMAGING DD 001	8193	95	f	\N	SQ	1-n	StackSequence	\N
1058	(2001,"PHILIPS IMAGING DD 001",60)	(2001,"PHILIPS IMAGING DD 001",60)	PHILIPS IMAGING DD 001	8193	96	f	\N	SL	1	NumberOfStacks	\N
1059	(2001,"PHILIPS IMAGING DD 001",61)	(2001,"PHILIPS IMAGING DD 001",61)	PHILIPS IMAGING DD 001	8193	97	f	\N	CS	1	SeriesTransmitted	\N
1060	(2001,"PHILIPS IMAGING DD 001",62)	(2001,"PHILIPS IMAGING DD 001",62)	PHILIPS IMAGING DD 001	8193	98	f	\N	CS	1	SeriesCommitted	\N
1061	(2001,"PHILIPS IMAGING DD 001",63)	(2001,"PHILIPS IMAGING DD 001",63)	PHILIPS IMAGING DD 001	8193	99	f	\N	CS	1	ExaminationSource	\N
1062	(2001,"PHILIPS IMAGING DD 001",7b)	(2001,"PHILIPS IMAGING DD 001",7b)	PHILIPS IMAGING DD 001	8193	123	f	\N	IS	1	AcquisitionNumber	\N
1063	(2001,"PHILIPS IMAGING DD 001",81)	(2001,"PHILIPS IMAGING DD 001",81)	PHILIPS IMAGING DD 001	8193	129	f	\N	IS	1	NumberOfDynamicScans	\N
1064	(2005,"Philips MR Imaging DD 001",05)	(2005,"Philips MR Imaging DD 001",05)	Philips MR Imaging DD 001	8197	5	f	\N	CS	1	SynergyReconstructionType	\N
1065	(2005,"Philips MR Imaging DD 001",1e)	(2005,"Philips MR Imaging DD 001",1e)	Philips MR Imaging DD 001	8197	30	f	\N	SH	1	MIPProtocol	\N
1066	(2005,"Philips MR Imaging DD 001",1f)	(2005,"Philips MR Imaging DD 001",1f)	Philips MR Imaging DD 001	8197	31	f	\N	SH	1	MPRProtocol	\N
1068	(2005,"Philips MR Imaging DD 001",2d)	(2005,"Philips MR Imaging DD 001",2d)	Philips MR Imaging DD 001	8197	45	f	\N	SS	1	NumberOfStackSlices	\N
1069	(2005,"Philips MR Imaging DD 001",32)	(2005,"Philips MR Imaging DD 001",32)	Philips MR Imaging DD 001	8197	50	f	\N	FL	1	StackRadialAngle	\N
1070	(2005,"Philips MR Imaging DD 001",33)	(2005,"Philips MR Imaging DD 001",33)	Philips MR Imaging DD 001	8197	51	f	\N	CS	1	StackRadialAxis	\N
1071	(2005,"Philips MR Imaging DD 001",35)	(2005,"Philips MR Imaging DD 001",35)	Philips MR Imaging DD 001	8197	53	f	\N	SS	1	StackSliceNumber	\N
1072	(2005,"Philips MR Imaging DD 001",36)	(2005,"Philips MR Imaging DD 001",36)	Philips MR Imaging DD 001	8197	54	f	\N	CS	1	StackType	\N
1074	(2005,"Philips MR Imaging DD 001",5f)	(2005,"Philips MR Imaging DD 001",5f)	Philips MR Imaging DD 001	8197	95	f	\N	SQ	1	StackSequence	\N
1075	(2005,"Philips MR Imaging DD 001",83)	(2005,"Philips MR Imaging DD 001",83)	Philips MR Imaging DD 001	8197	131	f	\N	SQ	1	Unknown	\N
1076	(2005,"Philips MR Imaging DD 005",02)	(2005,"Philips MR Imaging DD 005",02)	Philips MR Imaging DD 005	8197	2	f	\N	SQ	1	Unknown	\N
1077	(2005,"PHILIPS MR IMAGING DD 001",05)	(2005,"PHILIPS MR IMAGING DD 001",05)	PHILIPS MR IMAGING DD 001	8197	5	f	\N	CS	1	SynergyReconstructionType	\N
1078	(2005,"PHILIPS MR IMAGING DD 001",1e)	(2005,"PHILIPS MR IMAGING DD 001",1e)	PHILIPS MR IMAGING DD 001	8197	30	f	\N	SH	1	MIPProtocol	\N
1079	(2005,"PHILIPS MR IMAGING DD 001",1f)	(2005,"PHILIPS MR IMAGING DD 001",1f)	PHILIPS MR IMAGING DD 001	8197	31	f	\N	SH	1	MPRProtocol	\N
1080	(2005,"PHILIPS MR IMAGING DD 001",20)	(2005,"PHILIPS MR IMAGING DD 001",20)	PHILIPS MR IMAGING DD 001	8197	32	f	\N	SL	1	NumberOfChemicalShifts	\N
1081	(2005,"PHILIPS MR IMAGING DD 001",2d)	(2005,"PHILIPS MR IMAGING DD 001",2d)	PHILIPS MR IMAGING DD 001	8197	45	f	\N	SS	1	NumberOfStackSlices	\N
1082	(2005,"PHILIPS MR IMAGING DD 001",32)	(2005,"PHILIPS MR IMAGING DD 001",32)	PHILIPS MR IMAGING DD 001	8197	50	f	\N	FL	1	StackRadialAngle	\N
1083	(2005,"PHILIPS MR IMAGING DD 001",33)	(2005,"PHILIPS MR IMAGING DD 001",33)	PHILIPS MR IMAGING DD 001	8197	51	f	\N	CS	1	StackRadialAxis	\N
1084	(2005,"PHILIPS MR IMAGING DD 001",35)	(2005,"PHILIPS MR IMAGING DD 001",35)	PHILIPS MR IMAGING DD 001	8197	53	f	\N	SS	1	StackSliceNumber	\N
1085	(2005,"PHILIPS MR IMAGING DD 001",36)	(2005,"PHILIPS MR IMAGING DD 001",36)	PHILIPS MR IMAGING DD 001	8197	54	f	\N	CS	1	StackType	\N
1086	(2005,"PHILIPS MR IMAGING DD 001",a1)	(2005,"PHILIPS MR IMAGING DD 001",a1)	PHILIPS MR IMAGING DD 001	8197	161	f	\N	CS	1	SyncraScanType	\N
1087	(2005,"PHILIPS MR IMAGING DD 001",5f)	(2005,"PHILIPS MR IMAGING DD 001",5f)	PHILIPS MR IMAGING DD 001	8197	95	f	\N	SQ	1	StackSequence	\N
1088	(2005,"PHILIPS MR IMAGING DD 001",83)	(2005,"PHILIPS MR IMAGING DD 001",83)	PHILIPS MR IMAGING DD 001	8197	131	f	\N	SQ	1	Unknown	\N
1089	(0019,"PHILIPS MR R5.5/PART",1000)	(0019,"PHILIPS MR R5.5/PART",00)	PHILIPS MR R5.5/PART	25	0	t	0010	DS	1	FieldOfView	\N
1090	(0019,"PHILIPS MR R5.6/PART",1000)	(0019,"PHILIPS MR R5.6/PART",00)	PHILIPS MR R5.6/PART	25	0	t	0010	DS	1	FieldOfView	\N
1091	(0019,"PHILIPS MR SPECTRO;1",01)	(0019,"PHILIPS MR SPECTRO;1",01)	PHILIPS MR SPECTRO;1	25	1	f	\N	US	1	Unknown	\N
1092	(0019,"PHILIPS MR SPECTRO;1",02)	(0019,"PHILIPS MR SPECTRO;1",02)	PHILIPS MR SPECTRO;1	25	2	f	\N	US	1	Unknown	\N
1093	(0019,"PHILIPS MR SPECTRO;1",03)	(0019,"PHILIPS MR SPECTRO;1",03)	PHILIPS MR SPECTRO;1	25	3	f	\N	US	1	Unknown	\N
1094	(0019,"PHILIPS MR SPECTRO;1",04)	(0019,"PHILIPS MR SPECTRO;1",04)	PHILIPS MR SPECTRO;1	25	4	f	\N	US	1	Unknown	\N
1095	(0019,"PHILIPS MR SPECTRO;1",05)	(0019,"PHILIPS MR SPECTRO;1",05)	PHILIPS MR SPECTRO;1	25	5	f	\N	US	1	Unknown	\N
1096	(0019,"PHILIPS MR SPECTRO;1",06)	(0019,"PHILIPS MR SPECTRO;1",06)	PHILIPS MR SPECTRO;1	25	6	f	\N	US	1	Unknown	\N
1097	(0019,"PHILIPS MR SPECTRO;1",07)	(0019,"PHILIPS MR SPECTRO;1",07)	PHILIPS MR SPECTRO;1	25	7	f	\N	IS	1	Unknown	\N
1098	(0019,"PHILIPS MR SPECTRO;1",08)	(0019,"PHILIPS MR SPECTRO;1",08)	PHILIPS MR SPECTRO;1	25	8	f	\N	IS	1	Unknown	\N
1099	(0019,"PHILIPS MR SPECTRO;1",09)	(0019,"PHILIPS MR SPECTRO;1",09)	PHILIPS MR SPECTRO;1	25	9	f	\N	IS	1	Unknown	\N
1100	(0019,"PHILIPS MR SPECTRO;1",10)	(0019,"PHILIPS MR SPECTRO;1",10)	PHILIPS MR SPECTRO;1	25	16	f	\N	IS	1	Unknown	\N
1101	(0019,"PHILIPS MR SPECTRO;1",12)	(0019,"PHILIPS MR SPECTRO;1",12)	PHILIPS MR SPECTRO;1	25	18	f	\N	IS	1	Unknown	\N
1102	(0019,"PHILIPS MR SPECTRO;1",13)	(0019,"PHILIPS MR SPECTRO;1",13)	PHILIPS MR SPECTRO;1	25	19	f	\N	IS	1	Unknown	\N
1103	(0019,"PHILIPS MR SPECTRO;1",14)	(0019,"PHILIPS MR SPECTRO;1",14)	PHILIPS MR SPECTRO;1	25	20	f	\N	US	1	Unknown	\N
1104	(0019,"PHILIPS MR SPECTRO;1",15)	(0019,"PHILIPS MR SPECTRO;1",15)	PHILIPS MR SPECTRO;1	25	21	f	\N	US	1-n	Unknown	\N
1105	(0019,"PHILIPS MR SPECTRO;1",16)	(0019,"PHILIPS MR SPECTRO;1",16)	PHILIPS MR SPECTRO;1	25	22	f	\N	IS	1	Unknown	\N
1106	(0019,"PHILIPS MR SPECTRO;1",17)	(0019,"PHILIPS MR SPECTRO;1",17)	PHILIPS MR SPECTRO;1	25	23	f	\N	IS	1	Unknown	\N
1107	(0019,"PHILIPS MR SPECTRO;1",18)	(0019,"PHILIPS MR SPECTRO;1",18)	PHILIPS MR SPECTRO;1	25	24	f	\N	UN	1	Unknown	\N
1108	(0019,"PHILIPS MR SPECTRO;1",20)	(0019,"PHILIPS MR SPECTRO;1",20)	PHILIPS MR SPECTRO;1	25	32	f	\N	IS	1	Unknown	\N
1109	(0019,"PHILIPS MR SPECTRO;1",21)	(0019,"PHILIPS MR SPECTRO;1",21)	PHILIPS MR SPECTRO;1	25	33	f	\N	IS	1	Unknown	\N
1110	(0019,"PHILIPS MR SPECTRO;1",22)	(0019,"PHILIPS MR SPECTRO;1",22)	PHILIPS MR SPECTRO;1	25	34	f	\N	IS	1	Unknown	\N
1111	(0019,"PHILIPS MR SPECTRO;1",23)	(0019,"PHILIPS MR SPECTRO;1",23)	PHILIPS MR SPECTRO;1	25	35	f	\N	IS	1	Unknown	\N
1112	(0019,"PHILIPS MR SPECTRO;1",24)	(0019,"PHILIPS MR SPECTRO;1",24)	PHILIPS MR SPECTRO;1	25	36	f	\N	IS	1	Unknown	\N
1113	(0019,"PHILIPS MR SPECTRO;1",25)	(0019,"PHILIPS MR SPECTRO;1",25)	PHILIPS MR SPECTRO;1	25	37	f	\N	IS	1	Unknown	\N
1114	(0019,"PHILIPS MR SPECTRO;1",26)	(0019,"PHILIPS MR SPECTRO;1",26)	PHILIPS MR SPECTRO;1	25	38	f	\N	IS	1	Unknown	\N
1115	(0019,"PHILIPS MR SPECTRO;1",27)	(0019,"PHILIPS MR SPECTRO;1",27)	PHILIPS MR SPECTRO;1	25	39	f	\N	IS	1	Unknown	\N
1116	(0019,"PHILIPS MR SPECTRO;1",28)	(0019,"PHILIPS MR SPECTRO;1",28)	PHILIPS MR SPECTRO;1	25	40	f	\N	IS	1	Unknown	\N
1117	(0019,"PHILIPS MR SPECTRO;1",29)	(0019,"PHILIPS MR SPECTRO;1",29)	PHILIPS MR SPECTRO;1	25	41	f	\N	IS	1-n	Unknown	\N
1118	(0019,"PHILIPS MR SPECTRO;1",31)	(0019,"PHILIPS MR SPECTRO;1",31)	PHILIPS MR SPECTRO;1	25	49	f	\N	US	1	Unknown	\N
1119	(0019,"PHILIPS MR SPECTRO;1",32)	(0019,"PHILIPS MR SPECTRO;1",32)	PHILIPS MR SPECTRO;1	25	50	f	\N	US	1	Unknown	\N
1120	(0019,"PHILIPS MR SPECTRO;1",41)	(0019,"PHILIPS MR SPECTRO;1",41)	PHILIPS MR SPECTRO;1	25	65	f	\N	LT	1	Unknown	\N
1121	(0019,"PHILIPS MR SPECTRO;1",42)	(0019,"PHILIPS MR SPECTRO;1",42)	PHILIPS MR SPECTRO;1	25	66	f	\N	IS	2	Unknown	\N
1122	(0019,"PHILIPS MR SPECTRO;1",43)	(0019,"PHILIPS MR SPECTRO;1",43)	PHILIPS MR SPECTRO;1	25	67	f	\N	IS	2	Unknown	\N
1123	(0019,"PHILIPS MR SPECTRO;1",45)	(0019,"PHILIPS MR SPECTRO;1",45)	PHILIPS MR SPECTRO;1	25	69	f	\N	US	1	Unknown	\N
1124	(0019,"PHILIPS MR SPECTRO;1",46)	(0019,"PHILIPS MR SPECTRO;1",46)	PHILIPS MR SPECTRO;1	25	70	f	\N	US	1	Unknown	\N
1125	(0019,"PHILIPS MR SPECTRO;1",47)	(0019,"PHILIPS MR SPECTRO;1",47)	PHILIPS MR SPECTRO;1	25	71	f	\N	IS	1	Unknown	\N
1126	(0019,"PHILIPS MR SPECTRO;1",48)	(0019,"PHILIPS MR SPECTRO;1",48)	PHILIPS MR SPECTRO;1	25	72	f	\N	IS	1	Unknown	\N
1127	(0019,"PHILIPS MR SPECTRO;1",49)	(0019,"PHILIPS MR SPECTRO;1",49)	PHILIPS MR SPECTRO;1	25	73	f	\N	US	1	Unknown	\N
1128	(0019,"PHILIPS MR SPECTRO;1",50)	(0019,"PHILIPS MR SPECTRO;1",50)	PHILIPS MR SPECTRO;1	25	80	f	\N	UN	1	Unknown	\N
1129	(0019,"PHILIPS MR SPECTRO;1",60)	(0019,"PHILIPS MR SPECTRO;1",60)	PHILIPS MR SPECTRO;1	25	96	f	\N	US	1	Unknown	\N
1130	(0019,"PHILIPS MR SPECTRO;1",61)	(0019,"PHILIPS MR SPECTRO;1",61)	PHILIPS MR SPECTRO;1	25	97	f	\N	US	1	Unknown	\N
1131	(0019,"PHILIPS MR SPECTRO;1",70)	(0019,"PHILIPS MR SPECTRO;1",70)	PHILIPS MR SPECTRO;1	25	112	f	\N	UN	1	Unknown	\N
1132	(0019,"PHILIPS MR SPECTRO;1",71)	(0019,"PHILIPS MR SPECTRO;1",71)	PHILIPS MR SPECTRO;1	25	113	f	\N	IS	1-n	Unknown	\N
1133	(0019,"PHILIPS MR SPECTRO;1",72)	(0019,"PHILIPS MR SPECTRO;1",72)	PHILIPS MR SPECTRO;1	25	114	f	\N	US	1	Unknown	\N
1134	(0019,"PHILIPS MR SPECTRO;1",73)	(0019,"PHILIPS MR SPECTRO;1",73)	PHILIPS MR SPECTRO;1	25	115	f	\N	US	1	Unknown	\N
1135	(0019,"PHILIPS MR SPECTRO;1",74)	(0019,"PHILIPS MR SPECTRO;1",74)	PHILIPS MR SPECTRO;1	25	116	f	\N	US	1	Unknown	\N
1136	(0019,"PHILIPS MR SPECTRO;1",76)	(0019,"PHILIPS MR SPECTRO;1",76)	PHILIPS MR SPECTRO;1	25	118	f	\N	US	1	Unknown	\N
1137	(0019,"PHILIPS MR SPECTRO;1",77)	(0019,"PHILIPS MR SPECTRO;1",77)	PHILIPS MR SPECTRO;1	25	119	f	\N	US	1	Unknown	\N
1138	(0019,"PHILIPS MR SPECTRO;1",78)	(0019,"PHILIPS MR SPECTRO;1",78)	PHILIPS MR SPECTRO;1	25	120	f	\N	US	1	Unknown	\N
1139	(0019,"PHILIPS MR SPECTRO;1",79)	(0019,"PHILIPS MR SPECTRO;1",79)	PHILIPS MR SPECTRO;1	25	121	f	\N	US	1	Unknown	\N
1140	(0019,"PHILIPS MR SPECTRO;1",80)	(0019,"PHILIPS MR SPECTRO;1",80)	PHILIPS MR SPECTRO;1	25	128	f	\N	IS	1	Unknown	\N
1141	(0009,"PHILIPS MR",10)	(0009,"PHILIPS MR",10)	PHILIPS MR	9	16	f	\N	LO	1	SPIRelease	\N
1142	(0009,"PHILIPS MR",12)	(0009,"PHILIPS MR",12)	PHILIPS MR	9	18	f	\N	LO	1	Unknown	\N
1143	(0019,"PHILIPS MR/LAST",09)	(0019,"PHILIPS MR/LAST",09)	PHILIPS MR/LAST	25	9	f	\N	DS	1	MainMagneticField	\N
1144	(0019,"PHILIPS MR/LAST",0e)	(0019,"PHILIPS MR/LAST",0e)	PHILIPS MR/LAST	25	14	f	\N	IS	1	FlowCompensation	\N
1145	(0019,"PHILIPS MR/LAST",b1)	(0019,"PHILIPS MR/LAST",b1)	PHILIPS MR/LAST	25	177	f	\N	IS	1	MinimumRRInterval	\N
1146	(0019,"PHILIPS MR/LAST",b2)	(0019,"PHILIPS MR/LAST",b2)	PHILIPS MR/LAST	25	178	f	\N	IS	1	MaximumRRInterval	\N
1147	(0019,"PHILIPS MR/LAST",b3)	(0019,"PHILIPS MR/LAST",b3)	PHILIPS MR/LAST	25	179	f	\N	IS	1	NumberOfRejections	\N
1148	(0019,"PHILIPS MR/LAST",b4)	(0019,"PHILIPS MR/LAST",b4)	PHILIPS MR/LAST	25	180	f	\N	IS	1-n	NumberOfRRIntervals	\N
1149	(0019,"PHILIPS MR/LAST",b5)	(0019,"PHILIPS MR/LAST",b5)	PHILIPS MR/LAST	25	181	f	\N	IS	1	ArrhythmiaRejection	\N
1150	(0019,"PHILIPS MR/LAST",c0)	(0019,"PHILIPS MR/LAST",c0)	PHILIPS MR/LAST	25	192	f	\N	DS	1-n	Unknown	\N
1151	(0019,"PHILIPS MR/LAST",c6)	(0019,"PHILIPS MR/LAST",c6)	PHILIPS MR/LAST	25	198	f	\N	IS	1	CycledMultipleSlice	\N
1152	(0019,"PHILIPS MR/LAST",ce)	(0019,"PHILIPS MR/LAST",ce)	PHILIPS MR/LAST	25	206	f	\N	IS	1	REST	\N
1153	(0019,"PHILIPS MR/LAST",d5)	(0019,"PHILIPS MR/LAST",d5)	PHILIPS MR/LAST	25	213	f	\N	DS	1	Unknown	\N
1154	(0019,"PHILIPS MR/LAST",d6)	(0019,"PHILIPS MR/LAST",d6)	PHILIPS MR/LAST	25	214	f	\N	IS	1	FourierInterpolation	\N
1155	(0019,"PHILIPS MR/LAST",d9)	(0019,"PHILIPS MR/LAST",d9)	PHILIPS MR/LAST	25	217	f	\N	IS	1-n	Unknown	\N
1156	(0019,"PHILIPS MR/LAST",e0)	(0019,"PHILIPS MR/LAST",e0)	PHILIPS MR/LAST	25	224	f	\N	IS	1	Prepulse	\N
1157	(0019,"PHILIPS MR/LAST",e1)	(0019,"PHILIPS MR/LAST",e1)	PHILIPS MR/LAST	25	225	f	\N	DS	1	PrepulseDelay	\N
1158	(0019,"PHILIPS MR/LAST",e2)	(0019,"PHILIPS MR/LAST",e2)	PHILIPS MR/LAST	25	226	f	\N	IS	1	Unknown	\N
1159	(0019,"PHILIPS MR/LAST",e3)	(0019,"PHILIPS MR/LAST",e3)	PHILIPS MR/LAST	25	227	f	\N	DS	1	Unknown	\N
1160	(0019,"PHILIPS MR/LAST",f0)	(0019,"PHILIPS MR/LAST",f0)	PHILIPS MR/LAST	25	240	f	\N	LT	1	WSProtocolString1	\N
1161	(0019,"PHILIPS MR/LAST",f1)	(0019,"PHILIPS MR/LAST",f1)	PHILIPS MR/LAST	25	241	f	\N	LT	1	WSProtocolString2	\N
1162	(0019,"PHILIPS MR/LAST",f2)	(0019,"PHILIPS MR/LAST",f2)	PHILIPS MR/LAST	25	242	f	\N	LT	1	WSProtocolString3	\N
1163	(0019,"PHILIPS MR/LAST",f3)	(0019,"PHILIPS MR/LAST",f3)	PHILIPS MR/LAST	25	243	f	\N	LT	1	WSProtocolString4	\N
1164	(0021,"PHILIPS MR/LAST",00)	(0021,"PHILIPS MR/LAST",00)	PHILIPS MR/LAST	33	0	f	\N	IS	1	Unknown	\N
1165	(0021,"PHILIPS MR/LAST",10)	(0021,"PHILIPS MR/LAST",10)	PHILIPS MR/LAST	33	16	f	\N	IS	1	Unknown	\N
1166	(0021,"PHILIPS MR/LAST",20)	(0021,"PHILIPS MR/LAST",20)	PHILIPS MR/LAST	33	32	f	\N	IS	1	Unknown	\N
1167	(0021,"PHILIPS MR/LAST",21)	(0021,"PHILIPS MR/LAST",21)	PHILIPS MR/LAST	33	33	f	\N	DS	1	SliceGap	\N
1168	(0021,"PHILIPS MR/LAST",22)	(0021,"PHILIPS MR/LAST",22)	PHILIPS MR/LAST	33	34	f	\N	DS	1	StackRadialAngle	\N
1169	(0027,"PHILIPS MR/LAST",00)	(0027,"PHILIPS MR/LAST",00)	PHILIPS MR/LAST	39	0	f	\N	US	1	Unknown	\N
1170	(0027,"PHILIPS MR/LAST",11)	(0027,"PHILIPS MR/LAST",11)	PHILIPS MR/LAST	39	17	f	\N	US	1-n	Unknown	\N
1171	(0027,"PHILIPS MR/LAST",12)	(0027,"PHILIPS MR/LAST",12)	PHILIPS MR/LAST	39	18	f	\N	DS	1-n	Unknown	\N
1172	(0027,"PHILIPS MR/LAST",13)	(0027,"PHILIPS MR/LAST",13)	PHILIPS MR/LAST	39	19	f	\N	DS	1-n	Unknown	\N
1173	(0027,"PHILIPS MR/LAST",14)	(0027,"PHILIPS MR/LAST",14)	PHILIPS MR/LAST	39	20	f	\N	DS	1-n	Unknown	\N
1174	(0027,"PHILIPS MR/LAST",15)	(0027,"PHILIPS MR/LAST",15)	PHILIPS MR/LAST	39	21	f	\N	DS	1-n	Unknown	\N
1175	(0027,"PHILIPS MR/LAST",16)	(0027,"PHILIPS MR/LAST",16)	PHILIPS MR/LAST	39	22	f	\N	LO	1	Unknown	\N
1176	(0029,"PHILIPS MR/LAST",10)	(0029,"PHILIPS MR/LAST",10)	PHILIPS MR/LAST	41	16	f	\N	DS	1	FPMin	\N
1177	(0029,"PHILIPS MR/LAST",20)	(0029,"PHILIPS MR/LAST",20)	PHILIPS MR/LAST	41	32	f	\N	DS	1	FPMax	\N
1178	(0029,"PHILIPS MR/LAST",30)	(0029,"PHILIPS MR/LAST",30)	PHILIPS MR/LAST	41	48	f	\N	DS	1	ScaledMinimum	\N
1179	(0029,"PHILIPS MR/LAST",40)	(0029,"PHILIPS MR/LAST",40)	PHILIPS MR/LAST	41	64	f	\N	DS	1	ScaledMaximum	\N
1180	(0029,"PHILIPS MR/LAST",50)	(0029,"PHILIPS MR/LAST",50)	PHILIPS MR/LAST	41	80	f	\N	DS	1	WindowMinimum	\N
1181	(0029,"PHILIPS MR/LAST",60)	(0029,"PHILIPS MR/LAST",60)	PHILIPS MR/LAST	41	96	f	\N	DS	1	WindowMaximum	\N
1182	(0029,"PHILIPS MR/LAST",61)	(0029,"PHILIPS MR/LAST",61)	PHILIPS MR/LAST	41	97	f	\N	IS	1	Unknown	\N
1183	(0029,"PHILIPS MR/LAST",70)	(0029,"PHILIPS MR/LAST",70)	PHILIPS MR/LAST	41	112	f	\N	DS	1	Unknown	\N
1184	(0029,"PHILIPS MR/LAST",71)	(0029,"PHILIPS MR/LAST",71)	PHILIPS MR/LAST	41	113	f	\N	DS	1	Unknown	\N
1185	(0029,"PHILIPS MR/LAST",72)	(0029,"PHILIPS MR/LAST",72)	PHILIPS MR/LAST	41	114	f	\N	IS	1	Unknown	\N
1186	(0029,"PHILIPS MR/LAST",80)	(0029,"PHILIPS MR/LAST",80)	PHILIPS MR/LAST	41	128	f	\N	IS	1	ViewCenter	\N
1187	(0029,"PHILIPS MR/LAST",81)	(0029,"PHILIPS MR/LAST",81)	PHILIPS MR/LAST	41	129	f	\N	IS	1	ViewSize	\N
1188	(0029,"PHILIPS MR/LAST",82)	(0029,"PHILIPS MR/LAST",82)	PHILIPS MR/LAST	41	130	f	\N	IS	1	ViewZoom	\N
1189	(0029,"PHILIPS MR/LAST",83)	(0029,"PHILIPS MR/LAST",83)	PHILIPS MR/LAST	41	131	f	\N	IS	1	ViewTransform	\N
1190	(6001,"PHILIPS MR/LAST",00)	(6001,"PHILIPS MR/LAST",00)	PHILIPS MR/LAST	24577	0	f	\N	LT	1	Unknown	\N
1191	(0019,"PHILIPS MR/PART",1000)	(0019,"PHILIPS MR/PART",00)	PHILIPS MR/PART	25	0	t	0010	DS	1	FieldOfView	\N
1192	(0019,"PHILIPS MR/PART",1005)	(0019,"PHILIPS MR/PART",05)	PHILIPS MR/PART	25	5	t	0010	DS	1	CCAngulation	\N
1193	(0019,"PHILIPS MR/PART",1006)	(0019,"PHILIPS MR/PART",06)	PHILIPS MR/PART	25	6	t	0010	DS	1	APAngulation	\N
1194	(0019,"PHILIPS MR/PART",1007)	(0019,"PHILIPS MR/PART",07)	PHILIPS MR/PART	25	7	t	0010	DS	1	LRAngulation	\N
1195	(0019,"PHILIPS MR/PART",1008)	(0019,"PHILIPS MR/PART",08)	PHILIPS MR/PART	25	8	t	0010	IS	1	PatientPosition	\N
1196	(0019,"PHILIPS MR/PART",1009)	(0019,"PHILIPS MR/PART",09)	PHILIPS MR/PART	25	9	t	0010	IS	1	PatientOrientation	\N
1197	(0019,"PHILIPS MR/PART",100a)	(0019,"PHILIPS MR/PART",0a)	PHILIPS MR/PART	25	10	t	0010	IS	1	SliceOrientation	\N
1198	(0019,"PHILIPS MR/PART",100b)	(0019,"PHILIPS MR/PART",0b)	PHILIPS MR/PART	25	11	t	0010	DS	1	LROffcenter	\N
1199	(0019,"PHILIPS MR/PART",100c)	(0019,"PHILIPS MR/PART",0c)	PHILIPS MR/PART	25	12	t	0010	DS	1	CCOffcenter	\N
1200	(0019,"PHILIPS MR/PART",100d)	(0019,"PHILIPS MR/PART",0d)	PHILIPS MR/PART	25	13	t	0010	DS	1	APOffcenter	\N
1201	(0019,"PHILIPS MR/PART",100e)	(0019,"PHILIPS MR/PART",0e)	PHILIPS MR/PART	25	14	t	0010	DS	1	Unknown	\N
1202	(0019,"PHILIPS MR/PART",100f)	(0019,"PHILIPS MR/PART",0f)	PHILIPS MR/PART	25	15	t	0010	IS	1	NumberOfSlices	\N
1203	(0019,"PHILIPS MR/PART",1010)	(0019,"PHILIPS MR/PART",10)	PHILIPS MR/PART	25	16	t	0010	DS	1	SliceFactor	\N
1204	(0019,"PHILIPS MR/PART",1011)	(0019,"PHILIPS MR/PART",11)	PHILIPS MR/PART	25	17	t	0010	DS	1-n	EchoTimes	\N
1205	(0019,"PHILIPS MR/PART",1015)	(0019,"PHILIPS MR/PART",15)	PHILIPS MR/PART	25	21	t	0010	IS	1	DynamicStudy	\N
1206	(0019,"PHILIPS MR/PART",1018)	(0019,"PHILIPS MR/PART",18)	PHILIPS MR/PART	25	24	t	0010	DS	1	HeartbeatInterval	\N
1207	(0019,"PHILIPS MR/PART",1019)	(0019,"PHILIPS MR/PART",19)	PHILIPS MR/PART	25	25	t	0010	DS	1	RepetitionTimeFFE	\N
1208	(0019,"PHILIPS MR/PART",101a)	(0019,"PHILIPS MR/PART",1a)	PHILIPS MR/PART	25	26	t	0010	DS	1	FFEFlipAngle	\N
1209	(0019,"PHILIPS MR/PART",101b)	(0019,"PHILIPS MR/PART",1b)	PHILIPS MR/PART	25	27	t	0010	IS	1	NumberOfScans	\N
1210	(0019,"PHILIPS MR/PART",1021)	(0019,"PHILIPS MR/PART",21)	PHILIPS MR/PART	25	33	t	0010	DS	1-n	Unknown	\N
1211	(0019,"PHILIPS MR/PART",1022)	(0019,"PHILIPS MR/PART",22)	PHILIPS MR/PART	25	34	t	0010	DS	1	DynamicScanTimeBegin	\N
1212	(0019,"PHILIPS MR/PART",1024)	(0019,"PHILIPS MR/PART",24)	PHILIPS MR/PART	25	36	t	0010	IS	1	Unknown	\N
1213	(0019,"PHILIPS MR/PART",1064)	(0019,"PHILIPS MR/PART",64)	PHILIPS MR/PART	25	100	t	0010	DS	1	RepetitionTimeSE	\N
1214	(0019,"PHILIPS MR/PART",1065)	(0019,"PHILIPS MR/PART",65)	PHILIPS MR/PART	25	101	t	0010	DS	1	RepetitionTimeIR	\N
1215	(0019,"PHILIPS MR/PART",1069)	(0019,"PHILIPS MR/PART",69)	PHILIPS MR/PART	25	105	t	0010	IS	1	NumberOfPhases	\N
1216	(0019,"PHILIPS MR/PART",106a)	(0019,"PHILIPS MR/PART",6a)	PHILIPS MR/PART	25	106	t	0010	IS	1	CardiacFrequency	\N
1217	(0019,"PHILIPS MR/PART",106b)	(0019,"PHILIPS MR/PART",6b)	PHILIPS MR/PART	25	107	t	0010	DS	1	InversionDelay	\N
1218	(0019,"PHILIPS MR/PART",106c)	(0019,"PHILIPS MR/PART",6c)	PHILIPS MR/PART	25	108	t	0010	DS	1	GateDelay	\N
1219	(0019,"PHILIPS MR/PART",106d)	(0019,"PHILIPS MR/PART",6d)	PHILIPS MR/PART	25	109	t	0010	DS	1	GateWidth	\N
1220	(0019,"PHILIPS MR/PART",106e)	(0019,"PHILIPS MR/PART",6e)	PHILIPS MR/PART	25	110	t	0010	DS	1	TriggerDelayTime	\N
1221	(0019,"PHILIPS MR/PART",1080)	(0019,"PHILIPS MR/PART",80)	PHILIPS MR/PART	25	128	t	0010	IS	1	NumberOfChemicalShifts	\N
1222	(0019,"PHILIPS MR/PART",1081)	(0019,"PHILIPS MR/PART",81)	PHILIPS MR/PART	25	129	t	0010	DS	1	ChemicalShift	\N
1223	(0019,"PHILIPS MR/PART",1084)	(0019,"PHILIPS MR/PART",84)	PHILIPS MR/PART	25	132	t	0010	IS	1	NumberOfRows	\N
1224	(0019,"PHILIPS MR/PART",1085)	(0019,"PHILIPS MR/PART",85)	PHILIPS MR/PART	25	133	t	0010	IS	1	NumberOfSamples	\N
1225	(0019,"PHILIPS MR/PART",1094)	(0019,"PHILIPS MR/PART",94)	PHILIPS MR/PART	25	148	t	0010	LO	1	MagnetizationTransferContrast	\N
1226	(0019,"PHILIPS MR/PART",1095)	(0019,"PHILIPS MR/PART",95)	PHILIPS MR/PART	25	149	t	0010	LO	1	SpectralPresaturationWithInversionRecovery	\N
1227	(0019,"PHILIPS MR/PART",1096)	(0019,"PHILIPS MR/PART",96)	PHILIPS MR/PART	25	150	t	0010	IS	1	Unknown	\N
1228	(0019,"PHILIPS MR/PART",1097)	(0019,"PHILIPS MR/PART",97)	PHILIPS MR/PART	25	151	t	0010	LO	1	Unknown	\N
1229	(0019,"PHILIPS MR/PART",10a0)	(0019,"PHILIPS MR/PART",a0)	PHILIPS MR/PART	25	160	t	0010	IS	1	Unknown	\N
1230	(0019,"PHILIPS MR/PART",10a1)	(0019,"PHILIPS MR/PART",a1)	PHILIPS MR/PART	25	161	t	0010	DS	1	Unknown	\N
1231	(0019,"PHILIPS MR/PART",10a3)	(0019,"PHILIPS MR/PART",a3)	PHILIPS MR/PART	25	163	t	0010	DS	1	Unknown	\N
1232	(0019,"PHILIPS MR/PART",10a4)	(0019,"PHILIPS MR/PART",a4)	PHILIPS MR/PART	25	164	t	0010	CS	1	Unknown	\N
1233	(0019,"PHILIPS MR/PART",10c8)	(0019,"PHILIPS MR/PART",c8)	PHILIPS MR/PART	25	200	t	0010	IS	1	Unknown	\N
1234	(0019,"PHILIPS MR/PART",10c9)	(0019,"PHILIPS MR/PART",c9)	PHILIPS MR/PART	25	201	t	0010	IS	1	FoldoverDirectionTransverse	\N
1235	(0019,"PHILIPS MR/PART",10ca)	(0019,"PHILIPS MR/PART",ca)	PHILIPS MR/PART	25	202	t	0010	IS	1	FoldoverDirectionSagittal	\N
1236	(0019,"PHILIPS MR/PART",10cb)	(0019,"PHILIPS MR/PART",cb)	PHILIPS MR/PART	25	203	t	0010	IS	1	FoldoverDirectionCoronal	\N
1237	(0019,"PHILIPS MR/PART",10cc)	(0019,"PHILIPS MR/PART",cc)	PHILIPS MR/PART	25	204	t	0010	IS	1	Unknown	\N
1238	(0019,"PHILIPS MR/PART",10cd)	(0019,"PHILIPS MR/PART",cd)	PHILIPS MR/PART	25	205	t	0010	IS	1	Unknown	\N
1239	(0019,"PHILIPS MR/PART",10ce)	(0019,"PHILIPS MR/PART",ce)	PHILIPS MR/PART	25	206	t	0010	IS	1	Unknown	\N
1240	(0019,"PHILIPS MR/PART",10cf)	(0019,"PHILIPS MR/PART",cf)	PHILIPS MR/PART	25	207	t	0010	IS	1	NumberOfEchoes	\N
1241	(0019,"PHILIPS MR/PART",10d0)	(0019,"PHILIPS MR/PART",d0)	PHILIPS MR/PART	25	208	t	0010	IS	1	ScanResolution	\N
1242	(0019,"PHILIPS MR/PART",10d2)	(0019,"PHILIPS MR/PART",d2)	PHILIPS MR/PART	25	210	t	0010	LO	2	WaterFatShift	\N
1243	(0019,"PHILIPS MR/PART",10d4)	(0019,"PHILIPS MR/PART",d4)	PHILIPS MR/PART	25	212	t	0010	IS	1	ArtifactReduction	\N
1244	(0019,"PHILIPS MR/PART",10d5)	(0019,"PHILIPS MR/PART",d5)	PHILIPS MR/PART	25	213	t	0010	IS	1	Unknown	\N
1245	(0019,"PHILIPS MR/PART",10d6)	(0019,"PHILIPS MR/PART",d6)	PHILIPS MR/PART	25	214	t	0010	IS	1	Unknown	\N
1246	(0019,"PHILIPS MR/PART",10d7)	(0019,"PHILIPS MR/PART",d7)	PHILIPS MR/PART	25	215	t	0010	DS	1	ScanPercentage	\N
1247	(0019,"PHILIPS MR/PART",10d8)	(0019,"PHILIPS MR/PART",d8)	PHILIPS MR/PART	25	216	t	0010	IS	1	Halfscan	\N
1248	(0019,"PHILIPS MR/PART",10d9)	(0019,"PHILIPS MR/PART",d9)	PHILIPS MR/PART	25	217	t	0010	IS	1	EPIFactor	\N
1249	(0019,"PHILIPS MR/PART",10da)	(0019,"PHILIPS MR/PART",da)	PHILIPS MR/PART	25	218	t	0010	IS	1	TurboFactor	\N
1250	(0019,"PHILIPS MR/PART",10db)	(0019,"PHILIPS MR/PART",db)	PHILIPS MR/PART	25	219	t	0010	IS	1	Unknown	\N
1251	(0019,"PHILIPS MR/PART",10e0)	(0019,"PHILIPS MR/PART",e0)	PHILIPS MR/PART	25	224	t	0010	IS	1	PercentageOfScanCompleted	\N
1252	(0019,"PHILIPS MR/PART",10e1)	(0019,"PHILIPS MR/PART",e1)	PHILIPS MR/PART	25	225	t	0010	IS	1	Unknown	\N
1253	(0019,"PHILIPS MR/PART",1100)	(0019,"PHILIPS MR/PART",00)	PHILIPS MR/PART	25	0	t	0011	IS	1	NumberOfStacks	\N
1254	(0019,"PHILIPS MR/PART",1101)	(0019,"PHILIPS MR/PART",01)	PHILIPS MR/PART	25	1	t	0011	IS	1-n	StackType	\N
1255	(0019,"PHILIPS MR/PART",1102)	(0019,"PHILIPS MR/PART",02)	PHILIPS MR/PART	25	2	t	0011	IS	1-n	Unknown	\N
1256	(0019,"PHILIPS MR/PART",110b)	(0019,"PHILIPS MR/PART",0b)	PHILIPS MR/PART	25	11	t	0011	DS	1	LROffcenter	\N
1257	(0019,"PHILIPS MR/PART",110c)	(0019,"PHILIPS MR/PART",0c)	PHILIPS MR/PART	25	12	t	0011	DS	1	CCOffcenter	\N
1258	(0019,"PHILIPS MR/PART",110d)	(0019,"PHILIPS MR/PART",0d)	PHILIPS MR/PART	25	13	t	0011	DS	1	APOffcenter	\N
1259	(0019,"PHILIPS MR/PART",1145)	(0019,"PHILIPS MR/PART",45)	PHILIPS MR/PART	25	69	t	0011	IS	1	ReconstructionResolution	\N
1260	(0019,"PHILIPS MR/PART",11fc)	(0019,"PHILIPS MR/PART",fc)	PHILIPS MR/PART	25	252	t	0011	IS	1	ResonanceFrequency	\N
1261	(0019,"PHILIPS MR/PART",12c0)	(0019,"PHILIPS MR/PART",c0)	PHILIPS MR/PART	25	192	t	0012	DS	1	TriggerDelayTimes	\N
1262	(0019,"PHILIPS MR/PART",12e0)	(0019,"PHILIPS MR/PART",e0)	PHILIPS MR/PART	25	224	t	0012	IS	1	PrepulseType	\N
1263	(0019,"PHILIPS MR/PART",12e1)	(0019,"PHILIPS MR/PART",e1)	PHILIPS MR/PART	25	225	t	0012	DS	1	PrepulseDelay	\N
1264	(0019,"PHILIPS MR/PART",12e3)	(0019,"PHILIPS MR/PART",e3)	PHILIPS MR/PART	25	227	t	0012	DS	1	PhaseContrastVelocity	\N
1265	(0021,"PHILIPS MR/PART",1000)	(0021,"PHILIPS MR/PART",00)	PHILIPS MR/PART	33	0	t	0010	IS	1	ReconstructionNumber	\N
1266	(0021,"PHILIPS MR/PART",1010)	(0021,"PHILIPS MR/PART",10)	PHILIPS MR/PART	33	16	t	0010	IS	1	ImageType	\N
1267	(0021,"PHILIPS MR/PART",1020)	(0021,"PHILIPS MR/PART",20)	PHILIPS MR/PART	33	32	t	0010	IS	1	SliceNumber	\N
1268	(0021,"PHILIPS MR/PART",1030)	(0021,"PHILIPS MR/PART",30)	PHILIPS MR/PART	33	48	t	0010	IS	1	EchoNumber	\N
1269	(0021,"PHILIPS MR/PART",1031)	(0021,"PHILIPS MR/PART",31)	PHILIPS MR/PART	33	49	t	0010	DS	1	PatientReferenceID	\N
1270	(0021,"PHILIPS MR/PART",1035)	(0021,"PHILIPS MR/PART",35)	PHILIPS MR/PART	33	53	t	0010	IS	1	ChemicalShiftNumber	\N
1271	(0021,"PHILIPS MR/PART",1040)	(0021,"PHILIPS MR/PART",40)	PHILIPS MR/PART	33	64	t	0010	IS	1	PhaseNumber	\N
1272	(0021,"PHILIPS MR/PART",1050)	(0021,"PHILIPS MR/PART",50)	PHILIPS MR/PART	33	80	t	0010	IS	1	DynamicScanNumber	\N
1273	(0021,"PHILIPS MR/PART",1060)	(0021,"PHILIPS MR/PART",60)	PHILIPS MR/PART	33	96	t	0010	IS	1	NumberOfRowsInObject	\N
1274	(0021,"PHILIPS MR/PART",1061)	(0021,"PHILIPS MR/PART",61)	PHILIPS MR/PART	33	97	t	0010	IS	1-n	RowNumber	\N
1275	(0021,"PHILIPS MR/PART",1062)	(0021,"PHILIPS MR/PART",62)	PHILIPS MR/PART	33	98	t	0010	IS	1-n	Unknown	\N
1276	(0021,"PHILIPS MR/PART",1100)	(0021,"PHILIPS MR/PART",00)	PHILIPS MR/PART	33	0	t	0011	DA	1	ScanDate	\N
1277	(0021,"PHILIPS MR/PART",1110)	(0021,"PHILIPS MR/PART",10)	PHILIPS MR/PART	33	16	t	0011	TM	1	ScanTime	\N
1278	(0021,"PHILIPS MR/PART",1221)	(0021,"PHILIPS MR/PART",21)	PHILIPS MR/PART	33	33	t	0012	IS	1	SliceGap	\N
1279	(0029,"PHILIPS MR/PART",00)	(0029,"PHILIPS MR/PART",00)	PHILIPS MR/PART	41	0	f	\N	DS	2	Unknown	\N
1280	(0029,"PHILIPS MR/PART",04)	(0029,"PHILIPS MR/PART",04)	PHILIPS MR/PART	41	4	f	\N	US	1	Unknown	\N
1281	(0029,"PHILIPS MR/PART",10)	(0029,"PHILIPS MR/PART",10)	PHILIPS MR/PART	41	16	f	\N	DS	1	Unknown	\N
1282	(0029,"PHILIPS MR/PART",11)	(0029,"PHILIPS MR/PART",11)	PHILIPS MR/PART	41	17	f	\N	DS	1	Unknown	\N
1283	(0029,"PHILIPS MR/PART",20)	(0029,"PHILIPS MR/PART",20)	PHILIPS MR/PART	41	32	f	\N	LO	1	Unknown	\N
1284	(0029,"PHILIPS MR/PART",31)	(0029,"PHILIPS MR/PART",31)	PHILIPS MR/PART	41	49	f	\N	DS	2	Unknown	\N
1285	(0029,"PHILIPS MR/PART",32)	(0029,"PHILIPS MR/PART",32)	PHILIPS MR/PART	41	50	f	\N	DS	2	Unknown	\N
1286	(0029,"PHILIPS MR/PART",c3)	(0029,"PHILIPS MR/PART",c3)	PHILIPS MR/PART	41	195	f	\N	IS	1	ScanResolution	\N
1287	(0029,"PHILIPS MR/PART",c4)	(0029,"PHILIPS MR/PART",c4)	PHILIPS MR/PART	41	196	f	\N	IS	1	FieldOfView	\N
1288	(0029,"PHILIPS MR/PART",d5)	(0029,"PHILIPS MR/PART",d5)	PHILIPS MR/PART	41	213	f	\N	LT	1	SliceThickness	\N
1289	(0019,"PHILIPS-MR-1",11)	(0019,"PHILIPS-MR-1",11)	PHILIPS-MR-1	25	17	f	\N	IS	1	ChemicalShiftNumber	\N
1290	(0019,"PHILIPS-MR-1",12)	(0019,"PHILIPS-MR-1",12)	PHILIPS-MR-1	25	18	f	\N	IS	1	PhaseNumber	\N
1291	(0021,"PHILIPS-MR-1",01)	(0021,"PHILIPS-MR-1",01)	PHILIPS-MR-1	33	1	f	\N	IS	1	ReconstructionNumber	\N
1292	(0021,"PHILIPS-MR-1",02)	(0021,"PHILIPS-MR-1",02)	PHILIPS-MR-1	33	2	f	\N	IS	1	SliceNumber	\N
1293	(7001,"Picker NM Private Group",01)	(7001,"Picker NM Private Group",01)	Picker NM Private Group	28673	1	f	\N	UI	1	Unknown	\N
1294	(7001,"Picker NM Private Group",02)	(7001,"Picker NM Private Group",02)	Picker NM Private Group	28673	2	f	\N	OB	1	Unknown	\N
1295	(0019,"SIEMENS CM VA0  ACQU",10)	(0019,"SIEMENS CM VA0  ACQU",10)	SIEMENS CM VA0  ACQU	25	16	f	\N	LT	1	ParameterFileName	\N
1296	(0019,"SIEMENS CM VA0  ACQU",11)	(0019,"SIEMENS CM VA0  ACQU",11)	SIEMENS CM VA0  ACQU	25	17	f	\N	LO	1	SequenceFileName	\N
1297	(0019,"SIEMENS CM VA0  ACQU",12)	(0019,"SIEMENS CM VA0  ACQU",12)	SIEMENS CM VA0  ACQU	25	18	f	\N	LT	1	SequenceFileOwner	\N
1298	(0019,"SIEMENS CM VA0  ACQU",13)	(0019,"SIEMENS CM VA0  ACQU",13)	SIEMENS CM VA0  ACQU	25	19	f	\N	LT	1	SequenceDescription	\N
1299	(0019,"SIEMENS CM VA0  ACQU",14)	(0019,"SIEMENS CM VA0  ACQU",14)	SIEMENS CM VA0  ACQU	25	20	f	\N	LT	1	EPIFileName	\N
1300	(0009,"SIEMENS CM VA0  CMS",00)	(0009,"SIEMENS CM VA0  CMS",00)	SIEMENS CM VA0  CMS	9	0	f	\N	DS	1	NumberOfMeasurements	\N
1301	(0009,"SIEMENS CM VA0  CMS",10)	(0009,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	9	16	f	\N	LT	1	StorageMode	\N
1302	(0009,"SIEMENS CM VA0  CMS",12)	(0009,"SIEMENS CM VA0  CMS",12)	SIEMENS CM VA0  CMS	9	18	f	\N	UL	1	EvaluationMaskImage	\N
1303	(0009,"SIEMENS CM VA0  CMS",26)	(0009,"SIEMENS CM VA0  CMS",26)	SIEMENS CM VA0  CMS	9	38	f	\N	DA	1	LastMoveDate	\N
1304	(0009,"SIEMENS CM VA0  CMS",27)	(0009,"SIEMENS CM VA0  CMS",27)	SIEMENS CM VA0  CMS	9	39	f	\N	TM	1	LastMoveTime	\N
1305	(0011,"SIEMENS CM VA0  CMS",0a)	(0011,"SIEMENS CM VA0  CMS",0a)	SIEMENS CM VA0  CMS	17	10	f	\N	LT	1	Unknown	\N
1306	(0011,"SIEMENS CM VA0  CMS",10)	(0011,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	17	16	f	\N	DA	1	RegistrationDate	\N
1307	(0011,"SIEMENS CM VA0  CMS",11)	(0011,"SIEMENS CM VA0  CMS",11)	SIEMENS CM VA0  CMS	17	17	f	\N	TM	1	RegistrationTime	\N
1308	(0011,"SIEMENS CM VA0  CMS",22)	(0011,"SIEMENS CM VA0  CMS",22)	SIEMENS CM VA0  CMS	17	34	f	\N	LT	1	Unknown	\N
1309	(0011,"SIEMENS CM VA0  CMS",23)	(0011,"SIEMENS CM VA0  CMS",23)	SIEMENS CM VA0  CMS	17	35	f	\N	DS	1	UsedPatientWeight	\N
1310	(0011,"SIEMENS CM VA0  CMS",40)	(0011,"SIEMENS CM VA0  CMS",40)	SIEMENS CM VA0  CMS	17	64	f	\N	IS	1	OrganCode	\N
1311	(0013,"SIEMENS CM VA0  CMS",00)	(0013,"SIEMENS CM VA0  CMS",00)	SIEMENS CM VA0  CMS	19	0	f	\N	LT	1	ModifyingPhysician	\N
1312	(0013,"SIEMENS CM VA0  CMS",10)	(0013,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	19	16	f	\N	DA	1	ModificationDate	\N
1313	(0013,"SIEMENS CM VA0  CMS",12)	(0013,"SIEMENS CM VA0  CMS",12)	SIEMENS CM VA0  CMS	19	18	f	\N	TM	1	ModificationTime	\N
1314	(0013,"SIEMENS CM VA0  CMS",20)	(0013,"SIEMENS CM VA0  CMS",20)	SIEMENS CM VA0  CMS	19	32	f	\N	LO	1	PatientName	\N
1315	(0013,"SIEMENS CM VA0  CMS",22)	(0013,"SIEMENS CM VA0  CMS",22)	SIEMENS CM VA0  CMS	19	34	f	\N	LO	1	PatientId	\N
1316	(0013,"SIEMENS CM VA0  CMS",30)	(0013,"SIEMENS CM VA0  CMS",30)	SIEMENS CM VA0  CMS	19	48	f	\N	DA	1	PatientBirthdate	\N
1317	(0013,"SIEMENS CM VA0  CMS",31)	(0013,"SIEMENS CM VA0  CMS",31)	SIEMENS CM VA0  CMS	19	49	f	\N	DS	1	PatientWeight	\N
1318	(0013,"SIEMENS CM VA0  CMS",32)	(0013,"SIEMENS CM VA0  CMS",32)	SIEMENS CM VA0  CMS	19	50	f	\N	LT	1	PatientsMaidenName	\N
1319	(0013,"SIEMENS CM VA0  CMS",33)	(0013,"SIEMENS CM VA0  CMS",33)	SIEMENS CM VA0  CMS	19	51	f	\N	LT	1	ReferringPhysician	\N
1320	(0013,"SIEMENS CM VA0  CMS",34)	(0013,"SIEMENS CM VA0  CMS",34)	SIEMENS CM VA0  CMS	19	52	f	\N	LT	1	AdmittingDiagnosis	\N
1321	(0013,"SIEMENS CM VA0  CMS",35)	(0013,"SIEMENS CM VA0  CMS",35)	SIEMENS CM VA0  CMS	19	53	f	\N	LO	1	PatientSex	\N
1322	(0013,"SIEMENS CM VA0  CMS",40)	(0013,"SIEMENS CM VA0  CMS",40)	SIEMENS CM VA0  CMS	19	64	f	\N	LO	1	ProcedureDescription	\N
1323	(0013,"SIEMENS CM VA0  CMS",42)	(0013,"SIEMENS CM VA0  CMS",42)	SIEMENS CM VA0  CMS	19	66	f	\N	LO	1	RestDirection	\N
1324	(0013,"SIEMENS CM VA0  CMS",44)	(0013,"SIEMENS CM VA0  CMS",44)	SIEMENS CM VA0  CMS	19	68	f	\N	LO	1	PatientPosition	\N
1325	(0013,"SIEMENS CM VA0  CMS",46)	(0013,"SIEMENS CM VA0  CMS",46)	SIEMENS CM VA0  CMS	19	70	f	\N	LT	1	ViewDirection	\N
1326	(0013,"SIEMENS CM VA0  CMS",50)	(0013,"SIEMENS CM VA0  CMS",50)	SIEMENS CM VA0  CMS	19	80	f	\N	LT	1	Unknown	\N
1327	(0013,"SIEMENS CM VA0  CMS",51)	(0013,"SIEMENS CM VA0  CMS",51)	SIEMENS CM VA0  CMS	19	81	f	\N	LT	1	Unknown	\N
1328	(0013,"SIEMENS CM VA0  CMS",52)	(0013,"SIEMENS CM VA0  CMS",52)	SIEMENS CM VA0  CMS	19	82	f	\N	LT	1	Unknown	\N
1329	(0013,"SIEMENS CM VA0  CMS",53)	(0013,"SIEMENS CM VA0  CMS",53)	SIEMENS CM VA0  CMS	19	83	f	\N	LT	1	Unknown	\N
1330	(0013,"SIEMENS CM VA0  CMS",54)	(0013,"SIEMENS CM VA0  CMS",54)	SIEMENS CM VA0  CMS	19	84	f	\N	LT	1	Unknown	\N
1331	(0013,"SIEMENS CM VA0  CMS",55)	(0013,"SIEMENS CM VA0  CMS",55)	SIEMENS CM VA0  CMS	19	85	f	\N	LT	1	Unknown	\N
1332	(0013,"SIEMENS CM VA0  CMS",56)	(0013,"SIEMENS CM VA0  CMS",56)	SIEMENS CM VA0  CMS	19	86	f	\N	LT	1	Unknown	\N
1333	(0019,"SIEMENS CM VA0  CMS",10)	(0019,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	25	16	f	\N	DS	1	NetFrequency	\N
1334	(0019,"SIEMENS CM VA0  CMS",20)	(0019,"SIEMENS CM VA0  CMS",20)	SIEMENS CM VA0  CMS	25	32	f	\N	LT	1	MeasurementMode	\N
1335	(0019,"SIEMENS CM VA0  CMS",30)	(0019,"SIEMENS CM VA0  CMS",30)	SIEMENS CM VA0  CMS	25	48	f	\N	LT	1	CalculationMode	\N
1336	(0019,"SIEMENS CM VA0  CMS",50)	(0019,"SIEMENS CM VA0  CMS",50)	SIEMENS CM VA0  CMS	25	80	f	\N	IS	1	NoiseLevel	\N
1337	(0019,"SIEMENS CM VA0  CMS",60)	(0019,"SIEMENS CM VA0  CMS",60)	SIEMENS CM VA0  CMS	25	96	f	\N	IS	1	NumberOfDataBytes	\N
1338	(0021,"SIEMENS CM VA0  CMS",20)	(0021,"SIEMENS CM VA0  CMS",20)	SIEMENS CM VA0  CMS	33	32	f	\N	DS	2	FoV	\N
1339	(0021,"SIEMENS CM VA0  CMS",22)	(0021,"SIEMENS CM VA0  CMS",22)	SIEMENS CM VA0  CMS	33	34	f	\N	DS	1	ImageMagnificationFactor	\N
1340	(0021,"SIEMENS CM VA0  CMS",24)	(0021,"SIEMENS CM VA0  CMS",24)	SIEMENS CM VA0  CMS	33	36	f	\N	DS	2	ImageScrollOffset	\N
1341	(0021,"SIEMENS CM VA0  CMS",26)	(0021,"SIEMENS CM VA0  CMS",26)	SIEMENS CM VA0  CMS	33	38	f	\N	IS	1	ImagePixelOffset	\N
1342	(0021,"SIEMENS CM VA0  CMS",30)	(0021,"SIEMENS CM VA0  CMS",30)	SIEMENS CM VA0  CMS	33	48	f	\N	LT	1	ViewDirection	\N
1343	(0021,"SIEMENS CM VA0  CMS",32)	(0021,"SIEMENS CM VA0  CMS",32)	SIEMENS CM VA0  CMS	33	50	f	\N	CS	1	PatientRestDirection	\N
1344	(0021,"SIEMENS CM VA0  CMS",60)	(0021,"SIEMENS CM VA0  CMS",60)	SIEMENS CM VA0  CMS	33	96	f	\N	DS	3	ImagePosition	\N
1345	(0021,"SIEMENS CM VA0  CMS",61)	(0021,"SIEMENS CM VA0  CMS",61)	SIEMENS CM VA0  CMS	33	97	f	\N	DS	3	ImageNormal	\N
1346	(0021,"SIEMENS CM VA0  CMS",63)	(0021,"SIEMENS CM VA0  CMS",63)	SIEMENS CM VA0  CMS	33	99	f	\N	DS	1	ImageDistance	\N
1347	(0021,"SIEMENS CM VA0  CMS",65)	(0021,"SIEMENS CM VA0  CMS",65)	SIEMENS CM VA0  CMS	33	101	f	\N	US	1	ImagePositioningHistoryMask	\N
1348	(0021,"SIEMENS CM VA0  CMS",6a)	(0021,"SIEMENS CM VA0  CMS",6a)	SIEMENS CM VA0  CMS	33	106	f	\N	DS	3	ImageRow	\N
1349	(0021,"SIEMENS CM VA0  CMS",6b)	(0021,"SIEMENS CM VA0  CMS",6b)	SIEMENS CM VA0  CMS	33	107	f	\N	DS	3	ImageColumn	\N
1350	(0021,"SIEMENS CM VA0  CMS",70)	(0021,"SIEMENS CM VA0  CMS",70)	SIEMENS CM VA0  CMS	33	112	f	\N	LT	3	PatientOrientationSet1	\N
1351	(0021,"SIEMENS CM VA0  CMS",71)	(0021,"SIEMENS CM VA0  CMS",71)	SIEMENS CM VA0  CMS	33	113	f	\N	LT	3	PatientOrientationSet2	\N
1352	(0021,"SIEMENS CM VA0  CMS",80)	(0021,"SIEMENS CM VA0  CMS",80)	SIEMENS CM VA0  CMS	33	128	f	\N	LT	1	StudyName	\N
1353	(0021,"SIEMENS CM VA0  CMS",82)	(0021,"SIEMENS CM VA0  CMS",82)	SIEMENS CM VA0  CMS	33	130	f	\N	LT	3	StudyType	\N
1354	(0029,"SIEMENS CM VA0  CMS",10)	(0029,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	41	16	f	\N	LT	1	WindowStyle	\N
1355	(0029,"SIEMENS CM VA0  CMS",11)	(0029,"SIEMENS CM VA0  CMS",11)	SIEMENS CM VA0  CMS	41	17	f	\N	LT	1	Unknown	\N
1356	(0029,"SIEMENS CM VA0  CMS",13)	(0029,"SIEMENS CM VA0  CMS",13)	SIEMENS CM VA0  CMS	41	19	f	\N	LT	1	Unknown	\N
1357	(0029,"SIEMENS CM VA0  CMS",20)	(0029,"SIEMENS CM VA0  CMS",20)	SIEMENS CM VA0  CMS	41	32	f	\N	LT	3	PixelQualityCode	\N
1358	(0029,"SIEMENS CM VA0  CMS",22)	(0029,"SIEMENS CM VA0  CMS",22)	SIEMENS CM VA0  CMS	41	34	f	\N	IS	3	PixelQualityValue	\N
1359	(0029,"SIEMENS CM VA0  CMS",50)	(0029,"SIEMENS CM VA0  CMS",50)	SIEMENS CM VA0  CMS	41	80	f	\N	LT	1	ArchiveCode	\N
1360	(0029,"SIEMENS CM VA0  CMS",51)	(0029,"SIEMENS CM VA0  CMS",51)	SIEMENS CM VA0  CMS	41	81	f	\N	LT	1	ExposureCode	\N
1361	(0029,"SIEMENS CM VA0  CMS",52)	(0029,"SIEMENS CM VA0  CMS",52)	SIEMENS CM VA0  CMS	41	82	f	\N	LT	1	SortCode	\N
1362	(0029,"SIEMENS CM VA0  CMS",53)	(0029,"SIEMENS CM VA0  CMS",53)	SIEMENS CM VA0  CMS	41	83	f	\N	LT	1	Unknown	\N
1363	(0029,"SIEMENS CM VA0  CMS",60)	(0029,"SIEMENS CM VA0  CMS",60)	SIEMENS CM VA0  CMS	41	96	f	\N	LT	1	Splash	\N
1364	(0051,"SIEMENS CM VA0  CMS",10)	(0051,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	81	16	f	\N	LT	1-n	ImageText	\N
1365	(6021,"SIEMENS CM VA0  CMS",00)	(6021,"SIEMENS CM VA0  CMS",00)	SIEMENS CM VA0  CMS	24609	0	f	\N	LT	1	ImageGraphicsFormatCode	\N
1366	(6021,"SIEMENS CM VA0  CMS",10)	(6021,"SIEMENS CM VA0  CMS",10)	SIEMENS CM VA0  CMS	24609	16	f	\N	LT	1	ImageGraphics	\N
1367	(7fe1,"SIEMENS CM VA0  CMS",00)	(7fe1,"SIEMENS CM VA0  CMS",00)	SIEMENS CM VA0  CMS	32737	0	f	\N	OB	1-n	BinaryData	\N
1368	(0009,"SIEMENS CM VA0  LAB",10)	(0009,"SIEMENS CM VA0  LAB",10)	SIEMENS CM VA0  LAB	9	16	f	\N	LT	1	GeneratorIdentificationLabel	\N
1369	(0009,"SIEMENS CM VA0  LAB",11)	(0009,"SIEMENS CM VA0  LAB",11)	SIEMENS CM VA0  LAB	9	17	f	\N	LT	1	GantryIdentificationLabel	\N
1370	(0009,"SIEMENS CM VA0  LAB",12)	(0009,"SIEMENS CM VA0  LAB",12)	SIEMENS CM VA0  LAB	9	18	f	\N	LT	1	X-RayTubeIdentificationLabel	\N
2640	(0019,"SVISION",80)	(0019,"SVISION",80)	SVISION	25	128	f	\N	IS	1	BuckyFormat	\N
1371	(0009,"SIEMENS CM VA0  LAB",13)	(0009,"SIEMENS CM VA0  LAB",13)	SIEMENS CM VA0  LAB	9	19	f	\N	LT	1	DetectorIdentificationLabel	\N
1372	(0009,"SIEMENS CM VA0  LAB",14)	(0009,"SIEMENS CM VA0  LAB",14)	SIEMENS CM VA0  LAB	9	20	f	\N	LT	1	DASIdentificationLabel	\N
1373	(0009,"SIEMENS CM VA0  LAB",15)	(0009,"SIEMENS CM VA0  LAB",15)	SIEMENS CM VA0  LAB	9	21	f	\N	LT	1	SMIIdentificationLabel	\N
1374	(0009,"SIEMENS CM VA0  LAB",16)	(0009,"SIEMENS CM VA0  LAB",16)	SIEMENS CM VA0  LAB	9	22	f	\N	LT	1	CPUIdentificationLabel	\N
1375	(0009,"SIEMENS CM VA0  LAB",20)	(0009,"SIEMENS CM VA0  LAB",20)	SIEMENS CM VA0  LAB	9	32	f	\N	LT	1	HeaderVersion	\N
1384	(0029,"SIEMENS CSA NON-IMAGE",10)	(0029,"SIEMENS CSA NON-IMAGE",10)	SIEMENS CSA NON-IMAGE	41	16	f	\N	OB	1	CSADataInfo	\N
1385	(7FE1,"SIEMENS CSA NON-IMAGE",10)	(7FE1,"SIEMENS CSA NON-IMAGE",10)	SIEMENS CSA NON-IMAGE	32737	16	f	\N	OB	1	CSAData	\N
1386	(0019,"SIEMENS CT VA0  COAD",10)	(0019,"SIEMENS CT VA0  COAD",10)	SIEMENS CT VA0  COAD	25	16	f	\N	DS	1	DistanceSourceToSourceSideCollimator	\N
1387	(0019,"SIEMENS CT VA0  COAD",11)	(0019,"SIEMENS CT VA0  COAD",11)	SIEMENS CT VA0  COAD	25	17	f	\N	DS	1	DistanceSourceToDetectorSideCollimator	\N
1388	(0019,"SIEMENS CT VA0  COAD",20)	(0019,"SIEMENS CT VA0  COAD",20)	SIEMENS CT VA0  COAD	25	32	f	\N	IS	1	NumberOfPossibleChannels	\N
1389	(0019,"SIEMENS CT VA0  COAD",21)	(0019,"SIEMENS CT VA0  COAD",21)	SIEMENS CT VA0  COAD	25	33	f	\N	IS	1	MeanChannelNumber	\N
1390	(0019,"SIEMENS CT VA0  COAD",22)	(0019,"SIEMENS CT VA0  COAD",22)	SIEMENS CT VA0  COAD	25	34	f	\N	DS	1	DetectorSpacing	\N
1391	(0019,"SIEMENS CT VA0  COAD",23)	(0019,"SIEMENS CT VA0  COAD",23)	SIEMENS CT VA0  COAD	25	35	f	\N	DS	1	DetectorCenter	\N
1392	(0019,"SIEMENS CT VA0  COAD",24)	(0019,"SIEMENS CT VA0  COAD",24)	SIEMENS CT VA0  COAD	25	36	f	\N	DS	1	ReadingIntegrationTime	\N
1393	(0019,"SIEMENS CT VA0  COAD",50)	(0019,"SIEMENS CT VA0  COAD",50)	SIEMENS CT VA0  COAD	25	80	f	\N	DS	1	DetectorAlignment	\N
1394	(0019,"SIEMENS CT VA0  COAD",52)	(0019,"SIEMENS CT VA0  COAD",52)	SIEMENS CT VA0  COAD	25	82	f	\N	DS	1	Unknown	\N
1395	(0019,"SIEMENS CT VA0  COAD",54)	(0019,"SIEMENS CT VA0  COAD",54)	SIEMENS CT VA0  COAD	25	84	f	\N	DS	1	Unknown	\N
1396	(0019,"SIEMENS CT VA0  COAD",60)	(0019,"SIEMENS CT VA0  COAD",60)	SIEMENS CT VA0  COAD	25	96	f	\N	DS	1	FocusAlignment	\N
1397	(0019,"SIEMENS CT VA0  COAD",65)	(0019,"SIEMENS CT VA0  COAD",65)	SIEMENS CT VA0  COAD	25	101	f	\N	UL	1	FocalSpotDeflectionAmplitude	\N
1398	(0019,"SIEMENS CT VA0  COAD",66)	(0019,"SIEMENS CT VA0  COAD",66)	SIEMENS CT VA0  COAD	25	102	f	\N	UL	1	FocalSpotDeflectionPhase	\N
1399	(0019,"SIEMENS CT VA0  COAD",67)	(0019,"SIEMENS CT VA0  COAD",67)	SIEMENS CT VA0  COAD	25	103	f	\N	UL	1	FocalSpotDeflectionOffset	\N
1400	(0019,"SIEMENS CT VA0  COAD",70)	(0019,"SIEMENS CT VA0  COAD",70)	SIEMENS CT VA0  COAD	25	112	f	\N	DS	1	WaterScalingFactor	\N
1401	(0019,"SIEMENS CT VA0  COAD",71)	(0019,"SIEMENS CT VA0  COAD",71)	SIEMENS CT VA0  COAD	25	113	f	\N	DS	1	InterpolationFactor	\N
1402	(0019,"SIEMENS CT VA0  COAD",80)	(0019,"SIEMENS CT VA0  COAD",80)	SIEMENS CT VA0  COAD	25	128	f	\N	LT	1	PatientRegion	\N
1403	(0019,"SIEMENS CT VA0  COAD",82)	(0019,"SIEMENS CT VA0  COAD",82)	SIEMENS CT VA0  COAD	25	130	f	\N	LT	1	PatientPhaseOfLife	\N
10968	(0119,"MRSC",1181)	(0119,"MRSC",81)	MRSC	281	129	t	11	IS	1	fmSQFitNumber	K
1407	(0019,"SIEMENS CT VA0  COAD",94)	(0019,"SIEMENS CT VA0  COAD",94)	SIEMENS CT VA0  COAD	25	148	f	\N	DS	1	OsteoStandardizationCode	\N
1409	(0019,"SIEMENS CT VA0  COAD",A3)	(0019,"SIEMENS CT VA0  COAD",A3)	SIEMENS CT VA0  COAD	25	163	f	\N	US	1-n	Unknown	\N
1410	(0019,"SIEMENS CT VA0  COAD",A4)	(0019,"SIEMENS CT VA0  COAD",A4)	SIEMENS CT VA0  COAD	25	164	f	\N	DS	1	Unknown	\N
1411	(0019,"SIEMENS CT VA0  COAD",A5)	(0019,"SIEMENS CT VA0  COAD",A5)	SIEMENS CT VA0  COAD	25	165	f	\N	DS	1	Unknown	\N
1412	(0019,"SIEMENS CT VA0  COAD",A6)	(0019,"SIEMENS CT VA0  COAD",A6)	SIEMENS CT VA0  COAD	25	166	f	\N	US	1-n	Unknown	\N
1413	(0019,"SIEMENS CT VA0  COAD",A7)	(0019,"SIEMENS CT VA0  COAD",A7)	SIEMENS CT VA0  COAD	25	167	f	\N	US	1-n	Unknown	\N
1414	(0019,"SIEMENS CT VA0  COAD",A8)	(0019,"SIEMENS CT VA0  COAD",A8)	SIEMENS CT VA0  COAD	25	168	f	\N	US	1-n	Unknown	\N
1415	(0019,"SIEMENS CT VA0  COAD",A9)	(0019,"SIEMENS CT VA0  COAD",A9)	SIEMENS CT VA0  COAD	25	169	f	\N	DS	1	Unknown	\N
1416	(0019,"SIEMENS CT VA0  COAD",AA)	(0019,"SIEMENS CT VA0  COAD",AA)	SIEMENS CT VA0  COAD	25	170	f	\N	LT	1	Unknown	\N
1417	(0019,"SIEMENS CT VA0  COAD",AB)	(0019,"SIEMENS CT VA0  COAD",AB)	SIEMENS CT VA0  COAD	25	171	f	\N	DS	1	Unknown	\N
1418	(0019,"SIEMENS CT VA0  COAD",AC)	(0019,"SIEMENS CT VA0  COAD",AC)	SIEMENS CT VA0  COAD	25	172	f	\N	DS	1	Unknown	\N
1419	(0019,"SIEMENS CT VA0  COAD",AD)	(0019,"SIEMENS CT VA0  COAD",AD)	SIEMENS CT VA0  COAD	25	173	f	\N	DS	1	Unknown	\N
1420	(0019,"SIEMENS CT VA0  COAD",AE)	(0019,"SIEMENS CT VA0  COAD",AE)	SIEMENS CT VA0  COAD	25	174	f	\N	DS	1	Unknown	\N
1421	(0019,"SIEMENS CT VA0  COAD",AF)	(0019,"SIEMENS CT VA0  COAD",AF)	SIEMENS CT VA0  COAD	25	175	f	\N	DS	1	Unknown	\N
1405	(0019,"SIEMENS CT VA0  COAD",92)	(0019,"SIEMENS CT VA0  COAD",92)	SIEMENS CT VA0  COAD	25	146	f	\N	DS	1	OsteoRegressionLineSlope	K
1406	(0019,"SIEMENS CT VA0  COAD",93)	(0019,"SIEMENS CT VA0  COAD",93)	SIEMENS CT VA0  COAD	25	147	f	\N	DS	1	OsteoRegressionLineIntercept	K
1408	(0019,"SIEMENS CT VA0  COAD",96)	(0019,"SIEMENS CT VA0  COAD",96)	SIEMENS CT VA0  COAD	25	150	f	\N	IS	1	OsteoPhantomNumber	R
1376	(0029,"SIEMENS CSA HEADER",08)	(0029,"SIEMENS CSA HEADER",08)	SIEMENS CSA HEADER	41	8	f	\N	CS	1	CSAImageHeaderType	X
1377	(0029,"SIEMENS CSA HEADER",09)	(0029,"SIEMENS CSA HEADER",09)	SIEMENS CSA HEADER	41	9	f	\N	LO	1	CSAImageHeaderVersion	X
1378	(0029,"SIEMENS CSA HEADER",10)	(0029,"SIEMENS CSA HEADER",10)	SIEMENS CSA HEADER	41	16	f	\N	OB	1	CSAImageHeaderInfo	X
1379	(0029,"SIEMENS CSA HEADER",18)	(0029,"SIEMENS CSA HEADER",18)	SIEMENS CSA HEADER	41	24	f	\N	CS	1	CSASeriesHeaderType	X
1380	(0029,"SIEMENS CSA HEADER",19)	(0029,"SIEMENS CSA HEADER",19)	SIEMENS CSA HEADER	41	25	f	\N	LO	1	CSASeriesHeaderVersion	X
1381	(0029,"SIEMENS CSA HEADER",20)	(0029,"SIEMENS CSA HEADER",20)	SIEMENS CSA HEADER	41	32	f	\N	OB	1	CSASeriesHeaderInfo	X
1382	(0029,"SIEMENS CSA NON-IMAGE",08)	(0029,"SIEMENS CSA NON-IMAGE",08)	SIEMENS CSA NON-IMAGE	41	8	f	\N	CS	1	CSADataType	X
1383	(0029,"SIEMENS CSA NON-IMAGE",09)	(0029,"SIEMENS CSA NON-IMAGE",09)	SIEMENS CSA NON-IMAGE	41	9	f	\N	LO	1	CSADataVersion	X
1422	(0019,"SIEMENS CT VA0  COAD",B0)	(0019,"SIEMENS CT VA0  COAD",B0)	SIEMENS CT VA0  COAD	25	176	f	\N	DS	1	FeedPerRotation	\N
1423	(0019,"SIEMENS CT VA0  COAD",BD)	(0019,"SIEMENS CT VA0  COAD",BD)	SIEMENS CT VA0  COAD	25	189	f	\N	IS	1	PulmoTriggerLevel	\N
1424	(0019,"SIEMENS CT VA0  COAD",BE)	(0019,"SIEMENS CT VA0  COAD",BE)	SIEMENS CT VA0  COAD	25	190	f	\N	DS	1	ExpiratoricReserveVolume	\N
1425	(0019,"SIEMENS CT VA0  COAD",BF)	(0019,"SIEMENS CT VA0  COAD",BF)	SIEMENS CT VA0  COAD	25	191	f	\N	DS	1	VitalCapacity	\N
1426	(0019,"SIEMENS CT VA0  COAD",C0)	(0019,"SIEMENS CT VA0  COAD",C0)	SIEMENS CT VA0  COAD	25	192	f	\N	DS	1	PulmoWater	\N
1427	(0019,"SIEMENS CT VA0  COAD",C1)	(0019,"SIEMENS CT VA0  COAD",C1)	SIEMENS CT VA0  COAD	25	193	f	\N	DS	1	PulmoAir	\N
1428	(0019,"SIEMENS CT VA0  COAD",C2)	(0019,"SIEMENS CT VA0  COAD",C2)	SIEMENS CT VA0  COAD	25	194	f	\N	DA	1	PulmoDate	\N
1429	(0019,"SIEMENS CT VA0  COAD",C3)	(0019,"SIEMENS CT VA0  COAD",C3)	SIEMENS CT VA0  COAD	25	195	f	\N	TM	1	PulmoTime	\N
1430	(0019,"SIEMENS CT VA0  GEN",10)	(0019,"SIEMENS CT VA0  GEN",10)	SIEMENS CT VA0  GEN	25	16	f	\N	DS	1	SourceSideCollimatorAperture	\N
1431	(0019,"SIEMENS CT VA0  GEN",11)	(0019,"SIEMENS CT VA0  GEN",11)	SIEMENS CT VA0  GEN	25	17	f	\N	DS	1	DetectorSideCollimatorAperture	\N
1432	(0019,"SIEMENS CT VA0  GEN",20)	(0019,"SIEMENS CT VA0  GEN",20)	SIEMENS CT VA0  GEN	25	32	f	\N	DS	1	ExposureTime	\N
1433	(0019,"SIEMENS CT VA0  GEN",21)	(0019,"SIEMENS CT VA0  GEN",21)	SIEMENS CT VA0  GEN	25	33	f	\N	DS	1	ExposureCurrent	\N
1434	(0019,"SIEMENS CT VA0  GEN",25)	(0019,"SIEMENS CT VA0  GEN",25)	SIEMENS CT VA0  GEN	25	37	f	\N	DS	1	KVPGeneratorPowerCurrent	\N
1435	(0019,"SIEMENS CT VA0  GEN",26)	(0019,"SIEMENS CT VA0  GEN",26)	SIEMENS CT VA0  GEN	25	38	f	\N	DS	1	GeneratorVoltage	\N
1436	(0019,"SIEMENS CT VA0  GEN",40)	(0019,"SIEMENS CT VA0  GEN",40)	SIEMENS CT VA0  GEN	25	64	f	\N	UL	1	MasterControlMask	\N
1437	(0019,"SIEMENS CT VA0  GEN",42)	(0019,"SIEMENS CT VA0  GEN",42)	SIEMENS CT VA0  GEN	25	66	f	\N	US	5	ProcessingMask	\N
1438	(0019,"SIEMENS CT VA0  GEN",44)	(0019,"SIEMENS CT VA0  GEN",44)	SIEMENS CT VA0  GEN	25	68	f	\N	US	1-n	Unknown	\N
1439	(0019,"SIEMENS CT VA0  GEN",45)	(0019,"SIEMENS CT VA0  GEN",45)	SIEMENS CT VA0  GEN	25	69	f	\N	US	1-n	Unknown	\N
1440	(0019,"SIEMENS CT VA0  GEN",62)	(0019,"SIEMENS CT VA0  GEN",62)	SIEMENS CT VA0  GEN	25	98	f	\N	IS	1	NumberOfVirtuellChannels	\N
1441	(0019,"SIEMENS CT VA0  GEN",70)	(0019,"SIEMENS CT VA0  GEN",70)	SIEMENS CT VA0  GEN	25	112	f	\N	IS	1	NumberOfReadings	\N
1442	(0019,"SIEMENS CT VA0  GEN",71)	(0019,"SIEMENS CT VA0  GEN",71)	SIEMENS CT VA0  GEN	25	113	f	\N	LT	1-n	Unknown	\N
1443	(0019,"SIEMENS CT VA0  GEN",74)	(0019,"SIEMENS CT VA0  GEN",74)	SIEMENS CT VA0  GEN	25	116	f	\N	IS	1	NumberOfProjections	\N
1444	(0019,"SIEMENS CT VA0  GEN",75)	(0019,"SIEMENS CT VA0  GEN",75)	SIEMENS CT VA0  GEN	25	117	f	\N	IS	1	NumberOfBytes	\N
1445	(0019,"SIEMENS CT VA0  GEN",80)	(0019,"SIEMENS CT VA0  GEN",80)	SIEMENS CT VA0  GEN	25	128	f	\N	LT	1	ReconstructionAlgorithmSet	\N
1446	(0019,"SIEMENS CT VA0  GEN",81)	(0019,"SIEMENS CT VA0  GEN",81)	SIEMENS CT VA0  GEN	25	129	f	\N	LT	1	ReconstructionAlgorithmIndex	\N
1447	(0019,"SIEMENS CT VA0  GEN",82)	(0019,"SIEMENS CT VA0  GEN",82)	SIEMENS CT VA0  GEN	25	130	f	\N	LT	1	RegenerationSoftwareVersion	\N
1448	(0019,"SIEMENS CT VA0  GEN",88)	(0019,"SIEMENS CT VA0  GEN",88)	SIEMENS CT VA0  GEN	25	136	f	\N	DS	1	Unknown	\N
1449	(0021,"SIEMENS CT VA0  GEN",10)	(0021,"SIEMENS CT VA0  GEN",10)	SIEMENS CT VA0  GEN	33	16	f	\N	IS	1	RotationAngle	\N
1450	(0021,"SIEMENS CT VA0  GEN",11)	(0021,"SIEMENS CT VA0  GEN",11)	SIEMENS CT VA0  GEN	33	17	f	\N	IS	1	StartAngle	\N
1451	(0021,"SIEMENS CT VA0  GEN",20)	(0021,"SIEMENS CT VA0  GEN",20)	SIEMENS CT VA0  GEN	33	32	f	\N	US	1-n	Unknown	\N
1452	(0021,"SIEMENS CT VA0  GEN",30)	(0021,"SIEMENS CT VA0  GEN",30)	SIEMENS CT VA0  GEN	33	48	f	\N	IS	1	TopogramTubePosition	\N
1453	(0021,"SIEMENS CT VA0  GEN",32)	(0021,"SIEMENS CT VA0  GEN",32)	SIEMENS CT VA0  GEN	33	50	f	\N	DS	1	LengthOfTopogram	\N
1454	(0021,"SIEMENS CT VA0  GEN",34)	(0021,"SIEMENS CT VA0  GEN",34)	SIEMENS CT VA0  GEN	33	52	f	\N	DS	1	TopogramCorrectionFactor	\N
1455	(0021,"SIEMENS CT VA0  GEN",36)	(0021,"SIEMENS CT VA0  GEN",36)	SIEMENS CT VA0  GEN	33	54	f	\N	DS	1	MaximumTablePosition	\N
1456	(0021,"SIEMENS CT VA0  GEN",40)	(0021,"SIEMENS CT VA0  GEN",40)	SIEMENS CT VA0  GEN	33	64	f	\N	IS	1	TableMoveDirectionCode	\N
1457	(0021,"SIEMENS CT VA0  GEN",45)	(0021,"SIEMENS CT VA0  GEN",45)	SIEMENS CT VA0  GEN	33	69	f	\N	IS	1	VOIStartRow	\N
1458	(0021,"SIEMENS CT VA0  GEN",46)	(0021,"SIEMENS CT VA0  GEN",46)	SIEMENS CT VA0  GEN	33	70	f	\N	IS	1	VOIStopRow	\N
1459	(0021,"SIEMENS CT VA0  GEN",47)	(0021,"SIEMENS CT VA0  GEN",47)	SIEMENS CT VA0  GEN	33	71	f	\N	IS	1	VOIStartColumn	\N
1460	(0021,"SIEMENS CT VA0  GEN",48)	(0021,"SIEMENS CT VA0  GEN",48)	SIEMENS CT VA0  GEN	33	72	f	\N	IS	1	VOIStopColumn	\N
1461	(0021,"SIEMENS CT VA0  GEN",49)	(0021,"SIEMENS CT VA0  GEN",49)	SIEMENS CT VA0  GEN	33	73	f	\N	IS	1	VOIStartSlice	\N
1462	(0021,"SIEMENS CT VA0  GEN",4a)	(0021,"SIEMENS CT VA0  GEN",4a)	SIEMENS CT VA0  GEN	33	74	f	\N	IS	1	VOIStopSlice	\N
1463	(0021,"SIEMENS CT VA0  GEN",50)	(0021,"SIEMENS CT VA0  GEN",50)	SIEMENS CT VA0  GEN	33	80	f	\N	IS	1	VectorStartRow	\N
1464	(0021,"SIEMENS CT VA0  GEN",51)	(0021,"SIEMENS CT VA0  GEN",51)	SIEMENS CT VA0  GEN	33	81	f	\N	IS	1	VectorRowStep	\N
1465	(0021,"SIEMENS CT VA0  GEN",52)	(0021,"SIEMENS CT VA0  GEN",52)	SIEMENS CT VA0  GEN	33	82	f	\N	IS	1	VectorStartColumn	\N
1466	(0021,"SIEMENS CT VA0  GEN",53)	(0021,"SIEMENS CT VA0  GEN",53)	SIEMENS CT VA0  GEN	33	83	f	\N	IS	1	VectorColumnStep	\N
1467	(0021,"SIEMENS CT VA0  GEN",60)	(0021,"SIEMENS CT VA0  GEN",60)	SIEMENS CT VA0  GEN	33	96	f	\N	IS	1	RangeTypeCode	\N
1468	(0021,"SIEMENS CT VA0  GEN",62)	(0021,"SIEMENS CT VA0  GEN",62)	SIEMENS CT VA0  GEN	33	98	f	\N	IS	1	ReferenceTypeCode	\N
1469	(0021,"SIEMENS CT VA0  GEN",70)	(0021,"SIEMENS CT VA0  GEN",70)	SIEMENS CT VA0  GEN	33	112	f	\N	DS	3	ObjectOrientation	\N
1470	(0021,"SIEMENS CT VA0  GEN",72)	(0021,"SIEMENS CT VA0  GEN",72)	SIEMENS CT VA0  GEN	33	114	f	\N	DS	3	LightOrientation	\N
1471	(0021,"SIEMENS CT VA0  GEN",75)	(0021,"SIEMENS CT VA0  GEN",75)	SIEMENS CT VA0  GEN	33	117	f	\N	DS	1	LightBrightness	\N
1472	(0021,"SIEMENS CT VA0  GEN",76)	(0021,"SIEMENS CT VA0  GEN",76)	SIEMENS CT VA0  GEN	33	118	f	\N	DS	1	LightContrast	\N
1473	(0021,"SIEMENS CT VA0  GEN",7a)	(0021,"SIEMENS CT VA0  GEN",7a)	SIEMENS CT VA0  GEN	33	122	f	\N	IS	2	OverlayThreshold	\N
1474	(0021,"SIEMENS CT VA0  GEN",7b)	(0021,"SIEMENS CT VA0  GEN",7b)	SIEMENS CT VA0  GEN	33	123	f	\N	IS	2	SurfaceThreshold	\N
1475	(0021,"SIEMENS CT VA0  GEN",7c)	(0021,"SIEMENS CT VA0  GEN",7c)	SIEMENS CT VA0  GEN	33	124	f	\N	IS	2	GreyScaleThreshold	\N
1476	(0021,"SIEMENS CT VA0  GEN",a0)	(0021,"SIEMENS CT VA0  GEN",a0)	SIEMENS CT VA0  GEN	33	160	f	\N	DS	1	Unknown	\N
1477	(0021,"SIEMENS CT VA0  GEN",a2)	(0021,"SIEMENS CT VA0  GEN",a2)	SIEMENS CT VA0  GEN	33	162	f	\N	LT	1	Unknown	\N
1478	(0021,"SIEMENS CT VA0  GEN",a7)	(0021,"SIEMENS CT VA0  GEN",a7)	SIEMENS CT VA0  GEN	33	167	f	\N	LT	1	Unknown	\N
1479	(0009,"SIEMENS CT VA0  IDE",10)	(0009,"SIEMENS CT VA0  IDE",10)	SIEMENS CT VA0  IDE	9	16	f	\N	LT	1	Unknown	\N
1480	(0009,"SIEMENS CT VA0  IDE",30)	(0009,"SIEMENS CT VA0  IDE",30)	SIEMENS CT VA0  IDE	9	48	f	\N	LT	1	Unknown	\N
1481	(0009,"SIEMENS CT VA0  IDE",31)	(0009,"SIEMENS CT VA0  IDE",31)	SIEMENS CT VA0  IDE	9	49	f	\N	LT	1	Unknown	\N
1482	(0009,"SIEMENS CT VA0  IDE",32)	(0009,"SIEMENS CT VA0  IDE",32)	SIEMENS CT VA0  IDE	9	50	f	\N	LT	1	Unknown	\N
1483	(0009,"SIEMENS CT VA0  IDE",34)	(0009,"SIEMENS CT VA0  IDE",34)	SIEMENS CT VA0  IDE	9	52	f	\N	LT	1	Unknown	\N
1484	(0009,"SIEMENS CT VA0  IDE",40)	(0009,"SIEMENS CT VA0  IDE",40)	SIEMENS CT VA0  IDE	9	64	f	\N	LT	1	Unknown	\N
1485	(0009,"SIEMENS CT VA0  IDE",42)	(0009,"SIEMENS CT VA0  IDE",42)	SIEMENS CT VA0  IDE	9	66	f	\N	LT	1	Unknown	\N
1486	(0009,"SIEMENS CT VA0  IDE",50)	(0009,"SIEMENS CT VA0  IDE",50)	SIEMENS CT VA0  IDE	9	80	f	\N	LT	1	Unknown	\N
1487	(0009,"SIEMENS CT VA0  IDE",51)	(0009,"SIEMENS CT VA0  IDE",51)	SIEMENS CT VA0  IDE	9	81	f	\N	LT	1	Unknown	\N
1488	(0009,"SIEMENS CT VA0  ORI",20)	(0009,"SIEMENS CT VA0  ORI",20)	SIEMENS CT VA0  ORI	9	32	f	\N	LT	1	Unknown	\N
1489	(0009,"SIEMENS CT VA0  ORI",30)	(0009,"SIEMENS CT VA0  ORI",30)	SIEMENS CT VA0  ORI	9	48	f	\N	LT	1	Unknown	\N
1490	(6021,"SIEMENS CT VA0  OST",00)	(6021,"SIEMENS CT VA0  OST",00)	SIEMENS CT VA0  OST	24609	0	f	\N	LT	1	OsteoContourComment	\N
1491	(6021,"SIEMENS CT VA0  OST",10)	(6021,"SIEMENS CT VA0  OST",10)	SIEMENS CT VA0  OST	24609	16	f	\N	US	256	OsteoContourBuffer	\N
1492	(0021,"SIEMENS CT VA0  RAW",10)	(0021,"SIEMENS CT VA0  RAW",10)	SIEMENS CT VA0  RAW	33	16	f	\N	UL	2	CreationMask	\N
1493	(0021,"SIEMENS CT VA0  RAW",20)	(0021,"SIEMENS CT VA0  RAW",20)	SIEMENS CT VA0  RAW	33	32	f	\N	UL	2	EvaluationMask	\N
1494	(0021,"SIEMENS CT VA0  RAW",30)	(0021,"SIEMENS CT VA0  RAW",30)	SIEMENS CT VA0  RAW	33	48	f	\N	US	7	ExtendedProcessingMask	\N
1495	(0021,"SIEMENS CT VA0  RAW",40)	(0021,"SIEMENS CT VA0  RAW",40)	SIEMENS CT VA0  RAW	33	64	f	\N	US	1-n	Unknown	\N
1496	(0021,"SIEMENS CT VA0  RAW",41)	(0021,"SIEMENS CT VA0  RAW",41)	SIEMENS CT VA0  RAW	33	65	f	\N	US	1-n	Unknown	\N
1497	(0021,"SIEMENS CT VA0  RAW",42)	(0021,"SIEMENS CT VA0  RAW",42)	SIEMENS CT VA0  RAW	33	66	f	\N	US	1-n	Unknown	\N
1498	(0021,"SIEMENS CT VA0  RAW",43)	(0021,"SIEMENS CT VA0  RAW",43)	SIEMENS CT VA0  RAW	33	67	f	\N	US	1-n	Unknown	\N
1499	(0021,"SIEMENS CT VA0  RAW",44)	(0021,"SIEMENS CT VA0  RAW",44)	SIEMENS CT VA0  RAW	33	68	f	\N	US	1-n	Unknown	\N
1500	(0021,"SIEMENS CT VA0  RAW",50)	(0021,"SIEMENS CT VA0  RAW",50)	SIEMENS CT VA0  RAW	33	80	f	\N	LT	1	Unknown	\N
1501	(0009,"SIEMENS DICOM",10)	(0009,"SIEMENS DICOM",10)	SIEMENS DICOM	9	16	f	\N	UN	1	Unknown	\N
1502	(0009,"SIEMENS DICOM",12)	(0009,"SIEMENS DICOM",12)	SIEMENS DICOM	9	18	f	\N	LT	1	Unknown	\N
1503	(0019,"SIEMENS DLR.01",10)	(0019,"SIEMENS DLR.01",10)	SIEMENS DLR.01	25	16	f	\N	LT	1	MeasurementMode	\N
1504	(0019,"SIEMENS DLR.01",11)	(0019,"SIEMENS DLR.01",11)	SIEMENS DLR.01	25	17	f	\N	LT	1	ImageType	\N
1505	(0019,"SIEMENS DLR.01",15)	(0019,"SIEMENS DLR.01",15)	SIEMENS DLR.01	25	21	f	\N	LT	1	SoftwareVersion	\N
1506	(0019,"SIEMENS DLR.01",20)	(0019,"SIEMENS DLR.01",20)	SIEMENS DLR.01	25	32	f	\N	LT	1	MPMCode	\N
1507	(0019,"SIEMENS DLR.01",21)	(0019,"SIEMENS DLR.01",21)	SIEMENS DLR.01	25	33	f	\N	LT	1	Latitude	\N
1508	(0019,"SIEMENS DLR.01",22)	(0019,"SIEMENS DLR.01",22)	SIEMENS DLR.01	25	34	f	\N	LT	1	Sensitivity	\N
1509	(0019,"SIEMENS DLR.01",23)	(0019,"SIEMENS DLR.01",23)	SIEMENS DLR.01	25	35	f	\N	LT	1	EDR	\N
1510	(0019,"SIEMENS DLR.01",24)	(0019,"SIEMENS DLR.01",24)	SIEMENS DLR.01	25	36	f	\N	LT	1	LFix	\N
1511	(0019,"SIEMENS DLR.01",25)	(0019,"SIEMENS DLR.01",25)	SIEMENS DLR.01	25	37	f	\N	LT	1	SFix	\N
1512	(0019,"SIEMENS DLR.01",26)	(0019,"SIEMENS DLR.01",26)	SIEMENS DLR.01	25	38	f	\N	LT	1	PresetMode	\N
1513	(0019,"SIEMENS DLR.01",27)	(0019,"SIEMENS DLR.01",27)	SIEMENS DLR.01	25	39	f	\N	LT	1	Region	\N
1514	(0019,"SIEMENS DLR.01",28)	(0019,"SIEMENS DLR.01",28)	SIEMENS DLR.01	25	40	f	\N	LT	1	Subregion	\N
1515	(0019,"SIEMENS DLR.01",30)	(0019,"SIEMENS DLR.01",30)	SIEMENS DLR.01	25	48	f	\N	LT	1	Orientation	\N
1516	(0019,"SIEMENS DLR.01",31)	(0019,"SIEMENS DLR.01",31)	SIEMENS DLR.01	25	49	f	\N	LT	1	MarkOnFilm	\N
1517	(0019,"SIEMENS DLR.01",32)	(0019,"SIEMENS DLR.01",32)	SIEMENS DLR.01	25	50	f	\N	LT	1	RotationOnDRC	\N
1518	(0019,"SIEMENS DLR.01",40)	(0019,"SIEMENS DLR.01",40)	SIEMENS DLR.01	25	64	f	\N	LT	1	ReaderType	\N
1519	(0019,"SIEMENS DLR.01",41)	(0019,"SIEMENS DLR.01",41)	SIEMENS DLR.01	25	65	f	\N	LT	1	SubModality	\N
1520	(0019,"SIEMENS DLR.01",42)	(0019,"SIEMENS DLR.01",42)	SIEMENS DLR.01	25	66	f	\N	LT	1	ReaderSerialNumber	\N
1521	(0019,"SIEMENS DLR.01",50)	(0019,"SIEMENS DLR.01",50)	SIEMENS DLR.01	25	80	f	\N	LT	1	CassetteScale	\N
1522	(0019,"SIEMENS DLR.01",51)	(0019,"SIEMENS DLR.01",51)	SIEMENS DLR.01	25	81	f	\N	LT	1	CassetteMatrix	\N
1523	(0019,"SIEMENS DLR.01",52)	(0019,"SIEMENS DLR.01",52)	SIEMENS DLR.01	25	82	f	\N	LT	1	CassetteSubmatrix	\N
1524	(0019,"SIEMENS DLR.01",53)	(0019,"SIEMENS DLR.01",53)	SIEMENS DLR.01	25	83	f	\N	LT	1	Barcode	\N
1525	(0019,"SIEMENS DLR.01",60)	(0019,"SIEMENS DLR.01",60)	SIEMENS DLR.01	25	96	f	\N	LT	1	ContrastType	\N
1526	(0019,"SIEMENS DLR.01",61)	(0019,"SIEMENS DLR.01",61)	SIEMENS DLR.01	25	97	f	\N	LT	1	RotationAmount	\N
1527	(0019,"SIEMENS DLR.01",62)	(0019,"SIEMENS DLR.01",62)	SIEMENS DLR.01	25	98	f	\N	LT	1	RotationCenter	\N
1528	(0019,"SIEMENS DLR.01",63)	(0019,"SIEMENS DLR.01",63)	SIEMENS DLR.01	25	99	f	\N	LT	1	DensityShift	\N
1529	(0019,"SIEMENS DLR.01",64)	(0019,"SIEMENS DLR.01",64)	SIEMENS DLR.01	25	100	f	\N	US	1	FrequencyRank	\N
1530	(0019,"SIEMENS DLR.01",65)	(0019,"SIEMENS DLR.01",65)	SIEMENS DLR.01	25	101	f	\N	LT	1	FrequencyEnhancement	\N
1531	(0019,"SIEMENS DLR.01",66)	(0019,"SIEMENS DLR.01",66)	SIEMENS DLR.01	25	102	f	\N	LT	1	FrequencyType	\N
1532	(0019,"SIEMENS DLR.01",67)	(0019,"SIEMENS DLR.01",67)	SIEMENS DLR.01	25	103	f	\N	LT	1	KernelLength	\N
1533	(0019,"SIEMENS DLR.01",68)	(0019,"SIEMENS DLR.01",68)	SIEMENS DLR.01	25	104	f	\N	UL	1	KernelMode	\N
1534	(0019,"SIEMENS DLR.01",69)	(0019,"SIEMENS DLR.01",69)	SIEMENS DLR.01	25	105	f	\N	UL	1	ConvolutionMode	\N
1535	(0019,"SIEMENS DLR.01",70)	(0019,"SIEMENS DLR.01",70)	SIEMENS DLR.01	25	112	f	\N	LT	1	PLASource	\N
1536	(0019,"SIEMENS DLR.01",71)	(0019,"SIEMENS DLR.01",71)	SIEMENS DLR.01	25	113	f	\N	LT	1	PLADestination	\N
1537	(0019,"SIEMENS DLR.01",75)	(0019,"SIEMENS DLR.01",75)	SIEMENS DLR.01	25	117	f	\N	LT	1	UIDOriginalImage	\N
1538	(0019,"SIEMENS DLR.01",76)	(0019,"SIEMENS DLR.01",76)	SIEMENS DLR.01	25	118	f	\N	LT	1	Unknown	\N
1539	(0019,"SIEMENS DLR.01",80)	(0019,"SIEMENS DLR.01",80)	SIEMENS DLR.01	25	128	f	\N	LT	1	ReaderHeader	\N
1540	(0019,"SIEMENS DLR.01",90)	(0019,"SIEMENS DLR.01",90)	SIEMENS DLR.01	25	144	f	\N	LT	1	PLAOfSecondaryDestination	\N
1541	(0019,"SIEMENS DLR.01",a0)	(0019,"SIEMENS DLR.01",a0)	SIEMENS DLR.01	25	160	f	\N	DS	1	Unknown	\N
1542	(0019,"SIEMENS DLR.01",a1)	(0019,"SIEMENS DLR.01",a1)	SIEMENS DLR.01	25	161	f	\N	DS	1	Unknown	\N
1543	(0041,"SIEMENS DLR.01",10)	(0041,"SIEMENS DLR.01",10)	SIEMENS DLR.01	65	16	f	\N	US	1	NumberOfHardcopies	\N
1544	(0041,"SIEMENS DLR.01",20)	(0041,"SIEMENS DLR.01",20)	SIEMENS DLR.01	65	32	f	\N	LT	1	FilmFormat	\N
1545	(0041,"SIEMENS DLR.01",30)	(0041,"SIEMENS DLR.01",30)	SIEMENS DLR.01	65	48	f	\N	LT	1	FilmSize	\N
1546	(0041,"SIEMENS DLR.01",31)	(0041,"SIEMENS DLR.01",31)	SIEMENS DLR.01	65	49	f	\N	LT	1	FullFilmFormat	\N
1547	(0003,"SIEMENS ISI",08)	(0003,"SIEMENS ISI",08)	SIEMENS ISI	3	8	f	\N	US	1	ISICommandField	\N
1548	(0003,"SIEMENS ISI",11)	(0003,"SIEMENS ISI",11)	SIEMENS ISI	3	17	f	\N	US	1	AttachIDApplicationCode	\N
1549	(0003,"SIEMENS ISI",12)	(0003,"SIEMENS ISI",12)	SIEMENS ISI	3	18	f	\N	UL	1	AttachIDMessageCount	\N
1550	(0003,"SIEMENS ISI",13)	(0003,"SIEMENS ISI",13)	SIEMENS ISI	3	19	f	\N	DA	1	AttachIDDate	\N
1551	(0003,"SIEMENS ISI",14)	(0003,"SIEMENS ISI",14)	SIEMENS ISI	3	20	f	\N	TM	1	AttachIDTime	\N
1552	(0003,"SIEMENS ISI",20)	(0003,"SIEMENS ISI",20)	SIEMENS ISI	3	32	f	\N	US	1	MessageType	\N
1553	(0003,"SIEMENS ISI",30)	(0003,"SIEMENS ISI",30)	SIEMENS ISI	3	48	f	\N	DA	1	MaxWaitingDate	\N
1554	(0003,"SIEMENS ISI",31)	(0003,"SIEMENS ISI",31)	SIEMENS ISI	3	49	f	\N	TM	1	MaxWaitingTime	\N
1555	(0009,"SIEMENS ISI",01)	(0009,"SIEMENS ISI",01)	SIEMENS ISI	9	1	f	\N	UN	1	RISPatientInfoIMGEF	\N
1556	(0011,"SIEMENS ISI",03)	(0011,"SIEMENS ISI",03)	SIEMENS ISI	17	3	f	\N	LT	1	PatientUID	\N
1557	(0011,"SIEMENS ISI",04)	(0011,"SIEMENS ISI",04)	SIEMENS ISI	17	4	f	\N	LT	1	PatientID	\N
1558	(0011,"SIEMENS ISI",0a)	(0011,"SIEMENS ISI",0a)	SIEMENS ISI	17	10	f	\N	LT	1	CaseID	\N
1559	(0011,"SIEMENS ISI",22)	(0011,"SIEMENS ISI",22)	SIEMENS ISI	17	34	f	\N	LT	1	RequestID	\N
1560	(0011,"SIEMENS ISI",23)	(0011,"SIEMENS ISI",23)	SIEMENS ISI	17	35	f	\N	LT	1	ExaminationUID	\N
1561	(0011,"SIEMENS ISI",a1)	(0011,"SIEMENS ISI",a1)	SIEMENS ISI	17	161	f	\N	DA	1	PatientRegistrationDate	\N
1562	(0011,"SIEMENS ISI",a2)	(0011,"SIEMENS ISI",a2)	SIEMENS ISI	17	162	f	\N	TM	1	PatientRegistrationTime	\N
1563	(0011,"SIEMENS ISI",b0)	(0011,"SIEMENS ISI",b0)	SIEMENS ISI	17	176	f	\N	LT	1	PatientLastName	\N
1564	(0011,"SIEMENS ISI",b2)	(0011,"SIEMENS ISI",b2)	SIEMENS ISI	17	178	f	\N	LT	1	PatientFirstName	\N
1565	(0011,"SIEMENS ISI",b4)	(0011,"SIEMENS ISI",b4)	SIEMENS ISI	17	180	f	\N	LT	1	PatientHospitalStatus	\N
1566	(0011,"SIEMENS ISI",bc)	(0011,"SIEMENS ISI",bc)	SIEMENS ISI	17	188	f	\N	TM	1	CurrentLocationTime	\N
1567	(0011,"SIEMENS ISI",c0)	(0011,"SIEMENS ISI",c0)	SIEMENS ISI	17	192	f	\N	LT	1	PatientInsuranceStatus	\N
1568	(0011,"SIEMENS ISI",d0)	(0011,"SIEMENS ISI",d0)	SIEMENS ISI	17	208	f	\N	LT	1	PatientBillingType	\N
1569	(0011,"SIEMENS ISI",d2)	(0011,"SIEMENS ISI",d2)	SIEMENS ISI	17	210	f	\N	LT	1	PatientBillingAddress	\N
1570	(0031,"SIEMENS ISI",12)	(0031,"SIEMENS ISI",12)	SIEMENS ISI	49	18	f	\N	LT	1	ExaminationReason	\N
1571	(0031,"SIEMENS ISI",30)	(0031,"SIEMENS ISI",30)	SIEMENS ISI	49	48	f	\N	DA	1	RequestedDate	\N
1572	(0031,"SIEMENS ISI",32)	(0031,"SIEMENS ISI",32)	SIEMENS ISI	49	50	f	\N	TM	1	WorklistRequestStartTime	\N
1573	(0031,"SIEMENS ISI",33)	(0031,"SIEMENS ISI",33)	SIEMENS ISI	49	51	f	\N	TM	1	WorklistRequestEndTime	\N
1574	(0031,"SIEMENS ISI",4a)	(0031,"SIEMENS ISI",4a)	SIEMENS ISI	49	74	f	\N	TM	1	RequestedTime	\N
1575	(0031,"SIEMENS ISI",80)	(0031,"SIEMENS ISI",80)	SIEMENS ISI	49	128	f	\N	LT	1	RequestedLocation	\N
1576	(0055,"SIEMENS ISI",46)	(0055,"SIEMENS ISI",46)	SIEMENS ISI	85	70	f	\N	LT	1	CurrentWard	\N
1577	(0193,"SIEMENS ISI",02)	(0193,"SIEMENS ISI",02)	SIEMENS ISI	403	2	f	\N	DS	1	RISKey	\N
1578	(0307,"SIEMENS ISI",01)	(0307,"SIEMENS ISI",01)	SIEMENS ISI	775	1	f	\N	UN	1	RISWorklistIMGEF	\N
1579	(0309,"SIEMENS ISI",01)	(0309,"SIEMENS ISI",01)	SIEMENS ISI	777	1	f	\N	UN	1	RISReportIMGEF	\N
1580	(4009,"SIEMENS ISI",01)	(4009,"SIEMENS ISI",01)	SIEMENS ISI	16393	1	f	\N	LT	1	ReportID	\N
1581	(4009,"SIEMENS ISI",20)	(4009,"SIEMENS ISI",20)	SIEMENS ISI	16393	32	f	\N	LT	1	ReportStatus	\N
1582	(4009,"SIEMENS ISI",30)	(4009,"SIEMENS ISI",30)	SIEMENS ISI	16393	48	f	\N	DA	1	ReportCreationDate	\N
1583	(4009,"SIEMENS ISI",70)	(4009,"SIEMENS ISI",70)	SIEMENS ISI	16393	112	f	\N	LT	1	ReportApprovingPhysician	\N
1584	(4009,"SIEMENS ISI",e0)	(4009,"SIEMENS ISI",e0)	SIEMENS ISI	16393	224	f	\N	LT	1	ReportText	\N
1585	(4009,"SIEMENS ISI",e1)	(4009,"SIEMENS ISI",e1)	SIEMENS ISI	16393	225	f	\N	LT	1	ReportAuthor	\N
1586	(4009,"SIEMENS ISI",e3)	(4009,"SIEMENS ISI",e3)	SIEMENS ISI	16393	227	f	\N	LT	1	ReportingRadiologist	\N
1587	(0029,"SIEMENS MED DISPLAY",04)	(0029,"SIEMENS MED DISPLAY",04)	SIEMENS MED DISPLAY	41	4	f	\N	LT	1	PhotometricInterpretation	\N
1588	(0029,"SIEMENS MED DISPLAY",10)	(0029,"SIEMENS MED DISPLAY",10)	SIEMENS MED DISPLAY	41	16	f	\N	US	1	RowsOfSubmatrix	\N
1589	(0029,"SIEMENS MED DISPLAY",11)	(0029,"SIEMENS MED DISPLAY",11)	SIEMENS MED DISPLAY	41	17	f	\N	US	1	ColumnsOfSubmatrix	\N
1590	(0029,"SIEMENS MED DISPLAY",20)	(0029,"SIEMENS MED DISPLAY",20)	SIEMENS MED DISPLAY	41	32	f	\N	US	1	Unknown	\N
1591	(0029,"SIEMENS MED DISPLAY",21)	(0029,"SIEMENS MED DISPLAY",21)	SIEMENS MED DISPLAY	41	33	f	\N	US	1	Unknown	\N
1592	(0029,"SIEMENS MED DISPLAY",50)	(0029,"SIEMENS MED DISPLAY",50)	SIEMENS MED DISPLAY	41	80	f	\N	US	1	OriginOfSubmatrix	\N
1593	(0029,"SIEMENS MED DISPLAY",99)	(0029,"SIEMENS MED DISPLAY",99)	SIEMENS MED DISPLAY	41	153	f	\N	LT	1	ShutterType	\N
1594	(0029,"SIEMENS MED DISPLAY",a0)	(0029,"SIEMENS MED DISPLAY",a0)	SIEMENS MED DISPLAY	41	160	f	\N	US	1	RowsOfRectangularShutter	\N
1595	(0029,"SIEMENS MED DISPLAY",a1)	(0029,"SIEMENS MED DISPLAY",a1)	SIEMENS MED DISPLAY	41	161	f	\N	US	1	ColumnsOfRectangularShutter	\N
1596	(0029,"SIEMENS MED DISPLAY",a2)	(0029,"SIEMENS MED DISPLAY",a2)	SIEMENS MED DISPLAY	41	162	f	\N	US	1	OriginOfRectangularShutter	\N
1597	(0029,"SIEMENS MED DISPLAY",b0)	(0029,"SIEMENS MED DISPLAY",b0)	SIEMENS MED DISPLAY	41	176	f	\N	US	1	RadiusOfCircularShutter	\N
1598	(0029,"SIEMENS MED DISPLAY",b2)	(0029,"SIEMENS MED DISPLAY",b2)	SIEMENS MED DISPLAY	41	178	f	\N	US	1	OriginOfCircularShutter	\N
1599	(0029,"SIEMENS MED DISPLAY",c1)	(0029,"SIEMENS MED DISPLAY",c1)	SIEMENS MED DISPLAY	41	193	f	\N	US	1	ContourOfIrregularShutter	\N
1600	(0029,"SIEMENS MED HG",10)	(0029,"SIEMENS MED HG",10)	SIEMENS MED HG	41	16	f	\N	US	1	ListOfGroupNumbers	\N
1601	(0029,"SIEMENS MED HG",15)	(0029,"SIEMENS MED HG",15)	SIEMENS MED HG	41	21	f	\N	LT	1	ListOfShadowOwnerCodes	\N
1602	(0029,"SIEMENS MED HG",20)	(0029,"SIEMENS MED HG",20)	SIEMENS MED HG	41	32	f	\N	US	1	ListOfElementNumbers	\N
1603	(0029,"SIEMENS MED HG",30)	(0029,"SIEMENS MED HG",30)	SIEMENS MED HG	41	48	f	\N	US	1	ListOfTotalDisplayLength	\N
1604	(0029,"SIEMENS MED HG",40)	(0029,"SIEMENS MED HG",40)	SIEMENS MED HG	41	64	f	\N	LT	1	ListOfDisplayPrefix	\N
1605	(0029,"SIEMENS MED HG",50)	(0029,"SIEMENS MED HG",50)	SIEMENS MED HG	41	80	f	\N	LT	1	ListOfDisplayPostfix	\N
1606	(0029,"SIEMENS MED HG",60)	(0029,"SIEMENS MED HG",60)	SIEMENS MED HG	41	96	f	\N	US	1	ListOfTextPosition	\N
1607	(0029,"SIEMENS MED HG",70)	(0029,"SIEMENS MED HG",70)	SIEMENS MED HG	41	112	f	\N	LT	1	ListOfTextConcatenation	\N
1608	(0029,"SIEMENS MED MG",10)	(0029,"SIEMENS MED MG",10)	SIEMENS MED MG	41	16	f	\N	US	1	ListOfGroupNumbers	\N
1609	(0029,"SIEMENS MED MG",15)	(0029,"SIEMENS MED MG",15)	SIEMENS MED MG	41	21	f	\N	LT	1	ListOfShadowOwnerCodes	\N
1610	(0029,"SIEMENS MED MG",20)	(0029,"SIEMENS MED MG",20)	SIEMENS MED MG	41	32	f	\N	US	1	ListOfElementNumbers	\N
1611	(0029,"SIEMENS MED MG",30)	(0029,"SIEMENS MED MG",30)	SIEMENS MED MG	41	48	f	\N	US	1	ListOfTotalDisplayLength	\N
1612	(0029,"SIEMENS MED MG",40)	(0029,"SIEMENS MED MG",40)	SIEMENS MED MG	41	64	f	\N	LT	1	ListOfDisplayPrefix	\N
1613	(0029,"SIEMENS MED MG",50)	(0029,"SIEMENS MED MG",50)	SIEMENS MED MG	41	80	f	\N	LT	1	ListOfDisplayPostfix	\N
1614	(0029,"SIEMENS MED MG",60)	(0029,"SIEMENS MED MG",60)	SIEMENS MED MG	41	96	f	\N	US	1	ListOfTextPosition	\N
1615	(0029,"SIEMENS MED MG",70)	(0029,"SIEMENS MED MG",70)	SIEMENS MED MG	41	112	f	\N	LT	1	ListOfTextConcatenation	\N
1616	(0009,"SIEMENS MED",10)	(0009,"SIEMENS MED",10)	SIEMENS MED	9	16	f	\N	LO	1	RecognitionCode	\N
1617	(0009,"SIEMENS MED",30)	(0009,"SIEMENS MED",30)	SIEMENS MED	9	48	f	\N	UL	1	ByteOffsetOfOriginalHeader	\N
1618	(0009,"SIEMENS MED",31)	(0009,"SIEMENS MED",31)	SIEMENS MED	9	49	f	\N	UL	1	LengthOfOriginalHeader	\N
1619	(0009,"SIEMENS MED",40)	(0009,"SIEMENS MED",40)	SIEMENS MED	9	64	f	\N	UL	1	ByteOffsetOfPixelmatrix	\N
1620	(0009,"SIEMENS MED",41)	(0009,"SIEMENS MED",41)	SIEMENS MED	9	65	f	\N	UL	1	LengthOfPixelmatrixInBytes	\N
1621	(0009,"SIEMENS MED",50)	(0009,"SIEMENS MED",50)	SIEMENS MED	9	80	f	\N	LT	1	Unknown	\N
1622	(0009,"SIEMENS MED",51)	(0009,"SIEMENS MED",51)	SIEMENS MED	9	81	f	\N	LT	1	Unknown	\N
1623	(0009,"SIEMENS MED",f5)	(0009,"SIEMENS MED",f5)	SIEMENS MED	9	245	f	\N	LT	1	PDMEFIDPlaceholder	\N
1624	(0009,"SIEMENS MED",f6)	(0009,"SIEMENS MED",f6)	SIEMENS MED	9	246	f	\N	LT	1	PDMDataObjectTypeExtension	\N
1625	(0021,"SIEMENS MED",10)	(0021,"SIEMENS MED",10)	SIEMENS MED	33	16	f	\N	DS	1	Zoom	\N
1627	(0021,"SIEMENS MED",12)	(0021,"SIEMENS MED",12)	SIEMENS MED	33	18	f	\N	IS	1	TubeAngle	\N
1628	(0021,"SIEMENS MED",20)	(0021,"SIEMENS MED",20)	SIEMENS MED	33	32	f	\N	US	1	ROIMask	\N
1629	(7001,"SIEMENS MED",10)	(7001,"SIEMENS MED",10)	SIEMENS MED	28673	16	f	\N	LT	1	Dummy	\N
1630	(7003,"SIEMENS MED",10)	(7003,"SIEMENS MED",10)	SIEMENS MED	28675	16	f	\N	LT	1	Header	\N
1631	(7005,"SIEMENS MED",10)	(7005,"SIEMENS MED",10)	SIEMENS MED	28677	16	f	\N	LT	1	Dummy	\N
10969	(0119,"MRSC",11a0)	(0119,"MRSC",a0)	MRSC	281	160	t	11	CS	1	PhantCalibType	K
1633	(0029,"SIEMENS MEDCOM HEADER",09)	(0029,"SIEMENS MEDCOM HEADER",09)	SIEMENS MEDCOM HEADER	41	9	f	\N	LO	1	MedComHeaderVersion	R
1634	(0029,"SIEMENS MEDCOM HEADER",10)	(0029,"SIEMENS MEDCOM HEADER",10)	SIEMENS MEDCOM HEADER	41	16	f	\N	OB	1	MedComHeaderInfo	X
1635	(0029,"SIEMENS MEDCOM HEADER",20)	(0029,"SIEMENS MEDCOM HEADER",20)	SIEMENS MEDCOM HEADER	41	32	f	\N	OB	1	MedComHistoryInformation	X
1636	(0029,"SIEMENS MEDCOM HEADER",31)	(0029,"SIEMENS MEDCOM HEADER",31)	SIEMENS MEDCOM HEADER	41	49	f	\N	LO	1	PMTFInformation1	R
1637	(0029,"SIEMENS MEDCOM HEADER",32)	(0029,"SIEMENS MEDCOM HEADER",32)	SIEMENS MEDCOM HEADER	41	50	f	\N	UL	1	PMTFInformation2	KB
1638	(0029,"SIEMENS MEDCOM HEADER",33)	(0029,"SIEMENS MEDCOM HEADER",33)	SIEMENS MEDCOM HEADER	41	51	f	\N	UL	1	PMTFInformation3	KB
1639	(0029,"SIEMENS MEDCOM HEADER",34)	(0029,"SIEMENS MEDCOM HEADER",34)	SIEMENS MEDCOM HEADER	41	52	f	\N	CS	1	PMTFInformation4	R
1640	(0029,"SIEMENS MEDCOM HEADER",35)	(0029,"SIEMENS MEDCOM HEADER",35)	SIEMENS MEDCOM HEADER	41	53	f	\N	UL	1	PMTFInformation5	KB
1641	(0029,"SIEMENS MEDCOM HEADER",40)	(0029,"SIEMENS MEDCOM HEADER",40)	SIEMENS MEDCOM HEADER	41	64	f	\N	SQ	1	ApplicationHeaderSequence	X
1642	(0029,"SIEMENS MEDCOM HEADER",41)	(0029,"SIEMENS MEDCOM HEADER",41)	SIEMENS MEDCOM HEADER	41	65	f	\N	CS	1	ApplicationHeaderType	X
1643	(0029,"SIEMENS MEDCOM HEADER",42)	(0029,"SIEMENS MEDCOM HEADER",42)	SIEMENS MEDCOM HEADER	41	66	f	\N	LO	1	ApplicationHeaderID	X
1656	(0019,"SIEMENS MR VA0  COAD",12)	(0019,"SIEMENS MR VA0  COAD",12)	SIEMENS MR VA0  COAD	25	18	f	\N	DS	1	MagneticFieldStrength	\N
1657	(0019,"SIEMENS MR VA0  COAD",14)	(0019,"SIEMENS MR VA0  COAD",14)	SIEMENS MR VA0  COAD	25	20	f	\N	DS	1	ADCVoltage	\N
1658	(0019,"SIEMENS MR VA0  COAD",16)	(0019,"SIEMENS MR VA0  COAD",16)	SIEMENS MR VA0  COAD	25	22	f	\N	DS	2	ADCOffset	\N
1659	(0019,"SIEMENS MR VA0  COAD",20)	(0019,"SIEMENS MR VA0  COAD",20)	SIEMENS MR VA0  COAD	25	32	f	\N	DS	1	TransmitterAmplitude	\N
1660	(0019,"SIEMENS MR VA0  COAD",21)	(0019,"SIEMENS MR VA0  COAD",21)	SIEMENS MR VA0  COAD	25	33	f	\N	IS	1	NumberOfTransmitterAmplitudes	\N
1661	(0019,"SIEMENS MR VA0  COAD",22)	(0019,"SIEMENS MR VA0  COAD",22)	SIEMENS MR VA0  COAD	25	34	f	\N	DS	1	TransmitterAttenuator	\N
1662	(0019,"SIEMENS MR VA0  COAD",24)	(0019,"SIEMENS MR VA0  COAD",24)	SIEMENS MR VA0  COAD	25	36	f	\N	DS	1	TransmitterCalibration	\N
1663	(0019,"SIEMENS MR VA0  COAD",26)	(0019,"SIEMENS MR VA0  COAD",26)	SIEMENS MR VA0  COAD	25	38	f	\N	DS	1	TransmitterReference	\N
1664	(0019,"SIEMENS MR VA0  COAD",50)	(0019,"SIEMENS MR VA0  COAD",50)	SIEMENS MR VA0  COAD	25	80	f	\N	DS	1	ReceiverTotalGain	\N
1665	(0019,"SIEMENS MR VA0  COAD",51)	(0019,"SIEMENS MR VA0  COAD",51)	SIEMENS MR VA0  COAD	25	81	f	\N	DS	1	ReceiverAmplifierGain	\N
1666	(0019,"SIEMENS MR VA0  COAD",52)	(0019,"SIEMENS MR VA0  COAD",52)	SIEMENS MR VA0  COAD	25	82	f	\N	DS	1	ReceiverPreamplifierGain	\N
1667	(0019,"SIEMENS MR VA0  COAD",54)	(0019,"SIEMENS MR VA0  COAD",54)	SIEMENS MR VA0  COAD	25	84	f	\N	DS	1	ReceiverCableAttenuation	\N
1668	(0019,"SIEMENS MR VA0  COAD",55)	(0019,"SIEMENS MR VA0  COAD",55)	SIEMENS MR VA0  COAD	25	85	f	\N	DS	1	ReceiverReferenceGain	\N
1669	(0019,"SIEMENS MR VA0  COAD",56)	(0019,"SIEMENS MR VA0  COAD",56)	SIEMENS MR VA0  COAD	25	86	f	\N	DS	1	ReceiverFilterFrequency	\N
1670	(0019,"SIEMENS MR VA0  COAD",60)	(0019,"SIEMENS MR VA0  COAD",60)	SIEMENS MR VA0  COAD	25	96	f	\N	DS	1	ReconstructionScaleFactor	\N
1671	(0019,"SIEMENS MR VA0  COAD",62)	(0019,"SIEMENS MR VA0  COAD",62)	SIEMENS MR VA0  COAD	25	98	f	\N	DS	1	ReferenceScaleFactor	\N
1672	(0019,"SIEMENS MR VA0  COAD",70)	(0019,"SIEMENS MR VA0  COAD",70)	SIEMENS MR VA0  COAD	25	112	f	\N	DS	1	PhaseGradientAmplitude	\N
1673	(0019,"SIEMENS MR VA0  COAD",71)	(0019,"SIEMENS MR VA0  COAD",71)	SIEMENS MR VA0  COAD	25	113	f	\N	DS	1	ReadoutGradientAmplitude	\N
1674	(0019,"SIEMENS MR VA0  COAD",72)	(0019,"SIEMENS MR VA0  COAD",72)	SIEMENS MR VA0  COAD	25	114	f	\N	DS	1	SelectionGradientAmplitude	\N
1675	(0019,"SIEMENS MR VA0  COAD",80)	(0019,"SIEMENS MR VA0  COAD",80)	SIEMENS MR VA0  COAD	25	128	f	\N	DS	3	GradientDelayTime	\N
1676	(0019,"SIEMENS MR VA0  COAD",82)	(0019,"SIEMENS MR VA0  COAD",82)	SIEMENS MR VA0  COAD	25	130	f	\N	DS	1	TotalGradientDelayTime	\N
1677	(0019,"SIEMENS MR VA0  COAD",90)	(0019,"SIEMENS MR VA0  COAD",90)	SIEMENS MR VA0  COAD	25	144	f	\N	LT	1	SensitivityCorrectionLabel	\N
1678	(0019,"SIEMENS MR VA0  COAD",91)	(0019,"SIEMENS MR VA0  COAD",91)	SIEMENS MR VA0  COAD	25	145	f	\N	DS	6	SaturationPhaseEncodingVectorCoronalComponent	\N
1679	(0019,"SIEMENS MR VA0  COAD",92)	(0019,"SIEMENS MR VA0  COAD",92)	SIEMENS MR VA0  COAD	25	146	f	\N	DS	6	SaturationReadoutVectorCoronalComponent	\N
1680	(0019,"SIEMENS MR VA0  COAD",a0)	(0019,"SIEMENS MR VA0  COAD",a0)	SIEMENS MR VA0  COAD	25	160	f	\N	US	3	RFWatchdogMask	\N
1681	(0019,"SIEMENS MR VA0  COAD",a1)	(0019,"SIEMENS MR VA0  COAD",a1)	SIEMENS MR VA0  COAD	25	161	f	\N	DS	1	EPIReconstructionSlope	\N
1682	(0019,"SIEMENS MR VA0  COAD",a2)	(0019,"SIEMENS MR VA0  COAD",a2)	SIEMENS MR VA0  COAD	25	162	f	\N	DS	1	RFPowerErrorIndicator	\N
1683	(0019,"SIEMENS MR VA0  COAD",a5)	(0019,"SIEMENS MR VA0  COAD",a5)	SIEMENS MR VA0  COAD	25	165	f	\N	DS	3	SpecificAbsorptionRateWholeBody	\N
1684	(0019,"SIEMENS MR VA0  COAD",a6)	(0019,"SIEMENS MR VA0  COAD",a6)	SIEMENS MR VA0  COAD	25	166	f	\N	DS	3	SpecificEnergyDose	\N
1685	(0019,"SIEMENS MR VA0  COAD",b0)	(0019,"SIEMENS MR VA0  COAD",b0)	SIEMENS MR VA0  COAD	25	176	f	\N	UL	1	AdjustmentStatusMask	\N
1686	(0019,"SIEMENS MR VA0  COAD",c1)	(0019,"SIEMENS MR VA0  COAD",c1)	SIEMENS MR VA0  COAD	25	193	f	\N	DS	6	EPICapacity	\N
1687	(0019,"SIEMENS MR VA0  COAD",c2)	(0019,"SIEMENS MR VA0  COAD",c2)	SIEMENS MR VA0  COAD	25	194	f	\N	DS	3	EPIInductance	\N
1688	(0019,"SIEMENS MR VA0  COAD",c3)	(0019,"SIEMENS MR VA0  COAD",c3)	SIEMENS MR VA0  COAD	25	195	f	\N	IS	1-n	EPISwitchConfigurationCode	\N
1689	(0019,"SIEMENS MR VA0  COAD",c4)	(0019,"SIEMENS MR VA0  COAD",c4)	SIEMENS MR VA0  COAD	25	196	f	\N	IS	1-n	EPISwitchHardwareCode	\N
1690	(0019,"SIEMENS MR VA0  COAD",c5)	(0019,"SIEMENS MR VA0  COAD",c5)	SIEMENS MR VA0  COAD	25	197	f	\N	DS	1-n	EPISwitchDelayTime	\N
1691	(0019,"SIEMENS MR VA0  COAD",d1)	(0019,"SIEMENS MR VA0  COAD",d1)	SIEMENS MR VA0  COAD	25	209	f	\N	DS	1	FlowSensitivity	\N
1692	(0019,"SIEMENS MR VA0  COAD",d2)	(0019,"SIEMENS MR VA0  COAD",d2)	SIEMENS MR VA0  COAD	25	210	f	\N	LT	1	CalculationSubmode	\N
1645	(0029,"SIEMENS MEDCOM HEADER",44)	(0029,"SIEMENS MEDCOM HEADER",44)	SIEMENS MEDCOM HEADER	41	68	f	\N	OB	1	ApplicationHeaderInfo	X
1646	(0029,"SIEMENS MEDCOM HEADER",50)	(0029,"SIEMENS MEDCOM HEADER",50)	SIEMENS MEDCOM HEADER	41	80	f	\N	LO	8	WorkflowControlFlags	X
1647	(0029,"SIEMENS MEDCOM HEADER",51)	(0029,"SIEMENS MEDCOM HEADER",51)	SIEMENS MEDCOM HEADER	41	81	f	\N	CS	1	ArchiveManagementFlagKeepOnline	X
1648	(0029,"SIEMENS MEDCOM HEADER",52)	(0029,"SIEMENS MEDCOM HEADER",52)	SIEMENS MEDCOM HEADER	41	82	f	\N	CS	1	ArchiveManagementFlagDoNotArchive	X
1649	(0029,"SIEMENS MEDCOM HEADER",53)	(0029,"SIEMENS MEDCOM HEADER",53)	SIEMENS MEDCOM HEADER	41	83	f	\N	CS	1	ImageLocationStatus	X
1650	(0029,"SIEMENS MEDCOM HEADER",54)	(0029,"SIEMENS MEDCOM HEADER",54)	SIEMENS MEDCOM HEADER	41	84	f	\N	DS	1	EstimatedRetrieveTime	X
1651	(0029,"SIEMENS MEDCOM HEADER",55)	(0029,"SIEMENS MEDCOM HEADER",55)	SIEMENS MEDCOM HEADER	41	85	f	\N	DS	1	DataSizeOfRetrievedImages	X
1652	(0029,"SIEMENS MEDCOM HEADER2",60)	(0029,"SIEMENS MEDCOM HEADER2",60)	SIEMENS MEDCOM HEADER2	41	96	f	\N	LO	1	SeriesWorkflowStatus	X
1653	(0029,"SIEMENS MEDCOM OOG",08)	(0029,"SIEMENS MEDCOM OOG",08)	SIEMENS MEDCOM OOG	41	8	f	\N	CS	1	MEDCOMOOGType	X
1654	(0029,"SIEMENS MEDCOM OOG",09)	(0029,"SIEMENS MEDCOM OOG",09)	SIEMENS MEDCOM OOG	41	9	f	\N	LO	1	MEDCOMOOGVersion	X
1655	(0029,"SIEMENS MEDCOM OOG",10)	(0029,"SIEMENS MEDCOM OOG",10)	SIEMENS MEDCOM OOG	41	16	f	\N	OB	1	MEDCOMOOGInfo	X
1693	(0019,"SIEMENS MR VA0  COAD",d3)	(0019,"SIEMENS MR VA0  COAD",d3)	SIEMENS MR VA0  COAD	25	211	f	\N	DS	1	FieldOfViewRatio	\N
1694	(0019,"SIEMENS MR VA0  COAD",d4)	(0019,"SIEMENS MR VA0  COAD",d4)	SIEMENS MR VA0  COAD	25	212	f	\N	IS	1	BaseRawMatrixSize	\N
1695	(0019,"SIEMENS MR VA0  COAD",d5)	(0019,"SIEMENS MR VA0  COAD",d5)	SIEMENS MR VA0  COAD	25	213	f	\N	IS	1	2DOversamplingLines	\N
1696	(0019,"SIEMENS MR VA0  COAD",d6)	(0019,"SIEMENS MR VA0  COAD",d6)	SIEMENS MR VA0  COAD	25	214	f	\N	IS	1	3DPhaseOversamplingPartitions	\N
1697	(0019,"SIEMENS MR VA0  COAD",d7)	(0019,"SIEMENS MR VA0  COAD",d7)	SIEMENS MR VA0  COAD	25	215	f	\N	IS	1	EchoLinePosition	\N
1698	(0019,"SIEMENS MR VA0  COAD",d8)	(0019,"SIEMENS MR VA0  COAD",d8)	SIEMENS MR VA0  COAD	25	216	f	\N	IS	1	EchoColumnPosition	\N
1699	(0019,"SIEMENS MR VA0  COAD",d9)	(0019,"SIEMENS MR VA0  COAD",d9)	SIEMENS MR VA0  COAD	25	217	f	\N	IS	1	LinesPerSegment	\N
1700	(0019,"SIEMENS MR VA0  COAD",da)	(0019,"SIEMENS MR VA0  COAD",da)	SIEMENS MR VA0  COAD	25	218	f	\N	LT	1	PhaseCodingDirection	\N
1701	(0019,"SIEMENS MR VA0  GEN",10)	(0019,"SIEMENS MR VA0  GEN",10)	SIEMENS MR VA0  GEN	25	16	f	\N	DS	1	TotalMeasurementTimeNominal	\N
1702	(0019,"SIEMENS MR VA0  GEN",11)	(0019,"SIEMENS MR VA0  GEN",11)	SIEMENS MR VA0  GEN	25	17	f	\N	DS	1	TotalMeasurementTimeCurrent	\N
1703	(0019,"SIEMENS MR VA0  GEN",12)	(0019,"SIEMENS MR VA0  GEN",12)	SIEMENS MR VA0  GEN	25	18	f	\N	DS	1	StartDelayTime	\N
1704	(0019,"SIEMENS MR VA0  GEN",13)	(0019,"SIEMENS MR VA0  GEN",13)	SIEMENS MR VA0  GEN	25	19	f	\N	DS	1	DwellTime	\N
1705	(0019,"SIEMENS MR VA0  GEN",14)	(0019,"SIEMENS MR VA0  GEN",14)	SIEMENS MR VA0  GEN	25	20	f	\N	IS	1	NumberOfPhases	\N
1706	(0019,"SIEMENS MR VA0  GEN",16)	(0019,"SIEMENS MR VA0  GEN",16)	SIEMENS MR VA0  GEN	25	22	f	\N	UL	2	SequenceControlMask	\N
1707	(0019,"SIEMENS MR VA0  GEN",18)	(0019,"SIEMENS MR VA0  GEN",18)	SIEMENS MR VA0  GEN	25	24	f	\N	UL	1	MeasurementStatusMask	\N
1708	(0019,"SIEMENS MR VA0  GEN",20)	(0019,"SIEMENS MR VA0  GEN",20)	SIEMENS MR VA0  GEN	25	32	f	\N	IS	1	NumberOfFourierLinesNominal	\N
1709	(0019,"SIEMENS MR VA0  GEN",21)	(0019,"SIEMENS MR VA0  GEN",21)	SIEMENS MR VA0  GEN	25	33	f	\N	IS	1	NumberOfFourierLinesCurrent	\N
1710	(0019,"SIEMENS MR VA0  GEN",26)	(0019,"SIEMENS MR VA0  GEN",26)	SIEMENS MR VA0  GEN	25	38	f	\N	IS	1	NumberOfFourierLinesAfterZero	\N
1711	(0019,"SIEMENS MR VA0  GEN",28)	(0019,"SIEMENS MR VA0  GEN",28)	SIEMENS MR VA0  GEN	25	40	f	\N	IS	1	FirstMeasuredFourierLine	\N
1712	(0019,"SIEMENS MR VA0  GEN",30)	(0019,"SIEMENS MR VA0  GEN",30)	SIEMENS MR VA0  GEN	25	48	f	\N	IS	1	AcquisitionColumns	\N
1713	(0019,"SIEMENS MR VA0  GEN",31)	(0019,"SIEMENS MR VA0  GEN",31)	SIEMENS MR VA0  GEN	25	49	f	\N	IS	1	ReconstructionColumns	\N
1714	(0019,"SIEMENS MR VA0  GEN",40)	(0019,"SIEMENS MR VA0  GEN",40)	SIEMENS MR VA0  GEN	25	64	f	\N	IS	1	ArrayCoilElementNumber	\N
1715	(0019,"SIEMENS MR VA0  GEN",41)	(0019,"SIEMENS MR VA0  GEN",41)	SIEMENS MR VA0  GEN	25	65	f	\N	UL	1	ArrayCoilElementSelectMask	\N
1716	(0019,"SIEMENS MR VA0  GEN",42)	(0019,"SIEMENS MR VA0  GEN",42)	SIEMENS MR VA0  GEN	25	66	f	\N	UL	1	ArrayCoilElementDataMask	\N
1717	(0019,"SIEMENS MR VA0  GEN",43)	(0019,"SIEMENS MR VA0  GEN",43)	SIEMENS MR VA0  GEN	25	67	f	\N	IS	1-n	ArrayCoilElementToADCConnect	\N
1718	(0019,"SIEMENS MR VA0  GEN",44)	(0019,"SIEMENS MR VA0  GEN",44)	SIEMENS MR VA0  GEN	25	68	f	\N	DS	1-n	ArrayCoilElementNoiseLevel	\N
1719	(0019,"SIEMENS MR VA0  GEN",45)	(0019,"SIEMENS MR VA0  GEN",45)	SIEMENS MR VA0  GEN	25	69	f	\N	IS	1	ArrayCoilADCPairNumber	\N
1720	(0019,"SIEMENS MR VA0  GEN",46)	(0019,"SIEMENS MR VA0  GEN",46)	SIEMENS MR VA0  GEN	25	70	f	\N	UL	1	ArrayCoilCombinationMask	\N
1721	(0019,"SIEMENS MR VA0  GEN",50)	(0019,"SIEMENS MR VA0  GEN",50)	SIEMENS MR VA0  GEN	25	80	f	\N	IS	1	NumberOfAverages	\N
1722	(0019,"SIEMENS MR VA0  GEN",60)	(0019,"SIEMENS MR VA0  GEN",60)	SIEMENS MR VA0  GEN	25	96	f	\N	DS	1	FlipAngle	\N
1723	(0019,"SIEMENS MR VA0  GEN",70)	(0019,"SIEMENS MR VA0  GEN",70)	SIEMENS MR VA0  GEN	25	112	f	\N	IS	1	NumberOfPrescans	\N
1724	(0019,"SIEMENS MR VA0  GEN",81)	(0019,"SIEMENS MR VA0  GEN",81)	SIEMENS MR VA0  GEN	25	129	f	\N	LT	1	FilterTypeForRawData	\N
1725	(0019,"SIEMENS MR VA0  GEN",82)	(0019,"SIEMENS MR VA0  GEN",82)	SIEMENS MR VA0  GEN	25	130	f	\N	DS	1-n	FilterParameterForRawData	\N
1726	(0019,"SIEMENS MR VA0  GEN",83)	(0019,"SIEMENS MR VA0  GEN",83)	SIEMENS MR VA0  GEN	25	131	f	\N	LT	1	FilterTypeForImageData	\N
1727	(0019,"SIEMENS MR VA0  GEN",84)	(0019,"SIEMENS MR VA0  GEN",84)	SIEMENS MR VA0  GEN	25	132	f	\N	DS	1-n	FilterParameterForImageData	\N
1728	(0019,"SIEMENS MR VA0  GEN",85)	(0019,"SIEMENS MR VA0  GEN",85)	SIEMENS MR VA0  GEN	25	133	f	\N	LT	1	FilterTypeForPhaseCorrection	\N
1729	(0019,"SIEMENS MR VA0  GEN",86)	(0019,"SIEMENS MR VA0  GEN",86)	SIEMENS MR VA0  GEN	25	134	f	\N	DS	1-n	FilterParameterForPhaseCorrection	\N
1730	(0019,"SIEMENS MR VA0  GEN",87)	(0019,"SIEMENS MR VA0  GEN",87)	SIEMENS MR VA0  GEN	25	135	f	\N	LT	1	NormalizationFilterTypeForImageData	\N
1731	(0019,"SIEMENS MR VA0  GEN",88)	(0019,"SIEMENS MR VA0  GEN",88)	SIEMENS MR VA0  GEN	25	136	f	\N	DS	1-n	NormalizationFilterParameterForImageData	\N
1732	(0019,"SIEMENS MR VA0  GEN",90)	(0019,"SIEMENS MR VA0  GEN",90)	SIEMENS MR VA0  GEN	25	144	f	\N	IS	1	NumberOfSaturationRegions	\N
1733	(0019,"SIEMENS MR VA0  GEN",91)	(0019,"SIEMENS MR VA0  GEN",91)	SIEMENS MR VA0  GEN	25	145	f	\N	DS	6	SaturationPhaseEncodingVectorSagittalComponent	\N
1734	(0019,"SIEMENS MR VA0  GEN",92)	(0019,"SIEMENS MR VA0  GEN",92)	SIEMENS MR VA0  GEN	25	146	f	\N	DS	6	SaturationReadoutVectorSagittalComponent	\N
1735	(0019,"SIEMENS MR VA0  GEN",93)	(0019,"SIEMENS MR VA0  GEN",93)	SIEMENS MR VA0  GEN	25	147	f	\N	DS	1	EPIStimulationMonitorMode	\N
1736	(0019,"SIEMENS MR VA0  GEN",94)	(0019,"SIEMENS MR VA0  GEN",94)	SIEMENS MR VA0  GEN	25	148	f	\N	DS	1	ImageRotationAngle	\N
1737	(0019,"SIEMENS MR VA0  GEN",96)	(0019,"SIEMENS MR VA0  GEN",96)	SIEMENS MR VA0  GEN	25	150	f	\N	UL	3	CoilIDMask	\N
1738	(0019,"SIEMENS MR VA0  GEN",97)	(0019,"SIEMENS MR VA0  GEN",97)	SIEMENS MR VA0  GEN	25	151	f	\N	UL	2	CoilClassMask	\N
1739	(0019,"SIEMENS MR VA0  GEN",98)	(0019,"SIEMENS MR VA0  GEN",98)	SIEMENS MR VA0  GEN	25	152	f	\N	DS	3	CoilPosition	\N
1740	(0019,"SIEMENS MR VA0  GEN",a0)	(0019,"SIEMENS MR VA0  GEN",a0)	SIEMENS MR VA0  GEN	25	160	f	\N	DS	1	EPIReconstructionPhase	\N
1741	(0019,"SIEMENS MR VA0  GEN",a1)	(0019,"SIEMENS MR VA0  GEN",a1)	SIEMENS MR VA0  GEN	25	161	f	\N	DS	1	EPIReconstructionSlope	\N
1742	(0021,"SIEMENS MR VA0  GEN",20)	(0021,"SIEMENS MR VA0  GEN",20)	SIEMENS MR VA0  GEN	33	32	f	\N	IS	1	PhaseCorrectionRowsSequence	\N
1743	(0021,"SIEMENS MR VA0  GEN",21)	(0021,"SIEMENS MR VA0  GEN",21)	SIEMENS MR VA0  GEN	33	33	f	\N	IS	1	PhaseCorrectionColumnsSequence	\N
1744	(0021,"SIEMENS MR VA0  GEN",22)	(0021,"SIEMENS MR VA0  GEN",22)	SIEMENS MR VA0  GEN	33	34	f	\N	IS	1	PhaseCorrectionRowsReconstruction	\N
1745	(0021,"SIEMENS MR VA0  GEN",24)	(0021,"SIEMENS MR VA0  GEN",24)	SIEMENS MR VA0  GEN	33	36	f	\N	IS	1	PhaseCorrectionColumnsReconstruction	\N
1746	(0021,"SIEMENS MR VA0  GEN",30)	(0021,"SIEMENS MR VA0  GEN",30)	SIEMENS MR VA0  GEN	33	48	f	\N	IS	1	NumberOf3DRawPartitionsNominal	\N
1747	(0021,"SIEMENS MR VA0  GEN",31)	(0021,"SIEMENS MR VA0  GEN",31)	SIEMENS MR VA0  GEN	33	49	f	\N	IS	1	NumberOf3DRawPartitionsCurrent	\N
1748	(0021,"SIEMENS MR VA0  GEN",34)	(0021,"SIEMENS MR VA0  GEN",34)	SIEMENS MR VA0  GEN	33	52	f	\N	IS	1	NumberOf3DImagePartitions	\N
1749	(0021,"SIEMENS MR VA0  GEN",36)	(0021,"SIEMENS MR VA0  GEN",36)	SIEMENS MR VA0  GEN	33	54	f	\N	IS	1	Actual3DImagePartitionNumber	\N
1750	(0021,"SIEMENS MR VA0  GEN",39)	(0021,"SIEMENS MR VA0  GEN",39)	SIEMENS MR VA0  GEN	33	57	f	\N	DS	1	SlabThickness	\N
1751	(0021,"SIEMENS MR VA0  GEN",40)	(0021,"SIEMENS MR VA0  GEN",40)	SIEMENS MR VA0  GEN	33	64	f	\N	IS	1	NumberOfSlicesNominal	\N
1752	(0021,"SIEMENS MR VA0  GEN",41)	(0021,"SIEMENS MR VA0  GEN",41)	SIEMENS MR VA0  GEN	33	65	f	\N	IS	1	NumberOfSlicesCurrent	\N
1753	(0021,"SIEMENS MR VA0  GEN",42)	(0021,"SIEMENS MR VA0  GEN",42)	SIEMENS MR VA0  GEN	33	66	f	\N	IS	1	CurrentSliceNumber	\N
1754	(0021,"SIEMENS MR VA0  GEN",43)	(0021,"SIEMENS MR VA0  GEN",43)	SIEMENS MR VA0  GEN	33	67	f	\N	IS	1	CurrentGroupNumber	\N
1755	(0021,"SIEMENS MR VA0  GEN",44)	(0021,"SIEMENS MR VA0  GEN",44)	SIEMENS MR VA0  GEN	33	68	f	\N	DS	1	CurrentSliceDistanceFactor	\N
1756	(0021,"SIEMENS MR VA0  GEN",45)	(0021,"SIEMENS MR VA0  GEN",45)	SIEMENS MR VA0  GEN	33	69	f	\N	IS	1	MIPStartRow	\N
1757	(0021,"SIEMENS MR VA0  GEN",46)	(0021,"SIEMENS MR VA0  GEN",46)	SIEMENS MR VA0  GEN	33	70	f	\N	IS	1	MIPStopRow	\N
1758	(0021,"SIEMENS MR VA0  GEN",47)	(0021,"SIEMENS MR VA0  GEN",47)	SIEMENS MR VA0  GEN	33	71	f	\N	IS	1	MIPStartColumn	\N
1759	(0021,"SIEMENS MR VA0  GEN",48)	(0021,"SIEMENS MR VA0  GEN",48)	SIEMENS MR VA0  GEN	33	72	f	\N	IS	1	MIPStartColumn	\N
1760	(0021,"SIEMENS MR VA0  GEN",49)	(0021,"SIEMENS MR VA0  GEN",49)	SIEMENS MR VA0  GEN	33	73	f	\N	IS	1	MIPStartSlice Name=	\N
1761	(0021,"SIEMENS MR VA0  GEN",4a)	(0021,"SIEMENS MR VA0  GEN",4a)	SIEMENS MR VA0  GEN	33	74	f	\N	IS	1	MIPStartSlice	\N
1762	(0021,"SIEMENS MR VA0  GEN",4f)	(0021,"SIEMENS MR VA0  GEN",4f)	SIEMENS MR VA0  GEN	33	79	f	\N	LT	1	OrderofSlices	\N
1763	(0021,"SIEMENS MR VA0  GEN",50)	(0021,"SIEMENS MR VA0  GEN",50)	SIEMENS MR VA0  GEN	33	80	f	\N	US	1	SignalMask	\N
1764	(0021,"SIEMENS MR VA0  GEN",52)	(0021,"SIEMENS MR VA0  GEN",52)	SIEMENS MR VA0  GEN	33	82	f	\N	DS	1	DelayAfterTrigger	\N
1765	(0021,"SIEMENS MR VA0  GEN",53)	(0021,"SIEMENS MR VA0  GEN",53)	SIEMENS MR VA0  GEN	33	83	f	\N	IS	1	RRInterval	\N
1766	(0021,"SIEMENS MR VA0  GEN",54)	(0021,"SIEMENS MR VA0  GEN",54)	SIEMENS MR VA0  GEN	33	84	f	\N	DS	1	NumberOfTriggerPulses	\N
1767	(0021,"SIEMENS MR VA0  GEN",56)	(0021,"SIEMENS MR VA0  GEN",56)	SIEMENS MR VA0  GEN	33	86	f	\N	DS	1	RepetitionTimeEffective	\N
1768	(0021,"SIEMENS MR VA0  GEN",57)	(0021,"SIEMENS MR VA0  GEN",57)	SIEMENS MR VA0  GEN	33	87	f	\N	LT	1	GatePhase	\N
1769	(0021,"SIEMENS MR VA0  GEN",58)	(0021,"SIEMENS MR VA0  GEN",58)	SIEMENS MR VA0  GEN	33	88	f	\N	DS	1	GateThreshold	\N
1770	(0021,"SIEMENS MR VA0  GEN",59)	(0021,"SIEMENS MR VA0  GEN",59)	SIEMENS MR VA0  GEN	33	89	f	\N	DS	1	GatedRatio	\N
1771	(0021,"SIEMENS MR VA0  GEN",60)	(0021,"SIEMENS MR VA0  GEN",60)	SIEMENS MR VA0  GEN	33	96	f	\N	IS	1	NumberOfInterpolatedImages	\N
1772	(0021,"SIEMENS MR VA0  GEN",70)	(0021,"SIEMENS MR VA0  GEN",70)	SIEMENS MR VA0  GEN	33	112	f	\N	IS	1	NumberOfEchoes	\N
1773	(0021,"SIEMENS MR VA0  GEN",72)	(0021,"SIEMENS MR VA0  GEN",72)	SIEMENS MR VA0  GEN	33	114	f	\N	DS	1	SecondEchoTime	\N
1774	(0021,"SIEMENS MR VA0  GEN",73)	(0021,"SIEMENS MR VA0  GEN",73)	SIEMENS MR VA0  GEN	33	115	f	\N	DS	1	SecondRepetitionTime	\N
1775	(0021,"SIEMENS MR VA0  GEN",80)	(0021,"SIEMENS MR VA0  GEN",80)	SIEMENS MR VA0  GEN	33	128	f	\N	IS	1	CardiacCode	\N
1776	(0021,"SIEMENS MR VA0  GEN",91)	(0021,"SIEMENS MR VA0  GEN",91)	SIEMENS MR VA0  GEN	33	145	f	\N	DS	6	SaturationPhaseEncodingVectorTransverseComponent	\N
1777	(0021,"SIEMENS MR VA0  GEN",92)	(0021,"SIEMENS MR VA0  GEN",92)	SIEMENS MR VA0  GEN	33	146	f	\N	DS	6	SaturationReadoutVectorTransverseComponent	\N
1778	(0021,"SIEMENS MR VA0  GEN",93)	(0021,"SIEMENS MR VA0  GEN",93)	SIEMENS MR VA0  GEN	33	147	f	\N	DS	1	EPIChangeValueOfMagnitude	\N
1779	(0021,"SIEMENS MR VA0  GEN",94)	(0021,"SIEMENS MR VA0  GEN",94)	SIEMENS MR VA0  GEN	33	148	f	\N	DS	1	EPIChangeValueOfXComponent	\N
1780	(0021,"SIEMENS MR VA0  GEN",95)	(0021,"SIEMENS MR VA0  GEN",95)	SIEMENS MR VA0  GEN	33	149	f	\N	DS	1	EPIChangeValueOfYComponent	\N
1781	(0021,"SIEMENS MR VA0  GEN",96)	(0021,"SIEMENS MR VA0  GEN",96)	SIEMENS MR VA0  GEN	33	150	f	\N	DS	1	EPIChangeValueOfZComponent	\N
1782	(0021,"SIEMENS MR VA0  RAW",00)	(0021,"SIEMENS MR VA0  RAW",00)	SIEMENS MR VA0  RAW	33	0	f	\N	LT	1	SequenceType	\N
1783	(0021,"SIEMENS MR VA0  RAW",01)	(0021,"SIEMENS MR VA0  RAW",01)	SIEMENS MR VA0  RAW	33	1	f	\N	IS	1	VectorSizeOriginal	\N
1784	(0021,"SIEMENS MR VA0  RAW",02)	(0021,"SIEMENS MR VA0  RAW",02)	SIEMENS MR VA0  RAW	33	2	f	\N	IS	1	VectorSizeExtended	\N
1785	(0021,"SIEMENS MR VA0  RAW",03)	(0021,"SIEMENS MR VA0  RAW",03)	SIEMENS MR VA0  RAW	33	3	f	\N	DS	1	AcquiredSpectralRange	\N
1786	(0021,"SIEMENS MR VA0  RAW",04)	(0021,"SIEMENS MR VA0  RAW",04)	SIEMENS MR VA0  RAW	33	4	f	\N	DS	3	VOIPosition	\N
1787	(0021,"SIEMENS MR VA0  RAW",05)	(0021,"SIEMENS MR VA0  RAW",05)	SIEMENS MR VA0  RAW	33	5	f	\N	DS	3	VOISize	\N
1788	(0021,"SIEMENS MR VA0  RAW",06)	(0021,"SIEMENS MR VA0  RAW",06)	SIEMENS MR VA0  RAW	33	6	f	\N	IS	3	CSIMatrixSizeOriginal	\N
1789	(0021,"SIEMENS MR VA0  RAW",07)	(0021,"SIEMENS MR VA0  RAW",07)	SIEMENS MR VA0  RAW	33	7	f	\N	IS	3	CSIMatrixSizeExtended	\N
1790	(0021,"SIEMENS MR VA0  RAW",08)	(0021,"SIEMENS MR VA0  RAW",08)	SIEMENS MR VA0  RAW	33	8	f	\N	DS	3	SpatialGridShift	\N
1791	(0021,"SIEMENS MR VA0  RAW",09)	(0021,"SIEMENS MR VA0  RAW",09)	SIEMENS MR VA0  RAW	33	9	f	\N	DS	1	SignalLimitsMinimum	\N
2641	(0019,"SVISION",81)	(0019,"SVISION",81)	SVISION	25	129	f	\N	IS	1	ObjectPosition	\N
1792	(0021,"SIEMENS MR VA0  RAW",10)	(0021,"SIEMENS MR VA0  RAW",10)	SIEMENS MR VA0  RAW	33	16	f	\N	DS	1	SignalLimitsMaximum	\N
1793	(0021,"SIEMENS MR VA0  RAW",11)	(0021,"SIEMENS MR VA0  RAW",11)	SIEMENS MR VA0  RAW	33	17	f	\N	DS	1	SpecInfoMask	\N
1794	(0021,"SIEMENS MR VA0  RAW",12)	(0021,"SIEMENS MR VA0  RAW",12)	SIEMENS MR VA0  RAW	33	18	f	\N	DS	1	EPITimeRateOfChangeOfMagnitude	\N
1795	(0021,"SIEMENS MR VA0  RAW",13)	(0021,"SIEMENS MR VA0  RAW",13)	SIEMENS MR VA0  RAW	33	19	f	\N	DS	1	EPITimeRateOfChangeOfXComponent	\N
1796	(0021,"SIEMENS MR VA0  RAW",14)	(0021,"SIEMENS MR VA0  RAW",14)	SIEMENS MR VA0  RAW	33	20	f	\N	DS	1	EPITimeRateOfChangeOfYComponent	\N
1797	(0021,"SIEMENS MR VA0  RAW",15)	(0021,"SIEMENS MR VA0  RAW",15)	SIEMENS MR VA0  RAW	33	21	f	\N	DS	1	EPITimeRateOfChangeOfZComponent	\N
1798	(0021,"SIEMENS MR VA0  RAW",16)	(0021,"SIEMENS MR VA0  RAW",16)	SIEMENS MR VA0  RAW	33	22	f	\N	DS	1	EPITimeRateOfChangeLegalLimit1	\N
1799	(0021,"SIEMENS MR VA0  RAW",17)	(0021,"SIEMENS MR VA0  RAW",17)	SIEMENS MR VA0  RAW	33	23	f	\N	DS	1	EPIOperationModeFlag	\N
1800	(0021,"SIEMENS MR VA0  RAW",18)	(0021,"SIEMENS MR VA0  RAW",18)	SIEMENS MR VA0  RAW	33	24	f	\N	DS	1	EPIFieldCalculationSafetyFactor	\N
1801	(0021,"SIEMENS MR VA0  RAW",19)	(0021,"SIEMENS MR VA0  RAW",19)	SIEMENS MR VA0  RAW	33	25	f	\N	DS	1	EPILegalLimit1OfChangeValue	\N
1802	(0021,"SIEMENS MR VA0  RAW",20)	(0021,"SIEMENS MR VA0  RAW",20)	SIEMENS MR VA0  RAW	33	32	f	\N	DS	1	EPILegalLimit2OfChangeValue	\N
1803	(0021,"SIEMENS MR VA0  RAW",21)	(0021,"SIEMENS MR VA0  RAW",21)	SIEMENS MR VA0  RAW	33	33	f	\N	DS	1	EPIRiseTime	\N
1804	(0021,"SIEMENS MR VA0  RAW",30)	(0021,"SIEMENS MR VA0  RAW",30)	SIEMENS MR VA0  RAW	33	48	f	\N	DS	16	ArrayCoilADCOffset	\N
1805	(0021,"SIEMENS MR VA0  RAW",31)	(0021,"SIEMENS MR VA0  RAW",31)	SIEMENS MR VA0  RAW	33	49	f	\N	DS	16	ArrayCoilPreamplifierGain	\N
1806	(0021,"SIEMENS MR VA0  RAW",50)	(0021,"SIEMENS MR VA0  RAW",50)	SIEMENS MR VA0  RAW	33	80	f	\N	LT	1	SaturationType	\N
1807	(0021,"SIEMENS MR VA0  RAW",51)	(0021,"SIEMENS MR VA0  RAW",51)	SIEMENS MR VA0  RAW	33	81	f	\N	DS	3	SaturationNormalVector	\N
1808	(0021,"SIEMENS MR VA0  RAW",52)	(0021,"SIEMENS MR VA0  RAW",52)	SIEMENS MR VA0  RAW	33	82	f	\N	DS	3	SaturationPositionVector	\N
1809	(0021,"SIEMENS MR VA0  RAW",53)	(0021,"SIEMENS MR VA0  RAW",53)	SIEMENS MR VA0  RAW	33	83	f	\N	DS	6	SaturationThickness	\N
1810	(0021,"SIEMENS MR VA0  RAW",54)	(0021,"SIEMENS MR VA0  RAW",54)	SIEMENS MR VA0  RAW	33	84	f	\N	DS	6	SaturationWidth	\N
1811	(0021,"SIEMENS MR VA0  RAW",55)	(0021,"SIEMENS MR VA0  RAW",55)	SIEMENS MR VA0  RAW	33	85	f	\N	DS	6	SaturationDistance	\N
1812	(7fe3,"SIEMENS NUMARIS II",00)	(7fe3,"SIEMENS NUMARIS II",00)	SIEMENS NUMARIS II	32739	0	f	\N	LT	1	ImageGraphicsFormatCode	\N
1813	(7fe3,"SIEMENS NUMARIS II",10)	(7fe3,"SIEMENS NUMARIS II",10)	SIEMENS NUMARIS II	32739	16	f	\N	OB	1	ImageGraphics	\N
1814	(7fe3,"SIEMENS NUMARIS II",20)	(7fe3,"SIEMENS NUMARIS II",20)	SIEMENS NUMARIS II	32739	32	f	\N	OB	1	ImageGraphicsDummy	\N
1815	(0011,"SIEMENS RA GEN",20)	(0011,"SIEMENS RA GEN",20)	SIEMENS RA GEN	17	32	f	\N	SL	1	FluoroTimer	\N
1816	(0011,"SIEMENS RA GEN",25)	(0011,"SIEMENS RA GEN",25)	SIEMENS RA GEN	17	37	f	\N	SL	1	PtopDoseAreaProduct	\N
1817	(0011,"SIEMENS RA GEN",26)	(0011,"SIEMENS RA GEN",26)	SIEMENS RA GEN	17	38	f	\N	SL	1	PtopTotalSkinDose	\N
1818	(0011,"SIEMENS RA GEN",30)	(0011,"SIEMENS RA GEN",30)	SIEMENS RA GEN	17	48	f	\N	LT	1	Unknown	\N
1819	(0011,"SIEMENS RA GEN",35)	(0011,"SIEMENS RA GEN",35)	SIEMENS RA GEN	17	53	f	\N	LO	1	PatientInitialPuckCounter	\N
1820	(0011,"SIEMENS RA GEN",40)	(0011,"SIEMENS RA GEN",40)	SIEMENS RA GEN	17	64	f	\N	SS	1	SPIDataObjectType	\N
1821	(0019,"SIEMENS RA GEN",15)	(0019,"SIEMENS RA GEN",15)	SIEMENS RA GEN	25	21	f	\N	LO	1	AcquiredPlane	\N
1822	(0019,"SIEMENS RA GEN",1f)	(0019,"SIEMENS RA GEN",1f)	SIEMENS RA GEN	25	31	f	\N	SS	1	DefaultTableIsoCenterHeight	\N
1823	(0019,"SIEMENS RA GEN",20)	(0019,"SIEMENS RA GEN",20)	SIEMENS RA GEN	25	32	f	\N	SL	1	SceneFlag	\N
1824	(0019,"SIEMENS RA GEN",22)	(0019,"SIEMENS RA GEN",22)	SIEMENS RA GEN	25	34	f	\N	SL	1	RefPhotofileFlag	\N
1825	(0019,"SIEMENS RA GEN",24)	(0019,"SIEMENS RA GEN",24)	SIEMENS RA GEN	25	36	f	\N	LO	1	SceneName	\N
1826	(0019,"SIEMENS RA GEN",26)	(0019,"SIEMENS RA GEN",26)	SIEMENS RA GEN	25	38	f	\N	SS	1	AcquisitionIndex	\N
1827	(0019,"SIEMENS RA GEN",28)	(0019,"SIEMENS RA GEN",28)	SIEMENS RA GEN	25	40	f	\N	SS	1	MixedPulseMode	\N
1828	(0019,"SIEMENS RA GEN",2a)	(0019,"SIEMENS RA GEN",2a)	SIEMENS RA GEN	25	42	f	\N	SS	1	NoOfPositions	\N
1829	(0019,"SIEMENS RA GEN",2c)	(0019,"SIEMENS RA GEN",2c)	SIEMENS RA GEN	25	44	f	\N	SS	1	NoOfPhases	\N
1830	(0019,"SIEMENS RA GEN",2e)	(0019,"SIEMENS RA GEN",2e)	SIEMENS RA GEN	25	46	f	\N	SS	1-n	FrameRateForPositions	\N
1831	(0019,"SIEMENS RA GEN",30)	(0019,"SIEMENS RA GEN",30)	SIEMENS RA GEN	25	48	f	\N	SS	1-n	NoOfFramesForPositions	\N
1832	(0019,"SIEMENS RA GEN",32)	(0019,"SIEMENS RA GEN",32)	SIEMENS RA GEN	25	50	f	\N	SS	1	SteppingDirection	\N
1833	(0019,"SIEMENS RA GEN",34)	(0019,"SIEMENS RA GEN",34)	SIEMENS RA GEN	25	52	f	\N	US	1	Unknown	\N
1834	(0019,"SIEMENS RA GEN",36)	(0019,"SIEMENS RA GEN",36)	SIEMENS RA GEN	25	54	f	\N	US	1	Unknown	\N
1835	(0019,"SIEMENS RA GEN",38)	(0019,"SIEMENS RA GEN",38)	SIEMENS RA GEN	25	56	f	\N	US	1	Unknown	\N
1836	(0019,"SIEMENS RA GEN",3a)	(0019,"SIEMENS RA GEN",3a)	SIEMENS RA GEN	25	58	f	\N	US	1	Unknown	\N
1837	(0019,"SIEMENS RA GEN",3c)	(0019,"SIEMENS RA GEN",3c)	SIEMENS RA GEN	25	60	f	\N	US	1	Unknown	\N
1838	(0019,"SIEMENS RA GEN",3e)	(0019,"SIEMENS RA GEN",3e)	SIEMENS RA GEN	25	62	f	\N	US	1	Unknown	\N
1839	(0019,"SIEMENS RA GEN",40)	(0019,"SIEMENS RA GEN",40)	SIEMENS RA GEN	25	64	f	\N	US	1	Unknown	\N
1840	(0019,"SIEMENS RA GEN",42)	(0019,"SIEMENS RA GEN",42)	SIEMENS RA GEN	25	66	f	\N	US	1	Unknown	\N
1841	(0019,"SIEMENS RA GEN",44)	(0019,"SIEMENS RA GEN",44)	SIEMENS RA GEN	25	68	f	\N	SS	1	ImageTransferDelay	\N
1842	(0019,"SIEMENS RA GEN",46)	(0019,"SIEMENS RA GEN",46)	SIEMENS RA GEN	25	70	f	\N	SL	1	InversFlag	\N
1843	(0019,"SIEMENS RA GEN",48)	(0019,"SIEMENS RA GEN",48)	SIEMENS RA GEN	25	72	f	\N	US	1	Unknown	\N
1844	(0019,"SIEMENS RA GEN",4a)	(0019,"SIEMENS RA GEN",4a)	SIEMENS RA GEN	25	74	f	\N	US	1	Unknown	\N
1845	(0019,"SIEMENS RA GEN",4c)	(0019,"SIEMENS RA GEN",4c)	SIEMENS RA GEN	25	76	f	\N	SS	1	BlankingCircleDiameter	\N
1846	(0019,"SIEMENS RA GEN",50)	(0019,"SIEMENS RA GEN",50)	SIEMENS RA GEN	25	80	f	\N	SL	1	StandDataValid	\N
1848	(0019,"SIEMENS RA GEN",54)	(0019,"SIEMENS RA GEN",54)	SIEMENS RA GEN	25	84	f	\N	SS	1	TableAxisRotation	\N
1849	(0019,"SIEMENS RA GEN",56)	(0019,"SIEMENS RA GEN",56)	SIEMENS RA GEN	25	86	f	\N	SS	1	TableLongitudalPosition	\N
1850	(0019,"SIEMENS RA GEN",58)	(0019,"SIEMENS RA GEN",58)	SIEMENS RA GEN	25	88	f	\N	SS	1	TableSideOffset	\N
1851	(0019,"SIEMENS RA GEN",5a)	(0019,"SIEMENS RA GEN",5a)	SIEMENS RA GEN	25	90	f	\N	SS	1	TableIsoCenterHeight	\N
1852	(0019,"SIEMENS RA GEN",5c)	(0019,"SIEMENS RA GEN",5c)	SIEMENS RA GEN	25	92	f	\N	UN	1	Unknown	\N
1853	(0019,"SIEMENS RA GEN",5e)	(0019,"SIEMENS RA GEN",5e)	SIEMENS RA GEN	25	94	f	\N	SL	1	CollimationDataValid	\N
1854	(0019,"SIEMENS RA GEN",60)	(0019,"SIEMENS RA GEN",60)	SIEMENS RA GEN	25	96	f	\N	SL	1	PeriSequenceNo	\N
1855	(0019,"SIEMENS RA GEN",62)	(0019,"SIEMENS RA GEN",62)	SIEMENS RA GEN	25	98	f	\N	SL	1	PeriTotalScenes	\N
1856	(0019,"SIEMENS RA GEN",64)	(0019,"SIEMENS RA GEN",64)	SIEMENS RA GEN	25	100	f	\N	SL	1	PeriOverlapTop	\N
1857	(0019,"SIEMENS RA GEN",66)	(0019,"SIEMENS RA GEN",66)	SIEMENS RA GEN	25	102	f	\N	SL	1	PeriOverlapBottom	\N
1858	(0019,"SIEMENS RA GEN",68)	(0019,"SIEMENS RA GEN",68)	SIEMENS RA GEN	25	104	f	\N	SL	1	RawImageNumber	\N
1859	(0019,"SIEMENS RA GEN",6a)	(0019,"SIEMENS RA GEN",6a)	SIEMENS RA GEN	25	106	f	\N	SL	1	XRayDataValid	\N
1860	(0019,"SIEMENS RA GEN",70)	(0019,"SIEMENS RA GEN",70)	SIEMENS RA GEN	25	112	f	\N	US	1-n	Unknown	\N
1861	(0019,"SIEMENS RA GEN",72)	(0019,"SIEMENS RA GEN",72)	SIEMENS RA GEN	25	114	f	\N	US	1-n	Unknown	\N
1862	(0019,"SIEMENS RA GEN",74)	(0019,"SIEMENS RA GEN",74)	SIEMENS RA GEN	25	116	f	\N	US	1-n	Unknown	\N
1863	(0019,"SIEMENS RA GEN",76)	(0019,"SIEMENS RA GEN",76)	SIEMENS RA GEN	25	118	f	\N	SL	1	FillingAverageFactor	\N
1864	(0019,"SIEMENS RA GEN",78)	(0019,"SIEMENS RA GEN",78)	SIEMENS RA GEN	25	120	f	\N	US	1-n	Unknown	\N
1865	(0019,"SIEMENS RA GEN",7a)	(0019,"SIEMENS RA GEN",7a)	SIEMENS RA GEN	25	122	f	\N	US	1-n	Unknown	\N
1866	(0019,"SIEMENS RA GEN",7c)	(0019,"SIEMENS RA GEN",7c)	SIEMENS RA GEN	25	124	f	\N	US	1-n	Unknown	\N
1867	(0019,"SIEMENS RA GEN",7e)	(0019,"SIEMENS RA GEN",7e)	SIEMENS RA GEN	25	126	f	\N	US	1-n	Unknown	\N
1868	(0019,"SIEMENS RA GEN",80)	(0019,"SIEMENS RA GEN",80)	SIEMENS RA GEN	25	128	f	\N	US	1-n	Unknown	\N
1869	(0019,"SIEMENS RA GEN",82)	(0019,"SIEMENS RA GEN",82)	SIEMENS RA GEN	25	130	f	\N	US	1-n	Unknown	\N
1870	(0019,"SIEMENS RA GEN",84)	(0019,"SIEMENS RA GEN",84)	SIEMENS RA GEN	25	132	f	\N	US	1-n	Unknown	\N
1871	(0019,"SIEMENS RA GEN",86)	(0019,"SIEMENS RA GEN",86)	SIEMENS RA GEN	25	134	f	\N	US	1-n	Unknown	\N
1872	(0019,"SIEMENS RA GEN",88)	(0019,"SIEMENS RA GEN",88)	SIEMENS RA GEN	25	136	f	\N	US	1-n	Unknown	\N
1873	(0019,"SIEMENS RA GEN",8a)	(0019,"SIEMENS RA GEN",8a)	SIEMENS RA GEN	25	138	f	\N	US	1-n	Unknown	\N
1874	(0019,"SIEMENS RA GEN",8c)	(0019,"SIEMENS RA GEN",8c)	SIEMENS RA GEN	25	140	f	\N	US	1-n	Unknown	\N
1875	(0019,"SIEMENS RA GEN",8e)	(0019,"SIEMENS RA GEN",8e)	SIEMENS RA GEN	25	142	f	\N	US	1-n	Unknown	\N
1876	(0019,"SIEMENS RA GEN",92)	(0019,"SIEMENS RA GEN",92)	SIEMENS RA GEN	25	146	f	\N	US	1-n	Unknown	\N
1877	(0019,"SIEMENS RA GEN",94)	(0019,"SIEMENS RA GEN",94)	SIEMENS RA GEN	25	148	f	\N	US	1-n	Unknown	\N
1878	(0019,"SIEMENS RA GEN",96)	(0019,"SIEMENS RA GEN",96)	SIEMENS RA GEN	25	150	f	\N	US	1-n	Unknown	\N
1879	(0019,"SIEMENS RA GEN",98)	(0019,"SIEMENS RA GEN",98)	SIEMENS RA GEN	25	152	f	\N	US	1-n	Unknown	\N
1880	(0019,"SIEMENS RA GEN",9a)	(0019,"SIEMENS RA GEN",9a)	SIEMENS RA GEN	25	154	f	\N	US	1-n	Unknown	\N
1881	(0019,"SIEMENS RA GEN",9c)	(0019,"SIEMENS RA GEN",9c)	SIEMENS RA GEN	25	156	f	\N	SL	1	IntensifierLevelCalibrationFactor	\N
1882	(0019,"SIEMENS RA GEN",9e)	(0019,"SIEMENS RA GEN",9e)	SIEMENS RA GEN	25	158	f	\N	SL	1	NativeReviewFlag	\N
1883	(0019,"SIEMENS RA GEN",a2)	(0019,"SIEMENS RA GEN",a2)	SIEMENS RA GEN	25	162	f	\N	SL	1	SceneNumber	\N
1884	(0019,"SIEMENS RA GEN",a4)	(0019,"SIEMENS RA GEN",a4)	SIEMENS RA GEN	25	164	f	\N	SS	1	AcquisitionMode	\N
1885	(0019,"SIEMENS RA GEN",a5)	(0019,"SIEMENS RA GEN",a5)	SIEMENS RA GEN	25	165	f	\N	SS	1	AcquisitonFrameRate	\N
1886	(0019,"SIEMENS RA GEN",a6)	(0019,"SIEMENS RA GEN",a6)	SIEMENS RA GEN	25	166	f	\N	SL	1	ECGFlag	\N
1887	(0019,"SIEMENS RA GEN",a7)	(0019,"SIEMENS RA GEN",a7)	SIEMENS RA GEN	25	167	f	\N	SL	1	AdditionalSceneData	\N
1888	(0019,"SIEMENS RA GEN",a8)	(0019,"SIEMENS RA GEN",a8)	SIEMENS RA GEN	25	168	f	\N	SL	1	FileCopyFlag	\N
1889	(0019,"SIEMENS RA GEN",a9)	(0019,"SIEMENS RA GEN",a9)	SIEMENS RA GEN	25	169	f	\N	SL	1	PhlebovisionFlag	\N
1890	(0019,"SIEMENS RA GEN",aa)	(0019,"SIEMENS RA GEN",aa)	SIEMENS RA GEN	25	170	f	\N	SL	1	Co2Flag	\N
1891	(0019,"SIEMENS RA GEN",ab)	(0019,"SIEMENS RA GEN",ab)	SIEMENS RA GEN	25	171	f	\N	SS	1	MaxSpeed	\N
1892	(0019,"SIEMENS RA GEN",ac)	(0019,"SIEMENS RA GEN",ac)	SIEMENS RA GEN	25	172	f	\N	SS	1	StepWidth	\N
1893	(0019,"SIEMENS RA GEN",ad)	(0019,"SIEMENS RA GEN",ad)	SIEMENS RA GEN	25	173	f	\N	SL	1	DigitalAcquisitionZoom	\N
1894	(0019,"SIEMENS RA GEN",ff)	(0019,"SIEMENS RA GEN",ff)	SIEMENS RA GEN	25	255	f	\N	SS	1-n	Internal	\N
1895	(0021,"SIEMENS RA GEN",15)	(0021,"SIEMENS RA GEN",15)	SIEMENS RA GEN	33	21	f	\N	SS	1	ImagesInStudy	\N
1896	(0021,"SIEMENS RA GEN",20)	(0021,"SIEMENS RA GEN",20)	SIEMENS RA GEN	33	32	f	\N	SS	1	ScenesInStudy	\N
1897	(0021,"SIEMENS RA GEN",25)	(0021,"SIEMENS RA GEN",25)	SIEMENS RA GEN	33	37	f	\N	SS	1	ImagesInPhotofile	\N
1898	(0021,"SIEMENS RA GEN",27)	(0021,"SIEMENS RA GEN",27)	SIEMENS RA GEN	33	39	f	\N	SS	1	PlaneBImagesExist	\N
1899	(0021,"SIEMENS RA GEN",28)	(0021,"SIEMENS RA GEN",28)	SIEMENS RA GEN	33	40	f	\N	SS	1	NoOf2MBChunks	\N
1900	(0021,"SIEMENS RA GEN",30)	(0021,"SIEMENS RA GEN",30)	SIEMENS RA GEN	33	48	f	\N	SS	1	ImagesInAllScenes	\N
1901	(0021,"SIEMENS RA GEN",40)	(0021,"SIEMENS RA GEN",40)	SIEMENS RA GEN	33	64	f	\N	SS	1	ArchiveSWInternalVersion	\N
1902	(0011,"SIEMENS RA PLANE A",28)	(0011,"SIEMENS RA PLANE A",28)	SIEMENS RA PLANE A	17	40	f	\N	SL	1	FluoroTimerA	\N
1903	(0011,"SIEMENS RA PLANE A",29)	(0011,"SIEMENS RA PLANE A",29)	SIEMENS RA PLANE A	17	41	f	\N	SL	1	FluoroSkinDoseA	\N
1904	(0011,"SIEMENS RA PLANE A",2a)	(0011,"SIEMENS RA PLANE A",2a)	SIEMENS RA PLANE A	17	42	f	\N	SL	1	TotalSkinDoseA	\N
1905	(0011,"SIEMENS RA PLANE A",2b)	(0011,"SIEMENS RA PLANE A",2b)	SIEMENS RA PLANE A	17	43	f	\N	SL	1	FluoroDoseAreaProductA	\N
1906	(0011,"SIEMENS RA PLANE A",2c)	(0011,"SIEMENS RA PLANE A",2c)	SIEMENS RA PLANE A	17	44	f	\N	SL	1	TotalDoseAreaProductA	\N
1907	(0019,"SIEMENS RA PLANE A",15)	(0019,"SIEMENS RA PLANE A",15)	SIEMENS RA PLANE A	25	21	f	\N	LT	1	OfflineUID	\N
1908	(0019,"SIEMENS RA PLANE A",18)	(0019,"SIEMENS RA PLANE A",18)	SIEMENS RA PLANE A	25	24	f	\N	SS	1	Internal	\N
1909	(0019,"SIEMENS RA PLANE A",19)	(0019,"SIEMENS RA PLANE A",19)	SIEMENS RA PLANE A	25	25	f	\N	SS	1	Internal	\N
1910	(0019,"SIEMENS RA PLANE A",1a)	(0019,"SIEMENS RA PLANE A",1a)	SIEMENS RA PLANE A	25	26	f	\N	SS	1	Internal	\N
1911	(0019,"SIEMENS RA PLANE A",1b)	(0019,"SIEMENS RA PLANE A",1b)	SIEMENS RA PLANE A	25	27	f	\N	SS	1	Internal	\N
1912	(0019,"SIEMENS RA PLANE A",1c)	(0019,"SIEMENS RA PLANE A",1c)	SIEMENS RA PLANE A	25	28	f	\N	SS	1	Internal	\N
1913	(0019,"SIEMENS RA PLANE A",1d)	(0019,"SIEMENS RA PLANE A",1d)	SIEMENS RA PLANE A	25	29	f	\N	SS	1	Internal	\N
1914	(0019,"SIEMENS RA PLANE A",1e)	(0019,"SIEMENS RA PLANE A",1e)	SIEMENS RA PLANE A	25	30	f	\N	SS	1	Internal	\N
1915	(0019,"SIEMENS RA PLANE A",1f)	(0019,"SIEMENS RA PLANE A",1f)	SIEMENS RA PLANE A	25	31	f	\N	SS	1-n	Internal	\N
1916	(0019,"SIEMENS RA PLANE A",20)	(0019,"SIEMENS RA PLANE A",20)	SIEMENS RA PLANE A	25	32	f	\N	SS	1	SystemCalibFactorPlaneA	\N
1917	(0019,"SIEMENS RA PLANE A",22)	(0019,"SIEMENS RA PLANE A",22)	SIEMENS RA PLANE A	25	34	f	\N	SS	1	XRayParameterSetNo	\N
1918	(0019,"SIEMENS RA PLANE A",24)	(0019,"SIEMENS RA PLANE A",24)	SIEMENS RA PLANE A	25	36	f	\N	SS	1	XRaySystem	\N
1919	(0019,"SIEMENS RA PLANE A",26)	(0019,"SIEMENS RA PLANE A",26)	SIEMENS RA PLANE A	25	38	f	\N	US	1	Unknown	\N
1920	(0019,"SIEMENS RA PLANE A",28)	(0019,"SIEMENS RA PLANE A",28)	SIEMENS RA PLANE A	25	40	f	\N	SS	1	AcquiredDisplayMode	\N
1921	(0019,"SIEMENS RA PLANE A",2a)	(0019,"SIEMENS RA PLANE A",2a)	SIEMENS RA PLANE A	25	42	f	\N	SS	1	AcquisitionDelay	\N
1922	(0019,"SIEMENS RA PLANE A",2c)	(0019,"SIEMENS RA PLANE A",2c)	SIEMENS RA PLANE A	25	44	f	\N	US	1	Unknown	\N
1923	(0019,"SIEMENS RA PLANE A",2e)	(0019,"SIEMENS RA PLANE A",2e)	SIEMENS RA PLANE A	25	46	f	\N	SS	1	MaxFramesLimit	\N
1924	(0019,"SIEMENS RA PLANE A",30)	(0019,"SIEMENS RA PLANE A",30)	SIEMENS RA PLANE A	25	48	f	\N	US	1	MaximumFrameSizeNIU	\N
1925	(0019,"SIEMENS RA PLANE A",32)	(0019,"SIEMENS RA PLANE A",32)	SIEMENS RA PLANE A	25	50	f	\N	SS	1	SubtractedFilterType	\N
1926	(0019,"SIEMENS RA PLANE A",34)	(0019,"SIEMENS RA PLANE A",34)	SIEMENS RA PLANE A	25	52	f	\N	SS	1	FilterFactorNative	\N
1927	(0019,"SIEMENS RA PLANE A",36)	(0019,"SIEMENS RA PLANE A",36)	SIEMENS RA PLANE A	25	54	f	\N	SS	1	AnatomicBackgroundFactor	\N
1928	(0019,"SIEMENS RA PLANE A",38)	(0019,"SIEMENS RA PLANE A",38)	SIEMENS RA PLANE A	25	56	f	\N	SS	1	WindowUpperLimitNative	\N
1929	(0019,"SIEMENS RA PLANE A",3a)	(0019,"SIEMENS RA PLANE A",3a)	SIEMENS RA PLANE A	25	58	f	\N	SS	1	WindowLowerLimitNative	\N
1930	(0019,"SIEMENS RA PLANE A",3c)	(0019,"SIEMENS RA PLANE A",3c)	SIEMENS RA PLANE A	25	60	f	\N	SS	1	WindowBrightnessPhase1	\N
1931	(0019,"SIEMENS RA PLANE A",3e)	(0019,"SIEMENS RA PLANE A",3e)	SIEMENS RA PLANE A	25	62	f	\N	SS	1	WindowBrightnessPhase2	\N
1932	(0019,"SIEMENS RA PLANE A",40)	(0019,"SIEMENS RA PLANE A",40)	SIEMENS RA PLANE A	25	64	f	\N	SS	1	WindowContrastPhase1	\N
1933	(0019,"SIEMENS RA PLANE A",42)	(0019,"SIEMENS RA PLANE A",42)	SIEMENS RA PLANE A	25	66	f	\N	SS	1	WindowContrastPhase2	\N
1934	(0019,"SIEMENS RA PLANE A",44)	(0019,"SIEMENS RA PLANE A",44)	SIEMENS RA PLANE A	25	68	f	\N	SS	1	FilterFactorSub	\N
1935	(0019,"SIEMENS RA PLANE A",46)	(0019,"SIEMENS RA PLANE A",46)	SIEMENS RA PLANE A	25	70	f	\N	SS	1	PeakOpacified	\N
1936	(0019,"SIEMENS RA PLANE A",48)	(0019,"SIEMENS RA PLANE A",48)	SIEMENS RA PLANE A	25	72	f	\N	SL	1	MaskFrame	\N
1937	(0019,"SIEMENS RA PLANE A",4a)	(0019,"SIEMENS RA PLANE A",4a)	SIEMENS RA PLANE A	25	74	f	\N	SL	1	BIHFrame	\N
1938	(0019,"SIEMENS RA PLANE A",4c)	(0019,"SIEMENS RA PLANE A",4c)	SIEMENS RA PLANE A	25	76	f	\N	SS	1	CentBeamAngulationCaudCran	\N
1939	(0019,"SIEMENS RA PLANE A",4e)	(0019,"SIEMENS RA PLANE A",4e)	SIEMENS RA PLANE A	25	78	f	\N	SS	1	CentBeamAngulationLRAnterior	\N
1940	(0019,"SIEMENS RA PLANE A",50)	(0019,"SIEMENS RA PLANE A",50)	SIEMENS RA PLANE A	25	80	f	\N	SS	1	LongitudinalPosition	\N
1941	(0019,"SIEMENS RA PLANE A",52)	(0019,"SIEMENS RA PLANE A",52)	SIEMENS RA PLANE A	25	82	f	\N	SS	1	SideOffset	\N
1942	(0019,"SIEMENS RA PLANE A",54)	(0019,"SIEMENS RA PLANE A",54)	SIEMENS RA PLANE A	25	84	f	\N	SS	1	IsoCenterHeight	\N
1943	(0019,"SIEMENS RA PLANE A",56)	(0019,"SIEMENS RA PLANE A",56)	SIEMENS RA PLANE A	25	86	f	\N	SS	1	ImageTwist	\N
1944	(0019,"SIEMENS RA PLANE A",58)	(0019,"SIEMENS RA PLANE A",58)	SIEMENS RA PLANE A	25	88	f	\N	SS	1	SourceImageDistance	\N
1945	(0019,"SIEMENS RA PLANE A",5a)	(0019,"SIEMENS RA PLANE A",5a)	SIEMENS RA PLANE A	25	90	f	\N	SS	1	MechanicalMagnificationFactor	\N
1946	(0019,"SIEMENS RA PLANE A",5c)	(0019,"SIEMENS RA PLANE A",5c)	SIEMENS RA PLANE A	25	92	f	\N	SL	1	CalibrationFlag	\N
1947	(0019,"SIEMENS RA PLANE A",5e)	(0019,"SIEMENS RA PLANE A",5e)	SIEMENS RA PLANE A	25	94	f	\N	SL	1	CalibrationAngleCranCaud	\N
1948	(0019,"SIEMENS RA PLANE A",60)	(0019,"SIEMENS RA PLANE A",60)	SIEMENS RA PLANE A	25	96	f	\N	SL	1	CalibrationAngleRAOLAO	\N
1949	(0019,"SIEMENS RA PLANE A",62)	(0019,"SIEMENS RA PLANE A",62)	SIEMENS RA PLANE A	25	98	f	\N	SL	1	CalibrationTableToFloorDist	\N
1950	(0019,"SIEMENS RA PLANE A",64)	(0019,"SIEMENS RA PLANE A",64)	SIEMENS RA PLANE A	25	100	f	\N	SL	1	CalibrationIsocenterToFloorDist	\N
1951	(0019,"SIEMENS RA PLANE A",66)	(0019,"SIEMENS RA PLANE A",66)	SIEMENS RA PLANE A	25	102	f	\N	SL	1	CalibrationIsocenterToSourceDist	\N
1952	(0019,"SIEMENS RA PLANE A",68)	(0019,"SIEMENS RA PLANE A",68)	SIEMENS RA PLANE A	25	104	f	\N	SL	1	CalibrationSourceToII	\N
1953	(0019,"SIEMENS RA PLANE A",6a)	(0019,"SIEMENS RA PLANE A",6a)	SIEMENS RA PLANE A	25	106	f	\N	SL	1	CalibrationIIZoom	\N
1954	(0019,"SIEMENS RA PLANE A",6c)	(0019,"SIEMENS RA PLANE A",6c)	SIEMENS RA PLANE A	25	108	f	\N	SL	1	CalibrationIIField	\N
1955	(0019,"SIEMENS RA PLANE A",6e)	(0019,"SIEMENS RA PLANE A",6e)	SIEMENS RA PLANE A	25	110	f	\N	SL	1	CalibrationFactor	\N
1956	(0019,"SIEMENS RA PLANE A",70)	(0019,"SIEMENS RA PLANE A",70)	SIEMENS RA PLANE A	25	112	f	\N	SL	1	CalibrationObjectToImageDistance	\N
1957	(0019,"SIEMENS RA PLANE A",72)	(0019,"SIEMENS RA PLANE A",72)	SIEMENS RA PLANE A	25	114	f	\N	SL	1-n	CalibrationSystemFactor	\N
1958	(0019,"SIEMENS RA PLANE A",74)	(0019,"SIEMENS RA PLANE A",74)	SIEMENS RA PLANE A	25	116	f	\N	SL	1-n	CalibrationSystemCorrection	\N
1959	(0019,"SIEMENS RA PLANE A",76)	(0019,"SIEMENS RA PLANE A",76)	SIEMENS RA PLANE A	25	118	f	\N	SL	1-n	CalibrationSystemIIFormats	\N
1960	(0019,"SIEMENS RA PLANE A",78)	(0019,"SIEMENS RA PLANE A",78)	SIEMENS RA PLANE A	25	120	f	\N	SL	1	CalibrationGantryDataValid	\N
1961	(0019,"SIEMENS RA PLANE A",7a)	(0019,"SIEMENS RA PLANE A",7a)	SIEMENS RA PLANE A	25	122	f	\N	SS	1	CollimatorSquareBreadth	\N
1962	(0019,"SIEMENS RA PLANE A",7c)	(0019,"SIEMENS RA PLANE A",7c)	SIEMENS RA PLANE A	25	124	f	\N	SS	1	CollimatorSquareHeight	\N
1963	(0019,"SIEMENS RA PLANE A",7e)	(0019,"SIEMENS RA PLANE A",7e)	SIEMENS RA PLANE A	25	126	f	\N	SS	1	CollimatorSquareDiameter	\N
1964	(0019,"SIEMENS RA PLANE A",80)	(0019,"SIEMENS RA PLANE A",80)	SIEMENS RA PLANE A	25	128	f	\N	SS	1	CollimaterFingerTurnAngle	\N
1965	(0019,"SIEMENS RA PLANE A",82)	(0019,"SIEMENS RA PLANE A",82)	SIEMENS RA PLANE A	25	130	f	\N	SS	1	CollimaterFingerPosition	\N
1966	(0019,"SIEMENS RA PLANE A",84)	(0019,"SIEMENS RA PLANE A",84)	SIEMENS RA PLANE A	25	132	f	\N	SS	1	CollimaterDiaphragmTurnAngle	\N
1967	(0019,"SIEMENS RA PLANE A",86)	(0019,"SIEMENS RA PLANE A",86)	SIEMENS RA PLANE A	25	134	f	\N	SS	1	CollimaterDiaphragmPosition1	\N
1968	(0019,"SIEMENS RA PLANE A",88)	(0019,"SIEMENS RA PLANE A",88)	SIEMENS RA PLANE A	25	136	f	\N	SS	1	CollimaterDiaphragmPosition2	\N
1969	(0019,"SIEMENS RA PLANE A",8a)	(0019,"SIEMENS RA PLANE A",8a)	SIEMENS RA PLANE A	25	138	f	\N	SS	1	CollimaterDiaphragmMode	\N
1970	(0019,"SIEMENS RA PLANE A",8c)	(0019,"SIEMENS RA PLANE A",8c)	SIEMENS RA PLANE A	25	140	f	\N	SS	1	CollimaterBeamLimitBreadth	\N
1971	(0019,"SIEMENS RA PLANE A",8e)	(0019,"SIEMENS RA PLANE A",8e)	SIEMENS RA PLANE A	25	142	f	\N	SS	1	CollimaterBeamLimitHeight	\N
1972	(0019,"SIEMENS RA PLANE A",90)	(0019,"SIEMENS RA PLANE A",90)	SIEMENS RA PLANE A	25	144	f	\N	SS	1	CollimaterBeamLimitDiameter	\N
1973	(0019,"SIEMENS RA PLANE A",92)	(0019,"SIEMENS RA PLANE A",92)	SIEMENS RA PLANE A	25	146	f	\N	SS	1	X-RayControlMOde	\N
1974	(0019,"SIEMENS RA PLANE A",94)	(0019,"SIEMENS RA PLANE A",94)	SIEMENS RA PLANE A	25	148	f	\N	SS	1	X-RaySystem	\N
1975	(0019,"SIEMENS RA PLANE A",96)	(0019,"SIEMENS RA PLANE A",96)	SIEMENS RA PLANE A	25	150	f	\N	SS	1	FocalSpot	\N
1976	(0019,"SIEMENS RA PLANE A",98)	(0019,"SIEMENS RA PLANE A",98)	SIEMENS RA PLANE A	25	152	f	\N	SS	1	ExposureControl	\N
1977	(0019,"SIEMENS RA PLANE A",9a)	(0019,"SIEMENS RA PLANE A",9a)	SIEMENS RA PLANE A	25	154	f	\N	SL	1	XRayVoltage	\N
1978	(0019,"SIEMENS RA PLANE A",9c)	(0019,"SIEMENS RA PLANE A",9c)	SIEMENS RA PLANE A	25	156	f	\N	SL	1	XRayCurrent	\N
1979	(0019,"SIEMENS RA PLANE A",9e)	(0019,"SIEMENS RA PLANE A",9e)	SIEMENS RA PLANE A	25	158	f	\N	SL	1	XRayCurrentTimeProduct	\N
1980	(0019,"SIEMENS RA PLANE A",a0)	(0019,"SIEMENS RA PLANE A",a0)	SIEMENS RA PLANE A	25	160	f	\N	SL	1	XRayPulseTime	\N
1981	(0019,"SIEMENS RA PLANE A",a2)	(0019,"SIEMENS RA PLANE A",a2)	SIEMENS RA PLANE A	25	162	f	\N	SL	1	XRaySceneTimeFluoroClock	\N
1982	(0019,"SIEMENS RA PLANE A",a4)	(0019,"SIEMENS RA PLANE A",a4)	SIEMENS RA PLANE A	25	164	f	\N	SS	1	MaximumPulseRate	\N
1983	(0019,"SIEMENS RA PLANE A",a6)	(0019,"SIEMENS RA PLANE A",a6)	SIEMENS RA PLANE A	25	166	f	\N	SS	1	PulsesPerScene	\N
1984	(0019,"SIEMENS RA PLANE A",a8)	(0019,"SIEMENS RA PLANE A",a8)	SIEMENS RA PLANE A	25	168	f	\N	SL	1	DoseAreaProductOfScene	\N
1985	(0019,"SIEMENS RA PLANE A",aa)	(0019,"SIEMENS RA PLANE A",aa)	SIEMENS RA PLANE A	25	170	f	\N	SS	1	Dose	\N
1986	(0019,"SIEMENS RA PLANE A",ac)	(0019,"SIEMENS RA PLANE A",ac)	SIEMENS RA PLANE A	25	172	f	\N	SS	1	DoseRate	\N
1987	(0019,"SIEMENS RA PLANE A",ae)	(0019,"SIEMENS RA PLANE A",ae)	SIEMENS RA PLANE A	25	174	f	\N	SL	1	IIToCoverDistance	\N
1988	(0019,"SIEMENS RA PLANE A",b0)	(0019,"SIEMENS RA PLANE A",b0)	SIEMENS RA PLANE A	25	176	f	\N	SS	1	LastFramePhase1	\N
1989	(0019,"SIEMENS RA PLANE A",b1)	(0019,"SIEMENS RA PLANE A",b1)	SIEMENS RA PLANE A	25	177	f	\N	SS	1	FrameRatePhase1	\N
1990	(0019,"SIEMENS RA PLANE A",b2)	(0019,"SIEMENS RA PLANE A",b2)	SIEMENS RA PLANE A	25	178	f	\N	SS	1	LastFramePhase2	\N
1991	(0019,"SIEMENS RA PLANE A",b3)	(0019,"SIEMENS RA PLANE A",b3)	SIEMENS RA PLANE A	25	179	f	\N	SS	1	FrameRatePhase2	\N
1992	(0019,"SIEMENS RA PLANE A",b4)	(0019,"SIEMENS RA PLANE A",b4)	SIEMENS RA PLANE A	25	180	f	\N	SS	1	LastFramePhase3	\N
1993	(0019,"SIEMENS RA PLANE A",b5)	(0019,"SIEMENS RA PLANE A",b5)	SIEMENS RA PLANE A	25	181	f	\N	SS	1	FrameRatePhase3	\N
1994	(0019,"SIEMENS RA PLANE A",b6)	(0019,"SIEMENS RA PLANE A",b6)	SIEMENS RA PLANE A	25	182	f	\N	SS	1	LastFramePhase4	\N
1995	(0019,"SIEMENS RA PLANE A",b7)	(0019,"SIEMENS RA PLANE A",b7)	SIEMENS RA PLANE A	25	183	f	\N	SS	1	FrameRatePhase4	\N
1996	(0019,"SIEMENS RA PLANE A",b8)	(0019,"SIEMENS RA PLANE A",b8)	SIEMENS RA PLANE A	25	184	f	\N	SS	1	GammaOfNativeImage	\N
1997	(0019,"SIEMENS RA PLANE A",b9)	(0019,"SIEMENS RA PLANE A",b9)	SIEMENS RA PLANE A	25	185	f	\N	SS	1	GammaOfTVSystem	\N
1998	(0019,"SIEMENS RA PLANE A",bb)	(0019,"SIEMENS RA PLANE A",bb)	SIEMENS RA PLANE A	25	187	f	\N	SL	1	PixelshiftX	\N
1999	(0019,"SIEMENS RA PLANE A",bc)	(0019,"SIEMENS RA PLANE A",bc)	SIEMENS RA PLANE A	25	188	f	\N	SL	1	PixelshiftY	\N
2000	(0019,"SIEMENS RA PLANE A",bd)	(0019,"SIEMENS RA PLANE A",bd)	SIEMENS RA PLANE A	25	189	f	\N	SL	1	MaskAverageFactor	\N
2001	(0019,"SIEMENS RA PLANE A",be)	(0019,"SIEMENS RA PLANE A",be)	SIEMENS RA PLANE A	25	190	f	\N	SL	1	BlankingCircleFlag	\N
2002	(0019,"SIEMENS RA PLANE A",bf)	(0019,"SIEMENS RA PLANE A",bf)	SIEMENS RA PLANE A	25	191	f	\N	SL	1	CircleRowStart	\N
2003	(0019,"SIEMENS RA PLANE A",c0)	(0019,"SIEMENS RA PLANE A",c0)	SIEMENS RA PLANE A	25	192	f	\N	SL	1	CircleRowEnd	\N
2004	(0019,"SIEMENS RA PLANE A",c1)	(0019,"SIEMENS RA PLANE A",c1)	SIEMENS RA PLANE A	25	193	f	\N	SL	1	CircleColumnStart	\N
2005	(0019,"SIEMENS RA PLANE A",c2)	(0019,"SIEMENS RA PLANE A",c2)	SIEMENS RA PLANE A	25	194	f	\N	SL	1	CircleColumnEnd	\N
2006	(0019,"SIEMENS RA PLANE A",c3)	(0019,"SIEMENS RA PLANE A",c3)	SIEMENS RA PLANE A	25	195	f	\N	SL	1	CircleDiameter	\N
2007	(0019,"SIEMENS RA PLANE A",c4)	(0019,"SIEMENS RA PLANE A",c4)	SIEMENS RA PLANE A	25	196	f	\N	SL	1	RectangularCollimaterFlag	\N
2008	(0019,"SIEMENS RA PLANE A",c5)	(0019,"SIEMENS RA PLANE A",c5)	SIEMENS RA PLANE A	25	197	f	\N	SL	1	RectangleRowStart	\N
2642	(0019,"SVISION",90)	(0019,"SVISION",90)	SVISION	25	144	f	\N	LO	1	DeskCommand	\N
2009	(0019,"SIEMENS RA PLANE A",c6)	(0019,"SIEMENS RA PLANE A",c6)	SIEMENS RA PLANE A	25	198	f	\N	SL	1	RectangleRowEnd	\N
2010	(0019,"SIEMENS RA PLANE A",c7)	(0019,"SIEMENS RA PLANE A",c7)	SIEMENS RA PLANE A	25	199	f	\N	SL	1	RectangleColumnStart	\N
2011	(0019,"SIEMENS RA PLANE A",c8)	(0019,"SIEMENS RA PLANE A",c8)	SIEMENS RA PLANE A	25	200	f	\N	SL	1	RectangleColumnEnd	\N
2012	(0019,"SIEMENS RA PLANE A",c9)	(0019,"SIEMENS RA PLANE A",c9)	SIEMENS RA PLANE A	25	201	f	\N	SL	1	RectangleAngulation	\N
2013	(0019,"SIEMENS RA PLANE A",ca)	(0019,"SIEMENS RA PLANE A",ca)	SIEMENS RA PLANE A	25	202	f	\N	SL	1	IrisCollimatorFlag	\N
2014	(0019,"SIEMENS RA PLANE A",cb)	(0019,"SIEMENS RA PLANE A",cb)	SIEMENS RA PLANE A	25	203	f	\N	SL	1	IrisRowStart	\N
2015	(0019,"SIEMENS RA PLANE A",cc)	(0019,"SIEMENS RA PLANE A",cc)	SIEMENS RA PLANE A	25	204	f	\N	SL	1	IrisRowEnd	\N
2016	(0019,"SIEMENS RA PLANE A",cd)	(0019,"SIEMENS RA PLANE A",cd)	SIEMENS RA PLANE A	25	205	f	\N	SL	1	IrisColumnStart	\N
2017	(0019,"SIEMENS RA PLANE A",ce)	(0019,"SIEMENS RA PLANE A",ce)	SIEMENS RA PLANE A	25	206	f	\N	SL	1	IrisColumnEnd	\N
2018	(0019,"SIEMENS RA PLANE A",cf)	(0019,"SIEMENS RA PLANE A",cf)	SIEMENS RA PLANE A	25	207	f	\N	SL	1	IrisAngulation	\N
2019	(0019,"SIEMENS RA PLANE A",d1)	(0019,"SIEMENS RA PLANE A",d1)	SIEMENS RA PLANE A	25	209	f	\N	SS	1	NumberOfFramesPlane	\N
2020	(0019,"SIEMENS RA PLANE A",d2)	(0019,"SIEMENS RA PLANE A",d2)	SIEMENS RA PLANE A	25	210	f	\N	SS	1	Internal	\N
2021	(0019,"SIEMENS RA PLANE A",d3)	(0019,"SIEMENS RA PLANE A",d3)	SIEMENS RA PLANE A	25	211	f	\N	SS	1	Internal	\N
2022	(0019,"SIEMENS RA PLANE A",d4)	(0019,"SIEMENS RA PLANE A",d4)	SIEMENS RA PLANE A	25	212	f	\N	SS	1	Internal	\N
2023	(0019,"SIEMENS RA PLANE A",d5)	(0019,"SIEMENS RA PLANE A",d5)	SIEMENS RA PLANE A	25	213	f	\N	SS	1	Internal	\N
2024	(0019,"SIEMENS RA PLANE A",d6)	(0019,"SIEMENS RA PLANE A",d6)	SIEMENS RA PLANE A	25	214	f	\N	SS	1-n	Internal	\N
2025	(0019,"SIEMENS RA PLANE A",d7)	(0019,"SIEMENS RA PLANE A",d7)	SIEMENS RA PLANE A	25	215	f	\N	SS	1-n	Internal	\N
2026	(0019,"SIEMENS RA PLANE A",d8)	(0019,"SIEMENS RA PLANE A",d8)	SIEMENS RA PLANE A	25	216	f	\N	SS	1	Internal	\N
2027	(0019,"SIEMENS RA PLANE A",d9)	(0019,"SIEMENS RA PLANE A",d9)	SIEMENS RA PLANE A	25	217	f	\N	SS	1	Internal	\N
2028	(0019,"SIEMENS RA PLANE A",da)	(0019,"SIEMENS RA PLANE A",da)	SIEMENS RA PLANE A	25	218	f	\N	SS	1	Internal	\N
2029	(0019,"SIEMENS RA PLANE A",db)	(0019,"SIEMENS RA PLANE A",db)	SIEMENS RA PLANE A	25	219	f	\N	SS	1	Internal	\N
2030	(0019,"SIEMENS RA PLANE A",dc)	(0019,"SIEMENS RA PLANE A",dc)	SIEMENS RA PLANE A	25	220	f	\N	SS	1	Internal	\N
2031	(0019,"SIEMENS RA PLANE A",dd)	(0019,"SIEMENS RA PLANE A",dd)	SIEMENS RA PLANE A	25	221	f	\N	SL	1	AnatomicBackground	\N
2032	(0019,"SIEMENS RA PLANE A",de)	(0019,"SIEMENS RA PLANE A",de)	SIEMENS RA PLANE A	25	222	f	\N	SL	1-n	AutoWindowBase	\N
2033	(0019,"SIEMENS RA PLANE A",df)	(0019,"SIEMENS RA PLANE A",df)	SIEMENS RA PLANE A	25	223	f	\N	SS	1	Internal	\N
2034	(0019,"SIEMENS RA PLANE A",e0)	(0019,"SIEMENS RA PLANE A",e0)	SIEMENS RA PLANE A	25	224	f	\N	SL	1	Internal	\N
2035	(0011,"SIEMENS RA PLANE B",28)	(0011,"SIEMENS RA PLANE B",28)	SIEMENS RA PLANE B	17	40	f	\N	SL	1	FluoroTimerB	\N
2036	(0011,"SIEMENS RA PLANE B",29)	(0011,"SIEMENS RA PLANE B",29)	SIEMENS RA PLANE B	17	41	f	\N	SL	1	FluoroSkinDoseB	\N
2037	(0011,"SIEMENS RA PLANE B",2a)	(0011,"SIEMENS RA PLANE B",2a)	SIEMENS RA PLANE B	17	42	f	\N	SL	1	TotalSkinDoseB	\N
2038	(0011,"SIEMENS RA PLANE B",2b)	(0011,"SIEMENS RA PLANE B",2b)	SIEMENS RA PLANE B	17	43	f	\N	SL	1	FluoroDoseAreaProductB	\N
2039	(0011,"SIEMENS RA PLANE B",2c)	(0011,"SIEMENS RA PLANE B",2c)	SIEMENS RA PLANE B	17	44	f	\N	SL	1	TotalDoseAreaProductB	\N
2040	(0019,"SIEMENS RA PLANE B",18)	(0019,"SIEMENS RA PLANE B",18)	SIEMENS RA PLANE B	25	24	f	\N	SS	1	Internal	\N
2041	(0019,"SIEMENS RA PLANE B",19)	(0019,"SIEMENS RA PLANE B",19)	SIEMENS RA PLANE B	25	25	f	\N	SS	1	Internal	\N
2042	(0019,"SIEMENS RA PLANE B",1a)	(0019,"SIEMENS RA PLANE B",1a)	SIEMENS RA PLANE B	25	26	f	\N	SS	1	Internal	\N
2043	(0019,"SIEMENS RA PLANE B",1b)	(0019,"SIEMENS RA PLANE B",1b)	SIEMENS RA PLANE B	25	27	f	\N	SS	1	Internal	\N
2044	(0019,"SIEMENS RA PLANE B",1c)	(0019,"SIEMENS RA PLANE B",1c)	SIEMENS RA PLANE B	25	28	f	\N	SS	1	Internal	\N
2045	(0019,"SIEMENS RA PLANE B",1d)	(0019,"SIEMENS RA PLANE B",1d)	SIEMENS RA PLANE B	25	29	f	\N	SS	1	Internal	\N
2046	(0019,"SIEMENS RA PLANE B",1e)	(0019,"SIEMENS RA PLANE B",1e)	SIEMENS RA PLANE B	25	30	f	\N	SS	1	Internal	\N
2047	(0019,"SIEMENS RA PLANE B",1f)	(0019,"SIEMENS RA PLANE B",1f)	SIEMENS RA PLANE B	25	31	f	\N	SS	1	Internal	\N
2048	(0019,"SIEMENS RA PLANE B",20)	(0019,"SIEMENS RA PLANE B",20)	SIEMENS RA PLANE B	25	32	f	\N	SL	1-n	SystemCalibFactorPlaneB	\N
2049	(0019,"SIEMENS RA PLANE B",22)	(0019,"SIEMENS RA PLANE B",22)	SIEMENS RA PLANE B	25	34	f	\N	US	1	Unknown	\N
2050	(0019,"SIEMENS RA PLANE B",24)	(0019,"SIEMENS RA PLANE B",24)	SIEMENS RA PLANE B	25	36	f	\N	US	1	Unknown	\N
2051	(0019,"SIEMENS RA PLANE B",26)	(0019,"SIEMENS RA PLANE B",26)	SIEMENS RA PLANE B	25	38	f	\N	US	1	Unknown	\N
2052	(0019,"SIEMENS RA PLANE B",28)	(0019,"SIEMENS RA PLANE B",28)	SIEMENS RA PLANE B	25	40	f	\N	US	1	Unknown	\N
2053	(0019,"SIEMENS RA PLANE B",2a)	(0019,"SIEMENS RA PLANE B",2a)	SIEMENS RA PLANE B	25	42	f	\N	US	1	Unknown	\N
2054	(0019,"SIEMENS RA PLANE B",2c)	(0019,"SIEMENS RA PLANE B",2c)	SIEMENS RA PLANE B	25	44	f	\N	US	1	Unknown	\N
2055	(0019,"SIEMENS RA PLANE B",2e)	(0019,"SIEMENS RA PLANE B",2e)	SIEMENS RA PLANE B	25	46	f	\N	US	1	Unknown	\N
2056	(0019,"SIEMENS RA PLANE B",30)	(0019,"SIEMENS RA PLANE B",30)	SIEMENS RA PLANE B	25	48	f	\N	US	1	Unknown	\N
2057	(0019,"SIEMENS RA PLANE B",32)	(0019,"SIEMENS RA PLANE B",32)	SIEMENS RA PLANE B	25	50	f	\N	US	1	Unknown	\N
2058	(0019,"SIEMENS RA PLANE B",34)	(0019,"SIEMENS RA PLANE B",34)	SIEMENS RA PLANE B	25	52	f	\N	US	1	Unknown	\N
2059	(0019,"SIEMENS RA PLANE B",36)	(0019,"SIEMENS RA PLANE B",36)	SIEMENS RA PLANE B	25	54	f	\N	US	1	Unknown	\N
2060	(0019,"SIEMENS RA PLANE B",38)	(0019,"SIEMENS RA PLANE B",38)	SIEMENS RA PLANE B	25	56	f	\N	US	1	Unknown	\N
2061	(0019,"SIEMENS RA PLANE B",3a)	(0019,"SIEMENS RA PLANE B",3a)	SIEMENS RA PLANE B	25	58	f	\N	US	1	Unknown	\N
2062	(0019,"SIEMENS RA PLANE B",3c)	(0019,"SIEMENS RA PLANE B",3c)	SIEMENS RA PLANE B	25	60	f	\N	US	1	Unknown	\N
2063	(0019,"SIEMENS RA PLANE B",3e)	(0019,"SIEMENS RA PLANE B",3e)	SIEMENS RA PLANE B	25	62	f	\N	US	1	Unknown	\N
2064	(0019,"SIEMENS RA PLANE B",40)	(0019,"SIEMENS RA PLANE B",40)	SIEMENS RA PLANE B	25	64	f	\N	US	1	Unknown	\N
2065	(0019,"SIEMENS RA PLANE B",42)	(0019,"SIEMENS RA PLANE B",42)	SIEMENS RA PLANE B	25	66	f	\N	US	1	Unknown	\N
2066	(0019,"SIEMENS RA PLANE B",44)	(0019,"SIEMENS RA PLANE B",44)	SIEMENS RA PLANE B	25	68	f	\N	US	1	Unknown	\N
2067	(0019,"SIEMENS RA PLANE B",46)	(0019,"SIEMENS RA PLANE B",46)	SIEMENS RA PLANE B	25	70	f	\N	US	1	Unknown	\N
2068	(0019,"SIEMENS RA PLANE B",48)	(0019,"SIEMENS RA PLANE B",48)	SIEMENS RA PLANE B	25	72	f	\N	US	1	Unknown	\N
2069	(0019,"SIEMENS RA PLANE B",4a)	(0019,"SIEMENS RA PLANE B",4a)	SIEMENS RA PLANE B	25	74	f	\N	US	1-n	Unknown	\N
2070	(0019,"SIEMENS RA PLANE B",4c)	(0019,"SIEMENS RA PLANE B",4c)	SIEMENS RA PLANE B	25	76	f	\N	US	1-n	Unknown	\N
2071	(0019,"SIEMENS RA PLANE B",4e)	(0019,"SIEMENS RA PLANE B",4e)	SIEMENS RA PLANE B	25	78	f	\N	US	1-n	Unknown	\N
2072	(0019,"SIEMENS RA PLANE B",50)	(0019,"SIEMENS RA PLANE B",50)	SIEMENS RA PLANE B	25	80	f	\N	US	1	Unknown	\N
2073	(0019,"SIEMENS RA PLANE B",52)	(0019,"SIEMENS RA PLANE B",52)	SIEMENS RA PLANE B	25	82	f	\N	US	1	Unknown	\N
2074	(0019,"SIEMENS RA PLANE B",54)	(0019,"SIEMENS RA PLANE B",54)	SIEMENS RA PLANE B	25	84	f	\N	US	1	Unknown	\N
2075	(0019,"SIEMENS RA PLANE B",56)	(0019,"SIEMENS RA PLANE B",56)	SIEMENS RA PLANE B	25	86	f	\N	US	1	Unknown	\N
2076	(0019,"SIEMENS RA PLANE B",58)	(0019,"SIEMENS RA PLANE B",58)	SIEMENS RA PLANE B	25	88	f	\N	US	1	Unknown	\N
2077	(0019,"SIEMENS RA PLANE B",5a)	(0019,"SIEMENS RA PLANE B",5a)	SIEMENS RA PLANE B	25	90	f	\N	US	1	Unknown	\N
2078	(0019,"SIEMENS RA PLANE B",5c)	(0019,"SIEMENS RA PLANE B",5c)	SIEMENS RA PLANE B	25	92	f	\N	US	1-n	Unknown	\N
2079	(0019,"SIEMENS RA PLANE B",5e)	(0019,"SIEMENS RA PLANE B",5e)	SIEMENS RA PLANE B	25	94	f	\N	US	1-n	Unknown	\N
2080	(0019,"SIEMENS RA PLANE B",60)	(0019,"SIEMENS RA PLANE B",60)	SIEMENS RA PLANE B	25	96	f	\N	US	1-n	Unknown	\N
2081	(0019,"SIEMENS RA PLANE B",62)	(0019,"SIEMENS RA PLANE B",62)	SIEMENS RA PLANE B	25	98	f	\N	US	1-n	Unknown	\N
2082	(0019,"SIEMENS RA PLANE B",64)	(0019,"SIEMENS RA PLANE B",64)	SIEMENS RA PLANE B	25	100	f	\N	US	1-n	Unknown	\N
2083	(0019,"SIEMENS RA PLANE B",66)	(0019,"SIEMENS RA PLANE B",66)	SIEMENS RA PLANE B	25	102	f	\N	US	1-n	Unknown	\N
2084	(0019,"SIEMENS RA PLANE B",68)	(0019,"SIEMENS RA PLANE B",68)	SIEMENS RA PLANE B	25	104	f	\N	US	1-n	Unknown	\N
2085	(0019,"SIEMENS RA PLANE B",6a)	(0019,"SIEMENS RA PLANE B",6a)	SIEMENS RA PLANE B	25	106	f	\N	US	1-n	Unknown	\N
2086	(0019,"SIEMENS RA PLANE B",6c)	(0019,"SIEMENS RA PLANE B",6c)	SIEMENS RA PLANE B	25	108	f	\N	US	1-n	Unknown	\N
2087	(0019,"SIEMENS RA PLANE B",6e)	(0019,"SIEMENS RA PLANE B",6e)	SIEMENS RA PLANE B	25	110	f	\N	US	1-n	Unknown	\N
2088	(0019,"SIEMENS RA PLANE B",70)	(0019,"SIEMENS RA PLANE B",70)	SIEMENS RA PLANE B	25	112	f	\N	US	1-n	Unknown	\N
2089	(0019,"SIEMENS RA PLANE B",72)	(0019,"SIEMENS RA PLANE B",72)	SIEMENS RA PLANE B	25	114	f	\N	UN	1	Unknown	\N
2090	(0019,"SIEMENS RA PLANE B",74)	(0019,"SIEMENS RA PLANE B",74)	SIEMENS RA PLANE B	25	116	f	\N	UN	1	Unknown	\N
2091	(0019,"SIEMENS RA PLANE B",76)	(0019,"SIEMENS RA PLANE B",76)	SIEMENS RA PLANE B	25	118	f	\N	UN	1	Unknown	\N
2092	(0019,"SIEMENS RA PLANE B",78)	(0019,"SIEMENS RA PLANE B",78)	SIEMENS RA PLANE B	25	120	f	\N	US	1-n	Unknown	\N
2093	(0019,"SIEMENS RA PLANE B",7a)	(0019,"SIEMENS RA PLANE B",7a)	SIEMENS RA PLANE B	25	122	f	\N	US	1	Unknown	\N
2094	(0019,"SIEMENS RA PLANE B",7c)	(0019,"SIEMENS RA PLANE B",7c)	SIEMENS RA PLANE B	25	124	f	\N	US	1	Unknown	\N
2095	(0019,"SIEMENS RA PLANE B",7e)	(0019,"SIEMENS RA PLANE B",7e)	SIEMENS RA PLANE B	25	126	f	\N	US	1	Unknown	\N
2096	(0019,"SIEMENS RA PLANE B",80)	(0019,"SIEMENS RA PLANE B",80)	SIEMENS RA PLANE B	25	128	f	\N	US	1	Unknown	\N
2097	(0019,"SIEMENS RA PLANE B",82)	(0019,"SIEMENS RA PLANE B",82)	SIEMENS RA PLANE B	25	130	f	\N	US	1	Unknown	\N
2098	(0019,"SIEMENS RA PLANE B",84)	(0019,"SIEMENS RA PLANE B",84)	SIEMENS RA PLANE B	25	132	f	\N	US	1	Unknown	\N
2099	(0019,"SIEMENS RA PLANE B",86)	(0019,"SIEMENS RA PLANE B",86)	SIEMENS RA PLANE B	25	134	f	\N	US	1	Unknown	\N
2100	(0019,"SIEMENS RA PLANE B",88)	(0019,"SIEMENS RA PLANE B",88)	SIEMENS RA PLANE B	25	136	f	\N	US	1	Unknown	\N
2101	(0019,"SIEMENS RA PLANE B",8a)	(0019,"SIEMENS RA PLANE B",8a)	SIEMENS RA PLANE B	25	138	f	\N	US	1	Unknown	\N
2102	(0019,"SIEMENS RA PLANE B",8c)	(0019,"SIEMENS RA PLANE B",8c)	SIEMENS RA PLANE B	25	140	f	\N	US	1	Unknown	\N
2103	(0019,"SIEMENS RA PLANE B",8e)	(0019,"SIEMENS RA PLANE B",8e)	SIEMENS RA PLANE B	25	142	f	\N	US	1	Unknown	\N
2104	(0019,"SIEMENS RA PLANE B",90)	(0019,"SIEMENS RA PLANE B",90)	SIEMENS RA PLANE B	25	144	f	\N	US	1	Unknown	\N
2105	(0019,"SIEMENS RA PLANE B",92)	(0019,"SIEMENS RA PLANE B",92)	SIEMENS RA PLANE B	25	146	f	\N	US	1	Unknown	\N
2106	(0019,"SIEMENS RA PLANE B",94)	(0019,"SIEMENS RA PLANE B",94)	SIEMENS RA PLANE B	25	148	f	\N	US	1	Unknown	\N
2107	(0019,"SIEMENS RA PLANE B",96)	(0019,"SIEMENS RA PLANE B",96)	SIEMENS RA PLANE B	25	150	f	\N	US	1	Unknown	\N
2108	(0019,"SIEMENS RA PLANE B",98)	(0019,"SIEMENS RA PLANE B",98)	SIEMENS RA PLANE B	25	152	f	\N	US	1	Unknown	\N
2109	(0019,"SIEMENS RA PLANE B",9a)	(0019,"SIEMENS RA PLANE B",9a)	SIEMENS RA PLANE B	25	154	f	\N	US	1-n	Unknown	\N
2110	(0019,"SIEMENS RA PLANE B",9c)	(0019,"SIEMENS RA PLANE B",9c)	SIEMENS RA PLANE B	25	156	f	\N	US	1-n	Unknown	\N
2111	(0019,"SIEMENS RA PLANE B",9e)	(0019,"SIEMENS RA PLANE B",9e)	SIEMENS RA PLANE B	25	158	f	\N	US	1-n	Unknown	\N
2112	(0019,"SIEMENS RA PLANE B",a0)	(0019,"SIEMENS RA PLANE B",a0)	SIEMENS RA PLANE B	25	160	f	\N	US	1-n	Unknown	\N
2113	(0019,"SIEMENS RA PLANE B",a2)	(0019,"SIEMENS RA PLANE B",a2)	SIEMENS RA PLANE B	25	162	f	\N	US	1-n	Unknown	\N
2114	(0019,"SIEMENS RA PLANE B",a4)	(0019,"SIEMENS RA PLANE B",a4)	SIEMENS RA PLANE B	25	164	f	\N	US	1	Unknown	\N
2115	(0019,"SIEMENS RA PLANE B",a6)	(0019,"SIEMENS RA PLANE B",a6)	SIEMENS RA PLANE B	25	166	f	\N	US	1	Unknown	\N
2116	(0019,"SIEMENS RA PLANE B",a8)	(0019,"SIEMENS RA PLANE B",a8)	SIEMENS RA PLANE B	25	168	f	\N	US	1-n	Unknown	\N
2117	(0019,"SIEMENS RA PLANE B",aa)	(0019,"SIEMENS RA PLANE B",aa)	SIEMENS RA PLANE B	25	170	f	\N	US	1	Unknown	\N
2118	(0019,"SIEMENS RA PLANE B",ac)	(0019,"SIEMENS RA PLANE B",ac)	SIEMENS RA PLANE B	25	172	f	\N	US	1	Unknown	\N
2119	(0011,"SIEMENS RIS",10)	(0011,"SIEMENS RIS",10)	SIEMENS RIS	17	16	f	\N	LT	1	PatientUID	\N
2120	(0011,"SIEMENS RIS",11)	(0011,"SIEMENS RIS",11)	SIEMENS RIS	17	17	f	\N	LT	1	PatientID	\N
2121	(0011,"SIEMENS RIS",20)	(0011,"SIEMENS RIS",20)	SIEMENS RIS	17	32	f	\N	DA	1	PatientRegistrationDate	\N
2122	(0011,"SIEMENS RIS",21)	(0011,"SIEMENS RIS",21)	SIEMENS RIS	17	33	f	\N	TM	1	PatientRegistrationTime	\N
2123	(0011,"SIEMENS RIS",30)	(0011,"SIEMENS RIS",30)	SIEMENS RIS	17	48	f	\N	LT	1	PatientnameRIS	\N
2124	(0011,"SIEMENS RIS",31)	(0011,"SIEMENS RIS",31)	SIEMENS RIS	17	49	f	\N	LT	1	PatientprenameRIS	\N
2125	(0011,"SIEMENS RIS",40)	(0011,"SIEMENS RIS",40)	SIEMENS RIS	17	64	f	\N	LT	1	PatientHospitalStatus	\N
2126	(0011,"SIEMENS RIS",41)	(0011,"SIEMENS RIS",41)	SIEMENS RIS	17	65	f	\N	LT	1	MedicalAlerts	\N
2127	(0011,"SIEMENS RIS",42)	(0011,"SIEMENS RIS",42)	SIEMENS RIS	17	66	f	\N	LT	1	ContrastAllergies	\N
2128	(0031,"SIEMENS RIS",10)	(0031,"SIEMENS RIS",10)	SIEMENS RIS	49	16	f	\N	LT	1	RequestUID	\N
2129	(0031,"SIEMENS RIS",45)	(0031,"SIEMENS RIS",45)	SIEMENS RIS	49	69	f	\N	LT	1	RequestingPhysician	\N
2130	(0031,"SIEMENS RIS",50)	(0031,"SIEMENS RIS",50)	SIEMENS RIS	49	80	f	\N	LT	1	RequestedPhysician	\N
2131	(0033,"SIEMENS RIS",10)	(0033,"SIEMENS RIS",10)	SIEMENS RIS	51	16	f	\N	LT	1	PatientStudyUID	\N
2132	(0021,"SIEMENS SMS-AX  ACQ 1.0",00)	(0021,"SIEMENS SMS-AX  ACQ 1.0",00)	SIEMENS SMS-AX  ACQ 1.0	33	0	f	\N	US	1	AcquisitionType	\N
2133	(0021,"SIEMENS SMS-AX  ACQ 1.0",01)	(0021,"SIEMENS SMS-AX  ACQ 1.0",01)	SIEMENS SMS-AX  ACQ 1.0	33	1	f	\N	US	1	AcquisitionMode	\N
2134	(0021,"SIEMENS SMS-AX  ACQ 1.0",02)	(0021,"SIEMENS SMS-AX  ACQ 1.0",02)	SIEMENS SMS-AX  ACQ 1.0	33	2	f	\N	US	1	FootswitchIndex	\N
2135	(0021,"SIEMENS SMS-AX  ACQ 1.0",03)	(0021,"SIEMENS SMS-AX  ACQ 1.0",03)	SIEMENS SMS-AX  ACQ 1.0	33	3	f	\N	US	1	AcquisitionRoom	\N
2136	(0021,"SIEMENS SMS-AX  ACQ 1.0",04)	(0021,"SIEMENS SMS-AX  ACQ 1.0",04)	SIEMENS SMS-AX  ACQ 1.0	33	4	f	\N	SL	1	CurrentTimeProduct	\N
2137	(0021,"SIEMENS SMS-AX  ACQ 1.0",05)	(0021,"SIEMENS SMS-AX  ACQ 1.0",05)	SIEMENS SMS-AX  ACQ 1.0	33	5	f	\N	SL	1	Dose	\N
2138	(0021,"SIEMENS SMS-AX  ACQ 1.0",06)	(0021,"SIEMENS SMS-AX  ACQ 1.0",06)	SIEMENS SMS-AX  ACQ 1.0	33	6	f	\N	SL	1	SkinDosePercent	\N
2139	(0021,"SIEMENS SMS-AX  ACQ 1.0",07)	(0021,"SIEMENS SMS-AX  ACQ 1.0",07)	SIEMENS SMS-AX  ACQ 1.0	33	7	f	\N	SL	1	SkinDoseAccumulation	\N
2140	(0021,"SIEMENS SMS-AX  ACQ 1.0",08)	(0021,"SIEMENS SMS-AX  ACQ 1.0",08)	SIEMENS SMS-AX  ACQ 1.0	33	8	f	\N	SL	1	SkinDoseRate	\N
2141	(0021,"SIEMENS SMS-AX  ACQ 1.0",0A)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0A)	SIEMENS SMS-AX  ACQ 1.0	33	10	f	\N	UL	1	CopperFilter	\N
2142	(0021,"SIEMENS SMS-AX  ACQ 1.0",0B)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0B)	SIEMENS SMS-AX  ACQ 1.0	33	11	f	\N	US	1	MeasuringField	\N
2143	(0021,"SIEMENS SMS-AX  ACQ 1.0",0C)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0C)	SIEMENS SMS-AX  ACQ 1.0	33	12	f	\N	SS	3	PostBlankingCircle	\N
2144	(0021,"SIEMENS SMS-AX  ACQ 1.0",0D)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0D)	SIEMENS SMS-AX  ACQ 1.0	33	13	f	\N	SS	2-2n	DynaAngles	\N
2145	(0021,"SIEMENS SMS-AX  ACQ 1.0",0E)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0E)	SIEMENS SMS-AX  ACQ 1.0	33	14	f	\N	SS	1	TotalSteps	\N
2146	(0021,"SIEMENS SMS-AX  ACQ 1.0",0F)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0F)	SIEMENS SMS-AX  ACQ 1.0	33	15	f	\N	SL	3-3n	DynaXRayInfo	\N
2147	(0021,"SIEMENS SMS-AX  ACQ 1.0",10)	(0021,"SIEMENS SMS-AX  ACQ 1.0",10)	SIEMENS SMS-AX  ACQ 1.0	33	16	f	\N	US	1	ModalityLUTInputGamma	\N
2148	(0021,"SIEMENS SMS-AX  ACQ 1.0",11)	(0021,"SIEMENS SMS-AX  ACQ 1.0",11)	SIEMENS SMS-AX  ACQ 1.0	33	17	f	\N	US	1	ModalityLUTOutputGamma	\N
2149	(0021,"SIEMENS SMS-AX  ACQ 1.0",12)	(0021,"SIEMENS SMS-AX  ACQ 1.0",12)	SIEMENS SMS-AX  ACQ 1.0	33	18	f	\N	OB	1-n	SH_STPAR	\N
2150	(0021,"SIEMENS SMS-AX  ACQ 1.0",13)	(0021,"SIEMENS SMS-AX  ACQ 1.0",13)	SIEMENS SMS-AX  ACQ 1.0	33	19	f	\N	US	1	AcquisitionZoom	\N
2151	(0021,"SIEMENS SMS-AX  ACQ 1.0",14)	(0021,"SIEMENS SMS-AX  ACQ 1.0",14)	SIEMENS SMS-AX  ACQ 1.0	33	20	f	\N	SS	1	DynaAngulationStepWidth	\N
2152	(0021,"SIEMENS SMS-AX  ACQ 1.0",15)	(0021,"SIEMENS SMS-AX  ACQ 1.0",15)	SIEMENS SMS-AX  ACQ 1.0	33	21	f	\N	US	1	Harmonization	\N
2153	(0021,"SIEMENS SMS-AX  ACQ 1.0",16)	(0021,"SIEMENS SMS-AX  ACQ 1.0",16)	SIEMENS SMS-AX  ACQ 1.0	33	22	f	\N	US	1	DRSingleFlag	\N
2154	(0021,"SIEMENS SMS-AX  ACQ 1.0",17)	(0021,"SIEMENS SMS-AX  ACQ 1.0",17)	SIEMENS SMS-AX  ACQ 1.0	33	23	f	\N	SL	1	SourceToIsocenter	\N
2155	(0021,"SIEMENS SMS-AX  ACQ 1.0",18)	(0021,"SIEMENS SMS-AX  ACQ 1.0",18)	SIEMENS SMS-AX  ACQ 1.0	33	24	f	\N	US	1	PressureData	\N
2156	(0021,"SIEMENS SMS-AX  ACQ 1.0",19)	(0021,"SIEMENS SMS-AX  ACQ 1.0",19)	SIEMENS SMS-AX  ACQ 1.0	33	25	f	\N	SL	1	ECGIndexArray	\N
2157	(0021,"SIEMENS SMS-AX  ACQ 1.0",1A)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1A)	SIEMENS SMS-AX  ACQ 1.0	33	26	f	\N	US	1	FDFlag	\N
2158	(0021,"SIEMENS SMS-AX  ACQ 1.0",1B)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1B)	SIEMENS SMS-AX  ACQ 1.0	33	27	f	\N	OB	1	SH_ZOOM	\N
2159	(0021,"SIEMENS SMS-AX  ACQ 1.0",1C)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1C)	SIEMENS SMS-AX  ACQ 1.0	33	28	f	\N	OB	1	SH_COLPAR	\N
2160	(0021,"SIEMENS SMS-AX  ACQ 1.0",1D)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1D)	SIEMENS SMS-AX  ACQ 1.0	33	29	f	\N	US	1	K_Factor	\N
2161	(0021,"SIEMENS SMS-AX  ACQ 1.0",1E)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1E)	SIEMENS SMS-AX  ACQ 1.0	33	30	f	\N	US	8	EVE	\N
2162	(0021,"SIEMENS SMS-AX  ACQ 1.0",1F)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1F)	SIEMENS SMS-AX  ACQ 1.0	33	31	f	\N	SL	1	TotalSceneTime	\N
2163	(0021,"SIEMENS SMS-AX  ACQ 1.0",20)	(0021,"SIEMENS SMS-AX  ACQ 1.0",20)	SIEMENS SMS-AX  ACQ 1.0	33	32	f	\N	US	1	RestoreFlag	\N
2164	(0021,"SIEMENS SMS-AX  ACQ 1.0",21)	(0021,"SIEMENS SMS-AX  ACQ 1.0",21)	SIEMENS SMS-AX  ACQ 1.0	33	33	f	\N	US	1	StandMovementFlag	\N
2165	(0021,"SIEMENS SMS-AX  ACQ 1.0",22)	(0021,"SIEMENS SMS-AX  ACQ 1.0",22)	SIEMENS SMS-AX  ACQ 1.0	33	34	f	\N	US	1	FDRows	\N
2166	(0021,"SIEMENS SMS-AX  ACQ 1.0",23)	(0021,"SIEMENS SMS-AX  ACQ 1.0",23)	SIEMENS SMS-AX  ACQ 1.0	33	35	f	\N	US	1	FDColumns	\N
2167	(0021,"SIEMENS SMS-AX  ACQ 1.0",24)	(0021,"SIEMENS SMS-AX  ACQ 1.0",24)	SIEMENS SMS-AX  ACQ 1.0	33	36	f	\N	US	1	TableMovementFlag	\N
2168	(0021,"SIEMENS SMS-AX  ACQ 1.0",25)	(0021,"SIEMENS SMS-AX  ACQ 1.0",25)	SIEMENS SMS-AX  ACQ 1.0	33	37	f	\N	LO	1	OriginalOrganProgramName	\N
2169	(0021,"SIEMENS SMS-AX  ACQ 1.0",26)	(0021,"SIEMENS SMS-AX  ACQ 1.0",26)	SIEMENS SMS-AX  ACQ 1.0	33	38	f	\N	DS	1	CrispyXPIFilter	\N
2170	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",00)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",00)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	0	f	\N	US	1	ViewNative	\N
2171	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",01)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",01)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	1	f	\N	US	1	OriginalSeriesNumber	\N
2172	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",02)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",02)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	2	f	\N	US	1	OriginalImageNumber	\N
2173	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",03)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",03)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	3	f	\N	US	1	WinCenter	\N
2174	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",04)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",04)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	4	f	\N	US	1	WinWidth	\N
2175	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",05)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",05)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	5	f	\N	US	1	WinBrightness	\N
2176	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",06)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",06)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	6	f	\N	US	1	WinContrast	\N
2177	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",07)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",07)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	7	f	\N	US	1	OriginalFrameNumber	\N
2178	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",08)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",08)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	8	f	\N	US	1	OriginalMaskFrameNumber	\N
2179	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",09)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",09)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	9	f	\N	US	1	Opac	\N
2180	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0A)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0A)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	10	f	\N	US	1	OriginalNumberOfFrames	\N
2181	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0B)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0B)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	11	f	\N	DS	1	OriginalSceneDuration	\N
2182	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0C)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0C)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	12	f	\N	LO	1	IdentifierLOID	\N
2183	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0D)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0D)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	13	f	\N	SS	1-n	OriginalSceneVFRInfo	\N
2184	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0E)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0E)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	14	f	\N	SS	1	OriginalFrameECGPosition	\N
2185	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0F)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0F)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	15	f	\N	SS	1	OriginalECG1stFrameOffset_retired	\N
2186	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",10)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",10)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	16	f	\N	SS	1	ZoomFlag	\N
2187	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",11)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",11)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	17	f	\N	US	1	Flex	\N
2188	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",12)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",12)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	18	f	\N	US	1	NumberOfMaskFrames	\N
2189	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",13)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",13)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	19	f	\N	US	1	NumberOfFillFrames	\N
2190	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",14)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",14)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	20	f	\N	US	1	SeriesNumber	\N
2191	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",15)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",15)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	21	f	\N	IS	1	ImageNumber	\N
2192	(0023,"SIEMENS SMS-AX  QUANT 1.0",00)	(0023,"SIEMENS SMS-AX  QUANT 1.0",00)	SIEMENS SMS-AX  QUANT 1.0	35	0	f	\N	DS	2	HorizontalCalibrationPixelSize	\N
2193	(0023,"SIEMENS SMS-AX  QUANT 1.0",01)	(0023,"SIEMENS SMS-AX  QUANT 1.0",01)	SIEMENS SMS-AX  QUANT 1.0	35	1	f	\N	DS	2	VerticalCalibrationPixelSize	\N
2194	(0023,"SIEMENS SMS-AX  QUANT 1.0",02)	(0023,"SIEMENS SMS-AX  QUANT 1.0",02)	SIEMENS SMS-AX  QUANT 1.0	35	2	f	\N	LO	1	CalibrationObject	\N
2195	(0023,"SIEMENS SMS-AX  QUANT 1.0",03)	(0023,"SIEMENS SMS-AX  QUANT 1.0",03)	SIEMENS SMS-AX  QUANT 1.0	35	3	f	\N	DS	1	CalibrationObjectSize	\N
2196	(0023,"SIEMENS SMS-AX  QUANT 1.0",04)	(0023,"SIEMENS SMS-AX  QUANT 1.0",04)	SIEMENS SMS-AX  QUANT 1.0	35	4	f	\N	LO	1	CalibrationMethod	\N
2197	(0023,"SIEMENS SMS-AX  QUANT 1.0",05)	(0023,"SIEMENS SMS-AX  QUANT 1.0",05)	SIEMENS SMS-AX  QUANT 1.0	35	5	f	\N	ST	1	Filename	\N
2198	(0023,"SIEMENS SMS-AX  QUANT 1.0",06)	(0023,"SIEMENS SMS-AX  QUANT 1.0",06)	SIEMENS SMS-AX  QUANT 1.0	35	6	f	\N	IS	1	FrameNumber	\N
2199	(0023,"SIEMENS SMS-AX  QUANT 1.0",07)	(0023,"SIEMENS SMS-AX  QUANT 1.0",07)	SIEMENS SMS-AX  QUANT 1.0	35	7	f	\N	IS	2	CalibrationFactorMultiplicity	\N
2200	(0023,"SIEMENS SMS-AX  QUANT 1.0",08)	(0023,"SIEMENS SMS-AX  QUANT 1.0",08)	SIEMENS SMS-AX  QUANT 1.0	35	8	f	\N	IS	1	CalibrationTODValue	\N
2201	(0019,"SIEMENS SMS-AX  VIEW 1.0",00)	(0019,"SIEMENS SMS-AX  VIEW 1.0",00)	SIEMENS SMS-AX  VIEW 1.0	25	0	f	\N	US	1	ReviewMode	\N
2202	(0019,"SIEMENS SMS-AX  VIEW 1.0",01)	(0019,"SIEMENS SMS-AX  VIEW 1.0",01)	SIEMENS SMS-AX  VIEW 1.0	25	1	f	\N	US	1	AnatomicalBackgroundPercent	\N
2203	(0019,"SIEMENS SMS-AX  VIEW 1.0",02)	(0019,"SIEMENS SMS-AX  VIEW 1.0",02)	SIEMENS SMS-AX  VIEW 1.0	25	2	f	\N	US	1	NumberOfPhases	\N
2204	(0019,"SIEMENS SMS-AX  VIEW 1.0",03)	(0019,"SIEMENS SMS-AX  VIEW 1.0",03)	SIEMENS SMS-AX  VIEW 1.0	25	3	f	\N	US	1	ApplyAnatomicalBackground	\N
2205	(0019,"SIEMENS SMS-AX  VIEW 1.0",04)	(0019,"SIEMENS SMS-AX  VIEW 1.0",04)	SIEMENS SMS-AX  VIEW 1.0	25	4	f	\N	SS	4-4n	PixelShiftArray	\N
2206	(0019,"SIEMENS SMS-AX  VIEW 1.0",05)	(0019,"SIEMENS SMS-AX  VIEW 1.0",05)	SIEMENS SMS-AX  VIEW 1.0	25	5	f	\N	US	1	Brightness	\N
2207	(0019,"SIEMENS SMS-AX  VIEW 1.0",06)	(0019,"SIEMENS SMS-AX  VIEW 1.0",06)	SIEMENS SMS-AX  VIEW 1.0	25	6	f	\N	US	1	Contrast	\N
2208	(0019,"SIEMENS SMS-AX  VIEW 1.0",07)	(0019,"SIEMENS SMS-AX  VIEW 1.0",07)	SIEMENS SMS-AX  VIEW 1.0	25	7	f	\N	US	1	Enabled	\N
2209	(0019,"SIEMENS SMS-AX  VIEW 1.0",08)	(0019,"SIEMENS SMS-AX  VIEW 1.0",08)	SIEMENS SMS-AX  VIEW 1.0	25	8	f	\N	US	1	NativeEdgeEnhancementPercentGain	\N
2210	(0019,"SIEMENS SMS-AX  VIEW 1.0",09)	(0019,"SIEMENS SMS-AX  VIEW 1.0",09)	SIEMENS SMS-AX  VIEW 1.0	25	9	f	\N	SS	1	NativeEdgeEnhancementLUTIndex	\N
2211	(0019,"SIEMENS SMS-AX  VIEW 1.0",0A)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0A)	SIEMENS SMS-AX  VIEW 1.0	25	10	f	\N	SS	1	NativeEdgeEnhancementKernelSize	\N
2212	(0019,"SIEMENS SMS-AX  VIEW 1.0",0B)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0B)	SIEMENS SMS-AX  VIEW 1.0	25	11	f	\N	US	1	SubtrEdgeEnhancementPercentGain	\N
2213	(0019,"SIEMENS SMS-AX  VIEW 1.0",0C)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0C)	SIEMENS SMS-AX  VIEW 1.0	25	12	f	\N	SS	1	SubtrEdgeEnhancementLUTIndex	\N
2214	(0019,"SIEMENS SMS-AX  VIEW 1.0",0D)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0D)	SIEMENS SMS-AX  VIEW 1.0	25	13	f	\N	SS	1	SubtrEdgeEnhancementKernelSize	\N
2215	(0019,"SIEMENS SMS-AX  VIEW 1.0",0E)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0E)	SIEMENS SMS-AX  VIEW 1.0	25	14	f	\N	US	1	FadePercent	\N
2216	(0019,"SIEMENS SMS-AX  VIEW 1.0",0F)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0F)	SIEMENS SMS-AX  VIEW 1.0	25	15	f	\N	US	1	FlippedBeforeLateralityApplied	\N
2217	(0019,"SIEMENS SMS-AX  VIEW 1.0",10)	(0019,"SIEMENS SMS-AX  VIEW 1.0",10)	SIEMENS SMS-AX  VIEW 1.0	25	16	f	\N	US	1	ApplyFade	\N
2218	(0019,"SIEMENS SMS-AX  VIEW 1.0",12)	(0019,"SIEMENS SMS-AX  VIEW 1.0",12)	SIEMENS SMS-AX  VIEW 1.0	25	18	f	\N	US	1	Zoom	\N
2219	(0019,"SIEMENS SMS-AX  VIEW 1.0",13)	(0019,"SIEMENS SMS-AX  VIEW 1.0",13)	SIEMENS SMS-AX  VIEW 1.0	25	19	f	\N	SS	1	PanX	\N
2220	(0019,"SIEMENS SMS-AX  VIEW 1.0",14)	(0019,"SIEMENS SMS-AX  VIEW 1.0",14)	SIEMENS SMS-AX  VIEW 1.0	25	20	f	\N	SS	1	PanY	\N
2221	(0019,"SIEMENS SMS-AX  VIEW 1.0",15)	(0019,"SIEMENS SMS-AX  VIEW 1.0",15)	SIEMENS SMS-AX  VIEW 1.0	25	21	f	\N	SS	1	NativeEdgeEnhancementAdvPercGain	\N
2222	(0019,"SIEMENS SMS-AX  VIEW 1.0",16)	(0019,"SIEMENS SMS-AX  VIEW 1.0",16)	SIEMENS SMS-AX  VIEW 1.0	25	22	f	\N	SS	1	SubtrEdgeEnhancementAdvPercGain	\N
2223	(0019,"SIEMENS SMS-AX  VIEW 1.0",17)	(0019,"SIEMENS SMS-AX  VIEW 1.0",17)	SIEMENS SMS-AX  VIEW 1.0	25	23	f	\N	US	1	InvertFlag	\N
2224	(0019,"SIEMENS SMS-AX  VIEW 1.0",1A)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1A)	SIEMENS SMS-AX  VIEW 1.0	25	26	f	\N	OB	1	Quant1KOverlay	\N
2225	(0019,"SIEMENS SMS-AX  VIEW 1.0",1B)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1B)	SIEMENS SMS-AX  VIEW 1.0	25	27	f	\N	US	1	OriginalResolution	\N
2226	(0019,"SIEMENS SMS-AX  VIEW 1.0",1C)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1C)	SIEMENS SMS-AX  VIEW 1.0	25	28	f	\N	DS	1	AutoWindowCenter	\N
2227	(0019,"SIEMENS SMS-AX  VIEW 1.0",1D)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1D)	SIEMENS SMS-AX  VIEW 1.0	25	29	f	\N	DS	1	AutoWindowWidth	\N
2228	(0009,"SIENET",01)	(0009,"SIENET",01)	SIENET	9	1	f	\N	US	1	SIENETCommandField	\N
2229	(0009,"SIENET",14)	(0009,"SIENET",14)	SIENET	9	20	f	\N	LT	1	ReceiverPLA	\N
2230	(0009,"SIENET",16)	(0009,"SIENET",16)	SIENET	9	22	f	\N	US	1	TransferPriority	\N
2231	(0009,"SIENET",29)	(0009,"SIENET",29)	SIENET	9	41	f	\N	LT	1	ActualUser	\N
2232	(0095,"SIENET",01)	(0095,"SIENET",01)	SIENET	149	1	f	\N	LT	1	ExaminationFolderID	\N
2233	(0095,"SIENET",04)	(0095,"SIENET",04)	SIENET	149	4	f	\N	UL	1	FolderReportedStatus	\N
2234	(0095,"SIENET",05)	(0095,"SIENET",05)	SIENET	149	5	f	\N	LT	1	FolderReportingRadiologist	\N
2235	(0095,"SIENET",07)	(0095,"SIENET",07)	SIENET	149	7	f	\N	LT	1	SIENETISAPLA	\N
2236	(0099,"SIENET",02)	(0099,"SIENET",02)	SIENET	153	2	f	\N	UL	1	DataObjectAttributes	\N
2237	(0009,"SPI RELEASE 1",10)	(0009,"SPI RELEASE 1",10)	SPI RELEASE 1	9	16	f	\N	LT	1	Comments	\N
2238	(0009,"SPI RELEASE 1",15)	(0009,"SPI RELEASE 1",15)	SPI RELEASE 1	9	21	f	\N	LO	1	SPIImageUID	\N
2239	(0009,"SPI RELEASE 1",40)	(0009,"SPI RELEASE 1",40)	SPI RELEASE 1	9	64	f	\N	US	1	DataObjectType	\N
2240	(0009,"SPI RELEASE 1",41)	(0009,"SPI RELEASE 1",41)	SPI RELEASE 1	9	65	f	\N	LO	1	DataObjectSubtype	\N
2241	(0011,"SPI RELEASE 1",10)	(0011,"SPI RELEASE 1",10)	SPI RELEASE 1	17	16	f	\N	LO	1	Organ	\N
2242	(0011,"SPI RELEASE 1",15)	(0011,"SPI RELEASE 1",15)	SPI RELEASE 1	17	21	f	\N	LO	1	AllergyIndication	\N
2243	(0011,"SPI RELEASE 1",20)	(0011,"SPI RELEASE 1",20)	SPI RELEASE 1	17	32	f	\N	LO	1	Pregnancy	\N
2244	(0029,"SPI RELEASE 1",60)	(0029,"SPI RELEASE 1",60)	SPI RELEASE 1	41	96	f	\N	LT	1	CompressionAlgorithm	\N
2245	(0009,"SPI Release 1",10)	(0009,"SPI Release 1",10)	SPI Release 1	9	16	f	\N	LT	1	Comments	\N
2246	(0009,"SPI Release 1",15)	(0009,"SPI Release 1",15)	SPI Release 1	9	21	f	\N	LO	1	SPIImageUID	\N
2247	(0009,"SPI Release 1",40)	(0009,"SPI Release 1",40)	SPI Release 1	9	64	f	\N	US	1	DataObjectType	\N
2248	(0009,"SPI Release 1",41)	(0009,"SPI Release 1",41)	SPI Release 1	9	65	f	\N	LO	1	DataObjectSubtype	\N
2249	(0011,"SPI Release 1",10)	(0011,"SPI Release 1",10)	SPI Release 1	17	16	f	\N	LO	1	Organ	\N
2250	(0011,"SPI Release 1",15)	(0011,"SPI Release 1",15)	SPI Release 1	17	21	f	\N	LO	1	AllergyIndication	\N
2251	(0011,"SPI Release 1",20)	(0011,"SPI Release 1",20)	SPI Release 1	17	32	f	\N	LO	1	Pregnancy	\N
2252	(0029,"SPI Release 1",60)	(0029,"SPI Release 1",60)	SPI Release 1	41	96	f	\N	LT	1	CompressionAlgorithm	\N
2253	(0009,"SPI",10)	(0009,"SPI",10)	SPI	9	16	f	\N	LO	1	Comments	\N
2254	(0009,"SPI",15)	(0009,"SPI",15)	SPI	9	21	f	\N	LO	1	SPIImageUID	\N
2255	(0009,"SPI",40)	(0009,"SPI",40)	SPI	9	64	f	\N	US	1	DataObjectType	\N
2256	(0009,"SPI",41)	(0009,"SPI",41)	SPI	9	65	f	\N	LT	1	DataObjectSubtype	\N
2257	(0011,"SPI",10)	(0011,"SPI",10)	SPI	17	16	f	\N	LT	1	Organ	\N
2258	(0011,"SPI",15)	(0011,"SPI",15)	SPI	17	21	f	\N	LT	1	AllergyIndication	\N
2259	(0011,"SPI",20)	(0011,"SPI",20)	SPI	17	32	f	\N	LT	1	Pregnancy	\N
2260	(0029,"SPI",60)	(0029,"SPI",60)	SPI	41	96	f	\N	LT	1	CompressionAlgorithm	\N
2261	(0009,"SPI-P Release 1",00)	(0009,"SPI-P Release 1",00)	SPI-P Release 1	9	0	f	\N	LT	1	DataObjectRecognitionCode	\N
2262	(0009,"SPI-P Release 1",04)	(0009,"SPI-P Release 1",04)	SPI-P Release 1	9	4	f	\N	LO	1	ImageDataConsistence	\N
2263	(0009,"SPI-P Release 1",08)	(0009,"SPI-P Release 1",08)	SPI-P Release 1	9	8	f	\N	US	1	Unknown	\N
2264	(0009,"SPI-P Release 1",12)	(0009,"SPI-P Release 1",12)	SPI-P Release 1	9	18	f	\N	LO	1	Unknown	\N
2265	(0009,"SPI-P Release 1",15)	(0009,"SPI-P Release 1",15)	SPI-P Release 1	9	21	f	\N	LO	1	UniqueIdentifier	\N
2266	(0009,"SPI-P Release 1",16)	(0009,"SPI-P Release 1",16)	SPI-P Release 1	9	22	f	\N	LO	1	Unknown	\N
2267	(0009,"SPI-P Release 1",18)	(0009,"SPI-P Release 1",18)	SPI-P Release 1	9	24	f	\N	LO	1	Unknown	\N
2268	(0009,"SPI-P Release 1",21)	(0009,"SPI-P Release 1",21)	SPI-P Release 1	9	33	f	\N	LT	1	Unknown	\N
2269	(0009,"SPI-P Release 1",31)	(0009,"SPI-P Release 1",31)	SPI-P Release 1	9	49	f	\N	LT	1	PACSUniqueIdentifier	\N
2270	(0009,"SPI-P Release 1",34)	(0009,"SPI-P Release 1",34)	SPI-P Release 1	9	52	f	\N	LT	1	ClusterUniqueIdentifier	\N
2271	(0009,"SPI-P Release 1",38)	(0009,"SPI-P Release 1",38)	SPI-P Release 1	9	56	f	\N	LT	1	SystemUniqueIdentifier	\N
2272	(0009,"SPI-P Release 1",39)	(0009,"SPI-P Release 1",39)	SPI-P Release 1	9	57	f	\N	LT	1	Unknown	\N
2273	(0009,"SPI-P Release 1",51)	(0009,"SPI-P Release 1",51)	SPI-P Release 1	9	81	f	\N	LT	1	StudyUniqueIdentifier	\N
2274	(0009,"SPI-P Release 1",61)	(0009,"SPI-P Release 1",61)	SPI-P Release 1	9	97	f	\N	LT	1	SeriesUniqueIdentifier	\N
2275	(0009,"SPI-P Release 1",91)	(0009,"SPI-P Release 1",91)	SPI-P Release 1	9	145	f	\N	LT	1	Unknown	\N
2276	(0009,"SPI-P Release 1",f2)	(0009,"SPI-P Release 1",f2)	SPI-P Release 1	9	242	f	\N	LT	1	Unknown	\N
2277	(0009,"SPI-P Release 1",f3)	(0009,"SPI-P Release 1",f3)	SPI-P Release 1	9	243	f	\N	UN	1	Unknown	\N
2278	(0009,"SPI-P Release 1",f4)	(0009,"SPI-P Release 1",f4)	SPI-P Release 1	9	244	f	\N	LT	1	Unknown	\N
2279	(0009,"SPI-P Release 1",f5)	(0009,"SPI-P Release 1",f5)	SPI-P Release 1	9	245	f	\N	UN	1	Unknown	\N
2280	(0009,"SPI-P Release 1",f7)	(0009,"SPI-P Release 1",f7)	SPI-P Release 1	9	247	f	\N	LT	1	Unknown	\N
2281	(0011,"SPI-P Release 1",10)	(0011,"SPI-P Release 1",10)	SPI-P Release 1	17	16	f	\N	LT	1	PatientEntryID	\N
2282	(0011,"SPI-P Release 1",21)	(0011,"SPI-P Release 1",21)	SPI-P Release 1	17	33	f	\N	UN	1	Unknown	\N
2283	(0011,"SPI-P Release 1",22)	(0011,"SPI-P Release 1",22)	SPI-P Release 1	17	34	f	\N	UN	1	Unknown	\N
2284	(0011,"SPI-P Release 1",31)	(0011,"SPI-P Release 1",31)	SPI-P Release 1	17	49	f	\N	UN	1	Unknown	\N
2285	(0011,"SPI-P Release 1",32)	(0011,"SPI-P Release 1",32)	SPI-P Release 1	17	50	f	\N	UN	1	Unknown	\N
2286	(0019,"SPI-P Release 1",00)	(0019,"SPI-P Release 1",00)	SPI-P Release 1	25	0	f	\N	UN	1	Unknown	\N
2287	(0019,"SPI-P Release 1",01)	(0019,"SPI-P Release 1",01)	SPI-P Release 1	25	1	f	\N	UN	1	Unknown	\N
2288	(0019,"SPI-P Release 1",02)	(0019,"SPI-P Release 1",02)	SPI-P Release 1	25	2	f	\N	UN	1	Unknown	\N
2289	(0019,"SPI-P Release 1",10)	(0019,"SPI-P Release 1",10)	SPI-P Release 1	25	16	f	\N	US	1	MainsFrequency	\N
2290	(0019,"SPI-P Release 1",25)	(0019,"SPI-P Release 1",25)	SPI-P Release 1	25	37	f	\N	LT	1-n	OriginalPixelDataQuality	\N
2291	(0019,"SPI-P Release 1",30)	(0019,"SPI-P Release 1",30)	SPI-P Release 1	25	48	f	\N	US	1	ECGTriggering	\N
2292	(0019,"SPI-P Release 1",31)	(0019,"SPI-P Release 1",31)	SPI-P Release 1	25	49	f	\N	UN	1	ECG1Offset	\N
2293	(0019,"SPI-P Release 1",32)	(0019,"SPI-P Release 1",32)	SPI-P Release 1	25	50	f	\N	UN	1	ECG2Offset1	\N
2294	(0019,"SPI-P Release 1",33)	(0019,"SPI-P Release 1",33)	SPI-P Release 1	25	51	f	\N	UN	1	ECG2Offset2	\N
2295	(0019,"SPI-P Release 1",50)	(0019,"SPI-P Release 1",50)	SPI-P Release 1	25	80	f	\N	US	1	VideoScanMode	\N
2296	(0019,"SPI-P Release 1",51)	(0019,"SPI-P Release 1",51)	SPI-P Release 1	25	81	f	\N	US	1	VideoLineRate	\N
2297	(0019,"SPI-P Release 1",60)	(0019,"SPI-P Release 1",60)	SPI-P Release 1	25	96	f	\N	US	1	XrayTechnique	\N
2298	(0019,"SPI-P Release 1",61)	(0019,"SPI-P Release 1",61)	SPI-P Release 1	25	97	f	\N	DS	1	ImageIdentifierFromat	\N
2299	(0019,"SPI-P Release 1",62)	(0019,"SPI-P Release 1",62)	SPI-P Release 1	25	98	f	\N	US	1	IrisDiaphragm	\N
2300	(0019,"SPI-P Release 1",63)	(0019,"SPI-P Release 1",63)	SPI-P Release 1	25	99	f	\N	CS	1	Filter	\N
2301	(0019,"SPI-P Release 1",64)	(0019,"SPI-P Release 1",64)	SPI-P Release 1	25	100	f	\N	CS	1	CineParallel	\N
2302	(0019,"SPI-P Release 1",65)	(0019,"SPI-P Release 1",65)	SPI-P Release 1	25	101	f	\N	CS	1	CineMaster	\N
2303	(0019,"SPI-P Release 1",70)	(0019,"SPI-P Release 1",70)	SPI-P Release 1	25	112	f	\N	US	1	ExposureChannel	\N
2304	(0019,"SPI-P Release 1",71)	(0019,"SPI-P Release 1",71)	SPI-P Release 1	25	113	f	\N	UN	1	ExposureChannelFirstImage	\N
2305	(0019,"SPI-P Release 1",72)	(0019,"SPI-P Release 1",72)	SPI-P Release 1	25	114	f	\N	US	1	ProcessingChannel	\N
2306	(0019,"SPI-P Release 1",80)	(0019,"SPI-P Release 1",80)	SPI-P Release 1	25	128	f	\N	DS	1	AcquisitionDelay	\N
2307	(0019,"SPI-P Release 1",81)	(0019,"SPI-P Release 1",81)	SPI-P Release 1	25	129	f	\N	UN	1	RelativeImageTime	\N
2308	(0019,"SPI-P Release 1",90)	(0019,"SPI-P Release 1",90)	SPI-P Release 1	25	144	f	\N	CS	1	VideoWhiteCompression	\N
2309	(0019,"SPI-P Release 1",a0)	(0019,"SPI-P Release 1",a0)	SPI-P Release 1	25	160	f	\N	US	1	Angulation	\N
2310	(0019,"SPI-P Release 1",a1)	(0019,"SPI-P Release 1",a1)	SPI-P Release 1	25	161	f	\N	US	1	Rotation	\N
2311	(0021,"SPI-P Release 1",12)	(0021,"SPI-P Release 1",12)	SPI-P Release 1	33	18	f	\N	LT	1	SeriesUniqueIdentifier	\N
2312	(0021,"SPI-P Release 1",14)	(0021,"SPI-P Release 1",14)	SPI-P Release 1	33	20	f	\N	LT	1	Unknown	\N
2313	(0029,"SPI-P Release 1",00)	(0029,"SPI-P Release 1",00)	SPI-P Release 1	41	0	f	\N	DS	4	Unknown	\N
2314	(0029,"SPI-P Release 1",20)	(0029,"SPI-P Release 1",20)	SPI-P Release 1	41	32	f	\N	DS	1	PixelAspectRatio	\N
2315	(0029,"SPI-P Release 1",25)	(0029,"SPI-P Release 1",25)	SPI-P Release 1	41	37	f	\N	LO	1-n	ProcessedPixelDataQuality	\N
2316	(0029,"SPI-P Release 1",30)	(0029,"SPI-P Release 1",30)	SPI-P Release 1	41	48	f	\N	LT	1	Unknown	\N
2317	(0029,"SPI-P Release 1",38)	(0029,"SPI-P Release 1",38)	SPI-P Release 1	41	56	f	\N	US	1	Unknown	\N
2318	(0029,"SPI-P Release 1",60)	(0029,"SPI-P Release 1",60)	SPI-P Release 1	41	96	f	\N	LT	1	Unknown	\N
2319	(0029,"SPI-P Release 1",61)	(0029,"SPI-P Release 1",61)	SPI-P Release 1	41	97	f	\N	LT	1	Unknown	\N
2320	(0029,"SPI-P Release 1",67)	(0029,"SPI-P Release 1",67)	SPI-P Release 1	41	103	f	\N	LT	1	Unknown	\N
2321	(0029,"SPI-P Release 1",70)	(0029,"SPI-P Release 1",70)	SPI-P Release 1	41	112	f	\N	LT	1	WindowID	\N
2322	(0029,"SPI-P Release 1",71)	(0029,"SPI-P Release 1",71)	SPI-P Release 1	41	113	f	\N	CS	1	VideoInvertSubtracted	\N
2323	(0029,"SPI-P Release 1",72)	(0029,"SPI-P Release 1",72)	SPI-P Release 1	41	114	f	\N	CS	1	VideoInvertNonsubtracted	\N
2324	(0029,"SPI-P Release 1",77)	(0029,"SPI-P Release 1",77)	SPI-P Release 1	41	119	f	\N	CS	1	WindowSelectStatus	\N
2325	(0029,"SPI-P Release 1",78)	(0029,"SPI-P Release 1",78)	SPI-P Release 1	41	120	f	\N	LT	1	ECGDisplayPrintingID	\N
2326	(0029,"SPI-P Release 1",79)	(0029,"SPI-P Release 1",79)	SPI-P Release 1	41	121	f	\N	CS	1	ECGDisplayPrinting	\N
2327	(0029,"SPI-P Release 1",7e)	(0029,"SPI-P Release 1",7e)	SPI-P Release 1	41	126	f	\N	CS	1	ECGDisplayPrintingEnableStatus	\N
2328	(0029,"SPI-P Release 1",7f)	(0029,"SPI-P Release 1",7f)	SPI-P Release 1	41	127	f	\N	CS	1	ECGDisplayPrintingSelectStatus	\N
2329	(0029,"SPI-P Release 1",80)	(0029,"SPI-P Release 1",80)	SPI-P Release 1	41	128	f	\N	LT	1	PhysiologicalDisplayID	\N
2330	(0029,"SPI-P Release 1",81)	(0029,"SPI-P Release 1",81)	SPI-P Release 1	41	129	f	\N	US	1	PreferredPhysiologicalChannelDisplay	\N
2331	(0029,"SPI-P Release 1",8e)	(0029,"SPI-P Release 1",8e)	SPI-P Release 1	41	142	f	\N	CS	1	PhysiologicalDisplayEnableStatus	\N
2332	(0029,"SPI-P Release 1",8f)	(0029,"SPI-P Release 1",8f)	SPI-P Release 1	41	143	f	\N	CS	1	PhysiologicalDisplaySelectStatus	\N
2333	(0029,"SPI-P Release 1",c0)	(0029,"SPI-P Release 1",c0)	SPI-P Release 1	41	192	f	\N	LT	1	FunctionalShutterID	\N
2334	(0029,"SPI-P Release 1",c1)	(0029,"SPI-P Release 1",c1)	SPI-P Release 1	41	193	f	\N	US	1	FieldOfShutter	\N
2335	(0029,"SPI-P Release 1",c5)	(0029,"SPI-P Release 1",c5)	SPI-P Release 1	41	197	f	\N	LT	1	FieldOfShutterRectangle	\N
2336	(0029,"SPI-P Release 1",ce)	(0029,"SPI-P Release 1",ce)	SPI-P Release 1	41	206	f	\N	CS	1	ShutterEnableStatus	\N
2337	(0029,"SPI-P Release 1",cf)	(0029,"SPI-P Release 1",cf)	SPI-P Release 1	41	207	f	\N	CS	1	ShutterSelectStatus	\N
2338	(7FE1,"SPI-P Release 1",10)	(7FE1,"SPI-P Release 1",10)	SPI-P Release 1	32737	16	f	\N	ox	1	PixelData	\N
2339	(0009,"SPI-P Release 1;1",c0)	(0009,"SPI-P Release 1;1",c0)	SPI-P Release 1;1	9	192	f	\N	LT	1	Unknown	\N
2340	(0009,"SPI-P Release 1;1",c1)	(0009,"SPI-P Release 1;1",c1)	SPI-P Release 1;1	9	193	f	\N	LT	1	Unknown	\N
2341	(0019,"SPI-P Release 1;1",00)	(0019,"SPI-P Release 1;1",00)	SPI-P Release 1;1	25	0	f	\N	UN	1	PhysiologicalDataType	\N
2342	(0019,"SPI-P Release 1;1",01)	(0019,"SPI-P Release 1;1",01)	SPI-P Release 1;1	25	1	f	\N	UN	1	PhysiologicalDataChannelAndKind	\N
2343	(0019,"SPI-P Release 1;1",02)	(0019,"SPI-P Release 1;1",02)	SPI-P Release 1;1	25	2	f	\N	US	1	SampleBitsAllocated	\N
2344	(0019,"SPI-P Release 1;1",03)	(0019,"SPI-P Release 1;1",03)	SPI-P Release 1;1	25	3	f	\N	US	1	SampleBitsStored	\N
2345	(0019,"SPI-P Release 1;1",04)	(0019,"SPI-P Release 1;1",04)	SPI-P Release 1;1	25	4	f	\N	US	1	SampleHighBit	\N
2346	(0019,"SPI-P Release 1;1",05)	(0019,"SPI-P Release 1;1",05)	SPI-P Release 1;1	25	5	f	\N	US	1	SampleRepresentation	\N
2347	(0019,"SPI-P Release 1;1",06)	(0019,"SPI-P Release 1;1",06)	SPI-P Release 1;1	25	6	f	\N	UN	1	SmallestSampleValue	\N
2348	(0019,"SPI-P Release 1;1",07)	(0019,"SPI-P Release 1;1",07)	SPI-P Release 1;1	25	7	f	\N	UN	1	LargestSampleValue	\N
2349	(0019,"SPI-P Release 1;1",08)	(0019,"SPI-P Release 1;1",08)	SPI-P Release 1;1	25	8	f	\N	UN	1	NumberOfSamples	\N
2350	(0019,"SPI-P Release 1;1",09)	(0019,"SPI-P Release 1;1",09)	SPI-P Release 1;1	25	9	f	\N	UN	1	SampleData	\N
2351	(0019,"SPI-P Release 1;1",0a)	(0019,"SPI-P Release 1;1",0a)	SPI-P Release 1;1	25	10	f	\N	UN	1	SampleRate	\N
2352	(0019,"SPI-P Release 1;1",10)	(0019,"SPI-P Release 1;1",10)	SPI-P Release 1;1	25	16	f	\N	UN	1	PhysiologicalDataType2	\N
2353	(0019,"SPI-P Release 1;1",11)	(0019,"SPI-P Release 1;1",11)	SPI-P Release 1;1	25	17	f	\N	UN	1	PhysiologicalDataChannelAndKind2	\N
2354	(0019,"SPI-P Release 1;1",12)	(0019,"SPI-P Release 1;1",12)	SPI-P Release 1;1	25	18	f	\N	US	1	SampleBitsAllocated2	\N
2355	(0019,"SPI-P Release 1;1",13)	(0019,"SPI-P Release 1;1",13)	SPI-P Release 1;1	25	19	f	\N	US	1	SampleBitsStored2	\N
2356	(0019,"SPI-P Release 1;1",14)	(0019,"SPI-P Release 1;1",14)	SPI-P Release 1;1	25	20	f	\N	US	1	SampleHighBit2	\N
2357	(0019,"SPI-P Release 1;1",15)	(0019,"SPI-P Release 1;1",15)	SPI-P Release 1;1	25	21	f	\N	US	1	SampleRepresentation2	\N
2358	(0019,"SPI-P Release 1;1",16)	(0019,"SPI-P Release 1;1",16)	SPI-P Release 1;1	25	22	f	\N	UN	1	SmallestSampleValue2	\N
2359	(0019,"SPI-P Release 1;1",17)	(0019,"SPI-P Release 1;1",17)	SPI-P Release 1;1	25	23	f	\N	UN	1	LargestSampleValue2	\N
2360	(0019,"SPI-P Release 1;1",18)	(0019,"SPI-P Release 1;1",18)	SPI-P Release 1;1	25	24	f	\N	UN	1	NumberOfSamples2	\N
2361	(0019,"SPI-P Release 1;1",19)	(0019,"SPI-P Release 1;1",19)	SPI-P Release 1;1	25	25	f	\N	UN	1	SampleData2	\N
2362	(0019,"SPI-P Release 1;1",1a)	(0019,"SPI-P Release 1;1",1a)	SPI-P Release 1;1	25	26	f	\N	UN	1	SampleRate2	\N
2363	(0029,"SPI-P Release 1;1",00)	(0029,"SPI-P Release 1;1",00)	SPI-P Release 1;1	41	0	f	\N	LT	1	ZoomID	\N
2364	(0029,"SPI-P Release 1;1",01)	(0029,"SPI-P Release 1;1",01)	SPI-P Release 1;1	41	1	f	\N	DS	1-n	ZoomRectangle	\N
2365	(0029,"SPI-P Release 1;1",03)	(0029,"SPI-P Release 1;1",03)	SPI-P Release 1;1	41	3	f	\N	DS	1	ZoomFactor	\N
2366	(0029,"SPI-P Release 1;1",04)	(0029,"SPI-P Release 1;1",04)	SPI-P Release 1;1	41	4	f	\N	US	1	ZoomFunction	\N
2367	(0029,"SPI-P Release 1;1",0e)	(0029,"SPI-P Release 1;1",0e)	SPI-P Release 1;1	41	14	f	\N	CS	1	ZoomEnableStatus	\N
2368	(0029,"SPI-P Release 1;1",0f)	(0029,"SPI-P Release 1;1",0f)	SPI-P Release 1;1	41	15	f	\N	CS	1	ZoomSelectStatus	\N
2369	(0029,"SPI-P Release 1;1",40)	(0029,"SPI-P Release 1;1",40)	SPI-P Release 1;1	41	64	f	\N	LT	1	MagnifyingGlassID	\N
2370	(0029,"SPI-P Release 1;1",41)	(0029,"SPI-P Release 1;1",41)	SPI-P Release 1;1	41	65	f	\N	DS	1-n	MagnifyingGlassRectangle	\N
2371	(0029,"SPI-P Release 1;1",43)	(0029,"SPI-P Release 1;1",43)	SPI-P Release 1;1	41	67	f	\N	DS	1	MagnifyingGlassFactor	\N
2372	(0029,"SPI-P Release 1;1",44)	(0029,"SPI-P Release 1;1",44)	SPI-P Release 1;1	41	68	f	\N	US	1	MagnifyingGlassFunction	\N
2373	(0029,"SPI-P Release 1;1",4e)	(0029,"SPI-P Release 1;1",4e)	SPI-P Release 1;1	41	78	f	\N	CS	1	MagnifyingGlassEnableStatus	\N
2374	(0029,"SPI-P Release 1;1",4f)	(0029,"SPI-P Release 1;1",4f)	SPI-P Release 1;1	41	79	f	\N	CS	1	MagnifyingGlassSelectStatus	\N
2375	(0029,"SPI-P Release 1;2",00)	(0029,"SPI-P Release 1;2",00)	SPI-P Release 1;2	41	0	f	\N	LT	1	SubtractionMaskID	\N
2376	(0029,"SPI-P Release 1;2",04)	(0029,"SPI-P Release 1;2",04)	SPI-P Release 1;2	41	4	f	\N	UN	1	MaskingFunction	\N
2377	(0029,"SPI-P Release 1;2",0c)	(0029,"SPI-P Release 1;2",0c)	SPI-P Release 1;2	41	12	f	\N	UN	1	ProprietaryMaskingParameters	\N
2378	(0029,"SPI-P Release 1;2",1e)	(0029,"SPI-P Release 1;2",1e)	SPI-P Release 1;2	41	30	f	\N	CS	1	SubtractionMaskEnableStatus	\N
2379	(0029,"SPI-P Release 1;2",1f)	(0029,"SPI-P Release 1;2",1f)	SPI-P Release 1;2	41	31	f	\N	CS	1	SubtractionMaskSelectStatus	\N
2380	(0029,"SPI-P Release 1;3",00)	(0029,"SPI-P Release 1;3",00)	SPI-P Release 1;3	41	0	f	\N	LT	1	ImageEnhancementID	\N
2381	(0029,"SPI-P Release 1;3",01)	(0029,"SPI-P Release 1;3",01)	SPI-P Release 1;3	41	1	f	\N	LT	1	ImageEnhancement	\N
2382	(0029,"SPI-P Release 1;3",02)	(0029,"SPI-P Release 1;3",02)	SPI-P Release 1;3	41	2	f	\N	LT	1	ConvolutionID	\N
2383	(0029,"SPI-P Release 1;3",03)	(0029,"SPI-P Release 1;3",03)	SPI-P Release 1;3	41	3	f	\N	LT	1	ConvolutionType	\N
2384	(0029,"SPI-P Release 1;3",04)	(0029,"SPI-P Release 1;3",04)	SPI-P Release 1;3	41	4	f	\N	LT	1	ConvolutionKernelSizeID	\N
2385	(0029,"SPI-P Release 1;3",05)	(0029,"SPI-P Release 1;3",05)	SPI-P Release 1;3	41	5	f	\N	US	2	ConvolutionKernelSize	\N
2386	(0029,"SPI-P Release 1;3",06)	(0029,"SPI-P Release 1;3",06)	SPI-P Release 1;3	41	6	f	\N	US	1-n	ConvolutionKernel	\N
2387	(0029,"SPI-P Release 1;3",0c)	(0029,"SPI-P Release 1;3",0c)	SPI-P Release 1;3	41	12	f	\N	DS	1	EnhancementGain	\N
2388	(0029,"SPI-P Release 1;3",1e)	(0029,"SPI-P Release 1;3",1e)	SPI-P Release 1;3	41	30	f	\N	CS	1	ImageEnhancementEnableStatus	\N
2389	(0029,"SPI-P Release 1;3",1f)	(0029,"SPI-P Release 1;3",1f)	SPI-P Release 1;3	41	31	f	\N	CS	1	ImageEnhancementSelectStatus	\N
2390	(0011,"SPI-P Release 2;1",18)	(0011,"SPI-P Release 2;1",18)	SPI-P Release 2;1	17	24	f	\N	LT	1	Unknown	\N
2391	(0023,"SPI-P Release 2;1",0d)	(0023,"SPI-P Release 2;1",0d)	SPI-P Release 2;1	35	13	f	\N	UI	1	Unknown	\N
2392	(0023,"SPI-P Release 2;1",0e)	(0023,"SPI-P Release 2;1",0e)	SPI-P Release 2;1	35	14	f	\N	UI	1	Unknown	\N
2393	(0009,"SPI-P-GV-CT Release 1",00)	(0009,"SPI-P-GV-CT Release 1",00)	SPI-P-GV-CT Release 1	9	0	f	\N	LO	1	Unknown	\N
2394	(0009,"SPI-P-GV-CT Release 1",10)	(0009,"SPI-P-GV-CT Release 1",10)	SPI-P-GV-CT Release 1	9	16	f	\N	LO	1	Unknown	\N
2395	(0009,"SPI-P-GV-CT Release 1",20)	(0009,"SPI-P-GV-CT Release 1",20)	SPI-P-GV-CT Release 1	9	32	f	\N	LO	1	Unknown	\N
2396	(0009,"SPI-P-GV-CT Release 1",30)	(0009,"SPI-P-GV-CT Release 1",30)	SPI-P-GV-CT Release 1	9	48	f	\N	LO	1	Unknown	\N
2397	(0009,"SPI-P-GV-CT Release 1",40)	(0009,"SPI-P-GV-CT Release 1",40)	SPI-P-GV-CT Release 1	9	64	f	\N	LO	1	Unknown	\N
2398	(0009,"SPI-P-GV-CT Release 1",50)	(0009,"SPI-P-GV-CT Release 1",50)	SPI-P-GV-CT Release 1	9	80	f	\N	LO	1	Unknown	\N
2399	(0009,"SPI-P-GV-CT Release 1",60)	(0009,"SPI-P-GV-CT Release 1",60)	SPI-P-GV-CT Release 1	9	96	f	\N	LO	1	Unknown	\N
2400	(0009,"SPI-P-GV-CT Release 1",70)	(0009,"SPI-P-GV-CT Release 1",70)	SPI-P-GV-CT Release 1	9	112	f	\N	LO	1	Unknown	\N
2401	(0009,"SPI-P-GV-CT Release 1",75)	(0009,"SPI-P-GV-CT Release 1",75)	SPI-P-GV-CT Release 1	9	117	f	\N	LO	1	Unknown	\N
2402	(0009,"SPI-P-GV-CT Release 1",80)	(0009,"SPI-P-GV-CT Release 1",80)	SPI-P-GV-CT Release 1	9	128	f	\N	LO	1	Unknown	\N
2403	(0009,"SPI-P-GV-CT Release 1",90)	(0009,"SPI-P-GV-CT Release 1",90)	SPI-P-GV-CT Release 1	9	144	f	\N	LO	1	Unknown	\N
2404	(0019,"SPI-P-GV-CT Release 1",08)	(0019,"SPI-P-GV-CT Release 1",08)	SPI-P-GV-CT Release 1	25	8	f	\N	IS	1	Unknown	\N
2405	(0019,"SPI-P-GV-CT Release 1",09)	(0019,"SPI-P-GV-CT Release 1",09)	SPI-P-GV-CT Release 1	25	9	f	\N	IS	1	Unknown	\N
2406	(0019,"SPI-P-GV-CT Release 1",0a)	(0019,"SPI-P-GV-CT Release 1",0a)	SPI-P-GV-CT Release 1	25	10	f	\N	IS	1	Unknown	\N
2407	(0019,"SPI-P-GV-CT Release 1",10)	(0019,"SPI-P-GV-CT Release 1",10)	SPI-P-GV-CT Release 1	25	16	f	\N	LO	1	Unknown	\N
2408	(0019,"SPI-P-GV-CT Release 1",20)	(0019,"SPI-P-GV-CT Release 1",20)	SPI-P-GV-CT Release 1	25	32	f	\N	TM	1	Unknown	\N
2409	(0019,"SPI-P-GV-CT Release 1",50)	(0019,"SPI-P-GV-CT Release 1",50)	SPI-P-GV-CT Release 1	25	80	f	\N	LO	1	Unknown	\N
2410	(0019,"SPI-P-GV-CT Release 1",60)	(0019,"SPI-P-GV-CT Release 1",60)	SPI-P-GV-CT Release 1	25	96	f	\N	DS	1	Unknown	\N
2411	(0019,"SPI-P-GV-CT Release 1",61)	(0019,"SPI-P-GV-CT Release 1",61)	SPI-P-GV-CT Release 1	25	97	f	\N	US	1	Unknown	\N
2412	(0019,"SPI-P-GV-CT Release 1",63)	(0019,"SPI-P-GV-CT Release 1",63)	SPI-P-GV-CT Release 1	25	99	f	\N	LO	1	Unknown	\N
2413	(0019,"SPI-P-GV-CT Release 1",64)	(0019,"SPI-P-GV-CT Release 1",64)	SPI-P-GV-CT Release 1	25	100	f	\N	US	1	Unknown	\N
2414	(0019,"SPI-P-GV-CT Release 1",65)	(0019,"SPI-P-GV-CT Release 1",65)	SPI-P-GV-CT Release 1	25	101	f	\N	IS	1	Unknown	\N
2415	(0019,"SPI-P-GV-CT Release 1",70)	(0019,"SPI-P-GV-CT Release 1",70)	SPI-P-GV-CT Release 1	25	112	f	\N	LT	1	Unknown	\N
2416	(0019,"SPI-P-GV-CT Release 1",80)	(0019,"SPI-P-GV-CT Release 1",80)	SPI-P-GV-CT Release 1	25	128	f	\N	LO	1	Unknown	\N
2417	(0019,"SPI-P-GV-CT Release 1",81)	(0019,"SPI-P-GV-CT Release 1",81)	SPI-P-GV-CT Release 1	25	129	f	\N	LO	1	Unknown	\N
2418	(0019,"SPI-P-GV-CT Release 1",90)	(0019,"SPI-P-GV-CT Release 1",90)	SPI-P-GV-CT Release 1	25	144	f	\N	LO	1	Unknown	\N
2419	(0019,"SPI-P-GV-CT Release 1",a0)	(0019,"SPI-P-GV-CT Release 1",a0)	SPI-P-GV-CT Release 1	25	160	f	\N	LO	1	Unknown	\N
2420	(0019,"SPI-P-GV-CT Release 1",a1)	(0019,"SPI-P-GV-CT Release 1",a1)	SPI-P-GV-CT Release 1	25	161	f	\N	US	1	Unknown	\N
2421	(0019,"SPI-P-GV-CT Release 1",a2)	(0019,"SPI-P-GV-CT Release 1",a2)	SPI-P-GV-CT Release 1	25	162	f	\N	US	1	Unknown	\N
2422	(0019,"SPI-P-GV-CT Release 1",a3)	(0019,"SPI-P-GV-CT Release 1",a3)	SPI-P-GV-CT Release 1	25	163	f	\N	US	1	Unknown	\N
2423	(0019,"SPI-P-GV-CT Release 1",b0)	(0019,"SPI-P-GV-CT Release 1",b0)	SPI-P-GV-CT Release 1	25	176	f	\N	LO	1	Unknown	\N
2424	(0019,"SPI-P-GV-CT Release 1",b1)	(0019,"SPI-P-GV-CT Release 1",b1)	SPI-P-GV-CT Release 1	25	177	f	\N	LO	1	Unknown	\N
2425	(0021,"SPI-P-GV-CT Release 1",20)	(0021,"SPI-P-GV-CT Release 1",20)	SPI-P-GV-CT Release 1	33	32	f	\N	LO	1	Unknown	\N
2426	(0021,"SPI-P-GV-CT Release 1",30)	(0021,"SPI-P-GV-CT Release 1",30)	SPI-P-GV-CT Release 1	33	48	f	\N	DS	1	Unknown	\N
2427	(0021,"SPI-P-GV-CT Release 1",40)	(0021,"SPI-P-GV-CT Release 1",40)	SPI-P-GV-CT Release 1	33	64	f	\N	LO	1	Unknown	\N
2428	(0021,"SPI-P-GV-CT Release 1",50)	(0021,"SPI-P-GV-CT Release 1",50)	SPI-P-GV-CT Release 1	33	80	f	\N	LO	1	Unknown	\N
2429	(0021,"SPI-P-GV-CT Release 1",60)	(0021,"SPI-P-GV-CT Release 1",60)	SPI-P-GV-CT Release 1	33	96	f	\N	DS	1	Unknown	\N
2430	(0021,"SPI-P-GV-CT Release 1",70)	(0021,"SPI-P-GV-CT Release 1",70)	SPI-P-GV-CT Release 1	33	112	f	\N	DS	1	Unknown	\N
2431	(0021,"SPI-P-GV-CT Release 1",80)	(0021,"SPI-P-GV-CT Release 1",80)	SPI-P-GV-CT Release 1	33	128	f	\N	DS	1	Unknown	\N
2643	(0019,"SVISION",A0)	(0019,"SVISION",A0)	SVISION	25	160	f	\N	DS	1	ExtendedExposureTime	\N
2432	(0021,"SPI-P-GV-CT Release 1",90)	(0021,"SPI-P-GV-CT Release 1",90)	SPI-P-GV-CT Release 1	33	144	f	\N	DS	1	Unknown	\N
2433	(0021,"SPI-P-GV-CT Release 1",a0)	(0021,"SPI-P-GV-CT Release 1",a0)	SPI-P-GV-CT Release 1	33	160	f	\N	US	1	Unknown	\N
2434	(0021,"SPI-P-GV-CT Release 1",a1)	(0021,"SPI-P-GV-CT Release 1",a1)	SPI-P-GV-CT Release 1	33	161	f	\N	DS	1	Unknown	\N
2435	(0021,"SPI-P-GV-CT Release 1",a2)	(0021,"SPI-P-GV-CT Release 1",a2)	SPI-P-GV-CT Release 1	33	162	f	\N	DS	1	Unknown	\N
2436	(0021,"SPI-P-GV-CT Release 1",a3)	(0021,"SPI-P-GV-CT Release 1",a3)	SPI-P-GV-CT Release 1	33	163	f	\N	LT	1	Unknown	\N
2437	(0021,"SPI-P-GV-CT Release 1",a4)	(0021,"SPI-P-GV-CT Release 1",a4)	SPI-P-GV-CT Release 1	33	164	f	\N	LT	1	Unknown	\N
2438	(0021,"SPI-P-GV-CT Release 1",b0)	(0021,"SPI-P-GV-CT Release 1",b0)	SPI-P-GV-CT Release 1	33	176	f	\N	LO	1	Unknown	\N
2439	(0021,"SPI-P-GV-CT Release 1",c0)	(0021,"SPI-P-GV-CT Release 1",c0)	SPI-P-GV-CT Release 1	33	192	f	\N	LO	1	Unknown	\N
2440	(0029,"SPI-P-GV-CT Release 1",10)	(0029,"SPI-P-GV-CT Release 1",10)	SPI-P-GV-CT Release 1	41	16	f	\N	LO	1	Unknown	\N
2441	(0029,"SPI-P-GV-CT Release 1",30)	(0029,"SPI-P-GV-CT Release 1",30)	SPI-P-GV-CT Release 1	41	48	f	\N	UL	1	Unknown	\N
2442	(0029,"SPI-P-GV-CT Release 1",31)	(0029,"SPI-P-GV-CT Release 1",31)	SPI-P-GV-CT Release 1	41	49	f	\N	UL	1	Unknown	\N
2443	(0029,"SPI-P-GV-CT Release 1",32)	(0029,"SPI-P-GV-CT Release 1",32)	SPI-P-GV-CT Release 1	41	50	f	\N	UL	1	Unknown	\N
2444	(0029,"SPI-P-GV-CT Release 1",33)	(0029,"SPI-P-GV-CT Release 1",33)	SPI-P-GV-CT Release 1	41	51	f	\N	UL	1	Unknown	\N
2445	(0029,"SPI-P-GV-CT Release 1",80)	(0029,"SPI-P-GV-CT Release 1",80)	SPI-P-GV-CT Release 1	41	128	f	\N	LO	1	Unknown	\N
2446	(0029,"SPI-P-GV-CT Release 1",90)	(0029,"SPI-P-GV-CT Release 1",90)	SPI-P-GV-CT Release 1	41	144	f	\N	LO	1	Unknown	\N
2447	(0029,"SPI-P-GV-CT Release 1",d0)	(0029,"SPI-P-GV-CT Release 1",d0)	SPI-P-GV-CT Release 1	41	208	f	\N	IS	1	Unknown	\N
2448	(0029,"SPI-P-GV-CT Release 1",d1)	(0029,"SPI-P-GV-CT Release 1",d1)	SPI-P-GV-CT Release 1	41	209	f	\N	IS	1	Unknown	\N
2449	(0019,"SPI-P-PCR Release 2",30)	(0019,"SPI-P-PCR Release 2",30)	SPI-P-PCR Release 2	25	48	f	\N	US	1	Unknown	\N
2450	(0021,"SPI-P-Private-CWS Release 1",00)	(0021,"SPI-P-Private-CWS Release 1",00)	SPI-P-Private-CWS Release 1	33	0	f	\N	LT	1	WindowOfImagesID	\N
2451	(0021,"SPI-P-Private-CWS Release 1",01)	(0021,"SPI-P-Private-CWS Release 1",01)	SPI-P-Private-CWS Release 1	33	1	f	\N	CS	1	WindowOfImagesType	\N
2452	(0021,"SPI-P-Private-CWS Release 1",02)	(0021,"SPI-P-Private-CWS Release 1",02)	SPI-P-Private-CWS Release 1	33	2	f	\N	IS	1-n	WindowOfImagesScope	\N
2453	(0019,"SPI-P-Private-DCI Release 1",10)	(0019,"SPI-P-Private-DCI Release 1",10)	SPI-P-Private-DCI Release 1	25	16	f	\N	UN	1	ECGTimeMapDataBitsAllocated	\N
2454	(0019,"SPI-P-Private-DCI Release 1",11)	(0019,"SPI-P-Private-DCI Release 1",11)	SPI-P-Private-DCI Release 1	25	17	f	\N	UN	1	ECGTimeMapDataBitsStored	\N
2455	(0019,"SPI-P-Private-DCI Release 1",12)	(0019,"SPI-P-Private-DCI Release 1",12)	SPI-P-Private-DCI Release 1	25	18	f	\N	UN	1	ECGTimeMapDataHighBit	\N
2456	(0019,"SPI-P-Private-DCI Release 1",13)	(0019,"SPI-P-Private-DCI Release 1",13)	SPI-P-Private-DCI Release 1	25	19	f	\N	UN	1	ECGTimeMapDataRepresentation	\N
2457	(0019,"SPI-P-Private-DCI Release 1",14)	(0019,"SPI-P-Private-DCI Release 1",14)	SPI-P-Private-DCI Release 1	25	20	f	\N	UN	1	ECGTimeMapDataSmallestDataValue	\N
2458	(0019,"SPI-P-Private-DCI Release 1",15)	(0019,"SPI-P-Private-DCI Release 1",15)	SPI-P-Private-DCI Release 1	25	21	f	\N	UN	1	ECGTimeMapDataLargestDataValue	\N
2459	(0019,"SPI-P-Private-DCI Release 1",16)	(0019,"SPI-P-Private-DCI Release 1",16)	SPI-P-Private-DCI Release 1	25	22	f	\N	UN	1	ECGTimeMapDataNumberOfDataValues	\N
2460	(0019,"SPI-P-Private-DCI Release 1",17)	(0019,"SPI-P-Private-DCI Release 1",17)	SPI-P-Private-DCI Release 1	25	23	f	\N	UN	1	ECGTimeMapData	\N
2461	(0021,"SPI-P-Private_CDS Release 1",40)	(0021,"SPI-P-Private_CDS Release 1",40)	SPI-P-Private_CDS Release 1	33	64	f	\N	IS	1	Unknown	\N
2462	(0029,"SPI-P-Private_CDS Release 1",00)	(0029,"SPI-P-Private_CDS Release 1",00)	SPI-P-Private_CDS Release 1	41	0	f	\N	UN	1	Unknown	\N
2463	(0019,"SPI-P-Private_ICS Release 1",30)	(0019,"SPI-P-Private_ICS Release 1",30)	SPI-P-Private_ICS Release 1	25	48	f	\N	DS	1	Unknown	\N
2464	(0019,"SPI-P-Private_ICS Release 1",31)	(0019,"SPI-P-Private_ICS Release 1",31)	SPI-P-Private_ICS Release 1	25	49	f	\N	LO	1	Unknown	\N
2465	(0029,"SPI-P-Private_ICS Release 1",08)	(0029,"SPI-P-Private_ICS Release 1",08)	SPI-P-Private_ICS Release 1	41	8	f	\N	SQ	1	Unknown	\N
2466	(0029,"SPI-P-Private_ICS Release 1",0f)	(0029,"SPI-P-Private_ICS Release 1",0f)	SPI-P-Private_ICS Release 1	41	15	f	\N	SQ	1	Unknown	\N
2467	(0029,"SPI-P-Private_ICS Release 1",10)	(0029,"SPI-P-Private_ICS Release 1",10)	SPI-P-Private_ICS Release 1	41	16	f	\N	SQ	1	Unknown	\N
2468	(0029,"SPI-P-Private_ICS Release 1",1b)	(0029,"SPI-P-Private_ICS Release 1",1b)	SPI-P-Private_ICS Release 1	41	27	f	\N	SQ	1	Unknown	\N
2469	(0029,"SPI-P-Private_ICS Release 1",1c)	(0029,"SPI-P-Private_ICS Release 1",1c)	SPI-P-Private_ICS Release 1	41	28	f	\N	SQ	1	Unknown	\N
2470	(0029,"SPI-P-Private_ICS Release 1",21)	(0029,"SPI-P-Private_ICS Release 1",21)	SPI-P-Private_ICS Release 1	41	33	f	\N	SQ	1	Unknown	\N
2471	(0029,"SPI-P-Private_ICS Release 1",43)	(0029,"SPI-P-Private_ICS Release 1",43)	SPI-P-Private_ICS Release 1	41	67	f	\N	SQ	1	Unknown	\N
2472	(0029,"SPI-P-Private_ICS Release 1",44)	(0029,"SPI-P-Private_ICS Release 1",44)	SPI-P-Private_ICS Release 1	41	68	f	\N	SQ	1	Unknown	\N
2473	(0029,"SPI-P-Private_ICS Release 1",4C)	(0029,"SPI-P-Private_ICS Release 1",4C)	SPI-P-Private_ICS Release 1	41	76	f	\N	SQ	1	Unknown	\N
2474	(0029,"SPI-P-Private_ICS Release 1",67)	(0029,"SPI-P-Private_ICS Release 1",67)	SPI-P-Private_ICS Release 1	41	103	f	\N	LO	1	Unknown	\N
2475	(0029,"SPI-P-Private_ICS Release 1",68)	(0029,"SPI-P-Private_ICS Release 1",68)	SPI-P-Private_ICS Release 1	41	104	f	\N	US	1	Unknown	\N
2476	(0029,"SPI-P-Private_ICS Release 1",6A)	(0029,"SPI-P-Private_ICS Release 1",6A)	SPI-P-Private_ICS Release 1	41	106	f	\N	LO	1	Unknown	\N
2477	(0029,"SPI-P-Private_ICS Release 1",6B)	(0029,"SPI-P-Private_ICS Release 1",6B)	SPI-P-Private_ICS Release 1	41	107	f	\N	US	1	Unknown	\N
2478	(0029,"SPI-P-Private_ICS Release 1;1",00)	(0029,"SPI-P-Private_ICS Release 1;1",00)	SPI-P-Private_ICS Release 1;1	41	0	f	\N	SL	1	Unknown	\N
2479	(0029,"SPI-P-Private_ICS Release 1;1",05)	(0029,"SPI-P-Private_ICS Release 1;1",05)	SPI-P-Private_ICS Release 1;1	41	5	f	\N	FL	1	Unknown	\N
2480	(0029,"SPI-P-Private_ICS Release 1;1",06)	(0029,"SPI-P-Private_ICS Release 1;1",06)	SPI-P-Private_ICS Release 1;1	41	6	f	\N	FL	1	Unknown	\N
2481	(0029,"SPI-P-Private_ICS Release 1;1",20)	(0029,"SPI-P-Private_ICS Release 1;1",20)	SPI-P-Private_ICS Release 1;1	41	32	f	\N	FL	1	Unknown	\N
2482	(0029,"SPI-P-Private_ICS Release 1;1",21)	(0029,"SPI-P-Private_ICS Release 1;1",21)	SPI-P-Private_ICS Release 1;1	41	33	f	\N	FL	1	Unknown	\N
2483	(0029,"SPI-P-Private_ICS Release 1;1",CD)	(0029,"SPI-P-Private_ICS Release 1;1",CD)	SPI-P-Private_ICS Release 1;1	41	205	f	\N	SQ	1	Unknown	\N
2484	(0029,"SPI-P-Private_ICS Release 1;2",00)	(0029,"SPI-P-Private_ICS Release 1;2",00)	SPI-P-Private_ICS Release 1;2	41	0	f	\N	FD	1	Unknown	\N
2485	(0029,"SPI-P-Private_ICS Release 1;2",01)	(0029,"SPI-P-Private_ICS Release 1;2",01)	SPI-P-Private_ICS Release 1;2	41	1	f	\N	FD	1	Unknown	\N
2486	(0029,"SPI-P-Private_ICS Release 1;2",02)	(0029,"SPI-P-Private_ICS Release 1;2",02)	SPI-P-Private_ICS Release 1;2	41	2	f	\N	FD	1	Unknown	\N
2487	(0029,"SPI-P-Private_ICS Release 1;2",03)	(0029,"SPI-P-Private_ICS Release 1;2",03)	SPI-P-Private_ICS Release 1;2	41	3	f	\N	SL	1	Unknown	\N
2488	(0029,"SPI-P-Private_ICS Release 1;2",04)	(0029,"SPI-P-Private_ICS Release 1;2",04)	SPI-P-Private_ICS Release 1;2	41	4	f	\N	SL	1	Unknown	\N
2489	(0029,"SPI-P-Private_ICS Release 1;2",05)	(0029,"SPI-P-Private_ICS Release 1;2",05)	SPI-P-Private_ICS Release 1;2	41	5	f	\N	SL	1	Unknown	\N
2490	(0029,"SPI-P-Private_ICS Release 1;3",C0)	(0029,"SPI-P-Private_ICS Release 1;3",C0)	SPI-P-Private_ICS Release 1;3	41	192	f	\N	SQ	1	Unknown	\N
2491	(0029,"SPI-P-Private_ICS Release 1;3",C1)	(0029,"SPI-P-Private_ICS Release 1;3",C1)	SPI-P-Private_ICS Release 1;3	41	193	f	\N	SQ	1	Unknown	\N
2492	(0029,"SPI-P-Private_ICS Release 1;3",C2)	(0029,"SPI-P-Private_ICS Release 1;3",C2)	SPI-P-Private_ICS Release 1;3	41	194	f	\N	SQ	1	Unknown	\N
2493	(0029,"SPI-P-Private_ICS Release 1;3",C3)	(0029,"SPI-P-Private_ICS Release 1;3",C3)	SPI-P-Private_ICS Release 1;3	41	195	f	\N	SQ	1	Unknown	\N
2494	(0029,"SPI-P-Private_ICS Release 1;3",C4)	(0029,"SPI-P-Private_ICS Release 1;3",C4)	SPI-P-Private_ICS Release 1;3	41	196	f	\N	SQ	1	Unknown	\N
2495	(0029,"SPI-P-Private_ICS Release 1;3",C5)	(0029,"SPI-P-Private_ICS Release 1;3",C5)	SPI-P-Private_ICS Release 1;3	41	197	f	\N	SQ	1	Unknown	\N
2496	(0029,"SPI-P-Private_ICS Release 1;4",02)	(0029,"SPI-P-Private_ICS Release 1;4",02)	SPI-P-Private_ICS Release 1;4	41	2	f	\N	SQ	1	Unknown	\N
2497	(0029,"SPI-P-Private_ICS Release 1;4",9A)	(0029,"SPI-P-Private_ICS Release 1;4",9A)	SPI-P-Private_ICS Release 1;4	41	154	f	\N	SQ	1	Unknown	\N
2498	(0029,"SPI-P-Private_ICS Release 1;4",E0)	(0029,"SPI-P-Private_ICS Release 1;4",E0)	SPI-P-Private_ICS Release 1;4	41	224	f	\N	SQ	1	Unknown	\N
2499	(0029,"SPI-P-Private_ICS Release 1;5",50)	(0029,"SPI-P-Private_ICS Release 1;5",50)	SPI-P-Private_ICS Release 1;5	41	80	f	\N	CS	1	Unknown	\N
2500	(0029,"SPI-P-Private_ICS Release 1;5",55)	(0029,"SPI-P-Private_ICS Release 1;5",55)	SPI-P-Private_ICS Release 1;5	41	85	f	\N	CS	1	Unknown	\N
2501	(0019,"SPI-P-XSB-DCI Release 1",10)	(0019,"SPI-P-XSB-DCI Release 1",10)	SPI-P-XSB-DCI Release 1	25	16	f	\N	LT	1	VideoBeamBoost	\N
2502	(0019,"SPI-P-XSB-DCI Release 1",11)	(0019,"SPI-P-XSB-DCI Release 1",11)	SPI-P-XSB-DCI Release 1	25	17	f	\N	US	1	ChannelGeneratingVideoSync	\N
2503	(0019,"SPI-P-XSB-DCI Release 1",12)	(0019,"SPI-P-XSB-DCI Release 1",12)	SPI-P-XSB-DCI Release 1	25	18	f	\N	US	1	VideoGain	\N
2504	(0019,"SPI-P-XSB-DCI Release 1",13)	(0019,"SPI-P-XSB-DCI Release 1",13)	SPI-P-XSB-DCI Release 1	25	19	f	\N	US	1	VideoOffset	\N
2505	(0019,"SPI-P-XSB-DCI Release 1",20)	(0019,"SPI-P-XSB-DCI Release 1",20)	SPI-P-XSB-DCI Release 1	25	32	f	\N	DS	1	RTDDataCompressionFactor	\N
2506	(0029,"Silhouette Annot V1.0",11)	(0029,"Silhouette Annot V1.0",11)	Silhouette Annot V1.0	41	17	f	\N	IS	1	AnnotationName	\N
2507	(0029,"Silhouette Annot V1.0",12)	(0029,"Silhouette Annot V1.0",12)	Silhouette Annot V1.0	41	18	f	\N	LT	1	AnnotationFont	\N
2508	(0029,"Silhouette Annot V1.0",13)	(0029,"Silhouette Annot V1.0",13)	Silhouette Annot V1.0	41	19	f	\N	LT	1	AnnotationTextForegroundColor	\N
2509	(0029,"Silhouette Annot V1.0",14)	(0029,"Silhouette Annot V1.0",14)	Silhouette Annot V1.0	41	20	f	\N	LT	1	AnnotationTextBackgroundColor	\N
2510	(0029,"Silhouette Annot V1.0",15)	(0029,"Silhouette Annot V1.0",15)	Silhouette Annot V1.0	41	21	f	\N	UL	1	AnnotationTextBackingMode	\N
2511	(0029,"Silhouette Annot V1.0",16)	(0029,"Silhouette Annot V1.0",16)	Silhouette Annot V1.0	41	22	f	\N	UL	1	AnnotationTextJustification	\N
2512	(0029,"Silhouette Annot V1.0",17)	(0029,"Silhouette Annot V1.0",17)	Silhouette Annot V1.0	41	23	f	\N	UL	1	AnnotationTextLocation	\N
2513	(0029,"Silhouette Annot V1.0",18)	(0029,"Silhouette Annot V1.0",18)	Silhouette Annot V1.0	41	24	f	\N	LT	1	AnnotationTextString	\N
2514	(0029,"Silhouette Annot V1.0",19)	(0029,"Silhouette Annot V1.0",19)	Silhouette Annot V1.0	41	25	f	\N	UL	1	AnnotationTextAttachMode	\N
2515	(0029,"Silhouette Annot V1.0",20)	(0029,"Silhouette Annot V1.0",20)	Silhouette Annot V1.0	41	32	f	\N	UL	1	AnnotationTextCursorMode	\N
2516	(0029,"Silhouette Annot V1.0",21)	(0029,"Silhouette Annot V1.0",21)	Silhouette Annot V1.0	41	33	f	\N	UL	1	AnnotationTextShadowOffsetX	\N
2517	(0029,"Silhouette Annot V1.0",22)	(0029,"Silhouette Annot V1.0",22)	Silhouette Annot V1.0	41	34	f	\N	UL	1	AnnotationTextShadowOffsetY	\N
2518	(0029,"Silhouette Annot V1.0",23)	(0029,"Silhouette Annot V1.0",23)	Silhouette Annot V1.0	41	35	f	\N	LT	1	AnnotationLineColor	\N
2519	(0029,"Silhouette Annot V1.0",24)	(0029,"Silhouette Annot V1.0",24)	Silhouette Annot V1.0	41	36	f	\N	UL	1	AnnotationLineThickness	\N
2520	(0029,"Silhouette Annot V1.0",25)	(0029,"Silhouette Annot V1.0",25)	Silhouette Annot V1.0	41	37	f	\N	UL	1	AnnotationLineType	\N
2521	(0029,"Silhouette Annot V1.0",26)	(0029,"Silhouette Annot V1.0",26)	Silhouette Annot V1.0	41	38	f	\N	UL	1	AnnotationLineStyle	\N
2522	(0029,"Silhouette Annot V1.0",27)	(0029,"Silhouette Annot V1.0",27)	Silhouette Annot V1.0	41	39	f	\N	UL	1	AnnotationLineDashLength	\N
2523	(0029,"Silhouette Annot V1.0",28)	(0029,"Silhouette Annot V1.0",28)	Silhouette Annot V1.0	41	40	f	\N	UL	1	AnnotationLineAttachMode	\N
2524	(0029,"Silhouette Annot V1.0",29)	(0029,"Silhouette Annot V1.0",29)	Silhouette Annot V1.0	41	41	f	\N	UL	1	AnnotationLinePointCount	\N
2525	(0029,"Silhouette Annot V1.0",30)	(0029,"Silhouette Annot V1.0",30)	Silhouette Annot V1.0	41	48	f	\N	FD	1	AnnotationLinePoints	\N
2644	(0019,"SVISION",A1)	(0019,"SVISION",A1)	SVISION	25	161	f	\N	DS	1	ActualExposureTime	\N
2526	(0029,"Silhouette Annot V1.0",31)	(0029,"Silhouette Annot V1.0",31)	Silhouette Annot V1.0	41	49	f	\N	UL	1	AnnotationLineControlSize	\N
2527	(0029,"Silhouette Annot V1.0",32)	(0029,"Silhouette Annot V1.0",32)	Silhouette Annot V1.0	41	50	f	\N	LT	1	AnnotationMarkerColor	\N
2528	(0029,"Silhouette Annot V1.0",33)	(0029,"Silhouette Annot V1.0",33)	Silhouette Annot V1.0	41	51	f	\N	UL	1	AnnotationMarkerType	\N
2529	(0029,"Silhouette Annot V1.0",34)	(0029,"Silhouette Annot V1.0",34)	Silhouette Annot V1.0	41	52	f	\N	UL	1	AnnotationMarkerSize	\N
2530	(0029,"Silhouette Annot V1.0",35)	(0029,"Silhouette Annot V1.0",35)	Silhouette Annot V1.0	41	53	f	\N	FD	1	AnnotationMarkerLocation	\N
2531	(0029,"Silhouette Annot V1.0",36)	(0029,"Silhouette Annot V1.0",36)	Silhouette Annot V1.0	41	54	f	\N	UL	1	AnnotationMarkerAttachMode	\N
2532	(0029,"Silhouette Annot V1.0",37)	(0029,"Silhouette Annot V1.0",37)	Silhouette Annot V1.0	41	55	f	\N	LT	1	AnnotationGeomColor	\N
2533	(0029,"Silhouette Annot V1.0",38)	(0029,"Silhouette Annot V1.0",38)	Silhouette Annot V1.0	41	56	f	\N	UL	1	AnnotationGeomThickness	\N
2534	(0029,"Silhouette Annot V1.0",39)	(0029,"Silhouette Annot V1.0",39)	Silhouette Annot V1.0	41	57	f	\N	UL	1	AnnotationGeomLineStyle	\N
2535	(0029,"Silhouette Annot V1.0",40)	(0029,"Silhouette Annot V1.0",40)	Silhouette Annot V1.0	41	64	f	\N	UL	1	AnnotationGeomDashLength	\N
2536	(0029,"Silhouette Annot V1.0",41)	(0029,"Silhouette Annot V1.0",41)	Silhouette Annot V1.0	41	65	f	\N	UL	1	AnnotationGeomFillPattern	\N
2537	(0029,"Silhouette Annot V1.0",42)	(0029,"Silhouette Annot V1.0",42)	Silhouette Annot V1.0	41	66	f	\N	UL	1	AnnotationInteractivity	\N
2538	(0029,"Silhouette Annot V1.0",43)	(0029,"Silhouette Annot V1.0",43)	Silhouette Annot V1.0	41	67	f	\N	FD	1	AnnotationArrowLength	\N
2539	(0029,"Silhouette Annot V1.0",44)	(0029,"Silhouette Annot V1.0",44)	Silhouette Annot V1.0	41	68	f	\N	FD	1	AnnotationArrowAngle	\N
2540	(0029,"Silhouette Annot V1.0",45)	(0029,"Silhouette Annot V1.0",45)	Silhouette Annot V1.0	41	69	f	\N	UL	1	AnnotationDontSave	\N
2541	(0029,"Silhouette Graphics Export V1.0",00)	(0029,"Silhouette Graphics Export V1.0",00)	Silhouette Graphics Export V1.0	41	0	f	\N	UI	1	Unknown	\N
2542	(0029,"Silhouette Line V1.0",11)	(0029,"Silhouette Line V1.0",11)	Silhouette Line V1.0	41	17	f	\N	IS	1	LineName	\N
2543	(0029,"Silhouette Line V1.0",12)	(0029,"Silhouette Line V1.0",12)	Silhouette Line V1.0	41	18	f	\N	LT	1	LineNameFont	\N
2544	(0029,"Silhouette Line V1.0",13)	(0029,"Silhouette Line V1.0",13)	Silhouette Line V1.0	41	19	f	\N	UL	1	LineNameDisplay	\N
2545	(0029,"Silhouette Line V1.0",14)	(0029,"Silhouette Line V1.0",14)	Silhouette Line V1.0	41	20	f	\N	LT	1	LineNormalColor	\N
2546	(0029,"Silhouette Line V1.0",15)	(0029,"Silhouette Line V1.0",15)	Silhouette Line V1.0	41	21	f	\N	UL	1	LineType	\N
2547	(0029,"Silhouette Line V1.0",16)	(0029,"Silhouette Line V1.0",16)	Silhouette Line V1.0	41	22	f	\N	UL	1	LineThickness	\N
2548	(0029,"Silhouette Line V1.0",17)	(0029,"Silhouette Line V1.0",17)	Silhouette Line V1.0	41	23	f	\N	UL	1	LineStyle	\N
2549	(0029,"Silhouette Line V1.0",18)	(0029,"Silhouette Line V1.0",18)	Silhouette Line V1.0	41	24	f	\N	UL	1	LineDashLength	\N
2550	(0029,"Silhouette Line V1.0",19)	(0029,"Silhouette Line V1.0",19)	Silhouette Line V1.0	41	25	f	\N	UL	1	LineInteractivity	\N
2551	(0029,"Silhouette Line V1.0",20)	(0029,"Silhouette Line V1.0",20)	Silhouette Line V1.0	41	32	f	\N	LT	1	LineMeasurementColor	\N
2552	(0029,"Silhouette Line V1.0",21)	(0029,"Silhouette Line V1.0",21)	Silhouette Line V1.0	41	33	f	\N	LT	1	LineMeasurementFont	\N
2553	(0029,"Silhouette Line V1.0",22)	(0029,"Silhouette Line V1.0",22)	Silhouette Line V1.0	41	34	f	\N	UL	1	LineMeasurementDashLength	\N
2554	(0029,"Silhouette Line V1.0",23)	(0029,"Silhouette Line V1.0",23)	Silhouette Line V1.0	41	35	f	\N	UL	1	LinePointSpace	\N
2555	(0029,"Silhouette Line V1.0",24)	(0029,"Silhouette Line V1.0",24)	Silhouette Line V1.0	41	36	f	\N	FD	1	LinePoints	\N
2556	(0029,"Silhouette Line V1.0",25)	(0029,"Silhouette Line V1.0",25)	Silhouette Line V1.0	41	37	f	\N	UL	1	LineControlPointSize	\N
2557	(0029,"Silhouette Line V1.0",26)	(0029,"Silhouette Line V1.0",26)	Silhouette Line V1.0	41	38	f	\N	UL	1	LineControlPointSpace	\N
2558	(0029,"Silhouette Line V1.0",27)	(0029,"Silhouette Line V1.0",27)	Silhouette Line V1.0	41	39	f	\N	FD	1	LineControlPoints	\N
2559	(0029,"Silhouette Line V1.0",28)	(0029,"Silhouette Line V1.0",28)	Silhouette Line V1.0	41	40	f	\N	LT	1	LineLabel	\N
2560	(0029,"Silhouette Line V1.0",29)	(0029,"Silhouette Line V1.0",29)	Silhouette Line V1.0	41	41	f	\N	UL	1	LineDontSave	\N
2561	(0029,"Silhouette ROI V1.0",11)	(0029,"Silhouette ROI V1.0",11)	Silhouette ROI V1.0	41	17	f	\N	IS	1	ROIName	\N
2562	(0029,"Silhouette ROI V1.0",12)	(0029,"Silhouette ROI V1.0",12)	Silhouette ROI V1.0	41	18	f	\N	LT	1	ROINameFont	\N
2563	(0029,"Silhouette ROI V1.0",13)	(0029,"Silhouette ROI V1.0",13)	Silhouette ROI V1.0	41	19	f	\N	LT	1	ROINormalColor	\N
2564	(0029,"Silhouette ROI V1.0",14)	(0029,"Silhouette ROI V1.0",14)	Silhouette ROI V1.0	41	20	f	\N	UL	1	ROIFillPattern	\N
2565	(0029,"Silhouette ROI V1.0",15)	(0029,"Silhouette ROI V1.0",15)	Silhouette ROI V1.0	41	21	f	\N	UL	1	ROIBpSeg	\N
2566	(0029,"Silhouette ROI V1.0",16)	(0029,"Silhouette ROI V1.0",16)	Silhouette ROI V1.0	41	22	f	\N	UN	1	ROIBpSegPairs	\N
2567	(0029,"Silhouette ROI V1.0",17)	(0029,"Silhouette ROI V1.0",17)	Silhouette ROI V1.0	41	23	f	\N	UL	1	ROISeedSpace	\N
2568	(0029,"Silhouette ROI V1.0",18)	(0029,"Silhouette ROI V1.0",18)	Silhouette ROI V1.0	41	24	f	\N	UN	1	ROISeeds	\N
2569	(0029,"Silhouette ROI V1.0",19)	(0029,"Silhouette ROI V1.0",19)	Silhouette ROI V1.0	41	25	f	\N	UL	1	ROILineThickness	\N
2570	(0029,"Silhouette ROI V1.0",20)	(0029,"Silhouette ROI V1.0",20)	Silhouette ROI V1.0	41	32	f	\N	UL	1	ROILineStyle	\N
2571	(0029,"Silhouette ROI V1.0",21)	(0029,"Silhouette ROI V1.0",21)	Silhouette ROI V1.0	41	33	f	\N	UL	1	ROILineDashLength	\N
2572	(0029,"Silhouette ROI V1.0",22)	(0029,"Silhouette ROI V1.0",22)	Silhouette ROI V1.0	41	34	f	\N	UL	1	ROIInteractivity	\N
2573	(0029,"Silhouette ROI V1.0",23)	(0029,"Silhouette ROI V1.0",23)	Silhouette ROI V1.0	41	35	f	\N	UL	1	ROINamePosition	\N
2574	(0029,"Silhouette ROI V1.0",24)	(0029,"Silhouette ROI V1.0",24)	Silhouette ROI V1.0	41	36	f	\N	UL	1	ROINameDisplay	\N
2575	(0029,"Silhouette ROI V1.0",25)	(0029,"Silhouette ROI V1.0",25)	Silhouette ROI V1.0	41	37	f	\N	LT	1	ROILabel	\N
2576	(0029,"Silhouette ROI V1.0",26)	(0029,"Silhouette ROI V1.0",26)	Silhouette ROI V1.0	41	38	f	\N	UL	1	ROIShape	\N
2577	(0029,"Silhouette ROI V1.0",27)	(0029,"Silhouette ROI V1.0",27)	Silhouette ROI V1.0	41	39	f	\N	FD	1	ROIShapeTilt	\N
2578	(0029,"Silhouette ROI V1.0",28)	(0029,"Silhouette ROI V1.0",28)	Silhouette ROI V1.0	41	40	f	\N	UL	1	ROIShapePointsCount	\N
2579	(0029,"Silhouette ROI V1.0",29)	(0029,"Silhouette ROI V1.0",29)	Silhouette ROI V1.0	41	41	f	\N	UL	1	ROIShapePointsSpace	\N
2580	(0029,"Silhouette ROI V1.0",30)	(0029,"Silhouette ROI V1.0",30)	Silhouette ROI V1.0	41	48	f	\N	FD	1	ROIShapePoints	\N
2581	(0029,"Silhouette ROI V1.0",31)	(0029,"Silhouette ROI V1.0",31)	Silhouette ROI V1.0	41	49	f	\N	UL	1	ROIShapeControlPointsCount	\N
2582	(0029,"Silhouette ROI V1.0",32)	(0029,"Silhouette ROI V1.0",32)	Silhouette ROI V1.0	41	50	f	\N	UL	1	ROIShapeControlPointsSpace	\N
2583	(0029,"Silhouette ROI V1.0",33)	(0029,"Silhouette ROI V1.0",33)	Silhouette ROI V1.0	41	51	f	\N	FD	1	ROIShapeControlPoints	\N
2584	(0029,"Silhouette ROI V1.0",34)	(0029,"Silhouette ROI V1.0",34)	Silhouette ROI V1.0	41	52	f	\N	UL	1	ROIDontSave	\N
2585	(0029,"Silhouette Sequence Ids V1.0",41)	(0029,"Silhouette Sequence Ids V1.0",41)	Silhouette Sequence Ids V1.0	41	65	f	\N	SQ	1	Unknown	\N
2586	(0029,"Silhouette Sequence Ids V1.0",42)	(0029,"Silhouette Sequence Ids V1.0",42)	Silhouette Sequence Ids V1.0	41	66	f	\N	SQ	1	Unknown	\N
2587	(0029,"Silhouette Sequence Ids V1.0",43)	(0029,"Silhouette Sequence Ids V1.0",43)	Silhouette Sequence Ids V1.0	41	67	f	\N	SQ	1	Unknown	\N
2588	(0029,"Silhouette V1.0",13)	(0029,"Silhouette V1.0",13)	Silhouette V1.0	41	19	f	\N	UL	1	Unknown	\N
2589	(0029,"Silhouette V1.0",14)	(0029,"Silhouette V1.0",14)	Silhouette V1.0	41	20	f	\N	UL	1	Unknown	\N
2590	(0029,"Silhouette V1.0",17)	(0029,"Silhouette V1.0",17)	Silhouette V1.0	41	23	f	\N	UN	1	Unknown	\N
2591	(0029,"Silhouette V1.0",18)	(0029,"Silhouette V1.0",18)	Silhouette V1.0	41	24	f	\N	UN	1	Unknown	\N
2592	(0029,"Silhouette V1.0",19)	(0029,"Silhouette V1.0",19)	Silhouette V1.0	41	25	f	\N	UL	1	Unknown	\N
2593	(0029,"Silhouette V1.0",1a)	(0029,"Silhouette V1.0",1a)	Silhouette V1.0	41	26	f	\N	UN	1	Unknown	\N
2594	(0029,"Silhouette V1.0",1b)	(0029,"Silhouette V1.0",1b)	Silhouette V1.0	41	27	f	\N	UL	1	Unknown	\N
2595	(0029,"Silhouette V1.0",1c)	(0029,"Silhouette V1.0",1c)	Silhouette V1.0	41	28	f	\N	UL	1	Unknown	\N
2596	(0029,"Silhouette V1.0",1d)	(0029,"Silhouette V1.0",1d)	Silhouette V1.0	41	29	f	\N	UN	1	Unknown	\N
2597	(0029,"Silhouette V1.0",1e)	(0029,"Silhouette V1.0",1e)	Silhouette V1.0	41	30	f	\N	UN	1	Unknown	\N
2598	(0029,"Silhouette V1.0",21)	(0029,"Silhouette V1.0",21)	Silhouette V1.0	41	33	f	\N	US	1	Unknown	\N
2599	(0029,"Silhouette V1.0",22)	(0029,"Silhouette V1.0",22)	Silhouette V1.0	41	34	f	\N	US	1	Unknown	\N
2600	(0029,"Silhouette V1.0",23)	(0029,"Silhouette V1.0",23)	Silhouette V1.0	41	35	f	\N	US	1	Unknown	\N
2601	(0029,"Silhouette V1.0",24)	(0029,"Silhouette V1.0",24)	Silhouette V1.0	41	36	f	\N	US	1	Unknown	\N
2602	(0029,"Silhouette V1.0",25)	(0029,"Silhouette V1.0",25)	Silhouette V1.0	41	37	f	\N	US	1	Unknown	\N
2603	(0029,"Silhouette V1.0",27)	(0029,"Silhouette V1.0",27)	Silhouette V1.0	41	39	f	\N	UN	1	Unknown	\N
2604	(0029,"Silhouette V1.0",28)	(0029,"Silhouette V1.0",28)	Silhouette V1.0	41	40	f	\N	UN	1	Unknown	\N
2605	(0029,"Silhouette V1.0",29)	(0029,"Silhouette V1.0",29)	Silhouette V1.0	41	41	f	\N	UN	1	Unknown	\N
2606	(0029,"Silhouette V1.0",30)	(0029,"Silhouette V1.0",30)	Silhouette V1.0	41	48	f	\N	UN	1	Unknown	\N
2607	(0029,"Silhouette V1.0",52)	(0029,"Silhouette V1.0",52)	Silhouette V1.0	41	82	f	\N	US	1	Unknown	\N
2608	(0029,"Silhouette V1.0",53)	(0029,"Silhouette V1.0",53)	Silhouette V1.0	41	83	f	\N	LT	1	Unknown	\N
2609	(0029,"Silhouette V1.0",54)	(0029,"Silhouette V1.0",54)	Silhouette V1.0	41	84	f	\N	UN	1	Unknown	\N
2610	(0029,"Silhouette V1.0",55)	(0029,"Silhouette V1.0",55)	Silhouette V1.0	41	85	f	\N	LT	1	Unknown	\N
2611	(0029,"Silhouette V1.0",56)	(0029,"Silhouette V1.0",56)	Silhouette V1.0	41	86	f	\N	LT	1	Unknown	\N
2612	(0029,"Silhouette V1.0",57)	(0029,"Silhouette V1.0",57)	Silhouette V1.0	41	87	f	\N	UN	1	Unknown	\N
2613	(0135,"SONOWAND AS",10)	(0135,"SONOWAND AS",10)	SONOWAND AS	309	16	f	\N	LO	1	UltrasoundScannerName	\N
2614	(0135,"SONOWAND AS",11)	(0135,"SONOWAND AS",11)	SONOWAND AS	309	17	f	\N	LO	1	TransducerSerial	\N
2615	(0135,"SONOWAND AS",12)	(0135,"SONOWAND AS",12)	SONOWAND AS	309	18	f	\N	LO	1	ProbeApplication	\N
2616	(0017,"SVISION",00)	(0017,"SVISION",00)	SVISION	23	0	f	\N	LO	1	ExtendedBodyPart	\N
2617	(0017,"SVISION",10)	(0017,"SVISION",10)	SVISION	23	16	f	\N	LO	1	ExtendedViewPosition	\N
2618	(0017,"SVISION",F0)	(0017,"SVISION",F0)	SVISION	23	240	f	\N	IS	1	ImagesSOPClass	\N
2619	(0019,"SVISION",00)	(0019,"SVISION",00)	SVISION	25	0	f	\N	IS	1	AECField	\N
2620	(0019,"SVISION",01)	(0019,"SVISION",01)	SVISION	25	1	f	\N	IS	1	AECFilmScreen	\N
2621	(0019,"SVISION",02)	(0019,"SVISION",02)	SVISION	25	2	f	\N	IS	1	AECDensity	\N
2622	(0019,"SVISION",10)	(0019,"SVISION",10)	SVISION	25	16	f	\N	IS	1	PatientThickness	\N
2623	(0019,"SVISION",18)	(0019,"SVISION",18)	SVISION	25	24	f	\N	IS	1	BeamDistance	\N
2624	(0019,"SVISION",20)	(0019,"SVISION",20)	SVISION	25	32	f	\N	IS	1	WorkstationNumber	\N
2625	(0019,"SVISION",28)	(0019,"SVISION",28)	SVISION	25	40	f	\N	IS	1	TubeNumber	\N
2626	(0019,"SVISION",30)	(0019,"SVISION",30)	SVISION	25	48	f	\N	IS	1	BuckyGrid	\N
2627	(0019,"SVISION",34)	(0019,"SVISION",34)	SVISION	25	52	f	\N	IS	1	Focus	\N
2628	(0019,"SVISION",38)	(0019,"SVISION",38)	SVISION	25	56	f	\N	IS	1	Child	\N
2629	(0019,"SVISION",40)	(0019,"SVISION",40)	SVISION	25	64	f	\N	IS	1	CollimatorDistanceX	\N
2630	(0019,"SVISION",41)	(0019,"SVISION",41)	SVISION	25	65	f	\N	IS	1	CollimatorDistanceY	\N
2631	(0019,"SVISION",50)	(0019,"SVISION",50)	SVISION	25	80	f	\N	IS	1	CentralBeamHeight	\N
2632	(0019,"SVISION",60)	(0019,"SVISION",60)	SVISION	25	96	f	\N	IS	1	BuckyAngle	\N
2633	(0019,"SVISION",68)	(0019,"SVISION",68)	SVISION	25	104	f	\N	IS	1	CArmAngle	\N
2634	(0019,"SVISION",69)	(0019,"SVISION",69)	SVISION	25	105	f	\N	IS	1	CollimatorAngle	\N
2635	(0019,"SVISION",70)	(0019,"SVISION",70)	SVISION	25	112	f	\N	IS	1	FilterNumber	\N
2636	(0019,"SVISION",74)	(0019,"SVISION",74)	SVISION	25	116	f	\N	LO	1	FilterMaterial1	\N
2637	(0019,"SVISION",75)	(0019,"SVISION",75)	SVISION	25	117	f	\N	LO	1	FilterMaterial2	\N
2645	(0019,"SVISION",A8)	(0019,"SVISION",A8)	SVISION	25	168	f	\N	DS	1	ExtendedXRayTubeCurrent	\N
2646	(0021,"SVISION",00)	(0021,"SVISION",00)	SVISION	33	0	f	\N	DS	1	NoiseReduction	\N
2647	(0021,"SVISION",01)	(0021,"SVISION",01)	SVISION	33	1	f	\N	DS	1	ContrastAmplification	\N
2648	(0021,"SVISION",02)	(0021,"SVISION",02)	SVISION	33	2	f	\N	DS	1	EdgeContrastBoosting	\N
2649	(0021,"SVISION",03)	(0021,"SVISION",03)	SVISION	33	3	f	\N	DS	1	LatitudeReduction	\N
2650	(0021,"SVISION",10)	(0021,"SVISION",10)	SVISION	33	16	f	\N	LO	1	FindRangeAlgorithm	\N
2651	(0021,"SVISION",11)	(0021,"SVISION",11)	SVISION	33	17	f	\N	DS	1	ThresholdCAlgorithm	\N
2652	(0021,"SVISION",20)	(0021,"SVISION",20)	SVISION	33	32	f	\N	LO	1	SensometricCurve	\N
2653	(0021,"SVISION",30)	(0021,"SVISION",30)	SVISION	33	48	f	\N	DS	1	LowerWindowOffset	\N
2654	(0021,"SVISION",31)	(0021,"SVISION",31)	SVISION	33	49	f	\N	DS	1	UpperWindowOffset	\N
2655	(0021,"SVISION",40)	(0021,"SVISION",40)	SVISION	33	64	f	\N	DS	1	MinPrintableDensity	\N
2656	(0021,"SVISION",41)	(0021,"SVISION",41)	SVISION	33	65	f	\N	DS	1	MaxPrintableDensity	\N
2657	(0021,"SVISION",90)	(0021,"SVISION",90)	SVISION	33	144	f	\N	DS	1	Brightness	\N
2658	(0021,"SVISION",91)	(0021,"SVISION",91)	SVISION	33	145	f	\N	DS	1	Contrast	\N
2659	(0021,"SVISION",92)	(0021,"SVISION",92)	SVISION	33	146	f	\N	DS	1	ShapeFactor	\N
2660	(0023,"SVISION",00)	(0023,"SVISION",00)	SVISION	35	0	f	\N	LO	1	ImageLaterality	\N
2661	(0023,"SVISION",01)	(0023,"SVISION",01)	SVISION	35	1	f	\N	IS	1	LetterPosition	\N
2662	(0023,"SVISION",02)	(0023,"SVISION",02)	SVISION	35	2	f	\N	IS	1	BurnedInAnnotation	\N
2663	(0023,"SVISION",03)	(0023,"SVISION",03)	SVISION	35	3	f	\N	LO	1	Unknown	\N
2664	(0023,"SVISION",F0)	(0023,"SVISION",F0)	SVISION	35	240	f	\N	IS	1	ImageSOPClass	\N
2665	(0025,"SVISION",00)	(0025,"SVISION",00)	SVISION	37	0	f	\N	IS	1	OriginalImage	\N
2666	(0025,"SVISION",01)	(0025,"SVISION",01)	SVISION	37	1	f	\N	IS	1	NotProcessedImage	\N
2667	(0025,"SVISION",02)	(0025,"SVISION",02)	SVISION	37	2	f	\N	IS	1	CutOutImage	\N
2668	(0025,"SVISION",03)	(0025,"SVISION",03)	SVISION	37	3	f	\N	IS	1	DuplicatedImage	\N
2669	(0025,"SVISION",04)	(0025,"SVISION",04)	SVISION	37	4	f	\N	IS	1	StoredImage	\N
2670	(0025,"SVISION",05)	(0025,"SVISION",05)	SVISION	37	5	f	\N	IS	1	RetrievedImage	\N
2671	(0025,"SVISION",06)	(0025,"SVISION",06)	SVISION	37	6	f	\N	IS	1	RemoteImage	\N
2672	(0025,"SVISION",07)	(0025,"SVISION",07)	SVISION	37	7	f	\N	IS	1	MediaStoredImage	\N
2673	(0025,"SVISION",08)	(0025,"SVISION",08)	SVISION	37	8	f	\N	IS	1	ImageState	\N
2674	(0025,"SVISION",20)	(0025,"SVISION",20)	SVISION	37	32	f	\N	LO	1	SourceImageFile	\N
2675	(0025,"SVISION",21)	(0025,"SVISION",21)	SVISION	37	33	f	\N	UI	1	Unknown	\N
2676	(0027,"SVISION",00)	(0027,"SVISION",00)	SVISION	39	0	f	\N	IS	1	NumberOfSeries	\N
2677	(0027,"SVISION",01)	(0027,"SVISION",01)	SVISION	39	1	f	\N	IS	1	NumberOfStudies	\N
2678	(0027,"SVISION",10)	(0027,"SVISION",10)	SVISION	39	16	f	\N	DT	1	OldestSeries	\N
2679	(0027,"SVISION",11)	(0027,"SVISION",11)	SVISION	39	17	f	\N	DT	1	NewestSeries	\N
2680	(0027,"SVISION",12)	(0027,"SVISION",12)	SVISION	39	18	f	\N	DT	1	OldestStudy	\N
2681	(0027,"SVISION",13)	(0027,"SVISION",13)	SVISION	39	19	f	\N	DT	1	NewestStudy	\N
2682	(0009,"TOSHIBA_MEC_1.0",01)	(0009,"TOSHIBA_MEC_1.0",01)	TOSHIBA_MEC_1.0	9	1	f	\N	LT	1	Unknown	\N
2683	(0009,"TOSHIBA_MEC_1.0",02)	(0009,"TOSHIBA_MEC_1.0",02)	TOSHIBA_MEC_1.0	9	2	f	\N	US	1-n	Unknown	\N
2684	(0009,"TOSHIBA_MEC_1.0",03)	(0009,"TOSHIBA_MEC_1.0",03)	TOSHIBA_MEC_1.0	9	3	f	\N	US	1-n	Unknown	\N
2685	(0009,"TOSHIBA_MEC_1.0",04)	(0009,"TOSHIBA_MEC_1.0",04)	TOSHIBA_MEC_1.0	9	4	f	\N	US	1-n	Unknown	\N
2686	(0011,"TOSHIBA_MEC_1.0",01)	(0011,"TOSHIBA_MEC_1.0",01)	TOSHIBA_MEC_1.0	17	1	f	\N	LT	1	Unknown	\N
2687	(0011,"TOSHIBA_MEC_1.0",02)	(0011,"TOSHIBA_MEC_1.0",02)	TOSHIBA_MEC_1.0	17	2	f	\N	US	1-n	Unknown	\N
2688	(0019,"TOSHIBA_MEC_1.0",01)	(0019,"TOSHIBA_MEC_1.0",01)	TOSHIBA_MEC_1.0	25	1	f	\N	US	1-n	Unknown	\N
2689	(0019,"TOSHIBA_MEC_1.0",02)	(0019,"TOSHIBA_MEC_1.0",02)	TOSHIBA_MEC_1.0	25	2	f	\N	US	1-n	Unknown	\N
2690	(0021,"TOSHIBA_MEC_1.0",01)	(0021,"TOSHIBA_MEC_1.0",01)	TOSHIBA_MEC_1.0	33	1	f	\N	US	1-n	Unknown	\N
2691	(0021,"TOSHIBA_MEC_1.0",02)	(0021,"TOSHIBA_MEC_1.0",02)	TOSHIBA_MEC_1.0	33	2	f	\N	US	1-n	Unknown	\N
2692	(0021,"TOSHIBA_MEC_1.0",03)	(0021,"TOSHIBA_MEC_1.0",03)	TOSHIBA_MEC_1.0	33	3	f	\N	US	1-n	Unknown	\N
2693	(7ff1,"TOSHIBA_MEC_1.0",01)	(7ff1,"TOSHIBA_MEC_1.0",01)	TOSHIBA_MEC_1.0	32753	1	f	\N	US	1-n	Unknown	\N
2694	(7ff1,"TOSHIBA_MEC_1.0",02)	(7ff1,"TOSHIBA_MEC_1.0",02)	TOSHIBA_MEC_1.0	32753	2	f	\N	US	1-n	Unknown	\N
2695	(7ff1,"TOSHIBA_MEC_1.0",03)	(7ff1,"TOSHIBA_MEC_1.0",03)	TOSHIBA_MEC_1.0	32753	3	f	\N	US	1-n	Unknown	\N
2696	(7ff1,"TOSHIBA_MEC_1.0",10)	(7ff1,"TOSHIBA_MEC_1.0",10)	TOSHIBA_MEC_1.0	32753	16	f	\N	US	1-n	Unknown	\N
2697	(0019,"TOSHIBA_MEC_CT_1.0",01)	(0019,"TOSHIBA_MEC_CT_1.0",01)	TOSHIBA_MEC_CT_1.0	25	1	f	\N	IS	1	Unknown	\N
2698	(0019,"TOSHIBA_MEC_CT_1.0",02)	(0019,"TOSHIBA_MEC_CT_1.0",02)	TOSHIBA_MEC_CT_1.0	25	2	f	\N	IS	1	Unknown	\N
2699	(0019,"TOSHIBA_MEC_CT_1.0",03)	(0019,"TOSHIBA_MEC_CT_1.0",03)	TOSHIBA_MEC_CT_1.0	25	3	f	\N	US	1-n	Unknown	\N
2700	(0019,"TOSHIBA_MEC_CT_1.0",04)	(0019,"TOSHIBA_MEC_CT_1.0",04)	TOSHIBA_MEC_CT_1.0	25	4	f	\N	LT	1	Unknown	\N
2701	(0019,"TOSHIBA_MEC_CT_1.0",05)	(0019,"TOSHIBA_MEC_CT_1.0",05)	TOSHIBA_MEC_CT_1.0	25	5	f	\N	LT	1	Unknown	\N
2702	(0019,"TOSHIBA_MEC_CT_1.0",06)	(0019,"TOSHIBA_MEC_CT_1.0",06)	TOSHIBA_MEC_CT_1.0	25	6	f	\N	US	1-n	Unknown	\N
2703	(0019,"TOSHIBA_MEC_CT_1.0",07)	(0019,"TOSHIBA_MEC_CT_1.0",07)	TOSHIBA_MEC_CT_1.0	25	7	f	\N	US	1-n	Unknown	\N
2704	(0019,"TOSHIBA_MEC_CT_1.0",08)	(0019,"TOSHIBA_MEC_CT_1.0",08)	TOSHIBA_MEC_CT_1.0	25	8	f	\N	LT	1	OrientationHeadFeet	\N
2705	(0019,"TOSHIBA_MEC_CT_1.0",09)	(0019,"TOSHIBA_MEC_CT_1.0",09)	TOSHIBA_MEC_CT_1.0	25	9	f	\N	LT	1	ViewDirection	\N
2706	(0019,"TOSHIBA_MEC_CT_1.0",0a)	(0019,"TOSHIBA_MEC_CT_1.0",0a)	TOSHIBA_MEC_CT_1.0	25	10	f	\N	LT	1	OrientationSupineProne	\N
2707	(0019,"TOSHIBA_MEC_CT_1.0",0b)	(0019,"TOSHIBA_MEC_CT_1.0",0b)	TOSHIBA_MEC_CT_1.0	25	11	f	\N	DS	1	Unknown	\N
2708	(0019,"TOSHIBA_MEC_CT_1.0",0c)	(0019,"TOSHIBA_MEC_CT_1.0",0c)	TOSHIBA_MEC_CT_1.0	25	12	f	\N	US	1-n	Unknown	\N
2709	(0019,"TOSHIBA_MEC_CT_1.0",0d)	(0019,"TOSHIBA_MEC_CT_1.0",0d)	TOSHIBA_MEC_CT_1.0	25	13	f	\N	TM	1	Time	\N
2710	(0019,"TOSHIBA_MEC_CT_1.0",0e)	(0019,"TOSHIBA_MEC_CT_1.0",0e)	TOSHIBA_MEC_CT_1.0	25	14	f	\N	DS	1	Unknown	\N
2711	(7ff1,"TOSHIBA_MEC_CT_1.0",01)	(7ff1,"TOSHIBA_MEC_CT_1.0",01)	TOSHIBA_MEC_CT_1.0	32753	1	f	\N	US	1-n	Unknown	\N
2712	(7ff1,"TOSHIBA_MEC_CT_1.0",02)	(7ff1,"TOSHIBA_MEC_CT_1.0",02)	TOSHIBA_MEC_CT_1.0	32753	2	f	\N	US	1-n	Unknown	\N
2713	(7ff1,"TOSHIBA_MEC_CT_1.0",03)	(7ff1,"TOSHIBA_MEC_CT_1.0",03)	TOSHIBA_MEC_CT_1.0	32753	3	f	\N	IS	1	Unknown	\N
2714	(7ff1,"TOSHIBA_MEC_CT_1.0",04)	(7ff1,"TOSHIBA_MEC_CT_1.0",04)	TOSHIBA_MEC_CT_1.0	32753	4	f	\N	IS	1	Unknown	\N
2715	(7ff1,"TOSHIBA_MEC_CT_1.0",05)	(7ff1,"TOSHIBA_MEC_CT_1.0",05)	TOSHIBA_MEC_CT_1.0	32753	5	f	\N	US	1-n	Unknown	\N
2716	(7ff1,"TOSHIBA_MEC_CT_1.0",07)	(7ff1,"TOSHIBA_MEC_CT_1.0",07)	TOSHIBA_MEC_CT_1.0	32753	7	f	\N	US	1-n	Unknown	\N
2717	(7ff1,"TOSHIBA_MEC_CT_1.0",08)	(7ff1,"TOSHIBA_MEC_CT_1.0",08)	TOSHIBA_MEC_CT_1.0	32753	8	f	\N	US	1-n	Unknown	\N
2718	(7ff1,"TOSHIBA_MEC_CT_1.0",09)	(7ff1,"TOSHIBA_MEC_CT_1.0",09)	TOSHIBA_MEC_CT_1.0	32753	9	f	\N	US	1-n	Unknown	\N
2719	(7ff1,"TOSHIBA_MEC_CT_1.0",0a)	(7ff1,"TOSHIBA_MEC_CT_1.0",0a)	TOSHIBA_MEC_CT_1.0	32753	10	f	\N	LT	1	Unknown	\N
2720	(7ff1,"TOSHIBA_MEC_CT_1.0",0b)	(7ff1,"TOSHIBA_MEC_CT_1.0",0b)	TOSHIBA_MEC_CT_1.0	32753	11	f	\N	US	1-n	Unknown	\N
2721	(7ff1,"TOSHIBA_MEC_CT_1.0",0c)	(7ff1,"TOSHIBA_MEC_CT_1.0",0c)	TOSHIBA_MEC_CT_1.0	32753	12	f	\N	US	1-n	Unknown	\N
2722	(7ff1,"TOSHIBA_MEC_CT_1.0",0d)	(7ff1,"TOSHIBA_MEC_CT_1.0",0d)	TOSHIBA_MEC_CT_1.0	32753	13	f	\N	US	1-n	Unknown	\N
2723	(0009,"ACUSON:1.2.840.113680.1.0:0910",00)	(0009,"ACUSON:1.2.840.113680.1.0:0910",00)	ACUSON:1.2.840.113680.1.0:0910	9	0	f	\N	IS	1	Unknown	\N
2724	(0009,"ACUSON:1.2.840.113680.1.0:0910",01)	(0009,"ACUSON:1.2.840.113680.1.0:0910",01)	ACUSON:1.2.840.113680.1.0:0910	9	1	f	\N	IS	1	Unknown	\N
2725	(0009,"ACUSON:1.2.840.113680.1.0:0910",02)	(0009,"ACUSON:1.2.840.113680.1.0:0910",02)	ACUSON:1.2.840.113680.1.0:0910	9	2	f	\N	LO	1	Patient Registration Custom Field 1	\N
2726	(0009,"ACUSON:1.2.840.113680.1.0:0910",03)	(0009,"ACUSON:1.2.840.113680.1.0:0910",03)	ACUSON:1.2.840.113680.1.0:0910	9	3	f	\N	LO	1	Patient Registration Custom Field 2	\N
2727	(0009,"ACUSON:1.2.840.113680.1.0:0910",04)	(0009,"ACUSON:1.2.840.113680.1.0:0910",04)	ACUSON:1.2.840.113680.1.0:0910	9	4	f	\N	LO	1	Indications	\N
2728	(0009,"ACUSON:1.2.840.113680.1.0:0910",0f)	(0009,"ACUSON:1.2.840.113680.1.0:0910",0f)	ACUSON:1.2.840.113680.1.0:0910	9	15	f	\N	LT	1	Unknown	\N
2729	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",02)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",02)	ACUSON:1.2.840.113680.1.0:7f10	32735	2	f	\N	US	1	Unknown	\N
2730	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0b)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0b)	ACUSON:1.2.840.113680.1.0:7f10	32735	11	f	\N	SL	1	Unknown	\N
2731	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0c)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0c)	ACUSON:1.2.840.113680.1.0:7f10	32735	12	f	\N	SL	1	Unknown	\N
2732	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",20)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",20)	ACUSON:1.2.840.113680.1.0:7f10	32735	32	f	\N	FL	1	Unknown	\N
2733	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",22)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",22)	ACUSON:1.2.840.113680.1.0:7f10	32735	34	f	\N	FL	1	Unknown	\N
2734	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",00)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",00)	ACUSON:1.2.840.113680.1.0:7f10	32735	0	f	\N	IS	1	Unknown	\N
2735	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",01)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",01)	ACUSON:1.2.840.113680.1.0:7f10	32735	1	f	\N	US	1	Unknown	\N
2736	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0d)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",0d)	ACUSON:1.2.840.113680.1.0:7f10	32735	13	f	\N	IS	1	Unknown	\N
2737	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",10)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",10)	ACUSON:1.2.840.113680.1.0:7f10	32735	16	f	\N	SH	1	Unknown	\N
2738	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",24)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",24)	ACUSON:1.2.840.113680.1.0:7f10	32735	36	f	\N	UL	1	Unknown	\N
2739	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",25)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",25)	ACUSON:1.2.840.113680.1.0:7f10	32735	37	f	\N	OB	1	Unknown	\N
2740	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",26)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",26)	ACUSON:1.2.840.113680.1.0:7f10	32735	38	f	\N	UL	1	Unknown	\N
2741	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",27)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",27)	ACUSON:1.2.840.113680.1.0:7f10	32735	39	f	\N	SL	1	Unknown	\N
2742	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",28)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",28)	ACUSON:1.2.840.113680.1.0:7f10	32735	40	f	\N	UL	1	Unknown	\N
2743	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",29)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",29)	ACUSON:1.2.840.113680.1.0:7f10	32735	41	f	\N	UL	1	Unknown	\N
2744	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2a)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2a)	ACUSON:1.2.840.113680.1.0:7f10	32735	42	f	\N	UL	1	Unknown	\N
2745	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2b)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2b)	ACUSON:1.2.840.113680.1.0:7f10	32735	43	f	\N	UL	1	Unknown	\N
2746	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2c)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",2c)	ACUSON:1.2.840.113680.1.0:7f10	32735	44	f	\N	UL	1-n	Unknown	\N
2747	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",30)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",30)	ACUSON:1.2.840.113680.1.0:7f10	32735	48	f	\N	SQ	1	Unknown	\N
2748	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",31)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",31)	ACUSON:1.2.840.113680.1.0:7f10	32735	49	f	\N	IS	1	Unknown	\N
2749	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",32)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",32)	ACUSON:1.2.840.113680.1.0:7f10	32735	50	f	\N	IS	1	Unknown	\N
2750	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",33)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",33)	ACUSON:1.2.840.113680.1.0:7f10	32735	51	f	\N	FL	1	Unknown	\N
2751	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",34)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",34)	ACUSON:1.2.840.113680.1.0:7f10	32735	52	f	\N	FL	1	Unknown	\N
2752	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",35)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",35)	ACUSON:1.2.840.113680.1.0:7f10	32735	53	f	\N	IS	1	Unknown	\N
2753	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",36)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",36)	ACUSON:1.2.840.113680.1.0:7f10	32735	54	f	\N	IS	1	Unknown	\N
2754	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",37)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",37)	ACUSON:1.2.840.113680.1.0:7f10	32735	55	f	\N	FL	1	Unknown	\N
2968	(0087,"AGFA-AG_HPState",02)	(0087,"AGFA-AG_HPState",02)	AGFA-AG_HPState	135	2	f	\N	LO	1	Unknown	\N
2755	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",38)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",38)	ACUSON:1.2.840.113680.1.0:7f10	32735	56	f	\N	IS	1	Unknown	\N
2756	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",50)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",50)	ACUSON:1.2.840.113680.1.0:7f10	32735	80	f	\N	SH	1	Unknown	\N
2757	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",52)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",52)	ACUSON:1.2.840.113680.1.0:7f10	32735	82	f	\N	IS	1	Unknown	\N
2758	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",54)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",54)	ACUSON:1.2.840.113680.1.0:7f10	32735	84	f	\N	IS	1	Unknown	\N
2759	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",60)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",60)	ACUSON:1.2.840.113680.1.0:7f10	32735	96	f	\N	SL	1	Unknown	\N
2760	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",61)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",61)	ACUSON:1.2.840.113680.1.0:7f10	32735	97	f	\N	SL	1	Unknown	\N
2761	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",62)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",62)	ACUSON:1.2.840.113680.1.0:7f10	32735	98	f	\N	FD	1	Unknown	\N
2762	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",63)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",63)	ACUSON:1.2.840.113680.1.0:7f10	32735	99	f	\N	FD	1	Unknown	\N
2763	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",64)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",64)	ACUSON:1.2.840.113680.1.0:7f10	32735	100	f	\N	FD	1	Unknown	\N
2764	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",65)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",65)	ACUSON:1.2.840.113680.1.0:7f10	32735	101	f	\N	LO	1	Unknown	\N
2765	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",66)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",66)	ACUSON:1.2.840.113680.1.0:7f10	32735	102	f	\N	LO	1	Unknown	\N
2766	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",67)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",67)	ACUSON:1.2.840.113680.1.0:7f10	32735	103	f	\N	SL	1	Unknown	\N
2767	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",68)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",68)	ACUSON:1.2.840.113680.1.0:7f10	32735	104	f	\N	UL	1	Unknown	\N
2768	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",69)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",69)	ACUSON:1.2.840.113680.1.0:7f10	32735	105	f	\N	UL	1	Unknown	\N
2769	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6a)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6a)	ACUSON:1.2.840.113680.1.0:7f10	32735	106	f	\N	UL	1	Unknown	\N
2770	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6b)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6b)	ACUSON:1.2.840.113680.1.0:7f10	32735	107	f	\N	UL	1	Unknown	\N
2771	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6c)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",6c)	ACUSON:1.2.840.113680.1.0:7f10	32735	108	f	\N	UL	1	Unknown	\N
2772	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",72)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",72)	ACUSON:1.2.840.113680.1.0:7f10	32735	114	f	\N	LO	1	Unknown	\N
2773	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",73)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",73)	ACUSON:1.2.840.113680.1.0:7f10	32735	115	f	\N	FD	1	Unknown	\N
2774	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",74)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",74)	ACUSON:1.2.840.113680.1.0:7f10	32735	116	f	\N	UL	1	Unknown	\N
2775	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",75)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",75)	ACUSON:1.2.840.113680.1.0:7f10	32735	117	f	\N	LO	1	Unknown	\N
2776	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",76)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",76)	ACUSON:1.2.840.113680.1.0:7f10	32735	118	f	\N	SL	1	Unknown	\N
2777	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",77)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",77)	ACUSON:1.2.840.113680.1.0:7f10	32735	119	f	\N	UL	1	Unknown	\N
2778	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",78)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",78)	ACUSON:1.2.840.113680.1.0:7f10	32735	120	f	\N	UL	1	Unknown	\N
2779	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",79)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",79)	ACUSON:1.2.840.113680.1.0:7f10	32735	121	f	\N	UL	1	Unknown	\N
2780	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7a)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7a)	ACUSON:1.2.840.113680.1.0:7f10	32735	122	f	\N	LO	1	Unknown	\N
2781	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7b)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7b)	ACUSON:1.2.840.113680.1.0:7f10	32735	123	f	\N	LO	1	Unknown	\N
2782	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7c)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7c)	ACUSON:1.2.840.113680.1.0:7f10	32735	124	f	\N	LO	1	Unknown	\N
2783	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7d)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7d)	ACUSON:1.2.840.113680.1.0:7f10	32735	125	f	\N	LO	1	Unknown	\N
2784	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7e)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7e)	ACUSON:1.2.840.113680.1.0:7f10	32735	126	f	\N	SL	1	Unknown	\N
2785	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7f)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",7f)	ACUSON:1.2.840.113680.1.0:7f10	32735	127	f	\N	SL	1	Unknown	\N
2786	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",80)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",80)	ACUSON:1.2.840.113680.1.0:7f10	32735	128	f	\N	UL	1-n	Unknown	\N
2787	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",81)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",81)	ACUSON:1.2.840.113680.1.0:7f10	32735	129	f	\N	OB	1	Unknown	\N
2788	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",82)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",82)	ACUSON:1.2.840.113680.1.0:7f10	32735	130	f	\N	UL	1	Unknown	\N
2789	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",83)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",83)	ACUSON:1.2.840.113680.1.0:7f10	32735	131	f	\N	UL	1	Unknown	\N
2790	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",85)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",85)	ACUSON:1.2.840.113680.1.0:7f10	32735	133	f	\N	OB	1	Unknown	\N
2791	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",89)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",89)	ACUSON:1.2.840.113680.1.0:7f10	32735	137	f	\N	OB	1	Unknown	\N
2792	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8a)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8a)	ACUSON:1.2.840.113680.1.0:7f10	32735	138	f	\N	FD	1	Unknown	\N
2793	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8b)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8b)	ACUSON:1.2.840.113680.1.0:7f10	32735	139	f	\N	UL	1	Unknown	\N
2794	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8c)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8c)	ACUSON:1.2.840.113680.1.0:7f10	32735	140	f	\N	UL	1	Unknown	\N
2795	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8d)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",8d)	ACUSON:1.2.840.113680.1.0:7f10	32735	141	f	\N	OB	1	Unknown	\N
2796	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",86)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",86)	ACUSON:1.2.840.113680.1.0:7f10	32735	134	f	\N	OB	1	Unknown	\N
2797	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",88)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",88)	ACUSON:1.2.840.113680.1.0:7f10	32735	136	f	\N	FD	1	Unknown	\N
2969	(0087,"AGFA-AG_HPState",03)	(0087,"AGFA-AG_HPState",03)	AGFA-AG_HPState	135	3	f	\N	SL	2	Unknown	\N
2798	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",f1)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",f1)	ACUSON:1.2.840.113680.1.0:7f10	32735	241	f	\N	UL	1-n	Unknown	\N
2799	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",f5)	(7fdf,"ACUSON:1.2.840.113680.1.0:7f10",f5)	ACUSON:1.2.840.113680.1.0:7f10	32735	245	f	\N	IS	1	Unknown	\N
2800	(7fdf,"ACUSON:1.2.840.113680.1.0:7ffe",00)	(7fdf,"ACUSON:1.2.840.113680.1.0:7ffe",00)	ACUSON:1.2.840.113680.1.0:7ffe	32735	0	f	\N	OB	1	Unknown	\N
2801	(0011,"AgilityRuntime",20)	(0011,"AgilityRuntime",20)	AgilityRuntime	17	32	f	\N	LO	1	Unknown	\N
2802	(0011,"AgilityRuntime",21)	(0011,"AgilityRuntime",21)	AgilityRuntime	17	33	f	\N	LO	1	Unknown	\N
2803	(0011,"AgilityRuntime",22)	(0011,"AgilityRuntime",22)	AgilityRuntime	17	34	f	\N	LO	1	Unknown	\N
2804	(0011,"AGFA-AG_HPState",11)	(0011,"AGFA-AG_HPState",11)	AGFA-AG_HPState	17	17	f	\N	SH	1	Unknown	\N
2805	(0019,"AGFA-AG_HPState",a0)	(0019,"AGFA-AG_HPState",a0)	AGFA-AG_HPState	25	160	f	\N	SQ	1	Unknown	\N
2806	(0019,"AGFA-AG_HPState",a1)	(0019,"AGFA-AG_HPState",a1)	AGFA-AG_HPState	25	161	f	\N	FL	1	Unknown	\N
2807	(0019,"AGFA-AG_HPState",a2)	(0019,"AGFA-AG_HPState",a2)	AGFA-AG_HPState	25	162	f	\N	FL	1	Unknown	\N
2808	(0019,"AGFA-AG_HPState",a3)	(0019,"AGFA-AG_HPState",a3)	AGFA-AG_HPState	25	163	f	\N	FL	1	Unknown	\N
2809	(0019,"AGFA-AG_HPState",a4)	(0019,"AGFA-AG_HPState",a4)	AGFA-AG_HPState	25	164	f	\N	FL	1	Unknown	\N
2810	(0019,"AGFA",05)	(0019,"AGFA",05)	AGFA	25	5	f	\N	ST	1	Cassette Data Stream	\N
2811	(0019,"AGFA",10)	(0019,"AGFA",10)	AGFA	25	16	f	\N	ST	1	Image Processing Parameters	\N
2812	(0019,"AGFA",11)	(0019,"AGFA",11)	AGFA	25	17	f	\N	LO	1	Identification Data	\N
2813	(0019,"AGFA",13)	(0019,"AGFA",13)	AGFA	25	19	f	\N	LO	1	Sensitometry Name	\N
2814	(0019,"AGFA",14)	(0019,"AGFA",14)	AGFA	25	20	f	\N	ST	1	Window Level List	\N
2815	(0019,"AGFA",15)	(0019,"AGFA",15)	AGFA	25	21	f	\N	LO	1	Dose Monitoring	\N
2816	(0019,"AGFA",16)	(0019,"AGFA",16)	AGFA	25	22	f	\N	LO	1	Other Info	\N
2817	(0019,"AGFA",1a)	(0019,"AGFA",1a)	AGFA	25	26	f	\N	LO	1	Clipped Exposure Deviation	\N
2818	(0019,"AGFA",1b)	(0019,"AGFA",1b)	AGFA	25	27	f	\N	LO	1	Logarithmic PLT Full Scale	\N
2819	(0019,"AGFA",60)	(0019,"AGFA",60)	AGFA	25	96	f	\N	US	1	Total Number Series	\N
2820	(0019,"AGFA",61)	(0019,"AGFA",61)	AGFA	25	97	f	\N	SH	1	Session Number	\N
2821	(0019,"AGFA",62)	(0019,"AGFA",62)	AGFA	25	98	f	\N	SH	1	ID Station Name	\N
2822	(0019,"AGFA",65)	(0019,"AGFA",65)	AGFA	25	101	f	\N	US	1	Number of Images in Study to be Transmitted	\N
2823	(0019,"AGFA",70)	(0019,"AGFA",70)	AGFA	25	112	f	\N	US	1	Total Number Images	\N
2824	(0019,"AGFA",80)	(0019,"AGFA",80)	AGFA	25	128	f	\N	ST	1	Geometrical Transformations	\N
2825	(0019,"AGFA",81)	(0019,"AGFA",81)	AGFA	25	129	f	\N	ST	1	Roam Origin	\N
2826	(0019,"AGFA",82)	(0019,"AGFA",82)	AGFA	25	130	f	\N	US	1	Zoom Factor	\N
2827	(0019,"AGFA",93)	(0019,"AGFA",93)	AGFA	25	147	f	\N	CS	1	Status	\N
2828	(0019,"AGFA_ADC_Compact",30)	(0019,"AGFA_ADC_Compact",30)	AGFA_ADC_Compact	25	48	f	\N	ST	1	Data stream from cassette	\N
2829	(0019,"AGFA_ADC_Compact",40)	(0019,"AGFA_ADC_Compact",40)	AGFA_ADC_Compact	25	64	f	\N	ST	1	Set of destination Ids	\N
2830	(0019,"AGFA_ADC_Compact",50)	(0019,"AGFA_ADC_Compact",50)	AGFA_ADC_Compact	25	80	f	\N	ST	1	Set of processing codes	\N
2831	(0019,"AGFA_ADC_Compact",60)	(0019,"AGFA_ADC_Compact",60)	AGFA_ADC_Compact	25	96	f	\N	US	1	Number of series in study	\N
2832	(0019,"AGFA_ADC_Compact",61)	(0019,"AGFA_ADC_Compact",61)	AGFA_ADC_Compact	25	97	f	\N	US	1	Session Number	\N
2833	(0019,"AGFA_ADC_Compact",62)	(0019,"AGFA_ADC_Compact",62)	AGFA_ADC_Compact	25	98	f	\N	SH	1	ID station name	\N
2834	(0019,"AGFA_ADC_Compact",70)	(0019,"AGFA_ADC_Compact",70)	AGFA_ADC_Compact	25	112	f	\N	US	1	Number of images in series	\N
2835	(0019,"AGFA_ADC_Compact",71)	(0019,"AGFA_ADC_Compact",71)	AGFA_ADC_Compact	25	113	f	\N	US	1	Break condition	\N
2836	(0019,"AGFA_ADC_Compact",72)	(0019,"AGFA_ADC_Compact",72)	AGFA_ADC_Compact	25	114	f	\N	US	1	Wait (or Hold) flag	\N
2837	(0019,"AGFA_ADC_Compact",73)	(0019,"AGFA_ADC_Compact",73)	AGFA_ADC_Compact	25	115	f	\N	US	1	ScanRes flag	\N
2838	(0019,"AGFA_ADC_Compact",74)	(0019,"AGFA_ADC_Compact",74)	AGFA_ADC_Compact	25	116	f	\N	SH	1	Operation code	\N
2839	(0019,"AGFA_ADC_Compact",95)	(0019,"AGFA_ADC_Compact",95)	AGFA_ADC_Compact	25	149	f	\N	CS	1	Image quality	\N
2840	(0019,"Agfa ADC NX",07)	(0019,"Agfa ADC NX",07)	Agfa ADC NX	25	7	f	\N	CS	1	Unknown	\N
2841	(0019,"Agfa ADC NX",09)	(0019,"Agfa ADC NX",09)	Agfa ADC NX	25	9	f	\N	SQ	1	Unknown	\N
2842	(0019,"Agfa ADC NX",21)	(0019,"Agfa ADC NX",21)	Agfa ADC NX	25	33	f	\N	FL	1	Unknown	\N
2843	(0019,"Agfa ADC NX",28)	(0019,"Agfa ADC NX",28)	Agfa ADC NX	25	40	f	\N	CS	1	Unknown	\N
2844	(0019,"Agfa ADC NX",f0)	(0019,"Agfa ADC NX",f0)	Agfa ADC NX	25	240	f	\N	LO	1	User Defined field 1	\N
2845	(0019,"Agfa ADC NX",f1)	(0019,"Agfa ADC NX",f1)	Agfa ADC NX	25	241	f	\N	LO	1	User Defined field 2	\N
2846	(0019,"Agfa ADC NX",f2)	(0019,"Agfa ADC NX",f2)	Agfa ADC NX	25	242	f	\N	LO	1	User Defined field 3	\N
2847	(0019,"Agfa ADC NX",f3)	(0019,"Agfa ADC NX",f3)	Agfa ADC NX	25	243	f	\N	LO	1	User Defined field 4	\N
2848	(0019,"Agfa ADC NX",f4)	(0019,"Agfa ADC NX",f4)	Agfa ADC NX	25	244	f	\N	LO	1	User Defined field 5	\N
2849	(0019,"Agfa ADC NX",f5)	(0019,"Agfa ADC NX",f5)	Agfa ADC NX	25	245	f	\N	CS	1	Cassette Orientation	\N
2850	(0019,"Agfa ADC NX",f6)	(0019,"Agfa ADC NX",f6)	Agfa ADC NX	25	246	f	\N	DS	1	Plate Sensitivity	\N
2851	(0019,"Agfa ADC NX",f7)	(0019,"Agfa ADC NX",f7)	Agfa ADC NX	25	247	f	\N	DS	1	Plate Erasability	\N
2852	(0019,"Agfa ADC NX",f8)	(0019,"Agfa ADC NX",f8)	Agfa ADC NX	25	248	f	\N	IS	1	Unknown	\N
2853	(0019,"Agfa ADC NX",fa)	(0019,"Agfa ADC NX",fa)	Agfa ADC NX	25	250	f	\N	IS	1	Unknown	\N
2854	(0019,"Agfa ADC NX",fc)	(0019,"Agfa ADC NX",fc)	Agfa ADC NX	25	252	f	\N	IS	1	Unknown	\N
2855	(0019,"Agfa ADC NX",fd)	(0019,"Agfa ADC NX",fd)	Agfa ADC NX	25	253	f	\N	CS	1	Unknown	\N
2856	(0019,"Agfa ADC NX",fe)	(0019,"Agfa ADC NX",fe)	Agfa ADC NX	25	254	f	\N	CS	1	Unknown	\N
2857	(0031,"AGFA PACS Archive Mirroring 1.0",00)	(0031,"AGFA PACS Archive Mirroring 1.0",00)	AGFA PACS Archive Mirroring 1.0	49	0	f	\N	CS	1	Unknown	\N
2858	(0031,"AGFA PACS Archive Mirroring 1.0",01)	(0031,"AGFA PACS Archive Mirroring 1.0",01)	AGFA PACS Archive Mirroring 1.0	49	1	f	\N	UL	1	Unknown	\N
2859	(0029,"MITRA PRESENTATION 1.0",00)	(0029,"MITRA PRESENTATION 1.0",00)	MITRA PRESENTATION 1.0	41	0	f	\N	CS	1	Rotation	\N
2860	(0029,"MITRA PRESENTATION 1.0",01)	(0029,"MITRA PRESENTATION 1.0",01)	MITRA PRESENTATION 1.0	41	1	f	\N	LO	1	Window Width	\N
2861	(0029,"MITRA PRESENTATION 1.0",02)	(0029,"MITRA PRESENTATION 1.0",02)	MITRA PRESENTATION 1.0	41	2	f	\N	LO	1	Window Centre	\N
2862	(0029,"MITRA PRESENTATION 1.0",03)	(0029,"MITRA PRESENTATION 1.0",03)	MITRA PRESENTATION 1.0	41	3	f	\N	IS	1	Invert	\N
2863	(0029,"MITRA PRESENTATION 1.0",04)	(0029,"MITRA PRESENTATION 1.0",04)	MITRA PRESENTATION 1.0	41	4	f	\N	IS	1	Has Tabstop	\N
2864	(0029,"MITRA PRESENTATION 1.0",05)	(0029,"MITRA PRESENTATION 1.0",05)	MITRA PRESENTATION 1.0	41	5	f	\N	CS	1	Smooth Rotation	\N
2865	(0029,"MITRA PRESENTATION 1.0",10)	(0029,"MITRA PRESENTATION 1.0",10)	MITRA PRESENTATION 1.0	41	16	f	\N	CS	1	Unknown	\N
2866	(0029,"MITRA PRESENTATION 1.0",11)	(0029,"MITRA PRESENTATION 1.0",11)	MITRA PRESENTATION 1.0	41	17	f	\N	CS	1	Unknown	\N
2867	(0029,"MITRA PRESENTATION 1.0",12)	(0029,"MITRA PRESENTATION 1.0",12)	MITRA PRESENTATION 1.0	41	18	f	\N	CS	1	Unknown	\N
2868	(0029,"MITRA PRESENTATION 1.0",13)	(0029,"MITRA PRESENTATION 1.0",13)	MITRA PRESENTATION 1.0	41	19	f	\N	CS	1	Unknown	\N
2869	(0029,"MITRA OBJECT DOCUMENT 1.0",00)	(0029,"MITRA OBJECT DOCUMENT 1.0",00)	MITRA OBJECT DOCUMENT 1.0	41	0	f	\N	OB	1	IMPAX Object Document	\N
2870	(0029,"MITRA OBJECT DOCUMENT 1.0",01)	(0029,"MITRA OBJECT DOCUMENT 1.0",01)	MITRA OBJECT DOCUMENT 1.0	41	1	f	\N	OB	1	IMPAX Markup XML Stored	\N
2871	(0029,"MITRA MARKUP 1.0",00)	(0029,"MITRA MARKUP 1.0",00)	MITRA MARKUP 1.0	41	0	f	\N	OB	1-n	Markup1	\N
2872	(0029,"MITRA MARKUP 1.0",01)	(0029,"MITRA MARKUP 1.0",01)	MITRA MARKUP 1.0	41	1	f	\N	OB	1-n	Markup2	\N
2873	(0029,"MITRA MARKUP 1.0",02)	(0029,"MITRA MARKUP 1.0",02)	MITRA MARKUP 1.0	41	2	f	\N	OB	1-n	Markup3	\N
2874	(0029,"MITRA MARKUP 1.0",03)	(0029,"MITRA MARKUP 1.0",03)	MITRA MARKUP 1.0	41	3	f	\N	OB	1-n	Markup4	\N
2875	(0029,"MITRA MARKUP 1.0",04)	(0029,"MITRA MARKUP 1.0",04)	MITRA MARKUP 1.0	41	4	f	\N	OB	1-n	Markup5	\N
2876	(0029,"MITRA MARKUP 1.0",05)	(0029,"MITRA MARKUP 1.0",05)	MITRA MARKUP 1.0	41	5	f	\N	OB	1-n	Markup6	\N
2877	(0029,"MITRA MARKUP 1.0",06)	(0029,"MITRA MARKUP 1.0",06)	MITRA MARKUP 1.0	41	6	f	\N	OB	1-n	Markup7	\N
2878	(0029,"MITRA MARKUP 1.0",07)	(0029,"MITRA MARKUP 1.0",07)	MITRA MARKUP 1.0	41	7	f	\N	OB	1-n	Markup8	\N
2879	(0029,"MITRA MARKUP 1.0",08)	(0029,"MITRA MARKUP 1.0",08)	MITRA MARKUP 1.0	41	8	f	\N	OB	1-n	Markup9	\N
2880	(0029,"MITRA MARKUP 1.0",09)	(0029,"MITRA MARKUP 1.0",09)	MITRA MARKUP 1.0	41	9	f	\N	OB	1-n	Markup10	\N
2881	(0029,"MITRA MARKUP 1.0",10)	(0029,"MITRA MARKUP 1.0",10)	MITRA MARKUP 1.0	41	16	f	\N	OB	1-n	Markup11	\N
2882	(0029,"MITRA MARKUP 1.0",11)	(0029,"MITRA MARKUP 1.0",11)	MITRA MARKUP 1.0	41	17	f	\N	OB	1-n	Markup12	\N
2883	(0029,"MITRA MARKUP 1.0",12)	(0029,"MITRA MARKUP 1.0",12)	MITRA MARKUP 1.0	41	18	f	\N	OB	1-n	Markup13	\N
2884	(0029,"MITRA MARKUP 1.0",13)	(0029,"MITRA MARKUP 1.0",13)	MITRA MARKUP 1.0	41	19	f	\N	OB	1-n	Markup14	\N
2885	(0029,"MITRA MARKUP 1.0",14)	(0029,"MITRA MARKUP 1.0",14)	MITRA MARKUP 1.0	41	20	f	\N	OB	1-n	Markup14	\N
2886	(0029,"AgilityRuntime",11)	(0029,"AgilityRuntime",11)	AgilityRuntime	41	17	f	\N	CS	1	Unknown	\N
2887	(0029,"AgilityRuntime",12)	(0029,"AgilityRuntime",12)	AgilityRuntime	41	18	f	\N	US	1	Unknown	\N
2888	(0029,"AgilityRuntime",13)	(0029,"AgilityRuntime",13)	AgilityRuntime	41	19	f	\N	US	1	Unknown	\N
2889	(0029,"AgilityRuntime",14)	(0029,"AgilityRuntime",14)	AgilityRuntime	41	20	f	\N	US	1	Unknown	\N
2890	(0029,"AgilityRuntime",1f)	(0029,"AgilityRuntime",1f)	AgilityRuntime	41	31	f	\N	US	1	Unknown	\N
2891	(0031,"MITRA LINKED ATTRIBUTES 1.0",20)	(0031,"MITRA LINKED ATTRIBUTES 1.0",20)	MITRA LINKED ATTRIBUTES 1.0	49	32	f	\N	IS	1	Unknown	\N
2892	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",02)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",02)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	2	f	\N	OB	1	Unknown	\N
2893	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",04)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",04)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	4	f	\N	CS	1	Unknown	\N
2894	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",06)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",06)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	6	f	\N	OB	1	Unknown	\N
2895	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",08)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",08)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	8	f	\N	OB	1	Unknown	\N
2896	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0a)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0a)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	10	f	\N	OB	1	Unknown	\N
2897	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0c)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0c)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	12	f	\N	LO	1	Unknown	\N
2898	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0e)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0e)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	14	f	\N	OB	1	Unknown	\N
2899	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",13)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",13)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	19	f	\N	PN	1	Unknown	\N
2900	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",14)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",14)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	20	f	\N	OB	1	Unknown	\N
2901	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",15)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",15)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	21	f	\N	OB	1	Unknown	\N
2902	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",16)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",16)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	22	f	\N	PN	1	Unknown	\N
2903	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",19)	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",19)	MITRA OBJECT UTF8 ATTRIBUTES 1.0	51	25	f	\N	PN	1	Unknown	\N
2904	(0033,"MITRA OBJECT ATTRIBUTES 1.0",02)	(0033,"MITRA OBJECT ATTRIBUTES 1.0",02)	MITRA OBJECT ATTRIBUTES 1.0	51	2	f	\N	LO	1	Unknown	\N
2905	(0033,"MITRA OBJECT ATTRIBUTES 1.0",04)	(0033,"MITRA OBJECT ATTRIBUTES 1.0",04)	MITRA OBJECT ATTRIBUTES 1.0	51	4	f	\N	LO	1	Unknown	\N
2906	(0033,"MITRA OBJECT ATTRIBUTES 1.0",06)	(0033,"MITRA OBJECT ATTRIBUTES 1.0",06)	MITRA OBJECT ATTRIBUTES 1.0	51	6	f	\N	LO	1	Unknown	\N
2907	(0033,"MITRA OBJECT ATTRIBUTES 1.0",08)	(0033,"MITRA OBJECT ATTRIBUTES 1.0",08)	MITRA OBJECT ATTRIBUTES 1.0	51	8	f	\N	LO	1	Unknown	\N
2970	(0087,"AGFA-AG_HPState",04)	(0087,"AGFA-AG_HPState",04)	AGFA-AG_HPState	135	4	f	\N	SL	2	Unknown	\N
2908	(0033,"MITRA OBJECT ATTRIBUTES 1.0",0a)	(0033,"MITRA OBJECT ATTRIBUTES 1.0",0a)	MITRA OBJECT ATTRIBUTES 1.0	51	10	f	\N	LO	1	Unknown	\N
2909	(0071,"AGFA-AG_HPState",18)	(0071,"AGFA-AG_HPState",18)	AGFA-AG_HPState	113	24	f	\N	SQ	1	Unknown	\N
2910	(0071,"AGFA-AG_HPState",19)	(0071,"AGFA-AG_HPState",19)	AGFA-AG_HPState	113	25	f	\N	SQ	1	Unknown	\N
2911	(0071,"AGFA-AG_HPState",1a)	(0071,"AGFA-AG_HPState",1a)	AGFA-AG_HPState	113	26	f	\N	SQ	1	Unknown	\N
2912	(0071,"AGFA-AG_HPState",1c)	(0071,"AGFA-AG_HPState",1c)	AGFA-AG_HPState	113	28	f	\N	SQ	1	Unknown	\N
2913	(0071,"AGFA-AG_HPState",1e)	(0071,"AGFA-AG_HPState",1e)	AGFA-AG_HPState	113	30	f	\N	SQ	1	Unknown	\N
2914	(0071,"AGFA-AG_HPState",20)	(0071,"AGFA-AG_HPState",20)	AGFA-AG_HPState	113	32	f	\N	FL	1-n	Unknown	\N
2915	(0071,"AGFA-AG_HPState",21)	(0071,"AGFA-AG_HPState",21)	AGFA-AG_HPState	113	33	f	\N	FD	1-n	Unknown	\N
2916	(0071,"AGFA-AG_HPState",22)	(0071,"AGFA-AG_HPState",22)	AGFA-AG_HPState	113	34	f	\N	FD	1-n	Unknown	\N
2917	(0071,"AGFA-AG_HPState",23)	(0071,"AGFA-AG_HPState",23)	AGFA-AG_HPState	113	35	f	\N	FD	1-n	Unknown	\N
2918	(0071,"AGFA-AG_HPState",24)	(0071,"AGFA-AG_HPState",24)	AGFA-AG_HPState	113	36	f	\N	FD	1	Unknown	\N
2919	(0071,"AGFA-AG_HPState",2b)	(0071,"AGFA-AG_HPState",2b)	AGFA-AG_HPState	113	43	f	\N	FD	1-n	Unknown	\N
2920	(0071,"AGFA-AG_HPState",2c)	(0071,"AGFA-AG_HPState",2c)	AGFA-AG_HPState	113	44	f	\N	FD	3	Unknown	\N
2921	(0071,"AGFA-AG_HPState",2d)	(0071,"AGFA-AG_HPState",2d)	AGFA-AG_HPState	113	45	f	\N	FD	1	Unknown	\N
2922	(0071,"AgilityOverlay",01)	(0071,"AgilityOverlay",01)	AgilityOverlay	113	1	f	\N	ST	1	Unknown	\N
2923	(0071,"AgilityOverlay",02)	(0071,"AgilityOverlay",02)	AgilityOverlay	113	2	f	\N	ST	1	Unknown	\N
2924	(0071,"AgilityOverlay",03)	(0071,"AgilityOverlay",03)	AgilityOverlay	113	3	f	\N	ST	1	Unknown	\N
2925	(0071,"AgilityOverlay",05)	(0071,"AgilityOverlay",05)	AgilityOverlay	113	5	f	\N	ST	1	Unknown	\N
2926	(0071,"AgilityOverlay",06)	(0071,"AgilityOverlay",06)	AgilityOverlay	113	6	f	\N	SQ	1	Unknown	\N
2927	(0071,"AgilityOverlay",07)	(0071,"AgilityOverlay",07)	AgilityOverlay	113	7	f	\N	ST	1	Unknown	\N
2928	(0071,"AgilityOverlay",08)	(0071,"AgilityOverlay",08)	AgilityOverlay	113	8	f	\N	CS	1	Unknown	\N
2929	(0071,"AgilityOverlay",09)	(0071,"AgilityOverlay",09)	AgilityOverlay	113	9	f	\N	ST	1	Unknown	\N
2930	(0071,"AgilityOverlay",0a)	(0071,"AgilityOverlay",0a)	AgilityOverlay	113	10	f	\N	CS	1	Unknown	\N
2931	(0071,"AgilityOverlay",10)	(0071,"AgilityOverlay",10)	AgilityOverlay	113	16	f	\N	FL	1	Unknown	\N
2932	(0071,"AgilityOverlay",11)	(0071,"AgilityOverlay",11)	AgilityOverlay	113	17	f	\N	ST	1	Unknown	\N
2933	(0071,"AgilityOverlay",12)	(0071,"AgilityOverlay",12)	AgilityOverlay	113	18	f	\N	CS	1	Unknown	\N
2934	(0071,"AgilityOverlay",13)	(0071,"AgilityOverlay",13)	AgilityOverlay	113	19	f	\N	US	1	Unknown	\N
2935	(0071,"AgilityOverlay",14)	(0071,"AgilityOverlay",14)	AgilityOverlay	113	20	f	\N	US	1	Unknown	\N
2936	(0071,"AgilityOverlay",15)	(0071,"AgilityOverlay",15)	AgilityOverlay	113	21	f	\N	FD	1-n	Unknown	\N
2937	(0071,"AgilityOverlay",16)	(0071,"AgilityOverlay",16)	AgilityOverlay	113	22	f	\N	ST	1	Unknown	\N
2938	(0071,"AgilityOverlay",17)	(0071,"AgilityOverlay",17)	AgilityOverlay	113	23	f	\N	ST	1	Unknown	\N
2939	(0071,"AgilityOverlay",18)	(0071,"AgilityOverlay",18)	AgilityOverlay	113	24	f	\N	CS	1	Unknown	\N
2940	(0071,"AgilityOverlay",19)	(0071,"AgilityOverlay",19)	AgilityOverlay	113	25	f	\N	ST	1	Unknown	\N
2941	(0071,"AgilityOverlay",1b)	(0071,"AgilityOverlay",1b)	AgilityOverlay	113	27	f	\N	ST	1	Unknown	\N
2942	(0071,"AgilityOverlay",1c)	(0071,"AgilityOverlay",1c)	AgilityOverlay	113	28	f	\N	ST	1	Unknown	\N
2943	(0071,"AgilityOverlay",1d)	(0071,"AgilityOverlay",1d)	AgilityOverlay	113	29	f	\N	ST	1	Unknown	\N
2944	(0071,"AgilityOverlay",22)	(0071,"AgilityOverlay",22)	AgilityOverlay	113	34	f	\N	ST	1	Unknown	\N
2945	(0071,"AgilityOverlay",2c)	(0071,"AgilityOverlay",2c)	AgilityOverlay	113	44	f	\N	ST	1	Unknown	\N
2946	(0071,"AgilityOverlay",2d)	(0071,"AgilityOverlay",2d)	AgilityOverlay	113	45	f	\N	SQ	1	Unknown	\N
2947	(0071,"AgilityOverlay",2e)	(0071,"AgilityOverlay",2e)	AgilityOverlay	113	46	f	\N	US	1	Unknown	\N
2948	(0071,"AgilityOverlay",50)	(0071,"AgilityOverlay",50)	AgilityOverlay	113	80	f	\N	CS	1	Unknown	\N
2949	(0071,"AgilityOverlay",51)	(0071,"AgilityOverlay",51)	AgilityOverlay	113	81	f	\N	CS	1	Unknown	\N
2950	(0071,"AgilityOverlay",52)	(0071,"AgilityOverlay",52)	AgilityOverlay	113	82	f	\N	LT	1	Unknown	\N
2951	(0071,"AgilityOverlay",53)	(0071,"AgilityOverlay",53)	AgilityOverlay	113	83	f	\N	CS	1	Unknown	\N
2952	(0071,"AgilityOverlay",54)	(0071,"AgilityOverlay",54)	AgilityOverlay	113	84	f	\N	CS	1	Unknown	\N
2953	(0071,"AgilityOverlay",55)	(0071,"AgilityOverlay",55)	AgilityOverlay	113	85	f	\N	CS	1	Unknown	\N
2954	(0071,"AgilityOverlay",56)	(0071,"AgilityOverlay",56)	AgilityOverlay	113	86	f	\N	CS	1	Unknown	\N
2955	(0071,"AgilityOverlay",57)	(0071,"AgilityOverlay",57)	AgilityOverlay	113	87	f	\N	CS	1	Unknown	\N
2956	(0071,"AgilityOverlay",59)	(0071,"AgilityOverlay",59)	AgilityOverlay	113	89	f	\N	FL	1	Unknown	\N
2957	(0071,"AgilityOverlay",5a)	(0071,"AgilityOverlay",5a)	AgilityOverlay	113	90	f	\N	FL	1	Unknown	\N
2958	(0071,"AgilityOverlay",5b)	(0071,"AgilityOverlay",5b)	AgilityOverlay	113	91	f	\N	FL	2	Unknown	\N
2959	(0071,"AgilityOverlay",5c)	(0071,"AgilityOverlay",5c)	AgilityOverlay	113	92	f	\N	FL	4	Unknown	\N
2960	(0071,"AgilityOverlay",5d)	(0071,"AgilityOverlay",5d)	AgilityOverlay	113	93	f	\N	CS	1	Unknown	\N
2961	(0071,"AgilityOverlay",60)	(0071,"AgilityOverlay",60)	AgilityOverlay	113	96	f	\N	FD	1	Unknown	\N
2962	(0073,"AGFA-AG_HPState",23)	(0073,"AGFA-AG_HPState",23)	AGFA-AG_HPState	115	35	f	\N	SH	1	Unknown	\N
2963	(0073,"AGFA-AG_HPState",24)	(0073,"AGFA-AG_HPState",24)	AGFA-AG_HPState	115	36	f	\N	SQ	1	Unknown	\N
2964	(0073,"AGFA-AG_HPState",28)	(0073,"AGFA-AG_HPState",28)	AGFA-AG_HPState	115	40	f	\N	SQ	1	Unknown	\N
2965	(0073,"AGFA-AG_HPState",80)	(0073,"AGFA-AG_HPState",80)	AGFA-AG_HPState	115	128	f	\N	FL	1	Unknown	\N
2966	(0075,"AGFA-AG_HPState",10)	(0075,"AGFA-AG_HPState",10)	AGFA-AG_HPState	117	16	f	\N	LO	1	Unknown	\N
2967	(0087,"AGFA-AG_HPState",01)	(0087,"AGFA-AG_HPState",01)	AGFA-AG_HPState	135	1	f	\N	LO	1	Unknown	\N
2971	(0087,"AGFA-AG_HPState",05)	(0087,"AGFA-AG_HPState",05)	AGFA-AG_HPState	135	5	f	\N	FD	2	Unknown	\N
2972	(0087,"AGFA-AG_HPState",06)	(0087,"AGFA-AG_HPState",06)	AGFA-AG_HPState	135	6	f	\N	FD	2	Unknown	\N
2973	(0087,"AGFA-AG_HPState",07)	(0087,"AGFA-AG_HPState",07)	AGFA-AG_HPState	135	7	f	\N	FD	2	Unknown	\N
2974	(0087,"AGFA-AG_HPState",08)	(0087,"AGFA-AG_HPState",08)	AGFA-AG_HPState	135	8	f	\N	FD	2	Unknown	\N
2975	(0035,"AGFA KOSD 1.0",00)	(0035,"AGFA KOSD 1.0",00)	AGFA KOSD 1.0	53	0	f	\N	SH	1	Unknown	\N
2976	(0035,"AGFA KOSD 1.0",03)	(0035,"AGFA KOSD 1.0",03)	AGFA KOSD 1.0	53	3	f	\N	LT	1	Unknown	\N
2977	(2e13,"agfa/displayableImages",10)	(2e13,"agfa/displayableImages",10)	agfa/displayableImages	11795	16	f	\N	IS	1	Unknown	\N
2978	(2e13,"agfa/displayableImages",11)	(2e13,"agfa/displayableImages",11)	agfa/displayableImages	11795	17	f	\N	IS	1	Unknown	\N
2979	(7fdb,"agfa/xeroverse",99)	(7fdb,"agfa/xeroverse",99)	agfa/xeroverse	32731	153	f	\N	LO	1	Unknown	\N
2980	(0009,"Camtronics image level data",04)	(0009,"Camtronics image level data",04)	Camtronics image level data	9	4	f	\N	IS	1	Unknown	\N
2981	(0009,"Camtronics image level data",06)	(0009,"Camtronics image level data",06)	Camtronics image level data	9	6	f	\N	IS	1	Unknown	\N
2982	(0009,"Camtronics image level data",09)	(0009,"Camtronics image level data",09)	Camtronics image level data	9	9	f	\N	LO	1	Unknown	\N
2983	(0009,"Camtronics image level data",16)	(0009,"Camtronics image level data",16)	Camtronics image level data	9	22	f	\N	AE	1	Unknown	\N
2984	(0009,"Camtronics image level data",17)	(0009,"Camtronics image level data",17)	Camtronics image level data	9	23	f	\N	CS	1	Unknown	\N
2985	(0009,"Camtronics image level data",18)	(0009,"Camtronics image level data",18)	Camtronics image level data	9	24	f	\N	IS	1	Unknown	\N
2986	(0009,"QCA Results",00)	(0009,"QCA Results",00)	QCA Results	9	0	f	\N	CS	1	Analysis Type	\N
2987	(0009,"QCA Results",04)	(0009,"QCA Results",04)	QCA Results	9	4	f	\N	LO	1	Segment Name	\N
2988	(0009,"QCA Results",12)	(0009,"QCA Results",12)	QCA Results	9	18	f	\N	DS	1	Pre-procedure Catheter Size	\N
2989	(0009,"QCA Results",13)	(0009,"QCA Results",13)	QCA Results	9	19	f	\N	DS	1	Pre-procedure Reference Diameter	\N
2990	(0009,"QCA Results",14)	(0009,"QCA Results",14)	QCA Results	9	20	f	\N	DS	1	Pre-procedure Minimum Lumen Diameter	\N
2991	(0009,"QCA Results",15)	(0009,"QCA Results",15)	QCA Results	9	21	f	\N	DS	1	Pre-procedure Average Diameter	\N
2992	(0009,"QCA Results",16)	(0009,"QCA Results",16)	QCA Results	9	22	f	\N	DS	1	Pre-procedure Stenosis Length	\N
2993	(0009,"QCA Results",17)	(0009,"QCA Results",17)	QCA Results	9	23	f	\N	DS	1	Pre-procedure Stenosis %	\N
2994	(0009,"QCA Results",18)	(0009,"QCA Results",18)	QCA Results	9	24	f	\N	DS	1	Pre-procedure Geometric Area Reduction %	\N
2995	(0009,"QCA Results",22)	(0009,"QCA Results",22)	QCA Results	9	34	f	\N	DS	1	Post-procedure Catheter Size	\N
2996	(0009,"QCA Results",23)	(0009,"QCA Results",23)	QCA Results	9	35	f	\N	DS	1	Post-procedure Reference Diameter	\N
2997	(0009,"QCA Results",24)	(0009,"QCA Results",24)	QCA Results	9	36	f	\N	DS	1	Post-procedure Minimum Lumen Diameter	\N
2998	(0009,"QCA Results",25)	(0009,"QCA Results",25)	QCA Results	9	37	f	\N	DS	1	Post-procedure Average Diameter	\N
2999	(0009,"QCA Results",26)	(0009,"QCA Results",26)	QCA Results	9	38	f	\N	DS	1	Post-procedure Stenosis Length	\N
3000	(0009,"QCA Results",27)	(0009,"QCA Results",27)	QCA Results	9	39	f	\N	DS	1	Post-procedure Stenosis %	\N
3001	(0009,"QCA Results",28)	(0009,"QCA Results",28)	QCA Results	9	40	f	\N	DS	1	Post-procedure Geometric Area Reduction %	\N
3002	(0003,"ELSCINT1",01)	(0003,"ELSCINT1",01)	ELSCINT1	3	1	f	\N	OW	1	Offset List Structure	\N
3003	(00e1,"ELSCINT1",01)	(00e1,"ELSCINT1",01)	ELSCINT1	225	1	f	\N	US	1	Data Dictionary Version	\N
3004	(00e1,"ELSCINT1",05)	(00e1,"ELSCINT1",05)	ELSCINT1	225	5	f	\N	IS	1	Unknown	\N
3005	(00e1,"ELSCINT1",06)	(00e1,"ELSCINT1",06)	ELSCINT1	225	6	f	\N	IS	1	Unknown	\N
3006	(00e1,"ELSCINT1",07)	(00e1,"ELSCINT1",07)	ELSCINT1	225	7	f	\N	IS	1	Unknown	\N
3007	(00e1,"ELSCINT1",14)	(00e1,"ELSCINT1",14)	ELSCINT1	225	20	f	\N	CS	1	Unknown	\N
3008	(00e1,"ELSCINT1",18)	(00e1,"ELSCINT1",18)	ELSCINT1	225	24	f	\N	OB	1	Unknown	\N
10970	(0119,"MRSC",11a1)	(0119,"MRSC",a1)	MRSC	281	161	t	11	IS	1	PhantCalibNParms	K
3010	(00e1,"ELSCINT1",22)	(00e1,"ELSCINT1",22)	ELSCINT1	225	34	f	\N	DS	2	Presentation Relative Center	\N
3011	(00e1,"ELSCINT1",23)	(00e1,"ELSCINT1",23)	ELSCINT1	225	35	f	\N	DS	2	Presentation Relative Part	\N
3012	(00e1,"ELSCINT1",24)	(00e1,"ELSCINT1",24)	ELSCINT1	225	36	f	\N	CS	1	Unknown	\N
3013	(00e1,"ELSCINT1",25)	(00e1,"ELSCINT1",25)	ELSCINT1	225	37	f	\N	CS	1	Unknown	\N
3014	(00e1,"ELSCINT1",30)	(00e1,"ELSCINT1",30)	ELSCINT1	225	48	f	\N	UI	1	Unknown	\N
3015	(00e1,"ELSCINT1",31)	(00e1,"ELSCINT1",31)	ELSCINT1	225	49	f	\N	CS	1	Unknown	\N
3016	(00e1,"ELSCINT1",32)	(00e1,"ELSCINT1",32)	ELSCINT1	225	50	f	\N	US	2	Unknown	\N
3017	(00e1,"ELSCINT1",37)	(00e1,"ELSCINT1",37)	ELSCINT1	225	55	f	\N	DS	1	Total Dose Savings	\N
3018	(00e1,"ELSCINT1",39)	(00e1,"ELSCINT1",39)	ELSCINT1	225	57	f	\N	SQ	1	Unknown	\N
3019	(00e1,"ELSCINT1",3e)	(00e1,"ELSCINT1",3e)	ELSCINT1	225	62	f	\N	IS	1	Unknown	\N
3020	(00e1,"ELSCINT1",3f)	(00e1,"ELSCINT1",3f)	ELSCINT1	225	63	f	\N	CS	1	Unknown	\N
3021	(00e1,"ELSCINT1",40)	(00e1,"ELSCINT1",40)	ELSCINT1	225	64	f	\N	SH	1	Image Label	\N
3022	(00e1,"ELSCINT1",41)	(00e1,"ELSCINT1",41)	ELSCINT1	225	65	f	\N	DS	1	Unknown	\N
3023	(00e1,"ELSCINT1",42)	(00e1,"ELSCINT1",42)	ELSCINT1	225	66	f	\N	LO	1	Unknown	\N
3024	(00e1,"ELSCINT1",43)	(00e1,"ELSCINT1",43)	ELSCINT1	225	67	f	\N	IS	1	Unknown	\N
3025	(00e1,"ELSCINT1",50)	(00e1,"ELSCINT1",50)	ELSCINT1	225	80	f	\N	DS	1	Acquisition Duration	\N
3026	(00e1,"ELSCINT1",51)	(00e1,"ELSCINT1",51)	ELSCINT1	225	81	f	\N	SH	1	Unknown	\N
3027	(00e1,"ELSCINT1",60)	(00e1,"ELSCINT1",60)	ELSCINT1	225	96	f	\N	CS	1	Unknown	\N
3028	(00e1,"ELSCINT1",61)	(00e1,"ELSCINT1",61)	ELSCINT1	225	97	f	\N	LO	1	Protocol File Name	\N
3029	(00e1,"ELSCINT1",62)	(00e1,"ELSCINT1",62)	ELSCINT1	225	98	f	\N	CS	1	Unknown	\N
3030	(00e1,"ELSCINT1",63)	(00e1,"ELSCINT1",63)	ELSCINT1	225	99	f	\N	SH	1	Patient Language	\N
3031	(00e1,"ELSCINT1",65)	(00e1,"ELSCINT1",65)	ELSCINT1	225	101	f	\N	LO	1	Unknown	\N
3032	(00e1,"ELSCINT1",6a)	(00e1,"ELSCINT1",6a)	ELSCINT1	225	106	f	\N	IS	1	Unknown	\N
3033	(00e1,"ELSCINT1",6b)	(00e1,"ELSCINT1",6b)	ELSCINT1	225	107	f	\N	IS	1	Unknown	\N
3034	(00e1,"ELSCINT1",a0)	(00e1,"ELSCINT1",a0)	ELSCINT1	225	160	f	\N	LO	1	Unknown	\N
3036	(00e1,"ELSCINT1",c4)	(00e1,"ELSCINT1",c4)	ELSCINT1	225	196	f	\N	DS	1	Unknown	\N
3037	(00e1,"ELSCINT1",cf)	(00e1,"ELSCINT1",cf)	ELSCINT1	225	207	f	\N	IS	1	Unknown	\N
3038	(00e1,"ELSCINT1",eb)	(00e1,"ELSCINT1",eb)	ELSCINT1	225	235	f	\N	US	1	Unknown	\N
3039	(00e1,"ELSCINT1",ec)	(00e1,"ELSCINT1",ec)	ELSCINT1	225	236	f	\N	US	1	Unknown	\N
3040	(01e1,"ELSCINT1",18)	(01e1,"ELSCINT1",18)	ELSCINT1	481	24	f	\N	OB	1	Unknown	\N
3041	(01e1,"ELSCINT1",21)	(01e1,"ELSCINT1",21)	ELSCINT1	481	33	f	\N	ST	1	Unknown	\N
3042	(01e1,"ELSCINT1",26)	(01e1,"ELSCINT1",26)	ELSCINT1	481	38	f	\N	CS	1	Phantom Type	\N
3043	(01e1,"ELSCINT1",34)	(01e1,"ELSCINT1",34)	ELSCINT1	481	52	f	\N	IS	1	Unknown	\N
3044	(01e1,"ELSCINT1",40)	(01e1,"ELSCINT1",40)	ELSCINT1	481	64	f	\N	UI	1	Unknown	\N
3045	(01e1,"ELSCINT1",41)	(01e1,"ELSCINT1",41)	ELSCINT1	481	65	f	\N	OW	1	Unknown	\N
3046	(01f1,"ELSCINT1",01)	(01f1,"ELSCINT1",01)	ELSCINT1	497	1	f	\N	CS	1	Acquisition Type	\N
3047	(01f1,"ELSCINT1",02)	(01f1,"ELSCINT1",02)	ELSCINT1	497	2	f	\N	CS	1	Focal Spot Resolution	\N
3048	(01f1,"ELSCINT1",03)	(01f1,"ELSCINT1",03)	ELSCINT1	497	3	f	\N	CS	1	Concurrent Slices Generation	\N
3049	(01f1,"ELSCINT1",04)	(01f1,"ELSCINT1",04)	ELSCINT1	497	4	f	\N	CS	1	Angular Sampling Density	\N
3050	(01f1,"ELSCINT1",05)	(01f1,"ELSCINT1",05)	ELSCINT1	497	5	f	\N	DS	1	Reconstruction Arc	\N
3051	(01f1,"ELSCINT1",07)	(01f1,"ELSCINT1",07)	ELSCINT1	497	7	f	\N	DS	1	Table Velocity	\N
3052	(01f1,"ELSCINT1",08)	(01f1,"ELSCINT1",08)	ELSCINT1	497	8	f	\N	DS	1	Acquisition Length	\N
3053	(01f1,"ELSCINT1",0a)	(01f1,"ELSCINT1",0a)	ELSCINT1	497	10	f	\N	US	1	Edge Enhancement Weight	\N
3054	(01f1,"ELSCINT1",0c)	(01f1,"ELSCINT1",0c)	ELSCINT1	497	12	f	\N	DS	1	Scanner Relative Center	\N
3055	(01f1,"ELSCINT1",0d)	(01f1,"ELSCINT1",0d)	ELSCINT1	497	13	f	\N	DS	1	Rotation Angle	\N
3056	(01f1,"ELSCINT1",0e)	(01f1,"ELSCINT1",0e)	ELSCINT1	497	14	f	\N	FL	1	Unknown	\N
3057	(01f1,"ELSCINT1",26)	(01f1,"ELSCINT1",26)	ELSCINT1	497	38	f	\N	DS	1	Pitch	\N
3058	(01f1,"ELSCINT1",27)	(01f1,"ELSCINT1",27)	ELSCINT1	497	39	f	\N	DS	1	Rotation Time	\N
3059	(01f1,"ELSCINT1",28)	(01f1,"ELSCINT1",28)	ELSCINT1	497	40	f	\N	DS	1	Table Increment	\N
3060	(01f1,"ELSCINT1",30)	(01f1,"ELSCINT1",30)	ELSCINT1	497	48	f	\N	US	1	Unknown	\N
3061	(01f1,"ELSCINT1",32)	(01f1,"ELSCINT1",32)	ELSCINT1	497	50	f	\N	CS	1	Image View Convention	\N
3062	(01f1,"ELSCINT1",33)	(01f1,"ELSCINT1",33)	ELSCINT1	497	51	f	\N	DS	1	Cycle Time	\N
3063	(01f1,"ELSCINT1",36)	(01f1,"ELSCINT1",36)	ELSCINT1	497	54	f	\N	CS	1	Unknown	\N
3064	(01f1,"ELSCINT1",37)	(01f1,"ELSCINT1",37)	ELSCINT1	497	55	f	\N	DS	1	Unknown	\N
3065	(01f1,"ELSCINT1",38)	(01f1,"ELSCINT1",38)	ELSCINT1	497	56	f	\N	LO	1	Unknown	\N
3066	(01f1,"ELSCINT1",39)	(01f1,"ELSCINT1",39)	ELSCINT1	497	57	f	\N	LO	1	Unknown	\N
3067	(01f1,"ELSCINT1",40)	(01f1,"ELSCINT1",40)	ELSCINT1	497	64	f	\N	CS	1	Unknown	\N
3068	(01f1,"ELSCINT1",42)	(01f1,"ELSCINT1",42)	ELSCINT1	497	66	f	\N	SH	1	Unknown	\N
3069	(01f1,"ELSCINT1",43)	(01f1,"ELSCINT1",43)	ELSCINT1	497	67	f	\N	LO	1	Unknown	\N
3070	(01f1,"ELSCINT1",44)	(01f1,"ELSCINT1",44)	ELSCINT1	497	68	f	\N	OW	1	Unknown	\N
3071	(01f1,"ELSCINT1",45)	(01f1,"ELSCINT1",45)	ELSCINT1	497	69	f	\N	IS	1	Unknown	\N
3072	(01f1,"ELSCINT1",46)	(01f1,"ELSCINT1",46)	ELSCINT1	497	70	f	\N	FL	1	Unknown	\N
3073	(01f1,"ELSCINT1",47)	(01f1,"ELSCINT1",47)	ELSCINT1	497	71	f	\N	SH	1	Unknown	\N
3074	(01f1,"ELSCINT1",49)	(01f1,"ELSCINT1",49)	ELSCINT1	497	73	f	\N	DS	1	Unknown	\N
3075	(01f1,"ELSCINT1",4a)	(01f1,"ELSCINT1",4a)	ELSCINT1	497	74	f	\N	SH	1	Unknown	\N
3076	(01f1,"ELSCINT1",4b)	(01f1,"ELSCINT1",4b)	ELSCINT1	497	75	f	\N	SH	1	Unknown	\N
3077	(01f1,"ELSCINT1",4c)	(01f1,"ELSCINT1",4c)	ELSCINT1	497	76	f	\N	SH	1	Unknown	\N
3078	(01f1,"ELSCINT1",4d)	(01f1,"ELSCINT1",4d)	ELSCINT1	497	77	f	\N	SH	1	Unknown	\N
3079	(01f1,"ELSCINT1",4e)	(01f1,"ELSCINT1",4e)	ELSCINT1	497	78	f	\N	LO	1	Unknown	\N
3080	(01f1,"ELSCINT1",53)	(01f1,"ELSCINT1",53)	ELSCINT1	497	83	f	\N	SH	1	Unknown	\N
3081	(01f3,"ELSCINT1",01)	(01f3,"ELSCINT1",01)	ELSCINT1	499	1	f	\N	SQ	1	Unknown	\N
3082	(01f3,"ELSCINT1",02)	(01f3,"ELSCINT1",02)	ELSCINT1	499	2	f	\N	SS	1	Unknown	\N
3083	(01f3,"ELSCINT1",03)	(01f3,"ELSCINT1",03)	ELSCINT1	499	3	f	\N	FL	2	Unknown	\N
3084	(01f3,"ELSCINT1",04)	(01f3,"ELSCINT1",04)	ELSCINT1	499	4	f	\N	FL	1	Unknown	\N
3085	(01f3,"ELSCINT1",11)	(01f3,"ELSCINT1",11)	ELSCINT1	499	17	f	\N	SQ	1	Unknown	\N
3086	(01f3,"ELSCINT1",12)	(01f3,"ELSCINT1",12)	ELSCINT1	499	18	f	\N	SS	1	Unknown	\N
3087	(01f3,"ELSCINT1",13)	(01f3,"ELSCINT1",13)	ELSCINT1	499	19	f	\N	FL	2	Unknown	\N
3088	(01f3,"ELSCINT1",14)	(01f3,"ELSCINT1",14)	ELSCINT1	499	20	f	\N	FL	1	Unknown	\N
3089	(01f3,"ELSCINT1",15)	(01f3,"ELSCINT1",15)	ELSCINT1	499	21	f	\N	US	1	Unknown	\N
3090	(01f3,"ELSCINT1",16)	(01f3,"ELSCINT1",16)	ELSCINT1	499	22	f	\N	FL	1	Unknown	\N
3091	(01f3,"ELSCINT1",17)	(01f3,"ELSCINT1",17)	ELSCINT1	499	23	f	\N	FL	1	Unknown	\N
3092	(01f3,"ELSCINT1",18)	(01f3,"ELSCINT1",18)	ELSCINT1	499	24	f	\N	SH	1	Unknown	\N
3093	(01f3,"ELSCINT1",19)	(01f3,"ELSCINT1",19)	ELSCINT1	499	25	f	\N	FL	1	Unknown	\N
3094	(01f3,"ELSCINT1",23)	(01f3,"ELSCINT1",23)	ELSCINT1	499	35	f	\N	US	1	Unknown	\N
3095	(01f3,"ELSCINT1",24)	(01f3,"ELSCINT1",24)	ELSCINT1	499	36	f	\N	IS	2	Unknown	\N
3096	(01f7,"ELSCINT1",10)	(01f7,"ELSCINT1",10)	ELSCINT1	503	16	f	\N	OB	1	Unknown	\N
3097	(01f7,"ELSCINT1",11)	(01f7,"ELSCINT1",11)	ELSCINT1	503	17	f	\N	OW	1	Unknown	\N
3098	(01f7,"ELSCINT1",13)	(01f7,"ELSCINT1",13)	ELSCINT1	503	19	f	\N	OW	1	Unknown	\N
3099	(01f7,"ELSCINT1",14)	(01f7,"ELSCINT1",14)	ELSCINT1	503	20	f	\N	OW	1	Unknown	\N
3100	(01f7,"ELSCINT1",15)	(01f7,"ELSCINT1",15)	ELSCINT1	503	21	f	\N	OW	1	Unknown	\N
3101	(01f7,"ELSCINT1",16)	(01f7,"ELSCINT1",16)	ELSCINT1	503	22	f	\N	OW	1	Unknown	\N
3102	(01f7,"ELSCINT1",17)	(01f7,"ELSCINT1",17)	ELSCINT1	503	23	f	\N	OW	1	Unknown	\N
3103	(01f7,"ELSCINT1",18)	(01f7,"ELSCINT1",18)	ELSCINT1	503	24	f	\N	OW	1	Unknown	\N
3104	(01f7,"ELSCINT1",19)	(01f7,"ELSCINT1",19)	ELSCINT1	503	25	f	\N	OW	1	Unknown	\N
3105	(01f7,"ELSCINT1",1a)	(01f7,"ELSCINT1",1a)	ELSCINT1	503	26	f	\N	OW	1	Unknown	\N
3106	(01f7,"ELSCINT1",1b)	(01f7,"ELSCINT1",1b)	ELSCINT1	503	27	f	\N	OW	1	Unknown	\N
3107	(01f7,"ELSCINT1",1c)	(01f7,"ELSCINT1",1c)	ELSCINT1	503	28	f	\N	OW	1	Unknown	\N
3108	(01f7,"ELSCINT1",1e)	(01f7,"ELSCINT1",1e)	ELSCINT1	503	30	f	\N	OW	1	Unknown	\N
3109	(01f7,"ELSCINT1",1f)	(01f7,"ELSCINT1",1f)	ELSCINT1	503	31	f	\N	OW	1	Unknown	\N
3110	(01f7,"ELSCINT1",22)	(01f7,"ELSCINT1",22)	ELSCINT1	503	34	f	\N	UI	1	Unknown	\N
3111	(01f7,"ELSCINT1",23)	(01f7,"ELSCINT1",23)	ELSCINT1	503	35	f	\N	OW	1	Unknown	\N
3112	(01f7,"ELSCINT1",25)	(01f7,"ELSCINT1",25)	ELSCINT1	503	37	f	\N	OW	1	Unknown	\N
3113	(01f7,"ELSCINT1",26)	(01f7,"ELSCINT1",26)	ELSCINT1	503	38	f	\N	OW	1	Unknown	\N
3114	(01f7,"ELSCINT1",27)	(01f7,"ELSCINT1",27)	ELSCINT1	503	39	f	\N	OW	1	Unknown	\N
3115	(01f7,"ELSCINT1",28)	(01f7,"ELSCINT1",28)	ELSCINT1	503	40	f	\N	OW	1	Unknown	\N
3116	(01f7,"ELSCINT1",29)	(01f7,"ELSCINT1",29)	ELSCINT1	503	41	f	\N	OW	1	Unknown	\N
3117	(01f7,"ELSCINT1",2b)	(01f7,"ELSCINT1",2b)	ELSCINT1	503	43	f	\N	OW	1	Unknown	\N
3118	(01f7,"ELSCINT1",2c)	(01f7,"ELSCINT1",2c)	ELSCINT1	503	44	f	\N	OW	1	Unknown	\N
3119	(01f7,"ELSCINT1",2d)	(01f7,"ELSCINT1",2d)	ELSCINT1	503	45	f	\N	OW	1	Unknown	\N
3120	(01f7,"ELSCINT1",2e)	(01f7,"ELSCINT1",2e)	ELSCINT1	503	46	f	\N	OW	1	Unknown	\N
3121	(01f7,"ELSCINT1",30)	(01f7,"ELSCINT1",30)	ELSCINT1	503	48	f	\N	OW	1	Unknown	\N
3122	(01f7,"ELSCINT1",31)	(01f7,"ELSCINT1",31)	ELSCINT1	503	49	f	\N	OW	1	Unknown	\N
3123	(01f7,"ELSCINT1",5c)	(01f7,"ELSCINT1",5c)	ELSCINT1	503	92	f	\N	OW	1	Unknown	\N
3124	(01f7,"ELSCINT1",70)	(01f7,"ELSCINT1",70)	ELSCINT1	503	112	f	\N	OW	1	Unknown	\N
3125	(01f7,"ELSCINT1",73)	(01f7,"ELSCINT1",73)	ELSCINT1	503	115	f	\N	OW	1	Unknown	\N
3126	(01f7,"ELSCINT1",74)	(01f7,"ELSCINT1",74)	ELSCINT1	503	116	f	\N	OW	1	Unknown	\N
3127	(01f7,"ELSCINT1",75)	(01f7,"ELSCINT1",75)	ELSCINT1	503	117	f	\N	OW	1	Unknown	\N
3128	(01f7,"ELSCINT1",7f)	(01f7,"ELSCINT1",7f)	ELSCINT1	503	127	f	\N	OW	1	Unknown	\N
3129	(01f9,"ELSCINT1",01)	(01f9,"ELSCINT1",01)	ELSCINT1	505	1	f	\N	LO	1	SP Filter	\N
3130	(01f9,"ELSCINT1",04)	(01f9,"ELSCINT1",04)	ELSCINT1	505	4	f	\N	IS	1	Adaptive Filter	\N
3131	(01f9,"ELSCINT1",05)	(01f9,"ELSCINT1",05)	ELSCINT1	505	5	f	\N	IS	1	Recon Increment	\N
3132	(01f9,"ELSCINT1",08)	(01f9,"ELSCINT1",08)	ELSCINT1	505	8	f	\N	DS	1	Unknown	\N
3133	(01f9,"ELSCINT1",09)	(01f9,"ELSCINT1",09)	ELSCINT1	505	9	f	\N	DS	1	Unknown	\N
3134	(07a1,"ELSCINT1",02)	(07a1,"ELSCINT1",02)	ELSCINT1	1953	2	f	\N	UL	1	Unknown	\N
3135	(07a1,"ELSCINT1",07)	(07a1,"ELSCINT1",07)	ELSCINT1	1953	7	f	\N	US	3	Unknown	\N
3136	(07a1,"ELSCINT1",08)	(07a1,"ELSCINT1",08)	ELSCINT1	1953	8	f	\N	DS	1-n	Unknown	\N
3137	(07a1,"ELSCINT1",09)	(07a1,"ELSCINT1",09)	ELSCINT1	1953	9	f	\N	OW	1	Unknown	\N
3138	(07a1,"ELSCINT1",0a)	(07a1,"ELSCINT1",0a)	ELSCINT1	1953	10	f	\N	OB	1	Unknown	\N
3139	(07a1,"ELSCINT1",0c)	(07a1,"ELSCINT1",0c)	ELSCINT1	1953	12	f	\N	US	1	Unknown	\N
3140	(07a1,"ELSCINT1",10)	(07a1,"ELSCINT1",10)	ELSCINT1	1953	16	f	\N	LO	1	Unknown	\N
3141	(07a1,"ELSCINT1",11)	(07a1,"ELSCINT1",11)	ELSCINT1	1953	17	f	\N	CS	1	Unknown	\N
3142	(07a1,"ELSCINT1",12)	(07a1,"ELSCINT1",12)	ELSCINT1	1953	18	f	\N	FL	1-n	Unknown	\N
3143	(07a1,"ELSCINT1",13)	(07a1,"ELSCINT1",13)	ELSCINT1	1953	19	f	\N	UL	1	Unknown	\N
3144	(07a1,"ELSCINT1",16)	(07a1,"ELSCINT1",16)	ELSCINT1	1953	22	f	\N	FL	1-n	Unknown	\N
3145	(07a1,"ELSCINT1",18)	(07a1,"ELSCINT1",18)	ELSCINT1	1953	24	f	\N	SQ	1	Unknown	\N
3146	(07a1,"ELSCINT1",19)	(07a1,"ELSCINT1",19)	ELSCINT1	1953	25	f	\N	FL	1	Unknown	\N
3147	(07a1,"ELSCINT1",1c)	(07a1,"ELSCINT1",1c)	ELSCINT1	1953	28	f	\N	FL	1-n	Unknown	\N
3148	(07a1,"ELSCINT1",2a)	(07a1,"ELSCINT1",2a)	ELSCINT1	1953	42	f	\N	CS	1	Unknown	\N
3149	(07a1,"ELSCINT1",2b)	(07a1,"ELSCINT1",2b)	ELSCINT1	1953	43	f	\N	CS	1	Unknown	\N
3150	(07a1,"ELSCINT1",36)	(07a1,"ELSCINT1",36)	ELSCINT1	1953	54	f	\N	AE	1	Unknown	\N
3151	(07a1,"ELSCINT1",3d)	(07a1,"ELSCINT1",3d)	ELSCINT1	1953	61	f	\N	US	1	Unknown	\N
3152	(07a1,"ELSCINT1",40)	(07a1,"ELSCINT1",40)	ELSCINT1	1953	64	f	\N	CS	1	Unknown	\N
3153	(07a1,"ELSCINT1",43)	(07a1,"ELSCINT1",43)	ELSCINT1	1953	67	f	\N	IS	1	Unknown	\N
3154	(07a1,"ELSCINT1",47)	(07a1,"ELSCINT1",47)	ELSCINT1	1953	71	f	\N	CS	1	Unknown	\N
3155	(07a1,"ELSCINT1",50)	(07a1,"ELSCINT1",50)	ELSCINT1	1953	80	f	\N	US	1	Unknown	\N
3156	(07a1,"ELSCINT1",56)	(07a1,"ELSCINT1",56)	ELSCINT1	1953	86	f	\N	US	1	Unknown	\N
3157	(07a1,"ELSCINT1",70)	(07a1,"ELSCINT1",70)	ELSCINT1	1953	112	f	\N	SH	1	Unknown	\N
3158	(07a1,"ELSCINT1",71)	(07a1,"ELSCINT1",71)	ELSCINT1	1953	113	f	\N	SH	1	Unknown	\N
3159	(07a1,"ELSCINT1",75)	(07a1,"ELSCINT1",75)	ELSCINT1	1953	117	f	\N	LO	2	Unknown	\N
3160	(07a1,"ELSCINT1",85)	(07a1,"ELSCINT1",85)	ELSCINT1	1953	133	f	\N	UL	1	Unknown	\N
3161	(07a1,"ELSCINT1",87)	(07a1,"ELSCINT1",87)	ELSCINT1	1953	135	f	\N	LT	1	Unknown	\N
3162	(07a1,"ELSCINT1",88)	(07a1,"ELSCINT1",88)	ELSCINT1	1953	136	f	\N	CS	1	Unknown	\N
3163	(07a1,"ELSCINT1",98)	(07a1,"ELSCINT1",98)	ELSCINT1	1953	152	f	\N	CS	1	Unknown	\N
3164	(07a1,"ELSCINT1",9f)	(07a1,"ELSCINT1",9f)	ELSCINT1	1953	159	f	\N	CS	1	Unknown	\N
3165	(07a3,"ELSCINT1",01)	(07a3,"ELSCINT1",01)	ELSCINT1	1955	1	f	\N	LO	1	Unknown	\N
3166	(07a3,"ELSCINT1",03)	(07a3,"ELSCINT1",03)	ELSCINT1	1955	3	f	\N	CS	1	Unknown	\N
3167	(07a3,"ELSCINT1",05)	(07a3,"ELSCINT1",05)	ELSCINT1	1955	5	f	\N	CS	1	Unknown	\N
3168	(07a3,"ELSCINT1",06)	(07a3,"ELSCINT1",06)	ELSCINT1	1955	6	f	\N	CS	1	Unknown	\N
3169	(07a3,"ELSCINT1",13)	(07a3,"ELSCINT1",13)	ELSCINT1	1955	19	f	\N	SH	1	Unknown	\N
3170	(07a3,"ELSCINT1",14)	(07a3,"ELSCINT1",14)	ELSCINT1	1955	20	f	\N	ST	1	Unknown	\N
3171	(07a3,"ELSCINT1",15)	(07a3,"ELSCINT1",15)	ELSCINT1	1955	21	f	\N	ST	1	Unknown	\N
3172	(07a3,"ELSCINT1",17)	(07a3,"ELSCINT1",17)	ELSCINT1	1955	23	f	\N	SH	1	Unknown	\N
3173	(07a3,"ELSCINT1",1b)	(07a3,"ELSCINT1",1b)	ELSCINT1	1955	27	f	\N	ST	1	Unknown	\N
3174	(07a3,"ELSCINT1",1f)	(07a3,"ELSCINT1",1f)	ELSCINT1	1955	31	f	\N	ST	1	Unknown	\N
3175	(07a3,"ELSCINT1",22)	(07a3,"ELSCINT1",22)	ELSCINT1	1955	34	f	\N	ST	1	Unknown	\N
3176	(07a3,"ELSCINT1",23)	(07a3,"ELSCINT1",23)	ELSCINT1	1955	35	f	\N	ST	1	Unknown	\N
3177	(07a3,"ELSCINT1",34)	(07a3,"ELSCINT1",34)	ELSCINT1	1955	52	f	\N	SH	1	Unknown	\N
3178	(07a3,"ELSCINT1",43)	(07a3,"ELSCINT1",43)	ELSCINT1	1955	67	f	\N	DS	1-n	Unknown	\N
3179	(07a3,"ELSCINT1",55)	(07a3,"ELSCINT1",55)	ELSCINT1	1955	85	f	\N	SH	1	Unknown	\N
3180	(07a3,"ELSCINT1",61)	(07a3,"ELSCINT1",61)	ELSCINT1	1955	97	f	\N	LT	1	Unknown	\N
3181	(07a3,"ELSCINT1",62)	(07a3,"ELSCINT1",62)	ELSCINT1	1955	98	f	\N	SQ	1	Unknown	\N
3182	(07a3,"ELSCINT1",63)	(07a3,"ELSCINT1",63)	ELSCINT1	1955	99	f	\N	SQ	1	Unknown	\N
3183	(07a3,"ELSCINT1",64)	(07a3,"ELSCINT1",64)	ELSCINT1	1955	100	f	\N	IS	1-n	Unknown	\N
3184	(07a3,"ELSCINT1",65)	(07a3,"ELSCINT1",65)	ELSCINT1	1955	101	f	\N	CS	1	Unknown	\N
3185	(07a3,"ELSCINT1",66)	(07a3,"ELSCINT1",66)	ELSCINT1	1955	102	f	\N	IS	1	Unknown	\N
3186	(07a3,"ELSCINT1",80)	(07a3,"ELSCINT1",80)	ELSCINT1	1955	128	f	\N	SQ	1	Unknown	\N
3187	(07a3,"ELSCINT1",99)	(07a3,"ELSCINT1",99)	ELSCINT1	1955	153	f	\N	CS	1	Unknown	\N
3188	(07a3,"ELSCINT1",9c)	(07a3,"ELSCINT1",9c)	ELSCINT1	1955	156	f	\N	CS	1	Unknown	\N
3189	(07a3,"ELSCINT1",9f)	(07a3,"ELSCINT1",9f)	ELSCINT1	1955	159	f	\N	CS	1	Unknown	\N
3190	(07a3,"ELSCINT1",b9)	(07a3,"ELSCINT1",b9)	ELSCINT1	1955	185	f	\N	CS	1	Unknown	\N
3191	(07a3,"ELSCINT1",bb)	(07a3,"ELSCINT1",bb)	ELSCINT1	1955	187	f	\N	CS	1	Unknown	\N
3192	(07a5,"ELSCINT1",00)	(07a5,"ELSCINT1",00)	ELSCINT1	1957	0	f	\N	LO	1	Unknown	\N
3193	(07a5,"ELSCINT1",56)	(07a5,"ELSCINT1",56)	ELSCINT1	1957	86	f	\N	CS	1	Unknown	\N
3194	(5001,"ELSCINT1",70)	(5001,"ELSCINT1",70)	ELSCINT1	20481	112	f	\N	SQ	1	Unknown	\N
3195	(5001,"ELSCINT1",71)	(5001,"ELSCINT1",71)	ELSCINT1	20481	113	f	\N	SH	1	Unknown	\N
3196	(5001,"ELSCINT1",80)	(5001,"ELSCINT1",80)	ELSCINT1	20481	128	f	\N	SQ	1	Unknown	\N
3197	(5001,"ELSCINT1",81)	(5001,"ELSCINT1",81)	ELSCINT1	20481	129	f	\N	SH	1	Unknown	\N
3198	(5001,"ELSCINT1",82)	(5001,"ELSCINT1",82)	ELSCINT1	20481	130	f	\N	US	3	Unknown	\N
3199	(5001,"ELSCINT1",83)	(5001,"ELSCINT1",83)	ELSCINT1	20481	131	f	\N	FL	1-n	Unknown	\N
3200	(5001,"ELSCINT1",84)	(5001,"ELSCINT1",84)	ELSCINT1	20481	132	f	\N	SQ	1	Unknown	\N
3201	(7fdf,"ELSCINT1",f0)	(7fdf,"ELSCINT1",f0)	ELSCINT1	32735	240	f	\N	OB	1	Unknown	\N
3202	(7fdf,"ELSCINT1",ff)	(7fdf,"ELSCINT1",ff)	ELSCINT1	32735	255	f	\N	SH	1	Unknown	\N
3204	(0009,"GEMS_PETD_01",02)	(0009,"GEMS_PETD_01",02)	GEMS_PETD_01	9	2	f	\N	LO	1	Patient ID	X
3205	(0009,"GEMS_PETD_01",03)	(0009,"GEMS_PETD_01",03)	GEMS_PETD_01	9	3	f	\N	SH	1	Patient Compatible Version	K
3206	(0009,"GEMS_PETD_01",04)	(0009,"GEMS_PETD_01",04)	GEMS_PETD_01	9	4	f	\N	SH	1	Patient Software Version	K
3207	(0009,"GEMS_PETD_01",05)	(0009,"GEMS_PETD_01",05)	GEMS_PETD_01	9	5	f	\N	DT	1	Patient DateTime	R
3208	(0009,"GEMS_PETD_01",06)	(0009,"GEMS_PETD_01",06)	GEMS_PETD_01	9	6	f	\N	SL	1	Patient Type	K
3209	(0009,"GEMS_PETD_01",07)	(0009,"GEMS_PETD_01",07)	GEMS_PETD_01	9	7	f	\N	UI	1	Exam ID	R
3210	(0009,"GEMS_PETD_01",08)	(0009,"GEMS_PETD_01",08)	GEMS_PETD_01	9	8	f	\N	SH	1	Exam Compatible Version	R
3211	(0009,"GEMS_PETD_01",09)	(0009,"GEMS_PETD_01",09)	GEMS_PETD_01	9	9	f	\N	SH	1	Exam Software Version	R
3212	(0009,"GEMS_PETD_01",0a)	(0009,"GEMS_PETD_01",0a)	GEMS_PETD_01	9	10	f	\N	UI	1	Scan ID	R
3214	(0009,"GEMS_PETD_01",0c)	(0009,"GEMS_PETD_01",0c)	GEMS_PETD_01	9	12	f	\N	SH	1	Scan Software Version	R
3215	(0009,"GEMS_PETD_01",0d)	(0009,"GEMS_PETD_01",0d)	GEMS_PETD_01	9	13	f	\N	DT	1	Scan Date Time	R
3216	(0009,"GEMS_PETD_01",0e)	(0009,"GEMS_PETD_01",0e)	GEMS_PETD_01	9	14	f	\N	DT	1	Scan Ready	R
3217	(0009,"GEMS_PETD_01",0f)	(0009,"GEMS_PETD_01",0f)	GEMS_PETD_01	9	15	f	\N	ST	1	Scan Description	R
3218	(0009,"GEMS_PETD_01",10)	(0009,"GEMS_PETD_01",10)	GEMS_PETD_01	9	16	f	\N	LO	1	Hospital Name	X
3219	(0009,"GEMS_PETD_01",11)	(0009,"GEMS_PETD_01",11)	GEMS_PETD_01	9	17	f	\N	LO	1	Scanner Description	R
3220	(0009,"GEMS_PETD_01",12)	(0009,"GEMS_PETD_01",12)	GEMS_PETD_01	9	18	f	\N	LO	1	Manufacturer	R
3221	(0009,"GEMS_PETD_01",13)	(0009,"GEMS_PETD_01",13)	GEMS_PETD_01	9	19	f	\N	UI	1	FOR Identifier	R
3222	(0009,"GEMS_PETD_01",14)	(0009,"GEMS_PETD_01",14)	GEMS_PETD_01	9	20	f	\N	LO	1	Landmark Name	R
3223	(0009,"GEMS_PETD_01",15)	(0009,"GEMS_PETD_01",15)	GEMS_PETD_01	9	21	f	\N	SH	1	Landmark Abbrev	R
3224	(0009,"GEMS_PETD_01",16)	(0009,"GEMS_PETD_01",16)	GEMS_PETD_01	9	22	f	\N	SL	1	Patient Position	K
3225	(0009,"GEMS_PETD_01",17)	(0009,"GEMS_PETD_01",17)	GEMS_PETD_01	9	23	f	\N	SL	1	Scan Perspective	K
3226	(0009,"GEMS_PETD_01",18)	(0009,"GEMS_PETD_01",18)	GEMS_PETD_01	9	24	f	\N	SL	1	Scan Type	K
3227	(0009,"GEMS_PETD_01",19)	(0009,"GEMS_PETD_01",19)	GEMS_PETD_01	9	25	f	\N	SL	1	Scan Mode	K
3228	(0009,"GEMS_PETD_01",1a)	(0009,"GEMS_PETD_01",1a)	GEMS_PETD_01	9	26	f	\N	SL	1	Start Condition	K
3229	(0009,"GEMS_PETD_01",1b)	(0009,"GEMS_PETD_01",1b)	GEMS_PETD_01	9	27	f	\N	SL	1	Start Condition Data	K
3230	(0009,"GEMS_PETD_01",1c)	(0009,"GEMS_PETD_01",1c)	GEMS_PETD_01	9	28	f	\N	SL	1	Sel Stop Condition	K
3231	(0009,"GEMS_PETD_01",1d)	(0009,"GEMS_PETD_01",1d)	GEMS_PETD_01	9	29	f	\N	SL	1	Sel Stop Condition Data	K
3232	(0009,"GEMS_PETD_01",1e)	(0009,"GEMS_PETD_01",1e)	GEMS_PETD_01	9	30	f	\N	SL	1	Collect Deadtime	K
3233	(0009,"GEMS_PETD_01",1f)	(0009,"GEMS_PETD_01",1f)	GEMS_PETD_01	9	31	f	\N	SL	1	Collect Singles	K
3234	(0009,"GEMS_PETD_01",20)	(0009,"GEMS_PETD_01",20)	GEMS_PETD_01	9	32	f	\N	SL	1	Collect Count Rate	K
10971	(0119,"MRSC",11a2)	(0119,"MRSC",a2)	MRSC	281	162	t	11	DS	1-n	PhantCalibParam	K
3236	(0009,"GEMS_PETD_01",22)	(0009,"GEMS_PETD_01",22)	GEMS_PETD_01	9	34	f	\N	SL	1	Delayed Events	K
3237	(0009,"GEMS_PETD_01",23)	(0009,"GEMS_PETD_01",23)	GEMS_PETD_01	9	35	f	\N	SL	1	Delayed Bias	K
3238	(0009,"GEMS_PETD_01",24)	(0009,"GEMS_PETD_01",24)	GEMS_PETD_01	9	36	f	\N	SL	1	Word Size	K
3239	(0009,"GEMS_PETD_01",25)	(0009,"GEMS_PETD_01",25)	GEMS_PETD_01	9	37	f	\N	SL	1	Axial Acceptance	K
3240	(0009,"GEMS_PETD_01",26)	(0009,"GEMS_PETD_01",26)	GEMS_PETD_01	9	38	f	\N	SL	1	Axial Angle 3D	K
3241	(0009,"GEMS_PETD_01",27)	(0009,"GEMS_PETD_01",27)	GEMS_PETD_01	9	39	f	\N	SL	1	Theta Compression	K
3242	(0009,"GEMS_PETD_01",28)	(0009,"GEMS_PETD_01",28)	GEMS_PETD_01	9	40	f	\N	SL	1	Axial Compression	K
3244	(0009,"GEMS_PETD_01",2a)	(0009,"GEMS_PETD_01",2a)	GEMS_PETD_01	9	42	f	\N	SL	1	Collimation	K
3245	(0009,"GEMS_PETD_01",2b)	(0009,"GEMS_PETD_01",2b)	GEMS_PETD_01	9	43	f	\N	SL	1	Scan FOV	K
3246	(0009,"GEMS_PETD_01",2c)	(0009,"GEMS_PETD_01",2c)	GEMS_PETD_01	9	44	f	\N	SL	1	Axial FOV	K
3247	(0009,"GEMS_PETD_01",2d)	(0009,"GEMS_PETD_01",2d)	GEMS_PETD_01	9	45	f	\N	SL	1	Event Separation	K
3248	(0009,"GEMS_PETD_01",2e)	(0009,"GEMS_PETD_01",2e)	GEMS_PETD_01	9	46	f	\N	SL	1	Mask Width	K
3249	(0009,"GEMS_PETD_01",2f)	(0009,"GEMS_PETD_01",2f)	GEMS_PETD_01	9	47	f	\N	SL	1	Binning Mode	K
3250	(0009,"GEMS_PETD_01",30)	(0009,"GEMS_PETD_01",30)	GEMS_PETD_01	9	48	f	\N	SL	1	Trig Rej Method	K
3251	(0009,"GEMS_PETD_01",31)	(0009,"GEMS_PETD_01",31)	GEMS_PETD_01	9	49	f	\N	SL	1	Number For Reject	K
3252	(0009,"GEMS_PETD_01",32)	(0009,"GEMS_PETD_01",32)	GEMS_PETD_01	9	50	f	\N	SL	1	Lower Reject Limit	K
3253	(0009,"GEMS_PETD_01",33)	(0009,"GEMS_PETD_01",33)	GEMS_PETD_01	9	51	f	\N	SL	1	Upper Reject Limit	K
3254	(0009,"GEMS_PETD_01",34)	(0009,"GEMS_PETD_01",34)	GEMS_PETD_01	9	52	f	\N	SL	1	Triggers Acquired	K
3255	(0009,"GEMS_PETD_01",35)	(0009,"GEMS_PETD_01",35)	GEMS_PETD_01	9	53	f	\N	SL	1	Triggers Rejected	K
3256	(0009,"GEMS_PETD_01",36)	(0009,"GEMS_PETD_01",36)	GEMS_PETD_01	9	54	f	\N	LO	1	Tracer Name	R
3257	(0009,"GEMS_PETD_01",37)	(0009,"GEMS_PETD_01",37)	GEMS_PETD_01	9	55	f	\N	LO	1	Batch Description	R
3258	(0009,"GEMS_PETD_01",38)	(0009,"GEMS_PETD_01",38)	GEMS_PETD_01	9	56	f	\N	FL	1	Tracer Activity	K
3259	(0009,"GEMS_PETD_01",39)	(0009,"GEMS_PETD_01",39)	GEMS_PETD_01	9	57	f	\N	DT	1	Measured Date Time	R
3260	(0009,"GEMS_PETD_01",3a)	(0009,"GEMS_PETD_01",3a)	GEMS_PETD_01	9	58	f	\N	FL	1	Pre Inj Volume	K
3261	(0009,"GEMS_PETD_01",3b)	(0009,"GEMS_PETD_01",3b)	GEMS_PETD_01	9	59	f	\N	DT	1	Administered Date Time	R
3263	(0009,"GEMS_PETD_01",3d)	(0009,"GEMS_PETD_01",3d)	GEMS_PETD_01	9	61	f	\N	DT	1	Post Injected Date Time	R
3264	(0009,"GEMS_PETD_01",3e)	(0009,"GEMS_PETD_01",3e)	GEMS_PETD_01	9	62	f	\N	SH	1	Radio Nuclide Name	R
3265	(0009,"GEMS_PETD_01",3f)	(0009,"GEMS_PETD_01",3f)	GEMS_PETD_01	9	63	f	\N	FL	1	Half Life	K
3266	(0009,"GEMS_PETD_01",40)	(0009,"GEMS_PETD_01",40)	GEMS_PETD_01	9	64	f	\N	FL	1	Positron Fraction	K
3267	(0009,"GEMS_PETD_01",41)	(0009,"GEMS_PETD_01",41)	GEMS_PETD_01	9	65	f	\N	SL	1	Source 1 Holder	K
3268	(0009,"GEMS_PETD_01",42)	(0009,"GEMS_PETD_01",42)	GEMS_PETD_01	9	66	f	\N	FL	1	Source 1 Activity	K
3269	(0009,"GEMS_PETD_01",43)	(0009,"GEMS_PETD_01",43)	GEMS_PETD_01	9	67	f	\N	DT	1	Source 1 Meas DT	R
3270	(0009,"GEMS_PETD_01",44)	(0009,"GEMS_PETD_01",44)	GEMS_PETD_01	9	68	f	\N	SH	1	Source 1 Radio Nuclide	R
3271	(0009,"GEMS_PETD_01",45)	(0009,"GEMS_PETD_01",45)	GEMS_PETD_01	9	69	f	\N	FL	1	Source 1 Half Life	K
3272	(0009,"GEMS_PETD_01",46)	(0009,"GEMS_PETD_01",46)	GEMS_PETD_01	9	70	f	\N	SL	1	Source 2 Holder	K
3273	(0009,"GEMS_PETD_01",47)	(0009,"GEMS_PETD_01",47)	GEMS_PETD_01	9	71	f	\N	FL	1	Source 2 Activity	K
3274	(0009,"GEMS_PETD_01",48)	(0009,"GEMS_PETD_01",48)	GEMS_PETD_01	9	72	f	\N	DT	1	Source 2 Meas DT	R
3275	(0009,"GEMS_PETD_01",49)	(0009,"GEMS_PETD_01",49)	GEMS_PETD_01	9	73	f	\N	SH	1	Source 2 Radio Nuclide	K
3276	(0009,"GEMS_PETD_01",4a)	(0009,"GEMS_PETD_01",4a)	GEMS_PETD_01	9	74	f	\N	FL	1	Source 2 Half Life	K
3277	(0009,"GEMS_PETD_01",4b)	(0009,"GEMS_PETD_01",4b)	GEMS_PETD_01	9	75	f	\N	SL	1	Source Speed	K
3278	(0009,"GEMS_PETD_01",4c)	(0009,"GEMS_PETD_01",4c)	GEMS_PETD_01	9	76	f	\N	FL	1	Source Location	K
3279	(0009,"GEMS_PETD_01",4d)	(0009,"GEMS_PETD_01",4d)	GEMS_PETD_01	9	77	f	\N	SL	1	Emission Present	K
3280	(0009,"GEMS_PETD_01",4e)	(0009,"GEMS_PETD_01",4e)	GEMS_PETD_01	9	78	f	\N	SL	1	Lower Axial Acc	K
3281	(0009,"GEMS_PETD_01",4f)	(0009,"GEMS_PETD_01",4f)	GEMS_PETD_01	9	79	f	\N	SL	1	Upper Axial Acc	K
3282	(0009,"GEMS_PETD_01",50)	(0009,"GEMS_PETD_01",50)	GEMS_PETD_01	9	80	f	\N	SL	1	Lower Coinc Limit	K
3284	(0009,"GEMS_PETD_01",52)	(0009,"GEMS_PETD_01",52)	GEMS_PETD_01	9	82	f	\N	SL	1	Coinc Delay Offset	K
3285	(0009,"GEMS_PETD_01",53)	(0009,"GEMS_PETD_01",53)	GEMS_PETD_01	9	83	f	\N	SL	1	Coinc Output Mode	K
3286	(0009,"GEMS_PETD_01",54)	(0009,"GEMS_PETD_01",54)	GEMS_PETD_01	9	84	f	\N	SL	1	Upper Energy Limit	K
3287	(0009,"GEMS_PETD_01",55)	(0009,"GEMS_PETD_01",55)	GEMS_PETD_01	9	85	f	\N	SL	1	Lower Energy Limit	K
3288	(0009,"GEMS_PETD_01",56)	(0009,"GEMS_PETD_01",56)	GEMS_PETD_01	9	86	f	\N	UI	1	Normal Cal ID	R
3289	(0009,"GEMS_PETD_01",57)	(0009,"GEMS_PETD_01",57)	GEMS_PETD_01	9	87	f	\N	UI	1	Normal 2D Cal ID	R
3290	(0009,"GEMS_PETD_01",58)	(0009,"GEMS_PETD_01",58)	GEMS_PETD_01	9	88	f	\N	UI	1	Blank Cal ID	R
3291	(0009,"GEMS_PETD_01",59)	(0009,"GEMS_PETD_01",59)	GEMS_PETD_01	9	89	f	\N	UI	1	WC Cal ID	R
3292	(0009,"GEMS_PETD_01",5a)	(0009,"GEMS_PETD_01",5a)	GEMS_PETD_01	9	90	f	\N	SL	1	Derived	K
3293	(0009,"GEMS_PETD_01",5b)	(0009,"GEMS_PETD_01",5b)	GEMS_PETD_01	9	91	f	\N	LO	1	Contrast Agent	R
3294	(0009,"GEMS_PETD_01",5c)	(0009,"GEMS_PETD_01",5c)	GEMS_PETD_01	9	92	f	\N	UI	1	frame_id	R
3295	(0009,"GEMS_PETD_01",5d)	(0009,"GEMS_PETD_01",5d)	GEMS_PETD_01	9	93	f	\N	UI	1	scan_id	R
10972	(0119,"MRSC",11a3)	(0119,"MRSC",a3)	MRSC	281	163	t	11	IS	1-n	PhantGoodFlags	K
3297	(0009,"GEMS_PETD_01",5f)	(0009,"GEMS_PETD_01",5f)	GEMS_PETD_01	9	95	f	\N	LO	1	patient_id	X
3299	(0009,"GEMS_PETD_01",61)	(0009,"GEMS_PETD_01",61)	GEMS_PETD_01	9	97	f	\N	SH	1	software_version	R
3300	(0009,"GEMS_PETD_01",62)	(0009,"GEMS_PETD_01",62)	GEMS_PETD_01	9	98	f	\N	ST	1	where_is_frame	R
3301	(0009,"GEMS_PETD_01",63)	(0009,"GEMS_PETD_01",63)	GEMS_PETD_01	9	99	f	\N	SL	1	frame_size	K
3302	(0009,"GEMS_PETD_01",64)	(0009,"GEMS_PETD_01",64)	GEMS_PETD_01	9	100	f	\N	SL	1	file_exists	K
3303	(0009,"GEMS_PETD_01",65)	(0009,"GEMS_PETD_01",65)	GEMS_PETD_01	9	101	f	\N	SL	1	patient_entry	K
3304	(0009,"GEMS_PETD_01",66)	(0009,"GEMS_PETD_01",66)	GEMS_PETD_01	9	102	f	\N	FL	1	table_height	K
3305	(0009,"GEMS_PETD_01",67)	(0009,"GEMS_PETD_01",67)	GEMS_PETD_01	9	103	f	\N	FL	1	table_z_position	K
3306	(0009,"GEMS_PETD_01",68)	(0009,"GEMS_PETD_01",68)	GEMS_PETD_01	9	104	f	\N	DT	1	landmark_datetime	R
3307	(0009,"GEMS_PETD_01",69)	(0009,"GEMS_PETD_01",69)	GEMS_PETD_01	9	105	f	\N	SL	1	slice_count	K
3308	(0009,"GEMS_PETD_01",6a)	(0009,"GEMS_PETD_01",6a)	GEMS_PETD_01	9	106	f	\N	FL	1	start_location	K
3309	(0009,"GEMS_PETD_01",6b)	(0009,"GEMS_PETD_01",6b)	GEMS_PETD_01	9	107	f	\N	SL	1	acq_delay	K
3310	(0009,"GEMS_PETD_01",6c)	(0009,"GEMS_PETD_01",6c)	GEMS_PETD_01	9	108	f	\N	DT	1	acq_start	R
3311	(0009,"GEMS_PETD_01",6d)	(0009,"GEMS_PETD_01",6d)	GEMS_PETD_01	9	109	f	\N	SL	1	acq_duration	K
3312	(0009,"GEMS_PETD_01",6e)	(0009,"GEMS_PETD_01",6e)	GEMS_PETD_01	9	110	f	\N	SL	1	acq_bin_dur	K
3313	(0009,"GEMS_PETD_01",6f)	(0009,"GEMS_PETD_01",6f)	GEMS_PETD_01	9	111	f	\N	SL	1	acq_bin_start	K
3314	(0009,"GEMS_PETD_01",70)	(0009,"GEMS_PETD_01",70)	GEMS_PETD_01	9	112	f	\N	SL	1	actual_stop_cond	K
3315	(0009,"GEMS_PETD_01",71)	(0009,"GEMS_PETD_01",71)	GEMS_PETD_01	9	113	f	\N	FD	1	total_prompts	K
3316	(0009,"GEMS_PETD_01",72)	(0009,"GEMS_PETD_01",72)	GEMS_PETD_01	9	114	f	\N	FD	1	total_delays	K
3317	(0009,"GEMS_PETD_01",73)	(0009,"GEMS_PETD_01",73)	GEMS_PETD_01	9	115	f	\N	SL	1	frame_valid	K
3318	(0009,"GEMS_PETD_01",74)	(0009,"GEMS_PETD_01",74)	GEMS_PETD_01	9	116	f	\N	SL	1	validity_info	K
3319	(0009,"GEMS_PETD_01",75)	(0009,"GEMS_PETD_01",75)	GEMS_PETD_01	9	117	f	\N	SL	1	archived	K
3320	(0009,"GEMS_PETD_01",76)	(0009,"GEMS_PETD_01",76)	GEMS_PETD_01	9	118	f	\N	SL	1	compression	K
3321	(0009,"GEMS_PETD_01",77)	(0009,"GEMS_PETD_01",77)	GEMS_PETD_01	9	119	f	\N	SL	1	uncompressed_size	K
3322	(0009,"GEMS_PETD_01",78)	(0009,"GEMS_PETD_01",78)	GEMS_PETD_01	9	120	f	\N	SL	1	accum_bin_dur	K
3324	(0009,"GEMS_PETD_01",7a)	(0009,"GEMS_PETD_01",7a)	GEMS_PETD_01	9	122	f	\N	SH	1	Image Set Software Version	R
3325	(0009,"GEMS_PETD_01",7b)	(0009,"GEMS_PETD_01",7b)	GEMS_PETD_01	9	123	f	\N	DT	1	Image Set Date Time	R
3326	(0009,"GEMS_PETD_01",7c)	(0009,"GEMS_PETD_01",7c)	GEMS_PETD_01	9	124	f	\N	SL	1	Image Set Source	K
3327	(0009,"GEMS_PETD_01",7d)	(0009,"GEMS_PETD_01",7d)	GEMS_PETD_01	9	125	f	\N	SL	1	Image Set Contents	K
3328	(0009,"GEMS_PETD_01",7e)	(0009,"GEMS_PETD_01",7e)	GEMS_PETD_01	9	126	f	\N	SL	1	Image Set Type	K
3329	(0009,"GEMS_PETD_01",7f)	(0009,"GEMS_PETD_01",7f)	GEMS_PETD_01	9	127	f	\N	DS	1	Image Set Reference	K
3330	(0009,"GEMS_PETD_01",80)	(0009,"GEMS_PETD_01",80)	GEMS_PETD_01	9	128	f	\N	SL	1	Multi Patient	K
3331	(0009,"GEMS_PETD_01",81)	(0009,"GEMS_PETD_01",81)	GEMS_PETD_01	9	129	f	\N	SL	1	Number of Normals	K
3332	(0009,"GEMS_PETD_01",82)	(0009,"GEMS_PETD_01",82)	GEMS_PETD_01	9	130	f	\N	UI	1	Color Map ID	R
3333	(0009,"GEMS_PETD_01",83)	(0009,"GEMS_PETD_01",83)	GEMS_PETD_01	9	131	f	\N	SL	1	Window Level Type	K
3334	(0009,"GEMS_PETD_01",84)	(0009,"GEMS_PETD_01",84)	GEMS_PETD_01	9	132	f	\N	FL	1	Rotate	K
3335	(0009,"GEMS_PETD_01",85)	(0009,"GEMS_PETD_01",85)	GEMS_PETD_01	9	133	f	\N	SL	1	Flip	K
3336	(0009,"GEMS_PETD_01",86)	(0009,"GEMS_PETD_01",86)	GEMS_PETD_01	9	134	f	\N	FL	1	Zoom	K
3337	(0009,"GEMS_PETD_01",87)	(0009,"GEMS_PETD_01",87)	GEMS_PETD_01	9	135	f	\N	SL	1	PanX	K
3338	(0009,"GEMS_PETD_01",88)	(0009,"GEMS_PETD_01",88)	GEMS_PETD_01	9	136	f	\N	SL	1	PanY	K
3339	(0009,"GEMS_PETD_01",89)	(0009,"GEMS_PETD_01",89)	GEMS_PETD_01	9	137	f	\N	FL	1	Window Level Min	K
3340	(0009,"GEMS_PETD_01",8a)	(0009,"GEMS_PETD_01",8a)	GEMS_PETD_01	9	138	f	\N	FL	1	Window Level Max	K
3341	(0009,"GEMS_PETD_01",8b)	(0009,"GEMS_PETD_01",8b)	GEMS_PETD_01	9	139	f	\N	SL	1	ReconMethod	K
3342	(0009,"GEMS_PETD_01",8c)	(0009,"GEMS_PETD_01",8c)	GEMS_PETD_01	9	140	f	\N	SL	1	Attenuation	K
3343	(0009,"GEMS_PETD_01",8d)	(0009,"GEMS_PETD_01",8d)	GEMS_PETD_01	9	141	f	\N	FL	1	Attenuation Coefficient	K
3344	(0009,"GEMS_PETD_01",8e)	(0009,"GEMS_PETD_01",8e)	GEMS_PETD_01	9	142	f	\N	SL	1	BP Filter	K
3345	(0009,"GEMS_PETD_01",8f)	(0009,"GEMS_PETD_01",8f)	GEMS_PETD_01	9	143	f	\N	FL	1	BP Filter Cutoff	K
3346	(0009,"GEMS_PETD_01",90)	(0009,"GEMS_PETD_01",90)	GEMS_PETD_01	9	144	f	\N	SL	1	BP Filter Order	K
3347	(0009,"GEMS_PETD_01",91)	(0009,"GEMS_PETD_01",91)	GEMS_PETD_01	9	145	f	\N	FL	1	BP Filter Center I	K
3348	(0009,"GEMS_PETD_01",92)	(0009,"GEMS_PETD_01",92)	GEMS_PETD_01	9	146	f	\N	FL	1	BP Filter Center P	K
3349	(0009,"GEMS_PETD_01",93)	(0009,"GEMS_PETD_01",93)	GEMS_PETD_01	9	147	f	\N	SL	1	Atten Smooth	K
3351	(0009,"GEMS_PETD_01",95)	(0009,"GEMS_PETD_01",95)	GEMS_PETD_01	9	149	f	\N	SL	1	Angle Smooth Param	K
3352	(0009,"GEMS_PETD_01",96)	(0009,"GEMS_PETD_01",96)	GEMS_PETD_01	9	150	f	\N	UI	1	Well CounterCal ID	R
3353	(0009,"GEMS_PETD_01",97)	(0009,"GEMS_PETD_01",97)	GEMS_PETD_01	9	151	f	\N	UI	1	Trans Scan ID	R
3354	(0009,"GEMS_PETD_01",98)	(0009,"GEMS_PETD_01",98)	GEMS_PETD_01	9	152	f	\N	UI	1	Norm Cal ID	R
3355	(0009,"GEMS_PETD_01",99)	(0009,"GEMS_PETD_01",99)	GEMS_PETD_01	9	153	f	\N	UI	1	Blnk Cal ID	R
3356	(0009,"GEMS_PETD_01",9a)	(0009,"GEMS_PETD_01",9a)	GEMS_PETD_01	9	154	f	\N	FL	1	CAC Edge Threshold	K
3358	(0009,"GEMS_PETD_01",9c)	(0009,"GEMS_PETD_01",9c)	GEMS_PETD_01	9	156	f	\N	UI	1	Emiss Sub ID	R
3359	(0009,"GEMS_PETD_01",9d)	(0009,"GEMS_PETD_01",9d)	GEMS_PETD_01	9	157	f	\N	SS	1	Radial Filter 3D	K
3360	(0009,"GEMS_PETD_01",9e)	(0009,"GEMS_PETD_01",9e)	GEMS_PETD_01	9	158	f	\N	FL	1	Radial Cutoff 3D	K
3362	(0009,"GEMS_PETD_01",a0)	(0009,"GEMS_PETD_01",a0)	GEMS_PETD_01	9	160	f	\N	FL	1	Axial Cutoff 3D	K
3363	(0009,"GEMS_PETD_01",a1)	(0009,"GEMS_PETD_01",a1)	GEMS_PETD_01	9	161	f	\N	FL	1	Axial Start	K
3364	(0009,"GEMS_PETD_01",a2)	(0009,"GEMS_PETD_01",a2)	GEMS_PETD_01	9	162	f	\N	FL	1	Axial Spacing	K
3365	(0009,"GEMS_PETD_01",a3)	(0009,"GEMS_PETD_01",a3)	GEMS_PETD_01	9	163	f	\N	SL	1	Axial Angles Used	K
3366	(0009,"GEMS_PETD_01",a4)	(0009,"GEMS_PETD_01",a4)	GEMS_PETD_01	9	164	f	\N	SH	1	compatible_version	R
3367	(0009,"GEMS_PETD_01",a5)	(0009,"GEMS_PETD_01",a5)	GEMS_PETD_01	9	165	f	\N	SH	1	software_version	R
3368	(0009,"GEMS_PETD_01",a6)	(0009,"GEMS_PETD_01",a6)	GEMS_PETD_01	9	166	f	\N	SL	1	slice_number	K
3369	(0009,"GEMS_PETD_01",a7)	(0009,"GEMS_PETD_01",a7)	GEMS_PETD_01	9	167	f	\N	FL	1	total_counts	K
3370	(0009,"GEMS_PETD_01",a8)	(0009,"GEMS_PETD_01",a8)	GEMS_PETD_01	9	168	f	\N	OB	1	other_atts	X
3371	(0009,"GEMS_PETD_01",a9)	(0009,"GEMS_PETD_01",a9)	GEMS_PETD_01	9	169	f	\N	SL	1	other_atts_size	K
3372	(0009,"GEMS_PETD_01",aa)	(0009,"GEMS_PETD_01",aa)	GEMS_PETD_01	9	170	f	\N	SL	1	archived	K
3373	(0009,"GEMS_PETD_01",ab)	(0009,"GEMS_PETD_01",ab)	GEMS_PETD_01	9	171	f	\N	FL	1	bp_center_x	K
3374	(0009,"GEMS_PETD_01",ac)	(0009,"GEMS_PETD_01",ac)	GEMS_PETD_01	9	172	f	\N	FL	1	bp_center_y	K
3375	(0009,"GEMS_PETD_01",ad)	(0009,"GEMS_PETD_01",ad)	GEMS_PETD_01	9	173	f	\N	UI	1	trans_frame_id	R
3376	(0009,"GEMS_PETD_01",ae)	(0009,"GEMS_PETD_01",ae)	GEMS_PETD_01	9	174	f	\N	UI	1	tpluse_frame_id	R
3377	(0009,"GEMS_PETD_01",b1)	(0009,"GEMS_PETD_01",b1)	GEMS_PETD_01	9	177	f	\N	FL	1	profile_spacing	K
3378	(0009,"GEMS_PETD_01",b2)	(0009,"GEMS_PETD_01",b2)	GEMS_PETD_01	9	178	f	\N	SS	1	IR Num Iterations	K
3379	(0009,"GEMS_PETD_01",b3)	(0009,"GEMS_PETD_01",b3)	GEMS_PETD_01	9	179	f	\N	SS	1	IR Num Subsets	K
3380	(0009,"GEMS_PETD_01",b4)	(0009,"GEMS_PETD_01",b4)	GEMS_PETD_01	9	180	f	\N	FL	1	IR Recon FOV	K
3381	(0009,"GEMS_PETD_01",b5)	(0009,"GEMS_PETD_01",b5)	GEMS_PETD_01	9	181	f	\N	SS	1	IR Corr Model	K
3383	(0009,"GEMS_PETD_01",b7)	(0009,"GEMS_PETD_01",b7)	GEMS_PETD_01	9	183	f	\N	FL	1	IR Pre Filt Param	K
3384	(0009,"GEMS_PETD_01",b8)	(0009,"GEMS_PETD_01",b8)	GEMS_PETD_01	9	184	f	\N	FL	1	IR Loop Filt Param	K
3385	(0009,"GEMS_PETD_01",b9)	(0009,"GEMS_PETD_01",b9)	GEMS_PETD_01	9	185	f	\N	FL	1	Response Filt Param	K
3386	(0009,"GEMS_PETD_01",ba)	(0009,"GEMS_PETD_01",ba)	GEMS_PETD_01	9	186	f	\N	SS	1	Post Filter	K
3387	(0009,"GEMS_PETD_01",bb)	(0009,"GEMS_PETD_01",bb)	GEMS_PETD_01	9	187	f	\N	FL	1	Post Filter Param	K
3388	(0009,"GEMS_PETD_01",bc)	(0009,"GEMS_PETD_01",bc)	GEMS_PETD_01	9	188	f	\N	SS	1	IR Regularize	K
3389	(0009,"GEMS_PETD_01",bd)	(0009,"GEMS_PETD_01",bd)	GEMS_PETD_01	9	189	f	\N	FL	1	IR Regularize Param	K
3390	(0009,"GEMS_PETD_01",be)	(0009,"GEMS_PETD_01",be)	GEMS_PETD_01	9	190	f	\N	SS	1	AC BP Filter	K
3391	(0009,"GEMS_PETD_01",bf)	(0009,"GEMS_PETD_01",bf)	GEMS_PETD_01	9	191	f	\N	FL	1	AC BP Filt Cutoff	K
3392	(0009,"GEMS_PETD_01",c0)	(0009,"GEMS_PETD_01",c0)	GEMS_PETD_01	9	192	f	\N	SL	1	AC BP Filt Order	K
3393	(0009,"GEMS_PETD_01",c1)	(0009,"GEMS_PETD_01",c1)	GEMS_PETD_01	9	193	f	\N	SS	1	AC Img Smooth	K
3394	(0009,"GEMS_PETD_01",c2)	(0009,"GEMS_PETD_01",c2)	GEMS_PETD_01	9	194	f	\N	FL	1	AC Img Smooth Parm	K
3395	(0009,"GEMS_PETD_01",c3)	(0009,"GEMS_PETD_01",c3)	GEMS_PETD_01	9	195	f	\N	SL	1	Scatter Method	K
3396	(0009,"GEMS_PETD_01",c4)	(0009,"GEMS_PETD_01",c4)	GEMS_PETD_01	9	196	f	\N	SS	1	Scatter Num Iter	K
3397	(0009,"GEMS_PETD_01",c5)	(0009,"GEMS_PETD_01",c5)	GEMS_PETD_01	9	197	f	\N	FL	1	Scatter Parm	K
3398	(0009,"GEMS_PETD_01",c6)	(0009,"GEMS_PETD_01",c6)	GEMS_PETD_01	9	198	f	\N	FL	1	seg_qc_parm	K
3399	(0009,"GEMS_PETD_01",c7)	(0009,"GEMS_PETD_01",c7)	GEMS_PETD_01	9	199	f	\N	SL	1	overlap	K
3400	(0009,"GEMS_PETD_01",c8)	(0009,"GEMS_PETD_01",c8)	GEMS_PETD_01	9	200	f	\N	UI	1	ovlp_frm_id	R
3401	(0009,"GEMS_PETD_01",c9)	(0009,"GEMS_PETD_01",c9)	GEMS_PETD_01	9	201	f	\N	UI	1	ovlp_trans_frm_id	R
3402	(0009,"GEMS_PETD_01",ca)	(0009,"GEMS_PETD_01",ca)	GEMS_PETD_01	9	202	f	\N	UI	1	ovlp_tpulse_frm_id	R
3403	(0009,"GEMS_PETD_01",cb)	(0009,"GEMS_PETD_01",cb)	GEMS_PETD_01	9	203	f	\N	FL	1	vqc_x_axis_trans	K
3404	(0009,"GEMS_PETD_01",cc)	(0009,"GEMS_PETD_01",cc)	GEMS_PETD_01	9	204	f	\N	FL	1	vqc_x_axis_tilt	K
3406	(0009,"GEMS_PETD_01",ce)	(0009,"GEMS_PETD_01",ce)	GEMS_PETD_01	9	206	f	\N	FL	1	vqc_y_axis_swivel	K
3407	(0009,"GEMS_PETD_01",cf)	(0009,"GEMS_PETD_01",cf)	GEMS_PETD_01	9	207	f	\N	FL	1	vqc_z_axis_trans	K
3408	(0009,"GEMS_PETD_01",d0)	(0009,"GEMS_PETD_01",d0)	GEMS_PETD_01	9	208	f	\N	FL	1	vqc_z_axis_roll	K
3409	(0009,"GEMS_PETD_01",d1)	(0009,"GEMS_PETD_01",d1)	GEMS_PETD_01	9	209	f	\N	LO	1	ctac_conv_scale	R
3410	(0009,"GEMS_PETD_01",d2)	(0009,"GEMS_PETD_01",d2)	GEMS_PETD_01	9	210	f	\N	UI	1	image_set_id	R
3411	(0009,"GEMS_PETD_01",d3)	(0009,"GEMS_PETD_01",d3)	GEMS_PETD_01	9	211	f	\N	SL	1	contrast_route	K
3412	(0009,"GEMS_PETD_01",d4)	(0009,"GEMS_PETD_01",d4)	GEMS_PETD_01	9	212	f	\N	LO	1	ctac_conv_scale	R
3413	(0009,"GEMS_PETD_01",d5)	(0009,"GEMS_PETD_01",d5)	GEMS_PETD_01	9	213	f	\N	FL	1	loop_filter_parm	K
3414	(0009,"GEMS_PETD_01",d6)	(0009,"GEMS_PETD_01",d6)	GEMS_PETD_01	9	214	f	\N	FL	1	image_one_loc	K
3415	(0009,"GEMS_PETD_01",d7)	(0009,"GEMS_PETD_01",d7)	GEMS_PETD_01	9	215	f	\N	FL	1	image_index_loc	K
3416	(0009,"GEMS_PETD_01",d8)	(0009,"GEMS_PETD_01",d8)	GEMS_PETD_01	9	216	f	\N	SL	1	frame_number	K
3417	(0009,"GEMS_PETD_01",d9)	(0009,"GEMS_PETD_01",d9)	GEMS_PETD_01	9	217	f	\N	SL	1	list_file_exists	K
10973	(0119,"MRSC",11a4)	(0119,"MRSC",a4)	MRSC	281	164	t	11	DS	1-n	PhantValues	K
3438	(0011,"GEMS_PETD_01",18)	(0011,"GEMS_PETD_01",18)	GEMS_PETD_01	17	24	f	\N	OB	1	Unknown	\N
3478	(0023,"GEMS_PETD_01",01)	(0023,"GEMS_PETD_01",01)	GEMS_PETD_01	35	1	f	\N	OB	1	raw_data_blob	\N
3479	(5001,"GEMS_PETD_01",01)	(5001,"GEMS_PETD_01",01)	GEMS_PETD_01	20481	1	f	\N	UI	1	Curve ID	\N
3420	(0009,"GEMS_PETD_01",dc)	(0009,"GEMS_PETD_01",dc)	GEMS_PETD_01	9	220	f	\N	FL	1	ir_z_filter_ratio	K
3421	(0009,"GEMS_PETD_01",dd)	(0009,"GEMS_PETD_01",dd)	GEMS_PETD_01	9	221	f	\N	US	1	num_of_rr_interval	K
3422	(0009,"GEMS_PETD_01",de)	(0009,"GEMS_PETD_01",de)	GEMS_PETD_01	9	222	f	\N	US	1	num_of_time_slots	K
3423	(0009,"GEMS_PETD_01",df)	(0009,"GEMS_PETD_01",df)	GEMS_PETD_01	9	223	f	\N	US	1	num_of_slices	K
3424	(0009,"GEMS_PETD_01",e0)	(0009,"GEMS_PETD_01",e0)	GEMS_PETD_01	9	224	f	\N	US	1	num_of_time_slices	K
3425	(0009,"GEMS_PETD_01",e1)	(0009,"GEMS_PETD_01",e1)	GEMS_PETD_01	9	225	f	\N	SL	1	unlisted_scan	K
3426	(0009,"GEMS_PETD_01",e2)	(0009,"GEMS_PETD_01",e2)	GEMS_PETD_01	9	226	f	\N	SL	1	rest_stress	K
3427	(0009,"GEMS_PETD_01",e3)	(0009,"GEMS_PETD_01",e3)	GEMS_PETD_01	9	227	f	\N	FL	1	phase percentage	K
3428	(0009,"GEMS_PETD_01",e4)	(0009,"GEMS_PETD_01",e4)	GEMS_PETD_01	9	228	f	\N	ST	1	Unknown	R
3429	(0009,"GEMS_PETD_01",e5)	(0009,"GEMS_PETD_01",e5)	GEMS_PETD_01	9	229	f	\N	FL	1	left shift	K
3430	(0009,"GEMS_PETD_01",e6)	(0009,"GEMS_PETD_01",e6)	GEMS_PETD_01	9	230	f	\N	FL	1	posterior shift	K
3431	(0009,"GEMS_PETD_01",e7)	(0009,"GEMS_PETD_01",e7)	GEMS_PETD_01	9	231	f	\N	FL	1	superior shift	K
3432	(0009,"GEMS_PETD_01",e8)	(0009,"GEMS_PETD_01",e8)	GEMS_PETD_01	9	232	f	\N	SL	1	acq_bin_num	K
3433	(0009,"GEMS_PETD_01",e9)	(0009,"GEMS_PETD_01",e9)	GEMS_PETD_01	9	233	f	\N	FL	1	acq_bin_dur_percent	K
3434	(0009,"GEMS_PETD_01",ea)	(0009,"GEMS_PETD_01",ea)	GEMS_PETD_01	9	234	f	\N	SL	1	Unknown	K
3435	(0009,"GEMS_PETD_01",eb)	(0009,"GEMS_PETD_01",eb)	GEMS_PETD_01	9	235	f	\N	FL	1	Unknown	K
3436	(0009,"GEMS_PETD_01",ec)	(0009,"GEMS_PETD_01",ec)	GEMS_PETD_01	9	236	f	\N	SL	1	Unknown	K
3437	(0011,"GEMS_PETD_01",01)	(0011,"GEMS_PETD_01",01)	GEMS_PETD_01	17	1	f	\N	SQ	1	Unknown	X
3439	(0013,"GEMS_PETD_01",01)	(0013,"GEMS_PETD_01",01)	GEMS_PETD_01	19	1	f	\N	SQ	1	Unknown	X
3440	(0017,"GEMS_PETD_01",01)	(0017,"GEMS_PETD_01",01)	GEMS_PETD_01	23	1	f	\N	UI	1	correction_cal_id	R
3442	(0017,"GEMS_PETD_01",03)	(0017,"GEMS_PETD_01",03)	GEMS_PETD_01	23	3	f	\N	SH	1	software_version	K
3443	(0017,"GEMS_PETD_01",04)	(0017,"GEMS_PETD_01",04)	GEMS_PETD_01	23	4	f	\N	DT	1	cal_datetime	R
3444	(0017,"GEMS_PETD_01",05)	(0017,"GEMS_PETD_01",05)	GEMS_PETD_01	23	5	f	\N	LO	1	cal_datetime	K
3445	(0017,"GEMS_PETD_01",06)	(0017,"GEMS_PETD_01",06)	GEMS_PETD_01	23	6	f	\N	SL	1	cal_type	K
3446	(0017,"GEMS_PETD_01",07)	(0017,"GEMS_PETD_01",07)	GEMS_PETD_01	23	7	f	\N	ST	1	where_is_corr	K
3447	(0017,"GEMS_PETD_01",08)	(0017,"GEMS_PETD_01",08)	GEMS_PETD_01	23	8	f	\N	SL	1	corr_file_size	K
3448	(0017,"GEMS_PETD_01",09)	(0017,"GEMS_PETD_01",09)	GEMS_PETD_01	23	9	f	\N	LO	1	scan_id	R
3449	(0017,"GEMS_PETD_01",0a)	(0017,"GEMS_PETD_01",0a)	GEMS_PETD_01	23	10	f	\N	DT	1	scan_datetime	R
3450	(0017,"GEMS_PETD_01",0b)	(0017,"GEMS_PETD_01",0b)	GEMS_PETD_01	23	11	f	\N	LO	1	norm_2d_cal_id	R
3451	(0017,"GEMS_PETD_01",0c)	(0017,"GEMS_PETD_01",0c)	GEMS_PETD_01	23	12	f	\N	SH	1	hosp_identifier	R
3452	(0017,"GEMS_PETD_01",0d)	(0017,"GEMS_PETD_01",0d)	GEMS_PETD_01	23	13	f	\N	SL	1	archived	K
3453	(0019,"GEMS_PETD_01",01)	(0019,"GEMS_PETD_01",01)	GEMS_PETD_01	25	1	f	\N	UI	1	wc_cal_id	R
3454	(0019,"GEMS_PETD_01",02)	(0019,"GEMS_PETD_01",02)	GEMS_PETD_01	25	2	f	\N	SH	1	compatible_version	K
3455	(0019,"GEMS_PETD_01",03)	(0019,"GEMS_PETD_01",03)	GEMS_PETD_01	25	3	f	\N	SH	1	software_version	K
3456	(0019,"GEMS_PETD_01",04)	(0019,"GEMS_PETD_01",04)	GEMS_PETD_01	25	4	f	\N	DT	1	cal_datetime	R
3457	(0019,"GEMS_PETD_01",05)	(0019,"GEMS_PETD_01",05)	GEMS_PETD_01	25	5	f	\N	SL	1	cal_type	K
3458	(0019,"GEMS_PETD_01",06)	(0019,"GEMS_PETD_01",06)	GEMS_PETD_01	25	6	f	\N	LO	1	cal_description	R
3459	(0019,"GEMS_PETD_01",07)	(0019,"GEMS_PETD_01",07)	GEMS_PETD_01	25	7	f	\N	LO	1	cal_hardware	K
3460	(0019,"GEMS_PETD_01",08)	(0019,"GEMS_PETD_01",08)	GEMS_PETD_01	25	8	f	\N	OB	1	coefficients	K
3462	(0019,"GEMS_PETD_01",0a)	(0019,"GEMS_PETD_01",0a)	GEMS_PETD_01	25	10	f	\N	FL	1	activity_factor_hs	K
3463	(0019,"GEMS_PETD_01",0b)	(0019,"GEMS_PETD_01",0b)	GEMS_PETD_01	25	11	f	\N	FL	1	activity_factor_3d	K
3464	(0019,"GEMS_PETD_01",0c)	(0019,"GEMS_PETD_01",0c)	GEMS_PETD_01	25	12	f	\N	LO	1	scan_id	R
3465	(0019,"GEMS_PETD_01",0d)	(0019,"GEMS_PETD_01",0d)	GEMS_PETD_01	25	13	f	\N	DT	1	scan_datetime	R
3466	(0019,"GEMS_PETD_01",0e)	(0019,"GEMS_PETD_01",0e)	GEMS_PETD_01	25	14	f	\N	SH	1	hosp_identifier	R
3467	(0019,"GEMS_PETD_01",0f)	(0019,"GEMS_PETD_01",0f)	GEMS_PETD_01	25	15	f	\N	FL	1	meas_activity	K
3468	(0019,"GEMS_PETD_01",10)	(0019,"GEMS_PETD_01",10)	GEMS_PETD_01	25	16	f	\N	DT	1	meas_datetime	R
3469	(0019,"GEMS_PETD_01",11)	(0019,"GEMS_PETD_01",11)	GEMS_PETD_01	25	17	f	\N	SL	1	axial_filter_3d	K
3470	(0019,"GEMS_PETD_01",12)	(0019,"GEMS_PETD_01",12)	GEMS_PETD_01	25	18	f	\N	FL	1	axial_cutoff_3d	K
3471	(0019,"GEMS_PETD_01",13)	(0019,"GEMS_PETD_01",13)	GEMS_PETD_01	25	19	f	\N	SL	1	default_flag	K
3472	(0019,"GEMS_PETD_01",14)	(0019,"GEMS_PETD_01",14)	GEMS_PETD_01	25	20	f	\N	SL	1	archived	K
3473	(0019,"GEMS_PETD_01",15)	(0019,"GEMS_PETD_01",15)	GEMS_PETD_01	25	21	f	\N	SL	1	wc_cal_rec_method	K
3474	(0019,"GEMS_PETD_01",16)	(0019,"GEMS_PETD_01",16)	GEMS_PETD_01	25	22	f	\N	SL	1	activity_factor_2d	K
3475	(0019,"GEMS_PETD_01",17)	(0019,"GEMS_PETD_01",17)	GEMS_PETD_01	25	23	f	\N	SL	1	isotope	K
3476	(0021,"GEMS_PETD_01",01)	(0021,"GEMS_PETD_01",01)	GEMS_PETD_01	33	1	f	\N	US	1	raw_data_type	K
3477	(0021,"GEMS_PETD_01",02)	(0021,"GEMS_PETD_01",02)	GEMS_PETD_01	33	2	f	\N	UL	1	raw_data_size	K
3480	(5001,"GEMS_PETD_01",02)	(5001,"GEMS_PETD_01",02)	GEMS_PETD_01	20481	2	f	\N	SH	1	Curve Compatible Version	\N
3481	(5001,"GEMS_PETD_01",03)	(5001,"GEMS_PETD_01",03)	GEMS_PETD_01	20481	3	f	\N	SH	1	Curve Software Version	\N
3482	(5001,"GEMS_PETD_01",04)	(5001,"GEMS_PETD_01",04)	GEMS_PETD_01	20481	4	f	\N	SL	1	Statistics Type	\N
3483	(5001,"GEMS_PETD_01",05)	(5001,"GEMS_PETD_01",05)	GEMS_PETD_01	20481	5	f	\N	LT	1	How Derived	\N
3484	(5001,"GEMS_PETD_01",06)	(5001,"GEMS_PETD_01",06)	GEMS_PETD_01	20481	6	f	\N	SL	1	How Derived Size	\N
3485	(5001,"GEMS_PETD_01",07)	(5001,"GEMS_PETD_01",07)	GEMS_PETD_01	20481	7	f	\N	SL	1	Multi Patient	\N
3486	(5001,"GEMS_PETD_01",08)	(5001,"GEMS_PETD_01",08)	GEMS_PETD_01	20481	8	f	\N	SL	1	Deadtime	\N
3487	(5003,"GEMS_PETD_01",01)	(5003,"GEMS_PETD_01",01)	GEMS_PETD_01	20483	1	f	\N	SQ	1	Graph Sequence	\N
3488	(5003,"GEMS_PETD_01",02)	(5003,"GEMS_PETD_01",02)	GEMS_PETD_01	20483	2	f	\N	UI	1	Graph ID	\N
3489	(5003,"GEMS_PETD_01",03)	(5003,"GEMS_PETD_01",03)	GEMS_PETD_01	20483	3	f	\N	SH	1	Graph Compatible Version	\N
3490	(5003,"GEMS_PETD_01",04)	(5003,"GEMS_PETD_01",04)	GEMS_PETD_01	20483	4	f	\N	SH	1	Graph Software Version	\N
3491	(5003,"GEMS_PETD_01",05)	(5003,"GEMS_PETD_01",05)	GEMS_PETD_01	20483	5	f	\N	LO	1	Title	\N
3492	(5003,"GEMS_PETD_01",06)	(5003,"GEMS_PETD_01",06)	GEMS_PETD_01	20483	6	f	\N	DT	1	Graph Date Time	\N
3493	(5003,"GEMS_PETD_01",07)	(5003,"GEMS_PETD_01",07)	GEMS_PETD_01	20483	7	f	\N	ST	1	Graph Description	\N
3494	(5003,"GEMS_PETD_01",08)	(5003,"GEMS_PETD_01",08)	GEMS_PETD_01	20483	8	f	\N	LO	1	Title Font Name	\N
3495	(5003,"GEMS_PETD_01",09)	(5003,"GEMS_PETD_01",09)	GEMS_PETD_01	20483	9	f	\N	SH	1	Title Font Size	\N
3496	(5003,"GEMS_PETD_01",0a)	(5003,"GEMS_PETD_01",0a)	GEMS_PETD_01	20483	10	f	\N	LO	1	Footer	\N
3497	(5003,"GEMS_PETD_01",0b)	(5003,"GEMS_PETD_01",0b)	GEMS_PETD_01	20483	11	f	\N	SH	1	Footer Font Size	\N
3498	(5003,"GEMS_PETD_01",0c)	(5003,"GEMS_PETD_01",0c)	GEMS_PETD_01	20483	12	f	\N	LO	1	Foreground Color	\N
3499	(5003,"GEMS_PETD_01",0d)	(5003,"GEMS_PETD_01",0d)	GEMS_PETD_01	20483	13	f	\N	LO	1	Background Color	\N
3500	(5003,"GEMS_PETD_01",0e)	(5003,"GEMS_PETD_01",0e)	GEMS_PETD_01	20483	14	f	\N	SL	1	Graph Border	\N
3501	(5003,"GEMS_PETD_01",0f)	(5003,"GEMS_PETD_01",0f)	GEMS_PETD_01	20483	15	f	\N	SL	1	Graph Width	\N
3502	(5003,"GEMS_PETD_01",10)	(5003,"GEMS_PETD_01",10)	GEMS_PETD_01	20483	16	f	\N	SL	1	Graph Height	\N
3503	(5003,"GEMS_PETD_01",11)	(5003,"GEMS_PETD_01",11)	GEMS_PETD_01	20483	17	f	\N	SL	1	Grid	\N
3504	(5003,"GEMS_PETD_01",12)	(5003,"GEMS_PETD_01",12)	GEMS_PETD_01	20483	18	f	\N	LO	1	Label Font Name	\N
3505	(5003,"GEMS_PETD_01",13)	(5003,"GEMS_PETD_01",13)	GEMS_PETD_01	20483	19	f	\N	SH	1	Label Font Size	\N
3506	(5003,"GEMS_PETD_01",14)	(5003,"GEMS_PETD_01",14)	GEMS_PETD_01	20483	20	f	\N	LO	1	Axes Color	\N
3507	(5003,"GEMS_PETD_01",15)	(5003,"GEMS_PETD_01",15)	GEMS_PETD_01	20483	21	f	\N	LO	1	X Axis Label	\N
3508	(5003,"GEMS_PETD_01",16)	(5003,"GEMS_PETD_01",16)	GEMS_PETD_01	20483	22	f	\N	SL	1	X Axis Units	\N
3509	(5003,"GEMS_PETD_01",17)	(5003,"GEMS_PETD_01",17)	GEMS_PETD_01	20483	23	f	\N	FL	1	X Major Tics	\N
3510	(5003,"GEMS_PETD_01",18)	(5003,"GEMS_PETD_01",18)	GEMS_PETD_01	20483	24	f	\N	FL	1	X Axis Min	\N
3511	(5003,"GEMS_PETD_01",19)	(5003,"GEMS_PETD_01",19)	GEMS_PETD_01	20483	25	f	\N	FL	1	X Axis Max	\N
3512	(5003,"GEMS_PETD_01",1a)	(5003,"GEMS_PETD_01",1a)	GEMS_PETD_01	20483	26	f	\N	LO	1	Y Axis Label	\N
3513	(5003,"GEMS_PETD_01",1b)	(5003,"GEMS_PETD_01",1b)	GEMS_PETD_01	20483	27	f	\N	SL	1	Y Axis Units	\N
3514	(5003,"GEMS_PETD_01",1c)	(5003,"GEMS_PETD_01",1c)	GEMS_PETD_01	20483	28	f	\N	FL	1	Y Major Tics	\N
3515	(5003,"GEMS_PETD_01",1d)	(5003,"GEMS_PETD_01",1d)	GEMS_PETD_01	20483	29	f	\N	FL	1	Y Axis Min	\N
3516	(5003,"GEMS_PETD_01",1e)	(5003,"GEMS_PETD_01",1e)	GEMS_PETD_01	20483	30	f	\N	FL	1	Y Axis Max	\N
3517	(5003,"GEMS_PETD_01",1f)	(5003,"GEMS_PETD_01",1f)	GEMS_PETD_01	20483	31	f	\N	LO	1	Legend Font Name	\N
3518	(5003,"GEMS_PETD_01",20)	(5003,"GEMS_PETD_01",20)	GEMS_PETD_01	20483	32	f	\N	SH	1	Legend Font Size	\N
3519	(5003,"GEMS_PETD_01",21)	(5003,"GEMS_PETD_01",21)	GEMS_PETD_01	20483	33	f	\N	SL	1	Legend Location X	\N
3520	(5003,"GEMS_PETD_01",22)	(5003,"GEMS_PETD_01",22)	GEMS_PETD_01	20483	34	f	\N	SL	1	Legend Location Y	\N
3521	(5003,"GEMS_PETD_01",23)	(5003,"GEMS_PETD_01",23)	GEMS_PETD_01	20483	35	f	\N	SL	1	Legend Width	\N
3522	(5003,"GEMS_PETD_01",24)	(5003,"GEMS_PETD_01",24)	GEMS_PETD_01	20483	36	f	\N	SL	1	Legend Height	\N
3523	(5003,"GEMS_PETD_01",25)	(5003,"GEMS_PETD_01",25)	GEMS_PETD_01	20483	37	f	\N	SL	1	Legend Border	\N
3524	(5003,"GEMS_PETD_01",26)	(5003,"GEMS_PETD_01",26)	GEMS_PETD_01	20483	38	f	\N	SL	1	Multi Patient	\N
3525	(5005,"GEMS_PETD_01",01)	(5005,"GEMS_PETD_01",01)	GEMS_PETD_01	20485	1	f	\N	SQ	1	Curve Presentation Sequence	\N
3526	(5005,"GEMS_PETD_01",02)	(5005,"GEMS_PETD_01",02)	GEMS_PETD_01	20485	2	f	\N	UI	1	Curve Presentation ID	\N
3527	(5005,"GEMS_PETD_01",03)	(5005,"GEMS_PETD_01",03)	GEMS_PETD_01	20485	3	f	\N	UI	1	Graph ID	\N
3528	(5005,"GEMS_PETD_01",04)	(5005,"GEMS_PETD_01",04)	GEMS_PETD_01	20485	4	f	\N	UI	1	Curve ID	\N
3529	(5005,"GEMS_PETD_01",05)	(5005,"GEMS_PETD_01",05)	GEMS_PETD_01	20485	5	f	\N	SH	1	Curve Presentation Compatible Version	\N
3530	(5005,"GEMS_PETD_01",06)	(5005,"GEMS_PETD_01",06)	GEMS_PETD_01	20485	6	f	\N	SH	1	Curve Presentation Software Version	\N
3531	(5005,"GEMS_PETD_01",07)	(5005,"GEMS_PETD_01",07)	GEMS_PETD_01	20485	7	f	\N	LO	1	Curve Label	\N
3532	(5005,"GEMS_PETD_01",08)	(5005,"GEMS_PETD_01",08)	GEMS_PETD_01	20485	8	f	\N	LO	1	Color	\N
3533	(5005,"GEMS_PETD_01",09)	(5005,"GEMS_PETD_01",09)	GEMS_PETD_01	20485	9	f	\N	SL	1	Line Type	\N
3534	(5005,"GEMS_PETD_01",0a)	(5005,"GEMS_PETD_01",0a)	GEMS_PETD_01	20485	10	f	\N	SL	1	Line Width	\N
3535	(5005,"GEMS_PETD_01",0b)	(5005,"GEMS_PETD_01",0b)	GEMS_PETD_01	20485	11	f	\N	SL	1	Point Symbol	\N
3536	(5005,"GEMS_PETD_01",0c)	(5005,"GEMS_PETD_01",0c)	GEMS_PETD_01	20485	12	f	\N	SL	1	Point Symbol Dim	\N
3537	(5005,"GEMS_PETD_01",0d)	(5005,"GEMS_PETD_01",0d)	GEMS_PETD_01	20485	13	f	\N	LO	1	Point Color	\N
3538	(0009,"GEMS_GENIE_1",01)	(0009,"GEMS_GENIE_1",01)	GEMS_GENIE_1	9	1	f	\N	SH	1	Unknown	\N
3539	(0009,"GEMS_GENIE_1",28)	(0009,"GEMS_GENIE_1",28)	GEMS_GENIE_1	9	40	f	\N	SL	1	Number RR Windows	\N
3540	(0009,"GEMS_GENIE_1",2b)	(0009,"GEMS_GENIE_1",2b)	GEMS_GENIE_1	9	43	f	\N	LO	1	Trigger History UID	\N
3541	(0009,"GEMS_GENIE_1",2f)	(0009,"GEMS_GENIE_1",2f)	GEMS_GENIE_1	9	47	f	\N	SL	1	Table Direction	\N
3542	(0009,"GEMS_GENIE_1",33)	(0009,"GEMS_GENIE_1",33)	GEMS_GENIE_1	9	51	f	\N	FD	1	Rotational Continuous Speed	\N
3543	(0009,"GEMS_GENIE_1",34)	(0009,"GEMS_GENIE_1",34)	GEMS_GENIE_1	9	52	f	\N	SL	1	Gantry Motion Type (Retired)	\N
3544	(0009,"GEMS_GENIE_1",44)	(0009,"GEMS_GENIE_1",44)	GEMS_GENIE_1	9	68	f	\N	SL	1	Num Views Acquired (Retired)	\N
3545	(0009,"GEMS_GENIE_1",45)	(0009,"GEMS_GENIE_1",45)	GEMS_GENIE_1	9	69	f	\N	LT	1	Unknown	\N
3546	(0009,"GEMS_GENIE_1",46)	(0009,"GEMS_GENIE_1",46)	GEMS_GENIE_1	9	70	f	\N	UI	1	Unknown	\N
3547	(0011,"GEMS_GENIE_1",11)	(0011,"GEMS_GENIE_1",11)	GEMS_GENIE_1	17	17	f	\N	SL	1	Dataset Modified	\N
3548	(0011,"GEMS_GENIE_1",14)	(0011,"GEMS_GENIE_1",14)	GEMS_GENIE_1	17	20	f	\N	LO	1	Completion Time	\N
3549	(0011,"GEMS_GENIE_1",1e)	(0011,"GEMS_GENIE_1",1e)	GEMS_GENIE_1	17	30	f	\N	SL	4	Energy Width (Retired)	\N
3550	(0011,"GEMS_GENIE_1",21)	(0011,"GEMS_GENIE_1",21)	GEMS_GENIE_1	17	33	f	\N	DS	1	Acq Zoom (Retired)	\N
3551	(0011,"GEMS_GENIE_1",22)	(0011,"GEMS_GENIE_1",22)	GEMS_GENIE_1	17	34	f	\N	DS	1	Acq Pan (Retired)	\N
3552	(0011,"GEMS_GENIE_1",29)	(0011,"GEMS_GENIE_1",29)	GEMS_GENIE_1	17	41	f	\N	SL	1	Uniformity Mean	\N
3553	(0011,"GEMS_GENIE_1",2a)	(0011,"GEMS_GENIE_1",2a)	GEMS_GENIE_1	17	42	f	\N	FD	1	Phase Duration (Retired)	\N
3554	(0011,"GEMS_GENIE_1",2c)	(0011,"GEMS_GENIE_1",2c)	GEMS_GENIE_1	17	44	f	\N	FD	1	View X Adjustment	\N
3555	(0011,"GEMS_GENIE_1",2d)	(0011,"GEMS_GENIE_1",2d)	GEMS_GENIE_1	17	45	f	\N	FD	1	View Y Adjustment	\N
3556	(0011,"GEMS_GENIE_1",2e)	(0011,"GEMS_GENIE_1",2e)	GEMS_GENIE_1	17	46	f	\N	SL	1	Pixel Overflow Flag	\N
3557	(0011,"GEMS_GENIE_1",2f)	(0011,"GEMS_GENIE_1",2f)	GEMS_GENIE_1	17	47	f	\N	SL	1	Overflow Level	\N
3558	(0011,"GEMS_GENIE_1",31)	(0011,"GEMS_GENIE_1",31)	GEMS_GENIE_1	17	49	f	\N	LO	1	Acquisition Parent UID	\N
3559	(0011,"GEMS_GENIE_1",32)	(0011,"GEMS_GENIE_1",32)	GEMS_GENIE_1	17	50	f	\N	LO	1	Processing Parent UID	\N
3560	(0011,"GEMS_GENIE_1",39)	(0011,"GEMS_GENIE_1",39)	GEMS_GENIE_1	17	57	f	\N	SL	1	Compression Type	\N
3561	(0011,"GEMS_GENIE_1",3d)	(0011,"GEMS_GENIE_1",3d)	GEMS_GENIE_1	17	61	f	\N	SL	4	Energy Peak (Retired)	\N
3562	(0011,"GEMS_GENIE_1",40)	(0011,"GEMS_GENIE_1",40)	GEMS_GENIE_1	17	64	f	\N	LO	1	Viewing Object Name	\N
3563	(0011,"GEMS_GENIE_1",41)	(0011,"GEMS_GENIE_1",41)	GEMS_GENIE_1	17	65	f	\N	SL	1	Orientation Angle	\N
3564	(0011,"GEMS_GENIE_1",42)	(0011,"GEMS_GENIE_1",42)	GEMS_GENIE_1	17	66	f	\N	FD	1	Rotation Angle	\N
3565	(0011,"GEMS_GENIE_1",43)	(0011,"GEMS_GENIE_1",43)	GEMS_GENIE_1	17	67	f	\N	SL	1	Window Inverse Flag	\N
3566	(0011,"GEMS_GENIE_1",50)	(0011,"GEMS_GENIE_1",50)	GEMS_GENIE_1	17	80	f	\N	LO	1	Where Object Name	\N
3567	(0011,"GEMS_GENIE_1",57)	(0011,"GEMS_GENIE_1",57)	GEMS_GENIE_1	17	87	f	\N	FD	2	FOV	\N
3568	(0011,"GEMS_GENIE_1",61)	(0011,"GEMS_GENIE_1",61)	GEMS_GENIE_1	17	97	f	\N	SL	1	Image Size	\N
3569	(0011,"GEMS_GENIE_1",62)	(0011,"GEMS_GENIE_1",62)	GEMS_GENIE_1	17	98	f	\N	FD	1	Linear FOV	\N
3570	(0011,"GEMS_GENIE_1",63)	(0011,"GEMS_GENIE_1",63)	GEMS_GENIE_1	17	99	f	\N	FD	1	Spatial Offset	\N
3571	(0011,"GEMS_GENIE_1",64)	(0011,"GEMS_GENIE_1",64)	GEMS_GENIE_1	17	100	f	\N	FD	1	Spatial Orientation	\N
3572	(0011,"GEMS_GENIE_1",65)	(0011,"GEMS_GENIE_1",65)	GEMS_GENIE_1	17	101	f	\N	LO	1	Reference Dataset UID	\N
3573	(0011,"GEMS_GENIE_1",66)	(0011,"GEMS_GENIE_1",66)	GEMS_GENIE_1	17	102	f	\N	SH	1	Starcam Reference Dataset	\N
3574	(0011,"GEMS_GENIE_1",67)	(0011,"GEMS_GENIE_1",67)	GEMS_GENIE_1	17	103	f	\N	SL	1	Reference Frame Number	\N
3575	(0011,"GEMS_GENIE_1",68)	(0011,"GEMS_GENIE_1",68)	GEMS_GENIE_1	17	104	f	\N	SL	1	Cursor Length	\N
3576	(0011,"GEMS_GENIE_1",69)	(0011,"GEMS_GENIE_1",69)	GEMS_GENIE_1	17	105	f	\N	SL	1	Number of Cursors	\N
3577	(0011,"GEMS_GENIE_1",6a)	(0011,"GEMS_GENIE_1",6a)	GEMS_GENIE_1	17	106	f	\N	SL	1	Cursor Coordinates	\N
3578	(0011,"GEMS_GENIE_1",6b)	(0011,"GEMS_GENIE_1",6b)	GEMS_GENIE_1	17	107	f	\N	SL	1	Recon Options Flag	\N
3579	(0011,"GEMS_GENIE_1",6c)	(0011,"GEMS_GENIE_1",6c)	GEMS_GENIE_1	17	108	f	\N	FD	1	Motion Threshold	\N
3580	(0011,"GEMS_GENIE_1",6d)	(0011,"GEMS_GENIE_1",6d)	GEMS_GENIE_1	17	109	f	\N	UI	1	Motion Curve UID	\N
3581	(0011,"GEMS_GENIE_1",6e)	(0011,"GEMS_GENIE_1",6e)	GEMS_GENIE_1	17	110	f	\N	SL	1	Recon Type	\N
3582	(0011,"GEMS_GENIE_1",6f)	(0011,"GEMS_GENIE_1",6f)	GEMS_GENIE_1	17	111	f	\N	SL	1	Pre Filter Type	\N
3583	(0011,"GEMS_GENIE_1",71)	(0011,"GEMS_GENIE_1",71)	GEMS_GENIE_1	17	113	f	\N	SL	1	Back Proj Filter Type	\N
3584	(0011,"GEMS_GENIE_1",72)	(0011,"GEMS_GENIE_1",72)	GEMS_GENIE_1	17	114	f	\N	SL	1	Recon Arc	\N
3585	(0011,"GEMS_GENIE_1",73)	(0011,"GEMS_GENIE_1",73)	GEMS_GENIE_1	17	115	f	\N	FD	1	Recon Pan AP Offset	\N
3586	(0011,"GEMS_GENIE_1",74)	(0011,"GEMS_GENIE_1",74)	GEMS_GENIE_1	17	116	f	\N	FD	1	Recon Pan LR Offset	\N
3587	(0011,"GEMS_GENIE_1",75)	(0011,"GEMS_GENIE_1",75)	GEMS_GENIE_1	17	117	f	\N	FD	1	Recon Area	\N
3588	(0011,"GEMS_GENIE_1",76)	(0011,"GEMS_GENIE_1",76)	GEMS_GENIE_1	17	118	f	\N	SL	1	Start View	\N
3589	(0011,"GEMS_GENIE_1",77)	(0011,"GEMS_GENIE_1",77)	GEMS_GENIE_1	17	119	f	\N	SL	1	Attenuation Type	\N
3590	(0011,"GEMS_GENIE_1",78)	(0011,"GEMS_GENIE_1",78)	GEMS_GENIE_1	17	120	f	\N	SL	1	Dua lEnergy Processing	\N
3591	(0011,"GEMS_GENIE_1",79)	(0011,"GEMS_GENIE_1",79)	GEMS_GENIE_1	17	121	f	\N	SH	1	Pre Filter Param	\N
3592	(0011,"GEMS_GENIE_1",7a)	(0011,"GEMS_GENIE_1",7a)	GEMS_GENIE_1	17	122	f	\N	SH	1	Pre Filter Param 2	\N
3593	(0011,"GEMS_GENIE_1",7b)	(0011,"GEMS_GENIE_1",7b)	GEMS_GENIE_1	17	123	f	\N	SH	1	Back Proj Filter Param	\N
3594	(0011,"GEMS_GENIE_1",7c)	(0011,"GEMS_GENIE_1",7c)	GEMS_GENIE_1	17	124	f	\N	SH	1	Back Proj Filter Param 2	\N
3595	(0011,"GEMS_GENIE_1",7d)	(0011,"GEMS_GENIE_1",7d)	GEMS_GENIE_1	17	125	f	\N	SH	1	Attenuation Coef	\N
3596	(0011,"GEMS_GENIE_1",7e)	(0011,"GEMS_GENIE_1",7e)	GEMS_GENIE_1	17	126	f	\N	SL	1	Ref Slice Width	\N
3597	(0011,"GEMS_GENIE_1",7f)	(0011,"GEMS_GENIE_1",7f)	GEMS_GENIE_1	17	127	f	\N	FD	1	Ref Trans Pixel Volume	\N
3598	(0011,"GEMS_GENIE_1",81)	(0011,"GEMS_GENIE_1",81)	GEMS_GENIE_1	17	129	f	\N	SH	1	Attenuation Threshold	\N
3599	(0011,"GEMS_GENIE_1",82)	(0011,"GEMS_GENIE_1",82)	GEMS_GENIE_1	17	130	f	\N	FD	1	Interpolation Distance	\N
3600	(0011,"GEMS_GENIE_1",83)	(0011,"GEMS_GENIE_1",83)	GEMS_GENIE_1	17	131	f	\N	FD	1	Interpolation Center X	\N
3601	(0011,"GEMS_GENIE_1",84)	(0011,"GEMS_GENIE_1",84)	GEMS_GENIE_1	17	132	f	\N	FD	1	Interpolation Center Y	\N
3602	(0011,"GEMS_GENIE_1",85)	(0011,"GEMS_GENIE_1",85)	GEMS_GENIE_1	17	133	f	\N	SL	1	Quant Filter Flag	\N
3603	(0011,"GEMS_GENIE_1",86)	(0011,"GEMS_GENIE_1",86)	GEMS_GENIE_1	17	134	f	\N	SL	1	Head Conversion	\N
3604	(0011,"GEMS_GENIE_1",87)	(0011,"GEMS_GENIE_1",87)	GEMS_GENIE_1	17	135	f	\N	SL	1	Slice Width Pixels	\N
3605	(0011,"GEMS_GENIE_1",88)	(0011,"GEMS_GENIE_1",88)	GEMS_GENIE_1	17	136	f	\N	SL	1	Rfmtr Trans Ref	\N
3606	(0011,"GEMS_GENIE_1",89)	(0011,"GEMS_GENIE_1",89)	GEMS_GENIE_1	17	137	f	\N	FD	1	Rfmtr Trans Ref mm	\N
3607	(0011,"GEMS_GENIE_1",8a)	(0011,"GEMS_GENIE_1",8a)	GEMS_GENIE_1	17	138	f	\N	SL	1	Two Line Trans Ref	\N
3608	(0011,"GEMS_GENIE_1",8b)	(0011,"GEMS_GENIE_1",8b)	GEMS_GENIE_1	17	139	f	\N	SL	1	Three-D Zero	\N
3609	(0011,"GEMS_GENIE_1",8c)	(0011,"GEMS_GENIE_1",8c)	GEMS_GENIE_1	17	140	f	\N	SL	1	Three-D Zero Length	\N
3610	(0011,"GEMS_GENIE_1",8d)	(0011,"GEMS_GENIE_1",8d)	GEMS_GENIE_1	17	141	f	\N	SL	1	Three-D Zero In	\N
3611	(0011,"GEMS_DL_PATNT_01",80)	(0011,"GEMS_DL_PATNT_01",80)	GEMS_DL_PATNT_01	17	128	f	\N	UI	1	Patient Instance Uid	\N
3612	(0011,"GEMS_DL_PATNT_01",81)	(0011,"GEMS_DL_PATNT_01",81)	GEMS_DL_PATNT_01	17	129	f	\N	IS	1	Last Study Number	\N
3613	(0011,"GEMS_DL_PATNT_01",82)	(0011,"GEMS_DL_PATNT_01",82)	GEMS_DL_PATNT_01	17	130	f	\N	CS	1	Patient Repaired	\N
3614	(0011,"GEMS_DL_PATNT_01",83)	(0011,"GEMS_DL_PATNT_01",83)	GEMS_DL_PATNT_01	17	131	f	\N	CS	1	Lock Demographics	\N
3615	(0013,"GEMS_GENIE_1",13)	(0013,"GEMS_GENIE_1",13)	GEMS_GENIE_1	19	19	f	\N	SQ	1	eNTEGRA Frame Sequence	\N
3616	(0013,"GEMS_GENIE_1",14)	(0013,"GEMS_GENIE_1",14)	GEMS_GENIE_1	19	20	f	\N	SL	1	Original Image Number	\N
3617	(0013,"GEMS_GENIE_1",15)	(0013,"GEMS_GENIE_1",15)	GEMS_GENIE_1	19	21	f	\N	FD	1	Fscalar	\N
3618	(0013,"GEMS_GENIE_1",1b)	(0013,"GEMS_GENIE_1",1b)	GEMS_GENIE_1	19	27	f	\N	FD	1	Det Ang Separation	\N
3619	(0013,"GEMS_GENIE_1",20)	(0013,"GEMS_GENIE_1",20)	GEMS_GENIE_1	19	32	f	\N	FD	1	Accepted Beats Time	\N
3620	(0013,"GEMS_GENIE_1",21)	(0013,"GEMS_GENIE_1",21)	GEMS_GENIE_1	19	33	f	\N	FD	2	Threshold	\N
3621	(0013,"GEMS_GENIE_1",22)	(0013,"GEMS_GENIE_1",22)	GEMS_GENIE_1	19	34	f	\N	FD	2	Linear Depth	\N
3622	(0013,"GEMS_GENIE_1",23)	(0013,"GEMS_GENIE_1",23)	GEMS_GENIE_1	19	35	f	\N	LO	1	Unif Date Time	\N
3623	(0013,"GEMS_GENIE_1",24)	(0013,"GEMS_GENIE_1",24)	GEMS_GENIE_1	19	36	f	\N	SL	1	Series Accepted Beats	\N
3624	(0013,"GEMS_GENIE_1",25)	(0013,"GEMS_GENIE_1",25)	GEMS_GENIE_1	19	37	f	\N	SL	1	Series Rejected Beats	\N
3625	(0015,"GEMS_GENIE_1",10)	(0015,"GEMS_GENIE_1",10)	GEMS_GENIE_1	21	16	f	\N	SL	1	Frame Termination Condition	\N
3626	(0015,"GEMS_GENIE_1",11)	(0015,"GEMS_GENIE_1",11)	GEMS_GENIE_1	21	17	f	\N	SL	1	Frame Termination Value	\N
3627	(0015,"GEMS_GENIE_1",12)	(0015,"GEMS_GENIE_1",12)	GEMS_GENIE_1	21	18	f	\N	SL	1	Num ECT Phases	\N
3628	(0015,"GEMS_GENIE_1",13)	(0015,"GEMS_GENIE_1",13)	GEMS_GENIE_1	21	19	f	\N	SL	1	Num WB Scans	\N
3629	(0015,"GEMS_GENIE_1",14)	(0015,"GEMS_GENIE_1",14)	GEMS_GENIE_1	21	20	f	\N	SL	1	ECT Phase Num	\N
3630	(0015,"GEMS_GENIE_1",15)	(0015,"GEMS_GENIE_1",15)	GEMS_GENIE_1	21	21	f	\N	SL	1	WB Scan Num	\N
3631	(0015,"GEMS_GENIE_1",16)	(0015,"GEMS_GENIE_1",16)	GEMS_GENIE_1	21	22	f	\N	SL	1	Comb Head Number	\N
3632	(0015,"GEMS_GENIE_1",17)	(0015,"GEMS_GENIE_1",17)	GEMS_GENIE_1	21	23	f	\N	UL	1	Preceding Beat	\N
3633	(0015,"GEMS_DL_STUDY_01",80)	(0015,"GEMS_DL_STUDY_01",80)	GEMS_DL_STUDY_01	21	128	f	\N	DS	1	Study Dose	\N
3634	(0015,"GEMS_DL_STUDY_01",81)	(0015,"GEMS_DL_STUDY_01",81)	GEMS_DL_STUDY_01	21	129	f	\N	DS	1	Study Total Dap	\N
3635	(0015,"GEMS_DL_STUDY_01",82)	(0015,"GEMS_DL_STUDY_01",82)	GEMS_DL_STUDY_01	21	130	f	\N	DS	1	Fluoro Dose Area Product	\N
3636	(0015,"GEMS_DL_STUDY_01",83)	(0015,"GEMS_DL_STUDY_01",83)	GEMS_DL_STUDY_01	21	131	f	\N	IS	1	Study Fluoro Time	\N
3637	(0015,"GEMS_DL_STUDY_01",84)	(0015,"GEMS_DL_STUDY_01",84)	GEMS_DL_STUDY_01	21	132	f	\N	DS	1	Cine Dose Area Product	\N
3638	(0015,"GEMS_DL_STUDY_01",85)	(0015,"GEMS_DL_STUDY_01",85)	GEMS_DL_STUDY_01	21	133	f	\N	IS	1	Study Record Time	\N
3639	(0015,"GEMS_DL_STUDY_01",86)	(0015,"GEMS_DL_STUDY_01",86)	GEMS_DL_STUDY_01	21	134	f	\N	IS	1	Last XA Number	\N
3640	(0015,"GEMS_DL_STUDY_01",88)	(0015,"GEMS_DL_STUDY_01",88)	GEMS_DL_STUDY_01	21	136	f	\N	PN	1-n	Def Operator Name	\N
3641	(0015,"GEMS_DL_STUDY_01",89)	(0015,"GEMS_DL_STUDY_01",89)	GEMS_DL_STUDY_01	21	137	f	\N	PN	1-n	Def Performing Physician Name	\N
3642	(0015,"GEMS_DL_STUDY_01",8a)	(0015,"GEMS_DL_STUDY_01",8a)	GEMS_DL_STUDY_01	21	138	f	\N	CS	2	Def Patient Orientation	\N
3643	(0015,"GEMS_DL_STUDY_01",8b)	(0015,"GEMS_DL_STUDY_01",8b)	GEMS_DL_STUDY_01	21	139	f	\N	IS	1	Last Sc Number	\N
3644	(0015,"GEMS_DL_STUDY_01",8e)	(0015,"GEMS_DL_STUDY_01",8e)	GEMS_DL_STUDY_01	21	142	f	\N	UI	1	Common Series Instance UID	\N
3645	(0015,"GEMS_DL_STUDY_01",8f)	(0015,"GEMS_DL_STUDY_01",8f)	GEMS_DL_STUDY_01	21	143	f	\N	IS	1	Study Number	\N
3646	(0015,"GEMS_DL_STUDY_01",92)	(0015,"GEMS_DL_STUDY_01",92)	GEMS_DL_STUDY_01	21	146	f	\N	FL	1	Unknown	\N
3647	(0015,"GEMS_DL_STUDY_01",93)	(0015,"GEMS_DL_STUDY_01",93)	GEMS_DL_STUDY_01	21	147	f	\N	FL	1	Unknown	\N
3648	(0015,"GEMS_DL_STUDY_01",94)	(0015,"GEMS_DL_STUDY_01",94)	GEMS_DL_STUDY_01	21	148	f	\N	FL	1	Unknown	\N
3649	(0015,"GEMS_DL_STUDY_01",95)	(0015,"GEMS_DL_STUDY_01",95)	GEMS_DL_STUDY_01	21	149	f	\N	IS	1	Unknown	\N
3650	(0015,"GEMS_DL_STUDY_01",96)	(0015,"GEMS_DL_STUDY_01",96)	GEMS_DL_STUDY_01	21	150	f	\N	FL	1	Unknown	\N
3651	(0015,"GEMS_DL_STUDY_01",97)	(0015,"GEMS_DL_STUDY_01",97)	GEMS_DL_STUDY_01	21	151	f	\N	IS	1	Unknown	\N
3652	(0015,"GEMS_DL_STUDY_01",98)	(0015,"GEMS_DL_STUDY_01",98)	GEMS_DL_STUDY_01	21	152	f	\N	FL	1	Unknown	\N
3653	(0015,"GEMS_DL_STUDY_01",99)	(0015,"GEMS_DL_STUDY_01",99)	GEMS_DL_STUDY_01	21	153	f	\N	FL	1	Unknown	\N
3654	(0015,"GEMS_DL_STUDY_01",9a)	(0015,"GEMS_DL_STUDY_01",9a)	GEMS_DL_STUDY_01	21	154	f	\N	FL	1	Unknown	\N
3655	(0015,"GEMS_DL_STUDY_01",9b)	(0015,"GEMS_DL_STUDY_01",9b)	GEMS_DL_STUDY_01	21	155	f	\N	IS	1	Unknown	\N
3656	(0015,"GEMS_DL_STUDY_01",9c)	(0015,"GEMS_DL_STUDY_01",9c)	GEMS_DL_STUDY_01	21	156	f	\N	FL	1	Unknown	\N
3657	(0015,"GEMS_DL_STUDY_01",9d)	(0015,"GEMS_DL_STUDY_01",9d)	GEMS_DL_STUDY_01	21	157	f	\N	IS	1	Unknown	\N
3658	(0015,"GEMS_DL_SERIES_01",85)	(0015,"GEMS_DL_SERIES_01",85)	GEMS_DL_SERIES_01	21	133	f	\N	LO	1	Series File Name	\N
3659	(0015,"GEMS_DL_SERIES_01",87)	(0015,"GEMS_DL_SERIES_01",87)	GEMS_DL_SERIES_01	21	135	f	\N	IS	1	Number of Images	\N
3660	(0015,"GEMS_DL_SERIES_01",8c)	(0015,"GEMS_DL_SERIES_01",8c)	GEMS_DL_SERIES_01	21	140	f	\N	CS	1	Sent Flag	\N
3661	(0015,"GEMS_DL_SERIES_01",8d)	(0015,"GEMS_DL_SERIES_01",8d)	GEMS_DL_SERIES_01	21	141	f	\N	US	1	Item Locked	\N
3662	(0019,"GEMS_GENIE_1",5f)	(0019,"GEMS_GENIE_1",5f)	GEMS_GENIE_1	25	95	f	\N	SQ	1	Unknown	\N
3663	(0019,"GEMS_DL_IMG_01",0b)	(0019,"GEMS_DL_IMG_01",0b)	GEMS_DL_IMG_01	25	11	f	\N	DS	1-2	FOV Dimension Double	\N
3664	(0019,"GEMS_DL_IMG_01",2b)	(0019,"GEMS_DL_IMG_01",2b)	GEMS_DL_IMG_01	25	43	f	\N	FL	1	Distance to table top	\N
3665	(0019,"GEMS_DL_IMG_01",30)	(0019,"GEMS_DL_IMG_01",30)	GEMS_DL_IMG_01	25	48	f	\N	LO	1	Image File Name	\N
3666	(0019,"GEMS_DL_IMG_01",31)	(0019,"GEMS_DL_IMG_01",31)	GEMS_DL_IMG_01	25	49	f	\N	IS	1	Default Spatial Filter Family	\N
3667	(0019,"GEMS_DL_IMG_01",32)	(0019,"GEMS_DL_IMG_01",32)	GEMS_DL_IMG_01	25	50	f	\N	IS	1	Default Spatial Filter Strength	\N
3668	(0019,"GEMS_DL_IMG_01",33)	(0019,"GEMS_DL_IMG_01",33)	GEMS_DL_IMG_01	25	51	f	\N	DS	1	Min Saturation Dose	\N
3669	(0019,"GEMS_DL_IMG_01",34)	(0019,"GEMS_DL_IMG_01",34)	GEMS_DL_IMG_01	25	52	f	\N	DS	1	Detector Gain	\N
3670	(0019,"GEMS_DL_IMG_01",35)	(0019,"GEMS_DL_IMG_01",35)	GEMS_DL_IMG_01	25	53	f	\N	DS	1	Patient Dose Limit	\N
3671	(0019,"GEMS_DL_IMG_01",36)	(0019,"GEMS_DL_IMG_01",36)	GEMS_DL_IMG_01	25	54	f	\N	DS	1	Preproc Image Rate Max	\N
3672	(0019,"GEMS_DL_IMG_01",37)	(0019,"GEMS_DL_IMG_01",37)	GEMS_DL_IMG_01	25	55	f	\N	CS	1	Sensor Roi Shape	\N
3673	(0019,"GEMS_DL_IMG_01",38)	(0019,"GEMS_DL_IMG_01",38)	GEMS_DL_IMG_01	25	56	f	\N	DS	1	Sensor Roi x Position	\N
3674	(0019,"GEMS_DL_IMG_01",39)	(0019,"GEMS_DL_IMG_01",39)	GEMS_DL_IMG_01	25	57	f	\N	DS	1	Sensor Roi y Position	\N
3675	(0019,"GEMS_DL_IMG_01",3a)	(0019,"GEMS_DL_IMG_01",3a)	GEMS_DL_IMG_01	25	58	f	\N	DS	1	Sensor Roi x Size	\N
3676	(0019,"GEMS_DL_IMG_01",3b)	(0019,"GEMS_DL_IMG_01",3b)	GEMS_DL_IMG_01	25	59	f	\N	DS	1	Sensor Roi y Size	\N
3677	(0019,"GEMS_DL_IMG_01",3d)	(0019,"GEMS_DL_IMG_01",3d)	GEMS_DL_IMG_01	25	61	f	\N	DS	1	Noise Sensitivity	\N
3678	(0019,"GEMS_DL_IMG_01",3e)	(0019,"GEMS_DL_IMG_01",3e)	GEMS_DL_IMG_01	25	62	f	\N	DS	1	Sharp Sensitivity	\N
3679	(0019,"GEMS_DL_IMG_01",3f)	(0019,"GEMS_DL_IMG_01",3f)	GEMS_DL_IMG_01	25	63	f	\N	DS	1	Contrast Sensitivity	\N
3680	(0019,"GEMS_DL_IMG_01",40)	(0019,"GEMS_DL_IMG_01",40)	GEMS_DL_IMG_01	25	64	f	\N	DS	1	Lag Sensitivity	\N
3681	(0019,"GEMS_DL_IMG_01",41)	(0019,"GEMS_DL_IMG_01",41)	GEMS_DL_IMG_01	25	65	f	\N	CS	1	Tube	\N
3682	(0019,"GEMS_DL_IMG_01",42)	(0019,"GEMS_DL_IMG_01",42)	GEMS_DL_IMG_01	25	66	f	\N	US	1	Detector Size Rows	\N
3683	(0019,"GEMS_DL_IMG_01",43)	(0019,"GEMS_DL_IMG_01",43)	GEMS_DL_IMG_01	25	67	f	\N	US	1	Detector Size Columns	\N
3684	(0019,"GEMS_DL_IMG_01",44)	(0019,"GEMS_DL_IMG_01",44)	GEMS_DL_IMG_01	25	68	f	\N	DS	1	Min Object Size	\N
3685	(0019,"GEMS_DL_IMG_01",45)	(0019,"GEMS_DL_IMG_01",45)	GEMS_DL_IMG_01	25	69	f	\N	DS	1	Max Object Size	\N
3686	(0019,"GEMS_DL_IMG_01",46)	(0019,"GEMS_DL_IMG_01",46)	GEMS_DL_IMG_01	25	70	f	\N	DS	1	Max Object Speed	\N
3687	(0019,"GEMS_DL_IMG_01",47)	(0019,"GEMS_DL_IMG_01",47)	GEMS_DL_IMG_01	25	71	f	\N	CS	1	Object Back Motion	\N
3688	(0019,"GEMS_DL_IMG_01",48)	(0019,"GEMS_DL_IMG_01",48)	GEMS_DL_IMG_01	25	72	f	\N	UL	1	Exposure Trajectory Family	\N
3689	(0019,"GEMS_DL_IMG_01",49)	(0019,"GEMS_DL_IMG_01",49)	GEMS_DL_IMG_01	25	73	f	\N	DS	1	Window Time Duration	\N
3690	(0019,"GEMS_DL_IMG_01",4a)	(0019,"GEMS_DL_IMG_01",4a)	GEMS_DL_IMG_01	25	74	f	\N	CS	1	Positioner Angle Display Mode	\N
3691	(0019,"GEMS_DL_IMG_01",4b)	(0019,"GEMS_DL_IMG_01",4b)	GEMS_DL_IMG_01	25	75	f	\N	IS	2	Detector Origin	\N
3692	(0019,"GEMS_DL_IMG_01",4c)	(0019,"GEMS_DL_IMG_01",4c)	GEMS_DL_IMG_01	25	76	f	\N	CS	1	Unknown	\N
3693	(0019,"GEMS_DL_IMG_01",4e)	(0019,"GEMS_DL_IMG_01",4e)	GEMS_DL_IMG_01	25	78	f	\N	DS	2	Default Brightness and Contrast	\N
3694	(0019,"GEMS_DL_IMG_01",4f)	(0019,"GEMS_DL_IMG_01",4f)	GEMS_DL_IMG_01	25	79	f	\N	DS	2	User Brightness and Contrast	\N
3695	(0019,"GEMS_DL_IMG_01",50)	(0019,"GEMS_DL_IMG_01",50)	GEMS_DL_IMG_01	25	80	f	\N	IS	1	Source Series Number	\N
3696	(0019,"GEMS_DL_IMG_01",51)	(0019,"GEMS_DL_IMG_01",51)	GEMS_DL_IMG_01	25	81	f	\N	IS	1	Source Image Number	\N
3697	(0019,"GEMS_DL_IMG_01",52)	(0019,"GEMS_DL_IMG_01",52)	GEMS_DL_IMG_01	25	82	f	\N	IS	1	Source Frame Number	\N
3698	(0019,"GEMS_DL_IMG_01",53)	(0019,"GEMS_DL_IMG_01",53)	GEMS_DL_IMG_01	25	83	f	\N	UI	1	Source Series Item Id	\N
3699	(0019,"GEMS_DL_IMG_01",54)	(0019,"GEMS_DL_IMG_01",54)	GEMS_DL_IMG_01	25	84	f	\N	UI	1	Source Image Item Id	\N
3700	(0019,"GEMS_DL_IMG_01",55)	(0019,"GEMS_DL_IMG_01",55)	GEMS_DL_IMG_01	25	85	f	\N	UI	1	Source Frame Item Id	\N
3701	(0019,"GEMS_DL_IMG_01",60)	(0019,"GEMS_DL_IMG_01",60)	GEMS_DL_IMG_01	25	96	f	\N	US	1	Number of Points Before Acquisition	\N
3702	(0019,"GEMS_DL_IMG_01",61)	(0019,"GEMS_DL_IMG_01",61)	GEMS_DL_IMG_01	25	97	f	\N	OW	1	Curve Data Before Acquisition	\N
3703	(0019,"GEMS_DL_IMG_01",62)	(0019,"GEMS_DL_IMG_01",62)	GEMS_DL_IMG_01	25	98	f	\N	US	1	Number of Points Trigger	\N
3704	(0019,"GEMS_DL_IMG_01",63)	(0019,"GEMS_DL_IMG_01",63)	GEMS_DL_IMG_01	25	99	f	\N	OW	1	Curve Data Trigger	\N
3705	(0019,"GEMS_DL_IMG_01",64)	(0019,"GEMS_DL_IMG_01",64)	GEMS_DL_IMG_01	25	100	f	\N	SH	1	ECG Synchronization	\N
3706	(0019,"GEMS_DL_IMG_01",65)	(0019,"GEMS_DL_IMG_01",65)	GEMS_DL_IMG_01	25	101	f	\N	SH	1	ECG Delay Mode	\N
3707	(0019,"GEMS_DL_IMG_01",66)	(0019,"GEMS_DL_IMG_01",66)	GEMS_DL_IMG_01	25	102	f	\N	IS	1-n	ECG Delay Vector	\N
3708	(0019,"GEMS_DL_IMG_01",67)	(0019,"GEMS_DL_IMG_01",67)	GEMS_DL_IMG_01	25	103	f	\N	DS	1	Unknown	\N
3709	(0019,"GEMS_DL_IMG_01",68)	(0019,"GEMS_DL_IMG_01",68)	GEMS_DL_IMG_01	25	104	f	\N	DS	1	Unknown	\N
3710	(0019,"GEMS_DL_IMG_01",69)	(0019,"GEMS_DL_IMG_01",69)	GEMS_DL_IMG_01	25	105	f	\N	DS	1	Unknown	\N
3711	(0019,"GEMS_DL_IMG_01",7a)	(0019,"GEMS_DL_IMG_01",7a)	GEMS_DL_IMG_01	25	122	f	\N	DS	1	Unknown	\N
3712	(0019,"GEMS_DL_IMG_01",7b)	(0019,"GEMS_DL_IMG_01",7b)	GEMS_DL_IMG_01	25	123	f	\N	DS	1	Unknown	\N
3713	(0019,"GEMS_DL_IMG_01",7c)	(0019,"GEMS_DL_IMG_01",7c)	GEMS_DL_IMG_01	25	124	f	\N	DS	1	Unknown	\N
3714	(0019,"GEMS_DL_IMG_01",80)	(0019,"GEMS_DL_IMG_01",80)	GEMS_DL_IMG_01	25	128	f	\N	DS	1	Image Dose	\N
3715	(0019,"GEMS_DL_IMG_01",81)	(0019,"GEMS_DL_IMG_01",81)	GEMS_DL_IMG_01	25	129	f	\N	US	1	Calibration Frame	\N
3716	(0019,"GEMS_DL_IMG_01",82)	(0019,"GEMS_DL_IMG_01",82)	GEMS_DL_IMG_01	25	130	f	\N	CS	1	Calibration Object	\N
3717	(0019,"GEMS_DL_IMG_01",83)	(0019,"GEMS_DL_IMG_01",83)	GEMS_DL_IMG_01	25	131	f	\N	DS	1	Calibration Object Size mm	\N
3718	(0019,"GEMS_DL_IMG_01",84)	(0019,"GEMS_DL_IMG_01",84)	GEMS_DL_IMG_01	25	132	f	\N	FL	1	Calibration Factor	\N
3719	(0019,"GEMS_DL_IMG_01",85)	(0019,"GEMS_DL_IMG_01",85)	GEMS_DL_IMG_01	25	133	f	\N	DA	1	Calibration Date	\N
3720	(0019,"GEMS_DL_IMG_01",86)	(0019,"GEMS_DL_IMG_01",86)	GEMS_DL_IMG_01	25	134	f	\N	TM	1	Calibration Time	\N
3721	(0019,"GEMS_DL_IMG_01",87)	(0019,"GEMS_DL_IMG_01",87)	GEMS_DL_IMG_01	25	135	f	\N	US	1	Calibration Accuracy	\N
3722	(0019,"GEMS_DL_IMG_01",88)	(0019,"GEMS_DL_IMG_01",88)	GEMS_DL_IMG_01	25	136	f	\N	CS	1	Calibration Extended	\N
3723	(0019,"GEMS_DL_IMG_01",89)	(0019,"GEMS_DL_IMG_01",89)	GEMS_DL_IMG_01	25	137	f	\N	US	1	Calibration Image Original	\N
3724	(0019,"GEMS_DL_IMG_01",8a)	(0019,"GEMS_DL_IMG_01",8a)	GEMS_DL_IMG_01	25	138	f	\N	US	1	Calibration Frame Original	\N
3725	(0019,"GEMS_DL_IMG_01",8b)	(0019,"GEMS_DL_IMG_01",8b)	GEMS_DL_IMG_01	25	139	f	\N	US	1	Calibration nb points uif	\N
3726	(0019,"GEMS_DL_IMG_01",8c)	(0019,"GEMS_DL_IMG_01",8c)	GEMS_DL_IMG_01	25	140	f	\N	US	1-n	Calibration Points Row	\N
3727	(0019,"GEMS_DL_IMG_01",8d)	(0019,"GEMS_DL_IMG_01",8d)	GEMS_DL_IMG_01	25	141	f	\N	US	1-n	Calibration Points Column	\N
3728	(0019,"GEMS_DL_IMG_01",8e)	(0019,"GEMS_DL_IMG_01",8e)	GEMS_DL_IMG_01	25	142	f	\N	FL	1	Calibration Magnification Ratio	\N
3729	(0019,"GEMS_DL_IMG_01",8f)	(0019,"GEMS_DL_IMG_01",8f)	GEMS_DL_IMG_01	25	143	f	\N	LO	1	Calibration Software Version	\N
3730	(0019,"GEMS_DL_IMG_01",90)	(0019,"GEMS_DL_IMG_01",90)	GEMS_DL_IMG_01	25	144	f	\N	LO	1	Extended Calibration Software Version	\N
3731	(0019,"GEMS_DL_IMG_01",91)	(0019,"GEMS_DL_IMG_01",91)	GEMS_DL_IMG_01	25	145	f	\N	IS	1	Calibration Return Code	\N
3732	(0019,"GEMS_DL_IMG_01",92)	(0019,"GEMS_DL_IMG_01",92)	GEMS_DL_IMG_01	25	146	f	\N	DS	1	Detector Rotation Angle	\N
3733	(0019,"GEMS_DL_IMG_01",93)	(0019,"GEMS_DL_IMG_01",93)	GEMS_DL_IMG_01	25	147	f	\N	CS	1	Spatial Change	\N
3734	(0019,"GEMS_DL_IMG_01",94)	(0019,"GEMS_DL_IMG_01",94)	GEMS_DL_IMG_01	25	148	f	\N	CS	1	Inconsistent Flag	\N
3735	(0019,"GEMS_DL_IMG_01",95)	(0019,"GEMS_DL_IMG_01",95)	GEMS_DL_IMG_01	25	149	f	\N	CS	2	Horizontal and Vertical Image Flip	\N
3736	(0019,"GEMS_DL_IMG_01",96)	(0019,"GEMS_DL_IMG_01",96)	GEMS_DL_IMG_01	25	150	f	\N	CS	1	Internal Label Image	\N
3737	(0019,"GEMS_DL_IMG_01",97)	(0019,"GEMS_DL_IMG_01",97)	GEMS_DL_IMG_01	25	151	f	\N	DS	1-n	Angle 1 increment	\N
3738	(0019,"GEMS_DL_IMG_01",98)	(0019,"GEMS_DL_IMG_01",98)	GEMS_DL_IMG_01	25	152	f	\N	DS	1-n	Angle 2 increment	\N
3739	(0019,"GEMS_DL_IMG_01",99)	(0019,"GEMS_DL_IMG_01",99)	GEMS_DL_IMG_01	25	153	f	\N	DS	1-n	Angle 3 increment	\N
3740	(0019,"GEMS_DL_IMG_01",9a)	(0019,"GEMS_DL_IMG_01",9a)	GEMS_DL_IMG_01	25	154	f	\N	DS	1-n	Sensor Feedback	\N
3741	(0019,"GEMS_DL_IMG_01",9b)	(0019,"GEMS_DL_IMG_01",9b)	GEMS_DL_IMG_01	25	155	f	\N	CS	1	Grid	\N
3742	(0019,"GEMS_DL_IMG_01",9c)	(0019,"GEMS_DL_IMG_01",9c)	GEMS_DL_IMG_01	25	156	f	\N	FL	1	Default Mask Pixel Shift	\N
3743	(0019,"GEMS_DL_IMG_01",9d)	(0019,"GEMS_DL_IMG_01",9d)	GEMS_DL_IMG_01	25	157	f	\N	CS	1	Applicable Review Mode	\N
3744	(0019,"GEMS_DL_IMG_01",9e)	(0019,"GEMS_DL_IMG_01",9e)	GEMS_DL_IMG_01	25	158	f	\N	DS	1-n	Log LUT Control Points	\N
3745	(0019,"GEMS_DL_IMG_01",9f)	(0019,"GEMS_DL_IMG_01",9f)	GEMS_DL_IMG_01	25	159	f	\N	DS	1-n	Exp LUT SUB Control Points	\N
3746	(0019,"GEMS_DL_IMG_01",a0)	(0019,"GEMS_DL_IMG_01",a0)	GEMS_DL_IMG_01	25	160	f	\N	DS	1	ABD Value	\N
3747	(0019,"GEMS_DL_IMG_01",a1)	(0019,"GEMS_DL_IMG_01",a1)	GEMS_DL_IMG_01	25	161	f	\N	DS	1	Subtraction Window Center	\N
3748	(0019,"GEMS_DL_IMG_01",a2)	(0019,"GEMS_DL_IMG_01",a2)	GEMS_DL_IMG_01	25	162	f	\N	DS	1	Subtraction Window Width	\N
3749	(0019,"GEMS_DL_IMG_01",a3)	(0019,"GEMS_DL_IMG_01",a3)	GEMS_DL_IMG_01	25	163	f	\N	DS	1	Image Rotation	\N
3750	(0019,"GEMS_DL_IMG_01",a4)	(0019,"GEMS_DL_IMG_01",a4)	GEMS_DL_IMG_01	25	164	f	\N	CS	1	Auto Injection Enabled	\N
3751	(0019,"GEMS_DL_IMG_01",a5)	(0019,"GEMS_DL_IMG_01",a5)	GEMS_DL_IMG_01	25	165	f	\N	CS	1	Injection Phase	\N
3752	(0019,"GEMS_DL_IMG_01",a6)	(0019,"GEMS_DL_IMG_01",a6)	GEMS_DL_IMG_01	25	166	f	\N	DS	1	Injection Delay	\N
3753	(0019,"GEMS_DL_IMG_01",a7)	(0019,"GEMS_DL_IMG_01",a7)	GEMS_DL_IMG_01	25	167	f	\N	IS	1	Reference Injection Frame Number	\N
3754	(0019,"GEMS_DL_IMG_01",a8)	(0019,"GEMS_DL_IMG_01",a8)	GEMS_DL_IMG_01	25	168	f	\N	DS	1	Injection Duration	\N
3755	(0019,"GEMS_DL_IMG_01",a9)	(0019,"GEMS_DL_IMG_01",a9)	GEMS_DL_IMG_01	25	169	f	\N	DS	1-n	EPT	\N
3756	(0019,"GEMS_DL_IMG_01",aa)	(0019,"GEMS_DL_IMG_01",aa)	GEMS_DL_IMG_01	25	170	f	\N	CS	1	Can Downscan 512	\N
3757	(0019,"GEMS_DL_IMG_01",ab)	(0019,"GEMS_DL_IMG_01",ab)	GEMS_DL_IMG_01	25	171	f	\N	IS	1	Current Spatial Filter Strength	\N
3758	(0019,"GEMS_DL_IMG_01",ac)	(0019,"GEMS_DL_IMG_01",ac)	GEMS_DL_IMG_01	25	172	f	\N	DS	1	Brightness Sensitivity	\N
3759	(0019,"GEMS_DL_IMG_01",ad)	(0019,"GEMS_DL_IMG_01",ad)	GEMS_DL_IMG_01	25	173	f	\N	DS	1-n	Exp LUT NOSUB Control Points	\N
3760	(0019,"GEMS_DL_IMG_01",af)	(0019,"GEMS_DL_IMG_01",af)	GEMS_DL_IMG_01	25	175	f	\N	DS	1-n	Unknown	\N
3761	(0019,"GEMS_DL_IMG_01",b0)	(0019,"GEMS_DL_IMG_01",b0)	GEMS_DL_IMG_01	25	176	f	\N	DS	1-n	Unknown	\N
3762	(0019,"GEMS_DL_IMG_01",b1)	(0019,"GEMS_DL_IMG_01",b1)	GEMS_DL_IMG_01	25	177	f	\N	LO	1	Acquisition Mode Description	\N
3763	(0019,"GEMS_DL_IMG_01",b2)	(0019,"GEMS_DL_IMG_01",b2)	GEMS_DL_IMG_01	25	178	f	\N	LO	1	Acquisition Mode Description Label	\N
3764	(0019,"GEMS_DL_IMG_01",b3)	(0019,"GEMS_DL_IMG_01",b3)	GEMS_DL_IMG_01	25	179	f	\N	LO	1	Unknown	\N
3765	(0019,"GEMS_DL_IMG_01",b8)	(0019,"GEMS_DL_IMG_01",b8)	GEMS_DL_IMG_01	25	184	f	\N	FL	1	Unknown	\N
3766	(0019,"GEMS_DL_IMG_01",ba)	(0019,"GEMS_DL_IMG_01",ba)	GEMS_DL_IMG_01	25	186	f	\N	CS	1	Acquisition Region	\N
3767	(0019,"GEMS_DL_IMG_01",bb)	(0019,"GEMS_DL_IMG_01",bb)	GEMS_DL_IMG_01	25	187	f	\N	CS	1	Acquisition SUB Mode	\N
3768	(0019,"GEMS_DL_IMG_01",bc)	(0019,"GEMS_DL_IMG_01",bc)	GEMS_DL_IMG_01	25	188	f	\N	FL	1	Table Cradle Angle	\N
3769	(0019,"GEMS_DL_IMG_01",bd)	(0019,"GEMS_DL_IMG_01",bd)	GEMS_DL_IMG_01	25	189	f	\N	CS	1-n	Table Rotation Status Vector	\N
3770	(0019,"GEMS_DL_IMG_01",be)	(0019,"GEMS_DL_IMG_01",be)	GEMS_DL_IMG_01	25	190	f	\N	FL	1-n	Source to Image Distance per Frame Vector	\N
3771	(0019,"GEMS_DL_IMG_01",c2)	(0019,"GEMS_DL_IMG_01",c2)	GEMS_DL_IMG_01	25	194	f	\N	DS	1-n	Unknown	\N
3772	(0019,"GEMS_DL_IMG_01",c3)	(0019,"GEMS_DL_IMG_01",c3)	GEMS_DL_IMG_01	25	195	f	\N	FL	1-n	Table Rotation Angle Increment	\N
3773	(0019,"GEMS_DL_IMG_01",c4)	(0019,"GEMS_DL_IMG_01",c4)	GEMS_DL_IMG_01	25	196	f	\N	IS	1	Unknown	\N
3774	(0019,"GEMS_DL_IMG_01",c7)	(0019,"GEMS_DL_IMG_01",c7)	GEMS_DL_IMG_01	25	199	f	\N	CS	1	Patient Position per Image	\N
3775	(0019,"GEMS_DL_IMG_01",d7)	(0019,"GEMS_DL_IMG_01",d7)	GEMS_DL_IMG_01	25	215	f	\N	FL	1-n	Table X Position to Isoâcenter Increment	\N
3776	(0019,"GEMS_DL_IMG_01",d8)	(0019,"GEMS_DL_IMG_01",d8)	GEMS_DL_IMG_01	25	216	f	\N	FL	1-n	Table Y Position to Isoâcenter Increment	\N
3777	(0019,"GEMS_DL_IMG_01",d9)	(0019,"GEMS_DL_IMG_01",d9)	GEMS_DL_IMG_01	25	217	f	\N	FL	1-n	Table Z Position to Isoâcenter Increment	\N
3778	(0019,"GEMS_DL_IMG_01",da)	(0019,"GEMS_DL_IMG_01",da)	GEMS_DL_IMG_01	25	218	f	\N	FL	1-n	Table Head Tilt Angle Increment	\N
3779	(0019,"GEMS_DL_IMG_01",dc)	(0019,"GEMS_DL_IMG_01",dc)	GEMS_DL_IMG_01	25	220	f	\N	LO	1	Unknown	\N
3780	(0019,"GEMS_DL_IMG_01",de)	(0019,"GEMS_DL_IMG_01",de)	GEMS_DL_IMG_01	25	222	f	\N	CS	1	Acquisition Plane	\N
3781	(0019,"GEMS_DL_IMG_01",dd)	(0019,"GEMS_DL_IMG_01",dd)	GEMS_DL_IMG_01	25	221	f	\N	DS	1	Unknown	\N
3782	(0019,"GEMS_DL_IMG_01",e0)	(0019,"GEMS_DL_IMG_01",e0)	GEMS_DL_IMG_01	25	224	f	\N	FL	1	Unknown	\N
3783	(0019,"GEMS_DL_IMG_01",e9)	(0019,"GEMS_DL_IMG_01",e9)	GEMS_DL_IMG_01	25	233	f	\N	FL	1-n	Source to Detector Distance per Frame Vector	\N
3784	(0019,"GEMS_DL_IMG_01",ea)	(0019,"GEMS_DL_IMG_01",ea)	GEMS_DL_IMG_01	25	234	f	\N	FL	1	Table Rotation Angle	\N
3785	(0019,"GEMS_DL_IMG_01",eb)	(0019,"GEMS_DL_IMG_01",eb)	GEMS_DL_IMG_01	25	235	f	\N	FL	1	Table X Position to Isoâcenter	\N
3786	(0019,"GEMS_DL_IMG_01",ec)	(0019,"GEMS_DL_IMG_01",ec)	GEMS_DL_IMG_01	25	236	f	\N	FL	1	Table Y Position to Isoâcenter	\N
3787	(0019,"GEMS_DL_IMG_01",ed)	(0019,"GEMS_DL_IMG_01",ed)	GEMS_DL_IMG_01	25	237	f	\N	FL	1	Table Z Position to Isoâcenter	\N
3788	(0019,"GEMS_DL_IMG_01",ee)	(0019,"GEMS_DL_IMG_01",ee)	GEMS_DL_IMG_01	25	238	f	\N	FL	1	Table Head Tilt Angle	\N
3789	(0019,"GEMS_DL_IMG_01",ef)	(0019,"GEMS_DL_IMG_01",ef)	GEMS_DL_IMG_01	25	239	f	\N	FL	1	Unknown	\N
3790	(0019,"DLX_SERIE_01",20)	(0019,"DLX_SERIE_01",20)	DLX_SERIE_01	25	32	f	\N	LO	1	Ip Address	\N
3791	(0019,"DLX_SERIE_01",21)	(0019,"DLX_SERIE_01",21)	DLX_SERIE_01	25	33	f	\N	DS	1	Table position Z (vertical) first frame	\N
3792	(0019,"DLX_SERIE_01",22)	(0019,"DLX_SERIE_01",22)	DLX_SERIE_01	25	34	f	\N	DS	1	Table position X (longitudinal) first frame	\N
3793	(0019,"DLX_SERIE_01",23)	(0019,"DLX_SERIE_01",23)	DLX_SERIE_01	25	35	f	\N	DS	1	Table position Y (lateral) first frame	\N
3794	(0019,"DLX_SERIE_01",24)	(0019,"DLX_SERIE_01",24)	DLX_SERIE_01	25	36	f	\N	DS	1	Lambda cm Pincushion Distortion	\N
3795	(0019,"DLX_SERIE_01",25)	(0019,"DLX_SERIE_01",25)	DLX_SERIE_01	25	37	f	\N	DS	1	LV Regression Slope Coefficient	\N
3796	(0019,"DLX_SERIE_01",26)	(0019,"DLX_SERIE_01",26)	DLX_SERIE_01	25	38	f	\N	DS	1	LV Regression Intercept Coefficient	\N
3797	(0019,"DLX_SERIE_01",27)	(0019,"DLX_SERIE_01",27)	DLX_SERIE_01	25	39	f	\N	DS	1	Image chain FWHM psf mm min	\N
3798	(0019,"DLX_SERIE_01",28)	(0019,"DLX_SERIE_01",28)	DLX_SERIE_01	25	40	f	\N	DS	1	Image chain FWHM psf mm max	\N
3799	(0019,"GEMS_DL_SERIES_01",4c)	(0019,"GEMS_DL_SERIES_01",4c)	GEMS_DL_SERIES_01	25	76	f	\N	CS	1	Internal Label	\N
3800	(0019,"GEMS_DL_SERIES_01",4d)	(0019,"GEMS_DL_SERIES_01",4d)	GEMS_DL_SERIES_01	25	77	f	\N	CS	1	Browser Hide	\N
3801	(0021,"GEMS_XR3DCAL_01",20)	(0021,"GEMS_XR3DCAL_01",20)	GEMS_XR3DCAL_01	33	32	f	\N	LT	1	Generalized Calibration	\N
3802	(0021,"Mayo/IBM Archive Project",01)	(0021,"Mayo/IBM Archive Project",01)	Mayo/IBM Archive Project	33	1	f	\N	UN	1	Unknown	\N
3803	(0021,"Mayo/IBM Archive Project",10)	(0021,"Mayo/IBM Archive Project",10)	Mayo/IBM Archive Project	33	16	f	\N	UN	1	Unknown	\N
3804	(0021,"Mayo/IBM Archive Project",11)	(0021,"Mayo/IBM Archive Project",11)	Mayo/IBM Archive Project	33	17	f	\N	UN	1	Unknown	\N
3805	(0021,"Mayo/IBM Archive Project",12)	(0021,"Mayo/IBM Archive Project",12)	Mayo/IBM Archive Project	33	18	f	\N	UN	1	Unknown	\N
3806	(0021,"Mayo/IBM Archive Project",13)	(0021,"Mayo/IBM Archive Project",13)	Mayo/IBM Archive Project	33	19	f	\N	UN	1	Unknown	\N
3807	(0021,"Mayo/IBM Archive Project",14)	(0021,"Mayo/IBM Archive Project",14)	Mayo/IBM Archive Project	33	20	f	\N	UN	1	Unknown	\N
3808	(0021,"Mayo/IBM Archive Project",15)	(0021,"Mayo/IBM Archive Project",15)	Mayo/IBM Archive Project	33	21	f	\N	UN	1	Unknown	\N
3809	(0021,"Mayo/IBM Archive Project",16)	(0021,"Mayo/IBM Archive Project",16)	Mayo/IBM Archive Project	33	22	f	\N	UN	1	Unknown	\N
3810	(0021,"Mayo/IBM Archive Project",17)	(0021,"Mayo/IBM Archive Project",17)	Mayo/IBM Archive Project	33	23	f	\N	UN	1	Unknown	\N
3811	(0021,"Mayo/IBM Archive Project",18)	(0021,"Mayo/IBM Archive Project",18)	Mayo/IBM Archive Project	33	24	f	\N	UN	1	Unknown	\N
3812	(0021,"Mayo/IBM Archive Project",19)	(0021,"Mayo/IBM Archive Project",19)	Mayo/IBM Archive Project	33	25	f	\N	UN	1	Unknown	\N
3813	(0021,"Mayo/IBM Archive Project",1a)	(0021,"Mayo/IBM Archive Project",1a)	Mayo/IBM Archive Project	33	26	f	\N	UN	1	Unknown	\N
3814	(0021,"Mayo/IBM Archive Project",1b)	(0021,"Mayo/IBM Archive Project",1b)	Mayo/IBM Archive Project	33	27	f	\N	UN	1	Unknown	\N
3815	(0021,"Mayo/IBM Archive Project",1c)	(0021,"Mayo/IBM Archive Project",1c)	Mayo/IBM Archive Project	33	28	f	\N	UN	1	Unknown	\N
3816	(0021,"Mayo/IBM Archive Project",1d)	(0021,"Mayo/IBM Archive Project",1d)	Mayo/IBM Archive Project	33	29	f	\N	UN	1	Unknown	\N
3817	(0021,"Mayo/IBM Archive Project",1e)	(0021,"Mayo/IBM Archive Project",1e)	Mayo/IBM Archive Project	33	30	f	\N	UN	1	Unknown	\N
3818	(0021,"Mayo/IBM Archive Project",1f)	(0021,"Mayo/IBM Archive Project",1f)	Mayo/IBM Archive Project	33	31	f	\N	UN	1	Unknown	\N
3819	(0021,"Mayo/IBM Archive Project",20)	(0021,"Mayo/IBM Archive Project",20)	Mayo/IBM Archive Project	33	32	f	\N	UN	1	Unknown	\N
3820	(0021,"Mayo/IBM Archive Project",40)	(0021,"Mayo/IBM Archive Project",40)	Mayo/IBM Archive Project	33	64	f	\N	UN	1	Unknown	\N
3821	(0021,"Mayo/IBM Archive Project",41)	(0021,"Mayo/IBM Archive Project",41)	Mayo/IBM Archive Project	33	65	f	\N	UN	1	Unknown	\N
3822	(0021,"Mayo/IBM Archive Project",50)	(0021,"Mayo/IBM Archive Project",50)	Mayo/IBM Archive Project	33	80	f	\N	UN	1	Unknown	\N
3823	(0021,"Mayo/IBM Archive Project",60)	(0021,"Mayo/IBM Archive Project",60)	Mayo/IBM Archive Project	33	96	f	\N	UN	1	Unknown	\N
3824	(0021,"Mayo/IBM Archive Project",65)	(0021,"Mayo/IBM Archive Project",65)	Mayo/IBM Archive Project	33	101	f	\N	UN	1	Unknown	\N
3826	(0023,"GEMS_3D_INTVL_01",01)	(0023,"GEMS_3D_INTVL_01",01)	GEMS_3D_INTVL_01	35	1	f	\N	SQ	1	X-Ray Marker Sequence	\N
3827	(0023,"GEMS_3D_INTVL_01",02)	(0023,"GEMS_3D_INTVL_01",02)	GEMS_3D_INTVL_01	35	2	f	\N	SH	1	Marker ID	\N
3828	(0023,"GEMS_3D_INTVL_01",03)	(0023,"GEMS_3D_INTVL_01",03)	GEMS_3D_INTVL_01	35	3	f	\N	CS	1	Marker Type	\N
3829	(0023,"GEMS_3D_INTVL_01",04)	(0023,"GEMS_3D_INTVL_01",04)	GEMS_3D_INTVL_01	35	4	f	\N	FL	1	Marker Size	\N
3830	(0023,"GEMS_3D_INTVL_01",05)	(0023,"GEMS_3D_INTVL_01",05)	GEMS_3D_INTVL_01	35	5	f	\N	US	3	Marker Color CIELab Value	\N
3831	(0023,"GEMS_3D_INTVL_01",06)	(0023,"GEMS_3D_INTVL_01",06)	GEMS_3D_INTVL_01	35	6	f	\N	LO	1	Marker Label	\N
3832	(0023,"GEMS_3D_INTVL_01",07)	(0023,"GEMS_3D_INTVL_01",07)	GEMS_3D_INTVL_01	35	7	f	\N	CS	1	Marker Visible State	\N
3833	(0023,"GEMS_3D_INTVL_01",08)	(0023,"GEMS_3D_INTVL_01",08)	GEMS_3D_INTVL_01	35	8	f	\N	LO	1	Marker Description	\N
3834	(0023,"GEMS_3D_INTVL_01",10)	(0023,"GEMS_3D_INTVL_01",10)	GEMS_3D_INTVL_01	35	16	f	\N	SQ	1	Marker Points Sequence	\N
3835	(0023,"GEMS_3D_INTVL_01",11)	(0023,"GEMS_3D_INTVL_01",11)	GEMS_3D_INTVL_01	35	17	f	\N	SH	1	Marker Point ID	\N
3836	(0023,"GEMS_3D_INTVL_01",12)	(0023,"GEMS_3D_INTVL_01",12)	GEMS_3D_INTVL_01	35	18	f	\N	FL	3	Marker Point Position	\N
3837	(0023,"GEMS_3D_INTVL_01",13)	(0023,"GEMS_3D_INTVL_01",13)	GEMS_3D_INTVL_01	35	19	f	\N	FL	1	Marker Point Size	\N
3838	(0023,"GEMS_3D_INTVL_01",14)	(0023,"GEMS_3D_INTVL_01",14)	GEMS_3D_INTVL_01	35	20	f	\N	US	3	Marker Point Color CIELab Value	\N
3839	(0023,"GEMS_3D_INTVL_01",16)	(0023,"GEMS_3D_INTVL_01",16)	GEMS_3D_INTVL_01	35	22	f	\N	CS	1	Marker Point Visible State	\N
3840	(0023,"GEMS_3D_INTVL_01",17)	(0023,"GEMS_3D_INTVL_01",17)	GEMS_3D_INTVL_01	35	23	f	\N	IS	1	Marker Point Order	\N
3841	(0023,"GEMS_3D_INTVL_01",18)	(0023,"GEMS_3D_INTVL_01",18)	GEMS_3D_INTVL_01	35	24	f	\N	FL	3	Volume Manual Registration	\N
3842	(0023,"GEMS_3D_INTVL_01",20)	(0023,"GEMS_3D_INTVL_01",20)	GEMS_3D_INTVL_01	35	32	f	\N	IS	1-n	Volumes Threshold	\N
3843	(0023,"GEMS_3D_INTVL_01",25)	(0023,"GEMS_3D_INTVL_01",25)	GEMS_3D_INTVL_01	35	37	f	\N	CS	1	Cut Plane Activation Flag	\N
3844	(0023,"GEMS_3D_INTVL_01",26)	(0023,"GEMS_3D_INTVL_01",26)	GEMS_3D_INTVL_01	35	38	f	\N	IS	1	Cut Plane Position Value	\N
3845	(0023,"GEMS_3D_INTVL_01",27)	(0023,"GEMS_3D_INTVL_01",27)	GEMS_3D_INTVL_01	35	39	f	\N	FL	3	Cut Plane Normal Value	\N
3846	(0023,"GEMS_3D_INTVL_01",28)	(0023,"GEMS_3D_INTVL_01",28)	GEMS_3D_INTVL_01	35	40	f	\N	FL	1	Volume Scaling Factor	\N
3847	(0023,"GEMS_3D_INTVL_01",29)	(0023,"GEMS_3D_INTVL_01",29)	GEMS_3D_INTVL_01	35	41	f	\N	FL	1	ROI to Table Top Distance	\N
3848	(0023,"GEMS_3D_INTVL_01",30)	(0023,"GEMS_3D_INTVL_01",30)	GEMS_3D_INTVL_01	35	48	f	\N	IS	1-n	DRR Threshold	\N
3849	(0023,"GEMS_3D_INTVL_01",31)	(0023,"GEMS_3D_INTVL_01",31)	GEMS_3D_INTVL_01	35	49	f	\N	FL	3	Volume Table Position	\N
3850	(0023,"GEMS_3D_INTVL_01",32)	(0023,"GEMS_3D_INTVL_01",32)	GEMS_3D_INTVL_01	35	50	f	\N	IS	1	Rendering Mode	\N
3851	(0023,"GEMS_3D_INTVL_01",33)	(0023,"GEMS_3D_INTVL_01",33)	GEMS_3D_INTVL_01	35	51	f	\N	IS	1	3D Object Opacity	\N
3852	(0023,"GEMS_3D_INTVL_01",34)	(0023,"GEMS_3D_INTVL_01",34)	GEMS_3D_INTVL_01	35	52	f	\N	IS	1	Invert Image	\N
3853	(0023,"GEMS_3D_INTVL_01",35)	(0023,"GEMS_3D_INTVL_01",35)	GEMS_3D_INTVL_01	35	53	f	\N	IS	1	Enhance Full	\N
3854	(0023,"GEMS_3D_INTVL_01",36)	(0023,"GEMS_3D_INTVL_01",36)	GEMS_3D_INTVL_01	35	54	f	\N	FL	1	Zoom	\N
3855	(0023,"GEMS_3D_INTVL_01",37)	(0023,"GEMS_3D_INTVL_01",37)	GEMS_3D_INTVL_01	35	55	f	\N	IS	2	Roam	\N
3856	(0023,"GEMS_3D_INTVL_01",38)	(0023,"GEMS_3D_INTVL_01",38)	GEMS_3D_INTVL_01	35	56	f	\N	IS	1	Window Level	\N
3857	(0023,"GEMS_3D_INTVL_01",39)	(0023,"GEMS_3D_INTVL_01",39)	GEMS_3D_INTVL_01	35	57	f	\N	IS	1	Window Width	\N
3858	(0023,"GEMS_3D_INTVL_01",40)	(0023,"GEMS_3D_INTVL_01",40)	GEMS_3D_INTVL_01	35	64	f	\N	CS	1	BMC Setting	\N
3859	(0023,"GEMS_3D_INTVL_01",41)	(0023,"GEMS_3D_INTVL_01",41)	GEMS_3D_INTVL_01	35	65	f	\N	CS	1	Back View Setting	\N
3860	(0023,"GEMS_3D_INTVL_01",42)	(0023,"GEMS_3D_INTVL_01",42)	GEMS_3D_INTVL_01	35	66	f	\N	CS	1-n	Sub Volume Visibility	\N
3861	(0023,"GEMS_3D_INTVL_01",43)	(0023,"GEMS_3D_INTVL_01",43)	GEMS_3D_INTVL_01	35	67	f	\N	CS	1	3D Landmarks Visibility	\N
3862	(0023,"GEMS_3D_INTVL_01",44)	(0023,"GEMS_3D_INTVL_01",44)	GEMS_3D_INTVL_01	35	68	f	\N	CS	1	Ablation Point Visibility	\N
3864	(0025,"GEMS_DL_FRAME_01",02)	(0025,"GEMS_DL_FRAME_01",02)	GEMS_DL_FRAME_01	37	2	f	\N	IS	1	Frame ID	\N
3865	(0025,"GEMS_DL_FRAME_01",03)	(0025,"GEMS_DL_FRAME_01",03)	GEMS_DL_FRAME_01	37	3	f	\N	DS	1	Distance Source to Detector	\N
3866	(0025,"GEMS_DL_FRAME_01",04)	(0025,"GEMS_DL_FRAME_01",04)	GEMS_DL_FRAME_01	37	4	f	\N	DS	1	Distance Source to Patient	\N
3867	(0025,"GEMS_DL_FRAME_01",05)	(0025,"GEMS_DL_FRAME_01",05)	GEMS_DL_FRAME_01	37	5	f	\N	DS	1	Distance Source to Skin	\N
3868	(0025,"GEMS_DL_FRAME_01",06)	(0025,"GEMS_DL_FRAME_01",06)	GEMS_DL_FRAME_01	37	6	f	\N	DS	1	Positioner Primary Angle	\N
3869	(0025,"GEMS_DL_FRAME_01",07)	(0025,"GEMS_DL_FRAME_01",07)	GEMS_DL_FRAME_01	37	7	f	\N	DS	1	Positioner Secondary Angle	\N
3870	(0025,"GEMS_DL_FRAME_01",08)	(0025,"GEMS_DL_FRAME_01",08)	GEMS_DL_FRAME_01	37	8	f	\N	IS	1	Beam Orientation	\N
3871	(0025,"GEMS_DL_FRAME_01",09)	(0025,"GEMS_DL_FRAME_01",09)	GEMS_DL_FRAME_01	37	9	f	\N	DS	1	L Arm Angle	\N
3872	(0025,"GEMS_DL_FRAME_01",0a)	(0025,"GEMS_DL_FRAME_01",0a)	GEMS_DL_FRAME_01	37	10	f	\N	SQ	1	Frame Sequence	\N
3863	(0025,"GEMS_SERS_01",1b)	(0025,"GEMS_SERS_01",1b)	GEMS_SERS_01	37	27	f	\N	OB	1	Protocol Data Block (compressed)	X
3873	(0025,"GEMS_DL_FRAME_01",10)	(0025,"GEMS_DL_FRAME_01",10)	GEMS_DL_FRAME_01	37	16	f	\N	DS	1	Pivot Angle	\N
3874	(0025,"GEMS_DL_FRAME_01",1a)	(0025,"GEMS_DL_FRAME_01",1a)	GEMS_DL_FRAME_01	37	26	f	\N	DS	1	Arc Angle	\N
3875	(0025,"GEMS_DL_FRAME_01",1b)	(0025,"GEMS_DL_FRAME_01",1b)	GEMS_DL_FRAME_01	37	27	f	\N	DS	1	Table Vertical Position	\N
3876	(0025,"GEMS_DL_FRAME_01",1c)	(0025,"GEMS_DL_FRAME_01",1c)	GEMS_DL_FRAME_01	37	28	f	\N	DS	1	Table Longitudinal Position	\N
3877	(0025,"GEMS_DL_FRAME_01",1d)	(0025,"GEMS_DL_FRAME_01",1d)	GEMS_DL_FRAME_01	37	29	f	\N	DS	1	Table Lateral Position	\N
3878	(0025,"GEMS_DL_FRAME_01",1e)	(0025,"GEMS_DL_FRAME_01",1e)	GEMS_DL_FRAME_01	37	30	f	\N	IS	1	Beam Cover Area	\N
3879	(0025,"GEMS_DL_FRAME_01",1f)	(0025,"GEMS_DL_FRAME_01",1f)	GEMS_DL_FRAME_01	37	31	f	\N	DS	1	kVP Actual	\N
3880	(0025,"GEMS_DL_FRAME_01",20)	(0025,"GEMS_DL_FRAME_01",20)	GEMS_DL_FRAME_01	37	32	f	\N	DS	1	mAS Actual	\N
3881	(0025,"GEMS_DL_FRAME_01",21)	(0025,"GEMS_DL_FRAME_01",21)	GEMS_DL_FRAME_01	37	33	f	\N	DS	1	PW Actual	\N
3882	(0025,"GEMS_DL_FRAME_01",22)	(0025,"GEMS_DL_FRAME_01",22)	GEMS_DL_FRAME_01	37	34	f	\N	DS	1	Kvp Commanded	\N
3883	(0025,"GEMS_DL_FRAME_01",23)	(0025,"GEMS_DL_FRAME_01",23)	GEMS_DL_FRAME_01	37	35	f	\N	DS	1	Mas Commanded	\N
3884	(0025,"GEMS_DL_FRAME_01",24)	(0025,"GEMS_DL_FRAME_01",24)	GEMS_DL_FRAME_01	37	36	f	\N	DS	1	Pw Commanded	\N
3885	(0025,"GEMS_DL_FRAME_01",25)	(0025,"GEMS_DL_FRAME_01",25)	GEMS_DL_FRAME_01	37	37	f	\N	CS	1	Grid	\N
3886	(0025,"GEMS_DL_FRAME_01",26)	(0025,"GEMS_DL_FRAME_01",26)	GEMS_DL_FRAME_01	37	38	f	\N	DS	1	Sensor Feedback	\N
3887	(0025,"GEMS_DL_FRAME_01",27)	(0025,"GEMS_DL_FRAME_01",27)	GEMS_DL_FRAME_01	37	39	f	\N	DS	1	Target Entrance Dose	\N
3888	(0025,"GEMS_DL_FRAME_01",28)	(0025,"GEMS_DL_FRAME_01",28)	GEMS_DL_FRAME_01	37	40	f	\N	DS	1	Cnr Commanded	\N
3889	(0025,"GEMS_DL_FRAME_01",29)	(0025,"GEMS_DL_FRAME_01",29)	GEMS_DL_FRAME_01	37	41	f	\N	DS	1	Contrast Commanded	\N
3890	(0025,"GEMS_DL_FRAME_01",2a)	(0025,"GEMS_DL_FRAME_01",2a)	GEMS_DL_FRAME_01	37	42	f	\N	DS	1	EPT Actual	\N
3891	(0025,"GEMS_DL_FRAME_01",2b)	(0025,"GEMS_DL_FRAME_01",2b)	GEMS_DL_FRAME_01	37	43	f	\N	IS	1	Spectral Filter Znb	\N
3892	(0025,"GEMS_DL_FRAME_01",2c)	(0025,"GEMS_DL_FRAME_01",2c)	GEMS_DL_FRAME_01	37	44	f	\N	DS	1	Spectral Filter Weight	\N
3893	(0025,"GEMS_DL_FRAME_01",2d)	(0025,"GEMS_DL_FRAME_01",2d)	GEMS_DL_FRAME_01	37	45	f	\N	DS	1	Spectral Filter Density	\N
3894	(0025,"GEMS_DL_FRAME_01",2e)	(0025,"GEMS_DL_FRAME_01",2e)	GEMS_DL_FRAME_01	37	46	f	\N	IS	1	Spectral Filter Thickness	\N
3895	(0025,"GEMS_DL_FRAME_01",2f)	(0025,"GEMS_DL_FRAME_01",2f)	GEMS_DL_FRAME_01	37	47	f	\N	IS	1	Spectral Filter Status	\N
3896	(0025,"GEMS_DL_FRAME_01",30)	(0025,"GEMS_DL_FRAME_01",30)	GEMS_DL_FRAME_01	37	48	f	\N	IS	2	FOV Dimension	\N
3897	(0025,"GEMS_DL_FRAME_01",33)	(0025,"GEMS_DL_FRAME_01",33)	GEMS_DL_FRAME_01	37	51	f	\N	IS	2	FOV Origin	\N
3898	(0025,"GEMS_DL_FRAME_01",34)	(0025,"GEMS_DL_FRAME_01",34)	GEMS_DL_FRAME_01	37	52	f	\N	IS	1	Collimator Left Vertical Edge	\N
3899	(0025,"GEMS_DL_FRAME_01",35)	(0025,"GEMS_DL_FRAME_01",35)	GEMS_DL_FRAME_01	37	53	f	\N	IS	1	Collimator Right Vertical Edge	\N
3900	(0025,"GEMS_DL_FRAME_01",36)	(0025,"GEMS_DL_FRAME_01",36)	GEMS_DL_FRAME_01	37	54	f	\N	IS	1	Collimator Up Horizontal Edge	\N
3901	(0025,"GEMS_DL_FRAME_01",37)	(0025,"GEMS_DL_FRAME_01",37)	GEMS_DL_FRAME_01	37	55	f	\N	IS	1	Collimator Low Horizontal Edge	\N
3902	(0025,"GEMS_DL_FRAME_01",38)	(0025,"GEMS_DL_FRAME_01",38)	GEMS_DL_FRAME_01	37	56	f	\N	IS	1	Vertices Polygonal Collimator	\N
3903	(0025,"GEMS_DL_FRAME_01",39)	(0025,"GEMS_DL_FRAME_01",39)	GEMS_DL_FRAME_01	37	57	f	\N	IS	1	Contour Filter Distance	\N
3904	(0025,"GEMS_DL_FRAME_01",3a)	(0025,"GEMS_DL_FRAME_01",3a)	GEMS_DL_FRAME_01	37	58	f	\N	UL	1	Contour Filter Angle	\N
3905	(0025,"GEMS_DL_FRAME_01",3b)	(0025,"GEMS_DL_FRAME_01",3b)	GEMS_DL_FRAME_01	37	59	f	\N	CS	1	Table Rotation Status	\N
3906	(0025,"GEMS_DL_FRAME_01",3c)	(0025,"GEMS_DL_FRAME_01",3c)	GEMS_DL_FRAME_01	37	60	f	\N	CS	1	Internal Label Frame	\N
3907	(0033,"GEMS_GENIE_1",07)	(0033,"GEMS_GENIE_1",07)	GEMS_GENIE_1	51	7	f	\N	LO	1-n	Original SOP Instance UID	\N
3908	(0033,"GEMS_GENIE_1",08)	(0033,"GEMS_GENIE_1",08)	GEMS_GENIE_1	51	8	f	\N	CS	1	eNTEGRA Data Object Type	\N
3909	(0033,"GEMS_GENIE_1",10)	(0033,"GEMS_GENIE_1",10)	GEMS_GENIE_1	51	16	f	\N	SL	1	Modified	\N
3910	(0033,"GEMS_GENIE_1",11)	(0033,"GEMS_GENIE_1",11)	GEMS_GENIE_1	51	17	f	\N	LO	1	Name	\N
3911	(0033,"GEMS_GENIE_1",16)	(0033,"GEMS_GENIE_1",16)	GEMS_GENIE_1	51	22	f	\N	LO	1	Protocol Data UID	\N
3912	(0033,"GEMS_GENIE_1",17)	(0033,"GEMS_GENIE_1",17)	GEMS_GENIE_1	51	23	f	\N	SH	1	Date	\N
3913	(0033,"GEMS_GENIE_1",18)	(0033,"GEMS_GENIE_1",18)	GEMS_GENIE_1	51	24	f	\N	SH	1	Time	\N
3914	(0033,"GEMS_GENIE_1",19)	(0033,"GEMS_GENIE_1",19)	GEMS_GENIE_1	51	25	f	\N	UL	1	Protocol Data Flags	\N
3915	(0033,"GEMS_GENIE_1",1a)	(0033,"GEMS_GENIE_1",1a)	GEMS_GENIE_1	51	26	f	\N	UL	1	Protocol Name	\N
3916	(0033,"GEMS_GENIE_1",1b)	(0033,"GEMS_GENIE_1",1b)	GEMS_GENIE_1	51	27	f	\N	LO	1	Relevant Data UID	\N
3917	(0033,"GEMS_GENIE_1",1c)	(0033,"GEMS_GENIE_1",1c)	GEMS_GENIE_1	51	28	f	\N	LO	1	Bulk Data	\N
3918	(0033,"GEMS_GENIE_1",1d)	(0033,"GEMS_GENIE_1",1d)	GEMS_GENIE_1	51	29	f	\N	SL	1-n	Int Data	\N
3919	(0033,"GEMS_GENIE_1",1e)	(0033,"GEMS_GENIE_1",1e)	GEMS_GENIE_1	51	30	f	\N	FD	1-n	Double Data	\N
3920	(0033,"GEMS_GENIE_1",1f)	(0033,"GEMS_GENIE_1",1f)	GEMS_GENIE_1	51	31	f	\N	OB	1	String Data	\N
3921	(0033,"GEMS_GENIE_1",20)	(0033,"GEMS_GENIE_1",20)	GEMS_GENIE_1	51	32	f	\N	LT	1-n	Bulk Data Format	\N
3922	(0033,"GEMS_GENIE_1",21)	(0033,"GEMS_GENIE_1",21)	GEMS_GENIE_1	51	33	f	\N	LT	1-n	Int Data Format	\N
3923	(0033,"GEMS_GENIE_1",22)	(0033,"GEMS_GENIE_1",22)	GEMS_GENIE_1	51	34	f	\N	LT	1-n	Double Data Format	\N
3924	(0033,"GEMS_GENIE_1",23)	(0033,"GEMS_GENIE_1",23)	GEMS_GENIE_1	51	35	f	\N	LT	1-n	String Data Format	\N
3925	(0033,"GEMS_GENIE_1",24)	(0033,"GEMS_GENIE_1",24)	GEMS_GENIE_1	51	36	f	\N	LT	1	Description	\N
3926	(0033,"GEMS_GENIE_1",30)	(0033,"GEMS_GENIE_1",30)	GEMS_GENIE_1	51	48	f	\N	UL	1	Allocate Trigger Buffer	\N
3927	(0033,"GEMS_GENIE_1",33)	(0033,"GEMS_GENIE_1",33)	GEMS_GENIE_1	51	51	f	\N	UL	1	Number of Triggers	\N
3928	(0033,"GEMS_GENIE_1",34)	(0033,"GEMS_GENIE_1",34)	GEMS_GENIE_1	51	52	f	\N	UL	1	Trigger Size	\N
3929	(0033,"GEMS_GENIE_1",35)	(0033,"GEMS_GENIE_1",35)	GEMS_GENIE_1	51	53	f	\N	UL	1	Trigger Data Size	\N
3930	(0033,"GEMS_GENIE_1",36)	(0033,"GEMS_GENIE_1",36)	GEMS_GENIE_1	51	54	f	\N	OB	1	Trigger Data	\N
3931	(0035,"GEMS_GENIE_1",01)	(0035,"GEMS_GENIE_1",01)	GEMS_GENIE_1	53	1	f	\N	FD	1-n	Start Angle	\N
3932	(0039,"GEMS_ADWSoft_DPO",aa)	(0039,"GEMS_ADWSoft_DPO",aa)	GEMS_ADWSoft_DPO	57	170	f	\N	CS	1	Private Entity Type	\N
3933	(0039,"GEMS_ADWSoft_DPO1",95)	(0039,"GEMS_ADWSoft_DPO1",95)	GEMS_ADWSoft_DPO1	57	149	f	\N	LO	1	Unknown	\N
3934	(0039,"GEMS_AWSoft_SB1",50)	(0039,"GEMS_AWSoft_SB1",50)	GEMS_AWSoft_SB1	57	80	f	\N	UI	1	Reference to Study UID	\N
3935	(0039,"GEMS_AWSoft_SB1",51)	(0039,"GEMS_AWSoft_SB1",51)	GEMS_AWSoft_SB1	57	81	f	\N	UI	1	Reference to Series UID	\N
3936	(0039,"GEMS_AWSoft_SB1",52)	(0039,"GEMS_AWSoft_SB1",52)	GEMS_AWSoft_SB1	57	82	f	\N	IS	1	Reference to Original Instance Number	\N
3937	(0039,"GEMS_AWSoft_SB1",95)	(0039,"GEMS_AWSoft_SB1",95)	GEMS_AWSoft_SB1	57	149	f	\N	LO	1	Private Entity Launch Command	\N
3938	(0039,"GEMS_AWSOFT_CD1",65)	(0039,"GEMS_AWSOFT_CD1",65)	GEMS_AWSOFT_CD1	57	101	f	\N	UI	1	Reference to Study UID	\N
3939	(0039,"GEMS_AWSOFT_CD1",70)	(0039,"GEMS_AWSOFT_CD1",70)	GEMS_AWSOFT_CD1	57	112	f	\N	UI	1	Reference to Series UID	\N
3940	(0039,"GEMS_AWSOFT_CD1",75)	(0039,"GEMS_AWSOFT_CD1",75)	GEMS_AWSOFT_CD1	57	117	f	\N	IS	1	Reference to Original Instance Number	\N
3941	(0039,"GEMS_AWSOFT_CD1",80)	(0039,"GEMS_AWSOFT_CD1",80)	GEMS_AWSOFT_CD1	57	128	f	\N	IS	1	DPO Number	\N
3942	(0039,"GEMS_AWSOFT_CD1",85)	(0039,"GEMS_AWSOFT_CD1",85)	GEMS_AWSOFT_CD1	57	133	f	\N	DA	1	DPO Date	\N
3943	(0039,"GEMS_AWSOFT_CD1",90)	(0039,"GEMS_AWSOFT_CD1",90)	GEMS_AWSOFT_CD1	57	144	f	\N	TM	1	DPO Time	\N
3944	(0039,"GEMS_AWSOFT_CD1",95)	(0039,"GEMS_AWSOFT_CD1",95)	GEMS_AWSOFT_CD1	57	149	f	\N	LO	1	DPO Invocation String	\N
3945	(0039,"GEMS_AWSOFT_CD1",aa)	(0039,"GEMS_AWSOFT_CD1",aa)	GEMS_AWSOFT_CD1	57	170	f	\N	CS	1	DPO Type	\N
3946	(0039,"GEMS_AWSOFT_CD1",ff)	(0039,"GEMS_AWSOFT_CD1",ff)	GEMS_AWSOFT_CD1	57	255	f	\N	OB	1	DPO Data	\N
10974	(0119,"MRSC",11a5)	(0119,"MRSC",a5)	MRSC	281	165	t	11	DS	1-n	PhantRefValues	K
3948	(0043,"GEMS_PARM_01",64)	(0043,"GEMS_PARM_01",64)	GEMS_PARM_01	67	100	f	\N	CS	1-n	Image Filter	R
3950	(0043,"GEMS_PARM_01",66)	(0043,"GEMS_PARM_01",66)	GEMS_PARM_01	67	102	f	\N	US	1	Helical Correction Indicator	KB
3951	(0043,"GEMS_PARM_01",67)	(0043,"GEMS_PARM_01",67)	GEMS_PARM_01	67	103	f	\N	US	1	IBO Correction Indicator	KB
3952	(0043,"GEMS_PARM_01",68)	(0043,"GEMS_PARM_01",68)	GEMS_PARM_01	67	104	f	\N	US	1	XT Correction Indicator	KB
3953	(0043,"GEMS_PARM_01",69)	(0043,"GEMS_PARM_01",69)	GEMS_PARM_01	67	105	f	\N	US	1	Q-cal Correction Indicator	KB
3954	(0043,"GEMS_PARM_01",6a)	(0043,"GEMS_PARM_01",6a)	GEMS_PARM_01	67	106	f	\N	US	1	AV Correction Indicator	KB
3955	(0043,"GEMS_PARM_01",6b)	(0043,"GEMS_PARM_01",6b)	GEMS_PARM_01	67	107	f	\N	US	1	L-MDK Correction Indicator	KB
3956	(0043,"GEMS_PARM_01",6c)	(0043,"GEMS_PARM_01",6c)	GEMS_PARM_01	67	108	f	\N	IS	1	Detector Row	KB
3957	(0043,"GEMS_PARM_01",6d)	(0043,"GEMS_PARM_01",6d)	GEMS_PARM_01	67	109	f	\N	US	1	Area Size	KB
3958	(0043,"GEMS_PARM_01",6e)	(0043,"GEMS_PARM_01",6e)	GEMS_PARM_01	67	110	f	\N	SH	1	Auto mA Mode	KB
3959	(0043,"GEMS_PARM_01",70)	(0043,"GEMS_PARM_01",70)	GEMS_PARM_01	67	112	f	\N	LO	1	Paradigm Name	R
3960	(0043,"GEMS_PARM_01",71)	(0043,"GEMS_PARM_01",71)	GEMS_PARM_01	67	113	f	\N	ST	1	Paradigm Description	R
3961	(0043,"GEMS_PARM_01",72)	(0043,"GEMS_PARM_01",72)	GEMS_PARM_01	67	114	f	\N	UI	1	Paradigm UID	R
3962	(0043,"GEMS_PARM_01",73)	(0043,"GEMS_PARM_01",73)	GEMS_PARM_01	67	115	f	\N	US	1	Experiment Type	K
3963	(0043,"GEMS_PARM_01",74)	(0043,"GEMS_PARM_01",74)	GEMS_PARM_01	67	116	f	\N	US	1	Number of Rest Volumes	K
3964	(0043,"GEMS_PARM_01",75)	(0043,"GEMS_PARM_01",75)	GEMS_PARM_01	67	117	f	\N	US	1	Number of Active Volumes	K
3965	(0043,"GEMS_PARM_01",76)	(0043,"GEMS_PARM_01",76)	GEMS_PARM_01	67	118	f	\N	US	1	Number of Dummy Scans	K
3966	(0043,"GEMS_PARM_01",77)	(0043,"GEMS_PARM_01",77)	GEMS_PARM_01	67	119	f	\N	SH	1	Application Name	R
3967	(0043,"GEMS_PARM_01",78)	(0043,"GEMS_PARM_01",78)	GEMS_PARM_01	67	120	f	\N	SH	1	Application Version	R
3968	(0043,"GEMS_PARM_01",79)	(0043,"GEMS_PARM_01",79)	GEMS_PARM_01	67	121	f	\N	US	1	Slices Per Volume	K
3969	(0043,"GEMS_PARM_01",7a)	(0043,"GEMS_PARM_01",7a)	GEMS_PARM_01	67	122	f	\N	US	1	Expected Time Points	K
3970	(0043,"GEMS_PARM_01",7b)	(0043,"GEMS_PARM_01",7b)	GEMS_PARM_01	67	123	f	\N	FL	1-n	Regressor Values	K
3971	(0043,"GEMS_PARM_01",7c)	(0043,"GEMS_PARM_01",7c)	GEMS_PARM_01	67	124	f	\N	FL	1	Delay After Slice Group	K
3972	(0043,"GEMS_PARM_01",7d)	(0043,"GEMS_PARM_01",7d)	GEMS_PARM_01	67	125	f	\N	US	1	Recon Mode Flag Word	K
3973	(0043,"GEMS_PARM_01",7e)	(0043,"GEMS_PARM_01",7e)	GEMS_PARM_01	67	126	f	\N	LO	1-n	PACC Specific Information	R
3974	(0043,"GEMS_PARM_01",7f)	(0043,"GEMS_PARM_01",7f)	GEMS_PARM_01	67	127	f	\N	DS	1-n	Reserved	R
3975	(0043,"GEMS_PARM_01",80)	(0043,"GEMS_PARM_01",80)	GEMS_PARM_01	67	128	f	\N	LO	1-n	Coil ID Data	R
3976	(0043,"GEMS_PARM_01",81)	(0043,"GEMS_PARM_01",81)	GEMS_PARM_01	67	129	f	\N	LO	1	GE Coil Name	R
3978	(0043,"GEMS_PARM_01",83)	(0043,"GEMS_PARM_01",83)	GEMS_PARM_01	67	131	f	\N	DS	1-2	Asset R Factors	K
3979	(0043,"GEMS_PARM_01",84)	(0043,"GEMS_PARM_01",84)	GEMS_PARM_01	67	132	f	\N	LO	5	Additional Asset Data	R
3980	(0043,"GEMS_PARM_01",85)	(0043,"GEMS_PARM_01",85)	GEMS_PARM_01	67	133	f	\N	UT	1	Debug Data (Text Format)	X
3981	(0043,"GEMS_PARM_01",86)	(0043,"GEMS_PARM_01",86)	GEMS_PARM_01	67	134	f	\N	OB	1	Debug Data (Binary Format)	X
3982	(0043,"GEMS_PARM_01",87)	(0043,"GEMS_PARM_01",87)	GEMS_PARM_01	67	135	f	\N	UT	1	Reserved	R
3983	(0043,"GEMS_PARM_01",88)	(0043,"GEMS_PARM_01",88)	GEMS_PARM_01	67	136	f	\N	UI	1	PURE Acquisition Calibration Series UID	R
3984	(0043,"GEMS_PARM_01",89)	(0043,"GEMS_PARM_01",89)	GEMS_PARM_01	67	137	f	\N	LO	3	Governing Body, dB/dt, and SAR definition	R
3985	(0043,"GEMS_PARM_01",8a)	(0043,"GEMS_PARM_01",8a)	GEMS_PARM_01	67	138	f	\N	CS	1	Private In-Plane Phase Encoding Direction	R
10975	(0119,"MRSC",1200)	(0119,"MRSC",00)	MRSC	281	0	t	12	IS	1-n	ImageProcessStatus	K
4002	(0045,"GEMS_SENO_02",1b)	(0045,"GEMS_SENO_02",1b)	GEMS_SENO_02	69	27	f	\N	LO	1	Clinical View	\N
4003	(0045,"GEMS_SENO_02",1d)	(0045,"GEMS_SENO_02",1d)	GEMS_SENO_02	69	29	f	\N	DS	1	Mean Of Raw Gray Levels	\N
4004	(0045,"GEMS_SENO_02",1e)	(0045,"GEMS_SENO_02",1e)	GEMS_SENO_02	69	30	f	\N	DS	1	Mean Of Offset Gray Levels	\N
4005	(0045,"GEMS_SENO_02",1f)	(0045,"GEMS_SENO_02",1f)	GEMS_SENO_02	69	31	f	\N	DS	1	Mean Of Corrected Gray Levels	\N
4006	(0045,"GEMS_SENO_02",49)	(0045,"GEMS_SENO_02",49)	GEMS_SENO_02	69	73	f	\N	DS	1	Radiological Thickness	\N
4007	(0045,"GEMS_SENO_02",50)	(0045,"GEMS_SENO_02",50)	GEMS_SENO_02	69	80	f	\N	UI	1	Fallback Instance UID (CR or SC)	\N
4008	(0045,"GEMS_SENO_02",51)	(0045,"GEMS_SENO_02",51)	GEMS_SENO_02	69	81	f	\N	UI	1	Fallback Series UID (CR or SC)	\N
4009	(0045,"GEMS_SENO_02",52)	(0045,"GEMS_SENO_02",52)	GEMS_SENO_02	69	82	f	\N	IS	1	Raw Diagnostic Low	\N
4010	(0045,"GEMS_SENO_02",53)	(0045,"GEMS_SENO_02",53)	GEMS_SENO_02	69	83	f	\N	IS	1	Raw Diagnostic High	\N
4011	(0045,"GEMS_SENO_02",54)	(0045,"GEMS_SENO_02",54)	GEMS_SENO_02	69	84	f	\N	DS	1	Exponent	\N
4012	(0045,"GEMS_SENO_02",55)	(0045,"GEMS_SENO_02",55)	GEMS_SENO_02	69	85	f	\N	IS	1	A Coefficients	\N
4013	(0045,"GEMS_SENO_02",56)	(0045,"GEMS_SENO_02",56)	GEMS_SENO_02	69	86	f	\N	DS	1	Noise Reduction Sensitivity	\N
4014	(0045,"GEMS_SENO_02",57)	(0045,"GEMS_SENO_02",57)	GEMS_SENO_02	69	87	f	\N	DS	1	Noise Reduction Threshold	\N
4015	(0045,"GEMS_SENO_02",58)	(0045,"GEMS_SENO_02",58)	GEMS_SENO_02	69	88	f	\N	DS	1	Mu	\N
4016	(0045,"GEMS_SENO_02",59)	(0045,"GEMS_SENO_02",59)	GEMS_SENO_02	69	89	f	\N	IS	1	Threshold	\N
4017	(0045,"GEMS_SENO_02",60)	(0045,"GEMS_SENO_02",60)	GEMS_SENO_02	69	96	f	\N	IS	4	Breast ROI X	\N
4018	(0045,"GEMS_SENO_02",61)	(0045,"GEMS_SENO_02",61)	GEMS_SENO_02	69	97	f	\N	IS	4	Breast ROI Y	\N
4019	(0045,"GEMS_SENO_02",62)	(0045,"GEMS_SENO_02",62)	GEMS_SENO_02	69	98	f	\N	IS	1	User Window Center	\N
4020	(0045,"GEMS_SENO_02",63)	(0045,"GEMS_SENO_02",63)	GEMS_SENO_02	69	99	f	\N	IS	1	User Window Width	\N
4021	(0045,"GEMS_SENO_02",64)	(0045,"GEMS_SENO_02",64)	GEMS_SENO_02	69	100	f	\N	IS	1	Segmentation Threshold	\N
4022	(0045,"GEMS_SENO_02",65)	(0045,"GEMS_SENO_02",65)	GEMS_SENO_02	69	101	f	\N	IS	1	Detector Entrance Dose	\N
4023	(0045,"GEMS_SENO_02",66)	(0045,"GEMS_SENO_02",66)	GEMS_SENO_02	69	102	f	\N	IS	1	Asymmetrical Collimation Information	\N
4024	(0045,"GEMS_SENO_02",71)	(0045,"GEMS_SENO_02",71)	GEMS_SENO_02	69	113	f	\N	OB	1	STX Buffer	\N
4025	(0045,"GEMS_SENO_02",72)	(0045,"GEMS_SENO_02",72)	GEMS_SENO_02	69	114	f	\N	DS	2	Image Crop Point	\N
4026	(0045,"GEMS_SENO_02",90)	(0045,"GEMS_SENO_02",90)	GEMS_SENO_02	69	144	f	\N	SH	1	Premium View Beta	\N
4027	(0045,"GEMS_SENO_02",a0)	(0045,"GEMS_SENO_02",a0)	GEMS_SENO_02	69	160	f	\N	DS	1	Signal Average Factor	\N
4028	(0045,"GEMS_SENO_02",a1)	(0045,"GEMS_SENO_02",a1)	GEMS_SENO_02	69	161	f	\N	DS	2-n	Organ Dose for Source Images	\N
4029	(0045,"GEMS_SENO_02",a2)	(0045,"GEMS_SENO_02",a2)	GEMS_SENO_02	69	162	f	\N	DS	2-n	Entrance dose in mGy for Source Images	\N
4030	(0045,"GEMS_SENO_02",a4)	(0045,"GEMS_SENO_02",a4)	GEMS_SENO_02	69	164	f	\N	DS	1	Organ Dose in dGy for Complete DBT Sequence	\N
4031	(0045,"GEMS_SENO_02",a6)	(0045,"GEMS_SENO_02",a6)	GEMS_SENO_02	69	166	f	\N	UI	1	SOP Instance UID for Lossy Compression	\N
4032	(0045,"GEMS_SENO_02",a7)	(0045,"GEMS_SENO_02",a7)	GEMS_SENO_02	69	167	f	\N	LT	1	Reconstruction Parameters	\N
4033	(0045,"GEMS_SENO_02",a8)	(0045,"GEMS_SENO_02",a8)	GEMS_SENO_02	69	168	f	\N	DS	1	Entrance Dose in dGy for Complete DBT Sequence	\N
3987	(0043,"GEMS_PARM_01",8c)	(0043,"GEMS_PARM_01",8c)	GEMS_PARM_01	67	140	f	\N	DS	1	Voxel Location	R
3988	(0043,"GEMS_PARM_01",8d)	(0043,"GEMS_PARM_01",8d)	GEMS_PARM_01	67	141	f	\N	DS	1-n	SAT Band Locations	R
3989	(0043,"GEMS_PARM_01",8e)	(0043,"GEMS_PARM_01",8e)	GEMS_PARM_01	67	142	f	\N	DS	3	Spectro Prescan Values	R
3990	(0043,"GEMS_PARM_01",8f)	(0043,"GEMS_PARM_01",8f)	GEMS_PARM_01	67	143	f	\N	DS	3	Spectro Parameters	R
3991	(0043,"GEMS_PARM_01",90)	(0043,"GEMS_PARM_01",90)	GEMS_PARM_01	67	144	f	\N	LO	1-n	SAR Definition	R
3992	(0043,"GEMS_PARM_01",91)	(0043,"GEMS_PARM_01",91)	GEMS_PARM_01	67	145	f	\N	DS	1-n	SAR Value	K
3993	(0043,"GEMS_PARM_01",92)	(0043,"GEMS_PARM_01",92)	GEMS_PARM_01	67	146	f	\N	LO	1	Image Error Text	X
3994	(0043,"GEMS_PARM_01",93)	(0043,"GEMS_PARM_01",93)	GEMS_PARM_01	67	147	f	\N	DS	1-n	Spectro Quantitation Values	K
3995	(0043,"GEMS_PARM_01",94)	(0043,"GEMS_PARM_01",94)	GEMS_PARM_01	67	148	f	\N	DS	1-n	Spectro Ratio Values	K
3996	(0043,"GEMS_PARM_01",95)	(0043,"GEMS_PARM_01",95)	GEMS_PARM_01	67	149	f	\N	LO	1	Prescan Reuse String	R
3997	(0043,"GEMS_PARM_01",96)	(0043,"GEMS_PARM_01",96)	GEMS_PARM_01	67	150	f	\N	CS	1	Content Qualification	R
3999	(0043,"GEMS_PARM_01",98)	(0043,"GEMS_PARM_01",98)	GEMS_PARM_01	67	152	f	\N	UI	1	ASSET Acquisition Calibration Series UID	R
4000	(0043,"GEMS_PARM_01",99)	(0043,"GEMS_PARM_01",99)	GEMS_PARM_01	67	153	f	\N	LO	1-n	Extended Options	R
4001	(0043,"GEMS_PARM_01",9a)	(0043,"GEMS_PARM_01",9a)	GEMS_PARM_01	67	154	f	\N	IS	1	Rx Stack Identification	K
4034	(0045,"GEMS_HELIOS_01",01)	(0045,"GEMS_HELIOS_01",01)	GEMS_HELIOS_01	69	1	f	\N	SS	1	Number of Macro Rows in Detector	KB
4035	(0045,"GEMS_HELIOS_01",02)	(0045,"GEMS_HELIOS_01",02)	GEMS_HELIOS_01	69	2	f	\N	FL	1	Macro width at ISO Center	KB
4036	(0045,"GEMS_HELIOS_01",03)	(0045,"GEMS_HELIOS_01",03)	GEMS_HELIOS_01	69	3	f	\N	SS	1	DAS type	KB
4037	(0045,"GEMS_HELIOS_01",04)	(0045,"GEMS_HELIOS_01",04)	GEMS_HELIOS_01	69	4	f	\N	SS	1	DAS gain	KB
4038	(0045,"GEMS_HELIOS_01",05)	(0045,"GEMS_HELIOS_01",05)	GEMS_HELIOS_01	69	5	f	\N	SS	1	DAS Temprature	KB
4039	(0045,"GEMS_HELIOS_01",06)	(0045,"GEMS_HELIOS_01",06)	GEMS_HELIOS_01	69	6	f	\N	CS	1	Table Direction	R
4040	(0045,"GEMS_HELIOS_01",07)	(0045,"GEMS_HELIOS_01",07)	GEMS_HELIOS_01	69	7	f	\N	FL	1	Z smoothing Factor	KB
4041	(0045,"GEMS_HELIOS_01",08)	(0045,"GEMS_HELIOS_01",08)	GEMS_HELIOS_01	69	8	f	\N	SS	1	View Weighting Mode	KB
4042	(0045,"GEMS_HELIOS_01",09)	(0045,"GEMS_HELIOS_01",09)	GEMS_HELIOS_01	69	9	f	\N	SS	1	Sigma Row number	KB
4069	(0047,"GEMS_ADWSoft_3D1",8a)	(0047,"GEMS_ADWSoft_3D1",8a)	GEMS_ADWSoft_3D1	71	138	f	\N	US	1	Number Of Injections	\N
4070	(0047,"GEMS_ADWSoft_3D1",8b)	(0047,"GEMS_ADWSoft_3D1",8b)	GEMS_ADWSoft_3D1	71	139	f	\N	US	1	Frame Count	\N
4071	(0047,"GEMS_ADWSoft_3D1",9a)	(0047,"GEMS_ADWSoft_3D1",9a)	GEMS_ADWSoft_3D1	71	154	f	\N	DS	9	Transform Rotation Matrix	\N
4072	(0047,"GEMS_ADWSoft_3D1",9b)	(0047,"GEMS_ADWSoft_3D1",9b)	GEMS_ADWSoft_3D1	71	155	f	\N	DS	3	Transform Translation Vector	\N
4073	(0047,"GEMS_ADWSoft_3D1",9c)	(0047,"GEMS_ADWSoft_3D1",9c)	GEMS_ADWSoft_3D1	71	156	f	\N	LO	1	Transform Label	\N
4074	(0047,"GEMS_ADWSoft_3D1",b0)	(0047,"GEMS_ADWSoft_3D1",b0)	GEMS_ADWSoft_3D1	71	176	f	\N	SQ	1	Wireframe List	\N
4075	(0047,"GEMS_ADWSoft_3D1",b1)	(0047,"GEMS_ADWSoft_3D1",b1)	GEMS_ADWSoft_3D1	71	177	f	\N	US	1	Wireframe Count	\N
4076	(0047,"GEMS_ADWSoft_3D1",b2)	(0047,"GEMS_ADWSoft_3D1",b2)	GEMS_ADWSoft_3D1	71	178	f	\N	US	1	Location System	\N
4077	(0047,"GEMS_ADWSoft_3D1",b5)	(0047,"GEMS_ADWSoft_3D1",b5)	GEMS_ADWSoft_3D1	71	181	f	\N	LO	1	Wireframe Name	\N
4078	(0047,"GEMS_ADWSoft_3D1",b6)	(0047,"GEMS_ADWSoft_3D1",b6)	GEMS_ADWSoft_3D1	71	182	f	\N	LO	1	Wireframe Group Name	\N
4079	(0047,"GEMS_ADWSoft_3D1",b7)	(0047,"GEMS_ADWSoft_3D1",b7)	GEMS_ADWSoft_3D1	71	183	f	\N	LO	1	Wireframe Color	\N
4080	(0047,"GEMS_ADWSoft_3D1",b8)	(0047,"GEMS_ADWSoft_3D1",b8)	GEMS_ADWSoft_3D1	71	184	f	\N	SL	1	Wireframe Attributes	\N
4081	(0047,"GEMS_ADWSoft_3D1",b9)	(0047,"GEMS_ADWSoft_3D1",b9)	GEMS_ADWSoft_3D1	71	185	f	\N	SL	1	Wireframe Point Count	\N
4082	(0047,"GEMS_ADWSoft_3D1",ba)	(0047,"GEMS_ADWSoft_3D1",ba)	GEMS_ADWSoft_3D1	71	186	f	\N	SL	1	Wireframe Timestamp	\N
4083	(0047,"GEMS_ADWSoft_3D1",bb)	(0047,"GEMS_ADWSoft_3D1",bb)	GEMS_ADWSoft_3D1	71	187	f	\N	SQ	1	Wireframe Point List	\N
4084	(0047,"GEMS_ADWSoft_3D1",bc)	(0047,"GEMS_ADWSoft_3D1",bc)	GEMS_ADWSoft_3D1	71	188	f	\N	DS	3	Wireframe Points Coordinates	\N
4085	(0047,"GEMS_ADWSoft_3D1",c0)	(0047,"GEMS_ADWSoft_3D1",c0)	GEMS_ADWSoft_3D1	71	192	f	\N	DS	3	Volume Upper Left High Corner RAS	\N
4086	(0047,"GEMS_ADWSoft_3D1",c1)	(0047,"GEMS_ADWSoft_3D1",c1)	GEMS_ADWSoft_3D1	71	193	f	\N	DS	9	Volume Slice To RAS Rotation Matrix	\N
4087	(0047,"GEMS_ADWSoft_3D1",c2)	(0047,"GEMS_ADWSoft_3D1",c2)	GEMS_ADWSoft_3D1	71	194	f	\N	DS	1	Volume Upper Left High Corner TLOC	\N
4088	(0047,"GEMS_ADWSoft_3D1",d1)	(0047,"GEMS_ADWSoft_3D1",d1)	GEMS_ADWSoft_3D1	71	209	f	\N	OB	1	Volume Segment List	\N
4089	(0047,"GEMS_ADWSoft_3D1",d2)	(0047,"GEMS_ADWSoft_3D1",d2)	GEMS_ADWSoft_3D1	71	210	f	\N	OB	1	Volume Gradient List	\N
4090	(0047,"GEMS_ADWSoft_3D1",d3)	(0047,"GEMS_ADWSoft_3D1",d3)	GEMS_ADWSoft_3D1	71	211	f	\N	OB	1	Volume Density List	\N
4091	(0047,"GEMS_ADWSoft_3D1",d4)	(0047,"GEMS_ADWSoft_3D1",d4)	GEMS_ADWSoft_3D1	71	212	f	\N	OB	1	Volume Z Position List	\N
4092	(0047,"GEMS_ADWSoft_3D1",d5)	(0047,"GEMS_ADWSoft_3D1",d5)	GEMS_ADWSoft_3D1	71	213	f	\N	OB	1	Volume Original Index List	\N
4093	(0047,"GEMS_3DSTATE_001",e9)	(0047,"GEMS_3DSTATE_001",e9)	GEMS_3DSTATE_001	71	233	f	\N	FL	3	Unknown	\N
4094	(0047,"GEMS_3DSTATE_001",ea)	(0047,"GEMS_3DSTATE_001",ea)	GEMS_3DSTATE_001	71	234	f	\N	DS	3	Unknown	\N
4095	(0047,"GEMS_3DSTATE_001",eb)	(0047,"GEMS_3DSTATE_001",eb)	GEMS_3DSTATE_001	71	235	f	\N	DS	3	Unknown	\N
4096	(0047,"GEMS_3DSTATE_001",ec)	(0047,"GEMS_3DSTATE_001",ec)	GEMS_3DSTATE_001	71	236	f	\N	FL	1	Unknown	\N
4097	(0047,"GEMS_3DSTATE_001",ed)	(0047,"GEMS_3DSTATE_001",ed)	GEMS_3DSTATE_001	71	237	f	\N	CS	1	Unknown	\N
4044	(0045,"GEMS_HELIOS_01",0b)	(0045,"GEMS_HELIOS_01",0b)	GEMS_HELIOS_01	69	11	f	\N	FL	1	Maximum Offset Value	KB
4045	(0045,"GEMS_HELIOS_01",0c)	(0045,"GEMS_HELIOS_01",0c)	GEMS_HELIOS_01	69	12	f	\N	SS	1	Number of Views shifted	KB
4046	(0045,"GEMS_HELIOS_01",0d)	(0045,"GEMS_HELIOS_01",0d)	GEMS_HELIOS_01	69	13	f	\N	SS	1	Z tracking Flag	KB
4047	(0045,"GEMS_HELIOS_01",0e)	(0045,"GEMS_HELIOS_01",0e)	GEMS_HELIOS_01	69	14	f	\N	FL	1	Mean Z error	KB
4048	(0045,"GEMS_HELIOS_01",0f)	(0045,"GEMS_HELIOS_01",0f)	GEMS_HELIOS_01	69	15	f	\N	FL	1	Z tracking Error	KB
4049	(0045,"GEMS_HELIOS_01",10)	(0045,"GEMS_HELIOS_01",10)	GEMS_HELIOS_01	69	16	f	\N	SS	1	Start View 2A	KB
4050	(0045,"GEMS_HELIOS_01",11)	(0045,"GEMS_HELIOS_01",11)	GEMS_HELIOS_01	69	17	f	\N	SS	1	Number of Views 2A	KB
4051	(0045,"GEMS_HELIOS_01",12)	(0045,"GEMS_HELIOS_01",12)	GEMS_HELIOS_01	69	18	f	\N	SS	1	Start View 1A	KB
4052	(0045,"GEMS_HELIOS_01",13)	(0045,"GEMS_HELIOS_01",13)	GEMS_HELIOS_01	69	19	f	\N	SS	1	Sigma Mode	KB
4053	(0045,"GEMS_HELIOS_01",14)	(0045,"GEMS_HELIOS_01",14)	GEMS_HELIOS_01	69	20	f	\N	SS	1	Number of Views 1A	KB
4054	(0045,"GEMS_HELIOS_01",15)	(0045,"GEMS_HELIOS_01",15)	GEMS_HELIOS_01	69	21	f	\N	SS	1	Start View 2B	KB
4055	(0045,"GEMS_HELIOS_01",16)	(0045,"GEMS_HELIOS_01",16)	GEMS_HELIOS_01	69	22	f	\N	SS	1	Number Views 2B	KB
4056	(0045,"GEMS_HELIOS_01",17)	(0045,"GEMS_HELIOS_01",17)	GEMS_HELIOS_01	69	23	f	\N	SS	1	Start View 1B	KB
4058	(0045,"GEMS_HELIOS_01",21)	(0045,"GEMS_HELIOS_01",21)	GEMS_HELIOS_01	69	33	f	\N	SS	1	Iterbone Flag	KB
4059	(0045,"GEMS_HELIOS_01",22)	(0045,"GEMS_HELIOS_01",22)	GEMS_HELIOS_01	69	34	f	\N	SS	1	PeristalticFlag	KB
4060	(0045,"GEMS_HELIOS_01",30)	(0045,"GEMS_HELIOS_01",30)	GEMS_HELIOS_01	69	48	f	\N	CS	1	CardiacReconAlgorithm	R
4061	(0045,"GEMS_HELIOS_01",31)	(0045,"GEMS_HELIOS_01",31)	GEMS_HELIOS_01	69	49	f	\N	CS	1	AvgHeartRateForImage	R
4062	(0045,"GEMS_HELIOS_01",32)	(0045,"GEMS_HELIOS_01",32)	GEMS_HELIOS_01	69	50	f	\N	FL	1	TemporalResolution	KB
4063	(0045,"GEMS_HELIOS_01",33)	(0045,"GEMS_HELIOS_01",33)	GEMS_HELIOS_01	69	51	f	\N	CS	1	PctRpeakDelay	R
4064	(0045,"GEMS_HELIOS_01",36)	(0045,"GEMS_HELIOS_01",36)	GEMS_HELIOS_01	69	54	f	\N	CS	1	EkgFullMaStartPhase	R
4065	(0045,"GEMS_HELIOS_01",37)	(0045,"GEMS_HELIOS_01",37)	GEMS_HELIOS_01	69	55	f	\N	CS	1	EkgFullMaEndPhase	R
4066	(0045,"GEMS_HELIOS_01",38)	(0045,"GEMS_HELIOS_01",38)	GEMS_HELIOS_01	69	56	f	\N	CS	1	EkgModulationMaxMa	R
4067	(0045,"GEMS_HELIOS_01",39)	(0045,"GEMS_HELIOS_01",39)	GEMS_HELIOS_01	69	57	f	\N	CS	1	EkgModulationMinMa	R
4068	(0045,"GEMS_HELIOS_01",3b)	(0045,"GEMS_HELIOS_01",3b)	GEMS_HELIOS_01	69	59	f	\N	LO	1	NoiseReductionImageFilterDesc	R
4098	(0047,"GEMS_IQTB_IDEN_47",02)	(0047,"GEMS_IQTB_IDEN_47",02)	GEMS_IQTB_IDEN_47	71	2	f	\N	UL	1	Unknown	\N
10976	(0119,"MRSC",1201)	(0119,"MRSC",01)	MRSC	281	1	t	12	LO	1	SourceID	K
4111	(004b,"GEMS_CT_HINO_01",01)	(004b,"GEMS_CT_HINO_01",01)	GEMS_CT_HINO_01	75	1	f	\N	DS	1-n	Beam Thickess	\N
4112	(004b,"GEMS_CT_HINO_01",02)	(004b,"GEMS_CT_HINO_01",02)	GEMS_CT_HINO_01	75	2	f	\N	DS	1-n	R Time	\N
4113	(004b,"GEMS_CT_HINO_01",03)	(004b,"GEMS_CT_HINO_01",03)	GEMS_CT_HINO_01	75	3	f	\N	IS	1	HBC Number	\N
4114	(004b,"GEIIS",13)	(004b,"GEIIS",13)	GEIIS	75	19	f	\N	IS	1	Unknown	\N
4115	(004b,"GEIIS",15)	(004b,"GEIIS",15)	GEIIS	75	21	f	\N	LT	1	Unknown	\N
4116	(0051,"GEMS_CT_VES_01",01)	(0051,"GEMS_CT_VES_01",01)	GEMS_CT_VES_01	81	1	f	\N	SQ	1	CTVESequence	\N
4117	(0055,"GEMS_GENIE_1",12)	(0055,"GEMS_GENIE_1",12)	GEMS_GENIE_1	85	18	f	\N	SQ	1	eNTEGRA Energy Window Information Sequence	\N
4118	(0055,"GEMS_GENIE_1",13)	(0055,"GEMS_GENIE_1",13)	GEMS_GENIE_1	85	19	f	\N	SQ	1	eNTEGRA Energy Window Range Sequence	\N
4119	(0055,"GEMS_GENIE_1",22)	(0055,"GEMS_GENIE_1",22)	GEMS_GENIE_1	85	34	f	\N	SQ	1	eNTEGRA Detector Information Sequence	\N
4120	(0055,"GEMS_GENIE_1",52)	(0055,"GEMS_GENIE_1",52)	GEMS_GENIE_1	85	82	f	\N	SQ	1	eNTEGRA Rotation Information Sequence	\N
4121	(0055,"GEMS_GENIE_1",62)	(0055,"GEMS_GENIE_1",62)	GEMS_GENIE_1	85	98	f	\N	SQ	1	eNTEGRA Gated Information Sequence	\N
4122	(0055,"GEMS_GENIE_1",63)	(0055,"GEMS_GENIE_1",63)	GEMS_GENIE_1	85	99	f	\N	SQ	1	eNTEGRA Data Information Sequence	\N
4123	(0055,"GEMS_GENIE_1",64)	(0055,"GEMS_GENIE_1",64)	GEMS_GENIE_1	85	100	f	\N	SQ	1	SDO Double Data Sequence	\N
4124	(0055,"GEMS_GENIE_1",65)	(0055,"GEMS_GENIE_1",65)	GEMS_GENIE_1	85	101	f	\N	SQ	1	Unknown	\N
4125	(3101,"AMI Annotations_01",10)	(3101,"AMI Annotations_01",10)	AMI Annotations_01	12545	16	f	\N	SQ	1	Annotation Sequence	\N
4126	(3101,"AMI Annotations_02",20)	(3101,"AMI Annotations_02",20)	AMI Annotations_02	12545	32	f	\N	SQ	1	Annotation Sequence	\N
4127	(3103,"AMI Sequence Annotations_01",10)	(3103,"AMI Sequence Annotations_01",10)	AMI Sequence Annotations_01	12547	16	f	\N	CS	1	Annotation Sequence	\N
4128	(3103,"AMI Sequence Annotations_01",20)	(3103,"AMI Sequence Annotations_01",20)	AMI Sequence Annotations_01	12547	32	f	\N	UI	1	Annotation UID	\N
4129	(3103,"AMI Sequence Annotations_01",30)	(3103,"AMI Sequence Annotations_01",30)	AMI Sequence Annotations_01	12547	48	f	\N	US	1	Annotation Color	\N
4130	(3103,"AMI Sequence Annotations_01",50)	(3103,"AMI Sequence Annotations_01",50)	AMI Sequence Annotations_01	12547	80	f	\N	CS	1	Annotation Line Style	\N
4131	(3103,"AMI Sequence Annotations_01",60)	(3103,"AMI Sequence Annotations_01",60)	AMI Sequence Annotations_01	12547	96	f	\N	SQ	1	Annotation Elements	\N
4132	(3103,"AMI Sequence Annotations_01",70)	(3103,"AMI Sequence Annotations_01",70)	AMI Sequence Annotations_01	12547	112	f	\N	SH	1	Annotation Label	\N
4133	(3103,"AMI Sequence Annotations_01",80)	(3103,"AMI Sequence Annotations_01",80)	AMI Sequence Annotations_01	12547	128	f	\N	PN	1	Annotation Creator	\N
4134	(3103,"AMI Sequence Annotations_01",90)	(3103,"AMI Sequence Annotations_01",90)	AMI Sequence Annotations_01	12547	144	f	\N	PN	1	Annotation Modifiers	\N
4135	(3103,"AMI Sequence Annotations_01",a0)	(3103,"AMI Sequence Annotations_01",a0)	AMI Sequence Annotations_01	12547	160	f	\N	DA	1	Annotation Creation Date	\N
4136	(3103,"AMI Sequence Annotations_01",b0)	(3103,"AMI Sequence Annotations_01",b0)	AMI Sequence Annotations_01	12547	176	f	\N	TM	1	Annotation Creation Time	\N
4137	(3103,"AMI Sequence Annotations_01",c0)	(3103,"AMI Sequence Annotations_01",c0)	AMI Sequence Annotations_01	12547	192	f	\N	DA	1	Annotation Modification Dates	\N
4138	(3103,"AMI Sequence Annotations_01",d0)	(3103,"AMI Sequence Annotations_01",d0)	AMI Sequence Annotations_01	12547	208	f	\N	TM	1	Annotation Mofification Times	\N
4139	(3103,"AMI Sequence Annotations_01",e0)	(3103,"AMI Sequence Annotations_01",e0)	AMI Sequence Annotations_01	12547	224	f	\N	US	1	Annotation Frame Number	\N
4140	(3103,"AMI Sequence Annotations_02",10)	(3103,"AMI Sequence Annotations_02",10)	AMI Sequence Annotations_02	12547	16	f	\N	CS	1	Annotation Sequence	\N
4141	(3103,"AMI Sequence Annotations_02",20)	(3103,"AMI Sequence Annotations_02",20)	AMI Sequence Annotations_02	12547	32	f	\N	UI	1	Annotation UID	\N
4142	(3103,"AMI Sequence Annotations_02",30)	(3103,"AMI Sequence Annotations_02",30)	AMI Sequence Annotations_02	12547	48	f	\N	US	1	Annotation Color	\N
4143	(3103,"AMI Sequence Annotations_02",50)	(3103,"AMI Sequence Annotations_02",50)	AMI Sequence Annotations_02	12547	80	f	\N	CS	1	Annotation Line Style	\N
4144	(3103,"AMI Sequence Annotations_02",60)	(3103,"AMI Sequence Annotations_02",60)	AMI Sequence Annotations_02	12547	96	f	\N	SQ	1	Annotation Elements	\N
4145	(3103,"AMI Sequence Annotations_02",70)	(3103,"AMI Sequence Annotations_02",70)	AMI Sequence Annotations_02	12547	112	f	\N	SH	1	Annotation Label	\N
4146	(3103,"AMI Sequence Annotations_02",80)	(3103,"AMI Sequence Annotations_02",80)	AMI Sequence Annotations_02	12547	128	f	\N	PN	1	Annotation Creator	\N
4100	(0049,"GEMS_CT_CARDIAC_001",02)	(0049,"GEMS_CT_CARDIAC_001",02)	GEMS_CT_CARDIAC_001	73	2	f	\N	CS	1	HeartRateAtConfirm	R
4101	(0049,"GEMS_CT_CARDIAC_001",03)	(0049,"GEMS_CT_CARDIAC_001",03)	GEMS_CT_CARDIAC_001	73	3	f	\N	FL	1	AvgHeartRatePriorToConfirm	KB
4102	(0049,"GEMS_CT_CARDIAC_001",04)	(0049,"GEMS_CT_CARDIAC_001",04)	GEMS_CT_CARDIAC_001	73	4	f	\N	CS	1	MinHeartRatePriorToConfirm	R
4104	(0049,"GEMS_CT_CARDIAC_001",06)	(0049,"GEMS_CT_CARDIAC_001",06)	GEMS_CT_CARDIAC_001	73	6	f	\N	FL	1	StdDevHeartRatePriorToConfirm	KB
4105	(0049,"GEMS_CT_CARDIAC_001",07)	(0049,"GEMS_CT_CARDIAC_001",07)	GEMS_CT_CARDIAC_001	73	7	f	\N	US	1	NumHeartRateSamplesPriorToConfirm	KB
4106	(0049,"GEMS_CT_CARDIAC_001",08)	(0049,"GEMS_CT_CARDIAC_001",08)	GEMS_CT_CARDIAC_001	73	8	f	\N	CS	1	AutoHeartRateDetectPredict	R
4107	(0049,"GEMS_CT_CARDIAC_001",09)	(0049,"GEMS_CT_CARDIAC_001",09)	GEMS_CT_CARDIAC_001	73	9	f	\N	CS	1	SystemOptimizedHeartRate	R
4108	(0049,"GEMS_CT_CARDIAC_001",0a)	(0049,"GEMS_CT_CARDIAC_001",0a)	GEMS_CT_CARDIAC_001	73	10	f	\N	ST	1	EkgMonitorType	R
4109	(0049,"GEMS_CT_CARDIAC_001",0b)	(0049,"GEMS_CT_CARDIAC_001",0b)	GEMS_CT_CARDIAC_001	73	11	f	\N	CS	1	NumReconSectors	R
4110	(0049,"GEMS_CT_CARDIAC_001",0c)	(0049,"GEMS_CT_CARDIAC_001",0c)	GEMS_CT_CARDIAC_001	73	12	f	\N	FL	256	RpeakTimeStamps	KB
4147	(3103,"AMI Sequence Annotations_02",90)	(3103,"AMI Sequence Annotations_02",90)	AMI Sequence Annotations_02	12547	144	f	\N	PN	1	Annotation Modifiers	\N
4148	(3103,"AMI Sequence Annotations_02",a0)	(3103,"AMI Sequence Annotations_02",a0)	AMI Sequence Annotations_02	12547	160	f	\N	DA	1	Annotation Creation Date	\N
4149	(3103,"AMI Sequence Annotations_02",b0)	(3103,"AMI Sequence Annotations_02",b0)	AMI Sequence Annotations_02	12547	176	f	\N	TM	1	Annotation Creation Time	\N
4150	(3103,"AMI Sequence Annotations_02",c0)	(3103,"AMI Sequence Annotations_02",c0)	AMI Sequence Annotations_02	12547	192	f	\N	DA	1	Annotation Modification Dates	\N
4151	(3103,"AMI Sequence Annotations_02",d0)	(3103,"AMI Sequence Annotations_02",d0)	AMI Sequence Annotations_02	12547	208	f	\N	TM	1	Annotation Modification Times	\N
4152	(3103,"AMI Sequence Annotations_02",e0)	(3103,"AMI Sequence Annotations_02",e0)	AMI Sequence Annotations_02	12547	224	f	\N	US	1	Annotation Frame Number	\N
4153	(3105,"AMI Sequence AnnotElements_01",10)	(3105,"AMI Sequence AnnotElements_01",10)	AMI Sequence AnnotElements_01	12549	16	f	\N	DS	1-n	Annotation Element Position	\N
4154	(3105,"AMI Sequence AnnotElements_01",20)	(3105,"AMI Sequence AnnotElements_01",20)	AMI Sequence AnnotElements_01	12549	32	f	\N	LT	1	Annotation Element Text	\N
4155	(3107,"AMI ImageTransform_01",10)	(3107,"AMI ImageTransform_01",10)	AMI ImageTransform_01	12551	16	f	\N	DS	1-n	Transformation Matrix	\N
4156	(3107,"AMI ImageTransform_01",20)	(3107,"AMI ImageTransform_01",20)	AMI ImageTransform_01	12551	32	f	\N	DS	1	Center Offset	\N
4157	(3107,"AMI ImageTransform_01",30)	(3107,"AMI ImageTransform_01",30)	AMI ImageTransform_01	12551	48	f	\N	DS	1	Magnification	\N
4158	(3107,"AMI ImageTransform_01",40)	(3107,"AMI ImageTransform_01",40)	AMI ImageTransform_01	12551	64	f	\N	CS	1	Magnification Type	\N
4159	(3107,"AMI ImageTransform_01",50)	(3107,"AMI ImageTransform_01",50)	AMI ImageTransform_01	12551	80	f	\N	DS	1	Displayed Area	\N
4160	(3107,"AMI ImageTransform_01",60)	(3107,"AMI ImageTransform_01",60)	AMI ImageTransform_01	12551	96	f	\N	DS	1	Calibration Factor	\N
4161	(3107,"AMI ImageContextExt_01",a0)	(3107,"AMI ImageContextExt_01",a0)	AMI ImageContextExt_01	12551	160	f	\N	CS	1	Window Function	\N
4162	(3107,"AMI ImageContextExt_01",b0)	(3107,"AMI ImageContextExt_01",b0)	AMI ImageContextExt_01	12551	176	f	\N	DS	1	Window Slope	\N
4163	(3109,"Applicare/RadWorks/Version 5.0",01)	(3109,"Applicare/RadWorks/Version 5.0",01)	Applicare/RadWorks/Version 5.0	12553	1	f	\N	ST	1	Worklist Filename	\N
4164	(3109,"Applicare/RadWorks/Version 5.0",02)	(3109,"Applicare/RadWorks/Version 5.0",02)	Applicare/RadWorks/Version 5.0	12553	2	f	\N	SH	1	NEW/SEEN Status	\N
4165	(3109,"Applicare/RadWorks/Version 5.0",03)	(3109,"Applicare/RadWorks/Version 5.0",03)	Applicare/RadWorks/Version 5.0	12553	3	f	\N	CS	1	Delete Lock	\N
4166	(3109,"Applicare/RadWorks/Version 5.0",04)	(3109,"Applicare/RadWorks/Version 5.0",04)	Applicare/RadWorks/Version 5.0	12553	4	f	\N	CS	1	Unknown	\N
4167	(3109,"Applicare/RadWorks/Version 5.0",05)	(3109,"Applicare/RadWorks/Version 5.0",05)	Applicare/RadWorks/Version 5.0	12553	5	f	\N	CS	1	Unknown	\N
4168	(3109,"Applicare/RadWorks/Version 5.0",06)	(3109,"Applicare/RadWorks/Version 5.0",06)	Applicare/RadWorks/Version 5.0	12553	6	f	\N	CS	1	Unknown	\N
4169	(3109,"Applicare/RadWorks/Version 5.0",07)	(3109,"Applicare/RadWorks/Version 5.0",07)	Applicare/RadWorks/Version 5.0	12553	7	f	\N	UL	1	Unknown	\N
4170	(3109,"Applicare/RadWorks/Version 5.0",08)	(3109,"Applicare/RadWorks/Version 5.0",08)	Applicare/RadWorks/Version 5.0	12553	8	f	\N	LO	1	Receive Origin	\N
4171	(3109,"Applicare/RadWorks/Version 5.0",09)	(3109,"Applicare/RadWorks/Version 5.0",09)	Applicare/RadWorks/Version 5.0	12553	9	f	\N	LO	1	Folder	\N
4172	(3109,"Applicare/RadWorks/Version 5.0",0a)	(3109,"Applicare/RadWorks/Version 5.0",0a)	Applicare/RadWorks/Version 5.0	12553	10	f	\N	DA	1	Receive Date	\N
4173	(3109,"Applicare/RadWorks/Version 5.0",0b)	(3109,"Applicare/RadWorks/Version 5.0",0b)	Applicare/RadWorks/Version 5.0	12553	11	f	\N	TM	1	Receive Time	\N
4174	(3109,"Applicare/RadWorks/Version 5.0",0c)	(3109,"Applicare/RadWorks/Version 5.0",0c)	Applicare/RadWorks/Version 5.0	12553	12	f	\N	CS	1	Prior	\N
4175	(3109,"Applicare/RadWorks/Version 5.0",0d)	(3109,"Applicare/RadWorks/Version 5.0",0d)	Applicare/RadWorks/Version 5.0	12553	13	f	\N	CS	1	STAT Study	\N
4176	(3109,"Applicare/RadWorks/Version 5.0",0e)	(3109,"Applicare/RadWorks/Version 5.0",0e)	Applicare/RadWorks/Version 5.0	12553	14	f	\N	CS	1	Is Key Image Or Study	\N
4177	(3109,"Applicare/RadWorks/Version 5.0",10)	(3109,"Applicare/RadWorks/Version 5.0",10)	Applicare/RadWorks/Version 5.0	12553	16	f	\N	CS	1	Local Study	\N
4178	(3109,"Applicare/RadWorks/Version 5.0",11)	(3109,"Applicare/RadWorks/Version 5.0",11)	Applicare/RadWorks/Version 5.0	12553	17	f	\N	LO	1	Result Message	\N
4179	(3109,"Applicare/RadWorks/Version 5.0",12)	(3109,"Applicare/RadWorks/Version 5.0",12)	Applicare/RadWorks/Version 5.0	12553	18	f	\N	LO	1	Current User	\N
4180	(3109,"Applicare/RadWorks/Version 5.0",13)	(3109,"Applicare/RadWorks/Version 5.0",13)	Applicare/RadWorks/Version 5.0	12553	19	f	\N	DA	1	System Date	\N
4181	(3109,"Applicare/RadWorks/Version 5.0",14)	(3109,"Applicare/RadWorks/Version 5.0",14)	Applicare/RadWorks/Version 5.0	12553	20	f	\N	TM	1	System Time	\N
4182	(3109,"Applicare/RadWorks/Version 5.0",19)	(3109,"Applicare/RadWorks/Version 5.0",19)	Applicare/RadWorks/Version 5.0	12553	25	f	\N	LO	1	Worklist Name	\N
4183	(3109,"Applicare/RadWorks/Version 5.0",20)	(3109,"Applicare/RadWorks/Version 5.0",20)	Applicare/RadWorks/Version 5.0	12553	32	f	\N	UI	1	Worklist UID	\N
4184	(3109,"Applicare/RadWorks/Version 5.0",21)	(3109,"Applicare/RadWorks/Version 5.0",21)	Applicare/RadWorks/Version 5.0	12553	33	f	\N	CS	1	Hostname	\N
4185	(3109,"Applicare/RadWorks/Version 5.0",22)	(3109,"Applicare/RadWorks/Version 5.0",22)	Applicare/RadWorks/Version 5.0	12553	34	f	\N	AE	1	DICOM AE Title	\N
4186	(3109,"Applicare/RadWorks/Version 5.0",23)	(3109,"Applicare/RadWorks/Version 5.0",23)	Applicare/RadWorks/Version 5.0	12553	35	f	\N	US	1	DICOM Port Number	\N
4187	(3109,"Applicare/RadWorks/Version 5.0",24)	(3109,"Applicare/RadWorks/Version 5.0",24)	Applicare/RadWorks/Version 5.0	12553	36	f	\N	LO	1	Destination Name	\N
4188	(3109,"Applicare/RadWorks/Version 5.0",25)	(3109,"Applicare/RadWorks/Version 5.0",25)	Applicare/RadWorks/Version 5.0	12553	37	f	\N	LO	1	Origin Name	\N
4189	(3109,"Applicare/RadWorks/Version 5.0",26)	(3109,"Applicare/RadWorks/Version 5.0",26)	Applicare/RadWorks/Version 5.0	12553	38	f	\N	UI	1	Modality Study Instance UID	\N
4190	(3109,"Applicare/RadWorks/Version 5.0",27)	(3109,"Applicare/RadWorks/Version 5.0",27)	Applicare/RadWorks/Version 5.0	12553	39	f	\N	SQ	1	Exam Routing	\N
4191	(3109,"Applicare/RadWorks/Version 5.0",28)	(3109,"Applicare/RadWorks/Version 5.0",28)	Applicare/RadWorks/Version 5.0	12553	40	f	\N	LO	1	Notification Comments	\N
4192	(3109,"Applicare/RadWorks/Version 5.0",29)	(3109,"Applicare/RadWorks/Version 5.0",29)	Applicare/RadWorks/Version 5.0	12553	41	f	\N	LO	1	Transaction Comments	\N
4193	(3109,"Applicare/RadWorks/Version 5.0",2a)	(3109,"Applicare/RadWorks/Version 5.0",2a)	Applicare/RadWorks/Version 5.0	12553	42	f	\N	LO	1	Send Flag	\N
4194	(3109,"Applicare/RadWorks/Version 5.0",2b)	(3109,"Applicare/RadWorks/Version 5.0",2b)	Applicare/RadWorks/Version 5.0	12553	43	f	\N	LO	1	Print Flag	\N
4195	(3109,"Applicare/RadWorks/Version 5.0",2c)	(3109,"Applicare/RadWorks/Version 5.0",2c)	Applicare/RadWorks/Version 5.0	12553	44	f	\N	LO	1	Archive Flag	\N
4196	(3109,"Applicare/RadWorks/Version 5.0",30)	(3109,"Applicare/RadWorks/Version 5.0",30)	Applicare/RadWorks/Version 5.0	12553	48	f	\N	LO	1	Requesting Facility Name	\N
4197	(3109,"Applicare/RadWorks/Version 5.0",31)	(3109,"Applicare/RadWorks/Version 5.0",31)	Applicare/RadWorks/Version 5.0	12553	49	f	\N	CS	1	Requesting Procedure Name	\N
4198	(3109,"Applicare/RadWorks/Version 5.0",32)	(3109,"Applicare/RadWorks/Version 5.0",32)	Applicare/RadWorks/Version 5.0	12553	50	f	\N	CS	1	Requesting Procedure Code	\N
4199	(3109,"Applicare/RadWorks/Version 5.0",33)	(3109,"Applicare/RadWorks/Version 5.0",33)	Applicare/RadWorks/Version 5.0	12553	51	f	\N	CS	1	Request Storage Commitment	\N
4200	(3109,"Applicare/RadWorks/Version 5.0",34)	(3109,"Applicare/RadWorks/Version 5.0",34)	Applicare/RadWorks/Version 5.0	12553	52	f	\N	CS	1	Requested Compression	\N
4201	(3109,"Applicare/RadWorks/Version 5.0",35)	(3109,"Applicare/RadWorks/Version 5.0",35)	Applicare/RadWorks/Version 5.0	12553	53	f	\N	SQ	1	Study Sequence	\N
4202	(3109,"Applicare/RadWorks/Version 5.0",37)	(3109,"Applicare/RadWorks/Version 5.0",37)	Applicare/RadWorks/Version 5.0	12553	55	f	\N	UI	1	Replaced Study UID	\N
4203	(3109,"Applicare/RadWorks/Version 5.0",38)	(3109,"Applicare/RadWorks/Version 5.0",38)	Applicare/RadWorks/Version 5.0	12553	56	f	\N	SH	1	Teaching ACR Code	\N
4204	(3109,"Applicare/RadWorks/Version 5.0",39)	(3109,"Applicare/RadWorks/Version 5.0",39)	Applicare/RadWorks/Version 5.0	12553	57	f	\N	SH	1	Teaching Special Interest Code	\N
4205	(3109,"Applicare/RadWorks/Version 5.0",40)	(3109,"Applicare/RadWorks/Version 5.0",40)	Applicare/RadWorks/Version 5.0	12553	64	f	\N	IS	1	Number of Study Related Images	\N
4206	(3109,"Applicare/RadWorks/Version 5.0",41)	(3109,"Applicare/RadWorks/Version 5.0",41)	Applicare/RadWorks/Version 5.0	12553	65	f	\N	CS	1	Study Locked	\N
4207	(3109,"Applicare/RadWorks/Version 5.0",42)	(3109,"Applicare/RadWorks/Version 5.0",42)	Applicare/RadWorks/Version 5.0	12553	66	f	\N	CS	1	Workstation Name	\N
4208	(3109,"Applicare/RadWorks/Version 5.0",43)	(3109,"Applicare/RadWorks/Version 5.0",43)	Applicare/RadWorks/Version 5.0	12553	67	f	\N	CS	1	Archive Status	\N
4209	(3109,"Applicare/RadWorks/Version 5.0",ee)	(3109,"Applicare/RadWorks/Version 5.0",ee)	Applicare/RadWorks/Version 5.0	12553	238	f	\N	UI	1	Internal List UID	\N
4210	(3109,"Applicare/RadWorks/Version 5.0",ef)	(3109,"Applicare/RadWorks/Version 5.0",ef)	Applicare/RadWorks/Version 5.0	12553	239	f	\N	CS	1	Action (Add,Remove,Change)	\N
4211	(3109,"Applicare/RadWorks/Version 6.0/Summary",01)	(3109,"Applicare/RadWorks/Version 6.0/Summary",01)	Applicare/RadWorks/Version 6.0/Summary	12553	1	f	\N	SH	1	Status	\N
4212	(3109,"Applicare/RadWorks/Version 6.0/Summary",11)	(3109,"Applicare/RadWorks/Version 6.0/Summary",11)	Applicare/RadWorks/Version 6.0/Summary	12553	17	f	\N	ST	1	Receive Origin Site Name	\N
4213	(3109,"Applicare/RadWorks/Version 6.0/Summary",12)	(3109,"Applicare/RadWorks/Version 6.0/Summary",12)	Applicare/RadWorks/Version 6.0/Summary	12553	18	f	\N	ST	1	Receive Origin Description	\N
4214	(3109,"Applicare/RadWorks/Version 6.0/Summary",15)	(3109,"Applicare/RadWorks/Version 6.0/Summary",15)	Applicare/RadWorks/Version 6.0/Summary	12553	21	f	\N	DA	1	Receive Date	\N
4215	(3109,"Applicare/RadWorks/Version 6.0/Summary",16)	(3109,"Applicare/RadWorks/Version 6.0/Summary",16)	Applicare/RadWorks/Version 6.0/Summary	12553	22	f	\N	TM	1	Receive Time	\N
4216	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",01)	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",01)	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	12565	1	f	\N	UT	1	Unknown	\N
4217	(4101,"Applicare/Print/Version 5.1",01)	(4101,"Applicare/Print/Version 5.1",01)	Applicare/Print/Version 5.1	16641	1	f	\N	UL	1	Mask State	\N
4218	(4101,"Applicare/Print/Version 5.1",02)	(4101,"Applicare/Print/Version 5.1",02)	Applicare/Print/Version 5.1	16641	2	f	\N	SQ	1	Annotations	\N
4219	(4101,"Applicare/Print/Version 5.1",03)	(4101,"Applicare/Print/Version 5.1",03)	Applicare/Print/Version 5.1	16641	3	f	\N	LO	1	Font	\N
4220	(4101,"Applicare/Print/Version 5.1",04)	(4101,"Applicare/Print/Version 5.1",04)	Applicare/Print/Version 5.1	16641	4	f	\N	UL	1	Font Size	\N
4221	(4101,"Applicare/Print/Version 5.1",05)	(4101,"Applicare/Print/Version 5.1",05)	Applicare/Print/Version 5.1	16641	5	f	\N	FD	1	Font Relative Size	\N
4222	(4101,"Applicare/Print/Version 5.1",06)	(4101,"Applicare/Print/Version 5.1",06)	Applicare/Print/Version 5.1	16641	6	f	\N	US	1	Overlay	\N
4223	(4101,"Applicare/Print/Version 5.1",07)	(4101,"Applicare/Print/Version 5.1",07)	Applicare/Print/Version 5.1	16641	7	f	\N	US	1	Pixel Rep	\N
4224	(4101,"Applicare/Print/Version 5.1",08)	(4101,"Applicare/Print/Version 5.1",08)	Applicare/Print/Version 5.1	16641	8	f	\N	US	1	Annotation Level	\N
4225	(4101,"Applicare/Print/Version 5.1",09)	(4101,"Applicare/Print/Version 5.1",09)	Applicare/Print/Version 5.1	16641	9	f	\N	US	1	Show Caliper	\N
4226	(4103,"Applicare/RadWorks/Version 6.0",01)	(4103,"Applicare/RadWorks/Version 6.0",01)	Applicare/RadWorks/Version 6.0	16643	1	f	\N	AT	1-n	Non-existent tags	\N
4227	(4103,"Applicare/RadWorks/Version 6.0",02)	(4103,"Applicare/RadWorks/Version 6.0",02)	Applicare/RadWorks/Version 6.0	16643	2	f	\N	UI	1-n	Non-existent objects	\N
4228	(4105,"Applicare/RadWorks/Version 6.0",01)	(4105,"Applicare/RadWorks/Version 6.0",01)	Applicare/RadWorks/Version 6.0	16645	1	f	\N	CS	1	Annotation Type	\N
4229	(4105,"Applicare/RadWorks/Version 6.0",02)	(4105,"Applicare/RadWorks/Version 6.0",02)	Applicare/RadWorks/Version 6.0	16645	2	f	\N	LO	1	Annotation Value	\N
4230	(4105,"Applicare/RadWorks/Version 6.0",03)	(4105,"Applicare/RadWorks/Version 6.0",03)	Applicare/RadWorks/Version 6.0	16645	3	f	\N	UI	1	Cutline Image UID	\N
4231	(4105,"Applicare/RadWorks/Version 6.0",04)	(4105,"Applicare/RadWorks/Version 6.0",04)	Applicare/RadWorks/Version 6.0	16645	4	f	\N	UI	1	Cutline Set UID	\N
4287	(5001,"GEMS_GENIE_1",35)	(5001,"GEMS_GENIE_1",35)	GEMS_GENIE_1	20481	53	f	\N	LO	1	Dataset Name	\N
4232	(4105,"Applicare/RadWorks/Version 6.0",05)	(4105,"Applicare/RadWorks/Version 6.0",05)	Applicare/RadWorks/Version 6.0	16645	5	f	\N	US	3	Annotation Color (RGB)	\N
4233	(4105,"Applicare/RadWorks/Version 6.0",06)	(4105,"Applicare/RadWorks/Version 6.0",06)	Applicare/RadWorks/Version 6.0	16645	6	f	\N	CS	1	Annotation Line Style	\N
4234	(4105,"Applicare/RadWorks/Version 6.0",07)	(4105,"Applicare/RadWorks/Version 6.0",07)	Applicare/RadWorks/Version 6.0	16645	7	f	\N	SH	1	Annotation Label	\N
4235	(4105,"Applicare/RadWorks/Version 6.0",08)	(4105,"Applicare/RadWorks/Version 6.0",08)	Applicare/RadWorks/Version 6.0	16645	8	f	\N	PN	1	Annotation Creator	\N
4236	(4105,"Applicare/RadWorks/Version 6.0",09)	(4105,"Applicare/RadWorks/Version 6.0",09)	Applicare/RadWorks/Version 6.0	16645	9	f	\N	DA	1	Annotation Creation Date	\N
4237	(4105,"Applicare/RadWorks/Version 6.0",0a)	(4105,"Applicare/RadWorks/Version 6.0",0a)	Applicare/RadWorks/Version 6.0	16645	10	f	\N	TM	1	Annotation Creation Time	\N
4238	(4105,"Applicare/RadWorks/Version 6.0",0b)	(4105,"Applicare/RadWorks/Version 6.0",0b)	Applicare/RadWorks/Version 6.0	16645	11	f	\N	SQ	1	Annotation Modification Sequence	\N
4239	(4105,"Applicare/RadWorks/Version 6.0",0c)	(4105,"Applicare/RadWorks/Version 6.0",0c)	Applicare/RadWorks/Version 6.0	16645	12	f	\N	PN	1	Annotation Modifier	\N
4240	(4105,"Applicare/RadWorks/Version 6.0",0d)	(4105,"Applicare/RadWorks/Version 6.0",0d)	Applicare/RadWorks/Version 6.0	16645	13	f	\N	DA	1	Annotation Modification Date	\N
4241	(4105,"Applicare/RadWorks/Version 6.0",0e)	(4105,"Applicare/RadWorks/Version 6.0",0e)	Applicare/RadWorks/Version 6.0	16645	14	f	\N	TM	1	Annotation Modification Time	\N
4242	(4105,"Applicare/RadWorks/Version 6.0",10)	(4105,"Applicare/RadWorks/Version 6.0",10)	Applicare/RadWorks/Version 6.0	16645	16	f	\N	US	1	Unknown	\N
4243	(4107,"Applicare/RadWorks/Version 6.0",01)	(4107,"Applicare/RadWorks/Version 6.0",01)	Applicare/RadWorks/Version 6.0	16647	1	f	\N	SQ	1	Requested Palette Color LUT	\N
4244	(5001,"GEMS_GENIE_1",01)	(5001,"GEMS_GENIE_1",01)	GEMS_GENIE_1	20481	1	f	\N	SL	1	Modified	\N
4245	(5001,"GEMS_GENIE_1",02)	(5001,"GEMS_GENIE_1",02)	GEMS_GENIE_1	20481	2	f	\N	LO	1	Name	\N
4246	(5001,"GEMS_GENIE_1",03)	(5001,"GEMS_GENIE_1",03)	GEMS_GENIE_1	20481	3	f	\N	SL	1	Cid	\N
4247	(5001,"GEMS_GENIE_1",04)	(5001,"GEMS_GENIE_1",04)	GEMS_GENIE_1	20481	4	f	\N	SL	1	Srid	\N
4248	(5001,"GEMS_GENIE_1",05)	(5001,"GEMS_GENIE_1",05)	GEMS_GENIE_1	20481	5	f	\N	LO	1	SOP Class UID	\N
4249	(5001,"GEMS_GENIE_1",06)	(5001,"GEMS_GENIE_1",06)	GEMS_GENIE_1	20481	6	f	\N	LO	1	SOP Instance UID	\N
4250	(5001,"GEMS_GENIE_1",07)	(5001,"GEMS_GENIE_1",07)	GEMS_GENIE_1	20481	7	f	\N	SL	1	Curve Type	\N
4251	(5001,"GEMS_GENIE_1",08)	(5001,"GEMS_GENIE_1",08)	GEMS_GENIE_1	20481	8	f	\N	SL	1	Graph Type	\N
4252	(5001,"GEMS_GENIE_1",09)	(5001,"GEMS_GENIE_1",09)	GEMS_GENIE_1	20481	9	f	\N	LO	1	Legend	\N
4253	(5001,"GEMS_GENIE_1",0a)	(5001,"GEMS_GENIE_1",0a)	GEMS_GENIE_1	20481	10	f	\N	LO	1	X Units	\N
4254	(5001,"GEMS_GENIE_1",0b)	(5001,"GEMS_GENIE_1",0b)	GEMS_GENIE_1	20481	11	f	\N	LO	1	Y Units	\N
4255	(5001,"GEMS_GENIE_1",0c)	(5001,"GEMS_GENIE_1",0c)	GEMS_GENIE_1	20481	12	f	\N	SL	1	Edit	\N
4256	(5001,"GEMS_GENIE_1",0d)	(5001,"GEMS_GENIE_1",0d)	GEMS_GENIE_1	20481	13	f	\N	SL	1	Suspend	\N
4257	(5001,"GEMS_GENIE_1",0e)	(5001,"GEMS_GENIE_1",0e)	GEMS_GENIE_1	20481	14	f	\N	SL	1	Style Line	\N
4258	(5001,"GEMS_GENIE_1",0f)	(5001,"GEMS_GENIE_1",0f)	GEMS_GENIE_1	20481	15	f	\N	SL	1	Style Fill	\N
4259	(5001,"GEMS_GENIE_1",10)	(5001,"GEMS_GENIE_1",10)	GEMS_GENIE_1	20481	16	f	\N	LO	1	Style Colour	\N
4260	(5001,"GEMS_GENIE_1",11)	(5001,"GEMS_GENIE_1",11)	GEMS_GENIE_1	20481	17	f	\N	SL	1	Style Width	\N
4261	(5001,"GEMS_GENIE_1",12)	(5001,"GEMS_GENIE_1",12)	GEMS_GENIE_1	20481	18	f	\N	SL	1	Style Point	\N
4262	(5001,"GEMS_GENIE_1",13)	(5001,"GEMS_GENIE_1",13)	GEMS_GENIE_1	20481	19	f	\N	LO	1	Style P Colour	\N
4263	(5001,"GEMS_GENIE_1",14)	(5001,"GEMS_GENIE_1",14)	GEMS_GENIE_1	20481	20	f	\N	SL	1	Style P Size	\N
4264	(5001,"GEMS_GENIE_1",15)	(5001,"GEMS_GENIE_1",15)	GEMS_GENIE_1	20481	21	f	\N	SL	1	Segments	\N
4265	(5001,"GEMS_GENIE_1",16)	(5001,"GEMS_GENIE_1",16)	GEMS_GENIE_1	20481	22	f	\N	SL	1	Seg Type	\N
4266	(5001,"GEMS_GENIE_1",17)	(5001,"GEMS_GENIE_1",17)	GEMS_GENIE_1	20481	23	f	\N	FD	1-n	Seg Start	\N
4267	(5001,"GEMS_GENIE_1",18)	(5001,"GEMS_GENIE_1",18)	GEMS_GENIE_1	20481	24	f	\N	FD	1-n	Seg End	\N
4268	(5001,"GEMS_GENIE_1",19)	(5001,"GEMS_GENIE_1",19)	GEMS_GENIE_1	20481	25	f	\N	SL	1-n	Seg Style Line	\N
4269	(5001,"GEMS_GENIE_1",1a)	(5001,"GEMS_GENIE_1",1a)	GEMS_GENIE_1	20481	26	f	\N	SL	1-n	SegStyleFill	\N
4270	(5001,"GEMS_GENIE_1",1b)	(5001,"GEMS_GENIE_1",1b)	GEMS_GENIE_1	20481	27	f	\N	LO	1	Seg Style Colour	\N
4271	(5001,"GEMS_GENIE_1",1c)	(5001,"GEMS_GENIE_1",1c)	GEMS_GENIE_1	20481	28	f	\N	SL	1-n	Seg Style Width	\N
4272	(5001,"GEMS_GENIE_1",1d)	(5001,"GEMS_GENIE_1",1d)	GEMS_GENIE_1	20481	29	f	\N	SL	1-n	Seg Style Point	\N
4273	(5001,"GEMS_GENIE_1",1e)	(5001,"GEMS_GENIE_1",1e)	GEMS_GENIE_1	20481	30	f	\N	SL	1	Seg Style P Colour	\N
4274	(5001,"GEMS_GENIE_1",1f)	(5001,"GEMS_GENIE_1",1f)	GEMS_GENIE_1	20481	31	f	\N	SL	1	Seg Style P Size	\N
4275	(5001,"GEMS_GENIE_1",20)	(5001,"GEMS_GENIE_1",20)	GEMS_GENIE_1	20481	32	f	\N	LO	1	Seg Name	\N
4276	(5001,"GEMS_GENIE_1",21)	(5001,"GEMS_GENIE_1",21)	GEMS_GENIE_1	20481	33	f	\N	SL	1-n	Seg Allow Dir Int	\N
4277	(5001,"GEMS_GENIE_1",22)	(5001,"GEMS_GENIE_1",22)	GEMS_GENIE_1	20481	34	f	\N	SL	1	Text Annots	\N
4278	(5001,"GEMS_GENIE_1",23)	(5001,"GEMS_GENIE_1",23)	GEMS_GENIE_1	20481	35	f	\N	FD	1-n	Txt X	\N
4279	(5001,"GEMS_GENIE_1",24)	(5001,"GEMS_GENIE_1",24)	GEMS_GENIE_1	20481	36	f	\N	FD	1-n	Txt Y	\N
4280	(5001,"GEMS_GENIE_1",25)	(5001,"GEMS_GENIE_1",25)	GEMS_GENIE_1	20481	37	f	\N	LO	1	Txt Text	\N
4281	(5001,"GEMS_GENIE_1",26)	(5001,"GEMS_GENIE_1",26)	GEMS_GENIE_1	20481	38	f	\N	LO	1	Txt Name	\N
4282	(5001,"GEMS_GENIE_1",30)	(5001,"GEMS_GENIE_1",30)	GEMS_GENIE_1	20481	48	f	\N	LO	1	ROI Name	\N
4283	(5001,"GEMS_GENIE_1",31)	(5001,"GEMS_GENIE_1",31)	GEMS_GENIE_1	20481	49	f	\N	LO	1	Derived From Image UID	\N
4284	(5001,"GEMS_GENIE_1",32)	(5001,"GEMS_GENIE_1",32)	GEMS_GENIE_1	20481	50	f	\N	SL	1-n	Derived From Images	\N
4285	(5001,"GEMS_GENIE_1",33)	(5001,"GEMS_GENIE_1",33)	GEMS_GENIE_1	20481	51	f	\N	UL	1	Curve Flags	\N
4286	(5001,"GEMS_GENIE_1",34)	(5001,"GEMS_GENIE_1",34)	GEMS_GENIE_1	20481	52	f	\N	LO	1	Curve Name	\N
4288	(5001,"GEMS_GENIE_1",36)	(5001,"GEMS_GENIE_1",36)	GEMS_GENIE_1	20481	54	f	\N	LO	1	Curve UID	\N
4289	(5001,"GEMS_GENIE_1",37)	(5001,"GEMS_GENIE_1",37)	GEMS_GENIE_1	20481	55	f	\N	FD	1	ROI Area	\N
4290	(5001,"GEMS_GENIE_1",38)	(5001,"GEMS_GENIE_1",38)	GEMS_GENIE_1	20481	56	f	\N	LO	1	Modified	\N
4291	(5001,"GEMS_GENIE_1",39)	(5001,"GEMS_GENIE_1",39)	GEMS_GENIE_1	20481	57	f	\N	LO	1	Name	\N
4292	(5001,"GEMS_GENIE_1",3a)	(5001,"GEMS_GENIE_1",3a)	GEMS_GENIE_1	20481	58	f	\N	LO	1	Software Version	\N
4293	(5001,"GEMS_GENIE_1",3b)	(5001,"GEMS_GENIE_1",3b)	GEMS_GENIE_1	20481	59	f	\N	SH	1	Start Date	\N
4294	(5001,"GEMS_GENIE_1",3c)	(5001,"GEMS_GENIE_1",3c)	GEMS_GENIE_1	20481	60	f	\N	SH	1	Completion Date	\N
4295	(5001,"GEMS_GENIE_1",3d)	(5001,"GEMS_GENIE_1",3d)	GEMS_GENIE_1	20481	61	f	\N	LO	1	Detector Name	\N
4296	(5001,"GEMS_GENIE_1",41)	(5001,"GEMS_GENIE_1",41)	GEMS_GENIE_1	20481	65	f	\N	SL	1	Modified	\N
4297	(5001,"GEMS_GENIE_1",42)	(5001,"GEMS_GENIE_1",42)	GEMS_GENIE_1	20481	66	f	\N	LO	1	Name	\N
4298	(5001,"GEMS_GENIE_1",43)	(5001,"GEMS_GENIE_1",43)	GEMS_GENIE_1	20481	67	f	\N	SL	1	Name	\N
4299	(5001,"GEMS_GENIE_1",44)	(5001,"GEMS_GENIE_1",44)	GEMS_GENIE_1	20481	68	f	\N	SL	1	Name	\N
4300	(5001,"GEMS_GENIE_1",45)	(5001,"GEMS_GENIE_1",45)	GEMS_GENIE_1	20481	69	f	\N	LO	1	SOP Class UID	\N
4301	(5001,"GEMS_GENIE_1",46)	(5001,"GEMS_GENIE_1",46)	GEMS_GENIE_1	20481	70	f	\N	LO	1	SOP Instance UID	\N
4302	(5001,"GEMS_GENIE_1",47)	(5001,"GEMS_GENIE_1",47)	GEMS_GENIE_1	20481	71	f	\N	LO	1	Normal Color	\N
4303	(5001,"GEMS_GENIE_1",48)	(5001,"GEMS_GENIE_1",48)	GEMS_GENIE_1	20481	72	f	\N	LT	1	Name Font	\N
4304	(5001,"GEMS_GENIE_1",49)	(5001,"GEMS_GENIE_1",49)	GEMS_GENIE_1	20481	73	f	\N	SL	1	Fill Pattern	\N
4305	(5001,"GEMS_GENIE_1",4a)	(5001,"GEMS_GENIE_1",4a)	GEMS_GENIE_1	20481	74	f	\N	SL	1	Line Style	\N
4306	(5001,"GEMS_GENIE_1",4b)	(5001,"GEMS_GENIE_1",4b)	GEMS_GENIE_1	20481	75	f	\N	SL	1	Line Dash Length	\N
4307	(5001,"GEMS_GENIE_1",4c)	(5001,"GEMS_GENIE_1",4c)	GEMS_GENIE_1	20481	76	f	\N	SL	1	Line Thickness	\N
4308	(5001,"GEMS_GENIE_1",4d)	(5001,"GEMS_GENIE_1",4d)	GEMS_GENIE_1	20481	77	f	\N	SL	1	Interactivity	\N
4309	(5001,"GEMS_GENIE_1",4e)	(5001,"GEMS_GENIE_1",4e)	GEMS_GENIE_1	20481	78	f	\N	SL	1	Name Pos	\N
4310	(5001,"GEMS_GENIE_1",4f)	(5001,"GEMS_GENIE_1",4f)	GEMS_GENIE_1	20481	79	f	\N	SL	1	Name Display	\N
4311	(5001,"GEMS_GENIE_1",50)	(5001,"GEMS_GENIE_1",50)	GEMS_GENIE_1	20481	80	f	\N	LO	1	Label	\N
4312	(5001,"GEMS_GENIE_1",51)	(5001,"GEMS_GENIE_1",51)	GEMS_GENIE_1	20481	81	f	\N	SL	1-n	Bp Seg	\N
4313	(5001,"GEMS_GENIE_1",52)	(5001,"GEMS_GENIE_1",52)	GEMS_GENIE_1	20481	82	f	\N	US	1-n	Bp Seg Pairs	\N
4314	(5001,"GEMS_GENIE_1",53)	(5001,"GEMS_GENIE_1",53)	GEMS_GENIE_1	20481	83	f	\N	SL	1	Seed Space	\N
4315	(5001,"GEMS_GENIE_1",54)	(5001,"GEMS_GENIE_1",54)	GEMS_GENIE_1	20481	84	f	\N	FD	1-n	Seeds	\N
4316	(5001,"GEMS_GENIE_1",55)	(5001,"GEMS_GENIE_1",55)	GEMS_GENIE_1	20481	85	f	\N	SL	1-n	Shape	\N
4317	(5001,"GEMS_GENIE_1",56)	(5001,"GEMS_GENIE_1",56)	GEMS_GENIE_1	20481	86	f	\N	FD	1-n	Shape Tilt	\N
4318	(5001,"GEMS_GENIE_1",59)	(5001,"GEMS_GENIE_1",59)	GEMS_GENIE_1	20481	89	f	\N	SL	1-n	Shape Pts Space	\N
4319	(5001,"GEMS_GENIE_1",5a)	(5001,"GEMS_GENIE_1",5a)	GEMS_GENIE_1	20481	90	f	\N	SL	1-n	Shape Ctrl Pts Counts	\N
4320	(5001,"GEMS_GENIE_1",5b)	(5001,"GEMS_GENIE_1",5b)	GEMS_GENIE_1	20481	91	f	\N	FD	1-n	Shape Ctrl Pts	\N
4321	(5001,"GEMS_GENIE_1",5c)	(5001,"GEMS_GENIE_1",5c)	GEMS_GENIE_1	20481	92	f	\N	SL	1	Shape Ctrl P Space	\N
4322	(5001,"GEMS_GENIE_1",5d)	(5001,"GEMS_GENIE_1",5d)	GEMS_GENIE_1	20481	93	f	\N	SL	1	ROI Flags	\N
4323	(5001,"GEMS_GENIE_1",5e)	(5001,"GEMS_GENIE_1",5e)	GEMS_GENIE_1	20481	94	f	\N	SL	1	Frame Number	\N
4324	(5001,"GEMS_GENIE_1",5f)	(5001,"GEMS_GENIE_1",5f)	GEMS_GENIE_1	20481	95	f	\N	SL	1	ID	\N
4325	(5001,"GEMS_GENIE_1",60)	(5001,"GEMS_GENIE_1",60)	GEMS_GENIE_1	20481	96	f	\N	LO	1-n	Dataset ROI Mapping	\N
4326	(0009,"GEIIS",10)	(0009,"GEIIS",10)	GEIIS	9	16	f	\N	SQ	1	GE Private Image Thumbnail Sequence	\N
4327	(0009,"GEIIS",12)	(0009,"GEIIS",12)	GEIIS	9	18	f	\N	IS	1	Unknown	\N
4328	(0029,"GEIIS",10)	(0029,"GEIIS",10)	GEIIS	41	16	f	\N	UL	1	Shift Count	\N
4329	(0029,"GEIIS",12)	(0029,"GEIIS",12)	GEIIS	41	18	f	\N	UL	1	Offset	\N
4330	(0029,"GEIIS",14)	(0029,"GEIIS",14)	GEIIS	41	20	f	\N	UL	1	Actual Frame Number	\N
4331	(0903,"GEIIS PACS",10)	(0903,"GEIIS PACS",10)	GEIIS PACS	2307	16	f	\N	US	1	Reject Image Flag	\N
4332	(0903,"GEIIS PACS",11)	(0903,"GEIIS PACS",11)	GEIIS PACS	2307	17	f	\N	US	1	Significant Flag	\N
4333	(0903,"GEIIS PACS",12)	(0903,"GEIIS PACS",12)	GEIIS PACS	2307	18	f	\N	US	1	Confidential Flag	\N
4334	(0903,"GEIIS PACS",20)	(0903,"GEIIS PACS",20)	GEIIS PACS	2307	32	f	\N	CS	1	Unknown	\N
4335	(0905,"GEIIS",30)	(0905,"GEIIS",30)	GEIIS	2309	48	f	\N	LO	1	Assigning Authority For Patient ID	\N
4336	(0907,"GEIIS",10)	(0907,"GEIIS",10)	GEIIS	2311	16	f	\N	UI	1	Original Study Instance UID	\N
4337	(0907,"GEIIS",20)	(0907,"GEIIS",20)	GEIIS	2311	32	f	\N	UI	1	Original Series Instance UID	\N
4338	(0907,"GEIIS PACS",21)	(0907,"GEIIS PACS",21)	GEIIS PACS	2311	33	f	\N	US	1	Prefetch Algorithm	\N
4339	(0907,"GEIIS PACS",22)	(0907,"GEIIS PACS",22)	GEIIS PACS	2311	34	f	\N	US	1	Limit Recent Studies	\N
4340	(0907,"GEIIS PACS",23)	(0907,"GEIIS PACS",23)	GEIIS PACS	2311	35	f	\N	US	1	Limit Oldest Studies	\N
4341	(0907,"GEIIS PACS",24)	(0907,"GEIIS PACS",24)	GEIIS PACS	2311	36	f	\N	US	1	Limit Recent Months	\N
4342	(0907,"GEIIS",30)	(0907,"GEIIS",30)	GEIIS	2311	48	f	\N	UI	1	Original SOP Instance UID	\N
4343	(0907,"GEIIS PACS",31)	(0907,"GEIIS PACS",31)	GEIIS PACS	2311	49	f	\N	UI	1-n	Exclude Study UIDs	\N
4344	(7fd1,"GEIIS",10)	(7fd1,"GEIIS",10)	GEIIS	32721	16	f	\N	UL	1	Compression Type	\N
4345	(7fd1,"GEIIS",20)	(7fd1,"GEIIS",20)	GEIIS	32721	32	f	\N	UL	1-n	Multiframe Offsets	\N
4346	(7fd1,"GEIIS",30)	(7fd1,"GEIIS",30)	GEIIS	32721	48	f	\N	UL	1	Multi-Resolution Levels	\N
4347	(7fd1,"GEIIS",40)	(7fd1,"GEIIS",40)	GEIIS	32721	64	f	\N	UL	1-n	Subband Rows	\N
4348	(7fd1,"GEIIS",50)	(7fd1,"GEIIS",50)	GEIIS	32721	80	f	\N	UL	1-n	Subband Columns	\N
4349	(7fd1,"GEIIS",60)	(7fd1,"GEIIS",60)	GEIIS	32721	96	f	\N	UL	1-n	Subband Bytecounts	\N
4350	(0011,"GEMS_GDXE_FALCON_04",03)	(0011,"GEMS_GDXE_FALCON_04",03)	GEMS_GDXE_FALCON_04	17	3	f	\N	UI	1	Processed Series UID	\N
4351	(0011,"GEMS_GDXE_FALCON_04",04)	(0011,"GEMS_GDXE_FALCON_04",04)	GEMS_GDXE_FALCON_04	17	4	f	\N	CS	1	Acquisition Type	\N
4352	(0011,"GEMS_GDXE_FALCON_04",05)	(0011,"GEMS_GDXE_FALCON_04",05)	GEMS_GDXE_FALCON_04	17	5	f	\N	UI	1	Acquisition UID	\N
4353	(0011,"GEMS_GDXE_FALCON_04",06)	(0011,"GEMS_GDXE_FALCON_04",06)	GEMS_GDXE_FALCON_04	17	6	f	\N	DS	1	Image Dose	\N
4354	(0011,"GEMS_GDXE_FALCON_04",07)	(0011,"GEMS_GDXE_FALCON_04",07)	GEMS_GDXE_FALCON_04	17	7	f	\N	FL	1	Study Dose	\N
4355	(0011,"GEMS_GDXE_FALCON_04",08)	(0011,"GEMS_GDXE_FALCON_04",08)	GEMS_GDXE_FALCON_04	17	8	f	\N	FL	1	Study DAP	\N
4356	(0011,"GEMS_GDXE_FALCON_04",09)	(0011,"GEMS_GDXE_FALCON_04",09)	GEMS_GDXE_FALCON_04	17	9	f	\N	SL	1	Non-Digital Exposures	\N
4357	(0011,"GEMS_GDXE_FALCON_04",10)	(0011,"GEMS_GDXE_FALCON_04",10)	GEMS_GDXE_FALCON_04	17	16	f	\N	SL	1	Total Exposures	\N
4358	(0011,"GEMS_GDXE_FALCON_04",11)	(0011,"GEMS_GDXE_FALCON_04",11)	GEMS_GDXE_FALCON_04	17	17	f	\N	LT	1	ROI	\N
4359	(0011,"GEMS_GDXE_FALCON_04",12)	(0011,"GEMS_GDXE_FALCON_04",12)	GEMS_GDXE_FALCON_04	17	18	f	\N	LT	1	Patient Size String	\N
4360	(0011,"GEMS_GDXE_FALCON_04",13)	(0011,"GEMS_GDXE_FALCON_04",13)	GEMS_GDXE_FALCON_04	17	19	f	\N	UI	1	SPS UID	\N
4361	(0011,"GEMS_GDXE_FALCON_04",14)	(0011,"GEMS_GDXE_FALCON_04",14)	GEMS_GDXE_FALCON_04	17	20	f	\N	UI	1	Unknown	\N
4362	(0011,"GEMS_GDXE_FALCON_04",15)	(0011,"GEMS_GDXE_FALCON_04",15)	GEMS_GDXE_FALCON_04	17	21	f	\N	DS	1	Detector ARC Gain	\N
4363	(0011,"GEMS_GDXE_FALCON_04",16)	(0011,"GEMS_GDXE_FALCON_04",16)	GEMS_GDXE_FALCON_04	17	22	f	\N	LT	1	Processing Debug Info	\N
4364	(0011,"GEMS_GDXE_FALCON_04",17)	(0011,"GEMS_GDXE_FALCON_04",17)	GEMS_GDXE_FALCON_04	17	23	f	\N	CS	1	Override Mode	\N
4365	(0011,"GEMS_GDXE_FALCON_04",19)	(0011,"GEMS_GDXE_FALCON_04",19)	GEMS_GDXE_FALCON_04	17	25	f	\N	DS	1	Film Speed Selection	\N
4366	(0011,"GEMS_GDXE_FALCON_04",27)	(0011,"GEMS_GDXE_FALCON_04",27)	GEMS_GDXE_FALCON_04	17	39	f	\N	UN	1	Unknown	\N
4367	(0011,"GEMS_GDXE_FALCON_04",28)	(0011,"GEMS_GDXE_FALCON_04",28)	GEMS_GDXE_FALCON_04	17	40	f	\N	UN	1	Unknown	\N
4368	(0011,"GEMS_GDXE_FALCON_04",29)	(0011,"GEMS_GDXE_FALCON_04",29)	GEMS_GDXE_FALCON_04	17	41	f	\N	UN	1	Unknown	\N
4369	(0011,"GEMS_GDXE_FALCON_04",30)	(0011,"GEMS_GDXE_FALCON_04",30)	GEMS_GDXE_FALCON_04	17	48	f	\N	UN	1	Unknown	\N
4370	(0011,"GEMS_GDXE_FALCON_04",31)	(0011,"GEMS_GDXE_FALCON_04",31)	GEMS_GDXE_FALCON_04	17	49	f	\N	IS	1-n	Detected Field of View	\N
4371	(0011,"GEMS_GDXE_FALCON_04",32)	(0011,"GEMS_GDXE_FALCON_04",32)	GEMS_GDXE_FALCON_04	17	50	f	\N	IS	1-n	Adjusted Field of View	\N
4372	(0011,"GEMS_GDXE_FALCON_04",33)	(0011,"GEMS_GDXE_FALCON_04",33)	GEMS_GDXE_FALCON_04	17	51	f	\N	DS	1	Detector Exposure Index	\N
4373	(0011,"GEMS_GDXE_FALCON_04",34)	(0011,"GEMS_GDXE_FALCON_04",34)	GEMS_GDXE_FALCON_04	17	52	f	\N	DS	1	Compensated Detector Exposure	\N
4374	(0011,"GEMS_GDXE_FALCON_04",35)	(0011,"GEMS_GDXE_FALCON_04",35)	GEMS_GDXE_FALCON_04	17	53	f	\N	DS	1	Uncompensated Detector Exposure	\N
4375	(0011,"GEMS_GDXE_FALCON_04",36)	(0011,"GEMS_GDXE_FALCON_04",36)	GEMS_GDXE_FALCON_04	17	54	f	\N	DS	1	Median Anatomy Count Value	\N
4376	(0011,"GEMS_GDXE_FALCON_04",37)	(0011,"GEMS_GDXE_FALCON_04",37)	GEMS_GDXE_FALCON_04	17	55	f	\N	DS	2	DEI Lower & Upper Limit Values	\N
4377	(0011,"GEMS_GDXE_FALCON_04",38)	(0011,"GEMS_GDXE_FALCON_04",38)	GEMS_GDXE_FALCON_04	17	56	f	\N	SL	6	Shift Vector for Pasting	\N
4378	(0011,"GEMS_GDXE_FALCON_04",39)	(0011,"GEMS_GDXE_FALCON_04",39)	GEMS_GDXE_FALCON_04	17	57	f	\N	CS	6	Image Number in Pasting	\N
4379	(0011,"GEMS_GDXE_FALCON_04",40)	(0011,"GEMS_GDXE_FALCON_04",40)	GEMS_GDXE_FALCON_04	17	64	f	\N	SL	1	Pasting Overlap	\N
4380	(0011,"GEMS_GDXE_FALCON_04",41)	(0011,"GEMS_GDXE_FALCON_04",41)	GEMS_GDXE_FALCON_04	17	65	f	\N	IS	24	Sub-image Collimator Vertices	\N
4381	(0011,"GEMS_GDXE_FALCON_04",42)	(0011,"GEMS_GDXE_FALCON_04",42)	GEMS_GDXE_FALCON_04	17	66	f	\N	LO	1	View IP	\N
4382	(0011,"GEMS_GDXE_FALCON_04",43)	(0011,"GEMS_GDXE_FALCON_04",43)	GEMS_GDXE_FALCON_04	17	67	f	\N	IS	24	Keystone Coordinates	\N
4383	(0011,"GEMS_GDXE_FALCON_04",44)	(0011,"GEMS_GDXE_FALCON_04",44)	GEMS_GDXE_FALCON_04	17	68	f	\N	CS	1	Receptor Type	\N
4384	(0011,"GEMS_GDXE_FALCON_04",46)	(0011,"GEMS_GDXE_FALCON_04",46)	GEMS_GDXE_FALCON_04	17	70	f	\N	LO	1-n	Unknown	\N
4385	(0011,"GEMS_GDXE_FALCON_04",47)	(0011,"GEMS_GDXE_FALCON_04",47)	GEMS_GDXE_FALCON_04	17	71	f	\N	DS	1	Unknown	\N
4386	(0011,"GEMS_GDXE_FALCON_04",59)	(0011,"GEMS_GDXE_FALCON_04",59)	GEMS_GDXE_FALCON_04	17	89	f	\N	CS	1	Unknown	\N
4387	(0011,"GEMS_GDXE_FALCON_04",60)	(0011,"GEMS_GDXE_FALCON_04",60)	GEMS_GDXE_FALCON_04	17	96	f	\N	CS	1	Unknown	\N
4388	(0011,"GEMS_GDXE_FALCON_04",6d)	(0011,"GEMS_GDXE_FALCON_04",6d)	GEMS_GDXE_FALCON_04	17	109	f	\N	DS	1	Unknown	\N
4389	(0045,"GEMS_FALCON_03",55)	(0045,"GEMS_FALCON_03",55)	GEMS_FALCON_03	69	85	f	\N	DS	8	A_Coefficients used in Multiresolution Algorithm	\N
4390	(0045,"GEMS_FALCON_03",62)	(0045,"GEMS_FALCON_03",62)	GEMS_FALCON_03	69	98	f	\N	IS	1	User Window Center	\N
4391	(0045,"GEMS_FALCON_03",63)	(0045,"GEMS_FALCON_03",63)	GEMS_FALCON_03	69	99	f	\N	IS	1	User Window Width	\N
4392	(0045,"GEMS_FALCON_03",65)	(0045,"GEMS_FALCON_03",65)	GEMS_FALCON_03	69	101	f	\N	IS	1	Requested Detector Entrance Dose	\N
4393	(0045,"GEMS_FALCON_03",67)	(0045,"GEMS_FALCON_03",67)	GEMS_FALCON_03	69	103	f	\N	DS	3	VOI LUT Assymmetry Parameter Beta	\N
4394	(0045,"GEMS_FALCON_03",69)	(0045,"GEMS_FALCON_03",69)	GEMS_FALCON_03	69	105	f	\N	IS	1	Collimator Rotation	\N
4395	(0045,"GEMS_FALCON_03",72)	(0045,"GEMS_FALCON_03",72)	GEMS_FALCON_03	69	114	f	\N	IS	1	Collimator Width	\N
4396	(0045,"GEMS_FALCON_03",73)	(0045,"GEMS_FALCON_03",73)	GEMS_FALCON_03	69	115	f	\N	IS	1	Collimator Height	\N
4397	(0045,"GEMS_SEND_02",55)	(0045,"GEMS_SEND_02",55)	GEMS_SEND_02	69	85	f	\N	DS	8	A_Coefficients used in Multiresolution Algorithm	\N
4398	(0045,"GEMS_SEND_02",62)	(0045,"GEMS_SEND_02",62)	GEMS_SEND_02	69	98	f	\N	IS	1	User Window Center	\N
4399	(0045,"GEMS_SEND_02",63)	(0045,"GEMS_SEND_02",63)	GEMS_SEND_02	69	99	f	\N	IS	1	User Window Width	\N
4400	(0045,"GEMS_SEND_02",65)	(0045,"GEMS_SEND_02",65)	GEMS_SEND_02	69	101	f	\N	IS	1	Requested Detector Entrance Dose	\N
4401	(0045,"GEMS_SEND_02",67)	(0045,"GEMS_SEND_02",67)	GEMS_SEND_02	69	103	f	\N	DS	3	VOI LUT Assymmetry Parameter Beta	\N
4402	(0045,"GEMS_SEND_02",69)	(0045,"GEMS_SEND_02",69)	GEMS_SEND_02	69	105	f	\N	IS	1	Collimator Rotation	\N
4403	(0045,"GEMS_SEND_02",72)	(0045,"GEMS_SEND_02",72)	GEMS_SEND_02	69	114	f	\N	IS	1	Collimator Width	\N
4404	(0045,"GEMS_SEND_02",73)	(0045,"GEMS_SEND_02",73)	GEMS_SEND_02	69	115	f	\N	IS	1	Collimator Height	\N
4405	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",10)	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",10)	GEMS_GDXE_ATHENAV2_INTERNAL_USE	32735	16	f	\N	LT	1	Pixel Data References	\N
4406	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",11)	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",11)	GEMS_GDXE_ATHENAV2_INTERNAL_USE	32735	17	f	\N	LT	1	Pixel Data References (temporary)	\N
4407	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",20)	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",20)	GEMS_GDXE_ATHENAV2_INTERNAL_USE	32735	32	f	\N	SS	1	Auto Push Tag	\N
4408	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",25)	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",25)	GEMS_GDXE_ATHENAV2_INTERNAL_USE	32735	37	f	\N	CS	1	PPS Status	\N
4409	(6003,"GEMS_Ultrasound_ImageGroup_001",10)	(6003,"GEMS_Ultrasound_ImageGroup_001",10)	GEMS_Ultrasound_ImageGroup_001	24579	16	f	\N	SQ	1	Unknown	\N
4410	(6003,"GEMS_Ultrasound_ImageGroup_001",11)	(6003,"GEMS_Ultrasound_ImageGroup_001",11)	GEMS_Ultrasound_ImageGroup_001	24579	17	f	\N	OB	1	Unknown	\N
4411	(6003,"GEMS_Ultrasound_ImageGroup_001",12)	(6003,"GEMS_Ultrasound_ImageGroup_001",12)	GEMS_Ultrasound_ImageGroup_001	24579	18	f	\N	LT	1	Unknown	\N
4412	(6003,"GEMS_Ultrasound_ImageGroup_001",15)	(6003,"GEMS_Ultrasound_ImageGroup_001",15)	GEMS_Ultrasound_ImageGroup_001	24579	21	f	\N	LT	1-n	Unknown	\N
4413	(6005,"GEMS_Ultrasound_ExamGroup_001",10)	(6005,"GEMS_Ultrasound_ExamGroup_001",10)	GEMS_Ultrasound_ExamGroup_001	24581	16	f	\N	UT	1	Unknown	\N
4414	(6005,"GEMS_Ultrasound_ExamGroup_001",20)	(6005,"GEMS_Ultrasound_ExamGroup_001",20)	GEMS_Ultrasound_ExamGroup_001	24581	32	f	\N	UT	1	Unknown	\N
4415	(7fe1,"GEMS_Ultrasound_MovieGroup_001",01)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",01)	GEMS_Ultrasound_MovieGroup_001	32737	1	f	\N	SQ	1	Unknown	\N
4416	(7fe1,"GEMS_Ultrasound_MovieGroup_001",02)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",02)	GEMS_Ultrasound_MovieGroup_001	32737	2	f	\N	LO	1	Unknown	\N
4417	(7fe1,"GEMS_Ultrasound_MovieGroup_001",03)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",03)	GEMS_Ultrasound_MovieGroup_001	32737	3	f	\N	UL	1	Unknown	\N
4418	(7fe1,"GEMS_Ultrasound_MovieGroup_001",08)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",08)	GEMS_Ultrasound_MovieGroup_001	32737	8	f	\N	SQ	1	Unknown	\N
4419	(7fe1,"GEMS_Ultrasound_MovieGroup_001",10)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",10)	GEMS_Ultrasound_MovieGroup_001	32737	16	f	\N	SQ	1	Unknown	\N
4420	(7fe1,"GEMS_Ultrasound_MovieGroup_001",12)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",12)	GEMS_Ultrasound_MovieGroup_001	32737	18	f	\N	LO	1	Unknown	\N
4421	(7fe1,"GEMS_Ultrasound_MovieGroup_001",18)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",18)	GEMS_Ultrasound_MovieGroup_001	32737	24	f	\N	SQ	1	Unknown	\N
4422	(7fe1,"GEMS_Ultrasound_MovieGroup_001",20)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",20)	GEMS_Ultrasound_MovieGroup_001	32737	32	f	\N	SQ	1	Unknown	\N
4423	(7fe1,"GEMS_Ultrasound_MovieGroup_001",24)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",24)	GEMS_Ultrasound_MovieGroup_001	32737	36	f	\N	SH	1	Unknown	\N
4424	(7fe1,"GEMS_Ultrasound_MovieGroup_001",26)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",26)	GEMS_Ultrasound_MovieGroup_001	32737	38	f	\N	SQ	1	Unknown	\N
4425	(7fe1,"GEMS_Ultrasound_MovieGroup_001",30)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",30)	GEMS_Ultrasound_MovieGroup_001	32737	48	f	\N	LO	1	Unknown	\N
4426	(7fe1,"GEMS_Ultrasound_MovieGroup_001",32)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",32)	GEMS_Ultrasound_MovieGroup_001	32737	50	f	\N	UL	1	Unknown	\N
4427	(7fe1,"GEMS_Ultrasound_MovieGroup_001",36)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",36)	GEMS_Ultrasound_MovieGroup_001	32737	54	f	\N	SQ	1	Unknown	\N
4428	(7fe1,"GEMS_Ultrasound_MovieGroup_001",37)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",37)	GEMS_Ultrasound_MovieGroup_001	32737	55	f	\N	UL	1	Unknown	\N
4429	(7fe1,"GEMS_Ultrasound_MovieGroup_001",3a)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",3a)	GEMS_Ultrasound_MovieGroup_001	32737	58	f	\N	SQ	1	Unknown	\N
4430	(7fe1,"GEMS_Ultrasound_MovieGroup_001",3c)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",3c)	GEMS_Ultrasound_MovieGroup_001	32737	60	f	\N	FD	1	Unknown	\N
4431	(7fe1,"GEMS_Ultrasound_MovieGroup_001",43)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",43)	GEMS_Ultrasound_MovieGroup_001	32737	67	f	\N	OB	1	Unknown	\N
4432	(7fe1,"GEMS_Ultrasound_MovieGroup_001",48)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",48)	GEMS_Ultrasound_MovieGroup_001	32737	72	f	\N	FD	1	Unknown	\N
4433	(7fe1,"GEMS_Ultrasound_MovieGroup_001",49)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",49)	GEMS_Ultrasound_MovieGroup_001	32737	73	f	\N	UL	1	Unknown	\N
4434	(7fe1,"GEMS_Ultrasound_MovieGroup_001",51)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",51)	GEMS_Ultrasound_MovieGroup_001	32737	81	f	\N	FL	1	Unknown	\N
4435	(7fe1,"GEMS_Ultrasound_MovieGroup_001",52)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",52)	GEMS_Ultrasound_MovieGroup_001	32737	82	f	\N	FD	1	Unknown	\N
4436	(7fe1,"GEMS_Ultrasound_MovieGroup_001",53)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",53)	GEMS_Ultrasound_MovieGroup_001	32737	83	f	\N	UL	1	Unknown	\N
4437	(7fe1,"GEMS_Ultrasound_MovieGroup_001",54)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",54)	GEMS_Ultrasound_MovieGroup_001	32737	84	f	\N	SL	1	Unknown	\N
4438	(7fe1,"GEMS_Ultrasound_MovieGroup_001",55)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",55)	GEMS_Ultrasound_MovieGroup_001	32737	85	f	\N	OB	1	Unknown	\N
4439	(7fe1,"GEMS_Ultrasound_MovieGroup_001",57)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",57)	GEMS_Ultrasound_MovieGroup_001	32737	87	f	\N	LT	1	Unknown	\N
4440	(7fe1,"GEMS_Ultrasound_MovieGroup_001",60)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",60)	GEMS_Ultrasound_MovieGroup_001	32737	96	f	\N	OB	1	Unknown	\N
4441	(7fe1,"GEMS_Ultrasound_MovieGroup_001",61)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",61)	GEMS_Ultrasound_MovieGroup_001	32737	97	f	\N	OW	1	Unknown	\N
4442	(7fe1,"GEMS_Ultrasound_MovieGroup_001",62)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",62)	GEMS_Ultrasound_MovieGroup_001	32737	98	f	\N	SQ	1	Unknown	\N
4443	(7fe1,"GEMS_Ultrasound_MovieGroup_001",69)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",69)	GEMS_Ultrasound_MovieGroup_001	32737	105	f	\N	OW	1	Unknown	\N
4444	(7fe1,"GEMS_Ultrasound_MovieGroup_001",70)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",70)	GEMS_Ultrasound_MovieGroup_001	32737	112	f	\N	SQ	1	Unknown	\N
4445	(7fe1,"GEMS_Ultrasound_MovieGroup_001",71)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",71)	GEMS_Ultrasound_MovieGroup_001	32737	113	f	\N	UL	1	Unknown	\N
4446	(7fe1,"GEMS_Ultrasound_MovieGroup_001",72)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",72)	GEMS_Ultrasound_MovieGroup_001	32737	114	f	\N	LO	1	Unknown	\N
4447	(7fe1,"GEMS_Ultrasound_MovieGroup_001",73)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",73)	GEMS_Ultrasound_MovieGroup_001	32737	115	f	\N	SQ	1	Unknown	\N
4448	(7fe1,"GEMS_Ultrasound_MovieGroup_001",74)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",74)	GEMS_Ultrasound_MovieGroup_001	32737	116	f	\N	LO	1	Unknown	\N
4449	(7fe1,"GEMS_Ultrasound_MovieGroup_001",75)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",75)	GEMS_Ultrasound_MovieGroup_001	32737	117	f	\N	SQ	1	Unknown	\N
4450	(7fe1,"GEMS_Ultrasound_MovieGroup_001",77)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",77)	GEMS_Ultrasound_MovieGroup_001	32737	119	f	\N	FD	1	Unknown	\N
4451	(7fe1,"GEMS_Ultrasound_MovieGroup_001",79)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",79)	GEMS_Ultrasound_MovieGroup_001	32737	121	f	\N	SL	1	Unknown	\N
4452	(7fe1,"GEMS_Ultrasound_MovieGroup_001",83)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",83)	GEMS_Ultrasound_MovieGroup_001	32737	131	f	\N	SQ	1	Unknown	\N
4453	(7fe1,"GEMS_Ultrasound_MovieGroup_001",84)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",84)	GEMS_Ultrasound_MovieGroup_001	32737	132	f	\N	LO	1	Unknown	\N
4454	(7fe1,"GEMS_Ultrasound_MovieGroup_001",85)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",85)	GEMS_Ultrasound_MovieGroup_001	32737	133	f	\N	SQ	1	Unknown	\N
4455	(7fe1,"GEMS_Ultrasound_MovieGroup_001",86)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",86)	GEMS_Ultrasound_MovieGroup_001	32737	134	f	\N	SL	1	Unknown	\N
4456	(7fe1,"GEMS_Ultrasound_MovieGroup_001",87)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",87)	GEMS_Ultrasound_MovieGroup_001	32737	135	f	\N	FD	1	Unknown	\N
4457	(7fe1,"GEMS_Ultrasound_MovieGroup_001",88)	(7fe1,"GEMS_Ultrasound_MovieGroup_001",88)	GEMS_Ultrasound_MovieGroup_001	32737	136	f	\N	FD	1	Unknown	\N
4458	(7fe1,"KRETZ_US",01)	(7fe1,"KRETZ_US",01)	KRETZ_US	32737	1	f	\N	OB	1	Unknown	\N
4459	(0009,"QUASAR_INTERNAL_USE",01)	(0009,"QUASAR_INTERNAL_USE",01)	QUASAR_INTERNAL_USE	9	1	f	\N	UL	1-n	Rate Vector	\N
4460	(0009,"QUASAR_INTERNAL_USE",02)	(0009,"QUASAR_INTERNAL_USE",02)	QUASAR_INTERNAL_USE	9	2	f	\N	UL	1-n	Count Vector	\N
4461	(0009,"QUASAR_INTERNAL_USE",03)	(0009,"QUASAR_INTERNAL_USE",03)	QUASAR_INTERNAL_USE	9	3	f	\N	UL	1-n	Time Vector	\N
4462	(0009,"QUASAR_INTERNAL_USE",07)	(0009,"QUASAR_INTERNAL_USE",07)	QUASAR_INTERNAL_USE	9	7	f	\N	UL	1-n	Angle Vector	\N
4463	(0009,"QUASAR_INTERNAL_USE",08)	(0009,"QUASAR_INTERNAL_USE",08)	QUASAR_INTERNAL_USE	9	8	f	\N	US	1	Camera Shape	\N
4464	(0009,"QUASAR_INTERNAL_USE",10)	(0009,"QUASAR_INTERNAL_USE",10)	QUASAR_INTERNAL_USE	9	16	f	\N	US	1	Whole Body Spots	\N
4465	(0009,"QUASAR_INTERNAL_USE",11)	(0009,"QUASAR_INTERNAL_USE",11)	QUASAR_INTERNAL_USE	9	17	f	\N	US	1	Worklist Flag	\N
4466	(0009,"QUASAR_INTERNAL_USE",12)	(0009,"QUASAR_INTERNAL_USE",12)	QUASAR_INTERNAL_USE	9	18	f	\N	LO	1	Unknown	\N
4467	(0009,"QUASAR_INTERNAL_USE",13)	(0009,"QUASAR_INTERNAL_USE",13)	QUASAR_INTERNAL_USE	9	19	f	\N	ST	1	Sequence Type	\N
4468	(0009,"QUASAR_INTERNAL_USE",14)	(0009,"QUASAR_INTERNAL_USE",14)	QUASAR_INTERNAL_USE	9	20	f	\N	ST	1	Sequence Name	\N
4469	(0009,"QUASAR_INTERNAL_USE",15)	(0009,"QUASAR_INTERNAL_USE",15)	QUASAR_INTERNAL_USE	9	21	f	\N	UL	1-n	Average RR Time Vector	\N
4470	(0009,"QUASAR_INTERNAL_USE",16)	(0009,"QUASAR_INTERNAL_USE",16)	QUASAR_INTERNAL_USE	9	22	f	\N	UL	1-n	Low Limit Vector	\N
4471	(0009,"QUASAR_INTERNAL_USE",17)	(0009,"QUASAR_INTERNAL_USE",17)	QUASAR_INTERNAL_USE	9	23	f	\N	UL	1-n	High Limit Vector	\N
4472	(0009,"QUASAR_INTERNAL_USE",18)	(0009,"QUASAR_INTERNAL_USE",18)	QUASAR_INTERNAL_USE	9	24	f	\N	UL	1-n	Begin Index Vector	\N
4473	(0009,"QUASAR_INTERNAL_USE",19)	(0009,"QUASAR_INTERNAL_USE",19)	QUASAR_INTERNAL_USE	9	25	f	\N	UL	1-n	End Index Vector	\N
4474	(0009,"QUASAR_INTERNAL_USE",1a)	(0009,"QUASAR_INTERNAL_USE",1a)	QUASAR_INTERNAL_USE	9	26	f	\N	UL	1-n	Raw Time Vector	\N
4475	(0009,"QUASAR_INTERNAL_USE",1b)	(0009,"QUASAR_INTERNAL_USE",1b)	QUASAR_INTERNAL_USE	9	27	f	\N	LO	1	Image Type String	\N
4476	(0009,"QUASAR_INTERNAL_USE",1d)	(0009,"QUASAR_INTERNAL_USE",1d)	QUASAR_INTERNAL_USE	9	29	f	\N	US	1	Unknown	\N
4477	(0009,"QUASAR_INTERNAL_USE",1e)	(0009,"QUASAR_INTERNAL_USE",1e)	QUASAR_INTERNAL_USE	9	30	f	\N	ST	1	Unknown	\N
4478	(0009,"QUASAR_INTERNAL_USE",22)	(0009,"QUASAR_INTERNAL_USE",22)	QUASAR_INTERNAL_USE	9	34	f	\N	FL	1	Unknown	\N
4479	(0009,"QUASAR_INTERNAL_USE",23)	(0009,"QUASAR_INTERNAL_USE",23)	QUASAR_INTERNAL_USE	9	35	f	\N	US	1	Unknown	\N
4480	(0009,"QUASAR_INTERNAL_USE",39)	(0009,"QUASAR_INTERNAL_USE",39)	QUASAR_INTERNAL_USE	9	57	f	\N	UI	1	Unknown	\N
4481	(0009,"QUASAR_INTERNAL_USE",40)	(0009,"QUASAR_INTERNAL_USE",40)	QUASAR_INTERNAL_USE	9	64	f	\N	DA	1	Unknown	\N
4482	(0009,"QUASAR_INTERNAL_USE",41)	(0009,"QUASAR_INTERNAL_USE",41)	QUASAR_INTERNAL_USE	9	65	f	\N	TM	1	Unknown	\N
4483	(0009,"QUASAR_INTERNAL_USE",42)	(0009,"QUASAR_INTERNAL_USE",42)	QUASAR_INTERNAL_USE	9	66	f	\N	LO	1	Unknown	\N
4484	(0009,"QUASAR_INTERNAL_USE",44)	(0009,"QUASAR_INTERNAL_USE",44)	QUASAR_INTERNAL_USE	9	68	f	\N	SH	1	Unknown	\N
4485	(0009,"QUASAR_INTERNAL_USE",45)	(0009,"QUASAR_INTERNAL_USE",45)	QUASAR_INTERNAL_USE	9	69	f	\N	LO	1	Unknown	\N
4486	(0009,"QUASAR_INTERNAL_USE",48)	(0009,"QUASAR_INTERNAL_USE",48)	QUASAR_INTERNAL_USE	9	72	f	\N	LO	1	Unknown	\N
4487	(0037,"QUASAR_INTERNAL_USE",10)	(0037,"QUASAR_INTERNAL_USE",10)	QUASAR_INTERNAL_USE	55	16	f	\N	SQ	1	Unknown	\N
4488	(0037,"QUASAR_INTERNAL_USE",1b)	(0037,"QUASAR_INTERNAL_USE",1b)	QUASAR_INTERNAL_USE	55	27	f	\N	LO	1	Unknown	\N
4489	(0037,"QUASAR_INTERNAL_USE",30)	(0037,"QUASAR_INTERNAL_USE",30)	QUASAR_INTERNAL_USE	55	48	f	\N	LO	1	Unknown	\N
4490	(0037,"QUASAR_INTERNAL_USE",40)	(0037,"QUASAR_INTERNAL_USE",40)	QUASAR_INTERNAL_USE	55	64	f	\N	LO	1	Unknown	\N
4491	(0037,"QUASAR_INTERNAL_USE",50)	(0037,"QUASAR_INTERNAL_USE",50)	QUASAR_INTERNAL_USE	55	80	f	\N	LO	1	Unknown	\N
4492	(0037,"QUASAR_INTERNAL_USE",60)	(0037,"QUASAR_INTERNAL_USE",60)	QUASAR_INTERNAL_USE	55	96	f	\N	LO	1	Unknown	\N
4493	(0037,"QUASAR_INTERNAL_USE",70)	(0037,"QUASAR_INTERNAL_USE",70)	QUASAR_INTERNAL_USE	55	112	f	\N	LO	1	Unknown	\N
4494	(0037,"QUASAR_INTERNAL_USE",71)	(0037,"QUASAR_INTERNAL_USE",71)	QUASAR_INTERNAL_USE	55	113	f	\N	FD	1	Unknown	\N
4495	(0037,"QUASAR_INTERNAL_USE",72)	(0037,"QUASAR_INTERNAL_USE",72)	QUASAR_INTERNAL_USE	55	114	f	\N	SH	1	Unknown	\N
4496	(0037,"QUASAR_INTERNAL_USE",73)	(0037,"QUASAR_INTERNAL_USE",73)	QUASAR_INTERNAL_USE	55	115	f	\N	FD	1	Unknown	\N
4497	(0037,"QUASAR_INTERNAL_USE",78)	(0037,"QUASAR_INTERNAL_USE",78)	QUASAR_INTERNAL_USE	55	120	f	\N	FD	1	Unknown	\N
4498	(0037,"QUASAR_INTERNAL_USE",90)	(0037,"QUASAR_INTERNAL_USE",90)	QUASAR_INTERNAL_USE	55	144	f	\N	IS	1	Unknown	\N
4499	(0037,"QUASAR_INTERNAL_USE",92)	(0037,"QUASAR_INTERNAL_USE",92)	QUASAR_INTERNAL_USE	55	146	f	\N	DS	1	Unknown	\N
4500	(0041,"QUASAR_INTERNAL_USE",01)	(0041,"QUASAR_INTERNAL_USE",01)	QUASAR_INTERNAL_USE	65	1	f	\N	UT	1	Unknown	\N
4501	(0027,"APEX_PRIVATE",11)	(0027,"APEX_PRIVATE",11)	APEX_PRIVATE	39	17	f	\N	DS	1	Bed Position	\N
4502	(0033,"GEMS_XELPRV_01",08)	(0033,"GEMS_XELPRV_01",08)	GEMS_XELPRV_01	51	8	f	\N	CS	1	Unknown	\N
4503	(0033,"GEMS_XELPRV_01",10)	(0033,"GEMS_XELPRV_01",10)	GEMS_XELPRV_01	51	16	f	\N	SL	1	Unknown	\N
4504	(0033,"GEMS_XELPRV_01",11)	(0033,"GEMS_XELPRV_01",11)	GEMS_XELPRV_01	51	17	f	\N	LO	1	Unknown	\N
4505	(0033,"GEMS_XELPRV_01",16)	(0033,"GEMS_XELPRV_01",16)	GEMS_XELPRV_01	51	22	f	\N	UI	1	Unknown	\N
4506	(0033,"GEMS_XELPRV_01",17)	(0033,"GEMS_XELPRV_01",17)	GEMS_XELPRV_01	51	23	f	\N	DA	1	Unknown	\N
4507	(0033,"GEMS_XELPRV_01",18)	(0033,"GEMS_XELPRV_01",18)	GEMS_XELPRV_01	51	24	f	\N	TM	1	Unknown	\N
4508	(0033,"GEMS_XELPRV_01",19)	(0033,"GEMS_XELPRV_01",19)	GEMS_XELPRV_01	51	25	f	\N	UL	1	Unknown	\N
4509	(0033,"GEMS_XELPRV_01",1a)	(0033,"GEMS_XELPRV_01",1a)	GEMS_XELPRV_01	51	26	f	\N	LO	1	Unknown	\N
4510	(0033,"GEMS_XELPRV_01",1b)	(0033,"GEMS_XELPRV_01",1b)	GEMS_XELPRV_01	51	27	f	\N	LO	1	Unknown	\N
4511	(0033,"GEMS_XELPRV_01",1c)	(0033,"GEMS_XELPRV_01",1c)	GEMS_XELPRV_01	51	28	f	\N	OB	1	Unknown	\N
4512	(0033,"GEMS_XELPRV_01",1d)	(0033,"GEMS_XELPRV_01",1d)	GEMS_XELPRV_01	51	29	f	\N	UL	1	Unknown	\N
4513	(0033,"GEMS_XELPRV_01",1e)	(0033,"GEMS_XELPRV_01",1e)	GEMS_XELPRV_01	51	30	f	\N	FD	1	Unknown	\N
4514	(0033,"GEMS_XELPRV_01",1f)	(0033,"GEMS_XELPRV_01",1f)	GEMS_XELPRV_01	51	31	f	\N	OB	1	Unknown	\N
4515	(0033,"GEMS_XELPRV_01",20)	(0033,"GEMS_XELPRV_01",20)	GEMS_XELPRV_01	51	32	f	\N	OB	1	Unknown	\N
4516	(0033,"GEMS_XELPRV_01",21)	(0033,"GEMS_XELPRV_01",21)	GEMS_XELPRV_01	51	33	f	\N	OB	1	Unknown	\N
4517	(0033,"GEMS_XELPRV_01",22)	(0033,"GEMS_XELPRV_01",22)	GEMS_XELPRV_01	51	34	f	\N	OB	1	Unknown	\N
4518	(0033,"GEMS_XELPRV_01",23)	(0033,"GEMS_XELPRV_01",23)	GEMS_XELPRV_01	51	35	f	\N	OB	1	Unknown	\N
4519	(0033,"GEMS_XELPRV_01",24)	(0033,"GEMS_XELPRV_01",24)	GEMS_XELPRV_01	51	36	f	\N	LT	1	Unknown	\N
4520	(0033,"GEMS_XELPRV_01",70)	(0033,"GEMS_XELPRV_01",70)	GEMS_XELPRV_01	51	112	f	\N	SQ	1	Unknown	\N
4521	(0033,"GEMS_XELPRV_01",71)	(0033,"GEMS_XELPRV_01",71)	GEMS_XELPRV_01	51	113	f	\N	UI	1	Unknown	\N
4522	(0033,"GEMS_XELPRV_01",72)	(0033,"GEMS_XELPRV_01",72)	GEMS_XELPRV_01	51	114	f	\N	UI	1	Unknown	\N
4523	(0039,"REPORT_FROM_APP",95)	(0039,"REPORT_FROM_APP",95)	REPORT_FROM_APP	57	149	f	\N	LO	1	Unknown	\N
4524	(0047,"GEMS_VXTL_USERDATA_01",11)	(0047,"GEMS_VXTL_USERDATA_01",11)	GEMS_VXTL_USERDATA_01	71	17	f	\N	LT	1	Unknown	\N
4525	(0015,"DL_INTERNAL_USE",8f)	(0015,"DL_INTERNAL_USE",8f)	DL_INTERNAL_USE	21	143	f	\N	IS	1	Unknown	\N
4526	(7003,"GEMS_LUNAR_RAW",01)	(7003,"GEMS_LUNAR_RAW",01)	GEMS_LUNAR_RAW	28675	1	f	\N	ST	1	enCORE File Name	\N
4527	(7003,"GEMS_LUNAR_RAW",02)	(7003,"GEMS_LUNAR_RAW",02)	GEMS_LUNAR_RAW	28675	2	f	\N	OB	1	enCORE File Data	\N
4528	(7003,"GEMS_LUNAR_RAW",03)	(7003,"GEMS_LUNAR_RAW",03)	GEMS_LUNAR_RAW	28675	3	f	\N	UL	1	enCORE File Length	\N
4529	(7003,"GEMS_LUNAR_RAW",04)	(7003,"GEMS_LUNAR_RAW",04)	GEMS_LUNAR_RAW	28675	4	f	\N	LO	1	enCORE File Modified Time	\N
10977	(0119,"MRSC",1202)	(0119,"MRSC",02)	MRSC	281	2	t	12	IS	1	Group Version	K
4539	(6005,"GE_GROUP",10)	(6005,"GE_GROUP",10)	GE_GROUP	24581	16	f	\N	UT	1	Unknown	\N
4541	(0087,"1.2.840.113708.794.1.1.2.0",30)	(0087,"1.2.840.113708.794.1.1.2.0",30)	1.2.840.113708.794.1.1.2.0	135	48	f	\N	ST	1	Storage File ID	\N
4542	(0087,"1.2.840.113708.794.1.1.2.0",40)	(0087,"1.2.840.113708.794.1.1.2.0",40)	1.2.840.113708.794.1.1.2.0	135	64	f	\N	DS	1	Study or Image Size in MB	\N
4543	(0045,"GEMS_IT_US_REPORT",11)	(0045,"GEMS_IT_US_REPORT",11)	GEMS_IT_US_REPORT	69	17	f	\N	OW	1	Vivid excel file	\N
4544	(0045,"GEMS_IT_US_REPORT",12)	(0045,"GEMS_IT_US_REPORT",12)	GEMS_IT_US_REPORT	69	18	f	\N	OW	1	Vivid CHM file	\N
4545	(0045,"GEMS_IT_US_REPORT",13)	(0045,"GEMS_IT_US_REPORT",13)	GEMS_IT_US_REPORT	69	19	f	\N	OW	1	Vivid PDF file	\N
4546	(3113,"Applicare/Workflow/Version 1.0",01)	(3113,"Applicare/Workflow/Version 1.0",01)	Applicare/Workflow/Version 1.0	12563	1	f	\N	CS	1	Order Control	\N
4547	(3113,"Applicare/Workflow/Version 1.0",10)	(3113,"Applicare/Workflow/Version 1.0",10)	Applicare/Workflow/Version 1.0	12563	16	f	\N	SH	1	Scheduled Action Item Code Value	\N
4548	(3113,"Applicare/Workflow/Version 1.0",11)	(3113,"Applicare/Workflow/Version 1.0",11)	Applicare/Workflow/Version 1.0	12563	17	f	\N	SH	1	Scheduled Action Item Coding Scheme Designator	\N
4549	(3113,"Applicare/Workflow/Version 1.0",12)	(3113,"Applicare/Workflow/Version 1.0",12)	Applicare/Workflow/Version 1.0	12563	18	f	\N	LO	1	Scheduled Action Item Code Meaning	\N
4550	(3113,"Applicare/Workflow/Version 1.0",15)	(3113,"Applicare/Workflow/Version 1.0",15)	Applicare/Workflow/Version 1.0	12563	21	f	\N	SH	1	Requested Action Item Code Value	\N
4551	(3113,"Applicare/Workflow/Version 1.0",16)	(3113,"Applicare/Workflow/Version 1.0",16)	Applicare/Workflow/Version 1.0	12563	22	f	\N	SH	1	Requested Action Item Coding Scheme Designator	\N
4530	(0053,"GEHC_CT_ADVAPP_001",20)	(0053,"GEHC_CT_ADVAPP_001",20)	GEHC_CT_ADVAPP_001	83	32	f	\N	IS	1	Shuttle Flag	KB
4531	(0053,"GEHC_CT_ADVAPP_001",40)	(0053,"GEHC_CT_ADVAPP_001",40)	GEHC_CT_ADVAPP_001	83	64	f	\N	SH	1	Iterative Recon Annotation	R
4532	(0053,"GEHC_CT_ADVAPP_001",41)	(0053,"GEHC_CT_ADVAPP_001",41)	GEHC_CT_ADVAPP_001	83	65	f	\N	SH	1	Iterative Recon Mode	R
4533	(0053,"GEHC_CT_ADVAPP_001",42)	(0053,"GEHC_CT_ADVAPP_001",42)	GEHC_CT_ADVAPP_001	83	66	f	\N	LO	1	Iterative Recon Configuration	R
4534	(0053,"GEHC_CT_ADVAPP_001",43)	(0053,"GEHC_CT_ADVAPP_001",43)	GEHC_CT_ADVAPP_001	83	67	f	\N	SH	1	Iterative Recon Level	R
4536	(0053,"GEHC_CT_ADVAPP_001",61)	(0053,"GEHC_CT_ADVAPP_001",61)	GEHC_CT_ADVAPP_001	83	97	f	\N	SH	1	High Resolution Flag	R
4537	(0053,"GEHC_CT_ADVAPP_001",62)	(0053,"GEHC_CT_ADVAPP_001",62)	GEHC_CT_ADVAPP_001	83	98	f	\N	SH	1	Respiratory Flag	R
4538	(0053,"GEHC_CT_ADVAPP_001",9d)	(0053,"GEHC_CT_ADVAPP_001",9d)	GEHC_CT_ADVAPP_001	83	157	f	\N	LO	1	Unknown	R
4552	(3113,"Applicare/Workflow/Version 1.0",17)	(3113,"Applicare/Workflow/Version 1.0",17)	Applicare/Workflow/Version 1.0	12563	23	f	\N	LO	1	Requested Action Item Code Meaning	\N
4553	(3113,"Applicare/Workflow/Version 1.0",20)	(3113,"Applicare/Workflow/Version 1.0",20)	Applicare/Workflow/Version 1.0	12563	32	f	\N	SH	1	Performed Action Item Code Value	\N
4554	(3113,"Applicare/Workflow/Version 1.0",21)	(3113,"Applicare/Workflow/Version 1.0",21)	Applicare/Workflow/Version 1.0	12563	33	f	\N	SH	1	Performed Action Item Coding Scheme Designator	\N
4555	(3113,"Applicare/Workflow/Version 1.0",22)	(3113,"Applicare/Workflow/Version 1.0",22)	Applicare/Workflow/Version 1.0	12563	34	f	\N	LO	1	Performed Action Item Code Meaning	\N
4556	(3113,"Applicare/Workflow/Version 1.0",25)	(3113,"Applicare/Workflow/Version 1.0",25)	Applicare/Workflow/Version 1.0	12563	37	f	\N	SH	1	Performed Procedure Code Value	\N
4557	(3113,"Applicare/Workflow/Version 1.0",26)	(3113,"Applicare/Workflow/Version 1.0",26)	Applicare/Workflow/Version 1.0	12563	38	f	\N	SH	1	Performed Procedure Coding Scheme Designator	\N
4558	(3113,"Applicare/Workflow/Version 1.0",27)	(3113,"Applicare/Workflow/Version 1.0",27)	Applicare/Workflow/Version 1.0	12563	39	f	\N	LO	1	Performed Procedure Code Meaning	\N
4559	(3113,"Applicare/Workflow/Version 1.0",30)	(3113,"Applicare/Workflow/Version 1.0",30)	Applicare/Workflow/Version 1.0	12563	48	f	\N	UI	1	Referenced Image SOP Class UID	\N
4560	(3113,"Applicare/Workflow/Version 1.0",31)	(3113,"Applicare/Workflow/Version 1.0",31)	Applicare/Workflow/Version 1.0	12563	49	f	\N	UI	1	Referenced Image SOP Instance UID	\N
4561	(3113,"Applicare/Workflow/Version 1.0",e0)	(3113,"Applicare/Workflow/Version 1.0",e0)	Applicare/Workflow/Version 1.0	12563	224	f	\N	CS	1	Locked By Hostname	\N
4562	(3113,"Applicare/Workflow/Version 1.0",e1)	(3113,"Applicare/Workflow/Version 1.0",e1)	Applicare/Workflow/Version 1.0	12563	225	f	\N	CS	1	Locked By User	\N
4563	(3113,"Applicare/Workflow/Version 1.0",e2)	(3113,"Applicare/Workflow/Version 1.0",e2)	Applicare/Workflow/Version 1.0	12563	226	f	\N	CS	1	KfEdit Lock User	\N
4564	(0045,"GE LUT Asymmetry Parameter",67)	(0045,"GE LUT Asymmetry Parameter",67)	GE LUT Asymmetry Parameter	69	103	f	\N	DS	1	LUT Assymetry	\N
4565	(4109,"Applicare/Centricity Radiology Web/Version 1.0",01)	(4109,"Applicare/Centricity Radiology Web/Version 1.0",01)	Applicare/Centricity Radiology Web/Version 1.0	16649	1	f	\N	SH	1	Mammography Laterality	\N
4566	(4109,"Applicare/Centricity Radiology Web/Version 1.0",02)	(4109,"Applicare/Centricity Radiology Web/Version 1.0",02)	Applicare/Centricity Radiology Web/Version 1.0	16649	2	f	\N	SH	1	Mammography View Name	\N
4567	(4109,"Applicare/Centricity Radiology Web/Version 1.0",03)	(4109,"Applicare/Centricity Radiology Web/Version 1.0",03)	Applicare/Centricity Radiology Web/Version 1.0	16649	3	f	\N	SH	1	Mammography View Modifier	\N
4568	(4111,"Applicare/Centricity Radiology Web/Version 2.0",01)	(4111,"Applicare/Centricity Radiology Web/Version 2.0",01)	Applicare/Centricity Radiology Web/Version 2.0	16657	1	f	\N	CS	1	Secondary Spine Label	\N
4569	(4111,"Applicare/Centricity Radiology Web/Version 2.0",02)	(4111,"Applicare/Centricity Radiology Web/Version 2.0",02)	Applicare/Centricity Radiology Web/Version 2.0	16657	2	f	\N	IS	1	Additional tags for Presentation State	\N
4570	(4113,"GEMS-IT/Centricity RA600/7.0",10)	(4113,"GEMS-IT/Centricity RA600/7.0",10)	GEMS-IT/Centricity RA600/7.0	16659	16	f	\N	UI	1	Number of images in study	\N
4571	(3111,"AMI StudyExtensions_01",01)	(3111,"AMI StudyExtensions_01",01)	AMI StudyExtensions_01	12561	1	f	\N	UL	1	Last Released Annot Label	\N
4572	(3111,"RadWorksTBR",02)	(3111,"RadWorksTBR",02)	RadWorksTBR	12561	2	f	\N	CS	1	Compression Type	\N
4573	(3111,"RadWorksTBR",ff)	(3111,"RadWorksTBR",ff)	RadWorksTBR	12561	255	f	\N	SQ	1	Query Result	\N
4574	(3113,"Applicare/RadStore/Version 1.0",01)	(3113,"Applicare/RadStore/Version 1.0",01)	Applicare/RadStore/Version 1.0	12563	1	f	\N	SL	1	Unknown	\N
4575	(3113,"Applicare/RadStore/Version 1.0",02)	(3113,"Applicare/RadStore/Version 1.0",02)	Applicare/RadStore/Version 1.0	12563	2	f	\N	SL	1	Internal Id of Study	\N
4576	(3113,"Applicare/RadStore/Version 1.0",03)	(3113,"Applicare/RadStore/Version 1.0",03)	Applicare/RadStore/Version 1.0	12563	3	f	\N	SL	1	Internal Id of Series	\N
4577	(3113,"Applicare/RadStore/Version 1.0",04)	(3113,"Applicare/RadStore/Version 1.0",04)	Applicare/RadStore/Version 1.0	12563	4	f	\N	SL	1	Internal Id of Instance	\N
4578	(3113,"Applicare/RadStore/Version 1.0",11)	(3113,"Applicare/RadStore/Version 1.0",11)	Applicare/RadStore/Version 1.0	12563	17	f	\N	LO	1	Unknown	\N
4579	(3113,"Applicare/RadStore/Version 1.0",12)	(3113,"Applicare/RadStore/Version 1.0",12)	Applicare/RadStore/Version 1.0	12563	18	f	\N	CS	1	Instance State	\N
4580	(3113,"Applicare/RadStore/Version 1.0",13)	(3113,"Applicare/RadStore/Version 1.0",13)	Applicare/RadStore/Version 1.0	12563	19	f	\N	DT	1	Date Last Modified	\N
4581	(3113,"Applicare/RadStore/Version 1.0",14)	(3113,"Applicare/RadStore/Version 1.0",14)	Applicare/RadStore/Version 1.0	12563	20	f	\N	DT	1	Date Last Accessed	\N
4582	(3113,"Applicare/RadStore/Version 1.0",15)	(3113,"Applicare/RadStore/Version 1.0",15)	Applicare/RadStore/Version 1.0	12563	21	f	\N	CS	1	Unknown	\N
4583	(3113,"Applicare/RadStore/Version 1.0",16)	(3113,"Applicare/RadStore/Version 1.0",16)	Applicare/RadStore/Version 1.0	12563	22	f	\N	FD	1	Instance Size in Bytes	\N
4584	(3113,"Applicare/RadStore/Version 1.0",17)	(3113,"Applicare/RadStore/Version 1.0",17)	Applicare/RadStore/Version 1.0	12563	23	f	\N	LO	1	Library Id	\N
4585	(3113,"Applicare/RadStore/Version 1.0",18)	(3113,"Applicare/RadStore/Version 1.0",18)	Applicare/RadStore/Version 1.0	12563	24	f	\N	LO	1	Pathnames	\N
4586	(3113,"Applicare/RadStore/Version 1.0",19)	(3113,"Applicare/RadStore/Version 1.0",19)	Applicare/RadStore/Version 1.0	12563	25	f	\N	LO	1	Driver Path	\N
4587	(3113,"Applicare/RadStore/Version 1.0",1a)	(3113,"Applicare/RadStore/Version 1.0",1a)	Applicare/RadStore/Version 1.0	12563	26	f	\N	LO	1	Source	\N
4588	(3113,"Applicare/RadStore/Version 1.0",1b)	(3113,"Applicare/RadStore/Version 1.0",1b)	Applicare/RadStore/Version 1.0	12563	27	f	\N	LO	1	Destination	\N
4589	(3113,"Applicare/RadStore/Version 1.0",1c)	(3113,"Applicare/RadStore/Version 1.0",1c)	Applicare/RadStore/Version 1.0	12563	28	f	\N	SL	1	Medium Id	\N
4590	(3113,"Applicare/RadStore/Version 1.0",1d)	(3113,"Applicare/RadStore/Version 1.0",1d)	Applicare/RadStore/Version 1.0	12563	29	f	\N	LO	1	Archive Id	\N
4591	(3113,"Applicare/RadStore/Version 1.0",1e)	(3113,"Applicare/RadStore/Version 1.0",1e)	Applicare/RadStore/Version 1.0	12563	30	f	\N	LO	1	Instance Origin	\N
4592	(3113,"Applicare/RadStore/Version 1.0",21)	(3113,"Applicare/RadStore/Version 1.0",21)	Applicare/RadStore/Version 1.0	12563	33	f	\N	SL	1	Instance Version	\N
4593	(3113,"Applicare/RadStore/Version 1.0",22)	(3113,"Applicare/RadStore/Version 1.0",22)	Applicare/RadStore/Version 1.0	12563	34	f	\N	SL	1	Unknown	\N
4594	(3113,"Applicare/RadStore/Version 1.0",23)	(3113,"Applicare/RadStore/Version 1.0",23)	Applicare/RadStore/Version 1.0	12563	35	f	\N	ST	1	Instance File Location	\N
4595	(3113,"Applicare/RadStore/Version 1.0",31)	(3113,"Applicare/RadStore/Version 1.0",31)	Applicare/RadStore/Version 1.0	12563	49	f	\N	IS	1	Unknown	\N
4596	(3113,"Applicare/RadStore/Version 1.0",32)	(3113,"Applicare/RadStore/Version 1.0",32)	Applicare/RadStore/Version 1.0	12563	50	f	\N	IS	1	Unknown	\N
4597	(3113,"Applicare/RadStore/Version 1.0",33)	(3113,"Applicare/RadStore/Version 1.0",33)	Applicare/RadStore/Version 1.0	12563	51	f	\N	IS	1	Unknown	\N
4598	(3113,"Applicare/RadStore/Version 1.0",35)	(3113,"Applicare/RadStore/Version 1.0",35)	Applicare/RadStore/Version 1.0	12563	53	f	\N	LO	1	Image Medium Location	\N
4599	(3113,"Applicare/RadStore/Version 1.0",36)	(3113,"Applicare/RadStore/Version 1.0",36)	Applicare/RadStore/Version 1.0	12563	54	f	\N	LO	1	Image Medium Label	\N
4600	(3113,"Applicare/RadStore/Version 1.0",37)	(3113,"Applicare/RadStore/Version 1.0",37)	Applicare/RadStore/Version 1.0	12563	55	f	\N	CS	1	Image Medium State	\N
4601	(3113,"Applicare/RadStore/Version 1.0",38)	(3113,"Applicare/RadStore/Version 1.0",38)	Applicare/RadStore/Version 1.0	12563	56	f	\N	LO	1	Series Medium Location	\N
4602	(3113,"Applicare/RadStore/Version 1.0",39)	(3113,"Applicare/RadStore/Version 1.0",39)	Applicare/RadStore/Version 1.0	12563	57	f	\N	LO	1	Series Medium Label	\N
4603	(3113,"Applicare/RadStore/Version 1.0",3a)	(3113,"Applicare/RadStore/Version 1.0",3a)	Applicare/RadStore/Version 1.0	12563	58	f	\N	CS	1	Series Medium State	\N
4604	(3113,"Applicare/RadStore/Version 1.0",3b)	(3113,"Applicare/RadStore/Version 1.0",3b)	Applicare/RadStore/Version 1.0	12563	59	f	\N	LO	1	Study Medium Location	\N
4605	(3113,"Applicare/RadStore/Version 1.0",3c)	(3113,"Applicare/RadStore/Version 1.0",3c)	Applicare/RadStore/Version 1.0	12563	60	f	\N	LO	1	Study Medium Label	\N
4606	(3113,"Applicare/RadStore/Version 1.0",3d)	(3113,"Applicare/RadStore/Version 1.0",3d)	Applicare/RadStore/Version 1.0	12563	61	f	\N	CS	1	Study Medium State	\N
4607	(3113,"Applicare/RadStore/Version 1.0",52)	(3113,"Applicare/RadStore/Version 1.0",52)	Applicare/RadStore/Version 1.0	12563	82	f	\N	CS	1	Study State	\N
4608	(3113,"Applicare/RadStore/Version 1.0",53)	(3113,"Applicare/RadStore/Version 1.0",53)	Applicare/RadStore/Version 1.0	12563	83	f	\N	CS	1	Series State	\N
4609	(3113,"Applicare/RadStore/Version 1.0",55)	(3113,"Applicare/RadStore/Version 1.0",55)	Applicare/RadStore/Version 1.0	12563	85	f	\N	CS	1	Image State Text	\N
4610	(3113,"Applicare/RadStore/Version 1.0",56)	(3113,"Applicare/RadStore/Version 1.0",56)	Applicare/RadStore/Version 1.0	12563	86	f	\N	CS	1	Series State Text	\N
4611	(3113,"Applicare/RadStore/Version 1.0",57)	(3113,"Applicare/RadStore/Version 1.0",57)	Applicare/RadStore/Version 1.0	12563	87	f	\N	CS	1	Study State Text	\N
4612	(3113,"Applicare/RadStore/Version 1.0",60)	(3113,"Applicare/RadStore/Version 1.0",60)	Applicare/RadStore/Version 1.0	12563	96	f	\N	DT	1	Expiration	\N
4613	(3113,"Applicare/RadStore/Version 1.0",69)	(3113,"Applicare/RadStore/Version 1.0",69)	Applicare/RadStore/Version 1.0	12563	105	f	\N	AT	1-n	Deleted Tags	\N
4614	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",02)	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",02)	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	12565	2	f	\N	UT	1	Reference to pacs image	\N
4615	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",03)	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",03)	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	12565	3	f	\N	CS	1	Pacs examnotes flag	\N
4616	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",10)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",10)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	16	f	\N	DT	1	OrthoView Session Date/Time	\N
4617	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",20)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",20)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	32	f	\N	PN	1	OrthoView Session Creator	\N
4618	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",30)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",30)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	48	f	\N	CS	1	OrthoView Session Completion Flag	\N
4619	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",40)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",40)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	64	f	\N	SQ	1	OrthoView File Sequence	\N
4620	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",50)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",50)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	80	f	\N	ST	1	OrthoView File Name	\N
4621	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",60)	(3117,"http://www.gemedicalsystems.com/it_solutions/orthoview/2.1",60)	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	12567	96	f	\N	OB	1	OrthoView File Content	\N
4622	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",10)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",10)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	16	f	\N	DT	1	BAM WallThickness Session Date/Time	\N
4623	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",20)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",20)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	32	f	\N	PN	1	BAM WallThickness Session Creator	\N
4624	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",30)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",30)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	48	f	\N	CS	1	BAM WallThickness Session Completion Flag	\N
4625	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",40)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",40)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	64	f	\N	SQ	1	BAM WallThickness File Sequence	\N
4626	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",50)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",50)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	80	f	\N	ST	1	BAM WallThickness File Name	\N
4627	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",60)	(3118,"http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0",60)	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	12568	96	f	\N	OB	1	BAM WallThickness File Content	\N
4628	(3109,"AMI ImageContext_01",10)	(3109,"AMI ImageContext_01",10)	AMI ImageContext_01	12553	16	f	\N	CS	1	Window Invert	\N
4629	(3109,"AMI ImageContext_01",20)	(3109,"AMI ImageContext_01",20)	AMI ImageContext_01	12553	32	f	\N	IS	1	Window Center	\N
4630	(3109,"AMI ImageContext_01",30)	(3109,"AMI ImageContext_01",30)	AMI ImageContext_01	12553	48	f	\N	IS	1	Window Width	\N
4631	(3109,"AMI ImageContext_01",40)	(3109,"AMI ImageContext_01",40)	AMI ImageContext_01	12553	64	f	\N	CS	1	Pixel Aspect Ratio Swap	\N
4632	(3109,"AMI ImageContext_01",50)	(3109,"AMI ImageContext_01",50)	AMI ImageContext_01	12553	80	f	\N	CS	1	Enable Averaging	\N
4633	(3109,"AMI ImageContext_01",60)	(3109,"AMI ImageContext_01",60)	AMI ImageContext_01	12553	96	f	\N	CS	1	Quality	\N
4634	(3109,"AMI ImageContext_01",70)	(3109,"AMI ImageContext_01",70)	AMI ImageContext_01	12553	112	f	\N	CS	1	Viewport Annotation Level	\N
4635	(3109,"AMI ImageContext_01",80)	(3109,"AMI ImageContext_01",80)	AMI ImageContext_01	12553	128	f	\N	CS	1	Show Image Annotation	\N
4636	(3109,"AMI ImageContext_01",90)	(3109,"AMI ImageContext_01",90)	AMI ImageContext_01	12553	144	f	\N	CS	1	Show Image Overlay	\N
10978	(0119,"MRSC",1203)	(0119,"MRSC",03)	MRSC	281	3	t	12	IS	1	ExecuteOnRead	K
4649	(0051,"GEMS_FUNCTOOL_01",0d)	(0051,"GEMS_FUNCTOOL_01",0d)	GEMS_FUNCTOOL_01	81	13	f	\N	OB	1	Wizard State	\N
4650	(0019,"Harmony R1.0",00)	(0019,"Harmony R1.0",00)	Harmony R1.0	25	0	f	\N	IS	1	Unknown	\N
4651	(0019,"Harmony R1.0",01)	(0019,"Harmony R1.0",01)	Harmony R1.0	25	1	f	\N	LO	1	Unknown	\N
4652	(0019,"Harmony R1.0",02)	(0019,"Harmony R1.0",02)	Harmony R1.0	25	2	f	\N	US	1	Unknown	\N
4653	(0019,"Harmony R1.0",03)	(0019,"Harmony R1.0",03)	Harmony R1.0	25	3	f	\N	IS	1	Unknown	\N
4654	(0019,"Harmony R1.0",04)	(0019,"Harmony R1.0",04)	Harmony R1.0	25	4	f	\N	UN	1	Unknown	\N
4655	(0019,"Harmony R1.0",05)	(0019,"Harmony R1.0",05)	Harmony R1.0	25	5	f	\N	UN	1	Unknown	\N
4656	(0019,"Harmony R1.0",06)	(0019,"Harmony R1.0",06)	Harmony R1.0	25	6	f	\N	UN	1	Unknown	\N
4657	(0019,"Harmony R1.0",07)	(0019,"Harmony R1.0",07)	Harmony R1.0	25	7	f	\N	UN	1	Unknown	\N
4658	(0019,"Harmony R1.0",08)	(0019,"Harmony R1.0",08)	Harmony R1.0	25	8	f	\N	UN	1	Unknown	\N
4659	(0019,"Harmony R1.0",09)	(0019,"Harmony R1.0",09)	Harmony R1.0	25	9	f	\N	US	1	Unknown	\N
4660	(0019,"Harmony R1.0",0a)	(0019,"Harmony R1.0",0a)	Harmony R1.0	25	10	f	\N	US	1	Unknown	\N
4661	(0019,"Harmony R1.0",0b)	(0019,"Harmony R1.0",0b)	Harmony R1.0	25	11	f	\N	US	1	Unknown	\N
4662	(0019,"Harmony R1.0",0c)	(0019,"Harmony R1.0",0c)	Harmony R1.0	25	12	f	\N	UN	1	Unknown	\N
4663	(0019,"Harmony R1.0",0d)	(0019,"Harmony R1.0",0d)	Harmony R1.0	25	13	f	\N	UN	1	Unknown	\N
4664	(0019,"Harmony R1.0",0e)	(0019,"Harmony R1.0",0e)	Harmony R1.0	25	14	f	\N	US	1	Unknown	\N
4665	(0019,"Harmony R1.0",0f)	(0019,"Harmony R1.0",0f)	Harmony R1.0	25	15	f	\N	UN	1	Unknown	\N
4666	(0019,"Harmony R1.0",10)	(0019,"Harmony R1.0",10)	Harmony R1.0	25	16	f	\N	UN	1	Unknown	\N
4667	(0019,"Harmony R1.0",11)	(0019,"Harmony R1.0",11)	Harmony R1.0	25	17	f	\N	UN	1	Unknown	\N
4668	(0019,"Harmony R1.0",12)	(0019,"Harmony R1.0",12)	Harmony R1.0	25	18	f	\N	TM	1	Unknown	\N
4669	(0019,"Harmony R1.0",13)	(0019,"Harmony R1.0",13)	Harmony R1.0	25	19	f	\N	UN	1	Unknown	\N
4670	(0019,"Harmony R1.0",14)	(0019,"Harmony R1.0",14)	Harmony R1.0	25	20	f	\N	UN	1	Unknown	\N
4671	(0019,"Harmony R1.0",15)	(0019,"Harmony R1.0",15)	Harmony R1.0	25	21	f	\N	UN	1	Unknown	\N
4672	(0019,"Harmony R1.0",16)	(0019,"Harmony R1.0",16)	Harmony R1.0	25	22	f	\N	IS	1-n	Unknown	\N
4673	(0019,"Harmony R1.0",17)	(0019,"Harmony R1.0",17)	Harmony R1.0	25	23	f	\N	US	1	Unknown	\N
4674	(0019,"Harmony R1.0",18)	(0019,"Harmony R1.0",18)	Harmony R1.0	25	24	f	\N	UN	1	Unknown	\N
4675	(0019,"Harmony R1.0",19)	(0019,"Harmony R1.0",19)	Harmony R1.0	25	25	f	\N	US	1	Unknown	\N
4676	(0019,"Harmony R1.0",1a)	(0019,"Harmony R1.0",1a)	Harmony R1.0	25	26	f	\N	US	1	Unknown	\N
4677	(0019,"Harmony R1.0",1b)	(0019,"Harmony R1.0",1b)	Harmony R1.0	25	27	f	\N	US	1	Unknown	\N
4678	(0019,"Harmony R1.0",1c)	(0019,"Harmony R1.0",1c)	Harmony R1.0	25	28	f	\N	US	1	Unknown	\N
4679	(0019,"Harmony R1.0",1d)	(0019,"Harmony R1.0",1d)	Harmony R1.0	25	29	f	\N	IS	1	Unknown	\N
4680	(0019,"Harmony R1.0",1e)	(0019,"Harmony R1.0",1e)	Harmony R1.0	25	30	f	\N	US	1	Unknown	\N
4681	(0019,"Harmony R1.0",1f)	(0019,"Harmony R1.0",1f)	Harmony R1.0	25	31	f	\N	US	1	Unknown	\N
4682	(0019,"Harmony R1.0",20)	(0019,"Harmony R1.0",20)	Harmony R1.0	25	32	f	\N	US	1	Unknown	\N
4683	(0019,"Harmony R1.0",24)	(0019,"Harmony R1.0",24)	Harmony R1.0	25	36	f	\N	UN	1	Unknown	\N
4684	(0019,"Harmony R1.0",25)	(0019,"Harmony R1.0",25)	Harmony R1.0	25	37	f	\N	IS	1	Unknown	\N
4685	(0019,"Harmony R1.0",26)	(0019,"Harmony R1.0",26)	Harmony R1.0	25	38	f	\N	IS	1	Unknown	\N
4686	(0019,"Harmony R1.0",29)	(0019,"Harmony R1.0",29)	Harmony R1.0	25	41	f	\N	UN	1	Unknown	\N
4687	(0019,"Harmony R1.0",2a)	(0019,"Harmony R1.0",2a)	Harmony R1.0	25	42	f	\N	US	1	Unknown	\N
4688	(0019,"Harmony R1.0",2b)	(0019,"Harmony R1.0",2b)	Harmony R1.0	25	43	f	\N	UN	1	Unknown	\N
4638	(0051,"GEMS_FUNCTOOL_01",02)	(0051,"GEMS_FUNCTOOL_01",02)	GEMS_FUNCTOOL_01	81	2	f	\N	LO	1	Function Name	R
4639	(0051,"GEMS_FUNCTOOL_01",03)	(0051,"GEMS_FUNCTOOL_01",03)	GEMS_FUNCTOOL_01	81	3	f	\N	SL	1	Bias	K
4640	(0051,"GEMS_FUNCTOOL_01",04)	(0051,"GEMS_FUNCTOOL_01",04)	GEMS_FUNCTOOL_01	81	4	f	\N	FL	1	Scale	K
4641	(0051,"GEMS_FUNCTOOL_01",05)	(0051,"GEMS_FUNCTOOL_01",05)	GEMS_FUNCTOOL_01	81	5	f	\N	SL	1	Parameter Count	K
4642	(0051,"GEMS_FUNCTOOL_01",06)	(0051,"GEMS_FUNCTOOL_01",06)	GEMS_FUNCTOOL_01	81	6	f	\N	LT	1	Parameters	R
4643	(0051,"GEMS_FUNCTOOL_01",07)	(0051,"GEMS_FUNCTOOL_01",07)	GEMS_FUNCTOOL_01	81	7	f	\N	LO	1	Version	R
4645	(0051,"GEMS_FUNCTOOL_01",09)	(0051,"GEMS_FUNCTOOL_01",09)	GEMS_FUNCTOOL_01	81	9	f	\N	SL	1	Window Width	K
4646	(0051,"GEMS_FUNCTOOL_01",0a)	(0051,"GEMS_FUNCTOOL_01",0a)	GEMS_FUNCTOOL_01	81	10	f	\N	SL	1	Window Level	K
4647	(0051,"GEMS_FUNCTOOL_01",0b)	(0051,"GEMS_FUNCTOOL_01",0b)	GEMS_FUNCTOOL_01	81	11	f	\N	FL	1	B-Value	K
4648	(0051,"GEMS_FUNCTOOL_01",0c)	(0051,"GEMS_FUNCTOOL_01",0c)	GEMS_FUNCTOOL_01	81	12	f	\N	SL	1	Wizard State Data Size	R
4689	(0019,"Harmony R1.0",2d)	(0019,"Harmony R1.0",2d)	Harmony R1.0	25	45	f	\N	UN	1	Unknown	\N
4690	(0019,"Harmony R1.0",2e)	(0019,"Harmony R1.0",2e)	Harmony R1.0	25	46	f	\N	UN	1	Unknown	\N
4691	(0019,"Harmony R1.0",2f)	(0019,"Harmony R1.0",2f)	Harmony R1.0	25	47	f	\N	UN	1	Unknown	\N
4692	(0019,"Harmony R1.0",30)	(0019,"Harmony R1.0",30)	Harmony R1.0	25	48	f	\N	UN	1	Unknown	\N
4693	(0019,"Harmony R1.0",31)	(0019,"Harmony R1.0",31)	Harmony R1.0	25	49	f	\N	UN	1	Unknown	\N
4694	(0019,"Harmony R1.0",32)	(0019,"Harmony R1.0",32)	Harmony R1.0	25	50	f	\N	UN	1	Unknown	\N
4695	(0019,"Harmony R1.0",33)	(0019,"Harmony R1.0",33)	Harmony R1.0	25	51	f	\N	UN	1	Unknown	\N
4696	(0019,"Harmony R1.0",34)	(0019,"Harmony R1.0",34)	Harmony R1.0	25	52	f	\N	UN	1	Unknown	\N
4697	(0019,"Harmony R1.0",35)	(0019,"Harmony R1.0",35)	Harmony R1.0	25	53	f	\N	UN	1	Unknown	\N
4698	(0019,"Harmony R1.0",36)	(0019,"Harmony R1.0",36)	Harmony R1.0	25	54	f	\N	UN	1	Unknown	\N
4699	(0019,"Harmony R1.0",37)	(0019,"Harmony R1.0",37)	Harmony R1.0	25	55	f	\N	UN	1	Unknown	\N
4700	(0019,"Harmony R1.0",38)	(0019,"Harmony R1.0",38)	Harmony R1.0	25	56	f	\N	UN	1	Unknown	\N
4701	(0019,"Harmony R1.0",39)	(0019,"Harmony R1.0",39)	Harmony R1.0	25	57	f	\N	UN	1	Unknown	\N
4702	(0019,"Harmony R1.0",3a)	(0019,"Harmony R1.0",3a)	Harmony R1.0	25	58	f	\N	UN	1	Unknown	\N
4703	(0019,"Harmony R1.0",3b)	(0019,"Harmony R1.0",3b)	Harmony R1.0	25	59	f	\N	US	1	Unknown	\N
4704	(0019,"Harmony R1.0",3c)	(0019,"Harmony R1.0",3c)	Harmony R1.0	25	60	f	\N	US	1	Unknown	\N
4705	(0019,"Harmony R1.0",3d)	(0019,"Harmony R1.0",3d)	Harmony R1.0	25	61	f	\N	UN	1	Unknown	\N
4706	(0019,"Harmony R1.0",3e)	(0019,"Harmony R1.0",3e)	Harmony R1.0	25	62	f	\N	US	1	Unknown	\N
4707	(0019,"Harmony R1.0",3f)	(0019,"Harmony R1.0",3f)	Harmony R1.0	25	63	f	\N	US	1	Unknown	\N
4708	(0019,"Harmony R1.0",40)	(0019,"Harmony R1.0",40)	Harmony R1.0	25	64	f	\N	UN	1	Unknown	\N
4709	(0019,"Harmony R1.0",41)	(0019,"Harmony R1.0",41)	Harmony R1.0	25	65	f	\N	UN	1	Unknown	\N
4710	(0019,"Harmony R1.0",42)	(0019,"Harmony R1.0",42)	Harmony R1.0	25	66	f	\N	LO	1	Unknown	\N
4711	(0019,"Harmony R1.0",43)	(0019,"Harmony R1.0",43)	Harmony R1.0	25	67	f	\N	US	1	Unknown	\N
4712	(0019,"Harmony R1.0",44)	(0019,"Harmony R1.0",44)	Harmony R1.0	25	68	f	\N	US	1	Unknown	\N
4713	(0019,"Harmony R1.0",45)	(0019,"Harmony R1.0",45)	Harmony R1.0	25	69	f	\N	UN	1	Unknown	\N
4714	(0019,"Harmony R1.0",46)	(0019,"Harmony R1.0",46)	Harmony R1.0	25	70	f	\N	US	1	Unknown	\N
4715	(0019,"Harmony R1.0",47)	(0019,"Harmony R1.0",47)	Harmony R1.0	25	71	f	\N	LO	1	Unknown	\N
4716	(0019,"Harmony R1.0",48)	(0019,"Harmony R1.0",48)	Harmony R1.0	25	72	f	\N	US	1	Unknown	\N
4717	(0019,"Harmony R1.0",49)	(0019,"Harmony R1.0",49)	Harmony R1.0	25	73	f	\N	US	1	Unknown	\N
4718	(0019,"Harmony R1.0",4a)	(0019,"Harmony R1.0",4a)	Harmony R1.0	25	74	f	\N	US	1	Unknown	\N
4719	(0019,"Harmony R1.0",4b)	(0019,"Harmony R1.0",4b)	Harmony R1.0	25	75	f	\N	UN	1	Unknown	\N
4720	(0019,"Harmony R1.0",4c)	(0019,"Harmony R1.0",4c)	Harmony R1.0	25	76	f	\N	UN	1	Unknown	\N
4721	(0019,"Harmony R1.0",4e)	(0019,"Harmony R1.0",4e)	Harmony R1.0	25	78	f	\N	UN	1	Unknown	\N
4722	(0019,"Harmony R1.0",4f)	(0019,"Harmony R1.0",4f)	Harmony R1.0	25	79	f	\N	UN	1	Unknown	\N
4723	(0019,"Harmony R1.0",50)	(0019,"Harmony R1.0",50)	Harmony R1.0	25	80	f	\N	US	1	Unknown	\N
4724	(0019,"Harmony R1.0",51)	(0019,"Harmony R1.0",51)	Harmony R1.0	25	81	f	\N	UN	1	Unknown	\N
4725	(0019,"Harmony R1.0",52)	(0019,"Harmony R1.0",52)	Harmony R1.0	25	82	f	\N	UN	1	Unknown	\N
4726	(0019,"Harmony R1.0",54)	(0019,"Harmony R1.0",54)	Harmony R1.0	25	84	f	\N	UN	1	Unknown	\N
4727	(0019,"Harmony R1.0",55)	(0019,"Harmony R1.0",55)	Harmony R1.0	25	85	f	\N	UN	1	Unknown	\N
4728	(0019,"Harmony R1.0",56)	(0019,"Harmony R1.0",56)	Harmony R1.0	25	86	f	\N	US	1	Unknown	\N
4729	(0019,"Harmony R1.0",57)	(0019,"Harmony R1.0",57)	Harmony R1.0	25	87	f	\N	UN	1	Unknown	\N
4730	(0019,"Harmony R1.0",58)	(0019,"Harmony R1.0",58)	Harmony R1.0	25	88	f	\N	UN	1	Unknown	\N
4731	(0019,"Harmony R1.0",59)	(0019,"Harmony R1.0",59)	Harmony R1.0	25	89	f	\N	UN	1	Unknown	\N
4732	(0019,"Harmony R1.0",5a)	(0019,"Harmony R1.0",5a)	Harmony R1.0	25	90	f	\N	UN	1	Unknown	\N
4733	(0019,"Harmony R1.0",5b)	(0019,"Harmony R1.0",5b)	Harmony R1.0	25	91	f	\N	US	1	Unknown	\N
4734	(0019,"Harmony R1.0",5c)	(0019,"Harmony R1.0",5c)	Harmony R1.0	25	92	f	\N	UN	1	Unknown	\N
4735	(0019,"Harmony R1.0",5d)	(0019,"Harmony R1.0",5d)	Harmony R1.0	25	93	f	\N	UN	1	Unknown	\N
4736	(0019,"Harmony R1.0",5f)	(0019,"Harmony R1.0",5f)	Harmony R1.0	25	95	f	\N	UI	1	Unknown	\N
4737	(0019,"Harmony R1.0",60)	(0019,"Harmony R1.0",60)	Harmony R1.0	25	96	f	\N	UI	1	Unknown	\N
4738	(0019,"Harmony R1.0",63)	(0019,"Harmony R1.0",63)	Harmony R1.0	25	99	f	\N	US	1	Unknown	\N
4739	(0019,"Harmony R1.0",64)	(0019,"Harmony R1.0",64)	Harmony R1.0	25	100	f	\N	UN	1	Unknown	\N
4740	(0019,"Harmony R1.0",65)	(0019,"Harmony R1.0",65)	Harmony R1.0	25	101	f	\N	UN	1	Unknown	\N
4741	(0019,"Harmony R1.0",66)	(0019,"Harmony R1.0",66)	Harmony R1.0	25	102	f	\N	DS	1	Unknown	\N
4742	(0019,"Harmony R1.0",67)	(0019,"Harmony R1.0",67)	Harmony R1.0	25	103	f	\N	IS	1	Unknown	\N
4743	(0019,"Harmony R1.0",68)	(0019,"Harmony R1.0",68)	Harmony R1.0	25	104	f	\N	IS	1	Unknown	\N
4744	(0019,"Harmony R1.0",69)	(0019,"Harmony R1.0",69)	Harmony R1.0	25	105	f	\N	IS	1	Unknown	\N
4745	(0019,"Harmony R1.0",6a)	(0019,"Harmony R1.0",6a)	Harmony R1.0	25	106	f	\N	IS	1	Unknown	\N
4746	(0019,"Harmony R1.0",6b)	(0019,"Harmony R1.0",6b)	Harmony R1.0	25	107	f	\N	LO	1	Unknown	\N
4747	(0019,"Harmony R1.0",70)	(0019,"Harmony R1.0",70)	Harmony R1.0	25	112	f	\N	LO	1	Unknown	\N
4748	(0019,"Harmony R1.0",71)	(0019,"Harmony R1.0",71)	Harmony R1.0	25	113	f	\N	LO	1	Unknown	\N
4749	(0019,"Harmony R1.0",72)	(0019,"Harmony R1.0",72)	Harmony R1.0	25	114	f	\N	IS	1	Unknown	\N
4750	(0019,"Harmony R1.0",73)	(0019,"Harmony R1.0",73)	Harmony R1.0	25	115	f	\N	IS	1	Unknown	\N
4751	(0019,"Harmony R1.0",74)	(0019,"Harmony R1.0",74)	Harmony R1.0	25	116	f	\N	US	1	Unknown	\N
4752	(0019,"Harmony R1.0",75)	(0019,"Harmony R1.0",75)	Harmony R1.0	25	117	f	\N	IS	1	Unknown	\N
4753	(0019,"Harmony R1.0",78)	(0019,"Harmony R1.0",78)	Harmony R1.0	25	120	f	\N	IS	1	Unknown	\N
4754	(0019,"Harmony R1.0",79)	(0019,"Harmony R1.0",79)	Harmony R1.0	25	121	f	\N	IS	1	Unknown	\N
4755	(0019,"Harmony R1.0",7a)	(0019,"Harmony R1.0",7a)	Harmony R1.0	25	122	f	\N	IS	1	Unknown	\N
4756	(0019,"Harmony R1.0",7b)	(0019,"Harmony R1.0",7b)	Harmony R1.0	25	123	f	\N	IS	1	Unknown	\N
4757	(0019,"Harmony R1.0",7c)	(0019,"Harmony R1.0",7c)	Harmony R1.0	25	124	f	\N	US	1	Unknown	\N
4758	(0019,"Harmony R1.0",7d)	(0019,"Harmony R1.0",7d)	Harmony R1.0	25	125	f	\N	US	1	Unknown	\N
4759	(0019,"Harmony R1.0",7e)	(0019,"Harmony R1.0",7e)	Harmony R1.0	25	126	f	\N	US	1	Unknown	\N
4760	(0019,"Harmony R1.0",7f)	(0019,"Harmony R1.0",7f)	Harmony R1.0	25	127	f	\N	US	1	Unknown	\N
4761	(0019,"Harmony R1.0",80)	(0019,"Harmony R1.0",80)	Harmony R1.0	25	128	f	\N	US	1	Unknown	\N
4762	(0019,"Harmony R1.0",81)	(0019,"Harmony R1.0",81)	Harmony R1.0	25	129	f	\N	US	1	Unknown	\N
4763	(0019,"Harmony R1.0",82)	(0019,"Harmony R1.0",82)	Harmony R1.0	25	130	f	\N	US	1	Unknown	\N
4764	(0019,"Harmony R1.0",83)	(0019,"Harmony R1.0",83)	Harmony R1.0	25	131	f	\N	US	1	Unknown	\N
4765	(0019,"Harmony R1.0 C2",00)	(0019,"Harmony R1.0 C2",00)	Harmony R1.0 C2	25	0	f	\N	LO	1	Unknown	\N
4766	(0019,"Harmony R1.0 C2",01)	(0019,"Harmony R1.0 C2",01)	Harmony R1.0 C2	25	1	f	\N	UN	1	Unknown	\N
4767	(0019,"Harmony R1.0 C2",02)	(0019,"Harmony R1.0 C2",02)	Harmony R1.0 C2	25	2	f	\N	UN	1	Unknown	\N
4768	(0019,"Harmony R1.0 C2",03)	(0019,"Harmony R1.0 C2",03)	Harmony R1.0 C2	25	3	f	\N	UN	1	Unknown	\N
4769	(0019,"Harmony R1.0 C2",04)	(0019,"Harmony R1.0 C2",04)	Harmony R1.0 C2	25	4	f	\N	UN	1	Unknown	\N
4770	(0019,"Harmony R1.0 C2",05)	(0019,"Harmony R1.0 C2",05)	Harmony R1.0 C2	25	5	f	\N	UN	1	Unknown	\N
4771	(0019,"Harmony R1.0 C2",06)	(0019,"Harmony R1.0 C2",06)	Harmony R1.0 C2	25	6	f	\N	LO	1	Unknown	\N
4772	(0019,"Harmony R1.0 C2",07)	(0019,"Harmony R1.0 C2",07)	Harmony R1.0 C2	25	7	f	\N	UN	1	Unknown	\N
4773	(0019,"Harmony R1.0 C2",08)	(0019,"Harmony R1.0 C2",08)	Harmony R1.0 C2	25	8	f	\N	UN	1	Unknown	\N
4774	(0019,"Harmony R1.0 C2",09)	(0019,"Harmony R1.0 C2",09)	Harmony R1.0 C2	25	9	f	\N	UN	1	Unknown	\N
4775	(0019,"Harmony R1.0 C2",0a)	(0019,"Harmony R1.0 C2",0a)	Harmony R1.0 C2	25	10	f	\N	UN	1	Unknown	\N
4776	(0019,"Harmony R1.0 C2",6a)	(0019,"Harmony R1.0 C2",6a)	Harmony R1.0 C2	25	106	f	\N	LO	1	Unknown	\N
4777	(0019,"Harmony R1.0 C2",6c)	(0019,"Harmony R1.0 C2",6c)	Harmony R1.0 C2	25	108	f	\N	US	1	Unknown	\N
4778	(0019,"Harmony R1.0 C2",6d)	(0019,"Harmony R1.0 C2",6d)	Harmony R1.0 C2	25	109	f	\N	US	1	Unknown	\N
4779	(0019,"Harmony R1.0 C2",6e)	(0019,"Harmony R1.0 C2",6e)	Harmony R1.0 C2	25	110	f	\N	UN	1	Unknown	\N
4780	(0019,"Harmony R1.0 C2",74)	(0019,"Harmony R1.0 C2",74)	Harmony R1.0 C2	25	116	f	\N	UN	1	Unknown	\N
4781	(0019,"Harmony R1.0 C2",76)	(0019,"Harmony R1.0 C2",76)	Harmony R1.0 C2	25	118	f	\N	UN	1	Unknown	\N
4782	(0019,"Harmony R1.0 C2",78)	(0019,"Harmony R1.0 C2",78)	Harmony R1.0 C2	25	120	f	\N	US	1	Unknown	\N
4783	(0019,"Harmony R1.0 C2",79)	(0019,"Harmony R1.0 C2",79)	Harmony R1.0 C2	25	121	f	\N	US	1	Unknown	\N
4784	(0019,"Harmony R1.0 C2",7a)	(0019,"Harmony R1.0 C2",7a)	Harmony R1.0 C2	25	122	f	\N	US	1	Unknown	\N
4785	(0019,"Harmony R1.0 C2",80)	(0019,"Harmony R1.0 C2",80)	Harmony R1.0 C2	25	128	f	\N	UN	1	Unknown	\N
4786	(0019,"Harmony R1.0 C2",81)	(0019,"Harmony R1.0 C2",81)	Harmony R1.0 C2	25	129	f	\N	UN	1	Unknown	\N
4787	(0019,"Harmony R1.0 C2",82)	(0019,"Harmony R1.0 C2",82)	Harmony R1.0 C2	25	130	f	\N	UN	1	Unknown	\N
4788	(0019,"Harmony R1.0 C2",83)	(0019,"Harmony R1.0 C2",83)	Harmony R1.0 C2	25	131	f	\N	UN	1	Unknown	\N
4789	(0019,"Harmony R1.0 C2",84)	(0019,"Harmony R1.0 C2",84)	Harmony R1.0 C2	25	132	f	\N	UN	1	Unknown	\N
4790	(0019,"Harmony R1.0 C2",91)	(0019,"Harmony R1.0 C2",91)	Harmony R1.0 C2	25	145	f	\N	UN	1	Unknown	\N
4791	(0019,"Harmony R1.0 C3",00)	(0019,"Harmony R1.0 C3",00)	Harmony R1.0 C3	25	0	f	\N	LO	1	Unknown	\N
4792	(0019,"Harmony R1.0 C3",03)	(0019,"Harmony R1.0 C3",03)	Harmony R1.0 C3	25	3	f	\N	LO	1	Unknown	\N
4793	(0019,"Harmony R1.0 C3",07)	(0019,"Harmony R1.0 C3",07)	Harmony R1.0 C3	25	7	f	\N	LO	1	Unknown	\N
4794	(0019,"Harmony R1.0 C3",0b)	(0019,"Harmony R1.0 C3",0b)	Harmony R1.0 C3	25	11	f	\N	LO	1	Unknown	\N
4795	(0019,"Harmony R1.0 C3",50)	(0019,"Harmony R1.0 C3",50)	Harmony R1.0 C3	25	80	f	\N	UN	1	Unknown	\N
4796	(0019,"Harmony R1.0 C3",51)	(0019,"Harmony R1.0 C3",51)	Harmony R1.0 C3	25	81	f	\N	UN	1	Unknown	\N
4797	(0019,"Harmony R1.0 C3",52)	(0019,"Harmony R1.0 C3",52)	Harmony R1.0 C3	25	82	f	\N	LO	1	Unknown	\N
4798	(0019,"Harmony R1.0 C3",53)	(0019,"Harmony R1.0 C3",53)	Harmony R1.0 C3	25	83	f	\N	UN	1	Unknown	\N
4799	(0019,"Harmony R1.0 C3",5a)	(0019,"Harmony R1.0 C3",5a)	Harmony R1.0 C3	25	90	f	\N	US	1	Unknown	\N
4800	(0019,"Harmony R1.0 C3",5b)	(0019,"Harmony R1.0 C3",5b)	Harmony R1.0 C3	25	91	f	\N	LO	1	Unknown	\N
4801	(0019,"Harmony R1.0 C3",5c)	(0019,"Harmony R1.0 C3",5c)	Harmony R1.0 C3	25	92	f	\N	US	1	Unknown	\N
4802	(0019,"Harmony R1.0 C3",5f)	(0019,"Harmony R1.0 C3",5f)	Harmony R1.0 C3	25	95	f	\N	US	1	Unknown	\N
4803	(0019,"Harmony R1.0 C3",78)	(0019,"Harmony R1.0 C3",78)	Harmony R1.0 C3	25	120	f	\N	LO	1	Unknown	\N
4804	(0019,"Harmony R1.0 C3",79)	(0019,"Harmony R1.0 C3",79)	Harmony R1.0 C3	25	121	f	\N	PN	1	Unknown	\N
4805	(0019,"Harmony R1.0 C3",7a)	(0019,"Harmony R1.0 C3",7a)	Harmony R1.0 C3	25	122	f	\N	PN	1	Unknown	\N
4806	(0019,"Harmony R1.0 C3",7b)	(0019,"Harmony R1.0 C3",7b)	Harmony R1.0 C3	25	123	f	\N	LO	1	Unknown	\N
4807	(0019,"Harmony R1.0 C3",7c)	(0019,"Harmony R1.0 C3",7c)	Harmony R1.0 C3	25	124	f	\N	UN	1	Unknown	\N
4808	(0019,"Harmony R1.0 C3",7d)	(0019,"Harmony R1.0 C3",7d)	Harmony R1.0 C3	25	125	f	\N	CS	1	Unknown	\N
4809	(0019,"Harmony R1.0 C3",7e)	(0019,"Harmony R1.0 C3",7e)	Harmony R1.0 C3	25	126	f	\N	LO	1	Unknown	\N
4810	(0019,"Harmony R1.0 C3",7f)	(0019,"Harmony R1.0 C3",7f)	Harmony R1.0 C3	25	127	f	\N	UN	1	Unknown	\N
4811	(0019,"Harmony R1.0 C3",80)	(0019,"Harmony R1.0 C3",80)	Harmony R1.0 C3	25	128	f	\N	IS	1	Unknown	\N
4812	(0019,"Harmony R1.0 C3",83)	(0019,"Harmony R1.0 C3",83)	Harmony R1.0 C3	25	131	f	\N	IS	1	Unknown	\N
4813	(0019,"Harmony R1.0 C3",94)	(0019,"Harmony R1.0 C3",94)	Harmony R1.0 C3	25	148	f	\N	IS	1	Unknown	\N
4814	(0019,"Harmony R1.0 C3",95)	(0019,"Harmony R1.0 C3",95)	Harmony R1.0 C3	25	149	f	\N	IS	1	Unknown	\N
4815	(0019,"Harmony R1.0 C3",96)	(0019,"Harmony R1.0 C3",96)	Harmony R1.0 C3	25	150	f	\N	LO	1	Unknown	\N
4816	(0019,"Harmony R1.0 C3",97)	(0019,"Harmony R1.0 C3",97)	Harmony R1.0 C3	25	151	f	\N	UN	1	Unknown	\N
4817	(0019,"Harmony R1.0 C3",98)	(0019,"Harmony R1.0 C3",98)	Harmony R1.0 C3	25	152	f	\N	IS	1-n	Unknown	\N
4818	(0019,"Harmony R1.0 C3",e4)	(0019,"Harmony R1.0 C3",e4)	Harmony R1.0 C3	25	228	f	\N	LO	1	Unknown	\N
4819	(0019,"Harmony R1.0 C3",e5)	(0019,"Harmony R1.0 C3",e5)	Harmony R1.0 C3	25	229	f	\N	UN	1	Unknown	\N
4820	(0019,"Harmony R1.0 C3",e6)	(0019,"Harmony R1.0 C3",e6)	Harmony R1.0 C3	25	230	f	\N	UN	1	Unknown	\N
4821	(0019,"Harmony R1.0 C3",e7)	(0019,"Harmony R1.0 C3",e7)	Harmony R1.0 C3	25	231	f	\N	UN	1	Unknown	\N
4822	(0019,"Harmony R1.0 C3",e8)	(0019,"Harmony R1.0 C3",e8)	Harmony R1.0 C3	25	232	f	\N	UN	1	Unknown	\N
4823	(0019,"Harmony R1.0 C3",e9)	(0019,"Harmony R1.0 C3",e9)	Harmony R1.0 C3	25	233	f	\N	US	1	Unknown	\N
4824	(0019,"Harmony R1.0 C3",ea)	(0019,"Harmony R1.0 C3",ea)	Harmony R1.0 C3	25	234	f	\N	UN	1	Unknown	\N
4825	(0019,"Harmony R1.0 C3",eb)	(0019,"Harmony R1.0 C3",eb)	Harmony R1.0 C3	25	235	f	\N	US	1	Unknown	\N
4826	(0019,"Harmony R1.0 C3",ec)	(0019,"Harmony R1.0 C3",ec)	Harmony R1.0 C3	25	236	f	\N	UN	1	Unknown	\N
4827	(0019,"Harmony R1.0 C3",ed)	(0019,"Harmony R1.0 C3",ed)	Harmony R1.0 C3	25	237	f	\N	UN	1	Unknown	\N
4828	(0019,"Harmony R1.0 C3",ee)	(0019,"Harmony R1.0 C3",ee)	Harmony R1.0 C3	25	238	f	\N	US	1	Unknown	\N
4829	(0019,"Harmony R1.0 C3",ef)	(0019,"Harmony R1.0 C3",ef)	Harmony R1.0 C3	25	239	f	\N	US	1	Unknown	\N
4830	(0019,"Harmony R1.0 C3",f0)	(0019,"Harmony R1.0 C3",f0)	Harmony R1.0 C3	25	240	f	\N	UN	1	Unknown	\N
4831	(0019,"Harmony R1.0 C3",f1)	(0019,"Harmony R1.0 C3",f1)	Harmony R1.0 C3	25	241	f	\N	UN	1	Unknown	\N
4832	(0019,"Harmony R1.0 C3",f2)	(0019,"Harmony R1.0 C3",f2)	Harmony R1.0 C3	25	242	f	\N	UN	1	Unknown	\N
4833	(0019,"Harmony R2.0",79)	(0019,"Harmony R2.0",79)	Harmony R2.0	25	121	f	\N	IS	1	Unknown	\N
4834	(0019,"Harmony R2.0",7c)	(0019,"Harmony R2.0",7c)	Harmony R2.0	25	124	f	\N	IS	1	Unknown	\N
4835	(0019,"Harmony R2.0",7d)	(0019,"Harmony R2.0",7d)	Harmony R2.0	25	125	f	\N	UN	1	Unknown	\N
4836	(0019,"Harmony R2.0",81)	(0019,"Harmony R2.0",81)	Harmony R2.0	25	129	f	\N	IS	1	Unknown	\N
4837	(0019,"Harmony R2.0",82)	(0019,"Harmony R2.0",82)	Harmony R2.0	25	130	f	\N	US	1	Unknown	\N
4838	(0019,"Harmony R2.0",83)	(0019,"Harmony R2.0",83)	Harmony R2.0	25	131	f	\N	US	1	Unknown	\N
4839	(0019,"Harmony R2.0",84)	(0019,"Harmony R2.0",84)	Harmony R2.0	25	132	f	\N	US	1	Unknown	\N
4840	(0019,"Harmony R2.0",85)	(0019,"Harmony R2.0",85)	Harmony R2.0	25	133	f	\N	UN	1	Unknown	\N
4841	(0019,"Harmony R2.0",86)	(0019,"Harmony R2.0",86)	Harmony R2.0	25	134	f	\N	IS	1	Unknown	\N
4842	(0019,"Harmony R2.0",87)	(0019,"Harmony R2.0",87)	Harmony R2.0	25	135	f	\N	UN	1	Unknown	\N
4843	(0019,"Harmony R2.0",88)	(0019,"Harmony R2.0",88)	Harmony R2.0	25	136	f	\N	IS	1	Unknown	\N
4844	(0019,"Harmony R2.0",89)	(0019,"Harmony R2.0",89)	Harmony R2.0	25	137	f	\N	US	1	Unknown	\N
4845	(0019,"Harmony R2.0",8a)	(0019,"Harmony R2.0",8a)	Harmony R2.0	25	138	f	\N	US	1	Unknown	\N
4846	(0019,"Harmony R2.0",8c)	(0019,"Harmony R2.0",8c)	Harmony R2.0	25	140	f	\N	IS	1	Unknown	\N
4847	(0019,"Harmony R2.0",8d)	(0019,"Harmony R2.0",8d)	Harmony R2.0	25	141	f	\N	DS	1	Unknown	\N
4848	(0019,"Harmony R2.0",8f)	(0019,"Harmony R2.0",8f)	Harmony R2.0	25	143	f	\N	US	1	Unknown	\N
4849	(0019,"Harmony R2.0",90)	(0019,"Harmony R2.0",90)	Harmony R2.0	25	144	f	\N	US	1	Unknown	\N
4850	(0019,"Harmony R2.0",91)	(0019,"Harmony R2.0",91)	Harmony R2.0	25	145	f	\N	US	1	Unknown	\N
4851	(0019,"Harmony R2.0",92)	(0019,"Harmony R2.0",92)	Harmony R2.0	25	146	f	\N	US	1	Unknown	\N
4852	(0019,"Harmony R2.0",93)	(0019,"Harmony R2.0",93)	Harmony R2.0	25	147	f	\N	DS	2	Unknown	\N
4853	(0019,"Harmony R2.0",94)	(0019,"Harmony R2.0",94)	Harmony R2.0	25	148	f	\N	LO	1	Unknown	\N
4854	(0019,"Harmony R2.0",95)	(0019,"Harmony R2.0",95)	Harmony R2.0	25	149	f	\N	LO	1-n	Unknown	\N
4855	(0019,"Harmony R2.0",96)	(0019,"Harmony R2.0",96)	Harmony R2.0	25	150	f	\N	DS	1	Unknown	\N
4856	(0019,"Harmony R2.0",97)	(0019,"Harmony R2.0",97)	Harmony R2.0	25	151	f	\N	IS	2	Unknown	\N
4857	(0019,"Harmony R2.0",99)	(0019,"Harmony R2.0",99)	Harmony R2.0	25	153	f	\N	LO	1	Unknown	\N
4858	(0029,"Silhouette V1.0",31)	(0029,"Silhouette V1.0",31)	Silhouette V1.0	41	49	f	\N	UN	1	Unknown	\N
4859	(0029,"Silhouette V1.0",46)	(0029,"Silhouette V1.0",46)	Silhouette V1.0	41	70	f	\N	UN	1	Unknown	\N
4860	(0029,"Silhouette V1.0",47)	(0029,"Silhouette V1.0",47)	Silhouette V1.0	41	71	f	\N	UN	1	Unknown	\N
4861	(0029,"Silhouette V1.0",73)	(0029,"Silhouette V1.0",73)	Silhouette V1.0	41	115	f	\N	UN	1	Unknown	\N
4862	(0029,"Silhouette V1.0",74)	(0029,"Silhouette V1.0",74)	Silhouette V1.0	41	116	f	\N	UN	1	Unknown	\N
4863	(0029,"Silhouette V1.0",77)	(0029,"Silhouette V1.0",77)	Silhouette V1.0	41	119	f	\N	UN	1	Unknown	\N
4864	(0029,"Silhouette V1.0",78)	(0029,"Silhouette V1.0",78)	Silhouette V1.0	41	120	f	\N	UN	1	Unknown	\N
4865	(0029,"Silhouette V1.0",88)	(0029,"Silhouette V1.0",88)	Silhouette V1.0	41	136	f	\N	UN	1	Unknown	\N
4866	(0029,"Silhouette V1.0",89)	(0029,"Silhouette V1.0",89)	Silhouette V1.0	41	137	f	\N	UN	1	Unknown	\N
4867	(0029,"Silhouette V1.0",90)	(0029,"Silhouette V1.0",90)	Silhouette V1.0	41	144	f	\N	UN	1	Unknown	\N
4868	(0029,"Silhouette V1.0",91)	(0029,"Silhouette V1.0",91)	Silhouette V1.0	41	145	f	\N	UN	1	Unknown	\N
4869	(0011,"Hologic",00)	(0011,"Hologic",00)	Hologic	17	0	f	\N	OB	1	Hx Questionnaire	\N
4870	(0011,"HOLOGIC",00)	(0011,"HOLOGIC",00)	HOLOGIC	17	0	f	\N	OB	1	Hx Questionnaire	\N
4871	(0013,"Hologic",00)	(0013,"Hologic",00)	Hologic	19	0	f	\N	LO	1	IVA Results Flag	\N
4872	(0013,"HOLOGIC",00)	(0013,"HOLOGIC",00)	HOLOGIC	19	0	f	\N	LO	1	IVA Results Flag	\N
4873	(0019,"Hologic",00)	(0019,"Hologic",00)	Hologic	25	0	f	\N	UT	1	Report Data	\N
4874	(0019,"HOLOGIC",00)	(0019,"HOLOGIC",00)	HOLOGIC	25	0	f	\N	UT	1	Report Data	\N
4875	(0019,"LODOX_STATSCAN",01)	(0019,"LODOX_STATSCAN",01)	LODOX_STATSCAN	25	1	f	\N	IS	1-n	Unknown	\N
4876	(0019,"LODOX_STATSCAN",02)	(0019,"LODOX_STATSCAN",02)	LODOX_STATSCAN	25	2	f	\N	IS	1	Unknown	\N
4877	(0019,"LODOX_STATSCAN",03)	(0019,"LODOX_STATSCAN",03)	LODOX_STATSCAN	25	3	f	\N	DS	1	Unknown	\N
4878	(0019,"LODOX_STATSCAN",04)	(0019,"LODOX_STATSCAN",04)	LODOX_STATSCAN	25	4	f	\N	DS	1	Unknown	\N
4879	(0019,"LODOX_STATSCAN",05)	(0019,"LODOX_STATSCAN",05)	LODOX_STATSCAN	25	5	f	\N	DS	1	Unknown	\N
4880	(0019,"LODOX_STATSCAN",06)	(0019,"LODOX_STATSCAN",06)	LODOX_STATSCAN	25	6	f	\N	DS	1	Unknown	\N
4881	(0019,"LODOX_STATSCAN",07)	(0019,"LODOX_STATSCAN",07)	LODOX_STATSCAN	25	7	f	\N	DS	1	Unknown	\N
4882	(0019,"LODOX_STATSCAN",08)	(0019,"LODOX_STATSCAN",08)	LODOX_STATSCAN	25	8	f	\N	DS	1	Unknown	\N
4883	(0021,"SCHICK TECHNOLOGIES - Change List Creator ID",01)	(0021,"SCHICK TECHNOLOGIES - Change List Creator ID",01)	SCHICK TECHNOLOGIES - Change List Creator ID	33	1	f	\N	UI	1	Unknown	\N
4884	(0021,"SCHICK TECHNOLOGIES - Change List Creator ID",02)	(0021,"SCHICK TECHNOLOGIES - Change List Creator ID",02)	SCHICK TECHNOLOGIES - Change List Creator ID	33	2	f	\N	SQ	1	Unknown	\N
4885	(0021,"SCHICK TECHNOLOGIES - Note List Creator ID",01)	(0021,"SCHICK TECHNOLOGIES - Note List Creator ID",01)	SCHICK TECHNOLOGIES - Note List Creator ID	33	1	f	\N	UI	1	Unknown	\N
4886	(0021,"SCHICK TECHNOLOGIES - Note List Creator ID",02)	(0021,"SCHICK TECHNOLOGIES - Note List Creator ID",02)	SCHICK TECHNOLOGIES - Note List Creator ID	33	2	f	\N	SQ	1	Unknown	\N
4887	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",01)	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",01)	SCHICK TECHNOLOGIES - Change Item Creator ID	33	1	f	\N	UI	1	Unknown	\N
4888	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",02)	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",02)	SCHICK TECHNOLOGIES - Change Item Creator ID	33	2	f	\N	US	1	Unknown	\N
4889	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",03)	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",03)	SCHICK TECHNOLOGIES - Change Item Creator ID	33	3	f	\N	DT	1	Unknown	\N
4890	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",04)	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",04)	SCHICK TECHNOLOGIES - Change Item Creator ID	33	4	f	\N	PN	1	Unknown	\N
4891	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",05)	(0021,"SCHICK TECHNOLOGIES - Change Item Creator ID",05)	SCHICK TECHNOLOGIES - Change Item Creator ID	33	5	f	\N	OB	1	Unknown	\N
4892	(0021,"Hologic",01)	(0021,"Hologic",01)	Hologic	33	1	f	\N	LT	1	Image Analysis Data in XML	\N
4893	(0021,"HOLOGIC",01)	(0021,"HOLOGIC",01)	HOLOGIC	33	1	f	\N	LT	1	Image Analysis Data in XML	\N
4894	(0023,"Hologic",00)	(0023,"Hologic",00)	Hologic	35	0	f	\N	LO	1	Encoding Scheme Version	\N
4895	(0023,"HOLOGIC",00)	(0023,"HOLOGIC",00)	HOLOGIC	35	0	f	\N	LO	1	Encoding Scheme Version	\N
4896	(0023,"Hologic",01)	(0023,"Hologic",01)	Hologic	35	1	f	\N	LO	1	P File Name	\N
4897	(0023,"HOLOGIC",01)	(0023,"HOLOGIC",01)	HOLOGIC	35	1	f	\N	LO	1	P File Name	\N
4898	(0023,"Hologic",02)	(0023,"Hologic",02)	Hologic	35	2	f	\N	OB	1	P File Data	\N
4899	(0023,"HOLOGIC",02)	(0023,"HOLOGIC",02)	HOLOGIC	35	2	f	\N	OB	1	P File Data	\N
4900	(0023,"Hologic",03)	(0023,"Hologic",03)	Hologic	35	3	f	\N	UL	1	P File Length	\N
4901	(0023,"HOLOGIC",03)	(0023,"HOLOGIC",03)	HOLOGIC	35	3	f	\N	UL	1	P File Length	\N
4902	(0023,"Hologic",04)	(0023,"Hologic",04)	Hologic	35	4	f	\N	OB	1	R File Data	\N
4903	(0023,"HOLOGIC",04)	(0023,"HOLOGIC",04)	HOLOGIC	35	4	f	\N	OB	1	R File Data	\N
4904	(0023,"Hologic",05)	(0023,"Hologic",05)	Hologic	35	5	f	\N	UL	1	R File Length	\N
4905	(0023,"HOLOGIC",05)	(0023,"HOLOGIC",05)	HOLOGIC	35	5	f	\N	UL	1	R File Length	\N
4906	(0029,"Hologic",00)	(0029,"Hologic",00)	Hologic	41	0	f	\N	OB	1	Graph Bitmap Data	\N
4907	(0029,"HOLOGIC",00)	(0029,"HOLOGIC",00)	HOLOGIC	41	0	f	\N	OB	1	Graph Bitmap Data	\N
4908	(0029,"Hologic",01)	(0029,"Hologic",01)	Hologic	41	1	f	\N	UL	1	Graph Bitmap Size	\N
4909	(0029,"HOLOGIC",01)	(0029,"HOLOGIC",01)	HOLOGIC	41	1	f	\N	UL	1	Graph Bitmap Size	\N
4910	(0029,"SCHICK TECHNOLOGIES - Image Security Creator ID",01)	(0029,"SCHICK TECHNOLOGIES - Image Security Creator ID",01)	SCHICK TECHNOLOGIES - Image Security Creator ID	41	1	f	\N	UL	1	Unknown	\N
4911	(0029,"2.16.840.1.114059.1.1.6.1.50.1",20)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",20)	2.16.840.1.114059.1.1.6.1.50.1	41	32	f	\N	LT	1	Unknown	\N
4912	(0029,"2.16.840.1.114059.1.1.6.1.50.1",21)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",21)	2.16.840.1.114059.1.1.6.1.50.1	41	33	f	\N	ST	1	Unknown	\N
4913	(0029,"2.16.840.1.114059.1.1.6.1.50.1",22)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",22)	2.16.840.1.114059.1.1.6.1.50.1	41	34	f	\N	ST	1	Unknown	\N
4914	(0029,"2.16.840.1.114059.1.1.6.1.50.1",23)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",23)	2.16.840.1.114059.1.1.6.1.50.1	41	35	f	\N	ST	1	Unknown	\N
4915	(0029,"2.16.840.1.114059.1.1.6.1.50.1",24)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",24)	2.16.840.1.114059.1.1.6.1.50.1	41	36	f	\N	LO	1	Unknown	\N
4916	(0029,"2.16.840.1.114059.1.1.6.1.50.1",25)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",25)	2.16.840.1.114059.1.1.6.1.50.1	41	37	f	\N	LO	1	Unknown	\N
4917	(0029,"2.16.840.1.114059.1.1.6.1.50.1",26)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",26)	2.16.840.1.114059.1.1.6.1.50.1	41	38	f	\N	LO	1	Unknown	\N
4918	(0029,"2.16.840.1.114059.1.1.6.1.50.1",27)	(0029,"2.16.840.1.114059.1.1.6.1.50.1",27)	2.16.840.1.114059.1.1.6.1.50.1	41	39	f	\N	LO	1	Unknown	\N
4919	(0073,"STENTOR",01)	(0073,"STENTOR",01)	STENTOR	115	1	f	\N	ST	1	Unknown	\N
4920	(0073,"STENTOR",02)	(0073,"STENTOR",02)	STENTOR	115	2	f	\N	ST	1	Unknown	\N
4921	(0073,"STENTOR",03)	(0073,"STENTOR",03)	STENTOR	115	3	f	\N	ST	1	Unknown	\N
4922	(0073,"STENTOR",04)	(0073,"STENTOR",04)	STENTOR	115	4	f	\N	ST	1	Unknown	\N
4923	(0073,"STENTOR",06)	(0073,"STENTOR",06)	STENTOR	115	6	f	\N	LO	1	Unknown	\N
10979	(0119,"MRSC",1204)	(0119,"MRSC",04)	MRSC	281	4	t	12	IS	1	NumberPasses	K
4927	(0019,"FDMS 1.0",30)	(0019,"FDMS 1.0",30)	FDMS 1.0	25	48	f	\N	LO	1	Menu Character String	\N
4928	(0021,"FDMS 1.0",70)	(0021,"FDMS 1.0",70)	FDMS 1.0	33	112	f	\N	IS	1	Film Number within the Series	\N
4929	(0021,"FDMS 1.0",90)	(0021,"FDMS 1.0",90)	FDMS 1.0	33	144	f	\N	CS	1	LUT Number	\N
4926	(0009,"FDMS 1.0",f1)	(0009,"FDMS 1.0",f1)	FDMS 1.0	9	241	f	\N	LO	1	Processing Information Flag	K
5155	(0019,"MMCPrivate",03)	(0019,"MMCPrivate",03)	MMCPrivate	25	3	f	\N	SH	1	Is Snap Shot Series	K
4930	(0029,"FDMS 1.0",25)	(0029,"FDMS 1.0",25)	FDMS 1.0	41	37	f	\N	CS	1	Image Rotation/Reversal Information	\N
4931	(0032,"FDMS 1.0",32)	(0032,"FDMS 1.0",32)	FDMS 1.0	50	50	f	\N	PN	1	Requesting Physician	\N
4932	(0032,"FDMS 1.0",33)	(0032,"FDMS 1.0",33)	FDMS 1.0	50	51	f	\N	LO	1	Requesting Service	\N
4933	(2011,"FDMS 1.0",00)	(2011,"FDMS 1.0",00)	FDMS 1.0	8209	0	f	\N	CS	1	Trim Density	\N
4934	(2011,"FDMS 1.0",01)	(2011,"FDMS 1.0",01)	FDMS 1.0	8209	1	f	\N	IS	1	Trim Width	\N
4935	(2011,"FDMS 1.0",02)	(2011,"FDMS 1.0",02)	FDMS 1.0	8209	2	f	\N	CS	1	Image Mag./Reduc. Range	\N
4936	(2011,"FDMS 1.0",10)	(2011,"FDMS 1.0",10)	FDMS 1.0	8209	16	f	\N	CS	1	Image Display Format	\N
4937	(2011,"FDMS 1.0",20)	(2011,"FDMS 1.0",20)	FDMS 1.0	8209	32	f	\N	OW	1	Interpolation A-VRS System Format	\N
4943	(50f1,"FDMS 1.0",10)	(50f1,"FDMS 1.0",10)	FDMS 1.0	20721	16	f	\N	CS	1	Film Output Format	\N
4945	(0019,"Canon Inc.",10)	(0019,"Canon Inc.",10)	Canon Inc.	25	16	f	\N	UN	1	Unknown	\N
4946	(0019,"Canon Inc.",13)	(0019,"Canon Inc.",13)	Canon Inc.	25	19	f	\N	UN	1	Unknown	\N
4947	(0019,"Canon Inc.",15)	(0019,"Canon Inc.",15)	Canon Inc.	25	21	f	\N	DS	2	Unknown	\N
4948	(0019,"Canon Inc.",16)	(0019,"Canon Inc.",16)	Canon Inc.	25	22	f	\N	UN	1	Unknown	\N
4949	(0019,"Canon Inc.",17)	(0019,"Canon Inc.",17)	Canon Inc.	25	23	f	\N	DS	1	Unknown	\N
4950	(0019,"Canon Inc.",18)	(0019,"Canon Inc.",18)	Canon Inc.	25	24	f	\N	UN	1	Unknown	\N
4951	(0019,"Canon Inc.",19)	(0019,"Canon Inc.",19)	Canon Inc.	25	25	f	\N	UN	1	Unknown	\N
4952	(0019,"Canon Inc.",1a)	(0019,"Canon Inc.",1a)	Canon Inc.	25	26	f	\N	UN	1	Unknown	\N
4953	(0019,"Canon Inc.",1b)	(0019,"Canon Inc.",1b)	Canon Inc.	25	27	f	\N	LO	1	Unknown	\N
4954	(0019,"Canon Inc.",1c)	(0019,"Canon Inc.",1c)	Canon Inc.	25	28	f	\N	IS	1	Unknown	\N
4955	(0019,"Canon Inc.",1e)	(0019,"Canon Inc.",1e)	Canon Inc.	25	30	f	\N	IS	1	Unknown	\N
4956	(0019,"Canon Inc.",1f)	(0019,"Canon Inc.",1f)	Canon Inc.	25	31	f	\N	UN	1	Unknown	\N
4957	(0019,"Canon Inc.",21)	(0019,"Canon Inc.",21)	Canon Inc.	25	33	f	\N	IS	1	Unknown	\N
4942	(50f1,"FDMS 1.0",0a)	(50f1,"FDMS 1.0",0a)	FDMS 1.0	20721	10	f	\N	LO	1	FNC Parameters	K
4962	(0009,"SECTRA_Ident_01",01)	(0009,"SECTRA_Ident_01",01)	SECTRA_Ident_01	9	1	f	\N	SH	1	Request number	\N
4963	(0009,"SECTRA_Ident_01",02)	(0009,"SECTRA_Ident_01",02)	SECTRA_Ident_01	9	2	f	\N	SH	1	Examination number	\N
4964	(0009,"SECTRA_Ident_01",04)	(0009,"SECTRA_Ident_01",04)	SECTRA_Ident_01	9	4	f	\N	LO	1	Series Identifier	\N
4965	(0009,"SECTRA_Ident_01",05)	(0009,"SECTRA_Ident_01",05)	SECTRA_Ident_01	9	5	f	\N	LO	1	Series Order	\N
4966	(0009,"SECTRA_Ident_01",06)	(0009,"SECTRA_Ident_01",06)	SECTRA_Ident_01	9	6	f	\N	LO	1	File Name	\N
4967	(0009,"SECTRA_Ident_01",07)	(0009,"SECTRA_Ident_01",07)	SECTRA_Ident_01	9	7	f	\N	LO	1	Image Data ID	\N
4968	(0029,"SECTRA_ImageInfo_01",01)	(0029,"SECTRA_ImageInfo_01",01)	SECTRA_ImageInfo_01	41	1	f	\N	OB	1	Image info	\N
4969	(0029,"SECTRA_ImageInfo_01",02)	(0029,"SECTRA_ImageInfo_01",02)	SECTRA_ImageInfo_01	41	2	f	\N	CS	1	Marking	\N
4970	(0029,"SECTRA_ImageInfo_01",03)	(0029,"SECTRA_ImageInfo_01",03)	SECTRA_ImageInfo_01	41	3	f	\N	LO	1	No decompression	\N
4971	(0029,"SECTRA_ImageInfo_01",04)	(0029,"SECTRA_ImageInfo_01",04)	SECTRA_ImageInfo_01	41	4	f	\N	OB	1	Image info new	\N
4972	(6001,"SECTRA_OverlayInfo_01",01)	(6001,"SECTRA_OverlayInfo_01",01)	SECTRA_OverlayInfo_01	24577	1	f	\N	LO	1	Sectra Overlay	\N
4973	(0009,"BioPri",00)	(0009,"BioPri",00)	BioPri	9	0	f	\N	LO	1	Unknown	\N
4974	(0009,"BioPri",01)	(0009,"BioPri",01)	BioPri	9	1	f	\N	UN	1	Unknown	\N
4975	(0009,"BioPri",02)	(0009,"BioPri",02)	BioPri	9	2	f	\N	UN	1	Unknown	\N
4976	(0009,"BioPri",03)	(0009,"BioPri",03)	BioPri	9	3	f	\N	LO	1-n	Unknown	\N
4977	(0009,"BioPri",04)	(0009,"BioPri",04)	BioPri	9	4	f	\N	LO	1	Unknown	\N
4978	(0009,"BioPri",05)	(0009,"BioPri",05)	BioPri	9	5	f	\N	LO	1	Unknown	\N
4979	(0009,"BioPri",07)	(0009,"BioPri",07)	BioPri	9	7	f	\N	LO	1	Unknown	\N
4980	(0009,"BioPri",08)	(0009,"BioPri",08)	BioPri	9	8	f	\N	LO	1	Unknown	\N
4981	(0009,"BioPri",09)	(0009,"BioPri",09)	BioPri	9	9	f	\N	LO	1	Unknown	\N
4982	(0009,"BioPri",10)	(0009,"BioPri",10)	BioPri	9	16	f	\N	UN	1	Unknown	\N
4983	(0029,"Silhouette VRS 3.0",13)	(0029,"Silhouette VRS 3.0",13)	Silhouette VRS 3.0	41	19	f	\N	UN	1	Unknown	\N
4984	(0029,"Silhouette VRS 3.0",14)	(0029,"Silhouette VRS 3.0",14)	Silhouette VRS 3.0	41	20	f	\N	UN	1	Unknown	\N
4985	(0029,"Silhouette VRS 3.0",17)	(0029,"Silhouette VRS 3.0",17)	Silhouette VRS 3.0	41	23	f	\N	UN	1	Unknown	\N
4986	(0029,"Silhouette VRS 3.0",18)	(0029,"Silhouette VRS 3.0",18)	Silhouette VRS 3.0	41	24	f	\N	UN	1	Unknown	\N
4987	(0029,"Silhouette VRS 3.0",19)	(0029,"Silhouette VRS 3.0",19)	Silhouette VRS 3.0	41	25	f	\N	UN	1	Unknown	\N
4988	(0029,"Silhouette VRS 3.0",1a)	(0029,"Silhouette VRS 3.0",1a)	Silhouette VRS 3.0	41	26	f	\N	UN	1	Unknown	\N
4989	(0029,"Silhouette VRS 3.0",1b)	(0029,"Silhouette VRS 3.0",1b)	Silhouette VRS 3.0	41	27	f	\N	UN	1	Unknown	\N
4990	(0029,"Silhouette VRS 3.0",1c)	(0029,"Silhouette VRS 3.0",1c)	Silhouette VRS 3.0	41	28	f	\N	UN	1	Unknown	\N
4991	(0029,"Silhouette VRS 3.0",1d)	(0029,"Silhouette VRS 3.0",1d)	Silhouette VRS 3.0	41	29	f	\N	UN	1	Unknown	\N
4959	(0019,"ADAC_IMG",21)	(0019,"ADAC_IMG",21)	ADAC_IMG	25	33	f	\N	US	1	Number of ADAC Headers	X
4960	(0019,"ADAC_IMG",41)	(0019,"ADAC_IMG",41)	ADAC_IMG	25	65	f	\N	IS	1-n	ADAC Header/Image Size	X
4961	(0019,"ADAC_IMG",61)	(0019,"ADAC_IMG",61)	ADAC_IMG	25	97	f	\N	OB	1	ADAC Pegasys Headers	X
4992	(0029,"Silhouette VRS 3.0",1e)	(0029,"Silhouette VRS 3.0",1e)	Silhouette VRS 3.0	41	30	f	\N	UN	1	Unknown	\N
4993	(0029,"Silhouette VRS 3.0",27)	(0029,"Silhouette VRS 3.0",27)	Silhouette VRS 3.0	41	39	f	\N	US	1	Unknown	\N
4994	(0029,"Silhouette VRS 3.0",28)	(0029,"Silhouette VRS 3.0",28)	Silhouette VRS 3.0	41	40	f	\N	UN	1	Unknown	\N
4995	(0029,"Silhouette VRS 3.0",30)	(0029,"Silhouette VRS 3.0",30)	Silhouette VRS 3.0	41	48	f	\N	UN	1	Unknown	\N
4996	(0029,"Silhouette VRS 3.0",32)	(0029,"Silhouette VRS 3.0",32)	Silhouette VRS 3.0	41	50	f	\N	UN	1	Unknown	\N
4997	(0029,"Silhouette VRS 3.0",34)	(0029,"Silhouette VRS 3.0",34)	Silhouette VRS 3.0	41	52	f	\N	UN	1	Unknown	\N
4998	(0029,"Silhouette VRS 3.0",35)	(0029,"Silhouette VRS 3.0",35)	Silhouette VRS 3.0	41	53	f	\N	CS	1	Unknown	\N
4999	(0029,"Silhouette VRS 3.0",36)	(0029,"Silhouette VRS 3.0",36)	Silhouette VRS 3.0	41	54	f	\N	US	1	Unknown	\N
5000	(0011,"Hipaa Private Creator",01)	(0011,"Hipaa Private Creator",01)	Hipaa Private Creator	17	1	f	\N	LT	1	Encrypted Instance Creator ID	\N
5001	(0011,"Hipaa Private Creator",02)	(0011,"Hipaa Private Creator",02)	Hipaa Private Creator	17	2	f	\N	LT	1	Encrypted SOP Instance UID	\N
5002	(0011,"Hipaa Private Creator",03)	(0011,"Hipaa Private Creator",03)	Hipaa Private Creator	17	3	f	\N	LT	1	Encrypted Accession Number	\N
5003	(0011,"Hipaa Private Creator",04)	(0011,"Hipaa Private Creator",04)	Hipaa Private Creator	17	4	f	\N	LT	1	Encrypted Institution Name	\N
5004	(0011,"Hipaa Private Creator",05)	(0011,"Hipaa Private Creator",05)	Hipaa Private Creator	17	5	f	\N	LT	1	Encrypted Institution Address	\N
5005	(0011,"Hipaa Private Creator",06)	(0011,"Hipaa Private Creator",06)	Hipaa Private Creator	17	6	f	\N	LT	1	Encrypted Referring Physician's Name	\N
5006	(0011,"Hipaa Private Creator",07)	(0011,"Hipaa Private Creator",07)	Hipaa Private Creator	17	7	f	\N	LT	1	Encrypted Referring Physician's Address	\N
5007	(0011,"Hipaa Private Creator",08)	(0011,"Hipaa Private Creator",08)	Hipaa Private Creator	17	8	f	\N	LT	1	Encrypted Station Name	\N
5008	(0011,"Hipaa Private Creator",09)	(0011,"Hipaa Private Creator",09)	Hipaa Private Creator	17	9	f	\N	LT	1	Encrypted Study Description	\N
5009	(0011,"Hipaa Private Creator",10)	(0011,"Hipaa Private Creator",10)	Hipaa Private Creator	17	16	f	\N	LT	1	Encrypted Series Description	\N
5010	(0011,"Hipaa Private Creator",11)	(0011,"Hipaa Private Creator",11)	Hipaa Private Creator	17	17	f	\N	LT	1	Encrypted Institutional Department Name	\N
5011	(0011,"Hipaa Private Creator",12)	(0011,"Hipaa Private Creator",12)	Hipaa Private Creator	17	18	f	\N	LT	1	Encrypted Physicians of Record	\N
5012	(0011,"Hipaa Private Creator",13)	(0011,"Hipaa Private Creator",13)	Hipaa Private Creator	17	19	f	\N	LT	1	Encrypted Performing Physician's Name	\N
5013	(0011,"Hipaa Private Creator",14)	(0011,"Hipaa Private Creator",14)	Hipaa Private Creator	17	20	f	\N	LT	1	Encrypted Name of Physicians Reading Study	\N
5014	(0011,"Hipaa Private Creator",15)	(0011,"Hipaa Private Creator",15)	Hipaa Private Creator	17	21	f	\N	LT	1	Encrypted Operator's Name	\N
5015	(0011,"Hipaa Private Creator",16)	(0011,"Hipaa Private Creator",16)	Hipaa Private Creator	17	22	f	\N	LT	1	Encrypted Admitting Diagnoses Description	\N
5016	(0011,"Hipaa Private Creator",17)	(0011,"Hipaa Private Creator",17)	Hipaa Private Creator	17	23	f	\N	LT	1	Encrypted Referenced SOP Instance UID	\N
5017	(0011,"Hipaa Private Creator",18)	(0011,"Hipaa Private Creator",18)	Hipaa Private Creator	17	24	f	\N	LT	1	Encrypted Derivation Description	\N
5018	(0011,"Hipaa Private Creator",19)	(0011,"Hipaa Private Creator",19)	Hipaa Private Creator	17	25	f	\N	LT	1	Encrypted Patient's Name	\N
5019	(0011,"Hipaa Private Creator",20)	(0011,"Hipaa Private Creator",20)	Hipaa Private Creator	17	32	f	\N	LT	1	Encrypted Patient's ID	\N
5020	(0011,"Hipaa Private Creator",21)	(0011,"Hipaa Private Creator",21)	Hipaa Private Creator	17	33	f	\N	LT	1	Encrypted Patient's Birth Date	\N
5021	(0011,"Hipaa Private Creator",22)	(0011,"Hipaa Private Creator",22)	Hipaa Private Creator	17	34	f	\N	LT	1	Encrypted Patient's Birth Time	\N
5022	(0011,"Hipaa Private Creator",23)	(0011,"Hipaa Private Creator",23)	Hipaa Private Creator	17	35	f	\N	LT	1	Encrypted Patient's Sex	\N
5023	(0011,"Hipaa Private Creator",24)	(0011,"Hipaa Private Creator",24)	Hipaa Private Creator	17	36	f	\N	LT	1	Encrypted Other Patient IDs	\N
5024	(0011,"Hipaa Private Creator",25)	(0011,"Hipaa Private Creator",25)	Hipaa Private Creator	17	37	f	\N	LT	1	Encrypted Other Patient Names	\N
5025	(0011,"Hipaa Private Creator",26)	(0011,"Hipaa Private Creator",26)	Hipaa Private Creator	17	38	f	\N	LT	1	Encrypted Patient's Age	\N
5026	(0011,"Hipaa Private Creator",27)	(0011,"Hipaa Private Creator",27)	Hipaa Private Creator	17	39	f	\N	LT	1	Encrypted Patient's Size	\N
5027	(0011,"Hipaa Private Creator",28)	(0011,"Hipaa Private Creator",28)	Hipaa Private Creator	17	40	f	\N	LT	1	Encrypted Patient's Weight	\N
5028	(0011,"Hipaa Private Creator",29)	(0011,"Hipaa Private Creator",29)	Hipaa Private Creator	17	41	f	\N	LT	1	Encrypted Medical Record Locator	\N
5029	(0011,"Hipaa Private Creator",30)	(0011,"Hipaa Private Creator",30)	Hipaa Private Creator	17	48	f	\N	LT	1	Encrypted Ethnic Group	\N
5030	(0011,"Hipaa Private Creator",31)	(0011,"Hipaa Private Creator",31)	Hipaa Private Creator	17	49	f	\N	LT	1	Encrypted Occupation	\N
5031	(0011,"Hipaa Private Creator",32)	(0011,"Hipaa Private Creator",32)	Hipaa Private Creator	17	50	f	\N	LT	1	Encrypted Additional Patient's History	\N
5032	(0011,"Hipaa Private Creator",33)	(0011,"Hipaa Private Creator",33)	Hipaa Private Creator	17	51	f	\N	LT	1	Encrypted Patient Comments	\N
5033	(0011,"Hipaa Private Creator",34)	(0011,"Hipaa Private Creator",34)	Hipaa Private Creator	17	52	f	\N	LT	1	Encrypted Device Serial Number	\N
5034	(0011,"Hipaa Private Creator",35)	(0011,"Hipaa Private Creator",35)	Hipaa Private Creator	17	53	f	\N	LT	1	Encrypted Protocol Name	\N
5035	(0011,"Hipaa Private Creator",36)	(0011,"Hipaa Private Creator",36)	Hipaa Private Creator	17	54	f	\N	LT	1	Encrypted Study Instance UID	\N
5036	(0011,"Hipaa Private Creator",37)	(0011,"Hipaa Private Creator",37)	Hipaa Private Creator	17	55	f	\N	LT	1	Encrypted Series Instance UID	\N
5037	(0011,"Hipaa Private Creator",38)	(0011,"Hipaa Private Creator",38)	Hipaa Private Creator	17	56	f	\N	LT	1	Encrypted Study ID	\N
5038	(0011,"Hipaa Private Creator",39)	(0011,"Hipaa Private Creator",39)	Hipaa Private Creator	17	57	f	\N	LT	1	Encrypted Frame of Reference UID	\N
10980	(0119,"MRSC",1206)	(0119,"MRSC",06)	MRSC	281	6	t	12	IS	1-n	NumProcesses	K
5039	(0011,"Hipaa Private Creator",40)	(0011,"Hipaa Private Creator",40)	Hipaa Private Creator	17	64	f	\N	LT	1	Encrypted Synchronization Frame of Reference UID	\N
5040	(0011,"Hipaa Private Creator",41)	(0011,"Hipaa Private Creator",41)	Hipaa Private Creator	17	65	f	\N	LT	1	Encrypted Image Comments	\N
5041	(0011,"Hipaa Private Creator",42)	(0011,"Hipaa Private Creator",42)	Hipaa Private Creator	17	66	f	\N	LT	1	Encrypted UID	\N
5042	(0019,"LORAD Selenia",06)	(0019,"LORAD Selenia",06)	LORAD Selenia	25	6	f	\N	LO	1	Paddle ID	\N
5043	(0019,"LORAD Selenia",07)	(0019,"LORAD Selenia",07)	LORAD Selenia	25	7	f	\N	SH	1	Paddle Position	\N
5044	(0019,"LORAD Selenia",08)	(0019,"LORAD Selenia",08)	LORAD Selenia	25	8	f	\N	LO	1	Collimation Size	\N
5045	(0019,"LORAD Selenia",16)	(0019,"LORAD Selenia",16)	LORAD Selenia	25	22	f	\N	DS	1	Paddle Angle	\N
5046	(0019,"LORAD Selenia",26)	(0019,"LORAD Selenia",26)	LORAD Selenia	25	38	f	\N	LO	1	Paddle ID Description	\N
5047	(0019,"LORAD Selenia",27)	(0019,"LORAD Selenia",27)	LORAD Selenia	25	39	f	\N	SH	1	Paddle Position Description	\N
5048	(0019,"LORAD Selenia",28)	(0019,"LORAD Selenia",28)	LORAD Selenia	25	40	f	\N	LO	1	Collimation Size Description	\N
5049	(0019,"LORAD Selenia",29)	(0019,"LORAD Selenia",29)	LORAD Selenia	25	41	f	\N	LO	1	AEC User Density Scale Factor Description	\N
5050	(0019,"LORAD Selenia",30)	(0019,"LORAD Selenia",30)	LORAD Selenia	25	48	f	\N	US	1	AEC User Density Scale Factor	\N
5051	(0019,"LORAD Selenia",31)	(0019,"LORAD Selenia",31)	LORAD Selenia	25	49	f	\N	US	1	AEC System Density Scale Factor	\N
5052	(0019,"LORAD Selenia",32)	(0019,"LORAD Selenia",32)	LORAD Selenia	25	50	f	\N	US	1	AEC Calculated mAs	\N
5053	(0019,"LORAD Selenia",33)	(0019,"LORAD Selenia",33)	LORAD Selenia	25	51	f	\N	US	1	AEC Auto Pixel 1	\N
5054	(0019,"LORAD Selenia",34)	(0019,"LORAD Selenia",34)	LORAD Selenia	25	52	f	\N	US	1	AEC Auto Pixel 2	\N
5055	(0019,"LORAD Selenia",35)	(0019,"LORAD Selenia",35)	LORAD Selenia	25	53	f	\N	US	1	AEC Sensor	\N
5056	(0019,"LORAD Selenia",37)	(0019,"LORAD Selenia",37)	LORAD Selenia	25	55	f	\N	LO	1	NPT Mode	\N
5057	(0019,"LORAD Selenia",40)	(0019,"LORAD Selenia",40)	LORAD Selenia	25	64	f	\N	DS	1	Skin Edge	\N
5058	(0019,"LORAD Selenia",41)	(0019,"LORAD Selenia",41)	LORAD Selenia	25	65	f	\N	DS	1	Exposure Index	\N
5059	(0019,"LORAD Selenia",50)	(0019,"LORAD Selenia",50)	LORAD Selenia	25	80	f	\N	DS	1	Display Minimum OD	\N
5060	(0019,"LORAD Selenia",51)	(0019,"LORAD Selenia",51)	LORAD Selenia	25	81	f	\N	DS	1	Dispaly Maximum OD	\N
5061	(0019,"LORAD Selenia",52)	(0019,"LORAD Selenia",52)	LORAD Selenia	25	82	f	\N	IS	1	Display Minimum Nits	\N
5062	(0019,"LORAD Selenia",53)	(0019,"LORAD Selenia",53)	LORAD Selenia	25	83	f	\N	IS	1	Display Maximum Nits	\N
5063	(0019,"LORAD Selenia",60)	(0019,"LORAD Selenia",60)	LORAD Selenia	25	96	f	\N	LT	1	Geometry Calibration	\N
5064	(0019,"LORAD Selenia",70)	(0019,"LORAD Selenia",70)	LORAD Selenia	25	112	f	\N	LO	1	Frame of Reference ID	\N
5065	(0019,"LORAD Selenia",71)	(0019,"LORAD Selenia",71)	LORAD Selenia	25	113	f	\N	CS	1	Paired Position	\N
5066	(0019,"LORAD Selenia",80)	(0019,"LORAD Selenia",80)	LORAD Selenia	25	128	f	\N	SH	1	Detector Image Offset	\N
5067	(0019,"LORAD Selenia",90)	(0019,"LORAD Selenia",90)	LORAD Selenia	25	144	f	\N	DS	1	Conventional Tomo Angle	\N
5068	(0019,"HOLOGIC, Inc.",01)	(0019,"HOLOGIC, Inc.",01)	HOLOGIC, Inc.	25	1	f	\N	IS	1	Unknown	\N
5069	(0019,"HOLOGIC, Inc.",02)	(0019,"HOLOGIC, Inc.",02)	HOLOGIC, Inc.	25	2	f	\N	IS	1	Unknown	\N
5070	(0019,"HOLOGIC, Inc.",03)	(0019,"HOLOGIC, Inc.",03)	HOLOGIC, Inc.	25	3	f	\N	IS	1	Unknown	\N
5071	(0019,"HOLOGIC, Inc.",04)	(0019,"HOLOGIC, Inc.",04)	HOLOGIC, Inc.	25	4	f	\N	IS	1	Unknown	\N
5072	(0019,"HOLOGIC, Inc.",06)	(0019,"HOLOGIC, Inc.",06)	HOLOGIC, Inc.	25	6	f	\N	LO	1	Paddle ID	\N
5073	(0019,"HOLOGIC, Inc.",07)	(0019,"HOLOGIC, Inc.",07)	HOLOGIC, Inc.	25	7	f	\N	SH	1	Paddle Position	\N
5074	(0019,"HOLOGIC, Inc.",08)	(0019,"HOLOGIC, Inc.",08)	HOLOGIC, Inc.	25	8	f	\N	LO	1	Collimation Size	\N
5075	(0019,"HOLOGIC, Inc.",16)	(0019,"HOLOGIC, Inc.",16)	HOLOGIC, Inc.	25	22	f	\N	DS	1	Paddle Angle	\N
5076	(0019,"HOLOGIC, Inc.",25)	(0019,"HOLOGIC, Inc.",25)	HOLOGIC, Inc.	25	37	f	\N	SH	1	Unknown	\N
5077	(0019,"HOLOGIC, Inc.",26)	(0019,"HOLOGIC, Inc.",26)	HOLOGIC, Inc.	25	38	f	\N	LO	1	Paddle ID Description	\N
5078	(0019,"HOLOGIC, Inc.",27)	(0019,"HOLOGIC, Inc.",27)	HOLOGIC, Inc.	25	39	f	\N	SH	1	Paddle Position Description	\N
5079	(0019,"HOLOGIC, Inc.",28)	(0019,"HOLOGIC, Inc.",28)	HOLOGIC, Inc.	25	40	f	\N	LO	1	Collimation Size Description	\N
5080	(0019,"HOLOGIC, Inc.",29)	(0019,"HOLOGIC, Inc.",29)	HOLOGIC, Inc.	25	41	f	\N	LO	1	AEC User Density Scale Factor Description	\N
5081	(0019,"HOLOGIC, Inc.",30)	(0019,"HOLOGIC, Inc.",30)	HOLOGIC, Inc.	25	48	f	\N	US	1	AEC User Density Scale Factor	\N
5082	(0019,"HOLOGIC, Inc.",31)	(0019,"HOLOGIC, Inc.",31)	HOLOGIC, Inc.	25	49	f	\N	US	1	AEC System Density Scale Factor	\N
5083	(0019,"HOLOGIC, Inc.",32)	(0019,"HOLOGIC, Inc.",32)	HOLOGIC, Inc.	25	50	f	\N	US	1	AEC Calculated mAs	\N
5084	(0019,"HOLOGIC, Inc.",33)	(0019,"HOLOGIC, Inc.",33)	HOLOGIC, Inc.	25	51	f	\N	US	1	AEC Auto Pixel 1	\N
5085	(0019,"HOLOGIC, Inc.",34)	(0019,"HOLOGIC, Inc.",34)	HOLOGIC, Inc.	25	52	f	\N	US	1	AEC Auto Pixel 2	\N
5086	(0019,"HOLOGIC, Inc.",35)	(0019,"HOLOGIC, Inc.",35)	HOLOGIC, Inc.	25	53	f	\N	US	1	AEC Sensor	\N
5087	(0019,"HOLOGIC, Inc.",37)	(0019,"HOLOGIC, Inc.",37)	HOLOGIC, Inc.	25	55	f	\N	LO	1	NPT Mode	\N
5088	(0019,"HOLOGIC, Inc.",40)	(0019,"HOLOGIC, Inc.",40)	HOLOGIC, Inc.	25	64	f	\N	DS	1	Skin Edge	\N
5089	(0019,"HOLOGIC, Inc.",41)	(0019,"HOLOGIC, Inc.",41)	HOLOGIC, Inc.	25	65	f	\N	DS	1	Exposure Index	\N
5090	(0019,"HOLOGIC, Inc.",42)	(0019,"HOLOGIC, Inc.",42)	HOLOGIC, Inc.	25	66	f	\N	IS	1	Exposure Index Target	\N
5091	(0019,"HOLOGIC, Inc.",43)	(0019,"HOLOGIC, Inc.",43)	HOLOGIC, Inc.	25	67	f	\N	DS	1	Short Index Ratio	\N
5092	(0019,"HOLOGIC, Inc.",44)	(0019,"HOLOGIC, Inc.",44)	HOLOGIC, Inc.	25	68	f	\N	DS	1	Scout kVp	\N
5093	(0019,"HOLOGIC, Inc.",45)	(0019,"HOLOGIC, Inc.",45)	HOLOGIC, Inc.	25	69	f	\N	IS	1	Scout mA	\N
5094	(0019,"HOLOGIC, Inc.",46)	(0019,"HOLOGIC, Inc.",46)	HOLOGIC, Inc.	25	70	f	\N	IS	1	Scout mAs	\N
5095	(0019,"HOLOGIC, Inc.",50)	(0019,"HOLOGIC, Inc.",50)	HOLOGIC, Inc.	25	80	f	\N	DS	1	Display Minimum OD	\N
5096	(0019,"HOLOGIC, Inc.",51)	(0019,"HOLOGIC, Inc.",51)	HOLOGIC, Inc.	25	81	f	\N	DS	1	Dispaly Maximum OD	\N
5097	(0019,"HOLOGIC, Inc.",52)	(0019,"HOLOGIC, Inc.",52)	HOLOGIC, Inc.	25	82	f	\N	IS	1	Display Minimum Nits	\N
5098	(0019,"HOLOGIC, Inc.",53)	(0019,"HOLOGIC, Inc.",53)	HOLOGIC, Inc.	25	83	f	\N	IS	1	Display Maximum Nits	\N
5099	(0019,"HOLOGIC, Inc.",60)	(0019,"HOLOGIC, Inc.",60)	HOLOGIC, Inc.	25	96	f	\N	LT	1	Geometry Calibration	\N
5100	(0019,"HOLOGIC, Inc.",61)	(0019,"HOLOGIC, Inc.",61)	HOLOGIC, Inc.	25	97	f	\N	OB	1	3D IP Parameters	\N
5101	(0019,"HOLOGIC, Inc.",62)	(0019,"HOLOGIC, Inc.",62)	HOLOGIC, Inc.	25	98	f	\N	LT	1	2D IP Parameters	\N
5102	(0019,"HOLOGIC, Inc.",70)	(0019,"HOLOGIC, Inc.",70)	HOLOGIC, Inc.	25	112	f	\N	LO	1	Frame of Reference ID	\N
5103	(0019,"HOLOGIC, Inc.",71)	(0019,"HOLOGIC, Inc.",71)	HOLOGIC, Inc.	25	113	f	\N	CS	1	Paired Position	\N
5104	(0019,"HOLOGIC, Inc.",80)	(0019,"HOLOGIC, Inc.",80)	HOLOGIC, Inc.	25	128	f	\N	SH	1	Detector Image Offset	\N
5105	(0019,"HOLOGIC, Inc.",85)	(0019,"HOLOGIC, Inc.",85)	HOLOGIC, Inc.	25	133	f	\N	SH	1	Image Source	\N
5106	(0019,"HOLOGIC, Inc.",87)	(0019,"HOLOGIC, Inc.",87)	HOLOGIC, Inc.	25	135	f	\N	LO	1	Marker Text	\N
5107	(0019,"HOLOGIC, Inc.",88)	(0019,"HOLOGIC, Inc.",88)	HOLOGIC, Inc.	25	136	f	\N	LO	1	Marker Tech Initials	\N
5108	(0019,"HOLOGIC, Inc.",89)	(0019,"HOLOGIC, Inc.",89)	HOLOGIC, Inc.	25	137	f	\N	DS	2	Marker Location	\N
5109	(0019,"HOLOGIC, Inc.",8a)	(0019,"HOLOGIC, Inc.",8a)	HOLOGIC, Inc.	25	138	f	\N	SQ	2	Marker Sequence	\N
5110	(0019,"HOLOGIC, Inc.",90)	(0019,"HOLOGIC, Inc.",90)	HOLOGIC, Inc.	25	144	f	\N	DS	1	Conventional Tomo Angle	\N
5111	(0019,"HOLOGIC, Inc.",97)	(0019,"HOLOGIC, Inc.",97)	HOLOGIC, Inc.	25	151	f	\N	SH	1	Markers Burned Into Image	\N
5112	(0019,"HOLOGIC, Inc.",98)	(0019,"HOLOGIC, Inc.",98)	HOLOGIC, Inc.	25	152	f	\N	LO	1	Grid Line Correction	\N
5113	(7e01,"HOLOGIC, Inc.",01)	(7e01,"HOLOGIC, Inc.",01)	HOLOGIC, Inc.	32257	1	f	\N	LO	1	Codec Version	\N
5114	(7e01,"HOLOGIC, Inc.",02)	(7e01,"HOLOGIC, Inc.",02)	HOLOGIC, Inc.	32257	2	f	\N	SH	1	Codec Content Type	\N
5115	(7e01,"HOLOGIC, Inc.",10)	(7e01,"HOLOGIC, Inc.",10)	HOLOGIC, Inc.	32257	16	f	\N	SQ	1	High Resolution Data Sequence	\N
5116	(7e01,"HOLOGIC, Inc.",11)	(7e01,"HOLOGIC, Inc.",11)	HOLOGIC, Inc.	32257	17	f	\N	SQ	1	Low Resolution Data Sequence	\N
5117	(7e01,"HOLOGIC, Inc.",12)	(7e01,"HOLOGIC, Inc.",12)	HOLOGIC, Inc.	32257	18	f	\N	OB	1	Codec Content	\N
5118	(7f01,"HOLOGIC, Inc.",01)	(7f01,"HOLOGIC, Inc.",01)	HOLOGIC, Inc.	32513	1	f	\N	LO	1	Codec Version	\N
5119	(7f01,"HOLOGIC, Inc.",02)	(7f01,"HOLOGIC, Inc.",02)	HOLOGIC, Inc.	32513	2	f	\N	SH	1	Codec Content Type	\N
5120	(7f01,"HOLOGIC, Inc.",10)	(7f01,"HOLOGIC, Inc.",10)	HOLOGIC, Inc.	32513	16	f	\N	SQ	1	High Resolution Data Sequence	\N
5121	(7f01,"HOLOGIC, Inc.",11)	(7f01,"HOLOGIC, Inc.",11)	HOLOGIC, Inc.	32513	17	f	\N	SQ	1	Low Resolution Data Sequence	\N
5122	(7f01,"HOLOGIC, Inc.",12)	(7f01,"HOLOGIC, Inc.",12)	HOLOGIC, Inc.	32513	18	f	\N	OB	1	Codec Content	\N
5123	(0029,"1.2.840.113663.1",00)	(0029,"1.2.840.113663.1",00)	1.2.840.113663.1	41	0	f	\N	US	1	Unknown	\N
5124	(0029,"1.2.840.113663.1",01)	(0029,"1.2.840.113663.1",01)	1.2.840.113663.1	41	1	f	\N	US	1	Unknown	\N
5131	(0009,"MMCPrivate",50)	(0009,"MMCPrivate",50)	MMCPrivate	9	80	f	\N	CS	1	CMS Patient Position	\N
5132	(0009,"MMCPrivate",51)	(0009,"MMCPrivate",51)	MMCPrivate	9	81	f	\N	LO	1	CMI Contrast Bolus Agent	\N
5133	(0009,"MMCPrivate",52)	(0009,"MMCPrivate",52)	MMCPrivate	9	82	f	\N	LO	1	CMS institution Name	\N
5134	(0009,"MMCPrivate",53)	(0009,"MMCPrivate",53)	MMCPrivate	9	83	f	\N	LO	1	CMS Institutional Department Name	\N
5135	(0009,"MMCPrivate",54)	(0009,"MMCPrivate",54)	MMCPrivate	9	84	f	\N	LO	1	CMS Series Description	\N
5136	(0009,"MMCPrivate",55)	(0009,"MMCPrivate",55)	MMCPrivate	9	85	f	\N	LO	1	CMS Operators Name	\N
5137	(0009,"MMCPrivate",56)	(0009,"MMCPrivate",56)	MMCPrivate	9	86	f	\N	LO	1	CMS Performing Physicians Name	\N
5138	(0009,"MMCPrivate",57)	(0009,"MMCPrivate",57)	MMCPrivate	9	87	f	\N	ST	1	CMS Institution Address	\N
5139	(0009,"MMCPrivate",58)	(0009,"MMCPrivate",58)	MMCPrivate	9	88	f	\N	LO	1	CMI Image Comments	\N
5140	(0009,"MMCPrivate",59)	(0009,"MMCPrivate",59)	MMCPrivate	9	89	f	\N	LO	1	CMI Instance Creation DateTime	\N
5141	(0009,"MMCPrivate",5a)	(0009,"MMCPrivate",5a)	MMCPrivate	9	90	f	\N	LO	1	MPPS Step Status	\N
5142	(0009,"MMCPrivate",5b)	(0009,"MMCPrivate",5b)	MMCPrivate	9	91	f	\N	IS	1	Filmed Count	\N
5143	(0009,"MMCPrivate",5c)	(0009,"MMCPrivate",5c)	MMCPrivate	9	92	f	\N	LO	1	Is Allow Cascade Save	\N
5144	(0009,"MMCPrivate",5d)	(0009,"MMCPrivate",5d)	MMCPrivate	9	93	f	\N	LO	1	Is Allow Cascade Protect	\N
5145	(0009,"MMCPrivate",5e)	(0009,"MMCPrivate",5e)	MMCPrivate	9	94	f	\N	LO	1	Is Deleted	\N
5148	(0011,"MMCPrivate",03)	(0011,"MMCPrivate",03)	MMCPrivate	17	3	f	\N	IS	1	Filmed Count	\N
5149	(0011,"MMCPrivate",04)	(0011,"MMCPrivate",04)	MMCPrivate	17	4	f	\N	OB	1	Application Data	\N
5150	(0011,"MMCPrivate",05)	(0011,"MMCPrivate",05)	MMCPrivate	17	5	f	\N	LO	1	Is Allow Cascade Save	\N
5151	(0011,"MMCPrivate",06)	(0011,"MMCPrivate",06)	MMCPrivate	17	6	f	\N	LO	1	Is Allow Cascade Protect	\N
5152	(0011,"MMCPrivate",07)	(0011,"MMCPrivate",07)	MMCPrivate	17	7	f	\N	LO	1	Is Deleted	\N
5126	(0009,"MMCPrivate",02)	(0009,"MMCPrivate",02)	MMCPrivate	9	2	f	\N	LO	1	Scheduled Study DateTime	X
5127	(0009,"MMCPrivate",03)	(0009,"MMCPrivate",03)	MMCPrivate	9	3	f	\N	OB	1	Study App Data	X
5128	(0009,"MMCPrivate",48)	(0009,"MMCPrivate",48)	MMCPrivate	9	72	f	\N	LO	1	Protocol Name	K
5129	(0009,"MMCPrivate",4e)	(0009,"MMCPrivate",4e)	MMCPrivate	9	78	f	\N	LO	1	CMS Body Part Examined	K
5130	(0009,"MMCPrivate",4f)	(0009,"MMCPrivate",4f)	MMCPrivate	9	79	f	\N	LO	1	Is Protected	X
5146	(0011,"MMCPrivate",01)	(0011,"MMCPrivate",01)	MMCPrivate	17	1	f	\N	LO	1	Is Rapid Registration	X
5147	(0011,"MMCPrivate",02)	(0011,"MMCPrivate",02)	MMCPrivate	17	2	f	\N	LO	1	Is Protected	X
5153	(0019,"MMCPrivate",01)	(0019,"MMCPrivate",01)	MMCPrivate	25	1	f	\N	LO	1	Proc Type	K
5154	(0019,"MMCPrivate",02)	(0019,"MMCPrivate",02)	MMCPrivate	25	2	f	\N	LO	1	Plane	K
10981	(0119,"MRSC",1208)	(0119,"MRSC",08)	MRSC	281	8	t	12	IS	1-n	GroupExecuteOrder	K
5169	(0019,"MMCPrivate",12)	(0019,"MMCPrivate",12)	MMCPrivate	25	18	f	\N	IS	1	Image Increment	\N
5170	(0019,"MMCPrivate",13)	(0019,"MMCPrivate",13)	MMCPrivate	25	19	f	\N	LO	1	MPPS Step Status	\N
5171	(0019,"MMCPrivate",14)	(0019,"MMCPrivate",14)	MMCPrivate	25	20	f	\N	IS	1	Storage Committed Count	\N
5172	(0019,"MMCPrivate",15)	(0019,"MMCPrivate",15)	MMCPrivate	25	21	f	\N	IS	1	Archived Count	\N
5173	(0019,"MMCPrivate",16)	(0019,"MMCPrivate",16)	MMCPrivate	25	22	f	\N	IS	1	Transferred Count	\N
5174	(0019,"MMCPrivate",17)	(0019,"MMCPrivate",17)	MMCPrivate	25	23	f	\N	LO	1	Is Allow Cascade Save	\N
5175	(0019,"MMCPrivate",18)	(0019,"MMCPrivate",18)	MMCPrivate	25	24	f	\N	LO	1	Is Allow Cascade Protect	\N
5176	(0019,"MMCPrivate",19)	(0019,"MMCPrivate",19)	MMCPrivate	25	25	f	\N	LO	1	Is Deleted	\N
5177	(0019,"MMCPrivate",1a)	(0019,"MMCPrivate",1a)	MMCPrivate	25	26	f	\N	UI	1	Characterized Image Instance UID	\N
5178	(0019,"MMCPrivate",1b)	(0019,"MMCPrivate",1b)	MMCPrivate	25	27	f	\N	IS	1	Characterized Image Count	\N
5179	(0019,"MMCPrivate",1c)	(0019,"MMCPrivate",1c)	MMCPrivate	25	28	f	\N	LO	1	Internal Window Width	\N
5180	(0019,"MMCPrivate",1d)	(0019,"MMCPrivate",1d)	MMCPrivate	25	29	f	\N	LO	1	Internal Window Level	\N
5181	(0019,"MMCPrivate",1e)	(0019,"MMCPrivate",1e)	MMCPrivate	25	30	f	\N	LO	1	Unknown	\N
5158	(0019,"MMCPrivate",07)	(0019,"MMCPrivate",07)	MMCPrivate	25	7	f	\N	LO	1	Image Contrast Bolus Agent	K
5159	(0019,"MMCPrivate",08)	(0019,"MMCPrivate",08)	MMCPrivate	25	8	f	\N	DS	1	Image Slice Thickness	K
5161	(0019,"MMCPrivate",0a)	(0019,"MMCPrivate",0a)	MMCPrivate	25	10	f	\N	LO	1	Image Echo Time	K
5162	(0019,"MMCPrivate",0b)	(0019,"MMCPrivate",0b)	MMCPrivate	25	11	f	\N	DS	1	Image Repetition Time	K
5163	(0019,"MMCPrivate",0c)	(0019,"MMCPrivate",0c)	MMCPrivate	25	12	f	\N	LO	1	Sequence Type	K
5164	(0019,"MMCPrivate",0d)	(0019,"MMCPrivate",0d)	MMCPrivate	25	13	f	\N	LO	1	Task UID	X
5165	(0019,"MMCPrivate",0e)	(0019,"MMCPrivate",0e)	MMCPrivate	25	14	f	\N	OB	1	Series App Data	X
5166	(0019,"MMCPrivate",0f)	(0019,"MMCPrivate",0f)	MMCPrivate	25	15	f	\N	IS	1	Multi Slice Number	K
5167	(0019,"MMCPrivate",10)	(0019,"MMCPrivate",10)	MMCPrivate	25	16	f	\N	LO	1	Image Scan Time	K
5168	(0019,"MMCPrivate",11)	(0019,"MMCPrivate",11)	MMCPrivate	25	17	f	\N	LO	1	Is Protected	K
5182	(0029,"MMCPrivate",01)	(0029,"MMCPrivate",01)	MMCPrivate	41	1	f	\N	IS	1	Slice Number	K
5183	(0029,"MMCPrivate",02)	(0029,"MMCPrivate",02)	MMCPrivate	41	2	f	\N	IS	1	Phase Number	K
5184	(0029,"MMCPrivate",03)	(0029,"MMCPrivate",03)	MMCPrivate	41	3	f	\N	LO	1	Proc Type	K
5185	(0029,"MMCPrivate",04)	(0029,"MMCPrivate",04)	MMCPrivate	41	4	f	\N	LO	1	Stopwatch Time	K
5186	(0029,"MMCPrivate",05)	(0029,"MMCPrivate",05)	MMCPrivate	41	5	f	\N	LO	1	Plane	K
5187	(0029,"MMCPrivate",06)	(0029,"MMCPrivate",06)	MMCPrivate	41	6	f	\N	LO	1	Scan Time	K
5188	(0029,"MMCPrivate",08)	(0029,"MMCPrivate",08)	MMCPrivate	41	8	f	\N	LO	1	Dual Slice Flag	K
5189	(0029,"MMCPrivate",09)	(0029,"MMCPrivate",09)	MMCPrivate	41	9	f	\N	LO	1	SSP Ratio	K
5190	(0029,"MMCPrivate",0a)	(0029,"MMCPrivate",0a)	MMCPrivate	41	10	f	\N	LO	1	Gating Signal Source	K
5191	(0029,"MMCPrivate",0b)	(0029,"MMCPrivate",0b)	MMCPrivate	41	11	f	\N	LO	1	Rephase	K
5192	(0029,"MMCPrivate",0c)	(0029,"MMCPrivate",0c)	MMCPrivate	41	12	f	\N	LO	1	Half Echo	K
5193	(0029,"MMCPrivate",0d)	(0029,"MMCPrivate",0d)	MMCPrivate	41	13	f	\N	LO	1	Rect FOV Ratio	K
5194	(0029,"MMCPrivate",0e)	(0029,"MMCPrivate",0e)	MMCPrivate	41	14	f	\N	LO	1	Half Scan	K
5195	(0029,"MMCPrivate",0f)	(0029,"MMCPrivate",0f)	MMCPrivate	41	15	f	\N	LO	1	Num Shots	K
5196	(0029,"MMCPrivate",10)	(0029,"MMCPrivate",10)	MMCPrivate	41	16	f	\N	LO	1	Contrast Agent	K
5198	(0029,"MMCPrivate",12)	(0029,"MMCPrivate",12)	MMCPrivate	41	18	f	\N	LO	1	Num Echo Shift	K
5199	(0029,"MMCPrivate",13)	(0029,"MMCPrivate",13)	MMCPrivate	41	19	f	\N	LO	1	Fat Sat	K
5200	(0029,"MMCPrivate",14)	(0029,"MMCPrivate",14)	MMCPrivate	41	20	f	\N	LO	1	MTC	K
5201	(0029,"MMCPrivate",15)	(0029,"MMCPrivate",15)	MMCPrivate	41	21	f	\N	LO	1	Num Pre Sat	K
5202	(0029,"MMCPrivate",16)	(0029,"MMCPrivate",16)	MMCPrivate	41	22	f	\N	LO	1	Target Velocity	K
5203	(0029,"MMCPrivate",17)	(0029,"MMCPrivate",17)	MMCPrivate	41	23	f	\N	LO	1	VENC Axis	K
5204	(0029,"MMCPrivate",18)	(0029,"MMCPrivate",18)	MMCPrivate	41	24	f	\N	LO	1	Num VENC Direction	K
5205	(0029,"MMCPrivate",1c)	(0029,"MMCPrivate",1c)	MMCPrivate	41	28	f	\N	LO	1	Is Scalable Window Level	K
5206	(0029,"MMCPrivate",1d)	(0029,"MMCPrivate",1d)	MMCPrivate	41	29	f	\N	LO	1	Three D Setting Line Angle	K
5207	(0029,"MMCPrivate",1e)	(0029,"MMCPrivate",1e)	MMCPrivate	41	30	f	\N	LO	1	MPG Total Axis	K
5208	(0029,"MMCPrivate",1f)	(0029,"MMCPrivate",1f)	MMCPrivate	41	31	f	\N	LO	1	MPG Axis Number	K
5209	(0029,"MMCPrivate",20)	(0029,"MMCPrivate",20)	MMCPrivate	41	32	f	\N	IS	1	Multi Echo Number	K
5210	(0029,"MMCPrivate",21)	(0029,"MMCPrivate",21)	MMCPrivate	41	33	f	\N	DS	1	Navi Average Gate Width	K
5211	(0029,"MMCPrivate",22)	(0029,"MMCPrivate",22)	MMCPrivate	41	34	f	\N	ST	1	Shim Compensate Value	K
5212	(0029,"MMCPrivate",23)	(0029,"MMCPrivate",23)	MMCPrivate	41	35	f	\N	LO	1	GC Offset	K
5213	(0029,"MMCPrivate",24)	(0029,"MMCPrivate",24)	MMCPrivate	41	36	f	\N	DS	1	Navi Max Gate Width	K
5214	(0029,"MMCPrivate",25)	(0029,"MMCPrivate",25)	MMCPrivate	41	37	f	\N	DS	1	Navi Min Gate Width	K
5215	(0029,"MMCPrivate",26)	(0029,"MMCPrivate",26)	MMCPrivate	41	38	f	\N	DS	1	Navi Max Gate Position	K
5216	(0029,"MMCPrivate",27)	(0029,"MMCPrivate",27)	MMCPrivate	41	39	f	\N	DS	1	Navi Min Gate Position	K
5217	(0029,"MMCPrivate",28)	(0029,"MMCPrivate",28)	MMCPrivate	41	40	f	\N	DS	1	Time Duration	K
5219	(0029,"MMCPrivate",2a)	(0029,"MMCPrivate",2a)	MMCPrivate	41	42	f	\N	DS	1	Navi Initial Gate Width	K
10982	(0119,"MRSC",120a)	(0119,"MRSC",0a)	MRSC	281	10	t	12	IS	1	NumberTransforms	K
5221	(0029,"MMCPrivate",2c)	(0029,"MMCPrivate",2c)	MMCPrivate	41	44	f	\N	DS	1	Navi Initial Gate Position	K
5223	(0029,"MMCPrivate",2e)	(0029,"MMCPrivate",2e)	MMCPrivate	41	46	f	\N	DS	1	Navi Average Gate Position	K
5224	(0029,"MMCPrivate",2f)	(0029,"MMCPrivate",2f)	MMCPrivate	41	47	f	\N	OB	1	Image App Data	X
5225	(0029,"MMCPrivate",30)	(0029,"MMCPrivate",30)	MMCPrivate	41	48	f	\N	FD	1	Diffusion BValue	K
5226	(0029,"MMCPrivate",31)	(0029,"MMCPrivate",31)	MMCPrivate	41	49	f	\N	SQ	1	Shared Functional Groups Sequence	K
5227	(0029,"MMCPrivate",32)	(0029,"MMCPrivate",32)	MMCPrivate	41	50	f	\N	SQ	1	Per Frame Functional Groups Sequence	K
5228	(0029,"MMCPrivate",33)	(0029,"MMCPrivate",33)	MMCPrivate	41	51	f	\N	DS	1	Lossy Image Compression Ratio	K
5229	(0029,"MMCPrivate",34)	(0029,"MMCPrivate",34)	MMCPrivate	41	52	f	\N	UI	1	Instance Creator UID	R
5230	(0029,"MMCPrivate",35)	(0029,"MMCPrivate",35)	MMCPrivate	41	53	f	\N	UI	1	Related General SOPClass UID	K
5231	(0029,"MMCPrivate",36)	(0029,"MMCPrivate",36)	MMCPrivate	41	54	f	\N	UI	1	Original Specialized SOPClass UID	K
5232	(0029,"MMCPrivate",37)	(0029,"MMCPrivate",37)	MMCPrivate	41	55	f	\N	SH	1	Timezone Offset From UTC	X
5233	(0029,"MMCPrivate",38)	(0029,"MMCPrivate",38)	MMCPrivate	41	56	f	\N	CS	1	SOPInstance Status	X
5234	(0029,"MMCPrivate",39)	(0029,"MMCPrivate",39)	MMCPrivate	41	57	f	\N	DT	1	SOPAuthorization Dateand Time	X
5235	(0029,"MMCPrivate",3a)	(0029,"MMCPrivate",3a)	MMCPrivate	41	58	f	\N	LT	1	SOPAuthorization Comment	X
5236	(0029,"MMCPrivate",3b)	(0029,"MMCPrivate",3b)	MMCPrivate	41	59	f	\N	LO	1	Authorization Equipment Certification Number	X
5237	(0029,"MMCPrivate",3c)	(0029,"MMCPrivate",3c)	MMCPrivate	41	60	f	\N	UL	1	Concatenation Frame Offset Number	K
5238	(0029,"MMCPrivate",3d)	(0029,"MMCPrivate",3d)	MMCPrivate	41	61	f	\N	US	1	Representative Frame Number	K
5239	(0029,"MMCPrivate",3e)	(0029,"MMCPrivate",3e)	MMCPrivate	41	62	f	\N	UI	1	Concatenation UID	R
5240	(0029,"MMCPrivate",3f)	(0029,"MMCPrivate",3f)	MMCPrivate	41	63	f	\N	US	1	In Concatenation Number	K
5241	(0029,"MMCPrivate",40)	(0029,"MMCPrivate",40)	MMCPrivate	41	64	f	\N	CS	1	Cardiac Synchronization Technique	K
5242	(0029,"MMCPrivate",41)	(0029,"MMCPrivate",41)	MMCPrivate	41	65	f	\N	CS	1	Cardiac Signal Source	K
5243	(0029,"MMCPrivate",42)	(0029,"MMCPrivate",42)	MMCPrivate	41	66	f	\N	FD	1	Cardiac RRInterval Specified	K
5244	(0029,"MMCPrivate",43)	(0029,"MMCPrivate",43)	MMCPrivate	41	67	f	\N	CS	1	Cardiac Beat Rejection Technique	K
5245	(0029,"MMCPrivate",44)	(0029,"MMCPrivate",44)	MMCPrivate	41	68	f	\N	IS	1	Low RR Value	K
5246	(0029,"MMCPrivate",45)	(0029,"MMCPrivate",45)	MMCPrivate	41	69	f	\N	IS	1	High RR Value	K
5247	(0029,"MMCPrivate",46)	(0029,"MMCPrivate",46)	MMCPrivate	41	70	f	\N	IS	1	Intervals Acquired	K
5248	(0029,"MMCPrivate",47)	(0029,"MMCPrivate",47)	MMCPrivate	41	71	f	\N	IS	1	Intervals Rejected	K
5250	(0029,"MMCPrivate",49)	(0029,"MMCPrivate",49)	MMCPrivate	41	73	f	\N	CS	1	Respiratory Signal Source	K
5251	(0029,"MMCPrivate",4a)	(0029,"MMCPrivate",4a)	MMCPrivate	41	74	f	\N	CS	1	Bulk Motion Compensation Technique	K
5252	(0029,"MMCPrivate",4b)	(0029,"MMCPrivate",4b)	MMCPrivate	41	75	f	\N	CS	1	Bulk Motion Signal Source	K
5253	(0029,"MMCPrivate",4c)	(0029,"MMCPrivate",4c)	MMCPrivate	41	76	f	\N	CS	1	Pixel Presentation	K
5254	(0029,"MMCPrivate",4d)	(0029,"MMCPrivate",4d)	MMCPrivate	41	77	f	\N	CS	1	Volumetric Properties	K
5255	(0029,"MMCPrivate",4e)	(0029,"MMCPrivate",4e)	MMCPrivate	41	78	f	\N	CS	1	Volume Based Calculation Technique	K
5256	(0029,"MMCPrivate",4f)	(0029,"MMCPrivate",4f)	MMCPrivate	41	79	f	\N	ST	1	Acquisition Context Description	X
5257	(0029,"MMCPrivate",50)	(0029,"MMCPrivate",50)	MMCPrivate	41	80	f	\N	SQ	1	Unknown	K
5258	(0029,"MMCPrivate",51)	(0029,"MMCPrivate",51)	MMCPrivate	41	81	f	\N	LO	1	LUTDescriptor	K
5259	(0029,"MMCPrivate",52)	(0029,"MMCPrivate",52)	MMCPrivate	41	82	f	\N	LO	1	LUTExplanation	K
5260	(0029,"MMCPrivate",53)	(0029,"MMCPrivate",53)	MMCPrivate	41	83	f	\N	LO	1	LUTData	K
5261	(0029,"MMCPrivate",54)	(0029,"MMCPrivate",54)	MMCPrivate	41	84	f	\N	CS	1	Presentation LUT Shape	K
5262	(0029,"MMCPrivate",55)	(0029,"MMCPrivate",55)	MMCPrivate	41	85	f	\N	SQ	1	Frame Anatomy Sequence	K
5263	(0029,"MMCPrivate",56)	(0029,"MMCPrivate",56)	MMCPrivate	41	86	f	\N	CS	1	Frame Laterality	K
5264	(0029,"MMCPrivate",57)	(0029,"MMCPrivate",57)	MMCPrivate	41	87	f	\N	SQ	1	Anatomic Region Sequence	K
5265	(0029,"MMCPrivate",58)	(0029,"MMCPrivate",58)	MMCPrivate	41	88	f	\N	SH	1	Anatomic Region Code Value	K
5266	(0029,"MMCPrivate",59)	(0029,"MMCPrivate",59)	MMCPrivate	41	89	f	\N	SH	1	Anatomic Region Coding Scheme Designator	K
5267	(0029,"MMCPrivate",5a)	(0029,"MMCPrivate",5a)	MMCPrivate	41	90	f	\N	SH	1	Anatomic Region Coding Scheme Version	K
5268	(0029,"MMCPrivate",5b)	(0029,"MMCPrivate",5b)	MMCPrivate	41	91	f	\N	LO	1	Anatomic Region Code Meaning	K
5269	(0029,"MMCPrivate",5c)	(0029,"MMCPrivate",5c)	MMCPrivate	41	92	f	\N	SQ	1	Pixel Value Transformation Sequence	K
5270	(0029,"MMCPrivate",5d)	(0029,"MMCPrivate",5d)	MMCPrivate	41	93	f	\N	LO	1	Rescale Type	K
5271	(0029,"MMCPrivate",5e)	(0029,"MMCPrivate",5e)	MMCPrivate	41	94	f	\N	SQ	1	Cardiac Synchronization Sequence	K
5272	(0029,"MMCPrivate",5f)	(0029,"MMCPrivate",5f)	MMCPrivate	41	95	f	\N	FD	1	Trigger Delay Time	K
5273	(0029,"MMCPrivate",60)	(0029,"MMCPrivate",60)	MMCPrivate	41	96	f	\N	SQ	1	Frame VOILUTSequence	K
5275	(0029,"MMCPrivate",62)	(0029,"MMCPrivate",62)	MMCPrivate	41	98	f	\N	CS	1	Unknown	K
5276	(0029,"MMCPrivate",63)	(0029,"MMCPrivate",63)	MMCPrivate	41	99	f	\N	SQ	1	MRModifier Sequence	K
5277	(0029,"MMCPrivate",64)	(0029,"MMCPrivate",64)	MMCPrivate	41	100	f	\N	CS	1	Parallel Acquisition Technique	K
5278	(0029,"MMCPrivate",65)	(0029,"MMCPrivate",65)	MMCPrivate	41	101	f	\N	FD	1	Parallel Reduction Factor Sec In	K
10983	(0119,"MRSC",120b)	(0119,"MRSC",0b)	MRSC	281	11	t	12	IS	1-n	NumberProcesses	K
5280	(0029,"MMCPrivate",67)	(0029,"MMCPrivate",67)	MMCPrivate	41	103	f	\N	CS	1	Flow Compensation	K
5281	(0029,"MMCPrivate",68)	(0029,"MMCPrivate",68)	MMCPrivate	41	104	f	\N	CS	1	Flow Compensation Direction	K
5282	(0029,"MMCPrivate",69)	(0029,"MMCPrivate",69)	MMCPrivate	41	105	f	\N	CS	1	Spatial PreSaturation	K
5284	(0029,"MMCPrivate",6b)	(0029,"MMCPrivate",6b)	MMCPrivate	41	107	f	\N	CS	1	Partial Fourier Direction	K
5285	(0029,"MMCPrivate",70)	(0029,"MMCPrivate",70)	MMCPrivate	41	112	f	\N	SQ	1	MR Receive Coil Sequence	K
5286	(0029,"MMCPrivate",71)	(0029,"MMCPrivate",71)	MMCPrivate	41	113	f	\N	LO	1	Receive Coil Manufacturer Name	K
5287	(0029,"MMCPrivate",72)	(0029,"MMCPrivate",72)	MMCPrivate	41	114	f	\N	CS	1	Receive Coil Type	K
5288	(0029,"MMCPrivate",73)	(0029,"MMCPrivate",73)	MMCPrivate	41	115	f	\N	CS	1	Quadrature Receive Coil	K
5289	(0029,"MMCPrivate",74)	(0029,"MMCPrivate",74)	MMCPrivate	41	116	f	\N	LO	1	Multi Coil Configuration	K
5290	(0029,"MMCPrivate",75)	(0029,"MMCPrivate",75)	MMCPrivate	41	117	f	\N	CS	1	Complex Image Component	K
5291	(0029,"MMCPrivate",76)	(0029,"MMCPrivate",76)	MMCPrivate	41	118	f	\N	SH	1	Pulse Sequence Name	K
5292	(0029,"MMCPrivate",77)	(0029,"MMCPrivate",77)	MMCPrivate	41	119	f	\N	CS	1	Echo Pulse Sequence	K
5293	(0029,"MMCPrivate",78)	(0029,"MMCPrivate",78)	MMCPrivate	41	120	f	\N	CS	1	Multiple Spin Echo	K
5294	(0029,"MMCPrivate",79)	(0029,"MMCPrivate",79)	MMCPrivate	41	121	f	\N	CS	1	Multi Planar Excitation	K
5295	(0029,"MMCPrivate",7a)	(0029,"MMCPrivate",7a)	MMCPrivate	41	122	f	\N	CS	1	Phase Contrast	K
5296	(0029,"MMCPrivate",7b)	(0029,"MMCPrivate",7b)	MMCPrivate	41	123	f	\N	CS	1	Time of Flight Contrast	K
5297	(0029,"MMCPrivate",7c)	(0029,"MMCPrivate",7c)	MMCPrivate	41	124	f	\N	CS	1	Steady State Pulse Sequence	K
5298	(0029,"MMCPrivate",7d)	(0029,"MMCPrivate",7d)	MMCPrivate	41	125	f	\N	CS	1	Echo Planar Pulse Sequence	K
5299	(0029,"MMCPrivate",7e)	(0029,"MMCPrivate",7e)	MMCPrivate	41	126	f	\N	CS	1	Spectrally Selected Suppression	K
5300	(0029,"MMCPrivate",7f)	(0029,"MMCPrivate",7f)	MMCPrivate	41	127	f	\N	CS	1	Oversampling Phase	K
5301	(0029,"MMCPrivate",80)	(0029,"MMCPrivate",80)	MMCPrivate	41	128	f	\N	CS	1	Segmented KSpace Traversal	K
5302	(0029,"MMCPrivate",81)	(0029,"MMCPrivate",81)	MMCPrivate	41	129	f	\N	CS	1	Coverage of KSpace	K
5303	(0029,"MMCPrivate",82)	(0029,"MMCPrivate",82)	MMCPrivate	41	130	f	\N	SQ	1	MR Timing and Related Parameters Sequence	K
5304	(0029,"MMCPrivate",83)	(0029,"MMCPrivate",83)	MMCPrivate	41	131	f	\N	US	1	RF Echo Train Length	K
5305	(0029,"MMCPrivate",84)	(0029,"MMCPrivate",84)	MMCPrivate	41	132	f	\N	US	1	Gradient Echo Train Length	K
5306	(0029,"MMCPrivate",85)	(0029,"MMCPrivate",85)	MMCPrivate	41	133	f	\N	CS	1	Gradient Output Type	K
5307	(0029,"MMCPrivate",86)	(0029,"MMCPrivate",86)	MMCPrivate	41	134	f	\N	FD	1	Gradient Output	K
5308	(0029,"MMCPrivate",87)	(0029,"MMCPrivate",87)	MMCPrivate	41	135	f	\N	SQ	1	MRFOVGeometry Sequence	K
5310	(0029,"MMCPrivate",89)	(0029,"MMCPrivate",89)	MMCPrivate	41	137	f	\N	US	1	MRAcquisition Phase Encoding Steps In Plane	K
5311	(0029,"MMCPrivate",8a)	(0029,"MMCPrivate",8a)	MMCPrivate	41	138	f	\N	US	1	MRAcquisitionPhase Encoding Steps Out of Plane	K
5312	(0029,"MMCPrivate",8b)	(0029,"MMCPrivate",8b)	MMCPrivate	41	139	f	\N	SQ	1	MR Transmit Coil Sequence	K
5313	(0029,"MMCPrivate",8c)	(0029,"MMCPrivate",8c)	MMCPrivate	41	140	f	\N	SH	1	Transmit Coil Name	K
5314	(0029,"MMCPrivate",8d)	(0029,"MMCPrivate",8d)	MMCPrivate	41	141	f	\N	LO	1	Transmit Coil Manufacturer Name	K
5315	(0029,"MMCPrivate",8e)	(0029,"MMCPrivate",8e)	MMCPrivate	41	142	f	\N	CS	1	Transmit Coil Type	K
5316	(0029,"MMCPrivate",8f)	(0029,"MMCPrivate",8f)	MMCPrivate	41	143	f	\N	SQ	1	MR Echo Sequence	K
5317	(0029,"MMCPrivate",90)	(0029,"MMCPrivate",90)	MMCPrivate	41	144	f	\N	FD	1	Effective Echo Time	K
5318	(0029,"MMCPrivate",91)	(0029,"MMCPrivate",91)	MMCPrivate	41	145	f	\N	SQ	1	MR Metabolite Map Sequence	K
5319	(0029,"MMCPrivate",92)	(0029,"MMCPrivate",92)	MMCPrivate	41	146	f	\N	ST	1	Metabolite Map Description	K
5320	(0029,"MMCPrivate",93)	(0029,"MMCPrivate",93)	MMCPrivate	41	147	f	\N	SQ	1	Metabolite Map Code Sequence	K
5321	(0029,"MMCPrivate",94)	(0029,"MMCPrivate",94)	MMCPrivate	41	148	f	\N	SH	1	Metabolite Map Code Value	K
5322	(0029,"MMCPrivate",95)	(0029,"MMCPrivate",95)	MMCPrivate	41	149	f	\N	SH	1	Metabolite Map Coding Scheme Designator	K
5323	(0029,"MMCPrivate",96)	(0029,"MMCPrivate",96)	MMCPrivate	41	150	f	\N	SH	1	Metabolite Map Coding Scheme Version	K
5324	(0029,"MMCPrivate",97)	(0029,"MMCPrivate",97)	MMCPrivate	41	151	f	\N	LO	1	Metabolite Map Code Meaning	K
5325	(0029,"MMCPrivate",98)	(0029,"MMCPrivate",98)	MMCPrivate	41	152	f	\N	SQ	1	MR Imaging Modifier Sequence	K
5326	(0029,"MMCPrivate",99)	(0029,"MMCPrivate",99)	MMCPrivate	41	153	f	\N	CS	1	Magnetization Transfer	K
5327	(0029,"MMCPrivate",9a)	(0029,"MMCPrivate",9a)	MMCPrivate	41	154	f	\N	CS	1	Blood Signal Nulling	K
5328	(0029,"MMCPrivate",9b)	(0029,"MMCPrivate",9b)	MMCPrivate	41	155	f	\N	CS	1	Tagging	K
5329	(0029,"MMCPrivate",9c)	(0029,"MMCPrivate",9c)	MMCPrivate	41	156	f	\N	FD	1	Tag Spacing First Dimension	K
5330	(0029,"MMCPrivate",9d)	(0029,"MMCPrivate",9d)	MMCPrivate	41	157	f	\N	FD	1	Tag Spacing Second Dimension	K
5331	(0029,"MMCPrivate",9e)	(0029,"MMCPrivate",9e)	MMCPrivate	41	158	f	\N	FD	1	Tag Angle First Axis	K
5332	(0029,"MMCPrivate",9f)	(0029,"MMCPrivate",9f)	MMCPrivate	41	159	f	\N	SS	1	Tag Angle Second Axis	K
5333	(0029,"MMCPrivate",a0)	(0029,"MMCPrivate",a0)	MMCPrivate	41	160	f	\N	FD	1	Tag Thickness	K
5334	(0029,"MMCPrivate",a1)	(0029,"MMCPrivate",a1)	MMCPrivate	41	161	f	\N	FD	1	Tagging Delay	K
5336	(0029,"MMCPrivate",a3)	(0029,"MMCPrivate",a3)	MMCPrivate	41	163	f	\N	DS	1	Pixel Bandwidth	K
5337	(0029,"MMCPrivate",a4)	(0029,"MMCPrivate",a4)	MMCPrivate	41	164	f	\N	SQ	1	MRVelocity Encoding Sequence	K
10984	(0119,"MRSC",1211)	(0119,"MRSC",11)	MRSC	281	17	t	12	IS	1-n	InvertImage	K
5346	(0029,"MMCPrivate",ad)	(0029,"MMCPrivate",ad)	MMCPrivate	41	173	f	\N	IS	1	Filmed Count	\N
5347	(0029,"MMCPrivate",ae)	(0029,"MMCPrivate",ae)	MMCPrivate	41	174	f	\N	LO	1	Is Transferred	\N
5348	(0029,"MMCPrivate",af)	(0029,"MMCPrivate",af)	MMCPrivate	41	175	f	\N	LO	1	Is Archived	\N
5349	(0029,"MMCPrivate",b0)	(0029,"MMCPrivate",b0)	MMCPrivate	41	176	f	\N	LO	1	MPPS Step Status	\N
5350	(0029,"MMCPrivate",b1)	(0029,"MMCPrivate",b1)	MMCPrivate	41	177	f	\N	LO	1	Commitment Status	\N
5351	(0029,"MMCPrivate",b2)	(0029,"MMCPrivate",b2)	MMCPrivate	41	178	f	\N	LO	1	Is Storage Committed	\N
5352	(0029,"MMCPrivate",b3)	(0029,"MMCPrivate",b3)	MMCPrivate	41	179	f	\N	LO	1	Is Dicom	\N
5353	(0029,"MMCPrivate",b4)	(0029,"MMCPrivate",b4)	MMCPrivate	41	180	f	\N	LO	1	Is Allow Cascade Save	\N
5354	(0029,"MMCPrivate",b5)	(0029,"MMCPrivate",b5)	MMCPrivate	41	181	f	\N	LO	1	Is Allow Cascade Protect	\N
5355	(0029,"MMCPrivate",b6)	(0029,"MMCPrivate",b6)	MMCPrivate	41	182	f	\N	LO	1	Is Deleted	\N
5356	(0029,"MMCPrivate",b7)	(0029,"MMCPrivate",b7)	MMCPrivate	41	183	f	\N	OB	1	Application Data	\N
5357	(0029,"MMCPrivate",b8)	(0029,"MMCPrivate",b8)	MMCPrivate	41	184	f	\N	LO	1	Is Allow Cascade Save	\N
5358	(0029,"MMCPrivate",b9)	(0029,"MMCPrivate",b9)	MMCPrivate	41	185	f	\N	LO	1	Is Allow Cascade Protect	\N
5359	(0029,"MMCPrivate",ba)	(0029,"MMCPrivate",ba)	MMCPrivate	41	186	f	\N	LO	1	Is Deleted	\N
5360	(0029,"MMCPrivate",bb)	(0029,"MMCPrivate",bb)	MMCPrivate	41	187	f	\N	IS	1	VOI 1	\N
5361	(0029,"MMCPrivate",bc)	(0029,"MMCPrivate",bc)	MMCPrivate	41	188	f	\N	IS	1	VOI 2	\N
5365	(0029,"MMCPrivate",c0)	(0029,"MMCPrivate",c0)	MMCPrivate	41	192	f	\N	FD	1	Selective IR Column	\N
5376	(0019,"MeVis BreastCare",01)	(0019,"MeVis BreastCare",01)	MeVis BreastCare	25	1	f	\N	LO	1	Annotation Version	\N
5377	(0071,"MeVis BreastCare",01)	(0071,"MeVis BreastCare",01)	MeVis BreastCare	113	1	f	\N	LO	1	XML Formatted Text Value	\N
5378	(0065,"Viewing Protocol",93)	(0065,"Viewing Protocol",93)	Viewing Protocol	101	147	f	\N	CS	1	Unknown	\N
5379	(1455,"Mortara_Inc",00)	(1455,"Mortara_Inc",00)	Mortara_Inc	5205	0	f	\N	OW	1	ELI Interpretation Vector	\N
5380	(1455,"Mortara_Inc",01)	(1455,"Mortara_Inc",01)	Mortara_Inc	5205	1	f	\N	UN	1	Custom ID	\N
5381	(1455,"Mortara_Inc",02)	(1455,"Mortara_Inc",02)	Mortara_Inc	5205	2	f	\N	UT	1	Race	\N
5382	(1455,"Mortara_Inc",03)	(1455,"Mortara_Inc",03)	Mortara_Inc	5205	3	f	\N	UT	1	Social Security Number	\N
5383	(1455,"Mortara_Inc",04)	(1455,"Mortara_Inc",04)	Mortara_Inc	5205	4	f	\N	UT	1	Attending Physician	\N
5384	(1455,"Mortara_Inc",05)	(1455,"Mortara_Inc",05)	Mortara_Inc	5205	5	f	\N	UT	1	Procedural Diagnosis	\N
5385	(1455,"Mortara_Inc",06)	(1455,"Mortara_Inc",06)	Mortara_Inc	5205	6	f	\N	UT	1	Note 1	\N
5386	(1455,"Mortara_Inc",07)	(1455,"Mortara_Inc",07)	Mortara_Inc	5205	7	f	\N	UT	1	Note 2	\N
5387	(1455,"Mortara_Inc",08)	(1455,"Mortara_Inc",08)	Mortara_Inc	5205	8	f	\N	LO	1	Order Request Number	\N
5388	(1455,"Mortara_Inc",10)	(1455,"Mortara_Inc",10)	Mortara_Inc	5205	16	f	\N	LO	1	Manufacturer Name	\N
5389	(0029,"SEGAMI_HEADER",31)	(0029,"SEGAMI_HEADER",31)	SEGAMI_HEADER	41	49	f	\N	CS	1	Unknown	\N
5390	(0029,"SEGAMI_HEADER",32)	(0029,"SEGAMI_HEADER",32)	SEGAMI_HEADER	41	50	f	\N	OW	1	Unknown	\N
5391	(0031,"SEGAMI MIML",98)	(0031,"SEGAMI MIML",98)	SEGAMI MIML	49	152	f	\N	OW	1	Unknown	\N
5392	(0033,"SEGAMI__PAGE",97)	(0033,"SEGAMI__PAGE",97)	SEGAMI__PAGE	51	151	f	\N	IS	1	Unknown	\N
5393	(0033,"SEGAMI__PAGE",98)	(0033,"SEGAMI__PAGE",98)	SEGAMI__PAGE	51	152	f	\N	OW	1	Unknown	\N
5394	(0035,"SEGAMI__MEMO",97)	(0035,"SEGAMI__MEMO",97)	SEGAMI__MEMO	53	151	f	\N	SH	1	Unknown	\N
5395	(0035,"SEGAMI__MEMO",98)	(0035,"SEGAMI__MEMO",98)	SEGAMI__MEMO	53	152	f	\N	LT	1	Unknown	\N
5396	(5473,"MedIns HP Extensions",03)	(5473,"MedIns HP Extensions",03)	MedIns HP Extensions	21619	3	f	\N	LO	1	Unknown	\N
5397	(0029,"MEDIFACE",01)	(0029,"MEDIFACE",01)	MEDIFACE	41	1	f	\N	UL	1	Unknown	\N
5398	(0029,"MEDIFACE",10)	(0029,"MEDIFACE",10)	MEDIFACE	41	16	f	\N	DS	1	Unknown	\N
5399	(0029,"MEDIFACE",11)	(0029,"MEDIFACE",11)	MEDIFACE	41	17	f	\N	DS	1	Unknown	\N
5339	(0029,"MMCPrivate",a6)	(0029,"MMCPrivate",a6)	MMCPrivate	41	166	f	\N	FD	1	Velocity Encoding Minimum Value	K
5340	(0029,"MMCPrivate",a7)	(0029,"MMCPrivate",a7)	MMCPrivate	41	167	f	\N	FD	1	Velocity Encoding Maximum Value	K
5341	(0029,"MMCPrivate",a8)	(0029,"MMCPrivate",a8)	MMCPrivate	41	168	f	\N	SQ	1	MR Image Frame Type Sequence	K
5342	(0029,"MMCPrivate",a9)	(0029,"MMCPrivate",a9)	MMCPrivate	41	169	f	\N	CS	1	Frame Type	K
5343	(0029,"MMCPrivate",aa)	(0029,"MMCPrivate",aa)	MMCPrivate	41	170	f	\N	CS	1	Pixel Presentation	K
5345	(0029,"MMCPrivate",ac)	(0029,"MMCPrivate",ac)	MMCPrivate	41	172	f	\N	CS	1	Volume Based Calculation Technique	K
5362	(0029,"MMCPrivate",bd)	(0029,"MMCPrivate",bd)	MMCPrivate	41	189	f	\N	DS	1	Mixing Time	K
5363	(0029,"MMCPrivate",be)	(0029,"MMCPrivate",be)	MMCPrivate	41	190	f	\N	FD	1	Selective IR Position	X
5364	(0029,"MMCPrivate",bf)	(0029,"MMCPrivate",bf)	MMCPrivate	41	191	f	\N	FD	1	Selective IR Row	K
5366	(0029,"MMCPrivate",c1)	(0029,"MMCPrivate",c1)	MMCPrivate	41	193	f	\N	FD	1	Selective IR Orientation	K
5367	(0029,"MMCPrivate",c2)	(0029,"MMCPrivate",c2)	MMCPrivate	41	194	f	\N	DS	1	Selective IR Thickness	K
5368	(0029,"MMCPrivate",c3)	(0029,"MMCPrivate",c3)	MMCPrivate	41	195	f	\N	CS	1	Rephase Order Slice	K
5369	(0029,"MMCPrivate",c4)	(0029,"MMCPrivate",c4)	MMCPrivate	41	196	f	\N	CS	1	Rephase Order Phase	K
5370	(0029,"MMCPrivate",c5)	(0029,"MMCPrivate",c5)	MMCPrivate	41	197	f	\N	CS	1	Rephase Order Freq	K
5371	(0029,"MMCPrivate",d0)	(0029,"MMCPrivate",d0)	MMCPrivate	41	208	f	\N	LO	1	Unknown	K
5372	(0029,"MMCPrivate",d3)	(0029,"MMCPrivate",d3)	MMCPrivate	41	211	f	\N	LO	1	Unknown	K
5373	(0029,"MMCPrivate",d5)	(0029,"MMCPrivate",d5)	MMCPrivate	41	213	f	\N	UI	1	Unknown	K
5374	(0029,"MMCPrivate",d6)	(0029,"MMCPrivate",d6)	MMCPrivate	41	214	f	\N	LO	1	Unknown	K
5375	(0029,"MMCPrivate",d7)	(0029,"MMCPrivate",d7)	MMCPrivate	41	215	f	\N	OB	1	Unknown	X
5400	(0029,"MEDIFACE",20)	(0029,"MEDIFACE",20)	MEDIFACE	41	32	f	\N	DS	1	Unknown	\N
5401	(0029,"MEDIFACE",21)	(0029,"MEDIFACE",21)	MEDIFACE	41	33	f	\N	UL	1	Unknown	\N
5402	(0029,"MEDIFACE",22)	(0029,"MEDIFACE",22)	MEDIFACE	41	34	f	\N	DS	2	Unknown	\N
5403	(0029,"MEDIFACE",30)	(0029,"MEDIFACE",30)	MEDIFACE	41	48	f	\N	LT	1	Unknown	\N
5404	(8003,"Image (ID, Version, Size, Dump, GUID)",00)	(8003,"Image (ID, Version, Size, Dump, GUID)",00)	Image (ID, Version, Size, Dump, GUID)	32771	0	f	\N	LO	1	ID	\N
5405	(8003,"Image (ID, Version, Size, Dump, GUID)",10)	(8003,"Image (ID, Version, Size, Dump, GUID)",10)	Image (ID, Version, Size, Dump, GUID)	32771	16	f	\N	LO	1	Version	\N
5406	(8003,"Image (ID, Version, Size, Dump, GUID)",20)	(8003,"Image (ID, Version, Size, Dump, GUID)",20)	Image (ID, Version, Size, Dump, GUID)	32771	32	f	\N	UL	1	Size	\N
5407	(8003,"Image (ID, Version, Size, Dump, GUID)",30)	(8003,"Image (ID, Version, Size, Dump, GUID)",30)	Image (ID, Version, Size, Dump, GUID)	32771	48	f	\N	OB	1	Dump	\N
5408	(8003,"Image (ID, Version, Size, Dump, GUID)",40)	(8003,"Image (ID, Version, Size, Dump, GUID)",40)	Image (ID, Version, Size, Dump, GUID)	32771	64	f	\N	LO	1	GUID	\N
5409	(8101,"ObjectModel (ID, Version, Place, PlaceDescription)",00)	(8101,"ObjectModel (ID, Version, Place, PlaceDescription)",00)	ObjectModel (ID, Version, Place, PlaceDescription)	33025	0	f	\N	LO	1	ID	\N
5410	(8101,"ObjectModel (ID, Version, Place, PlaceDescription)",10)	(8101,"ObjectModel (ID, Version, Place, PlaceDescription)",10)	ObjectModel (ID, Version, Place, PlaceDescription)	33025	16	f	\N	LO	1	Version	\N
5411	(0015,"INFINITT_FMX",10)	(0015,"INFINITT_FMX",10)	INFINITT_FMX	21	16	f	\N	LO	1	Unknown	\N
5412	(0015,"INFINITT_FMX",11)	(0015,"INFINITT_FMX",11)	INFINITT_FMX	21	17	f	\N	LO	1	Unknown	\N
5413	(0009,"BrainLAB_Conversion",01)	(0009,"BrainLAB_Conversion",01)	BrainLAB_Conversion	9	1	f	\N	LO	1	Export Platform Name	\N
5414	(0009,"BrainLAB_Conversion",02)	(0009,"BrainLAB_Conversion",02)	BrainLAB_Conversion	9	2	f	\N	OB	1	Export Platform Data	\N
5415	(3273,"BrainLAB_PatientSetup",00)	(3273,"BrainLAB_PatientSetup",00)	BrainLAB_PatientSetup	12915	0	f	\N	DS	3	Isocenter Position	\N
5416	(3273,"BrainLAB_PatientSetup",01)	(3273,"BrainLAB_PatientSetup",01)	BrainLAB_PatientSetup	12915	1	f	\N	CS	1	Patient Position	\N
5417	(3411,"BrainLAB_BeamProfile",01)	(3411,"BrainLAB_BeamProfile",01)	BrainLAB_BeamProfile	13329	1	f	\N	SQ	1	Beam Profile Sequence	\N
5418	(3411,"BrainLAB_BeamProfile",02)	(3411,"BrainLAB_BeamProfile",02)	BrainLAB_BeamProfile	13329	2	f	\N	IS	1	Beam Profile Number	\N
5419	(3411,"BrainLAB_BeamProfile",03)	(3411,"BrainLAB_BeamProfile",03)	BrainLAB_BeamProfile	13329	3	f	\N	SQ	1	Beam Parameter Sequence	\N
5420	(3411,"BrainLAB_BeamProfile",04)	(3411,"BrainLAB_BeamProfile",04)	BrainLAB_BeamProfile	13329	4	f	\N	UT	1	Parameter Description	\N
5421	(3411,"BrainLAB_BeamProfile",05)	(3411,"BrainLAB_BeamProfile",05)	BrainLAB_BeamProfile	13329	5	f	\N	OB	1	Parameter Data	\N
5422	(3411,"BrainLAB_BeamProfile",06)	(3411,"BrainLAB_BeamProfile",06)	BrainLAB_BeamProfile	13329	6	f	\N	IS	1	Referenced Beam Profile Number	\N
5423	(0011,"V1",01)	(0011,"V1",01)	V1	17	1	f	\N	OB	1	User Data	\N
5424	(0011,"V1",02)	(0011,"V1",02)	V1	17	2	f	\N	DS	1	Normalization Coefficient	\N
5425	(0011,"V1",03)	(0011,"V1",03)	V1	17	3	f	\N	DS	1-n	Receiving Gain	\N
5426	(0011,"V1",04)	(0011,"V1",04)	V1	17	4	f	\N	DS	1	Mean Image Noise	\N
5427	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",00)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",00)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	0	f	\N	UI	1	Unknown	\N
5428	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",01)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",01)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	1	f	\N	OB	1	Unknown	\N
5429	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",02)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",02)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	2	f	\N	SQ	1	Unknown	\N
5430	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",06)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",06)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	6	f	\N	UL	1	Unknown	\N
5431	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",07)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",07)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	7	f	\N	UI	1	Unknown	\N
5432	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",08)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",08)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	8	f	\N	SQ	1	Unknown	\N
5433	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",09)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",09)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	9	f	\N	UI	1	Unknown	\N
5434	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",10)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",10)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	16	f	\N	IS	1	Unknown	\N
5435	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",13)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",13)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	19	f	\N	LO	1	Unknown	\N
5436	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",14)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",14)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	20	f	\N	UN	1	Unknown	\N
5437	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",16)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",16)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	22	f	\N	LO	1	Unknown	\N
5438	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",17)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",17)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	23	f	\N	UN	1	Unknown	\N
5439	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",18)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",18)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	24	f	\N	UN	1	Unknown	\N
5440	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",21)	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",21)	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	4405	33	f	\N	UL	1	Unknown	\N
5441	(0029,"Kodak Image Information",15)	(0029,"Kodak Image Information",15)	Kodak Image Information	41	21	f	\N	LO	1	Unknown	\N
5442	(0029,"Kodak Image Information",16)	(0029,"Kodak Image Information",16)	Kodak Image Information	41	22	f	\N	LO	1	Unknown	\N
5443	(0029,"Kodak Image Information",17)	(0029,"Kodak Image Information",17)	Kodak Image Information	41	23	f	\N	LO	1	Unknown	\N
5444	(0029,"Kodak Image Information",18)	(0029,"Kodak Image Information",18)	Kodak Image Information	41	24	f	\N	UT	1	Unknown	\N
5757	(0199,"NQLeft",12)	(0199,"NQLeft",12)	NQLeft	409	18	f	\N	FL	1	Left Nucleus Accumbens	\N
5445	(0029,"Kodak Image Information",19)	(0029,"Kodak Image Information",19)	Kodak Image Information	41	25	f	\N	IS	1	Unknown	\N
5446	(0029,"Kodak Image Information",1a)	(0029,"Kodak Image Information",1a)	Kodak Image Information	41	26	f	\N	IS	1	Unknown	\N
5447	(0037,"MAROTECH Inc.",01)	(0037,"MAROTECH Inc.",01)	MAROTECH Inc.	55	1	f	\N	LO	1	Unknown	\N
5448	(0037,"MAROTECH Inc.",21)	(0037,"MAROTECH Inc.",21)	MAROTECH Inc.	55	33	f	\N	US	1	Unknown	\N
5449	(0037,"MAROTECH Inc.",22)	(0037,"MAROTECH Inc.",22)	MAROTECH Inc.	55	34	f	\N	US	1	Unknown	\N
5450	(0037,"MAROTECH Inc.",23)	(0037,"MAROTECH Inc.",23)	MAROTECH Inc.	55	35	f	\N	OB	1	Unknown	\N
5451	(0021,"BRIT Systems, Inc.",00)	(0021,"BRIT Systems, Inc.",00)	BRIT Systems, Inc.	33	0	f	\N	SQ	1	Person Information Sequence	\N
5452	(0021,"BRIT Systems, Inc.",01)	(0021,"BRIT Systems, Inc.",01)	BRIT Systems, Inc.	33	1	f	\N	LO	1	Person ID	\N
5453	(0021,"BRIT Systems, Inc.",02)	(0021,"BRIT Systems, Inc.",02)	BRIT Systems, Inc.	33	2	f	\N	PN	1	Person Name	\N
5454	(0021,"BRIT Systems, Inc.",03)	(0021,"BRIT Systems, Inc.",03)	BRIT Systems, Inc.	33	3	f	\N	LO	1	Person Role	\N
5455	(0021,"BRIT Systems, Inc.",04)	(0021,"BRIT Systems, Inc.",04)	BRIT Systems, Inc.	33	4	f	\N	SH	1	Person Home Phone	\N
5456	(0021,"BRIT Systems, Inc.",05)	(0021,"BRIT Systems, Inc.",05)	BRIT Systems, Inc.	33	5	f	\N	SH	1	Person Work Phone	\N
5457	(0021,"BRIT Systems, Inc.",06)	(0021,"BRIT Systems, Inc.",06)	BRIT Systems, Inc.	33	6	f	\N	SH	1	Person Cell Phone	\N
5458	(0021,"BRIT Systems, Inc.",07)	(0021,"BRIT Systems, Inc.",07)	BRIT Systems, Inc.	33	7	f	\N	SH	1	Person Pager Phone	\N
5459	(0021,"BRIT Systems, Inc.",08)	(0021,"BRIT Systems, Inc.",08)	BRIT Systems, Inc.	33	8	f	\N	SH	1	Person Fax Phone	\N
5460	(0021,"BRIT Systems, Inc.",09)	(0021,"BRIT Systems, Inc.",09)	BRIT Systems, Inc.	33	9	f	\N	LO	1	Person EMail	\N
5461	(0021,"BRIT Systems, Inc.",0a)	(0021,"BRIT Systems, Inc.",0a)	BRIT Systems, Inc.	33	10	f	\N	ST	1	Person Address	\N
5462	(0021,"BRIT Systems, Inc.",0b)	(0021,"BRIT Systems, Inc.",0b)	BRIT Systems, Inc.	33	11	f	\N	LO	1	Person Password	\N
5463	(0021,"BRIT Systems, Inc.",0c)	(0021,"BRIT Systems, Inc.",0c)	BRIT Systems, Inc.	33	12	f	\N	SH	1	Person Emergency Phone	\N
5464	(0021,"BRIT Systems, Inc.",0d)	(0021,"BRIT Systems, Inc.",0d)	BRIT Systems, Inc.	33	13	f	\N	LO	1	Physician ID	\N
5465	(0021,"BRIT Systems, Inc.",11)	(0021,"BRIT Systems, Inc.",11)	BRIT Systems, Inc.	33	17	f	\N	LO	1	Original Patient ID	\N
5466	(0021,"BRIT Systems, Inc.",12)	(0021,"BRIT Systems, Inc.",12)	BRIT Systems, Inc.	33	18	f	\N	UI	1	Original Study Instance UID	\N
5467	(0021,"BRIT Systems, Inc.",13)	(0021,"BRIT Systems, Inc.",13)	BRIT Systems, Inc.	33	19	f	\N	UI	1	Original Series Instance UID	\N
5468	(0021,"BRIT Systems, Inc.",14)	(0021,"BRIT Systems, Inc.",14)	BRIT Systems, Inc.	33	20	f	\N	LO	1	Master Accession Number	\N
5469	(0021,"BRIT Systems, Inc.",15)	(0021,"BRIT Systems, Inc.",15)	BRIT Systems, Inc.	33	21	f	\N	LO	1	Order Category	\N
5470	(0021,"BRIT Systems, Inc.",16)	(0021,"BRIT Systems, Inc.",16)	BRIT Systems, Inc.	33	22	f	\N	LO	1	Patient ICN	\N
5471	(0021,"BRIT Systems, Inc.",17)	(0021,"BRIT Systems, Inc.",17)	BRIT Systems, Inc.	33	23	f	\N	LO	1	Patient DFS	\N
5472	(0021,"BRIT Systems, Inc.",18)	(0021,"BRIT Systems, Inc.",18)	BRIT Systems, Inc.	33	24	f	\N	LO	1	Patient Class	\N
5473	(0021,"BRIT Systems, Inc.",19)	(0021,"BRIT Systems, Inc.",19)	BRIT Systems, Inc.	33	25	f	\N	LO	1	Patient Type	\N
5474	(0021,"BRIT Systems, Inc.",1f)	(0021,"BRIT Systems, Inc.",1f)	BRIT Systems, Inc.	33	31	f	\N	LT	1	Generic String	\N
5475	(0021,"BRIT Systems, Inc.",20)	(0021,"BRIT Systems, Inc.",20)	BRIT Systems, Inc.	33	32	f	\N	LO	1	QC Study Assigned By	\N
5476	(0021,"BRIT Systems, Inc.",21)	(0021,"BRIT Systems, Inc.",21)	BRIT Systems, Inc.	33	33	f	\N	LO	1	QC Study Split By	\N
5477	(0021,"BRIT Systems, Inc.",22)	(0021,"BRIT Systems, Inc.",22)	BRIT Systems, Inc.	33	34	f	\N	LO	1	QC Study Moved By	\N
5478	(0021,"BRIT Systems, Inc.",23)	(0021,"BRIT Systems, Inc.",23)	BRIT Systems, Inc.	33	35	f	\N	LO	1	QC Study Edited By	\N
5479	(0021,"BRIT Systems, Inc.",24)	(0021,"BRIT Systems, Inc.",24)	BRIT Systems, Inc.	33	36	f	\N	LO	1	QC Series Split By	\N
5480	(0021,"BRIT Systems, Inc.",25)	(0021,"BRIT Systems, Inc.",25)	BRIT Systems, Inc.	33	37	f	\N	LO	1	QC Series Moved By	\N
5481	(0021,"BRIT Systems, Inc.",26)	(0021,"BRIT Systems, Inc.",26)	BRIT Systems, Inc.	33	38	f	\N	LO	1	QC Series Edited By	\N
5482	(0021,"BRIT Systems, Inc.",27)	(0021,"BRIT Systems, Inc.",27)	BRIT Systems, Inc.	33	39	f	\N	LO	1	QC Image Moved By	\N
5483	(0021,"BRIT Systems, Inc.",28)	(0021,"BRIT Systems, Inc.",28)	BRIT Systems, Inc.	33	40	f	\N	LO	1	QC Image Edited By	\N
5484	(0021,"BRIT Systems, Inc.",30)	(0021,"BRIT Systems, Inc.",30)	BRIT Systems, Inc.	33	48	f	\N	LO	1	QC Done Time	\N
5485	(0021,"BRIT Systems, Inc.",31)	(0021,"BRIT Systems, Inc.",31)	BRIT Systems, Inc.	33	49	f	\N	LO	1	QC Last Modification Time	\N
5486	(0021,"BRIT Systems, Inc.",32)	(0021,"BRIT Systems, Inc.",32)	BRIT Systems, Inc.	33	50	f	\N	LO	1	QC Image Accepted By	\N
5487	(0021,"BRIT Systems, Inc.",33)	(0021,"BRIT Systems, Inc.",33)	BRIT Systems, Inc.	33	51	f	\N	LO	1	QC Image Rejected By	\N
5488	(0021,"BRIT Systems, Inc.",34)	(0021,"BRIT Systems, Inc.",34)	BRIT Systems, Inc.	33	52	f	\N	DA	1	QC Done Date	\N
5489	(0021,"BRIT Systems, Inc.",50)	(0021,"BRIT Systems, Inc.",50)	BRIT Systems, Inc.	33	80	f	\N	LO	1	QC Deletion Requested	\N
5490	(0021,"BRIT Systems, Inc.",90)	(0021,"BRIT Systems, Inc.",90)	BRIT Systems, Inc.	33	144	f	\N	AE	1	Original Sender AE Title	\N
5491	(0021,"BRIT Systems, Inc.",91)	(0021,"BRIT Systems, Inc.",91)	BRIT Systems, Inc.	33	145	f	\N	LO	1	Software Title	\N
5492	(0021,"BRIT Systems, Inc.",92)	(0021,"BRIT Systems, Inc.",92)	BRIT Systems, Inc.	33	146	f	\N	SH	1	Software Version	\N
5493	(0021,"BRIT Systems, Inc.",93)	(0021,"BRIT Systems, Inc.",93)	BRIT Systems, Inc.	33	147	f	\N	LO	1	Serial Number	\N
5494	(0021,"BRIT Systems, Inc.",a0)	(0021,"BRIT Systems, Inc.",a0)	BRIT Systems, Inc.	33	160	f	\N	SQ	1	Object Action Sequence	\N
5495	(0021,"BRIT Systems, Inc.",a1)	(0021,"BRIT Systems, Inc.",a1)	BRIT Systems, Inc.	33	161	f	\N	ST	1	Object Action	\N
5496	(0021,"BRIT Systems, Inc.",a2)	(0021,"BRIT Systems, Inc.",a2)	BRIT Systems, Inc.	33	162	f	\N	DA	1	Object Action Date	\N
5497	(0021,"BRIT Systems, Inc.",a3)	(0021,"BRIT Systems, Inc.",a3)	BRIT Systems, Inc.	33	163	f	\N	TM	1	Object Action Time	\N
5498	(0021,"BRIT Systems, Inc.",a5)	(0021,"BRIT Systems, Inc.",a5)	BRIT Systems, Inc.	33	165	f	\N	AE	1	Local AE Title	\N
5499	(0021,"BRIT Systems, Inc.",a6)	(0021,"BRIT Systems, Inc.",a6)	BRIT Systems, Inc.	33	166	f	\N	SH	1	Local IP Address	\N
5500	(0021,"BRIT Systems, Inc.",a7)	(0021,"BRIT Systems, Inc.",a7)	BRIT Systems, Inc.	33	167	f	\N	AE	1	Remote AE Title	\N
5501	(0021,"BRIT Systems, Inc.",a8)	(0021,"BRIT Systems, Inc.",a8)	BRIT Systems, Inc.	33	168	f	\N	SH	1	Remote IP Address	\N
5502	(3005,"MDS NORDION OTP ANATOMY MODELLING",00)	(3005,"MDS NORDION OTP ANATOMY MODELLING",00)	MDS NORDION OTP ANATOMY MODELLING	12293	0	f	\N	SQ	1	Unknown	\N
5503	(3005,"MDS NORDION OTP ANATOMY MODELLING",02)	(3005,"MDS NORDION OTP ANATOMY MODELLING",02)	MDS NORDION OTP ANATOMY MODELLING	12293	2	f	\N	CS	1	Unknown	\N
5504	(3005,"MDS NORDION OTP ANATOMY MODELLING",04)	(3005,"MDS NORDION OTP ANATOMY MODELLING",04)	MDS NORDION OTP ANATOMY MODELLING	12293	4	f	\N	DS	1	Unknown	\N
5505	(3005,"MDS NORDION OTP ANATOMY MODELLING",06)	(3005,"MDS NORDION OTP ANATOMY MODELLING",06)	MDS NORDION OTP ANATOMY MODELLING	12293	6	f	\N	DS	1	Unknown	\N
5506	(3005,"MDS NORDION OTP ANATOMY MODELLING",08)	(3005,"MDS NORDION OTP ANATOMY MODELLING",08)	MDS NORDION OTP ANATOMY MODELLING	12293	8	f	\N	DS	1	Unknown	\N
5507	(3005,"MDS NORDION OTP ANATOMY MODELLING",0a)	(3005,"MDS NORDION OTP ANATOMY MODELLING",0a)	MDS NORDION OTP ANATOMY MODELLING	12293	10	f	\N	CS	1	Unknown	\N
5508	(3005,"MDS NORDION OTP ANATOMY MODELLING",0c)	(3005,"MDS NORDION OTP ANATOMY MODELLING",0c)	MDS NORDION OTP ANATOMY MODELLING	12293	12	f	\N	CS	1	Unknown	\N
5509	(3005,"MDS NORDION OTP ANATOMY MODELLING",0e)	(3005,"MDS NORDION OTP ANATOMY MODELLING",0e)	MDS NORDION OTP ANATOMY MODELLING	12293	14	f	\N	CS	1	Unknown	\N
5510	(3005,"MDS NORDION OTP ANATOMY MODELLING",10)	(3005,"MDS NORDION OTP ANATOMY MODELLING",10)	MDS NORDION OTP ANATOMY MODELLING	12293	16	f	\N	DS	1	Unknown	\N
5511	(3005,"MDS NORDION OTP ANATOMY MODELLING",12)	(3005,"MDS NORDION OTP ANATOMY MODELLING",12)	MDS NORDION OTP ANATOMY MODELLING	12293	18	f	\N	DS	1	Unknown	\N
5512	(4321,"Imaging Dynamics Company Ltd.",41)	(4321,"Imaging Dynamics Company Ltd.",41)	Imaging Dynamics Company Ltd.	17185	65	f	\N	CS	1	Unknown	\N
5513	(4321,"Imaging Dynamics Company Ltd.",42)	(4321,"Imaging Dynamics Company Ltd.",42)	Imaging Dynamics Company Ltd.	17185	66	f	\N	US	1	Unknown	\N
5514	(4321,"Imaging Dynamics Company Ltd.",64)	(4321,"Imaging Dynamics Company Ltd.",64)	Imaging Dynamics Company Ltd.	17185	100	f	\N	LO	1	POD Mode	\N
5515	(f001,"Sound Technologies",00)	(f001,"Sound Technologies",00)	Sound Technologies	61441	0	f	\N	LO	1	Patient Species	\N
5516	(f001,"Sound Technologies",01)	(f001,"Sound Technologies",01)	Sound Technologies	61441	1	f	\N	LO	1	Patient Breed	\N
5517	(f001,"Sound Technologies",02)	(f001,"Sound Technologies",02)	Sound Technologies	61441	2	f	\N	LO	1	Patient Category Size	\N
5518	(f001,"Sound Technologies",03)	(f001,"Sound Technologies",03)	Sound Technologies	61441	3	f	\N	CS	1	Patient Sex Extended	\N
5519	(f001,"Sound Technologies",04)	(f001,"Sound Technologies",04)	Sound Technologies	61441	4	f	\N	LO	1	Image View	\N
5520	(f001,"Sound Technologies",05)	(f001,"Sound Technologies",05)	Sound Technologies	61441	5	f	\N	LO	1	Anatomy Imaged	\N
5521	(f001,"Sound Technologies",06)	(f001,"Sound Technologies",06)	Sound Technologies	61441	6	f	\N	LT	1	Image Enhancements	\N
5522	(f001,"Sound Technologies",07)	(f001,"Sound Technologies",07)	Sound Technologies	61441	7	f	\N	LO	1	Detector Settings	\N
5523	(f001,"Sound Technologies",08)	(f001,"Sound Technologies",08)	Sound Technologies	61441	8	f	\N	LO	1	Application Version	\N
5524	(f001,"Sound Technologies",09)	(f001,"Sound Technologies",09)	Sound Technologies	61441	9	f	\N	LO	1	Image Laterality Extended	\N
5525	(f001,"Sound Technologies",0a)	(f001,"Sound Technologies",0a)	Sound Technologies	61441	10	f	\N	PN	1	Client Name	\N
5526	(f001,"Sound Technologies",0b)	(f001,"Sound Technologies",0b)	Sound Technologies	61441	11	f	\N	UI	1	Reference Study Instance UID	\N
5527	(f001,"Sound Technologies",0c)	(f001,"Sound Technologies",0c)	Sound Technologies	61441	12	f	\N	UI	1	Reference Study Instance UID	\N
5528	(f001,"Sound Technologies",0d)	(f001,"Sound Technologies",0d)	Sound Technologies	61441	13	f	\N	LO	1	Exam Ref ID	\N
5529	(f001,"Sound Technologies",0e)	(f001,"Sound Technologies",0e)	Sound Technologies	61441	14	f	\N	ST	1	Physician of Record Address	\N
5530	(f001,"Sound Technologies",0f)	(f001,"Sound Technologies",0f)	Sound Technologies	61441	15	f	\N	SH	1	Physician of Record Phone Numbers	\N
5531	(f001,"Sound Technologies",10)	(f001,"Sound Technologies",10)	Sound Technologies	61441	16	f	\N	LT	1	Reason For Study	\N
5532	(f001,"Sound Technologies",11)	(f001,"Sound Technologies",11)	Sound Technologies	61441	17	f	\N	LO	1	Protocol	\N
5533	(f001,"Sound Technologies",12)	(f001,"Sound Technologies",12)	Sound Technologies	61441	18	f	\N	LO	1	Capture Input Type	\N
5534	(f001,"Sound Technologies",13)	(f001,"Sound Technologies",13)	Sound Technologies	61441	19	f	\N	LT	1	Exam Complaint	\N
5535	(f001,"Sound Technologies",14)	(f001,"Sound Technologies",14)	Sound Technologies	61441	20	f	\N	LO	1	Exam Web Code	\N
5536	(f001,"Sound Technologies",15)	(f001,"Sound Technologies",15)	Sound Technologies	61441	21	f	\N	LO	1	Exam Category	\N
5537	(f001,"Sound Technologies",16)	(f001,"Sound Technologies",16)	Sound Technologies	61441	22	f	\N	SH	1	Exam Diagnosis	\N
5538	(f001,"Sound Technologies",17)	(f001,"Sound Technologies",17)	Sound Technologies	61441	23	f	\N	PN	1	Exam Created By	\N
5539	(f001,"Sound Technologies",18)	(f001,"Sound Technologies",18)	Sound Technologies	61441	24	f	\N	LO	1	Exam Created By Group	\N
5540	(f001,"Sound Technologies",19)	(f001,"Sound Technologies",19)	Sound Technologies	61441	25	f	\N	DT	1	Exam Required By DateTime	\N
5541	(f001,"Sound Technologies",1a)	(f001,"Sound Technologies",1a)	Sound Technologies	61441	26	f	\N	LO	1	Capture Type	\N
5542	(f001,"Sound Technologies",1b)	(f001,"Sound Technologies",1b)	Sound Technologies	61441	27	f	\N	IS	1	Telemed Exam ID	\N
5543	(f001,"Sound Technologies",1c)	(f001,"Sound Technologies",1c)	Sound Technologies	61441	28	f	\N	LO	1	Exam Created By Guid	\N
5544	(f001,"Sound Technologies",1d)	(f001,"Sound Technologies",1d)	Sound Technologies	61441	29	f	\N	LO	1	Client Name Guid	\N
5545	(f001,"Sound Technologies",1e)	(f001,"Sound Technologies",1e)	Sound Technologies	61441	30	f	\N	LO	1	Receptor Bits Per Pixel	\N
5546	(3711,"A.L.I. Technologies, Inc.",01)	(3711,"A.L.I. Technologies, Inc.",01)	A.L.I. Technologies, Inc.	14097	1	f	\N	LO	1	Filename	\N
5547	(3711,"A.L.I. Technologies, Inc.",02)	(3711,"A.L.I. Technologies, Inc.",02)	A.L.I. Technologies, Inc.	14097	2	f	\N	OB	1	Data Blob of a Visit	\N
5548	(3711,"A.L.I. Technologies, Inc.",03)	(3711,"A.L.I. Technologies, Inc.",03)	A.L.I. Technologies, Inc.	14097	3	f	\N	US	1	Revision Number	\N
5549	(3711,"A.L.I. Technologies, Inc.",04)	(3711,"A.L.I. Technologies, Inc.",04)	A.L.I. Technologies, Inc.	14097	4	f	\N	UL	1	Unix Timestamp	\N
5550	(3711,"A.L.I. Technologies, Inc.",05)	(3711,"A.L.I. Technologies, Inc.",05)	A.L.I. Technologies, Inc.	14097	5	f	\N	IS	1	Bag ID	\N
5551	(3711,"A.L.I. Technologies, Inc.",0c)	(3711,"A.L.I. Technologies, Inc.",0c)	A.L.I. Technologies, Inc.	14097	12	f	\N	UI	1	Original Study UID	\N
5552	(3711,"A.L.I. Technologies, Inc.",0d)	(3711,"A.L.I. Technologies, Inc.",0d)	A.L.I. Technologies, Inc.	14097	13	f	\N	US	1	Overlay Grayscale Value	\N
5553	(3711,"A.L.I. Technologies, Inc.",0e)	(3711,"A.L.I. Technologies, Inc.",0e)	A.L.I. Technologies, Inc.	14097	14	f	\N	CS	1	Anonymization Status	\N
5554	(3711,"A.L.I. Technologies, Inc.",0f)	(3711,"A.L.I. Technologies, Inc.",0f)	A.L.I. Technologies, Inc.	14097	15	f	\N	CS	1	Instance Type	\N
5555	(3711,"A.L.I. Technologies, Inc.",30)	(3711,"A.L.I. Technologies, Inc.",30)	A.L.I. Technologies, Inc.	14097	48	f	\N	LO	1	IP Converted Frame	\N
5556	(3711,"A.L.I. Technologies, Inc.",97)	(3711,"A.L.I. Technologies, Inc.",97)	A.L.I. Technologies, Inc.	14097	151	f	\N	OB	1	Unknown	\N
5557	(7777,"NUD_PRIVATE",02)	(7777,"NUD_PRIVATE",02)	NUD_PRIVATE	30583	2	f	\N	UT	1	Interfile	\N
5558	(7777,"NUD_PRIVATE",05)	(7777,"NUD_PRIVATE",05)	NUD_PRIVATE	30583	5	f	\N	IS	1	Unknown	\N
5559	(0011,"IDEXX",00)	(0011,"IDEXX",00)	IDEXX	17	0	f	\N	LO	1	Breed Name	\N
5560	(0011,"IDEXX",01)	(0011,"IDEXX",01)	IDEXX	17	1	f	\N	LO	1	Species Name	\N
5561	(0011,"IDEXX",02)	(0011,"IDEXX",02)	IDEXX	17	2	f	\N	PN	1	Owner	\N
5562	(0009,"WG12 Supplement 43",01)	(0009,"WG12 Supplement 43",01)	WG12 Supplement 43	9	1	f	\N	SQ	1	Event Timer Sequence	\N
5563	(0009,"WG12 Supplement 43",02)	(0009,"WG12 Supplement 43",02)	WG12 Supplement 43	9	2	f	\N	FD	1	Event Time Interval	\N
5564	(0009,"WG12 Supplement 43",03)	(0009,"WG12 Supplement 43",03)	WG12 Supplement 43	9	3	f	\N	SQ	1	Event Code Sequence	\N
5565	(0019,"WG12 Supplement 43",01)	(0019,"WG12 Supplement 43",01)	WG12 Supplement 43	25	1	f	\N	FD	1	Focus Depth(s)	\N
5566	(0019,"WG12 Supplement 43",03)	(0019,"WG12 Supplement 43",03)	WG12 Supplement 43	25	3	f	\N	SQ	1	Excluded Intervals Sequence	\N
5567	(0019,"WG12 Supplement 43",04)	(0019,"WG12 Supplement 43",04)	WG12 Supplement 43	25	4	f	\N	DT	1	Exclusion Start Datetime	\N
5568	(0019,"WG12 Supplement 43",05)	(0019,"WG12 Supplement 43",05)	WG12 Supplement 43	25	5	f	\N	FD	1	Exclusion Duration	\N
5569	(0019,"WG12 Supplement 43",06)	(0019,"WG12 Supplement 43",06)	WG12 Supplement 43	25	6	f	\N	SQ	1	US Image Description Sequence	\N
5570	(0019,"WG12 Supplement 43",07)	(0019,"WG12 Supplement 43",07)	WG12 Supplement 43	25	7	f	\N	SQ	1	Image Data Type Sequence	\N
5571	(0019,"WG12 Supplement 43",08)	(0019,"WG12 Supplement 43",08)	WG12 Supplement 43	25	8	f	\N	CS	1	Data Type	\N
5572	(0019,"WG12 Supplement 43",09)	(0019,"WG12 Supplement 43",09)	WG12 Supplement 43	25	9	f	\N	SQ	1	Transducer Scan Geometry Code Sequence	\N
5573	(0019,"WG12 Supplement 43",0b)	(0019,"WG12 Supplement 43",0b)	WG12 Supplement 43	25	11	f	\N	CS	1	Aliased Data Type	\N
5574	(0019,"WG12 Supplement 43",0c)	(0019,"WG12 Supplement 43",0c)	WG12 Supplement 43	25	12	f	\N	CS	1	Position Measuring Device Used	\N
5575	(0019,"WG12 Supplement 43",0d)	(0019,"WG12 Supplement 43",0d)	WG12 Supplement 43	25	13	f	\N	SQ	1	Transducer Scanning Configuration Code Sequence	\N
5576	(0019,"WG12 Supplement 43",0e)	(0019,"WG12 Supplement 43",0e)	WG12 Supplement 43	25	14	f	\N	SQ	1	Transducer Beam Steering Code Sequence	\N
5577	(0019,"WG12 Supplement 43",0f)	(0019,"WG12 Supplement 43",0f)	WG12 Supplement 43	25	15	f	\N	SQ	1	Transducer Access Code Sequence	\N
5578	(0021,"WG12 Supplement 43",01)	(0021,"WG12 Supplement 43",01)	WG12 Supplement 43	33	1	f	\N	FD	1	Image Position (Volume)	\N
5579	(0021,"WG12 Supplement 43",02)	(0021,"WG12 Supplement 43",02)	WG12 Supplement 43	33	2	f	\N	FD	1	Image Orientation (Volume)	\N
5580	(0021,"WG12 Supplement 43",07)	(0021,"WG12 Supplement 43",07)	WG12 Supplement 43	33	7	f	\N	CS	1	Ultrasound Acquisition Geometry	\N
5581	(0021,"WG12 Supplement 43",08)	(0021,"WG12 Supplement 43",08)	WG12 Supplement 43	33	8	f	\N	FD	1	Apex Position	\N
5582	(0021,"WG12 Supplement 43",09)	(0021,"WG12 Supplement 43",09)	WG12 Supplement 43	33	9	f	\N	FD	1	Volume to Transducer Mapping Matrix	\N
5583	(0021,"WG12 Supplement 43",0a)	(0021,"WG12 Supplement 43",0a)	WG12 Supplement 43	33	10	f	\N	FD	1	Volume to Table Mapping Matrix	\N
5584	(0021,"WG12 Supplement 43",0c)	(0021,"WG12 Supplement 43",0c)	WG12 Supplement 43	33	12	f	\N	CS	1	Patient Frame of Reference Source	\N
5585	(0021,"WG12 Supplement 43",0d)	(0021,"WG12 Supplement 43",0d)	WG12 Supplement 43	33	13	f	\N	FD	1	Temporal Position Time Offset	\N
5586	(0021,"WG12 Supplement 43",0e)	(0021,"WG12 Supplement 43",0e)	WG12 Supplement 43	33	14	f	\N	SQ	1	Plane Position (Volume) Sequence	\N
5587	(0021,"WG12 Supplement 43",0f)	(0021,"WG12 Supplement 43",0f)	WG12 Supplement 43	33	15	f	\N	SQ	1	Plane Orientation (Volume) Sequence	\N
5588	(0021,"WG12 Supplement 43",10)	(0021,"WG12 Supplement 43",10)	WG12 Supplement 43	33	16	f	\N	SQ	1	Temporal Position Sequence	\N
5589	(0021,"WG12 Supplement 43",11)	(0021,"WG12 Supplement 43",11)	WG12 Supplement 43	33	17	f	\N	CS	1	Dimension Organization Type	\N
5590	(0029,"WG12 Supplement 43",01)	(0029,"WG12 Supplement 43",01)	WG12 Supplement 43	41	1	f	\N	SQ	1	Data Frame Assignment Sequence	\N
5591	(0029,"WG12 Supplement 43",02)	(0029,"WG12 Supplement 43",02)	WG12 Supplement 43	41	2	f	\N	CS	1	Data Path Assignment	\N
5592	(0029,"WG12 Supplement 43",03)	(0029,"WG12 Supplement 43",03)	WG12 Supplement 43	41	3	f	\N	US	1	Bits Mapped to Color Lookup Table	\N
5593	(0029,"WG12 Supplement 43",04)	(0029,"WG12 Supplement 43",04)	WG12 Supplement 43	41	4	f	\N	SQ	1	Opacity 1 LUT Sequence	\N
5594	(0029,"WG12 Supplement 43",05)	(0029,"WG12 Supplement 43",05)	WG12 Supplement 43	41	5	f	\N	CS	1	Opacity 1 LUT Transfer Function	\N
5595	(0029,"WG12 Supplement 43",06)	(0029,"WG12 Supplement 43",06)	WG12 Supplement 43	41	6	f	\N	FD	1	Opacity Constant	\N
5596	(0029,"WG12 Supplement 43",07)	(0029,"WG12 Supplement 43",07)	WG12 Supplement 43	41	7	f	\N	US	1	Opacity Lookup Table Descriptor	\N
5758	(0199,"NQLeft",13)	(0199,"NQLeft",13)	NQLeft	409	19	f	\N	FL	1	Left Brain Stem	\N
5597	(0029,"WG12 Supplement 43",08)	(0029,"WG12 Supplement 43",08)	WG12 Supplement 43	41	8	f	\N	OW	1	Opacity Lookup Table Data	\N
5598	(0029,"WG12 Supplement 43",0b)	(0029,"WG12 Supplement 43",0b)	WG12 Supplement 43	41	11	f	\N	SQ	1	Enhanced Palette Color Lookup Table Sequence	\N
5599	(0029,"WG12 Supplement 43",0c)	(0029,"WG12 Supplement 43",0c)	WG12 Supplement 43	41	12	f	\N	SQ	1	Opacity 2 LUT Sequence	\N
5600	(0029,"WG12 Supplement 43",0d)	(0029,"WG12 Supplement 43",0d)	WG12 Supplement 43	41	13	f	\N	CS	1	Opacity 2 LUT Transfer Function	\N
5601	(0029,"WG12 Supplement 43",0e)	(0029,"WG12 Supplement 43",0e)	WG12 Supplement 43	41	14	f	\N	CS	1	Data Path ID	\N
5602	(0029,"WG12 Supplement 43",0f)	(0029,"WG12 Supplement 43",0f)	WG12 Supplement 43	41	15	f	\N	CS	1	RGB LUT Transfer Function	\N
5603	(0029,"WG12 Supplement 43",10)	(0029,"WG12 Supplement 43",10)	WG12 Supplement 43	41	16	f	\N	CS	1	Alpha LUT Transfer Function	\N
5604	(0041,"WG12 Supplement 43",01)	(0041,"WG12 Supplement 43",01)	WG12 Supplement 43	65	1	f	\N	CS	1	Performed Protocol Type	\N
5605	(0009,"HMC - CT - ID",00)	(0009,"HMC - CT - ID",00)	HMC - CT - ID	9	0	f	\N	OB	1	Image ID Information Patient Name ID	\N
5606	(0009,"HMC - CT - ID",01)	(0009,"HMC - CT - ID",01)	HMC - CT - ID	9	1	f	\N	OB	1	Image ID Information Patient Comment	\N
5607	(0019,"SET WINDOW",00)	(0019,"SET WINDOW",00)	SET WINDOW	25	0	f	\N	SH	1	Set Window Image Filter	\N
5608	(0019,"SET WINDOW",01)	(0019,"SET WINDOW",01)	SET WINDOW	25	1	f	\N	US	1	Set Window Magnification Power	\N
5609	(0017,"SVISION",20)	(0017,"SVISION",20)	SVISION	23	32	f	\N	SQ	1	Scheduled Procedure Step List	\N
5610	(0017,"SVISION",a0)	(0017,"SVISION",a0)	SVISION	23	160	f	\N	IS	1	Fixed Grid System	\N
5611	(0017,"SVISION",f0)	(0017,"SVISION",f0)	SVISION	23	240	f	\N	IS	1	Images SOP Class	\N
5612	(0019,"SVISION",16)	(0019,"SVISION",16)	SVISION	25	22	f	\N	IS	1	Unknown	\N
5613	(0019,"SVISION",91)	(0019,"SVISION",91)	SVISION	25	145	f	\N	IS	1	Central Beam X	\N
5614	(0019,"SVISION",92)	(0019,"SVISION",92)	SVISION	25	146	f	\N	IS	1	Central Beam Y	\N
5615	(0019,"SVISION",93)	(0019,"SVISION",93)	SVISION	25	147	f	\N	IS	1	Tube Turn Angle	\N
5616	(0019,"SVISION",94)	(0019,"SVISION",94)	SVISION	25	148	f	\N	IS	1	Stand Drive Level	\N
5617	(0019,"SVISION",a0)	(0019,"SVISION",a0)	SVISION	25	160	f	\N	DS	1	Extended Exposure Time	\N
5618	(0019,"SVISION",a1)	(0019,"SVISION",a1)	SVISION	25	161	f	\N	DS	1	Actual Exposure Time	\N
5619	(0019,"SVISION",a8)	(0019,"SVISION",a8)	SVISION	25	168	f	\N	DS	1	Extended X-ray Tube Current	\N
5620	(0019,"SVISION",b0)	(0019,"SVISION",b0)	SVISION	25	176	f	\N	IS	1	Dose Indicator	\N
5621	(0019,"SVISION",b1)	(0019,"SVISION",b1)	SVISION	25	177	f	\N	IS	1	Shift Reference Value	\N
5622	(0019,"SVISION",f0)	(0019,"SVISION",f0)	SVISION	25	240	f	\N	IS	1	Unknown	\N
5623	(0021,"SVISION",50)	(0021,"SVISION",50)	SVISION	33	80	f	\N	DS	1	Minimal Window Latitude	\N
5624	(0021,"SVISION",51)	(0021,"SVISION",51)	SVISION	33	81	f	\N	DS	1	Maximal Window Latitude	\N
5625	(0021,"SVISION",52)	(0021,"SVISION",52)	SVISION	33	82	f	\N	DS	1	Relative Window Alignment	\N
5626	(0021,"SVISION",60)	(0021,"SVISION",60)	SVISION	33	96	f	\N	IS	1	Decomposition Layer	\N
5627	(0023,"SVISION",f0)	(0023,"SVISION",f0)	SVISION	35	240	f	\N	IS	1	Image SOP Class	\N
5628	(0025,"SVISION",09)	(0025,"SVISION",09)	SVISION	37	9	f	\N	IS	1	Image Stitched Manually	\N
5629	(0025,"SVISION",0a)	(0025,"SVISION",0a)	SVISION	37	10	f	\N	IS	1	Image Stitched Automatically	\N
5630	(0029,"SVISION",00)	(0029,"SVISION",00)	SVISION	41	0	f	\N	IS	1	Key Note Instance UID	\N
5631	(0029,"SVISION",01)	(0029,"SVISION",01)	SVISION	41	1	f	\N	IS	1	Storage State	\N
5632	(0029,"SVISION",02)	(0029,"SVISION",02)	SVISION	41	2	f	\N	IS	1	Referenced Image SOP Class	\N
5633	(0029,"SVISION",03)	(0029,"SVISION",03)	SVISION	41	3	f	\N	IS	1	Referenced Image Instance UID	\N
5634	(0029,"SVISION",04)	(0029,"SVISION",04)	SVISION	41	4	f	\N	IS	1	Related Presentation State Number	\N
5635	(0029,"SVISION",05)	(0029,"SVISION",05)	SVISION	41	5	f	\N	IS	1	Related Presentation State UID	\N
5636	(5653,"Vital Images SW 3.4",10)	(5653,"Vital Images SW 3.4",10)	Vital Images SW 3.4	22099	16	f	\N	OB	1	Saved Workflow	\N
5637	(5653,"Vital Images SW 3.4",11)	(5653,"Vital Images SW 3.4",11)	Vital Images SW 3.4	22099	17	f	\N	LO	1	Saved Workflow File Name	\N
5638	(5653,"Vital Images SW 3.4",12)	(5653,"Vital Images SW 3.4",12)	Vital Images SW 3.4	22099	18	f	\N	OB	1	Saved Workflow File Data	\N
5639	(5653,"Vital Images SW 3.4",13)	(5653,"Vital Images SW 3.4",13)	Vital Images SW 3.4	22099	19	f	\N	SL	1	Saved Workflow File Length	\N
5640	(5653,"Vital Images SW 3.4",14)	(5653,"Vital Images SW 3.4",14)	Vital Images SW 3.4	22099	20	f	\N	SQ	1	Saved Workflow File Sequence	\N
5641	(5653,"Vital Images SW 3.4",15)	(5653,"Vital Images SW 3.4",15)	Vital Images SW 3.4	22099	21	f	\N	SQ	1	Image Sequence	\N
5642	(5653,"Vital Images SW 3.4",16)	(5653,"Vital Images SW 3.4",16)	Vital Images SW 3.4	22099	22	f	\N	SL	1	Volume Interpolated Slices	\N
5643	(5653,"Vital Images SW 3.4",17)	(5653,"Vital Images SW 3.4",17)	Vital Images SW 3.4	22099	23	f	\N	UI	1	Volume SOP Instance UID	\N
5644	(5653,"Vital Images SW 3.4",18)	(5653,"Vital Images SW 3.4",18)	Vital Images SW 3.4	22099	24	f	\N	SH	1	Saved Workflow Mark	\N
5645	(5653,"Vital Images SW 3.4",19)	(5653,"Vital Images SW 3.4",19)	Vital Images SW 3.4	22099	25	f	\N	UI	1	Volume Study Instance UID	\N
5646	(5653,"Vital Images SW 3.4",20)	(5653,"Vital Images SW 3.4",20)	Vital Images SW 3.4	22099	32	f	\N	SL	1	Number of Study Saved Workflow	\N
5647	(5653,"Vital Images SW 3.4",21)	(5653,"Vital Images SW 3.4",21)	Vital Images SW 3.4	22099	33	f	\N	SL	1	Number of Series Saved Workflow	\N
5648	(5653,"Vital Images SW 3.4",22)	(5653,"Vital Images SW 3.4",22)	Vital Images SW 3.4	22099	34	f	\N	UI	1	Volume Series Instance UID	\N
5649	(5653,"Vital Images SW 3.4",23)	(5653,"Vital Images SW 3.4",23)	Vital Images SW 3.4	22099	35	f	\N	LO	1	Saved Workflow Code Meaning	\N
5650	(5653,"Vital Images SW 3.4",24)	(5653,"Vital Images SW 3.4",24)	Vital Images SW 3.4	22099	36	f	\N	OB	1	Saved Workflow Data	\N
5651	(5653,"Vital Images SW 3.4",25)	(5653,"Vital Images SW 3.4",25)	Vital Images SW 3.4	22099	37	f	\N	SL	1	Saved Workflow Data Length	\N
5652	(0781,"PI Private Block (0781:3000 - 0781:30FF)",01)	(0781,"PI Private Block (0781:3000 - 0781:30FF)",01)	PI Private Block (0781:3000 - 0781:30FF)	1921	1	f	\N	US	1	Unknown	\N
5653	(0781,"PI Private Block (0781:3000 - 0781:30FF)",02)	(0781,"PI Private Block (0781:3000 - 0781:30FF)",02)	PI Private Block (0781:3000 - 0781:30FF)	1921	2	f	\N	US	1	Unknown	\N
5654	(0781,"PI Private Block (0781:3000 - 0781:30FF)",05)	(0781,"PI Private Block (0781:3000 - 0781:30FF)",05)	PI Private Block (0781:3000 - 0781:30FF)	1921	5	f	\N	FL	1	Unknown	\N
5655	(0781,"PI Private Block (0781:3000 - 0781:30FF)",09)	(0781,"PI Private Block (0781:3000 - 0781:30FF)",09)	PI Private Block (0781:3000 - 0781:30FF)	1921	9	f	\N	FL	4	Unknown	\N
5656	(0203,"Riverain Medical",00)	(0203,"Riverain Medical",00)	Riverain Medical	515	0	f	\N	LO	1	Unknown	\N
5657	(0203,"Riverain Medical",01)	(0203,"Riverain Medical",01)	Riverain Medical	515	1	f	\N	LO	1	Unknown	\N
5658	(0203,"Riverain Medical",02)	(0203,"Riverain Medical",02)	Riverain Medical	515	2	f	\N	LO	1	Unknown	\N
5659	(0203,"Riverain Medical",03)	(0203,"Riverain Medical",03)	Riverain Medical	515	3	f	\N	LO	1	Unknown	\N
5660	(0203,"Riverain Medical",10)	(0203,"Riverain Medical",10)	Riverain Medical	515	16	f	\N	LO	1	Unknown	\N
5661	(0203,"Riverain Medical",f0)	(0203,"Riverain Medical",f0)	Riverain Medical	515	240	f	\N	UI	1	Unknown	\N
5662	(0203,"Riverain Medical",f1)	(0203,"Riverain Medical",f1)	Riverain Medical	515	241	f	\N	UI	1	Unknown	\N
5663	(0029,"INTELERAD MEDICAL SYSTEMS",16)	(0029,"INTELERAD MEDICAL SYSTEMS",16)	INTELERAD MEDICAL SYSTEMS	41	22	f	\N	US	1	Unknown	\N
5664	(0029,"INTELERAD MEDICAL SYSTEMS",17)	(0029,"INTELERAD MEDICAL SYSTEMS",17)	INTELERAD MEDICAL SYSTEMS	41	23	f	\N	US	1	Unknown	\N
5665	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",01)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",01)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	1	f	\N	LO	1	Unknown	\N
5666	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",02)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",02)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	2	f	\N	LO	1	Unknown	\N
5667	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",03)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",03)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	3	f	\N	UN	1	Unknown	\N
5668	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",04)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",04)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	4	f	\N	UN	1	Unknown	\N
5669	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",05)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",05)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	5	f	\N	UN	1	Unknown	\N
5670	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",06)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",06)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	6	f	\N	UN	1	Unknown	\N
5671	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",07)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",07)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	7	f	\N	UN	1	Unknown	\N
5672	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",0a)	(0071,"INTELERAD MEDICAL SYSTEMS INTELEVIEWER",0a)	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	113	10	f	\N	UN	1	Unknown	\N
5673	(3f01,"INTELERAD MEDICAL SYSTEMS",09)	(3f01,"INTELERAD MEDICAL SYSTEMS",09)	INTELERAD MEDICAL SYSTEMS	16129	9	f	\N	LO	1	Unknown	\N
5674	(3f01,"INTELERAD MEDICAL SYSTEMS",0a)	(3f01,"INTELERAD MEDICAL SYSTEMS",0a)	INTELERAD MEDICAL SYSTEMS	16129	10	f	\N	DA	1	Unknown	\N
5675	(3f01,"INTELERAD MEDICAL SYSTEMS",0b)	(3f01,"INTELERAD MEDICAL SYSTEMS",0b)	INTELERAD MEDICAL SYSTEMS	16129	11	f	\N	TM	1	Unknown	\N
5676	(3f03,"INTELERAD MEDICAL SYSTEMS",01)	(3f03,"INTELERAD MEDICAL SYSTEMS",01)	INTELERAD MEDICAL SYSTEMS	16131	1	f	\N	SQ	1	Unknown	\N
5677	(3f03,"INTELERAD MEDICAL SYSTEMS",02)	(3f03,"INTELERAD MEDICAL SYSTEMS",02)	INTELERAD MEDICAL SYSTEMS	16131	2	f	\N	DT	1	Unknown	\N
5678	(3f03,"INTELERAD MEDICAL SYSTEMS",03)	(3f03,"INTELERAD MEDICAL SYSTEMS",03)	INTELERAD MEDICAL SYSTEMS	16131	3	f	\N	LO	1	Unknown	\N
5679	(3f03,"INTELERAD MEDICAL SYSTEMS",04)	(3f03,"INTELERAD MEDICAL SYSTEMS",04)	INTELERAD MEDICAL SYSTEMS	16131	4	f	\N	LO	1	Unknown	\N
5680	(4453,"DR Systems, Inc.",00)	(4453,"DR Systems, Inc.",00)	DR Systems, Inc.	17491	0	f	\N	LO	1	Exam ?	\N
5681	(4453,"DR Systems, Inc.",01)	(4453,"DR Systems, Inc.",01)	DR Systems, Inc.	17491	1	f	\N	LO	1	Exam ID	\N
5682	(4453,"DR Systems, Inc.",02)	(4453,"DR Systems, Inc.",02)	DR Systems, Inc.	17491	2	f	\N	LO	1	Image Type	\N
5683	(4453,"DR Systems, Inc.",04)	(4453,"DR Systems, Inc.",04)	DR Systems, Inc.	17491	4	f	\N	LO	1	File Type	\N
5684	(4453,"DR Systems, Inc.",05)	(4453,"DR Systems, Inc.",05)	DR Systems, Inc.	17491	5	f	\N	LO	1	File Suffix	\N
5685	(4453,"DR Systems, Inc.",0a)	(4453,"DR Systems, Inc.",0a)	DR Systems, Inc.	17491	10	f	\N	LO	1	Annotation Type	\N
5686	(4453,"DR Systems, Inc.",0c)	(4453,"DR Systems, Inc.",0c)	DR Systems, Inc.	17491	12	f	\N	SQ	1	Original Instance UID Sequence	\N
5687	(0859,"ETIAM DICOMDIR",40)	(0859,"ETIAM DICOMDIR",40)	ETIAM DICOMDIR	2137	64	f	\N	DS	1	Unknown	\N
5688	(0077,"TERARECON AQUARIUS",10)	(0077,"TERARECON AQUARIUS",10)	TERARECON AQUARIUS	119	16	f	\N	UI	1-n	Original Series/Study UID	\N
5689	(0077,"TERARECON AQUARIUS",12)	(0077,"TERARECON AQUARIUS",12)	TERARECON AQUARIUS	119	18	f	\N	UI	1-n	Original SOP UID	\N
5690	(0077,"TERARECON AQUARIUS",14)	(0077,"TERARECON AQUARIUS",14)	TERARECON AQUARIUS	119	20	f	\N	LO	1-n	Referenced Volume ID	\N
5691	(0077,"TERARECON AQUARIUS",16)	(0077,"TERARECON AQUARIUS",16)	TERARECON AQUARIUS	119	22	f	\N	CS	1	Binary Data Name SCS	\N
5692	(0077,"TERARECON AQUARIUS",20)	(0077,"TERARECON AQUARIUS",20)	TERARECON AQUARIUS	119	32	f	\N	LO	1-n	Binary Data Name	\N
5693	(0077,"TERARECON AQUARIUS",22)	(0077,"TERARECON AQUARIUS",22)	TERARECON AQUARIUS	119	34	f	\N	CS	1-n	Number of SOP Instance UID	\N
5694	(0077,"TERARECON AQUARIUS",24)	(0077,"TERARECON AQUARIUS",24)	TERARECON AQUARIUS	119	36	f	\N	CS	1-n	Number of Series Instance UID	\N
5695	(0077,"TERARECON AQUARIUS",26)	(0077,"TERARECON AQUARIUS",26)	TERARECON AQUARIUS	119	38	f	\N	US	1	Number of Binary Data	\N
5696	(0077,"TERARECON AQUARIUS",28)	(0077,"TERARECON AQUARIUS",28)	TERARECON AQUARIUS	119	40	f	\N	CS	1-n	Binary Data Type	\N
5697	(0077,"TERARECON AQUARIUS",30)	(0077,"TERARECON AQUARIUS",30)	TERARECON AQUARIUS	119	48	f	\N	UL	1-n	Binary Data Size	\N
5698	(0077,"TERARECON AQUARIUS",32)	(0077,"TERARECON AQUARIUS",32)	TERARECON AQUARIUS	119	50	f	\N	LO	1-n	Binary Data SubType	\N
5699	(0077,"TERARECON AQUARIUS",40)	(0077,"TERARECON AQUARIUS",40)	TERARECON AQUARIUS	119	64	f	\N	LO	1-n	Additional Information	\N
5700	(0077,"TERARECON AQUARIUS",50)	(0077,"TERARECON AQUARIUS",50)	TERARECON AQUARIUS	119	80	f	\N	OB	1	First Binary Data	\N
5701	(0077,"TERARECON AQUARIUS",60)	(0077,"TERARECON AQUARIUS",60)	TERARECON AQUARIUS	119	96	f	\N	OB	1	First Thumbnail	\N
5702	(0077,"TERARECON AQUARIUS",70)	(0077,"TERARECON AQUARIUS",70)	TERARECON AQUARIUS	119	112	f	\N	LO	1	Algorithm ID	\N
5703	(0077,"TERARECON AQUARIUS",80)	(0077,"TERARECON AQUARIUS",80)	TERARECON AQUARIUS	119	128	f	\N	LO	1	Volume ID	\N
5704	(0077,"TERARECON AQUARIUS",84)	(0077,"TERARECON AQUARIUS",84)	TERARECON AQUARIUS	119	132	f	\N	LO	1-n	COF Object UID	\N
5705	(0077,"TERARECON AQUARIUS",86)	(0077,"TERARECON AQUARIUS",86)	TERARECON AQUARIUS	119	134	f	\N	LO	1-n	Workflow Scene Status	\N
5706	(0077,"TERARECON AQUARIUS",88)	(0077,"TERARECON AQUARIUS",88)	TERARECON AQUARIUS	119	136	f	\N	UI	1-n	Reference SOP Instance UIDs	\N
5707	(0077,"TERARECON AQUARIUS",90)	(0077,"TERARECON AQUARIUS",90)	TERARECON AQUARIUS	119	144	f	\N	FL	1	COF Refinement Level	\N
5708	(0009,"EMAGEON STUDY HOME",00)	(0009,"EMAGEON STUDY HOME",00)	EMAGEON STUDY HOME	9	0	f	\N	LO	1	Unknown	\N
5709	(0009,"EMAGEON STUDY HOME",01)	(0009,"EMAGEON STUDY HOME",01)	EMAGEON STUDY HOME	9	1	f	\N	LO	1	Unknown	\N
5710	(0009,"EMAGEON JPEG2K INFO",00)	(0009,"EMAGEON JPEG2K INFO",00)	EMAGEON JPEG2K INFO	9	0	f	\N	SQ	1	Unknown	\N
5711	(0009,"EMAGEON JPEG2K INFO",01)	(0009,"EMAGEON JPEG2K INFO",01)	EMAGEON JPEG2K INFO	9	1	f	\N	DT	1	Unknown	\N
5712	(0029,"RadWorksMarconi",24)	(0029,"RadWorksMarconi",24)	RadWorksMarconi	41	36	f	\N	US	1-n	Key Frame Indices	\N
5713	(0009,"MeVis eatDicom",10)	(0009,"MeVis eatDicom",10)	MeVis eatDicom	9	16	f	\N	LO	1	eatDicom Version	\N
5714	(0009,"MeVis eatDicom",11)	(0009,"MeVis eatDicom",11)	MeVis eatDicom	9	17	f	\N	ST	1	eatDicom Options	\N
5715	(0021,"MeVis eD: Timepoint Information",10)	(0021,"MeVis eD: Timepoint Information",10)	MeVis eD: Timepoint Information	33	16	f	\N	LT	1	Timepoint DateTime	\N
5716	(0021,"MeVis eD: Timepoint Information",11)	(0021,"MeVis eD: Timepoint Information",11)	MeVis eD: Timepoint Information	33	17	f	\N	CS	1	Timepoint DateTime Type	\N
5717	(0021,"MeVis eD: Timepoint Information",12)	(0021,"MeVis eD: Timepoint Information",12)	MeVis eD: Timepoint Information	33	18	f	\N	UN	1	Timepoint Series Description	\N
5718	(0021,"MeVis eD: Timepoint Information",13)	(0021,"MeVis eD: Timepoint Information",13)	MeVis eD: Timepoint Information	33	19	f	\N	UN	1	Timepoint Gradient Directions	\N
5719	(0021,"MeVis eD: Timepoint Information",71)	(0021,"MeVis eD: Timepoint Information",71)	MeVis eD: Timepoint Information	33	113	f	\N	UN	1	Timepoint Empty Frames	\N
5720	(0021,"MeVis eD: Absolute Temporal Positions",10)	(0021,"MeVis eD: Absolute Temporal Positions",10)	MeVis eD: Absolute Temporal Positions	33	16	f	\N	LT	1	Timepoint DateTime	\N
5721	(0021,"MeVis eD: Absolute Temporal Positions",11)	(0021,"MeVis eD: Absolute Temporal Positions",11)	MeVis eD: Absolute Temporal Positions	33	17	f	\N	CS	1	Timepoint DateTime Type	\N
5722	(0021,"MeVis eD: Absolute Temporal Positions",12)	(0021,"MeVis eD: Absolute Temporal Positions",12)	MeVis eD: Absolute Temporal Positions	33	18	f	\N	UN	1	Timepoint Series Description	\N
5723	(0021,"MeVis eD: Absolute Temporal Positions",13)	(0021,"MeVis eD: Absolute Temporal Positions",13)	MeVis eD: Absolute Temporal Positions	33	19	f	\N	UN	1	Timepoint Gradient Directions	\N
5724	(0021,"MeVis eD: Absolute Temporal Positions",71)	(0021,"MeVis eD: Absolute Temporal Positions",71)	MeVis eD: Absolute Temporal Positions	33	113	f	\N	UN	1	Timepoint Empty Frames	\N
5725	(0021,"MeVis eD: Geometry Information",10)	(0021,"MeVis eD: Geometry Information",10)	MeVis eD: Geometry Information	33	16	f	\N	UN	1	Geometry Scanner Origin	\N
5726	(0021,"MeVis eD: Slice Information",10)	(0021,"MeVis eD: Slice Information",10)	MeVis eD: Slice Information	33	16	f	\N	UI	1-n	Slice SOP Instance UIDs	\N
5727	(0029,"ShowcaseAppearance",10)	(0029,"ShowcaseAppearance",10)	ShowcaseAppearance	41	16	f	\N	DS	1	Unknown	\N
5728	(0029,"ShowcaseAppearance",11)	(0029,"ShowcaseAppearance",11)	ShowcaseAppearance	41	17	f	\N	DS	1	Unknown	\N
5729	(0029,"ShowcaseAppearance",12)	(0029,"ShowcaseAppearance",12)	ShowcaseAppearance	41	18	f	\N	DS	1	Unknown	\N
5730	(0029,"ShowcaseAppearance",13)	(0029,"ShowcaseAppearance",13)	ShowcaseAppearance	41	19	f	\N	DS	1	Unknown	\N
5731	(0029,"ShowcaseAppearance",14)	(0029,"ShowcaseAppearance",14)	ShowcaseAppearance	41	20	f	\N	SQ	1	Unknown	\N
5732	(0099,"NQHeader",01)	(0099,"NQHeader",01)	NQHeader	153	1	f	\N	UI	1	Version	\N
5733	(0099,"NQHeader",02)	(0099,"NQHeader",02)	NQHeader	153	2	f	\N	UI	1	Analyzed Series UID	\N
5734	(0099,"NQHeader",03)	(0099,"NQHeader",03)	NQHeader	153	3	f	\N	LT	1	License	\N
5735	(0099,"NQHeader",04)	(0099,"NQHeader",04)	NQHeader	153	4	f	\N	SS	1	Return Code	\N
5736	(0099,"NQHeader",05)	(0099,"NQHeader",05)	NQHeader	153	5	f	\N	LT	1	Return Message	\N
5737	(0099,"NQHeader",10)	(0099,"NQHeader",10)	NQHeader	153	16	f	\N	FL	1	MI	\N
5738	(0099,"NQHeader",20)	(0099,"NQHeader",20)	NQHeader	153	32	f	\N	SH	1	Units	\N
5739	(0099,"NQHeader",21)	(0099,"NQHeader",21)	NQHeader	153	33	f	\N	FL	1	ICV	\N
5740	(0199,"NQLeft",01)	(0199,"NQLeft",01)	NQLeft	409	1	f	\N	FL	1	Left Cortical White Matter	\N
5741	(0199,"NQLeft",02)	(0199,"NQLeft",02)	NQLeft	409	2	f	\N	FL	1	Left Cortical Gray Matter	\N
5742	(0199,"NQLeft",03)	(0199,"NQLeft",03)	NQLeft	409	3	f	\N	FL	1	Left 3rd Ventricle	\N
5743	(0199,"NQLeft",04)	(0199,"NQLeft",04)	NQLeft	409	4	f	\N	FL	1	Left 4th Ventricle	\N
5744	(0199,"NQLeft",05)	(0199,"NQLeft",05)	NQLeft	409	5	f	\N	FL	1	Left 5th Ventricle	\N
5745	(0199,"NQLeft",06)	(0199,"NQLeft",06)	NQLeft	409	6	f	\N	FL	1	Left Lateral Ventricle	\N
5746	(0199,"NQLeft",07)	(0199,"NQLeft",07)	NQLeft	409	7	f	\N	FL	1	Left Inferior Lateral Ventricle	\N
5747	(0199,"NQLeft",08)	(0199,"NQLeft",08)	NQLeft	409	8	f	\N	FL	1	Left Inferior CSF	\N
5748	(0199,"NQLeft",09)	(0199,"NQLeft",09)	NQLeft	409	9	f	\N	FL	1	Left Cerebellar White Matter	\N
5749	(0199,"NQLeft",0a)	(0199,"NQLeft",0a)	NQLeft	409	10	f	\N	FL	1	Left Cerebellar Gray Matter	\N
5750	(0199,"NQLeft",0b)	(0199,"NQLeft",0b)	NQLeft	409	11	f	\N	FL	1	Left Hippocampus	\N
5751	(0199,"NQLeft",0c)	(0199,"NQLeft",0c)	NQLeft	409	12	f	\N	FL	1	Left Amygdala	\N
5752	(0199,"NQLeft",0d)	(0199,"NQLeft",0d)	NQLeft	409	13	f	\N	FL	1	Left Thalamus	\N
5753	(0199,"NQLeft",0e)	(0199,"NQLeft",0e)	NQLeft	409	14	f	\N	FL	1	Left Caudate	\N
5754	(0199,"NQLeft",0f)	(0199,"NQLeft",0f)	NQLeft	409	15	f	\N	FL	1	Left Putamen	\N
5755	(0199,"NQLeft",10)	(0199,"NQLeft",10)	NQLeft	409	16	f	\N	FL	1	Left Pallidum	\N
5756	(0199,"NQLeft",11)	(0199,"NQLeft",11)	NQLeft	409	17	f	\N	FL	1	Left Ventral Diencephalon	\N
5759	(0199,"NQLeft",14)	(0199,"NQLeft",14)	NQLeft	409	20	f	\N	FL	1	Left Exterior CSF	\N
5760	(0199,"NQLeft",15)	(0199,"NQLeft",15)	NQLeft	409	21	f	\N	FL	1	Left WM Hypo	\N
5761	(0199,"NQLeft",16)	(0199,"NQLeft",16)	NQLeft	409	22	f	\N	FL	1	Left Other	\N
5762	(0199,"NQLeft",17)	(0199,"NQLeft",17)	NQLeft	409	23	f	\N	FL	1	Left Cortex Unkown	\N
5763	(0199,"NQLeft",18)	(0199,"NQLeft",18)	NQLeft	409	24	f	\N	FL	1	Left Cortex Bankssts	\N
5764	(0199,"NQLeft",19)	(0199,"NQLeft",19)	NQLeft	409	25	f	\N	FL	1	Left Cortex Caudal Anterior Cingulate	\N
5765	(0199,"NQLeft",1a)	(0199,"NQLeft",1a)	NQLeft	409	26	f	\N	FL	1	Left Cortex Caudal Middle Frontal	\N
5766	(0199,"NQLeft",1b)	(0199,"NQLeft",1b)	NQLeft	409	27	f	\N	FL	1	Left Cortex Corpus Callosum	\N
5767	(0199,"NQLeft",1c)	(0199,"NQLeft",1c)	NQLeft	409	28	f	\N	FL	1	Left Cortex Cuneus	\N
5768	(0199,"NQLeft",1d)	(0199,"NQLeft",1d)	NQLeft	409	29	f	\N	FL	1	Left Cortex Entorhinal	\N
5769	(0199,"NQLeft",1e)	(0199,"NQLeft",1e)	NQLeft	409	30	f	\N	FL	1	Left Cortex Fusiform	\N
5770	(0199,"NQLeft",1f)	(0199,"NQLeft",1f)	NQLeft	409	31	f	\N	FL	1	Left Cortex Inferior Parietal	\N
5771	(0199,"NQLeft",20)	(0199,"NQLeft",20)	NQLeft	409	32	f	\N	FL	1	Left Cortex Inferior Temporal	\N
5772	(0199,"NQLeft",21)	(0199,"NQLeft",21)	NQLeft	409	33	f	\N	FL	1	Left Cortex Isthmus Cingulate	\N
5773	(0199,"NQLeft",22)	(0199,"NQLeft",22)	NQLeft	409	34	f	\N	FL	1	Left Cortex Lateral Occipital	\N
5774	(0199,"NQLeft",23)	(0199,"NQLeft",23)	NQLeft	409	35	f	\N	FL	1	Left Cortex Lateral Orbito Frontal	\N
5775	(0199,"NQLeft",24)	(0199,"NQLeft",24)	NQLeft	409	36	f	\N	FL	1	Left Cortex Lingual	\N
5776	(0199,"NQLeft",25)	(0199,"NQLeft",25)	NQLeft	409	37	f	\N	FL	1	Left Cortex Medial Orbito Frontal	\N
5777	(0199,"NQLeft",26)	(0199,"NQLeft",26)	NQLeft	409	38	f	\N	FL	1	Left Cortex Middle Temporal	\N
5778	(0199,"NQLeft",27)	(0199,"NQLeft",27)	NQLeft	409	39	f	\N	FL	1	Left Cortex Parahippocampal	\N
5779	(0199,"NQLeft",28)	(0199,"NQLeft",28)	NQLeft	409	40	f	\N	FL	1	Left Cortex Paracentral	\N
5780	(0199,"NQLeft",29)	(0199,"NQLeft",29)	NQLeft	409	41	f	\N	FL	1	Left Cortex Pars Opercularis	\N
5781	(0199,"NQLeft",2a)	(0199,"NQLeft",2a)	NQLeft	409	42	f	\N	FL	1	Left Cortex Pars Orbitalis	\N
5782	(0199,"NQLeft",2b)	(0199,"NQLeft",2b)	NQLeft	409	43	f	\N	FL	1	Left Cortex Pars Triangularis	\N
5783	(0199,"NQLeft",2c)	(0199,"NQLeft",2c)	NQLeft	409	44	f	\N	FL	1	Left Cortex Pericalcarine	\N
5784	(0199,"NQLeft",2d)	(0199,"NQLeft",2d)	NQLeft	409	45	f	\N	FL	1	Left Cortex Postcentral	\N
5785	(0199,"NQLeft",2e)	(0199,"NQLeft",2e)	NQLeft	409	46	f	\N	FL	1	Left Cortex Posterior Cingulate	\N
5786	(0199,"NQLeft",2f)	(0199,"NQLeft",2f)	NQLeft	409	47	f	\N	FL	1	Left Cortex Precentral	\N
5787	(0199,"NQLeft",30)	(0199,"NQLeft",30)	NQLeft	409	48	f	\N	FL	1	Left Cortex Precuneus	\N
5788	(0199,"NQLeft",31)	(0199,"NQLeft",31)	NQLeft	409	49	f	\N	FL	1	Left Cortex Rostral Anterior Cingulate	\N
5789	(0199,"NQLeft",32)	(0199,"NQLeft",32)	NQLeft	409	50	f	\N	FL	1	Left Cortex Rostral Middle Frontal	\N
5790	(0199,"NQLeft",33)	(0199,"NQLeft",33)	NQLeft	409	51	f	\N	FL	1	Left Cortex Superior Frontal	\N
5791	(0199,"NQLeft",34)	(0199,"NQLeft",34)	NQLeft	409	52	f	\N	FL	1	Left Cortex Superior Parietal	\N
5792	(0199,"NQLeft",35)	(0199,"NQLeft",35)	NQLeft	409	53	f	\N	FL	1	Left Cortex Superior Temporal	\N
5793	(0199,"NQLeft",36)	(0199,"NQLeft",36)	NQLeft	409	54	f	\N	FL	1	Left Cortex Supramarginal	\N
5794	(0199,"NQLeft",37)	(0199,"NQLeft",37)	NQLeft	409	55	f	\N	FL	1	Left Cortex Frontal Pole	\N
5795	(0199,"NQLeft",38)	(0199,"NQLeft",38)	NQLeft	409	56	f	\N	FL	1	Left Cortex Temporal Pole	\N
5796	(0199,"NQLeft",39)	(0199,"NQLeft",39)	NQLeft	409	57	f	\N	FL	1	Left Cortex Transvere Temporal	\N
5797	(0199,"NQLeft",3a)	(0199,"NQLeft",3a)	NQLeft	409	58	f	\N	FL	1	Left Meningie	\N
5798	(0299,"NQRight",01)	(0299,"NQRight",01)	NQRight	665	1	f	\N	FL	1	Right Cortical White Matter	\N
5799	(0299,"NQRight",02)	(0299,"NQRight",02)	NQRight	665	2	f	\N	FL	1	Right Cortical Gray Matter	\N
5800	(0299,"NQRight",03)	(0299,"NQRight",03)	NQRight	665	3	f	\N	FL	1	Right 3rd Ventricle	\N
5801	(0299,"NQRight",04)	(0299,"NQRight",04)	NQRight	665	4	f	\N	FL	1	Right 4th Ventricle	\N
5802	(0299,"NQRight",05)	(0299,"NQRight",05)	NQRight	665	5	f	\N	FL	1	Right 5th Ventricle	\N
5803	(0299,"NQRight",06)	(0299,"NQRight",06)	NQRight	665	6	f	\N	FL	1	Right Lateral Ventricle	\N
5804	(0299,"NQRight",07)	(0299,"NQRight",07)	NQRight	665	7	f	\N	FL	1	Right Inferior Lateral Ventricle	\N
5805	(0299,"NQRight",08)	(0299,"NQRight",08)	NQRight	665	8	f	\N	FL	1	Right Inferior CSF	\N
5806	(0299,"NQRight",09)	(0299,"NQRight",09)	NQRight	665	9	f	\N	FL	1	Right Cerebellar White Matter	\N
5807	(0299,"NQRight",0a)	(0299,"NQRight",0a)	NQRight	665	10	f	\N	FL	1	Right Cerebellar Gray Matter	\N
5808	(0299,"NQRight",0b)	(0299,"NQRight",0b)	NQRight	665	11	f	\N	FL	1	Right Hippocampus	\N
5809	(0299,"NQRight",0c)	(0299,"NQRight",0c)	NQRight	665	12	f	\N	FL	1	Right Amygdala	\N
5810	(0299,"NQRight",0d)	(0299,"NQRight",0d)	NQRight	665	13	f	\N	FL	1	Right Thalamus	\N
5811	(0299,"NQRight",0e)	(0299,"NQRight",0e)	NQRight	665	14	f	\N	FL	1	Right Caudate	\N
5812	(0299,"NQRight",0f)	(0299,"NQRight",0f)	NQRight	665	15	f	\N	FL	1	Right Putamen	\N
5813	(0299,"NQRight",10)	(0299,"NQRight",10)	NQRight	665	16	f	\N	FL	1	Right Pallidum	\N
5814	(0299,"NQRight",11)	(0299,"NQRight",11)	NQRight	665	17	f	\N	FL	1	Right Ventral Diencephalon	\N
5815	(0299,"NQRight",12)	(0299,"NQRight",12)	NQRight	665	18	f	\N	FL	1	Right Nucleus Accumbens	\N
5816	(0299,"NQRight",13)	(0299,"NQRight",13)	NQRight	665	19	f	\N	FL	1	Right Brain Stem	\N
5817	(0299,"NQRight",14)	(0299,"NQRight",14)	NQRight	665	20	f	\N	FL	1	Right Exterior CSF	\N
5818	(0299,"NQRight",15)	(0299,"NQRight",15)	NQRight	665	21	f	\N	FL	1	Right WM Hypo	\N
5819	(0299,"NQRight",16)	(0299,"NQRight",16)	NQRight	665	22	f	\N	FL	1	Right Other	\N
5820	(0299,"NQRight",17)	(0299,"NQRight",17)	NQRight	665	23	f	\N	FL	1	Right Cortex Unkown	\N
5821	(0299,"NQRight",18)	(0299,"NQRight",18)	NQRight	665	24	f	\N	FL	1	Right Cortex Bankssts	\N
5822	(0299,"NQRight",19)	(0299,"NQRight",19)	NQRight	665	25	f	\N	FL	1	Right Cortex Caudal Anterior Cingulate	\N
5823	(0299,"NQRight",1a)	(0299,"NQRight",1a)	NQRight	665	26	f	\N	FL	1	Right Cortex Caudal Middle Frontal	\N
5824	(0299,"NQRight",1b)	(0299,"NQRight",1b)	NQRight	665	27	f	\N	FL	1	Right Cortex Corpus Callosum	\N
5825	(0299,"NQRight",1c)	(0299,"NQRight",1c)	NQRight	665	28	f	\N	FL	1	Right Cortex Cuneus	\N
5826	(0299,"NQRight",1d)	(0299,"NQRight",1d)	NQRight	665	29	f	\N	FL	1	Right Cortex Entorhinal	\N
5827	(0299,"NQRight",1e)	(0299,"NQRight",1e)	NQRight	665	30	f	\N	FL	1	Right Cortex Fusiform	\N
5828	(0299,"NQRight",1f)	(0299,"NQRight",1f)	NQRight	665	31	f	\N	FL	1	Right Cortex Inferior Parietal	\N
5829	(0299,"NQRight",20)	(0299,"NQRight",20)	NQRight	665	32	f	\N	FL	1	Right Cortex Inferior Temporal	\N
5830	(0299,"NQRight",21)	(0299,"NQRight",21)	NQRight	665	33	f	\N	FL	1	Right Cortex Isthmus Cingulate	\N
5831	(0299,"NQRight",22)	(0299,"NQRight",22)	NQRight	665	34	f	\N	FL	1	Right Cortex Lateral Occipital	\N
5832	(0299,"NQRight",23)	(0299,"NQRight",23)	NQRight	665	35	f	\N	FL	1	Right Cortex Lateral Orbito Frontal	\N
5833	(0299,"NQRight",24)	(0299,"NQRight",24)	NQRight	665	36	f	\N	FL	1	Right Cortex Lingual	\N
5834	(0299,"NQRight",25)	(0299,"NQRight",25)	NQRight	665	37	f	\N	FL	1	Right Cortex Medial Orbito Frontal	\N
5835	(0299,"NQRight",26)	(0299,"NQRight",26)	NQRight	665	38	f	\N	FL	1	Right Cortex Middle Temporal	\N
5836	(0299,"NQRight",27)	(0299,"NQRight",27)	NQRight	665	39	f	\N	FL	1	Right Cortex Parahippocampal	\N
5837	(0299,"NQRight",28)	(0299,"NQRight",28)	NQRight	665	40	f	\N	FL	1	Right Cortex Paracentral	\N
5838	(0299,"NQRight",29)	(0299,"NQRight",29)	NQRight	665	41	f	\N	FL	1	Right Cortex Pars Opercularis	\N
5839	(0299,"NQRight",2a)	(0299,"NQRight",2a)	NQRight	665	42	f	\N	FL	1	Right Cortex Pars Orbitalis	\N
5840	(0299,"NQRight",2b)	(0299,"NQRight",2b)	NQRight	665	43	f	\N	FL	1	Right Cortex Pars Triangularis	\N
5841	(0299,"NQRight",2c)	(0299,"NQRight",2c)	NQRight	665	44	f	\N	FL	1	Right Cortex Pericalcarine	\N
5842	(0299,"NQRight",2d)	(0299,"NQRight",2d)	NQRight	665	45	f	\N	FL	1	Right Cortex Postcentral	\N
5843	(0299,"NQRight",2e)	(0299,"NQRight",2e)	NQRight	665	46	f	\N	FL	1	Right Cortex Posterior Cingulate	\N
5844	(0299,"NQRight",2f)	(0299,"NQRight",2f)	NQRight	665	47	f	\N	FL	1	Right Cortex Precentral	\N
5845	(0299,"NQRight",30)	(0299,"NQRight",30)	NQRight	665	48	f	\N	FL	1	Right Cortex Precuneus	\N
5846	(0299,"NQRight",31)	(0299,"NQRight",31)	NQRight	665	49	f	\N	FL	1	Right Cortex Rostral Anterior Cingulate	\N
5847	(0299,"NQRight",32)	(0299,"NQRight",32)	NQRight	665	50	f	\N	FL	1	Right Cortex Rostral Middle Frontal	\N
5848	(0299,"NQRight",33)	(0299,"NQRight",33)	NQRight	665	51	f	\N	FL	1	Right Cortex Superior Frontal	\N
5849	(0299,"NQRight",34)	(0299,"NQRight",34)	NQRight	665	52	f	\N	FL	1	Right Cortex Superior Parietal	\N
5850	(0299,"NQRight",35)	(0299,"NQRight",35)	NQRight	665	53	f	\N	FL	1	Right Cortex Superior Temporal	\N
5851	(0299,"NQRight",36)	(0299,"NQRight",36)	NQRight	665	54	f	\N	FL	1	Right Cortex Supramarginal	\N
5852	(0299,"NQRight",37)	(0299,"NQRight",37)	NQRight	665	55	f	\N	FL	1	Right Cortex Frontal Pole	\N
5853	(0299,"NQRight",38)	(0299,"NQRight",38)	NQRight	665	56	f	\N	FL	1	Right Cortex Temporal Pole	\N
5854	(0299,"NQRight",39)	(0299,"NQRight",39)	NQRight	665	57	f	\N	FL	1	Right Cortex Transvere Temporal	\N
5855	(0299,"NQRight",3a)	(0299,"NQRight",3a)	NQRight	665	58	f	\N	FL	1	Right Meningie	\N
5860	(0055,"VEPRO VIF 3.0 DATA",20)	(0055,"VEPRO VIF 3.0 DATA",20)	VEPRO VIF 3.0 DATA	85	32	f	\N	OB	1	Unknown	\N
5861	(0055,"VEPRO VIF 3.0 DATA",30)	(0055,"VEPRO VIF 3.0 DATA",30)	VEPRO VIF 3.0 DATA	85	48	f	\N	OB	1	Icon Data	\N
5862	(0055,"VEPRO VIF 3.0 DATA",65)	(0055,"VEPRO VIF 3.0 DATA",65)	VEPRO VIF 3.0 DATA	85	101	f	\N	OB	1	Image Hash Value	\N
5863	(0055,"VEPRO VIM 5.0 DATA",10)	(0055,"VEPRO VIM 5.0 DATA",10)	VEPRO VIM 5.0 DATA	85	16	f	\N	OB	1	Unknown	\N
5864	(0055,"VEPRO VIM 5.0 DATA",20)	(0055,"VEPRO VIM 5.0 DATA",20)	VEPRO VIM 5.0 DATA	85	32	f	\N	OB	1	Unknown	\N
5865	(0055,"VEPRO VIM 5.0 DATA",30)	(0055,"VEPRO VIM 5.0 DATA",30)	VEPRO VIM 5.0 DATA	85	48	f	\N	OB	1	Icon Data	\N
5866	(0055,"VEPRO VIM 5.0 DATA",51)	(0055,"VEPRO VIM 5.0 DATA",51)	VEPRO VIM 5.0 DATA	85	81	f	\N	UI	1	Unknown	\N
5867	(0055,"VEPRO VIM 5.0 DATA",65)	(0055,"VEPRO VIM 5.0 DATA",65)	VEPRO VIM 5.0 DATA	85	101	f	\N	OB	1	Image Hash Value	\N
5868	(0057,"VEPRO BROKER 1.0",10)	(0057,"VEPRO BROKER 1.0",10)	VEPRO BROKER 1.0	87	16	f	\N	SQ	1	Data Replace Sequence	\N
5869	(0057,"VEPRO BROKER 1.0 DATA REPLACE",20)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",20)	VEPRO BROKER 1.0 DATA REPLACE	87	32	f	\N	SQ	1	Original Data Sequence	\N
5870	(0057,"VEPRO BROKER 1.0 DATA REPLACE",30)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",30)	VEPRO BROKER 1.0 DATA REPLACE	87	48	f	\N	SQ	1	Replaced Data Sequence	\N
5871	(0057,"VEPRO BROKER 1.0 DATA REPLACE",40)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",40)	VEPRO BROKER 1.0 DATA REPLACE	87	64	f	\N	DA	1	Date of Data Replacement	\N
5872	(0057,"VEPRO BROKER 1.0 DATA REPLACE",41)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",41)	VEPRO BROKER 1.0 DATA REPLACE	87	65	f	\N	TM	1	Time of Data Replacement	\N
5873	(0057,"VEPRO BROKER 1.0 DATA REPLACE",42)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",42)	VEPRO BROKER 1.0 DATA REPLACE	87	66	f	\N	LO	1	Dicom Receive Node	\N
5874	(0057,"VEPRO BROKER 1.0 DATA REPLACE",43)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",43)	VEPRO BROKER 1.0 DATA REPLACE	87	67	f	\N	LO	1	Application Name	\N
5875	(0057,"VEPRO BROKER 1.0 DATA REPLACE",44)	(0057,"VEPRO BROKER 1.0 DATA REPLACE",44)	VEPRO BROKER 1.0 DATA REPLACE	87	68	f	\N	LO	1	Computer Name	\N
5876	(0059,"VEPRO DICOM TRANSFER 1.0",10)	(0059,"VEPRO DICOM TRANSFER 1.0",10)	VEPRO DICOM TRANSFER 1.0	89	16	f	\N	SQ	1	Dicom Transfer Info	\N
5877	(0059,"VEPRO DICOM RECEIVE DATA 1.0",40)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",40)	VEPRO DICOM RECEIVE DATA 1.0	89	64	f	\N	DA	1	Receive Date	\N
5878	(0059,"VEPRO DICOM RECEIVE DATA 1.0",41)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",41)	VEPRO DICOM RECEIVE DATA 1.0	89	65	f	\N	TM	1	Receive Time	\N
6027	(0031,"KONICA1.0",49)	(0031,"KONICA1.0",49)	KONICA1.0	49	73	f	\N	UN	1	Unknown	\N
5857	(0013,"CTP",11)	(0013,"CTP",11)	CTP	19	17	f	\N	LO	1	Trial Name	K
5858	(0013,"CTP",12)	(0013,"CTP",12)	CTP	19	18	f	\N	LO	1	Site Name	K
5859	(0013,"CTP",13)	(0013,"CTP",13)	CTP	19	19	f	\N	LO	1	Site ID	K
5879	(0059,"VEPRO DICOM RECEIVE DATA 1.0",42)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",42)	VEPRO DICOM RECEIVE DATA 1.0	89	66	f	\N	ST	1	Receive Node	\N
5880	(0059,"VEPRO DICOM RECEIVE DATA 1.0",43)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",43)	VEPRO DICOM RECEIVE DATA 1.0	89	67	f	\N	ST	1	Receive Application	\N
5881	(0059,"VEPRO DICOM RECEIVE DATA 1.0",50)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",50)	VEPRO DICOM RECEIVE DATA 1.0	89	80	f	\N	ST	1	Receive Local Computer	\N
5882	(0059,"VEPRO DICOM RECEIVE DATA 1.0",51)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",51)	VEPRO DICOM RECEIVE DATA 1.0	89	81	f	\N	ST	1	Receive Local AE Title	\N
5883	(0059,"VEPRO DICOM RECEIVE DATA 1.0",60)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",60)	VEPRO DICOM RECEIVE DATA 1.0	89	96	f	\N	ST	1	Receive Remote Computer	\N
5884	(0059,"VEPRO DICOM RECEIVE DATA 1.0",61)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",61)	VEPRO DICOM RECEIVE DATA 1.0	89	97	f	\N	ST	1	Receive Remote AE Title	\N
5885	(0059,"VEPRO DICOM RECEIVE DATA 1.0",70)	(0059,"VEPRO DICOM RECEIVE DATA 1.0",70)	VEPRO DICOM RECEIVE DATA 1.0	89	112	f	\N	UI	1	Receive Original Transfer Syntax	\N
5886	(0043,"dcm4che/archive",10)	(0043,"dcm4che/archive",10)	dcm4che/archive	67	16	f	\N	OB	1	Patient Pk	\N
5887	(0043,"dcm4che/archive",11)	(0043,"dcm4che/archive",11)	dcm4che/archive	67	17	f	\N	OB	1	Study Pk	\N
5888	(0043,"dcm4che/archive",12)	(0043,"dcm4che/archive",12)	dcm4che/archive	67	18	f	\N	OB	1	Series Pk	\N
5889	(0043,"dcm4che/archive",13)	(0043,"dcm4che/archive",13)	dcm4che/archive	67	19	f	\N	OB	1	Instance Pk	\N
5890	(0043,"dcm4che/archive",14)	(0043,"dcm4che/archive",14)	dcm4che/archive	67	20	f	\N	AE	1	Calling AE Title	\N
5891	(0043,"dcm4che/archive",15)	(0043,"dcm4che/archive",15)	dcm4che/archive	67	21	f	\N	AE	1	Called AE Title	\N
5892	(0043,"dcm4che/archive",16)	(0043,"dcm4che/archive",16)	dcm4che/archive	67	22	f	\N	DT	1	Instance Updated	\N
5893	(0043,"dcm4che/archive",20)	(0043,"dcm4che/archive",20)	dcm4che/archive	67	32	f	\N	SQ	1	Work Item Sequence	\N
5894	(0043,"dcm4che/archive",30)	(0043,"dcm4che/archive",30)	dcm4che/archive	67	48	f	\N	UI	1	Dcm4che URI Referenced Transfer Syntax UID	\N
5895	(1269,"IMS s.r.l. Biopsy Private Code",01)	(1269,"IMS s.r.l. Biopsy Private Code",01)	IMS s.r.l. Biopsy Private Code	4713	1	f	\N	IS	1	Biopsy Image	\N
5896	(1269,"IMS s.r.l. Biopsy Private Code",10)	(1269,"IMS s.r.l. Biopsy Private Code",10)	IMS s.r.l. Biopsy Private Code	4713	16	f	\N	IS	1-n	Biopsy Markers X	\N
5897	(1269,"IMS s.r.l. Biopsy Private Code",11)	(1269,"IMS s.r.l. Biopsy Private Code",11)	IMS s.r.l. Biopsy Private Code	4713	17	f	\N	IS	1-n	Biopsy Markers Y	\N
5898	(1269,"IMS s.r.l. Biopsy Private Code",12)	(1269,"IMS s.r.l. Biopsy Private Code",12)	IMS s.r.l. Biopsy Private Code	4713	18	f	\N	IS	1-n	Biopsy Markers Number	\N
5899	(1269,"IMS s.r.l. Biopsy Private Code",20)	(1269,"IMS s.r.l. Biopsy Private Code",20)	IMS s.r.l. Biopsy Private Code	4713	32	f	\N	IS	1	Biopsy Area Left Border	\N
5900	(1269,"IMS s.r.l. Biopsy Private Code",21)	(1269,"IMS s.r.l. Biopsy Private Code",21)	IMS s.r.l. Biopsy Private Code	4713	33	f	\N	IS	1	Biopsy Area Right Border	\N
5901	(1269,"IMS s.r.l. Biopsy Private Code",22)	(1269,"IMS s.r.l. Biopsy Private Code",22)	IMS s.r.l. Biopsy Private Code	4713	34	f	\N	IS	1	Biopsy Area Top Border	\N
5902	(1269,"IMS s.r.l. Biopsy Private Code",23)	(1269,"IMS s.r.l. Biopsy Private Code",23)	IMS s.r.l. Biopsy Private Code	4713	35	f	\N	IS	1	Biopsy Area Bottom Border	\N
5903	(1269,"IMS s.r.l. Biopsy Private Code",24)	(1269,"IMS s.r.l. Biopsy Private Code",24)	IMS s.r.l. Biopsy Private Code	4713	36	f	\N	IS	1	Biopsy Number	\N
5904	(1271,"IMS s.r.l. Mammography Private Code",01)	(1271,"IMS s.r.l. Mammography Private Code",01)	IMS s.r.l. Mammography Private Code	4721	1	f	\N	IS	1	Threshold 1	\N
5905	(1271,"IMS s.r.l. Mammography Private Code",02)	(1271,"IMS s.r.l. Mammography Private Code",02)	IMS s.r.l. Mammography Private Code	4721	2	f	\N	IS	1	Threshold 2	\N
5906	(1271,"IMS s.r.l. Mammography Private Code",10)	(1271,"IMS s.r.l. Mammography Private Code",10)	IMS s.r.l. Mammography Private Code	4721	16	f	\N	IS	1	Segmentation Left Border	\N
5907	(1271,"IMS s.r.l. Mammography Private Code",11)	(1271,"IMS s.r.l. Mammography Private Code",11)	IMS s.r.l. Mammography Private Code	4721	17	f	\N	IS	1	Segmentation Right Border	\N
5908	(1271,"IMS s.r.l. Mammography Private Code",12)	(1271,"IMS s.r.l. Mammography Private Code",12)	IMS s.r.l. Mammography Private Code	4721	18	f	\N	IS	1	Segmentation Top Border	\N
5909	(1271,"IMS s.r.l. Mammography Private Code",13)	(1271,"IMS s.r.l. Mammography Private Code",13)	IMS s.r.l. Mammography Private Code	4721	19	f	\N	IS	1	Segmentation Bottom Border	\N
5910	(1271,"IMS s.r.l. Mammography Private Code",20)	(1271,"IMS s.r.l. Mammography Private Code",20)	IMS s.r.l. Mammography Private Code	4721	32	f	\N	IS	1	Compressor Status	\N
5911	(1271,"IMS s.r.l. Mammography Private Code",21)	(1271,"IMS s.r.l. Mammography Private Code",21)	IMS s.r.l. Mammography Private Code	4721	33	f	\N	IS	1	Collimator Type	\N
5912	(1271,"IMS s.r.l. Mammography Private Code",22)	(1271,"IMS s.r.l. Mammography Private Code",22)	IMS s.r.l. Mammography Private Code	4721	34	f	\N	IS	1	Biopsy Specimen	\N
5913	(1271,"IMS s.r.l. Mammography Private Code",30)	(1271,"IMS s.r.l. Mammography Private Code",30)	IMS s.r.l. Mammography Private Code	4721	48	f	\N	IS	1	Printer Segmentation	\N
5914	(1271,"IMS s.r.l. Mammography Private Code",31)	(1271,"IMS s.r.l. Mammography Private Code",31)	IMS s.r.l. Mammography Private Code	4721	49	f	\N	IS	1	Printer 8x10 Format	\N
5915	(1271,"IMS s.r.l. Mammography Private Code",32)	(1271,"IMS s.r.l. Mammography Private Code",32)	IMS s.r.l. Mammography Private Code	4721	50	f	\N	FD	1	Printer 8x10 Size X	\N
5916	(1271,"IMS s.r.l. Mammography Private Code",33)	(1271,"IMS s.r.l. Mammography Private Code",33)	IMS s.r.l. Mammography Private Code	4721	51	f	\N	FD	1	Printer 8x10 Size Y	\N
5917	(1271,"IMS s.r.l. Mammography Private Code",34)	(1271,"IMS s.r.l. Mammography Private Code",34)	IMS s.r.l. Mammography Private Code	4721	52	f	\N	IS	1	Printer 8x10 Area Left Border	\N
5918	(1271,"IMS s.r.l. Mammography Private Code",35)	(1271,"IMS s.r.l. Mammography Private Code",35)	IMS s.r.l. Mammography Private Code	4721	53	f	\N	IS	1	Printer 8x10 Area Right Border	\N
5919	(1271,"IMS s.r.l. Mammography Private Code",36)	(1271,"IMS s.r.l. Mammography Private Code",36)	IMS s.r.l. Mammography Private Code	4721	54	f	\N	IS	1	Printer 8x10 Area Top Border	\N
5920	(1271,"IMS s.r.l. Mammography Private Code",37)	(1271,"IMS s.r.l. Mammography Private Code",37)	IMS s.r.l. Mammography Private Code	4721	55	f	\N	IS	1	Printer 8x10 Area Bottom Border	\N
6028	(0031,"KONICA1.0",4a)	(0031,"KONICA1.0",4a)	KONICA1.0	49	74	f	\N	UN	1	Unknown	\N
5921	(1271,"IMS s.r.l. Mammography Private Code",38)	(1271,"IMS s.r.l. Mammography Private Code",38)	IMS s.r.l. Mammography Private Code	4721	56	f	\N	LO	1	Rotation And Inclination Sensor Presence	\N
5922	(1271,"IMS s.r.l. Mammography Private Code",39)	(1271,"IMS s.r.l. Mammography Private Code",39)	IMS s.r.l. Mammography Private Code	4721	57	f	\N	US	1-n	Window Center For For Processing Images	\N
5923	(1271,"IMS s.r.l. Mammography Private Code",40)	(1271,"IMS s.r.l. Mammography Private Code",40)	IMS s.r.l. Mammography Private Code	4721	64	f	\N	US	1-n	Window Width For For Processing Images	\N
5924	(1271,"IMS s.r.l. Mammography Private Code",41)	(1271,"IMS s.r.l. Mammography Private Code",41)	IMS s.r.l. Mammography Private Code	4721	65	f	\N	LO	1-n	Window Center and Width Explanation For For Processing Images	\N
5925	(1271,"IMS s.r.l. Mammography Private Code",42)	(1271,"IMS s.r.l. Mammography Private Code",42)	IMS s.r.l. Mammography Private Code	4721	66	f	\N	LT	1	Processing Information	\N
5926	(1271,"IMS s.r.l. Mammography Private Code",43)	(1271,"IMS s.r.l. Mammography Private Code",43)	IMS s.r.l. Mammography Private Code	4721	67	f	\N	LT	1	Filename	\N
5927	(1271,"IMS s.r.l. Mammography Private Code",44)	(1271,"IMS s.r.l. Mammography Private Code",44)	IMS s.r.l. Mammography Private Code	4721	68	f	\N	LT	1	Contrast View	\N
5928	(1271,"IMS s.r.l. Mammography Private Code",45)	(1271,"IMS s.r.l. Mammography Private Code",45)	IMS s.r.l. Mammography Private Code	4721	69	f	\N	IS	1	Threshold 3	\N
5929	(1271,"IMS s.r.l. Mammography Private Code",46)	(1271,"IMS s.r.l. Mammography Private Code",46)	IMS s.r.l. Mammography Private Code	4721	70	f	\N	IS	1	Threshold 4	\N
5930	(1271,"IMS s.r.l. Mammography Private Code",47)	(1271,"IMS s.r.l. Mammography Private Code",47)	IMS s.r.l. Mammography Private Code	4721	71	f	\N	IS	1	Threshold 5	\N
5931	(1271,"IMS s.r.l. Mammography Private Code",48)	(1271,"IMS s.r.l. Mammography Private Code",48)	IMS s.r.l. Mammography Private Code	4721	72	f	\N	IS	1	Threshold 6	\N
5932	(1271,"IMS s.r.l. Mammography Private Code",49)	(1271,"IMS s.r.l. Mammography Private Code",49)	IMS s.r.l. Mammography Private Code	4721	73	f	\N	IS	1	Threshold 7	\N
5933	(1271,"IMS s.r.l. Mammography Private Code",50)	(1271,"IMS s.r.l. Mammography Private Code",50)	IMS s.r.l. Mammography Private Code	4721	80	f	\N	IS	1	Threshold 8	\N
5934	(1271,"IMS s.r.l. Mammography Private Code",51)	(1271,"IMS s.r.l. Mammography Private Code",51)	IMS s.r.l. Mammography Private Code	4721	81	f	\N	IS	1	Threshold 9	\N
5935	(1271,"IMS s.r.l. Mammography Private Code",52)	(1271,"IMS s.r.l. Mammography Private Code",52)	IMS s.r.l. Mammography Private Code	4721	82	f	\N	IS	1	Threshold 9	\N
5936	(1271,"IMS s.r.l. Mammography Private Code",53)	(1271,"IMS s.r.l. Mammography Private Code",53)	IMS s.r.l. Mammography Private Code	4721	83	f	\N	IS	1	Scaling Factor For Processing	\N
5937	(1271,"IMS s.r.l. Mammography Private Code",54)	(1271,"IMS s.r.l. Mammography Private Code",54)	IMS s.r.l. Mammography Private Code	4721	84	f	\N	IS	1	ConfirmX Image	\N
5938	(1271,"IMS s.r.l. Mammography Private Code",55)	(1271,"IMS s.r.l. Mammography Private Code",55)	IMS s.r.l. Mammography Private Code	4721	85	f	\N	IS	1	Background counts	\N
5939	(1271,"IMS s.r.l. Mammography Private Code",56)	(1271,"IMS s.r.l. Mammography Private Code",56)	IMS s.r.l. Mammography Private Code	4721	86	f	\N	IS	1	WL Roi Area X	\N
5940	(1271,"IMS s.r.l. Mammography Private Code",57)	(1271,"IMS s.r.l. Mammography Private Code",57)	IMS s.r.l. Mammography Private Code	4721	87	f	\N	IS	1	WL Roi Area Y	\N
5941	(1271,"IMS s.r.l. Mammography Private Code",60)	(1271,"IMS s.r.l. Mammography Private Code",60)	IMS s.r.l. Mammography Private Code	4721	96	f	\N	IS	1	Second Processing Image	\N
5942	(1271,"IMS s.r.l. Mammography Private Code",61)	(1271,"IMS s.r.l. Mammography Private Code",61)	IMS s.r.l. Mammography Private Code	4721	97	f	\N	IS	1	S Filter	\N
5943	(1271,"IMS s.r.l. Mammography Private Code",62)	(1271,"IMS s.r.l. Mammography Private Code",62)	IMS s.r.l. Mammography Private Code	4721	98	f	\N	IS	1	U Filter	\N
5944	(1271,"IMS s.r.l. Mammography Private Code",63)	(1271,"IMS s.r.l. Mammography Private Code",63)	IMS s.r.l. Mammography Private Code	4721	99	f	\N	IS	1	Anonymous	\N
5945	(1271,"IMS s.r.l. Mammography Private Code",70)	(1271,"IMS s.r.l. Mammography Private Code",70)	IMS s.r.l. Mammography Private Code	4721	112	f	\N	IS	1	Tomo SAD	\N
5946	(1271,"IMS s.r.l. Mammography Private Code",71)	(1271,"IMS s.r.l. Mammography Private Code",71)	IMS s.r.l. Mammography Private Code	4721	113	f	\N	IS	1	Tomo Detector YAW	\N
5947	(1271,"IMS s.r.l. Mammography Private Code",72)	(1271,"IMS s.r.l. Mammography Private Code",72)	IMS s.r.l. Mammography Private Code	4721	114	f	\N	IS	1	Tomo Detector Pitch	\N
5948	(1271,"IMS s.r.l. Mammography Private Code",73)	(1271,"IMS s.r.l. Mammography Private Code",73)	IMS s.r.l. Mammography Private Code	4721	115	f	\N	IS	1	Tomo Detector Roll	\N
5949	(1271,"IMS s.r.l. Mammography Private Code",74)	(1271,"IMS s.r.l. Mammography Private Code",74)	IMS s.r.l. Mammography Private Code	4721	116	f	\N	IS	1	Tomo Focal Spot X	\N
5950	(1271,"IMS s.r.l. Mammography Private Code",75)	(1271,"IMS s.r.l. Mammography Private Code",75)	IMS s.r.l. Mammography Private Code	4721	117	f	\N	IS	1	Tomo Focal Spot Y	\N
5951	(1271,"IMS s.r.l. Mammography Private Code",76)	(1271,"IMS s.r.l. Mammography Private Code",76)	IMS s.r.l. Mammography Private Code	4721	118	f	\N	IS	1	Tomo Xray Start Angle	\N
5952	(1271,"IMS s.r.l. Mammography Private Code",77)	(1271,"IMS s.r.l. Mammography Private Code",77)	IMS s.r.l. Mammography Private Code	4721	119	f	\N	IS	1	Tomo Xray End Angle	\N
5953	(1271,"IMS s.r.l. Mammography Private Code",78)	(1271,"IMS s.r.l. Mammography Private Code",78)	IMS s.r.l. Mammography Private Code	4721	120	f	\N	IS	1	Tomo Xray Angle	\N
5954	(1271,"IMS s.r.l. Mammography Private Code",79)	(1271,"IMS s.r.l. Mammography Private Code",79)	IMS s.r.l. Mammography Private Code	4721	121	f	\N	IS	1	Tomo Exposure Counter	\N
5955	(1271,"IMS s.r.l. Mammography Private Code",80)	(1271,"IMS s.r.l. Mammography Private Code",80)	IMS s.r.l. Mammography Private Code	4721	128	f	\N	IS	1	Tomo Exposure Number	\N
5956	(1271,"IMS s.r.l. Mammography Private Code",81)	(1271,"IMS s.r.l. Mammography Private Code",81)	IMS s.r.l. Mammography Private Code	4721	129	f	\N	IS	1	Tomo WL Modified	\N
5957	(1271,"IMS s.r.l. Mammography Private Code",82)	(1271,"IMS s.r.l. Mammography Private Code",82)	IMS s.r.l. Mammography Private Code	4721	130	f	\N	IS	1	Tomo Projection	\N
5958	(1271,"IMS s.r.l. Mammography Private Code",83)	(1271,"IMS s.r.l. Mammography Private Code",83)	IMS s.r.l. Mammography Private Code	4721	131	f	\N	IS	1	Key Object Selection Title Code	\N
6029	(0031,"KONICA1.0",4b)	(0031,"KONICA1.0",4b)	KONICA1.0	49	75	f	\N	UN	1	Unknown	\N
5959	(1271,"IMS s.r.l. Mammography Private Code",84)	(1271,"IMS s.r.l. Mammography Private Code",84)	IMS s.r.l. Mammography Private Code	4721	132	f	\N	IS	1	Rejected for Quality Reasons Code	\N
5960	(1271,"IMS s.r.l. Mammography Private Code",85)	(1271,"IMS s.r.l. Mammography Private Code",85)	IMS s.r.l. Mammography Private Code	4721	133	f	\N	IS	1	Unknown	\N
5961	(0031,"KONICA1.0",00)	(0031,"KONICA1.0",00)	KONICA1.0	49	0	f	\N	LO	1	Unknown	\N
5962	(0031,"KONICA1.0",01)	(0031,"KONICA1.0",01)	KONICA1.0	49	1	f	\N	US	1	Unknown	\N
5963	(0031,"KONICA1.0",05)	(0031,"KONICA1.0",05)	KONICA1.0	49	5	f	\N	US	1	Unknown	\N
5964	(0031,"KONICA1.0",06)	(0031,"KONICA1.0",06)	KONICA1.0	49	6	f	\N	LO	1	Unknown	\N
5965	(0031,"KONICA1.0",08)	(0031,"KONICA1.0",08)	KONICA1.0	49	8	f	\N	LO	1	Unknown	\N
5966	(0031,"KONICA1.0",09)	(0031,"KONICA1.0",09)	KONICA1.0	49	9	f	\N	US	1	Unknown	\N
5967	(0031,"KONICA1.0",0a)	(0031,"KONICA1.0",0a)	KONICA1.0	49	10	f	\N	LO	1	Unknown	\N
5968	(0031,"KONICA1.0",0b)	(0031,"KONICA1.0",0b)	KONICA1.0	49	11	f	\N	US	1	Unknown	\N
5969	(0031,"KONICA1.0",0c)	(0031,"KONICA1.0",0c)	KONICA1.0	49	12	f	\N	US	1	Unknown	\N
5970	(0031,"KONICA1.0",0d)	(0031,"KONICA1.0",0d)	KONICA1.0	49	13	f	\N	US	1	Unknown	\N
5971	(0031,"KONICA1.0",0e)	(0031,"KONICA1.0",0e)	KONICA1.0	49	14	f	\N	US	1	Unknown	\N
5972	(0031,"KONICA1.0",10)	(0031,"KONICA1.0",10)	KONICA1.0	49	16	f	\N	US	1	Unknown	\N
5973	(0031,"KONICA1.0",11)	(0031,"KONICA1.0",11)	KONICA1.0	49	17	f	\N	US	1	Unknown	\N
5974	(0031,"KONICA1.0",12)	(0031,"KONICA1.0",12)	KONICA1.0	49	18	f	\N	US	1	Unknown	\N
5975	(0031,"KONICA1.0",13)	(0031,"KONICA1.0",13)	KONICA1.0	49	19	f	\N	US	1	Unknown	\N
5976	(0031,"KONICA1.0",14)	(0031,"KONICA1.0",14)	KONICA1.0	49	20	f	\N	US	1	Unknown	\N
5977	(0031,"KONICA1.0",15)	(0031,"KONICA1.0",15)	KONICA1.0	49	21	f	\N	US	1	Unknown	\N
5978	(0031,"KONICA1.0",16)	(0031,"KONICA1.0",16)	KONICA1.0	49	22	f	\N	US	1	Unknown	\N
5979	(0031,"KONICA1.0",17)	(0031,"KONICA1.0",17)	KONICA1.0	49	23	f	\N	US	1	Unknown	\N
5980	(0031,"KONICA1.0",18)	(0031,"KONICA1.0",18)	KONICA1.0	49	24	f	\N	US	1	Unknown	\N
5981	(0031,"KONICA1.0",19)	(0031,"KONICA1.0",19)	KONICA1.0	49	25	f	\N	US	1	Unknown	\N
5982	(0031,"KONICA1.0",1a)	(0031,"KONICA1.0",1a)	KONICA1.0	49	26	f	\N	US	1	Unknown	\N
5983	(0031,"KONICA1.0",1b)	(0031,"KONICA1.0",1b)	KONICA1.0	49	27	f	\N	US	1	Unknown	\N
5984	(0031,"KONICA1.0",1c)	(0031,"KONICA1.0",1c)	KONICA1.0	49	28	f	\N	US	1	Unknown	\N
5985	(0031,"KONICA1.0",1d)	(0031,"KONICA1.0",1d)	KONICA1.0	49	29	f	\N	US	1	Unknown	\N
5986	(0031,"KONICA1.0",1e)	(0031,"KONICA1.0",1e)	KONICA1.0	49	30	f	\N	LO	1	Unknown	\N
5987	(0031,"KONICA1.0",20)	(0031,"KONICA1.0",20)	KONICA1.0	49	32	f	\N	SQ	1	Unknown	\N
5988	(0031,"KONICA1.0",21)	(0031,"KONICA1.0",21)	KONICA1.0	49	33	f	\N	SQ	1	Unknown	\N
5989	(0031,"KONICA1.0",22)	(0031,"KONICA1.0",22)	KONICA1.0	49	34	f	\N	SQ	1	Unknown	\N
5990	(0031,"KONICA1.0",23)	(0031,"KONICA1.0",23)	KONICA1.0	49	35	f	\N	SQ	1	Unknown	\N
5991	(0031,"KONICA1.0",24)	(0031,"KONICA1.0",24)	KONICA1.0	49	36	f	\N	SQ	1	Unknown	\N
5992	(0031,"KONICA1.0",25)	(0031,"KONICA1.0",25)	KONICA1.0	49	37	f	\N	SQ	1	Unknown	\N
5993	(0031,"KONICA1.0",26)	(0031,"KONICA1.0",26)	KONICA1.0	49	38	f	\N	SQ	1	Unknown	\N
5994	(0031,"KONICA1.0",27)	(0031,"KONICA1.0",27)	KONICA1.0	49	39	f	\N	SQ	1	Unknown	\N
5995	(0031,"KONICA1.0",28)	(0031,"KONICA1.0",28)	KONICA1.0	49	40	f	\N	SQ	1	Unknown	\N
5996	(0031,"KONICA1.0",29)	(0031,"KONICA1.0",29)	KONICA1.0	49	41	f	\N	SQ	1	Unknown	\N
5997	(0031,"KONICA1.0",2a)	(0031,"KONICA1.0",2a)	KONICA1.0	49	42	f	\N	SQ	1	Unknown	\N
5998	(0031,"KONICA1.0",2b)	(0031,"KONICA1.0",2b)	KONICA1.0	49	43	f	\N	SQ	1	Unknown	\N
5999	(0031,"KONICA1.0",2c)	(0031,"KONICA1.0",2c)	KONICA1.0	49	44	f	\N	SQ	1	Unknown	\N
6000	(0031,"KONICA1.0",2d)	(0031,"KONICA1.0",2d)	KONICA1.0	49	45	f	\N	SQ	1	Unknown	\N
6001	(0031,"KONICA1.0",2e)	(0031,"KONICA1.0",2e)	KONICA1.0	49	46	f	\N	SQ	1	Unknown	\N
6002	(0031,"KONICA1.0",2f)	(0031,"KONICA1.0",2f)	KONICA1.0	49	47	f	\N	SQ	1	Unknown	\N
6003	(0031,"KONICA1.0",30)	(0031,"KONICA1.0",30)	KONICA1.0	49	48	f	\N	US	1	Unknown	\N
6004	(0031,"KONICA1.0",31)	(0031,"KONICA1.0",31)	KONICA1.0	49	49	f	\N	US	1	Unknown	\N
6005	(0031,"KONICA1.0",32)	(0031,"KONICA1.0",32)	KONICA1.0	49	50	f	\N	US	1	Unknown	\N
6006	(0031,"KONICA1.0",33)	(0031,"KONICA1.0",33)	KONICA1.0	49	51	f	\N	US	1	Unknown	\N
6007	(0031,"KONICA1.0",34)	(0031,"KONICA1.0",34)	KONICA1.0	49	52	f	\N	US	1	Unknown	\N
6008	(0031,"KONICA1.0",35)	(0031,"KONICA1.0",35)	KONICA1.0	49	53	f	\N	UN	1	Unknown	\N
6009	(0031,"KONICA1.0",36)	(0031,"KONICA1.0",36)	KONICA1.0	49	54	f	\N	UN	1	Unknown	\N
6010	(0031,"KONICA1.0",37)	(0031,"KONICA1.0",37)	KONICA1.0	49	55	f	\N	US	1	Unknown	\N
6011	(0031,"KONICA1.0",38)	(0031,"KONICA1.0",38)	KONICA1.0	49	56	f	\N	US	1	Unknown	\N
6012	(0031,"KONICA1.0",39)	(0031,"KONICA1.0",39)	KONICA1.0	49	57	f	\N	US	1	Unknown	\N
6013	(0031,"KONICA1.0",3a)	(0031,"KONICA1.0",3a)	KONICA1.0	49	58	f	\N	UN	1	Unknown	\N
6014	(0031,"KONICA1.0",3b)	(0031,"KONICA1.0",3b)	KONICA1.0	49	59	f	\N	US	1	Unknown	\N
6015	(0031,"KONICA1.0",3c)	(0031,"KONICA1.0",3c)	KONICA1.0	49	60	f	\N	US	1	Unknown	\N
6016	(0031,"KONICA1.0",3d)	(0031,"KONICA1.0",3d)	KONICA1.0	49	61	f	\N	US	1	Unknown	\N
6017	(0031,"KONICA1.0",3e)	(0031,"KONICA1.0",3e)	KONICA1.0	49	62	f	\N	US	1	Unknown	\N
6018	(0031,"KONICA1.0",3f)	(0031,"KONICA1.0",3f)	KONICA1.0	49	63	f	\N	US	1	Unknown	\N
6019	(0031,"KONICA1.0",40)	(0031,"KONICA1.0",40)	KONICA1.0	49	64	f	\N	US	1	Unknown	\N
6020	(0031,"KONICA1.0",41)	(0031,"KONICA1.0",41)	KONICA1.0	49	65	f	\N	US	1	Unknown	\N
6021	(0031,"KONICA1.0",42)	(0031,"KONICA1.0",42)	KONICA1.0	49	66	f	\N	US	1	Unknown	\N
6022	(0031,"KONICA1.0",44)	(0031,"KONICA1.0",44)	KONICA1.0	49	68	f	\N	US	1	Unknown	\N
6023	(0031,"KONICA1.0",45)	(0031,"KONICA1.0",45)	KONICA1.0	49	69	f	\N	US	1	Unknown	\N
6024	(0031,"KONICA1.0",46)	(0031,"KONICA1.0",46)	KONICA1.0	49	70	f	\N	US	1	Unknown	\N
6025	(0031,"KONICA1.0",47)	(0031,"KONICA1.0",47)	KONICA1.0	49	71	f	\N	US	1	Unknown	\N
6026	(0031,"KONICA1.0",48)	(0031,"KONICA1.0",48)	KONICA1.0	49	72	f	\N	US	1	Unknown	\N
6030	(0031,"KONICA1.0",4c)	(0031,"KONICA1.0",4c)	KONICA1.0	49	76	f	\N	UN	1	Unknown	\N
6031	(0031,"KONICA1.0",4d)	(0031,"KONICA1.0",4d)	KONICA1.0	49	77	f	\N	US	1	Unknown	\N
6032	(0031,"KONICA1.0",4e)	(0031,"KONICA1.0",4e)	KONICA1.0	49	78	f	\N	US	1	Unknown	\N
6033	(0031,"KONICA1.0",4f)	(0031,"KONICA1.0",4f)	KONICA1.0	49	79	f	\N	US	1	Unknown	\N
6034	(0031,"KONICA1.0",50)	(0031,"KONICA1.0",50)	KONICA1.0	49	80	f	\N	US	1	Unknown	\N
6035	(0031,"KONICA1.0",51)	(0031,"KONICA1.0",51)	KONICA1.0	49	81	f	\N	US	1	Unknown	\N
6036	(0031,"KONICA1.0",52)	(0031,"KONICA1.0",52)	KONICA1.0	49	82	f	\N	US	1	Unknown	\N
6037	(0031,"KONICA1.0",53)	(0031,"KONICA1.0",53)	KONICA1.0	49	83	f	\N	US	1	Unknown	\N
6038	(0031,"KONICA1.0",54)	(0031,"KONICA1.0",54)	KONICA1.0	49	84	f	\N	US	1	Unknown	\N
6039	(0031,"KONICA1.0",55)	(0031,"KONICA1.0",55)	KONICA1.0	49	85	f	\N	US	1	Unknown	\N
6040	(0031,"KONICA1.0",56)	(0031,"KONICA1.0",56)	KONICA1.0	49	86	f	\N	UN	1	Unknown	\N
6041	(0031,"KONICA1.0",57)	(0031,"KONICA1.0",57)	KONICA1.0	49	87	f	\N	US	1	Unknown	\N
6042	(0031,"KONICA1.0",58)	(0031,"KONICA1.0",58)	KONICA1.0	49	88	f	\N	US	1	Unknown	\N
6043	(0031,"KONICA1.0",59)	(0031,"KONICA1.0",59)	KONICA1.0	49	89	f	\N	US	1	Unknown	\N
6044	(0031,"KONICA1.0",5a)	(0031,"KONICA1.0",5a)	KONICA1.0	49	90	f	\N	US	1	Unknown	\N
6045	(0031,"KONICA1.0",5b)	(0031,"KONICA1.0",5b)	KONICA1.0	49	91	f	\N	US	1	Unknown	\N
6046	(0031,"KONICA1.0",5c)	(0031,"KONICA1.0",5c)	KONICA1.0	49	92	f	\N	UN	1	Unknown	\N
6047	(0031,"KONICA1.0",62)	(0031,"KONICA1.0",62)	KONICA1.0	49	98	f	\N	US	1	Unknown	\N
6048	(0031,"KONICA1.0",63)	(0031,"KONICA1.0",63)	KONICA1.0	49	99	f	\N	US	3	Unknown	\N
6049	(0031,"KONICA1.0",6b)	(0031,"KONICA1.0",6b)	KONICA1.0	49	107	f	\N	US	1	Unknown	\N
6050	(0031,"KONICA1.0",70)	(0031,"KONICA1.0",70)	KONICA1.0	49	112	f	\N	US	1	Unknown	\N
6051	(0031,"KONICA1.0",71)	(0031,"KONICA1.0",71)	KONICA1.0	49	113	f	\N	LO	1	Unknown	\N
6052	(0031,"KONICA1.0",72)	(0031,"KONICA1.0",72)	KONICA1.0	49	114	f	\N	US	1	Unknown	\N
6053	(0031,"KONICA1.0",73)	(0031,"KONICA1.0",73)	KONICA1.0	49	115	f	\N	UN	1	Unknown	\N
6054	(0031,"KONICA1.0",74)	(0031,"KONICA1.0",74)	KONICA1.0	49	116	f	\N	LO	1	Unknown	\N
6055	(0031,"KONICA1.0",75)	(0031,"KONICA1.0",75)	KONICA1.0	49	117	f	\N	UN	1	Unknown	\N
6056	(0031,"KONICA1.0",77)	(0031,"KONICA1.0",77)	KONICA1.0	49	119	f	\N	UN	1	Unknown	\N
6057	(0031,"KONICA1.0",78)	(0031,"KONICA1.0",78)	KONICA1.0	49	120	f	\N	UN	1	Unknown	\N
6058	(0031,"KONICA1.0",79)	(0031,"KONICA1.0",79)	KONICA1.0	49	121	f	\N	UN	1	Unknown	\N
6059	(0031,"KONICA1.0",7a)	(0031,"KONICA1.0",7a)	KONICA1.0	49	122	f	\N	UN	1	Unknown	\N
6060	(0031,"KONICA1.0",7b)	(0031,"KONICA1.0",7b)	KONICA1.0	49	123	f	\N	UN	1	Unknown	\N
6061	(0031,"KONICA1.0",7c)	(0031,"KONICA1.0",7c)	KONICA1.0	49	124	f	\N	UN	1	Unknown	\N
6062	(0031,"KONICA1.0",7d)	(0031,"KONICA1.0",7d)	KONICA1.0	49	125	f	\N	UN	1	Unknown	\N
6063	(0031,"KONICA1.0",7e)	(0031,"KONICA1.0",7e)	KONICA1.0	49	126	f	\N	UN	1	Unknown	\N
6064	(0031,"KONICA1.0",7f)	(0031,"KONICA1.0",7f)	KONICA1.0	49	127	f	\N	UN	1	Unknown	\N
6065	(0031,"KONICA1.0",80)	(0031,"KONICA1.0",80)	KONICA1.0	49	128	f	\N	UN	1	Unknown	\N
6066	(0031,"KONICA1.0",81)	(0031,"KONICA1.0",81)	KONICA1.0	49	129	f	\N	UN	1	Unknown	\N
6067	(0031,"KONICA1.0",82)	(0031,"KONICA1.0",82)	KONICA1.0	49	130	f	\N	UN	1	Unknown	\N
6068	(0031,"KONICA1.0",83)	(0031,"KONICA1.0",83)	KONICA1.0	49	131	f	\N	UN	1	Unknown	\N
6069	(0031,"KONICA1.0",84)	(0031,"KONICA1.0",84)	KONICA1.0	49	132	f	\N	UN	1	Unknown	\N
6070	(0031,"KONICA1.0",85)	(0031,"KONICA1.0",85)	KONICA1.0	49	133	f	\N	UN	1	Unknown	\N
6071	(0031,"KONICA1.0",86)	(0031,"KONICA1.0",86)	KONICA1.0	49	134	f	\N	UN	1	Unknown	\N
6072	(0031,"KONICA1.0",87)	(0031,"KONICA1.0",87)	KONICA1.0	49	135	f	\N	UN	1	Unknown	\N
6073	(0031,"KONICA1.0",88)	(0031,"KONICA1.0",88)	KONICA1.0	49	136	f	\N	UN	1	Unknown	\N
6074	(0031,"KONICA1.0",89)	(0031,"KONICA1.0",89)	KONICA1.0	49	137	f	\N	UN	1	Unknown	\N
6075	(0031,"KONICA1.0",8a)	(0031,"KONICA1.0",8a)	KONICA1.0	49	138	f	\N	UN	1	Unknown	\N
6076	(0031,"KONICA1.0",8b)	(0031,"KONICA1.0",8b)	KONICA1.0	49	139	f	\N	UN	1	Unknown	\N
6077	(0031,"KONICA1.0",8c)	(0031,"KONICA1.0",8c)	KONICA1.0	49	140	f	\N	US	1	Unknown	\N
6078	(0031,"KONICA1.0",8d)	(0031,"KONICA1.0",8d)	KONICA1.0	49	141	f	\N	US	1	Unknown	\N
6079	(0031,"KONICA1.0",8e)	(0031,"KONICA1.0",8e)	KONICA1.0	49	142	f	\N	LO	1	Unknown	\N
6080	(0031,"KONICA1.0",8f)	(0031,"KONICA1.0",8f)	KONICA1.0	49	143	f	\N	UN	1	Unknown	\N
6081	(0031,"KONICA1.0",90)	(0031,"KONICA1.0",90)	KONICA1.0	49	144	f	\N	UN	1	Unknown	\N
6082	(0031,"KONICA1.0",91)	(0031,"KONICA1.0",91)	KONICA1.0	49	145	f	\N	US	1	Unknown	\N
6083	(0031,"KONICA1.0",92)	(0031,"KONICA1.0",92)	KONICA1.0	49	146	f	\N	UN	1	Unknown	\N
6084	(0031,"KONICA1.0",93)	(0031,"KONICA1.0",93)	KONICA1.0	49	147	f	\N	UN	1	Unknown	\N
6085	(0031,"KONICA1.0",94)	(0031,"KONICA1.0",94)	KONICA1.0	49	148	f	\N	UN	1	Unknown	\N
6086	(0031,"KONICA1.0",95)	(0031,"KONICA1.0",95)	KONICA1.0	49	149	f	\N	UN	1	Unknown	\N
6087	(0031,"KONICA1.0",a1)	(0031,"KONICA1.0",a1)	KONICA1.0	49	161	f	\N	IS	2	Unknown	\N
6088	(0031,"KONICA1.0",a2)	(0031,"KONICA1.0",a2)	KONICA1.0	49	162	f	\N	IS	1	Unknown	\N
6089	(0031,"KONICA1.0",a5)	(0031,"KONICA1.0",a5)	KONICA1.0	49	165	f	\N	US	1	Unknown	\N
6090	(0031,"KONICA1.0",a6)	(0031,"KONICA1.0",a6)	KONICA1.0	49	166	f	\N	US	1	Unknown	\N
6091	(0031,"KONICA1.0",a7)	(0031,"KONICA1.0",a7)	KONICA1.0	49	167	f	\N	UN	1	Unknown	\N
6092	(0031,"KONICA1.0",a8)	(0031,"KONICA1.0",a8)	KONICA1.0	49	168	f	\N	US	1	Unknown	\N
6093	(0031,"KONICA1.0",aa)	(0031,"KONICA1.0",aa)	KONICA1.0	49	170	f	\N	US	1	Unknown	\N
6094	(0031,"KONICA1.0",ab)	(0031,"KONICA1.0",ab)	KONICA1.0	49	171	f	\N	DA	1	Unknown	\N
6095	(0031,"KONICA1.0",ac)	(0031,"KONICA1.0",ac)	KONICA1.0	49	172	f	\N	TM	1	Unknown	\N
6096	(0031,"KONICA1.0",ad)	(0031,"KONICA1.0",ad)	KONICA1.0	49	173	f	\N	DA	1	Unknown	\N
6097	(0031,"KONICA1.0",ae)	(0031,"KONICA1.0",ae)	KONICA1.0	49	174	f	\N	TM	1	Unknown	\N
6098	(0031,"KONICA1.0",b0)	(0031,"KONICA1.0",b0)	KONICA1.0	49	176	f	\N	US	1	Unknown	\N
6099	(0031,"KONICA1.0",b1)	(0031,"KONICA1.0",b1)	KONICA1.0	49	177	f	\N	US	1	Unknown	\N
6100	(0031,"KONICA1.0",b2)	(0031,"KONICA1.0",b2)	KONICA1.0	49	178	f	\N	US	1	Unknown	\N
6101	(0031,"KONICA1.0",b3)	(0031,"KONICA1.0",b3)	KONICA1.0	49	179	f	\N	US	1	Unknown	\N
6102	(0031,"KONICA1.0",b4)	(0031,"KONICA1.0",b4)	KONICA1.0	49	180	f	\N	US	1	Unknown	\N
6103	(0031,"KONICA1.0",b5)	(0031,"KONICA1.0",b5)	KONICA1.0	49	181	f	\N	US	1	Unknown	\N
6104	(0031,"KONICA1.0",b6)	(0031,"KONICA1.0",b6)	KONICA1.0	49	182	f	\N	US	1	Unknown	\N
6105	(0031,"KONICA1.0",b7)	(0031,"KONICA1.0",b7)	KONICA1.0	49	183	f	\N	UN	1	Unknown	\N
6106	(0031,"KONICA1.0",b8)	(0031,"KONICA1.0",b8)	KONICA1.0	49	184	f	\N	LO	1	Unknown	\N
6107	(0031,"KONICA1.0",b9)	(0031,"KONICA1.0",b9)	KONICA1.0	49	185	f	\N	LO	1	Unknown	\N
6108	(0031,"KONICA1.0",ba)	(0031,"KONICA1.0",ba)	KONICA1.0	49	186	f	\N	US	1	Unknown	\N
6109	(0031,"KONICA1.0",bc)	(0031,"KONICA1.0",bc)	KONICA1.0	49	188	f	\N	US	1	Unknown	\N
6110	(0031,"KONICA1.0",be)	(0031,"KONICA1.0",be)	KONICA1.0	49	190	f	\N	UN	1	Unknown	\N
6111	(0031,"KONICA1.0",bf)	(0031,"KONICA1.0",bf)	KONICA1.0	49	191	f	\N	US	1	Unknown	\N
6112	(0031,"KONICA1.0",c0)	(0031,"KONICA1.0",c0)	KONICA1.0	49	192	f	\N	UN	1	Unknown	\N
6113	(0031,"KONICA1.0",c1)	(0031,"KONICA1.0",c1)	KONICA1.0	49	193	f	\N	UN	1	Unknown	\N
6114	(0031,"KONICA1.0",c2)	(0031,"KONICA1.0",c2)	KONICA1.0	49	194	f	\N	UN	1	Unknown	\N
6115	(0031,"KONICA1.0",c3)	(0031,"KONICA1.0",c3)	KONICA1.0	49	195	f	\N	UN	1	Unknown	\N
6116	(0031,"KONICA1.0",c4)	(0031,"KONICA1.0",c4)	KONICA1.0	49	196	f	\N	UN	1	Unknown	\N
6117	(0031,"KONICA1.0",c5)	(0031,"KONICA1.0",c5)	KONICA1.0	49	197	f	\N	UN	1	Unknown	\N
6118	(0031,"KONICA1.0",c6)	(0031,"KONICA1.0",c6)	KONICA1.0	49	198	f	\N	UN	1	Unknown	\N
6119	(0031,"KONICA1.0",c7)	(0031,"KONICA1.0",c7)	KONICA1.0	49	199	f	\N	UN	1	Unknown	\N
6120	(0031,"KONICA1.0",c8)	(0031,"KONICA1.0",c8)	KONICA1.0	49	200	f	\N	UN	1	Unknown	\N
6121	(0031,"KONICA1.0",c9)	(0031,"KONICA1.0",c9)	KONICA1.0	49	201	f	\N	UN	1	Unknown	\N
6122	(0031,"KONICA1.0",ca)	(0031,"KONICA1.0",ca)	KONICA1.0	49	202	f	\N	UN	1	Unknown	\N
6123	(0031,"KONICA1.0",cb)	(0031,"KONICA1.0",cb)	KONICA1.0	49	203	f	\N	UN	1	Unknown	\N
6124	(0031,"KONICA1.0",cc)	(0031,"KONICA1.0",cc)	KONICA1.0	49	204	f	\N	UN	1	Unknown	\N
6125	(0031,"KONICA1.0",cd)	(0031,"KONICA1.0",cd)	KONICA1.0	49	205	f	\N	UN	1	Unknown	\N
6126	(0031,"KONICA1.0",ce)	(0031,"KONICA1.0",ce)	KONICA1.0	49	206	f	\N	US	1	Unknown	\N
6127	(0031,"KONICA1.0",cf)	(0031,"KONICA1.0",cf)	KONICA1.0	49	207	f	\N	US	1	Unknown	\N
6128	(0031,"KONICA1.0",d0)	(0031,"KONICA1.0",d0)	KONICA1.0	49	208	f	\N	UN	1	Unknown	\N
6129	(0031,"KONICA1.0",d1)	(0031,"KONICA1.0",d1)	KONICA1.0	49	209	f	\N	UN	1	Unknown	\N
6130	(0031,"KONICA1.0",d2)	(0031,"KONICA1.0",d2)	KONICA1.0	49	210	f	\N	UN	1	Unknown	\N
6131	(0031,"KONICA1.0",d3)	(0031,"KONICA1.0",d3)	KONICA1.0	49	211	f	\N	UN	1	Unknown	\N
6132	(0031,"KONICA1.0",d4)	(0031,"KONICA1.0",d4)	KONICA1.0	49	212	f	\N	US	1	Unknown	\N
6133	(0031,"KONICA1.0",d5)	(0031,"KONICA1.0",d5)	KONICA1.0	49	213	f	\N	UN	1	Unknown	\N
6134	(0031,"KONICA1.0",d6)	(0031,"KONICA1.0",d6)	KONICA1.0	49	214	f	\N	UN	1	Unknown	\N
6135	(0031,"KONICA1.0",d7)	(0031,"KONICA1.0",d7)	KONICA1.0	49	215	f	\N	US	1	Unknown	\N
6136	(0031,"KONICA1.0",d8)	(0031,"KONICA1.0",d8)	KONICA1.0	49	216	f	\N	US	1	Unknown	\N
6137	(0031,"KONICA1.0",d9)	(0031,"KONICA1.0",d9)	KONICA1.0	49	217	f	\N	LO	1	Unknown	\N
6138	(0031,"KONICA1.0",da)	(0031,"KONICA1.0",da)	KONICA1.0	49	218	f	\N	UN	1	Unknown	\N
6139	(0031,"KONICA1.0",db)	(0031,"KONICA1.0",db)	KONICA1.0	49	219	f	\N	UN	1	Unknown	\N
6140	(0031,"KONICA1.0",dc)	(0031,"KONICA1.0",dc)	KONICA1.0	49	220	f	\N	UN	1	Unknown	\N
6141	(0031,"KONICA1.0",dd)	(0031,"KONICA1.0",dd)	KONICA1.0	49	221	f	\N	UN	1	Unknown	\N
6142	(0031,"KONICA1.0",de)	(0031,"KONICA1.0",de)	KONICA1.0	49	222	f	\N	UN	1	Unknown	\N
6143	(0031,"KONICA1.0",df)	(0031,"KONICA1.0",df)	KONICA1.0	49	223	f	\N	UN	1	Unknown	\N
6144	(0031,"KONICA1.0",e0)	(0031,"KONICA1.0",e0)	KONICA1.0	49	224	f	\N	UN	1	Unknown	\N
6145	(0031,"KONICA1.0",e1)	(0031,"KONICA1.0",e1)	KONICA1.0	49	225	f	\N	US	1	Unknown	\N
6146	(0031,"KONICA1.0",e2)	(0031,"KONICA1.0",e2)	KONICA1.0	49	226	f	\N	UN	1	Unknown	\N
6147	(0031,"KONICA1.0",e3)	(0031,"KONICA1.0",e3)	KONICA1.0	49	227	f	\N	UN	1	Unknown	\N
6148	(0031,"KONICA1.0",e4)	(0031,"KONICA1.0",e4)	KONICA1.0	49	228	f	\N	UN	1	Unknown	\N
6149	(0031,"KONICA1.0",e5)	(0031,"KONICA1.0",e5)	KONICA1.0	49	229	f	\N	US	1	Unknown	\N
6150	(0031,"KONICA1.0",e6)	(0031,"KONICA1.0",e6)	KONICA1.0	49	230	f	\N	UN	1	Unknown	\N
6151	(0031,"KONICA1.0",f0)	(0031,"KONICA1.0",f0)	KONICA1.0	49	240	f	\N	US	1	Unknown	\N
6152	(0031,"KONICA1.0",ff)	(0031,"KONICA1.0",ff)	KONICA1.0	49	255	f	\N	SQ	1	Private Data Sequence	\N
6153	(0009,"DZDICOM 4.3.0",01)	(0009,"DZDICOM 4.3.0",01)	DZDICOM 4.3.0	9	1	f	\N	UI	1	Unknown	\N
6154	(0009,"DZDICOM 4.3.0",02)	(0009,"DZDICOM 4.3.0",02)	DZDICOM 4.3.0	9	2	f	\N	LO	1	Unknown	\N
6155	(0009,"DZDICOM 4.3.0",03)	(0009,"DZDICOM 4.3.0",03)	DZDICOM 4.3.0	9	3	f	\N	LO	1	Unknown	\N
6156	(0009,"DZDICOM 4.3.0",04)	(0009,"DZDICOM 4.3.0",04)	DZDICOM 4.3.0	9	4	f	\N	IS	1	Unknown	\N
6157	(0009,"DZDICOM 4.3.0",05)	(0009,"DZDICOM 4.3.0",05)	DZDICOM 4.3.0	9	5	f	\N	LO	1	Unknown	\N
6158	(0009,"DZDICOM 4.3.0",06)	(0009,"DZDICOM 4.3.0",06)	DZDICOM 4.3.0	9	6	f	\N	LO	1	Unknown	\N
6159	(0009,"DZDICOM 4.3.0",07)	(0009,"DZDICOM 4.3.0",07)	DZDICOM 4.3.0	9	7	f	\N	LO	1	Unknown	\N
6160	(0009,"DZDICOM 4.3.0",08)	(0009,"DZDICOM 4.3.0",08)	DZDICOM 4.3.0	9	8	f	\N	IS	1	Unknown	\N
6161	(0009,"DZDICOM 4.3.0",11)	(0009,"DZDICOM 4.3.0",11)	DZDICOM 4.3.0	9	17	f	\N	LO	1	Unknown	\N
6162	(0009,"DZDICOM 4.3.0",12)	(0009,"DZDICOM 4.3.0",12)	DZDICOM 4.3.0	9	18	f	\N	LO	1	Unknown	\N
6163	(0009,"DZDICOM 4.3.0",13)	(0009,"DZDICOM 4.3.0",13)	DZDICOM 4.3.0	9	19	f	\N	LO	1	Unknown	\N
6164	(0009,"DZDICOM 4.3.0",14)	(0009,"DZDICOM 4.3.0",14)	DZDICOM 4.3.0	9	20	f	\N	LO	1	Unknown	\N
6165	(0009,"DZDICOM 4.3.0",15)	(0009,"DZDICOM 4.3.0",15)	DZDICOM 4.3.0	9	21	f	\N	LO	1	Unknown	\N
6166	(0009,"DZDICOM 4.3.0",16)	(0009,"DZDICOM 4.3.0",16)	DZDICOM 4.3.0	9	22	f	\N	LO	1	Unknown	\N
6167	(0009,"DZDICOM 4.3.0",17)	(0009,"DZDICOM 4.3.0",17)	DZDICOM 4.3.0	9	23	f	\N	LO	1	Unknown	\N
6168	(0009,"DZDICOM 4.3.0",70)	(0009,"DZDICOM 4.3.0",70)	DZDICOM 4.3.0	9	112	f	\N	IS	1	Unknown	\N
6169	(0009,"DZDICOM 4.3.0",71)	(0009,"DZDICOM 4.3.0",71)	DZDICOM 4.3.0	9	113	f	\N	IS	1	Unknown	\N
6170	(0009,"DZDICOM 4.3.0",72)	(0009,"DZDICOM 4.3.0",72)	DZDICOM 4.3.0	9	114	f	\N	IS	1	Unknown	\N
6171	(0009,"DZDICOM 4.3.0",74)	(0009,"DZDICOM 4.3.0",74)	DZDICOM 4.3.0	9	116	f	\N	IS	1	Unknown	\N
6172	(0009,"DZDICOM 4.3.0",7a)	(0009,"DZDICOM 4.3.0",7a)	DZDICOM 4.3.0	9	122	f	\N	IS	1	Unknown	\N
6173	(0009,"DZDICOM 4.3.0",a1)	(0009,"DZDICOM 4.3.0",a1)	DZDICOM 4.3.0	9	161	f	\N	LO	1	Unknown	\N
6174	(0009,"DZDICOM 4.3.0",a2)	(0009,"DZDICOM 4.3.0",a2)	DZDICOM 4.3.0	9	162	f	\N	IS	1	Unknown	\N
6175	(0009,"DZDICOM 4.3.0",f1)	(0009,"DZDICOM 4.3.0",f1)	DZDICOM 4.3.0	9	241	f	\N	LO	1	Unknown	\N
6176	(0009,"DZDICOM 4.3.0",f7)	(0009,"DZDICOM 4.3.0",f7)	DZDICOM 4.3.0	9	247	f	\N	IS	1	Unknown	\N
6177	(0009,"DZDICOM 4.3.0",f9)	(0009,"DZDICOM 4.3.0",f9)	DZDICOM 4.3.0	9	249	f	\N	IS	1	Unknown	\N
6178	(0019,"FOEM 1.0",50)	(0019,"FOEM 1.0",50)	FOEM 1.0	25	80	f	\N	IS	1	Unknown	\N
6179	(0025,"FOEM 1.0",10)	(0025,"FOEM 1.0",10)	FOEM 1.0	37	16	f	\N	US	1	Unknown	\N
6180	(0025,"FOEM 1.0",12)	(0025,"FOEM 1.0",12)	FOEM 1.0	37	18	f	\N	US	1	Unknown	\N
6181	(0029,"FOEM 1.0",20)	(0029,"FOEM 1.0",20)	FOEM 1.0	41	32	f	\N	IS	1	Unknown	\N
6182	(5533,"Visus Change",33)	(5533,"Visus Change",33)	Visus Change	21811	51	f	\N	SQ	1	Save Sequence	\N
6183	(5533,"Visus Change",35)	(5533,"Visus Change",35)	Visus Change	21811	53	f	\N	DA	1	Save Date	\N
6184	(5533,"Visus Change",37)	(5533,"Visus Change",37)	Visus Change	21811	55	f	\N	LO	1	Save Originator	\N
6185	(5533,"Visus Change",39)	(5533,"Visus Change",39)	Visus Change	21811	57	f	\N	FD	1	Save ID	\N
6186	(5533,"Visus Change",3b)	(5533,"Visus Change",3b)	Visus Change	21811	59	f	\N	TM	1	Save Time	\N
6187	(0099,"SYNARC_1.0",01)	(0099,"SYNARC_1.0",01)	SYNARC_1.0	153	1	f	\N	OB	1	Unknown	\N
6188	(0099,"SYNARC_1.0",02)	(0099,"SYNARC_1.0",02)	SYNARC_1.0	153	2	f	\N	OB	1	Unknown	\N
6189	(0099,"SYNARC_1.0",03)	(0099,"SYNARC_1.0",03)	SYNARC_1.0	153	3	f	\N	LO	1	Unknown	\N
6190	(0099,"SYNARC_1.0",04)	(0099,"SYNARC_1.0",04)	SYNARC_1.0	153	4	f	\N	US	1-n	Unknown	\N
6191	(0099,"SYNARC_1.0",05)	(0099,"SYNARC_1.0",05)	SYNARC_1.0	153	5	f	\N	LO	1	Unknown	\N
6192	(0011,"PixelMed Publishing",02)	(0011,"PixelMed Publishing",02)	PixelMed Publishing	17	2	f	\N	UC	1	Strain Description	\N
6193	(0011,"PixelMed Publishing",03)	(0011,"PixelMed Publishing",03)	PixelMed Publishing	17	3	f	\N	LO	1	Strain Nomenclature	\N
6194	(0011,"PixelMed Publishing",04)	(0011,"PixelMed Publishing",04)	PixelMed Publishing	17	4	f	\N	LO	1	Strain Stock Number	\N
6195	(0011,"PixelMed Publishing",05)	(0011,"PixelMed Publishing",05)	PixelMed Publishing	17	5	f	\N	SQ	1	Strain Source Registry Code Sequence	\N
6196	(0011,"PixelMed Publishing",06)	(0011,"PixelMed Publishing",06)	PixelMed Publishing	17	6	f	\N	SQ	1	Strain Stock Sequence	\N
6197	(0011,"PixelMed Publishing",07)	(0011,"PixelMed Publishing",07)	PixelMed Publishing	17	7	f	\N	LO	1	Strain Source	\N
6198	(0011,"PixelMed Publishing",08)	(0011,"PixelMed Publishing",08)	PixelMed Publishing	17	8	f	\N	UT	1	Strain Additional Information	\N
6199	(0011,"PixelMed Publishing",20)	(0011,"PixelMed Publishing",20)	PixelMed Publishing	17	32	f	\N	SQ	1	Strain Code Sequence	\N
6200	(0011,"PixelMed Publishing",50)	(0011,"PixelMed Publishing",50)	PixelMed Publishing	17	80	f	\N	LO	1	Cell Line Designation	\N
6201	(0011,"PixelMed Publishing",51)	(0011,"PixelMed Publishing",51)	PixelMed Publishing	17	81	f	\N	SQ	1	Cell Line Tissue of Origin Code Sequence	\N
6202	(0011,"PixelMed Publishing",52)	(0011,"PixelMed Publishing",52)	PixelMed Publishing	17	82	f	\N	SQ	1	Cell Line Histologic Type Code Sequence	\N
6203	(0011,"PixelMed Publishing",53)	(0011,"PixelMed Publishing",53)	PixelMed Publishing	17	83	f	\N	SQ	1	Cell Line Species of Origin Code Sequence	\N
6204	(0011,"PixelMed Publishing",54)	(0011,"PixelMed Publishing",54)	PixelMed Publishing	17	84	f	\N	UL	1	Cell Line Number of Passages	\N
6205	(0011,"PixelMed Publishing",71)	(0011,"PixelMed Publishing",71)	PixelMed Publishing	17	113	f	\N	SQ	1	Source Patient Group Identification Sequence	\N
6206	(0011,"PixelMed Publishing",72)	(0011,"PixelMed Publishing",72)	PixelMed Publishing	17	114	f	\N	SQ	1	Group of Patients Identification Sequence	\N
6207	(0011,"PixelMed Publishing",73)	(0011,"PixelMed Publishing",73)	PixelMed Publishing	17	115	f	\N	US	3	Subject Relative Position in Image	\N
6208	(0021,"PixelMed Publishing",01)	(0021,"PixelMed Publishing",01)	PixelMed Publishing	33	1	f	\N	SQ	1	Unassigned Shared Converted Attributes Sequence	\N
6209	(0021,"PixelMed Publishing",02)	(0021,"PixelMed Publishing",02)	PixelMed Publishing	33	2	f	\N	SQ	1	Unassigned Per-Frame Converted Attributes Sequence	\N
6210	(0021,"PixelMed Publishing",03)	(0021,"PixelMed Publishing",03)	PixelMed Publishing	33	3	f	\N	SQ	1	Conversion Source Attributes Sequence	\N
6211	(0041,"PixelMed Publishing",01)	(0041,"PixelMed Publishing",01)	PixelMed Publishing	65	1	f	\N	SQ	1	Quantity Definition Code Sequence	\N
6212	(7fe1,"PixelMed Publishing",01)	(7fe1,"PixelMed Publishing",01)	PixelMed Publishing	32737	1	f	\N	OF	1	Float Pixel Data	\N
6213	(7fe1,"PixelMed Publishing",02)	(7fe1,"PixelMed Publishing",02)	PixelMed Publishing	32737	2	f	\N	OD	1	Double Pixel Data	\N
6214	(0011,"METAEMOTION GINKGO",01)	(0011,"METAEMOTION GINKGO",01)	METAEMOTION GINKGO	17	1	f	\N	LT	1	KeyFile Indicator	\N
6215	(0011,"METAEMOTION GINKGO",0b)	(0011,"METAEMOTION GINKGO",0b)	METAEMOTION GINKGO	17	11	f	\N	LT	1	Serialized Diagnose and Markers	\N
6216	(0011,"METAEMOTION GINKGO RETINAL",01)	(0011,"METAEMOTION GINKGO RETINAL",01)	METAEMOTION GINKGO RETINAL	17	1	f	\N	LT	1	KeyFile Indicator	\N
6217	(0011,"METAEMOTION GINKGO RETINAL",0b)	(0011,"METAEMOTION GINKGO RETINAL",0b)	METAEMOTION GINKGO RETINAL	17	11	f	\N	LT	1	Serialized Diagnose and Markers	\N
6218	(0011,"METAEMOTION GINKGO RETINAL",0c)	(0011,"METAEMOTION GINKGO RETINAL",0c)	METAEMOTION GINKGO RETINAL	17	12	f	\N	UN	1	Virtual Aneritra Contrast Image	\N
6219	(0055,"PMOD_1",01)	(0055,"PMOD_1",01)	PMOD_1	85	1	f	\N	FD	1-n	Frame Start Times Vector	\N
6220	(0055,"PMOD_1",02)	(0055,"PMOD_1",02)	PMOD_1	85	2	f	\N	FD	3-3n	Frame Positions Vector	\N
6221	(0055,"PMOD_1",03)	(0055,"PMOD_1",03)	PMOD_1	85	3	f	\N	FD	6-6n	Frame Orientations Vector	\N
6222	(0055,"PMOD_1",04)	(0055,"PMOD_1",04)	PMOD_1	85	4	f	\N	FD	1-n	Frame Durations Vector	\N
6223	(0055,"PMOD_1",05)	(0055,"PMOD_1",05)	PMOD_1	85	5	f	\N	FD	1-n	Frame Rescale Slope Vector	\N
6224	(7fe1,"PMOD_GENPET",01)	(7fe1,"PMOD_GENPET",01)	PMOD_GENPET	32737	1	f	\N	UT	1	Slices Names	\N
6225	(7fe1,"PMOD_GENPET",02)	(7fe1,"PMOD_GENPET",02)	PMOD_GENPET	32737	2	f	\N	UT	1	Gene Codes	\N
6226	(7fe1,"PMOD_GENPET",03)	(7fe1,"PMOD_GENPET",03)	PMOD_GENPET	32737	3	f	\N	UT	1	Gene Labels	\N
6227	(0011,"ULTRAVISUAL_TAG_SET1",01)	(0011,"ULTRAVISUAL_TAG_SET1",01)	ULTRAVISUAL_TAG_SET1	17	1	f	\N	CS	1	Unknown	\N
6228	(0011,"ULTRAVISUAL_TAG_SET1",02)	(0011,"ULTRAVISUAL_TAG_SET1",02)	ULTRAVISUAL_TAG_SET1	17	2	f	\N	UN	1	Unknown	\N
6229	(0011,"ULTRAVISUAL_TAG_SET1",03)	(0011,"ULTRAVISUAL_TAG_SET1",03)	ULTRAVISUAL_TAG_SET1	17	3	f	\N	UN	1	Unknown	\N
6230	(0011,"ULTRAVISUAL_TAG_SET1",08)	(0011,"ULTRAVISUAL_TAG_SET1",08)	ULTRAVISUAL_TAG_SET1	17	8	f	\N	LO	1	Unknown	\N
6231	(0011,"ULTRAVISUAL_TAG_SET1",10)	(0011,"ULTRAVISUAL_TAG_SET1",10)	ULTRAVISUAL_TAG_SET1	17	16	f	\N	US	1	Unknown	\N
6232	(0011,"ULTRAVISUAL_TAG_SET1",11)	(0011,"ULTRAVISUAL_TAG_SET1",11)	ULTRAVISUAL_TAG_SET1	17	17	f	\N	UN	1	Unknown	\N
6233	(0011,"ULTRAVISUAL_TAG_SET1",12)	(0011,"ULTRAVISUAL_TAG_SET1",12)	ULTRAVISUAL_TAG_SET1	17	18	f	\N	UI	1	Unknown	\N
6234	(0011,"ULTRAVISUAL_TAG_SET1",18)	(0011,"ULTRAVISUAL_TAG_SET1",18)	ULTRAVISUAL_TAG_SET1	17	24	f	\N	UL	1	Unknown	\N
6235	(0011,"ULTRAVISUAL_TAG_SET1",19)	(0011,"ULTRAVISUAL_TAG_SET1",19)	ULTRAVISUAL_TAG_SET1	17	25	f	\N	UN	1	Unknown	\N
6236	(0011,"ULTRAVISUAL_TAG_SET1",1a)	(0011,"ULTRAVISUAL_TAG_SET1",1a)	ULTRAVISUAL_TAG_SET1	17	26	f	\N	CS	1	Unknown	\N
6237	(0011,"ULTRAVISUAL_TAG_SET1",1b)	(0011,"ULTRAVISUAL_TAG_SET1",1b)	ULTRAVISUAL_TAG_SET1	17	27	f	\N	IS	1	Unknown	\N
6238	(0011,"ULTRAVISUAL_TAG_SET1",1c)	(0011,"ULTRAVISUAL_TAG_SET1",1c)	ULTRAVISUAL_TAG_SET1	17	28	f	\N	IS	1	Unknown	\N
6239	(0011,"ULTRAVISUAL_TAG_SET1",1d)	(0011,"ULTRAVISUAL_TAG_SET1",1d)	ULTRAVISUAL_TAG_SET1	17	29	f	\N	LO	1	Unknown	\N
6240	(0015,"MATAKINA_10",28)	(0015,"MATAKINA_10",28)	MATAKINA_10	21	40	f	\N	LO	1	Volpara Density Grade	\N
6241	(0015,"MATAKINA_10",29)	(0015,"MATAKINA_10",29)	MATAKINA_10	21	41	f	\N	LT	1	Volpara Run Information	\N
6242	(0015,"MATAKINA_10",30)	(0015,"MATAKINA_10",30)	MATAKINA_10	21	48	f	\N	LO	1	Volpara Density Grade Cutoffs	\N
6243	(0101,"PM",05)	(0101,"PM",05)	PM	257	5	f	\N	LO	1-n	Image Enhancement Parameter File	\N
6244	(0101,"PM",06)	(0101,"PM",06)	PM	257	6	f	\N	IS	1	Original Sigmoid Ratio	\N
6245	(0863,"Biospace Med : EOS Tag",10)	(0863,"Biospace Med : EOS Tag",10)	Biospace Med : EOS Tag	2147	16	f	\N	SL	1	Image Type	\N
6246	(0863,"Biospace Med : EOS Tag",23)	(0863,"Biospace Med : EOS Tag",23)	Biospace Med : EOS Tag	2147	35	f	\N	SL	1	Calibration Flag	\N
6247	(0863,"Biospace Med : EOS Tag",26)	(0863,"Biospace Med : EOS Tag",26)	Biospace Med : EOS Tag	2147	38	f	\N	UL	1	Attribute Version	\N
6248	(0863,"Biospace Med : EOS Tag",27)	(0863,"Biospace Med : EOS Tag",27)	Biospace Med : EOS Tag	2147	39	f	\N	SL	1	Resizing Flag	\N
6249	(0863,"Biospace Med : EOS Tag",28)	(0863,"Biospace Med : EOS Tag",28)	Biospace Med : EOS Tag	2147	40	f	\N	SL	1	Logarithm Flag	\N
6250	(0863,"Biospace Med : EOS Tag",32)	(0863,"Biospace Med : EOS Tag",32)	Biospace Med : EOS Tag	2147	50	f	\N	SL	1	Left Collimator Edge	\N
6251	(0863,"Biospace Med : EOS Tag",33)	(0863,"Biospace Med : EOS Tag",33)	Biospace Med : EOS Tag	2147	51	f	\N	SL	1	Right Collimator Edge	\N
6252	(0863,"Biospace Med : EOS Tag",34)	(0863,"Biospace Med : EOS Tag",34)	Biospace Med : EOS Tag	2147	52	f	\N	FL	1	Distance Source to Patient of Biplane Pair	\N
6253	(0863,"Biospace Med : EOS Tag",35)	(0863,"Biospace Med : EOS Tag",35)	Biospace Med : EOS Tag	2147	53	f	\N	SL	1	Line Correction Flag	\N
6254	(0863,"Biospace Med : EOS Tag",36)	(0863,"Biospace Med : EOS Tag",36)	Biospace Med : EOS Tag	2147	54	f	\N	SL	1	Contrast Enhancement Flag	\N
6255	(0863,"Biospace Med : EOS Tag",37)	(0863,"Biospace Med : EOS Tag",37)	Biospace Med : EOS Tag	2147	55	f	\N	SL	1	Calibre Value	\N
6256	(0863,"Biospace Med : EOS Tag",38)	(0863,"Biospace Med : EOS Tag",38)	Biospace Med : EOS Tag	2147	56	f	\N	SL	1	High Frequency Line Correction Max Threshold	\N
6257	(0863,"Biospace Med : EOS Tag",39)	(0863,"Biospace Med : EOS Tag",39)	Biospace Med : EOS Tag	2147	57	f	\N	SL	1	High Frequency Line Correction Min Threshold	\N
6258	(0863,"Biospace Med : EOS Tag",40)	(0863,"Biospace Med : EOS Tag",40)	Biospace Med : EOS Tag	2147	64	f	\N	FL	1	Greater Limit	\N
6259	(0863,"Biospace Med : EOS Tag",41)	(0863,"Biospace Med : EOS Tag",41)	Biospace Med : EOS Tag	2147	65	f	\N	FL	1	Lower Limit	\N
6260	(0863,"Biospace Med : EOS Tag",42)	(0863,"Biospace Med : EOS Tag",42)	Biospace Med : EOS Tag	2147	66	f	\N	FL	1	Frontal Detector Blades Opening	\N
6261	(0863,"Biospace Med : EOS Tag",43)	(0863,"Biospace Med : EOS Tag",43)	Biospace Med : EOS Tag	2147	67	f	\N	FL	1	Frontal Tube Blades Opening	\N
6262	(0863,"Biospace Med : EOS Tag",44)	(0863,"Biospace Med : EOS Tag",44)	Biospace Med : EOS Tag	2147	68	f	\N	FL	1	Lateral Detector Blades Opening	\N
6263	(0863,"Biospace Med : EOS Tag",45)	(0863,"Biospace Med : EOS Tag",45)	Biospace Med : EOS Tag	2147	69	f	\N	FL	1	Lateral Tube Blades Opening	\N
6264	(0863,"Biospace Med : EOS Tag",46)	(0863,"Biospace Med : EOS Tag",46)	Biospace Med : EOS Tag	2147	70	f	\N	DS	1-n	ThreeD Calibration Parameters	\N
6265	(0863,"Biospace Med : EOS Tag",57)	(0863,"Biospace Med : EOS Tag",57)	Biospace Med : EOS Tag	2147	87	f	\N	CS	1	Image Horizontal Flip	\N
6266	(0019,"PRIVATE_CODE_STRING_0019",00)	(0019,"PRIVATE_CODE_STRING_0019",00)	PRIVATE_CODE_STRING_0019	25	0	f	\N	FD	1	Calibration	\N
6267	(0019,"PRIVATE_CODE_STRING_0019",01)	(0019,"PRIVATE_CODE_STRING_0019",01)	PRIVATE_CODE_STRING_0019	25	1	f	\N	FD	1	Depth Conversion	\N
6268	(0019,"PRIVATE_CODE_STRING_0019",02)	(0019,"PRIVATE_CODE_STRING_0019",02)	PRIVATE_CODE_STRING_0019	25	2	f	\N	FD	1	Stepsize	\N
6269	(0019,"PRIVATE_CODE_STRING_0019",03)	(0019,"PRIVATE_CODE_STRING_0019",03)	PRIVATE_CODE_STRING_0019	25	3	f	\N	SL	1-n	Warning	\N
6270	(0019,"PRIVATE_CODE_STRING_0019",04)	(0019,"PRIVATE_CODE_STRING_0019",04)	PRIVATE_CODE_STRING_0019	25	4	f	\N	ST	1	DataID	\N
6271	(0021,"PRIVATE_CODE_STRING_0021",70)	(0021,"PRIVATE_CODE_STRING_0021",70)	PRIVATE_CODE_STRING_0021	33	112	f	\N	FD	1	Distance Base Plane to Template	\N
6272	(0021,"PRIVATE_CODE_STRING_0021",71)	(0021,"PRIVATE_CODE_STRING_0021",71)	PRIVATE_CODE_STRING_0021	33	113	f	\N	FD	16	Volume to Patient Matrix	\N
6273	(0021,"PRIVATE_CODE_STRING_0021",72)	(0021,"PRIVATE_CODE_STRING_0021",72)	PRIVATE_CODE_STRING_0021	33	114	f	\N	FD	16	Patient to World Matrix	\N
6274	(0021,"PRIVATE_CODE_STRING_0021",73)	(0021,"PRIVATE_CODE_STRING_0021",73)	PRIVATE_CODE_STRING_0021	33	115	f	\N	SL	1	Base Plane	\N
6275	(0021,"PRIVATE_CODE_STRING_0021",74)	(0021,"PRIVATE_CODE_STRING_0021",74)	PRIVATE_CODE_STRING_0021	33	116	f	\N	SL	1	Reference Plane	\N
6276	(0021,"PRIVATE_CODE_STRING_0021",75)	(0021,"PRIVATE_CODE_STRING_0021",75)	PRIVATE_CODE_STRING_0021	33	117	f	\N	SL	1	Apex Plane	\N
6277	(0021,"PRIVATE_CODE_STRING_0021",76)	(0021,"PRIVATE_CODE_STRING_0021",76)	PRIVATE_CODE_STRING_0021	33	118	f	\N	FD	1	Base Plane Offset	\N
6278	(1001,"PRIVATE_CODE_STRING_1001",a0)	(1001,"PRIVATE_CODE_STRING_1001",a0)	PRIVATE_CODE_STRING_1001	4097	160	f	\N	SQ	1	Marker Sequence	\N
6279	(1001,"PRIVATE_CODE_STRING_1001",a1)	(1001,"PRIVATE_CODE_STRING_1001",a1)	PRIVATE_CODE_STRING_1001	4097	161	f	\N	SL	1	Marker Type	\N
6280	(1001,"PRIVATE_CODE_STRING_1001",a2)	(1001,"PRIVATE_CODE_STRING_1001",a2)	PRIVATE_CODE_STRING_1001	4097	162	f	\N	SL	1	Marker Number	\N
6281	(1001,"PRIVATE_CODE_STRING_1001",a3)	(1001,"PRIVATE_CODE_STRING_1001",a3)	PRIVATE_CODE_STRING_1001	4097	163	f	\N	FD	3	Marker 3D Position	\N
6282	(1001,"PRIVATE_CODE_STRING_1001",b0)	(1001,"PRIVATE_CODE_STRING_1001",b0)	PRIVATE_CODE_STRING_1001	4097	176	f	\N	SL	1	Distance Unit	\N
6283	(1001,"PRIVATE_CODE_STRING_1001",b1)	(1001,"PRIVATE_CODE_STRING_1001",b1)	PRIVATE_CODE_STRING_1001	4097	177	f	\N	SL	1	Dose Unit	\N
6284	(1001,"PRIVATE_CODE_STRING_1001",b2)	(1001,"PRIVATE_CODE_STRING_1001",b2)	PRIVATE_CODE_STRING_1001	4097	178	f	\N	SL	1	Normalisation Mode	\N
6285	(1001,"PRIVATE_CODE_STRING_1001",b3)	(1001,"PRIVATE_CODE_STRING_1001",b3)	PRIVATE_CODE_STRING_1001	4097	179	f	\N	FD	1	Normalisation Factor	\N
6286	(1001,"PRIVATE_CODE_STRING_1001",b4)	(1001,"PRIVATE_CODE_STRING_1001",b4)	PRIVATE_CODE_STRING_1001	4097	180	f	\N	FD	1	F-Value	\N
6287	(1001,"PRIVATE_CODE_STRING_1001",b5)	(1001,"PRIVATE_CODE_STRING_1001",b5)	PRIVATE_CODE_STRING_1001	4097	181	f	\N	FD	1	Prescribed Dose	\N
6288	(1001,"PRIVATE_CODE_STRING_1001",b6)	(1001,"PRIVATE_CODE_STRING_1001",b6)	PRIVATE_CODE_STRING_1001	4097	182	f	\N	FD	1	Absolute Dose Factor	\N
6289	(1001,"PRIVATE_CODE_STRING_1001",b7)	(1001,"PRIVATE_CODE_STRING_1001",b7)	PRIVATE_CODE_STRING_1001	4097	183	f	\N	SL	1	Decoupled sk	\N
6290	(1001,"PRIVATE_CODE_STRING_1001",b8)	(1001,"PRIVATE_CODE_STRING_1001",b8)	PRIVATE_CODE_STRING_1001	4097	184	f	\N	FD	1	Absolute Time Factor	\N
6291	(1001,"PRIVATE_CODE_STRING_1001",b9)	(1001,"PRIVATE_CODE_STRING_1001",b9)	PRIVATE_CODE_STRING_1001	4097	185	f	\N	FD	1	Total Treatment Time	\N
6292	(1001,"PRIVATE_CODE_STRING_1001",ba)	(1001,"PRIVATE_CODE_STRING_1001",ba)	PRIVATE_CODE_STRING_1001	4097	186	f	\N	SL	1	TG 43 Model	\N
6293	(1001,"PRIVATE_CODE_STRING_1001",bb)	(1001,"PRIVATE_CODE_STRING_1001",bb)	PRIVATE_CODE_STRING_1001	4097	187	f	\N	SL	1	3D Dose Grid Size	\N
6294	(1001,"PRIVATE_CODE_STRING_1001",bc)	(1001,"PRIVATE_CODE_STRING_1001",bc)	PRIVATE_CODE_STRING_1001	4097	188	f	\N	FD	3	Dose Grid Corner 1	\N
6295	(1001,"PRIVATE_CODE_STRING_1001",bd)	(1001,"PRIVATE_CODE_STRING_1001",bd)	PRIVATE_CODE_STRING_1001	4097	189	f	\N	FD	3	Dose Grid Corner 2	\N
6296	(1001,"PRIVATE_CODE_STRING_1001",be)	(1001,"PRIVATE_CODE_STRING_1001",be)	PRIVATE_CODE_STRING_1001	4097	190	f	\N	FD	1	Patient Data Conversion	\N
6297	(1001,"PRIVATE_CODE_STRING_1001",bf)	(1001,"PRIVATE_CODE_STRING_1001",bf)	PRIVATE_CODE_STRING_1001	4097	191	f	\N	FD	1	Volume Data Conversion	\N
6298	(1001,"PRIVATE_CODE_STRING_1001",c0)	(1001,"PRIVATE_CODE_STRING_1001",c0)	PRIVATE_CODE_STRING_1001	4097	192	f	\N	FD	3	Volume Data Vector	\N
6299	(1001,"PRIVATE_CODE_STRING_1001",c1)	(1001,"PRIVATE_CODE_STRING_1001",c1)	PRIVATE_CODE_STRING_1001	4097	193	f	\N	SL	1	Optimization Method	\N
6300	(1001,"PRIVATE_CODE_STRING_1001",c2)	(1001,"PRIVATE_CODE_STRING_1001",c2)	PRIVATE_CODE_STRING_1001	4097	194	f	\N	SL	1	Display Method	\N
6301	(1001,"PRIVATE_CODE_STRING_1001",c3)	(1001,"PRIVATE_CODE_STRING_1001",c3)	PRIVATE_CODE_STRING_1001	4097	195	f	\N	SL	1	Geometrical Method	\N
6302	(1001,"PRIVATE_CODE_STRING_1001",c5)	(1001,"PRIVATE_CODE_STRING_1001",c5)	PRIVATE_CODE_STRING_1001	4097	197	f	\N	SL	1	VOI Number	\N
6303	(1001,"PRIVATE_CODE_STRING_1001",c6)	(1001,"PRIVATE_CODE_STRING_1001",c6)	PRIVATE_CODE_STRING_1001	4097	198	f	\N	LO	1	VOI Name	\N
6304	(1001,"PRIVATE_CODE_STRING_1001",c7)	(1001,"PRIVATE_CODE_STRING_1001",c7)	PRIVATE_CODE_STRING_1001	4097	199	f	\N	SL	1	VOI Type	\N
6305	(1001,"PRIVATE_CODE_STRING_1001",c8)	(1001,"PRIVATE_CODE_STRING_1001",c8)	PRIVATE_CODE_STRING_1001	4097	200	f	\N	SL	1	VOI Class	\N
6306	(1001,"PRIVATE_CODE_STRING_1001",c9)	(1001,"PRIVATE_CODE_STRING_1001",c9)	PRIVATE_CODE_STRING_1001	4097	201	f	\N	SL	1	VOI Priority	\N
6307	(1001,"PRIVATE_CODE_STRING_1001",ca)	(1001,"PRIVATE_CODE_STRING_1001",ca)	PRIVATE_CODE_STRING_1001	4097	202	f	\N	SL	1	No of Points	\N
6308	(1001,"PRIVATE_CODE_STRING_1001",cb)	(1001,"PRIVATE_CODE_STRING_1001",cb)	PRIVATE_CODE_STRING_1001	4097	203	f	\N	FD	1	Percent On Surface	\N
6309	(1001,"PRIVATE_CODE_STRING_1001",cc)	(1001,"PRIVATE_CODE_STRING_1001",cc)	PRIVATE_CODE_STRING_1001	4097	204	f	\N	FD	1	Surface Margin	\N
6310	(1001,"PRIVATE_CODE_STRING_1001",cd)	(1001,"PRIVATE_CODE_STRING_1001",cd)	PRIVATE_CODE_STRING_1001	4097	205	f	\N	SL	1	Selected	\N
6311	(1001,"PRIVATE_CODE_STRING_1001",ce)	(1001,"PRIVATE_CODE_STRING_1001",ce)	PRIVATE_CODE_STRING_1001	4097	206	f	\N	FD	1	Dose Limit	\N
6312	(1001,"PRIVATE_CODE_STRING_1001",cf)	(1001,"PRIVATE_CODE_STRING_1001",cf)	PRIVATE_CODE_STRING_1001	4097	207	f	\N	FD	1	Importance Factor	\N
6313	(1001,"PRIVATE_CODE_STRING_1001",d0)	(1001,"PRIVATE_CODE_STRING_1001",d0)	PRIVATE_CODE_STRING_1001	4097	208	f	\N	FD	1	Importance Factor From	\N
6314	(1001,"PRIVATE_CODE_STRING_1001",d1)	(1001,"PRIVATE_CODE_STRING_1001",d1)	PRIVATE_CODE_STRING_1001	4097	209	f	\N	FD	1	Importance Factor To	\N
6315	(1001,"PRIVATE_CODE_STRING_1001",d2)	(1001,"PRIVATE_CODE_STRING_1001",d2)	PRIVATE_CODE_STRING_1001	4097	210	f	\N	FD	1	Focus	\N
6316	(1001,"PRIVATE_CODE_STRING_1001",d3)	(1001,"PRIVATE_CODE_STRING_1001",d3)	PRIVATE_CODE_STRING_1001	4097	211	f	\N	SL	1	Surface Sampling Method	\N
6317	(1001,"PRIVATE_CODE_STRING_1001",d4)	(1001,"PRIVATE_CODE_STRING_1001",d4)	PRIVATE_CODE_STRING_1001	4097	212	f	\N	FD	1	Number of Sampling Points Per ccm	\N
6318	(1001,"PRIVATE_CODE_STRING_1001",d5)	(1001,"PRIVATE_CODE_STRING_1001",d5)	PRIVATE_CODE_STRING_1001	4097	213	f	\N	SL	1	Convergence Accuracy	\N
6425	(3335,"CAD Sciences",07)	(3335,"CAD Sciences",07)	CAD Sciences	13109	7	f	\N	UN	1	Unknown	\N
6319	(1001,"PRIVATE_CODE_STRING_1001",d6)	(1001,"PRIVATE_CODE_STRING_1001",d6)	PRIVATE_CODE_STRING_1001	4097	214	f	\N	SL	1	Max No of Convergence Iterations	\N
6320	(1001,"PRIVATE_CODE_STRING_1001",d7)	(1001,"PRIVATE_CODE_STRING_1001",d7)	PRIVATE_CODE_STRING_1001	4097	215	f	\N	FD	1	Weight Smoothing	\N
6321	(1001,"PRIVATE_CODE_STRING_1001",d8)	(1001,"PRIVATE_CODE_STRING_1001",d8)	PRIVATE_CODE_STRING_1001	4097	216	f	\N	SL	1	Steps Per Importance Factor	\N
6322	(1001,"PRIVATE_CODE_STRING_1001",d9)	(1001,"PRIVATE_CODE_STRING_1001",d9)	PRIVATE_CODE_STRING_1001	4097	217	f	\N	FD	1	Constraints PTVDmax	\N
6323	(1001,"PRIVATE_CODE_STRING_1001",da)	(1001,"PRIVATE_CODE_STRING_1001",da)	PRIVATE_CODE_STRING_1001	4097	218	f	\N	FD	1	Constraints NTDmax	\N
6324	(1001,"PRIVATE_CODE_STRING_1001",db)	(1001,"PRIVATE_CODE_STRING_1001",db)	PRIVATE_CODE_STRING_1001	4097	219	f	\N	SL	1	Algorithmic Population Size	\N
6325	(1001,"PRIVATE_CODE_STRING_1001",dc)	(1001,"PRIVATE_CODE_STRING_1001",dc)	PRIVATE_CODE_STRING_1001	4097	220	f	\N	SL	1	Algorithmic Generations	\N
6326	(1001,"PRIVATE_CODE_STRING_1001",dd)	(1001,"PRIVATE_CODE_STRING_1001",dd)	PRIVATE_CODE_STRING_1001	4097	221	f	\N	SL	1	Algorithmic Initializations	\N
6327	(1001,"PRIVATE_CODE_STRING_1001",de)	(1001,"PRIVATE_CODE_STRING_1001",de)	PRIVATE_CODE_STRING_1001	4097	222	f	\N	SL	1	Min No Of SDP	\N
6328	(1001,"PRIVATE_CODE_STRING_1001",df)	(1001,"PRIVATE_CODE_STRING_1001",df)	PRIVATE_CODE_STRING_1001	4097	223	f	\N	SL	1	Depth Method	\N
6329	(1001,"PRIVATE_CODE_STRING_1001",e0)	(1001,"PRIVATE_CODE_STRING_1001",e0)	PRIVATE_CODE_STRING_1001	4097	224	f	\N	SL	1	Depth Defined On	\N
6330	(1001,"PRIVATE_CODE_STRING_1001",e1)	(1001,"PRIVATE_CODE_STRING_1001",e1)	PRIVATE_CODE_STRING_1001	4097	225	f	\N	FD	1	Depth	\N
6331	(1001,"PRIVATE_CODE_STRING_1001",e2)	(1001,"PRIVATE_CODE_STRING_1001",e2)	PRIVATE_CODE_STRING_1001	4097	226	f	\N	SQ	1	VOI Based Placement Settings Sequence	\N
6332	(1001,"PRIVATE_CODE_STRING_1001",e7)	(1001,"PRIVATE_CODE_STRING_1001",e7)	PRIVATE_CODE_STRING_1001	4097	231	f	\N	SL	1	VOI Selected	\N
6333	(1001,"PRIVATE_CODE_STRING_1001",e8)	(1001,"PRIVATE_CODE_STRING_1001",e8)	PRIVATE_CODE_STRING_1001	4097	232	f	\N	FD	1	Margin	\N
6334	(1001,"PRIVATE_CODE_STRING_1001",e9)	(1001,"PRIVATE_CODE_STRING_1001",e9)	PRIVATE_CODE_STRING_1001	4097	233	f	\N	SL	1	Selection Method	\N
6335	(1001,"PRIVATE_CODE_STRING_1001",ea)	(1001,"PRIVATE_CODE_STRING_1001",ea)	PRIVATE_CODE_STRING_1001	4097	234	f	\N	FD	1	Selection Distance	\N
6336	(1001,"PRIVATE_CODE_STRING_1001",eb)	(1001,"PRIVATE_CODE_STRING_1001",eb)	PRIVATE_CODE_STRING_1001	4097	235	f	\N	FD	1	WBT On Contour Spacing	\N
6337	(1001,"PRIVATE_CODE_STRING_1001",ec)	(1001,"PRIVATE_CODE_STRING_1001",ec)	PRIVATE_CODE_STRING_1001	4097	236	f	\N	FD	1	WBT Urethra Margin	\N
6338	(1001,"PRIVATE_CODE_STRING_1001",ed)	(1001,"PRIVATE_CODE_STRING_1001",ed)	PRIVATE_CODE_STRING_1001	4097	237	f	\N	FD	1	WBT Searching Radius PTV	\N
6339	(1001,"PRIVATE_CODE_STRING_1001",ee)	(1001,"PRIVATE_CODE_STRING_1001",ee)	PRIVATE_CODE_STRING_1001	4097	238	f	\N	FD	1	WBT Searching Radius OAR	\N
6340	(1001,"PRIVATE_CODE_STRING_1001",ef)	(1001,"PRIVATE_CODE_STRING_1001",ef)	PRIVATE_CODE_STRING_1001	4097	239	f	\N	FD	3	WBT Starting Point	\N
6341	(1001,"PRIVATE_CODE_STRING_1001",f0)	(1001,"PRIVATE_CODE_STRING_1001",f0)	PRIVATE_CODE_STRING_1001	4097	240	f	\N	FD	4	WBT Surface	\N
6342	(1001,"PRIVATE_CODE_STRING_1001",f1)	(1001,"PRIVATE_CODE_STRING_1001",f1)	PRIVATE_CODE_STRING_1001	4097	241	f	\N	FD	4	WBT No of Interior Catheters	\N
6343	(1001,"PRIVATE_CODE_STRING_1001",f2)	(1001,"PRIVATE_CODE_STRING_1001",f2)	PRIVATE_CODE_STRING_1001	4097	242	f	\N	FD	4	WBT Relative Radius	\N
6344	(1001,"PRIVATE_CODE_STRING_1001",f3)	(1001,"PRIVATE_CODE_STRING_1001",f3)	PRIVATE_CODE_STRING_1001	4097	243	f	\N	SL	1	Sorting Method	\N
6345	(1003,"PRIVATE_CODE_STRING_1003",01)	(1003,"PRIVATE_CODE_STRING_1003",01)	PRIVATE_CODE_STRING_1003	4099	1	f	\N	UN	1	Number Of Probes	\N
6346	(1003,"PRIVATE_CODE_STRING_1003",10)	(1003,"PRIVATE_CODE_STRING_1003",10)	PRIVATE_CODE_STRING_1003	4099	16	f	\N	UN	1	US Probe Sequence	\N
6347	(1003,"PRIVATE_CODE_STRING_1003",11)	(1003,"PRIVATE_CODE_STRING_1003",11)	PRIVATE_CODE_STRING_1003	4099	17	f	\N	UN	1	Identifier	\N
6348	(1003,"PRIVATE_CODE_STRING_1003",12)	(1003,"PRIVATE_CODE_STRING_1003",12)	PRIVATE_CODE_STRING_1003	4099	18	f	\N	UN	1	Probe Name	\N
6349	(1003,"PRIVATE_CODE_STRING_1003",13)	(1003,"PRIVATE_CODE_STRING_1003",13)	PRIVATE_CODE_STRING_1003	4099	19	f	\N	UN	1	Depth	\N
6350	(1003,"PRIVATE_CODE_STRING_1003",14)	(1003,"PRIVATE_CODE_STRING_1003",14)	PRIVATE_CODE_STRING_1003	4099	20	f	\N	UN	1	Frequency	\N
6351	(1003,"PRIVATE_CODE_STRING_1003",15)	(1003,"PRIVATE_CODE_STRING_1003",15)	PRIVATE_CODE_STRING_1003	4099	21	f	\N	UN	1	Gain	\N
6352	(1003,"PRIVATE_CODE_STRING_1003",16)	(1003,"PRIVATE_CODE_STRING_1003",16)	PRIVATE_CODE_STRING_1003	4099	22	f	\N	UN	1	Power	\N
6353	(1003,"PRIVATE_CODE_STRING_1003",17)	(1003,"PRIVATE_CODE_STRING_1003",17)	PRIVATE_CODE_STRING_1003	4099	23	f	\N	UN	1	Dynamic Range	\N
6354	(1003,"PRIVATE_CODE_STRING_1003",18)	(1003,"PRIVATE_CODE_STRING_1003",18)	PRIVATE_CODE_STRING_1003	4099	24	f	\N	UN	1	Frame Averaging	\N
6355	(1003,"PRIVATE_CODE_STRING_1003",19)	(1003,"PRIVATE_CODE_STRING_1003",19)	PRIVATE_CODE_STRING_1003	4099	25	f	\N	UN	1	Field Of View	\N
6356	(1003,"PRIVATE_CODE_STRING_1003",20)	(1003,"PRIVATE_CODE_STRING_1003",20)	PRIVATE_CODE_STRING_1003	4099	32	f	\N	UN	1	TGC	\N
6357	(1003,"PRIVATE_CODE_STRING_1003",2a)	(1003,"PRIVATE_CODE_STRING_1003",2a)	PRIVATE_CODE_STRING_1003	4099	42	f	\N	UN	1	Number Of Focus Sets	\N
6358	(1003,"PRIVATE_CODE_STRING_1003",2b)	(1003,"PRIVATE_CODE_STRING_1003",2b)	PRIVATE_CODE_STRING_1003	4099	43	f	\N	UN	1	Current Focus Set	\N
6359	(1003,"PRIVATE_CODE_STRING_1003",2c)	(1003,"PRIVATE_CODE_STRING_1003",2c)	PRIVATE_CODE_STRING_1003	4099	44	f	\N	UN	1	Image Enhancement Filter Index	\N
6360	(1003,"PRIVATE_CODE_STRING_1003",2d)	(1003,"PRIVATE_CODE_STRING_1003",2d)	PRIVATE_CODE_STRING_1003	4099	45	f	\N	UN	1	Rejection Filter Low	\N
6361	(1003,"PRIVATE_CODE_STRING_1003",2e)	(1003,"PRIVATE_CODE_STRING_1003",2e)	PRIVATE_CODE_STRING_1003	4099	46	f	\N	UN	1	Rejection Filter High	\N
6362	(1003,"PRIVATE_CODE_STRING_1003",2f)	(1003,"PRIVATE_CODE_STRING_1003",2f)	PRIVATE_CODE_STRING_1003	4099	47	f	\N	UN	1	Brightness	\N
6363	(1003,"PRIVATE_CODE_STRING_1003",30)	(1003,"PRIVATE_CODE_STRING_1003",30)	PRIVATE_CODE_STRING_1003	4099	48	f	\N	UN	1	Contrast	\N
6364	(1003,"PRIVATE_CODE_STRING_1003",31)	(1003,"PRIVATE_CODE_STRING_1003",31)	PRIVATE_CODE_STRING_1003	4099	49	f	\N	UN	1	Gamma	\N
6365	(1003,"PRIVATE_CODE_STRING_1003",32)	(1003,"PRIVATE_CODE_STRING_1003",32)	PRIVATE_CODE_STRING_1003	4099	50	f	\N	UN	1	Speckle Enabled	\N
6366	(1003,"PRIVATE_CODE_STRING_1003",33)	(1003,"PRIVATE_CODE_STRING_1003",33)	PRIVATE_CODE_STRING_1003	4099	51	f	\N	UN	1	Speckle Level	\N
6367	(1003,"PRIVATE_CODE_STRING_1003",40)	(1003,"PRIVATE_CODE_STRING_1003",40)	PRIVATE_CODE_STRING_1003	4099	64	f	\N	UN	1	Focus Set Sequence	\N
6368	(1003,"PRIVATE_CODE_STRING_1003",41)	(1003,"PRIVATE_CODE_STRING_1003",41)	PRIVATE_CODE_STRING_1003	4099	65	f	\N	UN	1	Identifier	\N
6369	(1003,"PRIVATE_CODE_STRING_1003",42)	(1003,"PRIVATE_CODE_STRING_1003",42)	PRIVATE_CODE_STRING_1003	4099	66	f	\N	UN	1	Number Of Focus Zone	\N
6370	(1003,"PRIVATE_CODE_STRING_1003",43)	(1003,"PRIVATE_CODE_STRING_1003",43)	PRIVATE_CODE_STRING_1003	4099	67	f	\N	UN	1	Focus	\N
6371	(3007,"PRIVATE_CODE_STRING_3007",00)	(3007,"PRIVATE_CODE_STRING_3007",00)	PRIVATE_CODE_STRING_3007	12295	0	f	\N	FD	16	Volume to Patient Matrix	\N
6372	(3007,"PRIVATE_CODE_STRING_3007",01)	(3007,"PRIVATE_CODE_STRING_3007",01)	PRIVATE_CODE_STRING_3007	12295	1	f	\N	FD	16	Volume Resolution Conversion	\N
6373	(3007,"PRIVATE_CODE_STRING_3007",02)	(3007,"PRIVATE_CODE_STRING_3007",02)	PRIVATE_CODE_STRING_3007	12295	2	f	\N	FD	16	Volume Data Conversion	\N
6374	(3007,"PRIVATE_CODE_STRING_3007",03)	(3007,"PRIVATE_CODE_STRING_3007",03)	PRIVATE_CODE_STRING_3007	12295	3	f	\N	FD	16	Patient Data Conversion	\N
6375	(3007,"PRIVATE_CODE_STRING_3007",04)	(3007,"PRIVATE_CODE_STRING_3007",04)	PRIVATE_CODE_STRING_3007	12295	4	f	\N	FD	16	DICOM Data Conversion	\N
6376	(300b,"PRIVATE_CODE_STRING_300B",00)	(300b,"PRIVATE_CODE_STRING_300B",00)	PRIVATE_CODE_STRING_300B	12299	0	f	\N	SL	1	Template Mode	\N
6377	(300b,"PRIVATE_CODE_STRING_300B",01)	(300b,"PRIVATE_CODE_STRING_300B",01)	PRIVATE_CODE_STRING_300B	12299	1	f	\N	LO	1	Template ID	\N
6378	(300b,"PRIVATE_CODE_STRING_300B",02)	(300b,"PRIVATE_CODE_STRING_300B",02)	PRIVATE_CODE_STRING_300B	12299	2	f	\N	SL	1	Number of Columns	\N
6379	(300b,"PRIVATE_CODE_STRING_300B",03)	(300b,"PRIVATE_CODE_STRING_300B",03)	PRIVATE_CODE_STRING_300B	12299	3	f	\N	FD	1	Column Distance	\N
6380	(300b,"PRIVATE_CODE_STRING_300B",04)	(300b,"PRIVATE_CODE_STRING_300B",04)	PRIVATE_CODE_STRING_300B	12299	4	f	\N	SL	1	Number of Rows	\N
6381	(300b,"PRIVATE_CODE_STRING_300B",05)	(300b,"PRIVATE_CODE_STRING_300B",05)	PRIVATE_CODE_STRING_300B	12299	5	f	\N	FD	1	Row Distance	\N
6382	(300b,"PRIVATE_CODE_STRING_300B",06)	(300b,"PRIVATE_CODE_STRING_300B",06)	PRIVATE_CODE_STRING_300B	12299	6	f	\N	SL	1	Origin	\N
6383	(300b,"PRIVATE_CODE_STRING_300B",07)	(300b,"PRIVATE_CODE_STRING_300B",07)	PRIVATE_CODE_STRING_300B	12299	7	f	\N	SH	1-n	Column Numbering	\N
6384	(300b,"PRIVATE_CODE_STRING_300B",08)	(300b,"PRIVATE_CODE_STRING_300B",08)	PRIVATE_CODE_STRING_300B	12299	8	f	\N	SH	1-n	Row Numbering	\N
6385	(300b,"PRIVATE_CODE_STRING_300B",09)	(300b,"PRIVATE_CODE_STRING_300B",09)	PRIVATE_CODE_STRING_300B	12299	9	f	\N	SS	1-n	Used Holes Array	\N
6386	(300b,"PRIVATE_CODE_STRING_300B",0a)	(300b,"PRIVATE_CODE_STRING_300B",0a)	PRIVATE_CODE_STRING_300B	12299	10	f	\N	SL	1	Lock Status	\N
6387	(300b,"PRIVATE_CODE_STRING_300B",0c)	(300b,"PRIVATE_CODE_STRING_300B",0c)	PRIVATE_CODE_STRING_300B	12299	12	f	\N	UN	1	Identifier	\N
6388	(300b,"PRIVATE_CODE_STRING_300B",0d)	(300b,"PRIVATE_CODE_STRING_300B",0d)	PRIVATE_CODE_STRING_300B	12299	13	f	\N	UN	1	Modification Type	\N
6389	(300b,"PRIVATE_CODE_STRING_300B",0e)	(300b,"PRIVATE_CODE_STRING_300B",0e)	PRIVATE_CODE_STRING_300B	12299	14	f	\N	UN	1	Modification Value	\N
6390	(300b,"PRIVATE_CODE_STRING_300B",0f)	(300b,"PRIVATE_CODE_STRING_300B",0f)	PRIVATE_CODE_STRING_300B	12299	15	f	\N	UN	1	Transformation Matrix	\N
6391	(000d,"INSTRU_PRIVATE_IDENT_CODE",00)	(000d,"INSTRU_PRIVATE_IDENT_CODE",00)	INSTRU_PRIVATE_IDENT_CODE	13	0	f	\N	OB	1	Image Xml Data	\N
6392	(000d,"SCANORA_PRIVATE_IDENT_CODE",00)	(000d,"SCANORA_PRIVATE_IDENT_CODE",00)	SCANORA_PRIVATE_IDENT_CODE	13	0	f	\N	OB	1	Image Xml Data	\N
6393	(0019,"NNT",02)	(0019,"NNT",02)	NNT	25	2	f	\N	US	1	Unknown	\N
6394	(0019,"NNT",03)	(0019,"NNT",03)	NNT	25	3	f	\N	DS	1	Unknown	\N
6395	(0019,"NNT",04)	(0019,"NNT",04)	NNT	25	4	f	\N	DS	1	Unknown	\N
6396	(0019,"NNT",05)	(0019,"NNT",05)	NNT	25	5	f	\N	DS	1	Unknown	\N
6397	(0019,"NNT",06)	(0019,"NNT",06)	NNT	25	6	f	\N	DS	1	Unknown	\N
6398	(0019,"NNT",07)	(0019,"NNT",07)	NNT	25	7	f	\N	DS	1	Unknown	\N
6399	(0019,"NNT",09)	(0019,"NNT",09)	NNT	25	9	f	\N	DS	1	Unknown	\N
6400	(0019,"NNT",0a)	(0019,"NNT",0a)	NNT	25	10	f	\N	DS	1	Unknown	\N
6401	(0019,"NNT",0b)	(0019,"NNT",0b)	NNT	25	11	f	\N	DS	1	Unknown	\N
6402	(0019,"NNT",0c)	(0019,"NNT",0c)	NNT	25	12	f	\N	DS	1	Unknown	\N
6403	(0019,"NNT",0d)	(0019,"NNT",0d)	NNT	25	13	f	\N	DS	1	Unknown	\N
6404	(0019,"NNT",0e)	(0019,"NNT",0e)	NNT	25	14	f	\N	DS	1	Unknown	\N
6405	(0019,"NNT",0f)	(0019,"NNT",0f)	NNT	25	15	f	\N	DS	1	Unknown	\N
6406	(0019,"NNT",12)	(0019,"NNT",12)	NNT	25	18	f	\N	DS	1	Unknown	\N
6407	(0019,"NNT",13)	(0019,"NNT",13)	NNT	25	19	f	\N	DS	1	Unknown	\N
6408	(0019,"NNT",1e)	(0019,"NNT",1e)	NNT	25	30	f	\N	DS	3	Unknown	\N
6409	(0019,"NNT",1f)	(0019,"NNT",1f)	NNT	25	31	f	\N	DS	1	Unknown	\N
6410	(0019,"NNT",20)	(0019,"NNT",20)	NNT	25	32	f	\N	DS	1	Unknown	\N
6411	(0019,"NNT",21)	(0019,"NNT",21)	NNT	25	33	f	\N	DS	1	Unknown	\N
6412	(0019,"NNT",22)	(0019,"NNT",22)	NNT	25	34	f	\N	IS	1	Unknown	\N
6413	(0019,"NNT",23)	(0019,"NNT",23)	NNT	25	35	f	\N	IS	1	Unknown	\N
6414	(0019,"NNT",24)	(0019,"NNT",24)	NNT	25	36	f	\N	LO	1	Unknown	\N
6415	(0019,"NNT",25)	(0019,"NNT",25)	NNT	25	37	f	\N	IS	1	Unknown	\N
6416	(0019,"NNT",26)	(0019,"NNT",26)	NNT	25	38	f	\N	LO	1	Unknown	\N
6417	(0019,"NNT",27)	(0019,"NNT",27)	NNT	25	39	f	\N	LO	1	Unknown	\N
6418	(0019,"NNT",28)	(0019,"NNT",28)	NNT	25	40	f	\N	LO	1	Unknown	\N
6419	(0019,"NNT",30)	(0019,"NNT",30)	NNT	25	48	f	\N	LO	1	Unknown	\N
6420	(0019,"NNT",31)	(0019,"NNT",31)	NNT	25	49	f	\N	IS	1	Unknown	\N
6421	(0019,"NNT",32)	(0019,"NNT",32)	NNT	25	50	f	\N	IS	1	Unknown	\N
6422	(0019,"NNT",33)	(0019,"NNT",33)	NNT	25	51	f	\N	DS	8	Unknown	\N
6423	(3335,"CAD Sciences",00)	(3335,"CAD Sciences",00)	CAD Sciences	13109	0	f	\N	UN	1	Unknown	\N
6424	(3335,"CAD Sciences",06)	(3335,"CAD Sciences",06)	CAD Sciences	13109	6	f	\N	UN	1	Unknown	\N
6426	(3335,"CAD Sciences",08)	(3335,"CAD Sciences",08)	CAD Sciences	13109	8	f	\N	UN	1	Unknown	\N
6427	(3335,"iCAD PK",10)	(3335,"iCAD PK",10)	iCAD PK	13109	16	f	\N	LO	1	Unknown	\N
6428	(3335,"iCAD PK",15)	(3335,"iCAD PK",15)	iCAD PK	13109	21	f	\N	LO	1	Unknown	\N
6429	(3335,"iCAD PK",16)	(3335,"iCAD PK",16)	iCAD PK	13109	22	f	\N	LO	1	Unknown	\N
6430	(3335,"iCAD PK",17)	(3335,"iCAD PK",17)	iCAD PK	13109	23	f	\N	LO	1	Unknown	\N
6431	(3335,"iCAD PK",18)	(3335,"iCAD PK",18)	iCAD PK	13109	24	f	\N	LO	1	Unknown	\N
6432	(3335,"iCAD PK",2a)	(3335,"iCAD PK",2a)	iCAD PK	13109	42	f	\N	LO	1	Unknown	\N
6433	(3335,"iCAD PK",34)	(3335,"iCAD PK",34)	iCAD PK	13109	52	f	\N	LO	1	Unknown	\N
6434	(3335,"iCAD PK",35)	(3335,"iCAD PK",35)	iCAD PK	13109	53	f	\N	LO	1	Unknown	\N
6435	(3335,"iCAD PK",3b)	(3335,"iCAD PK",3b)	iCAD PK	13109	59	f	\N	LO	1	Unknown	\N
6436	(3335,"iCAD PK",40)	(3335,"iCAD PK",40)	iCAD PK	13109	64	f	\N	LO	1	Unknown	\N
6437	(3335,"iCAD PK",50)	(3335,"iCAD PK",50)	iCAD PK	13109	80	f	\N	LO	1	Unknown	\N
6438	(3335,"iCAD PK",51)	(3335,"iCAD PK",51)	iCAD PK	13109	81	f	\N	LO	1	Unknown	\N
6439	(3335,"iCAD PK",52)	(3335,"iCAD PK",52)	iCAD PK	13109	82	f	\N	LO	1	Unknown	\N
6440	(3335,"iCAD PK",53)	(3335,"iCAD PK",53)	iCAD PK	13109	83	f	\N	LO	1	Unknown	\N
6441	(3335,"iCAD PK",54)	(3335,"iCAD PK",54)	iCAD PK	13109	84	f	\N	LO	1	Unknown	\N
6442	(3335,"iCAD PK",55)	(3335,"iCAD PK",55)	iCAD PK	13109	85	f	\N	LO	1	Unknown	\N
6443	(3335,"iCAD PK",56)	(3335,"iCAD PK",56)	iCAD PK	13109	86	f	\N	LO	1	Unknown	\N
6444	(3335,"iCAD PK",57)	(3335,"iCAD PK",57)	iCAD PK	13109	87	f	\N	LO	1	Unknown	\N
6445	(3335,"iCAD PK",70)	(3335,"iCAD PK",70)	iCAD PK	13109	112	f	\N	LO	1	Unknown	\N
6446	(3335,"iCAD PK",71)	(3335,"iCAD PK",71)	iCAD PK	13109	113	f	\N	LO	1	Unknown	\N
6447	(3335,"iCAD PK",72)	(3335,"iCAD PK",72)	iCAD PK	13109	114	f	\N	LO	1	Unknown	\N
6448	(3335,"iCAD PK",73)	(3335,"iCAD PK",73)	iCAD PK	13109	115	f	\N	LO	1	Unknown	\N
6449	(3335,"iCAD PK",74)	(3335,"iCAD PK",74)	iCAD PK	13109	116	f	\N	LO	1	Unknown	\N
6450	(3335,"iCAD PK",75)	(3335,"iCAD PK",75)	iCAD PK	13109	117	f	\N	UN	1	Unknown	\N
6451	(3335,"iCAD PK",80)	(3335,"iCAD PK",80)	iCAD PK	13109	128	f	\N	LO	1	Unknown	\N
6452	(3335,"iCAD PK",81)	(3335,"iCAD PK",81)	iCAD PK	13109	129	f	\N	LO	1	Unknown	\N
6453	(3335,"iCAD PK",82)	(3335,"iCAD PK",82)	iCAD PK	13109	130	f	\N	LO	1	Unknown	\N
6454	(3335,"iCAD PK",83)	(3335,"iCAD PK",83)	iCAD PK	13109	131	f	\N	LO	1	Unknown	\N
6455	(3335,"iCAD PK",84)	(3335,"iCAD PK",84)	iCAD PK	13109	132	f	\N	LO	1	Unknown	\N
6456	(3335,"iCAD PK",85)	(3335,"iCAD PK",85)	iCAD PK	13109	133	f	\N	LO	1	Unknown	\N
6457	(3335,"iCAD PK",86)	(3335,"iCAD PK",86)	iCAD PK	13109	134	f	\N	LO	1	Unknown	\N
6458	(3335,"iCAD PK",87)	(3335,"iCAD PK",87)	iCAD PK	13109	135	f	\N	LO	1	Unknown	\N
6459	(3335,"iCAD PK",88)	(3335,"iCAD PK",88)	iCAD PK	13109	136	f	\N	LO	1	Unknown	\N
6460	(3335,"iCAD PK",89)	(3335,"iCAD PK",89)	iCAD PK	13109	137	f	\N	LO	1	Unknown	\N
6461	(3335,"iCAD PK",8a)	(3335,"iCAD PK",8a)	iCAD PK	13109	138	f	\N	LO	1	Unknown	\N
6462	(3335,"iCAD PK",8b)	(3335,"iCAD PK",8b)	iCAD PK	13109	139	f	\N	LO	1	Unknown	\N
6463	(3335,"iCAD PK",8c)	(3335,"iCAD PK",8c)	iCAD PK	13109	140	f	\N	LO	1	Unknown	\N
6464	(3335,"iCAD PK",8d)	(3335,"iCAD PK",8d)	iCAD PK	13109	141	f	\N	LO	1	Unknown	\N
6465	(3335,"iCAD PK",8e)	(3335,"iCAD PK",8e)	iCAD PK	13109	142	f	\N	LO	1	Unknown	\N
6466	(3335,"iCAD PK",8f)	(3335,"iCAD PK",8f)	iCAD PK	13109	143	f	\N	LO	1	Unknown	\N
6467	(3335,"iCAD PK",90)	(3335,"iCAD PK",90)	iCAD PK	13109	144	f	\N	LO	1	Unknown	\N
6468	(3335,"iCAD PK",91)	(3335,"iCAD PK",91)	iCAD PK	13109	145	f	\N	LO	1	Unknown	\N
6469	(3335,"iCAD PK",92)	(3335,"iCAD PK",92)	iCAD PK	13109	146	f	\N	LO	1	Unknown	\N
6470	(3335,"iCAD PK",93)	(3335,"iCAD PK",93)	iCAD PK	13109	147	f	\N	LO	1	Unknown	\N
6471	(3335,"iCAD PK",94)	(3335,"iCAD PK",94)	iCAD PK	13109	148	f	\N	LO	1	Unknown	\N
6472	(3335,"iCAD PK",95)	(3335,"iCAD PK",95)	iCAD PK	13109	149	f	\N	LO	1	Unknown	\N
6473	(3335,"iCAD PK",a0)	(3335,"iCAD PK",a0)	iCAD PK	13109	160	f	\N	LO	1	Unknown	\N
6474	(3335,"iCAD PK",a1)	(3335,"iCAD PK",a1)	iCAD PK	13109	161	f	\N	LO	1	Unknown	\N
6475	(3335,"iCAD PK",a2)	(3335,"iCAD PK",a2)	iCAD PK	13109	162	f	\N	LO	1	Unknown	\N
6476	(3335,"iCAD PK",a3)	(3335,"iCAD PK",a3)	iCAD PK	13109	163	f	\N	LO	1	Unknown	\N
6477	(3335,"iCAD PK",a4)	(3335,"iCAD PK",a4)	iCAD PK	13109	164	f	\N	LO	1	Unknown	\N
6478	(3335,"iCAD PK",a5)	(3335,"iCAD PK",a5)	iCAD PK	13109	165	f	\N	LO	1	Unknown	\N
6479	(3335,"iCAD PK",a6)	(3335,"iCAD PK",a6)	iCAD PK	13109	166	f	\N	LO	1	Unknown	\N
6480	(3335,"iCAD PK",a7)	(3335,"iCAD PK",a7)	iCAD PK	13109	167	f	\N	LO	1	Unknown	\N
6481	(3335,"iCAD PK",a8)	(3335,"iCAD PK",a8)	iCAD PK	13109	168	f	\N	LO	1	Unknown	\N
6482	(3335,"iCAD PK",a9)	(3335,"iCAD PK",a9)	iCAD PK	13109	169	f	\N	LO	1	Unknown	\N
6483	(3335,"iCAD PK",aa)	(3335,"iCAD PK",aa)	iCAD PK	13109	170	f	\N	LO	1	Unknown	\N
6484	(3335,"iCAD PK",ab)	(3335,"iCAD PK",ab)	iCAD PK	13109	171	f	\N	LO	1	Unknown	\N
6485	(3335,"iCAD PK",ac)	(3335,"iCAD PK",ac)	iCAD PK	13109	172	f	\N	LO	1	Unknown	\N
6486	(3335,"iCAD PK",ad)	(3335,"iCAD PK",ad)	iCAD PK	13109	173	f	\N	LO	1	Unknown	\N
6487	(3335,"iCAD PK",ae)	(3335,"iCAD PK",ae)	iCAD PK	13109	174	f	\N	LO	1	Unknown	\N
6488	(3335,"iCAD PK",af)	(3335,"iCAD PK",af)	iCAD PK	13109	175	f	\N	LO	1	Unknown	\N
6489	(3335,"iCAD PK",b0)	(3335,"iCAD PK",b0)	iCAD PK	13109	176	f	\N	LO	1	Unknown	\N
6490	(3335,"iCAD PK",b1)	(3335,"iCAD PK",b1)	iCAD PK	13109	177	f	\N	LO	1	Unknown	\N
6491	(3335,"iCAD PK",c0)	(3335,"iCAD PK",c0)	iCAD PK	13109	192	f	\N	LO	1	Unknown	\N
6492	(3335,"iCAD PK Study",00)	(3335,"iCAD PK Study",00)	iCAD PK Study	13109	0	f	\N	LO	1	Unknown	\N
6493	(3335,"iCAD PK Study",01)	(3335,"iCAD PK Study",01)	iCAD PK Study	13109	1	f	\N	LO	1	Unknown	\N
6494	(3335,"iCAD PK Study",02)	(3335,"iCAD PK Study",02)	iCAD PK Study	13109	2	f	\N	LO	1	Unknown	\N
6495	(3335,"iCAD PK Study",03)	(3335,"iCAD PK Study",03)	iCAD PK Study	13109	3	f	\N	LO	1	Unknown	\N
6496	(3335,"iCAD PK Study",04)	(3335,"iCAD PK Study",04)	iCAD PK Study	13109	4	f	\N	LO	1	Unknown	\N
6497	(3335,"iCAD PK Study",05)	(3335,"iCAD PK Study",05)	iCAD PK Study	13109	5	f	\N	LO	1	Unknown	\N
6498	(3335,"iCAD PK Study",06)	(3335,"iCAD PK Study",06)	iCAD PK Study	13109	6	f	\N	LO	1	Unknown	\N
6499	(3335,"iCAD PK Study",07)	(3335,"iCAD PK Study",07)	iCAD PK Study	13109	7	f	\N	LO	1	Unknown	\N
6500	(3335,"iCAD PK Study",08)	(3335,"iCAD PK Study",08)	iCAD PK Study	13109	8	f	\N	LO	1	Unknown	\N
6501	(3335,"iCAD PK Study",09)	(3335,"iCAD PK Study",09)	iCAD PK Study	13109	9	f	\N	LO	1	Unknown	\N
6502	(3335,"iCAD PK Study",0a)	(3335,"iCAD PK Study",0a)	iCAD PK Study	13109	10	f	\N	LO	1	Unknown	\N
6503	(3335,"iCAD PK Study",0b)	(3335,"iCAD PK Study",0b)	iCAD PK Study	13109	11	f	\N	LO	1	Unknown	\N
6504	(3335,"iCAD PK Study",0c)	(3335,"iCAD PK Study",0c)	iCAD PK Study	13109	12	f	\N	LO	1	Unknown	\N
6505	(3335,"iCAD PK Study",0d)	(3335,"iCAD PK Study",0d)	iCAD PK Study	13109	13	f	\N	LO	1	Unknown	\N
6506	(3335,"iCAD PK Study",0e)	(3335,"iCAD PK Study",0e)	iCAD PK Study	13109	14	f	\N	LO	1	Unknown	\N
6507	(3335,"iCAD PK Study",0f)	(3335,"iCAD PK Study",0f)	iCAD PK Study	13109	15	f	\N	LO	1	Unknown	\N
6508	(3335,"iCAD PK Study",10)	(3335,"iCAD PK Study",10)	iCAD PK Study	13109	16	f	\N	LO	1	Unknown	\N
6509	(3335,"iCAD PK Study",11)	(3335,"iCAD PK Study",11)	iCAD PK Study	13109	17	f	\N	LO	1	Unknown	\N
6510	(3335,"iCAD PK Study",12)	(3335,"iCAD PK Study",12)	iCAD PK Study	13109	18	f	\N	LO	1	Unknown	\N
6511	(3335,"iCAD PK Study",13)	(3335,"iCAD PK Study",13)	iCAD PK Study	13109	19	f	\N	LO	1	Unknown	\N
6512	(3335,"iCAD PK Study",14)	(3335,"iCAD PK Study",14)	iCAD PK Study	13109	20	f	\N	LO	1	Unknown	\N
6513	(3335,"iCAD PK Study",15)	(3335,"iCAD PK Study",15)	iCAD PK Study	13109	21	f	\N	LO	1	Unknown	\N
6514	(3335,"iCAD PK Study",16)	(3335,"iCAD PK Study",16)	iCAD PK Study	13109	22	f	\N	LO	1	Unknown	\N
6515	(3335,"iCAD PK Study",17)	(3335,"iCAD PK Study",17)	iCAD PK Study	13109	23	f	\N	LO	1	Unknown	\N
6516	(3335,"iCAD PK Study",18)	(3335,"iCAD PK Study",18)	iCAD PK Study	13109	24	f	\N	LO	1	Unknown	\N
6517	(3335,"iCAD PK Study",19)	(3335,"iCAD PK Study",19)	iCAD PK Study	13109	25	f	\N	LO	1	Unknown	\N
6518	(3335,"iCAD PK Study",1a)	(3335,"iCAD PK Study",1a)	iCAD PK Study	13109	26	f	\N	LO	1	Unknown	\N
6519	(3335,"iCAD PK Study",1b)	(3335,"iCAD PK Study",1b)	iCAD PK Study	13109	27	f	\N	LO	1	Unknown	\N
6520	(7fdf,"TomTec",50)	(7fdf,"TomTec",50)	TomTec	32735	80	f	\N	OB	1	Unknown	\N
6521	(7fdf,"TomTec",51)	(7fdf,"TomTec",51)	TomTec	32735	81	f	\N	OB	1	Unknown	\N
6522	(0029,"CARESTREAM IMAGE INFORMATION",15)	(0029,"CARESTREAM IMAGE INFORMATION",15)	CARESTREAM IMAGE INFORMATION	41	21	f	\N	LO	1	Unknown	\N
6523	(0029,"CARESTREAM IMAGE INFORMATION",16)	(0029,"CARESTREAM IMAGE INFORMATION",16)	CARESTREAM IMAGE INFORMATION	41	22	f	\N	LO	1	Unknown	\N
6524	(0029,"CARESTREAM IMAGE INFORMATION",17)	(0029,"CARESTREAM IMAGE INFORMATION",17)	CARESTREAM IMAGE INFORMATION	41	23	f	\N	LO	1	Unknown	\N
6525	(0029,"CARESTREAM IMAGE INFORMATION",18)	(0029,"CARESTREAM IMAGE INFORMATION",18)	CARESTREAM IMAGE INFORMATION	41	24	f	\N	UT	1	Unknown	\N
6526	(0029,"CARESTREAM IMAGE INFORMATION",19)	(0029,"CARESTREAM IMAGE INFORMATION",19)	CARESTREAM IMAGE INFORMATION	41	25	f	\N	IS	1	Unknown	\N
6527	(0029,"CARESTREAM IMAGE INFORMATION",1a)	(0029,"CARESTREAM IMAGE INFORMATION",1a)	CARESTREAM IMAGE INFORMATION	41	26	f	\N	IS	1	Unknown	\N
6528	(0029,"CARESTREAM IMAGE INFORMATION",1b)	(0029,"CARESTREAM IMAGE INFORMATION",1b)	CARESTREAM IMAGE INFORMATION	41	27	f	\N	IS	1	Unknown	\N
6529	(ffff,"Carestream Health TIFF",ff)	(ffff,"Carestream Health TIFF",ff)	Carestream Health TIFF	65535	255	f	\N	UN	1	Unknown	\N
6530	(3111,"RamSoft File Kind Identifier",10)	(3111,"RamSoft File Kind Identifier",10)	RamSoft File Kind Identifier	12561	16	f	\N	CS	1	Binary Document Type	\N
6531	(3113,"RamSoft Custom Report Identifier",10)	(3113,"RamSoft Custom Report Identifier",10)	RamSoft Custom Report Identifier	12563	16	f	\N	OB	1	Binary Document	\N
6532	(3113,"RamSoft Custom Report Identifier",20)	(3113,"RamSoft Custom Report Identifier",20)	RamSoft Custom Report Identifier	12563	32	f	\N	UL	1	Binary Document Size	\N
6533	(3129,"RamSoft Race Identifier",10)	(3129,"RamSoft Race Identifier",10)	RamSoft Race Identifier	12585	16	f	\N	LO	1	Unknown	\N
6534	(0011,"MDDX",01)	(0011,"MDDX",01)	MDDX	17	1	f	\N	UT	1	AES Encrypted Values	\N
6535	(0011,"MDDX",02)	(0011,"MDDX",02)	MDDX	17	2	f	\N	LO	1	Allup Version Details	\N
6536	(0011,"MDDX",03)	(0011,"MDDX",03)	MDDX	17	3	f	\N	LO	1	Mask Id	\N
6537	(7fe1,"MDDX",01)	(7fe1,"MDDX",01)	MDDX	32737	1	f	\N	UT	1	AES Encrypted Values	\N
6538	(7fe1,"MDDX",02)	(7fe1,"MDDX",02)	MDDX	32737	2	f	\N	LO	1	Allup Version Details	\N
6539	(7fe1,"MDDX",03)	(7fe1,"MDDX",03)	MDDX	32737	3	f	\N	LO	1	Mask Id	\N
6540	(0099,"QTUltrasound",00)	(0099,"QTUltrasound",00)	QTUltrasound	153	0	f	\N	SS	1	Breast Density Value	\N
6541	(0009,"BioscanMedisoScivisNanoSPECT",35)	(0009,"BioscanMedisoScivisNanoSPECT",35)	BioscanMedisoScivisNanoSPECT	9	53	f	\N	DS	1	Unknown	\N
6542	(0009,"MEDISO-1",30)	(0009,"MEDISO-1",30)	MEDISO-1	9	48	f	\N	DT	1	Unknown	\N
6543	(0009,"MEDISO-1",36)	(0009,"MEDISO-1",36)	MEDISO-1	9	54	f	\N	FD	1	Unknown	\N
6544	(0009,"MEDISO-1",c0)	(0009,"MEDISO-1",c0)	MEDISO-1	9	192	f	\N	FD	1	Unknown	\N
6545	(0009,"MEDISO-1",c1)	(0009,"MEDISO-1",c1)	MEDISO-1	9	193	f	\N	OB	1	Unknown	\N
6546	(0009,"MEDISO-1",c4)	(0009,"MEDISO-1",c4)	MEDISO-1	9	196	f	\N	OB	1	Unknown	\N
6547	(0009,"MEDISO-1",d2)	(0009,"MEDISO-1",d2)	MEDISO-1	9	210	f	\N	LO	1	Unknown	\N
6548	(0009,"MEDISO-1",d5)	(0009,"MEDISO-1",d5)	MEDISO-1	9	213	f	\N	LO	1	Unknown	\N
6549	(0009,"MEDISO-1",dc)	(0009,"MEDISO-1",dc)	MEDISO-1	9	220	f	\N	SQ	1	Unknown	\N
6550	(0009,"MEDISO-1",de)	(0009,"MEDISO-1",de)	MEDISO-1	9	222	f	\N	UL	1	Unknown	\N
6551	(0009,"MEDISO-1",df)	(0009,"MEDISO-1",df)	MEDISO-1	9	223	f	\N	UL	1	Unknown	\N
6552	(0009,"MEDISO-1",e0)	(0009,"MEDISO-1",e0)	MEDISO-1	9	224	f	\N	US	1	Unknown	\N
6553	(0009,"MEDISO-1",e1)	(0009,"MEDISO-1",e1)	MEDISO-1	9	225	f	\N	FD	1	Unknown	\N
6554	(0009,"MEDISO-1",e6)	(0009,"MEDISO-1",e6)	MEDISO-1	9	230	f	\N	OB	1	Unknown	\N
6555	(0009,"MEDISO-1",e9)	(0009,"MEDISO-1",e9)	MEDISO-1	9	233	f	\N	UI	1-n	Unknown	\N
6556	(0009,"MEDISO-1",ee)	(0009,"MEDISO-1",ee)	MEDISO-1	9	238	f	\N	DT	1	Unknown	\N
6557	(0009,"MEDISO-1",ef)	(0009,"MEDISO-1",ef)	MEDISO-1	9	239	f	\N	DT	1	Unknown	\N
6558	(0009,"MEDISO-1",f0)	(0009,"MEDISO-1",f0)	MEDISO-1	9	240	f	\N	FD	1	Unknown	\N
6559	(0009,"MEDISO-1",f1)	(0009,"MEDISO-1",f1)	MEDISO-1	9	241	f	\N	FD	1	Unknown	\N
6560	(0009,"MEDISO-1",f2)	(0009,"MEDISO-1",f2)	MEDISO-1	9	242	f	\N	FD	1	Unknown	\N
6561	(0009,"MEDISO-1",f3)	(0009,"MEDISO-1",f3)	MEDISO-1	9	243	f	\N	FD	1	Unknown	\N
6562	(0009,"MEDISO-1",fa)	(0009,"MEDISO-1",fa)	MEDISO-1	9	250	f	\N	ST	1	Unknown	\N
6563	(0009,"MEDISO-1",fb)	(0009,"MEDISO-1",fb)	MEDISO-1	9	251	f	\N	US	1	Unknown	\N
6564	(0011,"MEDISO-1",06)	(0011,"MEDISO-1",06)	MEDISO-1	17	6	f	\N	LO	1	Unknown	\N
6565	(6001,"SCIVIS-1",a0)	(6001,"SCIVIS-1",a0)	SCIVIS-1	24577	160	f	\N	DS	1	Unknown	\N
6566	(6001,"SCIVIS-1",a1)	(6001,"SCIVIS-1",a1)	SCIVIS-1	24577	161	f	\N	DS	1	Unknown	\N
6567	(6001,"SCIVIS-1",a2)	(6001,"SCIVIS-1",a2)	SCIVIS-1	24577	162	f	\N	US	1	Unknown	\N
6568	(6001,"SCIVIS-1",a3)	(6001,"SCIVIS-1",a3)	SCIVIS-1	24577	163	f	\N	DS	1	Unknown	\N
6569	(6001,"SCIVIS-1",a4)	(6001,"SCIVIS-1",a4)	SCIVIS-1	24577	164	f	\N	IS	1	Unknown	\N
6570	(6001,"SCIVIS-1",a5)	(6001,"SCIVIS-1",a5)	SCIVIS-1	24577	165	f	\N	ST	1	Unknown	\N
6571	(6001,"SCIVIS-1",a6)	(6001,"SCIVIS-1",a6)	SCIVIS-1	24577	166	f	\N	ST	1	Unknown	\N
6572	(6001,"SCIVIS-1",a7)	(6001,"SCIVIS-1",a7)	SCIVIS-1	24577	167	f	\N	FL	1	Unknown	\N
6573	(6001,"SCIVIS-1",a8)	(6001,"SCIVIS-1",a8)	SCIVIS-1	24577	168	f	\N	FL	1	Unknown	\N
6574	(6001,"SCIVIS-1",a9)	(6001,"SCIVIS-1",a9)	SCIVIS-1	24577	169	f	\N	IS	1	Unknown	\N
6575	(6001,"SCIVIS-1",aa)	(6001,"SCIVIS-1",aa)	SCIVIS-1	24577	170	f	\N	IS	1	Unknown	\N
6576	(6001,"SCIVIS-1",ab)	(6001,"SCIVIS-1",ab)	SCIVIS-1	24577	171	f	\N	ST	1	Unknown	\N
6577	(0009,"Brainlab-S9-History",31)	(0009,"Brainlab-S9-History",31)	Brainlab-S9-History	9	49	f	\N	SQ	1	Unknown	\N
6578	(0009,"Brainlab-S9-History",32)	(0009,"Brainlab-S9-History",32)	Brainlab-S9-History	9	50	f	\N	SQ	1	Unknown	\N
6579	(0009,"Brainlab-S9-History",33)	(0009,"Brainlab-S9-History",33)	Brainlab-S9-History	9	51	f	\N	SQ	1	Unknown	\N
6580	(0063,"Brainlab-S32-SO",01)	(0063,"Brainlab-S32-SO",01)	Brainlab-S32-SO	99	1	f	\N	LO	1	Unknown	\N
6581	(0063,"Brainlab-S32-SO",10)	(0063,"Brainlab-S32-SO",10)	Brainlab-S32-SO	99	16	f	\N	SQ	1	Unknown	\N
6582	(0073,"Brainlab-S23-ProjectiveFusion",10)	(0073,"Brainlab-S23-ProjectiveFusion",10)	Brainlab-S23-ProjectiveFusion	115	16	f	\N	SQ	1	Projective Registration Sequence	\N
6583	(0009,"SPI Release 1",08)	(0009,"SPI Release 1",08)	SPI Release 1	9	8	f	\N	CS	1	Unknown	\N
6584	(0009,"PHILIPS MR/PART 12",2110)	(0009,"PHILIPS MR/PART 12",10)	PHILIPS MR/PART 12	9	16	t	0021	US	1	Unknown	\N
6585	(0009,"SPI-P Release 1",10)	(0009,"SPI-P Release 1",10)	SPI-P Release 1	9	16	f	\N	LO	1	Unknown	\N
6586	(0009,"SPI-P Release 1",a0)	(0009,"SPI-P Release 1",a0)	SPI-P Release 1	9	160	f	\N	UN	1	Unknown	\N
6587	(0011,"SPI-P Release 1",20)	(0011,"SPI-P Release 1",20)	SPI-P Release 1	17	32	f	\N	UN	1	Unknown	\N
6588	(0011,"SPI-P Release 1",30)	(0011,"SPI-P Release 1",30)	SPI-P Release 1	17	48	f	\N	UN	1	Unknown	\N
6589	(0019,"PHILIPS MR/PART 7",00)	(0019,"PHILIPS MR/PART 7",00)	PHILIPS MR/PART 7	25	0	f	\N	IS	1	Unknown	\N
6590	(0019,"SPI-P-CTBE Release 1",00)	(0019,"SPI-P-CTBE Release 1",00)	SPI-P-CTBE Release 1	25	0	f	\N	IS	1	Unknown	\N
6591	(0019,"SPI-P-Private-DiDi Release 1",00)	(0019,"SPI-P-Private-DiDi Release 1",00)	SPI-P-Private-DiDi Release 1	25	0	f	\N	LT	1	Post Mode String	\N
6592	(0019,"SPI-P-XSB-VISUB Release 1",00)	(0019,"SPI-P-XSB-VISUB Release 1",00)	SPI-P-XSB-VISUB Release 1	25	0	f	\N	UN	1	Unknown	\N
6593	(0019,"PHILIPS MR/PART",1001)	(0019,"PHILIPS MR/PART",01)	PHILIPS MR/PART	25	1	t	0010	DS	1	Unknown	\N
6594	(0019,"SPI-P-Private-DiDi Release 1",01)	(0019,"SPI-P-Private-DiDi Release 1",01)	SPI-P-Private-DiDi Release 1	25	1	f	\N	LT	1	Post Data	\N
6595	(0019,"PHILIPS MR/PART",1002)	(0019,"PHILIPS MR/PART",02)	PHILIPS MR/PART	25	2	t	0010	DS	1	Unknown	\N
6596	(0019,"SPI-P-CTBE Release 1",02)	(0019,"SPI-P-CTBE Release 1",02)	SPI-P-CTBE Release 1	25	2	f	\N	IS	1	Unknown	\N
6597	(0019,"PHILIPS MR/PART",1003)	(0019,"PHILIPS MR/PART",03)	PHILIPS MR/PART	25	3	t	0010	DS	1	Unknown	\N
6598	(0019,"SPI-P-CTBE Release 1",03)	(0019,"SPI-P-CTBE Release 1",03)	SPI-P-CTBE Release 1	25	3	f	\N	DS	1	Unknown	\N
6599	(0019,"SPI-P-CTBE Release 1",04)	(0019,"SPI-P-CTBE Release 1",04)	SPI-P-CTBE Release 1	25	4	f	\N	IS	1	Unknown	\N
6600	(0019,"SPI-P-CTBE Release 1",05)	(0019,"SPI-P-CTBE Release 1",05)	SPI-P-CTBE Release 1	25	5	f	\N	DS	1	Unknown	\N
6601	(0019,"SPI-P-CTBE Release 1",0b)	(0019,"SPI-P-CTBE Release 1",0b)	SPI-P-CTBE Release 1	25	11	f	\N	DS	1	Unknown	\N
6602	(0019,"SPI-P-CTBE Release 1",0c)	(0019,"SPI-P-CTBE Release 1",0c)	SPI-P-CTBE Release 1	25	12	f	\N	IS	1	Unknown	\N
6603	(0019,"PHILIPS MR/PART 6",10)	(0019,"PHILIPS MR/PART 6",10)	PHILIPS MR/PART 6	25	16	f	\N	IS	1	Unknown	\N
6604	(0019,"SPI-P-PCR Release 2",10)	(0019,"SPI-P-PCR Release 2",10)	SPI-P-PCR Release 2	25	16	f	\N	US	1	Unknown	\N
6605	(0019,"SPI-P-Private-DiDi Release 1",10)	(0019,"SPI-P-Private-DiDi Release 1",10)	SPI-P-Private-DiDi Release 1	25	16	f	\N	LT	1	Image Header	\N
6606	(0019,"SPI-P-XSB-VISUB Release 1",10)	(0019,"SPI-P-XSB-VISUB Release 1",10)	SPI-P-XSB-VISUB Release 1	25	16	f	\N	UN	1	Unknown	\N
6607	(0019,"SPI-P-XSB-VISUB Release 1",11)	(0019,"SPI-P-XSB-VISUB Release 1",11)	SPI-P-XSB-VISUB Release 1	25	17	f	\N	UN	1	Unknown	\N
6608	(0019,"SPI-P-XSB-VISUB Release 1",12)	(0019,"SPI-P-XSB-VISUB Release 1",12)	SPI-P-XSB-VISUB Release 1	25	18	f	\N	UN	1	Unknown	\N
6609	(0019,"PHILIPS MR/PART",1014)	(0019,"PHILIPS MR/PART",14)	PHILIPS MR/PART	25	20	t	0010	CS	1	Unknown	\N
6610	(0019,"SPI-P-CTBE Release 1",14)	(0019,"SPI-P-CTBE Release 1",14)	SPI-P-CTBE Release 1	25	20	f	\N	IS	1	Unknown	\N
6611	(0019,"SPI-P-CTBE Release 1",18)	(0019,"SPI-P-CTBE Release 1",18)	SPI-P-CTBE Release 1	25	24	f	\N	IS	1	Unknown	\N
6612	(0019,"SPI-P-CTBE Release 1",19)	(0019,"SPI-P-CTBE Release 1",19)	SPI-P-CTBE Release 1	25	25	f	\N	IS	1	Unknown	\N
6613	(0019,"SPI-P-CTBE Release 1",1a)	(0019,"SPI-P-CTBE Release 1",1a)	SPI-P-CTBE Release 1	25	26	f	\N	DS	1	Unknown	\N
6614	(0019,"SPI-P-CTBE Release 1",1b)	(0019,"SPI-P-CTBE Release 1",1b)	SPI-P-CTBE Release 1	25	27	f	\N	IS	1	Unknown	\N
6615	(0019,"PHILIPS MR/PART",101c)	(0019,"PHILIPS MR/PART",1c)	PHILIPS MR/PART	25	28	t	0010	CS	1	Unknown	\N
6616	(0019,"SPI-P-CTBE Release 1",1c)	(0019,"SPI-P-CTBE Release 1",1c)	SPI-P-CTBE Release 1	25	28	f	\N	IS	1	Unknown	\N
6617	(0019,"PHILIPS MR/PART",101d)	(0019,"PHILIPS MR/PART",1d)	PHILIPS MR/PART	25	29	t	0010	CS	1	Unknown	\N
6618	(0019,"SPI-P-CTBE Release 1",1d)	(0019,"SPI-P-CTBE Release 1",1d)	SPI-P-CTBE Release 1	25	29	f	\N	DS	1	Unknown	\N
6619	(0019,"PHILIPS MR/PART",101e)	(0019,"PHILIPS MR/PART",1e)	PHILIPS MR/PART	25	30	t	0010	DS	1	Unknown	\N
6620	(0019,"SPI-P-PCR Release 2",20)	(0019,"SPI-P-PCR Release 2",20)	SPI-P-PCR Release 2	25	32	f	\N	IS	1	Unknown	\N
6621	(0019,"SPI-P-XSB-VISUB Release 1",20)	(0019,"SPI-P-XSB-VISUB Release 1",20)	SPI-P-XSB-VISUB Release 1	25	32	f	\N	LO	1	Unknown	\N
6622	(0019,"PHILIPS MR/PART",1121)	(0019,"PHILIPS MR/PART",21)	PHILIPS MR/PART	25	33	t	0011	DS	1	Unknown	\N
6623	(0019,"SPI-P-PCR Release 2",21)	(0019,"SPI-P-PCR Release 2",21)	SPI-P-PCR Release 2	25	33	f	\N	LO	1	Unknown	\N
6624	(0019,"PHILIPS MR/PART",1123)	(0019,"PHILIPS MR/PART",23)	PHILIPS MR/PART	25	35	t	0011	DS	1-n	Unknown	\N
6625	(0019,"PHILIPS MR/PART",1124)	(0019,"PHILIPS MR/PART",24)	PHILIPS MR/PART	25	36	t	0011	DS	1-n	Unknown	\N
6626	(0019,"PHILIPS MR/PART",1125)	(0019,"PHILIPS MR/PART",25)	PHILIPS MR/PART	25	37	t	0011	DS	1-n	Unknown	\N
6627	(0019,"PHILIPS MR/PART",1126)	(0019,"PHILIPS MR/PART",26)	PHILIPS MR/PART	25	38	t	0011	DS	1-n	Unknown	\N
6628	(0019,"PHILIPS MR/PART",1127)	(0019,"PHILIPS MR/PART",27)	PHILIPS MR/PART	25	39	t	0011	DS	1-n	Unknown	\N
6629	(0019,"PHILIPS MR/PART",1128)	(0019,"PHILIPS MR/PART",28)	PHILIPS MR/PART	25	40	t	0011	CS	1	Unknown	\N
6630	(0019,"PHILIPS MR/PART",1129)	(0019,"PHILIPS MR/PART",29)	PHILIPS MR/PART	25	41	t	0011	DS	1-n	Unknown	\N
6631	(0019,"PHILIPS MR/PART",1130)	(0019,"PHILIPS MR/PART",30)	PHILIPS MR/PART	25	48	t	0011	LO	1-n	Unknown	\N
6632	(0019,"PHILIPS MR/PART",1131)	(0019,"PHILIPS MR/PART",31)	PHILIPS MR/PART	25	49	t	0011	DS	1-n	Unknown	\N
6633	(0019,"PHILIPS MR/PART",1040)	(0019,"PHILIPS MR/PART",40)	PHILIPS MR/PART	25	64	t	0010	US	1	Unknown	\N
6634	(0019,"SPI-P-PCR Release 2",40)	(0019,"SPI-P-PCR Release 2",40)	SPI-P-PCR Release 2	25	64	f	\N	DS	1	Unknown	\N
6635	(0019,"SPI-P-XSB-VISUB Release 1",40)	(0019,"SPI-P-XSB-VISUB Release 1",40)	SPI-P-XSB-VISUB Release 1	25	64	f	\N	UN	1	Unknown	\N
6636	(0019,"PHILIPS MR/PART",1050)	(0019,"PHILIPS MR/PART",50)	PHILIPS MR/PART	25	80	t	0010	IS	1	Unknown	\N
6637	(0019,"PHILIPS MR/PART",1150)	(0019,"PHILIPS MR/PART",50)	PHILIPS MR/PART	25	80	t	0011	DS	1	Unknown	\N
6638	(0019,"SPI-P-XSB-VISUB Release 1",50)	(0019,"SPI-P-XSB-VISUB Release 1",50)	SPI-P-XSB-VISUB Release 1	25	80	f	\N	LO	1	Unknown	\N
6639	(0019,"PHILIPS MR/PART",1151)	(0019,"PHILIPS MR/PART",51)	PHILIPS MR/PART	25	81	t	0011	DS	1	Unknown	\N
6640	(0019,"PHILIPS MR/PART",1152)	(0019,"PHILIPS MR/PART",52)	PHILIPS MR/PART	25	82	t	0011	DS	1	Unknown	\N
6641	(0019,"PHILIPS MR/PART",1153)	(0019,"PHILIPS MR/PART",53)	PHILIPS MR/PART	25	83	t	0011	IS	1	Unknown	\N
6642	(0019,"PHILIPS MR/PART",1154)	(0019,"PHILIPS MR/PART",54)	PHILIPS MR/PART	25	84	t	0011	DS	1	Unknown	\N
6643	(0019,"PHILIPS MR/PART",1155)	(0019,"PHILIPS MR/PART",55)	PHILIPS MR/PART	25	85	t	0011	DS	1	Unknown	\N
6644	(0019,"PHILIPS MR/PART",1156)	(0019,"PHILIPS MR/PART",56)	PHILIPS MR/PART	25	86	t	0011	DS	1	Unknown	\N
6645	(0019,"PHILIPS MR/PART",1157)	(0019,"PHILIPS MR/PART",57)	PHILIPS MR/PART	25	87	t	0011	US	1	Unknown	\N
6646	(0019,"PHILIPS MR/PART",1158)	(0019,"PHILIPS MR/PART",58)	PHILIPS MR/PART	25	88	t	0011	DS	1	Unknown	\N
6647	(0019,"PHILIPS MR/PART",1159)	(0019,"PHILIPS MR/PART",59)	PHILIPS MR/PART	25	89	t	0011	US	1	Unknown	\N
6648	(0019,"PHILIPS MR/PART",1160)	(0019,"PHILIPS MR/PART",60)	PHILIPS MR/PART	25	96	t	0011	DS	1	Unknown	\N
6649	(0019,"SPI-P-PCR Release 2",60)	(0019,"SPI-P-PCR Release 2",60)	SPI-P-PCR Release 2	25	96	f	\N	LO	1	Unknown	\N
6650	(0019,"PHILIPS MR/PART",1161)	(0019,"PHILIPS MR/PART",61)	PHILIPS MR/PART	25	97	t	0011	DS	1	Unknown	\N
6651	(0019,"PHILIPS MR/PART",1162)	(0019,"PHILIPS MR/PART",62)	PHILIPS MR/PART	25	98	t	0011	DS	1	Unknown	\N
6652	(0019,"PHILIPS MR/PART",1163)	(0019,"PHILIPS MR/PART",63)	PHILIPS MR/PART	25	99	t	0011	DS	1	Unknown	\N
6653	(0019,"PHILIPS MR/PART",1164)	(0019,"PHILIPS MR/PART",64)	PHILIPS MR/PART	25	100	t	0011	IS	1	Unknown	\N
6654	(0019,"PHILIPS MR/PART",1166)	(0019,"PHILIPS MR/PART",66)	PHILIPS MR/PART	25	102	t	0011	US	1	Unknown	\N
6655	(0019,"PHILIPS MR/PART",1067)	(0019,"PHILIPS MR/PART",67)	PHILIPS MR/PART	25	103	t	0010	US	1	Unknown	\N
6656	(0019,"PHILIPS MR/PART",1070)	(0019,"PHILIPS MR/PART",70)	PHILIPS MR/PART	25	112	t	0010	DS	1-n	Unknown	\N
6657	(0019,"SPI-P-PCR Release 2",80)	(0019,"SPI-P-PCR Release 2",80)	SPI-P-PCR Release 2	25	128	f	\N	US	1	Unknown	\N
6658	(0019,"DIDI TO PCR 1.1",89)	(0019,"DIDI TO PCR 1.1",89)	DIDI TO PCR 1.1	25	137	f	\N	IS	1	Exposure Index	\N
6659	(0019,"DIDI TO PCR 1.1",8a)	(0019,"DIDI TO PCR 1.1",8a)	DIDI TO PCR 1.1	25	138	f	\N	IS	1	Collimator X	\N
6660	(0019,"PHILIPS MR/PART",108a)	(0019,"PHILIPS MR/PART",8a)	PHILIPS MR/PART	25	138	t	0010	CS	1	Unknown	\N
6661	(0019,"DIDI TO PCR 1.1",8b)	(0019,"DIDI TO PCR 1.1",8b)	DIDI TO PCR 1.1	25	139	f	\N	IS	1	Collimator Y	\N
6662	(0019,"PHILIPS MR/PART",108b)	(0019,"PHILIPS MR/PART",8b)	PHILIPS MR/PART	25	139	t	0010	CS	1	Unknown	\N
6663	(0019,"DIDI TO PCR 1.1",8c)	(0019,"DIDI TO PCR 1.1",8c)	DIDI TO PCR 1.1	25	140	f	\N	LO	1	Print Marker	\N
6664	(0019,"PHILIPS MR/PART",108c)	(0019,"PHILIPS MR/PART",8c)	PHILIPS MR/PART	25	140	t	0010	CS	1	Unknown	\N
6665	(0019,"DIDI TO PCR 1.1",8d)	(0019,"DIDI TO PCR 1.1",8d)	DIDI TO PCR 1.1	25	141	f	\N	LO	1	RGDV Name	\N
6666	(0019,"PHILIPS MR/PART",108d)	(0019,"PHILIPS MR/PART",8d)	PHILIPS MR/PART	25	141	t	0010	CS	1	Unknown	\N
6667	(0019,"DIDI TO PCR 1.1",8e)	(0019,"DIDI TO PCR 1.1",8e)	DIDI TO PCR 1.1	25	142	f	\N	LO	1	Acqd Sensitivity	\N
6668	(0019,"PHILIPS MR/PART",108e)	(0019,"PHILIPS MR/PART",8e)	PHILIPS MR/PART	25	142	t	0010	CS	1	Unknown	\N
6669	(0019,"DIDI TO PCR 1.1",8f)	(0019,"DIDI TO PCR 1.1",8f)	DIDI TO PCR 1.1	25	143	f	\N	LO	1	Processing Category	\N
6670	(0019,"PHILIPS MR/PART",108f)	(0019,"PHILIPS MR/PART",8f)	PHILIPS MR/PART	25	143	t	0010	CS	1	Unknown	\N
6671	(0019,"SPI-P-PCR Release 2",90)	(0019,"SPI-P-PCR Release 2",90)	SPI-P-PCR Release 2	25	144	f	\N	LO	1	Unknown	\N
6672	(0019,"DIDI TO PCR 1.1",a0)	(0019,"DIDI TO PCR 1.1",a0)	DIDI TO PCR 1.1	25	160	f	\N	LO	1	Version	\N
6673	(0019,"DIDI TO PCR 1.1",a1)	(0019,"DIDI TO PCR 1.1",a1)	DIDI TO PCR 1.1	25	161	f	\N	LO	1	Ranging Mode	\N
6674	(0019,"DIDI TO PCR 1.1",a2)	(0019,"DIDI TO PCR 1.1",a2)	DIDI TO PCR 1.1	25	162	f	\N	DS	1	Abdomen Brightness	\N
6675	(0019,"DIDI TO PCR 1.1",a3)	(0019,"DIDI TO PCR 1.1",a3)	DIDI TO PCR 1.1	25	163	f	\N	DS	1	Fixed Brightness	\N
6676	(0019,"DIDI TO PCR 1.1",a4)	(0019,"DIDI TO PCR 1.1",a4)	DIDI TO PCR 1.1	25	164	f	\N	DS	1	Detail Contrast	\N
6677	(0019,"DIDI TO PCR 1.1",a5)	(0019,"DIDI TO PCR 1.1",a5)	DIDI TO PCR 1.1	25	165	f	\N	DS	1	Contrast Balance	\N
6678	(0019,"DIDI TO PCR 1.1",a6)	(0019,"DIDI TO PCR 1.1",a6)	DIDI TO PCR 1.1	25	166	f	\N	DS	1	Structure Boost	\N
6679	(0019,"DIDI TO PCR 1.1",a7)	(0019,"DIDI TO PCR 1.1",a7)	DIDI TO PCR 1.1	25	167	f	\N	DS	1	Structure Preference	\N
6680	(0019,"DIDI TO PCR 1.1",a8)	(0019,"DIDI TO PCR 1.1",a8)	DIDI TO PCR 1.1	25	168	f	\N	DS	1	Noise Robustness	\N
6681	(0019,"DIDI TO PCR 1.1",a9)	(0019,"DIDI TO PCR 1.1",a9)	DIDI TO PCR 1.1	25	169	f	\N	DS	1	Noise Dose Limit	\N
6682	(0019,"DIDI TO PCR 1.1",aa)	(0019,"DIDI TO PCR 1.1",aa)	DIDI TO PCR 1.1	25	170	f	\N	DS	1	Noise Dose Step	\N
6683	(0019,"DIDI TO PCR 1.1",ab)	(0019,"DIDI TO PCR 1.1",ab)	DIDI TO PCR 1.1	25	171	f	\N	DS	1	Noise Frequency Limit	\N
6684	(0019,"DIDI TO PCR 1.1",ac)	(0019,"DIDI TO PCR 1.1",ac)	DIDI TO PCR 1.1	25	172	f	\N	DS	1	Weak Contrast Limit	\N
6685	(0019,"DIDI TO PCR 1.1",ad)	(0019,"DIDI TO PCR 1.1",ad)	DIDI TO PCR 1.1	25	173	f	\N	DS	1	Strong Contrast Limit	\N
6686	(0019,"DIDI TO PCR 1.1",ae)	(0019,"DIDI TO PCR 1.1",ae)	DIDI TO PCR 1.1	25	174	f	\N	DS	1	Structure Boost Offset	\N
6687	(0019,"DIDI TO PCR 1.1",af)	(0019,"DIDI TO PCR 1.1",af)	DIDI TO PCR 1.1	25	175	f	\N	LO	1	Smooth Gain	\N
6688	(0019,"DIDI TO PCR 1.1",b0)	(0019,"DIDI TO PCR 1.1",b0)	DIDI TO PCR 1.1	25	176	f	\N	LO	1	Measure Field 1	\N
6689	(0019,"DIDI TO PCR 1.1",b1)	(0019,"DIDI TO PCR 1.1",b1)	DIDI TO PCR 1.1	25	177	f	\N	LO	1	Measure Field 2	\N
6690	(0019,"DIDI TO PCR 1.1",b2)	(0019,"DIDI TO PCR 1.1",b2)	DIDI TO PCR 1.1	25	178	f	\N	IS	1	Key Percentile 1	\N
6691	(0019,"DIDI TO PCR 1.1",b3)	(0019,"DIDI TO PCR 1.1",b3)	DIDI TO PCR 1.1	25	179	f	\N	IS	1	Key Percentile 2	\N
6692	(0019,"DIDI TO PCR 1.1",b4)	(0019,"DIDI TO PCR 1.1",b4)	DIDI TO PCR 1.1	25	180	f	\N	IS	1	Density LUT	\N
6693	(0019,"PHILIPS MR/PART",10b4)	(0019,"PHILIPS MR/PART",b4)	PHILIPS MR/PART	25	180	t	0010	DS	1	Unknown	\N
6694	(0019,"DIDI TO PCR 1.1",b5)	(0019,"DIDI TO PCR 1.1",b5)	DIDI TO PCR 1.1	25	181	f	\N	DS	1	Brightness	\N
6695	(0019,"PHILIPS MR/PART",10b5)	(0019,"PHILIPS MR/PART",b5)	PHILIPS MR/PART	25	181	t	0010	DS	1	Unknown	\N
6696	(0019,"DIDI TO PCR 1.1",b6)	(0019,"DIDI TO PCR 1.1",b6)	DIDI TO PCR 1.1	25	182	f	\N	DS	1	Gamma	\N
6697	(0019,"PHILIPS MR/PART",10b6)	(0019,"PHILIPS MR/PART",b6)	PHILIPS MR/PART	25	182	t	0010	DS	1	Unknown	\N
6698	(0019,"PHILIPS MR/LAST",b7)	(0019,"PHILIPS MR/LAST",b7)	PHILIPS MR/LAST	25	183	f	\N	IS	1	Unknown	\N
6699	(0019,"PHILIPS MR/PART",10d1)	(0019,"PHILIPS MR/PART",d1)	PHILIPS MR/PART	25	209	t	0010	US	1	Unknown	\N
6700	(0019,"PHILIPS MR/PART",10d3)	(0019,"PHILIPS MR/PART",d3)	PHILIPS MR/PART	25	211	t	0010	DS	1	Unknown	\N
6701	(0019,"PHILIPS MR/LAST",e4)	(0019,"PHILIPS MR/LAST",e4)	PHILIPS MR/LAST	25	228	f	\N	IS	1	Unknown	\N
6702	(0019,"PHILIPS MR/LAST",e5)	(0019,"PHILIPS MR/LAST",e5)	PHILIPS MR/LAST	25	229	f	\N	DS	1	Unknown	\N
6703	(0019,"PHILIPS MR/PART",10f0)	(0019,"PHILIPS MR/PART",f0)	PHILIPS MR/PART	25	240	t	0010	IS	1	Unknown	\N
6704	(0019,"PHILIPS MR/PART",10f6)	(0019,"PHILIPS MR/PART",f6)	PHILIPS MR/PART	25	246	t	0010	CS	1	Unknown	\N
6705	(0019,"PHILIPS MR/PART",10f7)	(0019,"PHILIPS MR/PART",f7)	PHILIPS MR/PART	25	247	t	0010	CS	1	Unknown	\N
6706	(0019,"PHILIPS MR/PART",10f8)	(0019,"PHILIPS MR/PART",f8)	PHILIPS MR/PART	25	248	t	0010	CS	1	Unknown	\N
6707	(0019,"PHILIPS MR/PART",10f9)	(0019,"PHILIPS MR/PART",f9)	PHILIPS MR/PART	25	249	t	0010	CS	1	Unknown	\N
6708	(0019,"PHILIPS MR/PART",10fa)	(0019,"PHILIPS MR/PART",fa)	PHILIPS MR/PART	25	250	t	0010	CS	1	Unknown	\N
6709	(0019,"PHILIPS MR/PART",10fb)	(0019,"PHILIPS MR/PART",fb)	PHILIPS MR/PART	25	251	t	0010	CS	1	Unknown	\N
6710	(0019,"PHILIPS MR/PART",10fc)	(0019,"PHILIPS MR/PART",fc)	PHILIPS MR/PART	25	252	t	0010	CS	1	Unknown	\N
6711	(0019,"SPI-P-PCR Release 2",a1)	(0019,"SPI-P-PCR Release 2",a1)	SPI-P-PCR Release 2	25	161	f	\N	ST	1	Unknown	\N
6712	(0019,"SPI-P-PCR Release 2",a3)	(0019,"SPI-P-PCR Release 2",a3)	SPI-P-PCR Release 2	25	163	f	\N	DS	1	Unknown	\N
6713	(0019,"SPI-P-PCR Release 2",a4)	(0019,"SPI-P-PCR Release 2",a4)	SPI-P-PCR Release 2	25	164	f	\N	DS	1	Unknown	\N
6714	(0019,"SPI-P-PCR Release 2",a5)	(0019,"SPI-P-PCR Release 2",a5)	SPI-P-PCR Release 2	25	165	f	\N	DS	1	Unknown	\N
6715	(0019,"SPI-P-PCR Release 2",a6)	(0019,"SPI-P-PCR Release 2",a6)	SPI-P-PCR Release 2	25	166	f	\N	DS	1	Unknown	\N
6716	(0019,"SPI-P-PCR Release 2",a7)	(0019,"SPI-P-PCR Release 2",a7)	SPI-P-PCR Release 2	25	167	f	\N	DS	1	Unknown	\N
6717	(0019,"SPI-P-PCR Release 2",a8)	(0019,"SPI-P-PCR Release 2",a8)	SPI-P-PCR Release 2	25	168	f	\N	DS	1	Unknown	\N
6718	(0019,"SPI-P-PCR Release 2",a9)	(0019,"SPI-P-PCR Release 2",a9)	SPI-P-PCR Release 2	25	169	f	\N	DS	1	Unknown	\N
6719	(0019,"SPI-P-PCR Release 2",aa)	(0019,"SPI-P-PCR Release 2",aa)	SPI-P-PCR Release 2	25	170	f	\N	DS	1	Unknown	\N
6720	(0019,"SPI-P-PCR Release 2",ab)	(0019,"SPI-P-PCR Release 2",ab)	SPI-P-PCR Release 2	25	171	f	\N	DS	1	Unknown	\N
6721	(0019,"SPI-P-PCR Release 2",ac)	(0019,"SPI-P-PCR Release 2",ac)	SPI-P-PCR Release 2	25	172	f	\N	DS	1	Unknown	\N
6722	(0019,"SPI-P-PCR Release 2",ad)	(0019,"SPI-P-PCR Release 2",ad)	SPI-P-PCR Release 2	25	173	f	\N	DS	1	Unknown	\N
6723	(0019,"SPI-P-PCR Release 2",ae)	(0019,"SPI-P-PCR Release 2",ae)	SPI-P-PCR Release 2	25	174	f	\N	DS	1	Unknown	\N
6724	(0019,"SPI-P-PCR Release 2",af)	(0019,"SPI-P-PCR Release 2",af)	SPI-P-PCR Release 2	25	175	f	\N	ST	1	Unknown	\N
6725	(0019,"SPI-P-PCR Release 2",b0)	(0019,"SPI-P-PCR Release 2",b0)	SPI-P-PCR Release 2	25	176	f	\N	ST	1	Unknown	\N
6726	(0019,"SPI-P-PCR Release 2",b1)	(0019,"SPI-P-PCR Release 2",b1)	SPI-P-PCR Release 2	25	177	f	\N	ST	1	Unknown	\N
6727	(0019,"SPI-P-PCR Release 2",b2)	(0019,"SPI-P-PCR Release 2",b2)	SPI-P-PCR Release 2	25	178	f	\N	IS	1	Unknown	\N
6728	(0019,"SPI-P-PCR Release 2",b3)	(0019,"SPI-P-PCR Release 2",b3)	SPI-P-PCR Release 2	25	179	f	\N	IS	1	Unknown	\N
6729	(0019,"SPI-P-PCR Release 2",b4)	(0019,"SPI-P-PCR Release 2",b4)	SPI-P-PCR Release 2	25	180	f	\N	IS	1	Unknown	\N
6730	(0019,"SPI-P-PCR Release 2",b5)	(0019,"SPI-P-PCR Release 2",b5)	SPI-P-PCR Release 2	25	181	f	\N	DS	1	Unknown	\N
6731	(0019,"SPI-P-PCR Release 2",b6)	(0019,"SPI-P-PCR Release 2",b6)	SPI-P-PCR Release 2	25	182	f	\N	DS	1	Unknown	\N
6732	(0019,"SPI-P-PCR Release 2",b7)	(0019,"SPI-P-PCR Release 2",b7)	SPI-P-PCR Release 2	25	183	f	\N	ST	1	Unknown	\N
6733	(0019,"SPI-P-PCR Release 2",b8)	(0019,"SPI-P-PCR Release 2",b8)	SPI-P-PCR Release 2	25	184	f	\N	DS	1	Unknown	\N
6734	(0019,"SPI-P-PCR Release 2",b9)	(0019,"SPI-P-PCR Release 2",b9)	SPI-P-PCR Release 2	25	185	f	\N	ST	1	Unknown	\N
6735	(0019,"SPI-P-PCR Release 2",ba)	(0019,"SPI-P-PCR Release 2",ba)	SPI-P-PCR Release 2	25	186	f	\N	ST	1	Unknown	\N
6736	(0021,"SPI-P-CTBE-Private Release 1",00)	(0021,"SPI-P-CTBE-Private Release 1",00)	SPI-P-CTBE-Private Release 1	33	0	f	\N	DS	1	Unknown	\N
6737	(0021,"PHILIPS MR/PART",1006)	(0021,"PHILIPS MR/PART",06)	PHILIPS MR/PART	33	6	t	0010	LO	1	Unknown	\N
6738	(0021,"PHILIPS MR/PART",1008)	(0021,"PHILIPS MR/PART",08)	PHILIPS MR/PART	33	8	t	0010	LO	1	Unknown	\N
6739	(0021,"PHILIPS MR/PART",1009)	(0021,"PHILIPS MR/PART",09)	PHILIPS MR/PART	33	9	t	0010	CS	1	Unknown	\N
6740	(0021,"PHILIPS MR/PART",100a)	(0021,"PHILIPS MR/PART",0a)	PHILIPS MR/PART	33	10	t	0010	CS	1	Unknown	\N
6741	(0021,"PHILIPS MR/PART",100f)	(0021,"PHILIPS MR/PART",0f)	PHILIPS MR/PART	33	15	t	0010	LO	1	Unknown	\N
6742	(0021,"PHILIPS MR/PART",1013)	(0021,"PHILIPS MR/PART",13)	PHILIPS MR/PART	33	19	t	0010	CS	1	Unknown	\N
6743	(0021,"PHILIPS MR/PART",1015)	(0021,"PHILIPS MR/PART",15)	PHILIPS MR/PART	33	21	t	0010	US	1	Unknown	\N
6744	(0029,"SPI-P-Private_ICS Release 1;3",00)	(0029,"SPI-P-Private_ICS Release 1;3",00)	SPI-P-Private_ICS Release 1;3	41	0	f	\N	ST	1	Unknown	\N
6745	(0029,"SPI-P-XSB-VISUB Release 1",00)	(0029,"SPI-P-XSB-VISUB Release 1",00)	SPI-P-XSB-VISUB Release 1	41	0	f	\N	LO	1	Unknown	\N
6746	(0029,"SPI-P-Private_ICS Release 1;3",01)	(0029,"SPI-P-Private_ICS Release 1;3",01)	SPI-P-Private_ICS Release 1;3	41	1	f	\N	ST	1	Unknown	\N
6747	(0029,"SPI-P-XSB-VISUB Release 1",01)	(0029,"SPI-P-XSB-VISUB Release 1",01)	SPI-P-XSB-VISUB Release 1	41	1	f	\N	DS	1	Unknown	\N
6748	(0029,"SPI-P-XSB-VISUB Release 1",02)	(0029,"SPI-P-XSB-VISUB Release 1",02)	SPI-P-XSB-VISUB Release 1	41	2	f	\N	CS	1	Unknown	\N
6749	(0029,"SPI-P-Private_ICS Release 1",0d)	(0029,"SPI-P-Private_ICS Release 1",0d)	SPI-P-Private_ICS Release 1	41	13	f	\N	SQ	1	Unknown	\N
6750	(0029,"SPI-P-Private_ICS Release 1",0e)	(0029,"SPI-P-Private_ICS Release 1",0e)	SPI-P-Private_ICS Release 1	41	14	f	\N	SQ	1	Unknown	\N
6751	(0029,"SPI-P-XSB-VISUB Release 1",0f)	(0029,"SPI-P-XSB-VISUB Release 1",0f)	SPI-P-XSB-VISUB Release 1	41	15	f	\N	CS	1	Unknown	\N
6752	(0029,"SPI-P-Private_CDS Release 1",10)	(0029,"SPI-P-Private_CDS Release 1",10)	SPI-P-Private_CDS Release 1	41	16	f	\N	OB	1	Unknown	\N
6753	(0029,"SPI-P-XSB-VISUB Release 1",10)	(0029,"SPI-P-XSB-VISUB Release 1",10)	SPI-P-XSB-VISUB Release 1	41	16	f	\N	LO	1	Unknown	\N
6754	(0029,"SPI-P-XSB-VISUB Release 1",11)	(0029,"SPI-P-XSB-VISUB Release 1",11)	SPI-P-XSB-VISUB Release 1	41	17	f	\N	DS	1	Unknown	\N
6755	(0029,"SPI-P-Private_ICS Release 1",12)	(0029,"SPI-P-Private_ICS Release 1",12)	SPI-P-Private_ICS Release 1	41	18	f	\N	SQ	1	Unknown	\N
6756	(0029,"SPI-P-XSB-VISUB Release 1",12)	(0029,"SPI-P-XSB-VISUB Release 1",12)	SPI-P-XSB-VISUB Release 1	41	18	f	\N	CS	1	Unknown	\N
6757	(0029,"SPI-P-Private_ICS Release 1",1d)	(0029,"SPI-P-Private_ICS Release 1",1d)	SPI-P-Private_ICS Release 1	41	29	f	\N	SQ	1	Unknown	\N
6758	(0029,"SPI-P-Private_ICS Release 1",1e)	(0029,"SPI-P-Private_ICS Release 1",1e)	SPI-P-Private_ICS Release 1	41	30	f	\N	SQ	1	Unknown	\N
6759	(0029,"SPI-P-XSB-VISUB Release 1",1f)	(0029,"SPI-P-XSB-VISUB Release 1",1f)	SPI-P-XSB-VISUB Release 1	41	31	f	\N	CS	1	Unknown	\N
6760	(0029,"SPI-P-Private_ICS Release 1",20)	(0029,"SPI-P-Private_ICS Release 1",20)	SPI-P-Private_ICS Release 1	41	32	f	\N	UN	1	Unknown	\N
6761	(0029,"SPI-P-XSB-VISUB Release 1",20)	(0029,"SPI-P-XSB-VISUB Release 1",20)	SPI-P-XSB-VISUB Release 1	41	32	f	\N	LO	1	Unknown	\N
6762	(0029,"SPI-P-XSB-VISUB Release 1",21)	(0029,"SPI-P-XSB-VISUB Release 1",21)	SPI-P-XSB-VISUB Release 1	41	33	f	\N	DS	1	Unknown	\N
6763	(0029,"SPI-P-XSB-VISUB Release 1",22)	(0029,"SPI-P-XSB-VISUB Release 1",22)	SPI-P-XSB-VISUB Release 1	41	34	f	\N	CS	1	Unknown	\N
6764	(0029,"SPI-P-XSB-VISUB Release 1",2f)	(0029,"SPI-P-XSB-VISUB Release 1",2f)	SPI-P-XSB-VISUB Release 1	41	47	f	\N	CS	1	Unknown	\N
6765	(0029,"SPI-P-Private_ICS Release 1;2",30)	(0029,"SPI-P-Private_ICS Release 1;2",30)	SPI-P-Private_ICS Release 1;2	41	48	f	\N	LT	1	Unknown	\N
6766	(0029,"SPI-P-XSB-VISUB Release 1",30)	(0029,"SPI-P-XSB-VISUB Release 1",30)	SPI-P-XSB-VISUB Release 1	41	48	f	\N	LO	1	Unknown	\N
6767	(0029,"SPI-P-XSB-VISUB Release 1",31)	(0029,"SPI-P-XSB-VISUB Release 1",31)	SPI-P-XSB-VISUB Release 1	41	49	f	\N	DS	1	Unknown	\N
6768	(0029,"SPI-P-XSB-VISUB Release 1",32)	(0029,"SPI-P-XSB-VISUB Release 1",32)	SPI-P-XSB-VISUB Release 1	41	50	f	\N	CS	1	Unknown	\N
6769	(0029,"SPI-P-XSB-VISUB Release 1",3f)	(0029,"SPI-P-XSB-VISUB Release 1",3f)	SPI-P-XSB-VISUB Release 1	41	63	f	\N	CS	1	Unknown	\N
6770	(0029,"SPI-P-Private_ICS Release 1",4c)	(0029,"SPI-P-Private_ICS Release 1",4c)	SPI-P-Private_ICS Release 1	41	76	f	\N	SQ	1	Unknown	\N
6771	(0029,"SPI-P-Private_ICS Release 1",4d)	(0029,"SPI-P-Private_ICS Release 1",4d)	SPI-P-Private_ICS Release 1	41	77	f	\N	SQ	1	Unknown	\N
6772	(0029,"SPI-P-Private_ICS Release 1",4e)	(0029,"SPI-P-Private_ICS Release 1",4e)	SPI-P-Private_ICS Release 1	41	78	f	\N	FD	1	Unknown	\N
6773	(0029,"SPI-P-Private_ICS Release 1",4f)	(0029,"SPI-P-Private_ICS Release 1",4f)	SPI-P-Private_ICS Release 1	41	79	f	\N	FD	1	Unknown	\N
6774	(0029,"PHILIPS MR/PART",1050)	(0029,"PHILIPS MR/PART",50)	PHILIPS MR/PART	41	80	t	0010	DS	1	Unknown	\N
6775	(0029,"SPI-P-Private_ICS Release 1",50)	(0029,"SPI-P-Private_ICS Release 1",50)	SPI-P-Private_ICS Release 1	41	80	f	\N	FD	1	Unknown	\N
6776	(0029,"PHILIPS MR/PART",1051)	(0029,"PHILIPS MR/PART",51)	PHILIPS MR/PART	41	81	t	0010	DS	1	Unknown	\N
6777	(0029,"SPI-P-Private_ICS Release 1",51)	(0029,"SPI-P-Private_ICS Release 1",51)	SPI-P-Private_ICS Release 1	41	81	f	\N	FD	1	Unknown	\N
6778	(0029,"PHILIPS MR/PART",1052)	(0029,"PHILIPS MR/PART",52)	PHILIPS MR/PART	41	82	t	0010	DS	1	Unknown	\N
6779	(0029,"PHILIPS MR/PART",1053)	(0029,"PHILIPS MR/PART",53)	PHILIPS MR/PART	41	83	t	0010	DS	1	Unknown	\N
6780	(0029,"PHILIPS MR/LAST",62)	(0029,"PHILIPS MR/LAST",62)	PHILIPS MR/LAST	41	98	f	\N	IS	1	Unknown	\N
6781	(0029,"SPI-P-Private_ICS Release 1",6a)	(0029,"SPI-P-Private_ICS Release 1",6a)	SPI-P-Private_ICS Release 1	41	106	f	\N	LO	1	Unknown	\N
6782	(0029,"SPI-P-Private_ICS Release 1",6b)	(0029,"SPI-P-Private_ICS Release 1",6b)	SPI-P-Private_ICS Release 1	41	107	f	\N	US	1	Unknown	\N
6783	(0029,"SPI-P-Private_ICS Release 1",72)	(0029,"SPI-P-Private_ICS Release 1",72)	SPI-P-Private_ICS Release 1	41	114	f	\N	SQ	1	Unknown	\N
6784	(0029,"SPI-P Release 1",90)	(0029,"SPI-P Release 1",90)	SPI-P Release 1	41	144	f	\N	DS	1-n	Unknown	\N
6785	(0029,"SPI-P Release 1",91)	(0029,"SPI-P Release 1",91)	SPI-P Release 1	41	145	f	\N	US	1	Unknown	\N
6786	(0029,"SPI-P-Private_ICS Release 1",91)	(0029,"SPI-P-Private_ICS Release 1",91)	SPI-P-Private_ICS Release 1	41	145	f	\N	IS	1	Unknown	\N
6787	(0029,"SPI-P Release 1",9f)	(0029,"SPI-P Release 1",9f)	SPI-P Release 1	41	159	f	\N	CS	1	Unknown	\N
6788	(0029,"SPI-P Release 1",a0)	(0029,"SPI-P Release 1",a0)	SPI-P Release 1	41	160	f	\N	DS	1-n	Unknown	\N
6789	(0029,"SPI-P-Private_ICS Release 1;2",a0)	(0029,"SPI-P-Private_ICS Release 1;2",a0)	SPI-P-Private_ICS Release 1;2	41	160	f	\N	SL	1	Unknown	\N
6790	(0029,"SPI-P Release 1",a1)	(0029,"SPI-P Release 1",a1)	SPI-P Release 1	41	161	f	\N	US	1	Unknown	\N
6791	(0029,"SPI-P-Private_ICS Release 1;2",a1)	(0029,"SPI-P-Private_ICS Release 1;2",a1)	SPI-P-Private_ICS Release 1;2	41	161	f	\N	FD	1	Unknown	\N
6792	(0029,"SPI-P-Private_ICS Release 1;2",a2)	(0029,"SPI-P-Private_ICS Release 1;2",a2)	SPI-P-Private_ICS Release 1;2	41	162	f	\N	SL	1	Unknown	\N
6793	(0029,"SPI-P-Private_ICS Release 1;2",a3)	(0029,"SPI-P-Private_ICS Release 1;2",a3)	SPI-P-Private_ICS Release 1;2	41	163	f	\N	SL	1	Unknown	\N
6794	(0029,"SPI-P-Private_ICS Release 1;2",a5)	(0029,"SPI-P-Private_ICS Release 1;2",a5)	SPI-P-Private_ICS Release 1;2	41	165	f	\N	SQ	1	Unknown	\N
6795	(0029,"SPI-P-Private_ICS Release 1;2",a6)	(0029,"SPI-P-Private_ICS Release 1;2",a6)	SPI-P-Private_ICS Release 1;2	41	166	f	\N	SL	1	Unknown	\N
6796	(0029,"SPI-P Release 1",af)	(0029,"SPI-P Release 1",af)	SPI-P Release 1	41	175	f	\N	CS	1	Unknown	\N
6797	(0029,"SPI-P Release 1",b0)	(0029,"SPI-P Release 1",b0)	SPI-P Release 1	41	176	f	\N	DS	1-n	Unknown	\N
6798	(0029,"SPI-P Release 1",b1)	(0029,"SPI-P Release 1",b1)	SPI-P Release 1	41	177	f	\N	US	1	Unknown	\N
6799	(0029,"SPI-P Release 1",bf)	(0029,"SPI-P Release 1",bf)	SPI-P Release 1	41	191	f	\N	CS	1	Unknown	\N
6800	(0029,"SPI-P-Private_ICS Release 1;1",c0)	(0029,"SPI-P-Private_ICS Release 1;1",c0)	SPI-P-Private_ICS Release 1;1	41	192	f	\N	SL	1	Unknown	\N
6801	(0029,"SPI-P-Private_ICS Release 1;1",c1)	(0029,"SPI-P-Private_ICS Release 1;1",c1)	SPI-P-Private_ICS Release 1;1	41	193	f	\N	US	1	Unknown	\N
6802	(0029,"SPI-P-Private_ICS Release 1;1",cb)	(0029,"SPI-P-Private_ICS Release 1;1",cb)	SPI-P-Private_ICS Release 1;1	41	203	f	\N	FD	1	Unknown	\N
6803	(0029,"SPI-P-Private_ICS Release 1;1",cc)	(0029,"SPI-P-Private_ICS Release 1;1",cc)	SPI-P-Private_ICS Release 1;1	41	204	f	\N	FD	1	Unknown	\N
6804	(0029,"SPI-P-Private_ICS Release 1;1",cd)	(0029,"SPI-P-Private_ICS Release 1;1",cd)	SPI-P-Private_ICS Release 1;1	41	205	f	\N	SQ	1	Unknown	\N
6805	(0029,"SPI-P-Private_ICS Release 1;1",d0)	(0029,"SPI-P-Private_ICS Release 1;1",d0)	SPI-P-Private_ICS Release 1;1	41	208	f	\N	UN	1	Unknown	\N
6806	(0029,"SPI-P-Private_ICS Release 1;1",d1)	(0029,"SPI-P-Private_ICS Release 1;1",d1)	SPI-P-Private_ICS Release 1;1	41	209	f	\N	LO	1	Unknown	\N
6807	(0029,"SPI-P-Private_ICS Release 1;1",d2)	(0029,"SPI-P-Private_ICS Release 1;1",d2)	SPI-P-Private_ICS Release 1;1	41	210	f	\N	FL	1	Unknown	\N
6808	(0029,"SPI-P-Private_ICS Release 1;1",d3)	(0029,"SPI-P-Private_ICS Release 1;1",d3)	SPI-P-Private_ICS Release 1;1	41	211	f	\N	FL	1	Unknown	\N
6809	(0029,"SPI-P-Private_ICS Release 1;1",d4)	(0029,"SPI-P-Private_ICS Release 1;1",d4)	SPI-P-Private_ICS Release 1;1	41	212	f	\N	FL	1	Unknown	\N
6810	(0029,"SPI-P-Private_ICS Release 1;1",d5)	(0029,"SPI-P-Private_ICS Release 1;1",d5)	SPI-P-Private_ICS Release 1;1	41	213	f	\N	FL	1	Unknown	\N
6811	(0029,"SPI-P-Private_ICS Release 1;1",d6)	(0029,"SPI-P-Private_ICS Release 1;1",d6)	SPI-P-Private_ICS Release 1;1	41	214	f	\N	ST	1	Unknown	\N
6812	(0029,"SPI-P-Private_ICS Release 1;4",d6)	(0029,"SPI-P-Private_ICS Release 1;4",d6)	SPI-P-Private_ICS Release 1;4	41	214	f	\N	FD	1	Unknown	\N
6813	(0029,"SPI-P-Private_ICS Release 1;4",d7)	(0029,"SPI-P-Private_ICS Release 1;4",d7)	SPI-P-Private_ICS Release 1;4	41	215	f	\N	FD	1	Unknown	\N
6814	(0029,"SPI-P-Private_ICS Release 1;4",d8)	(0029,"SPI-P-Private_ICS Release 1;4",d8)	SPI-P-Private_ICS Release 1;4	41	216	f	\N	FD	1	Unknown	\N
6815	(0029,"SPI-P-Private_ICS Release 1;2",d9)	(0029,"SPI-P-Private_ICS Release 1;2",d9)	SPI-P-Private_ICS Release 1;2	41	217	f	\N	SQ	1	Unknown	\N
6816	(0029,"SPI-P-Private_ICS Release 1;4",d9)	(0029,"SPI-P-Private_ICS Release 1;4",d9)	SPI-P-Private_ICS Release 1;4	41	217	f	\N	FL	1	Unknown	\N
6817	(0029,"SPI-P-Private_ICS Release 1;4",da)	(0029,"SPI-P-Private_ICS Release 1;4",da)	SPI-P-Private_ICS Release 1;4	41	218	f	\N	FL	1	Unknown	\N
6818	(0029,"SPI-P-Private_ICS Release 1;4",dc)	(0029,"SPI-P-Private_ICS Release 1;4",dc)	SPI-P-Private_ICS Release 1;4	41	220	f	\N	FD	1	Unknown	\N
6819	(0029,"SPI-P-Private_ICS Release 1;4",dd)	(0029,"SPI-P-Private_ICS Release 1;4",dd)	SPI-P-Private_ICS Release 1;4	41	221	f	\N	FD	1	Unknown	\N
6820	(0029,"SPI-P-Private_ICS Release 1;4",e0)	(0029,"SPI-P-Private_ICS Release 1;4",e0)	SPI-P-Private_ICS Release 1;4	41	224	f	\N	SQ	1	Unknown	\N
6821	(0041,"PHILIPS MR/LAST",07)	(0041,"PHILIPS MR/LAST",07)	PHILIPS MR/LAST	65	7	f	\N	LO	1	Unknown	\N
6822	(0041,"PHILIPS MR/LAST",09)	(0041,"PHILIPS MR/LAST",09)	PHILIPS MR/LAST	65	9	f	\N	DS	1	Unknown	\N
6823	(0089,"PMS-THORA-5.1",20)	(0089,"PMS-THORA-5.1",20)	PMS-THORA-5.1	137	32	f	\N	SQ	1	Unknown	\N
6824	(0511,"Philips PET Private Group",00)	(0511,"Philips PET Private Group",00)	Philips PET Private Group	1297	0	f	\N	US	1	Private Data	\N
6825	(0511,"Philips PET Private Group",01)	(0511,"Philips PET Private Group",01)	Philips PET Private Group	1297	1	f	\N	US	1	Private Data	\N
6826	(0511,"Philips PET Private Group",02)	(0511,"Philips PET Private Group",02)	Philips PET Private Group	1297	2	f	\N	OB	1	Private Data	\N
6827	(0511,"Philips PET Private Group",03)	(0511,"Philips PET Private Group",03)	Philips PET Private Group	1297	3	f	\N	OB	1	Private Data	\N
6828	(0511,"Philips PET Private Group",32)	(0511,"Philips PET Private Group",32)	Philips PET Private Group	1297	50	f	\N	DS	1	Private Data	\N
6829	(0511,"Philips PET Private Group",50)	(0511,"Philips PET Private Group",50)	Philips PET Private Group	1297	80	f	\N	DS	1	Private Data	\N
6830	(1001,"Philips Imaging DD 124",03)	(1001,"Philips Imaging DD 124",03)	Philips Imaging DD 124	4097	3	f	\N	LO	1	Unknown	\N
6831	(2001,"Philips Imaging DD 129",00)	(2001,"Philips Imaging DD 129",00)	Philips Imaging DD 129	8193	0	f	\N	SQ	1	Presentation State Sequence	\N
6832	(2001,"Philips Imaging DD 002",01)	(2001,"Philips Imaging DD 002",01)	Philips Imaging DD 002	8193	1	f	\N	US	1	Unknown	\N
6833	(2001,"Philips Imaging DD 129",01)	(2001,"Philips Imaging DD 129",01)	Philips Imaging DD 129	8193	1	f	\N	SQ	1	PresentationStateSequence	\N
6834	(2001,"Philips Imaging DD 002",02)	(2001,"Philips Imaging DD 002",02)	Philips Imaging DD 002	8193	2	f	\N	FD	1	Unknown	\N
6835	(2001,"PHILIPS IMAGING DD 001",05)	(2001,"PHILIPS IMAGING DD 001",05)	PHILIPS IMAGING DD 001	8193	5	f	\N	SS	1	Graphic Annotation ParentID	\N
6836	(2001,"Philips Imaging DD 001",05)	(2001,"Philips Imaging DD 001",05)	Philips Imaging DD 001	8193	5	f	\N	SS	1	Graphic Annotation ParentID	\N
6837	(2001,"PHILIPS IMAGING DD 001",09)	(2001,"PHILIPS IMAGING DD 001",09)	PHILIPS IMAGING DD 001	8193	9	f	\N	FL	1	Image Prepulse Delay	\N
6839	(2001,"PHILIPS IMAGING DD 001",0c)	(2001,"PHILIPS IMAGING DD 001",0c)	PHILIPS IMAGING DD 001	8193	12	f	\N	CS	1	Arrhythmia Rejection	\N
6841	(2001,"PHILIPS IMAGING DD 001",0e)	(2001,"PHILIPS IMAGING DD 001",0e)	PHILIPS IMAGING DD 001	8193	14	f	\N	CS	1	Cardiac Cycled	\N
6843	(2001,"PHILIPS IMAGING DD 001",0f)	(2001,"PHILIPS IMAGING DD 001",0f)	PHILIPS IMAGING DD 001	8193	15	f	\N	SS	1	Cardiac Gate Width	\N
6845	(2001,"PHILIPS IMAGING DD 001",10)	(2001,"PHILIPS IMAGING DD 001",10)	PHILIPS IMAGING DD 001	8193	16	f	\N	CS	1	Cardiac Sync	\N
6847	(2001,"Philips Imaging DD 002",13)	(2001,"Philips Imaging DD 002",13)	Philips Imaging DD 002	8193	19	f	\N	SS	1	Unknown	\N
6848	(2001,"Philips Imaging DD 002",14)	(2001,"Philips Imaging DD 002",14)	Philips Imaging DD 002	8193	20	f	\N	FD	1	Unknown	\N
6849	(2001,"Philips Imaging DD 002",15)	(2001,"Philips Imaging DD 002",15)	Philips Imaging DD 002	8193	21	f	\N	FD	1	Unknown	\N
6850	(2001,"Philips Imaging DD 002",16)	(2001,"Philips Imaging DD 002",16)	Philips Imaging DD 002	8193	22	f	\N	FD	1	Unknown	\N
6851	(2001,"Philips Imaging DD 002",17)	(2001,"Philips Imaging DD 002",17)	Philips Imaging DD 002	8193	23	f	\N	FD	1	Unknown	\N
6852	(2001,"Philips Imaging DD 002",18)	(2001,"Philips Imaging DD 002",18)	Philips Imaging DD 002	8193	24	f	\N	CS	1	Unknown	\N
6853	(2001,"Philips Imaging DD 002",19)	(2001,"Philips Imaging DD 002",19)	Philips Imaging DD 002	8193	25	f	\N	FD	1	Unknown	\N
6854	(2001,"Philips Imaging DD 002",1a)	(2001,"Philips Imaging DD 002",1a)	Philips Imaging DD 002	8193	26	f	\N	FD	1	Unknown	\N
6855	(2001,"Philips Imaging DD 002",1b)	(2001,"Philips Imaging DD 002",1b)	Philips Imaging DD 002	8193	27	f	\N	FD	1	Unknown	\N
6856	(2001,"Philips Imaging DD 002",1c)	(2001,"Philips Imaging DD 002",1c)	Philips Imaging DD 002	8193	28	f	\N	FD	1	Unknown	\N
6857	(2001,"Philips Imaging DD 002",1d)	(2001,"Philips Imaging DD 002",1d)	Philips Imaging DD 002	8193	29	f	\N	FD	1	Unknown	\N
6858	(2001,"PHILIPS IMAGING DD 001",1e)	(2001,"PHILIPS IMAGING DD 001",1e)	PHILIPS IMAGING DD 001	8193	30	f	\N	CS	1	Reformat Accuracy	\N
6859	(2001,"Philips Imaging DD 001",1e)	(2001,"Philips Imaging DD 001",1e)	Philips Imaging DD 001	8193	30	f	\N	CS	1	Reformat Accuracy	\N
6860	(2001,"Philips Imaging DD 002",1e)	(2001,"Philips Imaging DD 002",1e)	Philips Imaging DD 002	8193	30	f	\N	FD	1	Unknown	\N
6861	(2001,"Philips Imaging DD 002",1f)	(2001,"Philips Imaging DD 002",1f)	Philips Imaging DD 002	8193	31	f	\N	FD	1	Unknown	\N
6862	(2001,"PHILIPS IMAGING DD 001",20)	(2001,"PHILIPS IMAGING DD 001",20)	PHILIPS IMAGING DD 001	8193	32	f	\N	LO	1	Scanning Technique	\N
6864	(2001,"Philips Imaging DD 002",20)	(2001,"Philips Imaging DD 002",20)	Philips Imaging DD 002	8193	32	f	\N	FD	1	Unknown	\N
6865	(2001,"Philips Imaging DD 002",21)	(2001,"Philips Imaging DD 002",21)	Philips Imaging DD 002	8193	33	f	\N	FD	1	Unknown	\N
6866	(2001,"Philips Imaging DD 002",22)	(2001,"Philips Imaging DD 002",22)	Philips Imaging DD 002	8193	34	f	\N	FD	1	Unknown	\N
6867	(2001,"Philips Imaging DD 002",23)	(2001,"Philips Imaging DD 002",23)	Philips Imaging DD 002	8193	35	f	\N	FD	1	Unknown	\N
6868	(2001,"PHILIPS IMAGING DD 001",24)	(2001,"PHILIPS IMAGING DD 001",24)	PHILIPS IMAGING DD 001	8193	36	f	\N	CS	1	Series is Interactive	\N
6870	(2001,"Philips Imaging DD 002",24)	(2001,"Philips Imaging DD 002",24)	Philips Imaging DD 002	8193	36	f	\N	FD	1	Unknown	\N
6871	(2001,"Philips Imaging DD 002",25)	(2001,"Philips Imaging DD 002",25)	Philips Imaging DD 002	8193	37	f	\N	FD	1	Unknown	\N
6872	(2001,"PHILIPS IMAGING DD 001",26)	(2001,"PHILIPS IMAGING DD 001",26)	PHILIPS IMAGING DD 001	8193	38	f	\N	CS	1	Presentation State Subtraction Active	\N
6873	(2001,"Philips Imaging DD 001",26)	(2001,"Philips Imaging DD 001",26)	Philips Imaging DD 001	8193	38	f	\N	CS	1	Presentation State Subtraction Active	\N
6874	(2001,"Philips Imaging DD 002",26)	(2001,"Philips Imaging DD 002",26)	Philips Imaging DD 002	8193	38	f	\N	FD	1	Unknown	\N
6863	(2001,"Philips Imaging DD 001",20)	(2001,"Philips Imaging DD 001",20)	Philips Imaging DD 001	8193	32	f	\N	LO	1	Scanning Technique	R
6869	(2001,"Philips Imaging DD 001",24)	(2001,"Philips Imaging DD 001",24)	Philips Imaging DD 001	8193	36	f	\N	CS	1	Series is Interactive	R
6875	(2001,"Philips Imaging DD 002",27)	(2001,"Philips Imaging DD 002",27)	Philips Imaging DD 002	8193	39	f	\N	FD	1	Unknown	\N
6876	(2001,"Philips Imaging DD 002",28)	(2001,"Philips Imaging DD 002",28)	Philips Imaging DD 002	8193	40	f	\N	US	1	Unknown	\N
6877	(2001,"PHILIPS IMAGING DD 001",29)	(2001,"PHILIPS IMAGING DD 001",29)	PHILIPS IMAGING DD 001	8193	41	f	\N	FL	1	Unknown	\N
6878	(2001,"Philips Imaging DD 001",29)	(2001,"Philips Imaging DD 001",29)	Philips Imaging DD 001	8193	41	f	\N	FL	1	Unknown	\N
6879	(2001,"Philips Imaging DD 002",29)	(2001,"Philips Imaging DD 002",29)	Philips Imaging DD 002	8193	41	f	\N	US	1	Unknown	\N
6880	(2001,"Philips Imaging DD 002",2a)	(2001,"Philips Imaging DD 002",2a)	Philips Imaging DD 002	8193	42	f	\N	US	1	Unknown	\N
6881	(2001,"PHILIPS IMAGING DD 001",2b)	(2001,"PHILIPS IMAGING DD 001",2b)	PHILIPS IMAGING DD 001	8193	43	f	\N	CS	1	Unknown	\N
6882	(2001,"Philips Imaging DD 001",2b)	(2001,"Philips Imaging DD 001",2b)	Philips Imaging DD 001	8193	43	f	\N	CS	1	Unknown	\N
6883	(2001,"Philips Imaging DD 002",2b)	(2001,"Philips Imaging DD 002",2b)	Philips Imaging DD 002	8193	43	f	\N	SS	1	Unknown	\N
6884	(2001,"Philips Imaging DD 002",2c)	(2001,"Philips Imaging DD 002",2c)	Philips Imaging DD 002	8193	44	f	\N	FD	1	Unknown	\N
6885	(2001,"Philips Imaging DD 002",2d)	(2001,"Philips Imaging DD 002",2d)	Philips Imaging DD 002	8193	45	f	\N	FD	1	Unknown	\N
6886	(2001,"Philips Imaging DD 002",2e)	(2001,"Philips Imaging DD 002",2e)	Philips Imaging DD 002	8193	46	f	\N	SS	1	Unknown	\N
6887	(2001,"Philips Imaging DD 002",2f)	(2001,"Philips Imaging DD 002",2f)	Philips Imaging DD 002	8193	47	f	\N	SS	1	Unknown	\N
6888	(2001,"Philips Imaging DD 002",30)	(2001,"Philips Imaging DD 002",30)	Philips Imaging DD 002	8193	48	f	\N	SS	1	Unknown	\N
6889	(2001,"Philips Imaging DD 002",31)	(2001,"Philips Imaging DD 002",31)	Philips Imaging DD 002	8193	49	f	\N	SS	1	Unknown	\N
6890	(2001,"Philips Imaging DD 002",32)	(2001,"Philips Imaging DD 002",32)	Philips Imaging DD 002	8193	50	f	\N	SS	1	Unknown	\N
6891	(2001,"Philips Imaging DD 002",33)	(2001,"Philips Imaging DD 002",33)	Philips Imaging DD 002	8193	51	f	\N	SS	1	Unknown	\N
6892	(2001,"Philips Imaging DD 002",34)	(2001,"Philips Imaging DD 002",34)	Philips Imaging DD 002	8193	52	f	\N	SS	1	Unknown	\N
6893	(2001,"Philips Imaging DD 002",35)	(2001,"Philips Imaging DD 002",35)	Philips Imaging DD 002	8193	53	f	\N	FD	1	Unknown	\N
6894	(2001,"Philips Imaging DD 002",36)	(2001,"Philips Imaging DD 002",36)	Philips Imaging DD 002	8193	54	f	\N	FD	1	Unknown	\N
6895	(2001,"Philips Imaging DD 002",37)	(2001,"Philips Imaging DD 002",37)	Philips Imaging DD 002	8193	55	f	\N	FD	1	Unknown	\N
6896	(2001,"PHILIPS IMAGING DD 001",39)	(2001,"PHILIPS IMAGING DD 001",39)	PHILIPS IMAGING DD 001	8193	57	f	\N	FL	1	Unknown	\N
6897	(2001,"Philips Imaging DD 001",39)	(2001,"Philips Imaging DD 001",39)	Philips Imaging DD 001	8193	57	f	\N	FL	1	Unknown	\N
6898	(2001,"Philips Imaging DD 002",39)	(2001,"Philips Imaging DD 002",39)	Philips Imaging DD 002	8193	57	f	\N	CS	1	Unknown	\N
6899	(2001,"Philips Imaging DD 002",3a)	(2001,"Philips Imaging DD 002",3a)	Philips Imaging DD 002	8193	58	f	\N	SQ	1	Unknown	\N
6900	(2001,"Philips Imaging DD 002",3b)	(2001,"Philips Imaging DD 002",3b)	Philips Imaging DD 002	8193	59	f	\N	SQ	1	Unknown	\N
6901	(2001,"Philips Imaging DD 002",3c)	(2001,"Philips Imaging DD 002",3c)	Philips Imaging DD 002	8193	60	f	\N	SQ	1	Unknown	\N
6902	(2001,"PHILIPS IMAGING DD 001",3d)	(2001,"PHILIPS IMAGING DD 001",3d)	PHILIPS IMAGING DD 001	8193	61	f	\N	UL	1	Contour Fill Color	\N
6903	(2001,"Philips Imaging DD 001",3d)	(2001,"Philips Imaging DD 001",3d)	Philips Imaging DD 001	8193	61	f	\N	UL	1	Contour Fill Color	\N
6904	(2001,"Philips Imaging DD 002",3d)	(2001,"Philips Imaging DD 002",3d)	Philips Imaging DD 002	8193	61	f	\N	SQ	1	Unknown	\N
6905	(2001,"Philips Imaging DD 002",3e)	(2001,"Philips Imaging DD 002",3e)	Philips Imaging DD 002	8193	62	f	\N	SS	1	Unknown	\N
6906	(2001,"Philips Imaging DD 002",3f)	(2001,"Philips Imaging DD 002",3f)	Philips Imaging DD 002	8193	63	f	\N	SS	1	Unknown	\N
6907	(2001,"Philips Imaging DD 002",40)	(2001,"Philips Imaging DD 002",40)	Philips Imaging DD 002	8193	64	f	\N	SS	1	Unknown	\N
6908	(2001,"PHILIPS IMAGING DD 001",43)	(2001,"PHILIPS IMAGING DD 001",43)	PHILIPS IMAGING DD 001	8193	67	f	\N	IS	2	Ellipse Display Shutter Major Axis First End Point	\N
6909	(2001,"Philips Imaging DD 001",43)	(2001,"Philips Imaging DD 001",43)	Philips Imaging DD 001	8193	67	f	\N	IS	2	Ellipse Display Shutter Major Axis First End Point	\N
6910	(2001,"PHILIPS IMAGING DD 001",44)	(2001,"PHILIPS IMAGING DD 001",44)	PHILIPS IMAGING DD 001	8193	68	f	\N	IS	2	Ellipse Display Shutter Major Axis Second End Point	\N
6911	(2001,"Philips Imaging DD 001",44)	(2001,"Philips Imaging DD 001",44)	Philips Imaging DD 001	8193	68	f	\N	IS	2	Ellipse Display Shutter Major Axis Second End Point	\N
6912	(2001,"PHILIPS IMAGING DD 001",45)	(2001,"PHILIPS IMAGING DD 001",45)	PHILIPS IMAGING DD 001	8193	69	f	\N	IS	2	Ellipse Display Shutter Other Axis First End Point	\N
6913	(2001,"Philips Imaging DD 001",45)	(2001,"Philips Imaging DD 001",45)	Philips Imaging DD 001	8193	69	f	\N	IS	2	Ellipse Display Shutter Other Axis First End Point	\N
6914	(2001,"PHILIPS IMAGING DD 001",46)	(2001,"PHILIPS IMAGING DD 001",46)	PHILIPS IMAGING DD 001	8193	70	f	\N	CS	1	Graphic Line Style	\N
6915	(2001,"Philips Imaging DD 001",46)	(2001,"Philips Imaging DD 001",46)	Philips Imaging DD 001	8193	70	f	\N	CS	1	Graphic Line Style	\N
6916	(2001,"PHILIPS IMAGING DD 001",47)	(2001,"PHILIPS IMAGING DD 001",47)	PHILIPS IMAGING DD 001	8193	71	f	\N	FL	1	Graphic Line Width	\N
6917	(2001,"Philips Imaging DD 001",47)	(2001,"Philips Imaging DD 001",47)	Philips Imaging DD 001	8193	71	f	\N	FL	1	Graphic Line Width	\N
6918	(2001,"PHILIPS IMAGING DD 001",48)	(2001,"PHILIPS IMAGING DD 001",48)	PHILIPS IMAGING DD 001	8193	72	f	\N	SS	1	Graphic Annotation ID	\N
6919	(2001,"Philips Imaging DD 001",48)	(2001,"Philips Imaging DD 001",48)	Philips Imaging DD 001	8193	72	f	\N	SS	1	Graphic Annotation ID	\N
6920	(2001,"PHILIPS IMAGING DD 001",4b)	(2001,"PHILIPS IMAGING DD 001",4b)	PHILIPS IMAGING DD 001	8193	75	f	\N	CS	1	Interpolation Method	\N
6921	(2001,"Philips Imaging DD 001",4b)	(2001,"Philips Imaging DD 001",4b)	Philips Imaging DD 001	8193	75	f	\N	CS	1	Interpolation Method	\N
6922	(2001,"PHILIPS IMAGING DD 001",4c)	(2001,"PHILIPS IMAGING DD 001",4c)	PHILIPS IMAGING DD 001	8193	76	f	\N	CS	1	Poly Line Begin Point Style	\N
6923	(2001,"Philips Imaging DD 001",4c)	(2001,"Philips Imaging DD 001",4c)	Philips Imaging DD 001	8193	76	f	\N	CS	1	Poly Line Begin Point Style	\N
6924	(2001,"PHILIPS IMAGING DD 001",4d)	(2001,"PHILIPS IMAGING DD 001",4d)	PHILIPS IMAGING DD 001	8193	77	f	\N	CS	1	Poly Line End Point Style	\N
6925	(2001,"Philips Imaging DD 001",4d)	(2001,"Philips Imaging DD 001",4d)	Philips Imaging DD 001	8193	77	f	\N	CS	1	Poly Line End Point Style	\N
6926	(2001,"PHILIPS IMAGING DD 001",4e)	(2001,"PHILIPS IMAGING DD 001",4e)	PHILIPS IMAGING DD 001	8193	78	f	\N	CS	1	Window Smoothing Taste	\N
6927	(2001,"Philips Imaging DD 001",4e)	(2001,"Philips Imaging DD 001",4e)	Philips Imaging DD 001	8193	78	f	\N	CS	1	Window Smoothing Taste	\N
6928	(2001,"PHILIPS IMAGING DD 001",50)	(2001,"PHILIPS IMAGING DD 001",50)	PHILIPS IMAGING DD 001	8193	80	f	\N	LO	1	Graphic Marker Type	\N
6929	(2001,"Philips Imaging DD 001",50)	(2001,"Philips Imaging DD 001",50)	Philips Imaging DD 001	8193	80	f	\N	LO	1	Graphic Marker Type	\N
6930	(2001,"PHILIPS IMAGING DD 001",51)	(2001,"PHILIPS IMAGING DD 001",51)	PHILIPS IMAGING DD 001	8193	81	f	\N	IS	1	Overlay Plane ID	\N
6931	(2001,"Philips Imaging DD 001",51)	(2001,"Philips Imaging DD 001",51)	Philips Imaging DD 001	8193	81	f	\N	IS	1	Overlay Plane ID	\N
6932	(2001,"PHILIPS IMAGING DD 001",52)	(2001,"PHILIPS IMAGING DD 001",52)	PHILIPS IMAGING DD 001	8193	82	f	\N	UI	1	Image Presentation State UID	\N
6933	(2001,"Philips Imaging DD 001",52)	(2001,"Philips Imaging DD 001",52)	Philips Imaging DD 001	8193	82	f	\N	UI	1	Image Presentation State UID	\N
6934	(2001,"PHILIPS IMAGING DD 001",53)	(2001,"PHILIPS IMAGING DD 001",53)	PHILIPS IMAGING DD 001	8193	83	f	\N	CS	1	Presentation GL Transform Invert	\N
6935	(2001,"Philips Imaging DD 001",53)	(2001,"Philips Imaging DD 001",53)	Philips Imaging DD 001	8193	83	f	\N	CS	1	Presentation GL Transform Invert	\N
6936	(2001,"PHILIPS IMAGING DD 001",54)	(2001,"PHILIPS IMAGING DD 001",54)	PHILIPS IMAGING DD 001	8193	84	f	\N	FL	1	Contour Fill Transparency	\N
6937	(2001,"Philips Imaging DD 001",54)	(2001,"Philips Imaging DD 001",54)	Philips Imaging DD 001	8193	84	f	\N	FL	1	Contour Fill Transparency	\N
6938	(2001,"PHILIPS IMAGING DD 001",55)	(2001,"PHILIPS IMAGING DD 001",55)	PHILIPS IMAGING DD 001	8193	85	f	\N	UL	1	Graphic Line Color	\N
6939	(2001,"Philips Imaging DD 001",55)	(2001,"Philips Imaging DD 001",55)	Philips Imaging DD 001	8193	85	f	\N	UL	1	Graphic Line Color	\N
6940	(2001,"PHILIPS IMAGING DD 001",56)	(2001,"PHILIPS IMAGING DD 001",56)	PHILIPS IMAGING DD 001	8193	86	f	\N	CS	1	Graphic Type	\N
6941	(2001,"Philips Imaging DD 001",56)	(2001,"Philips Imaging DD 001",56)	Philips Imaging DD 001	8193	86	f	\N	CS	1	Graphic Type	\N
6942	(2001,"PHILIPS IMAGING DD 001",58)	(2001,"PHILIPS IMAGING DD 001",58)	PHILIPS IMAGING DD 001	8193	88	f	\N	UL	1	Contrast Transfer Taste	\N
6944	(2001,"PHILIPS IMAGING DD 001",5a)	(2001,"PHILIPS IMAGING DD 001",5a)	PHILIPS IMAGING DD 001	8193	90	f	\N	ST	1	Graphic Annotation Model	\N
6945	(2001,"Philips Imaging DD 001",5a)	(2001,"Philips Imaging DD 001",5a)	Philips Imaging DD 001	8193	90	f	\N	ST	1	Graphic Annotation Model	\N
6946	(2001,"PHILIPS IMAGING DD 001",5d)	(2001,"PHILIPS IMAGING DD 001",5d)	PHILIPS IMAGING DD 001	8193	93	f	\N	ST	1	Measurement Text Units	\N
6947	(2001,"Philips Imaging DD 001",5d)	(2001,"Philips Imaging DD 001",5d)	Philips Imaging DD 001	8193	93	f	\N	ST	1	Measurement Text Units	\N
6948	(2001,"PHILIPS IMAGING DD 001",5e)	(2001,"PHILIPS IMAGING DD 001",5e)	PHILIPS IMAGING DD 001	8193	94	f	\N	ST	1	Measurement Text Type	\N
6949	(2001,"Philips Imaging DD 001",5e)	(2001,"Philips Imaging DD 001",5e)	Philips Imaging DD 001	8193	94	f	\N	ST	1	Measurement Text Type	\N
6950	(2001,"PHILIPS IMAGING DD 001",64)	(2001,"PHILIPS IMAGING DD 001",64)	PHILIPS IMAGING DD 001	8193	100	f	\N	SH	1	Text Type	\N
6951	(2001,"Philips Imaging DD 001",64)	(2001,"Philips Imaging DD 001",64)	Philips Imaging DD 001	8193	100	f	\N	SH	1	Text Type	\N
6952	(2001,"PHILIPS IMAGING DD 001",65)	(2001,"PHILIPS IMAGING DD 001",65)	PHILIPS IMAGING DD 001	8193	101	f	\N	SQ	1	Graphic Overlay Plane	\N
6953	(2001,"Philips Imaging DD 001",65)	(2001,"Philips Imaging DD 001",65)	Philips Imaging DD 001	8193	101	f	\N	SQ	1	Graphic Overlay Plane	\N
6954	(2001,"PHILIPS IMAGING DD 001",67)	(2001,"PHILIPS IMAGING DD 001",67)	PHILIPS IMAGING DD 001	8193	103	f	\N	CS	1	Linear Presentation GL Transform Shape Sub	\N
6955	(2001,"Philips Imaging DD 001",67)	(2001,"Philips Imaging DD 001",67)	Philips Imaging DD 001	8193	103	f	\N	CS	1	Linear Presentation GL Transform Shape Sub	\N
6956	(2001,"PHILIPS IMAGING DD 001",68)	(2001,"PHILIPS IMAGING DD 001",68)	PHILIPS IMAGING DD 001	8193	104	f	\N	SQ	1	Linear Modality GL Transform	\N
6957	(2001,"Philips Imaging DD 001",68)	(2001,"Philips Imaging DD 001",68)	Philips Imaging DD 001	8193	104	f	\N	SQ	1	Linear Modality GL Transform	\N
6958	(2001,"PHILIPS IMAGING DD 001",69)	(2001,"PHILIPS IMAGING DD 001",69)	PHILIPS IMAGING DD 001	8193	105	f	\N	SQ	1	Display Shutter	\N
6959	(2001,"Philips Imaging DD 001",69)	(2001,"Philips Imaging DD 001",69)	Philips Imaging DD 001	8193	105	f	\N	SQ	1	Display Shutter	\N
6960	(2001,"PHILIPS IMAGING DD 001",6a)	(2001,"PHILIPS IMAGING DD 001",6a)	PHILIPS IMAGING DD 001	8193	106	f	\N	SQ	1	Spatial Transformation	\N
6961	(2001,"Philips Imaging DD 001",6a)	(2001,"Philips Imaging DD 001",6a)	Philips Imaging DD 001	8193	106	f	\N	SQ	1	Spatial Transformation	\N
6962	(2001,"PHILIPS IMAGING DD 001",6b)	(2001,"PHILIPS IMAGING DD 001",6b)	PHILIPS IMAGING DD 001	8193	107	f	\N	SQ	1	Unknown	\N
6963	(2001,"Philips Imaging DD 001",6b)	(2001,"Philips Imaging DD 001",6b)	Philips Imaging DD 001	8193	107	f	\N	SQ	1	Unknown	\N
6964	(2001,"PHILIPS IMAGING DD 001",6d)	(2001,"PHILIPS IMAGING DD 001",6d)	PHILIPS IMAGING DD 001	8193	109	f	\N	LO	1	Text Font	\N
6965	(2001,"Philips Imaging DD 001",6d)	(2001,"Philips Imaging DD 001",6d)	Philips Imaging DD 001	8193	109	f	\N	LO	1	Text Font	\N
6966	(2001,"PHILIPS IMAGING DD 001",6e)	(2001,"PHILIPS IMAGING DD 001",6e)	PHILIPS IMAGING DD 001	8193	110	f	\N	SH	1	Series Type	\N
6967	(2001,"Philips Imaging DD 001",6e)	(2001,"Philips Imaging DD 001",6e)	Philips Imaging DD 001	8193	110	f	\N	SH	1	Series Type	\N
6968	(2001,"PHILIPS IMAGING DD 001",71)	(2001,"PHILIPS IMAGING DD 001",71)	PHILIPS IMAGING DD 001	8193	113	f	\N	CS	1	Graphic Constraint	\N
6969	(2001,"Philips Imaging DD 001",71)	(2001,"Philips Imaging DD 001",71)	Philips Imaging DD 001	8193	113	f	\N	CS	1	Graphic Constraint	\N
6970	(2001,"PHILIPS IMAGING DD 001",72)	(2001,"PHILIPS IMAGING DD 001",72)	PHILIPS IMAGING DD 001	8193	114	f	\N	IS	1	Ellipse Display Shutter Other Axis Second End Point	\N
6971	(2001,"Philips Imaging DD 001",72)	(2001,"Philips Imaging DD 001",72)	Philips Imaging DD 001	8193	114	f	\N	IS	1	Ellipse Display Shutter Other Axis Second End Point	\N
6972	(2001,"Philips Imaging DD 002",72)	(2001,"Philips Imaging DD 002",72)	Philips Imaging DD 002	8193	114	f	\N	FL	2	Unknown	\N
6973	(2001,"Philips Imaging DD 002",73)	(2001,"Philips Imaging DD 002",73)	Philips Imaging DD 002	8193	115	f	\N	FL	2	Unknown	\N
6974	(2001,"PHILIPS IMAGING DD 001",74)	(2001,"PHILIPS IMAGING DD 001",74)	PHILIPS IMAGING DD 001	8193	116	f	\N	DS	1	Unknown	\N
6975	(2001,"Philips Imaging DD 001",74)	(2001,"Philips Imaging DD 001",74)	Philips Imaging DD 001	8193	116	f	\N	DS	1	Unknown	\N
6976	(2001,"PHILIPS IMAGING DD 001",75)	(2001,"PHILIPS IMAGING DD 001",75)	PHILIPS IMAGING DD 001	8193	117	f	\N	DS	1	Unknown	\N
6977	(2001,"Philips Imaging DD 001",75)	(2001,"Philips Imaging DD 001",75)	Philips Imaging DD 001	8193	117	f	\N	DS	1	Unknown	\N
6978	(2001,"PHILIPS IMAGING DD 001",76)	(2001,"PHILIPS IMAGING DD 001",76)	PHILIPS IMAGING DD 001	8193	118	f	\N	UL	1	Number of Frames	\N
6979	(2001,"Philips Imaging DD 001",76)	(2001,"Philips Imaging DD 001",76)	Philips Imaging DD 001	8193	118	f	\N	UL	1	Number of Frames	\N
6980	(2001,"PHILIPS IMAGING DD 001",77)	(2001,"PHILIPS IMAGING DD 001",77)	PHILIPS IMAGING DD 001	8193	119	f	\N	CS	1	GL Transform Type	\N
6981	(2001,"Philips Imaging DD 001",77)	(2001,"Philips Imaging DD 001",77)	Philips Imaging DD 001	8193	119	f	\N	CS	1	GL Transform Type	\N
6982	(2001,"PHILIPS IMAGING DD 001",7a)	(2001,"PHILIPS IMAGING DD 001",7a)	PHILIPS IMAGING DD 001	8193	122	f	\N	FL	1	Window Rounding Factor	\N
6983	(2001,"Philips Imaging DD 001",7a)	(2001,"Philips Imaging DD 001",7a)	Philips Imaging DD 001	8193	122	f	\N	FL	1	Window Rounding Factor	\N
6984	(2001,"PHILIPS IMAGING DD 001",7c)	(2001,"PHILIPS IMAGING DD 001",7c)	PHILIPS IMAGING DD 001	8193	124	f	\N	US	1	Frame Number	\N
6985	(2001,"Philips Imaging DD 001",7c)	(2001,"Philips Imaging DD 001",7c)	Philips Imaging DD 001	8193	124	f	\N	US	1	Frame Number	\N
6986	(2001,"PHILIPS IMAGING DD 001",80)	(2001,"PHILIPS IMAGING DD 001",80)	PHILIPS IMAGING DD 001	8193	128	f	\N	LO	1	Unknown	\N
6987	(2001,"Philips Imaging DD 001",80)	(2001,"Philips Imaging DD 001",80)	Philips Imaging DD 001	8193	128	f	\N	LO	1	Unknown	\N
6988	(2001,"PHILIPS IMAGING DD 001",82)	(2001,"PHILIPS IMAGING DD 001",82)	PHILIPS IMAGING DD 001	8193	130	f	\N	IS	1	Echo Train Length	\N
6989	(2001,"Philips Imaging DD 001",82)	(2001,"Philips Imaging DD 001",82)	Philips Imaging DD 001	8193	130	f	\N	IS	1	Echo Train Length	\N
6990	(2001,"PHILIPS IMAGING DD 001",83)	(2001,"PHILIPS IMAGING DD 001",83)	PHILIPS IMAGING DD 001	8193	131	f	\N	DS	1	Imaging Frequency	\N
6991	(2001,"Philips Imaging DD 001",83)	(2001,"Philips Imaging DD 001",83)	Philips Imaging DD 001	8193	131	f	\N	DS	1	Imaging Frequency	\N
6992	(2001,"PHILIPS IMAGING DD 001",84)	(2001,"PHILIPS IMAGING DD 001",84)	PHILIPS IMAGING DD 001	8193	132	f	\N	DS	1	Inversion Time	\N
6993	(2001,"Philips Imaging DD 001",84)	(2001,"Philips Imaging DD 001",84)	Philips Imaging DD 001	8193	132	f	\N	DS	1	Inversion Time	\N
6994	(2001,"PHILIPS IMAGING DD 001",85)	(2001,"PHILIPS IMAGING DD 001",85)	PHILIPS IMAGING DD 001	8193	133	f	\N	DS	1	Magnetic Field Strength	\N
6995	(2001,"Philips Imaging DD 001",85)	(2001,"Philips Imaging DD 001",85)	Philips Imaging DD 001	8193	133	f	\N	DS	1	Magnetic Field Strength	\N
6996	(2001,"PHILIPS IMAGING DD 001",86)	(2001,"PHILIPS IMAGING DD 001",86)	PHILIPS IMAGING DD 001	8193	134	f	\N	IS	1	Number of Phase Encoding Steps	\N
6997	(2001,"Philips Imaging DD 001",86)	(2001,"Philips Imaging DD 001",86)	Philips Imaging DD 001	8193	134	f	\N	IS	1	Number of Phase Encoding Steps	\N
6998	(2001,"PHILIPS IMAGING DD 001",87)	(2001,"PHILIPS IMAGING DD 001",87)	PHILIPS IMAGING DD 001	8193	135	f	\N	SH	1	Imaged Nucleus	\N
6999	(2001,"Philips Imaging DD 001",87)	(2001,"Philips Imaging DD 001",87)	Philips Imaging DD 001	8193	135	f	\N	SH	1	Imaged Nucleus	\N
7000	(2001,"PHILIPS IMAGING DD 001",88)	(2001,"PHILIPS IMAGING DD 001",88)	PHILIPS IMAGING DD 001	8193	136	f	\N	DS	1	Number of Averages	\N
7001	(2001,"Philips Imaging DD 001",88)	(2001,"Philips Imaging DD 001",88)	Philips Imaging DD 001	8193	136	f	\N	DS	1	Number of Averages	\N
7002	(2001,"PHILIPS IMAGING DD 001",89)	(2001,"PHILIPS IMAGING DD 001",89)	PHILIPS IMAGING DD 001	8193	137	f	\N	DS	1	Phase FOV Percent	\N
7003	(2001,"Philips Imaging DD 001",89)	(2001,"Philips Imaging DD 001",89)	Philips Imaging DD 001	8193	137	f	\N	DS	1	Phase FOV Percent	\N
7004	(2001,"PHILIPS IMAGING DD 001",8a)	(2001,"PHILIPS IMAGING DD 001",8a)	PHILIPS IMAGING DD 001	8193	138	f	\N	DS	1	Sampling Percent	\N
7005	(2001,"Philips Imaging DD 001",8a)	(2001,"Philips Imaging DD 001",8a)	Philips Imaging DD 001	8193	138	f	\N	DS	1	Sampling Percent	\N
7006	(2001,"PHILIPS IMAGING DD 001",8b)	(2001,"PHILIPS IMAGING DD 001",8b)	PHILIPS IMAGING DD 001	8193	139	f	\N	SH	1	Transmitting Coil	\N
7007	(2001,"Philips Imaging DD 001",8b)	(2001,"Philips Imaging DD 001",8b)	Philips Imaging DD 001	8193	139	f	\N	SH	1	Transmitting Coil	\N
7008	(2001,"PHILIPS IMAGING DD 001",90)	(2001,"PHILIPS IMAGING DD 001",90)	PHILIPS IMAGING DD 001	8193	144	f	\N	LO	1	Text Foreground Color	\N
7009	(2001,"Philips Imaging DD 001",90)	(2001,"Philips Imaging DD 001",90)	Philips Imaging DD 001	8193	144	f	\N	LO	1	Text Foreground Color	\N
7010	(2001,"PHILIPS IMAGING DD 001",91)	(2001,"PHILIPS IMAGING DD 001",91)	PHILIPS IMAGING DD 001	8193	145	f	\N	LO	1	Text Background Color	\N
7011	(2001,"Philips Imaging DD 001",91)	(2001,"Philips Imaging DD 001",91)	Philips Imaging DD 001	8193	145	f	\N	LO	1	Text Background Color	\N
7012	(2001,"PHILIPS IMAGING DD 001",92)	(2001,"PHILIPS IMAGING DD 001",92)	PHILIPS IMAGING DD 001	8193	146	f	\N	LO	1	Text Shadow Color	\N
7013	(2001,"Philips Imaging DD 001",92)	(2001,"Philips Imaging DD 001",92)	Philips Imaging DD 001	8193	146	f	\N	LO	1	Text Shadow Color	\N
7014	(2001,"PHILIPS IMAGING DD 001",93)	(2001,"PHILIPS IMAGING DD 001",93)	PHILIPS IMAGING DD 001	8193	147	f	\N	LO	1	Text Style	\N
7015	(2001,"Philips Imaging DD 001",93)	(2001,"Philips Imaging DD 001",93)	Philips Imaging DD 001	8193	147	f	\N	LO	1	Text Style	\N
7016	(2001,"PHILIPS IMAGING DD 001",9a)	(2001,"PHILIPS IMAGING DD 001",9a)	PHILIPS IMAGING DD 001	8193	154	f	\N	SQ	1	Unknown	\N
7017	(2001,"Philips Imaging DD 001",9a)	(2001,"Philips Imaging DD 001",9a)	Philips Imaging DD 001	8193	154	f	\N	SQ	1	Unknown	\N
7018	(2001,"PHILIPS IMAGING DD 001",9b)	(2001,"PHILIPS IMAGING DD 001",9b)	PHILIPS IMAGING DD 001	8193	155	f	\N	UL	1	Graphic Number	\N
7019	(2001,"Philips Imaging DD 001",9b)	(2001,"Philips Imaging DD 001",9b)	Philips Imaging DD 001	8193	155	f	\N	UL	1	Graphic Number	\N
7020	(2001,"PHILIPS IMAGING DD 001",9c)	(2001,"PHILIPS IMAGING DD 001",9c)	PHILIPS IMAGING DD 001	8193	156	f	\N	LO	1	Graphic Annotation Label	\N
7021	(2001,"Philips Imaging DD 001",9c)	(2001,"Philips Imaging DD 001",9c)	Philips Imaging DD 001	8193	156	f	\N	LO	1	Graphic Annotation Label	\N
7022	(2001,"PHILIPS IMAGING DD 001",9f)	(2001,"PHILIPS IMAGING DD 001",9f)	PHILIPS IMAGING DD 001	8193	159	f	\N	US	2	Pixel Processing Kernel Size	\N
7023	(2001,"Philips Imaging DD 001",9f)	(2001,"Philips Imaging DD 001",9f)	Philips Imaging DD 001	8193	159	f	\N	US	2	Pixel Processing Kernel Size	\N
7024	(2001,"PHILIPS IMAGING DD 001",a1)	(2001,"PHILIPS IMAGING DD 001",a1)	PHILIPS IMAGING DD 001	8193	161	f	\N	CS	1	Is Raw Image	\N
7026	(2001,"PHILIPS IMAGING DD 001",a3)	(2001,"PHILIPS IMAGING DD 001",a3)	PHILIPS IMAGING DD 001	8193	163	f	\N	UL	1	Text Color Foreground	\N
7027	(2001,"Philips Imaging DD 001",a3)	(2001,"Philips Imaging DD 001",a3)	Philips Imaging DD 001	8193	163	f	\N	UL	1	Text Color Foreground	\N
7028	(2001,"PHILIPS IMAGING DD 001",a4)	(2001,"PHILIPS IMAGING DD 001",a4)	PHILIPS IMAGING DD 001	8193	164	f	\N	UL	1	Text Color Background	\N
7029	(2001,"Philips Imaging DD 001",a4)	(2001,"Philips Imaging DD 001",a4)	Philips Imaging DD 001	8193	164	f	\N	UL	1	Text Color Background	\N
7030	(2001,"PHILIPS IMAGING DD 001",a5)	(2001,"PHILIPS IMAGING DD 001",a5)	PHILIPS IMAGING DD 001	8193	165	f	\N	UL	1	Text Color Shadow	\N
7031	(2001,"Philips Imaging DD 001",a5)	(2001,"Philips Imaging DD 001",a5)	Philips Imaging DD 001	8193	165	f	\N	UL	1	Text Color Shadow	\N
7032	(2001,"PHILIPS IMAGING DD 001",c1)	(2001,"PHILIPS IMAGING DD 001",c1)	PHILIPS IMAGING DD 001	8193	193	f	\N	LO	1	Linear Modality GL Transform	\N
7033	(2001,"Philips Imaging DD 001",c1)	(2001,"Philips Imaging DD 001",c1)	Philips Imaging DD 001	8193	193	f	\N	LO	1	Linear Modality GL Transform	\N
7034	(2001,"PHILIPS IMAGING DD 001",c8)	(2001,"PHILIPS IMAGING DD 001",c8)	PHILIPS IMAGING DD 001	8193	200	f	\N	LO	1	Exam Card Name	\N
7036	(2001,"PHILIPS IMAGING DD 001",cc)	(2001,"PHILIPS IMAGING DD 001",cc)	PHILIPS IMAGING DD 001	8193	204	f	\N	ST	1	Derivation Description	\N
7037	(2001,"Philips Imaging DD 001",cc)	(2001,"Philips Imaging DD 001",cc)	Philips Imaging DD 001	8193	204	f	\N	ST	1	Derivation Description	\N
7038	(2001,"PHILIPS IMAGING DD 001",da)	(2001,"PHILIPS IMAGING DD 001",da)	PHILIPS IMAGING DD 001	8193	218	f	\N	CS	1	Unknown	\N
7039	(2001,"Philips Imaging DD 001",da)	(2001,"Philips Imaging DD 001",da)	Philips Imaging DD 001	8193	218	f	\N	CS	1	Unknown	\N
7040	(2001,"PHILIPS IMAGING DD 001",f1)	(2001,"PHILIPS IMAGING DD 001",f1)	PHILIPS IMAGING DD 001	8193	241	f	\N	FL	1-n	Prospective Motion Correction	\N
7042	(2001,"PHILIPS IMAGING DD 001",f2)	(2001,"PHILIPS IMAGING DD 001",f2)	PHILIPS IMAGING DD 001	8193	242	f	\N	FL	1-n	Retrospective Motion Correction	\N
7044	(2003,"Philips X-ray Imaging DD 001",00)	(2003,"Philips X-ray Imaging DD 001",00)	Philips X-ray Imaging DD 001	8195	0	f	\N	CS	1	Unknown	\N
7045	(2003,"Philips X-ray Imaging DD 001",01)	(2003,"Philips X-ray Imaging DD 001",01)	Philips X-ray Imaging DD 001	8195	1	f	\N	LO	1	Unknown	\N
7046	(2003,"Philips X-ray Imaging DD 001",02)	(2003,"Philips X-ray Imaging DD 001",02)	Philips X-ray Imaging DD 001	8195	2	f	\N	FD	3	Unknown	\N
7047	(2003,"Philips X-ray Imaging DD 001",03)	(2003,"Philips X-ray Imaging DD 001",03)	Philips X-ray Imaging DD 001	8195	3	f	\N	LO	1	Unknown	\N
7048	(2003,"Philips X-ray Imaging DD 001",06)	(2003,"Philips X-ray Imaging DD 001",06)	Philips X-ray Imaging DD 001	8195	6	f	\N	SL	1	Unknown	\N
7049	(2003,"Philips X-ray Imaging DD 001",09)	(2003,"Philips X-ray Imaging DD 001",09)	Philips X-ray Imaging DD 001	8195	9	f	\N	SL	1	Unknown	\N
7050	(2003,"Philips X-ray Imaging DD 001",10)	(2003,"Philips X-ray Imaging DD 001",10)	Philips X-ray Imaging DD 001	8195	16	f	\N	LO	1	Unknown	\N
7051	(2003,"Philips X-ray Imaging DD 001",11)	(2003,"Philips X-ray Imaging DD 001",11)	Philips X-ray Imaging DD 001	8195	17	f	\N	SL	1	Unknown	\N
7052	(2003,"Philips X-ray Imaging DD 001",12)	(2003,"Philips X-ray Imaging DD 001",12)	Philips X-ray Imaging DD 001	8195	18	f	\N	SL	1	Unknown	\N
7053	(2003,"Philips X-ray Imaging DD 001",13)	(2003,"Philips X-ray Imaging DD 001",13)	Philips X-ray Imaging DD 001	8195	19	f	\N	SL	1	Unknown	\N
7054	(2003,"Philips X-ray Imaging DD 001",14)	(2003,"Philips X-ray Imaging DD 001",14)	Philips X-ray Imaging DD 001	8195	20	f	\N	FD	1	Unknown	\N
7055	(2003,"Philips X-ray Imaging DD 001",15)	(2003,"Philips X-ray Imaging DD 001",15)	Philips X-ray Imaging DD 001	8195	21	f	\N	FD	1	Unknown	\N
7056	(2003,"Philips X-ray Imaging DD 001",16)	(2003,"Philips X-ray Imaging DD 001",16)	Philips X-ray Imaging DD 001	8195	22	f	\N	SL	1	Unknown	\N
7057	(2003,"Philips X-ray Imaging DD 001",17)	(2003,"Philips X-ray Imaging DD 001",17)	Philips X-ray Imaging DD 001	8195	23	f	\N	SL	1	Unknown	\N
7058	(2003,"Philips X-ray Imaging DD 001",18)	(2003,"Philips X-ray Imaging DD 001",18)	Philips X-ray Imaging DD 001	8195	24	f	\N	SL	1	Unknown	\N
7059	(2003,"Philips X-ray Imaging DD 001",19)	(2003,"Philips X-ray Imaging DD 001",19)	Philips X-ray Imaging DD 001	8195	25	f	\N	SL	1	Unknown	\N
7060	(2003,"Philips X-ray Imaging DD 001",22)	(2003,"Philips X-ray Imaging DD 001",22)	Philips X-ray Imaging DD 001	8195	34	f	\N	SL	1	Unknown	\N
7061	(2003,"Philips X-ray Imaging DD 001",24)	(2003,"Philips X-ray Imaging DD 001",24)	Philips X-ray Imaging DD 001	8195	36	f	\N	FD	4	Unknown	\N
7062	(2003,"Philips X-ray Imaging DD 001",25)	(2003,"Philips X-ray Imaging DD 001",25)	Philips X-ray Imaging DD 001	8195	37	f	\N	SL	1	Unknown	\N
7063	(2003,"Philips X-ray Imaging DD 001",26)	(2003,"Philips X-ray Imaging DD 001",26)	Philips X-ray Imaging DD 001	8195	38	f	\N	SL	1	Unknown	\N
7064	(2003,"Philips X-ray Imaging DD 001",27)	(2003,"Philips X-ray Imaging DD 001",27)	Philips X-ray Imaging DD 001	8195	39	f	\N	SH	1	Unknown	\N
7065	(2003,"Philips X-ray Imaging DD 001",28)	(2003,"Philips X-ray Imaging DD 001",28)	Philips X-ray Imaging DD 001	8195	40	f	\N	SH	1	Unknown	\N
7066	(2003,"Philips X-ray Imaging DD 001",29)	(2003,"Philips X-ray Imaging DD 001",29)	Philips X-ray Imaging DD 001	8195	41	f	\N	FD	1	Unknown	\N
7067	(2003,"Philips X-ray Imaging DD 001",2a)	(2003,"Philips X-ray Imaging DD 001",2a)	Philips X-ray Imaging DD 001	8195	42	f	\N	LO	1	Unknown	\N
7068	(2003,"Philips X-ray Imaging DD 001",2b)	(2003,"Philips X-ray Imaging DD 001",2b)	Philips X-ray Imaging DD 001	8195	43	f	\N	FD	1	Unknown	\N
7069	(2003,"Philips X-ray Imaging DD 001",2c)	(2003,"Philips X-ray Imaging DD 001",2c)	Philips X-ray Imaging DD 001	8195	44	f	\N	SH	1	Unknown	\N
7070	(2003,"Philips X-ray Imaging DD 001",2d)	(2003,"Philips X-ray Imaging DD 001",2d)	Philips X-ray Imaging DD 001	8195	45	f	\N	SL	1-n	Unknown	\N
7071	(2003,"Philips X-ray Imaging DD 001",2e)	(2003,"Philips X-ray Imaging DD 001",2e)	Philips X-ray Imaging DD 001	8195	46	f	\N	SQ	1	Unknown	\N
7072	(2003,"Philips X-ray Imaging DD 001",30)	(2003,"Philips X-ray Imaging DD 001",30)	Philips X-ray Imaging DD 001	8195	48	f	\N	CS	1	Unknown	\N
7073	(2003,"Philips X-ray Imaging DD 001",31)	(2003,"Philips X-ray Imaging DD 001",31)	Philips X-ray Imaging DD 001	8195	49	f	\N	CS	1	Unknown	\N
7074	(2003,"Philips X-ray Imaging DD 001",32)	(2003,"Philips X-ray Imaging DD 001",32)	Philips X-ray Imaging DD 001	8195	50	f	\N	UI	1	Unknown	\N
7075	(2005,"PHILIPS MR IMAGING DD 001",00)	(2005,"PHILIPS MR IMAGING DD 001",00)	PHILIPS MR IMAGING DD 001	8197	0	f	\N	FL	1	Image Angulation AP	\N
7076	(2005,"Philips MR Imaging DD 001",00)	(2005,"Philips MR Imaging DD 001",00)	Philips MR Imaging DD 001	8197	0	f	\N	FL	1	Image Angulation AP	\N
7077	(2005,"Philips MR Imaging DD 003",00)	(2005,"Philips MR Imaging DD 003",00)	Philips MR Imaging DD 003	8197	0	f	\N	UL	1	Number of SOP Common	\N
7078	(2005,"Philips MR Imaging DD 004",00)	(2005,"Philips MR Imaging DD 004",00)	Philips MR Imaging DD 004	8197	0	f	\N	SS	1	Spectrum Extra Number	\N
7079	(2005,"Philips MR Imaging DD 005",00)	(2005,"Philips MR Imaging DD 005",00)	Philips MR Imaging DD 005	8197	0	f	\N	CS	1	Volume View Enabled	\N
7080	(2005,"PHILIPS MR IMAGING DD 001",01)	(2005,"PHILIPS MR IMAGING DD 001",01)	PHILIPS MR IMAGING DD 001	8197	1	f	\N	FL	1	Image Angulation FH	\N
7081	(2005,"Philips MR Imaging DD 001",01)	(2005,"Philips MR Imaging DD 001",01)	Philips MR Imaging DD 001	8197	1	f	\N	FL	1	Image Angulation FH	\N
7082	(2005,"Philips MR Imaging DD 003",01)	(2005,"Philips MR Imaging DD 003",01)	Philips MR Imaging DD 003	8197	1	f	\N	UL	1	Number of Film Consumption	\N
7083	(2005,"Philips MR Imaging DD 004",01)	(2005,"Philips MR Imaging DD 004",01)	Philips MR Imaging DD 004	8197	1	f	\N	SS	1	Spectrum Kx Coordinate	\N
7084	(2005,"Philips MR Imaging DD 005",01)	(2005,"Philips MR Imaging DD 005",01)	Philips MR Imaging DD 005	8197	1	f	\N	UL	1	Number of Study Reference	\N
7085	(2005,"PHILIPS MR IMAGING DD 001",02)	(2005,"PHILIPS MR IMAGING DD 001",02)	PHILIPS MR IMAGING DD 001	8197	2	f	\N	FL	1	Image Angulation RL	\N
7086	(2005,"Philips MR Imaging DD 001",02)	(2005,"Philips MR Imaging DD 001",02)	Philips MR Imaging DD 001	8197	2	f	\N	FL	1	Image Angulation RL	\N
7087	(2005,"Philips MR Imaging DD 004",02)	(2005,"Philips MR Imaging DD 004",02)	Philips MR Imaging DD 004	8197	2	f	\N	SS	1	Spectrum Ky Coordinate	\N
7088	(2005,"Philips MR Imaging DD 001",03)	(2005,"Philips MR Imaging DD 001",03)	Philips MR Imaging DD 001	8197	3	f	\N	IS	1	Image Annotation Count	\N
7089	(2005,"Philips MR Imaging DD 004",03)	(2005,"Philips MR Imaging DD 004",03)	Philips MR Imaging DD 004	8197	3	f	\N	SS	1	Spectrum Location Number	\N
7090	(2005,"Philips MR Imaging DD 005",03)	(2005,"Philips MR Imaging DD 005",03)	Philips MR Imaging DD 005	8197	3	f	\N	UL	1	Number of SPS Codes	\N
7091	(2005,"PHILIPS MR IMAGING DD 001",04)	(2005,"PHILIPS MR IMAGING DD 001",04)	PHILIPS MR IMAGING DD 001	8197	4	f	\N	CS	1	Image Display Orientation	\N
7092	(2005,"Philips MR Imaging DD 001",04)	(2005,"Philips MR Imaging DD 001",04)	Philips MR Imaging DD 001	8197	4	f	\N	CS	1	Image Display Orientation	\N
7093	(2005,"Philips MR Imaging DD 004",04)	(2005,"Philips MR Imaging DD 004",04)	Philips MR Imaging DD 004	8197	4	f	\N	SS	1	Spectrum Mix Number	\N
7094	(2005,"Philips MR Imaging DD 005",04)	(2005,"Philips MR Imaging DD 005",04)	Philips MR Imaging DD 005	8197	4	f	\N	SS	1	Unknown	\N
7095	(2005,"Philips MR Imaging DD 004",05)	(2005,"Philips MR Imaging DD 004",05)	Philips MR Imaging DD 004	8197	5	f	\N	SS	1	Spectrum X Coordinate	\N
7096	(2005,"Philips MR Imaging DD 004",06)	(2005,"Philips MR Imaging DD 004",06)	Philips MR Imaging DD 004	8197	6	f	\N	SS	1	Spectrum Y Coordinate	\N
7097	(2005,"Philips MR Imaging DD 005",06)	(2005,"Philips MR Imaging DD 005",06)	Philips MR Imaging DD 005	8197	6	f	\N	SS	1	Number of PS Specific Character Sets	\N
7098	(2005,"Philips MR Imaging DD 001",07)	(2005,"Philips MR Imaging DD 001",07)	Philips MR Imaging DD 001	8197	7	f	\N	IS	1	Image Line Count	\N
7099	(2005,"Philips MR Imaging DD 004",07)	(2005,"Philips MR Imaging DD 004",07)	Philips MR Imaging DD 004	8197	7	f	\N	FL	1	Spectrum DC Level	\N
7100	(2005,"Philips MR Imaging DD 005",07)	(2005,"Philips MR Imaging DD 005",07)	Philips MR Imaging DD 005	8197	7	f	\N	SS	1	Number of Specific Character Set	\N
7101	(2005,"PHILIPS MR IMAGING DD 001",08)	(2005,"PHILIPS MR IMAGING DD 001",08)	PHILIPS MR IMAGING DD 001	8197	8	f	\N	FL	1	Image Offcenter AP	\N
7102	(2005,"Philips MR Imaging DD 001",08)	(2005,"Philips MR Imaging DD 001",08)	Philips MR Imaging DD 001	8197	8	f	\N	FL	1	Image Offcenter AP	\N
7103	(2005,"Philips MR Imaging DD 004",08)	(2005,"Philips MR Imaging DD 004",08)	Philips MR Imaging DD 004	8197	8	f	\N	FL	1	Spectrum Noise Level	\N
7104	(2005,"PHILIPS MR IMAGING DD 001",09)	(2005,"PHILIPS MR IMAGING DD 001",09)	PHILIPS MR IMAGING DD 001	8197	9	f	\N	FL	1	Image Offcenter FH	\N
7105	(2005,"Philips MR Imaging DD 001",09)	(2005,"Philips MR Imaging DD 001",09)	Philips MR Imaging DD 001	8197	9	f	\N	FL	1	Image Offcenter FH	\N
7106	(2005,"Philips MR Imaging DD 004",09)	(2005,"Philips MR Imaging DD 004",09)	Philips MR Imaging DD 004	8197	9	f	\N	FL	1	Spectrum Begin Time	\N
7107	(2005,"Philips MR Imaging DD 005",09)	(2005,"Philips MR Imaging DD 005",09)	Philips MR Imaging DD 005	8197	9	f	\N	DS	1	Rescale Intercept Original	\N
7108	(2005,"PHILIPS MR IMAGING DD 001",0a)	(2005,"PHILIPS MR IMAGING DD 001",0a)	PHILIPS MR IMAGING DD 001	8197	10	f	\N	FL	1	Image OffCentre RL	\N
7109	(2005,"Philips MR Imaging DD 001",0a)	(2005,"Philips MR Imaging DD 001",0a)	Philips MR Imaging DD 001	8197	10	f	\N	FL	1	Image OffCentre RL	\N
7110	(2005,"Philips MR Imaging DD 005",0a)	(2005,"Philips MR Imaging DD 005",0a)	Philips MR Imaging DD 005	8197	10	f	\N	DS	1	Rescale Slope Original	\N
7111	(2005,"PHILIPS MR IMAGING DD 001",0b)	(2005,"PHILIPS MR IMAGING DD 001",0b)	PHILIPS MR IMAGING DD 001	8197	11	f	\N	FL	1	Max FP	\N
7112	(2005,"Philips MR Imaging DD 001",0b)	(2005,"Philips MR Imaging DD 001",0b)	Philips MR Imaging DD 001	8197	11	f	\N	FL	1	Max FP	\N
7113	(2005,"Philips MR Imaging DD 005",0b)	(2005,"Philips MR Imaging DD 005",0b)	Philips MR Imaging DD 005	8197	11	f	\N	LO	1	Rescale Type Original	\N
7114	(2005,"PHILIPS MR IMAGING DD 001",0c)	(2005,"PHILIPS MR IMAGING DD 001",0c)	PHILIPS MR IMAGING DD 001	8197	12	f	\N	FL	1	Min FP	\N
7115	(2005,"Philips MR Imaging DD 001",0c)	(2005,"Philips MR Imaging DD 001",0c)	Philips MR Imaging DD 001	8197	12	f	\N	FL	1	Min FP	\N
7116	(2005,"PHILIPS MR IMAGING DD 001",0d)	(2005,"PHILIPS MR IMAGING DD 001",0d)	PHILIPS MR IMAGING DD 001	8197	13	f	\N	FL	1	Scale Intercept	\N
7117	(2005,"Philips MR Imaging DD 001",0d)	(2005,"Philips MR Imaging DD 001",0d)	Philips MR Imaging DD 001	8197	13	f	\N	FL	1	Scale Intercept	\N
7118	(2005,"PHILIPS MR IMAGING DD 001",0e)	(2005,"PHILIPS MR IMAGING DD 001",0e)	PHILIPS MR IMAGING DD 001	8197	14	f	\N	FL	1	Scale Slope	\N
7119	(2005,"Philips MR Imaging DD 001",0e)	(2005,"Philips MR Imaging DD 001",0e)	Philips MR Imaging DD 001	8197	14	f	\N	FL	1	Scale Slope	\N
7120	(2005,"Philips MR Imaging DD 005",0e)	(2005,"Philips MR Imaging DD 005",0e)	Philips MR Imaging DD 005	8197	14	f	\N	SQ	1	Private Shared Sequence	\N
7121	(2005,"PHILIPS MR IMAGING DD 001",0f)	(2005,"PHILIPS MR IMAGING DD 001",0f)	PHILIPS MR IMAGING DD 001	8197	15	f	\N	DS	1	Window Center	\N
7122	(2005,"Philips MR Imaging DD 001",0f)	(2005,"Philips MR Imaging DD 001",0f)	Philips MR Imaging DD 001	8197	15	f	\N	DS	1	Window Center	\N
7123	(2005,"Philips MR Imaging DD 005",0f)	(2005,"Philips MR Imaging DD 005",0f)	Philips MR Imaging DD 005	8197	15	f	\N	SQ	1	Private Per-Frame Sequence	\N
7124	(2005,"PHILIPS MR IMAGING DD 001",10)	(2005,"PHILIPS MR IMAGING DD 001",10)	PHILIPS MR IMAGING DD 001	8197	16	f	\N	DS	1	Window Width	\N
7125	(2005,"Philips MR Imaging DD 001",10)	(2005,"Philips MR Imaging DD 001",10)	Philips MR Imaging DD 001	8197	16	f	\N	DS	1	Window Width	\N
7126	(2005,"Philips MR Imaging DD 004",10)	(2005,"Philips MR Imaging DD 004",10)	Philips MR Imaging DD 004	8197	16	f	\N	FL	1	Spectrum Echo Time	\N
7127	(2005,"Philips MR Imaging DD 005",10)	(2005,"Philips MR Imaging DD 005",10)	Philips MR Imaging DD 005	8197	16	f	\N	IS	1	MF Conv Treat Spectro Mix Number	\N
7128	(2005,"PHILIPS MR IMAGING DD 001",11)	(2005,"PHILIPS MR IMAGING DD 001",11)	PHILIPS MR IMAGING DD 001	8197	17	f	\N	CS	1	Image Type	\N
7129	(2005,"Philips MR Imaging DD 001",11)	(2005,"Philips MR Imaging DD 001",11)	Philips MR Imaging DD 001	8197	17	f	\N	CS	1-n	Image Type	\N
7130	(2005,"Philips MR Imaging DD 005",11)	(2005,"Philips MR Imaging DD 005",11)	Philips MR Imaging DD 005	8197	17	f	\N	UI	1	MF Private Referenced SOP Instance UID	\N
7131	(2005,"PHILIPS MR IMAGING DD 001",12)	(2005,"PHILIPS MR IMAGING DD 001",12)	PHILIPS MR IMAGING DD 001	8197	18	f	\N	CS	1	Cardiac Gating	\N
7132	(2005,"Philips MR Imaging DD 001",12)	(2005,"Philips MR Imaging DD 001",12)	Philips MR Imaging DD 001	8197	18	f	\N	CS	1	Cardiac Gating	\N
7133	(2005,"Philips MR Imaging DD 004",12)	(2005,"Philips MR Imaging DD 004",12)	Philips MR Imaging DD 004	8197	18	f	\N	FL	1	Spectrum Inversion Time	\N
7134	(2005,"Philips MR Imaging DD 005",12)	(2005,"Philips MR Imaging DD 005",12)	Philips MR Imaging DD 005	8197	18	f	\N	IS	1	Diffusion B Value Number	\N
7135	(2005,"PHILIPS MR IMAGING DD 001",13)	(2005,"PHILIPS MR IMAGING DD 001",13)	PHILIPS MR IMAGING DD 001	8197	19	f	\N	CS	1	Development Mode	\N
7136	(2005,"Philips MR Imaging DD 001",13)	(2005,"Philips MR Imaging DD 001",13)	Philips MR Imaging DD 001	8197	19	f	\N	CS	1	Development Mode	\N
7137	(2005,"Philips MR Imaging DD 003",13)	(2005,"Philips MR Imaging DD 003",13)	Philips MR Imaging DD 003	8197	19	f	\N	UL	1	Number of Codes	\N
7138	(2005,"Philips MR Imaging DD 004",13)	(2005,"Philips MR Imaging DD 004",13)	Philips MR Imaging DD 004	8197	19	f	\N	SS	1	Spectrum Number	\N
7139	(2005,"Philips MR Imaging DD 005",13)	(2005,"Philips MR Imaging DD 005",13)	Philips MR Imaging DD 005	8197	19	f	\N	IS	1	Gradient Orientation Number	\N
7140	(2005,"PHILIPS MR IMAGING DD 001",14)	(2005,"PHILIPS MR IMAGING DD 001",14)	PHILIPS MR IMAGING DD 001	8197	20	f	\N	CS	1	Diffusion	\N
7141	(2005,"Philips MR Imaging DD 001",14)	(2005,"Philips MR Imaging DD 001",14)	Philips MR Imaging DD 001	8197	20	f	\N	CS	1	Diffusion	\N
7142	(2005,"Philips MR Imaging DD 004",14)	(2005,"Philips MR Imaging DD 004",14)	Philips MR Imaging DD 004	8197	20	f	\N	SS	1	Spectrum Number of Averages	\N
7143	(2005,"Philips MR Imaging DD 005",14)	(2005,"Philips MR Imaging DD 005",14)	Philips MR Imaging DD 005	8197	20	f	\N	SL	1	Number of Diffusion B Values	\N
7144	(2005,"PHILIPS MR IMAGING DD 001",15)	(2005,"PHILIPS MR IMAGING DD 001",15)	PHILIPS MR IMAGING DD 001	8197	21	f	\N	CS	1	Fat Saturation	\N
7145	(2005,"Philips MR Imaging DD 001",15)	(2005,"Philips MR Imaging DD 001",15)	Philips MR Imaging DD 001	8197	21	f	\N	CS	1	Fat Saturation	\N
7146	(2005,"Philips MR Imaging DD 002",15)	(2005,"Philips MR Imaging DD 002",15)	Philips MR Imaging DD 002	8197	21	f	\N	LO	1	User Name	\N
7147	(2005,"Philips MR Imaging DD 004",15)	(2005,"Philips MR Imaging DD 004",15)	Philips MR Imaging DD 004	8197	21	f	\N	SS	1	Spectrum Number of Samples	\N
7148	(2005,"Philips MR Imaging DD 005",15)	(2005,"Philips MR Imaging DD 005",15)	Philips MR Imaging DD 005	8197	21	f	\N	SL	1	Number of Diffusion Gradient Orientations	\N
7149	(2005,"PHILIPS MR IMAGING DD 001",16)	(2005,"PHILIPS MR IMAGING DD 001",16)	PHILIPS MR IMAGING DD 001	8197	22	f	\N	CS	1	Flow Compensation	\N
7150	(2005,"Philips MR Imaging DD 001",16)	(2005,"Philips MR Imaging DD 001",16)	Philips MR Imaging DD 001	8197	22	f	\N	CS	1	Flow Compensation	\N
7151	(2005,"Philips MR Imaging DD 002",16)	(2005,"Philips MR Imaging DD 002",16)	Philips MR Imaging DD 002	8197	22	f	\N	LO	1	Pass Word	\N
7152	(2005,"Philips MR Imaging DD 004",16)	(2005,"Philips MR Imaging DD 004",16)	Philips MR Imaging DD 004	8197	22	f	\N	SS	1	Spectrum Scan Sequence Number	\N
7153	(2005,"Philips MR Imaging DD 005",16)	(2005,"Philips MR Imaging DD 005",16)	Philips MR Imaging DD 005	8197	22	f	\N	CS	1	Plan Mode	\N
7154	(2005,"PHILIPS MR IMAGING DD 001",17)	(2005,"PHILIPS MR IMAGING DD 001",17)	PHILIPS MR IMAGING DD 001	8197	23	f	\N	CS	1	Fourier Interpolation	\N
7155	(2005,"Philips MR Imaging DD 001",17)	(2005,"Philips MR Imaging DD 001",17)	Philips MR Imaging DD 001	8197	23	f	\N	CS	1	Fourier Interpolation	\N
7156	(2005,"Philips MR Imaging DD 002",17)	(2005,"Philips MR Imaging DD 002",17)	Philips MR Imaging DD 002	8197	23	f	\N	LO	1	Server Name	\N
7157	(2005,"Philips MR Imaging DD 004",17)	(2005,"Philips MR Imaging DD 004",17)	Philips MR Imaging DD 004	8197	23	f	\N	SS	1	Spectrum Number of Peaks	\N
7158	(2005,"Philips MR Imaging DD 005",17)	(2005,"Philips MR Imaging DD 005",17)	Philips MR Imaging DD 005	8197	23	f	\N	FD	3	Diffusion B Matrix	\N
7159	(2005,"PHILIPS MR IMAGING DD 001",18)	(2005,"PHILIPS MR IMAGING DD 001",18)	PHILIPS MR IMAGING DD 001	8197	24	f	\N	LO	1	Hardcopy Protocol	\N
7160	(2005,"Philips MR Imaging DD 001",18)	(2005,"Philips MR Imaging DD 001",18)	Philips MR Imaging DD 001	8197	24	f	\N	LO	1	Hardcopy Protocol	\N
7161	(2005,"Philips MR Imaging DD 002",18)	(2005,"Philips MR Imaging DD 002",18)	Philips MR Imaging DD 002	8197	24	f	\N	LO	1	Data Base Name	\N
7162	(2005,"Philips MR Imaging DD 004",18)	(2005,"Philips MR Imaging DD 004",18)	Philips MR Imaging DD 004	8197	24	f	\N	SQ	1	Spectrum Peak	\N
7163	(2005,"Philips MR Imaging DD 005",18)	(2005,"Philips MR Imaging DD 005",18)	Philips MR Imaging DD 005	8197	24	f	\N	CS	3	Operating Mode Type	\N
7164	(2005,"PHILIPS MR IMAGING DD 001",19)	(2005,"PHILIPS MR IMAGING DD 001",19)	PHILIPS MR IMAGING DD 001	8197	25	f	\N	CS	1	Inverse Reconstructed	\N
7165	(2005,"Philips MR Imaging DD 001",19)	(2005,"Philips MR Imaging DD 001",19)	Philips MR Imaging DD 001	8197	25	f	\N	CS	1	Inverse Reconstructed	\N
7166	(2005,"Philips MR Imaging DD 002",19)	(2005,"Philips MR Imaging DD 002",19)	Philips MR Imaging DD 002	8197	25	f	\N	LO	1	RootName	\N
7167	(2005,"Philips MR Imaging DD 004",19)	(2005,"Philips MR Imaging DD 004",19)	Philips MR Imaging DD 004	8197	25	f	\N	FL	1-n	Spectrum Peak Intensity	\N
7168	(2005,"Philips MR Imaging DD 005",19)	(2005,"Philips MR Imaging DD 005",19)	Philips MR Imaging DD 005	8197	25	f	\N	CS	3	Operating Mode	\N
7169	(2005,"PHILIPS MR IMAGING DD 001",1a)	(2005,"PHILIPS MR IMAGING DD 001",1a)	PHILIPS MR IMAGING DD 001	8197	26	f	\N	SS	1	Label Syntax	\N
7170	(2005,"Philips MR Imaging DD 001",1a)	(2005,"Philips MR Imaging DD 001",1a)	Philips MR Imaging DD 001	8197	26	f	\N	SS	1	Label Syntax	\N
7171	(2005,"Philips MR Imaging DD 005",1a)	(2005,"Philips MR Imaging DD 005",1a)	Philips MR Imaging DD 005	8197	26	f	\N	CS	1	Fat Saturation Technique	\N
7172	(2005,"PHILIPS MR IMAGING DD 001",1b)	(2005,"PHILIPS MR IMAGING DD 001",1b)	PHILIPS MR IMAGING DD 001	8197	27	f	\N	CS	1	Magnetization Prepared	\N
7173	(2005,"Philips MR Imaging DD 001",1b)	(2005,"Philips MR Imaging DD 001",1b)	Philips MR Imaging DD 001	8197	27	f	\N	CS	1	Magnetization Prepared	\N
7174	(2005,"Philips MR Imaging DD 005",1b)	(2005,"Philips MR Imaging DD 005",1b)	Philips MR Imaging DD 005	8197	27	f	\N	IS	1	Version Number Deleted Images	\N
7175	(2005,"PHILIPS MR IMAGING DD 001",1c)	(2005,"PHILIPS MR IMAGING DD 001",1c)	PHILIPS MR IMAGING DD 001	8197	28	f	\N	CS	1	Magnetization Transfer Contrast	\N
7176	(2005,"Philips MR Imaging DD 001",1c)	(2005,"Philips MR Imaging DD 001",1c)	Philips MR Imaging DD 001	8197	28	f	\N	CS	1	Magnetization Transfer Contrast	\N
7177	(2005,"Philips MR Imaging DD 005",1c)	(2005,"Philips MR Imaging DD 005",1c)	Philips MR Imaging DD 005	8197	28	f	\N	IS	1	Version Number Deleted Spectra	\N
7178	(2005,"PHILIPS MR IMAGING DD 001",1d)	(2005,"PHILIPS MR IMAGING DD 001",1d)	PHILIPS MR IMAGING DD 001	8197	29	f	\N	SS	1	Measurement Scan Resolution	\N
7179	(2005,"Philips MR Imaging DD 001",1d)	(2005,"Philips MR Imaging DD 001",1d)	Philips MR Imaging DD 001	8197	29	f	\N	SS	1	Measurement Scan Resolution	\N
7180	(2005,"Philips MR Imaging DD 005",1d)	(2005,"Philips MR Imaging DD 005",1d)	Philips MR Imaging DD 005	8197	29	f	\N	IS	1	Version Number Deleted Blobsets	\N
7181	(2005,"Philips MR Imaging DD 005",1e)	(2005,"Philips MR Imaging DD 005",1e)	Philips MR Imaging DD 005	8197	30	f	\N	UL	1	LUT1 Offset	\N
7182	(2005,"Philips MR Imaging DD 005",1f)	(2005,"Philips MR Imaging DD 005",1f)	Philips MR Imaging DD 005	8197	31	f	\N	UL	1	LUT1 Range	\N
7183	(2005,"Philips MR Imaging DD 002",20)	(2005,"Philips MR Imaging DD 002",20)	Philips MR Imaging DD 002	8197	32	f	\N	LO	1	DMI Application Name	\N
7184	(2005,"Philips MR Imaging DD 004",20)	(2005,"Philips MR Imaging DD 004",20)	Philips MR Imaging DD 004	8197	32	f	\N	LO	1-n	Spectrum Peak Label	\N
7185	(2005,"Philips MR Imaging DD 005",20)	(2005,"Philips MR Imaging DD 005",20)	Philips MR Imaging DD 005	8197	32	f	\N	UL	1	LUT1 Begin Color	\N
7186	(2005,"PHILIPS MR IMAGING DD 001",21)	(2005,"PHILIPS MR IMAGING DD 001",21)	PHILIPS MR IMAGING DD 001	8197	33	f	\N	SS	1	Number of Mixes	\N
7187	(2005,"Philips MR Imaging DD 001",21)	(2005,"Philips MR Imaging DD 001",21)	Philips MR Imaging DD 001	8197	33	f	\N	SS	1	Number of Mixes	\N
7188	(2005,"Philips MR Imaging DD 004",21)	(2005,"Philips MR Imaging DD 004",21)	Philips MR Imaging DD 004	8197	33	f	\N	FL	1-n	Spectrum Peak Phase	\N
7189	(2005,"Philips MR Imaging DD 005",21)	(2005,"Philips MR Imaging DD 005",21)	Philips MR Imaging DD 005	8197	33	f	\N	UL	1	LUT1 End Color	\N
7190	(2005,"PHILIPS MR IMAGING DD 001",22)	(2005,"PHILIPS MR IMAGING DD 001",22)	PHILIPS MR IMAGING DD 001	8197	34	f	\N	IS	1	Number of References	\N
7191	(2005,"Philips MR Imaging DD 001",22)	(2005,"Philips MR Imaging DD 001",22)	Philips MR Imaging DD 001	8197	34	f	\N	IS	1	Number of References	\N
7192	(2005,"Philips MR Imaging DD 004",22)	(2005,"Philips MR Imaging DD 004",22)	Philips MR Imaging DD 004	8197	34	f	\N	FL	1-n	Spectrum Peak Position	\N
7193	(2005,"Philips MR Imaging DD 005",22)	(2005,"Philips MR Imaging DD 005",22)	Philips MR Imaging DD 005	8197	34	f	\N	UL	1	LUT2 Offset	\N
7194	(2005,"PHILIPS MR IMAGING DD 001",23)	(2005,"PHILIPS MR IMAGING DD 001",23)	PHILIPS MR IMAGING DD 001	8197	35	f	\N	SS	1	Number of Slabs	\N
7195	(2005,"Philips MR Imaging DD 001",23)	(2005,"Philips MR Imaging DD 001",23)	Philips MR Imaging DD 001	8197	35	f	\N	SS	1	Number of Slabs	\N
7196	(2005,"Philips MR Imaging DD 004",23)	(2005,"Philips MR Imaging DD 004",23)	Philips MR Imaging DD 004	8197	35	f	\N	CS	1-n	Spectrum Peak Type	\N
7197	(2005,"Philips MR Imaging DD 005",23)	(2005,"Philips MR Imaging DD 005",23)	Philips MR Imaging DD 005	8197	35	f	\N	UL	1	LUT2 Range	\N
7198	(2005,"Philips MR Imaging DD 004",24)	(2005,"Philips MR Imaging DD 004",24)	Philips MR Imaging DD 004	8197	36	f	\N	FL	1-n	Spectrum Peak Width	\N
7199	(2005,"Philips MR Imaging DD 005",24)	(2005,"Philips MR Imaging DD 005",24)	Philips MR Imaging DD 005	8197	36	f	\N	UL	1	LUT2 Begin Color	\N
7200	(2005,"PHILIPS MR IMAGING DD 001",25)	(2005,"PHILIPS MR IMAGING DD 001",25)	PHILIPS MR IMAGING DD 001	8197	37	f	\N	SS	1	Number of Volumes	\N
7201	(2005,"Philips MR Imaging DD 001",25)	(2005,"Philips MR Imaging DD 001",25)	Philips MR Imaging DD 001	8197	37	f	\N	SS	1	Number of Volumes	\N
7202	(2005,"Philips MR Imaging DD 004",25)	(2005,"Philips MR Imaging DD 004",25)	Philips MR Imaging DD 004	8197	37	f	\N	CS	1	Spectro SI B0 Correction	\N
7203	(2005,"Philips MR Imaging DD 005",25)	(2005,"Philips MR Imaging DD 005",25)	Philips MR Imaging DD 005	8197	37	f	\N	UL	1	LUT2 End Color	\N
7204	(2005,"PHILIPS MR IMAGING DD 001",26)	(2005,"PHILIPS MR IMAGING DD 001",26)	PHILIPS MR IMAGING DD 001	8197	38	f	\N	CS	1	Over Sampling Phase	\N
7205	(2005,"Philips MR Imaging DD 001",26)	(2005,"Philips MR Imaging DD 001",26)	Philips MR Imaging DD 001	8197	38	f	\N	CS	1	Over Sampling Phase	\N
7206	(2005,"Philips MR Imaging DD 004",26)	(2005,"Philips MR Imaging DD 004",26)	Philips MR Imaging DD 004	8197	38	f	\N	FL	1	Spectro B0 Echo Top Position	\N
7207	(2005,"Philips MR Imaging DD 005",26)	(2005,"Philips MR Imaging DD 005",26)	Philips MR Imaging DD 005	8197	38	f	\N	CS	1	Viewing Hardcopy Only	\N
7208	(2005,"PHILIPS MR IMAGING DD 001",27)	(2005,"PHILIPS MR IMAGING DD 001",27)	PHILIPS MR IMAGING DD 001	8197	39	f	\N	CS	1	Package Mode	\N
7209	(2005,"Philips MR Imaging DD 001",27)	(2005,"Philips MR Imaging DD 001",27)	Philips MR Imaging DD 001	8197	39	f	\N	CS	1	Package Mode	\N
7210	(2005,"Philips MR Imaging DD 004",27)	(2005,"Philips MR Imaging DD 004",27)	Philips MR Imaging DD 004	8197	39	f	\N	CS	1	Spectro Complex Component	\N
7211	(2005,"Philips MR Imaging DD 005",27)	(2005,"Philips MR Imaging DD 005",27)	Philips MR Imaging DD 005	8197	39	f	\N	CS	1	Unknown	\N
7212	(2005,"PHILIPS MR IMAGING DD 001",28)	(2005,"PHILIPS MR IMAGING DD 001",28)	PHILIPS MR IMAGING DD 001	8197	40	f	\N	CS	1	Partial Fourier Frequency	\N
7213	(2005,"Philips MR Imaging DD 001",28)	(2005,"Philips MR Imaging DD 001",28)	Philips MR Imaging DD 001	8197	40	f	\N	CS	1	Partial Fourier Frequency	\N
7214	(2005,"Philips MR Imaging DD 004",28)	(2005,"Philips MR Imaging DD 004",28)	Philips MR Imaging DD 004	8197	40	f	\N	CS	1	Spectro Data Origin	\N
7215	(2005,"Philips MR Imaging DD 005",28)	(2005,"Philips MR Imaging DD 005",28)	Philips MR Imaging DD 005	8197	40	f	\N	SL	1	Number of Label Types	\N
7216	(2005,"PHILIPS MR IMAGING DD 001",29)	(2005,"PHILIPS MR IMAGING DD 001",29)	PHILIPS MR IMAGING DD 001	8197	41	f	\N	CS	1	PartialFourierPhase	\N
7217	(2005,"Philips MR Imaging DD 001",29)	(2005,"Philips MR Imaging DD 001",29)	Philips MR Imaging DD 001	8197	41	f	\N	CS	1	PartialFourierPhase	\N
7218	(2005,"Philips MR Imaging DD 004",29)	(2005,"Philips MR Imaging DD 004",29)	Philips MR Imaging DD 004	8197	41	f	\N	FL	1	Spectro Echo Top Position	\N
7219	(2005,"Philips MR Imaging DD 005",29)	(2005,"Philips MR Imaging DD 005",29)	Philips MR Imaging DD 005	8197	41	f	\N	CS	1	Label Type	\N
7220	(2005,"Philips MR Imaging DD 002",2d)	(2005,"Philips MR Imaging DD 002",2d)	Philips MR Imaging DD 002	8197	45	f	\N	LO	1	Root Id	\N
7221	(2005,"PHILIPS MR IMAGING DD 001",2a)	(2005,"PHILIPS MR IMAGING DD 001",2a)	PHILIPS MR IMAGING DD 001	8197	42	f	\N	IS	1	Patient Reference ID	\N
7222	(2005,"Philips MR Imaging DD 001",2a)	(2005,"Philips MR Imaging DD 001",2a)	Philips MR Imaging DD 001	8197	42	f	\N	IS	1	Patient Reference ID	\N
7223	(2005,"Philips MR Imaging DD 005",2a)	(2005,"Philips MR Imaging DD 005",2a)	Philips MR Imaging DD 005	8197	42	f	\N	CS	1	Exam Print Status	\N
7224	(2005,"PHILIPS MR IMAGING DD 001",2b)	(2005,"PHILIPS MR IMAGING DD 001",2b)	PHILIPS MR IMAGING DD 001	8197	43	f	\N	SS	1	Percent Scan Complete	\N
7225	(2005,"Philips MR Imaging DD 001",2b)	(2005,"Philips MR Imaging DD 001",2b)	Philips MR Imaging DD 001	8197	43	f	\N	SS	1	Percent Scan Complete	\N
7226	(2005,"Philips MR Imaging DD 005",2b)	(2005,"Philips MR Imaging DD 005",2b)	Philips MR Imaging DD 005	8197	43	f	\N	CS	1	Exam Export Status	\N
7227	(2005,"PHILIPS MR IMAGING DD 001",2c)	(2005,"PHILIPS MR IMAGING DD 001",2c)	PHILIPS MR IMAGING DD 001	8197	44	f	\N	CS	1	Phase Encode Reordering	\N
7228	(2005,"Philips MR Imaging DD 001",2c)	(2005,"Philips MR Imaging DD 001",2c)	Philips MR Imaging DD 001	8197	44	f	\N	CS	1	Phase Encode Reordering	\N
7229	(2005,"Philips MR Imaging DD 005",2c)	(2005,"Philips MR Imaging DD 005",2c)	Philips MR Imaging DD 005	8197	44	f	\N	CS	1	Exam Storage Commit Status	\N
7230	(2005,"Philips MR Imaging DD 005",2d)	(2005,"Philips MR Imaging DD 005",2d)	Philips MR Imaging DD 005	8197	45	f	\N	CS	1	Exam Media Write Status	\N
7231	(2005,"PHILIPS MR IMAGING DD 001",2e)	(2005,"PHILIPS MR IMAGING DD 001",2e)	PHILIPS MR IMAGING DD 001	8197	46	f	\N	CS	1	PPG PPU Gating	\N
7232	(2005,"Philips MR Imaging DD 001",2e)	(2005,"Philips MR Imaging DD 001",2e)	Philips MR Imaging DD 001	8197	46	f	\N	CS	1	PPG PPU Gating	\N
7233	(2005,"Philips MR Imaging DD 005",2e)	(2005,"Philips MR Imaging DD 005",2e)	Philips MR Imaging DD 005	8197	46	f	\N	FL	1	dBdt	\N
7234	(2005,"PHILIPS MR IMAGING DD 001",2f)	(2005,"PHILIPS MR IMAGING DD 001",2f)	PHILIPS MR IMAGING DD 001	8197	47	f	\N	CS	1	Spatial Presaturation	\N
7235	(2005,"Philips MR Imaging DD 001",2f)	(2005,"Philips MR Imaging DD 001",2f)	Philips MR Imaging DD 001	8197	47	f	\N	CS	1	Spatial Presaturation	\N
7236	(2005,"Philips MR Imaging DD 005",2f)	(2005,"Philips MR Imaging DD 005",2f)	Philips MR Imaging DD 005	8197	47	f	\N	FL	1	Proton SAR	\N
7237	(2005,"PHILIPS MR IMAGING DD 001",30)	(2005,"PHILIPS MR IMAGING DD 001",30)	PHILIPS MR IMAGING DD 001	8197	48	f	\N	FL	1-n	Repetition Time	\N
7238	(2005,"Philips MR Imaging DD 001",30)	(2005,"Philips MR Imaging DD 001",30)	Philips MR Imaging DD 001	8197	48	f	\N	FL	1-n	Repetition Time	\N
7239	(2005,"Philips MR Imaging DD 004",30)	(2005,"Philips MR Imaging DD 004",30)	Philips MR Imaging DD 004	8197	48	f	\N	CS	1-n	InPlane Transforms	\N
7240	(2005,"Philips MR Imaging DD 005",30)	(2005,"Philips MR Imaging DD 005",30)	Philips MR Imaging DD 005	8197	48	f	\N	FL	1	Non Proton SAR	\N
7241	(2005,"PHILIPS MR IMAGING DD 001",31)	(2005,"PHILIPS MR IMAGING DD 001",31)	PHILIPS MR IMAGING DD 001	8197	49	f	\N	CS	1	Respiratory Gating	\N
7242	(2005,"Philips MR Imaging DD 001",31)	(2005,"Philips MR Imaging DD 001",31)	Philips MR Imaging DD 001	8197	49	f	\N	CS	1	Respiratory Gating	\N
7243	(2005,"Philips MR Imaging DD 004",31)	(2005,"Philips MR Imaging DD 004",31)	Philips MR Imaging DD 004	8197	49	f	\N	SS	1	Number of Spectra Acquired	\N
7244	(2005,"Philips MR Imaging DD 005",31)	(2005,"Philips MR Imaging DD 005",31)	Philips MR Imaging DD 005	8197	49	f	\N	FL	1	Local SAR	\N
7245	(2005,"Philips MR Imaging DD 002",32)	(2005,"Philips MR Imaging DD 002",32)	Philips MR Imaging DD 002	8197	50	f	\N	SQ	1	Blob Data Object Array	\N
7246	(2005,"Philips MR Imaging DD 005",32)	(2005,"Philips MR Imaging DD 005",32)	Philips MR Imaging DD 005	8197	50	f	\N	CS	1	Safety Override Mode	\N
7247	(2005,"Philips MR Imaging DD 004",33)	(2005,"Philips MR Imaging DD 004",33)	Philips MR Imaging DD 004	8197	51	f	\N	FL	1	Phase Encoding Echo Top Positions	\N
7248	(2005,"Philips MR Imaging DD 005",33)	(2005,"Philips MR Imaging DD 005",33)	Philips MR Imaging DD 005	8197	51	f	\N	DT	1	EV DVD Job In Params Datetime	\N
7249	(2005,"PHILIPS MR IMAGING DD 001",34)	(2005,"PHILIPS MR IMAGING DD 001",34)	PHILIPS MR IMAGING DD 001	8197	52	f	\N	CS	1	Segmented KSpace	\N
7250	(2005,"Philips MR Imaging DD 001",34)	(2005,"Philips MR Imaging DD 001",34)	Philips MR Imaging DD 001	8197	52	f	\N	CS	1	Segmented KSpace	\N
7251	(2005,"Philips MR Imaging DD 002",34)	(2005,"Philips MR Imaging DD 002",34)	Philips MR Imaging DD 002	8197	52	f	\N	LT	1	Series Transaction UID	\N
7252	(2005,"Philips MR Imaging DD 003",34)	(2005,"Philips MR Imaging DD 003",34)	Philips MR Imaging DD 003	8197	52	f	\N	SL	1	Number of Image Per Series Ref	\N
7253	(2005,"Philips MR Imaging DD 004",34)	(2005,"Philips MR Imaging DD 004",34)	Philips MR Imaging DD 004	8197	52	f	\N	CS	1	Physical Quantity for Chemical Shift	\N
7254	(2005,"Philips MR Imaging DD 005",34)	(2005,"Philips MR Imaging DD 005",34)	Philips MR Imaging DD 005	8197	52	f	\N	DT	1	DVD Job In Params Volume Label	\N
7255	(2005,"Philips MR Imaging DD 002",35)	(2005,"Philips MR Imaging DD 002",35)	Philips MR Imaging DD 002	8197	53	f	\N	IS	1	Parent ID	\N
7256	(2005,"Philips MR Imaging DD 004",35)	(2005,"Philips MR Imaging DD 004",35)	Philips MR Imaging DD 004	8197	53	f	\N	CS	1	Physical Quantity Spatial	\N
7257	(2005,"Philips MR Imaging DD 005",35)	(2005,"Philips MR Imaging DD 005",35)	Philips MR Imaging DD 005	8197	53	f	\N	CS	1	Spectro Examcard	\N
7258	(2005,"Philips MR Imaging DD 002",36)	(2005,"Philips MR Imaging DD 002",36)	Philips MR Imaging DD 002	8197	54	f	\N	LO	1	Parent Type	\N
7259	(2005,"Philips MR Imaging DD 004",36)	(2005,"Philips MR Imaging DD 004",36)	Philips MR Imaging DD 004	8197	54	f	\N	FL	1	Reference Frequency	\N
7260	(2005,"Philips MR Imaging DD 005",36)	(2005,"Philips MR Imaging DD 005",36)	Philips MR Imaging DD 005	8197	54	f	\N	UI	1	Referenced Series Instance UID	\N
7261	(2005,"PHILIPS MR IMAGING DD 001",37)	(2005,"PHILIPS MR IMAGING DD 001",37)	PHILIPS MR IMAGING DD 001	8197	55	f	\N	CS	1	Is Spectro	\N
7262	(2005,"Philips MR Imaging DD 001",37)	(2005,"Philips MR Imaging DD 001",37)	Philips MR Imaging DD 001	8197	55	f	\N	CS	1	Is Spectro	\N
7263	(2005,"Philips MR Imaging DD 002",37)	(2005,"Philips MR Imaging DD 002",37)	Philips MR Imaging DD 002	8197	55	f	\N	LO	1	Blob Name	\N
7264	(2005,"Philips MR Imaging DD 004",37)	(2005,"Philips MR Imaging DD 004",37)	Philips MR Imaging DD 004	8197	55	f	\N	FL	1	Sample Offset	\N
7265	(2005,"Philips MR Imaging DD 005",37)	(2005,"Philips MR Imaging DD 005",37)	Philips MR Imaging DD 005	8197	55	f	\N	CS	1	Color LUT Type	\N
7266	(2005,"PHILIPS MR IMAGING DD 001",38)	(2005,"PHILIPS MR IMAGING DD 001",38)	PHILIPS MR IMAGING DD 001	8197	56	f	\N	CS	1	Spoiled	\N
7267	(2005,"Philips MR Imaging DD 001",38)	(2005,"Philips MR Imaging DD 001",38)	Philips MR Imaging DD 001	8197	56	f	\N	CS	1	Spoiled	\N
7268	(2005,"Philips MR Imaging DD 002",38)	(2005,"Philips MR Imaging DD 002",38)	Philips MR Imaging DD 002	8197	56	f	\N	LO	1	Application Name	\N
7269	(2005,"Philips MR Imaging DD 004",38)	(2005,"Philips MR Imaging DD 004",38)	Philips MR Imaging DD 004	8197	56	f	\N	FL	1	Sample Pitch	\N
7270	(2005,"Philips MR Imaging DD 005",38)	(2005,"Philips MR Imaging DD 005",38)	Philips MR Imaging DD 005	8197	56	f	\N	LT	1	Unknown	\N
7271	(2005,"PHILIPS MR IMAGING DD 001",39)	(2005,"PHILIPS MR IMAGING DD 001",39)	PHILIPS MR IMAGING DD 001	8197	57	f	\N	CS	1	Steady State	\N
7272	(2005,"Philips MR Imaging DD 001",39)	(2005,"Philips MR Imaging DD 001",39)	Philips MR Imaging DD 001	8197	57	f	\N	CS	1	Steady State	\N
7273	(2005,"Philips MR Imaging DD 002",39)	(2005,"Philips MR Imaging DD 002",39)	Philips MR Imaging DD 002	8197	57	f	\N	LO	1	Type Name	\N
7274	(2005,"Philips MR Imaging DD 004",39)	(2005,"Philips MR Imaging DD 004",39)	Philips MR Imaging DD 004	8197	57	f	\N	SS	2	Search Interval for Peaks	\N
7275	(2005,"Philips MR Imaging DD 005",39)	(2005,"Philips MR Imaging DD 005",39)	Philips MR Imaging DD 005	8197	57	f	\N	LT	1	Unknown	\N
7276	(2005,"PHILIPS MR IMAGING DD 001",3a)	(2005,"PHILIPS MR IMAGING DD 001",3a)	PHILIPS MR IMAGING DD 001	8197	58	f	\N	SH	1	Sub Anatomy	\N
7277	(2005,"Philips MR Imaging DD 001",3a)	(2005,"Philips MR Imaging DD 001",3a)	Philips MR Imaging DD 001	8197	58	f	\N	SH	1	Sub Anatomy	\N
7278	(2005,"Philips MR Imaging DD 005",3a)	(2005,"Philips MR Imaging DD 005",3a)	Philips MR Imaging DD 005	8197	58	f	\N	LT	1	Data Dictionary Contents Version	\N
7279	(2005,"PHILIPS MR IMAGING DD 001",3b)	(2005,"PHILIPS MR IMAGING DD 001",3b)	PHILIPS MR IMAGING DD 001	8197	59	f	\N	CS	1	Time Reversed Steady State	\N
7280	(2005,"Philips MR Imaging DD 001",3b)	(2005,"Philips MR Imaging DD 001",3b)	Philips MR Imaging DD 001	8197	59	f	\N	CS	1	Time Reversed Steady State	\N
7281	(2005,"Philips MR Imaging DD 005",3b)	(2005,"Philips MR Imaging DD 005",3b)	Philips MR Imaging DD 005	8197	59	f	\N	CS	1	Is Coil Survey	\N
7282	(2005,"PHILIPS MR IMAGING DD 001",3c)	(2005,"PHILIPS MR IMAGING DD 001",3c)	PHILIPS MR IMAGING DD 001	8197	60	f	\N	CS	1	Tilt Optimized Nonsaturated Excitation	\N
7283	(2005,"Philips MR Imaging DD 001",3c)	(2005,"Philips MR Imaging DD 001",3c)	Philips MR Imaging DD 001	8197	60	f	\N	CS	1	Tilt Optimized Nonsaturated Excitation	\N
7284	(2005,"Philips MR Imaging DD 005",3c)	(2005,"Philips MR Imaging DD 005",3c)	Philips MR Imaging DD 005	8197	60	f	\N	FL	1	Stack Table Position Longitudinal	\N
7285	(2005,"PHILIPS MR IMAGING DD 001",3d)	(2005,"PHILIPS MR IMAGING DD 001",3d)	PHILIPS MR IMAGING DD 001	8197	61	f	\N	SS	1	Number of RR Interval Ranges	\N
7286	(2005,"Philips MR Imaging DD 001",3d)	(2005,"Philips MR Imaging DD 001",3d)	Philips MR Imaging DD 001	8197	61	f	\N	SS	1	Number of RR Interval Ranges	\N
7287	(2005,"Philips MR Imaging DD 005",3d)	(2005,"Philips MR Imaging DD 005",3d)	Philips MR Imaging DD 005	8197	61	f	\N	FL	1	Stack Table Position Lateral	\N
7288	(2005,"PHILIPS MR IMAGING DD 001",3e)	(2005,"PHILIPS MR IMAGING DD 001",3e)	PHILIPS MR IMAGING DD 001	8197	62	f	\N	SL	1-n	RR Intervals Distribution	\N
7289	(2005,"Philips MR Imaging DD 001",3e)	(2005,"Philips MR Imaging DD 001",3e)	Philips MR Imaging DD 001	8197	62	f	\N	SL	1-n	RR Intervals Distribution	\N
7290	(2005,"Philips MR Imaging DD 005",3e)	(2005,"Philips MR Imaging DD 005",3e)	Philips MR Imaging DD 005	8197	62	f	\N	FL	1	Stack Posterior Coil Position	\N
7291	(2005,"PHILIPS MR IMAGING DD 001",3f)	(2005,"PHILIPS MR IMAGING DD 001",3f)	PHILIPS MR IMAGING DD 001	8197	63	f	\N	SL	1	PlanScan Acquisition Number	\N
7292	(2005,"Philips MR Imaging DD 001",3f)	(2005,"Philips MR Imaging DD 001",3f)	Philips MR Imaging DD 001	8197	63	f	\N	SL	1	PlanScan Acquisition Number	\N
7293	(2005,"Philips MR Imaging DD 005",3f)	(2005,"Philips MR Imaging DD 005",3f)	Philips MR Imaging DD 005	8197	63	f	\N	CS	1	Active Implantable Medical Device Limits Applied	\N
7294	(2005,"Philips MR Imaging DD 001",40)	(2005,"Philips MR Imaging DD 001",40)	Philips MR Imaging DD 001	8197	64	f	\N	SL	1-n	PlanScan Survey Chemical Shift Number	\N
7295	(2005,"Philips MR Imaging DD 002",40)	(2005,"Philips MR Imaging DD 002",40)	Philips MR Imaging DD 002	8197	64	f	\N	LO	1	Version String	\N
7296	(2005,"Philips MR Imaging DD 004",40)	(2005,"Philips MR Imaging DD 004",40)	Philips MR Imaging DD 004	8197	64	f	\N	CS	1	Signal Domain for Chemical Shift	\N
7297	(2005,"Philips MR Imaging DD 005",40)	(2005,"Philips MR Imaging DD 005",40)	Philips MR Imaging DD 005	8197	64	f	\N	FL	1	Active Implantable Medical Device Head SAR Limit	\N
7298	(2005,"Philips MR Imaging DD 001",41)	(2005,"Philips MR Imaging DD 001",41)	Philips MR Imaging DD 001	8197	65	f	\N	SL	1-n	PlanScan Survey Dynamic Scan Number	\N
7299	(2005,"Philips MR Imaging DD 002",41)	(2005,"Philips MR Imaging DD 002",41)	Philips MR Imaging DD 002	8197	65	f	\N	LO	1	Comment String	\N
7300	(2005,"Philips MR Imaging DD 004",41)	(2005,"Philips MR Imaging DD 004",41)	Philips MR Imaging DD 004	8197	65	f	\N	CS	1	Signal Domain Spatial	\N
7301	(2005,"Philips MR Imaging DD 005",41)	(2005,"Philips MR Imaging DD 005",41)	Philips MR Imaging DD 005	8197	65	f	\N	FL	1	Active Implantable Medical Device Whole Body SAR Limit	\N
7302	(2005,"Philips MR Imaging DD 001",42)	(2005,"Philips MR Imaging DD 001",42)	Philips MR Imaging DD 001	8197	66	f	\N	SL	1-n	PlanScan Survey Echo Number	\N
7303	(2005,"Philips MR Imaging DD 002",42)	(2005,"Philips MR Imaging DD 002",42)	Philips MR Imaging DD 002	8197	66	f	\N	CS	1	Blob In File	\N
7304	(2005,"Philips MR Imaging DD 004",42)	(2005,"Philips MR Imaging DD 004",42)	Philips MR Imaging DD 004	8197	66	f	\N	CS	1	Signal Type	\N
7305	(2005,"Philips MR Imaging DD 005",42)	(2005,"Philips MR Imaging DD 005",42)	Philips MR Imaging DD 005	8197	66	f	\N	FL	1	Active Implantable Medical Device B1 RMS Limit	\N
7306	(2005,"Philips MR Imaging DD 001",43)	(2005,"Philips MR Imaging DD 001",43)	Philips MR Imaging DD 001	8197	67	f	\N	CS	1-n	PlanScan Survey Image Type	\N
7307	(2005,"Philips MR Imaging DD 002",43)	(2005,"Philips MR Imaging DD 002",43)	Philips MR Imaging DD 002	8197	67	f	\N	SL	1	Actual Blob Size	\N
7308	(2005,"Philips MR Imaging DD 003",43)	(2005,"Philips MR Imaging DD 003",43)	Philips MR Imaging DD 003	8197	67	f	\N	SS	1	No Date of Last Calibration	\N
7309	(2005,"Philips MR Imaging DD 004",43)	(2005,"Philips MR Imaging DD 004",43)	Philips MR Imaging DD 004	8197	67	f	\N	CS	1	Spectro Additional Rotations	\N
7310	(2005,"Philips MR Imaging DD 005",43)	(2005,"Philips MR Imaging DD 005",43)	Philips MR Imaging DD 005	8197	67	f	\N	FL	1	Active Implantable Medical Device dbDt Limit	\N
7311	(2005,"Philips MR Imaging DD 001",44)	(2005,"Philips MR Imaging DD 001",44)	Philips MR Imaging DD 001	8197	68	f	\N	SL	1-n	PlanScan Survey Phase Number	\N
7312	(2005,"Philips MR Imaging DD 002",44)	(2005,"Philips MR Imaging DD 002",44)	Philips MR Imaging DD 002	8197	68	f	\N	OW	1	Blob Data	\N
7313	(2005,"Philips MR Imaging DD 003",44)	(2005,"Philips MR Imaging DD 003",44)	Philips MR Imaging DD 003	8197	68	f	\N	SS	1	No Time of Last Calibration	\N
7314	(2005,"Philips MR Imaging DD 004",44)	(2005,"Philips MR Imaging DD 004",44)	Philips MR Imaging DD 004	8197	68	f	\N	SS	1-n	Spectro Display Ranges	\N
7315	(2005,"Philips MR Imaging DD 005",44)	(2005,"Philips MR Imaging DD 005",44)	Philips MR Imaging DD 005	8197	68	f	\N	IS	1	TFE Factor	\N
7316	(2005,"Philips MR Imaging DD 001",45)	(2005,"Philips MR Imaging DD 001",45)	Philips MR Imaging DD 001	8197	69	f	\N	SL	1-n	PlanScan Survey Reconstruction Number	\N
7317	(2005,"Philips MR Imaging DD 002",45)	(2005,"Philips MR Imaging DD 002",45)	Philips MR Imaging DD 002	8197	69	f	\N	LO	1	Blob Filename	\N
7318	(2005,"Philips MR Imaging DD 003",45)	(2005,"Philips MR Imaging DD 003",45)	Philips MR Imaging DD 003	8197	69	f	\N	SS	1	Number of Software Version	\N
7319	(2005,"Philips MR Imaging DD 004",45)	(2005,"Philips MR Imaging DD 004",45)	Philips MR Imaging DD 004	8197	69	f	\N	CS	1	Spectro Echo Acquisition	\N
7320	(2005,"Philips MR Imaging DD 005",45)	(2005,"Philips MR Imaging DD 005",45)	Philips MR Imaging DD 005	8197	69	f	\N	CS	1	Attenuation Correction	\N
7321	(2005,"Philips MR Imaging DD 001",46)	(2005,"Philips MR Imaging DD 001",46)	Philips MR Imaging DD 001	8197	70	f	\N	CS	1-n	PlanScan Survey Scanning Sequence	\N
7322	(2005,"Philips MR Imaging DD 002",46)	(2005,"Philips MR Imaging DD 002",46)	Philips MR Imaging DD 002	8197	70	f	\N	SL	1	Blob Offset	\N
7323	(2005,"Philips MR Imaging DD 004",46)	(2005,"Philips MR Imaging DD 004",46)	Philips MR Imaging DD 004	8197	70	f	\N	CS	1	Spectro Frequency Unit	\N
7324	(2005,"Philips MR Imaging DD 005",46)	(2005,"Philips MR Imaging DD 005",46)	Philips MR Imaging DD 005	8197	70	f	\N	FL	1	FWHM Shim	\N
7325	(2005,"Philips MR Imaging DD 001",47)	(2005,"Philips MR Imaging DD 001",47)	Philips MR Imaging DD 001	8197	71	f	\N	SL	1-n	PlanScan Survey Slice Number	\N
7326	(2005,"Philips MR Imaging DD 002",47)	(2005,"Philips MR Imaging DD 002",47)	Philips MR Imaging DD 002	8197	71	f	\N	CS	1	Blob Flag	\N
7327	(2005,"Philips MR Imaging DD 003",47)	(2005,"Philips MR Imaging DD 003",47)	Philips MR Imaging DD 003	8197	71	f	\N	SS	1	Number of Patient Other Names	\N
7328	(2005,"Philips MR Imaging DD 004",47)	(2005,"Philips MR Imaging DD 004",47)	Philips MR Imaging DD 004	8197	71	f	\N	FL	1	Spectro Gamma	\N
7329	(2005,"Philips MR Imaging DD 005",47)	(2005,"Philips MR Imaging DD 005",47)	Philips MR Imaging DD 005	8197	71	f	\N	FL	1	Power Optimization	\N
7330	(2005,"PHILIPS MR IMAGING DD 001",48)	(2005,"PHILIPS MR IMAGING DD 001",48)	PHILIPS MR IMAGING DD 001	8197	72	f	\N	IS	1-n	Referenced Acquisition Number	\N
7331	(2005,"Philips MR Imaging DD 001",48)	(2005,"Philips MR Imaging DD 001",48)	Philips MR Imaging DD 001	8197	72	f	\N	IS	1-n	Referenced Acquisition Number	\N
7332	(2005,"Philips MR Imaging DD 003",48)	(2005,"Philips MR Imaging DD 003",48)	Philips MR Imaging DD 003	8197	72	f	\N	SS	1	Number of Req Recipe of Results	\N
7333	(2005,"Philips MR Imaging DD 004",48)	(2005,"Philips MR Imaging DD 004",48)	Philips MR Imaging DD 004	8197	72	f	\N	CS	1	Spectro Hidden Line Removal	\N
7334	(2005,"Philips MR Imaging DD 005",48)	(2005,"Philips MR Imaging DD 005",48)	Philips MR Imaging DD 005	8197	72	f	\N	FL	1	Coil Q	\N
7335	(2005,"PHILIPS MR IMAGING DD 001",49)	(2005,"PHILIPS MR IMAGING DD 001",49)	PHILIPS MR IMAGING DD 001	8197	73	f	\N	IS	1-n	Referenced Chemical Shift Number	\N
7336	(2005,"Philips MR Imaging DD 001",49)	(2005,"Philips MR Imaging DD 001",49)	Philips MR Imaging DD 001	8197	73	f	\N	IS	1-n	Referenced Chemical Shift Number	\N
7337	(2005,"Philips MR Imaging DD 003",49)	(2005,"Philips MR Imaging DD 003",49)	Philips MR Imaging DD 003	8197	73	f	\N	SS	1	Number of Series Operators Name	\N
7338	(2005,"Philips MR Imaging DD 004",49)	(2005,"Philips MR Imaging DD 004",49)	Philips MR Imaging DD 004	8197	73	f	\N	FL	1	Spectro Horizontal Shift	\N
7339	(2005,"Philips MR Imaging DD 005",49)	(2005,"Philips MR Imaging DD 005",49)	Philips MR Imaging DD 005	8197	73	f	\N	FL	1	Receiver Gain	\N
7340	(2005,"PHILIPS MR IMAGING DD 001",4a)	(2005,"PHILIPS MR IMAGING DD 001",4a)	PHILIPS MR IMAGING DD 001	8197	74	f	\N	IS	1-n	Referenced Dynamic Scan Number	\N
7341	(2005,"Philips MR Imaging DD 001",4a)	(2005,"Philips MR Imaging DD 001",4a)	Philips MR Imaging DD 001	8197	74	f	\N	IS	1-n	Referenced Dynamic Scan Number	\N
7342	(2005,"Philips MR Imaging DD 005",4a)	(2005,"Philips MR Imaging DD 005",4a)	Philips MR Imaging DD 005	8197	74	f	\N	FL	1	Data Window Duration	\N
7343	(2005,"PHILIPS MR IMAGING DD 001",4b)	(2005,"PHILIPS MR IMAGING DD 001",4b)	PHILIPS MR IMAGING DD 001	8197	75	f	\N	IS	1-n	Referenced Echo Number	\N
7344	(2005,"Philips MR Imaging DD 001",4b)	(2005,"Philips MR Imaging DD 001",4b)	Philips MR Imaging DD 001	8197	75	f	\N	IS	1-n	Referenced Echo Number	\N
7345	(2005,"Philips MR Imaging DD 005",4b)	(2005,"Philips MR Imaging DD 005",4b)	Philips MR Imaging DD 005	8197	75	f	\N	FL	1	Mixing Time	\N
7346	(2005,"PHILIPS MR IMAGING DD 001",4c)	(2005,"PHILIPS MR IMAGING DD 001",4c)	PHILIPS MR IMAGING DD 001	8197	76	f	\N	CS	1-n	Referenced Entity	\N
7347	(2005,"Philips MR Imaging DD 001",4c)	(2005,"Philips MR Imaging DD 001",4c)	Philips MR Imaging DD 001	8197	76	f	\N	CS	1-n	Referenced Entity	\N
7348	(2005,"Philips MR Imaging DD 005",4c)	(2005,"Philips MR Imaging DD 005",4c)	Philips MR Imaging DD 005	8197	76	f	\N	FL	1	First Echo Time	\N
7349	(2005,"PHILIPS MR IMAGING DD 001",4d)	(2005,"PHILIPS MR IMAGING DD 001",4d)	PHILIPS MR IMAGING DD 001	8197	77	f	\N	CS	1-n	Referenced Image Type	\N
7350	(2005,"Philips MR Imaging DD 001",4d)	(2005,"Philips MR Imaging DD 001",4d)	Philips MR Imaging DD 001	8197	77	f	\N	CS	1-n	Referenced Image Type	\N
7351	(2005,"Philips MR Imaging DD 005",4d)	(2005,"Philips MR Imaging DD 005",4d)	Philips MR Imaging DD 005	8197	77	f	\N	CS	1	Is B0 Series	\N
7352	(2005,"PHILIPS MR IMAGING DD 001",4e)	(2005,"PHILIPS MR IMAGING DD 001",4e)	PHILIPS MR IMAGING DD 001	8197	78	f	\N	FL	1-n	Slab FOV RL	\N
7353	(2005,"Philips MR Imaging DD 001",4e)	(2005,"Philips MR Imaging DD 001",4e)	Philips MR Imaging DD 001	8197	78	f	\N	FL	1-n	Slab FOV RL	\N
7354	(2005,"Philips MR Imaging DD 005",4e)	(2005,"Philips MR Imaging DD 005",4e)	Philips MR Imaging DD 005	8197	78	f	\N	CS	1	Is B1 Series	\N
7355	(2005,"PHILIPS MR IMAGING DD 001",4f)	(2005,"PHILIPS MR IMAGING DD 001",4f)	PHILIPS MR IMAGING DD 001	8197	79	f	\N	FL	1-n	Slab Offcentre AP	\N
7356	(2005,"Philips MR Imaging DD 001",4f)	(2005,"Philips MR Imaging DD 001",4f)	Philips MR Imaging DD 001	8197	79	f	\N	FL	1-n	Slab Offcentre AP	\N
7357	(2005,"Philips MR Imaging DD 005",4f)	(2005,"Philips MR Imaging DD 005",4f)	Philips MR Imaging DD 005	8197	79	f	\N	CS	1	Volume Select	\N
7358	(2005,"PHILIPS MR IMAGING DD 001",50)	(2005,"PHILIPS MR IMAGING DD 001",50)	PHILIPS MR IMAGING DD 001	8197	80	f	\N	FL	1-n	Slab Offcentre FH	\N
7359	(2005,"Philips MR Imaging DD 001",50)	(2005,"Philips MR Imaging DD 001",50)	Philips MR Imaging DD 001	8197	80	f	\N	FL	1-n	Slab Offcentre FH	\N
7360	(2005,"Philips MR Imaging DD 003",50)	(2005,"Philips MR Imaging DD 003",50)	Philips MR Imaging DD 003	8197	80	f	\N	SS	1	Number of Series Performing Physicians Name	\N
7361	(2005,"Philips MR Imaging DD 004",50)	(2005,"Philips MR Imaging DD 004",50)	Philips MR Imaging DD 004	8197	80	f	\N	FL	2	Spectro Horizontal Window	\N
7362	(2005,"Philips MR Imaging DD 005",50)	(2005,"Philips MR Imaging DD 005",50)	Philips MR Imaging DD 005	8197	80	f	\N	SS	1	Number of Patient Other IDs	\N
7363	(2005,"PHILIPS MR IMAGING DD 001",51)	(2005,"PHILIPS MR IMAGING DD 001",51)	PHILIPS MR IMAGING DD 001	8197	81	f	\N	FL	1-n	Slab Offcentre RL	\N
7364	(2005,"Philips MR Imaging DD 001",51)	(2005,"Philips MR Imaging DD 001",51)	Philips MR Imaging DD 001	8197	81	f	\N	FL	1-n	Slab Offcentre RL	\N
7365	(2005,"Philips MR Imaging DD 003",51)	(2005,"Philips MR Imaging DD 003",51)	Philips MR Imaging DD 003	8197	81	f	\N	SS	1	Number of Study Admitting Diagnostic Description	\N
7366	(2005,"Philips MR Imaging DD 004",51)	(2005,"Philips MR Imaging DD 004",51)	Philips MR Imaging DD 004	8197	81	f	\N	SS	1	Spectro Number of Display Ranges	\N
7367	(2005,"Philips MR Imaging DD 005",51)	(2005,"Philips MR Imaging DD 005",51)	Philips MR Imaging DD 005	8197	81	f	\N	IS	1	Original Series Number	\N
7368	(2005,"PHILIPS MR IMAGING DD 001",52)	(2005,"PHILIPS MR IMAGING DD 001",52)	PHILIPS MR IMAGING DD 001	8197	82	f	\N	CS	1-n	Slab Type	\N
7369	(2005,"Philips MR Imaging DD 001",52)	(2005,"Philips MR Imaging DD 001",52)	Philips MR Imaging DD 001	8197	82	f	\N	CS	1-n	Slab Type	\N
7370	(2005,"Philips MR Imaging DD 003",52)	(2005,"Philips MR Imaging DD 003",52)	Philips MR Imaging DD 003	8197	82	f	\N	SS	1	Number of Study Patient Contrast Allergies	\N
7371	(2005,"Philips MR Imaging DD 004",52)	(2005,"Philips MR Imaging DD 004",52)	Philips MR Imaging DD 004	8197	82	f	\N	SS	1	Spectro Number of Echo Pulses	\N
7372	(2005,"Philips MR Imaging DD 005",52)	(2005,"Philips MR Imaging DD 005",52)	Philips MR Imaging DD 005	8197	82	f	\N	UI	1	Original Series Instance UID	\N
7373	(2005,"PHILIPS MR IMAGING DD 001",53)	(2005,"PHILIPS MR IMAGING DD 001",53)	PHILIPS MR IMAGING DD 001	8197	83	f	\N	CS	1-n	Slab View Axis	\N
7374	(2005,"Philips MR Imaging DD 001",53)	(2005,"Philips MR Imaging DD 001",53)	Philips MR Imaging DD 001	8197	83	f	\N	CS	1-n	Slab View Axis	\N
7375	(2005,"Philips MR Imaging DD 003",53)	(2005,"Philips MR Imaging DD 003",53)	Philips MR Imaging DD 003	8197	83	f	\N	SS	1	Number of Study Patient Medical Alerts	\N
7376	(2005,"Philips MR Imaging DD 004",53)	(2005,"Philips MR Imaging DD 004",53)	Philips MR Imaging DD 004	8197	83	f	\N	LO	1-n	Spectro Processing History	\N
7377	(2005,"Philips MR Imaging DD 005",53)	(2005,"Philips MR Imaging DD 005",53)	Philips MR Imaging DD 005	8197	83	f	\N	CS	1	Split Series Job Params	\N
7378	(2005,"PHILIPS MR IMAGING DD 001",54)	(2005,"PHILIPS MR IMAGING DD 001",54)	PHILIPS MR IMAGING DD 001	8197	84	f	\N	FL	1-n	Volume Angulation AP	\N
7379	(2005,"Philips MR Imaging DD 001",54)	(2005,"Philips MR Imaging DD 001",54)	Philips MR Imaging DD 001	8197	84	f	\N	FL	1-n	Volume Angulation AP	\N
7380	(2005,"Philips MR Imaging DD 003",54)	(2005,"Philips MR Imaging DD 003",54)	Philips MR Imaging DD 003	8197	84	f	\N	SS	1	Number of Study Physicians of Record	\N
7381	(2005,"Philips MR Imaging DD 004",54)	(2005,"Philips MR Imaging DD 004",54)	Philips MR Imaging DD 004	8197	84	f	\N	CS	1	Spectro Scan Type	\N
7382	(2005,"Philips MR Imaging DD 005",54)	(2005,"Philips MR Imaging DD 005",54)	Philips MR Imaging DD 005	8197	84	f	\N	SS	1	Preferred Dimension for Splitting	\N
7383	(2005,"PHILIPS MR IMAGING DD 001",55)	(2005,"PHILIPS MR IMAGING DD 001",55)	PHILIPS MR IMAGING DD 001	8197	85	f	\N	FL	1-n	Volume Angulation FH	\N
7384	(2005,"Philips MR Imaging DD 001",55)	(2005,"Philips MR Imaging DD 001",55)	Philips MR Imaging DD 001	8197	85	f	\N	FL	1-n	Volume Angulation FH	\N
7385	(2005,"Philips MR Imaging DD 003",55)	(2005,"Philips MR Imaging DD 003",55)	Philips MR Imaging DD 003	8197	85	f	\N	SS	1	Number of Study Physicians Reading Study	\N
7386	(2005,"Philips MR Imaging DD 004",55)	(2005,"Philips MR Imaging DD 004",55)	Philips MR Imaging DD 004	8197	85	f	\N	FL	1-n	Spectro SI CS Intervals	\N
7387	(2005,"Philips MR Imaging DD 005",55)	(2005,"Philips MR Imaging DD 005",55)	Philips MR Imaging DD 005	8197	85	f	\N	FD	3	Velocity Encoding Direction	\N
7388	(2005,"PHILIPS MR IMAGING DD 001",56)	(2005,"PHILIPS MR IMAGING DD 001",56)	PHILIPS MR IMAGING DD 001	8197	86	f	\N	FL	1-n	Volume Angulation RL	\N
7389	(2005,"Philips MR Imaging DD 001",56)	(2005,"Philips MR Imaging DD 001",56)	Philips MR Imaging DD 001	8197	86	f	\N	FL	1-n	Volume Angulation RL	\N
7390	(2005,"Philips MR Imaging DD 003",56)	(2005,"Philips MR Imaging DD 003",56)	Philips MR Imaging DD 003	8197	86	f	\N	SS	1	Number of SC Software Versions	\N
7391	(2005,"Philips MR Imaging DD 004",56)	(2005,"Philips MR Imaging DD 004",56)	Philips MR Imaging DD 004	8197	86	f	\N	CS	1	Spectro SI Mode	\N
7392	(2005,"Philips MR Imaging DD 005",56)	(2005,"Philips MR Imaging DD 005",56)	Philips MR Imaging DD 005	8197	86	f	\N	SS	1	Contrast/Bolus Number of Injections	\N
7393	(2005,"PHILIPS MR IMAGING DD 001",57)	(2005,"PHILIPS MR IMAGING DD 001",57)	PHILIPS MR IMAGING DD 001	8197	87	f	\N	FL	1-n	Volume FOV AP	\N
7394	(2005,"Philips MR Imaging DD 001",57)	(2005,"Philips MR Imaging DD 001",57)	Philips MR Imaging DD 001	8197	87	f	\N	FL	1-n	Volume FOV AP	\N
7395	(2005,"Philips MR Imaging DD 003",57)	(2005,"Philips MR Imaging DD 003",57)	Philips MR Imaging DD 003	8197	87	f	\N	SS	1	Number of Running Attributes	\N
7396	(2005,"Philips MR Imaging DD 004",57)	(2005,"Philips MR Imaging DD 004",57)	Philips MR Imaging DD 004	8197	87	f	\N	SS	1	Spectro Spectral BW	\N
7397	(2005,"Philips MR Imaging DD 005",57)	(2005,"Philips MR Imaging DD 005",57)	Philips MR Imaging DD 005	8197	87	f	\N	LT	1	Contrast/Bolus Agent Code	\N
7398	(2005,"PHILIPS MR IMAGING DD 001",58)	(2005,"PHILIPS MR IMAGING DD 001",58)	PHILIPS MR IMAGING DD 001	8197	88	f	\N	FL	1-n	Volume FOV FH	\N
7399	(2005,"Philips MR Imaging DD 001",58)	(2005,"Philips MR Imaging DD 001",58)	Philips MR Imaging DD 001	8197	88	f	\N	FL	1-n	Volume FOV FH	\N
7400	(2005,"Philips MR Imaging DD 004",58)	(2005,"Philips MR Imaging DD 004",58)	Philips MR Imaging DD 004	8197	88	f	\N	LO	1	Spectro Title Line	\N
7401	(2005,"Philips MR Imaging DD 005",58)	(2005,"Philips MR Imaging DD 005",58)	Philips MR Imaging DD 005	8197	88	f	\N	LT	1	Contrast/Bolus Administration Route Code	\N
7402	(2005,"PHILIPS MR IMAGING DD 001",59)	(2005,"PHILIPS MR IMAGING DD 001",59)	PHILIPS MR IMAGING DD 001	8197	89	f	\N	FL	1-n	Volume FOV RL	\N
7403	(2005,"Philips MR Imaging DD 001",59)	(2005,"Philips MR Imaging DD 001",59)	Philips MR Imaging DD 001	8197	89	f	\N	FL	1-n	Volume FOV RL	\N
7404	(2005,"Philips MR Imaging DD 004",59)	(2005,"Philips MR Imaging DD 004",59)	Philips MR Imaging DD 004	8197	89	f	\N	FL	1	Spectro Turbo Echo Spacing	\N
7405	(2005,"Philips MR Imaging DD 005",59)	(2005,"Philips MR Imaging DD 005",59)	Philips MR Imaging DD 005	8197	89	f	\N	DS	1	Contrast/Bolus Volume	\N
7406	(2005,"PHILIPS MR IMAGING DD 001",5a)	(2005,"PHILIPS MR IMAGING DD 001",5a)	PHILIPS MR IMAGING DD 001	8197	90	f	\N	FL	1-n	Volume Offcentre AP	\N
7407	(2005,"Philips MR Imaging DD 001",5a)	(2005,"Philips MR Imaging DD 001",5a)	Philips MR Imaging DD 001	8197	90	f	\N	FL	1-n	Volume Offcentre AP	\N
7408	(2005,"Philips MR Imaging DD 005",5a)	(2005,"Philips MR Imaging DD 005",5a)	Philips MR Imaging DD 005	8197	90	f	\N	DS	1	Contrast/Bolus Ingredient Concentration	\N
7409	(2005,"PHILIPS MR IMAGING DD 001",5b)	(2005,"PHILIPS MR IMAGING DD 001",5b)	PHILIPS MR IMAGING DD 001	8197	91	f	\N	FL	1-n	Volume Offcentre FH	\N
7410	(2005,"Philips MR Imaging DD 001",5b)	(2005,"Philips MR Imaging DD 001",5b)	Philips MR Imaging DD 001	8197	91	f	\N	FL	1-n	Volume Offcentre FH	\N
7411	(2005,"Philips MR Imaging DD 005",5b)	(2005,"Philips MR Imaging DD 005",5b)	Philips MR Imaging DD 005	8197	91	f	\N	IS	1	Contrast/Bolus Dynamic Number	\N
7412	(2005,"PHILIPS MR IMAGING DD 001",5c)	(2005,"PHILIPS MR IMAGING DD 001",5c)	PHILIPS MR IMAGING DD 001	8197	92	f	\N	FL	1-n	Volume Offcentre RL	\N
7413	(2005,"Philips MR Imaging DD 001",5c)	(2005,"Philips MR Imaging DD 001",5c)	Philips MR Imaging DD 001	8197	92	f	\N	FL	1-n	Volume Offcentre RL	\N
7414	(2005,"Philips MR Imaging DD 005",5c)	(2005,"Philips MR Imaging DD 005",5c)	Philips MR Imaging DD 005	8197	92	f	\N	SQ	1	Contrast/Bolus Sequence	\N
7415	(2005,"PHILIPS MR IMAGING DD 001",5d)	(2005,"PHILIPS MR IMAGING DD 001",5d)	PHILIPS MR IMAGING DD 001	8197	93	f	\N	CS	1-n	Volume Type	\N
7416	(2005,"Philips MR Imaging DD 001",5d)	(2005,"Philips MR Imaging DD 001",5d)	Philips MR Imaging DD 001	8197	93	f	\N	CS	1-n	Volume Type	\N
7417	(2005,"Philips MR Imaging DD 005",5d)	(2005,"Philips MR Imaging DD 005",5d)	Philips MR Imaging DD 005	8197	93	f	\N	IS	1	Contrast/Bolus ID	\N
7418	(2005,"PHILIPS MR IMAGING DD 001",5e)	(2005,"PHILIPS MR IMAGING DD 001",5e)	PHILIPS MR IMAGING DD 001	8197	94	f	\N	CS	1	Volume View Axis	\N
7419	(2005,"Philips MR Imaging DD 001",5e)	(2005,"Philips MR Imaging DD 001",5e)	Philips MR Imaging DD 001	8197	94	f	\N	CS	1-n	Volume View Axis	\N
7420	(2005,"PHILIPS MR IMAGING DD 001",60)	(2005,"PHILIPS MR IMAGING DD 001",60)	PHILIPS MR IMAGING DD 001	8197	96	f	\N	IS	1	Study Sequence Number	\N
7421	(2005,"Philips MR Imaging DD 001",60)	(2005,"Philips MR Imaging DD 001",60)	Philips MR Imaging DD 001	8197	96	f	\N	IS	1	Study Sequence Number	\N
10538	(0009,"MMCPrivate",1d)	(0009,"MMCPrivate",1d)	MMCPrivate	9	29	f	\N	SH	1	IsAllowCascadeSave	X
7422	(2005,"Philips MR Imaging DD 004",60)	(2005,"Philips MR Imaging DD 004",60)	Philips MR Imaging DD 004	8197	96	f	\N	FL	1	Spectro Vertical Shift	\N
7423	(2005,"Philips MR Imaging DD 005",60)	(2005,"Philips MR Imaging DD 005",60)	Philips MR Imaging DD 005	8197	96	f	\N	CS	1	LUT to RGB Job Params	\N
7424	(2005,"PHILIPS MR IMAGING DD 001",61)	(2005,"PHILIPS MR IMAGING DD 001",61)	PHILIPS MR IMAGING DD 001	8197	97	f	\N	CS	1	Prepulse Type	\N
7425	(2005,"Philips MR Imaging DD 001",61)	(2005,"Philips MR Imaging DD 001",61)	Philips MR Imaging DD 001	8197	97	f	\N	CS	1	Prepulse Type	\N
7426	(2005,"Philips MR Imaging DD 004",61)	(2005,"Philips MR Imaging DD 004",61)	Philips MR Imaging DD 004	8197	97	f	\N	FL	2	Spectro Vertical Window	\N
7427	(2005,"Philips MR Imaging DD 004",62)	(2005,"Philips MR Imaging DD 004",62)	Philips MR Imaging DD 004	8197	98	f	\N	FL	1	Spectro Offset	\N
7428	(2005,"PHILIPS MR IMAGING DD 001",63)	(2005,"PHILIPS MR IMAGING DD 001",63)	PHILIPS MR IMAGING DD 001	8197	99	f	\N	SS	1	fMRI Status Indication	\N
7429	(2005,"Philips MR Imaging DD 001",63)	(2005,"Philips MR Imaging DD 001",63)	Philips MR Imaging DD 001	8197	99	f	\N	SS	1	fMRI Status Indication	\N
7430	(2005,"Philips MR Imaging DD 004",63)	(2005,"Philips MR Imaging DD 004",63)	Philips MR Imaging DD 004	8197	99	f	\N	FL	1	Spectrum Pitch	\N
7431	(2005,"PHILIPS MR IMAGING DD 001",64)	(2005,"PHILIPS MR IMAGING DD 001",64)	PHILIPS MR IMAGING DD 001	8197	100	f	\N	IS	1-n	Reference Phase Number	\N
7432	(2005,"Philips MR Imaging DD 001",64)	(2005,"Philips MR Imaging DD 001",64)	Philips MR Imaging DD 001	8197	100	f	\N	IS	1-n	Reference Phase Number	\N
7433	(2005,"Philips MR Imaging DD 004",64)	(2005,"Philips MR Imaging DD 004",64)	Philips MR Imaging DD 004	8197	100	f	\N	CS	1	Volume Selection	\N
7434	(2005,"PHILIPS MR IMAGING DD 001",65)	(2005,"PHILIPS MR IMAGING DD 001",65)	PHILIPS MR IMAGING DD 001	8197	101	f	\N	IS	1-n	Reference Reconstruction Number	\N
7435	(2005,"Philips MR Imaging DD 001",65)	(2005,"Philips MR Imaging DD 001",65)	Philips MR Imaging DD 001	8197	101	f	\N	IS	1-n	Reference Reconstruction Number	\N
7436	(2005,"PHILIPS MR IMAGING DD 001",66)	(2005,"PHILIPS MR IMAGING DD 001",66)	PHILIPS MR IMAGING DD 001	8197	102	f	\N	CS	1-n	Reference Scanning Sequence	\N
7437	(2005,"Philips MR Imaging DD 001",66)	(2005,"Philips MR Imaging DD 001",66)	Philips MR Imaging DD 001	8197	102	f	\N	CS	1-n	Reference Scanning Sequence	\N
7438	(2005,"PHILIPS MR IMAGING DD 001",67)	(2005,"PHILIPS MR IMAGING DD 001",67)	PHILIPS MR IMAGING DD 001	8197	103	f	\N	IS	1-n	Reference Slice Number	\N
7439	(2005,"Philips MR Imaging DD 001",67)	(2005,"Philips MR Imaging DD 001",67)	Philips MR Imaging DD 001	8197	103	f	\N	IS	1-n	Reference Slice Number	\N
7440	(2005,"PHILIPS MR IMAGING DD 001",68)	(2005,"PHILIPS MR IMAGING DD 001",68)	PHILIPS MR IMAGING DD 001	8197	104	f	\N	CS	1-n	Reference Type	\N
7441	(2005,"Philips MR Imaging DD 001",68)	(2005,"Philips MR Imaging DD 001",68)	Philips MR Imaging DD 001	8197	104	f	\N	CS	1-n	Reference Type	\N
7442	(2005,"PHILIPS MR IMAGING DD 001",69)	(2005,"PHILIPS MR IMAGING DD 001",69)	PHILIPS MR IMAGING DD 001	8197	105	f	\N	FL	1-n	Slab Angulation AP	\N
7443	(2005,"Philips MR Imaging DD 001",69)	(2005,"Philips MR Imaging DD 001",69)	Philips MR Imaging DD 001	8197	105	f	\N	FL	1-n	Slab Angulation AP	\N
7444	(2005,"PHILIPS MR IMAGING DD 001",6a)	(2005,"PHILIPS MR IMAGING DD 001",6a)	PHILIPS MR IMAGING DD 001	8197	106	f	\N	FL	1-n	Slab Angulation FH	\N
7445	(2005,"Philips MR Imaging DD 001",6a)	(2005,"Philips MR Imaging DD 001",6a)	Philips MR Imaging DD 001	8197	106	f	\N	FL	1-n	Slab Angulation FH	\N
7446	(2005,"PHILIPS MR IMAGING DD 001",6b)	(2005,"PHILIPS MR IMAGING DD 001",6b)	PHILIPS MR IMAGING DD 001	8197	107	f	\N	FL	1-n	Slab Angulation RL	\N
7447	(2005,"Philips MR Imaging DD 001",6b)	(2005,"Philips MR Imaging DD 001",6b)	Philips MR Imaging DD 001	8197	107	f	\N	FL	1-n	Slab Angulation RL	\N
7448	(2005,"PHILIPS MR IMAGING DD 001",6c)	(2005,"PHILIPS MR IMAGING DD 001",6c)	PHILIPS MR IMAGING DD 001	8197	108	f	\N	FL	1-n	Slab FOV AP	\N
7449	(2005,"Philips MR Imaging DD 001",6c)	(2005,"Philips MR Imaging DD 001",6c)	Philips MR Imaging DD 001	8197	108	f	\N	FL	1-n	Slab FOV AP	\N
7450	(2005,"PHILIPS MR IMAGING DD 001",6d)	(2005,"PHILIPS MR IMAGING DD 001",6d)	PHILIPS MR IMAGING DD 001	8197	109	f	\N	FL	1-n	Slab FOV FH	\N
7451	(2005,"Philips MR Imaging DD 001",6d)	(2005,"Philips MR Imaging DD 001",6d)	Philips MR Imaging DD 001	8197	109	f	\N	FL	1-n	Slab FOV FH	\N
7452	(2005,"PHILIPS MR IMAGING DD 001",6e)	(2005,"PHILIPS MR IMAGING DD 001",6e)	PHILIPS MR IMAGING DD 001	8197	110	f	\N	CS	1-n	Scanning Sequence	\N
7453	(2005,"Philips MR Imaging DD 001",6e)	(2005,"Philips MR Imaging DD 001",6e)	Philips MR Imaging DD 001	8197	110	f	\N	CS	1-n	Scanning Sequence	\N
7454	(2005,"PHILIPS MR IMAGING DD 001",6f)	(2005,"PHILIPS MR IMAGING DD 001",6f)	PHILIPS MR IMAGING DD 001	8197	111	f	\N	CS	1	Acquisition Type	\N
7455	(2005,"Philips MR Imaging DD 001",6f)	(2005,"Philips MR Imaging DD 001",6f)	Philips MR Imaging DD 001	8197	111	f	\N	CS	1	Acquisition Type	\N
7456	(2005,"PHILIPS MR IMAGING DD 001",70)	(2005,"PHILIPS MR IMAGING DD 001",70)	PHILIPS MR IMAGING DD 001	8197	112	f	\N	LO	1	Hardcopy Protocol EasyVision	\N
7457	(2005,"Philips MR Imaging DD 001",70)	(2005,"Philips MR Imaging DD 001",70)	Philips MR Imaging DD 001	8197	112	f	\N	LO	1	Hardcopy Protocol EasyVision	\N
7458	(2005,"Philips MR Imaging DD 003",70)	(2005,"Philips MR Imaging DD 003",70)	Philips MR Imaging DD 003	8197	112	f	\N	OW	1	Spectrum Pixel Data	\N
7459	(2005,"Philips MR Imaging DD 004",70)	(2005,"Philips MR Imaging DD 004",70)	Philips MR Imaging DD 004	8197	112	f	\N	SS	1	Number Mixes Spectro	\N
7460	(2005,"PHILIPS MR IMAGING DD 001",71)	(2005,"PHILIPS MR IMAGING DD 001",71)	PHILIPS MR IMAGING DD 001	8197	113	f	\N	FL	1-n	Stack Angulation AP	\N
7461	(2005,"Philips MR Imaging DD 001",71)	(2005,"Philips MR Imaging DD 001",71)	Philips MR Imaging DD 001	8197	113	f	\N	FL	1-n	Stack Angulation AP	\N
7462	(2005,"Philips MR Imaging DD 004",71)	(2005,"Philips MR Imaging DD 004",71)	Philips MR Imaging DD 004	8197	113	f	\N	SQ	1	Series SP Mix	\N
7463	(2005,"PHILIPS MR IMAGING DD 001",72)	(2005,"PHILIPS MR IMAGING DD 001",72)	PHILIPS MR IMAGING DD 001	8197	114	f	\N	FL	1-n	Stack Angulation FH	\N
7464	(2005,"Philips MR Imaging DD 001",72)	(2005,"Philips MR Imaging DD 001",72)	Philips MR Imaging DD 001	8197	114	f	\N	FL	1-n	Stack Angulation FH	\N
7465	(2005,"Philips MR Imaging DD 004",72)	(2005,"Philips MR Imaging DD 004",72)	Philips MR Imaging DD 004	8197	114	f	\N	SS	1-2	SP Mix T Resolution	\N
7466	(2005,"PHILIPS MR IMAGING DD 001",73)	(2005,"PHILIPS MR IMAGING DD 001",73)	PHILIPS MR IMAGING DD 001	8197	115	f	\N	FL	1-n	Stack Angulation RL	\N
7467	(2005,"Philips MR Imaging DD 001",73)	(2005,"Philips MR Imaging DD 001",73)	Philips MR Imaging DD 001	8197	115	f	\N	FL	1-n	Stack Angulation RL	\N
7468	(2005,"Philips MR Imaging DD 004",73)	(2005,"Philips MR Imaging DD 004",73)	Philips MR Imaging DD 004	8197	115	f	\N	SS	1-2	SP Mix KX Resolution	\N
7469	(2005,"PHILIPS MR IMAGING DD 001",74)	(2005,"PHILIPS MR IMAGING DD 001",74)	PHILIPS MR IMAGING DD 001	8197	116	f	\N	FL	1-n	Stack FOV AP	\N
7470	(2005,"Philips MR Imaging DD 001",74)	(2005,"Philips MR Imaging DD 001",74)	Philips MR Imaging DD 001	8197	116	f	\N	FL	1-n	Stack FOV AP	\N
7471	(2005,"Philips MR Imaging DD 004",74)	(2005,"Philips MR Imaging DD 004",74)	Philips MR Imaging DD 004	8197	116	f	\N	SS	1-2	SP Mix KY Resolution	\N
7472	(2005,"PHILIPS MR IMAGING DD 001",75)	(2005,"PHILIPS MR IMAGING DD 001",75)	PHILIPS MR IMAGING DD 001	8197	117	f	\N	FL	1-n	Stack FOV FH	\N
7473	(2005,"Philips MR Imaging DD 001",75)	(2005,"Philips MR Imaging DD 001",75)	Philips MR Imaging DD 001	8197	117	f	\N	FL	1-n	Stack FOV FH	\N
7474	(2005,"Philips MR Imaging DD 004",75)	(2005,"Philips MR Imaging DD 004",75)	Philips MR Imaging DD 004	8197	117	f	\N	SS	1-2	SP Mix F Resolution	\N
7475	(2005,"PHILIPS MR IMAGING DD 001",76)	(2005,"PHILIPS MR IMAGING DD 001",76)	PHILIPS MR IMAGING DD 001	8197	118	f	\N	FL	1-n	Stack FOV RL	\N
7476	(2005,"Philips MR Imaging DD 001",76)	(2005,"Philips MR Imaging DD 001",76)	Philips MR Imaging DD 001	8197	118	f	\N	FL	1-n	Stack FOV RL	\N
7477	(2005,"Philips MR Imaging DD 004",76)	(2005,"Philips MR Imaging DD 004",76)	Philips MR Imaging DD 004	8197	118	f	\N	SS	1-2	SP Mix X Resolution	\N
7478	(2005,"Philips MR Imaging DD 004",77)	(2005,"Philips MR Imaging DD 004",77)	Philips MR Imaging DD 004	8197	119	f	\N	SS	1-2	SP Mix Y Resolution	\N
7479	(2005,"PHILIPS MR IMAGING DD 001",78)	(2005,"PHILIPS MR IMAGING DD 001",78)	PHILIPS MR IMAGING DD 001	8197	120	f	\N	FL	1-n	Stack Offcentre AP	\N
7480	(2005,"Philips MR Imaging DD 001",78)	(2005,"Philips MR Imaging DD 001",78)	Philips MR Imaging DD 001	8197	120	f	\N	FL	1-n	Stack Offcentre AP	\N
7481	(2005,"Philips MR Imaging DD 004",78)	(2005,"Philips MR Imaging DD 004",78)	Philips MR Imaging DD 004	8197	120	f	\N	SS	1-2	SP Mix Number of Spectra Intended	\N
7482	(2005,"PHILIPS MR IMAGING DD 001",79)	(2005,"PHILIPS MR IMAGING DD 001",79)	PHILIPS MR IMAGING DD 001	8197	121	f	\N	FL	1-n	Stack Offcentre FH	\N
7483	(2005,"Philips MR Imaging DD 001",79)	(2005,"Philips MR Imaging DD 001",79)	Philips MR Imaging DD 001	8197	121	f	\N	FL	1-n	Stack Offcentre FH	\N
7484	(2005,"Philips MR Imaging DD 004",79)	(2005,"Philips MR Imaging DD 004",79)	Philips MR Imaging DD 004	8197	121	f	\N	SS	1-2	SP Mix Number of Averages	\N
7485	(2005,"PHILIPS MR IMAGING DD 001",7a)	(2005,"PHILIPS MR IMAGING DD 001",7a)	PHILIPS MR IMAGING DD 001	8197	122	f	\N	FL	1-n	Stack Offcentre RL	\N
7486	(2005,"Philips MR Imaging DD 001",7a)	(2005,"Philips MR Imaging DD 001",7a)	Philips MR Imaging DD 001	8197	122	f	\N	FL	1-n	Stack Offcentre RL	\N
7487	(2005,"PHILIPS MR IMAGING DD 001",7b)	(2005,"PHILIPS MR IMAGING DD 001",7b)	PHILIPS MR IMAGING DD 001	8197	123	f	\N	CS	1-n	Stack Preparation Direction	\N
7488	(2005,"Philips MR Imaging DD 001",7b)	(2005,"Philips MR Imaging DD 001",7b)	Philips MR Imaging DD 001	8197	123	f	\N	CS	1-n	Stack Preparation Direction	\N
7489	(2005,"PHILIPS MR IMAGING DD 001",7e)	(2005,"PHILIPS MR IMAGING DD 001",7e)	PHILIPS MR IMAGING DD 001	8197	126	f	\N	FL	1-n	Stack Slice Distance	\N
7490	(2005,"Philips MR Imaging DD 001",7e)	(2005,"Philips MR Imaging DD 001",7e)	Philips MR Imaging DD 001	8197	126	f	\N	FL	1-n	Stack Slice Distance	\N
7491	(2005,"PHILIPS MR IMAGING DD 001",80)	(2005,"PHILIPS MR IMAGING DD 001",80)	PHILIPS MR IMAGING DD 001	8197	128	f	\N	SQ	1	Series PlanScan	\N
7492	(2005,"Philips MR Imaging DD 001",80)	(2005,"Philips MR Imaging DD 001",80)	Philips MR Imaging DD 001	8197	128	f	\N	SQ	1	Series PlanScan	\N
7493	(2005,"Philips MR Imaging DD 004",80)	(2005,"Philips MR Imaging DD 004",80)	Philips MR Imaging DD 004	8197	128	f	\N	SL	1	Number of MF Image Objects	\N
7494	(2005,"PHILIPS MR IMAGING DD 001",81)	(2005,"PHILIPS MR IMAGING DD 001",81)	PHILIPS MR IMAGING DD 001	8197	129	f	\N	CS	1-n	Stack View Axis	\N
7495	(2005,"Philips MR Imaging DD 001",81)	(2005,"Philips MR Imaging DD 001",81)	Philips MR Imaging DD 001	8197	129	f	\N	CS	1-n	Stack View Axis	\N
7496	(2005,"Philips MR Imaging DD 003",81)	(2005,"Philips MR Imaging DD 003",81)	Philips MR Imaging DD 003	8197	129	f	\N	UI	1	Default Image UID	\N
7497	(2005,"Philips MR Imaging DD 004",81)	(2005,"Philips MR Imaging DD 004",81)	Philips MR Imaging DD 004	8197	129	f	\N	IS	1	ScanoGram Survey Number of Images	\N
7498	(2005,"Philips MR Imaging DD 003",82)	(2005,"Philips MR Imaging DD 003",82)	Philips MR Imaging DD 003	8197	130	f	\N	CS	1-n	Running Attributes	\N
7499	(2005,"Philips MR Imaging DD 004",82)	(2005,"Philips MR Imaging DD 004",82)	Philips MR Imaging DD 004	8197	130	f	\N	UL	1	Number of Procedure Codes	\N
7500	(2005,"Philips MR Imaging DD 004",83)	(2005,"Philips MR Imaging DD 004",83)	Philips MR Imaging DD 004	8197	131	f	\N	CS	1-n	Sort Attributes	\N
7501	(2005,"PHILIPS MR IMAGING DD 001",84)	(2005,"PHILIPS MR IMAGING DD 001",84)	PHILIPS MR IMAGING DD 001	8197	132	f	\N	SQ	1	Series Reference	\N
7502	(2005,"Philips MR Imaging DD 001",84)	(2005,"Philips MR Imaging DD 001",84)	Philips MR Imaging DD 001	8197	132	f	\N	SQ	1	Series Reference	\N
7503	(2005,"Philips MR Imaging DD 004",84)	(2005,"Philips MR Imaging DD 004",84)	Philips MR Imaging DD 004	8197	132	f	\N	SS	1	Number of Sort Attributes	\N
7504	(2005,"PHILIPS MR IMAGING DD 001",85)	(2005,"PHILIPS MR IMAGING DD 001",85)	PHILIPS MR IMAGING DD 001	8197	133	f	\N	SQ	1	Series Volume	\N
7505	(2005,"Philips MR Imaging DD 001",85)	(2005,"Philips MR Imaging DD 001",85)	Philips MR Imaging DD 001	8197	133	f	\N	SQ	1	Series Volume	\N
7506	(2005,"Philips MR Imaging DD 004",85)	(2005,"Philips MR Imaging DD 004",85)	Philips MR Imaging DD 004	8197	133	f	\N	CS	1	Image Display Direction	\N
7507	(2005,"PHILIPS MR IMAGING DD 001",86)	(2005,"PHILIPS MR IMAGING DD 001",86)	PHILIPS MR IMAGING DD 001	8197	134	f	\N	SS	1	Number of Geometry	\N
7508	(2005,"Philips MR Imaging DD 001",86)	(2005,"Philips MR Imaging DD 001",86)	Philips MR Imaging DD 001	8197	134	f	\N	SS	1	Number of Geometry	\N
7509	(2005,"Philips MR Imaging DD 004",86)	(2005,"Philips MR Imaging DD 004",86)	Philips MR Imaging DD 004	8197	134	f	\N	CS	1	Inset Scanogram	\N
7510	(2005,"Philips MR Imaging DD 001",87)	(2005,"Philips MR Imaging DD 001",87)	Philips MR Imaging DD 001	8197	135	f	\N	SL	1-n	Number of Geometry Slices	\N
7511	(2005,"Philips MR Imaging DD 004",87)	(2005,"Philips MR Imaging DD 004",87)	Philips MR Imaging DD 004	8197	135	f	\N	SS	1	Display Layout Number of Columns	\N
7512	(2005,"Philips MR Imaging DD 001",88)	(2005,"Philips MR Imaging DD 001",88)	Philips MR Imaging DD 001	8197	136	f	\N	FL	1-n	Geom Angulation AP	\N
7513	(2005,"Philips MR Imaging DD 004",88)	(2005,"Philips MR Imaging DD 004",88)	Philips MR Imaging DD 004	8197	136	f	\N	SS	1	Display Layout Number of Rows	\N
7514	(2005,"Philips MR Imaging DD 001",89)	(2005,"Philips MR Imaging DD 001",89)	Philips MR Imaging DD 001	8197	137	f	\N	FL	1-n	Geom Angulation FH	\N
7515	(2005,"Philips MR Imaging DD 004",89)	(2005,"Philips MR Imaging DD 004",89)	Philips MR Imaging DD 004	8197	137	f	\N	SQ	1	Viewing Protocol	\N
7516	(2005,"Philips MR Imaging DD 001",8a)	(2005,"Philips MR Imaging DD 001",8a)	Philips MR Imaging DD 001	8197	138	f	\N	FL	1-n	Geom Angulation RL	\N
7517	(2005,"Philips MR Imaging DD 001",8b)	(2005,"Philips MR Imaging DD 001",8b)	Philips MR Imaging DD 001	8197	139	f	\N	FL	1-n	Geom FOV AP	\N
7518	(2005,"Philips MR Imaging DD 001",8c)	(2005,"Philips MR Imaging DD 001",8c)	Philips MR Imaging DD 001	8197	140	f	\N	FL	1-n	Geom FOV FH	\N
7519	(2005,"Philips MR Imaging DD 001",8d)	(2005,"Philips MR Imaging DD 001",8d)	Philips MR Imaging DD 001	8197	141	f	\N	FL	1-n	Geom FOV RL	\N
7520	(2005,"Philips MR Imaging DD 001",8e)	(2005,"Philips MR Imaging DD 001",8e)	Philips MR Imaging DD 001	8197	142	f	\N	FL	1-n	Geom OffCentre AP	\N
7521	(2005,"Philips MR Imaging DD 001",8f)	(2005,"Philips MR Imaging DD 001",8f)	Philips MR Imaging DD 001	8197	143	f	\N	FL	1-n	Geom OffCentre FH	\N
7522	(2005,"Philips MR Imaging DD 001",90)	(2005,"Philips MR Imaging DD 001",90)	Philips MR Imaging DD 001	8197	144	f	\N	FL	1-n	Geom OffCentre RL	\N
7523	(2005,"Philips MR Imaging DD 004",90)	(2005,"Philips MR Imaging DD 004",90)	Philips MR Imaging DD 004	8197	144	f	\N	CS	1	Stack Coil Function	\N
7524	(2005,"Philips MR Imaging DD 005",90)	(2005,"Philips MR Imaging DD 005",90)	Philips MR Imaging DD 005	8197	144	f	\N	SQ	1	Original VOI LUT Sequence	\N
7525	(2005,"Philips MR Imaging DD 001",91)	(2005,"Philips MR Imaging DD 001",91)	Philips MR Imaging DD 001	8197	145	f	\N	CS	1-n	Geom Preparation Direct	\N
7526	(2005,"Philips MR Imaging DD 004",91)	(2005,"Philips MR Imaging DD 004",91)	Philips MR Imaging DD 004	8197	145	f	\N	PN	1	Patient Name Job In Params	\N
7527	(2005,"Philips MR Imaging DD 005",91)	(2005,"Philips MR Imaging DD 005",91)	Philips MR Imaging DD 005	8197	145	f	\N	SQ	1	Original Modality LUT Sequence	\N
7528	(2005,"Philips MR Imaging DD 001",92)	(2005,"Philips MR Imaging DD 001",92)	Philips MR Imaging DD 001	8197	146	f	\N	FL	1-n	Geom Radial Angle	\N
7529	(2005,"Philips MR Imaging DD 004",92)	(2005,"Philips MR Imaging DD 004",92)	Philips MR Imaging DD 004	8197	146	f	\N	IS	1	Geolink ID	\N
7530	(2005,"Philips MR Imaging DD 001",93)	(2005,"Philips MR Imaging DD 001",93)	Philips MR Imaging DD 001	8197	147	f	\N	CS	1-n	Geom Radial Axis	\N
7531	(2005,"Philips MR Imaging DD 004",93)	(2005,"Philips MR Imaging DD 004",93)	Philips MR Imaging DD 004	8197	147	f	\N	IS	1	Station Number	\N
7532	(2005,"Philips MR Imaging DD 001",94)	(2005,"Philips MR Imaging DD 001",94)	Philips MR Imaging DD 001	8197	148	f	\N	FL	1-n	Geom Slice Distance	\N
7533	(2005,"Philips MR Imaging DD 004",94)	(2005,"Philips MR Imaging DD 004",94)	Philips MR Imaging DD 004	8197	148	f	\N	CS	1-n	Processing History	\N
7534	(2005,"Philips MR Imaging DD 001",95)	(2005,"Philips MR Imaging DD 001",95)	Philips MR Imaging DD 001	8197	149	f	\N	SL	1-n	Geom Slice Number	\N
7535	(2005,"Philips MR Imaging DD 004",95)	(2005,"Philips MR Imaging DD 004",95)	Philips MR Imaging DD 004	8197	149	f	\N	UI	1	View Procedure String	\N
7536	(2005,"Philips MR Imaging DD 001",96)	(2005,"Philips MR Imaging DD 001",96)	Philips MR Imaging DD 001	8197	150	f	\N	CS	1-n	Geom Type	\N
7537	(2005,"Philips MR Imaging DD 004",96)	(2005,"Philips MR Imaging DD 004",96)	Philips MR Imaging DD 004	8197	150	f	\N	CS	1	Flow Images Present	\N
7538	(2005,"Philips MR Imaging DD 001",97)	(2005,"Philips MR Imaging DD 001",97)	Philips MR Imaging DD 001	8197	151	f	\N	CS	1-n	Geom ViewA xis	\N
7539	(2005,"Philips MR Imaging DD 004",97)	(2005,"Philips MR Imaging DD 004",97)	Philips MR Imaging DD 004	8197	151	f	\N	LO	1	Anatomic Region Code Value	\N
7540	(2005,"Philips MR Imaging DD 001",98)	(2005,"Philips MR Imaging DD 001",98)	Philips MR Imaging DD 001	8197	152	f	\N	CS	1-n	Geom Colour	\N
7541	(2005,"Philips MR Imaging DD 004",98)	(2005,"Philips MR Imaging DD 004",98)	Philips MR Imaging DD 004	8197	152	f	\N	CS	1	Mobiview Enabled	\N
7542	(2005,"Philips MR Imaging DD 001",99)	(2005,"Philips MR Imaging DD 001",99)	Philips MR Imaging DD 001	8197	153	f	\N	CS	1-n	Geom Application Type	\N
7543	(2005,"Philips MR Imaging DD 002",99)	(2005,"Philips MR Imaging DD 002",99)	Philips MR Imaging DD 002	8197	153	f	\N	UL	1	Number of Request Excerpts	\N
7544	(2005,"Philips MR Imaging DD 004",99)	(2005,"Philips MR Imaging DD 004",99)	Philips MR Imaging DD 004	8197	153	f	\N	CS	1	IViewBold Enabled	\N
7545	(2005,"Philips MR Imaging DD 001",9a)	(2005,"Philips MR Imaging DD 001",9a)	Philips MR Imaging DD 001	8197	154	f	\N	SL	1-n	Geom Id	\N
7546	(2005,"Philips MR Imaging DD 001",9b)	(2005,"Philips MR Imaging DD 001",9b)	Philips MR Imaging DD 001	8197	155	f	\N	SH	1-n	Geom Application Name	\N
7547	(2005,"Philips MR Imaging DD 001",9c)	(2005,"Philips MR Imaging DD 001",9c)	Philips MR Imaging DD 001	8197	156	f	\N	SH	1-n	Geom Label Name	\N
7548	(2005,"Philips MR Imaging DD 001",9d)	(2005,"Philips MR Imaging DD 001",9d)	Philips MR Imaging DD 001	8197	157	f	\N	CS	1-n	Geom Line Style	\N
7549	(2005,"PHILIPS MR IMAGING DD 001",9e)	(2005,"PHILIPS MR IMAGING DD 001",9e)	PHILIPS MR IMAGING DD 001	8197	158	f	\N	SQ	1	Series Geometry	\N
7550	(2005,"Philips MR Imaging DD 001",9e)	(2005,"Philips MR Imaging DD 001",9e)	Philips MR Imaging DD 001	8197	158	f	\N	SQ	1	Series Geometry	\N
7551	(2005,"PHILIPS MR IMAGING DD 001",9f)	(2005,"PHILIPS MR IMAGING DD 001",9f)	PHILIPS MR IMAGING DD 001	8197	159	f	\N	CS	1	Spectral Selective Excitation Pulse	\N
7552	(2005,"Philips MR Imaging DD 001",9f)	(2005,"Philips MR Imaging DD 001",9f)	Philips MR Imaging DD 001	8197	159	f	\N	CS	1	SeriesSpectral Selective Excitation Pulse	\N
7553	(2005,"PHILIPS MR IMAGING DD 001",a0)	(2005,"PHILIPS MR IMAGING DD 001",a0)	PHILIPS MR IMAGING DD 001	8197	160	f	\N	FL	1	Dynamic Scan Begin Time	\N
7554	(2005,"Philips MR Imaging DD 001",a0)	(2005,"Philips MR Imaging DD 001",a0)	Philips MR Imaging DD 001	8197	160	f	\N	FL	1	Dynamic Scan Begin Time	\N
7555	(2005,"PHILIPS MR IMAGING DD 001",a2)	(2005,"PHILIPS MR IMAGING DD 001",a2)	PHILIPS MR IMAGING DD 001	8197	162	f	\N	CS	1	Is COCA	\N
7556	(2005,"Philips MR Imaging DD 001",a2)	(2005,"Philips MR Imaging DD 001",a2)	Philips MR Imaging DD 001	8197	162	f	\N	CS	1	Is COCA	\N
7557	(2005,"PHILIPS MR IMAGING DD 001",a3)	(2005,"PHILIPS MR IMAGING DD 001",a3)	PHILIPS MR IMAGING DD 001	8197	163	f	\N	IS	1	Stack Coil ID	\N
7558	(2005,"Philips MR Imaging DD 001",a3)	(2005,"Philips MR Imaging DD 001",a3)	Philips MR Imaging DD 001	8197	163	f	\N	IS	1	Stack Coil ID	\N
7559	(2005,"PHILIPS MR IMAGING DD 001",a4)	(2005,"PHILIPS MR IMAGING DD 001",a4)	PHILIPS MR IMAGING DD 001	8197	164	f	\N	IS	1	Stack CBB Coil 1	\N
7560	(2005,"Philips MR Imaging DD 001",a4)	(2005,"Philips MR Imaging DD 001",a4)	Philips MR Imaging DD 001	8197	164	f	\N	IS	1	Stack CBB Coil 1	\N
7561	(2005,"PHILIPS MR IMAGING DD 001",a5)	(2005,"PHILIPS MR IMAGING DD 001",a5)	PHILIPS MR IMAGING DD 001	8197	165	f	\N	IS	1	Stack CBB Coil 2	\N
7562	(2005,"Philips MR Imaging DD 001",a5)	(2005,"Philips MR Imaging DD 001",a5)	Philips MR Imaging DD 001	8197	165	f	\N	IS	1	Stack CBB Coil 2	\N
7563	(2005,"PHILIPS MR IMAGING DD 001",a6)	(2005,"PHILIPS MR IMAGING DD 001",a6)	PHILIPS MR IMAGING DD 001	8197	166	f	\N	IS	1	Stack Channel Combination Bitmask	\N
7564	(2005,"Philips MR Imaging DD 001",a6)	(2005,"Philips MR Imaging DD 001",a6)	Philips MR Imaging DD 001	8197	166	f	\N	IS	1	Stack Channel Combination Bitmask	\N
7565	(2005,"PHILIPS MR IMAGING DD 001",a7)	(2005,"PHILIPS MR IMAGING DD 001",a7)	PHILIPS MR IMAGING DD 001	8197	167	f	\N	CS	1	Stack Coil Connection	\N
7566	(2005,"Philips MR Imaging DD 001",a7)	(2005,"Philips MR Imaging DD 001",a7)	Philips MR Imaging DD 001	8197	167	f	\N	CS	1	Stack Coil Connection	\N
7567	(2005,"PHILIPS MR IMAGING DD 001",a8)	(2005,"PHILIPS MR IMAGING DD 001",a8)	PHILIPS MR IMAGING DD 001	8197	168	f	\N	DS	1	Inversion Time	\N
7568	(2005,"Philips MR Imaging DD 001",a8)	(2005,"Philips MR Imaging DD 001",a8)	Philips MR Imaging DD 001	8197	168	f	\N	DS	1	Inversion Time	\N
7569	(2005,"PHILIPS MR IMAGING DD 001",a9)	(2005,"PHILIPS MR IMAGING DD 001",a9)	PHILIPS MR IMAGING DD 001	8197	169	f	\N	CS	1	Geometry Correction	\N
7570	(2005,"Philips MR Imaging DD 001",a9)	(2005,"Philips MR Imaging DD 001",a9)	Philips MR Imaging DD 001	8197	169	f	\N	CS	1	Geometry Correction	\N
7571	(2005,"PHILIPS MR IMAGING DD 001",b0)	(2005,"PHILIPS MR IMAGING DD 001",b0)	PHILIPS MR IMAGING DD 001	8197	176	f	\N	FL	1	Diffusion Direction RL	\N
7573	(2005,"PHILIPS MR IMAGING DD 001",b1)	(2005,"PHILIPS MR IMAGING DD 001",b1)	PHILIPS MR IMAGING DD 001	8197	177	f	\N	FL	1	Diffusion Direction AP	\N
7575	(2005,"PHILIPS MR IMAGING DD 001",b2)	(2005,"PHILIPS MR IMAGING DD 001",b2)	PHILIPS MR IMAGING DD 001	8197	178	f	\N	FL	1	Diffusion Direction FH	\N
7577	(2005,"PHILIPS MR IMAGING DD 001",c0)	(2005,"PHILIPS MR IMAGING DD 001",c0)	PHILIPS MR IMAGING DD 001	8197	192	f	\N	CS	1	Scan Sequence	\N
7578	(2005,"Philips MR Imaging DD 001",c0)	(2005,"Philips MR Imaging DD 001",c0)	Philips MR Imaging DD 001	8197	192	f	\N	CS	1	Scan Sequence	\N
7579	(2007,"Philips EV Imaging DD 022",00)	(2007,"Philips EV Imaging DD 022",00)	Philips EV Imaging DD 022	8199	0	f	\N	ST	1	Unknown	\N
7580	(200b,"Philips RAD Imaging DD 001",00)	(200b,"Philips RAD Imaging DD 001",00)	Philips RAD Imaging DD 001	8203	0	f	\N	PN	1	Unknown	\N
7581	(200b,"Philips RAD Imaging DD 097",00)	(200b,"Philips RAD Imaging DD 097",00)	Philips RAD Imaging DD 097	8203	0	f	\N	ST	1	Unknown	\N
7582	(200b,"Philips RAD Imaging DD 001",01)	(200b,"Philips RAD Imaging DD 001",01)	Philips RAD Imaging DD 001	8203	1	f	\N	US	1	Unknown	\N
7583	(200b,"Philips RAD Imaging DD 097",01)	(200b,"Philips RAD Imaging DD 097",01)	Philips RAD Imaging DD 097	8203	1	f	\N	CS	1	Unknown	\N
7584	(200b,"Philips RAD Imaging DD 001",02)	(200b,"Philips RAD Imaging DD 001",02)	Philips RAD Imaging DD 001	8203	2	f	\N	US	1	Unknown	\N
7585	(200b,"Philips RAD Imaging DD 097",02)	(200b,"Philips RAD Imaging DD 097",02)	Philips RAD Imaging DD 097	8203	2	f	\N	SS	1	Unknown	\N
7586	(200b,"Philips RAD Imaging DD 001",05)	(200b,"Philips RAD Imaging DD 001",05)	Philips RAD Imaging DD 001	8203	5	f	\N	IS	1	Unknown	\N
7587	(200b,"Philips RAD Imaging DD 001",11)	(200b,"Philips RAD Imaging DD 001",11)	Philips RAD Imaging DD 001	8203	17	f	\N	LO	1	Unknown	\N
7588	(200b,"Philips RAD Imaging DD 001",27)	(200b,"Philips RAD Imaging DD 001",27)	Philips RAD Imaging DD 001	8203	39	f	\N	DT	1	Unknown	\N
7589	(200b,"Philips RAD Imaging DD 001",28)	(200b,"Philips RAD Imaging DD 001",28)	Philips RAD Imaging DD 001	8203	40	f	\N	DS	1	Unknown	\N
7590	(200b,"Philips RAD Imaging DD 001",29)	(200b,"Philips RAD Imaging DD 001",29)	Philips RAD Imaging DD 001	8203	41	f	\N	DS	1	Unknown	\N
7591	(200b,"Philips RAD Imaging DD 001",2a)	(200b,"Philips RAD Imaging DD 001",2a)	Philips RAD Imaging DD 001	8203	42	f	\N	UL	1	Unknown	\N
7592	(200b,"Philips RAD Imaging DD 001",2b)	(200b,"Philips RAD Imaging DD 001",2b)	Philips RAD Imaging DD 001	8203	43	f	\N	DA	1	Unknown	\N
7593	(200b,"Philips RAD Imaging DD 001",2c)	(200b,"Philips RAD Imaging DD 001",2c)	Philips RAD Imaging DD 001	8203	44	f	\N	TM	1	Unknown	\N
7594	(200b,"Philips RAD Imaging DD 001",2d)	(200b,"Philips RAD Imaging DD 001",2d)	Philips RAD Imaging DD 001	8203	45	f	\N	LO	1	Unknown	\N
7595	(200b,"Philips RAD Imaging DD 001",3b)	(200b,"Philips RAD Imaging DD 001",3b)	Philips RAD Imaging DD 001	8203	59	f	\N	LO	1	Unknown	\N
7596	(200b,"Philips RAD Imaging DD 001",40)	(200b,"Philips RAD Imaging DD 001",40)	Philips RAD Imaging DD 001	8203	64	f	\N	SH	1	Unknown	\N
7597	(200b,"Philips RAD Imaging DD 001",41)	(200b,"Philips RAD Imaging DD 001",41)	Philips RAD Imaging DD 001	8203	65	f	\N	SH	1	Unknown	\N
7598	(200b,"Philips RAD Imaging DD 001",42)	(200b,"Philips RAD Imaging DD 001",42)	Philips RAD Imaging DD 001	8203	66	f	\N	UI	1	Unknown	\N
7599	(200b,"Philips RAD Imaging DD 001",43)	(200b,"Philips RAD Imaging DD 001",43)	Philips RAD Imaging DD 001	8203	67	f	\N	UI	1	Unknown	\N
7600	(200b,"Philips RAD Imaging DD 001",47)	(200b,"Philips RAD Imaging DD 001",47)	Philips RAD Imaging DD 001	8203	71	f	\N	DA	1	Unknown	\N
7601	(200b,"Philips RAD Imaging DD 001",48)	(200b,"Philips RAD Imaging DD 001",48)	Philips RAD Imaging DD 001	8203	72	f	\N	SH	1	Unknown	\N
7602	(200b,"Philips RAD Imaging DD 001",4c)	(200b,"Philips RAD Imaging DD 001",4c)	Philips RAD Imaging DD 001	8203	76	f	\N	SH	1	Unknown	\N
7603	(200b,"Philips RAD Imaging DD 001",4d)	(200b,"Philips RAD Imaging DD 001",4d)	Philips RAD Imaging DD 001	8203	77	f	\N	SH	1	Unknown	\N
7604	(200b,"Philips RAD Imaging DD 001",4f)	(200b,"Philips RAD Imaging DD 001",4f)	Philips RAD Imaging DD 001	8203	79	f	\N	DT	1	Unknown	\N
7605	(200b,"Philips RAD Imaging DD 097",50)	(200b,"Philips RAD Imaging DD 097",50)	Philips RAD Imaging DD 097	8203	80	f	\N	SS	1	Unknown	\N
7606	(200b,"Philips RAD Imaging DD 097",51)	(200b,"Philips RAD Imaging DD 097",51)	Philips RAD Imaging DD 097	8203	81	f	\N	SS	1	Unknown	\N
7607	(200b,"Philips RAD Imaging DD 001",52)	(200b,"Philips RAD Imaging DD 001",52)	Philips RAD Imaging DD 001	8203	82	f	\N	CS	1	Unknown	\N
7608	(200b,"Philips RAD Imaging DD 097",52)	(200b,"Philips RAD Imaging DD 097",52)	Philips RAD Imaging DD 097	8203	82	f	\N	SS	1	Unknown	\N
7609	(200b,"Philips RAD Imaging DD 097",53)	(200b,"Philips RAD Imaging DD 097",53)	Philips RAD Imaging DD 097	8203	83	f	\N	SS	1	Unknown	\N
7610	(200b,"Philips RAD Imaging DD 097",54)	(200b,"Philips RAD Imaging DD 097",54)	Philips RAD Imaging DD 097	8203	84	f	\N	ST	1	Unknown	\N
7611	(200b,"Philips RAD Imaging DD 097",60)	(200b,"Philips RAD Imaging DD 097",60)	Philips RAD Imaging DD 097	8203	96	f	\N	LT	1	Unknown	\N
7612	(200b,"Philips RAD Imaging DD 097",63)	(200b,"Philips RAD Imaging DD 097",63)	Philips RAD Imaging DD 097	8203	99	f	\N	LT	1	Unknown	\N
7613	(200b,"Philips RAD Imaging DD 097",65)	(200b,"Philips RAD Imaging DD 097",65)	Philips RAD Imaging DD 097	8203	101	f	\N	SS	1	Unknown	\N
7614	(200b,"Philips RAD Imaging DD 097",6e)	(200b,"Philips RAD Imaging DD 097",6e)	Philips RAD Imaging DD 097	8203	110	f	\N	US	1	Unknown	\N
7615	(200b,"Philips RAD Imaging DD 097",72)	(200b,"Philips RAD Imaging DD 097",72)	Philips RAD Imaging DD 097	8203	114	f	\N	FD	1	Unknown	\N
7616	(200b,"Philips RAD Imaging DD 097",73)	(200b,"Philips RAD Imaging DD 097",73)	Philips RAD Imaging DD 097	8203	115	f	\N	SS	1	Unknown	\N
7617	(200b,"Philips RAD Imaging DD 097",74)	(200b,"Philips RAD Imaging DD 097",74)	Philips RAD Imaging DD 097	8203	116	f	\N	IS	1	Unknown	\N
7618	(200b,"Philips RAD Imaging DD 097",75)	(200b,"Philips RAD Imaging DD 097",75)	Philips RAD Imaging DD 097	8203	117	f	\N	CS	1	Unknown	\N
7619	(200b,"Philips RAD Imaging DD 097",76)	(200b,"Philips RAD Imaging DD 097",76)	Philips RAD Imaging DD 097	8203	118	f	\N	SH	1	Unknown	\N
7620	(200b,"Philips RAD Imaging DD 097",78)	(200b,"Philips RAD Imaging DD 097",78)	Philips RAD Imaging DD 097	8203	120	f	\N	IS	1-n	Unknown	\N
7621	(200b,"Philips RAD Imaging DD 097",79)	(200b,"Philips RAD Imaging DD 097",79)	Philips RAD Imaging DD 097	8203	121	f	\N	IS	1	Unknown	\N
7622	(200b,"Philips RAD Imaging DD 097",7a)	(200b,"Philips RAD Imaging DD 097",7a)	Philips RAD Imaging DD 097	8203	122	f	\N	IS	1	Unknown	\N
7623	(200b,"Philips RAD Imaging DD 097",7b)	(200b,"Philips RAD Imaging DD 097",7b)	Philips RAD Imaging DD 097	8203	123	f	\N	US	1	Unknown	\N
7624	(200b,"Philips RAD Imaging DD 097",7c)	(200b,"Philips RAD Imaging DD 097",7c)	Philips RAD Imaging DD 097	8203	124	f	\N	US	1	Unknown	\N
7625	(200b,"Philips RAD Imaging DD 097",7d)	(200b,"Philips RAD Imaging DD 097",7d)	Philips RAD Imaging DD 097	8203	125	f	\N	IS	1-n	Unknown	\N
7626	(200b,"Philips RAD Imaging DD 097",7e)	(200b,"Philips RAD Imaging DD 097",7e)	Philips RAD Imaging DD 097	8203	126	f	\N	UI	1	Unknown	\N
7627	(200b,"Philips RAD Imaging DD 097",81)	(200b,"Philips RAD Imaging DD 097",81)	Philips RAD Imaging DD 097	8203	129	f	\N	LO	1	Unknown	\N
7628	(200b,"Philips RAD Imaging DD 097",82)	(200b,"Philips RAD Imaging DD 097",82)	Philips RAD Imaging DD 097	8203	130	f	\N	LO	1	Unknown	\N
7629	(200b,"Philips RAD Imaging DD 097",85)	(200b,"Philips RAD Imaging DD 097",85)	Philips RAD Imaging DD 097	8203	133	f	\N	IS	1	Unknown	\N
7630	(200b,"Philips RAD Imaging DD 097",86)	(200b,"Philips RAD Imaging DD 097",86)	Philips RAD Imaging DD 097	8203	134	f	\N	CS	1	Unknown	\N
7631	(200b,"Philips RAD Imaging DD 097",88)	(200b,"Philips RAD Imaging DD 097",88)	Philips RAD Imaging DD 097	8203	136	f	\N	CS	1	Unknown	\N
7632	(200b,"Philips RAD Imaging DD 097",89)	(200b,"Philips RAD Imaging DD 097",89)	Philips RAD Imaging DD 097	8203	137	f	\N	LT	1	Unknown	\N
7633	(200b,"Philips RAD Imaging DD 097",90)	(200b,"Philips RAD Imaging DD 097",90)	Philips RAD Imaging DD 097	8203	144	f	\N	DS	1	Unknown	\N
7634	(200b,"Philips RAD Imaging DD 097",96)	(200b,"Philips RAD Imaging DD 097",96)	Philips RAD Imaging DD 097	8203	150	f	\N	SH	1	Unknown	\N
7635	(200b,"Philips RAD Imaging DD 097",99)	(200b,"Philips RAD Imaging DD 097",99)	Philips RAD Imaging DD 097	8203	153	f	\N	SH	1	Unknown	\N
7636	(200b,"Philips RAD Imaging DD 097",9a)	(200b,"Philips RAD Imaging DD 097",9a)	Philips RAD Imaging DD 097	8203	154	f	\N	FD	1	Unknown	\N
7637	(200b,"Philips RAD Imaging DD 097",9b)	(200b,"Philips RAD Imaging DD 097",9b)	Philips RAD Imaging DD 097	8203	155	f	\N	FD	1	Unknown	\N
7638	(200b,"Philips RAD Imaging DD 097",a0)	(200b,"Philips RAD Imaging DD 097",a0)	Philips RAD Imaging DD 097	8203	160	f	\N	LT	1	Unknown	\N
7639	(200d,"Philips US Imaging DD 033",00)	(200d,"Philips US Imaging DD 033",00)	Philips US Imaging DD 033	8205	0	f	\N	OB	1	Unknown	\N
7640	(200d,"Philips US Imaging DD 066",00)	(200d,"Philips US Imaging DD 066",00)	Philips US Imaging DD 066	8205	0	f	\N	OB	1	Unknown	\N
7641	(200d,"Philips US Imaging DD 109",00)	(200d,"Philips US Imaging DD 109",00)	Philips US Imaging DD 109	8205	0	f	\N	US	1	Unknown	\N
7642	(200d,"Philips US Imaging DD 033",01)	(200d,"Philips US Imaging DD 033",01)	Philips US Imaging DD 033	8205	1	f	\N	LO	1	Unknown	\N
7643	(200d,"Philips US Imaging DD 034",01)	(200d,"Philips US Imaging DD 034",01)	Philips US Imaging DD 034	8205	1	f	\N	LO	1	Unknown	\N
7644	(200d,"Philips US Imaging DD 035",01)	(200d,"Philips US Imaging DD 035",01)	Philips US Imaging DD 035	8205	1	f	\N	LO	1	Unknown	\N
7645	(200d,"Philips US Imaging DD 038",01)	(200d,"Philips US Imaging DD 038",01)	Philips US Imaging DD 038	8205	1	f	\N	LO	1-n	Unknown	\N
7646	(200d,"Philips US Imaging DD 039",01)	(200d,"Philips US Imaging DD 039",01)	Philips US Imaging DD 039	8205	1	f	\N	LO	1	Unknown	\N
7647	(200d,"Philips US Imaging DD 040",01)	(200d,"Philips US Imaging DD 040",01)	Philips US Imaging DD 040	8205	1	f	\N	LO	1	Unknown	\N
7648	(200d,"Philips US Imaging DD 041",01)	(200d,"Philips US Imaging DD 041",01)	Philips US Imaging DD 041	8205	1	f	\N	LO	1	Unknown	\N
7649	(200d,"Philips US Imaging DD 048",01)	(200d,"Philips US Imaging DD 048",01)	Philips US Imaging DD 048	8205	1	f	\N	LO	1-n	Unknown	\N
10985	(0119,"MRSC",1212)	(0119,"MRSC",12)	MRSC	281	18	t	12	IS	1-n	SkeletonizeImage	K
7650	(200d,"Philips US Imaging DD 066",01)	(200d,"Philips US Imaging DD 066",01)	Philips US Imaging DD 066	8205	1	f	\N	LO	1	Unknown	\N
7651	(200d,"Philips US Imaging DD 109",01)	(200d,"Philips US Imaging DD 109",01)	Philips US Imaging DD 109	8205	1	f	\N	SQ	1	Unknown	\N
7652	(200d,"Philips US Imaging DD 113",01)	(200d,"Philips US Imaging DD 113",01)	Philips US Imaging DD 113	8205	1	f	\N	LO	1	Unknown	\N
7653	(200d,"Philips US Imaging DD 033",02)	(200d,"Philips US Imaging DD 033",02)	Philips US Imaging DD 033	8205	2	f	\N	LO	1	Unknown	\N
7654	(200d,"Philips US Imaging DD 034",02)	(200d,"Philips US Imaging DD 034",02)	Philips US Imaging DD 034	8205	2	f	\N	LO	1	Unknown	\N
7655	(200d,"Philips US Imaging DD 037",02)	(200d,"Philips US Imaging DD 037",02)	Philips US Imaging DD 037	8205	2	f	\N	IS	1	Unknown	\N
7656	(200d,"Philips US Imaging DD 038",02)	(200d,"Philips US Imaging DD 038",02)	Philips US Imaging DD 038	8205	2	f	\N	LO	1-n	Unknown	\N
7657	(200d,"Philips US Imaging DD 039",02)	(200d,"Philips US Imaging DD 039",02)	Philips US Imaging DD 039	8205	2	f	\N	LO	1	Unknown	\N
7658	(200d,"Philips US Imaging DD 040",02)	(200d,"Philips US Imaging DD 040",02)	Philips US Imaging DD 040	8205	2	f	\N	LO	1	Unknown	\N
7659	(200d,"Philips US Imaging DD 041",02)	(200d,"Philips US Imaging DD 041",02)	Philips US Imaging DD 041	8205	2	f	\N	LO	1	Unknown	\N
7660	(200d,"Philips US Imaging DD 066",02)	(200d,"Philips US Imaging DD 066",02)	Philips US Imaging DD 066	8205	2	f	\N	LO	1	Unknown	\N
7661	(200d,"Philips US Imaging DD 109",02)	(200d,"Philips US Imaging DD 109",02)	Philips US Imaging DD 109	8205	2	f	\N	ST	1	Unknown	\N
7662	(200d,"Philips US Imaging DD 113",02)	(200d,"Philips US Imaging DD 113",02)	Philips US Imaging DD 113	8205	2	f	\N	UL	1	Unknown	\N
7663	(200d,"Philips US Imaging DD 033",03)	(200d,"Philips US Imaging DD 033",03)	Philips US Imaging DD 033	8205	3	f	\N	LO	1-n	Unknown	\N
7664	(200d,"Philips US Imaging DD 034",03)	(200d,"Philips US Imaging DD 034",03)	Philips US Imaging DD 034	8205	3	f	\N	LO	1	Unknown	\N
7665	(200d,"Philips US Imaging DD 035",03)	(200d,"Philips US Imaging DD 035",03)	Philips US Imaging DD 035	8205	3	f	\N	LO	1	Unknown	\N
7666	(200d,"Philips US Imaging DD 037",03)	(200d,"Philips US Imaging DD 037",03)	Philips US Imaging DD 037	8205	3	f	\N	IS	1	Unknown	\N
7667	(200d,"Philips US Imaging DD 038",03)	(200d,"Philips US Imaging DD 038",03)	Philips US Imaging DD 038	8205	3	f	\N	LO	1-n	Unknown	\N
7668	(200d,"Philips US Imaging DD 039",03)	(200d,"Philips US Imaging DD 039",03)	Philips US Imaging DD 039	8205	3	f	\N	LO	1	Unknown	\N
7669	(200d,"Philips US Imaging DD 040",03)	(200d,"Philips US Imaging DD 040",03)	Philips US Imaging DD 040	8205	3	f	\N	LO	1	Unknown	\N
7670	(200d,"Philips US Imaging DD 041",03)	(200d,"Philips US Imaging DD 041",03)	Philips US Imaging DD 041	8205	3	f	\N	LO	1	Unknown	\N
7671	(200d,"Philips US Imaging DD 066",03)	(200d,"Philips US Imaging DD 066",03)	Philips US Imaging DD 066	8205	3	f	\N	LO	1	Unknown	\N
7672	(200d,"Philips US Imaging DD 109",03)	(200d,"Philips US Imaging DD 109",03)	Philips US Imaging DD 109	8205	3	f	\N	CS	1	Unknown	\N
7673	(200d,"Philips US Imaging DD 113",03)	(200d,"Philips US Imaging DD 113",03)	Philips US Imaging DD 113	8205	3	f	\N	UL	1	Unknown	\N
7674	(200d,"Philips US Imaging DD 033",04)	(200d,"Philips US Imaging DD 033",04)	Philips US Imaging DD 033	8205	4	f	\N	LO	1-n	Unknown	\N
7675	(200d,"Philips US Imaging DD 034",04)	(200d,"Philips US Imaging DD 034",04)	Philips US Imaging DD 034	8205	4	f	\N	LO	1	Unknown	\N
7676	(200d,"Philips US Imaging DD 035",04)	(200d,"Philips US Imaging DD 035",04)	Philips US Imaging DD 035	8205	4	f	\N	LO	1	Unknown	\N
7677	(200d,"Philips US Imaging DD 037",04)	(200d,"Philips US Imaging DD 037",04)	Philips US Imaging DD 037	8205	4	f	\N	IS	1	Unknown	\N
7678	(200d,"Philips US Imaging DD 038",04)	(200d,"Philips US Imaging DD 038",04)	Philips US Imaging DD 038	8205	4	f	\N	LO	1-n	Unknown	\N
7679	(200d,"Philips US Imaging DD 039",04)	(200d,"Philips US Imaging DD 039",04)	Philips US Imaging DD 039	8205	4	f	\N	LO	1	Unknown	\N
7680	(200d,"Philips US Imaging DD 040",04)	(200d,"Philips US Imaging DD 040",04)	Philips US Imaging DD 040	8205	4	f	\N	LO	1	Unknown	\N
7681	(200d,"Philips US Imaging DD 041",04)	(200d,"Philips US Imaging DD 041",04)	Philips US Imaging DD 041	8205	4	f	\N	LO	1	Unknown	\N
7682	(200d,"Philips US Imaging DD 066",04)	(200d,"Philips US Imaging DD 066",04)	Philips US Imaging DD 066	8205	4	f	\N	LO	1	Unknown	\N
7683	(200d,"Philips US Imaging DD 109",04)	(200d,"Philips US Imaging DD 109",04)	Philips US Imaging DD 109	8205	4	f	\N	SL	4	Unknown	\N
7684	(200d,"Philips US Imaging DD 113",04)	(200d,"Philips US Imaging DD 113",04)	Philips US Imaging DD 113	8205	4	f	\N	UL	1	Unknown	\N
7685	(200d,"Philips US Imaging DD 017",05)	(200d,"Philips US Imaging DD 017",05)	Philips US Imaging DD 017	8205	5	f	\N	LO	1	Unknown	\N
7686	(200d,"Philips US Imaging DD 033",05)	(200d,"Philips US Imaging DD 033",05)	Philips US Imaging DD 033	8205	5	f	\N	LO	1-n	Unknown	\N
7687	(200d,"Philips US Imaging DD 034",05)	(200d,"Philips US Imaging DD 034",05)	Philips US Imaging DD 034	8205	5	f	\N	LO	1	Unknown	\N
7688	(200d,"Philips US Imaging DD 039",05)	(200d,"Philips US Imaging DD 039",05)	Philips US Imaging DD 039	8205	5	f	\N	LO	1	Unknown	\N
7689	(200d,"Philips US Imaging DD 040",05)	(200d,"Philips US Imaging DD 040",05)	Philips US Imaging DD 040	8205	5	f	\N	LO	1	Unknown	\N
7690	(200d,"Philips US Imaging DD 043",05)	(200d,"Philips US Imaging DD 043",05)	Philips US Imaging DD 043	8205	5	f	\N	SH	1	Unknown	\N
7691	(200d,"Philips US Imaging DD 109",05)	(200d,"Philips US Imaging DD 109",05)	Philips US Imaging DD 109	8205	5	f	\N	UL	3	Unknown	\N
7692	(200d,"Philips US Imaging DD 113",05)	(200d,"Philips US Imaging DD 113",05)	Philips US Imaging DD 113	8205	5	f	\N	UL	1	Unknown	\N
7693	(200d,"Philips US Imaging DD 033",06)	(200d,"Philips US Imaging DD 033",06)	Philips US Imaging DD 033	8205	6	f	\N	LO	1-n	Unknown	\N
7694	(200d,"Philips US Imaging DD 037",06)	(200d,"Philips US Imaging DD 037",06)	Philips US Imaging DD 037	8205	6	f	\N	FD	1	Unknown	\N
7695	(200d,"Philips US Imaging DD 039",06)	(200d,"Philips US Imaging DD 039",06)	Philips US Imaging DD 039	8205	6	f	\N	LO	1	Unknown	\N
7696	(200d,"Philips US Imaging DD 040",06)	(200d,"Philips US Imaging DD 040",06)	Philips US Imaging DD 040	8205	6	f	\N	LO	1	Unknown	\N
7697	(200d,"Philips US Imaging DD 041",06)	(200d,"Philips US Imaging DD 041",06)	Philips US Imaging DD 041	8205	6	f	\N	LO	1	Unknown	\N
7698	(200d,"Philips US Imaging DD 109",06)	(200d,"Philips US Imaging DD 109",06)	Philips US Imaging DD 109	8205	6	f	\N	UL	3	Unknown	\N
7699	(200d,"Philips US Imaging DD 113",06)	(200d,"Philips US Imaging DD 113",06)	Philips US Imaging DD 113	8205	6	f	\N	UL	1	Unknown	\N
7700	(200d,"Philips US Imaging DD 021",07)	(200d,"Philips US Imaging DD 021",07)	Philips US Imaging DD 021	8205	7	f	\N	LO	1	Unknown	\N
7701	(200d,"Philips US Imaging DD 033",07)	(200d,"Philips US Imaging DD 033",07)	Philips US Imaging DD 033	8205	7	f	\N	LO	1	Unknown	\N
7702	(200d,"Philips US Imaging DD 035",07)	(200d,"Philips US Imaging DD 035",07)	Philips US Imaging DD 035	8205	7	f	\N	LO	1	Unknown	\N
7703	(200d,"Philips US Imaging DD 039",07)	(200d,"Philips US Imaging DD 039",07)	Philips US Imaging DD 039	8205	7	f	\N	LO	1	Unknown	\N
7704	(200d,"Philips US Imaging DD 040",07)	(200d,"Philips US Imaging DD 040",07)	Philips US Imaging DD 040	8205	7	f	\N	LO	1	Unknown	\N
7705	(200d,"Philips US Imaging DD 041",07)	(200d,"Philips US Imaging DD 041",07)	Philips US Imaging DD 041	8205	7	f	\N	LO	1	Unknown	\N
7706	(200d,"Philips US Imaging DD 065",07)	(200d,"Philips US Imaging DD 065",07)	Philips US Imaging DD 065	8205	7	f	\N	LO	1	Unknown	\N
7707	(200d,"Philips US Imaging DD 109",07)	(200d,"Philips US Imaging DD 109",07)	Philips US Imaging DD 109	8205	7	f	\N	CS	1	Unknown	\N
7708	(200d,"Philips US Imaging DD 113",07)	(200d,"Philips US Imaging DD 113",07)	Philips US Imaging DD 113	8205	7	f	\N	CS	1	Unknown	\N
7709	(200d,"Philips US Imaging DD 033",08)	(200d,"Philips US Imaging DD 033",08)	Philips US Imaging DD 033	8205	8	f	\N	LO	1	Unknown	\N
7710	(200d,"Philips US Imaging DD 034",08)	(200d,"Philips US Imaging DD 034",08)	Philips US Imaging DD 034	8205	8	f	\N	LO	1	Unknown	\N
7711	(200d,"Philips US Imaging DD 035",08)	(200d,"Philips US Imaging DD 035",08)	Philips US Imaging DD 035	8205	8	f	\N	LO	1	Unknown	\N
7712	(200d,"Philips US Imaging DD 037",08)	(200d,"Philips US Imaging DD 037",08)	Philips US Imaging DD 037	8205	8	f	\N	IS	1	Unknown	\N
7713	(200d,"Philips US Imaging DD 039",08)	(200d,"Philips US Imaging DD 039",08)	Philips US Imaging DD 039	8205	8	f	\N	LO	1	Unknown	\N
7714	(200d,"Philips US Imaging DD 041",08)	(200d,"Philips US Imaging DD 041",08)	Philips US Imaging DD 041	8205	8	f	\N	LO	1	Unknown	\N
7715	(200d,"Philips US Imaging DD 109",08)	(200d,"Philips US Imaging DD 109",08)	Philips US Imaging DD 109	8205	8	f	\N	CS	1	Unknown	\N
7716	(200d,"Philips US Imaging DD 113",08)	(200d,"Philips US Imaging DD 113",08)	Philips US Imaging DD 113	8205	8	f	\N	UL	1	Unknown	\N
7717	(200d,"Philips US Imaging DD 034",09)	(200d,"Philips US Imaging DD 034",09)	Philips US Imaging DD 034	8205	9	f	\N	LO	1	Unknown	\N
7718	(200d,"Philips US Imaging DD 035",09)	(200d,"Philips US Imaging DD 035",09)	Philips US Imaging DD 035	8205	9	f	\N	LO	1	Unknown	\N
7719	(200d,"Philips US Imaging DD 039",09)	(200d,"Philips US Imaging DD 039",09)	Philips US Imaging DD 039	8205	9	f	\N	LO	1	Unknown	\N
7720	(200d,"Philips US Imaging DD 041",09)	(200d,"Philips US Imaging DD 041",09)	Philips US Imaging DD 041	8205	9	f	\N	LO	1	Unknown	\N
7721	(200d,"Philips US Imaging DD 043",09)	(200d,"Philips US Imaging DD 043",09)	Philips US Imaging DD 043	8205	9	f	\N	IS	1	Unknown	\N
7722	(200d,"Philips US Imaging DD 109",09)	(200d,"Philips US Imaging DD 109",09)	Philips US Imaging DD 109	8205	9	f	\N	OB	1	Unknown	\N
7723	(200d,"Philips US Imaging DD 113",09)	(200d,"Philips US Imaging DD 113",09)	Philips US Imaging DD 113	8205	9	f	\N	UL	1	Unknown	\N
7724	(200d,"Philips US Imaging DD 034",0a)	(200d,"Philips US Imaging DD 034",0a)	Philips US Imaging DD 034	8205	10	f	\N	LO	1	Unknown	\N
7725	(200d,"Philips US Imaging DD 035",0a)	(200d,"Philips US Imaging DD 035",0a)	Philips US Imaging DD 035	8205	10	f	\N	LO	1	Unknown	\N
7726	(200d,"Philips US Imaging DD 037",0a)	(200d,"Philips US Imaging DD 037",0a)	Philips US Imaging DD 037	8205	10	f	\N	IS	1	Unknown	\N
7727	(200d,"Philips US Imaging DD 039",0a)	(200d,"Philips US Imaging DD 039",0a)	Philips US Imaging DD 039	8205	10	f	\N	LO	1	Unknown	\N
7728	(200d,"Philips US Imaging DD 043",0a)	(200d,"Philips US Imaging DD 043",0a)	Philips US Imaging DD 043	8205	10	f	\N	IS	1	Unknown	\N
7729	(200d,"Philips US Imaging DD 109",0a)	(200d,"Philips US Imaging DD 109",0a)	Philips US Imaging DD 109	8205	10	f	\N	UL	1	Unknown	\N
7730	(200d,"Philips US Imaging DD 113",0a)	(200d,"Philips US Imaging DD 113",0a)	Philips US Imaging DD 113	8205	10	f	\N	FD	1	Unknown	\N
7731	(200d,"Philips US Imaging DD 034",0b)	(200d,"Philips US Imaging DD 034",0b)	Philips US Imaging DD 034	8205	11	f	\N	LO	1	Unknown	\N
7732	(200d,"Philips US Imaging DD 037",0b)	(200d,"Philips US Imaging DD 037",0b)	Philips US Imaging DD 037	8205	11	f	\N	LO	1	Unknown	\N
7733	(200d,"Philips US Imaging DD 039",0b)	(200d,"Philips US Imaging DD 039",0b)	Philips US Imaging DD 039	8205	11	f	\N	LO	1	Unknown	\N
7734	(200d,"Philips US Imaging DD 043",0b)	(200d,"Philips US Imaging DD 043",0b)	Philips US Imaging DD 043	8205	11	f	\N	IS	1	Unknown	\N
7735	(200d,"Philips US Imaging DD 109",0b)	(200d,"Philips US Imaging DD 109",0b)	Philips US Imaging DD 109	8205	11	f	\N	OB	1	Unknown	\N
7736	(200d,"Philips US Imaging DD 113",0b)	(200d,"Philips US Imaging DD 113",0b)	Philips US Imaging DD 113	8205	11	f	\N	CS	1	Unknown	\N
7737	(200d,"Philips US Imaging DD 034",0c)	(200d,"Philips US Imaging DD 034",0c)	Philips US Imaging DD 034	8205	12	f	\N	LO	1	Unknown	\N
7738	(200d,"Philips US Imaging DD 035",0c)	(200d,"Philips US Imaging DD 035",0c)	Philips US Imaging DD 035	8205	12	f	\N	LO	1	Unknown	\N
7739	(200d,"Philips US Imaging DD 037",0c)	(200d,"Philips US Imaging DD 037",0c)	Philips US Imaging DD 037	8205	12	f	\N	IS	1	Unknown	\N
7740	(200d,"Philips US Imaging DD 039",0c)	(200d,"Philips US Imaging DD 039",0c)	Philips US Imaging DD 039	8205	12	f	\N	LO	1	Unknown	\N
7741	(200d,"Philips US Imaging DD 043",0c)	(200d,"Philips US Imaging DD 043",0c)	Philips US Imaging DD 043	8205	12	f	\N	IS	1	Unknown	\N
7742	(200d,"Philips US Imaging DD 109",0c)	(200d,"Philips US Imaging DD 109",0c)	Philips US Imaging DD 109	8205	12	f	\N	UL	1	Unknown	\N
7743	(200d,"Philips US Imaging DD 113",0c)	(200d,"Philips US Imaging DD 113",0c)	Philips US Imaging DD 113	8205	12	f	\N	UL	1	Unknown	\N
7744	(200d,"Philips US Imaging DD 033",0d)	(200d,"Philips US Imaging DD 033",0d)	Philips US Imaging DD 033	8205	13	f	\N	LO	1	Private Native Data Type	\N
7745	(200d,"Philips US Imaging DD 034",0d)	(200d,"Philips US Imaging DD 034",0d)	Philips US Imaging DD 034	8205	13	f	\N	LO	1	Unknown	\N
7746	(200d,"Philips US Imaging DD 035",0d)	(200d,"Philips US Imaging DD 035",0d)	Philips US Imaging DD 035	8205	13	f	\N	LO	1	Unknown	\N
7747	(200d,"Philips US Imaging DD 037",0d)	(200d,"Philips US Imaging DD 037",0d)	Philips US Imaging DD 037	8205	13	f	\N	IS	1	Unknown	\N
7748	(200d,"Philips US Imaging DD 039",0d)	(200d,"Philips US Imaging DD 039",0d)	Philips US Imaging DD 039	8205	13	f	\N	LO	1	Unknown	\N
7749	(200d,"Philips US Imaging DD 043",0d)	(200d,"Philips US Imaging DD 043",0d)	Philips US Imaging DD 043	8205	13	f	\N	IS	1	Unknown	\N
7750	(200d,"Philips US Imaging DD 109",0d)	(200d,"Philips US Imaging DD 109",0d)	Philips US Imaging DD 109	8205	13	f	\N	SQ	1	Unknown	\N
7751	(200d,"Philips US Imaging DD 113",0d)	(200d,"Philips US Imaging DD 113",0d)	Philips US Imaging DD 113	8205	13	f	\N	UL	1	Unknown	\N
7752	(200d,"Philips US Imaging DD 034",0e)	(200d,"Philips US Imaging DD 034",0e)	Philips US Imaging DD 034	8205	14	f	\N	LO	1	Unknown	\N
7753	(200d,"Philips US Imaging DD 037",0e)	(200d,"Philips US Imaging DD 037",0e)	Philips US Imaging DD 037	8205	14	f	\N	IS	1	Unknown	\N
7754	(200d,"Philips US Imaging DD 043",0e)	(200d,"Philips US Imaging DD 043",0e)	Philips US Imaging DD 043	8205	14	f	\N	IS	1	Unknown	\N
7755	(200d,"Philips US Imaging DD 109",0e)	(200d,"Philips US Imaging DD 109",0e)	Philips US Imaging DD 109	8205	14	f	\N	CS	1	Unknown	\N
7756	(200d,"Philips US Imaging DD 113",0e)	(200d,"Philips US Imaging DD 113",0e)	Philips US Imaging DD 113	8205	14	f	\N	UL	1	Unknown	\N
7757	(200d,"Philips US Imaging DD 033",0f)	(200d,"Philips US Imaging DD 033",0f)	Philips US Imaging DD 033	8205	15	f	\N	OB	1	Unknown	\N
7758	(200d,"Philips US Imaging DD 034",0f)	(200d,"Philips US Imaging DD 034",0f)	Philips US Imaging DD 034	8205	15	f	\N	LO	1	Unknown	\N
7759	(200d,"Philips US Imaging DD 037",0f)	(200d,"Philips US Imaging DD 037",0f)	Philips US Imaging DD 037	8205	15	f	\N	IS	1	Unknown	\N
7760	(200d,"Philips US Imaging DD 043",0f)	(200d,"Philips US Imaging DD 043",0f)	Philips US Imaging DD 043	8205	15	f	\N	IS	1	Unknown	\N
7761	(200d,"Philips US Imaging DD 109",0f)	(200d,"Philips US Imaging DD 109",0f)	Philips US Imaging DD 109	8205	15	f	\N	LO	1	Unknown	\N
7762	(200d,"Philips US Imaging DD 113",0f)	(200d,"Philips US Imaging DD 113",0f)	Philips US Imaging DD 113	8205	15	f	\N	DS	1	Unknown	\N
7763	(200d,"Philips US Imaging DD 033",10)	(200d,"Philips US Imaging DD 033",10)	Philips US Imaging DD 033	8205	16	f	\N	IS	1	Private Native Total Num Sample	\N
7764	(200d,"Philips US Imaging DD 034",10)	(200d,"Philips US Imaging DD 034",10)	Philips US Imaging DD 034	8205	16	f	\N	LO	1	Unknown	\N
7765	(200d,"Philips US Imaging DD 039",10)	(200d,"Philips US Imaging DD 039",10)	Philips US Imaging DD 039	8205	16	f	\N	LO	1-n	Unknown	\N
7766	(200d,"Philips US Imaging DD 041",10)	(200d,"Philips US Imaging DD 041",10)	Philips US Imaging DD 041	8205	16	f	\N	LO	1	Unknown	\N
7767	(200d,"Philips US Imaging DD 043",10)	(200d,"Philips US Imaging DD 043",10)	Philips US Imaging DD 043	8205	16	f	\N	IS	1	Unknown	\N
7768	(200d,"Philips US Imaging DD 109",10)	(200d,"Philips US Imaging DD 109",10)	Philips US Imaging DD 109	8205	16	f	\N	SL	1	Unknown	\N
7769	(200d,"Philips US Imaging DD 113",10)	(200d,"Philips US Imaging DD 113",10)	Philips US Imaging DD 113	8205	16	f	\N	DS	1	Unknown	\N
7770	(200d,"Philips US Imaging DD 033",11)	(200d,"Philips US Imaging DD 033",11)	Philips US Imaging DD 033	8205	17	f	\N	IS	1	Native Data Sample Size	\N
7771	(200d,"Philips US Imaging DD 034",11)	(200d,"Philips US Imaging DD 034",11)	Philips US Imaging DD 034	8205	17	f	\N	LO	1	Unknown	\N
7772	(200d,"Philips US Imaging DD 039",11)	(200d,"Philips US Imaging DD 039",11)	Philips US Imaging DD 039	8205	17	f	\N	LO	1-n	Unknown	\N
7773	(200d,"Philips US Imaging DD 041",11)	(200d,"Philips US Imaging DD 041",11)	Philips US Imaging DD 041	8205	17	f	\N	LO	1	Unknown	\N
7774	(200d,"Philips US Imaging DD 043",11)	(200d,"Philips US Imaging DD 043",11)	Philips US Imaging DD 043	8205	17	f	\N	IS	1	Unknown	\N
7775	(200d,"Philips US Imaging DD 109",11)	(200d,"Philips US Imaging DD 109",11)	Philips US Imaging DD 109	8205	17	f	\N	LO	1	Unknown	\N
7776	(200d,"Philips US Imaging DD 113",11)	(200d,"Philips US Imaging DD 113",11)	Philips US Imaging DD 113	8205	17	f	\N	SL	1	Unknown	\N
7777	(200d,"Philips US Imaging DD 034",12)	(200d,"Philips US Imaging DD 034",12)	Philips US Imaging DD 034	8205	18	f	\N	LO	1	Unknown	\N
7778	(200d,"Philips US Imaging DD 039",12)	(200d,"Philips US Imaging DD 039",12)	Philips US Imaging DD 039	8205	18	f	\N	LO	1-n	Unknown	\N
7779	(200d,"Philips US Imaging DD 041",12)	(200d,"Philips US Imaging DD 041",12)	Philips US Imaging DD 041	8205	18	f	\N	LO	1	Unknown	\N
7780	(200d,"Philips US Imaging DD 109",12)	(200d,"Philips US Imaging DD 109",12)	Philips US Imaging DD 109	8205	18	f	\N	SL	1	Unknown	\N
7781	(200d,"Philips US Imaging DD 113",12)	(200d,"Philips US Imaging DD 113",12)	Philips US Imaging DD 113	8205	18	f	\N	UL	1	Unknown	\N
7782	(200d,"Philips US Imaging DD 034",13)	(200d,"Philips US Imaging DD 034",13)	Philips US Imaging DD 034	8205	19	f	\N	LO	1	Unknown	\N
7783	(200d,"Philips US Imaging DD 039",13)	(200d,"Philips US Imaging DD 039",13)	Philips US Imaging DD 039	8205	19	f	\N	LO	1-n	Unknown	\N
7784	(200d,"Philips US Imaging DD 041",13)	(200d,"Philips US Imaging DD 041",13)	Philips US Imaging DD 041	8205	19	f	\N	LO	1	Unknown	\N
7785	(200d,"Philips US Imaging DD 109",13)	(200d,"Philips US Imaging DD 109",13)	Philips US Imaging DD 109	8205	19	f	\N	US	1-n	Unknown	\N
7786	(200d,"Philips US Imaging DD 113",13)	(200d,"Philips US Imaging DD 113",13)	Philips US Imaging DD 113	8205	19	f	\N	FL	1-n	Unknown	\N
7787	(200d,"Philips US Imaging DD 033",14)	(200d,"Philips US Imaging DD 033",14)	Philips US Imaging DD 033	8205	20	f	\N	IS	1	Unknown	\N
7788	(200d,"Philips US Imaging DD 034",14)	(200d,"Philips US Imaging DD 034",14)	Philips US Imaging DD 034	8205	20	f	\N	LO	1	Unknown	\N
7789	(200d,"Philips US Imaging DD 039",14)	(200d,"Philips US Imaging DD 039",14)	Philips US Imaging DD 039	8205	20	f	\N	LO	1-n	Unknown	\N
7790	(200d,"Philips US Imaging DD 041",14)	(200d,"Philips US Imaging DD 041",14)	Philips US Imaging DD 041	8205	20	f	\N	LO	1	Unknown	\N
7791	(200d,"Philips US Imaging DD 109",14)	(200d,"Philips US Imaging DD 109",14)	Philips US Imaging DD 109	8205	20	f	\N	CS	1	Unknown	\N
7792	(200d,"Philips US Imaging DD 113",14)	(200d,"Philips US Imaging DD 113",14)	Philips US Imaging DD 113	8205	20	f	\N	SS	1	Unknown	\N
7793	(200d,"Philips US Imaging DD 033",15)	(200d,"Philips US Imaging DD 033",15)	Philips US Imaging DD 033	8205	21	f	\N	LO	1	Unknown	\N
7794	(200d,"Philips US Imaging DD 036",15)	(200d,"Philips US Imaging DD 036",15)	Philips US Imaging DD 036	8205	21	f	\N	LO	1-n	Unknown	\N
7795	(200d,"Philips US Imaging DD 039",15)	(200d,"Philips US Imaging DD 039",15)	Philips US Imaging DD 039	8205	21	f	\N	LO	1	Unknown	\N
7796	(200d,"Philips US Imaging DD 041",15)	(200d,"Philips US Imaging DD 041",15)	Philips US Imaging DD 041	8205	21	f	\N	LO	1	Unknown	\N
7797	(200d,"Philips US Imaging DD 042",15)	(200d,"Philips US Imaging DD 042",15)	Philips US Imaging DD 042	8205	21	f	\N	IS	1	Unknown	\N
7798	(200d,"Philips US Imaging DD 113",15)	(200d,"Philips US Imaging DD 113",15)	Philips US Imaging DD 113	8205	21	f	\N	UL	1	Unknown	\N
7799	(200d,"Philips US Imaging DD 036",16)	(200d,"Philips US Imaging DD 036",16)	Philips US Imaging DD 036	8205	22	f	\N	LO	1-n	Unknown	\N
7800	(200d,"Philips US Imaging DD 041",16)	(200d,"Philips US Imaging DD 041",16)	Philips US Imaging DD 041	8205	22	f	\N	LO	1	Unknown	\N
7801	(200d,"Philips US Imaging DD 042",16)	(200d,"Philips US Imaging DD 042",16)	Philips US Imaging DD 042	8205	22	f	\N	FD	1	Unknown	\N
7802	(200d,"Philips US Imaging DD 034",17)	(200d,"Philips US Imaging DD 034",17)	Philips US Imaging DD 034	8205	23	f	\N	LO	1	Unknown	\N
7803	(200d,"Philips US Imaging DD 036",17)	(200d,"Philips US Imaging DD 036",17)	Philips US Imaging DD 036	8205	23	f	\N	LO	1-n	Unknown	\N
7804	(200d,"Philips US Imaging DD 041",17)	(200d,"Philips US Imaging DD 041",17)	Philips US Imaging DD 041	8205	23	f	\N	LO	1	Unknown	\N
7805	(200d,"Philips US Imaging DD 043",17)	(200d,"Philips US Imaging DD 043",17)	Philips US Imaging DD 043	8205	23	f	\N	IS	1	Unknown	\N
7806	(200d,"Philips US Imaging DD 046",17)	(200d,"Philips US Imaging DD 046",17)	Philips US Imaging DD 046	8205	23	f	\N	FD	1	Unknown	\N
7807	(200d,"Philips US Imaging DD 113",17)	(200d,"Philips US Imaging DD 113",17)	Philips US Imaging DD 113	8205	23	f	\N	FD	1	Unknown	\N
7808	(200d,"Philips US Imaging DD 034",18)	(200d,"Philips US Imaging DD 034",18)	Philips US Imaging DD 034	8205	24	f	\N	LO	1	Unknown	\N
7809	(200d,"Philips US Imaging DD 036",18)	(200d,"Philips US Imaging DD 036",18)	Philips US Imaging DD 036	8205	24	f	\N	LO	1-n	Unknown	\N
7810	(200d,"Philips US Imaging DD 041",18)	(200d,"Philips US Imaging DD 041",18)	Philips US Imaging DD 041	8205	24	f	\N	LO	1	Unknown	\N
7811	(200d,"Philips US Imaging DD 113",18)	(200d,"Philips US Imaging DD 113",18)	Philips US Imaging DD 113	8205	24	f	\N	FD	1	Unknown	\N
7812	(200d,"Philips US Imaging DD 036",19)	(200d,"Philips US Imaging DD 036",19)	Philips US Imaging DD 036	8205	25	f	\N	LO	1	Unknown	\N
7813	(200d,"Philips US Imaging DD 041",19)	(200d,"Philips US Imaging DD 041",19)	Philips US Imaging DD 041	8205	25	f	\N	LO	1	Unknown	\N
7814	(200d,"Philips US Imaging DD 046",19)	(200d,"Philips US Imaging DD 046",19)	Philips US Imaging DD 046	8205	25	f	\N	LO	1	Unknown	\N
7815	(200d,"Philips US Imaging DD 113",19)	(200d,"Philips US Imaging DD 113",19)	Philips US Imaging DD 113	8205	25	f	\N	FD	1	Unknown	\N
7816	(200d,"Philips US Imaging DD 041",1a)	(200d,"Philips US Imaging DD 041",1a)	Philips US Imaging DD 041	8205	26	f	\N	LO	1	Unknown	\N
7817	(200d,"Philips US Imaging DD 043",1a)	(200d,"Philips US Imaging DD 043",1a)	Philips US Imaging DD 043	8205	26	f	\N	IS	1	Unknown	\N
7818	(200d,"Philips US Imaging DD 113",1a)	(200d,"Philips US Imaging DD 113",1a)	Philips US Imaging DD 113	8205	26	f	\N	FD	1	Unknown	\N
7819	(200d,"Philips US Imaging DD 034",1b)	(200d,"Philips US Imaging DD 034",1b)	Philips US Imaging DD 034	8205	27	f	\N	LO	1	Unknown	\N
7820	(200d,"Philips US Imaging DD 041",1b)	(200d,"Philips US Imaging DD 041",1b)	Philips US Imaging DD 041	8205	27	f	\N	LO	1	Unknown	\N
7821	(200d,"Philips US Imaging DD 043",1b)	(200d,"Philips US Imaging DD 043",1b)	Philips US Imaging DD 043	8205	27	f	\N	IS	1	Unknown	\N
7822	(200d,"Philips US Imaging DD 113",1b)	(200d,"Philips US Imaging DD 113",1b)	Philips US Imaging DD 113	8205	27	f	\N	FD	1	Unknown	\N
7823	(200d,"Philips US Imaging DD 034",1c)	(200d,"Philips US Imaging DD 034",1c)	Philips US Imaging DD 034	8205	28	f	\N	LO	1	Unknown	\N
7824	(200d,"Philips US Imaging DD 041",1c)	(200d,"Philips US Imaging DD 041",1c)	Philips US Imaging DD 041	8205	28	f	\N	LO	1	Unknown	\N
7825	(200d,"Philips US Imaging DD 113",1c)	(200d,"Philips US Imaging DD 113",1c)	Philips US Imaging DD 113	8205	28	f	\N	FD	1	Unknown	\N
7826	(200d,"Philips US Imaging DD 034",1d)	(200d,"Philips US Imaging DD 034",1d)	Philips US Imaging DD 034	8205	29	f	\N	LO	1	Unknown	\N
7827	(200d,"Philips US Imaging DD 113",1d)	(200d,"Philips US Imaging DD 113",1d)	Philips US Imaging DD 113	8205	29	f	\N	UL	1	Unknown	\N
7828	(200d,"Philips US Imaging DD 034",1e)	(200d,"Philips US Imaging DD 034",1e)	Philips US Imaging DD 034	8205	30	f	\N	LO	1	Unknown	\N
7829	(200d,"Philips US Imaging DD 043",1e)	(200d,"Philips US Imaging DD 043",1e)	Philips US Imaging DD 043	8205	30	f	\N	IS	1	Unknown	\N
7830	(200d,"Philips US Imaging DD 113",1e)	(200d,"Philips US Imaging DD 113",1e)	Philips US Imaging DD 113	8205	30	f	\N	UL	1	Unknown	\N
7831	(200d,"Philips US Imaging DD 034",1f)	(200d,"Philips US Imaging DD 034",1f)	Philips US Imaging DD 034	8205	31	f	\N	LO	1	Unknown	\N
7832	(200d,"Philips US Imaging DD 043",1f)	(200d,"Philips US Imaging DD 043",1f)	Philips US Imaging DD 043	8205	31	f	\N	FD	1	Unknown	\N
7833	(200d,"Philips US Imaging DD 113",1f)	(200d,"Philips US Imaging DD 113",1f)	Philips US Imaging DD 113	8205	31	f	\N	FD	1	Unknown	\N
7834	(200d,"Philips US Imaging DD 034",20)	(200d,"Philips US Imaging DD 034",20)	Philips US Imaging DD 034	8205	32	f	\N	LO	1	Unknown	\N
7835	(200d,"Philips US Imaging DD 036",20)	(200d,"Philips US Imaging DD 036",20)	Philips US Imaging DD 036	8205	32	f	\N	LO	1	Unknown	\N
7836	(200d,"Philips US Imaging DD 040",20)	(200d,"Philips US Imaging DD 040",20)	Philips US Imaging DD 040	8205	32	f	\N	LO	1	Unknown	\N
7837	(200d,"Philips US Imaging DD 042",20)	(200d,"Philips US Imaging DD 042",20)	Philips US Imaging DD 042	8205	32	f	\N	LO	1	Unknown	\N
7838	(200d,"Philips US Imaging DD 113",20)	(200d,"Philips US Imaging DD 113",20)	Philips US Imaging DD 113	8205	32	f	\N	FD	1	Unknown	\N
7839	(200d,"Philips US Imaging DD 033",21)	(200d,"Philips US Imaging DD 033",21)	Philips US Imaging DD 033	8205	33	f	\N	IS	1	Private Native Data Instance Num	\N
7840	(200d,"Philips US Imaging DD 034",21)	(200d,"Philips US Imaging DD 034",21)	Philips US Imaging DD 034	8205	33	f	\N	LO	1	Unknown	\N
7841	(200d,"Philips US Imaging DD 043",21)	(200d,"Philips US Imaging DD 043",21)	Philips US Imaging DD 043	8205	33	f	\N	IS	1	Unknown	\N
7842	(200d,"Philips US Imaging DD 113",21)	(200d,"Philips US Imaging DD 113",21)	Philips US Imaging DD 113	8205	33	f	\N	FD	1	Unknown	\N
7843	(200d,"Philips US Imaging DD 034",22)	(200d,"Philips US Imaging DD 034",22)	Philips US Imaging DD 034	8205	34	f	\N	LO	1	Unknown	\N
7844	(200d,"Philips US Imaging DD 113",22)	(200d,"Philips US Imaging DD 113",22)	Philips US Imaging DD 113	8205	34	f	\N	UL	1	Unknown	\N
7845	(200d,"Philips US Imaging DD 034",23)	(200d,"Philips US Imaging DD 034",23)	Philips US Imaging DD 034	8205	35	f	\N	LO	1	Unknown	\N
7846	(200d,"Philips US Imaging DD 041",23)	(200d,"Philips US Imaging DD 041",23)	Philips US Imaging DD 041	8205	35	f	\N	LO	1	Unknown	\N
7847	(200d,"Philips US Imaging DD 043",23)	(200d,"Philips US Imaging DD 043",23)	Philips US Imaging DD 043	8205	35	f	\N	FD	1	Unknown	\N
7848	(200d,"Philips US Imaging DD 034",24)	(200d,"Philips US Imaging DD 034",24)	Philips US Imaging DD 034	8205	36	f	\N	LO	1	Unknown	\N
7849	(200d,"Philips US Imaging DD 041",24)	(200d,"Philips US Imaging DD 041",24)	Philips US Imaging DD 041	8205	36	f	\N	LO	1	Unknown	\N
7850	(200d,"Philips US Imaging DD 043",24)	(200d,"Philips US Imaging DD 043",24)	Philips US Imaging DD 043	8205	36	f	\N	FD	1	Unknown	\N
7851	(200d,"Philips US Imaging DD 113",24)	(200d,"Philips US Imaging DD 113",24)	Philips US Imaging DD 113	8205	36	f	\N	UL	1	Unknown	\N
7852	(200d,"Philips US Imaging DD 034",25)	(200d,"Philips US Imaging DD 034",25)	Philips US Imaging DD 034	8205	37	f	\N	LO	1	Unknown	\N
7853	(200d,"Philips US Imaging DD 041",25)	(200d,"Philips US Imaging DD 041",25)	Philips US Imaging DD 041	8205	37	f	\N	LO	1	Unknown	\N
7854	(200d,"Philips US Imaging DD 043",25)	(200d,"Philips US Imaging DD 043",25)	Philips US Imaging DD 043	8205	37	f	\N	FD	1	Unknown	\N
7855	(200d,"Philips US Imaging DD 113",25)	(200d,"Philips US Imaging DD 113",25)	Philips US Imaging DD 113	8205	37	f	\N	UL	1	Unknown	\N
7856	(200d,"Philips US Imaging DD 034",26)	(200d,"Philips US Imaging DD 034",26)	Philips US Imaging DD 034	8205	38	f	\N	LO	1	Unknown	\N
7857	(200d,"Philips US Imaging DD 041",26)	(200d,"Philips US Imaging DD 041",26)	Philips US Imaging DD 041	8205	38	f	\N	LO	1	Unknown	\N
7858	(200d,"Philips US Imaging DD 043",26)	(200d,"Philips US Imaging DD 043",26)	Philips US Imaging DD 043	8205	38	f	\N	FD	1	Unknown	\N
7859	(200d,"Philips US Imaging DD 113",26)	(200d,"Philips US Imaging DD 113",26)	Philips US Imaging DD 113	8205	38	f	\N	UL	1	Unknown	\N
7860	(200d,"Philips US Imaging DD 034",27)	(200d,"Philips US Imaging DD 034",27)	Philips US Imaging DD 034	8205	39	f	\N	LO	1	Unknown	\N
7861	(200d,"Philips US Imaging DD 041",27)	(200d,"Philips US Imaging DD 041",27)	Philips US Imaging DD 041	8205	39	f	\N	LO	1	Unknown	\N
7862	(200d,"Philips US Imaging DD 043",27)	(200d,"Philips US Imaging DD 043",27)	Philips US Imaging DD 043	8205	39	f	\N	FD	1	Unknown	\N
7863	(200d,"Philips US Imaging DD 113",27)	(200d,"Philips US Imaging DD 113",27)	Philips US Imaging DD 113	8205	39	f	\N	UL	1	Unknown	\N
7864	(200d,"Philips US Imaging DD 034",28)	(200d,"Philips US Imaging DD 034",28)	Philips US Imaging DD 034	8205	40	f	\N	LO	1	Unknown	\N
7865	(200d,"Philips US Imaging DD 041",28)	(200d,"Philips US Imaging DD 041",28)	Philips US Imaging DD 041	8205	40	f	\N	LO	1	Unknown	\N
7866	(200d,"Philips US Imaging DD 043",28)	(200d,"Philips US Imaging DD 043",28)	Philips US Imaging DD 043	8205	40	f	\N	FD	1	Unknown	\N
7867	(200d,"Philips US Imaging DD 113",28)	(200d,"Philips US Imaging DD 113",28)	Philips US Imaging DD 113	8205	40	f	\N	UL	1	Unknown	\N
7868	(200d,"Philips US Imaging DD 041",29)	(200d,"Philips US Imaging DD 041",29)	Philips US Imaging DD 041	8205	41	f	\N	LO	1	Unknown	\N
7869	(200d,"Philips US Imaging DD 043",29)	(200d,"Philips US Imaging DD 043",29)	Philips US Imaging DD 043	8205	41	f	\N	FD	1	Unknown	\N
7870	(200d,"Philips US Imaging DD 043",2a)	(200d,"Philips US Imaging DD 043",2a)	Philips US Imaging DD 043	8205	42	f	\N	FD	1	Unknown	\N
7871	(200d,"Philips US Imaging DD 043",2b)	(200d,"Philips US Imaging DD 043",2b)	Philips US Imaging DD 043	8205	43	f	\N	FD	1	Unknown	\N
7872	(200d,"Philips US Imaging DD 043",2c)	(200d,"Philips US Imaging DD 043",2c)	Philips US Imaging DD 043	8205	44	f	\N	FD	1-n	Unknown	\N
7873	(200d,"Philips US Imaging DD 043",2d)	(200d,"Philips US Imaging DD 043",2d)	Philips US Imaging DD 043	8205	45	f	\N	FD	1-n	Unknown	\N
7874	(200d,"Philips US Imaging DD 043",2e)	(200d,"Philips US Imaging DD 043",2e)	Philips US Imaging DD 043	8205	46	f	\N	FD	1-n	Unknown	\N
7875	(200d,"Philips US Imaging DD 043",2f)	(200d,"Philips US Imaging DD 043",2f)	Philips US Imaging DD 043	8205	47	f	\N	FD	1-n	Unknown	\N
7876	(200d,"Philips US Imaging DD 041",30)	(200d,"Philips US Imaging DD 041",30)	Philips US Imaging DD 041	8205	48	f	\N	LO	1	Unknown	\N
7877	(200d,"Philips US Imaging DD 042",30)	(200d,"Philips US Imaging DD 042",30)	Philips US Imaging DD 042	8205	48	f	\N	LO	1	Unknown	\N
7878	(200d,"Philips US Imaging DD 043",30)	(200d,"Philips US Imaging DD 043",30)	Philips US Imaging DD 043	8205	48	f	\N	FD	1-n	Unknown	\N
7879	(200d,"Philips US Imaging DD 042",31)	(200d,"Philips US Imaging DD 042",31)	Philips US Imaging DD 042	8205	49	f	\N	LO	1	Unknown	\N
7880	(200d,"Philips US Imaging DD 043",31)	(200d,"Philips US Imaging DD 043",31)	Philips US Imaging DD 043	8205	49	f	\N	FD	1-n	Unknown	\N
7881	(200d,"Philips US Imaging DD 113",31)	(200d,"Philips US Imaging DD 113",31)	Philips US Imaging DD 113	8205	49	f	\N	UL	1	Unknown	\N
7882	(200d,"Philips US Imaging DD 043",32)	(200d,"Philips US Imaging DD 043",32)	Philips US Imaging DD 043	8205	50	f	\N	FD	1-n	Unknown	\N
7883	(200d,"Philips US Imaging DD 043",33)	(200d,"Philips US Imaging DD 043",33)	Philips US Imaging DD 043	8205	51	f	\N	FD	1-n	Unknown	\N
7884	(200d,"Philips US Imaging DD 043",34)	(200d,"Philips US Imaging DD 043",34)	Philips US Imaging DD 043	8205	52	f	\N	FD	1-n	Unknown	\N
7885	(200d,"Philips US Imaging DD 043",35)	(200d,"Philips US Imaging DD 043",35)	Philips US Imaging DD 043	8205	53	f	\N	IS	1	Unknown	\N
7886	(200d,"Philips US Imaging DD 043",36)	(200d,"Philips US Imaging DD 043",36)	Philips US Imaging DD 043	8205	54	f	\N	IS	1	Unknown	\N
7887	(200d,"Philips US Imaging DD 023",37)	(200d,"Philips US Imaging DD 023",37)	Philips US Imaging DD 023	8205	55	f	\N	DA	1	Unknown	\N
7888	(200d,"Philips US Imaging DD 043",37)	(200d,"Philips US Imaging DD 043",37)	Philips US Imaging DD 043	8205	55	f	\N	FD	1	Unknown	\N
7889	(200d,"Philips US Imaging DD 023",38)	(200d,"Philips US Imaging DD 023",38)	Philips US Imaging DD 023	8205	56	f	\N	TM	1	Unknown	\N
7890	(200d,"Philips US Imaging DD 043",38)	(200d,"Philips US Imaging DD 043",38)	Philips US Imaging DD 043	8205	56	f	\N	FD	1-n	Unknown	\N
7891	(200d,"Philips US Imaging DD 043",39)	(200d,"Philips US Imaging DD 043",39)	Philips US Imaging DD 043	8205	57	f	\N	FD	1	Unknown	\N
7892	(200d,"Philips US Imaging DD 042",40)	(200d,"Philips US Imaging DD 042",40)	Philips US Imaging DD 042	8205	64	f	\N	LO	1-n	Unknown	\N
7893	(200d,"Philips US Imaging DD 043",40)	(200d,"Philips US Imaging DD 043",40)	Philips US Imaging DD 043	8205	64	f	\N	IS	1	Unknown	\N
7894	(200d,"Philips US Imaging DD 043",41)	(200d,"Philips US Imaging DD 043",41)	Philips US Imaging DD 043	8205	65	f	\N	IS	1	Unknown	\N
7895	(200d,"Philips US Imaging DD 043",42)	(200d,"Philips US Imaging DD 043",42)	Philips US Imaging DD 043	8205	66	f	\N	IS	1	Unknown	\N
7896	(200d,"Philips US Imaging DD 023",45)	(200d,"Philips US Imaging DD 023",45)	Philips US Imaging DD 023	8205	69	f	\N	IS	1	Unknown	\N
7897	(200d,"Philips US Imaging DD 039",50)	(200d,"Philips US Imaging DD 039",50)	Philips US Imaging DD 039	8205	80	f	\N	IS	1	Unknown	\N
7898	(200d,"Philips US Imaging DD 042",50)	(200d,"Philips US Imaging DD 042",50)	Philips US Imaging DD 042	8205	80	f	\N	LO	1-n	Unknown	\N
7899	(200d,"Philips US Imaging DD 039",51)	(200d,"Philips US Imaging DD 039",51)	Philips US Imaging DD 039	8205	81	f	\N	IS	1	Unknown	\N
7900	(200d,"Philips US Imaging DD 042",51)	(200d,"Philips US Imaging DD 042",51)	Philips US Imaging DD 042	8205	81	f	\N	LO	1	Unknown	\N
7901	(200d,"Philips US Imaging DD 039",52)	(200d,"Philips US Imaging DD 039",52)	Philips US Imaging DD 039	8205	82	f	\N	IS	1	Unknown	\N
7902	(200d,"Philips US Imaging DD 042",52)	(200d,"Philips US Imaging DD 042",52)	Philips US Imaging DD 042	8205	82	f	\N	LO	1	Unknown	\N
7903	(200d,"Philips US Imaging DD 039",53)	(200d,"Philips US Imaging DD 039",53)	Philips US Imaging DD 039	8205	83	f	\N	IS	1	Unknown	\N
7904	(200d,"Philips US Imaging DD 042",53)	(200d,"Philips US Imaging DD 042",53)	Philips US Imaging DD 042	8205	83	f	\N	LO	1	Unknown	\N
7905	(200d,"Philips US Imaging DD 039",54)	(200d,"Philips US Imaging DD 039",54)	Philips US Imaging DD 039	8205	84	f	\N	IS	1	Unknown	\N
7906	(200d,"Philips US Imaging DD 042",54)	(200d,"Philips US Imaging DD 042",54)	Philips US Imaging DD 042	8205	84	f	\N	LO	1	Unknown	\N
7907	(200d,"Philips US Imaging DD 039",55)	(200d,"Philips US Imaging DD 039",55)	Philips US Imaging DD 039	8205	85	f	\N	IS	1	Unknown	\N
7908	(200d,"Philips US Imaging DD 042",55)	(200d,"Philips US Imaging DD 042",55)	Philips US Imaging DD 042	8205	85	f	\N	LO	1	Unknown	\N
7909	(200d,"Philips US Imaging DD 039",56)	(200d,"Philips US Imaging DD 039",56)	Philips US Imaging DD 039	8205	86	f	\N	IS	1	Unknown	\N
7910	(200d,"Philips US Imaging DD 042",56)	(200d,"Philips US Imaging DD 042",56)	Philips US Imaging DD 042	8205	86	f	\N	LO	1	Unknown	\N
7911	(200d,"Philips US Imaging DD 039",57)	(200d,"Philips US Imaging DD 039",57)	Philips US Imaging DD 039	8205	87	f	\N	IS	1	Unknown	\N
7912	(200d,"Philips US Imaging DD 042",57)	(200d,"Philips US Imaging DD 042",57)	Philips US Imaging DD 042	8205	87	f	\N	LO	1	Unknown	\N
7913	(200d,"Philips US Imaging DD 039",58)	(200d,"Philips US Imaging DD 039",58)	Philips US Imaging DD 039	8205	88	f	\N	IS	1	Unknown	\N
7914	(200d,"Philips US Imaging DD 042",58)	(200d,"Philips US Imaging DD 042",58)	Philips US Imaging DD 042	8205	88	f	\N	LO	1	Unknown	\N
7915	(200d,"Philips US Imaging DD 039",59)	(200d,"Philips US Imaging DD 039",59)	Philips US Imaging DD 039	8205	89	f	\N	IS	1	Unknown	\N
7916	(200d,"Philips US Imaging DD 042",59)	(200d,"Philips US Imaging DD 042",59)	Philips US Imaging DD 042	8205	89	f	\N	LO	1	Unknown	\N
7917	(200d,"Philips US Imaging DD 042",5a)	(200d,"Philips US Imaging DD 042",5a)	Philips US Imaging DD 042	8205	90	f	\N	LO	1	Unknown	\N
7918	(200d,"Philips US Imaging DD 042",5b)	(200d,"Philips US Imaging DD 042",5b)	Philips US Imaging DD 042	8205	91	f	\N	LO	1	Unknown	\N
7919	(200d,"Philips US Imaging DD 042",5c)	(200d,"Philips US Imaging DD 042",5c)	Philips US Imaging DD 042	8205	92	f	\N	LO	1	Unknown	\N
7920	(200d,"Philips US Imaging DD 042",5d)	(200d,"Philips US Imaging DD 042",5d)	Philips US Imaging DD 042	8205	93	f	\N	LO	1	Unknown	\N
7921	(200d,"Philips US Imaging DD 042",5e)	(200d,"Philips US Imaging DD 042",5e)	Philips US Imaging DD 042	8205	94	f	\N	LO	1	Unknown	\N
7922	(200d,"Philips US Imaging DD 042",5f)	(200d,"Philips US Imaging DD 042",5f)	Philips US Imaging DD 042	8205	95	f	\N	LO	1	Unknown	\N
7923	(200d,"Philips US Imaging DD 039",60)	(200d,"Philips US Imaging DD 039",60)	Philips US Imaging DD 039	8205	96	f	\N	IS	1	Unknown	\N
7924	(200d,"Philips US Imaging DD 042",60)	(200d,"Philips US Imaging DD 042",60)	Philips US Imaging DD 042	8205	96	f	\N	LO	1	Unknown	\N
7925	(200d,"Philips US Imaging DD 039",61)	(200d,"Philips US Imaging DD 039",61)	Philips US Imaging DD 039	8205	97	f	\N	IS	1	Unknown	\N
7926	(200d,"Philips US Imaging DD 042",70)	(200d,"Philips US Imaging DD 042",70)	Philips US Imaging DD 042	8205	112	f	\N	LO	1	Unknown	\N
7927	(200d,"Philips US Imaging DD 042",71)	(200d,"Philips US Imaging DD 042",71)	Philips US Imaging DD 042	8205	113	f	\N	LO	1	Unknown	\N
7928	(200d,"Philips US Imaging DD 042",72)	(200d,"Philips US Imaging DD 042",72)	Philips US Imaging DD 042	8205	114	f	\N	LO	1	Unknown	\N
7929	(200d,"Philips US Imaging DD 042",73)	(200d,"Philips US Imaging DD 042",73)	Philips US Imaging DD 042	8205	115	f	\N	LO	1	Unknown	\N
7930	(200d,"Philips US Imaging DD 042",74)	(200d,"Philips US Imaging DD 042",74)	Philips US Imaging DD 042	8205	116	f	\N	LO	1	Unknown	\N
7931	(200d,"Philips US Imaging DD 042",75)	(200d,"Philips US Imaging DD 042",75)	Philips US Imaging DD 042	8205	117	f	\N	LO	1	Unknown	\N
7932	(200d,"Philips US Imaging DD 042",76)	(200d,"Philips US Imaging DD 042",76)	Philips US Imaging DD 042	8205	118	f	\N	LO	1	Unknown	\N
7933	(200d,"Philips US Imaging DD 042",77)	(200d,"Philips US Imaging DD 042",77)	Philips US Imaging DD 042	8205	119	f	\N	LO	1	Unknown	\N
7934	(200d,"Philips US Imaging DD 042",78)	(200d,"Philips US Imaging DD 042",78)	Philips US Imaging DD 042	8205	120	f	\N	LO	1	Unknown	\N
7935	(200d,"Philips US Imaging DD 042",8c)	(200d,"Philips US Imaging DD 042",8c)	Philips US Imaging DD 042	8205	140	f	\N	LO	1	Unknown	\N
7936	(200d,"Philips US Imaging DD 045",f1)	(200d,"Philips US Imaging DD 045",f1)	Philips US Imaging DD 045	8205	241	f	\N	SQ	1	Unknown	\N
7937	(200d,"Philips US Imaging DD 045",f3)	(200d,"Philips US Imaging DD 045",f3)	Philips US Imaging DD 045	8205	243	f	\N	OB	1	Unknown	\N
7938	(200d,"Philips US Imaging DD 045",f4)	(200d,"Philips US Imaging DD 045",f4)	Philips US Imaging DD 045	8205	244	f	\N	SQ	1	Unknown	\N
7939	(200d,"Philips US Imaging DD 045",f5)	(200d,"Philips US Imaging DD 045",f5)	Philips US Imaging DD 045	8205	245	f	\N	SQ	1	Unknown	\N
7940	(200d,"Philips US Imaging DD 045",f6)	(200d,"Philips US Imaging DD 045",f6)	Philips US Imaging DD 045	8205	246	f	\N	SQ	1	Unknown	\N
7941	(200d,"Philips US Imaging DD 045",f8)	(200d,"Philips US Imaging DD 045",f8)	Philips US Imaging DD 045	8205	248	f	\N	SQ	1	Unknown	\N
7942	(200d,"Philips US Imaging DD 045",fa)	(200d,"Philips US Imaging DD 045",fa)	Philips US Imaging DD 045	8205	250	f	\N	CS	1	Unknown	\N
10539	(0009,"MMCPrivate",1e)	(0009,"MMCPrivate",1e)	MMCPrivate	9	30	f	\N	SH	1	IsAllowCascadeProtect	X
7943	(200d,"Philips US Imaging DD 045",fb)	(200d,"Philips US Imaging DD 045",fb)	Philips US Imaging DD 045	8205	251	f	\N	OB	1	Unknown	\N
7944	(4001,"Philips Imaging DD 067",00)	(4001,"Philips Imaging DD 067",00)	Philips Imaging DD 067	16385	0	f	\N	SQ	1	Unknown	\N
7945	(4001,"Philips Imaging DD 067",01)	(4001,"Philips Imaging DD 067",01)	Philips Imaging DD 067	16385	1	f	\N	CS	1	Unknown	\N
7946	(4001,"Philips Imaging DD 067",08)	(4001,"Philips Imaging DD 067",08)	Philips Imaging DD 067	16385	8	f	\N	CS	1	Unknown	\N
7947	(4001,"Philips Imaging DD 067",09)	(4001,"Philips Imaging DD 067",09)	Philips Imaging DD 067	16385	9	f	\N	CS	1	Unknown	\N
7948	(4001,"Philips Imaging DD 070",10)	(4001,"Philips Imaging DD 070",10)	Philips Imaging DD 070	16385	16	f	\N	SQ	1	Unknown	\N
7949	(4001,"Philips Imaging DD 070",11)	(4001,"Philips Imaging DD 070",11)	Philips Imaging DD 070	16385	17	f	\N	SQ	1	Unknown	\N
7950	(4001,"Philips Imaging DD 070",12)	(4001,"Philips Imaging DD 070",12)	Philips Imaging DD 070	16385	18	f	\N	SQ	1	Unknown	\N
7951	(4001,"Philips Imaging DD 070",13)	(4001,"Philips Imaging DD 070",13)	Philips Imaging DD 070	16385	19	f	\N	ST	1	Unknown	\N
7952	(4001,"Philips Imaging DD 070",16)	(4001,"Philips Imaging DD 070",16)	Philips Imaging DD 070	16385	22	f	\N	ST	1	Unknown	\N
7953	(4001,"Philips Imaging DD 070",17)	(4001,"Philips Imaging DD 070",17)	Philips Imaging DD 070	16385	23	f	\N	ST	1	Unknown	\N
7954	(4001,"Philips Imaging DD 070",18)	(4001,"Philips Imaging DD 070",18)	Philips Imaging DD 070	16385	24	f	\N	ST	1	Unknown	\N
7955	(4001,"Philips Imaging DD 070",1c)	(4001,"Philips Imaging DD 070",1c)	Philips Imaging DD 070	16385	28	f	\N	SQ	1	Unknown	\N
7956	(4001,"Philips Imaging DD 070",1d)	(4001,"Philips Imaging DD 070",1d)	Philips Imaging DD 070	16385	29	f	\N	LT	1	Unknown	\N
7957	(4007,"Philips Imaging DD 065",00)	(4007,"Philips Imaging DD 065",00)	Philips Imaging DD 065	16391	0	f	\N	CS	1	Unknown	\N
7958	(4007,"Philips Imaging DD 073",48)	(4007,"Philips Imaging DD 073",48)	Philips Imaging DD 073	16391	72	f	\N	FL	1	Unknown	\N
7959	(4007,"Philips Imaging DD 073",4b)	(4007,"Philips Imaging DD 073",4b)	Philips Imaging DD 073	16391	75	f	\N	FL	1	Unknown	\N
7960	(4007,"Philips Imaging DD 073",4c)	(4007,"Philips Imaging DD 073",4c)	Philips Imaging DD 073	16391	76	f	\N	LO	1	Unknown	\N
7961	(4007,"Philips Imaging DD 073",4d)	(4007,"Philips Imaging DD 073",4d)	Philips Imaging DD 073	16391	77	f	\N	FL	1	Unknown	\N
7962	(4007,"Philips Imaging DD 073",4e)	(4007,"Philips Imaging DD 073",4e)	Philips Imaging DD 073	16391	78	f	\N	FL	1	Unknown	\N
7963	(4007,"Philips Imaging DD 073",4f)	(4007,"Philips Imaging DD 073",4f)	Philips Imaging DD 073	16391	79	f	\N	LO	1	Unknown	\N
7964	(7043,"Philips NM Private Group",00)	(7043,"Philips NM Private Group",00)	Philips NM Private Group	28739	0	f	\N	SH	1	Unknown	\N
7965	(7051,"PHILIPS NM -Private",00)	(7051,"PHILIPS NM -Private",00)	PHILIPS NM -Private	28753	0	f	\N	US	1	Current Segment	\N
7966	(7051,"PHILIPS NM -Private",01)	(7051,"PHILIPS NM -Private",01)	PHILIPS NM -Private	28753	1	f	\N	US	1	Number of Segments	\N
7967	(7051,"PHILIPS XCT -Private",01)	(7051,"PHILIPS XCT -Private",01)	PHILIPS XCT -Private	28753	1	f	\N	DS	1	Attenuation Threshold	\N
7968	(7051,"PHILIPS NM -Private",02)	(7051,"PHILIPS NM -Private",02)	PHILIPS NM -Private	28753	2	f	\N	FL	1	Segment Start Position	\N
7969	(7051,"PHILIPS XCT -Private",02)	(7051,"PHILIPS XCT -Private",02)	PHILIPS XCT -Private	28753	2	f	\N	DS	1	DLPEstimate	\N
7970	(7051,"PHILIPS NM -Private",03)	(7051,"PHILIPS NM -Private",03)	PHILIPS NM -Private	28753	3	f	\N	FL	1	Segment Stop Position	\N
7971	(7051,"PHILIPS NM -Private",04)	(7051,"PHILIPS NM -Private",04)	PHILIPS NM -Private	28753	4	f	\N	FL	1	Relative COR offset - X direction	\N
7972	(7051,"PHILIPS NM -Private",05)	(7051,"PHILIPS NM -Private",05)	PHILIPS NM -Private	28753	5	f	\N	FL	1	Relative COR offset - Z direction	\N
7973	(7051,"PHILIPS NM -Private",06)	(7051,"PHILIPS NM -Private",06)	PHILIPS NM -Private	28753	6	f	\N	US	1	Current Rotation Number	\N
7974	(7051,"PHILIPS NM -Private",07)	(7051,"PHILIPS NM -Private",07)	PHILIPS NM -Private	28753	7	f	\N	US	1	Number of Rotations	\N
7975	(7051,"PHILIPS NM -Private",10)	(7051,"PHILIPS NM -Private",10)	PHILIPS NM -Private	28753	16	f	\N	DS	1-n	Alignment Translations	\N
7976	(7051,"PHILIPS NM -Private",11)	(7051,"PHILIPS NM -Private",11)	PHILIPS NM -Private	28753	17	f	\N	DS	1-n	Alignment Rotations	\N
7977	(7051,"PHILIPS NM -Private",12)	(7051,"PHILIPS NM -Private",12)	PHILIPS NM -Private	28753	18	f	\N	DS	1	Alignment Timestamp	\N
7978	(7051,"PHILIPS NM -Private",15)	(7051,"PHILIPS NM -Private",15)	PHILIPS NM -Private	28753	21	f	\N	UI	1	Related Xray Series Instance UID	\N
7979	(7051,"PHILIPS NM -Private",25)	(7051,"PHILIPS NM -Private",25)	PHILIPS NM -Private	28753	37	f	\N	LO	1	Unknown	\N
7980	(7051,"PHILIPS NM -Private",26)	(7051,"PHILIPS NM -Private",26)	PHILIPS NM -Private	28753	38	f	\N	DS	1	Unknown	\N
7981	(7051,"PHILIPS NM -Private",27)	(7051,"PHILIPS NM -Private",27)	PHILIPS NM -Private	28753	39	f	\N	IS	1	Unknown	\N
7982	(7051,"PHILIPS NM -Private",28)	(7051,"PHILIPS NM -Private",28)	PHILIPS NM -Private	28753	40	f	\N	IS	1	Unknown	\N
7983	(7051,"PHILIPS NM -Private",29)	(7051,"PHILIPS NM -Private",29)	PHILIPS NM -Private	28753	41	f	\N	IS	1	Unknown	\N
7988	(7053,"Philips PET Private Group",04)	(7053,"Philips PET Private Group",04)	Philips PET Private Group	28755	4	f	\N	OB	1	Unknown	\N
7992	(7053,"Philips PET Private Group",08)	(7053,"Philips PET Private Group",08)	Philips PET Private Group	28755	8	f	\N	SQ	1	Unknown	\N
7994	(7053,"Philips PET Private Group",0f)	(7053,"Philips PET Private Group",0f)	Philips PET Private Group	28755	15	f	\N	UL	1	Unknown	\N
7995	(7053,"Philips PET Private Group",10)	(7053,"Philips PET Private Group",10)	Philips PET Private Group	28755	16	f	\N	US	1	Unknown	\N
7996	(7053,"Philips PET Private Group",11)	(7053,"Philips PET Private Group",11)	Philips PET Private Group	28755	17	f	\N	US	1	Unknown	\N
7997	(7053,"Philips PET Private Group",12)	(7053,"Philips PET Private Group",12)	Philips PET Private Group	28755	18	f	\N	SQ	1	Unknown	\N
8005	(7fe1,"SPI-P Release 1",10)	(7fe1,"SPI-P Release 1",10)	SPI-P Release 1	32737	16	f	\N	OW/OB	1	Pixel Data	\N
8006	(7001,"Picker NM Private Group",03)	(7001,"Picker NM Private Group",03)	Picker NM Private Group	28673	3	f	\N	OB	1	Unknown	\N
8007	(7001,"Picker NM Private Group",04)	(7001,"Picker NM Private Group",04)	Picker NM Private Group	28673	4	f	\N	OB	1	Unknown	\N
8008	(7001,"Picker NM Private Group",05)	(7001,"Picker NM Private Group",05)	Picker NM Private Group	28673	5	f	\N	OB	1	Unknown	\N
8009	(7001,"Picker NM Private Group",06)	(7001,"Picker NM Private Group",06)	Picker NM Private Group	28673	6	f	\N	OB	1	Unknown	\N
8010	(7001,"Picker NM Private Group",07)	(7001,"Picker NM Private Group",07)	Picker NM Private Group	28673	7	f	\N	OB	1	Unknown	\N
8011	(7001,"Picker NM Private Group",08)	(7001,"Picker NM Private Group",08)	Picker NM Private Group	28673	8	f	\N	OB	1	Unknown	\N
8012	(7001,"Picker NM Private Group",09)	(7001,"Picker NM Private Group",09)	Picker NM Private Group	28673	9	f	\N	OB	1	Unknown	\N
8013	(7001,"Picker NM Private Group",10)	(7001,"Picker NM Private Group",10)	Picker NM Private Group	28673	16	f	\N	SQ	1	Unknown	\N
8014	(7001,"Picker NM Private Group",11)	(7001,"Picker NM Private Group",11)	Picker NM Private Group	28673	17	f	\N	LO	1	Unknown	\N
8015	(7001,"Picker NM Private Group",12)	(7001,"Picker NM Private Group",12)	Picker NM Private Group	28673	18	f	\N	OB	1	Unknown	\N
8016	(7001,"Picker NM Private Group",13)	(7001,"Picker NM Private Group",13)	Picker NM Private Group	28673	19	f	\N	US	1	Unknown	\N
8017	(7001,"Picker NM Private Group",14)	(7001,"Picker NM Private Group",14)	Picker NM Private Group	28673	20	f	\N	OB	1	Unknown	\N
8018	(7001,"Picker NM Private Group",16)	(7001,"Picker NM Private Group",16)	Picker NM Private Group	28673	22	f	\N	OB	1	Unknown	\N
8019	(7001,"Picker NM Private Group",17)	(7001,"Picker NM Private Group",17)	Picker NM Private Group	28673	23	f	\N	LO	1	Unknown	\N
8020	(7101,"Picker MR Private Group",00)	(7101,"Picker MR Private Group",00)	Picker MR Private Group	28929	0	f	\N	OB	1	Unknown	\N
8021	(7101,"Picker MR Private Group",01)	(7101,"Picker MR Private Group",01)	Picker MR Private Group	28929	1	f	\N	SL	1	Unknown	\N
8022	(7101,"Picker MR Private Group",02)	(7101,"Picker MR Private Group",02)	Picker MR Private Group	28929	2	f	\N	OB	1	Unknown	\N
8023	(7101,"Picker MR Private Group",03)	(7101,"Picker MR Private Group",03)	Picker MR Private Group	28929	3	f	\N	SL	1	Unknown	\N
8024	(7101,"Picker MR Private Group",04)	(7101,"Picker MR Private Group",04)	Picker MR Private Group	28929	4	f	\N	SH	1	Unknown	\N
8025	(7101,"Picker MR Private Group",05)	(7101,"Picker MR Private Group",05)	Picker MR Private Group	28929	5	f	\N	SH	2	Unknown	\N
8026	(7101,"Picker MR Private Group",06)	(7101,"Picker MR Private Group",06)	Picker MR Private Group	28929	6	f	\N	SH	4	Unknown	\N
8027	(7101,"Picker MR Private Group",10)	(7101,"Picker MR Private Group",10)	Picker MR Private Group	28929	16	f	\N	DS	1	Unknown	\N
8028	(0009,"SIEMENS SYNGO INSTANCE MANIFEST",00)	(0009,"SIEMENS SYNGO INSTANCE MANIFEST",00)	SIEMENS SYNGO INSTANCE MANIFEST	9	0	f	\N	SQ	1	Temporary Original Header Sequence	\N
8029	(0009,"SIEMENS SYNGO INSTANCE MANIFEST",10)	(0009,"SIEMENS SYNGO INSTANCE MANIFEST",10)	SIEMENS SYNGO INSTANCE MANIFEST	9	16	f	\N	AE	1	syngo Index Source AE Title	\N
8030	(0009,"SIENET",70)	(0009,"SIENET",70)	SIENET	9	112	f	\N	DS	1	Unknown	\N
8031	(0009,"SIENET",71)	(0009,"SIENET",71)	SIENET	9	113	f	\N	DS	1	Unknown	\N
8032	(0009,"SIENET",72)	(0009,"SIENET",72)	SIENET	9	114	f	\N	LO	1	Unknown	\N
8033	(0009,"SIENET",73)	(0009,"SIENET",73)	SIENET	9	115	f	\N	LO	1	Unknown	\N
8034	(0009,"SIENET",74)	(0009,"SIENET",74)	SIENET	9	116	f	\N	LO	1	Unknown	\N
8035	(0009,"SIENET",75)	(0009,"SIENET",75)	SIENET	9	117	f	\N	LO	1	Unknown	\N
8036	(0009,"SIEMENS MED NM",80)	(0009,"SIEMENS MED NM",80)	SIEMENS MED NM	9	128	f	\N	ST	1	Unknown	\N
8037	(0009,"SIEMENS SYNGO INDEX SERVICE",20)	(0009,"SIEMENS SYNGO INDEX SERVICE",20)	SIEMENS SYNGO INDEX SERVICE	9	32	f	\N	DA	1	Object Insertion Date	\N
8038	(0009,"SIEMENS SYNGO INDEX SERVICE",a0)	(0009,"SIEMENS SYNGO INDEX SERVICE",a0)	SIEMENS SYNGO INDEX SERVICE	9	160	f	\N	LO	1	Sender System Device Name	\N
8039	(0009,"SIEMENS SYNGO INDEX SERVICE",40)	(0009,"SIEMENS SYNGO INDEX SERVICE",40)	SIEMENS SYNGO INDEX SERVICE	9	64	f	\N	DT	1	Last Access Time	\N
8040	(0009,"SIEMENS SYNGO INDEX SERVICE",41)	(0009,"SIEMENS SYNGO INDEX SERVICE",41)	SIEMENS SYNGO INDEX SERVICE	9	65	f	\N	CS	1	Delete Protected Status	\N
8041	(0009,"SIEMENS SYNGO INDEX SERVICE",42)	(0009,"SIEMENS SYNGO INDEX SERVICE",42)	SIEMENS SYNGO INDEX SERVICE	9	66	f	\N	CS	1	Received from Archive Status	\N
8042	(0009,"SIEMENS SYNGO INDEX SERVICE",43)	(0009,"SIEMENS SYNGO INDEX SERVICE",43)	SIEMENS SYNGO INDEX SERVICE	9	67	f	\N	CS	1	Archive Status	\N
8043	(0009,"SIEMENS SYNGO INDEX SERVICE",44)	(0009,"SIEMENS SYNGO INDEX SERVICE",44)	SIEMENS SYNGO INDEX SERVICE	9	68	f	\N	AE	1	Location	\N
8044	(0009,"SIEMENS SYNGO INDEX SERVICE",45)	(0009,"SIEMENS SYNGO INDEX SERVICE",45)	SIEMENS SYNGO INDEX SERVICE	9	69	f	\N	CS	1	Logical Deleted Status	\N
8045	(0009,"SIEMENS SYNGO INDEX SERVICE",46)	(0009,"SIEMENS SYNGO INDEX SERVICE",46)	SIEMENS SYNGO INDEX SERVICE	9	70	f	\N	DT	1	Insert Time	\N
8046	(0009,"SIEMENS SYNGO INDEX SERVICE",47)	(0009,"SIEMENS SYNGO INDEX SERVICE",47)	SIEMENS SYNGO INDEX SERVICE	9	71	f	\N	IS	1	Visible Instances on Series Level	\N
8047	(0009,"SIEMENS SYNGO INDEX SERVICE",48)	(0009,"SIEMENS SYNGO INDEX SERVICE",48)	SIEMENS SYNGO INDEX SERVICE	9	72	f	\N	IS	1	Unarchived Instances	\N
8048	(0009,"SIEMENS SYNGO INDEX SERVICE",49)	(0009,"SIEMENS SYNGO INDEX SERVICE",49)	SIEMENS SYNGO INDEX SERVICE	9	73	f	\N	IS	1	Visible Instances on Study Level	\N
8049	(0009,"SIEMENS SYNGO INDEX SERVICE",31)	(0009,"SIEMENS SYNGO INDEX SERVICE",31)	SIEMENS SYNGO INDEX SERVICE	9	49	f	\N	SQ	1	Series Object States	\N
8050	(0009,"SIEMENS SYNGO INDEX SERVICE",30)	(0009,"SIEMENS SYNGO INDEX SERVICE",30)	SIEMENS SYNGO INDEX SERVICE	9	48	f	\N	SQ	1	Instance Object States	\N
8051	(0009,"SIEMENS SYNGO INDEX SERVICE",50)	(0009,"SIEMENS SYNGO INDEX SERVICE",50)	SIEMENS SYNGO INDEX SERVICE	9	80	f	\N	CS	1	Hidden Instance	\N
8052	(0009,"SIEMENS AX INSPACE_EP",50)	(0009,"SIEMENS AX INSPACE_EP",50)	SIEMENS AX INSPACE_EP	9	80	f	\N	UI	1	Unknown	\N
8053	(0009,"SIEMENS AX INSPACE_EP",51)	(0009,"SIEMENS AX INSPACE_EP",51)	SIEMENS AX INSPACE_EP	9	81	f	\N	UI	1	Unknown	\N
8054	(0011,"SIEMENS MED NM",10)	(0011,"SIEMENS MED NM",10)	SIEMENS MED NM	17	16	f	\N	ST	1	Unknown	\N
8055	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",01)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",01)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	1	f	\N	ST	1	Reprocessing Info	\N
8056	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",02)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",02)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	2	f	\N	CS	1-n	Data Role Type	\N
8057	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",03)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",03)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	3	f	\N	ST	1	Data Role Name	\N
8058	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",04)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",04)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	4	f	\N	SL	1	Rescan Name	\N
8059	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",05)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",05)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	5	f	\N	FD	1	Unknown	\N
8060	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",06)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",06)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	6	f	\N	ST	1	Cardiac Type Name	\N
8061	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",07)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",07)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	7	f	\N	ST	1	Cardiac Type Name L2	\N
8062	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",08)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",08)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	8	f	\N	ST	1	Misc Indicator	\N
8063	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",09)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",09)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	9	f	\N	SL	1	Unknown	\N
8064	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0a)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0a)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	10	f	\N	SL	1	Unknown	\N
8065	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0b)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0b)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	11	f	\N	DS	1	Unknown	\N
8066	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0c)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0c)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	12	f	\N	ST	1	Split Bagging Name	\N
8067	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0d)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0d)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	13	f	\N	ST	1	Split Sub Bagging Name	\N
8068	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0e)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0e)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	14	f	\N	ST	1	Stage Sub Bagging Name	\N
8069	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0f)	(0011,"SIEMENS MR DATAMAPPING ATTRIBUTES",0f)	SIEMENS MR DATAMAPPING ATTRIBUTES	17	15	f	\N	ST	1	Is Internal Data Role	\N
8070	(0015,"ESOFT_DICOM_ECAT_OWNERCODE",00)	(0015,"ESOFT_DICOM_ECAT_OWNERCODE",00)	ESOFT_DICOM_ECAT_OWNERCODE	21	0	f	\N	OB	1	Unknown	\N
8071	(0017,"SIEMENS MED NM",00)	(0017,"SIEMENS MED NM",00)	SIEMENS MED NM	23	0	f	\N	ST	1	Unknown	\N
8072	(0017,"Siemens: Thorax/Multix FD Version",00)	(0017,"Siemens: Thorax/Multix FD Version",00)	Siemens: Thorax/Multix FD Version	23	0	f	\N	LO	1	Unknown	\N
8073	(0017,"Siemens: Thorax/Multix FD Version",01)	(0017,"Siemens: Thorax/Multix FD Version",01)	Siemens: Thorax/Multix FD Version	23	1	f	\N	LO	1	Unknown	\N
8074	(0017,"SIEMENS MED NM",20)	(0017,"SIEMENS MED NM",20)	SIEMENS MED NM	23	32	f	\N	ST	1	Unknown	\N
8075	(0017,"SIEMENS MED NM",70)	(0017,"SIEMENS MED NM",70)	SIEMENS MED NM	23	112	f	\N	ST	1	Unknown	\N
8076	(0017,"SIEMENS MED NM",80)	(0017,"SIEMENS MED NM",80)	SIEMENS MED NM	23	128	f	\N	ST	1	Unknown	\N
8077	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0a)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0a)	SIEMENS_FLCOMPACT_VA01A_PROC	23	10	f	\N	SS	1	Unknown	\N
8078	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0b)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0b)	SIEMENS_FLCOMPACT_VA01A_PROC	23	11	f	\N	SS	1	Unknown	\N
8079	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0c)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0c)	SIEMENS_FLCOMPACT_VA01A_PROC	23	12	f	\N	SS	1	Unknown	\N
8080	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0d)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0d)	SIEMENS_FLCOMPACT_VA01A_PROC	23	13	f	\N	FL	1	Unknown	\N
8081	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0e)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0e)	SIEMENS_FLCOMPACT_VA01A_PROC	23	14	f	\N	LO	1	Unknown	\N
8082	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0f)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0f)	SIEMENS_FLCOMPACT_VA01A_PROC	23	15	f	\N	LO	1	Unknown	\N
8083	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",10)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",10)	SIEMENS_FLCOMPACT_VA01A_PROC	23	16	f	\N	SS	1	Unknown	\N
8084	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",11)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",11)	SIEMENS_FLCOMPACT_VA01A_PROC	23	17	f	\N	SS	1	Unknown	\N
8085	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",14)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",14)	SIEMENS_FLCOMPACT_VA01A_PROC	23	20	f	\N	US	1	Unknown	\N
8086	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",16)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",16)	SIEMENS_FLCOMPACT_VA01A_PROC	23	22	f	\N	US	1	Unknown	\N
8087	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",17)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",17)	SIEMENS_FLCOMPACT_VA01A_PROC	23	23	f	\N	US	1	Unknown	\N
8235	(0019,"SIEMENS RA PLANE B",b8)	(0019,"SIEMENS RA PLANE B",b8)	SIEMENS RA PLANE B	25	184	f	\N	US	1	Unknown	\N
8088	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",18)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",18)	SIEMENS_FLCOMPACT_VA01A_PROC	23	24	f	\N	US	1	Unknown	\N
8089	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",19)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",19)	SIEMENS_FLCOMPACT_VA01A_PROC	23	25	f	\N	US	1	Unknown	\N
8090	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1a)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1a)	SIEMENS_FLCOMPACT_VA01A_PROC	23	26	f	\N	US	1	Unknown	\N
8091	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1b)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1b)	SIEMENS_FLCOMPACT_VA01A_PROC	23	27	f	\N	US	1	Unknown	\N
8092	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1c)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1c)	SIEMENS_FLCOMPACT_VA01A_PROC	23	28	f	\N	US	1	Unknown	\N
8093	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1e)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1e)	SIEMENS_FLCOMPACT_VA01A_PROC	23	30	f	\N	US	1	Unknown	\N
8094	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1f)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1f)	SIEMENS_FLCOMPACT_VA01A_PROC	23	31	f	\N	SS	1	Unknown	\N
8095	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",20)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",20)	SIEMENS_FLCOMPACT_VA01A_PROC	23	32	f	\N	SS	1	Unknown	\N
8096	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",21)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",21)	SIEMENS_FLCOMPACT_VA01A_PROC	23	33	f	\N	US	1	Unknown	\N
8097	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",22)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",22)	SIEMENS_FLCOMPACT_VA01A_PROC	23	34	f	\N	US	1	Unknown	\N
8098	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",23)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",23)	SIEMENS_FLCOMPACT_VA01A_PROC	23	35	f	\N	US	1	Unknown	\N
8099	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",24)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",24)	SIEMENS_FLCOMPACT_VA01A_PROC	23	36	f	\N	US	1	Unknown	\N
8100	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",25)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",25)	SIEMENS_FLCOMPACT_VA01A_PROC	23	37	f	\N	US	1	Unknown	\N
8101	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",26)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",26)	SIEMENS_FLCOMPACT_VA01A_PROC	23	38	f	\N	US	1	Unknown	\N
8102	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",27)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",27)	SIEMENS_FLCOMPACT_VA01A_PROC	23	39	f	\N	US	1	Unknown	\N
8103	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",28)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",28)	SIEMENS_FLCOMPACT_VA01A_PROC	23	40	f	\N	FL	1	Unknown	\N
8104	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",29)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",29)	SIEMENS_FLCOMPACT_VA01A_PROC	23	41	f	\N	FL	1	Unknown	\N
8105	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",48)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",48)	SIEMENS_FLCOMPACT_VA01A_PROC	23	72	f	\N	SS	1	Unknown	\N
8106	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",49)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",49)	SIEMENS_FLCOMPACT_VA01A_PROC	23	73	f	\N	SS	1	Unknown	\N
8107	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4d)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4d)	SIEMENS_FLCOMPACT_VA01A_PROC	23	77	f	\N	SS	1	Unknown	\N
8108	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4e)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4e)	SIEMENS_FLCOMPACT_VA01A_PROC	23	78	f	\N	LO	1	Unknown	\N
8109	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4f)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4f)	SIEMENS_FLCOMPACT_VA01A_PROC	23	79	f	\N	LO	1	Unknown	\N
8110	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",50)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",50)	SIEMENS_FLCOMPACT_VA01A_PROC	23	80	f	\N	SS	1	Unknown	\N
8111	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",51)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",51)	SIEMENS_FLCOMPACT_VA01A_PROC	23	81	f	\N	FL	1	Unknown	\N
8112	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",52)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",52)	SIEMENS_FLCOMPACT_VA01A_PROC	23	82	f	\N	SS	1	Unknown	\N
8113	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",53)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",53)	SIEMENS_FLCOMPACT_VA01A_PROC	23	83	f	\N	SS	1	Unknown	\N
8114	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",54)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",54)	SIEMENS_FLCOMPACT_VA01A_PROC	23	84	f	\N	SS	1	Unknown	\N
8115	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",55)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",55)	SIEMENS_FLCOMPACT_VA01A_PROC	23	85	f	\N	SS	1	Unknown	\N
8116	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",5c)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",5c)	SIEMENS_FLCOMPACT_VA01A_PROC	23	92	f	\N	OW	1	Unknown	\N
8117	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",64)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",64)	SIEMENS_FLCOMPACT_VA01A_PROC	23	100	f	\N	US	1	Unknown	\N
8118	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",66)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",66)	SIEMENS_FLCOMPACT_VA01A_PROC	23	102	f	\N	US	1	Unknown	\N
8119	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",67)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",67)	SIEMENS_FLCOMPACT_VA01A_PROC	23	103	f	\N	US	1	Unknown	\N
8120	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",68)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",68)	SIEMENS_FLCOMPACT_VA01A_PROC	23	104	f	\N	US	1	Unknown	\N
8121	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",85)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",85)	SIEMENS_FLCOMPACT_VA01A_PROC	23	133	f	\N	US	1	Unknown	\N
8122	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",86)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",86)	SIEMENS_FLCOMPACT_VA01A_PROC	23	134	f	\N	US	1	Unknown	\N
8123	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",87)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",87)	SIEMENS_FLCOMPACT_VA01A_PROC	23	135	f	\N	US	1	Unknown	\N
8124	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",88)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",88)	SIEMENS_FLCOMPACT_VA01A_PROC	23	136	f	\N	US	1	Unknown	\N
8125	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",89)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",89)	SIEMENS_FLCOMPACT_VA01A_PROC	23	137	f	\N	US	1	Unknown	\N
8126	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8a)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8a)	SIEMENS_FLCOMPACT_VA01A_PROC	23	138	f	\N	US	1	Unknown	\N
8127	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8b)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8b)	SIEMENS_FLCOMPACT_VA01A_PROC	23	139	f	\N	US	1	Unknown	\N
8128	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8c)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8c)	SIEMENS_FLCOMPACT_VA01A_PROC	23	140	f	\N	FL	1	Unknown	\N
8129	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8d)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8d)	SIEMENS_FLCOMPACT_VA01A_PROC	23	141	f	\N	FL	1	Unknown	\N
8130	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8e)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8e)	SIEMENS_FLCOMPACT_VA01A_PROC	23	142	f	\N	US	1	Unknown	\N
8131	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8f)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8f)	SIEMENS_FLCOMPACT_VA01A_PROC	23	143	f	\N	US	1	Unknown	\N
8132	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a0)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a0)	SIEMENS_FLCOMPACT_VA01A_PROC	23	160	f	\N	US	1	Unknown	\N
8133	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a1)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a1)	SIEMENS_FLCOMPACT_VA01A_PROC	23	161	f	\N	US	1	Unknown	\N
8134	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a2)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a2)	SIEMENS_FLCOMPACT_VA01A_PROC	23	162	f	\N	LO	1	Unknown	\N
8135	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a3)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a3)	SIEMENS_FLCOMPACT_VA01A_PROC	23	163	f	\N	US	1	Unknown	\N
8136	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a4)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a4)	SIEMENS_FLCOMPACT_VA01A_PROC	23	164	f	\N	US	1	Unknown	\N
8137	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a5)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a5)	SIEMENS_FLCOMPACT_VA01A_PROC	23	165	f	\N	US	1	Unknown	\N
8138	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a6)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a6)	SIEMENS_FLCOMPACT_VA01A_PROC	23	166	f	\N	US	1	Unknown	\N
8139	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",aa)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",aa)	SIEMENS_FLCOMPACT_VA01A_PROC	23	170	f	\N	US	1	Unknown	\N
8140	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",b0)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",b0)	SIEMENS_FLCOMPACT_VA01A_PROC	23	176	f	\N	DS	1	Unknown	\N
8141	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",c0)	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",c0)	SIEMENS_FLCOMPACT_VA01A_PROC	23	192	f	\N	LO	1	Unknown	\N
8142	(0017,"SIEMENS DFR.01 ORIGINAL",11)	(0017,"SIEMENS DFR.01 ORIGINAL",11)	SIEMENS DFR.01 ORIGINAL	23	17	f	\N	US	1	Unknown	\N
8143	(0017,"SIEMENS DFR.01 ORIGINAL",12)	(0017,"SIEMENS DFR.01 ORIGINAL",12)	SIEMENS DFR.01 ORIGINAL	23	18	f	\N	US	1	Unknown	\N
8144	(0017,"SIEMENS DFR.01 ORIGINAL",14)	(0017,"SIEMENS DFR.01 ORIGINAL",14)	SIEMENS DFR.01 ORIGINAL	23	20	f	\N	US	1	Unknown	\N
8145	(0017,"SIEMENS DFR.01 ORIGINAL",15)	(0017,"SIEMENS DFR.01 ORIGINAL",15)	SIEMENS DFR.01 ORIGINAL	23	21	f	\N	US	1	Unknown	\N
8146	(0017,"SIEMENS DFR.01 ORIGINAL",16)	(0017,"SIEMENS DFR.01 ORIGINAL",16)	SIEMENS DFR.01 ORIGINAL	23	22	f	\N	US	1	Unknown	\N
8147	(0017,"SIEMENS DFR.01 ORIGINAL",18)	(0017,"SIEMENS DFR.01 ORIGINAL",18)	SIEMENS DFR.01 ORIGINAL	23	24	f	\N	US	1	Unknown	\N
8148	(0017,"SIEMENS DFR.01 ORIGINAL",21)	(0017,"SIEMENS DFR.01 ORIGINAL",21)	SIEMENS DFR.01 ORIGINAL	23	33	f	\N	US	1	Unknown	\N
8149	(0017,"SIEMENS DFR.01 ORIGINAL",22)	(0017,"SIEMENS DFR.01 ORIGINAL",22)	SIEMENS DFR.01 ORIGINAL	23	34	f	\N	US	1	Unknown	\N
8150	(0017,"SIEMENS DFR.01 ORIGINAL",23)	(0017,"SIEMENS DFR.01 ORIGINAL",23)	SIEMENS DFR.01 ORIGINAL	23	35	f	\N	US	1	Unknown	\N
8151	(0017,"SIEMENS DFR.01 ORIGINAL",24)	(0017,"SIEMENS DFR.01 ORIGINAL",24)	SIEMENS DFR.01 ORIGINAL	23	36	f	\N	US	1	Unknown	\N
8152	(0017,"SIEMENS DFR.01 ORIGINAL",25)	(0017,"SIEMENS DFR.01 ORIGINAL",25)	SIEMENS DFR.01 ORIGINAL	23	37	f	\N	IS	1	Unknown	\N
8153	(0017,"SIEMENS DFR.01 ORIGINAL",26)	(0017,"SIEMENS DFR.01 ORIGINAL",26)	SIEMENS DFR.01 ORIGINAL	23	38	f	\N	US	1	Unknown	\N
8154	(0017,"SIEMENS DFR.01 ORIGINAL",27)	(0017,"SIEMENS DFR.01 ORIGINAL",27)	SIEMENS DFR.01 ORIGINAL	23	39	f	\N	IS	1	Unknown	\N
8155	(0017,"SIEMENS DFR.01 ORIGINAL",2a)	(0017,"SIEMENS DFR.01 ORIGINAL",2a)	SIEMENS DFR.01 ORIGINAL	23	42	f	\N	US	1	Unknown	\N
8156	(0017,"SIEMENS DFR.01 ORIGINAL",30)	(0017,"SIEMENS DFR.01 ORIGINAL",30)	SIEMENS DFR.01 ORIGINAL	23	48	f	\N	IS	1	Unknown	\N
8157	(0017,"SIEMENS DFR.01 ORIGINAL",31)	(0017,"SIEMENS DFR.01 ORIGINAL",31)	SIEMENS DFR.01 ORIGINAL	23	49	f	\N	US	1	Unknown	\N
8158	(0017,"SIEMENS DFR.01 ORIGINAL",32)	(0017,"SIEMENS DFR.01 ORIGINAL",32)	SIEMENS DFR.01 ORIGINAL	23	50	f	\N	US	1	Unknown	\N
8159	(0017,"SIEMENS DFR.01 ORIGINAL",33)	(0017,"SIEMENS DFR.01 ORIGINAL",33)	SIEMENS DFR.01 ORIGINAL	23	51	f	\N	US	1	Unknown	\N
8160	(0017,"SIEMENS DFR.01 ORIGINAL",37)	(0017,"SIEMENS DFR.01 ORIGINAL",37)	SIEMENS DFR.01 ORIGINAL	23	55	f	\N	US	1	Unknown	\N
8161	(0017,"SIEMENS DFR.01 ORIGINAL",38)	(0017,"SIEMENS DFR.01 ORIGINAL",38)	SIEMENS DFR.01 ORIGINAL	23	56	f	\N	US	1	Unknown	\N
8162	(0017,"SIEMENS DFR.01 ORIGINAL",41)	(0017,"SIEMENS DFR.01 ORIGINAL",41)	SIEMENS DFR.01 ORIGINAL	23	65	f	\N	IS	1	Unknown	\N
8163	(0017,"SIEMENS DFR.01 ORIGINAL",43)	(0017,"SIEMENS DFR.01 ORIGINAL",43)	SIEMENS DFR.01 ORIGINAL	23	67	f	\N	US	1	Unknown	\N
8164	(0017,"SIEMENS DFR.01 ORIGINAL",44)	(0017,"SIEMENS DFR.01 ORIGINAL",44)	SIEMENS DFR.01 ORIGINAL	23	68	f	\N	US	1	Unknown	\N
8165	(0017,"SIEMENS DFR.01 ORIGINAL",45)	(0017,"SIEMENS DFR.01 ORIGINAL",45)	SIEMENS DFR.01 ORIGINAL	23	69	f	\N	DS	1	Unknown	\N
8166	(0017,"SIEMENS DFR.01 ORIGINAL",46)	(0017,"SIEMENS DFR.01 ORIGINAL",46)	SIEMENS DFR.01 ORIGINAL	23	70	f	\N	DS	1	Unknown	\N
8167	(0017,"SIEMENS DFR.01 ORIGINAL",47)	(0017,"SIEMENS DFR.01 ORIGINAL",47)	SIEMENS DFR.01 ORIGINAL	23	71	f	\N	SH	1	Unknown	\N
8168	(0017,"SIEMENS DFR.01 ORIGINAL",48)	(0017,"SIEMENS DFR.01 ORIGINAL",48)	SIEMENS DFR.01 ORIGINAL	23	72	f	\N	IS	1	Unknown	\N
8169	(0017,"SIEMENS DFR.01 ORIGINAL",49)	(0017,"SIEMENS DFR.01 ORIGINAL",49)	SIEMENS DFR.01 ORIGINAL	23	73	f	\N	LO	1	Unknown	\N
8170	(0017,"SIEMENS DFR.01 ORIGINAL",4a)	(0017,"SIEMENS DFR.01 ORIGINAL",4a)	SIEMENS DFR.01 ORIGINAL	23	74	f	\N	IS	1	Unknown	\N
8171	(0017,"SIEMENS DFR.01 ORIGINAL",51)	(0017,"SIEMENS DFR.01 ORIGINAL",51)	SIEMENS DFR.01 ORIGINAL	23	81	f	\N	US	1	Unknown	\N
8172	(0017,"SIEMENS DFR.01 ORIGINAL",52)	(0017,"SIEMENS DFR.01 ORIGINAL",52)	SIEMENS DFR.01 ORIGINAL	23	82	f	\N	UL	1	Unknown	\N
8173	(0017,"SIEMENS DFR.01 ORIGINAL",61)	(0017,"SIEMENS DFR.01 ORIGINAL",61)	SIEMENS DFR.01 ORIGINAL	23	97	f	\N	US	1	Unknown	\N
8174	(0017,"SIEMENS DFR.01 ORIGINAL",62)	(0017,"SIEMENS DFR.01 ORIGINAL",62)	SIEMENS DFR.01 ORIGINAL	23	98	f	\N	US	1	Unknown	\N
8175	(0017,"SIEMENS DFR.01 ORIGINAL",71)	(0017,"SIEMENS DFR.01 ORIGINAL",71)	SIEMENS DFR.01 ORIGINAL	23	113	f	\N	IS	1	Unknown	\N
8176	(0017,"SIEMENS DFR.01 ORIGINAL",72)	(0017,"SIEMENS DFR.01 ORIGINAL",72)	SIEMENS DFR.01 ORIGINAL	23	114	f	\N	US	1	Unknown	\N
8177	(0017,"SIEMENS DFR.01 ORIGINAL",73)	(0017,"SIEMENS DFR.01 ORIGINAL",73)	SIEMENS DFR.01 ORIGINAL	23	115	f	\N	US	1	Unknown	\N
8178	(0017,"SIEMENS DFR.01 ORIGINAL",74)	(0017,"SIEMENS DFR.01 ORIGINAL",74)	SIEMENS DFR.01 ORIGINAL	23	116	f	\N	US	1	Unknown	\N
8179	(0017,"SIEMENS DFR.01 ORIGINAL",79)	(0017,"SIEMENS DFR.01 ORIGINAL",79)	SIEMENS DFR.01 ORIGINAL	23	121	f	\N	US	1	Unknown	\N
8180	(0017,"SIEMENS DFR.01 ORIGINAL",7a)	(0017,"SIEMENS DFR.01 ORIGINAL",7a)	SIEMENS DFR.01 ORIGINAL	23	122	f	\N	US	1	Unknown	\N
8181	(0017,"SIEMENS DFR.01 ORIGINAL",7b)	(0017,"SIEMENS DFR.01 ORIGINAL",7b)	SIEMENS DFR.01 ORIGINAL	23	123	f	\N	IS	1	Unknown	\N
8182	(0017,"SIEMENS DFR.01 ORIGINAL",a0)	(0017,"SIEMENS DFR.01 ORIGINAL",a0)	SIEMENS DFR.01 ORIGINAL	23	160	f	\N	IS	1	Unknown	\N
8183	(0017,"SIEMENS DFR.01 ORIGINAL",c1)	(0017,"SIEMENS DFR.01 ORIGINAL",c1)	SIEMENS DFR.01 ORIGINAL	23	193	f	\N	LO	1	Unknown	\N
8184	(0017,"SIEMENS DFR.01 ORIGINAL",c2)	(0017,"SIEMENS DFR.01 ORIGINAL",c2)	SIEMENS DFR.01 ORIGINAL	23	194	f	\N	LO	1	Unknown	\N
8185	(0017,"SIEMENS DFR.01 MANIPULATED",11)	(0017,"SIEMENS DFR.01 MANIPULATED",11)	SIEMENS DFR.01 MANIPULATED	23	17	f	\N	US	1	Unknown	\N
8186	(0017,"SIEMENS DFR.01 MANIPULATED",12)	(0017,"SIEMENS DFR.01 MANIPULATED",12)	SIEMENS DFR.01 MANIPULATED	23	18	f	\N	US	1	Unknown	\N
8187	(0017,"SIEMENS DFR.01 MANIPULATED",14)	(0017,"SIEMENS DFR.01 MANIPULATED",14)	SIEMENS DFR.01 MANIPULATED	23	20	f	\N	US	1	Unknown	\N
8188	(0017,"SIEMENS DFR.01 MANIPULATED",15)	(0017,"SIEMENS DFR.01 MANIPULATED",15)	SIEMENS DFR.01 MANIPULATED	23	21	f	\N	US	1	Unknown	\N
8189	(0017,"SIEMENS DFR.01 MANIPULATED",25)	(0017,"SIEMENS DFR.01 MANIPULATED",25)	SIEMENS DFR.01 MANIPULATED	23	37	f	\N	IS	1	Unknown	\N
8190	(0017,"SIEMENS DFR.01 MANIPULATED",27)	(0017,"SIEMENS DFR.01 MANIPULATED",27)	SIEMENS DFR.01 MANIPULATED	23	39	f	\N	IS	1	Unknown	\N
8191	(0017,"SIEMENS DFR.01 MANIPULATED",29)	(0017,"SIEMENS DFR.01 MANIPULATED",29)	SIEMENS DFR.01 MANIPULATED	23	41	f	\N	IS	1	Edge Enhancement %	\N
8192	(0017,"SIEMENS DFR.01 MANIPULATED",30)	(0017,"SIEMENS DFR.01 MANIPULATED",30)	SIEMENS DFR.01 MANIPULATED	23	48	f	\N	IS	1	Harmonization %	\N
8193	(0017,"SIEMENS DFR.01 MANIPULATED",31)	(0017,"SIEMENS DFR.01 MANIPULATED",31)	SIEMENS DFR.01 MANIPULATED	23	49	f	\N	US	1	Unknown	\N
8194	(0017,"SIEMENS DFR.01 MANIPULATED",32)	(0017,"SIEMENS DFR.01 MANIPULATED",32)	SIEMENS DFR.01 MANIPULATED	23	50	f	\N	US	1	Unknown	\N
8195	(0017,"SIEMENS DFR.01 MANIPULATED",33)	(0017,"SIEMENS DFR.01 MANIPULATED",33)	SIEMENS DFR.01 MANIPULATED	23	51	f	\N	US	1	Unknown	\N
8196	(0017,"SIEMENS DFR.01 MANIPULATED",35)	(0017,"SIEMENS DFR.01 MANIPULATED",35)	SIEMENS DFR.01 MANIPULATED	23	53	f	\N	US	1	Unknown	\N
8197	(0017,"SIEMENS DFR.01 MANIPULATED",37)	(0017,"SIEMENS DFR.01 MANIPULATED",37)	SIEMENS DFR.01 MANIPULATED	23	55	f	\N	US	1	Unknown	\N
8198	(0017,"SIEMENS DFR.01 MANIPULATED",38)	(0017,"SIEMENS DFR.01 MANIPULATED",38)	SIEMENS DFR.01 MANIPULATED	23	56	f	\N	US	1	Unknown	\N
8199	(0017,"SIEMENS DFR.01 MANIPULATED",71)	(0017,"SIEMENS DFR.01 MANIPULATED",71)	SIEMENS DFR.01 MANIPULATED	23	113	f	\N	IS	1	Landmark	\N
8200	(0017,"SIEMENS DFR.01 MANIPULATED",72)	(0017,"SIEMENS DFR.01 MANIPULATED",72)	SIEMENS DFR.01 MANIPULATED	23	114	f	\N	US	1	Unknown	\N
8201	(0017,"SIEMENS DFR.01 MANIPULATED",73)	(0017,"SIEMENS DFR.01 MANIPULATED",73)	SIEMENS DFR.01 MANIPULATED	23	115	f	\N	US	1	Unknown	\N
8202	(0017,"SIEMENS DFR.01 MANIPULATED",74)	(0017,"SIEMENS DFR.01 MANIPULATED",74)	SIEMENS DFR.01 MANIPULATED	23	116	f	\N	US	1	Unknown	\N
8203	(0017,"SIEMENS DFR.01 MANIPULATED",77)	(0017,"SIEMENS DFR.01 MANIPULATED",77)	SIEMENS DFR.01 MANIPULATED	23	119	f	\N	DS	1	Pixel Shift horizontal	\N
8204	(0017,"SIEMENS DFR.01 MANIPULATED",78)	(0017,"SIEMENS DFR.01 MANIPULATED",78)	SIEMENS DFR.01 MANIPULATED	23	120	f	\N	DS	1	Pixel Shift vertical	\N
8205	(0017,"SIEMENS DFR.01 MANIPULATED",79)	(0017,"SIEMENS DFR.01 MANIPULATED",79)	SIEMENS DFR.01 MANIPULATED	23	121	f	\N	US	1	Unknown	\N
8206	(0017,"SIEMENS DFR.01 MANIPULATED",7a)	(0017,"SIEMENS DFR.01 MANIPULATED",7a)	SIEMENS DFR.01 MANIPULATED	23	122	f	\N	US	1	Unknown	\N
8207	(0017,"SIEMENS DFR.01 MANIPULATED",80)	(0017,"SIEMENS DFR.01 MANIPULATED",80)	SIEMENS DFR.01 MANIPULATED	23	128	f	\N	US	1	Unknown	\N
8208	(0017,"SIEMENS DFR.01 MANIPULATED",83)	(0017,"SIEMENS DFR.01 MANIPULATED",83)	SIEMENS DFR.01 MANIPULATED	23	131	f	\N	LO	1	Left Marker	\N
8209	(0017,"SIEMENS DFR.01 MANIPULATED",84)	(0017,"SIEMENS DFR.01 MANIPULATED",84)	SIEMENS DFR.01 MANIPULATED	23	132	f	\N	LO	1	Right Marker	\N
8210	(0017,"SIEMENS DFR.01 MANIPULATED",a1)	(0017,"SIEMENS DFR.01 MANIPULATED",a1)	SIEMENS DFR.01 MANIPULATED	23	161	f	\N	SH	1	Unknown	\N
8211	(0017,"SIEMENS DFR.01 MANIPULATED",a2)	(0017,"SIEMENS DFR.01 MANIPULATED",a2)	SIEMENS DFR.01 MANIPULATED	23	162	f	\N	SH	1	Image Name Extension 1	\N
8212	(0017,"SIEMENS DFR.01 MANIPULATED",a3)	(0017,"SIEMENS DFR.01 MANIPULATED",a3)	SIEMENS DFR.01 MANIPULATED	23	163	f	\N	SH	1	Image Name Extension 2	\N
8213	(0019,"SIEMENS MED SP DXMG WH AWS 1",01)	(0019,"SIEMENS MED SP DXMG WH AWS 1",01)	SIEMENS MED SP DXMG WH AWS 1	25	1	f	\N	UL	1-n	AEC Coordinates	\N
8214	(0019,"SIEMENS MED SP DXMG WH AWS 1",02)	(0019,"SIEMENS MED SP DXMG WH AWS 1",02)	SIEMENS MED SP DXMG WH AWS 1	25	2	f	\N	US	2	AEC Coordinates Size	\N
8215	(0019,"SIEMENS MED SP DXMG WH AWS 1",10)	(0019,"SIEMENS MED SP DXMG WH AWS 1",10)	SIEMENS MED SP DXMG WH AWS 1	25	16	f	\N	ST	1	Derivation Description	\N
8216	(0019,"SIEMENS MED NM",08)	(0019,"SIEMENS MED NM",08)	SIEMENS MED NM	25	8	f	\N	SS	1	Unknown	\N
8217	(0019,"SIEMENS MED NM",0f)	(0019,"SIEMENS MED NM",0f)	SIEMENS MED NM	25	15	f	\N	SL	1-n	Siemens ICON Data Type	\N
8218	(0019,"SIEMENS MED NM",16)	(0019,"SIEMENS MED NM",16)	SIEMENS MED NM	25	22	f	\N	SS	1	Unknown	\N
8219	(0019,"SIEMENS MED NM",a5)	(0019,"SIEMENS MED NM",a5)	SIEMENS MED NM	25	165	f	\N	SS	1-n	Number of Repeats per Phase	\N
8220	(0019,"SIEMENS MED NM",a6)	(0019,"SIEMENS MED NM",a6)	SIEMENS MED NM	25	166	f	\N	SS	1-n	Cycles per Repeat	\N
8221	(0019,"SIEMENS MED NM",a7)	(0019,"SIEMENS MED NM",a7)	SIEMENS MED NM	25	167	f	\N	SL	1-n	Repeat Start Time	\N
8222	(0019,"SIEMENS MED NM",a8)	(0019,"SIEMENS MED NM",a8)	SIEMENS MED NM	25	168	f	\N	SL	1-n	Repeat Stop Time	\N
8223	(0019,"SIEMENS MED NM",a9)	(0019,"SIEMENS MED NM",a9)	SIEMENS MED NM	25	169	f	\N	SL	1-n	Effective Repeat Time	\N
8224	(0019,"SIEMENS MED NM",aa)	(0019,"SIEMENS MED NM",aa)	SIEMENS MED NM	25	170	f	\N	SS	1-n	Acquired Cycles per Repeat	\N
8225	(0019,"SIEMENS RA PLANE B",15)	(0019,"SIEMENS RA PLANE B",15)	SIEMENS RA PLANE B	25	21	f	\N	OB	1	Unknown	\N
8226	(0019,"SIEMENS RA PLANE B",ae)	(0019,"SIEMENS RA PLANE B",ae)	SIEMENS RA PLANE B	25	174	f	\N	UL	1	Unknown	\N
8227	(0019,"SIEMENS RA PLANE B",b0)	(0019,"SIEMENS RA PLANE B",b0)	SIEMENS RA PLANE B	25	176	f	\N	US	1	Unknown	\N
8228	(0019,"SIEMENS RA PLANE B",b1)	(0019,"SIEMENS RA PLANE B",b1)	SIEMENS RA PLANE B	25	177	f	\N	US	1	Unknown	\N
8229	(0019,"SIEMENS RA PLANE B",b2)	(0019,"SIEMENS RA PLANE B",b2)	SIEMENS RA PLANE B	25	178	f	\N	US	1	Unknown	\N
8230	(0019,"SIEMENS RA PLANE B",b3)	(0019,"SIEMENS RA PLANE B",b3)	SIEMENS RA PLANE B	25	179	f	\N	US	1	Unknown	\N
8231	(0019,"SIEMENS RA PLANE B",b4)	(0019,"SIEMENS RA PLANE B",b4)	SIEMENS RA PLANE B	25	180	f	\N	US	1	Unknown	\N
8232	(0019,"SIEMENS RA PLANE B",b5)	(0019,"SIEMENS RA PLANE B",b5)	SIEMENS RA PLANE B	25	181	f	\N	US	1	Unknown	\N
8233	(0019,"SIEMENS RA PLANE B",b6)	(0019,"SIEMENS RA PLANE B",b6)	SIEMENS RA PLANE B	25	182	f	\N	US	1	Unknown	\N
8234	(0019,"SIEMENS RA PLANE B",b7)	(0019,"SIEMENS RA PLANE B",b7)	SIEMENS RA PLANE B	25	183	f	\N	US	1	Unknown	\N
8236	(0019,"SIEMENS RA PLANE B",b9)	(0019,"SIEMENS RA PLANE B",b9)	SIEMENS RA PLANE B	25	185	f	\N	US	1	Unknown	\N
8237	(0019,"SIEMENS RA PLANE B",bb)	(0019,"SIEMENS RA PLANE B",bb)	SIEMENS RA PLANE B	25	187	f	\N	UL	1	Unknown	\N
8238	(0019,"SIEMENS RA PLANE B",bc)	(0019,"SIEMENS RA PLANE B",bc)	SIEMENS RA PLANE B	25	188	f	\N	UL	1	Unknown	\N
8239	(0019,"SIEMENS RA PLANE B",bd)	(0019,"SIEMENS RA PLANE B",bd)	SIEMENS RA PLANE B	25	189	f	\N	UL	1	Unknown	\N
8240	(0019,"SIEMENS RA PLANE B",be)	(0019,"SIEMENS RA PLANE B",be)	SIEMENS RA PLANE B	25	190	f	\N	UL	1	Unknown	\N
8241	(0019,"SIEMENS RA PLANE B",bf)	(0019,"SIEMENS RA PLANE B",bf)	SIEMENS RA PLANE B	25	191	f	\N	UL	1	Unknown	\N
8242	(0019,"SIEMENS RA PLANE B",c0)	(0019,"SIEMENS RA PLANE B",c0)	SIEMENS RA PLANE B	25	192	f	\N	UL	1	Unknown	\N
8243	(0019,"SIEMENS RA PLANE B",c1)	(0019,"SIEMENS RA PLANE B",c1)	SIEMENS RA PLANE B	25	193	f	\N	UL	1	Unknown	\N
8244	(0019,"SIEMENS RA PLANE B",c2)	(0019,"SIEMENS RA PLANE B",c2)	SIEMENS RA PLANE B	25	194	f	\N	UL	1	Unknown	\N
8245	(0019,"SIEMENS RA PLANE B",c3)	(0019,"SIEMENS RA PLANE B",c3)	SIEMENS RA PLANE B	25	195	f	\N	UL	1	Unknown	\N
8246	(0019,"SIEMENS RA PLANE B",c4)	(0019,"SIEMENS RA PLANE B",c4)	SIEMENS RA PLANE B	25	196	f	\N	UL	1	Unknown	\N
8247	(0019,"SIEMENS RA PLANE B",c5)	(0019,"SIEMENS RA PLANE B",c5)	SIEMENS RA PLANE B	25	197	f	\N	UL	1	Unknown	\N
8248	(0019,"SIEMENS RA PLANE B",c6)	(0019,"SIEMENS RA PLANE B",c6)	SIEMENS RA PLANE B	25	198	f	\N	UL	1	Unknown	\N
8249	(0019,"SIEMENS RA PLANE B",c7)	(0019,"SIEMENS RA PLANE B",c7)	SIEMENS RA PLANE B	25	199	f	\N	UL	1	Unknown	\N
8250	(0019,"SIEMENS RA PLANE B",c8)	(0019,"SIEMENS RA PLANE B",c8)	SIEMENS RA PLANE B	25	200	f	\N	UL	1	Unknown	\N
8251	(0019,"SIEMENS RA PLANE B",c9)	(0019,"SIEMENS RA PLANE B",c9)	SIEMENS RA PLANE B	25	201	f	\N	UL	1	Unknown	\N
8252	(0019,"SIEMENS RA PLANE B",ca)	(0019,"SIEMENS RA PLANE B",ca)	SIEMENS RA PLANE B	25	202	f	\N	UL	1	Unknown	\N
8253	(0019,"SIEMENS RA PLANE B",cb)	(0019,"SIEMENS RA PLANE B",cb)	SIEMENS RA PLANE B	25	203	f	\N	UL	1	Unknown	\N
8254	(0019,"SIEMENS RA PLANE B",cc)	(0019,"SIEMENS RA PLANE B",cc)	SIEMENS RA PLANE B	25	204	f	\N	UL	1	Unknown	\N
8255	(0019,"SIEMENS RA PLANE B",cd)	(0019,"SIEMENS RA PLANE B",cd)	SIEMENS RA PLANE B	25	205	f	\N	UL	1	Unknown	\N
8256	(0019,"SIEMENS RA PLANE B",ce)	(0019,"SIEMENS RA PLANE B",ce)	SIEMENS RA PLANE B	25	206	f	\N	UL	1	Unknown	\N
8257	(0019,"SIEMENS RA PLANE B",cf)	(0019,"SIEMENS RA PLANE B",cf)	SIEMENS RA PLANE B	25	207	f	\N	UL	1	Unknown	\N
8258	(0019,"SIEMENS RA PLANE B",d1)	(0019,"SIEMENS RA PLANE B",d1)	SIEMENS RA PLANE B	25	209	f	\N	US	1	Unknown	\N
8259	(0019,"SIEMENS RA PLANE B",d2)	(0019,"SIEMENS RA PLANE B",d2)	SIEMENS RA PLANE B	25	210	f	\N	OB	1	Unknown	\N
8260	(0019,"SIEMENS RA PLANE B",d3)	(0019,"SIEMENS RA PLANE B",d3)	SIEMENS RA PLANE B	25	211	f	\N	OB	1	Unknown	\N
8261	(0019,"SIEMENS RA PLANE B",d4)	(0019,"SIEMENS RA PLANE B",d4)	SIEMENS RA PLANE B	25	212	f	\N	OB	1	Unknown	\N
8262	(0019,"SIEMENS RA PLANE B",d5)	(0019,"SIEMENS RA PLANE B",d5)	SIEMENS RA PLANE B	25	213	f	\N	OB	1	Unknown	\N
8263	(0019,"SIEMENS RA PLANE B",d6)	(0019,"SIEMENS RA PLANE B",d6)	SIEMENS RA PLANE B	25	214	f	\N	OB	1	Unknown	\N
8264	(0019,"SIEMENS RA PLANE B",d7)	(0019,"SIEMENS RA PLANE B",d7)	SIEMENS RA PLANE B	25	215	f	\N	OB	1	Unknown	\N
8265	(0019,"SIEMENS RA PLANE B",d8)	(0019,"SIEMENS RA PLANE B",d8)	SIEMENS RA PLANE B	25	216	f	\N	OB	1	Unknown	\N
8266	(0019,"SIEMENS RA PLANE B",d9)	(0019,"SIEMENS RA PLANE B",d9)	SIEMENS RA PLANE B	25	217	f	\N	OB	1	Unknown	\N
8267	(0019,"SIEMENS RA PLANE B",da)	(0019,"SIEMENS RA PLANE B",da)	SIEMENS RA PLANE B	25	218	f	\N	OB	1	Unknown	\N
8268	(0019,"SIEMENS RA PLANE B",db)	(0019,"SIEMENS RA PLANE B",db)	SIEMENS RA PLANE B	25	219	f	\N	OB	1	Unknown	\N
8269	(0019,"SIEMENS RA PLANE B",dc)	(0019,"SIEMENS RA PLANE B",dc)	SIEMENS RA PLANE B	25	220	f	\N	OB	1	Unknown	\N
8270	(0019,"SIEMENS RA PLANE B",dd)	(0019,"SIEMENS RA PLANE B",dd)	SIEMENS RA PLANE B	25	221	f	\N	UL	1	Unknown	\N
8271	(0019,"SIEMENS RA PLANE B",de)	(0019,"SIEMENS RA PLANE B",de)	SIEMENS RA PLANE B	25	222	f	\N	UL	1-n	Unknown	\N
8272	(0019,"SIEMENS RA PLANE B",df)	(0019,"SIEMENS RA PLANE B",df)	SIEMENS RA PLANE B	25	223	f	\N	OB	1	Unknown	\N
8273	(0019,"SIEMENS RA PLANE B",e0)	(0019,"SIEMENS RA PLANE B",e0)	SIEMENS RA PLANE B	25	224	f	\N	UL	1	Unknown	\N
8274	(0019,"SIEMENS CM VA0  CMS",70)	(0019,"SIEMENS CM VA0  CMS",70)	SIEMENS CM VA0  CMS	25	112	f	\N	DS	1-n	Unknown	\N
8275	(0019,"SIEMENS CM VA0  CMS",80)	(0019,"SIEMENS CM VA0  CMS",80)	SIEMENS CM VA0  CMS	25	128	f	\N	LO	1	Unknown	\N
8276	(0019,"SIEMENS MED NM",93)	(0019,"SIEMENS MED NM",93)	SIEMENS MED NM	25	147	f	\N	SL	2	Unknown	\N
8277	(0019,"SIEMENS CT VA0  COAD",a0)	(0019,"SIEMENS CT VA0  COAD",a0)	SIEMENS CT VA0  COAD	25	160	f	\N	DS	1	Unknown	\N
8278	(0019,"SIEMENS CT VA0  COAD",a1)	(0019,"SIEMENS CT VA0  COAD",a1)	SIEMENS CT VA0  COAD	25	161	f	\N	DS	1	Unknown	\N
8279	(0019,"SIEMENS MED NM",a1)	(0019,"SIEMENS MED NM",a1)	SIEMENS MED NM	25	161	f	\N	SS	1	Unknown	\N
8280	(0019,"SIEMENS CT VA0  COAD",a2)	(0019,"SIEMENS CT VA0  COAD",a2)	SIEMENS CT VA0  COAD	25	162	f	\N	CS	1	Unknown	\N
8281	(0019,"SIEMENS CT VA0  COAD",a3)	(0019,"SIEMENS CT VA0  COAD",a3)	SIEMENS CT VA0  COAD	25	163	f	\N	CS	1	Unknown	\N
8282	(0019,"SIEMENS MED NM",a3)	(0019,"SIEMENS MED NM",a3)	SIEMENS MED NM	25	163	f	\N	SL	2	Unknown	\N
8283	(0019,"SIEMENS CT VA0  COAD",a4)	(0019,"SIEMENS CT VA0  COAD",a4)	SIEMENS CT VA0  COAD	25	164	f	\N	DS	1	Unknown	\N
8284	(0019,"SIEMENS CT VA0  COAD",a5)	(0019,"SIEMENS CT VA0  COAD",a5)	SIEMENS CT VA0  COAD	25	165	f	\N	DS	1	Unknown	\N
8285	(0019,"SIEMENS CT VA0  COAD",a6)	(0019,"SIEMENS CT VA0  COAD",a6)	SIEMENS CT VA0  COAD	25	166	f	\N	UL	1-n	Unknown	\N
8286	(0019,"SIEMENS CT VA0  COAD",a7)	(0019,"SIEMENS CT VA0  COAD",a7)	SIEMENS CT VA0  COAD	25	167	f	\N	UL	1-n	Unknown	\N
8287	(0019,"SIEMENS CT VA0  COAD",a8)	(0019,"SIEMENS CT VA0  COAD",a8)	SIEMENS CT VA0  COAD	25	168	f	\N	UL	1-n	Unknown	\N
8288	(0019,"SIEMENS CT VA0  COAD",a9)	(0019,"SIEMENS CT VA0  COAD",a9)	SIEMENS CT VA0  COAD	25	169	f	\N	IS	1	Unknown	\N
8289	(0019,"SIEMENS CT VA0  COAD",aa)	(0019,"SIEMENS CT VA0  COAD",aa)	SIEMENS CT VA0  COAD	25	170	f	\N	CS	1	Unknown	\N
8290	(0019,"SIEMENS CT VA0  COAD",ab)	(0019,"SIEMENS CT VA0  COAD",ab)	SIEMENS CT VA0  COAD	25	171	f	\N	IS	1	Unknown	\N
8291	(0019,"SIEMENS CT VA0  COAD",ac)	(0019,"SIEMENS CT VA0  COAD",ac)	SIEMENS CT VA0  COAD	25	172	f	\N	IS	1	Unknown	\N
8292	(0019,"SIEMENS CT VA0  COAD",ad)	(0019,"SIEMENS CT VA0  COAD",ad)	SIEMENS CT VA0  COAD	25	173	f	\N	IS	1	Unknown	\N
8293	(0019,"SIEMENS CT VA0  COAD",ae)	(0019,"SIEMENS CT VA0  COAD",ae)	SIEMENS CT VA0  COAD	25	174	f	\N	IS	1	Unknown	\N
8294	(0019,"SIEMENS CT VA0  COAD",af)	(0019,"SIEMENS CT VA0  COAD",af)	SIEMENS CT VA0  COAD	25	175	f	\N	DS	1	Unknown	\N
10986	(0119,"MRSC",1213)	(0119,"MRSC",13)	MRSC	281	19	t	12	IS	1-n	IsotropicResolution	K
8303	(0019,"SIEMENS MED NM",c3)	(0019,"SIEMENS MED NM",c3)	SIEMENS MED NM	25	195	f	\N	ST	1	Unknown	\N
8304	(0019,"SIEMENS CT VA0  COAD",c4)	(0019,"SIEMENS CT VA0  COAD",c4)	SIEMENS CT VA0  COAD	25	196	f	\N	UL	1	Unknown	\N
8305	(0019,"SIEMENS CT VA0  COAD",c5)	(0019,"SIEMENS CT VA0  COAD",c5)	SIEMENS CT VA0  COAD	25	197	f	\N	IS	1	Unknown	\N
8306	(0019,"SIEMENS Selma",06)	(0019,"SIEMENS Selma",06)	SIEMENS Selma	25	6	f	\N	IS	1	Unknown	\N
8307	(0019,"SIEMENS Selma",07)	(0019,"SIEMENS Selma",07)	SIEMENS Selma	25	7	f	\N	IS	1	Unknown	\N
8308	(0019,"SIEMENS Selma",08)	(0019,"SIEMENS Selma",08)	SIEMENS Selma	25	8	f	\N	IS	1	Unknown	\N
8309	(0019,"SIEMENS Selma",26)	(0019,"SIEMENS Selma",26)	SIEMENS Selma	25	38	f	\N	LO	1	Unknown	\N
8310	(0019,"SIEMENS Selma",29)	(0019,"SIEMENS Selma",29)	SIEMENS Selma	25	41	f	\N	LO	1	Unknown	\N
8311	(0019,"SIEMENS Selma",30)	(0019,"SIEMENS Selma",30)	SIEMENS Selma	25	48	f	\N	US	1	Unknown	\N
8312	(0019,"SIEMENS Selma",31)	(0019,"SIEMENS Selma",31)	SIEMENS Selma	25	49	f	\N	US	1	Unknown	\N
8313	(0019,"SIEMENS Selma",32)	(0019,"SIEMENS Selma",32)	SIEMENS Selma	25	50	f	\N	US	1	Unknown	\N
8314	(0019,"SIEMENS Selma",33)	(0019,"SIEMENS Selma",33)	SIEMENS Selma	25	51	f	\N	US	1	Unknown	\N
8315	(0019,"SIEMENS Selma",34)	(0019,"SIEMENS Selma",34)	SIEMENS Selma	25	52	f	\N	US	1	Unknown	\N
8316	(0019,"SIEMENS Selma",35)	(0019,"SIEMENS Selma",35)	SIEMENS Selma	25	53	f	\N	US	1	Unknown	\N
8317	(0019,"SIEMENS SMS-AX  VIEW 1.0",0a)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0a)	SIEMENS SMS-AX  VIEW 1.0	25	10	f	\N	SS	1	Native Edge Enhancement Kernel Size	\N
8318	(0019,"SIEMENS SMS-AX  VIEW 1.0",0b)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0b)	SIEMENS SMS-AX  VIEW 1.0	25	11	f	\N	US	1	Subtracted Edge Enhancement Percent Gain	\N
8319	(0019,"SIEMENS SMS-AX  VIEW 1.0",0c)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0c)	SIEMENS SMS-AX  VIEW 1.0	25	12	f	\N	SS	1	Subtracted Edge Enhancement LUT Index	\N
8320	(0019,"SIEMENS SMS-AX  VIEW 1.0",0d)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0d)	SIEMENS SMS-AX  VIEW 1.0	25	13	f	\N	SS	1	Subtracted Edge Enhancement Kernel Size	\N
8321	(0019,"SIEMENS SMS-AX  VIEW 1.0",0e)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0e)	SIEMENS SMS-AX  VIEW 1.0	25	14	f	\N	US	1	Fade Percent	\N
8322	(0019,"SIEMENS SMS-AX  VIEW 1.0",0f)	(0019,"SIEMENS SMS-AX  VIEW 1.0",0f)	SIEMENS SMS-AX  VIEW 1.0	25	15	f	\N	US	1	Flipped Before Laterality Applied	\N
8323	(0019,"SIEMENS SMS-AX  VIEW 1.0",11)	(0019,"SIEMENS SMS-AX  VIEW 1.0",11)	SIEMENS SMS-AX  VIEW 1.0	25	17	f	\N	US	1	Reference Images Taken Flag	\N
8324	(0019,"SIEMENS SMS-AX  VIEW 1.0",1a)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1a)	SIEMENS SMS-AX  VIEW 1.0	25	26	f	\N	OB	1	Quant 1K Overlay	\N
8325	(0019,"SIEMENS SMS-AX  VIEW 1.0",1b)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1b)	SIEMENS SMS-AX  VIEW 1.0	25	27	f	\N	US	1	Original Resolution	\N
8326	(0019,"SIEMENS SMS-AX  VIEW 1.0",1c)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1c)	SIEMENS SMS-AX  VIEW 1.0	25	28	f	\N	DS	1	Auto Window Center	\N
8327	(0019,"SIEMENS SMS-AX  VIEW 1.0",1d)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1d)	SIEMENS SMS-AX  VIEW 1.0	25	29	f	\N	DS	1	Auto Window Width	\N
8328	(0019,"SIEMENS SMS-AX  VIEW 1.0",1e)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1e)	SIEMENS SMS-AX  VIEW 1.0	25	30	f	\N	IS	2	Auto Window Correct Value	\N
8329	(0019,"SIEMENS SMS-AX  VIEW 1.0",1f)	(0019,"SIEMENS SMS-AX  VIEW 1.0",1f)	SIEMENS SMS-AX  VIEW 1.0	25	31	f	\N	DS	1	Sigmoid Window Parameter	\N
8330	(0019,"SIEMENS SMS-AX  VIEW 1.0",41)	(0019,"SIEMENS SMS-AX  VIEW 1.0",41)	SIEMENS SMS-AX  VIEW 1.0	25	65	f	\N	SL	2	Dispayed Area Top Left Hand Corner	\N
8331	(0019,"SIEMENS SMS-AX  VIEW 1.0",42)	(0019,"SIEMENS SMS-AX  VIEW 1.0",42)	SIEMENS SMS-AX  VIEW 1.0	25	66	f	\N	SL	2	Dispayed Area Bottom Right Hand Corner	\N
8332	(0019,"SIEMENS SIENET",01)	(0019,"SIEMENS SIENET",01)	SIEMENS SIENET	25	1	f	\N	DS	1	Unknown	\N
8333	(0019,"SIEMENS MED SMS USG ANTARES",00)	(0019,"SIEMENS MED SMS USG ANTARES",00)	SIEMENS MED SMS USG ANTARES	25	0	f	\N	SH	1	Unknown	\N
8334	(0019,"SIEMENS MED SMS USG ANTARES",03)	(0019,"SIEMENS MED SMS USG ANTARES",03)	SIEMENS MED SMS USG ANTARES	25	3	f	\N	FD	1	Unknown	\N
8335	(0019,"SIEMENS MED SMS USG ANTARES",0c)	(0019,"SIEMENS MED SMS USG ANTARES",0c)	SIEMENS MED SMS USG ANTARES	25	12	f	\N	US	1	Unknown	\N
8336	(0019,"SIEMENS MED SMS USG ANTARES",0d)	(0019,"SIEMENS MED SMS USG ANTARES",0d)	SIEMENS MED SMS USG ANTARES	25	13	f	\N	SH	1	Unknown	\N
8337	(0019,"SIEMENS MED SMS USG ANTARES",0e)	(0019,"SIEMENS MED SMS USG ANTARES",0e)	SIEMENS MED SMS USG ANTARES	25	14	f	\N	US	1	Unknown	\N
8338	(0019,"SIEMENS MED SMS USG ANTARES",95)	(0019,"SIEMENS MED SMS USG ANTARES",95)	SIEMENS MED SMS USG ANTARES	25	149	f	\N	US	1	Unknown	\N
8339	(0019,"SIEMENS MED SMS USG ANTARES",20)	(0019,"SIEMENS MED SMS USG ANTARES",20)	SIEMENS MED SMS USG ANTARES	25	32	f	\N	SH	1	Unknown	\N
8340	(0019,"SIEMENS MED SMS USG ANTARES",21)	(0019,"SIEMENS MED SMS USG ANTARES",21)	SIEMENS MED SMS USG ANTARES	25	33	f	\N	FD	1	Unknown	\N
8647	(0029,"SIEMENS SYNGO VOLUME",44)	(0029,"SIEMENS SYNGO VOLUME",44)	SIEMENS SYNGO VOLUME	41	68	f	\N	SQ	1	SubVolume Sequence	\N
8296	(0019,"SIEMENS CT VA0  COAD",bd)	(0019,"SIEMENS CT VA0  COAD",bd)	SIEMENS CT VA0  COAD	25	189	f	\N	IS	1	Pulmo Trigger Level	R
8298	(0019,"SIEMENS CT VA0  COAD",bf)	(0019,"SIEMENS CT VA0  COAD",bf)	SIEMENS CT VA0  COAD	25	191	f	\N	DS	1	Vital Capacity	K
8299	(0019,"SIEMENS CT VA0  COAD",c0)	(0019,"SIEMENS CT VA0  COAD",c0)	SIEMENS CT VA0  COAD	25	192	f	\N	DS	1	Pulmo Water	K
8300	(0019,"SIEMENS CT VA0  COAD",c1)	(0019,"SIEMENS CT VA0  COAD",c1)	SIEMENS CT VA0  COAD	25	193	f	\N	DS	1	Pulmo Air	K
8301	(0019,"SIEMENS CT VA0  COAD",c2)	(0019,"SIEMENS CT VA0  COAD",c2)	SIEMENS CT VA0  COAD	25	194	f	\N	DA	1	Pulmo Date	R
8302	(0019,"SIEMENS CT VA0  COAD",c3)	(0019,"SIEMENS CT VA0  COAD",c3)	SIEMENS CT VA0  COAD	25	195	f	\N	TM	1	Pulmo Time	R
8341	(0019,"SIEMENS MED SMS USG ANTARES",22)	(0019,"SIEMENS MED SMS USG ANTARES",22)	SIEMENS MED SMS USG ANTARES	25	34	f	\N	FD	1	Unknown	\N
8342	(0019,"SIEMENS MED SMS USG ANTARES",23)	(0019,"SIEMENS MED SMS USG ANTARES",23)	SIEMENS MED SMS USG ANTARES	25	35	f	\N	US	1	Unknown	\N
8343	(0019,"SIEMENS MED SMS USG ANTARES",24)	(0019,"SIEMENS MED SMS USG ANTARES",24)	SIEMENS MED SMS USG ANTARES	25	36	f	\N	US	1	Unknown	\N
8344	(0019,"SIEMENS MED SMS USG ANTARES",25)	(0019,"SIEMENS MED SMS USG ANTARES",25)	SIEMENS MED SMS USG ANTARES	25	37	f	\N	US	1	Unknown	\N
8345	(0019,"SIEMENS MED SMS USG ANTARES",26)	(0019,"SIEMENS MED SMS USG ANTARES",26)	SIEMENS MED SMS USG ANTARES	25	38	f	\N	US	1	Unknown	\N
8346	(0019,"SIEMENS MED SMS USG ANTARES",27)	(0019,"SIEMENS MED SMS USG ANTARES",27)	SIEMENS MED SMS USG ANTARES	25	39	f	\N	US	1	Unknown	\N
8347	(0019,"SIEMENS MED SMS USG ANTARES",28)	(0019,"SIEMENS MED SMS USG ANTARES",28)	SIEMENS MED SMS USG ANTARES	25	40	f	\N	US	1	Unknown	\N
8348	(0019,"SIEMENS MED SMS USG ANTARES",29)	(0019,"SIEMENS MED SMS USG ANTARES",29)	SIEMENS MED SMS USG ANTARES	25	41	f	\N	US	1	Unknown	\N
8349	(0019,"SIEMENS MED SMS USG ANTARES",2a)	(0019,"SIEMENS MED SMS USG ANTARES",2a)	SIEMENS MED SMS USG ANTARES	25	42	f	\N	US	1	Unknown	\N
8350	(0019,"SIEMENS MED SMS USG ANTARES",2d)	(0019,"SIEMENS MED SMS USG ANTARES",2d)	SIEMENS MED SMS USG ANTARES	25	45	f	\N	US	1	Unknown	\N
8351	(0019,"SIEMENS MED SMS USG ANTARES",2e)	(0019,"SIEMENS MED SMS USG ANTARES",2e)	SIEMENS MED SMS USG ANTARES	25	46	f	\N	SH	1	Unknown	\N
8352	(0019,"SIEMENS MED SMS USG ANTARES",31)	(0019,"SIEMENS MED SMS USG ANTARES",31)	SIEMENS MED SMS USG ANTARES	25	49	f	\N	US	1	Unknown	\N
8353	(0019,"SIEMENS MED SMS USG ANTARES",3a)	(0019,"SIEMENS MED SMS USG ANTARES",3a)	SIEMENS MED SMS USG ANTARES	25	58	f	\N	US	1	Unknown	\N
8354	(0019,"SIEMENS MED SMS USG ANTARES",3b)	(0019,"SIEMENS MED SMS USG ANTARES",3b)	SIEMENS MED SMS USG ANTARES	25	59	f	\N	LT	1	Unknown	\N
8355	(0019,"SIEMENS MED SMS USG ANTARES",40)	(0019,"SIEMENS MED SMS USG ANTARES",40)	SIEMENS MED SMS USG ANTARES	25	64	f	\N	SH	1	Unknown	\N
8356	(0019,"SIEMENS MED SMS USG ANTARES",41)	(0019,"SIEMENS MED SMS USG ANTARES",41)	SIEMENS MED SMS USG ANTARES	25	65	f	\N	US	1	Unknown	\N
8357	(0019,"SIEMENS MED SMS USG ANTARES",42)	(0019,"SIEMENS MED SMS USG ANTARES",42)	SIEMENS MED SMS USG ANTARES	25	66	f	\N	SH	1	Unknown	\N
8358	(0019,"SIEMENS MED SMS USG ANTARES",43)	(0019,"SIEMENS MED SMS USG ANTARES",43)	SIEMENS MED SMS USG ANTARES	25	67	f	\N	FD	1	Unknown	\N
8359	(0019,"SIEMENS MED SMS USG ANTARES",44)	(0019,"SIEMENS MED SMS USG ANTARES",44)	SIEMENS MED SMS USG ANTARES	25	68	f	\N	US	1	Unknown	\N
8360	(0019,"SIEMENS MED SMS USG ANTARES",46)	(0019,"SIEMENS MED SMS USG ANTARES",46)	SIEMENS MED SMS USG ANTARES	25	70	f	\N	US	1	Unknown	\N
8361	(0019,"SIEMENS MED SMS USG ANTARES",47)	(0019,"SIEMENS MED SMS USG ANTARES",47)	SIEMENS MED SMS USG ANTARES	25	71	f	\N	US	1	Unknown	\N
8362	(0019,"SIEMENS MED SMS USG ANTARES",48)	(0019,"SIEMENS MED SMS USG ANTARES",48)	SIEMENS MED SMS USG ANTARES	25	72	f	\N	US	1	Unknown	\N
8363	(0019,"SIEMENS MED SMS USG ANTARES",49)	(0019,"SIEMENS MED SMS USG ANTARES",49)	SIEMENS MED SMS USG ANTARES	25	73	f	\N	US	1	Unknown	\N
8364	(0019,"SIEMENS MED SMS USG ANTARES",54)	(0019,"SIEMENS MED SMS USG ANTARES",54)	SIEMENS MED SMS USG ANTARES	25	84	f	\N	FD	1	Unknown	\N
8365	(0019,"SIEMENS MED SMS USG ANTARES",60)	(0019,"SIEMENS MED SMS USG ANTARES",60)	SIEMENS MED SMS USG ANTARES	25	96	f	\N	FD	1	Unknown	\N
8366	(0019,"SIEMENS MED SMS USG ANTARES",61)	(0019,"SIEMENS MED SMS USG ANTARES",61)	SIEMENS MED SMS USG ANTARES	25	97	f	\N	FD	1	Unknown	\N
8367	(0019,"SIEMENS MED SMS USG ANTARES",62)	(0019,"SIEMENS MED SMS USG ANTARES",62)	SIEMENS MED SMS USG ANTARES	25	98	f	\N	FD	1	Unknown	\N
8368	(0019,"SIEMENS MED SMS USG ANTARES",63)	(0019,"SIEMENS MED SMS USG ANTARES",63)	SIEMENS MED SMS USG ANTARES	25	99	f	\N	FD	1	Unknown	\N
8369	(0019,"SIEMENS MED SMS USG ANTARES",65)	(0019,"SIEMENS MED SMS USG ANTARES",65)	SIEMENS MED SMS USG ANTARES	25	101	f	\N	US	1	Unknown	\N
8370	(0019,"SIEMENS MED SMS USG ANTARES",66)	(0019,"SIEMENS MED SMS USG ANTARES",66)	SIEMENS MED SMS USG ANTARES	25	102	f	\N	SH	1	Unknown	\N
8371	(0019,"SIEMENS MED SMS USG ANTARES",67)	(0019,"SIEMENS MED SMS USG ANTARES",67)	SIEMENS MED SMS USG ANTARES	25	103	f	\N	US	1	Unknown	\N
8372	(0019,"SIEMENS MED SMS USG ANTARES",69)	(0019,"SIEMENS MED SMS USG ANTARES",69)	SIEMENS MED SMS USG ANTARES	25	105	f	\N	US	1	Unknown	\N
8373	(0019,"SIEMENS MED SMS USG ANTARES",6a)	(0019,"SIEMENS MED SMS USG ANTARES",6a)	SIEMENS MED SMS USG ANTARES	25	106	f	\N	US	1	Unknown	\N
8374	(0019,"SIEMENS MED SMS USG ANTARES",6c)	(0019,"SIEMENS MED SMS USG ANTARES",6c)	SIEMENS MED SMS USG ANTARES	25	108	f	\N	US	1	Unknown	\N
8375	(0019,"SIEMENS MED SMS USG ANTARES",72)	(0019,"SIEMENS MED SMS USG ANTARES",72)	SIEMENS MED SMS USG ANTARES	25	114	f	\N	US	1	Unknown	\N
8376	(0019,"SIEMENS MED SMS USG ANTARES",80)	(0019,"SIEMENS MED SMS USG ANTARES",80)	SIEMENS MED SMS USG ANTARES	25	128	f	\N	FD	1	Unknown	\N
8377	(0019,"SIEMENS MED SMS USG ANTARES",81)	(0019,"SIEMENS MED SMS USG ANTARES",81)	SIEMENS MED SMS USG ANTARES	25	129	f	\N	FD	1	Unknown	\N
8378	(0019,"SIEMENS MED SMS USG ANTARES",82)	(0019,"SIEMENS MED SMS USG ANTARES",82)	SIEMENS MED SMS USG ANTARES	25	130	f	\N	US	1	Unknown	\N
8379	(0019,"SIEMENS MED SMS USG ANTARES",83)	(0019,"SIEMENS MED SMS USG ANTARES",83)	SIEMENS MED SMS USG ANTARES	25	131	f	\N	US	1	Unknown	\N
8380	(0019,"SIEMENS MED SMS USG ANTARES",86)	(0019,"SIEMENS MED SMS USG ANTARES",86)	SIEMENS MED SMS USG ANTARES	25	134	f	\N	US	1	Unknown	\N
8381	(0019,"SIEMENS MED SMS USG ANTARES",87)	(0019,"SIEMENS MED SMS USG ANTARES",87)	SIEMENS MED SMS USG ANTARES	25	135	f	\N	SH	1	Unknown	\N
8382	(0019,"SIEMENS MED SMS USG ANTARES",88)	(0019,"SIEMENS MED SMS USG ANTARES",88)	SIEMENS MED SMS USG ANTARES	25	136	f	\N	US	1	Unknown	\N
8383	(0019,"SIEMENS MED SMS USG ANTARES",a0)	(0019,"SIEMENS MED SMS USG ANTARES",a0)	SIEMENS MED SMS USG ANTARES	25	160	f	\N	LT	1	Unknown	\N
8384	(0019,"Siemens Ultrasound Miscellaneous",20)	(0019,"Siemens Ultrasound Miscellaneous",20)	Siemens Ultrasound Miscellaneous	25	32	f	\N	SH	1	Unknown	\N
8385	(0019,"Siemens: Thorax/Multix FD Lab Settings",00)	(0019,"Siemens: Thorax/Multix FD Lab Settings",00)	Siemens: Thorax/Multix FD Lab Settings	25	0	f	\N	LO	1	Unknown	\N
8386	(0019,"Siemens: Thorax/Multix FD Lab Settings",01)	(0019,"Siemens: Thorax/Multix FD Lab Settings",01)	Siemens: Thorax/Multix FD Lab Settings	25	1	f	\N	LO	1	Unknown	\N
8648	(0029,"SIEMENS SYNGO VOLUME",46)	(0029,"SIEMENS SYNGO VOLUME",46)	SIEMENS SYNGO VOLUME	41	70	f	\N	UL	1	Histogram Number Of Bins	\N
8387	(0019,"Siemens: Thorax/Multix FD Lab Settings",02)	(0019,"Siemens: Thorax/Multix FD Lab Settings",02)	Siemens: Thorax/Multix FD Lab Settings	25	2	f	\N	LO	1	Total Dose Area Product uGy*cm*cm	\N
8388	(0019,"Siemens: Thorax/Multix FD Lab Settings",03)	(0019,"Siemens: Thorax/Multix FD Lab Settings",03)	Siemens: Thorax/Multix FD Lab Settings	25	3	f	\N	US	1	Unknown	\N
8389	(0019,"Siemens: Thorax/Multix FD Lab Settings",04)	(0019,"Siemens: Thorax/Multix FD Lab Settings",04)	Siemens: Thorax/Multix FD Lab Settings	25	4	f	\N	LO	1	Unknown	\N
8390	(0019,"Siemens: Thorax/Multix FD Lab Settings",05)	(0019,"Siemens: Thorax/Multix FD Lab Settings",05)	Siemens: Thorax/Multix FD Lab Settings	25	5	f	\N	US	1	Unknown	\N
8391	(0019,"Siemens: Thorax/Multix FD Lab Settings",06)	(0019,"Siemens: Thorax/Multix FD Lab Settings",06)	Siemens: Thorax/Multix FD Lab Settings	25	6	f	\N	FD	1	Table Object Distance	\N
8392	(0019,"Siemens: Thorax/Multix FD Lab Settings",07)	(0019,"Siemens: Thorax/Multix FD Lab Settings",07)	Siemens: Thorax/Multix FD Lab Settings	25	7	f	\N	FD	1	Table Detector Distance	\N
8393	(0019,"Siemens: Thorax/Multix FD Lab Settings",08)	(0019,"Siemens: Thorax/Multix FD Lab Settings",08)	Siemens: Thorax/Multix FD Lab Settings	25	8	f	\N	US	1-n	Ortho Step Distance	\N
8394	(0019,"SIEMENS MED SMS USG S2000",00)	(0019,"SIEMENS MED SMS USG S2000",00)	SIEMENS MED SMS USG S2000	25	0	f	\N	SH	1	Private Creator Version	\N
8395	(0019,"SIEMENS MED SMS USG S2000",03)	(0019,"SIEMENS MED SMS USG S2000",03)	SIEMENS MED SMS USG S2000	25	3	f	\N	FD	1	Frame Rate	\N
8396	(0019,"SIEMENS MED SMS USG S2000",0c)	(0019,"SIEMENS MED SMS USG S2000",0c)	SIEMENS MED SMS USG S2000	25	12	f	\N	US	1	Burned in Graphics	\N
8397	(0019,"SIEMENS MED SMS USG S2000",0d)	(0019,"SIEMENS MED SMS USG S2000",0d)	SIEMENS MED SMS USG S2000	25	13	f	\N	SH	1	SieClear Index	\N
8398	(0019,"SIEMENS MED SMS USG S2000",0e)	(0019,"SIEMENS MED SMS USG S2000",0e)	SIEMENS MED SMS USG S2000	25	14	f	\N	US	1	Unknown	\N
8399	(0019,"SIEMENS MED SMS USG S2000",20)	(0019,"SIEMENS MED SMS USG S2000",20)	SIEMENS MED SMS USG S2000	25	32	f	\N	SH	1	B-Mode Submode	\N
8400	(0019,"SIEMENS MED SMS USG S2000",21)	(0019,"SIEMENS MED SMS USG S2000",21)	SIEMENS MED SMS USG S2000	25	33	f	\N	FD	1	B-Mode Dynamic Range	\N
8401	(0019,"SIEMENS MED SMS USG S2000",22)	(0019,"SIEMENS MED SMS USG S2000",22)	SIEMENS MED SMS USG S2000	25	34	f	\N	FD	1	B-Mode Overall Gain	\N
8402	(0019,"SIEMENS MED SMS USG S2000",23)	(0019,"SIEMENS MED SMS USG S2000",23)	SIEMENS MED SMS USG S2000	25	35	f	\N	US	1	B-Mode Resolution/Speed Index	\N
8403	(0019,"SIEMENS MED SMS USG S2000",24)	(0019,"SIEMENS MED SMS USG S2000",24)	SIEMENS MED SMS USG S2000	25	36	f	\N	US	1	B-Mode Edge Enhance Index	\N
8404	(0019,"SIEMENS MED SMS USG S2000",25)	(0019,"SIEMENS MED SMS USG S2000",25)	SIEMENS MED SMS USG S2000	25	37	f	\N	US	1	B-Mode Persistence Index	\N
8405	(0019,"SIEMENS MED SMS USG S2000",26)	(0019,"SIEMENS MED SMS USG S2000",26)	SIEMENS MED SMS USG S2000	25	38	f	\N	US	1	B-Mode Map Index	\N
8406	(0019,"SIEMENS MED SMS USG S2000",27)	(0019,"SIEMENS MED SMS USG S2000",27)	SIEMENS MED SMS USG S2000	25	39	f	\N	US	1	Unknown	\N
8407	(0019,"SIEMENS MED SMS USG S2000",28)	(0019,"SIEMENS MED SMS USG S2000",28)	SIEMENS MED SMS USG S2000	25	40	f	\N	US	1	Unknown	\N
8408	(0019,"SIEMENS MED SMS USG S2000",29)	(0019,"SIEMENS MED SMS USG S2000",29)	SIEMENS MED SMS USG S2000	25	41	f	\N	US	1	Unknown	\N
8409	(0019,"SIEMENS MED SMS USG S2000",2a)	(0019,"SIEMENS MED SMS USG S2000",2a)	SIEMENS MED SMS USG S2000	25	42	f	\N	US	1	B-Mode Tint Type	\N
8410	(0019,"SIEMENS MED SMS USG S2000",2d)	(0019,"SIEMENS MED SMS USG S2000",2d)	SIEMENS MED SMS USG S2000	25	45	f	\N	US	1	B-Mode Tint Index	\N
8411	(0019,"SIEMENS MED SMS USG S2000",2e)	(0019,"SIEMENS MED SMS USG S2000",2e)	SIEMENS MED SMS USG S2000	25	46	f	\N	SH	1	ClarifyVE Index	\N
8412	(0019,"SIEMENS MED SMS USG S2000",30)	(0019,"SIEMENS MED SMS USG S2000",30)	SIEMENS MED SMS USG S2000	25	48	f	\N	DS	1	Unknown	\N
8413	(0019,"SIEMENS MED SMS USG S2000",31)	(0019,"SIEMENS MED SMS USG S2000",31)	SIEMENS MED SMS USG S2000	25	49	f	\N	US	1	Unknown	\N
8414	(0019,"SIEMENS MED SMS USG S2000",3a)	(0019,"SIEMENS MED SMS USG S2000",3a)	SIEMENS MED SMS USG S2000	25	58	f	\N	US	1	Image Flag	\N
8415	(0019,"SIEMENS MED SMS USG S2000",3b)	(0019,"SIEMENS MED SMS USG S2000",3b)	SIEMENS MED SMS USG S2000	25	59	f	\N	LT	1	Unknown	\N
8416	(0019,"SIEMENS MED SMS USG S2000",40)	(0019,"SIEMENS MED SMS USG S2000",40)	SIEMENS MED SMS USG S2000	25	64	f	\N	SH	1	Color Flow State	\N
8417	(0019,"SIEMENS MED SMS USG S2000",41)	(0019,"SIEMENS MED SMS USG S2000",41)	SIEMENS MED SMS USG S2000	25	65	f	\N	US	1	Color Flow Wall Filter Index	\N
8418	(0019,"SIEMENS MED SMS USG S2000",42)	(0019,"SIEMENS MED SMS USG S2000",42)	SIEMENS MED SMS USG S2000	25	66	f	\N	SH	1	Color Flow Submode	\N
8419	(0019,"SIEMENS MED SMS USG S2000",43)	(0019,"SIEMENS MED SMS USG S2000",43)	SIEMENS MED SMS USG S2000	25	67	f	\N	FD	1	Color Flow Overall Gain	\N
8420	(0019,"SIEMENS MED SMS USG S2000",44)	(0019,"SIEMENS MED SMS USG S2000",44)	SIEMENS MED SMS USG S2000	25	68	f	\N	US	1	Color Flow Resolution/Speed Index	\N
8421	(0019,"SIEMENS MED SMS USG S2000",46)	(0019,"SIEMENS MED SMS USG S2000",46)	SIEMENS MED SMS USG S2000	25	70	f	\N	US	1	Color Flow Smooth Index	\N
8422	(0019,"SIEMENS MED SMS USG S2000",47)	(0019,"SIEMENS MED SMS USG S2000",47)	SIEMENS MED SMS USG S2000	25	71	f	\N	US	1	Color Flow Persistence Index	\N
8423	(0019,"SIEMENS MED SMS USG S2000",48)	(0019,"SIEMENS MED SMS USG S2000",48)	SIEMENS MED SMS USG S2000	25	72	f	\N	US	1	Color Flow Map Index	\N
8424	(0019,"SIEMENS MED SMS USG S2000",49)	(0019,"SIEMENS MED SMS USG S2000",49)	SIEMENS MED SMS USG S2000	25	73	f	\N	US	1	Color Flow Priority Index	\N
8425	(0019,"SIEMENS MED SMS USG S2000",54)	(0019,"SIEMENS MED SMS USG S2000",54)	SIEMENS MED SMS USG S2000	25	84	f	\N	FD	1	Color Flow Maximum Velocity	\N
8426	(0019,"SIEMENS MED SMS USG S2000",60)	(0019,"SIEMENS MED SMS USG S2000",60)	SIEMENS MED SMS USG S2000	25	96	f	\N	FD	1	Doppler Dynamic Range	\N
8427	(0019,"SIEMENS MED SMS USG S2000",61)	(0019,"SIEMENS MED SMS USG S2000",61)	SIEMENS MED SMS USG S2000	25	97	f	\N	FD	1	Doppler Overall Gain	\N
8428	(0019,"SIEMENS MED SMS USG S2000",62)	(0019,"SIEMENS MED SMS USG S2000",62)	SIEMENS MED SMS USG S2000	25	98	f	\N	FD	1	Doppler Wall Filter	\N
8429	(0019,"SIEMENS MED SMS USG S2000",63)	(0019,"SIEMENS MED SMS USG S2000",63)	SIEMENS MED SMS USG S2000	25	99	f	\N	FD	1	Doppler Gate Size	\N
8430	(0019,"SIEMENS MED SMS USG S2000",65)	(0019,"SIEMENS MED SMS USG S2000",65)	SIEMENS MED SMS USG S2000	25	101	f	\N	US	1	Doppler Map Index	\N
8649	(0029,"SIEMENS SYNGO VOLUME",47)	(0029,"SIEMENS SYNGO VOLUME",47)	SIEMENS SYNGO VOLUME	41	71	f	\N	OB	1	Volume Histogram Data	\N
8431	(0019,"SIEMENS MED SMS USG S2000",66)	(0019,"SIEMENS MED SMS USG S2000",66)	SIEMENS MED SMS USG S2000	25	102	f	\N	SH	1	Doppler Submode	\N
8432	(0019,"SIEMENS MED SMS USG S2000",67)	(0019,"SIEMENS MED SMS USG S2000",67)	SIEMENS MED SMS USG S2000	25	103	f	\N	US	1	Unknown	\N
8433	(0019,"SIEMENS MED SMS USG S2000",69)	(0019,"SIEMENS MED SMS USG S2000",69)	SIEMENS MED SMS USG S2000	25	105	f	\N	US	1	Doppler Time/Freq Res Index	\N
8434	(0019,"SIEMENS MED SMS USG S2000",6a)	(0019,"SIEMENS MED SMS USG S2000",6a)	SIEMENS MED SMS USG S2000	25	106	f	\N	US	1	Doppler Trace Inverted	\N
8435	(0019,"SIEMENS MED SMS USG S2000",6c)	(0019,"SIEMENS MED SMS USG S2000",6c)	SIEMENS MED SMS USG S2000	25	108	f	\N	US	1	Doppler Tint Type	\N
8436	(0019,"SIEMENS MED SMS USG S2000",72)	(0019,"SIEMENS MED SMS USG S2000",72)	SIEMENS MED SMS USG S2000	25	114	f	\N	US	1	Doppler Tint Index	\N
8437	(0019,"SIEMENS MED SMS USG S2000",80)	(0019,"SIEMENS MED SMS USG S2000",80)	SIEMENS MED SMS USG S2000	25	128	f	\N	US	1	M-Mode Dynamic Range	\N
8438	(0019,"SIEMENS MED SMS USG S2000",81)	(0019,"SIEMENS MED SMS USG S2000",81)	SIEMENS MED SMS USG S2000	25	129	f	\N	US	1	M-Mode Overall Gain	\N
8439	(0019,"SIEMENS MED SMS USG S2000",82)	(0019,"SIEMENS MED SMS USG S2000",82)	SIEMENS MED SMS USG S2000	25	130	f	\N	US	1	M-Mode Edge Enhance Index	\N
8440	(0019,"SIEMENS MED SMS USG S2000",83)	(0019,"SIEMENS MED SMS USG S2000",83)	SIEMENS MED SMS USG S2000	25	131	f	\N	US	1	M-Mode Map Index	\N
8441	(0019,"SIEMENS MED SMS USG S2000",86)	(0019,"SIEMENS MED SMS USG S2000",86)	SIEMENS MED SMS USG S2000	25	134	f	\N	US	1	M-Mode Tint Type	\N
8442	(0019,"SIEMENS MED SMS USG S2000",87)	(0019,"SIEMENS MED SMS USG S2000",87)	SIEMENS MED SMS USG S2000	25	135	f	\N	SH	1	M-Mode Submode	\N
8443	(0019,"SIEMENS MED SMS USG S2000",88)	(0019,"SIEMENS MED SMS USG S2000",88)	SIEMENS MED SMS USG S2000	25	136	f	\N	US	1	M-Mode Tint Index	\N
8444	(0019,"SIEMENS MED SMS USG S2000",95)	(0019,"SIEMENS MED SMS USG S2000",95)	SIEMENS MED SMS USG S2000	25	149	f	\N	US	1	Unknown	\N
8445	(0021,"SIEMENS MED NM",00)	(0021,"SIEMENS MED NM",00)	SIEMENS MED NM	33	0	f	\N	OB	1	ECAT_Main_Header	\N
8446	(0021,"SIEMENS MED NM",01)	(0021,"SIEMENS MED NM",01)	SIEMENS MED NM	33	1	f	\N	OB	1	ECAT_Image_Subheader	\N
8447	(0021,"SIEMENS MED ECAT FILE INFO",00)	(0021,"SIEMENS MED ECAT FILE INFO",00)	SIEMENS MED ECAT FILE INFO	33	0	f	\N	OB	1	ECAT_Main_Header	\N
8448	(0021,"SIEMENS MED ECAT FILE INFO",01)	(0021,"SIEMENS MED ECAT FILE INFO",01)	SIEMENS MED ECAT FILE INFO	33	1	f	\N	OB	1	ECAT_Image_Subheader	\N
8449	(0021,"SIEMENS SMS-AX  ACQ 1.0",09)	(0021,"SIEMENS SMS-AX  ACQ 1.0",09)	SIEMENS SMS-AX  ACQ 1.0	33	9	f	\N	UL	1	Impac Filename	\N
8450	(0021,"SIEMENS SMS-AX  ACQ 1.0",0a)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0a)	SIEMENS SMS-AX  ACQ 1.0	33	10	f	\N	UL	1	Copper Filter	\N
8451	(0021,"SIEMENS SMS-AX  ACQ 1.0",0b)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0b)	SIEMENS SMS-AX  ACQ 1.0	33	11	f	\N	US	1	Measuring Field	\N
8452	(0021,"SIEMENS SMS-AX  ACQ 1.0",0c)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0c)	SIEMENS SMS-AX  ACQ 1.0	33	12	f	\N	SS	3	Post Blanking Circle	\N
8453	(0021,"SIEMENS SMS-AX  ACQ 1.0",0d)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0d)	SIEMENS SMS-AX  ACQ 1.0	33	13	f	\N	SS	2-2n	Dyna Angles	\N
8454	(0021,"SIEMENS SMS-AX  ACQ 1.0",0e)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0e)	SIEMENS SMS-AX  ACQ 1.0	33	14	f	\N	SS	1	Total Steps	\N
8455	(0021,"SIEMENS SMS-AX  ACQ 1.0",0f)	(0021,"SIEMENS SMS-AX  ACQ 1.0",0f)	SIEMENS SMS-AX  ACQ 1.0	33	15	f	\N	SL	4-n	Dyna X-Ray Info	\N
8456	(0021,"SIEMENS SMS-AX  ACQ 1.0",1a)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1a)	SIEMENS SMS-AX  ACQ 1.0	33	26	f	\N	US	1	FD Flag	\N
8457	(0021,"SIEMENS SMS-AX  ACQ 1.0",1b)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1b)	SIEMENS SMS-AX  ACQ 1.0	33	27	f	\N	OB	1	SH_ZOOM	\N
8458	(0021,"SIEMENS SMS-AX  ACQ 1.0",1c)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1c)	SIEMENS SMS-AX  ACQ 1.0	33	28	f	\N	OB	1	SH_COLPAR	\N
8459	(0021,"SIEMENS SMS-AX  ACQ 1.0",1d)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1d)	SIEMENS SMS-AX  ACQ 1.0	33	29	f	\N	US	1	K-Factor	\N
8460	(0021,"SIEMENS SMS-AX  ACQ 1.0",1e)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1e)	SIEMENS SMS-AX  ACQ 1.0	33	30	f	\N	US	8	EVE	\N
8461	(0021,"SIEMENS SMS-AX  ACQ 1.0",1f)	(0021,"SIEMENS SMS-AX  ACQ 1.0",1f)	SIEMENS SMS-AX  ACQ 1.0	33	31	f	\N	SL	1	Total Scene Time	\N
8462	(0021,"SIEMENS SMS-AX  ACQ 1.0",27)	(0021,"SIEMENS SMS-AX  ACQ 1.0",27)	SIEMENS SMS-AX  ACQ 1.0	33	39	f	\N	US	1	IC Stent Flag	\N
8463	(0021,"SIEMENS SMS-AX  ACQ 1.0",28)	(0021,"SIEMENS SMS-AX  ACQ 1.0",28)	SIEMENS SMS-AX  ACQ 1.0	33	40	f	\N	SQ	1	Gamma LUT Sequence	\N
8464	(0021,"SIEMENS SMS-AX  ACQ 1.0",29)	(0021,"SIEMENS SMS-AX  ACQ 1.0",29)	SIEMENS SMS-AX  ACQ 1.0	33	41	f	\N	DS	1	Acquisition Scene Time	\N
8465	(0021,"SIEMENS SMS-AX  ACQ 1.0",2a)	(0021,"SIEMENS SMS-AX  ACQ 1.0",2a)	SIEMENS SMS-AX  ACQ 1.0	33	42	f	\N	IS	1	3D Cardiac Phase Center	\N
8466	(0021,"SIEMENS SMS-AX  ACQ 1.0",2b)	(0021,"SIEMENS SMS-AX  ACQ 1.0",2b)	SIEMENS SMS-AX  ACQ 1.0	33	43	f	\N	IS	1	3D Cardiac Phase Width	\N
8467	(0021,"SIEMENS SMS-AX  ACQ 1.0",30)	(0021,"SIEMENS SMS-AX  ACQ 1.0",30)	SIEMENS SMS-AX  ACQ 1.0	33	48	f	\N	OB	1	Organ Program Info	\N
8468	(0021,"SIEMENS SMS-AX  ACQ 1.0",3a)	(0021,"SIEMENS SMS-AX  ACQ 1.0",3a)	SIEMENS SMS-AX  ACQ 1.0	33	58	f	\N	IS	1	DDO Kernel size	\N
8469	(0021,"SIEMENS SMS-AX  ACQ 1.0",3b)	(0021,"SIEMENS SMS-AX  ACQ 1.0",3b)	SIEMENS SMS-AX  ACQ 1.0	33	59	f	\N	IS	1	mAs Modulation	\N
8470	(0021,"SIEMENS SMS-AX  ACQ 1.0",3c)	(0021,"SIEMENS SMS-AX  ACQ 1.0",3c)	SIEMENS SMS-AX  ACQ 1.0	33	60	f	\N	DT	1-n	3D R-Peak Reference Time	\N
8471	(0021,"SIEMENS SMS-AX  ACQ 1.0",3d)	(0021,"SIEMENS SMS-AX  ACQ 1.0",3d)	SIEMENS SMS-AX  ACQ 1.0	33	61	f	\N	SL	1-n	ECG Frame Time Vector	\N
8472	(0021,"SIEMENS SMS-AX  ACQ 1.0",3e)	(0021,"SIEMENS SMS-AX  ACQ 1.0",3e)	SIEMENS SMS-AX  ACQ 1.0	33	62	f	\N	SL	1	ECG Start Time of Run	\N
8473	(0021,"SIEMENS SMS-AX  ACQ 1.0",40)	(0021,"SIEMENS SMS-AX  ACQ 1.0",40)	SIEMENS SMS-AX  ACQ 1.0	33	64	f	\N	US	3	Gamma LUT Descriptor	\N
8474	(0021,"SIEMENS SMS-AX  ACQ 1.0",41)	(0021,"SIEMENS SMS-AX  ACQ 1.0",41)	SIEMENS SMS-AX  ACQ 1.0	33	65	f	\N	LO	1	Gamma LUT Type	\N
8475	(0021,"SIEMENS SMS-AX  ACQ 1.0",42)	(0021,"SIEMENS SMS-AX  ACQ 1.0",42)	SIEMENS SMS-AX  ACQ 1.0	33	66	f	\N	US	1-n	Gamma LUT Data	\N
8476	(0021,"SIEMENS SMS-AX  ACQ 1.0",43)	(0021,"SIEMENS SMS-AX  ACQ 1.0",43)	SIEMENS SMS-AX  ACQ 1.0	33	67	f	\N	US	1	Global Gain	\N
8477	(0021,"SIEMENS SMS-AX  ACQ 1.0",44)	(0021,"SIEMENS SMS-AX  ACQ 1.0",44)	SIEMENS SMS-AX  ACQ 1.0	33	68	f	\N	US	1	Global Offset	\N
8478	(0021,"SIEMENS SMS-AX  ACQ 1.0",45)	(0021,"SIEMENS SMS-AX  ACQ 1.0",45)	SIEMENS SMS-AX  ACQ 1.0	33	69	f	\N	US	1	DIPP Mode	\N
8479	(0021,"SIEMENS SMS-AX  ACQ 1.0",46)	(0021,"SIEMENS SMS-AX  ACQ 1.0",46)	SIEMENS SMS-AX  ACQ 1.0	33	70	f	\N	US	1	Artis System Type	\N
8480	(0021,"SIEMENS SMS-AX  ACQ 1.0",47)	(0021,"SIEMENS SMS-AX  ACQ 1.0",47)	SIEMENS SMS-AX  ACQ 1.0	33	71	f	\N	US	1	Artis Table Type	\N
8481	(0021,"SIEMENS SMS-AX  ACQ 1.0",48)	(0021,"SIEMENS SMS-AX  ACQ 1.0",48)	SIEMENS SMS-AX  ACQ 1.0	33	72	f	\N	US	1	Artis Table Top Type	\N
8482	(0021,"SIEMENS SMS-AX  ACQ 1.0",49)	(0021,"SIEMENS SMS-AX  ACQ 1.0",49)	SIEMENS SMS-AX  ACQ 1.0	33	73	f	\N	US	1	Water Value	\N
8483	(0021,"SIEMENS SMS-AX  ACQ 1.0",51)	(0021,"SIEMENS SMS-AX  ACQ 1.0",51)	SIEMENS SMS-AX  ACQ 1.0	33	81	f	\N	DS	1	3D Positioner Primary Start Angle	\N
8484	(0021,"SIEMENS SMS-AX  ACQ 1.0",52)	(0021,"SIEMENS SMS-AX  ACQ 1.0",52)	SIEMENS SMS-AX  ACQ 1.0	33	82	f	\N	DS	1	3D Positioner Secondary Start Angle	\N
8485	(0021,"SIEMENS SMS-AX  ACQ 1.0",53)	(0021,"SIEMENS SMS-AX  ACQ 1.0",53)	SIEMENS SMS-AX  ACQ 1.0	33	83	f	\N	SS	3	Stand Position	\N
8486	(0021,"SIEMENS SMS-AX  ACQ 1.0",54)	(0021,"SIEMENS SMS-AX  ACQ 1.0",54)	SIEMENS SMS-AX  ACQ 1.0	33	84	f	\N	SS	1	Rotation Angle	\N
8487	(0021,"SIEMENS SMS-AX  ACQ 1.0",55)	(0021,"SIEMENS SMS-AX  ACQ 1.0",55)	SIEMENS SMS-AX  ACQ 1.0	33	85	f	\N	US	1	Image Rotation	\N
8488	(0021,"SIEMENS SMS-AX  ACQ 1.0",56)	(0021,"SIEMENS SMS-AX  ACQ 1.0",56)	SIEMENS SMS-AX  ACQ 1.0	33	86	f	\N	SS	3	Table Coordinates	\N
8489	(0021,"SIEMENS SMS-AX  ACQ 1.0",57)	(0021,"SIEMENS SMS-AX  ACQ 1.0",57)	SIEMENS SMS-AX  ACQ 1.0	33	87	f	\N	SS	3	Isocenter Table Position	\N
8490	(0021,"SIEMENS SMS-AX  ACQ 1.0",58)	(0021,"SIEMENS SMS-AX  ACQ 1.0",58)	SIEMENS SMS-AX  ACQ 1.0	33	88	f	\N	DS	1	Table Object Distance	\N
8491	(0021,"SIEMENS SMS-AX  ACQ 1.0",59)	(0021,"SIEMENS SMS-AX  ACQ 1.0",59)	SIEMENS SMS-AX  ACQ 1.0	33	89	f	\N	FL	12-n	Carm Coordinate System	\N
8492	(0021,"SIEMENS SMS-AX  ACQ 1.0",5a)	(0021,"SIEMENS SMS-AX  ACQ 1.0",5a)	SIEMENS SMS-AX  ACQ 1.0	33	90	f	\N	FL	6-n	Robot Axes	\N
8493	(0021,"SIEMENS SMS-AX  ACQ 1.0",5b)	(0021,"SIEMENS SMS-AX  ACQ 1.0",5b)	SIEMENS SMS-AX  ACQ 1.0	33	91	f	\N	FL	12	Table Coordinate System	\N
8494	(0021,"SIEMENS SMS-AX  ACQ 1.0",5c)	(0021,"SIEMENS SMS-AX  ACQ 1.0",5c)	SIEMENS SMS-AX  ACQ 1.0	33	92	f	\N	FL	12	Patient Coordinate System	\N
8495	(0021,"SIEMENS SMS-AX  ACQ 1.0",5d)	(0021,"SIEMENS SMS-AX  ACQ 1.0",5d)	SIEMENS SMS-AX  ACQ 1.0	33	93	f	\N	SS	1-n	Angulation	\N
8496	(0021,"SIEMENS SMS-AX  ACQ 1.0",5e)	(0021,"SIEMENS SMS-AX  ACQ 1.0",5e)	SIEMENS SMS-AX  ACQ 1.0	33	94	f	\N	SS	1-n	Orbital	\N
8497	(0021,"SIEMENS SMS-AX  ACQ 1.0",61)	(0021,"SIEMENS SMS-AX  ACQ 1.0",61)	SIEMENS SMS-AX  ACQ 1.0	33	97	f	\N	SS	1	Large Volume Overlap	\N
8498	(0021,"SIEMENS SMS-AX  ACQ 1.0",62)	(0021,"SIEMENS SMS-AX  ACQ 1.0",62)	SIEMENS SMS-AX  ACQ 1.0	33	98	f	\N	US	1	Reconstruction Preset	\N
8499	(0021,"SIEMENS SMS-AX  ACQ 1.0",63)	(0021,"SIEMENS SMS-AX  ACQ 1.0",63)	SIEMENS SMS-AX  ACQ 1.0	33	99	f	\N	SS	1	3D Start Angle	\N
8500	(0021,"SIEMENS SMS-AX  ACQ 1.0",64)	(0021,"SIEMENS SMS-AX  ACQ 1.0",64)	SIEMENS SMS-AX  ACQ 1.0	33	100	f	\N	SL	1	3D Planned Angle	\N
8501	(0021,"SIEMENS SMS-AX  ACQ 1.0",65)	(0021,"SIEMENS SMS-AX  ACQ 1.0",65)	SIEMENS SMS-AX  ACQ 1.0	33	101	f	\N	SL	1	3D Rotation Plane Alpha	\N
8502	(0021,"SIEMENS SMS-AX  ACQ 1.0",66)	(0021,"SIEMENS SMS-AX  ACQ 1.0",66)	SIEMENS SMS-AX  ACQ 1.0	33	102	f	\N	SL	1	3D Rotation Plane Beta	\N
8503	(0021,"SIEMENS SMS-AX  ACQ 1.0",67)	(0021,"SIEMENS SMS-AX  ACQ 1.0",67)	SIEMENS SMS-AX  ACQ 1.0	33	103	f	\N	SL	1	3D First Image Angle	\N
8504	(0021,"SIEMENS SMS-AX  ACQ 1.0",68)	(0021,"SIEMENS SMS-AX  ACQ 1.0",68)	SIEMENS SMS-AX  ACQ 1.0	33	104	f	\N	SS	1-n	3D Trigger Angle	\N
8505	(0021,"SIEMENS SMS-AX  ACQ 1.0",71)	(0021,"SIEMENS SMS-AX  ACQ 1.0",71)	SIEMENS SMS-AX  ACQ 1.0	33	113	f	\N	DS	1-n	Detector Rotation	\N
8506	(0021,"SIEMENS SMS-AX  ACQ 1.0",72)	(0021,"SIEMENS SMS-AX  ACQ 1.0",72)	SIEMENS SMS-AX  ACQ 1.0	33	114	f	\N	SS	1-n	Physical Detector Rotation	\N
8507	(0021,"SIEMENS SMS-AX  ACQ 1.0",81)	(0021,"SIEMENS SMS-AX  ACQ 1.0",81)	SIEMENS SMS-AX  ACQ 1.0	33	129	f	\N	SS	1	Table Tilt	\N
8508	(0021,"SIEMENS SMS-AX  ACQ 1.0",82)	(0021,"SIEMENS SMS-AX  ACQ 1.0",82)	SIEMENS SMS-AX  ACQ 1.0	33	130	f	\N	SS	1	Table Rotation	\N
8509	(0021,"SIEMENS SMS-AX  ACQ 1.0",83)	(0021,"SIEMENS SMS-AX  ACQ 1.0",83)	SIEMENS SMS-AX  ACQ 1.0	33	131	f	\N	SS	1	Table Cradle Tilt	\N
8510	(0021,"SIEMENS SMS-AX  ACQ 1.0",a0)	(0021,"SIEMENS SMS-AX  ACQ 1.0",a0)	SIEMENS SMS-AX  ACQ 1.0	33	160	f	\N	OB	1	Crispy1 Container	\N
8511	(0021,"SIEMENS SMS-AX  ACQ 1.0",a3)	(0021,"SIEMENS SMS-AX  ACQ 1.0",a3)	SIEMENS SMS-AX  ACQ 1.0	33	163	f	\N	SQ	1	3D Cardiac Trigger Sequence	\N
8512	(0021,"SIEMENS SMS-AX  ACQ 1.0",a4)	(0021,"SIEMENS SMS-AX  ACQ 1.0",a4)	SIEMENS SMS-AX  ACQ 1.0	33	164	f	\N	DT	1	3D Frame Reference Date Time	\N
8513	(0021,"SIEMENS SMS-AX  ACQ 1.0",a5)	(0021,"SIEMENS SMS-AX  ACQ 1.0",a5)	SIEMENS SMS-AX  ACQ 1.0	33	165	f	\N	FD	1	3D Cardiac Trigger Delay Time	\N
8514	(0021,"SIEMENS SMS-AX  ACQ 1.0",a6)	(0021,"SIEMENS SMS-AX  ACQ 1.0",a6)	SIEMENS SMS-AX  ACQ 1.0	33	166	f	\N	FD	1	3D R-R Interval Time Measured	\N
8515	(0021,"Siemens: Thorax/Multix FD Post Processing",00)	(0021,"Siemens: Thorax/Multix FD Post Processing",00)	Siemens: Thorax/Multix FD Post Processing	33	0	f	\N	US	1	Unknown	\N
8516	(0021,"Siemens: Thorax/Multix FD Post Processing",01)	(0021,"Siemens: Thorax/Multix FD Post Processing",01)	Siemens: Thorax/Multix FD Post Processing	33	1	f	\N	SS	1	Unknown	\N
8517	(0021,"Siemens: Thorax/Multix FD Post Processing",02)	(0021,"Siemens: Thorax/Multix FD Post Processing",02)	Siemens: Thorax/Multix FD Post Processing	33	2	f	\N	FL	1	Unknown	\N
8518	(0021,"Siemens: Thorax/Multix FD Post Processing",03)	(0021,"Siemens: Thorax/Multix FD Post Processing",03)	Siemens: Thorax/Multix FD Post Processing	33	3	f	\N	FL	1	Unknown	\N
8519	(0021,"Siemens: Thorax/Multix FD Post Processing",04)	(0021,"Siemens: Thorax/Multix FD Post Processing",04)	Siemens: Thorax/Multix FD Post Processing	33	4	f	\N	US	1	Unknown	\N
8520	(0021,"Siemens: Thorax/Multix FD Post Processing",05)	(0021,"Siemens: Thorax/Multix FD Post Processing",05)	Siemens: Thorax/Multix FD Post Processing	33	5	f	\N	SS	1	Unknown	\N
8521	(0021,"Siemens: Thorax/Multix FD Post Processing",06)	(0021,"Siemens: Thorax/Multix FD Post Processing",06)	Siemens: Thorax/Multix FD Post Processing	33	6	f	\N	FL	1	Unknown	\N
8522	(0021,"Siemens: Thorax/Multix FD Post Processing",07)	(0021,"Siemens: Thorax/Multix FD Post Processing",07)	Siemens: Thorax/Multix FD Post Processing	33	7	f	\N	FL	1	Unknown	\N
8523	(0021,"Siemens: Thorax/Multix FD Post Processing",08)	(0021,"Siemens: Thorax/Multix FD Post Processing",08)	Siemens: Thorax/Multix FD Post Processing	33	8	f	\N	US	1	Auto Window Flag	\N
8524	(0021,"Siemens: Thorax/Multix FD Post Processing",09)	(0021,"Siemens: Thorax/Multix FD Post Processing",09)	Siemens: Thorax/Multix FD Post Processing	33	9	f	\N	SL	1	Auto Window Center	\N
8525	(0021,"Siemens: Thorax/Multix FD Post Processing",0a)	(0021,"Siemens: Thorax/Multix FD Post Processing",0a)	Siemens: Thorax/Multix FD Post Processing	33	10	f	\N	SL	1	Auto Window Width	\N
8526	(0021,"Siemens: Thorax/Multix FD Post Processing",0b)	(0021,"Siemens: Thorax/Multix FD Post Processing",0b)	Siemens: Thorax/Multix FD Post Processing	33	11	f	\N	SS	1	Filter ID	\N
8527	(0021,"Siemens: Thorax/Multix FD Post Processing",0c)	(0021,"Siemens: Thorax/Multix FD Post Processing",0c)	Siemens: Thorax/Multix FD Post Processing	33	12	f	\N	FL	1	Unknown	\N
8528	(0021,"Siemens: Thorax/Multix FD Post Processing",0d)	(0021,"Siemens: Thorax/Multix FD Post Processing",0d)	Siemens: Thorax/Multix FD Post Processing	33	13	f	\N	SS	1	Unknown	\N
8529	(0021,"Siemens: Thorax/Multix FD Post Processing",0e)	(0021,"Siemens: Thorax/Multix FD Post Processing",0e)	Siemens: Thorax/Multix FD Post Processing	33	14	f	\N	US	1	Dose Control Value	\N
8530	(0021,"Siemens: Thorax/Multix FD Post Processing",0f)	(0021,"Siemens: Thorax/Multix FD Post Processing",0f)	Siemens: Thorax/Multix FD Post Processing	33	15	f	\N	US	1	Unknown	\N
8531	(0021,"Siemens: Thorax/Multix FD Post Processing",10)	(0021,"Siemens: Thorax/Multix FD Post Processing",10)	Siemens: Thorax/Multix FD Post Processing	33	16	f	\N	US	1	Unknown	\N
8532	(0021,"Siemens: Thorax/Multix FD Post Processing",11)	(0021,"Siemens: Thorax/Multix FD Post Processing",11)	Siemens: Thorax/Multix FD Post Processing	33	17	f	\N	SS	1	Unknown	\N
8533	(0021,"Siemens: Thorax/Multix FD Post Processing",12)	(0021,"Siemens: Thorax/Multix FD Post Processing",12)	Siemens: Thorax/Multix FD Post Processing	33	18	f	\N	SS	1	Unknown	\N
8534	(0021,"Siemens: Thorax/Multix FD Post Processing",13)	(0021,"Siemens: Thorax/Multix FD Post Processing",13)	Siemens: Thorax/Multix FD Post Processing	33	19	f	\N	SS	1	Unknown	\N
8535	(0021,"Siemens: Thorax/Multix FD Post Processing",14)	(0021,"Siemens: Thorax/Multix FD Post Processing",14)	Siemens: Thorax/Multix FD Post Processing	33	20	f	\N	US	1	Anatomic Correct View	\N
8536	(0021,"Siemens: Thorax/Multix FD Post Processing",15)	(0021,"Siemens: Thorax/Multix FD Post Processing",15)	Siemens: Thorax/Multix FD Post Processing	33	21	f	\N	SS	1	Auto Window Shift	\N
8537	(0021,"Siemens: Thorax/Multix FD Post Processing",16)	(0021,"Siemens: Thorax/Multix FD Post Processing",16)	Siemens: Thorax/Multix FD Post Processing	33	22	f	\N	DS	1	Auto Window Expansion	\N
8538	(0021,"Siemens: Thorax/Multix FD Post Processing",17)	(0021,"Siemens: Thorax/Multix FD Post Processing",17)	Siemens: Thorax/Multix FD Post Processing	33	23	f	\N	LO	1	System Type	\N
8539	(0021,"Siemens: Thorax/Multix FD Post Processing",18)	(0021,"Siemens: Thorax/Multix FD Post Processing",18)	Siemens: Thorax/Multix FD Post Processing	33	24	f	\N	LO	1	Detector Type	\N
8540	(0021,"Siemens: Thorax/Multix FD Post Processing",30)	(0021,"Siemens: Thorax/Multix FD Post Processing",30)	Siemens: Thorax/Multix FD Post Processing	33	48	f	\N	US	1	Anatomic Sort Number	\N
8541	(0021,"Siemens: Thorax/Multix FD Post Processing",31)	(0021,"Siemens: Thorax/Multix FD Post Processing",31)	Siemens: Thorax/Multix FD Post Processing	33	49	f	\N	US	1	Acquisition Sort Number	\N
8542	(0021,"SIEMENS MED NM",10)	(0021,"SIEMENS MED NM",10)	SIEMENS MED NM	33	16	f	\N	ST	1	Unknown	\N
8543	(0021,"Siemens: Thorax/Multix FD Lab Settings",08)	(0021,"Siemens: Thorax/Multix FD Lab Settings",08)	Siemens: Thorax/Multix FD Lab Settings	33	8	f	\N	US	1	Auto Window Flag	\N
8544	(0021,"Siemens: Thorax/Multix FD Lab Settings",09)	(0021,"Siemens: Thorax/Multix FD Lab Settings",09)	Siemens: Thorax/Multix FD Lab Settings	33	9	f	\N	SL	1	Auto Window Center	\N
8545	(0021,"Siemens: Thorax/Multix FD Lab Settings",0a)	(0021,"Siemens: Thorax/Multix FD Lab Settings",0a)	Siemens: Thorax/Multix FD Lab Settings	33	10	f	\N	SL	1	Auto Window Width	\N
8546	(0021,"Siemens: Thorax/Multix FD Lab Settings",0b)	(0021,"Siemens: Thorax/Multix FD Lab Settings",0b)	Siemens: Thorax/Multix FD Lab Settings	33	11	f	\N	SS	1	Filter ID	\N
8547	(0021,"Siemens: Thorax/Multix FD Lab Settings",14)	(0021,"Siemens: Thorax/Multix FD Lab Settings",14)	Siemens: Thorax/Multix FD Lab Settings	33	20	f	\N	US	1	Anatomic Correct View	\N
8548	(0021,"Siemens: Thorax/Multix FD Lab Settings",15)	(0021,"Siemens: Thorax/Multix FD Lab Settings",15)	Siemens: Thorax/Multix FD Lab Settings	33	21	f	\N	SS	1	Auto Window Shift	\N
8549	(0021,"Siemens: Thorax/Multix FD Lab Settings",16)	(0021,"Siemens: Thorax/Multix FD Lab Settings",16)	Siemens: Thorax/Multix FD Lab Settings	33	22	f	\N	DS	1	Auto Window Expansion	\N
8550	(0021,"Siemens: Thorax/Multix FD Lab Settings",17)	(0021,"Siemens: Thorax/Multix FD Lab Settings",17)	Siemens: Thorax/Multix FD Lab Settings	33	23	f	\N	LO	1	System Type	\N
8551	(0021,"Siemens: Thorax/Multix FD Lab Settings",30)	(0021,"Siemens: Thorax/Multix FD Lab Settings",30)	Siemens: Thorax/Multix FD Lab Settings	33	48	f	\N	SH	1	Anatomic Sort Number	\N
8552	(0021,"Siemens: Thorax/Multix FD Lab Settings",31)	(0021,"Siemens: Thorax/Multix FD Lab Settings",31)	Siemens: Thorax/Multix FD Lab Settings	33	49	f	\N	SH	1	AcquisitionSortNumber	\N
8553	(0021,"KINETDX_GRAPHICS",a4)	(0021,"KINETDX_GRAPHICS",a4)	KINETDX_GRAPHICS	33	164	f	\N	OB	1	Unknown	\N
8554	(0021,"KINETDX",a6)	(0021,"KINETDX",a6)	KINETDX	33	166	f	\N	OB	1	Unknown	\N
8555	(0021,"KINETDX",a5)	(0021,"KINETDX",a5)	KINETDX	33	165	f	\N	US	1	Unknown	\N
8556	(0021,"KINETDX",a8)	(0021,"KINETDX",a8)	KINETDX	33	168	f	\N	LO	1	Unknown	\N
8557	(0021,"KINETDX",aa)	(0021,"KINETDX",aa)	KINETDX	33	170	f	\N	OB	1	Unknown	\N
8558	(0021,"KINETDX",ab)	(0021,"KINETDX",ab)	KINETDX	33	171	f	\N	LO	1	Unknown	\N
8559	(0021,"KINETDX",ac)	(0021,"KINETDX",ac)	KINETDX	33	172	f	\N	LO	1	Unknown	\N
8560	(0021,"KINETDX",b4)	(0021,"KINETDX",b4)	KINETDX	33	180	f	\N	LO	1	Unknown	\N
8561	(0021,"syngoDynamics",ae)	(0021,"syngoDynamics",ae)	syngoDynamics	33	174	f	\N	OB	1	Unknown	\N
8562	(0021,"syngoDynamics",b0)	(0021,"syngoDynamics",b0)	syngoDynamics	33	176	f	\N	LO	1	Unknown	\N
8563	(0021,"syngoDynamics",b1)	(0021,"syngoDynamics",b1)	syngoDynamics	33	177	f	\N	LO	1	Unknown	\N
8564	(0023,"SIEMENS MED NM",01)	(0023,"SIEMENS MED NM",01)	SIEMENS MED NM	35	1	f	\N	US	1	DICOM Reader flag	\N
8565	(0023,"Siemens: Thorax/Multix FD Image Stamp",00)	(0023,"Siemens: Thorax/Multix FD Image Stamp",00)	Siemens: Thorax/Multix FD Image Stamp	35	0	f	\N	US	1	Unknown	\N
8566	(0023,"Siemens: Thorax/Multix FD Image Stamp",01)	(0023,"Siemens: Thorax/Multix FD Image Stamp",01)	Siemens: Thorax/Multix FD Image Stamp	35	1	f	\N	US	1	Unknown	\N
8567	(0023,"Siemens: Thorax/Multix FD Image Stamp",02)	(0023,"Siemens: Thorax/Multix FD Image Stamp",02)	Siemens: Thorax/Multix FD Image Stamp	35	2	f	\N	US	1	Unknown	\N
8568	(0023,"Siemens: Thorax/Multix FD Image Stamp",03)	(0023,"Siemens: Thorax/Multix FD Image Stamp",03)	Siemens: Thorax/Multix FD Image Stamp	35	3	f	\N	US	1	Unknown	\N
8569	(0023,"Siemens: Thorax/Multix FD Image Stamp",04)	(0023,"Siemens: Thorax/Multix FD Image Stamp",04)	Siemens: Thorax/Multix FD Image Stamp	35	4	f	\N	US	1	Unknown	\N
8570	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0a)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0a)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	10	f	\N	US	1	Original Number of Frames	\N
8571	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0b)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0b)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	11	f	\N	DS	1	Original Scene Duration	\N
8572	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0c)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0c)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	12	f	\N	LO	1	Identifier LOID	\N
8573	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0d)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0d)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	13	f	\N	SS	1-n	Original Scene VFR Info	\N
8574	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0e)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0e)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	14	f	\N	SS	1	Original Frame ECG Position	\N
8575	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0f)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0f)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	15	f	\N	SS	1	Original ECG 1st Frame Offset	\N
8576	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",16)	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",16)	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	37	22	f	\N	IS	1	Ready Processing Status	\N
8577	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",00)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",00)	Siemens: Thorax/Multix FD Raw Image Settings	37	0	f	\N	SS	1	Raw Image Amplification	\N
8578	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",01)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",01)	Siemens: Thorax/Multix FD Raw Image Settings	37	1	f	\N	SS	1	Gamma LUT	\N
8579	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",02)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",02)	Siemens: Thorax/Multix FD Raw Image Settings	37	2	f	\N	US	1	Unknown	\N
8580	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",03)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",03)	Siemens: Thorax/Multix FD Raw Image Settings	37	3	f	\N	FL	1	Unknown	\N
8581	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",04)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",04)	Siemens: Thorax/Multix FD Raw Image Settings	37	4	f	\N	FL	1	Unknown	\N
8582	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",05)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",05)	Siemens: Thorax/Multix FD Raw Image Settings	37	5	f	\N	FL	1	Unknown	\N
8583	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",06)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",06)	Siemens: Thorax/Multix FD Raw Image Settings	37	6	f	\N	FL	1	Unknown	\N
8584	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",07)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",07)	Siemens: Thorax/Multix FD Raw Image Settings	37	7	f	\N	FL	1	Unknown	\N
8585	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",08)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",08)	Siemens: Thorax/Multix FD Raw Image Settings	37	8	f	\N	FL	1	Unknown	\N
8586	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",09)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",09)	Siemens: Thorax/Multix FD Raw Image Settings	37	9	f	\N	FL	1	Unknown	\N
8587	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0a)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0a)	Siemens: Thorax/Multix FD Raw Image Settings	37	10	f	\N	FL	1	Unknown	\N
8588	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0b)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0b)	Siemens: Thorax/Multix FD Raw Image Settings	37	11	f	\N	US	1	Unknown	\N
8589	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0c)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0c)	Siemens: Thorax/Multix FD Raw Image Settings	37	12	f	\N	SS	1	Harmonization Kernel	\N
8590	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0d)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0d)	Siemens: Thorax/Multix FD Raw Image Settings	37	13	f	\N	FL	1	Harmonization Gain	\N
8591	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0e)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0e)	Siemens: Thorax/Multix FD Raw Image Settings	37	14	f	\N	SS	1	Edge Enhancement Kernel	\N
8592	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0f)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0f)	Siemens: Thorax/Multix FD Raw Image Settings	37	15	f	\N	FL	1	Edge Enhancement Gain	\N
8593	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",10)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",10)	Siemens: Thorax/Multix FD Raw Image Settings	37	16	f	\N	LT	1	Internal Value	\N
8594	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",11)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",11)	Siemens: Thorax/Multix FD Raw Image Settings	37	17	f	\N	SS	1	Unknown	\N
8595	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",12)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",12)	Siemens: Thorax/Multix FD Raw Image Settings	37	18	f	\N	SS	1	Unknown	\N
8596	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",13)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",13)	Siemens: Thorax/Multix FD Raw Image Settings	37	19	f	\N	SS	1	Unknown	\N
8597	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",14)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",14)	Siemens: Thorax/Multix FD Raw Image Settings	37	20	f	\N	SS	1	Unknown	\N
8598	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",15)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",15)	Siemens: Thorax/Multix FD Raw Image Settings	37	21	f	\N	SS	1	Unknown	\N
8599	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",16)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",16)	Siemens: Thorax/Multix FD Raw Image Settings	37	22	f	\N	SS	1	Unknown	\N
8600	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",17)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",17)	Siemens: Thorax/Multix FD Raw Image Settings	37	23	f	\N	LO	1	Unknown	\N
8601	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",18)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",18)	Siemens: Thorax/Multix FD Raw Image Settings	37	24	f	\N	US	1	Auto Gain	\N
8602	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",19)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",19)	Siemens: Thorax/Multix FD Raw Image Settings	37	25	f	\N	US	1	Ortho Subsampling	\N
10540	(0009,"MMCPrivate",1f)	(0009,"MMCPrivate",1f)	MMCPrivate	9	31	f	\N	SQ	1	TaskInfo	X
8603	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1a)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1a)	Siemens: Thorax/Multix FD Raw Image Settings	37	26	f	\N	US	2	Image Crop Upper Left	\N
8604	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1b)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1b)	Siemens: Thorax/Multix FD Raw Image Settings	37	27	f	\N	US	2	Image Crop Upper Right	\N
8605	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1c)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1c)	Siemens: Thorax/Multix FD Raw Image Settings	37	28	f	\N	US	2	Image Crop Lower Left	\N
8606	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1d)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1d)	Siemens: Thorax/Multix FD Raw Image Settings	37	29	f	\N	US	2	Image Crop Lower Right	\N
8607	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",30)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",30)	Siemens: Thorax/Multix FD Raw Image Settings	37	48	f	\N	US	1	Manual Cropping	\N
8608	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",31)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",31)	Siemens: Thorax/Multix FD Raw Image Settings	37	49	f	\N	SS	1	Gamma LUT Parameter 1	\N
8609	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",32)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",32)	Siemens: Thorax/Multix FD Raw Image Settings	37	50	f	\N	DS	1	Gamma LUT Parameter 2	\N
8610	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",33)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",33)	Siemens: Thorax/Multix FD Raw Image Settings	37	51	f	\N	SS	1	Gamma LUT Parameter 3	\N
8611	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",34)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",34)	Siemens: Thorax/Multix FD Raw Image Settings	37	52	f	\N	SS	1	Gamma LUT Parameter 4	\N
8612	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",35)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",35)	Siemens: Thorax/Multix FD Raw Image Settings	37	53	f	\N	LO	1	Gamma LUT Name	\N
8613	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",36)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",36)	Siemens: Thorax/Multix FD Raw Image Settings	37	54	f	\N	DS	1	Unknown	\N
8614	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",37)	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",37)	Siemens: Thorax/Multix FD Raw Image Settings	37	55	f	\N	DS	1	Unknown	\N
8615	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",01)	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",01)	SIEMENS SYNGO ENHANCED IDATASET API	39	1	f	\N	CS	1	Business Unit Code	\N
8616	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",02)	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",02)	SIEMENS SYNGO ENHANCED IDATASET API	39	2	f	\N	LO	1	Application Type	\N
8617	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",03)	(0027,"SIEMENS SYNGO ENHANCED IDATASET API",03)	SIEMENS SYNGO ENHANCED IDATASET API	39	3	f	\N	SQ	1	Application Attributes Sequence	\N
8618	(0029,"SIEMENS SYNGO FUNCTION ASSIGNMENT",01)	(0029,"SIEMENS SYNGO FUNCTION ASSIGNMENT",01)	SIEMENS SYNGO FUNCTION ASSIGNMENT	41	1	f	\N	LO	1	Data Reference	\N
8619	(0029,"SHS MagicView 300",02)	(0029,"SHS MagicView 300",02)	SHS MagicView 300	41	2	f	\N	FD	1	Unknown	\N
8620	(0029,"SHS MagicView 300",03)	(0029,"SHS MagicView 300",03)	SHS MagicView 300	41	3	f	\N	FD	1	Unknown	\N
8621	(0029,"SIEMENS MED DISPLAY",80)	(0029,"SIEMENS MED DISPLAY",80)	SIEMENS MED DISPLAY	41	128	f	\N	US	1	Unknown	\N
8622	(0029,"SIEMENS MED MAMMO",5a)	(0029,"SIEMENS MED MAMMO",5a)	SIEMENS MED MAMMO	41	90	f	\N	CS	1	Unknown	\N
8623	(0029,"SIEMENS MED DISPLAY 0000",99)	(0029,"SIEMENS MED DISPLAY 0000",99)	SIEMENS MED DISPLAY 0000	41	153	f	\N	CS	1	Unknown	\N
8624	(0029,"SIEMENS MED DISPLAY 0000",c1)	(0029,"SIEMENS MED DISPLAY 0000",c1)	SIEMENS MED DISPLAY 0000	41	193	f	\N	US	1-n	Unknown	\N
8625	(0029,"SIEMENS MED DISPLAY 0000",b0)	(0029,"SIEMENS MED DISPLAY 0000",b0)	SIEMENS MED DISPLAY 0000	41	176	f	\N	US	1	Unknown	\N
8626	(0029,"SIEMENS MED DISPLAY 0000",b2)	(0029,"SIEMENS MED DISPLAY 0000",b2)	SIEMENS MED DISPLAY 0000	41	178	f	\N	US	1-n	Unknown	\N
8627	(0029,"SIEMENS MED DISPLAY 0001",99)	(0029,"SIEMENS MED DISPLAY 0001",99)	SIEMENS MED DISPLAY 0001	41	153	f	\N	CS	1	Unknown	\N
8628	(0029,"SIEMENS MED DISPLAY 0001",a0)	(0029,"SIEMENS MED DISPLAY 0001",a0)	SIEMENS MED DISPLAY 0001	41	160	f	\N	US	1	Unknown	\N
8629	(0029,"SIEMENS MED DISPLAY 0001",a1)	(0029,"SIEMENS MED DISPLAY 0001",a1)	SIEMENS MED DISPLAY 0001	41	161	f	\N	US	1	Unknown	\N
8630	(0029,"SIEMENS MED DISPLAY 0001",a2)	(0029,"SIEMENS MED DISPLAY 0001",a2)	SIEMENS MED DISPLAY 0001	41	162	f	\N	US	1-n	Unknown	\N
10987	(0119,"MRSC",1220)	(0119,"MRSC",20)	MRSC	281	32	t	12	IS	1-n	MedianFilterKernel	K
8638	(0029,"SIEMENS MEDCOM HEADER",77)	(0029,"SIEMENS MEDCOM HEADER",77)	SIEMENS MEDCOM HEADER	41	119	f	\N	UL	1	Referenced Object Offset	\N
8639	(0029,"SIEMENS SYNGO VOLUME",12)	(0029,"SIEMENS SYNGO VOLUME",12)	SIEMENS SYNGO VOLUME	41	18	f	\N	US	1	Slices	\N
8640	(0029,"SIEMENS SYNGO VOLUME",14)	(0029,"SIEMENS SYNGO VOLUME",14)	SIEMENS SYNGO VOLUME	41	20	f	\N	OB	1	Volume Histogram	\N
8641	(0029,"SIEMENS SYNGO VOLUME",18)	(0029,"SIEMENS SYNGO VOLUME",18)	SIEMENS SYNGO VOLUME	41	24	f	\N	IS	1	Volume Level	\N
8642	(0029,"SIEMENS SYNGO VOLUME",30)	(0029,"SIEMENS SYNGO VOLUME",30)	SIEMENS SYNGO VOLUME	41	48	f	\N	DS	3	Voxel Spacing	\N
8643	(0029,"SIEMENS SYNGO VOLUME",32)	(0029,"SIEMENS SYNGO VOLUME",32)	SIEMENS SYNGO VOLUME	41	50	f	\N	DS	3	Volume Position (Patient)	\N
8644	(0029,"SIEMENS SYNGO VOLUME",37)	(0029,"SIEMENS SYNGO VOLUME",37)	SIEMENS SYNGO VOLUME	41	55	f	\N	DS	9	Volume Orientation (Patient)	\N
8645	(0029,"SIEMENS SYNGO VOLUME",40)	(0029,"SIEMENS SYNGO VOLUME",40)	SIEMENS SYNGO VOLUME	41	64	f	\N	CS	1	Resampling Flag	\N
8646	(0029,"SIEMENS SYNGO VOLUME",42)	(0029,"SIEMENS SYNGO VOLUME",42)	SIEMENS SYNGO VOLUME	41	66	f	\N	CS	1	Normalization Flag	\N
8632	(0029,"SIEMENS MEDCOM HEADER",71)	(0029,"SIEMENS MEDCOM HEADER",71)	SIEMENS MEDCOM HEADER	41	113	f	\N	AT	1	Referenced Tag	X
8633	(0029,"SIEMENS MEDCOM HEADER",72)	(0029,"SIEMENS MEDCOM HEADER",72)	SIEMENS MEDCOM HEADER	41	114	f	\N	CS	1	Referenced Tag Type	X
8634	(0029,"SIEMENS MEDCOM HEADER",73)	(0029,"SIEMENS MEDCOM HEADER",73)	SIEMENS MEDCOM HEADER	41	115	f	\N	UL	1	Referenced Value Length	X
8635	(0029,"SIEMENS MEDCOM HEADER",74)	(0029,"SIEMENS MEDCOM HEADER",74)	SIEMENS MEDCOM HEADER	41	116	f	\N	CS	1	Referenced Object Device Type	X
8637	(0029,"SIEMENS MEDCOM HEADER",76)	(0029,"SIEMENS MEDCOM HEADER",76)	SIEMENS MEDCOM HEADER	41	118	f	\N	OB	1	Referenced Object ID	X
8650	(0029,"SIEMENS SYNGO TIME POINT SERVICE",01)	(0029,"SIEMENS SYNGO TIME POINT SERVICE",01)	SIEMENS SYNGO TIME POINT SERVICE	41	1	f	\N	LO	1	Time Point ID	\N
8651	(0029,"SIEMENS SYNGO TIME POINT SERVICE",02)	(0029,"SIEMENS SYNGO TIME POINT SERVICE",02)	SIEMENS SYNGO TIME POINT SERVICE	41	2	f	\N	LO	1	Time Point Information	\N
8652	(0029,"SIEMENS SYNGO TIME POINT SERVICE",50)	(0029,"SIEMENS SYNGO TIME POINT SERVICE",50)	SIEMENS SYNGO TIME POINT SERVICE	41	80	f	\N	SQ	1	Studies in Time Point Sequence	\N
8653	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",00)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",00)	SIEMENS SYNGO ADVANCED PRESENTATION	41	0	f	\N	CS	1	Presentation Name	\N
8654	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",01)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",01)	SIEMENS SYNGO ADVANCED PRESENTATION	41	1	f	\N	CS	1	Presentation Type	\N
8655	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)	SIEMENS SYNGO ADVANCED PRESENTATION	41	2	f	\N	SQ	1	Advanced Presentation Sequence	\N
8656	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)	SIEMENS SYNGO ADVANCED PRESENTATION	41	3	f	\N	SQ	1	Time Point Sequence	\N
8657	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)	SIEMENS SYNGO ADVANCED PRESENTATION	41	4	f	\N	SQ	1	Base Image Sequence	\N
8658	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",05)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",05)	SIEMENS SYNGO ADVANCED PRESENTATION	41	5	f	\N	SQ	1	Overlay Image Sequence	\N
8659	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",06)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",06)	SIEMENS SYNGO ADVANCED PRESENTATION	41	6	f	\N	SQ	1	Registration Instance Sequence	\N
8660	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",07)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",07)	SIEMENS SYNGO ADVANCED PRESENTATION	41	7	f	\N	SQ	1	Real World Value Mapping Instance Sequence	\N
8661	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",08)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",08)	SIEMENS SYNGO ADVANCED PRESENTATION	41	8	f	\N	SQ	1	Measurement Sequence	\N
8662	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",09)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",09)	SIEMENS SYNGO ADVANCED PRESENTATION	41	9	f	\N	UI	1	Measurement UID	\N
8663	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)	SIEMENS SYNGO ADVANCED PRESENTATION	41	16	f	\N	SQ	1	Segmentation Sequence	\N
8664	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",11)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",11)	SIEMENS SYNGO ADVANCED PRESENTATION	41	17	f	\N	UI	1	Segmentation UID	\N
8665	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)	SIEMENS SYNGO ADVANCED PRESENTATION	41	18	f	\N	SQ	1	Navigation Sequence	\N
8666	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",13)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",13)	SIEMENS SYNGO ADVANCED PRESENTATION	41	19	f	\N	CS	1	Navigation Name	\N
8667	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",14)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",14)	SIEMENS SYNGO ADVANCED PRESENTATION	41	20	f	\N	CS	1	Auto Navigation Direction	\N
8668	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",15)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",15)	SIEMENS SYNGO ADVANCED PRESENTATION	41	21	f	\N	DS	1	Auto Navigation Frame Rate	\N
8669	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",16)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",16)	SIEMENS SYNGO ADVANCED PRESENTATION	41	22	f	\N	CS	1	Auto Navigation Mode	\N
8670	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",17)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",17)	SIEMENS SYNGO ADVANCED PRESENTATION	41	23	f	\N	DS	1	Auto Navigation Realtime Speed	\N
8671	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",18)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",18)	SIEMENS SYNGO ADVANCED PRESENTATION	41	24	f	\N	CS	1	Auto Navigation Strategy	\N
8672	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",19)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",19)	SIEMENS SYNGO ADVANCED PRESENTATION	41	25	f	\N	CS	1	Auto Navigation Realtime Flag	\N
8673	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",20)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",20)	SIEMENS SYNGO ADVANCED PRESENTATION	41	32	f	\N	IS	1	Index Navigation Current Index	\N
8674	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",21)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",21)	SIEMENS SYNGO ADVANCED PRESENTATION	41	33	f	\N	IS	1	Index Auto Navigation Skipping Degree	\N
8675	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",22)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",22)	SIEMENS SYNGO ADVANCED PRESENTATION	41	34	f	\N	DS	1	Volume Navigation Minimum Pixel Spacing	\N
8676	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",23)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",23)	SIEMENS SYNGO ADVANCED PRESENTATION	41	35	f	\N	CS	1	Volume Navigation Scroll Unit	\N
8677	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",24)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",24)	SIEMENS SYNGO ADVANCED PRESENTATION	41	36	f	\N	DS	1	Volume Navigation Step Size	\N
8678	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",25)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",25)	SIEMENS SYNGO ADVANCED PRESENTATION	41	37	f	\N	DS	1	Volume Navigation Jump Size	\N
8679	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",26)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",26)	SIEMENS SYNGO ADVANCED PRESENTATION	41	38	f	\N	IS	1	Referenced Registration Number	\N
8680	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",27)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",27)	SIEMENS SYNGO ADVANCED PRESENTATION	41	39	f	\N	UI	1	Real World Value Mapping UID	\N
8681	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",28)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",28)	SIEMENS SYNGO ADVANCED PRESENTATION	41	40	f	\N	DS	1	Channel Alpha Value	\N
8682	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",30)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",30)	SIEMENS SYNGO ADVANCED PRESENTATION	41	48	f	\N	LO	1	Measurement Application Name	\N
8683	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)	SIEMENS SYNGO ADVANCED PRESENTATION	41	49	f	\N	SQ	1	Measurement Data Sequence	\N
8684	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",32)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",32)	SIEMENS SYNGO ADVANCED PRESENTATION	41	50	f	\N	LO	1	Measurement Type	\N
8685	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",33)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",33)	SIEMENS SYNGO ADVANCED PRESENTATION	41	51	f	\N	UI	1	Measurement Frame of Reference UID	\N
8686	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",34)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",34)	SIEMENS SYNGO ADVANCED PRESENTATION	41	52	f	\N	UI	1	Measurement UID	\N
8687	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",35)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",35)	SIEMENS SYNGO ADVANCED PRESENTATION	41	53	f	\N	IS	1	Measurement Application Number	\N
8688	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",36)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",36)	SIEMENS SYNGO ADVANCED PRESENTATION	41	54	f	\N	ST	1	Measurement Application Number Prefix Text	\N
8689	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",37)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",37)	SIEMENS SYNGO ADVANCED PRESENTATION	41	55	f	\N	CS	1	Measurement Graphic Is Visible Flag	\N
8690	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",38)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",38)	SIEMENS SYNGO ADVANCED PRESENTATION	41	56	f	\N	UI	4	Referenced Syngo UID	\N
8691	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",39)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",39)	SIEMENS SYNGO ADVANCED PRESENTATION	41	57	f	\N	UI	1	Clinical Finding UID	\N
8692	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	58	f	\N	CS	1	Measurement Evaluation String Value	\N
8693	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	59	f	\N	IS	1	Measurement Evaluation Integer Value	\N
8694	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3c)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3c)	SIEMENS SYNGO ADVANCED PRESENTATION	41	60	f	\N	FL	1	Measurement Evaluation Decimal Value	\N
8695	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3d)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3d)	SIEMENS SYNGO ADVANCED PRESENTATION	41	61	f	\N	CS	1	Measurement Line Show Center Flag	\N
8696	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3e)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3e)	SIEMENS SYNGO ADVANCED PRESENTATION	41	62	f	\N	CS	1	Measurement Angle Show ArrowTip Flag	\N
8697	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)	SIEMENS SYNGO ADVANCED PRESENTATION	41	63	f	\N	SQ	1	Camera Home Settings Sequence	\N
8698	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",40)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",40)	SIEMENS SYNGO ADVANCED PRESENTATION	41	64	f	\N	DS	1	Camera Zoom	\N
8699	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",41)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",41)	SIEMENS SYNGO ADVANCED PRESENTATION	41	65	f	\N	DS	3	Camera Position	\N
8700	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",42)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",42)	SIEMENS SYNGO ADVANCED PRESENTATION	41	66	f	\N	DS	4	Camera Orientation	\N
8701	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",43)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",43)	SIEMENS SYNGO ADVANCED PRESENTATION	41	67	f	\N	DS	1	Camera Far Clip Plane	\N
8702	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",44)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",44)	SIEMENS SYNGO ADVANCED PRESENTATION	41	68	f	\N	DS	1	Camera Near Clip Plane	\N
8703	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",45)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",45)	SIEMENS SYNGO ADVANCED PRESENTATION	41	69	f	\N	DS	1	Camera Thickness	\N
8704	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",46)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",46)	SIEMENS SYNGO ADVANCED PRESENTATION	41	70	f	\N	DS	1	Camera ViewPort Size	\N
8705	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",47)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",47)	SIEMENS SYNGO ADVANCED PRESENTATION	41	71	f	\N	DS	1	Camera Aspect Ratio	\N
8706	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",48)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",48)	SIEMENS SYNGO ADVANCED PRESENTATION	41	72	f	\N	LO	1	Camera Projection Type	\N
8707	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",49)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",49)	SIEMENS SYNGO ADVANCED PRESENTATION	41	73	f	\N	DS	1	Camera Field of View	\N
8708	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	74	f	\N	DS	1	Camera Image Plane Distance	\N
8709	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	75	f	\N	DS	1	Camera Image Maximum Height	\N
8710	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4c)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4c)	SIEMENS SYNGO ADVANCED PRESENTATION	41	76	f	\N	DS	1	Camera Image Minimum Height	\N
8711	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4d)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4d)	SIEMENS SYNGO ADVANCED PRESENTATION	41	77	f	\N	DS	1	Parallel Shift Interval MM	\N
8712	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4e)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4e)	SIEMENS SYNGO ADVANCED PRESENTATION	41	78	f	\N	DS	3	Parallel Shift BoundingBox Minimum	\N
8713	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4f)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4f)	SIEMENS SYNGO ADVANCED PRESENTATION	41	79	f	\N	DS	3	Parallel Shift BoundingBox Maximum	\N
8714	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",50)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",50)	SIEMENS SYNGO ADVANCED PRESENTATION	41	80	f	\N	CS	1	Renderer Vertex Is Characteristic Flag	\N
8715	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",51)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",51)	SIEMENS SYNGO ADVANCED PRESENTATION	41	81	f	\N	CS	1	Renderer Thickness Usage Flag	\N
8716	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",52)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",52)	SIEMENS SYNGO ADVANCED PRESENTATION	41	82	f	\N	DS	4	Renderer Threshold	\N
8717	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",53)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",53)	SIEMENS SYNGO ADVANCED PRESENTATION	41	83	f	\N	DS	4	Renderer Material	\N
8718	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",54)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",54)	SIEMENS SYNGO ADVANCED PRESENTATION	41	84	f	\N	DS	4	Renderer DirectionalLight Color	\N
8719	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",55)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",55)	SIEMENS SYNGO ADVANCED PRESENTATION	41	85	f	\N	DS	3	Renderer DirectionalLight Direction	\N
8720	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",56)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",56)	SIEMENS SYNGO ADVANCED PRESENTATION	41	86	f	\N	CS	1	Renderer DirectionalLight TwoSide Usage Flag	\N
8721	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)	SIEMENS SYNGO ADVANCED PRESENTATION	41	87	f	\N	SQ	1	Renderer PWL TransferFunction Sequence	\N
8722	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",58)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",58)	SIEMENS SYNGO ADVANCED PRESENTATION	41	88	f	\N	IS	0-n	Renderer PWL Vertex Index	\N
8723	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",59)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",59)	SIEMENS SYNGO ADVANCED PRESENTATION	41	89	f	\N	DS	0-n	Renderer PWL Vertex Color	\N
8724	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	90	f	\N	CS	1	Renderer Is Camera Required Flag	\N
10988	(0119,"MRSC",1221)	(0119,"MRSC",21)	MRSC	281	33	t	12	DS	1-n	BackgroundCorrection	K
8725	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	91	f	\N	CS	1	Renderer Do Depth Test Flag 	\N
8726	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5c)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5c)	SIEMENS SYNGO ADVANCED PRESENTATION	41	92	f	\N	CS	1	Renderer Directional Light Usage Flag	\N
8727	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5d)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5d)	SIEMENS SYNGO ADVANCED PRESENTATION	41	93	f	\N	SQ	1	Renderer Thickness Sequence	\N
8728	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5e)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5e)	SIEMENS SYNGO ADVANCED PRESENTATION	41	94	f	\N	SQ	0-n	Renderer Slice Spacing Sequence	\N
8729	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5f)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5f)	SIEMENS SYNGO ADVANCED PRESENTATION	41	95	f	\N	DS	1	Renderer Sampling Distance	\N
8730	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",60)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",60)	SIEMENS SYNGO ADVANCED PRESENTATION	41	96	f	\N	DS	1	Renderer Initial Sampling Distance	\N
8731	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)	SIEMENS SYNGO ADVANCED PRESENTATION	41	97	f	\N	SQ	1	Segmentation Display Data Sequence	\N
8732	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",62)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",62)	SIEMENS SYNGO ADVANCED PRESENTATION	41	98	f	\N	UI	0-n	Segmentation Display Data UID	\N
8733	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)	SIEMENS SYNGO ADVANCED PRESENTATION	41	99	f	\N	SQ	1	Segmentation Display Parameter Sequence	\N
8734	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",64)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",64)	SIEMENS SYNGO ADVANCED PRESENTATION	41	100	f	\N	LO	1	Segmentation Display Parameter Type	\N
8735	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",65)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",65)	SIEMENS SYNGO ADVANCED PRESENTATION	41	101	f	\N	LO	1	Segmentation Display Visibility	\N
8736	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",66)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",66)	SIEMENS SYNGO ADVANCED PRESENTATION	41	102	f	\N	DS	4	Segmentation Display Color	\N
8737	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",67)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",67)	SIEMENS SYNGO ADVANCED PRESENTATION	41	103	f	\N	CS	1	Segmentation Display is Selected Flag 	\N
8738	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",68)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",68)	SIEMENS SYNGO ADVANCED PRESENTATION	41	104	f	\N	OB	1	Segmentation Additional Information Blob	\N
8739	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",69)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",69)	SIEMENS SYNGO ADVANCED PRESENTATION	41	105	f	\N	ST	1	Hash Code Value	\N
8740	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",6a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",6a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	106	f	\N	LO	1-n	Segmentation Version Identifier	\N
8741	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",70)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",70)	SIEMENS SYNGO ADVANCED PRESENTATION	41	112	f	\N	DS	3	Segmentation Volume Size	\N
8742	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",71)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",71)	SIEMENS SYNGO ADVANCED PRESENTATION	41	113	f	\N	UI	1-n	Registration Referenced Frames	\N
8743	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",72)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",72)	SIEMENS SYNGO ADVANCED PRESENTATION	41	114	f	\N	UI	1-n	Registration Referenced Registrations	\N
8744	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",73)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",73)	SIEMENS SYNGO ADVANCED PRESENTATION	41	115	f	\N	LO	1	Registration Creation Algorithm Name	\N
8745	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",74)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",74)	SIEMENS SYNGO ADVANCED PRESENTATION	41	116	f	\N	CS	1	ECG Graphic Type	\N
8746	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	122	f	\N	DS	1	Segmentation Volume Storage Data Type	\N
8747	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	123	f	\N	FL	16	Segmentation Volume Model Matrix	\N
8748	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",80)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",80)	SIEMENS SYNGO ADVANCED PRESENTATION	41	128	f	\N	DS	3	Camera Rotation Axis	\N
8749	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",81)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",81)	SIEMENS SYNGO ADVANCED PRESENTATION	41	129	f	\N	SL	0-n	Overlay Hidden Display Attributes	\N
8750	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",82)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",82)	SIEMENS SYNGO ADVANCED PRESENTATION	41	130	f	\N	LO	1	Presentation State Group Identifier	\N
8751	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",83)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",83)	SIEMENS SYNGO ADVANCED PRESENTATION	41	131	f	\N	US	1	Temporary Smallest Image Pixel Value	\N
8752	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",84)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",84)	SIEMENS SYNGO ADVANCED PRESENTATION	41	132	f	\N	DS	3	Camera Rotation Center	\N
8753	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",85)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",85)	SIEMENS SYNGO ADVANCED PRESENTATION	41	133	f	\N	CS	1	Camera Rotation Center Usage Flag	\N
8754	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",86)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",86)	SIEMENS SYNGO ADVANCED PRESENTATION	41	134	f	\N	DS	12	Camera Parallel Epiped	\N
8755	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",87)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",87)	SIEMENS SYNGO ADVANCED PRESENTATION	41	135	f	\N	DS	1	Camera Max Zoom In Factor	\N
8756	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",88)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",88)	SIEMENS SYNGO ADVANCED PRESENTATION	41	136	f	\N	DS	1	Camera Min Zoom In Factor	\N
8757	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",89)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",89)	SIEMENS SYNGO ADVANCED PRESENTATION	41	137	f	\N	US	1	Temporary Largest Image Pixel Value	\N
8758	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	138	f	\N	CS	1	Camera Rotation Axis Usage Flag	\N
8759	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	139	f	\N	DS	3	Measurement Surface Normal	\N
8760	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8c)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8c)	SIEMENS SYNGO ADVANCED PRESENTATION	41	140	f	\N	FL	16	Measurement Ellipsoid Model Matrix	\N
8761	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8d)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8d)	SIEMENS SYNGO ADVANCED PRESENTATION	41	141	f	\N	LO	1	Measurement Evaluation DataRole ID	\N
8762	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8e)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8e)	SIEMENS SYNGO ADVANCED PRESENTATION	41	142	f	\N	LO	1	Measurement Algorithm Type	\N
8763	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)	SIEMENS SYNGO ADVANCED PRESENTATION	41	145	f	\N	SQ	1	Measurement Evaluation DataRole Sequence	\N
8764	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",92)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",92)	SIEMENS SYNGO ADVANCED PRESENTATION	41	146	f	\N	CS	1	Measurement Evaluation DataRole Item	\N
8765	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)	SIEMENS SYNGO ADVANCED PRESENTATION	41	147	f	\N	SQ	1	Measurement Evaluation Sequence	\N
8766	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",94)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",94)	SIEMENS SYNGO ADVANCED PRESENTATION	41	148	f	\N	DS	1	Measurement Evaluation Value	\N
8767	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",95)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",95)	SIEMENS SYNGO ADVANCED PRESENTATION	41	149	f	\N	CS	1	Measurement Evaluation ID	\N
8768	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",96)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",96)	SIEMENS SYNGO ADVANCED PRESENTATION	41	150	f	\N	FL	0-n	Measurement Data Points	\N
8769	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",97)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",97)	SIEMENS SYNGO ADVANCED PRESENTATION	41	151	f	\N	FL	0-n	Measurement Data Angles	\N
8770	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",98)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",98)	SIEMENS SYNGO ADVANCED PRESENTATION	41	152	f	\N	LO	1	Measurement Data Slice	\N
8771	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",99)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",99)	SIEMENS SYNGO ADVANCED PRESENTATION	41	153	f	\N	FL	1	Measurement Data Slice Thickness	\N
8772	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)	SIEMENS SYNGO ADVANCED PRESENTATION	41	154	f	\N	SQ	1	Measurement Referenced Frames Sequence	\N
8773	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9b)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9b)	SIEMENS SYNGO ADVANCED PRESENTATION	41	155	f	\N	DS	0-n	Measurement Evaluation Longest Distance	\N
8774	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9c)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9c)	SIEMENS SYNGO ADVANCED PRESENTATION	41	156	f	\N	DS	0-n	Measurement Evaluation Centroid	\N
8775	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9d)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9d)	SIEMENS SYNGO ADVANCED PRESENTATION	41	157	f	\N	FL	6	Measurement Data Bounding Box 	\N
8776	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9e)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9e)	SIEMENS SYNGO ADVANCED PRESENTATION	41	158	f	\N	LO	1	Measurement Text	\N
8777	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9f)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9f)	SIEMENS SYNGO ADVANCED PRESENTATION	41	159	f	\N	IS	1	Measurement Diameter	\N
8778	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a0)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a0)	SIEMENS SYNGO ADVANCED PRESENTATION	41	160	f	\N	DS	1	Image Rotation Fractional	\N
8779	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	161	f	\N	LO	1	Preset Name	\N
8780	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	162	f	\N	SQ	1	Fusion LUT Sequence	\N
8781	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	163	f	\N	CS	1	Fusion LUT Is Active Flag	\N
8782	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a5)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a5)	SIEMENS SYNGO ADVANCED PRESENTATION	41	165	f	\N	UI	1	Syngo UID	\N
8783	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a6)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a6)	SIEMENS SYNGO ADVANCED PRESENTATION	41	166	f	\N	UI	1	Presentation Version Identifier	\N
8784	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)	SIEMENS SYNGO ADVANCED PRESENTATION	41	167	f	\N	SQ	1	Presentation Module Sequence	\N
8785	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a8)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a8)	SIEMENS SYNGO ADVANCED PRESENTATION	41	168	f	\N	LO	1	Presentation Module Type	\N
8786	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)	SIEMENS SYNGO ADVANCED PRESENTATION	41	169	f	\N	SQ	1	Presentation State Sequence	\N
8787	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",aa)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",aa)	SIEMENS SYNGO ADVANCED PRESENTATION	41	170	f	\N	CS	1	LUT Inverted Flag	\N
8788	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ab)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ab)	SIEMENS SYNGO ADVANCED PRESENTATION	41	171	f	\N	IS	1	Softcopy VOI LUT Viewing Index	\N
8789	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ac)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ac)	SIEMENS SYNGO ADVANCED PRESENTATION	41	172	f	\N	FD	2	Displayed Area Bottom Right Hand Corner Fractional	\N
8790	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ad)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ad)	SIEMENS SYNGO ADVANCED PRESENTATION	41	173	f	\N	FD	2	Displayed Area Top Left Hand Corner Fractional	\N
8791	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ae)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ae)	SIEMENS SYNGO ADVANCED PRESENTATION	41	174	f	\N	FL	1	Measurement Alpha	\N
8792	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",af)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",af)	SIEMENS SYNGO ADVANCED PRESENTATION	41	175	f	\N	OB	1	Measurement Bitmap	\N
8793	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b0)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b0)	SIEMENS SYNGO ADVANCED PRESENTATION	41	176	f	\N	US	1	Current Frame Number	\N
8794	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	177	f	\N	LO	1	Image Text View Name	\N
8795	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	178	f	\N	SQ	1	Image Text View Content Sequence	\N
8796	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	179	f	\N	LO	1-n	Image Text Line Names	\N
8797	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b4)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b4)	SIEMENS SYNGO ADVANCED PRESENTATION	41	180	f	\N	LO	1-n	ImageText Line Values	\N
8798	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)	SIEMENS SYNGO ADVANCED PRESENTATION	41	181	f	\N	SQ	1	Measurement Evaluation Text Position Sequence	\N
8933	(0033,"SIEMENS MED NM",1a)	(0033,"SIEMENS MED NM",1a)	SIEMENS MED NM	51	26	f	\N	FL	1-n	Unknown	\N
8799	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b6)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b6)	SIEMENS SYNGO ADVANCED PRESENTATION	41	182	f	\N	CS	1	Measurement Link Evaluation Text Flag	\N
8800	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b7)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b7)	SIEMENS SYNGO ADVANCED PRESENTATION	41	183	f	\N	DS	3	Measurement Evaluation Text Position Vector	\N
8801	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b8)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b8)	SIEMENS SYNGO ADVANCED PRESENTATION	41	184	f	\N	OB	1	Image Text Alpha Blending Line Value	\N
8802	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	193	f	\N	SQ	1	Task Data Sequence	\N
8803	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	194	f	\N	CS	1	Task Data Type	\N
8804	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	195	f	\N	LO	1	Task Data Version	\N
8805	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c4)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c4)	SIEMENS SYNGO ADVANCED PRESENTATION	41	196	f	\N	ST	1	Task Data Description	\N
8806	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c5)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c5)	SIEMENS SYNGO ADVANCED PRESENTATION	41	197	f	\N	OB	1	Task Data	\N
8807	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c6)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c6)	SIEMENS SYNGO ADVANCED PRESENTATION	41	198	f	\N	IS	1	Task Data Size	\N
8808	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c9)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",c9)	SIEMENS SYNGO ADVANCED PRESENTATION	41	201	f	\N	SQ	1	Clip Plane Sequence	\N
8809	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ca)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ca)	SIEMENS SYNGO ADVANCED PRESENTATION	41	202	f	\N	DS	3	Clip Plane Center	\N
8810	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cb)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cb)	SIEMENS SYNGO ADVANCED PRESENTATION	41	203	f	\N	DS	3	Clip Plane Normal	\N
8811	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cc)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cc)	SIEMENS SYNGO ADVANCED PRESENTATION	41	204	f	\N	DS	2	Clip Plane Scale	\N
8812	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cd)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cd)	SIEMENS SYNGO ADVANCED PRESENTATION	41	205	f	\N	CS	1	Clip Plane Use Thickness Flag	\N
8813	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ce)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ce)	SIEMENS SYNGO ADVANCED PRESENTATION	41	206	f	\N	DS	1	Clip Plane Thickness	\N
8814	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)	SIEMENS SYNGO ADVANCED PRESENTATION	41	207	f	\N	SQ	1	Image Sequence	\N
8815	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d0)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d0)	SIEMENS SYNGO ADVANCED PRESENTATION	41	208	f	\N	CS	1	Clip Plane Enable Clip	\N
8816	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	209	f	\N	DS	1	Clip Plane Handle Ratio	\N
8817	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	210	f	\N	DS	24	Clip Plane Bounding Points	\N
8818	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	211	f	\N	DS	16	Clip Plane Motion Matrix	\N
8819	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d4)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d4)	SIEMENS SYNGO ADVANCED PRESENTATION	41	212	f	\N	DS	1	Clip Plane Shift Velocity	\N
8820	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d5)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d5)	SIEMENS SYNGO ADVANCED PRESENTATION	41	213	f	\N	CS	1	Clip Plane Enabled Flag	\N
8821	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d6)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d6)	SIEMENS SYNGO ADVANCED PRESENTATION	41	214	f	\N	DS	1	Clip Plane Rotate Velocity	\N
8822	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d7)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",d7)	SIEMENS SYNGO ADVANCED PRESENTATION	41	215	f	\N	CS	1	Clip Plane Show Graphics Flag	\N
8823	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e0)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e0)	SIEMENS SYNGO ADVANCED PRESENTATION	41	224	f	\N	DS	3	Crop Box Size	\N
8824	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	225	f	\N	CS	1	Crop Box Enabled Flag	\N
8825	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	226	f	\N	DS	3	Crop Box Absolute Origin	\N
8826	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",e3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	227	f	\N	CS	1	Crop Box Show Graphics Flag	\N
8827	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f1)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f1)	SIEMENS SYNGO ADVANCED PRESENTATION	41	241	f	\N	DS	0-n	Curved Camera Coordinates	\N
8828	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f2)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f2)	SIEMENS SYNGO ADVANCED PRESENTATION	41	242	f	\N	DS	1	Curved Camera Point of Interest	\N
8829	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f3)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f3)	SIEMENS SYNGO ADVANCED PRESENTATION	41	243	f	\N	CS	1	Curved Camera Point of Interest Usage Flag	\N
8830	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f4)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f4)	SIEMENS SYNGO ADVANCED PRESENTATION	41	244	f	\N	DS	1	Curved Camera Thickness	\N
8831	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f5)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f5)	SIEMENS SYNGO ADVANCED PRESENTATION	41	245	f	\N	DS	1	Curved Camera Extrusion Length	\N
8832	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f6)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f6)	SIEMENS SYNGO ADVANCED PRESENTATION	41	246	f	\N	CS	1	Curved Camera Rotation Axis Mode	\N
8833	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f7)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f7)	SIEMENS SYNGO ADVANCED PRESENTATION	41	247	f	\N	DS	1	Curved Camera Roll Rotation Axis	\N
8834	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f8)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f8)	SIEMENS SYNGO ADVANCED PRESENTATION	41	248	f	\N	DS	1	Curved Camera View Port Height	\N
8835	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f9)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f9)	SIEMENS SYNGO ADVANCED PRESENTATION	41	249	f	\N	DS	1	Curved Camera Cut Direction	\N
8836	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fa)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fa)	SIEMENS SYNGO ADVANCED PRESENTATION	41	250	f	\N	DS	1	Curved Camera Pan Vector	\N
8837	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fb)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fb)	SIEMENS SYNGO ADVANCED PRESENTATION	41	251	f	\N	LO	1	Clinical Finding ID	\N
8838	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fc)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fc)	SIEMENS SYNGO ADVANCED PRESENTATION	41	252	f	\N	CS	1	Measurement Is Circle Flag	\N
8839	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fd)	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fd)	SIEMENS SYNGO ADVANCED PRESENTATION	41	253	f	\N	LO	1	Measurement Application Type ID	\N
8840	(0029,"SIEMENS SYNGO FRAME SET",10)	(0029,"SIEMENS SYNGO FRAME SET",10)	SIEMENS SYNGO FRAME SET	41	16	f	\N	SQ	1	Image Frame Sequence	\N
8841	(0029,"SIEMENS SYNGO FRAME SET",12)	(0029,"SIEMENS SYNGO FRAME SET",12)	SIEMENS SYNGO FRAME SET	41	18	f	\N	CS	1	Type of Progression	\N
8842	(0029,"SIEMENS SYNGO FRAME SET",14)	(0029,"SIEMENS SYNGO FRAME SET",14)	SIEMENS SYNGO FRAME SET	41	20	f	\N	IS	1	Representation Level	\N
8843	(0029,"SIEMENS SYNGO FRAME SET",16)	(0029,"SIEMENS SYNGO FRAME SET",16)	SIEMENS SYNGO FRAME SET	41	22	f	\N	SQ	1	Representation Information Sequence	\N
8844	(0029,"SIEMENS SYNGO FRAME SET",18)	(0029,"SIEMENS SYNGO FRAME SET",18)	SIEMENS SYNGO FRAME SET	41	24	f	\N	IS	1	Number of Representations	\N
8845	(0029,"SIEMENS SYNGO FRAME SET",20)	(0029,"SIEMENS SYNGO FRAME SET",20)	SIEMENS SYNGO FRAME SET	41	32	f	\N	IS	1	Representation Pixel Offset	\N
8846	(0029,"SIEMENS SYNGO PRINT SERVICE",10)	(0029,"SIEMENS SYNGO PRINT SERVICE",10)	SIEMENS SYNGO PRINT SERVICE	41	16	f	\N	IS	1	Sheet Number	\N
8847	(0029,"SIEMENS IKM CKS LUNGCAD BMK",01)	(0029,"SIEMENS IKM CKS LUNGCAD BMK",01)	SIEMENS IKM CKS LUNGCAD BMK	41	1	f	\N	UT	1	Unknown	\N
8848	(0029,"SIEMENS IKM CKS CXRCAD FINDINGS",01)	(0029,"SIEMENS IKM CKS CXRCAD FINDINGS",01)	SIEMENS IKM CKS CXRCAD FINDINGS	41	1	f	\N	UT	1	Unknown	\N
8855	(0029,"SIEMENS MED NM",08)	(0029,"SIEMENS MED NM",08)	SIEMENS MED NM	41	8	f	\N	CS	1	Modality Image Header Type	\N
8856	(0029,"SIEMENS MED NM",09)	(0029,"SIEMENS MED NM",09)	SIEMENS MED NM	41	9	f	\N	LO	1	Modality Image Header Version	\N
8857	(0029,"SIEMENS MED NM",10)	(0029,"SIEMENS MED NM",10)	SIEMENS MED NM	41	16	f	\N	OB	1	Modality Image Header Info	\N
8858	(0031,"SIEMENS MED NM",01)	(0031,"SIEMENS MED NM",01)	SIEMENS MED NM	49	1	f	\N	ST	1	Unknown	\N
8859	(0031,"SIEMENS MED NM",0c)	(0031,"SIEMENS MED NM",0c)	SIEMENS MED NM	49	12	f	\N	SS	1	Unknown	\N
8860	(0031,"SIEMENS MED NM",0f)	(0031,"SIEMENS MED NM",0f)	SIEMENS MED NM	49	15	f	\N	SL	1	Unknown	\N
8861	(0031,"SIEMENS MED NM",10)	(0031,"SIEMENS MED NM",10)	SIEMENS MED NM	49	16	f	\N	SL	1	Unknown	\N
8862	(0031,"SIEMENS MED NM",12)	(0031,"SIEMENS MED NM",12)	SIEMENS MED NM	49	18	f	\N	SS	1	Unknown	\N
8863	(0031,"SIEMENS MED NM",13)	(0031,"SIEMENS MED NM",13)	SIEMENS MED NM	49	19	f	\N	ST	1	Unknown	\N
8864	(0031,"SIEMENS MED NM",14)	(0031,"SIEMENS MED NM",14)	SIEMENS MED NM	49	20	f	\N	ST	1	Unknown	\N
8865	(0031,"SIEMENS MED NM",15)	(0031,"SIEMENS MED NM",15)	SIEMENS MED NM	49	21	f	\N	SL	1-n	Unknown	\N
8866	(0031,"SIEMENS MED NM",16)	(0031,"SIEMENS MED NM",16)	SIEMENS MED NM	49	22	f	\N	SL	1-n	Unknown	\N
8867	(0031,"SIEMENS MED NM",17)	(0031,"SIEMENS MED NM",17)	SIEMENS MED NM	49	23	f	\N	SS	1-n	Unknown	\N
8868	(0031,"SIEMENS MED NM",20)	(0031,"SIEMENS MED NM",20)	SIEMENS MED NM	49	32	f	\N	ST	1	Unknown	\N
8869	(0031,"SIEMENS MED NM",21)	(0031,"SIEMENS MED NM",21)	SIEMENS MED NM	49	33	f	\N	SS	1	Unknown	\N
8870	(0031,"SIEMENS SYNGO SOP CLASS PACKING",10)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",10)	SIEMENS SYNGO SOP CLASS PACKING	49	16	f	\N	SQ	1	SOP Class Packing Sequence	\N
8871	(0031,"SIEMENS SYNGO SOP CLASS PACKING",20)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",20)	SIEMENS SYNGO SOP CLASS PACKING	49	32	f	\N	CS	1	Packing Version	\N
8872	(0031,"SIEMENS SYNGO SOP CLASS PACKING",21)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",21)	SIEMENS SYNGO SOP CLASS PACKING	49	33	f	\N	CS	1	Packing Originator	\N
8873	(0031,"SIEMENS SYNGO SOP CLASS PACKING",30)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",30)	SIEMENS SYNGO SOP CLASS PACKING	49	48	f	\N	UI	1	Original SOP Class UID	\N
8874	(0031,"SIEMENS SYNGO SOP CLASS PACKING",31)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",31)	SIEMENS SYNGO SOP CLASS PACKING	49	49	f	\N	UI	1	Original Study Instance UID	\N
8875	(0031,"SIEMENS SYNGO SOP CLASS PACKING",32)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",32)	SIEMENS SYNGO SOP CLASS PACKING	49	50	f	\N	UI	1	Original Series Instance UID	\N
8876	(0031,"SIEMENS SYNGO SOP CLASS PACKING",33)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",33)	SIEMENS SYNGO SOP CLASS PACKING	49	51	f	\N	UI	1	Original SOP Instance UID	\N
8877	(0031,"SIEMENS SYNGO SOP CLASS PACKING",34)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",34)	SIEMENS SYNGO SOP CLASS PACKING	49	52	f	\N	UI	1	Original Transfer Syntax UID	\N
8878	(0031,"SIEMENS SYNGO SOP CLASS PACKING",40)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",40)	SIEMENS SYNGO SOP CLASS PACKING	49	64	f	\N	AT	1-n	Attributes to Set to Zero Length	\N
8879	(0031,"SIEMENS SYNGO SOP CLASS PACKING",41)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",41)	SIEMENS SYNGO SOP CLASS PACKING	49	65	f	\N	AT	1-n	Attributes to Remove	\N
8880	(0031,"SIEMENS SYNGO SOP CLASS PACKING",50)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",50)	SIEMENS SYNGO SOP CLASS PACKING	49	80	f	\N	US	1	Original Rows	\N
8881	(0031,"SIEMENS SYNGO SOP CLASS PACKING",51)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",51)	SIEMENS SYNGO SOP CLASS PACKING	49	81	f	\N	US	1	Original Columns	\N
8882	(0031,"SIEMENS SYNGO SOP CLASS PACKING",58)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",58)	SIEMENS SYNGO SOP CLASS PACKING	49	88	f	\N	CS	2-n	Original Image Type	\N
8883	(0031,"SIEMENS SYNGO SOP CLASS PACKING",60)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",60)	SIEMENS SYNGO SOP CLASS PACKING	49	96	f	\N	CS	1	Original Modality	\N
8854	(0029,"SIEMENS CSA ENVELOPE",11)	(0029,"SIEMENS CSA ENVELOPE",11)	SIEMENS CSA ENVELOPE	41	17	f	\N	OB	1	syngo Report Presentation	X
8849	(0029,"SIEMENS CSA REPORT",08)	(0029,"SIEMENS CSA REPORT",08)	SIEMENS CSA REPORT	41	8	f	\N	CS	1	Report Type	X
8850	(0029,"SIEMENS CSA REPORT",09)	(0029,"SIEMENS CSA REPORT",09)	SIEMENS CSA REPORT	41	9	f	\N	LO	1	Report Version	X
8851	(0029,"SIEMENS CSA REPORT",15)	(0029,"SIEMENS CSA REPORT",15)	SIEMENS CSA REPORT	41	21	f	\N	US	1	SR Variant	X
8852	(0029,"SIEMENS CSA REPORT",17)	(0029,"SIEMENS CSA REPORT",17)	SIEMENS CSA REPORT	41	23	f	\N	UI	1	SC SOP Instance UID	X
8934	(0033,"SIEMENS MED NM",20)	(0033,"SIEMENS MED NM",20)	SIEMENS MED NM	51	32	f	\N	FL	1	Bed correction angle	K
8884	(0031,"SIEMENS SYNGO SOP CLASS PACKING",70)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",70)	SIEMENS SYNGO SOP CLASS PACKING	49	112	f	\N	SQ	1	Sequence of Original StreamCchunks	\N
8885	(0031,"SIEMENS SYNGO SOP CLASS PACKING",71)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",71)	SIEMENS SYNGO SOP CLASS PACKING	49	113	f	\N	AT	1	Start Tag of a Stream Chunk	\N
8886	(0031,"SIEMENS SYNGO SOP CLASS PACKING",72)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",72)	SIEMENS SYNGO SOP CLASS PACKING	49	114	f	\N	AT	1	End Tag of a Stream Chunk	\N
8887	(0031,"SIEMENS SYNGO SOP CLASS PACKING",73)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",73)	SIEMENS SYNGO SOP CLASS PACKING	49	115	f	\N	CS	1	Stream Chunk is a Payload	\N
8888	(0031,"SIEMENS SYNGO SOP CLASS PACKING",80)	(0031,"SIEMENS SYNGO SOP CLASS PACKING",80)	SIEMENS SYNGO SOP CLASS PACKING	49	128	f	\N	OB	1	Stream Chunk	\N
8889	(0031,"SIEMENS SYNGO WORKFLOW",10)	(0031,"SIEMENS SYNGO WORKFLOW",10)	SIEMENS SYNGO WORKFLOW	49	16	f	\N	UI	1	Internal Patient UID	\N
8890	(0031,"SIEMENS SYNGO WORKFLOW",11)	(0031,"SIEMENS SYNGO WORKFLOW",11)	SIEMENS SYNGO WORKFLOW	49	17	f	\N	SH	1	Patients Death Indicator	\N
8891	(0031,"SIEMENS SYNGO WORKFLOW",12)	(0031,"SIEMENS SYNGO WORKFLOW",12)	SIEMENS SYNGO WORKFLOW	49	18	f	\N	DA	1	Patients Death Date	\N
8892	(0031,"SIEMENS SYNGO WORKFLOW",13)	(0031,"SIEMENS SYNGO WORKFLOW",13)	SIEMENS SYNGO WORKFLOW	49	19	f	\N	TM	1	Patients Death Time	\N
8893	(0031,"SIEMENS SYNGO WORKFLOW",14)	(0031,"SIEMENS SYNGO WORKFLOW",14)	SIEMENS SYNGO WORKFLOW	49	20	f	\N	SH	1	VIP Indicator	\N
8894	(0031,"SIEMENS SYNGO WORKFLOW",15)	(0031,"SIEMENS SYNGO WORKFLOW",15)	SIEMENS SYNGO WORKFLOW	49	21	f	\N	US	1	Emergency Flag	\N
8895	(0031,"SIEMENS SYNGO WORKFLOW",20)	(0031,"SIEMENS SYNGO WORKFLOW",20)	SIEMENS SYNGO WORKFLOW	49	32	f	\N	SH	1	Internal Visit UID	\N
8896	(0031,"SIEMENS SYNGO WORKFLOW",25)	(0031,"SIEMENS SYNGO WORKFLOW",25)	SIEMENS SYNGO WORKFLOW	49	37	f	\N	SH	1	Internal ISR UID	\N
8897	(0031,"SIEMENS SYNGO WORKFLOW",32)	(0031,"SIEMENS SYNGO WORKFLOW",32)	SIEMENS SYNGO WORKFLOW	49	50	f	\N	SH	1	Control State	\N
8898	(0031,"SIEMENS SYNGO WORKFLOW",34)	(0031,"SIEMENS SYNGO WORKFLOW",34)	SIEMENS SYNGO WORKFLOW	49	52	f	\N	US	1	Local Flag	\N
8899	(0031,"SIEMENS SYNGO WORKFLOW",36)	(0031,"SIEMENS SYNGO WORKFLOW",36)	SIEMENS SYNGO WORKFLOW	49	54	f	\N	UI	1-n	Referenced Studies	\N
8900	(0031,"SIEMENS SYNGO WORKFLOW",40)	(0031,"SIEMENS SYNGO WORKFLOW",40)	SIEMENS SYNGO WORKFLOW	49	64	f	\N	LO	1	Workflow ID	\N
8901	(0031,"SIEMENS SYNGO WORKFLOW",41)	(0031,"SIEMENS SYNGO WORKFLOW",41)	SIEMENS SYNGO WORKFLOW	49	65	f	\N	LO	1	Workflow Description	\N
8902	(0031,"SIEMENS SYNGO WORKFLOW",42)	(0031,"SIEMENS SYNGO WORKFLOW",42)	SIEMENS SYNGO WORKFLOW	49	66	f	\N	LO	1	Workflow Control State	\N
8903	(0031,"SIEMENS SYNGO WORKFLOW",43)	(0031,"SIEMENS SYNGO WORKFLOW",43)	SIEMENS SYNGO WORKFLOW	49	67	f	\N	US	1	Workflow Ad Hoc Flag	\N
8904	(0031,"SIEMENS SYNGO WORKFLOW",44)	(0031,"SIEMENS SYNGO WORKFLOW",44)	SIEMENS SYNGO WORKFLOW	49	68	f	\N	US	1	Hybrid Flag	\N
8905	(0031,"SIEMENS SYNGO WORKFLOW",50)	(0031,"SIEMENS SYNGO WORKFLOW",50)	SIEMENS SYNGO WORKFLOW	49	80	f	\N	LO	1	Workitem ID	\N
8906	(0031,"SIEMENS SYNGO WORKFLOW",51)	(0031,"SIEMENS SYNGO WORKFLOW",51)	SIEMENS SYNGO WORKFLOW	49	81	f	\N	LO	1	Workitem Name	\N
8907	(0031,"SIEMENS SYNGO WORKFLOW",52)	(0031,"SIEMENS SYNGO WORKFLOW",52)	SIEMENS SYNGO WORKFLOW	49	82	f	\N	LO	1	Workitem Type	\N
8908	(0031,"SIEMENS SYNGO WORKFLOW",53)	(0031,"SIEMENS SYNGO WORKFLOW",53)	SIEMENS SYNGO WORKFLOW	49	83	f	\N	LO	1-n	Workitem Roles	\N
8909	(0031,"SIEMENS SYNGO WORKFLOW",54)	(0031,"SIEMENS SYNGO WORKFLOW",54)	SIEMENS SYNGO WORKFLOW	49	84	f	\N	LO	1	Workitem Description	\N
8910	(0031,"SIEMENS SYNGO WORKFLOW",55)	(0031,"SIEMENS SYNGO WORKFLOW",55)	SIEMENS SYNGO WORKFLOW	49	85	f	\N	LO	1	Workitem Control State	\N
8911	(0031,"SIEMENS SYNGO WORKFLOW",56)	(0031,"SIEMENS SYNGO WORKFLOW",56)	SIEMENS SYNGO WORKFLOW	49	86	f	\N	LO	1	Claiming User	\N
8912	(0031,"SIEMENS SYNGO WORKFLOW",57)	(0031,"SIEMENS SYNGO WORKFLOW",57)	SIEMENS SYNGO WORKFLOW	49	87	f	\N	LO	1	Claiming Host	\N
8913	(0031,"SIEMENS SYNGO WORKFLOW",58)	(0031,"SIEMENS SYNGO WORKFLOW",58)	SIEMENS SYNGO WORKFLOW	49	88	f	\N	LO	1	Taskflow ID	\N
8914	(0031,"SIEMENS SYNGO WORKFLOW",59)	(0031,"SIEMENS SYNGO WORKFLOW",59)	SIEMENS SYNGO WORKFLOW	49	89	f	\N	LO	1	Taskflow Name	\N
8915	(0031,"SIEMENS SYNGO WORKFLOW",5a)	(0031,"SIEMENS SYNGO WORKFLOW",5a)	SIEMENS SYNGO WORKFLOW	49	90	f	\N	US	1	Failed Flag	\N
8916	(0031,"SIEMENS SYNGO WORKFLOW",5b)	(0031,"SIEMENS SYNGO WORKFLOW",5b)	SIEMENS SYNGO WORKFLOW	49	91	f	\N	DT	1	Scheduled Time	\N
8917	(0031,"SIEMENS SYNGO WORKFLOW",5c)	(0031,"SIEMENS SYNGO WORKFLOW",5c)	SIEMENS SYNGO WORKFLOW	49	92	f	\N	US	1	Workitem Ad Hoc Flag	\N
8918	(0031,"SIEMENS SYNGO WORKFLOW",5d)	(0031,"SIEMENS SYNGO WORKFLOW",5d)	SIEMENS SYNGO WORKFLOW	49	93	f	\N	US	1	Patient Update Pending Flag	\N
8919	(0031,"SIEMENS SYNGO WORKFLOW",5e)	(0031,"SIEMENS SYNGO WORKFLOW",5e)	SIEMENS SYNGO WORKFLOW	49	94	f	\N	US	1	Patient Mixup Flag	\N
8920	(0031,"SIEMENS SYNGO WORKFLOW",60)	(0031,"SIEMENS SYNGO WORKFLOW",60)	SIEMENS SYNGO WORKFLOW	49	96	f	\N	LO	1	Client ID	\N
8921	(0031,"SIEMENS SYNGO WORKFLOW",61)	(0031,"SIEMENS SYNGO WORKFLOW",61)	SIEMENS SYNGO WORKFLOW	49	97	f	\N	LO	1	Template ID	\N
8922	(0031,"SIEMENS SYNGO WORKFLOW",81)	(0031,"SIEMENS SYNGO WORKFLOW",81)	SIEMENS SYNGO WORKFLOW	49	129	f	\N	LO	1	Institution Name	\N
8923	(0031,"SIEMENS SYNGO WORKFLOW",82)	(0031,"SIEMENS SYNGO WORKFLOW",82)	SIEMENS SYNGO WORKFLOW	49	130	f	\N	ST	1	Institution Address	\N
8924	(0031,"SIEMENS SYNGO WORKFLOW",83)	(0031,"SIEMENS SYNGO WORKFLOW",83)	SIEMENS SYNGO WORKFLOW	49	131	f	\N	SQ	1	Institution Code Sequence	\N
10989	(0119,"MRSC",1222)	(0119,"MRSC",22)	MRSC	281	34	t	12	DS	1-n	UnSharpMasking	K
8926	(0033,"SIEMENS MED NM",01)	(0033,"SIEMENS MED NM",01)	SIEMENS MED NM	51	1	f	\N	FL	1-n	Flood Correction Matrix Detector 2	K
8927	(0033,"SIEMENS MED NM",10)	(0033,"SIEMENS MED NM",10)	SIEMENS MED NM	51	16	f	\N	FL	1-n	COR Data for Detector 1	K
8928	(0033,"SIEMENS MED NM",11)	(0033,"SIEMENS MED NM",11)	SIEMENS MED NM	51	17	f	\N	FL	1-n	COR Data for Detector 2	K
8929	(0033,"SIEMENS MED NM",14)	(0033,"SIEMENS MED NM",14)	SIEMENS MED NM	51	20	f	\N	FL	1	MHR ( Y-Shift) data for detector 1	K
8930	(0033,"SIEMENS MED NM",15)	(0033,"SIEMENS MED NM",15)	SIEMENS MED NM	51	21	f	\N	FL	1	MHR ( Y-Shift) data for detector 2	K
8931	(0033,"SIEMENS MED NM",18)	(0033,"SIEMENS MED NM",18)	SIEMENS MED NM	51	24	f	\N	FL	1-n	NCO Data for detector 1	K
10990	(0119,"MRSC",1223)	(0119,"MRSC",23)	MRSC	281	35	t	12	IS	1-n	LocalThresholdKernel	K
8958	(0037,"SIEMENS MED NM",00)	(0037,"SIEMENS MED NM",00)	SIEMENS MED NM	55	0	f	\N	OW	1	Flood correction matrix Detector 1	\N
8959	(0037,"SIEMENS MED NM",80)	(0037,"SIEMENS MED NM",80)	SIEMENS MED NM	55	128	f	\N	OW	1	Flood correction matrix Detector 2	\N
8962	(0041,"SIEMENS MED SP DXMG WH AWS 1",02)	(0041,"SIEMENS MED SP DXMG WH AWS 1",02)	SIEMENS MED SP DXMG WH AWS 1	65	2	f	\N	SH	1	Reason for the Requested Procedure	\N
8976	(0041,"SIEMENS MED NM",30)	(0041,"SIEMENS MED NM",30)	SIEMENS MED NM	65	48	f	\N	ST	1	Unknown	\N
8977	(0041,"SIEMENS MED NM",32)	(0041,"SIEMENS MED NM",32)	SIEMENS MED NM	65	50	f	\N	ST	1	Unknown	\N
8978	(0041,"SIEMENS MI RWVM SUV",01)	(0041,"SIEMENS MI RWVM SUV",01)	SIEMENS MI RWVM SUV	65	1	f	\N	CS	1	SUV Decay Correction Method	\N
8984	(0051,"SIEMENS MED SP DXMG WH AWS 1",10)	(0051,"SIEMENS MED SP DXMG WH AWS 1",10)	SIEMENS MED SP DXMG WH AWS 1	81	16	f	\N	DS	1	Unknown	\N
8985	(0051,"SIEMENS MED SP DXMG WH AWS 1",37)	(0051,"SIEMENS MED SP DXMG WH AWS 1",37)	SIEMENS MED SP DXMG WH AWS 1	81	55	f	\N	DS	6	Unknown	\N
8986	(0051,"SIEMENS MED SP DXMG WH AWS 1",50)	(0051,"SIEMENS MED SP DXMG WH AWS 1",50)	SIEMENS MED SP DXMG WH AWS 1	81	80	f	\N	UI	1	Unknown	\N
8936	(0033,"SIEMENS MED NM",22)	(0033,"SIEMENS MED NM",22)	SIEMENS MED NM	51	34	f	\N	SS	1-n	Bed U/D correction data	K
8937	(0033,"SIEMENS MED NM",23)	(0033,"SIEMENS MED NM",23)	SIEMENS MED NM	51	35	f	\N	SS	1-n	Gantry L/R Correction Data	K
8938	(0033,"SIEMENS MED NM",24)	(0033,"SIEMENS MED NM",24)	SIEMENS MED NM	51	36	f	\N	FL	1	BackProjection Correction angle head 1	K
8939	(0033,"SIEMENS MED NM",25)	(0033,"SIEMENS MED NM",25)	SIEMENS MED NM	51	37	f	\N	FL	1	BackProjection Correction angle head 2	K
8940	(0033,"SIEMENS MED NM",28)	(0033,"SIEMENS MED NM",28)	SIEMENS MED NM	51	40	f	\N	SL	1	MHR calibrations	K
8941	(0033,"SIEMENS MED NM",29)	(0033,"SIEMENS MED NM",29)	SIEMENS MED NM	51	41	f	\N	FL	1-n	Crystal thickness	K
8942	(0033,"SIEMENS MED NM",30)	(0033,"SIEMENS MED NM",30)	SIEMENS MED NM	51	48	f	\N	LO	1	Preset name used for acquisition	K
8943	(0033,"SIEMENS MED NM",31)	(0033,"SIEMENS MED NM",31)	SIEMENS MED NM	51	49	f	\N	FL	1	Camera Config Angle	K
8944	(0033,"SIEMENS MED NM",32)	(0033,"SIEMENS MED NM",32)	SIEMENS MED NM	51	50	f	\N	LO	1	Crystal Type	K
8945	(0033,"SIEMENS MED NM",33)	(0033,"SIEMENS MED NM",33)	SIEMENS MED NM	51	51	f	\N	SL	1	Coin Gantry Step	K
8946	(0033,"SIEMENS MED NM",34)	(0033,"SIEMENS MED NM",34)	SIEMENS MED NM	51	52	f	\N	FL	1	Wholebody bed step	K
8948	(0033,"SIEMENS MED NM",36)	(0033,"SIEMENS MED NM",36)	SIEMENS MED NM	51	54	f	\N	FL	1	Coincidence weight factor table	K
8949	(0033,"SIEMENS MED NM",37)	(0033,"SIEMENS MED NM",37)	SIEMENS MED NM	51	55	f	\N	SL	1	Starburst flags at image acq time	K
8950	(0033,"SIEMENS MED NM",38)	(0033,"SIEMENS MED NM",38)	SIEMENS MED NM	51	56	f	\N	FL	1	Pixel Scale factor	K
8951	(0035,"SIEMENS MED NM",00)	(0035,"SIEMENS MED NM",00)	SIEMENS MED NM	53	0	f	\N	LO	1	Specialized Tomo Type	K
8952	(0035,"SIEMENS MED NM",01)	(0035,"SIEMENS MED NM",01)	SIEMENS MED NM	53	1	f	\N	LO	1	Energy Window Type	K
8953	(0035,"SIEMENS MED NM",02)	(0035,"SIEMENS MED NM",02)	SIEMENS MED NM	53	2	f	\N	SS	1	Start and End Row Illuminated By Wind Position	K
8954	(0035,"SIEMENS MED NM",03)	(0035,"SIEMENS MED NM",03)	SIEMENS MED NM	53	3	f	\N	LO	1	Blank Scan Image For Profile	K
8955	(0035,"SIEMENS MED NM",04)	(0035,"SIEMENS MED NM",04)	SIEMENS MED NM	53	4	f	\N	SS	1	Repeat Number of the Original Dynamic SPECT	K
8956	(0035,"SIEMENS MED NM",05)	(0035,"SIEMENS MED NM",05)	SIEMENS MED NM	53	5	f	\N	SS	1	Phase Number of the Original Dynamic SPECT	K
8957	(0035,"SIEMENS MED NM",06)	(0035,"SIEMENS MED NM",06)	SIEMENS MED NM	53	6	f	\N	LO	1	Siemens Profile 2 Image Subtype	K
8960	(0039,"SIEMENS MED NM",00)	(0039,"SIEMENS MED NM",00)	SIEMENS MED NM	57	0	f	\N	LT	1	Toshiba CBF Activity Results	K
8961	(0039,"SIEMENS MED NM",01)	(0039,"SIEMENS MED NM",01)	SIEMENS MED NM	57	1	f	\N	LT	1	Related CT Series Instance UID	R
8963	(0041,"SIEMENS MED NM",01)	(0041,"SIEMENS MED NM",01)	SIEMENS MED NM	65	1	f	\N	SL	1	Whole Body Tomo Position Index	K
8964	(0041,"SIEMENS MED NM",02)	(0041,"SIEMENS MED NM",02)	SIEMENS MED NM	65	2	f	\N	SL	1	Whole Body Tomo Number of Positions	K
8965	(0041,"SIEMENS MED NM",03)	(0041,"SIEMENS MED NM",03)	SIEMENS MED NM	65	3	f	\N	FL	1	Horizontal Table Position of CT scan	K
8966	(0041,"SIEMENS MED NM",04)	(0041,"SIEMENS MED NM",04)	SIEMENS MED NM	65	4	f	\N	FL	1	Effective Energy fo CT Scan	K
8967	(0041,"SIEMENS MED NM",05)	(0041,"SIEMENS MED NM",05)	SIEMENS MED NM	65	5	f	\N	FD	1-n	Long Linear Drive Information for Detector 1	K
8968	(0041,"SIEMENS MED NM",06)	(0041,"SIEMENS MED NM",06)	SIEMENS MED NM	65	6	f	\N	FD	1-n	Long Linear Drive Information for Detector 2	K
8969	(0041,"SIEMENS MED NM",07)	(0041,"SIEMENS MED NM",07)	SIEMENS MED NM	65	7	f	\N	FD	1-n	Trunnion Information for Detector 1	K
8970	(0041,"SIEMENS MED NM",08)	(0041,"SIEMENS MED NM",08)	SIEMENS MED NM	65	8	f	\N	FD	1-n	Trunnion Information for Detector 2	K
8971	(0041,"SIEMENS MED NM",09)	(0041,"SIEMENS MED NM",09)	SIEMENS MED NM	65	9	f	\N	FL	1	Broad Beam Factor	K
8972	(0041,"SIEMENS MED NM",0a)	(0041,"SIEMENS MED NM",0a)	SIEMENS MED NM	65	10	f	\N	FD	1	Original Wholebody Position	K
8973	(0041,"SIEMENS MED NM",0b)	(0041,"SIEMENS MED NM",0b)	SIEMENS MED NM	65	11	f	\N	FD	1	Wholebody Scan Range	K
8974	(0041,"SIEMENS MED NM",10)	(0041,"SIEMENS MED NM",10)	SIEMENS MED NM	65	16	f	\N	FL	1-3	Effective Emission Energy	K
8975	(0041,"SIEMENS MED NM",11)	(0041,"SIEMENS MED NM",11)	SIEMENS MED NM	65	17	f	\N	FL	1-n	Gated Frame Duration	K
8979	(0043,"SIEMENS MED NM",01)	(0043,"SIEMENS MED NM",01)	SIEMENS MED NM	67	1	f	\N	FL	1-n	Detector View Angle	K
8980	(0043,"SIEMENS MED NM",02)	(0043,"SIEMENS MED NM",02)	SIEMENS MED NM	67	2	f	\N	FD	1-16	Transformation Matrix	K
8982	(0043,"SIEMENS MED NM",04)	(0043,"SIEMENS MED NM",04)	SIEMENS MED NM	67	4	f	\N	FL	1-n	View Dependent Y Shift MHR For Detector 2	K
8983	(0045,"SIEMENS MED NM",01)	(0045,"SIEMENS MED NM",01)	SIEMENS MED NM	69	1	f	\N	LO	1-n	Planar Processing String	K
8987	(0051,"SIEMENS MED SP DXMG WH AWS 1",60)	(0051,"SIEMENS MED SP DXMG WH AWS 1",60)	SIEMENS MED SP DXMG WH AWS 1	81	96	f	\N	DS	1	Primary Positioner Scan Arc	\N
8988	(0051,"SIEMENS MED SP DXMG WH AWS 1",61)	(0051,"SIEMENS MED SP DXMG WH AWS 1",61)	SIEMENS MED SP DXMG WH AWS 1	81	97	f	\N	DS	1	Secondary Positioner Scan Arc	\N
8989	(0051,"SIEMENS MED SP DXMG WH AWS 1",62)	(0051,"SIEMENS MED SP DXMG WH AWS 1",62)	SIEMENS MED SP DXMG WH AWS 1	81	98	f	\N	DS	1	Primary Positioner Scan Start Angle	\N
8990	(0051,"SIEMENS MED SP DXMG WH AWS 1",63)	(0051,"SIEMENS MED SP DXMG WH AWS 1",63)	SIEMENS MED SP DXMG WH AWS 1	81	99	f	\N	DS	1	Secondary Positioner Scan Start Angle	\N
8991	(0051,"SIEMENS MED SP DXMG WH AWS 1",64)	(0051,"SIEMENS MED SP DXMG WH AWS 1",64)	SIEMENS MED SP DXMG WH AWS 1	81	100	f	\N	DS	1	Primary Positioner Increment	\N
8992	(0051,"SIEMENS MED SP DXMG WH AWS 1",65)	(0051,"SIEMENS MED SP DXMG WH AWS 1",65)	SIEMENS MED SP DXMG WH AWS 1	81	101	f	\N	DS	1	Secondary Positioner Increment	\N
8995	(0055,"SIEMENS MED NM",20)	(0055,"SIEMENS MED NM",20)	SIEMENS MED NM	85	32	f	\N	SS	1	Unknown	\N
8996	(0055,"SIEMENS MED NM",22)	(0055,"SIEMENS MED NM",22)	SIEMENS MED NM	85	34	f	\N	SS	1	Unknown	\N
8997	(0055,"SIEMENS MED NM",24)	(0055,"SIEMENS MED NM",24)	SIEMENS MED NM	85	36	f	\N	SS	1	Unknown	\N
8998	(0055,"SIEMENS MED NM",30)	(0055,"SIEMENS MED NM",30)	SIEMENS MED NM	85	48	f	\N	SS	1	Unknown	\N
8999	(0055,"SIEMENS MED NM",32)	(0055,"SIEMENS MED NM",32)	SIEMENS MED NM	85	50	f	\N	SS	1	Unknown	\N
9000	(0055,"SIEMENS MED NM",34)	(0055,"SIEMENS MED NM",34)	SIEMENS MED NM	85	52	f	\N	SS	1	Unknown	\N
9001	(0055,"SIEMENS MED NM",40)	(0055,"SIEMENS MED NM",40)	SIEMENS MED NM	85	64	f	\N	SS	1	Unknown	\N
9002	(0055,"SIEMENS MED NM",42)	(0055,"SIEMENS MED NM",42)	SIEMENS MED NM	85	66	f	\N	SS	1	Unknown	\N
9003	(0055,"SIEMENS MED NM",44)	(0055,"SIEMENS MED NM",44)	SIEMENS MED NM	85	68	f	\N	SS	1	Unknown	\N
9004	(0055,"SIEMENS MED NM",4c)	(0055,"SIEMENS MED NM",4c)	SIEMENS MED NM	85	76	f	\N	SL	1	Unknown	\N
9005	(0055,"SIEMENS MED NM",4d)	(0055,"SIEMENS MED NM",4d)	SIEMENS MED NM	85	77	f	\N	SL	1	Unknown	\N
9006	(0055,"SIEMENS MED NM",51)	(0055,"SIEMENS MED NM",51)	SIEMENS MED NM	85	81	f	\N	SS	1	Unknown	\N
9007	(0055,"SIEMENS MED NM",52)	(0055,"SIEMENS MED NM",52)	SIEMENS MED NM	85	82	f	\N	SS	1	Unknown	\N
9008	(0055,"SIEMENS MED NM",53)	(0055,"SIEMENS MED NM",53)	SIEMENS MED NM	85	83	f	\N	ST	1	Unknown	\N
9009	(0055,"SIEMENS MED NM",55)	(0055,"SIEMENS MED NM",55)	SIEMENS MED NM	85	85	f	\N	SL	1	Unknown	\N
9010	(0055,"SIEMENS MED NM",5c)	(0055,"SIEMENS MED NM",5c)	SIEMENS MED NM	85	92	f	\N	ST	1	Unknown	\N
9011	(0055,"SIEMENS MED NM",6d)	(0055,"SIEMENS MED NM",6d)	SIEMENS MED NM	85	109	f	\N	SS	1	Unknown	\N
9014	(0055,"SIEMENS MED NM",a8)	(0055,"SIEMENS MED NM",a8)	SIEMENS MED NM	85	168	f	\N	SS	1	Unknown	\N
9016	(0055,"SIEMENS MED NM",c2)	(0055,"SIEMENS MED NM",c2)	SIEMENS MED NM	85	194	f	\N	SS	1	Unknown	\N
9017	(0055,"SIEMENS MED NM",c3)	(0055,"SIEMENS MED NM",c3)	SIEMENS MED NM	85	195	f	\N	SS	1	Unknown	\N
9018	(0055,"SIEMENS MED NM",c4)	(0055,"SIEMENS MED NM",c4)	SIEMENS MED NM	85	196	f	\N	SS	1	Unknown	\N
9019	(0055,"SIEMENS MED NM",d0)	(0055,"SIEMENS MED NM",d0)	SIEMENS MED NM	85	208	f	\N	SS	1	Unknown	\N
9020	(0055,"SIEMENS MED SP DXMG WH AWS 1",01)	(0055,"SIEMENS MED SP DXMG WH AWS 1",01)	SIEMENS MED SP DXMG WH AWS 1	85	1	f	\N	LO	1	Projection View Display String	\N
8994	(0055,"SIEMENS MED NM",05)	(0055,"SIEMENS MED NM",05)	SIEMENS MED NM	85	5	f	\N	SS	1	Random Window Width	K
9012	(0055,"SIEMENS MED NM",7e)	(0055,"SIEMENS MED NM",7e)	SIEMENS MED NM	85	126	f	\N	FL	2	Collimator Thickness mm	K
9013	(0055,"SIEMENS MED NM",7f)	(0055,"SIEMENS MED NM",7f)	SIEMENS MED NM	85	127	f	\N	FL	2	Collimator Angular Resolution radians	K
9015	(0055,"SIEMENS MED NM",c0)	(0055,"SIEMENS MED NM",c0)	SIEMENS MED NM	85	192	f	\N	SS	1-n	Useful Field of View	K
9022	(0057,"SIEMENS MED NM",02)	(0057,"SIEMENS MED NM",02)	SIEMENS MED NM	87	2	f	\N	FL	1	Dose Calibration Factor	K
9023	(0057,"SIEMENS MED NM",03)	(0057,"SIEMENS MED NM",03)	SIEMENS MED NM	87	3	f	\N	LO	1	Units	K
9024	(0057,"SIEMENS MED NM",04)	(0057,"SIEMENS MED NM",04)	SIEMENS MED NM	87	4	f	\N	LO	1	Decay Correction	K
9025	(0057,"SIEMENS MED NM",05)	(0057,"SIEMENS MED NM",05)	SIEMENS MED NM	87	5	f	\N	SL	1-n	Radionuclide Half Life	K
9026	(0057,"SIEMENS MED NM",06)	(0057,"SIEMENS MED NM",06)	SIEMENS MED NM	87	6	f	\N	FL	1	Rescale Intercept	K
9027	(0057,"SIEMENS MED NM",07)	(0057,"SIEMENS MED NM",07)	SIEMENS MED NM	87	7	f	\N	FL	1	Rescale Slope	K
9028	(0057,"SIEMENS MED NM",08)	(0057,"SIEMENS MED NM",08)	SIEMENS MED NM	87	8	f	\N	FL	1	Frame Reference Time	K
9029	(0057,"SIEMENS MED NM",09)	(0057,"SIEMENS MED NM",09)	SIEMENS MED NM	87	9	f	\N	SL	1	Number of Radiopharmaceutical Information Sequence	K
9030	(0057,"SIEMENS MED NM",0a)	(0057,"SIEMENS MED NM",0a)	SIEMENS MED NM	87	10	f	\N	FL	1	Decay Factor	K
9031	(0057,"SIEMENS MED NM",0b)	(0057,"SIEMENS MED NM",0b)	SIEMENS MED NM	87	11	f	\N	LO	1	Counts Source	K
9032	(0057,"SIEMENS MED NM",0c)	(0057,"SIEMENS MED NM",0c)	SIEMENS MED NM	87	12	f	\N	SL	1-n	Radionuclide Positron Fraction	K
9033	(0057,"SIEMENS MED NM",0e)	(0057,"SIEMENS MED NM",0e)	SIEMENS MED NM	87	14	f	\N	US	1-n	Trigger Time of CT Slice	K
9034	(0061,"SIEMENS MED NM",01)	(0061,"SIEMENS MED NM",01)	SIEMENS MED NM	97	1	f	\N	FL	1-n	X Principal Ray Offset	K
9035	(0061,"SIEMENS MED NM",05)	(0061,"SIEMENS MED NM",05)	SIEMENS MED NM	97	5	f	\N	FL	1-n	Y Principal Ray Offset	K
9036	(0061,"SIEMENS MED NM",09)	(0061,"SIEMENS MED NM",09)	SIEMENS MED NM	97	9	f	\N	FL	1-n	X Principal Ray Angle	K
9037	(0061,"SIEMENS MED NM",0a)	(0061,"SIEMENS MED NM",0a)	SIEMENS MED NM	97	10	f	\N	FL	1-n	Y Principal Ray Angle	K
9038	(0061,"SIEMENS MED NM",0b)	(0061,"SIEMENS MED NM",0b)	SIEMENS MED NM	97	11	f	\N	FL	1-n	X Short Focal Length	K
9039	(0061,"SIEMENS MED NM",0c)	(0061,"SIEMENS MED NM",0c)	SIEMENS MED NM	97	12	f	\N	FL	1-n	Y Short Focal Length	K
9040	(0061,"SIEMENS MED NM",0d)	(0061,"SIEMENS MED NM",0d)	SIEMENS MED NM	97	13	f	\N	FL	1-n	X Long Focal Length	K
9041	(0061,"SIEMENS MED NM",0e)	(0061,"SIEMENS MED NM",0e)	SIEMENS MED NM	97	14	f	\N	FL	1-n	Y Long Focal Length	K
10991	(0119,"MRSC",1224)	(0119,"MRSC",24)	MRSC	281	36	t	12	IS	1-n	AbsoluteLimits	K
9081	(0071,"SIEMENS WH SR 1.0",01)	(0071,"SIEMENS WH SR 1.0",01)	SIEMENS WH SR 1.0	113	1	f	\N	LO	1	Unknown	\N
9082	(0071,"SIEMENS WH SR 1.0",02)	(0071,"SIEMENS WH SR 1.0",02)	SIEMENS WH SR 1.0	113	2	f	\N	LO	1	Unknown	\N
9085	(0071,"SIEMENS MED PT",23)	(0071,"SIEMENS MED PT",23)	SIEMENS MED PT	113	35	f	\N	US	1	Volume Index	\N
9086	(0071,"SIEMENS MED PT",24)	(0071,"SIEMENS MED PT",24)	SIEMENS MED PT	113	36	f	\N	IS	1	Time Slice Duration	\N
9092	(0071,"SIEMENS SYNGO REGISTRATION",20)	(0071,"SIEMENS SYNGO REGISTRATION",20)	SIEMENS SYNGO REGISTRATION	113	32	f	\N	SQ	1	Registered Image Sequence	\N
9093	(0071,"SIEMENS SYNGO REGISTRATION",21)	(0071,"SIEMENS SYNGO REGISTRATION",21)	SIEMENS SYNGO REGISTRATION	113	33	f	\N	CS	1	Registration Is Validated Flag	\N
9094	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",00)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",00)	SIEMENS SYNGO OBJECT GRAPHICS	113	0	f	\N	SQ	1	Graphic Object Sequence	\N
9043	(0061,"SIEMENS MED NM",10)	(0061,"SIEMENS MED NM",10)	SIEMENS MED NM	97	16	f	\N	FL	1-n	Y Focal Scaling	K
9044	(0061,"SIEMENS MED NM",11)	(0061,"SIEMENS MED NM",11)	SIEMENS MED NM	97	17	f	\N	FL	1-n	X Motion Correction Shift	K
9045	(0061,"SIEMENS MED NM",15)	(0061,"SIEMENS MED NM",15)	SIEMENS MED NM	97	21	f	\N	FL	1-n	Y Motion Correction Shift	K
9046	(0061,"SIEMENS MED NM",19)	(0061,"SIEMENS MED NM",19)	SIEMENS MED NM	97	25	f	\N	FL	1	X Heart Center	K
9047	(0061,"SIEMENS MED NM",1a)	(0061,"SIEMENS MED NM",1a)	SIEMENS MED NM	97	26	f	\N	FL	1	Y Heart Center	K
9048	(0061,"SIEMENS MED NM",1b)	(0061,"SIEMENS MED NM",1b)	SIEMENS MED NM	97	27	f	\N	FL	1	Z Heart Center	K
9049	(0061,"SIEMENS MED NM",1c)	(0061,"SIEMENS MED NM",1c)	SIEMENS MED NM	97	28	f	\N	LO	1	Image Pixel Content Type	K
9050	(0061,"SIEMENS MED NM",1d)	(0061,"SIEMENS MED NM",1d)	SIEMENS MED NM	97	29	f	\N	SS	1	Auto Save Corrected Series	K
9051	(0061,"SIEMENS MED NM",1e)	(0061,"SIEMENS MED NM",1e)	SIEMENS MED NM	97	30	f	\N	LT	1	Distorted Series Instance UID	R
9052	(0061,"SIEMENS MED NM",21)	(0061,"SIEMENS MED NM",21)	SIEMENS MED NM	97	33	f	\N	SS	1-n	Recon Range	K
9053	(0061,"SIEMENS MED NM",22)	(0061,"SIEMENS MED NM",22)	SIEMENS MED NM	97	34	f	\N	LO	1	Recon Orientation	K
9055	(0061,"SIEMENS MED NM",24)	(0061,"SIEMENS MED NM",24)	SIEMENS MED NM	97	36	f	\N	FL	1	Recon Transverse Angle	K
9056	(0061,"SIEMENS MED NM",25)	(0061,"SIEMENS MED NM",25)	SIEMENS MED NM	97	37	f	\N	FL	1	Recon Sagittal Angle	K
9057	(0061,"SIEMENS MED NM",26)	(0061,"SIEMENS MED NM",26)	SIEMENS MED NM	97	38	f	\N	FL	1	Recon X Mask Size	K
9058	(0061,"SIEMENS MED NM",27)	(0061,"SIEMENS MED NM",27)	SIEMENS MED NM	97	39	f	\N	FL	1	Recon Y Mask Size	K
9059	(0061,"SIEMENS MED NM",28)	(0061,"SIEMENS MED NM",28)	SIEMENS MED NM	97	40	f	\N	FL	1	Recon X Image Center	K
9060	(0061,"SIEMENS MED NM",29)	(0061,"SIEMENS MED NM",29)	SIEMENS MED NM	97	41	f	\N	FL	1	Recon Y Image Center	K
9061	(0061,"SIEMENS MED NM",2a)	(0061,"SIEMENS MED NM",2a)	SIEMENS MED NM	97	42	f	\N	FL	1	Recon Z Image Center	K
9062	(0061,"SIEMENS MED NM",2b)	(0061,"SIEMENS MED NM",2b)	SIEMENS MED NM	97	43	f	\N	FL	1	Recon X Zoom	K
9063	(0061,"SIEMENS MED NM",2c)	(0061,"SIEMENS MED NM",2c)	SIEMENS MED NM	97	44	f	\N	FL	1	Recon Y Zoom	K
9064	(0061,"SIEMENS MED NM",2d)	(0061,"SIEMENS MED NM",2d)	SIEMENS MED NM	97	45	f	\N	FL	1	Recon Threshold	K
9065	(0061,"SIEMENS MED NM",2e)	(0061,"SIEMENS MED NM",2e)	SIEMENS MED NM	97	46	f	\N	FL	1	Recon Output Pixel Size	K
9066	(0061,"SIEMENS MED NM",2f)	(0061,"SIEMENS MED NM",2f)	SIEMENS MED NM	97	47	f	\N	LO	1-n	Scatter Estimation Method	K
9067	(0061,"SIEMENS MED NM",30)	(0061,"SIEMENS MED NM",30)	SIEMENS MED NM	97	48	f	\N	LO	1-n	Scatter Estimation Method Mode	K
9068	(0061,"SIEMENS MED NM",31)	(0061,"SIEMENS MED NM",31)	SIEMENS MED NM	97	49	f	\N	FL	1-n	Scatter Estimation Lower Window Weights	K
9069	(0061,"SIEMENS MED NM",32)	(0061,"SIEMENS MED NM",32)	SIEMENS MED NM	97	50	f	\N	FL	1-n	Scatter Estimation Upper Window Weights	K
9070	(0061,"SIEMENS MED NM",33)	(0061,"SIEMENS MED NM",33)	SIEMENS MED NM	97	51	f	\N	LO	1-n	Scatter Estimation Window Mode	K
9071	(0061,"SIEMENS MED NM",34)	(0061,"SIEMENS MED NM",34)	SIEMENS MED NM	97	52	f	\N	LO	1-n	Scatter Estimation Filter	K
9072	(0061,"SIEMENS MED NM",35)	(0061,"SIEMENS MED NM",35)	SIEMENS MED NM	97	53	f	\N	LO	1	Recon RawTomo Input UID	R
9073	(0061,"SIEMENS MED NM",36)	(0061,"SIEMENS MED NM",36)	SIEMENS MED NM	97	54	f	\N	LO	1	Recon CT Input UID	R
9074	(0061,"SIEMENS MED NM",37)	(0061,"SIEMENS MED NM",37)	SIEMENS MED NM	97	55	f	\N	FL	1	Recon Z Mask Size	K
9075	(0061,"SIEMENS MED NM",38)	(0061,"SIEMENS MED NM",38)	SIEMENS MED NM	97	56	f	\N	FL	1	Recon X Mask Center	K
9076	(0061,"SIEMENS MED NM",39)	(0061,"SIEMENS MED NM",39)	SIEMENS MED NM	97	57	f	\N	FL	1	Recon Y Mask Center	K
9077	(0061,"SIEMENS MED NM",3a)	(0061,"SIEMENS MED NM",3a)	SIEMENS MED NM	97	58	f	\N	FL	1	Recon Z Mask Center	K
9078	(0061,"SIEMENS MED NM",51)	(0061,"SIEMENS MED NM",51)	SIEMENS MED NM	97	81	f	\N	LT	1	Raw Tomo Series UID	R
9080	(0061,"SIEMENS MED NM",53)	(0061,"SIEMENS MED NM",53)	SIEMENS MED NM	97	83	f	\N	LT	1	HighRes CT Series UID	R
9087	(0071,"SIEMENS MED PT WAVEFORM",46)	(0071,"SIEMENS MED PT WAVEFORM",46)	SIEMENS MED PT WAVEFORM	113	70	f	\N	UN	1	Starting Respiratory Amplitude	K
9088	(0071,"SIEMENS MED PT WAVEFORM",47)	(0071,"SIEMENS MED PT WAVEFORM",47)	SIEMENS MED PT WAVEFORM	113	71	f	\N	UN	1	Starting Respiratory Phase	K
9089	(0071,"SIEMENS MED PT WAVEFORM",48)	(0071,"SIEMENS MED PT WAVEFORM",48)	SIEMENS MED PT WAVEFORM	113	72	f	\N	UN	1	Ending Respiratory Amplitude	K
9090	(0071,"SIEMENS MED PT WAVEFORM",49)	(0071,"SIEMENS MED PT WAVEFORM",49)	SIEMENS MED PT WAVEFORM	113	73	f	\N	UN	1	Ending Respiratory Phase	K
9091	(0071,"SIEMENS MED PT WAVEFORM",50)	(0071,"SIEMENS MED PT WAVEFORM",50)	SIEMENS MED PT WAVEFORM	113	80	f	\N	CS	1	Respiratory Trigger Type	K
9083	(0071,"SIEMENS MED PT",21)	(0071,"SIEMENS MED PT",21)	SIEMENS MED PT	113	33	f	\N	UI	1	Registration Matrix UID	K
9084	(0071,"SIEMENS MED PT",22)	(0071,"SIEMENS MED PT",22)	SIEMENS MED PT	113	34	f	\N	DT	1	Decay Correction DateTime	R
9095	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",01)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",01)	SIEMENS SYNGO OBJECT GRAPHICS	113	1	f	\N	SL	1	Fill Style Version	\N
9096	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",02)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",02)	SIEMENS SYNGO OBJECT GRAPHICS	113	2	f	\N	FL	4	Fill Background Color	\N
9097	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",03)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",03)	SIEMENS SYNGO OBJECT GRAPHICS	113	3	f	\N	FL	4	Fill Foreground Color	\N
9098	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",04)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",04)	SIEMENS SYNGO OBJECT GRAPHICS	113	4	f	\N	SL	1	Fill Mode	\N
9099	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",05)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",05)	SIEMENS SYNGO OBJECT GRAPHICS	113	5	f	\N	OB	1	Fill Pattern	\N
9100	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",06)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",06)	SIEMENS SYNGO OBJECT GRAPHICS	113	6	f	\N	SL	1	Line Style Version	\N
9101	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",07)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",07)	SIEMENS SYNGO OBJECT GRAPHICS	113	7	f	\N	FL	4	Line Background Color	\N
9102	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",08)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",08)	SIEMENS SYNGO OBJECT GRAPHICS	113	8	f	\N	FL	4	Line Foreground Color	\N
9103	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",09)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",09)	SIEMENS SYNGO OBJECT GRAPHICS	113	9	f	\N	DS	1	Line Type	\N
9104	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",10)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",10)	SIEMENS SYNGO OBJECT GRAPHICS	113	16	f	\N	DS	1	Line Thickness	\N
9105	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",11)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",11)	SIEMENS SYNGO OBJECT GRAPHICS	113	17	f	\N	DS	1	Line Shadow X Offset	\N
9106	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",12)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",12)	SIEMENS SYNGO OBJECT GRAPHICS	113	18	f	\N	DS	1	Line Shadow Y Offset	\N
9107	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",13)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",13)	SIEMENS SYNGO OBJECT GRAPHICS	113	19	f	\N	DS	1	Shadow Style	\N
9108	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",14)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",14)	SIEMENS SYNGO OBJECT GRAPHICS	113	20	f	\N	FL	4	Shadow Color	\N
9109	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",15)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",15)	SIEMENS SYNGO OBJECT GRAPHICS	113	21	f	\N	DS	1	Stipple Pattern	\N
9110	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",16)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",16)	SIEMENS SYNGO OBJECT GRAPHICS	113	22	f	\N	DS	1	Line Anti Aliasing	\N
9111	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",17)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",17)	SIEMENS SYNGO OBJECT GRAPHICS	113	23	f	\N	CS	1	Line-Z-Blend Flag	\N
9112	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",18)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",18)	SIEMENS SYNGO OBJECT GRAPHICS	113	24	f	\N	SL	1	Text Style Version	\N
9113	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",19)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",19)	SIEMENS SYNGO OBJECT GRAPHICS	113	25	f	\N	FL	4	Text Color	\N
9114	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",20)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",20)	SIEMENS SYNGO OBJECT GRAPHICS	113	32	f	\N	SL	1	Text Horizontal Align	\N
9115	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",21)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",21)	SIEMENS SYNGO OBJECT GRAPHICS	113	33	f	\N	SL	1	Text Vertical Align	\N
9116	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",22)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",22)	SIEMENS SYNGO OBJECT GRAPHICS	113	34	f	\N	DS	1	Text Shadow X Offset	\N
9117	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",23)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",23)	SIEMENS SYNGO OBJECT GRAPHICS	113	35	f	\N	DS	1	Text Shadow Y Offset	\N
9118	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",24)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",24)	SIEMENS SYNGO OBJECT GRAPHICS	113	36	f	\N	SL	1	Text Shadow Style	\N
9119	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",25)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",25)	SIEMENS SYNGO OBJECT GRAPHICS	113	37	f	\N	FL	4	Text Shadow Color	\N
9120	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",26)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",26)	SIEMENS SYNGO OBJECT GRAPHICS	113	38	f	\N	CS	1-n	Text Log Font	\N
9121	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",27)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",27)	SIEMENS SYNGO OBJECT GRAPHICS	113	39	f	\N	CS	1	Text-Z-Blend Flag	\N
9122	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",28)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",28)	SIEMENS SYNGO OBJECT GRAPHICS	113	40	f	\N	OB	1	Graphic Bit Mask	\N
9123	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",29)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",29)	SIEMENS SYNGO OBJECT GRAPHICS	113	41	f	\N	CS	1	Visiblility Flag	\N
9124	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",30)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",30)	SIEMENS SYNGO OBJECT GRAPHICS	113	48	f	\N	SL	1	Graphic Sensitivity	\N
9125	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",31)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",31)	SIEMENS SYNGO OBJECT GRAPHICS	113	49	f	\N	SL	1	Graphic Pick Mode Type	\N
9126	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",32)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",32)	SIEMENS SYNGO OBJECT GRAPHICS	113	50	f	\N	SL	1	Graphic Layer	\N
9127	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",33)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",33)	SIEMENS SYNGO OBJECT GRAPHICS	113	51	f	\N	SL	1	Graphic Object Version	\N
9128	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",34)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",34)	SIEMENS SYNGO OBJECT GRAPHICS	113	52	f	\N	SL	1	Graphic Coordinate System	\N
9129	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",35)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",35)	SIEMENS SYNGO OBJECT GRAPHICS	113	53	f	\N	CS	1	Graphic Custom Attributes	\N
9130	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",36)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",36)	SIEMENS SYNGO OBJECT GRAPHICS	113	54	f	\N	CS	1	Graphic Custom Attributes Key	\N
9131	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",37)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",37)	SIEMENS SYNGO OBJECT GRAPHICS	113	55	f	\N	CS	1	Graphic Custom Attributes Value	\N
9132	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",38)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",38)	SIEMENS SYNGO OBJECT GRAPHICS	113	56	f	\N	CS	1	Graphic View Name	\N
9133	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",39)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",39)	SIEMENS SYNGO OBJECT GRAPHICS	113	57	f	\N	DS	3	Graphic Data	\N
9134	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",40)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",40)	SIEMENS SYNGO OBJECT GRAPHICS	113	64	f	\N	CS	1	Graphic Type	\N
9135	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",41)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",41)	SIEMENS SYNGO OBJECT GRAPHICS	113	65	f	\N	US	1	Number of Graphic Points	\N
9136	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",42)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",42)	SIEMENS SYNGO OBJECT GRAPHICS	113	66	f	\N	DS	1	Axis Main Tick Length	\N
9137	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",43)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",43)	SIEMENS SYNGO OBJECT GRAPHICS	113	67	f	\N	DS	1	Axis Detail Tick Length	\N
9138	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",44)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",44)	SIEMENS SYNGO OBJECT GRAPHICS	113	68	f	\N	DS	1	Axis Main Tick Spacing	\N
9139	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",45)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",45)	SIEMENS SYNGO OBJECT GRAPHICS	113	69	f	\N	DS	1-n	Axis Detail Tick Spacing	\N
9140	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",46)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",46)	SIEMENS SYNGO OBJECT GRAPHICS	113	70	f	\N	DS	1	Axis Main Tick Count	\N
9141	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",47)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",47)	SIEMENS SYNGO OBJECT GRAPHICS	113	71	f	\N	DS	1	Axis Detail Tick Count	\N
9142	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",48)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",48)	SIEMENS SYNGO OBJECT GRAPHICS	113	72	f	\N	SL	1	Axis Tick Behavior	\N
9143	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",49)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",49)	SIEMENS SYNGO OBJECT GRAPHICS	113	73	f	\N	SL	1	Axis Tick Aligment	\N
9144	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",50)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",50)	SIEMENS SYNGO OBJECT GRAPHICS	113	80	f	\N	DS	1	Axis Step	\N
9145	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",51)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",51)	SIEMENS SYNGO OBJECT GRAPHICS	113	81	f	\N	SL	1	Axis Step Index	\N
9146	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",52)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",52)	SIEMENS SYNGO OBJECT GRAPHICS	113	82	f	\N	CS	1	Axis Text Format	\N
9147	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",53)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",53)	SIEMENS SYNGO OBJECT GRAPHICS	113	83	f	\N	CS	1	Axis Show Center Text Flag	\N
9148	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",54)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",54)	SIEMENS SYNGO OBJECT GRAPHICS	113	84	f	\N	CS	1	Axis Show Tick Text Flag	\N
9149	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",55)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",55)	SIEMENS SYNGO OBJECT GRAPHICS	113	85	f	\N	DS	3	Bitmap X Orientation	\N
9150	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",56)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",56)	SIEMENS SYNGO OBJECT GRAPHICS	113	86	f	\N	DS	3	Bitmap Y Orientation	\N
9151	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",57)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",57)	SIEMENS SYNGO OBJECT GRAPHICS	113	87	f	\N	OB	1	Graphic Blob	\N
9152	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",58)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",58)	SIEMENS SYNGO OBJECT GRAPHICS	113	88	f	\N	CS	1	Graphic Interpolation	\N
9153	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",59)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",59)	SIEMENS SYNGO OBJECT GRAPHICS	113	89	f	\N	DS	1	Graphic Angle	\N
9154	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",60)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",60)	SIEMENS SYNGO OBJECT GRAPHICS	113	96	f	\N	DS	1	Graphic Size	\N
9155	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",61)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",61)	SIEMENS SYNGO OBJECT GRAPHICS	113	97	f	\N	CS	1	Cut Line Side	\N
9156	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",62)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",62)	SIEMENS SYNGO OBJECT GRAPHICS	113	98	f	\N	DS	1	Graphic Tip Length	\N
9157	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",63)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",63)	SIEMENS SYNGO OBJECT GRAPHICS	113	99	f	\N	DS	1	Cut Line Arrow Length	\N
9158	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",64)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",64)	SIEMENS SYNGO OBJECT GRAPHICS	113	100	f	\N	DS	1	Line Gap Length	\N
9159	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",65)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",65)	SIEMENS SYNGO OBJECT GRAPHICS	113	101	f	\N	DS	1	Graphic Circle Radius	\N
9160	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",66)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",66)	SIEMENS SYNGO OBJECT GRAPHICS	113	102	f	\N	DS	1	Line Distance Move	\N
9161	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",67)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",67)	SIEMENS SYNGO OBJECT GRAPHICS	113	103	f	\N	DS	1	Line Marker Length	\N
9162	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",68)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",68)	SIEMENS SYNGO OBJECT GRAPHICS	113	104	f	\N	DS	3	Graphic Center	\N
9163	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",69)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",69)	SIEMENS SYNGO OBJECT GRAPHICS	113	105	f	\N	DS	3	Range Center Area Top Left	\N
9164	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",70)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",70)	SIEMENS SYNGO OBJECT GRAPHICS	113	112	f	\N	DS	3	Range Center Area Bottom Right	\N
9165	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",71)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",71)	SIEMENS SYNGO OBJECT GRAPHICS	113	113	f	\N	DS	1	Range Tilt	\N
9166	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",72)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",72)	SIEMENS SYNGO OBJECT GRAPHICS	113	114	f	\N	DS	1	Range Minimum Tilt	\N
9167	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",73)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",73)	SIEMENS SYNGO OBJECT GRAPHICS	113	115	f	\N	DS	1	Range Maximum Tilt	\N
9168	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",74)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",74)	SIEMENS SYNGO OBJECT GRAPHICS	113	116	f	\N	DS	1	Graphic Width	\N
9169	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",75)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",75)	SIEMENS SYNGO OBJECT GRAPHICS	113	117	f	\N	DS	1	Range Minimum Width	\N
9170	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",76)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",76)	SIEMENS SYNGO OBJECT GRAPHICS	113	118	f	\N	DS	1	Range Maximum Width	\N
9171	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",77)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",77)	SIEMENS SYNGO OBJECT GRAPHICS	113	119	f	\N	DS	1	Graphic Height	\N
9172	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",78)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",78)	SIEMENS SYNGO OBJECT GRAPHICS	113	120	f	\N	DS	1	Range Feed	\N
9173	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",79)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",79)	SIEMENS SYNGO OBJECT GRAPHICS	113	121	f	\N	CS	1	Range Direction	\N
9174	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",80)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",80)	SIEMENS SYNGO OBJECT GRAPHICS	113	128	f	\N	CS	1	Range Show Scans	\N
9175	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",81)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",81)	SIEMENS SYNGO OBJECT GRAPHICS	113	129	f	\N	DS	1	Range Minimum Scan Distance	\N
9176	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",82)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",82)	SIEMENS SYNGO OBJECT GRAPHICS	113	130	f	\N	CS	1	Range Orthogonal Height	\N
9177	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",83)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",83)	SIEMENS SYNGO OBJECT GRAPHICS	113	131	f	\N	DS	3	Graphic Position	\N
9178	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",84)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",84)	SIEMENS SYNGO OBJECT GRAPHICS	113	132	f	\N	CS	1	Graphic Closed Flag	\N
9179	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",85)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",85)	SIEMENS SYNGO OBJECT GRAPHICS	113	133	f	\N	SL	1	Range Line Tip Mode	\N
9180	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",86)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",86)	SIEMENS SYNGO OBJECT GRAPHICS	113	134	f	\N	SL	1	Graphic List Count	\N
9181	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",87)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",87)	SIEMENS SYNGO OBJECT GRAPHICS	113	135	f	\N	CS	1	Axis Flip Text Flag	\N
9182	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",88)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",88)	SIEMENS SYNGO OBJECT GRAPHICS	113	136	f	\N	CS	1	Curve Diagram Type	\N
9183	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",89)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",89)	SIEMENS SYNGO OBJECT GRAPHICS	113	137	f	\N	DS	1	Graphic Start Angle	\N
9184	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",90)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",90)	SIEMENS SYNGO OBJECT GRAPHICS	113	144	f	\N	DS	1	Graphic End Angle	\N
9185	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",91)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",91)	SIEMENS SYNGO OBJECT GRAPHICS	113	145	f	\N	IS	1	Live Wire Smoothness	\N
9186	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",92)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",92)	SIEMENS SYNGO OBJECT GRAPHICS	113	146	f	\N	CS	1	Live Wire Spline Flag	\N
9187	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",93)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",93)	SIEMENS SYNGO OBJECT GRAPHICS	113	147	f	\N	CS	1	Ellipse Circle Flag	\N
9188	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",94)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",94)	SIEMENS SYNGO OBJECT GRAPHICS	113	148	f	\N	CS	1	Graphic Square Flag	\N
9189	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",95)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",95)	SIEMENS SYNGO OBJECT GRAPHICS	113	149	f	\N	DS	1	Curve Section Start Index	\N
9190	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",96)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",96)	SIEMENS SYNGO OBJECT GRAPHICS	113	150	f	\N	DS	1	Curve Section End Index	\N
9191	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",97)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",97)	SIEMENS SYNGO OBJECT GRAPHICS	113	151	f	\N	DS	1	Marker Alpha	\N
9192	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",98)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",98)	SIEMENS SYNGO OBJECT GRAPHICS	113	152	f	\N	IS	1	Table Row Count	\N
9193	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",99)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",99)	SIEMENS SYNGO OBJECT GRAPHICS	113	153	f	\N	IS	1	Table Column Count	\N
9194	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9a)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9a)	SIEMENS SYNGO OBJECT GRAPHICS	113	154	f	\N	DS	1	Table Row Height	\N
9195	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9b)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9b)	SIEMENS SYNGO OBJECT GRAPHICS	113	155	f	\N	DS	1	Table Column Width	\N
9196	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9c)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9c)	SIEMENS SYNGO OBJECT GRAPHICS	113	156	f	\N	IS	1	Rectangle Selection Segment Offset	\N
9197	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9d)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",9d)	SIEMENS SYNGO OBJECT GRAPHICS	113	157	f	\N	CS	1	Graphic Text	\N
9198	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a0)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a0)	SIEMENS SYNGO OBJECT GRAPHICS	113	160	f	\N	SL	1	Axis Tick Spacing Coordinate System	\N
9199	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a1)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a1)	SIEMENS SYNGO OBJECT GRAPHICS	113	161	f	\N	CS	1	Axis Diagram Grid Type	\N
9200	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a2)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a2)	SIEMENS SYNGO OBJECT GRAPHICS	113	162	f	\N	SL	1	Polar Plot Circle Count	\N
9201	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a3)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a3)	SIEMENS SYNGO OBJECT GRAPHICS	113	163	f	\N	SL	1	Polar Plot Lines-per-Circle	\N
9202	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a4)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a4)	SIEMENS SYNGO OBJECT GRAPHICS	113	164	f	\N	SL	1	Polar Plot Compartment Count	\N
9203	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a5)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a5)	SIEMENS SYNGO OBJECT GRAPHICS	113	165	f	\N	SL	1	Polar Plot Radius Weight	\N
9204	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a6)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a6)	SIEMENS SYNGO OBJECT GRAPHICS	113	166	f	\N	DS	1	Circle Segment Outer Radius	\N
9205	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a7)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a7)	SIEMENS SYNGO OBJECT GRAPHICS	113	167	f	\N	CS	1	Circle Segment Clockwise Flag	\N
9206	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a8)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a8)	SIEMENS SYNGO OBJECT GRAPHICS	113	168	f	\N	CS	1	Axis Diagram Auto Resize Flag	\N
9207	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a9)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",a9)	SIEMENS SYNGO OBJECT GRAPHICS	113	169	f	\N	DS	1	Axis Diagram Step Start	\N
9208	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b0)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b0)	SIEMENS SYNGO OBJECT GRAPHICS	113	176	f	\N	CS	1	Group Root	\N
9209	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b1)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b1)	SIEMENS SYNGO OBJECT GRAPHICS	113	177	f	\N	ST	1	Group Name	\N
9210	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b2)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b2)	SIEMENS SYNGO OBJECT GRAPHICS	113	178	f	\N	SQ	1	Graphic Annotation Sequence	\N
9211	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b3)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b3)	SIEMENS SYNGO OBJECT GRAPHICS	113	179	f	\N	SL	1	Text Minimum Height	\N
9212	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b4)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b4)	SIEMENS SYNGO OBJECT GRAPHICS	113	180	f	\N	DS	1	Text Font Scaling Factor	\N
9213	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b5)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b5)	SIEMENS SYNGO OBJECT GRAPHICS	113	181	f	\N	SL	2	Text Maximum Extensions	\N
9214	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b6)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b6)	SIEMENS SYNGO OBJECT GRAPHICS	113	182	f	\N	CS	1	Text Segment Size	\N
9215	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b7)	(0071,"SIEMENS SYNGO OBJECT GRAPHICS",b7)	SIEMENS SYNGO OBJECT GRAPHICS	113	183	f	\N	SL	1	Graphic Object Reference Label	\N
9216	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",02)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",02)	SIEMENS SYNGO LAYOUT PROTOCOL	115	2	f	\N	US	1	Hanging Protocol Excellence Rank	\N
9217	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",04)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",04)	SIEMENS SYNGO LAYOUT PROTOCOL	115	4	f	\N	CS	1	Template Data Role ID	\N
9218	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",06)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",06)	SIEMENS SYNGO LAYOUT PROTOCOL	115	6	f	\N	CS	1	Data Sharing Flag	\N
9219	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",08)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",08)	SIEMENS SYNGO LAYOUT PROTOCOL	115	8	f	\N	SQ	1	Bagging Operations Sequence	\N
9220	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",10)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",10)	SIEMENS SYNGO LAYOUT PROTOCOL	115	16	f	\N	LO	1	Synchronization Type	\N
9221	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",12)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",12)	SIEMENS SYNGO LAYOUT PROTOCOL	115	18	f	\N	LO	1	Custom Filter Type	\N
9222	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",14)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",14)	SIEMENS SYNGO LAYOUT PROTOCOL	115	20	f	\N	LO	1	Custom Sorter Type	\N
9223	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",16)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",16)	SIEMENS SYNGO LAYOUT PROTOCOL	115	22	f	\N	CS	1	Reference Template Data Role ID	\N
9224	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",18)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",18)	SIEMENS SYNGO LAYOUT PROTOCOL	115	24	f	\N	CS	1	Model Template Data Role ID	\N
9225	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",20)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",20)	SIEMENS SYNGO LAYOUT PROTOCOL	115	32	f	\N	DT	1-n	Selector DT Value	\N
9226	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",22)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",22)	SIEMENS SYNGO LAYOUT PROTOCOL	115	34	f	\N	DA	1-n	Selector DA Value	\N
9227	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",24)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",24)	SIEMENS SYNGO LAYOUT PROTOCOL	115	36	f	\N	TM	1-n	Selector TM Value	\N
9228	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",26)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",26)	SIEMENS SYNGO LAYOUT PROTOCOL	115	38	f	\N	UI	1-n	Selector UI Value	\N
9229	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",28)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",28)	SIEMENS SYNGO LAYOUT PROTOCOL	115	40	f	\N	CS	1	Referenced Template Data Role	\N
9230	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",30)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",30)	SIEMENS SYNGO LAYOUT PROTOCOL	115	48	f	\N	SQ	1	Custom Property Sequence	\N
9231	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",32)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",32)	SIEMENS SYNGO LAYOUT PROTOCOL	115	50	f	\N	CS	1	Custom Property Type	\N
9232	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",34)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",34)	SIEMENS SYNGO LAYOUT PROTOCOL	115	52	f	\N	LO	1	Custom Property Name	\N
9233	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",36)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",36)	SIEMENS SYNGO LAYOUT PROTOCOL	115	54	f	\N	LO	1	Custom Property Value	\N
9234	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",38)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",38)	SIEMENS SYNGO LAYOUT PROTOCOL	115	56	f	\N	SQ	1	Layout Property Sequence	\N
9235	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",40)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",40)	SIEMENS SYNGO LAYOUT PROTOCOL	115	64	f	\N	SQ	1	Synchronization Sequence	\N
9236	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",42)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",42)	SIEMENS SYNGO LAYOUT PROTOCOL	115	66	f	\N	CS	1	Presentation Creator Type	\N
9237	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",44)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",44)	SIEMENS SYNGO LAYOUT PROTOCOL	115	68	f	\N	CS	1	Cine Navigation Type	\N
9238	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",48)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",48)	SIEMENS SYNGO LAYOUT PROTOCOL	115	72	f	\N	LO	1	Semantic Naming Strategy	\N
9239	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",50)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",50)	SIEMENS SYNGO LAYOUT PROTOCOL	115	80	f	\N	LO	1	Parameter String	\N
9240	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",52)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",52)	SIEMENS SYNGO LAYOUT PROTOCOL	115	82	f	\N	CS	1	Sorting Order	\N
9241	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",54)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",54)	SIEMENS SYNGO LAYOUT PROTOCOL	115	84	f	\N	CS	1	syngo Template Type	\N
9242	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",56)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",56)	SIEMENS SYNGO LAYOUT PROTOCOL	115	86	f	\N	CS	1	Sorter Type	\N
9243	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",58)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",58)	SIEMENS SYNGO LAYOUT PROTOCOL	115	88	f	\N	SH	1	Data Display Protocol Version	\N
9244	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5a)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5a)	SIEMENS SYNGO LAYOUT PROTOCOL	115	90	f	\N	CS	1	Timepoint Value	\N
9245	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5b)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5b)	SIEMENS SYNGO LAYOUT PROTOCOL	115	91	f	\N	CS	1	Sharing Group Sequence	\N
9246	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5c)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5c)	SIEMENS SYNGO LAYOUT PROTOCOL	115	92	f	\N	CS	1	Template Selector Operator	\N
9247	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5d)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",5d)	SIEMENS SYNGO LAYOUT PROTOCOL	115	93	f	\N	CS	1	Sharing Type	\N
9248	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",60)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",60)	SIEMENS SYNGO LAYOUT PROTOCOL	115	96	f	\N	SQ	1	Viewport Definitions Sequence	\N
9249	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",62)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",62)	SIEMENS SYNGO LAYOUT PROTOCOL	115	98	f	\N	CS	1	Protocol Type	\N
9250	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",64)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",64)	SIEMENS SYNGO LAYOUT PROTOCOL	115	100	f	\N	SQ	1	Template Selector Sequence	\N
9251	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",66)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",66)	SIEMENS SYNGO LAYOUT PROTOCOL	115	102	f	\N	CS	1	Default Template	\N
9252	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",68)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",68)	SIEMENS SYNGO LAYOUT PROTOCOL	115	104	f	\N	CS	1	Is Preferred	\N
9253	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",6a)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",6a)	SIEMENS SYNGO LAYOUT PROTOCOL	115	106	f	\N	SQ	1	Timepoint Initial Value Sequence	\N
9254	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",6c)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",6c)	SIEMENS SYNGO LAYOUT PROTOCOL	115	108	f	\N	CS	1	Timepoint Variable	\N
9255	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",70)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",70)	SIEMENS SYNGO LAYOUT PROTOCOL	115	112	f	\N	SH	1	Display Protocol Name	\N
9256	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",72)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",72)	SIEMENS SYNGO LAYOUT PROTOCOL	115	114	f	\N	LO	1	Display Protocol Description	\N
9257	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",74)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",74)	SIEMENS SYNGO LAYOUT PROTOCOL	115	116	f	\N	CS	1	Display Protocol Level	\N
9258	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",76)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",76)	SIEMENS SYNGO LAYOUT PROTOCOL	115	118	f	\N	LO	1	Display Protocol Creator	\N
9259	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",78)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",78)	SIEMENS SYNGO LAYOUT PROTOCOL	115	120	f	\N	DT	1	Display Protocol Creation Datetime	\N
9260	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7a)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7a)	SIEMENS SYNGO LAYOUT PROTOCOL	115	122	f	\N	UI	1	Referenced Data Protocol	\N
9261	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7c)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7c)	SIEMENS SYNGO LAYOUT PROTOCOL	115	124	f	\N	US	1	Display Protocol Excellence Rank	\N
9262	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7e)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",7e)	SIEMENS SYNGO LAYOUT PROTOCOL	115	126	f	\N	SQ	1	Layout Sequence	\N
9263	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",80)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",80)	SIEMENS SYNGO LAYOUT PROTOCOL	115	128	f	\N	US	1	Layout Number	\N
9264	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",82)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",82)	SIEMENS SYNGO LAYOUT PROTOCOL	115	130	f	\N	LO	1	Layout Description	\N
9265	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",84)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",84)	SIEMENS SYNGO LAYOUT PROTOCOL	115	132	f	\N	SQ	1	Segment Sequence	\N
9266	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",86)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",86)	SIEMENS SYNGO LAYOUT PROTOCOL	115	134	f	\N	US	1	Segment Number	\N
9267	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",88)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",88)	SIEMENS SYNGO LAYOUT PROTOCOL	115	136	f	\N	LO	1	Segment Description	\N
9268	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8a)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8a)	SIEMENS SYNGO LAYOUT PROTOCOL	115	138	f	\N	CS	1	Segment Type	\N
9269	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8c)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8c)	SIEMENS SYNGO LAYOUT PROTOCOL	115	140	f	\N	US	1	Tile Horizontal Dimension	\N
9270	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8e)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",8e)	SIEMENS SYNGO LAYOUT PROTOCOL	115	142	f	\N	US	1	Tile Vertical Dimension	\N
9271	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",90)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",90)	SIEMENS SYNGO LAYOUT PROTOCOL	115	144	f	\N	CS	1	Fill Order	\N
9272	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",92)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",92)	SIEMENS SYNGO LAYOUT PROTOCOL	115	146	f	\N	CS	1	Segment Small Scroll Type	\N
9273	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",94)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",94)	SIEMENS SYNGO LAYOUT PROTOCOL	115	148	f	\N	US	1	Segment Small Scroll Amount	\N
9274	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",96)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",96)	SIEMENS SYNGO LAYOUT PROTOCOL	115	150	f	\N	CS	1	Segment Large Scroll Type	\N
9275	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",98)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",98)	SIEMENS SYNGO LAYOUT PROTOCOL	115	152	f	\N	US	1	Segment Large Scroll Amount	\N
9276	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9a)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9a)	SIEMENS SYNGO LAYOUT PROTOCOL	115	154	f	\N	US	1	Segment Overlap Priority	\N
9277	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9c)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9c)	SIEMENS SYNGO LAYOUT PROTOCOL	115	156	f	\N	SQ	1	Data Role View Sequence	\N
9278	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9e)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",9e)	SIEMENS SYNGO LAYOUT PROTOCOL	115	158	f	\N	US	1	Data Role View Number	\N
9279	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a2)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a2)	SIEMENS SYNGO LAYOUT PROTOCOL	115	162	f	\N	US	1	Referenced Data Role	\N
9280	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a4)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a4)	SIEMENS SYNGO LAYOUT PROTOCOL	115	164	f	\N	CS	1	Sharing Enabled	\N
9281	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",a8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	168	f	\N	US	2-n	Referenced Data Role Views	\N
9282	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b0)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b0)	SIEMENS SYNGO LAYOUT PROTOCOL	115	176	f	\N	SH	1	Data Protocol Name	\N
9283	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b2)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b2)	SIEMENS SYNGO LAYOUT PROTOCOL	115	178	f	\N	LO	1	Data Protocol Description	\N
9284	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b4)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b4)	SIEMENS SYNGO LAYOUT PROTOCOL	115	180	f	\N	CS	1	Data Protocol Level	\N
9285	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b6)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b6)	SIEMENS SYNGO LAYOUT PROTOCOL	115	182	f	\N	LO	1	Data Protocol Creator	\N
9286	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",b8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	184	f	\N	DT	1	Data Protocol Creation Datetime	\N
9287	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ba)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ba)	SIEMENS SYNGO LAYOUT PROTOCOL	115	186	f	\N	US	1	Data Protocol Excellence Rank	\N
9288	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",bc)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",bc)	SIEMENS SYNGO LAYOUT PROTOCOL	115	188	f	\N	SQ	1	Data Protocol Definition Sequence	\N
9289	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",be)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",be)	SIEMENS SYNGO LAYOUT PROTOCOL	115	190	f	\N	SQ	1	Data Role Sequence	\N
9290	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c0)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c0)	SIEMENS SYNGO LAYOUT PROTOCOL	115	192	f	\N	US	1	Data Role Number	\N
9291	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c2)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c2)	SIEMENS SYNGO LAYOUT PROTOCOL	115	194	f	\N	SH	1	Data Role Name	\N
9292	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c6)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c6)	SIEMENS SYNGO LAYOUT PROTOCOL	115	198	f	\N	SQ	1	Selector Operations Sequence	\N
9293	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",c8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	200	f	\N	CS	1	Selector Usage Flag	\N
9294	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ca)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ca)	SIEMENS SYNGO LAYOUT PROTOCOL	115	202	f	\N	CS	1	Select by Attribute Presence	\N
9295	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",cc)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",cc)	SIEMENS SYNGO LAYOUT PROTOCOL	115	204	f	\N	CS	1	Select by Category	\N
9296	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ce)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ce)	SIEMENS SYNGO LAYOUT PROTOCOL	115	206	f	\N	CS	1	Select by Operator	\N
9297	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d0)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d0)	SIEMENS SYNGO LAYOUT PROTOCOL	115	208	f	\N	LO	1	Custom Selector Type	\N
9298	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d2)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d2)	SIEMENS SYNGO LAYOUT PROTOCOL	115	210	f	\N	CS	1	Selector Operator	\N
9299	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d4)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d4)	SIEMENS SYNGO LAYOUT PROTOCOL	115	212	f	\N	CS	1	Reformatting Required	\N
9300	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d6)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d6)	SIEMENS SYNGO LAYOUT PROTOCOL	115	214	f	\N	SQ	1	Registration Data Sequence	\N
9301	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",d8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	216	f	\N	US	1	Reference Data Role Number	\N
9302	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",da)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",da)	SIEMENS SYNGO LAYOUT PROTOCOL	115	218	f	\N	SQ	1	Model Data Sequence	\N
9303	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",dc)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",dc)	SIEMENS SYNGO LAYOUT PROTOCOL	115	220	f	\N	US	1	Model Data Role Number	\N
9304	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",de)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",de)	SIEMENS SYNGO LAYOUT PROTOCOL	115	222	f	\N	SQ	1	Fusion Display Sequence	\N
9305	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e0)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e0)	SIEMENS SYNGO LAYOUT PROTOCOL	115	224	f	\N	FD	1	Transparency	\N
9306	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e2)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e2)	SIEMENS SYNGO LAYOUT PROTOCOL	115	226	f	\N	CS	1	Time Point	\N
9307	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e4)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e4)	SIEMENS SYNGO LAYOUT PROTOCOL	115	228	f	\N	LO	1	First Time Point Token	\N
9308	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e6)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e6)	SIEMENS SYNGO LAYOUT PROTOCOL	115	230	f	\N	LO	1	Last Time Point Token	\N
9309	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",e8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	232	f	\N	LO	1	Intermediate Time Point Token	\N
9310	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ea)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ea)	SIEMENS SYNGO LAYOUT PROTOCOL	115	234	f	\N	SQ	1	Data Processor Sequence	\N
9311	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ec)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ec)	SIEMENS SYNGO LAYOUT PROTOCOL	115	236	f	\N	LO	1	Data Processor Type	\N
9312	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ee)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ee)	SIEMENS SYNGO LAYOUT PROTOCOL	115	238	f	\N	SQ	1	Template Data Role Sequence	\N
9313	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f0)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f0)	SIEMENS SYNGO LAYOUT PROTOCOL	115	240	f	\N	SQ	1	View Sequence	\N
9314	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f4)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f4)	SIEMENS SYNGO LAYOUT PROTOCOL	115	244	f	\N	LO	1	View Type	\N
9315	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f6)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f6)	SIEMENS SYNGO LAYOUT PROTOCOL	115	246	f	\N	LO	1	Custom Bagging Type	\N
9316	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f8)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",f8)	SIEMENS SYNGO LAYOUT PROTOCOL	115	248	f	\N	US	1	Referenced Display Segment Number	\N
9317	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fa)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fa)	SIEMENS SYNGO LAYOUT PROTOCOL	115	250	f	\N	LO	1	Data Role Type	\N
9318	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",46)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",46)	SIEMENS SYNGO LAYOUT PROTOCOL	115	70	f	\N	CS	1	Internal Flag	\N
9319	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fc)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fc)	SIEMENS SYNGO LAYOUT PROTOCOL	115	252	f	\N	CS	1	Unassigned Flag	\N
9320	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fe)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",fe)	SIEMENS SYNGO LAYOUT PROTOCOL	115	254	f	\N	CS	1	Initial Display Scroll Position	\N
9321	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ff)	(0073,"SIEMENS SYNGO LAYOUT PROTOCOL",ff)	SIEMENS SYNGO LAYOUT PROTOCOL	115	255	f	\N	LO	1	VRT Preset	\N
9322	(0091,"SIENET",20)	(0091,"SIENET",20)	SIENET	145	32	f	\N	PN	1	RIS Patient Name	\N
9323	(0093,"SIENET",02)	(0093,"SIENET",02)	SIENET	147	2	f	\N	LO	1	Unknown	\N
9324	(0095,"SIENET",0c)	(0095,"SIENET",0c)	SIENET	149	12	f	\N	SL	1	Unknown	\N
9325	(0095,"SIENET",20)	(0095,"SIENET",20)	SIENET	149	32	f	\N	PN	1	RIS Patient Name	\N
9326	(0097,"SIENET",03)	(0097,"SIENET",03)	SIENET	151	3	f	\N	SL	1	Unknown	\N
9327	(0097,"SIENET",05)	(0097,"SIENET",05)	SIENET	151	5	f	\N	LO	1	Unknown	\N
9328	(0099,"SIENET",05)	(0099,"SIENET",05)	SIENET	153	5	f	\N	SL	1	Unknown	\N
9329	(00a5,"SIENET",05)	(00a5,"SIENET",05)	SIENET	165	5	f	\N	LO	1	Unknown	\N
9333	(7fe3,"SIEMENS MED NM",16)	(7fe3,"SIEMENS MED NM",16)	SIEMENS MED NM	32739	22	f	\N	OW	1	Unknown	\N
9334	(7fe3,"SIEMENS MED NM",1b)	(7fe3,"SIEMENS MED NM",1b)	SIEMENS MED NM	32739	27	f	\N	OW	1	Unknown	\N
9335	(7fe3,"SIEMENS MED NM",1c)	(7fe3,"SIEMENS MED NM",1c)	SIEMENS MED NM	32739	28	f	\N	OW	1	Unknown	\N
9336	(7fe3,"SIEMENS MED NM",1e)	(7fe3,"SIEMENS MED NM",1e)	SIEMENS MED NM	32739	30	f	\N	OW	1	Unknown	\N
9337	(7fe3,"SIEMENS MED NM",26)	(7fe3,"SIEMENS MED NM",26)	SIEMENS MED NM	32739	38	f	\N	OW	1	Unknown	\N
9338	(7fe3,"SIEMENS MED NM",27)	(7fe3,"SIEMENS MED NM",27)	SIEMENS MED NM	32739	39	f	\N	OW	1	Unknown	\N
9339	(7fe3,"SIEMENS MED NM",28)	(7fe3,"SIEMENS MED NM",28)	SIEMENS MED NM	32739	40	f	\N	OW	1	Unknown	\N
9341	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",10)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",10)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	16	f	\N	LO	1	Evidence Document Template Name	\N
9342	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",11)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",11)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	17	f	\N	DS	1	Evidence Document Template Version	\N
9343	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",20)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",20)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	32	f	\N	OB	1	Clinical Finding Data	\N
9344	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",21)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",21)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	33	f	\N	OB	1	Metadata	\N
9345	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",30)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",30)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	48	f	\N	DS	1	Implementation Version	\N
9346	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",40)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",40)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	64	f	\N	OB	1	Predecessor	\N
9347	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",50)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",50)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	80	f	\N	LO	1	Logical ID	\N
9348	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",60)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",60)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	96	f	\N	OB	1	Application Data	\N
9349	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",70)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",70)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	112	f	\N	LO	1	Owner Clinical Task Name	\N
9350	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",71)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",71)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	113	f	\N	LO	1	Owner Task Name	\N
9351	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",72)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",72)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	114	f	\N	OB	1	Owner Supported Templates	\N
9352	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",80)	(0077,"SIEMENS SYNGO EVIDENCE DOCUMENT DATA",80)	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	119	128	f	\N	OB	1	Volume Catalog	\N
9353	(0021,"syngoDynamics_Reporting",ad)	(0021,"syngoDynamics_Reporting",ad)	syngoDynamics_Reporting	33	173	f	\N	OB	1	Data	\N
9538	(0021,"SIEMENS MR N3D",4a)	(0021,"SIEMENS MR N3D",4a)	SIEMENS MR N3D	33	74	f	\N	SQ	1	Ortho MPR ColorLUT DR Sequence	\N
9354	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",20)	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",20)	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	135	32	f	\N	OB	1	Study Model	\N
9355	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",30)	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",30)	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	135	48	f	\N	OB	1	Report XML Schema	\N
9356	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",40)	(0087,"SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA",40)	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	135	64	f	\N	OB	1	Report Identifier	\N
9357	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",08)	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",08)	SIEMENS SYNGO 3D FUSION MATRIX	41	8	f	\N	UI	1	Object Series Instance UID	\N
9358	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",09)	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",09)	SIEMENS SYNGO 3D FUSION MATRIX	41	9	f	\N	UI	1	Model Series Instance UID	\N
9359	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",10)	(0029,"SIEMENS SYNGO 3D FUSION MATRIX",10)	SIEMENS SYNGO 3D FUSION MATRIX	41	16	f	\N	UI	1	Matrix Referenced Series Instance UID	\N
9360	(0019,"SIEMENS Ultrasound SC2000",2d)	(0019,"SIEMENS Ultrasound SC2000",2d)	SIEMENS Ultrasound SC2000	25	45	f	\N	US	1	B-mode Tint Index	\N
9361	(0019,"SIEMENS Ultrasound SC2000",72)	(0019,"SIEMENS Ultrasound SC2000",72)	SIEMENS Ultrasound SC2000	25	114	f	\N	US	1	Doppler Tint Index	\N
9362	(0019,"SIEMENS Ultrasound SC2000",88)	(0019,"SIEMENS Ultrasound SC2000",88)	SIEMENS Ultrasound SC2000	25	136	f	\N	US	1	M-mode Tint Index	\N
9363	(0019,"SIEMENS Ultrasound SC2000",89)	(0019,"SIEMENS Ultrasound SC2000",89)	SIEMENS Ultrasound SC2000	25	137	f	\N	LO	1	Unknown	\N
9364	(0119,"SIEMENS Ultrasound SC2000",00)	(0119,"SIEMENS Ultrasound SC2000",00)	SIEMENS Ultrasound SC2000	281	0	f	\N	LO	1	Acoustic Meta Information Version	\N
9365	(0119,"SIEMENS Ultrasound SC2000",01)	(0119,"SIEMENS Ultrasound SC2000",01)	SIEMENS Ultrasound SC2000	281	1	f	\N	UN	1	Common Acoustic Meta Information	\N
9366	(0119,"SIEMENS Ultrasound SC2000",02)	(0119,"SIEMENS Ultrasound SC2000",02)	SIEMENS Ultrasound SC2000	281	2	f	\N	SQ	1	Multi Stream Sequence	\N
9367	(0119,"SIEMENS Ultrasound SC2000",03)	(0119,"SIEMENS Ultrasound SC2000",03)	SIEMENS Ultrasound SC2000	281	3	f	\N	SQ	1	Acoustic Data Sequence	\N
9368	(0119,"SIEMENS Ultrasound SC2000",04)	(0119,"SIEMENS Ultrasound SC2000",04)	SIEMENS Ultrasound SC2000	281	4	f	\N	UN	1	Per Transaction Acoustic Control Information	\N
9369	(0119,"SIEMENS Ultrasound SC2000",05)	(0119,"SIEMENS Ultrasound SC2000",05)	SIEMENS Ultrasound SC2000	281	5	f	\N	UN	1	Acoustic Data Offset	\N
9370	(0119,"SIEMENS Ultrasound SC2000",06)	(0119,"SIEMENS Ultrasound SC2000",06)	SIEMENS Ultrasound SC2000	281	6	f	\N	UN	1	Acoustic Data Length	\N
9371	(0119,"SIEMENS Ultrasound SC2000",07)	(0119,"SIEMENS Ultrasound SC2000",07)	SIEMENS Ultrasound SC2000	281	7	f	\N	UN	1	Footer Offset	\N
9372	(0119,"SIEMENS Ultrasound SC2000",08)	(0119,"SIEMENS Ultrasound SC2000",08)	SIEMENS Ultrasound SC2000	281	8	f	\N	UN	1	Footer Length	\N
9373	(0119,"SIEMENS Ultrasound SC2000",09)	(0119,"SIEMENS Ultrasound SC2000",09)	SIEMENS Ultrasound SC2000	281	9	f	\N	UN	1	Acoustic Stream Number	\N
9374	(0119,"SIEMENS Ultrasound SC2000",10)	(0119,"SIEMENS Ultrasound SC2000",10)	SIEMENS Ultrasound SC2000	281	16	f	\N	UN	1	Acoustic Stream Type	\N
9375	(0119,"SIEMENS Ultrasound SC2000",11)	(0119,"SIEMENS Ultrasound SC2000",11)	SIEMENS Ultrasound SC2000	281	17	f	\N	UN	1	Stage Timer Time	\N
9376	(0119,"SIEMENS Ultrasound SC2000",12)	(0119,"SIEMENS Ultrasound SC2000",12)	SIEMENS Ultrasound SC2000	281	18	f	\N	UN	1	Stop Watch Time	\N
9377	(0119,"SIEMENS Ultrasound SC2000",13)	(0119,"SIEMENS Ultrasound SC2000",13)	SIEMENS Ultrasound SC2000	281	19	f	\N	UN	1	Volume Rate	\N
9378	(0129,"SIEMENS Ultrasound SC2000",00)	(0129,"SIEMENS Ultrasound SC2000",00)	SIEMENS Ultrasound SC2000	297	0	f	\N	SQ	1	MPR View Sequence	\N
9379	(0129,"SIEMENS Ultrasound SC2000",02)	(0129,"SIEMENS Ultrasound SC2000",02)	SIEMENS Ultrasound SC2000	297	2	f	\N	UI	1	Bookmark UID	\N
9380	(0129,"SIEMENS Ultrasound SC2000",03)	(0129,"SIEMENS Ultrasound SC2000",03)	SIEMENS Ultrasound SC2000	297	3	f	\N	UN	1	Plane Origin Vector	\N
9381	(0129,"SIEMENS Ultrasound SC2000",04)	(0129,"SIEMENS Ultrasound SC2000",04)	SIEMENS Ultrasound SC2000	297	4	f	\N	UN	1	Row Vector	\N
9382	(0129,"SIEMENS Ultrasound SC2000",05)	(0129,"SIEMENS Ultrasound SC2000",05)	SIEMENS Ultrasound SC2000	297	5	f	\N	UN	1	Column Vector	\N
9383	(0129,"SIEMENS Ultrasound SC2000",06)	(0129,"SIEMENS Ultrasound SC2000",06)	SIEMENS Ultrasound SC2000	297	6	f	\N	SQ	1	Visualization Sequence	\N
9384	(0129,"SIEMENS Ultrasound SC2000",07)	(0129,"SIEMENS Ultrasound SC2000",07)	SIEMENS Ultrasound SC2000	297	7	f	\N	UI	1	Bookmark UID	\N
9385	(0129,"SIEMENS Ultrasound SC2000",08)	(0129,"SIEMENS Ultrasound SC2000",08)	SIEMENS Ultrasound SC2000	297	8	f	\N	UN	1	Visualization Information	\N
9386	(0129,"SIEMENS Ultrasound SC2000",09)	(0129,"SIEMENS Ultrasound SC2000",09)	SIEMENS Ultrasound SC2000	297	9	f	\N	SQ	1	Application State Sequence	\N
9387	(0129,"SIEMENS Ultrasound SC2000",10)	(0129,"SIEMENS Ultrasound SC2000",10)	SIEMENS Ultrasound SC2000	297	16	f	\N	OB	1	Application State Information	\N
9388	(0129,"SIEMENS Ultrasound SC2000",11)	(0129,"SIEMENS Ultrasound SC2000",11)	SIEMENS Ultrasound SC2000	297	17	f	\N	SQ	1	Referenced Bookmark Sequence	\N
9389	(0129,"SIEMENS Ultrasound SC2000",12)	(0129,"SIEMENS Ultrasound SC2000",12)	SIEMENS Ultrasound SC2000	297	18	f	\N	UI	1	Referenced Bookmark UID	\N
9390	(0129,"SIEMENS Ultrasound SC2000",20)	(0129,"SIEMENS Ultrasound SC2000",20)	SIEMENS Ultrasound SC2000	297	32	f	\N	SQ	1	Cine Parameters Sequence	\N
9391	(0129,"SIEMENS Ultrasound SC2000",21)	(0129,"SIEMENS Ultrasound SC2000",21)	SIEMENS Ultrasound SC2000	297	33	f	\N	UN	1	Cine Parameters Schema	\N
9392	(0129,"SIEMENS Ultrasound SC2000",22)	(0129,"SIEMENS Ultrasound SC2000",22)	SIEMENS Ultrasound SC2000	297	34	f	\N	UN	1	Values of Cine Parameters	\N
9393	(0129,"SIEMENS Ultrasound SC2000",30)	(0129,"SIEMENS Ultrasound SC2000",30)	SIEMENS Ultrasound SC2000	297	48	f	\N	CS	1	Raw Data Object Type	\N
9394	(0139,"SIEMENS Ultrasound SC2000",01)	(0139,"SIEMENS Ultrasound SC2000",01)	SIEMENS Ultrasound SC2000	313	1	f	\N	SL	1	Physio Capture ROI	\N
9395	(0149,"SIEMENS Ultrasound SC2000",01)	(0149,"SIEMENS Ultrasound SC2000",01)	SIEMENS Ultrasound SC2000	329	1	f	\N	FD	1-n	Vector of BROI Points	\N
9396	(0149,"SIEMENS Ultrasound SC2000",02)	(0149,"SIEMENS Ultrasound SC2000",02)	SIEMENS Ultrasound SC2000	329	2	f	\N	FD	1-n	Start/End Timestamps of Strip Stream	\N
9397	(0149,"SIEMENS Ultrasound SC2000",03)	(0149,"SIEMENS Ultrasound SC2000",03)	SIEMENS Ultrasound SC2000	329	3	f	\N	FD	1-n	Timestamps of Visible R-waves	\N
9398	(7fd1,"SIEMENS Ultrasound SC2000",01)	(7fd1,"SIEMENS Ultrasound SC2000",01)	SIEMENS Ultrasound SC2000	32721	1	f	\N	UN	1	Acoustic Image and Footer Data	\N
9399	(7fd1,"SIEMENS Ultrasound SC2000",09)	(7fd1,"SIEMENS Ultrasound SC2000",09)	SIEMENS Ultrasound SC2000	32721	9	f	\N	UN	1	Volume Version ID	\N
9400	(7fd1,"SIEMENS Ultrasound SC2000",10)	(7fd1,"SIEMENS Ultrasound SC2000",10)	SIEMENS Ultrasound SC2000	32721	16	f	\N	UN	1	Volume Payload	\N
9401	(7fd1,"SIEMENS Ultrasound SC2000",11)	(7fd1,"SIEMENS Ultrasound SC2000",11)	SIEMENS Ultrasound SC2000	32721	17	f	\N	UN	1	After Payload	\N
9402	(7fdf,"SIEMENS SYNGO DATA PADDING",fc)	(7fdf,"SIEMENS SYNGO DATA PADDING",fc)	SIEMENS SYNGO DATA PADDING	32735	252	f	\N	OB	1	Pixel Data Leading Padding	\N
9403	(0019,"SIEMENS MR HEADER",08)	(0019,"SIEMENS MR HEADER",08)	SIEMENS MR HEADER	25	8	f	\N	CS	1	Unknown	\N
9404	(0019,"SIEMENS MR HEADER",09)	(0019,"SIEMENS MR HEADER",09)	SIEMENS MR HEADER	25	9	f	\N	LO	1	Unknown	\N
9405	(0019,"SIEMENS MR HEADER",0a)	(0019,"SIEMENS MR HEADER",0a)	SIEMENS MR HEADER	25	10	f	\N	US	1	Number of Images in Mosaic	\N
9406	(0019,"SIEMENS MR HEADER",0b)	(0019,"SIEMENS MR HEADER",0b)	SIEMENS MR HEADER	25	11	f	\N	DS	1	Slice Measurement Duration	\N
9407	(0019,"SIEMENS MR HEADER",0c)	(0019,"SIEMENS MR HEADER",0c)	SIEMENS MR HEADER	25	12	f	\N	IS	1	B Value	\N
9408	(0019,"SIEMENS MR HEADER",0d)	(0019,"SIEMENS MR HEADER",0d)	SIEMENS MR HEADER	25	13	f	\N	CS	1	Diffusion Directionality	\N
9409	(0019,"SIEMENS MR HEADER",0e)	(0019,"SIEMENS MR HEADER",0e)	SIEMENS MR HEADER	25	14	f	\N	FD	3	Diffusion Gradient Direction	\N
9410	(0019,"SIEMENS MR HEADER",0f)	(0019,"SIEMENS MR HEADER",0f)	SIEMENS MR HEADER	25	15	f	\N	SH	1	Gradient Mode	\N
9411	(0019,"SIEMENS MR HEADER",11)	(0019,"SIEMENS MR HEADER",11)	SIEMENS MR HEADER	25	17	f	\N	SH	1	Flow Compensation	\N
9412	(0019,"SIEMENS MR HEADER",12)	(0019,"SIEMENS MR HEADER",12)	SIEMENS MR HEADER	25	18	f	\N	SL	3	Table Position Origin	\N
9413	(0019,"SIEMENS MR HEADER",13)	(0019,"SIEMENS MR HEADER",13)	SIEMENS MR HEADER	25	19	f	\N	SL	3	Ima Abs Table Position	\N
9414	(0019,"SIEMENS MR HEADER",14)	(0019,"SIEMENS MR HEADER",14)	SIEMENS MR HEADER	25	20	f	\N	IS	3	Ima Rel Table Position	\N
9415	(0019,"SIEMENS MR HEADER",15)	(0019,"SIEMENS MR HEADER",15)	SIEMENS MR HEADER	25	21	f	\N	FD	3	Slice Position PCS	\N
9416	(0019,"SIEMENS MR HEADER",16)	(0019,"SIEMENS MR HEADER",16)	SIEMENS MR HEADER	25	22	f	\N	DS	1	Time After Start	\N
9417	(0019,"SIEMENS MR HEADER",17)	(0019,"SIEMENS MR HEADER",17)	SIEMENS MR HEADER	25	23	f	\N	DS	1	Slice Resolution	\N
9418	(0019,"SIEMENS MR HEADER",18)	(0019,"SIEMENS MR HEADER",18)	SIEMENS MR HEADER	25	24	f	\N	IS	1	Real Dwell Time	\N
9419	(0019,"SIEMENS MR HEADER",23)	(0019,"SIEMENS MR HEADER",23)	SIEMENS MR HEADER	25	35	f	\N	IS	1	Unknown	\N
9420	(0019,"SIEMENS MR HEADER",25)	(0019,"SIEMENS MR HEADER",25)	SIEMENS MR HEADER	25	37	f	\N	FD	1-n	Unknown	\N
9421	(0019,"SIEMENS MR HEADER",26)	(0019,"SIEMENS MR HEADER",26)	SIEMENS MR HEADER	25	38	f	\N	FD	1-n	Unknown	\N
9422	(0019,"SIEMENS MR HEADER",27)	(0019,"SIEMENS MR HEADER",27)	SIEMENS MR HEADER	25	39	f	\N	FD	6	B Matrix	\N
9423	(0019,"SIEMENS MR HEADER",28)	(0019,"SIEMENS MR HEADER",28)	SIEMENS MR HEADER	25	40	f	\N	FD	1	Bandwidth per Pixel Phase Encode	\N
9424	(0019,"SIEMENS MR HEADER",29)	(0019,"SIEMENS MR HEADER",29)	SIEMENS MR HEADER	25	41	f	\N	FD	1-n	Mosaic Ref Acq Times	\N
9425	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",01)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",01)	SIEMENS SERIES SHADOW ATTRIBUTES	33	1	f	\N	IS	1	Unknown	\N
9426	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",02)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",02)	SIEMENS SERIES SHADOW ATTRIBUTES	33	2	f	\N	DS	1-n	Unknown	\N
9427	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",03)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",03)	SIEMENS SERIES SHADOW ATTRIBUTES	33	3	f	\N	OB	1	Unknown	\N
9428	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",04)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",04)	SIEMENS SERIES SHADOW ATTRIBUTES	33	4	f	\N	DS	1	Unknown	\N
9429	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",05)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",05)	SIEMENS SERIES SHADOW ATTRIBUTES	33	5	f	\N	IS	1-n	Unknown	\N
9430	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",06)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",06)	SIEMENS SERIES SHADOW ATTRIBUTES	33	6	f	\N	LO	1	Unknown	\N
9431	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",07)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",07)	SIEMENS SERIES SHADOW ATTRIBUTES	33	7	f	\N	LO	1	Unknown	\N
9432	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",08)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",08)	SIEMENS SERIES SHADOW ATTRIBUTES	33	8	f	\N	SH	1	Unknown	\N
9433	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",09)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",09)	SIEMENS SERIES SHADOW ATTRIBUTES	33	9	f	\N	LO	1	Unknown	\N
9434	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0a)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0a)	SIEMENS SERIES SHADOW ATTRIBUTES	33	10	f	\N	DS	1	Unknown	\N
9435	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0c)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0c)	SIEMENS SERIES SHADOW ATTRIBUTES	33	12	f	\N	SH	1	Unknown	\N
9436	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0d)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0d)	SIEMENS SERIES SHADOW ATTRIBUTES	33	13	f	\N	US	1	Unknown	\N
9437	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0f)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",0f)	SIEMENS SERIES SHADOW ATTRIBUTES	33	15	f	\N	DS	1-n	Unknown	\N
9438	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",10)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",10)	SIEMENS SERIES SHADOW ATTRIBUTES	33	16	f	\N	IS	1	Unknown	\N
9439	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",11)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",11)	SIEMENS SERIES SHADOW ATTRIBUTES	33	17	f	\N	DS	1	Unknown	\N
9440	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",12)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",12)	SIEMENS SERIES SHADOW ATTRIBUTES	33	18	f	\N	FD	1	Unknown	\N
9441	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",13)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",13)	SIEMENS SERIES SHADOW ATTRIBUTES	33	19	f	\N	DS	1	Unknown	\N
9442	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",14)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",14)	SIEMENS SERIES SHADOW ATTRIBUTES	33	20	f	\N	IS	1	Unknown	\N
9443	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",16)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",16)	SIEMENS SERIES SHADOW ATTRIBUTES	33	22	f	\N	DS	1	Unknown	\N
9444	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",17)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",17)	SIEMENS SERIES SHADOW ATTRIBUTES	33	23	f	\N	DS	1	Unknown	\N
9445	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",18)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",18)	SIEMENS SERIES SHADOW ATTRIBUTES	33	24	f	\N	SH	1	Unknown	\N
9446	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",19)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",19)	SIEMENS SERIES SHADOW ATTRIBUTES	33	25	f	\N	OB	1	Unknown	\N
9447	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1a)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1a)	SIEMENS SERIES SHADOW ATTRIBUTES	33	26	f	\N	LO	1	Unknown	\N
9448	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1b)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1b)	SIEMENS SERIES SHADOW ATTRIBUTES	33	27	f	\N	DS	1	Unknown	\N
9449	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1c)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1c)	SIEMENS SERIES SHADOW ATTRIBUTES	33	28	f	\N	DS	1-n	Unknown	\N
9450	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1d)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1d)	SIEMENS SERIES SHADOW ATTRIBUTES	33	29	f	\N	IS	1	Unknown	\N
9451	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1f)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",1f)	SIEMENS SERIES SHADOW ATTRIBUTES	33	31	f	\N	DS	1-n	Unknown	\N
9452	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",22)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",22)	SIEMENS SERIES SHADOW ATTRIBUTES	33	34	f	\N	SH	1	Unknown	\N
9453	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",23)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",23)	SIEMENS SERIES SHADOW ATTRIBUTES	33	35	f	\N	IS	1	Unknown	\N
9454	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",25)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",25)	SIEMENS SERIES SHADOW ATTRIBUTES	33	37	f	\N	SL	1-n	Unknown	\N
9455	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",26)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",26)	SIEMENS SERIES SHADOW ATTRIBUTES	33	38	f	\N	IS	1-n	Unknown	\N
9456	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",27)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",27)	SIEMENS SERIES SHADOW ATTRIBUTES	33	39	f	\N	US	1	Unknown	\N
9457	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2a)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2a)	SIEMENS SERIES SHADOW ATTRIBUTES	33	42	f	\N	IS	1-n	Unknown	\N
9458	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2b)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2b)	SIEMENS SERIES SHADOW ATTRIBUTES	33	43	f	\N	ST	1	Unknown	\N
9459	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2c)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2c)	SIEMENS SERIES SHADOW ATTRIBUTES	33	44	f	\N	DS	1-n	Unknown	\N
9460	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2d)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2d)	SIEMENS SERIES SHADOW ATTRIBUTES	33	45	f	\N	DS	1	Unknown	\N
9461	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2e)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2e)	SIEMENS SERIES SHADOW ATTRIBUTES	33	46	f	\N	IS	1	Unknown	\N
9462	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2f)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",2f)	SIEMENS SERIES SHADOW ATTRIBUTES	33	47	f	\N	DS	1-n	Unknown	\N
9463	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",30)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",30)	SIEMENS SERIES SHADOW ATTRIBUTES	33	48	f	\N	DS	1	Unknown	\N
9464	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",31)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",31)	SIEMENS SERIES SHADOW ATTRIBUTES	33	49	f	\N	IS	1	Unknown	\N
9465	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",32)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",32)	SIEMENS SERIES SHADOW ATTRIBUTES	33	50	f	\N	SS	1	Unknown	\N
9466	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",33)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",33)	SIEMENS SERIES SHADOW ATTRIBUTES	33	51	f	\N	SH	1	Unknown	\N
9467	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",34)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",34)	SIEMENS SERIES SHADOW ATTRIBUTES	33	52	f	\N	DS	1	Unknown	\N
9468	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",35)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",35)	SIEMENS SERIES SHADOW ATTRIBUTES	33	53	f	\N	DS	1	Unknown	\N
9469	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",36)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",36)	SIEMENS SERIES SHADOW ATTRIBUTES	33	54	f	\N	DS	1	Unknown	\N
9470	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",38)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",38)	SIEMENS SERIES SHADOW ATTRIBUTES	33	56	f	\N	DS	1	Unknown	\N
9471	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",3b)	(0021,"SIEMENS SERIES SHADOW ATTRIBUTES",3b)	SIEMENS SERIES SHADOW ATTRIBUTES	33	59	f	\N	DS	1	Unknown	\N
9472	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",01)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",01)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	1	f	\N	US	1	Unknown	\N
9473	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",02)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",02)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	2	f	\N	FD	1-n	Unknown	\N
9474	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",03)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",03)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	3	f	\N	DS	1	Unknown	\N
9475	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",04)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",04)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	4	f	\N	DS	1	Unknown	\N
9476	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",05)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",05)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	5	f	\N	IS	1	Unknown	\N
9477	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",06)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",06)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	6	f	\N	LO	1	Unknown	\N
9478	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1a)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1a)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	26	f	\N	SH	1	Unknown	\N
9479	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1c)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1c)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	28	f	\N	IS	1	Unknown	\N
9480	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1f)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",1f)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	31	f	\N	IS	1	Unknown	\N
9481	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",20)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",20)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	32	f	\N	DS	1	Unknown	\N
9482	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",22)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",22)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	34	f	\N	DS	1	Unknown	\N
9483	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",24)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",24)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	36	f	\N	IS	1	Unknown	\N
9484	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",25)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",25)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	37	f	\N	LT	1	Unknown	\N
9485	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",26)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",26)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	38	f	\N	IS	1	Unknown	\N
9486	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",27)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",27)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	39	f	\N	DS	1	Unknown	\N
9487	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2a)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2a)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	42	f	\N	DS	1	Unknown	\N
9488	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2b)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2b)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	43	f	\N	DS	1	Unknown	\N
9489	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2c)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2c)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	44	f	\N	DS	1	Unknown	\N
9490	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2d)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2d)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	45	f	\N	DS	1	Unknown	\N
9491	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2e)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",2e)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	46	f	\N	UL	1	Unknown	\N
9492	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",33)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",33)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	51	f	\N	IS	1	Unknown	\N
9493	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",34)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",34)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	52	f	\N	FD	1	Unknown	\N
9494	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",35)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",35)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	53	f	\N	IS	1	Unknown	\N
9495	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",37)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",37)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	55	f	\N	DS	1	Unknown	\N
9496	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3a)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3a)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	58	f	\N	DS	1	Unknown	\N
9497	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3b)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3b)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	59	f	\N	IS	1	Unknown	\N
9498	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3c)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3c)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	60	f	\N	FD	1-n	Unknown	\N
9499	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3d)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3d)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	61	f	\N	IS	1	Unknown	\N
9500	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3f)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",3f)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	63	f	\N	SH	1	Unknown	\N
9501	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",40)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",40)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	64	f	\N	DS	1	Unknown	\N
9502	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",41)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",41)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	65	f	\N	SH	1	Unknown	\N
9503	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",42)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",42)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	66	f	\N	IS	1	Unknown	\N
9504	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",43)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",43)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	67	f	\N	LT	1	Unknown	\N
9505	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",44)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",44)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	68	f	\N	IS	1	Unknown	\N
9506	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",45)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",45)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	69	f	\N	SL	1-n	Unknown	\N
9507	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",46)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",46)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	70	f	\N	FD	1	Unknown	\N
9508	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",47)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",47)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	71	f	\N	IS	1	Unknown	\N
9509	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",48)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",48)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	72	f	\N	IS	1	Unknown	\N
9510	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",49)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",49)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	73	f	\N	IS	1	Unknown	\N
9511	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4b)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4b)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	75	f	\N	LT	1	Unknown	\N
9512	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4e)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4e)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	78	f	\N	IS	1	Unknown	\N
9513	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4f)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",4f)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	79	f	\N	LO	1	Unknown	\N
9514	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",51)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",51)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	81	f	\N	UL	1	Unknown	\N
9515	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",52)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",52)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	82	f	\N	US	1	Unknown	\N
9516	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",53)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",53)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	83	f	\N	FD	1	Unknown	\N
9517	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",54)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",54)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	84	f	\N	US	1	Unknown	\N
9518	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",56)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",56)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	86	f	\N	LO	1	Unknown	\N
9519	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",58)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",58)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	88	f	\N	SH	1	Unknown	\N
9520	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",59)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",59)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	89	f	\N	IS	1-n	Unknown	\N
9521	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5a)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5a)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	90	f	\N	FD	1-n	Unknown	\N
9522	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5b)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5b)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	91	f	\N	FD	1-n	Unknown	\N
9523	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5e)	(0021,"SIEMENS IMAGE SHADOW ATTRIBUTES",5e)	SIEMENS IMAGE SHADOW ATTRIBUTES	33	94	f	\N	IS	1	Unknown	\N
9524	(0021,"SIEMENS MR IMA",01)	(0021,"SIEMENS MR IMA",01)	SIEMENS MR IMA	33	1	f	\N	SQ	1	MR Image Sequence	\N
9525	(0021,"SIEMENS MR N3D",30)	(0021,"SIEMENS MR N3D",30)	SIEMENS MR N3D	33	48	f	\N	SQ	1	Background Color DR Sequence	\N
9526	(0021,"SIEMENS MR N3D",31)	(0021,"SIEMENS MR N3D",31)	SIEMENS MR N3D	33	49	f	\N	DS	3	Background Color	\N
9527	(0021,"SIEMENS MR N3D",36)	(0021,"SIEMENS MR N3D",36)	SIEMENS MR N3D	33	54	f	\N	SQ	1	Field Map DR Sequence	\N
9528	(0021,"SIEMENS MR N3D",37)	(0021,"SIEMENS MR N3D",37)	SIEMENS MR N3D	33	55	f	\N	CS	1	Visible	\N
9529	(0021,"SIEMENS MR N3D",38)	(0021,"SIEMENS MR N3D",38)	SIEMENS MR N3D	33	56	f	\N	DS	3	Tinting Color	\N
9530	(0021,"SIEMENS MR N3D",39)	(0021,"SIEMENS MR N3D",39)	SIEMENS MR N3D	33	57	f	\N	CS	1	Tinting Enabled	\N
9531	(0021,"SIEMENS MR N3D",3a)	(0021,"SIEMENS MR N3D",3a)	SIEMENS MR N3D	33	58	f	\N	LO	1	Volume ID	\N
9532	(0021,"SIEMENS MR N3D",3b)	(0021,"SIEMENS MR N3D",3b)	SIEMENS MR N3D	33	59	f	\N	LO	1	Volume ID As Bound	\N
9533	(0021,"SIEMENS MR N3D",41)	(0021,"SIEMENS MR N3D",41)	SIEMENS MR N3D	33	65	f	\N	SQ	1	Floating MPR Color LUT DR Sequence	\N
9534	(0021,"SIEMENS MR N3D",42)	(0021,"SIEMENS MR N3D",42)	SIEMENS MR N3D	33	66	f	\N	DS	1	RGBA LUT	\N
9535	(0021,"SIEMENS MR N3D",43)	(0021,"SIEMENS MR N3D",43)	SIEMENS MR N3D	33	67	f	\N	DS	1	Blend Factor	\N
9536	(0021,"SIEMENS MR N3D",44)	(0021,"SIEMENS MR N3D",44)	SIEMENS MR N3D	33	68	f	\N	SQ	1	RGBA LUT Data Sequence	\N
9537	(0021,"SIEMENS MR N3D",45)	(0021,"SIEMENS MR N3D",45)	SIEMENS MR N3D	33	69	f	\N	OB	1	Color LUT	\N
9539	(0021,"SIEMENS MR N3D",4b)	(0021,"SIEMENS MR N3D",4b)	SIEMENS MR N3D	33	75	f	\N	SQ	1	VRT Color LUT DR Sequence	\N
9540	(0021,"SIEMENS MR N3D",4d)	(0021,"SIEMENS MR N3D",4d)	SIEMENS MR N3D	33	77	f	\N	SQ	1	Pwl Transfer Function Data Sequence	\N
9541	(0021,"SIEMENS MR N3D",4c)	(0021,"SIEMENS MR N3D",4c)	SIEMENS MR N3D	33	76	f	\N	SQ	1	Pwl Transfer Function Sequence	\N
9542	(0021,"SIEMENS MR N3D",4e)	(0021,"SIEMENS MR N3D",4e)	SIEMENS MR N3D	33	78	f	\N	DS	1	Pwl Vertex Index	\N
9543	(0021,"SIEMENS MR N3D",50)	(0021,"SIEMENS MR N3D",50)	SIEMENS MR N3D	33	80	f	\N	SQ	1	Pwl Vertex Sequence	\N
9544	(0021,"SIEMENS MR N3D",51)	(0021,"SIEMENS MR N3D",51)	SIEMENS MR N3D	33	81	f	\N	SQ	1	Floating MPR Render DR Sequence	\N
9545	(0021,"SIEMENS MR N3D",52)	(0021,"SIEMENS MR N3D",52)	SIEMENS MR N3D	33	82	f	\N	CS	1	Primary Show Hide	\N
9546	(0021,"SIEMENS MR N3D",56)	(0021,"SIEMENS MR N3D",56)	SIEMENS MR N3D	33	86	f	\N	CS	1	Alpha Dependent Fieldmap	\N
9547	(0021,"SIEMENS MR N3D",57)	(0021,"SIEMENS MR N3D",57)	SIEMENS MR N3D	33	87	f	\N	LO	1	Volume Filter	\N
9548	(0021,"SIEMENS MR N3D",5a)	(0021,"SIEMENS MR N3D",5a)	SIEMENS MR N3D	33	90	f	\N	SQ	1	Ortho MPR Render DR Sequence	\N
9549	(0021,"SIEMENS MR N3D",5b)	(0021,"SIEMENS MR N3D",5b)	SIEMENS MR N3D	33	91	f	\N	SQ	1	VRT Render DR Sequence	\N
9550	(0021,"SIEMENS MR N3D",53)	(0021,"SIEMENS MR N3D",53)	SIEMENS MR N3D	33	83	f	\N	CS	1	Secondary Show Hide	\N
9551	(0021,"SIEMENS MR N3D",54)	(0021,"SIEMENS MR N3D",54)	SIEMENS MR N3D	33	84	f	\N	LO	1	Primary Shading Index	\N
9552	(0021,"SIEMENS MR N3D",55)	(0021,"SIEMENS MR N3D",55)	SIEMENS MR N3D	33	85	f	\N	LO	1	Secondary Shading Index	\N
9553	(0021,"SIEMENS MR N3D",58)	(0021,"SIEMENS MR N3D",58)	SIEMENS MR N3D	33	88	f	\N	DS	3	Bounding Box Color	\N
9554	(0021,"SIEMENS MR N3D",59)	(0021,"SIEMENS MR N3D",59)	SIEMENS MR N3D	33	89	f	\N	CS	1	Scene Interaction On	\N
9555	(0021,"SIEMENS MR N3D",60)	(0021,"SIEMENS MR N3D",60)	SIEMENS MR N3D	33	96	f	\N	SQ	6	Clip Plane DR Sequence	\N
9556	(0021,"SIEMENS MR N3D",61)	(0021,"SIEMENS MR N3D",61)	SIEMENS MR N3D	33	97	f	\N	DS	3	Plane Center	\N
9557	(0021,"SIEMENS MR N3D",62)	(0021,"SIEMENS MR N3D",62)	SIEMENS MR N3D	33	98	f	\N	DS	3	Plane Normal	\N
9558	(0021,"SIEMENS MR N3D",63)	(0021,"SIEMENS MR N3D",63)	SIEMENS MR N3D	33	99	f	\N	DS	2	Plane Scale	\N
9559	(0021,"SIEMENS MR N3D",64)	(0021,"SIEMENS MR N3D",64)	SIEMENS MR N3D	33	100	f	\N	CS	1	Plane Enable GL Clip	\N
9560	(0021,"SIEMENS MR N3D",65)	(0021,"SIEMENS MR N3D",65)	SIEMENS MR N3D	33	101	f	\N	DS	1	Plane Handle Ratio	\N
9561	(0021,"SIEMENS MR N3D",66)	(0021,"SIEMENS MR N3D",66)	SIEMENS MR N3D	33	102	f	\N	DS	24	Plane Bounding Points	\N
9562	(0021,"SIEMENS MR N3D",67)	(0021,"SIEMENS MR N3D",67)	SIEMENS MR N3D	33	103	f	\N	DS	16	Plane Motion Matrix	\N
9563	(0021,"SIEMENS MR N3D",68)	(0021,"SIEMENS MR N3D",68)	SIEMENS MR N3D	33	104	f	\N	DS	1	Plane Shift Velocity	\N
9564	(0021,"SIEMENS MR N3D",69)	(0021,"SIEMENS MR N3D",69)	SIEMENS MR N3D	33	105	f	\N	CS	1	Plane Enabled	\N
9565	(0021,"SIEMENS MR N3D",6a)	(0021,"SIEMENS MR N3D",6a)	SIEMENS MR N3D	33	106	f	\N	DS	1	Plane Rotate Velocity	\N
9566	(0021,"SIEMENS MR N3D",6b)	(0021,"SIEMENS MR N3D",6b)	SIEMENS MR N3D	33	107	f	\N	CS	1	Plane Show Graphics	\N
9567	(0021,"SIEMENS MR N3D",73)	(0021,"SIEMENS MR N3D",73)	SIEMENS MR N3D	33	115	f	\N	CS	1	Plane Single Selection Mode	\N
9568	(0021,"SIEMENS MR N3D",74)	(0021,"SIEMENS MR N3D",74)	SIEMENS MR N3D	33	116	f	\N	CS	1	Plane Alignment	\N
9569	(0021,"SIEMENS MR N3D",75)	(0021,"SIEMENS MR N3D",75)	SIEMENS MR N3D	33	117	f	\N	CS	1	Plane Selected	\N
9570	(0021,"SIEMENS MR N3D",70)	(0021,"SIEMENS MR N3D",70)	SIEMENS MR N3D	33	112	f	\N	SQ	1	Split Plane DR Sequence	\N
9571	(0021,"SIEMENS MR N3D",71)	(0021,"SIEMENS MR N3D",71)	SIEMENS MR N3D	33	113	f	\N	SQ	3	Floating MPR DR Sequence	\N
9572	(0021,"SIEMENS MR N3D",6e)	(0021,"SIEMENS MR N3D",6e)	SIEMENS MR N3D	33	110	f	\N	CS	1	Plane MPR Locked	\N
9573	(0021,"SIEMENS MR N3D",6f)	(0021,"SIEMENS MR N3D",6f)	SIEMENS MR N3D	33	111	f	\N	CS	1	Plane Scaling Disabled	\N
9574	(0021,"SIEMENS MR N3D",72)	(0021,"SIEMENS MR N3D",72)	SIEMENS MR N3D	33	114	f	\N	SQ	3	Ortho MPR DR Sequence	\N
9575	(0021,"SIEMENS MR N3D",6c)	(0021,"SIEMENS MR N3D",6c)	SIEMENS MR N3D	33	108	f	\N	DS	1	Offset	\N
9576	(0021,"SIEMENS MR N3D",6d)	(0021,"SIEMENS MR N3D",6d)	SIEMENS MR N3D	33	109	f	\N	CS	1	Ortho MPR At Bounding Box	\N
9577	(0021,"SIEMENS MR N3D",76)	(0021,"SIEMENS MR N3D",76)	SIEMENS MR N3D	33	118	f	\N	SQ	1	Clustering DR Sequence	\N
9578	(0021,"SIEMENS MR N3D",77)	(0021,"SIEMENS MR N3D",77)	SIEMENS MR N3D	33	119	f	\N	DS	1	Cluster Size	\N
9579	(0021,"SIEMENS MR N3D",78)	(0021,"SIEMENS MR N3D",78)	SIEMENS MR N3D	33	120	f	\N	CS	1	Clustering Enabled	\N
9580	(0021,"SIEMENS MR N3D",79)	(0021,"SIEMENS MR N3D",79)	SIEMENS MR N3D	33	121	f	\N	LO	1	Cluster Mask Vol ID	\N
9581	(0021,"SIEMENS MR N3D",80)	(0021,"SIEMENS MR N3D",80)	SIEMENS MR N3D	33	128	f	\N	SQ	1	Head Masking DR Sequence	\N
9582	(0021,"SIEMENS MR N3D",81)	(0021,"SIEMENS MR N3D",81)	SIEMENS MR N3D	33	129	f	\N	DS	2	Masking Range	\N
9583	(0021,"SIEMENS MR N3D",82)	(0021,"SIEMENS MR N3D",82)	SIEMENS MR N3D	33	130	f	\N	CS	1	Mask Enabled	\N
9584	(0021,"SIEMENS MR N3D",83)	(0021,"SIEMENS MR N3D",83)	SIEMENS MR N3D	33	131	f	\N	SQ	1	Brain Masking DR Sequence	\N
9585	(0021,"SIEMENS MR N3D",84)	(0021,"SIEMENS MR N3D",84)	SIEMENS MR N3D	33	132	f	\N	SQ	1	Masking Status DR Sequence	\N
9586	(0021,"SIEMENS MR N3D",85)	(0021,"SIEMENS MR N3D",85)	SIEMENS MR N3D	33	133	f	\N	SQ	1	VRT Masking DR Sequence	\N
9587	(0021,"SIEMENS MR N3D",86)	(0021,"SIEMENS MR N3D",86)	SIEMENS MR N3D	33	134	f	\N	SQ	1	Ortho MPR Masking DR Sequence	\N
9588	(0021,"SIEMENS MR N3D",87)	(0021,"SIEMENS MR N3D",87)	SIEMENS MR N3D	33	135	f	\N	SQ	1	Floating MPR Masking DR Sequence	\N
9589	(0021,"SIEMENS MR N3D",88)	(0021,"SIEMENS MR N3D",88)	SIEMENS MR N3D	33	136	f	\N	SQ	1	Align DR Sequence	\N
9590	(0021,"SIEMENS MR N3D",89)	(0021,"SIEMENS MR N3D",89)	SIEMENS MR N3D	33	137	f	\N	DS	16	Registration Matrix	\N
9591	(0021,"SIEMENS MR N3D",90)	(0021,"SIEMENS MR N3D",90)	SIEMENS MR N3D	33	144	f	\N	SQ	1	Functional Evaluation DR Sequence	\N
9592	(0021,"SIEMENS MR N3D",91)	(0021,"SIEMENS MR N3D",91)	SIEMENS MR N3D	33	145	f	\N	DS	1-n	Frame Acquition Numbers	\N
9593	(0021,"SIEMENS MR N3D",92)	(0021,"SIEMENS MR N3D",92)	SIEMENS MR N3D	33	146	f	\N	CS	1	Show Cursor	\N
9594	(0021,"SIEMENS MR N3D",93)	(0021,"SIEMENS MR N3D",93)	SIEMENS MR N3D	33	147	f	\N	DS	1	Current Frame	\N
9595	(0021,"SIEMENS MR N3D",94)	(0021,"SIEMENS MR N3D",94)	SIEMENS MR N3D	33	148	f	\N	DS	1-n	Plot Area	\N
9596	(0021,"SIEMENS MR N3D",95)	(0021,"SIEMENS MR N3D",95)	SIEMENS MR N3D	33	149	f	\N	DS	2	Plot Text Position	\N
9597	(0021,"SIEMENS MR N3D",96)	(0021,"SIEMENS MR N3D",96)	SIEMENS MR N3D	33	150	f	\N	DS	1-n	Base Line Points	\N
9598	(0021,"SIEMENS MR N3D",97)	(0021,"SIEMENS MR N3D",97)	SIEMENS MR N3D	33	151	f	\N	DS	1-n	Active Points	\N
9599	(0021,"SIEMENS MR N3D",98)	(0021,"SIEMENS MR N3D",98)	SIEMENS MR N3D	33	152	f	\N	CS	1	Show Label	\N
9600	(0021,"SIEMENS MR N3D",99)	(0021,"SIEMENS MR N3D",99)	SIEMENS MR N3D	33	153	f	\N	CS	1	Mean Plot	\N
9601	(0021,"SIEMENS MR N3D",9a)	(0021,"SIEMENS MR N3D",9a)	SIEMENS MR N3D	33	154	f	\N	CS	1	Motion Plot	\N
9602	(0021,"SIEMENS MR N3D",9b)	(0021,"SIEMENS MR N3D",9b)	SIEMENS MR N3D	33	155	f	\N	CS	1	Activate Normallized Curve	\N
9603	(0021,"SIEMENS MR N3D",9c)	(0021,"SIEMENS MR N3D",9c)	SIEMENS MR N3D	33	156	f	\N	DS	1	Plot Size	\N
9604	(0021,"SIEMENS MR N3D",a0)	(0021,"SIEMENS MR N3D",a0)	SIEMENS MR N3D	33	160	f	\N	SQ	4	PlotDR Sequence	\N
9605	(0021,"SIEMENS MR N3D",a1)	(0021,"SIEMENS MR N3D",a1)	SIEMENS MR N3D	33	161	f	\N	LO	1	Title	\N
9606	(0021,"SIEMENS MR N3D",a2)	(0021,"SIEMENS MR N3D",a2)	SIEMENS MR N3D	33	162	f	\N	CS	1	Auto Scale	\N
9607	(0021,"SIEMENS MR N3D",a3)	(0021,"SIEMENS MR N3D",a3)	SIEMENS MR N3D	33	163	f	\N	DS	1	Fixed Scale	\N
9608	(0021,"SIEMENS MR N3D",a4)	(0021,"SIEMENS MR N3D",a4)	SIEMENS MR N3D	33	164	f	\N	DS	3	Background Color	\N
9609	(0021,"SIEMENS MR N3D",a5)	(0021,"SIEMENS MR N3D",a5)	SIEMENS MR N3D	33	165	f	\N	LO	1	Label X	\N
9610	(0021,"SIEMENS MR N3D",a6)	(0021,"SIEMENS MR N3D",a6)	SIEMENS MR N3D	33	166	f	\N	LO	1	Label Y	\N
9611	(0021,"SIEMENS MR N3D",a7)	(0021,"SIEMENS MR N3D",a7)	SIEMENS MR N3D	33	167	f	\N	CS	1	Legend	\N
9612	(0021,"SIEMENS MR N3D",a8)	(0021,"SIEMENS MR N3D",a8)	SIEMENS MR N3D	33	168	f	\N	CS	1	Scroll Bar X	\N
9613	(0021,"SIEMENS MR N3D",a9)	(0021,"SIEMENS MR N3D",a9)	SIEMENS MR N3D	33	169	f	\N	CS	1	Scroll Bar Y	\N
9614	(0021,"SIEMENS MR N3D",aa)	(0021,"SIEMENS MR N3D",aa)	SIEMENS MR N3D	33	170	f	\N	LO	1	Connect Scroll X	\N
9615	(0021,"SIEMENS MR N3D",ab)	(0021,"SIEMENS MR N3D",ab)	SIEMENS MR N3D	33	171	f	\N	LO	1	Plot ID	\N
9616	(0021,"SIEMENS MR N3D",ac)	(0021,"SIEMENS MR N3D",ac)	SIEMENS MR N3D	33	172	f	\N	DS	1	Plot Position	\N
9617	(0021,"SIEMENS MR N3D",b0)	(0021,"SIEMENS MR N3D",b0)	SIEMENS MR N3D	33	176	f	\N	SQ	1	Curve DR Sequence	\N
9618	(0021,"SIEMENS MR N3D",b1)	(0021,"SIEMENS MR N3D",b1)	SIEMENS MR N3D	33	177	f	\N	LO	1	Curve ID	\N
9619	(0021,"SIEMENS MR N3D",b2)	(0021,"SIEMENS MR N3D",b2)	SIEMENS MR N3D	33	178	f	\N	LO	1	Plot Type	\N
9620	(0021,"SIEMENS MR N3D",b3)	(0021,"SIEMENS MR N3D",b3)	SIEMENS MR N3D	33	179	f	\N	DS	1-n	Curve Values	\N
9621	(0021,"SIEMENS MR N3D",b4)	(0021,"SIEMENS MR N3D",b4)	SIEMENS MR N3D	33	180	f	\N	DS	3	Line Color	\N
9622	(0021,"SIEMENS MR N3D",b5)	(0021,"SIEMENS MR N3D",b5)	SIEMENS MR N3D	33	181	f	\N	DS	3	Marker Color	\N
9623	(0021,"SIEMENS MR N3D",b6)	(0021,"SIEMENS MR N3D",b6)	SIEMENS MR N3D	33	182	f	\N	CS	1	Line Filled	\N
9624	(0021,"SIEMENS MR N3D",b7)	(0021,"SIEMENS MR N3D",b7)	SIEMENS MR N3D	33	183	f	\N	LO	1	Label	\N
9625	(0021,"SIEMENS MR N3D",b8)	(0021,"SIEMENS MR N3D",b8)	SIEMENS MR N3D	33	184	f	\N	CS	1	Show Marker	\N
9626	(0021,"SIEMENS MR N3D",b9)	(0021,"SIEMENS MR N3D",b9)	SIEMENS MR N3D	33	185	f	\N	LO	1	Marker Shape	\N
9627	(0021,"SIEMENS MR N3D",ba)	(0021,"SIEMENS MR N3D",ba)	SIEMENS MR N3D	33	186	f	\N	LO	1	Smoothing Algo	\N
9628	(0021,"SIEMENS MR N3D",bb)	(0021,"SIEMENS MR N3D",bb)	SIEMENS MR N3D	33	187	f	\N	DS	1	Marker Size	\N
9629	(0021,"SIEMENS MR N3D",bc)	(0021,"SIEMENS MR N3D",bc)	SIEMENS MR N3D	33	188	f	\N	LO	1	Line Style	\N
9630	(0021,"SIEMENS MR N3D",bd)	(0021,"SIEMENS MR N3D",bd)	SIEMENS MR N3D	33	189	f	\N	LO	1	Line Pattern	\N
9631	(0021,"SIEMENS MR N3D",be)	(0021,"SIEMENS MR N3D",be)	SIEMENS MR N3D	33	190	f	\N	DS	1	Line Width	\N
9632	(0021,"SIEMENS MR N3D",c0)	(0021,"SIEMENS MR N3D",c0)	SIEMENS MR N3D	33	192	f	\N	SQ	1	VRT Filter DR Sequence	\N
9633	(0021,"SIEMENS MR N3D",c1)	(0021,"SIEMENS MR N3D",c1)	SIEMENS MR N3D	33	193	f	\N	LO	1	Filter Type	\N
9634	(0021,"SIEMENS MR N3D",c2)	(0021,"SIEMENS MR N3D",c2)	SIEMENS MR N3D	33	194	f	\N	CS	1	Current Active Plane	\N
9635	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",01)	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",01)	SIEMENS MR PHOENIX ATTRIBUTES	33	1	f	\N	UL	1	Mds Mode Mask	\N
9636	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",02)	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",02)	SIEMENS MR PHOENIX ATTRIBUTES	33	2	f	\N	US	1	Dixon	\N
9637	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",03)	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",03)	SIEMENS MR PHOENIX ATTRIBUTES	33	3	f	\N	LT	1	Sequence File Name	\N
9638	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",f1)	(0021,"SIEMENS MR PHOENIX ATTRIBUTES",f1)	SIEMENS MR PHOENIX ATTRIBUTES	33	241	f	\N	UL	1	Count of Pseudo Attributes	\N
9639	(0021,"SIEMENS MR SDS 01",fe)	(0021,"SIEMENS MR SDS 01",fe)	SIEMENS MR SDS 01	33	254	f	\N	SQ	1	Siemens MR SDS Sequence	\N
9640	(0021,"SIEMENS MR SDS 01",01)	(0021,"SIEMENS MR SDS 01",01)	SIEMENS MR SDS 01	33	1	f	\N	IS	1	Used Patient Weight	\N
9641	(0021,"SIEMENS MR SDS 01",02)	(0021,"SIEMENS MR SDS 01",02)	SIEMENS MR SDS 01	33	2	f	\N	DS	3	SAR Whole Body	\N
9642	(0021,"SIEMENS MR SDS 01",03)	(0021,"SIEMENS MR SDS 01",03)	SIEMENS MR SDS 01	33	3	f	\N	OB	1	MR Protocol	\N
9643	(0021,"SIEMENS MR SDS 01",04)	(0021,"SIEMENS MR SDS 01",04)	SIEMENS MR SDS 01	33	4	f	\N	DS	1	Slice Array Concatenations	\N
9644	(0021,"SIEMENS MR SDS 01",05)	(0021,"SIEMENS MR SDS 01",05)	SIEMENS MR SDS 01	33	5	f	\N	IS	3	Rel Table Position	\N
9645	(0021,"SIEMENS MR SDS 01",06)	(0021,"SIEMENS MR SDS 01",06)	SIEMENS MR SDS 01	33	6	f	\N	LO	1	Coil For Gradient	\N
9646	(0021,"SIEMENS MR SDS 01",07)	(0021,"SIEMENS MR SDS 01",07)	SIEMENS MR SDS 01	33	7	f	\N	LO	1	Long Model Name	\N
9647	(0021,"SIEMENS MR SDS 01",08)	(0021,"SIEMENS MR SDS 01",08)	SIEMENS MR SDS 01	33	8	f	\N	SH	1	Gradient Mode	\N
9648	(0021,"SIEMENS MR SDS 01",09)	(0021,"SIEMENS MR SDS 01",09)	SIEMENS MR SDS 01	33	9	f	\N	LO	1	PAT Mode Text	\N
9649	(0021,"SIEMENS MR SDS 01",0a)	(0021,"SIEMENS MR SDS 01",0a)	SIEMENS MR SDS 01	33	10	f	\N	DS	1	SW Correction Factor	\N
9650	(0021,"SIEMENS MR SDS 01",0b)	(0021,"SIEMENS MR SDS 01",0b)	SIEMENS MR SDS 01	33	11	f	\N	DS	1	RF Power Error Indicator	\N
9651	(0021,"SIEMENS MR SDS 01",0c)	(0021,"SIEMENS MR SDS 01",0c)	SIEMENS MR SDS 01	33	12	f	\N	SH	1	Positive PCS Directions	\N
9652	(0021,"SIEMENS MR SDS 01",0d)	(0021,"SIEMENS MR SDS 01",0d)	SIEMENS MR SDS 01	33	13	f	\N	US	1	Protocol Change History	\N
9653	(0021,"SIEMENS MR SDS 01",0e)	(0021,"SIEMENS MR SDS 01",0e)	SIEMENS MR SDS 01	33	14	f	\N	LO	1	Data File Name	\N
9654	(0021,"SIEMENS MR SDS 01",0f)	(0021,"SIEMENS MR SDS 01",0f)	SIEMENS MR SDS 01	33	15	f	\N	DS	3	Stimlim	\N
9655	(0021,"SIEMENS MR SDS 01",10)	(0021,"SIEMENS MR SDS 01",10)	SIEMENS MR SDS 01	33	16	f	\N	IS	1	MR Protocol Version	\N
9656	(0021,"SIEMENS MR SDS 01",11)	(0021,"SIEMENS MR SDS 01",11)	SIEMENS MR SDS 01	33	17	f	\N	DS	1	Phase Gradient Amplitude	\N
9657	(0021,"SIEMENS MR SDS 01",12)	(0021,"SIEMENS MR SDS 01",12)	SIEMENS MR SDS 01	33	18	f	\N	FD	1	Readout OS	\N
9658	(0021,"SIEMENS MR SDS 01",13)	(0021,"SIEMENS MR SDS 01",13)	SIEMENS MR SDS 01	33	19	f	\N	DS	1	tpuls max	\N
9659	(0021,"SIEMENS MR SDS 01",14)	(0021,"SIEMENS MR SDS 01",14)	SIEMENS MR SDS 01	33	20	f	\N	IS	1	Number of Prescans	\N
9660	(0021,"SIEMENS MR SDS 01",15)	(0021,"SIEMENS MR SDS 01",15)	SIEMENS MR SDS 01	33	21	f	\N	FL	1	Measurement Index	\N
9661	(0021,"SIEMENS MR SDS 01",16)	(0021,"SIEMENS MR SDS 01",16)	SIEMENS MR SDS 01	33	22	f	\N	DS	1	dBdt Threshold	\N
9662	(0021,"SIEMENS MR SDS 01",17)	(0021,"SIEMENS MR SDS 01",17)	SIEMENS MR SDS 01	33	23	f	\N	DS	1	Selection Gradient Amplitude	\N
9663	(0021,"SIEMENS MR SDS 01",18)	(0021,"SIEMENS MR SDS 01",18)	SIEMENS MR SDS 01	33	24	f	\N	SH	1	RF SWD Most Critical Aspect	\N
9664	(0021,"SIEMENS MR SDS 01",19)	(0021,"SIEMENS MR SDS 01",19)	SIEMENS MR SDS 01	33	25	f	\N	OB	1	MR Phoenix Protocol	\N
9665	(0021,"SIEMENS MR SDS 01",1a)	(0021,"SIEMENS MR SDS 01",1a)	SIEMENS MR SDS 01	33	26	f	\N	LO	1	Coil String	\N
9666	(0021,"SIEMENS MR SDS 01",1b)	(0021,"SIEMENS MR SDS 01",1b)	SIEMENS MR SDS 01	33	27	f	\N	DS	1	Slice Resolution	\N
9667	(0021,"SIEMENS MR SDS 01",1c)	(0021,"SIEMENS MR SDS 01",1c)	SIEMENS MR SDS 01	33	28	f	\N	DS	3	Stim max online	\N
9668	(0021,"SIEMENS MR SDS 01",1d)	(0021,"SIEMENS MR SDS 01",1d)	SIEMENS MR SDS 01	33	29	f	\N	IS	1	Operation Mode Flag	\N
9669	(0021,"SIEMENS MR SDS 01",1e)	(0021,"SIEMENS MR SDS 01",1e)	SIEMENS MR SDS 01	33	30	f	\N	FL	16	Auto Align Matrix	\N
9670	(0021,"SIEMENS MR SDS 01",1f)	(0021,"SIEMENS MR SDS 01",1f)	SIEMENS MR SDS 01	33	31	f	\N	DS	2	Coil Tuning Reflection	\N
9671	(0021,"SIEMENS MR SDS 01",20)	(0021,"SIEMENS MR SDS 01",20)	SIEMENS MR SDS 01	33	32	f	\N	UI	1	Representative Image	\N
9672	(0021,"SIEMENS MR SDS 01",22)	(0021,"SIEMENS MR SDS 01",22)	SIEMENS MR SDS 01	33	34	f	\N	SH	1	Sequence File Owner	\N
9673	(0021,"SIEMENS MR SDS 01",23)	(0021,"SIEMENS MR SDS 01",23)	SIEMENS MR SDS 01	33	35	f	\N	IS	1	RF Watchdog Mask	\N
9674	(0021,"SIEMENS MR SDS 01",24)	(0021,"SIEMENS MR SDS 01",24)	SIEMENS MR SDS 01	33	36	f	\N	LO	1	Post Proc Protocol	\N
9675	(0021,"SIEMENS MR SDS 01",25)	(0021,"SIEMENS MR SDS 01",25)	SIEMENS MR SDS 01	33	37	f	\N	SL	3	Table Position Origin	\N
9676	(0021,"SIEMENS MR SDS 01",26)	(0021,"SIEMENS MR SDS 01",26)	SIEMENS MR SDS 01	33	38	f	\N	IS	32	Misc Sequence Param	\N
9677	(0021,"SIEMENS MR SDS 01",27)	(0021,"SIEMENS MR SDS 01",27)	SIEMENS MR SDS 01	33	39	f	\N	US	1	Isocentered	\N
9678	(0021,"SIEMENS MR SDS 01",2a)	(0021,"SIEMENS MR SDS 01",2a)	SIEMENS MR SDS 01	33	42	f	\N	IS	1-n	Coil ID	\N
9679	(0021,"SIEMENS MR SDS 01",2b)	(0021,"SIEMENS MR SDS 01",2b)	SIEMENS MR SDS 01	33	43	f	\N	ST	1	Pat Rein Pattern	\N
9680	(0021,"SIEMENS MR SDS 01",2c)	(0021,"SIEMENS MR SDS 01",2c)	SIEMENS MR SDS 01	33	44	f	\N	DS	3	SED	\N
9681	(0021,"SIEMENS MR SDS 01",2d)	(0021,"SIEMENS MR SDS 01",2d)	SIEMENS MR SDS 01	33	45	f	\N	DS	3	SAR Most Critical Aspect	\N
9682	(0021,"SIEMENS MR SDS 01",2e)	(0021,"SIEMENS MR SDS 01",2e)	SIEMENS MR SDS 01	33	46	f	\N	IS	1	Stimm on mode	\N
9683	(0021,"SIEMENS MR SDS 01",2f)	(0021,"SIEMENS MR SDS 01",2f)	SIEMENS MR SDS 01	33	47	f	\N	DS	3	Gradient Delay Time	\N
9684	(0021,"SIEMENS MR SDS 01",30)	(0021,"SIEMENS MR SDS 01",30)	SIEMENS MR SDS 01	33	48	f	\N	DS	1	Readout Gradient Amplitude	\N
9685	(0021,"SIEMENS MR SDS 01",31)	(0021,"SIEMENS MR SDS 01",31)	SIEMENS MR SDS 01	33	49	f	\N	IS	1	Abs Table Position	\N
9686	(0021,"SIEMENS MR SDS 01",32)	(0021,"SIEMENS MR SDS 01",32)	SIEMENS MR SDS 01	33	50	f	\N	SS	1	RF SWD Operation Mode	\N
9687	(0021,"SIEMENS MR SDS 01",33)	(0021,"SIEMENS MR SDS 01",33)	SIEMENS MR SDS 01	33	51	f	\N	SH	1	Coil for Gradient2	\N
9688	(0021,"SIEMENS MR SDS 01",34)	(0021,"SIEMENS MR SDS 01",34)	SIEMENS MR SDS 01	33	52	f	\N	DS	1	Stim Factor	\N
9689	(0021,"SIEMENS MR SDS 01",35)	(0021,"SIEMENS MR SDS 01",35)	SIEMENS MR SDS 01	33	53	f	\N	DS	1	Stim max ges norm online	\N
9690	(0021,"SIEMENS MR SDS 01",36)	(0021,"SIEMENS MR SDS 01",36)	SIEMENS MR SDS 01	33	54	f	\N	DS	1	dBdt max	\N
9691	(0021,"SIEMENS MR SDS 01",38)	(0021,"SIEMENS MR SDS 01",38)	SIEMENS MR SDS 01	33	56	f	\N	DS	1	Transmitter Calibration	\N
9692	(0021,"SIEMENS MR SDS 01",39)	(0021,"SIEMENS MR SDS 01",39)	SIEMENS MR SDS 01	33	57	f	\N	OB	1	MR EVA Protocol	\N
9693	(0021,"SIEMENS MR SDS 01",3b)	(0021,"SIEMENS MR SDS 01",3b)	SIEMENS MR SDS 01	33	59	f	\N	DS	1	dBdt Limit	\N
9694	(0021,"SIEMENS MR SDS 01",3c)	(0021,"SIEMENS MR SDS 01",3c)	SIEMENS MR SDS 01	33	60	f	\N	OB	1	VF Model Info	\N
9695	(0021,"SIEMENS MR SDS 01",3d)	(0021,"SIEMENS MR SDS 01",3d)	SIEMENS MR SDS 01	33	61	f	\N	CS	1	Phase Slice Oversampling	\N
9696	(0021,"SIEMENS MR SDS 01",3e)	(0021,"SIEMENS MR SDS 01",3e)	SIEMENS MR SDS 01	33	62	f	\N	OB	1	VF Settings	\N
9697	(0021,"SIEMENS MR SDS 01",3f)	(0021,"SIEMENS MR SDS 01",3f)	SIEMENS MR SDS 01	33	63	f	\N	UT	1	Auto Align Data	\N
9698	(0021,"SIEMENS MR SDS 01",40)	(0021,"SIEMENS MR SDS 01",40)	SIEMENS MR SDS 01	33	64	f	\N	UT	1	FMRI Model Parameters	\N
9699	(0021,"SIEMENS MR SDS 01",41)	(0021,"SIEMENS MR SDS 01",41)	SIEMENS MR SDS 01	33	65	f	\N	UT	1	FMRI Model Info	\N
9700	(0021,"SIEMENS MR SDS 01",42)	(0021,"SIEMENS MR SDS 01",42)	SIEMENS MR SDS 01	33	66	f	\N	UT	1	FMRI External Parameters	\N
9701	(0021,"SIEMENS MR SDS 01",43)	(0021,"SIEMENS MR SDS 01",43)	SIEMENS MR SDS 01	33	67	f	\N	UT	1	FMRI External Info	\N
9702	(0021,"SIEMENS MR SDS 01",44)	(0021,"SIEMENS MR SDS 01",44)	SIEMENS MR SDS 01	33	68	f	\N	DS	2	B1 RMS	\N
9703	(0021,"SIEMENS MR SDS 01",45)	(0021,"SIEMENS MR SDS 01",45)	SIEMENS MR SDS 01	33	69	f	\N	CS	1	B1 RMS Supervision	\N
9704	(0021,"SIEMENS MR SDS 01",46)	(0021,"SIEMENS MR SDS 01",46)	SIEMENS MR SDS 01	33	70	f	\N	DS	1	Tales Reference Power	\N
9705	(0021,"SIEMENS MR SDS 01",47)	(0021,"SIEMENS MR SDS 01",47)	SIEMENS MR SDS 01	33	71	f	\N	CS	1	Safety Standard	\N
9706	(0021,"SIEMENS MR SDS 01",48)	(0021,"SIEMENS MR SDS 01",48)	SIEMENS MR SDS 01	33	72	f	\N	CS	1	DICOM Image Flavor	\N
9707	(0021,"SIEMENS MR SDS 01",49)	(0021,"SIEMENS MR SDS 01",49)	SIEMENS MR SDS 01	33	73	f	\N	CS	1	DICOM Acquisition Contrast	\N
9708	(0021,"SIEMENS MR SDS 01",50)	(0021,"SIEMENS MR SDS 01",50)	SIEMENS MR SDS 01	33	80	f	\N	US	1	RF Echo Train Length 4MF	\N
9709	(0021,"SIEMENS MR SDS 01",51)	(0021,"SIEMENS MR SDS 01",51)	SIEMENS MR SDS 01	33	81	f	\N	US	1	Gradient Echo Train Length 4MF	\N
9710	(0021,"SIEMENS MR SDS 01",52)	(0021,"SIEMENS MR SDS 01",52)	SIEMENS MR SDS 01	33	82	f	\N	LO	1	Version Info	\N
9711	(0021,"SIEMENS MR SDS 01",53)	(0021,"SIEMENS MR SDS 01",53)	SIEMENS MR SDS 01	33	83	f	\N	CS	1	Laterality 4MF	\N
9712	(0021,"SIEMENS MR MRS 05",01)	(0021,"SIEMENS MR MRS 05",01)	SIEMENS MR MRS 05	33	1	f	\N	FD	1	Transmitter Reference Amplitude	\N
9713	(0021,"SIEMENS MR MRS 05",02)	(0021,"SIEMENS MR MRS 05",02)	SIEMENS MR MRS 05	33	2	f	\N	US	1	Hamming Filter Width	\N
9714	(0021,"SIEMENS MR MRS 05",03)	(0021,"SIEMENS MR MRS 05",03)	SIEMENS MR MRS 05	33	3	f	\N	FD	3	CSI Gridshift Vector	\N
9715	(0021,"SIEMENS MR MRS 05",04)	(0021,"SIEMENS MR MRS 05",04)	SIEMENS MR MRS 05	33	4	f	\N	FD	1	Mixing Time	\N
9716	(0021,"SIEMENS MR MRS 05",40)	(0021,"SIEMENS MR MRS 05",40)	SIEMENS MR MRS 05	33	64	f	\N	CS	1	Series Protocol Instance	\N
9717	(0021,"SIEMENS MR MRS 05",41)	(0021,"SIEMENS MR MRS 05",41)	SIEMENS MR MRS 05	33	65	f	\N	CS	1	Spectro Result Type	\N
9718	(0021,"SIEMENS MR MRS 05",42)	(0021,"SIEMENS MR MRS 05",42)	SIEMENS MR MRS 05	33	66	f	\N	CS	1	Spectro Result Extend Type	\N
9719	(0021,"SIEMENS MR MRS 05",43)	(0021,"SIEMENS MR MRS 05",43)	SIEMENS MR MRS 05	33	67	f	\N	CS	1	Post Proc Protocol	\N
9720	(0021,"SIEMENS MR MRS 05",44)	(0021,"SIEMENS MR MRS 05",44)	SIEMENS MR MRS 05	33	68	f	\N	CS	1	Rescan Level	\N
9721	(0021,"SIEMENS MR MRS 05",45)	(0021,"SIEMENS MR MRS 05",45)	SIEMENS MR MRS 05	33	69	f	\N	OF	1	Spectro Algo Result	\N
9722	(0021,"SIEMENS MR MRS 05",46)	(0021,"SIEMENS MR MRS 05",46)	SIEMENS MR MRS 05	33	70	f	\N	OF	1	Spectro Display Params	\N
9723	(0021,"SIEMENS MR MRS 05",47)	(0021,"SIEMENS MR MRS 05",47)	SIEMENS MR MRS 05	33	71	f	\N	IS	1	Voxel Number	\N
9724	(0021,"SIEMENS MR MRS 05",48)	(0021,"SIEMENS MR MRS 05",48)	SIEMENS MR MRS 05	33	72	f	\N	SQ	1	APR Sequence	\N
9725	(0021,"SIEMENS MR MRS 05",49)	(0021,"SIEMENS MR MRS 05",49)	SIEMENS MR MRS 05	33	73	f	\N	CS	1	Sync Data	\N
9726	(0021,"SIEMENS MR MRS 05",4a)	(0021,"SIEMENS MR MRS 05",4a)	SIEMENS MR MRS 05	33	74	f	\N	CS	1	Post Proc Detailed Protocol	\N
9727	(0021,"SIEMENS MR MRS 05",4b)	(0021,"SIEMENS MR MRS 05",4b)	SIEMENS MR MRS 05	33	75	f	\N	CS	1	Spectro Result Extend Type Detailed	\N
9728	(0025,"SIEMENS MR EXTRACTED CSA HEADER",01)	(0025,"SIEMENS MR EXTRACTED CSA HEADER",01)	SIEMENS MR EXTRACTED CSA HEADER	37	1	f	\N	SQ	1	Extracted MR Header Information Sequence	\N
9729	(0025,"SIEMENS MR EXTRACTED CSA HEADER",02)	(0025,"SIEMENS MR EXTRACTED CSA HEADER",02)	SIEMENS MR EXTRACTED CSA HEADER	37	2	f	\N	LO	1	Extracted MR Header Creator Identification Code	\N
9730	(0025,"SIEMENS MR EXTRACTED CSA HEADER",03)	(0025,"SIEMENS MR EXTRACTED CSA HEADER",03)	SIEMENS MR EXTRACTED CSA HEADER	37	3	f	\N	AT	1	Extracted MR Header Tag	\N
9731	(0051,"SIEMENS MR HEADER",08)	(0051,"SIEMENS MR HEADER",08)	SIEMENS MR HEADER	81	8	f	\N	CS	1	CSA Image Header Type	\N
9732	(0051,"SIEMENS MR HEADER",09)	(0051,"SIEMENS MR HEADER",09)	SIEMENS MR HEADER	81	9	f	\N	LO	1	CSA Image Header Version	\N
9733	(0051,"SIEMENS MR HEADER",0a)	(0051,"SIEMENS MR HEADER",0a)	SIEMENS MR HEADER	81	10	f	\N	LO	1	Unknown	\N
9734	(0051,"SIEMENS MR HEADER",0b)	(0051,"SIEMENS MR HEADER",0b)	SIEMENS MR HEADER	81	11	f	\N	SH	1	Acquisition Matrix Text	\N
9735	(0051,"SIEMENS MR HEADER",0c)	(0051,"SIEMENS MR HEADER",0c)	SIEMENS MR HEADER	81	12	f	\N	LO	1	Unknown	\N
9736	(0051,"SIEMENS MR HEADER",0d)	(0051,"SIEMENS MR HEADER",0d)	SIEMENS MR HEADER	81	13	f	\N	SH	1	Unknown	\N
9737	(0051,"SIEMENS MR HEADER",0e)	(0051,"SIEMENS MR HEADER",0e)	SIEMENS MR HEADER	81	14	f	\N	LO	1	Unknown	\N
9738	(0051,"SIEMENS MR HEADER",0f)	(0051,"SIEMENS MR HEADER",0f)	SIEMENS MR HEADER	81	15	f	\N	LO	1	Coil String	\N
9739	(0051,"SIEMENS MR HEADER",11)	(0051,"SIEMENS MR HEADER",11)	SIEMENS MR HEADER	81	17	f	\N	LO	1	Unknown	\N
9740	(0051,"SIEMENS MR HEADER",12)	(0051,"SIEMENS MR HEADER",12)	SIEMENS MR HEADER	81	18	f	\N	SH	1	Unknown	\N
9741	(0051,"SIEMENS MR HEADER",13)	(0051,"SIEMENS MR HEADER",13)	SIEMENS MR HEADER	81	19	f	\N	SH	1	Positive PCS Directions	\N
9742	(0051,"SIEMENS MR HEADER",15)	(0051,"SIEMENS MR HEADER",15)	SIEMENS MR HEADER	81	21	f	\N	SH	1	Unknown	\N
9743	(0051,"SIEMENS MR HEADER",16)	(0051,"SIEMENS MR HEADER",16)	SIEMENS MR HEADER	81	22	f	\N	LO	1	Unknown	\N
9744	(0051,"SIEMENS MR HEADER",17)	(0051,"SIEMENS MR HEADER",17)	SIEMENS MR HEADER	81	23	f	\N	SH	1	Unknown	\N
9745	(0051,"SIEMENS MR HEADER",18)	(0051,"SIEMENS MR HEADER",18)	SIEMENS MR HEADER	81	24	f	\N	SH	1	Unknown	\N
9746	(0051,"SIEMENS MR HEADER",19)	(0051,"SIEMENS MR HEADER",19)	SIEMENS MR HEADER	81	25	f	\N	LO	1	Unknown	\N
9747	(0021,"SIEMENS MR SDI 02",01)	(0021,"SIEMENS MR SDI 02",01)	SIEMENS MR SDI 02	33	1	f	\N	US	1	Number of Images in Mosaic	\N
9748	(0021,"SIEMENS MR SDI 02",02)	(0021,"SIEMENS MR SDI 02",02)	SIEMENS MR SDI 02	33	2	f	\N	FD	3	Slice Normal Vector	\N
9749	(0021,"SIEMENS MR SDI 02",03)	(0021,"SIEMENS MR SDI 02",03)	SIEMENS MR SDI 02	33	3	f	\N	DS	1	Slice Measurement Duration	\N
9750	(0021,"SIEMENS MR SDI 02",04)	(0021,"SIEMENS MR SDI 02",04)	SIEMENS MR SDI 02	33	4	f	\N	DS	1	Time After Start	\N
9751	(0021,"SIEMENS MR SDI 02",05)	(0021,"SIEMENS MR SDI 02",05)	SIEMENS MR SDI 02	33	5	f	\N	IS	1	B Value	\N
9752	(0021,"SIEMENS MR SDI 02",06)	(0021,"SIEMENS MR SDI 02",06)	SIEMENS MR SDI 02	33	6	f	\N	LO	1	ICE Dims	\N
9753	(0021,"SIEMENS MR SDI 02",1a)	(0021,"SIEMENS MR SDI 02",1a)	SIEMENS MR SDI 02	33	26	f	\N	SH	1	RF SWD Data Type	\N
9754	(0021,"SIEMENS MR SDI 02",1b)	(0021,"SIEMENS MR SDI 02",1b)	SIEMENS MR SDI 02	33	27	f	\N	US	1	MoCoQ Measure	\N
9755	(0021,"SIEMENS MR SDI 02",1c)	(0021,"SIEMENS MR SDI 02",1c)	SIEMENS MR SDI 02	33	28	f	\N	IS	1	Phase Encoding Direction Positive	\N
9756	(0021,"SIEMENS MR SDI 02",1d)	(0021,"SIEMENS MR SDI 02",1d)	SIEMENS MR SDI 02	33	29	f	\N	OB	1	Pixel File	\N
9757	(0021,"SIEMENS MR SDI 02",1f)	(0021,"SIEMENS MR SDI 02",1f)	SIEMENS MR SDI 02	33	31	f	\N	IS	1	FMRI Stimul Info	\N
9758	(0021,"SIEMENS MR SDI 02",20)	(0021,"SIEMENS MR SDI 02",20)	SIEMENS MR SDI 02	33	32	f	\N	DS	1	Voxel in Plane Rot	\N
9759	(0021,"SIEMENS MR SDI 02",21)	(0021,"SIEMENS MR SDI 02",21)	SIEMENS MR SDI 02	33	33	f	\N	CS	1	Diffusion Directionality 4MF	\N
9760	(0021,"SIEMENS MR SDI 02",22)	(0021,"SIEMENS MR SDI 02",22)	SIEMENS MR SDI 02	33	34	f	\N	DS	1	Voxel Thickness	\N
9761	(0021,"SIEMENS MR SDI 02",23)	(0021,"SIEMENS MR SDI 02",23)	SIEMENS MR SDI 02	33	35	f	\N	FD	6	B Matrix	\N
9762	(0021,"SIEMENS MR SDI 02",24)	(0021,"SIEMENS MR SDI 02",24)	SIEMENS MR SDI 02	33	36	f	\N	IS	1	Multistep Index	\N
9763	(0021,"SIEMENS MR SDI 02",25)	(0021,"SIEMENS MR SDI 02",25)	SIEMENS MR SDI 02	33	37	f	\N	LT	1	Comp Adjusted Param	\N
9764	(0021,"SIEMENS MR SDI 02",26)	(0021,"SIEMENS MR SDI 02",26)	SIEMENS MR SDI 02	33	38	f	\N	IS	1	Comp Algorithm	\N
9765	(0021,"SIEMENS MR SDI 02",27)	(0021,"SIEMENS MR SDI 02",27)	SIEMENS MR SDI 02	33	39	f	\N	DS	1	Voxel NormalC or	\N
9766	(0021,"SIEMENS MR SDI 02",29)	(0021,"SIEMENS MR SDI 02",29)	SIEMENS MR SDI 02	33	41	f	\N	SH	1	Flow Encoding Direction String	\N
9767	(0021,"SIEMENS MR SDI 02",2a)	(0021,"SIEMENS MR SDI 02",2a)	SIEMENS MR SDI 02	33	42	f	\N	DS	1	Voxel Normal Sag	\N
9768	(0021,"SIEMENS MR SDI 02",2b)	(0021,"SIEMENS MR SDI 02",2b)	SIEMENS MR SDI 02	33	43	f	\N	DS	1	Voxel Position Sag	\N
9769	(0021,"SIEMENS MR SDI 02",2c)	(0021,"SIEMENS MR SDI 02",2c)	SIEMENS MR SDI 02	33	44	f	\N	DS	1	Voxel Normal Tra	\N
9770	(0021,"SIEMENS MR SDI 02",2d)	(0021,"SIEMENS MR SDI 02",2d)	SIEMENS MR SDI 02	33	45	f	\N	DS	1	Voxel Position Tra	\N
9771	(0021,"SIEMENS MR SDI 02",2e)	(0021,"SIEMENS MR SDI 02",2e)	SIEMENS MR SDI 02	33	46	f	\N	UL	1	Used Channel Mask	\N
9772	(0021,"SIEMENS MR SDI 02",2f)	(0021,"SIEMENS MR SDI 02",2f)	SIEMENS MR SDI 02	33	47	f	\N	DS	1	Repetition Time Effective	\N
9773	(0021,"SIEMENS MR SDI 02",30)	(0021,"SIEMENS MR SDI 02",30)	SIEMENS MR SDI 02	33	48	f	\N	DS	6	CSI Image Orientation Patient	\N
9774	(0021,"SIEMENS MR SDI 02",32)	(0021,"SIEMENS MR SDI 02",32)	SIEMENS MR SDI 02	33	50	f	\N	DS	1	CSI Slice Location	\N
9775	(0021,"SIEMENS MR SDI 02",33)	(0021,"SIEMENS MR SDI 02",33)	SIEMENS MR SDI 02	33	51	f	\N	IS	1	Echo Column Position	\N
9776	(0021,"SIEMENS MR SDI 02",34)	(0021,"SIEMENS MR SDI 02",34)	SIEMENS MR SDI 02	33	52	f	\N	FD	1	Flow VENC	\N
9777	(0021,"SIEMENS MR SDI 02",35)	(0021,"SIEMENS MR SDI 02",35)	SIEMENS MR SDI 02	33	53	f	\N	IS	1	Measured Fourier Lines	\N
9778	(0021,"SIEMENS MR SDI 02",36)	(0021,"SIEMENS MR SDI 02",36)	SIEMENS MR SDI 02	33	54	f	\N	SH	1	LQ Algorithm	\N
9779	(0021,"SIEMENS MR SDI 02",37)	(0021,"SIEMENS MR SDI 02",37)	SIEMENS MR SDI 02	33	55	f	\N	DS	1	Voxel Position Cor	\N
9780	(0021,"SIEMENS MR SDI 02",38)	(0021,"SIEMENS MR SDI 02",38)	SIEMENS MR SDI 02	33	56	f	\N	IS	1	Filter2	\N
9781	(0021,"SIEMENS MR SDI 02",39)	(0021,"SIEMENS MR SDI 02",39)	SIEMENS MR SDI 02	33	57	f	\N	FD	1	FMRI Stimul Level	\N
9782	(0021,"SIEMENS MR SDI 02",3a)	(0021,"SIEMENS MR SDI 02",3a)	SIEMENS MR SDI 02	33	58	f	\N	DS	1	Voxel Readout FOV	\N
9783	(0021,"SIEMENS MR SDI 02",3b)	(0021,"SIEMENS MR SDI 02",3b)	SIEMENS MR SDI 02	33	59	f	\N	IS	1	Normalize Manipulated	\N
9784	(0021,"SIEMENS MR SDI 02",3c)	(0021,"SIEMENS MR SDI 02",3c)	SIEMENS MR SDI 02	33	60	f	\N	FD	3	RBMoCoRot	\N
9785	(0021,"SIEMENS MR SDI 02",3d)	(0021,"SIEMENS MR SDI 02",3d)	SIEMENS MR SDI 02	33	61	f	\N	IS	1	Comp Manual Adjusted	\N
9786	(0021,"SIEMENS MR SDI 02",3f)	(0021,"SIEMENS MR SDI 02",3f)	SIEMENS MR SDI 02	33	63	f	\N	SH	1	Spectrum Text Region Label	\N
9787	(0021,"SIEMENS MR SDI 02",40)	(0021,"SIEMENS MR SDI 02",40)	SIEMENS MR SDI 02	33	64	f	\N	DS	1	Voxel Phase FOV	\N
9788	(0021,"SIEMENS MR SDI 02",41)	(0021,"SIEMENS MR SDI 02",41)	SIEMENS MR SDI 02	33	65	f	\N	SH	1	GSWD Data Type	\N
9789	(0021,"SIEMENS MR SDI 02",42)	(0021,"SIEMENS MR SDI 02",42)	SIEMENS MR SDI 02	33	66	f	\N	IS	1	Real Dwell Time	\N
9790	(0021,"SIEMENS MR SDI 02",43)	(0021,"SIEMENS MR SDI 02",43)	SIEMENS MR SDI 02	33	67	f	\N	LT	1	Comp Job ID	\N
9791	(0021,"SIEMENS MR SDI 02",44)	(0021,"SIEMENS MR SDI 02",44)	SIEMENS MR SDI 02	33	68	f	\N	IS	1	Comp Blended	\N
9792	(0021,"SIEMENS MR SDI 02",45)	(0021,"SIEMENS MR SDI 02",45)	SIEMENS MR SDI 02	33	69	f	\N	SL	3	Ima Abs Table Position	\N
9793	(0021,"SIEMENS MR SDI 02",46)	(0021,"SIEMENS MR SDI 02",46)	SIEMENS MR SDI 02	33	70	f	\N	FD	3	Diffusion Gradient Direction	\N
9794	(0021,"SIEMENS MR SDI 02",47)	(0021,"SIEMENS MR SDI 02",47)	SIEMENS MR SDI 02	33	71	f	\N	IS	1	Flow Encoding Direction	\N
9795	(0021,"SIEMENS MR SDI 02",48)	(0021,"SIEMENS MR SDI 02",48)	SIEMENS MR SDI 02	33	72	f	\N	IS	1	Echo Partition Position	\N
9796	(0021,"SIEMENS MR SDI 02",49)	(0021,"SIEMENS MR SDI 02",49)	SIEMENS MR SDI 02	33	73	f	\N	IS	1	Echo Line Position	\N
9797	(0021,"SIEMENS MR SDI 02",4b)	(0021,"SIEMENS MR SDI 02",4b)	SIEMENS MR SDI 02	33	75	f	\N	LT	1	Comp Auto Param	\N
9798	(0021,"SIEMENS MR SDI 02",4c)	(0021,"SIEMENS MR SDI 02",4c)	SIEMENS MR SDI 02	33	76	f	\N	IS	1	Original Image Number	\N
9799	(0021,"SIEMENS MR SDI 02",4d)	(0021,"SIEMENS MR SDI 02",4d)	SIEMENS MR SDI 02	33	77	f	\N	IS	1	Original Series Number	\N
9800	(0021,"SIEMENS MR SDI 02",4e)	(0021,"SIEMENS MR SDI 02",4e)	SIEMENS MR SDI 02	33	78	f	\N	IS	1	Actual 3D Ima Part Number	\N
9801	(0021,"SIEMENS MR SDI 02",4f)	(0021,"SIEMENS MR SDI 02",4f)	SIEMENS MR SDI 02	33	79	f	\N	LO	1	Ima Coil String	\N
9802	(0021,"SIEMENS MR SDI 02",50)	(0021,"SIEMENS MR SDI 02",50)	SIEMENS MR SDI 02	33	80	f	\N	DS	2	CSI Pixel Spacing	\N
9803	(0021,"SIEMENS MR SDI 02",51)	(0021,"SIEMENS MR SDI 02",51)	SIEMENS MR SDI 02	33	81	f	\N	UL	1	Sequence Mask	\N
9804	(0021,"SIEMENS MR SDI 02",52)	(0021,"SIEMENS MR SDI 02",52)	SIEMENS MR SDI 02	33	82	f	\N	US	1	Image Group	\N
9805	(0021,"SIEMENS MR SDI 02",53)	(0021,"SIEMENS MR SDI 02",53)	SIEMENS MR SDI 02	33	83	f	\N	FD	1	Bandwidth Per Pixel Phase Encode	\N
9806	(0021,"SIEMENS MR SDI 02",54)	(0021,"SIEMENS MR SDI 02",54)	SIEMENS MR SDI 02	33	84	f	\N	US	1	Non Planar Image	\N
9807	(0021,"SIEMENS MR SDI 02",55)	(0021,"SIEMENS MR SDI 02",55)	SIEMENS MR SDI 02	33	85	f	\N	OB	1	Pixel File Name	\N
9808	(0021,"SIEMENS MR SDI 02",56)	(0021,"SIEMENS MR SDI 02",56)	SIEMENS MR SDI 02	33	86	f	\N	LO	1	Ima PAT Mode Text	\N
9809	(0021,"SIEMENS MR SDI 02",57)	(0021,"SIEMENS MR SDI 02",57)	SIEMENS MR SDI 02	33	87	f	\N	DS	3	CSI Image Position Patient	\N
9810	(0021,"SIEMENS MR SDI 02",58)	(0021,"SIEMENS MR SDI 02",58)	SIEMENS MR SDI 02	33	88	f	\N	SH	1	Acquisition Matrix Text	\N
9811	(0021,"SIEMENS MR SDI 02",59)	(0021,"SIEMENS MR SDI 02",59)	SIEMENS MR SDI 02	33	89	f	\N	IS	3	Ima Rel Table Position	\N
9812	(0021,"SIEMENS MR SDI 02",5a)	(0021,"SIEMENS MR SDI 02",5a)	SIEMENS MR SDI 02	33	90	f	\N	FD	3	RBMoCoTrans	\N
9813	(0021,"SIEMENS MR SDI 02",5b)	(0021,"SIEMENS MR SDI 02",5b)	SIEMENS MR SDI 02	33	91	f	\N	FD	3	Slice Position PCS	\N
9814	(0021,"SIEMENS MR SDI 02",5c)	(0021,"SIEMENS MR SDI 02",5c)	SIEMENS MR SDI 02	33	92	f	\N	DS	1	CSI Slice Thickness	\N
9815	(0021,"SIEMENS MR SDI 02",5e)	(0021,"SIEMENS MR SDI 02",5e)	SIEMENS MR SDI 02	33	94	f	\N	IS	1	Protocol Slice Number	\N
9816	(0021,"SIEMENS MR SDI 02",5f)	(0021,"SIEMENS MR SDI 02",5f)	SIEMENS MR SDI 02	33	95	f	\N	IS	1	Filter1	\N
9817	(0021,"SIEMENS MR SDI 02",60)	(0021,"SIEMENS MR SDI 02",60)	SIEMENS MR SDI 02	33	96	f	\N	SH	1	Transmitting Coil	\N
9818	(0021,"SIEMENS MR SDI 02",61)	(0021,"SIEMENS MR SDI 02",61)	SIEMENS MR SDI 02	33	97	f	\N	DS	1	Number of Averages N4	\N
9819	(0021,"SIEMENS MR SDI 02",62)	(0021,"SIEMENS MR SDI 02",62)	SIEMENS MR SDI 02	33	98	f	\N	FD	1-n	Mosaic Ref Acq Times	\N
9820	(0021,"SIEMENS MR SDI 02",63)	(0021,"SIEMENS MR SDI 02",63)	SIEMENS MR SDI 02	33	99	f	\N	IS	1	Auto Inline Image Filter Enabled	\N
9821	(0021,"SIEMENS MR SDI 02",65)	(0021,"SIEMENS MR SDI 02",65)	SIEMENS MR SDI 02	33	101	f	\N	FD	1-n	QC Data	\N
9822	(0021,"SIEMENS MR SDI 02",66)	(0021,"SIEMENS MR SDI 02",66)	SIEMENS MR SDI 02	33	102	f	\N	LT	1	Exam Landmarks	\N
9823	(0021,"SIEMENS MR SDI 02",67)	(0021,"SIEMENS MR SDI 02",67)	SIEMENS MR SDI 02	33	103	f	\N	ST	1	Exam Data Role	\N
9824	(0021,"SIEMENS MR SDI 02",68)	(0021,"SIEMENS MR SDI 02",68)	SIEMENS MR SDI 02	33	104	f	\N	OB	1	MR Diffusion	\N
9825	(0021,"SIEMENS MR SDI 02",69)	(0021,"SIEMENS MR SDI 02",69)	SIEMENS MR SDI 02	33	105	f	\N	OB	1	Real World Value Mapping	\N
9826	(0021,"SIEMENS MR SDI 02",70)	(0021,"SIEMENS MR SDI 02",70)	SIEMENS MR SDI 02	33	112	f	\N	OB	1	Data Set Info	\N
9827	(0021,"SIEMENS MR SDI 02",71)	(0021,"SIEMENS MR SDI 02",71)	SIEMENS MR SDI 02	33	113	f	\N	UT	1	Used Channel String	\N
9828	(0021,"SIEMENS MR SDI 02",72)	(0021,"SIEMENS MR SDI 02",72)	SIEMENS MR SDI 02	33	114	f	\N	CS	1	Phase ContrastN4	\N
9829	(0021,"SIEMENS MR SDI 02",73)	(0021,"SIEMENS MR SDI 02",73)	SIEMENS MR SDI 02	33	115	f	\N	UT	1	MR Velocity Encoding	\N
9830	(0021,"SIEMENS MR SDI 02",74)	(0021,"SIEMENS MR SDI 02",74)	SIEMENS MR SDI 02	33	116	f	\N	FD	3	Velocity Encoding Direction N4	\N
9831	(0021,"SIEMENS MR SDI 02",75)	(0021,"SIEMENS MR SDI 02",75)	SIEMENS MR SDI 02	33	117	f	\N	CS	1-n	Image Type 4MF	\N
9832	(0021,"SIEMENS MR SDI 02",76)	(0021,"SIEMENS MR SDI 02",76)	SIEMENS MR SDI 02	33	118	f	\N	LO	1-n	Image History	\N
9833	(0021,"SIEMENS MR SDI 02",77)	(0021,"SIEMENS MR SDI 02",77)	SIEMENS MR SDI 02	33	119	f	\N	LO	1	SequenceI nfo	\N
9834	(0021,"SIEMENS MR SDI 02",78)	(0021,"SIEMENS MR SDI 02",78)	SIEMENS MR SDI 02	33	120	f	\N	CS	1-n	Image Type Visible	\N
9835	(0021,"SIEMENS MR SDI 02",79)	(0021,"SIEMENS MR SDI 02",79)	SIEMENS MR SDI 02	33	121	f	\N	CS	1	Distortion Correction Type	\N
9836	(0021,"SIEMENS MR SDI 02",80)	(0021,"SIEMENS MR SDI 02",80)	SIEMENS MR SDI 02	33	128	f	\N	CS	1	Image Filter Type	\N
9837	(0021,"SIEMENS MR SDI 02",fe)	(0021,"SIEMENS MR SDI 02",fe)	SIEMENS MR SDI 02	33	254	f	\N	SQ	1	Siemens MR SDI Sequence	\N
9838	(0021,"SIEMENS MR CM 03",01)	(0021,"SIEMENS MR CM 03",01)	SIEMENS MR CM 03	33	1	f	\N	IS	1	Unknown	\N
9839	(0021,"SIEMENS MR CM 03",02)	(0021,"SIEMENS MR CM 03",02)	SIEMENS MR CM 03	33	2	f	\N	CS	1	Unknown	\N
9840	(0021,"SIEMENS MR PS 04",01)	(0021,"SIEMENS MR PS 04",01)	SIEMENS MR PS 04	33	1	f	\N	FD	1-n	Unknown	\N
9841	(0021,"SIEMENS MR FOR 06",01)	(0021,"SIEMENS MR FOR 06",01)	SIEMENS MR FOR 06	33	1	f	\N	LO	1	Unknown	\N
9842	(0029,"SIEMENS CT APPL DATASET",00)	(0029,"SIEMENS CT APPL DATASET",00)	SIEMENS CT APPL DATASET	41	0	f	\N	LT	1	Dual Energy Algorithm Parameters	\N
9843	(0029,"SIEMENS CT APPL DATASET",01)	(0029,"SIEMENS CT APPL DATASET",01)	SIEMENS CT APPL DATASET	41	1	f	\N	US	1	Valid CT Volume MBox Tasks	\N
9844	(0029,"SIEMENS CT APPL DATASET",02)	(0029,"SIEMENS CT APPL DATASET",02)	SIEMENS CT APPL DATASET	41	2	f	\N	LT	1	Scan Options	\N
9845	(0029,"SIEMENS CT APPL DATASET",03)	(0029,"SIEMENS CT APPL DATASET",03)	SIEMENS CT APPL DATASET	41	3	f	\N	ST	1	Acquisition Date and Time	\N
9846	(0029,"SIEMENS CT APPL DATASET",04)	(0029,"SIEMENS CT APPL DATASET",04)	SIEMENS CT APPL DATASET	41	4	f	\N	ST	1	Acquisition Number	\N
9847	(0029,"SIEMENS CT APPL DATASET",05)	(0029,"SIEMENS CT APPL DATASET",05)	SIEMENS CT APPL DATASET	41	5	f	\N	ST	1	Dynamic Data	\N
9848	(0029,"SIEMENS CT APPL DATASET",06)	(0029,"SIEMENS CT APPL DATASET",06)	SIEMENS CT APPL DATASET	41	6	f	\N	DS	6	Image Orientation Patient	\N
9849	(0029,"SIEMENS CT APPL DATASET",07)	(0029,"SIEMENS CT APPL DATASET",07)	SIEMENS CT APPL DATASET	41	7	f	\N	LT	1	Frame Of Reference Uid	\N
9850	(0029,"SIEMENS CT APPL DATASET",08)	(0029,"SIEMENS CT APPL DATASET",08)	SIEMENS CT APPL DATASET	41	8	f	\N	LT	1	Patient Position	\N
9851	(0029,"SIEMENS CT APPL DATASET",09)	(0029,"SIEMENS CT APPL DATASET",09)	SIEMENS CT APPL DATASET	41	9	f	\N	LT	1	Convolution Kernel	\N
9852	(0029,"SIEMENS CT APPL DATASET",10)	(0029,"SIEMENS CT APPL DATASET",10)	SIEMENS CT APPL DATASET	41	16	f	\N	LT	1	Kvp	\N
9853	(0029,"SIEMENS CT APPL DATASET",11)	(0029,"SIEMENS CT APPL DATASET",11)	SIEMENS CT APPL DATASET	41	17	f	\N	LT	1	Reconstruction Diameter	\N
9854	(0029,"SIEMENS CT APPL DATASET",12)	(0029,"SIEMENS CT APPL DATASET",12)	SIEMENS CT APPL DATASET	41	18	f	\N	LT	1	Rescale Intercept	\N
9855	(0029,"SIEMENS CT APPL DATASET",13)	(0029,"SIEMENS CT APPL DATASET",13)	SIEMENS CT APPL DATASET	41	19	f	\N	LT	1	Rescale Slope	\N
9856	(0029,"SIEMENS CT APPL DATASET",14)	(0029,"SIEMENS CT APPL DATASET",14)	SIEMENS CT APPL DATASET	41	20	f	\N	LT	1	Slice Thickness	\N
9857	(0029,"SIEMENS CT APPL DATASET",15)	(0029,"SIEMENS CT APPL DATASET",15)	SIEMENS CT APPL DATASET	41	21	f	\N	LT	1	Table Height	\N
9858	(0029,"SIEMENS CT APPL DATASET",16)	(0029,"SIEMENS CT APPL DATASET",16)	SIEMENS CT APPL DATASET	41	22	f	\N	LT	1	Gantry Detector Tilt	\N
9859	(0029,"SIEMENS CT APPL DATASET",17)	(0029,"SIEMENS CT APPL DATASET",17)	SIEMENS CT APPL DATASET	41	23	f	\N	LT	1	Pixel Spacing	\N
9860	(0029,"SIEMENS CT APPL DATASET",18)	(0029,"SIEMENS CT APPL DATASET",18)	SIEMENS CT APPL DATASET	41	24	f	\N	ST	1	Volume PatientPosition Not Equal	\N
9861	(0029,"SIEMENS CT APPL DATASET",19)	(0029,"SIEMENS CT APPL DATASET",19)	SIEMENS CT APPL DATASET	41	25	f	\N	ST	1	Volume LossyImageCompression Not Equal	\N
9862	(0029,"SIEMENS CT APPL DATASET",20)	(0029,"SIEMENS CT APPL DATASET",20)	SIEMENS CT APPL DATASET	41	32	f	\N	ST	1	Volume ConvolutionKernel Not Equal	\N
9863	(0029,"SIEMENS CT APPL DATASET",21)	(0029,"SIEMENS CT APPL DATASET",21)	SIEMENS CT APPL DATASET	41	33	f	\N	ST	1	Volume PixelSpacing Not Equal	\N
9864	(0029,"SIEMENS CT APPL DATASET",22)	(0029,"SIEMENS CT APPL DATASET",22)	SIEMENS CT APPL DATASET	41	34	f	\N	ST	1	Volume Kvp Not Equal	\N
9865	(0029,"SIEMENS CT APPL DATASET",23)	(0029,"SIEMENS CT APPL DATASET",23)	SIEMENS CT APPL DATASET	41	35	f	\N	ST	1	Volume ReconstructionDiameter Not Equal	\N
9866	(0029,"SIEMENS CT APPL DATASET",24)	(0029,"SIEMENS CT APPL DATASET",24)	SIEMENS CT APPL DATASET	41	36	f	\N	ST	1	Volume TableHeight Not Equal	\N
9867	(0029,"SIEMENS CT APPL DATASET",25)	(0029,"SIEMENS CT APPL DATASET",25)	SIEMENS CT APPL DATASET	41	37	f	\N	ST	1	Volume Has Gaps	\N
9868	(0029,"SIEMENS CT APPL DATASET",26)	(0029,"SIEMENS CT APPL DATASET",26)	SIEMENS CT APPL DATASET	41	38	f	\N	ST	1	Volume Number Of Missing Images	\N
9869	(0029,"SIEMENS CT APPL DATASET",27)	(0029,"SIEMENS CT APPL DATASET",27)	SIEMENS CT APPL DATASET	41	39	f	\N	ST	1	Volume Max Gap	\N
9870	(0029,"SIEMENS CT APPL DATASET",28)	(0029,"SIEMENS CT APPL DATASET",28)	SIEMENS CT APPL DATASET	41	40	f	\N	LT	1	Volume Position Of Gaps	\N
9871	(0029,"SIEMENS CT APPL DATASET",29)	(0029,"SIEMENS CT APPL DATASET",29)	SIEMENS CT APPL DATASET	41	41	f	\N	FD	1	Calibration Factor	\N
9872	(0029,"SIEMENS CT APPL DATASET",2a)	(0029,"SIEMENS CT APPL DATASET",2a)	SIEMENS CT APPL DATASET	41	42	f	\N	CS	1	Flash Mode	\N
9873	(0029,"SIEMENS CT APPL DATASET",2b)	(0029,"SIEMENS CT APPL DATASET",2b)	SIEMENS CT APPL DATASET	41	43	f	\N	LT	1	Warnings	\N
9874	(0029,"SIEMENS CT APPL DATASET",2c)	(0029,"SIEMENS CT APPL DATASET",2c)	SIEMENS CT APPL DATASET	41	44	f	\N	ST	1	Volume HighBit Not Equal	\N
9875	(0029,"SIEMENS CT APPL DATASET",2d)	(0029,"SIEMENS CT APPL DATASET",2d)	SIEMENS CT APPL DATASET	41	45	f	\N	ST	1	Volume ImageType Not Equal	\N
9876	(0029,"SIEMENS CT APPL DATASET",2e)	(0029,"SIEMENS CT APPL DATASET",2e)	SIEMENS CT APPL DATASET	41	46	f	\N	ST	1	ImageType 0	\N
9877	(0029,"SIEMENS CT APPL DATASET",2f)	(0029,"SIEMENS CT APPL DATASET",2f)	SIEMENS CT APPL DATASET	41	47	f	\N	ST	1	ImageType 1	\N
9878	(0029,"SIEMENS CT APPL DATASET",30)	(0029,"SIEMENS CT APPL DATASET",30)	SIEMENS CT APPL DATASET	41	48	f	\N	ST	1	ImageType 2	\N
9879	(0029,"SIEMENS CT APPL DATASET",31)	(0029,"SIEMENS CT APPL DATASET",31)	SIEMENS CT APPL DATASET	41	49	f	\N	ST	1	ImageType 3	\N
9880	(0029,"SIEMENS CT APPL DATASET",32)	(0029,"SIEMENS CT APPL DATASET",32)	SIEMENS CT APPL DATASET	41	50	f	\N	ST	1	PhotometricInterpretation not MONOCHROME2	\N
9881	(0029,"SIEMENS CT APPL DATASET",33)	(0029,"SIEMENS CT APPL DATASET",33)	SIEMENS CT APPL DATASET	41	51	f	\N	DA	1	First Acquisition Date	\N
9882	(0029,"SIEMENS CT APPL DATASET",34)	(0029,"SIEMENS CT APPL DATASET",34)	SIEMENS CT APPL DATASET	41	52	f	\N	DA	1	Last Acquisition Date	\N
9883	(0029,"SIEMENS CT APPL DATASET",35)	(0029,"SIEMENS CT APPL DATASET",35)	SIEMENS CT APPL DATASET	41	53	f	\N	TM	1	First Acquisition Time	\N
9884	(0029,"SIEMENS CT APPL DATASET",36)	(0029,"SIEMENS CT APPL DATASET",36)	SIEMENS CT APPL DATASET	41	54	f	\N	TM	1	Last Acquisition Time	\N
9885	(0029,"SIEMENS CT APPL DATASET",37)	(0029,"SIEMENS CT APPL DATASET",37)	SIEMENS CT APPL DATASET	41	55	f	\N	ST	1	Internal Data	\N
9886	(0029,"SIEMENS CT APPL DATASET",38)	(0029,"SIEMENS CT APPL DATASET",38)	SIEMENS CT APPL DATASET	41	56	f	\N	ST	1	Ranges SOM7	\N
9887	(0029,"SIEMENS CT APPL DATASET",39)	(0029,"SIEMENS CT APPL DATASET",39)	SIEMENS CT APPL DATASET	41	57	f	\N	LT	1	Calculated Gantry Detector Tilt	\N
9888	(0029,"SIEMENS CT APPL DATASET",40)	(0029,"SIEMENS CT APPL DATASET",40)	SIEMENS CT APPL DATASET	41	64	f	\N	ST	1	Volume Slice Distance	\N
9889	(0029,"SIEMENS CT APPL DATASET",41)	(0029,"SIEMENS CT APPL DATASET",41)	SIEMENS CT APPL DATASET	41	65	f	\N	DS	1	First Slice Z Coordinate 	\N
9890	(0029,"SIEMENS CT APPL DATASET",42)	(0029,"SIEMENS CT APPL DATASET",42)	SIEMENS CT APPL DATASET	41	66	f	\N	DS	1	Last Slice Z Coordinate 	\N
9891	(0029,"SIEMENS CT APPL DATASET",43)	(0029,"SIEMENS CT APPL DATASET",43)	SIEMENS CT APPL DATASET	41	67	f	\N	DS	1	Content DateTime	\N
9892	(0029,"SIEMENS CT APPL DATASET",44)	(0029,"SIEMENS CT APPL DATASET",44)	SIEMENS CT APPL DATASET	41	68	f	\N	DS	1	Delta Time	\N
9893	(0029,"SIEMENS CT APPL DATASET",45)	(0029,"SIEMENS CT APPL DATASET",45)	SIEMENS CT APPL DATASET	41	69	f	\N	DS	1	Frame Count	\N
9894	(0029,"SIEMENS CT APPL EVIDENCEDOCUMENT",00)	(0029,"SIEMENS CT APPL EVIDENCEDOCUMENT",00)	SIEMENS CT APPL EVIDENCEDOCUMENT	41	0	f	\N	UT	1	Private Task Datamodel	\N
9895	(0029,"SIEMENS CT APPL MEASUREMENT",00)	(0029,"SIEMENS CT APPL MEASUREMENT",00)	SIEMENS CT APPL MEASUREMENT	41	0	f	\N	UT	1	Oncology Segmentation Measurement Values	\N
9896	(0029,"SIEMENS CT APPL MEASUREMENT",01)	(0029,"SIEMENS CT APPL MEASUREMENT",01)	SIEMENS CT APPL MEASUREMENT	41	1	f	\N	ST	1	Oncology Measurement Recist Standard	\N
9897	(0029,"SIEMENS CT APPL MEASUREMENT",10)	(0029,"SIEMENS CT APPL MEASUREMENT",10)	SIEMENS CT APPL MEASUREMENT	41	16	f	\N	CS	1	DualEnergy ROI Annotation Mode	\N
9898	(0029,"SIEMENS CT APPL PRESENTATION",00)	(0029,"SIEMENS CT APPL PRESENTATION",00)	SIEMENS CT APPL PRESENTATION	41	0	f	\N	US	1	Translucent Mode	\N
9899	(0029,"SIEMENS CT APPL PRESENTATION",01)	(0029,"SIEMENS CT APPL PRESENTATION",01)	SIEMENS CT APPL PRESENTATION	41	1	f	\N	FD	1	Translucent Window Size	\N
9900	(0029,"SIEMENS CT APPL PRESENTATION",02)	(0029,"SIEMENS CT APPL PRESENTATION",02)	SIEMENS CT APPL PRESENTATION	41	2	f	\N	US	1	Panoramic Mode	\N
9901	(0029,"SIEMENS CT APPL PRESENTATION",03)	(0029,"SIEMENS CT APPL PRESENTATION",03)	SIEMENS CT APPL PRESENTATION	41	3	f	\N	FD	1	Panoramic Inner Width	\N
9902	(0029,"SIEMENS CT APPL PRESENTATION",04)	(0029,"SIEMENS CT APPL PRESENTATION",04)	SIEMENS CT APPL PRESENTATION	41	4	f	\N	US	1	Display Unseen Areas	\N
9903	(0029,"SIEMENS CT APPL PRESENTATION",05)	(0029,"SIEMENS CT APPL PRESENTATION",05)	SIEMENS CT APPL PRESENTATION	41	5	f	\N	US	4	Unseen Areas Color	\N
9904	(0029,"SIEMENS CT APPL PRESENTATION",06)	(0029,"SIEMENS CT APPL PRESENTATION",06)	SIEMENS CT APPL PRESENTATION	41	6	f	\N	US	1	Display Tagged Data	\N
9905	(0029,"SIEMENS CT APPL PRESENTATION",07)	(0029,"SIEMENS CT APPL PRESENTATION",07)	SIEMENS CT APPL PRESENTATION	41	7	f	\N	US	4	Tagged Color	\N
9906	(0029,"SIEMENS CT APPL PRESENTATION",08)	(0029,"SIEMENS CT APPL PRESENTATION",08)	SIEMENS CT APPL PRESENTATION	41	8	f	\N	UL	1	Tagged Sample Thickness	\N
9907	(0029,"SIEMENS CT APPL PRESENTATION",09)	(0029,"SIEMENS CT APPL PRESENTATION",09)	SIEMENS CT APPL PRESENTATION	41	9	f	\N	SL	1	Tagged Threshold	\N
9908	(0029,"SIEMENS CT APPL PRESENTATION",10)	(0029,"SIEMENS CT APPL PRESENTATION",10)	SIEMENS CT APPL PRESENTATION	41	16	f	\N	US	1	Kernel Filter	\N
9909	(0029,"SIEMENS CT APPL TMP DATAMODEL",00)	(0029,"SIEMENS CT APPL TMP DATAMODEL",00)	SIEMENS CT APPL TMP DATAMODEL	41	0	f	\N	OB	1	CT Task Common DataModel	\N
9910	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",00)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",00)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	0	f	\N	UN	1	Release Version	\N
9911	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",03)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",03)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	3	f	\N	UN	1	Volume Acquisition Duration	\N
9912	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",04)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",04)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	4	f	\N	UN	1	Volume Raw Data Type	\N
9913	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",05)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",05)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	5	f	\N	UN	1	Scan Type	\N
9914	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",06)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",06)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	6	f	\N	UN	1	Z Lateral Min	\N
9915	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",07)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",07)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	7	f	\N	UN	1	Z Lateral Span	\N
9916	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",08)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",08)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	8	f	\N	UN	1	Z Radius of Curvature	\N
9917	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",09)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",09)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	9	f	\N	UN	1	Wobble Correction	\N
9918	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",10)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",10)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	16	f	\N	UN	1	Scale Along Width	\N
9919	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",11)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",11)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	17	f	\N	UN	1	Scale Along Height	\N
9920	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",12)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",12)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	18	f	\N	UN	1	Scale Along Depth	\N
9921	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",13)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",13)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	19	f	\N	UN	1	Buffer Size	\N
9922	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",14)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",14)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	20	f	\N	UN	1	Acquisition Rate	\N
9923	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",15)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",15)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	21	f	\N	UN	1	Depth Min cm	\N
9924	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",16)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",16)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	22	f	\N	UN	1	Is Left Right Flipped Enabled	\N
9925	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",17)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",17)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	23	f	\N	UN	1	Is Up Down Flipped Enabled	\N
9926	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",18)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",18)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	24	f	\N	UN	1	Is Volume Geom Accurate	\N
9927	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",19)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",19)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	25	f	\N	UN	1	BByte Mask Offset	\N
9928	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",20)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",20)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	32	f	\N	UN	1	BByte Mask Size	\N
9929	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",22)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",22)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	34	f	\N	UN	1	Acq Plane Rotation Deg	\N
9930	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",23)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",23)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	35	f	\N	UN	1	Beam Axial Span	\N
9931	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",24)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",24)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	36	f	\N	UN	1	Beam Lateral Min	\N
9932	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",25)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",25)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	37	f	\N	UN	1	Beam Lateral Span	\N
9933	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",26)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",26)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	38	f	\N	UN	1	Beam Axial Min	\N
9934	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",27)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",27)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	39	f	\N	UN	1	Num Display Samples	\N
9935	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",28)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",28)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	40	f	\N	UN	1	DVolume Width	\N
9936	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",29)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",29)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	41	f	\N	UN	1	DVolume Depth	\N
9937	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",30)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",30)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	48	f	\N	UN	1	DVolume Height	\N
9938	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",31)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",31)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	49	f	\N	UN	1	DVolume Pos X	\N
9939	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",32)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",32)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	50	f	\N	UN	1	DVolume Pos Y	\N
9940	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",33)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",33)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	51	f	\N	UN	1	DVolume Pos Z	\N
9941	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",34)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",34)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	52	f	\N	UN	1	DBeam Axial Min	\N
9942	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",35)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",35)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	53	f	\N	UN	1	DBeam Axial Span	\N
9943	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",37)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",37)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	55	f	\N	UN	1	DBeam Lateral Span	\N
9944	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",38)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",38)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	56	f	\N	UN	1	Number of Volumes in Sequence	\N
9945	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",39)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",39)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	57	f	\N	UN	1	DByte Mask Offset	\N
9946	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",40)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",40)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	64	f	\N	UN	1	DByte Mask Size	\N
9947	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",50)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",50)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	80	f	\N	LO	1	Private Creator Version of Bookmark	\N
9948	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",51)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",51)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	81	f	\N	US	1	BCut Plane Enable	\N
9949	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",52)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",52)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	82	f	\N	US	1	BMpr Color Map Index	\N
9950	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",53)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",53)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	83	f	\N	US	1	BMpr Dynamic Range Db	\N
9951	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",54)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",54)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	84	f	\N	US	1	BMpr Gray Map Index	\N
9952	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",55)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",55)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	85	f	\N	US	1	BVolume Render Mode	\N
9953	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",56)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",56)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	86	f	\N	US	1	BVr Brightness	\N
9954	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",57)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",57)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	87	f	\N	US	1	BVr Contrast	\N
9955	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",58)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",58)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	88	f	\N	US	1	BVr Color Map Index	\N
9956	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",59)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",59)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	89	f	\N	US	1	BVr Dynamic Range Db	\N
9957	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5a)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5a)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	90	f	\N	US	1	BVr Gray Map Index	\N
9958	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5b)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5b)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	91	f	\N	US	1	BVr Gray Map Index	\N
9959	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5c)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5c)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	92	f	\N	US	1	BVr Threshold High	\N
9960	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5d)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5d)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	93	f	\N	US	1	BVr Threshold Low	\N
9961	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5e)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5e)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	94	f	\N	US	1	BPre Process Filter Mix	\N
9962	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5f)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",5f)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	95	f	\N	US	1	CCut Plane Enable	\N
9963	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",60)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",60)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	96	f	\N	US	1	CFront Clip Mode	\N
9964	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",61)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",61)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	97	f	\N	US	1	CMpr Color Map Index	\N
9965	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",62)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",62)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	98	f	\N	US	1	CMpr Color Flow Priority Index	\N
9966	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",63)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",63)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	99	f	\N	US	1	CVolume Render Mode	\N
9967	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",64)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",64)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	100	f	\N	US	1	CVr Color Map Index	\N
9968	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",65)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",65)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	101	f	\N	US	1	CVr Color Flow Priority Index	\N
9969	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",66)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",66)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	102	f	\N	US	1	CVr Opacity	\N
9970	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",67)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",67)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	103	f	\N	US	1	CVr Threshold High	\N
9971	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",68)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",68)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	104	f	\N	US	1	CVr Threshold Low	\N
9972	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",69)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",69)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	105	f	\N	US	1	Voi Mode	\N
9973	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6a)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6a)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	106	f	\N	US	1	Voi Rotation Offset Deg	\N
9974	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6b)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6b)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	107	f	\N	FD	1	Voi Size Ratio X	\N
9975	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6c)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6c)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	108	f	\N	FD	1	Voi Size Ratio Y	\N
9976	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6d)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6d)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	109	f	\N	FD	1	Voi Size Ratio Z	\N
9977	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6e)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6e)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	110	f	\N	US	1	Voi Sync Plane	\N
9978	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6f)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",6f)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	111	f	\N	US	1	Voi View Mode	\N
9979	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",70)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",70)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	112	f	\N	FD	1-n	Vr Orientation A	\N
9980	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",71)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",71)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	113	f	\N	FD	1-n	Mpr Orientation A	\N
9981	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",72)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",72)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	114	f	\N	FD	1	Vr Offset Vector	\N
9982	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",73)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",73)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	115	f	\N	FD	1	Blending Ratio	\N
9983	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",74)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",74)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	116	f	\N	US	1	Fusion Blend Mode	\N
9984	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",75)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",75)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	117	f	\N	FD	1	Quality Factor	\N
9985	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",76)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",76)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	118	f	\N	US	1	Renderer Type	\N
9986	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",77)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",77)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	119	f	\N	US	1	Slice Mode	\N
9987	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",78)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",78)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	120	f	\N	US	1	Active Quad	\N
9988	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",79)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",79)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	121	f	\N	US	1	Screen Mode	\N
9989	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7a)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7a)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	122	f	\N	US	1	Cut Plane Side	\N
9990	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7b)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7b)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	123	f	\N	US	1	Wireframe Mode	\N
9991	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7c)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7c)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	124	f	\N	US	1	Crossmark Mode	\N
9992	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7d)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7d)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	125	f	\N	US	1	Mpr Display Type	\N
9993	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7e)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7e)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	126	f	\N	US	1	Volume Display Type	\N
9994	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7f)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",7f)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	127	f	\N	US	1	Last Reset	\N
9995	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",80)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",80)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	128	f	\N	US	1	Last Non Full Screen Mode	\N
9996	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",81)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",81)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	129	f	\N	US	1	Mpr Tool Index	\N
9997	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",82)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",82)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	130	f	\N	US	1	Voi Tool Index	\N
9998	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",83)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",83)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	131	f	\N	US	1	Tool Loop Mode	\N
9999	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",84)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",84)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	132	f	\N	US	1	Volume Arb Mode	\N
10000	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",85)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",85)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	133	f	\N	US	1	Mpr Zoom Enabled	\N
10001	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",86)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",86)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	134	f	\N	US	1	Is Volume Zoom Enabled	\N
10002	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",87)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",87)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	135	f	\N	SS	1	Zoom Level Mpr	\N
10003	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",88)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",88)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	136	f	\N	SS	1	Zoom Level Volume	\N
10004	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",89)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",89)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	137	f	\N	US	1	Is Auto Rotate Enabled	\N
10005	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8a)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8a)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	138	f	\N	US	1	Auto Rotate Axis	\N
10006	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8b)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8b)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	139	f	\N	US	1	Auto Rotate Range Index	\N
10007	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8c)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8c)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	140	f	\N	US	1	Auto Rotate Speed Index	\N
10008	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8d)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8d)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	141	f	\N	US	1	CVr Brightness	\N
10009	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8e)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8e)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	142	f	\N	US	1	CFlow State Index	\N
10010	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8f)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",8f)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	143	f	\N	US	1	BSubmode Index	\N
10011	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",90)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",90)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	144	f	\N	US	1	CSubmode Index	\N
10012	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",91)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",91)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	145	f	\N	US	1	Cut Plane	\N
10013	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",92)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",92)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	146	f	\N	US	1	Bookmark Chunk Id	\N
10014	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",93)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",93)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	147	f	\N	US	1	Sequence Min Chunk Id	\N
10015	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",94)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",94)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	148	f	\N	US	1	Sequence Max Chunk Id	\N
10016	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",95)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",95)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	149	f	\N	FD	1	Volume Rate Hz	\N
10017	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9a)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9a)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	154	f	\N	FD	1	Voi Position Offset X	\N
10018	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9b)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9b)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	155	f	\N	FD	1	Voi Position Offset Y	\N
10019	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9c)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9c)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	156	f	\N	FD	1	Voi Position Offset Z	\N
10020	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9d)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9d)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	157	f	\N	US	1	Vr Tool Index	\N
10021	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9e)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9e)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	158	f	\N	US	1	Shading Percent	\N
10022	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9f)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",9f)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	159	f	\N	US	1	Volume Type	\N
10023	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",a0)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",a0)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	160	f	\N	US	1	Vr Quad Display Type	\N
10024	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",a1)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",a1)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	161	f	\N	FD	1-n	Mpr Center Location	\N
10025	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e0)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e0)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	224	f	\N	US	1	Slice Range Type	\N
10026	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e1)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e1)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	225	f	\N	US	1	Slice MPR Plane	\N
10027	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e2)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e2)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	226	f	\N	US	1	Slice Layout	\N
10028	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e3)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e3)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	227	f	\N	FD	1	Slice Spacing	\N
10029	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e4)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e4)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	228	f	\N	US	1	Thin Vr Mode	\N
10030	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e5)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e5)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	229	f	\N	US	1	Thin Vr Thickness	\N
10031	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e6)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e6)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	230	f	\N	FD	1	Curved TOP VOI Pivot X	\N
10032	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e7)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e7)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	231	f	\N	FD	1	Curved TOP VOI Pivot Y	\N
10033	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e8)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e8)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	232	f	\N	FD	1	Curved TOP VOI Pivot Z	\N
10034	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e9)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",e9)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	233	f	\N	US	1	Curved TOP VOI Quadrant	\N
10035	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ea)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ea)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	234	f	\N	US	1	Unknown	\N
10036	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ed)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ed)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	237	f	\N	US	1	Unknown	\N
10037	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ee)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ee)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	238	f	\N	US	1	Unknown	\N
10038	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ef)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",ef)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	239	f	\N	US	1	Unknown	\N
10039	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f0)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f0)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	240	f	\N	US	1-n	Unknown	\N
10040	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f1)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f1)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	241	f	\N	US	1	Unknown	\N
10041	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f2)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f2)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	242	f	\N	US	1	Unknown	\N
10042	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f3)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f3)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	243	f	\N	US	1	Unknown	\N
10043	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f4)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f4)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	244	f	\N	FD	1	Unknown	\N
10044	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f5)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f5)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	245	f	\N	LO	1	Unknown	\N
10045	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f6)	(0039,"SIEMENS MED SMS USG ANTARES 3D VOLUME",f6)	SIEMENS MED SMS USG ANTARES 3D VOLUME	57	246	f	\N	LT	1	Unknown	\N
10046	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",50)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",50)	SIEMENS MED SMS USG S2000 3D VOLUME	57	80	f	\N	LO	1	Private Creator Version of Bookmark	\N
10047	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",51)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",51)	SIEMENS MED SMS USG S2000 3D VOLUME	57	81	f	\N	US	1	BCut Plane Enable	\N
10048	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",52)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",52)	SIEMENS MED SMS USG S2000 3D VOLUME	57	82	f	\N	US	1	BMpr Color Map Index	\N
10049	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",53)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",53)	SIEMENS MED SMS USG S2000 3D VOLUME	57	83	f	\N	US	1	BMpr Dynamic Range Db	\N
10050	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",54)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",54)	SIEMENS MED SMS USG S2000 3D VOLUME	57	84	f	\N	US	1	BMpr Gray Map Index	\N
10051	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",55)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",55)	SIEMENS MED SMS USG S2000 3D VOLUME	57	85	f	\N	US	1	BVolume Render Mode	\N
10052	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",56)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",56)	SIEMENS MED SMS USG S2000 3D VOLUME	57	86	f	\N	US	1	BVr Brightness	\N
10053	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",57)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",57)	SIEMENS MED SMS USG S2000 3D VOLUME	57	87	f	\N	US	1	BVr Contrast	\N
10054	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",58)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",58)	SIEMENS MED SMS USG S2000 3D VOLUME	57	88	f	\N	US	1	BVr Color Map Index	\N
10055	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",59)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",59)	SIEMENS MED SMS USG S2000 3D VOLUME	57	89	f	\N	US	1	BVr Dynamic Range Db	\N
10056	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5a)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5a)	SIEMENS MED SMS USG S2000 3D VOLUME	57	90	f	\N	US	1	BVr Gray Map Index	\N
10057	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5b)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5b)	SIEMENS MED SMS USG S2000 3D VOLUME	57	91	f	\N	US	1	BVr Gray Map Index	\N
10058	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5c)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5c)	SIEMENS MED SMS USG S2000 3D VOLUME	57	92	f	\N	US	1	BVr Threshold High	\N
10059	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5d)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5d)	SIEMENS MED SMS USG S2000 3D VOLUME	57	93	f	\N	US	1	BVr Threshold Low	\N
10060	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5e)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5e)	SIEMENS MED SMS USG S2000 3D VOLUME	57	94	f	\N	US	1	BPre Process Filter Mix	\N
10061	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5f)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",5f)	SIEMENS MED SMS USG S2000 3D VOLUME	57	95	f	\N	US	1	CCut Plane Enable	\N
10062	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",60)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",60)	SIEMENS MED SMS USG S2000 3D VOLUME	57	96	f	\N	US	1	CFront Clip Mode	\N
10063	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",61)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",61)	SIEMENS MED SMS USG S2000 3D VOLUME	57	97	f	\N	US	1	CMpr Color Map Index	\N
10064	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",62)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",62)	SIEMENS MED SMS USG S2000 3D VOLUME	57	98	f	\N	US	1	CMpr Color Flow Priority Index	\N
10065	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",63)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",63)	SIEMENS MED SMS USG S2000 3D VOLUME	57	99	f	\N	US	1	CVolume Render Mode	\N
10066	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",64)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",64)	SIEMENS MED SMS USG S2000 3D VOLUME	57	100	f	\N	US	1	CVr Color Map Index	\N
10067	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",65)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",65)	SIEMENS MED SMS USG S2000 3D VOLUME	57	101	f	\N	US	1	CVr Color Flow Priority Index	\N
10068	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",66)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",66)	SIEMENS MED SMS USG S2000 3D VOLUME	57	102	f	\N	US	1	CVr Opacity	\N
10069	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",67)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",67)	SIEMENS MED SMS USG S2000 3D VOLUME	57	103	f	\N	US	1	CVr Threshold High	\N
10070	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",68)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",68)	SIEMENS MED SMS USG S2000 3D VOLUME	57	104	f	\N	US	1	CVr Threshold Low	\N
10071	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",69)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",69)	SIEMENS MED SMS USG S2000 3D VOLUME	57	105	f	\N	US	1	Voi Mode	\N
10072	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6a)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6a)	SIEMENS MED SMS USG S2000 3D VOLUME	57	106	f	\N	US	1	Voi Rotation Offset Deg	\N
10073	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6b)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6b)	SIEMENS MED SMS USG S2000 3D VOLUME	57	107	f	\N	FD	1	Voi Size Ratio X	\N
10074	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6c)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6c)	SIEMENS MED SMS USG S2000 3D VOLUME	57	108	f	\N	FD	1	Voi Size Ratio Y	\N
10075	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6d)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6d)	SIEMENS MED SMS USG S2000 3D VOLUME	57	109	f	\N	FD	1	Voi Size Ratio Z	\N
10076	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6e)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6e)	SIEMENS MED SMS USG S2000 3D VOLUME	57	110	f	\N	US	1	Voi Sync Plane	\N
10077	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6f)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",6f)	SIEMENS MED SMS USG S2000 3D VOLUME	57	111	f	\N	US	1	Voi View Mode	\N
10078	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",70)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",70)	SIEMENS MED SMS USG S2000 3D VOLUME	57	112	f	\N	FD	1-n	Vr Orientation A	\N
10079	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",71)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",71)	SIEMENS MED SMS USG S2000 3D VOLUME	57	113	f	\N	FD	1-n	Mpr Orientation A	\N
10080	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",72)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",72)	SIEMENS MED SMS USG S2000 3D VOLUME	57	114	f	\N	FD	1	Vr Offset Vector	\N
10081	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",73)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",73)	SIEMENS MED SMS USG S2000 3D VOLUME	57	115	f	\N	FD	1	Blending Ratio	\N
10082	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",74)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",74)	SIEMENS MED SMS USG S2000 3D VOLUME	57	116	f	\N	US	1	Fusion Blend Mode	\N
10083	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",75)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",75)	SIEMENS MED SMS USG S2000 3D VOLUME	57	117	f	\N	FD	1	Quality Factor	\N
10084	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",76)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",76)	SIEMENS MED SMS USG S2000 3D VOLUME	57	118	f	\N	US	1	Renderer Type	\N
10085	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",77)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",77)	SIEMENS MED SMS USG S2000 3D VOLUME	57	119	f	\N	US	1	Slice Mode	\N
10086	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",78)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",78)	SIEMENS MED SMS USG S2000 3D VOLUME	57	120	f	\N	US	1	Active Quad	\N
10087	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",79)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",79)	SIEMENS MED SMS USG S2000 3D VOLUME	57	121	f	\N	US	1	Screen Mode	\N
10088	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7a)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7a)	SIEMENS MED SMS USG S2000 3D VOLUME	57	122	f	\N	US	1	Cut Plane Side	\N
10089	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7b)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7b)	SIEMENS MED SMS USG S2000 3D VOLUME	57	123	f	\N	US	1	Wireframe Mode	\N
10090	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7c)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7c)	SIEMENS MED SMS USG S2000 3D VOLUME	57	124	f	\N	US	1	Crossmark Mode	\N
10091	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7d)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7d)	SIEMENS MED SMS USG S2000 3D VOLUME	57	125	f	\N	US	1	Mpr Display Type	\N
10092	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7e)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7e)	SIEMENS MED SMS USG S2000 3D VOLUME	57	126	f	\N	US	1	Volume Display Type	\N
10093	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7f)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",7f)	SIEMENS MED SMS USG S2000 3D VOLUME	57	127	f	\N	US	1	Last Reset	\N
10094	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",80)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",80)	SIEMENS MED SMS USG S2000 3D VOLUME	57	128	f	\N	US	1	Last Non Full Screen Mode	\N
10095	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",81)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",81)	SIEMENS MED SMS USG S2000 3D VOLUME	57	129	f	\N	US	1	Mpr Tool Index	\N
10096	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",82)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",82)	SIEMENS MED SMS USG S2000 3D VOLUME	57	130	f	\N	US	1	Voi Tool Index	\N
10097	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",83)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",83)	SIEMENS MED SMS USG S2000 3D VOLUME	57	131	f	\N	US	1	Tool Loop Mode	\N
10992	(0119,"MRSC",1225)	(0119,"MRSC",25)	MRSC	281	37	t	12	DS	1-n	PercentileLimits	K
10098	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",84)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",84)	SIEMENS MED SMS USG S2000 3D VOLUME	57	132	f	\N	US	1	Volume Arb Mode	\N
10099	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",85)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",85)	SIEMENS MED SMS USG S2000 3D VOLUME	57	133	f	\N	US	1	Mpr Zoom Enabled	\N
10100	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",86)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",86)	SIEMENS MED SMS USG S2000 3D VOLUME	57	134	f	\N	US	1	Is Volume Zoom Enabled	\N
10101	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",87)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",87)	SIEMENS MED SMS USG S2000 3D VOLUME	57	135	f	\N	SS	1	Zoom Level Mpr	\N
10102	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",88)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",88)	SIEMENS MED SMS USG S2000 3D VOLUME	57	136	f	\N	SS	1	Zoom Level Volume	\N
10103	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",89)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",89)	SIEMENS MED SMS USG S2000 3D VOLUME	57	137	f	\N	US	1	Is Auto Rotate Enabled	\N
10104	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8a)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8a)	SIEMENS MED SMS USG S2000 3D VOLUME	57	138	f	\N	US	1	Auto Rotate Axis	\N
10105	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8b)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8b)	SIEMENS MED SMS USG S2000 3D VOLUME	57	139	f	\N	US	1	Auto Rotate Range Index	\N
10106	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8c)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8c)	SIEMENS MED SMS USG S2000 3D VOLUME	57	140	f	\N	US	1	Auto Rotate Speed Index	\N
10107	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8d)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8d)	SIEMENS MED SMS USG S2000 3D VOLUME	57	141	f	\N	US	1	CVr Brightness	\N
10108	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8e)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8e)	SIEMENS MED SMS USG S2000 3D VOLUME	57	142	f	\N	US	1	CFlow State Index	\N
10109	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8f)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",8f)	SIEMENS MED SMS USG S2000 3D VOLUME	57	143	f	\N	US	1	BSubmode Index	\N
10110	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",90)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",90)	SIEMENS MED SMS USG S2000 3D VOLUME	57	144	f	\N	US	1	CSubmode Index	\N
10111	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",91)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",91)	SIEMENS MED SMS USG S2000 3D VOLUME	57	145	f	\N	US	1	Cut Plane	\N
10112	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",92)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",92)	SIEMENS MED SMS USG S2000 3D VOLUME	57	146	f	\N	US	1	Bookmark Chunk Id	\N
10113	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",93)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",93)	SIEMENS MED SMS USG S2000 3D VOLUME	57	147	f	\N	US	1	Sequence Min Chunk Id	\N
10114	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",94)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",94)	SIEMENS MED SMS USG S2000 3D VOLUME	57	148	f	\N	US	1	Sequence Max Chunk Id	\N
10115	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",95)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",95)	SIEMENS MED SMS USG S2000 3D VOLUME	57	149	f	\N	FD	1	Volume Rate Hz	\N
10116	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9a)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9a)	SIEMENS MED SMS USG S2000 3D VOLUME	57	154	f	\N	FD	1	Voi Position Offset X	\N
10117	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9b)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9b)	SIEMENS MED SMS USG S2000 3D VOLUME	57	155	f	\N	FD	1	Voi Position Offset Y	\N
10118	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9c)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9c)	SIEMENS MED SMS USG S2000 3D VOLUME	57	156	f	\N	FD	1	Voi Position Offset Z	\N
10119	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9d)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9d)	SIEMENS MED SMS USG S2000 3D VOLUME	57	157	f	\N	US	1	Vr Tool Index	\N
10120	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9e)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9e)	SIEMENS MED SMS USG S2000 3D VOLUME	57	158	f	\N	US	1	Shading Percent	\N
10121	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9f)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",9f)	SIEMENS MED SMS USG S2000 3D VOLUME	57	159	f	\N	US	1	Volume Type	\N
10122	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",a0)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",a0)	SIEMENS MED SMS USG S2000 3D VOLUME	57	160	f	\N	US	1	Vr Quad Display Type	\N
10123	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",a1)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",a1)	SIEMENS MED SMS USG S2000 3D VOLUME	57	161	f	\N	FD	1-n	Mpr Center Location	\N
10124	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e0)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e0)	SIEMENS MED SMS USG S2000 3D VOLUME	57	224	f	\N	US	1	Slice Range Type	\N
10125	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e1)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e1)	SIEMENS MED SMS USG S2000 3D VOLUME	57	225	f	\N	US	1	Slice MPR Plane	\N
10126	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e2)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e2)	SIEMENS MED SMS USG S2000 3D VOLUME	57	226	f	\N	US	1	Slice Layout	\N
10127	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e3)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e3)	SIEMENS MED SMS USG S2000 3D VOLUME	57	227	f	\N	FD	1	Slice Spacing	\N
10128	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e4)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e4)	SIEMENS MED SMS USG S2000 3D VOLUME	57	228	f	\N	US	1	Thin Vr Mode	\N
10129	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e5)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e5)	SIEMENS MED SMS USG S2000 3D VOLUME	57	229	f	\N	US	1	Thin Vr Thickness	\N
10130	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e6)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e6)	SIEMENS MED SMS USG S2000 3D VOLUME	57	230	f	\N	FD	1	Curved TOP VOI Pivot X	\N
10131	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e7)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e7)	SIEMENS MED SMS USG S2000 3D VOLUME	57	231	f	\N	FD	1	Curved TOP VOI Pivot Y	\N
10132	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e8)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e8)	SIEMENS MED SMS USG S2000 3D VOLUME	57	232	f	\N	FD	1	Curved TOP VOI Pivot Z	\N
10133	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e9)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",e9)	SIEMENS MED SMS USG S2000 3D VOLUME	57	233	f	\N	US	1	Curved TOP VOI Quadrant	\N
10134	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ea)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ea)	SIEMENS MED SMS USG S2000 3D VOLUME	57	234	f	\N	US	1	Unknown	\N
10135	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ed)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ed)	SIEMENS MED SMS USG S2000 3D VOLUME	57	237	f	\N	US	1	Unknown	\N
10136	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ee)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ee)	SIEMENS MED SMS USG S2000 3D VOLUME	57	238	f	\N	US	1	Unknown	\N
10137	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ef)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",ef)	SIEMENS MED SMS USG S2000 3D VOLUME	57	239	f	\N	US	1	Unknown	\N
10138	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f0)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f0)	SIEMENS MED SMS USG S2000 3D VOLUME	57	240	f	\N	US	1-n	Unknown	\N
10139	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f1)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f1)	SIEMENS MED SMS USG S2000 3D VOLUME	57	241	f	\N	US	1	Unknown	\N
10140	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f2)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f2)	SIEMENS MED SMS USG S2000 3D VOLUME	57	242	f	\N	US	1	Unknown	\N
10141	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f3)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f3)	SIEMENS MED SMS USG S2000 3D VOLUME	57	243	f	\N	US	1	Unknown	\N
10142	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f4)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f4)	SIEMENS MED SMS USG S2000 3D VOLUME	57	244	f	\N	FD	1	Unknown	\N
10143	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f5)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f5)	SIEMENS MED SMS USG S2000 3D VOLUME	57	245	f	\N	LO	1	Unknown	\N
10144	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f6)	(0039,"SIEMENS MED SMS USG S2000 3D VOLUME",f6)	SIEMENS MED SMS USG S2000 3D VOLUME	57	246	f	\N	LT	1	Unknown	\N
10145	(0039,"SIEMENS MED OCS BEAM DISPLAY INFO",76)	(0039,"SIEMENS MED OCS BEAM DISPLAY INFO",76)	SIEMENS MED OCS BEAM DISPLAY INFO	57	118	f	\N	CS	1	Beam Display Properties	\N
10146	(0039,"SIEMENS MED OCS PUBLIC RT PLAN ATTRIBUTES",01)	(0039,"SIEMENS MED OCS PUBLIC RT PLAN ATTRIBUTES",01)	SIEMENS MED OCS PUBLIC RT PLAN ATTRIBUTES	57	1	f	\N	UT	1	External Attributes	\N
10147	(0039,"SIEMENS MED OCS SS VERSION INFO",76)	(0039,"SIEMENS MED OCS SS VERSION INFO",76)	SIEMENS MED OCS SS VERSION INFO	57	118	f	\N	LO	1	Structure Set Predecessor	\N
10148	(0011,"BioPri3D",20)	(0011,"BioPri3D",20)	BioPri3D	17	32	f	\N	UL	1	Unknown	\N
10149	(0011,"BioPri3D",24)	(0011,"BioPri3D",24)	BioPri3D	17	36	f	\N	DS	1-n	Unknown	\N
10150	(0011,"BioPri3D",30)	(0011,"BioPri3D",30)	BioPri3D	17	48	f	\N	LO	1	Unknown	\N
10151	(0011,"BioPri3D",31)	(0011,"BioPri3D",31)	BioPri3D	17	49	f	\N	UL	1	Unknown	\N
10152	(0011,"BioPri3D",32)	(0011,"BioPri3D",32)	BioPri3D	17	50	f	\N	SL	1	Unknown	\N
10153	(0011,"BioPri3D",39)	(0011,"BioPri3D",39)	BioPri3D	17	57	f	\N	CS	1	Unknown	\N
10154	(0011,"BioPri3D",3a)	(0011,"BioPri3D",3a)	BioPri3D	17	58	f	\N	UL	1	Unknown	\N
10155	(0011,"BioPri3D",d0)	(0011,"BioPri3D",d0)	BioPri3D	17	208	f	\N	OB	1	Unknown	\N
10156	(0011,"BioPri3D",e0)	(0011,"BioPri3D",e0)	BioPri3D	17	224	f	\N	UL	1	Unknown	\N
10157	(0011,"BioPri3D",e1)	(0011,"BioPri3D",e1)	BioPri3D	17	225	f	\N	UL	1	Unknown	\N
10158	(0011,"BioPri3D",e2)	(0011,"BioPri3D",e2)	BioPri3D	17	226	f	\N	UL	1	Unknown	\N
10159	(0011,"BioPri3D",e3)	(0011,"BioPri3D",e3)	BioPri3D	17	227	f	\N	US	1	Unknown	\N
10160	(0011,"BioPri3D",e4)	(0011,"BioPri3D",e4)	BioPri3D	17	228	f	\N	US	1	Unknown	\N
10161	(0011,"BioPri3D",e5)	(0011,"BioPri3D",e5)	BioPri3D	17	229	f	\N	CS	1	Unknown	\N
10162	(0063,"BioPri3D",0c)	(0063,"BioPri3D",0c)	BioPri3D	99	12	f	\N	DS	1-n	Unknown	\N
10163	(0063,"BioPri3D",35)	(0063,"BioPri3D",35)	BioPri3D	99	53	f	\N	SQ	1	Unknown	\N
10164	(0063,"BioPri3D",20)	(0063,"BioPri3D",20)	BioPri3D	99	32	f	\N	US	1	Unknown	\N
10165	(0063,"BioPri3D",21)	(0063,"BioPri3D",21)	BioPri3D	99	33	f	\N	UL	1	Unknown	\N
10166	(2121,"PMI Private Calibration Module Version 2.0",01)	(2121,"PMI Private Calibration Module Version 2.0",01)	PMI Private Calibration Module Version 2.0	8481	1	f	\N	ST	1	Calibration Method	\N
10167	(2121,"PMI Private Calibration Module Version 2.0",02)	(2121,"PMI Private Calibration Module Version 2.0",02)	PMI Private Calibration Module Version 2.0	8481	2	f	\N	ST	1	Calibration Method Info	\N
10168	(2121,"PMI Private Calibration Module Version 2.0",03)	(2121,"PMI Private Calibration Module Version 2.0",03)	PMI Private Calibration Module Version 2.0	8481	3	f	\N	FL	1	Calibration Object Size	\N
10169	(2121,"PMI Private Calibration Module Version 2.0",04)	(2121,"PMI Private Calibration Module Version 2.0",04)	PMI Private Calibration Module Version 2.0	8481	4	f	\N	FL	1	Calibration Object S Dev	\N
10170	(2121,"PMI Private Calibration Module Version 2.0",05)	(2121,"PMI Private Calibration Module Version 2.0",05)	PMI Private Calibration Module Version 2.0	8481	5	f	\N	FL	1	Calibration Horizontal Pixel Spacing	\N
10171	(2121,"PMI Private Calibration Module Version 2.0",06)	(2121,"PMI Private Calibration Module Version 2.0",06)	PMI Private Calibration Module Version 2.0	8481	6	f	\N	FL	1	Calibration Vertical Pixel Spacing	\N
10172	(2121,"PMI Private Calibration Module Version 2.0",08)	(2121,"PMI Private Calibration Module Version 2.0",08)	PMI Private Calibration Module Version 2.0	8481	8	f	\N	ST	1	Calibration File Name	\N
10173	(2121,"PMI Private Calibration Module Version 2.0",09)	(2121,"PMI Private Calibration Module Version 2.0",09)	PMI Private Calibration Module Version 2.0	8481	9	f	\N	IS	1	Calibration Frame Number	\N
10174	(2121,"PMI Private Calibration Module Version 2.0",0a)	(2121,"PMI Private Calibration Module Version 2.0",0a)	PMI Private Calibration Module Version 2.0	8481	10	f	\N	SH	1	Calibration Object Unit	\N
10175	(2121,"PMI Private Calibration Module Version 2.0",0b)	(2121,"PMI Private Calibration Module Version 2.0",0b)	PMI Private Calibration Module Version 2.0	8481	11	f	\N	SS	1	Averaged Calibrations Performed	\N
10176	(2121,"PMI Private Calibration Module Version 2.0",0c)	(2121,"PMI Private Calibration Module Version 2.0",0c)	PMI Private Calibration Module Version 2.0	8481	12	f	\N	FL	1	Auto Magnify Factor	\N
10177	(2121,"PMI Private Calibration Module Version 2.0",0d)	(2121,"PMI Private Calibration Module Version 2.0",0d)	PMI Private Calibration Module Version 2.0	8481	13	f	\N	FL	1	Horizontal Pixel S Dev	\N
10178	(2121,"PMI Private Calibration Module Version 2.0",0e)	(2121,"PMI Private Calibration Module Version 2.0",0e)	PMI Private Calibration Module Version 2.0	8481	14	f	\N	FL	1	Vertical Pixel S Dev	\N
10179	(0029,"CARDIO-D.R. 1.0",ac)	(0029,"CARDIO-D.R. 1.0",ac)	CARDIO-D.R. 1.0	41	172	f	\N	FL	1	Displayed Area Bottom Right Hand Corner Fractional	\N
10180	(0029,"CARDIO-D.R. 1.0",ad)	(0029,"CARDIO-D.R. 1.0",ad)	CARDIO-D.R. 1.0	41	173	f	\N	FL	1	Displayed Area Top Left Hand Corner Fractional	\N
10181	(0009,"POLYTRON-SMS 2.5",02)	(0009,"POLYTRON-SMS 2.5",02)	POLYTRON-SMS 2.5	9	2	f	\N	OB	1	Unknown	\N
10182	(0009,"POLYTRON-SMS 2.5",04)	(0009,"POLYTRON-SMS 2.5",04)	POLYTRON-SMS 2.5	9	4	f	\N	OB	1	Unknown	\N
10183	(0009,"POLYTRON-SMS 2.5",06)	(0009,"POLYTRON-SMS 2.5",06)	POLYTRON-SMS 2.5	9	6	f	\N	OB	1	Unknown	\N
10184	(0089,"POLYTRON-SMS 2.5",10)	(0089,"POLYTRON-SMS 2.5",10)	POLYTRON-SMS 2.5	137	16	f	\N	OB	1	Unknown	\N
10185	(300b,"SIEMENS MED SYNGO RT",10)	(300b,"SIEMENS MED SYNGO RT",10)	SIEMENS MED SYNGO RT	12299	16	f	\N	CS	1	Plan Type	\N
10186	(300b,"SIEMENS MED SYNGO RT",11)	(300b,"SIEMENS MED SYNGO RT",11)	SIEMENS MED SYNGO RT	12299	17	f	\N	LT	1	Delivery Warning Dose Comment	\N
10187	(300b,"SIEMENS MED SYNGO RT",12)	(300b,"SIEMENS MED SYNGO RT",12)	SIEMENS MED SYNGO RT	12299	18	f	\N	LO	1	Imager Organ Program	\N
10188	(300b,"SIEMENS MED SYNGO RT",13)	(300b,"SIEMENS MED SYNGO RT",13)	SIEMENS MED SYNGO RT	12299	19	f	\N	DS	1	XA Image SID	\N
10189	(300b,"SIEMENS MED SYNGO RT",14)	(300b,"SIEMENS MED SYNGO RT",14)	SIEMENS MED SYNGO RT	12299	20	f	\N	DS	1	XA Image Receptor Angle	\N
10190	(300b,"SIEMENS MED SYNGO RT",15)	(300b,"SIEMENS MED SYNGO RT",15)	SIEMENS MED SYNGO RT	12299	21	f	\N	CS	1	Target Prescription Dose Type	\N
10191	(300b,"SIEMENS MED SYNGO RT",16)	(300b,"SIEMENS MED SYNGO RT",16)	SIEMENS MED SYNGO RT	12299	22	f	\N	IS	1	Referenced Target ROI Number	\N
10192	(300b,"SIEMENS MED SYNGO RT",17)	(300b,"SIEMENS MED SYNGO RT",17)	SIEMENS MED SYNGO RT	12299	23	f	\N	UT	1	RT Private Data	\N
10193	(300b,"SIEMENS MED SYNGO RT",18)	(300b,"SIEMENS MED SYNGO RT",18)	SIEMENS MED SYNGO RT	12299	24	f	\N	SQ	1	Referenced Siemens Non Image Sequence	\N
10194	(300b,"SIEMENS MED SYNGO RT",19)	(300b,"SIEMENS MED SYNGO RT",19)	SIEMENS MED SYNGO RT	12299	25	f	\N	CS	1	Verification Method	\N
10195	(300b,"SIEMENS MED SYNGO RT",20)	(300b,"SIEMENS MED SYNGO RT",20)	SIEMENS MED SYNGO RT	12299	32	f	\N	SQ	1	Alternative Treatment Machine Name Sequence	\N
10196	(300b,"SIEMENS MED SYNGO RT",24)	(300b,"SIEMENS MED SYNGO RT",24)	SIEMENS MED SYNGO RT	12299	36	f	\N	DS	1	Imager Angular Angle	\N
10197	(300b,"SIEMENS MED SYNGO RT",25)	(300b,"SIEMENS MED SYNGO RT",25)	SIEMENS MED SYNGO RT	12299	37	f	\N	DS	1	Imager Isocentric Angle	\N
10198	(300b,"SIEMENS MED SYNGO RT",26)	(300b,"SIEMENS MED SYNGO RT",26)	SIEMENS MED SYNGO RT	12299	38	f	\N	DS	1	Imager Vertical Position	\N
10199	(300b,"SIEMENS MED SYNGO RT",27)	(300b,"SIEMENS MED SYNGO RT",27)	SIEMENS MED SYNGO RT	12299	39	f	\N	DS	1	Imager Longitudinal Position	\N
10200	(300b,"SIEMENS MED SYNGO RT",28)	(300b,"SIEMENS MED SYNGO RT",28)	SIEMENS MED SYNGO RT	12299	40	f	\N	DS	1	Imager Lateral Position	\N
10201	(300b,"SIEMENS MED SYNGO RT",29)	(300b,"SIEMENS MED SYNGO RT",29)	SIEMENS MED SYNGO RT	12299	41	f	\N	CS	1	Imager Angular Rotation Direction	\N
10202	(300b,"SIEMENS MED SYNGO RT",2a)	(300b,"SIEMENS MED SYNGO RT",2a)	SIEMENS MED SYNGO RT	12299	42	f	\N	CS	1	Imager Isocentric Rotation Direction	\N
10203	(300b,"SIEMENS MED SYNGO RT",2b)	(300b,"SIEMENS MED SYNGO RT",2b)	SIEMENS MED SYNGO RT	12299	43	f	\N	DS	1	Requested Scanning Spot Size	\N
10204	(300b,"SIEMENS MED SYNGO RT",2c)	(300b,"SIEMENS MED SYNGO RT",2c)	SIEMENS MED SYNGO RT	12299	44	f	\N	DS	1	Imager Orbital Angle	\N
10205	(300b,"SIEMENS MED SYNGO RT",2e)	(300b,"SIEMENS MED SYNGO RT",2e)	SIEMENS MED SYNGO RT	12299	46	f	\N	CS	1	Imaging Technique	\N
10206	(300b,"SIEMENS MED SYNGO RT",2f)	(300b,"SIEMENS MED SYNGO RT",2f)	SIEMENS MED SYNGO RT	12299	47	f	\N	CS	1	Imager Orbital Rotation Direction	\N
10207	(300b,"SIEMENS MED SYNGO RT",30)	(300b,"SIEMENS MED SYNGO RT",30)	SIEMENS MED SYNGO RT	12299	48	f	\N	LO	1	Patient Barcode	\N
10208	(300b,"SIEMENS MED SYNGO RT",31)	(300b,"SIEMENS MED SYNGO RT",31)	SIEMENS MED SYNGO RT	12299	49	f	\N	SH	3	Beam Modifier Type	\N
10209	(300b,"SIEMENS MED SYNGO RT",32)	(300b,"SIEMENS MED SYNGO RT",32)	SIEMENS MED SYNGO RT	12299	50	f	\N	FL	3	Source to Range Shifter Distance	\N
10210	(300b,"SIEMENS MED SYNGO RT",33)	(300b,"SIEMENS MED SYNGO RT",33)	SIEMENS MED SYNGO RT	12299	51	f	\N	SH	3	Treatment Room Name	\N
10211	(300b,"SIEMENS MED SYNGO RT",60)	(300b,"SIEMENS MED SYNGO RT",60)	SIEMENS MED SYNGO RT	12299	96	f	\N	IS	1-n	Ordered Referenced Beam Numbers	\N
10212	(300b,"SIEMENS MED SYNGO RT",66)	(300b,"SIEMENS MED SYNGO RT",66)	SIEMENS MED SYNGO RT	12299	102	f	\N	LT	1	Fraction Delivery Notes	\N
10213	(300b,"SIEMENS MED SYNGO RT",67)	(300b,"SIEMENS MED SYNGO RT",67)	SIEMENS MED SYNGO RT	12299	103	f	\N	LO	1	Record ID	\N
10214	(300b,"SIEMENS MED SYNGO RT",76)	(300b,"SIEMENS MED SYNGO RT",76)	SIEMENS MED SYNGO RT	12299	118	f	\N	CS	1	Fraction Group Code	\N
10215	(300b,"SIEMENS MED SYNGO RT",77)	(300b,"SIEMENS MED SYNGO RT",77)	SIEMENS MED SYNGO RT	12299	119	f	\N	IS	1	Referenced Treatment Beam Number	\N
10216	(300b,"SIEMENS MED SYNGO RT",78)	(300b,"SIEMENS MED SYNGO RT",78)	SIEMENS MED SYNGO RT	12299	120	f	\N	DS	1	Fraction Dose to Dose Reference	\N
10217	(300b,"SIEMENS MED SYNGO RT",80)	(300b,"SIEMENS MED SYNGO RT",80)	SIEMENS MED SYNGO RT	12299	128	f	\N	SQ	1	Referenced Target ROI Sequence	\N
10218	(300b,"SIEMENS MED SYNGO RT",82)	(300b,"SIEMENS MED SYNGO RT",82)	SIEMENS MED SYNGO RT	12299	130	f	\N	DS	1	Target ROI Lateral Expansion Margin	\N
10219	(300b,"SIEMENS MED SYNGO RT",83)	(300b,"SIEMENS MED SYNGO RT",83)	SIEMENS MED SYNGO RT	12299	131	f	\N	DS	1	Target ROI Distal Expansion Margin	\N
10220	(300b,"SIEMENS MED SYNGO RT",84)	(300b,"SIEMENS MED SYNGO RT",84)	SIEMENS MED SYNGO RT	12299	132	f	\N	DS	1	Target ROI Proximal Expansion Margin	\N
10221	(300b,"SIEMENS MED SYNGO RT",85)	(300b,"SIEMENS MED SYNGO RT",85)	SIEMENS MED SYNGO RT	12299	133	f	\N	DS	2	Scan Grid Lateral Distance	\N
10222	(300b,"SIEMENS MED SYNGO RT",86)	(300b,"SIEMENS MED SYNGO RT",86)	SIEMENS MED SYNGO RT	12299	134	f	\N	DS	1	Scan Grid Longitudinal Distance	\N
10223	(300b,"SIEMENS MED SYNGO RT",87)	(300b,"SIEMENS MED SYNGO RT",87)	SIEMENS MED SYNGO RT	12299	135	f	\N	DS	1	Beam Weight	\N
10224	(300b,"SIEMENS MED SYNGO RT",89)	(300b,"SIEMENS MED SYNGO RT",89)	SIEMENS MED SYNGO RT	12299	137	f	\N	DS	3	Point on Plane	\N
10225	(300b,"SIEMENS MED SYNGO RT",8a)	(300b,"SIEMENS MED SYNGO RT",8a)	SIEMENS MED SYNGO RT	12299	138	f	\N	DS	3	Norm Vector of Plane	\N
10226	(300b,"SIEMENS MED SYNGO RT",8b)	(300b,"SIEMENS MED SYNGO RT",8b)	SIEMENS MED SYNGO RT	12299	139	f	\N	DS	1	Plane Thickness	\N
10227	(300b,"SIEMENS MED SYNGO RT",90)	(300b,"SIEMENS MED SYNGO RT",90)	SIEMENS MED SYNGO RT	12299	144	f	\N	SQ	1	Treatment Approval Sequence	\N
10228	(300b,"SIEMENS MED SYNGO RT",98)	(300b,"SIEMENS MED SYNGO RT",98)	SIEMENS MED SYNGO RT	12299	152	f	\N	DS	1	Treatment Room Temperature	\N
10229	(300b,"SIEMENS MED SYNGO RT",99)	(300b,"SIEMENS MED SYNGO RT",99)	SIEMENS MED SYNGO RT	12299	153	f	\N	DS	1	Treatment Room Air Pressure	\N
10230	(300b,"SIEMENS MED SYNGO RT",9b)	(300b,"SIEMENS MED SYNGO RT",9b)	SIEMENS MED SYNGO RT	12299	155	f	\N	SQ	1	Split Plane Sequence	\N
10231	(300b,"SIEMENS MED SYNGO RT",9c)	(300b,"SIEMENS MED SYNGO RT",9c)	SIEMENS MED SYNGO RT	12299	156	f	\N	IS	1	Display Color	\N
10232	(300b,"SIEMENS MED SYNGO RT",9d)	(300b,"SIEMENS MED SYNGO RT",9d)	SIEMENS MED SYNGO RT	12299	157	f	\N	SH	1	Beam Group Name	\N
10233	(300b,"SIEMENS MED SYNGO RT",a0)	(300b,"SIEMENS MED SYNGO RT",a0)	SIEMENS MED SYNGO RT	12299	160	f	\N	DT	1	Expire DateTime	\N
10234	(300b,"SIEMENS MED SYNGO RT",a1)	(300b,"SIEMENS MED SYNGO RT",a1)	SIEMENS MED SYNGO RT	12299	161	f	\N	OB	1	Checksum Encryption Code	\N
10235	(300b,"SIEMENS MED SYNGO RT",a2)	(300b,"SIEMENS MED SYNGO RT",a2)	SIEMENS MED SYNGO RT	12299	162	f	\N	CS	1	Setup Type	\N
10236	(300b,"SIEMENS MED SYNGO RT",a3)	(300b,"SIEMENS MED SYNGO RT",a3)	SIEMENS MED SYNGO RT	12299	163	f	\N	IS	1	Number of Therapy Detectors	\N
10237	(300b,"SIEMENS MED SYNGO RT",a4)	(300b,"SIEMENS MED SYNGO RT",a4)	SIEMENS MED SYNGO RT	12299	164	f	\N	SQ	1	Therapy Detector Sequence	\N
10238	(300b,"SIEMENS MED SYNGO RT",a5)	(300b,"SIEMENS MED SYNGO RT",a5)	SIEMENS MED SYNGO RT	12299	165	f	\N	IS	1	Therapy Detector Number	\N
10239	(300b,"SIEMENS MED SYNGO RT",a6)	(300b,"SIEMENS MED SYNGO RT",a6)	SIEMENS MED SYNGO RT	12299	166	f	\N	SH	1	Therapy Detector Setup ID	\N
10240	(300b,"SIEMENS MED SYNGO RT",a7)	(300b,"SIEMENS MED SYNGO RT",a7)	SIEMENS MED SYNGO RT	12299	167	f	\N	SQ	1	Therapy Detector Settings Sequence	\N
10241	(300b,"SIEMENS MED SYNGO RT",a8)	(300b,"SIEMENS MED SYNGO RT",a8)	SIEMENS MED SYNGO RT	12299	168	f	\N	IS	1	Referenced Therapy Detector Number	\N
10242	(300b,"SIEMENS MED SYNGO RT",a9)	(300b,"SIEMENS MED SYNGO RT",a9)	SIEMENS MED SYNGO RT	12299	169	f	\N	DS	1	Therapy Detector Position	\N
10243	(300b,"SIEMENS MED SYNGO RT",b0)	(300b,"SIEMENS MED SYNGO RT",b0)	SIEMENS MED SYNGO RT	12299	176	f	\N	IS	1	Scan Spot Resumption Index	\N
10244	(300b,"SIEMENS MED SYNGO RT",b1)	(300b,"SIEMENS MED SYNGO RT",b1)	SIEMENS MED SYNGO RT	12299	177	f	\N	OW	1	Phantom Detector Measurements	\N
10245	(300b,"SIEMENS MED SYNGO RT",b2)	(300b,"SIEMENS MED SYNGO RT",b2)	SIEMENS MED SYNGO RT	12299	178	f	\N	UT	1	Treatment Events	\N
10246	(300b,"SIEMENS MED SYNGO RT",c0)	(300b,"SIEMENS MED SYNGO RT",c0)	SIEMENS MED SYNGO RT	12299	192	f	\N	SQ	1	Dose Optimization Constraint Sequence	\N
10247	(300b,"SIEMENS MED SYNGO RT",c8)	(300b,"SIEMENS MED SYNGO RT",c8)	SIEMENS MED SYNGO RT	12299	200	f	\N	DS	1	Target Maximum Dose Constraint	\N
10248	(300b,"SIEMENS MED SYNGO RT",c9)	(300b,"SIEMENS MED SYNGO RT",c9)	SIEMENS MED SYNGO RT	12299	201	f	\N	DS	1	Target Maximum Dose Constraint Weight	\N
10249	(300b,"SIEMENS MED SYNGO RT",ca)	(300b,"SIEMENS MED SYNGO RT",ca)	SIEMENS MED SYNGO RT	12299	202	f	\N	DS	1	Target Minimum Dose Constraint	\N
10250	(300b,"SIEMENS MED SYNGO RT",cb)	(300b,"SIEMENS MED SYNGO RT",cb)	SIEMENS MED SYNGO RT	12299	203	f	\N	DS	1	Target Minimum Dose Constraint Weight	\N
10251	(300b,"SIEMENS MED SYNGO RT",cc)	(300b,"SIEMENS MED SYNGO RT",cc)	SIEMENS MED SYNGO RT	12299	204	f	\N	DS	1	Organ At Risk Maximum Dose Constraint	\N
10252	(300b,"SIEMENS MED SYNGO RT",cd)	(300b,"SIEMENS MED SYNGO RT",cd)	SIEMENS MED SYNGO RT	12299	205	f	\N	DS	1	Organ At Risk Maximum Dose Constraint Weight	\N
10253	(300b,"SIEMENS MED SYNGO RT",ce)	(300b,"SIEMENS MED SYNGO RT",ce)	SIEMENS MED SYNGO RT	12299	206	f	\N	SQ	1	DVH Constraint Sequence	\N
10254	(300b,"SIEMENS MED SYNGO RT",cf)	(300b,"SIEMENS MED SYNGO RT",cf)	SIEMENS MED SYNGO RT	12299	207	f	\N	DS	1	DVH Constraint Volume Limit	\N
10255	(300b,"SIEMENS MED SYNGO RT",d0)	(300b,"SIEMENS MED SYNGO RT",d0)	SIEMENS MED SYNGO RT	12299	208	f	\N	CS	1	DVH Constraint Volume Units	\N
10256	(300b,"SIEMENS MED SYNGO RT",d1)	(300b,"SIEMENS MED SYNGO RT",d1)	SIEMENS MED SYNGO RT	12299	209	f	\N	DS	1	DVH Constraint Dose Limit	\N
10257	(300b,"SIEMENS MED SYNGO RT",d3)	(300b,"SIEMENS MED SYNGO RT",d3)	SIEMENS MED SYNGO RT	12299	211	f	\N	CS	1	DVH Constraint Direction	\N
10258	(300b,"SIEMENS MED SYNGO RT",d4)	(300b,"SIEMENS MED SYNGO RT",d4)	SIEMENS MED SYNGO RT	12299	212	f	\N	DS	1	DVH Constraint Weight	\N
10259	(300b,"SIEMENS MED SYNGO RT",d5)	(300b,"SIEMENS MED SYNGO RT",d5)	SIEMENS MED SYNGO RT	12299	213	f	\N	CS	1	Optimized Dose Type	\N
10260	(300b,"SIEMENS MED SYNGO RT",d6)	(300b,"SIEMENS MED SYNGO RT",d6)	SIEMENS MED SYNGO RT	12299	214	f	\N	UT	1	Dose Calculation and Optimization Parameters	\N
10261	(300b,"SIEMENS MED SYNGO RT",d7)	(300b,"SIEMENS MED SYNGO RT",d7)	SIEMENS MED SYNGO RT	12299	215	f	\N	DS	1	Applied Renormalization Factor	\N
10262	(300b,"SIEMENS MED SYNGO RT",d8)	(300b,"SIEMENS MED SYNGO RT",d8)	SIEMENS MED SYNGO RT	12299	216	f	\N	CS	1	Dose Constraint Status	\N
10263	(300b,"SIEMENS MED SYNGO RT",d9)	(300b,"SIEMENS MED SYNGO RT",d9)	SIEMENS MED SYNGO RT	12299	217	f	\N	DS	1	Organ At Risk Minimum Dose Constraint	\N
10264	(300b,"SIEMENS MED SYNGO RT",da)	(300b,"SIEMENS MED SYNGO RT",da)	SIEMENS MED SYNGO RT	12299	218	f	\N	DS	1	Organ At Risk Minimum Dose Constraint Weight	\N
10265	(300b,"SIEMENS MED SYNGO RT",e0)	(300b,"SIEMENS MED SYNGO RT",e0)	SIEMENS MED SYNGO RT	12299	224	f	\N	SQ	1	Base Data Group Sequence	\N
10266	(300b,"SIEMENS MED SYNGO RT",e1)	(300b,"SIEMENS MED SYNGO RT",e1)	SIEMENS MED SYNGO RT	12299	225	f	\N	CS	1	Physics Base Data Group ID	\N
10267	(300b,"SIEMENS MED SYNGO RT",e2)	(300b,"SIEMENS MED SYNGO RT",e2)	SIEMENS MED SYNGO RT	12299	226	f	\N	CS	1	Biological Base Data Group ID	\N
10268	(300b,"SIEMENS MED SYNGO RT",e3)	(300b,"SIEMENS MED SYNGO RT",e3)	SIEMENS MED SYNGO RT	12299	227	f	\N	CS	1	Imaging Base Data Group ID	\N
10269	(300b,"SIEMENS MED SYNGO RT",e4)	(300b,"SIEMENS MED SYNGO RT",e4)	SIEMENS MED SYNGO RT	12299	228	f	\N	CS	1	Dosimetric Base Data Group ID	\N
10270	(300b,"SIEMENS MED SYNGO RT",e5)	(300b,"SIEMENS MED SYNGO RT",e5)	SIEMENS MED SYNGO RT	12299	229	f	\N	OB	1	Configuration Baseline	\N
10271	(300b,"SIEMENS MED SYNGO RT",e6)	(300b,"SIEMENS MED SYNGO RT",e6)	SIEMENS MED SYNGO RT	12299	230	f	\N	OB	1	Configuration Objects	\N
10272	(300b,"SIEMENS MED SYNGO RT",e7)	(300b,"SIEMENS MED SYNGO RT",e7)	SIEMENS MED SYNGO RT	12299	231	f	\N	CS	1	Confidence Measure Units	\N
10273	(300b,"SIEMENS MED SYNGO RT",e8)	(300b,"SIEMENS MED SYNGO RT",e8)	SIEMENS MED SYNGO RT	12299	232	f	\N	DS	1	Confidence Measure Value	\N
10274	(300b,"SIEMENS MED SYNGO RT",e9)	(300b,"SIEMENS MED SYNGO RT",e9)	SIEMENS MED SYNGO RT	12299	233	f	\N	LO	1	Imager Organ Program Name	\N
10275	(300b,"SIEMENS MED SYNGO RT",eb)	(300b,"SIEMENS MED SYNGO RT",eb)	SIEMENS MED SYNGO RT	12299	235	f	\N	CS	1	Body Region	\N
10276	(300b,"SIEMENS MED SYNGO RT",ec)	(300b,"SIEMENS MED SYNGO RT",ec)	SIEMENS MED SYNGO RT	12299	236	f	\N	CS	1	Prefinalized Status	\N
10277	(300b,"SIEMENS MED SYNGO RT",ed)	(300b,"SIEMENS MED SYNGO RT",ed)	SIEMENS MED SYNGO RT	12299	237	f	\N	OB	1	Dosimetric Checksum Encryption Code	\N
10278	(300b,"SIEMENS MED SYNGO RT",ee)	(300b,"SIEMENS MED SYNGO RT",ee)	SIEMENS MED SYNGO RT	12299	238	f	\N	SQ	1	Referenced Report Sequence	\N
10279	(300b,"SIEMENS MED SYNGO RT",ef)	(300b,"SIEMENS MED SYNGO RT",ef)	SIEMENS MED SYNGO RT	12299	239	f	\N	CS	1	Maintain Checksum Compatibility	\N
10280	(300b,"SIEMENS MED SYNGO RT",f0)	(300b,"SIEMENS MED SYNGO RT",f0)	SIEMENS MED SYNGO RT	12299	240	f	\N	DS	1	Dose Statistical Uncertainty	\N
10281	(300b,"SIEMENS MED SYNGO RT",f1)	(300b,"SIEMENS MED SYNGO RT",f1)	SIEMENS MED SYNGO RT	12299	241	f	\N	CS	1	Interpreted Radiation Type	\N
10282	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",01)	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",01)	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	32721	1	f	\N	OB	1	Padding	\N
10283	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",09)	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",09)	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	32721	9	f	\N	OB	1	Version ID	\N
10284	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",10)	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",10)	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	32721	16	f	\N	LO	1	Payload	\N
10285	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",11)	(7fd1,"SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING",11)	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	32721	17	f	\N	LO	1	After Payload	\N
10286	(0021,"SIEMENS Ultrasound S2000",00)	(0021,"SIEMENS Ultrasound S2000",00)	SIEMENS Ultrasound S2000	33	0	f	\N	US	1	Nipple Position	\N
10287	(0021,"SIEMENS Ultrasound S2000",01)	(0021,"SIEMENS Ultrasound S2000",01)	SIEMENS Ultrasound S2000	33	1	f	\N	US	1	ABVS Clip Derived From Volume	\N
10288	(0079,"SMIL_PB79",00)	(0079,"SMIL_PB79",00)	SMIL_PB79	121	0	f	\N	LO	1	Analgesia	\N
10289	(0079,"SMIL_PB79",01)	(0079,"SMIL_PB79",01)	SMIL_PB79	121	1	f	\N	LO	1	Anesthesia	\N
10290	(0079,"SMIL_PB79",02)	(0079,"SMIL_PB79",02)	SMIL_PB79	121	2	f	\N	IS	1	Bed Motion	\N
10291	(0079,"SMIL_PB79",03)	(0079,"SMIL_PB79",03)	SMIL_PB79	121	3	f	\N	LO	1	Food Access	\N
10292	(0079,"SMIL_PB79",04)	(0079,"SMIL_PB79",04)	SMIL_PB79	121	4	f	\N	DS	1	Histogram Version	\N
10293	(0079,"SMIL_PB79",06)	(0079,"SMIL_PB79",06)	SMIL_PB79	121	6	f	\N	DS	1	Injection Decay Correction	\N
10294	(0079,"SMIL_PB79",07)	(0079,"SMIL_PB79",07)	SMIL_PB79	121	7	f	\N	LO	1	Isotope	\N
10295	(0079,"SMIL_PB79",08)	(0079,"SMIL_PB79",08)	SMIL_PB79	121	8	f	\N	LO	1	Other Drugs	\N
10296	(0079,"SMIL_PB79",09)	(0079,"SMIL_PB79",09)	SMIL_PB79	121	9	f	\N	IS	1	RebinningType	\N
10297	(0079,"SMIL_PB79",0a)	(0079,"SMIL_PB79",0a)	SMIL_PB79	121	10	f	\N	DS	1	Rebinning Version	\N
10298	(0079,"SMIL_PB79",0b)	(0079,"SMIL_PB79",0b)	SMIL_PB79	121	11	f	\N	IS	1	Reconstruction	\N
10299	(0079,"SMIL_PB79",0c)	(0079,"SMIL_PB79",0c)	SMIL_PB79	121	12	f	\N	DS	1	ReconstructionVersion	\N
10300	(0079,"SMIL_PB79",0d)	(0079,"SMIL_PB79",0d)	SMIL_PB79	121	13	f	\N	LO	1	Injected Compounds	\N
10301	(0079,"SMIL_PB79",0e)	(0079,"SMIL_PB79",0e)	SMIL_PB79	121	14	f	\N	LO	1	Study Model	\N
10302	(0079,"SMIL_PB79",0f)	(0079,"SMIL_PB79",0f)	SMIL_PB79	121	15	f	\N	LO	1	Subject Genus	\N
10303	(0079,"SMIL_PB79",10)	(0079,"SMIL_PB79",10)	SMIL_PB79	121	16	f	\N	LO	1	Subject Phenotype	\N
10304	(0079,"SMIL_PB79",11)	(0079,"SMIL_PB79",11)	SMIL_PB79	121	17	f	\N	DS	1	Version	\N
10305	(0079,"SMIL_PB79",12)	(0079,"SMIL_PB79",12)	SMIL_PB79	121	18	f	\N	LO	1	Water Access	\N
10306	(0079,"SMIL_PB79",13)	(0079,"SMIL_PB79",13)	SMIL_PB79	121	19	f	\N	DS	1	X Offset	\N
10307	(0079,"SMIL_PB79",14)	(0079,"SMIL_PB79",14)	SMIL_PB79	121	20	f	\N	DS	1	Y Offset	\N
10308	(0079,"SMIL_PB79",15)	(0079,"SMIL_PB79",15)	SMIL_PB79	121	21	f	\N	DS	1	Zoom	\N
10309	(0079,"SMIL_PB79",17)	(0079,"SMIL_PB79",17)	SMIL_PB79	121	23	f	\N	IS	1	Subject Orientation	\N
10310	(007b,"SMIO_PB7B",00)	(007b,"SMIO_PB7B",00)	SMIO_PB7B	123	0	f	\N	LO	1	Units	\N
10311	(007d,"SMIO_PB7D",01)	(007d,"SMIO_PB7D",01)	SMIO_PB7D	125	1	f	\N	UL	1	Geometry	\N
10312	(007d,"SMIO_PB7D",02)	(007d,"SMIO_PB7D",02)	SMIO_PB7D	125	2	f	\N	FL	1	Spacing	\N
10313	(007d,"SMIO_PB7D",03)	(007d,"SMIO_PB7D",03)	SMIO_PB7D	125	3	f	\N	FL	1	Origin	\N
10314	(0009,"TOSHIBA_MEC_OT3",00)	(0009,"TOSHIBA_MEC_OT3",00)	TOSHIBA_MEC_OT3	9	0	f	\N	LO	1	HIS/RIS Study ID	\N
10315	(0029,"TOSHIBA MDW NON-IMAGE",08)	(0029,"TOSHIBA MDW NON-IMAGE",08)	TOSHIBA MDW NON-IMAGE	41	8	f	\N	CS	1	Non-Image Header Type	\N
10316	(0029,"TOSHIBA MDW NON-IMAGE",09)	(0029,"TOSHIBA MDW NON-IMAGE",09)	TOSHIBA MDW NON-IMAGE	41	9	f	\N	LO	1	Non-Image Header Version	\N
10317	(0029,"TOSHIBA MDW NON-IMAGE",20)	(0029,"TOSHIBA MDW NON-IMAGE",20)	TOSHIBA MDW NON-IMAGE	41	32	f	\N	OB	1	Unknown	\N
10318	(0029,"TOSHIBA MDW HEADER",08)	(0029,"TOSHIBA MDW HEADER",08)	TOSHIBA MDW HEADER	41	8	f	\N	CS	1	Image Header Type	\N
10319	(0029,"TOSHIBA MDW HEADER",09)	(0029,"TOSHIBA MDW HEADER",09)	TOSHIBA MDW HEADER	41	9	f	\N	LO	1	Image Header Version	\N
10320	(0029,"TOSHIBA MDW HEADER",10)	(0029,"TOSHIBA MDW HEADER",10)	TOSHIBA MDW HEADER	41	16	f	\N	OB	1	Image Header Info	\N
10321	(0029,"TOSHIBA MDW HEADER",18)	(0029,"TOSHIBA MDW HEADER",18)	TOSHIBA MDW HEADER	41	24	f	\N	CS	1	Series Header Type	\N
10322	(0029,"TOSHIBA MDW HEADER",19)	(0029,"TOSHIBA MDW HEADER",19)	TOSHIBA MDW HEADER	41	25	f	\N	LO	1	Series Header Version	\N
10323	(0029,"TOSHIBA MDW HEADER",20)	(0029,"TOSHIBA MDW HEADER",20)	TOSHIBA MDW HEADER	41	32	f	\N	OB	1	Series Header Info	\N
10324	(0029,"TOSHIBA COMAPL HEADER",08)	(0029,"TOSHIBA COMAPL HEADER",08)	TOSHIBA COMAPL HEADER	41	8	f	\N	CS	1	COMAPL Header Type	\N
10325	(0029,"TOSHIBA COMAPL HEADER",09)	(0029,"TOSHIBA COMAPL HEADER",09)	TOSHIBA COMAPL HEADER	41	9	f	\N	LO	1	COMAPL Header Version	\N
10326	(0029,"TOSHIBA COMAPL HEADER",10)	(0029,"TOSHIBA COMAPL HEADER",10)	TOSHIBA COMAPL HEADER	41	16	f	\N	OB	1	COMAPL Header Info	\N
10327	(0029,"TOSHIBA COMAPL HEADER",20)	(0029,"TOSHIBA COMAPL HEADER",20)	TOSHIBA COMAPL HEADER	41	32	f	\N	OB	1	COMAPL History Information	\N
10328	(0029,"TOSHIBA COMAPL HEADER",31)	(0029,"TOSHIBA COMAPL HEADER",31)	TOSHIBA COMAPL HEADER	41	49	f	\N	LO	1	Unknown	\N
10329	(0029,"TOSHIBA COMAPL HEADER",34)	(0029,"TOSHIBA COMAPL HEADER",34)	TOSHIBA COMAPL HEADER	41	52	f	\N	LO	1	Unknown	\N
10330	(0029,"TOSHIBA COMAPL OOG",08)	(0029,"TOSHIBA COMAPL OOG",08)	TOSHIBA COMAPL OOG	41	8	f	\N	CS	1	COMAPL OOG Type	\N
10331	(0029,"TOSHIBA COMAPL OOG",09)	(0029,"TOSHIBA COMAPL OOG",09)	TOSHIBA COMAPL OOG	41	9	f	\N	LO	1	COMAPL OOG Version	\N
10537	(0009,"MMCPrivate",1c)	(0009,"MMCPrivate",1c)	MMCPrivate	9	28	f	\N	OB	1	ProtocolAppData	X
10332	(0029,"TOSHIBA COMAPL OOG",10)	(0029,"TOSHIBA COMAPL OOG",10)	TOSHIBA COMAPL OOG	41	16	f	\N	OB	1	COMAPL OOG Info	\N
10333	(0029,"PMTF INFORMATION DATA",01)	(0029,"PMTF INFORMATION DATA",01)	PMTF INFORMATION DATA	41	1	f	\N	SQ	1	Unknown	\N
10334	(0029,"PMTF INFORMATION DATA",31)	(0029,"PMTF INFORMATION DATA",31)	PMTF INFORMATION DATA	41	49	f	\N	LO	1	PMTF Information 1	\N
10335	(0029,"PMTF INFORMATION DATA",32)	(0029,"PMTF INFORMATION DATA",32)	PMTF INFORMATION DATA	41	50	f	\N	UL	1	PMTF Information 2	\N
10336	(0029,"PMTF INFORMATION DATA",33)	(0029,"PMTF INFORMATION DATA",33)	PMTF INFORMATION DATA	41	51	f	\N	UL	1	PMTF Information 3	\N
10337	(0029,"PMTF INFORMATION DATA",34)	(0029,"PMTF INFORMATION DATA",34)	PMTF INFORMATION DATA	41	52	f	\N	CS	1	PMTF Information 4	\N
10338	(0029,"PMTF INFORMATION DATA",89)	(0029,"PMTF INFORMATION DATA",89)	PMTF INFORMATION DATA	41	137	f	\N	LO	1	Unknown	\N
10339	(0029,"PMTF INFORMATION DATA",90)	(0029,"PMTF INFORMATION DATA",90)	PMTF INFORMATION DATA	41	144	f	\N	OB	1	Unknown	\N
10395	(7005,"TOSHIBA_MEC_CT3",61)	(7005,"TOSHIBA_MEC_CT3",61)	TOSHIBA_MEC_CT3	28677	97	f	\N	LO	1	Synchronized Signal Information	\N
10396	(7005,"TOSHIBA_MEC_CT3",62)	(7005,"TOSHIBA_MEC_CT3",62)	TOSHIBA_MEC_CT3	28677	98	f	\N	DS	1	Total Raw Data Size	\N
10397	(7005,"TOSHIBA_MEC_CT3",63)	(7005,"TOSHIBA_MEC_CT3",63)	TOSHIBA_MEC_CT3	28677	99	f	\N	FD	1	CTDIw	\N
10398	(7005,"TOSHIBA_MEC_CT3",67)	(7005,"TOSHIBA_MEC_CT3",67)	TOSHIBA_MEC_CT3	28677	103	f	\N	UI	1	Volume UID of 4D-Volume	\N
10399	(7005,"TOSHIBA_MEC_CT3",68)	(7005,"TOSHIBA_MEC_CT3",68)	TOSHIBA_MEC_CT3	28677	104	f	\N	US	1	Total Frame Count in 4D-Volume	\N
10400	(7005,"TOSHIBA_MEC_CT3",69)	(7005,"TOSHIBA_MEC_CT3",69)	TOSHIBA_MEC_CT3	28677	105	f	\N	US	1	Frame Number in 4D-Volume	\N
10401	(7005,"TOSHIBA_MEC_CT3",6a)	(7005,"TOSHIBA_MEC_CT3",6a)	TOSHIBA_MEC_CT3	28677	106	f	\N	DS	3	Image Position of 4D-Volume Top	\N
10402	(7005,"TOSHIBA_MEC_CT3",6b)	(7005,"TOSHIBA_MEC_CT3",6b)	TOSHIBA_MEC_CT3	28677	107	f	\N	DS	3	Image Position of 4D-Volume Top (Equipment)	\N
10403	(7005,"TOSHIBA_MEC_CT3",6c)	(7005,"TOSHIBA_MEC_CT3",6c)	TOSHIBA_MEC_CT3	28677	108	f	\N	UI	1	SOP Instance UID of 4D-Volume	\N
10404	(7005,"TOSHIBA_MEC_CT3",6d)	(7005,"TOSHIBA_MEC_CT3",6d)	TOSHIBA_MEC_CT3	28677	109	f	\N	UI	1	Series Instance UID of 4D-Volume	\N
10416	(7015,"TOSHIBA ENCRYPTED SR DATA",00)	(7015,"TOSHIBA ENCRYPTED SR DATA",00)	TOSHIBA ENCRYPTED SR DATA	28693	0	f	\N	OB	1	Unknown	\N
10417	(7015,"TOSHIBA_SR",10)	(7015,"TOSHIBA_SR",10)	TOSHIBA_SR	28693	16	f	\N	OB	1	Unknown	\N
10418	(7015,"TOSHIBA_SR",60)	(7015,"TOSHIBA_SR",60)	TOSHIBA_SR	28693	96	f	\N	OB	1	Unknown	\N
10419	(7015,"PMTF INFORMATION DATA",73)	(7015,"PMTF INFORMATION DATA",73)	PMTF INFORMATION DATA	28693	115	f	\N	SQ	1	Unknown	\N
10420	(7079,"TOSHIBA_MEC_XA3",21)	(7079,"TOSHIBA_MEC_XA3",21)	TOSHIBA_MEC_XA3	28793	33	f	\N	SH	5	Unknown	\N
10421	(7079,"TOSHIBA_MEC_XA3",22)	(7079,"TOSHIBA_MEC_XA3",22)	TOSHIBA_MEC_XA3	28793	34	f	\N	IS	2	Unknown	\N
10422	(7079,"TOSHIBA_MEC_XA3",23)	(7079,"TOSHIBA_MEC_XA3",23)	TOSHIBA_MEC_XA3	28793	35	f	\N	IS	2	Unknown	\N
10423	(7079,"TOSHIBA_MEC_XA3",24)	(7079,"TOSHIBA_MEC_XA3",24)	TOSHIBA_MEC_XA3	28793	36	f	\N	DS	1	Unknown	\N
10424	(7079,"TOSHIBA_MEC_XA3",25)	(7079,"TOSHIBA_MEC_XA3",25)	TOSHIBA_MEC_XA3	28793	37	f	\N	SH	1	Unknown	\N
10425	(7079,"TOSHIBA_MEC_XA3",26)	(7079,"TOSHIBA_MEC_XA3",26)	TOSHIBA_MEC_XA3	28793	38	f	\N	DS	2	Unknown	\N
10426	(7079,"TOSHIBA_MEC_XA3",27)	(7079,"TOSHIBA_MEC_XA3",27)	TOSHIBA_MEC_XA3	28793	39	f	\N	US	2	Unknown	\N
10427	(7079,"TOSHIBA_MEC_XA3",28)	(7079,"TOSHIBA_MEC_XA3",28)	TOSHIBA_MEC_XA3	28793	40	f	\N	US	1	Unknown	\N
10428	(7079,"TOSHIBA_MEC_XA3",2a)	(7079,"TOSHIBA_MEC_XA3",2a)	TOSHIBA_MEC_XA3	28793	42	f	\N	US	5	Unknown	\N
10429	(7079,"TOSHIBA_MEC_XA3",2c)	(7079,"TOSHIBA_MEC_XA3",2c)	TOSHIBA_MEC_XA3	28793	44	f	\N	SH	3	Unknown	\N
10430	(7079,"TOSHIBA_MEC_XA3",2d)	(7079,"TOSHIBA_MEC_XA3",2d)	TOSHIBA_MEC_XA3	28793	45	f	\N	SS	2	Unknown	\N
10431	(7079,"TOSHIBA_MEC_XA3",2e)	(7079,"TOSHIBA_MEC_XA3",2e)	TOSHIBA_MEC_XA3	28793	46	f	\N	SH	1	Unknown	\N
10432	(7079,"TOSHIBA_MEC_XA3",2f)	(7079,"TOSHIBA_MEC_XA3",2f)	TOSHIBA_MEC_XA3	28793	47	f	\N	SH	1	Unknown	\N
10433	(7079,"TOSHIBA_MEC_XA3",30)	(7079,"TOSHIBA_MEC_XA3",30)	TOSHIBA_MEC_XA3	28793	48	f	\N	US	1	Unknown	\N
10434	(7079,"TOSHIBA_MEC_XA3",31)	(7079,"TOSHIBA_MEC_XA3",31)	TOSHIBA_MEC_XA3	28793	49	f	\N	US	1-n	Unknown	\N
10435	(7079,"TOSHIBA_MEC_XA3",32)	(7079,"TOSHIBA_MEC_XA3",32)	TOSHIBA_MEC_XA3	28793	50	f	\N	SH	2	Unknown	\N
10436	(7079,"TOSHIBA_MEC_XA3",33)	(7079,"TOSHIBA_MEC_XA3",33)	TOSHIBA_MEC_XA3	28793	51	f	\N	US	1-n	Unknown	\N
10437	(7079,"TOSHIBA_MEC_XA3",34)	(7079,"TOSHIBA_MEC_XA3",34)	TOSHIBA_MEC_XA3	28793	52	f	\N	SH	1	Unknown	\N
10438	(7079,"TOSHIBA_MEC_XA3",35)	(7079,"TOSHIBA_MEC_XA3",35)	TOSHIBA_MEC_XA3	28793	53	f	\N	SH	1	Unknown	\N
10439	(7079,"TOSHIBA_MEC_XA3",36)	(7079,"TOSHIBA_MEC_XA3",36)	TOSHIBA_MEC_XA3	28793	54	f	\N	SH	1	Unknown	\N
10440	(7079,"TOSHIBA_MEC_XA3",37)	(7079,"TOSHIBA_MEC_XA3",37)	TOSHIBA_MEC_XA3	28793	55	f	\N	US	4	Unknown	\N
10441	(7079,"TOSHIBA_MEC_XA3",38)	(7079,"TOSHIBA_MEC_XA3",38)	TOSHIBA_MEC_XA3	28793	56	f	\N	SS	1-n	Unknown	\N
10442	(7079,"TOSHIBA_MEC_XA3",39)	(7079,"TOSHIBA_MEC_XA3",39)	TOSHIBA_MEC_XA3	28793	57	f	\N	SS	1-n	Unknown	\N
10443	(7079,"TOSHIBA_MEC_XA3",3a)	(7079,"TOSHIBA_MEC_XA3",3a)	TOSHIBA_MEC_XA3	28793	58	f	\N	US	2	Unknown	\N
10444	(7079,"TOSHIBA_MEC_XA3",3b)	(7079,"TOSHIBA_MEC_XA3",3b)	TOSHIBA_MEC_XA3	28793	59	f	\N	SH	1	Unknown	\N
10445	(7079,"TOSHIBA_MEC_XA3",3c)	(7079,"TOSHIBA_MEC_XA3",3c)	TOSHIBA_MEC_XA3	28793	60	f	\N	DS	2	Unknown	\N
10446	(7079,"TOSHIBA_MEC_XA3",3d)	(7079,"TOSHIBA_MEC_XA3",3d)	TOSHIBA_MEC_XA3	28793	61	f	\N	SS	2	Unknown	\N
10447	(7079,"TOSHIBA_MEC_XA3",3e)	(7079,"TOSHIBA_MEC_XA3",3e)	TOSHIBA_MEC_XA3	28793	62	f	\N	SH	1	Unknown	\N
10448	(7079,"TOSHIBA_MEC_XA3",3f)	(7079,"TOSHIBA_MEC_XA3",3f)	TOSHIBA_MEC_XA3	28793	63	f	\N	US	2	Unknown	\N
10449	(7079,"TOSHIBA_MEC_XA3",40)	(7079,"TOSHIBA_MEC_XA3",40)	TOSHIBA_MEC_XA3	28793	64	f	\N	SH	2	Unknown	\N
10450	(7079,"TOSHIBA_MEC_XA3",41)	(7079,"TOSHIBA_MEC_XA3",41)	TOSHIBA_MEC_XA3	28793	65	f	\N	SS	2	Unknown	\N
10451	(7079,"TOSHIBA_MEC_XA3",42)	(7079,"TOSHIBA_MEC_XA3",42)	TOSHIBA_MEC_XA3	28793	66	f	\N	SH	1	Unknown	\N
10452	(7079,"TOSHIBA_MEC_XA3",43)	(7079,"TOSHIBA_MEC_XA3",43)	TOSHIBA_MEC_XA3	28793	67	f	\N	SH	1	Unknown	\N
10453	(7079,"TOSHIBA_MEC_XA3",44)	(7079,"TOSHIBA_MEC_XA3",44)	TOSHIBA_MEC_XA3	28793	68	f	\N	US	1	Unknown	\N
10454	(7079,"TOSHIBA_MEC_XA3",45)	(7079,"TOSHIBA_MEC_XA3",45)	TOSHIBA_MEC_XA3	28793	69	f	\N	SH	1	Unknown	\N
10455	(7079,"TOSHIBA_MEC_XA3",46)	(7079,"TOSHIBA_MEC_XA3",46)	TOSHIBA_MEC_XA3	28793	70	f	\N	SS	1	Unknown	\N
10456	(7079,"TOSHIBA_MEC_XA3",47)	(7079,"TOSHIBA_MEC_XA3",47)	TOSHIBA_MEC_XA3	28793	71	f	\N	SS	18	Unknown	\N
10457	(7079,"TOSHIBA_MEC_XA3",48)	(7079,"TOSHIBA_MEC_XA3",48)	TOSHIBA_MEC_XA3	28793	72	f	\N	US	12	Unknown	\N
10458	(7079,"TOSHIBA_MEC_XA3",49)	(7079,"TOSHIBA_MEC_XA3",49)	TOSHIBA_MEC_XA3	28793	73	f	\N	US	3	Unknown	\N
10459	(7079,"TOSHIBA_MEC_XA3",4a)	(7079,"TOSHIBA_MEC_XA3",4a)	TOSHIBA_MEC_XA3	28793	74	f	\N	US	1	Unknown	\N
10460	(7079,"TOSHIBA_MEC_XA3",4b)	(7079,"TOSHIBA_MEC_XA3",4b)	TOSHIBA_MEC_XA3	28793	75	f	\N	LO	3	Unknown	\N
10461	(7079,"TOSHIBA_MEC_XA3",4c)	(7079,"TOSHIBA_MEC_XA3",4c)	TOSHIBA_MEC_XA3	28793	76	f	\N	OB	1	Unknown	\N
10462	(7079,"TOSHIBA_MEC_XA3",4d)	(7079,"TOSHIBA_MEC_XA3",4d)	TOSHIBA_MEC_XA3	28793	77	f	\N	SH	3	Unknown	\N
10463	(7079,"TOSHIBA_MEC_XA3",4e)	(7079,"TOSHIBA_MEC_XA3",4e)	TOSHIBA_MEC_XA3	28793	78	f	\N	SL	35	Unknown	\N
10464	(7079,"TOSHIBA_MEC_XA3",4f)	(7079,"TOSHIBA_MEC_XA3",4f)	TOSHIBA_MEC_XA3	28793	79	f	\N	SH	3	Unknown	\N
10465	(7079,"TOSHIBA_MEC_XA3",50)	(7079,"TOSHIBA_MEC_XA3",50)	TOSHIBA_MEC_XA3	28793	80	f	\N	US	1-n	Unknown	\N
10466	(7079,"TOSHIBA_MEC_XA3",51)	(7079,"TOSHIBA_MEC_XA3",51)	TOSHIBA_MEC_XA3	28793	81	f	\N	US	1-n	Unknown	\N
10467	(7079,"TOSHIBA_MEC_XA3",52)	(7079,"TOSHIBA_MEC_XA3",52)	TOSHIBA_MEC_XA3	28793	82	f	\N	US	1	Unknown	\N
10468	(7079,"TOSHIBA_MEC_XA3",53)	(7079,"TOSHIBA_MEC_XA3",53)	TOSHIBA_MEC_XA3	28793	83	f	\N	SH	1	Unknown	\N
10469	(7079,"TOSHIBA_MEC_XA3",54)	(7079,"TOSHIBA_MEC_XA3",54)	TOSHIBA_MEC_XA3	28793	84	f	\N	US	5	Unknown	\N
10470	(7079,"TOSHIBA_MEC_XA3",55)	(7079,"TOSHIBA_MEC_XA3",55)	TOSHIBA_MEC_XA3	28793	85	f	\N	UL	47-47n	Unknown	\N
10471	(7079,"TOSHIBA_MEC_XA3",56)	(7079,"TOSHIBA_MEC_XA3",56)	TOSHIBA_MEC_XA3	28793	86	f	\N	US	1	Unknown	\N
10472	(7079,"TOSHIBA_MEC_XA3",57)	(7079,"TOSHIBA_MEC_XA3",57)	TOSHIBA_MEC_XA3	28793	87	f	\N	US	1-n	Unknown	\N
10473	(7079,"TOSHIBA_MEC_XA3",58)	(7079,"TOSHIBA_MEC_XA3",58)	TOSHIBA_MEC_XA3	28793	88	f	\N	US	1	Unknown	\N
10474	(7079,"TOSHIBA_MEC_XA3",59)	(7079,"TOSHIBA_MEC_XA3",59)	TOSHIBA_MEC_XA3	28793	89	f	\N	US	2-2n	Unknown	\N
10475	(7079,"TOSHIBA_MEC_XA3",5a)	(7079,"TOSHIBA_MEC_XA3",5a)	TOSHIBA_MEC_XA3	28793	90	f	\N	US	1	Unknown	\N
10476	(7079,"TOSHIBA_MEC_XA3",5b)	(7079,"TOSHIBA_MEC_XA3",5b)	TOSHIBA_MEC_XA3	28793	91	f	\N	US	2	Unknown	\N
10477	(7079,"TOSHIBA_MEC_XA3",5c)	(7079,"TOSHIBA_MEC_XA3",5c)	TOSHIBA_MEC_XA3	28793	92	f	\N	US	2-2n	Unknown	\N
10478	(7079,"TOSHIBA_MEC_XA3",5d)	(7079,"TOSHIBA_MEC_XA3",5d)	TOSHIBA_MEC_XA3	28793	93	f	\N	SH	1	Unknown	\N
10479	(7079,"TOSHIBA_MEC_XA3",5e)	(7079,"TOSHIBA_MEC_XA3",5e)	TOSHIBA_MEC_XA3	28793	94	f	\N	US	2	Unknown	\N
10480	(7079,"TOSHIBA_MEC_XA3",5f)	(7079,"TOSHIBA_MEC_XA3",5f)	TOSHIBA_MEC_XA3	28793	95	f	\N	SS	4-4n	Unknown	\N
10481	(7079,"TOSHIBA_MEC_XA3",60)	(7079,"TOSHIBA_MEC_XA3",60)	TOSHIBA_MEC_XA3	28793	96	f	\N	US	1-n	Unknown	\N
10482	(7079,"TOSHIBA_MEC_XA3",61)	(7079,"TOSHIBA_MEC_XA3",61)	TOSHIBA_MEC_XA3	28793	97	f	\N	SS	30-30n	Unknown	\N
10483	(7079,"TOSHIBA_MEC_XA3",62)	(7079,"TOSHIBA_MEC_XA3",62)	TOSHIBA_MEC_XA3	28793	98	f	\N	US	4	Unknown	\N
10484	(7079,"TOSHIBA_MEC_XA3",63)	(7079,"TOSHIBA_MEC_XA3",63)	TOSHIBA_MEC_XA3	28793	99	f	\N	US	1-n	Unknown	\N
10485	(7079,"TOSHIBA_MEC_XA3",64)	(7079,"TOSHIBA_MEC_XA3",64)	TOSHIBA_MEC_XA3	28793	100	f	\N	US	1-n	Unknown	\N
10486	(7079,"TOSHIBA_MEC_XA3",65)	(7079,"TOSHIBA_MEC_XA3",65)	TOSHIBA_MEC_XA3	28793	101	f	\N	US	1-n	Unknown	\N
10487	(7079,"TOSHIBA_MEC_XA3",66)	(7079,"TOSHIBA_MEC_XA3",66)	TOSHIBA_MEC_XA3	28793	102	f	\N	US	1-n	Unknown	\N
10488	(7079,"TOSHIBA_MEC_XA3",67)	(7079,"TOSHIBA_MEC_XA3",67)	TOSHIBA_MEC_XA3	28793	103	f	\N	US	1-n	Unknown	\N
10489	(7079,"TOSHIBA_MEC_XA3",68)	(7079,"TOSHIBA_MEC_XA3",68)	TOSHIBA_MEC_XA3	28793	104	f	\N	US	1-n	Unknown	\N
10490	(7079,"TOSHIBA_MEC_XA3",69)	(7079,"TOSHIBA_MEC_XA3",69)	TOSHIBA_MEC_XA3	28793	105	f	\N	US	1-n	Unknown	\N
10491	(7079,"TOSHIBA_MEC_XA3",6a)	(7079,"TOSHIBA_MEC_XA3",6a)	TOSHIBA_MEC_XA3	28793	106	f	\N	US	1-n	Unknown	\N
10492	(7079,"TOSHIBA_MEC_XA3",6b)	(7079,"TOSHIBA_MEC_XA3",6b)	TOSHIBA_MEC_XA3	28793	107	f	\N	US	1-n	Unknown	\N
10493	(7079,"TOSHIBA_MEC_XA3",6c)	(7079,"TOSHIBA_MEC_XA3",6c)	TOSHIBA_MEC_XA3	28793	108	f	\N	US	1	Unknown	\N
10494	(7079,"TOSHIBA_MEC_XA3",6d)	(7079,"TOSHIBA_MEC_XA3",6d)	TOSHIBA_MEC_XA3	28793	109	f	\N	DS	1	Unknown	\N
10495	(7079,"TOSHIBA_MEC_XA3",6e)	(7079,"TOSHIBA_MEC_XA3",6e)	TOSHIBA_MEC_XA3	28793	110	f	\N	LO	1	Unknown	\N
10496	(7079,"TOSHIBA_MEC_XA3",6f)	(7079,"TOSHIBA_MEC_XA3",6f)	TOSHIBA_MEC_XA3	28793	111	f	\N	DS	1	Unknown	\N
10497	(7079,"TOSHIBA_MEC_XA3",70)	(7079,"TOSHIBA_MEC_XA3",70)	TOSHIBA_MEC_XA3	28793	112	f	\N	DS	1	Unknown	\N
10498	(7079,"TOSHIBA_MEC_XA3",71)	(7079,"TOSHIBA_MEC_XA3",71)	TOSHIBA_MEC_XA3	28793	113	f	\N	DS	1-n	Unknown	\N
10499	(7079,"TOSHIBA_MEC_XA3",72)	(7079,"TOSHIBA_MEC_XA3",72)	TOSHIBA_MEC_XA3	28793	114	f	\N	DS	1-n	Unknown	\N
10500	(7079,"TOSHIBA_MEC_XA3",73)	(7079,"TOSHIBA_MEC_XA3",73)	TOSHIBA_MEC_XA3	28793	115	f	\N	SL	4	Unknown	\N
10501	(7079,"TOSHIBA_MEC_XA3",74)	(7079,"TOSHIBA_MEC_XA3",74)	TOSHIBA_MEC_XA3	28793	116	f	\N	SL	28	Unknown	\N
10502	(7079,"TOSHIBA_MEC_XA3",75)	(7079,"TOSHIBA_MEC_XA3",75)	TOSHIBA_MEC_XA3	28793	117	f	\N	SH	1	Unknown	\N
10503	(7079,"TOSHIBA_MEC_XA3",76)	(7079,"TOSHIBA_MEC_XA3",76)	TOSHIBA_MEC_XA3	28793	118	f	\N	US	1	Unknown	\N
10504	(7079,"TOSHIBA_MEC_XA3",77)	(7079,"TOSHIBA_MEC_XA3",77)	TOSHIBA_MEC_XA3	28793	119	f	\N	SL	1	Unknown	\N
10505	(7079,"TOSHIBA_MEC_XA3",78)	(7079,"TOSHIBA_MEC_XA3",78)	TOSHIBA_MEC_XA3	28793	120	f	\N	US	1	Unknown	\N
10506	(7079,"TOSHIBA_MEC_XA3",79)	(7079,"TOSHIBA_MEC_XA3",79)	TOSHIBA_MEC_XA3	28793	121	f	\N	US	1	Unknown	\N
10507	(7079,"TOSHIBA_MEC_XA3",7b)	(7079,"TOSHIBA_MEC_XA3",7b)	TOSHIBA_MEC_XA3	28793	123	f	\N	SH	1	Unknown	\N
10508	(7079,"TOSHIBA_MEC_XA3",80)	(7079,"TOSHIBA_MEC_XA3",80)	TOSHIBA_MEC_XA3	28793	128	f	\N	LO	1	Unknown	\N
160	(0009,"FDMS 1.0",04)	(0009,"FDMS 1.0",04)	FDMS 1.0	9	4	f	\N	SH	1	ImageControlUnit	X
162	(0009,"FDMS 1.0",06)	(0009,"FDMS 1.0",06)	FDMS 1.0	9	6	f	\N	OW	1	RouteImage UID	X
4924	(0009,"FDMS 1.0",0c)	(0009,"FDMS 1.0",0c)	FDMS 1.0	9	12	f	\N	OW	1	Film UID	X
4925	(0009,"FDMS 1.0",f0)	(0009,"FDMS 1.0",f0)	FDMS 1.0	9	240	f	\N	CS	1	Blackening Process Flag	K
658	(0009,"GEMS_IDEN_01",01)	(0009,"GEMS_IDEN_01",01)	GEMS_IDEN_01	9	1	f	\N	LO	1	FullFidelity	X
3203	(0009,"GEMS_PETD_01",01)	(0009,"GEMS_PETD_01",01)	GEMS_PETD_01	9	1	f	\N	LO	2	Implementation Version Name	R
3213	(0009,"GEMS_PETD_01",0b)	(0009,"GEMS_PETD_01",0b)	GEMS_PETD_01	9	11	f	\N	SH	1	Scan Compatible Version	R
3235	(0009,"GEMS_PETD_01",21)	(0009,"GEMS_PETD_01",21)	GEMS_PETD_01	9	33	f	\N	SL	1	Count Rate Period	K
3243	(0009,"GEMS_PETD_01",29)	(0009,"GEMS_PETD_01",29)	GEMS_PETD_01	9	41	f	\N	FL	1	Gantry Tilt Angle	K
3262	(0009,"GEMS_PETD_01",3c)	(0009,"GEMS_PETD_01",3c)	GEMS_PETD_01	9	60	f	\N	FL	1	Post Injected Activity	K
3283	(0009,"GEMS_PETD_01",51)	(0009,"GEMS_PETD_01",51)	GEMS_PETD_01	9	81	f	\N	SL	1	Upper Coinc Limit	K
3296	(0009,"GEMS_PETD_01",5e)	(0009,"GEMS_PETD_01",5e)	GEMS_PETD_01	9	94	f	\N	UI	1	exam_id	R
3298	(0009,"GEMS_PETD_01",60)	(0009,"GEMS_PETD_01",60)	GEMS_PETD_01	9	96	f	\N	SH	1	compatible_version	R
3323	(0009,"GEMS_PETD_01",79)	(0009,"GEMS_PETD_01",79)	GEMS_PETD_01	9	121	f	\N	SH	1	Image Set Compatible Version	R
3350	(0009,"GEMS_PETD_01",94)	(0009,"GEMS_PETD_01",94)	GEMS_PETD_01	9	148	f	\N	SL	1	Atten Smooth Param	K
3357	(0009,"GEMS_PETD_01",9b)	(0009,"GEMS_PETD_01",9b)	GEMS_PETD_01	9	155	f	\N	FL	1	CAC Skull Offset	K
3361	(0009,"GEMS_PETD_01",9f)	(0009,"GEMS_PETD_01",9f)	GEMS_PETD_01	9	159	f	\N	SL	1	Axial Filter 3D	K
3382	(0009,"GEMS_PETD_01",b6)	(0009,"GEMS_PETD_01",b6)	GEMS_PETD_01	9	182	f	\N	SS	1	IR Loop Filter	K
3405	(0009,"GEMS_PETD_01",cd)	(0009,"GEMS_PETD_01",cd)	GEMS_PETD_01	9	205	f	\N	FL	1	vqc_y_axis_trans	K
3418	(0009,"GEMS_PETD_01",da)	(0009,"GEMS_PETD_01",da)	GEMS_PETD_01	9	218	f	\N	ST	1	where_is_list_frame	K
3419	(0009,"GEMS_PETD_01",db)	(0009,"GEMS_PETD_01",db)	GEMS_PETD_01	9	219	f	\N	SL	1	ir_z_filter_flag	K
10509	(0009,"GEMS_PETD_01",f0)	(0009,"GEMS_PETD_01",f0)	GEMS_PETD_01	9	240	f	\N	UI	1	Reformat group	R
10510	(0009,"GEMS_PETD_01",f1)	(0009,"GEMS_PETD_01",f1)	GEMS_PETD_01	9	241	f	\N	SL	1	PET prompt gamma	K
10511	(0009,"GEMS_PETD_01",f2)	(0009,"GEMS_PETD_01",f2)	GEMS_PETD_01	9	242	f	\N	UI	1	PET tracerInjection_UID	R
10512	(0009,"GE_YMS_NJ001",31)	(0009,"GE_YMS_NJ001",31)	GE_YMS_NJ001	9	49	f	\N	SH	1	Mobile Location Code	X
5125	(0009,"MMCPrivate",01)	(0009,"MMCPrivate",01)	MMCPrivate	9	1	f	\N	LO	1	Technologist	X
10513	(0009,"MMCPrivate",04)	(0009,"MMCPrivate",04)	MMCPrivate	9	4	f	\N	UI	1	ProtocolObjectID	X
10514	(0009,"MMCPrivate",05)	(0009,"MMCPrivate",05)	MMCPrivate	9	5	f	\N	LO	1	Name	X
10515	(0009,"MMCPrivate",06)	(0009,"MMCPrivate",06)	MMCPrivate	9	6	f	\N	IS	1	Frequency	K
10516	(0009,"MMCPrivate",07)	(0009,"MMCPrivate",07)	MMCPrivate	9	7	f	\N	SH	1	UpdateFlag	X
10517	(0009,"MMCPrivate",08)	(0009,"MMCPrivate",08)	MMCPrivate	9	8	f	\N	SH	1	Directory	X
10518	(0009,"MMCPrivate",09)	(0009,"MMCPrivate",09)	MMCPrivate	9	9	f	\N	LO	1	Comments	X
10519	(0009,"MMCPrivate",0a)	(0009,"MMCPrivate",0a)	MMCPrivate	9	10	f	\N	LO	1	Region	K
10520	(0009,"MMCPrivate",0b)	(0009,"MMCPrivate",0b)	MMCPrivate	9	11	f	\N	SH	1	Laterality	K
10521	(0009,"MMCPrivate",0c)	(0009,"MMCPrivate",0c)	MMCPrivate	9	12	f	\N	TM	1	TotalScanTime	K
10522	(0009,"MMCPrivate",0d)	(0009,"MMCPrivate",0d)	MMCPrivate	9	13	f	\N	LO	1	ContrastMedium	K
10523	(0009,"MMCPrivate",0e)	(0009,"MMCPrivate",0e)	MMCPrivate	9	14	f	\N	LO	1	CreateDateTime	X
10524	(0009,"MMCPrivate",0f)	(0009,"MMCPrivate",0f)	MMCPrivate	9	15	f	\N	LO	1	Creator	X
10525	(0009,"MMCPrivate",10)	(0009,"MMCPrivate",10)	MMCPrivate	9	16	f	\N	LO	1	SiteName	X
10526	(0009,"MMCPrivate",11)	(0009,"MMCPrivate",11)	MMCPrivate	9	17	f	\N	LO	1	ReferringPhysician	X
10527	(0009,"MMCPrivate",12)	(0009,"MMCPrivate",12)	MMCPrivate	9	18	f	\N	LO	1	Radiologist	X
10528	(0009,"MMCPrivate",13)	(0009,"MMCPrivate",13)	MMCPrivate	9	19	f	\N	LO	1	Technologist	X
10529	(0009,"MMCPrivate",14)	(0009,"MMCPrivate",14)	MMCPrivate	9	20	f	\N	UI	1	ProtocolUid	X
10530	(0009,"MMCPrivate",15)	(0009,"MMCPrivate",15)	MMCPrivate	9	21	f	\N	SH	1	IsInLibrary	X
10531	(0009,"MMCPrivate",16)	(0009,"MMCPrivate",16)	MMCPrivate	9	22	f	\N	LO	1	Gating	K
10532	(0009,"MMCPrivate",17)	(0009,"MMCPrivate",17)	MMCPrivate	9	23	f	\N	ST	1	Note	X
10533	(0009,"MMCPrivate",18)	(0009,"MMCPrivate",18)	MMCPrivate	9	24	f	\N	IS	1	NumberOfTasks	X
10534	(0009,"MMCPrivate",19)	(0009,"MMCPrivate",19)	MMCPrivate	9	25	f	\N	SH	1	IsFlagRaised	X
10535	(0009,"MMCPrivate",1a)	(0009,"MMCPrivate",1a)	MMCPrivate	9	26	f	\N	SH	1	IsArchived	X
10536	(0009,"MMCPrivate",1b)	(0009,"MMCPrivate",1b)	MMCPrivate	9	27	f	\N	SH	1	IsDefault	X
10541	(0009,"MMCPrivate",20)	(0009,"MMCPrivate",20)	MMCPrivate	9	32	f	\N	UI	1	TaskInfoObjectID	X
10542	(0009,"MMCPrivate",21)	(0009,"MMCPrivate",21)	MMCPrivate	9	33	f	\N	LO	1	Name	X
10543	(0009,"MMCPrivate",22)	(0009,"MMCPrivate",22)	MMCPrivate	9	34	f	\N	SH	1	TaskStatus	X
10544	(0009,"MMCPrivate",23)	(0009,"MMCPrivate",23)	MMCPrivate	9	35	f	\N	SH	1	TaskPriority	X
10545	(0009,"MMCPrivate",24)	(0009,"MMCPrivate",24)	MMCPrivate	9	36	f	\N	SH	1	Leaf	X
10546	(0009,"MMCPrivate",25)	(0009,"MMCPrivate",25)	MMCPrivate	9	37	f	\N	LO	1	TaskID	X
10547	(0009,"MMCPrivate",26)	(0009,"MMCPrivate",26)	MMCPrivate	9	38	f	\N	IS	1	Frequency	K
10548	(0009,"MMCPrivate",27)	(0009,"MMCPrivate",27)	MMCPrivate	9	39	f	\N	SH	1	UpdateFlag	X
10549	(0009,"MMCPrivate",28)	(0009,"MMCPrivate",28)	MMCPrivate	9	40	f	\N	SH	1	Directory	X
10550	(0009,"MMCPrivate",29)	(0009,"MMCPrivate",29)	MMCPrivate	9	41	f	\N	LO	1	Comments	X
10551	(0009,"MMCPrivate",2a)	(0009,"MMCPrivate",2a)	MMCPrivate	9	42	f	\N	SH	1	Category	X
10552	(0009,"MMCPrivate",2b)	(0009,"MMCPrivate",2b)	MMCPrivate	9	43	f	\N	LO	1	Region	K
10553	(0009,"MMCPrivate",2c)	(0009,"MMCPrivate",2c)	MMCPrivate	9	44	f	\N	SH	1	Laterality	K
10554	(0009,"MMCPrivate",2d)	(0009,"MMCPrivate",2d)	MMCPrivate	9	45	f	\N	TM	1	ScanTime	K
10555	(0009,"MMCPrivate",2e)	(0009,"MMCPrivate",2e)	MMCPrivate	9	46	f	\N	LO	1	ContrastMedium	K
10556	(0009,"MMCPrivate",2f)	(0009,"MMCPrivate",2f)	MMCPrivate	9	47	f	\N	LO	1	CreateDateTime	X
10557	(0009,"MMCPrivate",30)	(0009,"MMCPrivate",30)	MMCPrivate	9	48	f	\N	LO	1	Creator	X
10558	(0009,"MMCPrivate",31)	(0009,"MMCPrivate",31)	MMCPrivate	9	49	f	\N	LO	1	SiteName	X
10559	(0009,"MMCPrivate",32)	(0009,"MMCPrivate",32)	MMCPrivate	9	50	f	\N	LO	1	ReferringPhysician	X
10560	(0009,"MMCPrivate",33)	(0009,"MMCPrivate",33)	MMCPrivate	9	51	f	\N	LO	1	Radiologist	X
10561	(0009,"MMCPrivate",34)	(0009,"MMCPrivate",34)	MMCPrivate	9	52	f	\N	LO	1	Technologist	X
10562	(0009,"MMCPrivate",35)	(0009,"MMCPrivate",35)	MMCPrivate	9	53	f	\N	UI	1	TaskUid	X
10563	(0009,"MMCPrivate",36)	(0009,"MMCPrivate",36)	MMCPrivate	9	54	f	\N	UI	1	TaskInfoUid	X
10564	(0009,"MMCPrivate",37)	(0009,"MMCPrivate",37)	MMCPrivate	9	55	f	\N	SH	1	IsInLibrary	X
10565	(0009,"MMCPrivate",38)	(0009,"MMCPrivate",38)	MMCPrivate	9	56	f	\N	IS	1	TaskOrder	X
10566	(0009,"MMCPrivate",39)	(0009,"MMCPrivate",39)	MMCPrivate	9	57	f	\N	LO	1	Gating	K
10567	(0009,"MMCPrivate",3a)	(0009,"MMCPrivate",3a)	MMCPrivate	9	58	f	\N	SH	1	Plane	K
10568	(0009,"MMCPrivate",3b)	(0009,"MMCPrivate",3b)	MMCPrivate	9	59	f	\N	LO	1	SequenceType	K
10569	(0009,"MMCPrivate",3c)	(0009,"MMCPrivate",3c)	MMCPrivate	9	60	f	\N	SH	1	IsExecutive	X
10570	(0009,"MMCPrivate",3d)	(0009,"MMCPrivate",3d)	MMCPrivate	9	61	f	\N	ST	1	Note	X
10571	(0009,"MMCPrivate",3e)	(0009,"MMCPrivate",3e)	MMCPrivate	9	62	f	\N	SH	1	AutoStart	X
10572	(0009,"MMCPrivate",3f)	(0009,"MMCPrivate",3f)	MMCPrivate	9	63	f	\N	SH	1	AutoSave	X
10573	(0009,"MMCPrivate",40)	(0009,"MMCPrivate",40)	MMCPrivate	9	64	f	\N	SH	1	AutoArchive	X
10574	(0009,"MMCPrivate",41)	(0009,"MMCPrivate",41)	MMCPrivate	9	65	f	\N	IS	1	QueueGroupID	X
10575	(0009,"MMCPrivate",42)	(0009,"MMCPrivate",42)	MMCPrivate	9	66	f	\N	SH	1	IsFlagRaised	X
10576	(0009,"MMCPrivate",43)	(0009,"MMCPrivate",43)	MMCPrivate	9	67	f	\N	SH	1	IsArchived	X
10577	(0009,"MMCPrivate",44)	(0009,"MMCPrivate",44)	MMCPrivate	9	68	f	\N	SH	1	IsDefault	X
10578	(0009,"MMCPrivate",45)	(0009,"MMCPrivate",45)	MMCPrivate	9	69	f	\N	OB	1	TaskInfoAppData	X
10579	(0009,"MMCPrivate",46)	(0009,"MMCPrivate",46)	MMCPrivate	9	70	f	\N	SH	1	IsAllowCascadeSave	X
10580	(0009,"MMCPrivate",47)	(0009,"MMCPrivate",47)	MMCPrivate	9	71	f	\N	SH	1	IsAllowCascadeProtect	X
10581	(0009,"MMCPrivate",5f)	(0009,"MMCPrivate",5f)	MMCPrivate	9	95	f	\N	UI	1	ProtocolObjectID	X
10582	(0009,"MMCPrivate",60)	(0009,"MMCPrivate",60)	MMCPrivate	9	96	f	\N	OB	1	TaskInfoAppData	X
10583	(0009,"MMCPrivate",72)	(0009,"MMCPrivate",72)	MMCPrivate	9	114	f	\N	UI	1	ProtocolTaskInfoObjectID	X
10584	(0009,"MMCPrivate",73)	(0009,"MMCPrivate",73)	MMCPrivate	9	115	f	\N	IS	1	ProtocolTaskOrder	X
10585	(0009,"MMCPrivate",74)	(0009,"MMCPrivate",74)	MMCPrivate	9	116	f	\N	UI	1	ProtocolTaskUid	X
10586	(0009,"MMCPrivate",75)	(0009,"MMCPrivate",75)	MMCPrivate	9	117	f	\N	OB	1	ProtocolTaskAppData	X
10587	(0009,"MMCPrivate",76)	(0009,"MMCPrivate",76)	MMCPrivate	9	118	f	\N	SH	1	ProtocolTaskIsAllowCascadeSave	X
10588	(0009,"MMCPrivate",77)	(0009,"MMCPrivate",77)	MMCPrivate	9	119	f	\N	SH	1	ProtocolTaskIsAllowCascadeProtect	X
798	(0011,"GEMS_PATI_01",10)	(0011,"GEMS_PATI_01",10)	GEMS_PATI_01	17	16	f	\N	SS	1	PatientStatus	X
10589	(0011,"GEMS_PETD_01",02)	(0011,"GEMS_PETD_01",02)	GEMS_PETD_01	17	2	f	\N	UI	1	PET ROI.roi_id	X
10590	(0011,"GEMS_PETD_01",03)	(0011,"GEMS_PETD_01",03)	GEMS_PETD_01	17	3	f	\N	UI	1	PET ROI.image_id	X
10591	(0011,"GEMS_PETD_01",04)	(0011,"GEMS_PETD_01",04)	GEMS_PETD_01	17	4	f	\N	UI	1	PET ROI.compatible_version	X
10592	(0011,"GEMS_PETD_01",05)	(0011,"GEMS_PETD_01",05)	GEMS_PETD_01	17	5	f	\N	SH	1	PET ROI.software_version	X
10593	(0011,"GEMS_PETD_01",06)	(0011,"GEMS_PETD_01",06)	GEMS_PETD_01	17	6	f	\N	LO	1	PET ROI.roi_name	X
10594	(0011,"GEMS_PETD_01",07)	(0011,"GEMS_PETD_01",07)	GEMS_PETD_01	17	7	f	\N	DT	1	PET ROI.roi_datetime	X
10595	(0011,"GEMS_PETD_01",08)	(0011,"GEMS_PETD_01",08)	GEMS_PETD_01	17	8	f	\N	SL	1	PET ROI.roi_type	X
10596	(0011,"GEMS_PETD_01",09)	(0011,"GEMS_PETD_01",09)	GEMS_PETD_01	17	9	f	\N	FL	1	PET ROI.center_x	X
10597	(0011,"GEMS_PETD_01",0a)	(0011,"GEMS_PETD_01",0a)	GEMS_PETD_01	17	10	f	\N	FL	1	PET ROI.center_y	X
10598	(0011,"GEMS_PETD_01",0b)	(0011,"GEMS_PETD_01",0b)	GEMS_PETD_01	17	11	f	\N	FL	1	PET ROI.width	X
10599	(0011,"GEMS_PETD_01",0c)	(0011,"GEMS_PETD_01",0c)	GEMS_PETD_01	17	12	f	\N	FL	1	PET ROI.height	X
10600	(0011,"GEMS_PETD_01",0d)	(0011,"GEMS_PETD_01",0d)	GEMS_PETD_01	17	13	f	\N	FL	1	PET ROI.angle	X
10601	(0011,"GEMS_PETD_01",0e)	(0011,"GEMS_PETD_01",0e)	GEMS_PETD_01	17	14	f	\N	SL	1	PET ROI.number_of_points	X
10602	(0011,"GEMS_PETD_01",0f)	(0011,"GEMS_PETD_01",0f)	GEMS_PETD_01	17	15	f	\N	OB	1	PET ROI.roi_data	X
10603	(0011,"GEMS_PETD_01",10)	(0011,"GEMS_PETD_01",10)	GEMS_PETD_01	17	16	f	\N	SL	1	PET ROI.roi_size	X
10604	(0011,"GEMS_PETD_01",11)	(0011,"GEMS_PETD_01",11)	GEMS_PETD_01	17	17	f	\N	LO	1	PET ROI.color	X
10605	(0011,"GEMS_PETD_01",12)	(0011,"GEMS_PETD_01",12)	GEMS_PETD_01	17	18	f	\N	SL	1	PET ROI.line_type	X
10606	(0011,"GEMS_PETD_01",13)	(0011,"GEMS_PETD_01",13)	GEMS_PETD_01	17	19	f	\N	SL	1	PET ROI.line_width	X
10607	(0011,"GEMS_PETD_01",14)	(0011,"GEMS_PETD_01",14)	GEMS_PETD_01	17	20	f	\N	SL	1	PET ROI.roi_number	X
10608	(0011,"GEMS_PETD_01",15)	(0011,"GEMS_PETD_01",15)	GEMS_PETD_01	17	21	f	\N	SL	1	PET ROI.convex	X
10609	(0011,"GEMS_PETD_01",16)	(0011,"GEMS_PETD_01",16)	GEMS_PETD_01	17	22	f	\N	SL	1	PET ROI.atten_cor_flag	X
5856	(0013,"CTP",10)	(0013,"CTP",10)	CTP	19	16	f	\N	LO	1	Project Name	K
10610	(0013,"CTP",14)	(0013,"CTP",14)	CTP	19	20	f	\N	UN	1	Visibility	K
10611	(0013,"GEMS_PETD_01",02)	(0013,"GEMS_PETD_01",02)	GEMS_PETD_01	19	2	f	\N	UI	1	PET Annotation.annotation_id	X
10612	(0013,"GEMS_PETD_01",03)	(0013,"GEMS_PETD_01",03)	GEMS_PETD_01	19	3	f	\N	UI	1	PET Annotation.image_id	X
10613	(0013,"GEMS_PETD_01",04)	(0013,"GEMS_PETD_01",04)	GEMS_PETD_01	19	4	f	\N	SH	1	PET Annotation.compatible_version	X
10614	(0013,"GEMS_PETD_01",05)	(0013,"GEMS_PETD_01",05)	GEMS_PETD_01	19	5	f	\N	SH	1	PET Annotation.software_version	X
10615	(0013,"GEMS_PETD_01",06)	(0013,"GEMS_PETD_01",06)	GEMS_PETD_01	19	6	f	\N	SL	1	PET Annotation.type	X
10616	(0013,"GEMS_PETD_01",07)	(0013,"GEMS_PETD_01",07)	GEMS_PETD_01	19	7	f	\N	LO	1	PET Annotation.font_name	X
10617	(0013,"GEMS_PETD_01",08)	(0013,"GEMS_PETD_01",08)	GEMS_PETD_01	19	8	f	\N	SH	1	PET Annotation.font_size	X
10618	(0013,"GEMS_PETD_01",09)	(0013,"GEMS_PETD_01",09)	GEMS_PETD_01	19	9	f	\N	LO	1	PET Annotation.foreground_color	X
10619	(0013,"GEMS_PETD_01",0a)	(0013,"GEMS_PETD_01",0a)	GEMS_PETD_01	19	10	f	\N	LO	1	PET Annotation.background_color	X
10620	(0013,"GEMS_PETD_01",0b)	(0013,"GEMS_PETD_01",0b)	GEMS_PETD_01	19	11	f	\N	SL	1	PET Annotation.coordinate_system	X
10621	(0013,"GEMS_PETD_01",0c)	(0013,"GEMS_PETD_01",0c)	GEMS_PETD_01	19	12	f	\N	FL	1	PET Annotation.start_x	X
10622	(0013,"GEMS_PETD_01",0d)	(0013,"GEMS_PETD_01",0d)	GEMS_PETD_01	19	13	f	\N	FL	1	PET Annotation.start_y	X
10623	(0013,"GEMS_PETD_01",0e)	(0013,"GEMS_PETD_01",0e)	GEMS_PETD_01	19	14	f	\N	FL	1	PET Annotation.end_x	X
10624	(0013,"GEMS_PETD_01",0f)	(0013,"GEMS_PETD_01",0f)	GEMS_PETD_01	19	15	f	\N	FL	1	PET Annotation.end_y	X
10625	(0013,"GEMS_PETD_01",10)	(0013,"GEMS_PETD_01",10)	GEMS_PETD_01	19	16	f	\N	SL	1	PET Annotation.start_symbol	X
10626	(0013,"GEMS_PETD_01",11)	(0013,"GEMS_PETD_01",11)	GEMS_PETD_01	19	17	f	\N	SL	1	PET Annotation.end_symbol	X
10627	(0013,"GEMS_PETD_01",12)	(0013,"GEMS_PETD_01",12)	GEMS_PETD_01	19	18	f	\N	OB	1	PET Annotation.annotation_data	X
10628	(0013,"GEMS_PETD_01",13)	(0013,"GEMS_PETD_01",13)	GEMS_PETD_01	19	19	f	\N	SL	1	PET Annotation.annotation.size	X
10629	(0013,"GEMS_PETD_01",14)	(0013,"GEMS_PETD_01",14)	GEMS_PETD_01	19	20	f	\N	LO	1	PET Annotation.label_id	X
10630	(0015,"GEMS_PETD_01",1a)	(0015,"GEMS_PETD_01",1a)	GEMS_PETD_01	21	26	f	\N	US	1	Physio Gating Type	K
10631	(0015,"GEMS_PETD_01",1b)	(0015,"GEMS_PETD_01",1b)	GEMS_PETD_01	21	27	f	\N	US	1	Total Number of Bins	K
10632	(0015,"GEMS_PETD_01",1c)	(0015,"GEMS_PETD_01",1c)	GEMS_PETD_01	21	28	f	\N	US	1	% Phase Value	K
10633	(0015,"GEMS_PETD_01",1d)	(0015,"GEMS_PETD_01",1d)	GEMS_PETD_01	21	29	f	\N	SL	1	Phase Matched Series	K
10634	(0015,"GEMS_PETD_01",1e)	(0015,"GEMS_PETD_01",1e)	GEMS_PETD_01	21	30	f	\N	SL	1	CTAC Percent Value	K
10635	(0015,"GEMS_PETD_01",1f)	(0015,"GEMS_PETD_01",1f)	GEMS_PETD_01	21	31	f	\N	UL	1	PET Recon Parameters Exists	K
10636	(0015,"GEMS_PETD_01",20)	(0015,"GEMS_PETD_01",20)	GEMS_PETD_01	21	32	f	\N	SL	1	First Packet Number	K
10637	(0015,"GEMS_PETD_01",21)	(0015,"GEMS_PETD_01",21)	GEMS_PETD_01	21	33	f	\N	FL	1	IR Loop Filter Ratio	K
10638	(0015,"GEMS_PETD_01",22)	(0015,"GEMS_PETD_01",22)	GEMS_PETD_01	21	34	f	\N	FL	1	IR Loop Filter Correction	K
10639	(0015,"GEMS_PETD_01",23)	(0015,"GEMS_PETD_01",23)	GEMS_PETD_01	21	35	f	\N	UL	1	BP3d Filter FlagU	K
10640	(0015,"GEMS_PETD_01",24)	(0015,"GEMS_PETD_01",24)	GEMS_PETD_01	21	36	f	\N	FL	1	BP3d Filter CutoffU	K
10641	(0015,"GEMS_PETD_01",25)	(0015,"GEMS_PETD_01",25)	GEMS_PETD_01	21	37	f	\N	SL	1	BP3d Filter OrderU	K
10642	(0015,"GEMS_PETD_01",26)	(0015,"GEMS_PETD_01",26)	GEMS_PETD_01	21	38	f	\N	UL	1	BP3d Filter FlagV	K
10643	(0015,"GEMS_PETD_01",27)	(0015,"GEMS_PETD_01",27)	GEMS_PETD_01	21	39	f	\N	FL	1	BP3d Filter OrderV	K
10644	(0015,"GEMS_PETD_01",28)	(0015,"GEMS_PETD_01",28)	GEMS_PETD_01	21	40	f	\N	SL	1	BP3d Filter CutoffV	K
10645	(0015,"GEMS_PETD_01",29)	(0015,"GEMS_PETD_01",29)	GEMS_PETD_01	21	41	f	\N	UL	1	Decay Flag	K
10646	(0015,"GEMS_PETD_01",2e)	(0015,"GEMS_PETD_01",2e)	GEMS_PETD_01	21	46	f	\N	UL	1	Image filter 3d flag	K
10647	(0015,"GEMS_PETD_01",2f)	(0015,"GEMS_PETD_01",2f)	GEMS_PETD_01	21	47	f	\N	UL	1	WCC Cal Flag	K
10648	(0015,"GEMS_PETD_01",30)	(0015,"GEMS_PETD_01",30)	GEMS_PETD_01	21	48	f	\N	UL	1	Emission Scatter Flag	K
10649	(0015,"GEMS_PETD_01",31)	(0015,"GEMS_PETD_01",31)	GEMS_PETD_01	21	49	f	\N	UL	1	Recon Algorithm	K
10650	(0015,"GEMS_PETD_01",32)	(0015,"GEMS_PETD_01",32)	GEMS_PETD_01	21	50	f	\N	UL	1	Normalization Flag	K
10651	(0015,"GEMS_PETD_01",33)	(0015,"GEMS_PETD_01",33)	GEMS_PETD_01	21	51	f	\N	UL	1	Emission Deadtime Flag	K
10652	(0015,"GEMS_PETD_01",34)	(0015,"GEMS_PETD_01",34)	GEMS_PETD_01	21	52	f	\N	UL	1	Emission Random Flag	K
10653	(0015,"GEMS_PETD_01",35)	(0015,"GEMS_PETD_01",35)	GEMS_PETD_01	21	53	f	\N	UL	1	Blank Scan Flag	K
10993	(0119,"MRSC",1226)	(0119,"MRSC",26)	MRSC	281	38	t	12	DS	1-n	InPlaneRotation	K
10654	(0015,"GEMS_PETD_01",39)	(0015,"GEMS_PETD_01",39)	GEMS_PETD_01	21	57	f	\N	SL	1	Event histogram Format	K
10655	(0015,"GEMS_PETD_01",3a)	(0015,"GEMS_PETD_01",3a)	GEMS_PETD_01	21	58	f	\N	SL	1	Number of Detector Rows	K
10656	(0015,"GEMS_PETD_01",3b)	(0015,"GEMS_PETD_01",3b)	GEMS_PETD_01	21	59	f	\N	SL	1	Number of Detector Columns	K
10657	(0015,"GEMS_PETD_01",3c)	(0015,"GEMS_PETD_01",3c)	GEMS_PETD_01	21	60	f	\N	US	1	Recon Matrix Size	K
10658	(0015,"GEMS_PETD_01",3d)	(0015,"GEMS_PETD_01",3d)	GEMS_PETD_01	21	61	f	\N	UL	1	PET Sharp IR Flag	K
10659	(0015,"GEMS_PETD_01",3e)	(0015,"GEMS_PETD_01",3e)	GEMS_PETD_01	21	62	f	\N	UL	1	PET Scatter Limit	K
3441	(0017,"GEMS_PETD_01",02)	(0017,"GEMS_PETD_01",02)	GEMS_PETD_01	23	2	f	\N	SH	1	compatible_version	K
4958	(0019,"ADAC_IMG",02)	(0019,"ADAC_IMG",02)	ADAC_IMG	25	2	f	\N	IS	1	ADAC Pegasys File Size	X
275	(0019,"GEMS_ACQU_01",02)	(0019,"GEMS_ACQU_01",02)	GEMS_ACQU_01	25	2	f	\N	SL	1	NumberOfCellsInDetector	KB
298	(0019,"GEMS_ACQU_01",25)	(0019,"GEMS_ACQU_01",25)	GEMS_ACQU_01	25	37	f	\N	SS	1	MidScanFlag	KB
313	(0019,"GEMS_ACQU_01",40)	(0019,"GEMS_ACQU_01",40)	GEMS_ACQU_01	25	64	f	\N	SS	1	StatReconFlag	KB
314	(0019,"GEMS_ACQU_01",41)	(0019,"GEMS_ACQU_01",41)	GEMS_ACQU_01	25	65	f	\N	SS	1	ComputeType	KB
334	(0019,"GEMS_ACQU_01",6a)	(0019,"GEMS_ACQU_01",6a)	GEMS_ACQU_01	25	106	f	\N	SS	1	DependantOnNumberOfViewsProcessed	KB
360	(0019,"GEMS_ACQU_01",92)	(0019,"GEMS_ACQU_01",92)	GEMS_ACQU_01	25	146	f	\N	SL	1	SliceOffsetOnFrequencyAxis	KB
371	(0019,"GEMS_ACQU_01",9e)	(0019,"GEMS_ACQU_01",9e)	GEMS_ACQU_01	25	158	f	\N	LO	1	InternalPulseSequenceName	R
390	(0019,"GEMS_ACQU_01",b2)	(0019,"GEMS_ACQU_01",b2)	GEMS_ACQU_01	25	178	f	\N	DS	1	UserData	R
414	(0019,"GEMS_ACQU_01",cb)	(0019,"GEMS_ACQU_01",cb)	GEMS_ACQU_01	25	203	f	\N	SS	1	PrescribedFlowAxis	K
431	(0019,"GEMS_ACQU_01",dd)	(0019,"GEMS_ACQU_01",dd)	GEMS_ACQU_01	25	221	f	\N	SS	1	OverrangeCorrectionUsed	KB
3461	(0019,"GEMS_PETD_01",09)	(0019,"GEMS_PETD_01",09)	GEMS_PETD_01	25	9	f	\N	FL	1	activity_factor_hr	K
10660	(0019,"GEMS_PETD_01",18)	(0019,"GEMS_PETD_01",18)	GEMS_PETD_01	25	24	f	\N	UI	1	WCC Image Set ID	R
10661	(0019,"GE_YMS_NJ001",02)	(0019,"GE_YMS_NJ001",02)	GE_YMS_NJ001	25	2	f	\N	SL	1	Detector Channel	KB
10662	(0019,"GE_YMS_NJ001",23)	(0019,"GE_YMS_NJ001",23)	GE_YMS_NJ001	25	35	f	\N	DS	1	Table speed	KB
10663	(0019,"GE_YMS_NJ001",24)	(0019,"GE_YMS_NJ001",24)	GE_YMS_NJ001	25	36	f	\N	DS	1	Mid scan time	R
10664	(0019,"GE_YMS_NJ001",26)	(0019,"GE_YMS_NJ001",26)	GE_YMS_NJ001	25	38	f	\N	SL	1	Tube Azimuth	KB
10665	(0019,"GE_YMS_NJ001",27)	(0019,"GE_YMS_NJ001",27)	GE_YMS_NJ001	25	39	f	\N	DS	1	Gantry Velocity	KB
10666	(0019,"GE_YMS_NJ001",39)	(0019,"GE_YMS_NJ001",39)	GE_YMS_NJ001	25	57	f	\N	SS	1	SFOV type	KB
10667	(0019,"GE_YMS_NJ001",42)	(0019,"GE_YMS_NJ001",42)	GE_YMS_NJ001	25	66	f	\N	SS	1	Segment number	KB
10668	(0019,"GE_YMS_NJ001",43)	(0019,"GE_YMS_NJ001",43)	GE_YMS_NJ001	25	67	f	\N	SS	1	Total segments required	KB
5156	(0019,"MMCPrivate",04)	(0019,"MMCPrivate",04)	MMCPrivate	25	4	f	\N	DS	1	Max Fscalor	K
5157	(0019,"MMCPrivate",05)	(0019,"MMCPrivate",05)	MMCPrivate	25	5	f	\N	LO	1	Series Category Type	K
5160	(0019,"MMCPrivate",09)	(0019,"MMCPrivate",09)	MMCPrivate	25	9	f	\N	DS	1	Image Reconstruction Diameter	K
10669	(0019,"MMCPrivate",20)	(0019,"MMCPrivate",20)	MMCPrivate	25	32	f	\N	UI	1	MultiFrameSopInstanceUid	R
1404	(0019,"SIEMENS CT VA0  COAD",90)	(0019,"SIEMENS CT VA0  COAD",90)	SIEMENS CT VA0  COAD	25	144	f	\N	DS	1	OsteoOffset	R
8295	(0019,"SIEMENS CT VA0  COAD",b0)	(0019,"SIEMENS CT VA0  COAD",b0)	SIEMENS CT VA0  COAD	25	176	f	\N	DS	1	Feed per Rotation	K
8297	(0019,"SIEMENS CT VA0  COAD",be)	(0019,"SIEMENS CT VA0  COAD",be)	SIEMENS CT VA0  COAD	25	190	f	\N	DS	1	Expiratoric Reserve Volume	K
10670	(0019,"Siemens MED NM",0f)	(0019,"Siemens MED NM",0f)	Siemens MED NM	25	15	f	\N	SL	1-n	Siemens ICON Data Type	K
10671	(0019,"Siemens MED NM",a5)	(0019,"Siemens MED NM",a5)	Siemens MED NM	25	165	f	\N	SS	1-n	Number of repeats per phase	K
10672	(0019,"Siemens MED NM",a6)	(0019,"Siemens MED NM",a6)	Siemens MED NM	25	166	f	\N	SS	1-n	Cycles per repeat	K
10673	(0019,"Siemens MED NM",a7)	(0019,"Siemens MED NM",a7)	Siemens MED NM	25	167	f	\N	SL	1-n	Repeat start time	K
10674	(0019,"Siemens MED NM",a8)	(0019,"Siemens MED NM",a8)	Siemens MED NM	25	168	f	\N	SL	1-n	Repeat stop time	K
10675	(0019,"Siemens MED NM",a9)	(0019,"Siemens MED NM",a9)	Siemens MED NM	25	169	f	\N	SL	1-n	Effective repeat time	K
10676	(0019,"Siemens MED NM",aa)	(0019,"Siemens MED NM",aa)	Siemens MED NM	25	170	f	\N	SS	1-n	Acquired cycles per repeat	K
184	(0021,"FDMS 1.0",40)	(0021,"FDMS 1.0",40)	FDMS 1.0	33	64	f	\N	IS	1	ImageNoInTheSet	X
799	(0021,"GEMS_RELA_01",03)	(0021,"GEMS_RELA_01",03)	GEMS_RELA_01	33	3	f	\N	SS	1	SeriesFromWhichPrescribed	R
832	(0021,"GEMS_RELA_01",82)	(0021,"GEMS_RELA_01",82)	GEMS_RELA_01	33	130	f	\N	DS	1	AutoWindowLevelBeta	K
835	(0021,"GEMS_RELA_01",90)	(0021,"GEMS_RELA_01",90)	GEMS_RELA_01	33	144	f	\N	SS	1	TubeFocalSpotPosition	KB
837	(0021,"GEMS_RELA_01",92)	(0021,"GEMS_RELA_01",92)	GEMS_RELA_01	33	146	f	\N	FL	1	BiopsyTLocation	KB
1626	(0021,"SIEMENS MED",11)	(0021,"SIEMENS MED",11)	SIEMENS MED	33	17	f	\N	DS	2	Target	K
10677	(0021,"Siemens MED NM",00)	(0021,"Siemens MED NM",00)	Siemens MED NM	33	0	f	\N	OB	1	ECAT File Menu Header	X
10678	(0021,"Siemens MED NM",01)	(0021,"Siemens MED NM",01)	Siemens MED NM	33	1	f	\N	OB	1	ECAT File Subheader	X
10679	(0023,"GEMS_PETD_01",02)	(0023,"GEMS_PETD_01",02)	GEMS_PETD_01	35	2	f	\N	0B	1	PET raw_data_blob	R
3825	(0023,"GEMS_STDY_01",80)	(0023,"GEMS_STDY_01",80)	GEMS_STDY_01	35	128	f	\N	SQ	1	Has MPPS Related Tags	X
10680	(0023,"Siemens MED NM",01)	(0023,"Siemens MED NM",01)	Siemens MED NM	35	1	f	\N	US	1	DICOM Reader Flag	X
676	(0027,"GEMS_IMAG_01",1c)	(0027,"GEMS_IMAG_01",1c)	GEMS_IMAG_01	39	28	f	\N	SL	1	VmaMamp	KB
691	(0027,"GEMS_IMAG_01",44)	(0027,"GEMS_IMAG_01",44)	GEMS_IMAG_01	39	68	f	\N	FL	1	CenterSCoordOfPlaneImage	KB
10994	(0119,"MRSC",1230)	(0119,"MRSC",30)	MRSC	281	48	t	12	IS	1-n	ReSample	K
10681	(0027,"GE_YMS_NJ001",10)	(0027,"GE_YMS_NJ001",10)	GE_YMS_NJ001	39	16	f	\N	SS	1	Scout Type	KB
10682	(0027,"GE_YMS_NJ001",50)	(0027,"GE_YMS_NJ001",50)	GE_YMS_NJ001	39	80	f	\N	FL	1	Scan start location	KB
10683	(0027,"GE_YMS_NJ001",51)	(0027,"GE_YMS_NJ001",51)	GE_YMS_NJ001	39	81	f	\N	FL	1	Scan end location	KB
10684	(0029,"GEMS_CT_FLRO_01",01)	(0029,"GEMS_CT_FLRO_01",01)	GEMS_CT_FLRO_01	41	1	f	\N	SS	1	CT Int Fluoro	K
10685	(0029,"GEMS_CT_FLRO_01",02)	(0029,"GEMS_CT_FLRO_01",02)	GEMS_CT_FLRO_01	41	2	f	\N	DS	1	Image Precise Location	K
712	(0029,"GEMS_IMPS_01",06)	(0029,"GEMS_IMPS_01",06)	GEMS_IMPS_01	41	6	f	\N	DS	1	LowerRangeOfPixels	KB
716	(0029,"GEMS_IMPS_01",0a)	(0029,"GEMS_IMPS_01",0a)	GEMS_IMPS_01	41	10	f	\N	SS	1	LowerRangeOfPixels	KB
5197	(0029,"MMCPrivate",11)	(0029,"MMCPrivate",11)	MMCPrivate	41	17	f	\N	LO	1	Echo Allocation	K
5218	(0029,"MMCPrivate",29)	(0029,"MMCPrivate",29)	MMCPrivate	41	41	f	\N	DS	1	Table Position	K
5220	(0029,"MMCPrivate",2b)	(0029,"MMCPrivate",2b)	MMCPrivate	41	43	f	\N	DS	1	Navi Final Gate Width	K
5222	(0029,"MMCPrivate",2d)	(0029,"MMCPrivate",2d)	MMCPrivate	41	45	f	\N	DS	1	Navi Final Gate Position	K
5249	(0029,"MMCPrivate",48)	(0029,"MMCPrivate",48)	MMCPrivate	41	72	f	\N	CS	1	Respiratory Motion Compensation Technique	K
5274	(0029,"MMCPrivate",61)	(0029,"MMCPrivate",61)	MMCPrivate	41	97	f	\N	LO	1	Window Center and Width Explanation	K
5279	(0029,"MMCPrivate",66)	(0029,"MMCPrivate",66)	MMCPrivate	41	102	f	\N	CS	1	Inversion Recovery	K
5283	(0029,"MMCPrivate",6a)	(0029,"MMCPrivate",6a)	MMCPrivate	41	106	f	\N	CS	1	Partial Fourier	K
10686	(0029,"MMCPrivate",6c)	(0029,"MMCPrivate",6c)	MMCPrivate	41	108	f	\N	CS	1	ResonantNucleus	K
10687	(0029,"MMCPrivate",6d)	(0029,"MMCPrivate",6d)	MMCPrivate	41	109	f	\N	CS	1	KSpaceFiltering	K
10688	(0029,"MMCPrivate",6e)	(0029,"MMCPrivate",6e)	MMCPrivate	41	110	f	\N	CS	1	ApplicableSafetyStandardAgency	K
10689	(0029,"MMCPrivate",6f)	(0029,"MMCPrivate",6f)	MMCPrivate	41	111	f	\N	LO	1	ApplicableSafetyStandardDescription	K
5309	(0029,"MMCPrivate",88)	(0029,"MMCPrivate",88)	MMCPrivate	41	136	f	\N	US	1	MRAcquisition Frequency Encoding Steps	K
5335	(0029,"MMCPrivate",a2)	(0029,"MMCPrivate",a2)	MMCPrivate	41	162	f	\N	FD	1	Transmitter Frequency	K
5338	(0029,"MMCPrivate",a5)	(0029,"MMCPrivate",a5)	MMCPrivate	41	165	f	\N	FD	1	Velocity Encoding Direction	K
5344	(0029,"MMCPrivate",ab)	(0029,"MMCPrivate",ab)	MMCPrivate	41	171	f	\N	CS	1	Volumetric Properties	K
10690	(0029,"MMCPrivate",c6)	(0029,"MMCPrivate",c6)	MMCPrivate	41	198	f	\N	DS	1	SelectiveIROrientation	K
10691	(0029,"MMCPrivate",c7)	(0029,"MMCPrivate",c7)	MMCPrivate	41	199	f	\N	LO	1	SelectiveIRThickness	K
10692	(0029,"MMCPrivate",c8)	(0029,"MMCPrivate",c8)	MMCPrivate	41	200	f	\N	SH	1	RephaseOrderSlice	K
10693	(0029,"MMCPrivate",c9)	(0029,"MMCPrivate",c9)	MMCPrivate	41	201	f	\N	SH	1	RephaseOrderPhase	K
10694	(0029,"MMCPrivate",ca)	(0029,"MMCPrivate",ca)	MMCPrivate	41	202	f	\N	SH	1	RephaseOrderFreq	K
10695	(0029,"MMCPrivate",cb)	(0029,"MMCPrivate",cb)	MMCPrivate	41	203	f	\N	ST	1	MetaboliteMapDescription	K
10696	(0029,"MMCPrivate",cc)	(0029,"MMCPrivate",cc)	MMCPrivate	41	204	f	\N	SQ	1	volumeLocalizationSeq	K
10697	(0029,"MMCPrivate",cd)	(0029,"MMCPrivate",cd)	MMCPrivate	41	205	f	\N	FD	1	SlabThickness	K
10698	(0029,"MMCPrivate",ce)	(0029,"MMCPrivate",ce)	MMCPrivate	41	206	f	\N	FD	1	SlabOrientation	K
10699	(0029,"MMCPrivate",cf)	(0029,"MMCPrivate",cf)	MMCPrivate	41	207	f	\N	FD	1	MidSlabPosition	K
10700	(0029,"MMCPrivate",d1)	(0029,"MMCPrivate",d1)	MMCPrivate	41	209	f	\N	LO	1	IRThicknessRatio	K
10701	(0029,"MMCPrivate",d2)	(0029,"MMCPrivate",d2)	MMCPrivate	41	210	f	\N	LO	1	BBIRThicknessRatio	K
10702	(0029,"MMCPrivate",d4)	(0029,"MMCPrivate",d4)	MMCPrivate	41	212	f	\N	IS	1	MultiFrameFrameNumber	K
8853	(0029,"SIEMENS CSA ENVELOPE",10)	(0029,"SIEMENS CSA ENVELOPE",10)	SIEMENS CSA ENVELOPE	41	16	f	\N	OB	1	syngo Report Data	X
1632	(0029,"SIEMENS MEDCOM HEADER",08)	(0029,"SIEMENS MEDCOM HEADER",08)	SIEMENS MEDCOM HEADER	41	8	f	\N	CS	1	MedComHeaderType	R
1644	(0029,"SIEMENS MEDCOM HEADER",43)	(0029,"SIEMENS MEDCOM HEADER",43)	SIEMENS MEDCOM HEADER	41	67	f	\N	LO	1	ApplicationHeaderVersion	X
8631	(0029,"SIEMENS MEDCOM HEADER",70)	(0029,"SIEMENS MEDCOM HEADER",70)	SIEMENS MEDCOM HEADER	41	112	f	\N	SQ	1	Siemens Link Sequence	X
8636	(0029,"SIEMENS MEDCOM HEADER",75)	(0029,"SIEMENS MEDCOM HEADER",75)	SIEMENS MEDCOM HEADER	41	117	f	\N	OB	1	Referenced Object Device Location	X
8925	(0033,"SIEMENS MED NM",00)	(0033,"SIEMENS MED NM",00)	SIEMENS MED NM	51	0	f	\N	FL	1-n	Flood Correction Matrix Detector 1	K
8932	(0033,"SIEMENS MED NM",19)	(0033,"SIEMENS MED NM",19)	SIEMENS MED NM	51	25	f	\N	FL	1-n	NCO Data for detector 2	K
8935	(0033,"SIEMENS MED NM",21)	(0033,"SIEMENS MED NM",21)	SIEMENS MED NM	51	33	f	\N	FL	1	Gantry correction angle	K
8947	(0033,"SIEMENS MED NM",35)	(0033,"SIEMENS MED NM",35)	SIEMENS MED NM	51	53	f	\N	FL	1	Weight Factor Table For Coincidence Acquisitions	K
4540	(0039,"GEMS_0039",95)	(0039,"GEMS_0039",95)	GEMS_0039	57	149	f	\N	LO	1	Unknown	R
10703	(0040,"GEMS_HELIOS_01",19)	(0040,"GEMS_HELIOS_01",19)	GEMS_HELIOS_01	64	25	f	\N	SS	1	Air Calibration Date	X
10704	(0041,"MMCPrivate",01)	(0041,"MMCPrivate",01)	MMCPrivate	65	1	f	\N	OB	1	RawDataAppData	K
10705	(0041,"MMCPrivate",02)	(0041,"MMCPrivate",02)	MMCPrivate	65	2	f	\N	SQ	1	RawDataIndex	K
10706	(0041,"MMCPrivate",03)	(0041,"MMCPrivate",03)	MMCPrivate	65	3	f	\N	LO	1	ChannelNumber	K
10707	(0041,"MMCPrivate",04)	(0041,"MMCPrivate",04)	MMCPrivate	65	4	f	\N	LO	1	AxisDirection	K
10708	(0041,"MMCPrivate",05)	(0041,"MMCPrivate",05)	MMCPrivate	65	5	f	\N	LO	1	SlabNumbe	K
10709	(0041,"MMCPrivate",06)	(0041,"MMCPrivate",06)	MMCPrivate	65	6	f	\N	LO	1	CardiacPhaseNumbe	K
10710	(0041,"MMCPrivate",07)	(0041,"MMCPrivate",07)	MMCPrivate	65	7	f	\N	LO	1	EchoNumber	K
10711	(0041,"MMCPrivate",08)	(0041,"MMCPrivate",08)	MMCPrivate	65	8	f	\N	LO	1	SliceEncodeNumber	K
10712	(0041,"MMCPrivate",09)	(0041,"MMCPrivate",09)	MMCPrivate	65	9	f	\N	LO	1	NsaNumber	K
10713	(0041,"MMCPrivate",0a)	(0041,"MMCPrivate",0a)	MMCPrivate	65	10	f	\N	OB	1	RawData	K
10714	(0041,"MMCPrivate",0b)	(0041,"MMCPrivate",0b)	MMCPrivate	65	11	f	\N	SS	1	RawDataMRInfo	K
10715	(0041,"MMCPrivate",0c)	(0041,"MMCPrivate",0c)	MMCPrivate	65	12	f	\N	IS	1	NumberOfVoxels	K
10716	(0041,"MMCPrivate",0d)	(0041,"MMCPrivate",0d)	MMCPrivate	65	13	f	\N	DS	1	MixingTime	K
10717	(0041,"MMCPrivate",0e)	(0041,"MMCPrivate",0e)	MMCPrivate	65	14	f	\N	DS	1	ADDiff	K
10718	(0041,"MMCPrivate",0f)	(0041,"MMCPrivate",0f)	MMCPrivate	65	15	f	\N	LO	1	ScanTime	K
10719	(0041,"MMCPrivate",10)	(0041,"MMCPrivate",10)	MMCPrivate	65	16	f	\N	LO	1	NumPreSat	K
10720	(0041,"MMCPrivate",11)	(0041,"MMCPrivate",11)	MMCPrivate	65	17	f	\N	LO	1	IsStoredToPortableMedia	X
10721	(0041,"MMCPrivate",12)	(0041,"MMCPrivate",12)	MMCPrivate	65	18	f	\N	DS	1	Voi1	K
10722	(0041,"MMCPrivate",13)	(0041,"MMCPrivate",13)	MMCPrivate	65	19	f	\N	DS	1	Voi2	K
10723	(0041,"MMCPrivate",14)	(0041,"MMCPrivate",14)	MMCPrivate	65	20	f	\N	DS	1	VoxelSize	K
10724	(0041,"MMCPrivate",15)	(0041,"MMCPrivate",15)	MMCPrivate	65	21	f	\N	IS	1	FreqPoint	K
10725	(0041,"MMCPrivate",16)	(0041,"MMCPrivate",16)	MMCPrivate	65	22	f	\N	SH	1	LowOrderShim	K
10726	(0041,"MMCPrivate",17)	(0041,"MMCPrivate",17)	MMCPrivate	65	23	f	\N	SH	1	EccLevel	K
10727	(0041,"MMCPrivate",18)	(0041,"MMCPrivate",18)	MMCPrivate	65	24	f	\N	FL	1	FwhmHz	K
10728	(0041,"MMCPrivate",19)	(0041,"MMCPrivate",19)	MMCPrivate	65	25	f	\N	FL	1	FwhmPpm	K
10729	(0041,"MMCPrivate",1a)	(0041,"MMCPrivate",1a)	MMCPrivate	65	26	f	\N	FL	1	WaterSupRate	K
727	(0043,"GEMS_PARM_01",03)	(0043,"GEMS_PARM_01",03)	GEMS_PARM_01	67	3	f	\N	SS	1	GradientOffsetInY	K
747	(0043,"GEMS_PARM_01",17)	(0043,"GEMS_PARM_01",17)	GEMS_PARM_01	67	23	f	\N	DS	1	IBHImageScaleFactors	KB
766	(0043,"GEMS_PARM_01",2d)	(0043,"GEMS_PARM_01",2d)	GEMS_PARM_01	67	45	f	\N	SH	1	StringSlopField1	R
793	(0043,"GEMS_PARM_01",4e)	(0043,"GEMS_PARM_01",4e)	GEMS_PARM_01	67	78	f	\N	FL	4	DurationOfXrayOn	KB
3947	(0043,"GEMS_PARM_01",63)	(0043,"GEMS_PARM_01",63)	GEMS_PARM_01	67	99	f	\N	SH	1	Raw Data ID	R
3949	(0043,"GEMS_PARM_01",65)	(0043,"GEMS_PARM_01",65)	GEMS_PARM_01	67	101	f	\N	US	1	Motion Correction Indicator	KB
3977	(0043,"GEMS_PARM_01",82)	(0043,"GEMS_PARM_01",82)	GEMS_PARM_01	67	130	f	\N	LO	1-n	System Configuration Information	R
3986	(0043,"GEMS_PARM_01",8b)	(0043,"GEMS_PARM_01",8b)	GEMS_PARM_01	67	139	f	\N	OB	1	FMRI Binary Data Block	X
3998	(0043,"GEMS_PARM_01",97)	(0043,"GEMS_PARM_01",97)	GEMS_PARM_01	67	151	f	\N	LO	8	Image Filtering Parameters	R
10730	(0043,"GEMS_PARM_01",9b)	(0043,"GEMS_PARM_01",9b)	GEMS_PARM_01	67	155	f	\N	DS	1	NPW factor	K
10731	(0043,"GEMS_PARM_01",9c)	(0043,"GEMS_PARM_01",9c)	GEMS_PARM_01	67	156	f	\N	OB	1	Research Tag 1	X
10732	(0043,"GEMS_PARM_01",9d)	(0043,"GEMS_PARM_01",9d)	GEMS_PARM_01	67	157	f	\N	OB	1	Research Tag 2	X
10733	(0043,"GEMS_PARM_01",9e)	(0043,"GEMS_PARM_01",9e)	GEMS_PARM_01	67	158	f	\N	OB	1	Research Tag 3	X
10734	(0043,"GEMS_PARM_01",9f)	(0043,"GEMS_PARM_01",9f)	GEMS_PARM_01	67	159	f	\N	OB	1	Research Tag 4	X
10735	(0043,"GEMS_PARM_01",a0)	(0043,"GEMS_PARM_01",a0)	GEMS_PARM_01	67	160	f	\N	SQ	1	Spectroscopy Pixel Sequence	X
10736	(0043,"GEMS_PARM_01",a1)	(0043,"GEMS_PARM_01",a1)	GEMS_PARM_01	67	161	f	\N	SQ	1	Spectroscopy Default Display Sequence	X
10737	(0043,"GEMS_PARM_01",a2)	(0043,"GEMS_PARM_01",a2)	GEMS_PARM_01	67	162	f	\N	DS	1-n	MEF Data	R
10738	(0043,"GEMS_PARM_01",a3)	(0043,"GEMS_PARM_01",a3)	GEMS_PARM_01	67	163	f	\N	CS	1	ASL Contrast technique	R
10739	(0043,"GEMS_PARM_01",a4)	(0043,"GEMS_PARM_01",a4)	GEMS_PARM_01	67	164	f	\N	LO	1	Detailed text for ASL labeling technique	R
10740	(0043,"GEMS_PARM_01",a5)	(0043,"GEMS_PARM_01",a5)	GEMS_PARM_01	67	165	f	\N	IS	1	Duration of the label or control pulse	K
10741	(0043,"GEMS_PARM_01",a6)	(0043,"GEMS_PARM_01",a6)	GEMS_PARM_01	67	166	f	\N	DS	1	Offset frequency value for FastB1map	K
10742	(0043,"GEMS_PARM_01",a7)	(0043,"GEMS_PARM_01",a7)	GEMS_PARM_01	67	167	f	\N	DS	1	Motion Encoding Factor	K
10744	(0043,"GE_YMS_NJ001",12)	(0043,"GE_YMS_NJ001",12)	GE_YMS_NJ001	67	18	f	\N	SS	3	X-Ray Chain	KB
10745	(0043,"GE_YMS_NJ001",1e)	(0043,"GE_YMS_NJ001",1e)	GE_YMS_NJ001	67	30	f	\N	DS	1	Delta start time [msec]	KB
10746	(0043,"GE_YMS_NJ001",35)	(0043,"GE_YMS_NJ001",35)	GE_YMS_NJ001	67	53	f	\N	US	1	Infant Indicator	X
10747	(0043,"GE_YMS_NJ001",37)	(0043,"GE_YMS_NJ001",37)	GE_YMS_NJ001	67	55	f	\N	CS	1	Gantry Type	R
10748	(0043,"GE_YMS_NJ001",38)	(0043,"GE_YMS_NJ001",38)	GE_YMS_NJ001	67	56	f	\N	SH	1	Raw data ID	X
10749	(0043,"GE_YMS_NJ001",39)	(0043,"GE_YMS_NJ001",39)	GE_YMS_NJ001	67	57	f	\N	IS	1	Reconstruction Matrix	KB
10750	(0043,"GE_YMS_NJ001",40)	(0043,"GE_YMS_NJ001",40)	GE_YMS_NJ001	67	64	f	\N	CS	1-n	Image Filter	R
10751	(0043,"GE_YMS_NJ001",41)	(0043,"GE_YMS_NJ001",41)	GE_YMS_NJ001	67	65	f	\N	US	1	Prospective Addition Indicator	KB
10752	(0043,"GE_YMS_NJ001",43)	(0043,"GE_YMS_NJ001",43)	GE_YMS_NJ001	67	67	f	\N	US	1	Motion Correction Indicator	KB
10753	(0043,"GE_YMS_NJ001",44)	(0043,"GE_YMS_NJ001",44)	GE_YMS_NJ001	67	68	f	\N	US	1	Helical Correction Indicator	KB
10754	(0043,"GE_YMS_NJ001",45)	(0043,"GE_YMS_NJ001",45)	GE_YMS_NJ001	67	69	f	\N	US	1	Cine Correction Indicator	KB
10755	(0043,"GE_YMS_NJ001",46)	(0043,"GE_YMS_NJ001",46)	GE_YMS_NJ001	67	70	f	\N	US	1	IBO Correction Indicator	KB
10756	(0043,"GE_YMS_NJ001",47)	(0043,"GE_YMS_NJ001",47)	GE_YMS_NJ001	67	71	f	\N	US	1	BBH Correction Indicator	KB
10757	(0043,"GE_YMS_NJ001",48)	(0043,"GE_YMS_NJ001",48)	GE_YMS_NJ001	67	72	f	\N	US	1	Advanced Noise Reduction Indicator	KB
10758	(0043,"GE_YMS_NJ001",49)	(0043,"GE_YMS_NJ001",49)	GE_YMS_NJ001	67	73	f	\N	US	1	Scatter Correction Indicator	KB
10759	(0043,"GE_YMS_NJ001",4a)	(0043,"GE_YMS_NJ001",4a)	GE_YMS_NJ001	67	74	f	\N	DS	3	Recon Center Coordinates	KB
10995	(0119,"MRSC",1231)	(0119,"MRSC",31)	MRSC	281	49	t	12	IS	1-n	OrthogonalReFormat	K
10760	(0043,"GE_YMS_NJ001",50)	(0043,"GE_YMS_NJ001",50)	GE_YMS_NJ001	67	80	f	\N	US	1	Cross-Talk Correction Indicator	KB
10761	(0043,"GE_YMS_NJ001",51)	(0043,"GE_YMS_NJ001",51)	GE_YMS_NJ001	67	81	f	\N	US	1	Q-Cal Correction Indicator	KB
10762	(0043,"GE_YMS_NJ001",52)	(0043,"GE_YMS_NJ001",52)	GE_YMS_NJ001	67	82	f	\N	US	1	Afterglow Correction Indicator	KB
10763	(0043,"GE_YMS_NJ001",53)	(0043,"GE_YMS_NJ001",53)	GE_YMS_NJ001	67	83	f	\N	US	1	Local Decon Correction Indicator	KB
10764	(0043,"GE_YMS_NJ001",54)	(0043,"GE_YMS_NJ001",54)	GE_YMS_NJ001	67	84	f	\N	DS	1	Scan Start location	KB
10765	(0043,"GE_YMS_NJ001",55)	(0043,"GE_YMS_NJ001",55)	GE_YMS_NJ001	67	85	f	\N	DS	1	Scan End location	KB
10766	(0043,"GE_YMS_NJ001",56)	(0043,"GE_YMS_NJ001",56)	GE_YMS_NJ001	67	86	f	\N	IS	1	Detector Row	KB
10767	(0043,"GE_YMS_NJ001",57)	(0043,"GE_YMS_NJ001",57)	GE_YMS_NJ001	67	87	f	\N	CS	1	Tube Focus	R
8981	(0043,"SIEMENS MED NM",03)	(0043,"SIEMENS MED NM",03)	SIEMENS MED NM	67	3	f	\N	FL	1-n	View Dependent Y Shift MHR For Detector 1	K
4043	(0045,"GEMS_HELIOS_01",0a)	(0045,"GEMS_HELIOS_01",0a)	GEMS_HELIOS_01	69	10	f	\N	FL	1	Minimum DAS value	KB
4057	(0045,"GEMS_HELIOS_01",18)	(0045,"GEMS_HELIOS_01",18)	GEMS_HELIOS_01	69	24	f	\N	SS	1	Number of Views 1B	KB
10768	(0045,"GEMS_HELIOS_01",1a)	(0045,"GEMS_HELIOS_01",1a)	GEMS_HELIOS_01	69	26	f	\N	SS	1	Air Calibration Time	X
10769	(0045,"GEMS_HELIOS_01",1b)	(0045,"GEMS_HELIOS_01",1b)	GEMS_HELIOS_01	69	27	f	\N	SS	1	Phantom Calibration Date	X
10770	(0045,"GEMS_HELIOS_01",1c)	(0045,"GEMS_HELIOS_01",1c)	GEMS_HELIOS_01	69	28	f	\N	SS	1	Phantom Calibration Time	X
10771	(0045,"GEMS_HELIOS_01",1d)	(0045,"GEMS_HELIOS_01",1d)	GEMS_HELIOS_01	69	29	f	\N	SS	1	Z Slope Calibration Date	X
10772	(0045,"GEMS_HELIOS_01",1e)	(0045,"GEMS_HELIOS_01",1e)	GEMS_HELIOS_01	69	30	f	\N	SS	1	Z Slope Calibration Time	X
10773	(0045,"GEMS_HELIOS_01",1f)	(0045,"GEMS_HELIOS_01",1f)	GEMS_HELIOS_01	69	31	f	\N	SS	1	Cross Talk Calibration Date	X
10774	(0045,"GEMS_HELIOS_01",20)	(0045,"GEMS_HELIOS_01",20)	GEMS_HELIOS_01	69	32	f	\N	SS	1	Cross Talk Calibration Time	X
10775	(0045,"GEMS_HELIOS_01",34)	(0045,"GEMS_HELIOS_01",34)	GEMS_HELIOS_01	69	52	f	\N	CS	1	ActualPctRpeakDelay	R
10776	(0045,"GEMS_HELIOS_01",3f)	(0045,"GEMS_HELIOS_01",3f)	GEMS_HELIOS_01	69	63	f	\N	IS	1	RPeakTimeDelay	R
10777	(0045,"GEMS_HELIOS_01",44)	(0045,"GEMS_HELIOS_01",44)	GEMS_HELIOS_01	69	68	f	\N	IS	1	ActualRPeakTimeDelay	R
10778	(0045,"GEMS_HELIOS_01",45)	(0045,"GEMS_HELIOS_01",45)	GEMS_HELIOS_01	69	69	f	\N	ST	1	CardiacScanOption	R
4099	(0049,"GEMS_CT_CARDIAC_001",01)	(0049,"GEMS_CT_CARDIAC_001",01)	GEMS_CT_CARDIAC_001	73	1	f	\N	SQ	1	CT Cardiac Sequence	R
4103	(0049,"GEMS_CT_CARDIAC_001",05)	(0049,"GEMS_CT_CARDIAC_001",05)	GEMS_CT_CARDIAC_001	73	5	f	\N	CS	1	MaxHeartRatePriorToConfirm	R
10779	(0049,"GEMS_CT_CARDIAC_001",16)	(0049,"GEMS_CT_CARDIAC_001",16)	GEMS_CT_CARDIAC_001	73	22	f	\N	SH	1	EkgGatingType	R
10780	(0049,"GEMS_CT_CARDIAC_001",1b)	(0049,"GEMS_CT_CARDIAC_001",1b)	GEMS_CT_CARDIAC_001	73	27	f	\N	FL	1	Ekg Wave Time Off First Data Point	KB
10781	(0049,"GEMS_CT_CARDIAC_001",22)	(0049,"GEMS_CT_CARDIAC_001",22)	GEMS_CT_CARDIAC_001	73	34	f	\N	CS	1	TemporalAlg	R
10782	(0049,"GEMS_CT_CARDIAC_001",23)	(0049,"GEMS_CT_CARDIAC_001",23)	GEMS_CT_CARDIAC_001	73	35	f	\N	CS	1	PhaseLocation	R
10783	(0049,"GEMS_CT_CARDIAC_001",24)	(0049,"GEMS_CT_CARDIAC_001",24)	GEMS_CT_CARDIAC_001	73	36	f	\N	OW	1	PreBlendedCycle1	X
10784	(0049,"GEMS_CT_CARDIAC_001",25)	(0049,"GEMS_CT_CARDIAC_001",25)	GEMS_CT_CARDIAC_001	73	37	f	\N	OW	1	PreBlendedCycle2	X
10785	(0049,"GEMS_CT_CARDIAC_001",26)	(0049,"GEMS_CT_CARDIAC_001",26)	GEMS_CT_CARDIAC_001	73	38	f	\N	CS	1	CompressionAlg	R
10786	(004b,"GEMS_HINO_CT_01",01)	(004b,"GEMS_HINO_CT_01",01)	GEMS_HINO_CT_01	75	1	f	\N	DS	1-n	Beam Thickness	KB
10787	(004b,"GEMS_HINO_CT_01",02)	(004b,"GEMS_HINO_CT_01",02)	GEMS_HINO_CT_01	75	2	f	\N	DS	1-n	R Time	R
10788	(004b,"GEMS_HINO_CT_01",03)	(004b,"GEMS_HINO_CT_01",03)	GEMS_HINO_CT_01	75	3	f	\N	IS	1	HBC number	R
10789	(004b,"GE_YMS_NJ001",01)	(004b,"GE_YMS_NJ001",01)	GE_YMS_NJ001	75	1	f	\N	DS	1-n	Beam Thickness	KB
10790	(004b,"GE_YMS_NJ001",02)	(004b,"GE_YMS_NJ001",02)	GE_YMS_NJ001	75	2	f	\N	DS	1-n	R Time	R
10791	(004b,"GE_YMS_NJ001",03)	(004b,"GE_YMS_NJ001",03)	GE_YMS_NJ001	75	3	f	\N	IS	1	HBC number	R
10792	(0051,"GEHC_CT_ADVAPP_001",01)	(0051,"GEHC_CT_ADVAPP_001",01)	GEHC_CT_ADVAPP_001	81	1	f	\N	SQ	1	CTVESSequence	X
4637	(0051,"GEMS_FUNCTOOL_01",01)	(0051,"GEMS_FUNCTOOL_01",01)	GEMS_FUNCTOOL_01	81	1	f	\N	LO	1	Group Name	R
4644	(0051,"GEMS_FUNCTOOL_01",08)	(0051,"GEMS_FUNCTOOL_01",08)	GEMS_FUNCTOOL_01	81	8	f	\N	SL	1	Color Ramp Index	K
10793	(0053,"GEHC_CT_ADVAPP_001",01)	(0053,"GEHC_CT_ADVAPP_001",01)	GEHC_CT_ADVAPP_001	83	1	f	\N	FL	1-n	MultiEnergyNoiseRedBlendingFact	KB
10794	(0053,"GEHC_CT_ADVAPP_001",02)	(0053,"GEHC_CT_ADVAPP_001",02)	GEHC_CT_ADVAPP_001	83	2	f	\N	FL	1-n	MultiEnergyNoiseRedScaleFact	KB
10795	(0053,"GEHC_CT_ADVAPP_001",03)	(0053,"GEHC_CT_ADVAPP_001",03)	GEHC_CT_ADVAPP_001	83	3	f	\N	IS	2	MultiEnergyMDTransformEnergies	KB
10796	(0053,"GEHC_CT_ADVAPP_001",21)	(0053,"GEHC_CT_ADVAPP_001",21)	GEHC_CT_ADVAPP_001	83	33	f	\N	IS	1	TableSpeedNotReachesTargetFlag	K
4535	(0053,"GEHC_CT_ADVAPP_001",60)	(0053,"GEHC_CT_ADVAPP_001",60)	GEHC_CT_ADVAPP_001	83	96	f	\N	SH	1	Recon Flip RotateA nno	R
10797	(0053,"GEHC_CT_ADVAPP_001",63)	(0053,"GEHC_CT_ADVAPP_001",63)	GEHC_CT_ADVAPP_001	83	99	f	\N	CS	1	Image Position Patient Setting	R
10798	(0053,"GEHC_CT_ADVAPP_001",64)	(0053,"GEHC_CT_ADVAPP_001",64)	GEHC_CT_ADVAPP_001	83	100	f	\N	IS	1	Shutter Mode	K
10799	(0053,"GEHC_CT_ADVAPP_001",65)	(0053,"GEHC_CT_ADVAPP_001",65)	GEHC_CT_ADVAPP_001	83	101	f	\N	IS	1	Shutter Mode Percent	KB
10800	(0053,"GEHC_CT_ADVAPP_001",66)	(0053,"GEHC_CT_ADVAPP_001",66)	GEHC_CT_ADVAPP_001	83	102	f	\N	LO	1	Image Browser Annotation	R
10801	(0053,"GEHC_CT_ADVAPP_001",67)	(0053,"GEHC_CT_ADVAPP_001",67)	GEHC_CT_ADVAPP_001	83	103	f	\N	IS	1	Overlapped Recon Flag	KB
10802	(0053,"GEHC_CT_ADVAPP_001",68)	(0053,"GEHC_CT_ADVAPP_001",68)	GEHC_CT_ADVAPP_001	83	104	f	\N	IS	1	Row Number Anotation Flag	K
10803	(0053,"GEHC_CT_ADVAPP_001",70)	(0053,"GEHC_CT_ADVAPP_001",70)	GEHC_CT_ADVAPP_001	83	112	f	\N	IS	1	MultiEnergySourceCount	KB
10804	(0053,"GEHC_CT_ADVAPP_001",71)	(0053,"GEHC_CT_ADVAPP_001",71)	GEHC_CT_ADVAPP_001	83	113	f	\N	LO	1	MultiEnergyScanType	R
10805	(0053,"GEHC_CT_ADVAPP_001",72)	(0053,"GEHC_CT_ADVAPP_001",72)	GEHC_CT_ADVAPP_001	83	114	f	\N	LO	1	MultiEnergyReconType	R
10806	(0053,"GEHC_CT_ADVAPP_001",73)	(0053,"GEHC_CT_ADVAPP_001",73)	GEHC_CT_ADVAPP_001	83	115	f	\N	LO	1	MultiEnergyImageType	R
10807	(0053,"GEHC_CT_ADVAPP_001",74)	(0053,"GEHC_CT_ADVAPP_001",74)	GEHC_CT_ADVAPP_001	83	116	f	\N	LO	1	MultiEnergyMaterialType	R
10808	(0053,"GEHC_CT_ADVAPP_001",75)	(0053,"GEHC_CT_ADVAPP_001",75)	GEHC_CT_ADVAPP_001	83	117	f	\N	DS	1	MonchromaticEnergy	KB
10809	(0053,"GEHC_CT_ADVAPP_001",76)	(0053,"GEHC_CT_ADVAPP_001",76)	GEHC_CT_ADVAPP_001	83	118	f	\N	DS	1	multiEnergyWeightedSubractionWidth1	KB
10810	(0053,"GEHC_CT_ADVAPP_001",77)	(0053,"GEHC_CT_ADVAPP_001",77)	GEHC_CT_ADVAPP_001	83	119	f	\N	DS	1	MultiEnergyWeightedSubractionWidth2	KB
10811	(0053,"GEHC_CT_ADVAPP_001",78)	(0053,"GEHC_CT_ADVAPP_001",78)	GEHC_CT_ADVAPP_001	83	120	f	\N	LO	1	MultiEnergyWeightedSubtractionType	R
10812	(0053,"GEHC_CT_ADVAPP_001",79)	(0053,"GEHC_CT_ADVAPP_001",79)	GEHC_CT_ADVAPP_001	83	121	f	\N	LO	1	MultiEnergyAcqMethod	R
10813	(0053,"GEHC_CT_ADVAPP_001",7a)	(0053,"GEHC_CT_ADVAPP_001",7a)	GEHC_CT_ADVAPP_001	83	122	f	\N	SH	1	MultiEnergyFeatAnnotName	R
10814	(0053,"GEHC_CT_ADVAPP_001",7b)	(0053,"GEHC_CT_ADVAPP_001",7b)	GEHC_CT_ADVAPP_001	83	123	f	\N	SH	1	MultiEnergyNoiseReduced	R
10815	(0053,"GEHC_CT_ADVAPP_001",7c)	(0053,"GEHC_CT_ADVAPP_001",7c)	GEHC_CT_ADVAPP_001	83	124	f	\N	LO	1	MultiEnergyNoiseReducdeMethod	R
10816	(0053,"GEHC_CT_ADVAPP_001",7d)	(0053,"GEHC_CT_ADVAPP_001",7d)	GEHC_CT_ADVAPP_001	83	125	f	\N	LO	1	SubOptimalIQString	R
10817	(0053,"GEHC_CT_ADVAPP_001",7e)	(0053,"GEHC_CT_ADVAPP_001",7e)	GEHC_CT_ADVAPP_001	83	126	f	\N	DS	1	MultiEnergyHighLowRatio	KB
10818	(0053,"GEHC_CT_ADVAPP_001",83)	(0053,"GEHC_CT_ADVAPP_001",83)	GEHC_CT_ADVAPP_001	83	131	f	\N	DS	1	AnnotationmA	KB
10819	(0053,"GEHC_CT_ADVAPP_001",84)	(0053,"GEHC_CT_ADVAPP_001",84)	GEHC_CT_ADVAPP_001	83	132	f	\N	DS	1	CommandedFirstkVp	KB
10820	(0053,"GEHC_CT_ADVAPP_001",85)	(0053,"GEHC_CT_ADVAPP_001",85)	GEHC_CT_ADVAPP_001	83	133	f	\N	DS	1	CommandedFirstmA	KB
10821	(0053,"GEHC_CT_ADVAPP_001",86)	(0053,"GEHC_CT_ADVAPP_001",86)	GEHC_CT_ADVAPP_001	83	134	f	\N	DS	1	CommandedSecondkVp	KB
10822	(0053,"GEHC_CT_ADVAPP_001",87)	(0053,"GEHC_CT_ADVAPP_001",87)	GEHC_CT_ADVAPP_001	83	135	f	\N	DS	1	CommandedSecondmA	KB
10823	(0053,"GEHC_CT_ADVAPP_001",88)	(0053,"GEHC_CT_ADVAPP_001",88)	GEHC_CT_ADVAPP_001	83	136	f	\N	SH	1	MultiEnergyKVAnnotName	R
10824	(0053,"GEHC_CT_ADVAPP_001",89)	(0053,"GEHC_CT_ADVAPP_001",89)	GEHC_CT_ADVAPP_001	83	137	f	\N	SH	1	MultiEnergyKVUnitLabel	R
10825	(0053,"GEHC_CT_ADVAPP_001",8a)	(0053,"GEHC_CT_ADVAPP_001",8a)	GEHC_CT_ADVAPP_001	83	138	f	\N	LO	1	MaterialType#1	R
10826	(0053,"GEHC_CT_ADVAPP_001",8b)	(0053,"GEHC_CT_ADVAPP_001",8b)	GEHC_CT_ADVAPP_001	83	139	f	\N	LO	1	MaterialType#2	R
10827	(0053,"GEHC_CT_ADVAPP_001",8c)	(0053,"GEHC_CT_ADVAPP_001",8c)	GEHC_CT_ADVAPP_001	83	140	f	\N	LO	1	GSIScanModePreset	R
10828	(0053,"GEHC_CT_ADVAPP_001",8d)	(0053,"GEHC_CT_ADVAPP_001",8d)	GEHC_CT_ADVAPP_001	83	141	f	\N	IS	1	MonoWindowLow	KB
10829	(0053,"GEHC_CT_ADVAPP_001",8e)	(0053,"GEHC_CT_ADVAPP_001",8e)	GEHC_CT_ADVAPP_001	83	142	f	\N	IS	1	MonoWindoHigh	KB
10830	(0053,"GEHC_CT_ADVAPP_001",8f)	(0053,"GEHC_CT_ADVAPP_001",8f)	GEHC_CT_ADVAPP_001	83	143	f	\N	FL	1-143	MD1AttenuationCurve	KB
10831	(0053,"GEHC_CT_ADVAPP_001",92)	(0053,"GEHC_CT_ADVAPP_001",92)	GEHC_CT_ADVAPP_001	83	146	f	\N	DS	1	MD1intercept	KB
10832	(0053,"GEHC_CT_ADVAPP_001",93)	(0053,"GEHC_CT_ADVAPP_001",93)	GEHC_CT_ADVAPP_001	83	147	f	\N	DS	1	MD1slope	KB
10833	(0053,"GEHC_CT_ADVAPP_001",95)	(0053,"GEHC_CT_ADVAPP_001",95)	GEHC_CT_ADVAPP_001	83	149	f	\N	OW	1	MD1supportData	X
10834	(0053,"GEHC_CT_ADVAPP_001",96)	(0053,"GEHC_CT_ADVAPP_001",96)	GEHC_CT_ADVAPP_001	83	150	f	\N	OW	1	MD2supportData	X
10835	(0053,"GEHC_CT_ADVAPP_001",97)	(0053,"GEHC_CT_ADVAPP_001",97)	GEHC_CT_ADVAPP_001	83	151	f	\N	OW	1	NM1data	X
10836	(0053,"GEHC_CT_ADVAPP_001",98)	(0053,"GEHC_CT_ADVAPP_001",98)	GEHC_CT_ADVAPP_001	83	152	f	\N	DS	1	MD2intercept	KB
10837	(0053,"GEHC_CT_ADVAPP_001",99)	(0053,"GEHC_CT_ADVAPP_001",99)	GEHC_CT_ADVAPP_001	83	153	f	\N	DS	1	MD2slope	KB
10838	(0053,"GEHC_CT_ADVAPP_001",9a)	(0053,"GEHC_CT_ADVAPP_001",9a)	GEHC_CT_ADVAPP_001	83	154	f	\N	OW	1	NM2data	X
10839	(0053,"GEHC_CT_ADVAPP_001",9b)	(0053,"GEHC_CT_ADVAPP_001",9b)	GEHC_CT_ADVAPP_001	83	155	f	\N	FL	1-143	MD2attenuationCurve	KB
10840	(0053,"GEHC_CT_ADVAPP_001",9c)	(0053,"GEHC_CT_ADVAPP_001",9c)	GEHC_CT_ADVAPP_001	83	156	f	\N	SH	1	GSIdataVersion	R
10841	(0053,"GEHC_CT_ADVAPP_001",9e)	(0053,"GEHC_CT_ADVAPP_001",9e)	GEHC_CT_ADVAPP_001	83	158	f	\N	IS	1	MultiEnergyNumNoiseRedPair	KB
10842	(0053,"GEHC_CT_ADVAPP_001",9f)	(0053,"GEHC_CT_ADVAPP_001",9f)	GEHC_CT_ADVAPP_001	83	159	f	\N	LO	1-n	MultiEnergyNoiseRedPairString	R
8993	(0055,"SIEMENS MED NM",04)	(0055,"SIEMENS MED NM",04)	SIEMENS MED NM	85	4	f	\N	SS	1	Prompt Window Width	K
9021	(0057,"SIEMENS MED NM",01)	(0057,"SIEMENS MED NM",01)	SIEMENS MED NM	87	1	f	\N	LO	1	Syngo MI DICOM Original Image Type	K
9042	(0061,"SIEMENS MED NM",0f)	(0061,"SIEMENS MED NM",0f)	SIEMENS MED NM	97	15	f	\N	FL	1-n	X Focal Scaling	K
9054	(0061,"SIEMENS MED NM",23)	(0061,"SIEMENS MED NM",23)	SIEMENS MED NM	97	35	f	\N	FL	1-n	Recon Selected Angular Range	K
9079	(0061,"SIEMENS MED NM",52)	(0061,"SIEMENS MED NM",52)	SIEMENS MED NM	97	82	f	\N	LT	1	LowRes CT Series UID	R
10843	(0071,"MMCPrivate",01)	(0071,"MMCPrivate",01)	MMCPrivate	113	1	f	\N	FL	1	ForegroundTransparency	K
10844	(0071,"MMCPrivate",02)	(0071,"MMCPrivate",02)	MMCPrivate	113	2	f	\N	LO	1	IsDisplayBackgroundImage	K
10845	(0071,"MMCPrivate",03)	(0071,"MMCPrivate",03)	MMCPrivate	113	3	f	\N	FL	1	ForegroundHorizontalShift	K
10846	(0071,"MMCPrivate",04)	(0071,"MMCPrivate",04)	MMCPrivate	113	4	f	\N	FL	1	ForegroundVerticalShift	K
10996	(0119,"MRSC",1240)	(0119,"MRSC",40)	MRSC	281	64	t	12	IS	1	LPCCVersion	K
10847	(0071,"MMCPrivate",05)	(0071,"MMCPrivate",05)	MMCPrivate	113	5	f	\N	FL	1	ForegroundRotationAngle	K
10848	(0071,"MMCPrivate",06)	(0071,"MMCPrivate",06)	MMCPrivate	113	6	f	\N	FL	1	ForegroundMagnification	K
10849	(0071,"MMCPrivate",07)	(0071,"MMCPrivate",07)	MMCPrivate	113	7	f	\N	OB	1	ApplicationData	K
3009	(00e1,"ELSCINT1",21)	(00e1,"ELSCINT1",21)	ELSCINT1	225	33	f	\N	DS	1	DLP Total	K
3035	(00e1,"ELSCINT1",c2)	(00e1,"ELSCINT1",c2)	ELSCINT1	225	194	f	\N	UI	1	Unknown	R
10850	(0117,"MRSC",10)	(0117,"MRSC",10)	MRSC	279	16	f	\N	SQ	1	PESERParameterSequence	K
10851	(0117,"MRSC",12)	(0117,"MRSC",12)	MRSC	279	18	f	\N	CS	1	PESERParameterType	K
10852	(0117,"MRSC",14)	(0117,"MRSC",14)	MRSC	279	20	f	\N	LO	1	PESERParameterName	K
10853	(0117,"MRSC",16)	(0117,"MRSC",16)	MRSC	279	22	f	\N	LO	1	PESERParameterDescription	K
10854	(0117,"MRSC",18)	(0117,"MRSC",18)	MRSC	279	24	f	\N	DS	1-n	PESERParameterFloatingValue	K
10855	(0117,"MRSC",19)	(0117,"MRSC",19)	MRSC	279	25	f	\N	IS	1-n	PESERParameterIntegerValue	K
10856	(0117,"MRSC",1a)	(0117,"MRSC",1a)	MRSC	279	26	f	\N	LO	1-n	PESERParameterStringValue	K
10857	(0117,"MRSC",20)	(0117,"MRSC",20)	MRSC	279	32	f	\N	SQ	1	VOISequence	K
10858	(0117,"MRSC",22)	(0117,"MRSC",22)	MRSC	279	34	f	\N	SQ	1	OmitVOISequence	K
10859	(0117,"MRSC",24)	(0117,"MRSC",24)	MRSC	279	36	f	\N	SQ	1	ImageQualitySequence	K
10860	(0117,"MRSC",30)	(0117,"MRSC",30)	MRSC	279	48	f	\N	IS	1	NumberAcquiredTimePoints	K
10861	(0117,"MRSC",31)	(0117,"MRSC",31)	MRSC	279	49	f	\N	DS	1	AcquisitionDuration	K
10862	(0117,"MRSC",32)	(0117,"MRSC",32)	MRSC	279	50	f	\N	DS	1-n	AcquisitionStartTimes	K
10863	(0117,"MRSC",33)	(0117,"MRSC",33)	MRSC	279	51	f	\N	TM	1	InjectionTime	K
10864	(0117,"MRSC",34)	(0117,"MRSC",34)	MRSC	279	52	f	\N	DS	1-n	EffectiveAcquisitionDelay	K
10865	(0117,"MRSC",35)	(0117,"MRSC",35)	MRSC	279	53	f	\N	IS	3	SERTimingIndices	K
10866	(0117,"MRSC",3a)	(0117,"MRSC",3a)	MRSC	279	58	f	\N	LO	1	AcquisitionTimingMethod	K
10867	(0117,"MRSC",3b)	(0117,"MRSC",3b)	MRSC	279	59	f	\N	LT	1	AcquisitionTimingComments	K
10868	(0117,"MRSC",41)	(0117,"MRSC",41)	MRSC	279	65	f	\N	IS	1	ROIVOILPSFlag	K
10869	(0117,"MRSC",42)	(0117,"MRSC",42)	MRSC	279	66	f	\N	DS	3	VOILPSCenter	K
10870	(0117,"MRSC",43)	(0117,"MRSC",43)	MRSC	279	67	f	\N	DS	3	VOILPSWidthHalfLength	K
10871	(0117,"MRSC",44)	(0117,"MRSC",44)	MRSC	279	68	f	\N	DS	3	VOILPSHeightHalfLength	K
10872	(0117,"MRSC",45)	(0117,"MRSC",45)	MRSC	279	69	f	\N	DS	3	VOILPSDepthHalfLength	K
10873	(0117,"MRSC",46)	(0117,"MRSC",46)	MRSC	279	70	f	\N	CS	1	VOILPSType	K
10874	(0117,"MRSC",50)	(0117,"MRSC",50)	MRSC	279	80	f	\N	US	3	ProjectedROINPixels	K
10875	(0117,"MRSC",51)	(0117,"MRSC",51)	MRSC	279	81	f	\N	IS	1	ProjectedROIProjectionAxis	K
10876	(0117,"MRSC",52)	(0117,"MRSC",52)	MRSC	279	82	f	\N	IS	1	ProjectedROITransposeFlag	K
10877	(0117,"MRSC",53)	(0117,"MRSC",53)	MRSC	279	83	f	\N	US	1-n	ProjectedROIXVerts	K
10878	(0117,"MRSC",54)	(0117,"MRSC",54)	MRSC	279	84	f	\N	US	1-n	ProjectedROIYVerts	K
10879	(0117,"MRSC",55)	(0117,"MRSC",55)	MRSC	279	85	f	\N	US	2	ProjectedROIZRange	K
10880	(0117,"MRSC",56)	(0117,"MRSC",56)	MRSC	279	86	f	\N	CS	1	ProjectedROIType	K
10881	(0117,"MRSC",5a)	(0117,"MRSC",5a)	MRSC	279	90	f	\N	LO	1	ProjectedROILabel	K
10882	(0117,"MRSC",a1)	(0117,"MRSC",a1)	MRSC	279	161	f	\N	US	3	FTVPixelLimitsStart	K
10883	(0117,"MRSC",a2)	(0117,"MRSC",a2)	MRSC	279	162	f	\N	US	3	FTVPixelLimitsEnd	K
10884	(0117,"MRSC",a3)	(0117,"MRSC",a3)	MRSC	279	163	f	\N	CS	1	FTVBackgroundMethod	K
10885	(0117,"MRSC",a4)	(0117,"MRSC",a4)	MRSC	279	164	f	\N	DS	1	FTVBackgroundThreshold	K
10886	(0117,"MRSC",b0)	(0117,"MRSC",b0)	MRSC	279	176	f	\N	SQ	1	FTVSequence	K
10887	(0117,"MRSC",b1)	(0117,"MRSC",b1)	MRSC	279	177	f	\N	DS	1	FTVSERMinimum	K
10888	(0117,"MRSC",b2)	(0117,"MRSC",b2)	MRSC	279	178	f	\N	DS	1	FTVSERMaximum	K
10889	(0117,"MRSC",b3)	(0117,"MRSC",b3)	MRSC	279	179	f	\N	IS	1	FTVPixelCount	K
10890	(0117,"MRSC",b4)	(0117,"MRSC",b4)	MRSC	279	180	f	\N	DS	1	FTVcc	K
10891	(0117,"MRSC",b5)	(0117,"MRSC",b5)	MRSC	279	181	f	\N	LO	1	FTVLabel	K
10892	(0117,"MRSC",c0)	(0117,"MRSC",c0)	MRSC	279	192	f	\N	CS	1	QualityControlType	K
10893	(0117,"MRSC",c1)	(0117,"MRSC",c1)	MRSC	279	193	f	\N	LO	1	QualityControlFactor	K
10894	(0117,"MRSC",c2)	(0117,"MRSC",c2)	MRSC	279	194	f	\N	DS	1	QualityControlValue	K
10895	(0117,"MRSC",c3)	(0117,"MRSC",c3)	MRSC	279	195	f	\N	CS	1	QualityControlMeaning	K
10896	(0117,"MRSC",c4)	(0117,"MRSC",c4)	MRSC	279	196	f	\N	LT	1	QualityControlComment	K
10897	(0117,"MRSC",c5)	(0117,"MRSC",c5)	MRSC	279	197	f	\N	CS	1	ProtocolCompliantFlag	K
10898	(0117,"MRSC",c6)	(0117,"MRSC",c6)	MRSC	279	198	f	\N	LO	1-n	ProtocolNotCompliantReasons	K
10899	(0117,"MRSC",c7)	(0117,"MRSC",c7)	MRSC	279	199	f	\N	CS	1	ImagesAnalyzable	K
10900	(0117,"MRSC",c8)	(0117,"MRSC",c8)	MRSC	279	200	f	\N	LO	1-n	ProtocolNotCAnalyzableReasons	K
10901	(0119,"MRSC",1000)	(0119,"MRSC",00)	MRSC	281	0	t	10	DS	1	Version	K
10902	(0119,"MRSC",1006)	(0119,"MRSC",06)	MRSC	281	6	t	10	DS	1	MinimumPixelValue	K
10903	(0119,"MRSC",1007)	(0119,"MRSC",07)	MRSC	281	7	t	10	DS	1	MaximumPixelValue	K
10904	(0119,"MRSC",1010)	(0119,"MRSC",10)	MRSC	281	16	t	10	IS	1	PixelDataType	K
10905	(0119,"MRSC",1011)	(0119,"MRSC",11)	MRSC	281	17	t	10	IS	1-n	ImageIDNumbers	K
10906	(0119,"MRSC",1012)	(0119,"MRSC",12)	MRSC	281	18	t	10	IS	1-n	ParameterDims	K
10907	(0119,"MRSC",1013)	(0119,"MRSC",13)	MRSC	281	19	t	10	CS	1-n	VariableParameter	K
10908	(0119,"MRSC",1020)	(0119,"MRSC",20)	MRSC	281	32	t	10	LO	1-n	SourceFileNames	K
10909	(0119,"MRSC",1021)	(0119,"MRSC",21)	MRSC	281	33	t	10	IS	1	SourceCropFlag	K
10910	(0119,"MRSC",1022)	(0119,"MRSC",22)	MRSC	281	34	t	10	IS	6	SourceCropLimits	K
10997	(0119,"MRSC",1241)	(0119,"MRSC",41)	MRSC	281	65	t	12	LO	1	LPCCFilename	K
10911	(0119,"MRSC",1023)	(0119,"MRSC",23)	MRSC	281	35	t	10	UI	1-n	SourceFileUIDs	K
10912	(0119,"MRSC",1024)	(0119,"MRSC",24)	MRSC	281	36	t	10	IS	1-n	SourceVolumeIndices	K
10913	(0119,"MRSC",1025)	(0119,"MRSC",25)	MRSC	281	37	t	10	LO	1-n	SourceVolumeLabels	K
10914	(0119,"MRSC",1030)	(0119,"MRSC",30)	MRSC	281	48	t	10	DS	9	DirectionCosines	K
10915	(0119,"MRSC",1031)	(0119,"MRSC",31)	MRSC	281	49	t	10	CS	3	PatientOrientation3	K
10916	(0119,"MRSC",1041)	(0119,"MRSC",41)	MRSC	281	65	t	10	DS	1-n	SlicePosition	K
10917	(0119,"MRSC",1050)	(0119,"MRSC",50)	MRSC	281	80	t	10	LO	1-n	VolumeLabels	K
10918	(0119,"MRSC",1051)	(0119,"MRSC",51)	MRSC	281	81	t	10	DA	1-n	AcquisitionDate	K
10919	(0119,"MRSC",1060)	(0119,"MRSC",60)	MRSC	281	96	t	10	LO	1	SecCptrUser	K
10920	(0119,"MRSC",1061)	(0119,"MRSC",61)	MRSC	281	97	t	10	LO	1	SecCptrApplication	K
10921	(0119,"MRSC",1070)	(0119,"MRSC",70)	MRSC	281	112	t	10	AT	1-n	VariableParamTags	K
10922	(0119,"MRSC",1071)	(0119,"MRSC",71)	MRSC	281	113	t	10	CS	1-n	VariableParamNames	K
10923	(0119,"MRSC",1080)	(0119,"MRSC",80)	MRSC	281	128	t	10	DS	1-n	TR	K
10924	(0119,"MRSC",1081)	(0119,"MRSC",81)	MRSC	281	129	t	10	DS	1-n	TE	K
10925	(0119,"MRSC",10a0)	(0119,"MRSC",a0)	MRSC	281	160	t	10	DS	1-n	DIFF_GRAD_X	K
10926	(0119,"MRSC",10a1)	(0119,"MRSC",a1)	MRSC	281	161	t	10	DS	1-n	DIFF_GRAD_Y	K
10927	(0119,"MRSC",10a2)	(0119,"MRSC",a2)	MRSC	281	162	t	10	DS	1-n	DIFF_GRAD_Z	K
10928	(0119,"MRSC",10a3)	(0119,"MRSC",a3)	MRSC	281	163	t	10	DS	1-n	DIFF_PW_X	K
10929	(0119,"MRSC",10a4)	(0119,"MRSC",a4)	MRSC	281	164	t	10	DS	1-n	DIFF_PW_Y	K
10930	(0119,"MRSC",10a5)	(0119,"MRSC",a5)	MRSC	281	165	t	10	DS	1-n	DIFF_PW_Z	K
10931	(0119,"MRSC",10a6)	(0119,"MRSC",a6)	MRSC	281	166	t	10	DS	1-n	DIFF_TIME_X	K
10932	(0119,"MRSC",10a7)	(0119,"MRSC",a7)	MRSC	281	167	t	10	DS	1-n	DIFF_TIME_Y	K
10933	(0119,"MRSC",10a8)	(0119,"MRSC",a8)	MRSC	281	168	t	10	DS	1-n	DIFF_TIME_Z	K
10934	(0119,"MRSC",10a9)	(0119,"MRSC",a9)	MRSC	281	169	t	10	DS	1-n	DiffBValues	K
10935	(0119,"MRSC",10b0)	(0119,"MRSC",b0)	MRSC	281	176	t	10	LO	1	CoilCorrectionMethod	K
10936	(0119,"MRSC",10b1)	(0119,"MRSC",b1)	MRSC	281	177	t	10	IS	1	PolyFitOrder	K
10937	(0119,"MRSC",10b2)	(0119,"MRSC",b2)	MRSC	281	178	t	10	DS	1-n	PolyFitCoeff	K
10938	(0119,"MRSC",1100)	(0119,"MRSC",00)	MRSC	281	0	t	11	DS	1	FitMapModuleVersion	K
10939	(0119,"MRSC",1101)	(0119,"MRSC",01)	MRSC	281	1	t	11	LO	1-n	SourceFileNames	K
10940	(0119,"MRSC",1102)	(0119,"MRSC",02)	MRSC	281	2	t	11	IS	1-n	SourceVolumeIndices	K
10941	(0119,"MRSC",1103)	(0119,"MRSC",03)	MRSC	281	3	t	11	DS	1-n	ParameterValues	K
10942	(0119,"MRSC",1104)	(0119,"MRSC",04)	MRSC	281	4	t	11	AT	1	ParameterTag	K
10943	(0119,"MRSC",1105)	(0119,"MRSC",05)	MRSC	281	5	t	11	UI	1-n	SourceFileUIDs	K
10944	(0119,"MRSC",1106)	(0119,"MRSC",06)	MRSC	281	6	t	11	LO	1-n	SourceFileDirectory	K
10945	(0119,"MRSC",1107)	(0119,"MRSC",07)	MRSC	281	7	t	11	IS	1	SourceDataInPlaceFlag	K
10946	(0119,"MRSC",1108)	(0119,"MRSC",08)	MRSC	281	8	t	11	IS	1-n	ResultVolumeindices	K
10947	(0119,"MRSC",1109)	(0119,"MRSC",09)	MRSC	281	9	t	11	IS	1	SMOOTHBoxcarAverageKernel	K
10948	(0119,"MRSC",110c)	(0119,"MRSC",0c)	MRSC	281	12	t	11	LO	1	FitICFunction	K
10949	(0119,"MRSC",110d)	(0119,"MRSC",0d)	MRSC	281	13	t	11	LO	1	FitFormulaProcedure	K
10950	(0119,"MRSC",110e)	(0119,"MRSC",0e)	MRSC	281	14	t	11	LO	1	FittingProgram	K
10951	(0119,"MRSC",110f)	(0119,"MRSC",0f)	MRSC	281	15	t	11	IS	1	FittingProgramVersion	K
10952	(0119,"MRSC",1110)	(0119,"MRSC",10)	MRSC	281	16	t	11	CS	1	FitType	K
10953	(0119,"MRSC",1111)	(0119,"MRSC",11)	MRSC	281	17	t	11	IS	1	SetICFlag	K
10954	(0119,"MRSC",1112)	(0119,"MRSC",12)	MRSC	281	18	t	11	DS	1-n	InitialConditions	K
10955	(0119,"MRSC",1113)	(0119,"MRSC",13)	MRSC	281	19	t	11	DS	1-n	FitMapScaleFactors	K
10956	(0119,"MRSC",1120)	(0119,"MRSC",20)	MRSC	281	32	t	11	IS	1	ThresholdingFlag	K
10957	(0119,"MRSC",1121)	(0119,"MRSC",21)	MRSC	281	33	t	11	DS	1	Threshold	K
10958	(0119,"MRSC",1122)	(0119,"MRSC",22)	MRSC	281	34	t	11	IS	1	MaskCompression	K
10959	(0119,"MRSC",1123)	(0119,"MRSC",23)	MRSC	281	35	t	11	OB	1-n	FitMapMask	K
10960	(0119,"MRSC",1124)	(0119,"MRSC",24)	MRSC	281	36	t	11	OB	1-n	FitMapPntThreshMap	K
10961	(0119,"MRSC",1125)	(0119,"MRSC",25)	MRSC	281	37	t	11	ST	1	PixelMaskCheckString	K
10998	(0119,"MRSC",1250)	(0119,"MRSC",50)	MRSC	281	80	t	12	IS	1	LPCCFilter_type	K
10999	(0119,"MRSC",1251)	(0119,"MRSC",51)	MRSC	281	81	t	12	DS	1	LPCCMean_Multiplier	K
11000	(0119,"MRSC",1260)	(0119,"MRSC",60)	MRSC	281	96	t	12	DS	1	SACoilCorrectionIncrement	K
11001	(0119,"MRSC",1261)	(0119,"MRSC",61)	MRSC	281	97	t	12	IS	1	SACoilCorrectionVersion	K
11002	(0119,"MRSC",1270)	(0119,"MRSC",70)	MRSC	281	112	t	12	DS	1	SACoilCorrectionParams_Angle_deg	K
11003	(0119,"MRSC",1271)	(0119,"MRSC",71)	MRSC	281	113	t	12	DS	1	SACoilCorrectionParams_Offset_in	K
11004	(0119,"MRSC",12a0)	(0119,"MRSC",a0)	MRSC	281	160	t	12	LO	1	MinVarFiltSid	K
11005	(0119,"MRSC",12a1)	(0119,"MRSC",a1)	MRSC	281	161	t	12	LO	1	MinVarFiltPath	K
11006	(0119,"MRSC",12a2)	(0119,"MRSC",a2)	MRSC	281	162	t	12	IS	1	MinVarFiltMax_images	K
11007	(0119,"MRSC",12a3)	(0119,"MRSC",a3)	MRSC	281	163	t	12	IS	2	MinVarFiltId_locs	K
11008	(0119,"MRSC",12a4)	(0119,"MRSC",a4)	MRSC	281	164	t	12	LO	1	MinVarFiltScript_name	K
11009	(0119,"MRSC",12a5)	(0119,"MRSC",a5)	MRSC	281	165	t	12	IS	1	MinVarFiltSave_masks	K
11010	(0119,"MRSC",12a6)	(0119,"MRSC",a6)	MRSC	281	166	t	12	IS	1	MinVarFiltSave_idf	K
11011	(0119,"MRSC",12a7)	(0119,"MRSC",a7)	MRSC	281	167	t	12	LO	1	MinVarFiltMask	K
11012	(0119,"MRSC",12a8)	(0119,"MRSC",a8)	MRSC	281	168	t	12	LO	1	MinVarFiltIdfmask	K
11013	(0119,"MRSC",12a9)	(0119,"MRSC",a9)	MRSC	281	169	t	12	LO	1	MinVarFiltImage	K
11014	(0119,"MRSC",12b0)	(0119,"MRSC",b0)	MRSC	281	176	t	12	IS	1	MinVarFiltOutput_type	K
11015	(0119,"MRSC",12b1)	(0119,"MRSC",b1)	MRSC	281	177	t	12	IS	1	MinVarFiltOutput_ftype	K
11016	(0119,"MRSC",12b2)	(0119,"MRSC",b2)	MRSC	281	178	t	12	LO	1	MinVarFiltScaling	K
11017	(0119,"MRSC",14)	(0119,"MRSC",14)	MRSC	281	20	f	\N	UI	1	SERMaskFileUID	K
11018	(0119,"MRSC",1400)	(0119,"MRSC",00)	MRSC	281	0	t	14	LO	1	MIPsSid	K
11019	(0119,"MRSC",1401)	(0119,"MRSC",01)	MRSC	281	1	t	14	UI	1	MIPsUID	K
11020	(0119,"MRSC",1402)	(0119,"MRSC",02)	MRSC	281	2	t	14	TM	1	MIPsTime	K
11021	(0119,"MRSC",1403)	(0119,"MRSC",03)	MRSC	281	3	t	14	DA	1	MIPsDate	K
11022	(0119,"MRSC",1404)	(0119,"MRSC",04)	MRSC	281	4	t	14	IS	1	MIPsVersion	K
11023	(0119,"MRSC",1405)	(0119,"MRSC",05)	MRSC	281	5	t	14	IS	1	MIPsVolume	K
11024	(0119,"MRSC",1406)	(0119,"MRSC",06)	MRSC	281	6	t	14	IS	1	MIPsOrtho	K
11025	(0119,"MRSC",1407)	(0119,"MRSC",07)	MRSC	281	7	t	14	IS	1	MIPsMaskedFlag	K
11026	(0119,"MRSC",1408)	(0119,"MRSC",08)	MRSC	281	8	t	14	IS	1	MIPsSubtractVolume	K
11027	(0119,"MRSC",1410)	(0119,"MRSC",10)	MRSC	281	16	t	14	UL	1-n	MIPsProtectPixels	K
11028	(0119,"MRSC",1411)	(0119,"MRSC",11)	MRSC	281	17	t	14	UL	1-n	MIPsIgnorePixels	K
11029	(0119,"MRSC",1412)	(0119,"MRSC",12)	MRSC	281	18	t	14	IS	1	MIPsProjectFlag	K
11030	(0119,"MRSC",1413)	(0119,"MRSC",13)	MRSC	281	19	t	14	IS	1-n	MIPsProjectPlaneIndices	K
11031	(0119,"MRSC",1500)	(0119,"MRSC",00)	MRSC	281	0	t	15	LO	1	SERSid	K
11032	(0119,"MRSC",1501)	(0119,"MRSC",01)	MRSC	281	1	t	15	UI	1	SERUID	K
11034	(0119,"MRSC",1503)	(0119,"MRSC",03)	MRSC	281	3	t	15	DA	1	SERDate	K
11035	(0119,"MRSC",1504)	(0119,"MRSC",04)	MRSC	281	4	t	15	IS	1	SERVersion	K
11036	(0119,"MRSC",1505)	(0119,"MRSC",05)	MRSC	281	5	t	15	IS	3	SERTimePoints	K
11037	(0119,"MRSC",1506)	(0119,"MRSC",06)	MRSC	281	6	t	15	IS	1	SERByteScaled	K
11038	(0119,"MRSC",1507)	(0119,"MRSC",07)	MRSC	281	7	t	15	DS	1	SERBackground	K
11039	(0119,"MRSC",1508)	(0119,"MRSC",08)	MRSC	281	8	t	15	DS	1	SERThreshold	K
11040	(0119,"MRSC",1509)	(0119,"MRSC",09)	MRSC	281	9	t	15	DS	1	SERMaximum	K
11041	(0119,"MRSC",150a)	(0119,"MRSC",0a)	MRSC	281	10	t	15	IS	1	SERMinConPixels	K
11042	(0119,"MRSC",150b)	(0119,"MRSC",0b)	MRSC	281	11	t	15	IS	1	SERCorrectFlag	K
11043	(0119,"MRSC",150c)	(0119,"MRSC",0c)	MRSC	281	12	t	15	DS	2	SERAcqTimes	K
11044	(0119,"MRSC",150d)	(0119,"MRSC",0d)	MRSC	281	13	t	15	DS	2	SERTargetTimes	K
11045	(0119,"MRSC",150e)	(0119,"MRSC",0e)	MRSC	281	14	t	15	DS	1	SERTimeTolerance	K
11046	(0119,"MRSC",150f)	(0119,"MRSC",0f)	MRSC	281	15	t	15	DS	4	SERCorrectionParams	K
11047	(0119,"MRSC",1510)	(0119,"MRSC",10)	MRSC	281	16	t	15	LO	1	SERImageType	K
11048	(0119,"MRSC",1511)	(0119,"MRSC",11)	MRSC	281	17	t	15	IS	1-n	SEROffsets	K
11049	(0119,"MRSC",1512)	(0119,"MRSC",12)	MRSC	281	18	t	15	LO	1	SERMaskFileName	K
11050	(0119,"MRSC",1513)	(0119,"MRSC",13)	MRSC	281	19	t	15	DS	1	SERMaskChecksum	K
11051	(0119,"MRSC",18)	(0119,"MRSC",18)	MRSC	281	24	f	\N	IS	3	GAINS	K
11052	(0119,"MRSC",27)	(0119,"MRSC",27)	MRSC	281	39	f	\N	IS	1-n	ByteScaleMinMaxTop	K
11053	(0119,"MRSC",28)	(0119,"MRSC",28)	MRSC	281	40	f	\N	IS	1-n	GlobalThreshold	K
11054	(0119,"MRSC",29)	(0119,"MRSC",29)	MRSC	281	41	f	\N	DS	1-n	IntensityScale	K
11055	(0119,"MRSC",32)	(0119,"MRSC",32)	MRSC	281	50	f	\N	IS	1-n	REBIN	K
11056	(0119,"MRSC",33)	(0119,"MRSC",33)	MRSC	281	51	f	\N	DS	1-n	WhiteTopHat	K
11057	(0119,"MRSC",34)	(0119,"MRSC",34)	MRSC	281	52	f	\N	IS	1-n	HistEqual	K
11058	(0119,"MRSC",35)	(0119,"MRSC",35)	MRSC	281	53	f	\N	IS	1-n	Crop	K
11059	(0119,"MRSC",36)	(0119,"MRSC",36)	MRSC	281	54	f	\N	DS	1-n	LPCoil	K
11060	(0119,"MRSC",38)	(0119,"MRSC",38)	MRSC	281	56	f	\N	DS	3	PixelGap	K
11061	(0119,"MRSC",42)	(0119,"MRSC",42)	MRSC	281	66	f	\N	DS	1-n	LPCCBandwidth	K
11062	(0119,"MRSC",43)	(0119,"MRSC",43)	MRSC	281	67	f	\N	DS	1	LPCCNoise_factor	K
11063	(0119,"MRSC",44)	(0119,"MRSC",44)	MRSC	281	68	f	\N	DS	1	LPCCNoise_level	K
11064	(0119,"MRSC",45)	(0119,"MRSC",45)	MRSC	281	69	f	\N	IS	1	LPCCNoise_mode	K
11065	(0119,"MRSC",46)	(0119,"MRSC",46)	MRSC	281	70	f	\N	IS	1	LPCCDirection	K
11066	(0119,"MRSC",47)	(0119,"MRSC",47)	MRSC	281	71	f	\N	IS	1	LPCCEdge_fill	K
11067	(0119,"MRSC",48)	(0119,"MRSC",48)	MRSC	281	72	f	\N	IS	1	LPCCMean_fill	K
11068	(0119,"MRSC",49)	(0119,"MRSC",49)	MRSC	281	73	f	\N	IS	1	LPCCPixelsearch	K
11069	(0119,"MRSC",4a)	(0119,"MRSC",4a)	MRSC	281	74	f	\N	DS	1	LPCCIntensity_scale	K
11070	(0119,"MRSC",4b)	(0119,"MRSC",4b)	MRSC	281	75	f	\N	IS	1	LPCCThreed	K
11071	(0119,"MRSC",4c)	(0119,"MRSC",4c)	MRSC	281	76	f	\N	LO	1	LPCCRoi_mask	K
11072	(0119,"MRSC",4d)	(0119,"MRSC",4d)	MRSC	281	77	f	\N	IS	2	LPCCMask_slices	K
11073	(0119,"MRSC",4e)	(0119,"MRSC",4e)	MRSC	281	78	f	\N	IS	1	LPCCSlice_pad	K
11074	(0119,"MRSC",4f)	(0119,"MRSC",4f)	MRSC	281	79	f	\N	IS	1	LPCCSave_type	K
11075	(0119,"MRSC",52)	(0119,"MRSC",52)	MRSC	281	82	f	\N	TM	1-n	AcquisitionTime	K
11076	(0119,"MRSC",62)	(0119,"MRSC",62)	MRSC	281	98	f	\N	DA	1	SACoilCorrectionCorr_date	K
11077	(0119,"MRSC",63)	(0119,"MRSC",63)	MRSC	281	99	f	\N	TM	1	SACoilCorrectionCorr_time	K
11078	(0119,"MRSC",64)	(0119,"MRSC",64)	MRSC	281	100	f	\N	LO	1	SACoilCorrectionMethod	K
11079	(0119,"MRSC",65)	(0119,"MRSC",65)	MRSC	281	101	f	\N	DS	1-n	SACoilCorrectionOrigin	K
11080	(0119,"MRSC",66)	(0119,"MRSC",66)	MRSC	281	102	f	\N	DS	1-n	SACoilCorrectionAxis_cos	K
11081	(0119,"MRSC",67)	(0119,"MRSC",67)	MRSC	281	103	f	\N	IS	1	SACoilCorrectionNumber	K
11082	(0119,"MRSC",68)	(0119,"MRSC",68)	MRSC	281	104	f	\N	LO	1	SACoilCorrectionSid	K
11083	(0119,"MRSC",69)	(0119,"MRSC",69)	MRSC	281	105	f	\N	DS	1-n	SACoilCorrectionRange	K
11084	(0119,"MRSC",6a)	(0119,"MRSC",6a)	MRSC	281	106	f	\N	FD	1-n	SACoilCorrectionSa_value	K
11085	(0119,"MRSC",6b)	(0119,"MRSC",6b)	MRSC	281	107	f	\N	IS	1	SACoilCorrectionAxis_flag	K
11086	(0119,"MRSC",6c)	(0119,"MRSC",6c)	MRSC	281	108	f	\N	IS	1-n	SACoilCorrectionSample_number	K
11087	(0119,"MRSC",6d)	(0119,"MRSC",6d)	MRSC	281	109	f	\N	LO	1	SACoilCorrectionParams_SID	K
11088	(0119,"MRSC",6e)	(0119,"MRSC",6e)	MRSC	281	110	f	\N	IS	1	SACoilCorrectionParams_Version	K
11089	(0119,"MRSC",6f)	(0119,"MRSC",6f)	MRSC	281	111	f	\N	DS	1	SACoilCorrectionParams_Rot_axis_off	K
11090	(0119,"MRSC",72)	(0119,"MRSC",72)	MRSC	281	114	f	\N	DS	1-n	SACoilCorrectionParams_Plane_cos_ref	K
11091	(0119,"MRSC",73)	(0119,"MRSC",73)	MRSC	281	115	f	\N	DS	1-n	SACoilCorrectionParams_Lps_ref	K
11092	(0119,"MRSC",74)	(0119,"MRSC",74)	MRSC	281	116	f	\N	IS	1	SACoilCorrectionParams_Order	K
11093	(0119,"MRSC",75)	(0119,"MRSC",75)	MRSC	281	117	f	\N	DS	1-n	SACoilCorrectionParams_Coeff	K
11094	(0119,"MRSC",76)	(0119,"MRSC",76)	MRSC	281	118	f	\N	DA	1	SACoilCorrectionParams_Coeff_date	K
11095	(0119,"MRSC",77)	(0119,"MRSC",77)	MRSC	281	119	f	\N	LO	1	SACoilCorrectionParams_Coeff_src	K
11096	(0119,"MRSC",82)	(0119,"MRSC",82)	MRSC	281	130	f	\N	DS	1-n	TI	K
11097	(0119,"MRSC",83)	(0119,"MRSC",83)	MRSC	281	131	f	\N	DS	1-n	TSL	K
11098	(0119,"MRSC",88)	(0119,"MRSC",88)	MRSC	281	136	f	\N	DS	1-n	FlipAngle	K
11099	(0119,"MRSC",90)	(0119,"MRSC",90)	MRSC	281	144	f	\N	DS	1-n	TemporalIndex	K
11100	(0119,"MRSC",91)	(0119,"MRSC",91)	MRSC	281	145	f	\N	DS	1-n	TemporalValue	K
11101	(0119,"MRSC",aa)	(0119,"MRSC",aa)	MRSC	281	170	f	\N	LO	1-n	MinVarFiltIdfimages	K
11102	(0119,"MRSC",ab)	(0119,"MRSC",ab)	MRSC	281	171	f	\N	LO	1	MinVarFiltOutput_file	K
11103	(0119,"MRSC",ac)	(0119,"MRSC",ac)	MRSC	281	172	f	\N	IS	1	MinVarFiltNum_loops	K
11104	(0119,"MRSC",ad)	(0119,"MRSC",ad)	MRSC	281	173	f	\N	IS	3	MinVarFiltKernel	K
11105	(0119,"MRSC",ae)	(0119,"MRSC",ae)	MRSC	281	174	f	\N	IS	1	MinVarFiltLimit_sliceFlag	K
11106	(0119,"MRSC",af)	(0119,"MRSC",af)	MRSC	281	175	f	\N	SS	2	MinVarFiltSlice_limits	K
11107	(0119,"MRSC",b3)	(0119,"MRSC",b3)	MRSC	281	179	f	\N	LO	1	MinVarFiltScript	K
11108	(0119,"MRSC",b4)	(0119,"MRSC",b4)	MRSC	281	180	f	\N	LO	1	MinVarFiltLog	K
11109	(0119,"MRSC",c0)	(0119,"MRSC",c0)	MRSC	281	192	f	\N	SQ	1	QCMinimumLimits	K
11110	(0119,"MRSC",c1)	(0119,"MRSC",c1)	MRSC	281	193	f	\N	SQ	1	QCMaximumLimits	K
11111	(0119,"MRSC",d0)	(0119,"MRSC",d0)	MRSC	281	208	f	\N	ST	1	CheckString	K
11112	(0119,"MRSC",d1)	(0119,"MRSC",d1)	MRSC	281	209	f	\N	LO	1-n	Source	K
11113	(0119,"MRSC",f0)	(0119,"MRSC",f0)	MRSC	281	240	f	\N	OB	1-n	SampleHeader	K
11114	(0119,"MRSC",ff)	(0119,"MRSC",ff)	MRSC	281	255	f	\N	DS	1-n	UserInfo	K
11115	(01e1,"ELSCINT1",c2)	(01e1,"ELSCINT1",c2)	ELSCINT1	481	194	f	\N	UI	1	GT Gating UID	R
11116	(1001,"BrainWave: 1.2.840.113819.3",11)	(1001,"BrainWave: 1.2.840.113819.3",11)	BrainWave: 1.2.840.113819.3	4097	17	f	\N	SH	1	DICOM Implementation Version	R
11117	(2001,"BrainWave: 1.2.840.113819.3",10)	(2001,"BrainWave: 1.2.840.113819.3",10)	BrainWave: 1.2.840.113819.3	8193	16	f	\N	UI	1	DICOM Implementation UID	R
11118	(2001,"BrainWave: 1.2.840.113819.3",12)	(2001,"BrainWave: 1.2.840.113819.3",12)	BrainWave: 1.2.840.113819.3	8193	18	f	\N	UI	1	Within-DICOM-Implementation SOP Instance UID	R
11119	(2001,"BrainWave: 1.2.840.113819.3",13)	(2001,"BrainWave: 1.2.840.113819.3",13)	BrainWave: 1.2.840.113819.3	8193	19	f	\N	SH	1	Application Name	R
11120	(2001,"BrainWave: 1.2.840.113819.3",14)	(2001,"BrainWave: 1.2.840.113819.3",14)	BrainWave: 1.2.840.113819.3	8193	20	f	\N	SH	1	Application Version	R
11121	(2001,"BrainWave: 1.2.840.113819.3",15)	(2001,"BrainWave: 1.2.840.113819.3",15)	BrainWave: 1.2.840.113819.3	8193	21	f	\N	SH	1	Compatibility Version	R
11122	(2001,"BrainWave: 1.2.840.113819.3",21)	(2001,"BrainWave: 1.2.840.113819.3",21)	BrainWave: 1.2.840.113819.3	8193	33	f	\N	UI	1-n	Referenced Series UID	R
11123	(2001,"BrainWave: 1.2.840.113819.3",31)	(2001,"BrainWave: 1.2.840.113819.3",31)	BrainWave: 1.2.840.113819.3	8193	49	f	\N	US	1	Number of Objects Averaged	K
11124	(2001,"BrainWave: 1.2.840.113819.3",41)	(2001,"BrainWave: 1.2.840.113819.3",41)	BrainWave: 1.2.840.113819.3	8193	65	f	\N	US	1	Number of Expected Time Points	K
11125	(2001,"BrainWave: 1.2.840.113819.3",51)	(2001,"BrainWave: 1.2.840.113819.3",51)	BrainWave: 1.2.840.113819.3	8193	81	f	\N	US	1	Number of Slices Per Volume	K
11126	(2001,"BrainWave: 1.2.840.113819.3",60)	(2001,"BrainWave: 1.2.840.113819.3",60)	BrainWave: 1.2.840.113819.3	8193	96	f	\N	US	1	BW Image Type	K
11127	(2001,"BrainWave: 1.2.840.113819.3",61)	(2001,"BrainWave: 1.2.840.113819.3",61)	BrainWave: 1.2.840.113819.3	8193	97	f	\N	US	1	Experiment Type	K
11128	(2001,"BrainWave: 1.2.840.113819.3",71)	(2001,"BrainWave: 1.2.840.113819.3",71)	BrainWave: 1.2.840.113819.3	8193	113	f	\N	UI	1	Paradigm UID	R
11129	(2001,"BrainWave: 1.2.840.113819.3",72)	(2001,"BrainWave: 1.2.840.113819.3",72)	BrainWave: 1.2.840.113819.3	8193	114	f	\N	LO	1	Paradigm Name	R
11130	(2001,"BrainWave: 1.2.840.113819.3",73)	(2001,"BrainWave: 1.2.840.113819.3",73)	BrainWave: 1.2.840.113819.3	8193	115	f	\N	ST	1	Paradigm Description	R
11131	(2001,"BrainWave: 1.2.840.113819.3",80)	(2001,"BrainWave: 1.2.840.113819.3",80)	BrainWave: 1.2.840.113819.3	8193	128	f	\N	OB	1	Contrast	X
11132	(2001,"BrainWave: 1.2.840.113819.3",81)	(2001,"BrainWave: 1.2.840.113819.3",81)	BrainWave: 1.2.840.113819.3	8193	129	f	\N	FL	1-n	Regressor Values	K
11133	(2001,"BrainWave: 1.2.840.113819.3",86)	(2001,"BrainWave: 1.2.840.113819.3",86)	BrainWave: 1.2.840.113819.3	8193	134	f	\N	US	1	Number of Degrees of Freedom	K
11134	(2001,"BrainWave: 1.2.840.113819.3",8a)	(2001,"BrainWave: 1.2.840.113819.3",8a)	BrainWave: 1.2.840.113819.3	8193	138	f	\N	FL	1	Z Threshold	K
11135	(2001,"BrainWave: 1.2.840.113819.3",8b)	(2001,"BrainWave: 1.2.840.113819.3",8b)	BrainWave: 1.2.840.113819.3	8193	139	f	\N	FL	1	p Threshold	K
11136	(2001,"BrainWave: 1.2.840.113819.3",90)	(2001,"BrainWave: 1.2.840.113819.3",90)	BrainWave: 1.2.840.113819.3	8193	144	f	\N	OB	1	Processing Parameters	X
11137	(2001,"BrainWave: 1.2.840.113819.3",91)	(2001,"BrainWave: 1.2.840.113819.3",91)	BrainWave: 1.2.840.113819.3	8193	145	f	\N	OB	1	Motion Plot	X
11138	(2001,"BrainWave: 1.2.840.113819.3",92)	(2001,"BrainWave: 1.2.840.113819.3",92)	BrainWave: 1.2.840.113819.3	8193	146	f	\N	OB	1	ROIs	X
11139	(2001,"BrainWave: 1.2.840.113819.3",93)	(2001,"BrainWave: 1.2.840.113819.3",93)	BrainWave: 1.2.840.113819.3	8193	147	f	\N	OB	1	Tracts	X
11140	(2001,"BrainWave: 1.2.840.113819.3",94)	(2001,"BrainWave: 1.2.840.113819.3",94)	BrainWave: 1.2.840.113819.3	8193	148	f	\N	OB	1	Report	X
11141	(2001,"BrainWave: 1.2.840.113819.3",95)	(2001,"BrainWave: 1.2.840.113819.3",95)	BrainWave: 1.2.840.113819.3	8193	149	f	\N	OB	1	Response Data	X
11142	(2001,"BrainWave: 1.2.840.113819.3",a0)	(2001,"BrainWave: 1.2.840.113819.3",a0)	BrainWave: 1.2.840.113819.3	8193	160	f	\N	FL	1-n	Motion Parameters	K
11143	(2001,"BrainWave: 1.2.840.113819.3",a1)	(2001,"BrainWave: 1.2.840.113819.3",a1)	BrainWave: 1.2.840.113819.3	8193	161	f	\N	FL	1-n	Registration Parameters	K
11144	(2001,"BrainWave: 1.2.840.113819.3",a2)	(2001,"BrainWave: 1.2.840.113819.3",a2)	BrainWave: 1.2.840.113819.3	8193	162	f	\N	FL	1-n	Subject Data	K
11145	(2001,"BrainWave: 1.2.840.113819.3",b0)	(2001,"BrainWave: 1.2.840.113819.3",b0)	BrainWave: 1.2.840.113819.3	8193	176	f	\N	OB	1	DTI Parameters	X
11146	(2001,"BrainWave: 1.2.840.113819.3",c0)	(2001,"BrainWave: 1.2.840.113819.3",c0)	BrainWave: 1.2.840.113819.3	8193	192	f	\N	OB	1	Paradigm Info	X
984	(2001,"Philips Imaging DD 001",01)	(2001,"Philips Imaging DD 001",01)	Philips Imaging DD 001	8193	1	f	\N	FL	1	ChemicalShift	KB
985	(2001,"Philips Imaging DD 001",02)	(2001,"Philips Imaging DD 001",02)	Philips Imaging DD 001	8193	2	f	\N	IS	1	ChemicalShiftNumberMR	KB
986	(2001,"Philips Imaging DD 001",03)	(2001,"Philips Imaging DD 001",03)	Philips Imaging DD 001	8193	3	f	\N	FL	1	DiffusionB-Factor	KB
987	(2001,"Philips Imaging DD 001",04)	(2001,"Philips Imaging DD 001",04)	Philips Imaging DD 001	8193	4	f	\N	CS	1	DiffusionDirection	R
988	(2001,"Philips Imaging DD 001",06)	(2001,"Philips Imaging DD 001",06)	Philips Imaging DD 001	8193	6	f	\N	CS	1	ImageEnhanced	R
989	(2001,"Philips Imaging DD 001",07)	(2001,"Philips Imaging DD 001",07)	Philips Imaging DD 001	8193	7	f	\N	CS	1	ImageTypeEDES	R
990	(2001,"Philips Imaging DD 001",08)	(2001,"Philips Imaging DD 001",08)	Philips Imaging DD 001	8193	8	f	\N	IS	1	PhaseNumber	KB
6838	(2001,"Philips Imaging DD 001",09)	(2001,"Philips Imaging DD 001",09)	Philips Imaging DD 001	8193	9	f	\N	FL	1	Image Prepulse Delay	KB
991	(2001,"Philips Imaging DD 001",0a)	(2001,"Philips Imaging DD 001",0a)	Philips Imaging DD 001	8193	10	f	\N	IS	1	SliceNumberMR	K3
992	(2001,"Philips Imaging DD 001",0b)	(2001,"Philips Imaging DD 001",0b)	Philips Imaging DD 001	8193	11	f	\N	CS	1	SliceOrientation	R
6840	(2001,"Philips Imaging DD 001",0c)	(2001,"Philips Imaging DD 001",0c)	Philips Imaging DD 001	8193	12	f	\N	CS	1	Arrhythmia Rejection	R
6842	(2001,"Philips Imaging DD 001",0e)	(2001,"Philips Imaging DD 001",0e)	Philips Imaging DD 001	8193	14	f	\N	CS	1	Cardiac Cycled	R
6844	(2001,"Philips Imaging DD 001",0f)	(2001,"Philips Imaging DD 001",0f)	Philips Imaging DD 001	8193	15	f	\N	SS	1	Cardiac Gate Width	K
6846	(2001,"Philips Imaging DD 001",10)	(2001,"Philips Imaging DD 001",10)	Philips Imaging DD 001	8193	16	f	\N	CS	1	Cardiac Sync	R
993	(2001,"Philips Imaging DD 001",11)	(2001,"Philips Imaging DD 001",11)	Philips Imaging DD 001	8193	17	f	\N	FL	1	DiffusionEchoTime	KB
994	(2001,"Philips Imaging DD 001",12)	(2001,"Philips Imaging DD 001",12)	Philips Imaging DD 001	8193	18	f	\N	CS	1	DynamicSeries	R
995	(2001,"Philips Imaging DD 001",13)	(2001,"Philips Imaging DD 001",13)	Philips Imaging DD 001	8193	19	f	\N	SL	1	EPIFactor	KB
996	(2001,"Philips Imaging DD 001",14)	(2001,"Philips Imaging DD 001",14)	Philips Imaging DD 001	8193	20	f	\N	SL	1	NumberOfEchoes	KB
997	(2001,"Philips Imaging DD 001",15)	(2001,"Philips Imaging DD 001",15)	Philips Imaging DD 001	8193	21	f	\N	SS	1	NumberOfLocations	KB
998	(2001,"Philips Imaging DD 001",16)	(2001,"Philips Imaging DD 001",16)	Philips Imaging DD 001	8193	22	f	\N	SS	1	NumberOfPCDirections	KB
1001	(2001,"Philips Imaging DD 001",19)	(2001,"Philips Imaging DD 001",19)	Philips Imaging DD 001	8193	25	f	\N	CS	1	PartialMatrixScanned	R
1003	(2001,"Philips Imaging DD 001",1b)	(2001,"Philips Imaging DD 001",1b)	Philips Imaging DD 001	8193	27	f	\N	FL	1	PrepulseDelay	KB
1004	(2001,"Philips Imaging DD 001",1c)	(2001,"Philips Imaging DD 001",1c)	Philips Imaging DD 001	8193	28	f	\N	CS	1	PrepulseType	R
1005	(2001,"Philips Imaging DD 001",1d)	(2001,"Philips Imaging DD 001",1d)	Philips Imaging DD 001	8193	29	f	\N	IS	1	ReconstructionNumberMR	K3
1006	(2001,"Philips Imaging DD 001",1f)	(2001,"Philips Imaging DD 001",1f)	Philips Imaging DD 001	8193	31	f	\N	CS	1	RespirationSync	R
1007	(2001,"Philips Imaging DD 001",21)	(2001,"Philips Imaging DD 001",21)	Philips Imaging DD 001	8193	33	f	\N	CS	1	SPIR	R
1008	(2001,"Philips Imaging DD 001",22)	(2001,"Philips Imaging DD 001",22)	Philips Imaging DD 001	8193	34	f	\N	FL	1	WaterFatShift	KB
1009	(2001,"Philips Imaging DD 001",23)	(2001,"Philips Imaging DD 001",23)	Philips Imaging DD 001	8193	35	f	\N	DS	1	FlipAnglePhilips	KB
1010	(2001,"Philips Imaging DD 001",25)	(2001,"Philips Imaging DD 001",25)	Philips Imaging DD 001	8193	37	f	\N	SH	1	EchoTimeDisplayMR	K
1011	(2001,"Philips Imaging DD 001",2d)	(2001,"Philips Imaging DD 001",2d)	Philips Imaging DD 001	8193	45	f	\N	SS	1	StackNumberOfSlices	K
1012	(2001,"Philips Imaging DD 001",32)	(2001,"Philips Imaging DD 001",32)	Philips Imaging DD 001	8193	50	f	\N	FL	1	StackRadialAngle	K
1013	(2001,"Philips Imaging DD 001",33)	(2001,"Philips Imaging DD 001",33)	Philips Imaging DD 001	8193	51	f	\N	CS	1	StackRadialAxis	K
1014	(2001,"Philips Imaging DD 001",35)	(2001,"Philips Imaging DD 001",35)	Philips Imaging DD 001	8193	53	f	\N	SS	1	StackSliceNumber	K
1015	(2001,"Philips Imaging DD 001",36)	(2001,"Philips Imaging DD 001",36)	Philips Imaging DD 001	8193	54	f	\N	CS	1	StackType	K
6943	(2001,"Philips Imaging DD 001",58)	(2001,"Philips Imaging DD 001",58)	Philips Imaging DD 001	8193	88	f	\N	UL	1	Contrast Transfer Taste	KB
1017	(2001,"Philips Imaging DD 001",5f)	(2001,"Philips Imaging DD 001",5f)	Philips Imaging DD 001	8193	95	f	\N	SQ	1-n	StackSequence	K
1018	(2001,"Philips Imaging DD 001",60)	(2001,"Philips Imaging DD 001",60)	Philips Imaging DD 001	8193	96	f	\N	SL	1	NumberOfStacks	KB
1019	(2001,"Philips Imaging DD 001",61)	(2001,"Philips Imaging DD 001",61)	Philips Imaging DD 001	8193	97	f	\N	CS	1	SeriesTransmitted	KB
1021	(2001,"Philips Imaging DD 001",63)	(2001,"Philips Imaging DD 001",63)	Philips Imaging DD 001	8193	99	f	\N	CS	1	ExaminationSource	X
1022	(2001,"Philips Imaging DD 001",7b)	(2001,"Philips Imaging DD 001",7b)	Philips Imaging DD 001	8193	123	f	\N	IS	1	AcquisitionNumber	K3
1023	(2001,"Philips Imaging DD 001",81)	(2001,"Philips Imaging DD 001",81)	Philips Imaging DD 001	8193	129	f	\N	IS	1	NumberOfDynamicScans	KB
7025	(2001,"Philips Imaging DD 001",a1)	(2001,"Philips Imaging DD 001",a1)	Philips Imaging DD 001	8193	161	f	\N	CS	1	Is Raw Image	R
7035	(2001,"Philips Imaging DD 001",c8)	(2001,"Philips Imaging DD 001",c8)	Philips Imaging DD 001	8193	200	f	\N	LO	1	Exam Card Name	X
7041	(2001,"Philips Imaging DD 001",f1)	(2001,"Philips Imaging DD 001",f1)	Philips Imaging DD 001	8193	241	f	\N	FL	6	Prospective Motion Correction	KB
7043	(2001,"Philips Imaging DD 001",f2)	(2001,"Philips Imaging DD 001",f2)	Philips Imaging DD 001	8193	242	f	\N	FL	6	Retrospective Motion Correction	KB
1067	(2005,"Philips MR Imaging DD 001",20)	(2005,"Philips MR Imaging DD 001",20)	Philips MR Imaging DD 001	8197	32	f	\N	SL	1	NumberOfChemicalShifts	KB
1073	(2005,"Philips MR Imaging DD 001",a1)	(2005,"Philips MR Imaging DD 001",a1)	Philips MR Imaging DD 001	8197	161	f	\N	CS	1	SyncraScanType	R
7572	(2005,"Philips MR Imaging DD 001",b0)	(2005,"Philips MR Imaging DD 001",b0)	Philips MR Imaging DD 001	8197	176	f	\N	FL	1	Diffusion Direction RL	KB
7574	(2005,"Philips MR Imaging DD 001",b1)	(2005,"Philips MR Imaging DD 001",b1)	Philips MR Imaging DD 001	8197	177	f	\N	FL	1	Diffusion Direction AP	KB
7576	(2005,"Philips MR Imaging DD 001",b2)	(2005,"Philips MR Imaging DD 001",b2)	Philips MR Imaging DD 001	8197	178	f	\N	FL	1	Diffusion Direction FH	KB
4938	(50f1,"FDMS 1.0",06)	(50f1,"FDMS 1.0",06)	FDMS 1.0	20721	6	f	\N	CS	1	Energy Subtraction Parameter	K
4939	(50f1,"FDMS 1.0",07)	(50f1,"FDMS 1.0",07)	FDMS 1.0	20721	7	f	\N	CS	1	Subtraction Registration Result	K
4940	(50f1,"FDMS 1.0",08)	(50f1,"FDMS 1.0",08)	FDMS 1.0	20721	8	f	\N	CS	1	Energy Subtraction Parameter 2	K
4941	(50f1,"FDMS 1.0",09)	(50f1,"FDMS 1.0",09)	FDMS 1.0	20721	9	f	\N	SL	1	Afin Conversion Coefficient	K
4944	(50f1,"FDMS 1.0",20)	(50f1,"FDMS 1.0",20)	FDMS 1.0	20721	32	f	\N	CS	1	Image Processing Modification Flag	K
11147	(7001,"GEMS_MR_RAW_01",01)	(7001,"GEMS_MR_RAW_01",01)	GEMS_MR_RAW_01	28673	1	f	\N	OB	1	rdb_hdr_rec	X
11148	(7001,"GEMS_MR_RAW_01",02)	(7001,"GEMS_MR_RAW_01",02)	GEMS_MR_RAW_01	28673	2	f	\N	OB	1	rdb_hdr_per_pass_tab	X
11149	(7001,"GEMS_MR_RAW_01",03)	(7001,"GEMS_MR_RAW_01",03)	GEMS_MR_RAW_01	28673	3	f	\N	OB	1	rdr_hdr_unlock_raw	X
11150	(7001,"GEMS_MR_RAW_01",04)	(7001,"GEMS_MR_RAW_01",04)	GEMS_MR_RAW_01	28673	4	f	\N	OB	1	rdb_hdr_data_acq_tab	X
11151	(7001,"GEMS_MR_RAW_01",05)	(7001,"GEMS_MR_RAW_01",05)	GEMS_MR_RAW_01	28673	5	f	\N	OB	1	rdb_hdr_nex_tab	X
11152	(7001,"GEMS_MR_RAW_01",06)	(7001,"GEMS_MR_RAW_01",06)	GEMS_MR_RAW_01	28673	6	f	\N	OB	1	rdb_hdr_nex_abort_tab	X
11153	(7001,"GEMS_MR_RAW_01",07)	(7001,"GEMS_MR_RAW_01",07)	GEMS_MR_RAW_01	28673	7	f	\N	OB	1	rdb_hdr_tool	X
11154	(7001,"GEMS_MR_RAW_01",08)	(7001,"GEMS_MR_RAW_01",08)	GEMS_MR_RAW_01	28673	8	f	\N	OB	1	rdb_raw_data	X
11155	(7001,"GEMS_MR_RAW_01",09)	(7001,"GEMS_MR_RAW_01",09)	GEMS_MR_RAW_01	28673	9	f	\N	OB	1	SSP save	X
11156	(7001,"GEMS_MR_RAW_01",0a)	(7001,"GEMS_MR_RAW_01",0a)	GEMS_MR_RAW_01	28673	10	f	\N	OB	1	UDA save	X
11157	(7001,"GEMS_MR_RAW_01",0b)	(7001,"GEMS_MR_RAW_01",0b)	GEMS_MR_RAW_01	28673	11	f	\N	OB	1	rdb_chemsat_data	X
10340	(7005,"TOSHIBA_MEC_CT3",00)	(7005,"TOSHIBA_MEC_CT3",00)	TOSHIBA_MEC_CT3	28677	0	f	\N	OB	1	CT Private Data 1	X
10341	(7005,"TOSHIBA_MEC_CT3",03)	(7005,"TOSHIBA_MEC_CT3",03)	TOSHIBA_MEC_CT3	28677	3	f	\N	SH	1	Cardiac R-R Mean Time	K
10342	(7005,"TOSHIBA_MEC_CT3",04)	(7005,"TOSHIBA_MEC_CT3",04)	TOSHIBA_MEC_CT3	28677	4	f	\N	SH	1	Cardiac Reconstruction Getting Phase in Percent	K
10343	(7005,"TOSHIBA_MEC_CT3",05)	(7005,"TOSHIBA_MEC_CT3",05)	TOSHIBA_MEC_CT3	28677	5	f	\N	SH	1	Cardiac Reconstruction Getting Phase in ms	K
10344	(7005,"TOSHIBA_MEC_CT3",06)	(7005,"TOSHIBA_MEC_CT3",06)	TOSHIBA_MEC_CT3	28677	6	f	\N	SH	1	Cardiac Reconstruction Mode	K
10345	(7005,"TOSHIBA_MEC_CT3",07)	(7005,"TOSHIBA_MEC_CT3",07)	TOSHIBA_MEC_CT3	28677	7	f	\N	DS	1-n	Reconstruction Center	KB
10346	(7005,"TOSHIBA_MEC_CT3",08)	(7005,"TOSHIBA_MEC_CT3",08)	TOSHIBA_MEC_CT3	28677	8	f	\N	DS	1	Detector Slice Thickness in mm	KB
10347	(7005,"TOSHIBA_MEC_CT3",09)	(7005,"TOSHIBA_MEC_CT3",09)	TOSHIBA_MEC_CT3	28677	9	f	\N	LO	1	Number of Detector rows to Reconstruct	KB
10348	(7005,"TOSHIBA_MEC_CT3",0a)	(7005,"TOSHIBA_MEC_CT3",0a)	TOSHIBA_MEC_CT3	28677	10	f	\N	DS	1	Table Speed in mm/rot	KB
10349	(7005,"TOSHIBA_MEC_CT3",0b)	(7005,"TOSHIBA_MEC_CT3",0b)	TOSHIBA_MEC_CT3	28677	11	f	\N	SH	1	Filter	R
10350	(7005,"TOSHIBA_MEC_CT3",0c)	(7005,"TOSHIBA_MEC_CT3",0c)	TOSHIBA_MEC_CT3	28677	12	f	\N	SH	1	Reconstruction Correction Type	R
10351	(7005,"TOSHIBA_MEC_CT3",0d)	(7005,"TOSHIBA_MEC_CT3",0d)	TOSHIBA_MEC_CT3	28677	13	f	\N	SH	1	Organ	R
10352	(7005,"TOSHIBA_MEC_CT3",0e)	(7005,"TOSHIBA_MEC_CT3",0e)	TOSHIBA_MEC_CT3	28677	14	f	\N	SH	1	File Type Remarks	R
10353	(7005,"TOSHIBA_MEC_CT3",0f)	(7005,"TOSHIBA_MEC_CT3",0f)	TOSHIBA_MEC_CT3	28677	15	f	\N	SH	1	Direction (head or feet first)	R
10354	(7005,"TOSHIBA_MEC_CT3",10)	(7005,"TOSHIBA_MEC_CT3",10)	TOSHIBA_MEC_CT3	28677	16	f	\N	OB	1	CT Private Data 2	X
10355	(7005,"TOSHIBA_MEC_CT3",11)	(7005,"TOSHIBA_MEC_CT3",11)	TOSHIBA_MEC_CT3	28677	17	f	\N	LT	1	Series Comment	R
10356	(7005,"TOSHIBA_MEC_CT3",12)	(7005,"TOSHIBA_MEC_CT3",12)	TOSHIBA_MEC_CT3	28677	18	f	\N	SH	1	Position (supine or prone)	R
10357	(7005,"TOSHIBA_MEC_CT3",13)	(7005,"TOSHIBA_MEC_CT3",13)	TOSHIBA_MEC_CT3	28677	19	f	\N	US	1	Expert Plan Number	KB
10358	(7005,"TOSHIBA_MEC_CT3",14)	(7005,"TOSHIBA_MEC_CT3",14)	TOSHIBA_MEC_CT3	28677	20	f	\N	US	1	Reconstruction ROI Number	KB
10359	(7005,"TOSHIBA_MEC_CT3",15)	(7005,"TOSHIBA_MEC_CT3",15)	TOSHIBA_MEC_CT3	28677	21	f	\N	US	1	Special Helical Acquisition Number	KB
10360	(7005,"TOSHIBA_MEC_CT3",16)	(7005,"TOSHIBA_MEC_CT3",16)	TOSHIBA_MEC_CT3	28677	22	f	\N	UI	1	Volume UID	X
10361	(7005,"TOSHIBA_MEC_CT3",17)	(7005,"TOSHIBA_MEC_CT3",17)	TOSHIBA_MEC_CT3	28677	23	f	\N	US	1	Total Frame Count in the Volume	KB
10362	(7005,"TOSHIBA_MEC_CT3",18)	(7005,"TOSHIBA_MEC_CT3",18)	TOSHIBA_MEC_CT3	28677	24	f	\N	US	1	Frame Number	KB
10363	(7005,"TOSHIBA_MEC_CT3",19)	(7005,"TOSHIBA_MEC_CT3",19)	TOSHIBA_MEC_CT3	28677	25	f	\N	UL	1	Frame Sort Key	KB
10364	(7005,"TOSHIBA_MEC_CT3",1a)	(7005,"TOSHIBA_MEC_CT3",1a)	TOSHIBA_MEC_CT3	28677	26	f	\N	US	1	Frame Sort Order	KB
10365	(7005,"TOSHIBA_MEC_CT3",1b)	(7005,"TOSHIBA_MEC_CT3",1b)	TOSHIBA_MEC_CT3	28677	27	f	\N	SH	1	Convolution Kernel for Series Record	R
10366	(7005,"TOSHIBA_MEC_CT3",1c)	(7005,"TOSHIBA_MEC_CT3",1c)	TOSHIBA_MEC_CT3	28677	28	f	\N	LO	1	Contrast/Bolus Agent for Series Record	R
10367	(7005,"TOSHIBA_MEC_CT3",1d)	(7005,"TOSHIBA_MEC_CT3",1d)	TOSHIBA_MEC_CT3	28677	29	f	\N	UL	1	Reconstruction Number	KB
10368	(7005,"TOSHIBA_MEC_CT3",1e)	(7005,"TOSHIBA_MEC_CT3",1e)	TOSHIBA_MEC_CT3	28677	30	f	\N	UL	1	Raw Data Number	KB
10369	(7005,"TOSHIBA_MEC_CT3",1f)	(7005,"TOSHIBA_MEC_CT3",1f)	TOSHIBA_MEC_CT3	28677	31	f	\N	LO	1	Volume Number	R
10370	(7005,"TOSHIBA_MEC_CT3",20)	(7005,"TOSHIBA_MEC_CT3",20)	TOSHIBA_MEC_CT3	28677	32	f	\N	UL	1	Local Series Number	KB
10371	(7005,"TOSHIBA_MEC_CT3",21)	(7005,"TOSHIBA_MEC_CT3",21)	TOSHIBA_MEC_CT3	28677	33	f	\N	LO	1	Decrease in Artifact Filter	R
10372	(7005,"TOSHIBA_MEC_CT3",22)	(7005,"TOSHIBA_MEC_CT3",22)	TOSHIBA_MEC_CT3	28677	34	f	\N	DS	1	Reconstruction Interval	KB
10373	(7005,"TOSHIBA_MEC_CT3",23)	(7005,"TOSHIBA_MEC_CT3",23)	TOSHIBA_MEC_CT3	28677	35	f	\N	DS	1	Pitch Factor	KB
10374	(7005,"TOSHIBA_MEC_CT3",24)	(7005,"TOSHIBA_MEC_CT3",24)	TOSHIBA_MEC_CT3	28677	36	f	\N	DA	1	AcquisitionDateOfNRA	R
10375	(7005,"TOSHIBA_MEC_CT3",25)	(7005,"TOSHIBA_MEC_CT3",25)	TOSHIBA_MEC_CT3	28677	37	f	\N	UL	1	Large Data File Attribute	KB
10376	(7005,"TOSHIBA_MEC_CT3",26)	(7005,"TOSHIBA_MEC_CT3",26)	TOSHIBA_MEC_CT3	28677	38	f	\N	CS	1-8	Large Data File Name	R
10377	(7005,"TOSHIBA_MEC_CT3",28)	(7005,"TOSHIBA_MEC_CT3",28)	TOSHIBA_MEC_CT3	28677	40	f	\N	SQ	1	Enhanced CT Private Sequence	X
10378	(7005,"TOSHIBA_MEC_CT3",29)	(7005,"TOSHIBA_MEC_CT3",29)	TOSHIBA_MEC_CT3	28677	41	f	\N	UI	1	Frame UID	R
10379	(7005,"TOSHIBA_MEC_CT3",30)	(7005,"TOSHIBA_MEC_CT3",30)	TOSHIBA_MEC_CT3	28677	48	f	\N	CS	1	Main Modality in Study	R
10380	(7005,"TOSHIBA_MEC_CT3",35)	(7005,"TOSHIBA_MEC_CT3",35)	TOSHIBA_MEC_CT3	28677	53	f	\N	DS	2	Scan Range	KB
10381	(7005,"TOSHIBA_MEC_CT3",36)	(7005,"TOSHIBA_MEC_CT3",36)	TOSHIBA_MEC_CT3	28677	54	f	\N	OB	1	CT Private Data 3	X
10382	(7005,"TOSHIBA_MEC_CT3",37)	(7005,"TOSHIBA_MEC_CT3",37)	TOSHIBA_MEC_CT3	28677	55	f	\N	IS	1	Total Frames	KB
10383	(7005,"TOSHIBA_MEC_CT3",38)	(7005,"TOSHIBA_MEC_CT3",38)	TOSHIBA_MEC_CT3	28677	56	f	\N	IS	1	Start Frame	KB
10384	(7005,"TOSHIBA_MEC_CT3",39)	(7005,"TOSHIBA_MEC_CT3",39)	TOSHIBA_MEC_CT3	28677	57	f	\N	IS	1	End Frame	KB
10385	(7005,"TOSHIBA_MEC_CT3",40)	(7005,"TOSHIBA_MEC_CT3",40)	TOSHIBA_MEC_CT3	28677	64	f	\N	FD	1	DLP	KB
10386	(7005,"TOSHIBA_MEC_CT3",41)	(7005,"TOSHIBA_MEC_CT3",41)	TOSHIBA_MEC_CT3	28677	65	f	\N	SH	1	Row Slice Information	R
10387	(7005,"TOSHIBA_MEC_CT3",42)	(7005,"TOSHIBA_MEC_CT3",42)	TOSHIBA_MEC_CT3	28677	66	f	\N	US	1	Local Frame Number	KB
10388	(7005,"TOSHIBA_MEC_CT3",43)	(7005,"TOSHIBA_MEC_CT3",43)	TOSHIBA_MEC_CT3	28677	67	f	\N	DS	3	Volume Vector	KB
10389	(7005,"TOSHIBA_MEC_CT3",44)	(7005,"TOSHIBA_MEC_CT3",44)	TOSHIBA_MEC_CT3	28677	68	f	\N	US	1	Volume Type	KB
10390	(7005,"TOSHIBA_MEC_CT3",45)	(7005,"TOSHIBA_MEC_CT3",45)	TOSHIBA_MEC_CT3	28677	69	f	\N	DS	1	Relative Table Position of 4D Volume	KB
10391	(7005,"TOSHIBA_MEC_CT3",46)	(7005,"TOSHIBA_MEC_CT3",46)	TOSHIBA_MEC_CT3	28677	70	f	\N	DS	1	Absolute Table Position of 4D Volume	KB
10392	(7005,"TOSHIBA_MEC_CT3",47)	(7005,"TOSHIBA_MEC_CT3",47)	TOSHIBA_MEC_CT3	28677	71	f	\N	DS	1	Slice Pitch of 4D Volume	KB
10393	(7005,"TOSHIBA_MEC_CT3",48)	(7005,"TOSHIBA_MEC_CT3",48)	TOSHIBA_MEC_CT3	28677	72	f	\N	LO	1	Respiratory Gating Information	R
10394	(7005,"TOSHIBA_MEC_CT3",49)	(7005,"TOSHIBA_MEC_CT3",49)	TOSHIBA_MEC_CT3	28677	73	f	\N	SH	1	Respiratory Phase	R
10405	(7005,"TOSHIBA_MEC_CT3",f1)	(7005,"TOSHIBA_MEC_CT3",f1)	TOSHIBA_MEC_CT3	28677	241	f	\N	CS	1	Protect Mark for Image, Curve or Private Record	R
11158	(7005,"TOSHIBA_MEC_CT3",f2)	(7005,"TOSHIBA_MEC_CT3",f2)	TOSHIBA_MEC_CT3	28677	242	f	\N	CS	1	Protect Mark for Series Record	R
11159	(7005,"TOSHIBA_MEC_CT3",f3)	(7005,"TOSHIBA_MEC_CT3",f3)	TOSHIBA_MEC_CT3	28677	243	f	\N	CS	1	Protect Mark for Study Record	R
10406	(700d,"TOSHIBA_MEC_MR3",00)	(700d,"TOSHIBA_MEC_MR3",00)	TOSHIBA_MEC_MR3	28685	0	f	\N	DS	1	Scale Factor	KB
10407	(700d,"TOSHIBA_MEC_MR3",01)	(700d,"TOSHIBA_MEC_MR3",01)	TOSHIBA_MEC_MR3	28685	1	f	\N	OB	1	Acquisition Order	X
10408	(700d,"TOSHIBA_MEC_MR3",02)	(700d,"TOSHIBA_MEC_MR3",02)	TOSHIBA_MEC_MR3	28685	2	f	\N	DS	1	Orientation Vector	KB
10409	(700d,"TOSHIBA_MEC_MR3",03)	(700d,"TOSHIBA_MEC_MR3",03)	TOSHIBA_MEC_MR3	28685	3	f	\N	SS	1	Flip Flag	KB
10410	(700d,"TOSHIBA_MEC_MR3",04)	(700d,"TOSHIBA_MEC_MR3",04)	TOSHIBA_MEC_MR3	28685	4	f	\N	OB	1	Rotate Information	X
10411	(700d,"TOSHIBA_MEC_MR3",05)	(700d,"TOSHIBA_MEC_MR3",05)	TOSHIBA_MEC_MR3	28685	5	f	\N	DS	1	FOV	KB
10412	(700d,"TOSHIBA_MEC_MR3",06)	(700d,"TOSHIBA_MEC_MR3",06)	TOSHIBA_MEC_MR3	28685	6	f	\N	US	1	Image Matrix	KB
10413	(700d,"TOSHIBA_MEC_MR3",07)	(700d,"TOSHIBA_MEC_MR3",07)	TOSHIBA_MEC_MR3	28685	7	f	\N	OB	1	Image Information	X
10414	(700d,"TOSHIBA_MEC_MR3",08)	(700d,"TOSHIBA_MEC_MR3",08)	TOSHIBA_MEC_MR3	28685	8	f	\N	OB	1	Original Data	X
10415	(700d,"TOSHIBA_MEC_MR3",09)	(700d,"TOSHIBA_MEC_MR3",09)	TOSHIBA_MEC_MR3	28685	9	f	\N	SS	1	Original Data Flag	KB
11160	(700d,"TOSHIBA_MEC_MR3",80)	(700d,"TOSHIBA_MEC_MR3",80)	TOSHIBA_MEC_MR3	28685	128	f	\N	US	N	Number of PAC channel	KB
11161	(700d,"TOSHIBA_MEC_MR3",81)	(700d,"TOSHIBA_MEC_MR3",81)	TOSHIBA_MEC_MR3	28685	129	f	\N	US	N	Reference mode	KB
11162	(700d,"TOSHIBA_MEC_MR3",82)	(700d,"TOSHIBA_MEC_MR3",82)	TOSHIBA_MEC_MR3	28685	130	f	\N	SQ	N	Gain value group for MRS	KB
11163	(700d,"TOSHIBA_MEC_MR3",88)	(700d,"TOSHIBA_MEC_MR3",88)	TOSHIBA_MEC_MR3	28685	136	f	\N	UL	N	Flag of water Sat pulse	KB
11164	(700d,"TOSHIBA_MEC_MR3",89)	(700d,"TOSHIBA_MEC_MR3",89)	TOSHIBA_MEC_MR3	28685	137	f	\N	FL	N	Selected contrast TE	KB
11165	(700d,"TOSHIBA_MEC_MR3",8a)	(700d,"TOSHIBA_MEC_MR3",8a)	TOSHIBA_MEC_MR3	28685	138	f	\N	SQ	N	Raw Data Set Sequence	KB
11166	(700d,"TOSHIBA_MEC_MR3",91)	(700d,"TOSHIBA_MEC_MR3",91)	TOSHIBA_MEC_MR3	28685	145	f	\N	FL	N	Receiver gain of prescan	KB
7984	(7053,"Philips PET Private Group",00)	(7053,"Philips PET Private Group",00)	Philips PET Private Group	28755	0	f	\N	DS	1	SUV Factor	K
7985	(7053,"Philips PET Private Group",01)	(7053,"Philips PET Private Group",01)	Philips PET Private Group	28755	1	f	\N	OB	1	Private Data	X
7986	(7053,"Philips PET Private Group",02)	(7053,"Philips PET Private Group",02)	Philips PET Private Group	28755	2	f	\N	OB	1	Private Data	X
7987	(7053,"Philips PET Private Group",03)	(7053,"Philips PET Private Group",03)	Philips PET Private Group	28755	3	f	\N	ST	1	Original File Name	X
7989	(7053,"Philips PET Private Group",05)	(7053,"Philips PET Private Group",05)	Philips PET Private Group	28755	5	f	\N	LO	1	Worklist Info File Name	X
7990	(7053,"Philips PET Private Group",06)	(7053,"Philips PET Private Group",06)	Philips PET Private Group	28755	6	f	\N	OB	1	Unknown	X
7991	(7053,"Philips PET Private Group",07)	(7053,"Philips PET Private Group",07)	Philips PET Private Group	28755	7	f	\N	SQ	1	Unknown	X
7993	(7053,"Philips PET Private Group",09)	(7053,"Philips PET Private Group",09)	Philips PET Private Group	28755	9	f	\N	DS	1	Activity Concentration Scale Factor	K
7998	(7053,"Philips PET Private Group",13)	(7053,"Philips PET Private Group",13)	Philips PET Private Group	28755	19	f	\N	SS	1	Unknown	X
7999	(7053,"Philips PET Private Group",14)	(7053,"Philips PET Private Group",14)	Philips PET Private Group	28755	20	f	\N	SS	1	Unknown	X
8000	(7053,"Philips PET Private Group",15)	(7053,"Philips PET Private Group",15)	Philips PET Private Group	28755	21	f	\N	SS	1	Unknown	X
8001	(7053,"Philips PET Private Group",16)	(7053,"Philips PET Private Group",16)	Philips PET Private Group	28755	22	f	\N	SS	1	Unknown	X
8002	(7053,"Philips PET Private Group",17)	(7053,"Philips PET Private Group",17)	Philips PET Private Group	28755	23	f	\N	SS	1	Unknown	X
8003	(7053,"Philips PET Private Group",18)	(7053,"Philips PET Private Group",18)	Philips PET Private Group	28755	24	f	\N	SS	1	Unknown	X
8004	(7053,"Philips PET Private Group",c2)	(7053,"Philips PET Private Group",c2)	Philips PET Private Group	28755	194	f	\N	UI	1	Unknown	X
9330	(7fe1,"SIEMENS CSA NON-IMAGE",10)	(7fe1,"SIEMENS CSA NON-IMAGE",10)	SIEMENS CSA NON-IMAGE	32737	16	f	\N	OB	1	CSA Data	X
9331	(7fe3,"SIEMENS MED NM",14)	(7fe3,"SIEMENS MED NM",14)	SIEMENS MED NM	32739	20	f	\N	OW	1	Minimum Pixel in Frame	K
9332	(7fe3,"SIEMENS MED NM",15)	(7fe3,"SIEMENS MED NM",15)	SIEMENS MED NM	32739	21	f	\N	OW	1	Maximum Pixel in Frame	K
9340	(7fe3,"SIEMENS MED NM",29)	(7fe3,"SIEMENS MED NM",29)	SIEMENS MED NM	32739	41	f	\N	OW	1	Number of R-Waves in Frame	K
\.


--
-- Data for Name: pt_dcmtk; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt_dcmtk (pt_dcmtk_is_repeating, pt_id, ptrg_id, pt_dcmtk_signature, pt_dcmtk_vr, pt_dcmtk_vm, pt_dcmtk_name) FROM stdin;
f	1	\N	(0019,"1.2.840.113681",10)	ST	1	CRImageParamsCommon
f	2	\N	(0019,"1.2.840.113681",11)	ST	1	CRImageIPParamsSingle
f	3	\N	(0019,"1.2.840.113681",12)	ST	1	CRImageIPParamsLeft
f	4	\N	(0019,"1.2.840.113681",13)	ST	1	CRImageIPParamsRight
f	5	\N	(0087,"1.2.840.113708.794.1.1.2.0",10)	CS	1	MediaType
f	6	\N	(0087,"1.2.840.113708.794.1.1.2.0",20)	CS	1	MediaLocation
f	7	\N	(0087,"1.2.840.113708.794.1.1.2.0",50)	IS	1	EstimatedRetrieveTime
f	8	\N	(0009,"ACUSON",00)	IS	1	Unknown
f	9	\N	(0009,"ACUSON",01)	IS	1	Unknown
f	10	\N	(0009,"ACUSON",02)	UN	1	Unknown
f	11	\N	(0009,"ACUSON",03)	UN	1	Unknown
f	12	\N	(0009,"ACUSON",04)	UN	1	Unknown
f	13	\N	(0009,"ACUSON",05)	UN	1	Unknown
f	14	\N	(0009,"ACUSON",06)	UN	1	Unknown
f	15	\N	(0009,"ACUSON",07)	UN	1	Unknown
f	16	\N	(0009,"ACUSON",08)	LT	1	Unknown
f	17	\N	(0009,"ACUSON",09)	LT	1	Unknown
f	18	\N	(0009,"ACUSON",0a)	IS	1	Unknown
f	19	\N	(0009,"ACUSON",0b)	IS	1	Unknown
f	20	\N	(0009,"ACUSON",0c)	IS	1	Unknown
f	21	\N	(0009,"ACUSON",0d)	IS	1	Unknown
f	22	\N	(0009,"ACUSON",0e)	IS	1	Unknown
f	23	\N	(0009,"ACUSON",0f)	UN	1	Unknown
f	24	\N	(0009,"ACUSON",10)	IS	1	Unknown
f	25	\N	(0009,"ACUSON",11)	UN	1	Unknown
f	26	\N	(0009,"ACUSON",12)	IS	1	Unknown
f	27	\N	(0009,"ACUSON",13)	IS	1	Unknown
f	28	\N	(0009,"ACUSON",14)	LT	1	Unknown
f	29	\N	(0009,"ACUSON",15)	UN	1	Unknown
f	30	\N	(0003,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	31	\N	(0005,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	32	\N	(0009,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	33	\N	(0019,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	34	\N	(0029,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	35	\N	(1369,"AEGIS_DICOM_2.00",00)	US	1-n	Unknown
f	36	\N	(0009,"AGFA",10)	LO	1	Unknown
f	37	\N	(0009,"AGFA",11)	LO	1	Unknown
f	38	\N	(0009,"AGFA",13)	LO	1	Unknown
f	39	\N	(0009,"AGFA",14)	LO	1	Unknown
f	40	\N	(0009,"AGFA",15)	LO	1	Unknown
f	41	\N	(0029,"CAMTRONICS IP",10)	LT	1	Unknown
f	42	\N	(0029,"CAMTRONICS IP",20)	UN	1	Unknown
f	43	\N	(0029,"CAMTRONICS IP",30)	UN	1	Unknown
f	44	\N	(0029,"CAMTRONICS IP",40)	UN	1	Unknown
f	45	\N	(0029,"CAMTRONICS",10)	LT	1	Commentline
f	46	\N	(0029,"CAMTRONICS",20)	DS	1	EdgeEnhancementCoefficient
f	47	\N	(0029,"CAMTRONICS",50)	LT	1	SceneText
f	48	\N	(0029,"CAMTRONICS",60)	LT	1	ImageText
f	49	\N	(0029,"CAMTRONICS",70)	IS	1	PixelShiftHorizontal
f	50	\N	(0029,"CAMTRONICS",80)	IS	1	PixelShiftVertical
f	51	\N	(0029,"CAMTRONICS",90)	IS	1	Unknown
f	52	\N	(0009,"CARDIO-D.R. 1.0",00)	UL	1	FileLocation
f	53	\N	(0009,"CARDIO-D.R. 1.0",01)	UL	1	FileSize
f	54	\N	(0009,"CARDIO-D.R. 1.0",40)	SQ	1	AlternateImageSequence
f	55	\N	(0019,"CARDIO-D.R. 1.0",00)	CS	1	ImageBlankingShape
f	56	\N	(0019,"CARDIO-D.R. 1.0",02)	IS	1	ImageBlankingLeftVerticalEdge
f	57	\N	(0019,"CARDIO-D.R. 1.0",04)	IS	1	ImageBlankingRightVerticalEdge
f	58	\N	(0019,"CARDIO-D.R. 1.0",06)	IS	1	ImageBlankingUpperHorizontalEdge
f	59	\N	(0019,"CARDIO-D.R. 1.0",08)	IS	1	ImageBlankingLowerHorizontalEdge
f	60	\N	(0019,"CARDIO-D.R. 1.0",10)	IS	1	CenterOfCircularImageBlanking
f	61	\N	(0019,"CARDIO-D.R. 1.0",12)	IS	1	RadiusOfCircularImageBlanking
f	62	\N	(0019,"CARDIO-D.R. 1.0",30)	UL	1	MaximumImageFrameSize
f	63	\N	(0021,"CARDIO-D.R. 1.0",13)	IS	1	ImageSequenceNumber
f	64	\N	(0029,"CARDIO-D.R. 1.0",00)	SQ	1	EdgeEnhancementSequence
f	65	\N	(0029,"CARDIO-D.R. 1.0",01)	US	2	ConvolutionKernelSize
f	66	\N	(0029,"CARDIO-D.R. 1.0",02)	DS	1-n	ConvolutionKernelCoefficients
f	67	\N	(0029,"CARDIO-D.R. 1.0",03)	DS	1	EdgeEnhancementGain
f	68	\N	(0025,"CMR42 CIRCLECVI",1010)	LO	1	WorkspaceID
f	69	\N	(0025,"CMR42 CIRCLECVI",1020)	LO	1	WorkspaceTimeString
f	70	\N	(0025,"CMR42 CIRCLECVI",1030)	OB	1	WorkspaceStream
f	71	\N	(0009,"DCMTK_ANONYMIZER",00)	SQ	1	AnonymizerUIDMap
f	72	\N	(0009,"DCMTK_ANONYMIZER",10)	UI	1	AnonymizerUIDKey
f	73	\N	(0009,"DCMTK_ANONYMIZER",20)	UI	1	AnonymizerUIDValue
f	74	\N	(0009,"DCMTK_ANONYMIZER",30)	SQ	1	AnonymizerPatientIDMap
f	75	\N	(0009,"DCMTK_ANONYMIZER",40)	LO	1	AnonymizerPatientIDKey
f	76	\N	(0009,"DCMTK_ANONYMIZER",50)	LO	1	AnonymizerPatientIDValue
f	77	\N	(0019,"DIDI TO PCR 1.1",22)	UN	1	RouteAET
f	78	\N	(0019,"DIDI TO PCR 1.1",23)	DS	1	PCRPrintScale
f	79	\N	(0019,"DIDI TO PCR 1.1",24)	UN	1	PCRPrintJobEnd
f	80	\N	(0019,"DIDI TO PCR 1.1",25)	IS	1	PCRNoFilmCopies
f	81	\N	(0019,"DIDI TO PCR 1.1",26)	IS	1	PCRFilmLayoutPosition
f	82	\N	(0019,"DIDI TO PCR 1.1",27)	UN	1	PCRPrintReportName
f	83	\N	(0019,"DIDI TO PCR 1.1",70)	UN	1	RADProtocolPrinter
f	84	\N	(0019,"DIDI TO PCR 1.1",71)	UN	1	RADProtocolMedium
f	85	\N	(0019,"DIDI TO PCR 1.1",90)	LO	1	UnprocessedFlag
f	86	\N	(0019,"DIDI TO PCR 1.1",91)	UN	1	KeyValues
f	87	\N	(0019,"DIDI TO PCR 1.1",92)	UN	1	DestinationPostprocessingFunction
f	88	\N	(0019,"DIDI TO PCR 1.1",A0)	UN	1	Version
f	89	\N	(0019,"DIDI TO PCR 1.1",A1)	UN	1	RangingMode
f	90	\N	(0019,"DIDI TO PCR 1.1",A2)	UN	1	AbdomenBrightness
f	91	\N	(0019,"DIDI TO PCR 1.1",A3)	UN	1	FixedBrightness
f	92	\N	(0019,"DIDI TO PCR 1.1",A4)	UN	1	DetailContrast
f	93	\N	(0019,"DIDI TO PCR 1.1",A5)	UN	1	ContrastBalance
f	94	\N	(0019,"DIDI TO PCR 1.1",A6)	UN	1	StructureBoost
f	95	\N	(0019,"DIDI TO PCR 1.1",A7)	UN	1	StructurePreference
f	96	\N	(0019,"DIDI TO PCR 1.1",A8)	UN	1	NoiseRobustness
f	97	\N	(0019,"DIDI TO PCR 1.1",A9)	UN	1	NoiseDoseLimit
f	98	\N	(0019,"DIDI TO PCR 1.1",AA)	UN	1	NoiseDoseStep
f	99	\N	(0019,"DIDI TO PCR 1.1",AB)	UN	1	NoiseFrequencyLimit
f	100	\N	(0019,"DIDI TO PCR 1.1",AC)	UN	1	WeakContrastLimit
f	101	\N	(0019,"DIDI TO PCR 1.1",AD)	UN	1	StrongContrastLimit
f	102	\N	(0019,"DIDI TO PCR 1.1",AE)	UN	1	StructureBoostOffset
f	103	\N	(0019,"DIDI TO PCR 1.1",AF)	UN	1	SmoothGain
f	104	\N	(0019,"DIDI TO PCR 1.1",B0)	UN	1	MeasureField1
f	105	\N	(0019,"DIDI TO PCR 1.1",B1)	UN	1	MeasureField2
f	106	\N	(0019,"DIDI TO PCR 1.1",B2)	UN	1	KeyPercentile1
f	107	\N	(0019,"DIDI TO PCR 1.1",B3)	UN	1	KeyPercentile2
f	108	\N	(0019,"DIDI TO PCR 1.1",B4)	UN	1	DensityLUT
f	109	\N	(0019,"DIDI TO PCR 1.1",B5)	UN	1	Brightness
f	110	\N	(0019,"DIDI TO PCR 1.1",B6)	UN	1	Gamma
f	111	\N	(0089,"DIDI TO PCR 1.1",10)	SQ	1	Unknown
f	112	\N	(0029,"DIGISCAN IMAGE",31)	US	1-n	Unknown
f	113	\N	(0029,"DIGISCAN IMAGE",32)	US	1-n	Unknown
f	114	\N	(0029,"DIGISCAN IMAGE",33)	LT	1	Unknown
f	115	\N	(0029,"DIGISCAN IMAGE",34)	LT	1	Unknown
t	\N	1	(7001-o-70ff,"DLX_ANNOT_01",04)	ST	1	TextAnnotation
t	\N	2	(7001-o-70ff,"DLX_ANNOT_01",05)	IS	2	Box
t	\N	3	(7001-o-70ff,"DLX_ANNOT_01",07)	IS	2	ArrowEnd
f	116	\N	(0015,"DLX_EXAMS_01",01)	DS	1	StenosisCalibrationRatio
f	117	\N	(0015,"DLX_EXAMS_01",02)	DS	1	StenosisMagnification
f	118	\N	(0015,"DLX_EXAMS_01",03)	DS	1	CardiacCalibrationRatio
t	\N	4	(6001-o-60ff,"DLX_LKUP_01",01)	US	3	GrayPaletteColorLookupTableDescriptor
t	\N	5	(6001-o-60ff,"DLX_LKUP_01",02)	US	1	GrayPaletteColorLookupTableData
f	119	\N	(0011,"DLX_PATNT_01",01)	LT	1	PatientDOB
f	120	\N	(0019,"DLX_SERIE_01",01)	DS	1	AngleValueLArm
f	121	\N	(0019,"DLX_SERIE_01",02)	DS	1	AngleValuePArm
f	122	\N	(0019,"DLX_SERIE_01",03)	DS	1	AngleValueCArm
f	123	\N	(0019,"DLX_SERIE_01",04)	CS	1	AngleLabelLArm
f	124	\N	(0019,"DLX_SERIE_01",05)	CS	1	AngleLabelPArm
f	125	\N	(0019,"DLX_SERIE_01",06)	CS	1	AngleLabelCArm
f	126	\N	(0019,"DLX_SERIE_01",07)	ST	1	ProcedureName
f	127	\N	(0019,"DLX_SERIE_01",08)	ST	1	ExamName
f	128	\N	(0019,"DLX_SERIE_01",09)	SH	1	PatientSize
f	129	\N	(0019,"DLX_SERIE_01",0a)	IS	1	RecordView
f	130	\N	(0019,"DLX_SERIE_01",10)	DS	1	InjectorDelay
f	131	\N	(0019,"DLX_SERIE_01",11)	CS	1	AutoInject
f	132	\N	(0019,"DLX_SERIE_01",14)	IS	1	AcquisitionMode
f	133	\N	(0019,"DLX_SERIE_01",15)	CS	1	CameraRotationEnabled
f	134	\N	(0019,"DLX_SERIE_01",16)	CS	1	ReverseSweep
f	135	\N	(0019,"DLX_SERIE_01",17)	IS	1	SpatialFilterStrength
f	136	\N	(0019,"DLX_SERIE_01",18)	IS	1	ZoomFactor
f	137	\N	(0019,"DLX_SERIE_01",19)	IS	1	XZoomCenter
f	138	\N	(0019,"DLX_SERIE_01",1a)	IS	1	YZoomCenter
f	139	\N	(0019,"DLX_SERIE_01",1b)	DS	1	Focus
f	140	\N	(0019,"DLX_SERIE_01",1c)	CS	1	Dose
f	141	\N	(0019,"DLX_SERIE_01",1d)	IS	1	SideMark
f	142	\N	(0019,"DLX_SERIE_01",1e)	IS	1	PercentageLandscape
f	143	\N	(0019,"DLX_SERIE_01",1f)	DS	1	ExposureDuration
f	144	\N	(00E1,"ELSCINT1",01)	US	1	DataDictionaryVersion
f	145	\N	(00E1,"ELSCINT1",14)	LT	1	Unknown
f	146	\N	(00E1,"ELSCINT1",22)	DS	2	Unknown
f	147	\N	(00E1,"ELSCINT1",23)	DS	2	Unknown
f	148	\N	(00E1,"ELSCINT1",24)	LT	1	Unknown
f	149	\N	(00E1,"ELSCINT1",25)	LT	1	Unknown
f	150	\N	(00E1,"ELSCINT1",40)	SH	1	OffsetFromCTMRImages
f	151	\N	(0601,"ELSCINT1",00)	SH	1	ImplementationVersion
f	152	\N	(0601,"ELSCINT1",20)	DS	1	RelativeTablePosition
f	153	\N	(0601,"ELSCINT1",21)	DS	1	RelativeTableHeight
f	154	\N	(0601,"ELSCINT1",30)	SH	1	SurviewDirection
f	155	\N	(0601,"ELSCINT1",31)	DS	1	SurviewLength
f	156	\N	(0601,"ELSCINT1",50)	SH	1	ImageViewType
f	157	\N	(0601,"ELSCINT1",70)	DS	1	BatchNumber
f	158	\N	(0601,"ELSCINT1",71)	DS	1	BatchSize
f	159	\N	(0601,"ELSCINT1",72)	DS	1	BatchSliceNumber
f	160	\N	(0009,"FDMS 1.0",04)	SH	1	ImageControlUnit
f	161	\N	(0009,"FDMS 1.0",05)	OW	1	ImageUID
f	162	\N	(0009,"FDMS 1.0",06)	OW	1	RouteImage UID
f	163	\N	(0009,"FDMS 1.0",08)	UL	1	ImageDisplayInformationVersionNo
f	164	\N	(0009,"FDMS 1.0",09)	UL	1	PatientInformationVersionNo
f	165	\N	(0009,"FDMS 1.0",0C)	OW	1	FilmUID
f	166	\N	(0009,"FDMS 1.0",10)	CS	1	ExposureUnitTypeCode
f	167	\N	(0009,"FDMS 1.0",80)	LO	1	KanjiHospitalName
f	168	\N	(0009,"FDMS 1.0",90)	ST	1	DistributionCode
f	169	\N	(0009,"FDMS 1.0",92)	SH	1	KanjiDepartmentName
f	170	\N	(0009,"FDMS 1.0",F0)	CS	1	BlackeningProcessFlag
f	171	\N	(0019,"FDMS 1.0",15)	LO	1	KanjiBodyPartForExposure
f	172	\N	(0019,"FDMS 1.0",32)	LO	1	KanjiMenuName
f	173	\N	(0019,"FDMS 1.0",40)	CS	1	ImageProcessingType
f	174	\N	(0019,"FDMS 1.0",50)	CS	1	EDRMode
f	175	\N	(0019,"FDMS 1.0",60)	SH	1	RadiographersCode
f	176	\N	(0019,"FDMS 1.0",70)	IS	1	SplitExposureFormat
f	177	\N	(0019,"FDMS 1.0",71)	IS	1	NoOfSplitExposureFrames
f	178	\N	(0019,"FDMS 1.0",80)	IS	1	ReadingPositionSpecification
f	179	\N	(0019,"FDMS 1.0",81)	IS	1	ReadingSensitivityCenter
f	180	\N	(0019,"FDMS 1.0",90)	SH	1	FilmAnnotationCharacterString1
f	181	\N	(0019,"FDMS 1.0",91)	SH	1	FilmAnnotationCharacterString2
f	182	\N	(0021,"FDMS 1.0",10)	CS	1	FCRImageID
f	183	\N	(0021,"FDMS 1.0",30)	CS	1	SetNo
f	184	\N	(0021,"FDMS 1.0",40)	IS	1	ImageNoInTheSet
f	185	\N	(0021,"FDMS 1.0",50)	CS	1	PairProcessingInformation
f	186	\N	(0021,"FDMS 1.0",80)	OB	1	EquipmentTypeSpecificInformation
f	187	\N	(0023,"FDMS 1.0",10)	SQ	1	Unknown
f	188	\N	(0023,"FDMS 1.0",20)	SQ	1	Unknown
f	189	\N	(0023,"FDMS 1.0",30)	SQ	1	Unknown
f	190	\N	(0025,"FDMS 1.0",10)	US	1	RelativeLightEmissionAmountSk
f	191	\N	(0025,"FDMS 1.0",11)	US	1	TermOfCorrectionForEachIPTypeSt
f	192	\N	(0025,"FDMS 1.0",12)	US	1	ReadingGainGp
f	193	\N	(0025,"FDMS 1.0",13)	US	1	Unknown
f	194	\N	(0025,"FDMS 1.0",15)	CS	1	Unknown
f	195	\N	(0025,"FDMS 1.0",20)	US	2	Unknown
f	196	\N	(0025,"FDMS 1.0",21)	US	1	Unknown
f	197	\N	(0025,"FDMS 1.0",30)	US	1	Unknown
f	198	\N	(0025,"FDMS 1.0",31)	SS	1	Unknown
f	199	\N	(0025,"FDMS 1.0",32)	US	1	Unknown
f	200	\N	(0025,"FDMS 1.0",33)	SS	1	Unknown
f	201	\N	(0025,"FDMS 1.0",34)	SS	1	Unknown
f	202	\N	(0025,"FDMS 1.0",40)	US	1	Unknown
f	203	\N	(0025,"FDMS 1.0",41)	US	1	Unknown
f	204	\N	(0025,"FDMS 1.0",42)	US	1	Unknown
f	205	\N	(0025,"FDMS 1.0",43)	US	1	Unknown
f	206	\N	(0025,"FDMS 1.0",50)	US	1	Unknown
f	207	\N	(0025,"FDMS 1.0",51)	US	1	Unknown
f	208	\N	(0025,"FDMS 1.0",52)	US	1	Unknown
f	209	\N	(0025,"FDMS 1.0",53)	US	1	Unknown
f	210	\N	(0025,"FDMS 1.0",60)	US	1	Unknown
f	211	\N	(0025,"FDMS 1.0",61)	US	1	Unknown
f	212	\N	(0025,"FDMS 1.0",62)	US	1	Unknown
f	213	\N	(0025,"FDMS 1.0",63)	CS	1	Unknown
f	214	\N	(0025,"FDMS 1.0",70)	US	1	Unknown
f	215	\N	(0025,"FDMS 1.0",71)	US	1	Unknown
f	216	\N	(0025,"FDMS 1.0",72)	US	1	Unknown
f	217	\N	(0025,"FDMS 1.0",73)	US	1-n	Unknown
f	218	\N	(0025,"FDMS 1.0",74)	US	1-n	Unknown
f	219	\N	(0025,"FDMS 1.0",80)	US	1	Unknown
f	220	\N	(0025,"FDMS 1.0",81)	US	1	Unknown
f	221	\N	(0025,"FDMS 1.0",82)	US	1	Unknown
f	222	\N	(0025,"FDMS 1.0",83)	US	1-n	Unknown
f	223	\N	(0025,"FDMS 1.0",84)	US	1-n	Unknown
f	224	\N	(0025,"FDMS 1.0",90)	US	1	Unknown
f	225	\N	(0025,"FDMS 1.0",91)	US	1	Unknown
f	226	\N	(0025,"FDMS 1.0",92)	US	1	Unknown
f	227	\N	(0025,"FDMS 1.0",93)	US	1	Unknown
f	228	\N	(0025,"FDMS 1.0",94)	US	1	Unknown
f	229	\N	(0025,"FDMS 1.0",95)	US	1	Unknown
f	230	\N	(0025,"FDMS 1.0",96)	CS	1	Unknown
f	231	\N	(0025,"FDMS 1.0",a0)	US	1	Unknown
f	232	\N	(0025,"FDMS 1.0",a1)	SS	1	Unknown
f	233	\N	(0025,"FDMS 1.0",a2)	US	1	Unknown
f	234	\N	(0025,"FDMS 1.0",a3)	SS	1	Unknown
f	235	\N	(0027,"FDMS 1.0",10)	SQ	1	Unknown
f	236	\N	(0027,"FDMS 1.0",20)	SQ	1	Unknown
f	237	\N	(0027,"FDMS 1.0",30)	SQ	1	Unknown
f	238	\N	(0027,"FDMS 1.0",40)	SQ	1	Unknown
f	239	\N	(0027,"FDMS 1.0",50)	SQ	1	Unknown
f	240	\N	(0027,"FDMS 1.0",60)	SQ	1	Unknown
f	241	\N	(0027,"FDMS 1.0",70)	SQ	1	Unknown
f	242	\N	(0027,"FDMS 1.0",80)	SQ	1	Unknown
f	243	\N	(0027,"FDMS 1.0",a0)	IS	1	Unknown
f	244	\N	(0027,"FDMS 1.0",a1)	CS	2	Unknown
f	245	\N	(0027,"FDMS 1.0",a2)	CS	2	Unknown
f	246	\N	(0027,"FDMS 1.0",a3)	SS	1-n	Unknown
f	247	\N	(0029,"FDMS 1.0",20)	CS	1	ImageScanningDirection
f	248	\N	(0029,"FDMS 1.0",30)	CS	1	ExtendedReadingSizeValue
f	249	\N	(0029,"FDMS 1.0",34)	US	1	MagnificationReductionRatio
f	250	\N	(0029,"FDMS 1.0",44)	CS	1	LineDensityCode
f	251	\N	(0029,"FDMS 1.0",50)	CS	1	DataCompressionCode
f	252	\N	(2011,"FDMS 1.0",11)	CS	1	ImagePosition SpecifyingFlag
f	253	\N	(50F1,"FDMS 1.0",06)	CS	1	EnergySubtractionParam
f	254	\N	(50F1,"FDMS 1.0",07)	CS	1	SubtractionRegistrationResult
f	255	\N	(50F1,"FDMS 1.0",08)	CS	1	EnergySubtractionParam2
f	256	\N	(50F1,"FDMS 1.0",09)	SL	1	AfinConversionCoefficient
f	257	\N	(50F1,"FDMS 1.0",10)	CS	1	FilmOutputFormat
f	258	\N	(50F1,"FDMS 1.0",20)	CS	1	ImageProcessingModificationFlag
f	259	\N	(0009,"FFP DATA",01)	UN	1	CRHeaderInformation
f	260	\N	(0019,"GE ??? From Adantage Review CS",30)	LO	1	CREDRMode
f	261	\N	(0019,"GE ??? From Adantage Review CS",40)	LO	1	CRLatitude
f	262	\N	(0019,"GE ??? From Adantage Review CS",50)	LO	1	CRGroupNumber
f	263	\N	(0019,"GE ??? From Adantage Review CS",70)	LO	1	CRImageSerialNumber
f	264	\N	(0019,"GE ??? From Adantage Review CS",80)	LO	1	CRBarCodeNumber
f	265	\N	(0019,"GE ??? From Adantage Review CS",90)	LO	1	CRFilmOutputExposures
f	266	\N	(0009,"GEMS_ACQU_01",24)	DS	1	Unknown
f	267	\N	(0009,"GEMS_ACQU_01",25)	US	1	Unknown
f	268	\N	(0009,"GEMS_ACQU_01",3e)	US	1	Unknown
f	269	\N	(0009,"GEMS_ACQU_01",3f)	US	1	Unknown
f	270	\N	(0009,"GEMS_ACQU_01",42)	US	1	Unknown
f	271	\N	(0009,"GEMS_ACQU_01",43)	US	1	Unknown
f	272	\N	(0009,"GEMS_ACQU_01",f8)	US	1	Unknown
f	273	\N	(0009,"GEMS_ACQU_01",fb)	IS	1	Unknown
f	274	\N	(0019,"GEMS_ACQU_01",01)	LT	1	Unknown
f	275	\N	(0019,"GEMS_ACQU_01",02)	SL	1	NumberOfCellsInDetector
f	276	\N	(0019,"GEMS_ACQU_01",03)	DS	1	CellNumberAtTheta
f	277	\N	(0019,"GEMS_ACQU_01",04)	DS	1	CellSpacing
f	278	\N	(0019,"GEMS_ACQU_01",05)	LT	1	Unknown
f	279	\N	(0019,"GEMS_ACQU_01",06)	UN	1	Unknown
f	280	\N	(0019,"GEMS_ACQU_01",0e)	US	1	Unknown
f	281	\N	(0019,"GEMS_ACQU_01",0f)	DS	1	HorizontalFrameOfReference
f	282	\N	(0019,"GEMS_ACQU_01",11)	SS	1	SeriesContrast
f	283	\N	(0019,"GEMS_ACQU_01",12)	SS	1	LastPseq
f	284	\N	(0019,"GEMS_ACQU_01",13)	SS	1	StartNumberForBaseline
f	285	\N	(0019,"GEMS_ACQU_01",14)	SS	1	End NumberForBaseline
f	286	\N	(0019,"GEMS_ACQU_01",15)	SS	1	StartNumberForEnhancedScans
f	287	\N	(0019,"GEMS_ACQU_01",16)	SS	1	EndNumberForEnhancedScans
f	288	\N	(0019,"GEMS_ACQU_01",17)	SS	1	SeriesPlane
f	289	\N	(0019,"GEMS_ACQU_01",18)	LO	1	FirstScanRAS
f	290	\N	(0019,"GEMS_ACQU_01",19)	DS	1	FirstScanLocation
f	291	\N	(0019,"GEMS_ACQU_01",1a)	LO	1	LastScanRAS
f	292	\N	(0019,"GEMS_ACQU_01",1b)	DS	1	LastScanLocation
f	293	\N	(0019,"GEMS_ACQU_01",1e)	DS	1	DisplayFieldOfView
f	294	\N	(0019,"GEMS_ACQU_01",20)	DS	1	Unknown
f	295	\N	(0019,"GEMS_ACQU_01",22)	DS	1	Unknown
f	296	\N	(0019,"GEMS_ACQU_01",23)	DS	1	TableSpeed
f	297	\N	(0019,"GEMS_ACQU_01",24)	DS	1	MidScanTime
f	298	\N	(0019,"GEMS_ACQU_01",25)	SS	1	MidScanFlag
f	299	\N	(0019,"GEMS_ACQU_01",26)	SL	1	DegreesOfAzimuth
f	300	\N	(0019,"GEMS_ACQU_01",27)	DS	1	GantryPeriod
f	301	\N	(0019,"GEMS_ACQU_01",2a)	DS	1	XrayOnPosition
f	302	\N	(0019,"GEMS_ACQU_01",2b)	DS	1	XrayOffPosition
f	303	\N	(0019,"GEMS_ACQU_01",2c)	SL	1	NumberOfTriggers
f	304	\N	(0019,"GEMS_ACQU_01",2d)	US	1	Unknown
f	305	\N	(0019,"GEMS_ACQU_01",2e)	DS	1	AngleOfFirstView
f	306	\N	(0019,"GEMS_ACQU_01",2f)	DS	1	TriggerFrequency
f	307	\N	(0019,"GEMS_ACQU_01",39)	SS	1	ScanFOVType
f	308	\N	(0019,"GEMS_ACQU_01",3a)	IS	1	Unknown
f	309	\N	(0019,"GEMS_ACQU_01",3b)	LT	1	Unknown
f	310	\N	(0019,"GEMS_ACQU_01",3c)	UN	1	Unknown
f	311	\N	(0019,"GEMS_ACQU_01",3e)	UN	1	Unknown
f	312	\N	(0019,"GEMS_ACQU_01",3f)	UN	1	Unknown
f	313	\N	(0019,"GEMS_ACQU_01",40)	SS	1	StatReconFlag
f	314	\N	(0019,"GEMS_ACQU_01",41)	SS	1	ComputeType
f	315	\N	(0019,"GEMS_ACQU_01",42)	SS	1	SegmentNumber
f	316	\N	(0019,"GEMS_ACQU_01",43)	SS	1	TotalSegmentsRequested
f	317	\N	(0019,"GEMS_ACQU_01",44)	DS	1	InterscanDelay
f	318	\N	(0019,"GEMS_ACQU_01",47)	SS	1	ViewCompressionFactor
f	319	\N	(0019,"GEMS_ACQU_01",48)	US	1	Unknown
f	320	\N	(0019,"GEMS_ACQU_01",49)	US	1	Unknown
f	321	\N	(0019,"GEMS_ACQU_01",4a)	SS	1	TotalNumberOfRefChannels
f	322	\N	(0019,"GEMS_ACQU_01",4b)	SL	1	DataSizeForScanData
f	323	\N	(0019,"GEMS_ACQU_01",52)	SS	1	ReconPostProcessingFlag
f	324	\N	(0019,"GEMS_ACQU_01",54)	UN	1	Unknown
f	325	\N	(0019,"GEMS_ACQU_01",57)	SS	1	CTWaterNumber
f	326	\N	(0019,"GEMS_ACQU_01",58)	SS	1	CTBoneNumber
f	327	\N	(0019,"GEMS_ACQU_01",5a)	FL	1	AcquisitionDuration
f	328	\N	(0019,"GEMS_ACQU_01",5d)	US	1	Unknown
f	329	\N	(0019,"GEMS_ACQU_01",5e)	SL	1	NumberOfChannels1To512
f	330	\N	(0019,"GEMS_ACQU_01",5f)	SL	1	IncrementBetweenChannels
f	331	\N	(0019,"GEMS_ACQU_01",60)	SL	1	StartingView
f	332	\N	(0019,"GEMS_ACQU_01",61)	SL	1	NumberOfViews
f	333	\N	(0019,"GEMS_ACQU_01",62)	SL	1	IncrementBetweenViews
f	334	\N	(0019,"GEMS_ACQU_01",6a)	SS	1	DependantOnNumberOfViewsProcessed
f	335	\N	(0019,"GEMS_ACQU_01",6b)	SS	1	FieldOfViewInDetectorCells
f	336	\N	(0019,"GEMS_ACQU_01",70)	SS	1	ValueOfBackProjectionButton
f	337	\N	(0019,"GEMS_ACQU_01",71)	SS	1	SetIfFatqEstimatesWereUsed
f	338	\N	(0019,"GEMS_ACQU_01",72)	DS	1	ZChannelAvgOverViews
f	339	\N	(0019,"GEMS_ACQU_01",73)	DS	1	AvgOfLeftRefChannelsOverViews
f	340	\N	(0019,"GEMS_ACQU_01",74)	DS	1	MaxLeftChannelOverViews
f	341	\N	(0019,"GEMS_ACQU_01",75)	DS	1	AvgOfRightRefChannelsOverViews
f	342	\N	(0019,"GEMS_ACQU_01",76)	DS	1	MaxRightChannelOverViews
f	343	\N	(0019,"GEMS_ACQU_01",7d)	DS	1	SecondEcho
f	344	\N	(0019,"GEMS_ACQU_01",7e)	SS	1	NumberOfEchos
f	345	\N	(0019,"GEMS_ACQU_01",7f)	DS	1	TableDelta
f	346	\N	(0019,"GEMS_ACQU_01",81)	SS	1	Contiguous
f	347	\N	(0019,"GEMS_ACQU_01",82)	US	1	Unknown
f	348	\N	(0019,"GEMS_ACQU_01",83)	DS	1	Unknown
f	349	\N	(0019,"GEMS_ACQU_01",84)	DS	1	PeakSAR
f	350	\N	(0019,"GEMS_ACQU_01",85)	SS	1	MonitorSAR
f	351	\N	(0019,"GEMS_ACQU_01",86)	US	1	Unknown
f	352	\N	(0019,"GEMS_ACQU_01",87)	DS	1	CardiacRepetition Time
f	353	\N	(0019,"GEMS_ACQU_01",88)	SS	1	ImagesPerCardiacCycle
f	354	\N	(0019,"GEMS_ACQU_01",8a)	SS	1	ActualReceiveGainAnalog
f	355	\N	(0019,"GEMS_ACQU_01",8b)	SS	1	ActualReceiveGainDigital
f	356	\N	(0019,"GEMS_ACQU_01",8d)	DS	1	DelayAfterTrigger
f	357	\N	(0019,"GEMS_ACQU_01",8f)	SS	1	SwapPhaseFrequency
f	358	\N	(0019,"GEMS_ACQU_01",90)	SS	1	PauseInterval
f	359	\N	(0019,"GEMS_ACQU_01",91)	DS	1	PulseTime
f	360	\N	(0019,"GEMS_ACQU_01",92)	SL	1	SliceOffsetOnFrequencyAxis
f	361	\N	(0019,"GEMS_ACQU_01",93)	DS	1	CenterFrequency
f	362	\N	(0019,"GEMS_ACQU_01",94)	SS	1	TransmitGain
f	363	\N	(0019,"GEMS_ACQU_01",95)	SS	1	AnalogReceiverGain
f	364	\N	(0019,"GEMS_ACQU_01",96)	SS	1	DigitalReceiverGain
f	365	\N	(0019,"GEMS_ACQU_01",97)	SL	1	BitmapDefiningCVs
f	366	\N	(0019,"GEMS_ACQU_01",98)	SS	1	CenterFrequencyMethod
f	367	\N	(0019,"GEMS_ACQU_01",99)	US	1	Unknown
f	368	\N	(0019,"GEMS_ACQU_01",9b)	SS	1	PulseSequenceMode
f	369	\N	(0019,"GEMS_ACQU_01",9c)	LO	1	PulseSequenceName
f	370	\N	(0019,"GEMS_ACQU_01",9d)	DT	1	PulseSequenceDate
f	371	\N	(0019,"GEMS_ACQU_01",9e)	LO	1	InternalPulseSequenceName
f	372	\N	(0019,"GEMS_ACQU_01",9f)	SS	1	TransmittingCoil
f	373	\N	(0019,"GEMS_ACQU_01",a0)	SS	1	SurfaceCoilType
f	374	\N	(0019,"GEMS_ACQU_01",a1)	SS	1	ExtremityCoilFlag
f	375	\N	(0019,"GEMS_ACQU_01",a2)	SL	1	RawDataRunNumber
f	376	\N	(0019,"GEMS_ACQU_01",a3)	UL	1	CalibratedFieldStrength
f	377	\N	(0019,"GEMS_ACQU_01",a4)	SS	1	SATFatWaterBone
f	378	\N	(0019,"GEMS_ACQU_01",a5)	DS	1	ReceiveBandwidth
f	379	\N	(0019,"GEMS_ACQU_01",a7)	DS	1	UserData
f	380	\N	(0019,"GEMS_ACQU_01",a8)	DS	1	UserData
f	381	\N	(0019,"GEMS_ACQU_01",a9)	DS	1	UserData
f	382	\N	(0019,"GEMS_ACQU_01",aa)	DS	1	UserData
f	383	\N	(0019,"GEMS_ACQU_01",ab)	DS	1	UserData
f	384	\N	(0019,"GEMS_ACQU_01",ac)	DS	1	UserData
f	385	\N	(0019,"GEMS_ACQU_01",ad)	DS	1	UserData
f	386	\N	(0019,"GEMS_ACQU_01",ae)	DS	1	UserData
f	387	\N	(0019,"GEMS_ACQU_01",af)	DS	1	UserData
f	388	\N	(0019,"GEMS_ACQU_01",b0)	DS	1	UserData
f	389	\N	(0019,"GEMS_ACQU_01",b1)	DS	1	UserData
f	390	\N	(0019,"GEMS_ACQU_01",b2)	DS	1	UserData
f	391	\N	(0019,"GEMS_ACQU_01",b3)	DS	1	UserData
f	392	\N	(0019,"GEMS_ACQU_01",b4)	DS	1	UserData
f	393	\N	(0019,"GEMS_ACQU_01",b5)	DS	1	UserData
f	394	\N	(0019,"GEMS_ACQU_01",b6)	DS	1	UserData
f	395	\N	(0019,"GEMS_ACQU_01",b7)	DS	1	UserData
f	396	\N	(0019,"GEMS_ACQU_01",b8)	DS	1	UserData
f	397	\N	(0019,"GEMS_ACQU_01",b9)	DS	1	UserData
f	398	\N	(0019,"GEMS_ACQU_01",ba)	DS	1	UserData
f	399	\N	(0019,"GEMS_ACQU_01",bb)	DS	1	UserData
f	400	\N	(0019,"GEMS_ACQU_01",bc)	DS	1	UserData
f	401	\N	(0019,"GEMS_ACQU_01",bd)	DS	1	UserData
f	402	\N	(0019,"GEMS_ACQU_01",be)	DS	1	ProjectionAngle
f	403	\N	(0019,"GEMS_ACQU_01",c0)	SS	1	SaturationPlanes
f	404	\N	(0019,"GEMS_ACQU_01",c1)	SS	1	SurfaceCoilIntensityCorrectionFlag
f	405	\N	(0019,"GEMS_ACQU_01",c2)	SS	1	SATLocationR
f	406	\N	(0019,"GEMS_ACQU_01",c3)	SS	1	SATLocationL
f	407	\N	(0019,"GEMS_ACQU_01",c4)	SS	1	SATLocationA
f	408	\N	(0019,"GEMS_ACQU_01",c5)	SS	1	SATLocationP
f	409	\N	(0019,"GEMS_ACQU_01",c6)	SS	1	SATLocationH
f	410	\N	(0019,"GEMS_ACQU_01",c7)	SS	1	SATLocationF
f	411	\N	(0019,"GEMS_ACQU_01",c8)	SS	1	SATThicknessRL
f	412	\N	(0019,"GEMS_ACQU_01",c9)	SS	1	SATThicknessAP
f	413	\N	(0019,"GEMS_ACQU_01",ca)	SS	1	SATThicknessHF
f	414	\N	(0019,"GEMS_ACQU_01",cb)	SS	1	PrescribedFlowAxis
f	415	\N	(0019,"GEMS_ACQU_01",cc)	SS	1	VelocityEncoding
f	416	\N	(0019,"GEMS_ACQU_01",cd)	SS	1	ThicknessDisclaimer
f	417	\N	(0019,"GEMS_ACQU_01",ce)	SS	1	PrescanType
f	418	\N	(0019,"GEMS_ACQU_01",cf)	SS	1	PrescanStatus
f	419	\N	(0019,"GEMS_ACQU_01",d0)	SH	1	RawDataType
f	420	\N	(0019,"GEMS_ACQU_01",d2)	SS	1	ProjectionAlgorithm
f	421	\N	(0019,"GEMS_ACQU_01",d3)	SH	1	ProjectionAlgorithm
f	422	\N	(0019,"GEMS_ACQU_01",d4)	US	1	Unknown
f	423	\N	(0019,"GEMS_ACQU_01",d5)	SS	1	FractionalEcho
f	424	\N	(0019,"GEMS_ACQU_01",d6)	SS	1	PrepPulse
f	425	\N	(0019,"GEMS_ACQU_01",d7)	SS	1	CardiacPhases
f	426	\N	(0019,"GEMS_ACQU_01",d8)	SS	1	VariableEchoFlag
f	427	\N	(0019,"GEMS_ACQU_01",d9)	DS	1	ConcatenatedSAT
f	428	\N	(0019,"GEMS_ACQU_01",da)	SS	1	ReferenceChannelUsed
f	429	\N	(0019,"GEMS_ACQU_01",db)	DS	1	BackProjectorCoefficient
f	430	\N	(0019,"GEMS_ACQU_01",dc)	SS	1	PrimarySpeedCorrectionUsed
f	431	\N	(0019,"GEMS_ACQU_01",dd)	SS	1	OverrangeCorrectionUsed
f	432	\N	(0019,"GEMS_ACQU_01",de)	DS	1	DynamicZAlphaValue
f	433	\N	(0019,"GEMS_ACQU_01",df)	DS	1	UserData
f	434	\N	(0019,"GEMS_ACQU_01",e0)	DS	1	UserData
f	435	\N	(0019,"GEMS_ACQU_01",e1)	DS	1	Unknown
f	436	\N	(0019,"GEMS_ACQU_01",e2)	DS	1	VelocityEncodeScale
f	437	\N	(0019,"GEMS_ACQU_01",e3)	LT	1	Unknown
f	438	\N	(0019,"GEMS_ACQU_01",e4)	LT	1	Unknown
f	439	\N	(0019,"GEMS_ACQU_01",e5)	IS	1	Unknown
f	440	\N	(0019,"GEMS_ACQU_01",e6)	US	1	Unknown
f	441	\N	(0019,"GEMS_ACQU_01",e8)	DS	1	Unknown
f	442	\N	(0019,"GEMS_ACQU_01",e9)	DS	1	Unknown
f	443	\N	(0019,"GEMS_ACQU_01",eb)	DS	1	Unknown
f	444	\N	(0019,"GEMS_ACQU_01",ec)	US	1	Unknown
f	445	\N	(0019,"GEMS_ACQU_01",f0)	UN	1	Unknown
f	446	\N	(0019,"GEMS_ACQU_01",f1)	LT	1	Unknown
f	447	\N	(0019,"GEMS_ACQU_01",f2)	SS	1	FastPhases
f	448	\N	(0019,"GEMS_ACQU_01",f3)	LT	1	Unknown
f	449	\N	(0019,"GEMS_ACQU_01",f4)	LT	1	Unknown
f	450	\N	(0019,"GEMS_ACQU_01",f9)	DS	1	TransmissionGain
f	451	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",00)	LO	1	CRExposureMenuCode
f	452	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",10)	LO	1	CRExposureMenuString
f	453	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",20)	LO	1	CREDRMode
f	454	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",30)	LO	1	CRLatitude
f	455	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",40)	LO	1	CRGroupNumber
f	456	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",50)	US	1	CRImageSerialNumber
f	457	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",60)	LO	1	CRBarCodeNumber
f	458	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",70)	LO	1	CRFilmOutputExposure
f	459	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",80)	LO	1	CRFilmFormat
f	460	\N	(0023,"GEMS_ACRQA_1.0 BLOCK1",90)	LO	1	CRSShiftString
f	461	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",00)	US	1	CRSShift
f	462	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",10)	DS	1	CRCShift
f	463	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",20)	DS	1	CRGT
f	464	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",30)	DS	1	CRGA
f	465	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",40)	DS	1	CRGC
f	466	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",50)	DS	1	CRGS
f	467	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",60)	DS	1	CRRT
f	468	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",70)	DS	1	CRRE
f	469	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",80)	US	1	CRRN
f	470	\N	(0023,"GEMS_ACRQA_1.0 BLOCK2",90)	DS	1	CRDRT
f	471	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",00)	DS	1	CRDRE
f	472	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",10)	US	1	CRDRN
f	473	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",20)	DS	1	CRORE
f	474	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",30)	US	1	CRORN
f	475	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",40)	US	1	CRORD
f	476	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",50)	LO	1	CRCassetteSize
f	477	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",60)	LO	1	CRMachineID
f	478	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",70)	LO	1	CRMachineType
f	479	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",80)	LO	1	CRTechnicianCode
f	480	\N	(0023,"GEMS_ACRQA_1.0 BLOCK3",90)	LO	1	CREnergySubtractionParameters
f	481	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",00)	LO	1	CRExposureMenuCode
f	482	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",10)	LO	1	CRExposureMenuString
f	483	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",20)	LO	1	CREDRMode
f	484	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",30)	LO	1	CRLatitude
f	485	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",40)	LO	1	CRGroupNumber
f	486	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",50)	US	1	CRImageSerialNumber
f	487	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",60)	LO	1	CRBarCodeNumber
f	488	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",70)	LO	1	CRFilmOutputExposure
f	489	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",80)	LO	1	CRFilmFormat
f	490	\N	(0023,"GEMS_ACRQA_2.0 BLOCK1",90)	LO	1	CRSShiftString
f	491	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",00)	US	1	CRSShift
f	492	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",10)	LO	1	CRCShift
f	493	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",20)	LO	1	CRGT
f	494	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",30)	DS	1	CRGA
f	495	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",40)	DS	1	CRGC
f	496	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",50)	DS	1	CRGS
f	497	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",60)	LO	1	CRRT
f	498	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",70)	DS	1	CRRE
f	499	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",80)	US	1	CRRN
f	500	\N	(0023,"GEMS_ACRQA_2.0 BLOCK2",90)	DS	1	CRDRT
f	501	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",00)	DS	1	CRDRE
f	502	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",10)	US	1	CRDRN
f	503	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",20)	DS	1	CRORE
f	504	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",30)	US	1	CRORN
f	505	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",40)	US	1	CRORD
f	506	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",50)	LO	1	CRCassetteSize
f	507	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",60)	LO	1	CRMachineID
f	508	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",70)	LO	1	CRMachineType
f	509	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",80)	LO	1	CRTechnicianCode
f	510	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",90)	LO	1	CREnergySubtractionParameters
f	511	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",f0)	LO	1	CRDistributionCode
f	512	\N	(0023,"GEMS_ACRQA_2.0 BLOCK3",ff)	US	1	CRShuttersApplied
f	513	\N	(0047,"GEMS_ADWSoft_3D1",01)	SQ	1	Reconstruction Parameters Sequence
f	514	\N	(0047,"GEMS_ADWSoft_3D1",50)	UL	1	VolumeVoxelCount
f	515	\N	(0047,"GEMS_ADWSoft_3D1",51)	UL	1	VolumeSegmentCount
f	516	\N	(0047,"GEMS_ADWSoft_3D1",53)	US	1	VolumeSliceSize
f	517	\N	(0047,"GEMS_ADWSoft_3D1",54)	US	1	VolumeSliceCount
f	518	\N	(0047,"GEMS_ADWSoft_3D1",55)	SL	1	VolumeThresholdValue
f	519	\N	(0047,"GEMS_ADWSoft_3D1",57)	DS	1	VolumeVoxelRatio
f	520	\N	(0047,"GEMS_ADWSoft_3D1",58)	DS	1	VolumeVoxelSize
f	521	\N	(0047,"GEMS_ADWSoft_3D1",59)	US	1	VolumeZPositionSize
f	522	\N	(0047,"GEMS_ADWSoft_3D1",60)	DS	9	VolumeBaseLine
f	523	\N	(0047,"GEMS_ADWSoft_3D1",61)	DS	3	VolumeCenterPoint
f	524	\N	(0047,"GEMS_ADWSoft_3D1",63)	SL	1	VolumeSkewBase
f	525	\N	(0047,"GEMS_ADWSoft_3D1",64)	DS	9	VolumeRegistrationTransformRotationMatrix
f	526	\N	(0047,"GEMS_ADWSoft_3D1",65)	DS	3	VolumeRegistrationTransformTranslationVector
f	527	\N	(0047,"GEMS_ADWSoft_3D1",70)	DS	1-n	KVPList
f	528	\N	(0047,"GEMS_ADWSoft_3D1",71)	IS	1-n	XRayTubeCurrentList
f	529	\N	(0047,"GEMS_ADWSoft_3D1",72)	IS	1-n	ExposureList
f	530	\N	(0047,"GEMS_ADWSoft_3D1",80)	LO	1	AcquisitionDLXIdentifier
f	531	\N	(0047,"GEMS_ADWSoft_3D1",85)	SQ	1	AcquisitionDLX2DSeriesSequence
f	532	\N	(0047,"GEMS_ADWSoft_3D1",89)	DS	1-n	ContrastAgentVolumeList
f	533	\N	(0047,"GEMS_ADWSoft_3D1",8A)	US	1	NumberOfInjections
f	534	\N	(0047,"GEMS_ADWSoft_3D1",8B)	US	1	FrameCount
f	535	\N	(0047,"GEMS_ADWSoft_3D1",91)	LO	1	XA3DReconstructionAlgorithmName
f	536	\N	(0047,"GEMS_ADWSoft_3D1",92)	CS	1	XA3DReconstructionAlgorithmVersion
f	537	\N	(0047,"GEMS_ADWSoft_3D1",93)	DA	1	DLXCalibrationDate
f	538	\N	(0047,"GEMS_ADWSoft_3D1",94)	TM	1	DLXCalibrationTime
f	539	\N	(0047,"GEMS_ADWSoft_3D1",95)	CS	1	DLXCalibrationStatus
f	540	\N	(0047,"GEMS_ADWSoft_3D1",96)	IS	1-n	UsedFrames
f	541	\N	(0047,"GEMS_ADWSoft_3D1",98)	US	1	TransformCount
f	542	\N	(0047,"GEMS_ADWSoft_3D1",99)	SQ	1	TransformSequence
f	543	\N	(0047,"GEMS_ADWSoft_3D1",9A)	DS	9	TransformRotationMatrix
f	544	\N	(0047,"GEMS_ADWSoft_3D1",9B)	DS	3	TransformTranslationVector
f	545	\N	(0047,"GEMS_ADWSoft_3D1",9C)	LO	1	TransformLabel
f	546	\N	(0047,"GEMS_ADWSoft_3D1",B0)	SQ	1	WireframeList
f	547	\N	(0047,"GEMS_ADWSoft_3D1",B1)	US	1	WireframeCount
f	548	\N	(0047,"GEMS_ADWSoft_3D1",B2)	US	1	LocationSystem
f	549	\N	(0047,"GEMS_ADWSoft_3D1",B5)	LO	1	WireframeName
f	550	\N	(0047,"GEMS_ADWSoft_3D1",B6)	LO	1	WireframeGroupName
f	551	\N	(0047,"GEMS_ADWSoft_3D1",B7)	LO	1	WireframeColor
f	552	\N	(0047,"GEMS_ADWSoft_3D1",B8)	SL	1	WireframeAttributes
f	553	\N	(0047,"GEMS_ADWSoft_3D1",B9)	SL	1	WireframePointCount
f	554	\N	(0047,"GEMS_ADWSoft_3D1",BA)	SL	1	WireframeTimestamp
f	555	\N	(0047,"GEMS_ADWSoft_3D1",BB)	SQ	1	WireframePointList
f	556	\N	(0047,"GEMS_ADWSoft_3D1",BC)	DS	3	WireframePointsCoordinates
f	557	\N	(0047,"GEMS_ADWSoft_3D1",C0)	DS	3	VolumeUpperLeftHighCornerRAS
f	558	\N	(0047,"GEMS_ADWSoft_3D1",C1)	DS	9	VolumeSliceToRASRotationMatrix
f	559	\N	(0047,"GEMS_ADWSoft_3D1",C2)	DS	1	VolumeUpperLeftHighCornerTLOC
f	560	\N	(0047,"GEMS_ADWSoft_3D1",D1)	OB	1	VolumeSegmentList
f	561	\N	(0047,"GEMS_ADWSoft_3D1",D2)	OB	1	VolumeGradientList
f	562	\N	(0047,"GEMS_ADWSoft_3D1",D3)	OB	1	VolumeDensityList
f	563	\N	(0047,"GEMS_ADWSoft_3D1",D4)	OB	1	VolumeZPositionList
f	564	\N	(0047,"GEMS_ADWSoft_3D1",D5)	OB	1	VolumeOriginalIndexList
f	565	\N	(0039,"GEMS_ADWSoft_DPO",80)	IS	1	PrivateEntityNumber
f	566	\N	(0039,"GEMS_ADWSoft_DPO",85)	DA	1	PrivateEntityDate
f	567	\N	(0039,"GEMS_ADWSoft_DPO",90)	TM	1	PrivateEntityTime
f	568	\N	(0039,"GEMS_ADWSoft_DPO",95)	LO	1	PrivateEntityLaunchCommand
f	569	\N	(0039,"GEMS_ADWSoft_DPO",AA)	CS	1	PrivateEntityType
f	570	\N	(0033,"GEMS_CTHD_01",02)	UN	1	Unknown
f	571	\N	(0037,"GEMS_DRS_1",10)	LO	1	ReferringDepartment
f	572	\N	(0037,"GEMS_DRS_1",20)	US	1	ScreenNumber
f	573	\N	(0037,"GEMS_DRS_1",40)	SH	1	LeftOrientation
f	574	\N	(0037,"GEMS_DRS_1",42)	SH	1	RightOrientation
f	575	\N	(0037,"GEMS_DRS_1",50)	CS	1	Inversion
f	576	\N	(0037,"GEMS_DRS_1",60)	US	1	DSA
f	577	\N	(0009,"GEMS_GENIE_1",10)	LO	1	Unknown
f	578	\N	(0009,"GEMS_GENIE_1",11)	SL	1	StudyFlags
f	579	\N	(0009,"GEMS_GENIE_1",12)	SL	1	StudyType
f	580	\N	(0009,"GEMS_GENIE_1",1e)	UI	1	Unknown
f	581	\N	(0009,"GEMS_GENIE_1",20)	LO	1	Unknown
f	582	\N	(0009,"GEMS_GENIE_1",21)	SL	1	SeriesFlags
f	583	\N	(0009,"GEMS_GENIE_1",22)	SH	1	UserOrientation
f	584	\N	(0009,"GEMS_GENIE_1",23)	SL	1	InitiationType
f	585	\N	(0009,"GEMS_GENIE_1",24)	SL	1	InitiationDelay
f	586	\N	(0009,"GEMS_GENIE_1",25)	SL	1	InitiationCountRate
f	587	\N	(0009,"GEMS_GENIE_1",26)	SL	1	NumberEnergySets
f	588	\N	(0009,"GEMS_GENIE_1",27)	SL	1	NumberDetectors
f	589	\N	(0009,"GEMS_GENIE_1",29)	SL	1	Unknown
f	590	\N	(0009,"GEMS_GENIE_1",2a)	SL	1	Unknown
f	591	\N	(0009,"GEMS_GENIE_1",2c)	LO	1	SeriesComments
f	592	\N	(0009,"GEMS_GENIE_1",2d)	SL	1	TrackBeatAverage
f	593	\N	(0009,"GEMS_GENIE_1",2e)	FD	1	DistancePrescribed
f	594	\N	(0009,"GEMS_GENIE_1",30)	LO	1	Unknown
f	595	\N	(0009,"GEMS_GENIE_1",35)	SL	1	GantryLocusType
f	596	\N	(0009,"GEMS_GENIE_1",37)	SL	1	StartingHeartRate
f	597	\N	(0009,"GEMS_GENIE_1",38)	SL	1	RRWindowWidth
f	598	\N	(0009,"GEMS_GENIE_1",39)	SL	1	RRWindowOffset
f	599	\N	(0009,"GEMS_GENIE_1",3a)	SL	1	PercentCycleImaged
f	600	\N	(0009,"GEMS_GENIE_1",40)	LO	1	Unknown
f	601	\N	(0009,"GEMS_GENIE_1",41)	SL	1	PatientFlags
f	602	\N	(0009,"GEMS_GENIE_1",42)	DA	1	PatientCreationDate
f	603	\N	(0009,"GEMS_GENIE_1",43)	TM	1	PatientCreationTime
f	604	\N	(0011,"GEMS_GENIE_1",0a)	SL	1	SeriesType
f	605	\N	(0011,"GEMS_GENIE_1",0b)	SL	1	EffectiveSeriesDuration
f	606	\N	(0011,"GEMS_GENIE_1",0c)	SL	1	NumBeats
f	607	\N	(0011,"GEMS_GENIE_1",0d)	LO	1	RadioNuclideName
f	608	\N	(0011,"GEMS_GENIE_1",10)	LO	1	Unknown
f	609	\N	(0011,"GEMS_GENIE_1",12)	LO	1	DatasetName
f	610	\N	(0011,"GEMS_GENIE_1",13)	SL	1	DatasetType
f	611	\N	(0011,"GEMS_GENIE_1",15)	SL	1	DetectorNumber
f	612	\N	(0011,"GEMS_GENIE_1",16)	SL	1	EnergyNumber
f	613	\N	(0011,"GEMS_GENIE_1",17)	SL	1	RRIntervalWindowNumber
f	614	\N	(0011,"GEMS_GENIE_1",18)	SL	1	MGBinNumber
f	615	\N	(0011,"GEMS_GENIE_1",19)	FD	1	RadiusOfRotation
f	616	\N	(0011,"GEMS_GENIE_1",1a)	SL	1	DetectorCountZone
f	617	\N	(0011,"GEMS_GENIE_1",1b)	SL	1	NumEnergyWindows
f	618	\N	(0011,"GEMS_GENIE_1",1c)	SL	4	EnergyOffset
f	619	\N	(0011,"GEMS_GENIE_1",1d)	SL	1	EnergyRange
f	620	\N	(0011,"GEMS_GENIE_1",1f)	SL	1	ImageOrientation
f	621	\N	(0011,"GEMS_GENIE_1",23)	SL	1	UseFOVMask
f	622	\N	(0011,"GEMS_GENIE_1",24)	SL	1	FOVMaskYCutoffAngle
f	623	\N	(0011,"GEMS_GENIE_1",25)	SL	1	FOVMaskCutoffAngle
f	624	\N	(0011,"GEMS_GENIE_1",26)	SL	1	TableOrientation
f	625	\N	(0011,"GEMS_GENIE_1",27)	SL	2	ROITopLeft
f	626	\N	(0011,"GEMS_GENIE_1",28)	SL	2	ROIBottomRight
f	627	\N	(0011,"GEMS_GENIE_1",30)	LO	1	Unknown
f	628	\N	(0011,"GEMS_GENIE_1",33)	LO	1	EnergyCorrectName
f	629	\N	(0011,"GEMS_GENIE_1",34)	LO	1	SpatialCorrectName
f	630	\N	(0011,"GEMS_GENIE_1",35)	LO	1	TuningCalibName
f	631	\N	(0011,"GEMS_GENIE_1",36)	LO	1	UniformityCorrectName
f	632	\N	(0011,"GEMS_GENIE_1",37)	LO	1	AcquisitionSpecificCorrectName
f	633	\N	(0011,"GEMS_GENIE_1",38)	SL	1	ByteOrder
f	634	\N	(0011,"GEMS_GENIE_1",3a)	SL	1	PictureFormat
f	635	\N	(0011,"GEMS_GENIE_1",3b)	FD	1	PixelScale
f	636	\N	(0011,"GEMS_GENIE_1",3c)	FD	1	PixelOffset
f	637	\N	(0011,"GEMS_GENIE_1",3e)	SL	1	FOVShape
f	638	\N	(0011,"GEMS_GENIE_1",3f)	SL	1	DatasetFlags
f	639	\N	(0011,"GEMS_GENIE_1",44)	FD	1	ThresholdCenter
f	640	\N	(0011,"GEMS_GENIE_1",45)	FD	1	ThresholdWidth
f	641	\N	(0011,"GEMS_GENIE_1",46)	SL	1	InterpolationType
f	642	\N	(0011,"GEMS_GENIE_1",55)	FD	1	Period
f	643	\N	(0011,"GEMS_GENIE_1",56)	FD	1	ElapsedTime
f	644	\N	(0013,"GEMS_GENIE_1",10)	FD	2	DigitalFOV
f	645	\N	(0013,"GEMS_GENIE_1",11)	SL	1	Unknown
f	646	\N	(0013,"GEMS_GENIE_1",12)	SL	1	Unknown
f	647	\N	(0013,"GEMS_GENIE_1",16)	SL	1	AutoTrackPeak
f	648	\N	(0013,"GEMS_GENIE_1",17)	SL	1	AutoTrackWidth
f	649	\N	(0013,"GEMS_GENIE_1",18)	FD	1	TransmissionScanTime
f	650	\N	(0013,"GEMS_GENIE_1",19)	FD	1	TransmissionMaskWidth
f	651	\N	(0013,"GEMS_GENIE_1",1a)	FD	1	CopperAttenuatorThickness
f	652	\N	(0013,"GEMS_GENIE_1",1c)	FD	1	Unknown
f	653	\N	(0013,"GEMS_GENIE_1",1d)	FD	1	Unknown
f	654	\N	(0013,"GEMS_GENIE_1",1e)	FD	1-n	TomoViewOffset
f	655	\N	(0013,"GEMS_GENIE_1",26)	LT	1	StudyComments
f	656	\N	(0033,"GEMS_GNHD_01",01)	UN	1	Unknown
f	657	\N	(0033,"GEMS_GNHD_01",02)	UN	1	Unknown
f	658	\N	(0009,"GEMS_IDEN_01",01)	LO	1	FullFidelity
f	659	\N	(0009,"GEMS_IDEN_01",02)	SH	1	SuiteId
f	660	\N	(0009,"GEMS_IDEN_01",04)	SH	1	ProductId
f	661	\N	(0009,"GEMS_IDEN_01",17)	LT	1	Unknown
f	662	\N	(0009,"GEMS_IDEN_01",1a)	US	1	Unknown
f	663	\N	(0009,"GEMS_IDEN_01",20)	US	1	Unknown
f	664	\N	(0009,"GEMS_IDEN_01",27)	SL	1	ImageActualDate
f	665	\N	(0009,"GEMS_IDEN_01",2f)	LT	1	Unknown
f	666	\N	(0009,"GEMS_IDEN_01",30)	SH	1	ServiceId
f	667	\N	(0009,"GEMS_IDEN_01",31)	SH	1	MobileLocationNumber
f	668	\N	(0009,"GEMS_IDEN_01",e2)	LT	1	Unknown
f	669	\N	(0009,"GEMS_IDEN_01",e3)	UI	1	EquipmentUID
f	670	\N	(0009,"GEMS_IDEN_01",e6)	SH	1	GenesisVersionNow
f	671	\N	(0009,"GEMS_IDEN_01",e7)	UL	1	ExamRecordChecksum
f	672	\N	(0009,"GEMS_IDEN_01",e8)	UL	1	Unknown
f	673	\N	(0009,"GEMS_IDEN_01",e9)	SL	1	ActualSeriesDataTimeStamp
f	674	\N	(0027,"GEMS_IMAG_01",06)	SL	1	ImageArchiveFlag
f	675	\N	(0027,"GEMS_IMAG_01",10)	SS	1	ScoutType
f	676	\N	(0027,"GEMS_IMAG_01",1c)	SL	1	VmaMamp
f	677	\N	(0027,"GEMS_IMAG_01",1d)	SS	1	VmaPhase
f	678	\N	(0027,"GEMS_IMAG_01",1e)	SL	1	VmaMod
f	679	\N	(0027,"GEMS_IMAG_01",1f)	SL	1	VmaClip
f	680	\N	(0027,"GEMS_IMAG_01",20)	SS	1	SmartScanOnOffFlag
f	681	\N	(0027,"GEMS_IMAG_01",30)	SH	1	ForeignImageRevision
f	682	\N	(0027,"GEMS_IMAG_01",31)	SS	1	ImagingMode
f	683	\N	(0027,"GEMS_IMAG_01",32)	SS	1	PulseSequence
f	684	\N	(0027,"GEMS_IMAG_01",33)	SL	1	ImagingOptions
f	685	\N	(0027,"GEMS_IMAG_01",35)	SS	1	PlaneType
f	686	\N	(0027,"GEMS_IMAG_01",36)	SL	1	ObliquePlane
f	687	\N	(0027,"GEMS_IMAG_01",40)	SH	1	RASLetterOfImageLocation
f	688	\N	(0027,"GEMS_IMAG_01",41)	FL	1	ImageLocation
f	689	\N	(0027,"GEMS_IMAG_01",42)	FL	1	CenterRCoordOfPlaneImage
f	690	\N	(0027,"GEMS_IMAG_01",43)	FL	1	CenterACoordOfPlaneImage
f	691	\N	(0027,"GEMS_IMAG_01",44)	FL	1	CenterSCoordOfPlaneImage
f	692	\N	(0027,"GEMS_IMAG_01",45)	FL	1	NormalRCoord
f	693	\N	(0027,"GEMS_IMAG_01",46)	FL	1	NormalACoord
f	694	\N	(0027,"GEMS_IMAG_01",47)	FL	1	NormalSCoord
f	695	\N	(0027,"GEMS_IMAG_01",48)	FL	1	RCoordOfTopRightCorner
f	696	\N	(0027,"GEMS_IMAG_01",49)	FL	1	ACoordOfTopRightCorner
f	697	\N	(0027,"GEMS_IMAG_01",4a)	FL	1	SCoordOfTopRightCorner
f	698	\N	(0027,"GEMS_IMAG_01",4b)	FL	1	RCoordOfBottomRightCorner
f	699	\N	(0027,"GEMS_IMAG_01",4c)	FL	1	ACoordOfBottomRightCorner
f	700	\N	(0027,"GEMS_IMAG_01",4d)	FL	1	SCoordOfBottomRightCorner
f	701	\N	(0027,"GEMS_IMAG_01",50)	FL	1	TableStartLocation
f	702	\N	(0027,"GEMS_IMAG_01",51)	FL	1	TableEndLocation
f	703	\N	(0027,"GEMS_IMAG_01",52)	SH	1	RASLetterForSideOfImage
f	704	\N	(0027,"GEMS_IMAG_01",53)	SH	1	RASLetterForAnteriorPosterior
f	705	\N	(0027,"GEMS_IMAG_01",54)	SH	1	RASLetterForScoutStartLoc
f	706	\N	(0027,"GEMS_IMAG_01",55)	SH	1	RASLetterForScoutEndLoc
f	707	\N	(0027,"GEMS_IMAG_01",60)	FL	1	ImageDimensionX
f	708	\N	(0027,"GEMS_IMAG_01",61)	FL	1	ImageDimensionY
f	709	\N	(0027,"GEMS_IMAG_01",62)	FL	1	NumberOfExcitations
f	710	\N	(0029,"GEMS_IMPS_01",04)	SL	1	LowerRangeOfPixels
f	711	\N	(0029,"GEMS_IMPS_01",05)	DS	1	LowerRangeOfPixels
f	712	\N	(0029,"GEMS_IMPS_01",06)	DS	1	LowerRangeOfPixels
f	713	\N	(0029,"GEMS_IMPS_01",07)	SL	1	LowerRangeOfPixels
f	714	\N	(0029,"GEMS_IMPS_01",08)	SH	1	LowerRangeOfPixels
f	715	\N	(0029,"GEMS_IMPS_01",09)	SH	1	LowerRangeOfPixels
f	716	\N	(0029,"GEMS_IMPS_01",0a)	SS	1	LowerRangeOfPixels
f	717	\N	(0029,"GEMS_IMPS_01",15)	SL	1	LowerRangeOfPixels
f	718	\N	(0029,"GEMS_IMPS_01",16)	SL	1	LowerRangeOfPixels
f	719	\N	(0029,"GEMS_IMPS_01",17)	SL	1	LowerRangeOfPixels
f	720	\N	(0029,"GEMS_IMPS_01",18)	SL	1	UpperRangeOfPixels
f	721	\N	(0029,"GEMS_IMPS_01",1a)	SL	1	LengthOfTotalHeaderInBytes
f	722	\N	(0029,"GEMS_IMPS_01",26)	SS	1	VersionOfHeaderStructure
f	723	\N	(0029,"GEMS_IMPS_01",34)	SL	1	AdvantageCompOverflow
f	724	\N	(0029,"GEMS_IMPS_01",35)	SL	1	AdvantageCompUnderflow
f	725	\N	(0043,"GEMS_PARM_01",01)	SS	1	BitmapOfPrescanOptions
f	726	\N	(0043,"GEMS_PARM_01",02)	SS	1	GradientOffsetInX
f	727	\N	(0043,"GEMS_PARM_01",03)	SS	1	GradientOffsetInY
f	728	\N	(0043,"GEMS_PARM_01",04)	SS	1	GradientOffsetInZ
f	729	\N	(0043,"GEMS_PARM_01",05)	SS	1	ImageIsOriginalOrUnoriginal
f	730	\N	(0043,"GEMS_PARM_01",06)	SS	1	NumberOfEPIShots
f	731	\N	(0043,"GEMS_PARM_01",07)	SS	1	ViewsPerSegment
f	732	\N	(0043,"GEMS_PARM_01",08)	SS	1	RespiratoryRateInBPM
f	733	\N	(0043,"GEMS_PARM_01",09)	SS	1	RespiratoryTriggerPoint
f	734	\N	(0043,"GEMS_PARM_01",0a)	SS	1	TypeOfReceiverUsed
f	735	\N	(0043,"GEMS_PARM_01",0b)	DS	1	PeakRateOfChangeOfGradientField
f	736	\N	(0043,"GEMS_PARM_01",0c)	DS	1	LimitsInUnitsOfPercent
f	737	\N	(0043,"GEMS_PARM_01",0d)	DS	1	PSDEstimatedLimit
f	738	\N	(0043,"GEMS_PARM_01",0e)	DS	1	PSDEstimatedLimitInTeslaPerSecond
f	739	\N	(0043,"GEMS_PARM_01",0f)	DS	1	SARAvgHead
f	740	\N	(0043,"GEMS_PARM_01",10)	US	1	WindowValue
f	741	\N	(0043,"GEMS_PARM_01",11)	US	1	TotalInputViews
f	742	\N	(0043,"GEMS_PARM_01",12)	SS	3	XrayChain
f	743	\N	(0043,"GEMS_PARM_01",13)	SS	5	ReconKernelParameters
f	744	\N	(0043,"GEMS_PARM_01",14)	SS	3	CalibrationParameters
f	745	\N	(0043,"GEMS_PARM_01",15)	SS	3	TotalOutputViews
f	746	\N	(0043,"GEMS_PARM_01",16)	SS	5	NumberOfOverranges
f	747	\N	(0043,"GEMS_PARM_01",17)	DS	1	IBHImageScaleFactors
f	748	\N	(0043,"GEMS_PARM_01",18)	DS	3	BBH Coefficients
f	749	\N	(0043,"GEMS_PARM_01",19)	SS	1	NumberOfBBHChainsToBlend
f	750	\N	(0043,"GEMS_PARM_01",1a)	SL	1	StartingChannelNumber
f	751	\N	(0043,"GEMS_PARM_01",1b)	SS	1	PPScanParameters
f	752	\N	(0043,"GEMS_PARM_01",1c)	SS	1	GEImageIntegrity
f	753	\N	(0043,"GEMS_PARM_01",1d)	SS	1	LevelValue
f	754	\N	(0043,"GEMS_PARM_01",1e)	DS	1	DeltaStartTime
f	755	\N	(0043,"GEMS_PARM_01",1f)	SL	1	MaxOverrangesInAView
f	756	\N	(0043,"GEMS_PARM_01",20)	DS	1	AvgOverrangesAllViews
f	757	\N	(0043,"GEMS_PARM_01",21)	SS	1	CorrectedAfterglowTerms
f	758	\N	(0043,"GEMS_PARM_01",25)	SS	6	ReferenceChannels
f	759	\N	(0043,"GEMS_PARM_01",26)	US	6	NoViewsRefChannelsBlocked
f	760	\N	(0043,"GEMS_PARM_01",27)	SH	1	ScanPitchRatio
f	761	\N	(0043,"GEMS_PARM_01",28)	OB	1	UniqueImageIdentifier
f	762	\N	(0043,"GEMS_PARM_01",29)	OB	1	HistogramTables
f	763	\N	(0043,"GEMS_PARM_01",2a)	OB	1	UserDefinedData
f	764	\N	(0043,"GEMS_PARM_01",2b)	SS	4	PrivateScanOptions
f	765	\N	(0043,"GEMS_PARM_01",2c)	SS	1	EffectiveEchoSpacing
f	766	\N	(0043,"GEMS_PARM_01",2d)	SH	1	StringSlopField1
f	767	\N	(0043,"GEMS_PARM_01",2e)	SH	1	StringSlopField2
f	768	\N	(0043,"GEMS_PARM_01",2f)	SS	1	RawDataType
f	769	\N	(0043,"GEMS_PARM_01",30)	SS	1	RawDataType
f	770	\N	(0043,"GEMS_PARM_01",31)	DS	2	RACoordOfTargetReconCentre
f	771	\N	(0043,"GEMS_PARM_01",32)	SS	1	RawDataType
f	772	\N	(0043,"GEMS_PARM_01",33)	FL	1	NegScanSpacing
f	773	\N	(0043,"GEMS_PARM_01",34)	IS	1	OffsetFrequency
f	774	\N	(0043,"GEMS_PARM_01",35)	UL	1	UserUsageTag
f	775	\N	(0043,"GEMS_PARM_01",36)	UL	1	UserFillMapMSW
f	776	\N	(0043,"GEMS_PARM_01",37)	UL	1	UserFillMapLSW
f	777	\N	(0043,"GEMS_PARM_01",38)	FL	24	User25ToUser48
f	778	\N	(0043,"GEMS_PARM_01",39)	IS	4	SlopInteger6ToSlopInteger9
f	779	\N	(0043,"GEMS_PARM_01",40)	FL	4	TriggerOnPosition
f	780	\N	(0043,"GEMS_PARM_01",41)	FL	4	DegreeOfRotation
f	781	\N	(0043,"GEMS_PARM_01",42)	SL	4	DASTriggerSource
f	782	\N	(0043,"GEMS_PARM_01",43)	SL	4	DASFpaGain
f	783	\N	(0043,"GEMS_PARM_01",44)	SL	4	DASOutputSource
f	784	\N	(0043,"GEMS_PARM_01",45)	SL	4	DASAdInput
f	785	\N	(0043,"GEMS_PARM_01",46)	SL	4	DASCalMode
f	786	\N	(0043,"GEMS_PARM_01",47)	SL	4	DASCalFrequency
f	787	\N	(0043,"GEMS_PARM_01",48)	SL	4	DASRegXm
f	788	\N	(0043,"GEMS_PARM_01",49)	SL	4	DASAutoZero
f	789	\N	(0043,"GEMS_PARM_01",4a)	SS	4	StartingChannelOfView
f	790	\N	(0043,"GEMS_PARM_01",4b)	SL	4	DASXmPattern
f	791	\N	(0043,"GEMS_PARM_01",4c)	SS	4	TGGCTriggerMode
f	792	\N	(0043,"GEMS_PARM_01",4d)	FL	4	StartScanToXrayOnDelay
f	793	\N	(0043,"GEMS_PARM_01",4e)	FL	4	DurationOfXrayOn
f	794	\N	(0043,"GEMS_PARM_01",60)	IS	8	Unknown
f	795	\N	(0043,"GEMS_PARM_01",61)	UI	1	Unknown
f	796	\N	(0043,"GEMS_PARM_01",62)	SH	1	Unknown
f	797	\N	(0043,"GEMS_PARM_01",6f)	DS	3	Unknown
f	798	\N	(0011,"GEMS_PATI_01",10)	SS	1	PatientStatus
f	799	\N	(0021,"GEMS_RELA_01",03)	SS	1	SeriesFromWhichPrescribed
f	800	\N	(0021,"GEMS_RELA_01",05)	SH	1	GenesisVersionNow
f	801	\N	(0021,"GEMS_RELA_01",07)	UL	1	SeriesRecordChecksum
f	802	\N	(0021,"GEMS_RELA_01",15)	US	1	Unknown
f	803	\N	(0021,"GEMS_RELA_01",16)	SS	1	Unknown
f	804	\N	(0021,"GEMS_RELA_01",18)	SH	1	GenesisVersionNow
f	805	\N	(0021,"GEMS_RELA_01",19)	UL	1	AcqReconRecordChecksum
f	806	\N	(0021,"GEMS_RELA_01",20)	DS	1	TableStartLocation
f	807	\N	(0021,"GEMS_RELA_01",35)	SS	1	SeriesFromWhichPrescribed
f	808	\N	(0021,"GEMS_RELA_01",36)	SS	1	ImageFromWhichPrescribed
f	809	\N	(0021,"GEMS_RELA_01",37)	SS	1	ScreenFormat
f	810	\N	(0021,"GEMS_RELA_01",4a)	LO	1	AnatomicalReferenceForScout
f	811	\N	(0021,"GEMS_RELA_01",4e)	US	1	Unknown
f	812	\N	(0021,"GEMS_RELA_01",4f)	SS	1	LocationsInAcquisition
f	813	\N	(0021,"GEMS_RELA_01",50)	SS	1	GraphicallyPrescribed
f	814	\N	(0021,"GEMS_RELA_01",51)	DS	1	RotationFromSourceXRot
f	815	\N	(0021,"GEMS_RELA_01",52)	DS	1	RotationFromSourceYRot
f	816	\N	(0021,"GEMS_RELA_01",53)	DS	1	RotationFromSourceZRot
f	817	\N	(0021,"GEMS_RELA_01",54)	SH	3	ImagePosition
f	818	\N	(0021,"GEMS_RELA_01",55)	SH	6	ImageOrientation
f	819	\N	(0021,"GEMS_RELA_01",56)	SL	1	IntegerSlop
f	820	\N	(0021,"GEMS_RELA_01",57)	SL	1	IntegerSlop
f	821	\N	(0021,"GEMS_RELA_01",58)	SL	1	IntegerSlop
f	822	\N	(0021,"GEMS_RELA_01",59)	SL	1	IntegerSlop
f	823	\N	(0021,"GEMS_RELA_01",5a)	SL	1	IntegerSlop
f	824	\N	(0021,"GEMS_RELA_01",5b)	DS	1	FloatSlop
f	825	\N	(0021,"GEMS_RELA_01",5c)	DS	1	FloatSlop
f	826	\N	(0021,"GEMS_RELA_01",5d)	DS	1	FloatSlop
f	827	\N	(0021,"GEMS_RELA_01",5e)	DS	1	FloatSlop
f	828	\N	(0021,"GEMS_RELA_01",5f)	DS	1	FloatSlop
f	829	\N	(0021,"GEMS_RELA_01",70)	LT	1	Unknown
f	830	\N	(0021,"GEMS_RELA_01",71)	LT	1	Unknown
f	831	\N	(0021,"GEMS_RELA_01",81)	DS	1	AutoWindowLevelAlpha
f	832	\N	(0021,"GEMS_RELA_01",82)	DS	1	AutoWindowLevelBeta
f	833	\N	(0021,"GEMS_RELA_01",83)	DS	1	AutoWindowLevelWindow
f	834	\N	(0021,"GEMS_RELA_01",84)	DS	1	AutoWindowLevelLevel
f	835	\N	(0021,"GEMS_RELA_01",90)	SS	1	TubeFocalSpotPosition
f	836	\N	(0021,"GEMS_RELA_01",91)	SS	1	BiopsyPosition
f	837	\N	(0021,"GEMS_RELA_01",92)	FL	1	BiopsyTLocation
f	838	\N	(0021,"GEMS_RELA_01",93)	FL	1	BiopsyRefLocation
f	839	\N	(0045,"GEMS_SENO_02",04)	CS	1	AES
f	840	\N	(0045,"GEMS_SENO_02",06)	DS	1	Angulation
f	841	\N	(0045,"GEMS_SENO_02",09)	DS	1	RealMagnificationFactor
f	842	\N	(0045,"GEMS_SENO_02",0b)	CS	1	SenographType
f	843	\N	(0045,"GEMS_SENO_02",0c)	DS	1	IntegrationTime
f	844	\N	(0045,"GEMS_SENO_02",0d)	DS	1	ROIOriginXY
f	845	\N	(0045,"GEMS_SENO_02",11)	DS	2	ReceptorSizeCmXY
f	846	\N	(0045,"GEMS_SENO_02",12)	IS	2	ReceptorSizePixelsXY
f	847	\N	(0045,"GEMS_SENO_02",13)	ST	1	Screen
f	848	\N	(0045,"GEMS_SENO_02",14)	DS	1	PixelPitchMicrons
f	849	\N	(0045,"GEMS_SENO_02",15)	IS	1	PixelDepthBits
f	850	\N	(0045,"GEMS_SENO_02",16)	IS	2	BinningFactorXY
f	851	\N	(0045,"GEMS_SENO_02",1B)	CS	1	ClinicalView
f	852	\N	(0045,"GEMS_SENO_02",1D)	DS	1	MeanOfRawGrayLevels
f	853	\N	(0045,"GEMS_SENO_02",1E)	DS	1	MeanOfOffsetGrayLevels
f	854	\N	(0045,"GEMS_SENO_02",1F)	DS	1	MeanOfCorrectedGrayLevels
f	855	\N	(0045,"GEMS_SENO_02",20)	DS	1	MeanOfRegionGrayLevels
f	856	\N	(0045,"GEMS_SENO_02",21)	DS	1	MeanOfLogRegionGrayLevels
f	857	\N	(0045,"GEMS_SENO_02",22)	DS	1	StandardDeviationOfRawGrayLevels
f	858	\N	(0045,"GEMS_SENO_02",23)	DS	1	StandardDeviationOfCorrectedGrayLevels
f	859	\N	(0045,"GEMS_SENO_02",24)	DS	1	StandardDeviationOfRegionGrayLevels
f	860	\N	(0045,"GEMS_SENO_02",25)	DS	1	StandardDeviationOfLogRegionGrayLevels
f	861	\N	(0045,"GEMS_SENO_02",26)	OB	1	MAOBuffer
f	862	\N	(0045,"GEMS_SENO_02",27)	IS	1	SetNumber
f	863	\N	(0045,"GEMS_SENO_02",28)	CS	1	WindowingType
f	864	\N	(0045,"GEMS_SENO_02",29)	DS	1-n	WindowingParameters
f	865	\N	(0045,"GEMS_SENO_02",2a)	IS	1	CrosshairCursorXCoordinates
f	866	\N	(0045,"GEMS_SENO_02",2b)	IS	1	CrosshairCursorYCoordinates
f	867	\N	(0045,"GEMS_SENO_02",39)	US	1	VignetteRows
f	868	\N	(0045,"GEMS_SENO_02",3a)	US	1	VignetteColumns
f	869	\N	(0045,"GEMS_SENO_02",3b)	US	1	VignetteBitsAllocated
f	870	\N	(0045,"GEMS_SENO_02",3c)	US	1	VignetteBitsStored
f	871	\N	(0045,"GEMS_SENO_02",3d)	US	1	VignetteHighBit
f	872	\N	(0045,"GEMS_SENO_02",3e)	US	1	VignettePixelRepresentation
f	873	\N	(0045,"GEMS_SENO_02",3f)	OB	1	VignettePixelData
f	874	\N	(0025,"GEMS_SERS_01",06)	SS	1	LastPulseSequenceUsed
f	875	\N	(0025,"GEMS_SERS_01",07)	SL	1	ImagesInSeries
f	876	\N	(0025,"GEMS_SERS_01",10)	SL	1	LandmarkCounter
f	877	\N	(0025,"GEMS_SERS_01",11)	SS	1	NumberOfAcquisitions
f	878	\N	(0025,"GEMS_SERS_01",14)	SL	1	IndicatesNumberOfUpdatesToHeader
f	879	\N	(0025,"GEMS_SERS_01",17)	SL	1	SeriesCompleteFlag
f	880	\N	(0025,"GEMS_SERS_01",18)	SL	1	NumberOfImagesArchived
f	881	\N	(0025,"GEMS_SERS_01",19)	SL	1	LastImageNumberUsed
f	882	\N	(0025,"GEMS_SERS_01",1a)	SH	1	PrimaryReceiverSuiteAndHost
f	883	\N	(0023,"GEMS_STDY_01",01)	SL	1	NumberOfSeriesInStudy
f	884	\N	(0023,"GEMS_STDY_01",02)	SL	1	NumberOfUnarchivedSeries
f	885	\N	(0023,"GEMS_STDY_01",10)	SS	1	ReferenceImageField
f	886	\N	(0023,"GEMS_STDY_01",50)	SS	1	SummaryImage
f	887	\N	(0023,"GEMS_STDY_01",70)	FD	1	StartTimeSecsInFirstAxial
f	888	\N	(0023,"GEMS_STDY_01",74)	SL	1	NumberOfUpdatesToHeader
f	889	\N	(0023,"GEMS_STDY_01",7d)	SS	1	IndicatesIfStudyHasCompleteInfo
f	890	\N	(0033,"GEMS_YMHD_01",05)	UN	1	Unknown
f	891	\N	(0033,"GEMS_YMHD_01",06)	UN	1	Unknown
f	892	\N	(0019,"GE_GENESIS_REV3.0",39)	SS	1	AxialType
f	893	\N	(0019,"GE_GENESIS_REV3.0",8f)	SS	1	SwapPhaseFrequency
f	894	\N	(0019,"GE_GENESIS_REV3.0",9c)	SS	1	PulseSequenceName
f	895	\N	(0019,"GE_GENESIS_REV3.0",9f)	SS	1	CoilType
f	896	\N	(0019,"GE_GENESIS_REV3.0",a4)	SS	1	SATFatWaterBone
f	897	\N	(0019,"GE_GENESIS_REV3.0",c0)	SS	1	BitmapOfSATSelections
f	898	\N	(0019,"GE_GENESIS_REV3.0",c1)	SS	1	SurfaceCoilIntensityCorrectionFlag
f	899	\N	(0019,"GE_GENESIS_REV3.0",cb)	SS	1	PhaseContrastFlowAxis
f	900	\N	(0019,"GE_GENESIS_REV3.0",cc)	SS	1	PhaseContrastVelocityEncoding
f	901	\N	(0019,"GE_GENESIS_REV3.0",d5)	SS	1	FractionalEcho
f	902	\N	(0019,"GE_GENESIS_REV3.0",d8)	SS	1	VariableEchoFlag
f	903	\N	(0019,"GE_GENESIS_REV3.0",d9)	DS	1	ConcatenatedSat
f	904	\N	(0019,"GE_GENESIS_REV3.0",f2)	SS	1	NumberOfPhases
f	905	\N	(0043,"GE_GENESIS_REV3.0",1e)	DS	1	DeltaStartTime
f	906	\N	(0043,"GE_GENESIS_REV3.0",27)	SH	1	ScanPitchRatio
f	907	\N	(0029,"INTELERAD MEDICAL SYSTEMS",01)	FD	1	ImageCompressionFraction
f	908	\N	(0029,"INTELERAD MEDICAL SYSTEMS",02)	FD	1	ImageQuality
f	909	\N	(0029,"INTELERAD MEDICAL SYSTEMS",03)	FD	1	ImageBytesTransferred
f	910	\N	(0029,"INTELERAD MEDICAL SYSTEMS",10)	SH	1	J2cParameterType
f	911	\N	(0029,"INTELERAD MEDICAL SYSTEMS",11)	US	1	J2cPixelRepresentation
f	912	\N	(0029,"INTELERAD MEDICAL SYSTEMS",12)	US	1	J2cBitsAllocated
f	913	\N	(0029,"INTELERAD MEDICAL SYSTEMS",13)	US	1	J2cPixelShiftValue
f	914	\N	(0029,"INTELERAD MEDICAL SYSTEMS",14)	US	1	J2cPlanarConfiguration
f	915	\N	(0029,"INTELERAD MEDICAL SYSTEMS",15)	DS	1	J2cRescaleIntercept
f	916	\N	(0029,"INTELERAD MEDICAL SYSTEMS",20)	LO	1	PixelDataMD5SumPerFrame
f	917	\N	(0029,"INTELERAD MEDICAL SYSTEMS",21)	US	1	HistogramPercentileLabels
f	918	\N	(0029,"INTELERAD MEDICAL SYSTEMS",22)	FD	1	HistogramPercentileValues
f	919	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",01)	LO	1	InstitutionCode
f	920	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",02)	LO	1	RoutedTransferAE
f	921	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",03)	LO	1	SourceAE
f	922	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",04)	SH	1	DeferredValidation
f	923	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",05)	LO	1	SeriesOwner
f	924	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",06)	LO	1	OrderGroupNumber
f	925	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",07)	SH	1	StrippedPixelData
f	926	\N	(3f01,"INTELERAD MEDICAL SYSTEMS",08)	SH	1	PendingMoveRequest
f	927	\N	(0041,"INTEGRIS 1.0",20)	FL	1	AccumulatedFluoroscopyDose
f	928	\N	(0041,"INTEGRIS 1.0",30)	FL	1	AccumulatedExposureDose
f	929	\N	(0041,"INTEGRIS 1.0",40)	FL	1	TotalDose
f	930	\N	(0041,"INTEGRIS 1.0",41)	FL	1	TotalNumberOfFrames
f	931	\N	(0041,"INTEGRIS 1.0",50)	SQ	1	ExposureInformationSequence
f	932	\N	(0009,"INTEGRIS 1.0",08)	CS	1-n	ExposureChannel
f	933	\N	(0009,"INTEGRIS 1.0",32)	TM	1	ExposureStartTime
f	934	\N	(0019,"INTEGRIS 1.0",00)	LO	1	APRName
f	935	\N	(0019,"INTEGRIS 1.0",40)	DS	1	FrameRate
f	936	\N	(0021,"INTEGRIS 1.0",12)	IS	1	ExposureNumber
f	937	\N	(0029,"INTEGRIS 1.0",08)	IS	1	NumberOfExposureResults
f	938	\N	(0029,"ISG shadow",70)	IS	1	Unknown
f	939	\N	(0029,"ISG shadow",80)	IS	1	Unknown
f	940	\N	(0029,"ISG shadow",90)	IS	1	Unknown
f	941	\N	(0009,"ISI",01)	UN	1	SIENETGeneralPurposeIMGEF
f	942	\N	(0009,"MERGE TECHNOLOGIES, INC.",00)	OB	1	Unknown
f	943	\N	(0029,"OCULUS Optikgeraete GmbH",1010)	OB	1	OriginalMeasuringData
f	944	\N	(0029,"OCULUS Optikgeraete GmbH",1012)	UL	1	OriginalMeasuringDataLength
f	945	\N	(0029,"OCULUS Optikgeraete GmbH",1020)	OB	1	OriginalMeasuringRawData
f	946	\N	(0029,"OCULUS Optikgeraete GmbH",1022)	UL	1	OriginalMeasuringRawDataLength
f	947	\N	(0041,"PAPYRUS 3.0",00)	LT	1	PapyrusComments
f	948	\N	(0041,"PAPYRUS 3.0",10)	SQ	1	PointerSequence
f	949	\N	(0041,"PAPYRUS 3.0",11)	UL	1	ImagePointer
f	950	\N	(0041,"PAPYRUS 3.0",12)	UL	1	PixelOffset
f	951	\N	(0041,"PAPYRUS 3.0",13)	SQ	1	ImageIdentifierSequence
f	952	\N	(0041,"PAPYRUS 3.0",14)	SQ	1	ExternalFileReferenceSequence
f	953	\N	(0041,"PAPYRUS 3.0",15)	US	1	NumberOfImages
f	954	\N	(0041,"PAPYRUS 3.0",21)	UI	1	ReferencedSOPClassUID
f	955	\N	(0041,"PAPYRUS 3.0",22)	UI	1	ReferencedSOPInstanceUID
f	956	\N	(0041,"PAPYRUS 3.0",31)	LT	1	ReferencedFileName
f	957	\N	(0041,"PAPYRUS 3.0",32)	LT	1-n	ReferencedFilePath
f	958	\N	(0041,"PAPYRUS 3.0",41)	UI	1	ReferencedImageSOPClassUID
f	959	\N	(0041,"PAPYRUS 3.0",42)	UI	1	ReferencedImageSOPInstanceUID
f	960	\N	(0041,"PAPYRUS 3.0",50)	SQ	1	ImageSequence
t	\N	6	(6001-o-60ff,"PAPYRUS 3.0",00)	IS	1	OverlayID
t	\N	7	(6001-o-60ff,"PAPYRUS 3.0",01)	LT	1-n	LinkedOverlays
t	\N	8	(6001-o-60ff,"PAPYRUS 3.0",10)	US	1	OverlayRows
t	\N	9	(6001-o-60ff,"PAPYRUS 3.0",11)	US	1	OverlayColumns
t	\N	10	(6001-o-60ff,"PAPYRUS 3.0",40)	LO	1	OverlayType
t	\N	11	(6001-o-60ff,"PAPYRUS 3.0",50)	US	1-n	OverlayOrigin
t	\N	12	(6001-o-60ff,"PAPYRUS 3.0",60)	LO	1	Editable
t	\N	13	(6001-o-60ff,"PAPYRUS 3.0",70)	LO	1	OverlayFont
t	\N	14	(6001-o-60ff,"PAPYRUS 3.0",72)	LO	1	OverlayStyle
t	\N	15	(6001-o-60ff,"PAPYRUS 3.0",74)	US	1	OverlayFontSize
t	\N	16	(6001-o-60ff,"PAPYRUS 3.0",76)	LO	1	OverlayColor
t	\N	17	(6001-o-60ff,"PAPYRUS 3.0",78)	US	1	ShadowSize
t	\N	18	(6001-o-60ff,"PAPYRUS 3.0",80)	LO	1	FillPattern
t	\N	19	(6001-o-60ff,"PAPYRUS 3.0",82)	US	1	OverlayPenSize
t	\N	20	(6001-o-60ff,"PAPYRUS 3.0",a0)	LO	1	Label
t	\N	21	(6001-o-60ff,"PAPYRUS 3.0",a2)	LT	1	PostItText
t	\N	22	(6001-o-60ff,"PAPYRUS 3.0",a4)	US	2	AnchorPoint
t	\N	23	(6001-o-60ff,"PAPYRUS 3.0",b0)	LO	1	ROIType
t	\N	24	(6001-o-60ff,"PAPYRUS 3.0",b2)	LT	1	AttachedAnnotation
t	\N	25	(6001-o-60ff,"PAPYRUS 3.0",ba)	US	1-n	ContourPoints
t	\N	26	(6001-o-60ff,"PAPYRUS 3.0",bc)	US	1-n	MaskData
t	\N	27	(6001-o-60ff,"PAPYRUS 3.0",c0)	SQ	1	UINOverlaySequence
f	961	\N	(0009,"PAPYRUS",00)	LT	1	OriginalFileName
f	962	\N	(0009,"PAPYRUS",10)	LT	1	OriginalFileLocation
f	963	\N	(0009,"PAPYRUS",18)	LT	1	DataSetIdentifier
f	964	\N	(0041,"PAPYRUS",00)	LT	1-n	PapyrusComments
f	965	\N	(0041,"PAPYRUS",10)	US	1	FolderType
f	966	\N	(0041,"PAPYRUS",11)	LT	1	PatientFolderDataSetID
f	967	\N	(0041,"PAPYRUS",20)	LT	1	FolderName
f	968	\N	(0041,"PAPYRUS",30)	DA	1	CreationDate
f	969	\N	(0041,"PAPYRUS",32)	TM	1	CreationTime
f	970	\N	(0041,"PAPYRUS",34)	DA	1	ModifiedDate
f	971	\N	(0041,"PAPYRUS",36)	TM	1	ModifiedTime
f	972	\N	(0041,"PAPYRUS",40)	LT	1-n	OwnerName
f	973	\N	(0041,"PAPYRUS",50)	LT	1	FolderStatus
f	974	\N	(0041,"PAPYRUS",60)	UL	1	NumberOfImages
f	975	\N	(0041,"PAPYRUS",62)	UL	1	NumberOfOther
f	976	\N	(0041,"PAPYRUS",a0)	LT	1-n	ExternalFolderElementDSID
f	977	\N	(0041,"PAPYRUS",a1)	US	1-n	ExternalFolderElementDataSetType
f	978	\N	(0041,"PAPYRUS",a2)	LT	1-n	ExternalFolderElementFileLocation
f	979	\N	(0041,"PAPYRUS",a3)	UL	1-n	ExternalFolderElementLength
f	980	\N	(0041,"PAPYRUS",b0)	LT	1-n	InternalFolderElementDSID
f	981	\N	(0041,"PAPYRUS",b1)	US	1-n	InternalFolderElementDataSetType
f	982	\N	(0041,"PAPYRUS",b2)	UL	1-n	InternalOffsetToDataSet
f	983	\N	(0041,"PAPYRUS",b3)	UL	1-n	InternalOffsetToImage
f	984	\N	(2001,"Philips Imaging DD 001",01)	FL	1	ChemicalShift
f	985	\N	(2001,"Philips Imaging DD 001",02)	IS	1	ChemicalShiftNumberMR
f	986	\N	(2001,"Philips Imaging DD 001",03)	FL	1	DiffusionB-Factor
f	987	\N	(2001,"Philips Imaging DD 001",04)	CS	1	DiffusionDirection
f	988	\N	(2001,"Philips Imaging DD 001",06)	CS	1	ImageEnhanced
f	989	\N	(2001,"Philips Imaging DD 001",07)	CS	1	ImageTypeEDES
f	990	\N	(2001,"Philips Imaging DD 001",08)	IS	1	PhaseNumber
f	991	\N	(2001,"Philips Imaging DD 001",0a)	IS	1	SliceNumberMR
f	992	\N	(2001,"Philips Imaging DD 001",0b)	CS	1	SliceOrientation
f	993	\N	(2001,"Philips Imaging DD 001",11)	FL	1	DiffusionEchoTime
f	994	\N	(2001,"Philips Imaging DD 001",12)	CS	1	DynamicSeries
f	995	\N	(2001,"Philips Imaging DD 001",13)	SL	1	EPIFactor
f	996	\N	(2001,"Philips Imaging DD 001",14)	SL	1	NumberOfEchoes
f	997	\N	(2001,"Philips Imaging DD 001",15)	SS	1	NumberOfLocations
f	998	\N	(2001,"Philips Imaging DD 001",16)	SS	1	NumberOfPCDirections
f	999	\N	(2001,"Philips Imaging DD 001",17)	SL	1	NumberOfPhasesMR
f	1000	\N	(2001,"Philips Imaging DD 001",18)	SL	1	NumberOfSlicesMR
f	1001	\N	(2001,"Philips Imaging DD 001",19)	CS	1	PartialMatrixScanned
f	1002	\N	(2001,"Philips Imaging DD 001",1a)	FL	1-n	PCVelocity
f	1003	\N	(2001,"Philips Imaging DD 001",1b)	FL	1	PrepulseDelay
f	1004	\N	(2001,"Philips Imaging DD 001",1c)	CS	1	PrepulseType
f	1005	\N	(2001,"Philips Imaging DD 001",1d)	IS	1	ReconstructionNumberMR
f	1006	\N	(2001,"Philips Imaging DD 001",1f)	CS	1	RespirationSync
f	1007	\N	(2001,"Philips Imaging DD 001",21)	CS	1	SPIR
f	1008	\N	(2001,"Philips Imaging DD 001",22)	FL	1	WaterFatShift
f	1009	\N	(2001,"Philips Imaging DD 001",23)	DS	1	FlipAnglePhilips
f	1010	\N	(2001,"Philips Imaging DD 001",25)	SH	1	EchoTimeDisplayMR
f	1011	\N	(2001,"Philips Imaging DD 001",2d)	SS	1	StackNumberOfSlices
f	1012	\N	(2001,"Philips Imaging DD 001",32)	FL	1	StackRadialAngle
f	1013	\N	(2001,"Philips Imaging DD 001",33)	CS	1	StackRadialAxis
f	1014	\N	(2001,"Philips Imaging DD 001",35)	SS	1	StackSliceNumber
f	1015	\N	(2001,"Philips Imaging DD 001",36)	CS	1	StackType
f	1016	\N	(2001,"Philips Imaging DD 001",3f)	CS	1	ZoomMode
f	1017	\N	(2001,"Philips Imaging DD 001",5f)	SQ	1-n	StackSequence
f	1018	\N	(2001,"Philips Imaging DD 001",60)	SL	1	NumberOfStacks
f	1019	\N	(2001,"Philips Imaging DD 001",61)	CS	1	SeriesTransmitted
f	1020	\N	(2001,"Philips Imaging DD 001",62)	CS	1	SeriesCommitted
f	1021	\N	(2001,"Philips Imaging DD 001",63)	CS	1	ExaminationSource
f	1022	\N	(2001,"Philips Imaging DD 001",7b)	IS	1	AcquisitionNumber
f	1023	\N	(2001,"Philips Imaging DD 001",81)	IS	1	NumberOfDynamicScans
f	1024	\N	(2001,"PHILIPS IMAGING DD 001",01)	FL	1	ChemicalShift
f	1025	\N	(2001,"PHILIPS IMAGING DD 001",02)	IS	1	ChemicalShiftNumberMR
f	1026	\N	(2001,"PHILIPS IMAGING DD 001",03)	FL	1	DiffusionB-Factor
f	1027	\N	(2001,"PHILIPS IMAGING DD 001",04)	CS	1	DiffusionDirection
f	1028	\N	(2001,"PHILIPS IMAGING DD 001",06)	CS	1	ImageEnhanced
f	1029	\N	(2001,"PHILIPS IMAGING DD 001",07)	CS	1	ImageTypeEDES
f	1030	\N	(2001,"PHILIPS IMAGING DD 001",08)	IS	1	PhaseNumber
f	1031	\N	(2001,"PHILIPS IMAGING DD 001",0a)	IS	1	SliceNumberMR
f	1032	\N	(2001,"PHILIPS IMAGING DD 001",0b)	CS	1	SliceOrientation
f	1033	\N	(2001,"PHILIPS IMAGING DD 001",11)	FL	1	DiffusionEchoTime
f	1034	\N	(2001,"PHILIPS IMAGING DD 001",12)	CS	1	DynamicSeries
f	1035	\N	(2001,"PHILIPS IMAGING DD 001",13)	SL	1	EPIFactor
f	1036	\N	(2001,"PHILIPS IMAGING DD 001",14)	SL	1	NumberOfEchoes
f	1037	\N	(2001,"PHILIPS IMAGING DD 001",15)	SS	1	NumberOfLocations
f	1038	\N	(2001,"PHILIPS IMAGING DD 001",16)	SS	1	NumberOfPCDirections
f	1039	\N	(2001,"PHILIPS IMAGING DD 001",17)	SL	1	NumberOfPhasesMR
f	1040	\N	(2001,"PHILIPS IMAGING DD 001",18)	SL	1	NumberOfSlicesMR
f	1041	\N	(2001,"PHILIPS IMAGING DD 001",19)	CS	1	PartialMatrixScanned
f	1042	\N	(2001,"PHILIPS IMAGING DD 001",1a)	FL	1-n	PCVelocity
f	1043	\N	(2001,"PHILIPS IMAGING DD 001",1b)	FL	1	PrepulseDelay
f	1044	\N	(2001,"PHILIPS IMAGING DD 001",1c)	CS	1	PrepulseType
f	1045	\N	(2001,"PHILIPS IMAGING DD 001",1d)	IS	1	ReconstructionNumberMR
f	1046	\N	(2001,"PHILIPS IMAGING DD 001",1f)	CS	1	RespirationSync
f	1047	\N	(2001,"PHILIPS IMAGING DD 001",21)	CS	1	SPIR
f	1048	\N	(2001,"PHILIPS IMAGING DD 001",22)	FL	1	WaterFatShift
f	1049	\N	(2001,"PHILIPS IMAGING DD 001",23)	DS	1	FlipAnglePhilips
f	1050	\N	(2001,"PHILIPS IMAGING DD 001",25)	SH	1	EchoTimeDisplayMR
f	1051	\N	(2001,"PHILIPS IMAGING DD 001",2d)	SS	1	StackNumberOfSlices
f	1052	\N	(2001,"PHILIPS IMAGING DD 001",32)	FL	1	StackRadialAngle
f	1053	\N	(2001,"PHILIPS IMAGING DD 001",33)	CS	1	StackRadialAxis
f	1054	\N	(2001,"PHILIPS IMAGING DD 001",35)	SS	1	StackSliceNumber
f	1055	\N	(2001,"PHILIPS IMAGING DD 001",36)	CS	1	StackType
f	1056	\N	(2001,"PHILIPS IMAGING DD 001",3f)	CS	1	ZoomMode
f	1057	\N	(2001,"PHILIPS IMAGING DD 001",5f)	SQ	1-n	StackSequence
f	1058	\N	(2001,"PHILIPS IMAGING DD 001",60)	SL	1	NumberOfStacks
f	1059	\N	(2001,"PHILIPS IMAGING DD 001",61)	CS	1	SeriesTransmitted
f	1060	\N	(2001,"PHILIPS IMAGING DD 001",62)	CS	1	SeriesCommitted
f	1061	\N	(2001,"PHILIPS IMAGING DD 001",63)	CS	1	ExaminationSource
f	1062	\N	(2001,"PHILIPS IMAGING DD 001",7b)	IS	1	AcquisitionNumber
f	1063	\N	(2001,"PHILIPS IMAGING DD 001",81)	IS	1	NumberOfDynamicScans
f	1064	\N	(2005,"Philips MR Imaging DD 001",05)	CS	1	SynergyReconstructionType
f	1065	\N	(2005,"Philips MR Imaging DD 001",1e)	SH	1	MIPProtocol
f	1066	\N	(2005,"Philips MR Imaging DD 001",1f)	SH	1	MPRProtocol
f	1067	\N	(2005,"Philips MR Imaging DD 001",20)	SL	1	NumberOfChemicalShifts
f	1068	\N	(2005,"Philips MR Imaging DD 001",2d)	SS	1	NumberOfStackSlices
f	1069	\N	(2005,"Philips MR Imaging DD 001",32)	FL	1	StackRadialAngle
f	1070	\N	(2005,"Philips MR Imaging DD 001",33)	CS	1	StackRadialAxis
f	1071	\N	(2005,"Philips MR Imaging DD 001",35)	SS	1	StackSliceNumber
f	1072	\N	(2005,"Philips MR Imaging DD 001",36)	CS	1	StackType
f	1073	\N	(2005,"Philips MR Imaging DD 001",a1)	CS	1	SyncraScanType
f	1074	\N	(2005,"Philips MR Imaging DD 001",5f)	SQ	1	StackSequence
f	1075	\N	(2005,"Philips MR Imaging DD 001",83)	SQ	1	Unknown
f	1076	\N	(2005,"Philips MR Imaging DD 005",02)	SQ	1	Unknown
f	1077	\N	(2005,"PHILIPS MR IMAGING DD 001",05)	CS	1	SynergyReconstructionType
f	1078	\N	(2005,"PHILIPS MR IMAGING DD 001",1e)	SH	1	MIPProtocol
f	1079	\N	(2005,"PHILIPS MR IMAGING DD 001",1f)	SH	1	MPRProtocol
f	1080	\N	(2005,"PHILIPS MR IMAGING DD 001",20)	SL	1	NumberOfChemicalShifts
f	1081	\N	(2005,"PHILIPS MR IMAGING DD 001",2d)	SS	1	NumberOfStackSlices
f	1082	\N	(2005,"PHILIPS MR IMAGING DD 001",32)	FL	1	StackRadialAngle
f	1083	\N	(2005,"PHILIPS MR IMAGING DD 001",33)	CS	1	StackRadialAxis
f	1084	\N	(2005,"PHILIPS MR IMAGING DD 001",35)	SS	1	StackSliceNumber
f	1085	\N	(2005,"PHILIPS MR IMAGING DD 001",36)	CS	1	StackType
f	1086	\N	(2005,"PHILIPS MR IMAGING DD 001",a1)	CS	1	SyncraScanType
f	1087	\N	(2005,"PHILIPS MR IMAGING DD 001",5f)	SQ	1	StackSequence
f	1088	\N	(2005,"PHILIPS MR IMAGING DD 001",83)	SQ	1	Unknown
f	1089	\N	(0019,"PHILIPS MR R5.5/PART",1000)	DS	1	FieldOfView
f	1090	\N	(0019,"PHILIPS MR R5.6/PART",1000)	DS	1	FieldOfView
f	1091	\N	(0019,"PHILIPS MR SPECTRO;1",01)	US	1	Unknown
f	1092	\N	(0019,"PHILIPS MR SPECTRO;1",02)	US	1	Unknown
f	1093	\N	(0019,"PHILIPS MR SPECTRO;1",03)	US	1	Unknown
f	1094	\N	(0019,"PHILIPS MR SPECTRO;1",04)	US	1	Unknown
f	1095	\N	(0019,"PHILIPS MR SPECTRO;1",05)	US	1	Unknown
f	1096	\N	(0019,"PHILIPS MR SPECTRO;1",06)	US	1	Unknown
f	1097	\N	(0019,"PHILIPS MR SPECTRO;1",07)	IS	1	Unknown
f	1098	\N	(0019,"PHILIPS MR SPECTRO;1",08)	IS	1	Unknown
f	1099	\N	(0019,"PHILIPS MR SPECTRO;1",09)	IS	1	Unknown
f	1100	\N	(0019,"PHILIPS MR SPECTRO;1",10)	IS	1	Unknown
f	1101	\N	(0019,"PHILIPS MR SPECTRO;1",12)	IS	1	Unknown
f	1102	\N	(0019,"PHILIPS MR SPECTRO;1",13)	IS	1	Unknown
f	1103	\N	(0019,"PHILIPS MR SPECTRO;1",14)	US	1	Unknown
f	1104	\N	(0019,"PHILIPS MR SPECTRO;1",15)	US	1-n	Unknown
f	1105	\N	(0019,"PHILIPS MR SPECTRO;1",16)	IS	1	Unknown
f	1106	\N	(0019,"PHILIPS MR SPECTRO;1",17)	IS	1	Unknown
f	1107	\N	(0019,"PHILIPS MR SPECTRO;1",18)	UN	1	Unknown
f	1108	\N	(0019,"PHILIPS MR SPECTRO;1",20)	IS	1	Unknown
f	1109	\N	(0019,"PHILIPS MR SPECTRO;1",21)	IS	1	Unknown
f	1110	\N	(0019,"PHILIPS MR SPECTRO;1",22)	IS	1	Unknown
f	1111	\N	(0019,"PHILIPS MR SPECTRO;1",23)	IS	1	Unknown
f	1112	\N	(0019,"PHILIPS MR SPECTRO;1",24)	IS	1	Unknown
f	1113	\N	(0019,"PHILIPS MR SPECTRO;1",25)	IS	1	Unknown
f	1114	\N	(0019,"PHILIPS MR SPECTRO;1",26)	IS	1	Unknown
f	1115	\N	(0019,"PHILIPS MR SPECTRO;1",27)	IS	1	Unknown
f	1116	\N	(0019,"PHILIPS MR SPECTRO;1",28)	IS	1	Unknown
f	1117	\N	(0019,"PHILIPS MR SPECTRO;1",29)	IS	1-n	Unknown
f	1118	\N	(0019,"PHILIPS MR SPECTRO;1",31)	US	1	Unknown
f	1119	\N	(0019,"PHILIPS MR SPECTRO;1",32)	US	1	Unknown
f	1120	\N	(0019,"PHILIPS MR SPECTRO;1",41)	LT	1	Unknown
f	1121	\N	(0019,"PHILIPS MR SPECTRO;1",42)	IS	2	Unknown
f	1122	\N	(0019,"PHILIPS MR SPECTRO;1",43)	IS	2	Unknown
f	1123	\N	(0019,"PHILIPS MR SPECTRO;1",45)	US	1	Unknown
f	1124	\N	(0019,"PHILIPS MR SPECTRO;1",46)	US	1	Unknown
f	1125	\N	(0019,"PHILIPS MR SPECTRO;1",47)	IS	1	Unknown
f	1126	\N	(0019,"PHILIPS MR SPECTRO;1",48)	IS	1	Unknown
f	1127	\N	(0019,"PHILIPS MR SPECTRO;1",49)	US	1	Unknown
f	1128	\N	(0019,"PHILIPS MR SPECTRO;1",50)	UN	1	Unknown
f	1129	\N	(0019,"PHILIPS MR SPECTRO;1",60)	US	1	Unknown
f	1130	\N	(0019,"PHILIPS MR SPECTRO;1",61)	US	1	Unknown
f	1131	\N	(0019,"PHILIPS MR SPECTRO;1",70)	UN	1	Unknown
f	1132	\N	(0019,"PHILIPS MR SPECTRO;1",71)	IS	1-n	Unknown
f	1133	\N	(0019,"PHILIPS MR SPECTRO;1",72)	US	1	Unknown
f	1134	\N	(0019,"PHILIPS MR SPECTRO;1",73)	US	1	Unknown
f	1135	\N	(0019,"PHILIPS MR SPECTRO;1",74)	US	1	Unknown
f	1136	\N	(0019,"PHILIPS MR SPECTRO;1",76)	US	1	Unknown
f	1137	\N	(0019,"PHILIPS MR SPECTRO;1",77)	US	1	Unknown
f	1138	\N	(0019,"PHILIPS MR SPECTRO;1",78)	US	1	Unknown
f	1139	\N	(0019,"PHILIPS MR SPECTRO;1",79)	US	1	Unknown
f	1140	\N	(0019,"PHILIPS MR SPECTRO;1",80)	IS	1	Unknown
f	1141	\N	(0009,"PHILIPS MR",10)	LO	1	SPIRelease
f	1142	\N	(0009,"PHILIPS MR",12)	LO	1	Unknown
f	1143	\N	(0019,"PHILIPS MR/LAST",09)	DS	1	MainMagneticField
f	1144	\N	(0019,"PHILIPS MR/LAST",0e)	IS	1	FlowCompensation
f	1145	\N	(0019,"PHILIPS MR/LAST",b1)	IS	1	MinimumRRInterval
f	1146	\N	(0019,"PHILIPS MR/LAST",b2)	IS	1	MaximumRRInterval
f	1147	\N	(0019,"PHILIPS MR/LAST",b3)	IS	1	NumberOfRejections
f	1148	\N	(0019,"PHILIPS MR/LAST",b4)	IS	1-n	NumberOfRRIntervals
f	1149	\N	(0019,"PHILIPS MR/LAST",b5)	IS	1	ArrhythmiaRejection
f	1150	\N	(0019,"PHILIPS MR/LAST",c0)	DS	1-n	Unknown
f	1151	\N	(0019,"PHILIPS MR/LAST",c6)	IS	1	CycledMultipleSlice
f	1152	\N	(0019,"PHILIPS MR/LAST",ce)	IS	1	REST
f	1153	\N	(0019,"PHILIPS MR/LAST",d5)	DS	1	Unknown
f	1154	\N	(0019,"PHILIPS MR/LAST",d6)	IS	1	FourierInterpolation
f	1155	\N	(0019,"PHILIPS MR/LAST",d9)	IS	1-n	Unknown
f	1156	\N	(0019,"PHILIPS MR/LAST",e0)	IS	1	Prepulse
f	1157	\N	(0019,"PHILIPS MR/LAST",e1)	DS	1	PrepulseDelay
f	1158	\N	(0019,"PHILIPS MR/LAST",e2)	IS	1	Unknown
f	1159	\N	(0019,"PHILIPS MR/LAST",e3)	DS	1	Unknown
f	1160	\N	(0019,"PHILIPS MR/LAST",f0)	LT	1	WSProtocolString1
f	1161	\N	(0019,"PHILIPS MR/LAST",f1)	LT	1	WSProtocolString2
f	1162	\N	(0019,"PHILIPS MR/LAST",f2)	LT	1	WSProtocolString3
f	1163	\N	(0019,"PHILIPS MR/LAST",f3)	LT	1	WSProtocolString4
f	1164	\N	(0021,"PHILIPS MR/LAST",00)	IS	1	Unknown
f	1165	\N	(0021,"PHILIPS MR/LAST",10)	IS	1	Unknown
f	1166	\N	(0021,"PHILIPS MR/LAST",20)	IS	1	Unknown
f	1167	\N	(0021,"PHILIPS MR/LAST",21)	DS	1	SliceGap
f	1168	\N	(0021,"PHILIPS MR/LAST",22)	DS	1	StackRadialAngle
f	1169	\N	(0027,"PHILIPS MR/LAST",00)	US	1	Unknown
f	1170	\N	(0027,"PHILIPS MR/LAST",11)	US	1-n	Unknown
f	1171	\N	(0027,"PHILIPS MR/LAST",12)	DS	1-n	Unknown
f	1172	\N	(0027,"PHILIPS MR/LAST",13)	DS	1-n	Unknown
f	1173	\N	(0027,"PHILIPS MR/LAST",14)	DS	1-n	Unknown
f	1174	\N	(0027,"PHILIPS MR/LAST",15)	DS	1-n	Unknown
f	1175	\N	(0027,"PHILIPS MR/LAST",16)	LO	1	Unknown
f	1176	\N	(0029,"PHILIPS MR/LAST",10)	DS	1	FPMin
f	1177	\N	(0029,"PHILIPS MR/LAST",20)	DS	1	FPMax
f	1178	\N	(0029,"PHILIPS MR/LAST",30)	DS	1	ScaledMinimum
f	1179	\N	(0029,"PHILIPS MR/LAST",40)	DS	1	ScaledMaximum
f	1180	\N	(0029,"PHILIPS MR/LAST",50)	DS	1	WindowMinimum
f	1181	\N	(0029,"PHILIPS MR/LAST",60)	DS	1	WindowMaximum
f	1182	\N	(0029,"PHILIPS MR/LAST",61)	IS	1	Unknown
f	1183	\N	(0029,"PHILIPS MR/LAST",70)	DS	1	Unknown
f	1184	\N	(0029,"PHILIPS MR/LAST",71)	DS	1	Unknown
f	1185	\N	(0029,"PHILIPS MR/LAST",72)	IS	1	Unknown
f	1186	\N	(0029,"PHILIPS MR/LAST",80)	IS	1	ViewCenter
f	1187	\N	(0029,"PHILIPS MR/LAST",81)	IS	1	ViewSize
f	1188	\N	(0029,"PHILIPS MR/LAST",82)	IS	1	ViewZoom
f	1189	\N	(0029,"PHILIPS MR/LAST",83)	IS	1	ViewTransform
f	1190	\N	(6001,"PHILIPS MR/LAST",00)	LT	1	Unknown
f	1191	\N	(0019,"PHILIPS MR/PART",1000)	DS	1	FieldOfView
f	1192	\N	(0019,"PHILIPS MR/PART",1005)	DS	1	CCAngulation
f	1193	\N	(0019,"PHILIPS MR/PART",1006)	DS	1	APAngulation
f	1194	\N	(0019,"PHILIPS MR/PART",1007)	DS	1	LRAngulation
f	1195	\N	(0019,"PHILIPS MR/PART",1008)	IS	1	PatientPosition
f	1196	\N	(0019,"PHILIPS MR/PART",1009)	IS	1	PatientOrientation
f	1197	\N	(0019,"PHILIPS MR/PART",100a)	IS	1	SliceOrientation
f	1198	\N	(0019,"PHILIPS MR/PART",100b)	DS	1	LROffcenter
f	1199	\N	(0019,"PHILIPS MR/PART",100c)	DS	1	CCOffcenter
f	1200	\N	(0019,"PHILIPS MR/PART",100d)	DS	1	APOffcenter
f	1201	\N	(0019,"PHILIPS MR/PART",100e)	DS	1	Unknown
f	1202	\N	(0019,"PHILIPS MR/PART",100f)	IS	1	NumberOfSlices
f	1203	\N	(0019,"PHILIPS MR/PART",1010)	DS	1	SliceFactor
f	1204	\N	(0019,"PHILIPS MR/PART",1011)	DS	1-n	EchoTimes
f	1205	\N	(0019,"PHILIPS MR/PART",1015)	IS	1	DynamicStudy
f	1206	\N	(0019,"PHILIPS MR/PART",1018)	DS	1	HeartbeatInterval
f	1207	\N	(0019,"PHILIPS MR/PART",1019)	DS	1	RepetitionTimeFFE
f	1208	\N	(0019,"PHILIPS MR/PART",101a)	DS	1	FFEFlipAngle
f	1209	\N	(0019,"PHILIPS MR/PART",101b)	IS	1	NumberOfScans
f	1210	\N	(0019,"PHILIPS MR/PART",1021)	DS	1-n	Unknown
f	1211	\N	(0019,"PHILIPS MR/PART",1022)	DS	1	DynamicScanTimeBegin
f	1212	\N	(0019,"PHILIPS MR/PART",1024)	IS	1	Unknown
f	1213	\N	(0019,"PHILIPS MR/PART",1064)	DS	1	RepetitionTimeSE
f	1214	\N	(0019,"PHILIPS MR/PART",1065)	DS	1	RepetitionTimeIR
f	1215	\N	(0019,"PHILIPS MR/PART",1069)	IS	1	NumberOfPhases
f	1216	\N	(0019,"PHILIPS MR/PART",106a)	IS	1	CardiacFrequency
f	1217	\N	(0019,"PHILIPS MR/PART",106b)	DS	1	InversionDelay
f	1218	\N	(0019,"PHILIPS MR/PART",106c)	DS	1	GateDelay
f	1219	\N	(0019,"PHILIPS MR/PART",106d)	DS	1	GateWidth
f	1220	\N	(0019,"PHILIPS MR/PART",106e)	DS	1	TriggerDelayTime
f	1221	\N	(0019,"PHILIPS MR/PART",1080)	IS	1	NumberOfChemicalShifts
f	1222	\N	(0019,"PHILIPS MR/PART",1081)	DS	1	ChemicalShift
f	1223	\N	(0019,"PHILIPS MR/PART",1084)	IS	1	NumberOfRows
f	1224	\N	(0019,"PHILIPS MR/PART",1085)	IS	1	NumberOfSamples
f	1225	\N	(0019,"PHILIPS MR/PART",1094)	LO	1	MagnetizationTransferContrast
f	1226	\N	(0019,"PHILIPS MR/PART",1095)	LO	1	SpectralPresaturationWithInversionRecovery
f	1227	\N	(0019,"PHILIPS MR/PART",1096)	IS	1	Unknown
f	1228	\N	(0019,"PHILIPS MR/PART",1097)	LO	1	Unknown
f	1229	\N	(0019,"PHILIPS MR/PART",10a0)	IS	1	Unknown
f	1230	\N	(0019,"PHILIPS MR/PART",10a1)	DS	1	Unknown
f	1231	\N	(0019,"PHILIPS MR/PART",10a3)	DS	1	Unknown
f	1232	\N	(0019,"PHILIPS MR/PART",10a4)	CS	1	Unknown
f	1233	\N	(0019,"PHILIPS MR/PART",10c8)	IS	1	Unknown
f	1234	\N	(0019,"PHILIPS MR/PART",10c9)	IS	1	FoldoverDirectionTransverse
f	1235	\N	(0019,"PHILIPS MR/PART",10ca)	IS	1	FoldoverDirectionSagittal
f	1236	\N	(0019,"PHILIPS MR/PART",10cb)	IS	1	FoldoverDirectionCoronal
f	1237	\N	(0019,"PHILIPS MR/PART",10cc)	IS	1	Unknown
f	1238	\N	(0019,"PHILIPS MR/PART",10cd)	IS	1	Unknown
f	1239	\N	(0019,"PHILIPS MR/PART",10ce)	IS	1	Unknown
f	1240	\N	(0019,"PHILIPS MR/PART",10cf)	IS	1	NumberOfEchoes
f	1241	\N	(0019,"PHILIPS MR/PART",10d0)	IS	1	ScanResolution
f	1242	\N	(0019,"PHILIPS MR/PART",10d2)	LO	2	WaterFatShift
f	1243	\N	(0019,"PHILIPS MR/PART",10d4)	IS	1	ArtifactReduction
f	1244	\N	(0019,"PHILIPS MR/PART",10d5)	IS	1	Unknown
f	1245	\N	(0019,"PHILIPS MR/PART",10d6)	IS	1	Unknown
f	1246	\N	(0019,"PHILIPS MR/PART",10d7)	DS	1	ScanPercentage
f	1247	\N	(0019,"PHILIPS MR/PART",10d8)	IS	1	Halfscan
f	1248	\N	(0019,"PHILIPS MR/PART",10d9)	IS	1	EPIFactor
f	1249	\N	(0019,"PHILIPS MR/PART",10da)	IS	1	TurboFactor
f	1250	\N	(0019,"PHILIPS MR/PART",10db)	IS	1	Unknown
f	1251	\N	(0019,"PHILIPS MR/PART",10e0)	IS	1	PercentageOfScanCompleted
f	1252	\N	(0019,"PHILIPS MR/PART",10e1)	IS	1	Unknown
f	1253	\N	(0019,"PHILIPS MR/PART",1100)	IS	1	NumberOfStacks
f	1254	\N	(0019,"PHILIPS MR/PART",1101)	IS	1-n	StackType
f	1255	\N	(0019,"PHILIPS MR/PART",1102)	IS	1-n	Unknown
f	1256	\N	(0019,"PHILIPS MR/PART",110b)	DS	1	LROffcenter
f	1257	\N	(0019,"PHILIPS MR/PART",110c)	DS	1	CCOffcenter
f	1258	\N	(0019,"PHILIPS MR/PART",110d)	DS	1	APOffcenter
f	1259	\N	(0019,"PHILIPS MR/PART",1145)	IS	1	ReconstructionResolution
f	1260	\N	(0019,"PHILIPS MR/PART",11fc)	IS	1	ResonanceFrequency
f	1261	\N	(0019,"PHILIPS MR/PART",12c0)	DS	1	TriggerDelayTimes
f	1262	\N	(0019,"PHILIPS MR/PART",12e0)	IS	1	PrepulseType
f	1263	\N	(0019,"PHILIPS MR/PART",12e1)	DS	1	PrepulseDelay
f	1264	\N	(0019,"PHILIPS MR/PART",12e3)	DS	1	PhaseContrastVelocity
f	1265	\N	(0021,"PHILIPS MR/PART",1000)	IS	1	ReconstructionNumber
f	1266	\N	(0021,"PHILIPS MR/PART",1010)	IS	1	ImageType
f	1267	\N	(0021,"PHILIPS MR/PART",1020)	IS	1	SliceNumber
f	1268	\N	(0021,"PHILIPS MR/PART",1030)	IS	1	EchoNumber
f	1269	\N	(0021,"PHILIPS MR/PART",1031)	DS	1	PatientReferenceID
f	1270	\N	(0021,"PHILIPS MR/PART",1035)	IS	1	ChemicalShiftNumber
f	1271	\N	(0021,"PHILIPS MR/PART",1040)	IS	1	PhaseNumber
f	1272	\N	(0021,"PHILIPS MR/PART",1050)	IS	1	DynamicScanNumber
f	1273	\N	(0021,"PHILIPS MR/PART",1060)	IS	1	NumberOfRowsInObject
f	1274	\N	(0021,"PHILIPS MR/PART",1061)	IS	1-n	RowNumber
f	1275	\N	(0021,"PHILIPS MR/PART",1062)	IS	1-n	Unknown
f	1276	\N	(0021,"PHILIPS MR/PART",1100)	DA	1	ScanDate
f	1277	\N	(0021,"PHILIPS MR/PART",1110)	TM	1	ScanTime
f	1278	\N	(0021,"PHILIPS MR/PART",1221)	IS	1	SliceGap
f	1279	\N	(0029,"PHILIPS MR/PART",00)	DS	2	Unknown
f	1280	\N	(0029,"PHILIPS MR/PART",04)	US	1	Unknown
f	1281	\N	(0029,"PHILIPS MR/PART",10)	DS	1	Unknown
f	1282	\N	(0029,"PHILIPS MR/PART",11)	DS	1	Unknown
f	1283	\N	(0029,"PHILIPS MR/PART",20)	LO	1	Unknown
f	1284	\N	(0029,"PHILIPS MR/PART",31)	DS	2	Unknown
f	1285	\N	(0029,"PHILIPS MR/PART",32)	DS	2	Unknown
f	1286	\N	(0029,"PHILIPS MR/PART",c3)	IS	1	ScanResolution
f	1287	\N	(0029,"PHILIPS MR/PART",c4)	IS	1	FieldOfView
f	1288	\N	(0029,"PHILIPS MR/PART",d5)	LT	1	SliceThickness
f	1289	\N	(0019,"PHILIPS-MR-1",11)	IS	1	ChemicalShiftNumber
f	1290	\N	(0019,"PHILIPS-MR-1",12)	IS	1	PhaseNumber
f	1291	\N	(0021,"PHILIPS-MR-1",01)	IS	1	ReconstructionNumber
f	1292	\N	(0021,"PHILIPS-MR-1",02)	IS	1	SliceNumber
f	1293	\N	(7001,"Picker NM Private Group",01)	UI	1	Unknown
f	1294	\N	(7001,"Picker NM Private Group",02)	OB	1	Unknown
f	1295	\N	(0019,"SIEMENS CM VA0  ACQU",10)	LT	1	ParameterFileName
f	1296	\N	(0019,"SIEMENS CM VA0  ACQU",11)	LO	1	SequenceFileName
f	1297	\N	(0019,"SIEMENS CM VA0  ACQU",12)	LT	1	SequenceFileOwner
f	1298	\N	(0019,"SIEMENS CM VA0  ACQU",13)	LT	1	SequenceDescription
f	1299	\N	(0019,"SIEMENS CM VA0  ACQU",14)	LT	1	EPIFileName
f	1300	\N	(0009,"SIEMENS CM VA0  CMS",00)	DS	1	NumberOfMeasurements
f	1301	\N	(0009,"SIEMENS CM VA0  CMS",10)	LT	1	StorageMode
f	1302	\N	(0009,"SIEMENS CM VA0  CMS",12)	UL	1	EvaluationMaskImage
f	1303	\N	(0009,"SIEMENS CM VA0  CMS",26)	DA	1	LastMoveDate
f	1304	\N	(0009,"SIEMENS CM VA0  CMS",27)	TM	1	LastMoveTime
f	1305	\N	(0011,"SIEMENS CM VA0  CMS",0a)	LT	1	Unknown
f	1306	\N	(0011,"SIEMENS CM VA0  CMS",10)	DA	1	RegistrationDate
f	1307	\N	(0011,"SIEMENS CM VA0  CMS",11)	TM	1	RegistrationTime
f	1308	\N	(0011,"SIEMENS CM VA0  CMS",22)	LT	1	Unknown
f	1309	\N	(0011,"SIEMENS CM VA0  CMS",23)	DS	1	UsedPatientWeight
f	1310	\N	(0011,"SIEMENS CM VA0  CMS",40)	IS	1	OrganCode
f	1311	\N	(0013,"SIEMENS CM VA0  CMS",00)	LT	1	ModifyingPhysician
f	1312	\N	(0013,"SIEMENS CM VA0  CMS",10)	DA	1	ModificationDate
f	1313	\N	(0013,"SIEMENS CM VA0  CMS",12)	TM	1	ModificationTime
f	1314	\N	(0013,"SIEMENS CM VA0  CMS",20)	LO	1	PatientName
f	1315	\N	(0013,"SIEMENS CM VA0  CMS",22)	LO	1	PatientId
f	1316	\N	(0013,"SIEMENS CM VA0  CMS",30)	DA	1	PatientBirthdate
f	1317	\N	(0013,"SIEMENS CM VA0  CMS",31)	DS	1	PatientWeight
f	1318	\N	(0013,"SIEMENS CM VA0  CMS",32)	LT	1	PatientsMaidenName
f	1319	\N	(0013,"SIEMENS CM VA0  CMS",33)	LT	1	ReferringPhysician
f	1320	\N	(0013,"SIEMENS CM VA0  CMS",34)	LT	1	AdmittingDiagnosis
f	1321	\N	(0013,"SIEMENS CM VA0  CMS",35)	LO	1	PatientSex
f	1322	\N	(0013,"SIEMENS CM VA0  CMS",40)	LO	1	ProcedureDescription
f	1323	\N	(0013,"SIEMENS CM VA0  CMS",42)	LO	1	RestDirection
f	1324	\N	(0013,"SIEMENS CM VA0  CMS",44)	LO	1	PatientPosition
f	1325	\N	(0013,"SIEMENS CM VA0  CMS",46)	LT	1	ViewDirection
f	1326	\N	(0013,"SIEMENS CM VA0  CMS",50)	LT	1	Unknown
f	1327	\N	(0013,"SIEMENS CM VA0  CMS",51)	LT	1	Unknown
f	1328	\N	(0013,"SIEMENS CM VA0  CMS",52)	LT	1	Unknown
f	1329	\N	(0013,"SIEMENS CM VA0  CMS",53)	LT	1	Unknown
f	1330	\N	(0013,"SIEMENS CM VA0  CMS",54)	LT	1	Unknown
f	1331	\N	(0013,"SIEMENS CM VA0  CMS",55)	LT	1	Unknown
f	1332	\N	(0013,"SIEMENS CM VA0  CMS",56)	LT	1	Unknown
f	1333	\N	(0019,"SIEMENS CM VA0  CMS",10)	DS	1	NetFrequency
f	1334	\N	(0019,"SIEMENS CM VA0  CMS",20)	LT	1	MeasurementMode
f	1335	\N	(0019,"SIEMENS CM VA0  CMS",30)	LT	1	CalculationMode
f	1336	\N	(0019,"SIEMENS CM VA0  CMS",50)	IS	1	NoiseLevel
f	1337	\N	(0019,"SIEMENS CM VA0  CMS",60)	IS	1	NumberOfDataBytes
f	1338	\N	(0021,"SIEMENS CM VA0  CMS",20)	DS	2	FoV
f	1339	\N	(0021,"SIEMENS CM VA0  CMS",22)	DS	1	ImageMagnificationFactor
f	1340	\N	(0021,"SIEMENS CM VA0  CMS",24)	DS	2	ImageScrollOffset
f	1341	\N	(0021,"SIEMENS CM VA0  CMS",26)	IS	1	ImagePixelOffset
f	1342	\N	(0021,"SIEMENS CM VA0  CMS",30)	LT	1	ViewDirection
f	1343	\N	(0021,"SIEMENS CM VA0  CMS",32)	CS	1	PatientRestDirection
f	1344	\N	(0021,"SIEMENS CM VA0  CMS",60)	DS	3	ImagePosition
f	1345	\N	(0021,"SIEMENS CM VA0  CMS",61)	DS	3	ImageNormal
f	1346	\N	(0021,"SIEMENS CM VA0  CMS",63)	DS	1	ImageDistance
f	1347	\N	(0021,"SIEMENS CM VA0  CMS",65)	US	1	ImagePositioningHistoryMask
f	1348	\N	(0021,"SIEMENS CM VA0  CMS",6a)	DS	3	ImageRow
f	1349	\N	(0021,"SIEMENS CM VA0  CMS",6b)	DS	3	ImageColumn
f	1350	\N	(0021,"SIEMENS CM VA0  CMS",70)	LT	3	PatientOrientationSet1
f	1351	\N	(0021,"SIEMENS CM VA0  CMS",71)	LT	3	PatientOrientationSet2
f	1352	\N	(0021,"SIEMENS CM VA0  CMS",80)	LT	1	StudyName
f	1353	\N	(0021,"SIEMENS CM VA0  CMS",82)	LT	3	StudyType
f	1354	\N	(0029,"SIEMENS CM VA0  CMS",10)	LT	1	WindowStyle
f	1355	\N	(0029,"SIEMENS CM VA0  CMS",11)	LT	1	Unknown
f	1356	\N	(0029,"SIEMENS CM VA0  CMS",13)	LT	1	Unknown
f	1357	\N	(0029,"SIEMENS CM VA0  CMS",20)	LT	3	PixelQualityCode
f	1358	\N	(0029,"SIEMENS CM VA0  CMS",22)	IS	3	PixelQualityValue
f	1359	\N	(0029,"SIEMENS CM VA0  CMS",50)	LT	1	ArchiveCode
f	1360	\N	(0029,"SIEMENS CM VA0  CMS",51)	LT	1	ExposureCode
f	1361	\N	(0029,"SIEMENS CM VA0  CMS",52)	LT	1	SortCode
f	1362	\N	(0029,"SIEMENS CM VA0  CMS",53)	LT	1	Unknown
f	1363	\N	(0029,"SIEMENS CM VA0  CMS",60)	LT	1	Splash
f	1364	\N	(0051,"SIEMENS CM VA0  CMS",10)	LT	1-n	ImageText
f	1365	\N	(6021,"SIEMENS CM VA0  CMS",00)	LT	1	ImageGraphicsFormatCode
f	1366	\N	(6021,"SIEMENS CM VA0  CMS",10)	LT	1	ImageGraphics
f	1367	\N	(7fe1,"SIEMENS CM VA0  CMS",00)	OB	1-n	BinaryData
f	1368	\N	(0009,"SIEMENS CM VA0  LAB",10)	LT	1	GeneratorIdentificationLabel
f	1369	\N	(0009,"SIEMENS CM VA0  LAB",11)	LT	1	GantryIdentificationLabel
f	1370	\N	(0009,"SIEMENS CM VA0  LAB",12)	LT	1	X-RayTubeIdentificationLabel
f	1371	\N	(0009,"SIEMENS CM VA0  LAB",13)	LT	1	DetectorIdentificationLabel
f	1372	\N	(0009,"SIEMENS CM VA0  LAB",14)	LT	1	DASIdentificationLabel
f	1373	\N	(0009,"SIEMENS CM VA0  LAB",15)	LT	1	SMIIdentificationLabel
f	1374	\N	(0009,"SIEMENS CM VA0  LAB",16)	LT	1	CPUIdentificationLabel
f	1375	\N	(0009,"SIEMENS CM VA0  LAB",20)	LT	1	HeaderVersion
f	1376	\N	(0029,"SIEMENS CSA HEADER",08)	CS	1	CSAImageHeaderType
f	1377	\N	(0029,"SIEMENS CSA HEADER",09)	LO	1	CSAImageHeaderVersion
f	1378	\N	(0029,"SIEMENS CSA HEADER",10)	OB	1	CSAImageHeaderInfo
f	1379	\N	(0029,"SIEMENS CSA HEADER",18)	CS	1	CSASeriesHeaderType
f	1380	\N	(0029,"SIEMENS CSA HEADER",19)	LO	1	CSASeriesHeaderVersion
f	1381	\N	(0029,"SIEMENS CSA HEADER",20)	OB	1	CSASeriesHeaderInfo
f	1382	\N	(0029,"SIEMENS CSA NON-IMAGE",08)	CS	1	CSADataType
f	1383	\N	(0029,"SIEMENS CSA NON-IMAGE",09)	LO	1	CSADataVersion
f	1384	\N	(0029,"SIEMENS CSA NON-IMAGE",10)	OB	1	CSADataInfo
f	1385	\N	(7FE1,"SIEMENS CSA NON-IMAGE",10)	OB	1	CSAData
f	1386	\N	(0019,"SIEMENS CT VA0  COAD",10)	DS	1	DistanceSourceToSourceSideCollimator
f	1387	\N	(0019,"SIEMENS CT VA0  COAD",11)	DS	1	DistanceSourceToDetectorSideCollimator
f	1388	\N	(0019,"SIEMENS CT VA0  COAD",20)	IS	1	NumberOfPossibleChannels
f	1389	\N	(0019,"SIEMENS CT VA0  COAD",21)	IS	1	MeanChannelNumber
f	1390	\N	(0019,"SIEMENS CT VA0  COAD",22)	DS	1	DetectorSpacing
f	1391	\N	(0019,"SIEMENS CT VA0  COAD",23)	DS	1	DetectorCenter
f	1392	\N	(0019,"SIEMENS CT VA0  COAD",24)	DS	1	ReadingIntegrationTime
f	1393	\N	(0019,"SIEMENS CT VA0  COAD",50)	DS	1	DetectorAlignment
f	1394	\N	(0019,"SIEMENS CT VA0  COAD",52)	DS	1	Unknown
f	1395	\N	(0019,"SIEMENS CT VA0  COAD",54)	DS	1	Unknown
f	1396	\N	(0019,"SIEMENS CT VA0  COAD",60)	DS	1	FocusAlignment
f	1397	\N	(0019,"SIEMENS CT VA0  COAD",65)	UL	1	FocalSpotDeflectionAmplitude
f	1398	\N	(0019,"SIEMENS CT VA0  COAD",66)	UL	1	FocalSpotDeflectionPhase
f	1399	\N	(0019,"SIEMENS CT VA0  COAD",67)	UL	1	FocalSpotDeflectionOffset
f	1400	\N	(0019,"SIEMENS CT VA0  COAD",70)	DS	1	WaterScalingFactor
f	1401	\N	(0019,"SIEMENS CT VA0  COAD",71)	DS	1	InterpolationFactor
f	1402	\N	(0019,"SIEMENS CT VA0  COAD",80)	LT	1	PatientRegion
f	1403	\N	(0019,"SIEMENS CT VA0  COAD",82)	LT	1	PatientPhaseOfLife
f	1404	\N	(0019,"SIEMENS CT VA0  COAD",90)	DS	1	OsteoOffset
f	1405	\N	(0019,"SIEMENS CT VA0  COAD",92)	DS	1	OsteoRegressionLineSlope
f	1406	\N	(0019,"SIEMENS CT VA0  COAD",93)	DS	1	OsteoRegressionLineIntercept
f	1407	\N	(0019,"SIEMENS CT VA0  COAD",94)	DS	1	OsteoStandardizationCode
f	1408	\N	(0019,"SIEMENS CT VA0  COAD",96)	IS	1	OsteoPhantomNumber
f	1409	\N	(0019,"SIEMENS CT VA0  COAD",A3)	US	1-n	Unknown
f	1410	\N	(0019,"SIEMENS CT VA0  COAD",A4)	DS	1	Unknown
f	1411	\N	(0019,"SIEMENS CT VA0  COAD",A5)	DS	1	Unknown
f	1412	\N	(0019,"SIEMENS CT VA0  COAD",A6)	US	1-n	Unknown
f	1413	\N	(0019,"SIEMENS CT VA0  COAD",A7)	US	1-n	Unknown
f	1414	\N	(0019,"SIEMENS CT VA0  COAD",A8)	US	1-n	Unknown
f	1415	\N	(0019,"SIEMENS CT VA0  COAD",A9)	DS	1	Unknown
f	1416	\N	(0019,"SIEMENS CT VA0  COAD",AA)	LT	1	Unknown
f	1417	\N	(0019,"SIEMENS CT VA0  COAD",AB)	DS	1	Unknown
f	1418	\N	(0019,"SIEMENS CT VA0  COAD",AC)	DS	1	Unknown
f	1419	\N	(0019,"SIEMENS CT VA0  COAD",AD)	DS	1	Unknown
f	1420	\N	(0019,"SIEMENS CT VA0  COAD",AE)	DS	1	Unknown
f	1421	\N	(0019,"SIEMENS CT VA0  COAD",AF)	DS	1	Unknown
f	1422	\N	(0019,"SIEMENS CT VA0  COAD",B0)	DS	1	FeedPerRotation
f	1423	\N	(0019,"SIEMENS CT VA0  COAD",BD)	IS	1	PulmoTriggerLevel
f	1424	\N	(0019,"SIEMENS CT VA0  COAD",BE)	DS	1	ExpiratoricReserveVolume
f	1425	\N	(0019,"SIEMENS CT VA0  COAD",BF)	DS	1	VitalCapacity
f	1426	\N	(0019,"SIEMENS CT VA0  COAD",C0)	DS	1	PulmoWater
f	1427	\N	(0019,"SIEMENS CT VA0  COAD",C1)	DS	1	PulmoAir
f	1428	\N	(0019,"SIEMENS CT VA0  COAD",C2)	DA	1	PulmoDate
f	1429	\N	(0019,"SIEMENS CT VA0  COAD",C3)	TM	1	PulmoTime
f	1430	\N	(0019,"SIEMENS CT VA0  GEN",10)	DS	1	SourceSideCollimatorAperture
f	1431	\N	(0019,"SIEMENS CT VA0  GEN",11)	DS	1	DetectorSideCollimatorAperture
f	1432	\N	(0019,"SIEMENS CT VA0  GEN",20)	DS	1	ExposureTime
f	1433	\N	(0019,"SIEMENS CT VA0  GEN",21)	DS	1	ExposureCurrent
f	1434	\N	(0019,"SIEMENS CT VA0  GEN",25)	DS	1	KVPGeneratorPowerCurrent
f	1435	\N	(0019,"SIEMENS CT VA0  GEN",26)	DS	1	GeneratorVoltage
f	1436	\N	(0019,"SIEMENS CT VA0  GEN",40)	UL	1	MasterControlMask
f	1437	\N	(0019,"SIEMENS CT VA0  GEN",42)	US	5	ProcessingMask
f	1438	\N	(0019,"SIEMENS CT VA0  GEN",44)	US	1-n	Unknown
f	1439	\N	(0019,"SIEMENS CT VA0  GEN",45)	US	1-n	Unknown
f	1440	\N	(0019,"SIEMENS CT VA0  GEN",62)	IS	1	NumberOfVirtuellChannels
f	1441	\N	(0019,"SIEMENS CT VA0  GEN",70)	IS	1	NumberOfReadings
f	1442	\N	(0019,"SIEMENS CT VA0  GEN",71)	LT	1-n	Unknown
f	1443	\N	(0019,"SIEMENS CT VA0  GEN",74)	IS	1	NumberOfProjections
f	1444	\N	(0019,"SIEMENS CT VA0  GEN",75)	IS	1	NumberOfBytes
f	1445	\N	(0019,"SIEMENS CT VA0  GEN",80)	LT	1	ReconstructionAlgorithmSet
f	1446	\N	(0019,"SIEMENS CT VA0  GEN",81)	LT	1	ReconstructionAlgorithmIndex
f	1447	\N	(0019,"SIEMENS CT VA0  GEN",82)	LT	1	RegenerationSoftwareVersion
f	1448	\N	(0019,"SIEMENS CT VA0  GEN",88)	DS	1	Unknown
f	1449	\N	(0021,"SIEMENS CT VA0  GEN",10)	IS	1	RotationAngle
f	1450	\N	(0021,"SIEMENS CT VA0  GEN",11)	IS	1	StartAngle
f	1451	\N	(0021,"SIEMENS CT VA0  GEN",20)	US	1-n	Unknown
f	1452	\N	(0021,"SIEMENS CT VA0  GEN",30)	IS	1	TopogramTubePosition
f	1453	\N	(0021,"SIEMENS CT VA0  GEN",32)	DS	1	LengthOfTopogram
f	1454	\N	(0021,"SIEMENS CT VA0  GEN",34)	DS	1	TopogramCorrectionFactor
f	1455	\N	(0021,"SIEMENS CT VA0  GEN",36)	DS	1	MaximumTablePosition
f	1456	\N	(0021,"SIEMENS CT VA0  GEN",40)	IS	1	TableMoveDirectionCode
f	1457	\N	(0021,"SIEMENS CT VA0  GEN",45)	IS	1	VOIStartRow
f	1458	\N	(0021,"SIEMENS CT VA0  GEN",46)	IS	1	VOIStopRow
f	1459	\N	(0021,"SIEMENS CT VA0  GEN",47)	IS	1	VOIStartColumn
f	1460	\N	(0021,"SIEMENS CT VA0  GEN",48)	IS	1	VOIStopColumn
f	1461	\N	(0021,"SIEMENS CT VA0  GEN",49)	IS	1	VOIStartSlice
f	1462	\N	(0021,"SIEMENS CT VA0  GEN",4a)	IS	1	VOIStopSlice
f	1463	\N	(0021,"SIEMENS CT VA0  GEN",50)	IS	1	VectorStartRow
f	1464	\N	(0021,"SIEMENS CT VA0  GEN",51)	IS	1	VectorRowStep
f	1465	\N	(0021,"SIEMENS CT VA0  GEN",52)	IS	1	VectorStartColumn
f	1466	\N	(0021,"SIEMENS CT VA0  GEN",53)	IS	1	VectorColumnStep
f	1467	\N	(0021,"SIEMENS CT VA0  GEN",60)	IS	1	RangeTypeCode
f	1468	\N	(0021,"SIEMENS CT VA0  GEN",62)	IS	1	ReferenceTypeCode
f	1469	\N	(0021,"SIEMENS CT VA0  GEN",70)	DS	3	ObjectOrientation
f	1470	\N	(0021,"SIEMENS CT VA0  GEN",72)	DS	3	LightOrientation
f	1471	\N	(0021,"SIEMENS CT VA0  GEN",75)	DS	1	LightBrightness
f	1472	\N	(0021,"SIEMENS CT VA0  GEN",76)	DS	1	LightContrast
f	1473	\N	(0021,"SIEMENS CT VA0  GEN",7a)	IS	2	OverlayThreshold
f	1474	\N	(0021,"SIEMENS CT VA0  GEN",7b)	IS	2	SurfaceThreshold
f	1475	\N	(0021,"SIEMENS CT VA0  GEN",7c)	IS	2	GreyScaleThreshold
f	1476	\N	(0021,"SIEMENS CT VA0  GEN",a0)	DS	1	Unknown
f	1477	\N	(0021,"SIEMENS CT VA0  GEN",a2)	LT	1	Unknown
f	1478	\N	(0021,"SIEMENS CT VA0  GEN",a7)	LT	1	Unknown
f	1479	\N	(0009,"SIEMENS CT VA0  IDE",10)	LT	1	Unknown
f	1480	\N	(0009,"SIEMENS CT VA0  IDE",30)	LT	1	Unknown
f	1481	\N	(0009,"SIEMENS CT VA0  IDE",31)	LT	1	Unknown
f	1482	\N	(0009,"SIEMENS CT VA0  IDE",32)	LT	1	Unknown
f	1483	\N	(0009,"SIEMENS CT VA0  IDE",34)	LT	1	Unknown
f	1484	\N	(0009,"SIEMENS CT VA0  IDE",40)	LT	1	Unknown
f	1485	\N	(0009,"SIEMENS CT VA0  IDE",42)	LT	1	Unknown
f	1486	\N	(0009,"SIEMENS CT VA0  IDE",50)	LT	1	Unknown
f	1487	\N	(0009,"SIEMENS CT VA0  IDE",51)	LT	1	Unknown
f	1488	\N	(0009,"SIEMENS CT VA0  ORI",20)	LT	1	Unknown
f	1489	\N	(0009,"SIEMENS CT VA0  ORI",30)	LT	1	Unknown
f	1490	\N	(6021,"SIEMENS CT VA0  OST",00)	LT	1	OsteoContourComment
f	1491	\N	(6021,"SIEMENS CT VA0  OST",10)	US	256	OsteoContourBuffer
f	1492	\N	(0021,"SIEMENS CT VA0  RAW",10)	UL	2	CreationMask
f	1493	\N	(0021,"SIEMENS CT VA0  RAW",20)	UL	2	EvaluationMask
f	1494	\N	(0021,"SIEMENS CT VA0  RAW",30)	US	7	ExtendedProcessingMask
f	1495	\N	(0021,"SIEMENS CT VA0  RAW",40)	US	1-n	Unknown
f	1496	\N	(0021,"SIEMENS CT VA0  RAW",41)	US	1-n	Unknown
f	1497	\N	(0021,"SIEMENS CT VA0  RAW",42)	US	1-n	Unknown
f	1498	\N	(0021,"SIEMENS CT VA0  RAW",43)	US	1-n	Unknown
f	1499	\N	(0021,"SIEMENS CT VA0  RAW",44)	US	1-n	Unknown
f	1500	\N	(0021,"SIEMENS CT VA0  RAW",50)	LT	1	Unknown
f	1501	\N	(0009,"SIEMENS DICOM",10)	UN	1	Unknown
f	1502	\N	(0009,"SIEMENS DICOM",12)	LT	1	Unknown
f	1503	\N	(0019,"SIEMENS DLR.01",10)	LT	1	MeasurementMode
f	1504	\N	(0019,"SIEMENS DLR.01",11)	LT	1	ImageType
f	1505	\N	(0019,"SIEMENS DLR.01",15)	LT	1	SoftwareVersion
f	1506	\N	(0019,"SIEMENS DLR.01",20)	LT	1	MPMCode
f	1507	\N	(0019,"SIEMENS DLR.01",21)	LT	1	Latitude
f	1508	\N	(0019,"SIEMENS DLR.01",22)	LT	1	Sensitivity
f	1509	\N	(0019,"SIEMENS DLR.01",23)	LT	1	EDR
f	1510	\N	(0019,"SIEMENS DLR.01",24)	LT	1	LFix
f	1511	\N	(0019,"SIEMENS DLR.01",25)	LT	1	SFix
f	1512	\N	(0019,"SIEMENS DLR.01",26)	LT	1	PresetMode
f	1513	\N	(0019,"SIEMENS DLR.01",27)	LT	1	Region
f	1514	\N	(0019,"SIEMENS DLR.01",28)	LT	1	Subregion
f	1515	\N	(0019,"SIEMENS DLR.01",30)	LT	1	Orientation
f	1516	\N	(0019,"SIEMENS DLR.01",31)	LT	1	MarkOnFilm
f	1517	\N	(0019,"SIEMENS DLR.01",32)	LT	1	RotationOnDRC
f	1518	\N	(0019,"SIEMENS DLR.01",40)	LT	1	ReaderType
f	1519	\N	(0019,"SIEMENS DLR.01",41)	LT	1	SubModality
f	1520	\N	(0019,"SIEMENS DLR.01",42)	LT	1	ReaderSerialNumber
f	1521	\N	(0019,"SIEMENS DLR.01",50)	LT	1	CassetteScale
f	1522	\N	(0019,"SIEMENS DLR.01",51)	LT	1	CassetteMatrix
f	1523	\N	(0019,"SIEMENS DLR.01",52)	LT	1	CassetteSubmatrix
f	1524	\N	(0019,"SIEMENS DLR.01",53)	LT	1	Barcode
f	1525	\N	(0019,"SIEMENS DLR.01",60)	LT	1	ContrastType
f	1526	\N	(0019,"SIEMENS DLR.01",61)	LT	1	RotationAmount
f	1527	\N	(0019,"SIEMENS DLR.01",62)	LT	1	RotationCenter
f	1528	\N	(0019,"SIEMENS DLR.01",63)	LT	1	DensityShift
f	1529	\N	(0019,"SIEMENS DLR.01",64)	US	1	FrequencyRank
f	1530	\N	(0019,"SIEMENS DLR.01",65)	LT	1	FrequencyEnhancement
f	1531	\N	(0019,"SIEMENS DLR.01",66)	LT	1	FrequencyType
f	1532	\N	(0019,"SIEMENS DLR.01",67)	LT	1	KernelLength
f	1533	\N	(0019,"SIEMENS DLR.01",68)	UL	1	KernelMode
f	1534	\N	(0019,"SIEMENS DLR.01",69)	UL	1	ConvolutionMode
f	1535	\N	(0019,"SIEMENS DLR.01",70)	LT	1	PLASource
f	1536	\N	(0019,"SIEMENS DLR.01",71)	LT	1	PLADestination
f	1537	\N	(0019,"SIEMENS DLR.01",75)	LT	1	UIDOriginalImage
f	1538	\N	(0019,"SIEMENS DLR.01",76)	LT	1	Unknown
f	1539	\N	(0019,"SIEMENS DLR.01",80)	LT	1	ReaderHeader
f	1540	\N	(0019,"SIEMENS DLR.01",90)	LT	1	PLAOfSecondaryDestination
f	1541	\N	(0019,"SIEMENS DLR.01",a0)	DS	1	Unknown
f	1542	\N	(0019,"SIEMENS DLR.01",a1)	DS	1	Unknown
f	1543	\N	(0041,"SIEMENS DLR.01",10)	US	1	NumberOfHardcopies
f	1544	\N	(0041,"SIEMENS DLR.01",20)	LT	1	FilmFormat
f	1545	\N	(0041,"SIEMENS DLR.01",30)	LT	1	FilmSize
f	1546	\N	(0041,"SIEMENS DLR.01",31)	LT	1	FullFilmFormat
f	1547	\N	(0003,"SIEMENS ISI",08)	US	1	ISICommandField
f	1548	\N	(0003,"SIEMENS ISI",11)	US	1	AttachIDApplicationCode
f	1549	\N	(0003,"SIEMENS ISI",12)	UL	1	AttachIDMessageCount
f	1550	\N	(0003,"SIEMENS ISI",13)	DA	1	AttachIDDate
f	1551	\N	(0003,"SIEMENS ISI",14)	TM	1	AttachIDTime
f	1552	\N	(0003,"SIEMENS ISI",20)	US	1	MessageType
f	1553	\N	(0003,"SIEMENS ISI",30)	DA	1	MaxWaitingDate
f	1554	\N	(0003,"SIEMENS ISI",31)	TM	1	MaxWaitingTime
f	1555	\N	(0009,"SIEMENS ISI",01)	UN	1	RISPatientInfoIMGEF
f	1556	\N	(0011,"SIEMENS ISI",03)	LT	1	PatientUID
f	1557	\N	(0011,"SIEMENS ISI",04)	LT	1	PatientID
f	1558	\N	(0011,"SIEMENS ISI",0a)	LT	1	CaseID
f	1559	\N	(0011,"SIEMENS ISI",22)	LT	1	RequestID
f	1560	\N	(0011,"SIEMENS ISI",23)	LT	1	ExaminationUID
f	1561	\N	(0011,"SIEMENS ISI",a1)	DA	1	PatientRegistrationDate
f	1562	\N	(0011,"SIEMENS ISI",a2)	TM	1	PatientRegistrationTime
f	1563	\N	(0011,"SIEMENS ISI",b0)	LT	1	PatientLastName
f	1564	\N	(0011,"SIEMENS ISI",b2)	LT	1	PatientFirstName
f	1565	\N	(0011,"SIEMENS ISI",b4)	LT	1	PatientHospitalStatus
f	1566	\N	(0011,"SIEMENS ISI",bc)	TM	1	CurrentLocationTime
f	1567	\N	(0011,"SIEMENS ISI",c0)	LT	1	PatientInsuranceStatus
f	1568	\N	(0011,"SIEMENS ISI",d0)	LT	1	PatientBillingType
f	1569	\N	(0011,"SIEMENS ISI",d2)	LT	1	PatientBillingAddress
f	1570	\N	(0031,"SIEMENS ISI",12)	LT	1	ExaminationReason
f	1571	\N	(0031,"SIEMENS ISI",30)	DA	1	RequestedDate
f	1572	\N	(0031,"SIEMENS ISI",32)	TM	1	WorklistRequestStartTime
f	1573	\N	(0031,"SIEMENS ISI",33)	TM	1	WorklistRequestEndTime
f	1574	\N	(0031,"SIEMENS ISI",4a)	TM	1	RequestedTime
f	1575	\N	(0031,"SIEMENS ISI",80)	LT	1	RequestedLocation
f	1576	\N	(0055,"SIEMENS ISI",46)	LT	1	CurrentWard
f	1577	\N	(0193,"SIEMENS ISI",02)	DS	1	RISKey
f	1578	\N	(0307,"SIEMENS ISI",01)	UN	1	RISWorklistIMGEF
f	1579	\N	(0309,"SIEMENS ISI",01)	UN	1	RISReportIMGEF
f	1580	\N	(4009,"SIEMENS ISI",01)	LT	1	ReportID
f	1581	\N	(4009,"SIEMENS ISI",20)	LT	1	ReportStatus
f	1582	\N	(4009,"SIEMENS ISI",30)	DA	1	ReportCreationDate
f	1583	\N	(4009,"SIEMENS ISI",70)	LT	1	ReportApprovingPhysician
f	1584	\N	(4009,"SIEMENS ISI",e0)	LT	1	ReportText
f	1585	\N	(4009,"SIEMENS ISI",e1)	LT	1	ReportAuthor
f	1586	\N	(4009,"SIEMENS ISI",e3)	LT	1	ReportingRadiologist
f	1587	\N	(0029,"SIEMENS MED DISPLAY",04)	LT	1	PhotometricInterpretation
f	1588	\N	(0029,"SIEMENS MED DISPLAY",10)	US	1	RowsOfSubmatrix
f	1589	\N	(0029,"SIEMENS MED DISPLAY",11)	US	1	ColumnsOfSubmatrix
f	1590	\N	(0029,"SIEMENS MED DISPLAY",20)	US	1	Unknown
f	1591	\N	(0029,"SIEMENS MED DISPLAY",21)	US	1	Unknown
f	1592	\N	(0029,"SIEMENS MED DISPLAY",50)	US	1	OriginOfSubmatrix
f	1593	\N	(0029,"SIEMENS MED DISPLAY",99)	LT	1	ShutterType
f	1594	\N	(0029,"SIEMENS MED DISPLAY",a0)	US	1	RowsOfRectangularShutter
f	1595	\N	(0029,"SIEMENS MED DISPLAY",a1)	US	1	ColumnsOfRectangularShutter
f	1596	\N	(0029,"SIEMENS MED DISPLAY",a2)	US	1	OriginOfRectangularShutter
f	1597	\N	(0029,"SIEMENS MED DISPLAY",b0)	US	1	RadiusOfCircularShutter
f	1598	\N	(0029,"SIEMENS MED DISPLAY",b2)	US	1	OriginOfCircularShutter
f	1599	\N	(0029,"SIEMENS MED DISPLAY",c1)	US	1	ContourOfIrregularShutter
f	1600	\N	(0029,"SIEMENS MED HG",10)	US	1	ListOfGroupNumbers
f	1601	\N	(0029,"SIEMENS MED HG",15)	LT	1	ListOfShadowOwnerCodes
f	1602	\N	(0029,"SIEMENS MED HG",20)	US	1	ListOfElementNumbers
f	1603	\N	(0029,"SIEMENS MED HG",30)	US	1	ListOfTotalDisplayLength
f	1604	\N	(0029,"SIEMENS MED HG",40)	LT	1	ListOfDisplayPrefix
f	1605	\N	(0029,"SIEMENS MED HG",50)	LT	1	ListOfDisplayPostfix
f	1606	\N	(0029,"SIEMENS MED HG",60)	US	1	ListOfTextPosition
f	1607	\N	(0029,"SIEMENS MED HG",70)	LT	1	ListOfTextConcatenation
f	1608	\N	(0029,"SIEMENS MED MG",10)	US	1	ListOfGroupNumbers
f	1609	\N	(0029,"SIEMENS MED MG",15)	LT	1	ListOfShadowOwnerCodes
f	1610	\N	(0029,"SIEMENS MED MG",20)	US	1	ListOfElementNumbers
f	1611	\N	(0029,"SIEMENS MED MG",30)	US	1	ListOfTotalDisplayLength
f	1612	\N	(0029,"SIEMENS MED MG",40)	LT	1	ListOfDisplayPrefix
f	1613	\N	(0029,"SIEMENS MED MG",50)	LT	1	ListOfDisplayPostfix
f	1614	\N	(0029,"SIEMENS MED MG",60)	US	1	ListOfTextPosition
f	1615	\N	(0029,"SIEMENS MED MG",70)	LT	1	ListOfTextConcatenation
f	1616	\N	(0009,"SIEMENS MED",10)	LO	1	RecognitionCode
f	1617	\N	(0009,"SIEMENS MED",30)	UL	1	ByteOffsetOfOriginalHeader
f	1618	\N	(0009,"SIEMENS MED",31)	UL	1	LengthOfOriginalHeader
f	1619	\N	(0009,"SIEMENS MED",40)	UL	1	ByteOffsetOfPixelmatrix
f	1620	\N	(0009,"SIEMENS MED",41)	UL	1	LengthOfPixelmatrixInBytes
f	1621	\N	(0009,"SIEMENS MED",50)	LT	1	Unknown
f	1622	\N	(0009,"SIEMENS MED",51)	LT	1	Unknown
f	1623	\N	(0009,"SIEMENS MED",f5)	LT	1	PDMEFIDPlaceholder
f	1624	\N	(0009,"SIEMENS MED",f6)	LT	1	PDMDataObjectTypeExtension
f	1625	\N	(0021,"SIEMENS MED",10)	DS	1	Zoom
f	1626	\N	(0021,"SIEMENS MED",11)	DS	2	Target
f	1627	\N	(0021,"SIEMENS MED",12)	IS	1	TubeAngle
f	1628	\N	(0021,"SIEMENS MED",20)	US	1	ROIMask
f	1629	\N	(7001,"SIEMENS MED",10)	LT	1	Dummy
f	1630	\N	(7003,"SIEMENS MED",10)	LT	1	Header
f	1631	\N	(7005,"SIEMENS MED",10)	LT	1	Dummy
f	1632	\N	(0029,"SIEMENS MEDCOM HEADER",08)	CS	1	MedComHeaderType
f	1633	\N	(0029,"SIEMENS MEDCOM HEADER",09)	LO	1	MedComHeaderVersion
f	1634	\N	(0029,"SIEMENS MEDCOM HEADER",10)	OB	1	MedComHeaderInfo
f	1635	\N	(0029,"SIEMENS MEDCOM HEADER",20)	OB	1	MedComHistoryInformation
f	1636	\N	(0029,"SIEMENS MEDCOM HEADER",31)	LO	1	PMTFInformation1
f	1637	\N	(0029,"SIEMENS MEDCOM HEADER",32)	UL	1	PMTFInformation2
f	1638	\N	(0029,"SIEMENS MEDCOM HEADER",33)	UL	1	PMTFInformation3
f	1639	\N	(0029,"SIEMENS MEDCOM HEADER",34)	CS	1	PMTFInformation4
f	1640	\N	(0029,"SIEMENS MEDCOM HEADER",35)	UL	1	PMTFInformation5
f	1641	\N	(0029,"SIEMENS MEDCOM HEADER",40)	SQ	1	ApplicationHeaderSequence
f	1642	\N	(0029,"SIEMENS MEDCOM HEADER",41)	CS	1	ApplicationHeaderType
f	1643	\N	(0029,"SIEMENS MEDCOM HEADER",42)	LO	1	ApplicationHeaderID
f	1644	\N	(0029,"SIEMENS MEDCOM HEADER",43)	LO	1	ApplicationHeaderVersion
f	1645	\N	(0029,"SIEMENS MEDCOM HEADER",44)	OB	1	ApplicationHeaderInfo
f	1646	\N	(0029,"SIEMENS MEDCOM HEADER",50)	LO	8	WorkflowControlFlags
f	1647	\N	(0029,"SIEMENS MEDCOM HEADER",51)	CS	1	ArchiveManagementFlagKeepOnline
f	1648	\N	(0029,"SIEMENS MEDCOM HEADER",52)	CS	1	ArchiveManagementFlagDoNotArchive
f	1649	\N	(0029,"SIEMENS MEDCOM HEADER",53)	CS	1	ImageLocationStatus
f	1650	\N	(0029,"SIEMENS MEDCOM HEADER",54)	DS	1	EstimatedRetrieveTime
f	1651	\N	(0029,"SIEMENS MEDCOM HEADER",55)	DS	1	DataSizeOfRetrievedImages
f	1652	\N	(0029,"SIEMENS MEDCOM HEADER2",60)	LO	1	SeriesWorkflowStatus
f	1653	\N	(0029,"SIEMENS MEDCOM OOG",08)	CS	1	MEDCOMOOGType
f	1654	\N	(0029,"SIEMENS MEDCOM OOG",09)	LO	1	MEDCOMOOGVersion
f	1655	\N	(0029,"SIEMENS MEDCOM OOG",10)	OB	1	MEDCOMOOGInfo
f	1656	\N	(0019,"SIEMENS MR VA0  COAD",12)	DS	1	MagneticFieldStrength
f	1657	\N	(0019,"SIEMENS MR VA0  COAD",14)	DS	1	ADCVoltage
f	1658	\N	(0019,"SIEMENS MR VA0  COAD",16)	DS	2	ADCOffset
f	1659	\N	(0019,"SIEMENS MR VA0  COAD",20)	DS	1	TransmitterAmplitude
f	1660	\N	(0019,"SIEMENS MR VA0  COAD",21)	IS	1	NumberOfTransmitterAmplitudes
f	1661	\N	(0019,"SIEMENS MR VA0  COAD",22)	DS	1	TransmitterAttenuator
f	1662	\N	(0019,"SIEMENS MR VA0  COAD",24)	DS	1	TransmitterCalibration
f	1663	\N	(0019,"SIEMENS MR VA0  COAD",26)	DS	1	TransmitterReference
f	1664	\N	(0019,"SIEMENS MR VA0  COAD",50)	DS	1	ReceiverTotalGain
f	1665	\N	(0019,"SIEMENS MR VA0  COAD",51)	DS	1	ReceiverAmplifierGain
f	1666	\N	(0019,"SIEMENS MR VA0  COAD",52)	DS	1	ReceiverPreamplifierGain
f	1667	\N	(0019,"SIEMENS MR VA0  COAD",54)	DS	1	ReceiverCableAttenuation
f	1668	\N	(0019,"SIEMENS MR VA0  COAD",55)	DS	1	ReceiverReferenceGain
f	1669	\N	(0019,"SIEMENS MR VA0  COAD",56)	DS	1	ReceiverFilterFrequency
f	1670	\N	(0019,"SIEMENS MR VA0  COAD",60)	DS	1	ReconstructionScaleFactor
f	1671	\N	(0019,"SIEMENS MR VA0  COAD",62)	DS	1	ReferenceScaleFactor
f	1672	\N	(0019,"SIEMENS MR VA0  COAD",70)	DS	1	PhaseGradientAmplitude
f	1673	\N	(0019,"SIEMENS MR VA0  COAD",71)	DS	1	ReadoutGradientAmplitude
f	1674	\N	(0019,"SIEMENS MR VA0  COAD",72)	DS	1	SelectionGradientAmplitude
f	1675	\N	(0019,"SIEMENS MR VA0  COAD",80)	DS	3	GradientDelayTime
f	1676	\N	(0019,"SIEMENS MR VA0  COAD",82)	DS	1	TotalGradientDelayTime
f	1677	\N	(0019,"SIEMENS MR VA0  COAD",90)	LT	1	SensitivityCorrectionLabel
f	1678	\N	(0019,"SIEMENS MR VA0  COAD",91)	DS	6	SaturationPhaseEncodingVectorCoronalComponent
f	1679	\N	(0019,"SIEMENS MR VA0  COAD",92)	DS	6	SaturationReadoutVectorCoronalComponent
f	1680	\N	(0019,"SIEMENS MR VA0  COAD",a0)	US	3	RFWatchdogMask
f	1681	\N	(0019,"SIEMENS MR VA0  COAD",a1)	DS	1	EPIReconstructionSlope
f	1682	\N	(0019,"SIEMENS MR VA0  COAD",a2)	DS	1	RFPowerErrorIndicator
f	1683	\N	(0019,"SIEMENS MR VA0  COAD",a5)	DS	3	SpecificAbsorptionRateWholeBody
f	1684	\N	(0019,"SIEMENS MR VA0  COAD",a6)	DS	3	SpecificEnergyDose
f	1685	\N	(0019,"SIEMENS MR VA0  COAD",b0)	UL	1	AdjustmentStatusMask
f	1686	\N	(0019,"SIEMENS MR VA0  COAD",c1)	DS	6	EPICapacity
f	1687	\N	(0019,"SIEMENS MR VA0  COAD",c2)	DS	3	EPIInductance
f	1688	\N	(0019,"SIEMENS MR VA0  COAD",c3)	IS	1-n	EPISwitchConfigurationCode
f	1689	\N	(0019,"SIEMENS MR VA0  COAD",c4)	IS	1-n	EPISwitchHardwareCode
f	1690	\N	(0019,"SIEMENS MR VA0  COAD",c5)	DS	1-n	EPISwitchDelayTime
f	1691	\N	(0019,"SIEMENS MR VA0  COAD",d1)	DS	1	FlowSensitivity
f	1692	\N	(0019,"SIEMENS MR VA0  COAD",d2)	LT	1	CalculationSubmode
f	1693	\N	(0019,"SIEMENS MR VA0  COAD",d3)	DS	1	FieldOfViewRatio
f	1694	\N	(0019,"SIEMENS MR VA0  COAD",d4)	IS	1	BaseRawMatrixSize
f	1695	\N	(0019,"SIEMENS MR VA0  COAD",d5)	IS	1	2DOversamplingLines
f	1696	\N	(0019,"SIEMENS MR VA0  COAD",d6)	IS	1	3DPhaseOversamplingPartitions
f	1697	\N	(0019,"SIEMENS MR VA0  COAD",d7)	IS	1	EchoLinePosition
f	1698	\N	(0019,"SIEMENS MR VA0  COAD",d8)	IS	1	EchoColumnPosition
f	1699	\N	(0019,"SIEMENS MR VA0  COAD",d9)	IS	1	LinesPerSegment
f	1700	\N	(0019,"SIEMENS MR VA0  COAD",da)	LT	1	PhaseCodingDirection
f	1701	\N	(0019,"SIEMENS MR VA0  GEN",10)	DS	1	TotalMeasurementTimeNominal
f	1702	\N	(0019,"SIEMENS MR VA0  GEN",11)	DS	1	TotalMeasurementTimeCurrent
f	1703	\N	(0019,"SIEMENS MR VA0  GEN",12)	DS	1	StartDelayTime
f	1704	\N	(0019,"SIEMENS MR VA0  GEN",13)	DS	1	DwellTime
f	1705	\N	(0019,"SIEMENS MR VA0  GEN",14)	IS	1	NumberOfPhases
f	1706	\N	(0019,"SIEMENS MR VA0  GEN",16)	UL	2	SequenceControlMask
f	1707	\N	(0019,"SIEMENS MR VA0  GEN",18)	UL	1	MeasurementStatusMask
f	1708	\N	(0019,"SIEMENS MR VA0  GEN",20)	IS	1	NumberOfFourierLinesNominal
f	1709	\N	(0019,"SIEMENS MR VA0  GEN",21)	IS	1	NumberOfFourierLinesCurrent
f	1710	\N	(0019,"SIEMENS MR VA0  GEN",26)	IS	1	NumberOfFourierLinesAfterZero
f	1711	\N	(0019,"SIEMENS MR VA0  GEN",28)	IS	1	FirstMeasuredFourierLine
f	1712	\N	(0019,"SIEMENS MR VA0  GEN",30)	IS	1	AcquisitionColumns
f	1713	\N	(0019,"SIEMENS MR VA0  GEN",31)	IS	1	ReconstructionColumns
f	1714	\N	(0019,"SIEMENS MR VA0  GEN",40)	IS	1	ArrayCoilElementNumber
f	1715	\N	(0019,"SIEMENS MR VA0  GEN",41)	UL	1	ArrayCoilElementSelectMask
f	1716	\N	(0019,"SIEMENS MR VA0  GEN",42)	UL	1	ArrayCoilElementDataMask
f	1717	\N	(0019,"SIEMENS MR VA0  GEN",43)	IS	1-n	ArrayCoilElementToADCConnect
f	1718	\N	(0019,"SIEMENS MR VA0  GEN",44)	DS	1-n	ArrayCoilElementNoiseLevel
f	1719	\N	(0019,"SIEMENS MR VA0  GEN",45)	IS	1	ArrayCoilADCPairNumber
f	1720	\N	(0019,"SIEMENS MR VA0  GEN",46)	UL	1	ArrayCoilCombinationMask
f	1721	\N	(0019,"SIEMENS MR VA0  GEN",50)	IS	1	NumberOfAverages
f	1722	\N	(0019,"SIEMENS MR VA0  GEN",60)	DS	1	FlipAngle
f	1723	\N	(0019,"SIEMENS MR VA0  GEN",70)	IS	1	NumberOfPrescans
f	1724	\N	(0019,"SIEMENS MR VA0  GEN",81)	LT	1	FilterTypeForRawData
f	1725	\N	(0019,"SIEMENS MR VA0  GEN",82)	DS	1-n	FilterParameterForRawData
f	1726	\N	(0019,"SIEMENS MR VA0  GEN",83)	LT	1	FilterTypeForImageData
f	1727	\N	(0019,"SIEMENS MR VA0  GEN",84)	DS	1-n	FilterParameterForImageData
f	1728	\N	(0019,"SIEMENS MR VA0  GEN",85)	LT	1	FilterTypeForPhaseCorrection
f	1729	\N	(0019,"SIEMENS MR VA0  GEN",86)	DS	1-n	FilterParameterForPhaseCorrection
f	1730	\N	(0019,"SIEMENS MR VA0  GEN",87)	LT	1	NormalizationFilterTypeForImageData
f	1731	\N	(0019,"SIEMENS MR VA0  GEN",88)	DS	1-n	NormalizationFilterParameterForImageData
f	1732	\N	(0019,"SIEMENS MR VA0  GEN",90)	IS	1	NumberOfSaturationRegions
f	1733	\N	(0019,"SIEMENS MR VA0  GEN",91)	DS	6	SaturationPhaseEncodingVectorSagittalComponent
f	1734	\N	(0019,"SIEMENS MR VA0  GEN",92)	DS	6	SaturationReadoutVectorSagittalComponent
f	1735	\N	(0019,"SIEMENS MR VA0  GEN",93)	DS	1	EPIStimulationMonitorMode
f	1736	\N	(0019,"SIEMENS MR VA0  GEN",94)	DS	1	ImageRotationAngle
f	1737	\N	(0019,"SIEMENS MR VA0  GEN",96)	UL	3	CoilIDMask
f	1738	\N	(0019,"SIEMENS MR VA0  GEN",97)	UL	2	CoilClassMask
f	1739	\N	(0019,"SIEMENS MR VA0  GEN",98)	DS	3	CoilPosition
f	1740	\N	(0019,"SIEMENS MR VA0  GEN",a0)	DS	1	EPIReconstructionPhase
f	1741	\N	(0019,"SIEMENS MR VA0  GEN",a1)	DS	1	EPIReconstructionSlope
f	1742	\N	(0021,"SIEMENS MR VA0  GEN",20)	IS	1	PhaseCorrectionRowsSequence
f	1743	\N	(0021,"SIEMENS MR VA0  GEN",21)	IS	1	PhaseCorrectionColumnsSequence
f	1744	\N	(0021,"SIEMENS MR VA0  GEN",22)	IS	1	PhaseCorrectionRowsReconstruction
f	1745	\N	(0021,"SIEMENS MR VA0  GEN",24)	IS	1	PhaseCorrectionColumnsReconstruction
f	1746	\N	(0021,"SIEMENS MR VA0  GEN",30)	IS	1	NumberOf3DRawPartitionsNominal
f	1747	\N	(0021,"SIEMENS MR VA0  GEN",31)	IS	1	NumberOf3DRawPartitionsCurrent
f	1748	\N	(0021,"SIEMENS MR VA0  GEN",34)	IS	1	NumberOf3DImagePartitions
f	1749	\N	(0021,"SIEMENS MR VA0  GEN",36)	IS	1	Actual3DImagePartitionNumber
f	1750	\N	(0021,"SIEMENS MR VA0  GEN",39)	DS	1	SlabThickness
f	1751	\N	(0021,"SIEMENS MR VA0  GEN",40)	IS	1	NumberOfSlicesNominal
f	1752	\N	(0021,"SIEMENS MR VA0  GEN",41)	IS	1	NumberOfSlicesCurrent
f	1753	\N	(0021,"SIEMENS MR VA0  GEN",42)	IS	1	CurrentSliceNumber
f	1754	\N	(0021,"SIEMENS MR VA0  GEN",43)	IS	1	CurrentGroupNumber
f	1755	\N	(0021,"SIEMENS MR VA0  GEN",44)	DS	1	CurrentSliceDistanceFactor
f	1756	\N	(0021,"SIEMENS MR VA0  GEN",45)	IS	1	MIPStartRow
f	1757	\N	(0021,"SIEMENS MR VA0  GEN",46)	IS	1	MIPStopRow
f	1758	\N	(0021,"SIEMENS MR VA0  GEN",47)	IS	1	MIPStartColumn
f	1759	\N	(0021,"SIEMENS MR VA0  GEN",48)	IS	1	MIPStartColumn
f	1760	\N	(0021,"SIEMENS MR VA0  GEN",49)	IS	1	MIPStartSlice Name=
f	1761	\N	(0021,"SIEMENS MR VA0  GEN",4a)	IS	1	MIPStartSlice
f	1762	\N	(0021,"SIEMENS MR VA0  GEN",4f)	LT	1	OrderofSlices
f	1763	\N	(0021,"SIEMENS MR VA0  GEN",50)	US	1	SignalMask
f	1764	\N	(0021,"SIEMENS MR VA0  GEN",52)	DS	1	DelayAfterTrigger
f	1765	\N	(0021,"SIEMENS MR VA0  GEN",53)	IS	1	RRInterval
f	1766	\N	(0021,"SIEMENS MR VA0  GEN",54)	DS	1	NumberOfTriggerPulses
f	1767	\N	(0021,"SIEMENS MR VA0  GEN",56)	DS	1	RepetitionTimeEffective
f	1768	\N	(0021,"SIEMENS MR VA0  GEN",57)	LT	1	GatePhase
f	1769	\N	(0021,"SIEMENS MR VA0  GEN",58)	DS	1	GateThreshold
f	1770	\N	(0021,"SIEMENS MR VA0  GEN",59)	DS	1	GatedRatio
f	1771	\N	(0021,"SIEMENS MR VA0  GEN",60)	IS	1	NumberOfInterpolatedImages
f	1772	\N	(0021,"SIEMENS MR VA0  GEN",70)	IS	1	NumberOfEchoes
f	1773	\N	(0021,"SIEMENS MR VA0  GEN",72)	DS	1	SecondEchoTime
f	1774	\N	(0021,"SIEMENS MR VA0  GEN",73)	DS	1	SecondRepetitionTime
f	1775	\N	(0021,"SIEMENS MR VA0  GEN",80)	IS	1	CardiacCode
f	1776	\N	(0021,"SIEMENS MR VA0  GEN",91)	DS	6	SaturationPhaseEncodingVectorTransverseComponent
f	1777	\N	(0021,"SIEMENS MR VA0  GEN",92)	DS	6	SaturationReadoutVectorTransverseComponent
f	1778	\N	(0021,"SIEMENS MR VA0  GEN",93)	DS	1	EPIChangeValueOfMagnitude
f	1779	\N	(0021,"SIEMENS MR VA0  GEN",94)	DS	1	EPIChangeValueOfXComponent
f	1780	\N	(0021,"SIEMENS MR VA0  GEN",95)	DS	1	EPIChangeValueOfYComponent
f	1781	\N	(0021,"SIEMENS MR VA0  GEN",96)	DS	1	EPIChangeValueOfZComponent
f	1782	\N	(0021,"SIEMENS MR VA0  RAW",00)	LT	1	SequenceType
f	1783	\N	(0021,"SIEMENS MR VA0  RAW",01)	IS	1	VectorSizeOriginal
f	1784	\N	(0021,"SIEMENS MR VA0  RAW",02)	IS	1	VectorSizeExtended
f	1785	\N	(0021,"SIEMENS MR VA0  RAW",03)	DS	1	AcquiredSpectralRange
f	1786	\N	(0021,"SIEMENS MR VA0  RAW",04)	DS	3	VOIPosition
f	1787	\N	(0021,"SIEMENS MR VA0  RAW",05)	DS	3	VOISize
f	1788	\N	(0021,"SIEMENS MR VA0  RAW",06)	IS	3	CSIMatrixSizeOriginal
f	1789	\N	(0021,"SIEMENS MR VA0  RAW",07)	IS	3	CSIMatrixSizeExtended
f	1790	\N	(0021,"SIEMENS MR VA0  RAW",08)	DS	3	SpatialGridShift
f	1791	\N	(0021,"SIEMENS MR VA0  RAW",09)	DS	1	SignalLimitsMinimum
f	1792	\N	(0021,"SIEMENS MR VA0  RAW",10)	DS	1	SignalLimitsMaximum
f	1793	\N	(0021,"SIEMENS MR VA0  RAW",11)	DS	1	SpecInfoMask
f	1794	\N	(0021,"SIEMENS MR VA0  RAW",12)	DS	1	EPITimeRateOfChangeOfMagnitude
f	1795	\N	(0021,"SIEMENS MR VA0  RAW",13)	DS	1	EPITimeRateOfChangeOfXComponent
f	1796	\N	(0021,"SIEMENS MR VA0  RAW",14)	DS	1	EPITimeRateOfChangeOfYComponent
f	1797	\N	(0021,"SIEMENS MR VA0  RAW",15)	DS	1	EPITimeRateOfChangeOfZComponent
f	1798	\N	(0021,"SIEMENS MR VA0  RAW",16)	DS	1	EPITimeRateOfChangeLegalLimit1
f	1799	\N	(0021,"SIEMENS MR VA0  RAW",17)	DS	1	EPIOperationModeFlag
f	1800	\N	(0021,"SIEMENS MR VA0  RAW",18)	DS	1	EPIFieldCalculationSafetyFactor
f	1801	\N	(0021,"SIEMENS MR VA0  RAW",19)	DS	1	EPILegalLimit1OfChangeValue
f	1802	\N	(0021,"SIEMENS MR VA0  RAW",20)	DS	1	EPILegalLimit2OfChangeValue
f	1803	\N	(0021,"SIEMENS MR VA0  RAW",21)	DS	1	EPIRiseTime
f	1804	\N	(0021,"SIEMENS MR VA0  RAW",30)	DS	16	ArrayCoilADCOffset
f	1805	\N	(0021,"SIEMENS MR VA0  RAW",31)	DS	16	ArrayCoilPreamplifierGain
f	1806	\N	(0021,"SIEMENS MR VA0  RAW",50)	LT	1	SaturationType
f	1807	\N	(0021,"SIEMENS MR VA0  RAW",51)	DS	3	SaturationNormalVector
f	1808	\N	(0021,"SIEMENS MR VA0  RAW",52)	DS	3	SaturationPositionVector
f	1809	\N	(0021,"SIEMENS MR VA0  RAW",53)	DS	6	SaturationThickness
f	1810	\N	(0021,"SIEMENS MR VA0  RAW",54)	DS	6	SaturationWidth
f	1811	\N	(0021,"SIEMENS MR VA0  RAW",55)	DS	6	SaturationDistance
f	1812	\N	(7fe3,"SIEMENS NUMARIS II",00)	LT	1	ImageGraphicsFormatCode
f	1813	\N	(7fe3,"SIEMENS NUMARIS II",10)	OB	1	ImageGraphics
f	1814	\N	(7fe3,"SIEMENS NUMARIS II",20)	OB	1	ImageGraphicsDummy
f	1815	\N	(0011,"SIEMENS RA GEN",20)	SL	1	FluoroTimer
f	1816	\N	(0011,"SIEMENS RA GEN",25)	SL	1	PtopDoseAreaProduct
f	1817	\N	(0011,"SIEMENS RA GEN",26)	SL	1	PtopTotalSkinDose
f	1818	\N	(0011,"SIEMENS RA GEN",30)	LT	1	Unknown
f	1819	\N	(0011,"SIEMENS RA GEN",35)	LO	1	PatientInitialPuckCounter
f	1820	\N	(0011,"SIEMENS RA GEN",40)	SS	1	SPIDataObjectType
f	1821	\N	(0019,"SIEMENS RA GEN",15)	LO	1	AcquiredPlane
f	1822	\N	(0019,"SIEMENS RA GEN",1f)	SS	1	DefaultTableIsoCenterHeight
f	1823	\N	(0019,"SIEMENS RA GEN",20)	SL	1	SceneFlag
f	1824	\N	(0019,"SIEMENS RA GEN",22)	SL	1	RefPhotofileFlag
f	1825	\N	(0019,"SIEMENS RA GEN",24)	LO	1	SceneName
f	1826	\N	(0019,"SIEMENS RA GEN",26)	SS	1	AcquisitionIndex
f	1827	\N	(0019,"SIEMENS RA GEN",28)	SS	1	MixedPulseMode
f	1828	\N	(0019,"SIEMENS RA GEN",2a)	SS	1	NoOfPositions
f	1829	\N	(0019,"SIEMENS RA GEN",2c)	SS	1	NoOfPhases
f	1830	\N	(0019,"SIEMENS RA GEN",2e)	SS	1-n	FrameRateForPositions
f	1831	\N	(0019,"SIEMENS RA GEN",30)	SS	1-n	NoOfFramesForPositions
f	1832	\N	(0019,"SIEMENS RA GEN",32)	SS	1	SteppingDirection
f	1833	\N	(0019,"SIEMENS RA GEN",34)	US	1	Unknown
f	1834	\N	(0019,"SIEMENS RA GEN",36)	US	1	Unknown
f	1835	\N	(0019,"SIEMENS RA GEN",38)	US	1	Unknown
f	1836	\N	(0019,"SIEMENS RA GEN",3a)	US	1	Unknown
f	1837	\N	(0019,"SIEMENS RA GEN",3c)	US	1	Unknown
f	1838	\N	(0019,"SIEMENS RA GEN",3e)	US	1	Unknown
f	1839	\N	(0019,"SIEMENS RA GEN",40)	US	1	Unknown
f	1840	\N	(0019,"SIEMENS RA GEN",42)	US	1	Unknown
f	1841	\N	(0019,"SIEMENS RA GEN",44)	SS	1	ImageTransferDelay
f	1842	\N	(0019,"SIEMENS RA GEN",46)	SL	1	InversFlag
f	1843	\N	(0019,"SIEMENS RA GEN",48)	US	1	Unknown
f	1844	\N	(0019,"SIEMENS RA GEN",4a)	US	1	Unknown
f	1845	\N	(0019,"SIEMENS RA GEN",4c)	SS	1	BlankingCircleDiameter
f	1846	\N	(0019,"SIEMENS RA GEN",50)	SL	1	StandDataValid
f	1847	\N	(0019,"SIEMENS RA GEN",52)	SS	1	TableTilt
f	1848	\N	(0019,"SIEMENS RA GEN",54)	SS	1	TableAxisRotation
f	1849	\N	(0019,"SIEMENS RA GEN",56)	SS	1	TableLongitudalPosition
f	1850	\N	(0019,"SIEMENS RA GEN",58)	SS	1	TableSideOffset
f	1851	\N	(0019,"SIEMENS RA GEN",5a)	SS	1	TableIsoCenterHeight
f	1852	\N	(0019,"SIEMENS RA GEN",5c)	UN	1	Unknown
f	1853	\N	(0019,"SIEMENS RA GEN",5e)	SL	1	CollimationDataValid
f	1854	\N	(0019,"SIEMENS RA GEN",60)	SL	1	PeriSequenceNo
f	1855	\N	(0019,"SIEMENS RA GEN",62)	SL	1	PeriTotalScenes
f	1856	\N	(0019,"SIEMENS RA GEN",64)	SL	1	PeriOverlapTop
f	1857	\N	(0019,"SIEMENS RA GEN",66)	SL	1	PeriOverlapBottom
f	1858	\N	(0019,"SIEMENS RA GEN",68)	SL	1	RawImageNumber
f	1859	\N	(0019,"SIEMENS RA GEN",6a)	SL	1	XRayDataValid
f	1860	\N	(0019,"SIEMENS RA GEN",70)	US	1-n	Unknown
f	1861	\N	(0019,"SIEMENS RA GEN",72)	US	1-n	Unknown
f	1862	\N	(0019,"SIEMENS RA GEN",74)	US	1-n	Unknown
f	1863	\N	(0019,"SIEMENS RA GEN",76)	SL	1	FillingAverageFactor
f	1864	\N	(0019,"SIEMENS RA GEN",78)	US	1-n	Unknown
f	1865	\N	(0019,"SIEMENS RA GEN",7a)	US	1-n	Unknown
f	1866	\N	(0019,"SIEMENS RA GEN",7c)	US	1-n	Unknown
f	1867	\N	(0019,"SIEMENS RA GEN",7e)	US	1-n	Unknown
f	1868	\N	(0019,"SIEMENS RA GEN",80)	US	1-n	Unknown
f	1869	\N	(0019,"SIEMENS RA GEN",82)	US	1-n	Unknown
f	1870	\N	(0019,"SIEMENS RA GEN",84)	US	1-n	Unknown
f	1871	\N	(0019,"SIEMENS RA GEN",86)	US	1-n	Unknown
f	1872	\N	(0019,"SIEMENS RA GEN",88)	US	1-n	Unknown
f	1873	\N	(0019,"SIEMENS RA GEN",8a)	US	1-n	Unknown
f	1874	\N	(0019,"SIEMENS RA GEN",8c)	US	1-n	Unknown
f	1875	\N	(0019,"SIEMENS RA GEN",8e)	US	1-n	Unknown
f	1876	\N	(0019,"SIEMENS RA GEN",92)	US	1-n	Unknown
f	1877	\N	(0019,"SIEMENS RA GEN",94)	US	1-n	Unknown
f	1878	\N	(0019,"SIEMENS RA GEN",96)	US	1-n	Unknown
f	1879	\N	(0019,"SIEMENS RA GEN",98)	US	1-n	Unknown
f	1880	\N	(0019,"SIEMENS RA GEN",9a)	US	1-n	Unknown
f	1881	\N	(0019,"SIEMENS RA GEN",9c)	SL	1	IntensifierLevelCalibrationFactor
f	1882	\N	(0019,"SIEMENS RA GEN",9e)	SL	1	NativeReviewFlag
f	1883	\N	(0019,"SIEMENS RA GEN",a2)	SL	1	SceneNumber
f	1884	\N	(0019,"SIEMENS RA GEN",a4)	SS	1	AcquisitionMode
f	1885	\N	(0019,"SIEMENS RA GEN",a5)	SS	1	AcquisitonFrameRate
f	1886	\N	(0019,"SIEMENS RA GEN",a6)	SL	1	ECGFlag
f	1887	\N	(0019,"SIEMENS RA GEN",a7)	SL	1	AdditionalSceneData
f	1888	\N	(0019,"SIEMENS RA GEN",a8)	SL	1	FileCopyFlag
f	1889	\N	(0019,"SIEMENS RA GEN",a9)	SL	1	PhlebovisionFlag
f	1890	\N	(0019,"SIEMENS RA GEN",aa)	SL	1	Co2Flag
f	1891	\N	(0019,"SIEMENS RA GEN",ab)	SS	1	MaxSpeed
f	1892	\N	(0019,"SIEMENS RA GEN",ac)	SS	1	StepWidth
f	1893	\N	(0019,"SIEMENS RA GEN",ad)	SL	1	DigitalAcquisitionZoom
f	1894	\N	(0019,"SIEMENS RA GEN",ff)	SS	1-n	Internal
f	1895	\N	(0021,"SIEMENS RA GEN",15)	SS	1	ImagesInStudy
f	1896	\N	(0021,"SIEMENS RA GEN",20)	SS	1	ScenesInStudy
f	1897	\N	(0021,"SIEMENS RA GEN",25)	SS	1	ImagesInPhotofile
f	1898	\N	(0021,"SIEMENS RA GEN",27)	SS	1	PlaneBImagesExist
f	1899	\N	(0021,"SIEMENS RA GEN",28)	SS	1	NoOf2MBChunks
f	1900	\N	(0021,"SIEMENS RA GEN",30)	SS	1	ImagesInAllScenes
f	1901	\N	(0021,"SIEMENS RA GEN",40)	SS	1	ArchiveSWInternalVersion
f	1902	\N	(0011,"SIEMENS RA PLANE A",28)	SL	1	FluoroTimerA
f	1903	\N	(0011,"SIEMENS RA PLANE A",29)	SL	1	FluoroSkinDoseA
f	1904	\N	(0011,"SIEMENS RA PLANE A",2a)	SL	1	TotalSkinDoseA
f	1905	\N	(0011,"SIEMENS RA PLANE A",2b)	SL	1	FluoroDoseAreaProductA
f	1906	\N	(0011,"SIEMENS RA PLANE A",2c)	SL	1	TotalDoseAreaProductA
f	1907	\N	(0019,"SIEMENS RA PLANE A",15)	LT	1	OfflineUID
f	1908	\N	(0019,"SIEMENS RA PLANE A",18)	SS	1	Internal
f	1909	\N	(0019,"SIEMENS RA PLANE A",19)	SS	1	Internal
f	1910	\N	(0019,"SIEMENS RA PLANE A",1a)	SS	1	Internal
f	1911	\N	(0019,"SIEMENS RA PLANE A",1b)	SS	1	Internal
f	1912	\N	(0019,"SIEMENS RA PLANE A",1c)	SS	1	Internal
f	1913	\N	(0019,"SIEMENS RA PLANE A",1d)	SS	1	Internal
f	1914	\N	(0019,"SIEMENS RA PLANE A",1e)	SS	1	Internal
f	1915	\N	(0019,"SIEMENS RA PLANE A",1f)	SS	1-n	Internal
f	1916	\N	(0019,"SIEMENS RA PLANE A",20)	SS	1	SystemCalibFactorPlaneA
f	1917	\N	(0019,"SIEMENS RA PLANE A",22)	SS	1	XRayParameterSetNo
f	1918	\N	(0019,"SIEMENS RA PLANE A",24)	SS	1	XRaySystem
f	1919	\N	(0019,"SIEMENS RA PLANE A",26)	US	1	Unknown
f	1920	\N	(0019,"SIEMENS RA PLANE A",28)	SS	1	AcquiredDisplayMode
f	1921	\N	(0019,"SIEMENS RA PLANE A",2a)	SS	1	AcquisitionDelay
f	1922	\N	(0019,"SIEMENS RA PLANE A",2c)	US	1	Unknown
f	1923	\N	(0019,"SIEMENS RA PLANE A",2e)	SS	1	MaxFramesLimit
f	1924	\N	(0019,"SIEMENS RA PLANE A",30)	US	1	MaximumFrameSizeNIU
f	1925	\N	(0019,"SIEMENS RA PLANE A",32)	SS	1	SubtractedFilterType
f	1926	\N	(0019,"SIEMENS RA PLANE A",34)	SS	1	FilterFactorNative
f	1927	\N	(0019,"SIEMENS RA PLANE A",36)	SS	1	AnatomicBackgroundFactor
f	1928	\N	(0019,"SIEMENS RA PLANE A",38)	SS	1	WindowUpperLimitNative
f	1929	\N	(0019,"SIEMENS RA PLANE A",3a)	SS	1	WindowLowerLimitNative
f	1930	\N	(0019,"SIEMENS RA PLANE A",3c)	SS	1	WindowBrightnessPhase1
f	1931	\N	(0019,"SIEMENS RA PLANE A",3e)	SS	1	WindowBrightnessPhase2
f	1932	\N	(0019,"SIEMENS RA PLANE A",40)	SS	1	WindowContrastPhase1
f	1933	\N	(0019,"SIEMENS RA PLANE A",42)	SS	1	WindowContrastPhase2
f	1934	\N	(0019,"SIEMENS RA PLANE A",44)	SS	1	FilterFactorSub
f	1935	\N	(0019,"SIEMENS RA PLANE A",46)	SS	1	PeakOpacified
f	1936	\N	(0019,"SIEMENS RA PLANE A",48)	SL	1	MaskFrame
f	1937	\N	(0019,"SIEMENS RA PLANE A",4a)	SL	1	BIHFrame
f	1938	\N	(0019,"SIEMENS RA PLANE A",4c)	SS	1	CentBeamAngulationCaudCran
f	1939	\N	(0019,"SIEMENS RA PLANE A",4e)	SS	1	CentBeamAngulationLRAnterior
f	1940	\N	(0019,"SIEMENS RA PLANE A",50)	SS	1	LongitudinalPosition
f	1941	\N	(0019,"SIEMENS RA PLANE A",52)	SS	1	SideOffset
f	1942	\N	(0019,"SIEMENS RA PLANE A",54)	SS	1	IsoCenterHeight
f	1943	\N	(0019,"SIEMENS RA PLANE A",56)	SS	1	ImageTwist
f	1944	\N	(0019,"SIEMENS RA PLANE A",58)	SS	1	SourceImageDistance
f	1945	\N	(0019,"SIEMENS RA PLANE A",5a)	SS	1	MechanicalMagnificationFactor
f	1946	\N	(0019,"SIEMENS RA PLANE A",5c)	SL	1	CalibrationFlag
f	1947	\N	(0019,"SIEMENS RA PLANE A",5e)	SL	1	CalibrationAngleCranCaud
f	1948	\N	(0019,"SIEMENS RA PLANE A",60)	SL	1	CalibrationAngleRAOLAO
f	1949	\N	(0019,"SIEMENS RA PLANE A",62)	SL	1	CalibrationTableToFloorDist
f	1950	\N	(0019,"SIEMENS RA PLANE A",64)	SL	1	CalibrationIsocenterToFloorDist
f	1951	\N	(0019,"SIEMENS RA PLANE A",66)	SL	1	CalibrationIsocenterToSourceDist
f	1952	\N	(0019,"SIEMENS RA PLANE A",68)	SL	1	CalibrationSourceToII
f	1953	\N	(0019,"SIEMENS RA PLANE A",6a)	SL	1	CalibrationIIZoom
f	1954	\N	(0019,"SIEMENS RA PLANE A",6c)	SL	1	CalibrationIIField
f	1955	\N	(0019,"SIEMENS RA PLANE A",6e)	SL	1	CalibrationFactor
f	1956	\N	(0019,"SIEMENS RA PLANE A",70)	SL	1	CalibrationObjectToImageDistance
f	1957	\N	(0019,"SIEMENS RA PLANE A",72)	SL	1-n	CalibrationSystemFactor
f	1958	\N	(0019,"SIEMENS RA PLANE A",74)	SL	1-n	CalibrationSystemCorrection
f	1959	\N	(0019,"SIEMENS RA PLANE A",76)	SL	1-n	CalibrationSystemIIFormats
f	1960	\N	(0019,"SIEMENS RA PLANE A",78)	SL	1	CalibrationGantryDataValid
f	1961	\N	(0019,"SIEMENS RA PLANE A",7a)	SS	1	CollimatorSquareBreadth
f	1962	\N	(0019,"SIEMENS RA PLANE A",7c)	SS	1	CollimatorSquareHeight
f	1963	\N	(0019,"SIEMENS RA PLANE A",7e)	SS	1	CollimatorSquareDiameter
f	1964	\N	(0019,"SIEMENS RA PLANE A",80)	SS	1	CollimaterFingerTurnAngle
f	1965	\N	(0019,"SIEMENS RA PLANE A",82)	SS	1	CollimaterFingerPosition
f	1966	\N	(0019,"SIEMENS RA PLANE A",84)	SS	1	CollimaterDiaphragmTurnAngle
f	1967	\N	(0019,"SIEMENS RA PLANE A",86)	SS	1	CollimaterDiaphragmPosition1
f	1968	\N	(0019,"SIEMENS RA PLANE A",88)	SS	1	CollimaterDiaphragmPosition2
f	1969	\N	(0019,"SIEMENS RA PLANE A",8a)	SS	1	CollimaterDiaphragmMode
f	1970	\N	(0019,"SIEMENS RA PLANE A",8c)	SS	1	CollimaterBeamLimitBreadth
f	1971	\N	(0019,"SIEMENS RA PLANE A",8e)	SS	1	CollimaterBeamLimitHeight
f	1972	\N	(0019,"SIEMENS RA PLANE A",90)	SS	1	CollimaterBeamLimitDiameter
f	1973	\N	(0019,"SIEMENS RA PLANE A",92)	SS	1	X-RayControlMOde
f	1974	\N	(0019,"SIEMENS RA PLANE A",94)	SS	1	X-RaySystem
f	1975	\N	(0019,"SIEMENS RA PLANE A",96)	SS	1	FocalSpot
f	1976	\N	(0019,"SIEMENS RA PLANE A",98)	SS	1	ExposureControl
f	1977	\N	(0019,"SIEMENS RA PLANE A",9a)	SL	1	XRayVoltage
f	1978	\N	(0019,"SIEMENS RA PLANE A",9c)	SL	1	XRayCurrent
f	1979	\N	(0019,"SIEMENS RA PLANE A",9e)	SL	1	XRayCurrentTimeProduct
f	1980	\N	(0019,"SIEMENS RA PLANE A",a0)	SL	1	XRayPulseTime
f	1981	\N	(0019,"SIEMENS RA PLANE A",a2)	SL	1	XRaySceneTimeFluoroClock
f	1982	\N	(0019,"SIEMENS RA PLANE A",a4)	SS	1	MaximumPulseRate
f	1983	\N	(0019,"SIEMENS RA PLANE A",a6)	SS	1	PulsesPerScene
f	1984	\N	(0019,"SIEMENS RA PLANE A",a8)	SL	1	DoseAreaProductOfScene
f	1985	\N	(0019,"SIEMENS RA PLANE A",aa)	SS	1	Dose
f	1986	\N	(0019,"SIEMENS RA PLANE A",ac)	SS	1	DoseRate
f	1987	\N	(0019,"SIEMENS RA PLANE A",ae)	SL	1	IIToCoverDistance
f	1988	\N	(0019,"SIEMENS RA PLANE A",b0)	SS	1	LastFramePhase1
f	1989	\N	(0019,"SIEMENS RA PLANE A",b1)	SS	1	FrameRatePhase1
f	1990	\N	(0019,"SIEMENS RA PLANE A",b2)	SS	1	LastFramePhase2
f	1991	\N	(0019,"SIEMENS RA PLANE A",b3)	SS	1	FrameRatePhase2
f	1992	\N	(0019,"SIEMENS RA PLANE A",b4)	SS	1	LastFramePhase3
f	1993	\N	(0019,"SIEMENS RA PLANE A",b5)	SS	1	FrameRatePhase3
f	1994	\N	(0019,"SIEMENS RA PLANE A",b6)	SS	1	LastFramePhase4
f	1995	\N	(0019,"SIEMENS RA PLANE A",b7)	SS	1	FrameRatePhase4
f	1996	\N	(0019,"SIEMENS RA PLANE A",b8)	SS	1	GammaOfNativeImage
f	1997	\N	(0019,"SIEMENS RA PLANE A",b9)	SS	1	GammaOfTVSystem
f	1998	\N	(0019,"SIEMENS RA PLANE A",bb)	SL	1	PixelshiftX
f	1999	\N	(0019,"SIEMENS RA PLANE A",bc)	SL	1	PixelshiftY
f	2000	\N	(0019,"SIEMENS RA PLANE A",bd)	SL	1	MaskAverageFactor
f	2001	\N	(0019,"SIEMENS RA PLANE A",be)	SL	1	BlankingCircleFlag
f	2002	\N	(0019,"SIEMENS RA PLANE A",bf)	SL	1	CircleRowStart
f	2003	\N	(0019,"SIEMENS RA PLANE A",c0)	SL	1	CircleRowEnd
f	2004	\N	(0019,"SIEMENS RA PLANE A",c1)	SL	1	CircleColumnStart
f	2005	\N	(0019,"SIEMENS RA PLANE A",c2)	SL	1	CircleColumnEnd
f	2006	\N	(0019,"SIEMENS RA PLANE A",c3)	SL	1	CircleDiameter
f	2007	\N	(0019,"SIEMENS RA PLANE A",c4)	SL	1	RectangularCollimaterFlag
f	2008	\N	(0019,"SIEMENS RA PLANE A",c5)	SL	1	RectangleRowStart
f	2009	\N	(0019,"SIEMENS RA PLANE A",c6)	SL	1	RectangleRowEnd
f	2010	\N	(0019,"SIEMENS RA PLANE A",c7)	SL	1	RectangleColumnStart
f	2011	\N	(0019,"SIEMENS RA PLANE A",c8)	SL	1	RectangleColumnEnd
f	2012	\N	(0019,"SIEMENS RA PLANE A",c9)	SL	1	RectangleAngulation
f	2013	\N	(0019,"SIEMENS RA PLANE A",ca)	SL	1	IrisCollimatorFlag
f	2014	\N	(0019,"SIEMENS RA PLANE A",cb)	SL	1	IrisRowStart
f	2015	\N	(0019,"SIEMENS RA PLANE A",cc)	SL	1	IrisRowEnd
f	2016	\N	(0019,"SIEMENS RA PLANE A",cd)	SL	1	IrisColumnStart
f	2017	\N	(0019,"SIEMENS RA PLANE A",ce)	SL	1	IrisColumnEnd
f	2018	\N	(0019,"SIEMENS RA PLANE A",cf)	SL	1	IrisAngulation
f	2019	\N	(0019,"SIEMENS RA PLANE A",d1)	SS	1	NumberOfFramesPlane
f	2020	\N	(0019,"SIEMENS RA PLANE A",d2)	SS	1	Internal
f	2021	\N	(0019,"SIEMENS RA PLANE A",d3)	SS	1	Internal
f	2022	\N	(0019,"SIEMENS RA PLANE A",d4)	SS	1	Internal
f	2023	\N	(0019,"SIEMENS RA PLANE A",d5)	SS	1	Internal
f	2024	\N	(0019,"SIEMENS RA PLANE A",d6)	SS	1-n	Internal
f	2025	\N	(0019,"SIEMENS RA PLANE A",d7)	SS	1-n	Internal
f	2026	\N	(0019,"SIEMENS RA PLANE A",d8)	SS	1	Internal
f	2027	\N	(0019,"SIEMENS RA PLANE A",d9)	SS	1	Internal
f	2028	\N	(0019,"SIEMENS RA PLANE A",da)	SS	1	Internal
f	2029	\N	(0019,"SIEMENS RA PLANE A",db)	SS	1	Internal
f	2030	\N	(0019,"SIEMENS RA PLANE A",dc)	SS	1	Internal
f	2031	\N	(0019,"SIEMENS RA PLANE A",dd)	SL	1	AnatomicBackground
f	2032	\N	(0019,"SIEMENS RA PLANE A",de)	SL	1-n	AutoWindowBase
f	2033	\N	(0019,"SIEMENS RA PLANE A",df)	SS	1	Internal
f	2034	\N	(0019,"SIEMENS RA PLANE A",e0)	SL	1	Internal
f	2035	\N	(0011,"SIEMENS RA PLANE B",28)	SL	1	FluoroTimerB
f	2036	\N	(0011,"SIEMENS RA PLANE B",29)	SL	1	FluoroSkinDoseB
f	2037	\N	(0011,"SIEMENS RA PLANE B",2a)	SL	1	TotalSkinDoseB
f	2038	\N	(0011,"SIEMENS RA PLANE B",2b)	SL	1	FluoroDoseAreaProductB
f	2039	\N	(0011,"SIEMENS RA PLANE B",2c)	SL	1	TotalDoseAreaProductB
f	2040	\N	(0019,"SIEMENS RA PLANE B",18)	SS	1	Internal
f	2041	\N	(0019,"SIEMENS RA PLANE B",19)	SS	1	Internal
f	2042	\N	(0019,"SIEMENS RA PLANE B",1a)	SS	1	Internal
f	2043	\N	(0019,"SIEMENS RA PLANE B",1b)	SS	1	Internal
f	2044	\N	(0019,"SIEMENS RA PLANE B",1c)	SS	1	Internal
f	2045	\N	(0019,"SIEMENS RA PLANE B",1d)	SS	1	Internal
f	2046	\N	(0019,"SIEMENS RA PLANE B",1e)	SS	1	Internal
f	2047	\N	(0019,"SIEMENS RA PLANE B",1f)	SS	1	Internal
f	2048	\N	(0019,"SIEMENS RA PLANE B",20)	SL	1-n	SystemCalibFactorPlaneB
f	2049	\N	(0019,"SIEMENS RA PLANE B",22)	US	1	Unknown
f	2050	\N	(0019,"SIEMENS RA PLANE B",24)	US	1	Unknown
f	2051	\N	(0019,"SIEMENS RA PLANE B",26)	US	1	Unknown
f	2052	\N	(0019,"SIEMENS RA PLANE B",28)	US	1	Unknown
f	2053	\N	(0019,"SIEMENS RA PLANE B",2a)	US	1	Unknown
f	2054	\N	(0019,"SIEMENS RA PLANE B",2c)	US	1	Unknown
f	2055	\N	(0019,"SIEMENS RA PLANE B",2e)	US	1	Unknown
f	2056	\N	(0019,"SIEMENS RA PLANE B",30)	US	1	Unknown
f	2057	\N	(0019,"SIEMENS RA PLANE B",32)	US	1	Unknown
f	2058	\N	(0019,"SIEMENS RA PLANE B",34)	US	1	Unknown
f	2059	\N	(0019,"SIEMENS RA PLANE B",36)	US	1	Unknown
f	2060	\N	(0019,"SIEMENS RA PLANE B",38)	US	1	Unknown
f	2061	\N	(0019,"SIEMENS RA PLANE B",3a)	US	1	Unknown
f	2062	\N	(0019,"SIEMENS RA PLANE B",3c)	US	1	Unknown
f	2063	\N	(0019,"SIEMENS RA PLANE B",3e)	US	1	Unknown
f	2064	\N	(0019,"SIEMENS RA PLANE B",40)	US	1	Unknown
f	2065	\N	(0019,"SIEMENS RA PLANE B",42)	US	1	Unknown
f	2066	\N	(0019,"SIEMENS RA PLANE B",44)	US	1	Unknown
f	2067	\N	(0019,"SIEMENS RA PLANE B",46)	US	1	Unknown
f	2068	\N	(0019,"SIEMENS RA PLANE B",48)	US	1	Unknown
f	2069	\N	(0019,"SIEMENS RA PLANE B",4a)	US	1-n	Unknown
f	2070	\N	(0019,"SIEMENS RA PLANE B",4c)	US	1-n	Unknown
f	2071	\N	(0019,"SIEMENS RA PLANE B",4e)	US	1-n	Unknown
f	2072	\N	(0019,"SIEMENS RA PLANE B",50)	US	1	Unknown
f	2073	\N	(0019,"SIEMENS RA PLANE B",52)	US	1	Unknown
f	2074	\N	(0019,"SIEMENS RA PLANE B",54)	US	1	Unknown
f	2075	\N	(0019,"SIEMENS RA PLANE B",56)	US	1	Unknown
f	2076	\N	(0019,"SIEMENS RA PLANE B",58)	US	1	Unknown
f	2077	\N	(0019,"SIEMENS RA PLANE B",5a)	US	1	Unknown
f	2078	\N	(0019,"SIEMENS RA PLANE B",5c)	US	1-n	Unknown
f	2079	\N	(0019,"SIEMENS RA PLANE B",5e)	US	1-n	Unknown
f	2080	\N	(0019,"SIEMENS RA PLANE B",60)	US	1-n	Unknown
f	2081	\N	(0019,"SIEMENS RA PLANE B",62)	US	1-n	Unknown
f	2082	\N	(0019,"SIEMENS RA PLANE B",64)	US	1-n	Unknown
f	2083	\N	(0019,"SIEMENS RA PLANE B",66)	US	1-n	Unknown
f	2084	\N	(0019,"SIEMENS RA PLANE B",68)	US	1-n	Unknown
f	2085	\N	(0019,"SIEMENS RA PLANE B",6a)	US	1-n	Unknown
f	2086	\N	(0019,"SIEMENS RA PLANE B",6c)	US	1-n	Unknown
f	2087	\N	(0019,"SIEMENS RA PLANE B",6e)	US	1-n	Unknown
f	2088	\N	(0019,"SIEMENS RA PLANE B",70)	US	1-n	Unknown
f	2089	\N	(0019,"SIEMENS RA PLANE B",72)	UN	1	Unknown
f	2090	\N	(0019,"SIEMENS RA PLANE B",74)	UN	1	Unknown
f	2091	\N	(0019,"SIEMENS RA PLANE B",76)	UN	1	Unknown
f	2092	\N	(0019,"SIEMENS RA PLANE B",78)	US	1-n	Unknown
f	2093	\N	(0019,"SIEMENS RA PLANE B",7a)	US	1	Unknown
f	2094	\N	(0019,"SIEMENS RA PLANE B",7c)	US	1	Unknown
f	2095	\N	(0019,"SIEMENS RA PLANE B",7e)	US	1	Unknown
f	2096	\N	(0019,"SIEMENS RA PLANE B",80)	US	1	Unknown
f	2097	\N	(0019,"SIEMENS RA PLANE B",82)	US	1	Unknown
f	2098	\N	(0019,"SIEMENS RA PLANE B",84)	US	1	Unknown
f	2099	\N	(0019,"SIEMENS RA PLANE B",86)	US	1	Unknown
f	2100	\N	(0019,"SIEMENS RA PLANE B",88)	US	1	Unknown
f	2101	\N	(0019,"SIEMENS RA PLANE B",8a)	US	1	Unknown
f	2102	\N	(0019,"SIEMENS RA PLANE B",8c)	US	1	Unknown
f	2103	\N	(0019,"SIEMENS RA PLANE B",8e)	US	1	Unknown
f	2104	\N	(0019,"SIEMENS RA PLANE B",90)	US	1	Unknown
f	2105	\N	(0019,"SIEMENS RA PLANE B",92)	US	1	Unknown
f	2106	\N	(0019,"SIEMENS RA PLANE B",94)	US	1	Unknown
f	2107	\N	(0019,"SIEMENS RA PLANE B",96)	US	1	Unknown
f	2108	\N	(0019,"SIEMENS RA PLANE B",98)	US	1	Unknown
f	2109	\N	(0019,"SIEMENS RA PLANE B",9a)	US	1-n	Unknown
f	2110	\N	(0019,"SIEMENS RA PLANE B",9c)	US	1-n	Unknown
f	2111	\N	(0019,"SIEMENS RA PLANE B",9e)	US	1-n	Unknown
f	2112	\N	(0019,"SIEMENS RA PLANE B",a0)	US	1-n	Unknown
f	2113	\N	(0019,"SIEMENS RA PLANE B",a2)	US	1-n	Unknown
f	2114	\N	(0019,"SIEMENS RA PLANE B",a4)	US	1	Unknown
f	2115	\N	(0019,"SIEMENS RA PLANE B",a6)	US	1	Unknown
f	2116	\N	(0019,"SIEMENS RA PLANE B",a8)	US	1-n	Unknown
f	2117	\N	(0019,"SIEMENS RA PLANE B",aa)	US	1	Unknown
f	2118	\N	(0019,"SIEMENS RA PLANE B",ac)	US	1	Unknown
f	2119	\N	(0011,"SIEMENS RIS",10)	LT	1	PatientUID
f	2120	\N	(0011,"SIEMENS RIS",11)	LT	1	PatientID
f	2121	\N	(0011,"SIEMENS RIS",20)	DA	1	PatientRegistrationDate
f	2122	\N	(0011,"SIEMENS RIS",21)	TM	1	PatientRegistrationTime
f	2123	\N	(0011,"SIEMENS RIS",30)	LT	1	PatientnameRIS
f	2124	\N	(0011,"SIEMENS RIS",31)	LT	1	PatientprenameRIS
f	2125	\N	(0011,"SIEMENS RIS",40)	LT	1	PatientHospitalStatus
f	2126	\N	(0011,"SIEMENS RIS",41)	LT	1	MedicalAlerts
f	2127	\N	(0011,"SIEMENS RIS",42)	LT	1	ContrastAllergies
f	2128	\N	(0031,"SIEMENS RIS",10)	LT	1	RequestUID
f	2129	\N	(0031,"SIEMENS RIS",45)	LT	1	RequestingPhysician
f	2130	\N	(0031,"SIEMENS RIS",50)	LT	1	RequestedPhysician
f	2131	\N	(0033,"SIEMENS RIS",10)	LT	1	PatientStudyUID
f	2132	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",00)	US	1	AcquisitionType
f	2133	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",01)	US	1	AcquisitionMode
f	2134	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",02)	US	1	FootswitchIndex
f	2135	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",03)	US	1	AcquisitionRoom
f	2136	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",04)	SL	1	CurrentTimeProduct
f	2137	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",05)	SL	1	Dose
f	2138	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",06)	SL	1	SkinDosePercent
f	2139	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",07)	SL	1	SkinDoseAccumulation
f	2140	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",08)	SL	1	SkinDoseRate
f	2141	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0A)	UL	1	CopperFilter
f	2142	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0B)	US	1	MeasuringField
f	2143	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0C)	SS	3	PostBlankingCircle
f	2144	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0D)	SS	2-2n	DynaAngles
f	2145	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0E)	SS	1	TotalSteps
f	2146	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",0F)	SL	3-3n	DynaXRayInfo
f	2147	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",10)	US	1	ModalityLUTInputGamma
f	2148	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",11)	US	1	ModalityLUTOutputGamma
f	2149	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",12)	OB	1-n	SH_STPAR
f	2150	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",13)	US	1	AcquisitionZoom
f	2151	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",14)	SS	1	DynaAngulationStepWidth
f	2152	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",15)	US	1	Harmonization
f	2153	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",16)	US	1	DRSingleFlag
f	2154	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",17)	SL	1	SourceToIsocenter
f	2155	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",18)	US	1	PressureData
f	2156	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",19)	SL	1	ECGIndexArray
f	2157	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1A)	US	1	FDFlag
f	2158	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1B)	OB	1	SH_ZOOM
f	2159	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1C)	OB	1	SH_COLPAR
f	2160	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1D)	US	1	K_Factor
f	2161	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1E)	US	8	EVE
f	2162	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",1F)	SL	1	TotalSceneTime
f	2163	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",20)	US	1	RestoreFlag
f	2164	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",21)	US	1	StandMovementFlag
f	2165	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",22)	US	1	FDRows
f	2166	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",23)	US	1	FDColumns
f	2167	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",24)	US	1	TableMovementFlag
f	2168	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",25)	LO	1	OriginalOrganProgramName
f	2169	\N	(0021,"SIEMENS SMS-AX  ACQ 1.0",26)	DS	1	CrispyXPIFilter
f	2170	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",00)	US	1	ViewNative
f	2171	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",01)	US	1	OriginalSeriesNumber
f	2172	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",02)	US	1	OriginalImageNumber
f	2173	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",03)	US	1	WinCenter
f	2174	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",04)	US	1	WinWidth
f	2175	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",05)	US	1	WinBrightness
f	2176	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",06)	US	1	WinContrast
f	2177	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",07)	US	1	OriginalFrameNumber
f	2178	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",08)	US	1	OriginalMaskFrameNumber
f	2179	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",09)	US	1	Opac
f	2180	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0A)	US	1	OriginalNumberOfFrames
f	2181	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0B)	DS	1	OriginalSceneDuration
f	2182	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0C)	LO	1	IdentifierLOID
f	2183	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0D)	SS	1-n	OriginalSceneVFRInfo
f	2184	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0E)	SS	1	OriginalFrameECGPosition
f	2185	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",0F)	SS	1	OriginalECG1stFrameOffset_retired
f	2186	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",10)	SS	1	ZoomFlag
f	2187	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",11)	US	1	Flex
f	2188	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",12)	US	1	NumberOfMaskFrames
f	2189	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",13)	US	1	NumberOfFillFrames
f	2190	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",14)	US	1	SeriesNumber
f	2191	\N	(0025,"SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0",15)	IS	1	ImageNumber
f	2192	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",00)	DS	2	HorizontalCalibrationPixelSize
f	2193	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",01)	DS	2	VerticalCalibrationPixelSize
f	2194	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",02)	LO	1	CalibrationObject
f	2195	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",03)	DS	1	CalibrationObjectSize
f	2196	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",04)	LO	1	CalibrationMethod
f	2197	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",05)	ST	1	Filename
f	2198	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",06)	IS	1	FrameNumber
f	2199	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",07)	IS	2	CalibrationFactorMultiplicity
f	2200	\N	(0023,"SIEMENS SMS-AX  QUANT 1.0",08)	IS	1	CalibrationTODValue
f	2201	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",00)	US	1	ReviewMode
f	2202	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",01)	US	1	AnatomicalBackgroundPercent
f	2203	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",02)	US	1	NumberOfPhases
f	2204	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",03)	US	1	ApplyAnatomicalBackground
f	2205	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",04)	SS	4-4n	PixelShiftArray
f	2206	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",05)	US	1	Brightness
f	2207	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",06)	US	1	Contrast
f	2208	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",07)	US	1	Enabled
f	2209	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",08)	US	1	NativeEdgeEnhancementPercentGain
f	2210	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",09)	SS	1	NativeEdgeEnhancementLUTIndex
f	2211	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0A)	SS	1	NativeEdgeEnhancementKernelSize
f	2212	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0B)	US	1	SubtrEdgeEnhancementPercentGain
f	2213	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0C)	SS	1	SubtrEdgeEnhancementLUTIndex
f	2214	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0D)	SS	1	SubtrEdgeEnhancementKernelSize
f	2215	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0E)	US	1	FadePercent
f	2216	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",0F)	US	1	FlippedBeforeLateralityApplied
f	2217	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",10)	US	1	ApplyFade
f	2218	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",12)	US	1	Zoom
f	2219	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",13)	SS	1	PanX
f	2220	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",14)	SS	1	PanY
f	2221	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",15)	SS	1	NativeEdgeEnhancementAdvPercGain
f	2222	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",16)	SS	1	SubtrEdgeEnhancementAdvPercGain
f	2223	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",17)	US	1	InvertFlag
f	2224	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",1A)	OB	1	Quant1KOverlay
f	2225	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",1B)	US	1	OriginalResolution
f	2226	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",1C)	DS	1	AutoWindowCenter
f	2227	\N	(0019,"SIEMENS SMS-AX  VIEW 1.0",1D)	DS	1	AutoWindowWidth
f	2228	\N	(0009,"SIENET",01)	US	1	SIENETCommandField
f	2229	\N	(0009,"SIENET",14)	LT	1	ReceiverPLA
f	2230	\N	(0009,"SIENET",16)	US	1	TransferPriority
f	2231	\N	(0009,"SIENET",29)	LT	1	ActualUser
f	2232	\N	(0095,"SIENET",01)	LT	1	ExaminationFolderID
f	2233	\N	(0095,"SIENET",04)	UL	1	FolderReportedStatus
f	2234	\N	(0095,"SIENET",05)	LT	1	FolderReportingRadiologist
f	2235	\N	(0095,"SIENET",07)	LT	1	SIENETISAPLA
f	2236	\N	(0099,"SIENET",02)	UL	1	DataObjectAttributes
f	2237	\N	(0009,"SPI RELEASE 1",10)	LT	1	Comments
f	2238	\N	(0009,"SPI RELEASE 1",15)	LO	1	SPIImageUID
f	2239	\N	(0009,"SPI RELEASE 1",40)	US	1	DataObjectType
f	2240	\N	(0009,"SPI RELEASE 1",41)	LO	1	DataObjectSubtype
f	2241	\N	(0011,"SPI RELEASE 1",10)	LO	1	Organ
f	2242	\N	(0011,"SPI RELEASE 1",15)	LO	1	AllergyIndication
f	2243	\N	(0011,"SPI RELEASE 1",20)	LO	1	Pregnancy
f	2244	\N	(0029,"SPI RELEASE 1",60)	LT	1	CompressionAlgorithm
f	2245	\N	(0009,"SPI Release 1",10)	LT	1	Comments
f	2246	\N	(0009,"SPI Release 1",15)	LO	1	SPIImageUID
f	2247	\N	(0009,"SPI Release 1",40)	US	1	DataObjectType
f	2248	\N	(0009,"SPI Release 1",41)	LO	1	DataObjectSubtype
f	2249	\N	(0011,"SPI Release 1",10)	LO	1	Organ
f	2250	\N	(0011,"SPI Release 1",15)	LO	1	AllergyIndication
f	2251	\N	(0011,"SPI Release 1",20)	LO	1	Pregnancy
f	2252	\N	(0029,"SPI Release 1",60)	LT	1	CompressionAlgorithm
f	2253	\N	(0009,"SPI",10)	LO	1	Comments
f	2254	\N	(0009,"SPI",15)	LO	1	SPIImageUID
f	2255	\N	(0009,"SPI",40)	US	1	DataObjectType
f	2256	\N	(0009,"SPI",41)	LT	1	DataObjectSubtype
f	2257	\N	(0011,"SPI",10)	LT	1	Organ
f	2258	\N	(0011,"SPI",15)	LT	1	AllergyIndication
f	2259	\N	(0011,"SPI",20)	LT	1	Pregnancy
f	2260	\N	(0029,"SPI",60)	LT	1	CompressionAlgorithm
f	2241	\N	(0011,"SPI RELEASE 1",10)	LO	1	Organ
f	2242	\N	(0011,"SPI RELEASE 1",15)	LO	1	AllergyIndication
f	2243	\N	(0011,"SPI RELEASE 1",20)	LO	1	Pregnancy
f	2261	\N	(0009,"SPI-P Release 1",00)	LT	1	DataObjectRecognitionCode
f	2262	\N	(0009,"SPI-P Release 1",04)	LO	1	ImageDataConsistence
f	2263	\N	(0009,"SPI-P Release 1",08)	US	1	Unknown
f	2264	\N	(0009,"SPI-P Release 1",12)	LO	1	Unknown
f	2265	\N	(0009,"SPI-P Release 1",15)	LO	1	UniqueIdentifier
f	2266	\N	(0009,"SPI-P Release 1",16)	LO	1	Unknown
f	2267	\N	(0009,"SPI-P Release 1",18)	LO	1	Unknown
f	2268	\N	(0009,"SPI-P Release 1",21)	LT	1	Unknown
f	2269	\N	(0009,"SPI-P Release 1",31)	LT	1	PACSUniqueIdentifier
f	2270	\N	(0009,"SPI-P Release 1",34)	LT	1	ClusterUniqueIdentifier
f	2271	\N	(0009,"SPI-P Release 1",38)	LT	1	SystemUniqueIdentifier
f	2272	\N	(0009,"SPI-P Release 1",39)	LT	1	Unknown
f	2273	\N	(0009,"SPI-P Release 1",51)	LT	1	StudyUniqueIdentifier
f	2274	\N	(0009,"SPI-P Release 1",61)	LT	1	SeriesUniqueIdentifier
f	2275	\N	(0009,"SPI-P Release 1",91)	LT	1	Unknown
f	2276	\N	(0009,"SPI-P Release 1",f2)	LT	1	Unknown
f	2277	\N	(0009,"SPI-P Release 1",f3)	UN	1	Unknown
f	2278	\N	(0009,"SPI-P Release 1",f4)	LT	1	Unknown
f	2279	\N	(0009,"SPI-P Release 1",f5)	UN	1	Unknown
f	2280	\N	(0009,"SPI-P Release 1",f7)	LT	1	Unknown
f	2281	\N	(0011,"SPI-P Release 1",10)	LT	1	PatientEntryID
f	2282	\N	(0011,"SPI-P Release 1",21)	UN	1	Unknown
f	2283	\N	(0011,"SPI-P Release 1",22)	UN	1	Unknown
f	2284	\N	(0011,"SPI-P Release 1",31)	UN	1	Unknown
f	2285	\N	(0011,"SPI-P Release 1",32)	UN	1	Unknown
f	2286	\N	(0019,"SPI-P Release 1",00)	UN	1	Unknown
f	2287	\N	(0019,"SPI-P Release 1",01)	UN	1	Unknown
f	2288	\N	(0019,"SPI-P Release 1",02)	UN	1	Unknown
f	2289	\N	(0019,"SPI-P Release 1",10)	US	1	MainsFrequency
f	2290	\N	(0019,"SPI-P Release 1",25)	LT	1-n	OriginalPixelDataQuality
f	2291	\N	(0019,"SPI-P Release 1",30)	US	1	ECGTriggering
f	2292	\N	(0019,"SPI-P Release 1",31)	UN	1	ECG1Offset
f	2293	\N	(0019,"SPI-P Release 1",32)	UN	1	ECG2Offset1
f	2294	\N	(0019,"SPI-P Release 1",33)	UN	1	ECG2Offset2
f	2295	\N	(0019,"SPI-P Release 1",50)	US	1	VideoScanMode
f	2296	\N	(0019,"SPI-P Release 1",51)	US	1	VideoLineRate
f	2297	\N	(0019,"SPI-P Release 1",60)	US	1	XrayTechnique
f	2298	\N	(0019,"SPI-P Release 1",61)	DS	1	ImageIdentifierFromat
f	2299	\N	(0019,"SPI-P Release 1",62)	US	1	IrisDiaphragm
f	2300	\N	(0019,"SPI-P Release 1",63)	CS	1	Filter
f	2301	\N	(0019,"SPI-P Release 1",64)	CS	1	CineParallel
f	2302	\N	(0019,"SPI-P Release 1",65)	CS	1	CineMaster
f	2303	\N	(0019,"SPI-P Release 1",70)	US	1	ExposureChannel
f	2304	\N	(0019,"SPI-P Release 1",71)	UN	1	ExposureChannelFirstImage
f	2305	\N	(0019,"SPI-P Release 1",72)	US	1	ProcessingChannel
f	2306	\N	(0019,"SPI-P Release 1",80)	DS	1	AcquisitionDelay
f	2307	\N	(0019,"SPI-P Release 1",81)	UN	1	RelativeImageTime
f	2308	\N	(0019,"SPI-P Release 1",90)	CS	1	VideoWhiteCompression
f	2309	\N	(0019,"SPI-P Release 1",a0)	US	1	Angulation
f	2310	\N	(0019,"SPI-P Release 1",a1)	US	1	Rotation
f	2311	\N	(0021,"SPI-P Release 1",12)	LT	1	SeriesUniqueIdentifier
f	2312	\N	(0021,"SPI-P Release 1",14)	LT	1	Unknown
f	2313	\N	(0029,"SPI-P Release 1",00)	DS	4	Unknown
f	2314	\N	(0029,"SPI-P Release 1",20)	DS	1	PixelAspectRatio
f	2315	\N	(0029,"SPI-P Release 1",25)	LO	1-n	ProcessedPixelDataQuality
f	2316	\N	(0029,"SPI-P Release 1",30)	LT	1	Unknown
f	2317	\N	(0029,"SPI-P Release 1",38)	US	1	Unknown
f	2318	\N	(0029,"SPI-P Release 1",60)	LT	1	Unknown
f	2319	\N	(0029,"SPI-P Release 1",61)	LT	1	Unknown
f	2320	\N	(0029,"SPI-P Release 1",67)	LT	1	Unknown
f	2321	\N	(0029,"SPI-P Release 1",70)	LT	1	WindowID
f	2322	\N	(0029,"SPI-P Release 1",71)	CS	1	VideoInvertSubtracted
f	2323	\N	(0029,"SPI-P Release 1",72)	CS	1	VideoInvertNonsubtracted
f	2324	\N	(0029,"SPI-P Release 1",77)	CS	1	WindowSelectStatus
f	2325	\N	(0029,"SPI-P Release 1",78)	LT	1	ECGDisplayPrintingID
f	2326	\N	(0029,"SPI-P Release 1",79)	CS	1	ECGDisplayPrinting
f	2327	\N	(0029,"SPI-P Release 1",7e)	CS	1	ECGDisplayPrintingEnableStatus
f	2328	\N	(0029,"SPI-P Release 1",7f)	CS	1	ECGDisplayPrintingSelectStatus
f	2329	\N	(0029,"SPI-P Release 1",80)	LT	1	PhysiologicalDisplayID
f	2330	\N	(0029,"SPI-P Release 1",81)	US	1	PreferredPhysiologicalChannelDisplay
f	2331	\N	(0029,"SPI-P Release 1",8e)	CS	1	PhysiologicalDisplayEnableStatus
f	2332	\N	(0029,"SPI-P Release 1",8f)	CS	1	PhysiologicalDisplaySelectStatus
f	2333	\N	(0029,"SPI-P Release 1",c0)	LT	1	FunctionalShutterID
f	2334	\N	(0029,"SPI-P Release 1",c1)	US	1	FieldOfShutter
f	2335	\N	(0029,"SPI-P Release 1",c5)	LT	1	FieldOfShutterRectangle
f	2336	\N	(0029,"SPI-P Release 1",ce)	CS	1	ShutterEnableStatus
f	2337	\N	(0029,"SPI-P Release 1",cf)	CS	1	ShutterSelectStatus
f	2338	\N	(7FE1,"SPI-P Release 1",10)	ox	1	PixelData
f	2339	\N	(0009,"SPI-P Release 1;1",c0)	LT	1	Unknown
f	2340	\N	(0009,"SPI-P Release 1;1",c1)	LT	1	Unknown
f	2341	\N	(0019,"SPI-P Release 1;1",00)	UN	1	PhysiologicalDataType
f	2342	\N	(0019,"SPI-P Release 1;1",01)	UN	1	PhysiologicalDataChannelAndKind
f	2343	\N	(0019,"SPI-P Release 1;1",02)	US	1	SampleBitsAllocated
f	2344	\N	(0019,"SPI-P Release 1;1",03)	US	1	SampleBitsStored
f	2345	\N	(0019,"SPI-P Release 1;1",04)	US	1	SampleHighBit
f	2346	\N	(0019,"SPI-P Release 1;1",05)	US	1	SampleRepresentation
f	2347	\N	(0019,"SPI-P Release 1;1",06)	UN	1	SmallestSampleValue
f	2348	\N	(0019,"SPI-P Release 1;1",07)	UN	1	LargestSampleValue
f	2349	\N	(0019,"SPI-P Release 1;1",08)	UN	1	NumberOfSamples
f	2350	\N	(0019,"SPI-P Release 1;1",09)	UN	1	SampleData
f	2351	\N	(0019,"SPI-P Release 1;1",0a)	UN	1	SampleRate
f	2352	\N	(0019,"SPI-P Release 1;1",10)	UN	1	PhysiologicalDataType2
f	2353	\N	(0019,"SPI-P Release 1;1",11)	UN	1	PhysiologicalDataChannelAndKind2
f	2354	\N	(0019,"SPI-P Release 1;1",12)	US	1	SampleBitsAllocated2
f	2355	\N	(0019,"SPI-P Release 1;1",13)	US	1	SampleBitsStored2
f	2356	\N	(0019,"SPI-P Release 1;1",14)	US	1	SampleHighBit2
f	2357	\N	(0019,"SPI-P Release 1;1",15)	US	1	SampleRepresentation2
f	2358	\N	(0019,"SPI-P Release 1;1",16)	UN	1	SmallestSampleValue2
f	2359	\N	(0019,"SPI-P Release 1;1",17)	UN	1	LargestSampleValue2
f	2360	\N	(0019,"SPI-P Release 1;1",18)	UN	1	NumberOfSamples2
f	2361	\N	(0019,"SPI-P Release 1;1",19)	UN	1	SampleData2
f	2362	\N	(0019,"SPI-P Release 1;1",1a)	UN	1	SampleRate2
f	2363	\N	(0029,"SPI-P Release 1;1",00)	LT	1	ZoomID
f	2364	\N	(0029,"SPI-P Release 1;1",01)	DS	1-n	ZoomRectangle
f	2365	\N	(0029,"SPI-P Release 1;1",03)	DS	1	ZoomFactor
f	2366	\N	(0029,"SPI-P Release 1;1",04)	US	1	ZoomFunction
f	2367	\N	(0029,"SPI-P Release 1;1",0e)	CS	1	ZoomEnableStatus
f	2368	\N	(0029,"SPI-P Release 1;1",0f)	CS	1	ZoomSelectStatus
f	2369	\N	(0029,"SPI-P Release 1;1",40)	LT	1	MagnifyingGlassID
f	2370	\N	(0029,"SPI-P Release 1;1",41)	DS	1-n	MagnifyingGlassRectangle
f	2371	\N	(0029,"SPI-P Release 1;1",43)	DS	1	MagnifyingGlassFactor
f	2372	\N	(0029,"SPI-P Release 1;1",44)	US	1	MagnifyingGlassFunction
f	2373	\N	(0029,"SPI-P Release 1;1",4e)	CS	1	MagnifyingGlassEnableStatus
f	2374	\N	(0029,"SPI-P Release 1;1",4f)	CS	1	MagnifyingGlassSelectStatus
f	2375	\N	(0029,"SPI-P Release 1;2",00)	LT	1	SubtractionMaskID
f	2376	\N	(0029,"SPI-P Release 1;2",04)	UN	1	MaskingFunction
f	2377	\N	(0029,"SPI-P Release 1;2",0c)	UN	1	ProprietaryMaskingParameters
f	2378	\N	(0029,"SPI-P Release 1;2",1e)	CS	1	SubtractionMaskEnableStatus
f	2379	\N	(0029,"SPI-P Release 1;2",1f)	CS	1	SubtractionMaskSelectStatus
f	2380	\N	(0029,"SPI-P Release 1;3",00)	LT	1	ImageEnhancementID
f	2381	\N	(0029,"SPI-P Release 1;3",01)	LT	1	ImageEnhancement
f	2382	\N	(0029,"SPI-P Release 1;3",02)	LT	1	ConvolutionID
f	2383	\N	(0029,"SPI-P Release 1;3",03)	LT	1	ConvolutionType
f	2384	\N	(0029,"SPI-P Release 1;3",04)	LT	1	ConvolutionKernelSizeID
f	2385	\N	(0029,"SPI-P Release 1;3",05)	US	2	ConvolutionKernelSize
f	2386	\N	(0029,"SPI-P Release 1;3",06)	US	1-n	ConvolutionKernel
f	2387	\N	(0029,"SPI-P Release 1;3",0c)	DS	1	EnhancementGain
f	2388	\N	(0029,"SPI-P Release 1;3",1e)	CS	1	ImageEnhancementEnableStatus
f	2389	\N	(0029,"SPI-P Release 1;3",1f)	CS	1	ImageEnhancementSelectStatus
f	2390	\N	(0011,"SPI-P Release 2;1",18)	LT	1	Unknown
f	2391	\N	(0023,"SPI-P Release 2;1",0d)	UI	1	Unknown
f	2392	\N	(0023,"SPI-P Release 2;1",0e)	UI	1	Unknown
f	2393	\N	(0009,"SPI-P-GV-CT Release 1",00)	LO	1	Unknown
f	2394	\N	(0009,"SPI-P-GV-CT Release 1",10)	LO	1	Unknown
f	2395	\N	(0009,"SPI-P-GV-CT Release 1",20)	LO	1	Unknown
f	2396	\N	(0009,"SPI-P-GV-CT Release 1",30)	LO	1	Unknown
f	2397	\N	(0009,"SPI-P-GV-CT Release 1",40)	LO	1	Unknown
f	2398	\N	(0009,"SPI-P-GV-CT Release 1",50)	LO	1	Unknown
f	2399	\N	(0009,"SPI-P-GV-CT Release 1",60)	LO	1	Unknown
f	2400	\N	(0009,"SPI-P-GV-CT Release 1",70)	LO	1	Unknown
f	2401	\N	(0009,"SPI-P-GV-CT Release 1",75)	LO	1	Unknown
f	2402	\N	(0009,"SPI-P-GV-CT Release 1",80)	LO	1	Unknown
f	2403	\N	(0009,"SPI-P-GV-CT Release 1",90)	LO	1	Unknown
f	2404	\N	(0019,"SPI-P-GV-CT Release 1",08)	IS	1	Unknown
f	2405	\N	(0019,"SPI-P-GV-CT Release 1",09)	IS	1	Unknown
f	2406	\N	(0019,"SPI-P-GV-CT Release 1",0a)	IS	1	Unknown
f	2407	\N	(0019,"SPI-P-GV-CT Release 1",10)	LO	1	Unknown
f	2408	\N	(0019,"SPI-P-GV-CT Release 1",20)	TM	1	Unknown
f	2409	\N	(0019,"SPI-P-GV-CT Release 1",50)	LO	1	Unknown
f	2410	\N	(0019,"SPI-P-GV-CT Release 1",60)	DS	1	Unknown
f	2411	\N	(0019,"SPI-P-GV-CT Release 1",61)	US	1	Unknown
f	2412	\N	(0019,"SPI-P-GV-CT Release 1",63)	LO	1	Unknown
f	2413	\N	(0019,"SPI-P-GV-CT Release 1",64)	US	1	Unknown
f	2414	\N	(0019,"SPI-P-GV-CT Release 1",65)	IS	1	Unknown
f	2415	\N	(0019,"SPI-P-GV-CT Release 1",70)	LT	1	Unknown
f	2416	\N	(0019,"SPI-P-GV-CT Release 1",80)	LO	1	Unknown
f	2417	\N	(0019,"SPI-P-GV-CT Release 1",81)	LO	1	Unknown
f	2418	\N	(0019,"SPI-P-GV-CT Release 1",90)	LO	1	Unknown
f	2419	\N	(0019,"SPI-P-GV-CT Release 1",a0)	LO	1	Unknown
f	2420	\N	(0019,"SPI-P-GV-CT Release 1",a1)	US	1	Unknown
f	2421	\N	(0019,"SPI-P-GV-CT Release 1",a2)	US	1	Unknown
f	2422	\N	(0019,"SPI-P-GV-CT Release 1",a3)	US	1	Unknown
f	2423	\N	(0019,"SPI-P-GV-CT Release 1",b0)	LO	1	Unknown
f	2424	\N	(0019,"SPI-P-GV-CT Release 1",b1)	LO	1	Unknown
f	2425	\N	(0021,"SPI-P-GV-CT Release 1",20)	LO	1	Unknown
f	2426	\N	(0021,"SPI-P-GV-CT Release 1",30)	DS	1	Unknown
f	2427	\N	(0021,"SPI-P-GV-CT Release 1",40)	LO	1	Unknown
f	2428	\N	(0021,"SPI-P-GV-CT Release 1",50)	LO	1	Unknown
f	2429	\N	(0021,"SPI-P-GV-CT Release 1",60)	DS	1	Unknown
f	2430	\N	(0021,"SPI-P-GV-CT Release 1",70)	DS	1	Unknown
f	2431	\N	(0021,"SPI-P-GV-CT Release 1",80)	DS	1	Unknown
f	2432	\N	(0021,"SPI-P-GV-CT Release 1",90)	DS	1	Unknown
f	2433	\N	(0021,"SPI-P-GV-CT Release 1",a0)	US	1	Unknown
f	2434	\N	(0021,"SPI-P-GV-CT Release 1",a1)	DS	1	Unknown
f	2435	\N	(0021,"SPI-P-GV-CT Release 1",a2)	DS	1	Unknown
f	2436	\N	(0021,"SPI-P-GV-CT Release 1",a3)	LT	1	Unknown
f	2437	\N	(0021,"SPI-P-GV-CT Release 1",a4)	LT	1	Unknown
f	2438	\N	(0021,"SPI-P-GV-CT Release 1",b0)	LO	1	Unknown
f	2439	\N	(0021,"SPI-P-GV-CT Release 1",c0)	LO	1	Unknown
f	2440	\N	(0029,"SPI-P-GV-CT Release 1",10)	LO	1	Unknown
f	2441	\N	(0029,"SPI-P-GV-CT Release 1",30)	UL	1	Unknown
f	2442	\N	(0029,"SPI-P-GV-CT Release 1",31)	UL	1	Unknown
f	2443	\N	(0029,"SPI-P-GV-CT Release 1",32)	UL	1	Unknown
f	2444	\N	(0029,"SPI-P-GV-CT Release 1",33)	UL	1	Unknown
f	2445	\N	(0029,"SPI-P-GV-CT Release 1",80)	LO	1	Unknown
f	2446	\N	(0029,"SPI-P-GV-CT Release 1",90)	LO	1	Unknown
f	2447	\N	(0029,"SPI-P-GV-CT Release 1",d0)	IS	1	Unknown
f	2448	\N	(0029,"SPI-P-GV-CT Release 1",d1)	IS	1	Unknown
f	2449	\N	(0019,"SPI-P-PCR Release 2",30)	US	1	Unknown
f	2450	\N	(0021,"SPI-P-Private-CWS Release 1",00)	LT	1	WindowOfImagesID
f	2451	\N	(0021,"SPI-P-Private-CWS Release 1",01)	CS	1	WindowOfImagesType
f	2452	\N	(0021,"SPI-P-Private-CWS Release 1",02)	IS	1-n	WindowOfImagesScope
f	2453	\N	(0019,"SPI-P-Private-DCI Release 1",10)	UN	1	ECGTimeMapDataBitsAllocated
f	2454	\N	(0019,"SPI-P-Private-DCI Release 1",11)	UN	1	ECGTimeMapDataBitsStored
f	2455	\N	(0019,"SPI-P-Private-DCI Release 1",12)	UN	1	ECGTimeMapDataHighBit
f	2456	\N	(0019,"SPI-P-Private-DCI Release 1",13)	UN	1	ECGTimeMapDataRepresentation
f	2457	\N	(0019,"SPI-P-Private-DCI Release 1",14)	UN	1	ECGTimeMapDataSmallestDataValue
f	2458	\N	(0019,"SPI-P-Private-DCI Release 1",15)	UN	1	ECGTimeMapDataLargestDataValue
f	2459	\N	(0019,"SPI-P-Private-DCI Release 1",16)	UN	1	ECGTimeMapDataNumberOfDataValues
f	2460	\N	(0019,"SPI-P-Private-DCI Release 1",17)	UN	1	ECGTimeMapData
f	2461	\N	(0021,"SPI-P-Private_CDS Release 1",40)	IS	1	Unknown
f	2462	\N	(0029,"SPI-P-Private_CDS Release 1",00)	UN	1	Unknown
f	2463	\N	(0019,"SPI-P-Private_ICS Release 1",30)	DS	1	Unknown
f	2464	\N	(0019,"SPI-P-Private_ICS Release 1",31)	LO	1	Unknown
f	2465	\N	(0029,"SPI-P-Private_ICS Release 1",08)	SQ	1	Unknown
f	2466	\N	(0029,"SPI-P-Private_ICS Release 1",0f)	SQ	1	Unknown
f	2467	\N	(0029,"SPI-P-Private_ICS Release 1",10)	SQ	1	Unknown
f	2468	\N	(0029,"SPI-P-Private_ICS Release 1",1b)	SQ	1	Unknown
f	2469	\N	(0029,"SPI-P-Private_ICS Release 1",1c)	SQ	1	Unknown
f	2470	\N	(0029,"SPI-P-Private_ICS Release 1",21)	SQ	1	Unknown
f	2471	\N	(0029,"SPI-P-Private_ICS Release 1",43)	SQ	1	Unknown
f	2472	\N	(0029,"SPI-P-Private_ICS Release 1",44)	SQ	1	Unknown
f	2473	\N	(0029,"SPI-P-Private_ICS Release 1",4C)	SQ	1	Unknown
f	2474	\N	(0029,"SPI-P-Private_ICS Release 1",67)	LO	1	Unknown
f	2475	\N	(0029,"SPI-P-Private_ICS Release 1",68)	US	1	Unknown
f	2476	\N	(0029,"SPI-P-Private_ICS Release 1",6A)	LO	1	Unknown
f	2477	\N	(0029,"SPI-P-Private_ICS Release 1",6B)	US	1	Unknown
f	2478	\N	(0029,"SPI-P-Private_ICS Release 1;1",00)	SL	1	Unknown
f	2479	\N	(0029,"SPI-P-Private_ICS Release 1;1",05)	FL	1	Unknown
f	2480	\N	(0029,"SPI-P-Private_ICS Release 1;1",06)	FL	1	Unknown
f	2481	\N	(0029,"SPI-P-Private_ICS Release 1;1",20)	FL	1	Unknown
f	2482	\N	(0029,"SPI-P-Private_ICS Release 1;1",21)	FL	1	Unknown
f	2483	\N	(0029,"SPI-P-Private_ICS Release 1;1",CD)	SQ	1	Unknown
f	2484	\N	(0029,"SPI-P-Private_ICS Release 1;2",00)	FD	1	Unknown
f	2485	\N	(0029,"SPI-P-Private_ICS Release 1;2",01)	FD	1	Unknown
f	2486	\N	(0029,"SPI-P-Private_ICS Release 1;2",02)	FD	1	Unknown
f	2487	\N	(0029,"SPI-P-Private_ICS Release 1;2",03)	SL	1	Unknown
f	2488	\N	(0029,"SPI-P-Private_ICS Release 1;2",04)	SL	1	Unknown
f	2489	\N	(0029,"SPI-P-Private_ICS Release 1;2",05)	SL	1	Unknown
f	2490	\N	(0029,"SPI-P-Private_ICS Release 1;3",C0)	SQ	1	Unknown
f	2491	\N	(0029,"SPI-P-Private_ICS Release 1;3",C1)	SQ	1	Unknown
f	2492	\N	(0029,"SPI-P-Private_ICS Release 1;3",C2)	SQ	1	Unknown
f	2493	\N	(0029,"SPI-P-Private_ICS Release 1;3",C3)	SQ	1	Unknown
f	2494	\N	(0029,"SPI-P-Private_ICS Release 1;3",C4)	SQ	1	Unknown
f	2495	\N	(0029,"SPI-P-Private_ICS Release 1;3",C5)	SQ	1	Unknown
f	2496	\N	(0029,"SPI-P-Private_ICS Release 1;4",02)	SQ	1	Unknown
f	2497	\N	(0029,"SPI-P-Private_ICS Release 1;4",9A)	SQ	1	Unknown
f	2498	\N	(0029,"SPI-P-Private_ICS Release 1;4",E0)	SQ	1	Unknown
f	2499	\N	(0029,"SPI-P-Private_ICS Release 1;5",50)	CS	1	Unknown
f	2500	\N	(0029,"SPI-P-Private_ICS Release 1;5",55)	CS	1	Unknown
f	2501	\N	(0019,"SPI-P-XSB-DCI Release 1",10)	LT	1	VideoBeamBoost
f	2502	\N	(0019,"SPI-P-XSB-DCI Release 1",11)	US	1	ChannelGeneratingVideoSync
f	2503	\N	(0019,"SPI-P-XSB-DCI Release 1",12)	US	1	VideoGain
f	2504	\N	(0019,"SPI-P-XSB-DCI Release 1",13)	US	1	VideoOffset
f	2505	\N	(0019,"SPI-P-XSB-DCI Release 1",20)	DS	1	RTDDataCompressionFactor
f	2506	\N	(0029,"Silhouette Annot V1.0",11)	IS	1	AnnotationName
f	2507	\N	(0029,"Silhouette Annot V1.0",12)	LT	1	AnnotationFont
f	2508	\N	(0029,"Silhouette Annot V1.0",13)	LT	1	AnnotationTextForegroundColor
f	2509	\N	(0029,"Silhouette Annot V1.0",14)	LT	1	AnnotationTextBackgroundColor
f	2510	\N	(0029,"Silhouette Annot V1.0",15)	UL	1	AnnotationTextBackingMode
f	2511	\N	(0029,"Silhouette Annot V1.0",16)	UL	1	AnnotationTextJustification
f	2512	\N	(0029,"Silhouette Annot V1.0",17)	UL	1	AnnotationTextLocation
f	2513	\N	(0029,"Silhouette Annot V1.0",18)	LT	1	AnnotationTextString
f	2514	\N	(0029,"Silhouette Annot V1.0",19)	UL	1	AnnotationTextAttachMode
f	2515	\N	(0029,"Silhouette Annot V1.0",20)	UL	1	AnnotationTextCursorMode
f	2516	\N	(0029,"Silhouette Annot V1.0",21)	UL	1	AnnotationTextShadowOffsetX
f	2517	\N	(0029,"Silhouette Annot V1.0",22)	UL	1	AnnotationTextShadowOffsetY
f	2518	\N	(0029,"Silhouette Annot V1.0",23)	LT	1	AnnotationLineColor
f	2519	\N	(0029,"Silhouette Annot V1.0",24)	UL	1	AnnotationLineThickness
f	2520	\N	(0029,"Silhouette Annot V1.0",25)	UL	1	AnnotationLineType
f	2521	\N	(0029,"Silhouette Annot V1.0",26)	UL	1	AnnotationLineStyle
f	2522	\N	(0029,"Silhouette Annot V1.0",27)	UL	1	AnnotationLineDashLength
f	2523	\N	(0029,"Silhouette Annot V1.0",28)	UL	1	AnnotationLineAttachMode
f	2524	\N	(0029,"Silhouette Annot V1.0",29)	UL	1	AnnotationLinePointCount
f	2525	\N	(0029,"Silhouette Annot V1.0",30)	FD	1	AnnotationLinePoints
f	2526	\N	(0029,"Silhouette Annot V1.0",31)	UL	1	AnnotationLineControlSize
f	2527	\N	(0029,"Silhouette Annot V1.0",32)	LT	1	AnnotationMarkerColor
f	2528	\N	(0029,"Silhouette Annot V1.0",33)	UL	1	AnnotationMarkerType
f	2529	\N	(0029,"Silhouette Annot V1.0",34)	UL	1	AnnotationMarkerSize
f	2530	\N	(0029,"Silhouette Annot V1.0",35)	FD	1	AnnotationMarkerLocation
f	2531	\N	(0029,"Silhouette Annot V1.0",36)	UL	1	AnnotationMarkerAttachMode
f	2532	\N	(0029,"Silhouette Annot V1.0",37)	LT	1	AnnotationGeomColor
f	2533	\N	(0029,"Silhouette Annot V1.0",38)	UL	1	AnnotationGeomThickness
f	2534	\N	(0029,"Silhouette Annot V1.0",39)	UL	1	AnnotationGeomLineStyle
f	2535	\N	(0029,"Silhouette Annot V1.0",40)	UL	1	AnnotationGeomDashLength
f	2536	\N	(0029,"Silhouette Annot V1.0",41)	UL	1	AnnotationGeomFillPattern
f	2537	\N	(0029,"Silhouette Annot V1.0",42)	UL	1	AnnotationInteractivity
f	2538	\N	(0029,"Silhouette Annot V1.0",43)	FD	1	AnnotationArrowLength
f	2539	\N	(0029,"Silhouette Annot V1.0",44)	FD	1	AnnotationArrowAngle
f	2540	\N	(0029,"Silhouette Annot V1.0",45)	UL	1	AnnotationDontSave
f	2541	\N	(0029,"Silhouette Graphics Export V1.0",00)	UI	1	Unknown
f	2542	\N	(0029,"Silhouette Line V1.0",11)	IS	1	LineName
f	2543	\N	(0029,"Silhouette Line V1.0",12)	LT	1	LineNameFont
f	2544	\N	(0029,"Silhouette Line V1.0",13)	UL	1	LineNameDisplay
f	2545	\N	(0029,"Silhouette Line V1.0",14)	LT	1	LineNormalColor
f	2546	\N	(0029,"Silhouette Line V1.0",15)	UL	1	LineType
f	2547	\N	(0029,"Silhouette Line V1.0",16)	UL	1	LineThickness
f	2548	\N	(0029,"Silhouette Line V1.0",17)	UL	1	LineStyle
f	2549	\N	(0029,"Silhouette Line V1.0",18)	UL	1	LineDashLength
f	2550	\N	(0029,"Silhouette Line V1.0",19)	UL	1	LineInteractivity
f	2551	\N	(0029,"Silhouette Line V1.0",20)	LT	1	LineMeasurementColor
f	2552	\N	(0029,"Silhouette Line V1.0",21)	LT	1	LineMeasurementFont
f	2553	\N	(0029,"Silhouette Line V1.0",22)	UL	1	LineMeasurementDashLength
f	2554	\N	(0029,"Silhouette Line V1.0",23)	UL	1	LinePointSpace
f	2555	\N	(0029,"Silhouette Line V1.0",24)	FD	1	LinePoints
f	2556	\N	(0029,"Silhouette Line V1.0",25)	UL	1	LineControlPointSize
f	2557	\N	(0029,"Silhouette Line V1.0",26)	UL	1	LineControlPointSpace
f	2558	\N	(0029,"Silhouette Line V1.0",27)	FD	1	LineControlPoints
f	2559	\N	(0029,"Silhouette Line V1.0",28)	LT	1	LineLabel
f	2560	\N	(0029,"Silhouette Line V1.0",29)	UL	1	LineDontSave
f	2561	\N	(0029,"Silhouette ROI V1.0",11)	IS	1	ROIName
f	2562	\N	(0029,"Silhouette ROI V1.0",12)	LT	1	ROINameFont
f	2563	\N	(0029,"Silhouette ROI V1.0",13)	LT	1	ROINormalColor
f	2564	\N	(0029,"Silhouette ROI V1.0",14)	UL	1	ROIFillPattern
f	2565	\N	(0029,"Silhouette ROI V1.0",15)	UL	1	ROIBpSeg
f	2566	\N	(0029,"Silhouette ROI V1.0",16)	UN	1	ROIBpSegPairs
f	2567	\N	(0029,"Silhouette ROI V1.0",17)	UL	1	ROISeedSpace
f	2568	\N	(0029,"Silhouette ROI V1.0",18)	UN	1	ROISeeds
f	2569	\N	(0029,"Silhouette ROI V1.0",19)	UL	1	ROILineThickness
f	2570	\N	(0029,"Silhouette ROI V1.0",20)	UL	1	ROILineStyle
f	2571	\N	(0029,"Silhouette ROI V1.0",21)	UL	1	ROILineDashLength
f	2572	\N	(0029,"Silhouette ROI V1.0",22)	UL	1	ROIInteractivity
f	2573	\N	(0029,"Silhouette ROI V1.0",23)	UL	1	ROINamePosition
f	2574	\N	(0029,"Silhouette ROI V1.0",24)	UL	1	ROINameDisplay
f	2575	\N	(0029,"Silhouette ROI V1.0",25)	LT	1	ROILabel
f	2576	\N	(0029,"Silhouette ROI V1.0",26)	UL	1	ROIShape
f	2577	\N	(0029,"Silhouette ROI V1.0",27)	FD	1	ROIShapeTilt
f	2578	\N	(0029,"Silhouette ROI V1.0",28)	UL	1	ROIShapePointsCount
f	2579	\N	(0029,"Silhouette ROI V1.0",29)	UL	1	ROIShapePointsSpace
f	2580	\N	(0029,"Silhouette ROI V1.0",30)	FD	1	ROIShapePoints
f	2581	\N	(0029,"Silhouette ROI V1.0",31)	UL	1	ROIShapeControlPointsCount
f	2582	\N	(0029,"Silhouette ROI V1.0",32)	UL	1	ROIShapeControlPointsSpace
f	2583	\N	(0029,"Silhouette ROI V1.0",33)	FD	1	ROIShapeControlPoints
f	2584	\N	(0029,"Silhouette ROI V1.0",34)	UL	1	ROIDontSave
f	2585	\N	(0029,"Silhouette Sequence Ids V1.0",41)	SQ	1	Unknown
f	2586	\N	(0029,"Silhouette Sequence Ids V1.0",42)	SQ	1	Unknown
f	2587	\N	(0029,"Silhouette Sequence Ids V1.0",43)	SQ	1	Unknown
f	2588	\N	(0029,"Silhouette V1.0",13)	UL	1	Unknown
f	2589	\N	(0029,"Silhouette V1.0",14)	UL	1	Unknown
f	2590	\N	(0029,"Silhouette V1.0",17)	UN	1	Unknown
f	2591	\N	(0029,"Silhouette V1.0",18)	UN	1	Unknown
f	2592	\N	(0029,"Silhouette V1.0",19)	UL	1	Unknown
f	2593	\N	(0029,"Silhouette V1.0",1a)	UN	1	Unknown
f	2594	\N	(0029,"Silhouette V1.0",1b)	UL	1	Unknown
f	2595	\N	(0029,"Silhouette V1.0",1c)	UL	1	Unknown
f	2596	\N	(0029,"Silhouette V1.0",1d)	UN	1	Unknown
f	2597	\N	(0029,"Silhouette V1.0",1e)	UN	1	Unknown
f	2598	\N	(0029,"Silhouette V1.0",21)	US	1	Unknown
f	2599	\N	(0029,"Silhouette V1.0",22)	US	1	Unknown
f	2600	\N	(0029,"Silhouette V1.0",23)	US	1	Unknown
f	2601	\N	(0029,"Silhouette V1.0",24)	US	1	Unknown
f	2602	\N	(0029,"Silhouette V1.0",25)	US	1	Unknown
f	2603	\N	(0029,"Silhouette V1.0",27)	UN	1	Unknown
f	2604	\N	(0029,"Silhouette V1.0",28)	UN	1	Unknown
f	2605	\N	(0029,"Silhouette V1.0",29)	UN	1	Unknown
f	2606	\N	(0029,"Silhouette V1.0",30)	UN	1	Unknown
f	2607	\N	(0029,"Silhouette V1.0",52)	US	1	Unknown
f	2608	\N	(0029,"Silhouette V1.0",53)	LT	1	Unknown
f	2609	\N	(0029,"Silhouette V1.0",54)	UN	1	Unknown
f	2610	\N	(0029,"Silhouette V1.0",55)	LT	1	Unknown
f	2611	\N	(0029,"Silhouette V1.0",56)	LT	1	Unknown
f	2612	\N	(0029,"Silhouette V1.0",57)	UN	1	Unknown
f	2613	\N	(0135,"SONOWAND AS",10)	LO	1	UltrasoundScannerName
f	2614	\N	(0135,"SONOWAND AS",11)	LO	1	TransducerSerial
f	2615	\N	(0135,"SONOWAND AS",12)	LO	1	ProbeApplication
f	2616	\N	(0017,"SVISION",00)	LO	1	ExtendedBodyPart
f	2617	\N	(0017,"SVISION",10)	LO	1	ExtendedViewPosition
f	2618	\N	(0017,"SVISION",F0)	IS	1	ImagesSOPClass
f	2619	\N	(0019,"SVISION",00)	IS	1	AECField
f	2620	\N	(0019,"SVISION",01)	IS	1	AECFilmScreen
f	2621	\N	(0019,"SVISION",02)	IS	1	AECDensity
f	2622	\N	(0019,"SVISION",10)	IS	1	PatientThickness
f	2623	\N	(0019,"SVISION",18)	IS	1	BeamDistance
f	2624	\N	(0019,"SVISION",20)	IS	1	WorkstationNumber
f	2625	\N	(0019,"SVISION",28)	IS	1	TubeNumber
f	2626	\N	(0019,"SVISION",30)	IS	1	BuckyGrid
f	2627	\N	(0019,"SVISION",34)	IS	1	Focus
f	2628	\N	(0019,"SVISION",38)	IS	1	Child
f	2629	\N	(0019,"SVISION",40)	IS	1	CollimatorDistanceX
f	2630	\N	(0019,"SVISION",41)	IS	1	CollimatorDistanceY
f	2631	\N	(0019,"SVISION",50)	IS	1	CentralBeamHeight
f	2632	\N	(0019,"SVISION",60)	IS	1	BuckyAngle
f	2633	\N	(0019,"SVISION",68)	IS	1	CArmAngle
f	2634	\N	(0019,"SVISION",69)	IS	1	CollimatorAngle
f	2635	\N	(0019,"SVISION",70)	IS	1	FilterNumber
f	2636	\N	(0019,"SVISION",74)	LO	1	FilterMaterial1
f	2637	\N	(0019,"SVISION",75)	LO	1	FilterMaterial2
f	2638	\N	(0019,"SVISION",78)	DS	1	FilterThickness1
f	2639	\N	(0019,"SVISION",79)	DS	1	FilterThickness2
f	2640	\N	(0019,"SVISION",80)	IS	1	BuckyFormat
f	2641	\N	(0019,"SVISION",81)	IS	1	ObjectPosition
f	2642	\N	(0019,"SVISION",90)	LO	1	DeskCommand
f	2643	\N	(0019,"SVISION",A0)	DS	1	ExtendedExposureTime
f	2644	\N	(0019,"SVISION",A1)	DS	1	ActualExposureTime
f	2645	\N	(0019,"SVISION",A8)	DS	1	ExtendedXRayTubeCurrent
f	2646	\N	(0021,"SVISION",00)	DS	1	NoiseReduction
f	2647	\N	(0021,"SVISION",01)	DS	1	ContrastAmplification
f	2648	\N	(0021,"SVISION",02)	DS	1	EdgeContrastBoosting
f	2649	\N	(0021,"SVISION",03)	DS	1	LatitudeReduction
f	2650	\N	(0021,"SVISION",10)	LO	1	FindRangeAlgorithm
f	2651	\N	(0021,"SVISION",11)	DS	1	ThresholdCAlgorithm
f	2652	\N	(0021,"SVISION",20)	LO	1	SensometricCurve
f	2653	\N	(0021,"SVISION",30)	DS	1	LowerWindowOffset
f	2654	\N	(0021,"SVISION",31)	DS	1	UpperWindowOffset
f	2655	\N	(0021,"SVISION",40)	DS	1	MinPrintableDensity
f	2656	\N	(0021,"SVISION",41)	DS	1	MaxPrintableDensity
f	2657	\N	(0021,"SVISION",90)	DS	1	Brightness
f	2658	\N	(0021,"SVISION",91)	DS	1	Contrast
f	2659	\N	(0021,"SVISION",92)	DS	1	ShapeFactor
f	2660	\N	(0023,"SVISION",00)	LO	1	ImageLaterality
f	2661	\N	(0023,"SVISION",01)	IS	1	LetterPosition
f	2662	\N	(0023,"SVISION",02)	IS	1	BurnedInAnnotation
f	2663	\N	(0023,"SVISION",03)	LO	1	Unknown
f	2664	\N	(0023,"SVISION",F0)	IS	1	ImageSOPClass
f	2665	\N	(0025,"SVISION",00)	IS	1	OriginalImage
f	2666	\N	(0025,"SVISION",01)	IS	1	NotProcessedImage
f	2667	\N	(0025,"SVISION",02)	IS	1	CutOutImage
f	2668	\N	(0025,"SVISION",03)	IS	1	DuplicatedImage
f	2669	\N	(0025,"SVISION",04)	IS	1	StoredImage
f	2670	\N	(0025,"SVISION",05)	IS	1	RetrievedImage
f	2671	\N	(0025,"SVISION",06)	IS	1	RemoteImage
f	2672	\N	(0025,"SVISION",07)	IS	1	MediaStoredImage
f	2673	\N	(0025,"SVISION",08)	IS	1	ImageState
f	2674	\N	(0025,"SVISION",20)	LO	1	SourceImageFile
f	2675	\N	(0025,"SVISION",21)	UI	1	Unknown
f	2676	\N	(0027,"SVISION",00)	IS	1	NumberOfSeries
f	2677	\N	(0027,"SVISION",01)	IS	1	NumberOfStudies
f	2678	\N	(0027,"SVISION",10)	DT	1	OldestSeries
f	2679	\N	(0027,"SVISION",11)	DT	1	NewestSeries
f	2680	\N	(0027,"SVISION",12)	DT	1	OldestStudy
f	2681	\N	(0027,"SVISION",13)	DT	1	NewestStudy
f	2682	\N	(0009,"TOSHIBA_MEC_1.0",01)	LT	1	Unknown
f	2683	\N	(0009,"TOSHIBA_MEC_1.0",02)	US	1-n	Unknown
f	2684	\N	(0009,"TOSHIBA_MEC_1.0",03)	US	1-n	Unknown
f	2685	\N	(0009,"TOSHIBA_MEC_1.0",04)	US	1-n	Unknown
f	2686	\N	(0011,"TOSHIBA_MEC_1.0",01)	LT	1	Unknown
f	2687	\N	(0011,"TOSHIBA_MEC_1.0",02)	US	1-n	Unknown
f	2688	\N	(0019,"TOSHIBA_MEC_1.0",01)	US	1-n	Unknown
f	2689	\N	(0019,"TOSHIBA_MEC_1.0",02)	US	1-n	Unknown
f	2690	\N	(0021,"TOSHIBA_MEC_1.0",01)	US	1-n	Unknown
f	2691	\N	(0021,"TOSHIBA_MEC_1.0",02)	US	1-n	Unknown
f	2692	\N	(0021,"TOSHIBA_MEC_1.0",03)	US	1-n	Unknown
f	2693	\N	(7ff1,"TOSHIBA_MEC_1.0",01)	US	1-n	Unknown
f	2694	\N	(7ff1,"TOSHIBA_MEC_1.0",02)	US	1-n	Unknown
f	2695	\N	(7ff1,"TOSHIBA_MEC_1.0",03)	US	1-n	Unknown
f	2696	\N	(7ff1,"TOSHIBA_MEC_1.0",10)	US	1-n	Unknown
f	2697	\N	(0019,"TOSHIBA_MEC_CT_1.0",01)	IS	1	Unknown
f	2698	\N	(0019,"TOSHIBA_MEC_CT_1.0",02)	IS	1	Unknown
f	2699	\N	(0019,"TOSHIBA_MEC_CT_1.0",03)	US	1-n	Unknown
f	2700	\N	(0019,"TOSHIBA_MEC_CT_1.0",04)	LT	1	Unknown
f	2701	\N	(0019,"TOSHIBA_MEC_CT_1.0",05)	LT	1	Unknown
f	2702	\N	(0019,"TOSHIBA_MEC_CT_1.0",06)	US	1-n	Unknown
f	2703	\N	(0019,"TOSHIBA_MEC_CT_1.0",07)	US	1-n	Unknown
f	2704	\N	(0019,"TOSHIBA_MEC_CT_1.0",08)	LT	1	OrientationHeadFeet
f	2705	\N	(0019,"TOSHIBA_MEC_CT_1.0",09)	LT	1	ViewDirection
f	2706	\N	(0019,"TOSHIBA_MEC_CT_1.0",0a)	LT	1	OrientationSupineProne
f	2707	\N	(0019,"TOSHIBA_MEC_CT_1.0",0b)	DS	1	Unknown
f	2708	\N	(0019,"TOSHIBA_MEC_CT_1.0",0c)	US	1-n	Unknown
f	2709	\N	(0019,"TOSHIBA_MEC_CT_1.0",0d)	TM	1	Time
f	2710	\N	(0019,"TOSHIBA_MEC_CT_1.0",0e)	DS	1	Unknown
f	2711	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",01)	US	1-n	Unknown
f	2712	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",02)	US	1-n	Unknown
f	2713	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",03)	IS	1	Unknown
f	2714	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",04)	IS	1	Unknown
f	2715	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",05)	US	1-n	Unknown
f	2716	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",07)	US	1-n	Unknown
f	2717	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",08)	US	1-n	Unknown
f	2718	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",09)	US	1-n	Unknown
f	2719	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",0a)	LT	1	Unknown
f	2720	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",0b)	US	1-n	Unknown
f	2721	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",0c)	US	1-n	Unknown
f	2722	\N	(7ff1,"TOSHIBA_MEC_CT_1.0",0d)	US	1-n	Unknown
\.


--
-- Data for Name: pt_dicom3; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt_dicom3 (pt_dicom3_is_repeating, pt_id, ptrg_id, pt_dicom3_tag, pt_dicom3_vr, pt_dicom3_vm, pt_dicom3_name, pt_dicom3_keyword, pt_dicom3_owner, pt_dicom3_vers, pt_dicom3_comment, pt_dicom3_assumption, pt_dicom3_private_block) FROM stdin;
f	8	\N	(0009,0000)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	9	\N	(0009,0001)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	10	\N	(0009,0002)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	11	\N	(0009,0003)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	12	\N	(0009,0004)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	13	\N	(0009,0005)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	14	\N	(0009,0006)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	15	\N	(0009,0007)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	16	\N	(0009,0008)	LT	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	17	\N	(0009,0009)	LT	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	18	\N	(0009,000a)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	19	\N	(0009,000b)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	20	\N	(0009,000c)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	21	\N	(0009,000d)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	22	\N	(0009,000e)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	23	\N	(0009,000f)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	24	\N	(0009,0010)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	25	\N	(0009,0011)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	26	\N	(0009,0012)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	27	\N	(0009,0013)	IS	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	28	\N	(0009,0014)	LT	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	29	\N	(0009,0015)	UN	1	Unknown	Unknown	ACUSON	ACU	\N	\N	\N
f	2723	\N	(0009,0000)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2724	\N	(0009,0001)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2725	\N	(0009,0002)	LO	1	Patient Registration Custom Field 1	PatientRegistrationCustomField1	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2726	\N	(0009,0003)	LO	1	Patient Registration Custom Field 2	PatientRegistrationCustomField2	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2727	\N	(0009,0004)	LO	1	Indications	Indications	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2728	\N	(0009,000f)	LT	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:0910	ACU	\N	\N	\N
f	2729	\N	(7fdf,0002)	US	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2730	\N	(7fdf,000b)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2731	\N	(7fdf,000c)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2732	\N	(7fdf,0020)	FL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2733	\N	(7fdf,0022)	FL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2734	\N	(7fdf,0000)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2735	\N	(7fdf,0001)	US	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2736	\N	(7fdf,000d)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2737	\N	(7fdf,0010)	SH	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2738	\N	(7fdf,0024)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2739	\N	(7fdf,0025)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2740	\N	(7fdf,0026)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2741	\N	(7fdf,0027)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2742	\N	(7fdf,0028)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2743	\N	(7fdf,0029)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2744	\N	(7fdf,002a)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2745	\N	(7fdf,002b)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2746	\N	(7fdf,002c)	UL	1-n	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2747	\N	(7fdf,0030)	SQ	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2748	\N	(7fdf,0031)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2749	\N	(7fdf,0032)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2750	\N	(7fdf,0033)	FL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2751	\N	(7fdf,0034)	FL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2752	\N	(7fdf,0035)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2753	\N	(7fdf,0036)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2754	\N	(7fdf,0037)	FL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2755	\N	(7fdf,0038)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2756	\N	(7fdf,0050)	SH	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2757	\N	(7fdf,0052)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2758	\N	(7fdf,0054)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2759	\N	(7fdf,0060)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2760	\N	(7fdf,0061)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2761	\N	(7fdf,0062)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2762	\N	(7fdf,0063)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2763	\N	(7fdf,0064)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2764	\N	(7fdf,0065)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2765	\N	(7fdf,0066)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2766	\N	(7fdf,0067)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2767	\N	(7fdf,0068)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2768	\N	(7fdf,0069)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2769	\N	(7fdf,006a)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2770	\N	(7fdf,006b)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2771	\N	(7fdf,006c)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2772	\N	(7fdf,0072)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2773	\N	(7fdf,0073)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2774	\N	(7fdf,0074)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2775	\N	(7fdf,0075)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2776	\N	(7fdf,0076)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2777	\N	(7fdf,0077)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2778	\N	(7fdf,0078)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2779	\N	(7fdf,0079)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2780	\N	(7fdf,007a)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2781	\N	(7fdf,007b)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2782	\N	(7fdf,007c)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2783	\N	(7fdf,007d)	LO	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2784	\N	(7fdf,007e)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2785	\N	(7fdf,007f)	SL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2786	\N	(7fdf,0080)	UL	1-n	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2787	\N	(7fdf,0081)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2788	\N	(7fdf,0082)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2789	\N	(7fdf,0083)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2790	\N	(7fdf,0085)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2791	\N	(7fdf,0089)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2792	\N	(7fdf,008a)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2793	\N	(7fdf,008b)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2794	\N	(7fdf,008c)	UL	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2795	\N	(7fdf,008d)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2796	\N	(7fdf,0086)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2797	\N	(7fdf,0088)	FD	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2798	\N	(7fdf,00f1)	UL	1-n	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2799	\N	(7fdf,00f5)	IS	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7f10	ACU	\N	\N	\N
f	2800	\N	(7fdf,0000)	OB	1	Unknown	Unknown	ACUSON:1.2.840.113680.1.0:7ffe	ACU	\N	\N	\N
f	36	\N	(0009,0010)	LO	1	Unknown	Unknown	AGFA	AGFA	\N	\N	\N
f	37	\N	(0009,0011)	LO	1	Unknown	Unknown	AGFA	AGFA	\N	\N	\N
f	38	\N	(0009,0013)	LO	1	Unknown	Unknown	AGFA	AGFA	\N	\N	\N
f	39	\N	(0009,0014)	LO	1	Unknown	Unknown	AGFA	AGFA	\N	\N	\N
f	40	\N	(0009,0015)	LO	1	Unknown	Unknown	AGFA	AGFA	\N	\N	\N
f	2801	\N	(0011,0020)	LO	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2802	\N	(0011,0021)	LO	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2803	\N	(0011,0022)	LO	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2804	\N	(0011,0011)	SH	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2805	\N	(0019,00a0)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2806	\N	(0019,00a1)	FL	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2807	\N	(0019,00a2)	FL	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2808	\N	(0019,00a3)	FL	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2809	\N	(0019,00a4)	FL	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2810	\N	(0019,0005)	ST	1	Cassette Data Stream	CassetteDataStream	AGFA	AGFA	\N	\N	\N
f	2811	\N	(0019,0010)	ST	1	Image Processing Parameters	ImageProcessingParameters	AGFA	AGFA	\N	\N	\N
f	2812	\N	(0019,0011)	LO	1	Identification Data	IdentificationData	AGFA	AGFA	\N	\N	\N
f	2813	\N	(0019,0013)	LO	1	Sensitometry Name	SensitometryName	AGFA	AGFA	\N	\N	\N
f	2814	\N	(0019,0014)	ST	1	Window Level List	WindowLevelList	AGFA	AGFA	\N	\N	\N
f	2815	\N	(0019,0015)	LO	1	Dose Monitoring	DoseMonitoring	AGFA	AGFA	\N	\N	\N
f	2816	\N	(0019,0016)	LO	1	Other Info	OtherInfo	AGFA	AGFA	\N	\N	\N
f	2817	\N	(0019,001a)	LO	1	Clipped Exposure Deviation	ClippedExposureDeviation	AGFA	AGFA	\N	\N	\N
f	2818	\N	(0019,001b)	LO	1	Logarithmic PLT Full Scale	Logarithmic PLT Full Scale	AGFA	AGFA	\N	\N	\N
f	2819	\N	(0019,0060)	US	1	Total Number Series	TotalNumberSeries	AGFA	AGFA	\N	\N	\N
f	2820	\N	(0019,0061)	SH	1	Session Number	SessionNumber	AGFA	AGFA	\N	\N	\N
f	2821	\N	(0019,0062)	SH	1	ID Station Name	IDStationName	AGFA	AGFA	\N	\N	\N
f	2822	\N	(0019,0065)	US	1	Number of Images in Study to be Transmitted	NumberOfImagesInStudyToBeTransmitted	AGFA	AGFA	\N	\N	\N
f	2823	\N	(0019,0070)	US	1	Total Number Images	TotalNumberImages	AGFA	AGFA	\N	\N	\N
f	2824	\N	(0019,0080)	ST	1	Geometrical Transformations	GeometricalTransformations	AGFA	AGFA	\N	\N	\N
f	2825	\N	(0019,0081)	ST	1	Roam Origin	RoamOrigin	AGFA	AGFA	\N	\N	\N
f	2826	\N	(0019,0082)	US	1	Zoom Factor	ZoomFactor	AGFA	AGFA	\N	\N	\N
f	2827	\N	(0019,0093)	CS	1	Status	Status	AGFA	AGFA	\N	\N	\N
f	2828	\N	(0019,0030)	ST	1	Data stream from cassette	DataStreamFromCassette	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2828	\N	(0019,0030)	ST	1	Set of destination types	SetOfDestinationTypes	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2829	\N	(0019,0040)	ST	1	Set of destination Ids	SetOfDestinationIds	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2830	\N	(0019,0050)	ST	1	Set of processing codes	SetOfProcessingCodes	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2831	\N	(0019,0060)	US	1	Number of series in study	NumberOfSeriesInStudy	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2832	\N	(0019,0061)	US	1	Session Number	SessionNumber	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2833	\N	(0019,0062)	SH	1	ID station name	IDStationName	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2834	\N	(0019,0070)	US	1	Number of images in series	NumberOfImagesInSeries	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2835	\N	(0019,0071)	US	1	Break condition	BreakCondition	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2836	\N	(0019,0072)	US	1	Wait (or Hold) flag	WaitOrHoldFlag	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2837	\N	(0019,0073)	US	1	ScanRes flag	ScanResFlag	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2838	\N	(0019,0074)	SH	1	Operation code	OperationCode	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2839	\N	(0019,0095)	CS	1	Image quality	ImageQuality	AGFA_ADC_Compact	AGFA	\N	\N	\N
f	2840	\N	(0019,0007)	CS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2841	\N	(0019,0009)	SQ	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2842	\N	(0019,0021)	FL	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2843	\N	(0019,0028)	CS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2844	\N	(0019,00f0)	LO	1	User Defined field 1	UserDefinedField1	Agfa ADC NX	AGFA	\N	\N	\N
f	2845	\N	(0019,00f1)	LO	1	User Defined field 2	UserDefinedField2	Agfa ADC NX	AGFA	\N	\N	\N
f	2846	\N	(0019,00f2)	LO	1	User Defined field 3	UserDefinedField3	Agfa ADC NX	AGFA	\N	\N	\N
f	2847	\N	(0019,00f3)	LO	1	User Defined field 4	UserDefinedField4	Agfa ADC NX	AGFA	\N	\N	\N
f	2848	\N	(0019,00f4)	LO	1	User Defined field 5	UserDefinedField5	Agfa ADC NX	AGFA	\N	\N	\N
f	2849	\N	(0019,00f5)	CS	1	Cassette Orientation	CassetteOrientation	Agfa ADC NX	AGFA	\N	\N	\N
f	2850	\N	(0019,00f6)	DS	1	Plate Sensitivity	PlateSensitivity	Agfa ADC NX	AGFA	\N	\N	\N
f	2851	\N	(0019,00f7)	DS	1	Plate Erasability	PlateErasability	Agfa ADC NX	AGFA	\N	\N	\N
f	2852	\N	(0019,00f8)	IS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2853	\N	(0019,00fa)	IS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2854	\N	(0019,00fc)	IS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2855	\N	(0019,00fd)	CS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2856	\N	(0019,00fe)	CS	1	Unknown	Unknown	Agfa ADC NX	AGFA	\N	\N	\N
f	2857	\N	(0031,0000)	CS	1	Unknown	Unknown	AGFA PACS Archive Mirroring 1.0	MIT	\N	\N	\N
f	2858	\N	(0031,0001)	UL	1	Unknown	Unknown	AGFA PACS Archive Mirroring 1.0	MIT	\N	\N	\N
f	2859	\N	(0029,0000)	CS	1	Rotation	Rotation	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2860	\N	(0029,0001)	LO	1	Window Width	WindowWidth	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2861	\N	(0029,0002)	LO	1	Window Centre	WindowCentre	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2862	\N	(0029,0003)	IS	1	Invert	Invert	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2863	\N	(0029,0004)	IS	1	Has Tabstop	HasTabstop	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2864	\N	(0029,0005)	CS	1	Smooth Rotation	SmoothRotation	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2865	\N	(0029,0010)	CS	1	Unknown	Unknown	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2866	\N	(0029,0011)	CS	1	Unknown	Unknown	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2867	\N	(0029,0012)	CS	1	Unknown	Unknown	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2868	\N	(0029,0013)	CS	1	Unknown	Unknown	MITRA PRESENTATION 1.0	MIT	\N	\N	\N
f	2869	\N	(0029,0000)	OB	1	IMPAX Object Document	IMPAXObjectDocument	MITRA OBJECT DOCUMENT 1.0	MIT	\N	\N	\N
f	2870	\N	(0029,0001)	OB	1	IMPAX Markup XML Stored	IMPAXMarkupXMLStored	MITRA OBJECT DOCUMENT 1.0	MIT	\N	\N	\N
f	2871	\N	(0029,0000)	OB	1-n	Markup1	Markup1	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2872	\N	(0029,0001)	OB	1-n	Markup2	Markup2	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2873	\N	(0029,0002)	OB	1-n	Markup3	Markup3	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2874	\N	(0029,0003)	OB	1-n	Markup4	Markup4	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2875	\N	(0029,0004)	OB	1-n	Markup5	Markup5	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2876	\N	(0029,0005)	OB	1-n	Markup6	Markup6	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2877	\N	(0029,0006)	OB	1-n	Markup7	Markup7	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2878	\N	(0029,0007)	OB	1-n	Markup8	Markup8	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2879	\N	(0029,0008)	OB	1-n	Markup9	Markup9	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2880	\N	(0029,0009)	OB	1-n	Markup10	Markup10	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2881	\N	(0029,0010)	OB	1-n	Markup11	Markup11	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2882	\N	(0029,0011)	OB	1-n	Markup12	Markup12	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2883	\N	(0029,0012)	OB	1-n	Markup13	Markup13	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2884	\N	(0029,0013)	OB	1-n	Markup14	Markup14	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2885	\N	(0029,0014)	OB	1-n	Markup14	Markup15	MITRA MARKUP 1.0	MIT	\N	\N	\N
f	2886	\N	(0029,0011)	CS	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2887	\N	(0029,0012)	US	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2888	\N	(0029,0013)	US	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2889	\N	(0029,0014)	US	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2890	\N	(0029,001f)	US	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2890	\N	(0029,001f)	US	1	Unknown	Unknown	AgilityRuntime	AGFA	\N	\N	\N
f	2891	\N	(0031,0020)	IS	1	Unknown	Unknown	MITRA LINKED ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2892	\N	(0033,0002)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2893	\N	(0033,0004)	CS	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2894	\N	(0033,0006)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2895	\N	(0033,0008)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2896	\N	(0033,000a)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2897	\N	(0033,000c)	LO	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2898	\N	(0033,000e)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2899	\N	(0033,0013)	PN	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2900	\N	(0033,0014)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2901	\N	(0033,0015)	OB	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2902	\N	(0033,0016)	PN	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2903	\N	(0033,0019)	PN	1	Unknown	Unknown	MITRA OBJECT UTF8 ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2904	\N	(0033,0002)	LO	1	Unknown	Unknown	MITRA OBJECT ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2905	\N	(0033,0004)	LO	1	Unknown	Unknown	MITRA OBJECT ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2906	\N	(0033,0006)	LO	1	Unknown	Unknown	MITRA OBJECT ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2907	\N	(0033,0008)	LO	1	Unknown	Unknown	MITRA OBJECT ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2908	\N	(0033,000a)	LO	1	Unknown	Unknown	MITRA OBJECT ATTRIBUTES 1.0	MIT	\N	\N	\N
f	2909	\N	(0071,0018)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2910	\N	(0071,0019)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2911	\N	(0071,001a)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2912	\N	(0071,001c)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2913	\N	(0071,001e)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2914	\N	(0071,0020)	FL	1-n	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2915	\N	(0071,0021)	FD	1-n	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2916	\N	(0071,0022)	FD	1-n	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2917	\N	(0071,0023)	FD	1-n	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2918	\N	(0071,0024)	FD	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2919	\N	(0071,002b)	FD	1-n	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2920	\N	(0071,002c)	FD	3	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2921	\N	(0071,002d)	FD	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2922	\N	(0071,0001)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2923	\N	(0071,0002)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2924	\N	(0071,0003)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2925	\N	(0071,0005)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2926	\N	(0071,0006)	SQ	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2927	\N	(0071,0007)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2928	\N	(0071,0008)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2929	\N	(0071,0009)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2930	\N	(0071,000a)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2931	\N	(0071,0010)	FL	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2932	\N	(0071,0011)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2933	\N	(0071,0012)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2934	\N	(0071,0013)	US	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2935	\N	(0071,0014)	US	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2936	\N	(0071,0015)	FD	1-n	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2937	\N	(0071,0016)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2938	\N	(0071,0017)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2939	\N	(0071,0018)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2940	\N	(0071,0019)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2941	\N	(0071,001b)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2942	\N	(0071,001c)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2943	\N	(0071,001d)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2944	\N	(0071,0022)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2945	\N	(0071,002c)	ST	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2946	\N	(0071,002d)	SQ	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2947	\N	(0071,002e)	US	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2948	\N	(0071,0050)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2949	\N	(0071,0051)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2950	\N	(0071,0052)	LT	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2951	\N	(0071,0053)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2952	\N	(0071,0054)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2953	\N	(0071,0055)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2954	\N	(0071,0056)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2955	\N	(0071,0057)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2956	\N	(0071,0059)	FL	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2957	\N	(0071,005a)	FL	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2958	\N	(0071,005b)	FL	2	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2959	\N	(0071,005c)	FL	4	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2960	\N	(0071,005d)	CS	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2961	\N	(0071,0060)	FD	1	Unknown	Unknown	AgilityOverlay	AGFA	\N	\N	\N
f	2962	\N	(0073,0023)	SH	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2963	\N	(0073,0024)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2964	\N	(0073,0028)	SQ	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2965	\N	(0073,0080)	FL	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2966	\N	(0075,0010)	LO	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2967	\N	(0087,0001)	LO	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2968	\N	(0087,0002)	LO	1	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2969	\N	(0087,0003)	SL	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2970	\N	(0087,0004)	SL	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2971	\N	(0087,0005)	FD	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2972	\N	(0087,0006)	FD	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2973	\N	(0087,0007)	FD	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2974	\N	(0087,0008)	FD	2	Unknown	Unknown	AGFA-AG_HPState	AGFA	\N	\N	\N
f	2975	\N	(0035,0000)	SH	1	Unknown	Unknown	AGFA KOSD 1.0	AGFA	\N	\N	\N
f	2976	\N	(0035,0003)	LT	1	Unknown	Unknown	AGFA KOSD 1.0	AGFA	\N	\N	\N
f	2977	\N	(2e13,0010)	IS	1	Unknown	Unknown	agfa/displayableImages	AGFA	\N	\N	\N
f	2978	\N	(2e13,0011)	IS	1	Unknown	Unknown	agfa/displayableImages	AGFA	\N	\N	\N
f	2979	\N	(7fdb,0099)	LO	1	Unknown	Unknown	agfa/xeroverse	AGFA	\N	\N	\N
f	2980	\N	(0009,0004)	IS	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2981	\N	(0009,0006)	IS	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2982	\N	(0009,0009)	LO	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2983	\N	(0009,0016)	AE	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2984	\N	(0009,0017)	CS	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2985	\N	(0009,0018)	IS	1	Unknown	Unknown	Camtronics image level data	CMT	\N	\N	\N
f	2986	\N	(0009,0000)	CS	1	Analysis Type	AnalysisType	QCA Results	CMT	\N	\N	\N
f	2987	\N	(0009,0004)	LO	1	Segment Name	SegmentName	QCA Results	CMT	\N	\N	\N
f	2988	\N	(0009,0012)	DS	1	Pre-procedure Catheter Size	PreProcedureCatheterSize	QCA Results	CMT	\N	\N	\N
f	2989	\N	(0009,0013)	DS	1	Pre-procedure Reference Diameter	PreProcedureReferenceDiameter	QCA Results	CMT	\N	\N	\N
f	2990	\N	(0009,0014)	DS	1	Pre-procedure Minimum Lumen Diameter	PreProcedureMinimumLumenDiameter	QCA Results	CMT	\N	\N	\N
f	2991	\N	(0009,0015)	DS	1	Pre-procedure Average Diameter	PreProcedureAverageDiameter	QCA Results	CMT	\N	\N	\N
f	2992	\N	(0009,0016)	DS	1	Pre-procedure Stenosis Length	PreProcedureStenosisLength	QCA Results	CMT	\N	\N	\N
f	2993	\N	(0009,0017)	DS	1	Pre-procedure Stenosis %	PreProcedureStenosisPercentage	QCA Results	CMT	\N	\N	\N
f	2994	\N	(0009,0018)	DS	1	Pre-procedure Geometric Area Reduction %	PreProcedureGeometricAreaReductionPercentage	QCA Results	CMT	\N	\N	\N
f	2995	\N	(0009,0022)	DS	1	Post-procedure Catheter Size	PostProcedureCatheterSize	QCA Results	CMT	\N	\N	\N
f	2996	\N	(0009,0023)	DS	1	Post-procedure Reference Diameter	PostProcedureReferenceDiameter	QCA Results	CMT	\N	\N	\N
f	2997	\N	(0009,0024)	DS	1	Post-procedure Minimum Lumen Diameter	PostProcedureMinimumLumenDiameter	QCA Results	CMT	\N	\N	\N
f	2998	\N	(0009,0025)	DS	1	Post-procedure Average Diameter	PostProcedureAverageDiameter	QCA Results	CMT	\N	\N	\N
f	2999	\N	(0009,0026)	DS	1	Post-procedure Stenosis Length	PostProcedureStenosisLength	QCA Results	CMT	\N	\N	\N
f	3000	\N	(0009,0027)	DS	1	Post-procedure Stenosis %	PostProcedureStenosisPercentage	QCA Results	CMT	\N	\N	\N
f	3001	\N	(0009,0028)	DS	1	Post-procedure Geometric Area Reduction %	PostProcedureGeometricAreaReductionPercentage	QCA Results	CMT	\N	\N	\N
f	41	\N	(0029,0010)	LT	1	Unknown	Unknown	CAMTRONICS IP	CMT	\N	\N	\N
f	45	\N	(0029,0010)	LT	1	Commentline	Commentline	CAMTRONICS	CMT	\N	\N	\N
f	46	\N	(0029,0020)	DS	1	Edge Enhancement Coefficient	EdgeEnhancementCoefficient	CAMTRONICS	CMT	\N	\N	\N
f	42	\N	(0029,0020)	UN	1	Unknown	Unknown	CAMTRONICS IP	CMT	\N	\N	\N
f	43	\N	(0029,0030)	UN	1	Unknown	Unknown	CAMTRONICS IP	CMT	\N	\N	\N
f	44	\N	(0029,0040)	UN	1	Unknown	Unknown	CAMTRONICS IP	CMT	\N	\N	\N
f	47	\N	(0029,0050)	LT	1	Scene Text	SceneText	CAMTRONICS	CMT	\N	\N	\N
f	48	\N	(0029,0060)	LT	1	Image Text	ImageText	CAMTRONICS	CMT	\N	\N	\N
f	49	\N	(0029,0070)	IS	1	Pixel Shift Horizontal	PixelShiftHorizontal	CAMTRONICS	CMT	\N	\N	\N
f	50	\N	(0029,0080)	IS	1	Pixel Shift Vertical	PixelShiftVertical	CAMTRONICS	CMT	\N	\N	\N
f	51	\N	(0029,0090)	IS	1	Unknown	Unknown	CAMTRONICS	CMT	\N	\N	\N
f	3002	\N	(0003,0001)	OW	1	Offset List Structure	OffsetListStructure	ELSCINT1	EL1	\N	\N	\N
f	3003	\N	(00e1,0001)	US	1	Data Dictionary Version	DataDictionaryVersion	ELSCINT1	EL1	\N	\N	\N
f	3004	\N	(00e1,0005)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3005	\N	(00e1,0006)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3006	\N	(00e1,0007)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3007	\N	(00e1,0014)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3008	\N	(00e1,0018)	OB	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3009	\N	(00e1,0021)	DS	1	DLP Total	DLPTotal	ELSCINT1	EL1	\N	\N	\N
f	3010	\N	(00e1,0022)	DS	2	Presentation Relative Center	PresentationRelativeCenter	ELSCINT1	EL1	\N	\N	\N
f	3011	\N	(00e1,0023)	DS	2	Presentation Relative Part	PresentationRelativePart	ELSCINT1	EL1	\N	\N	\N
f	3012	\N	(00e1,0024)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3013	\N	(00e1,0025)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3014	\N	(00e1,0030)	UI	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3015	\N	(00e1,0031)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3016	\N	(00e1,0032)	US	2	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3017	\N	(00e1,0037)	DS	1	Total Dose Savings	TotalDoseSavings	ELSCINT1	EL1	\N	\N	\N
f	3018	\N	(00e1,0039)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3019	\N	(00e1,003e)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3020	\N	(00e1,003f)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3021	\N	(00e1,0040)	SH	1	Image Label	ImageLabel	ELSCINT1	EL1	\N	\N	\N
f	3022	\N	(00e1,0041)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3023	\N	(00e1,0042)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3024	\N	(00e1,0043)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3025	\N	(00e1,0050)	DS	1	Acquisition Duration	AcquisitionDuration	ELSCINT1	EL1	\N	\N	\N
f	3026	\N	(00e1,0051)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3027	\N	(00e1,0060)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3028	\N	(00e1,0061)	LO	1	Protocol File Name	ProtocolFileName	ELSCINT1	EL1	\N	\N	\N
f	3029	\N	(00e1,0062)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3030	\N	(00e1,0063)	SH	1	Patient Language	PatientLanguage	ELSCINT1	EL1	\N	\N	\N
f	3031	\N	(00e1,0065)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3032	\N	(00e1,006a)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3033	\N	(00e1,006b)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3034	\N	(00e1,00a0)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3035	\N	(00e1,00c2)	UI	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3036	\N	(00e1,00c4)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3037	\N	(00e1,00cf)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3038	\N	(00e1,00eb)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3039	\N	(00e1,00ec)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3040	\N	(01e1,0018)	OB	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3041	\N	(01e1,0021)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3042	\N	(01e1,0026)	CS	1	Phantom Type	PhantomType	ELSCINT1	EL1	\N	\N	\N
f	3043	\N	(01e1,0034)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3044	\N	(01e1,0040)	UI	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3045	\N	(01e1,0041)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3046	\N	(01f1,0001)	CS	1	Acquisition Type	AcquisitionType	ELSCINT1	EL1	\N	\N	\N
f	3047	\N	(01f1,0002)	CS	1	Focal Spot Resolution	FocalSpotResolution	ELSCINT1	EL1	\N	\N	\N
f	3048	\N	(01f1,0003)	CS	1	Concurrent Slices Generation	ConcurrentSlicesGeneration	ELSCINT1	EL1	\N	\N	\N
f	3049	\N	(01f1,0004)	CS	1	Angular Sampling Density	AngularSamplingDensity	ELSCINT1	EL1	\N	\N	\N
f	3050	\N	(01f1,0005)	DS	1	Reconstruction Arc	ReconstructionArc	ELSCINT1	EL1	\N	\N	\N
f	3051	\N	(01f1,0007)	DS	1	Table Velocity	TableVelocity	ELSCINT1	EL1	\N	\N	\N
f	3052	\N	(01f1,0008)	DS	1	Acquisition Length	AcquisitionLength	ELSCINT1	EL1	\N	\N	\N
f	3053	\N	(01f1,000a)	US	1	Edge Enhancement Weight	EdgeEnhancementWeight	ELSCINT1	EL1	\N	\N	\N
f	3054	\N	(01f1,000c)	DS	1	Scanner Relative Center	ScannerRelativeCenter	ELSCINT1	EL1	\N	\N	\N
f	3055	\N	(01f1,000d)	DS	1	Rotation Angle	RotationAngle	ELSCINT1	EL1	\N	\N	\N
f	3056	\N	(01f1,000e)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3057	\N	(01f1,0026)	DS	1	Pitch	Pitch	ELSCINT1	EL1	\N	\N	\N
f	3058	\N	(01f1,0027)	DS	1	Rotation Time	RotationTime	ELSCINT1	EL1	\N	\N	\N
f	3059	\N	(01f1,0028)	DS	1	Table Increment	TableIncrement	ELSCINT1	EL1	\N	\N	\N
f	3060	\N	(01f1,0030)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3061	\N	(01f1,0032)	CS	1	Image View Convention	ImageViewConvention	ELSCINT1	EL1	\N	\N	\N
f	3062	\N	(01f1,0033)	DS	1	Cycle Time	CycleTime	ELSCINT1	EL1	\N	\N	\N
f	3063	\N	(01f1,0036)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3064	\N	(01f1,0037)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3065	\N	(01f1,0038)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3066	\N	(01f1,0039)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3067	\N	(01f1,0040)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3068	\N	(01f1,0042)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3069	\N	(01f1,0043)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3070	\N	(01f1,0044)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3071	\N	(01f1,0045)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3072	\N	(01f1,0046)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3073	\N	(01f1,0047)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3074	\N	(01f1,0049)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3075	\N	(01f1,004a)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3076	\N	(01f1,004b)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3077	\N	(01f1,004c)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3078	\N	(01f1,004d)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3079	\N	(01f1,004e)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3080	\N	(01f1,0053)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3081	\N	(01f3,0001)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3082	\N	(01f3,0002)	SS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3083	\N	(01f3,0003)	FL	2	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3084	\N	(01f3,0004)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3085	\N	(01f3,0011)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3086	\N	(01f3,0012)	SS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3087	\N	(01f3,0013)	FL	2	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3088	\N	(01f3,0014)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3089	\N	(01f3,0015)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3090	\N	(01f3,0016)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3091	\N	(01f3,0017)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3092	\N	(01f3,0018)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3093	\N	(01f3,0019)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3094	\N	(01f3,0023)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3095	\N	(01f3,0024)	IS	2	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3096	\N	(01f7,0010)	OB	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3097	\N	(01f7,0011)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3098	\N	(01f7,0013)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3099	\N	(01f7,0014)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3100	\N	(01f7,0015)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3101	\N	(01f7,0016)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3102	\N	(01f7,0017)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3103	\N	(01f7,0018)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3104	\N	(01f7,0019)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3105	\N	(01f7,001a)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3106	\N	(01f7,001b)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3107	\N	(01f7,001c)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3108	\N	(01f7,001e)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3109	\N	(01f7,001f)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3110	\N	(01f7,0022)	UI	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3111	\N	(01f7,0023)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3112	\N	(01f7,0025)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3113	\N	(01f7,0026)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3114	\N	(01f7,0027)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3115	\N	(01f7,0028)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3116	\N	(01f7,0029)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3117	\N	(01f7,002b)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3118	\N	(01f7,002c)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3119	\N	(01f7,002d)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3120	\N	(01f7,002e)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3121	\N	(01f7,0030)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3122	\N	(01f7,0031)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3123	\N	(01f7,005c)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3124	\N	(01f7,0070)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3125	\N	(01f7,0073)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3126	\N	(01f7,0074)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3127	\N	(01f7,0075)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3128	\N	(01f7,007f)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3129	\N	(01f9,0001)	LO	1	SP Filter	SPFilter	ELSCINT1	EL1	\N	\N	\N
f	3130	\N	(01f9,0004)	IS	1	Adaptive Filter	AdaptiveFilter	ELSCINT1	EL1	\N	\N	\N
f	3131	\N	(01f9,0005)	IS	1	Recon Increment	ReconIncrement	ELSCINT1	EL1	\N	\N	\N
f	3132	\N	(01f9,0008)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3133	\N	(01f9,0009)	DS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	151	\N	(0601,0000)	SH	1	Implementation Version	ImplementationVersion	ELSCINT1	EL1	\N	\N	\N
f	152	\N	(0601,0020)	DS	1	Relative Table Position	RelativeTablePosition	ELSCINT1	EL1	\N	\N	\N
f	153	\N	(0601,0021)	DS	1	Relative Table Height	RelativeTableHeight	ELSCINT1	EL1	\N	\N	\N
f	154	\N	(0601,0030)	SH	1	Surview Direction	SurviewDirection	ELSCINT1	EL1	\N	\N	\N
f	155	\N	(0601,0031)	DS	1	Surview Length	SurviewLength	ELSCINT1	EL1	\N	\N	\N
f	156	\N	(0601,0050)	SH	1	Image View Type	ImageViewType	ELSCINT1	EL1	\N	\N	\N
f	157	\N	(0601,0070)	DS	1	Batch Number	BatchNumber	ELSCINT1	EL1	\N	\N	\N
f	158	\N	(0601,0071)	DS	1	Batch Size	BatchSize	ELSCINT1	EL1	\N	\N	\N
f	159	\N	(0601,0072)	DS	1	Batch Slice Number	BatchSliceNumber	ELSCINT1	EL1	\N	\N	\N
f	3134	\N	(07a1,0002)	UL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3135	\N	(07a1,0007)	US	3	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3136	\N	(07a1,0008)	DS	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3137	\N	(07a1,0009)	OW	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3138	\N	(07a1,000a)	OB	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3139	\N	(07a1,000c)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3140	\N	(07a1,0010)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3141	\N	(07a1,0011)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3142	\N	(07a1,0012)	FL	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3143	\N	(07a1,0013)	UL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3144	\N	(07a1,0016)	FL	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3145	\N	(07a1,0018)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3146	\N	(07a1,0019)	FL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3147	\N	(07a1,001c)	FL	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3148	\N	(07a1,002a)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3149	\N	(07a1,002b)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3150	\N	(07a1,0036)	AE	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3151	\N	(07a1,003d)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3152	\N	(07a1,0040)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3153	\N	(07a1,0043)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3154	\N	(07a1,0047)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3155	\N	(07a1,0050)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3156	\N	(07a1,0056)	US	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3157	\N	(07a1,0070)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3158	\N	(07a1,0071)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3159	\N	(07a1,0075)	LO	2	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3160	\N	(07a1,0085)	UL	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3161	\N	(07a1,0087)	LT	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3162	\N	(07a1,0088)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3163	\N	(07a1,0098)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3164	\N	(07a1,009f)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3165	\N	(07a3,0001)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3166	\N	(07a3,0003)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3167	\N	(07a3,0005)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3168	\N	(07a3,0006)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3169	\N	(07a3,0013)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3170	\N	(07a3,0014)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3171	\N	(07a3,0015)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3172	\N	(07a3,0017)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3173	\N	(07a3,001b)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3174	\N	(07a3,001f)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3175	\N	(07a3,0022)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3176	\N	(07a3,0023)	ST	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3177	\N	(07a3,0034)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3178	\N	(07a3,0043)	DS	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3179	\N	(07a3,0055)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3180	\N	(07a3,0061)	LT	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3181	\N	(07a3,0062)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3182	\N	(07a3,0063)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3183	\N	(07a3,0064)	IS	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3184	\N	(07a3,0065)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3185	\N	(07a3,0066)	IS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3186	\N	(07a3,0080)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3187	\N	(07a3,0099)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3188	\N	(07a3,009c)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3189	\N	(07a3,009f)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3190	\N	(07a3,00b9)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3191	\N	(07a3,00bb)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3192	\N	(07a5,0000)	LO	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3193	\N	(07a5,0056)	CS	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3194	\N	(5001,0070)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3195	\N	(5001,0071)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3196	\N	(5001,0080)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3197	\N	(5001,0081)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3198	\N	(5001,0082)	US	3	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3199	\N	(5001,0083)	FL	1-n	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3200	\N	(5001,0084)	SQ	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3201	\N	(7fdf,00f0)	OB	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3202	\N	(7fdf,00ff)	SH	1	Unknown	Unknown	ELSCINT1	EL1	\N	\N	\N
f	3203	\N	(0009,0001)	LO	2	Implementation Version Name	ImplementationVersionName	GEMS_PETD_01	GEM	\N	\N	\N
f	3204	\N	(0009,0002)	LO	1	Patient ID	PatientID	GEMS_PETD_01	GEM	\N	\N	\N
f	3205	\N	(0009,0003)	SH	1	Patient Compatible Version	PatientCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3206	\N	(0009,0004)	SH	1	Patient Software Version	PatientSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3207	\N	(0009,0005)	DT	1	Patient DateTime	PatientDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3208	\N	(0009,0006)	SL	1	Patient Type	PatientType	GEMS_PETD_01	GEM	\N	\N	\N
f	3209	\N	(0009,0007)	UI	1	Exam ID	ExamID	GEMS_PETD_01	GEM	\N	\N	\N
f	3210	\N	(0009,0008)	SH	1	Exam Compatible Version	ExamCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3211	\N	(0009,0009)	SH	1	Exam Software Version	ExamSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3212	\N	(0009,000a)	UI	1	Scan ID	ScanID	GEMS_PETD_01	GEM	\N	\N	\N
f	3213	\N	(0009,000b)	SH	1	Scan Compatible Version	ScanCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3214	\N	(0009,000c)	SH	1	Scan Software Version	ScanSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3215	\N	(0009,000d)	DT	1	Scan Date Time	ScanDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3216	\N	(0009,000e)	DT	1	Scan Ready	ScanReady	GEMS_PETD_01	GEM	\N	\N	\N
f	3217	\N	(0009,000f)	ST	1	Scan Description	ScanDescription	GEMS_PETD_01	GEM	\N	\N	\N
f	3218	\N	(0009,0010)	LO	1	Hospital Name	HospitalName	GEMS_PETD_01	GEM	\N	\N	\N
f	3219	\N	(0009,0011)	LO	1	Scanner Description	ScannerDescription	GEMS_PETD_01	GEM	\N	\N	\N
f	3220	\N	(0009,0012)	LO	1	Manufacturer	Manufacturer	GEMS_PETD_01	GEM	\N	\N	\N
f	3221	\N	(0009,0013)	UI	1	FOR Identifier	FORIdentifier	GEMS_PETD_01	GEM	\N	\N	\N
f	3222	\N	(0009,0014)	LO	1	Landmark Name	LandmarkName	GEMS_PETD_01	GEM	\N	\N	\N
f	3223	\N	(0009,0015)	SH	1	Landmark Abbrev	LandmarkAbbrev	GEMS_PETD_01	GEM	\N	\N	\N
f	3224	\N	(0009,0016)	SL	1	Patient Position	PatientPosition	GEMS_PETD_01	GEM	\N	\N	\N
f	3225	\N	(0009,0017)	SL	1	Scan Perspective	ScanPerspective	GEMS_PETD_01	GEM	\N	\N	\N
f	3226	\N	(0009,0018)	SL	1	Scan Type	ScanType	GEMS_PETD_01	GEM	\N	\N	\N
f	3227	\N	(0009,0019)	SL	1	Scan Mode	ScanMode	GEMS_PETD_01	GEM	\N	\N	\N
f	3228	\N	(0009,001a)	SL	1	Start Condition	StartCondition	GEMS_PETD_01	GEM	\N	\N	\N
f	3229	\N	(0009,001b)	SL	1	Start Condition Data	StartConditionData	GEMS_PETD_01	GEM	\N	\N	\N
f	3230	\N	(0009,001c)	SL	1	Sel Stop Condition	SelStopCondition	GEMS_PETD_01	GEM	\N	\N	\N
f	3231	\N	(0009,001d)	SL	1	Sel Stop Condition Data	SelStopConditionData	GEMS_PETD_01	GEM	\N	\N	\N
f	3232	\N	(0009,001e)	SL	1	Collect Deadtime	CollectDeadtime	GEMS_PETD_01	GEM	\N	\N	\N
f	3233	\N	(0009,001f)	SL	1	Collect Singles	CollectSingles	GEMS_PETD_01	GEM	\N	\N	\N
f	3234	\N	(0009,0020)	SL	1	Collect Count Rate	CollectCountRate	GEMS_PETD_01	GEM	\N	\N	\N
f	3235	\N	(0009,0021)	SL	1	Count Rate Period	CountRatePeriod	GEMS_PETD_01	GEM	\N	\N	\N
f	3236	\N	(0009,0022)	SL	1	Delayed Events	DelayedEvents	GEMS_PETD_01	GEM	\N	\N	\N
f	3237	\N	(0009,0023)	SL	1	Delayed Bias	DelayedBias	GEMS_PETD_01	GEM	\N	\N	\N
f	3238	\N	(0009,0024)	SL	1	Word Size	WordSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3239	\N	(0009,0025)	SL	1	Axial Acceptance	AxialAcceptance	GEMS_PETD_01	GEM	\N	\N	\N
f	3240	\N	(0009,0026)	SL	1	Axial Angle 3D	AxialAngle3D	GEMS_PETD_01	GEM	\N	\N	\N
f	3241	\N	(0009,0027)	SL	1	Theta Compression	ThetaCompression	GEMS_PETD_01	GEM	\N	\N	\N
f	3242	\N	(0009,0028)	SL	1	Axial Compression	AxialCompression	GEMS_PETD_01	GEM	\N	\N	\N
f	3243	\N	(0009,0029)	FL	1	Gantry Tilt Angle	GantryTiltAngle	GEMS_PETD_01	GEM	\N	\N	\N
f	3244	\N	(0009,002a)	SL	1	Collimation	Collimation	GEMS_PETD_01	GEM	\N	\N	\N
f	3245	\N	(0009,002b)	SL	1	Scan FOV	ScanFOV	GEMS_PETD_01	GEM	\N	\N	\N
f	3246	\N	(0009,002c)	SL	1	Axial FOV	AxialFOV	GEMS_PETD_01	GEM	\N	\N	\N
f	3247	\N	(0009,002d)	SL	1	Event Separation	EventSeparation	GEMS_PETD_01	GEM	\N	\N	\N
f	3248	\N	(0009,002e)	SL	1	Mask Width	MaskWidth	GEMS_PETD_01	GEM	\N	\N	\N
f	3249	\N	(0009,002f)	SL	1	Binning Mode	BinningMode	GEMS_PETD_01	GEM	\N	\N	\N
f	3250	\N	(0009,0030)	SL	1	Trig Rej Method	TrigRejMethod	GEMS_PETD_01	GEM	\N	\N	\N
f	3251	\N	(0009,0031)	SL	1	Number For Reject	NumberForReject	GEMS_PETD_01	GEM	\N	\N	\N
f	3252	\N	(0009,0032)	SL	1	Lower Reject Limit	LowerRejectLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3253	\N	(0009,0033)	SL	1	Upper Reject Limit	UpperRejectLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3254	\N	(0009,0034)	SL	1	Triggers Acquired	TriggersAcquired	GEMS_PETD_01	GEM	\N	\N	\N
f	3255	\N	(0009,0035)	SL	1	Triggers Rejected	TriggersRejected	GEMS_PETD_01	GEM	\N	\N	\N
f	3256	\N	(0009,0036)	LO	1	Tracer Name	TracerName	GEMS_PETD_01	GEM	\N	\N	\N
f	3257	\N	(0009,0037)	LO	1	Batch Description	BatchDescription	GEMS_PETD_01	GEM	\N	\N	\N
f	3258	\N	(0009,0038)	FL	1	Tracer Activity	TracerActivity	GEMS_PETD_01	GEM	\N	\N	\N
f	3259	\N	(0009,0039)	DT	1	Measured Date Time	MeasuredDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3260	\N	(0009,003a)	FL	1	Pre Inj Volume	PreInjVolume	GEMS_PETD_01	GEM	\N	\N	\N
f	3261	\N	(0009,003b)	DT	1	Administered Date Time	AdministeredDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3262	\N	(0009,003c)	FL	1	Post Injected Activity	PostInjectedActivity	GEMS_PETD_01	GEM	\N	\N	\N
f	3263	\N	(0009,003d)	DT	1	Post Injected Date Time	PostInjectedDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3264	\N	(0009,003e)	SH	1	Radio Nuclide Name	RadioNuclideName	GEMS_PETD_01	GEM	\N	\N	\N
f	3265	\N	(0009,003f)	FL	1	Half Life	HalfLife	GEMS_PETD_01	GEM	\N	\N	\N
f	3266	\N	(0009,0040)	FL	1	Positron Fraction	PositronFraction	GEMS_PETD_01	GEM	\N	\N	\N
f	3267	\N	(0009,0041)	SL	1	Source 1 Holder	Source1Holder	GEMS_PETD_01	GEM	\N	\N	\N
f	3268	\N	(0009,0042)	FL	1	Source 1 Activity	Source1Activity	GEMS_PETD_01	GEM	\N	\N	\N
f	3269	\N	(0009,0043)	DT	1	Source 1 Meas DT	Source1MeasDT	GEMS_PETD_01	GEM	\N	\N	\N
f	3270	\N	(0009,0044)	SH	1	Source 1 Radio Nuclide	Source1RadioNuclide	GEMS_PETD_01	GEM	\N	\N	\N
f	3271	\N	(0009,0045)	FL	1	Source 1 Half Life	Source1HalfLife	GEMS_PETD_01	GEM	\N	\N	\N
f	3272	\N	(0009,0046)	SL	1	Source 2 Holder	Source2Holder	GEMS_PETD_01	GEM	\N	\N	\N
f	3273	\N	(0009,0047)	FL	1	Source 2 Activity	Source2Activity	GEMS_PETD_01	GEM	\N	\N	\N
f	3274	\N	(0009,0048)	DT	1	Source 2 Meas DT	Source2MeasDT	GEMS_PETD_01	GEM	\N	\N	\N
f	3275	\N	(0009,0049)	SH	1	Source 2 Radio Nuclide	Source2RadioNuclide	GEMS_PETD_01	GEM	\N	\N	\N
f	3276	\N	(0009,004a)	FL	1	Source 2 Half Life	Source2HalfLife	GEMS_PETD_01	GEM	\N	\N	\N
f	3277	\N	(0009,004b)	SL	1	Source Speed	SourceSpeed	GEMS_PETD_01	GEM	\N	\N	\N
f	3278	\N	(0009,004c)	FL	1	Source Location	SourceLocation	GEMS_PETD_01	GEM	\N	\N	\N
f	3279	\N	(0009,004d)	SL	1	Emission Present	EmissionPresent	GEMS_PETD_01	GEM	\N	\N	\N
f	3280	\N	(0009,004e)	SL	1	Lower Axial Acc	LowerAxialAcc	GEMS_PETD_01	GEM	\N	\N	\N
f	3281	\N	(0009,004f)	SL	1	Upper Axial Acc	UpperAxialAcc	GEMS_PETD_01	GEM	\N	\N	\N
f	3282	\N	(0009,0050)	SL	1	Lower Coinc Limit	LowerCoincLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3283	\N	(0009,0051)	SL	1	Upper Coinc Limit	UpperCoincLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3284	\N	(0009,0052)	SL	1	Coinc Delay Offset	CoincDelayOffset	GEMS_PETD_01	GEM	\N	\N	\N
f	3285	\N	(0009,0053)	SL	1	Coinc Output Mode	CoincOutputMode	GEMS_PETD_01	GEM	\N	\N	\N
f	3286	\N	(0009,0054)	SL	1	Upper Energy Limit	UpperEnergyLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3287	\N	(0009,0055)	SL	1	Lower Energy Limit	LowerEnergyLimit	GEMS_PETD_01	GEM	\N	\N	\N
f	3288	\N	(0009,0056)	UI	1	Normal Cal ID	NormalCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3289	\N	(0009,0057)	UI	1	Normal 2D Cal ID	Normal2DCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3290	\N	(0009,0058)	UI	1	Blank Cal ID	BlankCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3291	\N	(0009,0059)	UI	1	WC Cal ID	WCCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3292	\N	(0009,005a)	SL	1	Derived	Derived	GEMS_PETD_01	GEM	\N	\N	\N
f	3293	\N	(0009,005b)	LO	1	Contrast Agent	ContrastAgent	GEMS_PETD_01	GEM	\N	\N	\N
f	3294	\N	(0009,005c)	UI	1	frame_id	frame_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3295	\N	(0009,005d)	UI	1	scan_id	scan_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3296	\N	(0009,005e)	UI	1	exam_id	exam_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3297	\N	(0009,005f)	LO	1	patient_id	patient_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3298	\N	(0009,0060)	SH	1	compatible_version	compatible_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3299	\N	(0009,0061)	SH	1	software_version	software_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3300	\N	(0009,0062)	ST	1	where_is_frame	where_is_frame	GEMS_PETD_01	GEM	\N	\N	\N
f	3301	\N	(0009,0063)	SL	1	frame_size	frame_size	GEMS_PETD_01	GEM	\N	\N	\N
f	3302	\N	(0009,0064)	SL	1	file_exists	file_exists	GEMS_PETD_01	GEM	\N	\N	\N
f	3303	\N	(0009,0065)	SL	1	patient_entry	patient_entry	GEMS_PETD_01	GEM	\N	\N	\N
f	3304	\N	(0009,0066)	FL	1	table_height	table_height	GEMS_PETD_01	GEM	\N	\N	\N
f	3305	\N	(0009,0067)	FL	1	table_z_position	table_z_position	GEMS_PETD_01	GEM	\N	\N	\N
f	3306	\N	(0009,0068)	DT	1	landmark_datetime	landmark_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3307	\N	(0009,0069)	SL	1	slice_count	slice_count	GEMS_PETD_01	GEM	\N	\N	\N
f	3308	\N	(0009,006a)	FL	1	start_location	start_location	GEMS_PETD_01	GEM	\N	\N	\N
f	3309	\N	(0009,006b)	SL	1	acq_delay	acq_delay	GEMS_PETD_01	GEM	\N	\N	\N
f	3310	\N	(0009,006c)	DT	1	acq_start	acq_start	GEMS_PETD_01	GEM	\N	\N	\N
f	3311	\N	(0009,006d)	SL	1	acq_duration	acq_duration	GEMS_PETD_01	GEM	\N	\N	\N
f	3312	\N	(0009,006e)	SL	1	acq_bin_dur	acq_bin_dur	GEMS_PETD_01	GEM	\N	\N	\N
f	3313	\N	(0009,006f)	SL	1	acq_bin_start	acq_bin_start	GEMS_PETD_01	GEM	\N	\N	\N
f	3314	\N	(0009,0070)	SL	1	actual_stop_cond	actual_stop_cond	GEMS_PETD_01	GEM	\N	\N	\N
f	3315	\N	(0009,0071)	FD	1	total_prompts	total_prompts	GEMS_PETD_01	GEM	\N	\N	\N
f	3316	\N	(0009,0072)	FD	1	total_delays	total_delays	GEMS_PETD_01	GEM	\N	\N	\N
f	3317	\N	(0009,0073)	SL	1	frame_valid	frame_valid	GEMS_PETD_01	GEM	\N	\N	\N
f	3318	\N	(0009,0074)	SL	1	validity_info	validity_info	GEMS_PETD_01	GEM	\N	\N	\N
f	3319	\N	(0009,0075)	SL	1	archived	archived	GEMS_PETD_01	GEM	\N	\N	\N
f	3320	\N	(0009,0076)	SL	1	compression	compression	GEMS_PETD_01	GEM	\N	\N	\N
f	3321	\N	(0009,0077)	SL	1	uncompressed_size	uncompressed_size	GEMS_PETD_01	GEM	\N	\N	\N
f	3322	\N	(0009,0078)	SL	1	accum_bin_dur	accum_bin_dur	GEMS_PETD_01	GEM	\N	\N	\N
f	3323	\N	(0009,0079)	SH	1	Image Set Compatible Version	ImageSetCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3324	\N	(0009,007a)	SH	1	Image Set Software Version	ImageSetSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3325	\N	(0009,007b)	DT	1	Image Set Date Time	ImageSetDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3326	\N	(0009,007c)	SL	1	Image Set Source	ImageSetSource	GEMS_PETD_01	GEM	\N	\N	\N
f	3327	\N	(0009,007d)	SL	1	Image Set Contents	ImageSetContents	GEMS_PETD_01	GEM	\N	\N	\N
f	3328	\N	(0009,007e)	SL	1	Image Set Type	ImageSetType	GEMS_PETD_01	GEM	\N	\N	\N
f	3329	\N	(0009,007f)	DS	1	Image Set Reference	ImageSetReference	GEMS_PETD_01	GEM	\N	\N	\N
f	3330	\N	(0009,0080)	SL	1	Multi Patient	MultiPatient	GEMS_PETD_01	GEM	\N	\N	\N
f	3331	\N	(0009,0081)	SL	1	Number of Normals	NumberOfNormals	GEMS_PETD_01	GEM	\N	\N	\N
f	3332	\N	(0009,0082)	UI	1	Color Map ID	ColorMapID	GEMS_PETD_01	GEM	\N	\N	\N
f	3333	\N	(0009,0083)	SL	1	Window Level Type	WindowLevelType	GEMS_PETD_01	GEM	\N	\N	\N
f	3334	\N	(0009,0084)	FL	1	Rotate	Rotate	GEMS_PETD_01	GEM	\N	\N	\N
f	3335	\N	(0009,0085)	SL	1	Flip	Flip	GEMS_PETD_01	GEM	\N	\N	\N
f	3336	\N	(0009,0086)	FL	1	Zoom	Zoom	GEMS_PETD_01	GEM	\N	\N	\N
f	3337	\N	(0009,0087)	SL	1	PanX	PanX	GEMS_PETD_01	GEM	\N	\N	\N
f	3338	\N	(0009,0088)	SL	1	PanY	PanY	GEMS_PETD_01	GEM	\N	\N	\N
f	3339	\N	(0009,0089)	FL	1	Window Level Min	WindowLevelMin	GEMS_PETD_01	GEM	\N	\N	\N
f	3340	\N	(0009,008a)	FL	1	Window Level Max	WindowLevelMax	GEMS_PETD_01	GEM	\N	\N	\N
f	3341	\N	(0009,008b)	SL	1	ReconMethod	ReconMethod	GEMS_PETD_01	GEM	\N	\N	\N
f	3342	\N	(0009,008c)	SL	1	Attenuation	Attenuation	GEMS_PETD_01	GEM	\N	\N	\N
f	3343	\N	(0009,008d)	FL	1	Attenuation Coefficient	AttenuationCoefficient	GEMS_PETD_01	GEM	\N	\N	\N
f	3344	\N	(0009,008e)	SL	1	BP Filter	BPFilter	GEMS_PETD_01	GEM	\N	\N	\N
f	3345	\N	(0009,008f)	FL	1	BP Filter Cutoff	BPFilterCutoff	GEMS_PETD_01	GEM	\N	\N	\N
f	3346	\N	(0009,0090)	SL	1	BP Filter Order	BPFilterOrder	GEMS_PETD_01	GEM	\N	\N	\N
f	3347	\N	(0009,0091)	FL	1	BP Filter Center I	BPFilterCenterI	GEMS_PETD_01	GEM	\N	\N	\N
f	3348	\N	(0009,0092)	FL	1	BP Filter Center P	BPFilterCenterP	GEMS_PETD_01	GEM	\N	\N	\N
f	3349	\N	(0009,0093)	SL	1	Atten Smooth	AttenSmooth	GEMS_PETD_01	GEM	\N	\N	\N
f	3350	\N	(0009,0094)	SL	1	Atten Smooth Param	AttenSmoothParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3351	\N	(0009,0095)	SL	1	Angle Smooth Param	AngleSmoothParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3352	\N	(0009,0096)	UI	1	Well CounterCal ID	WellCounterCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3353	\N	(0009,0097)	UI	1	Trans Scan ID	TransScanID	GEMS_PETD_01	GEM	\N	\N	\N
f	3354	\N	(0009,0098)	UI	1	Norm Cal ID	NormCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3355	\N	(0009,0099)	UI	1	Blnk Cal ID	BlnkCalID	GEMS_PETD_01	GEM	\N	\N	\N
f	3356	\N	(0009,009a)	FL	1	CAC Edge Threshold	CACEdgeThreshold	GEMS_PETD_01	GEM	\N	\N	\N
f	3357	\N	(0009,009b)	FL	1	CAC Skull Offset	CACSkullOffset	GEMS_PETD_01	GEM	\N	\N	\N
f	3358	\N	(0009,009c)	UI	1	Emiss Sub ID	EmissSubID	GEMS_PETD_01	GEM	\N	\N	\N
f	3359	\N	(0009,009d)	SS	1	Radial Filter 3D	RadialFilter3D	GEMS_PETD_01	GEM	\N	\N	\N
f	3360	\N	(0009,009e)	FL	1	Radial Cutoff 3D	RadialCutoff3D	GEMS_PETD_01	GEM	\N	\N	\N
f	3361	\N	(0009,009f)	SL	1	Axial Filter 3D	AxialFilter3D	GEMS_PETD_01	GEM	\N	\N	\N
f	3362	\N	(0009,00a0)	FL	1	Axial Cutoff 3D	AxialCutoff3D	GEMS_PETD_01	GEM	\N	\N	\N
f	3363	\N	(0009,00a1)	FL	1	Axial Start	AxialStart	GEMS_PETD_01	GEM	\N	\N	\N
f	3364	\N	(0009,00a2)	FL	1	Axial Spacing	AxialSpacing	GEMS_PETD_01	GEM	\N	\N	\N
f	3365	\N	(0009,00a3)	SL	1	Axial Angles Used	AxialAnglesUsed	GEMS_PETD_01	GEM	\N	\N	\N
f	3366	\N	(0009,00a4)	SH	1	compatible_version	compatible_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3367	\N	(0009,00a5)	SH	1	software_version	software_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3368	\N	(0009,00a6)	SL	1	slice_number	slice_number	GEMS_PETD_01	GEM	\N	\N	\N
f	3369	\N	(0009,00a7)	FL	1	total_counts	total_counts	GEMS_PETD_01	GEM	\N	\N	\N
f	3370	\N	(0009,00a8)	OB	1	other_atts	other_atts	GEMS_PETD_01	GEM	\N	\N	\N
f	3371	\N	(0009,00a9)	SL	1	other_atts_size	other_atts_size	GEMS_PETD_01	GEM	\N	\N	\N
f	3372	\N	(0009,00aa)	SL	1	archived	archived	GEMS_PETD_01	GEM	\N	\N	\N
f	3373	\N	(0009,00ab)	FL	1	bp_center_x	bp_center_x	GEMS_PETD_01	GEM	\N	\N	\N
f	3374	\N	(0009,00ac)	FL	1	bp_center_y	bp_center_y	GEMS_PETD_01	GEM	\N	\N	\N
f	3375	\N	(0009,00ad)	UI	1	trans_frame_id	trans_frame_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3376	\N	(0009,00ae)	UI	1	tpluse_frame_id	tpluse_frame_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3377	\N	(0009,00b1)	FL	1	profile_spacing	profile_spacing	GEMS_PETD_01	GEM	\N	\N	\N
f	3378	\N	(0009,00b2)	SS	1	IR Num Iterations	IRNumIterations	GEMS_PETD_01	GEM	\N	\N	\N
f	3379	\N	(0009,00b3)	SS	1	IR Num Subsets	IRNumSubsets	GEMS_PETD_01	GEM	\N	\N	\N
f	3380	\N	(0009,00b4)	FL	1	IR Recon FOV	IRReconFOV	GEMS_PETD_01	GEM	\N	\N	\N
f	3381	\N	(0009,00b5)	SS	1	IR Corr Model	IRCorrModel	GEMS_PETD_01	GEM	\N	\N	\N
f	3382	\N	(0009,00b6)	SS	1	IR Loop Filter	IRLoopFilter	GEMS_PETD_01	GEM	\N	\N	\N
f	3383	\N	(0009,00b7)	FL	1	IR Pre Filt Param	IRPreFiltParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3384	\N	(0009,00b8)	FL	1	IR Loop Filt Param	IRLoopFiltParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3385	\N	(0009,00b9)	FL	1	Response Filt Param	ResponseFiltParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3386	\N	(0009,00ba)	SS	1	Post Filter	PostFilter	GEMS_PETD_01	GEM	\N	\N	\N
f	3387	\N	(0009,00bb)	FL	1	Post Filter Param	PostFilterParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3388	\N	(0009,00bc)	SS	1	IR Regularize	IRRegularize	GEMS_PETD_01	GEM	\N	\N	\N
f	3389	\N	(0009,00bd)	FL	1	IR Regularize Param	IRRegularizeParam	GEMS_PETD_01	GEM	\N	\N	\N
f	3390	\N	(0009,00be)	SS	1	AC BP Filter	ACBPFilter	GEMS_PETD_01	GEM	\N	\N	\N
f	3391	\N	(0009,00bf)	FL	1	AC BP Filt Cutoff	ACBPFiltCutoff	GEMS_PETD_01	GEM	\N	\N	\N
f	3392	\N	(0009,00c0)	SL	1	AC BP Filt Order	ACBPFiltOrder	GEMS_PETD_01	GEM	\N	\N	\N
f	3393	\N	(0009,00c1)	SS	1	AC Img Smooth	ACImgSmooth	GEMS_PETD_01	GEM	\N	\N	\N
f	3394	\N	(0009,00c2)	FL	1	AC Img Smooth Parm	ACImgSmoothParm	GEMS_PETD_01	GEM	\N	\N	\N
f	3395	\N	(0009,00c3)	SL	1	Scatter Method	ScatterMethod	GEMS_PETD_01	GEM	\N	\N	\N
f	3396	\N	(0009,00c4)	SS	1	Scatter Num Iter	ScatterNumIter	GEMS_PETD_01	GEM	\N	\N	\N
f	3397	\N	(0009,00c5)	FL	1	Scatter Parm	ScatterParm	GEMS_PETD_01	GEM	\N	\N	\N
f	3398	\N	(0009,00c6)	FL	1	seg_qc_parm	seg_qc_parm	GEMS_PETD_01	GEM	\N	\N	\N
f	3399	\N	(0009,00c7)	SL	1	overlap	overlap	GEMS_PETD_01	GEM	\N	\N	\N
f	3400	\N	(0009,00c8)	UI	1	ovlp_frm_id	ovlp_frm_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3401	\N	(0009,00c9)	UI	1	ovlp_trans_frm_id	ovlp_trans_frm_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3402	\N	(0009,00ca)	UI	1	ovlp_tpulse_frm_id	ovlp_tpulse_frm_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3403	\N	(0009,00cb)	FL	1	vqc_x_axis_trans	vqc_x_axis_trans	GEMS_PETD_01	GEM	\N	\N	\N
f	3404	\N	(0009,00cc)	FL	1	vqc_x_axis_tilt	vqc_x_axis_tilt	GEMS_PETD_01	GEM	\N	\N	\N
f	3405	\N	(0009,00cd)	FL	1	vqc_y_axis_trans	vqc_y_axis_trans	GEMS_PETD_01	GEM	\N	\N	\N
f	3406	\N	(0009,00ce)	FL	1	vqc_y_axis_swivel	vqc_y_axis_swivel	GEMS_PETD_01	GEM	\N	\N	\N
f	3407	\N	(0009,00cf)	FL	1	vqc_z_axis_trans	vqc_z_axis_trans	GEMS_PETD_01	GEM	\N	\N	\N
f	3408	\N	(0009,00d0)	FL	1	vqc_z_axis_roll	vqc_z_axis_roll	GEMS_PETD_01	GEM	\N	\N	\N
f	3409	\N	(0009,00d1)	LO	1	ctac_conv_scale	ctac_conv_scale	GEMS_PETD_01	GEM	\N	\N	\N
f	3410	\N	(0009,00d2)	UI	1	image_set_id	image_set_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3411	\N	(0009,00d3)	SL	1	contrast_route	contrast_route	GEMS_PETD_01	GEM	\N	\N	\N
f	3412	\N	(0009,00d4)	LO	1	ctac_conv_scale	ctac_conv_scale	GEMS_PETD_01	GEM	\N	\N	\N
f	3413	\N	(0009,00d5)	FL	1	loop_filter_parm	loop_filter_parm	GEMS_PETD_01	GEM	\N	\N	\N
f	3414	\N	(0009,00d6)	FL	1	image_one_loc	image_one_loc	GEMS_PETD_01	GEM	\N	\N	\N
f	3415	\N	(0009,00d7)	FL	1	image_index_loc	image_index_loc	GEMS_PETD_01	GEM	\N	\N	\N
f	3416	\N	(0009,00d8)	SL	1	frame_number	frame_number	GEMS_PETD_01	GEM	\N	\N	\N
f	3417	\N	(0009,00d9)	SL	1	list_file_exists	list_file_exists	GEMS_PETD_01	GEM	\N	\N	\N
f	3418	\N	(0009,00da)	ST	1	where_is_list_frame	where_is_list_frame	GEMS_PETD_01	GEM	\N	\N	\N
f	3419	\N	(0009,00db)	SL	1	ir_z_filter_flag	ir_z_filter_flag	GEMS_PETD_01	GEM	\N	\N	\N
f	3420	\N	(0009,00dc)	FL	1	ir_z_filter_ratio	ir_z_filter_ratio	GEMS_PETD_01	GEM	\N	\N	\N
f	3421	\N	(0009,00dd)	US	1	num_of_rr_interval	num_of_rr_interval	GEMS_PETD_01	GEM	\N	\N	\N
f	3422	\N	(0009,00de)	US	1	num_of_time_slots	num_of_time_slots	GEMS_PETD_01	GEM	\N	\N	\N
f	3423	\N	(0009,00df)	US	1	num_of_slices	num_of_slices	GEMS_PETD_01	GEM	\N	\N	\N
f	3424	\N	(0009,00e0)	US	1	num_of_time_slices	num_of_time_slices	GEMS_PETD_01	GEM	\N	\N	\N
f	3425	\N	(0009,00e1)	SL	1	unlisted_scan	unlisted_scan	GEMS_PETD_01	GEM	\N	\N	\N
f	3426	\N	(0009,00e2)	SL	1	rest_stress	rest_stress	GEMS_PETD_01	GEM	\N	\N	\N
f	3427	\N	(0009,00e3)	FL	1	phase percentage	phase_percentage	GEMS_PETD_01	GEM	\N	\N	\N
f	3428	\N	(0009,00e4)	ST	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3429	\N	(0009,00e5)	FL	1	left shift	left_shift	GEMS_PETD_01	GEM	\N	\N	\N
f	3430	\N	(0009,00e6)	FL	1	posterior shift	posterior_shift	GEMS_PETD_01	GEM	\N	\N	\N
f	3431	\N	(0009,00e7)	FL	1	superior shift	superior_shift	GEMS_PETD_01	GEM	\N	\N	\N
f	3432	\N	(0009,00e8)	SL	1	acq_bin_num	acq_bin_num	GEMS_PETD_01	GEM	\N	\N	\N
f	3433	\N	(0009,00e9)	FL	1	acq_bin_dur_percent	acq_bin_dur_percent	GEMS_PETD_01	GEM	\N	\N	\N
f	3434	\N	(0009,00ea)	SL	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3435	\N	(0009,00eb)	FL	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3436	\N	(0009,00ec)	SL	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3437	\N	(0011,0001)	SQ	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3438	\N	(0011,0018)	OB	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3439	\N	(0013,0001)	SQ	1	Unknown	Unknown	GEMS_PETD_01	GEM	\N	\N	\N
f	3440	\N	(0017,0001)	UI	1	correction_cal_id	correction_cal_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3441	\N	(0017,0002)	SH	1	compatible_version	compatible_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3442	\N	(0017,0003)	SH	1	software_version	software_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3443	\N	(0017,0004)	DT	1	cal_datetime	cal_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3444	\N	(0017,0005)	LO	1	cal_datetime	cal_description	GEMS_PETD_01	GEM	\N	\N	\N
f	3445	\N	(0017,0006)	SL	1	cal_type	cal_type	GEMS_PETD_01	GEM	\N	\N	\N
f	3446	\N	(0017,0007)	ST	1	where_is_corr	where_is_corr	GEMS_PETD_01	GEM	\N	\N	\N
f	3447	\N	(0017,0008)	SL	1	corr_file_size	corr_file_size	GEMS_PETD_01	GEM	\N	\N	\N
f	3448	\N	(0017,0009)	LO	1	scan_id	scan_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3449	\N	(0017,000a)	DT	1	scan_datetime	scan_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3450	\N	(0017,000b)	LO	1	norm_2d_cal_id	norm_2d_cal_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3451	\N	(0017,000c)	SH	1	hosp_identifier	hosp_identifier	GEMS_PETD_01	GEM	\N	\N	\N
f	3452	\N	(0017,000d)	SL	1	archived	archived	GEMS_PETD_01	GEM	\N	\N	\N
f	3453	\N	(0019,0001)	UI	1	wc_cal_id	wc_cal_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3454	\N	(0019,0002)	SH	1	compatible_version	compatible_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3455	\N	(0019,0003)	SH	1	software_version	software_version	GEMS_PETD_01	GEM	\N	\N	\N
f	3456	\N	(0019,0004)	DT	1	cal_datetime	cal_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3457	\N	(0019,0005)	SL	1	cal_type	cal_type	GEMS_PETD_01	GEM	\N	\N	\N
f	3458	\N	(0019,0006)	LO	1	cal_description	cal_description	GEMS_PETD_01	GEM	\N	\N	\N
f	3459	\N	(0019,0007)	LO	1	cal_hardware	cal_hardware	GEMS_PETD_01	GEM	\N	\N	\N
f	3460	\N	(0019,0008)	OB	1	coefficients	coefficients	GEMS_PETD_01	GEM	\N	\N	\N
f	3461	\N	(0019,0009)	FL	1	activity_factor_hr	activity_factor_hr	GEMS_PETD_01	GEM	\N	\N	\N
f	3462	\N	(0019,000a)	FL	1	activity_factor_hs	activity_factor_hs	GEMS_PETD_01	GEM	\N	\N	\N
f	3463	\N	(0019,000b)	FL	1	activity_factor_3d	activity_factor_3d	GEMS_PETD_01	GEM	\N	\N	\N
f	3464	\N	(0019,000c)	LO	1	scan_id	scan_id	GEMS_PETD_01	GEM	\N	\N	\N
f	3465	\N	(0019,000d)	DT	1	scan_datetime	scan_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3466	\N	(0019,000e)	SH	1	hosp_identifier	hosp_identifier	GEMS_PETD_01	GEM	\N	\N	\N
f	3467	\N	(0019,000f)	FL	1	meas_activity	meas_activity	GEMS_PETD_01	GEM	\N	\N	\N
f	3468	\N	(0019,0010)	DT	1	meas_datetime	meas_datetime	GEMS_PETD_01	GEM	\N	\N	\N
f	3469	\N	(0019,0011)	SL	1	axial_filter_3d	axial_filter_3d	GEMS_PETD_01	GEM	\N	\N	\N
f	3470	\N	(0019,0012)	FL	1	axial_cutoff_3d	axial_cutoff_3d	GEMS_PETD_01	GEM	\N	\N	\N
f	3471	\N	(0019,0013)	SL	1	default_flag	default_flag	GEMS_PETD_01	GEM	\N	\N	\N
f	3472	\N	(0019,0014)	SL	1	archived	archived	GEMS_PETD_01	GEM	\N	\N	\N
f	3473	\N	(0019,0015)	SL	1	wc_cal_rec_method	wc_cal_rec_method	GEMS_PETD_01	GEM	\N	\N	\N
f	3474	\N	(0019,0016)	SL	1	activity_factor_2d	activity_factor_2d	GEMS_PETD_01	GEM	\N	\N	\N
f	3475	\N	(0019,0017)	SL	1	isotope	isotope	GEMS_PETD_01	GEM	\N	\N	\N
f	3476	\N	(0021,0001)	US	1	raw_data_type	raw_data_type	GEMS_PETD_01	GEM	\N	\N	\N
f	3477	\N	(0021,0002)	UL	1	raw_data_size	raw_data_size	GEMS_PETD_01	GEM	\N	\N	\N
f	3478	\N	(0023,0001)	OB	1	raw_data_blob	raw_data_blob	GEMS_PETD_01	GEM	\N	\N	\N
f	3479	\N	(5001,0001)	UI	1	Curve ID	CurveID	GEMS_PETD_01	GEM	\N	\N	\N
f	3480	\N	(5001,0002)	SH	1	Curve Compatible Version	CurveCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3481	\N	(5001,0003)	SH	1	Curve Software Version	CurveSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3482	\N	(5001,0004)	SL	1	Statistics Type	StatisticsType	GEMS_PETD_01	GEM	\N	\N	\N
f	3483	\N	(5001,0005)	LT	1	How Derived	HowDerived	GEMS_PETD_01	GEM	\N	\N	\N
f	3484	\N	(5001,0006)	SL	1	How Derived Size	HowDerivedSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3485	\N	(5001,0007)	SL	1	Multi Patient	MultiPatient	GEMS_PETD_01	GEM	\N	\N	\N
f	3486	\N	(5001,0008)	SL	1	Deadtime	Deadtime	GEMS_PETD_01	GEM	\N	\N	\N
f	3487	\N	(5003,0001)	SQ	1	Graph Sequence	GraphSequence	GEMS_PETD_01	GEM	\N	\N	\N
f	3488	\N	(5003,0002)	UI	1	Graph ID	GraphID	GEMS_PETD_01	GEM	\N	\N	\N
f	3489	\N	(5003,0003)	SH	1	Graph Compatible Version	GraphCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3490	\N	(5003,0004)	SH	1	Graph Software Version	GraphSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3491	\N	(5003,0005)	LO	1	Title	Title	GEMS_PETD_01	GEM	\N	\N	\N
f	3492	\N	(5003,0006)	DT	1	Graph Date Time	GraphDateTime	GEMS_PETD_01	GEM	\N	\N	\N
f	3493	\N	(5003,0007)	ST	1	Graph Description	GraphDescription	GEMS_PETD_01	GEM	\N	\N	\N
f	3494	\N	(5003,0008)	LO	1	Title Font Name	TitleFontName	GEMS_PETD_01	GEM	\N	\N	\N
f	3495	\N	(5003,0009)	SH	1	Title Font Size	TitleFontSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3496	\N	(5003,000a)	LO	1	Footer	Footer	GEMS_PETD_01	GEM	\N	\N	\N
f	3497	\N	(5003,000b)	SH	1	Footer Font Size	FooterFontSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3498	\N	(5003,000c)	LO	1	Foreground Color	ForegroundColor	GEMS_PETD_01	GEM	\N	\N	\N
f	3499	\N	(5003,000d)	LO	1	Background Color	BackgroundColor	GEMS_PETD_01	GEM	\N	\N	\N
f	3500	\N	(5003,000e)	SL	1	Graph Border	GraphBorder	GEMS_PETD_01	GEM	\N	\N	\N
f	3501	\N	(5003,000f)	SL	1	Graph Width	GraphWidth	GEMS_PETD_01	GEM	\N	\N	\N
f	3502	\N	(5003,0010)	SL	1	Graph Height	GraphHeight	GEMS_PETD_01	GEM	\N	\N	\N
f	3503	\N	(5003,0011)	SL	1	Grid	Grid	GEMS_PETD_01	GEM	\N	\N	\N
f	3504	\N	(5003,0012)	LO	1	Label Font Name	LabelFontName	GEMS_PETD_01	GEM	\N	\N	\N
f	3505	\N	(5003,0013)	SH	1	Label Font Size	LabelFontSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3506	\N	(5003,0014)	LO	1	Axes Color	AxesColor	GEMS_PETD_01	GEM	\N	\N	\N
f	3507	\N	(5003,0015)	LO	1	X Axis Label	XAxisLabel	GEMS_PETD_01	GEM	\N	\N	\N
f	3508	\N	(5003,0016)	SL	1	X Axis Units	XAxisUnits	GEMS_PETD_01	GEM	\N	\N	\N
f	3509	\N	(5003,0017)	FL	1	X Major Tics	XMajorTics	GEMS_PETD_01	GEM	\N	\N	\N
f	3510	\N	(5003,0018)	FL	1	X Axis Min	XAxisMin	GEMS_PETD_01	GEM	\N	\N	\N
f	3511	\N	(5003,0019)	FL	1	X Axis Max	XAxisMax	GEMS_PETD_01	GEM	\N	\N	\N
f	3512	\N	(5003,001a)	LO	1	Y Axis Label	YAxisLabel	GEMS_PETD_01	GEM	\N	\N	\N
f	3513	\N	(5003,001b)	SL	1	Y Axis Units	YAxisUnits	GEMS_PETD_01	GEM	\N	\N	\N
f	3514	\N	(5003,001c)	FL	1	Y Major Tics	YMajorTics	GEMS_PETD_01	GEM	\N	\N	\N
f	3515	\N	(5003,001d)	FL	1	Y Axis Min	YAxisMin	GEMS_PETD_01	GEM	\N	\N	\N
f	3516	\N	(5003,001e)	FL	1	Y Axis Max	YAxisMax	GEMS_PETD_01	GEM	\N	\N	\N
f	3517	\N	(5003,001f)	LO	1	Legend Font Name	LegendFontName	GEMS_PETD_01	GEM	\N	\N	\N
f	3518	\N	(5003,0020)	SH	1	Legend Font Size	LegendFontSize	GEMS_PETD_01	GEM	\N	\N	\N
f	3519	\N	(5003,0021)	SL	1	Legend Location X	LegendLocationX	GEMS_PETD_01	GEM	\N	\N	\N
f	3520	\N	(5003,0022)	SL	1	Legend Location Y	LegendLocationY	GEMS_PETD_01	GEM	\N	\N	\N
f	3521	\N	(5003,0023)	SL	1	Legend Width	LegendWidth	GEMS_PETD_01	GEM	\N	\N	\N
f	3522	\N	(5003,0024)	SL	1	Legend Height	LegendHeight	GEMS_PETD_01	GEM	\N	\N	\N
f	3523	\N	(5003,0025)	SL	1	Legend Border	LegendBorder	GEMS_PETD_01	GEM	\N	\N	\N
f	3524	\N	(5003,0026)	SL	1	Multi Patient	MultiPatient	GEMS_PETD_01	GEM	\N	\N	\N
f	3525	\N	(5005,0001)	SQ	1	Curve Presentation Sequence	CurvePresentationSequence	GEMS_PETD_01	GEM	\N	\N	\N
f	3526	\N	(5005,0002)	UI	1	Curve Presentation ID	CurvePresentationID	GEMS_PETD_01	GEM	\N	\N	\N
f	3527	\N	(5005,0003)	UI	1	Graph ID	GraphID	GEMS_PETD_01	GEM	\N	\N	\N
f	3528	\N	(5005,0004)	UI	1	Curve ID	CurveID	GEMS_PETD_01	GEM	\N	\N	\N
f	3529	\N	(5005,0005)	SH	1	Curve Presentation Compatible Version	CurvePresentationCompatibleVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3530	\N	(5005,0006)	SH	1	Curve Presentation Software Version	CurvePresentationSoftwareVersion	GEMS_PETD_01	GEM	\N	\N	\N
f	3531	\N	(5005,0007)	LO	1	Curve Label	CurveLabel	GEMS_PETD_01	GEM	\N	\N	\N
f	3532	\N	(5005,0008)	LO	1	Color	Color	GEMS_PETD_01	GEM	\N	\N	\N
f	3533	\N	(5005,0009)	SL	1	Line Type	LineType	GEMS_PETD_01	GEM	\N	\N	\N
f	3534	\N	(5005,000a)	SL	1	Line Width	LineWidth	GEMS_PETD_01	GEM	\N	\N	\N
f	3535	\N	(5005,000b)	SL	1	Point Symbol	PointSymbol	GEMS_PETD_01	GEM	\N	\N	\N
f	3536	\N	(5005,000c)	SL	1	Point Symbol Dim	PointSymbolDim	GEMS_PETD_01	GEM	\N	\N	\N
f	3537	\N	(5005,000d)	LO	1	Point Color	PointColor	GEMS_PETD_01	GEM	\N	\N	\N
f	3538	\N	(0009,0001)	SH	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	658	\N	(0009,0001)	LO	1	Full Fidelity	FullFidelity	GEMS_IDEN_01	GEM	\N	\N	\N
f	659	\N	(0009,0002)	SH	1	Suite Id	SuiteId	GEMS_IDEN_01	GEM	\N	\N	\N
f	660	\N	(0009,0004)	SH	1	Product Id	ProductId	GEMS_IDEN_01	GEM	\N	\N	\N
f	577	\N	(0009,0010)	LO	1	Study Name	StudyName	GEMS_GENIE_1	GEM	\N	\N	\N
f	578	\N	(0009,0011)	SL	1	Study Flags	StudyFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	579	\N	(0009,0012)	SL	1	Study Type	StudyType	GEMS_GENIE_1	GEM	\N	\N	\N
f	661	\N	(0009,0017)	LT	1	Unknown	Unknown	GEMS_IDEN_01	GEM	\N	\N	\N
f	662	\N	(0009,001a)	US	1	Unknown	Unknown	GEMS_IDEN_01	GEM	\N	\N	\N
f	580	\N	(0009,001e)	UI	1	Dataset UID	DatasetUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	581	\N	(0009,0020)	LO	1	Series Object Name	SeriesObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	663	\N	(0009,0020)	US	1	Unknown	Unknown	GEMS_IDEN_01	GEM	\N	\N	\N
f	582	\N	(0009,0021)	SL	1	Series Flags	SeriesFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	583	\N	(0009,0022)	SH	1	User Orientation	UserOrientation	GEMS_GENIE_1	GEM	\N	\N	\N
f	584	\N	(0009,0023)	SL	1	Initiation Type	InitiationType	GEMS_GENIE_1	GEM	\N	\N	\N
f	266	\N	(0009,0024)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	585	\N	(0009,0024)	SL	1	Initiation Delay	InitiationDelay	GEMS_GENIE_1	GEM	\N	\N	\N
f	586	\N	(0009,0025)	SL	1	Initiation Count Rate	InitiationCountRate	GEMS_GENIE_1	GEM	\N	\N	\N
f	267	\N	(0009,0025)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	587	\N	(0009,0026)	SL	1	Number Energy Sets	NumberEnergySets	GEMS_GENIE_1	GEM	\N	\N	\N
f	664	\N	(0009,0027)	SL	1	Image Actual Date	ImageActualDate	GEMS_IDEN_01	GEM	\N	\N	\N
f	588	\N	(0009,0027)	SL	1	Number Detectors	NumberDetectors	GEMS_GENIE_1	GEM	\N	\N	\N
f	3539	\N	(0009,0028)	SL	1	Number RR Windows	NumberRRWindows	GEMS_GENIE_1	GEM	\N	\N	\N
f	589	\N	(0009,0029)	SL	1	Number MG Time Slots	NumberMGTimeSlots	GEMS_GENIE_1	GEM	\N	\N	\N
f	590	\N	(0009,002a)	SL	1	Number View Sets	NumberViewSets	GEMS_GENIE_1	GEM	\N	\N	\N
f	3540	\N	(0009,002b)	LO	1	Trigger History UID	TriggerHistoryUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	591	\N	(0009,002c)	LO	1	Series Comments	SeriesComments	GEMS_GENIE_1	GEM	\N	\N	\N
f	592	\N	(0009,002d)	SL	1	Track Beat Average	TrackBeatAverage	GEMS_GENIE_1	GEM	\N	\N	\N
f	593	\N	(0009,002e)	FD	1	Distance Prescribed	DistancePrescribed	GEMS_GENIE_1	GEM	\N	\N	\N
f	3541	\N	(0009,002f)	SL	1	Table Direction	TableDirection	GEMS_GENIE_1	GEM	\N	\N	\N
f	665	\N	(0009,002f)	SH	1	Unknown	Unknown	GEMS_IDEN_01	GEM	\N	\N	\N
f	594	\N	(0009,0030)	LO	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	666	\N	(0009,0030)	SH	1	Service Id	ServiceId	GEMS_IDEN_01	GEM	\N	\N	\N
f	667	\N	(0009,0031)	SH	1	Mobile Location Number	MobileLocationNumber	GEMS_IDEN_01	GEM	\N	\N	\N
f	3542	\N	(0009,0033)	FD	1	Rotational Continuous Speed	RotationalContinuousSpeed	GEMS_GENIE_1	GEM	\N	\N	\N
f	3543	\N	(0009,0034)	SL	1	Gantry Motion Type (Retired)	GantryMotionTypeRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	595	\N	(0009,0035)	SL	1	Gantry Locus Type	GantryLocusType	GEMS_GENIE_1	GEM	\N	\N	\N
f	596	\N	(0009,0037)	SL	1	Starting Heart Rate	StartingHeartRate	GEMS_GENIE_1	GEM	\N	\N	\N
f	597	\N	(0009,0038)	SL	1	RR Window Width	RRWindowWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	598	\N	(0009,0039)	SL	1	RR Window Offset	RRWindowOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	599	\N	(0009,003a)	SL	1	Percent Cycle Imaged	PercentCycleImaged	GEMS_GENIE_1	GEM	\N	\N	\N
f	268	\N	(0009,003e)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	269	\N	(0009,003f)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	600	\N	(0009,0040)	PN	1	Patient Object Name	PatientObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	601	\N	(0009,0041)	SL	1	Patient Flags	PatientFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	602	\N	(0009,0042)	DA	1	Patient Creation Date	PatientCreationDate	GEMS_GENIE_1	GEM	\N	\N	\N
f	270	\N	(0009,0042)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	603	\N	(0009,0043)	TM	1	Patient Creation Time	PatientCreationTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	271	\N	(0009,0043)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	3544	\N	(0009,0044)	SL	1	Num Views Acquired (Retired)	NumViewsAcquiredRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	3545	\N	(0009,0045)	LT	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	3546	\N	(0009,0046)	UI	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	668	\N	(0009,00e2)	LT	1	Unknown	Unknown	GEMS_IDEN_01	GEM	\N	\N	\N
f	669	\N	(0009,00e3)	UI	1	Equipment UID	EquipmentUID	GEMS_IDEN_01	GEM	\N	\N	\N
f	670	\N	(0009,00e6)	SH	1	Genesis Version Now	GenesisVersionNow	GEMS_IDEN_01	GEM	\N	\N	\N
f	671	\N	(0009,00e7)	UL	1	Exam Record Checksum	ExamRecordChecksum	GEMS_IDEN_01	GEM	\N	\N	\N
f	672	\N	(0009,00e8)	UL	1	Series Suite ID	SeriesSuiteID	GEMS_IDEN_01	GEM	\N	\N	\N
f	673	\N	(0009,00e9)	SL	1	Actual Series Data Time Stamp	ActualSeriesDataTimeStamp	GEMS_IDEN_01	GEM	\N	\N	\N
f	272	\N	(0009,00f8)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	273	\N	(0009,00fb)	IS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	119	\N	(0011,0001)	LT	1	Patient DOB	PatientDOB	DLX_PATNT_01	GEM	\N	\N	\N
f	604	\N	(0011,000a)	SL	1	Series Type	SeriesType	GEMS_GENIE_1	GEM	\N	\N	\N
f	605	\N	(0011,000b)	SL	1	Effective Series Duration	EffectiveSeriesDuration	GEMS_GENIE_1	GEM	\N	\N	\N
f	606	\N	(0011,000c)	SL	1	Num Beats	NumBeats	GEMS_GENIE_1	GEM	\N	\N	\N
f	607	\N	(0011,000d)	LO	1	Radio Nuclide Name	RadioNuclideName	GEMS_GENIE_1	GEM	\N	\N	\N
f	608	\N	(0011,0010)	LO	1	Dataset Object Name	DatasetObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	798	\N	(0011,0010)	SS	1	Patient Status	PatientStatus	GEMS_PATI_01	GEM	\N	\N	\N
f	3547	\N	(0011,0011)	SL	1	Dataset Modified	DatasetModified	GEMS_GENIE_1	GEM	\N	\N	\N
f	609	\N	(0011,0012)	LO	1	Dataset Name	DatasetName	GEMS_GENIE_1	GEM	\N	\N	\N
f	610	\N	(0011,0013)	SL	1	Dataset Type	DatasetType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3548	\N	(0011,0014)	LO	1	Completion Time	CompletionTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	611	\N	(0011,0015)	SL	1	Detector Number	DetectorNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	612	\N	(0011,0016)	SL	1	Energy Number	EnergyNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	613	\N	(0011,0017)	SL	1	RR Interval Window Number	RRIntervalWindowNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	614	\N	(0011,0018)	SL	1	MG Bin Number	MGBinNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	615	\N	(0011,0019)	FD	1	Radius Of Rotation	RadiusOfRotation	GEMS_GENIE_1	GEM	\N	\N	\N
f	616	\N	(0011,001a)	SL	1	Detector Count Zone	DetectorCountZone	GEMS_GENIE_1	GEM	\N	\N	\N
f	617	\N	(0011,001b)	SL	1	Num Energy Windows	NumEnergyWindows	GEMS_GENIE_1	GEM	\N	\N	\N
f	618	\N	(0011,001c)	SL	4	Energy Offset	EnergyOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	619	\N	(0011,001d)	SL	1	Energy Range	EnergyRange	GEMS_GENIE_1	GEM	\N	\N	\N
f	3549	\N	(0011,001e)	SL	4	Energy Width (Retired)	EnergyWidthRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	620	\N	(0011,001f)	SL	1	Image Orientation	ImageOrientation	GEMS_GENIE_1	GEM	\N	\N	\N
f	3550	\N	(0011,0021)	DS	1	Acq Zoom (Retired)	AcqZoomRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	3551	\N	(0011,0022)	DS	1	Acq Pan (Retired)	AcqPanRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	621	\N	(0011,0023)	SL	1	Use FOV Mask	UseFOVMask	GEMS_GENIE_1	GEM	\N	\N	\N
f	622	\N	(0011,0024)	SL	1	FOV Mask Y Cutoff Angle	FOVMaskYCutoffAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	623	\N	(0011,0025)	SL	1	FOV Mask Cutoff Angle	FOVMaskCutoffAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	624	\N	(0011,0026)	SL	1	Table Orientation	TableOrientation	GEMS_GENIE_1	GEM	\N	\N	\N
f	625	\N	(0011,0027)	SL	2	ROI Top Left	ROITopLeft	GEMS_GENIE_1	GEM	\N	\N	\N
f	626	\N	(0011,0028)	SL	2	ROI Bottom Right	ROIBottomRight	GEMS_GENIE_1	GEM	\N	\N	\N
f	3552	\N	(0011,0029)	SL	1	Uniformity Mean	UniformityMean	GEMS_GENIE_1	GEM	\N	\N	\N
f	3553	\N	(0011,002a)	FD	1	Phase Duration (Retired)	PhaseDurationRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	3554	\N	(0011,002c)	FD	1	View X Adjustment	ViewXAdjustment	GEMS_GENIE_1	GEM	\N	\N	\N
f	3555	\N	(0011,002d)	FD	1	View Y Adjustment	ViewYAdjustment	GEMS_GENIE_1	GEM	\N	\N	\N
f	3556	\N	(0011,002e)	SL	1	Pixel Overflow Flag	PixelOverflowFlag	GEMS_GENIE_1	GEM	\N	\N	\N
f	3557	\N	(0011,002f)	SL	1	Overflow Level	OverflowLevel	GEMS_GENIE_1	GEM	\N	\N	\N
f	627	\N	(0011,0030)	LO	1	Picture Object Name	PictureObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	3558	\N	(0011,0031)	LO	1	Acquisition Parent UID	AcquisitionParentUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3559	\N	(0011,0032)	LO	1	Processing Parent UID	ProcessingParentUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	628	\N	(0011,0033)	LO	1	Energy Correct Name	EnergyCorrectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	629	\N	(0011,0034)	LO	1	Spatial Correct Name	SpatialCorrectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	630	\N	(0011,0035)	LO	1	Tuning Calib Name	TuningCalibName	GEMS_GENIE_1	GEM	\N	\N	\N
f	631	\N	(0011,0036)	LO	1	Uniformity Correct Name	UniformityCorrectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	632	\N	(0011,0037)	LT	1	Acquisition Specific Correct Name	AcquisitionSpecificCorrectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	633	\N	(0011,0038)	SL	1	Byte Order	ByteOrder	GEMS_GENIE_1	GEM	\N	\N	\N
f	3560	\N	(0011,0039)	SL	1	Compression Type	CompressionType	GEMS_GENIE_1	GEM	\N	\N	\N
f	634	\N	(0011,003a)	SL	1	Picture Format	PictureFormat	GEMS_GENIE_1	GEM	\N	\N	\N
f	635	\N	(0011,003b)	FD	1	Pixel Scale	PixelScale	GEMS_GENIE_1	GEM	\N	\N	\N
f	636	\N	(0011,003c)	FD	1	Pixel Offset	PixelOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3561	\N	(0011,003d)	SL	4	Energy Peak (Retired)	EnergyPeakRetired	GEMS_GENIE_1	GEM	\N	\N	\N
f	637	\N	(0011,003e)	SL	1	FOV Shape	FOVShape	GEMS_GENIE_1	GEM	\N	\N	\N
f	638	\N	(0011,003f)	SL	1	Dataset Flags	DatasetFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	3562	\N	(0011,0040)	LO	1	Viewing Object Name	ViewingObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	3563	\N	(0011,0041)	SL	1	Orientation Angle	OrientationAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	3564	\N	(0011,0042)	FD	1	Rotation Angle	RotationAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	3565	\N	(0011,0043)	SL	1	Window Inverse Flag	WindowInverseFlag	GEMS_GENIE_1	GEM	\N	\N	\N
f	639	\N	(0011,0044)	FD	1	Threshold Center	ThresholdCenter	GEMS_GENIE_1	GEM	\N	\N	\N
f	640	\N	(0011,0045)	FD	1	Threshold Width	ThresholdWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	641	\N	(0011,0046)	SL	1	Interpolation Type	InterpolationType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3566	\N	(0011,0050)	LO	1	Where Object Name	WhereObjectName	GEMS_GENIE_1	GEM	\N	\N	\N
f	642	\N	(0011,0055)	FD	1	Period	Period	GEMS_GENIE_1	GEM	\N	\N	\N
f	643	\N	(0011,0056)	FD	1	ElapsedTime	ElapsedTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	3567	\N	(0011,0057)	FD	2	FOV	FOV	GEMS_GENIE_1	GEM	\N	\N	\N
f	3568	\N	(0011,0061)	SL	1	Image Size	ImageSize	GEMS_GENIE_1	GEM	\N	\N	\N
f	3569	\N	(0011,0062)	FD	1	Linear FOV	LinearFOV	GEMS_GENIE_1	GEM	\N	\N	\N
f	3570	\N	(0011,0063)	FD	1	Spatial Offset	SpatialOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3571	\N	(0011,0064)	FD	1	Spatial Orientation	SpatialOrientation	GEMS_GENIE_1	GEM	\N	\N	\N
f	3572	\N	(0011,0065)	LO	1	Reference Dataset UID	ReferenceDatasetUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3573	\N	(0011,0066)	SH	1	Starcam Reference Dataset	StarcamReferenceDataset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3574	\N	(0011,0067)	SL	1	Reference Frame Number	ReferenceFrameNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	3575	\N	(0011,0068)	SL	1	Cursor Length	CursorLength	GEMS_GENIE_1	GEM	\N	\N	\N
f	3576	\N	(0011,0069)	SL	1	Number of Cursors	NumberOfCursors	GEMS_GENIE_1	GEM	\N	\N	\N
f	3577	\N	(0011,006a)	SL	1	Cursor Coordinates	CursorCoordinates	GEMS_GENIE_1	GEM	\N	\N	\N
f	3578	\N	(0011,006b)	SL	1	Recon Options Flag	ReconOptionsFlag	GEMS_GENIE_1	GEM	\N	\N	\N
f	3579	\N	(0011,006c)	FD	1	Motion Threshold	MotionThreshold	GEMS_GENIE_1	GEM	\N	\N	\N
f	3580	\N	(0011,006d)	UI	1	Motion Curve UID	MotionCurveUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3581	\N	(0011,006e)	SL	1	Recon Type	ReconType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3582	\N	(0011,006f)	SL	1	Pre Filter Type	PreFilterType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3583	\N	(0011,0071)	SL	1	Back Proj Filter Type	BackProjFilterType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3584	\N	(0011,0072)	SL	1	Recon Arc	ReconArc	GEMS_GENIE_1	GEM	\N	\N	\N
f	3585	\N	(0011,0073)	FD	1	Recon Pan AP Offset	ReconPanAPOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3586	\N	(0011,0074)	FD	1	Recon Pan LR Offset	ReconPanLROffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3587	\N	(0011,0075)	FD	1	Recon Area	ReconArea	GEMS_GENIE_1	GEM	\N	\N	\N
f	3588	\N	(0011,0076)	SL	1	Start View	StartView	GEMS_GENIE_1	GEM	\N	\N	\N
f	3589	\N	(0011,0077)	SL	1	Attenuation Type	AttenuationType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3590	\N	(0011,0078)	SL	1	Dua lEnergy Processing	DualEnergyProcessing	GEMS_GENIE_1	GEM	\N	\N	\N
f	3591	\N	(0011,0079)	SH	1	Pre Filter Param	PreFilterParam	GEMS_GENIE_1	GEM	\N	\N	\N
f	3592	\N	(0011,007a)	SH	1	Pre Filter Param 2	PreFilterParam2	GEMS_GENIE_1	GEM	\N	\N	\N
f	3593	\N	(0011,007b)	SH	1	Back Proj Filter Param	BackProjFilterParam	GEMS_GENIE_1	GEM	\N	\N	\N
f	3594	\N	(0011,007c)	SH	1	Back Proj Filter Param 2	BackProjFilterParam2	GEMS_GENIE_1	GEM	\N	\N	\N
f	3595	\N	(0011,007d)	SH	1	Attenuation Coef	AttenuationCoef	GEMS_GENIE_1	GEM	\N	\N	\N
f	3596	\N	(0011,007e)	SL	1	Ref Slice Width	RefSliceWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	3597	\N	(0011,007f)	FD	1	Ref Trans Pixel Volume	RefTransPixelVolume	GEMS_GENIE_1	GEM	\N	\N	\N
f	3598	\N	(0011,0081)	SH	1	Attenuation Threshold	AttenuationThreshold	GEMS_GENIE_1	GEM	\N	\N	\N
f	3599	\N	(0011,0082)	FD	1	Interpolation Distance	InterpolationDistance	GEMS_GENIE_1	GEM	\N	\N	\N
f	3600	\N	(0011,0083)	FD	1	Interpolation Center X	InterpolationCenterX	GEMS_GENIE_1	GEM	\N	\N	\N
f	3601	\N	(0011,0084)	FD	1	Interpolation Center Y	InterpolationCenterY	GEMS_GENIE_1	GEM	\N	\N	\N
f	3602	\N	(0011,0085)	SL	1	Quant Filter Flag	QuantFilterFlag	GEMS_GENIE_1	GEM	\N	\N	\N
f	3603	\N	(0011,0086)	SL	1	Head Conversion	HeadConversion	GEMS_GENIE_1	GEM	\N	\N	\N
f	3604	\N	(0011,0087)	SL	1	Slice Width Pixels	SliceWidthPixels	GEMS_GENIE_1	GEM	\N	\N	\N
f	3605	\N	(0011,0088)	SL	1	Rfmtr Trans Ref	RfmtrTransRef	GEMS_GENIE_1	GEM	\N	\N	\N
f	3606	\N	(0011,0089)	FD	1	Rfmtr Trans Ref mm	RfmtrTransRefmm	GEMS_GENIE_1	GEM	\N	\N	\N
f	3607	\N	(0011,008a)	SL	1	Two Line Trans Ref	TwoLineTransRef	GEMS_GENIE_1	GEM	\N	\N	\N
f	3608	\N	(0011,008b)	SL	1	Three-D Zero	ThreeDZero	GEMS_GENIE_1	GEM	\N	\N	\N
f	3609	\N	(0011,008c)	SL	1	Three-D Zero Length	ThreeDZeroLength	GEMS_GENIE_1	GEM	\N	\N	\N
f	3610	\N	(0011,008d)	SL	1	Three-D Zero In	ThreeDZeroIn	GEMS_GENIE_1	GEM	\N	\N	\N
f	3611	\N	(0011,0080)	UI	1	Patient Instance Uid	PatientInstanceUid	GEMS_DL_PATNT_01	GEM	\N	\N	\N
f	3612	\N	(0011,0081)	IS	1	Last Study Number	LastStudyNumber	GEMS_DL_PATNT_01	GEM	\N	\N	\N
f	3613	\N	(0011,0082)	CS	1	Patient Repaired	PatientRepaired	GEMS_DL_PATNT_01	GEM	\N	\N	\N
f	3614	\N	(0011,0083)	CS	1	Lock Demographics	LockDemographics	GEMS_DL_PATNT_01	GEM	\N	\N	\N
f	644	\N	(0013,0010)	FD	2	Digital FOV	DigitalFOV	GEMS_GENIE_1	GEM	\N	\N	\N
f	645	\N	(0013,0011)	SL	1	Source Translator	SourceTranslator	GEMS_GENIE_1	GEM	\N	\N	\N
f	646	\N	(0013,0012)	SL	1	RAL Flags	RALFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	3615	\N	(0013,0013)	SQ	1	eNTEGRA Frame Sequence	eNTEGRAFrameSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	3616	\N	(0013,0014)	SL	1	Original Image Number	OriginalImageNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	3617	\N	(0013,0015)	FD	1	Fscalar	Fscalar	GEMS_GENIE_1	GEM	\N	\N	\N
f	647	\N	(0013,0016)	SL	1	AutoTrack Peak	AutoTrackPeak	GEMS_GENIE_1	GEM	\N	\N	\N
f	648	\N	(0013,0017)	SL	1	AutoTrack Width	AutoTrackWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	649	\N	(0013,0018)	FD	1	Transmission Scan Time	TransmissionScanTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	650	\N	(0013,0019)	FD	1	Transmission Mask Width	TransmissionMaskWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	651	\N	(0013,001a)	FD	1	Copper Attenuator Thickness	CopperAttenuatorThickness	GEMS_GENIE_1	GEM	\N	\N	\N
f	3618	\N	(0013,001b)	FD	1	Det Ang Separation	DetAngSeparation	GEMS_GENIE_1	GEM	\N	\N	\N
f	652	\N	(0013,001c)	SL	1	Axial Acceptance Angle	AxialAcceptanceAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	653	\N	(0013,001d)	SL	1	Theta Acceptance Value	ThetaAcceptanceValue	GEMS_GENIE_1	GEM	\N	\N	\N
f	654	\N	(0013,001e)	FD	1-n	Tomo View Offset	TomoViewOffset	GEMS_GENIE_1	GEM	\N	\N	\N
f	3619	\N	(0013,0020)	FD	1	Accepted Beats Time	AcceptedBeatsTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	3620	\N	(0013,0021)	FD	2	Threshold	Threshold	GEMS_GENIE_1	GEM	\N	\N	\N
f	3621	\N	(0013,0022)	FD	2	Linear Depth	LinearDepth	GEMS_GENIE_1	GEM	\N	\N	\N
f	3622	\N	(0013,0023)	LO	1	Unif Date Time	UnifDateTime	GEMS_GENIE_1	GEM	\N	\N	\N
f	3623	\N	(0013,0024)	SL	1	Series Accepted Beats	SeriesAcceptedBeats	GEMS_GENIE_1	GEM	\N	\N	\N
f	3624	\N	(0013,0025)	SL	1	Series Rejected Beats	SeriesRejectedBeats	GEMS_GENIE_1	GEM	\N	\N	\N
f	655	\N	(0013,0026)	LT	1	Study Comments	StudyComments	GEMS_GENIE_1	GEM	\N	\N	\N
f	116	\N	(0015,0001)	DS	1	Stenosis Calibration Ratio	StenosisCalibrationRatio	DLX_EXAMS_01	GEM	\N	\N	\N
f	117	\N	(0015,0002)	DS	1	Stenosis Magnification	StenosisMagnification	DLX_EXAMS_01	GEM	\N	\N	\N
f	118	\N	(0015,0003)	DS	1	Cardiac Calibration Ratio	CardiacCalibrationRatio	DLX_EXAMS_01	GEM	\N	\N	\N
f	3625	\N	(0015,0010)	SL	1	Frame Termination Condition	FrameTerminationCondition	GEMS_GENIE_1	GEM	\N	\N	\N
f	3626	\N	(0015,0011)	SL	1	Frame Termination Value	FrameTerminationValue	GEMS_GENIE_1	GEM	\N	\N	\N
f	3627	\N	(0015,0012)	SL	1	Num ECT Phases	NumECTPhases	GEMS_GENIE_1	GEM	\N	\N	\N
f	3628	\N	(0015,0013)	SL	1	Num WB Scans	NumWBScans	GEMS_GENIE_1	GEM	\N	\N	\N
f	3629	\N	(0015,0014)	SL	1	ECT Phase Num	ECTPhaseNum	GEMS_GENIE_1	GEM	\N	\N	\N
f	3630	\N	(0015,0015)	SL	1	WB Scan Num	WBScanNum	GEMS_GENIE_1	GEM	\N	\N	\N
f	3631	\N	(0015,0016)	SL	1	Comb Head Number	CombHeadNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	3632	\N	(0015,0017)	UL	1	Preceding Beat	PrecedingBeat	GEMS_GENIE_1	GEM	\N	\N	\N
f	3633	\N	(0015,0080)	DS	1	Study Dose	Study Dose	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3634	\N	(0015,0081)	DS	1	Study Total Dap	StudyTotalDap	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3635	\N	(0015,0082)	DS	1	Fluoro Dose Area Product	FluoroDoseAreaProduct	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3636	\N	(0015,0083)	IS	1	Study Fluoro Time	Study luoroTime	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3637	\N	(0015,0084)	DS	1	Cine Dose Area Product	CineDoseAreaProduct	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3638	\N	(0015,0085)	IS	1	Study Record Time	StudyRecordTime	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3639	\N	(0015,0086)	IS	1	Last XA Number	LastXANumber	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3640	\N	(0015,0088)	PN	1-n	Def Operator Name	DefOperatorName	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3641	\N	(0015,0089)	PN	1-n	Def Performing Physician Name	DefPerformingPhysicianName	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3642	\N	(0015,008a)	CS	2	Def Patient Orientation	DefPatientOrientation	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3643	\N	(0015,008b)	IS	1	Last Sc Number	LastScNumber	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3644	\N	(0015,008e)	UI	1	Common Series Instance UID	CommonSeriesInstanceUID	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3645	\N	(0015,008f)	IS	1	Study Number	StudyNumber	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3646	\N	(0015,0092)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3647	\N	(0015,0093)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3648	\N	(0015,0094)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3649	\N	(0015,0095)	IS	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3650	\N	(0015,0096)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3651	\N	(0015,0097)	IS	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3652	\N	(0015,0098)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3653	\N	(0015,0099)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3654	\N	(0015,009a)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3655	\N	(0015,009b)	IS	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3656	\N	(0015,009c)	FL	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3657	\N	(0015,009d)	IS	1	Unknown	Unknown	GEMS_DL_STUDY_01	GEM	\N	\N	\N
f	3658	\N	(0015,0085)	LO	1	Series File Name	SeriesFileName	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	3659	\N	(0015,0087)	IS	1	Number of Images	NumberOfImages	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	3660	\N	(0015,008c)	CS	1	Sent Flag	SentFlag	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	3661	\N	(0015,008d)	US	1	Item Locked	ItemLocked	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	274	\N	(0019,0001)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	275	\N	(0019,0002)	SL	1	Number Of Cells In Detector	NumberOfCellsInDetector	GEMS_ACQU_01	GEM	\N	\N	\N
f	276	\N	(0019,0003)	DS	1	Cell Number At Theta	CellNumberAtTheta	GEMS_ACQU_01	GEM	\N	\N	\N
f	277	\N	(0019,0004)	DS	1	Cell Spacing	CellSpacing	GEMS_ACQU_01	GEM	\N	\N	\N
f	278	\N	(0019,0005)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	279	\N	(0019,0006)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	280	\N	(0019,000e)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	281	\N	(0019,000f)	DS	1	Horizontal Frame Of Reference	HorizontalFrameOfReference	GEMS_ACQU_01	GEM	\N	\N	\N
f	282	\N	(0019,0011)	SS	1	Series Contrast	SeriesContrast	GEMS_ACQU_01	GEM	\N	\N	\N
f	283	\N	(0019,0012)	SS	1	Last Pseq	LastPseq	GEMS_ACQU_01	GEM	\N	\N	\N
f	284	\N	(0019,0013)	SS	1	Start Number For Baseline	StartNumberForBaseline	GEMS_ACQU_01	GEM	\N	\N	\N
f	285	\N	(0019,0014)	SS	1	End Number For Baseline	End NumberForBaseline	GEMS_ACQU_01	GEM	\N	\N	\N
f	286	\N	(0019,0015)	SS	1	Start Number For Enhanced Scans	StartNumberForEnhancedScans	GEMS_ACQU_01	GEM	\N	\N	\N
f	287	\N	(0019,0016)	SS	1	End Number For Enhanced Scans	EndNumberForEnhancedScans	GEMS_ACQU_01	GEM	\N	\N	\N
f	288	\N	(0019,0017)	SS	1	Series Plane	SeriesPlane	GEMS_ACQU_01	GEM	\N	\N	\N
f	289	\N	(0019,0018)	LO	1	First Scan RAS	FirstScanRAS	GEMS_ACQU_01	GEM	\N	\N	\N
f	290	\N	(0019,0019)	DS	1	First Scan Location	FirstScanLocation	GEMS_ACQU_01	GEM	\N	\N	\N
f	291	\N	(0019,001a)	LO	1	Last Scan RAS	LastScanRAS	GEMS_ACQU_01	GEM	\N	\N	\N
f	292	\N	(0019,001b)	DS	1	Last Scan Location	LastScanLocation	GEMS_ACQU_01	GEM	\N	\N	\N
f	293	\N	(0019,001e)	DS	1	Display Field Of View	DisplayFieldOfView	GEMS_ACQU_01	GEM	\N	\N	\N
f	294	\N	(0019,0020)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	295	\N	(0019,0022)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	296	\N	(0019,0023)	DS	1	Table Speed [mm/rotation]	TableSpeed	GEMS_ACQU_01	GEM	\N	\N	\N
f	297	\N	(0019,0024)	DS	1	Mid Scan Time [sec]	MidScanTime	GEMS_ACQU_01	GEM	\N	\N	\N
f	298	\N	(0019,0025)	SS	1	Mid Scan Flag	MidScanFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	299	\N	(0019,0026)	SL	1	Tube Azimuth [degrees]	TubeAzimuth	GEMS_ACQU_01	GEM	\N	\N	\N
f	300	\N	(0019,0027)	DS	1	Rotation Speed (Gantry Period)	RotationSpeed	GEMS_ACQU_01	GEM	\N	\N	\N
f	301	\N	(0019,002a)	DS	1	Xray On Position	XrayOnPosition	GEMS_ACQU_01	GEM	\N	\N	\N
f	302	\N	(0019,002b)	DS	1	Xray Off Position	XrayOffPosition	GEMS_ACQU_01	GEM	\N	\N	\N
f	303	\N	(0019,002c)	SL	1	Number of Triggers	NumberOfTriggers	GEMS_ACQU_01	GEM	\N	\N	\N
f	304	\N	(0019,002d)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	305	\N	(0019,002e)	DS	1	Angle Of First View	AngleOfFirstView	GEMS_ACQU_01	GEM	\N	\N	\N
f	306	\N	(0019,002f)	DS	1	Trigger Frequency	TriggerFrequency	GEMS_ACQU_01	GEM	\N	\N	\N
f	260	\N	(0019,0030)	LO	1	CR EDR Mode	CREDRMode	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	307	\N	(0019,0039)	SS	1	Scan FOV Type	ScanFOVType	GEMS_ACQU_01	GEM	\N	\N	\N
f	892	\N	(0019,0039)	SS	1	Axial Type	AxialType	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	308	\N	(0019,003a)	IS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	309	\N	(0019,003b)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	310	\N	(0019,003c)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	311	\N	(0019,003e)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	312	\N	(0019,003f)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	261	\N	(0019,0040)	LO	1	CR Latitude	CRLatitude	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	313	\N	(0019,0040)	SS	1	Stat Recon Flag	StatReconFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	314	\N	(0019,0041)	SS	1	Compute Type	ComputeType	GEMS_ACQU_01	GEM	\N	\N	\N
f	315	\N	(0019,0042)	SS	1	Segment Number	SegmentNumber	GEMS_ACQU_01	GEM	\N	\N	\N
f	316	\N	(0019,0043)	SS	1	Total Segments Required	TotalSegmentsRequired	GEMS_ACQU_01	GEM	\N	\N	\N
f	317	\N	(0019,0044)	DS	1	Interscan Delay	InterscanDelay	GEMS_ACQU_01	GEM	\N	\N	\N
f	318	\N	(0019,0047)	SS	1	View Compression Factor	ViewCompressionFactor	GEMS_ACQU_01	GEM	\N	\N	\N
f	319	\N	(0019,0048)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	320	\N	(0019,0049)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	321	\N	(0019,004a)	SS	1	Total Number Of Ref Channels	TotalNumberOfRefChannels	GEMS_ACQU_01	GEM	\N	\N	\N
f	322	\N	(0019,004b)	SL	1	Data Size For Scan Data	DataSizeForScanData	GEMS_ACQU_01	GEM	\N	\N	\N
f	262	\N	(0019,0050)	LO	1	CR Group Number	CRGroupNumber	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	323	\N	(0019,0052)	SS	1	Recon Post Processing Flag	ReconPostProcessingFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	324	\N	(0019,0054)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	325	\N	(0019,0057)	SS	1	CT Water Number	CTWaterNumber	GEMS_ACQU_01	GEM	\N	\N	\N
f	326	\N	(0019,0058)	SS	1	CT Bone Number	CTBoneNumber	GEMS_ACQU_01	GEM	\N	\N	\N
f	327	\N	(0019,005a)	FL	1	Acquisition Duration	AcquisitionDuration	GEMS_ACQU_01	GEM	\N	\N	\N
f	328	\N	(0019,005d)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	329	\N	(0019,005e)	SL	1	Number Of Channels 1 To 512	NumberOfChannels1To512	GEMS_ACQU_01	GEM	\N	\N	\N
f	3662	\N	(0019,005f)	SQ	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	330	\N	(0019,005f)	SL	1	Increment Between Channels	IncrementBetweenChannels	GEMS_ACQU_01	GEM	\N	\N	\N
f	331	\N	(0019,0060)	SL	1	Starting View	StartingView	GEMS_ACQU_01	GEM	\N	\N	\N
f	332	\N	(0019,0061)	SL	1	Number Of Views	NumberOfViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	333	\N	(0019,0062)	SL	1	Increment Between Views	IncrementBetweenViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	334	\N	(0019,006a)	SS	1	Dependant On Number Of Views Processed	DependantOnNumberOfViewsProcessed	GEMS_ACQU_01	GEM	\N	\N	\N
f	335	\N	(0019,006b)	SS	1	Field Of View In Detector Cells	FieldOfViewInDetectorCells	GEMS_ACQU_01	GEM	\N	\N	\N
f	263	\N	(0019,0070)	LO	1	CR Image Serial Number	CRImageSerialNumber	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	336	\N	(0019,0070)	SS	1	Value Of Back Projection Button	ValueOfBackProjectionButton	GEMS_ACQU_01	GEM	\N	\N	\N
f	337	\N	(0019,0071)	SS	1	Set If Fatq Estimates Were Used	SetIfFatqEstimatesWereUsed	GEMS_ACQU_01	GEM	\N	\N	\N
f	338	\N	(0019,0072)	DS	1	Z Channel Avg Over Views	ZChannelAvgOverViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	339	\N	(0019,0073)	DS	1	Avg Of Left Ref Channels Over Views	AvgOfLeftRefChannelsOverViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	340	\N	(0019,0074)	DS	1	Max Left Channel Over Views	MaxLeftChannelOverViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	341	\N	(0019,0075)	DS	1	Avg Of Right Ref Channels Over Views	AvgOfRightRefChannelsOverViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	342	\N	(0019,0076)	DS	1	Max Right Channel Over Views	MaxRightChannelOverViews	GEMS_ACQU_01	GEM	\N	\N	\N
f	343	\N	(0019,007d)	DS	1	Second Echo	SecondEcho	GEMS_ACQU_01	GEM	\N	\N	\N
f	344	\N	(0019,007e)	SS	1	Number Of Echos	NumberOfEchos	GEMS_ACQU_01	GEM	\N	\N	\N
f	345	\N	(0019,007f)	DS	1	Table Delta	TableDelta	GEMS_ACQU_01	GEM	\N	\N	\N
f	264	\N	(0019,0080)	LO	1	CR Bar Code Number	CRBarCodeNumber	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	346	\N	(0019,0081)	SS	1	Contiguous	Contiguous	GEMS_ACQU_01	GEM	\N	\N	\N
f	347	\N	(0019,0082)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	348	\N	(0019,0083)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	349	\N	(0019,0084)	DS	1	Peak SAR	PeakSAR	GEMS_ACQU_01	GEM	\N	\N	\N
f	350	\N	(0019,0085)	SS	1	Monitor SAR	MonitorSAR	GEMS_ACQU_01	GEM	\N	\N	\N
f	351	\N	(0019,0086)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	352	\N	(0019,0087)	DS	1	Cardiac Repetition Time	CardiacRepetition Time	GEMS_ACQU_01	GEM	\N	\N	\N
f	353	\N	(0019,0088)	SS	1	Images Per Cardiac Cycle	ImagesPerCardiacCycle	GEMS_ACQU_01	GEM	\N	\N	\N
f	354	\N	(0019,008a)	SS	1	Actual Receive Gain Analog	ActualReceiveGainAnalog	GEMS_ACQU_01	GEM	\N	\N	\N
f	355	\N	(0019,008b)	SS	1	Actual Receive Gain Digital	ActualReceiveGainDigital	GEMS_ACQU_01	GEM	\N	\N	\N
f	356	\N	(0019,008d)	DS	1	Delay After Trigger	DelayAfterTrigger	GEMS_ACQU_01	GEM	\N	\N	\N
f	357	\N	(0019,008f)	SS	1	Swap Phase Frequency	SwapPhaseFrequency	GEMS_ACQU_01	GEM	\N	\N	\N
f	893	\N	(0019,008f)	SS	1	Swap Phase Frequency	SwapPhaseFrequency	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	265	\N	(0019,0090)	LO	1	CR Film Output Exposures	CRFilmOutputExposures	GE ??? From Adantage Review CS	GEM	\N	\N	\N
f	358	\N	(0019,0090)	SS	1	Pause Interval	PauseInterval	GEMS_ACQU_01	GEM	\N	\N	\N
f	359	\N	(0019,0091)	DS	1	Pause Time	PauseTime	GEMS_ACQU_01	GEM	\N	\N	\N
f	360	\N	(0019,0092)	SL	1	Slice Offset On Frequency Axis	SliceOffsetOnFrequencyAxis	GEMS_ACQU_01	GEM	\N	\N	\N
f	361	\N	(0019,0093)	DS	1	Auto Prescan Center Frequency	AutoPrescanCenterFrequency	GEMS_ACQU_01	GEM	\N	\N	\N
f	362	\N	(0019,0094)	SS	1	Auto Prescan Transmit Gain	AutoPrescanTransmitGain	GEMS_ACQU_01	GEM	\N	\N	\N
f	363	\N	(0019,0095)	SS	1	Auto Prescan Analog Receiver Gain	AutoPrescanAnalogReceiverGain	GEMS_ACQU_01	GEM	\N	\N	\N
f	364	\N	(0019,0096)	SS	1	Auto Prescan Digital Receiver Gain	AutoPrescanDigitalReceiverGain	GEMS_ACQU_01	GEM	\N	\N	\N
f	365	\N	(0019,0097)	SL	1	Bitmap Defining CVs	BitmapDefiningCVs	GEMS_ACQU_01	GEM	\N	\N	\N
f	366	\N	(0019,0098)	SS	1	Center Frequency Method	CenterFrequencyMethod	GEMS_ACQU_01	GEM	\N	\N	\N
f	367	\N	(0019,0099)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	368	\N	(0019,009b)	SS	1	Pulse Sequence Mode	PulseSequenceMode	GEMS_ACQU_01	GEM	\N	\N	\N
f	369	\N	(0019,009c)	LO	1	Pulse Sequence Name	PulseSequenceName	GEMS_ACQU_01	GEM	\N	\N	\N
f	894	\N	(0019,009c)	SS	1	Pulse Sequence Name	PulseSequenceName	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	370	\N	(0019,009d)	DT	1	Pulse Sequence Date	PulseSequenceDate	GEMS_ACQU_01	GEM	\N	\N	\N
f	371	\N	(0019,009e)	LO	1	Internal Pulse Sequence Name	InternalPulseSequenceName	GEMS_ACQU_01	GEM	\N	\N	\N
f	372	\N	(0019,009f)	SS	1	Transmitting Coil	TransmittingCoil	GEMS_ACQU_01	GEM	\N	\N	\N
f	895	\N	(0019,009f)	SS	1	Coil Type	CoilType	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	373	\N	(0019,00a0)	SS	1	Surface Coil Type	SurfaceCoilType	GEMS_ACQU_01	GEM	\N	\N	\N
f	374	\N	(0019,00a1)	SS	1	Extremity Coil Flag	ExtremityCoilFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	375	\N	(0019,00a2)	SL	1	Raw Data Run Number	RawDataRunNumber	GEMS_ACQU_01	GEM	\N	\N	\N
f	376	\N	(0019,00a3)	UL	1	Calibrated Field Strength	CalibratedFieldStrength	GEMS_ACQU_01	GEM	\N	\N	\N
f	377	\N	(0019,00a4)	SS	1	SAT Fat Water Bone	SATFatWaterBone	GEMS_ACQU_01	GEM	\N	\N	\N
f	896	\N	(0019,00a4)	SS	1	SAT Fat Water Bone	SATFatWaterBone	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	378	\N	(0019,00a5)	DS	1	Receive Bandwidth	ReceiveBandwidth	GEMS_ACQU_01	GEM	\N	\N	\N
f	379	\N	(0019,00a7)	DS	1	User Data 0	UserData0	GEMS_ACQU_01	GEM	\N	\N	\N
f	380	\N	(0019,00a8)	DS	1	User Data 1	UserData1	GEMS_ACQU_01	GEM	\N	\N	\N
f	381	\N	(0019,00a9)	DS	1	User Data 2	UserData2	GEMS_ACQU_01	GEM	\N	\N	\N
f	382	\N	(0019,00aa)	DS	1	User Data 3	UserData3	GEMS_ACQU_01	GEM	\N	\N	\N
f	383	\N	(0019,00ab)	DS	1	User Data 4	UserData4	GEMS_ACQU_01	GEM	\N	\N	\N
f	384	\N	(0019,00ac)	DS	1	User Data 5	UserData5	GEMS_ACQU_01	GEM	\N	\N	\N
f	385	\N	(0019,00ad)	DS	1	User Data 6	UserData6	GEMS_ACQU_01	GEM	\N	\N	\N
f	386	\N	(0019,00ae)	DS	1	User Data 7	UserData7	GEMS_ACQU_01	GEM	\N	\N	\N
f	387	\N	(0019,00af)	DS	1	User Data 8	UserData8	GEMS_ACQU_01	GEM	\N	\N	\N
f	388	\N	(0019,00b0)	DS	1	User Data 9	UserData9	GEMS_ACQU_01	GEM	\N	\N	\N
f	389	\N	(0019,00b1)	DS	1	User Data 10	UserData10	GEMS_ACQU_01	GEM	\N	\N	\N
f	390	\N	(0019,00b2)	DS	1	User Data 11	UserData11	GEMS_ACQU_01	GEM	\N	\N	\N
f	391	\N	(0019,00b3)	DS	1	User Data 12	UserData12	GEMS_ACQU_01	GEM	\N	\N	\N
f	392	\N	(0019,00b4)	DS	1	User Data 13	UserData13	GEMS_ACQU_01	GEM	\N	\N	\N
f	393	\N	(0019,00b5)	DS	1	User Data 14	UserData14	GEMS_ACQU_01	GEM	\N	\N	\N
f	394	\N	(0019,00b6)	DS	1	User Data 15	UserData15	GEMS_ACQU_01	GEM	\N	\N	\N
f	395	\N	(0019,00b7)	DS	1	User Data 16	UserData16	GEMS_ACQU_01	GEM	\N	\N	\N
f	396	\N	(0019,00b8)	DS	1	User Data 17	UserData17	GEMS_ACQU_01	GEM	\N	\N	\N
f	397	\N	(0019,00b9)	DS	1	User Data 18	UserData18	GEMS_ACQU_01	GEM	\N	\N	\N
f	398	\N	(0019,00ba)	DS	1	User Data 19	UserData19	GEMS_ACQU_01	GEM	\N	\N	\N
f	399	\N	(0019,00bb)	DS	1	User Data 20	UserData20	GEMS_ACQU_01	GEM	\N	\N	\N
f	400	\N	(0019,00bc)	DS	1	User Data 21	UserData21	GEMS_ACQU_01	GEM	\N	\N	\N
f	401	\N	(0019,00bd)	DS	1	User Data 22	UserData22	GEMS_ACQU_01	GEM	\N	\N	\N
f	402	\N	(0019,00be)	DS	1	Projection Angle	ProjectionAngle	GEMS_ACQU_01	GEM	\N	\N	\N
f	403	\N	(0019,00c0)	SS	1	Saturation Planes	SaturationPlanes	GEMS_ACQU_01	GEM	\N	\N	\N
f	897	\N	(0019,00c0)	SS	1	Bitmap Of SAT Selections	BitmapOfSATSelections	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	404	\N	(0019,00c1)	SS	1	Surface Coil Intensity Correction Flag	SurfaceCoilIntensityCorrectionFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	898	\N	(0019,00c1)	SS	1	Surface Coil Intensity Correction Flag	SurfaceCoilIntensityCorrectionFlag	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	405	\N	(0019,00c2)	SS	1	SAT Location R	SATLocationR	GEMS_ACQU_01	GEM	\N	\N	\N
f	406	\N	(0019,00c3)	SS	1	SAT Location L	SATLocationL	GEMS_ACQU_01	GEM	\N	\N	\N
f	407	\N	(0019,00c4)	SS	1	SAT Location A	SATLocationA	GEMS_ACQU_01	GEM	\N	\N	\N
f	408	\N	(0019,00c5)	SS	1	SAT Location P	SATLocationP	GEMS_ACQU_01	GEM	\N	\N	\N
f	409	\N	(0019,00c6)	SS	1	SAT Location H	SATLocationH	GEMS_ACQU_01	GEM	\N	\N	\N
f	410	\N	(0019,00c7)	SS	1	SAT Location F	SATLocationF	GEMS_ACQU_01	GEM	\N	\N	\N
f	411	\N	(0019,00c8)	SS	1	SAT Thickness R L	SATThicknessRL	GEMS_ACQU_01	GEM	\N	\N	\N
f	412	\N	(0019,00c9)	SS	1	SAT Thickness A P	SATThicknessAP	GEMS_ACQU_01	GEM	\N	\N	\N
f	413	\N	(0019,00ca)	SS	1	SAT Thickness H F	SATThicknessHF	GEMS_ACQU_01	GEM	\N	\N	\N
f	414	\N	(0019,00cb)	SS	1	PhaseContrast Flow Axis	PhaseContrastFlowAxis	GEMS_ACQU_01	GEM	\N	\N	\N
f	899	\N	(0019,00cb)	SS	1	Phase Contrast Flow Axis	PhaseContrastFlowAxis	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	415	\N	(0019,00cc)	SS	1	Velocity Encoding	VelocityEncoding	GEMS_ACQU_01	GEM	\N	\N	\N
f	900	\N	(0019,00cc)	SS	1	Phase Contrast Velocity Encoding	PhaseContrastVelocityEncoding	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	416	\N	(0019,00cd)	SS	1	Thickness Disclaimer	ThicknessDisclaimer	GEMS_ACQU_01	GEM	\N	\N	\N
f	417	\N	(0019,00ce)	SS	1	Prescan Type	PrescanType	GEMS_ACQU_01	GEM	\N	\N	\N
f	418	\N	(0019,00cf)	SS	1	Prescan Status	PrescanStatus	GEMS_ACQU_01	GEM	\N	\N	\N
f	419	\N	(0019,00d0)	SH	1	Raw Data Type	RawDataType	GEMS_ACQU_01	GEM	\N	\N	\N
f	420	\N	(0019,00d2)	SS	1	Projection Algorithm	ProjectionAlgorithm	GEMS_ACQU_01	GEM	\N	\N	\N
f	421	\N	(0019,00d3)	SH	1	Projection Algorithm Name	ProjectionAlgorithmName	GEMS_ACQU_01	GEM	\N	\N	\N
f	422	\N	(0019,00d4)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	423	\N	(0019,00d5)	SS	1	Fractional Echo	FractionalEcho	GEMS_ACQU_01	GEM	\N	\N	\N
f	901	\N	(0019,00d5)	SS	1	Fractional Echo	FractionalEcho	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	424	\N	(0019,00d6)	SS	1	Prep Pulse	PrepPulse	GEMS_ACQU_01	GEM	\N	\N	\N
f	425	\N	(0019,00d7)	SS	1	Cardiac Phases	CardiacPhases	GEMS_ACQU_01	GEM	\N	\N	\N
f	426	\N	(0019,00d8)	SS	1	Variable Echo Flag	VariableEchoFlag	GEMS_ACQU_01	GEM	\N	\N	\N
f	902	\N	(0019,00d8)	SS	1	Variable Echo Flag	VariableEchoFlag	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	427	\N	(0019,00d9)	DS	1	Concatenated Sat or DTI Diffusion Direction	ConcatenatedSatOrDTIDiffusionDirection	GEMS_ACQU_01	GEM	\N	\N	\N
f	903	\N	(0019,00d9)	DS	1	Concatenated Sat	ConcatenatedSat	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	428	\N	(0019,00da)	SS	1	Reference Channel Used	ReferenceChannelUsed	GEMS_ACQU_01	GEM	\N	\N	\N
f	429	\N	(0019,00db)	DS	1	Back Projector Coefficient	BackProjectorCoefficient	GEMS_ACQU_01	GEM	\N	\N	\N
f	430	\N	(0019,00dc)	SS	1	Primary Speed Correction Used	PrimarySpeedCorrectionUsed	GEMS_ACQU_01	GEM	\N	\N	\N
f	431	\N	(0019,00dd)	SS	1	Overrange Correction Used	OverrangeCorrectionUsed	GEMS_ACQU_01	GEM	\N	\N	\N
f	432	\N	(0019,00de)	DS	1	Dynamic Z Alpha Value	DynamicZAlphaValue	GEMS_ACQU_01	GEM	\N	\N	\N
f	433	\N	(0019,00df)	DS	1	User Data 23 or DTI Diffusion Direction	UserData23	GEMS_ACQU_01	GEM	\N	\N	\N
f	434	\N	(0019,00e0)	DS	1	User Data 24 or DTI Diffusion Direction	UserData24	GEMS_ACQU_01	GEM	\N	\N	\N
f	435	\N	(0019,00e1)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	436	\N	(0019,00e2)	DS	1	Velocity Encode Scale	VelocityEncodeScale	GEMS_ACQU_01	GEM	\N	\N	\N
f	437	\N	(0019,00e3)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	438	\N	(0019,00e4)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	439	\N	(0019,00e5)	IS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	440	\N	(0019,00e6)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	441	\N	(0019,00e8)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	442	\N	(0019,00e9)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	443	\N	(0019,00eb)	DS	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	444	\N	(0019,00ec)	US	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	445	\N	(0019,00f0)	UN	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	446	\N	(0019,00f1)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	447	\N	(0019,00f2)	SS	1	Fast Phases	FastPhases	GEMS_ACQU_01	GEM	\N	\N	\N
f	904	\N	(0019,00f2)	SS	1	Number Of Phases	NumberOfPhases	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	448	\N	(0019,00f3)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	449	\N	(0019,00f4)	LT	1	Unknown	Unknown	GEMS_ACQU_01	GEM	\N	\N	\N
f	450	\N	(0019,00f9)	DS	1	Transmit Gain	TransmitGain	GEMS_ACQU_01	GEM	\N	\N	\N
f	3663	\N	(0019,000b)	DS	1-2	FOV Dimension Double	FOVDimensionDouble	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3664	\N	(0019,002b)	FL	1	Distance to table top	DistanceToTableTop	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3665	\N	(0019,0030)	LO	1	Image File Name	ImageFileName	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3666	\N	(0019,0031)	IS	1	Default Spatial Filter Family	DefaultSpatialFilterFamily	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3667	\N	(0019,0032)	IS	1	Default Spatial Filter Strength	DefaultSpatialFilterStrength	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3668	\N	(0019,0033)	DS	1	Min Saturation Dose	MinSaturationDose	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3669	\N	(0019,0034)	DS	1	Detector Gain	DetectorGain	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3670	\N	(0019,0035)	DS	1	Patient Dose Limit	PatientDoseLimit	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3671	\N	(0019,0036)	DS	1	Preproc Image Rate Max	PreprocImageRateMax	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3672	\N	(0019,0037)	CS	1	Sensor Roi Shape	SensorRoiShape	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3673	\N	(0019,0038)	DS	1	Sensor Roi x Position	SensorRoixPosition	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3674	\N	(0019,0039)	DS	1	Sensor Roi y Position	SensorRoiyPosition	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3675	\N	(0019,003a)	DS	1	Sensor Roi x Size	SensorRoixSize	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3676	\N	(0019,003b)	DS	1	Sensor Roi y Size	SensorRoiySize	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3677	\N	(0019,003d)	DS	1	Noise Sensitivity	NoiseSensitivity	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3678	\N	(0019,003e)	DS	1	Sharp Sensitivity	SharpSensitivity	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3679	\N	(0019,003f)	DS	1	Contrast Sensitivity	ContrastSensitivity	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3680	\N	(0019,0040)	DS	1	Lag Sensitivity	LagSensitivity	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3681	\N	(0019,0041)	CS	1	Tube	Tube	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3682	\N	(0019,0042)	US	1	Detector Size Rows	DetectorSizeRows	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3683	\N	(0019,0043)	US	1	Detector Size Columns	DetectorSizeColumns	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3684	\N	(0019,0044)	DS	1	Min Object Size	MinObjectSize	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3685	\N	(0019,0045)	DS	1	Max Object Size	MaxObjectSize	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3686	\N	(0019,0046)	DS	1	Max Object Speed	MaxObjectSpeed	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3687	\N	(0019,0047)	CS	1	Object Back Motion	ObjectBackMotion	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3688	\N	(0019,0048)	UL	1	Exposure Trajectory Family	ExposureTrajectoryFamily	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3689	\N	(0019,0049)	DS	1	Window Time Duration	WindowTimeDuration	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3690	\N	(0019,004a)	CS	1	Positioner Angle Display Mode	PositionerAngleDisplayMode	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3691	\N	(0019,004b)	IS	2	Detector Origin	DetectorOrigin	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3692	\N	(0019,004c)	CS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3693	\N	(0019,004e)	DS	2	Default Brightness and Contrast	DefaultBrightnessContrast	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3694	\N	(0019,004f)	DS	2	User Brightness and Contrast	UserBrightnessContrast	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3695	\N	(0019,0050)	IS	1	Source Series Number	SourceSeriesNumber	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3696	\N	(0019,0051)	IS	1	Source Image Number	SourceImageNumber	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3697	\N	(0019,0052)	IS	1	Source Frame Number	SourceFrameNumber	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3698	\N	(0019,0053)	UI	1	Source Series Item Id	SourceSeriesItemId	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3699	\N	(0019,0054)	UI	1	Source Image Item Id	SourceImageItemId	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3700	\N	(0019,0055)	UI	1	Source Frame Item Id	SourceFrameItemId	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3701	\N	(0019,0060)	US	1	Number of Points Before Acquisition	NumberOfPointsBeforeAcquisition	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3702	\N	(0019,0061)	OW	1	Curve Data Before Acquisition	CurveDataBeforeAcquisition	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3703	\N	(0019,0062)	US	1	Number of Points Trigger	NumberOfPointsTrigger	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3704	\N	(0019,0063)	OW	1	Curve Data Trigger	CurveDataTrigger	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3705	\N	(0019,0064)	SH	1	ECG Synchronization	ECGSynchronization	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3706	\N	(0019,0065)	SH	1	ECG Delay Mode	ECGDelayMode	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3707	\N	(0019,0066)	IS	1-n	ECG Delay Vector	ECGDelayVector	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3708	\N	(0019,0067)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3709	\N	(0019,0068)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3710	\N	(0019,0069)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3711	\N	(0019,007a)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3712	\N	(0019,007b)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3713	\N	(0019,007c)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3714	\N	(0019,0080)	DS	1	Image Dose	ImageDose	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3715	\N	(0019,0081)	US	1	Calibration Frame	CalibrationFrame	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3716	\N	(0019,0082)	CS	1	Calibration Object	CalibrationObject	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3717	\N	(0019,0083)	DS	1	Calibration Object Size mm	CalibrationObjectSize	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3718	\N	(0019,0084)	FL	1	Calibration Factor	CalibrationFactor	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3719	\N	(0019,0085)	DA	1	Calibration Date	CalibrationDate	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3720	\N	(0019,0086)	TM	1	Calibration Time	CalibrationTime	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3721	\N	(0019,0087)	US	1	Calibration Accuracy	CalibrationAccuracy	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3722	\N	(0019,0088)	CS	1	Calibration Extended	CalibrationExtended	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3723	\N	(0019,0089)	US	1	Calibration Image Original	CalibrationImageOriginal	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3724	\N	(0019,008a)	US	1	Calibration Frame Original	CalibrationFrameOriginal	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3725	\N	(0019,008b)	US	1	Calibration nb points uif	CalibrationNbPointsUif	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3726	\N	(0019,008c)	US	1-n	Calibration Points Row	CalibrationPointsRow	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3727	\N	(0019,008d)	US	1-n	Calibration Points Column	CalibrationPointsColumn	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3728	\N	(0019,008e)	FL	1	Calibration Magnification Ratio	CalibrationMagnificationRatio	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3729	\N	(0019,008f)	LO	1	Calibration Software Version	CalibrationSoftwareVersion	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3730	\N	(0019,0090)	LO	1	Extended Calibration Software Version	ExtendedCalibrationSoftwareVersion	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3731	\N	(0019,0091)	IS	1	Calibration Return Code	CalibrationReturnCode	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3732	\N	(0019,0092)	DS	1	Detector Rotation Angle	DetectorRotationAngle	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3733	\N	(0019,0093)	CS	1	Spatial Change	SpatialChange	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3734	\N	(0019,0094)	CS	1	Inconsistent Flag	InconsistentFlag	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3735	\N	(0019,0095)	CS	2	Horizontal and Vertical Image Flip	HorizontalAndVerticalImageFlip	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3736	\N	(0019,0096)	CS	1	Internal Label Image	InternalLabelImage	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3737	\N	(0019,0097)	DS	1-n	Angle 1 increment	Angle1Increment	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3738	\N	(0019,0098)	DS	1-n	Angle 2 increment	Angle2Increment	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3739	\N	(0019,0099)	DS	1-n	Angle 3 increment	Angle3Increment	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3740	\N	(0019,009a)	DS	1-n	Sensor Feedback	SensorFeedback	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3741	\N	(0019,009b)	CS	1	Grid	Grid	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3742	\N	(0019,009c)	FL	1	Default Mask Pixel Shift	DefaultMaskPixelShift	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3743	\N	(0019,009d)	CS	1	Applicable Review Mode	ApplicableReviewMode	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3744	\N	(0019,009e)	DS	1-n	Log LUT Control Points	LogLUTControlPoints	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3745	\N	(0019,009f)	DS	1-n	Exp LUT SUB Control Points	ExpLUTSUBControlPoints	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3746	\N	(0019,00a0)	DS	1	ABD Value	ABDValue	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3747	\N	(0019,00a1)	DS	1	Subtraction Window Center	SubtractionWindowCenter	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3748	\N	(0019,00a2)	DS	1	Subtraction Window Width	SubtractionWindowWidth	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3749	\N	(0019,00a3)	DS	1	Image Rotation	ImageRotation	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3750	\N	(0019,00a4)	CS	1	Auto Injection Enabled	AutoInjectionEnabled	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3751	\N	(0019,00a5)	CS	1	Injection Phase	InjectionPhase	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3752	\N	(0019,00a6)	DS	1	Injection Delay	InjectionDelay	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3753	\N	(0019,00a7)	IS	1	Reference Injection Frame Number	ReferenceInjectionFrameNumber	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3754	\N	(0019,00a8)	DS	1	Injection Duration	InjectionDuration	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3755	\N	(0019,00a9)	DS	1-n	EPT	EPT	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3756	\N	(0019,00aa)	CS	1	Can Downscan 512	CanDownscan512	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3757	\N	(0019,00ab)	IS	1	Current Spatial Filter Strength	CurrentSpatialFilterStrength	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3758	\N	(0019,00ac)	DS	1	Brightness Sensitivity	BrightnessSensitivity	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3759	\N	(0019,00ad)	DS	1-n	Exp LUT NOSUB Control Points	ExpLUTNOSUBControlPoints	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3760	\N	(0019,00af)	DS	1-n	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3761	\N	(0019,00b0)	DS	1-n	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3762	\N	(0019,00b1)	LO	1	Acquisition Mode Description	AcquisitionModeDescription	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3763	\N	(0019,00b2)	LO	1	Acquisition Mode Description Label	AcquisitionModeDescriptionLabel	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3764	\N	(0019,00b3)	LO	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3765	\N	(0019,00b8)	FL	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	890	\N	(0033,0005)	UN	1	Unknown	Unknown	GEMS_YMHD_01	GEM	\N	\N	\N
f	3766	\N	(0019,00ba)	CS	1	Acquisition Region	AcquisitionRegion	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3767	\N	(0019,00bb)	CS	1	Acquisition SUB Mode	AcquisitionSUBMode	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3768	\N	(0019,00bc)	FL	1	Table Cradle Angle	TableCradleAngle	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3769	\N	(0019,00bd)	CS	1-n	Table Rotation Status Vector	TableRotationStatusVector	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3770	\N	(0019,00be)	FL	1-n	Source to Image Distance per Frame Vector	SourceToImageDistancePerFrameVector	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3771	\N	(0019,00c2)	DS	1-n	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3772	\N	(0019,00c3)	FL	1-n	Table Rotation Angle Increment	TableRotationAngleIncrement	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3773	\N	(0019,00c4)	IS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3774	\N	(0019,00c7)	CS	1	Patient Position per Image	PatientPositionPerImage	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3775	\N	(0019,00d7)	FL	1-n	Table X Position to Isoâcenter Increment	TableXPositionToIsocenterIncrement	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3776	\N	(0019,00d8)	FL	1-n	Table Y Position to Isoâcenter Increment	TableYPositionToIsocenterIncrement	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3777	\N	(0019,00d9)	FL	1-n	Table Z Position to Isoâcenter Increment	TableZPositionToIsocenterIncrement	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3778	\N	(0019,00da)	FL	1-n	Table Head Tilt Angle Increment	TableHeadTiltAngleIncrement	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3779	\N	(0019,00dc)	LO	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3780	\N	(0019,00de)	CS	1	Acquisition Plane	AcquisitionPlane	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3781	\N	(0019,00dd)	DS	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3782	\N	(0019,00e0)	FL	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3783	\N	(0019,00e9)	FL	1-n	Source to Detector Distance per Frame Vector	SourceToDetectorDistancePerFrameVector	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3784	\N	(0019,00ea)	FL	1	Table Rotation Angle	TableRotationAngle	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3785	\N	(0019,00eb)	FL	1	Table X Position to Isoâcenter	TableXPositionToIsocenter	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3786	\N	(0019,00ec)	FL	1	Table Y Position to Isoâcenter	TableYPositionToIsocenter	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3787	\N	(0019,00ed)	FL	1	Table Z Position to Isoâcenter	TableZPositionToIsocenter	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3788	\N	(0019,00ee)	FL	1	Table Head Tilt Angle	TableHeadTiltAngle	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	3789	\N	(0019,00ef)	FL	1	Unknown	Unknown	GEMS_DL_IMG_01	GEM	\N	\N	\N
f	120	\N	(0019,0001)	DS	1	Angle Value L Arm	AngleValueLArm	DLX_SERIE_01	GEM	\N	\N	\N
f	121	\N	(0019,0002)	DS	1	Angle Value P Arm	AngleValuePArm	DLX_SERIE_01	GEM	\N	\N	\N
f	122	\N	(0019,0003)	DS	1	Angle Value C Arm	AngleValueCArm	DLX_SERIE_01	GEM	\N	\N	\N
f	123	\N	(0019,0004)	CS	1	Angle Label L Arm	AngleLabelLArm	DLX_SERIE_01	GEM	\N	\N	\N
f	124	\N	(0019,0005)	CS	1	Angle Label P Arm	AngleLabelPArm	DLX_SERIE_01	GEM	\N	\N	\N
f	125	\N	(0019,0006)	CS	1	Angle Label C Arm	AngleLabelCArm	DLX_SERIE_01	GEM	\N	\N	\N
f	126	\N	(0019,0007)	ST	1	Procedure Name	ProcedureName	DLX_SERIE_01	GEM	\N	\N	\N
f	127	\N	(0019,0008)	ST	1	Exam Name	ExamName	DLX_SERIE_01	GEM	\N	\N	\N
f	128	\N	(0019,0009)	SH	1	Patient Size	PatientSize	DLX_SERIE_01	GEM	\N	\N	\N
f	129	\N	(0019,000a)	IS	1	Record View	RecordView	DLX_SERIE_01	GEM	\N	\N	\N
f	130	\N	(0019,0010)	DS	1	Injector Delay	InjectorDelay	DLX_SERIE_01	GEM	\N	\N	\N
f	131	\N	(0019,0011)	CS	1	Auto Inject	AutoInject	DLX_SERIE_01	GEM	\N	\N	\N
f	132	\N	(0019,0014)	IS	1	Acquisition Mode	AcquisitionMode	DLX_SERIE_01	GEM	\N	\N	\N
f	133	\N	(0019,0015)	CS	1	Camera Rotation Enabled	CameraRotationEnabled	DLX_SERIE_01	GEM	\N	\N	\N
f	134	\N	(0019,0016)	CS	1	Reverse Sweep	ReverseSweep	DLX_SERIE_01	GEM	\N	\N	\N
f	135	\N	(0019,0017)	IS	1	User Spatial Filter Strength	UserSpatialFilterStrength	DLX_SERIE_01	GEM	\N	\N	\N
f	136	\N	(0019,0018)	IS	1	User Zoom Factor	UserZoomFactor	DLX_SERIE_01	GEM	\N	\N	\N
f	137	\N	(0019,0019)	IS	1	X Zoom Center	XZoomCenter	DLX_SERIE_01	GEM	\N	\N	\N
f	138	\N	(0019,001a)	IS	1	Y Zoom Center	YZoomCenter	DLX_SERIE_01	GEM	\N	\N	\N
f	139	\N	(0019,001b)	DS	1	Focus	Focus	DLX_SERIE_01	GEM	\N	\N	\N
f	140	\N	(0019,001c)	CS	1	Dose	Dose	DLX_SERIE_01	GEM	\N	\N	\N
f	141	\N	(0019,001d)	IS	1	Side Mark	SideMark	DLX_SERIE_01	GEM	\N	\N	\N
f	142	\N	(0019,001e)	IS	1	Percentage Landscape	PercentageLandscape	DLX_SERIE_01	GEM	\N	\N	\N
f	143	\N	(0019,001f)	DS	1	Exposure Duration	ExposureDuration	DLX_SERIE_01	GEM	\N	\N	\N
f	3790	\N	(0019,0020)	LO	1	Ip Address	IpAddress	DLX_SERIE_01	GEM	\N	\N	\N
f	3791	\N	(0019,0021)	DS	1	Table position Z (vertical) first frame	TablePositionZ	DLX_SERIE_01	GEM	\N	\N	\N
f	3792	\N	(0019,0022)	DS	1	Table position X (longitudinal) first frame	TablePositionX	DLX_SERIE_01	GEM	\N	\N	\N
f	3793	\N	(0019,0023)	DS	1	Table position Y (lateral) first frame	TablePositionY	DLX_SERIE_01	GEM	\N	\N	\N
f	3794	\N	(0019,0024)	DS	1	Lambda cm Pincushion Distortion	Lambda	DLX_SERIE_01	GEM	\N	\N	\N
f	3795	\N	(0019,0025)	DS	1	LV Regression Slope Coefficient	RegressionSlope	DLX_SERIE_01	GEM	\N	\N	\N
f	3796	\N	(0019,0026)	DS	1	LV Regression Intercept Coefficient	RegressionIntercept	DLX_SERIE_01	GEM	\N	\N	\N
f	3797	\N	(0019,1027)	DS	1	Image chain FWHM psf mm min	ImageChainFWHMPsfMmMin	DLX_SERIE_01	GEM	\N	typo in element assumed "1027" translated to "0027"	\N
f	3798	\N	(0019,1028)	DS	1	Image chain FWHM psf mm max	ImageChainFWHMPsfMmMax	DLX_SERIE_01	GEM	\N	typo in element assumed "1028" translated to "0028"	\N
f	3799	\N	(0019,004c)	CS	1	Internal Label	InternalLabel	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	3800	\N	(0019,004d)	CS	1	Browser Hide	BrowserHide	GEMS_DL_SERIES_01	GEM	\N	\N	\N
f	799	\N	(0021,0003)	SS	1	Series From Which Prescribed	SeriesFromWhichPrescribed	GEMS_RELA_01	GEM	\N	\N	\N
f	800	\N	(0021,0005)	SH	1	Genesis Version Now	GenesisVersionNow	GEMS_RELA_01	GEM	\N	\N	\N
f	801	\N	(0021,0007)	UL	1	Series Record Checksum	SeriesRecordChecksum	GEMS_RELA_01	GEM	\N	\N	\N
f	802	\N	(0021,0015)	US	1	Unknown	Unknown	GEMS_RELA_01	GEM	\N	\N	\N
f	803	\N	(0021,0016)	SS	1	Unknown	Unknown	GEMS_RELA_01	GEM	\N	\N	\N
f	804	\N	(0021,0018)	SH	1	Genesis Version Now	GenesisVersionNow	GEMS_RELA_01	GEM	\N	\N	\N
f	891	\N	(0033,0006)	UN	1	Unknown	Unknown	GEMS_YMHD_01	GEM	\N	\N	\N
f	805	\N	(0021,0019)	UL	1	Acq Recon Record Checksum	AcqReconRecordChecksum	GEMS_RELA_01	GEM	\N	\N	\N
f	806	\N	(0021,0020)	DS	1	Table Start Location	TableStartLocation	GEMS_RELA_01	GEM	\N	\N	\N
f	807	\N	(0021,0035)	SS	1	Series From Which Prescribed	SeriesFromWhichPrescribed	GEMS_RELA_01	GEM	\N	\N	\N
f	808	\N	(0021,0036)	SS	1	Image From Which Prescribed	ImageFromWhichPrescribed	GEMS_RELA_01	GEM	\N	\N	\N
f	809	\N	(0021,0037)	SS	1	Screen Format	ScreenFormat	GEMS_RELA_01	GEM	\N	\N	\N
f	810	\N	(0021,004a)	LO	1	Anatomical Reference For Scout	AnatomicalReferenceForScout	GEMS_RELA_01	GEM	\N	\N	\N
f	811	\N	(0021,004e)	US	1	Unknown	Unknown	GEMS_RELA_01	GEM	\N	\N	\N
f	812	\N	(0021,004f)	SS	1	Locations In Acquisition	LocationsInAcquisition	GEMS_RELA_01	GEM	\N	\N	\N
f	813	\N	(0021,0050)	SS	1	Graphically Prescribed	GraphicallyPrescribed	GEMS_RELA_01	GEM	\N	\N	\N
f	814	\N	(0021,0051)	DS	1	Rotation From Source X Rot	RotationFromSourceXRot	GEMS_RELA_01	GEM	\N	\N	\N
f	815	\N	(0021,0052)	DS	1	Rotation From Source Y Rot	RotationFromSourceYRot	GEMS_RELA_01	GEM	\N	\N	\N
f	816	\N	(0021,0053)	DS	1	Rotation From Source Z Rot	RotationFromSourceZRot	GEMS_RELA_01	GEM	\N	\N	\N
f	817	\N	(0021,0054)	SH	3	Image Position	ImagePosition	GEMS_RELA_01	GEM	\N	\N	\N
f	818	\N	(0021,0055)	SH	6	Image Orientation	ImageOrientation	GEMS_RELA_01	GEM	\N	\N	\N
f	819	\N	(0021,0056)	SL	1	Num 3D slabs	Num3DSlabs	GEMS_RELA_01	GEM	\N	\N	\N
f	820	\N	(0021,0057)	SL	1	Locs per 3D slab	LocsPer3DSlab	GEMS_RELA_01	GEM	\N	\N	\N
f	821	\N	(0021,0058)	SL	1	Overlaps	Overlaps	GEMS_RELA_01	GEM	\N	\N	\N
f	822	\N	(0021,0059)	SL	1	Image Filtering 0.5/0.2T	ImageFiltering	GEMS_RELA_01	GEM	\N	\N	\N
f	823	\N	(0021,005a)	SL	1	Diffusion direction	DiffusionDirection	GEMS_RELA_01	GEM	\N	\N	\N
f	824	\N	(0021,005b)	DS	1	Tagging Flip Angle	TaggingFlipAngle	GEMS_RELA_01	GEM	\N	\N	\N
f	825	\N	(0021,005c)	DS	1	Tagging Orientation	TaggingFlipAngle	GEMS_RELA_01	GEM	\N	\N	\N
f	826	\N	(0021,005d)	DS	1	Tag Spacing	TagSpacing	GEMS_RELA_01	GEM	\N	\N	\N
f	827	\N	(0021,005e)	DS	1	RTIA_timer	RTIATimer	GEMS_RELA_01	GEM	\N	\N	\N
f	828	\N	(0021,005f)	DS	1	Fps	Fps	GEMS_RELA_01	GEM	\N	\N	\N
f	829	\N	(0021,0070)	LT	1	Unknown	Unknown	GEMS_RELA_01	GEM	\N	\N	\N
f	830	\N	(0021,0071)	LT	1	Unknown	Unknown	GEMS_RELA_01	GEM	\N	\N	\N
f	831	\N	(0021,0081)	DS	1	Auto Window Level Alpha	AutoWindowLevelAlpha	GEMS_RELA_01	GEM	\N	\N	\N
f	832	\N	(0021,0082)	DS	1	Auto Window Level Beta	AutoWindowLevelBeta	GEMS_RELA_01	GEM	\N	\N	\N
f	833	\N	(0021,0083)	DS	1	Auto Window Level Window	AutoWindowLevelWindow	GEMS_RELA_01	GEM	\N	\N	\N
f	834	\N	(0021,0084)	DS	1	Auto Window Level Level	AutoWindowLevelLevel	GEMS_RELA_01	GEM	\N	\N	\N
f	835	\N	(0021,0090)	SS	1	Tube Focal Spot Position	TubeFocalSpotPosition	GEMS_RELA_01	GEM	\N	\N	\N
f	836	\N	(0021,0091)	SS	1	Biopsy Position	BiopsyPosition	GEMS_RELA_01	GEM	\N	\N	\N
f	837	\N	(0021,0092)	FL	1	Biopsy T Location	BiopsyTLocation	GEMS_RELA_01	GEM	\N	\N	\N
f	838	\N	(0021,0093)	FL	1	Biopsy Ref Location	BiopsyRefLocation	GEMS_RELA_01	GEM	\N	\N	\N
f	3801	\N	(0021,0020)	LT	1	Generalized Calibration	GeneralizedCalibration	GEMS_XR3DCAL_01	GEM	\N	\N	\N
f	3802	\N	(0021,0001)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3803	\N	(0021,0010)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3804	\N	(0021,0011)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3805	\N	(0021,0012)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3806	\N	(0021,0013)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3807	\N	(0021,0014)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3808	\N	(0021,0015)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3809	\N	(0021,0016)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3810	\N	(0021,0017)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3811	\N	(0021,0018)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3812	\N	(0021,0019)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3813	\N	(0021,001a)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3814	\N	(0021,001b)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3815	\N	(0021,001c)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3816	\N	(0021,001d)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3817	\N	(0021,001e)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3818	\N	(0021,001f)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3819	\N	(0021,0020)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3820	\N	(0021,0040)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3821	\N	(0021,0041)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3822	\N	(0021,0050)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3823	\N	(0021,0060)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	3824	\N	(0021,0065)	UN	1	Unknown	Unknown	Mayo/IBM Archive Project	MIBM	\N	\N	\N
f	471	\N	(0023,0000)	DS	1	CR DRE	CRDRE	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	501	\N	(0023,0000)	DS	1	CR DRE	CRDRE	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	451	\N	(0023,0000)	LO	1	CR Exposure Menu Code	CRExposureMenuCode	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	481	\N	(0023,0000)	LO	1	CR Exposure Menu Code	CRExposureMenuCode	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	461	\N	(0023,0000)	US	1	CR S Shift	CRSShift	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	491	\N	(0023,0000)	US	1	CR S Shift	CRSShift	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	883	\N	(0023,0001)	SL	1	Number Of Series In Study	NumberOfSeriesInStudy	GEMS_STDY_01	GEM	\N	\N	\N
f	884	\N	(0023,0002)	SL	1	Number Of Unarchived Series	NumberOfUnarchivedSeries	GEMS_STDY_01	GEM	\N	\N	\N
f	462	\N	(0023,0010)	DS	1	CR C Shift	CRCShift	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	452	\N	(0023,0010)	LO	1	CR Exposure Menu String	CRExposureMenuString	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	482	\N	(0023,0010)	LO	1	CR Exposure Menu String	CRExposureMenuString	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	492	\N	(0023,0010)	LO	1	CR C Shift	CRCShift	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	885	\N	(0023,0010)	SS	1	Reference Image Field	ReferenceImageField	GEMS_STDY_01	GEM	\N	\N	\N
f	472	\N	(0023,0010)	US	1	CR DRN	CRDRN	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	502	\N	(0023,0010)	US	1	CR DRN	CRDRN	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	463	\N	(0023,0020)	DS	1	CR GT	CRGT	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	473	\N	(0023,0020)	DS	1	CR ORE	CRORE	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	503	\N	(0023,0020)	DS	1	CR ORE	CRORE	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	453	\N	(0023,0020)	LO	1	CR EDR Mode	CREDRMode	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	483	\N	(0023,0020)	LO	1	CR EDR Mode	CREDRMode	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	493	\N	(0023,0020)	LO	1	CR GT	CRGT	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	464	\N	(0023,0030)	DS	1	CR GA	CRGA	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	494	\N	(0023,0030)	DS	1	CR GA	CRGA	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	454	\N	(0023,0030)	LO	1	CR Latitude	CRLatitude	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	484	\N	(0023,0030)	LO	1	CR Latitude	CRLatitude	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	474	\N	(0023,0030)	US	1	CR ORN	CRORN	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	504	\N	(0023,0030)	US	1	CR ORN	CRORN	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	465	\N	(0023,0040)	DS	1	CR GC	CRGC	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	495	\N	(0023,0040)	DS	1	CR GC	CRGC	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	455	\N	(0023,0040)	LO	1	CR Group Number	CRGroupNumber	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	485	\N	(0023,0040)	LO	1	CR Group Number	CRGroupNumber	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	475	\N	(0023,0040)	US	1	CR ORD	CRORD	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	505	\N	(0023,0040)	US	1	CR ORD	CRORD	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	466	\N	(0023,0050)	DS	1	CR GS	CRGS	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	496	\N	(0023,0050)	DS	1	CR GS	CRGS	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	476	\N	(0023,0050)	LO	1	CR Cassette Size	CRCassetteSize	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	506	\N	(0023,0050)	LO	1	CR Cassette Size	CRCassetteSize	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	886	\N	(0023,0050)	SS	1	Summary Image	SummaryImage	GEMS_STDY_01	GEM	\N	\N	\N
f	456	\N	(0023,0050)	US	1	CR Image Serial Number	CRImageSerialNumber	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	486	\N	(0023,0050)	US	1	CR Image Serial Number	CRImageSerialNumber	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	467	\N	(0023,0060)	DS	1	CR RT	CRRT	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	457	\N	(0023,0060)	LO	1	CR Bar Code Number	CRBarCodeNumber	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	477	\N	(0023,0060)	LO	1	CR Machine ID	CRMachineID	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	487	\N	(0023,0060)	LO	1	CR Bar Code Number	CRBarCodeNumber	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	497	\N	(0023,0060)	LO	1	CR RT	CRRT	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	507	\N	(0023,0060)	LO	1	CR Machine ID	CRMachineID	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	468	\N	(0023,0070)	DS	1	CR RE	CRRE	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	498	\N	(0023,0070)	DS	1	CR RE	CRRE	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	887	\N	(0023,0070)	FD	1	Start Time Secs In First Axial	StartTimeSecsInFirstAxial	GEMS_STDY_01	GEM	\N	\N	\N
f	458	\N	(0023,0070)	LO	1	CR Film Output Exposure	CRFilmOutputExposure	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	478	\N	(0023,0070)	LO	1	CR Machine Type	CRMachineType	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	488	\N	(0023,0070)	LO	1	CR Film Output Exposure	CRFilmOutputExposure	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	508	\N	(0023,0070)	LO	1	CR Machine Type	CRMachineType	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	888	\N	(0023,0074)	SL	1	Number Of Updates To Header	NumberOfUpdatesToHeader	GEMS_STDY_01	GEM	\N	\N	\N
f	889	\N	(0023,007d)	SS	1	Indicates If Study Has Complete Info	IndicatesIfStudyHasCompleteInfo	GEMS_STDY_01	GEM	\N	\N	\N
f	3825	\N	(0023,0080)	SQ	1	Has MPPS Related Tags	HasMPPSRelatedTags	GEMS_STDY_01	GEM	\N	\N	\N
f	459	\N	(0023,0080)	LO	1	CR Film Format	CRFilmFormat	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	479	\N	(0023,0080)	LO	1	CR Technician Code	CRTechnicianCode	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	489	\N	(0023,0080)	LO	1	CR Film Format	CRFilmFormat	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	509	\N	(0023,0080)	LO	1	CR Technician Code	CRTechnicianCode	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	469	\N	(0023,0080)	US	1	CR RN	CRRN	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	499	\N	(0023,0080)	US	1	CR RN	CRRN	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	470	\N	(0023,0090)	DS	1	CR DRT	CRDRT	GEMS_ACRQA_1.0 BLOCK2	GEM	\N	\N	\N
f	500	\N	(0023,0090)	DS	1	CR DRT	CRDRT	GEMS_ACRQA_2.0 BLOCK2	GEM	\N	\N	\N
f	460	\N	(0023,0090)	LO	1	CR S Shift String	CRSShiftString	GEMS_ACRQA_1.0 BLOCK1	GEM	\N	\N	\N
f	480	\N	(0023,0090)	LO	1	CR Energy Subtraction Parameters	CREnergySubtractionParameters	GEMS_ACRQA_1.0 BLOCK3	GEM	\N	\N	\N
f	490	\N	(0023,0090)	LO	1	CR S Shift String	CRSShiftString	GEMS_ACRQA_2.0 BLOCK1	GEM	\N	\N	\N
f	510	\N	(0023,0090)	LO	1	CR Energy Subtraction Parameters	CREnergySubtractionParameters	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	511	\N	(0023,00f0)	LO	1	CR Distribution Code	CRDistributionCode	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	512	\N	(0023,00ff)	US	1	CR Shutters Applied	CRShuttersApplied	GEMS_ACRQA_2.0 BLOCK3	GEM	\N	\N	\N
f	3826	\N	(0023,0001)	SQ	1	X-Ray Marker Sequence	XRayMarkerSequence	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3827	\N	(0023,0002)	SH	1	Marker ID	MarkerID	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3828	\N	(0023,0003)	CS	1	Marker Type	MarkerType	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3829	\N	(0023,0004)	FL	1	Marker Size	MarkerSize	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3830	\N	(0023,0005)	US	3	Marker Color CIELab Value	MarkerColorCIELabValue	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3831	\N	(0023,0006)	LO	1	Marker Label	MarkerLabel	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3832	\N	(0023,0007)	CS	1	Marker Visible State	MarkerVisibleState	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3833	\N	(0023,0008)	LO	1	Marker Description	MarkerDescription	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3834	\N	(0023,0010)	SQ	1	Marker Points Sequence	MarkerPointsSequence	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3835	\N	(0023,0011)	SH	1	Marker Point ID	MarkerPointID	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3836	\N	(0023,0012)	FL	3	Marker Point Position	MarkerPointPosition	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3837	\N	(0023,0013)	FL	1	Marker Point Size	MarkerPointSize	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3838	\N	(0023,0014)	US	3	Marker Point Color CIELab Value	MarkerPointColorCIELabValue	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3839	\N	(0023,0016)	CS	1	Marker Point Visible State	MarkerPointVisibleState	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3840	\N	(0023,0017)	IS	1	Marker Point Order	MarkerPointOrder	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3841	\N	(0023,0018)	FL	3	Volume Manual Registration	VolumeManualRegistration	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3842	\N	(0023,0020)	IS	1-n	Volumes Threshold	VolumesThreshold	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3843	\N	(0023,0025)	CS	1	Cut Plane Activation Flag	CutPlaneActivationFlag	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3844	\N	(0023,0026)	IS	1	Cut Plane Position Value	CutPlanePositionValue	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3845	\N	(0023,0027)	FL	3	Cut Plane Normal Value	CutPlaneNormalValue	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3846	\N	(0023,0028)	FL	1	Volume Scaling Factor	VolumeScalingFactor	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3847	\N	(0023,0029)	FL	1	ROI to Table Top Distance	ROIToTableTopDistance	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3848	\N	(0023,0030)	IS	1-n	DRR Threshold	DRRThreshold	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3849	\N	(0023,0031)	FL	3	Volume Table Position	VolumeTablePosition	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3850	\N	(0023,0032)	IS	1	Rendering Mode	RenderingMode	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3851	\N	(0023,0033)	IS	1	3D Object Opacity	ThreeDObjectOpacity	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3852	\N	(0023,0034)	IS	1	Invert Image	InvertImage	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3853	\N	(0023,0035)	IS	1	Enhance Full	EnhanceFull	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3854	\N	(0023,0036)	FL	1	Zoom	Zoom	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3855	\N	(0023,0037)	IS	2	Roam	Roam	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3856	\N	(0023,0038)	IS	1	Window Level	WindowLevel	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3857	\N	(0023,0039)	IS	1	Window Width	WindowWidth	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3858	\N	(0023,0040)	CS	1	BMC Setting	BMCSetting	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3859	\N	(0023,0041)	CS	1	Back View Setting	BackViewSetting	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3860	\N	(0023,0042)	CS	1-n	Sub Volume Visibility	SubVolumeVisibility	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3861	\N	(0023,0043)	CS	1	3D Landmarks Visibility	ThreeDLandmarksVisibility	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	3862	\N	(0023,0044)	CS	1	Ablation Point Visibility	AblationPointVisibility	GEMS_3D_INTVL_01	GEM	\N	\N	\N
f	874	\N	(0025,0006)	SS	1	Last Pulse Sequence Used	LastPulseSequenceUsed	GEMS_SERS_01	GEM	\N	\N	\N
f	875	\N	(0025,0007)	SL	1	Images In Series	ImagesInSeries	GEMS_SERS_01	GEM	\N	\N	\N
f	876	\N	(0025,0010)	SL	1	Landmark Counter	LandmarkCounter	GEMS_SERS_01	GEM	\N	\N	\N
f	877	\N	(0025,0011)	SS	1	Number Of Acquisitions	NumberOfAcquisitions	GEMS_SERS_01	GEM	\N	\N	\N
f	878	\N	(0025,0014)	SL	1	Indicates Number Of Updates To Header	IndicatesNumberOfUpdatesToHeader	GEMS_SERS_01	GEM	\N	\N	\N
f	879	\N	(0025,0017)	SL	1	Series Complete Flag	SeriesCompleteFlag	GEMS_SERS_01	GEM	\N	\N	\N
f	880	\N	(0025,0018)	SL	1	Number Of Images Archived	NumberOfImagesArchived	GEMS_SERS_01	GEM	\N	\N	\N
f	881	\N	(0025,0019)	SL	1	Last Instance Number Used	LastInstanceNumberUsed	GEMS_SERS_01	GEM	\N	\N	\N
f	882	\N	(0025,001a)	SH	1	Primary Receiver Suite And Host	PrimaryReceiverSuiteAndHost	GEMS_SERS_01	GEM	\N	\N	\N
f	3863	\N	(0025,001b)	OB	1	Protocol Data Block (compressed)	ProtocolDataBlockCompressed	GEMS_SERS_01	GEM	\N	\N	\N
f	3864	\N	(0025,0002)	IS	1	Frame ID	FrameID	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3865	\N	(0025,0003)	DS	1	Distance Source to Detector	DistanceSourceToDetector	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3866	\N	(0025,0004)	DS	1	Distance Source to Patient	DistanceSourceToPatient	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3867	\N	(0025,0005)	DS	1	Distance Source to Skin	DistanceSourceToSkin	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3868	\N	(0025,0006)	DS	1	Positioner Primary Angle	PositionerPrimaryAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3869	\N	(0025,0007)	DS	1	Positioner Secondary Angle	PositionerSecondaryAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3870	\N	(0025,0008)	IS	1	Beam Orientation	BeamOrientation	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3871	\N	(0025,0009)	DS	1	L Arm Angle	LArmAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3872	\N	(0025,000a)	SQ	1	Frame Sequence	FrameSequence	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3873	\N	(0025,0010)	DS	1	Pivot Angle	PivotAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3874	\N	(0025,001a)	DS	1	Arc Angle	ArcAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3875	\N	(0025,001b)	DS	1	Table Vertical Position	TableVerticalPosition	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3876	\N	(0025,001c)	DS	1	Table Longitudinal Position	TableLongitudinalPosition	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3877	\N	(0025,001d)	DS	1	Table Lateral Position	Table Lateral Position	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3878	\N	(0025,001e)	IS	1	Beam Cover Area	BeamCoverArea	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3879	\N	(0025,001f)	DS	1	kVP Actual	kVPActual	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3880	\N	(0025,0020)	DS	1	mAS Actual	mASActual	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3881	\N	(0025,0021)	DS	1	PW Actual	PWActual	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3882	\N	(0025,0022)	DS	1	Kvp Commanded	KvpCommanded	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3883	\N	(0025,0023)	DS	1	Mas Commanded	MasCommanded	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3884	\N	(0025,0024)	DS	1	Pw Commanded	PwCommanded	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3885	\N	(0025,0025)	CS	1	Grid	Grid	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3886	\N	(0025,0026)	DS	1	Sensor Feedback	SensorFeedback	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3887	\N	(0025,0027)	DS	1	Target Entrance Dose	TargetEntranceDose	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3888	\N	(0025,0028)	DS	1	Cnr Commanded	CnrCommanded	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3889	\N	(0025,0029)	DS	1	Contrast Commanded	ContrastCommanded	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3890	\N	(0025,002a)	DS	1	EPT Actual	EPTActual	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3891	\N	(0025,002b)	IS	1	Spectral Filter Znb	SpectralFilterZnb	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3892	\N	(0025,002c)	DS	1	Spectral Filter Weight	SpectralFilterWeight	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3893	\N	(0025,002d)	DS	1	Spectral Filter Density	SpectralFilterDensity	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3894	\N	(0025,002e)	IS	1	Spectral Filter Thickness	SpectralFilterThickness	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3895	\N	(0025,002f)	IS	1	Spectral Filter Status	SpectralFilterStatus	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3896	\N	(0025,0030)	IS	2	FOV Dimension	FOVDimension	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3897	\N	(0025,0033)	IS	2	FOV Origin	FOVOrigin	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3898	\N	(0025,0034)	IS	1	Collimator Left Vertical Edge	CollimatorLeftVerticalEdge	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3899	\N	(0025,0035)	IS	1	Collimator Right Vertical Edge	CollimatorRightVerticalEdge	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3900	\N	(0025,0036)	IS	1	Collimator Up Horizontal Edge	CollimatorUpHorizontalEdge	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3901	\N	(0025,0037)	IS	1	Collimator Low Horizontal Edge	CollimatorLowHorizontalEdge	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3902	\N	(0025,0038)	IS	1	Vertices Polygonal Collimator	VerticesPolygonalCollimator	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3903	\N	(0025,0039)	IS	1	Contour Filter Distance	ContourFilterDistance	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3904	\N	(0025,003a)	UL	1	Contour Filter Angle	ContourFilterAngle	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3905	\N	(0025,003b)	CS	1	Table Rotation Status	TableRotationStatus	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	3906	\N	(0025,003c)	CS	1	Internal Label Frame	InternalLabelFrame	GEMS_DL_FRAME_01	GEM	\N	\N	\N
f	674	\N	(0027,0006)	SL	1	Image Archive Flag	ImageArchiveFlag	GEMS_IMAG_01	GEM	\N	\N	\N
f	675	\N	(0027,0010)	SS	1	Scout Type	ScoutType	GEMS_IMAG_01	GEM	\N	\N	\N
f	676	\N	(0027,001c)	SL	1	Vma Mamp	VmaMamp	GEMS_IMAG_01	GEM	\N	\N	\N
f	677	\N	(0027,001d)	SS	1	Vma Phase	VmaPhase	GEMS_IMAG_01	GEM	\N	\N	\N
f	678	\N	(0027,001e)	SL	1	Vma Mod	VmaMod	GEMS_IMAG_01	GEM	\N	\N	\N
f	679	\N	(0027,001f)	SL	1	Vma Clip or Noise Index by 10	VmaClipOrNoiseIndexBy10	GEMS_IMAG_01	GEM	\N	\N	\N
f	680	\N	(0027,0020)	SS	1	Smart Scan On Off Flag	SmartScanOnOffFlag	GEMS_IMAG_01	GEM	\N	\N	\N
f	681	\N	(0027,0030)	SH	1	Foreign Image Revision	ForeignImageRevision	GEMS_IMAG_01	GEM	\N	\N	\N
f	682	\N	(0027,0031)	SS	1	Imaging Mode	ImagingMode	GEMS_IMAG_01	GEM	\N	\N	\N
f	683	\N	(0027,0032)	SS	1	Pulse Sequence	PulseSequence	GEMS_IMAG_01	GEM	\N	\N	\N
f	684	\N	(0027,0033)	SL	1	Imaging Options	ImagingOptions	GEMS_IMAG_01	GEM	\N	\N	\N
f	685	\N	(0027,0035)	SS	1	Plane Type	PlaneType	GEMS_IMAG_01	GEM	\N	\N	\N
f	686	\N	(0027,0036)	SL	1	Oblique Plane	ObliquePlane	GEMS_IMAG_01	GEM	\N	\N	\N
f	687	\N	(0027,0040)	SH	1	RAS Letter Of Image Location	RASLetterOfImageLocation	GEMS_IMAG_01	GEM	\N	\N	\N
f	688	\N	(0027,0041)	FL	1	Image Location	ImageLocation	GEMS_IMAG_01	GEM	\N	\N	\N
f	689	\N	(0027,0042)	FL	1	Center R Coord Of Plane Image	CenterRCoordOfPlaneImage	GEMS_IMAG_01	GEM	\N	\N	\N
f	690	\N	(0027,0043)	FL	1	Center A Coord Of Plane Image	CenterACoordOfPlaneImage	GEMS_IMAG_01	GEM	\N	\N	\N
f	691	\N	(0027,0044)	FL	1	Center S Coord Of Plane Image	CenterSCoordOfPlaneImage	GEMS_IMAG_01	GEM	\N	\N	\N
f	692	\N	(0027,0045)	FL	1	Normal R Coord	NormalRCoord	GEMS_IMAG_01	GEM	\N	\N	\N
f	693	\N	(0027,0046)	FL	1	Normal A Coord	NormalACoord	GEMS_IMAG_01	GEM	\N	\N	\N
f	694	\N	(0027,0047)	FL	1	Normal S Coord	NormalSCoord	GEMS_IMAG_01	GEM	\N	\N	\N
f	695	\N	(0027,0048)	FL	1	R Coord Of Top Right Corner	RCoordOfTopRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	696	\N	(0027,0049)	FL	1	A Coord Of Top Right Corner	ACoordOfTopRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	697	\N	(0027,004a)	FL	1	S Coord Of Top Right Corner	SCoordOfTopRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	698	\N	(0027,004b)	FL	1	R Coord Of Bottom Right Corner	RCoordOfBottomRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	699	\N	(0027,004c)	FL	1	A Coord Of Bottom Right Corner	ACoordOfBottomRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	700	\N	(0027,004d)	FL	1	S Coord Of Bottom Right Corner	SCoordOfBottomRightCorner	GEMS_IMAG_01	GEM	\N	\N	\N
f	701	\N	(0027,0050)	FL	1	Table Start Location (Scout)	TableStartLocation	GEMS_IMAG_01	GEM	\N	\N	\N
f	702	\N	(0027,0051)	FL	1	Table End Location (Scout)	TableEndLocation	GEMS_IMAG_01	GEM	\N	\N	\N
f	703	\N	(0027,0052)	SH	1	RAS Letter For Side Of Image	RASLetterForSideOfImage	GEMS_IMAG_01	GEM	\N	\N	\N
f	704	\N	(0027,0053)	SH	1	RAS Letter For Anterior Posterior	RASLetterForAnteriorPosterior	GEMS_IMAG_01	GEM	\N	\N	\N
f	705	\N	(0027,0054)	SH	1	RAS Letter For Scout Start Loc	RASLetterForScoutStartLoc	GEMS_IMAG_01	GEM	\N	\N	\N
f	706	\N	(0027,0055)	SH	1	RAS Letter For Scout End Loc	RASLetterForScoutEndLoc	GEMS_IMAG_01	GEM	\N	\N	\N
f	707	\N	(0027,0060)	FL	1	Image Dimension X	ImageDimensionX	GEMS_IMAG_01	GEM	\N	\N	\N
f	708	\N	(0027,0061)	FL	1	Image Dimension Y	ImageDimensionY	GEMS_IMAG_01	GEM	\N	\N	\N
f	709	\N	(0027,0062)	FL	1	Number Of Excitations	NumberOfExcitations	GEMS_IMAG_01	GEM	\N	\N	\N
f	710	\N	(0029,0004)	SL	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	711	\N	(0029,0005)	DS	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	712	\N	(0029,0006)	DS	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	713	\N	(0029,0007)	SL	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	714	\N	(0029,0008)	SH	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	715	\N	(0029,0009)	SH	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	716	\N	(0029,000a)	SS	1	Lower Range Of Pixels	LowerRangeOfPixels	GEMS_IMPS_01	GEM	\N	\N	\N
f	717	\N	(0029,0015)	SL	1	Lower Range Of Pixels1	LowerRangeOfPixels1	GEMS_IMPS_01	GEM	\N	\N	\N
f	718	\N	(0029,0016)	SL	1	Upper Range Of Pixels1	UpperRangeOfPixels1	GEMS_IMPS_01	GEM	\N	\N	\N
f	719	\N	(0029,0017)	SL	1	Lower Range Of Pixels2	LowerRangeOfPixels2	GEMS_IMPS_01	GEM	\N	\N	\N
f	720	\N	(0029,0018)	SL	1	Upper Range Of Pixels2	UpperRangeOfPixels2	GEMS_IMPS_01	GEM	\N	\N	\N
f	721	\N	(0029,001a)	SL	1	Length Of Total Header In Bytes	LengthOfTotalHeaderInBytes	GEMS_IMPS_01	GEM	\N	\N	\N
f	722	\N	(0029,0026)	SS	1	Version Of Header Structure	VersionOfHeaderStructure	GEMS_IMPS_01	GEM	\N	\N	\N
f	723	\N	(0029,0034)	SL	1	Advantage Comp Overflow	AdvantageCompOverflow	GEMS_IMPS_01	GEM	\N	\N	\N
f	724	\N	(0029,0035)	SL	1	Advantage Comp Underflow	AdvantageCompUnderflow	GEMS_IMPS_01	GEM	\N	\N	\N
f	656	\N	(0033,0001)	UN	1	Unknown	Unknown	GEMS_GNHD_01	GEM	\N	\N	\N
f	570	\N	(0033,0002)	UN	1	Unknown	Unknown	GEMS_CTHD_01	GEM	\N	\N	\N
f	657	\N	(0033,0002)	UN	1	Unknown	Unknown	GEMS_GNHD_01	GEM	\N	\N	\N
f	3907	\N	(0033,0007)	LO	1-n	Original SOP Instance UID	OriginalSOPInstanceUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3908	\N	(0033,0008)	CS	1	eNTEGRA Data Object Type	eNTEGRADataObjectType	GEMS_GENIE_1	GEM	\N	\N	\N
f	3909	\N	(0033,0010)	SL	1	Modified	Modified	GEMS_GENIE_1	GEM	\N	\N	\N
f	3910	\N	(0033,0011)	LO	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	3911	\N	(0033,0016)	LO	1	Protocol Data UID	ProtocolDataUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3912	\N	(0033,0017)	SH	1	Date	Date	GEMS_GENIE_1	GEM	\N	\N	\N
f	3913	\N	(0033,0018)	SH	1	Time	Time	GEMS_GENIE_1	GEM	\N	\N	\N
f	3914	\N	(0033,0019)	UL	1	Protocol Data Flags	ProtocolDataFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	3915	\N	(0033,001a)	UL	1	Protocol Name	ProtocolName	GEMS_GENIE_1	GEM	\N	\N	\N
f	3916	\N	(0033,001b)	LO	1	Relevant Data UID	RelevantDataUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	3917	\N	(0033,001c)	LO	1	Bulk Data	BulkData	GEMS_GENIE_1	GEM	\N	\N	\N
f	3918	\N	(0033,001d)	SL	1-n	Int Data	IntData	GEMS_GENIE_1	GEM	\N	\N	\N
f	3919	\N	(0033,001e)	FD	1-n	Double Data	DoubleData	GEMS_GENIE_1	GEM	\N	\N	\N
f	3920	\N	(0033,001f)	OB	1	String Data	StringData	GEMS_GENIE_1	GEM	\N	\N	\N
f	3921	\N	(0033,0020)	LT	1-n	Bulk Data Format	BulkDataFormat	GEMS_GENIE_1	GEM	\N	\N	\N
f	3922	\N	(0033,0021)	LT	1-n	Int Data Format	IntDataFormat	GEMS_GENIE_1	GEM	\N	\N	\N
f	3923	\N	(0033,0022)	LT	1-n	Double Data Format	DoubleDataFormat	GEMS_GENIE_1	GEM	\N	\N	\N
f	3924	\N	(0033,0023)	LT	1-n	String Data Format	StringDataFormat	GEMS_GENIE_1	GEM	\N	\N	\N
f	3925	\N	(0033,0024)	LT	1	Description	Description	GEMS_GENIE_1	GEM	\N	\N	\N
f	3926	\N	(0033,0030)	UL	1	Allocate Trigger Buffer	AllocateTriggerBuffer	GEMS_GENIE_1	GEM	\N	\N	\N
f	3927	\N	(0033,0033)	UL	1	Number of Triggers	NumberOfTriggers	GEMS_GENIE_1	GEM	\N	\N	\N
f	3928	\N	(0033,0034)	UL	1	Trigger Size	TriggerSize	GEMS_GENIE_1	GEM	\N	\N	\N
f	3929	\N	(0033,0035)	UL	1	Trigger Data Size	TriggerDataSize	GEMS_GENIE_1	GEM	\N	\N	\N
f	3930	\N	(0033,0036)	OB	1	Trigger Data	TriggerData	GEMS_GENIE_1	GEM	\N	\N	\N
f	3931	\N	(0035,0001)	FD	1-n	Start Angle	StartAngle	GEMS_GENIE_1	GEM	\N	\N	\N
f	571	\N	(0037,0010)	LO	1	ReferringDepartment	ReferringDepartment	GEMS_DRS_1	GEM	\N	\N	\N
f	572	\N	(0037,0020)	US	1	ScreenNumber	ScreenNumber	GEMS_DRS_1	GEM	\N	\N	\N
f	573	\N	(0037,0040)	SH	1	LeftOrientation	LeftOrientation	GEMS_DRS_1	GEM	\N	\N	\N
f	574	\N	(0037,0042)	SH	1	RightOrientation	RightOrientation	GEMS_DRS_1	GEM	\N	\N	\N
f	575	\N	(0037,0050)	CS	1	Inversion	Inversion	GEMS_DRS_1	GEM	\N	\N	\N
f	576	\N	(0037,0060)	US	1	DSA	DSA	GEMS_DRS_1	GEM	\N	\N	\N
f	565	\N	(0039,0080)	IS	1	Private Entity Number	PrivateEntityNumber	GEMS_ADWSoft_DPO	GEM	\N	\N	\N
f	566	\N	(0039,0085)	DA	1	Private Entity Date	PrivateEntityDate	GEMS_ADWSoft_DPO	GEM	\N	\N	\N
f	567	\N	(0039,0090)	TM	1	Private Entity Time	PrivateEntityTime	GEMS_ADWSoft_DPO	GEM	\N	\N	\N
f	568	\N	(0039,0095)	LO	1	Private Entity Launch Command	PrivateEntityLaunchCommand	GEMS_ADWSoft_DPO	GEM	\N	\N	\N
f	3932	\N	(0039,00aa)	CS	1	Private Entity Type	PrivateEntityType	GEMS_ADWSoft_DPO	GEM	\N	\N	\N
f	3933	\N	(0039,0095)	LO	1	Unknown	Unknown	GEMS_ADWSoft_DPO1	GEM	\N	\N	\N
f	3934	\N	(0039,0050)	UI	1	Reference to Study UID	ReferenceToStudyUID	GEMS_AWSoft_SB1	GEM	\N	\N	\N
f	3935	\N	(0039,0051)	UI	1	Reference to Series UID	ReferenceToSeriesUID	GEMS_AWSoft_SB1	GEM	\N	\N	\N
f	3936	\N	(0039,0052)	IS	1	Reference to Original Instance Number	ReferenceToOriginalInstance	GEMS_AWSoft_SB1	GEM	\N	\N	\N
f	3937	\N	(0039,0095)	LO	1	Private Entity Launch Command	PrivateEntityLaunchCommand	GEMS_AWSoft_SB1	GEM	\N	\N	\N
f	3938	\N	(0039,0065)	UI	1	Reference to Study UID	ReferenceToStudyUID	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3939	\N	(0039,0070)	UI	1	Reference to Series UID	ReferenceToSeriesUID	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3940	\N	(0039,0075)	IS	1	Reference to Original Instance Number	ReferenceToOriginalInstance	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3941	\N	(0039,0080)	IS	1	DPO Number	DPONumber	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3942	\N	(0039,0085)	DA	1	DPO Date	DPODate	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3943	\N	(0039,0090)	TM	1	DPO Time	DPOTime	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3944	\N	(0039,0095)	LO	1	DPO Invocation String	DPOInvocationString	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3945	\N	(0039,00aa)	CS	1	DPO Type	DPOType	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	3946	\N	(0039,00ff)	OB	1	DPO Data	DPOData	GEMS_AWSOFT_CD1	GEM	\N	\N	\N
f	725	\N	(0043,0001)	SS	1	Bitmap Of Prescan Options	BitmapOfPrescanOptions	GEMS_PARM_01	GEM	\N	\N	\N
f	726	\N	(0043,0002)	SS	1	Gradient Offset In X	GradientOffsetInX	GEMS_PARM_01	GEM	\N	\N	\N
f	727	\N	(0043,0003)	SS	1	Gradient Offset In Y	GradientOffsetInY	GEMS_PARM_01	GEM	\N	\N	\N
f	728	\N	(0043,0004)	SS	1	Gradient Offset In Z	GradientOffsetInZ	GEMS_PARM_01	GEM	\N	\N	\N
f	729	\N	(0043,0005)	SS	1	Image Is Original Or Unoriginal	ImageIsOriginalOrUnoriginal	GEMS_PARM_01	GEM	\N	\N	\N
f	730	\N	(0043,0006)	SS	1	Number Of EPI Shots	NumberOfEPIShots	GEMS_PARM_01	GEM	\N	\N	\N
f	731	\N	(0043,0007)	SS	1	Views Per Segment	ViewsPerSegment	GEMS_PARM_01	GEM	\N	\N	\N
f	732	\N	(0043,0008)	SS	1	Respiratory Rate In BPM	RespiratoryRateInBPM	GEMS_PARM_01	GEM	\N	\N	\N
f	733	\N	(0043,0009)	SS	1	Respiratory Trigger Point	RespiratoryTriggerPoint	GEMS_PARM_01	GEM	\N	\N	\N
f	734	\N	(0043,000a)	SS	1	Type Of Receiver Used	TypeOfReceiverUsed	GEMS_PARM_01	GEM	\N	\N	\N
f	735	\N	(0043,000b)	DS	1	dB/dt Peak Rate Of Change Of Gradient Field	PeakRateOfChangeOfGradientField	GEMS_PARM_01	GEM	\N	\N	\N
f	736	\N	(0043,000c)	DS	1	dB/dt Limits In Units Of Percent	LimitsInUnitsOfPercent	GEMS_PARM_01	GEM	\N	\N	\N
f	737	\N	(0043,000d)	DS	1	PSD Estimated Limit	PSDEstimatedLimit	GEMS_PARM_01	GEM	\N	\N	\N
f	738	\N	(0043,000e)	DS	1	PSD Estimated Limit In Tesla Per Second	PSDEstimatedLimitInTeslaPerSecond	GEMS_PARM_01	GEM	\N	\N	\N
f	739	\N	(0043,000f)	DS	1	SAR Avg Head	SARAvgHead	GEMS_PARM_01	GEM	\N	\N	\N
f	740	\N	(0043,0010)	US	1	Window Value	WindowValue	GEMS_PARM_01	GEM	\N	\N	\N
f	741	\N	(0043,0011)	US	1	Total Input Views	TotalInputViews	GEMS_PARM_01	GEM	\N	\N	\N
f	742	\N	(0043,0012)	SS	3	Xray Chain	XrayChain	GEMS_PARM_01	GEM	\N	\N	\N
f	743	\N	(0043,0013)	SS	5	Recon Kernel Parameters	ReconKernelParameters	GEMS_PARM_01	GEM	\N	\N	\N
f	744	\N	(0043,0014)	SS	3	Calibration Parameters	CalibrationParameters	GEMS_PARM_01	GEM	\N	\N	\N
f	745	\N	(0043,0015)	SS	3	Total Output Views	TotalOutputViews	GEMS_PARM_01	GEM	\N	\N	\N
f	746	\N	(0043,0016)	SS	5	Number Of Overranges	NumberOfOverranges	GEMS_PARM_01	GEM	\N	\N	\N
f	747	\N	(0043,0017)	DS	1	IBH Image Scale Factors	IBHImageScaleFactors	GEMS_PARM_01	GEM	\N	\N	\N
f	748	\N	(0043,0018)	DS	3	BBH Coefficients	BBH Coefficients	GEMS_PARM_01	GEM	\N	\N	\N
f	749	\N	(0043,0019)	SS	1	Number Of BBH Chains To Blend	NumberOfBBHChainsToBlend	GEMS_PARM_01	GEM	\N	\N	\N
f	750	\N	(0043,001a)	SL	1	Starting Channel Number	StartingChannelNumber	GEMS_PARM_01	GEM	\N	\N	\N
f	751	\N	(0043,001b)	SS	1	PPScan Parameters	PPScanParameters	GEMS_PARM_01	GEM	\N	\N	\N
f	752	\N	(0043,001c)	SS	1	GE Image Integrity	GEImageIntegrity	GEMS_PARM_01	GEM	\N	\N	\N
f	753	\N	(0043,001d)	SS	1	Level Value	LevelValue	GEMS_PARM_01	GEM	\N	\N	\N
f	754	\N	(0043,001e)	DS	1	Delta Start Time	DeltaStartTime	GEMS_PARM_01	GEM	\N	\N	\N
f	905	\N	(0043,001e)	DS	1	Delta Start Time	DeltaStartTime	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	755	\N	(0043,001f)	SL	1	Max Overranges In A View	MaxOverrangesInAView	GEMS_PARM_01	GEM	\N	\N	\N
f	756	\N	(0043,0020)	DS	1	Avg Overranges All Views	AvgOverrangesAllViews	GEMS_PARM_01	GEM	\N	\N	\N
f	757	\N	(0043,0021)	SS	1	Corrected Afterglow Terms	CorrectedAfterglowTerms	GEMS_PARM_01	GEM	\N	\N	\N
f	758	\N	(0043,0025)	SS	6	Reference Channels	ReferenceChannels	GEMS_PARM_01	GEM	\N	\N	\N
f	759	\N	(0043,0026)	US	6	No Views Ref Channels Blocked	NoViewsRefChannelsBlocked	GEMS_PARM_01	GEM	\N	\N	\N
f	760	\N	(0043,0027)	SH	1	Scan Pitch Ratio	ScanPitchRatio	GEMS_PARM_01	GEM	\N	\N	\N
f	906	\N	(0043,0027)	SH	1	Scan Pitch Ratio	ScanPitchRatio	GE_GENESIS_REV3.0	GEM	\N	\N	\N
f	761	\N	(0043,0028)	OB	1	Unique Image Identifier	UniqueImageIdentifier	GEMS_PARM_01	GEM	\N	\N	\N
f	762	\N	(0043,0029)	OB	1	Histogram Tables	HistogramTables	GEMS_PARM_01	GEM	\N	\N	\N
f	763	\N	(0043,002a)	OB	1	User Defined Data	UserDefinedData	GEMS_PARM_01	GEM	\N	\N	\N
f	764	\N	(0043,002b)	SS	4	Private Scan Options	PrivateScanOptions	GEMS_PARM_01	GEM	\N	\N	\N
f	765	\N	(0043,002c)	SS	1	Effective Echo Spacing	EffectiveEchoSpacing	GEMS_PARM_01	GEM	\N	\N	\N
f	766	\N	(0043,002d)	SH	1	Filter Mode	FilterMode	GEMS_PARM_01	GEM	\N	\N	\N
f	767	\N	(0043,002e)	SH	1	String Slop Field 2	StringSlopField2	GEMS_PARM_01	GEM	\N	\N	\N
f	768	\N	(0043,002f)	SS	1	Image Type (Real,Imaginary,Phase,Magnitude)	ImageType	GEMS_PARM_01	GEM	\N	\N	\N
f	769	\N	(0043,0030)	SS	1	Vas Collapse Flag	VasCollapseFlag	GEMS_PARM_01	GEM	\N	\N	\N
f	770	\N	(0043,0031)	DS	2	Recon Center Coordinates	ReconCenterCoordinates	GEMS_PARM_01	GEM	\N	\N	\N
f	771	\N	(0043,0032)	SS	1	Vas Flags	VasFlags	GEMS_PARM_01	GEM	\N	\N	\N
f	772	\N	(0043,0033)	FL	1	Neg Scan Spacing	NegScanSpacing	GEMS_PARM_01	GEM	\N	\N	\N
f	773	\N	(0043,0034)	IS	1	Offset Frequency	OffsetFrequency	GEMS_PARM_01	GEM	\N	\N	\N
f	774	\N	(0043,0035)	UL	1	User Usage Tag	UserUsageTag	GEMS_PARM_01	GEM	\N	\N	\N
f	775	\N	(0043,0036)	UL	1	User Fill Map MSW	UserFillMapMSW	GEMS_PARM_01	GEM	\N	\N	\N
f	776	\N	(0043,0037)	UL	1	User Fill Map LSW	UserFillMapLSW	GEMS_PARM_01	GEM	\N	\N	\N
f	777	\N	(0043,0038)	FL	24	User 25 To User 48	User25ToUser48	GEMS_PARM_01	GEM	\N	\N	\N
f	778	\N	(0043,0039)	IS	4	Slop Integer 6 To Slop Integer 9	SlopInteger6ToSlopInteger9	GEMS_PARM_01	GEM	\N	\N	\N
f	779	\N	(0043,0040)	FL	4	Trigger On Position	TriggerOnPosition	GEMS_PARM_01	GEM	\N	\N	\N
f	780	\N	(0043,0041)	FL	4	Degree Of Rotation	DegreeOfRotation	GEMS_PARM_01	GEM	\N	\N	\N
f	781	\N	(0043,0042)	SL	4	DAS Trigger Source	DASTriggerSource	GEMS_PARM_01	GEM	\N	\N	\N
f	782	\N	(0043,0043)	SL	4	DAS Fpa Gain	DASFpaGain	GEMS_PARM_01	GEM	\N	\N	\N
f	783	\N	(0043,0044)	SL	4	DAS Output Source	DASOutputSource	GEMS_PARM_01	GEM	\N	\N	\N
f	784	\N	(0043,0045)	SL	4	DAS Ad Input	DASAdInput	GEMS_PARM_01	GEM	\N	\N	\N
f	785	\N	(0043,0046)	SL	4	DAS Cal Mode	DASCalMode	GEMS_PARM_01	GEM	\N	\N	\N
f	786	\N	(0043,0047)	SL	4	DAS Cal Frequency	DASCalFrequency	GEMS_PARM_01	GEM	\N	\N	\N
f	787	\N	(0043,0048)	SL	4	DAS Reg Xm	DASRegXm	GEMS_PARM_01	GEM	\N	\N	\N
f	788	\N	(0043,0049)	SL	4	DAS Auto Zero	DASAutoZero	GEMS_PARM_01	GEM	\N	\N	\N
f	789	\N	(0043,004a)	SS	4	Starting Channel Of View	StartingChannelOfView	GEMS_PARM_01	GEM	\N	\N	\N
f	790	\N	(0043,004b)	SL	4	DAS Xm Pattern	DASXmPattern	GEMS_PARM_01	GEM	\N	\N	\N
f	791	\N	(0043,004c)	SS	4	TGGC Trigger Mode	TGGCTriggerMode	GEMS_PARM_01	GEM	\N	\N	\N
f	792	\N	(0043,004d)	FL	4	Start Scan To Xray On Delay	StartScanToXrayOnDelay	GEMS_PARM_01	GEM	\N	\N	\N
f	793	\N	(0043,004e)	FL	4	Duration Of Xray On	DurationOfXrayOn	GEMS_PARM_01	GEM	\N	\N	\N
f	794	\N	(0043,0060)	IS	8	Slop Integer 10 To Slop Integer 17	SlopInteger10ToSlopInteger17	GEMS_PARM_01	GEM	\N	\N	\N
f	795	\N	(0043,0061)	UI	1	Scanner Study Entity UID	ScannerStudyEntityUID	GEMS_PARM_01	GEM	\N	\N	\N
f	796	\N	(0043,0062)	SH	1	Scanner Study ID	ScannerStudyID	GEMS_PARM_01	GEM	\N	\N	\N
f	3947	\N	(0043,0063)	SH	1	Raw Data ID	RawDataID	GEMS_PARM_01	GEM	\N	\N	\N
f	3948	\N	(0043,0064)	CS	1-n	Image Filter	ImageFilter	GEMS_PARM_01	GEM	\N	\N	\N
f	3949	\N	(0043,0065)	US	1	Motion Correction Indicator	MotionCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3950	\N	(0043,0066)	US	1	Helical Correction Indicator	HelicalCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3951	\N	(0043,0067)	US	1	IBO Correction Indicator	IBOCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3952	\N	(0043,0068)	US	1	XT Correction Indicator	IXTCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3953	\N	(0043,0069)	US	1	Q-cal Correction Indicator	QcalCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3954	\N	(0043,006a)	US	1	AV Correction Indicator	AVCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3955	\N	(0043,006b)	US	1	L-MDK Correction Indicator	LMDKCorrectionIndicator	GEMS_PARM_01	GEM	\N	\N	\N
f	3956	\N	(0043,006c)	IS	1	Detector Row	DetectorRow	GEMS_PARM_01	GEM	\N	\N	\N
f	3957	\N	(0043,006d)	US	1	Area Size	AreaSize	GEMS_PARM_01	GEM	\N	\N	\N
f	3958	\N	(0043,006e)	SH	1	Auto mA Mode	AutoMAMode	GEMS_PARM_01	GEM	\N	\N	\N
f	797	\N	(0043,006f)	DS	3-4	Scanner Table Entry + Gradient Coil Selected	ScannerTableEntry	GEMS_PARM_01	GEM	\N	\N	\N
f	3959	\N	(0043,0070)	LO	1	Paradigm Name	ParadigmName	GEMS_PARM_01	GEM	\N	\N	\N
f	3960	\N	(0043,0071)	ST	1	Paradigm Description	ParadigmDescription	GEMS_PARM_01	GEM	\N	\N	\N
f	3961	\N	(0043,0072)	UI	1	Paradigm UID	ParadigmUID	GEMS_PARM_01	GEM	\N	\N	\N
f	3962	\N	(0043,0073)	US	1	Experiment Type	ExperimentType	GEMS_PARM_01	GEM	\N	\N	\N
f	3963	\N	(0043,0074)	US	1	Number of Rest Volumes	NumberOfRestVolumes	GEMS_PARM_01	GEM	\N	\N	\N
f	3964	\N	(0043,0075)	US	1	Number of Active Volumes	NumberOfActiveVolumes	GEMS_PARM_01	GEM	\N	\N	\N
f	3965	\N	(0043,0076)	US	1	Number of Dummy Scans	NumberOfDummyScans	GEMS_PARM_01	GEM	\N	\N	\N
f	3966	\N	(0043,0077)	SH	1	Application Name	ApplicationName	GEMS_PARM_01	GEM	\N	\N	\N
f	3967	\N	(0043,0078)	SH	1	Application Version	ApplicationVersion	GEMS_PARM_01	GEM	\N	\N	\N
f	3968	\N	(0043,0079)	US	1	Slices Per Volume	SlicesPerVolume	GEMS_PARM_01	GEM	\N	\N	\N
f	3969	\N	(0043,007a)	US	1	Expected Time Points	ExpectedTimePoints	GEMS_PARM_01	GEM	\N	\N	\N
f	3970	\N	(0043,007b)	FL	1-n	Regressor Values	RegressorValues	GEMS_PARM_01	GEM	\N	\N	\N
f	3971	\N	(0043,007c)	FL	1	Delay After Slice Group	DelayAfterSliceGroup	GEMS_PARM_01	GEM	\N	\N	\N
f	3972	\N	(0043,007d)	US	1	Recon Mode Flag Word	ReconModeFlagWord	GEMS_PARM_01	GEM	\N	\N	\N
f	3973	\N	(0043,007e)	LO	1-n	PACC Specific Information	PACCSpecificInformation	GEMS_PARM_01	GEM	\N	\N	\N
f	3974	\N	(0043,007f)	DS	1-n	Reserved	Reserved	GEMS_PARM_01	GEM	\N	\N	\N
f	3975	\N	(0043,0080)	LO	1-n	Coil ID Data	CoilIDData	GEMS_PARM_01	GEM	\N	\N	\N
f	3976	\N	(0043,0081)	LO	1	GE Coil Name	GECoilName	GEMS_PARM_01	GEM	\N	\N	\N
f	3977	\N	(0043,0082)	LO	1-n	System Configuration Information	SystemConfigurationInformation	GEMS_PARM_01	GEM	\N	\N	\N
f	3978	\N	(0043,0083)	DS	1-2	Asset R Factors	AssetRFactors	GEMS_PARM_01	GEM	\N	\N	\N
f	3979	\N	(0043,0084)	LO	5	Additional Asset Data	AdditionalAssetData	GEMS_PARM_01	GEM	\N	\N	\N
f	3980	\N	(0043,0085)	UT	1	Debug Data (Text Format)	DebugDataTextFormat	GEMS_PARM_01	GEM	\N	\N	\N
f	3981	\N	(0043,0086)	OB	1	Debug Data (Binary Format)	DebugDataBinaryFormat	GEMS_PARM_01	GEM	\N	\N	\N
f	3982	\N	(0043,0087)	UT	1	Reserved	Reserved	GEMS_PARM_01	GEM	\N	\N	\N
f	3983	\N	(0043,0088)	UI	1	PURE Acquisition Calibration Series UID	PUREAcquisitionCalibrationSeriesUID	GEMS_PARM_01	GEM	\N	\N	\N
f	3984	\N	(0043,0089)	LO	3	Governing Body, dB/dt, and SAR definition	GoverningBodyDBdtSARDefinition	GEMS_PARM_01	GEM	\N	\N	\N
f	3985	\N	(0043,008a)	CS	1	Private In-Plane Phase Encoding Direction	PrivateInPlanePhaseEncodingDirection	GEMS_PARM_01	GEM	\N	\N	\N
f	3986	\N	(0043,008b)	OB	1	FMRI Binary Data Block	FMRIBinaryDataBlock	GEMS_PARM_01	GEM	\N	\N	\N
f	3987	\N	(0043,008c)	DS	1	Voxel Location	VoxelLocation	GEMS_PARM_01	GEM	\N	\N	\N
f	3988	\N	(0043,008d)	DS	1-n	SAT Band Locations	SATBandLocations	GEMS_PARM_01	GEM	\N	\N	\N
f	3989	\N	(0043,008e)	DS	3	Spectro Prescan Values	SpectroPrescanValues	GEMS_PARM_01	GEM	\N	\N	\N
f	3990	\N	(0043,008f)	DS	3	Spectro Parameters	SpectroParameters	GEMS_PARM_01	GEM	\N	\N	\N
f	3991	\N	(0043,0090)	LO	1-n	SAR Definition	SARDefinition	GEMS_PARM_01	GEM	\N	\N	\N
f	3992	\N	(0043,0091)	DS	1-n	SAR Value	SARValue	GEMS_PARM_01	GEM	\N	\N	\N
f	3993	\N	(0043,0092)	LO	1	Image Error Text	ImageErrorText	GEMS_PARM_01	GEM	\N	\N	\N
f	3994	\N	(0043,0093)	DS	1-n	Spectro Quantitation Values	SpectroQuantitationValues	GEMS_PARM_01	GEM	\N	\N	\N
f	3995	\N	(0043,0094)	DS	1-n	Spectro Ratio Values	SpectroRatioValues	GEMS_PARM_01	GEM	\N	\N	\N
f	3996	\N	(0043,0095)	LO	1	Prescan Reuse String	PrescanReuseString	GEMS_PARM_01	GEM	\N	\N	\N
f	3997	\N	(0043,0096)	CS	1	Content Qualification	ContentQualification	GEMS_PARM_01	GEM	\N	\N	\N
f	3998	\N	(0043,0097)	LO	8	Image Filtering Parameters	ImageFilteringParameters	GEMS_PARM_01	GEM	\N	\N	\N
f	3999	\N	(0043,0098)	UI	1	ASSET Acquisition Calibration Series UID	ASSETAcquisitionCalibrationSeriesUID	GEMS_PARM_01	GEM	\N	\N	\N
f	4000	\N	(0043,0099)	LO	1-n	Extended Options	ExtendedOptions	GEMS_PARM_01	GEM	\N	\N	\N
f	4001	\N	(0043,009a)	IS	1	Rx Stack Identification	RxStackIdentification	GEMS_PARM_01	GEM	\N	\N	\N
f	839	\N	(0045,0004)	CS	1	AES	AES	GEMS_SENO_02	GEM	\N	\N	\N
f	840	\N	(0045,0006)	DS	1	Angulation	Angulation	GEMS_SENO_02	GEM	\N	\N	\N
f	841	\N	(0045,0009)	DS	1	Real Magnification Factor	RealMagnificationFactor	GEMS_SENO_02	GEM	\N	\N	\N
f	842	\N	(0045,000b)	CS	1	Senograph Type	SenographType	GEMS_SENO_02	GEM	\N	\N	\N
f	843	\N	(0045,000c)	DS	1	Integration Time	IntegrationTime	GEMS_SENO_02	GEM	\N	\N	\N
f	844	\N	(0045,000d)	DS	1	ROI Origin X and Y	ROIOriginXY	GEMS_SENO_02	GEM	\N	\N	\N
f	845	\N	(0045,0011)	DS	2	Receptor Size cm X and Y	ReceptorSizeCmXY	GEMS_SENO_02	GEM	\N	\N	\N
f	846	\N	(0045,0012)	IS	2	Receptor Size Pixels X and Y	ReceptorSizePixelsXY	GEMS_SENO_02	GEM	\N	\N	\N
f	847	\N	(0045,0013)	ST	1	Screen	Screen	GEMS_SENO_02	GEM	\N	\N	\N
f	848	\N	(0045,0014)	DS	1	Pixel Pitch Microns	PixelPitchMicrons	GEMS_SENO_02	GEM	\N	\N	\N
f	849	\N	(0045,0015)	IS	1	Pixel Depth Bits	PixelDepthBits	GEMS_SENO_02	GEM	\N	\N	\N
f	850	\N	(0045,0016)	IS	2	Binning Factor X and Y	BinningFactorXY	GEMS_SENO_02	GEM	\N	\N	\N
f	4002	\N	(0045,001b)	LO	1	Clinical View	ClinicalView	GEMS_SENO_02	GEM	\N	\N	\N
f	4003	\N	(0045,001d)	DS	1	Mean Of Raw Gray Levels	MeanOfRawGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	4004	\N	(0045,001e)	DS	1	Mean Of Offset Gray Levels	MeanOfOffsetGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	4005	\N	(0045,001f)	DS	1	Mean Of Corrected Gray Levels	MeanOfCorrectedGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	855	\N	(0045,0020)	DS	1	Mean Of Region Gray Levels	MeanOfRegionGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	856	\N	(0045,0021)	DS	1	Mean Of Log Region Gray Levels	MeanOfLogRegionGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	857	\N	(0045,0022)	DS	1	Standard Deviation Of Raw Gray Levels	StandardDeviationOfRawGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	858	\N	(0045,0023)	DS	1	Standard Deviation Of Corrected Gray Levels	StandardDeviationOfCorrectedGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	859	\N	(0045,0024)	DS	1	Standard Deviation Of Region Gray Levels	StandardDeviationOfRegionGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	860	\N	(0045,0025)	DS	1	Standard Deviation Of Log Region Gray Levels	StandardDeviationOfLogRegionGrayLevels	GEMS_SENO_02	GEM	\N	\N	\N
f	861	\N	(0045,0026)	OB	1	MAO Buffer	MAOBuffer	GEMS_SENO_02	GEM	\N	\N	\N
f	862	\N	(0045,0027)	IS	1	Set Number	SetNumber	GEMS_SENO_02	GEM	\N	\N	\N
f	863	\N	(0045,0028)	CS	1	WindowingType (LINEAR or GAMMA)	WindowingType	GEMS_SENO_02	GEM	\N	\N	\N
f	864	\N	(0045,0029)	DS	1-n	WindowingParameters	WindowingParameters	GEMS_SENO_02	GEM	\N	\N	\N
f	865	\N	(0045,002a)	IS	1	Crosshair Cursor X Coordinates	CrosshairCursorXCoordinates	GEMS_SENO_02	GEM	\N	\N	\N
f	866	\N	(0045,002b)	IS	1	Crosshair Cursor Y Coordinates	CrosshairCursorYCoordinates	GEMS_SENO_02	GEM	\N	\N	\N
f	867	\N	(0045,0039)	US	1	Vignette Rows	VignetteRows	GEMS_SENO_02	GEM	\N	\N	\N
f	868	\N	(0045,003a)	US	1	Vignette Columns	VignetteColumns	GEMS_SENO_02	GEM	\N	\N	\N
f	869	\N	(0045,003b)	US	1	Vignette Bits Allocated	VignetteBitsAllocated	GEMS_SENO_02	GEM	\N	\N	\N
f	870	\N	(0045,003c)	US	1	Vignette Bits Stored	VignetteBitsStored	GEMS_SENO_02	GEM	\N	\N	\N
f	871	\N	(0045,003d)	US	1	Vignette High Bit	VignetteHighBit	GEMS_SENO_02	GEM	\N	\N	\N
f	872	\N	(0045,003e)	US	1	Vignette Pixel Representation	VignettePixelRepresentation	GEMS_SENO_02	GEM	\N	\N	\N
f	873	\N	(0045,003f)	OB	1	Vignette Pixel Data	VignettePixelData	GEMS_SENO_02	GEM	\N	\N	\N
f	4006	\N	(0045,0049)	DS	1	Radiological Thickness	RadiologicalThickness	GEMS_SENO_02	GEM	\N	\N	\N
f	4007	\N	(0045,0050)	UI	1	Fallback Instance UID (CR or SC)	FallbackInstanceUID	GEMS_SENO_02	GEM	\N	\N	\N
f	4008	\N	(0045,0051)	UI	1	Fallback Series UID (CR or SC)	FallbackSeriesUID	GEMS_SENO_02	GEM	\N	\N	\N
f	4009	\N	(0045,0052)	IS	1	Raw Diagnostic Low	RawDiagnosticLow	GEMS_SENO_02	GEM	\N	\N	\N
f	4010	\N	(0045,0053)	IS	1	Raw Diagnostic High	RawDiagnosticHigh	GEMS_SENO_02	GEM	\N	\N	\N
f	4011	\N	(0045,0054)	DS	1	Exponent	Exponent	GEMS_SENO_02	GEM	\N	\N	\N
f	4012	\N	(0045,0055)	IS	1	A Coefficients	ACoefficients	GEMS_SENO_02	GEM	\N	\N	\N
f	4013	\N	(0045,0056)	DS	1	Noise Reduction Sensitivity	NoiseReductionSensitivity	GEMS_SENO_02	GEM	\N	\N	\N
f	4014	\N	(0045,0057)	DS	1	Noise Reduction Threshold	NoiseReductionThreshold	GEMS_SENO_02	GEM	\N	\N	\N
f	4015	\N	(0045,0058)	DS	1	Mu	Mu	GEMS_SENO_02	GEM	\N	\N	\N
f	4016	\N	(0045,0059)	IS	1	Threshold	Threshold	GEMS_SENO_02	GEM	\N	\N	\N
f	4017	\N	(0045,0060)	IS	4	Breast ROI X	BreastROIX	GEMS_SENO_02	GEM	\N	\N	\N
f	4018	\N	(0045,0061)	IS	4	Breast ROI Y	BreastROIY	GEMS_SENO_02	GEM	\N	\N	\N
f	4019	\N	(0045,0062)	IS	1	User Window Center	UserWindowCenter	GEMS_SENO_02	GEM	\N	\N	\N
f	4020	\N	(0045,0063)	IS	1	User Window Width	UserWindowWidth	GEMS_SENO_02	GEM	\N	\N	\N
f	4021	\N	(0045,0064)	IS	1	Segmentation Threshold	SegmentationThreshold	GEMS_SENO_02	GEM	\N	\N	\N
f	4022	\N	(0045,0065)	IS	1	Detector Entrance Dose	DetectorEntranceDose	GEMS_SENO_02	GEM	\N	\N	\N
f	4023	\N	(0045,0066)	IS	1	Asymmetrical Collimation Information	AsymmetricalCollimationInformation	GEMS_SENO_02	GEM	\N	\N	\N
f	4024	\N	(0045,0071)	OB	1	STX Buffer	STXBuffer	GEMS_SENO_02	GEM	\N	\N	\N
f	4025	\N	(0045,0072)	DS	2	Image Crop Point	ImageCropPoint	GEMS_SENO_02	GEM	\N	\N	\N
f	4026	\N	(0045,0090)	SH	1	Premium View Beta	PremiumViewBeta	GEMS_SENO_02	GEM	\N	\N	\N
f	4027	\N	(0045,00a0)	DS	1	Signal Average Factor	SignalAverageFactor	GEMS_SENO_02	GEM	\N	\N	\N
f	4028	\N	(0045,00a1)	DS	2-n	Organ Dose for Source Images	OrganDoseForSourceImages	GEMS_SENO_02	GEM	\N	\N	\N
f	4029	\N	(0045,00a2)	DS	2-n	Entrance dose in mGy for Source Images	EntranceDoseInmGyForSourceImages	GEMS_SENO_02	GEM	\N	\N	\N
f	4030	\N	(0045,00a4)	DS	1	Organ Dose in dGy for Complete DBT Sequence	OrganDoseIndGyForCompleteDBTSequence	GEMS_SENO_02	GEM	\N	\N	\N
f	4031	\N	(0045,00a6)	UI	1	SOP Instance UID for Lossy Compression	SOPInstanceUIDForLossyCompression	GEMS_SENO_02	GEM	\N	\N	\N
f	4032	\N	(0045,00a7)	LT	1	Reconstruction Parameters	ReconstructionParameters	GEMS_SENO_02	GEM	\N	\N	\N
f	4033	\N	(0045,00a8)	DS	1	Entrance Dose in dGy for Complete DBT Sequence	EntranceDoseIndGyForCompleteDBTSequence	GEMS_SENO_02	GEM	\N	\N	\N
f	4034	\N	(0045,0001)	SS	1	Number of Macro Rows in Detector	NumberOfMacroRowsInDetector	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4035	\N	(0045,0002)	FL	1	Macro width at ISO Center	MacroWidthAtISOCenter	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4036	\N	(0045,0003)	SS	1	DAS type	DASType	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4037	\N	(0045,0004)	SS	1	DAS gain	DASGain	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4038	\N	(0045,0005)	SS	1	DAS Temprature	DASTemprature	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4039	\N	(0045,0006)	CS	1	Table Direction	TableDirection	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4040	\N	(0045,0007)	FL	1	Z smoothing Factor	ZSmoothingFactor	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4041	\N	(0045,0008)	SS	1	View Weighting Mode	ViewWeightingMode	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4042	\N	(0045,0009)	SS	1	Sigma Row number	SigmaRowNumber	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4043	\N	(0045,000a)	FL	1	Minimum DAS value	MinimumDASValue	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4044	\N	(0045,000b)	FL	1	Maximum Offset Value	MaximumOffsetValue	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4045	\N	(0045,000c)	SS	1	Number of Views shifted	NumberOfViewsShifted	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4046	\N	(0045,000d)	SS	1	Z tracking Flag	ZTrackingFlag	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4047	\N	(0045,000e)	FL	1	Mean Z error	MeanZError	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4048	\N	(0045,000f)	FL	1	Z tracking Error	ZTrackingError	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4049	\N	(0045,0010)	SS	1	Start View 2A	StartView2A	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4050	\N	(0045,0011)	SS	1	Number of Views 2A	NumberOfViews2A	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4051	\N	(0045,0012)	SS	1	Start View 1A	StartView1A	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4052	\N	(0045,0013)	SS	1	Sigma Mode	SigmaMode	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4053	\N	(0045,0014)	SS	1	Number of Views 1A	NumberOfViews1A	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4054	\N	(0045,0015)	SS	1	Start View 2B	StartView2B	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4055	\N	(0045,0016)	SS	1	Number Views 2B	NumberViews2B	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4056	\N	(0045,0017)	SS	1	Start View 1B	StartView1B	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4057	\N	(0045,0018)	SS	1	Number of Views 1B	NumberOfViews1B	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4058	\N	(0045,0021)	SS	1	Iterbone Flag	IterboneFlag	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4059	\N	(0045,0022)	SS	1	PeristalticFlag	PeristalticFlag	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4060	\N	(0045,0030)	CS	1	CardiacReconAlgorithm	CardiacReconAlgorithm	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4061	\N	(0045,0031)	CS	1	AvgHeartRateForImage	AvgHeartRateForImage	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4062	\N	(0045,0032)	FL	1	TemporalResolution	TemporalResolution	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4063	\N	(0045,0033)	CS	1	PctRpeakDelay	PctRpeakDelay	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4064	\N	(0045,0036)	CS	1	EkgFullMaStartPhase	EkgFullMaStartPhase	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4065	\N	(0045,0037)	CS	1	EkgFullMaEndPhase	EkgFullMaEndPhase	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4066	\N	(0045,0038)	CS	1	EkgModulationMaxMa	EkgModulationMaxMa	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4067	\N	(0045,0039)	CS	1	EkgModulationMinMa	EkgModulationMinMa	GEMS_HELIOS_01	GEM	\N	\N	\N
f	4068	\N	(0045,003b)	LO	1	NoiseReductionImageFilterDesc	NoiseReductionImageFilterDesc	GEMS_HELIOS_01	GEM	\N	\N	\N
f	513	\N	(0047,0001)	SQ	1	Reconstruction Parameters Sequence	Reconstruction Parameters Sequence	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	514	\N	(0047,0050)	UL	1	Volume Voxel Count	VolumeVoxelCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	515	\N	(0047,0051)	UL	1	Volume Segment Count	VolumeSegmentCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	516	\N	(0047,0053)	US	1	Volume Slice Size	VolumeSliceSize	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	517	\N	(0047,0054)	US	1	Volume Slice Count	VolumeSliceCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	518	\N	(0047,0055)	SL	1	Volume Threshold Value	VolumeThresholdValue	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	519	\N	(0047,0057)	DS	1	Volume Voxel Ratio	VolumeVoxelRatio	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	520	\N	(0047,0058)	DS	1	Volume Voxel Size	VolumeVoxelSize	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	521	\N	(0047,0059)	US	1	Volume Z Position Size	VolumeZPositionSize	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	522	\N	(0047,0060)	DS	9	Volume Base Line	VolumeBaseLine	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	523	\N	(0047,0061)	DS	3	Volume Center Point	VolumeCenterPoint	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	524	\N	(0047,0063)	SL	1	Volume Skew Base	VolumeSkewBase	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	525	\N	(0047,0064)	DS	9	Volume Registration Transform Rotation Matrix	VolumeRegistrationTransformRotationMatrix	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	526	\N	(0047,0065)	DS	3	Volume Registration Transform Translation Vector	VolumeRegistrationTransformTranslationVector	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	527	\N	(0047,0070)	DS	1-n	KVP List	KVPList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	528	\N	(0047,0071)	IS	1-n	XRay Tube Current List	XRayTubeCurrentList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	529	\N	(0047,0072)	IS	1-n	Exposure List	ExposureList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	530	\N	(0047,0080)	LO	1	Acquisition DLX Identifier	AcquisitionDLXIdentifier	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	531	\N	(0047,0085)	SQ	1	Acquisition DLX 2D Series Sequence	AcquisitionDLX2DSeriesSequence	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	532	\N	(0047,0089)	DS	1-n	Contrast Agent Volume List	ContrastAgentVolumeList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4069	\N	(0047,008a)	US	1	Number Of Injections	NumberOfInjections	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4070	\N	(0047,008b)	US	1	Frame Count	FrameCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	535	\N	(0047,0091)	LO	1	XA 3D Reconstruction Algorithm Name	XA3DReconstructionAlgorithmName	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	536	\N	(0047,0092)	CS	1	XA 3D Reconstruction Algorithm Version	XA3DReconstructionAlgorithmVersion	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	537	\N	(0047,0093)	DA	1	DLX Calibration Date	DLXCalibrationDate	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	538	\N	(0047,0094)	TM	1	DLX Calibration Time	DLXCalibrationTime	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	539	\N	(0047,0095)	CS	1	DLX Calibration Status	DLXCalibrationStatus	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	540	\N	(0047,0096)	IS	1-n	Used Frames	UsedFrames	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	541	\N	(0047,0098)	US	1	Transform Count	TransformCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	542	\N	(0047,0099)	SQ	1	Transform Sequence	TransformSequence	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4071	\N	(0047,009a)	DS	9	Transform Rotation Matrix	TransformRotationMatrix	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4072	\N	(0047,009b)	DS	3	Transform Translation Vector	TransformTranslationVector	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4073	\N	(0047,009c)	LO	1	Transform Label	TransformLabel	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4074	\N	(0047,00b0)	SQ	1	Wireframe List	WireframeList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4075	\N	(0047,00b1)	US	1	Wireframe Count	WireframeCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4076	\N	(0047,00b2)	US	1	Location System	LocationSystem	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4077	\N	(0047,00b5)	LO	1	Wireframe Name	WireframeName	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4078	\N	(0047,00b6)	LO	1	Wireframe Group Name	WireframeGroupName	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4079	\N	(0047,00b7)	LO	1	Wireframe Color	WireframeColor	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4080	\N	(0047,00b8)	SL	1	Wireframe Attributes	WireframeAttributes	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4081	\N	(0047,00b9)	SL	1	Wireframe Point Count	WireframePointCount	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4082	\N	(0047,00ba)	SL	1	Wireframe Timestamp	WireframeTimestamp	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4083	\N	(0047,00bb)	SQ	1	Wireframe Point List	WireframePointList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4084	\N	(0047,00bc)	DS	3	Wireframe Points Coordinates	WireframePointsCoordinates	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4085	\N	(0047,00c0)	DS	3	Volume Upper Left High Corner RAS	VolumeUpperLeftHighCornerRAS	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4086	\N	(0047,00c1)	DS	9	Volume Slice To RAS Rotation Matrix	VolumeSliceToRASRotationMatrix	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4087	\N	(0047,00c2)	DS	1	Volume Upper Left High Corner TLOC	VolumeUpperLeftHighCornerTLOC	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4088	\N	(0047,00d1)	OB	1	Volume Segment List	VolumeSegmentList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4089	\N	(0047,00d2)	OB	1	Volume Gradient List	VolumeGradientList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4090	\N	(0047,00d3)	OB	1	Volume Density List	VolumeDensityList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4091	\N	(0047,00d4)	OB	1	Volume Z Position List	VolumeZPositionList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4092	\N	(0047,00d5)	OB	1	Volume Original Index List	VolumeOriginalIndexList	GEMS_ADWSoft_3D1	GEM	\N	\N	\N
f	4093	\N	(0047,00e9)	FL	3	Unknown	Unknown	GEMS_3DSTATE_001	GEM	\N	\N	\N
f	4094	\N	(0047,00ea)	DS	3	Unknown	Unknown	GEMS_3DSTATE_001	GEM	\N	\N	\N
f	4095	\N	(0047,00eb)	DS	3	Unknown	Unknown	GEMS_3DSTATE_001	GEM	\N	\N	\N
f	4096	\N	(0047,00ec)	FL	1	Unknown	Unknown	GEMS_3DSTATE_001	GEM	\N	\N	\N
f	4097	\N	(0047,00ed)	CS	1	Unknown	Unknown	GEMS_3DSTATE_001	GEM	\N	\N	\N
f	4098	\N	(0047,0002)	UL	1	Unknown	Unknown	GEMS_IQTB_IDEN_47	GEM	\N	\N	\N
f	4099	\N	(0049,0001)	SQ	1	CT Cardiac Sequence	CTCardiacSequence	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4100	\N	(0049,0002)	CS	1	HeartRateAtConfirm	HeartRateAtConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4101	\N	(0049,0003)	FL	1	AvgHeartRatePriorToConfirm	AvgHeartRatePriorToConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4102	\N	(0049,0004)	CS	1	MinHeartRatePriorToConfirm	MinHeartRatePriorToConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4103	\N	(0049,0005)	CS	1	MaxHeartRatePriorToConfirm	MaxHeartRatePriorToConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4104	\N	(0049,0006)	FL	1	StdDevHeartRatePriorToConfirm	StdDevHeartRatePriorToConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4105	\N	(0049,0007)	US	1	NumHeartRateSamplesPriorToConfirm	NumHeartRateSamplesPriorToConfirm	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4106	\N	(0049,0008)	CS	1	AutoHeartRateDetectPredict	AutoHeartRateDetectPredict	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4107	\N	(0049,0009)	CS	1	SystemOptimizedHeartRate	SystemOptimizedHeartRate	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4108	\N	(0049,000a)	ST	1	EkgMonitorType	EkgMonitorType	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4109	\N	(0049,000b)	CS	1	NumReconSectors	NumReconSectors	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4110	\N	(0049,000c)	FL	256	RpeakTimeStamps	RpeakTimeStamps	GEMS_CT_CARDIAC_001	GEM	\N	\N	\N
f	4111	\N	(004b,0001)	DS	1-n	Beam Thickess	BeamThickess	GEMS_CT_HINO_01	GEM	\N	\N	\N
f	4112	\N	(004b,0002)	DS	1-n	R Time	RTime	GEMS_CT_HINO_01	GEM	\N	\N	\N
f	4113	\N	(004b,0003)	IS	1	HBC Number	HBCNumber	GEMS_CT_HINO_01	GEM	\N	\N	\N
f	4114	\N	(004b,0013)	IS	1	Unknown	Unknown	GEIIS	GEM	\N	\N	\N
f	4115	\N	(004b,0015)	LT	1	Unknown	Unknown	GEIIS	GEM	\N	\N	\N
f	4116	\N	(0051,1001)	SQ	1	CTVESequence	CTVESSequence	GEMS_CT_VES_01	GEM	\N	typo in element assumed "1001" translated to "0001"	\N
f	4117	\N	(0055,0012)	SQ	1	eNTEGRA Energy Window Information Sequence	eNTEGRAEnergyWindowInformationSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4118	\N	(0055,0013)	SQ	1	eNTEGRA Energy Window Range Sequence	eNTEGRAEnergyWindowRangeSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4119	\N	(0055,0022)	SQ	1	eNTEGRA Detector Information Sequence	eNTEGRADetectorInformationSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4120	\N	(0055,0052)	SQ	1	eNTEGRA Rotation Information Sequence	eNTEGRARotationInformationSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4121	\N	(0055,0062)	SQ	1	eNTEGRA Gated Information Sequence	eNTEGRAGatedInformationSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4122	\N	(0055,0063)	SQ	1	eNTEGRA Data Information Sequence	eNTEGRADataInformationSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4123	\N	(0055,0064)	SQ	1	SDO Double Data Sequence	SDODoubleDataSequence	GEMS_GENIE_1	GEM	\N	\N	\N
f	4124	\N	(0055,0065)	SQ	1	Unknown	Unknown	GEMS_GENIE_1	GEM	\N	\N	\N
f	4125	\N	(3101,0010)	SQ	1	Annotation Sequence	AnnotationSequence	AMI Annotations_01	GEM	\N	\N	\N
f	4126	\N	(3101,0020)	SQ	1	Annotation Sequence	AnnotationSequence	AMI Annotations_02	GEM	\N	\N	\N
f	4127	\N	(3103,0010)	CS	1	Annotation Sequence	AnnotationSequence	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4128	\N	(3103,0020)	UI	1	Annotation UID	AnnotationUID	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4129	\N	(3103,0030)	US	1	Annotation Color	AnnotationColor	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4130	\N	(3103,0050)	CS	1	Annotation Line Style	AnnotationLineStyle	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4131	\N	(3103,0060)	SQ	1	Annotation Elements	AnnotationElements	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4132	\N	(3103,0070)	SH	1	Annotation Label	AnnotationLabel	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4133	\N	(3103,0080)	PN	1	Annotation Creator	AnnotationCreator	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4134	\N	(3103,0090)	PN	1	Annotation Modifiers	AnnotationModifiers	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4135	\N	(3103,00a0)	DA	1	Annotation Creation Date	AnnotationCreationDate	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4136	\N	(3103,00b0)	TM	1	Annotation Creation Time	AnnotationCreationTime	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4137	\N	(3103,00c0)	DA	1	Annotation Modification Dates	AnnotationModificationDates	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4138	\N	(3103,00d0)	TM	1	Annotation Mofification Times	AnnotationMofificationTimes	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4139	\N	(3103,00e0)	US	1	Annotation Frame Number	AnnotationFrameNumber	AMI Sequence Annotations_01	GEM	\N	\N	\N
f	4140	\N	(3103,0010)	CS	1	Annotation Sequence	AnnotationSequence	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4141	\N	(3103,0020)	UI	1	Annotation UID	AnnotationUID	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4142	\N	(3103,0030)	US	1	Annotation Color	AnnotationColor	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4143	\N	(3103,0050)	CS	1	Annotation Line Style	AnnotationLineStyle	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4144	\N	(3103,0060)	SQ	1	Annotation Elements	AnnotationElements	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4145	\N	(3103,0070)	SH	1	Annotation Label	AnnotationLabel	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4146	\N	(3103,0080)	PN	1	Annotation Creator	AnnotationCreator	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4147	\N	(3103,0090)	PN	1	Annotation Modifiers	AnnotationModifiers	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4148	\N	(3103,00a0)	DA	1	Annotation Creation Date	AnnotationCreationDate	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4149	\N	(3103,00b0)	TM	1	Annotation Creation Time	AnnotationCreationTime	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4150	\N	(3103,00c0)	DA	1	Annotation Modification Dates	AnnotationModificationDates	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4151	\N	(3103,00d0)	TM	1	Annotation Modification Times	AnnotationModificationTimes	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4152	\N	(3103,00e0)	US	1	Annotation Frame Number	AnnotationFrame Number	AMI Sequence Annotations_02	GEM	\N	\N	\N
f	4153	\N	(3105,0010)	DS	1-n	Annotation Element Position	AnnotationElementPosition	AMI Sequence AnnotElements_01	GEM	\N	\N	\N
f	4154	\N	(3105,0020)	LT	1	Annotation Element Text	AnnotationElementText	AMI Sequence AnnotElements_01	GEM	\N	\N	\N
f	4155	\N	(3107,0010)	DS	1-n	Transformation Matrix	Transformation Matrix	AMI ImageTransform_01	GEM	\N	\N	\N
f	4289	\N	(5001,0037)	FD	1	ROI Area	ROIArea	GEMS_GENIE_1	GEM	\N	\N	\N
f	4156	\N	(3107,0020)	DS	1	Center Offset	CenterOffset	AMI ImageTransform_01	GEM	\N	\N	\N
f	4157	\N	(3107,0030)	DS	1	Magnification	Magnification	AMI ImageTransform_01	GEM	\N	\N	\N
f	4158	\N	(3107,0040)	CS	1	Magnification Type	MagnificationType	AMI ImageTransform_01	GEM	\N	\N	\N
f	4159	\N	(3107,0050)	DS	1	Displayed Area	DisplayedArea	AMI ImageTransform_01	GEM	\N	\N	\N
f	4160	\N	(3107,0060)	DS	1	Calibration Factor	CalibrationFactor	AMI ImageTransform_01	GEM	\N	\N	\N
f	4161	\N	(3107,00a0)	CS	1	Window Function	WindowFunction	AMI ImageContextExt_01	GEM	\N	\N	\N
f	4162	\N	(3107,00b0)	DS	1	Window Slope	WindowSlope	AMI ImageContextExt_01	GEM	\N	\N	\N
f	4163	\N	(3109,0001)	ST	1	Worklist Filename	WorklistFilename	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4164	\N	(3109,0002)	SH	1	NEW/SEEN Status	NewSeenStatus	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4165	\N	(3109,0003)	CS	1	Delete Lock	DeleteLock	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4166	\N	(3109,0004)	CS	1	Unknown	Unknown	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4167	\N	(3109,0005)	CS	1	Unknown	Unknown	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4168	\N	(3109,0006)	CS	1	Unknown	Unknown	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4169	\N	(3109,0007)	UL	1	Unknown	Unknown	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4170	\N	(3109,0008)	LO	1	Receive Origin	ReceiveOrigin	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4171	\N	(3109,0009)	LO	1	Folder	Folder	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4172	\N	(3109,000a)	DA	1	Receive Date	ReceiveDate	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4173	\N	(3109,000b)	TM	1	Receive Time	ReceiveTime	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4174	\N	(3109,000c)	CS	1	Prior	Prior	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4175	\N	(3109,000d)	CS	1	STAT Study	StatStudy	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4176	\N	(3109,000e)	CS	1	Is Key Image Or Study	Key	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4177	\N	(3109,0010)	CS	1	Local Study	LocalStudy	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4178	\N	(3109,0011)	LO	1	Result Message	ResultMessage	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4179	\N	(3109,0012)	LO	1	Current User	CurrentUser	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4180	\N	(3109,0013)	DA	1	System Date	SystemDate	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4181	\N	(3109,0014)	TM	1	System Time	SystemTime	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4182	\N	(3109,0019)	LO	1	Worklist Name	WorklistName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4183	\N	(3109,0020)	UI	1	Worklist UID	WorklistUID	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4184	\N	(3109,0021)	CS	1	Hostname	Hostname	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4185	\N	(3109,0022)	AE	1	DICOM AE Title	DICOMAETitle	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4186	\N	(3109,0023)	US	1	DICOM Port Number	DICOMPortNumber	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4187	\N	(3109,0024)	LO	1	Destination Name	DestinationName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4188	\N	(3109,0025)	LO	1	Origin Name	OriginName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4189	\N	(3109,0026)	UI	1	Modality Study Instance UID	ModalityStudyInstanceUID	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4190	\N	(3109,0027)	SQ	1	Exam Routing	ExamRouting	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4191	\N	(3109,0028)	LO	1	Notification Comments	NotificationComments	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4192	\N	(3109,0029)	LO	1	Transaction Comments	TransactionComments	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4193	\N	(3109,002a)	LO	1	Send Flag	SendFlag	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4194	\N	(3109,002b)	LO	1	Print Flag	PrintFlag	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4195	\N	(3109,002c)	LO	1	Archive Flag	ArchiveFlag	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4196	\N	(3109,0030)	LO	1	Requesting Facility Name	RequestingFacilityName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4197	\N	(3109,0031)	CS	1	Requesting Procedure Name	RequestingProcedureName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4198	\N	(3109,0032)	CS	1	Requesting Procedure Code	RequestingProcedureCode	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4199	\N	(3109,0033)	CS	1	Request Storage Commitment	RequestStorage ommitment	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4200	\N	(3109,0034)	CS	1	Requested Compression	RequestedCompression	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4201	\N	(3109,0035)	SQ	1	Study Sequence	StudySequence	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4202	\N	(3109,0037)	UI	1	Replaced Study UID	ReplacedStudyUID	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4203	\N	(3109,0038)	SH	1	Teaching ACR Code	TeachingACRCode	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4204	\N	(3109,0039)	SH	1	Teaching Special Interest Code	TeachingSpecialInterestCode	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4205	\N	(3109,0040)	IS	1	Number of Study Related Images	NumberOfStudyRelatedImages	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4206	\N	(3109,0041)	CS	1	Study Locked	StudyLocked	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4207	\N	(3109,0042)	CS	1	Workstation Name	WorkstationName	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4208	\N	(3109,0043)	CS	1	Archive Status	ArchiveStatus	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4209	\N	(3109,00ee)	UI	1	Internal List UID	InternalListUID	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4210	\N	(3109,00ef)	CS	1	Action (Add,Remove,Change)	Action	Applicare/RadWorks/Version 5.0	GEM	\N	\N	\N
f	4211	\N	(3109,0001)	SH	1	Status	Status	Applicare/RadWorks/Version 6.0/Summary	GEM	\N	\N	\N
f	4212	\N	(3109,0011)	ST	1	Receive Origin Site Name	ReceiveOriginSiteName	Applicare/RadWorks/Version 6.0/Summary	GEM	\N	\N	\N
f	4213	\N	(3109,0012)	ST	1	Receive Origin Description	ReceiveOriginDescription	Applicare/RadWorks/Version 6.0/Summary	GEM	\N	\N	\N
f	4214	\N	(3109,0015)	DA	1	Receive Date	ReceiveDate	Applicare/RadWorks/Version 6.0/Summary	GEM	\N	\N	\N
f	4215	\N	(3109,0016)	TM	1	Receive Time	ReceiveTime	Applicare/RadWorks/Version 6.0/Summary	GEM	\N	\N	\N
f	4216	\N	(3115,0001)	UT	1	Unknown	Unknown	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	GEM	\N	\N	\N
f	4217	\N	(4101,0001)	UL	1	Mask State	MaskState	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4218	\N	(4101,0002)	SQ	1	Annotations	Annotations	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4219	\N	(4101,0003)	LO	1	Font	Font	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4220	\N	(4101,0004)	UL	1	Font Size	FontSize	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4221	\N	(4101,0005)	FD	1	Font Relative Size	FontRelativeSize	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4222	\N	(4101,0006)	US	1	Overlay	Overlay	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4223	\N	(4101,0007)	US	1	Pixel Rep	PixelRep	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4224	\N	(4101,0008)	US	1	Annotation Level	AnnotationLevel	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4225	\N	(4101,0009)	US	1	Show Caliper	ShowCaliper	Applicare/Print/Version 5.1	GEM	\N	\N	\N
f	4226	\N	(4103,0001)	AT	1-n	Non-existent tags	NonExistentTags	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4227	\N	(4103,0002)	UI	1-n	Non-existent objects	NonExistentObjects	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4228	\N	(4105,0001)	CS	1	Annotation Type	AnnotationType	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4229	\N	(4105,0002)	LO	1	Annotation Value	AnnotationValue	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4230	\N	(4105,0003)	UI	1	Cutline Image UID	CutlineImageUID	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4231	\N	(4105,0004)	UI	1	Cutline Set UID	CutlineSetUID	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4232	\N	(4105,0005)	US	3	Annotation Color (RGB)	AnnotationColor	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4233	\N	(4105,0006)	CS	1	Annotation Line Style	AnnotationLineStyle	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4234	\N	(4105,0007)	SH	1	Annotation Label	AnnotationLabel	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4235	\N	(4105,0008)	PN	1	Annotation Creator	AnnotationCreator	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4236	\N	(4105,0009)	DA	1	Annotation Creation Date	AnnotationCreationDate	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4237	\N	(4105,000a)	TM	1	Annotation Creation Time	AnnotationCreationTime	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4238	\N	(4105,000b)	SQ	1	Annotation Modification Sequence	AnnotationModificationSequence	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4239	\N	(4105,000c)	PN	1	Annotation Modifier	AnnotationModifier	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4240	\N	(4105,000d)	DA	1	Annotation Modification Date	AnnotationModificationDate	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4241	\N	(4105,000e)	TM	1	Annotation Modification Time	AnnotationModificationTime	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4242	\N	(4105,0010)	US	1	Unknown	Unknown	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4243	\N	(4107,0001)	SQ	1	Requested Palette Color LUT	RequestedPaletteColorLUT	Applicare/RadWorks/Version 6.0	GEM	\N	\N	\N
f	4244	\N	(5001,0001)	SL	1	Modified	Modified	GEMS_GENIE_1	GEM	\N	\N	\N
f	4245	\N	(5001,0002)	LO	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	4246	\N	(5001,0003)	SL	1	Cid	Cid	GEMS_GENIE_1	GEM	\N	\N	\N
f	4247	\N	(5001,0004)	SL	1	Srid	Srid	GEMS_GENIE_1	GEM	\N	\N	\N
f	4248	\N	(5001,0005)	LO	1	SOP Class UID	SOPClassUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4249	\N	(5001,0006)	LO	1	SOP Instance UID	SOPInstanceUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4250	\N	(5001,0007)	SL	1	Curve Type	CurveType	GEMS_GENIE_1	GEM	\N	\N	\N
f	4251	\N	(5001,0008)	SL	1	Graph Type	GraphType	GEMS_GENIE_1	GEM	\N	\N	\N
f	4252	\N	(5001,0009)	LO	1	Legend	Legend	GEMS_GENIE_1	GEM	\N	\N	\N
f	4253	\N	(5001,000a)	LO	1	X Units	XUnits	GEMS_GENIE_1	GEM	\N	\N	\N
f	4254	\N	(5001,000b)	LO	1	Y Units	YUnits	GEMS_GENIE_1	GEM	\N	\N	\N
f	4255	\N	(5001,000c)	SL	1	Edit	Edit	GEMS_GENIE_1	GEM	\N	\N	\N
f	4256	\N	(5001,000d)	SL	1	Suspend	Suspend	GEMS_GENIE_1	GEM	\N	\N	\N
f	4257	\N	(5001,000e)	SL	1	Style Line	StyleLine	GEMS_GENIE_1	GEM	\N	\N	\N
f	4258	\N	(5001,000f)	SL	1	Style Fill	StyleFill	GEMS_GENIE_1	GEM	\N	\N	\N
f	4259	\N	(5001,0010)	LO	1	Style Colour	StyleColour	GEMS_GENIE_1	GEM	\N	\N	\N
f	4260	\N	(5001,0011)	SL	1	Style Width	StyleWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	4261	\N	(5001,0012)	SL	1	Style Point	StylePoint	GEMS_GENIE_1	GEM	\N	\N	\N
f	4262	\N	(5001,0013)	LO	1	Style P Colour	StylePColour	GEMS_GENIE_1	GEM	\N	\N	\N
f	4263	\N	(5001,0014)	SL	1	Style P Size	StylePSize	GEMS_GENIE_1	GEM	\N	\N	\N
f	4264	\N	(5001,0015)	SL	1	Segments	Segments	GEMS_GENIE_1	GEM	\N	\N	\N
f	4265	\N	(5001,0016)	SL	1	Seg Type	SegType	GEMS_GENIE_1	GEM	\N	\N	\N
f	4266	\N	(5001,0017)	FD	1-n	Seg Start	SegStart	GEMS_GENIE_1	GEM	\N	\N	\N
f	4267	\N	(5001,0018)	FD	1-n	Seg End	SegEnd	GEMS_GENIE_1	GEM	\N	\N	\N
f	4268	\N	(5001,0019)	SL	1-n	Seg Style Line	SegStyleLine	GEMS_GENIE_1	GEM	\N	\N	\N
f	4269	\N	(5001,001a)	SL	1-n	SegStyleFill	SegStyleFill	GEMS_GENIE_1	GEM	\N	\N	\N
f	4270	\N	(5001,001b)	LO	1	Seg Style Colour	SegStyleColour	GEMS_GENIE_1	GEM	\N	\N	\N
f	4271	\N	(5001,001c)	SL	1-n	Seg Style Width	SegStyleWidth	GEMS_GENIE_1	GEM	\N	\N	\N
f	4272	\N	(5001,001d)	SL	1-n	Seg Style Point	SegStylePoint	GEMS_GENIE_1	GEM	\N	\N	\N
f	4273	\N	(5001,001e)	SL	1	Seg Style P Colour	SegStylePColour	GEMS_GENIE_1	GEM	\N	\N	\N
f	4274	\N	(5001,001f)	SL	1	Seg Style P Size	SegStylePSize	GEMS_GENIE_1	GEM	\N	\N	\N
f	4275	\N	(5001,0020)	LO	1	Seg Name	SegName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4276	\N	(5001,0021)	SL	1-n	Seg Allow Dir Int	SegAllowDirInt	GEMS_GENIE_1	GEM	\N	\N	\N
f	4277	\N	(5001,0022)	SL	1	Text Annots	TextAnnots	GEMS_GENIE_1	GEM	\N	\N	\N
f	4278	\N	(5001,0023)	FD	1-n	Txt X	TxtX	GEMS_GENIE_1	GEM	\N	\N	\N
f	4279	\N	(5001,0024)	FD	1-n	Txt Y	TxtY	GEMS_GENIE_1	GEM	\N	\N	\N
f	4280	\N	(5001,0025)	LO	1	Txt Text	TxtText	GEMS_GENIE_1	GEM	\N	\N	\N
f	4281	\N	(5001,0026)	LO	1	Txt Name	TxtName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4282	\N	(5001,0030)	LO	1	ROI Name	ROIName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4283	\N	(5001,0031)	LO	1	Derived From Image UID	DerivedFromImageUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4284	\N	(5001,0032)	SL	1-n	Derived From Images	DerivedFromImages	GEMS_GENIE_1	GEM	\N	\N	\N
f	4285	\N	(5001,0033)	UL	1	Curve Flags	CurveFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	4286	\N	(5001,0034)	LO	1	Curve Name	CurveName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4287	\N	(5001,0035)	LO	1	Dataset Name	DatasetName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4288	\N	(5001,0036)	LO	1	Curve UID	CurveUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4290	\N	(5001,0038)	LO	1	Modified	Modified	GEMS_GENIE_1	GEM	\N	\N	\N
f	4291	\N	(5001,0039)	LO	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	4292	\N	(5001,003a)	LO	1	Software Version	SoftwareVersion	GEMS_GENIE_1	GEM	\N	\N	\N
f	4293	\N	(5001,003b)	SH	1	Start Date	StartDate	GEMS_GENIE_1	GEM	\N	\N	\N
f	4294	\N	(5001,003c)	SH	1	Completion Date	CompletionDate	GEMS_GENIE_1	GEM	\N	\N	\N
f	4295	\N	(5001,003d)	LO	1	Detector Name	DetectorName	GEMS_GENIE_1	GEM	\N	\N	\N
f	4296	\N	(5001,0041)	SL	1	Modified	Modified	GEMS_GENIE_1	GEM	\N	\N	\N
f	4297	\N	(5001,0042)	LO	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	4298	\N	(5001,0043)	SL	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	4299	\N	(5001,0044)	SL	1	Name	Name	GEMS_GENIE_1	GEM	\N	\N	\N
f	4300	\N	(5001,0045)	LO	1	SOP Class UID	SOPClassUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4301	\N	(5001,0046)	LO	1	SOP Instance UID	SOPInstanceUID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4302	\N	(5001,0047)	LO	1	Normal Color	NormalColor	GEMS_GENIE_1	GEM	\N	\N	\N
f	4303	\N	(5001,0048)	LT	1	Name Font	NameFont	GEMS_GENIE_1	GEM	\N	\N	\N
f	4304	\N	(5001,0049)	SL	1	Fill Pattern	FillPattern	GEMS_GENIE_1	GEM	\N	\N	\N
f	4305	\N	(5001,004a)	SL	1	Line Style	LineStyle	GEMS_GENIE_1	GEM	\N	\N	\N
f	4306	\N	(5001,004b)	SL	1	Line Dash Length	LineDashLength	GEMS_GENIE_1	GEM	\N	\N	\N
f	4307	\N	(5001,004c)	SL	1	Line Thickness	LineThickness	GEMS_GENIE_1	GEM	\N	\N	\N
f	4308	\N	(5001,004d)	SL	1	Interactivity	Interactivity	GEMS_GENIE_1	GEM	\N	\N	\N
f	4309	\N	(5001,004e)	SL	1	Name Pos	NamePos	GEMS_GENIE_1	GEM	\N	\N	\N
f	4310	\N	(5001,004f)	SL	1	Name Display	NameDisplay	GEMS_GENIE_1	GEM	\N	\N	\N
f	4311	\N	(5001,0050)	LO	1	Label	Label	GEMS_GENIE_1	GEM	\N	\N	\N
f	4312	\N	(5001,0051)	SL	1-n	Bp Seg	BpSeg	GEMS_GENIE_1	GEM	\N	\N	\N
f	4313	\N	(5001,0052)	US	1-n	Bp Seg Pairs	BpSegPairs	GEMS_GENIE_1	GEM	\N	\N	\N
f	4314	\N	(5001,0053)	SL	1	Seed Space	SeedSpace	GEMS_GENIE_1	GEM	\N	\N	\N
f	4315	\N	(5001,0054)	FD	1-n	Seeds	Seeds	GEMS_GENIE_1	GEM	\N	\N	\N
f	4316	\N	(5001,0055)	SL	1-n	Shape	Shape	GEMS_GENIE_1	GEM	\N	\N	\N
f	4317	\N	(5001,0056)	FD	1-n	Shape Tilt	ShapeTilt	GEMS_GENIE_1	GEM	\N	\N	\N
f	4318	\N	(5001,0059)	SL	1-n	Shape Pts Space	ShapePtsSpace	GEMS_GENIE_1	GEM	\N	\N	\N
f	4319	\N	(5001,005a)	SL	1-n	Shape Ctrl Pts Counts	ShapeCtrlPtsCounts	GEMS_GENIE_1	GEM	\N	\N	\N
f	4320	\N	(5001,005b)	FD	1-n	Shape Ctrl Pts	ShapeCtrlPts	GEMS_GENIE_1	GEM	\N	\N	\N
f	4321	\N	(5001,005c)	SL	1	Shape Ctrl P Space	ShapeCtrlPSpace	GEMS_GENIE_1	GEM	\N	\N	\N
f	4322	\N	(5001,005d)	SL	1	ROI Flags	ROIFlags	GEMS_GENIE_1	GEM	\N	\N	\N
f	4323	\N	(5001,005e)	SL	1	Frame Number	FrameNumber	GEMS_GENIE_1	GEM	\N	\N	\N
f	4324	\N	(5001,005f)	SL	1	ID	ID	GEMS_GENIE_1	GEM	\N	\N	\N
f	4325	\N	(5001,0060)	LO	1-n	Dataset ROI Mapping	DatasetROIMapping	GEMS_GENIE_1	GEM	\N	\N	\N
t	\N	4	(60xx,0001)	US	3	Gray Palette Color Lookup Table Descriptor	GrayPaletteColorLookupTableDescriptor	DLX_LKUP_01	GEM	\N	\N	\N
t	\N	5	(60xx,0002)	US	1	Gray Palette Color Lookup Table Data	GrayPaletteColorLookupTableData	DLX_LKUP_01	GEM	\N	\N	\N
t	\N	1	(70xx,0004)	ST	1	TextAnnotation	TextAnnotation	DLX_ANNOT_01	GEM	\N	\N	\N
t	\N	2	(70xx,0005)	IS	2	Box	Box	DLX_ANNOT_01	GEM	\N	\N	\N
t	\N	3	(70xx,0007)	IS	2	ArrowEnd	ArrowEnd	DLX_ANNOT_01	GEM	\N	\N	\N
f	4326	\N	(0009,0010)	SQ	1	GE Private Image Thumbnail Sequence	GEPrivateImageThumbnailSequence	GEIIS	GEM	\N	\N	\N
f	4327	\N	(0009,0012)	IS	1	Unknown	Unknown	GEIIS	GEM	\N	\N	\N
f	4328	\N	(0029,0010)	UL	1	Shift Count	ShiftCount	GEIIS	GEM	\N	\N	\N
f	4329	\N	(0029,0012)	UL	1	Offset	Offset	GEIIS	GEM	\N	\N	\N
f	4330	\N	(0029,0014)	UL	1	Actual Frame Number	ActualFrameNumber	GEIIS	GEM	\N	\N	\N
f	4331	\N	(0903,0010)	US	1	Reject Image Flag	RejectImageFlag	GEIIS PACS	GEM	\N	\N	\N
f	4332	\N	(0903,0011)	US	1	Significant Flag	SignificantFlag	GEIIS PACS	GEM	\N	\N	\N
f	4333	\N	(0903,0012)	US	1	Confidential Flag	ConfidentialFlag	GEIIS PACS	GEM	\N	\N	\N
f	4334	\N	(0903,0020)	CS	1	Unknown	Unknown	GEIIS PACS	GEM	\N	\N	\N
f	4335	\N	(0905,0030)	LO	1	Assigning Authority For Patient ID	AssigningAuthorityForPatientID	GEIIS	GEM	\N	\N	\N
f	4336	\N	(0907,0010)	UI	1	Original Study Instance UID	OriginalStudyInstanceUID	GEIIS	GEM	\N	\N	\N
f	4337	\N	(0907,0020)	UI	1	Original Series Instance UID	OriginalSeriesInstanceUID	GEIIS	GEM	\N	\N	\N
f	4338	\N	(0907,0021)	US	1	Prefetch Algorithm	PrefetchAlgorithm	GEIIS PACS	GEM	\N	\N	\N
f	4339	\N	(0907,0022)	US	1	Limit Recent Studies	LimitRecentStudies	GEIIS PACS	GEM	\N	\N	\N
f	4340	\N	(0907,0023)	US	1	Limit Oldest Studies	LimitOldestStudies	GEIIS PACS	GEM	\N	\N	\N
f	4341	\N	(0907,0024)	US	1	Limit Recent Months	LimitRecentMonths	GEIIS PACS	GEM	\N	\N	\N
f	4342	\N	(0907,0030)	UI	1	Original SOP Instance UID	OriginalSOPInstanceUID	GEIIS	GEM	\N	\N	\N
f	4343	\N	(0907,0031)	UI	1-n	Exclude Study UIDs	ExcludeStudyUIDs	GEIIS PACS	GEM	\N	\N	\N
f	4344	\N	(7fd1,0010)	UL	1	Compression Type	CompressionType	GEIIS	GEM	\N	\N	\N
f	4345	\N	(7fd1,0020)	UL	1-n	Multiframe Offsets	MultiframeOffsets	GEIIS	GEM	\N	\N	\N
f	4346	\N	(7fd1,0030)	UL	1	Multi-Resolution Levels	MultiResolutionLevels	GEIIS	GEM	\N	\N	\N
f	4347	\N	(7fd1,0040)	UL	1-n	Subband Rows	SubbandRows	GEIIS	GEM	\N	\N	\N
f	4348	\N	(7fd1,0050)	UL	1-n	Subband Columns	SubbandColumns	GEIIS	GEM	\N	\N	\N
f	4349	\N	(7fd1,0060)	UL	1-n	Subband Bytecounts	SubbandBytecounts	GEIIS	GEM	\N	\N	\N
f	4350	\N	(0011,0003)	UI	1	Processed Series UID	ProcessedSeriesUID	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4351	\N	(0011,0004)	CS	1	Acquisition Type	AcquisitionType	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4352	\N	(0011,0005)	UI	1	Acquisition UID	AcquisitionUID	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4353	\N	(0011,0006)	DS	1	Image Dose	ImageDose	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4354	\N	(0011,0007)	FL	1	Study Dose	StudyDose	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4355	\N	(0011,0008)	FL	1	Study DAP	StudyDAP	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4356	\N	(0011,0009)	SL	1	Non-Digital Exposures	NonDigitalExposures	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4357	\N	(0011,0010)	SL	1	Total Exposures	TotalExposures	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4358	\N	(0011,0011)	LT	1	ROI	ROI	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4359	\N	(0011,0012)	LT	1	Patient Size String	PatientSizeString	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4360	\N	(0011,0013)	UI	1	SPS UID	SPSUID	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4361	\N	(0011,0014)	UI	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4362	\N	(0011,0015)	DS	1	Detector ARC Gain	DetectorARCGain	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4363	\N	(0011,0016)	LT	1	Processing Debug Info	ProcessingDebugInfo	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4364	\N	(0011,0017)	CS	1	Override Mode	OverrideMode	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4365	\N	(0011,0019)	DS	1	Film Speed Selection	FilmSpeedSelection	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4366	\N	(0011,0027)	UN	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4367	\N	(0011,0028)	UN	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4368	\N	(0011,0029)	UN	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4369	\N	(0011,0030)	UN	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4370	\N	(0011,0031)	IS	1-n	Detected Field of View	DetectedFieldOfView	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4371	\N	(0011,0032)	IS	1-n	Adjusted Field of View	AdjustedFieldOfView	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4372	\N	(0011,0033)	DS	1	Detector Exposure Index	DetectorExposureIndex	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4373	\N	(0011,0034)	DS	1	Compensated Detector Exposure	CompensatedDetectorExposure	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4374	\N	(0011,0035)	DS	1	Uncompensated Detector Exposure	UncompensatedDetectorExposure	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4375	\N	(0011,0036)	DS	1	Median Anatomy Count Value	MedianAnatomyCountValue	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4376	\N	(0011,0037)	DS	2	DEI Lower & Upper Limit Values	DEILowerAndUpperLimitValues	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4377	\N	(0011,0038)	SL	6	Shift Vector for Pasting	ShiftVectorForPasting	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4378	\N	(0011,0039)	CS	6	Image Number in Pasting	ImageNumberInPasting	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4379	\N	(0011,0040)	SL	1	Pasting Overlap	PastingOverlap	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4380	\N	(0011,0041)	IS	24	Sub-image Collimator Vertices	SubImageCollimatorVertices	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4381	\N	(0011,0042)	LO	1	View IP	ViewIP	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4382	\N	(0011,0043)	IS	24	Keystone Coordinates	KeystoneCoordinates	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4383	\N	(0011,0044)	CS	1	Receptor Type	ReceptorType	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4384	\N	(0011,0046)	LO	1-n	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4385	\N	(0011,0047)	DS	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4386	\N	(0011,0059)	CS	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4387	\N	(0011,0060)	CS	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4388	\N	(0011,006d)	DS	1	Unknown	Unknown	GEMS_GDXE_FALCON_04	GEM	\N	\N	\N
f	4389	\N	(0045,0055)	DS	8	A_Coefficients used in Multiresolution Algorithm	A_Coefficients	GEMS_FALCON_03	GEM	\N	\N	\N
f	4390	\N	(0045,0062)	IS	1	User Window Center	UserWindowCenter	GEMS_FALCON_03	GEM	\N	\N	\N
f	4391	\N	(0045,0063)	IS	1	User Window Width	UserWindowWidth	GEMS_FALCON_03	GEM	\N	\N	\N
f	4392	\N	(0045,0065)	IS	1	Requested Detector Entrance Dose	RequestedDetectorEntranceDose	GEMS_FALCON_03	GEM	\N	\N	\N
f	4393	\N	(0045,0067)	DS	3	VOI LUT Assymmetry Parameter Beta	VOILUTAssymmetryParameterBeta	GEMS_FALCON_03	GEM	\N	\N	\N
f	4394	\N	(0045,0069)	IS	1	Collimator Rotation	CollimatorRotation	GEMS_FALCON_03	GEM	\N	\N	\N
f	4395	\N	(0045,0072)	IS	1	Collimator Width	CollimatorWidth	GEMS_FALCON_03	GEM	\N	\N	\N
f	4396	\N	(0045,0073)	IS	1	Collimator Height	CollimatorHeight	GEMS_FALCON_03	GEM	\N	\N	\N
f	4397	\N	(0045,0055)	DS	8	A_Coefficients used in Multiresolution Algorithm	A_Coefficients	GEMS_SEND_02	GEM	\N	\N	\N
f	4398	\N	(0045,0062)	IS	1	User Window Center	UserWindowCenter	GEMS_SEND_02	GEM	\N	\N	\N
f	4399	\N	(0045,0063)	IS	1	User Window Width	UserWindowWidth	GEMS_SEND_02	GEM	\N	\N	\N
f	4400	\N	(0045,0065)	IS	1	Requested Detector Entrance Dose	RequestedDetectorEntranceDose	GEMS_SEND_02	GEM	\N	\N	\N
f	4401	\N	(0045,0067)	DS	3	VOI LUT Assymmetry Parameter Beta	VOILUTAssymmetryParameterBeta	GEMS_SEND_02	GEM	\N	\N	\N
f	4402	\N	(0045,0069)	IS	1	Collimator Rotation	CollimatorRotation	GEMS_SEND_02	GEM	\N	\N	\N
f	4403	\N	(0045,0072)	IS	1	Collimator Width	CollimatorWidth	GEMS_SEND_02	GEM	\N	\N	\N
f	4404	\N	(0045,0073)	IS	1	Collimator Height	CollimatorHeight	GEMS_SEND_02	GEM	\N	\N	\N
f	4405	\N	(7fdf,0010)	LT	1	Pixel Data References	PixelDataReferences	GEMS_GDXE_ATHENAV2_INTERNAL_USE	GEM	\N	\N	\N
f	4406	\N	(7fdf,0011)	LT	1	Pixel Data References (temporary)	PixelDataReferencesTemporary	GEMS_GDXE_ATHENAV2_INTERNAL_USE	GEM	\N	\N	\N
f	4407	\N	(7fdf,0020)	SS	1	Auto Push Tag	AutoPushTag	GEMS_GDXE_ATHENAV2_INTERNAL_USE	GEM	\N	\N	\N
f	4408	\N	(7fdf,0025)	CS	1	PPS Status	PPSStatus	GEMS_GDXE_ATHENAV2_INTERNAL_USE	GEM	\N	\N	\N
f	4409	\N	(6003,0010)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_ImageGroup_001	GEM	\N	\N	\N
f	4410	\N	(6003,0011)	OB	1	Unknown	Unknown	GEMS_Ultrasound_ImageGroup_001	GEM	\N	\N	\N
f	4411	\N	(6003,0012)	LT	1	Unknown	Unknown	GEMS_Ultrasound_ImageGroup_001	GEM	\N	\N	\N
f	4412	\N	(6003,0015)	LT	1-n	Unknown	Unknown	GEMS_Ultrasound_ImageGroup_001	GEM	\N	\N	\N
f	4413	\N	(6005,0010)	UT	1	Unknown	Unknown	GEMS_Ultrasound_ExamGroup_001	GEM	\N	\N	\N
f	4414	\N	(6005,0020)	UT	1	Unknown	Unknown	GEMS_Ultrasound_ExamGroup_001	GEM	\N	\N	\N
f	4415	\N	(7fe1,0001)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4416	\N	(7fe1,0002)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4417	\N	(7fe1,0003)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4418	\N	(7fe1,0008)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4419	\N	(7fe1,0010)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4420	\N	(7fe1,0012)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4421	\N	(7fe1,0018)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4422	\N	(7fe1,0020)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4423	\N	(7fe1,0024)	SH	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4424	\N	(7fe1,0026)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4425	\N	(7fe1,0030)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4426	\N	(7fe1,0032)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4427	\N	(7fe1,0036)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4428	\N	(7fe1,0037)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4429	\N	(7fe1,003a)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4430	\N	(7fe1,003c)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4431	\N	(7fe1,0043)	OB	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4432	\N	(7fe1,0048)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4433	\N	(7fe1,0049)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4434	\N	(7fe1,0051)	FL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4435	\N	(7fe1,0052)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4436	\N	(7fe1,0053)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4437	\N	(7fe1,0054)	SL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4438	\N	(7fe1,0055)	OB	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4439	\N	(7fe1,0057)	LT	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4440	\N	(7fe1,0060)	OB	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4441	\N	(7fe1,0061)	OW	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4442	\N	(7fe1,0062)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4443	\N	(7fe1,0069)	OW	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4444	\N	(7fe1,0070)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4445	\N	(7fe1,0071)	UL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4446	\N	(7fe1,0072)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4447	\N	(7fe1,0073)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4448	\N	(7fe1,0074)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4449	\N	(7fe1,0075)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4450	\N	(7fe1,0077)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4451	\N	(7fe1,0079)	SL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4452	\N	(7fe1,0083)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4453	\N	(7fe1,0084)	LO	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4454	\N	(7fe1,0085)	SQ	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4455	\N	(7fe1,0086)	SL	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4456	\N	(7fe1,0087)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4457	\N	(7fe1,0088)	FD	1	Unknown	Unknown	GEMS_Ultrasound_MovieGroup_001	GEM	\N	\N	\N
f	4458	\N	(7fe1,0001)	OB	1	Unknown	Unknown	KRETZ_US	GEM	\N	\N	\N
f	4459	\N	(0009,0001)	UL	1-n	Rate Vector	RateVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4460	\N	(0009,0002)	UL	1-n	Count Vector	CountVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4461	\N	(0009,0003)	UL	1-n	Time Vector	TimeVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4462	\N	(0009,0007)	UL	1-n	Angle Vector	AngleVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4463	\N	(0009,0008)	US	1	Camera Shape	CameraShape	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4464	\N	(0009,0010)	US	1	Whole Body Spots	WholeBodySpots	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4465	\N	(0009,0011)	US	1	Worklist Flag	WorklistFlag	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4466	\N	(0009,0012)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4467	\N	(0009,0013)	ST	1	Sequence Type	SequenceType	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4468	\N	(0009,0014)	ST	1	Sequence Name	SequenceName	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4469	\N	(0009,0015)	UL	1-n	Average RR Time Vector	AverageRRTimeVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4470	\N	(0009,0016)	UL	1-n	Low Limit Vector	LowLimitVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4471	\N	(0009,0017)	UL	1-n	High Limit Vector	HighLimitVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4472	\N	(0009,0018)	UL	1-n	Begin Index Vector	BeginIndexVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4473	\N	(0009,0019)	UL	1-n	End Index Vector	EndIndexVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4474	\N	(0009,001a)	UL	1-n	Raw Time Vector	RawTimeVector	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4475	\N	(0009,001b)	LO	1	Image Type String	ImageTypeString	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4476	\N	(0009,001d)	US	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4477	\N	(0009,001e)	ST	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4478	\N	(0009,0022)	FL	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4479	\N	(0009,0023)	US	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4480	\N	(0009,0039)	UI	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4481	\N	(0009,0040)	DA	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4482	\N	(0009,0041)	TM	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4483	\N	(0009,0042)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4484	\N	(0009,0044)	SH	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4485	\N	(0009,0045)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4486	\N	(0009,0048)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4487	\N	(0037,0010)	SQ	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4488	\N	(0037,001b)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4489	\N	(0037,0030)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4490	\N	(0037,0040)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4491	\N	(0037,0050)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4492	\N	(0037,0060)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4493	\N	(0037,0070)	LO	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4494	\N	(0037,0071)	FD	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4495	\N	(0037,0072)	SH	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4496	\N	(0037,0073)	FD	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4497	\N	(0037,0078)	FD	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4498	\N	(0037,0090)	IS	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4499	\N	(0037,0092)	DS	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4500	\N	(0041,0001)	UT	1	Unknown	Unknown	QUASAR_INTERNAL_USE	GEM	\N	\N	\N
f	4501	\N	(0027,0011)	DS	1	Bed Position	BedPosition	APEX_PRIVATE	GEM	\N	\N	\N
f	4502	\N	(0033,0008)	CS	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4503	\N	(0033,0010)	SL	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4504	\N	(0033,0011)	LO	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4505	\N	(0033,0016)	UI	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4506	\N	(0033,0017)	DA	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4507	\N	(0033,0018)	TM	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4508	\N	(0033,0019)	UL	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4509	\N	(0033,001a)	LO	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4510	\N	(0033,001b)	LO	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4511	\N	(0033,001c)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4512	\N	(0033,001d)	UL	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4513	\N	(0033,001e)	FD	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4514	\N	(0033,001f)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4515	\N	(0033,0020)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4516	\N	(0033,0021)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4517	\N	(0033,0022)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4518	\N	(0033,0023)	OB	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4519	\N	(0033,0024)	LT	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4520	\N	(0033,0070)	SQ	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4521	\N	(0033,0071)	UI	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4522	\N	(0033,0072)	UI	1	Unknown	Unknown	GEMS_XELPRV_01	GEM	\N	\N	\N
f	4523	\N	(0039,0095)	LO	1	Unknown	Unknown	REPORT_FROM_APP	GEM	\N	\N	\N
f	4524	\N	(0047,0011)	LT	1	Unknown	Unknown	GEMS_VXTL_USERDATA_01	GEM	\N	\N	\N
f	4525	\N	(0015,008f)	IS	1	Unknown	Unknown	DL_INTERNAL_USE	GEM	\N	\N	\N
f	4526	\N	(7003,0001)	ST	1	enCORE File Name	enCOREFileName	GEMS_LUNAR_RAW	GEM	\N	\N	\N
f	4527	\N	(7003,0002)	OB	1	enCORE File Data	enCOREFileData	GEMS_LUNAR_RAW	GEM	\N	\N	\N
f	4528	\N	(7003,0003)	UL	1	enCORE File Length	enCOREFileLength	GEMS_LUNAR_RAW	GEM	\N	\N	\N
f	4529	\N	(7003,0004)	LO	1	enCORE File Modified Time	enCOREFileModifiedTime	GEMS_LUNAR_RAW	GEM	\N	\N	\N
f	4530	\N	(0053,0020)	IS	1	Shuttle Flag	ShuttleFlag	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4530	\N	(0053,0020)	IS	1	Table Speed Not Reaches Target Flag	TableSpeedNotReachesTargetFlag	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4531	\N	(0053,0040)	SH	1	Iterative Recon Annotation	IterativeReconAnnotation	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4532	\N	(0053,0041)	SH	1	Iterative Recon Mode	IterativeReconMode	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4533	\N	(0053,0042)	LO	1	Iterative Recon Configuration	IterativeReconConfiguration	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4534	\N	(0053,0043)	SH	1	Iterative Recon Level	IterativeReconLevel	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4535	\N	(0053,0060)	SH	1	Recon Flip RotateA nno	ReconFlipRotateAnno	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4536	\N	(0053,0061)	SH	1	High Resolution Flag	HighResolutionFlag	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4537	\N	(0053,0062)	SH	1	Respiratory Flag	RespiratoryFlag	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4538	\N	(0053,009d)	LO	1	Unknown	Unknown	GEHC_CT_ADVAPP_001	GEM	\N	\N	\N
f	4539	\N	(6005,0010)	UT	1	Unknown	Unknown	GE_GROUP	GEM	\N	\N	\N
f	4540	\N	(0039,0095)	LO	1	Unknown	Unknown	GEMS_0039	GEM	\N	\N	\N
f	5	\N	(0087,0010)	CS	1	Media Type	MediaType	1.2.840.113708.794.1.1.2.0	GEM	\N	\N	\N
f	6	\N	(0087,0020)	CS	1	Media Location	MediaLocation	1.2.840.113708.794.1.1.2.0	GEM	\N	\N	\N
f	4541	\N	(0087,0030)	ST	1	Storage File ID	StorageFileID	1.2.840.113708.794.1.1.2.0	GEM	\N	\N	\N
f	4542	\N	(0087,0040)	DS	1	Study or Image Size in MB	StudyOrImageSizeInMB	1.2.840.113708.794.1.1.2.0	GEM	\N	\N	\N
f	7	\N	(0087,0050)	IS	1	Estimated Retrieve Time	EstimatedRetrieveTime	1.2.840.113708.794.1.1.2.0	GEM	\N	\N	\N
f	4543	\N	(0045,0111)	OW	1	Vivid excel file	VividExcelFile	GEMS_IT_US_REPORT	GEM	\N	typo in element assumed "0111" translated to "0011"	\N
f	4544	\N	(0045,0112)	OW	1	Vivid CHM file	VividCHMFile	GEMS_IT_US_REPORT	GEM	\N	typo in element assumed "0112" translated to "0012"	\N
f	4545	\N	(0045,0113)	OW	1	Vivid PDF file	VividPDFFile	GEMS_IT_US_REPORT	GEM	\N	typo in element assumed "0113" translated to "0013"	\N
f	4546	\N	(3113,0001)	CS	1	Order Control	OrderControl	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4547	\N	(3113,0010)	SH	1	Scheduled Action Item Code Value	ScheduledActionItemCodeValue	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4548	\N	(3113,0011)	SH	1	Scheduled Action Item Coding Scheme Designator	ScheduledActionItemCodingSchemeDesignator	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4549	\N	(3113,0012)	LO	1	Scheduled Action Item Code Meaning	ScheduledActionItemCodeMeaning	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4550	\N	(3113,0015)	SH	1	Requested Action Item Code Value	RequestedActionItemCodeValue	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4551	\N	(3113,0016)	SH	1	Requested Action Item Coding Scheme Designator	RequestedActionItemCodingSchemeDesignator	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4552	\N	(3113,0017)	LO	1	Requested Action Item Code Meaning	RequestedActionItemCodeMeaning	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4553	\N	(3113,0020)	SH	1	Performed Action Item Code Value	PerformedActionItemCodeValue	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4554	\N	(3113,0021)	SH	1	Performed Action Item Coding Scheme Designator	PerformedActionItemCodingSchemeDesignator	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4555	\N	(3113,0022)	LO	1	Performed Action Item Code Meaning	PerformedActionItemCodeMeaning	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4556	\N	(3113,0025)	SH	1	Performed Procedure Code Value	PerformedProcedureCodeValue	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4683	\N	(0019,0024)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4557	\N	(3113,0026)	SH	1	Performed Procedure Coding Scheme Designator	PerformedProcedureCodingSchemeDesignator	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4558	\N	(3113,0027)	LO	1	Performed Procedure Code Meaning	PerformedProcedureCodeMeaning	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4559	\N	(3113,0030)	UI	1	Referenced Image SOP Class UID	ReferencedImageSOPClassUID	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4560	\N	(3113,0031)	UI	1	Referenced Image SOP Instance UID	ReferencedImageSOPInstanceUID	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4561	\N	(3113,00e0)	CS	1	Locked By Hostname	LockedByHostname	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4562	\N	(3113,00e1)	CS	1	Locked By User	LockedByUser	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4563	\N	(3113,00e2)	CS	1	KfEdit Lock User	KfEditLockUser	Applicare/Workflow/Version 1.0	GEM	\N	\N	\N
f	4564	\N	(0045,0067)	DS	1	LUT Assymetry	LUTAssymetry	GE LUT Asymmetry Parameter	GEM	\N	\N	\N
f	4565	\N	(4109,0001)	SH	1	Mammography Laterality	MammographyLaterality	Applicare/Centricity Radiology Web/Version 1.0	GEM	\N	\N	\N
f	4566	\N	(4109,0002)	SH	1	Mammography View Name	MammographyViewName	Applicare/Centricity Radiology Web/Version 1.0	GEM	\N	\N	\N
f	4567	\N	(4109,0003)	SH	1	Mammography View Modifier	MammographyViewModifier	Applicare/Centricity Radiology Web/Version 1.0	GEM	\N	\N	\N
f	4568	\N	(4111,0001)	CS	1	Secondary Spine Label	Secondary pineLabel	Applicare/Centricity Radiology Web/Version 2.0	GEM	\N	\N	\N
f	4569	\N	(4111,0002)	IS	1	Additional tags for Presentation State	AdditionalTagsForPresentationState	Applicare/Centricity Radiology Web/Version 2.0	GEM	\N	\N	\N
f	4570	\N	(4113,0010)	UI	1	Number of images in study	NumberOfImagesInStudy	GEMS-IT/Centricity RA600/7.0	GEM	\N	\N	\N
f	4571	\N	(3111,0001)	UL	1	Last Released Annot Label	Last Released Annot Label	AMI StudyExtensions_01	GEM	\N	\N	\N
f	4572	\N	(3111,0002)	CS	1	Compression Type	Compression Type	RadWorksTBR	GEM	\N	\N	\N
f	4573	\N	(3111,00ff)	SQ	1	Query Result	QueryResult	RadWorksTBR	GEM	\N	\N	\N
f	4574	\N	(3113,0001)	SL	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4575	\N	(3113,0002)	SL	1	Internal Id of Study	Id1	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4576	\N	(3113,0003)	SL	1	Internal Id of Series	Id2	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4577	\N	(3113,0004)	SL	1	Internal Id of Instance	Id3	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4578	\N	(3113,0011)	LO	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4579	\N	(3113,0012)	CS	1	Instance State	InstanceState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4580	\N	(3113,0013)	DT	1	Date Last Modified	DateLastModified	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4581	\N	(3113,0014)	DT	1	Date Last Accessed	DateLastAccessed	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4582	\N	(3113,0015)	CS	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4583	\N	(3113,0016)	FD	1	Instance Size in Bytes	InstanceSizeInBytes	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4584	\N	(3113,0017)	LO	1	Library Id	LibraryId	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4585	\N	(3113,0018)	LO	1	Pathnames	Pathnames	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4586	\N	(3113,0019)	LO	1	Driver Path	DriverPath	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4587	\N	(3113,001a)	LO	1	Source	Source	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4588	\N	(3113,001b)	LO	1	Destination	Destination	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4589	\N	(3113,001c)	SL	1	Medium Id	MediumId	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4590	\N	(3113,001d)	LO	1	Archive Id	ArchiveId	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4591	\N	(3113,001e)	LO	1	Instance Origin	InstanceOrigin	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4592	\N	(3113,0021)	SL	1	Instance Version	InstanceVersion	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4593	\N	(3113,0022)	SL	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4594	\N	(3113,0023)	ST	1	Instance File Location	InstanceFileLocation	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4595	\N	(3113,0031)	IS	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4596	\N	(3113,0032)	IS	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4597	\N	(3113,0033)	IS	1	Unknown	Unknown	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4598	\N	(3113,0035)	LO	1	Image Medium Location	ImageMediumLocation	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4599	\N	(3113,0036)	LO	1	Image Medium Label	ImageMediumLabel	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4600	\N	(3113,0037)	CS	1	Image Medium State	ImageMediumState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4601	\N	(3113,0038)	LO	1	Series Medium Location	SeriesMediumLocation	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4602	\N	(3113,0039)	LO	1	Series Medium Label	SeriesMediumLabel	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4603	\N	(3113,003a)	CS	1	Series Medium State	SeriesMediumState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4604	\N	(3113,003b)	LO	1	Study Medium Location	StudyMediumLocation	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4605	\N	(3113,003c)	LO	1	Study Medium Label	StudyMediumLabel	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4606	\N	(3113,003d)	CS	1	Study Medium State	StudyMediumState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4607	\N	(3113,0052)	CS	1	Study State	StudyState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4608	\N	(3113,0053)	CS	1	Series State	SeriesState	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4609	\N	(3113,0055)	CS	1	Image State Text	ImageStateText	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4610	\N	(3113,0056)	CS	1	Series State Text	SeriesStateText	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4611	\N	(3113,0057)	CS	1	Study State Text	StudyStateText	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4612	\N	(3113,0060)	DT	1	Expiration	Expiration	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4613	\N	(3113,0069)	AT	1-n	Deleted Tags	DeletedTags	Applicare/RadStore/Version 1.0	GEM	\N	\N	\N
f	4216	\N	(3115,0001)	UT	1	Reference to pacs study	Reference to pacs study	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	GEM	\N	\N	\N
f	4614	\N	(3115,0002)	UT	1	Reference to pacs image	Reference to pacs image	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	GEM	\N	\N	\N
f	4615	\N	(3115,0003)	CS	1	Pacs examnotes flag	Pacs examnotes flag	http://www.gemedicalsystems.com/it_solutions/rad_pacs/	GEM	\N	\N	\N
f	4616	\N	(3117,0010)	DT	1	OrthoView Session Date/Time	OrthoView Session Date/Time	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4617	\N	(3117,0020)	PN	1	OrthoView Session Creator	OrthoView Session Creator	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4618	\N	(3117,0030)	CS	1	OrthoView Session Completion Flag	OrthoView Session Completion Flag	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4619	\N	(3117,0040)	SQ	1	OrthoView File Sequence	OrthoView File Sequence	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4620	\N	(3117,0050)	ST	1	OrthoView File Name	OrthoView File Name	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4621	\N	(3117,0060)	OB	1	OrthoView File Content	OrthoView File Content	http://www.gemedicalsystems.com/it_solutions/orthoview/2.1	GEM	\N	\N	\N
f	4622	\N	(3118,0010)	DT	1	BAM WallThickness Session Date/Time	BAM WallThickness Session Date/Time	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4623	\N	(3118,0020)	PN	1	BAM WallThickness Session Creator	BAM WallThickness Session Creator	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4624	\N	(3118,0030)	CS	1	BAM WallThickness Session Completion Flag	BAM WallThickness Session Completion Flag	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4625	\N	(3118,0040)	SQ	1	BAM WallThickness File Sequence	BAM WallThickness File Sequence	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4626	\N	(3118,0050)	ST	1	BAM WallThickness File Name	BAM WallThickness File Name	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4627	\N	(3118,0060)	OB	1	BAM WallThickness File Content	BAM WallThickness File Content	http://www.gemedicalsystems.com/it_solutions/bamwallthickness/1.0	GEM	\N	\N	\N
f	4628	\N	(3109,0010)	CS	1	Window Invert	WindowInvert	AMI ImageContext_01	GEM	\N	\N	\N
f	4629	\N	(3109,0020)	IS	1	Window Center	WindowCenter	AMI ImageContext_01	GEM	\N	\N	\N
f	4630	\N	(3109,0030)	IS	1	Window Width	WindowWidth	AMI ImageContext_01	GEM	\N	\N	\N
f	4631	\N	(3109,0040)	CS	1	Pixel Aspect Ratio Swap	PixelAspectRatioSwap	AMI ImageContext_01	GEM	\N	\N	\N
f	4632	\N	(3109,0050)	CS	1	Enable Averaging	EnableAveraging	AMI ImageContext_01	GEM	\N	\N	\N
f	4633	\N	(3109,0060)	CS	1	Quality	Quality	AMI ImageContext_01	GEM	\N	\N	\N
f	4634	\N	(3109,0070)	CS	1	Viewport Annotation Level	ViewportAnnotationLevel	AMI ImageContext_01	GEM	\N	\N	\N
f	4635	\N	(3109,0080)	CS	1	Show Image Annotation	ShowImageAnnotation	AMI ImageContext_01	GEM	\N	\N	\N
f	4636	\N	(3109,0090)	CS	1	Show Image Overlay	Show mageOverlay	AMI ImageContext_01	GEM	\N	\N	\N
f	4637	\N	(0051,0001)	LO	1	Group Name	GroupName	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4638	\N	(0051,0002)	LO	1	Function Name	FunctionName	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4639	\N	(0051,0003)	SL	1	Bias	Bias	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4640	\N	(0051,0004)	FL	1	Scale	Scale	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4641	\N	(0051,0005)	SL	1	Parameter Count	ParameterCount	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4642	\N	(0051,0006)	LT	1	Parameters	Parameters	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4643	\N	(0051,0007)	LO	1	Version	Version	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4644	\N	(0051,0008)	SL	1	Color Ramp Index	ColorRampIndex	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4645	\N	(0051,0009)	SL	1	Window Width	WindowWidth	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4646	\N	(0051,000a)	SL	1	Window Level	WindowLevel	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4647	\N	(0051,000b)	FL	1	B-Value	BValue	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4648	\N	(0051,000c)	SL	1	Wizard State Data Size	WizardStateDataSize	GEMS_FUNCTOOL_01	GEM	 in MRI, this has been used as VR LO Analysis Package :(	\N	\N
f	4649	\N	(0051,000d)	OB	1	Wizard State	WizardState	GEMS_FUNCTOOL_01	GEM	\N	\N	\N
f	4650	\N	(0019,0000)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4651	\N	(0019,0001)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4652	\N	(0019,0002)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4653	\N	(0019,0003)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4654	\N	(0019,0004)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4655	\N	(0019,0005)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4656	\N	(0019,0006)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4657	\N	(0019,0007)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4658	\N	(0019,0008)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4659	\N	(0019,0009)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4660	\N	(0019,000a)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4661	\N	(0019,000b)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4662	\N	(0019,000c)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4663	\N	(0019,000d)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4664	\N	(0019,000e)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4665	\N	(0019,000f)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4666	\N	(0019,0010)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4667	\N	(0019,0011)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4668	\N	(0019,0012)	TM	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4669	\N	(0019,0013)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4670	\N	(0019,0014)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4671	\N	(0019,0015)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4672	\N	(0019,0016)	IS	1-n	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4673	\N	(0019,0017)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4674	\N	(0019,0018)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4675	\N	(0019,0019)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4676	\N	(0019,001a)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4677	\N	(0019,001b)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4678	\N	(0019,001c)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4679	\N	(0019,001d)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4680	\N	(0019,001e)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4681	\N	(0019,001f)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4682	\N	(0019,0020)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4684	\N	(0019,0025)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4685	\N	(0019,0026)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4686	\N	(0019,0029)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4687	\N	(0019,002a)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4688	\N	(0019,002b)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4689	\N	(0019,002d)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4690	\N	(0019,002e)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4691	\N	(0019,002f)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4692	\N	(0019,0030)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4693	\N	(0019,0031)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4694	\N	(0019,0032)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4695	\N	(0019,0033)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4696	\N	(0019,0034)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4697	\N	(0019,0035)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4698	\N	(0019,0036)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4699	\N	(0019,0037)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4700	\N	(0019,0038)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4701	\N	(0019,0039)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4702	\N	(0019,003a)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4703	\N	(0019,003b)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4704	\N	(0019,003c)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4705	\N	(0019,003d)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4706	\N	(0019,003e)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4707	\N	(0019,003f)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4708	\N	(0019,0040)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4709	\N	(0019,0041)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4710	\N	(0019,0042)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4711	\N	(0019,0043)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4712	\N	(0019,0044)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4713	\N	(0019,0045)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4714	\N	(0019,0046)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4715	\N	(0019,0047)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4716	\N	(0019,0048)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4717	\N	(0019,0049)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4718	\N	(0019,004a)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4719	\N	(0019,004b)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4720	\N	(0019,004c)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4721	\N	(0019,004e)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4722	\N	(0019,004f)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4723	\N	(0019,0050)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4724	\N	(0019,0051)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4725	\N	(0019,0052)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4726	\N	(0019,0054)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4727	\N	(0019,0055)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4728	\N	(0019,0056)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4729	\N	(0019,0057)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4730	\N	(0019,0058)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4731	\N	(0019,0059)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4732	\N	(0019,005a)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4733	\N	(0019,005b)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4734	\N	(0019,005c)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4735	\N	(0019,005d)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4736	\N	(0019,005f)	UI	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4737	\N	(0019,0060)	UI	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4738	\N	(0019,0063)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4739	\N	(0019,0064)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4740	\N	(0019,0065)	UN	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4741	\N	(0019,0066)	DS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4742	\N	(0019,0067)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4743	\N	(0019,0068)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4744	\N	(0019,0069)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4745	\N	(0019,006a)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4746	\N	(0019,006b)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4747	\N	(0019,0070)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4748	\N	(0019,0071)	LO	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4749	\N	(0019,0072)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4750	\N	(0019,0073)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4751	\N	(0019,0074)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4752	\N	(0019,0075)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4753	\N	(0019,0078)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4754	\N	(0019,0079)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4755	\N	(0019,007a)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4756	\N	(0019,007b)	IS	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4757	\N	(0019,007c)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4758	\N	(0019,007d)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4759	\N	(0019,007e)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4760	\N	(0019,007f)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4761	\N	(0019,0080)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4762	\N	(0019,0081)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4763	\N	(0019,0082)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4764	\N	(0019,0083)	US	1	Unknown	Unknown	Harmony R1.0	HIT	\N	\N	\N
f	4765	\N	(0019,0000)	LO	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4766	\N	(0019,0001)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4767	\N	(0019,0002)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4768	\N	(0019,0003)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4769	\N	(0019,0004)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4770	\N	(0019,0005)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4771	\N	(0019,0006)	LO	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4772	\N	(0019,0007)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4773	\N	(0019,0008)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4774	\N	(0019,0009)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4775	\N	(0019,000a)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4776	\N	(0019,006a)	LO	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4777	\N	(0019,006c)	US	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4778	\N	(0019,006d)	US	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4779	\N	(0019,006e)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4780	\N	(0019,0074)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4781	\N	(0019,0076)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4782	\N	(0019,0078)	US	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4783	\N	(0019,0079)	US	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4784	\N	(0019,007a)	US	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4785	\N	(0019,0080)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4786	\N	(0019,0081)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4787	\N	(0019,0082)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4788	\N	(0019,0083)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4789	\N	(0019,0084)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4790	\N	(0019,0091)	UN	1	Unknown	Unknown	Harmony R1.0 C2	HIT	\N	\N	\N
f	4791	\N	(0019,0000)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4792	\N	(0019,0003)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4793	\N	(0019,0007)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4794	\N	(0019,000b)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4795	\N	(0019,0050)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4796	\N	(0019,0051)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4797	\N	(0019,0052)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4798	\N	(0019,0053)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4799	\N	(0019,005a)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4800	\N	(0019,005b)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4801	\N	(0019,005c)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4802	\N	(0019,005f)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4803	\N	(0019,0078)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4804	\N	(0019,0079)	PN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4805	\N	(0019,007a)	PN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4806	\N	(0019,007b)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4807	\N	(0019,007c)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4808	\N	(0019,007d)	CS	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4809	\N	(0019,007e)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4810	\N	(0019,007f)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4811	\N	(0019,0080)	IS	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4812	\N	(0019,0083)	IS	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4813	\N	(0019,0094)	IS	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4814	\N	(0019,0095)	IS	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4815	\N	(0019,0096)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4816	\N	(0019,0097)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4817	\N	(0019,0098)	IS	1-n	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4818	\N	(0019,00e4)	LO	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4819	\N	(0019,00e5)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4820	\N	(0019,00e6)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4821	\N	(0019,00e7)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4822	\N	(0019,00e8)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4823	\N	(0019,00e9)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4824	\N	(0019,00ea)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4825	\N	(0019,00eb)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4826	\N	(0019,00ec)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4827	\N	(0019,00ed)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4828	\N	(0019,00ee)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4829	\N	(0019,00ef)	US	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4830	\N	(0019,00f0)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4831	\N	(0019,00f1)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4832	\N	(0019,00f2)	UN	1	Unknown	Unknown	Harmony R1.0 C3	HIT	\N	\N	\N
f	4833	\N	(0019,0079)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4834	\N	(0019,007c)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4835	\N	(0019,007d)	UN	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4836	\N	(0019,0081)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4837	\N	(0019,0082)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4838	\N	(0019,0083)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4839	\N	(0019,0084)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4840	\N	(0019,0085)	UN	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4841	\N	(0019,0086)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4842	\N	(0019,0087)	UN	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4843	\N	(0019,0088)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4844	\N	(0019,0089)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4845	\N	(0019,008a)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4846	\N	(0019,008c)	IS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4847	\N	(0019,008d)	DS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4848	\N	(0019,008f)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4849	\N	(0019,0090)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4850	\N	(0019,0091)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4851	\N	(0019,0092)	US	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4852	\N	(0019,0093)	DS	2	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4853	\N	(0019,0094)	LO	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4854	\N	(0019,0095)	LO	1-n	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4855	\N	(0019,0096)	DS	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4856	\N	(0019,0097)	IS	2	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	4857	\N	(0019,0099)	LO	1	Unknown	Unknown	Harmony R2.0	HIT	\N	\N	\N
f	938	\N	(0029,0070)	IS	1	Unknown	Unknown	ISG shadow	ISG	\N	\N	\N
f	939	\N	(0029,0080)	IS	1	Unknown	Unknown	ISG shadow	ISG	\N	\N	\N
f	940	\N	(0029,0090)	IS	1	Unknown	Unknown	ISG shadow	ISG	\N	\N	\N
f	2588	\N	(0029,0013)	UL	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2589	\N	(0029,0014)	UL	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2590	\N	(0029,0017)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2591	\N	(0029,0018)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2592	\N	(0029,0019)	UL	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2593	\N	(0029,001a)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2594	\N	(0029,001b)	UL	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2595	\N	(0029,001c)	UL	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2596	\N	(0029,001d)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2597	\N	(0029,001e)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2598	\N	(0029,0021)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2599	\N	(0029,0022)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2600	\N	(0029,0023)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2601	\N	(0029,0024)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2602	\N	(0029,0025)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2603	\N	(0029,0027)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2604	\N	(0029,0028)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2605	\N	(0029,0029)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2606	\N	(0029,0030)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4858	\N	(0029,0031)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4859	\N	(0029,0046)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4860	\N	(0029,0047)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2607	\N	(0029,0052)	US	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2608	\N	(0029,0053)	LT	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2609	\N	(0029,0054)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2610	\N	(0029,0055)	LT	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2611	\N	(0029,0056)	LT	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2612	\N	(0029,0057)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4861	\N	(0029,0073)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4862	\N	(0029,0074)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4863	\N	(0029,0077)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4864	\N	(0029,0078)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4865	\N	(0029,0088)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4866	\N	(0029,0089)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4867	\N	(0029,0090)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	4868	\N	(0029,0091)	UN	1	Unknown	Unknown	Silhouette V1.0	ISG	\N	\N	\N
f	2541	\N	(0029,0000)	UI	1	Unknown	Unknown	Silhouette Graphics Export V1.0	ISG	\N	\N	\N
f	2542	\N	(0029,0011)	IS	1	Line Name	LineName	Silhouette Line V1.0	ISG	\N	\N	\N
f	2543	\N	(0029,0012)	LT	1	Line Name Font	LineNameFont	Silhouette Line V1.0	ISG	\N	\N	\N
f	2544	\N	(0029,0013)	UL	1	Line Name Display	LineNameDisplay	Silhouette Line V1.0	ISG	\N	\N	\N
f	2545	\N	(0029,0014)	LT	1	Line Normal Color	LineNormalColor	Silhouette Line V1.0	ISG	\N	\N	\N
f	2546	\N	(0029,0015)	UL	1	Line Type	LineType	Silhouette Line V1.0	ISG	\N	\N	\N
f	2547	\N	(0029,0016)	UL	1	Line Thickness	LineThickness	Silhouette Line V1.0	ISG	\N	\N	\N
f	2548	\N	(0029,0017)	UL	1	Line Style	LineStyle	Silhouette Line V1.0	ISG	\N	\N	\N
f	2549	\N	(0029,0018)	UL	1	Line Dash Length	LineDashLength	Silhouette Line V1.0	ISG	\N	\N	\N
f	2550	\N	(0029,0019)	UL	1	Line Interactivity	LineInteractivity	Silhouette Line V1.0	ISG	\N	\N	\N
f	2551	\N	(0029,0020)	LT	1	Line Measurement Color	LineMeasurementColor	Silhouette Line V1.0	ISG	\N	\N	\N
f	2552	\N	(0029,0021)	LT	1	Line Measurement Font	LineMeasurementFont	Silhouette Line V1.0	ISG	\N	\N	\N
f	2553	\N	(0029,0022)	UL	1	Line Measurement Dash Length	LineMeasurementDashLength	Silhouette Line V1.0	ISG	\N	\N	\N
f	2554	\N	(0029,0023)	UL	1	Line Point Space	LinePointSpace	Silhouette Line V1.0	ISG	\N	\N	\N
f	2555	\N	(0029,0024)	FD	1	Line Points	LinePoints	Silhouette Line V1.0	ISG	\N	\N	\N
f	2556	\N	(0029,0025)	UL	1	Line Control Point Size	LineControlPointSize	Silhouette Line V1.0	ISG	\N	\N	\N
f	2557	\N	(0029,0026)	UL	1	Line Control Point Space	LineControlPointSpace	Silhouette Line V1.0	ISG	\N	\N	\N
f	2558	\N	(0029,0027)	FD	1	Line Control Points	LineControlPoints	Silhouette Line V1.0	ISG	\N	\N	\N
f	2559	\N	(0029,0028)	LT	1	Line Label	LineLabel	Silhouette Line V1.0	ISG	\N	\N	\N
f	2560	\N	(0029,0029)	UL	1	Line Don't Save	LineDontSave	Silhouette Line V1.0	ISG	\N	\N	\N
f	2585	\N	(0029,0041)	SQ	1	Unknown	Unknown	Silhouette Sequence Ids V1.0	ISG	\N	\N	\N
f	2586	\N	(0029,0042)	SQ	1	Unknown	Unknown	Silhouette Sequence Ids V1.0	ISG	\N	\N	\N
f	2587	\N	(0029,0043)	SQ	1	Unknown	Unknown	Silhouette Sequence Ids V1.0	ISG	\N	\N	\N
f	2506	\N	(0029,0011)	IS	1	Annotation Name	AnnotationName	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2507	\N	(0029,0012)	LT	1	Annotation Font	AnnotationFont	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2508	\N	(0029,0013)	LT	1	Annotation Text Foreground Color	AnnotationTextForegroundColor	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2509	\N	(0029,0014)	LT	1	Annotation Text Background Color	AnnotationTextBackgroundColor	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2510	\N	(0029,0015)	UL	1	Annotation Text Backing Mode	AnnotationTextBackingMode	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2511	\N	(0029,0016)	UL	1	Annotation Text Justification	AnnotationTextJustification	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2512	\N	(0029,0017)	UL	1	Annotation Text Location	AnnotationTextLocation	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2513	\N	(0029,0018)	LT	1	Annotation Text String	AnnotationTextString	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2514	\N	(0029,0019)	UL	1	Annotation Text Attach Mode	AnnotationTextAttachMode	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2515	\N	(0029,0020)	UL	1	Annotation Text Cursor Mode	AnnotationTextCursorMode	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2516	\N	(0029,0021)	UL	1	Annotation Text Shadow Offset X	AnnotationTextShadowOffsetX	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2517	\N	(0029,0022)	UL	1	Annotation Text Shadow Offset Y	AnnotationTextShadowOffsetY	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2518	\N	(0029,0023)	LT	1	Annotation Line Color	AnnotationLineColor	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2519	\N	(0029,0024)	UL	1	Annotation Line Thickness	AnnotationLineThickness	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2520	\N	(0029,0025)	UL	1	Annotation Line Type	AnnotationLineType	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2521	\N	(0029,0026)	UL	1	Annotation Line Style	AnnotationLineStyle	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2522	\N	(0029,0027)	UL	1	Annotation Line Dash Length	AnnotationLineDashLength	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2523	\N	(0029,0028)	UL	1	Annotation Line Attach Mode	AnnotationLineAttachMode	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2524	\N	(0029,0029)	UL	1	Annotation Line Point Count	AnnotationLinePointCount	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2525	\N	(0029,0030)	FD	1	Annotation Line Points	AnnotationLinePoints	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2526	\N	(0029,0031)	UL	1	Annotation Line Control Size	AnnotationLineControlSize	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2527	\N	(0029,0032)	LT	1	Annotation Marker Color	AnnotationMarkerColor	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2528	\N	(0029,0033)	UL	1	Annotation Marker Type	AnnotationMarkerType	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2529	\N	(0029,0034)	UL	1	Annotation Marker Size	AnnotationMarkerSize	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2530	\N	(0029,0035)	FD	1	Annotation Marker Location	AnnotationMarkerLocation	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2531	\N	(0029,0036)	UL	1	Annotation Marker Attach Mode	AnnotationMarkerAttachMode	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2532	\N	(0029,0037)	LT	1	Annotation Geom Color	AnnotationGeomColor	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2533	\N	(0029,0038)	UL	1	Annotation Geom Thickness	AnnotationGeomThickness	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2534	\N	(0029,0039)	UL	1	Annotation Geom Line Style	AnnotationGeomLineStyle	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2535	\N	(0029,0040)	UL	1	Annotation Geom Dash Length	AnnotationGeomDashLength	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2536	\N	(0029,0041)	UL	1	Annotation Geom Fill Pattern	AnnotationGeomFillPattern	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2537	\N	(0029,0042)	UL	1	Annotation Interactivity	AnnotationInteractivity	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2538	\N	(0029,0043)	FD	1	Annotation Arrow Length	AnnotationArrowLength	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2539	\N	(0029,0044)	FD	1	Annotation Arrow Angle	AnnotationArrowAngle	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2540	\N	(0029,0045)	UL	1	Annotation Don't Save	AnnotationDontSave	Silhouette Annot V1.0	ISG	\N	\N	\N
f	2561	\N	(0029,0011)	IS	1	ROI Name	ROIName	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2562	\N	(0029,0012)	LT	1	ROI Name Font	ROINameFont	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2563	\N	(0029,0013)	LT	1	ROI Normal Color	ROINormalColor	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2564	\N	(0029,0014)	UL	1	ROI Fill Pattern	ROIFillPattern	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2565	\N	(0029,0015)	UL	1	ROI Bp Seg	ROIBpSeg	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2566	\N	(0029,0016)	UN	1	ROI Bp Seg Pairs	ROIBpSegPairs	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2567	\N	(0029,0017)	UL	1	ROI Seed Space	ROISeedSpace	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2568	\N	(0029,0018)	UN	1	ROI Seeds	ROISeeds	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2569	\N	(0029,0019)	UL	1	ROI Line Thickness	ROILineThickness	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2570	\N	(0029,0020)	UL	1	ROI Line Style	ROILineStyle	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2571	\N	(0029,0021)	UL	1	ROI Line Dash Length	ROILineDashLength	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2572	\N	(0029,0022)	UL	1	ROI Interactivity	ROIInteractivity	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2573	\N	(0029,0023)	UL	1	ROI Name Position	ROINamePosition	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2574	\N	(0029,0024)	UL	1	ROI Name Display	ROINameDisplay	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2575	\N	(0029,0025)	LT	1	ROI Label	ROILabel	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2576	\N	(0029,0026)	UL	1	ROI Shape	ROIShape	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2577	\N	(0029,0027)	FD	1	ROI Shape Tilt	ROIShapeTilt	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2578	\N	(0029,0028)	UL	1	ROI Shape Points Count	ROIShapePointsCount	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2579	\N	(0029,0029)	UL	1	ROI Shape Points Space	ROIShapePointsSpace	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2580	\N	(0029,0030)	FD	1	ROI Shape Points	ROIShapePoints	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2581	\N	(0029,0031)	UL	1	ROI Shape Control Points Count	ROIShapeControlPointsCount	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2582	\N	(0029,0032)	UL	1	ROI Shape Control Points Space	ROIShapeControlPointsSpace	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2583	\N	(0029,0033)	FD	1	ROI Shape Control Points	ROIShapeControlPoints	Silhouette ROI V1.0	ISG	\N	\N	\N
f	2584	\N	(0029,0034)	UL	1	ROI Don't Save	ROIDontSave	Silhouette ROI V1.0	ISG	\N	\N	\N
f	30	\N	(0003,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	31	\N	(0005,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	32	\N	(0009,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	942	\N	(0009,0000)	OB	1	Unknown	Unknown	MERGE TECHNOLOGIES, INC.	MRG	\N	\N	\N
f	4869	\N	(0011,0000)	OB	1	Hx Questionnaire	HxQuestionnaire	Hologic	HOL	\N	\N	\N
f	231	\N	(0025,00a0)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	4870	\N	(0011,0000)	OB	1	Hx Questionnaire	HxQuestionnaire	HOLOGIC	HOL	\N	\N	\N
f	4871	\N	(0013,0000)	LO	1	IVA Results Flag	IVAResultsFlag	Hologic	HOL	\N	\N	\N
f	4872	\N	(0013,0000)	LO	1	IVA Results Flag	IVAResultsFlag	HOLOGIC	HOL	\N	\N	\N
f	4873	\N	(0019,0000)	UT	1	Report Data	ReportData	Hologic	HOL	\N	\N	\N
f	4874	\N	(0019,0000)	UT	1	Report Data	ReportData	HOLOGIC	HOL	\N	\N	\N
f	33	\N	(0019,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	1	\N	(0019,0010)	ST	1	CR Image Params Common	CRImageParamsCommon	1.2.840.113681	DUP	\N	\N	\N
f	2	\N	(0019,0011)	ST	1	CR Image IP Params Single	CRImageIPParamsSingle	1.2.840.113681	DUP	\N	\N	\N
f	3	\N	(0019,0012)	ST	1	CR Image IP Params Left	CRImageIPParamsLeft	1.2.840.113681	DUP	\N	\N	\N
f	4	\N	(0019,0013)	ST	1	CR Image IP Params Right	CRImageIPParamsRight	1.2.840.113681	DUP	\N	\N	\N
f	4875	\N	(0019,0001)	IS	1-n	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4876	\N	(0019,0002)	IS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4877	\N	(0019,0003)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4878	\N	(0019,0004)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4879	\N	(0019,0005)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4880	\N	(0019,0006)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4881	\N	(0019,0007)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4882	\N	(0019,0008)	DS	1	Unknown	Unknown	LODOX_STATSCAN	LDX	\N	\N	\N
f	4883	\N	(0021,0001)	UI	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change List Creator ID	SCH	\N	\N	\N
f	4884	\N	(0021,0002)	SQ	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change List Creator ID	SCH	\N	\N	\N
f	4885	\N	(0021,0001)	UI	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Note List Creator ID	SCH	\N	\N	\N
f	4886	\N	(0021,0002)	SQ	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Note List Creator ID	SCH	\N	\N	\N
f	4887	\N	(0021,0001)	UI	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change Item Creator ID	SCH	\N	\N	\N
f	4888	\N	(0021,0002)	US	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change Item Creator ID	SCH	\N	\N	\N
f	4889	\N	(0021,0003)	DT	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change Item Creator ID	SCH	\N	\N	\N
f	4890	\N	(0021,0004)	PN	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change Item Creator ID	SCH	\N	\N	\N
f	4891	\N	(0021,0005)	OB	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Change Item Creator ID	SCH	\N	\N	\N
f	4892	\N	(0021,0001)	LT	1	Image Analysis Data in XML	ImageAnalysisDataInXML	Hologic	HOL	\N	\N	\N
f	4893	\N	(0021,0001)	LT	1	Image Analysis Data in XML	ImageAnalysisDataInXML	HOLOGIC	HOL	\N	\N	\N
f	4894	\N	(0023,0000)	LO	1	Encoding Scheme Version	EncodingSchemeVersion	Hologic	HOL	\N	\N	\N
f	4895	\N	(0023,0000)	LO	1	Encoding Scheme Version	EncodingSchemeVersion	HOLOGIC	HOL	\N	\N	\N
f	4896	\N	(0023,0001)	LO	1	P File Name	PFileName	Hologic	HOL	\N	\N	\N
f	4897	\N	(0023,0001)	LO	1	P File Name	PFileName	HOLOGIC	HOL	\N	\N	\N
f	4898	\N	(0023,0002)	OB	1	P File Data	PFileData	Hologic	HOL	\N	\N	\N
f	4899	\N	(0023,0002)	OB	1	P File Data	PFileData	HOLOGIC	HOL	\N	\N	\N
f	4900	\N	(0023,0003)	UL	1	P File Length	PFileLength	Hologic	HOL	\N	\N	\N
f	4901	\N	(0023,0003)	UL	1	P File Length	PFileLength	HOLOGIC	HOL	\N	\N	\N
f	4902	\N	(0023,0004)	OB	1	R File Data	RFileData	Hologic	HOL	\N	\N	\N
f	4903	\N	(0023,0004)	OB	1	R File Data	RFileData	HOLOGIC	HOL	\N	\N	\N
f	4904	\N	(0023,0005)	UL	1	R File Length	RFileLength	Hologic	HOL	\N	\N	\N
f	4905	\N	(0023,0005)	UL	1	R File Length	RFileLength	HOLOGIC	HOL	\N	\N	\N
f	4906	\N	(0029,0000)	OB	1	Graph Bitmap Data	GraphBitmapData	Hologic	HOL	\N	\N	\N
f	4907	\N	(0029,0000)	OB	1	Graph Bitmap Data	GraphBitmapData	HOLOGIC	HOL	\N	\N	\N
f	4908	\N	(0029,0001)	UL	1	Graph Bitmap Size	GraphBitmapSize	Hologic	HOL	\N	\N	\N
f	4909	\N	(0029,0001)	UL	1	Graph Bitmap Size	GraphBitmapSize	HOLOGIC	HOL	\N	\N	\N
f	34	\N	(0029,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	4910	\N	(0029,0001)	UL	1	Unknown	Unknown	SCHICK TECHNOLOGIES - Image Security Creator ID	SCH	\N	\N	\N
f	4911	\N	(0029,0020)	LT	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4912	\N	(0029,0021)	ST	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4913	\N	(0029,0022)	ST	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4914	\N	(0029,0023)	ST	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4915	\N	(0029,0024)	LO	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4916	\N	(0029,0025)	LO	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4917	\N	(0029,0026)	LO	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4918	\N	(0029,0027)	LO	1	Unknown	Unknown	2.16.840.1.114059.1.1.6.1.50.1	DEX	\N	\N	\N
f	4919	\N	(0073,0001)	ST	1	Unknown	Unknown	STENTOR	STE	\N	\N	\N
f	4920	\N	(0073,0002)	ST	1	Unknown	Unknown	STENTOR	STE	\N	\N	\N
f	4921	\N	(0073,0003)	ST	1	Unknown	Unknown	STENTOR	STE	\N	\N	\N
f	4922	\N	(0073,0004)	ST	1	Unknown	Unknown	STENTOR	STE	\N	\N	\N
f	4923	\N	(0073,0006)	LO	1	Unknown	Unknown	STENTOR	STE	\N	\N	\N
f	5	\N	(0087,0010)	CS	1	Media Type	MediaType	1.2.840.113708.794.1.1.2.0	ARM	\N	\N	\N
f	6	\N	(0087,0020)	CS	1	Media Location	MediaLocation	1.2.840.113708.794.1.1.2.0	ARM	\N	\N	\N
f	7	\N	(0087,0050)	IS	1	Estimated Retrieve Time	EstimatedRetrieveTime	1.2.840.113708.794.1.1.2.0	ARM	\N	\N	\N
f	35	\N	(1369,0000)	US	1-n	Unknown	Unknown	AEGIS_DICOM_2.00	AEG	\N	\N	\N
f	160	\N	(0009,0004)	SH	1	Image Control Unit	ImageControlUnit	FDMS 1.0	FUJ	\N	\N	\N
f	161	\N	(0009,0005)	OW	1	Image UID	ImageUID	FDMS 1.0	FUJ	\N	\N	\N
f	162	\N	(0009,0006)	OW	1	Route Image UID	RouteImageUID	FDMS 1.0	FUJ	\N	\N	\N
f	163	\N	(0009,0008)	UL	1	Image Display Information Version Number	ImageDisplayInformationVersionNumber	FDMS 1.0	FUJ	\N	\N	\N
f	164	\N	(0009,0009)	UL	1	Patient Information Version Number	PatientInformationVersionNumber	FDMS 1.0	FUJ	\N	\N	\N
f	4924	\N	(0009,000c)	OW	1	Film UID	FilmUID	FDMS 1.0	FUJ	\N	\N	\N
f	166	\N	(0009,0010)	CS	1	Exposure Unit Type Code	ExposureUnitTypeCode	FDMS 1.0	FUJ	\N	\N	\N
f	167	\N	(0009,0080)	LO	1	Kanji Hospital Name	KanjiHospitalName	FDMS 1.0	FUJ	\N	\N	\N
f	168	\N	(0009,0090)	ST	1	Distribution Code	DistributionCode	FDMS 1.0	FUJ	\N	\N	\N
f	169	\N	(0009,0092)	SH	1	Kanji Department Name	KanjiDepartmentName	FDMS 1.0	FUJ	\N	\N	\N
f	4925	\N	(0009,00f0)	CS	1	Blackening Process Flag	BlackeningProcessFlag	FDMS 1.0	FUJ	\N	\N	\N
f	4926	\N	(0009,00f1)	LO	1	Processing Information Flag	ProcessingInformationFlag	FDMS 1.0	FUJ	\N	\N	\N
f	171	\N	(0019,0015)	LO	1	Kanji Body Part for Exposure	KanjiBodyPartForExposure	FDMS 1.0	FUJ	\N	\N	\N
f	4927	\N	(0019,0030)	LO	1	Menu Character String	MenuCharacterString	FDMS 1.0	FUJ	\N	\N	\N
f	172	\N	(0019,0032)	LO	1	Kanji Menu Name	KanjiMenuName	FDMS 1.0	FUJ	\N	\N	\N
f	173	\N	(0019,0040)	CS	1	Image Processing Type	ImageProcessingType	FDMS 1.0	FUJ	\N	\N	\N
f	174	\N	(0019,0050)	CS	1	EDR Mode	EDRMode	FDMS 1.0	FUJ	\N	\N	\N
f	175	\N	(0019,0060)	SH	1	Radiographer's Code	RadiographersCode	FDMS 1.0	FUJ	\N	\N	\N
f	176	\N	(0019,0070)	IS	1	Split Exposure Format	SplitExposureFormat	FDMS 1.0	FUJ	\N	\N	\N
f	177	\N	(0019,0071)	IS	1	Number of Split Exposure Frames	NumberOfSplitExposureFrames	FDMS 1.0	FUJ	\N	\N	\N
f	178	\N	(0019,0080)	IS	1	Reading Position Specification	ReadingPositionSpecification	FDMS 1.0	FUJ	\N	\N	\N
f	179	\N	(0019,0081)	IS	1	Reading Sensitivity Center	ReadingSensitivityCenter	FDMS 1.0	FUJ	\N	\N	\N
f	180	\N	(0019,0090)	SH	1	Film Annotation Character String 1	FilmAnnotationCharacterString1	FDMS 1.0	FUJ	\N	\N	\N
f	181	\N	(0019,0091)	SH	1	Film Annotation Character String 2	FilmAnnotationCharacterString2	FDMS 1.0	FUJ	\N	\N	\N
f	182	\N	(0021,0010)	CS	1	FCR Image ID	FCRImageID	FDMS 1.0	FUJ	\N	\N	\N
f	183	\N	(0021,0030)	CS	1	Set Number	SetNumber	FDMS 1.0	FUJ	\N	\N	\N
f	184	\N	(0021,0040)	IS	1	Image Number in the Set	ImageNumberInTheSet	FDMS 1.0	FUJ	\N	\N	\N
f	185	\N	(0021,0050)	CS	1	Pair Processing Information	PairProcessingInformation	FDMS 1.0	FUJ	\N	\N	\N
f	4928	\N	(0021,0070)	IS	1	Film Number within the Series	FilmNumberWithinTheSeries	FDMS 1.0	FUJ	\N	\N	\N
f	186	\N	(0021,0080)	CS	1	Equipment Type-Specific Information	EquipmentTypeSpecificInformation	FDMS 1.0	FUJ	\N	\N	\N
f	4929	\N	(0021,0090)	CS	1	LUT Number	LUTNumber	FDMS 1.0	FUJ	\N	\N	\N
f	187	\N	(0023,0010)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	188	\N	(0023,0020)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	189	\N	(0023,0030)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	190	\N	(0025,0010)	US	1	Relative Light Emission Amount Sk	RelativeLightEmissionAmountSk	FDMS 1.0	FUJ	\N	\N	\N
f	191	\N	(0025,0011)	US	1	Term of Correction for Each IP Type St	TermOfCorrectionForEachIPTypeSt	FDMS 1.0	FUJ	\N	\N	\N
f	192	\N	(0025,0012)	US	1	Reading Gain Gp	ReadingGainGp	FDMS 1.0	FUJ	\N	\N	\N
f	193	\N	(0025,0013)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	194	\N	(0025,0015)	CS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	195	\N	(0025,0020)	US	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	196	\N	(0025,0021)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	197	\N	(0025,0030)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	197	\N	(0025,0030)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	198	\N	(0025,0031)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	199	\N	(0025,0032)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	200	\N	(0025,0033)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	201	\N	(0025,0034)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	202	\N	(0025,0040)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	203	\N	(0025,0041)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	204	\N	(0025,0042)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	204	\N	(0025,0042)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	205	\N	(0025,0043)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	206	\N	(0025,0050)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	207	\N	(0025,0051)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	208	\N	(0025,0052)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	209	\N	(0025,0053)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	210	\N	(0025,0060)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	211	\N	(0025,0061)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	212	\N	(0025,0062)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	213	\N	(0025,0063)	CS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	214	\N	(0025,0070)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	215	\N	(0025,0071)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	216	\N	(0025,0072)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	216	\N	(0025,0072)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	217	\N	(0025,0073)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	218	\N	(0025,0074)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	219	\N	(0025,0080)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	220	\N	(0025,0081)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	220	\N	(0025,0081)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	220	\N	(0025,0081)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	221	\N	(0025,0082)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	221	\N	(0025,0082)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	221	\N	(0025,0082)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	222	\N	(0025,0083)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	222	\N	(0025,0083)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	223	\N	(0025,0084)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	223	\N	(0025,0084)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	223	\N	(0025,0084)	US	6	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	224	\N	(0025,0090)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	225	\N	(0025,0091)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	226	\N	(0025,0092)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	227	\N	(0025,0093)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	228	\N	(0025,0094)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	229	\N	(0025,0095)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	230	\N	(0025,0096)	CS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	231	\N	(0025,00a0)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	231	\N	(0025,00a0)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	232	\N	(0025,00a1)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	232	\N	(0025,00a1)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	233	\N	(0025,00a2)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	233	\N	(0025,00a2)	US	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	234	\N	(0025,00a3)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	234	\N	(0025,00a3)	SS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	235	\N	(0027,0010)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	236	\N	(0027,0020)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	237	\N	(0027,0030)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	238	\N	(0027,0040)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	239	\N	(0027,0050)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	240	\N	(0027,0060)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	241	\N	(0027,0070)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	242	\N	(0027,0080)	SQ	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	243	\N	(0027,00a0)	IS	1	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	244	\N	(0027,00a1)	CS	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	244	\N	(0027,00a1)	CS	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	245	\N	(0027,00a2)	CS	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	245	\N	(0027,00a2)	CS	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	245	\N	(0027,00a2)	CS	2	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	246	\N	(0027,00a3)	SS	1-n	Unknown	Unknown	FDMS 1.0	FUJ	\N	\N	\N
f	247	\N	(0029,0020)	CS	1	Image Scanning Direction	ImageScanningDirection	FDMS 1.0	FUJ	\N	\N	\N
f	4930	\N	(0029,0025)	CS	1	Image Rotation/Reversal Information	ImageRotationReversalInformation	FDMS 1.0	FUJ	\N	\N	\N
f	248	\N	(0029,0030)	CS	1	Extended Reading Size Value	ExtendedReadingSizeValue	FDMS 1.0	FUJ	\N	\N	\N
f	249	\N	(0029,0034)	US	1	Mag./Reduc. Ratio	MagReducRatio	FDMS 1.0	FUJ	\N	\N	\N
f	250	\N	(0029,0044)	CS	1	Line Density Code	LineDensityCode	FDMS 1.0	FUJ	\N	\N	\N
f	251	\N	(0029,0050)	CS	1	Data Compression Code	DataCompressionCode	FDMS 1.0	FUJ	\N	\N	\N
f	4931	\N	(0032,0032)	PN	1	Requesting Physician	RequestingPhysician	FDMS 1.0	FUJ	\N	\N	\N
f	4932	\N	(0032,0033)	LO	1	Requesting Service	RequestingService	FDMS 1.0	FUJ	\N	\N	\N
f	4933	\N	(2011,0000)	CS	1	Trim Density	TrimDensity	FDMS 1.0	FUJ	\N	\N	\N
f	4934	\N	(2011,0001)	IS	1	Trim Width	TrimWidth	FDMS 1.0	FUJ	\N	\N	\N
f	4935	\N	(2011,0002)	CS	1	Image Mag./Reduc. Range	ImageMagReducRatio	FDMS 1.0	FUJ	\N	\N	\N
f	4936	\N	(2011,0010)	CS	1	Image Display Format	ImageDisplayFormat	FDMS 1.0	FUJ	\N	\N	\N
f	252	\N	(2011,0011)	CS	1	Image Position Specifying Flag	ImagePositionSpecifyingFlag	FDMS 1.0	FUJ	\N	\N	\N
f	4937	\N	(2011,0020)	OW	1	Interpolation A-VRS System Format	InterpolationAVRSSystemFormat	FDMS 1.0	FUJ	\N	\N	\N
f	4938	\N	(50f1,0006)	CS	1	Energy Subtraction Parameter	EnergySubtractionParameter	FDMS 1.0	FUJ	\N	\N	\N
f	4939	\N	(50f1,0007)	CS	1	Subtraction Registration Result	SubtractionRegistrationResult	FDMS 1.0	FUJ	\N	\N	\N
f	4940	\N	(50f1,0008)	CS	1	Energy Subtraction Parameter 2	EnergySubtractionParameter2	FDMS 1.0	FUJ	\N	\N	\N
f	4941	\N	(50f1,0009)	SL	1	Afin Conversion Coefficient	AfinConversionCoefficient	FDMS 1.0	FUJ	\N	\N	\N
f	4942	\N	(50f1,000a)	LO	1	FNC Parameters	FNCParameters	FDMS 1.0	FUJ	\N	\N	\N
f	4943	\N	(50f1,0010)	CS	1	Film Output Format	FilmOutputFormat	FDMS 1.0	FUJ	\N	\N	\N
f	4944	\N	(50f1,0020)	CS	1	Image Processing Modification Flag	ImageProcessingModificationFlag	FDMS 1.0	FUJ	\N	\N	\N
f	4945	\N	(0019,0010)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4946	\N	(0019,0013)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4947	\N	(0019,0015)	DS	2	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4948	\N	(0019,0016)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4949	\N	(0019,0017)	DS	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4950	\N	(0019,0018)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4951	\N	(0019,0019)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4952	\N	(0019,001a)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4953	\N	(0019,001b)	LO	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4954	\N	(0019,001c)	IS	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4955	\N	(0019,001e)	IS	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4956	\N	(0019,001f)	UN	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4957	\N	(0019,0021)	IS	1	Unknown	Unknown	Canon Inc.	CAN	\N	\N	\N
f	4958	\N	(0019,0002)	IS	1	ADAC Pegasys File Size	ADACPegasysFileSize	ADAC_IMG	ADAC	\N	\N	\N
f	4959	\N	(0019,0021)	US	1	Number of ADAC Headers	NumberOfADACHeaders	ADAC_IMG	ADAC	\N	\N	\N
f	4960	\N	(0019,0041)	IS	1-n	ADAC Header/Image Size	ADACHeaderImageSize	ADAC_IMG	ADAC	\N	\N	\N
f	4961	\N	(0019,0061)	OB	1	ADAC Pegasys Headers	ADACPegasysHeaders	ADAC_IMG	ADAC	\N	\N	\N
f	4962	\N	(0009,0001)	SH	1	Request number	RequestNumber	SECTRA_Ident_01	SEC	\N	\N	\N
f	4963	\N	(0009,0002)	SH	1	Examination number	ExaminationNumber	SECTRA_Ident_01	SEC	\N	\N	\N
f	4964	\N	(0009,0004)	LO	1	Series Identifier	SeriesIdentifier	SECTRA_Ident_01	SEC	\N	\N	\N
f	4965	\N	(0009,0005)	LO	1	Series Order	SeriesOrder	SECTRA_Ident_01	SEC	\N	\N	\N
f	4966	\N	(0009,0006)	LO	1	File Name	FileName	SECTRA_Ident_01	SEC	\N	\N	\N
f	4967	\N	(0009,0007)	LO	1	Image Data ID	ImageDataID	SECTRA_Ident_01	SEC	\N	\N	\N
f	4968	\N	(0029,0001)	OB	1	Image info	ImageInfo	SECTRA_ImageInfo_01	SEC	\N	\N	\N
f	4969	\N	(0029,0002)	CS	1	Marking	Marking	SECTRA_ImageInfo_01	SEC	\N	\N	\N
f	4970	\N	(0029,0003)	LO	1	No decompression	NoDecompression	SECTRA_ImageInfo_01	SEC	\N	\N	\N
f	4971	\N	(0029,0004)	OB	1	Image info new	ImageInfoNew	SECTRA_ImageInfo_01	SEC	\N	\N	\N
f	4972	\N	(6001,0001)	LO	1	Sectra Overlay	SectraOverlay	SECTRA_OverlayInfo_01	SEC	\N	\N	\N
f	4973	\N	(0009,0000)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4974	\N	(0009,0001)	UN	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4975	\N	(0009,0002)	UN	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4976	\N	(0009,0003)	LO	1-n	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4977	\N	(0009,0004)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4978	\N	(0009,0005)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4979	\N	(0009,0007)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4980	\N	(0009,0008)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4981	\N	(0009,0009)	LO	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4982	\N	(0009,0010)	UN	1	Unknown	Unknown	BioPri	BIO	\N	\N	\N
f	4983	\N	(0029,0013)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4984	\N	(0029,0014)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4985	\N	(0029,0017)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4986	\N	(0029,0018)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4987	\N	(0029,0019)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4988	\N	(0029,001a)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4989	\N	(0029,001b)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4990	\N	(0029,001c)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4991	\N	(0029,001d)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4992	\N	(0029,001e)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4993	\N	(0029,0027)	US	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4994	\N	(0029,0028)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4995	\N	(0029,0030)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4996	\N	(0029,0032)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4997	\N	(0029,0034)	UN	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4998	\N	(0029,0035)	CS	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	4999	\N	(0029,0036)	US	1	Unknown	Unknown	Silhouette VRS 3.0	ISG	\N	\N	\N
f	5000	\N	(0011,0001)	LT	1	Encrypted Instance Creator ID	EncryptedInstanceCreatorID	Hipaa Private Creator	HOL	\N	\N	\N
f	5001	\N	(0011,0002)	LT	1	Encrypted SOP Instance UID	EncryptedSOPInstanceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5002	\N	(0011,0003)	LT	1	Encrypted Accession Number	EncryptedAccessionNumber	Hipaa Private Creator	HOL	\N	\N	\N
f	5003	\N	(0011,0004)	LT	1	Encrypted Institution Name	EncryptedInstitutionName	Hipaa Private Creator	HOL	\N	\N	\N
f	5004	\N	(0011,0005)	LT	1	Encrypted Institution Address	EncryptedInstitutionAddress	Hipaa Private Creator	HOL	\N	\N	\N
f	5005	\N	(0011,0006)	LT	1	Encrypted Referring Physician's Name	EncryptedReferringPhysicianName	Hipaa Private Creator	HOL	\N	\N	\N
f	5006	\N	(0011,0007)	LT	1	Encrypted Referring Physician's Address	EncryptedReferringPhysicianAddress	Hipaa Private Creator	HOL	\N	\N	\N
f	5007	\N	(0011,0008)	LT	1	Encrypted Station Name	EncryptedStationName	Hipaa Private Creator	HOL	\N	\N	\N
f	5008	\N	(0011,0009)	LT	1	Encrypted Study Description	EncryptedStudyDescription	Hipaa Private Creator	HOL	\N	\N	\N
f	5009	\N	(0011,0010)	LT	1	Encrypted Series Description	EncryptedSeriesDescription	Hipaa Private Creator	HOL	\N	\N	\N
f	5010	\N	(0011,0011)	LT	1	Encrypted Institutional Department Name	EncryptedInstitutionalDepartmentName	Hipaa Private Creator	HOL	\N	\N	\N
f	5011	\N	(0011,0012)	LT	1	Encrypted Physicians of Record	EncryptedPhysiciansOfRecord	Hipaa Private Creator	HOL	\N	\N	\N
f	5012	\N	(0011,0013)	LT	1	Encrypted Performing Physician's Name	EncryptedPerformingPhysicianName	Hipaa Private Creator	HOL	\N	\N	\N
f	5013	\N	(0011,0014)	LT	1	Encrypted Name of Physicians Reading Study	EncryptedNameOfPhysiciansReadingStudy	Hipaa Private Creator	HOL	\N	\N	\N
f	5014	\N	(0011,0015)	LT	1	Encrypted Operator's Name	EncryptedOperatorName	Hipaa Private Creator	HOL	\N	\N	\N
f	5015	\N	(0011,0016)	LT	1	Encrypted Admitting Diagnoses Description	EncryptedAdmittingDiagnosesDescription	Hipaa Private Creator	HOL	\N	\N	\N
f	5016	\N	(0011,0017)	LT	1	Encrypted Referenced SOP Instance UID	EncryptedReferencedSOPInstanceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5017	\N	(0011,0018)	LT	1	Encrypted Derivation Description	EncryptedDerivationDescription	Hipaa Private Creator	HOL	\N	\N	\N
f	5018	\N	(0011,0019)	LT	1	Encrypted Patient's Name	EncryptedPatientName	Hipaa Private Creator	HOL	\N	\N	\N
f	5019	\N	(0011,0020)	LT	1	Encrypted Patient's ID	EncryptedPatientID	Hipaa Private Creator	HOL	\N	\N	\N
f	5020	\N	(0011,0021)	LT	1	Encrypted Patient's Birth Date	EncryptedPatientBirthDate	Hipaa Private Creator	HOL	\N	\N	\N
f	5021	\N	(0011,0022)	LT	1	Encrypted Patient's Birth Time	EncryptedPatientBirthTime	Hipaa Private Creator	HOL	\N	\N	\N
f	5022	\N	(0011,0023)	LT	1	Encrypted Patient's Sex	EncryptedPatientSex	Hipaa Private Creator	HOL	\N	\N	\N
f	5023	\N	(0011,0024)	LT	1	Encrypted Other Patient IDs	EncryptedOtherPatientIDs	Hipaa Private Creator	HOL	\N	\N	\N
f	5024	\N	(0011,0025)	LT	1	Encrypted Other Patient Names	EncryptedOtherPatientNames	Hipaa Private Creator	HOL	\N	\N	\N
f	5025	\N	(0011,0026)	LT	1	Encrypted Patient's Age	EncryptedPatientAge	Hipaa Private Creator	HOL	\N	\N	\N
f	5026	\N	(0011,0027)	LT	1	Encrypted Patient's Size	EncryptedPatientSize	Hipaa Private Creator	HOL	\N	\N	\N
f	5027	\N	(0011,0028)	LT	1	Encrypted Patient's Weight	EncryptedPatientWeight	Hipaa Private Creator	HOL	\N	\N	\N
f	5028	\N	(0011,0029)	LT	1	Encrypted Medical Record Locator	EncryptedMedicalRecordLocator	Hipaa Private Creator	HOL	\N	\N	\N
f	5029	\N	(0011,0030)	LT	1	Encrypted Ethnic Group	EncryptedEthnicGroup	Hipaa Private Creator	HOL	\N	\N	\N
f	5030	\N	(0011,0031)	LT	1	Encrypted Occupation	EncryptedOccupation	Hipaa Private Creator	HOL	\N	\N	\N
f	5031	\N	(0011,0032)	LT	1	Encrypted Additional Patient's History	EncryptedAdditionalPatient'sHistory	Hipaa Private Creator	HOL	\N	\N	\N
f	5032	\N	(0011,0033)	LT	1	Encrypted Patient Comments	EncryptedPatientComments	Hipaa Private Creator	HOL	\N	\N	\N
f	5033	\N	(0011,0034)	LT	1	Encrypted Device Serial Number	EncryptedDeviceSerialNumber	Hipaa Private Creator	HOL	\N	\N	\N
f	5034	\N	(0011,0035)	LT	1	Encrypted Protocol Name	EncryptedProtocolName	Hipaa Private Creator	HOL	\N	\N	\N
f	5035	\N	(0011,0036)	LT	1	Encrypted Study Instance UID	EncryptedStudyInstanceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5036	\N	(0011,0037)	LT	1	Encrypted Series Instance UID	EncryptedSeriesInstanceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5037	\N	(0011,0038)	LT	1	Encrypted Study ID	EncryptedStudyID	Hipaa Private Creator	HOL	\N	\N	\N
f	5038	\N	(0011,0039)	LT	1	Encrypted Frame of Reference UID	EncryptedFrameOfReferenceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5039	\N	(0011,0040)	LT	1	Encrypted Synchronization Frame of Reference UID	EncryptedSynchronizationFrameOfReferenceUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5040	\N	(0011,0041)	LT	1	Encrypted Image Comments	EncryptedImageComments	Hipaa Private Creator	HOL	\N	\N	\N
f	5041	\N	(0011,0042)	LT	1	Encrypted UID	EncryptedUID	Hipaa Private Creator	HOL	\N	\N	\N
f	5042	\N	(0019,0006)	LO	1	Paddle ID	PaddleID	LORAD Selenia	HOL	\N	\N	\N
f	5043	\N	(0019,0007)	SH	1	Paddle Position	PaddlePosition	LORAD Selenia	HOL	\N	\N	\N
f	5044	\N	(0019,0008)	LO	1	Collimation Size	CollimationSize	LORAD Selenia	HOL	\N	\N	\N
f	5045	\N	(0019,0016)	DS	1	Paddle Angle	PaddleAngle	LORAD Selenia	HOL	\N	\N	\N
f	5046	\N	(0019,0026)	LO	1	Paddle ID Description	PaddleIDDescription	LORAD Selenia	HOL	\N	\N	\N
f	5047	\N	(0019,0027)	SH	1	Paddle Position Description	PaddlePositionDescription	LORAD Selenia	HOL	\N	\N	\N
f	5048	\N	(0019,0028)	LO	1	Collimation Size Description	CollimationSizeDescription	LORAD Selenia	HOL	\N	\N	\N
f	5049	\N	(0019,0029)	LO	1	AEC User Density Scale Factor Description	AECUserDensityScaleFactorDescription	LORAD Selenia	HOL	\N	\N	\N
f	5050	\N	(0019,0030)	US	1	AEC User Density Scale Factor	AECUserDensityScaleFactor	LORAD Selenia	HOL	\N	\N	\N
f	5051	\N	(0019,0031)	US	1	AEC System Density Scale Factor	AECSystemDensityScaleFactor	LORAD Selenia	HOL	\N	\N	\N
f	5052	\N	(0019,0032)	US	1	AEC Calculated mAs	AECCalculatedmAs	LORAD Selenia	HOL	\N	\N	\N
f	5053	\N	(0019,0033)	US	1	AEC Auto Pixel 1	AECAutoPixel1	LORAD Selenia	HOL	\N	\N	\N
f	5054	\N	(0019,0034)	US	1	AEC Auto Pixel 2	AECAutoPixel2	LORAD Selenia	HOL	\N	\N	\N
f	5055	\N	(0019,0035)	US	1	AEC Sensor	AECSensor	LORAD Selenia	HOL	\N	\N	\N
f	5056	\N	(0019,0037)	LO	1	NPT Mode	NPTMode	LORAD Selenia	HOL	\N	\N	\N
f	5057	\N	(0019,0040)	DS	1	Skin Edge	SkinEdge	LORAD Selenia	HOL	\N	\N	\N
f	5058	\N	(0019,0041)	DS	1	Exposure Index	ExposureIndex	LORAD Selenia	HOL	\N	\N	\N
f	5059	\N	(0019,0050)	DS	1	Display Minimum OD	DisplayMinimumOD	LORAD Selenia	HOL	\N	\N	\N
f	5060	\N	(0019,0051)	DS	1	Dispaly Maximum OD	DispalyMaximumOD	LORAD Selenia	HOL	\N	\N	\N
f	5061	\N	(0019,0052)	IS	1	Display Minimum Nits	DisplayMinimumNits	LORAD Selenia	HOL	\N	\N	\N
f	5062	\N	(0019,0053)	IS	1	Display Maximum Nits	DisplayMaximumNits	LORAD Selenia	HOL	\N	\N	\N
f	5063	\N	(0019,0060)	LT	1	Geometry Calibration	GeometryCalibration	LORAD Selenia	HOL	\N	\N	\N
f	5064	\N	(0019,0070)	LO	1	Frame of Reference ID	FrameOfReferenceID	LORAD Selenia	HOL	\N	\N	\N
f	5065	\N	(0019,0071)	CS	1	Paired Position	PairedPosition	LORAD Selenia	HOL	\N	\N	\N
f	5066	\N	(0019,0080)	SH	1	Detector Image Offset	DetectorImageOffset	LORAD Selenia	HOL	\N	\N	\N
f	5067	\N	(0019,0090)	DS	1	Conventional Tomo Angle	ConventionalTomoAngle	LORAD Selenia	HOL	\N	\N	\N
f	5068	\N	(0019,0001)	IS	1	Unknown	Unknown	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5069	\N	(0019,0002)	IS	1	Unknown	Unknown	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5070	\N	(0019,0003)	IS	1	Unknown	Unknown	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5071	\N	(0019,0004)	IS	1	Unknown	Unknown	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5072	\N	(0019,0006)	LO	1	Paddle ID	PaddleID	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5073	\N	(0019,0007)	SH	1	Paddle Position	PaddlePosition	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5074	\N	(0019,0008)	LO	1	Collimation Size	CollimationSize	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5075	\N	(0019,0016)	DS	1	Paddle Angle	PaddleAngle	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5076	\N	(0019,0025)	SH	1	Unknown	Unknown	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5077	\N	(0019,0026)	LO	1	Paddle ID Description	PaddleIDDescription	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5078	\N	(0019,0027)	SH	1	Paddle Position Description	PaddlePositionDescription	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5079	\N	(0019,0028)	LO	1	Collimation Size Description	CollimationSizeDescription	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5080	\N	(0019,0029)	LO	1	AEC User Density Scale Factor Description	AECUserDensityScaleFactorDescription	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5081	\N	(0019,0030)	US	1	AEC User Density Scale Factor	AECUserDensityScaleFactor	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5082	\N	(0019,0031)	US	1	AEC System Density Scale Factor	AECSystemDensityScaleFactor	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5083	\N	(0019,0032)	US	1	AEC Calculated mAs	AECCalculatedmAs	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5084	\N	(0019,0033)	US	1	AEC Auto Pixel 1	AECAutoPixel1	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5085	\N	(0019,0034)	US	1	AEC Auto Pixel 2	AECAutoPixel2	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5086	\N	(0019,0035)	US	1	AEC Sensor	AECSensor	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5087	\N	(0019,0037)	LO	1	NPT Mode	NPTMode	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5088	\N	(0019,0040)	DS	1	Skin Edge	SkinEdge	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5089	\N	(0019,0041)	DS	1	Exposure Index	ExposureIndex	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5090	\N	(0019,0042)	IS	1	Exposure Index Target	ExposureIndexTarget	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5091	\N	(0019,0043)	DS	1	Short Index Ratio	ShortIndexRatio	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5092	\N	(0019,0044)	DS	1	Scout kVp	ScoutkVp	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5093	\N	(0019,0045)	IS	1	Scout mA	ScoutmA	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5094	\N	(0019,0046)	IS	1	Scout mAs	ScoutmAs	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5095	\N	(0019,0050)	DS	1	Display Minimum OD	DisplayMinimumOD	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5096	\N	(0019,0051)	DS	1	Dispaly Maximum OD	DispalyMaximumOD	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5097	\N	(0019,0052)	IS	1	Display Minimum Nits	DisplayMinimumNits	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5098	\N	(0019,0053)	IS	1	Display Maximum Nits	DisplayMaximumNits	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5099	\N	(0019,0060)	LT	1	Geometry Calibration	GeometryCalibration	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5100	\N	(0019,0061)	OB	1	3D IP Parameters	ThreeDIPParameters	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5101	\N	(0019,0062)	LT	1	2D IP Parameters	TwoDIPParameters	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5102	\N	(0019,0070)	LO	1	Frame of Reference ID	FrameOfReferenceID	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5103	\N	(0019,0071)	CS	1	Paired Position	PairedPosition	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5104	\N	(0019,0080)	SH	1	Detector Image Offset	DetectorImageOffset	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5105	\N	(0019,0085)	SH	1	Image Source	ImageSource	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5106	\N	(0019,0087)	LO	1	Marker Text	MarkerText	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5107	\N	(0019,0088)	LO	1	Marker Tech Initials	MarkerTechInitials	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5108	\N	(0019,0089)	DS	2	Marker Location	MarkerLocation	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5109	\N	(0019,008a)	SQ	2	Marker Sequence	MarkerSequence	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5110	\N	(0019,0090)	DS	1	Conventional Tomo Angle	ConventionalTomoAngle	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5111	\N	(0019,0097)	SH	1	Markers Burned Into Image	MarkersBurnedIntoImage	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5112	\N	(0019,0098)	LO	1	Grid Line Correction	GridLineCorrection	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5113	\N	(7e01,0001)	LO	1	Codec Version	CodecVersion	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5114	\N	(7e01,0002)	SH	1	Codec Content Type	CodecContentType	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5115	\N	(7e01,0010)	SQ	1	High Resolution Data Sequence	HighResolutionDataSeqence	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5116	\N	(7e01,0011)	SQ	1	Low Resolution Data Sequence	LowResolutionDataSeqence	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5117	\N	(7e01,0012)	OB	1	Codec Content	CodecContent	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5118	\N	(7f01,0001)	LO	1	Codec Version	CodecVersion	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5119	\N	(7f01,0002)	SH	1	Codec Content Type	CodecContentType	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5120	\N	(7f01,0010)	SQ	1	High Resolution Data Sequence	HighResolutionDataSeqence	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5121	\N	(7f01,0011)	SQ	1	Low Resolution Data Sequence	LowResolutionDataSeqence	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5122	\N	(7f01,0012)	OB	1	Codec Content	CodecContent	HOLOGIC, Inc.	HOL	\N	\N	\N
f	5123	\N	(0029,0000)	US	1	Unknown	Unknown	1.2.840.113663.1	ATL	\N	\N	\N
f	5124	\N	(0029,0001)	US	1	Unknown	Unknown	1.2.840.113663.1	ATL	\N	\N	\N
f	5125	\N	(0009,0001)	LO	1	Technologist	Technologist	MMCPrivate	HIT	\N	\N	\N
f	5126	\N	(0009,0002)	LO	1	Scheduled Study DateTime	ScheduledStudyDateTime	MMCPrivate	HIT	\N	\N	\N
f	5127	\N	(0009,0003)	OB	1	Study App Data	StudyAppData	MMCPrivate	HIT	\N	\N	\N
f	5128	\N	(0009,0048)	LO	1	Protocol Name	ProtocolName	MMCPrivate	HIT	\N	\N	\N
f	5129	\N	(0009,004e)	LO	1	CMS Body Part Examined	Cms_BodyPartExamined	MMCPrivate	HIT	\N	\N	\N
f	5130	\N	(0009,004f)	LO	1	Is Protected	IsProtected	MMCPrivate	HIT	\N	\N	\N
f	5131	\N	(0009,0050)	CS	1	CMS Patient Position	Cms_PatientPosition	MMCPrivate	HIT	\N	\N	\N
f	5132	\N	(0009,0051)	LO	1	CMI Contrast Bolus Agent	Cmi_contrastBolusAgent	MMCPrivate	HIT	\N	\N	\N
f	5133	\N	(0009,0052)	LO	1	CMS institution Name	Cms_institutionName	MMCPrivate	HIT	\N	\N	\N
f	5134	\N	(0009,0053)	LO	1	CMS Institutional Department Name	Cms_institutionalDepartmentName	MMCPrivate	HIT	\N	\N	\N
f	5135	\N	(0009,0054)	LO	1	CMS Series Description	Cms_seriesDescription	MMCPrivate	HIT	\N	\N	\N
f	5136	\N	(0009,0055)	LO	1	CMS Operators Name	Cms_operatorsName	MMCPrivate	HIT	\N	\N	\N
f	5137	\N	(0009,0056)	LO	1	CMS Performing Physicians Name	Cms_PerformingPhysiciansName	MMCPrivate	HIT	\N	\N	\N
f	5138	\N	(0009,0057)	ST	1	CMS Institution Address	Cms_institutionAddress	MMCPrivate	HIT	\N	\N	\N
f	5139	\N	(0009,0058)	LO	1	CMI Image Comments	Cmi_imageComments	MMCPrivate	HIT	\N	\N	\N
f	5140	\N	(0009,0059)	LO	1	CMI Instance Creation DateTime	Cmi_instanceCreationDateTime	MMCPrivate	HIT	\N	\N	\N
f	5141	\N	(0009,005a)	LO	1	MPPS Step Status	MPPSStepStatus	MMCPrivate	HIT	\N	\N	\N
f	5142	\N	(0009,005b)	IS	1	Filmed Count	FilmedCount	MMCPrivate	HIT	\N	\N	\N
f	5143	\N	(0009,005c)	LO	1	Is Allow Cascade Save	IsAllowCascadeSave	MMCPrivate	HIT	\N	\N	\N
f	5144	\N	(0009,005d)	LO	1	Is Allow Cascade Protect	IsAllowCascadeProtect	MMCPrivate	HIT	\N	\N	\N
f	5145	\N	(0009,005e)	LO	1	Is Deleted	IsDeleted	MMCPrivate	HIT	\N	\N	\N
f	5146	\N	(0011,0001)	LO	1	Is Rapid Registration	IsRapidRegistration	MMCPrivate	HIT	\N	\N	\N
f	5147	\N	(0011,0002)	LO	1	Is Protected	IsProtected	MMCPrivate	HIT	\N	\N	\N
f	5148	\N	(0011,0003)	IS	1	Filmed Count	FilmedCount	MMCPrivate	HIT	\N	\N	\N
f	5149	\N	(0011,0004)	OB	1	Application Data	ApplicationData	MMCPrivate	HIT	\N	\N	\N
f	5150	\N	(0011,0005)	LO	1	Is Allow Cascade Save	IsAllowCascadeSave	MMCPrivate	HIT	\N	\N	\N
f	5151	\N	(0011,0006)	LO	1	Is Allow Cascade Protect	IsAllowCascadeProtect	MMCPrivate	HIT	\N	\N	\N
f	5152	\N	(0011,0007)	LO	1	Is Deleted	IsDeleted	MMCPrivate	HIT	\N	\N	\N
f	5153	\N	(0019,0001)	LO	1	Proc Type	ProcType	MMCPrivate	HIT	\N	\N	\N
f	5154	\N	(0019,0002)	LO	1	Plane	Plane	MMCPrivate	HIT	\N	\N	\N
f	5155	\N	(0019,0003)	SH	1	Is Snap Shot Series	IsSnapShotSeries	MMCPrivate	HIT	\N	\N	\N
f	5156	\N	(0019,0004)	DS	1	Max Fscalor	MaxFscalor	MMCPrivate	HIT	\N	\N	\N
f	5157	\N	(0019,0005)	LO	1	Series Category Type	SeriesCategoryType	MMCPrivate	HIT	\N	\N	\N
f	5158	\N	(0019,0007)	LO	1	Image Contrast Bolus Agent	ImageContrastBolusAgent	MMCPrivate	HIT	\N	\N	\N
f	5159	\N	(0019,0008)	DS	1	Image Slice Thickness	ImageSliceThickness	MMCPrivate	HIT	\N	\N	\N
f	5160	\N	(0019,0009)	DS	1	Image Reconstruction Diameter	ImageReconstructionDiameter	MMCPrivate	HIT	\N	\N	\N
f	5161	\N	(0019,000a)	LO	1	Image Echo Time	ImageEchoTime	MMCPrivate	HIT	\N	\N	\N
f	5162	\N	(0019,000b)	DS	1	Image Repetition Time	ImageRepetitionTime	MMCPrivate	HIT	\N	\N	\N
f	5163	\N	(0019,000c)	LO	1	Sequence Type	SequenceType	MMCPrivate	HIT	\N	\N	\N
f	5164	\N	(0019,000d)	LO	1	Task UID	TaskUID	MMCPrivate	HIT	\N	\N	\N
f	5165	\N	(0019,000e)	OB	1	Series App Data	SeriesAppData	MMCPrivate	HIT	\N	\N	\N
f	5166	\N	(0019,000f)	IS	1	Multi Slice Number	MultiSliceNumber	MMCPrivate	HIT	\N	\N	\N
f	5167	\N	(0019,0010)	LO	1	Image Scan Time	ImageScanTime	MMCPrivate	HIT	\N	\N	\N
f	5168	\N	(0019,0011)	LO	1	Is Protected	IsProtected	MMCPrivate	HIT	\N	\N	\N
f	5169	\N	(0019,0012)	IS	1	Image Increment	ImageIncrement	MMCPrivate	HIT	\N	\N	\N
f	5170	\N	(0019,0013)	LO	1	MPPS Step Status	MPPSStepStatus	MMCPrivate	HIT	\N	\N	\N
f	5171	\N	(0019,0014)	IS	1	Storage Committed Count	StorageCommittedCount	MMCPrivate	HIT	\N	\N	\N
f	5172	\N	(0019,0015)	IS	1	Archived Count	ArchivedCount	MMCPrivate	HIT	\N	\N	\N
f	5173	\N	(0019,0016)	IS	1	Transferred Count	TransferredCount	MMCPrivate	HIT	\N	\N	\N
f	5174	\N	(0019,0017)	LO	1	Is Allow Cascade Save	IsAllowCascadeSave	MMCPrivate	HIT	\N	\N	\N
f	5175	\N	(0019,0018)	LO	1	Is Allow Cascade Protect	IsAllowCascadeProtect	MMCPrivate	HIT	\N	\N	\N
f	5176	\N	(0019,0019)	LO	1	Is Deleted	IsDeleted	MMCPrivate	HIT	\N	\N	\N
f	5177	\N	(0019,001a)	UI	1	Characterized Image Instance UID	CharacterizedImageInstanceUID	MMCPrivate	HIT	\N	\N	\N
f	5178	\N	(0019,001b)	IS	1	Characterized Image Count	CharacterizedImageCount	MMCPrivate	HIT	\N	\N	\N
f	5179	\N	(0019,001c)	LO	1	Internal Window Width	InternalWindowWidth	MMCPrivate	HIT	\N	\N	\N
f	5180	\N	(0019,001d)	LO	1	Internal Window Level	InternalWindowLevel	MMCPrivate	HIT	\N	\N	\N
f	5181	\N	(0019,001e)	LO	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5182	\N	(0029,0001)	IS	1	Slice Number	SliceNumber	MMCPrivate	HIT	\N	\N	\N
f	5183	\N	(0029,0002)	IS	1	Phase Number	PhaseNumber	MMCPrivate	HIT	\N	\N	\N
f	5184	\N	(0029,0003)	LO	1	Proc Type	ProcType	MMCPrivate	HIT	\N	\N	\N
f	5185	\N	(0029,0004)	LO	1	Stopwatch Time	StopwatchTime	MMCPrivate	HIT	\N	\N	\N
f	5186	\N	(0029,0005)	LO	1	Plane	Plane	MMCPrivate	HIT	\N	\N	\N
f	5187	\N	(0029,0006)	LO	1	Scan Time	ScanTime	MMCPrivate	HIT	\N	\N	\N
f	5188	\N	(0029,0008)	LO	1	Dual Slice Flag	DualSliceFlag	MMCPrivate	HIT	\N	\N	\N
f	5189	\N	(0029,0009)	LO	1	SSP Ratio	SSPRatio	MMCPrivate	HIT	\N	\N	\N
f	5190	\N	(0029,000a)	LO	1	Gating Signal Source	GatingSignalSource	MMCPrivate	HIT	\N	\N	\N
f	5191	\N	(0029,000b)	LO	1	Rephase	Rephase	MMCPrivate	HIT	\N	\N	\N
f	5192	\N	(0029,000c)	LO	1	Half Echo	HalfEcho	MMCPrivate	HIT	\N	\N	\N
f	5193	\N	(0029,000d)	LO	1	Rect FOV Ratio	RectFOVRatio	MMCPrivate	HIT	\N	\N	\N
f	5194	\N	(0029,000e)	LO	1	Half Scan	HalfScan	MMCPrivate	HIT	\N	\N	\N
f	5195	\N	(0029,000f)	LO	1	Num Shots	NumShots	MMCPrivate	HIT	\N	\N	\N
f	5196	\N	(0029,0010)	LO	1	Contrast Agent	ContrastAgent	MMCPrivate	HIT	\N	\N	\N
f	5197	\N	(0029,0011)	LO	1	Echo Allocation	EchoAllocation	MMCPrivate	HIT	\N	\N	\N
f	5198	\N	(0029,0012)	LO	1	Num Echo Shift	NumEchoShift	MMCPrivate	HIT	\N	\N	\N
f	5199	\N	(0029,0013)	LO	1	Fat Sat	FatSat	MMCPrivate	HIT	\N	\N	\N
f	5200	\N	(0029,0014)	LO	1	MTC	MTC	MMCPrivate	HIT	\N	\N	\N
f	5201	\N	(0029,0015)	LO	1	Num Pre Sat	NumPreSat	MMCPrivate	HIT	\N	\N	\N
f	5202	\N	(0029,0016)	LO	1	Target Velocity	TargetVelocity	MMCPrivate	HIT	\N	\N	\N
f	5203	\N	(0029,0017)	LO	1	VENC Axis	VENCAxis	MMCPrivate	HIT	\N	\N	\N
f	5204	\N	(0029,0018)	LO	1	Num VENC Direction	NumVENCDirection	MMCPrivate	HIT	\N	\N	\N
f	5205	\N	(0029,001c)	LO	1	Is Scalable Window Level	IsScalableWindowLevel	MMCPrivate	HIT	\N	\N	\N
f	5206	\N	(0029,001d)	LO	1	Three D Setting Line Angle	ThreeDSettingLineAngle	MMCPrivate	HIT	\N	\N	\N
f	5207	\N	(0029,001e)	LO	1	MPG Total Axis	MPGTotalAxis	MMCPrivate	HIT	\N	\N	\N
f	5208	\N	(0029,001f)	LO	1	MPG Axis Number	MPGAxisNumber	MMCPrivate	HIT	\N	\N	\N
f	5209	\N	(0029,0020)	IS	1	Multi Echo Number	MultiEchoNumber	MMCPrivate	HIT	\N	\N	\N
f	5210	\N	(0029,0021)	DS	1	Navi Average Gate Width	NaviAverageGateWidth	MMCPrivate	HIT	\N	\N	\N
f	5211	\N	(0029,0022)	ST	1	Shim Compensate Value	ShimCompensateValue	MMCPrivate	HIT	\N	\N	\N
f	5212	\N	(0029,0023)	LO	1	GC Offset	GCOffset	MMCPrivate	HIT	\N	\N	\N
f	5213	\N	(0029,0024)	DS	1	Navi Max Gate Width	NaviMaxGateWidth	MMCPrivate	HIT	\N	\N	\N
f	5214	\N	(0029,0025)	DS	1	Navi Min Gate Width	NaviMinGateWidth	MMCPrivate	HIT	\N	\N	\N
f	5215	\N	(0029,0026)	DS	1	Navi Max Gate Position	NaviMaxGatePosition	MMCPrivate	HIT	\N	\N	\N
f	5216	\N	(0029,0027)	DS	1	Navi Min Gate Position	NaviMinGatePosition	MMCPrivate	HIT	\N	\N	\N
f	5217	\N	(0029,0028)	DS	1	Time Duration	TimeDuration	MMCPrivate	HIT	\N	\N	\N
f	5218	\N	(0029,0029)	DS	1	Table Position	TablePosition	MMCPrivate	HIT	\N	\N	\N
f	5219	\N	(0029,002a)	DS	1	Navi Initial Gate Width	NaviInitialGateWidth	MMCPrivate	HIT	\N	\N	\N
f	5220	\N	(0029,002b)	DS	1	Navi Final Gate Width	NaviFinalGateWidth	MMCPrivate	HIT	\N	\N	\N
f	5221	\N	(0029,002c)	DS	1	Navi Initial Gate Position	NaviInitialGatePosition	MMCPrivate	HIT	\N	\N	\N
f	5222	\N	(0029,002d)	DS	1	Navi Final Gate Position	NaviFinalGatePosition	MMCPrivate	HIT	\N	\N	\N
f	5223	\N	(0029,002e)	DS	1	Navi Average Gate Position	NaviAverageGatePosition	MMCPrivate	HIT	\N	\N	\N
f	5224	\N	(0029,002f)	OB	1	Image App Data	ImageAppData	MMCPrivate	HIT	\N	\N	\N
f	5225	\N	(0029,0030)	FD	1	Diffusion BValue	DiffusionBValue	MMCPrivate	HIT	\N	\N	\N
f	5226	\N	(0029,0031)	SQ	1	Shared Functional Groups Sequence	SharedFunctionalGroupsSequence	MMCPrivate	HIT	\N	\N	\N
f	5227	\N	(0029,0032)	SQ	1	Per Frame Functional Groups Sequence	PerFrameFunctionalGroupsSequence	MMCPrivate	HIT	\N	\N	\N
f	5228	\N	(0029,0033)	DS	1	Lossy Image Compression Ratio	LossyImageCompressionRatio	MMCPrivate	HIT	\N	\N	\N
f	5229	\N	(0029,0034)	UI	1	Instance Creator UID	InstanceCreatorUID	MMCPrivate	HIT	\N	\N	\N
f	5230	\N	(0029,0035)	UI	1	Related General SOPClass UID	RelatedGeneralSOPClassUID	MMCPrivate	HIT	\N	\N	\N
f	5231	\N	(0029,0036)	UI	1	Original Specialized SOPClass UID	OriginalSpecializedSOPClassUID	MMCPrivate	HIT	\N	\N	\N
f	5232	\N	(0029,0037)	SH	1	Timezone Offset From UTC	TimezoneOffsetFromUTC	MMCPrivate	HIT	\N	\N	\N
f	5233	\N	(0029,0038)	CS	1	SOPInstance Status	SOPInstanceStatus	MMCPrivate	HIT	\N	\N	\N
f	5234	\N	(0029,0039)	DT	1	SOPAuthorization Dateand Time	SOPAuthorizationDateandTime	MMCPrivate	HIT	\N	\N	\N
f	5235	\N	(0029,003a)	LT	1	SOPAuthorization Comment	SOPAuthorizationComment	MMCPrivate	HIT	\N	\N	\N
f	5236	\N	(0029,003b)	LO	1	Authorization Equipment Certification Number	AuthorizationEquipmentCertificationNumber	MMCPrivate	HIT	\N	\N	\N
f	5237	\N	(0029,003c)	UL	1	Concatenation Frame Offset Number	ConcatenationFrameOffsetNumber	MMCPrivate	HIT	\N	\N	\N
f	5238	\N	(0029,003d)	US	1	Representative Frame Number	RepresentativeFrameNumber	MMCPrivate	HIT	\N	\N	\N
f	5239	\N	(0029,003e)	UI	1	Concatenation UID	ConcatenationUID	MMCPrivate	HIT	\N	\N	\N
f	5372	\N	(0029,00d3)	LO	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5240	\N	(0029,003f)	US	1	In Concatenation Number	InConcatenationNumber	MMCPrivate	HIT	\N	\N	\N
f	5241	\N	(0029,0040)	CS	1	Cardiac Synchronization Technique	CardiacSynchronizationTechnique	MMCPrivate	HIT	\N	\N	\N
f	5242	\N	(0029,0041)	CS	1	Cardiac Signal Source	CardiacSignalSource	MMCPrivate	HIT	\N	\N	\N
f	5243	\N	(0029,0042)	FD	1	Cardiac RRInterval Specified	CardiacRRIntervalSpecified	MMCPrivate	HIT	\N	\N	\N
f	5244	\N	(0029,0043)	CS	1	Cardiac Beat Rejection Technique	CardiacBeatRejectionTechnique	MMCPrivate	HIT	\N	\N	\N
f	5245	\N	(0029,0044)	IS	1	Low RR Value	LowRRValue	MMCPrivate	HIT	\N	\N	\N
f	5246	\N	(0029,0045)	IS	1	High RR Value	HighRRValue	MMCPrivate	HIT	\N	\N	\N
f	5247	\N	(0029,0046)	IS	1	Intervals Acquired	IntervalsAcquired	MMCPrivate	HIT	\N	\N	\N
f	5248	\N	(0029,0047)	IS	1	Intervals Rejected	IntervalsRejected	MMCPrivate	HIT	\N	\N	\N
f	5249	\N	(0029,0048)	CS	1	Respiratory Motion Compensation Technique	RespiratoryMotionCompensationTechnique	MMCPrivate	HIT	\N	\N	\N
f	5250	\N	(0029,0049)	CS	1	Respiratory Signal Source	RespiratorySignalSource	MMCPrivate	HIT	\N	\N	\N
f	5251	\N	(0029,004a)	CS	1	Bulk Motion Compensation Technique	BulkMotionCompensationTechnique	MMCPrivate	HIT	\N	\N	\N
f	5252	\N	(0029,004b)	CS	1	Bulk Motion Signal Source	BulkMotionSignalSource	MMCPrivate	HIT	\N	\N	\N
f	5253	\N	(0029,004c)	CS	1	Pixel Presentation	PixelPresentation	MMCPrivate	HIT	\N	\N	\N
f	5254	\N	(0029,004d)	CS	1	Volumetric Properties	VolumetricProperties	MMCPrivate	HIT	\N	\N	\N
f	5255	\N	(0029,004e)	CS	1	Volume Based Calculation Technique	VolumeBasedCalculationTechnique	MMCPrivate	HIT	\N	\N	\N
f	5256	\N	(0029,004f)	ST	1	Acquisition Context Description	AcquisitionContextDescription	MMCPrivate	HIT	\N	\N	\N
f	5257	\N	(0029,0050)	SQ	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5258	\N	(0029,0051)	LO	1	LUTDescriptor	LUTDescriptor	MMCPrivate	HIT	\N	\N	\N
f	5259	\N	(0029,0052)	LO	1	LUTExplanation	LUTExplanation	MMCPrivate	HIT	\N	\N	\N
f	5260	\N	(0029,0053)	LO	1	LUTData	LUTData	MMCPrivate	HIT	\N	\N	\N
f	5261	\N	(0029,0054)	CS	1	Presentation LUT Shape	PresentationLUTShape	MMCPrivate	HIT	\N	\N	\N
f	5262	\N	(0029,0055)	SQ	1	Frame Anatomy Sequence	FrameAnatomySequence	MMCPrivate	HIT	\N	\N	\N
f	5263	\N	(0029,0056)	CS	1	Frame Laterality	FrameLaterality	MMCPrivate	HIT	\N	\N	\N
f	5264	\N	(0029,0057)	SQ	1	Anatomic Region Sequence	AnatomicRegionSequence	MMCPrivate	HIT	\N	\N	\N
f	5265	\N	(0029,0058)	SH	1	Anatomic Region Code Value	AnatomicRegionCodeValue	MMCPrivate	HIT	\N	\N	\N
f	5266	\N	(0029,0059)	SH	1	Anatomic Region Coding Scheme Designator	AnatomicRegionCodingSchemeDesignator	MMCPrivate	HIT	\N	\N	\N
f	5267	\N	(0029,005a)	SH	1	Anatomic Region Coding Scheme Version	AnatomicRegionCodingSchemeVersion	MMCPrivate	HIT	\N	\N	\N
f	5268	\N	(0029,005b)	LO	1	Anatomic Region Code Meaning	AnatomicRegionCodeMeaning	MMCPrivate	HIT	\N	\N	\N
f	5269	\N	(0029,005c)	SQ	1	Pixel Value Transformation Sequence	PixelValueTransformationSequence	MMCPrivate	HIT	\N	\N	\N
f	5270	\N	(0029,005d)	LO	1	Rescale Type	RescaleType	MMCPrivate	HIT	\N	\N	\N
f	5271	\N	(0029,005e)	SQ	1	Cardiac Synchronization Sequence	CardiacSynchronizationSequence	MMCPrivate	HIT	\N	\N	\N
f	5272	\N	(0029,005f)	FD	1	Trigger Delay Time	TriggerDelayTime	MMCPrivate	HIT	\N	\N	\N
f	5273	\N	(0029,0060)	SQ	1	Frame VOILUTSequence	FrameVOILUTSequence	MMCPrivate	HIT	\N	\N	\N
f	5274	\N	(0029,0061)	LO	1	Window Center and Width Explanation	WindowCenterAndWidthExplanation	MMCPrivate	HIT	\N	\N	\N
f	5275	\N	(0029,0062)	CS	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5276	\N	(0029,0063)	SQ	1	MRModifier Sequence	MRModifierSequence	MMCPrivate	HIT	\N	\N	\N
f	5277	\N	(0029,0064)	CS	1	Parallel Acquisition Technique	ParallelAcquisitionTechnique	MMCPrivate	HIT	\N	\N	\N
f	5278	\N	(0029,0065)	FD	1	Parallel Reduction Factor Sec In	ParallelReductionFactorSecIn	MMCPrivate	HIT	\N	\N	\N
f	5279	\N	(0029,0066)	CS	1	Inversion Recovery	InversionRecovery	MMCPrivate	HIT	\N	\N	\N
f	5280	\N	(0029,0067)	CS	1	Flow Compensation	FlowCompensation	MMCPrivate	HIT	\N	\N	\N
f	5281	\N	(0029,0068)	CS	1	Flow Compensation Direction	FlowCompensationDirection	MMCPrivate	HIT	\N	\N	\N
f	5282	\N	(0029,0069)	CS	1	Spatial PreSaturation	SpatialPreSaturation	MMCPrivate	HIT	\N	\N	\N
f	5283	\N	(0029,006a)	CS	1	Partial Fourier	PartialFourier	MMCPrivate	HIT	\N	\N	\N
f	5284	\N	(0029,006b)	CS	1	Partial Fourier Direction	PartialFourierDirection	MMCPrivate	HIT	\N	\N	\N
f	5285	\N	(0029,0070)	SQ	1	MR Receive Coil Sequence	MRReceiveCoilSequence	MMCPrivate	HIT	\N	\N	\N
f	5286	\N	(0029,0071)	LO	1	Receive Coil Manufacturer Name	ReceiveCoilManufacturerName	MMCPrivate	HIT	\N	\N	\N
f	5287	\N	(0029,0072)	CS	1	Receive Coil Type	ReceiveCoilType	MMCPrivate	HIT	\N	\N	\N
f	5288	\N	(0029,0073)	CS	1	Quadrature Receive Coil	QuadratureReceiveCoil	MMCPrivate	HIT	\N	\N	\N
f	5289	\N	(0029,0074)	LO	1	Multi Coil Configuration	MultiCoilConfiguration	MMCPrivate	HIT	\N	\N	\N
f	5290	\N	(0029,0075)	CS	1	Complex Image Component	ComplexImageComponent	MMCPrivate	HIT	\N	\N	\N
f	5291	\N	(0029,0076)	SH	1	Pulse Sequence Name	PulseSequenceName	MMCPrivate	HIT	\N	\N	\N
f	5292	\N	(0029,0077)	CS	1	Echo Pulse Sequence	EchoPulseSequence	MMCPrivate	HIT	\N	\N	\N
f	5293	\N	(0029,0078)	CS	1	Multiple Spin Echo	MultipleSpinEcho	MMCPrivate	HIT	\N	\N	\N
f	5294	\N	(0029,0079)	CS	1	Multi Planar Excitation	MultiPlanarExcitation	MMCPrivate	HIT	\N	\N	\N
f	5295	\N	(0029,007a)	CS	1	Phase Contrast	PhaseContrast	MMCPrivate	HIT	\N	\N	\N
f	5296	\N	(0029,007b)	CS	1	Time of Flight Contrast	TimeOfFlightContrast	MMCPrivate	HIT	\N	\N	\N
f	5297	\N	(0029,007c)	CS	1	Steady State Pulse Sequence	SteadyStatePulseSequence	MMCPrivate	HIT	\N	\N	\N
f	5298	\N	(0029,007d)	CS	1	Echo Planar Pulse Sequence	EchoPlanarPulseSequence	MMCPrivate	HIT	\N	\N	\N
f	5299	\N	(0029,007e)	CS	1	Spectrally Selected Suppression	SpectrallySelectedSuppression	MMCPrivate	HIT	\N	\N	\N
f	5300	\N	(0029,007f)	CS	1	Oversampling Phase	OversamplingPhase	MMCPrivate	HIT	\N	\N	\N
f	5301	\N	(0029,0080)	CS	1	Segmented KSpace Traversal	SegmentedKSpaceTraversal	MMCPrivate	HIT	\N	\N	\N
f	5302	\N	(0029,0081)	CS	1	Coverage of KSpace	CoverageOfKSpace	MMCPrivate	HIT	\N	\N	\N
f	5303	\N	(0029,0082)	SQ	1	MR Timing and Related Parameters Sequence	MRTimingAndRelatedParametersSequence	MMCPrivate	HIT	\N	\N	\N
f	5304	\N	(0029,0083)	US	1	RF Echo Train Length	RFEchoTrainLength	MMCPrivate	HIT	\N	\N	\N
f	5305	\N	(0029,0084)	US	1	Gradient Echo Train Length	GradientEchoTrainLength	MMCPrivate	HIT	\N	\N	\N
f	5306	\N	(0029,0085)	CS	1	Gradient Output Type	GradientOutputType	MMCPrivate	HIT	\N	\N	\N
f	5307	\N	(0029,0086)	FD	1	Gradient Output	GradientOutput	MMCPrivate	HIT	\N	\N	\N
f	5308	\N	(0029,0087)	SQ	1	MRFOVGeometry Sequence	MRFOVGeometrySequence	MMCPrivate	HIT	\N	\N	\N
f	5309	\N	(0029,0088)	US	1	MRAcquisition Frequency Encoding Steps	MRAcquisitionFrequencyEncodingSteps	MMCPrivate	HIT	\N	\N	\N
f	5310	\N	(0029,0089)	US	1	MRAcquisition Phase Encoding Steps In Plane	MRAcquisitionPhaseEncodingStepsInPlane	MMCPrivate	HIT	\N	\N	\N
f	5311	\N	(0029,008a)	US	1	MRAcquisitionPhase Encoding Steps Out of Plane	MRAcquisitionPhaseEncodingStepsOutOfPlane	MMCPrivate	HIT	\N	\N	\N
f	5312	\N	(0029,008b)	SQ	1	MR Transmit Coil Sequence	MRTransmitCoilSequence	MMCPrivate	HIT	\N	\N	\N
f	5313	\N	(0029,008c)	SH	1	Transmit Coil Name	TransmitCoilName	MMCPrivate	HIT	\N	\N	\N
f	5314	\N	(0029,008d)	LO	1	Transmit Coil Manufacturer Name	TransmitCoilManufacturerName	MMCPrivate	HIT	\N	\N	\N
f	5315	\N	(0029,008e)	CS	1	Transmit Coil Type	TransmitCoilType	MMCPrivate	HIT	\N	\N	\N
f	5316	\N	(0029,008f)	SQ	1	MR Echo Sequence	MREchoSequence	MMCPrivate	HIT	\N	\N	\N
f	5317	\N	(0029,0090)	FD	1	Effective Echo Time	EffectiveEchoTime	MMCPrivate	HIT	\N	\N	\N
f	5318	\N	(0029,0091)	SQ	1	MR Metabolite Map Sequence	MRMetaboliteMapSequence	MMCPrivate	HIT	\N	\N	\N
f	5319	\N	(0029,0092)	ST	1	Metabolite Map Description	MetaboliteMapDescription	MMCPrivate	HIT	\N	\N	\N
f	5320	\N	(0029,0093)	SQ	1	Metabolite Map Code Sequence	MetaboliteMapCodeSequence	MMCPrivate	HIT	\N	\N	\N
f	5321	\N	(0029,0094)	SH	1	Metabolite Map Code Value	MetaboliteMapCodeValue	MMCPrivate	HIT	\N	\N	\N
f	5322	\N	(0029,0095)	SH	1	Metabolite Map Coding Scheme Designator	MetaboliteMapCodingSchemeDesignator	MMCPrivate	HIT	\N	\N	\N
f	5323	\N	(0029,0096)	SH	1	Metabolite Map Coding Scheme Version	MetaboliteMapCodingSchemeVersion	MMCPrivate	HIT	\N	\N	\N
f	5324	\N	(0029,0097)	LO	1	Metabolite Map Code Meaning	MetaboliteMapCodeMeaning	MMCPrivate	HIT	\N	\N	\N
f	5325	\N	(0029,0098)	SQ	1	MR Imaging Modifier Sequence	MRImagingModifierSequence	MMCPrivate	HIT	\N	\N	\N
f	5326	\N	(0029,0099)	CS	1	Magnetization Transfer	MagnetizationTransfer	MMCPrivate	HIT	\N	\N	\N
f	5327	\N	(0029,009a)	CS	1	Blood Signal Nulling	BloodSignalNulling	MMCPrivate	HIT	\N	\N	\N
f	5328	\N	(0029,009b)	CS	1	Tagging	Tagging	MMCPrivate	HIT	\N	\N	\N
f	5329	\N	(0029,009c)	FD	1	Tag Spacing First Dimension	TagSpacingFirstDimension	MMCPrivate	HIT	\N	\N	\N
f	5330	\N	(0029,009d)	FD	1	Tag Spacing Second Dimension	TagSpacingSecondDimension	MMCPrivate	HIT	\N	\N	\N
f	5331	\N	(0029,009e)	FD	1	Tag Angle First Axis	TagAngleFirstAxis	MMCPrivate	HIT	\N	\N	\N
f	5332	\N	(0029,009f)	SS	1	Tag Angle Second Axis	TagAngleSecondAxis	MMCPrivate	HIT	\N	\N	\N
f	5333	\N	(0029,00a0)	FD	1	Tag Thickness	TagThickness	MMCPrivate	HIT	\N	\N	\N
f	5334	\N	(0029,00a1)	FD	1	Tagging Delay	TaggingDelay	MMCPrivate	HIT	\N	\N	\N
f	5335	\N	(0029,00a2)	FD	1	Transmitter Frequency	TransmitterFrequency	MMCPrivate	HIT	\N	\N	\N
f	5336	\N	(0029,00a3)	DS	1	Pixel Bandwidth	PixelBandwidth	MMCPrivate	HIT	\N	\N	\N
f	5337	\N	(0029,00a4)	SQ	1	MRVelocity Encoding Sequence	MRVelocityEncodingSequence	MMCPrivate	HIT	\N	\N	\N
f	5338	\N	(0029,00a5)	FD	1	Velocity Encoding Direction	VelocityEncodingDirection	MMCPrivate	HIT	\N	\N	\N
f	5339	\N	(0029,00a6)	FD	1	Velocity Encoding Minimum Value	VelocityEncodingMinimumValue	MMCPrivate	HIT	\N	\N	\N
f	5340	\N	(0029,00a7)	FD	1	Velocity Encoding Maximum Value	VelocityEncodingMaximumValue	MMCPrivate	HIT	\N	\N	\N
f	5341	\N	(0029,00a8)	SQ	1	MR Image Frame Type Sequence	MRImageFrameTypeSequence	MMCPrivate	HIT	\N	\N	\N
f	5342	\N	(0029,00a9)	CS	1	Frame Type	FrameType	MMCPrivate	HIT	\N	\N	\N
f	5343	\N	(0029,00aa)	CS	1	Pixel Presentation	PixelPresentation	MMCPrivate	HIT	\N	\N	\N
f	5344	\N	(0029,00ab)	CS	1	Volumetric Properties	VolumetricProperties	MMCPrivate	HIT	\N	\N	\N
f	5345	\N	(0029,00ac)	CS	1	Volume Based Calculation Technique	VolumeBasedCalculationTechnique	MMCPrivate	HIT	\N	\N	\N
f	5346	\N	(0029,00ad)	IS	1	Filmed Count	FilmedCount	MMCPrivate	HIT	\N	\N	\N
f	5347	\N	(0029,00ae)	LO	1	Is Transferred	IsTransferred	MMCPrivate	HIT	\N	\N	\N
f	5348	\N	(0029,00af)	LO	1	Is Archived	IsArchived	MMCPrivate	HIT	\N	\N	\N
f	5349	\N	(0029,00b0)	LO	1	MPPS Step Status	MPPSStepStatus	MMCPrivate	HIT	\N	\N	\N
f	5350	\N	(0029,00b1)	LO	1	Commitment Status	CommitmentStatus	MMCPrivate	HIT	\N	\N	\N
f	5351	\N	(0029,00b2)	LO	1	Is Storage Committed	IsStorageCommitted	MMCPrivate	HIT	\N	\N	\N
f	5352	\N	(0029,00b3)	LO	1	Is Dicom	IsDicom	MMCPrivate	HIT	\N	\N	\N
f	5353	\N	(0029,00b4)	LO	1	Is Allow Cascade Save	IsAllowCascadeSave	MMCPrivate	HIT	\N	\N	\N
f	5354	\N	(0029,00b5)	LO	1	Is Allow Cascade Protect	IsAllowCascadeProtect	MMCPrivate	HIT	\N	\N	\N
f	5355	\N	(0029,00b6)	LO	1	Is Deleted	IsDeleted	MMCPrivate	HIT	\N	\N	\N
f	5356	\N	(0029,00b7)	OB	1	Application Data	ApplicationData	MMCPrivate	HIT	\N	\N	\N
f	5357	\N	(0029,00b8)	LO	1	Is Allow Cascade Save	IsAllowCascadeSave	MMCPrivate	HIT	\N	\N	\N
f	5358	\N	(0029,00b9)	LO	1	Is Allow Cascade Protect	IsAllowCascadeProtect	MMCPrivate	HIT	\N	\N	\N
f	5359	\N	(0029,00ba)	LO	1	Is Deleted	IsDeleted	MMCPrivate	HIT	\N	\N	\N
f	5360	\N	(0029,00bb)	IS	1	VOI 1	VOI1	MMCPrivate	HIT	\N	\N	\N
f	5361	\N	(0029,00bc)	IS	1	VOI 2	VOI2	MMCPrivate	HIT	\N	\N	\N
f	5362	\N	(0029,00bd)	DS	1	Mixing Time	MixingTime	MMCPrivate	HIT	\N	\N	\N
f	5363	\N	(0029,00be)	FD	1	Selective IR Position	SelectiveIRPosition	MMCPrivate	HIT	\N	\N	\N
f	5364	\N	(0029,00bf)	FD	1	Selective IR Row	SelectiveIRRow	MMCPrivate	HIT	\N	\N	\N
f	5365	\N	(0029,00c0)	FD	1	Selective IR Column	SelectiveIRColumn	MMCPrivate	HIT	\N	\N	\N
f	5366	\N	(0029,00c1)	FD	1	Selective IR Orientation	SelectiveIROrientation	MMCPrivate	HIT	\N	\N	\N
f	5367	\N	(0029,00c2)	DS	1	Selective IR Thickness	SelectiveIRThickness	MMCPrivate	HIT	\N	\N	\N
f	5368	\N	(0029,00c3)	CS	1	Rephase Order Slice	RephaseOrderSlice	MMCPrivate	HIT	\N	\N	\N
f	5369	\N	(0029,00c4)	CS	1	Rephase Order Phase	RephaseOrderPhase	MMCPrivate	HIT	\N	\N	\N
f	5370	\N	(0029,00c5)	CS	1	Rephase Order Freq	RephaseOrderFreq	MMCPrivate	HIT	\N	\N	\N
f	5371	\N	(0029,00d0)	LO	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5373	\N	(0029,00d5)	UI	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5374	\N	(0029,00d6)	LO	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5375	\N	(0029,00d7)	OB	1	Unknown	Unknown	MMCPrivate	HIT	\N	\N	\N
f	5376	\N	(0019,0001)	LO	1	Annotation Version	AnnotationVersion	MeVis BreastCare	MEV	\N	\N	\N
f	5377	\N	(0071,0001)	LO	1	XML Formatted Text Value	XMLFormattedTextValue	MeVis BreastCare	MEV	\N	\N	\N
f	5378	\N	(0065,0093)	CS	1	Unknown	Unknown	Viewing Protocol	\N	\N	\N	\N
f	5379	\N	(1455,0000)	OW	1	ELI Interpretation Vector	ELIInterpretationVector	Mortara_Inc	MOR	\N	\N	\N
f	5380	\N	(1455,0001)	UN	1	Custom ID	CustomID	Mortara_Inc	MOR	\N	\N	\N
f	5381	\N	(1455,0002)	UT	1	Race	Race	Mortara_Inc	MOR	\N	\N	\N
f	5382	\N	(1455,0003)	UT	1	Social Security Number	SocialSecurityNumber	Mortara_Inc	MOR	\N	\N	\N
f	5383	\N	(1455,0004)	UT	1	Attending Physician	AttendingPhysician	Mortara_Inc	MOR	\N	\N	\N
f	5384	\N	(1455,0005)	UT	1	Procedural Diagnosis	ProceduralDiagnosis	Mortara_Inc	MOR	\N	\N	\N
f	5385	\N	(1455,0006)	UT	1	Note 1	Note1	Mortara_Inc	MOR	\N	\N	\N
f	5386	\N	(1455,0007)	UT	1	Note 2	Note2	Mortara_Inc	MOR	\N	\N	\N
f	5387	\N	(1455,0008)	LO	1	Order Request Number	OrderRequestNumber	Mortara_Inc	MOR	\N	\N	\N
f	5388	\N	(1455,0010)	LO	1	Manufacturer Name	ManufacturerName	Mortara_Inc	MOR	\N	\N	\N
f	5389	\N	(0029,0031)	CS	1	Unknown	Unknown	SEGAMI_HEADER	SEG	\N	\N	\N
f	5390	\N	(0029,0032)	OW	1	Unknown	Unknown	SEGAMI_HEADER	SEG	\N	\N	\N
f	5391	\N	(0031,0098)	OW	1	Unknown	Unknown	SEGAMI MIML	SEG	\N	\N	\N
f	5392	\N	(0033,0097)	IS	1	Unknown	Unknown	SEGAMI__PAGE	SEG	\N	\N	\N
f	5393	\N	(0033,0098)	OW	1	Unknown	Unknown	SEGAMI__PAGE	SEG	\N	\N	\N
f	5394	\N	(0035,0097)	SH	1	Unknown	Unknown	SEGAMI__MEMO	SEG	\N	\N	\N
f	5395	\N	(0035,0098)	LT	1	Unknown	Unknown	SEGAMI__MEMO	SEG	\N	\N	\N
f	5396	\N	(5473,0003)	LO	1	Unknown	Unknown	MedIns HP Extensions	\N	\N	\N	\N
f	5397	\N	(0029,0001)	UL	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5398	\N	(0029,0010)	DS	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5399	\N	(0029,0011)	DS	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5400	\N	(0029,0020)	DS	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5401	\N	(0029,0021)	UL	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5402	\N	(0029,0022)	DS	2	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5403	\N	(0029,0030)	LT	1	Unknown	Unknown	MEDIFACE	\N	\N	\N	\N
f	5404	\N	(8003,0000)	LO	1	ID	ID	Image (ID, Version, Size, Dump, GUID)	\N	\N	\N	\N
f	5405	\N	(8003,0010)	LO	1	Version	Version	Image (ID, Version, Size, Dump, GUID)	\N	\N	\N	\N
f	5406	\N	(8003,0020)	UL	1	Size	Size	Image (ID, Version, Size, Dump, GUID)	\N	\N	\N	\N
f	5407	\N	(8003,0030)	OB	1	Dump	Dump	Image (ID, Version, Size, Dump, GUID)	\N	\N	\N	\N
f	5408	\N	(8003,0040)	LO	1	GUID	GUID	Image (ID, Version, Size, Dump, GUID)	\N	\N	\N	\N
f	5409	\N	(8101,0000)	LO	1	ID	ID	ObjectModel (ID, Version, Place, PlaceDescription)	\N	\N	\N	\N
f	5410	\N	(8101,0010)	LO	1	Version	Version	ObjectModel (ID, Version, Place, PlaceDescription)	\N	\N	\N	\N
f	5411	\N	(0015,0010)	LO	1	Unknown	Unknown	INFINITT_FMX	\N	\N	\N	\N
f	5412	\N	(0015,0011)	LO	1	Unknown	Unknown	INFINITT_FMX	\N	\N	\N	\N
f	5413	\N	(0009,0001)	LO	1	Export Platform Name	ExportPlatformName	BrainLAB_Conversion	\N	\N	\N	\N
f	5414	\N	(0009,0002)	OB	1	Export Platform Data	ExportPlatformData	BrainLAB_Conversion	\N	\N	\N	\N
f	5415	\N	(3273,0000)	DS	3	Isocenter Position	IsocenterPosition	BrainLAB_PatientSetup	\N	\N	\N	\N
f	5416	\N	(3273,0001)	CS	1	Patient Position	PatientPosition	BrainLAB_PatientSetup	\N	\N	\N	\N
f	5417	\N	(3411,0001)	SQ	1	Beam Profile Sequence	BeamProfileSequence	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5418	\N	(3411,0002)	IS	1	Beam Profile Number	BeamProfileNumber	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5419	\N	(3411,0003)	SQ	1	Beam Parameter Sequence	BeamParameterSequence	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5420	\N	(3411,0004)	UT	1	Parameter Description	ParameterDescription	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5421	\N	(3411,0005)	OB	1	Parameter Data	ParameterData	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5422	\N	(3411,0006)	IS	1	Referenced Beam Profile Number	ReferencedBeamProfileNumber	BrainLAB_BeamProfile	\N	\N	\N	\N
f	5423	\N	(0011,0001)	OB	1	User Data	UserData	V1	\N	\N	\N	\N
f	5424	\N	(0011,0002)	DS	1	Normalization Coefficient	NormalizationCoefficient	V1	\N	\N	\N	\N
f	5425	\N	(0011,0003)	DS	1-n	Receiving Gain	ReceivingGain	V1	\N	\N	\N	\N
f	5426	\N	(0011,0004)	DS	1	Mean Image Noise	MeanImageNoise	V1	\N	\N	\N	\N
f	5427	\N	(1135,0000)	UI	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5428	\N	(1135,0001)	OB	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5429	\N	(1135,0002)	SQ	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5430	\N	(1135,0006)	UL	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5431	\N	(1135,0007)	UI	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5432	\N	(1135,0008)	SQ	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5433	\N	(1135,0009)	UI	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5434	\N	(1135,0010)	IS	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5435	\N	(1135,0013)	LO	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5436	\N	(1135,0014)	UN	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5437	\N	(1135,0016)	LO	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5438	\N	(1135,0017)	UN	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5439	\N	(1135,0018)	UN	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5440	\N	(1135,0021)	UL	1	Unknown	Unknown	Voxar 2.16.124.113543.6003.1999.12.20.12.5.0	\N	\N	\N	\N
f	5441	\N	(0029,0015)	LO	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5442	\N	(0029,0016)	LO	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5443	\N	(0029,0017)	LO	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5444	\N	(0029,0018)	UT	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5445	\N	(0029,0019)	IS	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5446	\N	(0029,001a)	IS	1	Unknown	Unknown	Kodak Image Information	\N	\N	\N	\N
f	5447	\N	(0037,0001)	LO	1	Unknown	Unknown	MAROTECH Inc.	\N	\N	\N	\N
f	5448	\N	(0037,0021)	US	1	Unknown	Unknown	MAROTECH Inc.	\N	\N	\N	\N
f	5449	\N	(0037,0022)	US	1	Unknown	Unknown	MAROTECH Inc.	\N	\N	\N	\N
f	5450	\N	(0037,0023)	OB	1	Unknown	Unknown	MAROTECH Inc.	\N	\N	\N	\N
f	5451	\N	(0021,0000)	SQ	1	Person Information Sequence	PersonInformationSequence	BRIT Systems, Inc.	\N	\N	\N	\N
f	5452	\N	(0021,0001)	LO	1	Person ID	PersonID	BRIT Systems, Inc.	\N	\N	\N	\N
f	5453	\N	(0021,0002)	PN	1	Person Name	PersonName	BRIT Systems, Inc.	\N	\N	\N	\N
f	5454	\N	(0021,0003)	LO	1	Person Role	PersonRole	BRIT Systems, Inc.	\N	\N	\N	\N
f	5455	\N	(0021,0004)	SH	1	Person Home Phone	PersonHomePhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5456	\N	(0021,0005)	SH	1	Person Work Phone	PersonWorkPhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5457	\N	(0021,0006)	SH	1	Person Cell Phone	PersonCellPhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5458	\N	(0021,0007)	SH	1	Person Pager Phone	PersonPagerPhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5459	\N	(0021,0008)	SH	1	Person Fax Phone	PersonFaxPhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5460	\N	(0021,0009)	LO	1	Person EMail	PersonEMail	BRIT Systems, Inc.	\N	\N	\N	\N
f	5461	\N	(0021,000a)	ST	1	Person Address	PersonAddress	BRIT Systems, Inc.	\N	\N	\N	\N
f	5462	\N	(0021,000b)	LO	1	Person Password	PersonPassword	BRIT Systems, Inc.	\N	\N	\N	\N
f	5463	\N	(0021,000c)	SH	1	Person Emergency Phone	PersonEmergencyPhone	BRIT Systems, Inc.	\N	\N	\N	\N
f	5464	\N	(0021,000d)	LO	1	Physician ID	PhysicianID	BRIT Systems, Inc.	\N	\N	\N	\N
f	5465	\N	(0021,0011)	LO	1	Original Patient ID	OriginalPatientID	BRIT Systems, Inc.	\N	\N	\N	\N
f	5466	\N	(0021,0012)	UI	1	Original Study Instance UID	OriginalStudyInstanceUID	BRIT Systems, Inc.	\N	\N	\N	\N
f	5467	\N	(0021,0013)	UI	1	Original Series Instance UID	OriginalSeriesInstanceUID	BRIT Systems, Inc.	\N	\N	\N	\N
f	5468	\N	(0021,0014)	LO	1	Master Accession Number	MasterAccessionNumber	BRIT Systems, Inc.	\N	\N	\N	\N
f	5469	\N	(0021,0015)	LO	1	Order Category	OrderCategory	BRIT Systems, Inc.	\N	\N	\N	\N
f	5470	\N	(0021,0016)	LO	1	Patient ICN	PatientICN	BRIT Systems, Inc.	\N	\N	\N	\N
f	5471	\N	(0021,0017)	LO	1	Patient DFS	PatientDFS	BRIT Systems, Inc.	\N	\N	\N	\N
f	5472	\N	(0021,0018)	LO	1	Patient Class	PatientClass	BRIT Systems, Inc.	\N	\N	\N	\N
f	5473	\N	(0021,0019)	LO	1	Patient Type	PatientType	BRIT Systems, Inc.	\N	\N	\N	\N
f	5474	\N	(0021,001f)	LT	1	Generic String	GenericString	BRIT Systems, Inc.	\N	\N	\N	\N
f	5475	\N	(0021,0020)	LO	1	QC Study Assigned By	QCStudyAssignedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5476	\N	(0021,0021)	LO	1	QC Study Split By	QCStudySplitBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5477	\N	(0021,0022)	LO	1	QC Study Moved By	QCStudyMovedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5478	\N	(0021,0023)	LO	1	QC Study Edited By	QCStudyEditedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5479	\N	(0021,0024)	LO	1	QC Series Split By	QCSeriesSplitBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5480	\N	(0021,0025)	LO	1	QC Series Moved By	QCSeriesMovedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5481	\N	(0021,0026)	LO	1	QC Series Edited By	QCSeriesEditedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5482	\N	(0021,0027)	LO	1	QC Image Moved By	QCImageMovedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5483	\N	(0021,0028)	LO	1	QC Image Edited By	QCImageEditedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5484	\N	(0021,0030)	LO	1	QC Done Time	QCDoneTime	BRIT Systems, Inc.	\N	\N	\N	\N
f	5485	\N	(0021,0031)	LO	1	QC Last Modification Time	QCLastModificationTime	BRIT Systems, Inc.	\N	\N	\N	\N
f	5486	\N	(0021,0032)	LO	1	QC Image Accepted By	QCImageAcceptedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5487	\N	(0021,0033)	LO	1	QC Image Rejected By	QCImageRejectedBy	BRIT Systems, Inc.	\N	\N	\N	\N
f	5488	\N	(0021,0034)	DA	1	QC Done Date	QCDoneDate	BRIT Systems, Inc.	\N	\N	\N	\N
f	5488	\N	(0021,0034)	DA	1	QC Last Modification Date	QCLastModificationDate	BRIT Systems, Inc.	\N	\N	\N	\N
f	5489	\N	(0021,0050)	LO	1	QC Deletion Requested	QCDeletionRequested	BRIT Systems, Inc.	\N	\N	\N	\N
f	5490	\N	(0021,0090)	AE	1	Original Sender AE Title	OriginalSenderAETitle	BRIT Systems, Inc.	\N	\N	\N	\N
f	5491	\N	(0021,0091)	LO	1	Software Title	SoftwareTitle	BRIT Systems, Inc.	\N	\N	\N	\N
f	5492	\N	(0021,0092)	SH	1	Software Version	SoftwareVersion	BRIT Systems, Inc.	\N	\N	\N	\N
f	5493	\N	(0021,0093)	LO	1	Serial Number	SerialNumber	BRIT Systems, Inc.	\N	\N	\N	\N
f	5494	\N	(0021,00a0)	SQ	1	Object Action Sequence	ObjectActionSequence	BRIT Systems, Inc.	\N	\N	\N	\N
f	5495	\N	(0021,00a1)	ST	1	Object Action	ObjectAction	BRIT Systems, Inc.	\N	\N	\N	\N
f	5496	\N	(0021,00a2)	DA	1	Object Action Date	ObjectActionDate	BRIT Systems, Inc.	\N	\N	\N	\N
f	5497	\N	(0021,00a3)	TM	1	Object Action Time	ObjectActionTime	BRIT Systems, Inc.	\N	\N	\N	\N
f	5498	\N	(0021,00a5)	AE	1	Local AE Title	LocalAETitle	BRIT Systems, Inc.	\N	\N	\N	\N
f	5499	\N	(0021,00a6)	SH	1	Local IP Address	LocalIPAddress	BRIT Systems, Inc.	\N	\N	\N	\N
f	5500	\N	(0021,00a7)	AE	1	Remote AE Title	RemoteAETitle	BRIT Systems, Inc.	\N	\N	\N	\N
f	5501	\N	(0021,00a8)	SH	1	Remote IP Address	RemoteIPAddress	BRIT Systems, Inc.	\N	\N	\N	\N
f	5502	\N	(3005,0000)	SQ	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5503	\N	(3005,0002)	CS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5504	\N	(3005,0004)	DS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5505	\N	(3005,0006)	DS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5506	\N	(3005,0008)	DS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5507	\N	(3005,000a)	CS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5508	\N	(3005,000c)	CS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5509	\N	(3005,000e)	CS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5510	\N	(3005,0010)	DS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5511	\N	(3005,0012)	DS	1	Unknown	Unknown	MDS NORDION OTP ANATOMY MODELLING	\N	\N	\N	\N
f	5512	\N	(4321,0041)	CS	1	Unknown	Unknown	Imaging Dynamics Company Ltd.	\N	\N	\N	\N
f	5513	\N	(4321,0042)	US	1	Unknown	Unknown	Imaging Dynamics Company Ltd.	\N	\N	\N	\N
f	5514	\N	(4321,0064)	LO	1	POD Mode	PODMode	Imaging Dynamics Company Ltd.	\N	\N	\N	\N
f	5515	\N	(f001,0000)	LO	1	Patient Species	PatientSpecies	Sound Technologies	\N	\N	\N	\N
f	5516	\N	(f001,0001)	LO	1	Patient Breed	PatientBreed	Sound Technologies	\N	\N	\N	\N
f	5517	\N	(f001,0002)	LO	1	Patient Category Size	PatientCategorySize	Sound Technologies	\N	\N	\N	\N
f	5518	\N	(f001,0003)	CS	1	Patient Sex Extended	PatientSexExtended	Sound Technologies	\N	\N	\N	\N
f	5519	\N	(f001,0004)	LO	1	Image View	ImageView	Sound Technologies	\N	\N	\N	\N
f	5520	\N	(f001,0005)	LO	1	Anatomy Imaged	AnatomyImaged	Sound Technologies	\N	\N	\N	\N
f	5521	\N	(f001,0006)	LT	1	Image Enhancements	ImageEnhancements	Sound Technologies	\N	\N	\N	\N
f	5522	\N	(f001,0007)	LO	1	Detector Settings	DetectorSettings	Sound Technologies	\N	\N	\N	\N
f	5523	\N	(f001,0008)	LO	1	Application Version	ApplicationVersion	Sound Technologies	\N	\N	\N	\N
f	5524	\N	(f001,0009)	LO	1	Image Laterality Extended	ImageLateralityExtended	Sound Technologies	\N	\N	\N	\N
f	5525	\N	(f001,000a)	PN	1	Client Name	ClientName	Sound Technologies	\N	\N	\N	\N
f	5526	\N	(f001,000b)	UI	1	Reference Study Instance UID	ReferenceStudyInstanceUID	Sound Technologies	\N	\N	\N	\N
f	5527	\N	(f001,000c)	UI	1	Reference Study Instance UID	ReferenceStudyInstanceUID	Sound Technologies	\N	\N	\N	\N
f	5528	\N	(f001,000d)	LO	1	Exam Ref ID	ExamRefID	Sound Technologies	\N	\N	\N	\N
f	5529	\N	(f001,000e)	ST	1	Physician of Record Address	PhysicianOfRecordAddress	Sound Technologies	\N	\N	\N	\N
f	5530	\N	(f001,000f)	SH	1	Physician of Record Phone Numbers	PhysicianOfRecordPhoneNumbers	Sound Technologies	\N	\N	\N	\N
f	5531	\N	(f001,0010)	LT	1	Reason For Study	ReasonForStudy	Sound Technologies	\N	\N	\N	\N
f	5532	\N	(f001,0011)	LO	1	Protocol	Protocol	Sound Technologies	\N	\N	\N	\N
f	5533	\N	(f001,0012)	LO	1	Capture Input Type	CaptureInputType	Sound Technologies	\N	\N	\N	\N
f	5534	\N	(f001,0013)	LT	1	Exam Complaint	ExamComplaint	Sound Technologies	\N	\N	\N	\N
f	5535	\N	(f001,0014)	LO	1	Exam Web Code	ExamWebCode	Sound Technologies	\N	\N	\N	\N
f	5536	\N	(f001,0015)	LO	1	Exam Category	ExamCategory	Sound Technologies	\N	\N	\N	\N
f	5537	\N	(f001,0016)	SH	1	Exam Diagnosis	ExamDiagnosis	Sound Technologies	\N	\N	\N	\N
f	5538	\N	(f001,0017)	PN	1	Exam Created By	ExamCreatedBy	Sound Technologies	\N	\N	\N	\N
f	5539	\N	(f001,0018)	LO	1	Exam Created By Group	ExamCreatedByGroup	Sound Technologies	\N	\N	\N	\N
f	5540	\N	(f001,0019)	DT	1	Exam Required By DateTime	ExamRequiredByDateTime	Sound Technologies	\N	\N	\N	\N
f	5541	\N	(f001,001a)	LO	1	Capture Type	CaptureType	Sound Technologies	\N	\N	\N	\N
f	5542	\N	(f001,001b)	IS	1	Telemed Exam ID	TelemedExamID	Sound Technologies	\N	\N	\N	\N
f	5543	\N	(f001,001c)	LO	1	Exam Created By Guid	ExamCreatedByGuid	Sound Technologies	\N	\N	\N	\N
f	5544	\N	(f001,001d)	LO	1	Client Name Guid	ClientNameGuid	Sound Technologies	\N	\N	\N	\N
f	5545	\N	(f001,001e)	LO	1	Receptor Bits Per Pixel	ReceptorBitsPerPixel	Sound Technologies	\N	\N	\N	\N
f	5546	\N	(3711,0001)	LO	1	Filename	Filename	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5547	\N	(3711,0002)	OB	1	Data Blob of a Visit	DataBlobOfAVisit	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5548	\N	(3711,0003)	US	1	Revision Number	RevisionNumber	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5549	\N	(3711,0004)	UL	1	Unix Timestamp	UnixTimestamp	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5550	\N	(3711,0005)	IS	1	Bag ID	BagID	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5551	\N	(3711,000c)	UI	1	Original Study UID	OriginalStudyUID	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5552	\N	(3711,000d)	US	1	Overlay Grayscale Value	OverlayGrayscaleValue	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5553	\N	(3711,000e)	CS	1	Anonymization Status	AnonymizationStatus	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5554	\N	(3711,000f)	CS	1	Instance Type	InstanceType	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5555	\N	(3711,0030)	LO	1	IP Converted Frame	IPConvertedFrame	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5556	\N	(3711,0097)	OB	1	Unknown	Unknown	A.L.I. Technologies, Inc.	\N	\N	\N	\N
f	5557	\N	(7777,0002)	UT	1	Interfile	Interfile	NUD_PRIVATE	\N	\N	\N	\N
f	5558	\N	(7777,0005)	IS	1	Unknown	Unknown	NUD_PRIVATE	\N	\N	\N	\N
f	5559	\N	(0011,0000)	LO	1	Breed Name	BreedName	IDEXX	\N	\N	\N	\N
f	5560	\N	(0011,0001)	LO	1	Species Name	SpeciesName	IDEXX	\N	\N	\N	\N
f	5561	\N	(0011,0002)	PN	1	Owner	Owner	IDEXX	\N	\N	\N	\N
f	5562	\N	(0009,0001)	SQ	1	Event Timer Sequence	EventTimerSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5563	\N	(0009,0002)	FD	1	Event Time Interval	EventTimeInterval	WG12 Supplement 43	SUP43	\N	\N	\N
f	5564	\N	(0009,0003)	SQ	1	Event Code Sequence	EventCodeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5565	\N	(0019,0001)	FD	1	Focus Depth(s)	FocusDepth	WG12 Supplement 43	SUP43	\N	\N	\N
f	5566	\N	(0019,0003)	SQ	1	Excluded Intervals Sequence	ExcludedIntervalsSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5567	\N	(0019,0004)	DT	1	Exclusion Start Datetime	ExclusionStartDatetime	WG12 Supplement 43	SUP43	\N	\N	\N
f	5568	\N	(0019,0005)	FD	1	Exclusion Duration	ExclusionDuration	WG12 Supplement 43	SUP43	\N	\N	\N
f	5569	\N	(0019,0006)	SQ	1	US Image Description Sequence	USImageDescriptionSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5570	\N	(0019,0007)	SQ	1	Image Data Type Sequence	ImageDataTypeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5571	\N	(0019,0008)	CS	1	Data Type	DataType	WG12 Supplement 43	SUP43	\N	\N	\N
f	5572	\N	(0019,0009)	SQ	1	Transducer Scan Geometry Code Sequence	TransducerScanGeometryCodeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5573	\N	(0019,000b)	CS	1	Aliased Data Type	AliasedDataType	WG12 Supplement 43	SUP43	\N	\N	\N
f	5574	\N	(0019,000c)	CS	1	Position Measuring Device Used	PositionMeasuringDeviceUsed	WG12 Supplement 43	SUP43	\N	\N	\N
f	5575	\N	(0019,000d)	SQ	1	Transducer Scanning Configuration Code Sequence	TransducerScanningConfigurationCodeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5576	\N	(0019,000e)	SQ	1	Transducer Beam Steering Code Sequence	TransducerBeamSteeringCodeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5577	\N	(0019,000f)	SQ	1	Transducer Access Code Sequence	TransducerAccessCodeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5578	\N	(0021,0001)	FD	1	Image Position (Volume)	ImagePositionVolume	WG12 Supplement 43	SUP43	\N	\N	\N
f	5579	\N	(0021,0002)	FD	1	Image Orientation (Volume)	ImageOrientationVolume	WG12 Supplement 43	SUP43	\N	\N	\N
f	5580	\N	(0021,0007)	CS	1	Ultrasound Acquisition Geometry	UltrasoundAcquisitionGeometry	WG12 Supplement 43	SUP43	\N	\N	\N
f	5581	\N	(0021,0008)	FD	1	Apex Position	ApexPosition	WG12 Supplement 43	SUP43	\N	\N	\N
f	5582	\N	(0021,0009)	FD	1	Volume to Transducer Mapping Matrix	VolumeToTransducerMappingMatrix	WG12 Supplement 43	SUP43	\N	\N	\N
f	5583	\N	(0021,000a)	FD	1	Volume to Table Mapping Matrix	VolumeToTableMappingMatrix	WG12 Supplement 43	SUP43	\N	\N	\N
f	5584	\N	(0021,000c)	CS	1	Patient Frame of Reference Source	PatientFrameOfReferenceSource	WG12 Supplement 43	SUP43	\N	\N	\N
f	5585	\N	(0021,000d)	FD	1	Temporal Position Time Offset	TemporalPositionTimeOffset	WG12 Supplement 43	SUP43	\N	\N	\N
f	5586	\N	(0021,000e)	SQ	1	Plane Position (Volume) Sequence	PlanePositionVolumeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5587	\N	(0021,000f)	SQ	1	Plane Orientation (Volume) Sequence	PlaneOrientationVolumeSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5588	\N	(0021,0010)	SQ	1	Temporal Position Sequence	TemporalPositionSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5589	\N	(0021,0011)	CS	1	Dimension Organization Type	DimensionOrganizationType	WG12 Supplement 43	SUP43	\N	\N	\N
f	5590	\N	(0029,0001)	SQ	1	Data Frame Assignment Sequence	DataFrameAssignmentSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5591	\N	(0029,0002)	CS	1	Data Path Assignment	DataPathAssignment	WG12 Supplement 43	SUP43	\N	\N	\N
f	5592	\N	(0029,0003)	US	1	Bits Mapped to Color Lookup Table	BitsMappedToColorLookupTable	WG12 Supplement 43	SUP43	\N	\N	\N
f	5593	\N	(0029,0004)	SQ	1	Opacity 1 LUT Sequence	Opacity1LUTSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5594	\N	(0029,0005)	CS	1	Opacity 1 LUT Transfer Function	Opacity1LUTTransferFunction	WG12 Supplement 43	SUP43	\N	\N	\N
f	5595	\N	(0029,0006)	FD	1	Opacity Constant	OpacityConstant	WG12 Supplement 43	SUP43	\N	\N	\N
f	5596	\N	(0029,0007)	US	1	Opacity Lookup Table Descriptor	OpacityLookupTableDescriptor	WG12 Supplement 43	SUP43	\N	\N	\N
f	5597	\N	(0029,0008)	OW	1	Opacity Lookup Table Data	OpacityLookupTableData	WG12 Supplement 43	SUP43	\N	\N	\N
f	5598	\N	(0029,000b)	SQ	1	Enhanced Palette Color Lookup Table Sequence	EnhancedPaletteColorLookupTableSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5599	\N	(0029,000c)	SQ	1	Opacity 2 LUT Sequence	Opacity2LUTSequence	WG12 Supplement 43	SUP43	\N	\N	\N
f	5600	\N	(0029,000d)	CS	1	Opacity 2 LUT Transfer Function	Opacity2LUTTransferFunction	WG12 Supplement 43	SUP43	\N	\N	\N
f	5601	\N	(0029,000e)	CS	1	Data Path ID	DataPathID	WG12 Supplement 43	SUP43	\N	\N	\N
f	5602	\N	(0029,000f)	CS	1	RGB LUT Transfer Function	RGBLUTTransferFunction	WG12 Supplement 43	SUP43	\N	\N	\N
f	5603	\N	(0029,0010)	CS	1	Alpha LUT Transfer Function	AlphaLUTTransferFunction	WG12 Supplement 43	SUP43	\N	\N	\N
f	5604	\N	(0041,0001)	CS	1	Performed Protocol Type	PerformedProtocolType	WG12 Supplement 43	SUP43	\N	\N	\N
f	5605	\N	(0009,0000)	OB	1	Image ID Information Patient Name ID	ImageIDInformationPatientNameID	HMC - CT - ID	HMC	\N	\N	\N
f	5606	\N	(0009,0001)	OB	1	Image ID Information Patient Comment	ImageIDInformationPatientComment	HMC - CT - ID	HMC	\N	\N	\N
f	5607	\N	(0019,0000)	SH	1	Set Window Image Filter	SetWindowImageFilter	SET WINDOW	HMC	\N	\N	\N
f	5608	\N	(0019,0001)	US	1	Set Window Magnification Power	SetWindowMagnificationPower	SET WINDOW	HMC	\N	\N	\N
f	2616	\N	(0017,0000)	LO	1	Extended Body Part	ExtendedBodyPart	SVISION	SWS	\N	\N	\N
f	2617	\N	(0017,0010)	LO	1	Extended View Position	ExtendedViewPosition	SVISION	SWS	\N	\N	\N
f	5609	\N	(0017,0020)	SQ	1	Scheduled Procedure Step List	ScheduledProcedureStepList	SVISION	SWS	\N	\N	\N
f	5610	\N	(0017,00a0)	IS	1	Fixed Grid System	FixedGridSystem	SVISION	SWS	\N	\N	\N
f	5611	\N	(0017,00f0)	IS	1	Images SOP Class	ImagesSOPClass	SVISION	SWS	\N	\N	\N
f	2619	\N	(0019,0000)	IS	1	AEC Field	Unknown	SVISION	SWS	\N	\N	\N
f	2620	\N	(0019,0001)	IS	1	AEC Film Screen	Unknown	SVISION	SWS	\N	\N	\N
f	2621	\N	(0019,0002)	IS	1	AEC Density	Unknown	SVISION	SWS	\N	\N	\N
f	2622	\N	(0019,0010)	IS	1	Patient Thickness	Unknown	SVISION	SWS	\N	\N	\N
f	5612	\N	(0019,0016)	IS	1	Unknown	Unknown	SVISION	SWS	\N	\N	\N
f	2623	\N	(0019,0018)	IS	1	Beam Distance	Unknown	SVISION	SWS	\N	\N	\N
f	2624	\N	(0019,0020)	IS	1	Workstation Number	Unknown	SVISION	SWS	\N	\N	\N
f	2625	\N	(0019,0028)	IS	1	Tube Number	Unknown	SVISION	SWS	\N	\N	\N
f	2626	\N	(0019,0030)	IS	1	Bucky Grid	Unknown	SVISION	SWS	\N	\N	\N
f	2627	\N	(0019,0034)	IS	1	Focus	Unknown	SVISION	SWS	\N	\N	\N
f	2628	\N	(0019,0038)	IS	1	Age Group	Unknown	SVISION	SWS	\N	\N	\N
f	2629	\N	(0019,0040)	IS	1	Collimator Distance X	Unknown	SVISION	SWS	\N	\N	\N
f	2630	\N	(0019,0041)	IS	1	Collimator Distance Y	Unknown	SVISION	SWS	\N	\N	\N
f	2631	\N	(0019,0050)	IS	1	Bucky Height	Unknown	SVISION	SWS	\N	\N	\N
f	2632	\N	(0019,0060)	IS	1	Bucky Angle	Unknown	SVISION	SWS	\N	\N	\N
f	2633	\N	(0019,0068)	IS	1	C-Arm Angle	Unknown	SVISION	SWS	\N	\N	\N
f	2634	\N	(0019,0069)	IS	1	Collimator Angle	Unknown	SVISION	SWS	\N	\N	\N
f	2635	\N	(0019,0070)	IS	1	Filter Number	Unknown	SVISION	SWS	\N	\N	\N
f	2636	\N	(0019,0074)	IS	1	Filter Material 1	Unknown	SVISION	SWS	\N	\N	\N
f	2637	\N	(0019,0075)	IS	1	Filter Material 2	Unknown	SVISION	SWS	\N	\N	\N
f	2638	\N	(0019,0078)	DS	1	Filter Thickness 1	Unknown	SVISION	SWS	\N	\N	\N
f	2639	\N	(0019,0079)	DS	1	Filter Thickness 2	Unknown	SVISION	SWS	\N	\N	\N
f	2640	\N	(0019,0080)	IS	1	Bucky Format	Unknown	SVISION	SWS	\N	\N	\N
f	2641	\N	(0019,0081)	IS	1	Object Position	Unknown	SVISION	SWS	\N	\N	\N
f	2642	\N	(0019,0090)	LO	1	Desk Command	Unknown	SVISION	SWS	\N	\N	\N
f	5613	\N	(0019,0091)	IS	1	Central Beam X	Unknown	SVISION	SWS	\N	\N	\N
f	5614	\N	(0019,0092)	IS	1	Central Beam Y	Unknown	SVISION	SWS	\N	\N	\N
f	5615	\N	(0019,0093)	IS	1	Tube Turn Angle	Unknown	SVISION	SWS	\N	\N	\N
f	5616	\N	(0019,0094)	IS	1	Stand Drive Level	Unknown	SVISION	SWS	\N	\N	\N
f	5617	\N	(0019,00a0)	DS	1	Extended Exposure Time	Unknown	SVISION	SWS	\N	\N	\N
f	5618	\N	(0019,00a1)	DS	1	Actual Exposure Time	Unknown	SVISION	SWS	\N	\N	\N
f	5619	\N	(0019,00a8)	DS	1	Extended X-ray Tube Current	Unknown	SVISION	SWS	\N	\N	\N
f	5620	\N	(0019,00b0)	IS	1	Dose Indicator	Unknown	SVISION	SWS	\N	\N	\N
f	5621	\N	(0019,00b1)	IS	1	Shift Reference Value	Unknown	SVISION	SWS	\N	\N	\N
f	5622	\N	(0019,00f0)	IS	1	Unknown	Unknown	SVISION	SWS	\N	\N	\N
f	2646	\N	(0021,0000)	DS	1	Noise Reduction	Unknown	SVISION	SWS	\N	\N	\N
f	2647	\N	(0021,0001)	DS	1	Contrast Amplification	Unknown	SVISION	SWS	\N	\N	\N
f	2648	\N	(0021,0002)	DS	1	Edge Contrast Boosting	Unknown	SVISION	SWS	\N	\N	\N
f	2649	\N	(0021,0003)	DS	1	Latitude Reduction	Unknown	SVISION	SWS	\N	\N	\N
f	2650	\N	(0021,0010)	LO	1	Find Range Algorithm	Unknown	SVISION	SWS	\N	\N	\N
f	2651	\N	(0021,0011)	DS	1	Threshold C-Algorithm	Unknown	SVISION	SWS	\N	\N	\N
f	2652	\N	(0021,0020)	LO	1	Sensometric Curve	Unknown	SVISION	SWS	\N	\N	\N
f	2653	\N	(0021,0030)	DS	1	Lower Window Offset	Unknown	SVISION	SWS	\N	\N	\N
f	2654	\N	(0021,0031)	DS	1	Upper Window Offset	Unknown	SVISION	SWS	\N	\N	\N
f	2655	\N	(0021,0040)	DS	1	Minimal Printable Density	Unknown	SVISION	SWS	\N	\N	\N
f	2656	\N	(0021,0041)	DS	1	Maximal Printable Density	Unknown	SVISION	SWS	\N	\N	\N
f	5623	\N	(0021,0050)	DS	1	Minimal Window Latitude	Unknown	SVISION	SWS	\N	\N	\N
f	5624	\N	(0021,0051)	DS	1	Maximal Window Latitude	Unknown	SVISION	SWS	\N	\N	\N
f	5625	\N	(0021,0052)	DS	1	Relative Window Alignment	Unknown	SVISION	SWS	\N	\N	\N
f	5626	\N	(0021,0060)	IS	1	Decomposition Layer	Unknown	SVISION	SWS	\N	\N	\N
f	2657	\N	(0021,0090)	DS	1	Brightness	Unknown	SVISION	SWS	\N	\N	\N
f	2658	\N	(0021,0091)	DS	1	Contrast	Unknown	SVISION	SWS	\N	\N	\N
f	2659	\N	(0021,0092)	DS	1	Shape Factor	Unknown	SVISION	SWS	\N	\N	\N
f	2660	\N	(0023,0000)	LO	1	Image Laterality	Unknown	SVISION	SWS	\N	\N	\N
f	2661	\N	(0023,0001)	IS	1	Letter Position	Unknown	SVISION	SWS	\N	\N	\N
f	2662	\N	(0023,0002)	IS	1	Burned In Annotation	Unknown	SVISION	SWS	\N	\N	\N
f	2663	\N	(0023,0003)	LO	1	Unknown	Unknown	SVISION	SWS	\N	\N	\N
f	5627	\N	(0023,00f0)	IS	1	Image SOP Class	Unknown	SVISION	SWS	\N	\N	\N
f	2665	\N	(0025,0000)	IS	1	Original Image	Unknown	SVISION	SWS	\N	\N	\N
f	2666	\N	(0025,0001)	IS	1	Not Processed Image	Unknown	SVISION	SWS	\N	\N	\N
f	2667	\N	(0025,0002)	IS	1	Cut Out Image	Unknown	SVISION	SWS	\N	\N	\N
f	2668	\N	(0025,0003)	IS	1	Duplicated Image	Unknown	SVISION	SWS	\N	\N	\N
f	2669	\N	(0025,0004)	IS	1	Stored Image	Unknown	SVISION	SWS	\N	\N	\N
f	2670	\N	(0025,0005)	IS	1	Retrieved Image	Unknown	SVISION	SWS	\N	\N	\N
f	2671	\N	(0025,0006)	IS	1	New Image	Unknown	SVISION	SWS	\N	\N	\N
f	2672	\N	(0025,0007)	IS	1	Media Stored Image	Unknown	SVISION	SWS	\N	\N	\N
f	2673	\N	(0025,0008)	IS	1	Image State	Unknown	SVISION	SWS	\N	\N	\N
f	5628	\N	(0025,0009)	IS	1	Image Stitched Manually	Unknown	SVISION	SWS	\N	\N	\N
f	5629	\N	(0025,000a)	IS	1	Image Stitched Automatically	Unknown	SVISION	SWS	\N	\N	\N
f	2674	\N	(0025,0020)	LO	1	Source Image File	Unknown	SVISION	SWS	\N	\N	\N
f	2675	\N	(0025,0021)	LO	1	Source UID	Unknown	SVISION	SWS	\N	\N	\N
f	2676	\N	(0027,0000)	IS	1	Number of Series	Unknown	SVISION	SWS	\N	\N	\N
f	2677	\N	(0027,0001)	IS	1	Number of Studies	Unknown	SVISION	SWS	\N	\N	\N
f	2678	\N	(0027,0010)	DT	1	Oldest Series	Unknown	SVISION	SWS	\N	\N	\N
f	2679	\N	(0027,0011)	DT	1	Newest Series	Unknown	SVISION	SWS	\N	\N	\N
f	2680	\N	(0027,0012)	DT	1	Oldest Study	Unknown	SVISION	SWS	\N	\N	\N
f	2681	\N	(0027,0013)	DT	1	Newest Study	Unknown	SVISION	SWS	\N	\N	\N
f	5630	\N	(0029,0000)	IS	1	Key Note Instance UID	Unknown	SVISION	SWS	\N	\N	\N
f	5631	\N	(0029,0001)	IS	1	Storage State	Unknown	SVISION	SWS	\N	\N	\N
f	5632	\N	(0029,0002)	IS	1	Referenced Image SOP Class	Unknown	SVISION	SWS	\N	\N	\N
f	5633	\N	(0029,0003)	IS	1	Referenced Image Instance UID	Unknown	SVISION	SWS	\N	\N	\N
f	5634	\N	(0029,0004)	IS	1	Related Presentation State Number	Unknown	SVISION	SWS	\N	\N	\N
f	5635	\N	(0029,0005)	IS	1	Related Presentation State UID	Unknown	SVISION	SWS	\N	\N	\N
f	5636	\N	(5653,0010)	OB	1	Saved Workflow	SavedWorkflow	Vital Images SW 3.4	VIT	\N	\N	\N
f	5637	\N	(5653,0011)	LO	1	Saved Workflow File Name	SavedWorkflowFileName	Vital Images SW 3.4	VIT	\N	\N	\N
f	5638	\N	(5653,0012)	OB	1	Saved Workflow File Data	SavedWorkflowFileData	Vital Images SW 3.4	VIT	\N	\N	\N
f	5639	\N	(5653,0013)	SL	1	Saved Workflow File Length	SavedWorkflowFileLength	Vital Images SW 3.4	VIT	\N	\N	\N
f	5640	\N	(5653,0014)	SQ	1	Saved Workflow File Sequence	SavedWorkflowFileSequence	Vital Images SW 3.4	VIT	\N	\N	\N
f	5641	\N	(5653,0015)	SQ	1	Image Sequence	ImageSequence	Vital Images SW 3.4	VIT	\N	\N	\N
f	5642	\N	(5653,0016)	SL	1	Volume Interpolated Slices	VolumeInterpolatedSlices	Vital Images SW 3.4	VIT	\N	\N	\N
f	5643	\N	(5653,0017)	UI	1	Volume SOP Instance UID	VolumeSOPInstanceUID	Vital Images SW 3.4	VIT	\N	\N	\N
f	5644	\N	(5653,0018)	SH	1	Saved Workflow Mark	SavedWorkflowMark	Vital Images SW 3.4	VIT	\N	\N	\N
f	5645	\N	(5653,0019)	UI	1	Volume Study Instance UID	VolumeStudyInstanceUID	Vital Images SW 3.4	VIT	\N	\N	\N
f	5646	\N	(5653,0020)	SL	1	Number of Study Saved Workflow	NumStudySwf	Vital Images SW 3.4	VIT	\N	\N	\N
f	5647	\N	(5653,0021)	SL	1	Number of Series Saved Workflow	NumSeriesSwf	Vital Images SW 3.4	VIT	\N	\N	\N
f	5648	\N	(5653,0022)	UI	1	Volume Series Instance UID	VolumeSeriesInstanceUID	Vital Images SW 3.4	VIT	\N	\N	\N
f	5649	\N	(5653,0023)	LO	1	Saved Workflow Code Meaning	SavedWorkflowCodeMeaning	Vital Images SW 3.4	VIT	\N	\N	\N
f	5650	\N	(5653,0024)	OB	1	Saved Workflow Data	SavedWorkflowData	Vital Images SW 3.4	VIT	\N	\N	\N
f	5651	\N	(5653,0025)	SL	1	Saved Workflow Data Length	SavedWorkflowDataLength	Vital Images SW 3.4	VIT	\N	\N	\N
f	5652	\N	(0781,0001)	US	1	Unknown	Unknown	PI Private Block (0781:3000 - 0781:30FF)	ALICE	\N	\N	\N
f	5653	\N	(0781,0002)	US	1	Unknown	Unknown	PI Private Block (0781:3000 - 0781:30FF)	ALICE	\N	\N	\N
f	5654	\N	(0781,0005)	FL	1	Unknown	Unknown	PI Private Block (0781:3000 - 0781:30FF)	ALICE	\N	\N	\N
f	5655	\N	(0781,0009)	FL	4	Unknown	Unknown	PI Private Block (0781:3000 - 0781:30FF)	ALICE	\N	\N	\N
f	5656	\N	(0203,0000)	LO	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5657	\N	(0203,0001)	LO	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5658	\N	(0203,0002)	LO	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5659	\N	(0203,0003)	LO	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5660	\N	(0203,0010)	LO	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5661	\N	(0203,00f0)	UI	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	5662	\N	(0203,00f1)	UI	1	Unknown	Unknown	Riverain Medical	RVN	\N	\N	\N
f	910	\N	(0029,0010)	CS	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	911	\N	(0029,0011)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	912	\N	(0029,0012)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	913	\N	(0029,0013)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	915	\N	(0029,0015)	DS	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5663	\N	(0029,0016)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5664	\N	(0029,0017)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	916	\N	(0029,0020)	LO	1	MD5Sum	MD5Sum	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	917	\N	(0029,0021)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	918	\N	(0029,0022)	US	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5665	\N	(0071,0001)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5666	\N	(0071,0002)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5667	\N	(0071,0003)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5668	\N	(0071,0004)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5669	\N	(0071,0005)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5670	\N	(0071,0006)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5671	\N	(0071,0007)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	5672	\N	(0071,000a)	UN	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS INTELEVIEWER	INT	\N	\N	\N
f	919	\N	(3f01,0001)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	921	\N	(3f01,0003)	AE	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	922	\N	(3f01,0004)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	923	\N	(3f01,0005)	AE	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	925	\N	(3f01,0007)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5673	\N	(3f01,0009)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5674	\N	(3f01,000a)	DA	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5675	\N	(3f01,000b)	TM	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5676	\N	(3f03,0001)	SQ	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5677	\N	(3f03,0002)	DT	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5678	\N	(3f03,0003)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5679	\N	(3f03,0004)	LO	1	Unknown	Unknown	INTELERAD MEDICAL SYSTEMS	INT	\N	\N	\N
f	5680	\N	(4453,0000)	LO	1	Exam ?	Unknown	DR Systems, Inc.	DRS	\N	\N	\N
f	5681	\N	(4453,0001)	LO	1	Exam ID	ExamID	DR Systems, Inc.	DRS	\N	\N	\N
f	5682	\N	(4453,0002)	LO	1	Image Type	ImageType	DR Systems, Inc.	DRS	\N	\N	\N
f	5683	\N	(4453,0004)	LO	1	File Type	FileType	DR Systems, Inc.	DRS	\N	\N	\N
f	5684	\N	(4453,0005)	LO	1	File Suffix	FileSuffix	DR Systems, Inc.	DRS	\N	\N	\N
f	5685	\N	(4453,000a)	LO	1	Annotation Type	AnnotationType	DR Systems, Inc.	DRS	\N	\N	\N
f	5686	\N	(4453,000c)	SQ	1	Original Instance UID Sequence	OriginalInstanceUIDSequence	DR Systems, Inc.	DRS	\N	\N	\N
f	5687	\N	(0859,0040)	DS	1	Unknown	Unknown	ETIAM DICOMDIR	INT	\N	\N	\N
f	5688	\N	(0077,0010)	UI	1-n	Original Series/Study UID	OriginalSeriesStudyUID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5689	\N	(0077,0012)	UI	1-n	Original SOP UID	OriginalSOPUID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5690	\N	(0077,0014)	LO	1-n	Referenced Volume ID	ReferencedVolumeID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5691	\N	(0077,0016)	CS	1	Binary Data Name SCS	BinaryDataNameSCS	TERARECON AQUARIUS	TER	\N	\N	\N
f	5692	\N	(0077,0020)	LO	1-n	Binary Data Name	BinaryDataName	TERARECON AQUARIUS	TER	\N	\N	\N
f	5693	\N	(0077,0022)	CS	1-n	Number of SOP Instance UID	NumberOfSOPInstanceUID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5694	\N	(0077,0024)	CS	1-n	Number of Series Instance UID	NumberOfSeriesInstanceUID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5695	\N	(0077,0026)	US	1	Number of Binary Data	NumberOfBinaryData	TERARECON AQUARIUS	TER	\N	\N	\N
f	5696	\N	(0077,0028)	CS	1-n	Binary Data Type	BinaryDataType	TERARECON AQUARIUS	TER	\N	\N	\N
f	5697	\N	(0077,0030)	UL	1-n	Binary Data Size	BinaryDataSize	TERARECON AQUARIUS	TER	\N	\N	\N
f	5698	\N	(0077,0032)	LO	1-n	Binary Data SubType	BinaryDataSubType	TERARECON AQUARIUS	TER	\N	\N	\N
f	5699	\N	(0077,0040)	LO	1-n	Additional Information	AdditionalInformation	TERARECON AQUARIUS	TER	\N	\N	\N
f	5700	\N	(0077,0050)	OB	1	First Binary Data	FirstBinaryData	TERARECON AQUARIUS	TER	\N	\N	\N
f	5701	\N	(0077,0060)	OB	1	First Thumbnail	FirstThumbnail	TERARECON AQUARIUS	TER	\N	\N	\N
f	5702	\N	(0077,0070)	LO	1	Algorithm ID	AlgorithmID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5703	\N	(0077,0080)	LO	1	Volume ID	VolumeID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5704	\N	(0077,0084)	LO	1-n	COF Object UID	COFObjectUID	TERARECON AQUARIUS	TER	\N	\N	\N
f	5705	\N	(0077,0086)	LO	1-n	Workflow Scene Status	WorkflowSceneStatus	TERARECON AQUARIUS	TER	\N	\N	\N
f	5706	\N	(0077,0088)	UI	1-n	Reference SOP Instance UIDs	ReferenceSOPInstanceUIDs	TERARECON AQUARIUS	TER	\N	\N	\N
f	5707	\N	(0077,0090)	FL	1	COF Refinement Level	COFRefinementLevel	TERARECON AQUARIUS	TER	\N	\N	\N
f	5708	\N	(0009,0000)	LO	1	Unknown	Unknown	EMAGEON STUDY HOME	EMG	\N	\N	\N
f	5709	\N	(0009,0001)	LO	1	Unknown	Unknown	EMAGEON STUDY HOME	EMG	\N	\N	\N
f	5710	\N	(0009,0000)	SQ	1	Unknown	Unknown	EMAGEON JPEG2K INFO	EMG	\N	\N	\N
f	5711	\N	(0009,0001)	DT	1	Unknown	Unknown	EMAGEON JPEG2K INFO	EMG	\N	\N	\N
f	5712	\N	(0029,0024)	US	1-n	Key Frame Indices	KeyFrameIndices	RadWorksMarconi	RWM	\N	\N	\N
f	5713	\N	(0009,0010)	LO	1	eatDicom Version	eatDicomVersion	MeVis eatDicom	MEV	\N	\N	\N
f	5714	\N	(0009,0011)	ST	1	eatDicom Options	eatDicomOptions	MeVis eatDicom	MEV	\N	\N	\N
f	5715	\N	(0021,0010)	LT	1	Timepoint DateTime	TimepointDateTime	MeVis eD: Timepoint Information	MEV	\N	\N	\N
f	5716	\N	(0021,0011)	CS	1	Timepoint DateTime Type	TimepointDateTimeType	MeVis eD: Timepoint Information	MEV	\N	\N	\N
f	5965	\N	(0031,0008)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5717	\N	(0021,0012)	UN	1	Timepoint Series Description	TimepointSeriesDescription	MeVis eD: Timepoint Information	MEV	\N	\N	\N
f	5718	\N	(0021,0013)	UN	1	Timepoint Gradient Directions	TimepointGradientDirections	MeVis eD: Timepoint Information	MEV	\N	\N	\N
f	5719	\N	(0021,0071)	UN	1	Timepoint Empty Frames	TimepointEmptyFrames	MeVis eD: Timepoint Information	MEV	\N	\N	\N
f	5720	\N	(0021,0010)	LT	1	Timepoint DateTime	TimepointDateTime	MeVis eD: Absolute Temporal Positions	MEV	\N	\N	\N
f	5721	\N	(0021,0011)	CS	1	Timepoint DateTime Type	TimepointDateTimeType	MeVis eD: Absolute Temporal Positions	MEV	\N	\N	\N
f	5722	\N	(0021,0012)	UN	1	Timepoint Series Description	TimepointSeriesDescription	MeVis eD: Absolute Temporal Positions	MEV	\N	\N	\N
f	5723	\N	(0021,0013)	UN	1	Timepoint Gradient Directions	TimepointGradientDirections	MeVis eD: Absolute Temporal Positions	MEV	\N	\N	\N
f	5724	\N	(0021,0071)	UN	1	Timepoint Empty Frames	TimepointEmptyFrames	MeVis eD: Absolute Temporal Positions	MEV	\N	\N	\N
f	5725	\N	(0021,0010)	UN	1	Geometry Scanner Origin	GeometryScannerOrigin	MeVis eD: Geometry Information	MEV	\N	\N	\N
f	5726	\N	(0021,0010)	UI	1-n	Slice SOP Instance UIDs	SliceSOPInstanceUIDs	MeVis eD: Slice Information	MEV	\N	\N	\N
f	5727	\N	(0029,0010)	DS	1	Unknown	Unknown	ShowcaseAppearance	\N	\N	\N	\N
f	5728	\N	(0029,0011)	DS	1	Unknown	Unknown	ShowcaseAppearance	\N	\N	\N	\N
f	5729	\N	(0029,0012)	DS	1	Unknown	Unknown	ShowcaseAppearance	\N	\N	\N	\N
f	5730	\N	(0029,0013)	DS	1	Unknown	Unknown	ShowcaseAppearance	\N	\N	\N	\N
f	5731	\N	(0029,0014)	SQ	1	Unknown	Unknown	ShowcaseAppearance	\N	\N	\N	\N
f	71	\N	(0009,0000)	SQ	1	Anonymizer UID Map	AnonymizerUIDMap	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	72	\N	(0009,0010)	UI	1	Anonymizer UID Key	AnonymizerUIDKey	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	73	\N	(0009,0020)	UI	1	Anonymizer UID Value	AnonymizerUIDValue	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	74	\N	(0009,0030)	SQ	1	Anonymizer Patient ID Map	AnonymizerPatientIDMap	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	75	\N	(0009,0040)	LO	1	Anonymizer Patient ID Key	AnonymizerPatientIDKey	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	76	\N	(0009,0050)	LO	1	Anonymizer Patient ID Value	AnonymizerPatientIDValue	DCMTK_ANONYMIZER	DTK	\N	\N	\N
f	5732	\N	(0099,0001)	UI	1	Version	Version	NQHeader	NQT	\N	\N	\N
f	5733	\N	(0099,0002)	UI	1	Analyzed Series UID	AnalyzedSeriesUID	NQHeader	NQT	\N	\N	\N
f	5734	\N	(0099,0003)	LT	1	License	License	NQHeader	NQT	\N	\N	\N
f	5735	\N	(0099,0004)	SS	1	Return Code	ReturnCode	NQHeader	NQT	\N	\N	\N
f	5736	\N	(0099,0005)	LT	1	Return Message	ReturnMessage	NQHeader	NQT	\N	\N	\N
f	5737	\N	(0099,0010)	FL	1	MI	MI	NQHeader	NQT	\N	\N	\N
f	5738	\N	(0099,0020)	SH	1	Units	Units	NQHeader	NQT	\N	\N	\N
f	5739	\N	(0099,0021)	FL	1	ICV	ICV	NQHeader	NQT	\N	\N	\N
f	5740	\N	(0199,0001)	FL	1	Left Cortical White Matter	LeftCorticalWhiteMatter	NQLeft	NQT	\N	\N	\N
f	5741	\N	(0199,0002)	FL	1	Left Cortical Gray Matter	LeftCorticalGrayMatter	NQLeft	NQT	\N	\N	\N
f	5742	\N	(0199,0003)	FL	1	Left 3rd Ventricle	Left3rdVentricle	NQLeft	NQT	\N	\N	\N
f	5743	\N	(0199,0004)	FL	1	Left 4th Ventricle	Left4thVentricle	NQLeft	NQT	\N	\N	\N
f	5744	\N	(0199,0005)	FL	1	Left 5th Ventricle	Left5thVentricle	NQLeft	NQT	\N	\N	\N
f	5745	\N	(0199,0006)	FL	1	Left Lateral Ventricle	LeftLateralVentricle	NQLeft	NQT	\N	\N	\N
f	5746	\N	(0199,0007)	FL	1	Left Inferior Lateral Ventricle	LeftInferiorLateralVentricle	NQLeft	NQT	\N	\N	\N
f	5747	\N	(0199,0008)	FL	1	Left Inferior CSF	LeftInferiorCSF	NQLeft	NQT	\N	\N	\N
f	5748	\N	(0199,0009)	FL	1	Left Cerebellar White Matter	LeftCerebellarWhiteMatter	NQLeft	NQT	\N	\N	\N
f	5749	\N	(0199,000a)	FL	1	Left Cerebellar Gray Matter	LeftCerebellarGrayMatter	NQLeft	NQT	\N	\N	\N
f	5750	\N	(0199,000b)	FL	1	Left Hippocampus	LeftHippocampus	NQLeft	NQT	\N	\N	\N
f	5751	\N	(0199,000c)	FL	1	Left Amygdala	LeftAmygdala	NQLeft	NQT	\N	\N	\N
f	5752	\N	(0199,000d)	FL	1	Left Thalamus	LeftThalamus	NQLeft	NQT	\N	\N	\N
f	5753	\N	(0199,000e)	FL	1	Left Caudate	LeftCaudate	NQLeft	NQT	\N	\N	\N
f	5754	\N	(0199,000f)	FL	1	Left Putamen	LeftPutamen	NQLeft	NQT	\N	\N	\N
f	5755	\N	(0199,0010)	FL	1	Left Pallidum	LeftPallidum	NQLeft	NQT	\N	\N	\N
f	5756	\N	(0199,0011)	FL	1	Left Ventral Diencephalon	LeftVentralDiencephalon	NQLeft	NQT	\N	\N	\N
f	5757	\N	(0199,0012)	FL	1	Left Nucleus Accumbens	LeftNucleusAccumbens	NQLeft	NQT	\N	\N	\N
f	5758	\N	(0199,0013)	FL	1	Left Brain Stem	LeftBrainStem	NQLeft	NQT	\N	\N	\N
f	5759	\N	(0199,0014)	FL	1	Left Exterior CSF	LeftExteriorCSF	NQLeft	NQT	\N	\N	\N
f	5760	\N	(0199,0015)	FL	1	Left WM Hypo	LeftWMHypo	NQLeft	NQT	\N	\N	\N
f	5761	\N	(0199,0016)	FL	1	Left Other	LeftOther	NQLeft	NQT	\N	\N	\N
f	5762	\N	(0199,0017)	FL	1	Left Cortex Unkown	LeftCortexUnkown	NQLeft	NQT	\N	\N	\N
f	5763	\N	(0199,0018)	FL	1	Left Cortex Bankssts	LeftCortexBankssts	NQLeft	NQT	\N	\N	\N
f	5764	\N	(0199,0019)	FL	1	Left Cortex Caudal Anterior Cingulate	LeftCortexCaudalAnteriorCingulate	NQLeft	NQT	\N	\N	\N
f	5765	\N	(0199,001a)	FL	1	Left Cortex Caudal Middle Frontal	LeftCortexCaudalMiddleFrontal	NQLeft	NQT	\N	\N	\N
f	5766	\N	(0199,001b)	FL	1	Left Cortex Corpus Callosum	LeftCortexCorpusCallosum	NQLeft	NQT	\N	\N	\N
f	5767	\N	(0199,001c)	FL	1	Left Cortex Cuneus	LeftCortexCuneus	NQLeft	NQT	\N	\N	\N
f	5768	\N	(0199,001d)	FL	1	Left Cortex Entorhinal	LeftCortexEntorhinal	NQLeft	NQT	\N	\N	\N
f	5769	\N	(0199,001e)	FL	1	Left Cortex Fusiform	LeftCortexFusiform	NQLeft	NQT	\N	\N	\N
f	5770	\N	(0199,001f)	FL	1	Left Cortex Inferior Parietal	LeftCortexInferiorParietal	NQLeft	NQT	\N	\N	\N
f	5771	\N	(0199,0020)	FL	1	Left Cortex Inferior Temporal	LeftCortexInferiorTemporal	NQLeft	NQT	\N	\N	\N
f	5772	\N	(0199,0021)	FL	1	Left Cortex Isthmus Cingulate	LeftCortexIsthmusCingulate	NQLeft	NQT	\N	\N	\N
f	5773	\N	(0199,0022)	FL	1	Left Cortex Lateral Occipital	LeftCortexLateralOccipital	NQLeft	NQT	\N	\N	\N
f	5774	\N	(0199,0023)	FL	1	Left Cortex Lateral Orbito Frontal	LeftCortexLateralOrbitoFrontal	NQLeft	NQT	\N	\N	\N
f	5775	\N	(0199,0024)	FL	1	Left Cortex Lingual	LeftCortexLingual	NQLeft	NQT	\N	\N	\N
f	5776	\N	(0199,0025)	FL	1	Left Cortex Medial Orbito Frontal	LeftCortexMedialOrbitoFrontal	NQLeft	NQT	\N	\N	\N
f	5777	\N	(0199,0026)	FL	1	Left Cortex Middle Temporal	LeftCortexMiddleTemporal	NQLeft	NQT	\N	\N	\N
f	5966	\N	(0031,0009)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5778	\N	(0199,0027)	FL	1	Left Cortex Parahippocampal	LeftCortexParahippocampal	NQLeft	NQT	\N	\N	\N
f	5779	\N	(0199,0028)	FL	1	Left Cortex Paracentral	LeftCortexParacentral	NQLeft	NQT	\N	\N	\N
f	5780	\N	(0199,0029)	FL	1	Left Cortex Pars Opercularis	LeftCortexParsOpercularis	NQLeft	NQT	\N	\N	\N
f	5781	\N	(0199,002a)	FL	1	Left Cortex Pars Orbitalis	LeftCortexParsOrbitalis	NQLeft	NQT	\N	\N	\N
f	5782	\N	(0199,002b)	FL	1	Left Cortex Pars Triangularis	LeftCortexParsTriangularis	NQLeft	NQT	\N	\N	\N
f	5783	\N	(0199,002c)	FL	1	Left Cortex Pericalcarine	LeftCortexPericalcarine	NQLeft	NQT	\N	\N	\N
f	5784	\N	(0199,002d)	FL	1	Left Cortex Postcentral	LeftCortexPostcentral	NQLeft	NQT	\N	\N	\N
f	5785	\N	(0199,002e)	FL	1	Left Cortex Posterior Cingulate	LeftCortexPosteriorCingulate	NQLeft	NQT	\N	\N	\N
f	5786	\N	(0199,002f)	FL	1	Left Cortex Precentral	LeftCortexPrecentral	NQLeft	NQT	\N	\N	\N
f	5787	\N	(0199,0030)	FL	1	Left Cortex Precuneus	LeftCortexPrecuneus	NQLeft	NQT	\N	\N	\N
f	5788	\N	(0199,0031)	FL	1	Left Cortex Rostral Anterior Cingulate	LeftCortexRostralAnteriorCingulate	NQLeft	NQT	\N	\N	\N
f	5789	\N	(0199,0032)	FL	1	Left Cortex Rostral Middle Frontal	LeftCortexRostralMiddleFrontal	NQLeft	NQT	\N	\N	\N
f	5790	\N	(0199,0033)	FL	1	Left Cortex Superior Frontal	LeftCortexSuperiorFrontal	NQLeft	NQT	\N	\N	\N
f	5791	\N	(0199,0034)	FL	1	Left Cortex Superior Parietal	LeftCortexSuperiorParietal	NQLeft	NQT	\N	\N	\N
f	5792	\N	(0199,0035)	FL	1	Left Cortex Superior Temporal	LeftCortexSuperiorTemporal	NQLeft	NQT	\N	\N	\N
f	5793	\N	(0199,0036)	FL	1	Left Cortex Supramarginal	LeftCortexSupramarginal	NQLeft	NQT	\N	\N	\N
f	5794	\N	(0199,0037)	FL	1	Left Cortex Frontal Pole	LeftCortexFrontalPole	NQLeft	NQT	\N	\N	\N
f	5795	\N	(0199,0038)	FL	1	Left Cortex Temporal Pole	LeftCortexTemporalPole	NQLeft	NQT	\N	\N	\N
f	5796	\N	(0199,0039)	FL	1	Left Cortex Transvere Temporal	LeftCortexTransvereTemporal	NQLeft	NQT	\N	\N	\N
f	5797	\N	(0199,003a)	FL	1	Left Meningie	LeftMeningie	NQLeft	NQT	\N	\N	\N
f	5798	\N	(0299,0001)	FL	1	Right Cortical White Matter	RightCorticalWhiteMatter	NQRight	NQT	\N	\N	\N
f	5799	\N	(0299,0002)	FL	1	Right Cortical Gray Matter	RightCorticalGrayMatter	NQRight	NQT	\N	\N	\N
f	5800	\N	(0299,0003)	FL	1	Right 3rd Ventricle	Right3rdVentricle	NQRight	NQT	\N	\N	\N
f	5801	\N	(0299,0004)	FL	1	Right 4th Ventricle	Right4thVentricle	NQRight	NQT	\N	\N	\N
f	5802	\N	(0299,0005)	FL	1	Right 5th Ventricle	Right5thVentricle	NQRight	NQT	\N	\N	\N
f	5803	\N	(0299,0006)	FL	1	Right Lateral Ventricle	RightLateralVentricle	NQRight	NQT	\N	\N	\N
f	5804	\N	(0299,0007)	FL	1	Right Inferior Lateral Ventricle	RightInferiorLateralVentricle	NQRight	NQT	\N	\N	\N
f	5805	\N	(0299,0008)	FL	1	Right Inferior CSF	RightInferiorCSF	NQRight	NQT	\N	\N	\N
f	5806	\N	(0299,0009)	FL	1	Right Cerebellar White Matter	RightCerebellarWhiteMatter	NQRight	NQT	\N	\N	\N
f	5807	\N	(0299,000a)	FL	1	Right Cerebellar Gray Matter	RightCerebellarGrayMatter	NQRight	NQT	\N	\N	\N
f	5808	\N	(0299,000b)	FL	1	Right Hippocampus	RightHippocampus	NQRight	NQT	\N	\N	\N
f	5809	\N	(0299,000c)	FL	1	Right Amygdala	RightAmygdala	NQRight	NQT	\N	\N	\N
f	5810	\N	(0299,000d)	FL	1	Right Thalamus	RightThalamus	NQRight	NQT	\N	\N	\N
f	5811	\N	(0299,000e)	FL	1	Right Caudate	RightCaudate	NQRight	NQT	\N	\N	\N
f	5812	\N	(0299,000f)	FL	1	Right Putamen	RightPutamen	NQRight	NQT	\N	\N	\N
f	5813	\N	(0299,0010)	FL	1	Right Pallidum	RightPallidum	NQRight	NQT	\N	\N	\N
f	5814	\N	(0299,0011)	FL	1	Right Ventral Diencephalon	RightVentralDiencephalon	NQRight	NQT	\N	\N	\N
f	5815	\N	(0299,0012)	FL	1	Right Nucleus Accumbens	RightNucleusAccumbens	NQRight	NQT	\N	\N	\N
f	5816	\N	(0299,0013)	FL	1	Right Brain Stem	RightBrainStem	NQRight	NQT	\N	\N	\N
f	5817	\N	(0299,0014)	FL	1	Right Exterior CSF	RightExteriorCSF	NQRight	NQT	\N	\N	\N
f	5818	\N	(0299,0015)	FL	1	Right WM Hypo	RightWMHypo	NQRight	NQT	\N	\N	\N
f	5819	\N	(0299,0016)	FL	1	Right Other	RightOther	NQRight	NQT	\N	\N	\N
f	5820	\N	(0299,0017)	FL	1	Right Cortex Unkown	RightCortexUnkown	NQRight	NQT	\N	\N	\N
f	5821	\N	(0299,0018)	FL	1	Right Cortex Bankssts	RightCortexBankssts	NQRight	NQT	\N	\N	\N
f	5822	\N	(0299,0019)	FL	1	Right Cortex Caudal Anterior Cingulate	RightCortexCaudalAnteriorCingulate	NQRight	NQT	\N	\N	\N
f	5823	\N	(0299,001a)	FL	1	Right Cortex Caudal Middle Frontal	RightCortexCaudalMiddleFrontal	NQRight	NQT	\N	\N	\N
f	5824	\N	(0299,001b)	FL	1	Right Cortex Corpus Callosum	RightCortexCorpusCallosum	NQRight	NQT	\N	\N	\N
f	5825	\N	(0299,001c)	FL	1	Right Cortex Cuneus	RightCortexCuneus	NQRight	NQT	\N	\N	\N
f	5826	\N	(0299,001d)	FL	1	Right Cortex Entorhinal	RightCortexEntorhinal	NQRight	NQT	\N	\N	\N
f	5827	\N	(0299,001e)	FL	1	Right Cortex Fusiform	RightCortexFusiform	NQRight	NQT	\N	\N	\N
f	5828	\N	(0299,001f)	FL	1	Right Cortex Inferior Parietal	RightCortexInferiorParietal	NQRight	NQT	\N	\N	\N
f	5829	\N	(0299,0020)	FL	1	Right Cortex Inferior Temporal	RightCortexInferiorTemporal	NQRight	NQT	\N	\N	\N
f	5830	\N	(0299,0021)	FL	1	Right Cortex Isthmus Cingulate	RightCortexIsthmusCingulate	NQRight	NQT	\N	\N	\N
f	5831	\N	(0299,0022)	FL	1	Right Cortex Lateral Occipital	RightCortexLateralOccipital	NQRight	NQT	\N	\N	\N
f	5832	\N	(0299,0023)	FL	1	Right Cortex Lateral Orbito Frontal	RightCortexLateralOrbitoFrontal	NQRight	NQT	\N	\N	\N
f	5833	\N	(0299,0024)	FL	1	Right Cortex Lingual	RightCortexLingual	NQRight	NQT	\N	\N	\N
f	5834	\N	(0299,0025)	FL	1	Right Cortex Medial Orbito Frontal	RightCortexMedialOrbitoFrontal	NQRight	NQT	\N	\N	\N
f	5835	\N	(0299,0026)	FL	1	Right Cortex Middle Temporal	RightCortexMiddleTemporal	NQRight	NQT	\N	\N	\N
f	5836	\N	(0299,0027)	FL	1	Right Cortex Parahippocampal	RightCortexParahippocampal	NQRight	NQT	\N	\N	\N
f	5837	\N	(0299,0028)	FL	1	Right Cortex Paracentral	RightCortexParacentral	NQRight	NQT	\N	\N	\N
f	5838	\N	(0299,0029)	FL	1	Right Cortex Pars Opercularis	RightCortexParsOpercularis	NQRight	NQT	\N	\N	\N
f	5839	\N	(0299,002a)	FL	1	Right Cortex Pars Orbitalis	RightCortexParsOrbitalis	NQRight	NQT	\N	\N	\N
f	5840	\N	(0299,002b)	FL	1	Right Cortex Pars Triangularis	RightCortexParsTriangularis	NQRight	NQT	\N	\N	\N
f	5841	\N	(0299,002c)	FL	1	Right Cortex Pericalcarine	RightCortexPericalcarine	NQRight	NQT	\N	\N	\N
f	5842	\N	(0299,002d)	FL	1	Right Cortex Postcentral	RightCortexPostcentral	NQRight	NQT	\N	\N	\N
f	5843	\N	(0299,002e)	FL	1	Right Cortex Posterior Cingulate	RightCortexPosteriorCingulate	NQRight	NQT	\N	\N	\N
f	5844	\N	(0299,002f)	FL	1	Right Cortex Precentral	RightCortexPrecentral	NQRight	NQT	\N	\N	\N
f	5845	\N	(0299,0030)	FL	1	Right Cortex Precuneus	RightCortexPrecuneus	NQRight	NQT	\N	\N	\N
f	5846	\N	(0299,0031)	FL	1	Right Cortex Rostral Anterior Cingulate	RightCortexRostralAnteriorCingulate	NQRight	NQT	\N	\N	\N
f	5847	\N	(0299,0032)	FL	1	Right Cortex Rostral Middle Frontal	RightCortexRostralMiddleFrontal	NQRight	NQT	\N	\N	\N
f	5848	\N	(0299,0033)	FL	1	Right Cortex Superior Frontal	RightCortexSuperiorFrontal	NQRight	NQT	\N	\N	\N
f	5849	\N	(0299,0034)	FL	1	Right Cortex Superior Parietal	RightCortexSuperiorParietal	NQRight	NQT	\N	\N	\N
f	5850	\N	(0299,0035)	FL	1	Right Cortex Superior Temporal	RightCortexSuperiorTemporal	NQRight	NQT	\N	\N	\N
f	5851	\N	(0299,0036)	FL	1	Right Cortex Supramarginal	RightCortexSupramarginal	NQRight	NQT	\N	\N	\N
f	5852	\N	(0299,0037)	FL	1	Right Cortex Frontal Pole	RightCortexFrontalPole	NQRight	NQT	\N	\N	\N
f	5853	\N	(0299,0038)	FL	1	Right Cortex Temporal Pole	RightCortexTemporalPole	NQRight	NQT	\N	\N	\N
f	5854	\N	(0299,0039)	FL	1	Right Cortex Transvere Temporal	RightCortexTransvereTemporal	NQRight	NQT	\N	\N	\N
f	5855	\N	(0299,003a)	FL	1	Right Meningie	RightMeningie	NQRight	NQT	\N	\N	\N
f	5856	\N	(0013,0010)	LO	1	Project Name	ProjectName	CTP	SEG	\N	\N	\N
f	5857	\N	(0013,0011)	LO	1	Trial Name	TrialName	CTP	SEG	\N	\N	\N
f	5858	\N	(0013,0012)	LO	1	Site Name	SiteName	CTP	SEG	\N	\N	\N
f	5859	\N	(0013,0013)	LO	1	Site ID	SiteID	CTP	SEG	\N	\N	\N
f	5860	\N	(0055,0020)	OB	1	Unknown	Unknown	VEPRO VIF 3.0 DATA	VEP	\N	\N	\N
f	5861	\N	(0055,0030)	OB	1	Icon Data	IconData	VEPRO VIF 3.0 DATA	VEP	\N	\N	\N
f	5862	\N	(0055,0065)	OB	1	Image Hash Value	ImageHashValue	VEPRO VIF 3.0 DATA	VEP	\N	\N	\N
f	5863	\N	(0055,0010)	OB	1	Unknown	Unknown	VEPRO VIM 5.0 DATA	VEP	\N	\N	\N
f	5864	\N	(0055,0020)	OB	1	Unknown	Unknown	VEPRO VIM 5.0 DATA	VEP	\N	\N	\N
f	5865	\N	(0055,0030)	OB	1	Icon Data	IconData	VEPRO VIM 5.0 DATA	VEP	\N	\N	\N
f	5866	\N	(0055,0051)	UI	1	Unknown	Unknown	VEPRO VIM 5.0 DATA	VEP	\N	\N	\N
f	5867	\N	(0055,0065)	OB	1	Image Hash Value	ImageHashValue	VEPRO VIM 5.0 DATA	VEP	\N	\N	\N
f	5868	\N	(0057,0010)	SQ	1	Data Replace Sequence	DataReplaceSequence	VEPRO BROKER 1.0	VEP	\N	\N	\N
f	5869	\N	(0057,0020)	SQ	1	Original Data Sequence	OriginalDataSequence	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5870	\N	(0057,0030)	SQ	1	Replaced Data Sequence	ReplacedDataSequence	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5871	\N	(0057,0040)	DA	1	Date of Data Replacement	DateOfDataReplacement	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5872	\N	(0057,0041)	TM	1	Time of Data Replacement	TimeOfDataReplacement	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5873	\N	(0057,0042)	LO	1	Dicom Receive Node	DicomReceiveNode	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5874	\N	(0057,0043)	LO	1	Application Name	ApplicationName	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5875	\N	(0057,0044)	LO	1	Computer Name	ComputerName	VEPRO BROKER 1.0 DATA REPLACE	VEP	\N	\N	\N
f	5876	\N	(0059,0010)	SQ	1	Dicom Transfer Info	DicomTransferInfo	VEPRO DICOM TRANSFER 1.0	VEP	\N	\N	\N
f	5877	\N	(0059,0040)	DA	1	Receive Date	ReceiveDate	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5878	\N	(0059,0041)	TM	1	Receive Time	ReceiveTime	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5879	\N	(0059,0042)	ST	1	Receive Node	ReceiveNode	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5880	\N	(0059,0043)	ST	1	Receive Application	ReceiveApplication	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5881	\N	(0059,0050)	ST	1	Receive Local Computer	ReceiveLocalComputer	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5882	\N	(0059,0051)	ST	1	Receive Local AE Title	ReceiveLocalAETitle	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5883	\N	(0059,0060)	ST	1	Receive Remote Computer	ReceiveRemoteComputer	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5884	\N	(0059,0061)	ST	1	Receive Remote AE Title	ReceiveRemoteAETitle	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5885	\N	(0059,0070)	UI	1	Receive Original Transfer Syntax	ReceiveOriginalTransferSyntax	VEPRO DICOM RECEIVE DATA 1.0	VEP	\N	\N	\N
f	5886	\N	(0043,0010)	OB	1	Patient Pk	PatientPk	dcm4che/archive	D4C	\N	\N	\N
f	5887	\N	(0043,0011)	OB	1	Study Pk	StudyPk	dcm4che/archive	D4C	\N	\N	\N
f	5888	\N	(0043,0012)	OB	1	Series Pk	SeriesPk	dcm4che/archive	D4C	\N	\N	\N
f	5889	\N	(0043,0013)	OB	1	Instance Pk	InstancePk	dcm4che/archive	D4C	\N	\N	\N
f	5890	\N	(0043,0014)	AE	1	Calling AE Title	CallingAETitle	dcm4che/archive	D4C	\N	\N	\N
f	5891	\N	(0043,0015)	AE	1	Called AE Title	CalledAETitle	dcm4che/archive	D4C	\N	\N	\N
f	5892	\N	(0043,0016)	DT	1	Instance Updated	InstanceUpdated	dcm4che/archive	D4C	\N	\N	\N
f	5893	\N	(0043,0020)	SQ	1	Work Item Sequence	WorkItemSeq	dcm4che/archive	D4C	\N	\N	\N
f	5894	\N	(0043,0030)	UI	1	Dcm4che URI Referenced Transfer Syntax UID	Dcm4cheURIReferencedTransferSyntaxUID	dcm4che/archive	D4C	\N	\N	\N
f	5895	\N	(1269,0001)	IS	1	Biopsy Image	BiopsyImage	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5896	\N	(1269,0010)	IS	1-n	Biopsy Markers X	BiopsyMarkersX	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5897	\N	(1269,0011)	IS	1-n	Biopsy Markers Y	BiopsyMarkersY	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5898	\N	(1269,0012)	IS	1-n	Biopsy Markers Number	BiopsyMarkersNumber	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5899	\N	(1269,0020)	IS	1	Biopsy Area Left Border	BiopsyAreaLeftBorder	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5900	\N	(1269,0021)	IS	1	Biopsy Area Right Border	BiopsyAreaRightBorder	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5901	\N	(1269,0022)	IS	1	Biopsy Area Top Border	BiopsyAreaTopBorder	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5902	\N	(1269,0023)	IS	1	Biopsy Area Bottom Border	BiopsyAreaBottomBorder	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5903	\N	(1269,0024)	IS	1	Biopsy Number	BiopsyNumber	IMS s.r.l. Biopsy Private Code	IMS	\N	\N	\N
f	5904	\N	(1271,0001)	IS	1	Threshold 1	Threshold1	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5905	\N	(1271,0002)	IS	1	Threshold 2	Threshold2	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5906	\N	(1271,0010)	IS	1	Segmentation Left Border	SegmentationLeftBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5907	\N	(1271,0011)	IS	1	Segmentation Right Border	SegmentationRightBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5908	\N	(1271,0012)	IS	1	Segmentation Top Border	SegmentationTopBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5909	\N	(1271,0013)	IS	1	Segmentation Bottom Border	SegmentationBottomBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5910	\N	(1271,0020)	IS	1	Compressor Status	CompressorStatus	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5911	\N	(1271,0021)	IS	1	Collimator Type	CollimatorType	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5912	\N	(1271,0022)	IS	1	Biopsy Specimen	BiopsySpecimen	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5913	\N	(1271,0030)	IS	1	Printer Segmentation	PrinterSegmentation	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5914	\N	(1271,0031)	IS	1	Printer 8x10 Format	Printer8x10Format	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5915	\N	(1271,0032)	FD	1	Printer 8x10 Size X	Printer8x10SizeX	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5916	\N	(1271,0033)	FD	1	Printer 8x10 Size Y	Printer8x10SizeY	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5917	\N	(1271,0034)	IS	1	Printer 8x10 Area Left Border	Printer8x10AreaLeftBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5918	\N	(1271,0035)	IS	1	Printer 8x10 Area Right Border	Printer8x10AreaRightBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5919	\N	(1271,0036)	IS	1	Printer 8x10 Area Top Border	Printer8x10AreaTopBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5920	\N	(1271,0037)	IS	1	Printer 8x10 Area Bottom Border	Printer8x10AreaBottomBorder	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5921	\N	(1271,0038)	LO	1	Rotation And Inclination Sensor Presence	RotationAndInclinationSensorPresence	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5922	\N	(1271,0039)	US	1-n	Window Center For For Processing Images	WindowCenterForForProcessingImages	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5923	\N	(1271,0040)	US	1-n	Window Width For For Processing Images	WindowWidthForForProcessingImages	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5924	\N	(1271,0041)	LO	1-n	Window Center and Width Explanation For For Processing Images	WindowCenterAndWidthExplanationForForProcessingImages	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5925	\N	(1271,0042)	LT	1	Processing Information	ProcessingInformation	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5926	\N	(1271,0043)	LT	1	Filename	Filename	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5927	\N	(1271,0044)	LT	1	Contrast View	ContrastView	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5928	\N	(1271,0045)	IS	1	Threshold 3	Threshold3	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5929	\N	(1271,0046)	IS	1	Threshold 4	Threshold4	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5930	\N	(1271,0047)	IS	1	Threshold 5	Threshold5	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5931	\N	(1271,0048)	IS	1	Threshold 6	Threshold6	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5932	\N	(1271,0049)	IS	1	Threshold 7	Threshold7	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5933	\N	(1271,0050)	IS	1	Threshold 8	Threshold8	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5934	\N	(1271,0051)	IS	1	Threshold 9	Threshold9	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5935	\N	(1271,0052)	IS	1	Threshold 9	Threshold9	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5936	\N	(1271,0053)	IS	1	Scaling Factor For Processing	ScalingFactorForProcessing	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5937	\N	(1271,0054)	IS	1	ConfirmX Image	ConfirmXImage	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5938	\N	(1271,0055)	IS	1	Background counts	Backgroundcounts	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5939	\N	(1271,0056)	IS	1	WL Roi Area X	WLRoiAreaX	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5940	\N	(1271,0057)	IS	1	WL Roi Area Y	WLRoiAreaY	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5941	\N	(1271,0060)	IS	1	Second Processing Image	SecondProcessingImage	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5942	\N	(1271,0061)	IS	1	S Filter	SFilter	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5943	\N	(1271,0062)	IS	1	U Filter	UFilter	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5944	\N	(1271,0063)	IS	1	Anonymous	Anonymous	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5945	\N	(1271,0070)	IS	1	Tomo SAD	TomoSAD	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5946	\N	(1271,0071)	IS	1	Tomo Detector YAW	TomoDetectorYAW	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5947	\N	(1271,0072)	IS	1	Tomo Detector Pitch	TomoDetectorPitch	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5948	\N	(1271,0073)	IS	1	Tomo Detector Roll	TomoDetectorRoll	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5949	\N	(1271,0074)	IS	1	Tomo Focal Spot X	TomoFocalSpotX	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5950	\N	(1271,0075)	IS	1	Tomo Focal Spot Y	TomoFocalSpotY	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5951	\N	(1271,0076)	IS	1	Tomo Xray Start Angle	TomoXrayStartAngle	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5952	\N	(1271,0077)	IS	1	Tomo Xray End Angle	TomoXrayEndAngle	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5953	\N	(1271,0078)	IS	1	Tomo Xray Angle	TomoXrayAngle	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5954	\N	(1271,0079)	IS	1	Tomo Exposure Counter	TomoExposureCounter	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5955	\N	(1271,0080)	IS	1	Tomo Exposure Number	TomoExposureNumber	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5956	\N	(1271,0081)	IS	1	Tomo WL Modified	TomoWLModified	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5957	\N	(1271,0082)	IS	1	Tomo Projection	TomoProjection	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5958	\N	(1271,0083)	IS	1	Key Object Selection Title Code	KeyObjectSelectionTitleCode	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5959	\N	(1271,0084)	IS	1	Rejected for Quality Reasons Code	RejectedForQualityReasonsCode	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5960	\N	(1271,0085)	IS	1	Unknown	Unknown	IMS s.r.l. Mammography Private Code	IMS	\N	\N	\N
f	5961	\N	(0031,0000)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5962	\N	(0031,0001)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5963	\N	(0031,0005)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5964	\N	(0031,0006)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5967	\N	(0031,000a)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5968	\N	(0031,000b)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5969	\N	(0031,000c)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5970	\N	(0031,000d)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5971	\N	(0031,000e)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5972	\N	(0031,0010)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5973	\N	(0031,0011)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5974	\N	(0031,0012)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5975	\N	(0031,0013)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5976	\N	(0031,0014)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5977	\N	(0031,0015)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5978	\N	(0031,0016)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5979	\N	(0031,0017)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5980	\N	(0031,0018)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5981	\N	(0031,0019)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5982	\N	(0031,001a)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5983	\N	(0031,001b)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5984	\N	(0031,001c)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5985	\N	(0031,001d)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5986	\N	(0031,001e)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5987	\N	(0031,0020)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5988	\N	(0031,0021)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5989	\N	(0031,0022)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5990	\N	(0031,0023)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5991	\N	(0031,0024)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5992	\N	(0031,0025)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5993	\N	(0031,0026)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5994	\N	(0031,0027)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5995	\N	(0031,0028)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5996	\N	(0031,0029)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5997	\N	(0031,002a)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5998	\N	(0031,002b)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	5999	\N	(0031,002c)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6000	\N	(0031,002d)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6001	\N	(0031,002e)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6002	\N	(0031,002f)	SQ	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6003	\N	(0031,0030)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6004	\N	(0031,0031)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6005	\N	(0031,0032)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6006	\N	(0031,0033)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6007	\N	(0031,0034)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6008	\N	(0031,0035)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6009	\N	(0031,0036)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6010	\N	(0031,0037)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6011	\N	(0031,0038)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6012	\N	(0031,0039)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6013	\N	(0031,003a)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6014	\N	(0031,003b)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6015	\N	(0031,003c)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6016	\N	(0031,003d)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6017	\N	(0031,003e)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6018	\N	(0031,003f)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6019	\N	(0031,0040)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6020	\N	(0031,0041)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6021	\N	(0031,0042)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6022	\N	(0031,0044)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6023	\N	(0031,0045)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6024	\N	(0031,0046)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6025	\N	(0031,0047)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6026	\N	(0031,0048)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6027	\N	(0031,0049)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6028	\N	(0031,004a)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6029	\N	(0031,004b)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6030	\N	(0031,004c)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6031	\N	(0031,004d)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6032	\N	(0031,004e)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6033	\N	(0031,004f)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6034	\N	(0031,0050)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6035	\N	(0031,0051)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6036	\N	(0031,0052)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6037	\N	(0031,0053)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6038	\N	(0031,0054)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6039	\N	(0031,0055)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6040	\N	(0031,0056)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6041	\N	(0031,0057)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6042	\N	(0031,0058)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6043	\N	(0031,0059)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6044	\N	(0031,005a)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6045	\N	(0031,005b)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6046	\N	(0031,005c)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6047	\N	(0031,0062)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6048	\N	(0031,0063)	US	3	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6049	\N	(0031,006b)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6050	\N	(0031,0070)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6051	\N	(0031,0071)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6052	\N	(0031,0072)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6053	\N	(0031,0073)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6054	\N	(0031,0074)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6055	\N	(0031,0075)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6056	\N	(0031,0077)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6057	\N	(0031,0078)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6058	\N	(0031,0079)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6059	\N	(0031,007a)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6060	\N	(0031,007b)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6061	\N	(0031,007c)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6062	\N	(0031,007d)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6063	\N	(0031,007e)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6064	\N	(0031,007f)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6065	\N	(0031,0080)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6066	\N	(0031,0081)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6067	\N	(0031,0082)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6068	\N	(0031,0083)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6069	\N	(0031,0084)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6070	\N	(0031,0085)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6071	\N	(0031,0086)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6072	\N	(0031,0087)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6073	\N	(0031,0088)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6074	\N	(0031,0089)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6075	\N	(0031,008a)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6076	\N	(0031,008b)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6077	\N	(0031,008c)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6078	\N	(0031,008d)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6079	\N	(0031,008e)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6080	\N	(0031,008f)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6081	\N	(0031,0090)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6082	\N	(0031,0091)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6083	\N	(0031,0092)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6084	\N	(0031,0093)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6085	\N	(0031,0094)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6086	\N	(0031,0095)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6087	\N	(0031,00a1)	IS	2	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6088	\N	(0031,00a2)	IS	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6089	\N	(0031,00a5)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6090	\N	(0031,00a6)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6091	\N	(0031,00a7)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6092	\N	(0031,00a8)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6093	\N	(0031,00aa)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6094	\N	(0031,00ab)	DA	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6095	\N	(0031,00ac)	TM	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6096	\N	(0031,00ad)	DA	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6097	\N	(0031,00ae)	TM	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6098	\N	(0031,00b0)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6099	\N	(0031,00b1)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6100	\N	(0031,00b2)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6101	\N	(0031,00b3)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6102	\N	(0031,00b4)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6103	\N	(0031,00b5)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6104	\N	(0031,00b6)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6105	\N	(0031,00b7)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6106	\N	(0031,00b8)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6107	\N	(0031,00b9)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6108	\N	(0031,00ba)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6109	\N	(0031,00bc)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6110	\N	(0031,00be)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6111	\N	(0031,00bf)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6112	\N	(0031,00c0)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6113	\N	(0031,00c1)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6114	\N	(0031,00c2)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6115	\N	(0031,00c3)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6116	\N	(0031,00c4)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6117	\N	(0031,00c5)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6118	\N	(0031,00c6)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6119	\N	(0031,00c7)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6120	\N	(0031,00c8)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6121	\N	(0031,00c9)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6122	\N	(0031,00ca)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6123	\N	(0031,00cb)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6124	\N	(0031,00cc)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6125	\N	(0031,00cd)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6126	\N	(0031,00ce)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6127	\N	(0031,00cf)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6128	\N	(0031,00d0)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6129	\N	(0031,00d1)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6130	\N	(0031,00d2)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6131	\N	(0031,00d3)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6132	\N	(0031,00d4)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6133	\N	(0031,00d5)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6134	\N	(0031,00d6)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6135	\N	(0031,00d7)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6136	\N	(0031,00d8)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6137	\N	(0031,00d9)	LO	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6138	\N	(0031,00da)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6139	\N	(0031,00db)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6140	\N	(0031,00dc)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6141	\N	(0031,00dd)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6142	\N	(0031,00de)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6143	\N	(0031,00df)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6144	\N	(0031,00e0)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6145	\N	(0031,00e1)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6146	\N	(0031,00e2)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6147	\N	(0031,00e3)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6148	\N	(0031,00e4)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6149	\N	(0031,00e5)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6150	\N	(0031,00e6)	UN	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6151	\N	(0031,00f0)	US	1	Unknown	Unknown	KONICA1.0	KON	\N	\N	\N
f	6152	\N	(0031,00ff)	SQ	1	Private Data Sequence	PrivateDataSequence	KONICA1.0	KON	\N	\N	\N
f	6153	\N	(0009,0001)	UI	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6154	\N	(0009,0002)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6155	\N	(0009,0003)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6156	\N	(0009,0004)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6157	\N	(0009,0005)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6158	\N	(0009,0006)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6159	\N	(0009,0007)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6160	\N	(0009,0008)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6161	\N	(0009,0011)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6162	\N	(0009,0012)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6163	\N	(0009,0013)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6164	\N	(0009,0014)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6165	\N	(0009,0015)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6166	\N	(0009,0016)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6167	\N	(0009,0017)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6168	\N	(0009,0070)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6169	\N	(0009,0071)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6170	\N	(0009,0072)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6171	\N	(0009,0074)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6172	\N	(0009,007a)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6173	\N	(0009,00a1)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6174	\N	(0009,00a2)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6175	\N	(0009,00f1)	LO	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6176	\N	(0009,00f7)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6177	\N	(0009,00f9)	IS	1	Unknown	Unknown	DZDICOM 4.3.0	DZD	\N	\N	\N
f	6178	\N	(0019,0050)	IS	1	Unknown	Unknown	FOEM 1.0	FOEM	\N	\N	\N
f	6179	\N	(0025,0010)	US	1	Unknown	Unknown	FOEM 1.0	FOEM	\N	\N	\N
f	6180	\N	(0025,0012)	US	1	Unknown	Unknown	FOEM 1.0	FOEM	\N	\N	\N
f	6181	\N	(0029,0020)	IS	1	Unknown	Unknown	FOEM 1.0	FOEM	\N	\N	\N
f	6182	\N	(5533,0033)	SQ	1	Save Sequence	SaveSequence	Visus Change	VIS	\N	\N	\N
f	6183	\N	(5533,0035)	DA	1	Save Date	SaveDate	Visus Change	VIS	\N	\N	\N
f	6184	\N	(5533,0037)	LO	1	Save Originator	SaveOriginator	Visus Change	VIS	\N	\N	\N
f	6185	\N	(5533,0039)	FD	1	Save ID	SaveID	Visus Change	VIS	\N	\N	\N
f	6186	\N	(5533,003b)	TM	1	Save Time	SaveTime	Visus Change	VIS	\N	\N	\N
f	6187	\N	(0099,0001)	OB	1	Unknown	Unknown	SYNARC_1.0	SYN	\N	\N	\N
f	6188	\N	(0099,0002)	OB	1	Unknown	Unknown	SYNARC_1.0	SYN	\N	\N	\N
f	6189	\N	(0099,0003)	LO	1	Unknown	Unknown	SYNARC_1.0	SYN	\N	\N	\N
f	6190	\N	(0099,0004)	US	1-n	Unknown	Unknown	SYNARC_1.0	SYN	\N	\N	\N
f	6191	\N	(0099,0005)	LO	1	Unknown	Unknown	SYNARC_1.0	SYN	\N	\N	\N
f	6192	\N	(0011,0002)	UC	1	Strain Description	StrainDescription	PixelMed Publishing	PMP	\N	\N	\N
f	6193	\N	(0011,0003)	LO	1	Strain Nomenclature	StrainNomenclature	PixelMed Publishing	PMP	\N	\N	\N
f	6194	\N	(0011,0004)	LO	1	Strain Stock Number	StrainStockNumber	PixelMed Publishing	PMP	\N	\N	\N
f	6195	\N	(0011,0005)	SQ	1	Strain Source Registry Code Sequence	StrainSourceRegistryCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6196	\N	(0011,0006)	SQ	1	Strain Stock Sequence	StrainStockSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6197	\N	(0011,0007)	LO	1	Strain Source	StrainSource	PixelMed Publishing	PMP	\N	\N	\N
f	6198	\N	(0011,0008)	UT	1	Strain Additional Information	StrainAdditionalInformation	PixelMed Publishing	PMP	\N	\N	\N
f	6199	\N	(0011,0020)	SQ	1	Strain Code Sequence	StrainCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6200	\N	(0011,0050)	LO	1	Cell Line Designation	CellLineDesignation	PixelMed Publishing	PMP	\N	\N	\N
f	6201	\N	(0011,0051)	SQ	1	Cell Line Tissue of Origin Code Sequence	CellLineTissueOfOriginCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6202	\N	(0011,0052)	SQ	1	Cell Line Histologic Type Code Sequence	CellLineHistologicTypeCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6203	\N	(0011,0053)	SQ	1	Cell Line Species of Origin Code Sequence	CellLineSpeciesOfOriginCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6204	\N	(0011,0054)	UL	1	Cell Line Number of Passages	CellLineNumberOfPassages	PixelMed Publishing	PMP	\N	\N	\N
f	6205	\N	(0011,0071)	SQ	1	Source Patient Group Identification Sequence	SourcePatientGroupIdentificationSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6206	\N	(0011,0072)	SQ	1	Group of Patients Identification Sequence	GroupOfPatientsIdentificationSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6207	\N	(0011,0073)	US	3	Subject Relative Position in Image	SubjectRelativePositionInImage	PixelMed Publishing	PMP	\N	\N	\N
f	6208	\N	(0021,0001)	SQ	1	Unassigned Shared Converted Attributes Sequence	UnassignedSharedConvertedAttributesSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6209	\N	(0021,0002)	SQ	1	Unassigned Per-Frame Converted Attributes Sequence	UnassignedPerFrameConvertedAttributesSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6210	\N	(0021,0003)	SQ	1	Conversion Source Attributes Sequence	ConversionSourceAttributesSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6211	\N	(0041,0001)	SQ	1	Quantity Definition Code Sequence	QuantityDefinitionCodeSequence	PixelMed Publishing	PMP	\N	\N	\N
f	6212	\N	(7fe1,0001)	OF	1	Float Pixel Data	FloatPixelData	PixelMed Publishing	PMP	\N	\N	\N
f	6213	\N	(7fe1,0002)	OD	1	Double Pixel Data	DoublePixelData	PixelMed Publishing	PMP	\N	\N	\N
f	6400	\N	(0019,000a)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6214	\N	(0011,0001)	LT	1	KeyFile Indicator	KeyFileIndicator	METAEMOTION GINKGO	MEG	\N	\N	\N
f	6215	\N	(0011,000b)	LT	1	Serialized Diagnose and Markers	SerializedDiagnoseAndMarkers	METAEMOTION GINKGO	MEG	\N	\N	\N
f	6216	\N	(0011,0001)	LT	1	KeyFile Indicator	KeyFileIndicator	METAEMOTION GINKGO RETINAL	MEG	\N	\N	\N
f	6217	\N	(0011,000b)	LT	1	Serialized Diagnose and Markers	SerializedDiagnoseAndMarkers	METAEMOTION GINKGO RETINAL	MEG	\N	\N	\N
f	6218	\N	(0011,000c)	UN	1	Virtual Aneritra Contrast Image	VirtualAneritraContrastImage	METAEMOTION GINKGO RETINAL	MEG	\N	\N	\N
f	6219	\N	(0055,0001)	FD	1-n	Frame Start Times Vector	FrameStartTimesVector	PMOD_1	PMOD	\N	\N	\N
f	6220	\N	(0055,0002)	FD	3-3n	Frame Positions Vector	FramePositionsVector	PMOD_1	PMOD	\N	\N	\N
f	6221	\N	(0055,0003)	FD	6-6n	Frame Orientations Vector	FrameOrientationsVector	PMOD_1	PMOD	\N	\N	\N
f	6222	\N	(0055,0004)	FD	1-n	Frame Durations Vector	FrameDurationsVector	PMOD_1	PMOD	\N	\N	\N
f	6223	\N	(0055,0005)	FD	1-n	Frame Rescale Slope Vector	FrameRescaleSlopeVector	PMOD_1	PMOD	\N	\N	\N
f	6224	\N	(7fe1,0001)	UT	1	Slices Names	SlicesNames	PMOD_GENPET	PMOD	\N	\N	\N
f	6225	\N	(7fe1,0002)	UT	1	Gene Codes	GeneCodes	PMOD_GENPET	PMOD	\N	\N	\N
f	6226	\N	(7fe1,0003)	UT	1	Gene Labels	GeneLabels	PMOD_GENPET	PMOD	\N	\N	\N
f	6227	\N	(0011,0001)	CS	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6228	\N	(0011,0002)	UN	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6229	\N	(0011,0003)	UN	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6230	\N	(0011,0008)	LO	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6231	\N	(0011,0010)	US	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6232	\N	(0011,0011)	UN	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6233	\N	(0011,0012)	UI	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6234	\N	(0011,0018)	UL	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6235	\N	(0011,0019)	UN	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6236	\N	(0011,001a)	CS	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6237	\N	(0011,001b)	IS	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6238	\N	(0011,001c)	IS	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	6239	\N	(0011,001d)	LO	1	Unknown	Unknown	ULTRAVISUAL_TAG_SET1	ULV	\N	\N	\N
f	5727	\N	(0029,0010)	DS	1	Unknown	Unknown	ShowcaseAppearance	CDN	\N	\N	\N
f	5728	\N	(0029,0011)	DS	1	Unknown	Unknown	ShowcaseAppearance	CDN	\N	\N	\N
f	5729	\N	(0029,0012)	DS	1	Unknown	Unknown	ShowcaseAppearance	CDN	\N	\N	\N
f	5730	\N	(0029,0013)	DS	1	Unknown	Unknown	ShowcaseAppearance	CDN	\N	\N	\N
f	5731	\N	(0029,0014)	SQ	1	Unknown	Unknown	ShowcaseAppearance	CDN	\N	\N	\N
f	6240	\N	(0015,0028)	LO	1	Volpara Density Grade	VolparaDensityGrade	MATAKINA_10	MAT	\N	\N	\N
f	6241	\N	(0015,0029)	LT	1	Volpara Run Information	VolparaRunInformation	MATAKINA_10	MAT	\N	\N	\N
f	6242	\N	(0015,0030)	LO	1	Volpara Density Grade Cutoffs	VolparaDensityGradeCutoffs	MATAKINA_10	MAT	\N	\N	\N
f	6243	\N	(0101,0005)	LO	1-n	Image Enhancement Parameter File	ImageEnhancementParameterFile	PM	PM	\N	\N	\N
f	6244	\N	(0101,0006)	IS	1	Original Sigmoid Ratio	OriginalSigmoidRatio	PM	PM	\N	\N	\N
f	6245	\N	(0863,0010)	SL	1	Image Type	ImageType	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6246	\N	(0863,0023)	SL	1	Calibration Flag	CalibrationFlag	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6247	\N	(0863,0026)	UL	1	Attribute Version	AttributeVersion	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6248	\N	(0863,0027)	SL	1	Resizing Flag	ResizingFlag	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6249	\N	(0863,0028)	SL	1	Logarithm Flag	LogarithmFlag	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6250	\N	(0863,0032)	SL	1	Left Collimator Edge	LeftCollimatorEdge	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6251	\N	(0863,0033)	SL	1	Right Collimator Edge	RightCollimatorEdge	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6252	\N	(0863,0034)	FL	1	Distance Source to Patient of Biplane Pair	DistanceSourceToPatientOfBiplanePair	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6253	\N	(0863,0035)	SL	1	Line Correction Flag	LineCorrectionFlag	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6254	\N	(0863,0036)	SL	1	Contrast Enhancement Flag	ContrastEnhancementFlag	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6255	\N	(0863,0037)	SL	1	Calibre Value	CalibreValue	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6256	\N	(0863,0038)	SL	1	High Frequency Line Correction Max Threshold	HighFrequencyLineCorrectionMaxThreshold	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6257	\N	(0863,0039)	SL	1	High Frequency Line Correction Min Threshold	HighFrequencyLineCorrectionMinThreshold	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6258	\N	(0863,0040)	FL	1	Greater Limit	GreaterLimit	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6259	\N	(0863,0041)	FL	1	Lower Limit	LowerLimit	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6260	\N	(0863,0042)	FL	1	Frontal Detector Blades Opening	FrontalDetectorBladesOpening	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6261	\N	(0863,0043)	FL	1	Frontal Tube Blades Opening	FrontalTubeBladesOpening	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6262	\N	(0863,0044)	FL	1	Lateral Detector Blades Opening	LateralDetectorBladesOpening	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6263	\N	(0863,0045)	FL	1	Lateral Tube Blades Opening	LateralTubeBladesOpening	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6264	\N	(0863,0046)	DS	1-n	ThreeD Calibration Parameters	ThreeDCalibrationParameters	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6265	\N	(0863,0057)	CS	1	Image Horizontal Flip	ImageHorizontalFlip	Biospace Med : EOS Tag	EOS	\N	\N	\N
f	6266	\N	(0019,0000)	FD	1	Calibration	Calibration	PRIVATE_CODE_STRING_0019	ONC	\N	\N	\N
f	6267	\N	(0019,0001)	FD	1	Depth Conversion	DepthConversion	PRIVATE_CODE_STRING_0019	ONC	\N	\N	\N
f	6268	\N	(0019,0002)	FD	1	Stepsize	Stepsize	PRIVATE_CODE_STRING_0019	ONC	\N	\N	\N
f	6269	\N	(0019,0003)	SL	1-n	Warning	Warning	PRIVATE_CODE_STRING_0019	ONC	\N	\N	\N
f	6270	\N	(0019,0004)	ST	1	DataID	DataID	PRIVATE_CODE_STRING_0019	ONC	\N	\N	\N
f	6271	\N	(0021,0070)	FD	1	Distance Base Plane to Template	DistanceBasePlaneToTemplate	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6272	\N	(0021,0071)	FD	16	Volume to Patient Matrix	VolumeToPatientMatrix	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6273	\N	(0021,0072)	FD	16	Patient to World Matrix	PatientToWorldMatrix	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6274	\N	(0021,0073)	SL	1	Base Plane	BasePlane	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6275	\N	(0021,0074)	SL	1	Reference Plane	ReferencePlane	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6276	\N	(0021,0075)	SL	1	Apex Plane	ApexPlane	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6277	\N	(0021,0076)	FD	1	Base Plane Offset	BasePlaneOffset	PRIVATE_CODE_STRING_0021	ONC	\N	\N	\N
f	6278	\N	(1001,00a0)	SQ	1	Marker Sequence	MarkerSequence	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6279	\N	(1001,00a1)	SL	1	Marker Type	MarkerType	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6280	\N	(1001,00a2)	SL	1	Marker Number	MarkerNumber	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6281	\N	(1001,00a3)	FD	3	Marker 3D Position	Marker3DPosition	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6282	\N	(1001,00b0)	SL	1	Distance Unit	DistanceUnit	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6283	\N	(1001,00b1)	SL	1	Dose Unit	DoseUnit	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6284	\N	(1001,00b2)	SL	1	Normalisation Mode	NormalisationMode	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6285	\N	(1001,00b3)	FD	1	Normalisation Factor	NormalisationFactor	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6286	\N	(1001,00b4)	FD	1	F-Value	FValue	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6287	\N	(1001,00b5)	FD	1	Prescribed Dose	PrescribedDose	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6288	\N	(1001,00b6)	FD	1	Absolute Dose Factor	AbsoluteDoseFactor	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6289	\N	(1001,00b7)	SL	1	Decoupled sk	DecoupledSK	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6290	\N	(1001,00b8)	FD	1	Absolute Time Factor	AbsoluteTimeFactor	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6291	\N	(1001,00b9)	FD	1	Total Treatment Time	Total Treatment Time	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6292	\N	(1001,00ba)	SL	1	TG 43 Model	TG43Model	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6293	\N	(1001,00bb)	SL	1	3D Dose Grid Size	ThreeDDoseGridSize	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6294	\N	(1001,00bc)	FD	3	Dose Grid Corner 1	DoseGridCorner1	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6295	\N	(1001,00bd)	FD	3	Dose Grid Corner 2	DoseGridCorner2	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6296	\N	(1001,00be)	FD	1	Patient Data Conversion	PatientDataConversion	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6297	\N	(1001,00bf)	FD	1	Volume Data Conversion	VolumeDataConversion	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6298	\N	(1001,00c0)	FD	3	Volume Data Vector	VolumeDataVector	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6299	\N	(1001,00c1)	SL	1	Optimization Method	OptimizationMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6300	\N	(1001,00c2)	SL	1	Display Method	DisplayMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6301	\N	(1001,00c3)	SL	1	Geometrical Method	GeometricalMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6301	\N	(1001,00c3)	SQ	1	VOI Based Optimization Settings Sequence	VOIBasedOptimizationSettingsSequence	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6302	\N	(1001,00c5)	SL	1	VOI Number	VOINumber	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6303	\N	(1001,00c6)	LO	1	VOI Name	VOIName	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6304	\N	(1001,00c7)	SL	1	VOI Type	VOIType	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6305	\N	(1001,00c8)	SL	1	VOI Class	VOIClass	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6306	\N	(1001,00c9)	SL	1	VOI Priority	VOIPriority	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6307	\N	(1001,00ca)	SL	1	No of Points	NoOfPoints	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6308	\N	(1001,00cb)	FD	1	Percent On Surface	PercentOnSurface	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6309	\N	(1001,00cc)	FD	1	Surface Margin	SurfaceMargin	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6310	\N	(1001,00cd)	SL	1	Selected	Selected	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6311	\N	(1001,00ce)	FD	1	Dose Limit	DoseLimit	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6312	\N	(1001,00cf)	FD	1	Importance Factor	ImportanceFactor	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6313	\N	(1001,00d0)	FD	1	Importance Factor From	ImportanceFactorFrom	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6314	\N	(1001,00d1)	FD	1	Importance Factor To	ImportanceFactorTo	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6315	\N	(1001,00d2)	FD	1	Focus	Focus	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6316	\N	(1001,00d3)	SL	1	Surface Sampling Method	SurfaceSamplingMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6317	\N	(1001,00d4)	FD	1	Number of Sampling Points Per ccm	NumberOfSamplingPointsPerccm	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6318	\N	(1001,00d5)	SL	1	Convergence Accuracy	ConvergenceAccuracy	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6319	\N	(1001,00d6)	SL	1	Max No of Convergence Iterations	MaxNoOfConvergenceIterations	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6320	\N	(1001,00d7)	FD	1	Weight Smoothing	WeightSmoothing	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6321	\N	(1001,00d8)	SL	1	Steps Per Importance Factor	StepsPerImportanceFactor	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6322	\N	(1001,00d9)	FD	1	Constraints PTVDmax	ConstraintsPTVDmax	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6323	\N	(1001,00da)	FD	1	Constraints NTDmax	ConstraintsNTDmax	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6324	\N	(1001,00db)	SL	1	Algorithmic Population Size	AlgorithmicPopulationSize	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6325	\N	(1001,00dc)	SL	1	Algorithmic Generations	AlgorithmicGenerations	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6326	\N	(1001,00dd)	SL	1	Algorithmic Initializations	AlgorithmicInitializations	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6327	\N	(1001,00de)	SL	1	Min No Of SDP	MinNoOfSDP	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6328	\N	(1001,00df)	SL	1	Depth Method	DepthMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6329	\N	(1001,00e0)	SL	1	Depth Defined On	DepthDefinedOn	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6330	\N	(1001,00e1)	FD	1	Depth	Depth	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6331	\N	(1001,00e2)	SQ	1	VOI Based Placement Settings Sequence	VOIBasedPlacementSettingsSequence	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6302	\N	(1001,00c5)	SL	1	VOI Number	VOINumber	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6303	\N	(1001,00c6)	LO	1	VOI Name	VOIName	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6304	\N	(1001,00c7)	SL	1	VOI Type	VOIType	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6305	\N	(1001,00c8)	SL	1	VOI Class	VOIClass	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6332	\N	(1001,00e7)	SL	1	VOI Selected	VOISelected	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6333	\N	(1001,00e8)	FD	1	Margin	Margin	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6334	\N	(1001,00e9)	SL	1	Selection Method	SelectionMethod	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6335	\N	(1001,00ea)	FD	1	Selection Distance	SelectionDistance	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6336	\N	(1001,00eb)	FD	1	WBT On Contour Spacing	WBTOnContourSpacing	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6337	\N	(1001,00ec)	FD	1	WBT Urethra Margin	WBTUrethraMargin	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6338	\N	(1001,00ed)	FD	1	WBT Searching Radius PTV	WBTSearchingRadiusPTV	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6339	\N	(1001,00ee)	FD	1	WBT Searching Radius OAR	WBTSearchingRadiusOAR	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6340	\N	(1001,00ef)	FD	3	WBT Starting Point	WBTStartingPoint	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6341	\N	(1001,00f0)	FD	4	WBT Surface	WBTSurface	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6342	\N	(1001,00f1)	FD	4	WBT No of Interior Catheters	WBTNoOfInteriorCatheters	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6343	\N	(1001,00f2)	FD	4	WBT Relative Radius	WBTRelativeRadius	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6344	\N	(1001,00f3)	SL	1	Sorting Method	Sorting Method	PRIVATE_CODE_STRING_1001	ONC	\N	\N	\N
f	6345	\N	(1003,0001)	UN	1	Number Of Probes	NumberOfProbes	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6346	\N	(1003,0010)	UN	1	US Probe Sequence	US Probe Sequence	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6347	\N	(1003,0011)	UN	1	Identifier	Identifier	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6348	\N	(1003,0012)	UN	1	Probe Name	Probe Name	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6349	\N	(1003,0013)	UN	1	Depth	Depth	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6350	\N	(1003,0014)	UN	1	Frequency	Frequency	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6351	\N	(1003,0015)	UN	1	Gain	Gain\t	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6352	\N	(1003,0016)	UN	1	Power	Power	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6353	\N	(1003,0017)	UN	1	Dynamic Range	DynamicRange	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6354	\N	(1003,0018)	UN	1	Frame Averaging	FrameAveraging	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6355	\N	(1003,0019)	UN	1	Field Of View	FieldOfView	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6356	\N	(1003,0020)	UN	1	TGC	TGC	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6357	\N	(1003,002a)	UN	1	Number Of Focus Sets	NumberOfFocusSets	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6358	\N	(1003,002b)	UN	1	Current Focus Set	CurrentFocusSet	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6359	\N	(1003,002c)	UN	1	Image Enhancement Filter Index	ImageEnhancementFilterIndex	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6360	\N	(1003,002d)	UN	1	Rejection Filter Low	RejectionFilterLow	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6361	\N	(1003,002e)	UN	1	Rejection Filter High	RejectionFilterHigh	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6362	\N	(1003,002f)	UN	1	Brightness	Brightness	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6363	\N	(1003,0030)	UN	1	Contrast	Contrast	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6364	\N	(1003,0031)	UN	1	Gamma	Gamma	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6365	\N	(1003,0032)	UN	1	Speckle Enabled	SpeckleEnabled	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6366	\N	(1003,0033)	UN	1	Speckle Level	SpeckleLevel	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6367	\N	(1003,0040)	UN	1	Focus Set Sequence	FocusSetSequence	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6368	\N	(1003,0041)	UN	1	Identifier	Identifier	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6369	\N	(1003,0042)	UN	1	Number Of Focus Zone	NumberOfFocusZone	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6370	\N	(1003,0043)	UN	1	Focus	Focus	PRIVATE_CODE_STRING_1003	ONC	\N	\N	\N
f	6371	\N	(3007,0000)	FD	16	Volume to Patient Matrix	VolumeToPatientMatrix	PRIVATE_CODE_STRING_3007	ONC	\N	\N	\N
f	6372	\N	(3007,0001)	FD	16	Volume Resolution Conversion	VolumeResolutionConversion	PRIVATE_CODE_STRING_3007	ONC	\N	\N	\N
f	6373	\N	(3007,0002)	FD	16	Volume Data Conversion	VolumeDataConversion	PRIVATE_CODE_STRING_3007	ONC	\N	\N	\N
f	6374	\N	(3007,0003)	FD	16	Patient Data Conversion	PatientDataConversion	PRIVATE_CODE_STRING_3007	ONC	\N	\N	\N
f	6375	\N	(3007,0004)	FD	16	DICOM Data Conversion	DICOMDataConversion	PRIVATE_CODE_STRING_3007	ONC	\N	\N	\N
f	6376	\N	(300b,0000)	SL	1	Template Mode	TemplateMode	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6377	\N	(300b,0001)	LO	1	Template ID	TemplateID	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6378	\N	(300b,0002)	SL	1	Number of Columns	NumberOfColumns	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6379	\N	(300b,0003)	FD	1	Column Distance	ColumnDistance	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6380	\N	(300b,0004)	SL	1	Number of Rows	NumberORows	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6381	\N	(300b,0005)	FD	1	Row Distance	Row Distance	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6382	\N	(300b,0006)	SL	1	Origin	Origin	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6383	\N	(300b,0007)	SH	1-n	Column Numbering	ColumnNumbering	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6384	\N	(300b,0008)	SH	1-n	Row Numbering	RowNumbering	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6385	\N	(300b,0009)	SS	1-n	Used Holes Array	UsedHolesArray	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6386	\N	(300b,000a)	SL	1	Lock Status	LockStatus	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6387	\N	(300b,000c)	UN	1	Identifier	Identifier	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6388	\N	(300b,000d)	UN	1	Modification Type	ModificationType	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6389	\N	(300b,000e)	UN	1	Modification Value	ModificationValue	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6390	\N	(300b,000f)	UN	1	Transformation Matrix	TransformationMatrix	PRIVATE_CODE_STRING_300B	ONC	\N	\N	\N
f	6391	\N	(000d,0000)	OB	1	Image Xml Data	ImageXmlData	INSTRU_PRIVATE_IDENT_CODE	INS	\N	\N	\N
f	6392	\N	(000d,0000)	OB	1	Image Xml Data	ImageXmlData	SCANORA_PRIVATE_IDENT_CODE	INS	\N	\N	\N
f	6393	\N	(0019,0002)	US	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6394	\N	(0019,0003)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6395	\N	(0019,0004)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6396	\N	(0019,0005)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6397	\N	(0019,0006)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6398	\N	(0019,0007)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6399	\N	(0019,0009)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6401	\N	(0019,000b)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6402	\N	(0019,000c)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6403	\N	(0019,000d)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6404	\N	(0019,000e)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6405	\N	(0019,000f)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6406	\N	(0019,0012)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6407	\N	(0019,0013)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6408	\N	(0019,001e)	DS	3	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6409	\N	(0019,001f)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6410	\N	(0019,0020)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6411	\N	(0019,0021)	DS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6412	\N	(0019,0022)	IS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6413	\N	(0019,0023)	IS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6414	\N	(0019,0024)	LO	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6415	\N	(0019,0025)	IS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6416	\N	(0019,0026)	LO	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6417	\N	(0019,0027)	LO	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6418	\N	(0019,0028)	LO	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6419	\N	(0019,0030)	LO	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6420	\N	(0019,0031)	IS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6421	\N	(0019,0032)	IS	1	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6422	\N	(0019,0033)	DS	8	Unknown	Unknown	NNT	NNT	\N	\N	\N
f	6423	\N	(3335,0000)	UN	1	Unknown	Unknown	CAD Sciences	iCAD	\N	\N	\N
f	6424	\N	(3335,0006)	UN	1	Unknown	Unknown	CAD Sciences	iCAD	\N	\N	\N
f	6425	\N	(3335,0007)	UN	1	Unknown	Unknown	CAD Sciences	iCAD	\N	\N	\N
f	6426	\N	(3335,0008)	UN	1	Unknown	Unknown	CAD Sciences	iCAD	\N	\N	\N
f	6427	\N	(3335,0010)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6428	\N	(3335,0015)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6429	\N	(3335,0016)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6430	\N	(3335,0017)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6431	\N	(3335,0018)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6432	\N	(3335,002a)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6433	\N	(3335,0034)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6434	\N	(3335,0035)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6435	\N	(3335,003b)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6436	\N	(3335,0040)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6437	\N	(3335,0050)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6438	\N	(3335,0051)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6439	\N	(3335,0052)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6440	\N	(3335,0053)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6441	\N	(3335,0054)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6442	\N	(3335,0055)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6443	\N	(3335,0056)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6444	\N	(3335,0057)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6445	\N	(3335,0070)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6446	\N	(3335,0071)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6447	\N	(3335,0072)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6448	\N	(3335,0073)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6449	\N	(3335,0074)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6450	\N	(3335,0075)	UN	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6451	\N	(3335,0080)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6452	\N	(3335,0081)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6453	\N	(3335,0082)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6454	\N	(3335,0083)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6455	\N	(3335,0084)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6456	\N	(3335,0085)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6457	\N	(3335,0086)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6458	\N	(3335,0087)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6459	\N	(3335,0088)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6460	\N	(3335,0089)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6461	\N	(3335,008a)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6462	\N	(3335,008b)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6463	\N	(3335,008c)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6464	\N	(3335,008d)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6465	\N	(3335,008e)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6466	\N	(3335,008f)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6467	\N	(3335,0090)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6468	\N	(3335,0091)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6469	\N	(3335,0092)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6470	\N	(3335,0093)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6471	\N	(3335,0094)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6472	\N	(3335,0095)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6473	\N	(3335,00a0)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6474	\N	(3335,00a1)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6475	\N	(3335,00a2)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6476	\N	(3335,00a3)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6477	\N	(3335,00a4)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6478	\N	(3335,00a5)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6479	\N	(3335,00a6)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6480	\N	(3335,00a7)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6481	\N	(3335,00a8)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6482	\N	(3335,00a9)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6483	\N	(3335,00aa)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6484	\N	(3335,00ab)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6485	\N	(3335,00ac)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6486	\N	(3335,00ad)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6487	\N	(3335,00ae)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6488	\N	(3335,00af)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6489	\N	(3335,00b0)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6490	\N	(3335,00b1)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6491	\N	(3335,00c0)	LO	1	Unknown	Unknown	iCAD PK	iCAD	\N	\N	\N
f	6492	\N	(3335,0000)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6493	\N	(3335,0001)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6494	\N	(3335,0002)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6495	\N	(3335,0003)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6496	\N	(3335,0004)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6497	\N	(3335,0005)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6498	\N	(3335,0006)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6499	\N	(3335,0007)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6500	\N	(3335,0008)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6501	\N	(3335,0009)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6502	\N	(3335,000a)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6503	\N	(3335,000b)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6504	\N	(3335,000c)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6505	\N	(3335,000d)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6506	\N	(3335,000e)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6507	\N	(3335,000f)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6508	\N	(3335,0010)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6509	\N	(3335,0011)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6510	\N	(3335,0012)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6511	\N	(3335,0013)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6512	\N	(3335,0014)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6513	\N	(3335,0015)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6514	\N	(3335,0016)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6515	\N	(3335,0017)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6516	\N	(3335,0018)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6517	\N	(3335,0019)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6518	\N	(3335,001a)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6519	\N	(3335,001b)	LO	1	Unknown	Unknown	iCAD PK Study	iCAD	\N	\N	\N
f	6520	\N	(7fdf,0050)	OB	1	Unknown	Unknown	TomTec	TTC	\N	\N	\N
f	6521	\N	(7fdf,0051)	OB	1	Unknown	Unknown	TomTec	TTC	\N	\N	\N
f	6522	\N	(0029,0015)	LO	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6523	\N	(0029,0016)	LO	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6524	\N	(0029,0017)	LO	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6525	\N	(0029,0018)	UT	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6526	\N	(0029,0019)	IS	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6527	\N	(0029,001a)	IS	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6528	\N	(0029,001b)	IS	1	Unknown	Unknown	CARESTREAM IMAGE INFORMATION	CARE	\N	\N	\N
f	6529	\N	(ffff,00ff)	UN	1	Unknown	Unknown	Carestream Health TIFF	CARE	\N	\N	\N
f	6530	\N	(3111,0010)	CS	1	Binary Document Type	BinaryDocumentKind	RamSoft File Kind Identifier	RAM	\N	\N	\N
f	6531	\N	(3113,0010)	OB	1	Binary Document	BinaryDocument	RamSoft Custom Report Identifier	RAM	\N	\N	\N
f	6532	\N	(3113,0020)	UL	1	Binary Document Size	BinaryDocumentSize	RamSoft Custom Report Identifier	RAM	\N	\N	\N
f	6533	\N	(3129,0010)	LO	1	Unknown	Unknown	RamSoft Race Identifier	RAM	\N	\N	\N
f	6534	\N	(0011,0001)	UT	1	AES Encrypted Values	AESEncryptedValues	MDDX	MDDX	\N	\N	\N
f	6535	\N	(0011,0002)	LO	1	Allup Version Details	AllupVersionDetails	MDDX	MDDX	\N	\N	\N
f	6536	\N	(0011,0003)	LO	1	Mask Id	MaskID	MDDX	MDDX	\N	\N	\N
f	6537	\N	(7fe1,0001)	UT	1	AES Encrypted Values	AESEncryptedValues	MDDX	MDDX	\N	\N	\N
f	6538	\N	(7fe1,0002)	LO	1	Allup Version Details	AllupVersionDetails	MDDX	MDDX	\N	\N	\N
f	6539	\N	(7fe1,0003)	LO	1	Mask Id	MaskID	MDDX	MDDX	\N	\N	\N
f	6540	\N	(0099,0000)	SS	1	Breast Density Value	BreastDensityValue	QTUltrasound	QTU	\N	\N	\N
f	6541	\N	(0009,0035)	DS	1	Unknown	Unknown	BioscanMedisoScivisNanoSPECT	MDSO	\N	\N	\N
f	6542	\N	(0009,0030)	DT	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6543	\N	(0009,0036)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6544	\N	(0009,00c0)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6545	\N	(0009,00c1)	OB	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6546	\N	(0009,00c4)	OB	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6547	\N	(0009,00d2)	LO	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6548	\N	(0009,00d5)	LO	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6549	\N	(0009,00dc)	SQ	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6550	\N	(0009,00de)	UL	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6551	\N	(0009,00df)	UL	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6552	\N	(0009,00e0)	US	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6553	\N	(0009,00e1)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6554	\N	(0009,00e6)	OB	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6555	\N	(0009,00e9)	UI	1-n	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6556	\N	(0009,00ee)	DT	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6557	\N	(0009,00ef)	DT	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6558	\N	(0009,00f0)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6559	\N	(0009,00f1)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6560	\N	(0009,00f2)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6561	\N	(0009,00f3)	FD	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6562	\N	(0009,00fa)	ST	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6563	\N	(0009,00fb)	US	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6563	\N	(0009,00fb)	US	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6564	\N	(0011,0006)	LO	1	Unknown	Unknown	MEDISO-1	MDSO	\N	\N	\N
f	6565	\N	(6001,00a0)	DS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6566	\N	(6001,00a1)	DS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6567	\N	(6001,00a2)	US	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6568	\N	(6001,00a3)	DS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6569	\N	(6001,00a4)	IS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6570	\N	(6001,00a5)	ST	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6571	\N	(6001,00a6)	ST	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6572	\N	(6001,00a7)	FL	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6573	\N	(6001,00a8)	FL	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6574	\N	(6001,00a9)	IS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6575	\N	(6001,00aa)	IS	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6576	\N	(6001,00ab)	ST	1	Unknown	Unknown	SCIVIS-1	SVIS	\N	\N	\N
f	6577	\N	(0009,0031)	SQ	1	Unknown	Unknown	Brainlab-S9-History	BLB	\N	\N	\N
f	6578	\N	(0009,0032)	SQ	1	Unknown	Unknown	Brainlab-S9-History	BLB	\N	\N	\N
f	6579	\N	(0009,0033)	SQ	1	Unknown	Unknown	Brainlab-S9-History	BLB	\N	\N	\N
f	6580	\N	(0063,0001)	LO	1	Unknown	Unknown	Brainlab-S32-SO	BLB	\N	\N	\N
f	6581	\N	(0063,0010)	SQ	1	Unknown	Unknown	Brainlab-S32-SO	BLB	\N	\N	\N
f	6582	\N	(0073,0010)	SQ	1	Projective Registration Sequence	ProjectiveRegistrationSequence	Brainlab-S23-ProjectiveFusion	BLB	\N	\N	\N
f	961	\N	(0009,0000)	LT	1	Original File Name	OriginalFileName	PAPYRUS	PAP	\N	\N	\N
f	962	\N	(0009,0010)	LT	1	Original File Location	OriginalFileLocation	PAPYRUS	PAP	\N	\N	\N
f	963	\N	(0009,0018)	LT	1	Data Set Identifier	DataSetIdentifier	PAPYRUS	PAP	\N	\N	\N
f	947	\N	(0041,0000)	LT	1	Papyrus Comments	PapyrusComments	PAPYRUS 3.0	PA3	\N	\N	\N
f	964	\N	(0041,0000)	LT	1-n	Papyrus Comments	PapyrusComments	PAPYRUS	PAP	\N	\N	\N
f	948	\N	(0041,0010)	SQ	1	Pointer Sequence	PointerSequence	PAPYRUS 3.0	PA3	\N	\N	\N
f	965	\N	(0041,0010)	US	1	Folder Type	FolderType	PAPYRUS	PAP	\N	\N	\N
f	949	\N	(0041,0011)	UL	1	Image Pointer	ImagePointer	PAPYRUS 3.0	PA3	\N	\N	\N
f	966	\N	(0041,0011)	LT	1	Patient Folder Data Set ID	PatientFolderDataSetID	PAPYRUS	PAP	\N	\N	\N
f	950	\N	(0041,0012)	UL	1	Pixel Offset	PixelOffset	PAPYRUS 3.0	PA3	\N	\N	\N
f	951	\N	(0041,0013)	SQ	1	Image Identifier Sequence	ImageIdentifierSequence	PAPYRUS 3.0	PA3	\N	\N	\N
f	952	\N	(0041,0014)	SQ	1	External File Reference Sequence	ExternalFileReferenceSequence	PAPYRUS 3.0	PA3	\N	\N	\N
f	953	\N	(0041,0015)	US	1	Number of Images	NumberOfImages	PAPYRUS 3.0	PA3	\N	\N	\N
f	967	\N	(0041,0020)	LT	1	Folder Name	FolderName	PAPYRUS	PAP	\N	\N	\N
f	954	\N	(0041,0021)	UI	1	Referenced SOP Class UID	ReferencedSOPClassUID	PAPYRUS 3.0	PA3	\N	\N	\N
f	955	\N	(0041,0022)	UI	1	Referenced SOP Instance UID	ReferencedSOPInstanceUID	PAPYRUS 3.0	PA3	\N	\N	\N
f	968	\N	(0041,0030)	DA	1	Creation Date	CreationDate	PAPYRUS	PAP	\N	\N	\N
f	956	\N	(0041,0031)	LT	1	Referenced File Name	ReferencedFileName	PAPYRUS 3.0	PA3	\N	\N	\N
f	957	\N	(0041,0032)	LT	1-n	Referenced File Path	ReferencedFilePath	PAPYRUS 3.0	PA3	\N	\N	\N
f	969	\N	(0041,0032)	TM	1	Creation Time	CreationTime	PAPYRUS	PAP	\N	\N	\N
f	970	\N	(0041,0034)	DA	1	Modified Date	ModifiedDate	PAPYRUS	PAP	\N	\N	\N
f	971	\N	(0041,0036)	TM	1	Modified Time	ModifiedTime	PAPYRUS	PAP	\N	\N	\N
f	972	\N	(0041,0040)	LT	1-n	Owner Name	OwnerName	PAPYRUS	PAP	\N	\N	\N
f	958	\N	(0041,0041)	UI	1	Referenced Image SOP Class UID	ReferencedImageSOPClassUID	PAPYRUS 3.0	PA3	\N	\N	\N
f	959	\N	(0041,0042)	UI	1	Referenced Image SOP Instance UID	ReferencedImageSOPInstanceUID	PAPYRUS 3.0	PA3	\N	\N	\N
f	960	\N	(0041,0050)	SQ	1	Image Sequence	ImageSequence	PAPYRUS 3.0	PA3	\N	\N	\N
f	973	\N	(0041,0050)	LT	1	Folder Status	FolderStatus	PAPYRUS	PAP	\N	\N	\N
f	974	\N	(0041,0060)	UL	1	Number of Images	NumberOfImages	PAPYRUS	PAP	\N	\N	\N
f	975	\N	(0041,0062)	UL	1	Number of Other	NumberOfOther	PAPYRUS	PAP	\N	\N	\N
f	976	\N	(0041,00a0)	LT	1-n	External Folder Element DSID	ExternalFolderElementDSID	PAPYRUS	PAP	\N	\N	\N
f	977	\N	(0041,00a1)	US	1-n	External Folder Element Data Set Type	ExternalFolderElementDataSetType	PAPYRUS	PAP	\N	\N	\N
f	978	\N	(0041,00a2)	LT	1-n	External Folder Element File Location	ExternalFolderElementFileLocation	PAPYRUS	PAP	\N	\N	\N
f	979	\N	(0041,00a3)	UL	1-n	External Folder Element Length	ExternalFolderElementLength	PAPYRUS	PAP	\N	\N	\N
f	980	\N	(0041,00b0)	LT	1-n	Internal Folder Element DSID	InternalFolderElementDSID	PAPYRUS	PAP	\N	\N	\N
f	981	\N	(0041,00b1)	US	1-n	Internal Folder Element Data Set Type	InternalFolderElementDataSetType	PAPYRUS	PAP	\N	\N	\N
f	982	\N	(0041,00b2)	UL	1-n	Internal Offset To Data Set	InternalOffsetToDataSet	PAPYRUS	PAP	\N	\N	\N
f	983	\N	(0041,00b3)	UL	1-n	Internal Offset To Image	InternalOffsetToImage	PAPYRUS	PAP	\N	\N	\N
t	\N	6	(60xx,0000)	IS	1	Overlay ID	OverlayID	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	7	(60xx,0001)	LT	1-n	Linked Overlays	LinkedOverlays	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	8	(60xx,0010)	US	1	Overlay Rows	OverlayRows	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	9	(60xx,0011)	US	1	Overlay Columns	OverlayColumns	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	10	(60xx,0040)	LO	1	Overlay Type	OverlayType	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	11	(60xx,0050)	US	1-n	Overlay Origin	OverlayOrigin	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	12	(60xx,0060)	LO	1	Editable	Editable	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	13	(60xx,0070)	LO	1	Overlay Font	OverlayFont	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	14	(60xx,0072)	LO	1	Overlay Style	OverlayStyle	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	15	(60xx,0074)	US	1	Overlay Font Size	OverlayFontSize	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	16	(60xx,0076)	LO	1	Overlay Color	OverlayColor	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	17	(60xx,0078)	US	1	Shadow Size	ShadowSize	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	18	(60xx,0080)	LO	1	Fill Pattern	FillPattern	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	19	(60xx,0082)	US	1	Overlay Pen Size	OverlayPenSize	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	20	(60xx,00a0)	LO	1	Label	Label	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	21	(60xx,00a2)	LT	1	Post It Text	PostItText	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	22	(60xx,00a4)	US	2	Anchor Point	AnchorPoint	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	23	(60xx,00b0)	LO	1	ROI Type	ROIType	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	24	(60xx,00b2)	LT	1	Attached Annotation	AttachedAnnotation	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	25	(60xx,00ba)	US	1-n	Contour Points	ContourPoints	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	26	(60xx,00bc)	US	1-n	Mask Data	MaskData	PAPYRUS 3.0	PA3	\N	\N	\N
t	\N	27	(60xx,00c0)	SQ	1	UIN Overlay Sequence	UINOverlaySequence	PAPYRUS 3.0	PA3	\N	\N	\N
f	52	\N	(0009,0000)	UL	1	File Location	FileLocation	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2261	\N	(0009,0000)	LT	1	Data Object Recognition Code	DataObjectRecognitionCode	SPI-P Release 1	\N	\N	\N	\N
f	2393	\N	(0009,0000)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	53	\N	(0009,0001)	UL	1	File Size	FileSize	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2262	\N	(0009,0004)	LO	1	Image Data Consistency	ImageDataConsistency	SPI-P Release 1	\N	\N	\N	\N
f	6583	\N	(0009,0008)	CS	1	Unknown	Unknown	SPI Release 1	\N	\N	\N	\N
f	2263	\N	(0009,0008)	US	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	1141	\N	(0009,0010)	LO	1	SPI Release	SPIRelease	PHILIPS MR	\N	\N	\N	\N
f	6584	\N	(0009,0010)	US	1	Unknown	Unknown	PHILIPS MR/PART 12	\N	\N	\N	0021
f	2245	\N	(0009,0010)	LO	1	Unknown	Unknown	SPI Release 1	\N	\N	\N	\N
f	6585	\N	(0009,0010)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2394	\N	(0009,0010)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1142	\N	(0009,0012)	LO	1	Unknown	Unknown	PHILIPS MR	\N	\N	\N	\N
f	2264	\N	(0009,0012)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2265	\N	(0009,0015)	LO	1	Unique Identifier	UniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2266	\N	(0009,0016)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2267	\N	(0009,0018)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2395	\N	(0009,0020)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2268	\N	(0009,0021)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2396	\N	(0009,0030)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2269	\N	(0009,0031)	LT	1	PACS Unique Identifier	PACSUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2270	\N	(0009,0034)	LT	1	Cluster Unique Identifier	ClusterUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2271	\N	(0009,0038)	LT	1	System Unique Identifier	SystemUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2272	\N	(0009,0039)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	54	\N	(0009,0040)	SQ	1	Alternate Image Sequence	AlternateImageSequence	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2397	\N	(0009,0040)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2398	\N	(0009,0050)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2273	\N	(0009,0051)	LT	1	Study Unique Identifier	StudyUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2399	\N	(0009,0060)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2274	\N	(0009,0061)	LT	1	Series Unique Identifier	SeriesUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	2400	\N	(0009,0070)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2401	\N	(0009,0075)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2402	\N	(0009,0080)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2403	\N	(0009,0090)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2275	\N	(0009,0091)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6586	\N	(0009,00a0)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2339	\N	(0009,00c0)	LT	1	Unknown	Unknown	SPI-P Release 1;1	\N	\N	\N	\N
f	2340	\N	(0009,00c1)	LT	1	Unknown	Unknown	SPI-P Release 1;1	\N	\N	\N	\N
f	2276	\N	(0009,00f2)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2277	\N	(0009,00f3)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2278	\N	(0009,00f4)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2279	\N	(0009,00f5)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2280	\N	(0009,00f7)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2281	\N	(0011,0010)	LT	1	Patient Entry ID	PatientEntryID	SPI-P Release 1	\N	\N	\N	\N
f	2390	\N	(0011,0018)	LT	1	Unknown	Unknown	SPI-P Release 2;1	\N	\N	\N	\N
f	6587	\N	(0011,0020)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2282	\N	(0011,0021)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2283	\N	(0011,0022)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6588	\N	(0011,0030)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2284	\N	(0011,0031)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2285	\N	(0011,0032)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	55	\N	(0019,0000)	CS	1	Image Blanking Shape	ImageBlankingShape	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1089	\N	(0019,0000)	DS	1	Field of View	FieldOfView	PHILIPS MR R5.5/PART	\N	\N	\N	0010
f	1090	\N	(0019,0000)	DS	1	Field of View	FieldOfView	PHILIPS MR R5.6/PART	\N	\N	\N	0010
f	6589	\N	(0019,0000)	IS	1	Unknown	Unknown	PHILIPS MR/PART 7	\N	\N	\N	\N
f	1191	\N	(0019,0000)	DS	1	Field of View	FieldOfView	PHILIPS MR/PART	\N	\N	\N	0010
f	1253	\N	(0019,0000)	IS	1	Number of Stacks	NumberOfStacks	PHILIPS MR/PART	\N	\N	\N	0011
f	2286	\N	(0019,0000)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2341	\N	(0019,0000)	UN	1	Physiological Data Type	PhysiologicalDataType	SPI-P Release 1;1	\N	\N	\N	\N
f	6590	\N	(0019,0000)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	6591	\N	(0019,0000)	LT	1	Post Mode String	PostModeString	SPI-P-Private-DiDi Release 1	\N	\N	\N	\N
f	6592	\N	(0019,0000)	UN	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1091	\N	(0019,0001)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6593	\N	(0019,0001)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1254	\N	(0019,0001)	IS	1-n	Stack Type	StackType	PHILIPS MR/PART	\N	\N	\N	0011
f	2287	\N	(0019,0001)	LO	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2342	\N	(0019,0001)	UN	1	Physiological Data Channel And Kind	PhysiologicalDataChannelAndKind	SPI-P Release 1;1	\N	\N	\N	\N
f	6594	\N	(0019,0001)	LT	1	Post Data	PostData	SPI-P-Private-DiDi Release 1	\N	\N	\N	\N
f	56	\N	(0019,0002)	IS	1	Image Blanking Left Vertical Edge	ImageBlankingLeftVerticalEdge	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1092	\N	(0019,0002)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1255	\N	(0019,0002)	IS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6595	\N	(0019,0002)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2288	\N	(0019,0002)	UN	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2343	\N	(0019,0002)	US	1	Sample Bits Allocated	SampleBitsAllocated	SPI-P Release 1;1	\N	\N	\N	\N
f	6596	\N	(0019,0002)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1093	\N	(0019,0003)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6597	\N	(0019,0003)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2344	\N	(0019,0003)	US	1	Sample Bits Stored	SampleBitsStored	SPI-P Release 1;1	\N	\N	\N	\N
f	6598	\N	(0019,0003)	DS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	57	\N	(0019,0004)	IS	1	Image Blanking Right Vertical Edge	ImageBlankingRightVerticalEdge	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1094	\N	(0019,0004)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2345	\N	(0019,0004)	US	1	Sample High Bit	SampleHighBit	SPI-P Release 1;1	\N	\N	\N	\N
f	6599	\N	(0019,0004)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1095	\N	(0019,0005)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1192	\N	(0019,0005)	DS	1	CC Angulation	CCAngulation	PHILIPS MR/PART	\N	\N	\N	0010
f	2346	\N	(0019,0005)	US	1	Sample Representation	SampleRepresentation	SPI-P Release 1;1	\N	\N	\N	\N
f	6600	\N	(0019,0005)	DS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	58	\N	(0019,0006)	IS	1	Image Blanking Upper Horizontal Edge	ImageBlankingUpperHorizontalEdge	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1096	\N	(0019,0006)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1193	\N	(0019,0006)	DS	1	AP Angulation	APAngulation	PHILIPS MR/PART	\N	\N	\N	0010
f	2347	\N	(0019,0006)	UN	1	Smallest Sample Value	SmallestSampleValue	SPI-P Release 1;1	\N	\N	\N	\N
f	1097	\N	(0019,0007)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1194	\N	(0019,0007)	DS	1	LR Angulation	LRAngulation	PHILIPS MR/PART	\N	\N	\N	0010
f	2348	\N	(0019,0007)	UN	1	Largest Sample Value	LargestSampleValue	SPI-P Release 1;1	\N	\N	\N	\N
f	59	\N	(0019,0008)	IS	1	Image Blanking Lower Horizontal Edge	ImageBlankingLowerHorizontalEdge	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1098	\N	(0019,0008)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1195	\N	(0019,0008)	IS	1	Patient Orientation 1	PatientOrientation1	PHILIPS MR/PART	\N	\N	\N	0010
f	1195	\N	(0019,0008)	IS	1	Patient Position	PatientPosition	PHILIPS MR/PART	\N	\N	\N	0010
f	2349	\N	(0019,0008)	UN	1	Number Of Samples	NumberOfSamples	SPI-P Release 1;1	\N	\N	\N	\N
f	2404	\N	(0019,0008)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1099	\N	(0019,0009)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1143	\N	(0019,0009)	DS	1	Main Magnetic Field	MainMagneticField	PHILIPS MR/LAST	\N	\N	\N	\N
f	1196	\N	(0019,0009)	IS	1	Patient Orientation	PatientOrientation	PHILIPS MR/PART	\N	\N	\N	0010
f	2350	\N	(0019,0009)	UN	1	Sample Data	SampleData	SPI-P Release 1;1	\N	\N	\N	\N
f	2405	\N	(0019,0009)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1197	\N	(0019,000a)	IS	1	Slice Orientation	SliceOrientation	PHILIPS MR/PART	\N	\N	\N	0010
f	2351	\N	(0019,000a)	UN	1	Sample Rate	SampleRate	SPI-P Release 1;1	\N	\N	\N	\N
f	2406	\N	(0019,000a)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1198	\N	(0019,000b)	DS	1	LR Offcenter	LROffcenter	PHILIPS MR/PART	\N	\N	\N	0010
f	1256	\N	(0019,000b)	DS	1	LR Offcenter	LROffcenter	PHILIPS MR/PART	\N	\N	\N	0011
f	6601	\N	(0019,000b)	DS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1199	\N	(0019,000c)	DS	1	CC Offcenter	CCOffcenter	PHILIPS MR/PART	\N	\N	\N	0010
f	1257	\N	(0019,000c)	DS	1	CC Offcenter	CCOffcenter	PHILIPS MR/PART	\N	\N	\N	0011
f	6602	\N	(0019,000c)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1200	\N	(0019,000d)	DS	1	AP Offcenter	APOffcenter	PHILIPS MR/PART	\N	\N	\N	0010
f	1258	\N	(0019,000d)	DS	1	AP Offcenter	APOffcenter	PHILIPS MR/PART	\N	\N	\N	0011
f	1144	\N	(0019,000e)	IS	1	Flow Compensation	FlowCompensation	PHILIPS MR/LAST	\N	\N	\N	\N
f	1201	\N	(0019,000e)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1202	\N	(0019,000f)	IS	1	Number of Slices	NumberOfSlices	PHILIPS MR/PART	\N	\N	\N	0010
f	60	\N	(0019,0010)	IS	1	Center of Circular Image Blanking	CenterOfCircularImageBlanking	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1100	\N	(0019,0010)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6603	\N	(0019,0010)	IS	1	Unknown	Unknown	PHILIPS MR/PART 6	\N	\N	\N	\N
f	1203	\N	(0019,0010)	DS	1	Slice Factor	SliceFactor	PHILIPS MR/PART	\N	\N	\N	0010
f	2289	\N	(0019,0010)	US	1	Mains Frequency	MainsFrequency	SPI-P Release 1	\N	\N	\N	\N
f	2352	\N	(0019,0010)	UN	1	Physiological Data Type 2	PhysiologicalDataType2	SPI-P Release 1;1	\N	\N	\N	\N
f	2407	\N	(0019,0010)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6604	\N	(0019,0010)	US	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	2453	\N	(0019,0010)	UN	1	Unknown	ECGTimeMapDataBitsAllocated	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	6605	\N	(0019,0010)	LT	1	Image Header	ImageHeader	SPI-P-Private-DiDi Release 1	\N	\N	\N	\N
f	2501	\N	(0019,0010)	LT	1	Video Beam Boost	VideoBeamBoost	SPI-P-XSB-DCI Release 1	\N	\N	\N	\N
f	6606	\N	(0019,0010)	UN	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1204	\N	(0019,0011)	DS	1-n	Echo Times	EchoTimes	PHILIPS MR/PART	\N	\N	\N	0010
f	1289	\N	(0019,0011)	IS	1	Chemical Shift Number	ChemicalShiftNumber	PHILIPS-MR-1	\N	\N	\N	\N
f	2353	\N	(0019,0011)	UN	1	Physiological Data Channel And Kind 2	PhysiologicalDataChannelAndKind2	SPI-P Release 1;1	\N	\N	\N	\N
f	2454	\N	(0019,0011)	UN	1	Unknown	ECGTimeMapDataBitsStored	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	2502	\N	(0019,0011)	US	1	Channel Generating Video Sync	ChannelGeneratingVideoSync	SPI-P-XSB-DCI Release 1	\N	\N	\N	\N
f	6607	\N	(0019,0011)	UN	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	61	\N	(0019,0012)	IS	1	Radius of Circular Image Blanking	RadiusOfCircularImageBlanking	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1101	\N	(0019,0012)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1290	\N	(0019,0012)	IS	1	Phase Number	PhaseNumber	PHILIPS-MR-1	\N	\N	\N	\N
f	2354	\N	(0019,0012)	US	1	Sample Bits Allocated 2	SampleBitsAllocated2	SPI-P Release 1;1	\N	\N	\N	\N
f	2455	\N	(0019,0012)	UN	1	Unknown	ECGTimeMapDataHighBit	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	2503	\N	(0019,0012)	US	1	Video Gain	VideoGain	SPI-P-XSB-DCI Release 1	\N	\N	\N	\N
f	6608	\N	(0019,0012)	UN	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1102	\N	(0019,0013)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1139	\N	(0019,0079)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2355	\N	(0019,0013)	US	1	Sample Bits Stored 2	SampleBitsStored2	SPI-P Release 1;1	\N	\N	\N	\N
f	2456	\N	(0019,0013)	UN	1	Unknown	ECGTimeMapDataRepresentation	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	2504	\N	(0019,0013)	US	1	Video Offset	VideoOffset	SPI-P-XSB-DCI Release 1	\N	\N	\N	\N
f	1103	\N	(0019,0014)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6609	\N	(0019,0014)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2356	\N	(0019,0014)	US	1	Sample High Bit 2	SampleHighBit2	SPI-P Release 1;1	\N	\N	\N	\N
f	6610	\N	(0019,0014)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	2457	\N	(0019,0014)	UN	1	Unknown	ECGTimeMapDataSmallestDataValue	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	1104	\N	(0019,0015)	US	1-n	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1205	\N	(0019,0015)	IS	1	Dynamic Study	DynamicStudy	PHILIPS MR/PART	\N	\N	\N	0010
f	2357	\N	(0019,0015)	US	1	Sample Representation 2	SampleRepresentation2	SPI-P Release 1;1	\N	\N	\N	\N
f	2458	\N	(0019,0015)	UN	1	Unknown	ECGTimeMapDataLargestDataValue	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	1105	\N	(0019,0016)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2358	\N	(0019,0016)	UN	1	Smallest Sample Value 2	SmallestSampleValue2	SPI-P Release 1;1	\N	\N	\N	\N
f	2459	\N	(0019,0016)	UN	1	Unknown	ECGTimeMapDataNumberOfDataValues	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	1106	\N	(0019,0017)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2359	\N	(0019,0017)	UN	1	Largest Sample Value 2	LargestSampleValue2	SPI-P Release 1;1	\N	\N	\N	\N
f	2460	\N	(0019,0017)	UN	1	Unknown	ECGTimeMapData	SPI-P-Private-DCI Release 1	\N	\N	\N	\N
f	1107	\N	(0019,0018)	UN	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1206	\N	(0019,0018)	DS	1	Heartbeat Interval	HeartbeatInterval	PHILIPS MR/PART	\N	\N	\N	0010
f	2360	\N	(0019,0018)	UN	1	Number Of Samples 2	NumberOfSamples2	SPI-P Release 1;1	\N	\N	\N	\N
f	6611	\N	(0019,0018)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1207	\N	(0019,0019)	DS	1	Repetition Time FFE	RepetitionTimeFFE	PHILIPS MR/PART	\N	\N	\N	0010
f	2361	\N	(0019,0019)	UN	1	Sample Data 2	SampleData2	SPI-P Release 1;1	\N	\N	\N	\N
f	6612	\N	(0019,0019)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1208	\N	(0019,001a)	DS	1	FFE Flip Angle	FFEFlipAngle	PHILIPS MR/PART	\N	\N	\N	0010
f	2362	\N	(0019,001a)	UN	1	Sample Rate 2	SampleRate2	SPI-P Release 1;1	\N	\N	\N	\N
f	6613	\N	(0019,001a)	DS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	1209	\N	(0019,001b)	IS	1	Number of Scans	NumberOfScans	PHILIPS MR/PART	\N	\N	\N	0010
f	6614	\N	(0019,001b)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	6615	\N	(0019,001c)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6616	\N	(0019,001c)	IS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	6617	\N	(0019,001d)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6618	\N	(0019,001d)	DS	1	Unknown	Unknown	SPI-P-CTBE Release 1	\N	\N	\N	\N
f	6619	\N	(0019,001e)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1108	\N	(0019,0020)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2408	\N	(0019,0020)	TM	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6620	\N	(0019,0020)	IS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	2505	\N	(0019,0020)	DS	1	RTD Data Compression Factor	RTDDataCompressionFactor	SPI-P-XSB-DCI Release 1	\N	\N	\N	\N
f	6621	\N	(0019,0020)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1109	\N	(0019,0021)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1210	\N	(0019,0021)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6622	\N	(0019,0021)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6623	\N	(0019,0021)	LO	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	77	\N	(0019,0022)	LO	1	Route AET	RouteAET	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1110	\N	(0019,0022)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1211	\N	(0019,0022)	DS	1	Dynamic Scan Time Begin	DynamicScanTimeBegin	PHILIPS MR/PART	\N	\N	\N	0010
f	78	\N	(0019,0023)	DS	1	PCR Print Scale	PCRPrintScale	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1111	\N	(0019,0023)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6624	\N	(0019,0023)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	79	\N	(0019,0024)	ST	1	PCR Print Job End	PCRPrintJobEnd	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1112	\N	(0019,0024)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1212	\N	(0019,0024)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6625	\N	(0019,0024)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	80	\N	(0019,0025)	IS	1	PCR No Film Copies	PCRNoFilmCopies	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1113	\N	(0019,0025)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6626	\N	(0019,0025)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2290	\N	(0019,0025)	LO	1-n	Original Pixel Data Quality	OriginalPixelDataQuality	SPI-P Release 1	\N	\N	\N	\N
f	81	\N	(0019,0026)	IS	1	PCR Film Layout Position	PCRFilmLayoutPosition	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1114	\N	(0019,0026)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6627	\N	(0019,0026)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	82	\N	(0019,0027)	ST	1	PCR Print Report Name	PCRPrintReportName	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1115	\N	(0019,0027)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6628	\N	(0019,0027)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	1116	\N	(0019,0028)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6629	\N	(0019,0028)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	1117	\N	(0019,0029)	IS	1-n	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6630	\N	(0019,0029)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	62	\N	(0019,0030)	UL	1	Maximum Image Frame Size	MaximumImageFrameSize	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	6631	\N	(0019,0030)	LO	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2291	\N	(0019,0030)	US	1	ECG Triggering	ECGTriggering	SPI-P Release 1	\N	\N	\N	\N
f	2449	\N	(0019,0030)	US	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	2463	\N	(0019,0030)	DS	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	1118	\N	(0019,0031)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6632	\N	(0019,0031)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2292	\N	(0019,0031)	UN	1	ECG 1 Offset	ECG1Offset	SPI-P Release 1	\N	\N	\N	\N
f	2464	\N	(0019,0031)	LO	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	1119	\N	(0019,0032)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2293	\N	(0019,0032)	UN	1	ECG 2 Offset 1	ECG2Offset1	SPI-P Release 1	\N	\N	\N	\N
f	2294	\N	(0019,0033)	UN	1	ECG 2 Offset 2	ECG2Offset2	SPI-P Release 1	\N	\N	\N	\N
f	6633	\N	(0019,0040)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6634	\N	(0019,0040)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6635	\N	(0019,0040)	UN	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1120	\N	(0019,0041)	LT	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1121	\N	(0019,0042)	IS	2	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1122	\N	(0019,0043)	IS	2	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1123	\N	(0019,0045)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1259	\N	(0019,0045)	IS	1	Reconstruction Resolution	ReconstructionResolution	PHILIPS MR/PART	\N	\N	\N	0011
f	1124	\N	(0019,0046)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1125	\N	(0019,0047)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1126	\N	(0019,0048)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1127	\N	(0019,0049)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1128	\N	(0019,0050)	UN	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6636	\N	(0019,0050)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6637	\N	(0019,0050)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2295	\N	(0019,0050)	US	1	Video Scan Mode	VideoScanMode	SPI-P Release 1	\N	\N	\N	\N
f	2409	\N	(0019,0050)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6638	\N	(0019,0050)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	6639	\N	(0019,0051)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2296	\N	(0019,0051)	US	1	Video LineRate	VideoLineRate	SPI-P Release 1	\N	\N	\N	\N
f	6640	\N	(0019,0052)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6641	\N	(0019,0053)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6642	\N	(0019,0054)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6643	\N	(0019,0055)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6644	\N	(0019,0056)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6645	\N	(0019,0057)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6646	\N	(0019,0058)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6647	\N	(0019,0059)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	1129	\N	(0019,0060)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6648	\N	(0019,0060)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2297	\N	(0019,0060)	US	1	Xray Technique	XrayTechnique	SPI-P Release 1	\N	\N	\N	\N
f	2410	\N	(0019,0060)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6649	\N	(0019,0060)	LO	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1130	\N	(0019,0061)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6650	\N	(0019,0061)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2298	\N	(0019,0061)	DS	1	Image Identifier Fromat	ImageIdentifierFromat	SPI-P Release 1	\N	\N	\N	\N
f	2411	\N	(0019,0061)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6651	\N	(0019,0062)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2299	\N	(0019,0062)	US	1	Iris Diaphragm	IrisDiaphragm	SPI-P Release 1	\N	\N	\N	\N
f	6652	\N	(0019,0063)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	2300	\N	(0019,0063)	CS	1	Filter	Filter	SPI-P Release 1	\N	\N	\N	\N
f	2412	\N	(0019,0063)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6653	\N	(0019,0064)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	1213	\N	(0019,0064)	DS	1	Repetition Time SE	RepetitionTimeSE	PHILIPS MR/PART	\N	\N	\N	0010
f	2301	\N	(0019,0064)	CS	1	Cine Parallel	CineParallel	SPI-P Release 1	\N	\N	\N	\N
f	2413	\N	(0019,0064)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1214	\N	(0019,0065)	DS	1	Repetition Time IR	RepetitionTimeIR	PHILIPS MR/PART	\N	\N	\N	0010
f	2302	\N	(0019,0065)	CS	1	Cine Master	CineMaster	SPI-P Release 1	\N	\N	\N	\N
f	2414	\N	(0019,0065)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6654	\N	(0019,0066)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0011
f	6655	\N	(0019,0067)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1215	\N	(0019,0069)	IS	1	Number of Phases	NumberOfPhases	PHILIPS MR/PART	\N	\N	\N	0010
f	1216	\N	(0019,006a)	IS	1	Cardiac Frequency	CardiacFrequency	PHILIPS MR/PART	\N	\N	\N	0010
f	1217	\N	(0019,006b)	DS	1	Inversion Delay	InversionDelay	PHILIPS MR/PART	\N	\N	\N	0010
f	1218	\N	(0019,006c)	DS	1	Gate Delay	GateDelay	PHILIPS MR/PART	\N	\N	\N	0010
f	1219	\N	(0019,006d)	DS	1	Gate Width	GateWidth	PHILIPS MR/PART	\N	\N	\N	0010
f	1220	\N	(0019,006e)	DS	1	Trigger Delay Time	TriggerDelayTime	PHILIPS MR/PART	\N	\N	\N	0010
f	83	\N	(0019,0070)	ST	1	RAD Protocol Printer	RADProtocolPrinter	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1131	\N	(0019,0070)	UN	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	6656	\N	(0019,0070)	DS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2303	\N	(0019,0070)	US	1	Exposure Channel	ExposureChannel	SPI-P Release 1	\N	\N	\N	\N
f	2415	\N	(0019,0070)	LT	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	84	\N	(0019,0071)	ST	1	RAD Protocol Medium	RADProtocolMedium	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1132	\N	(0019,0071)	IS	1-n	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2304	\N	(0019,0071)	UN	1	Exposure Channel First Image	ExposureChannelFirstImage	SPI-P Release 1	\N	\N	\N	\N
f	1133	\N	(0019,0072)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	2305	\N	(0019,0072)	US	1	Processing Channel	ProcessingChannel	SPI-P Release 1	\N	\N	\N	\N
f	1134	\N	(0019,0073)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1135	\N	(0019,0074)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1136	\N	(0019,0076)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1137	\N	(0019,0077)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1138	\N	(0019,0078)	US	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1140	\N	(0019,0080)	IS	1	Unknown	Unknown	PHILIPS MR SPECTRO;1	\N	\N	\N	\N
f	1221	\N	(0019,0080)	IS	1	Number of Chemical Shifts	NumberOfChemicalShifts	PHILIPS MR/PART	\N	\N	\N	0010
f	2306	\N	(0019,0080)	DS	1	Acquisition Delay	AcquisitionDelay	SPI-P Release 1	\N	\N	\N	\N
f	2416	\N	(0019,0080)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6657	\N	(0019,0080)	US	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1222	\N	(0019,0081)	DS	1	Chemical Shift	ChemicalShift	PHILIPS MR/PART	\N	\N	\N	0010
f	2307	\N	(0019,0081)	UN	1	Relative Image Time	RelativeImageTime	SPI-P Release 1	\N	\N	\N	\N
f	2417	\N	(0019,0081)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1223	\N	(0019,0084)	IS	1	Number of Rows	NumberOfRows	PHILIPS MR/PART	\N	\N	\N	0010
f	1224	\N	(0019,0085)	IS	1	Number of Samples	NumberOfSamples	PHILIPS MR/PART	\N	\N	\N	0010
f	6658	\N	(0019,0089)	IS	1	Exposure Index	ExposureIndex	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6659	\N	(0019,008a)	IS	1	Collimator X	CollimatorX	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6660	\N	(0019,008a)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6661	\N	(0019,008b)	IS	1	Collimator Y	CollimatorY	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6662	\N	(0019,008b)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6663	\N	(0019,008c)	LO	1	Print Marker	PrintMarker	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6664	\N	(0019,008c)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6665	\N	(0019,008d)	LO	1	RGDV Name	RGDVName	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6666	\N	(0019,008d)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6667	\N	(0019,008e)	LO	1	Acqd Sensitivity	AcqdSensitivity	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6668	\N	(0019,008e)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6669	\N	(0019,008f)	LO	1	Processing Category	ProcessingCategory	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6670	\N	(0019,008f)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	85	\N	(0019,0090)	LO	1	Unprocessed Flag	UnprocessedFlag	DIDI TO PCR 1.1	\N	\N	\N	\N
f	2308	\N	(0019,0090)	CS	1	Video White Compression	VideoWhiteCompression	SPI-P Release 1	\N	\N	\N	\N
f	2418	\N	(0019,0090)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6671	\N	(0019,0090)	LO	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	86	\N	(0019,0091)	DS	1-n	Key Values	KeyValues	DIDI TO PCR 1.1	\N	\N	\N	\N
f	87	\N	(0019,0092)	LO	1	Destination Postprocessing Function	DestinationPostprocessingFunction	DIDI TO PCR 1.1	\N	\N	\N	\N
f	1225	\N	(0019,0094)	LO	1	Magnetization Transfer Contrast	MagnetizationTransferContrast	PHILIPS MR/PART	\N	\N	\N	0010
f	1226	\N	(0019,0095)	LO	1	Spectral Presaturation With Inversion Recovery	SpectralPresaturationWithInversionRecovery	PHILIPS MR/PART	\N	\N	\N	0010
f	1227	\N	(0019,0096)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1228	\N	(0019,0097)	LO	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6672	\N	(0019,00a0)	LO	1	Version	Version	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6673	\N	(0019,00a1)	LO	1	Ranging Mode	RangingMode	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6674	\N	(0019,00a2)	DS	1	Abdomen Brightness	AbdomenBrightness	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6675	\N	(0019,00a3)	DS	1	Fixed Brightness	FixedBrightness	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6676	\N	(0019,00a4)	DS	1	Detail Contrast	DetailContrast	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6677	\N	(0019,00a5)	DS	1	Contrast Balance	ContrastBalance	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6678	\N	(0019,00a6)	DS	1	Structure Boost	StructureBoost	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6679	\N	(0019,00a7)	DS	1	Structure Preference	StructurePreference	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6680	\N	(0019,00a8)	DS	1	Noise Robustness	NoiseRobustness	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6681	\N	(0019,00a9)	DS	1	Noise Dose Limit	NoiseDoseLimit	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6682	\N	(0019,00aa)	DS	1	Noise Dose Step	NoiseDoseStep	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6683	\N	(0019,00ab)	DS	1	Noise Frequency Limit	NoiseFrequencyLimit	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6684	\N	(0019,00ac)	DS	1	Weak Contrast Limit	WeakContrastLimit	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6685	\N	(0019,00ad)	DS	1	Strong Contrast Limit	StrongContrastLimit	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6686	\N	(0019,00ae)	DS	1	Structure Boost Offset	StructureBoostOffset	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6687	\N	(0019,00af)	LO	1	Smooth Gain	SmoothGain	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6688	\N	(0019,00b0)	LO	1	Measure Field 1	MeasureField1	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6689	\N	(0019,00b1)	LO	1	Measure Field 2	MeasureField2	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6690	\N	(0019,00b2)	IS	1	Key Percentile 1	KeyPercentile1	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6691	\N	(0019,00b3)	IS	1	Key Percentile 2	KeyPercentile2	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6692	\N	(0019,00b4)	IS	1	Density LUT	DensityLUT	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6693	\N	(0019,00b4)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6694	\N	(0019,00b5)	DS	1	Brightness	Brightness	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6695	\N	(0019,00b5)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6696	\N	(0019,00b6)	DS	1	Gamma	Gamma	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6697	\N	(0019,00b6)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6698	\N	(0019,00b7)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	6699	\N	(0019,00d1)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6700	\N	(0019,00d3)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6701	\N	(0019,00e4)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	6702	\N	(0019,00e5)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	6703	\N	(0019,00f0)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6704	\N	(0019,00f6)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6705	\N	(0019,00f7)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6706	\N	(0019,00f8)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6707	\N	(0019,00f9)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6708	\N	(0019,00fa)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6709	\N	(0019,00fb)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6710	\N	(0019,00fc)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1229	\N	(0019,00a0)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2309	\N	(0019,00a0)	US	1	Angulation	Angulation	SPI-P Release 1	\N	\N	\N	\N
f	2419	\N	(0019,00a0)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1230	\N	(0019,00a1)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2310	\N	(0019,00a1)	US	1	Rotation	Rotation	SPI-P Release 1	\N	\N	\N	\N
f	2420	\N	(0019,00a1)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6711	\N	(0019,00a1)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	2421	\N	(0019,00a2)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1231	\N	(0019,00a3)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2422	\N	(0019,00a3)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6712	\N	(0019,00a3)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1232	\N	(0019,00a4)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6713	\N	(0019,00a4)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6714	\N	(0019,00a5)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6715	\N	(0019,00a6)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6716	\N	(0019,00a7)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6717	\N	(0019,00a8)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6718	\N	(0019,00a9)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6719	\N	(0019,00aa)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6720	\N	(0019,00ab)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6721	\N	(0019,00ac)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6722	\N	(0019,00ad)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6723	\N	(0019,00ae)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6724	\N	(0019,00af)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	2423	\N	(0019,00b0)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6725	\N	(0019,00b0)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1145	\N	(0019,00b1)	IS	1	Minimum RR Interval	MinimumRRInterval	PHILIPS MR/LAST	\N	\N	\N	\N
f	2424	\N	(0019,00b1)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6726	\N	(0019,00b1)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1146	\N	(0019,00b2)	IS	1	Maximum RR Interval	MaximumRRInterval	PHILIPS MR/LAST	\N	\N	\N	\N
f	6727	\N	(0019,00b2)	IS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1147	\N	(0019,00b3)	IS	1	Number of Rejections	NumberOfRejections	PHILIPS MR/LAST	\N	\N	\N	\N
f	6728	\N	(0019,00b3)	IS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1148	\N	(0019,00b4)	IS	1-n	Number of RR Intervals	NumberOfRRIntervals	PHILIPS MR/LAST	\N	\N	\N	\N
f	6729	\N	(0019,00b4)	IS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1149	\N	(0019,00b5)	IS	1	Arrhythmia Rejection	ArrhythmiaRejection	PHILIPS MR/LAST	\N	\N	\N	\N
f	6730	\N	(0019,00b5)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6731	\N	(0019,00b6)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6732	\N	(0019,00b7)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6733	\N	(0019,00b8)	DS	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6734	\N	(0019,00b9)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	6735	\N	(0019,00ba)	ST	1	Unknown	Unknown	SPI-P-PCR Release 2	\N	\N	\N	\N
f	1150	\N	(0019,00c0)	DS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1261	\N	(0019,00c0)	DS	1	Trigger Delay Times	TriggerDelayTimes	PHILIPS MR/PART	\N	\N	\N	0012
f	1151	\N	(0019,00c6)	IS	1	Cycled Multiple Slice	CycledMultipleSlice	PHILIPS MR/LAST	\N	\N	\N	\N
f	1233	\N	(0019,00c8)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1234	\N	(0019,00c9)	IS	1	Foldover Direction Transverse	FoldoverDirectionTransverse	PHILIPS MR/PART	\N	\N	\N	0010
f	1235	\N	(0019,00ca)	IS	1	Foldover Direction Sagittal	FoldoverDirectionSagittal	PHILIPS MR/PART	\N	\N	\N	0010
f	1236	\N	(0019,00cb)	IS	1	Foldover Direction Coronal	FoldoverDirectionCoronal	PHILIPS MR/PART	\N	\N	\N	0010
f	1237	\N	(0019,00cc)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1238	\N	(0019,00cd)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1152	\N	(0019,00ce)	IS	1	REST	REST	PHILIPS MR/LAST	\N	\N	\N	\N
f	1239	\N	(0019,00ce)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1240	\N	(0019,00cf)	IS	1	Number of Echoes	NumberOfEchoes	PHILIPS MR/PART	\N	\N	\N	0010
f	1241	\N	(0019,00d0)	IS	1	Scan Resolution	ScanResolution	PHILIPS MR/PART	\N	\N	\N	0010
f	1242	\N	(0019,00d2)	LO	2	Water Fat Shift	WaterFatShift	PHILIPS MR/PART	\N	\N	\N	0010
f	1243	\N	(0019,00d4)	IS	1	Artifact Reduction	ArtifactReduction	PHILIPS MR/PART	\N	\N	\N	0010
f	1153	\N	(0019,00d5)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1244	\N	(0019,00d5)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1154	\N	(0019,00d6)	IS	1	Fourier Interpolation	FourierInterpolation	PHILIPS MR/LAST	\N	\N	\N	\N
f	1245	\N	(0019,00d6)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1246	\N	(0019,00d7)	DS	1	Scan Percentage	ScanPercentage	PHILIPS MR/PART	\N	\N	\N	0010
f	1247	\N	(0019,00d8)	IS	1	Halfscan	Halfscan	PHILIPS MR/PART	\N	\N	\N	0010
f	1155	\N	(0019,00d9)	IS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1248	\N	(0019,00d9)	IS	1	EPI Factor	EPIFactor	PHILIPS MR/PART	\N	\N	\N	0010
f	1249	\N	(0019,00da)	IS	1	Turbo Factor	TurboFactor	PHILIPS MR/PART	\N	\N	\N	0010
f	1250	\N	(0019,00db)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1156	\N	(0019,00e0)	IS	1	Prepulse	Prepulse	PHILIPS MR/LAST	\N	\N	\N	\N
f	1251	\N	(0019,00e0)	IS	1	Percentage of Scan Completed	PercentageOfScanCompleted	PHILIPS MR/PART	\N	\N	\N	0010
f	1262	\N	(0019,00e0)	IS	1	Prepulse Type	PrepulseType	PHILIPS MR/PART	\N	\N	\N	0012
f	1157	\N	(0019,00e1)	DS	1	Prepulse Delay	PrepulseDelay	PHILIPS MR/LAST	\N	\N	\N	\N
f	1252	\N	(0019,00e1)	IS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1263	\N	(0019,00e1)	DS	1	Prepulse Delay	PrepulseDelay	PHILIPS MR/PART	\N	\N	\N	0012
f	1158	\N	(0019,00e2)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1159	\N	(0019,00e3)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1264	\N	(0019,00e3)	DS	1	Phase Contrast Velocity	PhaseContrastVelocity	PHILIPS MR/PART	\N	\N	\N	0012
f	1160	\N	(0019,00f0)	LT	1	WS Protocol String 1	WSProtocolString1	PHILIPS MR/LAST	\N	\N	\N	\N
f	1161	\N	(0019,00f1)	LT	1	WS Protocol String 2	WSProtocolString2	PHILIPS MR/LAST	\N	\N	\N	\N
f	1162	\N	(0019,00f2)	LT	1	WS Protocol String 3	WSProtocolString3	PHILIPS MR/LAST	\N	\N	\N	\N
f	1163	\N	(0019,00f3)	LT	1	WS Protocol String 4	WSProtocolString4	PHILIPS MR/LAST	\N	\N	\N	\N
f	1260	\N	(0019,00fc)	IS	1	Resonance Frequency	ResonanceFrequency	PHILIPS MR/PART	\N	\N	\N	0011
f	1164	\N	(0021,0000)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1265	\N	(0021,0000)	IS	1	Reconstruction Number	ReconstructionNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	1276	\N	(0021,0000)	DA	1	Scan Date	ScanDate	PHILIPS MR/PART	\N	\N	\N	0011
f	1276	\N	(0021,0000)	DA	1	Series Date	SeriesDate	PHILIPS MR/PART	\N	\N	\N	0011
f	6736	\N	(0021,0000)	DS	1	Unknown	Unknown	SPI-P-CTBE-Private Release 1	\N	\N	\N	\N
f	2450	\N	(0021,0000)	LT	1	Window Of Images ID	WindowOfImagesID	SPI-P-Private-CWS Release 1	\N	\N	\N	\N
f	1291	\N	(0021,0001)	IS	1	Reconstruction Number	ReconstructionNumber	PHILIPS-MR-1	\N	\N	\N	\N
f	2451	\N	(0021,0001)	CS	1	Window Of Images Type	WindowOfImagesType	SPI-P-Private-CWS Release 1	\N	\N	\N	\N
f	1292	\N	(0021,0002)	IS	1	Slice Number	SliceNumber	PHILIPS-MR-1	\N	\N	\N	\N
f	2452	\N	(0021,0002)	IS	1-n	WindowOfImagesScope	WindowOfImagesScope	SPI-P-Private-CWS Release 1	\N	\N	\N	\N
f	6737	\N	(0021,0006)	LO	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6738	\N	(0021,0008)	LO	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6739	\N	(0021,0009)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6740	\N	(0021,000a)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6741	\N	(0021,000f)	LO	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1165	\N	(0021,0010)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1266	\N	(0021,0010)	IS	1	Image Type	ImageType	PHILIPS MR/PART	\N	\N	\N	0010
f	1277	\N	(0021,0010)	TM	1	Scan Time	ScanTime	PHILIPS MR/PART	\N	\N	\N	0011
f	2311	\N	(0021,0012)	LT	1	Series Unique Identifier	SeriesUniqueIdentifier	SPI-P Release 1	\N	\N	\N	\N
f	63	\N	(0021,0013)	IS	1	Image Sequence Number	ImageSequenceNumber	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	6742	\N	(0021,0013)	CS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2312	\N	(0021,0014)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6743	\N	(0021,0015)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	1166	\N	(0021,0020)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1267	\N	(0021,0020)	IS	1	Slice Number	SliceNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	2425	\N	(0021,0020)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1167	\N	(0021,0021)	DS	1	Slice Gap	SliceGap	PHILIPS MR/LAST	\N	\N	\N	\N
f	1278	\N	(0021,0021)	IS	1	Slice Gap	SliceGap	PHILIPS MR/PART	\N	\N	\N	0012
f	1168	\N	(0021,0022)	DS	1	Stack Radial Angle	StackRadialAngle	PHILIPS MR/LAST	\N	\N	\N	\N
f	1268	\N	(0021,0030)	IS	1	Echo Number	EchoNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	2426	\N	(0021,0030)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1269	\N	(0021,0031)	DS	1	Patient Reference ID	PatientReferenceID	PHILIPS MR/PART	\N	\N	\N	0010
f	1270	\N	(0021,0035)	IS	1	Chemical Shift Number	ChemicalShiftNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	1271	\N	(0021,0040)	IS	1	Phase Number	PhaseNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	2427	\N	(0021,0040)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2461	\N	(0021,0040)	IS	1	Unknown	Unknown	SPI-P-Private_CDS Release 1	\N	\N	\N	\N
f	1272	\N	(0021,0050)	IS	1	Dynamic Scan Number	DynamicScanNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	2428	\N	(0021,0050)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1273	\N	(0021,0060)	IS	1	Number of Rows In Object	NumberOfRowsInObject	PHILIPS MR/PART	\N	\N	\N	0010
f	2429	\N	(0021,0060)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1274	\N	(0021,0061)	IS	1-n	Row Number	RowNumber	PHILIPS MR/PART	\N	\N	\N	0010
f	1275	\N	(0021,0062)	IS	1-n	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2430	\N	(0021,0070)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2431	\N	(0021,0080)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2432	\N	(0021,0090)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2433	\N	(0021,00a0)	US	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2434	\N	(0021,00a1)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2435	\N	(0021,00a2)	DS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2436	\N	(0021,00a3)	LT	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2437	\N	(0021,00a4)	LT	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2438	\N	(0021,00b0)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2439	\N	(0021,00c0)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2391	\N	(0023,000d)	UI	1	Unknown	Unknown	SPI-P Release 2;1	\N	\N	\N	\N
f	2392	\N	(0023,000e)	UI	1	Unknown	Unknown	SPI-P Release 2;1	\N	\N	\N	\N
f	1169	\N	(0027,0000)	US	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1170	\N	(0027,0011)	US	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1171	\N	(0027,0012)	DS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1172	\N	(0027,0013)	DS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1173	\N	(0027,0014)	DS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1174	\N	(0027,0015)	DS	1-n	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	1175	\N	(0027,0016)	LO	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	64	\N	(0029,0000)	SQ	1	Edge Enhancement Sequence	EdgeEnhancementSequence	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	1279	\N	(0029,0000)	DS	2	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2313	\N	(0029,0000)	DS	4	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2363	\N	(0029,0000)	LT	1	Zoom ID	ZoomID	SPI-P Release 1;1	\N	\N	\N	\N
f	2375	\N	(0029,0000)	LT	1	Subtraction Mask ID	SubtractionMaskID	SPI-P Release 1;2	\N	\N	\N	\N
f	2380	\N	(0029,0000)	LT	1	Image Enhancement ID	ImageEnhancementID	SPI-P Release 1;3	\N	\N	\N	\N
f	2462	\N	(0029,0000)	UN	1	Unknown	Unknown	SPI-P-Private_CDS Release 1	\N	\N	\N	\N
f	2478	\N	(0029,0000)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2484	\N	(0029,0000)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6744	\N	(0029,0000)	ST	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;3	\N	\N	\N	\N
f	6745	\N	(0029,0000)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	65	\N	(0029,0001)	US	2	Convolution Kernel Size	ConvolutionKernelSize	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2364	\N	(0029,0001)	DS	1-n	Zoom Rectangle	ZoomRectangle	SPI-P Release 1;1	\N	\N	\N	\N
f	2381	\N	(0029,0001)	LT	1	Image Enhancement	ImageEnhancement	SPI-P Release 1;3	\N	\N	\N	\N
f	2485	\N	(0029,0001)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6746	\N	(0029,0001)	ST	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;3	\N	\N	\N	\N
f	6747	\N	(0029,0001)	DS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	66	\N	(0029,0002)	US	1-n	Convolution Kernel Coefficients	ConvolutionKernelCoefficients	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2382	\N	(0029,0002)	LT	1	Convolution ID	ConvolutionID	SPI-P Release 1;3	\N	\N	\N	\N
f	2486	\N	(0029,0002)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6748	\N	(0029,0002)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	67	\N	(0029,0003)	FL	1	Edge Enhancement Gain	EdgeEnhancementGain	CARDIO-D.R. 1.0	\N	\N	\N	\N
f	2365	\N	(0029,0003)	DS	1	Zoom Factor	ZoomFactor	SPI-P Release 1;1	\N	\N	\N	\N
f	2383	\N	(0029,0003)	LT	1	Convolution Type	ConvolutionType	SPI-P Release 1;3	\N	\N	\N	\N
f	2487	\N	(0029,0003)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	1280	\N	(0029,0004)	US	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2366	\N	(0029,0004)	US	1	Zoom Function	ZoomFunction	SPI-P Release 1;1	\N	\N	\N	\N
f	2376	\N	(0029,0004)	UN	1	Masking Function	MaskingFunction	SPI-P Release 1;2	\N	\N	\N	\N
f	2384	\N	(0029,0004)	LT	1	Convolution Kernel Size ID	ConvolutionKernelSizeID	SPI-P Release 1;3	\N	\N	\N	\N
f	2488	\N	(0029,0004)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	2385	\N	(0029,0005)	US	2	Convolution Kernel Size	ConvolutionKernelSize	SPI-P Release 1;3	\N	\N	\N	\N
f	2479	\N	(0029,0005)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2489	\N	(0029,0005)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	2386	\N	(0029,0006)	US	1-n	Convolution Kernel	ConvolutionKernel	SPI-P Release 1;3	\N	\N	\N	\N
f	2480	\N	(0029,0006)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2377	\N	(0029,000c)	UN	1	Proprietary Masking Parameters	ProprietaryMaskingParameters	SPI-P Release 1;2	\N	\N	\N	\N
f	2387	\N	(0029,000c)	DS	1	Enhancement Gain	EnhancementGain	SPI-P Release 1;3	\N	\N	\N	\N
f	6749	\N	(0029,000d)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2367	\N	(0029,000e)	CS	1	Zoom Enable Status	ZoomEnableStatus	SPI-P Release 1;1	\N	\N	\N	\N
f	6750	\N	(0029,000e)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2368	\N	(0029,000f)	CS	1	Zoom Select Status	ZoomSelectStatus	SPI-P Release 1;1	\N	\N	\N	\N
f	2466	\N	(0029,000f)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6751	\N	(0029,000f)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1176	\N	(0029,0010)	DS	1	FP Min	FPMin	PHILIPS MR/LAST	\N	\N	\N	\N
f	1281	\N	(0029,0010)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2440	\N	(0029,0010)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6752	\N	(0029,0010)	OB	1	Unknown	Unknown	SPI-P-Private_CDS Release 1	\N	\N	\N	\N
f	2467	\N	(0029,0010)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6753	\N	(0029,0010)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1282	\N	(0029,0011)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	6754	\N	(0029,0011)	DS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	6755	\N	(0029,0012)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6756	\N	(0029,0012)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	2468	\N	(0029,001b)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2469	\N	(0029,001c)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6757	\N	(0029,001d)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2378	\N	(0029,001e)	CS	1	Subtraction Mask Enable Status	SubtractionMaskEnableStatus	SPI-P Release 1;2	\N	\N	\N	\N
f	2388	\N	(0029,001e)	CS	1	Image Enhancement Enable Status	ImageEnhancementEnableStatus	SPI-P Release 1;3	\N	\N	\N	\N
f	6758	\N	(0029,001e)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2379	\N	(0029,001f)	CS	1	Subtraction Mask Select Status	SubtractionMaskSelectStatus	SPI-P Release 1;2	\N	\N	\N	\N
f	2389	\N	(0029,001f)	CS	1	Image Enhancement Select Status	ImageEnhancementSelectStatus	SPI-P Release 1;3	\N	\N	\N	\N
f	6759	\N	(0029,001f)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1177	\N	(0029,0020)	DS	1	FP Max	FPMax	PHILIPS MR/LAST	\N	\N	\N	\N
f	1283	\N	(0029,0020)	LO	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2314	\N	(0029,0020)	DS	1	Pixel Aspect Ratio	PixelAspectRatio	SPI-P Release 1	\N	\N	\N	\N
f	6760	\N	(0029,0020)	UN	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2481	\N	(0029,0020)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6761	\N	(0029,0020)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	2470	\N	(0029,0021)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2482	\N	(0029,0021)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6762	\N	(0029,0021)	DS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	6763	\N	(0029,0022)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	2315	\N	(0029,0025)	LO	1-n	Processed Pixel Data Quality	ProcessedPixelDataQuality	SPI-P Release 1	\N	\N	\N	\N
f	6764	\N	(0029,002f)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1178	\N	(0029,0030)	DS	1	Scaled Minimum	ScaledMinimum	PHILIPS MR/LAST	\N	\N	\N	\N
f	2316	\N	(0029,0030)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2441	\N	(0029,0030)	UL	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6765	\N	(0029,0030)	LT	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6766	\N	(0029,0030)	LO	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1284	\N	(0029,0031)	DS	2	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2442	\N	(0029,0031)	UL	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6767	\N	(0029,0031)	DS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1285	\N	(0029,0032)	DS	2	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	\N
f	2443	\N	(0029,0032)	UL	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6768	\N	(0029,0032)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	2444	\N	(0029,0033)	UL	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	2317	\N	(0029,0038)	US	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6769	\N	(0029,003f)	CS	1	Unknown	Unknown	SPI-P-XSB-VISUB Release 1	\N	\N	\N	\N
f	1179	\N	(0029,0040)	DS	1	Scaled Maximum	ScaledMaximum	PHILIPS MR/LAST	\N	\N	\N	\N
f	2369	\N	(0029,0040)	LT	1	Magnifying Glass ID	MagnifyingGlassID	SPI-P Release 1;1	\N	\N	\N	\N
f	2370	\N	(0029,0041)	DS	1-n	Magnifying Glass Rectangle	MagnifyingGlassRectangle	SPI-P Release 1;1	\N	\N	\N	\N
f	2371	\N	(0029,0043)	DS	1	Magnifying Glass Factor	MagnifyingGlassFactor	SPI-P Release 1;1	\N	\N	\N	\N
f	2372	\N	(0029,0044)	US	1	Magnifying Glass Function	MagnifyingGlassFunction	SPI-P Release 1;1	\N	\N	\N	\N
f	6770	\N	(0029,004c)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6771	\N	(0029,004d)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2373	\N	(0029,004e)	CS	1	Magnifying Glass Enable Status	MagnifyingGlassEnableStatus	SPI-P Release 1;1	\N	\N	\N	\N
f	6772	\N	(0029,004e)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2374	\N	(0029,004f)	CS	1	Magnifying Glass Select Status	MagnifyingGlassSelectStatus	SPI-P Release 1;1	\N	\N	\N	\N
f	6773	\N	(0029,004f)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	1180	\N	(0029,0050)	DS	1	Window Minimum	WindowMinimum	PHILIPS MR/LAST	\N	\N	\N	\N
f	6774	\N	(0029,0050)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6775	\N	(0029,0050)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2499	\N	(0029,0050)	CS	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;5	\N	\N	\N	\N
f	6776	\N	(0029,0051)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6777	\N	(0029,0051)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6778	\N	(0029,0052)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	6779	\N	(0029,0053)	DS	1	Unknown	Unknown	PHILIPS MR/PART	\N	\N	\N	0010
f	2500	\N	(0029,0055)	CS	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;5	\N	\N	\N	\N
f	1181	\N	(0029,0060)	DS	1	Window Maximum	WindowMaximum	PHILIPS MR/LAST	\N	\N	\N	\N
f	2318	\N	(0029,0060)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	1182	\N	(0029,0061)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	2319	\N	(0029,0061)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6780	\N	(0029,0062)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	2320	\N	(0029,0067)	LT	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2474	\N	(0029,0067)	LO	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2475	\N	(0029,0068)	US	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6781	\N	(0029,006a)	LO	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6782	\N	(0029,006b)	US	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	1183	\N	(0029,0070)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	2321	\N	(0029,0070)	LT	1	Window ID	WindowID	SPI-P Release 1	\N	\N	\N	\N
f	1184	\N	(0029,0071)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	2322	\N	(0029,0071)	CS	1	Video Invert Subtracted	VideoInvertSubtracted	SPI-P Release 1	\N	\N	\N	\N
f	1185	\N	(0029,0072)	IS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	2323	\N	(0029,0072)	CS	1	Video Invert Nonsubtracted	VideoInvertNonsubtracted	SPI-P Release 1	\N	\N	\N	\N
f	6783	\N	(0029,0072)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	2324	\N	(0029,0077)	CS	1	Window Select Status	WindowSelectStatus	SPI-P Release 1	\N	\N	\N	\N
f	2325	\N	(0029,0078)	LT	1	ECG Display Printing ID	ECGDisplayPrintingID	SPI-P Release 1	\N	\N	\N	\N
f	2326	\N	(0029,0079)	CS	1	ECG Display Printing	ECGDisplayPrinting	SPI-P Release 1	\N	\N	\N	\N
f	2327	\N	(0029,007e)	CS	1	ECG Display Printing Enable Status	ECGDisplayPrintingEnableStatus	SPI-P Release 1	\N	\N	\N	\N
f	2328	\N	(0029,007f)	CS	1	ECG Display Printing Select Status	ECGDisplayPrintingSelectStatus	SPI-P Release 1	\N	\N	\N	\N
f	1186	\N	(0029,0080)	IS	1	View Center	ViewCenter	PHILIPS MR/LAST	\N	\N	\N	\N
f	2329	\N	(0029,0080)	LT	1	Physiological Display ID	PhysiologicalDisplayID	SPI-P Release 1	\N	\N	\N	\N
f	2445	\N	(0029,0080)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	1187	\N	(0029,0081)	IS	1	View Size	ViewSize	PHILIPS MR/LAST	\N	\N	\N	\N
f	2330	\N	(0029,0081)	US	1	Preferred Physiological Channel Display	PreferredPhysiologicalChannelDisplay	SPI-P Release 1	\N	\N	\N	\N
f	1188	\N	(0029,0082)	IS	1	View Zoom	ViewZoom	PHILIPS MR/LAST	\N	\N	\N	\N
f	1189	\N	(0029,0083)	IS	1	View Transform	ViewTransform	PHILIPS MR/LAST	\N	\N	\N	\N
f	2331	\N	(0029,008e)	CS	1	Physiological Display Enable Status	PhysiologicalDisplayEnableStatus	SPI-P Release 1	\N	\N	\N	\N
f	2332	\N	(0029,008f)	CS	1	Physiological Display Select Status	PhysiologicalDisplaySelectStatus	SPI-P Release 1	\N	\N	\N	\N
f	6784	\N	(0029,0090)	DS	1-n	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2446	\N	(0029,0090)	LO	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6785	\N	(0029,0091)	US	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6786	\N	(0029,0091)	IS	1	Unknown	Unknown	SPI-P-Private_ICS Release 1	\N	\N	\N	\N
f	6787	\N	(0029,009f)	CS	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6788	\N	(0029,00a0)	DS	1-n	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6789	\N	(0029,00a0)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6790	\N	(0029,00a1)	US	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6791	\N	(0029,00a1)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6792	\N	(0029,00a2)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6793	\N	(0029,00a3)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6794	\N	(0029,00a5)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6795	\N	(0029,00a6)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6796	\N	(0029,00af)	CS	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6797	\N	(0029,00b0)	DS	1-n	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6798	\N	(0029,00b1)	US	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	6799	\N	(0029,00bf)	CS	1	Unknown	Unknown	SPI-P Release 1	\N	\N	\N	\N
f	2333	\N	(0029,00c0)	LT	1	Functional Shutter ID	FunctionalShutterID	SPI-P Release 1	\N	\N	\N	\N
f	6800	\N	(0029,00c0)	SL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2334	\N	(0029,00c1)	US	1	Field Of Shutter	FieldOfShutter	SPI-P Release 1	\N	\N	\N	\N
f	6801	\N	(0029,00c1)	US	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	1286	\N	(0029,00c3)	IS	1	Scan Resolution	ScanResolution	PHILIPS MR/PART	\N	\N	\N	\N
f	1287	\N	(0029,00c4)	IS	1	Field of View	FieldOfView	PHILIPS MR/PART	\N	\N	\N	\N
f	2335	\N	(0029,00c5)	LT	1	Field Of Shutter Rectangle	FieldOfShutterRectangle	SPI-P Release 1	\N	\N	\N	\N
f	6802	\N	(0029,00cb)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6803	\N	(0029,00cc)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6804	\N	(0029,00cd)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2336	\N	(0029,00ce)	CS	1	Shutter Enable Status	ShutterEnableStatus	SPI-P Release 1	\N	\N	\N	\N
f	2337	\N	(0029,00cf)	CS	1	Shutter Select Status	ShutterSelectStatus	SPI-P Release 1	\N	\N	\N	\N
f	2447	\N	(0029,00d0)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6805	\N	(0029,00d0)	UN	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	2448	\N	(0029,00d1)	IS	1	Unknown	Unknown	SPI-P-GV-CT Release 1	\N	\N	\N	\N
f	6806	\N	(0029,00d1)	LO	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6807	\N	(0029,00d2)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6808	\N	(0029,00d3)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6809	\N	(0029,00d4)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	1288	\N	(0029,00d5)	LT	1	Slice Thickness	SliceThickness	PHILIPS MR/PART	\N	\N	\N	\N
f	6810	\N	(0029,00d5)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6811	\N	(0029,00d6)	ST	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;1	\N	\N	\N	\N
f	6812	\N	(0029,00d6)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6813	\N	(0029,00d7)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6814	\N	(0029,00d8)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6815	\N	(0029,00d9)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;2	\N	\N	\N	\N
f	6816	\N	(0029,00d9)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6817	\N	(0029,00da)	FL	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6818	\N	(0029,00dc)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6819	\N	(0029,00dd)	FD	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6820	\N	(0029,00e0)	SQ	1	Unknown	Unknown	SPI-P-Private_ICS Release 1;4	\N	\N	\N	\N
f	6821	\N	(0041,0007)	LO	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	6822	\N	(0041,0009)	DS	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	111	\N	(0089,0010)	SQ	1	Stamp Image Sequence	StampImageSequence	DIDI TO PCR 1.1	\N	\N	\N	\N
f	6823	\N	(0089,0020)	SQ	1	Unknown	Unknown	PMS-THORA-5.1	\N	\N	\N	\N
f	6824	\N	(0511,0000)	US	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6825	\N	(0511,0001)	US	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6826	\N	(0511,0002)	OB	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6827	\N	(0511,0003)	OB	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6828	\N	(0511,0032)	DS	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6829	\N	(0511,0050)	DS	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	6830	\N	(1001,0003)	LO	1	Unknown	Unknown	Philips Imaging DD 124	\N	\N	\N	\N
f	6831	\N	(2001,0000)	SQ	1	Presentation State Sequence	PresentationStateSequence	Philips Imaging DD 129	\N	\N	\N	\N
f	1024	\N	(2001,0001)	FL	1	Chemical Shift	ChemicalShift	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	984	\N	(2001,0001)	FL	1	Chemical Shift	ChemicalShift	Philips Imaging DD 001	\N	\N	\N	\N
f	6832	\N	(2001,0001)	US	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6833	\N	(2001,0001)	SQ	1	PresentationStateSequence	PresentationStateSequence	Philips Imaging DD 129	\N	\N	\N	\N
f	1025	\N	(2001,0002)	IS	1	Chemical Shift Number MR	ChemicalShiftNumberMR	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	985	\N	(2001,0002)	IS	1	Chemical Shift Number MR	ChemicalShiftNumberMR	Philips Imaging DD 001	\N	\N	\N	\N
f	6834	\N	(2001,0002)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1026	\N	(2001,0003)	FL	1	Diffusion B-Factor	DiffusionBFactor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	986	\N	(2001,0003)	FL	1	Diffusion B-Factor	DiffusionBFactor	Philips Imaging DD 001	\N	\N	\N	\N
f	1027	\N	(2001,0004)	CS	1	Diffusion Direction	DiffusionDirection	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	987	\N	(2001,0004)	CS	1	Diffusion Direction	DiffusionDirection	Philips Imaging DD 001	\N	\N	\N	\N
f	6835	\N	(2001,0005)	SS	1	Graphic Annotation ParentID	GraphicAnnotationParentID	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6836	\N	(2001,0005)	SS	1	Graphic Annotation ParentID	GraphicAnnotationParentID	Philips Imaging DD 001	\N	\N	\N	\N
f	1028	\N	(2001,0006)	CS	1	Image Enhanced	ImageEnhanced	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	988	\N	(2001,0006)	CS	1	Image Enhanced	ImageEnhanced	Philips Imaging DD 001	\N	\N	\N	\N
f	1029	\N	(2001,0007)	CS	1	Image Type End Diastole or End Systole	ImageTypeEDES	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	989	\N	(2001,0007)	CS	1	Image Type End Diastole or End Systole	ImageTypeEDES	Philips Imaging DD 001	\N	\N	\N	\N
f	1030	\N	(2001,0008)	IS	1	Phase Number	PhaseNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	990	\N	(2001,0008)	IS	1	Phase Number	PhaseNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	6837	\N	(2001,0009)	FL	1	Image Prepulse Delay	ImagePrepulseDelay	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6838	\N	(2001,0009)	FL	1	Image Prepulse Delay	ImagePrepulseDelay	Philips Imaging DD 001	\N	\N	\N	\N
f	1031	\N	(2001,000a)	IS	1	Image Plane Number	ImagePlaneNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	991	\N	(2001,000a)	IS	1	Slice Number	SliceNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	1032	\N	(2001,000b)	CS	1	Image Orientation	ImageOrientation	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	992	\N	(2001,000b)	CS	1	Slice Orientation	SliceOrientation	Philips Imaging DD 001	\N	\N	\N	\N
f	6839	\N	(2001,000c)	CS	1	Arrhythmia Rejection	ArrhythmiaRejection	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6840	\N	(2001,000c)	CS	1	Arrhythmia Rejection	ArrhythmiaRejection	Philips Imaging DD 001	\N	\N	\N	\N
f	6841	\N	(2001,000e)	CS	1	Cardiac Cycled	CardiacCycled	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6842	\N	(2001,000e)	CS	1	Cardiac Cycled	CardiacCycled	Philips Imaging DD 001	\N	\N	\N	\N
f	6843	\N	(2001,000f)	SS	1	Cardiac Gate Width	CardiacGateWidth	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6844	\N	(2001,000f)	SS	1	Cardiac Gate Width	CardiacGateWidth	Philips Imaging DD 001	\N	\N	\N	\N
f	6845	\N	(2001,0010)	CS	1	Cardiac Sync	CardiacSync	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6846	\N	(2001,0010)	CS	1	Cardiac Sync	CardiacSync	Philips Imaging DD 001	\N	\N	\N	\N
f	1033	\N	(2001,0011)	FL	1	Diffusion Echo Time	DiffusionEchoTime	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	993	\N	(2001,0011)	FL	1	Diffusion Echo Time	DiffusionEchoTime	Philips Imaging DD 001	\N	\N	\N	\N
f	1034	\N	(2001,0012)	CS	1	Dynamic Series	DynamicSeries	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	994	\N	(2001,0012)	CS	1	Dynamic Series	DynamicSeries	Philips Imaging DD 001	\N	\N	\N	\N
f	1035	\N	(2001,0013)	SL	1	EPI Factor	EPIFactor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	995	\N	(2001,0013)	SL	1	EPI Factor	EPIFactor	Philips Imaging DD 001	\N	\N	\N	\N
f	6847	\N	(2001,0013)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1036	\N	(2001,0014)	SL	1	Number of Echoes	NumberOfEchoes	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	996	\N	(2001,0014)	SL	1	Number of Echoes	NumberOfEchoes	Philips Imaging DD 001	\N	\N	\N	\N
f	6848	\N	(2001,0014)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1037	\N	(2001,0015)	SS	1	Number of Locations	NumberOfLocations	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	997	\N	(2001,0015)	SS	1	Number of Locations	NumberOfLocations	Philips Imaging DD 001	\N	\N	\N	\N
f	6849	\N	(2001,0015)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1038	\N	(2001,0016)	SS	1	Number of PC Directions	NumberOfPCDirections	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	998	\N	(2001,0016)	SS	1	Number of PC Directions	NumberOfPCDirections	Philips Imaging DD 001	\N	\N	\N	\N
f	6850	\N	(2001,0016)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1039	\N	(2001,0017)	SL	1	Number of Phases	NumberOfPhases	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	999	\N	(2001,0017)	SL	1	Number of Phases	NumberOfPhases	Philips Imaging DD 001	\N	\N	\N	\N
f	6851	\N	(2001,0017)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1040	\N	(2001,0018)	SL	1	Number of Slices	NumberOfSlices	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1000	\N	(2001,0018)	SL	1	Number of Slices	NumberOfSlices	Philips Imaging DD 001	\N	\N	\N	\N
f	6852	\N	(2001,0018)	CS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1041	\N	(2001,0019)	CS	1	Partial Matrix Scanned	PartialMatrixScanned	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1001	\N	(2001,0019)	CS	1	Partial Matrix Scanned	PartialMatrixScanned	Philips Imaging DD 001	\N	\N	\N	\N
f	6853	\N	(2001,0019)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1042	\N	(2001,001a)	FL	3	PC Velocity	PCVelocity	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1002	\N	(2001,001a)	FL	3	PC Velocity	PCVelocity	Philips Imaging DD 001	\N	\N	\N	\N
f	6854	\N	(2001,001a)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1043	\N	(2001,001b)	FL	1	Prepulse Delay	PrepulseDelay	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1003	\N	(2001,001b)	FL	1	Prepulse Delay	PrepulseDelay	Philips Imaging DD 001	\N	\N	\N	\N
f	6855	\N	(2001,001b)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1044	\N	(2001,001c)	CS	1	Prepulse Type	PrepulseType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1004	\N	(2001,001c)	CS	1	Prepulse Type	PrepulseType	Philips Imaging DD 001	\N	\N	\N	\N
f	6856	\N	(2001,001c)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1045	\N	(2001,001d)	IS	1	Reconstruction Number	ReconstructionNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1005	\N	(2001,001d)	IS	1	Reconstruction Number	ReconstructionNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	6857	\N	(2001,001d)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6858	\N	(2001,001e)	CS	1	Reformat Accuracy	ReformatAccuracy	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6859	\N	(2001,001e)	CS	1	Reformat Accuracy	ReformatAccuracy	Philips Imaging DD 001	\N	\N	\N	\N
f	6860	\N	(2001,001e)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1046	\N	(2001,001f)	CS	1	Respiration Sync	RespirationSync	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1006	\N	(2001,001f)	CS	1	Respiration Sync	RespirationSync	Philips Imaging DD 001	\N	\N	\N	\N
f	6861	\N	(2001,001f)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6862	\N	(2001,0020)	LO	1	Scanning Technique	ScanningTechnique	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6863	\N	(2001,0020)	LO	1	Scanning Technique	ScanningTechnique	Philips Imaging DD 001	\N	\N	\N	\N
f	6864	\N	(2001,0020)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1047	\N	(2001,0021)	CS	1	SPIR	SPIR	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1007	\N	(2001,0021)	CS	1	SPIR	SPIR	Philips Imaging DD 001	\N	\N	\N	\N
f	6865	\N	(2001,0021)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1048	\N	(2001,0022)	FL	1	Water-Fat Shift	WaterFatShift	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1008	\N	(2001,0022)	FL	1	Water-Fat Shift	WaterFatShift	Philips Imaging DD 001	\N	\N	\N	\N
f	6866	\N	(2001,0022)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1049	\N	(2001,0023)	DS	1	Flip Angle	FlipAngle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1009	\N	(2001,0023)	DS	1	Flip Angle	FlipAngle	Philips Imaging DD 001	\N	\N	\N	\N
f	6867	\N	(2001,0023)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6868	\N	(2001,0024)	CS	1	Series is Interactive	SeriesIsInteractive	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6869	\N	(2001,0024)	CS	1	Series is Interactive	SeriesIsInteractive	Philips Imaging DD 001	\N	\N	\N	\N
f	6870	\N	(2001,0024)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1050	\N	(2001,0025)	SH	1	Echo Time Display	EchoTimeDisplay	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1010	\N	(2001,0025)	SH	1	Echo Time Display	EchoTimeDisplay	Philips Imaging DD 001	\N	\N	\N	\N
f	6871	\N	(2001,0025)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6872	\N	(2001,0026)	CS	1	Presentation State Subtraction Active	PresentationStateSubtractionActive	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6873	\N	(2001,0026)	CS	1	Presentation State Subtraction Active	PresentationStateSubtractionActive	Philips Imaging DD 001	\N	\N	\N	\N
f	6874	\N	(2001,0026)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6875	\N	(2001,0027)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6876	\N	(2001,0028)	US	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6877	\N	(2001,0029)	FL	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6878	\N	(2001,0029)	FL	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6879	\N	(2001,0029)	US	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6880	\N	(2001,002a)	US	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6881	\N	(2001,002b)	CS	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6882	\N	(2001,002b)	CS	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6883	\N	(2001,002b)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6884	\N	(2001,002c)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1051	\N	(2001,002d)	SS	1	Number of Slices in Stack	NumberOfSlicesInStack	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1011	\N	(2001,002d)	SS	1	Number of Slices in Stack	NumberOfSlicesInStack	Philips Imaging DD 001	\N	\N	\N	\N
f	6885	\N	(2001,002d)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6886	\N	(2001,002e)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6887	\N	(2001,002f)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6888	\N	(2001,0030)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6889	\N	(2001,0031)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1052	\N	(2001,0032)	FL	1	Stack Radial Angle	StackRadialAngle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1012	\N	(2001,0032)	FL	1	Stack Radial Angle	StackRadialAngle	Philips Imaging DD 001	\N	\N	\N	\N
f	6890	\N	(2001,0032)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1053	\N	(2001,0033)	CS	1	Stack Radial Axis	StackRadialAxis	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1013	\N	(2001,0033)	CS	1	Stack Radial Axis	StackRadialAxis	Philips Imaging DD 001	\N	\N	\N	\N
f	6891	\N	(2001,0033)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6892	\N	(2001,0034)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1054	\N	(2001,0035)	SS	1	Stack Slice Number	StackSliceNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1014	\N	(2001,0035)	SS	1	Stack Slice Number	StackSliceNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	6893	\N	(2001,0035)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1055	\N	(2001,0036)	CS	1	Stack Type	StackType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1015	\N	(2001,0036)	CS	1	Stack Type	StackType	Philips Imaging DD 001	\N	\N	\N	\N
f	6894	\N	(2001,0036)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6895	\N	(2001,0037)	FD	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6896	\N	(2001,0039)	FL	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6897	\N	(2001,0039)	FL	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6898	\N	(2001,0039)	CS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6899	\N	(2001,003a)	SQ	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6900	\N	(2001,003b)	SQ	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6901	\N	(2001,003c)	SQ	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6902	\N	(2001,003d)	UL	1	Contour Fill Color	ContourFillColor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6903	\N	(2001,003d)	UL	1	Contour Fill Color	ContourFillColor	Philips Imaging DD 001	\N	\N	\N	\N
f	6904	\N	(2001,003d)	SQ	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6905	\N	(2001,003e)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	1056	\N	(2001,003f)	CS	1	Displayed Area Zoom Interpolation Method	DisplayedAreaZoomInterpolationMeth	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1016	\N	(2001,003f)	CS	1	Displayed Area Zoom Interpolation Method	DisplayedAreaZoomInterpolationMeth	Philips Imaging DD 001	\N	\N	\N	\N
f	6906	\N	(2001,003f)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6907	\N	(2001,0040)	SS	1	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6908	\N	(2001,0043)	IS	2	Ellipse Display Shutter Major Axis First End Point	EllipsDisplShutMajorAxFrstEndPnt	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6909	\N	(2001,0043)	IS	2	Ellipse Display Shutter Major Axis First End Point	EllipsDisplShutMajorAxFrstEndPnt	Philips Imaging DD 001	\N	\N	\N	\N
f	6910	\N	(2001,0044)	IS	2	Ellipse Display Shutter Major Axis Second End Point	EllipsDisplShutMajorAxScndEndPnt	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6911	\N	(2001,0044)	IS	2	Ellipse Display Shutter Major Axis Second End Point	EllipsDisplShutMajorAxScndEndPnt	Philips Imaging DD 001	\N	\N	\N	\N
f	6912	\N	(2001,0045)	IS	2	Ellipse Display Shutter Other Axis First End Point	EllipsDisplShutOtherAxFrstEndPnt	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6913	\N	(2001,0045)	IS	2	Ellipse Display Shutter Other Axis First End Point	EllipsDisplShutOtherAxFrstEndPnt	Philips Imaging DD 001	\N	\N	\N	\N
f	6914	\N	(2001,0046)	CS	1	Graphic Line Style	GraphicLineStyle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6915	\N	(2001,0046)	CS	1	Graphic Line Style	GraphicLineStyle	Philips Imaging DD 001	\N	\N	\N	\N
f	6916	\N	(2001,0047)	FL	1	Graphic Line Width	GraphicLineWidth	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6917	\N	(2001,0047)	FL	1	Graphic Line Width	GraphicLineWidth	Philips Imaging DD 001	\N	\N	\N	\N
f	6918	\N	(2001,0048)	SS	1	Graphic Annotation ID	GraphicAnnotationID	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6919	\N	(2001,0048)	SS	1	Graphic Annotation ID	GraphicAnnotationID	Philips Imaging DD 001	\N	\N	\N	\N
f	6920	\N	(2001,004b)	CS	1	Interpolation Method	InterpolationMethod	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6921	\N	(2001,004b)	CS	1	Interpolation Method	InterpolationMethod	Philips Imaging DD 001	\N	\N	\N	\N
f	6922	\N	(2001,004c)	CS	1	Poly Line Begin Point Style	PolyLineBeginPointStyle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6923	\N	(2001,004c)	CS	1	Poly Line Begin Point Style	PolyLineBeginPointStyle	Philips Imaging DD 001	\N	\N	\N	\N
f	6924	\N	(2001,004d)	CS	1	Poly Line End Point Style	PolyLineEndPointStyle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6925	\N	(2001,004d)	CS	1	Poly Line End Point Style	PolyLineEndPointStyle	Philips Imaging DD 001	\N	\N	\N	\N
f	6926	\N	(2001,004e)	CS	1	Window Smoothing Taste	WindowSmoothingTaste	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6927	\N	(2001,004e)	CS	1	Window Smoothing Taste	WindowSmoothingTaste	Philips Imaging DD 001	\N	\N	\N	\N
f	6928	\N	(2001,0050)	LO	1	Graphic Marker Type	GraphicMarkerType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6929	\N	(2001,0050)	LO	1	Graphic Marker Type	GraphicMarkerType	Philips Imaging DD 001	\N	\N	\N	\N
f	6930	\N	(2001,0051)	IS	1	Overlay Plane ID	OverlayPlaneID	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6931	\N	(2001,0051)	IS	1	Overlay Plane ID	OverlayPlaneID	Philips Imaging DD 001	\N	\N	\N	\N
f	6932	\N	(2001,0052)	UI	1	Image Presentation State UID	ImagePresentationStateUID	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6933	\N	(2001,0052)	UI	1	Image Presentation State UID	ImagePresentationStateUID	Philips Imaging DD 001	\N	\N	\N	\N
f	6934	\N	(2001,0053)	CS	1	Presentation GL Transform Invert	PresentationGLTrafoInvert	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6935	\N	(2001,0053)	CS	1	Presentation GL Transform Invert	PresentationGLTrafoInvert	Philips Imaging DD 001	\N	\N	\N	\N
f	6936	\N	(2001,0054)	FL	1	Contour Fill Transparency	ContourFillTransparency	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6937	\N	(2001,0054)	FL	1	Contour Fill Transparency	ContourFillTransparency	Philips Imaging DD 001	\N	\N	\N	\N
f	6938	\N	(2001,0055)	UL	1	Graphic Line Color	GraphicLineColor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6939	\N	(2001,0055)	UL	1	Graphic Line Color	GraphicLineColor	Philips Imaging DD 001	\N	\N	\N	\N
f	6940	\N	(2001,0056)	CS	1	Graphic Type	GraphicType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6941	\N	(2001,0056)	CS	1	Graphic Type	GraphicType	Philips Imaging DD 001	\N	\N	\N	\N
f	6942	\N	(2001,0058)	UL	1	Contrast Transfer Taste	ContrastTransferTaste	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6943	\N	(2001,0058)	UL	1	Contrast Transfer Taste	ContrastTransferTaste	Philips Imaging DD 001	\N	\N	\N	\N
f	6944	\N	(2001,005a)	ST	1	Graphic Annotation Model	GraphicAnnotationModel	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6945	\N	(2001,005a)	ST	1	Graphic Annotation Model	GraphicAnnotationModel	Philips Imaging DD 001	\N	\N	\N	\N
f	6946	\N	(2001,005d)	ST	1	Measurement Text Units	MeasurementTextUnits	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6947	\N	(2001,005d)	ST	1	Measurement Text Units	MeasurementTextUnits	Philips Imaging DD 001	\N	\N	\N	\N
f	6948	\N	(2001,005e)	ST	1	Measurement Text Type	MeasurementTextType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6949	\N	(2001,005e)	ST	1	Measurement Text Type	MeasurementTextType	Philips Imaging DD 001	\N	\N	\N	\N
f	1057	\N	(2001,005f)	SQ	1	Stack Sequence	StackSequence	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1017	\N	(2001,005f)	SQ	1	Stack Sequence	StackSequence	Philips Imaging DD 001	\N	\N	\N	\N
f	1058	\N	(2001,0060)	SL	1	Number of Stacks	NumberOfStacks	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1018	\N	(2001,0060)	SL	1	Number of Stacks	NumberOfStacks	Philips Imaging DD 001	\N	\N	\N	\N
f	1059	\N	(2001,0061)	CS	1	Series Transmitted	SeriesTransmitted	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1019	\N	(2001,0061)	CS	1	Series Transmitted	SeriesTransmitted	Philips Imaging DD 001	\N	\N	\N	\N
f	1060	\N	(2001,0062)	CS	1	Series Committed	SeriesCommitted	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1020	\N	(2001,0062)	CS	1	Series Committed	SeriesCommitted	Philips Imaging DD 001	\N	\N	\N	\N
f	1061	\N	(2001,0063)	CS	1	Examination Source	ExaminationSource	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1021	\N	(2001,0063)	CS	1	Examination Source	ExaminationSource	Philips Imaging DD 001	\N	\N	\N	\N
f	6950	\N	(2001,0064)	SH	1	Text Type	TextType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6951	\N	(2001,0064)	SH	1	Text Type	TextType	Philips Imaging DD 001	\N	\N	\N	\N
f	6952	\N	(2001,0065)	SQ	1	Graphic Overlay Plane	GraphicOverlayPlane	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6953	\N	(2001,0065)	SQ	1	Graphic Overlay Plane	GraphicOverlayPlane	Philips Imaging DD 001	\N	\N	\N	\N
f	6954	\N	(2001,0067)	CS	1	Linear Presentation GL Transform Shape Sub	LinearPresentationGLTrafoShapeSub	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6955	\N	(2001,0067)	CS	1	Linear Presentation GL Transform Shape Sub	LinearPresentationGLTrafoShapeSub	Philips Imaging DD 001	\N	\N	\N	\N
f	6956	\N	(2001,0068)	SQ	1	Linear Modality GL Transform	LinearModalityGLTrafo	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6957	\N	(2001,0068)	SQ	1	Linear Modality GL Transform	LinearModalityGLTrafo	Philips Imaging DD 001	\N	\N	\N	\N
f	6958	\N	(2001,0069)	SQ	1	Display Shutter	DisplayShutter	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6959	\N	(2001,0069)	SQ	1	Display Shutter	DisplayShutter	Philips Imaging DD 001	\N	\N	\N	\N
f	6960	\N	(2001,006a)	SQ	1	Spatial Transformation	SpatialTransformation	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6961	\N	(2001,006a)	SQ	1	Spatial Transformation	SpatialTransformation	Philips Imaging DD 001	\N	\N	\N	\N
f	6962	\N	(2001,006b)	SQ	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6963	\N	(2001,006b)	SQ	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6964	\N	(2001,006d)	LO	1	Text Font	TextFont	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6965	\N	(2001,006d)	LO	1	Text Font	TextFont	Philips Imaging DD 001	\N	\N	\N	\N
f	6966	\N	(2001,006e)	SH	1	Series Type	SeriesType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6967	\N	(2001,006e)	SH	1	Series Type	SeriesType	Philips Imaging DD 001	\N	\N	\N	\N
f	6968	\N	(2001,0071)	CS	1	Graphic Constraint	GraphicConstraint	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6969	\N	(2001,0071)	CS	1	Graphic Constraint	GraphicConstraint	Philips Imaging DD 001	\N	\N	\N	\N
f	6970	\N	(2001,0072)	IS	1	Ellipse Display Shutter Other Axis Second End Point	EllipsDisplShutOtherAxScndEndPnt	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6971	\N	(2001,0072)	IS	1	Ellipse Display Shutter Other Axis Second End Point	EllipsDisplShutOtherAxScndEndPnt	Philips Imaging DD 001	\N	\N	\N	\N
f	6972	\N	(2001,0072)	FL	2	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6973	\N	(2001,0073)	FL	2	Unknown	Unknown	Philips Imaging DD 002	\N	\N	\N	\N
f	6974	\N	(2001,0074)	DS	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6975	\N	(2001,0074)	DS	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6976	\N	(2001,0075)	DS	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6977	\N	(2001,0075)	DS	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	6978	\N	(2001,0076)	UL	1	Number of Frames	NumberOfFrames	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6979	\N	(2001,0076)	UL	1	Number of Frames	NumberOfFrames	Philips Imaging DD 001	\N	\N	\N	\N
f	6980	\N	(2001,0077)	CS	1	GL Transform Type	GLTrafoType	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6981	\N	(2001,0077)	CS	1	GL Transform Type	GLTrafoType	Philips Imaging DD 001	\N	\N	\N	\N
f	6982	\N	(2001,007a)	FL	1	Window Rounding Factor	WindowRoundingFactor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6983	\N	(2001,007a)	FL	1	Window Rounding Factor	WindowRoundingFactor	Philips Imaging DD 001	\N	\N	\N	\N
f	1062	\N	(2001,007b)	IS	1	Acquisition Number	AcquisitionNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1022	\N	(2001,007b)	IS	1	Acquisition Number	AcquisitionNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	6984	\N	(2001,007c)	US	1	Frame Number	FrameNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6985	\N	(2001,007c)	US	1	Frame Number	FrameNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	6986	\N	(2001,0080)	LO	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6987	\N	(2001,0080)	LO	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	1063	\N	(2001,0081)	IS	1	Number of Dynamic Scans	NumberOfDynamicScans	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	1023	\N	(2001,0081)	IS	1	Number of Dynamic Scans	NumberOfDynamicScans	Philips Imaging DD 001	\N	\N	\N	\N
f	6988	\N	(2001,0082)	IS	1	Echo Train Length	EchoTrainLength	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6989	\N	(2001,0082)	IS	1	Echo Train Length	EchoTrainLength	Philips Imaging DD 001	\N	\N	\N	\N
f	6990	\N	(2001,0083)	DS	1	Imaging Frequency	ImagingFrequency	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6991	\N	(2001,0083)	DS	1	Imaging Frequency	ImagingFrequency	Philips Imaging DD 001	\N	\N	\N	\N
f	6992	\N	(2001,0084)	DS	1	Inversion Time	InversionTime	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6993	\N	(2001,0084)	DS	1	Inversion Time	InversionTime	Philips Imaging DD 001	\N	\N	\N	\N
f	6994	\N	(2001,0085)	DS	1	Magnetic Field Strength	MagneticFieldStrength	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6995	\N	(2001,0085)	DS	1	Magnetic Field Strength	MagneticFieldStrength	Philips Imaging DD 001	\N	\N	\N	\N
f	6996	\N	(2001,0086)	IS	1	Number of Phase Encoding Steps	NrOfPhaseEncodingSteps	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6997	\N	(2001,0086)	IS	1	Number of Phase Encoding Steps	NrOfPhaseEncodingSteps	Philips Imaging DD 001	\N	\N	\N	\N
f	6998	\N	(2001,0087)	SH	1	Imaged Nucleus	ImagedNucleus	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	6999	\N	(2001,0087)	SH	1	Imaged Nucleus	ImagedNucleus	Philips Imaging DD 001	\N	\N	\N	\N
f	7000	\N	(2001,0088)	DS	1	Number of Averages	NumberOfAverages	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7001	\N	(2001,0088)	DS	1	Number of Averages	NumberOfAverages	Philips Imaging DD 001	\N	\N	\N	\N
f	7002	\N	(2001,0089)	DS	1	Phase FOV Percent	PhaseFOVPercent	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7003	\N	(2001,0089)	DS	1	Phase FOV Percent	PhaseFOVPercent	Philips Imaging DD 001	\N	\N	\N	\N
f	7004	\N	(2001,008a)	DS	1	Sampling Percent	SamplingPercent	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7005	\N	(2001,008a)	DS	1	Sampling Percent	SamplingPercent	Philips Imaging DD 001	\N	\N	\N	\N
f	7006	\N	(2001,008b)	SH	1	Transmitting Coil	TransmittingCoil	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7007	\N	(2001,008b)	SH	1	Transmitting Coil	TransmittingCoil	Philips Imaging DD 001	\N	\N	\N	\N
f	7008	\N	(2001,0090)	LO	1	Text Foreground Color	TextForegroundColor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7009	\N	(2001,0090)	LO	1	Text Foreground Color	TextForegroundColor	Philips Imaging DD 001	\N	\N	\N	\N
f	7010	\N	(2001,0091)	LO	1	Text Background Color	TextBackgroundColor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7011	\N	(2001,0091)	LO	1	Text Background Color	TextBackgroundColor	Philips Imaging DD 001	\N	\N	\N	\N
f	7012	\N	(2001,0092)	LO	1	Text Shadow Color	TextShadowColor	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7013	\N	(2001,0092)	LO	1	Text Shadow Color	TextShadowColor	Philips Imaging DD 001	\N	\N	\N	\N
f	7014	\N	(2001,0093)	LO	1	Text Style	TextStyle	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7015	\N	(2001,0093)	LO	1	Text Style	TextStyle	Philips Imaging DD 001	\N	\N	\N	\N
f	7016	\N	(2001,009a)	SQ	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7017	\N	(2001,009a)	SQ	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	7018	\N	(2001,009b)	UL	1	Graphic Number	GraphicNumber	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7019	\N	(2001,009b)	UL	1	Graphic Number	GraphicNumber	Philips Imaging DD 001	\N	\N	\N	\N
f	7020	\N	(2001,009c)	LO	1	Graphic Annotation Label	GraphicAnnotationLabel	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7021	\N	(2001,009c)	LO	1	Graphic Annotation Label	GraphicAnnotationLabel	Philips Imaging DD 001	\N	\N	\N	\N
f	7022	\N	(2001,009f)	US	2	Pixel Processing Kernel Size	PixelProcessingKernelSize	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7023	\N	(2001,009f)	US	2	Pixel Processing Kernel Size	PixelProcessingKernelSize	Philips Imaging DD 001	\N	\N	\N	\N
f	7024	\N	(2001,00a1)	CS	1	Is Raw Image	IsRawImage	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7025	\N	(2001,00a1)	CS	1	Is Raw Image	IsRawImage	Philips Imaging DD 001	\N	\N	\N	\N
f	7026	\N	(2001,00a3)	UL	1	Text Color Foreground	TextColorForeground	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7027	\N	(2001,00a3)	UL	1	Text Color Foreground	TextColorForeground	Philips Imaging DD 001	\N	\N	\N	\N
f	7028	\N	(2001,00a4)	UL	1	Text Color Background	TextColorBackground	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7029	\N	(2001,00a4)	UL	1	Text Color Background	TextColorBackground	Philips Imaging DD 001	\N	\N	\N	\N
f	7030	\N	(2001,00a5)	UL	1	Text Color Shadow	TextColorShadow	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7031	\N	(2001,00a5)	UL	1	Text Color Shadow	TextColorShadow	Philips Imaging DD 001	\N	\N	\N	\N
f	7032	\N	(2001,00c1)	LO	1	Linear Modality GL Transform	LinearModalityGLTrafo	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7033	\N	(2001,00c1)	LO	1	Linear Modality GL Transform	LinearModalityGLTrafo	Philips Imaging DD 001	\N	\N	\N	\N
f	7034	\N	(2001,00c8)	LO	1	Exam Card Name	ExamCardName	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7035	\N	(2001,00c8)	LO	1	Exam Card Name	ExamCardName	Philips Imaging DD 001	\N	\N	\N	\N
f	7036	\N	(2001,00cc)	ST	1	Derivation Description	DerivationDescription	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7037	\N	(2001,00cc)	ST	1	Derivation Description	DerivationDescription	Philips Imaging DD 001	\N	\N	\N	\N
f	7038	\N	(2001,00da)	CS	1	Unknown	Unknown	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7039	\N	(2001,00da)	CS	1	Unknown	Unknown	Philips Imaging DD 001	\N	\N	\N	\N
f	7040	\N	(2001,00f1)	FL	1-n	Prospective Motion Correction	ProspectiveMotionCorrection	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7041	\N	(2001,00f1)	FL	6	Prospective Motion Correction	ProspectiveMotionCorrection	Philips Imaging DD 001	\N	\N	\N	\N
f	7042	\N	(2001,00f2)	FL	1-n	Retrospective Motion Correction	RetrospectiveMotionCorrection	PHILIPS IMAGING DD 001	\N	\N	\N	\N
f	7043	\N	(2001,00f2)	FL	6	Retrospective Motion Correction	RetrospectiveMotionCorrection	Philips Imaging DD 001	\N	\N	\N	\N
f	7044	\N	(2003,0000)	CS	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7045	\N	(2003,0001)	LO	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7046	\N	(2003,0002)	FD	3	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7047	\N	(2003,0003)	LO	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7048	\N	(2003,0006)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7049	\N	(2003,0009)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7050	\N	(2003,0010)	LO	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7051	\N	(2003,0011)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7052	\N	(2003,0012)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7053	\N	(2003,0013)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7054	\N	(2003,0014)	FD	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7055	\N	(2003,0015)	FD	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7056	\N	(2003,0016)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7057	\N	(2003,0017)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7058	\N	(2003,0018)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7059	\N	(2003,0019)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7060	\N	(2003,0022)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7061	\N	(2003,0024)	FD	4	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7062	\N	(2003,0025)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7063	\N	(2003,0026)	SL	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7064	\N	(2003,0027)	SH	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7065	\N	(2003,0028)	SH	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7066	\N	(2003,0029)	FD	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7067	\N	(2003,002a)	LO	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7068	\N	(2003,002b)	FD	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7069	\N	(2003,002c)	SH	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7070	\N	(2003,002d)	SL	1-n	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7071	\N	(2003,002e)	SQ	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7072	\N	(2003,0030)	CS	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7073	\N	(2003,0031)	CS	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7074	\N	(2003,0032)	UI	1	Unknown	Unknown	Philips X-ray Imaging DD 001	\N	\N	\N	\N
f	7075	\N	(2005,0000)	FL	1	Image Angulation AP	ImageAngulationAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7076	\N	(2005,0000)	FL	1	Image Angulation AP	ImageAngulationAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7077	\N	(2005,0000)	UL	1	Number of SOP Common	NumberOfSOPCommon	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7078	\N	(2005,0000)	SS	1	Spectrum Extra Number	SpectrumExtraNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7079	\N	(2005,0000)	CS	1	Volume View Enabled	VolumeViewEnabled	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7080	\N	(2005,0001)	FL	1	Image Angulation FH	ImageAngulationFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7081	\N	(2005,0001)	FL	1	Image Angulation FH	ImageAngulationFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7082	\N	(2005,0001)	UL	1	Number of Film Consumption	NoOfFilmConsumption	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7083	\N	(2005,0001)	SS	1	Spectrum Kx Coordinate	SpectrumKxCoordinate	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7084	\N	(2005,0001)	UL	1	Number of Study Reference	NumberOfStudyReference	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7085	\N	(2005,0002)	FL	1	Image Angulation RL	ImageAngulationRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7086	\N	(2005,0002)	FL	1	Image Angulation RL	ImageAngulationRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7087	\N	(2005,0002)	SS	1	Spectrum Ky Coordinate	SpectrumKyCoordinate	Philips MR Imaging DD 004	\N	\N	\N	\N
f	1076	\N	(2005,0002)	SQ	1	SPS Code	SPSCode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7088	\N	(2005,0003)	IS	1	Image Annotation Count	ImageAnnotationCount	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7089	\N	(2005,0003)	SS	1	Spectrum Location Number	SpectrumLocationNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7090	\N	(2005,0003)	UL	1	Number of SPS Codes	NumberOfSPSCodes	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7091	\N	(2005,0004)	CS	1	Image Display Orientation	ImageDisplayOrientation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7092	\N	(2005,0004)	CS	1	Image Display Orientation	ImageDisplayOrientation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7093	\N	(2005,0004)	SS	1	Spectrum Mix Number	SpectrumMixNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7094	\N	(2005,0004)	SS	1	Unknown	Unknown	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1077	\N	(2005,0005)	CS	1	Synergy Reconstruction Type	SynergyReconstructionType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1064	\N	(2005,0005)	CS	1	Synergy Reconstruction Type	SynergyReconstructionType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7095	\N	(2005,0005)	SS	1	Spectrum X Coordinate	SpectrumXCoordinate	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7096	\N	(2005,0006)	SS	1	Spectrum Y Coordinate	SpectrumYCoordinate	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7097	\N	(2005,0006)	SS	1	Number of PS Specific Character Sets	NumberOfPSSpecificCharacterSets	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7098	\N	(2005,0007)	IS	1	Image Line Count	ImageLineCount	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7099	\N	(2005,0007)	FL	1	Spectrum DC Level	SpectrumDCLevel	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7100	\N	(2005,0007)	SS	1	Number of Specific Character Set	NumberOfSpecificCharacterSet	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7101	\N	(2005,0008)	FL	1	Image Offcenter AP	ImageOffcenterAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7102	\N	(2005,0008)	FL	1	Image Offcenter AP	ImageOffcenterAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7103	\N	(2005,0008)	FL	1	Spectrum Noise Level	SpectrumNoiseLevel	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7104	\N	(2005,0009)	FL	1	Image Offcenter FH	ImageOffcenterFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7105	\N	(2005,0009)	FL	1	Image Offcenter FH	ImageOffcenterFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7106	\N	(2005,0009)	FL	1	Spectrum Begin Time	SpectrumBeginTime	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7107	\N	(2005,0009)	DS	1	Rescale Intercept Original	RescaleInterceptOriginal	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7108	\N	(2005,000a)	FL	1	Image OffCentre RL	ImageOffCentreRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7109	\N	(2005,000a)	FL	1	Image OffCentre RL	ImageOffCentreRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7110	\N	(2005,000a)	DS	1	Rescale Slope Original	RescaleSlopeOriginal	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7111	\N	(2005,000b)	FL	1	Max FP	MaxFP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7112	\N	(2005,000b)	FL	1	Max FP	MaxFP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	1834	\N	(0019,0036)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	7113	\N	(2005,000b)	LO	1	Rescale Type Original	RescaleTypeOriginal	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7114	\N	(2005,000c)	FL	1	Min FP	MinFP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7115	\N	(2005,000c)	FL	1	Min FP	MinFP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7116	\N	(2005,000d)	FL	1	Scale Intercept	ScaleIntercept	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7117	\N	(2005,000d)	FL	1	Scale Intercept	ScaleIntercept	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7118	\N	(2005,000e)	FL	1	Scale Slope	ScaleSlope	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7119	\N	(2005,000e)	FL	1	Scale Slope	ScaleSlope	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7120	\N	(2005,000e)	SQ	1	Private Shared Sequence	PrivateSharedSequence	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7121	\N	(2005,000f)	DS	1	Window Center	WindowCenter	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7122	\N	(2005,000f)	DS	1	Window Center	WindowCenter	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7123	\N	(2005,000f)	SQ	1	Private Per-Frame Sequence	PrivatePerFrameSequence	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7124	\N	(2005,0010)	DS	1	Window Width	WindowWidth	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7125	\N	(2005,0010)	DS	1	Window Width	WindowWidth	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7126	\N	(2005,0010)	FL	1	Spectrum Echo Time	SpectrumEchoTime	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7127	\N	(2005,0010)	IS	1	MF Conv Treat Spectro Mix Number	MFConvTreatSpectroMixNumber	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7128	\N	(2005,0011)	CS	1	Image Type	ImageType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7129	\N	(2005,0011)	CS	1-n	Image Type	ImageType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7130	\N	(2005,0011)	UI	1	MF Private Referenced SOP Instance UID	MFPrivateReferencedSOPInstanceUID	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7131	\N	(2005,0012)	CS	1	Cardiac Gating	CardiacGating	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7132	\N	(2005,0012)	CS	1	Cardiac Gating	CardiacGating	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7133	\N	(2005,0012)	FL	1	Spectrum Inversion Time	SpectrumInversionTime	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7134	\N	(2005,0012)	IS	1	Diffusion B Value Number	DiffusionBValueNumber	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7135	\N	(2005,0013)	CS	1	Development Mode	DevelopmentMode	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7136	\N	(2005,0013)	CS	1	Development Mode	DevelopmentMode	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7137	\N	(2005,0013)	UL	1	Number of Codes	NumberOfCodes	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7138	\N	(2005,0013)	SS	1	Spectrum Number	SpectrumNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7139	\N	(2005,0013)	IS	1	Gradient Orientation Number	GradientOrientationNumber	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7140	\N	(2005,0014)	CS	1	Diffusion	Diffusion	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7141	\N	(2005,0014)	CS	1	Diffusion	Diffusion	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7142	\N	(2005,0014)	SS	1	Spectrum Number of Averages	SpectrumNumberOfAverages	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7143	\N	(2005,0014)	SL	1	Number of Diffusion B Values	NumberOfDiffusionBValues	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7144	\N	(2005,0015)	CS	1	Fat Saturation	FatSaturation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7145	\N	(2005,0015)	CS	1	Fat Saturation	FatSaturation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7146	\N	(2005,0015)	LO	1	User Name	UserName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7147	\N	(2005,0015)	SS	1	Spectrum Number of Samples	SpectrumNumberOfSamples	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7148	\N	(2005,0015)	SL	1	Number of Diffusion Gradient Orientations	NumberOfDiffusionGradientOrientations	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7149	\N	(2005,0016)	CS	1	Flow Compensation	FlowCompensation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7150	\N	(2005,0016)	CS	1	Flow Compensation	FlowCompensation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7151	\N	(2005,0016)	LO	1	Pass Word	PassWord	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7152	\N	(2005,0016)	SS	1	Spectrum Scan Sequence Number	SpectrumScanSequenceNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7153	\N	(2005,0016)	CS	1	Plan Mode	PlanMode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7154	\N	(2005,0017)	CS	1	Fourier Interpolation	FourierInterpolation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7155	\N	(2005,0017)	CS	1	Fourier Interpolation	FourierInterpolation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7156	\N	(2005,0017)	LO	1	Server Name	ServerName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7157	\N	(2005,0017)	SS	1	Spectrum Number of Peaks	SpectrumNumberOfPeaks	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7158	\N	(2005,0017)	FD	3	Diffusion B Matrix	DiffusionBMatrix	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7159	\N	(2005,0018)	LO	1	Hardcopy Protocol	HardcopyProtocol	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7160	\N	(2005,0018)	LO	1	Hardcopy Protocol	HardcopyProtocol	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7161	\N	(2005,0018)	LO	1	Data Base Name	DataBaseName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7162	\N	(2005,0018)	SQ	1	Spectrum Peak	SpectrumPeak	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7163	\N	(2005,0018)	CS	3	Operating Mode Type	OperatingModeType	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7164	\N	(2005,0019)	CS	1	Inverse Reconstructed	InverseReconstructed	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7165	\N	(2005,0019)	CS	1	Inverse Reconstructed	InverseReconstructed	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7166	\N	(2005,0019)	LO	1	RootName	RootName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7167	\N	(2005,0019)	FL	1-n	Spectrum Peak Intensity	SpectrumPeakIntensity	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7168	\N	(2005,0019)	CS	3	Operating Mode	OperatingMode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7169	\N	(2005,001a)	SS	1	Label Syntax	LabelSyntax	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7170	\N	(2005,001a)	SS	1	Label Syntax	LabelSyntax	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7171	\N	(2005,001a)	CS	1	Fat Saturation Technique	FatSaturationTechnique	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7172	\N	(2005,001b)	CS	1	Magnetization Prepared	MagnetizationPrepared	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7173	\N	(2005,001b)	CS	1	Magnetization Prepared	MagnetizationPrepared	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7174	\N	(2005,001b)	IS	1	Version Number Deleted Images	VersionNumberDeletedImages	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7175	\N	(2005,001c)	CS	1	Magnetization Transfer Contrast	MagnetizationTransferContrast	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7176	\N	(2005,001c)	CS	1	Magnetization Transfer Contrast	MagnetizationTransferContrast	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7177	\N	(2005,001c)	IS	1	Version Number Deleted Spectra	VersionNumberDeletedSpectra	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7178	\N	(2005,001d)	SS	1	Measurement Scan Resolution	MeasurementScanResolution	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7179	\N	(2005,001d)	SS	1	Measurement Scan Resolution	MeasurementScanResolution	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7180	\N	(2005,001d)	IS	1	Version Number Deleted Blobsets	VersionNumberDeletedBlobsets	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1078	\N	(2005,001e)	SH	1	MIP Protocol	MIPProtocol	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1065	\N	(2005,001e)	SH	1	MIP Protocol	MIPProtocol	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7181	\N	(2005,001e)	UL	1	LUT1 Offset	LUT1Offset	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1079	\N	(2005,001f)	SH	1	MPR Protocol	MPRProtocol	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1066	\N	(2005,001f)	SH	1	MPR Protocol	MPRProtocol	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7182	\N	(2005,001f)	UL	1	LUT1 Range	LUT1Range	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1080	\N	(2005,0020)	SL	1	Number of Chemical Shift	NumberOfChemicalShift	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1067	\N	(2005,0020)	SL	1	Number of Chemical Shifts	NumberOfChemicalShifts	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7183	\N	(2005,0020)	LO	1	DMI Application Name	DMIApplicationName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7184	\N	(2005,0020)	LO	1-n	Spectrum Peak Label	SpectrumPeakLabel	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7185	\N	(2005,0020)	UL	1	LUT1 Begin Color	LUT1BeginColor	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7186	\N	(2005,0021)	SS	1	Number of Mixes	NumberOfMixes	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7187	\N	(2005,0021)	SS	1	Number of Mixes	NumberOfMixes	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7188	\N	(2005,0021)	FL	1-n	Spectrum Peak Phase	SpectrumPeakPhase	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7189	\N	(2005,0021)	UL	1	LUT1 End Color	LUT1EndColor	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7190	\N	(2005,0022)	IS	1	Number of References	NumberOfReferences	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7191	\N	(2005,0022)	IS	1	Number of References	NumberOfReferences	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7192	\N	(2005,0022)	FL	1-n	Spectrum Peak Position	SpectrumPeakPosition	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7193	\N	(2005,0022)	UL	1	LUT2 Offset	LUT2Offset	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7194	\N	(2005,0023)	SS	1	Number of Slabs	NumberOfSlabs	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7195	\N	(2005,0023)	SS	1	Number of Slabs	NumberOfSlabs	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7196	\N	(2005,0023)	CS	1-n	Spectrum Peak Type	SpectrumPeakType	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7197	\N	(2005,0023)	UL	1	LUT2 Range	LUT2Range	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7198	\N	(2005,0024)	FL	1-n	Spectrum Peak Width	SpectrumPeakWidth	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7199	\N	(2005,0024)	UL	1	LUT2 Begin Color	LUT2BeginColor	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7200	\N	(2005,0025)	SS	1	Number of Volumes	NumberOfVolumes	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7201	\N	(2005,0025)	SS	1	Number of Volumes	NumberOfVolumes	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7202	\N	(2005,0025)	CS	1	Spectro SI B0 Correction	SpectroSIB0Correction	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7203	\N	(2005,0025)	UL	1	LUT2 End Color	LUT2EndColor	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7204	\N	(2005,0026)	CS	1	Over Sampling Phase	OverSamplingPhase	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7205	\N	(2005,0026)	CS	1	Over Sampling Phase	OverSamplingPhase	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7206	\N	(2005,0026)	FL	1	Spectro B0 Echo Top Position	SpectroB0EchoTopPosition	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7207	\N	(2005,0026)	CS	1	Viewing Hardcopy Only	ViewingHardcopyOnly	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7208	\N	(2005,0027)	CS	1	Package Mode	PackageMode	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7209	\N	(2005,0027)	CS	1	Package Mode	PackageMode	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7210	\N	(2005,0027)	CS	1	Spectro Complex Component	SpectroComplexComponent	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7211	\N	(2005,0027)	CS	1	Unknown	Unknown	Philips MR Imaging DD 005	\N	 not SQ <Private EMR> after all :(	\N	\N
f	7212	\N	(2005,0028)	CS	1	Partial Fourier Frequency	PartialFourierFrequency	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7213	\N	(2005,0028)	CS	1	Partial Fourier Frequency	PartialFourierFrequency	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7214	\N	(2005,0028)	CS	1	Spectro Data Origin	SpectroDataOrigin	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7215	\N	(2005,0028)	SL	1	Number of Label Types	NumberOfLabelTypes	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7216	\N	(2005,0029)	CS	1	PartialFourierPhase	PartialFourierPhase	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7217	\N	(2005,0029)	CS	1	PartialFourierPhase	PartialFourierPhase	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7218	\N	(2005,0029)	FL	1	Spectro Echo Top Position	SpectroEchoTopPosition	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7219	\N	(2005,0029)	CS	1	Label Type	LabelType	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7220	\N	(2005,002d)	LO	1	Root Id	RootId	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7221	\N	(2005,002a)	IS	1	Patient Reference ID	PatientReferenceID	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7222	\N	(2005,002a)	IS	1	Patient Reference ID	PatientReferenceID	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7223	\N	(2005,002a)	CS	1	Exam Print Status	ExamPrintStatus	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7224	\N	(2005,002b)	SS	1	Percent Scan Complete	PercentScanComplete	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7225	\N	(2005,002b)	SS	1	Percent Scan Complete	PercentScanComplete	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7226	\N	(2005,002b)	CS	1	Exam Export Status	ExamExportStatus	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7227	\N	(2005,002c)	CS	1	Phase Encode Reordering	PhaseEncodeReordering	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7228	\N	(2005,002c)	CS	1	Phase Encode Reordering	PhaseEncodeReordering	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7229	\N	(2005,002c)	CS	1	Exam Storage Commit Status	ExamStorageCommitStatus	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1081	\N	(2005,002d)	IS	1	PlanScan Survey Number of Images	PlanScanSurveyNumberOfImages	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1068	\N	(2005,002d)	IS	1	PlanScan Survey Number of Images	PlanScanSurveyNumberOfImages	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7230	\N	(2005,002d)	CS	1	Exam Media Write Status	ExamMediaWriteStatus	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7231	\N	(2005,002e)	CS	1	PPG PPU Gating	PPGPPUGating	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7232	\N	(2005,002e)	CS	1	PPG PPU Gating	PPGPPUGating	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7233	\N	(2005,002e)	FL	1	dBdt	DBdt	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7234	\N	(2005,002f)	CS	1	Spatial Presaturation	SpatialPresaturation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7235	\N	(2005,002f)	CS	1	Spatial Presaturation	SpatialPresaturation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7236	\N	(2005,002f)	FL	1	Proton SAR	ProtonSAR	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7237	\N	(2005,0030)	FL	1-n	Repetition Time	RepetitionTime	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7238	\N	(2005,0030)	FL	1-n	Repetition Time	RepetitionTime	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7239	\N	(2005,0030)	CS	1-n	InPlane Transforms	InPlaneTransforms	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7240	\N	(2005,0030)	FL	1	Non Proton SAR	NonProtonSAR	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7241	\N	(2005,0031)	CS	1	Respiratory Gating	RespiratoryGating	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7242	\N	(2005,0031)	CS	1	Respiratory Gating	RespiratoryGating	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7243	\N	(2005,0031)	SS	1	Number of Spectra Acquired	NumberOfSpectraAcquired	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7244	\N	(2005,0031)	FL	1	Local SAR	LocalSAR	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1082	\N	(2005,0032)	CS	1	Sample Representation	SampleRepresentation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1069	\N	(2005,0032)	CS	1	Sample Representation	SampleRepresentation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7245	\N	(2005,0032)	SQ	1	Blob Data Object Array	BlobDataObjectArray	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7246	\N	(2005,0032)	CS	1	Safety Override Mode	SafetyOverrideMode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1083	\N	(2005,0033)	FL	1	Acquisition Duration	AcquisitionDuration	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1070	\N	(2005,0033)	FL	1	Acquisition Duration	AcquisitionDuration	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7247	\N	(2005,0033)	FL	1	Phase Encoding Echo Top Positions	PhaseEncodingEchoTopPositions	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7248	\N	(2005,0033)	DT	1	EV DVD Job In Params Datetime	EVDVDJobInParamsDatetime	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7249	\N	(2005,0034)	CS	1	Segmented KSpace	SegmentedKSpace	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7250	\N	(2005,0034)	CS	1	Segmented KSpace	SegmentedKSpace	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7251	\N	(2005,0034)	LT	1	Series Transaction UID	SeriesTransactionUID	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7252	\N	(2005,0034)	SL	1	Number of Image Per Series Ref	NumberOfImagePerSeriesRef	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7253	\N	(2005,0034)	CS	1	Physical Quantity for Chemical Shift	PhysicalQuantityForChemicalShift	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7254	\N	(2005,0034)	DT	1	DVD Job In Params Volume Label	DVDJobInParamsVolumeLabel	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1084	\N	(2005,0035)	CS	1	Data Type	DataType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1071	\N	(2005,0035)	CS	1	Data Type	DataType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7255	\N	(2005,0035)	IS	1	Parent ID	ParentID	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7256	\N	(2005,0035)	CS	1	Physical Quantity Spatial	PhysicalQuantitySpatial	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7257	\N	(2005,0035)	CS	1	Spectro Examcard	SpectroExamcard	Philips MR Imaging DD 005	\N	\N	\N	\N
f	1085	\N	(2005,0036)	CS	1	Is Cardiac	IsCardiac	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1072	\N	(2005,0036)	CS	1	Is Cardiac	IsCardiac	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7258	\N	(2005,0036)	LO	1	Parent Type	ParentType	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7259	\N	(2005,0036)	FL	1	Reference Frequency	ReferenceFrequency	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7260	\N	(2005,0036)	UI	1	Referenced Series Instance UID	ReferencedSeriesInstanceUID	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7261	\N	(2005,0037)	CS	1	Is Spectro	IsSpectro	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7262	\N	(2005,0037)	CS	1	Is Spectro	IsSpectro	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7263	\N	(2005,0037)	LO	1	Blob Name	BlobName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7264	\N	(2005,0037)	FL	1	Sample Offset	SampleOffset	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7265	\N	(2005,0037)	CS	1	Color LUT Type	ColorLUTType	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7266	\N	(2005,0038)	CS	1	Spoiled	Spoiled	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7267	\N	(2005,0038)	CS	1	Spoiled	Spoiled	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7268	\N	(2005,0038)	LO	1	Application Name	ApplicationName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7269	\N	(2005,0038)	FL	1	Sample Pitch	SamplePitch	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7270	\N	(2005,0038)	LT	1	Unknown	Unknown	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7271	\N	(2005,0039)	CS	1	Steady State	SteadyState	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7272	\N	(2005,0039)	CS	1	Steady State	SteadyState	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7273	\N	(2005,0039)	LO	1	Type Name	TypeName	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7274	\N	(2005,0039)	SS	2	Search Interval for Peaks	SearchIntervalForPeaks	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7275	\N	(2005,0039)	LT	1	Unknown	Unknown	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7276	\N	(2005,003a)	SH	1	Sub Anatomy	SubAnatomy	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7277	\N	(2005,003a)	SH	1	Sub Anatomy	SubAnatomy	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7278	\N	(2005,003a)	LT	1	Data Dictionary Contents Version	DataDictionaryContentsVersion	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7279	\N	(2005,003b)	CS	1	Time Reversed Steady State	TimeReversedSteadyState	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7280	\N	(2005,003b)	CS	1	Time Reversed Steady State	TimeReversedSteadyState	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7281	\N	(2005,003b)	CS	1	Is Coil Survey	IsCoilSurvey	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7282	\N	(2005,003c)	CS	1	Tilt Optimized Nonsaturated Excitation	TiltOptimizedNonsaturatedExcitation	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7283	\N	(2005,003c)	CS	1	Tilt Optimized Nonsaturated Excitation	TiltOptimizedNonsaturatedExcitation	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7284	\N	(2005,003c)	FL	1	Stack Table Position Longitudinal	StackTablePosLong	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7285	\N	(2005,003d)	SS	1	Number of RR Interval Ranges	NumberOfRRIntervalRanges	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7286	\N	(2005,003d)	SS	1	Number of RR Interval Ranges	NumberOfRRIntervalRanges	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7287	\N	(2005,003d)	FL	1	Stack Table Position Lateral	StackTablePosLat	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7288	\N	(2005,003e)	SL	1-n	RR Intervals Distribution	RRIntervalsDistribution	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7289	\N	(2005,003e)	SL	1-n	RR Intervals Distribution	RRIntervalsDistribution	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7290	\N	(2005,003e)	FL	1	Stack Posterior Coil Position	StackPosteriorCoilPos	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7291	\N	(2005,003f)	SL	1	PlanScan Acquisition Number	PlanScanAcquisitionNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7292	\N	(2005,003f)	SL	1	PlanScan Acquisition Number	PlanScanAcquisitionNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7293	\N	(2005,003f)	CS	1	Active Implantable Medical Device Limits Applied	AIMDLimitsApplied	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7294	\N	(2005,0040)	SL	1-n	PlanScan Survey Chemical Shift Number	PlanScanSurveyChemicalShiftNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7295	\N	(2005,0040)	LO	1	Version String	VersionStr	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7296	\N	(2005,0040)	CS	1	Signal Domain for Chemical Shift	SignalDomainForChemicalShift	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7297	\N	(2005,0040)	FL	1	Active Implantable Medical Device Head SAR Limit	AIMDHeadSARLimit	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7298	\N	(2005,0041)	SL	1-n	PlanScan Survey Dynamic Scan Number	PlanScanSurveyDynamicScanNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7299	\N	(2005,0041)	LO	1	Comment String	CommentStr	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7300	\N	(2005,0041)	CS	1	Signal Domain Spatial	SignalDomainSpatial	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7301	\N	(2005,0041)	FL	1	Active Implantable Medical Device Whole Body SAR Limit	AIMDWholeBodySARLimit	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7302	\N	(2005,0042)	SL	1-n	PlanScan Survey Echo Number	PlanScanSurveyEchoNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7303	\N	(2005,0042)	CS	1	Blob In File	BlobInFile	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7304	\N	(2005,0042)	CS	1	Signal Type	SignalType	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7305	\N	(2005,0042)	FL	1	Active Implantable Medical Device B1 RMS Limit	AIMDB1RMSLimit	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7306	\N	(2005,0043)	CS	1-n	PlanScan Survey Image Type	PlanScanSurveyImageType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7307	\N	(2005,0043)	SL	1	Actual Blob Size	ActualBlobSize	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7308	\N	(2005,0043)	SS	1	No Date of Last Calibration	NoDateOfLastCalibration	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7309	\N	(2005,0043)	CS	1	Spectro Additional Rotations	SpectroAdditionalRotations	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7310	\N	(2005,0043)	FL	1	Active Implantable Medical Device dbDt Limit	AIMDdbDtLimit	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7311	\N	(2005,0044)	SL	1-n	PlanScan Survey Phase Number	PlanScanSurveyPhaseNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7312	\N	(2005,0044)	OW	1	Blob Data	BlobData	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7313	\N	(2005,0044)	SS	1	No Time of Last Calibration	NoTimeOfLastCalibration	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7314	\N	(2005,0044)	SS	1-n	Spectro Display Ranges	SpectroDisplayRanges	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7315	\N	(2005,0044)	IS	1	TFE Factor	TFEFactor	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7316	\N	(2005,0045)	SL	1-n	PlanScan Survey Reconstruction Number	PlanScanSurveyReconstructionNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7317	\N	(2005,0045)	LO	1	Blob Filename	BlobFilename	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7318	\N	(2005,0045)	SS	1	Number of Software Version	NrOfSoftwareVersion	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7319	\N	(2005,0045)	CS	1	Spectro Echo Acquisition	SpectroEchoAcquisition	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7320	\N	(2005,0045)	CS	1	Attenuation Correction	AttenuationCorrection	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7321	\N	(2005,0046)	CS	1-n	PlanScan Survey Scanning Sequence	PlanScanSurveyScanningSequence	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7322	\N	(2005,0046)	SL	1	Blob Offset	BlobOffset	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7323	\N	(2005,0046)	CS	1	Spectro Frequency Unit	SpectroFrequencyUnit	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7324	\N	(2005,0046)	FL	1	FWHM Shim	FWHMShim	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7325	\N	(2005,0047)	SL	1-n	PlanScan Survey Slice Number	PlanScanSurveyCSliceNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7326	\N	(2005,0047)	CS	1	Blob Flag	BlobFlag	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7327	\N	(2005,0047)	SS	1	Number of Patient Other Names	NrOfPatientOtherNames	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7328	\N	(2005,0047)	FL	1	Spectro Gamma	SpectroGamma	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7329	\N	(2005,0047)	FL	1	Power Optimization	PowerOptimization	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7330	\N	(2005,0048)	IS	1-n	Referenced Acquisition Number	ReferencedAcquisitionNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7331	\N	(2005,0048)	IS	1-n	Referenced Acquisition Number	ReferencedAcquisitionNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7332	\N	(2005,0048)	SS	1	Number of Req Recipe of Results	NrOfReqRecipeOfResults	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7333	\N	(2005,0048)	CS	1	Spectro Hidden Line Removal	SpectroHiddenLineRemoval	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7334	\N	(2005,0048)	FL	1	Coil Q	CoilQ	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7335	\N	(2005,0049)	IS	1-n	Referenced Chemical Shift Number	ReferencedChemicalShiftNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7336	\N	(2005,0049)	IS	1-n	Referenced Chemical Shift Number	ReferencedChemicalShiftNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7337	\N	(2005,0049)	SS	1	Number of Series Operators Name	NrOfSeriesOperatorsName	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7338	\N	(2005,0049)	FL	1	Spectro Horizontal Shift	SpectroHorizontalShift	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7339	\N	(2005,0049)	FL	1	Receiver Gain	ReceiverGain	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7340	\N	(2005,004a)	IS	1-n	Referenced Dynamic Scan Number	ReferenceDynamicScanNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7341	\N	(2005,004a)	IS	1-n	Referenced Dynamic Scan Number	ReferenceDynamicScanNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7342	\N	(2005,004a)	FL	1	Data Window Duration	DataWindowDuration	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7343	\N	(2005,004b)	IS	1-n	Referenced Echo Number	ReferencedEchoNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7344	\N	(2005,004b)	IS	1-n	Referenced Echo Number	ReferencedEchoNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7345	\N	(2005,004b)	FL	1	Mixing Time	MixingTime	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7346	\N	(2005,004c)	CS	1-n	Referenced Entity	ReferencedEntity	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7347	\N	(2005,004c)	CS	1-n	Referenced Entity	ReferencedEntity	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7348	\N	(2005,004c)	FL	1	First Echo Time	FirstEchoTime	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7349	\N	(2005,004d)	CS	1-n	Referenced Image Type	ReferencedImageType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7350	\N	(2005,004d)	CS	1-n	Referenced Image Type	ReferencedImageType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7351	\N	(2005,004d)	CS	1	Is B0 Series	IsB0Series	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7352	\N	(2005,004e)	FL	1-n	Slab FOV RL	SlabFOVRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7353	\N	(2005,004e)	FL	1-n	Slab FOV RL	SlabFOVRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7354	\N	(2005,004e)	CS	1	Is B1 Series	IsB1Series	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7355	\N	(2005,004f)	FL	1-n	Slab Offcentre AP	SlabOffcentreAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7356	\N	(2005,004f)	FL	1-n	Slab Offcentre AP	SlabOffcentreAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7357	\N	(2005,004f)	CS	1	Volume Select	VolumeSelect	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7358	\N	(2005,0050)	FL	1-n	Slab Offcentre FH	SlabOffcentreFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7359	\N	(2005,0050)	FL	1-n	Slab Offcentre FH	SlabOffcentreFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7360	\N	(2005,0050)	SS	1	Number of Series Performing Physicians Name	NrOfSeriesPerfPhysiName	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7361	\N	(2005,0050)	FL	2	Spectro Horizontal Window	SpectroHorizontalWindow	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7362	\N	(2005,0050)	SS	1	Number of Patient Other IDs	NumberOfPatientOtherIDs	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7363	\N	(2005,0051)	FL	1-n	Slab Offcentre RL	SlabOffcentreRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7364	\N	(2005,0051)	FL	1-n	Slab Offcentre RL	SlabOffcentreRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7365	\N	(2005,0051)	SS	1	Number of Study Admitting Diagnostic Description	NrOfStudyAdmittingDiagnosticDescr	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7366	\N	(2005,0051)	SS	1	Spectro Number of Display Ranges	SpectroNumberOfDisplayRanges	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7367	\N	(2005,0051)	IS	1	Original Series Number	OriginalSeriesNumber	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7368	\N	(2005,0052)	CS	1-n	Slab Type	SlabType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7369	\N	(2005,0052)	CS	1-n	Slab Type	SlabType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7370	\N	(2005,0052)	SS	1	Number of Study Patient Contrast Allergies	NrOfStudyPatientContrastAllergies	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7371	\N	(2005,0052)	SS	1	Spectro Number of Echo Pulses	SpectroNumberOfEchoPulses	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7372	\N	(2005,0052)	UI	1	Original Series Instance UID	OriginalSeriesInstanceUID	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7373	\N	(2005,0053)	CS	1-n	Slab View Axis	SlabViewAxis	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7374	\N	(2005,0053)	CS	1-n	Slab View Axis	SlabViewAxis	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7375	\N	(2005,0053)	SS	1	Number of Study Patient Medical Alerts	NrOfStudyPatientMedicalAlerts	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7376	\N	(2005,0053)	LO	1-n	Spectro Processing History	SpectroProcessingHistory	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7377	\N	(2005,0053)	CS	1	Split Series Job Params	SplitSeriesJobParams	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7378	\N	(2005,0054)	FL	1-n	Volume Angulation AP	VolumeAngulationAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7379	\N	(2005,0054)	FL	1-n	Volume Angulation AP	VolumeAngulationAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7380	\N	(2005,0054)	SS	1	Number of Study Physicians of Record	NrOfStudyPhysiciansOfRecord	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7381	\N	(2005,0054)	CS	1	Spectro Scan Type	SpectroScanType	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7382	\N	(2005,0054)	SS	1	Preferred Dimension for Splitting	PreferredDimensionForSplitting	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7383	\N	(2005,0055)	FL	1-n	Volume Angulation FH	VolumeAngulationFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7384	\N	(2005,0055)	FL	1-n	Volume Angulation FH	VolumeAngulationFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7385	\N	(2005,0055)	SS	1	Number of Study Physicians Reading Study	NrOfStudyPhysiReadingStudy	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7386	\N	(2005,0055)	FL	1-n	Spectro SI CS Intervals	SpectroSICSIntervals	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7387	\N	(2005,0055)	FD	3	Velocity Encoding Direction	VelocityEncodingDirection	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7388	\N	(2005,0056)	FL	1-n	Volume Angulation RL	VolumeAngulationRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7389	\N	(2005,0056)	FL	1-n	Volume Angulation RL	VolumeAngulationRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7390	\N	(2005,0056)	SS	1	Number of SC Software Versions	NrSCSoftwareVersions	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7391	\N	(2005,0056)	CS	1	Spectro SI Mode	SpectroSIMode	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7392	\N	(2005,0056)	SS	1	Contrast/Bolus Number of Injections	ContrastBolusNumberOfInjections	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7393	\N	(2005,0057)	FL	1-n	Volume FOV AP	VolumeFOVAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7394	\N	(2005,0057)	FL	1-n	Volume FOV AP	VolumeFOVAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7395	\N	(2005,0057)	SS	1	Number of Running Attributes	NrRunningAttributes	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7396	\N	(2005,0057)	SS	1	Spectro Spectral BW	SpectroSpectralBW	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7397	\N	(2005,0057)	LT	1	Contrast/Bolus Agent Code	ContrastBolusAgentCode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7398	\N	(2005,0058)	FL	1-n	Volume FOV FH	VolumeFOVFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7399	\N	(2005,0058)	FL	1-n	Volume FOV FH	VolumeFOVFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7400	\N	(2005,0058)	LO	1	Spectro Title Line	SpectroTitleLine	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7401	\N	(2005,0058)	LT	1	Contrast/Bolus Administration Route Code	ContrastBolusAdminRouteCode	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7402	\N	(2005,0059)	FL	1-n	Volume FOV RL	VolumeFOVRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7403	\N	(2005,0059)	FL	1-n	Volume FOV RL	VolumeFOVRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7404	\N	(2005,0059)	FL	1	Spectro Turbo Echo Spacing	SpectroTurboEchoSpacing	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7405	\N	(2005,0059)	DS	1	Contrast/Bolus Volume	ContrastBolusVolume	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7406	\N	(2005,005a)	FL	1-n	Volume Offcentre AP	VolumeOffcentreAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7407	\N	(2005,005a)	FL	1-n	Volume Offcentre AP	VolumeOffcentreAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7408	\N	(2005,005a)	DS	1	Contrast/Bolus Ingredient Concentration	ContrastBolusIngredientConcentration	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7409	\N	(2005,005b)	FL	1-n	Volume Offcentre FH	VolumeOffcentreFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7410	\N	(2005,005b)	FL	1-n	Volume Offcentre FH	VolumeOffcentreFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7411	\N	(2005,005b)	IS	1	Contrast/Bolus Dynamic Number	ContrastBolusDynamicNumber	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7412	\N	(2005,005c)	FL	1-n	Volume Offcentre RL	VolumeOffcentreRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7413	\N	(2005,005c)	FL	1-n	Volume Offcentre RL	VolumeOffcentreRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7414	\N	(2005,005c)	SQ	1	Contrast/Bolus Sequence	ContrastBolusSequence	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7415	\N	(2005,005d)	CS	1-n	Volume Type	VolumeType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7416	\N	(2005,005d)	CS	1-n	Volume Type	VolumeType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7417	\N	(2005,005d)	IS	1	Contrast/Bolus ID	ContrastBolusID	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7418	\N	(2005,005e)	CS	1	Volume View Axis	VolumeViewAxis	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7419	\N	(2005,005e)	CS	1-n	Volume View Axis	VolumeViewAxis	Philips MR Imaging DD 001	\N	\N	\N	\N
f	1087	\N	(2005,005f)	CS	1	Study Origin	StudyOrigin	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1074	\N	(2005,005f)	CS	1	Study Origin	StudyOrigin	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7420	\N	(2005,0060)	IS	1	Study Sequence Number	StudySequenceNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7421	\N	(2005,0060)	IS	1	Study Sequence Number	StudySequenceNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7422	\N	(2005,0060)	FL	1	Spectro Vertical Shift	SpectroVerticalShift	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7423	\N	(2005,0060)	CS	1	LUT to RGB Job Params	LUTToRGBJobParams	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7424	\N	(2005,0061)	CS	1	Prepulse Type	PrepulseType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7425	\N	(2005,0061)	CS	1	Prepulse Type	PrepulseType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7426	\N	(2005,0061)	FL	2	Spectro Vertical Window	SpectroVerticalWindow	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7427	\N	(2005,0062)	FL	1	Spectro Offset	SpectroOffset	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7428	\N	(2005,0063)	SS	1	fMRI Status Indication	fMRIStatusIndication	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7429	\N	(2005,0063)	SS	1	fMRI Status Indication	fMRIStatusIndication	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7430	\N	(2005,0063)	FL	1	Spectrum Pitch	SpectrumPitch	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7431	\N	(2005,0064)	IS	1-n	Reference Phase Number	ReferencePhaseNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7432	\N	(2005,0064)	IS	1-n	Reference Phase Number	ReferencePhaseNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7433	\N	(2005,0064)	CS	1	Volume Selection	VolumeSelection	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7434	\N	(2005,0065)	IS	1-n	Reference Reconstruction Number	ReferenceReconstructionNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7435	\N	(2005,0065)	IS	1-n	Reference Reconstruction Number	ReferenceReconstructionNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7436	\N	(2005,0066)	CS	1-n	Reference Scanning Sequence	ReferenceScanningSequence	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7437	\N	(2005,0066)	CS	1-n	Reference Scanning Sequence	ReferenceScanningSequence	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7438	\N	(2005,0067)	IS	1-n	Reference Slice Number	ReferenceSliceNumber	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7439	\N	(2005,0067)	IS	1-n	Reference Slice Number	ReferenceSliceNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7440	\N	(2005,0068)	CS	1-n	Reference Type	ReferenceType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7441	\N	(2005,0068)	CS	1-n	Reference Type	ReferenceType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7442	\N	(2005,0069)	FL	1-n	Slab Angulation AP	SlabAngulationAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7443	\N	(2005,0069)	FL	1-n	Slab Angulation AP	SlabAngulationAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7444	\N	(2005,006a)	FL	1-n	Slab Angulation FH	SlabAngulationFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7445	\N	(2005,006a)	FL	1-n	Slab Angulation FH	SlabAngulationFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7446	\N	(2005,006b)	FL	1-n	Slab Angulation RL	SlabAngulationRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7447	\N	(2005,006b)	FL	1-n	Slab Angulation RL	SlabAngulationRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7448	\N	(2005,006c)	FL	1-n	Slab FOV AP	SlabFOVAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7449	\N	(2005,006c)	FL	1-n	Slab FOV AP	SlabFOVAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7450	\N	(2005,006d)	FL	1-n	Slab FOV FH	SlabFOVFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7451	\N	(2005,006d)	FL	1-n	Slab FOV FH	SlabFOVFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7452	\N	(2005,006e)	CS	1-n	Scanning Sequence	ScanningSequence	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7453	\N	(2005,006e)	CS	1-n	Scanning Sequence	ScanningSequence	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7454	\N	(2005,006f)	CS	1	Acquisition Type	AcquisitionType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7455	\N	(2005,006f)	CS	1	Acquisition Type	AcquisitionType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7456	\N	(2005,0070)	LO	1	Hardcopy Protocol EasyVision	HardcopyProtocolEV	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7457	\N	(2005,0070)	LO	1	Hardcopy Protocol EasyVision	HardcopyProtocolEV	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7458	\N	(2005,0070)	OW	1	Spectrum Pixel Data	SpectrumPixelData	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7459	\N	(2005,0070)	SS	1	Number Mixes Spectro	NumberMixesSpectro	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7460	\N	(2005,0071)	FL	1-n	Stack Angulation AP	StackAngulationAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7461	\N	(2005,0071)	FL	1-n	Stack Angulation AP	StackAngulationAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7462	\N	(2005,0071)	SQ	1	Series SP Mix	SeriesSPMix	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7463	\N	(2005,0072)	FL	1-n	Stack Angulation FH	StackAngulationFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7464	\N	(2005,0072)	FL	1-n	Stack Angulation FH	StackAngulationFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7465	\N	(2005,0072)	SS	1-2	SP Mix T Resolution	SPMixTResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7466	\N	(2005,0073)	FL	1-n	Stack Angulation RL	StackAngulationRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7467	\N	(2005,0073)	FL	1-n	Stack Angulation RL	StackAngulationRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7468	\N	(2005,0073)	SS	1-2	SP Mix KX Resolution	SPMixKXResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7469	\N	(2005,0074)	FL	1-n	Stack FOV AP	StackFOVAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7470	\N	(2005,0074)	FL	1-n	Stack FOV AP	StackFOVAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7471	\N	(2005,0074)	SS	1-2	SP Mix KY Resolution	SPMixKYResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7472	\N	(2005,0075)	FL	1-n	Stack FOV FH	StackFOVFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7473	\N	(2005,0075)	FL	1-n	Stack FOV FH	StackFOVFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7474	\N	(2005,0075)	SS	1-2	SP Mix F Resolution	SPMixFResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7475	\N	(2005,0076)	FL	1-n	Stack FOV RL	StackFOVRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7476	\N	(2005,0076)	FL	1-n	Stack FOV RL	StackFOVRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7477	\N	(2005,0076)	SS	1-2	SP Mix X Resolution	SPMixXResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7478	\N	(2005,0077)	SS	1-2	SP Mix Y Resolution	SPMixYResolution	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7479	\N	(2005,0078)	FL	1-n	Stack Offcentre AP	StackOffcentreAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7480	\N	(2005,0078)	FL	1-n	Stack Offcentre AP	StackOffcentreAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7481	\N	(2005,0078)	SS	1-2	SP Mix Number of Spectra Intended	SPMixNumberOfSpectraIntended	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7482	\N	(2005,0079)	FL	1-n	Stack Offcentre FH	StackOffcentreFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7483	\N	(2005,0079)	FL	1-n	Stack Offcentre FH	StackOffcentreFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7484	\N	(2005,0079)	SS	1-2	SP Mix Number of Averages	SPMixNumberOfAverages	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7485	\N	(2005,007a)	FL	1-n	Stack Offcentre RL	StackOffcentreRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7486	\N	(2005,007a)	FL	1-n	Stack Offcentre RL	StackOffcentreRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7487	\N	(2005,007b)	CS	1-n	Stack Preparation Direction	StackPreparationDirection	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7488	\N	(2005,007b)	CS	1-n	Stack Preparation Direction	StackPreparationDirection	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7489	\N	(2005,007e)	FL	1-n	Stack Slice Distance	StackSliceDistance	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7490	\N	(2005,007e)	FL	1-n	Stack Slice Distance	StackSliceDistance	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7491	\N	(2005,0080)	SQ	1	Series PlanScan	SeriesPlanScan	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7492	\N	(2005,0080)	SQ	1	Series PlanScan	SeriesPlanScan	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7493	\N	(2005,0080)	SL	1	Number of MF Image Objects	NumberOfMFImageObjects	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7494	\N	(2005,0081)	CS	1-n	Stack View Axis	StackViewAxis	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7495	\N	(2005,0081)	CS	1-n	Stack View Axis	StackViewAxis	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7496	\N	(2005,0081)	UI	1	Default Image UID	DefaultImageUID	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7497	\N	(2005,0081)	IS	1	ScanoGram Survey Number of Images	ScanoGramSurveyNumberOfImages	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7498	\N	(2005,0082)	CS	1-n	Running Attributes	RunningAttributes	Philips MR Imaging DD 003	\N	\N	\N	\N
f	7499	\N	(2005,0082)	UL	1	Number of Procedure Codes	NumberOfProcedureCodes	Philips MR Imaging DD 004	\N	\N	\N	\N
f	1088	\N	(2005,0083)	SQ	1	Series Slab	SeriesSlab	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1075	\N	(2005,0083)	SQ	1	Series Slab	SeriesSlab	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7500	\N	(2005,0083)	CS	1-n	Sort Attributes	Sort Attributes	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7501	\N	(2005,0084)	SQ	1	Series Reference	SeriesReference	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7502	\N	(2005,0084)	SQ	1	Series Reference	SeriesReference	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7503	\N	(2005,0084)	SS	1	Number of Sort Attributes	NumberOfSortAttributes	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7504	\N	(2005,0085)	SQ	1	Series Volume	SeriesVolume	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7505	\N	(2005,0085)	SQ	1	Series Volume	SeriesVolume	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7506	\N	(2005,0085)	CS	1	Image Display Direction	ImageDisplayDirection	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7507	\N	(2005,0086)	SS	1	Number of Geometry	NumberOfGeometry	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7508	\N	(2005,0086)	SS	1	Number of Geometry	NumberOfGeometry	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7509	\N	(2005,0086)	CS	1	Inset Scanogram	Inset Scanogram	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7510	\N	(2005,0087)	SL	1-n	Number of Geometry Slices	NumberOfGeometrySlices	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7511	\N	(2005,0087)	SS	1	Display Layout Number of Columns	DisplayLayoutNumberOfColumns	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7512	\N	(2005,0088)	FL	1-n	Geom Angulation AP	GeomAngulationAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7513	\N	(2005,0088)	SS	1	Display Layout Number of Rows	DisplayLayoutNumberOfRows	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7514	\N	(2005,0089)	FL	1-n	Geom Angulation FH	GeomAngulationFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7515	\N	(2005,0089)	SQ	1	Viewing Protocol	ViewingProtocol	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7516	\N	(2005,008a)	FL	1-n	Geom Angulation RL	GeomAngulationRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7517	\N	(2005,008b)	FL	1-n	Geom FOV AP	GeomFOVAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7518	\N	(2005,008c)	FL	1-n	Geom FOV FH	GeomFOVFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7519	\N	(2005,008d)	FL	1-n	Geom FOV RL	GeomFOVRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7520	\N	(2005,008e)	FL	1-n	Geom OffCentre AP	GeomOffCentreAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7521	\N	(2005,008f)	FL	1-n	Geom OffCentre FH	GeomOffCentreFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7522	\N	(2005,0090)	FL	1-n	Geom OffCentre RL	GeomOffCentreRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7523	\N	(2005,0090)	CS	1	Stack Coil Function	StackCoilFunction	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7524	\N	(2005,0090)	SQ	1	Original VOI LUT Sequence	OriginalVOILUTSequence	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7525	\N	(2005,0091)	CS	1-n	Geom Preparation Direct	GeomPreparationDirect	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7526	\N	(2005,0091)	PN	1	Patient Name Job In Params	PatientNameJobInParams	Philips MR Imaging DD 004	\N	\N	\N	\N
f	1835	\N	(0019,0038)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	7527	\N	(2005,0091)	SQ	1	Original Modality LUT Sequence	OriginalModalityLUTSequence	Philips MR Imaging DD 005	\N	\N	\N	\N
f	7528	\N	(2005,0092)	FL	1-n	Geom Radial Angle	GeomRadialAngle	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7529	\N	(2005,0092)	IS	1	Geolink ID	GeolinkID	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7530	\N	(2005,0093)	CS	1-n	Geom Radial Axis	GeomRadialAxis	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7531	\N	(2005,0093)	IS	1	Station Number	StationNumber	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7532	\N	(2005,0094)	FL	1-n	Geom Slice Distance	GeomSliceDistance	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7533	\N	(2005,0094)	CS	1-n	Processing History	ProcessingHistory	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7534	\N	(2005,0095)	SL	1-n	Geom Slice Number	GeomSliceNumber	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7535	\N	(2005,0095)	UI	1	View Procedure String	ViewProcedureString	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7536	\N	(2005,0096)	CS	1-n	Geom Type	GeomType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7537	\N	(2005,0096)	CS	1	Flow Images Present	FlowImagesPresent	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7538	\N	(2005,0097)	CS	1-n	Geom ViewA xis	GeomViewAxis	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7539	\N	(2005,0097)	LO	1	Anatomic Region Code Value	AnatomicRegionCodeValue	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7540	\N	(2005,0098)	CS	1-n	Geom Colour	GeomColour	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7541	\N	(2005,0098)	CS	1	Mobiview Enabled	MobiviewEnabled	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7542	\N	(2005,0099)	CS	1-n	Geom Application Type	GeomApplicationType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7543	\N	(2005,0099)	UL	1	Number of Request Excerpts	NumberOfRequestExcerpts	Philips MR Imaging DD 002	\N	\N	\N	\N
f	7544	\N	(2005,0099)	CS	1	IViewBold Enabled	IViewBoldEnabled	Philips MR Imaging DD 004	\N	\N	\N	\N
f	7545	\N	(2005,009a)	SL	1-n	Geom Id	GeomId	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7546	\N	(2005,009b)	SH	1-n	Geom Application Name	GeomApplicationName	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7547	\N	(2005,009c)	SH	1-n	Geom Label Name	GeomLabelName	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7548	\N	(2005,009d)	CS	1-n	Geom Line Style	GeomLineStyle	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7549	\N	(2005,009e)	SQ	1	Series Geometry	SeriesGeometry	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7550	\N	(2005,009e)	SQ	1	Series Geometry	SeriesGeometry	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7551	\N	(2005,009f)	CS	1	Spectral Selective Excitation Pulse	SpectralSelectiveExcitationPulse	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7552	\N	(2005,009f)	CS	1	SeriesSpectral Selective Excitation Pulse	SpectralSelectiveExcitationPulse	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7553	\N	(2005,00a0)	FL	1	Dynamic Scan Begin Time	DynamicScanBeginTime	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7554	\N	(2005,00a0)	FL	1	Dynamic Scan Begin Time	DynamicScanBeginTime	Philips MR Imaging DD 001	\N	\N	\N	\N
f	1086	\N	(2005,00a1)	CS	1	Syncra Scan Type	SyncraScanType	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	1073	\N	(2005,00a1)	CS	1	Syncra Scan Type	SyncraScanType	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7555	\N	(2005,00a2)	CS	1	Is COCA	IsCOCA	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7556	\N	(2005,00a2)	CS	1	Is COCA	IsCOCA	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7557	\N	(2005,00a3)	IS	1	Stack Coil ID	StackCoilID	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7558	\N	(2005,00a3)	IS	1	Stack Coil ID	StackCoilID	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7559	\N	(2005,00a4)	IS	1	Stack CBB Coil 1	StackCBBCoil1	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7560	\N	(2005,00a4)	IS	1	Stack CBB Coil 1	StackCBBCoil1	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7561	\N	(2005,00a5)	IS	1	Stack CBB Coil 2	StackCBBCoil2	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7562	\N	(2005,00a5)	IS	1	Stack CBB Coil 2	StackCBBCoil2	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7563	\N	(2005,00a6)	IS	1	Stack Channel Combination Bitmask	StackChannelCombi	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7564	\N	(2005,00a6)	IS	1	Stack Channel Combination Bitmask	StackChannelCombi	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7565	\N	(2005,00a7)	CS	1	Stack Coil Connection	StackCoilConnection	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7566	\N	(2005,00a7)	CS	1	Stack Coil Connection	StackCoilConnection	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7567	\N	(2005,00a8)	DS	1	Inversion Time	InversionTime	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7568	\N	(2005,00a8)	DS	1	Inversion Time	InversionTime	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7569	\N	(2005,00a9)	CS	1	Geometry Correction	GeometryCorrection	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7570	\N	(2005,00a9)	CS	1	Geometry Correction	GeometryCorrection	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7571	\N	(2005,00b0)	FL	1	Diffusion Direction RL	DiffusionDirectionRL	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7572	\N	(2005,00b0)	FL	1	Diffusion Direction RL	DiffusionDirectionRL	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7573	\N	(2005,00b1)	FL	1	Diffusion Direction AP	DiffusionDirectionAP	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7574	\N	(2005,00b1)	FL	1	Diffusion Direction AP	DiffusionDirectionAP	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7575	\N	(2005,00b2)	FL	1	Diffusion Direction FH	DiffusionDirectionFH	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7576	\N	(2005,00b2)	FL	1	Diffusion Direction FH	DiffusionDirectionFH	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7577	\N	(2005,00c0)	CS	1	Scan Sequence	ScanSequence	PHILIPS MR IMAGING DD 001	\N	\N	\N	\N
f	7578	\N	(2005,00c0)	CS	1	Scan Sequence	ScanSequence	Philips MR Imaging DD 001	\N	\N	\N	\N
f	7579	\N	(2007,0000)	ST	1	Unknown	Unknown	Philips EV Imaging DD 022	\N	\N	\N	\N
f	7580	\N	(200b,0000)	PN	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7581	\N	(200b,0000)	ST	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7582	\N	(200b,0001)	US	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7583	\N	(200b,0001)	CS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7584	\N	(200b,0002)	US	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7585	\N	(200b,0002)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7586	\N	(200b,0005)	IS	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7587	\N	(200b,0011)	LO	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7588	\N	(200b,0027)	DT	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7589	\N	(200b,0028)	DS	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7590	\N	(200b,0029)	DS	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7591	\N	(200b,002a)	UL	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7592	\N	(200b,002b)	DA	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7593	\N	(200b,002c)	TM	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7594	\N	(200b,002d)	LO	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7595	\N	(200b,003b)	LO	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7596	\N	(200b,0040)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7597	\N	(200b,0041)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7598	\N	(200b,0042)	UI	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7599	\N	(200b,0043)	UI	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7600	\N	(200b,0047)	DA	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7601	\N	(200b,0048)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7602	\N	(200b,004c)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7603	\N	(200b,004d)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7604	\N	(200b,004f)	DT	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7605	\N	(200b,0050)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7606	\N	(200b,0051)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7607	\N	(200b,0052)	CS	1	Unknown	Unknown	Philips RAD Imaging DD 001	\N	\N	\N	\N
f	7608	\N	(200b,0052)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7609	\N	(200b,0053)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7610	\N	(200b,0054)	ST	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7611	\N	(200b,0060)	LT	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7612	\N	(200b,0063)	LT	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7613	\N	(200b,0065)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7614	\N	(200b,006e)	US	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7615	\N	(200b,0072)	FD	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7616	\N	(200b,0073)	SS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7617	\N	(200b,0074)	IS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7618	\N	(200b,0075)	CS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7619	\N	(200b,0076)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7620	\N	(200b,0078)	IS	1-n	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7621	\N	(200b,0079)	IS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7622	\N	(200b,007a)	IS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7623	\N	(200b,007b)	US	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7624	\N	(200b,007c)	US	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7625	\N	(200b,007d)	IS	1-n	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7626	\N	(200b,007e)	UI	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7627	\N	(200b,0081)	LO	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7628	\N	(200b,0082)	LO	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7629	\N	(200b,0085)	IS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7630	\N	(200b,0086)	CS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7631	\N	(200b,0088)	CS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7632	\N	(200b,0089)	LT	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7633	\N	(200b,0090)	DS	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7634	\N	(200b,0096)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7635	\N	(200b,0099)	SH	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7636	\N	(200b,009a)	FD	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7637	\N	(200b,009b)	FD	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7638	\N	(200b,00a0)	LT	1	Unknown	Unknown	Philips RAD Imaging DD 097	\N	\N	\N	\N
f	7639	\N	(200d,0000)	OB	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7640	\N	(200d,0000)	OB	1	Unknown	Unknown	Philips US Imaging DD 066	\N	\N	\N	\N
f	7641	\N	(200d,0000)	US	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7642	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7643	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7644	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7645	\N	(200d,0001)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 038	\N	\N	\N	\N
f	7646	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7647	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7648	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7649	\N	(200d,0001)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 048	\N	\N	\N	\N
f	7650	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 066	\N	\N	\N	\N
f	7651	\N	(200d,0001)	SQ	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7652	\N	(200d,0001)	LO	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7653	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7654	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7655	\N	(200d,0002)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7656	\N	(200d,0002)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 038	\N	\N	\N	\N
f	7657	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7658	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7659	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7660	\N	(200d,0002)	LO	1	Unknown	Unknown	Philips US Imaging DD 066	\N	\N	\N	\N
f	7661	\N	(200d,0002)	ST	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7662	\N	(200d,0002)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7663	\N	(200d,0003)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7664	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7665	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7666	\N	(200d,0003)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7667	\N	(200d,0003)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 038	\N	\N	\N	\N
f	7668	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7669	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7670	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7671	\N	(200d,0003)	LO	1	Unknown	Unknown	Philips US Imaging DD 066	\N	\N	\N	\N
f	7672	\N	(200d,0003)	CS	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7673	\N	(200d,0003)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7674	\N	(200d,0004)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7675	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7676	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7677	\N	(200d,0004)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7678	\N	(200d,0004)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 038	\N	\N	\N	\N
f	7679	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7680	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7681	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7682	\N	(200d,0004)	LO	1	Unknown	Unknown	Philips US Imaging DD 066	\N	\N	\N	\N
f	7683	\N	(200d,0004)	SL	4	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7684	\N	(200d,0004)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7685	\N	(200d,0005)	LO	1	Unknown	Unknown	Philips US Imaging DD 017	\N	\N	\N	\N
f	7686	\N	(200d,0005)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7687	\N	(200d,0005)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7688	\N	(200d,0005)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7689	\N	(200d,0005)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7690	\N	(200d,0005)	SH	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7691	\N	(200d,0005)	UL	3	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7692	\N	(200d,0005)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7693	\N	(200d,0006)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7694	\N	(200d,0006)	FD	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7695	\N	(200d,0006)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7696	\N	(200d,0006)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7697	\N	(200d,0006)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7698	\N	(200d,0006)	UL	3	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7699	\N	(200d,0006)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7700	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 021	\N	\N	\N	\N
f	7701	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7702	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7703	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7704	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7705	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7706	\N	(200d,0007)	LO	1	Unknown	Unknown	Philips US Imaging DD 065	\N	\N	\N	\N
f	7707	\N	(200d,0007)	CS	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7708	\N	(200d,0007)	CS	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7709	\N	(200d,0008)	LO	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7710	\N	(200d,0008)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7711	\N	(200d,0008)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7712	\N	(200d,0008)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7713	\N	(200d,0008)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7714	\N	(200d,0008)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7715	\N	(200d,0008)	CS	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7716	\N	(200d,0008)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7717	\N	(200d,0009)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7718	\N	(200d,0009)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7719	\N	(200d,0009)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7720	\N	(200d,0009)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7721	\N	(200d,0009)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7722	\N	(200d,0009)	OB	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7723	\N	(200d,0009)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7724	\N	(200d,000a)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7725	\N	(200d,000a)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7726	\N	(200d,000a)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7727	\N	(200d,000a)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7728	\N	(200d,000a)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7729	\N	(200d,000a)	UL	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7730	\N	(200d,000a)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7731	\N	(200d,000b)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7732	\N	(200d,000b)	LO	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7733	\N	(200d,000b)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7734	\N	(200d,000b)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7735	\N	(200d,000b)	OB	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7736	\N	(200d,000b)	CS	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7737	\N	(200d,000c)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7738	\N	(200d,000c)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7739	\N	(200d,000c)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7740	\N	(200d,000c)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7741	\N	(200d,000c)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7742	\N	(200d,000c)	UL	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7743	\N	(200d,000c)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7744	\N	(200d,000d)	LO	1	Private Native Data Type	PrivateNativeDataType	Philips US Imaging DD 033	\N	\N	\N	\N
f	7745	\N	(200d,000d)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7746	\N	(200d,000d)	LO	1	Unknown	Unknown	Philips US Imaging DD 035	\N	\N	\N	\N
f	7747	\N	(200d,000d)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7748	\N	(200d,000d)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7749	\N	(200d,000d)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7750	\N	(200d,000d)	SQ	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7751	\N	(200d,000d)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7752	\N	(200d,000e)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7753	\N	(200d,000e)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7754	\N	(200d,000e)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7755	\N	(200d,000e)	CS	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7756	\N	(200d,000e)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7757	\N	(200d,000f)	OB	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7758	\N	(200d,000f)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7759	\N	(200d,000f)	IS	1	Unknown	Unknown	Philips US Imaging DD 037	\N	\N	\N	\N
f	7760	\N	(200d,000f)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7761	\N	(200d,000f)	LO	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7762	\N	(200d,000f)	DS	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7763	\N	(200d,0010)	IS	1	Private Native Total Num Sample	PrivateNativeTotalNumSample	Philips US Imaging DD 033	\N	\N	\N	\N
f	7764	\N	(200d,0010)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7765	\N	(200d,0010)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7766	\N	(200d,0010)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7767	\N	(200d,0010)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7768	\N	(200d,0010)	SL	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7769	\N	(200d,0010)	DS	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7770	\N	(200d,0011)	IS	1	Native Data Sample Size	NativeDataSampleSize	Philips US Imaging DD 033	\N	\N	\N	\N
f	7771	\N	(200d,0011)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7772	\N	(200d,0011)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7773	\N	(200d,0011)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7774	\N	(200d,0011)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7775	\N	(200d,0011)	LO	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7776	\N	(200d,0011)	SL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7777	\N	(200d,0012)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7778	\N	(200d,0012)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7779	\N	(200d,0012)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7780	\N	(200d,0012)	SL	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7781	\N	(200d,0012)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7782	\N	(200d,0013)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7783	\N	(200d,0013)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7784	\N	(200d,0013)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7785	\N	(200d,0013)	US	1-n	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7786	\N	(200d,0013)	FL	1-n	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7787	\N	(200d,0014)	IS	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7788	\N	(200d,0014)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7789	\N	(200d,0014)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7790	\N	(200d,0014)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7791	\N	(200d,0014)	CS	1	Unknown	Unknown	Philips US Imaging DD 109	\N	\N	\N	\N
f	7792	\N	(200d,0014)	SS	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7793	\N	(200d,0015)	LO	1	Unknown	Unknown	Philips US Imaging DD 033	\N	\N	\N	\N
f	7794	\N	(200d,0015)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7795	\N	(200d,0015)	LO	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7796	\N	(200d,0015)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7797	\N	(200d,0015)	IS	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7798	\N	(200d,0015)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7799	\N	(200d,0016)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7800	\N	(200d,0016)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7801	\N	(200d,0016)	FD	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7802	\N	(200d,0017)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7803	\N	(200d,0017)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7804	\N	(200d,0017)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7805	\N	(200d,0017)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7806	\N	(200d,0017)	FD	1	Unknown	Unknown	Philips US Imaging DD 046	\N	\N	\N	\N
f	7807	\N	(200d,0017)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7808	\N	(200d,0018)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7809	\N	(200d,0018)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7810	\N	(200d,0018)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7811	\N	(200d,0018)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7812	\N	(200d,0019)	LO	1	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7813	\N	(200d,0019)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7814	\N	(200d,0019)	LO	1	Unknown	Unknown	Philips US Imaging DD 046	\N	\N	\N	\N
f	7815	\N	(200d,0019)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7816	\N	(200d,001a)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7817	\N	(200d,001a)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7818	\N	(200d,001a)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7819	\N	(200d,001b)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7820	\N	(200d,001b)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7821	\N	(200d,001b)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7822	\N	(200d,001b)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7823	\N	(200d,001c)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7824	\N	(200d,001c)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7825	\N	(200d,001c)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7826	\N	(200d,001d)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7827	\N	(200d,001d)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7828	\N	(200d,001e)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7829	\N	(200d,001e)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7830	\N	(200d,001e)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7831	\N	(200d,001f)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7832	\N	(200d,001f)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7833	\N	(200d,001f)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7834	\N	(200d,0020)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7835	\N	(200d,0020)	LO	1	Unknown	Unknown	Philips US Imaging DD 036	\N	\N	\N	\N
f	7836	\N	(200d,0020)	LO	1	Unknown	Unknown	Philips US Imaging DD 040	\N	\N	\N	\N
f	7837	\N	(200d,0020)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7838	\N	(200d,0020)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7839	\N	(200d,0021)	IS	1	Private Native Data Instance Num	PrivateNativeDataInstanceNum	Philips US Imaging DD 033	\N	\N	\N	\N
f	7840	\N	(200d,0021)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7841	\N	(200d,0021)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7842	\N	(200d,0021)	FD	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7843	\N	(200d,0022)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7844	\N	(200d,0022)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7845	\N	(200d,0023)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7846	\N	(200d,0023)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7847	\N	(200d,0023)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7848	\N	(200d,0024)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7849	\N	(200d,0024)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7850	\N	(200d,0024)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7851	\N	(200d,0024)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7852	\N	(200d,0025)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7853	\N	(200d,0025)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7854	\N	(200d,0025)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7855	\N	(200d,0025)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7856	\N	(200d,0026)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7857	\N	(200d,0026)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7858	\N	(200d,0026)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7859	\N	(200d,0026)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7860	\N	(200d,0027)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7861	\N	(200d,0027)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7862	\N	(200d,0027)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7863	\N	(200d,0027)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7864	\N	(200d,0028)	LO	1	Unknown	Unknown	Philips US Imaging DD 034	\N	\N	\N	\N
f	7865	\N	(200d,0028)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7866	\N	(200d,0028)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7867	\N	(200d,0028)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7868	\N	(200d,0029)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7869	\N	(200d,0029)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7870	\N	(200d,002a)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7871	\N	(200d,002b)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7872	\N	(200d,002c)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7873	\N	(200d,002d)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7874	\N	(200d,002e)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7875	\N	(200d,002f)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7876	\N	(200d,0030)	LO	1	Unknown	Unknown	Philips US Imaging DD 041	\N	\N	\N	\N
f	7877	\N	(200d,0030)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7878	\N	(200d,0030)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7879	\N	(200d,0031)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7880	\N	(200d,0031)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7881	\N	(200d,0031)	UL	1	Unknown	Unknown	Philips US Imaging DD 113	\N	\N	\N	\N
f	7882	\N	(200d,0032)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7883	\N	(200d,0033)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7884	\N	(200d,0034)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7885	\N	(200d,0035)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7886	\N	(200d,0036)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7887	\N	(200d,0037)	DA	1	Unknown	Unknown	Philips US Imaging DD 023	\N	\N	\N	\N
f	7888	\N	(200d,0037)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7889	\N	(200d,0038)	TM	1	Unknown	Unknown	Philips US Imaging DD 023	\N	\N	\N	\N
f	7890	\N	(200d,0038)	FD	1-n	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7891	\N	(200d,0039)	FD	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7892	\N	(200d,0040)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7893	\N	(200d,0040)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7894	\N	(200d,0041)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7895	\N	(200d,0042)	IS	1	Unknown	Unknown	Philips US Imaging DD 043	\N	\N	\N	\N
f	7896	\N	(200d,0045)	IS	1	Unknown	Unknown	Philips US Imaging DD 023	\N	\N	\N	\N
f	7897	\N	(200d,0050)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7898	\N	(200d,0050)	LO	1-n	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7899	\N	(200d,0051)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7900	\N	(200d,0051)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7901	\N	(200d,0052)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7902	\N	(200d,0052)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7903	\N	(200d,0053)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7904	\N	(200d,0053)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7905	\N	(200d,0054)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7906	\N	(200d,0054)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7907	\N	(200d,0055)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7908	\N	(200d,0055)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7909	\N	(200d,0056)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7910	\N	(200d,0056)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7911	\N	(200d,0057)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7912	\N	(200d,0057)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7913	\N	(200d,0058)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7914	\N	(200d,0058)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7915	\N	(200d,0059)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7916	\N	(200d,0059)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7917	\N	(200d,005a)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7918	\N	(200d,005b)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7919	\N	(200d,005c)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7920	\N	(200d,005d)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7921	\N	(200d,005e)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7922	\N	(200d,005f)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7923	\N	(200d,0060)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7924	\N	(200d,0060)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7925	\N	(200d,0061)	IS	1	Unknown	Unknown	Philips US Imaging DD 039	\N	\N	\N	\N
f	7926	\N	(200d,0070)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7927	\N	(200d,0071)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7928	\N	(200d,0072)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7929	\N	(200d,0073)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7930	\N	(200d,0074)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7931	\N	(200d,0075)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7932	\N	(200d,0076)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7933	\N	(200d,0077)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7934	\N	(200d,0078)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7935	\N	(200d,008c)	LO	1	Unknown	Unknown	Philips US Imaging DD 042	\N	\N	\N	\N
f	7936	\N	(200d,00f1)	SQ	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7937	\N	(200d,00f3)	OB	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7938	\N	(200d,00f4)	SQ	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7939	\N	(200d,00f5)	SQ	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7940	\N	(200d,00f6)	SQ	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7941	\N	(200d,00f8)	SQ	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7942	\N	(200d,00fa)	CS	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7943	\N	(200d,00fb)	OB	1	Unknown	Unknown	Philips US Imaging DD 045	\N	\N	\N	\N
f	7944	\N	(4001,0000)	SQ	1	Unknown	Unknown	Philips Imaging DD 067	\N	\N	\N	\N
f	7945	\N	(4001,0001)	CS	1	Unknown	Unknown	Philips Imaging DD 067	\N	\N	\N	\N
f	7946	\N	(4001,0008)	CS	1	Unknown	Unknown	Philips Imaging DD 067	\N	\N	\N	\N
f	7947	\N	(4001,0009)	CS	1	Unknown	Unknown	Philips Imaging DD 067	\N	\N	\N	\N
f	7948	\N	(4001,0010)	SQ	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7949	\N	(4001,0011)	SQ	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7950	\N	(4001,0012)	SQ	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7951	\N	(4001,0013)	ST	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7952	\N	(4001,0016)	ST	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7953	\N	(4001,0017)	ST	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7954	\N	(4001,0018)	ST	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7955	\N	(4001,001c)	SQ	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7956	\N	(4001,001d)	LT	1	Unknown	Unknown	Philips Imaging DD 070	\N	\N	\N	\N
f	7957	\N	(4007,0000)	CS	1	Unknown	Unknown	Philips Imaging DD 065	\N	\N	\N	\N
f	7958	\N	(4007,0048)	FL	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	7959	\N	(4007,004b)	FL	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	7960	\N	(4007,004c)	LO	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	7961	\N	(4007,004d)	FL	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	7962	\N	(4007,004e)	FL	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	7963	\N	(4007,004f)	LO	1	Unknown	Unknown	Philips Imaging DD 073	\N	\N	\N	\N
f	1190	\N	(6001,0000)	LT	1	Unknown	Unknown	PHILIPS MR/LAST	\N	\N	\N	\N
f	7964	\N	(7043,0000)	SH	1	Unknown	Unknown	Philips NM Private Group	\N	\N	\N	\N
f	7965	\N	(7051,0000)	US	1	Current Segment	CurrentSegment	PHILIPS NM -Private	\N	\N	\N	\N
f	7966	\N	(7051,0001)	US	1	Number of Segments	NumberOfSegments	PHILIPS NM -Private	\N	\N	\N	\N
f	7967	\N	(7051,0001)	DS	1	Attenuation Threshold	AttenuationThreshold	PHILIPS XCT -Private	\N	\N	\N	\N
f	7968	\N	(7051,0002)	FL	1	Segment Start Position	SegmentStartPosition	PHILIPS NM -Private	\N	\N	\N	\N
f	7969	\N	(7051,0002)	DS	1	DLPEstimate	DLPEstimate	PHILIPS XCT -Private	\N	\N	\N	\N
f	7970	\N	(7051,0003)	FL	1	Segment Stop Position	SegmentStopPosition	PHILIPS NM -Private	\N	\N	\N	\N
f	7971	\N	(7051,0004)	FL	1	Relative COR offset - X direction	RelativeCOROffsetXDirection	PHILIPS NM -Private	\N	\N	\N	\N
f	7972	\N	(7051,0005)	FL	1	Relative COR offset - Z direction	RelativeCOROffsetZDirection	PHILIPS NM -Private	\N	\N	\N	\N
f	7973	\N	(7051,0006)	US	1	Current Rotation Number	CurrentRotationNumber	PHILIPS NM -Private	\N	\N	\N	\N
f	7974	\N	(7051,0007)	US	1	Number of Rotations	NumberOfRotations	PHILIPS NM -Private	\N	\N	\N	\N
f	7975	\N	(7051,0010)	DS	1-n	Alignment Translations	AlignmentTranslations	PHILIPS NM -Private	\N	\N	\N	\N
f	7976	\N	(7051,0011)	DS	1-n	Alignment Rotations	AlignmentRotations	PHILIPS NM -Private	\N	\N	\N	\N
f	7977	\N	(7051,0012)	DS	1	Alignment Timestamp	AlignmentTimestamp	PHILIPS NM -Private	\N	\N	\N	\N
f	7978	\N	(7051,0015)	UI	1	Related Xray Series Instance UID	RelatedXraySeriesInstanceUID	PHILIPS NM -Private	\N	\N	\N	\N
f	7979	\N	(7051,0025)	LO	1	Unknown	Unknown	PHILIPS NM -Private	\N	\N	\N	\N
f	7980	\N	(7051,0026)	DS	1	Unknown	Unknown	PHILIPS NM -Private	\N	\N	\N	\N
f	7981	\N	(7051,0027)	IS	1	Unknown	Unknown	PHILIPS NM -Private	\N	\N	\N	\N
f	7982	\N	(7051,0028)	IS	1	Unknown	Unknown	PHILIPS NM -Private	\N	\N	\N	\N
f	7983	\N	(7051,0029)	IS	1	Unknown	Unknown	PHILIPS NM -Private	\N	\N	\N	\N
f	7984	\N	(7053,0000)	DS	1	SUV Factor	SUVFactor	Philips PET Private Group	\N	\N	\N	\N
f	7985	\N	(7053,0001)	OB	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	7986	\N	(7053,0002)	OB	1	Private Data	PrivateData	Philips PET Private Group	\N	\N	\N	\N
f	7987	\N	(7053,0003)	ST	1	Original File Name	OriginalFileName	Philips PET Private Group	\N	\N	\N	\N
f	7988	\N	(7053,0004)	OB	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7989	\N	(7053,0005)	LO	1	Worklist Info File Name	WorklistInfoFileName	Philips PET Private Group	\N	\N	\N	\N
f	7990	\N	(7053,0006)	OB	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7991	\N	(7053,0007)	SQ	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7992	\N	(7053,0008)	SQ	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7993	\N	(7053,0009)	DS	1	Activity Concentration Scale Factor	ActivityConcentrationScaleFactor	Philips PET Private Group	\N	\N	\N	\N
f	7994	\N	(7053,000f)	UL	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7995	\N	(7053,0010)	US	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7996	\N	(7053,0011)	US	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7997	\N	(7053,0012)	SQ	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7998	\N	(7053,0013)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	7999	\N	(7053,0014)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8000	\N	(7053,0015)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8001	\N	(7053,0016)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8002	\N	(7053,0017)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8003	\N	(7053,0018)	SS	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8004	\N	(7053,00c2)	UI	1	Unknown	Unknown	Philips PET Private Group	\N	\N	\N	\N
f	8005	\N	(7fe1,0010)	OW/OB	1	Pixel Data	PixelData	SPI-P Release 1	\N	\N	\N	\N
f	1293	\N	(7001,0001)	UI	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	1294	\N	(7001,0002)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8006	\N	(7001,0003)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8007	\N	(7001,0004)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8008	\N	(7001,0005)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8009	\N	(7001,0006)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8010	\N	(7001,0007)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8011	\N	(7001,0008)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8012	\N	(7001,0009)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8013	\N	(7001,0010)	SQ	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8014	\N	(7001,0011)	LO	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8015	\N	(7001,0012)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8016	\N	(7001,0013)	US	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8017	\N	(7001,0014)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8018	\N	(7001,0016)	OB	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8019	\N	(7001,0017)	LO	1	Unknown	Unknown	Picker NM Private Group	PCK	\N	\N	\N
f	8020	\N	(7101,0000)	OB	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8021	\N	(7101,0001)	SL	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8022	\N	(7101,0002)	OB	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8023	\N	(7101,0003)	SL	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8024	\N	(7101,0004)	SH	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8025	\N	(7101,0005)	SH	2	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8026	\N	(7101,0006)	SH	4	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	8027	\N	(7101,0010)	DS	1	Unknown	Unknown	Picker MR Private Group	PCK	\N	\N	\N
f	1547	\N	(0003,0008)	US	1	ISI Command Field	ISICommandField	SIEMENS ISI	SSPI	\N	\N	\N
f	1548	\N	(0003,0011)	US	1	Attach ID Application Code	AttachIDApplicationCode	SIEMENS ISI	SSPI	\N	\N	\N
f	1549	\N	(0003,0012)	UL	1	Attach ID Message Count	AttachIDMessageCount	SIEMENS ISI	SSPI	\N	\N	\N
f	1550	\N	(0003,0013)	DA	1	Attach ID Date	AttachIDDate	SIEMENS ISI	SSPI	\N	\N	\N
f	1551	\N	(0003,0014)	TM	1	Attach ID Time	AttachIDTime	SIEMENS ISI	SSPI	\N	\N	\N
f	1552	\N	(0003,0020)	US	1	Message Type	MessageType	SIEMENS ISI	SSPI	\N	\N	\N
f	1553	\N	(0003,0030)	DA	1	Max Waiting Date	MaxWaitingDate	SIEMENS ISI	SSPI	\N	\N	\N
f	1554	\N	(0003,0031)	TM	1	Max Waiting Time	MaxWaitingTime	SIEMENS ISI	SSPI	\N	\N	\N
f	8028	\N	(0009,0000)	SQ	1	Temporary Original Header Sequence	TemporaryOriginalHeaderSequence	SIEMENS SYNGO INSTANCE MANIFEST	SSPI	\N	\N	\N
f	1300	\N	(0009,0000)	DS	1	Number of Measurements	NumberOfMeasurements	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	259	\N	(0009,0001)	UN	1	CR Header Information	CRHeaderInformation	FFP DATA	SSPI	\N	\N	\N
f	941	\N	(0009,0001)	UN	1	SIENET General Purpose IMGEF	SIENETGeneralPurposeIMGEF	ISI	SSPI	\N	\N	\N
f	1555	\N	(0009,0001)	UN	1	RIS Patient Info IMGEF	RISPatientInfoIMGEF	SIEMENS ISI	SSPI	\N	\N	\N
f	2228	\N	(0009,0001)	US	1	SIENET Command Field	SIENETCommandField	SIENET	SSPI	\N	\N	\N
f	8029	\N	(0009,0010)	AE	1	syngo Index Source AE Title	syngoIndexSourceAETitle	SIEMENS SYNGO INSTANCE MANIFEST	SSPI	\N	\N	\N
f	1301	\N	(0009,0010)	CS	1	Storage Mode	StorageMode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1501	\N	(0009,0010)	UN	1	Unknown	Unknown	SIEMENS DICOM	SSPI	\N	\N	\N
f	1368	\N	(0009,0010)	LO	1	Generator Identification Label	GeneratorIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1479	\N	(0009,0010)	LO	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1616	\N	(0009,0010)	LO	1	Recognition Code	RecognitionCode	SIEMENS MED	SSPI	\N	\N	\N
f	1369	\N	(0009,0011)	LO	1	Gantry Identification Label	GantryIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1302	\N	(0009,0012)	UL	1	Evaluation Mask - Image	EvaluationMaskImage	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1370	\N	(0009,0012)	LO	1	X-Ray Tube Identification Label	XRayTubeIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1502	\N	(0009,0012)	LO	1	Unknown	Unknown	SIEMENS DICOM	SSPI	\N	\N	\N
f	1371	\N	(0009,0013)	LO	1	Detector Identification Label	DetectorIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	2229	\N	(0009,0014)	LO	1	Receiver PLA	ReceiverPLA	SIENET	SSPI	\N	\N	\N
f	1372	\N	(0009,0014)	LO	1	DAS Identification Label	DASIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1373	\N	(0009,0015)	LO	1	SMI Identification Label	SMIIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	2230	\N	(0009,0016)	US	1	Transfer Priority	TransferPriority	SIENET	SSPI	\N	\N	\N
f	1374	\N	(0009,0016)	LO	1	CPU Identification Label	CPUIdentificationLabel	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1375	\N	(0009,0020)	SH	1	Header Version	HeaderVersion	SIEMENS CM VA0  LAB	SSPI	\N	\N	\N
f	1488	\N	(0009,0020)	LO	1	Unknown	Unknown	SIEMENS CT VA0  ORI	SSPI	\N	\N	\N
f	1303	\N	(0009,0026)	DA	1	Last Move Date	LastMoveDate	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1304	\N	(0009,0027)	TM	1	Last Move Time	LastMoveTime	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	2231	\N	(0009,0029)	LO	1	Actual User	ActualUser	SIENET	SSPI	\N	\N	\N
f	1617	\N	(0009,0030)	US	1	Byte Offset of Original Header	ByteOffsetOfOriginalHeader	SIEMENS MED	SSPI	\N	\N	\N
f	1480	\N	(0009,0030)	CS	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1489	\N	(0009,0030)	LO	1	Unknown	Unknown	SIEMENS CT VA0  ORI	SSPI	\N	\N	\N
f	1618	\N	(0009,0031)	UL	1	Length of Original Header	LengthOfOriginalHeader	SIEMENS MED	SSPI	\N	\N	\N
f	1481	\N	(0009,0031)	SH	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1482	\N	(0009,0032)	SH	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1483	\N	(0009,0034)	SH	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1619	\N	(0009,0040)	US	1	Byte Offset of Pixelmatrix	ByteOffsetOfPixelmatrix	SIEMENS MED	SSPI	\N	\N	\N
f	1484	\N	(0009,0040)	LO	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1620	\N	(0009,0041)	UL	1	Length of Pixelmatrix In Bytes	LengthOfPixelmatrixInBytes	SIEMENS MED	SSPI	\N	\N	\N
f	1485	\N	(0009,0042)	LO	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1486	\N	(0009,0050)	DA	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1621	\N	(0009,0050)	LO	1	Unknown	Unknown	SIEMENS MED	SSPI	\N	\N	\N
f	1487	\N	(0009,0051)	TM	1	Unknown	Unknown	SIEMENS CT VA0  IDE	SSPI	\N	\N	\N
f	1622	\N	(0009,0051)	LO	1	Unknown	Unknown	SIEMENS MED	SSPI	\N	\N	\N
f	8030	\N	(0009,0070)	DS	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8031	\N	(0009,0071)	DS	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8032	\N	(0009,0072)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8033	\N	(0009,0073)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8034	\N	(0009,0074)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8035	\N	(0009,0075)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	8036	\N	(0009,0080)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1623	\N	(0009,00f5)	LO	1	PDM EFID Placeholder	PDMEFIDPlaceholder	SIEMENS MED	SSPI	\N	\N	\N
f	1624	\N	(0009,00f6)	LO	1	PDM Data Object Type Extension	PDMDataObjectTypeExtension	SIEMENS MED	SSPI	\N	\N	\N
f	8037	\N	(0009,0020)	DA	1	Object Insertion Date	ObjectInsertionDate	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8038	\N	(0009,00a0)	LO	1	Sender System Device Name	SenderSystemDeviceName	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8039	\N	(0009,0040)	DT	1	Last Access Time	LastAccessTime	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8040	\N	(0009,0041)	CS	1	Delete Protected Status	DeleteProtectedStatus	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8041	\N	(0009,0042)	CS	1	Received from Archive Status	ReceivedfromArchiveStatus	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8042	\N	(0009,0043)	CS	1	Archive Status	ArchiveStatus	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8043	\N	(0009,0044)	AE	1	Location	Location	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8044	\N	(0009,0045)	CS	1	Logical Deleted Status	LogicalDeletedStatus	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8045	\N	(0009,0046)	DT	1	Insert Time	InsertTime	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8046	\N	(0009,0047)	IS	1	Visible Instances on Series Level	VisibleInstancesonSeriesLevel	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8047	\N	(0009,0048)	IS	1	Unarchived Instances	UnarchivedInstances	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8048	\N	(0009,0049)	IS	1	Visible Instances on Study Level	VisibleInstancesonStudyLevel	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8049	\N	(0009,0031)	SQ	1	Series Object States	SeriesObjectStates	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8050	\N	(0009,0030)	SQ	1	Instance Object States	InstanceObjectStates	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8051	\N	(0009,0050)	CS	1	Hidden Instance	HiddenInstance	SIEMENS SYNGO INDEX SERVICE	SSPI	\N	\N	\N
f	8052	\N	(0009,0050)	UI	1	Unknown	Unknown	SIEMENS AX INSPACE_EP	SSPI	\N	\N	\N
f	8053	\N	(0009,0051)	UI	1	Unknown	Unknown	SIEMENS AX INSPACE_EP	SSPI	\N	\N	\N
f	1815	\N	(0011,0020)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1816	\N	(0011,0025)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1817	\N	(0011,0026)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1818	\N	(0011,0030)	LO	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1819	\N	(0011,0035)	LO	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1820	\N	(0011,0040)	CS	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1902	\N	(0011,0028)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	1903	\N	(0011,0029)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	1904	\N	(0011,002a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	1905	\N	(0011,002b)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	1906	\N	(0011,002c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2035	\N	(0011,0028)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2036	\N	(0011,0029)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2037	\N	(0011,002a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2038	\N	(0011,002b)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2039	\N	(0011,002c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1556	\N	(0011,0003)	LO	1	Patient UID	PatientUID	SIEMENS ISI	SSPI	\N	\N	\N
f	1557	\N	(0011,0004)	LO	1	Patient ID	PatientID	SIEMENS ISI	SSPI	\N	\N	\N
f	1305	\N	(0011,000a)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1558	\N	(0011,000a)	LO	1	Case ID	CaseID	SIEMENS ISI	SSPI	\N	\N	\N
f	1306	\N	(0011,0010)	DA	1	Registration Date	RegistrationDate	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	2119	\N	(0011,0010)	LO	1	Patient UID	PatientUID	SIEMENS RIS	SSPI	\N	\N	\N
f	8054	\N	(0011,0010)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1307	\N	(0011,0011)	TM	1	Registration Time	RegistrationTime	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	2120	\N	(0011,0011)	LO	1	Patient ID	PatientID	SIEMENS RIS	SSPI	\N	\N	\N
f	2121	\N	(0011,0020)	DA	1	Patient Registration Date	PatientRegistrationDate	SIEMENS RIS	SSPI	\N	\N	\N
f	2122	\N	(0011,0021)	TM	1	Patient Registration Time	PatientRegistrationTime	SIEMENS RIS	SSPI	\N	\N	\N
f	1308	\N	(0011,0022)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1559	\N	(0011,0022)	LO	1	Request ID	RequestID	SIEMENS ISI	SSPI	\N	\N	\N
f	1309	\N	(0011,0023)	DS	1	Used Patient Weight	UsedPatientWeight	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1560	\N	(0011,0023)	LO	1	Examination UID	ExaminationUID	SIEMENS ISI	SSPI	\N	\N	\N
f	2123	\N	(0011,0030)	PN	1	Patientname RIS	PatientnameRIS	SIEMENS RIS	SSPI	\N	\N	\N
f	2124	\N	(0011,0031)	LO	1	Patientprename RIS	PatientprenameRIS	SIEMENS RIS	SSPI	\N	\N	\N
f	1310	\N	(0011,0040)	IS	1	Organ Code	OrganCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	2125	\N	(0011,0040)	LO	1	Patient Hospital Status	PatientHospitalStatus	SIEMENS RIS	SSPI	\N	\N	\N
f	2126	\N	(0011,0041)	LO	1	Medical Alerts	MedicalAlerts	SIEMENS RIS	SSPI	\N	\N	\N
f	2127	\N	(0011,0042)	LO	1	Contrast Allergies	ContrastAllergies	SIEMENS RIS	SSPI	\N	\N	\N
f	1561	\N	(0011,00a1)	DA	1	Patient Registration Date	PatientRegistrationDate	SIEMENS ISI	SSPI	\N	\N	\N
f	1562	\N	(0011,00a2)	TM	1	Patient Registration Time	PatientRegistrationTime	SIEMENS ISI	SSPI	\N	\N	\N
f	1563	\N	(0011,00b0)	LO	1	Patient Last Name	PatientLastName	SIEMENS ISI	SSPI	\N	\N	\N
f	1564	\N	(0011,00b2)	LO	1	Patient First Name	PatientFirstName	SIEMENS ISI	SSPI	\N	\N	\N
f	1565	\N	(0011,00b4)	LO	1	Patient Hospital Status	PatientHospitalStatus	SIEMENS ISI	SSPI	\N	\N	\N
f	1566	\N	(0011,00bc)	TM	1	Current Location Time	CurrentLocationTime	SIEMENS ISI	SSPI	\N	\N	\N
f	1567	\N	(0011,00c0)	LO	1	Patient Insurance Status	PatientInsuranceStatus	SIEMENS ISI	SSPI	\N	\N	\N
f	1568	\N	(0011,00d0)	LO	1	Patient Billing Type	PatientBillingType	SIEMENS ISI	SSPI	\N	\N	\N
f	1569	\N	(0011,00d2)	LO	1	Patient Billing Address	PatientBillingAddress	SIEMENS ISI	SSPI	\N	\N	\N
f	8055	\N	(0011,0001)	ST	1	Reprocessing Info	ReprocessingInfo	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8056	\N	(0011,0002)	CS	1-n	Data Role Type	DataRoleType	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8057	\N	(0011,0003)	ST	1	Data Role Name	DataRoleName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8058	\N	(0011,0004)	SL	1	Rescan Name	RescanName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8059	\N	(0011,0005)	FD	1	Unknown	Unknown	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8060	\N	(0011,0006)	ST	1	Cardiac Type Name	CardiacTypeName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8061	\N	(0011,0007)	ST	1	Cardiac Type Name L2	CardiacTypeNameL2	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8062	\N	(0011,0008)	ST	1	Misc Indicator	MiscIndicator	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8063	\N	(0011,0009)	SL	1	Unknown	Unknown	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8064	\N	(0011,000a)	SL	1	Unknown	Unknown	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8065	\N	(0011,000b)	DS	1	Unknown	Unknown	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8066	\N	(0011,000c)	ST	1	Split Bagging Name	SplitBaggingName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8067	\N	(0011,000d)	ST	1	Split Sub Bagging Name	SplitSubBaggingName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8068	\N	(0011,000e)	ST	1	Stage Sub Bagging Name	StageSubBaggingName	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	8069	\N	(0011,000f)	ST	1	Is Internal Data Role	IsInternalDataRole	SIEMENS MR DATAMAPPING ATTRIBUTES	SSPI	\N	\N	\N
f	1311	\N	(0013,0000)	PN	1	Modifying Physician	ModifyingPhysician	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1312	\N	(0013,0010)	DA	1	Modification Date	ModificationDate	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1313	\N	(0013,0012)	TM	1	Modification Time	ModificationTime	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1314	\N	(0013,0020)	PN	1	Patient Name	PatientName	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1315	\N	(0013,0022)	LO	1	Patient Id	PatientId	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1316	\N	(0013,0030)	DA	1	Patient Birthdate	PatientBirthdate	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1317	\N	(0013,0031)	DS	1	Patient Weight	PatientWeight	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1318	\N	(0013,0032)	LO	1	Patients Maiden Name	PatientsMaidenName	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1319	\N	(0013,0033)	LO	1	Referring Physician	ReferringPhysician	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1320	\N	(0013,0034)	LO	1	Admitting Diagnosis	AdmittingDiagnosis	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1321	\N	(0013,0035)	LO	1	Patient Sex	PatientSex	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1322	\N	(0013,0040)	LO	1	Procedure Description	ProcedureDescription	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1323	\N	(0013,0042)	LO	1	Patient Rest Direction	PatientRestDirection	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1324	\N	(0013,0044)	LO	1	Patient Position	PatientPosition	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1325	\N	(0013,0046)	LO	1	View Direction	ViewDirection	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1326	\N	(0013,0050)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1327	\N	(0013,0051)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1328	\N	(0013,0052)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1329	\N	(0013,0053)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1330	\N	(0013,0054)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1331	\N	(0013,0055)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1332	\N	(0013,0056)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	8070	\N	(0015,0000)	OB	1	Unknown	Unknown	ESOFT_DICOM_ECAT_OWNERCODE	SSPI	\N	\N	\N
f	8071	\N	(0017,0000)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8072	\N	(0017,0000)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Version	SSPI	\N	\N	\N
f	8073	\N	(0017,0001)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Version	SSPI	\N	\N	\N
f	8074	\N	(0017,0020)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8075	\N	(0017,0070)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8076	\N	(0017,0080)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8077	\N	(0017,000a)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8078	\N	(0017,000b)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8079	\N	(0017,000c)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8080	\N	(0017,000d)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8081	\N	(0017,000e)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8082	\N	(0017,000f)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8083	\N	(0017,0010)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8084	\N	(0017,0011)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8085	\N	(0017,0014)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8086	\N	(0017,0016)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8087	\N	(0017,0017)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8088	\N	(0017,0018)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8089	\N	(0017,0019)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8090	\N	(0017,001a)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8091	\N	(0017,001b)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8092	\N	(0017,001c)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8093	\N	(0017,001e)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8094	\N	(0017,001f)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8095	\N	(0017,0020)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8096	\N	(0017,0021)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8097	\N	(0017,0022)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8098	\N	(0017,0023)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8099	\N	(0017,0024)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8100	\N	(0017,0025)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8101	\N	(0017,0026)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8102	\N	(0017,0027)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8103	\N	(0017,0028)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8104	\N	(0017,0029)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8105	\N	(0017,0048)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8106	\N	(0017,0049)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8107	\N	(0017,004d)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8108	\N	(0017,004e)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8109	\N	(0017,004f)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8110	\N	(0017,0050)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8111	\N	(0017,0051)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8112	\N	(0017,0052)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8113	\N	(0017,0053)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8114	\N	(0017,0054)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8115	\N	(0017,0055)	SS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8116	\N	(0017,005c)	OW	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8117	\N	(0017,0064)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8118	\N	(0017,0066)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8119	\N	(0017,0067)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8120	\N	(0017,0068)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8121	\N	(0017,0085)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8122	\N	(0017,0086)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8123	\N	(0017,0087)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8124	\N	(0017,0088)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8125	\N	(0017,0089)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8126	\N	(0017,008a)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8127	\N	(0017,008b)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8128	\N	(0017,008c)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8129	\N	(0017,008d)	FL	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8130	\N	(0017,008e)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8131	\N	(0017,008f)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8132	\N	(0017,00a0)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8133	\N	(0017,00a1)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8134	\N	(0017,00a2)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8135	\N	(0017,00a3)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8136	\N	(0017,00a4)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8137	\N	(0017,00a5)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8138	\N	(0017,00a6)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8139	\N	(0017,00aa)	US	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8140	\N	(0017,00b0)	DS	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8141	\N	(0017,00c0)	LO	1	Unknown	Unknown	SIEMENS_FLCOMPACT_VA01A_PROC	SSPI	\N	\N	\N
f	8142	\N	(0017,0011)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8143	\N	(0017,0012)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8144	\N	(0017,0014)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8145	\N	(0017,0015)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8146	\N	(0017,0016)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8147	\N	(0017,0018)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8148	\N	(0017,0021)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8149	\N	(0017,0022)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8150	\N	(0017,0023)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8151	\N	(0017,0024)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8152	\N	(0017,0025)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8153	\N	(0017,0026)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8154	\N	(0017,0027)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8155	\N	(0017,002a)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8156	\N	(0017,0030)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8157	\N	(0017,0031)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8158	\N	(0017,0032)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8159	\N	(0017,0033)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8160	\N	(0017,0037)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8161	\N	(0017,0038)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8162	\N	(0017,0041)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8163	\N	(0017,0043)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8164	\N	(0017,0044)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8165	\N	(0017,0045)	DS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8166	\N	(0017,0046)	DS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8167	\N	(0017,0047)	SH	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8168	\N	(0017,0048)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8169	\N	(0017,0049)	LO	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8170	\N	(0017,004a)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8171	\N	(0017,0051)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8172	\N	(0017,0052)	UL	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8173	\N	(0017,0061)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8174	\N	(0017,0062)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8175	\N	(0017,0071)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8176	\N	(0017,0072)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8177	\N	(0017,0073)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8178	\N	(0017,0074)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8179	\N	(0017,0079)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8180	\N	(0017,007a)	US	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8181	\N	(0017,007b)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8182	\N	(0017,00a0)	IS	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8183	\N	(0017,00c1)	LO	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8184	\N	(0017,00c2)	LO	1	Unknown	Unknown	SIEMENS DFR.01 ORIGINAL	SSPI	\N	\N	\N
f	8185	\N	(0017,0011)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8186	\N	(0017,0012)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8187	\N	(0017,0014)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8188	\N	(0017,0015)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8189	\N	(0017,0025)	IS	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8190	\N	(0017,0027)	IS	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8191	\N	(0017,0029)	IS	1	Edge Enhancement %	EdgeEnhancement	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8192	\N	(0017,0030)	IS	1	Harmonization %	Harmonization	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8193	\N	(0017,0031)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8194	\N	(0017,0032)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8195	\N	(0017,0033)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8196	\N	(0017,0035)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8197	\N	(0017,0037)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8198	\N	(0017,0038)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8199	\N	(0017,0071)	IS	1	Landmark	Landmark	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8200	\N	(0017,0072)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8201	\N	(0017,0073)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8202	\N	(0017,0074)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8203	\N	(0017,0077)	DS	1	Pixel Shift horizontal	PixelShiftHorizontal	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8204	\N	(0017,0078)	DS	1	Pixel Shift vertical	PixelShiftVertical	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8205	\N	(0017,0079)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8206	\N	(0017,007a)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8207	\N	(0017,0080)	US	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8208	\N	(0017,0083)	LO	1	Left Marker	LeftMarker	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8209	\N	(0017,0084)	LO	1	Right Marker	RightMarker	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8210	\N	(0017,00a1)	SH	1	Unknown	Unknown	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8211	\N	(0017,00a2)	SH	1	Image Name Extension 1	ImageNameExtension1	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8212	\N	(0017,00a3)	SH	1	Image Name Extension 2	ImageNameExtension2	SIEMENS DFR.01 MANIPULATED	SSPI	\N	\N	\N
f	8213	\N	(0019,0001)	UL	1-n	AEC Coordinates	AECCoordinates	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8214	\N	(0019,0002)	US	2	AEC Coordinates Size	AECCoordinatesSize	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8215	\N	(0019,0010)	ST	1	Derivation Description	DerivationDescription	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8216	\N	(0019,0008)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8217	\N	(0019,000f)	SL	1-n	Siemens ICON Data Type	SiemensICONDataType	SIEMENS MED NM	SSPI	\N	\N	\N
f	8218	\N	(0019,0016)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8219	\N	(0019,00a5)	SS	1-n	Number of Repeats per Phase	NumberOfRepeatsPerPhase	SIEMENS MED NM	SSPI	\N	\N	\N
f	8220	\N	(0019,00a6)	SS	1-n	Cycles per Repeat	CyclesPerRepeat	SIEMENS MED NM	SSPI	\N	\N	\N
f	8221	\N	(0019,00a7)	SL	1-n	Repeat Start Time	RepeatStartTime	SIEMENS MED NM	SSPI	\N	\N	\N
f	8222	\N	(0019,00a8)	SL	1-n	Repeat Stop Time	RepeatStopTime	SIEMENS MED NM	SSPI	\N	\N	\N
f	8223	\N	(0019,00a9)	SL	1-n	Effective Repeat Time	EffectiveRepeatTime	SIEMENS MED NM	SSPI	\N	\N	\N
f	8224	\N	(0019,00aa)	SS	1-n	Acquired Cycles per Repeat	AcquiredCyclesPerRepeat	SIEMENS MED NM	SSPI	\N	\N	\N
f	1907	\N	(0019,0015)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8225	\N	(0019,0015)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1908	\N	(0019,0018)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2040	\N	(0019,0018)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1909	\N	(0019,0019)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2041	\N	(0019,0019)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1910	\N	(0019,001a)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2042	\N	(0019,001a)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1911	\N	(0019,001b)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2043	\N	(0019,001b)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1912	\N	(0019,001c)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2044	\N	(0019,001c)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1913	\N	(0019,001d)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2045	\N	(0019,001d)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1914	\N	(0019,001e)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2046	\N	(0019,001e)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1915	\N	(0019,001f)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2047	\N	(0019,001f)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1916	\N	(0019,0020)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2048	\N	(0019,0020)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1917	\N	(0019,0022)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2049	\N	(0019,0022)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1918	\N	(0019,0024)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2050	\N	(0019,0024)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1919	\N	(0019,0026)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2051	\N	(0019,0026)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1920	\N	(0019,0028)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2052	\N	(0019,0028)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1921	\N	(0019,002a)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2053	\N	(0019,002a)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1922	\N	(0019,002c)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2054	\N	(0019,002c)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1923	\N	(0019,002e)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2055	\N	(0019,002e)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1924	\N	(0019,0030)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2056	\N	(0019,0030)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1925	\N	(0019,0032)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2057	\N	(0019,0032)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1926	\N	(0019,0034)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2058	\N	(0019,0034)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1927	\N	(0019,0036)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2059	\N	(0019,0036)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1928	\N	(0019,0038)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2060	\N	(0019,0038)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1929	\N	(0019,003a)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2061	\N	(0019,003a)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1930	\N	(0019,003c)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2062	\N	(0019,003c)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1931	\N	(0019,003e)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2063	\N	(0019,003e)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1932	\N	(0019,0040)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2064	\N	(0019,0040)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1933	\N	(0019,0042)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2065	\N	(0019,0042)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1934	\N	(0019,0044)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2066	\N	(0019,0044)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1935	\N	(0019,0046)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2067	\N	(0019,0046)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2068	\N	(0019,0048)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1936	\N	(0019,0048)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	1937	\N	(0019,004a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2069	\N	(0019,004a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1938	\N	(0019,004c)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2070	\N	(0019,004c)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1939	\N	(0019,004e)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2071	\N	(0019,004e)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1940	\N	(0019,0050)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2072	\N	(0019,0050)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1941	\N	(0019,0052)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2073	\N	(0019,0052)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1942	\N	(0019,0054)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2074	\N	(0019,0054)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1943	\N	(0019,0056)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2075	\N	(0019,0056)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1944	\N	(0019,0058)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2076	\N	(0019,0058)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1945	\N	(0019,005a)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2077	\N	(0019,005a)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1946	\N	(0019,005c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2078	\N	(0019,005c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1947	\N	(0019,005e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2079	\N	(0019,005e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1948	\N	(0019,0060)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2080	\N	(0019,0060)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1949	\N	(0019,0062)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2081	\N	(0019,0062)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1950	\N	(0019,0064)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2082	\N	(0019,0064)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1951	\N	(0019,0066)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2083	\N	(0019,0066)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1952	\N	(0019,0068)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2084	\N	(0019,0068)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1953	\N	(0019,006a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2085	\N	(0019,006a)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1954	\N	(0019,006c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2086	\N	(0019,006c)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1955	\N	(0019,006e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2087	\N	(0019,006e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1956	\N	(0019,0070)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2088	\N	(0019,0070)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1957	\N	(0019,0072)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2089	\N	(0019,0072)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1958	\N	(0019,0074)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2090	\N	(0019,0074)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1959	\N	(0019,0076)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2091	\N	(0019,0076)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1960	\N	(0019,0078)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2092	\N	(0019,0078)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1961	\N	(0019,007a)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2093	\N	(0019,007a)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1962	\N	(0019,007c)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2094	\N	(0019,007c)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1963	\N	(0019,007e)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2095	\N	(0019,007e)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1964	\N	(0019,0080)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2096	\N	(0019,0080)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1965	\N	(0019,0082)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2097	\N	(0019,0082)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1966	\N	(0019,0084)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2098	\N	(0019,0084)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1967	\N	(0019,0086)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2099	\N	(0019,0086)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1968	\N	(0019,0088)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2100	\N	(0019,0088)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1969	\N	(0019,008a)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2101	\N	(0019,008a)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1970	\N	(0019,008c)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2102	\N	(0019,008c)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1971	\N	(0019,008e)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2103	\N	(0019,008e)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1972	\N	(0019,0090)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2104	\N	(0019,0090)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1973	\N	(0019,0092)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2105	\N	(0019,0092)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1974	\N	(0019,0094)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2106	\N	(0019,0094)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1975	\N	(0019,0096)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2107	\N	(0019,0096)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1976	\N	(0019,0098)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2108	\N	(0019,0098)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1977	\N	(0019,009a)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2109	\N	(0019,009a)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1978	\N	(0019,009c)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2110	\N	(0019,009c)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1979	\N	(0019,009e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2111	\N	(0019,009e)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1980	\N	(0019,00a0)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2112	\N	(0019,00a0)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1981	\N	(0019,00a2)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2113	\N	(0019,00a2)	US	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1982	\N	(0019,00a4)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2114	\N	(0019,00a4)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1983	\N	(0019,00a6)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2115	\N	(0019,00a6)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1984	\N	(0019,00a8)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2116	\N	(0019,00a8)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1985	\N	(0019,00aa)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2117	\N	(0019,00aa)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1986	\N	(0019,00ac)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	2118	\N	(0019,00ac)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1987	\N	(0019,00ae)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8226	\N	(0019,00ae)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1988	\N	(0019,00b0)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8227	\N	(0019,00b0)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1989	\N	(0019,00b1)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8228	\N	(0019,00b1)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1990	\N	(0019,00b2)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8229	\N	(0019,00b2)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1991	\N	(0019,00b3)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8230	\N	(0019,00b3)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1992	\N	(0019,00b4)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8231	\N	(0019,00b4)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1993	\N	(0019,00b5)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8232	\N	(0019,00b5)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1994	\N	(0019,00b6)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8233	\N	(0019,00b6)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1995	\N	(0019,00b7)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8234	\N	(0019,00b7)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1996	\N	(0019,00b8)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8235	\N	(0019,00b8)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1997	\N	(0019,00b9)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8236	\N	(0019,00b9)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1998	\N	(0019,00bb)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8237	\N	(0019,00bb)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1999	\N	(0019,00bc)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8238	\N	(0019,00bc)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2000	\N	(0019,00bd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8239	\N	(0019,00bd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2001	\N	(0019,00be)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8240	\N	(0019,00be)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2002	\N	(0019,00bf)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8241	\N	(0019,00bf)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2003	\N	(0019,00c0)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8242	\N	(0019,00c0)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2004	\N	(0019,00c1)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8243	\N	(0019,00c1)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2005	\N	(0019,00c2)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8244	\N	(0019,00c2)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2006	\N	(0019,00c3)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8245	\N	(0019,00c3)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2007	\N	(0019,00c4)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8246	\N	(0019,00c4)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2008	\N	(0019,00c5)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8247	\N	(0019,00c5)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2009	\N	(0019,00c6)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8248	\N	(0019,00c6)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2010	\N	(0019,00c7)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8249	\N	(0019,00c7)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2011	\N	(0019,00c8)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8250	\N	(0019,00c8)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2012	\N	(0019,00c9)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8251	\N	(0019,00c9)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2013	\N	(0019,00ca)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8252	\N	(0019,00ca)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2014	\N	(0019,00cb)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8253	\N	(0019,00cb)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2015	\N	(0019,00cc)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8254	\N	(0019,00cc)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2016	\N	(0019,00cd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8255	\N	(0019,00cd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2017	\N	(0019,00ce)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8256	\N	(0019,00ce)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2018	\N	(0019,00cf)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8257	\N	(0019,00cf)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2019	\N	(0019,00d1)	US	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8258	\N	(0019,00d1)	US	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2020	\N	(0019,00d2)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8259	\N	(0019,00d2)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2021	\N	(0019,00d3)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8260	\N	(0019,00d3)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2022	\N	(0019,00d4)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8261	\N	(0019,00d4)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2023	\N	(0019,00d5)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8262	\N	(0019,00d5)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2024	\N	(0019,00d6)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8263	\N	(0019,00d6)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2025	\N	(0019,00d7)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8264	\N	(0019,00d7)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2026	\N	(0019,00d8)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8265	\N	(0019,00d8)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2027	\N	(0019,00d9)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8266	\N	(0019,00d9)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2028	\N	(0019,00da)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8267	\N	(0019,00da)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2029	\N	(0019,00db)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8268	\N	(0019,00db)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2030	\N	(0019,00dc)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8269	\N	(0019,00dc)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2031	\N	(0019,00dd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8270	\N	(0019,00dd)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2032	\N	(0019,00de)	UL	1-n	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8271	\N	(0019,00de)	UL	1-n	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2033	\N	(0019,00df)	OB	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8272	\N	(0019,00df)	OB	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	2034	\N	(0019,00e0)	UL	1	Unknown	Unknown	SIEMENS RA PLANE A	SSPI	\N	\N	\N
f	8273	\N	(0019,00e0)	UL	1	Unknown	Unknown	SIEMENS RA PLANE B	SSPI	\N	\N	\N
f	1821	\N	(0019,0015)	CS	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1822	\N	(0019,001f)	OB	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1823	\N	(0019,0020)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1824	\N	(0019,0022)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1825	\N	(0019,0024)	LO	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1826	\N	(0019,0026)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1827	\N	(0019,0028)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1829	\N	(0019,002c)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1828	\N	(0019,002a)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1830	\N	(0019,002e)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1831	\N	(0019,0030)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1833	\N	(0019,0034)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1836	\N	(0019,003a)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1837	\N	(0019,003c)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1838	\N	(0019,003e)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1832	\N	(0019,0032)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1839	\N	(0019,0040)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1840	\N	(0019,0042)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1841	\N	(0019,0044)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1842	\N	(0019,0046)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1843	\N	(0019,0048)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1844	\N	(0019,004a)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1845	\N	(0019,004c)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1846	\N	(0019,0050)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1847	\N	(0019,0052)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1848	\N	(0019,0054)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1849	\N	(0019,0056)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1850	\N	(0019,0058)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1851	\N	(0019,005a)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1852	\N	(0019,005c)	UN	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1853	\N	(0019,005e)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1854	\N	(0019,0060)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1855	\N	(0019,0062)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1856	\N	(0019,0064)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1857	\N	(0019,0066)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1858	\N	(0019,0068)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1859	\N	(0019,006a)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1860	\N	(0019,0070)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1861	\N	(0019,0072)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1862	\N	(0019,0074)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1863	\N	(0019,0076)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1864	\N	(0019,0078)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1865	\N	(0019,007a)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1866	\N	(0019,007c)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1867	\N	(0019,007e)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1868	\N	(0019,0080)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1869	\N	(0019,0082)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1870	\N	(0019,0084)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1871	\N	(0019,0086)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1872	\N	(0019,0088)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1873	\N	(0019,008a)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1874	\N	(0019,008c)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1875	\N	(0019,008e)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1876	\N	(0019,0092)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1878	\N	(0019,0096)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1879	\N	(0019,0098)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1880	\N	(0019,009a)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1881	\N	(0019,009c)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1882	\N	(0019,009e)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1877	\N	(0019,0094)	US	1-n	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1883	\N	(0019,00a2)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1884	\N	(0019,00a4)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1885	\N	(0019,00a5)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1886	\N	(0019,00a6)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1887	\N	(0019,00a7)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1888	\N	(0019,00a8)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1889	\N	(0019,00a9)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1890	\N	(0019,00aa)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1891	\N	(0019,00ab)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1892	\N	(0019,00ac)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1893	\N	(0019,00ad)	UL	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1894	\N	(0019,00ff)	OB	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1333	\N	(0019,0010)	IS	1	Net Frequency	NetFrequency	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1386	\N	(0019,0010)	IS	1	Distance Source To Source Side Collimator	DistanceSourceToSourceSideCollimator	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1430	\N	(0019,0010)	DS	1	Source Side Collimator Aperture	SourceSideCollimatorAperture	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1701	\N	(0019,0010)	DS	1	Total Measurement Time Nominal	TotalMeasurementTimeNominal	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1295	\N	(0019,0010)	LO	1	Parameter File Name	ParameterFileName	SIEMENS CM VA0  ACQU	SSPI	\N	\N	\N
f	1503	\N	(0019,0010)	LO	1	Measurement Mode	MeasurementMode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1387	\N	(0019,0011)	IS	1	Distance Source To Detector Side Collimator	DistanceSourceToDetectorSideCollimator	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1431	\N	(0019,0011)	DS	1	Detector Side Collimator Aperture	DetectorSideCollimatorAperture	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1702	\N	(0019,0011)	DS	1	Total Measurement Time Current	TotalMeasurementTimeCurrent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1296	\N	(0019,0011)	LO	1	Sequence File Name	SequenceFileName	SIEMENS CM VA0  ACQU	SSPI	\N	\N	\N
f	1504	\N	(0019,0011)	LO	1	Image Type	ImageType	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1656	\N	(0019,0012)	DS	1	Magnetic Field Strength	MagneticFieldStrength	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1703	\N	(0019,0012)	DS	1	Start Delay Time	StartDelayTime	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1297	\N	(0019,0012)	LO	1	Sequence File Owner	SequenceFileOwner	SIEMENS CM VA0  ACQU	SSPI	\N	\N	\N
f	1704	\N	(0019,0013)	DS	1	Dwell Time	DwellTime	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	8862	\N	(0031,0012)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1298	\N	(0019,0013)	LO	1	Sequence Description	SequenceDescription	SIEMENS CM VA0  ACQU	SSPI	\N	\N	\N
f	1657	\N	(0019,0014)	DS	1	ADC Voltage	ADCVoltage	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1705	\N	(0019,0014)	IS	1	Number of Phases	NumberOfPhases	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1299	\N	(0019,0014)	LO	1	EPI File Name	EPIFileName	SIEMENS CM VA0  ACQU	SSPI	\N	\N	\N
f	1505	\N	(0019,0015)	LO	1	Software Version	SoftwareVersion	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1658	\N	(0019,0016)	DS	2	ADC Offset	ADCOffset	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1706	\N	(0019,0016)	UL	2	Sequence Control Mask	SequenceControlMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1707	\N	(0019,0018)	UL	1	Measurement Status Mask	MeasurementStatusMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1432	\N	(0019,0020)	IS	1	Exposure Time	ExposureTime	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1659	\N	(0019,0020)	DS	1	Transmitter Amplitude	TransmitterAmplitude	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1388	\N	(0019,0020)	IS	1	Number of Possible Channels	NumberOfPossibleChannels	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1708	\N	(0019,0020)	IS	1	Number of Fourier Lines Nominal	NumberOfFourierLinesNominal	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1334	\N	(0019,0020)	CS	1	Measurement Mode	MeasurementMode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1506	\N	(0019,0020)	LO	1	MPM Code	MPMCode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1433	\N	(0019,0021)	IS	1	Exposure Current	ExposureCurrent	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1389	\N	(0019,0021)	IS	1	Mean Channel Number	MeanChannelNumber	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1660	\N	(0019,0021)	IS	1	Number of Transmitter Amplitudes	NumberOfTransmitterAmplitudes	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1709	\N	(0019,0021)	IS	1	Number of Fourier Lines Current	NumberOfFourierLinesCurrent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1507	\N	(0019,0021)	LO	1	Latitude	Latitude	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1390	\N	(0019,0022)	DS	1	Detector Spacing	DetectorSpacing	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1661	\N	(0019,0022)	DS	1	Transmitter Attenuator	TransmitterAttenuator	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1508	\N	(0019,0022)	LO	1	Sensitivity	Sensitivity	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1391	\N	(0019,0023)	DS	1	Detector Center	DetectorCenter	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1509	\N	(0019,0023)	LO	1	EDR	EDR	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1392	\N	(0019,0024)	DS	1	Reading Integration Time	ReadingIntegrationTime	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1662	\N	(0019,0024)	DS	1	Transmitter Calibration	TransmitterCalibration	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1510	\N	(0019,0024)	LO	1	L Fix	LFix	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1434	\N	(0019,0025)	DS	1	KVP Generator Power Current	KVPGeneratorPowerCurrent	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1511	\N	(0019,0025)	LO	1	S Fix	SFix	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1435	\N	(0019,0026)	DS	1	Generator Voltage	GeneratorVoltage	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1663	\N	(0019,0026)	DS	1	Transmitter Reference	TransmitterReference	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1710	\N	(0019,0026)	IS	1	Number of Fourier Lines after Zero	NumberOfFourierLinesAfterZero	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1512	\N	(0019,0026)	LO	1	Preset Mode	PresetMode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1513	\N	(0019,0027)	LO	1	Region	Region	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1711	\N	(0019,0028)	IS	1	First Measured Fourier Line	FirstMeasuredFourierLine	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1514	\N	(0019,0028)	LO	1	Subregion	Subregion	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1712	\N	(0019,0030)	IS	1	Acquisition Columns	AcquisitionColumns	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1335	\N	(0019,0030)	CS	1	Calculation Mode	CalculationMode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1515	\N	(0019,0030)	LO	1	Orientation	Orientation	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1713	\N	(0019,0031)	IS	1	Reconstruction Columns	ReconstructionColumns	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1516	\N	(0019,0031)	LO	1	Mark On Film	MarkOnFilm	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1517	\N	(0019,0032)	LO	1	Rotation On DRC	RotationOnDRC	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1714	\N	(0019,0040)	IS	1	Array Coil Element Number	ArrayCoilElementNumber	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1436	\N	(0019,0040)	UL	1	Master Control Mask	MasterControlMask	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1518	\N	(0019,0040)	LO	1	Reader Type	ReaderType	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1715	\N	(0019,0041)	UL	1	Array Coil Element Select Mask	ArrayCoilElementSelectMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1519	\N	(0019,0041)	LO	1	Sub Modality	SubModality	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1716	\N	(0019,0042)	UL	1	Array Coil Element Data Mask	ArrayCoilElementDataMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1437	\N	(0019,0042)	US	5	Processing Mask	ProcessingMask	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1520	\N	(0019,0042)	LO	1	Reader Serial Number	ReaderSerialNumber	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1717	\N	(0019,0043)	IS	1-n	Array Coil Element To ADC Connect	ArrayCoilElementToADCConnect	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1718	\N	(0019,0044)	DS	1-n	Array Coil Element Noise Level	ArrayCoilElementNoiseLevel	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1438	\N	(0019,0044)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1719	\N	(0019,0045)	IS	1	Array Coil ADC Pair Number	ArrayCoilADCPairNumber	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1439	\N	(0019,0045)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1720	\N	(0019,0046)	UL	1	Array Coil Combination Mask	ArrayCoilCombinationMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1393	\N	(0019,0050)	DS	1	Detector Alignment	DetectorAlignment	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1664	\N	(0019,0050)	DS	1	Receiver Total Gain	ReceiverTotalGain	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1336	\N	(0019,0050)	IS	1	Noise Level	NoiseLevel	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1721	\N	(0019,0050)	IS	1	Number of Averages Current	NumberOfAveragesCurrent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1521	\N	(0019,0050)	LO	1	Cassette Scale	CassetteScale	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1665	\N	(0019,0051)	DS	1	Receiver Amplifier Gain	ReceiverAmplifierGain	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1522	\N	(0019,0051)	LO	1	Cassette Matrix	CassetteMatrix	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1394	\N	(0019,0052)	DS	1	? 	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1666	\N	(0019,0052)	DS	1	Receiver Preamplifier Gain	ReceiverPreamplifierGain	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1523	\N	(0019,0052)	LO	1	Cassette Submatrix	CassetteSubmatrix	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1524	\N	(0019,0053)	LO	1	Barcode	Barcode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1395	\N	(0019,0054)	DS	1	? 	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1667	\N	(0019,0054)	DS	1	Receiver Cable Attenuation	ReceiverCableAttenuation	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1668	\N	(0019,0055)	DS	1	Receiver Reference Gain	ReceiverReferenceGain	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1669	\N	(0019,0056)	DS	1	Receiver Filter Frequency	ReceiverFilterFrequency	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1396	\N	(0019,0060)	DS	1	Focus Alignment	FocusAlignment	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1670	\N	(0019,0060)	DS	1	Reconstruction Scale Factor	ReconstructionScaleFactor	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1722	\N	(0019,0060)	DS	1	Flip Angle	FlipAngle	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1337	\N	(0019,0060)	IS	1	Number of Data Bytes	NumberOfDataBytes	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1525	\N	(0019,0060)	LO	1	GT - Contrast Type	ContrastType	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1526	\N	(0019,0061)	LO	1	GA - Rotation Amount	RotationAmount	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1671	\N	(0019,0062)	DS	1	Reference Scale Factor	ReferenceScaleFactor	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1440	\N	(0019,0062)	IS	1	Number of Virtuell Channels	NumberOfVirtuellChannels	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1527	\N	(0019,0062)	LO	1	GC - Rotation Center	RotationCenter	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1528	\N	(0019,0063)	LO	1	GS - Density Shift	DensityShift	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1529	\N	(0019,0064)	US	1	RN - Frequency Rank	FrequencyRank	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1397	\N	(0019,0065)	UL	1	Focal Spot Deflection Amplitude	FocalSpotDeflectionAmplitude	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1530	\N	(0019,0065)	LO	1	RE - Frequency Enhancement	FrequencyEnhancement	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1398	\N	(0019,0066)	UL	1	Focal Spot Deflection Phase	FocalSpotDeflectionPhase	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1531	\N	(0019,0066)	LO	1	RT - Frequency Type	FrequencyType	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1399	\N	(0019,0067)	UL	1	Focal Spot Deflection Offset	FocalSpotDeflectionOffset	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1532	\N	(0019,0067)	LO	1	Kernel Length	KernelLength	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1533	\N	(0019,0068)	UL	1	Kernel Mode	KernelMode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1534	\N	(0019,0069)	UL	1	Convolution Mode	ConvolutionMode	SIEMENS DLR.01	SSPI	\N	\N	\N
f	8274	\N	(0019,0070)	DS	1-n	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1400	\N	(0019,0070)	DS	1	Water Scaling Factor	WaterScalingFactor	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1672	\N	(0019,0070)	DS	1	Phase Gradient Amplitude	PhaseGradientAmplitude	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1441	\N	(0019,0070)	IS	1	Number of Readings	NumberOfReadings	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1723	\N	(0019,0070)	IS	1	Number of Prescans	NumberOfPrescans	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1535	\N	(0019,0070)	LO	1	PLA Source	PLASource	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1401	\N	(0019,0071)	DS	1	Interpolation Factor	InterpolationFactor	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1673	\N	(0019,0071)	DS	1	Readout Gradient Amplitude	ReadoutGradientAmplitude	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1442	\N	(0019,0071)	CS	1	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1536	\N	(0019,0071)	LO	1	PLA Destination	PLADestination	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1674	\N	(0019,0072)	DS	1	Selection Gradient Amplitude	SelectionGradientAmplitude	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1443	\N	(0019,0074)	IS	1	Number of Projections	NumberOfProjections	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1444	\N	(0019,0075)	IS	1	Number of Bytes	NumberOfBytes	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1537	\N	(0019,0075)	LO	1	UID Original Image	UIDOriginalImage	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1538	\N	(0019,0076)	LO	1	Unknown	Unknown	SIEMENS DLR.01	SPI	\N	\N	\N
f	8275	\N	(0019,0080)	LO	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1675	\N	(0019,0080)	DS	3	Gradient Delay Time	GradientDelayTime	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1445	\N	(0019,0080)	LO	1	Reconstruction Algorithm Set	ReconstructionAlgorithmSet	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1402	\N	(0019,0080)	CS	1	Patient Region	PatientRegion	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1539	\N	(0019,0080)	LT	1	Reader Header	ReaderHeader	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1446	\N	(0019,0081)	LO	1	Reconstruction Algorithm Index	ReconstructionAlgorithmIndex	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1724	\N	(0019,0081)	CS	1	Filter Type for Raw Data	FilterTypeForRawData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1676	\N	(0019,0082)	DS	1	Total Gradient Delay Time	TotalGradientDelayTime	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1725	\N	(0019,0082)	DS	1-n	Filter Parameter for Raw Data	FilterParameterForRawData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1403	\N	(0019,0082)	CS	1	Patient Phase of Life	PatientPhaseOfLife	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1447	\N	(0019,0082)	LO	1	Regeneration Software Version	RegenerationSoftwareVersion	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1726	\N	(0019,0083)	CS	1	Filter Type for Image Data	FilterTypeForImageData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1727	\N	(0019,0084)	DS	1-n	Filter Parameter for Image Data	FilterParameterForImageData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1728	\N	(0019,0085)	CS	1	Filter Type for Phase Correction	FilterTypeForPhaseCorrection	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1729	\N	(0019,0086)	DS	1-n	Filter Parameter for Phase Correction	FilterParameterForPhaseCorrection	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1730	\N	(0019,0087)	CS	1	Normalization Filter Type for Image Data	NormalizationFilterTypeForImageData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1448	\N	(0019,0088)	IS	1	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1731	\N	(0019,0088)	DS	1-n	Normalization Filter Parameter for Image Data	NormalizationFilterParameterForImageData	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1404	\N	(0019,0090)	DS	1	Osteo Offset	OsteoOffset	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1732	\N	(0019,0090)	IS	1	Number of Saturation Regions	NumberOfSaturationRegions	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1540	\N	(0019,0090)	LO	1	PLA of Secondary Destination	PLAOfSecondaryDestination	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1677	\N	(0019,0090)	LO	1	Sensitivity Correction Label	SensitivityCorrectionLabel	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8863	\N	(0031,0013)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1678	\N	(0019,0091)	DS	6	Saturation Phase Encoding Vector Coronal Component	SaturationPhaseEncodingVectorCoronalComponent	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1733	\N	(0019,0091)	DS	6	Saturation Phase Encoding Vector Sagittal Component	SaturationPhaseEncodingVectorSagittalComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1679	\N	(0019,0092)	DS	6	Saturation Readout Vector Coronal Component	SaturationReadoutVectorCoronalComponent	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1734	\N	(0019,0092)	DS	6	Saturation Readout Vector Sagittal Component	SaturationReadoutVectorSagittalComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1405	\N	(0019,0092)	DS	1	Osteo Regression Line Slope	OsteoRegressionLineSlope	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1406	\N	(0019,0093)	DS	1	Osteo Regression Line Intercept	OsteoRegressionLineIntercept	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1735	\N	(0019,0093)	IS	1	EPI Stimulation Monitor Mode	EPIStimulationMonitorMode	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	8276	\N	(0019,0093)	SL	2	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1407	\N	(0019,0094)	IS	1	Osteo Standardization Code	OsteoStandardizationCode	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1736	\N	(0019,0094)	DS	1	Image Rotation Angle	ImageRotationAngle	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1408	\N	(0019,0096)	IS	1	Osteo Phantom Number	OsteoPhantomNumber	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1737	\N	(0019,0096)	UL	3	Coil ID Mask	CoilIDMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1738	\N	(0019,0097)	UL	2	Coil Class Mask	CoilClassMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1739	\N	(0019,0098)	DS	3	Coil Position	CoilPosition	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1541	\N	(0019,00a0)	DS	1	Unknown	Unknown	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1740	\N	(0019,00a0)	DS	1	EPI Reconstruction Phase	EPIReconstructionPhase	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1680	\N	(0019,00a0)	IS	1	RF Watchdog Mask	RFWatchdogMask	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8277	\N	(0019,00a0)	DS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8278	\N	(0019,00a1)	DS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1542	\N	(0019,00a1)	DS	1	Unknown	Unknown	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1681	\N	(0019,00a1)	DS	1	EPI Reconstruction Slope	EPIReconstructionSlope	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1741	\N	(0019,00a1)	DS	1	EPI Reconstruction Slope	EPIReconstructionSlope	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	8279	\N	(0019,00a1)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8280	\N	(0019,00a2)	CS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1682	\N	(0019,00a2)	DS	1	RF Power Error Indicator	RFPowerErrorIndicator	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8281	\N	(0019,00a3)	CS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8282	\N	(0019,00a3)	SL	2	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8283	\N	(0019,00a4)	DS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8284	\N	(0019,00a5)	DS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1683	\N	(0019,00a5)	DS	3	Specific Absorption Rate Whole Body	SpecificAbsorptionRateWholeBody	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1684	\N	(0019,00a6)	DS	3	Specific Energy Dose	SpecificEnergyDose	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8285	\N	(0019,00a6)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8286	\N	(0019,00a7)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8287	\N	(0019,00a8)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8288	\N	(0019,00a9)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8289	\N	(0019,00aa)	CS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8290	\N	(0019,00ab)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8291	\N	(0019,00ac)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8292	\N	(0019,00ad)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8293	\N	(0019,00ae)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8294	\N	(0019,00af)	DS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8295	\N	(0019,00b0)	DS	1	Feed per Rotation	FeedPerRotation	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1685	\N	(0019,00b0)	UL	1	Adjustment Status Mask	AdjustmentStatusMask	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8296	\N	(0019,00bd)	IS	1	Pulmo Trigger Level	PulmoTriggerLevel	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8297	\N	(0019,00be)	DS	1	Expiratoric Reserve Volume	ExpiratoricReserveVolume	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8298	\N	(0019,00bf)	DS	1	Vital Capacity	VitalCapacity	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8299	\N	(0019,00c0)	DS	1	Pulmo Water	PulmoWater	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8300	\N	(0019,00c1)	DS	1	Pulmo Air	PulmoAir	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1686	\N	(0019,00c1)	DS	6	EPI Capacity	EPICapacity	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1687	\N	(0019,00c2)	DS	3	EPI Inductance	EPIInductance	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8301	\N	(0019,00c2)	DA	1	Pulmo Date	PulmoDate	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1688	\N	(0019,00c3)	IS	1-n	EPI Switch Configuration Code	EPISwitchConfigurationCode	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8302	\N	(0019,00c3)	TM	1	Pulmo Time	PulmoTime	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	8303	\N	(0019,00c3)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1689	\N	(0019,00c4)	IS	1-n	EPI Switch Hardware Code	EPISwitchHardwareCode	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8304	\N	(0019,00c4)	UL	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1690	\N	(0019,00c5)	DS	1-n	EPI Switch Delay Time	EPISwitchDelayTime	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8305	\N	(0019,00c5)	IS	1	Unknown	Unknown	SIEMENS CT VA0  COAD	SSPI	\N	\N	\N
f	1691	\N	(0019,00d1)	DS	1	Flow Sensitivity	FlowSensitivity	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1692	\N	(0019,00d2)	CS	1	Calculation Submode	CalculationSubmode	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1693	\N	(0019,00d3)	DS	1	Field of View Ratio	FieldOfViewRatio	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1694	\N	(0019,00d4)	IS	1	Base Raw Matrix Size	BaseRawMatrixSize	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1695	\N	(0019,00d5)	IS	1	2D Oversampling Lines	2DOversamplingLines	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1696	\N	(0019,00d6)	IS	1	3D Phase Oversampling Partitions	ThreeDPhaseOversamplingPartitions	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1697	\N	(0019,00d7)	IS	1	Echo Line Position	EchoLinePosition	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1698	\N	(0019,00d8)	IS	1	Echo Column Position	EchoColumnPosition	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1699	\N	(0019,00d9)	IS	1	Lines Per Segment	LinesPerSegment	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	1700	\N	(0019,00da)	CS	1	Phase Coding Direction	PhaseCodingDirection	SIEMENS MR VA0  COAD	SSPI	\N	\N	\N
f	8306	\N	(0019,0006)	IS	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8307	\N	(0019,0007)	IS	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8308	\N	(0019,0008)	IS	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8309	\N	(0019,0026)	LO	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8310	\N	(0019,0029)	LO	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8311	\N	(0019,0030)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8312	\N	(0019,0031)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8313	\N	(0019,0032)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8314	\N	(0019,0033)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8315	\N	(0019,0034)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	8316	\N	(0019,0035)	US	1	Unknown	Unknown	SIEMENS Selma	SSPI	\N	\N	\N
f	2201	\N	(0019,0000)	US	1	Review Mode	ReviewMode	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2202	\N	(0019,0001)	US	1	Anatomical Background Percent	AnatomicalBackgroundPercent	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2203	\N	(0019,0002)	US	1	Number of Phases	NumberOfPhases	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2204	\N	(0019,0003)	US	1	Apply Anatomical Background	ApplyAnatomicalBackground	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2205	\N	(0019,0004)	SS	4-4n	Pixel Shift Array	PixelShiftArray	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2206	\N	(0019,0005)	US	1	Brightness	Brightness	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2207	\N	(0019,0006)	US	1	Contrast	Contrast	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2208	\N	(0019,0007)	US	1	Enabled Shutters	EnabledShutters	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2209	\N	(0019,0008)	US	1	Native Edge Enhancement Percent Gain	NativeEdgeEnhancementPercentGain	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2210	\N	(0019,0009)	SS	1	Native Edge Enhancement LUT Index	NativeEdgeEnhancementLUTIndex	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8317	\N	(0019,000a)	SS	1	Native Edge Enhancement Kernel Size	NativeEdgeEnhancementKernelSize	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8318	\N	(0019,000b)	US	1	Subtracted Edge Enhancement Percent Gain	SubtractedEdgeEnhancementPercentGain	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8319	\N	(0019,000c)	SS	1	Subtracted Edge Enhancement LUT Index	SubtractedEdgeEnhancementLUTIndex	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8320	\N	(0019,000d)	SS	1	Subtracted Edge Enhancement Kernel Size	SubtractedEdgeEnhancementKernelSize	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8321	\N	(0019,000e)	US	1	Fade Percent	FadePercent	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8322	\N	(0019,000f)	US	1	Flipped Before Laterality Applied	FlippedBeforeLateralityApplied	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2217	\N	(0019,0010)	US	1	Apply Fade	ApplyFade	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8323	\N	(0019,0011)	US	1	Reference Images Taken Flag	ReferenceImagesTakenFlag	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2218	\N	(0019,0012)	US	1	Zoom	Zoom	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2219	\N	(0019,0013)	SS	1	Pan X	PanX	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2220	\N	(0019,0014)	SS	1	Pan Y	PanY	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2221	\N	(0019,0015)	SS	1	Native Edge Enhancement Adv Percent Gain	NativeEdgeEnhancementAdvPercentGain	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2222	\N	(0019,0016)	SS	1	Subtracted Edge Enhancement Adv Percent Gain	SubtractedEdgeEnhancementAdvPercentGain	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	2223	\N	(0019,0017)	US	1	Invert Flag	InvertFlag	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8324	\N	(0019,001a)	OB	1	Quant 1K Overlay	Quant1KOverlay	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8325	\N	(0019,001b)	US	1	Original Resolution	OriginalResolution	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8326	\N	(0019,001c)	DS	1	Auto Window Center	AutoWindowCenter	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8327	\N	(0019,001d)	DS	1	Auto Window Width	AutoWindowWidth	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8328	\N	(0019,001e)	IS	2	Auto Window Correct Value	AutoWindowCorrectValue	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8329	\N	(0019,001f)	DS	1	Sigmoid Window Parameter	SigmoidWindowParameter	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8330	\N	(0019,0041)	SL	2	Dispayed Area Top Left Hand Corner	DispayedAreaTopLeftHandCorner	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8331	\N	(0019,0042)	SL	2	Dispayed Area Bottom Right Hand Corner	DispayedAreaBottomRightHandCorner	SIEMENS SMS-AX  VIEW 1.0	SSPI	\N	\N	\N
f	8332	\N	(0019,0001)	DS	1	Unknown	Unknown	SIEMENS SIENET	SSPI	\N	\N	\N
f	8333	\N	(0019,0000)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8334	\N	(0019,0003)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8335	\N	(0019,000c)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8336	\N	(0019,000d)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8337	\N	(0019,000e)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8338	\N	(0019,0095)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8339	\N	(0019,0020)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8340	\N	(0019,0021)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8341	\N	(0019,0022)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8342	\N	(0019,0023)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8343	\N	(0019,0024)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8344	\N	(0019,0025)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8345	\N	(0019,0026)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8346	\N	(0019,0027)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8347	\N	(0019,0028)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8348	\N	(0019,0029)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8349	\N	(0019,002a)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8350	\N	(0019,002d)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8351	\N	(0019,002e)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8352	\N	(0019,0031)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8353	\N	(0019,003a)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8354	\N	(0019,003b)	LT	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8355	\N	(0019,0040)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8356	\N	(0019,0041)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8357	\N	(0019,0042)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8358	\N	(0019,0043)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8359	\N	(0019,0044)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8360	\N	(0019,0046)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8361	\N	(0019,0047)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8362	\N	(0019,0048)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8363	\N	(0019,0049)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8364	\N	(0019,0054)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8365	\N	(0019,0060)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8366	\N	(0019,0061)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8367	\N	(0019,0062)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8368	\N	(0019,0063)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8369	\N	(0019,0065)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8370	\N	(0019,0066)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8371	\N	(0019,0067)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8372	\N	(0019,0069)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8373	\N	(0019,006a)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8374	\N	(0019,006c)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8375	\N	(0019,0072)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8376	\N	(0019,0080)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8377	\N	(0019,0081)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8378	\N	(0019,0082)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8379	\N	(0019,0083)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8380	\N	(0019,0086)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8381	\N	(0019,0087)	SH	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8382	\N	(0019,0088)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8383	\N	(0019,00a0)	LT	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES	SSPI	\N	\N	\N
f	8384	\N	(0019,0020)	SH	1	Unknown	Unknown	Siemens Ultrasound Miscellaneous	SSPI	\N	\N	\N
f	8385	\N	(0019,0000)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8386	\N	(0019,0001)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8387	\N	(0019,0002)	LO	1	Total Dose Area Product uGy*cm*cm	TotalDoseAreaProduct	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8388	\N	(0019,0003)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8389	\N	(0019,0004)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8390	\N	(0019,0005)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8391	\N	(0019,0006)	FD	1	Table Object Distance	TableObjectDistance	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8392	\N	(0019,0007)	FD	1	Table Detector Distance	TableDetectorDistance	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8393	\N	(0019,0008)	US	1-n	Ortho Step Distance	OrthoStepDistance	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8394	\N	(0019,0000)	SH	1	Private Creator Version	PrivateCreatorVersion	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8395	\N	(0019,0003)	FD	1	Frame Rate	FrameRate	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8396	\N	(0019,000c)	US	1	Burned in Graphics	BurnedInGraphics	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8397	\N	(0019,000d)	SH	1	SieClear Index	SieClearIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8398	\N	(0019,000e)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8399	\N	(0019,0020)	SH	1	B-Mode Submode	BModeSubmode	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8400	\N	(0019,0021)	FD	1	B-Mode Dynamic Range	BModeDynamicRange	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8401	\N	(0019,0022)	FD	1	B-Mode Overall Gain	BModeOverallGain	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8402	\N	(0019,0023)	US	1	B-Mode Resolution/Speed Index	BModeResolutionSpeedIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8403	\N	(0019,0024)	US	1	B-Mode Edge Enhance Index	BModeEdgeEnhanceIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8404	\N	(0019,0025)	US	1	B-Mode Persistence Index	BModePersistenceIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8405	\N	(0019,0026)	US	1	B-Mode Map Index	BModeMapIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8406	\N	(0019,0027)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8407	\N	(0019,0028)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8408	\N	(0019,0029)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8409	\N	(0019,002a)	US	1	B-Mode Tint Type	BModeTintType	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8410	\N	(0019,002d)	US	1	B-Mode Tint Index	BModeTintIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8411	\N	(0019,002e)	SH	1	ClarifyVE Index	ClarifyVEIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8412	\N	(0019,0030)	DS	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8413	\N	(0019,0031)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8414	\N	(0019,003a)	US	1	Image Flag	ImageFlag	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8415	\N	(0019,003b)	LT	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8416	\N	(0019,0040)	SH	1	Color Flow State	ColorFlowState	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8417	\N	(0019,0041)	US	1	Color Flow Wall Filter Index	ColorFlowWallFilterIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8418	\N	(0019,0042)	SH	1	Color Flow Submode	ColorFlowSubmode	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8419	\N	(0019,0043)	FD	1	Color Flow Overall Gain	ColorFlowOverallGain	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8420	\N	(0019,0044)	US	1	Color Flow Resolution/Speed Index	ColorFlowResolutionSpeedIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8421	\N	(0019,0046)	US	1	Color Flow Smooth Index	ColorFlowSmoothIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8422	\N	(0019,0047)	US	1	Color Flow Persistence Index	ColorFlowPersistenceIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8423	\N	(0019,0048)	US	1	Color Flow Map Index	ColorFlowMapIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8424	\N	(0019,0049)	US	1	Color Flow Priority Index	ColorFlowPriorityIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8425	\N	(0019,0054)	FD	1	Color Flow Maximum Velocity	ColorFlowMaximumVelocity	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8426	\N	(0019,0060)	FD	1	Doppler Dynamic Range	DopplerDynamicRange	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8427	\N	(0019,0061)	FD	1	Doppler Overall Gain	DopplerOverallGain	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8428	\N	(0019,0062)	FD	1	Doppler Wall Filter	DopplerWallFilter	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8429	\N	(0019,0063)	FD	1	Doppler Gate Size	DopplerGateSize	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8430	\N	(0019,0065)	US	1	Doppler Map Index	DopplerMapIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8431	\N	(0019,0066)	SH	1	Doppler Submode	DopplerSubmode	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8432	\N	(0019,0067)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8433	\N	(0019,0069)	US	1	Doppler Time/Freq Res Index	DopplerTimeFreqResIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8434	\N	(0019,006a)	US	1	Doppler Trace Inverted	DopplerTraceInverted	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8435	\N	(0019,006c)	US	1	Doppler Tint Type	DopplerTintType	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8436	\N	(0019,0072)	US	1	Doppler Tint Index	DopplerTintIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8437	\N	(0019,0080)	US	1	M-Mode Dynamic Range	MModeDynamicRange	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8438	\N	(0019,0081)	US	1	M-Mode Overall Gain	MModeOverallGain	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8439	\N	(0019,0082)	US	1	M-Mode Edge Enhance Index	MModeEdgeEnhanceIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8440	\N	(0019,0083)	US	1	M-Mode Map Index	MModeMapIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8441	\N	(0019,0086)	US	1	M-Mode Tint Type	MModeTintType	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8442	\N	(0019,0087)	SH	1	M-Mode Submode	MModeSubmode	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8443	\N	(0019,0088)	US	1	M-Mode Tint Index	MModeTintIndex	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8444	\N	(0019,0095)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000	SSPI	\N	\N	\N
f	8445	\N	(0021,0000)	OB	1	ECAT_Main_Header	ECATMainHeader	SIEMENS MED NM	SSPI	\N	\N	\N
f	8446	\N	(0021,0001)	OB	1	ECAT_Image_Subheader	ECATImageSubheader	SIEMENS MED NM	SSPI	\N	\N	\N
f	8447	\N	(0021,0000)	OB	1	ECAT_Main_Header	ECATMainHeader	SIEMENS MED ECAT FILE INFO	SSPI	\N	\N	\N
f	8448	\N	(0021,0001)	OB	1	ECAT_Image_Subheader	ECATImageSubheader	SIEMENS MED ECAT FILE INFO	SSPI	\N	\N	\N
f	2132	\N	(0021,0000)	US	1	Acquisition Type	AcquisitionType	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2133	\N	(0021,0001)	US	1	Acquisition Mode	AcquisitionMode	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2134	\N	(0021,0002)	US	1	Footswitch Index	FootswitchIndex	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2135	\N	(0021,0003)	US	1	Acquisition Room	AcquisitionRoom	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2136	\N	(0021,0004)	SL	1	Current Time Product	CurrentTimeProduct	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2137	\N	(0021,0005)	SL	1	Imager Receptor Dose	ImagerReceptorDose	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2138	\N	(0021,0006)	SL	1	Skin Dose Percent	SkinDosePercent	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2139	\N	(0021,0007)	SL	1	Skin Dose Accumulation	SkinDoseAccumulation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2140	\N	(0021,0008)	SL	1	Skin Dose Rate	SkinDoseRate	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8449	\N	(0021,0009)	UL	1	Impac Filename	ImpacFilename	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8450	\N	(0021,000a)	UL	1	Copper Filter	CopperFilter	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8451	\N	(0021,000b)	US	1	Measuring Field	MeasuringField	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8452	\N	(0021,000c)	SS	3	Post Blanking Circle	PostBlankingCircle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8453	\N	(0021,000d)	SS	2-2n	Dyna Angles	DynaAngles	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8454	\N	(0021,000e)	SS	1	Total Steps	TotalSteps	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8455	\N	(0021,000f)	SL	4-n	Dyna X-Ray Info	DynaXRayInfo	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2147	\N	(0021,0010)	US	1	Modality LUT Input Gamma	ModalityLUTInputGamma	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2148	\N	(0021,0011)	US	1	Modality LUT Output Gamma	ModalityLUTOutputGamma	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2149	\N	(0021,0012)	OB	1	SH_STPAR	SHSTPAR	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2150	\N	(0021,0013)	US	1	Acquisition Zoom	AcquisitionZoom	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2151	\N	(0021,0014)	SS	1	Dyna Angulation Step	DynaAngulationStep	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2152	\N	(0021,0015)	US	1	DDO Value	DDOValue	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2153	\N	(0021,0016)	US	1	DR Single Flag	DRSingleFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2154	\N	(0021,0017)	SL	1	Source to Isocenter	SourcetoIsocenter	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2155	\N	(0021,0018)	US	1	Pressure Data	PressureData	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2156	\N	(0021,0019)	SL	1	ECG Index Array	ECGIndexArray	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8456	\N	(0021,001a)	US	1	FD Flag	FDFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8457	\N	(0021,001b)	OB	1	SH_ZOOM	SHZOOM	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8458	\N	(0021,001c)	OB	1	SH_COLPAR	SHCOLPAR	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8459	\N	(0021,001d)	US	1	K-Factor	KFactor	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8460	\N	(0021,001e)	US	8	EVE	EVE	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8461	\N	(0021,001f)	SL	1	Total Scene Time	TotalSceneTime	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8864	\N	(0031,0014)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	2163	\N	(0021,0020)	US	1	Restore Flag	RestoreFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2164	\N	(0021,0021)	US	1	Stand Movement Flag	StandMovementFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2165	\N	(0021,0022)	US	1	FD Rows	FDRows	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2166	\N	(0021,0023)	US	1	FD Columns	FDColumns	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2167	\N	(0021,0024)	US	1	Table Movement Flag	TableMovementFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	2169	\N	(0021,0026)	DS	1	Crispy XPI Filter Value	CrispyXPIFilterValue	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8462	\N	(0021,0027)	US	1	IC Stent Flag	ICStentFlag	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8463	\N	(0021,0028)	SQ	1	Gamma LUT Sequence	GammaLUTSequence	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8464	\N	(0021,0029)	DS	1	Acquisition Scene Time	AcquisitionSceneTime	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8465	\N	(0021,002a)	IS	1	3D Cardiac Phase Center	ThreeDCardiacPhaseCenter	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8466	\N	(0021,002b)	IS	1	3D Cardiac Phase Width	ThreeDCardiacPhaseWidth	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8467	\N	(0021,0030)	OB	1	Organ Program Info	OrganProgramInfo	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8468	\N	(0021,003a)	IS	1	DDO Kernel size	DDOKernelsize	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8469	\N	(0021,003b)	IS	1	mAs Modulation	mAsModulation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8470	\N	(0021,003c)	DT	1-n	3D R-Peak Reference Time	ThreeDRPeakReferenceTime	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8471	\N	(0021,003d)	SL	1-n	ECG Frame Time Vector	ECGFrameTimeVector	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8472	\N	(0021,003e)	SL	1	ECG Start Time of Run	ECGStartTimeOfRun	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8473	\N	(0021,0040)	US	3	Gamma LUT Descriptor	GammaLUTDescriptor	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8474	\N	(0021,0041)	LO	1	Gamma LUT Type	GammaLUTType	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8475	\N	(0021,0042)	US	1-n	Gamma LUT Data	GammaLUTData	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8476	\N	(0021,0043)	US	1	Global Gain	GlobalGain	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8477	\N	(0021,0044)	US	1	Global Offset	GlobalOffset	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8478	\N	(0021,0045)	US	1	DIPP Mode	DIPPMode	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8479	\N	(0021,0046)	US	1	Artis System Type	ArtisSystemType	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8480	\N	(0021,0047)	US	1	Artis Table Type	ArtisTableType	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8481	\N	(0021,0048)	US	1	Artis Table Top Type	ArtisTableTopType	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8482	\N	(0021,0049)	US	1	Water Value	WaterValue	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8483	\N	(0021,0051)	DS	1	3D Positioner Primary Start Angle	ThreeDPositionerPrimaryStartAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8484	\N	(0021,0052)	DS	1	3D Positioner Secondary Start Angle	ThreeDPositionerSecondaryStartAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8485	\N	(0021,0053)	SS	3	Stand Position	StandPosition	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8486	\N	(0021,0054)	SS	1	Rotation Angle	RotationAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8487	\N	(0021,0055)	US	1	Image Rotation	ImageRotation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8488	\N	(0021,0056)	SS	3	Table Coordinates	TableCoordinates	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8489	\N	(0021,0057)	SS	3	Isocenter Table Position	IsocenterTablePosition	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8490	\N	(0021,0058)	DS	1	Table Object Distance	TableObjectDistance	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8491	\N	(0021,0059)	FL	12-n	Carm Coordinate System	CarmCoordinateSystem	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8492	\N	(0021,005a)	FL	6-n	Robot Axes	RobotAxes	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8493	\N	(0021,005b)	FL	12	Table Coordinate System	TableCoordinateSystem	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8494	\N	(0021,005c)	FL	12	Patient Coordinate System	PatientCoordinateSystem	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8495	\N	(0021,005d)	SS	1-n	Angulation	Angulation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8496	\N	(0021,005e)	SS	1-n	Orbital	Orbital	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8497	\N	(0021,0061)	SS	1	Large Volume Overlap	LargeVolumeOverlap	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8498	\N	(0021,0062)	US	1	Reconstruction Preset	ReconstructionPreset	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8499	\N	(0021,0063)	SS	1	3D Start Angle	ThreeDStartAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8500	\N	(0021,0064)	SL	1	3D Planned Angle	ThreeDPlannedAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8501	\N	(0021,0065)	SL	1	3D Rotation Plane Alpha	ThreeDRotationPlaneAlpha	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8502	\N	(0021,0066)	SL	1	3D Rotation Plane Beta	ThreeDRotationPlaneBeta	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8503	\N	(0021,0067)	SL	1	3D First Image Angle	ThreeDFirstImageAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8504	\N	(0021,0068)	SS	1-n	3D Trigger Angle	ThreeDTriggerAngle	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8505	\N	(0021,0071)	DS	1-n	Detector Rotation	DetectorRotation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8506	\N	(0021,0072)	SS	1-n	Physical Detector Rotation	PhysicalDetectorRotation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8507	\N	(0021,0081)	SS	1	Table Tilt	TableTilt	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8508	\N	(0021,0082)	SS	1	Table Rotation	TableRotation	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8509	\N	(0021,0083)	SS	1	Table Cradle Tilt	TableCradleTilt	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8510	\N	(0021,00a0)	OB	1	Crispy1 Container	Crispy1Container	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8511	\N	(0021,00a3)	SQ	1	3D Cardiac Trigger Sequence	ThreeDCardiacTriggerSequence	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8512	\N	(0021,00a4)	DT	1	3D Frame Reference Date Time	ThreeDFrameReferenceDateTime	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8513	\N	(0021,00a5)	FD	1	3D Cardiac Trigger Delay Time	ThreeDCardiacTriggerDelayTime	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8514	\N	(0021,00a6)	FD	1	3D R-R Interval Time Measured	ThreeDRRIntervalTimeMeasured	SIEMENS SMS-AX  ACQ 1.0	SSPI	\N	\N	\N
f	8515	\N	(0021,0000)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8516	\N	(0021,0001)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8517	\N	(0021,0002)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8518	\N	(0021,0003)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8519	\N	(0021,0004)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8520	\N	(0021,0005)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8521	\N	(0021,0006)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8522	\N	(0021,0007)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8523	\N	(0021,0008)	US	1	Auto Window Flag	AutoWindowFlag	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8524	\N	(0021,0009)	SL	1	Auto Window Center	AutoWindowCenter	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8525	\N	(0021,000a)	SL	1	Auto Window Width	AutoWindowWidth	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8526	\N	(0021,000b)	SS	1	Filter ID	FilterID	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8527	\N	(0021,000c)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8528	\N	(0021,000d)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8529	\N	(0021,000e)	US	1	Dose Control Value	DoseControlValue	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8530	\N	(0021,000f)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8531	\N	(0021,0010)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8532	\N	(0021,0011)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8533	\N	(0021,0012)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8534	\N	(0021,0013)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8535	\N	(0021,0014)	US	1	Anatomic Correct View	AnatomicCorrectView	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8536	\N	(0021,0015)	SS	1	Auto Window Shift	AutoWindowShift	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8537	\N	(0021,0016)	DS	1	Auto Window Expansion	AutoWindowExpansion	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8538	\N	(0021,0017)	LO	1	System Type	SystemType	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8539	\N	(0021,0018)	LO	1	Detector Type	DetectorType	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8540	\N	(0021,0030)	US	1	Anatomic Sort Number	AnatomicSortNumber	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	8541	\N	(0021,0031)	US	1	Acquisition Sort Number	AcquisitionSortNumber	Siemens: Thorax/Multix FD Post Processing	SSPI	\N	\N	\N
f	1895	\N	(0021,0015)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1896	\N	(0021,0020)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1897	\N	(0021,0025)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1898	\N	(0021,0027)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1899	\N	(0021,0028)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1900	\N	(0021,0030)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1901	\N	(0021,0040)	US	1	Unknown	Unknown	SIEMENS RA GEN	SSPI	\N	\N	\N
f	1782	\N	(0021,0000)	CS	1	Sequence Type	SequenceType	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1783	\N	(0021,0001)	IS	1	Vector Size Original	VectorSizeOriginal	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1784	\N	(0021,0002)	IS	1	Vector Size Extended	VectorSizeExtended	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1785	\N	(0021,0003)	DS	1	Acquired Spectral Range	AcquiredSpectralRange	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1786	\N	(0021,0004)	DS	3	VOI Position	VOIPosition	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1787	\N	(0021,0005)	DS	3	VOI Size	VOISize	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1788	\N	(0021,0006)	IS	3	CSI Matrix Size Original	CSIMatrixSizeOriginal	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1789	\N	(0021,0007)	IS	3	CSI Matrix Size Extended	CSIMatrixSizeExtended	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1790	\N	(0021,0008)	DS	3	Spatial Grid Shift	SpatialGridShift	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1791	\N	(0021,0009)	DS	1	Signal Limits Minimum	SignalLimitsMinimum	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1625	\N	(0021,0010)	DS	1	Zoom	Zoom	SIEMENS MED	SSPI	\N	\N	\N
f	1792	\N	(0021,0010)	DS	1	Signal Limits Maximum	SignalLimitsMaximum	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1449	\N	(0021,0010)	IS	1	Rotation Angle	RotationAngle	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1492	\N	(0021,0010)	UL	2	Creation Mask	CreationMask	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	8542	\N	(0021,0010)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1793	\N	(0021,0011)	DS	1	Spec Info Mask	SpecInfoMask	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1626	\N	(0021,0011)	DS	2	Target	Target	SIEMENS MED	SSPI	\N	\N	\N
f	1450	\N	(0021,0011)	IS	1	Start Angle	StartAngle	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1794	\N	(0021,0012)	DS	1	EPI Time Rate of Change of Magnitude	EPITimeRateOfChangeOfMagnitude	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1627	\N	(0021,0012)	IS	1	Tube Angle	TubeAngle	SIEMENS MED	SSPI	\N	\N	\N
f	1795	\N	(0021,0013)	DS	1	EPI Time Rate of Change of X Component	EPITimeRateOfChangeOfXComponent	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1796	\N	(0021,0014)	DS	1	EPI Time Rate of Change of Y Component	EPITimeRateOfChangeOfYComponent	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1797	\N	(0021,0015)	DS	1	EPI Time Rate of Change of Z Component	EPITimeRateOfChangeOfZComponent	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1798	\N	(0021,0016)	DS	1	EPI Time Rate of Change Legal Limit 1	EPITimeRateOfChangeLegalLimit1	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1799	\N	(0021,0017)	IS	1	EPI Operation Mode Flag	EPIOperationModeFlag	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1800	\N	(0021,0018)	DS	1	EPI Field Calculation Safety Factor	EPIFieldCalculationSafetyFactor	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1801	\N	(0021,0019)	DS	1	EPI Legal Limit 1 of Change Value	EPILegalLimit1OfChangeValue	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1802	\N	(0021,0020)	DS	1	EPI Legal Limit 2 of Change Value	EPILegalLimit2OfChangeValue	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1338	\N	(0021,0020)	DS	2	FoV	FoV	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1742	\N	(0021,0020)	IS	1	Phase Correction Rows Sequence	PhaseCorrectionRowsSequence	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1493	\N	(0021,0020)	UL	2	Evaluation Mask	EvaluationMask	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1628	\N	(0021,0020)	US	1	ROI Mask	ROIMask	SIEMENS MED	SSPI	\N	\N	\N
f	1451	\N	(0021,0020)	IS	1-n	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1803	\N	(0021,0021)	DS	1	EPI Rise Time	EPIRiseTime	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1743	\N	(0021,0021)	IS	1	Phase Correction Columns Sequence	PhaseCorrectionColumnsSequence	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1339	\N	(0021,0022)	DS	1	Image Magnification Factor	ImageMagnificationFactor	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1744	\N	(0021,0022)	IS	1	Phase Correction Rows Reconstruction	PhaseCorrectionRowsReconstruction	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1340	\N	(0021,0024)	DS	2	Image Scroll Offset	ImageScrollOffset	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1745	\N	(0021,0024)	IS	1	Phase Correction Columns Reconstruction	PhaseCorrectionColumnsReconstruction	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1341	\N	(0021,0026)	IS	1	Image Pixel Offset	ImagePixelOffset	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1804	\N	(0021,0030)	DS	16	Array Coil ADC Offset	ArrayCoilADCOffset	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1452	\N	(0021,0030)	IS	1	Topogram Tube Position	TopogramTubePosition	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1746	\N	(0021,0030)	IS	1	Number of 3D Raw Partitions Nominal	NumberOf3DRawPartitionsNominal	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1342	\N	(0021,0030)	CS	1	View Direction	ViewDirection	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1494	\N	(0021,0030)	US	7	Extended Processing Mask	ExtendedProcessingMask	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1805	\N	(0021,0031)	DS	16	Array Coil Preamplifier Gain	ArrayCoilPreamplifierGain	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1747	\N	(0021,0031)	IS	1	Number of 3D Raw Partitions Current	NumberOf3DRawPartitionsCurrent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1343	\N	(0021,0032)	CS	1	Patient Rest Direction	PatientRestDirection	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1453	\N	(0021,0032)	DS	1	Length of Topogram	LengthOfTopogram	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1454	\N	(0021,0034)	DS	1	Topogram Correction Factor	TopogramCorrectionFactor	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1748	\N	(0021,0034)	IS	1	Number of 3D Image Partitions	NumberOf3DImagePartitions	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1455	\N	(0021,0036)	DS	1	Maximum Table Position	MaximumTablePosition	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1749	\N	(0021,0036)	IS	1	Actual 3D Image Partition Number	Actual3DImagePartitionNumber	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1750	\N	(0021,0039)	DS	1	Slab Thickness	SlabThickness	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1456	\N	(0021,0040)	IS	1	Table Move Direction Code	TableMoveDirectionCode	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1751	\N	(0021,0040)	IS	1	Number of Slices Nominal	NumberOfSlicesNominal	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1495	\N	(0021,0040)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1752	\N	(0021,0041)	IS	1	Number of Slices Current	NumberOfSlicesCurrent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1496	\N	(0021,0041)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1753	\N	(0021,0042)	IS	1	Current Slice Number	CurrentSliceNumber	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1497	\N	(0021,0042)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1754	\N	(0021,0043)	IS	1	Current Group Number	CurrentGroupNumber	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1498	\N	(0021,0043)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1755	\N	(0021,0044)	DS	1	Current Slice Distance Factor	CurrentSliceDistanceFactor	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1499	\N	(0021,0044)	UL	1-n	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1457	\N	(0021,0045)	IS	1	VOI Start Row	VOIStartRow	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1756	\N	(0021,0045)	IS	1	MIP Start Row	MIPStartRow	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1458	\N	(0021,0046)	IS	1	VOI Stop Row	VOIStopRow	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1757	\N	(0021,0046)	IS	1	MIP Stop Row	MIPStopRow	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1459	\N	(0021,0047)	IS	1	VOI Start Column	VOIStartColumn	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1758	\N	(0021,0047)	IS	1	MIP Start Column	MIPStartColumn	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1460	\N	(0021,0048)	IS	1	VOI Stop Column	VOIStopColumn	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1759	\N	(0021,0048)	IS	1	MIP Stop Column	MIPStartColumn	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1461	\N	(0021,0049)	IS	1	VOI Start Slice	VOIStartSlice	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1760	\N	(0021,0049)	IS	1	MIP Start Slice	MIPStartSlice	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1462	\N	(0021,004a)	IS	1	VOI Stop Slice	VOIStopSlice	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1761	\N	(0021,004a)	IS	1	MIP Stop Slice	MIPStartSlice	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1762	\N	(0021,004f)	CS	1	Order of Slices	OrderofSlices	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1463	\N	(0021,0050)	IS	1	Vector Start Row	VectorStartRow	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1763	\N	(0021,0050)	UL	1-n	Signal Mask	SignalMask	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1500	\N	(0021,0050)	CS	1	Unknown	Unknown	SIEMENS CT VA0  RAW	SSPI	\N	\N	\N
f	1806	\N	(0021,0050)	LO	1	Saturation Type	SaturationType	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1807	\N	(0021,0051)	DS	3	Saturation Normal Vector	SaturationNormalVector	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1464	\N	(0021,0051)	IS	1	Vector Row Step	VectorRowStep	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1764	\N	(0021,0052)	IS	1	Delay After Trigger	DelayAfterTrigger	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1808	\N	(0021,0052)	DS	3	Saturation Position Vector	SaturationPositionVector	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1465	\N	(0021,0052)	IS	1	Vector Start Column	VectorStartColumn	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1809	\N	(0021,0053)	DS	6	Saturation Thickness	SaturationThickness	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1466	\N	(0021,0053)	IS	1	Vector Column Step	VectorColumnStep	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1765	\N	(0021,0053)	IS	1	RR Interval	RRInterval	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1766	\N	(0021,0054)	DS	1	Number of Trigger Pulses	NumberOfTriggerPulses	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1810	\N	(0021,0054)	DS	6	Saturation Width	SaturationWidth	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1811	\N	(0021,0055)	DS	6	Saturation Distance	SaturationDistance	SIEMENS MR VA0  RAW	SSPI	\N	\N	\N
f	1767	\N	(0021,0056)	DS	1	Repetition Time Effective	RepetitionTimeEffective	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1768	\N	(0021,0057)	LO	1	Gate Phase	GatePhase	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1769	\N	(0021,0058)	DS	1	Gate Threshold	GateThreshold	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	8865	\N	(0031,0015)	SL	1-n	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1770	\N	(0021,0059)	DS	1	Gated Ratio	GatedRatio	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1344	\N	(0021,0060)	DS	3	Image Position	ImagePosition	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1467	\N	(0021,0060)	IS	1	Range Type Code	RangeTypeCode	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1771	\N	(0021,0060)	IS	1	Number of Interpolated Images	NumberOfInterpolatedImages	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1345	\N	(0021,0061)	DS	3	Image Normal	ImageNormal	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1468	\N	(0021,0062)	IS	1	Reference Type Code	ReferenceTypeCode	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1346	\N	(0021,0063)	DS	1	Image Distance	ImageDistance	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1347	\N	(0021,0065)	US	1	Image Positioning History Mask	ImagePositioningHistoryMask	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1348	\N	(0021,006a)	DS	3	Image Row	ImageRow	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1349	\N	(0021,006b)	DS	3	Image Column	ImageColumn	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1469	\N	(0021,0070)	DS	3	Object Orientation	ObjectOrientation	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1772	\N	(0021,0070)	IS	1	Number of Echoes	NumberOfEchoes	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1350	\N	(0021,0070)	CS	3	Patient Orientation Set1	PatientOrientationSet1	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1351	\N	(0021,0071)	CS	3	Patient Orientation Set2	PatientOrientationSet2	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1773	\N	(0021,0072)	DS	1	Second Echo Time	SecondEchoTime	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1773	\N	(0021,0072)	DS	1	Second Repetition Time	SecondRepetitionTime	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1470	\N	(0021,0072)	DS	3	Light Orientation	LightOrientation	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1774	\N	(0021,0073)	DS	1	Second Repetition Time	SecondRepetitionTime	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1471	\N	(0021,0075)	DS	1	Light Brightness	LightBrightness	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1472	\N	(0021,0076)	DS	1	Light Contrast	LightContrast	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1473	\N	(0021,007a)	IS	2	Overlay Threshold	OverlayThreshold	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1474	\N	(0021,007b)	IS	2	Surface Threshold	SurfaceThreshold	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1475	\N	(0021,007c)	IS	2	Grey Scale Threshold	GreyScaleThreshold	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1775	\N	(0021,0080)	IS	1	Cardiac Code	CardiacCode	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1352	\N	(0021,0080)	LO	1	Study Name	StudyName	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1353	\N	(0021,0082)	SH	3	Study Type	StudyType	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1776	\N	(0021,0091)	DS	6	Saturation Phase Encoding Vector Transverse Component	SaturationPhaseEncodingVectorTransverseComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1777	\N	(0021,0092)	DS	6	Saturation Readout Vector Transverse Component	SaturationReadoutVectorTransverseComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1778	\N	(0021,0093)	DS	1	EPI Change Value of Magnitude	EPIChangeValueOfMagnitude	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1779	\N	(0021,0094)	DS	1	EPI Change Value of X Component	EPIChangeValueOfXComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1780	\N	(0021,0095)	DS	1	EPI Change Value of Y Component	EPIChangeValueOfYComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1781	\N	(0021,0096)	DS	1	EPI Change Value of Z Component	EPIChangeValueOfZComponent	SIEMENS MR VA0  GEN	SSPI	\N	\N	\N
f	1476	\N	(0021,00a0)	IS	1	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1477	\N	(0021,00a2)	CS	1	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	1478	\N	(0021,00a7)	LO	1	Unknown	Unknown	SIEMENS CT VA0  GEN	SSPI	\N	\N	\N
f	8543	\N	(0021,0008)	US	1	Auto Window Flag	AutoWindowFlag	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8544	\N	(0021,0009)	SL	1	Auto Window Center	AutoWindowCenter	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8545	\N	(0021,000a)	SL	1	Auto Window Width	AutoWindowWidth	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8546	\N	(0021,000b)	SS	1	Filter ID	FilterID	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8547	\N	(0021,0014)	US	1	Anatomic Correct View	AnatomicCorrectView	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8548	\N	(0021,0015)	SS	1	Auto Window Shift	AutoWindowShift	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8549	\N	(0021,0016)	DS	1	Auto Window Expansion	AutoWindowExpansion	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8550	\N	(0021,0017)	LO	1	System Type	SystemType	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8551	\N	(0021,0030)	SH	1	Anatomic Sort Number	AnatomicSortNumber	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8552	\N	(0021,0031)	SH	1	AcquisitionSortNumber	AcquisitionSortNumber	Siemens: Thorax/Multix FD Lab Settings	SSPI	\N	\N	\N
f	8553	\N	(0021,00a4)	OB	1	Unknown	Unknown	KINETDX_GRAPHICS	KDX	\N	\N	\N
f	8554	\N	(0021,00a6)	OB	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8555	\N	(0021,00a5)	US	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8556	\N	(0021,00a8)	LO	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8557	\N	(0021,00aa)	OB	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8558	\N	(0021,00ab)	LO	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8559	\N	(0021,00ac)	LO	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8560	\N	(0021,00b4)	LO	1	Unknown	Unknown	KINETDX	KDX	\N	\N	\N
f	8561	\N	(0021,00ae)	OB	1	Unknown	Unknown	syngoDynamics	SSPI	\N	\N	\N
f	8562	\N	(0021,00b0)	LO	1	Unknown	Unknown	syngoDynamics	SSPI	\N	\N	\N
f	8563	\N	(0021,00b1)	LO	1	Unknown	Unknown	syngoDynamics	SSPI	\N	\N	\N
f	8564	\N	(0023,0001)	US	1	DICOM Reader flag	DICOMReaderFlag	SIEMENS MED NM	SSPI	\N	\N	\N
f	8565	\N	(0023,0000)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Image Stamp	SSPI	\N	\N	\N
f	8566	\N	(0023,0001)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Image Stamp	SSPI	\N	\N	\N
f	8567	\N	(0023,0002)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Image Stamp	SSPI	\N	\N	\N
f	8568	\N	(0023,0003)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Image Stamp	SSPI	\N	\N	\N
f	8569	\N	(0023,0004)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Image Stamp	SSPI	\N	\N	\N
f	2192	\N	(0023,0000)	DS	2	Horizontal Calibration Pixel Size	HorizontalCalibrationPixelSize	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2193	\N	(0023,0001)	DS	2	Vertical Calibration Pixel Size	VerticalCalibrationPixelSize	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2194	\N	(0023,0002)	LO	1	Calibration Object	CalibrationObject	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2195	\N	(0023,0003)	DS	1	Calibration Object Size	CalibrationObjectSize	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2196	\N	(0023,0004)	LO	1	Calibration Method	CalibrationMethod	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2197	\N	(0023,0005)	ST	1	Filename	Filename	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2198	\N	(0023,0006)	IS	1	Frame Number	FrameNumber	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2199	\N	(0023,0007)	IS	2	Calibration Factor Multiplicity	CalibrationFactorMultiplicity	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2200	\N	(0023,0008)	IS	1	Calibration Table Object Distance	CalibrationTableObjectDistance	SIEMENS SMS-AX  QUANT 1.0	SSPI	\N	\N	\N
f	2170	\N	(0025,0000)	US	1	View Native	ViewNative	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2171	\N	(0025,0001)	US	1	Original Series Number	OriginalSeriesNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2172	\N	(0025,0002)	US	1	Original Image Number	OriginalImageNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2173	\N	(0025,0003)	US	1	Win Center	WinCenter	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2174	\N	(0025,0004)	US	1	Win Width	WinWidth	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2175	\N	(0025,0005)	US	1	Win Brightness	WinBrightness	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2176	\N	(0025,0006)	US	1	Win Contrast	WinContrast	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2177	\N	(0025,0007)	US	1	Original Frame Number	OriginalFrameNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2178	\N	(0025,0008)	US	1	Original Mask Frame Number	OriginalMaskFrameNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2179	\N	(0025,0009)	US	1	Opac	Opac	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8570	\N	(0025,000a)	US	1	Original Number of Frames	OriginalNumberofFrames	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8571	\N	(0025,000b)	DS	1	Original Scene Duration	OriginalSceneDuration	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8572	\N	(0025,000c)	LO	1	Identifier LOID	IdentifierLOID	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8573	\N	(0025,000d)	SS	1-n	Original Scene VFR Info	OriginalSceneVFRInfo	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8574	\N	(0025,000e)	SS	1	Original Frame ECG Position	OriginalFrameECGPosition	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8575	\N	(0025,000f)	SS	1	Original ECG 1st Frame Offset	OriginalECG1stFrameOffset	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2186	\N	(0025,0010)	SS	1	Zoom Flag	ZoomFlag	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2187	\N	(0025,0011)	US	1	Flexible Pixel Shift	FlexiblePixelShift	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2188	\N	(0025,0012)	US	1	Number of Mask Frames	NumberOfMaskFrames	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2189	\N	(0025,0013)	US	1	Number of Fill Frames	NumberOfFillFrames	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2190	\N	(0025,0014)	IS	1	Series Number	SeriesNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	2191	\N	(0025,0015)	IS	1	Image Number	ImageNumber	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8576	\N	(0025,0016)	IS	1	Ready Processing Status	ReadyProcessingStatus	SIEMENS SMS-AX  ORIGINAL IMAGE INFO 1.0	SSPI	\N	\N	\N
f	8577	\N	(0025,0000)	SS	1	Raw Image Amplification	RawImageAmplification	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8578	\N	(0025,0001)	SS	1	Gamma LUT	GammaLUT	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8579	\N	(0025,0002)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8580	\N	(0025,0003)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8581	\N	(0025,0004)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8582	\N	(0025,0005)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8583	\N	(0025,0006)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8584	\N	(0025,0007)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8585	\N	(0025,0008)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8586	\N	(0025,0009)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8587	\N	(0025,000a)	FL	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8588	\N	(0025,000b)	US	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8589	\N	(0025,000c)	SS	1	Harmonization Kernel	HarmonizationKernel	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8590	\N	(0025,000d)	FL	1	Harmonization Gain	HarmonizationGain	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8591	\N	(0025,000e)	SS	1	Edge Enhancement Kernel	EdgeEnhancementKernel	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8592	\N	(0025,000f)	FL	1	Edge Enhancement Gain	EdgeEnhancementGain	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8593	\N	(0025,0010)	LT	1	Internal Value	InternalValue	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8594	\N	(0025,0011)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8595	\N	(0025,0012)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8596	\N	(0025,0013)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8597	\N	(0025,0014)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8598	\N	(0025,0015)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8599	\N	(0025,0016)	SS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8600	\N	(0025,0017)	LO	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8601	\N	(0025,0018)	US	1	Auto Gain	AutoGain	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8602	\N	(0025,0019)	US	1	Ortho Subsampling	OrthoSubsampling	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8603	\N	(0025,001a)	US	2	Image Crop Upper Left	ImageCropUpperLeft	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8604	\N	(0025,001b)	US	2	Image Crop Upper Right	ImageCropUpperRight	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8866	\N	(0031,0016)	SL	1-n	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8605	\N	(0025,001c)	US	2	Image Crop Lower Left	ImageCropLowerLeft	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8606	\N	(0025,001d)	US	2	Image Crop Lower Right	ImageCropLowerRight	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8607	\N	(0025,0030)	US	1	Manual Cropping	ManualCropping	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8608	\N	(0025,0031)	SS	1	Gamma LUT Parameter 1	GammaLUTParameter1	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8609	\N	(0025,0032)	DS	1	Gamma LUT Parameter 2	GammaLUTParameter2	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8610	\N	(0025,0033)	SS	1	Gamma LUT Parameter 3	GammaLUTParameter3	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8611	\N	(0025,0034)	SS	1	Gamma LUT Parameter 4	GammaLUTParameter4	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8612	\N	(0025,0035)	LO	1	Gamma LUT Name	GammaLUTName	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8613	\N	(0025,0036)	DS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8614	\N	(0025,0037)	DS	1	Unknown	Unknown	Siemens: Thorax/Multix FD Raw Image Settings	SSPI	\N	\N	\N
f	8615	\N	(0027,0001)	CS	1	Business Unit Code	BusinessUnitCode	SIEMENS SYNGO ENHANCED IDATASET API	SSPI	\N	\N	\N
f	8616	\N	(0027,0002)	LO	1	Application Type	ApplicationType	SIEMENS SYNGO ENHANCED IDATASET API	SSPI	\N	\N	\N
f	8617	\N	(0027,0003)	SQ	1	Application Attributes Sequence	ApplicationAttributesSequence	SIEMENS SYNGO ENHANCED IDATASET API	SSPI	\N	\N	\N
f	8618	\N	(0029,0001)	LO	1	Data Reference	DataReference	SIEMENS SYNGO FUNCTION ASSIGNMENT	SSPI	\N	\N	\N
f	8619	\N	(0029,0002)	FD	1	Unknown	Unknown	SHS MagicView 300	SSPI	\N	\N	\N
f	8620	\N	(0029,0003)	FD	1	Unknown	Unknown	SHS MagicView 300	SSPI	\N	\N	\N
f	1587	\N	(0029,0004)	CS	1	Photometric Interpretation	PhotometricInterpretation	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1382	\N	(0029,0008)	CS	1	CSA Data Type	CSADataType	SIEMENS CSA NON-IMAGE	SSPI	\N	\N	\N
f	1376	\N	(0029,0008)	CS	1	CSA Image Header Type	CSAImageHeaderType	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1632	\N	(0029,0008)	CS	1	MedCom Header Type	MedComHeaderType	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1653	\N	(0029,0008)	CS	1	MedCom OOG Type	MedComOOGType	SIEMENS MEDCOM OOG	SSPI	\N	\N	\N
f	1383	\N	(0029,0009)	LO	1	CSA Data Version	CSADataVersion	SIEMENS CSA NON-IMAGE	SSPI	\N	\N	\N
f	1377	\N	(0029,0009)	LO	1	CSA Image Header Version	CSAImageHeaderVersion	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1654	\N	(0029,0009)	LO	1	MedCom OOG Version	MedComOOGVersion	SIEMENS MEDCOM OOG	SSPI	\N	\N	\N
f	1588	\N	(0029,0010)	US	1	Rows of Submatrix	RowsOfSubmatrix	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1600	\N	(0029,0010)	US	1	List of Group Numbers	ListOfGroupNumbers	SIEMENS MED HG	SSPI	\N	\N	\N
f	1608	\N	(0029,0010)	US	1	List of Group Numbers	ListOfGroupNumbers	SIEMENS MED MG	SSPI	\N	\N	\N
f	1354	\N	(0029,0010)	CS	1	Window Style	WindowStyle	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1384	\N	(0029,0010)	OB	1	CSA Data Info	CSADataInfo	SIEMENS CSA NON-IMAGE	SSPI	\N	\N	\N
f	1378	\N	(0029,0010)	OB	1	CSA Image Header Info	CSAImageHeaderInfo	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1655	\N	(0029,0010)	OB	1	MedCom OOG Info	MedComOOGInfo	SIEMENS MEDCOM OOG	SSPI	\N	\N	\N
f	1589	\N	(0029,0011)	US	1	Columns of Submatrix	ColumnsOfSubmatrix	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1355	\N	(0029,0011)	CS	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1356	\N	(0029,0013)	CS	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1601	\N	(0029,0015)	LO	1	List of Shadow Owner Codes	ListOfShadowOwnerCodes	SIEMENS MED HG	SSPI	\N	\N	\N
f	1609	\N	(0029,0015)	LO	1	List of Shadow Owner Codes	ListOfShadowOwnerCodes	SIEMENS MED MG	SSPI	\N	\N	\N
f	1379	\N	(0029,0018)	CS	1	CSA Series Header Type	CSASeriesHeaderType	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1380	\N	(0029,0019)	LO	1	CSA Series Header Version	CSASeriesHeaderVersion	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1602	\N	(0029,0020)	US	1	List of Element Numbers	ListOfElementNumbers	SIEMENS MED HG	SSPI	\N	\N	\N
f	1610	\N	(0029,0020)	US	1	List of Element Numbers	ListOfElementNumbers	SIEMENS MED MG	SSPI	\N	\N	\N
f	1357	\N	(0029,0020)	CS	3	Pixel Quality Code	PixelQualityCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1590	\N	(0029,0020)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1381	\N	(0029,0020)	OB	1	CSA Series Header Info	CSASeriesHeaderInfo	SIEMENS CSA HEADER	SSPI	\N	\N	\N
f	1591	\N	(0029,0021)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1358	\N	(0029,0022)	IS	3	Pixel Quality Value	PixelQualityValue	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1603	\N	(0029,0030)	US	1	List of Total Display Length	ListOfTotalDisplayLength	SIEMENS MED HG	SSPI	\N	\N	\N
f	1611	\N	(0029,0030)	US	1	List of Total Display Length	ListOfTotalDisplayLength	SIEMENS MED MG	SSPI	\N	\N	\N
f	112	\N	(0029,0031)	US	1-n	Unknown	Unknown	DIGISCAN IMAGE	SSPI	\N	\N	\N
f	113	\N	(0029,0032)	US	1-n	Unknown	Unknown	DIGISCAN IMAGE	SSPI	\N	\N	\N
f	114	\N	(0029,0033)	LO	1	Unknown	Unknown	DIGISCAN IMAGE	SSPI	\N	\N	\N
f	115	\N	(0029,0034)	LO	1	Unknown	Unknown	DIGISCAN IMAGE	SSPI	\N	\N	\N
f	1604	\N	(0029,0040)	LO	1-n	List of Display Prefix	ListOfDisplayPrefix	SIEMENS MED HG	SSPI	\N	\N	\N
f	1612	\N	(0029,0040)	LO	1-n	List of Display Prefix	ListOfDisplayPrefix	SIEMENS MED MG	SSPI	\N	\N	\N
f	1592	\N	(0029,0050)	US	1	Origin of Submatrix	OriginOfSubmatrix	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1359	\N	(0029,0050)	CS	1	Archive Code	ArchiveCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1605	\N	(0029,0050)	LO	1-n	List of Display Postfix	ListOfDisplayPostfix	SIEMENS MED HG	SSPI	\N	\N	\N
f	1613	\N	(0029,0050)	LO	1-n	List of Display Postfix	ListOfDisplayPostfix	SIEMENS MED MG	SSPI	\N	\N	\N
f	1360	\N	(0029,0051)	CS	1	Exposure Code	ExposureCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1361	\N	(0029,0052)	IS	1	Sort Code	SortCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1362	\N	(0029,0053)	CS	1	Unknown	Unknown	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1363	\N	(0029,0060)	LO	1	Splash	Splash	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1606	\N	(0029,0060)	US	1	List of Text Position	ListOfTextPosition	SIEMENS MED HG	SSPI	\N	\N	\N
f	1614	\N	(0029,0060)	US	1	List of Text Position	ListOfTextPosition	SIEMENS MED MG	SSPI	\N	\N	\N
f	2260	\N	(0029,0060)	LO	1	Compression Algorithm	CompressionAlgorithm	SPI	SSPI	\N	\N	\N
f	1607	\N	(0029,0070)	LO	1	List of Text Concatenation	ListOfTextConcatenation	SIEMENS MED HG	SSPI	\N	\N	\N
f	1615	\N	(0029,0070)	LO	1	List of Text Concatenation	ListOfTextConcatenation	SIEMENS MED MG	SSPI	\N	\N	\N
f	8621	\N	(0029,0080)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1593	\N	(0029,0099)	LO	1	Shutter Type	ShutterType	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1594	\N	(0029,00a0)	US	1	Rows of Rectangular Shutter	RowsOfRectangularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1595	\N	(0029,00a1)	US	1	Columns of Rectangular Shutter	ColumnsOfRectangularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1596	\N	(0029,00a2)	US	1	Origin of Rectangular Shutter	OriginOfRectangularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1597	\N	(0029,00b0)	US	1	Radius of Circular Shutter	RadiusOfCircularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1598	\N	(0029,00b2)	US	1	Origin of Circular Shutter	OriginOfCircularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	1599	\N	(0029,00c1)	US	1	Contour of Irregular Shutter	ContourOfIrregularShutter	SIEMENS MED DISPLAY	SSPI	\N	\N	\N
f	8622	\N	(0029,005a)	CS	1	Unknown	Unknown	SIEMENS MED MAMMO	SSPI	\N	\N	\N
f	8623	\N	(0029,0099)	CS	1	Unknown	Unknown	SIEMENS MED DISPLAY 0000	SSPI	\N	\N	\N
f	8624	\N	(0029,00c1)	US	1-n	Unknown	Unknown	SIEMENS MED DISPLAY 0000	SSPI	\N	\N	\N
f	8625	\N	(0029,00b0)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY 0000	SSPI	\N	\N	\N
f	8626	\N	(0029,00b2)	US	1-n	Unknown	Unknown	SIEMENS MED DISPLAY 0000	SSPI	\N	\N	\N
f	8627	\N	(0029,0099)	CS	1	Unknown	Unknown	SIEMENS MED DISPLAY 0001	SSPI	\N	\N	\N
f	8628	\N	(0029,00a0)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY 0001	SSPI	\N	\N	\N
f	8629	\N	(0029,00a1)	US	1	Unknown	Unknown	SIEMENS MED DISPLAY 0001	SSPI	\N	\N	\N
f	8630	\N	(0029,00a2)	US	1-n	Unknown	Unknown	SIEMENS MED DISPLAY 0001	SSPI	\N	\N	\N
f	1633	\N	(0029,0009)	LO	1	MedCom Header Version	MedComHeaderVersion	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1634	\N	(0029,0010)	OB	1	MedCom Header Info	MedComHeaderInfo	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1635	\N	(0029,0020)	OB	1	MedCom History Information	MedComHistoryInformation	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1636	\N	(0029,0031)	LO	1	PMTF Information 1	PMTFInformation1	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1637	\N	(0029,0032)	UL	1	PMTF Information 2	PMTFInformation2	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1638	\N	(0029,0033)	UL	1	PMTF Information 3	PMTFInformation3	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1639	\N	(0029,0034)	CS	1	PMTF Information 4	PMTFInformation4	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1640	\N	(0029,0035)	UL	1	PMTF Information 5	PMTFInformation5	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1641	\N	(0029,0040)	SQ	1	Application Header Sequence	ApplicationHeaderSequence	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1642	\N	(0029,0041)	CS	1	Application Header Type	ApplicationHeaderType	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1643	\N	(0029,0042)	LO	1	Application Header ID	ApplicationHeaderID	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1644	\N	(0029,0043)	LO	1	Application Header Version	ApplicationHeaderVersion	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1645	\N	(0029,0044)	OB	1	Application Header Info	ApplicationHeaderInfo	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1646	\N	(0029,0050)	LO	8	Workflow Control Flags	WorkflowControlFlags	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1647	\N	(0029,0051)	CS	1	Archive Management Flag Keep Online	ArchiveManagementFlagKeepOnline	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1648	\N	(0029,0052)	CS	1	Archive Management Flag Do Not Archive	ArchiveManagementFlagDoNotArchive	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1649	\N	(0029,0053)	CS	1	Image Location Status	ImageLocationStatus	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1650	\N	(0029,0054)	DS	1	Estimated Retrieve Time	EstimatedRetrieveTime	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1651	\N	(0029,0055)	DS	1	Data Size of Retrieved Images	DataSizeOfRetrievedImages	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8631	\N	(0029,0070)	SQ	1	Siemens Link Sequence	SiemensLinkSequence	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8632	\N	(0029,0071)	AT	1	Referenced Tag	ReferencedTag	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8633	\N	(0029,0072)	CS	1	Referenced Tag Type	ReferencedTagType	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8634	\N	(0029,0073)	UL	1	Referenced Value Length	ReferencedValueLength	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8635	\N	(0029,0074)	CS	1	Referenced Object Device Type	ReferencedObjectDeviceType	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8636	\N	(0029,0075)	OB	1	Referenced Object Device Location	ReferencedObjectDeviceLocation	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8637	\N	(0029,0076)	OB	1	Referenced Object ID	ReferencedObjectID	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	8638	\N	(0029,0077)	UL	1	Referenced Object Offset	ReferencedObjectOffset	SIEMENS MEDCOM HEADER	SSPI	\N	\N	\N
f	1652	\N	(0029,0060)	LO	1	Series Work Flow Status	SeriesWorkFlowStatus	SIEMENS MEDCOM HEADER2	SSPI	\N	\N	\N
f	8639	\N	(0029,0012)	US	1	Slices	Slices	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8640	\N	(0029,0014)	OB	1	Volume Histogram	VolumeHistogram	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8641	\N	(0029,0018)	IS	1	Volume Level	VolumeLevel	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8642	\N	(0029,0030)	DS	3	Voxel Spacing	VoxelSpacing	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8643	\N	(0029,0032)	DS	3	Volume Position (Patient)	VolumePositionPatient	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8644	\N	(0029,0037)	DS	9	Volume Orientation (Patient)	VolumeOrientationPatient	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8645	\N	(0029,0040)	CS	1	Resampling Flag	ResamplingFlag	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8646	\N	(0029,0042)	CS	1	Normalization Flag	NormalizationFlag	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8647	\N	(0029,0044)	SQ	1	SubVolume Sequence	SubVolumeSequence	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8648	\N	(0029,0046)	UL	1	Histogram Number Of Bins	HistogramNumberOfBins	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8649	\N	(0029,0047)	OB	1	Volume Histogram Data	VolumeHistogramData	SIEMENS SYNGO VOLUME	SSPI	\N	\N	\N
f	8650	\N	(0029,0001)	LO	1	Time Point ID	TimePointID	SIEMENS SYNGO TIME POINT SERVICE	SSPI	\N	\N	\N
f	8651	\N	(0029,0002)	LO	1	Time Point Information	TimePointInformation	SIEMENS SYNGO TIME POINT SERVICE	SSPI	\N	\N	\N
f	8652	\N	(0029,0050)	SQ	1	Studies in Time Point Sequence	StudiesinTimePointSequence	SIEMENS SYNGO TIME POINT SERVICE	SSPI	\N	\N	\N
f	8653	\N	(0029,0000)	CS	1	Presentation Name	PresentationName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8654	\N	(0029,0001)	CS	1	Presentation Type	PresentationType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8655	\N	(0029,0002)	SQ	1	Advanced Presentation Sequence	AdvancedPresentationSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8656	\N	(0029,0003)	SQ	1	Time Point Sequence	TimePointSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8657	\N	(0029,0004)	SQ	1	Base Image Sequence	BaseImageSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8658	\N	(0029,0005)	SQ	1	Overlay Image Sequence	OverlayImageSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8659	\N	(0029,0006)	SQ	1	Registration Instance Sequence	RegistrationInstanceSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8660	\N	(0029,0007)	SQ	1	Real World Value Mapping Instance Sequence	RealWorldValueMappingInstanceSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8661	\N	(0029,0008)	SQ	1	Measurement Sequence	MeasurementSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8662	\N	(0029,0009)	UI	1	Measurement UID	MeasurementUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8663	\N	(0029,0010)	SQ	1	Segmentation Sequence	SegmentationSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8664	\N	(0029,0011)	UI	1	Segmentation UID	SegmentationUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8665	\N	(0029,0012)	SQ	1	Navigation Sequence	NavigationSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8666	\N	(0029,0013)	CS	1	Navigation Name	NavigationName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8667	\N	(0029,0014)	CS	1	Auto Navigation Direction	AutoNavigationDirection	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8668	\N	(0029,0015)	DS	1	Auto Navigation Frame Rate	AutoNavigationFrameRate	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8669	\N	(0029,0016)	CS	1	Auto Navigation Mode	AutoNavigationMode	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8670	\N	(0029,0017)	DS	1	Auto Navigation Realtime Speed	AutoNavigationRealtimeSpeed	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8671	\N	(0029,0018)	CS	1	Auto Navigation Strategy	AutoNavigationStrategy	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8672	\N	(0029,0019)	CS	1	Auto Navigation Realtime Flag	AutoNavigationRealtimeFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8673	\N	(0029,0020)	IS	1	Index Navigation Current Index	IndexNavigationCurrentIndex	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8674	\N	(0029,0021)	IS	1	Index Auto Navigation Skipping Degree	IndexAutoNavigationSkippingDegree	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8675	\N	(0029,0022)	DS	1	Volume Navigation Minimum Pixel Spacing	VolumeNavigationMinimumPixelSpacing	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8676	\N	(0029,0023)	CS	1	Volume Navigation Scroll Unit	VolumeNavigationScrollUnit	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8677	\N	(0029,0024)	DS	1	Volume Navigation Step Size	VolumeNavigationStepSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8678	\N	(0029,0025)	DS	1	Volume Navigation Jump Size	VolumeNavigationJumpSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8679	\N	(0029,0026)	IS	1	Referenced Registration Number	ReferencedRegistrationNumber	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8680	\N	(0029,0027)	UI	1	Real World Value Mapping UID	RealWorldValueMappingUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8681	\N	(0029,0028)	DS	1	Channel Alpha Value	ChannelAlphaValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8682	\N	(0029,0030)	LO	1	Measurement Application Name	MeasurementApplicationName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8683	\N	(0029,0031)	SQ	1	Measurement Data Sequence	MeasurementDataSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8684	\N	(0029,0032)	LO	1	Measurement Type	MeasurementType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8685	\N	(0029,0033)	UI	1	Measurement Frame of Reference UID	MeasurementFrameOfReferenceUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8686	\N	(0029,0034)	UI	1	Measurement UID	MeasurementUid	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8687	\N	(0029,0035)	IS	1	Measurement Application Number	MeasurementApplicationNumber	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8688	\N	(0029,0036)	ST	1	Measurement Application Number Prefix Text	MeasurementApplicationNumberPrefixText	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8689	\N	(0029,0037)	CS	1	Measurement Graphic Is Visible Flag	MeasurementGraphicIsVisibleFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8690	\N	(0029,0038)	UI	4	Referenced Syngo UID	ReferencedSyngoUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8691	\N	(0029,0039)	UI	1	Clinical Finding UID	ClinicalFindingUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8692	\N	(0029,003a)	CS	1	Measurement Evaluation String Value	MeasurementEvaluationStringValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8693	\N	(0029,003b)	IS	1	Measurement Evaluation Integer Value	MeasurementEvaluationIntegerValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8694	\N	(0029,003c)	FL	1	Measurement Evaluation Decimal Value	MeasurementEvaluationDecimalValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8695	\N	(0029,003d)	CS	1	Measurement Line Show Center Flag	MeasurementLineShowCenterFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8696	\N	(0029,003e)	CS	1	Measurement Angle Show ArrowTip Flag	MeasurementAngleShowArrowTipFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8697	\N	(0029,003f)	SQ	1	Camera Home Settings Sequence	CameraHomeSettingsSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8698	\N	(0029,0040)	DS	1	Camera Zoom	CameraZoom	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8699	\N	(0029,0041)	DS	3	Camera Position	CameraPosition	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8700	\N	(0029,0042)	DS	4	Camera Orientation	CameraOrientation	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8701	\N	(0029,0043)	DS	1	Camera Far Clip Plane	CameraFarClipPlane	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8702	\N	(0029,0044)	DS	1	Camera Near Clip Plane	CameraNearClipPlane	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8703	\N	(0029,0045)	DS	1	Camera Thickness	CameraThickness	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8704	\N	(0029,0046)	DS	1	Camera ViewPort Size	CameraViewPortSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8705	\N	(0029,0047)	DS	1	Camera Aspect Ratio	CameraAspectRatio	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8706	\N	(0029,0048)	LO	1	Camera Projection Type	CameraProjectionType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8707	\N	(0029,0049)	DS	1	Camera Field of View	CameraFieldOfView	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8708	\N	(0029,004a)	DS	1	Camera Image Plane Distance	CameraImagePlaneDistance	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8709	\N	(0029,004b)	DS	1	Camera Image Maximum Height	CameraImageMaximumHeight	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8710	\N	(0029,004c)	DS	1	Camera Image Minimum Height	CameraImageMinimumHeight	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8711	\N	(0029,004d)	DS	1	Parallel Shift Interval MM	ParallelShiftIntervalMM	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8712	\N	(0029,004e)	DS	3	Parallel Shift BoundingBox Minimum	ParallelShiftBoundingBoxMinimum	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8713	\N	(0029,004f)	DS	3	Parallel Shift BoundingBox Maximum	ParallelShiftBoundingBoxMaximum	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8714	\N	(0029,0050)	CS	1	Renderer Vertex Is Characteristic Flag	RendererVertexIsCharacteristicFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8715	\N	(0029,0051)	CS	1	Renderer Thickness Usage Flag	RendererThicknessUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8716	\N	(0029,0052)	DS	4	Renderer Threshold	RendererThreshold	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8717	\N	(0029,0053)	DS	4	Renderer Material	RendererMaterial	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8718	\N	(0029,0054)	DS	4	Renderer DirectionalLight Color	RendererDirectionalLightColor	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8719	\N	(0029,0055)	DS	3	Renderer DirectionalLight Direction	RendererDirectionalLightDirection	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8720	\N	(0029,0056)	CS	1	Renderer DirectionalLight TwoSide Usage Flag	RendererDirectionalLightTwoSideUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8721	\N	(0029,0057)	SQ	1	Renderer PWL TransferFunction Sequence	RendererPWLTransferFunctionSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8722	\N	(0029,0058)	IS	0-n	Renderer PWL Vertex Index	RendererPWLVertexIndex	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8723	\N	(0029,0059)	DS	0-n	Renderer PWL Vertex Color	RendererPWLVertexColor	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8724	\N	(0029,005a)	CS	1	Renderer Is Camera Required Flag	RendererIsCameraRequiredFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8725	\N	(0029,005b)	CS	1	Renderer Do Depth Test Flag 	RendererDoDepthTestFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8726	\N	(0029,005c)	CS	1	Renderer Directional Light Usage Flag	RendererDirectionalLightUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8727	\N	(0029,005d)	SQ	1	Renderer Thickness Sequence	RendererThicknessSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8728	\N	(0029,005e)	SQ	0-n	Renderer Slice Spacing Sequence	RendererSliceSpacingSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8729	\N	(0029,005f)	DS	1	Renderer Sampling Distance	RendererSamplingDistance	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8730	\N	(0029,0060)	DS	1	Renderer Initial Sampling Distance	RendererInitialSamplingDistance	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8731	\N	(0029,0061)	SQ	1	Segmentation Display Data Sequence	SegmentationDisplayDataSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8732	\N	(0029,0062)	UI	0-n	Segmentation Display Data UID	SegmentationDisplayDataUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8733	\N	(0029,0063)	SQ	1	Segmentation Display Parameter Sequence	SegmentationDisplayParameterSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8734	\N	(0029,0064)	LO	1	Segmentation Display Parameter Type	SegmentationDisplayParameterType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8735	\N	(0029,0065)	LO	1	Segmentation Display Visibility	SegmentationDisplayVisibility	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8736	\N	(0029,0066)	DS	4	Segmentation Display Color	SegmentationDisplayColor	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8737	\N	(0029,0067)	CS	1	Segmentation Display is Selected Flag 	SegmentationDisplayIsSelectedFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8738	\N	(0029,0068)	OB	1	Segmentation Additional Information Blob	SegmentationAdditionalInformationBlob	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8739	\N	(0029,0069)	ST	1	Hash Code Value	HashCodeValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8740	\N	(0029,006a)	LO	1-n	Segmentation Version Identifier	SegmentationVersionIdentifier	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8741	\N	(0029,0070)	DS	3	Segmentation Volume Size	SegmentationVolumeSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8742	\N	(0029,0071)	UI	1-n	Registration Referenced Frames	RegistrationReferencedFrames	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8743	\N	(0029,0072)	UI	1-n	Registration Referenced Registrations	RegistrationReferencedRegistrations	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8744	\N	(0029,0073)	LO	1	Registration Creation Algorithm Name	RegistrationCreationAlgorithmName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8745	\N	(0029,0074)	CS	1	ECG Graphic Type	ECGGraphicType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8746	\N	(0029,007a)	DS	1	Segmentation Volume Storage Data Type	SegmentationVolumeStorageDataType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8747	\N	(0029,007b)	FL	16	Segmentation Volume Model Matrix	SegmentationVolumeModelMatrix	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8748	\N	(0029,0080)	DS	3	Camera Rotation Axis	CameraRotationAxis	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8749	\N	(0029,0081)	SL	0-n	Overlay Hidden Display Attributes	OverlayHiddenDisplayAttributes	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8750	\N	(0029,0082)	LO	1	Presentation State Group Identifier	PresentationStateGroupIdentifier	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8751	\N	(0029,0083)	US	1	Temporary Smallest Image Pixel Value	TemporarySmallestImagePixelValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8752	\N	(0029,0084)	DS	3	Camera Rotation Center	CameraRotationCenter	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8753	\N	(0029,0085)	CS	1	Camera Rotation Center Usage Flag	CameraRotationCenterUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8754	\N	(0029,0086)	DS	12	Camera Parallel Epiped	CameraParallelEpiped	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8867	\N	(0031,0017)	SS	1-n	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8755	\N	(0029,0087)	DS	1	Camera Max Zoom In Factor	CameraMaxZoomInFactor	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8756	\N	(0029,0088)	DS	1	Camera Min Zoom In Factor	CameraMinZoomInFactor	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8757	\N	(0029,0089)	US	1	Temporary Largest Image Pixel Value	TemporaryLargestImagePixelValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8758	\N	(0029,008a)	CS	1	Camera Rotation Axis Usage Flag	CameraRotationAxisUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8759	\N	(0029,008b)	DS	3	Measurement Surface Normal	MeasurementSurfaceNormal	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8760	\N	(0029,008c)	FL	16	Measurement Ellipsoid Model Matrix	MeasurementEllipsoidModelMatrix	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8761	\N	(0029,008d)	LO	1	Measurement Evaluation DataRole ID	MeasurementEvaluationDataRoleID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8762	\N	(0029,008e)	LO	1	Measurement Algorithm Type	MeasurementAlgorithmType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8763	\N	(0029,0091)	SQ	1	Measurement Evaluation DataRole Sequence	MeasurementEvaluationDataRoleSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8764	\N	(0029,0092)	CS	1	Measurement Evaluation DataRole Item	MeasurementEvaluationDataRoleItem	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8765	\N	(0029,0093)	SQ	1	Measurement Evaluation Sequence	MeasurementEvaluationSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8766	\N	(0029,0094)	DS	1	Measurement Evaluation Value	MeasurementEvaluationValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8767	\N	(0029,0095)	CS	1	Measurement Evaluation ID	MeasurementEvaluationID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8768	\N	(0029,0096)	FL	0-n	Measurement Data Points	MeasurementDataPoints	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8769	\N	(0029,0097)	FL	0-n	Measurement Data Angles	MeasurementDataAngles	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8770	\N	(0029,0098)	LO	1	Measurement Data Slice	MeasurementDataSlice	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8771	\N	(0029,0099)	FL	1	Measurement Data Slice Thickness	MeasurementDataSliceThickness	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8772	\N	(0029,009a)	SQ	1	Measurement Referenced Frames Sequence	MeasurementReferencedFramesSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8773	\N	(0029,009b)	DS	0-n	Measurement Evaluation Longest Distance	MeasurementEvaluationLongestDistance	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8774	\N	(0029,009c)	DS	0-n	Measurement Evaluation Centroid	MeasurementEvaluationCentroid	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8775	\N	(0029,009d)	FL	6	Measurement Data Bounding Box 	MeasurementDataBoundingBox	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8776	\N	(0029,009e)	LO	1	Measurement Text	MeasurementText	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8777	\N	(0029,009f)	IS	1	Measurement Diameter	MeasurementDiameter	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8778	\N	(0029,00a0)	DS	1	Image Rotation Fractional	ImageRotationFractional	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8779	\N	(0029,00a1)	LO	1	Preset Name	PresetName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8780	\N	(0029,00a2)	SQ	1	Fusion LUT Sequence	FusionLUTSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8781	\N	(0029,00a3)	CS	1	Fusion LUT Is Active Flag	FusionLUTIsActiveFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8782	\N	(0029,00a5)	UI	1	Syngo UID	SyngoUID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8783	\N	(0029,00a6)	UI	1	Presentation Version Identifier	PresentationVersionIdentifier	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8784	\N	(0029,00a7)	SQ	1	Presentation Module Sequence	PresentationModuleSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8785	\N	(0029,00a8)	LO	1	Presentation Module Type	PresentationModuleType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8786	\N	(0029,00a9)	SQ	1	Presentation State Sequence	PresentationStateSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8787	\N	(0029,00aa)	CS	1	LUT Inverted Flag	LUTInvertedFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8788	\N	(0029,00ab)	IS	1	Softcopy VOI LUT Viewing Index	SoftcopyVOILUTViewingIndex	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8789	\N	(0029,00ac)	FD	2	Displayed Area Bottom Right Hand Corner Fractional	DisplayedAreaBottomRightHandCornerFractional	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8790	\N	(0029,00ad)	FD	2	Displayed Area Top Left Hand Corner Fractional	DisplayedAreaTopLeftHandCornerFractional	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8791	\N	(0029,00ae)	FL	1	Measurement Alpha	MeasurementAlpha	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8792	\N	(0029,00af)	OB	1	Measurement Bitmap	MeasurementBitmap	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8793	\N	(0029,00b0)	US	1	Current Frame Number	CurrentFrameNumber	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8794	\N	(0029,00b1)	LO	1	Image Text View Name	ImageTextViewName	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8795	\N	(0029,00b2)	SQ	1	Image Text View Content Sequence	ImageTextViewContentSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8796	\N	(0029,00b3)	LO	1-n	Image Text Line Names	ImageTextLineNames	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8797	\N	(0029,00b4)	LO	1-n	ImageText Line Values	ImageTextLineValues	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8798	\N	(0029,00b5)	SQ	1	Measurement Evaluation Text Position Sequence	MeasurementEvaluationTextPositionSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8799	\N	(0029,00b6)	CS	1	Measurement Link Evaluation Text Flag	MeasurementLinkEvaluationTextFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8800	\N	(0029,00b7)	DS	3	Measurement Evaluation Text Position Vector	MeasurementEvaluationTextPositionVector	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8801	\N	(0029,00b8)	OB	1	Image Text Alpha Blending Line Value	ImageTextAlphaBlendingLineValue	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8802	\N	(0029,00c1)	SQ	1	Task Data Sequence	TaskDataSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8803	\N	(0029,00c2)	CS	1	Task Data Type	TaskDataType	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8804	\N	(0029,00c3)	LO	1	Task Data Version	TaskDataVersion	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8805	\N	(0029,00c4)	ST	1	Task Data Description	TaskDataDescription	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8806	\N	(0029,00c5)	OB	1	Task Data	TaskData	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8807	\N	(0029,00c6)	IS	1	Task Data Size	TaskDataSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8808	\N	(0029,00c9)	SQ	1	Clip Plane Sequence	ClipPlaneSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8809	\N	(0029,00ca)	DS	3	Clip Plane Center	ClipPlaneCenter	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8810	\N	(0029,00cb)	DS	3	Clip Plane Normal	ClipPlaneNormal	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8811	\N	(0029,00cc)	DS	2	Clip Plane Scale	ClipPlaneScale	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8812	\N	(0029,00cd)	CS	1	Clip Plane Use Thickness Flag	ClipPlaneUseThicknessFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8813	\N	(0029,00ce)	DS	1	Clip Plane Thickness	ClipPlaneThickness	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8814	\N	(0029,00cf)	SQ	1	Image Sequence	ImageSequence	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8815	\N	(0029,00d0)	CS	1	Clip Plane Enable Clip	ClipPlaneEnableClip	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8816	\N	(0029,00d1)	DS	1	Clip Plane Handle Ratio	ClipPlaneHandleRatio	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8817	\N	(0029,00d2)	DS	24	Clip Plane Bounding Points	ClipPlaneBoundingPoints	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8818	\N	(0029,00d3)	DS	16	Clip Plane Motion Matrix	ClipPlaneMotionMatrix	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8819	\N	(0029,00d4)	DS	1	Clip Plane Shift Velocity	ClipPlaneShiftVelocity	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8820	\N	(0029,00d5)	CS	1	Clip Plane Enabled Flag	ClipPlaneEnabledFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8821	\N	(0029,00d6)	DS	1	Clip Plane Rotate Velocity	ClipPlaneRotateVelocity	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8822	\N	(0029,00d7)	CS	1	Clip Plane Show Graphics Flag	ClipPlaneShowGraphicsFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8823	\N	(0029,00e0)	DS	3	Crop Box Size	CropBoxSize	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8824	\N	(0029,00e1)	CS	1	Crop Box Enabled Flag	CropBoxEnabledFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8825	\N	(0029,00e2)	DS	3	Crop Box Absolute Origin	CropBoxAbsoluteOrigin	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8826	\N	(0029,00e3)	CS	1	Crop Box Show Graphics Flag	CropBoxShowGraphicsFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8827	\N	(0029,00f1)	DS	0-n	Curved Camera Coordinates	CurvedCameraCoordinates	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8828	\N	(0029,00f2)	DS	1	Curved Camera Point of Interest	CurvedCameraPointOfInterest	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8829	\N	(0029,00f3)	CS	1	Curved Camera Point of Interest Usage Flag	CurvedCameraPointOfInterestUsageFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8830	\N	(0029,00f4)	DS	1	Curved Camera Thickness	CurvedCameraThickness	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8831	\N	(0029,00f5)	DS	1	Curved Camera Extrusion Length	CurvedCameraExtrusionLength	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8832	\N	(0029,00f6)	CS	1	Curved Camera Rotation Axis Mode	CurvedCameraRotationAxisMode	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8833	\N	(0029,00f7)	DS	1	Curved Camera Roll Rotation Axis	CurvedCameraRollRotationAxis	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8834	\N	(0029,00f8)	DS	1	Curved Camera View Port Height	CurvedCameraViewPortHeight	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8835	\N	(0029,00f9)	DS	1	Curved Camera Cut Direction	CurvedCameraCutDirection	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8836	\N	(0029,00fa)	DS	1	Curved Camera Pan Vector	CurvedCameraPanVector	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8837	\N	(0029,00fb)	LO	1	Clinical Finding ID	ClinicalFindingID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8838	\N	(0029,00fc)	CS	1	Measurement Is Circle Flag	MeasurementIsCircleFlag	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8839	\N	(0029,00fd)	LO	1	Measurement Application Type ID	MeasurementApplicationTypeID	SIEMENS SYNGO ADVANCED PRESENTATION	SSPI	\N	\N	\N
f	8840	\N	(0029,0010)	SQ	1	Image Frame Sequence	ImageFrameSequence	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8841	\N	(0029,0012)	CS	1	Type of Progression	TypeOfProgression	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8842	\N	(0029,0014)	IS	1	Representation Level	RepresentationLevel	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8843	\N	(0029,0016)	SQ	1	Representation Information Sequence	RepresentationInformationSequence	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8844	\N	(0029,0018)	IS	1	Number of Representations	NumberOfRepresentations	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8845	\N	(0029,0020)	IS	1	Representation Pixel Offset	RepresentationPixelOffset	SIEMENS SYNGO FRAME SET	SSPI	\N	\N	\N
f	8846	\N	(0029,0010)	IS	1	Sheet Number	SheetNumber	SIEMENS SYNGO PRINT SERVICE	SSPI	\N	\N	\N
f	8847	\N	(0029,0001)	UT	1	Unknown	Unknown	SIEMENS IKM CKS LUNGCAD BMK	SSPI	\N	\N	\N
f	8848	\N	(0029,0001)	UT	1	Unknown	Unknown	SIEMENS IKM CKS CXRCAD FINDINGS	SSPI	\N	\N	\N
f	8849	\N	(0029,0008)	CS	1	Report Type	ReportType	SIEMENS CSA REPORT	SSPI	\N	\N	\N
f	8850	\N	(0029,0009)	LO	1	Report Version	ReportVersion	SIEMENS CSA REPORT	SSPI	\N	\N	\N
f	8851	\N	(0029,0015)	US	1	SR Variant	SRVariant	SIEMENS CSA REPORT	SSPI	\N	\N	\N
f	8852	\N	(0029,0017)	UI	1	SC SOP Instance UID	SCSOP InstanceUID	SIEMENS CSA REPORT	SSPI	\N	\N	\N
f	8853	\N	(0029,0010)	OB	1	syngo Report Data	syngoReportData	SIEMENS CSA ENVELOPE	SSPI	\N	\N	\N
f	8854	\N	(0029,0011)	OB	1	syngo Report Presentation	syngoReportPresentation	SIEMENS CSA ENVELOPE	SSPI	\N	\N	\N
f	8855	\N	(0029,0008)	CS	1	Modality Image Header Type	ModalityImageHeaderType	SIEMENS MED NM	SSPI	\N	\N	\N
f	8856	\N	(0029,0009)	LO	1	Modality Image Header Version	ModalityImageHeaderVersion	SIEMENS MED NM	SSPI	\N	\N	\N
f	8857	\N	(0029,0010)	OB	1	Modality Image Header Info	ModalityImageHeaderInfo	SIEMENS MED NM	SSPI	\N	\N	\N
f	8858	\N	(0031,0001)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8859	\N	(0031,000c)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8860	\N	(0031,000f)	SL	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	2128	\N	(0031,0010)	LO	1	Request UID	RequestUID	SIEMENS RIS	SSPI	\N	\N	\N
f	8861	\N	(0031,0010)	SL	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1570	\N	(0031,0012)	LO	1	Examination Reason	ExaminationReason	SIEMENS ISI	SSPI	\N	\N	\N
f	8868	\N	(0031,0020)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8869	\N	(0031,0021)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1571	\N	(0031,0030)	DA	1	Requested Date	RequestedDate	SIEMENS ISI	SSPI	\N	\N	\N
f	1572	\N	(0031,0032)	TM	1	Worklist Request Start Time	WorklistRequestStartTime	SIEMENS ISI	SSPI	\N	\N	\N
f	1573	\N	(0031,0033)	TM	1	Worklist Request End Time	WorklistRequestEndTime	SIEMENS ISI	SSPI	\N	\N	\N
f	2129	\N	(0031,0045)	LO	1	Requesting Physician	RequestingPhysician	SIEMENS RIS	SSPI	\N	\N	\N
f	1574	\N	(0031,004a)	TM	1	Requested Time	RequestedTime	SIEMENS ISI	SSPI	\N	\N	\N
f	2130	\N	(0031,0050)	LO	1	Requested Physician	RequestedPhysician	SIEMENS RIS	SSPI	\N	\N	\N
f	1575	\N	(0031,0080)	LO	1	Requested Location	RequestedLocation	SIEMENS ISI	SSPI	\N	\N	\N
f	8870	\N	(0031,0010)	SQ	1	SOP Class Packing Sequence	SOPClassPackingSequence	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8871	\N	(0031,0020)	CS	1	Packing Version	PackingVersion	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8872	\N	(0031,0021)	CS	1	Packing Originator	PackingOriginator	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8873	\N	(0031,0030)	UI	1	Original SOP Class UID	OriginalSOPClassUID	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8874	\N	(0031,0031)	UI	1	Original Study Instance UID	OriginalStudyInstanceUID	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8875	\N	(0031,0032)	UI	1	Original Series Instance UID	OriginalSeriesInstanceUID	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8876	\N	(0031,0033)	UI	1	Original SOP Instance UID	OriginalSOPInstanceUID	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8877	\N	(0031,0034)	UI	1	Original Transfer Syntax UID	OriginalTransferSyntaxUID	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8878	\N	(0031,0040)	AT	1-n	Attributes to Set to Zero Length	AttributesToSetToZeroLength	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8879	\N	(0031,0041)	AT	1-n	Attributes to Remove	AttributesToRemove	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8880	\N	(0031,0050)	US	1	Original Rows	OriginalRows	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8881	\N	(0031,0051)	US	1	Original Columns	OriginalColumns	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8882	\N	(0031,0058)	CS	2-n	Original Image Type	OriginalImageType	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8883	\N	(0031,0060)	CS	1	Original Modality	OriginalModality	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8884	\N	(0031,0070)	SQ	1	Sequence of Original StreamCchunks	SequenceOfOriginalStreamChunks	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8885	\N	(0031,0071)	AT	1	Start Tag of a Stream Chunk	StartTagOfAStreamChunk	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8886	\N	(0031,0072)	AT	1	End Tag of a Stream Chunk	EndTagOfAStreamChunk	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8887	\N	(0031,0073)	CS	1	Stream Chunk is a Payload	StreamChunkIsAPayload	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8888	\N	(0031,0080)	OB	1	Stream Chunk	StreamChunk	SIEMENS SYNGO SOP CLASS PACKING	SSPI	\N	\N	\N
f	8889	\N	(0031,0010)	UI	1	Internal Patient UID	InternalPatientUID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8890	\N	(0031,0011)	SH	1	Patients Death Indicator	PatientsDeathIndicator	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8891	\N	(0031,0012)	DA	1	Patients Death Date	PatientsDeathDate	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8892	\N	(0031,0013)	TM	1	Patients Death Time	PatientsDeathTime	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8893	\N	(0031,0014)	SH	1	VIP Indicator	VIPIndicator	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8894	\N	(0031,0015)	US	1	Emergency Flag	EmergencyFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8895	\N	(0031,0020)	SH	1	Internal Visit UID	InternalVisitUID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8896	\N	(0031,0025)	SH	1	Internal ISR UID	InternalISRUID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8897	\N	(0031,0032)	SH	1	Control State	ControlState	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8898	\N	(0031,0034)	US	1	Local Flag	LocalFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8899	\N	(0031,0036)	UI	1-n	Referenced Studies	ReferencedStudies	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8900	\N	(0031,0040)	LO	1	Workflow ID	WorkflowID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8901	\N	(0031,0041)	LO	1	Workflow Description	WorkflowDescription	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8902	\N	(0031,0042)	LO	1	Workflow Control State	WorkflowControlState	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8903	\N	(0031,0043)	US	1	Workflow Ad Hoc Flag	WorkflowAdHocFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8904	\N	(0031,0044)	US	1	Hybrid Flag	HybridFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8905	\N	(0031,0050)	LO	1	Workitem ID	WorkitemID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8906	\N	(0031,0051)	LO	1	Workitem Name	WorkitemName	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8907	\N	(0031,0052)	LO	1	Workitem Type	WorkitemType	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8908	\N	(0031,0053)	LO	1-n	Workitem Roles	WorkitemRoles	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8909	\N	(0031,0054)	LO	1	Workitem Description	WorkitemDescription	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8910	\N	(0031,0055)	LO	1	Workitem Control State	WorkitemControlState	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8911	\N	(0031,0056)	LO	1	Claiming User	ClaimingUser	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8912	\N	(0031,0057)	LO	1	Claiming Host	ClaimingHost	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8913	\N	(0031,0058)	LO	1	Taskflow ID	TaskflowID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8914	\N	(0031,0059)	LO	1	Taskflow Name	TaskflowName	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8915	\N	(0031,005a)	US	1	Failed Flag	FailedFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8916	\N	(0031,005b)	DT	1	Scheduled Time	ScheduledTime	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8917	\N	(0031,005c)	US	1	Workitem Ad Hoc Flag	WorkitemAdHocFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8918	\N	(0031,005d)	US	1	Patient Update Pending Flag	PatientUpdatePendingFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8919	\N	(0031,005e)	US	1	Patient Mixup Flag	PatientMixupFlag	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8920	\N	(0031,0060)	LO	1	Client ID	ClientID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8921	\N	(0031,0061)	LO	1	Template ID	TemplateID	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8922	\N	(0031,0081)	LO	1	Institution Name	InstitutionName	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	9687	\N	(0021,0033)	SH	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	8923	\N	(0031,0082)	ST	1	Institution Address	InstitutionAddress	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	8924	\N	(0031,0083)	SQ	1	Institution Code Sequence	InstitutionCodeSequence	SIEMENS SYNGO WORKFLOW	SSPI	\N	\N	\N
f	2131	\N	(0033,0010)	LO	1	Patient Study UID	PatientStudyUID	SIEMENS RIS	SSPI	\N	\N	\N
f	8925	\N	(0033,0000)	FL	1-n	Flood Correction Matrix Detector 1	FloodCorrectionMatrixDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8926	\N	(0033,0001)	FL	1-n	Flood Correction Matrix Detector 2	FloodCorrectionMatrixDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8927	\N	(0033,0010)	FL	1-n	COR Data for Detector 1	CORDataForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8928	\N	(0033,0011)	FL	1-n	COR Data for Detector 2	CORDataForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8929	\N	(0033,0014)	FL	1	MHR ( Y-Shift) data for detector 1	MHRDataForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8930	\N	(0033,0015)	FL	1	MHR ( Y-Shift) data for detector 2	MHRDataForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8931	\N	(0033,0018)	FL	1-n	NCO Data for detector 1	NCODataForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8932	\N	(0033,0019)	FL	1-n	NCO Data for detector 2	NCODataForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8933	\N	(0033,001a)	FL	1-n	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8934	\N	(0033,0020)	FL	1	Bed correction angle	BedCorrectionAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	8935	\N	(0033,0021)	FL	1	Gantry correction angle	GantryCorrectionAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	8936	\N	(0033,0022)	SS	1-n	Bed U/D correction data	BedUDCorrectionData	SIEMENS MED NM	SSPI	\N	\N	\N
f	8937	\N	(0033,0023)	SS	1-n	Gantry L/R Correction Data	GantryLRCorrectionData	SIEMENS MED NM	SSPI	\N	\N	\N
f	8938	\N	(0033,0024)	FL	1	BackProjection Correction angle head 1	BackProjectionCorrectionAngleHead1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8939	\N	(0033,0025)	FL	1	BackProjection Correction angle head 2	BackProjectionCorrectionAngleHead2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8940	\N	(0033,0028)	SL	1	MHR calibrations	MHRCalibrations	SIEMENS MED NM	SSPI	\N	\N	\N
f	8941	\N	(0033,0029)	FL	1-n	Crystal thickness	CrystalThickness	SIEMENS MED NM	SSPI	\N	\N	\N
f	8942	\N	(0033,0030)	LO	1	Preset name used for acquisition	PresetNameUsedForAcquisition	SIEMENS MED NM	SSPI	\N	\N	\N
f	8943	\N	(0033,0031)	FL	1	Camera Config Angle	CameraConfigAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	8944	\N	(0033,0032)	LO	1	Crystal Type	CrystalType	SIEMENS MED NM	SSPI	\N	\N	\N
f	8945	\N	(0033,0033)	SL	1	Coin Gantry Step	CoinGantryStep	SIEMENS MED NM	SSPI	\N	\N	\N
f	8946	\N	(0033,0034)	FL	1	Wholebody bed step	WholebodyBedStep	SIEMENS MED NM	SSPI	\N	\N	\N
f	8947	\N	(0033,0035)	FL	1	Weight Factor Table For Coincidence Acquisitions	WeightFactorTableForCoincidenceAcquisitions	SIEMENS MED NM	SSPI	\N	\N	\N
f	8948	\N	(0033,0036)	FL	1	Coincidence weight factor table	CoincidenceWeightFactorTable	SIEMENS MED NM	SSPI	\N	\N	\N
f	8949	\N	(0033,0037)	SL	1	Starburst flags at image acq time	StarburstFlagsAtImageAcqTime	SIEMENS MED NM	SSPI	\N	\N	\N
f	8950	\N	(0033,0038)	FL	1	Pixel Scale factor	PixelScaleFactor	SIEMENS MED NM	SSPI	\N	\N	\N
f	8951	\N	(0035,0000)	LO	1	Specialized Tomo Type	SpecializedTomoType	SIEMENS MED NM	SSPI	\N	\N	\N
f	8952	\N	(0035,0001)	LO	1	Energy Window Type	EnergyWindowType	SIEMENS MED NM	SSPI	\N	\N	\N
f	8953	\N	(0035,0002)	SS	1	Start and End Row Illuminated By Wind Position	StartandEndRowIlluminatedByWindPosition	SIEMENS MED NM	SSPI	\N	\N	\N
f	8954	\N	(0035,0003)	LO	1	Blank Scan Image For Profile	BlankScanImageForProfile	SIEMENS MED NM	SSPI	\N	\N	\N
f	8955	\N	(0035,0004)	SS	1	Repeat Number of the Original Dynamic SPECT	RepeatNumberOfTheOriginalDynamicSPECT	SIEMENS MED NM	SSPI	\N	\N	\N
f	8956	\N	(0035,0005)	SS	1	Phase Number of the Original Dynamic SPECT	PhaseNumberOfTheOriginalDynamicSPECT	SIEMENS MED NM	SSPI	\N	\N	\N
f	8957	\N	(0035,0006)	LO	1	Siemens Profile 2 Image Subtype	SiemensProfile2ImageSubtype	SIEMENS MED NM	SSPI	\N	\N	\N
f	8958	\N	(0037,0000)	OW	1	Flood correction matrix Detector 1	FloodCorrectionMatrixDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8959	\N	(0037,0080)	OW	1	Flood correction matrix Detector 2	FloodCorrectionMatrixDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8960	\N	(0039,0000)	LT	1	Toshiba CBF Activity Results	ToshibaCBFActivityResults	SIEMENS MED NM	SSPI	\N	\N	\N
f	8961	\N	(0039,0001)	LT	1	Related CT Series Instance UID	RelatedCTSeriesInstanceUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	8962	\N	(0041,0002)	SH	1	Reason for the Requested Procedure	ReasonForTheRequestedProcedure	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8963	\N	(0041,0001)	SL	1	Whole Body Tomo Position Index	WholeBodyTomoPositionIndex	SIEMENS MED NM	SSPI	\N	\N	\N
f	8964	\N	(0041,0002)	SL	1	Whole Body Tomo Number of Positions	WholeBodyTomoNumberOfPositions	SIEMENS MED NM	SSPI	\N	\N	\N
f	8965	\N	(0041,0003)	FL	1	Horizontal Table Position of CT scan	HorizontalTablePositionOfCTScan	SIEMENS MED NM	SSPI	\N	\N	\N
f	8966	\N	(0041,0004)	FL	1	Effective Energy fo CT Scan	EffectiveEnergyOfCTScan	SIEMENS MED NM	SSPI	\N	\N	\N
f	8967	\N	(0041,0005)	FD	1-n	Long Linear Drive Information for Detector 1	LongLinearDriveInformationForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8968	\N	(0041,0006)	FD	1-n	Long Linear Drive Information for Detector 2	LongLinearDriveInformationForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8969	\N	(0041,0007)	FD	1-n	Trunnion Information for Detector 1	TrunnionInformationForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8970	\N	(0041,0008)	FD	1-n	Trunnion Information for Detector 2	TrunnionInformationForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8971	\N	(0041,0009)	FL	1	Broad Beam Factor	BroadBeamFactor	SIEMENS MED NM	SSPI	\N	\N	\N
f	8972	\N	(0041,000a)	FD	1	Original Wholebody Position	OriginalWholebodyPosition	SIEMENS MED NM	SSPI	\N	\N	\N
f	8973	\N	(0041,000b)	FD	1	Wholebody Scan Range	WholebodyScanRange	SIEMENS MED NM	SSPI	\N	\N	\N
f	8974	\N	(0041,0010)	FL	1-3	Effective Emission Energy	EffectiveEmissionEnergy	SIEMENS MED NM	SSPI	\N	\N	\N
f	8975	\N	(0041,0011)	FL	1-n	Gated Frame Duration	GatedFrameDuration	SIEMENS MED NM	SSPI	\N	\N	\N
f	8976	\N	(0041,0030)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8977	\N	(0041,0032)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1543	\N	(0041,0010)	US	1	Number of Hardcopies	NumberOfHardcopies	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1544	\N	(0041,0020)	LO	1	Film Format	FilmFormat	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1545	\N	(0041,0030)	LO	1	Film Size	FilmSize	SIEMENS DLR.01	SSPI	\N	\N	\N
f	1546	\N	(0041,0031)	LO	1	Full Film Format	FullFilmFormat	SIEMENS DLR.01	SSPI	\N	\N	\N
f	8978	\N	(0041,0001)	CS	1	SUV Decay Correction Method	SUVDecayCorrectionMethod	SIEMENS MI RWVM SUV	SSPI	\N	\N	\N
f	8979	\N	(0043,0001)	FL	1-n	Detector View Angle	DetectorViewAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	8980	\N	(0043,0002)	FD	1-16	Transformation Matrix	TransformationMatrix	SIEMENS MED NM	SSPI	\N	\N	\N
f	8981	\N	(0043,0003)	FL	1-n	View Dependent Y Shift MHR For Detector 1	ViewDependentYShiftMHRForDetector1	SIEMENS MED NM	SSPI	\N	\N	\N
f	8982	\N	(0043,0004)	FL	1-n	View Dependent Y Shift MHR For Detector 2	ViewDependentYShiftMHRForDetector2	SIEMENS MED NM	SSPI	\N	\N	\N
f	8983	\N	(0045,0001)	LO	1-n	Planar Processing String	PlanarProcessingString	SIEMENS MED NM	SSPI	\N	\N	\N
f	1364	\N	(0051,0010)	LO	1-n	Image Text	ImageText	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	8984	\N	(0051,0010)	DS	1	Unknown	Unknown	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8985	\N	(0051,0037)	DS	6	Unknown	Unknown	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8986	\N	(0051,0050)	UI	1	Unknown	Unknown	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8987	\N	(0051,0060)	DS	1	Primary Positioner Scan Arc	PrimaryPositionerScanArc	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8988	\N	(0051,0061)	DS	1	Secondary Positioner Scan Arc	SecondaryPositionerScanArc	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8989	\N	(0051,0062)	DS	1	Primary Positioner Scan Start Angle	PrimaryPositionerScanStartAngle	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8990	\N	(0051,0063)	DS	1	Secondary Positioner Scan Start Angle	SecondaryPositionerScanStartAngle	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8991	\N	(0051,0064)	DS	1	Primary Positioner Increment	PrimaryPositionerIncrement	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8992	\N	(0051,0065)	DS	1	Secondary Positioner Increment	SecondaryPositionerIncrement	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	8993	\N	(0055,0004)	SS	1	Prompt Window Width	PromptWindowWidth	SIEMENS MED NM	SSPI	\N	\N	\N
f	8994	\N	(0055,0005)	SS	1	Random Window Width	RandomWindowWidth	SIEMENS MED NM	SSPI	\N	\N	\N
f	8995	\N	(0055,0020)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8996	\N	(0055,0022)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8997	\N	(0055,0024)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8998	\N	(0055,0030)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	8999	\N	(0055,0032)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9000	\N	(0055,0034)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9001	\N	(0055,0040)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9002	\N	(0055,0042)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9003	\N	(0055,0044)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9004	\N	(0055,004c)	SL	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9005	\N	(0055,004d)	SL	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9006	\N	(0055,0051)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9007	\N	(0055,0052)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9008	\N	(0055,0053)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9009	\N	(0055,0055)	SL	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9010	\N	(0055,005c)	ST	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9011	\N	(0055,006d)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9012	\N	(0055,007e)	FL	2	Collimator Thickness mm	CollimatorThickness	SIEMENS MED NM	SSPI	\N	\N	\N
f	9013	\N	(0055,007f)	FL	2	Collimator Angular Resolution radians	CollimatorAngularResolution	SIEMENS MED NM	SSPI	\N	\N	\N
f	9014	\N	(0055,00a8)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9015	\N	(0055,00c0)	SS	1-n	Useful Field of View	UsefulFieldOfView	SIEMENS MED NM	SSPI	\N	\N	\N
f	9016	\N	(0055,00c2)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9017	\N	(0055,00c3)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9018	\N	(0055,00c4)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9019	\N	(0055,00d0)	SS	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	1576	\N	(0055,0046)	LO	1	Current Ward	CurrentWard	SIEMENS ISI	SSPI	\N	\N	\N
f	9020	\N	(0055,0001)	LO	1	Projection View Display String	ProjectionViewDisplayString	SIEMENS MED SP DXMG WH AWS 1	SSPI	\N	\N	\N
f	9021	\N	(0057,0001)	LO	1	Syngo MI DICOM Original Image Type	SyngoMIDICOMOriginalImageType	SIEMENS MED NM	SSPI	\N	\N	\N
f	9022	\N	(0057,0002)	FL	1	Dose Calibration Factor	DoseCalibrationFactor	SIEMENS MED NM	SSPI	\N	\N	\N
f	9023	\N	(0057,0003)	LO	1	Units	Units	SIEMENS MED NM	SSPI	\N	\N	\N
f	9024	\N	(0057,0004)	LO	1	Decay Correction	DecayCorrection	SIEMENS MED NM	SSPI	\N	\N	\N
f	9025	\N	(0057,0005)	SL	1-n	Radionuclide Half Life	RadionuclideHalfLife	SIEMENS MED NM	SSPI	\N	\N	\N
f	9026	\N	(0057,0006)	FL	1	Rescale Intercept	RescaleIntercept	SIEMENS MED NM	SSPI	\N	\N	\N
f	9027	\N	(0057,0007)	FL	1	Rescale Slope	RescaleSlope	SIEMENS MED NM	SSPI	\N	\N	\N
f	9028	\N	(0057,0008)	FL	1	Frame Reference Time	FrameReferenceTime	SIEMENS MED NM	SSPI	\N	\N	\N
f	9029	\N	(0057,0009)	SL	1	Number of Radiopharmaceutical Information Sequence	NumberofRadiopharmaceuticalInformationSequence	SIEMENS MED NM	SSPI	\N	\N	\N
f	9030	\N	(0057,000a)	FL	1	Decay Factor	DecayFactor	SIEMENS MED NM	SSPI	\N	\N	\N
f	9031	\N	(0057,000b)	LO	1	Counts Source	CountsSource	SIEMENS MED NM	SSPI	\N	\N	\N
f	9032	\N	(0057,000c)	SL	1-n	Radionuclide Positron Fraction	RadionuclidePositronFraction	SIEMENS MED NM	SSPI	\N	\N	\N
f	9033	\N	(0057,000e)	US	1-n	Trigger Time of CT Slice	TriggerTimeOfCTSlice	SIEMENS MED NM	SSPI	\N	\N	\N
f	9034	\N	(0061,0001)	FL	1-n	X Principal Ray Offset	XPrincipalRayOffset	SIEMENS MED NM	SSPI	\N	\N	\N
f	9035	\N	(0061,0005)	FL	1-n	Y Principal Ray Offset	YPrincipalRayOffset	SIEMENS MED NM	SSPI	\N	\N	\N
f	9036	\N	(0061,0009)	FL	1-n	X Principal Ray Angle	XPrincipalRayAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	9037	\N	(0061,000a)	FL	1-n	Y Principal Ray Angle	YPrincipalRayAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	9038	\N	(0061,000b)	FL	1-n	X Short Focal Length	XShortFocalLength	SIEMENS MED NM	SSPI	\N	\N	\N
f	9039	\N	(0061,000c)	FL	1-n	Y Short Focal Length	YShortFocalLength	SIEMENS MED NM	SSPI	\N	\N	\N
f	9040	\N	(0061,000d)	FL	1-n	X Long Focal Length	XLongFocalLength	SIEMENS MED NM	SSPI	\N	\N	\N
f	9041	\N	(0061,000e)	FL	1-n	Y Long Focal Length	YLongFocalLength	SIEMENS MED NM	SSPI	\N	\N	\N
f	9042	\N	(0061,000f)	FL	1-n	X Focal Scaling	XFocalScaling	SIEMENS MED NM	SSPI	\N	\N	\N
f	9043	\N	(0061,0010)	FL	1-n	Y Focal Scaling	YFocalScaling	SIEMENS MED NM	SSPI	\N	\N	\N
f	9044	\N	(0061,0011)	FL	1-n	X Motion Correction Shift	XMotionCorrectionShift	SIEMENS MED NM	SSPI	\N	\N	\N
f	9045	\N	(0061,0015)	FL	1-n	Y Motion Correction Shift	YMotionCorrectionShift	SIEMENS MED NM	SSPI	\N	\N	\N
f	9046	\N	(0061,0019)	FL	1	X Heart Center	XHeartCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9047	\N	(0061,001a)	FL	1	Y Heart Center	YHeartCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9048	\N	(0061,001b)	FL	1	Z Heart Center	ZHeartCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9049	\N	(0061,001c)	LO	1	Image Pixel Content Type	ImagePixelContentType	SIEMENS MED NM	SSPI	\N	\N	\N
f	9050	\N	(0061,001d)	SS	1	Auto Save Corrected Series	AutoSaveCorrectedSeries	SIEMENS MED NM	SSPI	\N	\N	\N
f	9051	\N	(0061,001e)	LT	1	Distorted Series Instance UID	DistortedSeriesInstanceUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9052	\N	(0061,0021)	SS	1-n	Recon Range	ReconRange	SIEMENS MED NM	SSPI	\N	\N	\N
f	9053	\N	(0061,0022)	LO	1	Recon Orientation	ReconOrientation	SIEMENS MED NM	SSPI	\N	\N	\N
f	9054	\N	(0061,0023)	FL	1-n	Recon Selected Angular Range	ReconSelectedAngularRange	SIEMENS MED NM	SSPI	\N	\N	\N
f	9055	\N	(0061,0024)	FL	1	Recon Transverse Angle	ReconTransverseAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	9056	\N	(0061,0025)	FL	1	Recon Sagittal Angle	ReconSagittalAngle	SIEMENS MED NM	SSPI	\N	\N	\N
f	9057	\N	(0061,0026)	FL	1	Recon X Mask Size	ReconXMaskSize	SIEMENS MED NM	SSPI	\N	\N	\N
f	9058	\N	(0061,0027)	FL	1	Recon Y Mask Size	ReconYMaskSize	SIEMENS MED NM	SSPI	\N	\N	\N
f	9059	\N	(0061,0028)	FL	1	Recon X Image Center	ReconXImageCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9060	\N	(0061,0029)	FL	1	Recon Y Image Center	ReconYImageCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9061	\N	(0061,002a)	FL	1	Recon Z Image Center	ReconZImageCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9062	\N	(0061,002b)	FL	1	Recon X Zoom	ReconXZoom	SIEMENS MED NM	SSPI	\N	\N	\N
f	9063	\N	(0061,002c)	FL	1	Recon Y Zoom	ReconYZoom	SIEMENS MED NM	SSPI	\N	\N	\N
f	9064	\N	(0061,002d)	FL	1	Recon Threshold	ReconThreshold	SIEMENS MED NM	SSPI	\N	\N	\N
f	9065	\N	(0061,002e)	FL	1	Recon Output Pixel Size	ReconOutputPixelSize	SIEMENS MED NM	SSPI	\N	\N	\N
f	9066	\N	(0061,002f)	LO	1-n	Scatter Estimation Method	ScatterEstimationMethod	SIEMENS MED NM	SSPI	\N	\N	\N
f	9067	\N	(0061,0030)	LO	1-n	Scatter Estimation Method Mode	ScatterEstimationMethodMode	SIEMENS MED NM	SSPI	\N	\N	\N
f	9068	\N	(0061,0031)	FL	1-n	Scatter Estimation Lower Window Weights	ScatterEstimationLowerWindowWeights	SIEMENS MED NM	SSPI	\N	\N	\N
f	9069	\N	(0061,0032)	FL	1-n	Scatter Estimation Upper Window Weights	ScatterEstimationUpperWindowWeights	SIEMENS MED NM	SSPI	\N	\N	\N
f	9070	\N	(0061,0033)	LO	1-n	Scatter Estimation Window Mode	ScatterEstimationWindowMode	SIEMENS MED NM	SSPI	\N	\N	\N
f	9071	\N	(0061,0034)	LO	1-n	Scatter Estimation Filter	ScatterEstimationFilter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9072	\N	(0061,0035)	LO	1	Recon RawTomo Input UID	ReconRawTomoInputUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9073	\N	(0061,0036)	LO	1	Recon CT Input UID	ReconCTInputUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9074	\N	(0061,0037)	FL	1	Recon Z Mask Size	ReconZMaskSize	SIEMENS MED NM	SSPI	\N	\N	\N
f	9075	\N	(0061,0038)	FL	1	Recon X Mask Center	ReconXMaskCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9076	\N	(0061,0039)	FL	1	Recon Y Mask Center	ReconYMaskCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9077	\N	(0061,003a)	FL	1	Recon Z Mask Center	ReconZMaskCenter	SIEMENS MED NM	SSPI	\N	\N	\N
f	9078	\N	(0061,0051)	LT	1	Raw Tomo Series UID	RawTomoSeriesUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9079	\N	(0061,0052)	LT	1	LowRes CT Series UID	LowResCTSeriesUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9080	\N	(0061,0053)	LT	1	HighRes CT Series UID	HighResCTSeriesUID	SIEMENS MED NM	SSPI	\N	\N	\N
f	9081	\N	(0071,0001)	LO	1	Unknown	Unknown	SIEMENS WH SR 1.0	SSPI	\N	\N	\N
f	9082	\N	(0071,0002)	LO	1	Unknown	Unknown	SIEMENS WH SR 1.0	SSPI	\N	\N	\N
f	9083	\N	(0071,0021)	UI	1	Registration Matrix UID	RegistrationMatrixUID	SIEMENS MED PT	SSPI	\N	\N	\N
f	9084	\N	(0071,0022)	DT	1	Decay Correction DateTime	DecayCorrectionDateTime	SIEMENS MED PT	SSPI	\N	\N	\N
f	9085	\N	(0071,0023)	US	1	Volume Index	VolumeIndex	SIEMENS MED PT	SSPI	\N	\N	\N
f	9086	\N	(0071,0024)	IS	1	Time Slice Duration	TimeSliceDuration	SIEMENS MED PT	SSPI	\N	\N	\N
f	9087	\N	(0071,0046)	UN	1	Starting Respiratory Amplitude	StartingRespiratoryAmplitude	SIEMENS MED PT WAVEFORM	SSPI	\N	\N	\N
f	9088	\N	(0071,0047)	UN	1	Starting Respiratory Phase	StartingRespiratoryPhase	SIEMENS MED PT WAVEFORM	SSPI	\N	\N	\N
f	9089	\N	(0071,0048)	UN	1	Ending Respiratory Amplitude	EndingRespiratoryAmplitude	SIEMENS MED PT WAVEFORM	SSPI	\N	\N	\N
f	9090	\N	(0071,0049)	UN	1	Ending Respiratory Phase	EndingRespiratoryPhase	SIEMENS MED PT WAVEFORM	SSPI	\N	\N	\N
f	9091	\N	(0071,0050)	CS	1	Respiratory Trigger Type	RespiratoryTriggerType	SIEMENS MED PT WAVEFORM	SSPI	\N	\N	\N
f	9092	\N	(0071,0020)	SQ	1	Registered Image Sequence	RegisteredImageSequence	SIEMENS SYNGO REGISTRATION	SSPI	\N	\N	\N
f	9093	\N	(0071,0021)	CS	1	Registration Is Validated Flag	RegistrationIsValidatedFlag	SIEMENS SYNGO REGISTRATION	SSPI	\N	\N	\N
f	9094	\N	(0071,0000)	SQ	1	Graphic Object Sequence	GraphicObjectSequence	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9095	\N	(0071,0001)	SL	1	Fill Style Version	FillStyleVersion	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9096	\N	(0071,0002)	FL	4	Fill Background Color	FillBackgroundColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9097	\N	(0071,0003)	FL	4	Fill Foreground Color	FillForegroundColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9098	\N	(0071,0004)	SL	1	Fill Mode	FillMode	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9099	\N	(0071,0005)	OB	1	Fill Pattern	FillPattern	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9100	\N	(0071,0006)	SL	1	Line Style Version	LineStyleVersion	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9101	\N	(0071,0007)	FL	4	Line Background Color	LineBackgroundColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9102	\N	(0071,0008)	FL	4	Line Foreground Color	LineForegroundColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9103	\N	(0071,0009)	DS	1	Line Type	LineType	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9104	\N	(0071,0010)	DS	1	Line Thickness	LineThickness	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9105	\N	(0071,0011)	DS	1	Line Shadow X Offset	LineShadowXOffset	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9106	\N	(0071,0012)	DS	1	Line Shadow Y Offset	LineShadowYOffset	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9107	\N	(0071,0013)	DS	1	Shadow Style	ShadowStyle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9108	\N	(0071,0014)	FL	4	Shadow Color	ShadowColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9109	\N	(0071,0015)	DS	1	Stipple Pattern	StipplePattern	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9110	\N	(0071,0016)	DS	1	Line Anti Aliasing	LineAntiAliasing	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9111	\N	(0071,0017)	CS	1	Line-Z-Blend Flag	Line-Z-BlendFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9112	\N	(0071,0018)	SL	1	Text Style Version	TextStyleVersion	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9113	\N	(0071,0019)	FL	4	Text Color	TextColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9114	\N	(0071,0020)	SL	1	Text Horizontal Align	TextHorizontalAlign	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9115	\N	(0071,0021)	SL	1	Text Vertical Align	TextVerticalAlign	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9116	\N	(0071,0022)	DS	1	Text Shadow X Offset	TextShadowXOffset	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9117	\N	(0071,0023)	DS	1	Text Shadow Y Offset	TextShadowYOffset	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9118	\N	(0071,0024)	SL	1	Text Shadow Style	TextShadowStyle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9119	\N	(0071,0025)	FL	4	Text Shadow Color	TextShadowColor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9120	\N	(0071,0026)	CS	1-n	Text Log Font	TextLogFont	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9121	\N	(0071,0027)	CS	1	Text-Z-Blend Flag	Text-Z-BlendFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9122	\N	(0071,0028)	OB	1	Graphic Bit Mask	GraphicBitMask	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9123	\N	(0071,0029)	CS	1	Visiblility Flag	VisiblilityFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9124	\N	(0071,0030)	SL	1	Graphic Sensitivity	GraphicSensitivity	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9125	\N	(0071,0031)	SL	1	Graphic Pick Mode Type	GraphicPickModeType	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9126	\N	(0071,0032)	SL	1	Graphic Layer	GraphicLayer	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9127	\N	(0071,0033)	SL	1	Graphic Object Version	GraphicObjectVersion	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9128	\N	(0071,0034)	SL	1	Graphic Coordinate System	GraphicCoordinateSystem	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9129	\N	(0071,0035)	CS	1	Graphic Custom Attributes	GraphicCustomAttributes	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9130	\N	(0071,0036)	CS	1	Graphic Custom Attributes Key	GraphicCustomAttributesKey	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9131	\N	(0071,0037)	CS	1	Graphic Custom Attributes Value	GraphicCustomAttributesValue	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9132	\N	(0071,0038)	CS	1	Graphic View Name	GraphicViewName	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9133	\N	(0071,0039)	DS	3	Graphic Data	GraphicData	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9134	\N	(0071,0040)	CS	1	Graphic Type	GraphicType	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9135	\N	(0071,0041)	US	1	Number of Graphic Points	NumberOfGraphicPoints	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9136	\N	(0071,0042)	DS	1	Axis Main Tick Length	AxisMainTickLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9137	\N	(0071,0043)	DS	1	Axis Detail Tick Length	AxisDetailTickLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9138	\N	(0071,0044)	DS	1	Axis Main Tick Spacing	AxisMainTickSpacing	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9139	\N	(0071,0045)	DS	1-n	Axis Detail Tick Spacing	AxisDetailTickSpacing	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9140	\N	(0071,0046)	DS	1	Axis Main Tick Count	AxisMainTickCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9141	\N	(0071,0047)	DS	1	Axis Detail Tick Count	AxisDetailTickCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9142	\N	(0071,0048)	SL	1	Axis Tick Behavior	AxisTickBehavior	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9143	\N	(0071,0049)	SL	1	Axis Tick Aligment	AxisTickAligment	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9144	\N	(0071,0050)	DS	1	Axis Step	AxisStep	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9145	\N	(0071,0051)	SL	1	Axis Step Index	AxisStepIndex	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9146	\N	(0071,0052)	CS	1	Axis Text Format	AxisTextFormat	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9147	\N	(0071,0053)	CS	1	Axis Show Center Text Flag	AxisShowCenterTextFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9148	\N	(0071,0054)	CS	1	Axis Show Tick Text Flag	AxisShowTickTextFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9149	\N	(0071,0055)	DS	3	Bitmap X Orientation	BitmapXOrientation	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9150	\N	(0071,0056)	DS	3	Bitmap Y Orientation	BitmapYOrientation	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9151	\N	(0071,0057)	OB	1	Graphic Blob	GraphicBlob	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9152	\N	(0071,0058)	CS	1	Graphic Interpolation	GraphicInterpolation	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9153	\N	(0071,0059)	DS	1	Graphic Angle	GraphicAngle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9154	\N	(0071,0060)	DS	1	Graphic Size	GraphicSize	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9155	\N	(0071,0061)	CS	1	Cut Line Side	CutLineSide	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9156	\N	(0071,0062)	DS	1	Graphic Tip Length	GraphicTipLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9157	\N	(0071,0063)	DS	1	Cut Line Arrow Length	CutLineArrowLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9158	\N	(0071,0064)	DS	1	Line Gap Length	LineGapLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9159	\N	(0071,0065)	DS	1	Graphic Circle Radius	GraphicCircleRadius	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9160	\N	(0071,0066)	DS	1	Line Distance Move	LineDistanceMove	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9161	\N	(0071,0067)	DS	1	Line Marker Length	LineMarkerLength	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9162	\N	(0071,0068)	DS	3	Graphic Center	GraphicCenter	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9163	\N	(0071,0069)	DS	3	Range Center Area Top Left	RangeCenterAreaTopLeft	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9164	\N	(0071,0070)	DS	3	Range Center Area Bottom Right	RangeCenterAreaBottomRight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9165	\N	(0071,0071)	DS	1	Range Tilt	RangeTilt	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9166	\N	(0071,0072)	DS	1	Range Minimum Tilt	RangeMinimumTilt	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9167	\N	(0071,0073)	DS	1	Range Maximum Tilt	RangeMaximumTilt	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9168	\N	(0071,0074)	DS	1	Graphic Width	GraphicWidth	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9169	\N	(0071,0075)	DS	1	Range Minimum Width	RangeMinimumWidth	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9170	\N	(0071,0076)	DS	1	Range Maximum Width	RangeMaximumWidth	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9171	\N	(0071,0077)	DS	1	Graphic Height	GraphicHeight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9172	\N	(0071,0078)	DS	1	Range Feed	RangeFeed	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9173	\N	(0071,0079)	CS	1	Range Direction	RangeDirection	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9174	\N	(0071,0080)	CS	1	Range Show Scans	RangeShowScans	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9175	\N	(0071,0081)	DS	1	Range Minimum Scan Distance	RangeMinimumScanDistance	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9176	\N	(0071,0082)	CS	1	Range Orthogonal Height	RangeOrthogonalHeight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9177	\N	(0071,0083)	DS	3	Graphic Position	GraphicPosition	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9178	\N	(0071,0084)	CS	1	Graphic Closed Flag	GraphicClosedFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9179	\N	(0071,0085)	SL	1	Range Line Tip Mode	RangeLineTipMode	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9180	\N	(0071,0086)	SL	1	Graphic List Count	GraphicListCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9181	\N	(0071,0087)	CS	1	Axis Flip Text Flag	AxisFlipTextFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9182	\N	(0071,0088)	CS	1	Curve Diagram Type	CurveDiagramType	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9183	\N	(0071,0089)	DS	1	Graphic Start Angle	GraphicStartAngle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9184	\N	(0071,0090)	DS	1	Graphic End Angle	GraphicEndAngle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9185	\N	(0071,0091)	IS	1	Live Wire Smoothness	LiveWireSmoothness	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9186	\N	(0071,0092)	CS	1	Live Wire Spline Flag	LiveWireSplineFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9187	\N	(0071,0093)	CS	1	Ellipse Circle Flag	EllipseCircleFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9188	\N	(0071,0094)	CS	1	Graphic Square Flag	GraphicSquareFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9189	\N	(0071,0095)	DS	1	Curve Section Start Index	CurveSectionStartIndex	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9190	\N	(0071,0096)	DS	1	Curve Section End Index	CurveSectionEndIndex	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9191	\N	(0071,0097)	DS	1	Marker Alpha	MarkerAlpha	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9192	\N	(0071,0098)	IS	1	Table Row Count	TableRowCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9193	\N	(0071,0099)	IS	1	Table Column Count	TableColumnCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9194	\N	(0071,009a)	DS	1	Table Row Height	TableRowHeight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9195	\N	(0071,009b)	DS	1	Table Column Width	TableColumnWidth	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9196	\N	(0071,009c)	IS	1	Rectangle Selection Segment Offset	RectangleSelectionSegmentOffset	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9197	\N	(0071,009d)	CS	1	Graphic Text	GraphicText	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9198	\N	(0071,00a0)	SL	1	Axis Tick Spacing Coordinate System	AxisTickSpacingCoordinateSystem	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9199	\N	(0071,00a1)	CS	1	Axis Diagram Grid Type	AxisDiagramGridType	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9200	\N	(0071,00a2)	SL	1	Polar Plot Circle Count	PolarPlotCircleCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9201	\N	(0071,00a3)	SL	1	Polar Plot Lines-per-Circle	PolarPlotLines-per-Circle	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9202	\N	(0071,00a4)	SL	1	Polar Plot Compartment Count	PolarPlotCompartmentCount	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9203	\N	(0071,00a5)	SL	1	Polar Plot Radius Weight	PolarPlotRadiusWeight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9204	\N	(0071,00a6)	DS	1	Circle Segment Outer Radius	CircleSegmentOuterRadius	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9205	\N	(0071,00a7)	CS	1	Circle Segment Clockwise Flag	CircleSegmentClockwiseFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9206	\N	(0071,00a8)	CS	1	Axis Diagram Auto Resize Flag	AxisDiagramAutoResizeFlag	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9207	\N	(0071,00a9)	DS	1	Axis Diagram Step Start	AxisDiagramStepStart	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9208	\N	(0071,00b0)	CS	1	Group Root	GroupRoot	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9209	\N	(0071,00b1)	ST	1	Group Name	GroupName	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9210	\N	(0071,00b2)	SQ	1	Graphic Annotation Sequence	GraphicAnnotationSequence	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9211	\N	(0071,00b3)	SL	1	Text Minimum Height	TextMinimumHeight	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9212	\N	(0071,00b4)	DS	1	Text Font Scaling Factor	TextFontScalingFactor	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9213	\N	(0071,00b5)	SL	2	Text Maximum Extensions	TextMaximumExtensions	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9214	\N	(0071,00b6)	CS	1	Text Segment Size	TextSegmentSize	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9215	\N	(0071,00b7)	SL	1	Graphic Object Reference Label	GraphicObjectReferenceLabel	SIEMENS SYNGO OBJECT GRAPHICS	SSPI	\N	\N	\N
f	9216	\N	(0073,0002)	US	1	Hanging Protocol Excellence Rank	HangingProtocolExcellenceRank	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9217	\N	(0073,0004)	CS	1	Template Data Role ID	TemplateDataRoleID	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9218	\N	(0073,0006)	CS	1	Data Sharing Flag	DataSharingFlag	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9219	\N	(0073,0008)	SQ	1	Bagging Operations Sequence	BaggingOperationsSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9220	\N	(0073,0010)	LO	1	Synchronization Type	SynchronizationType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9221	\N	(0073,0012)	LO	1	Custom Filter Type	CustomFilterType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9222	\N	(0073,0014)	LO	1	Custom Sorter Type	CustomSorterType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9223	\N	(0073,0016)	CS	1	Reference Template Data Role ID	ReferenceTemplateDataRoleID	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9224	\N	(0073,0018)	CS	1	Model Template Data Role ID	ModelTemplateDataRoleID	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9225	\N	(0073,0020)	DT	1-n	Selector DT Value	SelectorDTValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9226	\N	(0073,0022)	DA	1-n	Selector DA Value	SelectorDAValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9227	\N	(0073,0024)	TM	1-n	Selector TM Value	SelectorTMValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9228	\N	(0073,0026)	UI	1-n	Selector UI Value	SelectorUIValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9229	\N	(0073,0028)	CS	1	Referenced Template Data Role	ReferencedTemplateDataRole	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9230	\N	(0073,0030)	SQ	1	Custom Property Sequence	CustomPropertySequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9231	\N	(0073,0032)	CS	1	Custom Property Type	CustomPropertyType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9232	\N	(0073,0034)	LO	1	Custom Property Name	CustomPropertyName	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9233	\N	(0073,0036)	LO	1	Custom Property Value	CustomPropertyValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9234	\N	(0073,0038)	SQ	1	Layout Property Sequence	LayoutPropertySequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9235	\N	(0073,0040)	SQ	1	Synchronization Sequence	SynchronizationSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9236	\N	(0073,0042)	CS	1	Presentation Creator Type	PresentationCreatorType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9237	\N	(0073,0044)	CS	1	Cine Navigation Type	CineNavigationType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9238	\N	(0073,0048)	LO	1	Semantic Naming Strategy	SemanticNamingStrategy	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9239	\N	(0073,0050)	LO	1	Parameter String	ParameterString	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9240	\N	(0073,0052)	CS	1	Sorting Order	SortingOrder	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9241	\N	(0073,0054)	CS	1	syngo Template Type	syngoTemplateType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9242	\N	(0073,0056)	CS	1	Sorter Type	SorterType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9243	\N	(0073,0058)	SH	1	Data Display Protocol Version	DataDisplayProtocolVersion	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9244	\N	(0073,005a)	CS	1	Timepoint Value	TimepointValue	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9245	\N	(0073,005b)	CS	1	Sharing Group Sequence	SharingGroupSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9246	\N	(0073,005c)	CS	1	Template Selector Operator	TemplateSelectorOperator	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9247	\N	(0073,005d)	CS	1	Sharing Type	SharingType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9248	\N	(0073,0060)	SQ	1	Viewport Definitions Sequence	ViewportDefinitionsSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9249	\N	(0073,0062)	CS	1	Protocol Type	ProtocolType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9250	\N	(0073,0064)	SQ	1	Template Selector Sequence	TemplateSelectorSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9251	\N	(0073,0066)	CS	1	Default Template	DefaultTemplate	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9252	\N	(0073,0068)	CS	1	Is Preferred	IsPreferred	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9253	\N	(0073,006a)	SQ	1	Timepoint Initial Value Sequence	TimepointInitialValueSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9254	\N	(0073,006c)	CS	1	Timepoint Variable	TimepointVariable	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9255	\N	(0073,0070)	SH	1	Display Protocol Name	DisplayProtocolName	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9256	\N	(0073,0072)	LO	1	Display Protocol Description	DisplayProtocolDescription	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9257	\N	(0073,0074)	CS	1	Display Protocol Level	DisplayProtocolLevel	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9258	\N	(0073,0076)	LO	1	Display Protocol Creator	DisplayProtocolCreator	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9259	\N	(0073,0078)	DT	1	Display Protocol Creation Datetime	DisplayProtocolCreationDatetime	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9260	\N	(0073,007a)	UI	1	Referenced Data Protocol	ReferencedDataProtocol	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9261	\N	(0073,007c)	US	1	Display Protocol Excellence Rank	DisplayProtocolExcellenceRank	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9262	\N	(0073,007e)	SQ	1	Layout Sequence	LayoutSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9263	\N	(0073,0080)	US	1	Layout Number	LayoutNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9264	\N	(0073,0082)	LO	1	Layout Description	LayoutDescription	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9265	\N	(0073,0084)	SQ	1	Segment Sequence	SegmentSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9266	\N	(0073,0086)	US	1	Segment Number	SegmentNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9267	\N	(0073,0088)	LO	1	Segment Description	SegmentDescription	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9268	\N	(0073,008a)	CS	1	Segment Type	SegmentType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9269	\N	(0073,008c)	US	1	Tile Horizontal Dimension	TileHorizontalDimension	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9270	\N	(0073,008e)	US	1	Tile Vertical Dimension	TileVerticalDimension	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9271	\N	(0073,0090)	CS	1	Fill Order	FillOrder	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9272	\N	(0073,0092)	CS	1	Segment Small Scroll Type	SegmentSmallScrollType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9273	\N	(0073,0094)	US	1	Segment Small Scroll Amount	SegmentSmallScrollAmount	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9274	\N	(0073,0096)	CS	1	Segment Large Scroll Type	SegmentLargeScrollType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9275	\N	(0073,0098)	US	1	Segment Large Scroll Amount	SegmentLargeScrollAmount	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9276	\N	(0073,009a)	US	1	Segment Overlap Priority	SegmentOverlapPriority	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9277	\N	(0073,009c)	SQ	1	Data Role View Sequence	DataRoleViewSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9278	\N	(0073,009e)	US	1	Data Role View Number	DataRoleViewNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9279	\N	(0073,00a2)	US	1	Referenced Data Role	ReferencedDataRole	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9280	\N	(0073,00a4)	CS	1	Sharing Enabled	SharingEnabled	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9281	\N	(0073,00a8)	US	2-n	Referenced Data Role Views	ReferencedDataRoleViews	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9282	\N	(0073,00b0)	SH	1	Data Protocol Name	DataProtocolName	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9283	\N	(0073,00b2)	LO	1	Data Protocol Description	DataProtocolDescription	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9284	\N	(0073,00b4)	CS	1	Data Protocol Level	DataProtocolLevel	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9285	\N	(0073,00b6)	LO	1	Data Protocol Creator	DataProtocolCreator	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9286	\N	(0073,00b8)	DT	1	Data Protocol Creation Datetime	DataProtocolCreationDatetime	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9287	\N	(0073,00ba)	US	1	Data Protocol Excellence Rank	DataProtocolExcellenceRank	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9288	\N	(0073,00bc)	SQ	1	Data Protocol Definition Sequence	DataProtocolDefinitionSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9289	\N	(0073,00be)	SQ	1	Data Role Sequence	DataRoleSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9290	\N	(0073,00c0)	US	1	Data Role Number	DataRoleNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9291	\N	(0073,00c2)	SH	1	Data Role Name	DataRoleName	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9292	\N	(0073,00c6)	SQ	1	Selector Operations Sequence	SelectorOperationsSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9293	\N	(0073,00c8)	CS	1	Selector Usage Flag	SelectorUsageFlag	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9294	\N	(0073,00ca)	CS	1	Select by Attribute Presence	SelectByAttributePresence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9295	\N	(0073,00cc)	CS	1	Select by Category	SelectByCategory	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9296	\N	(0073,00ce)	CS	1	Select by Operator	SelectByOperator	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9297	\N	(0073,00d0)	LO	1	Custom Selector Type	CustomSelectorType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9298	\N	(0073,00d2)	CS	1	Selector Operator	SelectorOperator	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9299	\N	(0073,00d4)	CS	1	Reformatting Required	ReformattingRequired	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9300	\N	(0073,00d6)	SQ	1	Registration Data Sequence	RegistrationDataSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9301	\N	(0073,00d8)	US	1	Reference Data Role Number	ReferenceDataRoleNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9302	\N	(0073,00da)	SQ	1	Model Data Sequence	ModelDataSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9303	\N	(0073,00dc)	US	1	Model Data Role Number	ModelDataRoleNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9304	\N	(0073,00de)	SQ	1	Fusion Display Sequence	FusionDisplaySequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9305	\N	(0073,00e0)	FD	1	Transparency	Transparency	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9306	\N	(0073,00e2)	CS	1	Time Point	TimePoint	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9307	\N	(0073,00e4)	LO	1	First Time Point Token	FirstTimePointToken	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9308	\N	(0073,00e6)	LO	1	Last Time Point Token	LastTimePointToken	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9309	\N	(0073,00e8)	LO	1	Intermediate Time Point Token	IntermediateTimePointToken	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9310	\N	(0073,00ea)	SQ	1	Data Processor Sequence	DataProcessorSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9311	\N	(0073,00ec)	LO	1	Data Processor Type	DataProcessorType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9312	\N	(0073,00ee)	SQ	1	Template Data Role Sequence	TemplateDataRoleSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9313	\N	(0073,00f0)	SQ	1	View Sequence	ViewSequence	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9314	\N	(0073,00f4)	LO	1	View Type	ViewType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9315	\N	(0073,00f6)	LO	1	Custom Bagging Type	CustomBaggingType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9316	\N	(0073,00f8)	US	1	Referenced Display Segment Number	ReferencedDisplaySegmentNumber	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9317	\N	(0073,00fa)	LO	1	Data Role Type	DataRoleType	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9318	\N	(0073,0046)	CS	1	Internal Flag	InternalFlag	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9319	\N	(0073,00fc)	CS	1	Unassigned Flag	UnassignedFlag	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9320	\N	(0073,00fe)	CS	1	Initial Display Scroll Position	InitialDisplayScrollPosition	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9321	\N	(0073,00ff)	LO	1	VRT Preset	VRTPreset	SIEMENS SYNGO LAYOUT PROTOCOL	SSPI	\N	\N	\N
f	9322	\N	(0091,0020)	PN	1	RIS Patient Name	RISPatientName	SIENET	SSPI	\N	\N	\N
f	9323	\N	(0093,0002)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	2232	\N	(0095,0001)	LO	1	Examination Folder ID	ExaminationFolderID	SIENET	SSPI	\N	\N	\N
f	2233	\N	(0095,0004)	UL	1	Folder Reported Status	FolderReportedStatus	SIENET	SSPI	\N	\N	\N
f	2234	\N	(0095,0005)	LO	1	Folder Reporting Radiologist	FolderReportingRadiologist	SIENET	SSPI	\N	\N	\N
f	2235	\N	(0095,0007)	LO	1	SIENET ISA PLA	SIENETISAPLA	SIENET	SSPI	\N	\N	\N
f	9324	\N	(0095,000c)	SL	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	9325	\N	(0095,0020)	PN	1	RIS Patient Name	RISPatientName	SIENET	SSPI	\N	\N	\N
f	9326	\N	(0097,0003)	SL	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	9327	\N	(0097,0005)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	2236	\N	(0099,0002)	SL	1	Data Object Attributes	DataObjectAttributes	SIENET	SSPI	\N	\N	\N
f	9328	\N	(0099,0005)	SL	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	9329	\N	(00a5,0005)	LO	1	Unknown	Unknown	SIENET	SSPI	\N	\N	\N
f	1577	\N	(0193,0002)	DS	1	RIS Key	RISKey	SIEMENS ISI	SSPI	\N	\N	\N
f	1578	\N	(0307,0001)	UN	1	RIS Worklist IMGEF	RISWorklistIMGEF	SIEMENS ISI	SSPI	\N	\N	\N
f	1579	\N	(0309,0001)	UN	1	RIS Report IMGEF	RISReportIMGEF	SIEMENS ISI	SSPI	\N	\N	\N
f	1580	\N	(4009,0001)	LO	1	Report ID	ReportID	SIEMENS ISI	SSPI	\N	\N	\N
f	1581	\N	(4009,0020)	LO	1	Report Status	ReportStatus	SIEMENS ISI	SSPI	\N	\N	\N
f	1582	\N	(4009,0030)	DA	1	Report Creation Date	ReportCreationDate	SIEMENS ISI	SSPI	\N	\N	\N
f	1583	\N	(4009,0070)	LO	1	Report Approving Physician	ReportApprovingPhysician	SIEMENS ISI	SSPI	\N	\N	\N
f	1584	\N	(4009,00e0)	LO	1	Report Text	ReportText	SIEMENS ISI	SSPI	\N	\N	\N
f	1585	\N	(4009,00e1)	LO	1	Report Author	ReportAuthor	SIEMENS ISI	SSPI	\N	\N	\N
f	1586	\N	(4009,00e3)	LO	1	Reporting Radiologist	ReportingRadiologist	SIEMENS ISI	SSPI	\N	\N	\N
f	1365	\N	(6021,0000)	LO	1	Image Graphics Format Code	ImageGraphicsFormatCode	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1490	\N	(6021,0000)	LO	1	Osteo Contour Comment	OsteoContourComment	SIEMENS CT VA0  OST	SSPI	\N	\N	\N
f	1366	\N	(6021,0010)	LO	1	Image Graphics	ImageGraphics	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	1491	\N	(6021,0010)	US	256	Osteo Contour Buffer	OsteoContourBuffer	SIEMENS CT VA0  OST	SSPI	\N	\N	\N
f	1629	\N	(7001,0010)	LO	1	Dummy	Dummy	SIEMENS MED	SSPI	\N	\N	\N
f	1630	\N	(7003,0010)	LO	1	Header	Header	SIEMENS MED	SSPI	\N	\N	\N
f	1631	\N	(7005,0010)	LO	1	Dummy	Dummy	SIEMENS MED	SSPI	\N	\N	\N
f	1367	\N	(7fe1,0000)	OB	1-n	Binary Data	BinaryData	SIEMENS CM VA0  CMS	SSPI	\N	\N	\N
f	9330	\N	(7fe1,0010)	OB	1	CSA Data	CSAData	SIEMENS CSA NON-IMAGE	SSPI	\N	\N	\N
f	1812	\N	(7fe3,0000)	LO	1	Image Graphics Format Code	ImageGraphicsFormatCode	SIEMENS NUMARIS II	SSPI	\N	\N	\N
f	1813	\N	(7fe3,0010)	OB	1	Image Graphics	ImageGraphics	SIEMENS NUMARIS II	SSPI	\N	\N	\N
f	1814	\N	(7fe3,0020)	OB	1	Image Graphics Dummy	ImageGraphicsDummy	SIEMENS NUMARIS II	SSPI	\N	\N	\N
f	9331	\N	(7fe3,0014)	OW	1	Minimum Pixel in Frame	MinimumPixelInFrame	SIEMENS MED NM	SSPI	\N	\N	\N
f	9332	\N	(7fe3,0015)	OW	1	Maximum Pixel in Frame	MaximumPixelInFrame	SIEMENS MED NM	SSPI	\N	\N	\N
f	9333	\N	(7fe3,0016)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9334	\N	(7fe3,001b)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9335	\N	(7fe3,001c)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9336	\N	(7fe3,001e)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9337	\N	(7fe3,0026)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9338	\N	(7fe3,0027)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9339	\N	(7fe3,0028)	OW	1	Unknown	Unknown	SIEMENS MED NM	SSPI	\N	\N	\N
f	9340	\N	(7fe3,0029)	OW	1	Number of R-Waves in Frame	NumberOfRWavesInFrame	SIEMENS MED NM	SSPI	\N	\N	\N
f	9341	\N	(0077,0010)	LO	1	Evidence Document Template Name	EvidenceDocumentTemplateName	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9342	\N	(0077,0011)	DS	1	Evidence Document Template Version	EvidenceDocumentTemplateVersion	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9343	\N	(0077,0020)	OB	1	Clinical Finding Data	ClinicalFindingData	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9344	\N	(0077,0021)	OB	1	Metadata	Metadata	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9345	\N	(0077,0030)	DS	1	Implementation Version	ImplementationVersion	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9346	\N	(0077,0040)	OB	1	Predecessor	Predecessor	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9347	\N	(0077,0050)	LO	1	Logical ID	LogicalID	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9348	\N	(0077,0060)	OB	1	Application Data	ApplicationData	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9349	\N	(0077,0070)	LO	1	Owner Clinical Task Name	OwnerClinicalTaskName	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9350	\N	(0077,0071)	LO	1	Owner Task Name	OwnerTaskName	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9351	\N	(0077,0072)	OB	1	Owner Supported Templates	OwnerSupportedTemplates	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9352	\N	(0077,0080)	OB	1	Volume Catalog	VolumeCatalog	SIEMENS SYNGO EVIDENCE DOCUMENT DATA	SSPI	\N	\N	\N
f	9353	\N	(0021,00ad)	OB	1	Data	Data	syngoDynamics_Reporting	SSPI	\N	\N	\N
f	9354	\N	(0087,0020)	OB	1	Study Model	StudyModel	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	SSPI	\N	\N	\N
f	9355	\N	(0087,0030)	OB	1	Report XML Schema	ReportXMLSchema	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	SSPI	\N	\N	\N
f	9356	\N	(0087,0040)	OB	1	Report Identifier	ReportIdentifier	SIEMENS SYNGO ENCAPSULATED DOCUMENT DATA	SSPI	\N	\N	\N
f	9357	\N	(0029,0008)	UI	1	Object Series Instance UID	ObjectSeriesInstanceUID	SIEMENS SYNGO 3D FUSION MATRIX	SSPI	\N	\N	\N
f	9358	\N	(0029,0009)	UI	1	Model Series Instance UID	ModelSeriesInstanceUID	SIEMENS SYNGO 3D FUSION MATRIX	SSPI	\N	\N	\N
f	9359	\N	(0029,0010)	UI	1	Matrix Referenced Series Instance UID	MatrixReferencedSeriesInstanceUID	SIEMENS SYNGO 3D FUSION MATRIX	SSPI	\N	\N	\N
f	9360	\N	(0019,002d)	US	1	B-mode Tint Index	BModeTintIndex	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9361	\N	(0019,0072)	US	1	Doppler Tint Index	DopplerTintIndex	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9362	\N	(0019,0088)	US	1	M-mode Tint Index	MModeTintIndex	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9363	\N	(0019,0089)	LO	1	Unknown	Unknown	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9364	\N	(0119,0000)	LO	1	Acoustic Meta Information Version	AcousticMetaInformationVersion	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9365	\N	(0119,0001)	UN	1	Common Acoustic Meta Information	CommonAcousticMetaInformation	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9366	\N	(0119,0002)	SQ	1	Multi Stream Sequence	MultiStreamSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9367	\N	(0119,0003)	SQ	1	Acoustic Data Sequence	AcousticDataSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9368	\N	(0119,0004)	UN	1	Per Transaction Acoustic Control Information	PerTransactionAcousticControlInformation	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9369	\N	(0119,0005)	UN	1	Acoustic Data Offset	AcousticDataOffset	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9370	\N	(0119,0006)	UN	1	Acoustic Data Length	AcousticDataLength	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9371	\N	(0119,0007)	UN	1	Footer Offset	FooterOffset	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9372	\N	(0119,0008)	UN	1	Footer Length	FooterLength	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9373	\N	(0119,0009)	UN	1	Acoustic Stream Number	AcousticStreamNumber	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9374	\N	(0119,0010)	UN	1	Acoustic Stream Type	AcousticStreamType	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9375	\N	(0119,0011)	UN	1	Stage Timer Time	StageTimerTime	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9376	\N	(0119,0012)	UN	1	Stop Watch Time	StopWatchTime	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9377	\N	(0119,0013)	UN	1	Volume Rate	VolumeRate	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9378	\N	(0129,0000)	SQ	1	MPR View Sequence	MPRViewSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9379	\N	(0129,0002)	UI	1	Bookmark UID	BookmarkUID	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9380	\N	(0129,0003)	UN	1	Plane Origin Vector	PlaneOriginVector	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9381	\N	(0129,0004)	UN	1	Row Vector	RowVector	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9382	\N	(0129,0005)	UN	1	Column Vector	ColumnVector	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9383	\N	(0129,0006)	SQ	1	Visualization Sequence	VisualizationSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9384	\N	(0129,0007)	UI	1	Bookmark UID	BookmarkUID	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9385	\N	(0129,0008)	UN	1	Visualization Information	VisualizationInformation	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9386	\N	(0129,0009)	SQ	1	Application State Sequence	ApplicationStateSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9387	\N	(0129,0010)	OB	1	Application State Information	ApplicationStateInformation	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9388	\N	(0129,0011)	SQ	1	Referenced Bookmark Sequence	ReferencedBookmarkSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9389	\N	(0129,0012)	UI	1	Referenced Bookmark UID	ReferencedBookmarkUID	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9390	\N	(0129,0020)	SQ	1	Cine Parameters Sequence	CineParametersSequence	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9391	\N	(0129,0021)	UN	1	Cine Parameters Schema	CineParametersSchema	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9392	\N	(0129,0022)	UN	1	Values of Cine Parameters	ValuesOfCineParameters	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9393	\N	(0129,0030)	CS	1	Raw Data Object Type	RawDataObjectType	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9394	\N	(0139,0001)	SL	1	Physio Capture ROI	PhysioCaptureROI	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9395	\N	(0149,0001)	FD	1-n	Vector of BROI Points	VectorOfBROIPoints	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9396	\N	(0149,0002)	FD	1-n	Start/End Timestamps of Strip Stream	StartEndTimestampsOfStripStream	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9397	\N	(0149,0003)	FD	1-n	Timestamps of Visible R-waves	TimestampsOfVisibleRWaves	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9398	\N	(7fd1,0001)	UN	1	Acoustic Image and Footer Data	AcousticImageAndFooterData	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9399	\N	(7fd1,0009)	UN	1	Volume Version ID	VolumeVersionID	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9400	\N	(7fd1,0010)	UN	1	Volume Payload	VolumePayload	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9401	\N	(7fd1,0011)	UN	1	After Payload	AfterPayload	SIEMENS Ultrasound SC2000	SSPI	\N	\N	\N
f	9402	\N	(7fdf,00fc)	OB	1	Pixel Data Leading Padding	PixelDataLeadingPadding	SIEMENS SYNGO DATA PADDING	SSPI	\N	\N	\N
f	9403	\N	(0019,0008)	CS	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9404	\N	(0019,0009)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9405	\N	(0019,000a)	US	1	Number of Images in Mosaic	NumberOfImagesInMosaic	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9406	\N	(0019,000b)	DS	1	Slice Measurement Duration	SliceMeasurementDuration	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9407	\N	(0019,000c)	IS	1	B Value	BValue	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9408	\N	(0019,000d)	CS	1	Diffusion Directionality	DiffusionDirectionality	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9409	\N	(0019,000e)	FD	3	Diffusion Gradient Direction	DiffusionGradientDirection	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9410	\N	(0019,000f)	SH	1	Gradient Mode	GradientMode	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9411	\N	(0019,0011)	SH	1	Flow Compensation	FlowCompensation	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9412	\N	(0019,0012)	SL	3	Table Position Origin	TablePositionOrigin	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9413	\N	(0019,0013)	SL	3	Ima Abs Table Position	ImaAbsTablePosition	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9414	\N	(0019,0014)	IS	3	Ima Rel Table Position	ImaRelTablePosition	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9415	\N	(0019,0015)	FD	3	Slice Position PCS	SlicePosition_PCS	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9416	\N	(0019,0016)	DS	1	Time After Start	TimeAfterStart	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9417	\N	(0019,0017)	DS	1	Slice Resolution	SliceResolution	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9418	\N	(0019,0018)	IS	1	Real Dwell Time	RealDwellTime	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9419	\N	(0019,0023)	IS	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9420	\N	(0019,0025)	FD	1-n	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9421	\N	(0019,0026)	FD	1-n	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9422	\N	(0019,0027)	FD	6	B Matrix	BMatrix	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9423	\N	(0019,0028)	FD	1	Bandwidth per Pixel Phase Encode	BandwidthPerPixelPhaseEncode	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9424	\N	(0019,0029)	FD	1-n	Mosaic Ref Acq Times	MosaicRefAcqTimes	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9425	\N	(0021,0001)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9426	\N	(0021,0002)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9427	\N	(0021,0003)	OB	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9428	\N	(0021,0004)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9429	\N	(0021,0005)	IS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9430	\N	(0021,0006)	LO	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9431	\N	(0021,0007)	LO	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9432	\N	(0021,0008)	SH	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9433	\N	(0021,0009)	LO	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9434	\N	(0021,000a)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9435	\N	(0021,000c)	SH	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9436	\N	(0021,000d)	US	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9437	\N	(0021,000f)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9438	\N	(0021,0010)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9439	\N	(0021,0011)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9440	\N	(0021,0012)	FD	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9441	\N	(0021,0013)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9442	\N	(0021,0014)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9443	\N	(0021,0016)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9444	\N	(0021,0017)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9445	\N	(0021,0018)	SH	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9446	\N	(0021,0019)	OB	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9447	\N	(0021,001a)	LO	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9448	\N	(0021,001b)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9449	\N	(0021,001c)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9450	\N	(0021,001d)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9451	\N	(0021,001f)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9452	\N	(0021,0022)	SH	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9453	\N	(0021,0023)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9454	\N	(0021,0025)	SL	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9455	\N	(0021,0026)	IS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9456	\N	(0021,0027)	US	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9457	\N	(0021,002a)	IS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9458	\N	(0021,002b)	ST	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9459	\N	(0021,002c)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9460	\N	(0021,002d)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9461	\N	(0021,002e)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9462	\N	(0021,002f)	DS	1-n	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9463	\N	(0021,0030)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9464	\N	(0021,0031)	IS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9465	\N	(0021,0032)	SS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9466	\N	(0021,0033)	SH	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9467	\N	(0021,0034)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9468	\N	(0021,0035)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9469	\N	(0021,0036)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9470	\N	(0021,0038)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9471	\N	(0021,003b)	DS	1	Unknown	Unknown	SIEMENS SERIES SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9472	\N	(0021,0001)	US	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9473	\N	(0021,0002)	FD	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9474	\N	(0021,0003)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9475	\N	(0021,0004)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9476	\N	(0021,0005)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9477	\N	(0021,0006)	LO	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9478	\N	(0021,001a)	SH	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9479	\N	(0021,001c)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9480	\N	(0021,001f)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9481	\N	(0021,0020)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9482	\N	(0021,0022)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9483	\N	(0021,0024)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9484	\N	(0021,0025)	LT	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9485	\N	(0021,0026)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9486	\N	(0021,0027)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9487	\N	(0021,002a)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9488	\N	(0021,002b)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9489	\N	(0021,002c)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9490	\N	(0021,002d)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9491	\N	(0021,002e)	UL	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9492	\N	(0021,0033)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9493	\N	(0021,0034)	FD	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9494	\N	(0021,0035)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9495	\N	(0021,0037)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9496	\N	(0021,003a)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9497	\N	(0021,003b)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9498	\N	(0021,003c)	FD	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9499	\N	(0021,003d)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9500	\N	(0021,003f)	SH	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9501	\N	(0021,0040)	DS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9502	\N	(0021,0041)	SH	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9503	\N	(0021,0042)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9504	\N	(0021,0043)	LT	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9505	\N	(0021,0044)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9506	\N	(0021,0045)	SL	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9507	\N	(0021,0046)	FD	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9508	\N	(0021,0047)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9509	\N	(0021,0048)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9510	\N	(0021,0049)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9511	\N	(0021,004b)	LT	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9688	\N	(0021,0034)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9512	\N	(0021,004e)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9513	\N	(0021,004f)	LO	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9514	\N	(0021,0051)	UL	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9515	\N	(0021,0052)	US	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9516	\N	(0021,0053)	FD	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9517	\N	(0021,0054)	US	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9518	\N	(0021,0056)	LO	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9519	\N	(0021,0058)	SH	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9520	\N	(0021,0059)	IS	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9521	\N	(0021,005a)	FD	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9522	\N	(0021,005b)	FD	1-n	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9523	\N	(0021,005e)	IS	1	Unknown	Unknown	SIEMENS IMAGE SHADOW ATTRIBUTES	SSPI	\N	\N	\N
f	9524	\N	(0021,0001)	SQ	1	MR Image Sequence	MRImageSequence	SIEMENS MR IMA	SSPI	\N	\N	\N
f	9525	\N	(0021,0030)	SQ	1	Background Color DR Sequence	BackgroundColorDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9526	\N	(0021,0031)	DS	3	Background Color	BackgroundColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9527	\N	(0021,0036)	SQ	1	Field Map DR Sequence	FieldMapDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9528	\N	(0021,0037)	CS	1	Visible	Visible	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9529	\N	(0021,0038)	DS	3	Tinting Color	TintingColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9530	\N	(0021,0039)	CS	1	Tinting Enabled	TintingEnabled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9531	\N	(0021,003a)	LO	1	Volume ID	VolumeID	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9532	\N	(0021,003b)	LO	1	Volume ID As Bound	VolumeIDAsBound	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9533	\N	(0021,0041)	SQ	1	Floating MPR Color LUT DR Sequence	FloatingMPRColorLUTDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9534	\N	(0021,0042)	DS	1	RGBA LUT	RGBALUT	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9535	\N	(0021,0043)	DS	1	Blend Factor	BlendFactor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9536	\N	(0021,0044)	SQ	1	RGBA LUT Data Sequence	RGBALUTDataSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9537	\N	(0021,0045)	OB	1	Color LUT	ColorLUT	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9538	\N	(0021,004a)	SQ	1	Ortho MPR ColorLUT DR Sequence	OrthoMPRColorLUTDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9539	\N	(0021,004b)	SQ	1	VRT Color LUT DR Sequence	VRTColorLUTDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9540	\N	(0021,004d)	SQ	1	Pwl Transfer Function Data Sequence	PwlTransferFunctionDataSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9541	\N	(0021,004c)	SQ	1	Pwl Transfer Function Sequence	PwlTransferFunctionSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9542	\N	(0021,004e)	DS	1	Pwl Vertex Index	PwlVertexIndex	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9543	\N	(0021,0050)	SQ	1	Pwl Vertex Sequence	PwlVertexSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9544	\N	(0021,0051)	SQ	1	Floating MPR Render DR Sequence	FloatingMPRRenderDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9545	\N	(0021,0052)	CS	1	Primary Show Hide	PrimaryShowHide	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9546	\N	(0021,0056)	CS	1	Alpha Dependent Fieldmap	AlphaDependentFieldmap	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9547	\N	(0021,0057)	LO	1	Volume Filter	VolumeFilter	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9548	\N	(0021,005a)	SQ	1	Ortho MPR Render DR Sequence	OrthoMPRRenderDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9549	\N	(0021,005b)	SQ	1	VRT Render DR Sequence	VRTRenderDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9550	\N	(0021,0053)	CS	1	Secondary Show Hide	SecondaryShowHide	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9551	\N	(0021,0054)	LO	1	Primary Shading Index	PrimaryShadingIndex	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9552	\N	(0021,0055)	LO	1	Secondary Shading Index	SecondaryShadingIndex	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9553	\N	(0021,0058)	DS	3	Bounding Box Color	BoundingBoxColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9554	\N	(0021,0059)	CS	1	Scene Interaction On	SceneInteractionOn	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9555	\N	(0021,0060)	SQ	6	Clip Plane DR Sequence	ClipPlaneDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9556	\N	(0021,0061)	DS	3	Plane Center	PlaneCenter	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9557	\N	(0021,0062)	DS	3	Plane Normal	PlaneNormal	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9558	\N	(0021,0063)	DS	2	Plane Scale	PlaneScale	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9559	\N	(0021,0064)	CS	1	Plane Enable GL Clip	PlaneEnableGLClip	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9560	\N	(0021,0065)	DS	1	Plane Handle Ratio	PlaneHandleRatio	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9561	\N	(0021,0066)	DS	24	Plane Bounding Points	PlaneBoundingPoints	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9562	\N	(0021,0067)	DS	16	Plane Motion Matrix	PlaneMotionMatrix	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9563	\N	(0021,0068)	DS	1	Plane Shift Velocity	PlaneShiftVelocity	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9564	\N	(0021,0069)	CS	1	Plane Enabled	PlaneEnabled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9565	\N	(0021,006a)	DS	1	Plane Rotate Velocity	PlaneRotateVelocity	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9566	\N	(0021,006b)	CS	1	Plane Show Graphics	PlaneShowGraphics	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9567	\N	(0021,0073)	CS	1	Plane Single Selection Mode	PlaneSingleSelectionMode	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9568	\N	(0021,0074)	CS	1	Plane Alignment	PlaneAlignment	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9569	\N	(0021,0075)	CS	1	Plane Selected	PlaneSelected	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9570	\N	(0021,0070)	SQ	1	Split Plane DR Sequence	SplitPlaneDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9571	\N	(0021,0071)	SQ	3	Floating MPR DR Sequence	FloatingMPRDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9572	\N	(0021,006e)	CS	1	Plane MPR Locked	PlaneMPRLocked	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9573	\N	(0021,006f)	CS	1	Plane Scaling Disabled	PlaneScalingDisabled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9574	\N	(0021,0072)	SQ	3	Ortho MPR DR Sequence	OrthoMPRDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9575	\N	(0021,006c)	DS	1	Offset	Offset	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9576	\N	(0021,006d)	CS	1	Ortho MPR At Bounding Box	OrthoMPRAtBoundingBox	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9577	\N	(0021,0076)	SQ	1	Clustering DR Sequence	ClusteringDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9578	\N	(0021,0077)	DS	1	Cluster Size	ClusterSize	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9579	\N	(0021,0078)	CS	1	Clustering Enabled	ClusteringEnabled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9580	\N	(0021,0079)	LO	1	Cluster Mask Vol ID	ClusterMaskVolID	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9581	\N	(0021,0080)	SQ	1	Head Masking DR Sequence	HeadMaskingDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9582	\N	(0021,0081)	DS	2	Masking Range	MaskingRange	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9583	\N	(0021,0082)	CS	1	Mask Enabled	MaskEnabled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9584	\N	(0021,0083)	SQ	1	Brain Masking DR Sequence	BrainMaskingDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9585	\N	(0021,0084)	SQ	1	Masking Status DR Sequence	MaskingStatusDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9586	\N	(0021,0085)	SQ	1	VRT Masking DR Sequence	VRTMaskingDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9587	\N	(0021,0086)	SQ	1	Ortho MPR Masking DR Sequence	OrthoMPRMaskingDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9588	\N	(0021,0087)	SQ	1	Floating MPR Masking DR Sequence	FloatingMPRMaskingDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9589	\N	(0021,0088)	SQ	1	Align DR Sequence	AlignDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9590	\N	(0021,0089)	DS	16	Registration Matrix	RegistrationMatrix	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9591	\N	(0021,0090)	SQ	1	Functional Evaluation DR Sequence	FunctionalEvaluationDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9592	\N	(0021,0091)	DS	1-n	Frame Acquition Numbers	FrameAcquitionNumbers	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9593	\N	(0021,0092)	CS	1	Show Cursor	ShowCursor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9594	\N	(0021,0093)	DS	1	Current Frame	CurrentFrame	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9595	\N	(0021,0094)	DS	1-n	Plot Area	PlotArea	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9596	\N	(0021,0095)	DS	2	Plot Text Position	PlotTextPosition	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9597	\N	(0021,0096)	DS	1-n	Base Line Points	BaseLinePoints	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9598	\N	(0021,0097)	DS	1-n	Active Points	ActivePoints	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9599	\N	(0021,0098)	CS	1	Show Label	ShowLabel	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9600	\N	(0021,0099)	CS	1	Mean Plot	MeanPlot	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9601	\N	(0021,009a)	CS	1	Motion Plot	MotionPlot	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9602	\N	(0021,009b)	CS	1	Activate Normallized Curve	ActivateNormallizedCurve	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9603	\N	(0021,009c)	DS	1	Plot Size	PlotSize	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9604	\N	(0021,00a0)	SQ	4	PlotDR Sequence	PlotDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9605	\N	(0021,00a1)	LO	1	Title	Title	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9606	\N	(0021,00a2)	CS	1	Auto Scale	AutoScale	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9607	\N	(0021,00a3)	DS	1	Fixed Scale	FixedScale	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9608	\N	(0021,00a4)	DS	3	Background Color	BackgroundColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9609	\N	(0021,00a5)	LO	1	Label X	LabelX	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9610	\N	(0021,00a6)	LO	1	Label Y	LabelY	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9611	\N	(0021,00a7)	CS	1	Legend	Legend	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9612	\N	(0021,00a8)	CS	1	Scroll Bar X	ScrollBarX	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9613	\N	(0021,00a9)	CS	1	Scroll Bar Y	ScrollBarY	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9614	\N	(0021,00aa)	LO	1	Connect Scroll X	ConnectScrollX	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9615	\N	(0021,00ab)	LO	1	Plot ID	PlotID	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9616	\N	(0021,00ac)	DS	1	Plot Position	PlotPosition	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9617	\N	(0021,00b0)	SQ	1	Curve DR Sequence	CurveDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9618	\N	(0021,00b1)	LO	1	Curve ID	CurveID	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9619	\N	(0021,00b2)	LO	1	Plot Type	PlotType	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9620	\N	(0021,00b3)	DS	1-n	Curve Values	CurveValues	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9621	\N	(0021,00b4)	DS	3	Line Color	LineColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9622	\N	(0021,00b5)	DS	3	Marker Color	MarkerColor	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9623	\N	(0021,00b6)	CS	1	Line Filled	LineFilled	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9624	\N	(0021,00b7)	LO	1	Label	Label	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9625	\N	(0021,00b8)	CS	1	Show Marker	ShowMarker	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9626	\N	(0021,00b9)	LO	1	Marker Shape	MarkerShape	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9627	\N	(0021,00ba)	LO	1	Smoothing Algo	SmoothingAlgo	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9628	\N	(0021,00bb)	DS	1	Marker Size	MarkerSize	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9629	\N	(0021,00bc)	LO	1	Line Style	LineStyle	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9630	\N	(0021,00bd)	LO	1	Line Pattern	LinePattern	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9631	\N	(0021,00be)	DS	1	Line Width	LineWidth	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9632	\N	(0021,00c0)	SQ	1	VRT Filter DR Sequence	VRTFilterDRSequence	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9633	\N	(0021,00c1)	LO	1	Filter Type	FilterType	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9634	\N	(0021,00c2)	CS	1	Current Active Plane	CurrentActivePlane	SIEMENS MR N3D	SSPI	\N	\N	\N
f	9635	\N	(0021,0001)	UL	1	Mds Mode Mask	MdsModeMask	SIEMENS MR PHOENIX ATTRIBUTES	SSPI	\N	\N	\N
f	9636	\N	(0021,0002)	US	1	Dixon	Dixon	SIEMENS MR PHOENIX ATTRIBUTES	SSPI	\N	\N	\N
f	9637	\N	(0021,0003)	LT	1	Sequence File Name	SequenceFileName	SIEMENS MR PHOENIX ATTRIBUTES	SSPI	\N	\N	\N
f	9638	\N	(0021,00f1)	UL	1	Count of Pseudo Attributes	CountOfPseudoAttributes	SIEMENS MR PHOENIX ATTRIBUTES	SSPI	\N	\N	\N
f	9639	\N	(0021,00fe)	SQ	1	Siemens MR SDS Sequence	SiemensMRSDSSequence	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9640	\N	(0021,0001)	IS	1	Used Patient Weight	UsedPatientWeight	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9641	\N	(0021,0002)	DS	3	SAR Whole Body	SARWholeBody	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9642	\N	(0021,0003)	OB	1	MR Protocol	MRProtocol	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9643	\N	(0021,0004)	DS	1	Slice Array Concatenations	SliceArrayConcatenations	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9644	\N	(0021,0005)	IS	3	Rel Table Position	RelTablePosition	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9645	\N	(0021,0006)	LO	1	Coil For Gradient	CoilForGradient	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9646	\N	(0021,0007)	LO	1	Long Model Name	LongModelName	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9647	\N	(0021,0008)	SH	1	Gradient Mode	GradientMode	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9648	\N	(0021,0009)	LO	1	PAT Mode Text	PATModeText	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9649	\N	(0021,000a)	DS	1	SW Correction Factor	SWCorrectionFactor	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9650	\N	(0021,000b)	DS	1	RF Power Error Indicator	RFPowerErrorIndicator	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9651	\N	(0021,000c)	SH	1	Positive PCS Directions	PositivePCSDirections	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9652	\N	(0021,000d)	US	1	Protocol Change History	ProtocolChangeHistory	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9653	\N	(0021,000e)	LO	1	Data File Name	DataFileName	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9654	\N	(0021,000f)	DS	3	Stimlim	Stimlim	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9655	\N	(0021,0010)	IS	1	MR Protocol Version	MRProtocolVersion	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9656	\N	(0021,0011)	DS	1	Phase Gradient Amplitude	PhaseGradientAmplitude	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9657	\N	(0021,0012)	FD	1	Readout OS	ReadoutOS	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9658	\N	(0021,0013)	DS	1	tpuls max	tpulsmax	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9659	\N	(0021,0014)	IS	1	Number of Prescans	NumberOfPrescans	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9660	\N	(0021,0015)	FL	1	Measurement Index	MeasurementIndex	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9661	\N	(0021,0016)	DS	1	dBdt Threshold	dBdtThreshold	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9662	\N	(0021,0017)	DS	1	Selection Gradient Amplitude	SelectionGradientAmplitude	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9663	\N	(0021,0018)	SH	1	RF SWD Most Critical Aspect	RFSWDMostCriticalAspect	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9664	\N	(0021,0019)	OB	1	MR Phoenix Protocol	MRPhoenixProtocol	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9665	\N	(0021,001a)	LO	1	Coil String	CoilString	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9666	\N	(0021,001b)	DS	1	Slice Resolution	SliceResolution	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9667	\N	(0021,001c)	DS	3	Stim max online	Stimmaxonline	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9668	\N	(0021,001d)	IS	1	Operation Mode Flag	OperationModeFlag	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9669	\N	(0021,001e)	FL	16	Auto Align Matrix	AutoAlignMatrix	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9670	\N	(0021,001f)	DS	2	Coil Tuning Reflection	CoilTuningReflection	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9671	\N	(0021,0020)	UI	1	Representative Image	RepresentativeImage	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9672	\N	(0021,0022)	SH	1	Sequence File Owner	SequenceFileOwner	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9673	\N	(0021,0023)	IS	1	RF Watchdog Mask	RFWatchdogMask	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9674	\N	(0021,0024)	LO	1	Post Proc Protocol	PostProcProtocol	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9675	\N	(0021,0025)	SL	3	Table Position Origin	TablePositionOrigin	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9676	\N	(0021,0026)	IS	32	Misc Sequence Param	MiscSequenceParam	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9677	\N	(0021,0027)	US	1	Isocentered	Isocentered	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9678	\N	(0021,002a)	IS	1-n	Coil ID	CoilID	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9679	\N	(0021,002b)	ST	1	Pat Rein Pattern	PatReinPattern	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9680	\N	(0021,002c)	DS	3	SED	SED	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9681	\N	(0021,002d)	DS	3	SAR Most Critical Aspect	SARMostCriticalAspect	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9682	\N	(0021,002e)	IS	1	Stimm on mode	StimmOnMode	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9683	\N	(0021,002f)	DS	3	Gradient Delay Time	GradientDelayTime	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9684	\N	(0021,0030)	DS	1	Readout Gradient Amplitude	ReadoutGradientAmplitude	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9685	\N	(0021,0031)	IS	1	Abs Table Position	AbsTablePosition	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9686	\N	(0021,0032)	SS	1	RF SWD Operation Mode	RFSWDOperationMode	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9687	\N	(0021,0033)	SH	1	Coil for Gradient2	CoilForGradient2	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9688	\N	(0021,0034)	DS	1	Stim Factor	StimFactor	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9689	\N	(0021,0035)	DS	1	Stim max ges norm online	Stimmaxgesnormonline	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9690	\N	(0021,0036)	DS	1	dBdt max	dBdtmax	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9691	\N	(0021,0038)	DS	1	Transmitter Calibration	TransmitterCalibration	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9692	\N	(0021,0039)	OB	1	MR EVA Protocol	MREVAProtocol	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9693	\N	(0021,003b)	DS	1	dBdt Limit	dBdtLimit	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9694	\N	(0021,003c)	OB	1	VF Model Info	VFModelInfo	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9695	\N	(0021,003d)	CS	1	Phase Slice Oversampling	PhaseSliceOversampling	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9696	\N	(0021,003e)	OB	1	VF Settings	VFSettings	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9697	\N	(0021,003f)	UT	1	Auto Align Data	AutoAlignData	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9698	\N	(0021,0040)	UT	1	FMRI Model Parameters	FMRIModelParameters	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9699	\N	(0021,0041)	UT	1	FMRI Model Info	FMRIModelInfo	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9700	\N	(0021,0042)	UT	1	FMRI External Parameters	FMRIExternalParameters	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9701	\N	(0021,0043)	UT	1	FMRI External Info	FMRIExternalInfo	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9702	\N	(0021,0044)	DS	2	B1 RMS	B1RMS	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9703	\N	(0021,0045)	CS	1	B1 RMS Supervision	B1RMSSupervision	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9704	\N	(0021,0046)	DS	1	Tales Reference Power	TalesReferencePower	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9705	\N	(0021,0047)	CS	1	Safety Standard	SafetyStandard	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9706	\N	(0021,0048)	CS	1	DICOM Image Flavor	DICOMImageFlavor	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9707	\N	(0021,0049)	CS	1	DICOM Acquisition Contrast	DICOMAcquisitionContrast	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9708	\N	(0021,0050)	US	1	RF Echo Train Length 4MF	RFEchoTrainLength4MF	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9709	\N	(0021,0051)	US	1	Gradient Echo Train Length 4MF	GradientEchoTrainLength4MF	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9710	\N	(0021,0052)	LO	1	Version Info	VersionInfo	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9711	\N	(0021,0053)	CS	1	Laterality 4MF	Laterality4MF	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9712	\N	(0021,0001)	FD	1	Transmitter Reference Amplitude	TransmitterReferenceAmplitude	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9713	\N	(0021,0002)	US	1	Hamming Filter Width	HammingFilterWidth	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9714	\N	(0021,0003)	FD	3	CSI Gridshift Vector	CSIGridshiftVector	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9715	\N	(0021,0004)	FD	1	Mixing Time	MixingTime	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9716	\N	(0021,0040)	CS	1	Series Protocol Instance	SeriesProtocolInstance	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9717	\N	(0021,0041)	CS	1	Spectro Result Type	SpectroResultType	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9718	\N	(0021,0042)	CS	1	Spectro Result Extend Type	SpectroResultExtendType	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9719	\N	(0021,0043)	CS	1	Post Proc Protocol	PostProcProtocol	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9720	\N	(0021,0044)	CS	1	Rescan Level	RescanLevel	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9721	\N	(0021,0045)	OF	1	Spectro Algo Result	SpectroAlgoResult	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9722	\N	(0021,0046)	OF	1	Spectro Display Params	SpectroDisplayParams	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9723	\N	(0021,0047)	IS	1	Voxel Number	VoxelNumber	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9724	\N	(0021,0048)	SQ	1	APR Sequence	APRSequence	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9725	\N	(0021,0049)	CS	1	Sync Data	SyncData	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9726	\N	(0021,004a)	CS	1	Post Proc Detailed Protocol	PostProcDetailedProtocol	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9727	\N	(0021,004b)	CS	1	Spectro Result Extend Type Detailed	SpectroResultExtendTypeDetailed	SIEMENS MR MRS 05	SSPI	\N	\N	\N
f	9728	\N	(0025,0001)	SQ	1	Extracted MR Header Information Sequence	ExtractedMRHeaderInformationSequence	SIEMENS MR EXTRACTED CSA HEADER	SSPI	\N	\N	\N
f	9729	\N	(0025,0002)	LO	1	Extracted MR Header Creator Identification Code	ExtractedMRHeaderCreatorIdentificationCode	SIEMENS MR EXTRACTED CSA HEADER	SSPI	\N	\N	\N
f	9730	\N	(0025,0003)	AT	1	Extracted MR Header Tag	ExtractedMRHeaderTag	SIEMENS MR EXTRACTED CSA HEADER	SSPI	\N	\N	\N
f	9731	\N	(0051,0008)	CS	1	CSA Image Header Type	CSAImageHeaderType	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9732	\N	(0051,0009)	LO	1	CSA Image Header Version	CSAImageHeaderVersion	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9733	\N	(0051,000a)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9734	\N	(0051,000b)	SH	1	Acquisition Matrix Text	AcquisitionMatrixText	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9735	\N	(0051,000c)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9736	\N	(0051,000d)	SH	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9737	\N	(0051,000e)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9738	\N	(0051,000f)	LO	1	Coil String	CoilString	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9739	\N	(0051,0011)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9740	\N	(0051,0012)	SH	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9741	\N	(0051,0013)	SH	1	Positive PCS Directions	PositivePCSDirections	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9742	\N	(0051,0015)	SH	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9743	\N	(0051,0016)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9744	\N	(0051,0017)	SH	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9745	\N	(0051,0018)	SH	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9746	\N	(0051,0019)	LO	1	Unknown	Unknown	SIEMENS MR HEADER	SSPI	\N	\N	\N
f	9640	\N	(0021,0001)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9641	\N	(0021,0002)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9642	\N	(0021,0003)	OB	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9643	\N	(0021,0004)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9644	\N	(0021,0005)	IS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9645	\N	(0021,0006)	LO	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9646	\N	(0021,0007)	LO	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9647	\N	(0021,0008)	SH	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9648	\N	(0021,0009)	LO	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9649	\N	(0021,000a)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9651	\N	(0021,000c)	SH	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9652	\N	(0021,000d)	US	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9654	\N	(0021,000f)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9655	\N	(0021,0010)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9656	\N	(0021,0011)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9657	\N	(0021,0012)	FD	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9658	\N	(0021,0013)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9659	\N	(0021,0014)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9661	\N	(0021,0016)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9662	\N	(0021,0017)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9663	\N	(0021,0018)	SH	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9664	\N	(0021,0019)	OB	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9665	\N	(0021,001a)	LO	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9666	\N	(0021,001b)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9667	\N	(0021,001c)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9668	\N	(0021,001d)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9670	\N	(0021,001f)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9672	\N	(0021,0022)	SH	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9673	\N	(0021,0023)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9675	\N	(0021,0025)	SL	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9676	\N	(0021,0026)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9677	\N	(0021,0027)	US	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9678	\N	(0021,002a)	IS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9679	\N	(0021,002b)	ST	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9680	\N	(0021,002c)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9681	\N	(0021,002d)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9682	\N	(0021,002e)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9683	\N	(0021,002f)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9684	\N	(0021,0030)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9685	\N	(0021,0031)	IS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9686	\N	(0021,0032)	SS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9689	\N	(0021,0035)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9690	\N	(0021,0036)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9691	\N	(0021,0038)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9692	\N	(0021,0039)	OB	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9693	\N	(0021,003b)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9702	\N	(0021,0044)	DS	1-n	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9703	\N	(0021,0045)	CS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9704	\N	(0021,0046)	DS	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9639	\N	(0021,00fe)	SQ	1	Unknown	Unknown	SIEMENS MR SDS 01	SSPI	\N	\N	\N
f	9747	\N	(0021,0001)	US	1	Number of Images in Mosaic	NumberOfImagesInMosaic	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9748	\N	(0021,0002)	FD	3	Slice Normal Vector	SliceNormalVector	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9749	\N	(0021,0003)	DS	1	Slice Measurement Duration	SliceMeasurementDuration	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9750	\N	(0021,0004)	DS	1	Time After Start	TimeAfterStart	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9751	\N	(0021,0005)	IS	1	B Value	BValue	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9752	\N	(0021,0006)	LO	1	ICE Dims	ICEDims	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9753	\N	(0021,001a)	SH	1	RF SWD Data Type	RFSWDDataType	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9754	\N	(0021,001b)	US	1	MoCoQ Measure	MoCoQMeasure	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9755	\N	(0021,001c)	IS	1	Phase Encoding Direction Positive	PhaseEncodingDirectionPositive	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9756	\N	(0021,001d)	OB	1	Pixel File	PixelFile	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9757	\N	(0021,001f)	IS	1	FMRI Stimul Info	FMRIStimulInfo	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9758	\N	(0021,0020)	DS	1	Voxel in Plane Rot	VoxelInPlaneRot	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9759	\N	(0021,0021)	CS	1	Diffusion Directionality 4MF	DiffusionDirectionality4MF	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9760	\N	(0021,0022)	DS	1	Voxel Thickness	VoxelThickness	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9761	\N	(0021,0023)	FD	6	B Matrix	BMatrix	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9762	\N	(0021,0024)	IS	1	Multistep Index	MultistepIndex	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9763	\N	(0021,0025)	LT	1	Comp Adjusted Param	CompAdjustedParam	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9764	\N	(0021,0026)	IS	1	Comp Algorithm	CompAlgorithm	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9765	\N	(0021,0027)	DS	1	Voxel NormalC or	VoxelNormalCor	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9766	\N	(0021,0029)	SH	1	Flow Encoding Direction String	FlowEncodingDirectionString	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9767	\N	(0021,002a)	DS	1	Voxel Normal Sag	VoxelNormalSag	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9768	\N	(0021,002b)	DS	1	Voxel Position Sag	VoxelPositionSag	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9769	\N	(0021,002c)	DS	1	Voxel Normal Tra	VoxelNormalTra	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9770	\N	(0021,002d)	DS	1	Voxel Position Tra	VoxelPositionTra	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9771	\N	(0021,002e)	UL	1	Used Channel Mask	UsedChannelMask	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9772	\N	(0021,002f)	DS	1	Repetition Time Effective	RepetitionTimeEffective	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9773	\N	(0021,0030)	DS	6	CSI Image Orientation Patient	CSIImageOrientationPatient	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9774	\N	(0021,0032)	DS	1	CSI Slice Location	CSISliceLocation	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9775	\N	(0021,0033)	IS	1	Echo Column Position	EchoColumnPosition	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9776	\N	(0021,0034)	FD	1	Flow VENC	FlowVENC	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9777	\N	(0021,0035)	IS	1	Measured Fourier Lines	MeasuredFourierLines	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9778	\N	(0021,0036)	SH	1	LQ Algorithm	LQAlgorithm	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9779	\N	(0021,0037)	DS	1	Voxel Position Cor	VoxelPositionCor	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9780	\N	(0021,0038)	IS	1	Filter2	Filter2	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9781	\N	(0021,0039)	FD	1	FMRI Stimul Level	FMRIStimulLevel	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9782	\N	(0021,003a)	DS	1	Voxel Readout FOV	VoxelReadoutFOV	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9783	\N	(0021,003b)	IS	1	Normalize Manipulated	NormalizeManipulated	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9784	\N	(0021,003c)	FD	3	RBMoCoRot	RBMoCoRot	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9785	\N	(0021,003d)	IS	1	Comp Manual Adjusted	CompManualAdjusted	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9786	\N	(0021,003f)	SH	1	Spectrum Text Region Label	SpectrumTextRegionLabel	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9787	\N	(0021,0040)	DS	1	Voxel Phase FOV	VoxelPhaseFOV	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9788	\N	(0021,0041)	SH	1	GSWD Data Type	GSWDDataType	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9789	\N	(0021,0042)	IS	1	Real Dwell Time	RealDwellTime	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9790	\N	(0021,0043)	LT	1	Comp Job ID	CompJobID	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9791	\N	(0021,0044)	IS	1	Comp Blended	CompBlended	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9792	\N	(0021,0045)	SL	3	Ima Abs Table Position	ImaAbsTablePosition	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9793	\N	(0021,0046)	FD	3	Diffusion Gradient Direction	DiffusionGradientDirection	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9794	\N	(0021,0047)	IS	1	Flow Encoding Direction	FlowEncodingDirection	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9795	\N	(0021,0048)	IS	1	Echo Partition Position	EchoPartitionPosition	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9796	\N	(0021,0049)	IS	1	Echo Line Position	EchoLinePosition	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9797	\N	(0021,004b)	LT	1	Comp Auto Param	CompAutoParam	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9798	\N	(0021,004c)	IS	1	Original Image Number	OriginalImageNumber	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9799	\N	(0021,004d)	IS	1	Original Series Number	OriginalSeriesNumber	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9800	\N	(0021,004e)	IS	1	Actual 3D Ima Part Number	Actual3DImaPartNumber	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9801	\N	(0021,004f)	LO	1	Ima Coil String	ImaCoilString	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9802	\N	(0021,0050)	DS	2	CSI Pixel Spacing	CSIPixelSpacing	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9803	\N	(0021,0051)	UL	1	Sequence Mask	SequenceMask	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9804	\N	(0021,0052)	US	1	Image Group	ImageGroup	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	10043	\N	(0039,00f4)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9805	\N	(0021,0053)	FD	1	Bandwidth Per Pixel Phase Encode	BandwidthPerPixelPhaseEncode	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9806	\N	(0021,0054)	US	1	Non Planar Image	NonPlanarImage	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9807	\N	(0021,0055)	OB	1	Pixel File Name	PixelFileName	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9808	\N	(0021,0056)	LO	1	Ima PAT Mode Text	ImaPATModeText	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9809	\N	(0021,0057)	DS	3	CSI Image Position Patient	CSIImagePositionPatient	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9810	\N	(0021,0058)	SH	1	Acquisition Matrix Text	AcquisitionMatrixText	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9811	\N	(0021,0059)	IS	3	Ima Rel Table Position	ImaRelTablePosition	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9812	\N	(0021,005a)	FD	3	RBMoCoTrans	RBMoCoTrans	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9813	\N	(0021,005b)	FD	3	Slice Position PCS	SlicePositionPCS	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9814	\N	(0021,005c)	DS	1	CSI Slice Thickness	CSISliceThickness	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9815	\N	(0021,005e)	IS	1	Protocol Slice Number	ProtocolSliceNumber	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9816	\N	(0021,005f)	IS	1	Filter1	Filter1	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9817	\N	(0021,0060)	SH	1	Transmitting Coil	TransmittingCoil	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9818	\N	(0021,0061)	DS	1	Number of Averages N4	NumberOfAveragesN4	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9819	\N	(0021,0062)	FD	1-n	Mosaic Ref Acq Times	MosaicRefAcqTimes	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9820	\N	(0021,0063)	IS	1	Auto Inline Image Filter Enabled	AutoInlineImageFilterEnabled	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9821	\N	(0021,0065)	FD	1-n	QC Data	QCData	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9822	\N	(0021,0066)	LT	1	Exam Landmarks	ExamLandmarks	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9823	\N	(0021,0067)	ST	1	Exam Data Role	ExamDataRole	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9824	\N	(0021,0068)	OB	1	MR Diffusion	MRDiffusion	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9825	\N	(0021,0069)	OB	1	Real World Value Mapping	RealWorldValueMapping	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9826	\N	(0021,0070)	OB	1	Data Set Info	DataSetInfo	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9827	\N	(0021,0071)	UT	1	Used Channel String	UsedChannelString	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9828	\N	(0021,0072)	CS	1	Phase ContrastN4	PhaseContrastN4	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9829	\N	(0021,0073)	UT	1	MR Velocity Encoding	MRVelocityEncoding	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9830	\N	(0021,0074)	FD	3	Velocity Encoding Direction N4	VelocityEncodingDirectionN4	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9831	\N	(0021,0075)	CS	1-n	Image Type 4MF	ImageType4MF	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9832	\N	(0021,0076)	LO	1-n	Image History	ImageHistory	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9833	\N	(0021,0077)	LO	1	SequenceI nfo	SequenceInfo	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9834	\N	(0021,0078)	CS	1-n	Image Type Visible	ImageTypeVisible	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9835	\N	(0021,0079)	CS	1	Distortion Correction Type	DistortionCorrectionType	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9836	\N	(0021,0080)	CS	1	Image Filter Type	ImageFilterType	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9837	\N	(0021,00fe)	SQ	1	Siemens MR SDI Sequence	SiemensMRSDISequence	SIEMENS MR SDI 02	SSPI	\N	\N	\N
f	9838	\N	(0021,0001)	IS	1	Unknown	Unknown	SIEMENS MR CM 03	SSPI	\N	\N	\N
f	9839	\N	(0021,0002)	CS	1	Unknown	Unknown	SIEMENS MR CM 03	SSPI	\N	\N	\N
f	9840	\N	(0021,0001)	FD	1-n	Unknown	Unknown	SIEMENS MR PS 04	SSPI	\N	\N	\N
f	9841	\N	(0021,0001)	LO	1	Unknown	Unknown	SIEMENS MR FOR 06	SSPI	\N	\N	\N
f	9842	\N	(0029,0000)	LT	1	Dual Energy Algorithm Parameters	DualEnergyAlgorithmParameters	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9843	\N	(0029,0001)	US	1	Valid CT Volume MBox Tasks	ValidCTVolumeMBoxTasks	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9844	\N	(0029,0002)	LT	1	Scan Options	ScanOptions	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9845	\N	(0029,0003)	ST	1	Acquisition Date and Time	AcquisitionDateandTime	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9846	\N	(0029,0004)	ST	1	Acquisition Number	AcquisitionNumber	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9847	\N	(0029,0005)	ST	1	Dynamic Data	DynamicData	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9848	\N	(0029,0006)	DS	6	Image Orientation Patient	ImageOrientationPatient	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9849	\N	(0029,0007)	LT	1	Frame Of Reference Uid	FrameOfReferenceUid	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9850	\N	(0029,0008)	LT	1	Patient Position	PatientPosition	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9851	\N	(0029,0009)	LT	1	Convolution Kernel	ConvolutionKernel	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9852	\N	(0029,0010)	LT	1	Kvp	Kvp	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9853	\N	(0029,0011)	LT	1	Reconstruction Diameter	ReconstructionDiameter	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9854	\N	(0029,0012)	LT	1	Rescale Intercept	RescaleIntercept	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9855	\N	(0029,0013)	LT	1	Rescale Slope	RescaleSlope	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9856	\N	(0029,0014)	LT	1	Slice Thickness	SliceThickness	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9857	\N	(0029,0015)	LT	1	Table Height	TableHeight	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9858	\N	(0029,0016)	LT	1	Gantry Detector Tilt	GantryDetectorTilt	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9859	\N	(0029,0017)	LT	1	Pixel Spacing	PixelSpacing	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9860	\N	(0029,0018)	ST	1	Volume PatientPosition Not Equal	VolumePatientPositionNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9861	\N	(0029,0019)	ST	1	Volume LossyImageCompression Not Equal	VolumeLossyImageCompressionNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9862	\N	(0029,0020)	ST	1	Volume ConvolutionKernel Not Equal	VolumeConvolutionKernelNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9863	\N	(0029,0021)	ST	1	Volume PixelSpacing Not Equal	VolumePixelSpacingNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9864	\N	(0029,0022)	ST	1	Volume Kvp Not Equal	VolumeKvpNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9865	\N	(0029,0023)	ST	1	Volume ReconstructionDiameter Not Equal	VolumeReconstructionDiameterNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9866	\N	(0029,0024)	ST	1	Volume TableHeight Not Equal	VolumeTableHeightNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9867	\N	(0029,0025)	ST	1	Volume Has Gaps	VolumeHasGaps	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9868	\N	(0029,0026)	ST	1	Volume Number Of Missing Images	VolumeNumberOfMissingImages	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9869	\N	(0029,0027)	ST	1	Volume Max Gap	VolumeMaxGap	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9870	\N	(0029,0028)	LT	1	Volume Position Of Gaps	VolumePositionOfGaps	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9871	\N	(0029,0029)	FD	1	Calibration Factor	CalibrationFactor	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9872	\N	(0029,002a)	CS	1	Flash Mode	FlashMode	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9873	\N	(0029,002b)	LT	1	Warnings	Warnings	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9874	\N	(0029,002c)	ST	1	Volume HighBit Not Equal	VolumeHighBitNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9875	\N	(0029,002d)	ST	1	Volume ImageType Not Equal	VolumeImageTypeNotEqual	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9876	\N	(0029,002e)	ST	1	ImageType 0	ImageType0	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9877	\N	(0029,002f)	ST	1	ImageType 1	ImageType1	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9878	\N	(0029,0030)	ST	1	ImageType 2	ImageType2	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9879	\N	(0029,0031)	ST	1	ImageType 3	ImageType3	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9880	\N	(0029,0032)	ST	1	PhotometricInterpretation not MONOCHROME2	PhotometricInterpretationNotMONOCHROME2	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9881	\N	(0029,0033)	DA	1	First Acquisition Date	FirstAcquisitionDate	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9882	\N	(0029,0034)	DA	1	Last Acquisition Date	LastAcquisitionDate	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9883	\N	(0029,0035)	TM	1	First Acquisition Time	FirstAcquisitionTime	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9884	\N	(0029,0036)	TM	1	Last Acquisition Time	LastAcquisitionTime	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9885	\N	(0029,0037)	ST	1	Internal Data	InternalData	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9886	\N	(0029,0038)	ST	1	Ranges SOM7	RangesSOM7	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9887	\N	(0029,0039)	LT	1	Calculated Gantry Detector Tilt	CalculatedGantryDetectorTilt	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9888	\N	(0029,0040)	ST	1	Volume Slice Distance	VolumeSliceDistance	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9889	\N	(0029,0041)	DS	1	First Slice Z Coordinate 	FirstSliceZCoordinate	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9890	\N	(0029,0042)	DS	1	Last Slice Z Coordinate 	LastSliceZCoordinate	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9891	\N	(0029,0043)	DS	1	Content DateTime	ContentDateTime	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9892	\N	(0029,0044)	DS	1	Delta Time	DeltaTime	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9893	\N	(0029,0045)	DS	1	Frame Count	FrameCount	SIEMENS CT APPL DATASET	SSPI	\N	\N	\N
f	9894	\N	(0029,0000)	UT	1	Private Task Datamodel	PrivateTaskDatamodel	SIEMENS CT APPL EVIDENCEDOCUMENT	SSPI	\N	\N	\N
f	9895	\N	(0029,0000)	UT	1	Oncology Segmentation Measurement Values	OncologySegmentationMeasurementValues	SIEMENS CT APPL MEASUREMENT	SSPI	\N	\N	\N
f	9896	\N	(0029,0001)	ST	1	Oncology Measurement Recist Standard	OncologyMeasurementRecistStandard	SIEMENS CT APPL MEASUREMENT	SSPI	\N	\N	\N
f	9897	\N	(0029,0010)	CS	1	DualEnergy ROI Annotation Mode	DualEnergyROIAnnotationMode	SIEMENS CT APPL MEASUREMENT	SSPI	\N	\N	\N
f	9898	\N	(0029,0000)	US	1	Translucent Mode	TranslucentMode	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9899	\N	(0029,0001)	FD	1	Translucent Window Size	TranslucentWindowSize	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9900	\N	(0029,0002)	US	1	Panoramic Mode	PanoramicMode	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9901	\N	(0029,0003)	FD	1	Panoramic Inner Width	PanoramicInnerWidth	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9902	\N	(0029,0004)	US	1	Display Unseen Areas	DisplayUnseenAreas	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9903	\N	(0029,0005)	US	4	Unseen Areas Color	UnseenAreasColor	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9904	\N	(0029,0006)	US	1	Display Tagged Data	DisplayTaggedData	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9905	\N	(0029,0007)	US	4	Tagged Color	TaggedColor	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9906	\N	(0029,0008)	UL	1	Tagged Sample Thickness	TaggedSampleThickness	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9907	\N	(0029,0009)	SL	1	Tagged Threshold	TaggedThreshold	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9908	\N	(0029,0010)	US	1	Kernel Filter	KernelFilter	SIEMENS CT APPL PRESENTATION	SSPI	\N	\N	\N
f	9909	\N	(0029,0000)	OB	1	CT Task Common DataModel	CTTaskCommonDataModel	SIEMENS CT APPL TMP DATAMODEL	SSPI	\N	\N	\N
f	9910	\N	(0039,0000)	UN	1	Release Version	ReleaseVersion	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9911	\N	(0039,0003)	UN	1	Volume Acquisition Duration	VolumeAcquisitionDuration	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9912	\N	(0039,0004)	UN	1	Volume Raw Data Type	VolumeRawDataType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9913	\N	(0039,0005)	UN	1	Scan Type	ScanType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9914	\N	(0039,0006)	UN	1	Z Lateral Min	ZlateralMin	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9915	\N	(0039,0007)	UN	1	Z Lateral Span	ZlateralSpan	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9916	\N	(0039,0008)	UN	1	Z Radius of Curvature	ZRadiusOfCurvature	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9917	\N	(0039,0009)	UN	1	Wobble Correction	WobbleCorrection	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9918	\N	(0039,0010)	UN	1	Scale Along Width	ScaleAlongWidth	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9919	\N	(0039,0011)	UN	1	Scale Along Height	ScaleAlongHeight	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9920	\N	(0039,0012)	UN	1	Scale Along Depth	ScaleAlongDepth	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9921	\N	(0039,0013)	UN	1	Buffer Size	BufferSize	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9922	\N	(0039,0014)	UN	1	Acquisition Rate	AcquisitionRate	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9923	\N	(0039,0015)	UN	1	Depth Min cm	DepthMinCm	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9924	\N	(0039,0016)	UN	1	Is Left Right Flipped Enabled	IsLeftRightFlippedEn	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9925	\N	(0039,0017)	UN	1	Is Up Down Flipped Enabled	IsUpDownFlippedEn	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9926	\N	(0039,0018)	UN	1	Is Volume Geom Accurate	IsVolumeGeomAccurate	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9927	\N	(0039,0019)	UN	1	BByte Mask Offset	BByteMaskOffset	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9928	\N	(0039,0020)	UN	1	BByte Mask Size	BByteMaskSize	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9929	\N	(0039,0022)	UN	1	Acq Plane Rotation Deg	AcqPlaneRotationDeg	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9930	\N	(0039,0023)	UN	1	Beam Axial Span	BeamAxialSpan	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9931	\N	(0039,0024)	UN	1	Beam Lateral Min	BeamLateralMin	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9932	\N	(0039,0025)	UN	1	Beam Lateral Span	BeamLateralSpan	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9933	\N	(0039,0026)	UN	1	Beam Axial Min	BeamAxialMin	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9934	\N	(0039,0027)	UN	1	Num Display Samples	NumDisplaySamples	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9935	\N	(0039,0028)	UN	1	DVolume Width	DVolumeWidth	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9936	\N	(0039,0029)	UN	1	DVolume Depth	DVolumeDepth	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9937	\N	(0039,0030)	UN	1	DVolume Height	DVolumeHeight	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9938	\N	(0039,0031)	UN	1	DVolume Pos X	DVolumePosX	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9939	\N	(0039,0032)	UN	1	DVolume Pos Y	DVolumePosY	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9940	\N	(0039,0033)	UN	1	DVolume Pos Z	DVolumePosZ	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9941	\N	(0039,0034)	UN	1	DBeam Axial Min	DBeamAxialMin	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9942	\N	(0039,0035)	UN	1	DBeam Axial Span	DBeamAxialSpan	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9943	\N	(0039,0037)	UN	1	DBeam Lateral Span	DBeamLateralSpan	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9944	\N	(0039,0038)	UN	1	Number of Volumes in Sequence	NumOfVolumesInSequence	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9945	\N	(0039,0039)	UN	1	DByte Mask Offset	DByteMaskOffset	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9946	\N	(0039,0040)	UN	1	DByte Mask Size	DByteMaskSize	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9947	\N	(0039,0050)	LO	1	Private Creator Version of Bookmark	PrivateCreatorVersionOfBookmark	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9948	\N	(0039,0051)	US	1	BCut Plane Enable	BCutPlaneEnable	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9949	\N	(0039,0052)	US	1	BMpr Color Map Index	BMprColorMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9950	\N	(0039,0053)	US	1	BMpr Dynamic Range Db	BMprDynamicRangeDb	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9951	\N	(0039,0054)	US	1	BMpr Gray Map Index	BMprGrayMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9952	\N	(0039,0055)	US	1	BVolume Render Mode	BVolumeRenderMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9953	\N	(0039,0056)	US	1	BVr Brightness	BVrBrightness	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9954	\N	(0039,0057)	US	1	BVr Contrast	BVrContrast	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9955	\N	(0039,0058)	US	1	BVr Color Map Index	BVrColorMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9956	\N	(0039,0059)	US	1	BVr Dynamic Range Db	BVrDynamicRangeDb	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9957	\N	(0039,005a)	US	1	BVr Gray Map Index	BVrGrayMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9958	\N	(0039,005b)	US	1	BVr Gray Map Index	BVrGrayMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9959	\N	(0039,005c)	US	1	BVr Threshold High	BVrThresholdHigh	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9960	\N	(0039,005d)	US	1	BVr Threshold Low	BVrThresholdLow	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9961	\N	(0039,005e)	US	1	BPre Process Filter Mix	BPreProcessFilterMix	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9962	\N	(0039,005f)	US	1	CCut Plane Enable	CCutPlaneEnable	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9963	\N	(0039,0060)	US	1	CFront Clip Mode	CFrontClipMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9964	\N	(0039,0061)	US	1	CMpr Color Map Index	CMprColorMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9965	\N	(0039,0062)	US	1	CMpr Color Flow Priority Index	CMprColorFlowPriorityIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9966	\N	(0039,0063)	US	1	CVolume Render Mode	CVolumeRenderMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9967	\N	(0039,0064)	US	1	CVr Color Map Index	CVrColorMapIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9968	\N	(0039,0065)	US	1	CVr Color Flow Priority Index	CVrColorFlowPriorityIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9969	\N	(0039,0066)	US	1	CVr Opacity	CVrOpacity	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9970	\N	(0039,0067)	US	1	CVr Threshold High	CVrThresholdHigh	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9971	\N	(0039,0068)	US	1	CVr Threshold Low	CVrThresholdLow	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9972	\N	(0039,0069)	US	1	Voi Mode	VoiMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9973	\N	(0039,006a)	US	1	Voi Rotation Offset Deg	VoiRotationOffsetDeg	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9974	\N	(0039,006b)	FD	1	Voi Size Ratio X	VoiSizeRatioX	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9975	\N	(0039,006c)	FD	1	Voi Size Ratio Y	VoiSizeRatioY	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9976	\N	(0039,006d)	FD	1	Voi Size Ratio Z	VoiSizeRatioZ	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9977	\N	(0039,006e)	US	1	Voi Sync Plane	VoiSyncPlane	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9978	\N	(0039,006f)	US	1	Voi View Mode	VoiViewMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9979	\N	(0039,0070)	FD	1-n	Vr Orientation A	VrOrientationA	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9980	\N	(0039,0071)	FD	1-n	Mpr Orientation A	MprOrientationA	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9981	\N	(0039,0072)	FD	1	Vr Offset Vector	VrOffsetVector	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9982	\N	(0039,0073)	FD	1	Blending Ratio	BlendingRatio	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9983	\N	(0039,0074)	US	1	Fusion Blend Mode	FusionBlendMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9984	\N	(0039,0075)	FD	1	Quality Factor	QualityFactor	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9985	\N	(0039,0076)	US	1	Renderer Type	RendererType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9986	\N	(0039,0077)	US	1	Slice Mode	SliceMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9987	\N	(0039,0078)	US	1	Active Quad	ActiveQuad	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9988	\N	(0039,0079)	US	1	Screen Mode	ScreenMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9989	\N	(0039,007a)	US	1	Cut Plane Side	CutPlaneSide	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9990	\N	(0039,007b)	US	1	Wireframe Mode	WireframeMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9991	\N	(0039,007c)	US	1	Crossmark Mode	CrossmarkMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9992	\N	(0039,007d)	US	1	Mpr Display Type	MprDisplayType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9993	\N	(0039,007e)	US	1	Volume Display Type	VolumeDisplayType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9994	\N	(0039,007f)	US	1	Last Reset	LastReset	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9995	\N	(0039,0080)	US	1	Last Non Full Screen Mode	LastNonFullScreenMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9996	\N	(0039,0081)	US	1	Mpr Tool Index	MprToolIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9997	\N	(0039,0082)	US	1	Voi Tool Index	VoiToolIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9998	\N	(0039,0083)	US	1	Tool Loop Mode	ToolLoopMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	9999	\N	(0039,0084)	US	1	Volume Arb Mode	VolumeArbMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10000	\N	(0039,0085)	US	1	Mpr Zoom Enabled	MprZoomEn	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10001	\N	(0039,0086)	US	1	Is Volume Zoom Enabled	IsVolumeZoomEn	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10002	\N	(0039,0087)	SS	1	Zoom Level Mpr	ZoomLevelMpr	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10003	\N	(0039,0088)	SS	1	Zoom Level Volume	ZoomLevelVolume	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10004	\N	(0039,0089)	US	1	Is Auto Rotate Enabled	IsAutoRotateEn	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10005	\N	(0039,008a)	US	1	Auto Rotate Axis	AutoRotateAxis	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10006	\N	(0039,008b)	US	1	Auto Rotate Range Index	AutoRotateRangeIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10007	\N	(0039,008c)	US	1	Auto Rotate Speed Index	AutoRotateSpeedIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10008	\N	(0039,008d)	US	1	CVr Brightness	CVrBrightness	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10009	\N	(0039,008e)	US	1	CFlow State Index	CFlowStateIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10010	\N	(0039,008f)	US	1	BSubmode Index	BSubmodeIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10011	\N	(0039,0090)	US	1	CSubmode Index	CSubmodeIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10012	\N	(0039,0091)	US	1	Cut Plane	CutPlane	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10013	\N	(0039,0092)	US	1	Bookmark Chunk Id	BookmarkChunkId	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10014	\N	(0039,0093)	US	1	Sequence Min Chunk Id	SequenceMinChunkId	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10015	\N	(0039,0094)	US	1	Sequence Max Chunk Id	SequenceMaxChunkId	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10016	\N	(0039,0095)	FD	1	Volume Rate Hz	VolumeRateHz	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10017	\N	(0039,009a)	FD	1	Voi Position Offset X	VoiPositionOffsetX	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10018	\N	(0039,009b)	FD	1	Voi Position Offset Y	VoiPositionOffsetY	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10019	\N	(0039,009c)	FD	1	Voi Position Offset Z	VoiPositionOffsetZ	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10020	\N	(0039,009d)	US	1	Vr Tool Index	VrToolIndex	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10021	\N	(0039,009e)	US	1	Shading Percent	ShadingPercent	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10022	\N	(0039,009f)	US	1	Volume Type	VolumeType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10023	\N	(0039,00a0)	US	1	Vr Quad Display Type	VrQuadDisplayType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10024	\N	(0039,00a1)	FD	1-n	Mpr Center Location	MprCenterLocation	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10025	\N	(0039,00e0)	US	1	Slice Range Type	SliceRangeType	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10026	\N	(0039,00e1)	US	1	Slice MPR Plane	SliceMPRPlane	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10027	\N	(0039,00e2)	US	1	Slice Layout	SliceLayout	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10028	\N	(0039,00e3)	FD	1	Slice Spacing	SliceSpacing	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10029	\N	(0039,00e4)	US	1	Thin Vr Mode	ThinVrMode	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10030	\N	(0039,00e5)	US	1	Thin Vr Thickness	ThinVrThickness	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10031	\N	(0039,00e6)	FD	1	Curved TOP VOI Pivot X	VoiPivotX	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10032	\N	(0039,00e7)	FD	1	Curved TOP VOI Pivot Y	VoiPivotY	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10033	\N	(0039,00e8)	FD	1	Curved TOP VOI Pivot Z	VoiPivotZ	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10034	\N	(0039,00e9)	US	1	Curved TOP VOI Quadrant	CTopVoiQuad	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10035	\N	(0039,00ea)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10036	\N	(0039,00ed)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10037	\N	(0039,00ee)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10038	\N	(0039,00ef)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10039	\N	(0039,00f0)	US	1-n	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10040	\N	(0039,00f1)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10041	\N	(0039,00f2)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10042	\N	(0039,00f3)	US	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10044	\N	(0039,00f5)	LO	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10045	\N	(0039,00f6)	LT	1	Unknown	Unknown	SIEMENS MED SMS USG ANTARES 3D VOLUME	SSPI	\N	\N	\N
f	10046	\N	(0039,0050)	LO	1	Private Creator Version of Bookmark	PrivateCreatorVersionOfBookmark	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10047	\N	(0039,0051)	US	1	BCut Plane Enable	BCutPlaneEnable	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10048	\N	(0039,0052)	US	1	BMpr Color Map Index	BMprColorMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10049	\N	(0039,0053)	US	1	BMpr Dynamic Range Db	BMprDynamicRangeDb	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10050	\N	(0039,0054)	US	1	BMpr Gray Map Index	BMprGrayMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10051	\N	(0039,0055)	US	1	BVolume Render Mode	BVolumeRenderMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10052	\N	(0039,0056)	US	1	BVr Brightness	BVrBrightness	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10053	\N	(0039,0057)	US	1	BVr Contrast	BVrContrast	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10054	\N	(0039,0058)	US	1	BVr Color Map Index	BVrColorMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10055	\N	(0039,0059)	US	1	BVr Dynamic Range Db	BVrDynamicRangeDb	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10056	\N	(0039,005a)	US	1	BVr Gray Map Index	BVrGrayMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10057	\N	(0039,005b)	US	1	BVr Gray Map Index	BVrGrayMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10058	\N	(0039,005c)	US	1	BVr Threshold High	BVrThresholdHigh	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10059	\N	(0039,005d)	US	1	BVr Threshold Low	BVrThresholdLow	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10060	\N	(0039,005e)	US	1	BPre Process Filter Mix	BPreProcessFilterMix	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10061	\N	(0039,005f)	US	1	CCut Plane Enable	CCutPlaneEnable	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10062	\N	(0039,0060)	US	1	CFront Clip Mode	CFrontClipMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10063	\N	(0039,0061)	US	1	CMpr Color Map Index	CMprColorMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10064	\N	(0039,0062)	US	1	CMpr Color Flow Priority Index	CMprColorFlowPriorityIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10065	\N	(0039,0063)	US	1	CVolume Render Mode	CVolumeRenderMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10066	\N	(0039,0064)	US	1	CVr Color Map Index	CVrColorMapIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10067	\N	(0039,0065)	US	1	CVr Color Flow Priority Index	CVrColorFlowPriorityIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10068	\N	(0039,0066)	US	1	CVr Opacity	CVrOpacity	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10069	\N	(0039,0067)	US	1	CVr Threshold High	CVrThresholdHigh	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10070	\N	(0039,0068)	US	1	CVr Threshold Low	CVrThresholdLow	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10071	\N	(0039,0069)	US	1	Voi Mode	VoiMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10072	\N	(0039,006a)	US	1	Voi Rotation Offset Deg	VoiRotationOffsetDeg	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10073	\N	(0039,006b)	FD	1	Voi Size Ratio X	VoiSizeRatioX	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10074	\N	(0039,006c)	FD	1	Voi Size Ratio Y	VoiSizeRatioY	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10075	\N	(0039,006d)	FD	1	Voi Size Ratio Z	VoiSizeRatioZ	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10076	\N	(0039,006e)	US	1	Voi Sync Plane	VoiSyncPlane	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10077	\N	(0039,006f)	US	1	Voi View Mode	VoiViewMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10078	\N	(0039,0070)	FD	1-n	Vr Orientation A	VrOrientationA	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10079	\N	(0039,0071)	FD	1-n	Mpr Orientation A	MprOrientationA	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10080	\N	(0039,0072)	FD	1	Vr Offset Vector	VrOffsetVector	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10081	\N	(0039,0073)	FD	1	Blending Ratio	BlendingRatio	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10082	\N	(0039,0074)	US	1	Fusion Blend Mode	FusionBlendMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10083	\N	(0039,0075)	FD	1	Quality Factor	QualityFactor	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10084	\N	(0039,0076)	US	1	Renderer Type	RendererType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10085	\N	(0039,0077)	US	1	Slice Mode	SliceMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10086	\N	(0039,0078)	US	1	Active Quad	ActiveQuad	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10087	\N	(0039,0079)	US	1	Screen Mode	ScreenMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10088	\N	(0039,007a)	US	1	Cut Plane Side	CutPlaneSide	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10089	\N	(0039,007b)	US	1	Wireframe Mode	WireframeMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10090	\N	(0039,007c)	US	1	Crossmark Mode	CrossmarkMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10091	\N	(0039,007d)	US	1	Mpr Display Type	MprDisplayType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10092	\N	(0039,007e)	US	1	Volume Display Type	VolumeDisplayType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10093	\N	(0039,007f)	US	1	Last Reset	LastReset	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10094	\N	(0039,0080)	US	1	Last Non Full Screen Mode	LastNonFullScreenMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10095	\N	(0039,0081)	US	1	Mpr Tool Index	MprToolIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10096	\N	(0039,0082)	US	1	Voi Tool Index	VoiToolIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10097	\N	(0039,0083)	US	1	Tool Loop Mode	ToolLoopMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10098	\N	(0039,0084)	US	1	Volume Arb Mode	VolumeArbMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10099	\N	(0039,0085)	US	1	Mpr Zoom Enabled	MprZoomEn	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10100	\N	(0039,0086)	US	1	Is Volume Zoom Enabled	IsVolumeZoomEn	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10101	\N	(0039,0087)	SS	1	Zoom Level Mpr	ZoomLevelMpr	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	2702	\N	(0019,0006)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	10102	\N	(0039,0088)	SS	1	Zoom Level Volume	ZoomLevelVolume	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10103	\N	(0039,0089)	US	1	Is Auto Rotate Enabled	IsAutoRotateEn	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10104	\N	(0039,008a)	US	1	Auto Rotate Axis	AutoRotateAxis	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10105	\N	(0039,008b)	US	1	Auto Rotate Range Index	AutoRotateRangeIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10106	\N	(0039,008c)	US	1	Auto Rotate Speed Index	AutoRotateSpeedIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10107	\N	(0039,008d)	US	1	CVr Brightness	CVrBrightness	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10108	\N	(0039,008e)	US	1	CFlow State Index	CFlowStateIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10109	\N	(0039,008f)	US	1	BSubmode Index	BSubmodeIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10110	\N	(0039,0090)	US	1	CSubmode Index	CSubmodeIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10111	\N	(0039,0091)	US	1	Cut Plane	CutPlane	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10112	\N	(0039,0092)	US	1	Bookmark Chunk Id	BookmarkChunkId	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10113	\N	(0039,0093)	US	1	Sequence Min Chunk Id	SequenceMinChunkId	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10114	\N	(0039,0094)	US	1	Sequence Max Chunk Id	SequenceMaxChunkId	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10115	\N	(0039,0095)	FD	1	Volume Rate Hz	VolumeRateHz	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10116	\N	(0039,009a)	FD	1	Voi Position Offset X	VoiPositionOffsetX	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10117	\N	(0039,009b)	FD	1	Voi Position Offset Y	VoiPositionOffsetY	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10118	\N	(0039,009c)	FD	1	Voi Position Offset Z	VoiPositionOffsetZ	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10119	\N	(0039,009d)	US	1	Vr Tool Index	VrToolIndex	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10120	\N	(0039,009e)	US	1	Shading Percent	ShadingPercent	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10121	\N	(0039,009f)	US	1	Volume Type	VolumeType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10122	\N	(0039,00a0)	US	1	Vr Quad Display Type	VrQuadDisplayType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10123	\N	(0039,00a1)	FD	1-n	Mpr Center Location	MprCenterLocation	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10124	\N	(0039,00e0)	US	1	Slice Range Type	SliceRangeType	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10125	\N	(0039,00e1)	US	1	Slice MPR Plane	SliceMPRPlane	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10126	\N	(0039,00e2)	US	1	Slice Layout	SliceLayout	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10127	\N	(0039,00e3)	FD	1	Slice Spacing	SliceSpacing	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10128	\N	(0039,00e4)	US	1	Thin Vr Mode	ThinVrMode	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10129	\N	(0039,00e5)	US	1	Thin Vr Thickness	ThinVrThickness	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10130	\N	(0039,00e6)	FD	1	Curved TOP VOI Pivot X	VoiPivotX	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10131	\N	(0039,00e7)	FD	1	Curved TOP VOI Pivot Y	VoiPivotY	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10132	\N	(0039,00e8)	FD	1	Curved TOP VOI Pivot Z	VoiPivotZ	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10133	\N	(0039,00e9)	US	1	Curved TOP VOI Quadrant	CTopVoiQuad	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10134	\N	(0039,00ea)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10135	\N	(0039,00ed)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10136	\N	(0039,00ee)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10137	\N	(0039,00ef)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10138	\N	(0039,00f0)	US	1-n	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10139	\N	(0039,00f1)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10140	\N	(0039,00f2)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10141	\N	(0039,00f3)	US	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10142	\N	(0039,00f4)	FD	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10143	\N	(0039,00f5)	LO	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10144	\N	(0039,00f6)	LT	1	Unknown	Unknown	SIEMENS MED SMS USG S2000 3D VOLUME	SSPI	\N	\N	\N
f	10145	\N	(0039,0076)	CS	1	Beam Display Properties	BeamDisplayProperties	SIEMENS MED OCS BEAM DISPLAY INFO	SSPI	\N	\N	\N
f	10146	\N	(0039,0001)	UT	1	External Attributes	ExternalAttributes	SIEMENS MED OCS PUBLIC RT PLAN ATTRIBUTES	SSPI	\N	\N	\N
f	10147	\N	(0039,0076)	LO	1	Structure Set Predecessor	StructureSetPredecessor	SIEMENS MED OCS SS VERSION INFO	SSPI	\N	\N	\N
f	10148	\N	(0011,0020)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10149	\N	(0011,0024)	DS	1-n	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10150	\N	(0011,0030)	LO	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10151	\N	(0011,0031)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10152	\N	(0011,0032)	SL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10153	\N	(0011,0039)	CS	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10154	\N	(0011,003a)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10155	\N	(0011,00d0)	OB	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10156	\N	(0011,00e0)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10157	\N	(0011,00e1)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10158	\N	(0011,00e2)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10159	\N	(0011,00e3)	US	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10160	\N	(0011,00e4)	US	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10161	\N	(0011,00e5)	CS	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10162	\N	(0063,000c)	DS	1-n	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10163	\N	(0063,0035)	SQ	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10164	\N	(0063,0020)	US	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10165	\N	(0063,0021)	UL	1	Unknown	Unknown	BioPri3D	SSPI	\N	\N	\N
f	10166	\N	(2121,0001)	ST	1	Calibration Method	CalibrationMethod	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10167	\N	(2121,0002)	ST	1	Calibration Method Info	CalibrationMethodInfo	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10168	\N	(2121,0003)	FL	1	Calibration Object Size	CalibrationObjectSize	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10169	\N	(2121,0004)	FL	1	Calibration Object S Dev	CalibrationObjectSDev	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10170	\N	(2121,0005)	FL	1	Calibration Horizontal Pixel Spacing	CalibrationHorizontalPixelSpacing	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10171	\N	(2121,0006)	FL	1	Calibration Vertical Pixel Spacing	CalibrationVerticalPixelSpacing	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10172	\N	(2121,0008)	ST	1	Calibration File Name	CalibrationFileName	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10173	\N	(2121,0009)	IS	1	Calibration Frame Number	CalibrationFrameNumber	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10174	\N	(2121,000a)	SH	1	Calibration Object Unit	CalibrationObjectUnit	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10175	\N	(2121,000b)	SS	1	Averaged Calibrations Performed	AveragedCalibrationsPerformed	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10176	\N	(2121,000c)	FL	1	Auto Magnify Factor	AutoMagnifyFactor	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10177	\N	(2121,000d)	FL	1	Horizontal Pixel S Dev	HorizontalPixelSDev	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	10178	\N	(2121,000e)	FL	1	Vertical Pixel S Dev	VerticalPixelSDev	PMI Private Calibration Module Version 2.0	\N	\N	\N	\N
f	64	\N	(0029,0000)	SQ	1	Edge Enhancement Sequence	EdgeEnhancementSequence	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	65	\N	(0029,0001)	US	2	Convolution Kernel Size	ConvolutionKernelSize	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	66	\N	(0029,0002)	US	1-n	Convolution Kernel Coefficients	ConvolutionKernelCoefficients	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	67	\N	(0029,0003)	FL	1	Edge Enhancement Gain	EdgeEnhancementGain	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	10179	\N	(0029,00ac)	FL	1	Displayed Area Bottom Right Hand Corner Fractional	DisplayedAreaBottomRightHandCornerFractional	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	10180	\N	(0029,00ad)	FL	1	Displayed Area Top Left Hand Corner Fractional	DisplayedAreaTopLeftHandCornerFractional	CARDIO-D.R. 1.0	SSPI	\N	\N	\N
f	10181	\N	(0009,0002)	OB	1	Unknown	Unknown	POLYTRON-SMS 2.5	SSPI	\N	\N	\N
f	10182	\N	(0009,0004)	OB	1	Unknown	Unknown	POLYTRON-SMS 2.5	SSPI	\N	\N	\N
f	10183	\N	(0009,0006)	OB	1	Unknown	Unknown	POLYTRON-SMS 2.5	SSPI	\N	\N	\N
f	10184	\N	(0089,0010)	OB	1	Unknown	Unknown	POLYTRON-SMS 2.5	SSPI	\N	\N	\N
f	10185	\N	(300b,0010)	CS	1	Plan Type	PlanType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10186	\N	(300b,0011)	LT	1	Delivery Warning Dose Comment	DeliveryWarningDoseComment	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10187	\N	(300b,0012)	LO	1	Imager Organ Program	ImagerOrganProgram	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10188	\N	(300b,0013)	DS	1	XA Image SID	XAImageSID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10189	\N	(300b,0014)	DS	1	XA Image Receptor Angle	XAImageReceptorAngle	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10190	\N	(300b,0015)	CS	1	Target Prescription Dose Type	TargetPrescriptionDoseType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10191	\N	(300b,0016)	IS	1	Referenced Target ROI Number	ReferencedTargetROINumber	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10192	\N	(300b,0017)	UT	1	RT Private Data	RTPrivateData	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10193	\N	(300b,0018)	SQ	1	Referenced Siemens Non Image Sequence	ReferencedSiemensNonImageSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10194	\N	(300b,0019)	CS	1	Verification Method	VerificationMethod	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10195	\N	(300b,0020)	SQ	1	Alternative Treatment Machine Name Sequence	AlternativeTreatmentMachineNameSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10196	\N	(300b,0024)	DS	1	Imager Angular Angle	ImagerAngularAngle	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10197	\N	(300b,0025)	DS	1	Imager Isocentric Angle	ImagerIsocentricAngle	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10198	\N	(300b,0026)	DS	1	Imager Vertical Position	ImagerVerticalPosition	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10199	\N	(300b,0027)	DS	1	Imager Longitudinal Position	ImagerLongitudinalPosition	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10200	\N	(300b,0028)	DS	1	Imager Lateral Position	ImagerLateralPosition	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10201	\N	(300b,0029)	CS	1	Imager Angular Rotation Direction	ImagerAngularRotationDirection	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10202	\N	(300b,002a)	CS	1	Imager Isocentric Rotation Direction	ImagerIsocentricRotationDirection	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10203	\N	(300b,002b)	DS	1	Requested Scanning Spot Size	RequestedScanningSpotSize	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10204	\N	(300b,002c)	DS	1	Imager Orbital Angle	ImagerOrbitalAngle	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10205	\N	(300b,002e)	CS	1	Imaging Technique	ImagingTechnique	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10206	\N	(300b,002f)	CS	1	Imager Orbital Rotation Direction	ImagerOrbitalRotationDirection	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10207	\N	(300b,0030)	LO	1	Patient Barcode	PatientBarcode	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10208	\N	(300b,0031)	SH	3	Beam Modifier Type	BeamModifierType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10209	\N	(300b,0032)	FL	3	Source to Range Shifter Distance	SourceToRangeShifterDistance	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10210	\N	(300b,0033)	SH	3	Treatment Room Name	TreatmentRoomName	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10211	\N	(300b,0060)	IS	1-n	Ordered Referenced Beam Numbers	OrderedReferencedBeamNumbers	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10212	\N	(300b,0066)	LT	1	Fraction Delivery Notes	FractionDeliveryNotes	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10213	\N	(300b,0067)	LO	1	Record ID	RecordID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10214	\N	(300b,0076)	CS	1	Fraction Group Code	FractionGroupCode	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10215	\N	(300b,0077)	IS	1	Referenced Treatment Beam Number	ReferencedTreatmentBeamNumber	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10216	\N	(300b,0078)	DS	1	Fraction Dose to Dose Reference	FractionDoseToDoseReference	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10217	\N	(300b,0080)	SQ	1	Referenced Target ROI Sequence	ReferencedTargetROISequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10218	\N	(300b,0082)	DS	1	Target ROI Lateral Expansion Margin	TargetROILateralExpansionMargin	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10219	\N	(300b,0083)	DS	1	Target ROI Distal Expansion Margin	TargetROIDistalExpansionMargin	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10220	\N	(300b,0084)	DS	1	Target ROI Proximal Expansion Margin	TargetROIProximalExpansionMargin	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10221	\N	(300b,0085)	DS	2	Scan Grid Lateral Distance	ScanGridLateralDistance	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10222	\N	(300b,0086)	DS	1	Scan Grid Longitudinal Distance	ScanGridLongitudinalDistance	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10223	\N	(300b,0087)	DS	1	Beam Weight	BeamWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10224	\N	(300b,0089)	DS	3	Point on Plane	PointOnPlane	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10225	\N	(300b,008a)	DS	3	Norm Vector of Plane	NormVectorOfPlane	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10226	\N	(300b,008b)	DS	1	Plane Thickness	PlaneThickness	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10227	\N	(300b,0090)	SQ	1	Treatment Approval Sequence	TreatmentApprovalSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10228	\N	(300b,0098)	DS	1	Treatment Room Temperature	TreatmentRoomTemperature	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10229	\N	(300b,0099)	DS	1	Treatment Room Air Pressure	TreatmentRoomAirPressure	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10230	\N	(300b,009b)	SQ	1	Split Plane Sequence	Split[laneSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10231	\N	(300b,009c)	IS	1	Display Color	DisplayColor	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10232	\N	(300b,009d)	SH	1	Beam Group Name	BeamGroupName	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10233	\N	(300b,00a0)	DT	1	Expire DateTime	ExpireDateTime	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10234	\N	(300b,00a1)	OB	1	Checksum Encryption Code	ChecksumEncryptionCode	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10235	\N	(300b,00a2)	CS	1	Setup Type	SetupType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10236	\N	(300b,00a3)	IS	1	Number of Therapy Detectors	NumberofTherapyDetectors	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10237	\N	(300b,00a4)	SQ	1	Therapy Detector Sequence	TherapyDetectorSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10238	\N	(300b,00a5)	IS	1	Therapy Detector Number	TherapyDetectorNumber	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10239	\N	(300b,00a6)	SH	1	Therapy Detector Setup ID	TherapyDetectorSetupID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10240	\N	(300b,00a7)	SQ	1	Therapy Detector Settings Sequence	TherapyDetectorSettingsSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10241	\N	(300b,00a8)	IS	1	Referenced Therapy Detector Number	ReferencedTherapyDetectorNumber	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10242	\N	(300b,00a9)	DS	1	Therapy Detector Position	TherapyDetectorPosition	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10243	\N	(300b,00b0)	IS	1	Scan Spot Resumption Index	ScanSpotResumptionIndex	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10244	\N	(300b,00b1)	OW	1	Phantom Detector Measurements	PhantomDetectorMeasurements	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10245	\N	(300b,00b2)	UT	1	Treatment Events	TreatmentEvents	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10246	\N	(300b,00c0)	SQ	1	Dose Optimization Constraint Sequence	DoseOptimizationConstraintSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10247	\N	(300b,00c8)	DS	1	Target Maximum Dose Constraint	TargetMaximumDoseConstraint	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10248	\N	(300b,00c9)	DS	1	Target Maximum Dose Constraint Weight	TargetMaximumDoseConstraintWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10249	\N	(300b,00ca)	DS	1	Target Minimum Dose Constraint	TargetMinimumDoseConstraint	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10250	\N	(300b,00cb)	DS	1	Target Minimum Dose Constraint Weight	TargetMinimumDoseConstraintWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10251	\N	(300b,00cc)	DS	1	Organ At Risk Maximum Dose Constraint	OrganAtRiskMaximumDoseConstraint	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10252	\N	(300b,00cd)	DS	1	Organ At Risk Maximum Dose Constraint Weight	OrganAtRiskMaximumDoseConstraintWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10253	\N	(300b,00ce)	SQ	1	DVH Constraint Sequence	DVHConstraintSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10254	\N	(300b,00cf)	DS	1	DVH Constraint Volume Limit	DVHConstraintVolumeLimit	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10255	\N	(300b,00d0)	CS	1	DVH Constraint Volume Units	DVHConstraintVolumeUnits	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10256	\N	(300b,00d1)	DS	1	DVH Constraint Dose Limit	DVHConstraintDoseLimit	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10257	\N	(300b,00d3)	CS	1	DVH Constraint Direction	DVHConstraintDirection	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10258	\N	(300b,00d4)	DS	1	DVH Constraint Weight	DVHConstraintWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10259	\N	(300b,00d5)	CS	1	Optimized Dose Type	OptimizedDoseType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10260	\N	(300b,00d6)	UT	1	Dose Calculation and Optimization Parameters	DoseCalculationandOptimizationParameters	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10261	\N	(300b,00d7)	DS	1	Applied Renormalization Factor	AppliedRenormalizationFactor	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10262	\N	(300b,00d8)	CS	1	Dose Constraint Status	DoseConstraintStatus	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10263	\N	(300b,00d9)	DS	1	Organ At Risk Minimum Dose Constraint	OrganAtRiskMinimumDoseConstraint	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10264	\N	(300b,00da)	DS	1	Organ At Risk Minimum Dose Constraint Weight	OrganAtRiskMinimumDoseConstraintWeight	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10265	\N	(300b,00e0)	SQ	1	Base Data Group Sequence	BaseDataGroupSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10266	\N	(300b,00e1)	CS	1	Physics Base Data Group ID	PhysicsBaseDataGroupID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10267	\N	(300b,00e2)	CS	1	Biological Base Data Group ID	BiologicalBaseDataGroupID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10268	\N	(300b,00e3)	CS	1	Imaging Base Data Group ID	ImagingBaseDataGroupID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10269	\N	(300b,00e4)	CS	1	Dosimetric Base Data Group ID	DosimetricBaseDataGroupID	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10270	\N	(300b,00e5)	OB	1	Configuration Baseline	ConfigurationBaseline	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10271	\N	(300b,00e6)	OB	1	Configuration Objects	ConfigurationObjects	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10272	\N	(300b,00e7)	CS	1	Confidence Measure Units	ConfidenceMeasureUnits	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10273	\N	(300b,00e8)	DS	1	Confidence Measure Value	ConfidenceMeasureValue	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10274	\N	(300b,00e9)	LO	1	Imager Organ Program Name	ImagerOrganProgramName	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10275	\N	(300b,00eb)	CS	1	Body Region	BodyRegion	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10276	\N	(300b,00ec)	CS	1	Prefinalized Status	PrefinalizedStatus	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10437	\N	(7079,0034)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10277	\N	(300b,00ed)	OB	1	Dosimetric Checksum Encryption Code	DosimetricChecksumEncryptionCode	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10278	\N	(300b,00ee)	SQ	1	Referenced Report Sequence	ReferencedReportSequence	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10279	\N	(300b,00ef)	CS	1	Maintain Checksum Compatibility	MaintainChecksumCompatibility	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10280	\N	(300b,00f0)	DS	1	Dose Statistical Uncertainty	DoseStatisticalUncertainty	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10281	\N	(300b,00f1)	CS	1	Interpreted Radiation Type	InterpretedRadiationType	SIEMENS MED SYNGO RT	SSPI	\N	\N	\N
f	10282	\N	(7fd1,0001)	OB	1	Padding	Padding	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	SSPI	\N	\N	\N
f	10283	\N	(7fd1,0009)	OB	1	Version ID	VersionID	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	SSPI	\N	\N	\N
f	10284	\N	(7fd1,0010)	LO	1	Payload	Payload	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	SSPI	\N	\N	\N
f	10285	\N	(7fd1,0011)	LO	1	After Payload	AfterPayload	SIEMENS SYNGO ULTRA-SOUND TOYON DATA STREAMING	SSPI	\N	\N	\N
f	10286	\N	(0021,0000)	US	1	Nipple Position	NipplePosition	SIEMENS Ultrasound S2000	SSPI	\N	\N	\N
f	10287	\N	(0021,0001)	US	1	ABVS Clip Derived From Volume	ABVSClipDerivedFromVolume	SIEMENS Ultrasound S2000	SSPI	\N	\N	\N
f	10288	\N	(0079,0000)	LO	1	Analgesia	Analgesia	SMIL_PB79	SMIL	\N	\N	\N
f	10289	\N	(0079,0001)	LO	1	Anesthesia	Anesthesia	SMIL_PB79	SMIL	\N	\N	\N
f	10290	\N	(0079,0002)	IS	1	Bed Motion	BedMotion	SMIL_PB79	SMIL	\N	\N	\N
f	10291	\N	(0079,0003)	LO	1	Food Access	FoodAccess	SMIL_PB79	SMIL	\N	\N	\N
f	10292	\N	(0079,0004)	DS	1	Histogram Version	HistogramVersion	SMIL_PB79	SMIL	\N	\N	\N
f	10293	\N	(0079,0006)	DS	1	Injection Decay Correction	InjectionDecayCorrection	SMIL_PB79	SMIL	\N	\N	\N
f	10294	\N	(0079,0007)	LO	1	Isotope	Isotope	SMIL_PB79	SMIL	\N	\N	\N
f	10295	\N	(0079,0008)	LO	1	Other Drugs	OtherDrugs	SMIL_PB79	SMIL	\N	\N	\N
f	10296	\N	(0079,0009)	IS	1	RebinningType	RebinningType	SMIL_PB79	SMIL	\N	\N	\N
f	10297	\N	(0079,000a)	DS	1	Rebinning Version	RebinningVersion	SMIL_PB79	SMIL	\N	\N	\N
f	10298	\N	(0079,000b)	IS	1	Reconstruction	Reconstruction	SMIL_PB79	SMIL	\N	\N	\N
f	10299	\N	(0079,000c)	DS	1	ReconstructionVersion	ReconstructionVersion	SMIL_PB79	SMIL	\N	\N	\N
f	10300	\N	(0079,000d)	LO	1	Injected Compounds	InjectedCompound	SMIL_PB79	SMIL	\N	\N	\N
f	10301	\N	(0079,000e)	LO	1	Study Model	StudyModel	SMIL_PB79	SMIL	\N	\N	\N
f	10302	\N	(0079,000f)	LO	1	Subject Genus	SubjectGenus	SMIL_PB79	SMIL	\N	\N	\N
f	10303	\N	(0079,0010)	LO	1	Subject Phenotype	SubjectPhenotype	SMIL_PB79	SMIL	\N	\N	\N
f	10304	\N	(0079,0011)	DS	1	Version	Version	SMIL_PB79	SMIL	\N	\N	\N
f	10305	\N	(0079,0012)	LO	1	Water Access	WaterAccess	SMIL_PB79	SMIL	\N	\N	\N
f	10306	\N	(0079,0013)	DS	1	X Offset	XOffset	SMIL_PB79	SMIL	\N	\N	\N
f	10307	\N	(0079,0014)	DS	1	Y Offset	YOffset	SMIL_PB79	SMIL	\N	\N	\N
f	10308	\N	(0079,0015)	DS	1	Zoom	Zoom	SMIL_PB79	SMIL	\N	\N	\N
f	10309	\N	(0079,0017)	IS	1	Subject Orientation	SubjectOrientation	SMIL_PB79	SMIL	\N	\N	\N
f	10310	\N	(007b,0000)	LO	1	Units	Units	SMIO_PB7B	SMIO	\N	\N	\N
f	10311	\N	(007d,0001)	UL	1	Geometry	Geometry	SMIO_PB7D	SMIO	\N	\N	\N
f	10312	\N	(007d,0002)	FL	1	Spacing	Spacing	SMIO_PB7D	SMIO	\N	\N	\N
f	10313	\N	(007d,0003)	FL	1	Origin	Origin	SMIO_PB7D	SMIO	\N	\N	\N
f	2253	\N	(0009,0010)	LO	1	Comments	Comments	SPI	SPI	\N	\N	\N
f	2237	\N	(0009,0010)	LO	1	Comments	Comments	SPI RELEASE 1	SPI	\N	\N	\N
f	2245	\N	(0009,0010)	LO	1	Comments	Comments	SPI Release 1	SPI	\N	\N	\N
f	2254	\N	(0009,0015)	LO	1	UID	UID	SPI	SPI	\N	\N	\N
f	2238	\N	(0009,0015)	LO	1	UID	UID	SPI RELEASE 1	SPI	\N	\N	\N
f	2246	\N	(0009,0015)	LO	1	UID	UID	SPI Release 1	SPI	\N	\N	\N
f	2255	\N	(0009,0040)	US	1	Data Object Type	DataObjectType	SPI	SPI	\N	\N	\N
f	2239	\N	(0009,0040)	US	1	Data Object Type	DataObjectType	SPI RELEASE 1	SPI	\N	\N	\N
f	2247	\N	(0009,0040)	US	1	Data Object Type	DataObjectType	SPI Release 1	SPI	\N	\N	\N
f	2256	\N	(0009,0041)	SH	1	Data Object Subtype	DataObjectSubtype	SPI	SPI	\N	\N	\N
f	2240	\N	(0009,0041)	SH	1	Data Object Subtype	DataObjectSubtype	SPI RELEASE 1	SPI	\N	\N	\N
f	2248	\N	(0009,0041)	SH	1	Data Object Subtype	DataObjectSubtype	SPI Release 1	SPI	\N	\N	\N
f	2257	\N	(0011,0010)	LO	1	Organ	Organ	SPI	SPI	\N	\N	\N
f	2241	\N	(0011,0010)	LO	1	Organ	Organ	SPI RELEASE 1	SPI	\N	\N	\N
f	2249	\N	(0011,0010)	LO	1	Organ	Organ	SPI Release 1	SPI	\N	\N	\N
f	2258	\N	(0011,0015)	LO	1	Allergy Indication	AllergyIndication	SPI	SPI	\N	\N	\N
f	2242	\N	(0011,0015)	LO	1	Allergy Indication	AllergyIndication	SPI RELEASE 1	SPI	\N	\N	\N
f	2250	\N	(0011,0015)	LO	1	Allergy Indication	AllergyIndication	SPI Release 1	SPI	\N	\N	\N
f	2259	\N	(0011,0020)	LO	1	Pregnancy	Pregnancy	SPI	SPI	\N	\N	\N
f	2243	\N	(0011,0020)	LO	1	Pregnancy	Pregnancy	SPI RELEASE 1	SPI	\N	\N	\N
f	2251	\N	(0011,0020)	LO	1	Pregnancy	Pregnancy	SPI Release 1	SPI	\N	\N	\N
f	2244	\N	(0029,0060)	LO	1	Compression Algorithm	CompressionAlgorithm	SPI RELEASE 1	SPI	\N	\N	\N
f	2252	\N	(0029,0060)	LO	1	Compression Algorithm	CompressionAlgorithm	SPI Release 1	SPI	\N	\N	\N
f	10314	\N	(0009,0000)	LO	1	HIS/RIS Study ID	HISRISStudyID	TOSHIBA_MEC_OT3	TSH	\N	\N	\N
f	2682	\N	(0009,0001)	LT	1	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2683	\N	(0009,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2684	\N	(0009,0003)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2685	\N	(0009,0004)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2686	\N	(0011,0001)	LT	1	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2687	\N	(0011,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2697	\N	(0019,0001)	IS	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2688	\N	(0019,0001)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2698	\N	(0019,0002)	IS	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2689	\N	(0019,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2699	\N	(0019,0003)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2700	\N	(0019,0004)	LT	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2701	\N	(0019,0005)	LT	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2703	\N	(0019,0007)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2704	\N	(0019,0008)	LT	1	Orientation Head Feet	OrientationHeadFeet	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2705	\N	(0019,0009)	LT	1	View Direction	ViewDirection	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2706	\N	(0019,000a)	LT	1	Orientation Supine Prone	OrientationSupineProne	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2707	\N	(0019,000b)	DS	1	Location	Location	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2708	\N	(0019,000c)	CS	1	Scan View Direction	ScanViewDirection	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2709	\N	(0019,000d)	TM	1	Time	Time	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2710	\N	(0019,000e)	DS	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2690	\N	(0021,0001)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2691	\N	(0021,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2692	\N	(0021,0003)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	10315	\N	(0029,0008)	CS	1	Non-Image Header Type	NonImageHeaderType	TOSHIBA MDW NON-IMAGE	TSH	\N	\N	\N
f	10316	\N	(0029,0009)	LO	1	Non-Image Header Version	NonImageHeaderVersion	TOSHIBA MDW NON-IMAGE	TSH	\N	\N	\N
f	10317	\N	(0029,0020)	OB	1	Unknown	Unknown	TOSHIBA MDW NON-IMAGE	TSH	\N	\N	\N
f	10318	\N	(0029,0008)	CS	1	Image Header Type	ImageHeaderType	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10319	\N	(0029,0009)	LO	1	Image Header Version	ImageHeaderVersion	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10320	\N	(0029,0010)	OB	1	Image Header Info	ImageHeaderInfo	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10321	\N	(0029,0018)	CS	1	Series Header Type	SeriesHeaderType	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10322	\N	(0029,0019)	LO	1	Series Header Version	SeriesHeaderVersion	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10323	\N	(0029,0020)	OB	1	Series Header Info	SeriesHeaderInfo	TOSHIBA MDW HEADER	TSH	\N	\N	\N
f	10324	\N	(0029,0008)	CS	1	COMAPL Header Type	COMAPLHeaderType	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10325	\N	(0029,0009)	LO	1	COMAPL Header Version	COMAPLHeaderVersion	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10326	\N	(0029,0010)	OB	1	COMAPL Header Info	COMAPLHeaderInfo	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10327	\N	(0029,0020)	OB	1	COMAPL History Information	COMAPLHistoryInformation	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10328	\N	(0029,0031)	LO	1	Unknown	Unknown	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10329	\N	(0029,0034)	LO	1	Unknown	Unknown	TOSHIBA COMAPL HEADER	TSH	\N	\N	\N
f	10330	\N	(0029,0008)	CS	1	COMAPL OOG Type	COMAPLOOGType	TOSHIBA COMAPL OOG	TSH	\N	\N	\N
f	10331	\N	(0029,0009)	LO	1	COMAPL OOG Version	COMAPLOOGVersion	TOSHIBA COMAPL OOG	TSH	\N	\N	\N
f	10332	\N	(0029,0010)	OB	1	COMAPL OOG Info	COMAPLOOGInfo	TOSHIBA COMAPL OOG	TSH	\N	\N	\N
f	10333	\N	(0029,0001)	SQ	1	Unknown	Unknown	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10334	\N	(0029,0031)	LO	1	PMTF Information 1	PMTFInformation1	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10335	\N	(0029,0032)	UL	1	PMTF Information 2	PMTFInformation2	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10336	\N	(0029,0033)	UL	1	PMTF Information 3	PMTFInformation3	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10337	\N	(0029,0034)	CS	1	PMTF Information 4	PMTFInformation4	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10338	\N	(0029,0089)	LO	1	Unknown	Unknown	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10339	\N	(0029,0090)	OB	1	Unknown	Unknown	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10340	\N	(7005,0000)	OB	1	CT Private Data 1	CTPrivateData1	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10341	\N	(7005,0003)	SH	1	Cardiac R-R Mean Time	CardiacRRMeanTime	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10342	\N	(7005,0004)	SH	1	Cardiac Reconstruction Getting Phase in Percent	CardiacReconstructionGettingPhaseInPercent	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10343	\N	(7005,0005)	SH	1	Cardiac Reconstruction Getting Phase in ms	CardiacReconstructionGettingPhaseInMS	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10344	\N	(7005,0006)	SH	1	Cardiac Reconstruction Mode	CardiacReconstructionMode	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10345	\N	(7005,0007)	DS	1-n	Reconstruction Center	ReconstructionCenter	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10346	\N	(7005,0008)	DS	1	Detector Slice Thickness in mm	DetectorSliceThickness	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10347	\N	(7005,0009)	LO	1	Number of Detector rows to Reconstruct	NumberOfDetectorRowsToReconstruct	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10348	\N	(7005,000a)	DS	1	Table Speed in mm/rot	TableSpeed	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10349	\N	(7005,000b)	SH	1	Filter	Filter	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10350	\N	(7005,000c)	SH	1	Reconstruction Correction Type	ReconstructionCorrectionType	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10351	\N	(7005,000d)	SH	1	Organ	Organ	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10352	\N	(7005,000e)	SH	1	File Type Remarks	FileTypeRemarks	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10353	\N	(7005,000f)	SH	1	Direction (head or feet first)	Direction	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10354	\N	(7005,0010)	OB	1	CT Private Data 2	CTPrivateData2	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10355	\N	(7005,0011)	LT	1	Series Comment	SeriesComment	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10356	\N	(7005,0012)	SH	1	Position (supine or prone)	Position	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10357	\N	(7005,0013)	US	1	Expert Plan Number	ExpertPlanNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10358	\N	(7005,0014)	US	1	Reconstruction ROI Number	ReconstructionROINumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10359	\N	(7005,0015)	US	1	Special Helical Acquisition Number	SpecialHelicalAcquisitionNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10360	\N	(7005,0016)	UI	1	Volume UID	VolumeUID	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10361	\N	(7005,0017)	US	1	Total Frame Count in the Volume	TotalFrameCountInTheVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10362	\N	(7005,0018)	US	1	Frame Number	FrameNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10363	\N	(7005,0019)	UL	1	Frame Sort Key	FrameSortKey	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10364	\N	(7005,001a)	US	1	Frame Sort Order	FrameSortOrder	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10365	\N	(7005,001b)	SH	1	Convolution Kernel for Series Record	ConvolutionKernelForSeriesRecord	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10366	\N	(7005,001c)	LO	1	Contrast/Bolus Agent for Series Record	ContrastBolusAgentForSeriesRecord	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10367	\N	(7005,001d)	UL	1	Reconstruction Number	ReconstructionNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10368	\N	(7005,001e)	UL	1	Raw Data Number	RawDataNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10369	\N	(7005,001f)	LO	1	Volume Number	VolumeNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10370	\N	(7005,0020)	UL	1	Local Series Number	LocalSeriesNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10371	\N	(7005,0021)	LO	1	Decrease in Artifact Filter	DecreaseInArtifactFilter	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10372	\N	(7005,0022)	DS	1	Reconstruction Interval	ReconstructionInterval	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10373	\N	(7005,0023)	DS	1	Pitch Factor	PitchFactor	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10374	\N	(7005,0024)	DA	1	AcquisitionDateOfNRA	AcquisitionDateOfNRA	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10375	\N	(7005,0025)	UL	1	Large Data File Attribute	LargeDataFileAttribute	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10376	\N	(7005,0026)	CS	1-8	Large Data File Name	LargeDataFileName	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10377	\N	(7005,0028)	SQ	1	Enhanced CT Private Sequence	EnhancedCTPrivateSequence	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10378	\N	(7005,0029)	UI	1	Frame UID	FrameUID	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10379	\N	(7005,0030)	CS	1	Main Modality in Study	MainModalityInStudy	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10380	\N	(7005,0035)	DS	2	Scan Range	ScanRange	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10381	\N	(7005,0036)	OB	1	CT Private Data 3	CTPrivateData3	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10382	\N	(7005,0037)	IS	1	Total Frames	TotalFrames	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10383	\N	(7005,0038)	IS	1	Start Frame	StartFrame	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10384	\N	(7005,0039)	IS	1	End Frame	EndFrame	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10385	\N	(7005,0040)	FD	1	DLP	DLP	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10386	\N	(7005,0041)	SH	1	Row Slice Information	RowSliceInformation	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10387	\N	(7005,0042)	US	1	Local Frame Number	LocalFrameNumber	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10388	\N	(7005,0043)	DS	3	Volume Vector	VolumeVector	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10389	\N	(7005,0044)	US	1	Volume Type	VolumeType	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10390	\N	(7005,0045)	DS	1	Relative Table Position of 4D Volume	RelativeTablePositionOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10391	\N	(7005,0046)	DS	1	Absolute Table Position of 4D Volume	AbsoluteTablePositionOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10392	\N	(7005,0047)	DS	1	Slice Pitch of 4D Volume	SlicePitchOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10393	\N	(7005,0048)	LO	1	Respiratory Gating Information	RespiratoryGatingInformation	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10394	\N	(7005,0049)	SH	1	Respiratory Phase	RespiratoryPhase	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10395	\N	(7005,0061)	LO	1	Synchronized Signal Information	SynchronizedSignalInformation	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10396	\N	(7005,0062)	DS	1	Total Raw Data Size	TotalRawDataSize	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10397	\N	(7005,0063)	FD	1	CTDIw	CTDIw	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10398	\N	(7005,0067)	UI	1	Volume UID of 4D-Volume	VolumeUIDOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10399	\N	(7005,0068)	US	1	Total Frame Count in 4D-Volume	TotalFrameCountIn4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10400	\N	(7005,0069)	US	1	Frame Number in 4D-Volume	FrameNumberIn4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10401	\N	(7005,006a)	DS	3	Image Position of 4D-Volume Top	ImagePositionOf4DVolumeTop	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10402	\N	(7005,006b)	DS	3	Image Position of 4D-Volume Top (Equipment)	ImagePositionOf4DVolumeTopEquipment	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10403	\N	(7005,006c)	UI	1	SOP Instance UID of 4D-Volume	SOPInstanceUIDOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10404	\N	(7005,006d)	UI	1	Series Instance UID of 4D-Volume	SeriesInstanceUIDOf4DVolume	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10405	\N	(7005,00f1)	CS	1	Protect Mark for Image, Curve or Private Record	ProtectMarkForImageCurveOrPrivateRecord	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10405	\N	(7005,00f1)	CS	1	Protect Mark for Series Record	ProtectMarkForSeriesRecord	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10405	\N	(7005,00f1)	CS	1	Protect Mark for Study Record	ProtectMarkForStudyRecord	TOSHIBA_MEC_CT3	TSH	\N	\N	\N
f	10406	\N	(700d,0000)	DS	1	Scale Factor	ScaleFactor	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10407	\N	(700d,0001)	OB	1	Acquisition Order	AcquisitionOrder	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10408	\N	(700d,0002)	DS	1	Orientation Vector	OrientationVector	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10409	\N	(700d,0003)	SS	1	Flip Flag	FlipFlag	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10410	\N	(700d,0004)	OB	1	Rotate Information	RotateInformation	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10411	\N	(700d,0005)	DS	1	FOV	FOV	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10412	\N	(700d,0006)	US	1	Image Matrix	ImageMatrix	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10413	\N	(700d,0007)	OB	1	Image Information	ImageInformation	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10414	\N	(700d,0008)	OB	1	Original Data	OriginalData	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10415	\N	(700d,0009)	SS	1	Original Data Flag	OriginalDataFlag	TOSHIBA_MEC_MR3	TSH	\N	\N	\N
f	10416	\N	(7015,0000)	OB	1	Unknown	Unknown	TOSHIBA ENCRYPTED SR DATA	TSH	\N	\N	\N
f	10417	\N	(7015,0010)	OB	1	Unknown	Unknown	TOSHIBA_SR	TSH	\N	\N	\N
f	10418	\N	(7015,0060)	OB	1	Unknown	Unknown	TOSHIBA_SR	TSH	\N	\N	\N
f	10419	\N	(7015,0073)	SQ	1	Unknown	Unknown	PMTF INFORMATION DATA	TSH	\N	\N	\N
f	10420	\N	(7079,0021)	SH	5	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10421	\N	(7079,0022)	IS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10422	\N	(7079,0023)	IS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10423	\N	(7079,0024)	DS	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10424	\N	(7079,0025)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10425	\N	(7079,0026)	DS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10426	\N	(7079,0027)	US	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10427	\N	(7079,0028)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10428	\N	(7079,002a)	US	5	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10429	\N	(7079,002c)	SH	3	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10430	\N	(7079,002d)	SS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10431	\N	(7079,002e)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10432	\N	(7079,002f)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10433	\N	(7079,0030)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10434	\N	(7079,0031)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10435	\N	(7079,0032)	SH	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10436	\N	(7079,0033)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10438	\N	(7079,0035)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10439	\N	(7079,0036)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10440	\N	(7079,0037)	US	4	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10441	\N	(7079,0038)	SS	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10442	\N	(7079,0039)	SS	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10443	\N	(7079,003a)	US	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10444	\N	(7079,003b)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10445	\N	(7079,003c)	DS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10446	\N	(7079,003d)	SS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10447	\N	(7079,003e)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10448	\N	(7079,003f)	US	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10449	\N	(7079,0040)	SH	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10450	\N	(7079,0041)	SS	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10451	\N	(7079,0042)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10452	\N	(7079,0043)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10453	\N	(7079,0044)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10454	\N	(7079,0045)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10455	\N	(7079,0046)	SS	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10456	\N	(7079,0047)	SS	18	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10457	\N	(7079,0048)	US	12	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10458	\N	(7079,0049)	US	3	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10459	\N	(7079,004a)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10460	\N	(7079,004b)	LO	3	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10461	\N	(7079,004c)	OB	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10462	\N	(7079,004d)	SH	3	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10463	\N	(7079,004e)	SL	35	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10464	\N	(7079,004f)	SH	3	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10465	\N	(7079,0050)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10466	\N	(7079,0051)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10467	\N	(7079,0052)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10468	\N	(7079,0053)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10469	\N	(7079,0054)	US	5	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10470	\N	(7079,0055)	UL	47-47n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10471	\N	(7079,0056)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10472	\N	(7079,0057)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10473	\N	(7079,0058)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10474	\N	(7079,0059)	US	2-2n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10475	\N	(7079,005a)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10476	\N	(7079,005b)	US	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10477	\N	(7079,005c)	US	2-2n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10478	\N	(7079,005d)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10479	\N	(7079,005e)	US	2	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10480	\N	(7079,005f)	SS	4-4n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10481	\N	(7079,0060)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10482	\N	(7079,0061)	SS	30-30n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10483	\N	(7079,0062)	US	4	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10484	\N	(7079,0063)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10485	\N	(7079,0064)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10486	\N	(7079,0065)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10487	\N	(7079,0066)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10488	\N	(7079,0067)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10489	\N	(7079,0068)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10490	\N	(7079,0069)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10491	\N	(7079,006a)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10492	\N	(7079,006b)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10493	\N	(7079,006c)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10494	\N	(7079,006d)	DS	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10495	\N	(7079,006e)	LO	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10496	\N	(7079,006f)	DS	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10497	\N	(7079,0070)	DS	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10498	\N	(7079,0071)	DS	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10499	\N	(7079,0072)	DS	1-n	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10500	\N	(7079,0073)	SL	4	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10501	\N	(7079,0074)	SL	28	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10502	\N	(7079,0075)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10503	\N	(7079,0076)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10504	\N	(7079,0077)	SL	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10505	\N	(7079,0078)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10506	\N	(7079,0079)	US	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10507	\N	(7079,007b)	SH	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	10508	\N	(7079,0080)	LO	1	Unknown	Unknown	TOSHIBA_MEC_XA3	TSH	\N	\N	\N
f	2693	\N	(7ff1,0001)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2711	\N	(7ff1,0001)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2694	\N	(7ff1,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2712	\N	(7ff1,0002)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2713	\N	(7ff1,0003)	IS	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2695	\N	(7ff1,0003)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
f	2714	\N	(7ff1,0004)	IS	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2715	\N	(7ff1,0005)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2716	\N	(7ff1,0007)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2717	\N	(7ff1,0008)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2718	\N	(7ff1,0009)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2719	\N	(7ff1,000a)	LT	1	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2720	\N	(7ff1,000b)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2721	\N	(7ff1,000c)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2722	\N	(7ff1,000d)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_CT_1.0	TSH	\N	\N	\N
f	2696	\N	(7ff1,0010)	US	1-n	Unknown	Unknown	TOSHIBA_MEC_1.0	TSH	\N	\N	\N
\.


--
-- Data for Name: pt_gdcm; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt_gdcm (pt_gdcm_is_repeating, pt_id, ptrg_id, pt_gdcm_signature, pt_gdcm_vr, pt_gdcm_vm, pt_gdcm_name) FROM stdin;
\.


--
-- Data for Name: pt_observation; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt_observation (pt_id, pt_obs_observer, pt_obs_value, pt_obs_comment, pt_obs_time) FROM stdin;
\.


--
-- Data for Name: pt_wustl; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pt_wustl (pt_id, pt_wustl_vr, pt_wustl_vm, pt_wustl_vm_second, pt_wustl_name, pt_wustl_name_second, pt_wustl_disposition, pt_wustl_disposition_second, pt_wustl_is_specific_to_block, pt_wustl_private_block, pt_wustl_signature, pt_wustl_device_sig) FROM stdin;
160	SH		\N	Image Control Unit	\N	X	\N	f	\N	(0009,"FDMS 1.0",04)	combined.txt
161	OW		\N	Image UID	\N	X	\N	f	\N	(0009,"FDMS 1.0",05)	combined.txt
162	OW		\N	Route Image UID	\N	X	\N	f	\N	(0009,"FDMS 1.0",06)	combined.txt
163	UL		\N	Image Display Information Version No.	\N	KB	\N	f	\N	(0009,"FDMS 1.0",08)	combined.txt
164	UL		\N	Patient Information Version No.	\N	X	\N	f	\N	(0009,"FDMS 1.0",09)	combined.txt
4924	OW		\N	Film UID	\N	X	\N	f	\N	(0009,"FDMS 1.0",0c)	combined.txt
166	CS		\N	Exposure Unit Type Code	\N	K	\N	f	\N	(0009,"FDMS 1.0",10)	combined.txt
167	LO		\N	Kanji Hospital Name	\N	X	\N	f	\N	(0009,"FDMS 1.0",80)	combined.txt
168	ST		\N	Distribution Code	\N	X	\N	f	\N	(0009,"FDMS 1.0",90)	combined.txt
169	SH		\N	Kanji Department Name	\N	X	\N	f	\N	(0009,"FDMS 1.0",92)	combined.txt
4925	CS		\N	Blackening Process Flag	\N	K	\N	f	\N	(0009,"FDMS 1.0",f0)	combined.txt
4926	ST		\N	Processing Information Flag	\N	K	\N	f	\N	(0009,"FDMS 1.0",f1)	combined.txt
658	LO	1	\N	Full fidelity	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",01)	combined.txt
659	SH	1	\N	Suite id	\N	K	\N	f	\N	(0009,"GEMS_IDEN_01",02)	combined.txt
660	SH	1	\N	Product ID	\N	K	\N	f	\N	(0009,"GEMS_IDEN_01",04)	combined.txt
661	UN	1	\N	GEMS_IDEN_01 Undefined XX17	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",17)	combined.txt
662	UN	1	\N	GEMS_IDEN_01 Undefined XX1a	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",1a)	combined.txt
663	UN	1	\N	GEMS_IDEN_01 Undefined XX20	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",20)	combined.txt
664	SL	1	\N	Image Actual Date	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",27)	combined.txt
665	UN	1	\N	GEMS_IDEN_01 Undefined XX2f	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",2f)	combined.txt
666	SH	1	\N	Service id	\N	R	\N	f	\N	(0009,"GEMS_IDEN_01",30)	combined.txt
667	SH	1	\N	Mobile location number	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",31)	combined.txt
668	UN	1	\N	GEMS_IDEN_01 Undefined XXe2	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",e2)	combined.txt
669	UI	1	\N	Equipment UID	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",e3)	combined.txt
670	SH	1	\N	Genesis Version - now	\N	R	\N	f	\N	(0009,"GEMS_IDEN_01",e6)	combined.txt
671	UL	1	\N	Exam Record checksum	Exam Record Checksum	X	\N	f	\N	(0009,"GEMS_IDEN_01",e7)	combined.txt
673	SL	1	\N	Actual series data time stamp	\N	X	\N	f	\N	(0009,"GEMS_IDEN_01",e9)	combined.txt
3203	LO	2	\N	GE Discovery PET Implementation Version Name	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",01)	combined.txt
3204	LO	1	\N	PET patient_id	\N	X	\N	f	\N	(0009,"GEMS_PETD_01",02)	combined.txt
3205	SH	1	\N	PET compatible_version	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",03)	combined.txt
3206	SH	1	\N	PET Patient.software_version	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",04)	combined.txt
3207	DT	1	\N	PET patient_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",05)	combined.txt
3208	SL	1	\N	PET type	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",06)	combined.txt
3209	UI	1	\N	PET exam_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",07)	combined.txt
3210	SH	1	\N	PET compatible_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",08)	combined.txt
3211	SH	1	\N	PET software_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",09)	combined.txt
3212	UI	1	\N	PET scan_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0a)	combined.txt
3213	SH	1	\N	PET compatible_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0b)	combined.txt
3214	SH	1	\N	PET software_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0c)	combined.txt
3215	DT	1	\N	PET scan_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0d)	combined.txt
3216	DT	1	\N	PET scan_ready	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0e)	combined.txt
3217	ST	1	\N	PET scan_description	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",0f)	combined.txt
3218	LO	1	\N	PET hospital_name	\N	X	\N	f	\N	(0009,"GEMS_PETD_01",10)	combined.txt
3219	LO	1	\N	PET scanner_desc	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",11)	combined.txt
3220	LO	1	\N	PET manufacturer	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",12)	combined.txt
3221	UI	1	\N	PET for_identifier	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",13)	combined.txt
3222	LO	1	\N	PET landmark_name	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",14)	combined.txt
3223	SH	1	\N	PET landmark_abbrev	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",15)	combined.txt
3224	SL	1	\N	PET patient_position	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",16)	combined.txt
3225	SL	1	\N	PET scan_perspective	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",17)	combined.txt
3226	SL	1	\N	PET scan_type	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",18)	combined.txt
3227	SL	1	\N	PET scan_mode	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",19)	combined.txt
3228	SL	1	\N	PET start_condition	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1a)	combined.txt
3229	SL	1	\N	PET start_cond_data	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1b)	combined.txt
3230	SL	1	\N	PET sel_stop_cond	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1c)	combined.txt
3231	SL	1	\N	PET sel_stop_cond_data	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1d)	combined.txt
3232	SL	1	\N	PET collect_deadtime	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1e)	combined.txt
3233	SL	1	\N	PET collect_singles	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",1f)	combined.txt
3234	SL	1	\N	PET collect_countrate	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",20)	combined.txt
3235	SL	1	\N	PET countrate_period	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",21)	combined.txt
3236	SL	1	\N	PET delayed_events	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",22)	combined.txt
3237	SL	1	\N	PET delayed_bias	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",23)	combined.txt
3238	SL	1	\N	PET word_size	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",24)	combined.txt
3239	SL	1	\N	PET axial_acceptance	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",25)	combined.txt
3240	SL	1	\N	PET axial_angle_3d	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",26)	combined.txt
3241	SL	1	\N	PET theta_compression	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",27)	combined.txt
3242	SL	1	\N	PET axial_compression	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",28)	combined.txt
3243	FL	1	\N	PET gantry_tilt_angle	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",29)	combined.txt
3244	SL	1	\N	PET collimation	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2a)	combined.txt
3245	SL	1	\N	PET scan_fov	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2b)	combined.txt
3246	SL	1	\N	PET axial_fov	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2c)	combined.txt
3247	SL	1	\N	PET event_separation	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2d)	combined.txt
3248	SL	1	\N	PET mask_width	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2e)	combined.txt
3249	SL	1	\N	PET binning_mode	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",2f)	combined.txt
3250	SL	1	\N	PET trig_rej_method	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",30)	combined.txt
3251	SL	1	\N	PET number_for_reject	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",31)	combined.txt
3252	SL	1	\N	PET lower_reject_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",32)	combined.txt
3253	SL	1	\N	PET upper_reject_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",33)	combined.txt
3254	SL	1	\N	PET triggers_acquired	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",34)	combined.txt
3255	SL	1	\N	PET triggers_rejected	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",35)	combined.txt
3256	LO	1	\N	PET tracer_name	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",36)	combined.txt
3257	LO	1	\N	PET batch_description	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",37)	combined.txt
3258	FL	1	\N	PET tracer_activity	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",38)	combined.txt
3259	DT	1	\N	PET meas_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",39)	combined.txt
3260	FL	1	\N	PET pre_inj_volume	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",3a)	combined.txt
3261	DT	1	\N	PET admin_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",3b)	combined.txt
3262	FL	1	\N	PET post_inj_activity	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",3c)	combined.txt
3263	DT	1	\N	PET post_inj_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",3d)	combined.txt
3264	SH	1	\N	PET radionuclide_name	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",3e)	combined.txt
3265	FL	1	\N	PET half_life	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",3f)	combined.txt
3266	FL	1	\N	PET positron_fraction	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",40)	combined.txt
3267	SL	1	\N	PET source1_holder	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",41)	combined.txt
3268	FL	1	\N	PET source1_activity	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",42)	combined.txt
3269	DT	1	\N	PET source1_meas_dt	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",43)	combined.txt
3270	SH	1	\N	PET source1_radnuclide	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",44)	combined.txt
3271	FL	1	\N	PET source1_half_life	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",45)	combined.txt
3272	SL	1	\N	PET source2_holder	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",46)	combined.txt
3273	FL	1	\N	PET source2_activity	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",47)	combined.txt
3274	DT	1	\N	PET source2_meas_dt	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",48)	combined.txt
3275	SH	1	\N	PET source2_radnuclide	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",49)	combined.txt
3276	FL	1	\N	PET source2_half_life	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4a)	combined.txt
3277	SL	1	\N	PET source_speed	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4b)	combined.txt
3278	FL	1	\N	PET source_location	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4c)	combined.txt
3279	SL	1	\N	PET emission_present	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4d)	combined.txt
3280	SL	1	\N	PET lower_axial_acc	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4e)	combined.txt
3281	SL	1	\N	PET upper_axial_acc	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",4f)	combined.txt
3282	SL	1	\N	PET lower_coinc_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",50)	combined.txt
3283	SL	1	\N	PET upper_coinc_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",51)	combined.txt
3284	SL	1	\N	PET coinc_delay_offset	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",52)	combined.txt
3285	SL	1	\N	PET coinc_output_mode	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",53)	combined.txt
3286	SL	1	\N	PET upper_energy_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",54)	combined.txt
3287	SL	1	\N	PET lower_energy_limit	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",55)	combined.txt
3288	UI	1	\N	PET normal_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",56)	combined.txt
3289	UI	1	\N	PET normal_2d_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",57)	combined.txt
3290	UI	1	\N	PET blank_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",58)	combined.txt
3291	UI	1	\N	PET wc_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",59)	combined.txt
3292	SL	1	\N	PET derived	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",5a)	combined.txt
3293	LO	1	\N	PET contrast_agent	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",5b)	combined.txt
3294	UI	1	\N	PET frame_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",5c)	combined.txt
3295	UI	1	\N	PET scan_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",5d)	combined.txt
3296	UI	1	\N	PET exam_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",5e)	combined.txt
3297	LO	1	\N	PET patient_id	\N	X	\N	f	\N	(0009,"GEMS_PETD_01",5f)	combined.txt
3298	SH	1	\N	PET compatible_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",60)	combined.txt
3299	SH	1	\N	PET software_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",61)	combined.txt
3300	ST	1	\N	PET where_is_frame	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",62)	combined.txt
3301	SL	1	\N	PET frame_size	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",63)	combined.txt
3302	SL	1	\N	PET file_exists	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",64)	combined.txt
3303	SL	1	\N	PET patient_entry	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",65)	combined.txt
3304	FL	1	\N	PET table_height	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",66)	combined.txt
3305	FL	1	\N	PET table_z_position	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",67)	combined.txt
3306	DT	1	\N	PET landmark_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",68)	combined.txt
3307	SL	1	\N	PET slice_count	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",69)	combined.txt
3308	FL	1	\N	PET start_location	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",6a)	combined.txt
3309	SL	1	\N	PET acq_delay	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",6b)	combined.txt
3310	DT	1	\N	PET acq_start	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",6c)	combined.txt
3311	SL	1	\N	PET acq_duration	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",6d)	combined.txt
3312	SL	1	\N	PET acq_bin_dur	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",6e)	combined.txt
3313	SL	1	\N	PET acq_bin_start	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",6f)	combined.txt
3314	SL	1	\N	PET actual_stop_cond	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",70)	combined.txt
3315	FD	1	\N	PET total_prompts	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",71)	combined.txt
3316	FD	1	\N	PET total_delays	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",72)	combined.txt
3317	SL	1	\N	PET frame_valid	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",73)	combined.txt
3318	SL	1	\N	PET validity_info	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",74)	combined.txt
3319	SL	1	\N	PET archived	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",75)	combined.txt
3320	SL	1	\N	PET compression	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",76)	combined.txt
3321	SL	1	\N	PET uncompressed_size	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",77)	combined.txt
3322	SL	1	\N	PET accum_bin_dur	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",78)	combined.txt
3323	SH	1	\N	PET compatible_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",79)	combined.txt
3324	SH	1	\N	PET software_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",7a)	combined.txt
3325	DT	1	\N	PET is_datetime	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",7b)	combined.txt
3326	SL	1	\N	PET is_source	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",7c)	combined.txt
3327	SL	1	\N	PET is_contents	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",7d)	combined.txt
3328	SL	1	\N	PET is_type	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",7e)	combined.txt
3329	DS	1	\N	PET is_reference	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",7f)	combined.txt
3330	SL	1	\N	PET multi_patient	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",80)	combined.txt
3331	SL	1	\N	PET number_of_normals	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",81)	combined.txt
3332	UI	1	\N	PET color_map_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",82)	combined.txt
3333	SL	1	\N	PET window_level_type	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",83)	combined.txt
3334	FL	1	\N	PET rotate	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",84)	combined.txt
3335	SL	1	\N	PET flip	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",85)	combined.txt
3336	FL	1	\N	PET zoom	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",86)	combined.txt
3337	SL	1	\N	PET pan_x	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",87)	combined.txt
3338	SL	1	\N	PET pan_y	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",88)	combined.txt
3339	FL	1	\N	PET window_level_min	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",89)	combined.txt
3340	FL	1	\N	PET window_level_max	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8a)	combined.txt
3341	SL	1	\N	PET recon_method	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8b)	combined.txt
3342	SL	1	\N	PET attenuation	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8c)	combined.txt
3343	FL	1	\N	PET atten_coefficient	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8d)	combined.txt
3344	SL	1	\N	PET bp_filter	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8e)	combined.txt
3345	FL	1	\N	PET bp_filter_cutoff	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",8f)	combined.txt
3346	SL	1	\N	PET bp_filter_order	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",90)	combined.txt
3347	FL	1	\N	PET bp_center_l	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",91)	combined.txt
3348	FL	1	\N	PET bp_center_p	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",92)	combined.txt
3349	SL	1	\N	PET atten_smooth	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",93)	combined.txt
3350	SL	1	\N	PET atten_smooth_param	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",94)	combined.txt
3351	SL	1	\N	PET angle_smooth_param	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",95)	combined.txt
3352	UI	1	\N	PET wellcountercal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",96)	combined.txt
3353	UI	1	\N	PET trans_scan_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",97)	combined.txt
3354	UI	1	\N	PET norm_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",98)	combined.txt
3355	UI	1	\N	PET blnk_cal_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",99)	combined.txt
3356	FL	1	\N	PET cac_edge_threshold	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",9a)	combined.txt
3357	FL	1	\N	PET cac_skull_offset	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",9b)	combined.txt
3358	UI	1	\N	PET emiss_sub_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",9c)	combined.txt
3359	SL	1	\N	PET radial_filter_3d	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",9d)	combined.txt
3360	FL	1	\N	PET radial_cutoff_3d	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",9e)	combined.txt
3361	SL	1	\N	PET axial_filter_3d	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",9f)	combined.txt
3362	FL	1	\N	PET axial_cutoff_3d	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a0)	combined.txt
3363	FL	1	\N	PET axial_start	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a1)	combined.txt
3364	FL	1	\N	PET axial_spacing	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a2)	combined.txt
3365	SL	1	\N	PET axial_angles_used	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a3)	combined.txt
3366	SH	1	\N	PET compatible_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",a4)	combined.txt
3367	SH	1	\N	PET software_version	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",a5)	combined.txt
3368	SL	1	\N	PET slice_number	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a6)	combined.txt
3369	FL	1	\N	PET total_counts	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a7)	combined.txt
3370	OB	1	\N	PET other_atts	\N	X	\N	f	\N	(0009,"GEMS_PETD_01",a8)	combined.txt
3371	SL	1	\N	PET other_atts_size	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",a9)	combined.txt
3372	SL	1	\N	PET archived	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",aa)	combined.txt
3373	FL	1	\N	PET bp_center_x	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ab)	combined.txt
3374	FL	1	\N	PET bp_center_y	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ac)	combined.txt
3375	UI	1	\N	PET trans_frame_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",ad)	combined.txt
3376	UI	1	\N	PET tpluse_frame_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",ae)	combined.txt
3377	FL	1	\N	PET profile_spacing	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b1)	combined.txt
3378	SL	1	\N	PET ir_num_iterations	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b2)	combined.txt
3379	SL	1	\N	PET ir_num_subsets	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b3)	combined.txt
3380	FL	1	\N	PET ir_recon_fov	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b4)	combined.txt
3381	SL	1	\N	PET ir_corr_model	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b5)	combined.txt
3382	SL	1	\N	PET ir_loop_filter	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b6)	combined.txt
3383	FL	1	\N	PET ir_pre_filt_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b7)	combined.txt
3384	SL	1	\N	PET ir_loop_filt_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b8)	combined.txt
3385	FL	1	\N	PET response_filt_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",b9)	combined.txt
3386	SL	1	\N	PET post_filter	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ba)	combined.txt
3387	FL	1	\N	PET post_filt_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",bb)	combined.txt
3388	SL	1	\N	PET ir_regularize	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",bc)	combined.txt
3389	FL	1	\N	PET regularize_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",bd)	combined.txt
3390	SL	1	\N	PET ac_bp_filter	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",be)	combined.txt
3391	FL	1	\N	PET ac_bp_filt_cut_off	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",bf)	combined.txt
3392	SL	1	\N	PET ac_bp_filt_order	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c0)	combined.txt
3393	SL	1	\N	PET ac_img_smooth	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c1)	combined.txt
3394	FL	1	\N	PET ac_img_smooth_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c2)	combined.txt
3395	SL	1	\N	PET scatter_method	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c3)	combined.txt
3396	SL	1	\N	PET scatter_num_iter	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c4)	combined.txt
3397	FL	1	\N	PET scatter_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c5)	combined.txt
3398	FL	1	\N	PET seg_qc_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c6)	combined.txt
3399	SL	1	\N	PET overlap	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",c7)	combined.txt
3400	UI	1	\N	PET ovlp_frm_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",c8)	combined.txt
3401	UI	1	\N	PET ovlp_trans_frm_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",c9)	combined.txt
3402	UI	1	\N	PET ovlp_tpulse_frm_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",ca)	combined.txt
3403	FL	1	\N	PET vqc_x_axis_trans	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",cb)	combined.txt
3404	FL	1	\N	PET vqc_x_axis_tilt	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",cc)	combined.txt
3405	FL	1	\N	PET vqc_y_axis_trans	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",cd)	combined.txt
3406	FL	1	\N	PET vqc_y_axis_swivel	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ce)	combined.txt
3407	FL	1	\N	PET vqc_z_axis_trans	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",cf)	combined.txt
3408	FL	1	\N	PET vqc_z_axis_roll	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d0)	combined.txt
3409	LO	1	\N	PET ctac_conv_scale	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",d1)	combined.txt
3410	UI	1	\N	PET image_set_id	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",d2)	combined.txt
3411	SL	1	\N	PET constrast_route	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d3)	combined.txt
3412	LO	1	\N	PET ctac_conv_scale	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",d4)	combined.txt
3413	FL	1	\N	PET loop_filter_parm	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d5)	combined.txt
3414	FL	1	\N	PET image_one_loc	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d6)	combined.txt
3415	FL	1	\N	PET image_index_loc	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d7)	combined.txt
3416	SL	1	\N	PET frame_number	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d8)	combined.txt
3417	SL	1	\N	PET list_file_exists	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",d9)	combined.txt
3418	ST	1	\N	PET where_is_list_frame	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",da)	combined.txt
3419	SL	1	\N	PET ir_z_filter_flag	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",db)	combined.txt
3420	FL	1	\N	PET ir_z_filter_ratio	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",dc)	combined.txt
3421	US	1	\N	PET num_of_rr_interval	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",dd)	combined.txt
3422	US	1	\N	PET num_of_time_slots	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",de)	combined.txt
3423	US	1	\N	PET num_of_slices	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",df)	combined.txt
3424	US	1	\N	PET num_of_time_slices	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e0)	combined.txt
3425	SL	1	\N	PET unlisted_scan	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e1)	combined.txt
3426	SL	1	\N	PET rest_stress	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e2)	combined.txt
3427	FL	1	\N	PET phase percentage	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e3)	combined.txt
3428	ST	1	\N	Recon Protocol	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",e4)	combined.txt
3429	FL	1	\N	PET left shift	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e5)	combined.txt
3430	FL	1	\N	PET posterior shift	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e6)	combined.txt
3431	FL	1	\N	PET superior shift	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e7)	combined.txt
3432	SL	1	\N	PET acq_bin_num	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e8)	combined.txt
3433	FL	1	\N	PET acq_bin_dur_percent	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",e9)	combined.txt
3434	SL	1	\N	3D Filter flag	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ea)	combined.txt
3435	FL	1	\N	3D Filter cutoff	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",eb)	combined.txt
3436	SL	1	\N	3D Filter order	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",ec)	combined.txt
10509	UI	1	\N	Reformat group	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",f0)	combined.txt
10510	SL	1	\N	PET prompt gamma	\N	K	\N	f	\N	(0009,"GEMS_PETD_01",f1)	combined.txt
10511	UI	1	\N	PET tracerInjection_UID	\N	R	\N	f	\N	(0009,"GEMS_PETD_01",f2)	combined.txt
10512	SH	1	\N	Mobile Location Code	\N	X	\N	f	\N	(0009,"GE_YMS_NJ001",31)	combined.txt
5125	LO	1	\N	Technologist	\N	X	\N	f	\N	(0009,"MMCPrivate",01)	combined.txt
5126	LO	1	\N	ScheduledStudyDateTime	\N	X	\N	f	\N	(0009,"MMCPrivate",02)	combined.txt
5127	OB	1	\N	StudyAppData	\N	X	\N	f	\N	(0009,"MMCPrivate",03)	combined.txt
10513	UI	1	\N	ProtocolObjectID	\N	X	\N	f	\N	(0009,"MMCPrivate",04)	combined.txt
10514	LO	1	\N	Name	\N	X	\N	f	\N	(0009,"MMCPrivate",05)	combined.txt
10515	IS	1	\N	Frequency	\N	K	\N	f	\N	(0009,"MMCPrivate",06)	combined.txt
10516	SH	1	\N	UpdateFlag	\N	X	\N	f	\N	(0009,"MMCPrivate",07)	combined.txt
10517	SH	1	\N	Directory	\N	X	\N	f	\N	(0009,"MMCPrivate",08)	combined.txt
10518	LO	1	\N	Comments	\N	X	\N	f	\N	(0009,"MMCPrivate",09)	combined.txt
10519	LO	1	\N	Region	\N	K	\N	f	\N	(0009,"MMCPrivate",0a)	combined.txt
10520	SH	1	\N	Laterality	\N	K	\N	f	\N	(0009,"MMCPrivate",0b)	combined.txt
10521	TM	1	\N	TotalScanTime	\N	K	\N	f	\N	(0009,"MMCPrivate",0c)	combined.txt
10522	LO	1	\N	ContrastMedium	\N	K	\N	f	\N	(0009,"MMCPrivate",0d)	combined.txt
10523	LO	1	\N	CreateDateTime	\N	X	\N	f	\N	(0009,"MMCPrivate",0e)	combined.txt
10524	LO	1	\N	Creator	\N	X	\N	f	\N	(0009,"MMCPrivate",0f)	combined.txt
10525	LO	1	\N	SiteName	\N	X	\N	f	\N	(0009,"MMCPrivate",10)	combined.txt
10526	LO	1	\N	ReferringPhysician	\N	X	\N	f	\N	(0009,"MMCPrivate",11)	combined.txt
10527	LO	1	\N	Radiologist	\N	X	\N	f	\N	(0009,"MMCPrivate",12)	combined.txt
10528	LO	1	\N	Technologist	\N	X	\N	f	\N	(0009,"MMCPrivate",13)	combined.txt
10529	UI	1	\N	ProtocolUid	\N	X	\N	f	\N	(0009,"MMCPrivate",14)	combined.txt
10530	SH	1	\N	IsInLibrary	\N	X	\N	f	\N	(0009,"MMCPrivate",15)	combined.txt
10531	LO	1	\N	Gating	\N	K	\N	f	\N	(0009,"MMCPrivate",16)	combined.txt
10532	ST	1	\N	Note	\N	X	\N	f	\N	(0009,"MMCPrivate",17)	combined.txt
10533	IS	1	\N	NumberOfTasks	\N	X	\N	f	\N	(0009,"MMCPrivate",18)	combined.txt
10534	SH	1	\N	IsFlagRaised	\N	X	\N	f	\N	(0009,"MMCPrivate",19)	combined.txt
10535	SH	1	\N	IsArchived	\N	X	\N	f	\N	(0009,"MMCPrivate",1a)	combined.txt
10536	SH	1	\N	IsDefault	\N	X	\N	f	\N	(0009,"MMCPrivate",1b)	combined.txt
10537	OB	1	\N	ProtocolAppData	\N	X	\N	f	\N	(0009,"MMCPrivate",1c)	combined.txt
10538	SH	1	\N	IsAllowCascadeSave	\N	X	\N	f	\N	(0009,"MMCPrivate",1d)	combined.txt
10539	SH	1	\N	IsAllowCascadeProtect	\N	X	\N	f	\N	(0009,"MMCPrivate",1e)	combined.txt
10540	SQ	1	\N	TaskInfo	\N	X	\N	f	\N	(0009,"MMCPrivate",1f)	combined.txt
10541	UI	1	\N	TaskInfoObjectID	\N	X	\N	f	\N	(0009,"MMCPrivate",20)	combined.txt
10542	LO	1	\N	Name	\N	X	\N	f	\N	(0009,"MMCPrivate",21)	combined.txt
10543	SH	1	\N	TaskStatus	\N	X	\N	f	\N	(0009,"MMCPrivate",22)	combined.txt
10544	SH	1	\N	TaskPriority	\N	X	\N	f	\N	(0009,"MMCPrivate",23)	combined.txt
10545	SH	1	\N	Leaf	\N	X	\N	f	\N	(0009,"MMCPrivate",24)	combined.txt
10546	LO	1	\N	TaskID	\N	X	\N	f	\N	(0009,"MMCPrivate",25)	combined.txt
10547	IS	1	\N	Frequency	\N	K	\N	f	\N	(0009,"MMCPrivate",26)	combined.txt
10548	SH	1	\N	UpdateFlag	\N	X	\N	f	\N	(0009,"MMCPrivate",27)	combined.txt
10549	SH	1	\N	Directory	\N	X	\N	f	\N	(0009,"MMCPrivate",28)	combined.txt
10550	LO	1	\N	Comments	\N	X	\N	f	\N	(0009,"MMCPrivate",29)	combined.txt
10551	SH	1	\N	Category	\N	X	\N	f	\N	(0009,"MMCPrivate",2a)	combined.txt
10552	LO	1	\N	Region	\N	K	\N	f	\N	(0009,"MMCPrivate",2b)	combined.txt
10553	SH	1	\N	Laterality	\N	K	\N	f	\N	(0009,"MMCPrivate",2c)	combined.txt
10554	TM	1	\N	ScanTime	\N	K	\N	f	\N	(0009,"MMCPrivate",2d)	combined.txt
10555	LO	1	\N	ContrastMedium	\N	K	\N	f	\N	(0009,"MMCPrivate",2e)	combined.txt
10556	LO	1	\N	CreateDateTime	\N	X	\N	f	\N	(0009,"MMCPrivate",2f)	combined.txt
10557	LO	1	\N	Creator	\N	X	\N	f	\N	(0009,"MMCPrivate",30)	combined.txt
10558	LO	1	\N	SiteName	\N	X	\N	f	\N	(0009,"MMCPrivate",31)	combined.txt
10559	LO	1	\N	ReferringPhysician	\N	X	\N	f	\N	(0009,"MMCPrivate",32)	combined.txt
10560	LO	1	\N	Radiologist	\N	X	\N	f	\N	(0009,"MMCPrivate",33)	combined.txt
10561	LO	1	\N	Technologist	\N	X	\N	f	\N	(0009,"MMCPrivate",34)	combined.txt
10562	UI	1	\N	TaskUid	\N	X	\N	f	\N	(0009,"MMCPrivate",35)	combined.txt
10563	UI	1	\N	TaskInfoUid	\N	X	\N	f	\N	(0009,"MMCPrivate",36)	combined.txt
10564	SH	1	\N	IsInLibrary	\N	X	\N	f	\N	(0009,"MMCPrivate",37)	combined.txt
10565	IS	1	\N	TaskOrder	\N	X	\N	f	\N	(0009,"MMCPrivate",38)	combined.txt
10566	LO	1	\N	Gating	\N	K	\N	f	\N	(0009,"MMCPrivate",39)	combined.txt
10567	SH	1	\N	Plane	\N	K	\N	f	\N	(0009,"MMCPrivate",3a)	combined.txt
10568	LO	1	\N	SequenceType	\N	K	\N	f	\N	(0009,"MMCPrivate",3b)	combined.txt
10569	SH	1	\N	IsExecutive	\N	X	\N	f	\N	(0009,"MMCPrivate",3c)	combined.txt
10570	ST	1	\N	Note	\N	X	\N	f	\N	(0009,"MMCPrivate",3d)	combined.txt
10571	SH	1	\N	AutoStart	\N	X	\N	f	\N	(0009,"MMCPrivate",3e)	combined.txt
10572	SH	1	\N	AutoSave	\N	X	\N	f	\N	(0009,"MMCPrivate",3f)	combined.txt
10573	SH	1	\N	AutoArchive	\N	X	\N	f	\N	(0009,"MMCPrivate",40)	combined.txt
10574	IS	1	\N	QueueGroupID	\N	X	\N	f	\N	(0009,"MMCPrivate",41)	combined.txt
10575	SH	1	\N	IsFlagRaised	\N	X	\N	f	\N	(0009,"MMCPrivate",42)	combined.txt
10576	SH	1	\N	IsArchived	\N	X	\N	f	\N	(0009,"MMCPrivate",43)	combined.txt
10577	SH	1	\N	IsDefault	\N	X	\N	f	\N	(0009,"MMCPrivate",44)	combined.txt
10578	OB	1	\N	TaskInfoAppData	\N	X	\N	f	\N	(0009,"MMCPrivate",45)	combined.txt
10579	SH	1	\N	IsAllowCascadeSave	\N	X	\N	f	\N	(0009,"MMCPrivate",46)	combined.txt
10580	SH	1	\N	IsAllowCascadeProtect	\N	X	\N	f	\N	(0009,"MMCPrivate",47)	combined.txt
5128	LO	1	\N	ProtocolName	\N	K	\N	f	\N	(0009,"MMCPrivate",48)	combined.txt
5129	LO	1	\N	Cms_BodyPartExamined	\N	K	\N	f	\N	(0009,"MMCPrivate",4e)	combined.txt
5130	LO	1	\N	IsProtected	\N	X	\N	f	\N	(0009,"MMCPrivate",4f)	combined.txt
10581	UI	1	\N	ProtocolObjectID	\N	X	\N	f	\N	(0009,"MMCPrivate",5f)	combined.txt
10582	OB	1	\N	TaskInfoAppData	\N	X	\N	f	\N	(0009,"MMCPrivate",60)	combined.txt
10583	UI	1	\N	ProtocolTaskInfoObjectID	\N	X	\N	f	\N	(0009,"MMCPrivate",72)	combined.txt
10584	IS	1	\N	ProtocolTaskOrder	\N	X	\N	f	\N	(0009,"MMCPrivate",73)	combined.txt
10585	UI	1	\N	ProtocolTaskUid	\N	X	\N	f	\N	(0009,"MMCPrivate",74)	combined.txt
10586	OB	1	\N	ProtocolTaskAppData	\N	X	\N	f	\N	(0009,"MMCPrivate",75)	combined.txt
10587	SH	1	\N	ProtocolTaskIsAllowCascadeSave	\N	X	\N	f	\N	(0009,"MMCPrivate",76)	combined.txt
10588	SH	1	\N	ProtocolTaskIsAllowCascadeProtect	\N	X	\N	f	\N	(0009,"MMCPrivate",77)	combined.txt
798	SS	1	\N	Patient Status	\N	X	\N	f	\N	(0011,"GEMS_PATI_01",10)	combined.txt
3437	SQ	1	\N	PET ROI Sequence	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",01)	combined.txt
10589	UI	1	\N	PET ROI.roi_id	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",02)	combined.txt
10590	UI	1	\N	PET ROI.image_id	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",03)	combined.txt
10591	UI	1	\N	PET ROI.compatible_version	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",04)	combined.txt
10592	SH	1	\N	PET ROI.software_version	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",05)	combined.txt
10593	LO	1	\N	PET ROI.roi_name	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",06)	combined.txt
10594	DT	1	\N	PET ROI.roi_datetime	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",07)	combined.txt
10595	SL	1	\N	PET ROI.roi_type	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",08)	combined.txt
10596	FL	1	\N	PET ROI.center_x	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",09)	combined.txt
10597	FL	1	\N	PET ROI.center_y	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0a)	combined.txt
10598	FL	1	\N	PET ROI.width	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0b)	combined.txt
10599	FL	1	\N	PET ROI.height	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0c)	combined.txt
10600	FL	1	\N	PET ROI.angle	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0d)	combined.txt
10601	SL	1	\N	PET ROI.number_of_points	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0e)	combined.txt
10602	OB	1	\N	PET ROI.roi_data	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",0f)	combined.txt
10603	SL	1	\N	PET ROI.roi_size	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",10)	combined.txt
10604	LO	1	\N	PET ROI.color	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",11)	combined.txt
10605	SL	1	\N	PET ROI.line_type	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",12)	combined.txt
10606	SL	1	\N	PET ROI.line_width	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",13)	combined.txt
10607	SL	1	\N	PET ROI.roi_number	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",14)	combined.txt
10608	SL	1	\N	PET ROI.convex	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",15)	combined.txt
10609	SL	1	\N	PET ROI.atten_cor_flag	\N	X	\N	f	\N	(0011,"GEMS_PETD_01",16)	combined.txt
5146	LO	1	\N	IsRapidRegistration	\N	X	\N	f	\N	(0011,"MMCPrivate",01)	combined.txt
5147	LO	1	\N	IsProtected	\N	X	\N	f	\N	(0011,"MMCPrivate",02)	combined.txt
5856	UN	1	\N	Project Name	\N	K	\N	f	\N	(0013,"CTP",10)	combined.txt
5857	UN	1	\N	Trial Name	\N	K	\N	f	\N	(0013,"CTP",11)	combined.txt
5858	UN	1	\N	Site Name	\N	K	\N	f	\N	(0013,"CTP",12)	combined.txt
5859	UN	1	\N	Site ID	\N	K	\N	f	\N	(0013,"CTP",13)	combined.txt
10610	UN	1	\N	Visibility	\N	K	\N	f	\N	(0013,"CTP",14)	combined.txt
3439	SQ	1	\N	PET Annotation Sequence	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",01)	combined.txt
10611	UI	1	\N	PET Annotation.annotation_id	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",02)	combined.txt
10612	UI	1	\N	PET Annotation.image_id	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",03)	combined.txt
10613	SH	1	\N	PET Annotation.compatible_version	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",04)	combined.txt
10614	SH	1	\N	PET Annotation.software_version	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",05)	combined.txt
10615	SL	1	\N	PET Annotation.type	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",06)	combined.txt
10616	LO	1	\N	PET Annotation.font_name	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",07)	combined.txt
10617	SH	1	\N	PET Annotation.font_size	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",08)	combined.txt
10618	LO	1	\N	PET Annotation.foreground_color	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",09)	combined.txt
10619	LO	1	\N	PET Annotation.background_color	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0a)	combined.txt
10620	SL	1	\N	PET Annotation.coordinate_system	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0b)	combined.txt
10621	FL	1	\N	PET Annotation.start_x	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0c)	combined.txt
10622	FL	1	\N	PET Annotation.start_y	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0d)	combined.txt
10623	FL	1	\N	PET Annotation.end_x	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0e)	combined.txt
10624	FL	1	\N	PET Annotation.end_y	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",0f)	combined.txt
10625	SL	1	\N	PET Annotation.start_symbol	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",10)	combined.txt
10626	SL	1	\N	PET Annotation.end_symbol	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",11)	combined.txt
10627	OB	1	\N	PET Annotation.annotation_data	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",12)	combined.txt
10628	SL	1	\N	PET Annotation.annotation.size	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",13)	combined.txt
10629	LO	1	\N	PET Annotation.label_id	\N	X	\N	f	\N	(0013,"GEMS_PETD_01",14)	combined.txt
10630	US	1	\N	Physio Gating Type	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1a)	combined.txt
10631	US	1	\N	Total Number of Bins	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1b)	combined.txt
10632	US	1	\N	% Phase Value	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1c)	combined.txt
10633	SL	1	\N	Phase Matched Series	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1d)	combined.txt
10634	SL	1	\N	CTAC Percent Value	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1e)	combined.txt
10635	UL	1	\N	PET Recon Parameters Exists	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",1f)	combined.txt
10636	SL	1	\N	First Packet Number	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",20)	combined.txt
10637	FL	1	\N	IR Loop Filter Ratio	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",21)	combined.txt
10638	FL	1	\N	IR Loop Filter Correction	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",22)	combined.txt
10639	UL	1	\N	BP3d Filter FlagU	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",23)	combined.txt
10640	FL	1	\N	BP3d Filter CutoffU	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",24)	combined.txt
10641	SL	1	\N	BP3d Filter OrderU	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",25)	combined.txt
10642	UL	1	\N	BP3d Filter FlagV	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",26)	combined.txt
10643	FL	1	\N	BP3d Filter OrderV	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",27)	combined.txt
10644	SL	1	\N	BP3d Filter CutoffV	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",28)	combined.txt
10645	UL	1	\N	Decay Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",29)	combined.txt
10646	UL	1	\N	Image filter 3d flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",2e)	combined.txt
10647	UL	1	\N	WCC Cal Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",2f)	combined.txt
10648	UL	1	\N	Emission Scatter Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",30)	combined.txt
10649	UL	1	\N	Recon Algorithm	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",31)	combined.txt
10650	UL	1	\N	Normalization Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",32)	combined.txt
10651	UL	1	\N	Emission Deadtime Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",33)	combined.txt
10652	UL	1	\N	Emission Random Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",34)	combined.txt
10653	UL	1	\N	Blank Scan Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",35)	combined.txt
10654	SL	1	\N	Event histogram Format	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",39)	combined.txt
10655	SL	1	\N	Number of Detector Rows	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",3a)	combined.txt
10656	SL	1	\N	Number of Detector Columns	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",3b)	combined.txt
10657	US	1	\N	Recon Matrix Size	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",3c)	combined.txt
10658	UL	1	\N	PET Sharp IR Flag	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",3d)	combined.txt
10659	UL	1	\N	PET Scatter Limit	\N	K	\N	f	\N	(0015,"GEMS_PETD_01",3e)	combined.txt
3440	UI	1	\N	PET correction_cal_id	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",01)	combined.txt
3441	SH	1	\N	PET compatible_version	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",02)	combined.txt
3442	SH	1	\N	PET software_version	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",03)	combined.txt
3443	DT	1	\N	PET cal_datetime	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",04)	combined.txt
3444	LO	1	\N	PET cal_description	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",05)	combined.txt
3445	SL	1	\N	PET cal_type	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",06)	combined.txt
3446	ST	1	\N	PET where_is_corr	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",07)	combined.txt
3447	SL	1	\N	PET corr_file_size	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",08)	combined.txt
3448	LO	1	\N	PET scan_id	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",09)	combined.txt
3449	DT	1	\N	PET scan_datetime	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",0a)	combined.txt
3450	LO	1	\N	PET norm_2d_cal_id	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",0b)	combined.txt
3451	SH	1	\N	PET hosp_identifier	\N	R	\N	f	\N	(0017,"GEMS_PETD_01",0c)	combined.txt
3452	SL	1	\N	PET archived	\N	K	\N	f	\N	(0017,"GEMS_PETD_01",0d)	combined.txt
4958	IS	1	\N	ADAC Pegasys File Size	\N	X	\N	f	\N	(0019,"ADAC_IMG",02)	combined.txt
4959	US	1	\N	Number of ADAC Headers	\N	X	\N	f	\N	(0019,"ADAC_IMG",21)	combined.txt
4960	IS	1-n	\N	ADAC Header/Image Size	\N	X	\N	f	\N	(0019,"ADAC_IMG",41)	combined.txt
4961	OB	1	\N	ADAC Pegasys Headers	\N	X	\N	f	\N	(0019,"ADAC_IMG",61)	combined.txt
171	LO		\N	Kanji Body Part for Exposure	\N	X	\N	f	\N	(0019,"FDMS 1.0",15)	combined.txt
172	LO		\N	Kanji Menu Name	\N	X	\N	f	\N	(0019,"FDMS 1.0",32)	combined.txt
173	CS		\N	Image Processing Type	\N	KB	\N	f	\N	(0019,"FDMS 1.0",40)	combined.txt
174	CS		\N	EDR Mode	\N	K	\N	f	\N	(0019,"FDMS 1.0",50)	combined.txt
175	SH		\N	Radiographers Code	\N	X	\N	f	\N	(0019,"FDMS 1.0",60)	combined.txt
176	IS		\N	Split Exposure Format	\N	K	\N	f	\N	(0019,"FDMS 1.0",70)	combined.txt
177	IS		\N	No. of Split Exposure Frames	\N	K	\N	f	\N	(0019,"FDMS 1.0",71)	combined.txt
178	IS		\N	Reading Position Specification	\N	K	\N	f	\N	(0019,"FDMS 1.0",80)	combined.txt
179	IS		\N	Reading Sensitivity Center	\N	K	\N	f	\N	(0019,"FDMS 1.0",81)	combined.txt
275	SL	1	\N	Number of cells I in Detector	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",02)	combined.txt
276	DS	1	\N	Cell number at Theta	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",03)	combined.txt
277	DS	1	\N	Cell spacing	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",04)	combined.txt
281	DS	1	\N	Horiz. Frame of ref.	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",0f)	combined.txt
282	SS	1	\N	Series Contrast	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",11)	combined.txt
283	SS	1	\N	Last pseq	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",12)	combined.txt
284	SS	1	\N	Start number for baseline	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",13)	combined.txt
285	SS	1	\N	End number for baseline	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",14)	combined.txt
286	SS	1	\N	Start number for enhanced scans	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",15)	combined.txt
287	SS	1	\N	End number for enhanced scans	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",16)	combined.txt
288	SS	1	\N	Series plane	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",17)	combined.txt
289	LO	1	\N	First scan ras	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",18)	combined.txt
290	DS	1	\N	First scan location	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",19)	combined.txt
291	LO	1	\N	Last scan ras	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",1a)	combined.txt
292	DS	1	\N	Last scan loc	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",1b)	combined.txt
293	DS	1	3	Display field of view	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",1e)	combined.txt
296	DS	1	\N	Table speed [mm/rotation]	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",23)	combined.txt
297	DS	1	\N	Mid scan time	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",24)	combined.txt
298	SS	1	\N	Mid scan flag	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",25)	combined.txt
299	SL	1	\N	Degrees of azimuth / Tube Azimuth [degree]	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",26)	combined.txt
300	DS	1	\N	Gantry period / Rotation Speed [msec]	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",27)	combined.txt
301	DS	1	\N	x-ray On position	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",2a)	combined.txt
302	DS	1	\N	x-ray Off position	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",2b)	combined.txt
303	SL	1	\N	Number of triggers	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",2c)	combined.txt
305	DS	1	\N	Angle of first view	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",2e)	combined.txt
306	DS	1	\N	Trigger frequency	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",2f)	combined.txt
307	SS	1	\N	Scan FOV type	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",39)	combined.txt
313	SS	1	\N	Stat recon flag	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",40)	combined.txt
314	SS	1	\N	Compute type	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",41)	combined.txt
315	SS	1	\N	Segment number	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",42)	combined.txt
316	SS	1	\N	Total segments requested	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",43)	combined.txt
317	DS	1	\N	Interscan delay	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",44)	combined.txt
318	SS	1	\N	View compression factor	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",47)	combined.txt
321	SS	1	\N	Total no. of ref channels	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",4a)	combined.txt
322	SL	1	\N	Data size for scan data	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",4b)	combined.txt
323	SS	1	\N	Recon post proc. Flag	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",52)	combined.txt
325	SS	1	\N	CT water number	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",57)	combined.txt
326	SS	1	\N	CT bone number	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",58)	combined.txt
327	FL	1	\N	Acquisition Duration	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",5a)	combined.txt
329	SL	1	\N	Number of channels (1512)	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",5e)	combined.txt
330	SL	1	\N	Increment between channels	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",5f)	combined.txt
331	SL	1	\N	Starting view	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",60)	combined.txt
332	SL	1	\N	Number of views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",61)	combined.txt
333	SL	1	\N	Increment between views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",62)	combined.txt
334	SS	1	\N	Dependent on #views processed	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",6a)	combined.txt
335	SS	1	\N	Field of view in detector cells	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",6b)	combined.txt
336	SS	1	\N	Value of back projection button	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",70)	combined.txt
337	SS	1	\N	Set if fatq estimates were used	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",71)	combined.txt
338	DS	1	\N	Z chan avg over views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",72)	combined.txt
339	DS	1	\N	Avg of left ref chans over views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",73)	combined.txt
340	DS	1	\N	Max left chan over views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",74)	combined.txt
341	DS	1	\N	Avg of right ref chans over views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",75)	combined.txt
342	DS	1	\N	Max right chan over views	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",76)	combined.txt
343	DS	1	\N	Second echo	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",7d)	combined.txt
344	SS	1	\N	Number of echoes	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",7e)	combined.txt
345	DS	1	\N	Table delta	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",7f)	combined.txt
346	SS	1	\N	Contiguous	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",81)	combined.txt
349	DS	1	\N	Peak SAR	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",84)	combined.txt
350	DS	1	\N	Monitor SAR	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",85)	combined.txt
352	DS	1	\N	Cardiac repetition time	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",87)	combined.txt
353	SS	1	\N	Images per cardiac cycle	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",88)	combined.txt
354	SS	1	\N	Actual receive gain analog	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",8a)	combined.txt
355	SS	1	\N	Actual receive gain digital	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",8b)	combined.txt
356	DS	1	\N	Delay after trigger	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",8d)	combined.txt
357	SS	1	\N	Swappf	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",8f)	combined.txt
358	SS	1	\N	Pause Interval	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",90)	combined.txt
359	DS	1	\N	Pause Time	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",91)	combined.txt
360	SL	1	\N	Slice offset on freq axis	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",92)	combined.txt
361	DS	1	\N	Auto Prescan Center Frequency	Center Frequency	K	\N	f	\N	(0019,"GEMS_ACQU_01",93)	combined.txt
362	SS	1	\N	Auto Prescan Transmit Gain	Transmit Gain	K	\N	f	\N	(0019,"GEMS_ACQU_01",94)	combined.txt
363	SS	1	\N	Analog receiver gain	Auto Prescan Analog receiver gain	K	\N	f	\N	(0019,"GEMS_ACQU_01",95)	combined.txt
364	SS	1	\N	Digital receiver gain	Auto Prescan Digital receiver gain	K	\N	f	\N	(0019,"GEMS_ACQU_01",96)	combined.txt
365	SL	1	\N	Bitmap defining CVs	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",97)	combined.txt
366	SS	1	\N	Center freq. Method	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",98)	combined.txt
368	SS	1	\N	Pulse Sequence Mode	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",9b)	combined.txt
369	LO	1	\N	Pulse Sequence Name	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",9c)	combined.txt
370	DT	1	\N	Pulse Sequence Date	\N	Z	\N	f	\N	(0019,"GEMS_ACQU_01",9d)	combined.txt
371	LO	1	\N	Internal Pulse Sequence Name	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",9e)	combined.txt
372	SS	1	\N	Transmitting Coil Type	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",9f)	combined.txt
373	SS	1	\N	Surface Coil Type	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a0)	combined.txt
374	SS	1	\N	Extremity Coil flag	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a1)	combined.txt
375	SL	1	\N	Raw data run number	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a2)	combined.txt
376	UL	1	\N	Calibrated Field Strength	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a3)	combined.txt
377	SS	1	\N	SAT fat/water/bone	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a4)	combined.txt
378	DS	1	\N	Receive bandwith	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",a5)	combined.txt
379	DS	1	\N	User data 0	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",a7)	combined.txt
380	DS	1	\N	User data 1	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",a8)	combined.txt
381	DS	1	\N	User data 2	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",a9)	combined.txt
382	DS	1	\N	User data 3	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",aa)	combined.txt
383	DS	1	\N	User data 4	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",ab)	combined.txt
384	DS	1	\N	User data 5	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",ac)	combined.txt
385	DS	1	\N	user data 6	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",ad)	combined.txt
386	DS	1	\N	User data 7	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",ae)	combined.txt
387	DS	1	\N	User data 8	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",af)	combined.txt
388	DS	1	\N	User data 9	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b0)	combined.txt
389	DS	1	\N	User data 10	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b1)	combined.txt
390	DS	1	\N	User data 11	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b2)	combined.txt
391	DS	1	\N	User data 12	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b3)	combined.txt
392	DS	1	\N	User data 13	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b4)	combined.txt
393	DS	1	\N	User data 14	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b5)	combined.txt
394	DS	1	\N	User data 15	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b6)	combined.txt
395	DS	1	\N	User data 16	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b7)	combined.txt
396	DS	1	\N	User data 17	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b8)	combined.txt
397	DS	1	\N	User data 18	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",b9)	combined.txt
398	DS	1	\N	User data 19	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",ba)	combined.txt
399	DS	1	\N	User data 20	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",bb)	combined.txt
400	DS	1	\N	User data 21	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",bc)	combined.txt
401	DS	1	\N	User data 22	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",bd)	combined.txt
402	DS	1	\N	Projection angle	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",be)	combined.txt
403	SS	1	\N	Saturation planes	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c0)	combined.txt
404	SS	1	\N	Surface coil intensity	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c1)	combined.txt
405	SS	1	\N	SAT location R	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c2)	combined.txt
406	SS	1	\N	SAT location L	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c3)	combined.txt
407	SS	1	\N	SAT location A	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c4)	combined.txt
408	SS	1	\N	SAT location P	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c5)	combined.txt
409	SS	1	\N	SAT location H	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c6)	combined.txt
410	SS	1	\N	SAT location F	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c7)	combined.txt
411	SS	1	\N	SAT thickness R/L	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c8)	combined.txt
412	SS	1	\N	SAT thickness A/P	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",c9)	combined.txt
413	SS	1	\N	SAT thickness H/F	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",ca)	combined.txt
414	SS	1	\N	Phase Contrast flow axis	Prescribed flow axis	K	\N	f	\N	(0019,"GEMS_ACQU_01",cb)	combined.txt
415	SS	1	\N	Velocity encoding	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",cc)	combined.txt
416	SS	1	\N	Thickness disclaimer	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",cd)	combined.txt
417	SS	1	\N	Prescan type	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",ce)	combined.txt
418	SS	1	\N	Prescan status	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",cf)	combined.txt
419	SH	1	\N	Raw data type	\N	R	\N	f	\N	(0019,"GEMS_ACQU_01",d0)	combined.txt
420	SS	1	\N	Projection Algorithm	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",d2)	combined.txt
421	SH	1	\N	Projection Algorithm	Projection Algorithm Name	K	\N	f	\N	(0019,"GEMS_ACQU_01",d3)	combined.txt
423	SS	1	\N	Fractional echo	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",d5)	combined.txt
424	SS	1	\N	Prep pulse	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",d6)	combined.txt
425	SS	1	\N	Cardiac phase number	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",d7)	combined.txt
426	SS	1	\N	Variable echoflag	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",d8)	combined.txt
427	DS	1	\N	Concatenated SAT	"Concatenated SAT {# DTI Diffusion Dir., release 9.0 & below"	R	\N	f	\N	(0019,"GEMS_ACQU_01",d9)	combined.txt
428	SS	1	\N	Reference channel used	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",da)	combined.txt
429	DS	1	\N	Back projector coefficient	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",db)	combined.txt
430	SS	1	\N	Primary speed correction used	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",dc)	combined.txt
431	SS	1	\N	Overrange correction used	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",dd)	combined.txt
432	DS	1	\N	Dynamic Z alpha value	\N	KB	\N	f	\N	(0019,"GEMS_ACQU_01",de)	combined.txt
433	DS	1	\N	User data 23	"User data 23 {# DTI Diffusion Dir., release 9.0 & below}"	R	\N	f	\N	(0019,"GEMS_ACQU_01",df)	combined.txt
434	DS	1	\N	User data 24	"User data 24 {# DTI Diffusion Dir., release 10.0 & above}"	R	\N	f	\N	(0019,"GEMS_ACQU_01",e0)	combined.txt
436	DS	1	\N	Velocity Encocde Scale	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",e2)	combined.txt
447	SS	1	\N	Fast phases	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",f2)	combined.txt
450	DS	1	\N	Transmit gain	\N	K	\N	f	\N	(0019,"GEMS_ACQU_01",f9)	combined.txt
3453	UI	1	\N	PET wc_cal_id	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",01)	combined.txt
3454	SH	1	\N	PET compatible_version	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",02)	combined.txt
3455	SH	1	\N	PET software_version	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",03)	combined.txt
3456	DT	1	\N	PET cal_datetime	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",04)	combined.txt
3457	SL	1	\N	PET cal_type	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",05)	combined.txt
3458	LO	1	\N	PET cal_description	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",06)	combined.txt
3459	LO	1	\N	PET cal_hardware	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",07)	combined.txt
3460	OB	1	\N	PET coefficients	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",08)	combined.txt
3461	FL	1	\N	PET activity_factor_hr	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",09)	combined.txt
3462	FL	1	\N	PET activity_factor_hs	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",0a)	combined.txt
3463	FL	1	\N	PET activity_factor_3d	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",0b)	combined.txt
3464	LO	1	\N	PET scan_id	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",0c)	combined.txt
3465	DT	1	\N	PET scan_datetime	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",0d)	combined.txt
3466	SH	1	\N	PET hosp_identifier	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",0e)	combined.txt
3467	FL	1	\N	PET meas_activity	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",0f)	combined.txt
3468	DT	1	\N	PET meas_datetime	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",10)	combined.txt
3469	SL	1	\N	PET axial_filter_3d	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",11)	combined.txt
3470	FL	1	\N	PET axial_cutoff_3d	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",12)	combined.txt
3471	SL	1	\N	PET default_flag	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",13)	combined.txt
3472	SL	1	\N	PET archived	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",14)	combined.txt
3473	SL	1	\N	PET wc_cal_rec_method	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",15)	combined.txt
3474	FL	1	\N	PET activity_factor_2d	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",16)	combined.txt
3475	SL	1	\N	PET isotope	\N	K	\N	f	\N	(0019,"GEMS_PETD_01",17)	combined.txt
10660	UI	1	\N	WCC Image Set ID	\N	R	\N	f	\N	(0019,"GEMS_PETD_01",18)	combined.txt
10661	SL	1	\N	Detector Channel	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",02)	combined.txt
10662	DS	1	\N	Table speed	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",23)	combined.txt
10663	DS	1	\N	Mid scan time	\N	R	\N	f	\N	(0019,"GE_YMS_NJ001",24)	combined.txt
10664	SL	1	\N	Tube Azimuth	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",26)	combined.txt
10665	DS	1	\N	Gantry Velocity	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",27)	combined.txt
10666	SS	1	\N	SFOV type	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",39)	combined.txt
10667	SS	1	\N	Segment number	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",42)	combined.txt
10668	SS	1	\N	Total segments required	\N	KB	\N	f	\N	(0019,"GE_YMS_NJ001",43)	combined.txt
5153	LO	1	\N	ProcType	\N	K	\N	f	\N	(0019,"MMCPrivate",01)	combined.txt
5154	LO	1	\N	Plane	\N	K	\N	f	\N	(0019,"MMCPrivate",02)	combined.txt
5155	SH	1	\N	IsSnapShotSeries	\N	K	\N	f	\N	(0019,"MMCPrivate",03)	combined.txt
5156	DS	1	\N	MaxFsColor	\N	K	\N	f	\N	(0019,"MMCPrivate",04)	combined.txt
5157	LO	1	\N	SeriesCategoryType	\N	K	\N	f	\N	(0019,"MMCPrivate",05)	combined.txt
5158	LO	1	\N	ImageContrastBolusAgent	\N	K	\N	f	\N	(0019,"MMCPrivate",07)	combined.txt
5159	LO	1	\N	ImageSliceThickness	\N	K	\N	f	\N	(0019,"MMCPrivate",08)	combined.txt
5160	LO	1	\N	ImageReconstructionDiameter	\N	K	\N	f	\N	(0019,"MMCPrivate",09)	combined.txt
5161	LO	1	\N	ImageEchoTime	\N	K	\N	f	\N	(0019,"MMCPrivate",0a)	combined.txt
5162	LO	1	\N	ImageRepetitionTime	\N	K	\N	f	\N	(0019,"MMCPrivate",0b)	combined.txt
5163	LO	1	\N	SequenceType	\N	K	\N	f	\N	(0019,"MMCPrivate",0c)	combined.txt
5164	LO	1	\N	TaskUid	\N	X	\N	f	\N	(0019,"MMCPrivate",0d)	combined.txt
5165	OB	1	\N	SeriesAppData	\N	X	\N	f	\N	(0019,"MMCPrivate",0e)	combined.txt
5166	IS	1	\N	MultiSliceNumber	\N	K	\N	f	\N	(0019,"MMCPrivate",0f)	combined.txt
5167	LO	1	\N	ImageScanTime	\N	K	\N	f	\N	(0019,"MMCPrivate",10)	combined.txt
5168	LO	1	\N	IsProtected	\N	K	\N	f	\N	(0019,"MMCPrivate",11)	combined.txt
10669	UI	1	\N	MultiFrameSopInstanceUid	\N	R	\N	f	\N	(0019,"MMCPrivate",20)	combined.txt
1404	DS	1	\N	Osteo offset	\N	R	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",90)	combined.txt
1405	DS	1	\N	Osteo Regression Line Slope	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",92)	combined.txt
1406	DS	1	\N	Osteo Regression Line Intercept	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",93)	combined.txt
1408	IS	1	\N	Osteo Phantom Number	\N	R	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",96)	combined.txt
8295	DS	1	\N	Feed per Rotation	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",b0)	combined.txt
8296	IS	1	\N	Pulmo Trigger Level	\N	R	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",bd)	combined.txt
8297	DS	1	\N	Expiratoric Reserve Volume	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",be)	combined.txt
8298	DS	1	\N	Vital Capacity	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",bf)	combined.txt
8299	DS	1	\N	Pulmo Water	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",c0)	combined.txt
8300	DS	1	\N	Pulmo Air	\N	K	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",c1)	combined.txt
8301	DA	1	\N	Pulmo Date	\N	R	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",c2)	combined.txt
8302	TM	1	\N	Pulmo Time	\N	R	\N	f	\N	(0019,"SIEMENS CT VA0  COAD",c3)	combined.txt
10670	SL	1-n	\N	Siemens ICON Data Type	\N	K	\N	f	\N	(0019,"Siemens MED NM",0f)	combined.txt
10671	SS	1-n	\N	Number of repeats per phase	\N	K	\N	f	\N	(0019,"Siemens MED NM",a5)	combined.txt
10672	SS	1-n	\N	Cycles per repeat	\N	K	\N	f	\N	(0019,"Siemens MED NM",a6)	combined.txt
10673	SL	1-n	\N	Repeat start time	\N	K	\N	f	\N	(0019,"Siemens MED NM",a7)	combined.txt
10674	SL	1-n	\N	Repeat stop time	\N	K	\N	f	\N	(0019,"Siemens MED NM",a8)	combined.txt
10675	SL	1-n	\N	Effective repeat time	\N	K	\N	f	\N	(0019,"Siemens MED NM",a9)	combined.txt
10676	SS	1-n	\N	Acquired cycles per repeat	\N	K	\N	f	\N	(0019,"Siemens MED NM",aa)	combined.txt
182	CS		\N	FCR Image ID	\N	X	\N	f	\N	(0021,"FDMS 1.0",10)	combined.txt
183	CS		\N	Set No.	\N	X	\N	f	\N	(0021,"FDMS 1.0",30)	combined.txt
184	IS		\N	Image No. In the Set	\N	X	\N	f	\N	(0021,"FDMS 1.0",40)	combined.txt
185	CS		\N	Pair Processing Information	\N	K	\N	f	\N	(0021,"FDMS 1.0",50)	combined.txt
186	OB		\N	Equipment Type-Specific Information	\N	X	\N	f	\N	(0021,"FDMS 1.0",80)	combined.txt
3476	US	1	\N	PET raw_data_type	\N	K	\N	f	\N	(0021,"GEMS_PETD_01",01)	combined.txt
3477	UL	1	\N	PET raw_data_size	\N	K	\N	f	\N	(0021,"GEMS_PETD_01",02)	combined.txt
799	SS	1	\N	Series from which Prescribed	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",03)	combined.txt
800	SH	1	\N	Genesis Version - now	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",05)	combined.txt
801	UL	1	\N	Series Record checksum	\N	X	\N	f	\N	(0021,"GEMS_RELA_01",07)	combined.txt
804	SH	1	\N	Genesis version - Now	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",18)	combined.txt
3948	LO	1	\N	Recon filter	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",64)	combined.txt
805	UL	1	\N	Acqrecon record checksum	Acq recon record checksum	X	\N	f	\N	(0021,"GEMS_RELA_01",19)	combined.txt
806	DS	1	\N	Table start location	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",20)	combined.txt
807	SS	1	\N	Series Prescribed From	Series from which prescribed	R	\N	f	\N	(0021,"GEMS_RELA_01",35)	combined.txt
808	SS	1	\N	Image from which prescribed	Image Prescribed From	R	\N	f	\N	(0021,"GEMS_RELA_01",36)	combined.txt
809	SS	1	\N	Screen Format	\N	KB	\N	f	\N	(0021,"GEMS_RELA_01",37)	combined.txt
810	LO	1	\N	Anatomical reference for scout	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",4a)	combined.txt
812	SS	1	\N	Locations in acquisition	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",4f)	combined.txt
813	SS	1	\N	Graphically prescribed	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",50)	combined.txt
814	DS	1	\N	Rotation from source x rot	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",51)	combined.txt
815	DS	1	\N	Rotation from source y rot	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",52)	combined.txt
816	DS	1	\N	Rotation from source z rot	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",53)	combined.txt
817	SH	3	\N	Image position	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",54)	combined.txt
818	SH	6	\N	Image orientation	\N	R	\N	f	\N	(0021,"GEMS_RELA_01",55)	combined.txt
819	SL	1	\N	Num 3D slabs	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",56)	combined.txt
820	SL	1	\N	Locs per 3D slab	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",57)	combined.txt
821	SL	1	\N	Overlaps	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",58)	combined.txt
822	SL	1	\N	Image Filtering 0.5/0.2T	Image Filtering	K	\N	f	\N	(0021,"GEMS_RELA_01",59)	combined.txt
823	SL	1	\N	Diffusion direction	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",5a)	combined.txt
824	DS	1	\N	Ihtagfa	Tagging Flip Angle	K	\N	f	\N	(0021,"GEMS_RELA_01",5b)	combined.txt
825	DS	1	\N	Ihtagor	Tagging Orientation	K	\N	f	\N	(0021,"GEMS_RELA_01",5c)	combined.txt
826	DS	1	\N	Tag Spacing	Ihbspti	K	\N	f	\N	(0021,"GEMS_RELA_01",5d)	combined.txt
827	DS	1	\N	RTIA_timer	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",5e)	combined.txt
828	DS	1	\N	Fps	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",5f)	combined.txt
831	DS	1	\N	Auto window/level alpha	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",81)	combined.txt
832	DS	1	\N	Auto window/level beta	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",82)	combined.txt
833	DS	1	\N	Auto window/level window	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",83)	combined.txt
834	DS	1	\N	Auto window/level level	\N	K	\N	f	\N	(0021,"GEMS_RELA_01",84)	combined.txt
835	SS	1	\N	Tube focal spot position	\N	KB	\N	f	\N	(0021,"GEMS_RELA_01",90)	combined.txt
836	SS	1	\N	Biopsy position	\N	KB	\N	f	\N	(0021,"GEMS_RELA_01",91)	combined.txt
837	FL	1	\N	Biopsy T location	\N	KB	\N	f	\N	(0021,"GEMS_RELA_01",92)	combined.txt
838	FL	1	\N	Biopsy ref location	\N	KB	\N	f	\N	(0021,"GEMS_RELA_01",93)	combined.txt
1626	DS	2	\N	Target: Center x/y as entered for reconstruction	\N	K	\N	f	\N	(0021,"SIEMENS MED",11)	combined.txt
10677	OB	1	\N	ECAT File Menu Header	\N	X	\N	f	\N	(0021,"Siemens MED NM",00)	combined.txt
10678	OB	1	\N	ECAT File Subheader	\N	X	\N	f	\N	(0021,"Siemens MED NM",01)	combined.txt
10679	0B	1	\N	PET raw_data_blob	\N	R	\N	f	\N	(0023,"GEMS_PETD_01",02)	combined.txt
883	SL	1	\N	Number of series in Study	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",01)	combined.txt
884	SL	1	\N	Number of unarchived Series	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",02)	combined.txt
885	SS	1	\N	Reference image field	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",10)	combined.txt
886	SS	1	\N	Summary image	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",50)	combined.txt
887	FD	1	\N	Start time(secs) in first axial	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",70)	combined.txt
888	SL	1	\N	No. of updates to header	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",74)	combined.txt
889	SS	1	\N	Indicates study has complete info (DICOM/genesis)	Indicates if the study has complete info (DICOM/genesis)	X	\N	f	\N	(0023,"GEMS_STDY_01",7d)	combined.txt
3825	SQ	1	\N	Has MPPS related tags	\N	X	\N	f	\N	(0023,"GEMS_STDY_01",80)	combined.txt
10680	US	1	\N	DICOM Reader Flag	\N	X	\N	f	\N	(0023,"Siemens MED NM",01)	combined.txt
190	US		\N	Relative Light Emission Amount Sk	\N	K	\N	f	\N	(0025,"FDMS 1.0",10)	combined.txt
191	US		\N	Term of Correction for Each IP Type St	\N	K	\N	f	\N	(0025,"FDMS 1.0",11)	combined.txt
192	US		\N	Reading Gain Gp	\N	K	\N	f	\N	(0025,"FDMS 1.0",12)	combined.txt
874	SS	1	\N	Last pulse sequence used	\N	KB	\N	f	\N	(0025,"GEMS_SERS_01",06)	combined.txt
875	SL	1	\N	Images in Series	\N	KB	\N	f	\N	(0025,"GEMS_SERS_01",07)	combined.txt
876	SL	1	\N	Landmark Counter	\N	KB	\N	f	\N	(0025,"GEMS_SERS_01",10)	combined.txt
877	SS	1	\N	Number of Acquisitions	\N	KB	\N	f	\N	(0025,"GEMS_SERS_01",11)	combined.txt
878	SL	1	\N	Indicates no. of updates to header	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",14)	combined.txt
879	SL	1	\N	Series Complete Flag	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",17)	combined.txt
880	SL	1	\N	Number of images archived	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",18)	combined.txt
881	SL	1	\N	Last image number used	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",19)	combined.txt
882	SH	1	\N	Primary Receiver Suite and Host	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",1a)	combined.txt
3863	OB	1	\N	Protocol Data Block (compressed)	\N	X	\N	f	\N	(0025,"GEMS_SERS_01",1b)	combined.txt
674	SL	1	\N	Image archive flag	\N	X	\N	f	\N	(0027,"GEMS_IMAG_01",06)	combined.txt
675	SS	1	\N	Scout Type	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",10)	combined.txt
676	SL	1	\N	Vma mamp	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",1c)	combined.txt
677	SS	1	\N	Vma phase	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",1d)	combined.txt
678	SL	1	\N	Vma mod	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",1e)	combined.txt
679	SL	1	\N	GE Noise Index * 10	Vma clip	KB	\N	f	\N	(0027,"GEMS_IMAG_01",1f)	combined.txt
680	SS	1	\N	Smart scan  ON/OFF flag	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",20)	combined.txt
681	SH	1	\N	Foreign Image Revision	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",30)	combined.txt
682	SS	1	\N	Imaging Mode	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",31)	combined.txt
683	SS	1	\N	Pulse Sequence	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",32)	combined.txt
684	SL	1	\N	Imaging Options	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",33)	combined.txt
685	SS	1	\N	Plane Type	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",35)	combined.txt
686	SL	1	\N	Oblique Plane	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",36)	combined.txt
687	SH	1	\N	RAS letter of image location	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",40)	combined.txt
688	FL	1	\N	Image Location	Image location	KB	\N	f	\N	(0027,"GEMS_IMAG_01",41)	combined.txt
689	FL	1	\N	Center R coord of plane image	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",42)	combined.txt
690	FL	1	\N	Center A coord of plane image	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",43)	combined.txt
691	FL	1	\N	Center S coord of plane image	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",44)	combined.txt
692	FL	1	\N	Normal R coord	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",45)	combined.txt
693	FL	1	\N	Normal A coord	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",46)	combined.txt
694	FL	1	\N	Normal S coord	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",47)	combined.txt
695	FL	1	\N	R Coord of Top Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",48)	combined.txt
696	FL	1	\N	A Coord of Top Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",49)	combined.txt
697	FL	1	\N	S Coord of Top Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",4a)	combined.txt
698	FL	1	\N	R Coord of Bottom Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",4b)	combined.txt
699	FL	1	\N	A Coord of Bottom Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",4c)	combined.txt
700	FL	1	\N	S Coord of Bottom Right Corner	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",4d)	combined.txt
701	FL	1	\N	Table start location	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",50)	combined.txt
702	FL	1	\N	Table end location	\N	KB	\N	f	\N	(0027,"GEMS_IMAG_01",51)	combined.txt
703	SH	1	\N	RAS letter for side of image	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",52)	combined.txt
704	SH	1	\N	RAS letter for anterior/posterior	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",53)	combined.txt
705	SH	1	\N	RAS letter for scout start loc	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",54)	combined.txt
706	SH	1	\N	RAS letter for scout end loc	\N	R	\N	f	\N	(0027,"GEMS_IMAG_01",55)	combined.txt
707	FL	1	\N	Image dimension - X	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",60)	combined.txt
708	FL	1	\N	Image dimension - Y	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",61)	combined.txt
709	FL	1	\N	Number of Excitations	\N	K	\N	f	\N	(0027,"GEMS_IMAG_01",62)	combined.txt
10681	SS	1	\N	Scout Type	\N	KB	\N	f	\N	(0027,"GE_YMS_NJ001",10)	combined.txt
10682	FL	1	\N	Scan start location	\N	KB	\N	f	\N	(0027,"GE_YMS_NJ001",50)	combined.txt
10683	FL	1	\N	Scan end location	\N	KB	\N	f	\N	(0027,"GE_YMS_NJ001",51)	combined.txt
251	CS		\N	Data Compression Code	\N	K	\N	f	\N	(0029,"FDMS 1.0",50)	combined.txt
10684	SS	1	\N	CT Int Fluoro	\N	K	\N	f	\N	(0029,"GEMS_CT_FLRO_01",01)	combined.txt
10685	DS	1	\N	Image Precise Location	\N	K	\N	f	\N	(0029,"GEMS_CT_FLRO_01",02)	combined.txt
710	SL	1	\N	Lower range of Pixels1	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",04)	combined.txt
711	DS	1	\N	Lower range of Pixels1	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",05)	combined.txt
712	DS	1	\N	Lower range of Pixels1	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",06)	combined.txt
713	SL	1	\N	Lower range of Pixels1	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",07)	combined.txt
714	SH	1	\N	Lower range of Pixels1	\N	R	\N	f	\N	(0029,"GEMS_IMPS_01",08)	combined.txt
715	SH	1	\N	Lower range of Pixels1	\N	R	\N	f	\N	(0029,"GEMS_IMPS_01",09)	combined.txt
716	SS	1	\N	Lower range of Pixels1	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",0a)	combined.txt
717	SL	1	\N	Lower range of Pixels1	\N	K	\N	f	\N	(0029,"GEMS_IMPS_01",15)	combined.txt
718	SL	1	\N	Upper range of Pixels1	\N	K	\N	f	\N	(0029,"GEMS_IMPS_01",16)	combined.txt
719	SL	1	\N	Lower range of Pixels2	\N	K	\N	f	\N	(0029,"GEMS_IMPS_01",17)	combined.txt
720	SL	1	\N	Upper range of Pixels2	\N	K	\N	f	\N	(0029,"GEMS_IMPS_01",18)	combined.txt
721	SL	1	\N	Len of tot hdr in bytes	\N	X	\N	f	\N	(0029,"GEMS_IMPS_01",1a)	combined.txt
722	SS	1	\N	Version of the hdr struct	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",26)	combined.txt
723	SL	1	\N	Advantage comp. Overflow	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",34)	combined.txt
724	SL	1	\N	Advantage comp. Underflow	\N	KB	\N	f	\N	(0029,"GEMS_IMPS_01",35)	combined.txt
5182	IS	1	\N	SliceNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",01)	combined.txt
5183	IS	1	\N	PhaseNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",02)	combined.txt
5184	LO	1	\N	ProcType	\N	K	\N	f	\N	(0029,"MMCPrivate",03)	combined.txt
5185	LO	1	\N	StopwatchTime	\N	K	\N	f	\N	(0029,"MMCPrivate",04)	combined.txt
5186	LO	1	\N	Plane	\N	K	\N	f	\N	(0029,"MMCPrivate",05)	combined.txt
5187	LO	1	\N	ScanTime	\N	K	\N	f	\N	(0029,"MMCPrivate",06)	combined.txt
5188	LO	1	\N	DualSliceFlag	\N	K	\N	f	\N	(0029,"MMCPrivate",08)	combined.txt
5189	LO	1	\N	SspRatio	\N	K	\N	f	\N	(0029,"MMCPrivate",09)	combined.txt
5190	LO	1	\N	GatingSignalSource	\N	K	\N	f	\N	(0029,"MMCPrivate",0a)	combined.txt
5191	LO	1	\N	Rephase	\N	K	\N	f	\N	(0029,"MMCPrivate",0b)	combined.txt
5192	LO	1	\N	HalfEcho	\N	K	\N	f	\N	(0029,"MMCPrivate",0c)	combined.txt
5193	LO	1	\N	RectFOVRatio	\N	K	\N	f	\N	(0029,"MMCPrivate",0d)	combined.txt
5194	LO	1	\N	HalfScan	\N	K	\N	f	\N	(0029,"MMCPrivate",0e)	combined.txt
5195	LO	1	\N	NumShots	\N	K	\N	f	\N	(0029,"MMCPrivate",0f)	combined.txt
5196	LO	1	\N	ContrastAgent	\N	K	\N	f	\N	(0029,"MMCPrivate",10)	combined.txt
5197	LO	1	\N	EchoAllocation	\N	K	\N	f	\N	(0029,"MMCPrivate",11)	combined.txt
5198	LO	1	\N	NumEchoShift	\N	K	\N	f	\N	(0029,"MMCPrivate",12)	combined.txt
5199	LO	1	\N	FatSat	\N	K	\N	f	\N	(0029,"MMCPrivate",13)	combined.txt
5200	LO	1	\N	MTC	\N	K	\N	f	\N	(0029,"MMCPrivate",14)	combined.txt
5201	LO	1	\N	NumPreSat	\N	K	\N	f	\N	(0029,"MMCPrivate",15)	combined.txt
5202	LO	1	\N	TargetVelocity	\N	K	\N	f	\N	(0029,"MMCPrivate",16)	combined.txt
5203	LO	1	\N	VENCAxis	\N	K	\N	f	\N	(0029,"MMCPrivate",17)	combined.txt
5204	LO	1	\N	NumVENCDirection	\N	K	\N	f	\N	(0029,"MMCPrivate",18)	combined.txt
5205	LO	1	\N	IsScalableWindowLevel	\N	K	\N	f	\N	(0029,"MMCPrivate",1c)	combined.txt
5206	LO	1	\N	ThreeDSettingLineAngle	\N	K	\N	f	\N	(0029,"MMCPrivate",1d)	combined.txt
5207	LO	1	\N	MPGTotalAxis	\N	K	\N	f	\N	(0029,"MMCPrivate",1e)	combined.txt
5208	LO	1	\N	MPGAxisNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",1f)	combined.txt
5209	IS	1	\N	MultiEchoNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",20)	combined.txt
5210	DS	1	\N	NaviAverageGateWidth	\N	K	\N	f	\N	(0029,"MMCPrivate",21)	combined.txt
5211	ST	1	\N	ShimCompensateValue	\N	K	\N	f	\N	(0029,"MMCPrivate",22)	combined.txt
5212	LO	1	\N	GCOffset	\N	K	\N	f	\N	(0029,"MMCPrivate",23)	combined.txt
10744	SS	3	\N	X-Ray Chain	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",12)	combined.txt
5213	DS	1	\N	NaviMaxGateWidth	\N	K	\N	f	\N	(0029,"MMCPrivate",24)	combined.txt
5214	DS	1	\N	NaviMinGateWidth	\N	K	\N	f	\N	(0029,"MMCPrivate",25)	combined.txt
5215	DS	1	\N	NaviMaxGatePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",26)	combined.txt
5216	DS	1	\N	NaviMinGatePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",27)	combined.txt
5217	DS	1	\N	TimeDuration	\N	K	\N	f	\N	(0029,"MMCPrivate",28)	combined.txt
5218	DS	1	\N	TablePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",29)	combined.txt
5219	DS	1	\N	NaviInitialGateWidth	\N	K	\N	f	\N	(0029,"MMCPrivate",2a)	combined.txt
5220	DS	1	\N	NaviFinalGateWidth	\N	K	\N	f	\N	(0029,"MMCPrivate",2b)	combined.txt
5221	DS	1	\N	NaviInitialGatePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",2c)	combined.txt
5222	DS	1	\N	NaviFinalGatePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",2d)	combined.txt
5223	DS	1	\N	NaviAverageGatePosition	\N	K	\N	f	\N	(0029,"MMCPrivate",2e)	combined.txt
5224	OB	1	\N	ImageAppData	\N	X	\N	f	\N	(0029,"MMCPrivate",2f)	combined.txt
5225	FD	1	\N	DiffusionBValue	\N	K	\N	f	\N	(0029,"MMCPrivate",30)	combined.txt
5226	SQ	1	\N	SharedFunctionalGroupsSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",31)	combined.txt
5227	SQ	1	\N	PerFrameFunctionalGroupsSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",32)	combined.txt
5228	DS	1	\N	LossyImageCompressionRatio	\N	K	\N	f	\N	(0029,"MMCPrivate",33)	combined.txt
5229	UI	1	\N	InstanceCreatorUID	\N	R	\N	f	\N	(0029,"MMCPrivate",34)	combined.txt
5230	UI	1	\N	RelatedGeneralSOPClassUID	\N	K	\N	f	\N	(0029,"MMCPrivate",35)	combined.txt
5231	UI	1	\N	OriginalSpecializedSOPClassUID	\N	K	\N	f	\N	(0029,"MMCPrivate",36)	combined.txt
5232	SH	1	\N	TimezoneOffsetFromUTC	\N	X	\N	f	\N	(0029,"MMCPrivate",37)	combined.txt
5233	CS	1	\N	SOPInstanceStatus	\N	X	\N	f	\N	(0029,"MMCPrivate",38)	combined.txt
5234	DT	1	\N	SOPAuthorizationDateandTime	\N	X	\N	f	\N	(0029,"MMCPrivate",39)	combined.txt
5235	LT	1	\N	SOPAuthorizationComment	\N	X	\N	f	\N	(0029,"MMCPrivate",3a)	combined.txt
5236	LO	1	\N	AuthorizationEquipmentCertificationNumber	\N	X	\N	f	\N	(0029,"MMCPrivate",3b)	combined.txt
5237	UL	1	\N	ConcatenationFrameOffsetNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",3c)	combined.txt
5238	CS	1	\N	RepresentativeFrameNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",3d)	combined.txt
5239	UI	1	\N	ConcatenationUID	\N	R	\N	f	\N	(0029,"MMCPrivate",3e)	combined.txt
5240	US	1	\N	InConcatenationNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",3f)	combined.txt
5241	CS	1	\N	CardiacSynchronizationTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",40)	combined.txt
5242	CS	1	\N	CardiacSignalSource	\N	K	\N	f	\N	(0029,"MMCPrivate",41)	combined.txt
5243	FD	1	\N	CardiacRRIntervalSpecified	\N	K	\N	f	\N	(0029,"MMCPrivate",42)	combined.txt
5244	CS	1	\N	CardiacBeatRejectionTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",43)	combined.txt
5245	IS	1	\N	LowRRValue	\N	K	\N	f	\N	(0029,"MMCPrivate",44)	combined.txt
5246	IS	1	\N	HighRRValue	\N	K	\N	f	\N	(0029,"MMCPrivate",45)	combined.txt
5247	IS	1	\N	IntervalsAcquired	\N	K	\N	f	\N	(0029,"MMCPrivate",46)	combined.txt
5248	IS	1	\N	IntervalsRejected	\N	K	\N	f	\N	(0029,"MMCPrivate",47)	combined.txt
5249	CS	1	\N	RespiratoryMotionCompensationTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",48)	combined.txt
5250	CS	1	\N	RespiratorySignalSource	\N	K	\N	f	\N	(0029,"MMCPrivate",49)	combined.txt
5251	CS	1	\N	BulkMotionCompensationTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",4a)	combined.txt
5252	CS	1	\N	BulkMotionSignalSource	\N	K	\N	f	\N	(0029,"MMCPrivate",4b)	combined.txt
5253	CS	1	\N	PixelPresentation	\N	K	\N	f	\N	(0029,"MMCPrivate",4c)	combined.txt
5254	CS	1	\N	VolumetricProperties	\N	K	\N	f	\N	(0029,"MMCPrivate",4d)	combined.txt
5255	CS	1	\N	VolumeBasedCalculationTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",4e)	combined.txt
5256	ST	1	\N	AcquisitionContextDescription	\N	X	\N	f	\N	(0029,"MMCPrivate",4f)	combined.txt
5257	SQ	1	\N	ModalityLUTSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",50)	combined.txt
5258	LO	1	\N	LUTDescriptor	\N	K	\N	f	\N	(0029,"MMCPrivate",51)	combined.txt
5259	LO	1	\N	LUTExplanation	\N	K	\N	f	\N	(0029,"MMCPrivate",52)	combined.txt
5260	LO	1	\N	LUTData	\N	K	\N	f	\N	(0029,"MMCPrivate",53)	combined.txt
5261	CS	1	\N	PresentationLUTShape	\N	K	\N	f	\N	(0029,"MMCPrivate",54)	combined.txt
5262	SQ	1	\N	FrameAnatomySequence	\N	K	\N	f	\N	(0029,"MMCPrivate",55)	combined.txt
5263	CS	1	\N	FrameLaterality	\N	K	\N	f	\N	(0029,"MMCPrivate",56)	combined.txt
5264	SQ	1	\N	AnatomicRegionSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",57)	combined.txt
5265	SH	1	\N	AnatomicRegionCodeValue	\N	K	\N	f	\N	(0029,"MMCPrivate",58)	combined.txt
5266	SH	1	\N	AnatomicRegionCodingSchemeDesignator	\N	K	\N	f	\N	(0029,"MMCPrivate",59)	combined.txt
5267	SH	1	\N	AnatomicRegionCodingSchemeVersion	\N	K	\N	f	\N	(0029,"MMCPrivate",5a)	combined.txt
5268	LO	1	\N	AnatomicRegionCodeMeaning	\N	K	\N	f	\N	(0029,"MMCPrivate",5b)	combined.txt
5269	SQ	1	\N	PixelValueTransformationSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",5c)	combined.txt
5270	LO	1	\N	RescaleType	\N	K	\N	f	\N	(0029,"MMCPrivate",5d)	combined.txt
5271	SQ	1	\N	CardiacTriggerSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",5e)	combined.txt
5272	FD	1	\N	TriggerDelayTime	\N	K	\N	f	\N	(0029,"MMCPrivate",5f)	combined.txt
5273	SQ	1	\N	FrameVOILUTSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",60)	combined.txt
5274	LO	1	\N	WindowCenterAndWidthExplanation	\N	K	\N	f	\N	(0029,"MMCPrivate",61)	combined.txt
5275	CS	1	\N	AcquisitionContrast	\N	K	\N	f	\N	(0029,"MMCPrivate",62)	combined.txt
5276	SQ	1	\N	MRModifierSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",63)	combined.txt
5277	CS	1	\N	ParallelAcquisitionTechnic	\N	K	\N	f	\N	(0029,"MMCPrivate",64)	combined.txt
5278	FD	1	\N	ParallelReductionFactorSecIn	\N	K	\N	f	\N	(0029,"MMCPrivate",65)	combined.txt
5279	CS	1	\N	InversionRecovery	\N	K	\N	f	\N	(0029,"MMCPrivate",66)	combined.txt
5280	CS	1	\N	FlowCompensation	\N	K	\N	f	\N	(0029,"MMCPrivate",67)	combined.txt
5281	CS	1	\N	FlowCompensationDirection	\N	K	\N	f	\N	(0029,"MMCPrivate",68)	combined.txt
5282	CS	1	\N	SpatialPreSaturation	\N	K	\N	f	\N	(0029,"MMCPrivate",69)	combined.txt
5283	CS	1	\N	PartialFourier	\N	K	\N	f	\N	(0029,"MMCPrivate",6a)	combined.txt
5284	CS	1	\N	PartialFourierDirection	\N	K	\N	f	\N	(0029,"MMCPrivate",6b)	combined.txt
10686	CS	1	\N	ResonantNucleus	\N	K	\N	f	\N	(0029,"MMCPrivate",6c)	combined.txt
10687	CS	1	\N	KSpaceFiltering	\N	K	\N	f	\N	(0029,"MMCPrivate",6d)	combined.txt
10688	CS	1	\N	ApplicableSafetyStandardAgency	\N	K	\N	f	\N	(0029,"MMCPrivate",6e)	combined.txt
10689	LO	1	\N	ApplicableSafetyStandardDescription	\N	K	\N	f	\N	(0029,"MMCPrivate",6f)	combined.txt
5285	SQ	1	\N	MRReceiveCoilSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",70)	combined.txt
5286	LO	1	\N	ReceiveCoilManufacturerName	\N	K	\N	f	\N	(0029,"MMCPrivate",71)	combined.txt
5287	CS	1	\N	ReceiveCoilType	\N	K	\N	f	\N	(0029,"MMCPrivate",72)	combined.txt
5288	CS	1	\N	QuadratureReceiveCoil	\N	K	\N	f	\N	(0029,"MMCPrivate",73)	combined.txt
5289	LO	1	\N	MultiCoilConfiguration	\N	K	\N	f	\N	(0029,"MMCPrivate",74)	combined.txt
5290	CS	1	\N	ComplexImageComponent	\N	K	\N	f	\N	(0029,"MMCPrivate",75)	combined.txt
5291	SH	1	\N	PulseSequenceName	\N	K	\N	f	\N	(0029,"MMCPrivate",76)	combined.txt
5292	CS	1	\N	EchoPulseSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",77)	combined.txt
5293	CS	1	\N	MultipleSpinEcho	\N	K	\N	f	\N	(0029,"MMCPrivate",78)	combined.txt
5294	CS	1	\N	MultiPlanarExcitation	\N	K	\N	f	\N	(0029,"MMCPrivate",79)	combined.txt
5295	CS	1	\N	PhaseContrast	\N	K	\N	f	\N	(0029,"MMCPrivate",7a)	combined.txt
5296	CS	1	\N	TimeOfFlightContrast	\N	K	\N	f	\N	(0029,"MMCPrivate",7b)	combined.txt
5297	CS	1	\N	SteadyStatePulseSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",7c)	combined.txt
5298	CS	1	\N	EchoPlanarPulseSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",7d)	combined.txt
5299	CS	1	\N	SpectrallySelectedSuppression	\N	K	\N	f	\N	(0029,"MMCPrivate",7e)	combined.txt
5300	CS	1	\N	OversamplingPhase	\N	K	\N	f	\N	(0029,"MMCPrivate",7f)	combined.txt
5301	CS	1	\N	SegmentedKSpaceTraversal	\N	K	\N	f	\N	(0029,"MMCPrivate",80)	combined.txt
5302	CS	1	\N	CoverageOfKSpace	\N	K	\N	f	\N	(0029,"MMCPrivate",81)	combined.txt
5303	SQ	1	\N	MRTimingAndRelatedParametersSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",82)	combined.txt
5304	US	1	\N	RFEchoTrainLength	\N	K	\N	f	\N	(0029,"MMCPrivate",83)	combined.txt
5305	US	1	\N	GradientEchoTrainLength	\N	K	\N	f	\N	(0029,"MMCPrivate",84)	combined.txt
5306	CS	1	\N	GradientOutputType	\N	K	\N	f	\N	(0029,"MMCPrivate",85)	combined.txt
5307	FD	1	\N	GradientOutput	\N	K	\N	f	\N	(0029,"MMCPrivate",86)	combined.txt
5308	SQ	1	\N	MRFOVGeometrySequence	\N	K	\N	f	\N	(0029,"MMCPrivate",87)	combined.txt
5309	US	1	\N	MRAcquisitionFrequencyEncodingSteps	\N	K	\N	f	\N	(0029,"MMCPrivate",88)	combined.txt
5310	US	1	\N	MRAcquisitionPhaseEncodingStepsInPlane	\N	K	\N	f	\N	(0029,"MMCPrivate",89)	combined.txt
5311	US	1	\N	MRAcquisitionPhaseEncodingStepsOutOfPlane	\N	K	\N	f	\N	(0029,"MMCPrivate",8a)	combined.txt
5312	SQ	1	\N	MRTransmitCoilSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",8b)	combined.txt
5313	SH	1	\N	TransmitCoilName	\N	K	\N	f	\N	(0029,"MMCPrivate",8c)	combined.txt
5314	LO	1	\N	TransmitCoilManufacturerName	\N	K	\N	f	\N	(0029,"MMCPrivate",8d)	combined.txt
5315	CS	1	\N	TransmitCoilType	\N	K	\N	f	\N	(0029,"MMCPrivate",8e)	combined.txt
5316	SQ	1	\N	MREchoSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",8f)	combined.txt
5317	FD	1	\N	EffectiveEchoTime	\N	K	\N	f	\N	(0029,"MMCPrivate",90)	combined.txt
5318	SQ	1	\N	MRMetaboliteMapSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",91)	combined.txt
5319	ST	1	\N	MetaboliteMapDescription	\N	K	\N	f	\N	(0029,"MMCPrivate",92)	combined.txt
5320	SQ	1	\N	MetaboliteMapCodeSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",93)	combined.txt
5321	SH	1	\N	MetaboliteMapCodeValue	\N	K	\N	f	\N	(0029,"MMCPrivate",94)	combined.txt
5322	SH	1	\N	MetaboliteMapCodingSchemeDesignator	\N	K	\N	f	\N	(0029,"MMCPrivate",95)	combined.txt
5323	SH	1	\N	MetaboliteMapCodingSchemeVersion	\N	K	\N	f	\N	(0029,"MMCPrivate",96)	combined.txt
5324	LO	1	\N	MetaboliteMapCodeMeaning	\N	K	\N	f	\N	(0029,"MMCPrivate",97)	combined.txt
5325	SQ	1	\N	MRImagingModifierSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",98)	combined.txt
5326	CS	1	\N	MagnetizationTransfer	\N	K	\N	f	\N	(0029,"MMCPrivate",99)	combined.txt
5327	CS	1	\N	BloodSignalNulling	\N	K	\N	f	\N	(0029,"MMCPrivate",9a)	combined.txt
5328	CS	1	\N	Tagging	\N	K	\N	f	\N	(0029,"MMCPrivate",9b)	combined.txt
5329	FD	1	\N	TagSpacingFirstDimension	\N	K	\N	f	\N	(0029,"MMCPrivate",9c)	combined.txt
5330	FD	1	\N	TagSpacingSecondDimension	\N	K	\N	f	\N	(0029,"MMCPrivate",9d)	combined.txt
5331	FD	1	\N	TagAngleFirstAxis	\N	K	\N	f	\N	(0029,"MMCPrivate",9e)	combined.txt
5332	SS	1	\N	TagAngleSecondAxis	\N	K	\N	f	\N	(0029,"MMCPrivate",9f)	combined.txt
5333	FD	1	\N	TagThickness	\N	K	\N	f	\N	(0029,"MMCPrivate",a0)	combined.txt
5334	FD	1	\N	TaggingDelay	\N	K	\N	f	\N	(0029,"MMCPrivate",a1)	combined.txt
5335	FD	1	\N	TransmitterFrequency	\N	K	\N	f	\N	(0029,"MMCPrivate",a2)	combined.txt
5336	DS	1	\N	PixelBandwidth	\N	K	\N	f	\N	(0029,"MMCPrivate",a3)	combined.txt
5337	SQ	1	\N	MRVelocityEncodingSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",a4)	combined.txt
5338	FD	1	\N	VelocityEncodingDirection	\N	K	\N	f	\N	(0029,"MMCPrivate",a5)	combined.txt
5339	FD	1	\N	VelocityEncodingMinimumValue	\N	K	\N	f	\N	(0029,"MMCPrivate",a6)	combined.txt
5340	FD	1	\N	VelocityEncodingMaximumValue	\N	K	\N	f	\N	(0029,"MMCPrivate",a7)	combined.txt
5341	SQ	1	\N	MRImageFrameTypeSequence	\N	K	\N	f	\N	(0029,"MMCPrivate",a8)	combined.txt
5342	CS	1	\N	FrameType	\N	K	\N	f	\N	(0029,"MMCPrivate",a9)	combined.txt
5343	CS	1	\N	PixelPresentation	\N	K	\N	f	\N	(0029,"MMCPrivate",aa)	combined.txt
5344	CS	1	\N	VolumetricProperties	\N	K	\N	f	\N	(0029,"MMCPrivate",ab)	combined.txt
5345	CS	1	\N	VolumeBasedCalculationTechnique	\N	K	\N	f	\N	(0029,"MMCPrivate",ac)	combined.txt
5362	UI	1	\N	BackgroundImageInstanceUID	\N	K	\N	f	\N	(0029,"MMCPrivate",bd)	combined.txt
5363	LO	1	\N	IsStoredToPortableMedia	\N	X	\N	f	\N	(0029,"MMCPrivate",be)	combined.txt
5364	DS	1	\N	Voi1	\N	K	\N	f	\N	(0029,"MMCPrivate",bf)	combined.txt
5366	DS	1	\N	Voi2	\N	K	\N	f	\N	(0029,"MMCPrivate",c1)	combined.txt
5367	DS	1	\N	MixingTime	\N	K	\N	f	\N	(0029,"MMCPrivate",c2)	combined.txt
5368	DS	1	\N	SelectiveIRPosition	\N	K	\N	f	\N	(0029,"MMCPrivate",c3)	combined.txt
5369	DS	1	\N	SelectiveIRRow	\N	K	\N	f	\N	(0029,"MMCPrivate",c4)	combined.txt
5370	DS	1	\N	SelectiveIRColumn	\N	K	\N	f	\N	(0029,"MMCPrivate",c5)	combined.txt
10690	DS	1	\N	SelectiveIROrientation	\N	K	\N	f	\N	(0029,"MMCPrivate",c6)	combined.txt
10691	LO	1	\N	SelectiveIRThickness	\N	K	\N	f	\N	(0029,"MMCPrivate",c7)	combined.txt
10692	SH	1	\N	RephaseOrderSlice	\N	K	\N	f	\N	(0029,"MMCPrivate",c8)	combined.txt
10693	SH	1	\N	RephaseOrderPhase	\N	K	\N	f	\N	(0029,"MMCPrivate",c9)	combined.txt
10694	SH	1	\N	RephaseOrderFreq	\N	K	\N	f	\N	(0029,"MMCPrivate",ca)	combined.txt
10695	ST	1	\N	MetaboliteMapDescription	\N	K	\N	f	\N	(0029,"MMCPrivate",cb)	combined.txt
10696	SQ	1	\N	volumeLocalizationSeq	\N	K	\N	f	\N	(0029,"MMCPrivate",cc)	combined.txt
10697	FD	1	\N	SlabThickness	\N	K	\N	f	\N	(0029,"MMCPrivate",cd)	combined.txt
10698	FD	1	\N	SlabOrientation	\N	K	\N	f	\N	(0029,"MMCPrivate",ce)	combined.txt
10699	FD	1	\N	MidSlabPosition	\N	K	\N	f	\N	(0029,"MMCPrivate",cf)	combined.txt
5371	LO	1	\N	AcqModeSliceDir	\N	K	\N	f	\N	(0029,"MMCPrivate",d0)	combined.txt
10700	LO	1	\N	IRThicknessRatio	\N	K	\N	f	\N	(0029,"MMCPrivate",d1)	combined.txt
10701	LO	1	\N	BBIRThicknessRatio	\N	K	\N	f	\N	(0029,"MMCPrivate",d2)	combined.txt
5372	LO	1	\N	DeltaAngle	\N	K	\N	f	\N	(0029,"MMCPrivate",d3)	combined.txt
10702	IS	1	\N	MultiFrameFrameNumber	\N	K	\N	f	\N	(0029,"MMCPrivate",d4)	combined.txt
5373	UI	1	\N	EnhancedSopInstanceUid	\N	K	\N	f	\N	(0029,"MMCPrivate",d5)	combined.txt
5374	LO	1	\N	PolarityOfPhaseEncoding	\N	K	\N	f	\N	(0029,"MMCPrivate",d6)	combined.txt
5375	OB	1	\N	PresentationStates	\N	X	\N	f	\N	(0029,"MMCPrivate",d7)	combined.txt
8853	OB	1	\N	Syngo Report Data	\N	X	\N	f	\N	(0029,"SIEMENS CSA ENVELOPE",10)	combined.txt
8854	OB	1	\N	Syngo Report Presentation	\N	X	\N	f	\N	(0029,"SIEMENS CSA ENVELOPE",11)	combined.txt
1376	CS	1	\N	CSA Image Header Type	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",08)	combined.txt
1377	LO	1	\N	CSA Image Header Version	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",09)	combined.txt
1378	OB	1	\N	CSA Image Header Info	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",10)	combined.txt
1379	CS	1	\N	CSA Series Header Type	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",18)	combined.txt
1380	LO	1	\N	CSA Series Header Version	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",19)	combined.txt
1381	OB	1	\N	CSA Series Header Info	\N	X	\N	f	\N	(0029,"SIEMENS CSA HEADER",20)	combined.txt
1382	CS	1	\N	CSA Data Type	\N	X	\N	f	\N	(0029,"SIEMENS CSA NON-IMAGE",08)	combined.txt
1383	LO	1	\N	CSA Data Version	\N	X	\N	f	\N	(0029,"SIEMENS CSA NON-IMAGE",09)	combined.txt
8849	CS	1	\N	Syngo Report Type	\N	X	\N	f	\N	(0029,"SIEMENS CSA REPORT",08)	combined.txt
8850	LO	1	\N	Syngo Report	\N	X	\N	f	\N	(0029,"SIEMENS CSA REPORT",09)	combined.txt
8851	US	1	\N	SR Variant	\N	X	\N	f	\N	(0029,"SIEMENS CSA REPORT",15)	combined.txt
8852	UI	1	\N	SC SOP Instance UID	\N	X	\N	f	\N	(0029,"SIEMENS CSA REPORT",17)	combined.txt
1632	CS	1	\N	MedCom Header Type	\N	R	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",08)	combined.txt
1633	LO	1	\N	MedCom Header Version	\N	R	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",09)	combined.txt
1634	OB	1	\N	MedCom Header Info	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",10)	combined.txt
1635	OB	1	\N	MedCom History Information	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",20)	combined.txt
1636	LO	1	\N	PMTF Information 1	\N	R	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",31)	combined.txt
1637	UL	1	\N	PMTF Information 2	\N	KB	R	f	\N	(0029,"SIEMENS MEDCOM HEADER",32)	combined.txt
1638	UL	1	\N	PMTF Information 3	\N	KB	R	f	\N	(0029,"SIEMENS MEDCOM HEADER",33)	combined.txt
1639	CS	1	\N	PMTF Information 4	\N	R	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",34)	combined.txt
1640	UL	1	\N	PMTF Information 5	\N	KB	R	f	\N	(0029,"SIEMENS MEDCOM HEADER",35)	combined.txt
1641	SQ	1	\N	Application Header Sequence	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",40)	combined.txt
1642	CS	1	\N	Application Header Type	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",41)	combined.txt
1643	LO	1	\N	Application Header ID	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",42)	combined.txt
1644	LO	1	\N	Application Header Version	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",43)	combined.txt
1645	OB	1	\N	Application Header Info	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",44)	combined.txt
1646	LO	8	\N	Workflow Control Flags	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",50)	combined.txt
1647	CS	1	\N	Archive Management Flag Keep Online	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",51)	combined.txt
1648	CS	1	\N	Archive Management Flag Do Not Archive	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",52)	combined.txt
1649	CS	1	\N	Image Location Status	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",53)	combined.txt
1650	DS	1	\N	Estimated Retrieve Time	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",54)	combined.txt
1651	DS	1	\N	Data Size of Retrieved Images	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",55)	combined.txt
8631	SQ	1	\N	Siemens Link Sequence	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",70)	combined.txt
8632	AT	1	\N	Referenced Tag	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",71)	combined.txt
8633	CS	1	\N	Referenced Tag Type	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",72)	combined.txt
8634	UL	1	\N	Referenced Value Length	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",73)	combined.txt
8635	CS	1	\N	Referenced Object Device Type	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",74)	combined.txt
8636	OB	1	\N	Referenced Object Device Location	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",75)	combined.txt
8637	OB	1	\N	Referenced Object ID	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER",76)	combined.txt
1652	LO	1	\N	Series Work Flow Status	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM HEADER2",60)	combined.txt
1653	CS	1	\N	MEDCOM OOG Type	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM OOG",08)	combined.txt
1654	LO	1	\N	MEDCOM OOG Version	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM OOG",09)	combined.txt
1655	OB	1	\N	MEDCOM OOG Info	\N	X	\N	f	\N	(0029,"SIEMENS MEDCOM OOG",10)	combined.txt
8925	FL	n	\N	Flood correction matrix Detector 1 ( n=row s x cols) E.Soft vers upto SR2.0	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",00)	combined.txt
8926	FL	n	\N	Flood correction Matrix Det 2 upto SR 2.0	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",01)	combined.txt
8927	FL	n	\N	COR Data for detector 1 ( n = 128)	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",10)	combined.txt
8928	FL	n	\N	COR Data for detector 2 ( n = 128)	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",11)	combined.txt
8929	FL	n	\N	MHR ( Y-Shift) data for detector 1	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",14)	combined.txt
8930	FL	n	\N	MHR ( Y-Shift) data for detector 2	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",15)	combined.txt
8931	FL	n	\N	NCO Data for detector 1 (n = number of view s)	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",18)	combined.txt
8932	FL	n	\N	NCO Data 2	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",19)	combined.txt
8934	FL	1	\N	Bed correction angle	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",20)	combined.txt
8935	FL	1	\N	Gantry correction angle	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",21)	combined.txt
8936	SS	n	\N	Bed U/D correction data (n=number of view s)	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",22)	combined.txt
8937	SS	n	\N	Gantry L/R Correction Data	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",23)	combined.txt
8938	FL	1	\N	BackProjection Correction angle head 1	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",24)	combined.txt
8939	FL	1	\N	BackProjection Correction angle head 2	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",25)	combined.txt
8940	SL	1	\N	Number of point sources used for NCO and MHR	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",28)	combined.txt
8941	FL	1	\N	Crystal thickness	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",29)	combined.txt
8942	LO	1	\N	Preset name used for acquisiton	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",30)	combined.txt
8943	FL	1	\N	Camera Config Angle	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",31)	combined.txt
8944	LO	1	\N	Crystal type Startburst or not	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",32)	combined.txt
8945	SL	1	\N	Gantry step for COIN acquisitions	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",33)	combined.txt
8946	FL	1	\N	Bed step for wholebody or Coin acquisitions	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",34)	combined.txt
8947	FL	1	\N	Weight factor table for coincidence acquisitions	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",35)	combined.txt
8948	FL	1	\N	Transaxial acceptance width for coincidence	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",36)	combined.txt
8949	SL	1	\N	Starburst flags at image acq time	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",37)	combined.txt
8950	FL	1	\N	Pixel Scale factor	\N	K	\N	f	\N	(0033,"SIEMENS MED NM",38)	combined.txt
8951	LO	1	\N	Specialized tomo type	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",00)	combined.txt
8952	LO	1	\N	Energy window type	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",01)	combined.txt
8953	SS	1	\N	Start and end row illuminated by wind position	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",02)	combined.txt
8954	LO	1	\N	Blank scan image for profile	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",03)	combined.txt
8955	SS	1	\N	Repeat number of the original dynamic SPECT	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",04)	combined.txt
8956	SS	1	\N	Phase number of the original dynamic SPECT	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",05)	combined.txt
8957	LO	1	\N	Siemens Profile 2 Image Sub type	\N	K	\N	f	\N	(0035,"SIEMENS MED NM",06)	combined.txt
4540	LO	1	\N	SR Application Name	\N	R	\N	f	\N	(0039,"GEMS_0039",95)	combined.txt
8960	LT	1	\N	Toshiba CBF activity results	\N	K	\N	f	\N	(0039,"SIEMENS MED NM",00)	combined.txt
8961	LT	1	\N	Related CT Series Instance UID	\N	R	\N	f	\N	(0039,"SIEMENS MED NM",01)	combined.txt
10703	SS	1	\N	Air Calibration Date	\N	X	\N	f	\N	(0040,"GEMS_HELIOS_01",19)	combined.txt
10704	OB	1	\N	RawDataAppData	\N	K	\N	f	\N	(0041,"MMCPrivate",01)	combined.txt
10705	SQ	1	\N	RawDataIndex	\N	K	\N	f	\N	(0041,"MMCPrivate",02)	combined.txt
10706	LO	1	\N	ChannelNumber	\N	K	\N	f	\N	(0041,"MMCPrivate",03)	combined.txt
10707	LO	1	\N	AxisDirection	\N	K	\N	f	\N	(0041,"MMCPrivate",04)	combined.txt
10708	LO	1	\N	SlabNumbe	\N	K	\N	f	\N	(0041,"MMCPrivate",05)	combined.txt
10709	LO	1	\N	CardiacPhaseNumbe	\N	K	\N	f	\N	(0041,"MMCPrivate",06)	combined.txt
10710	LO	1	\N	EchoNumber	\N	K	\N	f	\N	(0041,"MMCPrivate",07)	combined.txt
10711	LO	1	\N	SliceEncodeNumber	\N	K	\N	f	\N	(0041,"MMCPrivate",08)	combined.txt
10712	LO	1	\N	NsaNumber	\N	K	\N	f	\N	(0041,"MMCPrivate",09)	combined.txt
10713	OB	1	\N	RawData	\N	K	\N	f	\N	(0041,"MMCPrivate",0a)	combined.txt
10714	SS	1	\N	RawDataMRInfo	\N	K	\N	f	\N	(0041,"MMCPrivate",0b)	combined.txt
10715	IS	1	\N	NumberOfVoxels	\N	K	\N	f	\N	(0041,"MMCPrivate",0c)	combined.txt
10716	DS	1	\N	MixingTime	\N	K	\N	f	\N	(0041,"MMCPrivate",0d)	combined.txt
10717	DS	1	\N	ADDiff	\N	K	\N	f	\N	(0041,"MMCPrivate",0e)	combined.txt
10718	LO	1	\N	ScanTime	\N	K	\N	f	\N	(0041,"MMCPrivate",0f)	combined.txt
10719	LO	1	\N	NumPreSat	\N	K	\N	f	\N	(0041,"MMCPrivate",10)	combined.txt
10720	LO	1	\N	IsStoredToPortableMedia	\N	X	\N	f	\N	(0041,"MMCPrivate",11)	combined.txt
10721	DS	1	\N	Voi1	\N	K	\N	f	\N	(0041,"MMCPrivate",12)	combined.txt
10722	DS	1	\N	Voi2	\N	K	\N	f	\N	(0041,"MMCPrivate",13)	combined.txt
10723	DS	1	\N	VoxelSize	\N	K	\N	f	\N	(0041,"MMCPrivate",14)	combined.txt
10724	IS	1	\N	FreqPoint	\N	K	\N	f	\N	(0041,"MMCPrivate",15)	combined.txt
10725	SH	1	\N	LowOrderShim	\N	K	\N	f	\N	(0041,"MMCPrivate",16)	combined.txt
10726	SH	1	\N	EccLevel	\N	K	\N	f	\N	(0041,"MMCPrivate",17)	combined.txt
10727	FL	1	\N	FwhmHz	\N	K	\N	f	\N	(0041,"MMCPrivate",18)	combined.txt
10728	FL	1	\N	FwhmPpm	\N	K	\N	f	\N	(0041,"MMCPrivate",19)	combined.txt
10729	FL	1	\N	WaterSupRate	\N	K	\N	f	\N	(0041,"MMCPrivate",1a)	combined.txt
8963	SL	1	\N	Whole Body Tomo Position Index	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",01)	combined.txt
8964	SL	1	\N	Whole Body Tomo Number of Positions	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",02)	combined.txt
8965	FL	1	\N	Horizontal Table Position of CT scan	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",03)	combined.txt
8966	FL	1	\N	Effective Energy fo CT Scan	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",04)	combined.txt
8967	FD	1-n	\N	Long Linear Drive Information for Detector 1	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",05)	combined.txt
8968	FD	1-n	\N	Long Linear Drive Information for Detector 2	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",06)	combined.txt
8969	FD	1-n	\N	Trunnion Information for Detector 1	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",07)	combined.txt
8970	FD	1-n	\N	Trunnion Information for Detector 2	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",08)	combined.txt
8971	FL	1	\N	Broad Beam Factor	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",09)	combined.txt
8972	FD	1	\N	Original Wholebody Position	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",0a)	combined.txt
8973	FD	1	\N	Wholebody Scan Range	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",0b)	combined.txt
8974	FL	1-3	\N	Effective Emission Energy	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",10)	combined.txt
8975	FL	1-n	\N	Gated Frame Duration	\N	K	\N	f	\N	(0041,"SIEMENS MED NM",11)	combined.txt
725	SS	1	\N	Bitmap of prescan options	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",01)	combined.txt
726	SS	1	\N	Gradient offset in X	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",02)	combined.txt
727	SS	1	\N	Gradient offset in Y	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",03)	combined.txt
728	SS	1	\N	Gradient offset in Z	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",04)	combined.txt
729	SS	1	\N	Img is original or unoriginal	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",05)	combined.txt
730	SS	1	\N	Number of EPI shots	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",06)	combined.txt
731	SS	1	\N	Views per segment	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",07)	combined.txt
732	SS	1	\N	"Respiratory rate, bpm"	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",08)	combined.txt
733	SS	1	\N	Respiratory trigger point	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",09)	combined.txt
734	SS	1	\N	Type of receiver used	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",0a)	combined.txt
735	DS	1	\N	dB/dt Peak rate of change of gradient field	Peak rate of change of gradient field	K	\N	f	\N	(0043,"GEMS_PARM_01",0b)	combined.txt
736	DS	1	\N	Limits in units of percent	dB/dt Limits in units of percent	KB	\N	f	\N	(0043,"GEMS_PARM_01",0c)	combined.txt
737	DS	1	\N	PSD estimated limit	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",0d)	combined.txt
738	DS	1	\N	PSD estimated limit in tesla per second	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",0e)	combined.txt
739	DS	1	\N	Saravghead	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",0f)	combined.txt
740	US	1	\N	Window value	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",10)	combined.txt
741	US	1	\N	Total input views	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",11)	combined.txt
742	SS	3	\N	X-ray chain	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",12)	combined.txt
743	SS	5	\N	Decon kernel parameters	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",13)	combined.txt
744	SS	3	\N	Calibration parameters	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",14)	combined.txt
745	SS	3	\N	Total output views	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",15)	combined.txt
746	SS	5	\N	Number of overranges	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",16)	combined.txt
747	DS	1	\N	IBH image scale factors	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",17)	combined.txt
748	DS	3	\N	BBH coefficients	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",18)	combined.txt
749	SS	1	\N	Number of BBH chains to blend	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",19)	combined.txt
750	SL	1	\N	Starting channel number	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",1a)	combined.txt
751	SS	1	\N	Ppscan parameters	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",1b)	combined.txt
752	SS	1	\N	GE image integrity	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",1c)	combined.txt
753	SS	1	\N	Level value	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",1d)	combined.txt
754	DS	1	\N	Delta start time	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",1e)	combined.txt
755	SL	1	\N	Max overranges in a view	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",1f)	combined.txt
756	DS	1	\N	Avg overranges all views	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",20)	combined.txt
757	SS	1	\N	Corrected after glow terms	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",21)	combined.txt
758	SS	6	\N	Reference channels	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",25)	combined.txt
759	US	6	\N	No views ref chans blocked	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",26)	combined.txt
760	SH	1	\N	Scan pitch ratio	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",27)	combined.txt
761	OB	1	\N	Unique image iden	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",28)	combined.txt
762	OB	1	\N	Histogram tables	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",29)	combined.txt
763	OB	1	\N	User defined data	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",2a)	combined.txt
764	SS	4	\N	Private Scan Options	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",2b)	combined.txt
765	SS	1	\N	Effective echo spacing	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",2c)	combined.txt
766	SH	1	\N	Filter Mode (String slop field 1 in legacy GE MR images)	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",2d)	combined.txt
767	SH	1	\N	String slop field 2	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",2e)	combined.txt
768	SS	1	\N	"Image Type (real, imaginary, phase, magnitude)"	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",2f)	combined.txt
769	SS	1	\N	Vas collapse flag	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",30)	combined.txt
770	DS	"2,3"	\N	RA cord of target recon center	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",31)	combined.txt
771	SS	1	\N	Vas flags	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",32)	combined.txt
772	FL	1	\N	Neg_scanspacing	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",33)	combined.txt
773	IS	1	\N	Offset frequency	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",34)	combined.txt
774	UL	1	\N	User_usage_tag	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",35)	combined.txt
775	UL	1	\N	User_fill_map_MSW	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",36)	combined.txt
776	UL	1	\N	User_fill_map_LSW	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",37)	combined.txt
777	FL	24	\N	User data 25...User data 48	User data 25...User data 48 {User48=Effective Resolution for spiral)	K	\N	f	\N	(0043,"GEMS_PARM_01",38)	combined.txt
778	IS	4	\N	slop_int_6; slop_int_9; 6: b_value; 7: private imaging options 2; 8: ihtagging; 9: ihtagspc	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",39)	combined.txt
779	FL	4	\N	Trigger on position	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",40)	combined.txt
780	FL	4	\N	Degree of rotation	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",41)	combined.txt
781	SL	4	\N	DAS trigger source	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",42)	combined.txt
782	SL	4	\N	DAS fpa gain	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",43)	combined.txt
783	SL	4	\N	DAS output source	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",44)	combined.txt
784	SL	4	\N	DAS ad input	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",45)	combined.txt
785	SL	4	\N	DAS cal mode	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",46)	combined.txt
786	SL	4	\N	DAS cal frequency	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",47)	combined.txt
787	SL	4	\N	DAS reg xm	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",48)	combined.txt
788	SL	4	\N	DAS auto zero	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",49)	combined.txt
789	SS	4	\N	Starting channel of view	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",4a)	combined.txt
790	SL	4	\N	DAS xm pattern	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",4b)	combined.txt
791	SS	4	\N	TGGC trigger mode	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",4c)	combined.txt
792	FL	4	\N	Start scan to X-ray on delay	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",4d)	combined.txt
793	FL	4	\N	Duration of X-ray on	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",4e)	combined.txt
794	IS	8	\N	Slop_int_10; slop_int_17; 10: ihfcineim; 11: ihfcinent; 12: Reserved; 13: oprtarr; 14: averages; 15: Current Station #; 16: Total # of Stations; 17: Reserved	Slop_int_10; slop_int_17; 10: ihfcineim; 11: ihfcinent; 12: Reserved; 13: oprtarr; 14: averages; 15: Current Station #; 16: Total # of Stations; 17: private imaging options 3	K	\N	f	\N	(0043,"GEMS_PARM_01",60)	combined.txt
795	UI	1	\N	Scanner Study Entity UID	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",61)	combined.txt
796	SH	1	\N	Scanner Study ID	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",62)	combined.txt
3947	SH	1	\N	Raw Data ID	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",63)	combined.txt
3949	US	1	\N	Motion Correction Indicator	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",65)	combined.txt
3950	US	1	\N	Helical Correction Indicator	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",66)	combined.txt
3951	US	1	\N	IBO Correction Indicator	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",67)	combined.txt
3952	US	1	\N	XT Correction Indicator	Cross-Talk Correction Indicator	KB	\N	f	\N	(0043,"GEMS_PARM_01",68)	combined.txt
3953	US	1	\N	Q-cal Correction Indicator	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",69)	combined.txt
3954	US	1	\N	AV Correction Indicator	Afterglow Correction Indicator	KB	\N	f	\N	(0043,"GEMS_PARM_01",6a)	combined.txt
3955	US	1	\N	Local Decon Correction Indicator	L-MDK Correction Indicator	KB	\N	f	\N	(0043,"GEMS_PARM_01",6b)	combined.txt
3956	IS	1	\N	Detector Row	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",6c)	combined.txt
3957	US	1	\N	Area Size	Z-smoothing Size	KB	\N	f	\N	(0043,"GEMS_PARM_01",6d)	combined.txt
3958	SH	1	\N	Auto mA Mode	\N	KB	\N	f	\N	(0043,"GEMS_PARM_01",6e)	combined.txt
797	DS	"3,4"	\N	"Scanner Table Entry (single gradient coil systems only); Scanner table Entry + Gradient Coil Selected 1: table entry, 2: table swing angle, 3: table lateral offset, 4: gradient coil selected (multiple gradient systems only)"	Scanner Table Entry (single gradient coil systems only); Scanner table Entry + Gradient Coil Selectedonly)	K	\N	f	\N	(0043,"GEMS_PARM_01",6f)	combined.txt
3959	LO	1	\N	Paradigm Name	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",70)	combined.txt
3960	ST	1	\N	Paradigm Description	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",71)	combined.txt
3961	UI	1	\N	Paradigm UID	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",72)	combined.txt
3962	US	1	\N	Experiment Type	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",73)	combined.txt
3963	US	1	\N	#rest volumes	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",74)	combined.txt
3964	US	1	\N	#active volumes	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",75)	combined.txt
3965	US	1	\N	#dummy scans	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",76)	combined.txt
3966	SH	1	\N	Application Name	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",77)	combined.txt
3967	SH	1	\N	Application Version	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",78)	combined.txt
3968	US	1	\N	Slices Per Volume	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",79)	combined.txt
3969	US	1	\N	Expected Time Points	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",7a)	combined.txt
3970	FL	1-n	\N	Regressor Values	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",7b)	combined.txt
3971	FL	1	\N	Delay after slice group	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",7c)	combined.txt
3972	US	1	\N	Recon mode flag word	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",7d)	combined.txt
3973	LO	1-n	\N	PACC specific information	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",7e)	combined.txt
3974	DS	1-n	\N	Grad Shim Values	Reserved	R	\N	f	\N	(0043,"GEMS_PARM_01",7f)	combined.txt
3975	LO	1-n	\N	Coil ID Name	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",80)	combined.txt
3976	LO	1	\N	GE Coil Name	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",81)	combined.txt
3977	LO	1-n	\N	System Configuration Information	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",82)	combined.txt
3978	DS	1-2	\N	Asset R Factors	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",83)	combined.txt
3979	LO	5	\N	Additional Asset Data	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",84)	combined.txt
3980	UT	1	\N	Debug Data (text format)	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",85)	combined.txt
3981	OB	1	\N	Debug Data (binary format)	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",86)	combined.txt
3982	UT	1	\N	Reserved	Software Versions Long	R	\N	f	\N	(0043,"GEMS_PARM_01",87)	combined.txt
3983	UI	1	\N	PURE Acquisition Calibration Series UID	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",88)	combined.txt
3984	LO	3	\N	"Governing Body, dB/dt, and SAR definition"	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",89)	combined.txt
3985	CS	1	\N	Private In-Plane Phase Encoding Direction	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",8a)	combined.txt
3986	OB	1	\N	FMRI Binary Data Block	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",8b)	combined.txt
3987	DS	6	\N	Voxel Location	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",8c)	combined.txt
3988	DS	7n	\N	SAT Band Locations	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",8d)	combined.txt
3989	DS	3	\N	Spectro Prescan Values	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",8e)	combined.txt
3990	DS	3	\N	Spectro Parameters	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",8f)	combined.txt
3991	LO	1-n	\N	SAR Definition	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",90)	combined.txt
3992	DS	1-n	\N	SAR value	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",91)	combined.txt
3993	LO	1	\N	Image Error Text	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",92)	combined.txt
3994	DS	1-n	\N	Spectro Quantitation Values	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",93)	combined.txt
3995	DS	1-n	\N	Spectro Ratio Values	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",94)	combined.txt
3996	LO	1	\N	Prescan Reuse String	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",95)	combined.txt
3997	CS	1	\N	Content Qualification	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",96)	combined.txt
3998	LO	8	\N	Image Filtering Parameters	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",97)	combined.txt
3999	UI	1	\N	ASSET Acquisition Calibration Series UID	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",98)	combined.txt
4000	LO	1-n	\N	Extended Options	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",99)	combined.txt
4001	IS	1	\N	Rx Stack Identification	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",9a)	combined.txt
10730	DS	1	\N	NPW factor	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",9b)	combined.txt
10731	OB	1	\N	Research Tag 1	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",9c)	combined.txt
10732	OB	1	\N	Research Tag 2	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",9d)	combined.txt
10733	OB	1	\N	Research Tag 3	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",9e)	combined.txt
10734	OB	1	\N	Research Tag 4	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",9f)	combined.txt
10735	SQ	1	\N	Spectroscopy Pixel Sequence	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",a0)	combined.txt
10736	SQ	1	\N	Spectroscopy Default Display Sequence	\N	X	\N	f	\N	(0043,"GEMS_PARM_01",a1)	combined.txt
10737	DS	1-n	\N	MEF Data	MEG Data	R	\N	f	\N	(0043,"GEMS_PARM_01",a2)	combined.txt
10738	CS	1	\N	ASL Contrast technique	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",a3)	combined.txt
10739	LO	1	\N	Detailed text for ASL labeling technique	\N	R	\N	f	\N	(0043,"GEMS_PARM_01",a4)	combined.txt
10740	IS	1	\N	Duration of the label or control pulse	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",a5)	combined.txt
10741	DS	1	\N	Offset frequency value for FastB1map	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",a6)	combined.txt
10742	DS	1	\N	Motion Encoding Factor	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",a7)	combined.txt
10743	DS	3	\N	"Dual Drive Mode, Amplitude Attentuation and Phase Offset"	\N	K	\N	f	\N	(0043,"GEMS_PARM_01",a8)	combined.txt
10745	DS	1	\N	Delta start time [msec]	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",1e)	combined.txt
10746	US	1	\N	Infant Indicator	\N	X	\N	f	\N	(0043,"GE_YMS_NJ001",35)	combined.txt
10747	CS	1	\N	Gantry Type	\N	R	\N	f	\N	(0043,"GE_YMS_NJ001",37)	combined.txt
10748	SH	1	\N	Raw data ID	\N	X	\N	f	\N	(0043,"GE_YMS_NJ001",38)	combined.txt
10749	IS	1	\N	Reconstruction Matrix	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",39)	combined.txt
10750	CS	1-n	\N	Image Filter	\N	R	\N	f	\N	(0043,"GE_YMS_NJ001",40)	combined.txt
10751	US	1	\N	Prospective Addition Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",41)	combined.txt
10752	US	1	\N	Motion Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",43)	combined.txt
10753	US	1	\N	Helical Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",44)	combined.txt
10754	US	1	\N	Cine Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",45)	combined.txt
10755	US	1	\N	IBO Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",46)	combined.txt
10756	US	1	\N	BBH Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",47)	combined.txt
10757	US	1	\N	Advanced Noise Reduction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",48)	combined.txt
10758	US	1	\N	Scatter Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",49)	combined.txt
10759	DS	3	\N	Recon Center Coordinates	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",4a)	combined.txt
10760	US	1	\N	Cross-Talk Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",50)	combined.txt
10761	US	1	\N	Q-Cal Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",51)	combined.txt
10762	US	1	\N	Afterglow Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",52)	combined.txt
10763	US	1	\N	Local Decon Correction Indicator	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",53)	combined.txt
10764	DS	1	\N	Scan Start location	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",54)	combined.txt
10765	DS	1	\N	Scan End location	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",55)	combined.txt
10766	IS	1	\N	Detector Row	\N	KB	\N	f	\N	(0043,"GE_YMS_NJ001",56)	combined.txt
10767	CS	1	\N	Tube Focus	\N	R	\N	f	\N	(0043,"GE_YMS_NJ001",57)	combined.txt
8979	FL	1-n	\N	Detector View Angle	\N	K	\N	f	\N	(0043,"SIEMENS MED NM",01)	combined.txt
8980	FD	1-16	\N	Transformation Matrix	\N	K	\N	f	\N	(0043,"SIEMENS MED NM",02)	combined.txt
8981	FL	1-n	\N	View Dependent Y shift MHR for Detector 1	\N	K	\N	f	\N	(0043,"SIEMENS MED NM",03)	combined.txt
8982	FL	1-n	\N	View Dependent Y shift MHR for Detector 2	\N	K	\N	f	\N	(0043,"SIEMENS MED NM",04)	combined.txt
4034	SS	1	\N	Number of Macro Rows in Detector	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",01)	combined.txt
4035	FL	1	\N	Macro width at ISO Center	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",02)	combined.txt
4036	SS	1	\N	DAS type	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",03)	combined.txt
4037	SS	1	\N	DAS gain	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",04)	combined.txt
4038	SS	1	\N	DAS Temprature	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",05)	combined.txt
4039	CS	1	\N	Table Direction	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",06)	combined.txt
4040	FL	1	\N	Z smoothing Factor	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",07)	combined.txt
4041	SS	1	\N	View Weighting Mode	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",08)	combined.txt
4042	SS	1	\N	Sigma Row number	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",09)	combined.txt
4043	FL	1	\N	Minimum DAS value	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0a)	combined.txt
4044	FL	1	\N	Maximum Offset Value	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0b)	combined.txt
4045	SS	1	\N	Number of Views shifted	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0c)	combined.txt
4046	SS	1	\N	Z tracking Flag	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0d)	combined.txt
4047	FL	1	\N	Mean Z error	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0e)	combined.txt
4048	FL	1	\N	Z tracking Error	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",0f)	combined.txt
4049	SS	1	\N	Start View 2A	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",10)	combined.txt
4050	SS	1	\N	Number of Views 2A	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",11)	combined.txt
4051	SS	1	\N	Start View 1A	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",12)	combined.txt
4052	SS	1	\N	Sigma Mode	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",13)	combined.txt
4053	SS	1	\N	Number of Views 1A	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",14)	combined.txt
4054	SS	1	\N	Start View 2B	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",15)	combined.txt
4055	SS	1	\N	Number Views 2B	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",16)	combined.txt
4056	SS	1	\N	Start View 1B	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",17)	combined.txt
4057	SS	1	\N	Number of Views 1B	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",18)	combined.txt
10768	SS	1	\N	Air Calibration Time	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1a)	combined.txt
10769	SS	1	\N	Phantom Calibration Date	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1b)	combined.txt
10770	SS	1	\N	Phantom Calibration Time	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1c)	combined.txt
10771	SS	1	\N	Z Slope Calibration Date	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1d)	combined.txt
10772	SS	1	\N	Z Slope Calibration Time	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1e)	combined.txt
10773	SS	1	\N	Cross Talk Calibration Date	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",1f)	combined.txt
10774	SS	1	\N	Cross Talk Calibration Time	\N	X	\N	f	\N	(0045,"GEMS_HELIOS_01",20)	combined.txt
4058	SS	1	\N	Iterbone Flag	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",21)	combined.txt
4059	SS	1	\N	Perisstaltic Flag	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",22)	combined.txt
4060	CS	1	\N	CardiacReconAlgorithm	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",30)	combined.txt
4061	CS	1	\N	AvgHeartRateForImage	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",31)	combined.txt
4062	FL	1	\N	TemporalResolution	\N	KB	\N	f	\N	(0045,"GEMS_HELIOS_01",32)	combined.txt
4063	CS	1	\N	PctRpeakDelay	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",33)	combined.txt
10775	CS	1	\N	ActualPctRpeakDelay	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",34)	combined.txt
4064	CS	1	\N	EkgFullMaStartPhase	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",36)	combined.txt
4065	CS	1	\N	EkgFullMaEndPhase	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",37)	combined.txt
4066	CS	1	\N	EkgModulationMaxMa	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",38)	combined.txt
4067	CS	1	\N	EkgModulationMinMa	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",39)	combined.txt
4068	LO	1	\N	Noise ReductionImageFilterDesc	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",3b)	combined.txt
10776	IS	1	\N	RPeakTimeDelay	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",3f)	combined.txt
10777	IS	1	\N	ActualRPeakTimeDelay	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",44)	combined.txt
10778	ST	1	\N	CardiacScanOption	\N	R	\N	f	\N	(0045,"GEMS_HELIOS_01",45)	combined.txt
8983	LO	1-n	\N	Planar Processing String	\N	K	\N	f	\N	(0045,"SIEMENS MED NM",01)	combined.txt
4099	SQ	1	\N	CT Cardiac Sequence	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",01)	combined.txt
4100	CS	1	\N	HeartRateAtConfirm	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",02)	combined.txt
4101	FL	1	\N	AvgHeartRatePriorToConfirm	\N	KB	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",03)	combined.txt
4102	CS	1	\N	MinHeartRatePriorToConfirm	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",04)	combined.txt
4103	CS	1	\N	MaxHeartRatePriorToConfirm	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",05)	combined.txt
4104	FL	1	\N	StdDevHeartRate PriorToConfirm	\N	KB	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",06)	combined.txt
4105	US	1	\N	NumHeartRateSamples PriorToConfirm	\N	KB	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",07)	combined.txt
4106	CS	1	\N	AutoHeartRateDetectPredict	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",08)	combined.txt
4107	CS	1	\N	SystemOptimizedHeartRate	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",09)	combined.txt
4108	ST	1	\N	EkgMonitorType	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",0a)	combined.txt
4109	CS	1	\N	NumReconSectors	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",0b)	combined.txt
4110	FL	1-256	\N	RpeakTimeStamps	\N	KB	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",0c)	combined.txt
10779	SH	1	\N	EkgGatingType	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",16)	combined.txt
10780	FL	1	\N	Ekg Wave Time Off First Data Point	\N	KB	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",1b)	combined.txt
10781	CS	1	\N	TemporalAlg	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",22)	combined.txt
10782	CS	1	\N	PhaseLocation	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",23)	combined.txt
10783	OW	1	\N	PreBlendedCycle1	\N	X	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",24)	combined.txt
10784	OW	1	\N	PreBlendedCycle2	\N	X	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",25)	combined.txt
10785	CS	1	\N	CompressionAlg	\N	R	\N	f	\N	(0049,"GEMS_CT_CARDIAC_001",26)	combined.txt
10786	DS	1-n	\N	Beam Thickness	\N	KB	\N	f	\N	(004b,"GEMS_HINO_CT_01",01)	combined.txt
10787	DS	1-n	\N	R Time	\N	R	\N	f	\N	(004b,"GEMS_HINO_CT_01",02)	combined.txt
10788	IS	1	\N	HBC number	\N	R	\N	f	\N	(004b,"GEMS_HINO_CT_01",03)	combined.txt
10789	DS	1-n	\N	Beam Thickness	\N	KB	\N	f	\N	(004b,"GE_YMS_NJ001",01)	combined.txt
10790	DS	1-n	\N	R Time	\N	R	\N	f	\N	(004b,"GE_YMS_NJ001",02)	combined.txt
10791	IS	1	\N	HBC number	\N	R	\N	f	\N	(004b,"GE_YMS_NJ001",03)	combined.txt
10792	SQ	1	\N	CTVESSequence	\N	X	\N	f	\N	(0051,"GEHC_CT_ADVAPP_001",01)	combined.txt
4637	LO	1	\N	Functional Proc Group Name	\N	R	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",01)	combined.txt
4638	LO	1	\N	Functional Processing Name	\N	R	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",02)	combined.txt
4639	SL	1	\N	Bias of Functional Image	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",03)	combined.txt
4640	FL	1	\N	Scale of Functional Image	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",04)	combined.txt
4641	SL	1	\N	Length of Parameters String	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",05)	combined.txt
4642	LT	1	\N	"Store Parameters string, delimited by character ESC=0x1b (27)"	\N	R	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",06)	combined.txt
4643	LO	1	\N	Functional Image Version	\N	R	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",07)	combined.txt
4644	SL	1	\N	Store Color Ramp	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",08)	combined.txt
4645	SL	1	\N	Store Width of Functional Image	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",09)	combined.txt
4646	SL	1	\N	Store level of Functional Image	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",0a)	combined.txt
4647	FL	1	\N	Store B-Value with Functional Image	\N	K	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",0b)	combined.txt
4648	LO	1	\N	Analysis Package	\N	R	\N	f	\N	(0051,"GEMS_FUNCTOOL_01",0c)	combined.txt
10793	FL	1-n	\N	MultiEnergyNoiseRedBlendingFact	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",01)	combined.txt
10794	FL	1-n	\N	MultiEnergyNoiseRedScaleFact	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",02)	combined.txt
10795	IS	2	\N	MultiEnergyMDTransformEnergies	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",03)	combined.txt
4530	IS	1	\N	ShuttleFlag	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",20)	combined.txt
10796	IS	1	\N	TableSpeedNotReachesTargetFlag	\N	K	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",21)	combined.txt
4531	SH	1	\N	IterativeReconAnnotation	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",40)	combined.txt
4532	SH	1	\N	IterativeReconMode	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",41)	combined.txt
4533	LO	1	\N	IterativeReconConfiguration	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",42)	combined.txt
4534	SH	1	\N	IterativeReconLevel	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",43)	combined.txt
4535	SH	1	\N	ReconFlipRotateAnno	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",60)	combined.txt
4536	SH	1	\N	hiResolutionFlag	HiResMod	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",61)	combined.txt
4537	SH	1	\N	RespiratoryFlag	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",62)	combined.txt
10797	CS	1	\N	Image Position Patient Setting	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",63)	combined.txt
10798	IS	1	\N	Shutter Mode	\N	K	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",64)	combined.txt
10799	IS	1	\N	Shutter Mode Percent	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",65)	combined.txt
10800	LO	1	\N	Image Browser Annotation	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",66)	combined.txt
10801	IS	1	\N	Overlapped Recon Flag	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",67)	combined.txt
10802	IS	1	\N	Row Number Anotation Flag	\N	K	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",68)	combined.txt
10803	IS	1	\N	MultiEnergySourceCount	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",70)	combined.txt
10804	LO	1	\N	MultiEnergyScanType	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",71)	combined.txt
10805	LO	1	\N	MultiEnergyReconType	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",72)	combined.txt
10806	LO	1	\N	MultiEnergyImageType	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",73)	combined.txt
10807	LO	1	\N	MultiEnergyMaterialType	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",74)	combined.txt
10808	DS	1	\N	MonchromaticEnergy	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",75)	combined.txt
10809	DS	1	\N	multiEnergyWeightedSubractionWidth1	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",76)	combined.txt
10810	DS	1	\N	MultiEnergyWeightedSubractionWidth2	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",77)	combined.txt
10811	LO	1	\N	MultiEnergyWeightedSubtractionType	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",78)	combined.txt
10812	LO	1	\N	MultiEnergyAcqMethod	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",79)	combined.txt
10813	SH	1	\N	MultiEnergyFeatAnnotName	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",7a)	combined.txt
10814	SH	1	\N	MultiEnergyNoiseReduced	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",7b)	combined.txt
10815	LO	1	\N	MultiEnergyNoiseReducdeMethod	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",7c)	combined.txt
10816	LO	1	\N	SubOptimalIQString	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",7d)	combined.txt
10817	DS	1	\N	MultiEnergyHighLowRatio	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",7e)	combined.txt
10818	DS	1	\N	AnnotationmA	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",83)	combined.txt
10819	DS	1	\N	CommandedFirstkVp	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",84)	combined.txt
10820	DS	1	\N	CommandedFirstmA	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",85)	combined.txt
10821	DS	1	\N	CommandedSecondkVp	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",86)	combined.txt
10822	DS	1	\N	CommandedSecondmA	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",87)	combined.txt
10823	SH	1	\N	MultiEnergyKVAnnotName	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",88)	combined.txt
10824	SH	1	\N	MultiEnergyKVUnitLabel	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",89)	combined.txt
10825	LO	1	\N	MaterialType#1	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8a)	combined.txt
10826	LO	1	\N	MaterialType#2	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8b)	combined.txt
10827	LO	1	\N	GSIScanModePreset	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8c)	combined.txt
10828	IS	1	\N	MonoWindowLow	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8d)	combined.txt
10829	IS	1	\N	MonoWindoHigh	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8e)	combined.txt
10830	FL	1-143	\N	MD1AttenuationCurve	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",8f)	combined.txt
10831	DS	1	\N	MD1intercept	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",92)	combined.txt
10832	DS	1	\N	MD1slope	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",93)	combined.txt
10833	OW	1	\N	MD1supportData	\N	X	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",95)	combined.txt
10834	OW	1	\N	MD2supportData	\N	X	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",96)	combined.txt
10835	OW	1	\N	NM1data	\N	X	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",97)	combined.txt
10836	DS	1	\N	MD2intercept	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",98)	combined.txt
10837	DS	1	\N	MD2slope	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",99)	combined.txt
10838	OW	1	\N	NM2data	\N	X	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9a)	combined.txt
10839	FL	1-143	\N	MD2attenuationCurve	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9b)	combined.txt
10840	SH	1	\N	GSIdataVersion	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9c)	combined.txt
4538	LO	1	\N	MARsAnnotation	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9d)	combined.txt
10841	IS	1	\N	MultiEnergyNumNoiseRedPair	\N	KB	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9e)	combined.txt
10842	LO	1-n	\N	MultiEnergyNoiseRedPairString	\N	R	\N	f	\N	(0053,"GEHC_CT_ADVAPP_001",9f)	combined.txt
8993	SS	1	\N	Prompt window width	\N	K	\N	f	\N	(0055,"SIEMENS MED NM",04)	combined.txt
8994	SS	1	\N	Random window width	\N	K	\N	f	\N	(0055,"SIEMENS MED NM",05)	combined.txt
9012	FL	1-n	\N	Collimator thickness	\N	K	\N	f	\N	(0055,"SIEMENS MED NM",7e)	combined.txt
9013	FL	1-n	\N	Collimator angular resolution	\N	K	\N	f	\N	(0055,"SIEMENS MED NM",7f)	combined.txt
9015	SS	1-n	\N	Useful Field of View	\N	K	\N	f	\N	(0055,"SIEMENS MED NM",c0)	combined.txt
9021	LO	1	\N	syngo MI DICOM original image type	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",01)	combined.txt
9022	FL	1	\N	Dose calibration factor	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",02)	combined.txt
9023	LO	1	\N	Units	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",03)	combined.txt
9024	LO	1	\N	Decay correction	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",04)	combined.txt
9025	SL	n	\N	Radio nuclide half life	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",05)	combined.txt
9026	FL	1	\N	Rescale intercept	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",06)	combined.txt
9027	FL	1	\N	Rescale Slope	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",07)	combined.txt
9028	FL	1	\N	Frame reference time	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",08)	combined.txt
9029	SL	1	\N	Number of Radiopharmaceutical information seq	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",09)	combined.txt
9030	FL	1	\N	Decay factor	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",0a)	combined.txt
9031	LO	1	\N	Counts source	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",0b)	combined.txt
9032	SL	n	\N	Radio Nuclide positron fraction	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",0c)	combined.txt
9033	US	1-n	\N	Trigger Time of CT Slice	\N	K	\N	f	\N	(0057,"SIEMENS MED NM",0e)	combined.txt
9034	FL	1-n	\N	X Principal Ray Offset	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",01)	combined.txt
9035	FL	1-n	\N	Y Principal Ray Offset	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",05)	combined.txt
9036	FL	1-n	\N	X Principal Ray Angle	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",09)	combined.txt
9037	FL	1-n	\N	Y Principal Ray Angle	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0a)	combined.txt
9038	FL	1-n	\N	X Short Focal Length	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0b)	combined.txt
9039	FL	1-n	\N	Y Short Focal Length	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0c)	combined.txt
9040	FL	1-n	\N	X Long Focal Length	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0d)	combined.txt
9041	FL	1-n	\N	Y Long Focal Length	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0e)	combined.txt
9042	FL	1-n	\N	X Focal Scaling	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",0f)	combined.txt
9043	FL	1-n	\N	Y Focal Scaling	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",10)	combined.txt
9044	FL	1-n	\N	X Motion Correction Shift	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",11)	combined.txt
9045	FL	1-n	\N	Y Motion Correction Shift	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",15)	combined.txt
9046	FL	1	\N	X Heart Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",19)	combined.txt
9047	FL	1	\N	Y Heart Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",1a)	combined.txt
9048	FL	1	\N	Z Heart Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",1b)	combined.txt
9049	LO	1	\N	Image Pixel Content Type	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",1c)	combined.txt
9050	SS	1	\N	Auto Save Corrected Series	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",1d)	combined.txt
9051	LT	1	\N	Distorted Series Instance UID	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",1e)	combined.txt
9052	SS	1-n	\N	Recon Range	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",21)	combined.txt
9053	LO	1	\N	Recon Orientation	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",22)	combined.txt
9054	FL	1-n	\N	Recon Selected Angular Range	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",23)	combined.txt
9055	FL	1	\N	Recon Transverse Angle	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",24)	combined.txt
9056	FL	1	\N	Recon Sagittal Angle	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",25)	combined.txt
9057	FL	1	\N	Recon X Mask Size	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",26)	combined.txt
9058	FL	1	\N	Recon Y Mask Size	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",27)	combined.txt
9059	FL	1	\N	Recon X Image Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",28)	combined.txt
9060	FL	1	\N	Recon Y Image Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",29)	combined.txt
9061	FL	1	\N	Recon Z Image Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2a)	combined.txt
9062	FL	1	\N	Recon X Zoom	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2b)	combined.txt
9063	FL	1	\N	Recon Y Zoom	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2c)	combined.txt
9064	FL	1	\N	Recon Threshold	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2d)	combined.txt
9065	FL	1	\N	Recon Output Pixel Size	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2e)	combined.txt
9066	LO	1-n	\N	Scatter Estimation Method	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",2f)	combined.txt
9067	LO	1-n	\N	Scatter Estimation Method Mode	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",30)	combined.txt
9068	FL	1-n	\N	Scatter Estimation Lower Window Weights	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",31)	combined.txt
9069	FL	1-n	\N	Scatter Estimation Upper Window Weights	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",32)	combined.txt
9070	LO	1-n	\N	Scatter Estimation Window Mode	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",33)	combined.txt
9071	LO	1-n	\N	Scatter Estimation Filter	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",34)	combined.txt
9072	LO	1	\N	Recon RawTomo Input Uid	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",35)	combined.txt
9073	LO	1	\N	Recon CT Input Uid	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",36)	combined.txt
9074	FL	1	\N	Recon Z Mask Size	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",37)	combined.txt
9075	FL	1	\N	Recon X Mask Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",38)	combined.txt
9076	FL	1	\N	Recon Y Mask Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",39)	combined.txt
9077	FL	1	\N	Recon Z Mask Center	\N	K	\N	f	\N	(0061,"SIEMENS MED NM",3a)	combined.txt
9078	LT	1	\N	Raw Tomo Series UID	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",51)	combined.txt
9079	LT	1	\N	LowRes CT Series UID	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",52)	combined.txt
9080	LT	1	\N	HighRes CT Series UID	\N	R	\N	f	\N	(0061,"SIEMENS MED NM",53)	combined.txt
10843	FL	1	\N	ForegroundTransparency	\N	K	\N	f	\N	(0071,"MMCPrivate",01)	combined.txt
10844	LO	1	\N	IsDisplayBackgroundImage	\N	K	\N	f	\N	(0071,"MMCPrivate",02)	combined.txt
10845	FL	1	\N	ForegroundHorizontalShift	\N	K	\N	f	\N	(0071,"MMCPrivate",03)	combined.txt
10846	FL	1	\N	ForegroundVerticalShift	\N	K	\N	f	\N	(0071,"MMCPrivate",04)	combined.txt
10847	FL	1	\N	ForegroundRotationAngle	\N	K	\N	f	\N	(0071,"MMCPrivate",05)	combined.txt
10848	FL	1	\N	ForegroundMagnification	\N	K	\N	f	\N	(0071,"MMCPrivate",06)	combined.txt
10849	OB	1	\N	ApplicationData	\N	K	\N	f	\N	(0071,"MMCPrivate",07)	combined.txt
9087	UK	1	\N	Starting Respiratory Amplitude	\N	K	\N	f	\N	(0071,"SIEMENS MED PT WAVEFORM",46)	combined.txt
9088	UK	1	\N	Starting Respiratory Phase	\N	K	\N	f	\N	(0071,"SIEMENS MED PT WAVEFORM",47)	combined.txt
9089	UK	1	\N	Ending Respiratory Amplitude	\N	K	\N	f	\N	(0071,"SIEMENS MED PT WAVEFORM",48)	combined.txt
9090	UK	1	\N	Ending Respiratory Phase	\N	K	\N	f	\N	(0071,"SIEMENS MED PT WAVEFORM",49)	combined.txt
9091	UK	1	\N	Respiratory Trigger Type. Currently always AMPLITUDE	\N	K	\N	f	\N	(0071,"SIEMENS MED PT WAVEFORM",50)	combined.txt
9083	UI	1	\N	Registration Matrix UID Registration matrix between PET and CT	\N	K	\N	f	\N	(0071,"SIEMENS MED PT",21)	combined.txt
9084	DT	1	\N	Decay Correction DateTime The date and time to which the image was decay  corrected	\N	R	\N	f	\N	(0071,"SIEMENS MED PT",22)	combined.txt
3009	DS	1	\N	Dose Length Product (in mGy-cm)	ELSCINT1_DLP_TOTAL	K	\N	f	\N	(00e1,"ELSCINT1",21)	combined.txt
3035	UI	1	\N	PET-CT Multi Modality Name	\N	R	\N	f	\N	(00e1,"ELSCINT1",c2)	combined.txt
10850	SQ	1	\N	PESERParameterSequence	\N	K	\N	f	\N	(0117,"MRSC",10)	combined.txt
10851	CS	1	\N	PESERParameterType	\N	K	\N	f	\N	(0117,"MRSC",12)	combined.txt
10852	LO	1	\N	PESERParameterName	\N	K	\N	f	\N	(0117,"MRSC",14)	combined.txt
10853	LO	1	\N	PESERParameterDescription	\N	K	\N	f	\N	(0117,"MRSC",16)	combined.txt
10854	DS	1-n	\N	PESERParameterFloatingValue	\N	K	\N	f	\N	(0117,"MRSC",18)	combined.txt
10855	IS	1-n	\N	PESERParameterIntegerValue	\N	K	\N	f	\N	(0117,"MRSC",19)	combined.txt
10856	LO	1-n	\N	PESERParameterStringValue	\N	K	\N	f	\N	(0117,"MRSC",1a)	combined.txt
10857	SQ	1	\N	VOISequence	\N	K	\N	f	\N	(0117,"MRSC",20)	combined.txt
10858	SQ	1	\N	OmitVOISequence	\N	K	\N	f	\N	(0117,"MRSC",22)	combined.txt
10859	SQ	1	\N	ImageQualitySequence	\N	K	\N	f	\N	(0117,"MRSC",24)	combined.txt
10860	IS	1	\N	NumberAcquiredTimePoints	\N	K	\N	f	\N	(0117,"MRSC",30)	combined.txt
10861	DS	1	\N	AcquisitionDuration	\N	K	\N	f	\N	(0117,"MRSC",31)	combined.txt
10862	DS	1-n	\N	AcquisitionStartTimes	\N	K	\N	f	\N	(0117,"MRSC",32)	combined.txt
10863	TM	1	\N	InjectionTime	\N	K	\N	f	\N	(0117,"MRSC",33)	combined.txt
10864	DS	1-n	\N	EffectiveAcquisitionDelay	\N	K	\N	f	\N	(0117,"MRSC",34)	combined.txt
10865	IS	3	\N	SERTimingIndices	\N	K	\N	f	\N	(0117,"MRSC",35)	combined.txt
10866	LO	1	\N	AcquisitionTimingMethod	\N	K	\N	f	\N	(0117,"MRSC",3a)	combined.txt
10867	LT	1	\N	AcquisitionTimingComments	\N	K	\N	f	\N	(0117,"MRSC",3b)	combined.txt
10868	IS	1	\N	ROIVOILPSFlag	\N	K	\N	f	\N	(0117,"MRSC",41)	combined.txt
10869	DS	3	\N	VOILPSCenter	\N	K	\N	f	\N	(0117,"MRSC",42)	combined.txt
10870	DS	3	\N	VOILPSWidthHalfLength	\N	K	\N	f	\N	(0117,"MRSC",43)	combined.txt
10871	DS	3	\N	VOILPSHeightHalfLength	\N	K	\N	f	\N	(0117,"MRSC",44)	combined.txt
10872	DS	3	\N	VOILPSDepthHalfLength	\N	K	\N	f	\N	(0117,"MRSC",45)	combined.txt
10873	CS	1	\N	VOILPSType	\N	K	\N	f	\N	(0117,"MRSC",46)	combined.txt
10874	US	3	\N	ProjectedROINPixels	\N	K	\N	f	\N	(0117,"MRSC",50)	combined.txt
10875	IS	1	\N	ProjectedROIProjectionAxis	\N	K	\N	f	\N	(0117,"MRSC",51)	combined.txt
10876	IS	1	\N	ProjectedROITransposeFlag	\N	K	\N	f	\N	(0117,"MRSC",52)	combined.txt
10877	US	1-n	\N	ProjectedROIXVerts	\N	K	\N	f	\N	(0117,"MRSC",53)	combined.txt
10878	US	1-n	\N	ProjectedROIYVerts	\N	K	\N	f	\N	(0117,"MRSC",54)	combined.txt
10879	US	2	\N	ProjectedROIZRange	\N	K	\N	f	\N	(0117,"MRSC",55)	combined.txt
10880	CS	1	\N	ProjectedROIType	\N	K	\N	f	\N	(0117,"MRSC",56)	combined.txt
10881	LO	1	\N	ProjectedROILabel	\N	K	\N	f	\N	(0117,"MRSC",5a)	combined.txt
10882	US	3	\N	FTVPixelLimitsStart	\N	K	\N	f	\N	(0117,"MRSC",a1)	combined.txt
10883	US	3	\N	FTVPixelLimitsEnd	\N	K	\N	f	\N	(0117,"MRSC",a2)	combined.txt
10884	CS	1	\N	FTVBackgroundMethod	\N	K	\N	f	\N	(0117,"MRSC",a3)	combined.txt
10885	DS	1	\N	FTVBackgroundThreshold	\N	K	\N	f	\N	(0117,"MRSC",a4)	combined.txt
10886	SQ	1	\N	FTVSequence	\N	K	\N	f	\N	(0117,"MRSC",b0)	combined.txt
10887	DS	1	\N	FTVSERMinimum	\N	K	\N	f	\N	(0117,"MRSC",b1)	combined.txt
10888	DS	1	\N	FTVSERMaximum	\N	K	\N	f	\N	(0117,"MRSC",b2)	combined.txt
10889	IS	1	\N	FTVPixelCount	\N	K	\N	f	\N	(0117,"MRSC",b3)	combined.txt
10890	DS	1	\N	FTVcc	\N	K	\N	f	\N	(0117,"MRSC",b4)	combined.txt
10891	LO	1	\N	FTVLabel	\N	K	\N	f	\N	(0117,"MRSC",b5)	combined.txt
10892	CS	1	\N	QualityControlType	\N	K	\N	f	\N	(0117,"MRSC",c0)	combined.txt
10893	LO	1	\N	QualityControlFactor	\N	K	\N	f	\N	(0117,"MRSC",c1)	combined.txt
10894	DS	1	\N	QualityControlValue	\N	K	\N	f	\N	(0117,"MRSC",c2)	combined.txt
10895	CS	1	\N	QualityControlMeaning	\N	K	\N	f	\N	(0117,"MRSC",c3)	combined.txt
10896	LT	1	\N	QualityControlComment	\N	K	\N	f	\N	(0117,"MRSC",c4)	combined.txt
10897	CS	1	\N	ProtocolCompliantFlag	\N	K	\N	f	\N	(0117,"MRSC",c5)	combined.txt
10898	LO	1-n	\N	ProtocolNotCompliantReasons	\N	K	\N	f	\N	(0117,"MRSC",c6)	combined.txt
10899	CS	1	\N	ImagesAnalyzable	\N	K	\N	f	\N	(0117,"MRSC",c7)	combined.txt
10900	LO	1-n	\N	ProtocolNotCAnalyzableReasons	\N	K	\N	f	\N	(0117,"MRSC",c8)	combined.txt
10901	DS	1	\N	Version	\N	K	\N	t	10	(0119,"MRSC",1000)	combined.txt
10902	DS	1	\N	MinimumPixelValue	\N	K	\N	t	10	(0119,"MRSC",1006)	combined.txt
10903	DS	1	\N	MaximumPixelValue	\N	K	\N	t	10	(0119,"MRSC",1007)	combined.txt
10904	IS	1	\N	PixelDataType	\N	K	\N	t	10	(0119,"MRSC",1010)	combined.txt
10905	IS	1-n	\N	ImageIDNumbers	\N	K	\N	t	10	(0119,"MRSC",1011)	combined.txt
10906	IS	1-n	\N	ParameterDims	\N	K	\N	t	10	(0119,"MRSC",1012)	combined.txt
10907	CS	1-n	\N	VariableParameter	\N	K	\N	t	10	(0119,"MRSC",1013)	combined.txt
10908	LO	1-n	\N	SourceFileNames	\N	K	\N	t	10	(0119,"MRSC",1020)	combined.txt
10909	IS	1	\N	SourceCropFlag	\N	K	\N	t	10	(0119,"MRSC",1021)	combined.txt
10910	IS	6	\N	SourceCropLimits	\N	K	\N	t	10	(0119,"MRSC",1022)	combined.txt
10911	UI	1-n	\N	SourceFileUIDs	\N	K	\N	t	10	(0119,"MRSC",1023)	combined.txt
10912	IS	1-n	\N	SourceVolumeIndices	\N	K	\N	t	10	(0119,"MRSC",1024)	combined.txt
10913	LO	1-n	\N	SourceVolumeLabels	\N	K	\N	t	10	(0119,"MRSC",1025)	combined.txt
10914	DS	9	\N	DirectionCosines	\N	K	\N	t	10	(0119,"MRSC",1030)	combined.txt
10915	CS	3	\N	PatientOrientation3	\N	K	\N	t	10	(0119,"MRSC",1031)	combined.txt
10916	DS	1-n	\N	SlicePosition	\N	K	\N	t	10	(0119,"MRSC",1041)	combined.txt
10917	LO	1-n	\N	VolumeLabels	\N	K	\N	t	10	(0119,"MRSC",1050)	combined.txt
10918	DA	1-n	\N	AcquisitionDate	\N	K	\N	t	10	(0119,"MRSC",1051)	combined.txt
10919	LO	1	\N	SecCptrUser	\N	K	\N	t	10	(0119,"MRSC",1060)	combined.txt
10920	LO	1	\N	SecCptrApplication	\N	K	\N	t	10	(0119,"MRSC",1061)	combined.txt
10921	AT	1-n	\N	VariableParamTags	\N	K	\N	t	10	(0119,"MRSC",1070)	combined.txt
10922	CS	1-n	\N	VariableParamNames	\N	K	\N	t	10	(0119,"MRSC",1071)	combined.txt
10923	DS	1-n	\N	TR	\N	K	\N	t	10	(0119,"MRSC",1080)	combined.txt
10924	DS	1-n	\N	TE	\N	K	\N	t	10	(0119,"MRSC",1081)	combined.txt
10925	DS	1-n	\N	DIFF_GRAD_X	\N	K	\N	t	10	(0119,"MRSC",10a0)	combined.txt
10926	DS	1-n	\N	DIFF_GRAD_Y	\N	K	\N	t	10	(0119,"MRSC",10a1)	combined.txt
10927	DS	1-n	\N	DIFF_GRAD_Z	\N	K	\N	t	10	(0119,"MRSC",10a2)	combined.txt
10928	DS	1-n	\N	DIFF_PW_X	\N	K	\N	t	10	(0119,"MRSC",10a3)	combined.txt
10929	DS	1-n	\N	DIFF_PW_Y	\N	K	\N	t	10	(0119,"MRSC",10a4)	combined.txt
10930	DS	1-n	\N	DIFF_PW_Z	\N	K	\N	t	10	(0119,"MRSC",10a5)	combined.txt
10931	DS	1-n	\N	DIFF_TIME_X	\N	K	\N	t	10	(0119,"MRSC",10a6)	combined.txt
10932	DS	1-n	\N	DIFF_TIME_Y	\N	K	\N	t	10	(0119,"MRSC",10a7)	combined.txt
10933	DS	1-n	\N	DIFF_TIME_Z	\N	K	\N	t	10	(0119,"MRSC",10a8)	combined.txt
10934	DS	1-n	\N	DiffBValues	\N	K	\N	t	10	(0119,"MRSC",10a9)	combined.txt
10935	LO	1	\N	CoilCorrectionMethod	\N	K	\N	t	10	(0119,"MRSC",10b0)	combined.txt
10936	IS	1	\N	PolyFitOrder	\N	K	\N	t	10	(0119,"MRSC",10b1)	combined.txt
10937	DS	1-n	\N	PolyFitCoeff	\N	K	\N	t	10	(0119,"MRSC",10b2)	combined.txt
10938	DS	1	\N	FitMapModuleVersion	\N	K	\N	t	11	(0119,"MRSC",1100)	combined.txt
10939	LO	1-n	\N	SourceFileNames	\N	K	\N	t	11	(0119,"MRSC",1101)	combined.txt
10940	IS	1-n	\N	SourceVolumeIndices	\N	K	\N	t	11	(0119,"MRSC",1102)	combined.txt
10941	DS	1-n	\N	ParameterValues	\N	K	\N	t	11	(0119,"MRSC",1103)	combined.txt
10942	AT	1	\N	ParameterTag	\N	K	\N	t	11	(0119,"MRSC",1104)	combined.txt
10943	UI	1-n	\N	SourceFileUIDs	\N	K	\N	t	11	(0119,"MRSC",1105)	combined.txt
10944	LO	1-n	\N	SourceFileDirectory	\N	K	\N	t	11	(0119,"MRSC",1106)	combined.txt
10945	IS	1	\N	SourceDataInPlaceFlag	\N	K	\N	t	11	(0119,"MRSC",1107)	combined.txt
10946	IS	1-n	\N	ResultVolumeindices	\N	K	\N	t	11	(0119,"MRSC",1108)	combined.txt
10947	IS	1	\N	SMOOTHBoxcarAverageKernel	\N	K	\N	t	11	(0119,"MRSC",1109)	combined.txt
10948	LO	1	\N	FitICFunction	\N	K	\N	t	11	(0119,"MRSC",110c)	combined.txt
10949	LO	1	\N	FitFormulaProcedure	\N	K	\N	t	11	(0119,"MRSC",110d)	combined.txt
10950	LO	1	\N	FittingProgram	\N	K	\N	t	11	(0119,"MRSC",110e)	combined.txt
10951	IS	1	\N	FittingProgramVersion	\N	K	\N	t	11	(0119,"MRSC",110f)	combined.txt
10952	CS	1	\N	FitType	\N	K	\N	t	11	(0119,"MRSC",1110)	combined.txt
10953	IS	1	\N	SetICFlag	\N	K	\N	t	11	(0119,"MRSC",1111)	combined.txt
10954	DS	1-n	\N	InitialConditions	\N	K	\N	t	11	(0119,"MRSC",1112)	combined.txt
10955	DS	1-n	\N	FitMapScaleFactors	\N	K	\N	t	11	(0119,"MRSC",1113)	combined.txt
10956	IS	1	\N	ThresholdingFlag	\N	K	\N	t	11	(0119,"MRSC",1120)	combined.txt
10957	DS	1	\N	Threshold	\N	K	\N	t	11	(0119,"MRSC",1121)	combined.txt
10958	IS	1	\N	MaskCompression	\N	K	\N	t	11	(0119,"MRSC",1122)	combined.txt
10959	OB	1-n	\N	FitMapMask	\N	K	\N	t	11	(0119,"MRSC",1123)	combined.txt
10960	OB	1-n	\N	FitMapPntThreshMap	\N	K	\N	t	11	(0119,"MRSC",1124)	combined.txt
10961	ST	1	\N	PixelMaskCheckString	\N	K	\N	t	11	(0119,"MRSC",1125)	combined.txt
10962	ST	1	\N	PixelMaskSource	\N	K	\N	t	11	(0119,"MRSC",1126)	combined.txt
10963	DS	1-n	\N	UpperFitLimit	\N	K	\N	t	11	(0119,"MRSC",1130)	combined.txt
10964	DS	1-n	\N	LowerFitLimit	\N	K	\N	t	11	(0119,"MRSC",1131)	combined.txt
10965	LO	1	\N	GradientMatrixMethod	\N	K	\N	t	11	(0119,"MRSC",1140)	combined.txt
10966	DS	1-n	\N	GradientMatrix	\N	K	\N	t	11	(0119,"MRSC",1141)	combined.txt
10967	SQ	1	\N	FitMapSQ	\N	K	\N	t	11	(0119,"MRSC",1180)	combined.txt
10968	IS	1	\N	fmSQFitNumber	\N	K	\N	t	11	(0119,"MRSC",1181)	combined.txt
10969	CS	1	\N	PhantCalibType	\N	K	\N	t	11	(0119,"MRSC",11a0)	combined.txt
10970	IS	1	\N	PhantCalibNParms	\N	K	\N	t	11	(0119,"MRSC",11a1)	combined.txt
10971	DS	1-n	\N	PhantCalibParam	\N	K	\N	t	11	(0119,"MRSC",11a2)	combined.txt
10972	IS	1-n	\N	PhantGoodFlags	\N	K	\N	t	11	(0119,"MRSC",11a3)	combined.txt
10973	DS	1-n	\N	PhantValues	\N	K	\N	t	11	(0119,"MRSC",11a4)	combined.txt
10974	DS	1-n	\N	PhantRefValues	\N	K	\N	t	11	(0119,"MRSC",11a5)	combined.txt
10975	IS	1-n	\N	ImageProcessStatus	\N	K	\N	t	12	(0119,"MRSC",1200)	combined.txt
10976	LO	1	\N	SourceID	\N	K	\N	t	12	(0119,"MRSC",1201)	combined.txt
10977	IS	1	\N	Group Version	\N	K	\N	t	12	(0119,"MRSC",1202)	combined.txt
10978	IS	1	\N	ExecuteOnRead	\N	K	\N	t	12	(0119,"MRSC",1203)	combined.txt
10979	IS	1	\N	NumberPasses	\N	K	\N	t	12	(0119,"MRSC",1204)	combined.txt
10980	IS	1-n	\N	NumProcesses	\N	K	\N	t	12	(0119,"MRSC",1206)	combined.txt
10981	IS	1-n	\N	GroupExecuteOrder	\N	K	\N	t	12	(0119,"MRSC",1208)	combined.txt
10982	IS	1	\N	NumberTransforms	\N	K	\N	t	12	(0119,"MRSC",120a)	combined.txt
10983	IS	1-n	\N	NumberProcesses	\N	K	\N	t	12	(0119,"MRSC",120b)	combined.txt
10984	IS	1-n	\N	InvertImage	\N	K	\N	t	12	(0119,"MRSC",1211)	combined.txt
10985	IS	1-n	\N	SkeletonizeImage	\N	K	\N	t	12	(0119,"MRSC",1212)	combined.txt
10986	IS	1-n	\N	IsotropicResolution	\N	K	\N	t	12	(0119,"MRSC",1213)	combined.txt
10987	IS	1-n	\N	MedianFilterKernel	\N	K	\N	t	12	(0119,"MRSC",1220)	combined.txt
10988	DS	1-n	\N	BackgroundCorrection	\N	K	\N	t	12	(0119,"MRSC",1221)	combined.txt
10989	DS	1-n	\N	UnSharpMasking	\N	K	\N	t	12	(0119,"MRSC",1222)	combined.txt
10990	IS	1-n	\N	LocalThresholdKernel	\N	K	\N	t	12	(0119,"MRSC",1223)	combined.txt
10991	IS	1-n	\N	AbsoluteLimits	\N	K	\N	t	12	(0119,"MRSC",1224)	combined.txt
10992	DS	1-n	\N	PercentileLimits	\N	K	\N	t	12	(0119,"MRSC",1225)	combined.txt
10993	DS	1-n	\N	InPlaneRotation	\N	K	\N	t	12	(0119,"MRSC",1226)	combined.txt
10994	IS	1-n	\N	ReSample	\N	K	\N	t	12	(0119,"MRSC",1230)	combined.txt
10995	IS	1-n	\N	OrthogonalReFormat	\N	K	\N	t	12	(0119,"MRSC",1231)	combined.txt
10996	IS	1	\N	LPCCVersion	\N	K	\N	t	12	(0119,"MRSC",1240)	combined.txt
10997	LO	1	\N	LPCCFilename	\N	K	\N	t	12	(0119,"MRSC",1241)	combined.txt
10998	IS	1	\N	LPCCFilter_type	\N	K	\N	t	12	(0119,"MRSC",1250)	combined.txt
10999	DS	1	\N	LPCCMean_Multiplier	\N	K	\N	t	12	(0119,"MRSC",1251)	combined.txt
11000	DS	1	\N	SACoilCorrectionIncrement	\N	K	\N	t	12	(0119,"MRSC",1260)	combined.txt
11001	IS	1	\N	SACoilCorrectionVersion	\N	K	\N	t	12	(0119,"MRSC",1261)	combined.txt
11002	DS	1	\N	SACoilCorrectionParams_Angle_deg	\N	K	\N	t	12	(0119,"MRSC",1270)	combined.txt
11003	DS	1	\N	SACoilCorrectionParams_Offset_in	\N	K	\N	t	12	(0119,"MRSC",1271)	combined.txt
11004	LO	1	\N	MinVarFiltSid	\N	K	\N	t	12	(0119,"MRSC",12a0)	combined.txt
11005	LO	1	\N	MinVarFiltPath	\N	K	\N	t	12	(0119,"MRSC",12a1)	combined.txt
11006	IS	1	\N	MinVarFiltMax_images	\N	K	\N	t	12	(0119,"MRSC",12a2)	combined.txt
11007	IS	2	\N	MinVarFiltId_locs	\N	K	\N	t	12	(0119,"MRSC",12a3)	combined.txt
11008	LO	1	\N	MinVarFiltScript_name	\N	K	\N	t	12	(0119,"MRSC",12a4)	combined.txt
11009	IS	1	\N	MinVarFiltSave_masks	\N	K	\N	t	12	(0119,"MRSC",12a5)	combined.txt
11010	IS	1	\N	MinVarFiltSave_idf	\N	K	\N	t	12	(0119,"MRSC",12a6)	combined.txt
11011	LO	1	\N	MinVarFiltMask	\N	K	\N	t	12	(0119,"MRSC",12a7)	combined.txt
11012	LO	1	\N	MinVarFiltIdfmask	\N	K	\N	t	12	(0119,"MRSC",12a8)	combined.txt
11013	LO	1	\N	MinVarFiltImage	\N	K	\N	t	12	(0119,"MRSC",12a9)	combined.txt
11014	IS	1	\N	MinVarFiltOutput_type	\N	K	\N	t	12	(0119,"MRSC",12b0)	combined.txt
11015	IS	1	\N	MinVarFiltOutput_ftype	\N	K	\N	t	12	(0119,"MRSC",12b1)	combined.txt
11016	LO	1	\N	MinVarFiltScaling	\N	K	\N	t	12	(0119,"MRSC",12b2)	combined.txt
11017	UI	1	\N	SERMaskFileUID	\N	K	\N	f	\N	(0119,"MRSC",14)	combined.txt
11018	LO	1	\N	MIPsSid	\N	K	\N	t	14	(0119,"MRSC",1400)	combined.txt
11019	UI	1	\N	MIPsUID	\N	K	\N	t	14	(0119,"MRSC",1401)	combined.txt
11020	TM	1	\N	MIPsTime	\N	K	\N	t	14	(0119,"MRSC",1402)	combined.txt
11021	DA	1	\N	MIPsDate	\N	K	\N	t	14	(0119,"MRSC",1403)	combined.txt
11022	IS	1	\N	MIPsVersion	\N	K	\N	t	14	(0119,"MRSC",1404)	combined.txt
11023	IS	1	\N	MIPsVolume	\N	K	\N	t	14	(0119,"MRSC",1405)	combined.txt
11024	IS	1	\N	MIPsOrtho	\N	K	\N	t	14	(0119,"MRSC",1406)	combined.txt
11025	IS	1	\N	MIPsMaskedFlag	\N	K	\N	t	14	(0119,"MRSC",1407)	combined.txt
11026	IS	1	\N	MIPsSubtractVolume	\N	K	\N	t	14	(0119,"MRSC",1408)	combined.txt
11027	UL	1-n	\N	MIPsProtectPixels	\N	K	\N	t	14	(0119,"MRSC",1410)	combined.txt
11028	UL	1-n	\N	MIPsIgnorePixels	\N	K	\N	t	14	(0119,"MRSC",1411)	combined.txt
11029	IS	1	\N	MIPsProjectFlag	\N	K	\N	t	14	(0119,"MRSC",1412)	combined.txt
11030	IS	1-n	\N	MIPsProjectPlaneIndices	\N	K	\N	t	14	(0119,"MRSC",1413)	combined.txt
11031	LO	1	\N	SERSid	\N	K	\N	t	15	(0119,"MRSC",1500)	combined.txt
11032	UI	1	\N	SERUID	\N	K	\N	t	15	(0119,"MRSC",1501)	combined.txt
11033	TM	1	\N	SERTime	\N	K	\N	t	15	(0119,"MRSC",1502)	combined.txt
11034	DA	1	\N	SERDate	\N	K	\N	t	15	(0119,"MRSC",1503)	combined.txt
11035	IS	1	\N	SERVersion	\N	K	\N	t	15	(0119,"MRSC",1504)	combined.txt
11036	IS	3	\N	SERTimePoints	\N	K	\N	t	15	(0119,"MRSC",1505)	combined.txt
11037	IS	1	\N	SERByteScaled	\N	K	\N	t	15	(0119,"MRSC",1506)	combined.txt
11038	DS	1	\N	SERBackground	\N	K	\N	t	15	(0119,"MRSC",1507)	combined.txt
11039	DS	1	\N	SERThreshold	\N	K	\N	t	15	(0119,"MRSC",1508)	combined.txt
11040	DS	1	\N	SERMaximum	\N	K	\N	t	15	(0119,"MRSC",1509)	combined.txt
11041	IS	1	\N	SERMinConPixels	\N	K	\N	t	15	(0119,"MRSC",150a)	combined.txt
11042	IS	1	\N	SERCorrectFlag	\N	K	\N	t	15	(0119,"MRSC",150b)	combined.txt
11043	DS	2	\N	SERAcqTimes	\N	K	\N	t	15	(0119,"MRSC",150c)	combined.txt
11044	DS	2	\N	SERTargetTimes	\N	K	\N	t	15	(0119,"MRSC",150d)	combined.txt
11045	DS	1	\N	SERTimeTolerance	\N	K	\N	t	15	(0119,"MRSC",150e)	combined.txt
11046	DS	4	\N	SERCorrectionParams	\N	K	\N	t	15	(0119,"MRSC",150f)	combined.txt
11047	LO	1	\N	SERImageType	\N	K	\N	t	15	(0119,"MRSC",1510)	combined.txt
11048	IS	1-n	\N	SEROffsets	\N	K	\N	t	15	(0119,"MRSC",1511)	combined.txt
11049	LO	1	\N	SERMaskFileName	\N	K	\N	t	15	(0119,"MRSC",1512)	combined.txt
11050	DS	1	\N	SERMaskChecksum	\N	K	\N	t	15	(0119,"MRSC",1513)	combined.txt
11051	IS	3	\N	GAINS	\N	K	\N	f	\N	(0119,"MRSC",18)	combined.txt
11052	IS	1-n	\N	ByteScaleMinMaxTop	\N	K	\N	f	\N	(0119,"MRSC",27)	combined.txt
11053	IS	1-n	\N	GlobalThreshold	\N	K	\N	f	\N	(0119,"MRSC",28)	combined.txt
11054	DS	1-n	\N	IntensityScale	\N	K	\N	f	\N	(0119,"MRSC",29)	combined.txt
11055	IS	1-n	\N	REBIN	\N	K	\N	f	\N	(0119,"MRSC",32)	combined.txt
11056	DS	1-n	\N	WhiteTopHat	\N	K	\N	f	\N	(0119,"MRSC",33)	combined.txt
11057	IS	1-n	\N	HistEqual	\N	K	\N	f	\N	(0119,"MRSC",34)	combined.txt
11058	IS	1-n	\N	Crop	\N	K	\N	f	\N	(0119,"MRSC",35)	combined.txt
11059	DS	1-n	\N	LPCoil	\N	K	\N	f	\N	(0119,"MRSC",36)	combined.txt
11060	DS	3	\N	PixelGap	\N	K	\N	f	\N	(0119,"MRSC",38)	combined.txt
11061	DS	1-n	\N	LPCCBandwidth	\N	K	\N	f	\N	(0119,"MRSC",42)	combined.txt
11062	DS	1	\N	LPCCNoise_factor	\N	K	\N	f	\N	(0119,"MRSC",43)	combined.txt
11063	DS	1	\N	LPCCNoise_level	\N	K	\N	f	\N	(0119,"MRSC",44)	combined.txt
11064	IS	1	\N	LPCCNoise_mode	\N	K	\N	f	\N	(0119,"MRSC",45)	combined.txt
11065	IS	1	\N	LPCCDirection	\N	K	\N	f	\N	(0119,"MRSC",46)	combined.txt
11066	IS	1	\N	LPCCEdge_fill	\N	K	\N	f	\N	(0119,"MRSC",47)	combined.txt
11067	IS	1	\N	LPCCMean_fill	\N	K	\N	f	\N	(0119,"MRSC",48)	combined.txt
11068	IS	1	\N	LPCCPixelsearch	\N	K	\N	f	\N	(0119,"MRSC",49)	combined.txt
11069	DS	1	\N	LPCCIntensity_scale	\N	K	\N	f	\N	(0119,"MRSC",4a)	combined.txt
11070	IS	1	\N	LPCCThreed	\N	K	\N	f	\N	(0119,"MRSC",4b)	combined.txt
11071	LO	1	\N	LPCCRoi_mask	\N	K	\N	f	\N	(0119,"MRSC",4c)	combined.txt
11072	IS	2	\N	LPCCMask_slices	\N	K	\N	f	\N	(0119,"MRSC",4d)	combined.txt
11073	IS	1	\N	LPCCSlice_pad	\N	K	\N	f	\N	(0119,"MRSC",4e)	combined.txt
11074	IS	1	\N	LPCCSave_type	\N	K	\N	f	\N	(0119,"MRSC",4f)	combined.txt
11075	TM	1-n	\N	AcquisitionTime	\N	K	\N	f	\N	(0119,"MRSC",52)	combined.txt
11076	DA	1	\N	SACoilCorrectionCorr_date	\N	K	\N	f	\N	(0119,"MRSC",62)	combined.txt
11077	TM	1	\N	SACoilCorrectionCorr_time	\N	K	\N	f	\N	(0119,"MRSC",63)	combined.txt
11078	LO	1	\N	SACoilCorrectionMethod	\N	K	\N	f	\N	(0119,"MRSC",64)	combined.txt
11079	DS	1-n	\N	SACoilCorrectionOrigin	\N	K	\N	f	\N	(0119,"MRSC",65)	combined.txt
11080	DS	1-n	\N	SACoilCorrectionAxis_cos	\N	K	\N	f	\N	(0119,"MRSC",66)	combined.txt
11081	IS	1	\N	SACoilCorrectionNumber	\N	K	\N	f	\N	(0119,"MRSC",67)	combined.txt
11082	LO	1	\N	SACoilCorrectionSid	\N	K	\N	f	\N	(0119,"MRSC",68)	combined.txt
11083	DS	1-n	\N	SACoilCorrectionRange	\N	K	\N	f	\N	(0119,"MRSC",69)	combined.txt
11084	FD	1-n	\N	SACoilCorrectionSa_value	\N	K	\N	f	\N	(0119,"MRSC",6a)	combined.txt
11085	IS	1	\N	SACoilCorrectionAxis_flag	\N	K	\N	f	\N	(0119,"MRSC",6b)	combined.txt
11086	IS	1-n	\N	SACoilCorrectionSample_number	\N	K	\N	f	\N	(0119,"MRSC",6c)	combined.txt
11087	LO	1	\N	SACoilCorrectionParams_SID	\N	K	\N	f	\N	(0119,"MRSC",6d)	combined.txt
11088	IS	1	\N	SACoilCorrectionParams_Version	\N	K	\N	f	\N	(0119,"MRSC",6e)	combined.txt
11089	DS	1	\N	SACoilCorrectionParams_Rot_axis_off	\N	K	\N	f	\N	(0119,"MRSC",6f)	combined.txt
11090	DS	1-n	\N	SACoilCorrectionParams_Plane_cos_ref	\N	K	\N	f	\N	(0119,"MRSC",72)	combined.txt
11091	DS	1-n	\N	SACoilCorrectionParams_Lps_ref	\N	K	\N	f	\N	(0119,"MRSC",73)	combined.txt
11092	IS	1	\N	SACoilCorrectionParams_Order	\N	K	\N	f	\N	(0119,"MRSC",74)	combined.txt
11093	DS	1-n	\N	SACoilCorrectionParams_Coeff	\N	K	\N	f	\N	(0119,"MRSC",75)	combined.txt
11094	DA	1	\N	SACoilCorrectionParams_Coeff_date	\N	K	\N	f	\N	(0119,"MRSC",76)	combined.txt
11095	LO	1	\N	SACoilCorrectionParams_Coeff_src	\N	K	\N	f	\N	(0119,"MRSC",77)	combined.txt
11096	DS	1-n	\N	TI	\N	K	\N	f	\N	(0119,"MRSC",82)	combined.txt
11097	DS	1-n	\N	TSL	\N	K	\N	f	\N	(0119,"MRSC",83)	combined.txt
11098	DS	1-n	\N	FlipAngle	\N	K	\N	f	\N	(0119,"MRSC",88)	combined.txt
11099	DS	1-n	\N	TemporalIndex	\N	K	\N	f	\N	(0119,"MRSC",90)	combined.txt
11100	DS	1-n	\N	TemporalValue	\N	K	\N	f	\N	(0119,"MRSC",91)	combined.txt
11101	LO	1-n	\N	MinVarFiltIdfimages	\N	K	\N	f	\N	(0119,"MRSC",aa)	combined.txt
11102	LO	1	\N	MinVarFiltOutput_file	\N	K	\N	f	\N	(0119,"MRSC",ab)	combined.txt
11103	IS	1	\N	MinVarFiltNum_loops	\N	K	\N	f	\N	(0119,"MRSC",ac)	combined.txt
11104	IS	3	\N	MinVarFiltKernel	\N	K	\N	f	\N	(0119,"MRSC",ad)	combined.txt
11105	IS	1	\N	MinVarFiltLimit_sliceFlag	\N	K	\N	f	\N	(0119,"MRSC",ae)	combined.txt
11106	SS	2	\N	MinVarFiltSlice_limits	\N	K	\N	f	\N	(0119,"MRSC",af)	combined.txt
11107	LO	1	\N	MinVarFiltScript	\N	K	\N	f	\N	(0119,"MRSC",b3)	combined.txt
11108	LO	1	\N	MinVarFiltLog	\N	K	\N	f	\N	(0119,"MRSC",b4)	combined.txt
11109	SQ	1	\N	QCMinimumLimits	\N	K	\N	f	\N	(0119,"MRSC",c0)	combined.txt
11110	SQ	1	\N	QCMaximumLimits	\N	K	\N	f	\N	(0119,"MRSC",c1)	combined.txt
11111	ST	1	\N	CheckString	\N	K	\N	f	\N	(0119,"MRSC",d0)	combined.txt
11112	LO	1-n	\N	Source	\N	K	\N	f	\N	(0119,"MRSC",d1)	combined.txt
11113	OB	1-n	\N	SampleHeader	\N	K	\N	f	\N	(0119,"MRSC",f0)	combined.txt
11114	DS	1-n	\N	UserInfo	\N	K	\N	f	\N	(0119,"MRSC",ff)	combined.txt
11115	UI	1	\N	GT Gating UID	\N	R	\N	f	\N	(01e1,"ELSCINT1",c2)	combined.txt
11116	SH	1	\N	DICOM Implementation Version	\N	R	\N	f	\N	(1001,"BrainWave: 1.2.840.113819.3",11)	combined.txt
11117	UI	1	\N	DICOM Implementation UID	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",10)	combined.txt
11118	UI	1	\N	Within-DICOM-Implementation SOP Instance UID	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",12)	combined.txt
11119	SH	1	\N	Application Name	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",13)	combined.txt
11120	SH	1	\N	Application Version	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",14)	combined.txt
11121	SH	1	\N	Compatibility Version	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",15)	combined.txt
11122	UI	1-n	\N	Referenced Series UID	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",21)	combined.txt
11123	US	1	\N	Number of Objects Averaged	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",31)	combined.txt
11124	US	1	\N	Number of Expected Time Points	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",41)	combined.txt
11125	US	1	\N	Number of Slices Per Volume	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",51)	combined.txt
11126	US	1	\N	BW Image Type	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",60)	combined.txt
11127	US	1	\N	Experiment Type	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",61)	combined.txt
11128	UI	1	\N	Paradigm UID	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",71)	combined.txt
11129	LO	1	\N	Paradigm Name	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",72)	combined.txt
11130	ST	1	\N	Paradigm Description	\N	R	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",73)	combined.txt
11131	OB	1	\N	Contrast	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",80)	combined.txt
11132	FL	1-n	\N	Regressor Values	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",81)	combined.txt
11133	US	1	\N	Number of Degrees of Freedom	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",86)	combined.txt
11134	FL	1	\N	Z Threshold	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",8a)	combined.txt
11135	FL	1	\N	p Threshold	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",8b)	combined.txt
11136	OB	1	\N	Processing Parameters	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",90)	combined.txt
11137	OB	1	\N	Motion Plot	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",91)	combined.txt
11138	OB	1	\N	ROIs	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",92)	combined.txt
11139	OB	1	\N	Tracts	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",93)	combined.txt
11140	OB	1	\N	Report	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",94)	combined.txt
11141	OB	1	\N	Response Data	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",95)	combined.txt
11142	FL	1-n	\N	Motion Parameters	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",a0)	combined.txt
11143	FL	1-n	\N	Registration Parameters	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",a1)	combined.txt
11144	FL	1-n	\N	Subject Data	\N	K	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",a2)	combined.txt
11145	OB	1	\N	DTI Parameters	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",b0)	combined.txt
11146	OB	1	\N	Paradigm Info	\N	X	\N	f	\N	(2001,"BrainWave: 1.2.840.113819.3",c0)	combined.txt
984	FL	1	\N	Chemical Shift	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",01)	combined.txt
985	IS	1	\N	Chemical Shift Number MR	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",02)	combined.txt
986	FL	1	\N	Diffusion b-value	Diffusion B-Factor	KB	\N	f	\N	(2001,"Philips Imaging DD 001",03)	combined.txt
987	CS	1	\N	Diffusion Direction	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",04)	combined.txt
988	CS	1	\N	Image Enhanced	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",06)	combined.txt
989	CS	1	\N	Image Type ED ES	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",07)	combined.txt
990	IS	1	\N	Phase Number	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",08)	combined.txt
6838	FL	1	\N	Image Prepulse Delay	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",09)	combined.txt
991	IS	1	\N	Slice Number MR	\N	K3	\N	f	\N	(2001,"Philips Imaging DD 001",0a)	combined.txt
992	CS	1	\N	Slice Orientation	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",0b)	combined.txt
6840	CS	1	\N	Arrhythmia Rejection	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",0c)	combined.txt
6842	CS	1	\N	Cardiac Cycled	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",0e)	combined.txt
6844	SS	1	\N	Cardiac Gate Width	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",0f)	combined.txt
6846	CS	1	\N	Cardiac Sync	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",10)	combined.txt
993	FL	1	\N	Diffusion Echo Time	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",11)	combined.txt
994	CS	1	\N	Dynamic Series	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",12)	combined.txt
995	SL	1	\N	EPI Factor	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",13)	combined.txt
996	SL	1	\N	Number of Echoes	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",14)	combined.txt
997	SS	1	\N	Number of Locations	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",15)	combined.txt
998	SS	1	\N	Number of PC Directions	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",16)	combined.txt
999	SL	1	\N	Number of Phases MR	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",17)	combined.txt
1000	SL	1	\N	Number of Slices MR	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",18)	combined.txt
1001	CS	1	\N	Partial Matrix Scanned	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",19)	combined.txt
1002	FL	1	\N	PC Velocity	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",1a)	combined.txt
1003	FL	1	\N	Prepulse Delay	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",1b)	combined.txt
1004	CS	1	\N	Prepulse Type	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",1c)	combined.txt
1005	IS	1	\N	Reconstruction Number MR	\N	K3	\N	f	\N	(2001,"Philips Imaging DD 001",1d)	combined.txt
1006	CS	1	\N	Respiration Sync	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",1f)	combined.txt
6863	LO	1	\N	Scanning Technique	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",20)	combined.txt
1007	CS	1	\N	SPIR	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",21)	combined.txt
1008	FL	1	\N	Water Fat Shift	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",22)	combined.txt
1009	DS	1	\N	Flip Angle Philips	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",23)	combined.txt
6869	CS	1	\N	Series is Interactive	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",24)	combined.txt
1010	SH	1	\N	Echo Time Display	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",25)	combined.txt
1011	SS	1	\N	Stack Number of Slices	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",2d)	combined.txt
1012	FL	1	\N	Stack Radial Angle	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",32)	combined.txt
1013	CS	1	\N	Stack Radial Axis	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",33)	combined.txt
1014	SS	1	\N	Stack Slice Number	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",35)	combined.txt
1015	CS	1	\N	Stack Type	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",36)	combined.txt
6943	UL	1	\N	Constrast Transfer Taste	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",58)	combined.txt
1017	SQ	1	\N	Stack Sequence	\N	K	\N	f	\N	(2001,"Philips Imaging DD 001",5f)	combined.txt
1018	SL	1	\N	Number of Stacks	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",60)	combined.txt
1019	CS	1	\N	Series Transmitted	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",61)	combined.txt
1021	CS	1	\N	Examination Source	\N	X	\N	f	\N	(2001,"Philips Imaging DD 001",63)	combined.txt
1022	IS	1	\N	Acquisition no	Acquisition Number	K3	\N	f	\N	(2001,"Philips Imaging DD 001",7b)	combined.txt
1023	IS	1	\N	Number of Dynamic Scans	no_dynamic_scans	KB	\N	f	\N	(2001,"Philips Imaging DD 001",81)	combined.txt
7025	CS	1	\N	Israwimage	\N	R	\N	f	\N	(2001,"Philips Imaging DD 001",a1)	combined.txt
7035	LO	1	\N	ExamCard Name	\N	X	\N	f	\N	(2001,"Philips Imaging DD 001",c8)	combined.txt
7041	FL	1	\N	Prospective Motion Correction	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",f1)	combined.txt
7043	FL	1	\N	Retrospective Motion Correction	\N	KB	\N	f	\N	(2001,"Philips Imaging DD 001",f2)	combined.txt
1067	SL	1	\N	Number of Chemical Shift	\N	KB	\N	f	\N	(2005,"Philips MR Imaging DD 001",20)	combined.txt
1073	CS	1	\N	Syncra Scan Type	\N	R	\N	f	\N	(2005,"Philips MR Imaging DD 001",a1)	combined.txt
7572	FL	1	\N	Diffusion Direction RL	\N	KB	\N	f	\N	(2005,"Philips MR Imaging DD 001",b0)	combined.txt
7574	FL	1	\N	Diffusion Direction AP	\N	KB	\N	f	\N	(2005,"Philips MR Imaging DD 001",b1)	combined.txt
7576	FL	1	\N	Diffusion Direction FH	\N	KB	\N	f	\N	(2005,"Philips MR Imaging DD 001",b2)	combined.txt
4938	CS		\N	Energy Subtraction Param	\N	K	\N	f	\N	(50f1,"FDMS 1.0",06)	combined.txt
4939	CS		\N	Subtraction Registration Result	\N	K	\N	f	\N	(50f1,"FDMS 1.0",07)	combined.txt
4940	CS		\N	Energy Subtraction Param. 2	\N	K	\N	f	\N	(50f1,"FDMS 1.0",08)	combined.txt
4941	SL		\N	Afin Conversion Coefficient	\N	K	\N	f	\N	(50f1,"FDMS 1.0",09)	combined.txt
4942	SH		\N	FNC Parameters	\N	K	\N	f	\N	(50f1,"FDMS 1.0",0a)	combined.txt
4944	CS		\N	Image Processing Modification Flag	\N	K	\N	f	\N	(50f1,"FDMS 1.0",20)	combined.txt
11147	OB	1	\N	rdb_hdr_rec	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",01)	combined.txt
11148	OB	1	\N	rdb_hdr_per_pass_tab	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",02)	combined.txt
11149	OB	1	\N	rdr_hdr_unlock_raw	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",03)	combined.txt
11150	OB	1	\N	rdb_hdr_data_acq_tab	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",04)	combined.txt
11151	OB	1	\N	rdb_hdr_nex_tab	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",05)	combined.txt
11152	OB	1	\N	rdb_hdr_nex_abort_tab	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",06)	combined.txt
11153	OB	1	\N	rdb_hdr_tool	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",07)	combined.txt
11154	OB	1	\N	rdb_raw_data	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",08)	combined.txt
11155	OB	1	\N	SSP save	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",09)	combined.txt
11156	OB	1	\N	UDA save	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",0a)	combined.txt
11157	OB	1	\N	rdb_chemsat_data	\N	X	\N	f	\N	(7001,"GEMS_MR_RAW_01",0b)	combined.txt
10340	OB	1-n	\N	CT Private Data 1	\N	X	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",00)	combined.txt
10341	SH	1	\N	Cardiac R-R Mean Time	\N	K	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",03)	combined.txt
10342	SH	1	\N	Cardiac Reconstruction Gating Phase in Percent	\N	K	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",04)	combined.txt
10343	SH	1	\N	Cardiac Reconstruction Gating Phase in ms	\N	K	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",05)	combined.txt
10344	SH	1	\N	Cardiac Reconstruction Mode	\N	K	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",06)	combined.txt
10345	DS	2	\N	Reconstruction Center	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",07)	combined.txt
10346	DS	1	\N	Detector Slice Thickness in mm	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",08)	combined.txt
10347	LO	1	\N	Number of Detector rows to Reconstruct	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",09)	combined.txt
10348	DS	1	\N	Table Speed in mm/rot	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0a)	combined.txt
10349	SH	1	\N	Filter	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0b)	combined.txt
10350	SH	1	\N	Reconstruction Correction Type	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0c)	combined.txt
10351	CS	1	\N	Organ	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0d)	combined.txt
10352	SH	1	\N	File Type Remarks	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0e)	combined.txt
10353	SH	1	\N	Direction	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",0f)	combined.txt
10354	OB	1-n	\N	CT Private Data 2	\N	X	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",10)	combined.txt
10355	LT	1	\N	Series Comment	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",11)	combined.txt
10356	SH	1	\N	Position	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",12)	combined.txt
10357	US	1	\N	Expert Plan No.	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",13)	combined.txt
10358	US	1	\N	Reconstruction ROI No.	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",14)	combined.txt
10359	US	1	\N	Special Helical ACQ No.	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",15)	combined.txt
10360	US	1	\N	Volume UID	\N	X	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",16)	combined.txt
10361	US	1	\N	Total Frame Count in the Volume	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",17)	combined.txt
10362	US	1	\N	Frame No.	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",18)	combined.txt
10363	UL	1	\N	Frame Sort Key	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",19)	combined.txt
10364	US	1	\N	Frame Sort Order	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1a)	combined.txt
10365	SH	1	\N	"(L1) Convolution Kernel, (L2) Convolution Kernel for Series Record"	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1b)	combined.txt
10366	LO	1	\N	"(L1) Contrast/Bolus Agent, (L2) Contrast/Bolus Agent for Series Record"	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1c)	combined.txt
10367	UL	1	\N	Reconstruction Number	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1d)	combined.txt
10368	UL	1	\N	Raw Data Number	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1e)	combined.txt
10369	LO	1	\N	Volume Number	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",1f)	combined.txt
10370	UL	1	\N	Local Series Number	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",20)	combined.txt
10371	LO	1	\N	Decrease in Artifact Filter	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",21)	combined.txt
10372	DS	1	\N	Reconstruction Interval	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",22)	combined.txt
10373	DS	1	\N	Pitch Factor	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",23)	combined.txt
10374	DA	1	\N	The Acquisition Date of NRA	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",24)	combined.txt
10375	UL	1	\N	Large Data File Attribute	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",25)	combined.txt
10376	CS	1-8	\N	Large Data File Name	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",26)	combined.txt
10377	SQ	1	\N	Enhanced CT Private Sequence	\N	X	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",28)	combined.txt
10378	UI	1	\N	Frame UID	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",29)	combined.txt
10379	CS	1	\N	Main Modality in Study	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",30)	combined.txt
10380	DS	2	\N	Scan Range	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",35)	combined.txt
10381	OB	1-n	\N	CT Private Data 3	\N	X	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",36)	combined.txt
10382	IS	1	\N	Total Frames	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",37)	combined.txt
10383	IS	1	\N	Start Frame	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",38)	combined.txt
10384	IS	1	\N	End Frame	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",39)	combined.txt
10385	FD	1	\N	DLP (Dose Length Product)	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",40)	combined.txt
10386	SH	1	\N	Raw Slice Information	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",41)	combined.txt
10387	US	1	\N	Local Frame No	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",42)	combined.txt
10388	DS	3	\N	Volume Vector	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",43)	combined.txt
10389	US	1	\N	Volume Type	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",44)	combined.txt
10390	DS	1	\N	Relative Table Position of 4D Volume	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",45)	combined.txt
10391	DS	1	\N	Absolute Table Position of 4D Volume	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",46)	combined.txt
10392	DS	1	\N	Slice Pitch of 4D Volume	\N	KB	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",47)	combined.txt
10393	LO	1	\N	Respiratory Gating Inf.	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",48)	combined.txt
10394	SH	1	\N	Respiration Phase	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",49)	combined.txt
10405	CS	1	\N	"Protect Mark for Image, Curve or Private Record"	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",f1)	combined.txt
11158	CS	1	\N	Protect Mark for Series Record	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",f2)	combined.txt
11159	CS	1	\N	Protect Mark for Study Record	\N	R	\N	f	\N	(7005,"TOSHIBA_MEC_CT3",f3)	combined.txt
10406	DS	N	\N	Scale Factor	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",00)	combined.txt
10407	OB	N	\N	Acquisition Order	\N	X	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",01)	combined.txt
10408	DS	N	\N	Orientation Vector	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",02)	combined.txt
10409	SS	N	\N	Flip Flag	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",03)	combined.txt
10410	OB	N	\N	Rotate Information	\N	X	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",04)	combined.txt
10411	DS	N	\N	FOV	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",05)	combined.txt
10412	US	N	\N	Image Matrix	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",06)	combined.txt
10413	OB	N	\N	Image Information	\N	X	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",07)	combined.txt
10414	OB	N	\N	Original Data	\N	X	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",08)	combined.txt
10415	SS	N	\N	Original Data Flag	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",09)	combined.txt
11160	US	N	\N	Number of PAC channel	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",80)	combined.txt
11161	US	N	\N	Reference mode	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",81)	combined.txt
11162	SQ	N	\N	Gain value group for MRS	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",82)	combined.txt
11163	UL	N	\N	Flag of water Sat pulse	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",88)	combined.txt
11164	FL	N	\N	Selected contrast TE	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",89)	combined.txt
11165	SQ	N	\N	Raw Data Set Sequence	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",8a)	combined.txt
11166	FL	N	\N	Receiver gain of prescan	\N	KB	\N	f	\N	(700d,"TOSHIBA_MEC_MR3",91)	combined.txt
7984	DS	1	\N	SUV Scale Factor	\N	K	\N	f	\N	(7053,"Philips PET Private Group",00)	combined.txt
7985	OB	1	\N	Philips Private 7053 1001	\N	X	\N	f	\N	(7053,"Philips PET Private Group",01)	combined.txt
7986	OB	1	\N	Philips Private 7053 1002	\N	X	\N	f	\N	(7053,"Philips PET Private Group",02)	combined.txt
7987	ST	1	\N	Original Image file name	\N	X	\N	f	\N	(7053,"Philips PET Private Group",03)	combined.txt
7989	LO	1	\N	File Name	\N	X	\N	f	\N	(7053,"Philips PET Private Group",05)	combined.txt
7990	OB	1	\N	Private	\N	X	\N	f	\N	(7053,"Philips PET Private Group",06)	combined.txt
7991	SQ	1	\N	Acquisition File Sequence	\N	X	\N	f	\N	(7053,"Philips PET Private Group",07)	combined.txt
7993	DS	1	\N	Activity Concentration Scale Factor	\N	K	\N	f	\N	(7053,"Philips PET Private Group",09)	combined.txt
7998	SS	1	\N	Philips Private 7053 1013	\N	X	\N	f	\N	(7053,"Philips PET Private Group",13)	combined.txt
7999	SS	1	\N	Philips Private 7053 1014	\N	X	\N	f	\N	(7053,"Philips PET Private Group",14)	combined.txt
8000	SS	1	\N	Philips Private 7053 1015	\N	X	\N	f	\N	(7053,"Philips PET Private Group",15)	combined.txt
8001	SS	1	\N	Philips Private 7053 1016	\N	X	\N	f	\N	(7053,"Philips PET Private Group",16)	combined.txt
8002	SS	1	\N	Philips Private 7053 1017	\N	X	\N	f	\N	(7053,"Philips PET Private Group",17)	combined.txt
8003	SS	1	\N	Philips Private 7053 1018	\N	X	\N	f	\N	(7053,"Philips PET Private Group",18)	combined.txt
8004	UI	1	\N	PET-CT Multi Modality Name	\N	X	\N	f	\N	(7053,"Philips PET Private Group",c2)	combined.txt
9330	OB	1	\N	CSA Data	\N	X	\N	f	\N	(7fe1,"SIEMENS CSA NON-IMAGE",10)	combined.txt
9331	OW	1	\N	Minimum pixel in frame	\N	K	\N	f	\N	(7fe3,"SIEMENS MED NM",14)	combined.txt
9332	OW	1	\N	Maximum pixel in frame	\N	K	\N	f	\N	(7fe3,"SIEMENS MED NM",15)	combined.txt
9340	OW	1	\N	Number of R-Waves in frame	\N	K	\N	f	\N	(7fe3,"SIEMENS MED NM",29)	combined.txt
\.


--
-- Data for Name: ptrg; Type: TABLE DATA; Schema: public; Owner: -
--

COPY ptrg (ptrg_id, ptrg_signature_masked, ptrg_owner, ptrg_base_grp, ptrg_grp_mask, ptrg_grp_ext_mask, ptrg_grp_ext_shift, ptrg_element, ptrg_is_specific_to_block, ptrg_specific_block, ptrg_consensus_vr, ptrg_consensus_vm, ptrg_consensus_name, ptrg_consensus_disposition) FROM stdin;
1	(7001,"DLX_ANNOT_01",04)	DLX_ANNOT_01	28673	65281	254	1	04	f	\N	ST	1	TextAnnotation	\N
2	(7001,"DLX_ANNOT_01",05)	DLX_ANNOT_01	28673	65281	254	1	05	f	\N	IS	2	Box	\N
3	(7001,"DLX_ANNOT_01",07)	DLX_ANNOT_01	28673	65281	254	1	07	f	\N	IS	2	ArrowEnd	\N
4	(6001,"DLX_LKUP_01",01)	DLX_LKUP_01	24577	65281	254	1	01	f	\N	US	3	GrayPaletteColorLookupTableDescriptor	\N
5	(6001,"DLX_LKUP_01",02)	DLX_LKUP_01	24577	65281	254	1	02	f	\N	US	1	GrayPaletteColorLookupTableData	\N
6	(6001,"PAPYRUS 3.0",00)	PAPYRUS 3.0	24577	65281	254	1	00	f	\N	IS	1	OverlayID	\N
7	(6001,"PAPYRUS 3.0",01)	PAPYRUS 3.0	24577	65281	254	1	01	f	\N	LT	1-n	LinkedOverlays	\N
8	(6001,"PAPYRUS 3.0",10)	PAPYRUS 3.0	24577	65281	254	1	10	f	\N	US	1	OverlayRows	\N
9	(6001,"PAPYRUS 3.0",11)	PAPYRUS 3.0	24577	65281	254	1	11	f	\N	US	1	OverlayColumns	\N
10	(6001,"PAPYRUS 3.0",40)	PAPYRUS 3.0	24577	65281	254	1	40	f	\N	LO	1	OverlayType	\N
11	(6001,"PAPYRUS 3.0",50)	PAPYRUS 3.0	24577	65281	254	1	50	f	\N	US	1-n	OverlayOrigin	\N
12	(6001,"PAPYRUS 3.0",60)	PAPYRUS 3.0	24577	65281	254	1	60	f	\N	LO	1	Editable	\N
13	(6001,"PAPYRUS 3.0",70)	PAPYRUS 3.0	24577	65281	254	1	70	f	\N	LO	1	OverlayFont	\N
14	(6001,"PAPYRUS 3.0",72)	PAPYRUS 3.0	24577	65281	254	1	72	f	\N	LO	1	OverlayStyle	\N
15	(6001,"PAPYRUS 3.0",74)	PAPYRUS 3.0	24577	65281	254	1	74	f	\N	US	1	OverlayFontSize	\N
16	(6001,"PAPYRUS 3.0",76)	PAPYRUS 3.0	24577	65281	254	1	76	f	\N	LO	1	OverlayColor	\N
17	(6001,"PAPYRUS 3.0",78)	PAPYRUS 3.0	24577	65281	254	1	78	f	\N	US	1	ShadowSize	\N
18	(6001,"PAPYRUS 3.0",80)	PAPYRUS 3.0	24577	65281	254	1	80	f	\N	LO	1	FillPattern	\N
19	(6001,"PAPYRUS 3.0",82)	PAPYRUS 3.0	24577	65281	254	1	82	f	\N	US	1	OverlayPenSize	\N
20	(6001,"PAPYRUS 3.0",a0)	PAPYRUS 3.0	24577	65281	254	1	a0	f	\N	LO	1	Label	\N
21	(6001,"PAPYRUS 3.0",a2)	PAPYRUS 3.0	24577	65281	254	1	a2	f	\N	LT	1	PostItText	\N
22	(6001,"PAPYRUS 3.0",a4)	PAPYRUS 3.0	24577	65281	254	1	a4	f	\N	US	2	AnchorPoint	\N
23	(6001,"PAPYRUS 3.0",b0)	PAPYRUS 3.0	24577	65281	254	1	b0	f	\N	LO	1	ROIType	\N
24	(6001,"PAPYRUS 3.0",b2)	PAPYRUS 3.0	24577	65281	254	1	b2	f	\N	LT	1	AttachedAnnotation	\N
25	(6001,"PAPYRUS 3.0",ba)	PAPYRUS 3.0	24577	65281	254	1	ba	f	\N	US	1-n	ContourPoints	\N
26	(6001,"PAPYRUS 3.0",bc)	PAPYRUS 3.0	24577	65281	254	1	bc	f	\N	US	1-n	MaskData	\N
27	(6001,"PAPYRUS 3.0",c0)	PAPYRUS 3.0	24577	65281	254	1	c0	f	\N	SQ	1	UINOverlaySequence	\N
\.


--
-- Data for Name: ptrg_observation; Type: TABLE DATA; Schema: public; Owner: -
--

COPY ptrg_observation (ptrg_id, ptrg_obs_observer, ptrg_obs_value, ptrg_obs_comment, ptrg_obs_time) FROM stdin;
\.


--
-- PostgreSQL database dump complete
--

\connect posda_phi_simple
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.7 (Ubuntu 10.7-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- Data for Name: element_seen; Type: TABLE DATA; Schema: public; Owner: -
--

COPY public.element_seen (element_seen_id, element_sig_pattern, vr, is_private, tag_name, private_disposition) FROM stdin;
3224	(300a,0010)[<0>](300a,0021)	DS	f	Dose Reference Sequence:Constraint Weight	\N
3231	(300a,0070)[<0>](300c,0050)[<1>](300a,0026)	DS	f	Fraction Group Sequence:Referenced Dose Reference Sequence:Target Prescription Dose	\N
3217	(300a,0180)[<0>](300a,01b4)[<1>](300a,01b8)	SH	f	Patient Setup Sequence:Setup Device Sequence:Setup Device Label	\N
3234	(300c,0080)[<0>](0008,1155)	UI	f	Referenced Dose Sequence:Referenced SOP Instance UID	\N
3218	(300a,0180)[<0>](300a,01b4)	SQ	f	Patient Setup Sequence:Setup Device Sequence	\N
3225	(300a,0010)[<0>](300a,002a)	DS	f	Dose Reference Sequence:Organ at Risk Full-volume Dose	\N
5916	(7039,"CtProjectionData-MayoClinc-v1",05)	UN	t	Unknown	d
3215	(3004,0006)	LO	f	Dose Comment	\N
3228	(300a,0010)[<0>](300a,002c)	DS	f	Dose Reference Sequence:Organ at Risk Maximum Dose	\N
5902	(7029,"CtProjectionData-MayoClinc-v1",10)	UN	t	Unknown	d
2183	(0040,0321)	SQ	f	Film Consumption Sequence	\N
3227	(300a,0010)[<0>](300a,002d)	DS	f	Dose Reference Sequence:Organ at Risk Overdose Volume Fraction	\N
3221	(300a,000e)	ST	f	Prescription Description	\N
5908	(7033,"CtProjectionData-MayoClinc-v1",61)	UN	t	Unknown	d
4882	(0053,"GEHC_CT_ADVAPP_001",20)	OB	t	Shuttle Flag	k
4803	(0045,"GEMS_HELIOS_01",02)	OB	t	Macro width at ISO Center	k
3229	(300a,0010)[<0>](300a,0025)	DS	f	Dose Reference Sequence:Target Minimum Dose	\N
5915	(7029,"CtProjectionData-MayoClinc-v1",02)	UN	t	Unknown	d
6491	(0023,"AMICAS0",01)	UN	t	Unknown	d
1715	(0018,9346)	SQ	f	CTDI Phantom Type Code Sequence	\N
1712	(0018,1143)	DS	f	Scan Arc	\N
51	(0018,0050)	DS	f	Slice Thickness	\N
43	(0018,0080)	DS	f	Repetition Time	\N
117	(0028,0010)	US	f	Rows	\N
9	(0008,1110)	SQ	f	Referenced Study Sequence	\N
4	(0008,0050)	SH	f	Accession Number	\N
129	(0018,1044)	DS	f	Contrast/Bolus Total Dose	\N
124	(0008,0012)	DA	f	Instance Creation Date	\N
78	(0018,0022)	CS	f	Scan Options	\N
52	(0018,0087)	DS	f	Magnetic Field Strength	\N
32	(0018,0089)	IS	f	Number of Phase Encoding Steps	\N
46	(0018,0095)	DS	f	Pixel Bandwidth	\N
40	(0028,1050)	DS	f	Window Center	\N
126	(0008,0021)	DA	f	Series Date	\N
10	(0012,0064)	SQ	f	De-identification Method Code Sequence	\N
103	(0008,1140)[<0>](0008,1155)	UI	f	Referenced Image Sequence:Referenced SOP Instance UID	\N
3	(0012,0064)[<0>](0008,0100)	SH	f	De-identification Method Code Sequence:Code Value	\N
45	(0018,0084)	DS	f	Imaging Frequency	\N
79	(0018,1315)	CS	f	Variable Flip Angle Flag	\N
29	(0018,0091)	IS	f	Echo Train Length	\N
25	(0040,0254)	LO	f	Performed Procedure Step Description	\N
22	(0008,1090)	LO	f	Manufacturer's Model Name	\N
84	(0018,0015)	CS	f	Body Part Examined	\N
94	(0008,0032)	TM	f	Acquisition Time	\N
111	(0028,0102)	US	f	High Bit	\N
30	(0018,0086)	IS	f	Echo Number(s)	\N
20	(0008,0070)	LO	f	Manufacturer	\N
113	(0018,1310)	US	f	Acquisition Matrix	\N
6422	(0009,"SIEMENS CT VA0  IDE",31)	SH	t	Unknown	d
109	(0020,000e)	UI	f	Series Instance UID	\N
2	(0020,0010)	SH	f	Study ID	\N
90	(0032,000c)	CS	f	Study Priority ID	\N
107	(0020,000d)	UI	f	Study Instance UID	\N
100	(0010,1010)	AS	f	Patient's Age	\N
86	(0018,0020)	CS	f	Scanning Sequence	\N
35	(0020,0032)	DS	f	Image Position (Patient)	\N
36	(0018,1314)	DS	f	Flip Angle	\N
26	(0010,0020)	LO	f	Patient ID	\N
34	(0010,0010)	PN	f	Patient's Name	\N
88	(0008,0060)	CS	f	Modality	\N
93	(0028,0004)	CS	f	Photometric Interpretation	\N
49	(0018,0093)	DS	f	Percent Sampling	\N
54	(0018,1316)	DS	f	SAR	\N
55	(0018,0083)	DS	f	Number of Averages	\N
50	(0018,1318)	DS	f	dB/dt	\N
121	(0040,0244)	DA	f	Performed Procedure Step Start Date	\N
13	(0012,0064)[<0>](0008,0104)	LO	f	De-identification Method Code Sequence:Code Meaning	\N
3216	(00e1,"ELSCINT1",64)	UN	t	Unknown	d
1179	(5008,3000)	UN	f	Curve Data	\N
3222	(300a,0010)[<0>](3006,0084)	IS	f	Dose Reference Sequence:Referenced ROI Number	\N
6555	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",08)		t	Unknown	d
3220	(300c,0080)	SQ	f	Referenced Dose Sequence	\N
4796	(0009,"GEMS_IDEN_01",e3)	OB	t	EquipmentUID	h
3842	(0029,"",16)	UN	t	Unknown	d
3232	(300a,0180)[<0>](300a,01b4)[<1>](300a,01b6)	CS	f	Patient Setup Sequence:Setup Device Sequence:Setup Device Type	\N
5501	(0010,2292)	LO	f	Patient Breed Description	\N
3223	(300a,0070)[<0>](300c,0050)[<1>](300c,0051)	IS	f	Fraction Group Sequence:Referenced Dose Reference Sequence:Referenced Dose Reference Number	\N
3230	(300a,0180)[<0>](300a,01b4)[<1>](300a,01bc)	DS	f	Patient Setup Sequence:Setup Device Sequence:Setup Device Parameter	\N
4860	(0021,"GEMS_RELA_01",93)	OB	t	BiopsyRefLocation	k
3233	(300c,0080)[<0>](0008,1150)	UI	f	Referenced Dose Sequence:Referenced SOP Class UID	\N
3226	(300a,0010)[<0>](300a,0028)	DS	f	Dose Reference Sequence:Target Underdose Volume Fraction	\N
4909	(7005,"TOSHIBA_MEC_CT3",06)	SH	t	Cardiac Reconstruction Mode	k
5496	(0040,a525)	SQ	f	Identical Documents Sequence	\N
5500	(0040,a730)[<0>](0008,1199)[<1>](0008,1160)	IS	f	Content Sequence:Referenced SOP Sequence:Referenced Frame Number	\N
4858	(0045,"GEMS_HELIOS_01",0d)	OB	t	Z tracking Flag	k
5498	(0040,a730)[<0>](0008,1199)[<1>](0008,1199)	SQ	f	Content Sequence:Referenced SOP Sequence:Referenced SOP Sequence	\N
4872	(0045,"GEMS_HELIOS_01",0e)	OB	t	Mean Z error	k
5506	(0040,a525)[<0>](0008,1115)[<1>](0020,000e)	UI	f	Identical Documents Sequence:Referenced Series Sequence:Series Instance UID	\N
5953	(0057,"GEMS_VXTLSTATE_001",26)	SQ	t	Unknown	d
3251	(300a,0070)[<0>](300a,007b)	LT	f	Fraction Group Sequence:Fraction Pattern	\N
3262	(3006,0039)[<0>](3006,0040)[<1>](3006,0045)	DS	f	ROI Contour Sequence:Contour Sequence:Contour Offset Vector	\N
5705	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",44)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Near Clip Plane	k
87	(0012,0062)	CS	f	Patient Identity Removed	\N
5914	(7029,"CtProjectionData-MayoClinc-v1",11)	UN	t	Unknown	d
6266	(0009,"GEMS_GENIE_1",45)	LT	t	Unknown	d
6546	(0019,"SPI-P-PCR Release 2",20)	UN	t	Unknown	d
4810	(0019,"GEMS_ACQU_01",47)	OB	t	ViewCompressionFactor	k
6538	(200b,"Philips RAD Imaging DD 001",2d)	LO	t	Unknown	d
836	(0020,0020)	CS	f	Patient Orientation	\N
6554	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",02)		t	Unknown	d
3835	(0019,"",b3)	UN	t	Unknown	d
6563	(0511,"Unnamed Private Block - 10",01)	UN	t	Unknown	d
2202	(0020,0105)	IS	f	Number of Temporal Positions	\N
2212	(0008,1111)[<0>](0020,0013)	IS	f	Referenced Performed Procedure Step Sequence:Instance Number	\N
2208	(0020,0100)	IS	f	Temporal Position Identifier	\N
5508	(0040,a730)[<0>](0008,1199)[<1>](0062,000b)	US	f	Content Sequence:Referenced SOP Sequence:Referenced Segment Number	\N
1430	(0018,a001)[<0>](0008,1010)	SH	f	Contributing Equipment Sequence:Station Name	\N
5507	(0040,a730)[<0>](0008,1199)[<1>](0008,1199)[<2>](0008,1150)	UI	f	Content Sequence:Referenced SOP Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
6525	(0023,"AMICAS0",10)	US	t	Unknown	d
6532	(200b,"Philips RAD Imaging DD 001",4d)	SH	t	Unknown	d
6556	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",06)	UL	t	Unknown	d
6528	(0023,"AMICAS0",16)	SL	t	Unknown	d
3254	(300a,00b0)[<0>](300a,0111)[<1>](300a,0144)	FL	f	Beam Sequence:Control Point Sequence:Table Top Roll Angle	\N
6560	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",13)	LO	t	Unknown	d
4870	(0027,"GEMS_IMAG_01",1f)	OB	t	VmaClip	k
6543	(0019,"SPI-P-PCR Release 2",60)	UN	t	Unknown	d
4795	(0053,"GEHC_CT_ADVAPP_001",60)	OB	t	Recon Flip RotateA nno	k
6534	(0009,"SPI-P Release 1",16)	LO	t	Unknown	d
1298	(0008,9121)	SQ	f	Referenced Raw Data Sequence	\N
4830	(0045,"GEMS_HELIOS_01",16)	OB	t	Number Views 2B	k
4842	(0027,"GEMS_IMAG_01",35)	OB	t	PlaneType	k
6544	(0019,"SPI-P-PCR Release 2",40)	UN	t	Unknown	d
6524	(0023,"AMICAS0",08)	US	t	Unknown	d
91	(0032,000a)	CS	f	Study Status ID	\N
4804	(0053,"GEHC_CT_ADVAPP_001",40)	OB	t	Iterative Recon Annotation	d
6104	(0045,"GEMS_SENO_02",20)	DS	t	MeanOfRegionGrayLevels	k
4784	(0043,"GEMS_PARM_01",12)	OB	t	XrayChain	k
147	(0018,1048)	CS	f	Contrast/Bolus Ingredient	\N
3255	(300a,00b0)[<0>](300a,0111)[<1>](300a,0140)	FL	f	Beam Sequence:Control Point Sequence:Table Top Pitch Angle	\N
203	(0018,0060)	DS	f	KVP	\N
162	(0018,1210)	SH	f	Convolution Kernel	\N
150	(0008,2112)[<0>](0008,1155)	UI	f	Source Image Sequence:Referenced SOP Instance UID	\N
1742	(0018,9318)	FD	f	Reconstruction Target Center (Patient)	\N
1732	(0018,9346)[<0>](0008,0104)	LO	f	CTDI Phantom Type Code Sequence:Code Meaning	\N
1743	(0018,9313)	FD	f	Data Collection Center (Patient)	\N
1740	(0018,9352)	CS	f	Calcium Scoring Mass Factor Device	\N
1731	(0018,9346)[<0>](0008,0102)	SH	f	CTDI Phantom Type Code Sequence:Coding Scheme Designator	\N
1730	(0018,9346)[<0>](0008,0100)	SH	f	CTDI Phantom Type Code Sequence:Code Value	\N
151	(0008,2112)[<0>](0008,1150)	UI	f	Source Image Sequence:Referenced SOP Class UID	\N
207	(0018,1120)	DS	f	Gantry/Detector Tilt	\N
220	(0018,1140)	CS	f	Rotation Direction	\N
180	(0008,0090)	PN	f	Referring Physician's Name	\N
4827	(0019,"GEMS_ACQU_01",25)	OB	t	MidScanFlag	k
3269	(0051,"GEMS_CT_VES_01",01)[<0>](0008,0050)	SH	t	CTVESequence:Accession Number	d
173	(0018,1150)	IS	f	Exposure Time	\N
191	(0018,1100)	DS	f	Reconstruction Diameter	\N
204	(0018,1190)	DS	f	Focal Spot(s)	\N
1462	(0020,0200)	UI	f	Synchronization Frame of Reference UID	\N
3252	(300a,00b0)[<0>](300a,0111)[<1>](300a,0142)	CS	f	Beam Sequence:Control Point Sequence:Table Top Pitch Rotation Direction	\N
334	(0018,9306)	FD	f	Single Collimation Width	\N
3264	(300c,0002)[<0>](300a,0055)	CS	f	Referenced RT Plan Sequence:RT Plan Relationship	\N
3272	(300a,00b0)[<0>](300a,00d1)	SQ	f	Beam Sequence:Wedge Sequence	\N
3249	(3006,0006)	ST	f	Structure Set Description	\N
3253	(300a,00b0)[<0>](300a,0111)[<1>](300a,0146)	CS	f	Beam Sequence:Control Point Sequence:Table Top Roll Rotation Direction	\N
6575	(0018,9332)	FD	f	Exposure in mAs	\N
6573	(0018,11a0)	DS	f	Body Part Thickness	\N
3263	(3006,0039)[<0>](3006,0040)[<1>](3006,0044)	DS	f	ROI Contour Sequence:Contour Sequence:Contour Slab Thickness	\N
3250	(300a,0070)[<0>](300a,007a)	IS	f	Fraction Group Sequence:Repeat Fraction Cycle Length	\N
2875	(0040,a120)	DT	f	DateTime	\N
3219	(300a,0070)[<0>](300c,0050)	SQ	f	Fraction Group Sequence:Referenced Dose Reference Sequence	\N
3273	(300a,00b0)[<0>](300a,0111)[<1>](300a,0116)	SQ	f	Beam Sequence:Control Point Sequence:Wedge Position Sequence	\N
3503	(0018,7026)	DS	f	Detector Active Dimension(s)	\N
3500	(0018,7052)	DS	f	Filter Thickness Minimum	\N
3487	(0028,3010)[<0>](0028,3002)	SS	f	VOI LUT Sequence:LUT Descriptor	\N
3499	(0018,7054)	DS	f	Filter Thickness Maximum	\N
3501	(0018,7032)	DS	f	Field of View Rotation	\N
3481	(0018,1720)	IS	f	Vertices of the Polygonal Collimator	\N
3493	(0018,7030)	DS	f	Field of View Origin	\N
3279	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d3)	CS	f	Beam Sequence:Wedge Sequence:Wedge Type	\N
102	(0020,0052)	UI	f	Frame of Reference UID	\N
548	(0018,9321)[<0>](0018,9345)	FD	f	CT Exposure Sequence:CTDIvol	\N
82	(0008,0008)	CS	f	Image Type	\N
3283	(3004,0008)	DS	f	Normalization Point	\N
5	(0012,0064)[<0>](0008,0102)	SH	f	De-identification Method Code Sequence:Coding Scheme Designator	\N
6082	(0037,"MAROTECH Inc.",21)	US	t	Unknown	d
6542	(0029,"SPI-P-Private_ICS Release 1;5",40)	UN	t	Unknown	d
6557	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",01)	OB	t	Unknown	d
6549	(200b,"Philips RAD Imaging DD 097",66)	UN	t	Unknown	d
6559	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",07)	UI	t	Unknown	d
6558	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",00)	UI	t	Unknown	d
6540	(0029,"SPI-P-Private_ICS Release 1;5",55)	CS	t	Unknown	d
6545	(200b,"Philips RAD Imaging DD 097",6a)	UN	t	Unknown	d
6530	(0029,"SPI-P-Private_ICS Release 1",4c)		t	Unknown	d
6562	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",10)	UN	t	Unknown	d
3278	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d8)	DS	f	Beam Sequence:Wedge Sequence:Wedge Orientation	\N
4881	(0053,"GEHC_CT_ADVAPP_001",61)	OB	t	High Resolution Flag	k
6548	(200b,"Philips RAD Imaging DD 097",67)	UN	t	Unknown	d
3280	(300a,00b0)[<0>](300a,0111)[<1>](300a,0116)[<2>](300a,0118)	CS	f	Beam Sequence:Control Point Sequence:Wedge Position Sequence:Wedge Position	\N
6531	(200b,"Philips RAD Imaging DD 001",43)	UI	t	Unknown	d
3277	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d6)	DS	f	Beam Sequence:Wedge Sequence:Wedge Factor	\N
4802	(0009,"GEMS_IDEN_01",01)	OB	t	FullFidelity	k
6536	(0009,"SPI-P Release 1",18)	LO	t	Unknown	d
6561	(1135,"Voxar 2.16.124.113543.6003.1999.12.20.12.5.0",14)	UN	t	Unknown	d
4822	(0021,"GEMS_RELA_01",91)	OB	t	BiopsyPosition	k
5503	(0040,a525)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1150)	UI	f	Identical Documents Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
6131	(0035,"SIEMENS MED NM",00)	LO	t	Specialized Tomo Type	k
3282	(300a,00b0)[<0>](300c,00b0)[<1>](3006,0084)	IS	f	Beam Sequence:Referenced Bolus Sequence:Referenced ROI Number	\N
4833	(0043,"GEMS_PARM_01",16)	OB	t	NumberOfOverranges	k
6105	(0045,"GEMS_SENO_02",57)	DS	t	Noise Reduction Threshold	k
6301	(0055,"GEMS_GENIE_1",12)[<0>](0055,"GEMS_GENIE_1",13)[<1>](0011,"GEMS_GENIE_1",1c)	SL	t	eNTEGRA Energy Window Information Sequence:eNTEGRA Energy Window Range Sequence:EnergyOffset	k
1748	(0032,1040)	DA	f	Study Arrival Date	\N
1746	(0008,4000)	LT	f	Identifying Comments	\N
1747	(0032,1041)	TM	f	Study Arrival Time	\N
366	(0008,1032)	SQ	f	Procedure Code Sequence	\N
329	(0028,1054)	LO	f	Rescale Type	\N
337	(0018,9307)	FD	f	Total Collimation Width	\N
386	(0018,1090)	IS	f	Cardiac Number of Images	\N
3276	(300a,00b0)[<0>](300a,0111)[<1>](300a,0116)[<2>](300c,00c0)	IS	f	Beam Sequence:Control Point Sequence:Wedge Position Sequence:Referenced Wedge Number	\N
6287	(0011,"GEMS_GENIE_1",16)	SL	t	EnergyNumber	k
3509	(0018,7062)	LT	f	Exposure Control Mode Description	\N
3826	(0033,"",0e)	UN	t	Unknown	d
387	(0018,1088)	IS	f	Heart Rate	\N
3511	(0018,1166)	CS	f	Grid	\N
3510	(0018,7024)	CS	f	Detector Active Shape	\N
336	(0018,9309)	FD	f	Table Speed	\N
327	(0018,1170)	IS	f	Generator Power	\N
4896	(0137,"NetRAAD",40)	UN	t	Unknown	d
4815	(0043,"GEMS_PARM_01",44)	OB	t	DASOutputSource	k
3301	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d4)	SH	f	Beam Sequence:Wedge Sequence:Wedge ID	\N
3275	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d2)	IS	f	Beam Sequence:Wedge Sequence:Wedge Number	\N
4867	(0045,"GEMS_HELIOS_01",0c)	OB	t	Number of Views shifted	k
4782	(0053,"GEHC_CT_ADVAPP_001",65)	OB	t	Shutter Mode Percent	k
3281	(300a,00b0)[<0>](300c,00b0)	SQ	f	Beam Sequence:Referenced Bolus Sequence	\N
4829	(0027,"GEMS_IMAG_01",1c)	OB	t	VmaMamp	k
3274	(300a,00b0)[<0>](300a,00d1)[<1>](300a,00d5)	IS	f	Beam Sequence:Wedge Sequence:Wedge Angle	\N
5505	(0040,a525)[<0>](0020,000d)	UI	f	Identical Documents Sequence:Study Instance UID	\N
333	(0018,9311)	FD	f	Spiral Pitch Factor	\N
5497	(0040,a525)[<0>](0008,1115)	SQ	f	Identical Documents Sequence:Referenced Series Sequence	\N
4785	(0043,"GEMS_PARM_01",1e)	OB	t	DeltaStartTime	k
4834	(0045,"GEMS_HELIOS_01",14)	OB	t	Number of Views 1A	k
5504	(0040,a525)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1155)	UI	f	Identical Documents Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
5509	(3006,0080)[<0>](300a,00e1)	SH	f	RT ROI Observations Sequence:Material ID	\N
5511	(0018,1191)	CS	f	Anode Target Material	\N
4852	(0027,"GEMS_IMAG_01",46)	OB	t	NormalACoord	k
5499	(0040,a525)[<0>](0008,1115)[<1>](0008,1199)	SQ	f	Identical Documents Sequence:Referenced Series Sequence:Referenced SOP Sequence	\N
5502	(0040,a730)[<0>](0008,1199)[<1>](0008,1199)[<2>](0008,1155)	UI	f	Content Sequence:Referenced SOP Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
4841	(0027,"GEMS_IMAG_01",10)	OB	t	ScoutType	k
5546	(0054,0071)	US	f	Number of Time Slots	\N
4828	(0045,"GEMS_HELIOS_01",10)	OB	t	Start View 2A	k
4818	(0021,"GEMS_RELA_01",92)	OB	t	BiopsyTLocation	k
5547	(0054,0061)	US	f	Number of R-R Intervals	\N
6349	(0019,"FDMS 1.0",91)	SH	t	FilmAnnotationCharacterString2	k
6365	(0021,"FDMS 1.0",10)	CS	t	FCRImageID	d
6319	(0009,"GEMS_GENIE_1",28)	SL	t	Number RR Windows	k
6318	(0055,"GEMS_GENIE_1",12)[<0>](0055,"GEMS_GENIE_1",13)[<1>](0013,"GEMS_GENIE_1",16)	SL	t	eNTEGRA Energy Window Information Sequence:eNTEGRA Energy Window Range Sequence:AutoTrackPeak	k
4845	(0045,"GEMS_HELIOS_01",22)	OB	t	PeristalticFlag	k
6184	(0033,"SIEMENS MED NM",11)	FL	t	COR Data for Detector 2	k
4885	(0045,"GEMS_HELIOS_01",01)	OB	t	Number of Macro Rows in Detector	k
6050	(7005,"TOSHIBA_MEC_CT3",0b)	OB	t	Filter	k
5766	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",37)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Graphic Is Visible Flag	k
5706	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",48)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Projection Type	k
5824	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",56)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer DirectionalLight TwoSide Usage Flag	k
6061	(7005,"TOSHIBA_MEC_CT3",1d)	OB	t	Reconstruction Number	k
5600	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence	k
6354	(0009,"FDMS 1.0",09)	UL	t	PatientInformationVersionNo	k
6316	(0009,"GEMS_GENIE_1",26)	SL	t	NumberEnergySets	k
4787	(0053,"GEHC_CT_ADVAPP_001",42)	OB	t	Iterative Recon Configuration	k
1586	(0023,"GEMS_STDY_01",7d)	SS	t	IndicatesIfStudyHasCompleteInfo	k
161	(0021,"GEMS_RELA_01",05)	SH	t	GenesisVersionNow	k
6060	(7005,"TOSHIBA_MEC_CT3",0a)	OB	t	Table Speed in mm/rot	k
6087	(0045,"GEMS_SENO_02",55)	IS	t	A Coefficients	k
455	(0018,1250)	SH	f	Receive Coil Name	\N
6355	(0009,"FDMS 1.0",80)	LO	t	KanjiHospitalName	d
544	(0010,2110)	LO	f	Allergies	\N
6370	(0029,"FDMS 1.0",44)	CS	t	LineDensityCode	k
6197	(0041,"SIEMENS MED NM",06)	FD	t	Long Linear Drive Information for Detector 2	k
6285	(0055,"GEMS_GENIE_1",22)[<0>](0011,"GEMS_GENIE_1",3e)	SL	t	eNTEGRA Detector Information Sequence:FOVShape	k
6352	(0009,"FDMS 1.0",90)	ST	t	DistributionCode	k
6132	(0035,"SIEMENS MED NM",01)	LO	t	Energy Window Type	k
4853	(0045,"GEMS_HELIOS_01",09)	OB	t	Sigma Row number	k
2588	(0040,1003)	SH	f	Requested Procedure Priority	\N
2586	(0018,5101)	CS	f	View Position	\N
2304	(0008,1111)[<0>](0008,0014)	UI	f	Referenced Performed Procedure Step Sequence:Instance Creator UID	\N
2124	(300a,000a)	CS	f	Plan Intent	\N
2110	(0038,0016)	LO	f	Route of Admissions	\N
2123	(300a,00b0)[<0>](300a,0111)[<1>](300a,012e)	DS	f	Beam Sequence:Control Point Sequence:Surface Entry Point	\N
2122	(300a,000b)	LO	f	Treatment Sites	\N
6237	(0013,"GEMS_GENIE_1",26)	LT	t	StudyComments	k
6281	(0013,"GEMS_GENIE_1",10)	FD	t	DigitalFOV	k
4886	(0019,"GEMS_ACQU_01",04)	OB	t	CellSpacing	k
6133	(0033,"SIEMENS MED NM",32)	LO	t	Crystal Type	k
6257	(0011,"GEMS_GENIE_1",34)	LO	t	SpatialCorrectName	k
4821	(0045,"GEMS_HELIOS_01",11)	OB	t	Number of Views 2A	k
6086	(0045,"GEMS_SENO_02",52)	IS	t	Raw Diagnostic Low	k
4950	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",1e)	UN	t	Unknown	d
1775	(0018,1074)	DS	f	Radionuclide Total Dose	\N
6335	(0011,"GEMS_GDXE_FALCON_04",17)	CS	t	Override Mode	k
6367	(0029,"FDMS 1.0",50)	CS	t	DataCompressionCode	k
2850	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",18)	OB	t	Unknown:Unknown	d
546	(0010,4000)	LT	f	Patient Comments	\N
532	(0018,0082)	DS	f	Inversion Time	\N
542	(0010,2000)	LO	f	Medical Alerts	\N
550	(0018,9321)[<0>](0018,9330)	FD	f	CT Exposure Sequence:X-Ray Tube Current in mA	\N
549	(0018,9345)	FD	f	CTDIvol	\N
539	(0008,3010)	UI	f	Irradiation Event UID	\N
538	(0008,1032)[<0>](0008,0104)	LO	f	Procedure Code Sequence:Code Meaning	\N
4183	(0043,"dcm4che/archive",21)	SS	t	Unknown	d
6433	(0009,"SIEMENS CM VA0  LAB",13)	LO	t	DetectorIdentificationLabel	k
6362	(0009,"FDMS 1.0",10)	CS	t	ExposureUnitTypeCode	k
6187	(0033,"SIEMENS MED NM",25)	FL	t	BackProjection Correction angle head 2	k
6373	(50f1,"FDMS 1.0",20)	CS	t	Image Processing Modification Flag	k
6290	(0055,"GEMS_GENIE_1",22)[<0>](0011,"GEMS_GENIE_1",29)	SL	t	eNTEGRA Detector Information Sequence:Uniformity Mean	k
553	(0018,9321)[<0>](0018,9332)	FD	f	CT Exposure Sequence:Exposure in mAs	\N
2378	(2001,"Philips Imaging DD 001",8a)	DS	t	Sampling Percent	k
4798	(0043,"GEMS_PARM_01",64)	OB	t	Image Filter	d
4839	(0045,"GEMS_HELIOS_01",21)	OB	t	Iterbone Flag	k
4813	(0019,"GEMS_ACQU_01",52)	OB	t	ReconPostProcessingFlag	k
4836	(0019,"GEMS_ACQU_01",2c)	OB	t	NumberOfTriggers	k
4850	(0027,"GEMS_IMAG_01",45)	OB	t	NormalRCoord	k
4861	(0043,"GEMS_PARM_01",41)	OB	t	DegreeOfRotation	k
3513	(0018,7034)	CS	f	Field of View Horizontal Flip	\N
3518	(0018,7050)	CS	f	Filter Material	\N
3514	(0018,7000)	CS	f	Detector Conditions Nominal Flag	\N
4816	(0027,"GEMS_IMAG_01",1e)	OB	t	VmaMod	k
4831	(0045,"GEMS_HELIOS_01",15)	OB	t	Start View 2B	k
5998	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",94)	FL	t	Unknown:Unknown:Unknown	d
5598	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence	k
4876	(0045,"GEMS_HELIOS_01",12)	OB	t	Start View 1A	k
6350	(0019,"FDMS 1.0",90)	SH	t	FilmAnnotationCharacterString1	k
6308	(0011,"GEMS_GENIE_1",18)	SL	t	MGBinNumber	k
6269	(0011,"GEMS_GENIE_1",56)	FD	t	ElapsedTime	k
6417	(0021,"SIEMENS CT VA0  GEN",40)	IS	t	TableMoveDirectionCode	k
6423	(0009,"SIEMENS CM VA0  LAB",11)	LO	t	GantryIdentificationLabel	k
1448	(0009,"GEMS_IDEN_01",e4)	UN	t	Unknown	d
4937	(5001,"ELSCINT1",a8)	US	t	Unknown	d
4864	(0045,"GEMS_HELIOS_01",0b)	OB	t	Maximum Offset Value	k
4915	(0045,"GEMS_HELIOS_01",50)	OB	t	Unknown	d
4869	(0043,"GEMS_PARM_01",26)	OB	t	NoViewsRefChannelsBlocked	k
6232	(4453,"DR Systems, Inc.",05)	UN	t	File Suffix	k
6101	(0045,"GEMS_SENO_02",71)	DS	t	STX Buffer	k
2342	(0008,0100)	SH	f	Code Value	\N
2355	(0008,0104)	LO	f	Code Meaning	\N
2591	(0018,4000)	LT	f	Acquisition Comments	\N
2352	(0008,0102)	SH	f	Coding Scheme Designator	\N
6389	(0021,"SIEMENS CT VA0  RAW",10)	UL	t	CreationMask	k
4817	(0019,"GEMS_ACQU_01",43)	OB	t	TotalSegmentsRequested	k
6124	(0055,"SIEMENS MED NM",7e)	FL	t	Collimator Thickness mm	k
6207	(0041,"SIEMENS MED NM",02)	SL	t	Whole Body Tomo Number of Positions	k
6292	(0011,"GEMS_GENIE_1",1f)	SL	t	ImageOrientation	k
4797	(0045,"GEMS_HELIOS_01",3b)	OB	t	NoiseReductionImageFilterDesc	k
6161	(0041,"SIEMENS MED NM",03)	FL	t	Horizontal Table Position of CT scan	k
6314	(0011,"GEMS_GENIE_1",39)	SL	t	Compression Type	k
4884	(0053,"GEHC_CT_ADVAPP_001",67)	OB	t	Overlapped Recon Flag	k
6091	(0045,"GEMS_SENO_02",66)	IS	t	Asymmetrical Collimation Information	k
590	(0018,1242)	IS	f	Actual Frame Duration	\N
577	(0054,0016)	SQ	f	Radiopharmaceutical Information Sequence	\N
582	(0018,0074)	IS	f	Acquisition Start Condition Data	\N
566	(300c,0002)[<0>](0008,1150)	UI	f	Referenced RT Plan Sequence:Referenced SOP Class UID	\N
676	(0054,0414)[<0>](0008,0104)	LO	f	Patient Gantry Relationship Code Sequence:Code Meaning	\N
565	(300c,0002)[<0>](0008,1155)	UI	f	Referenced RT Plan Sequence:Referenced SOP Instance UID	\N
664	(0054,1103)	LO	f	Reconstruction Method	\N
654	(0054,0412)[<0>](0008,0100)	SH	f	Patient Orientation Modifier Code Sequence:Code Value	\N
586	(0054,1310)	IS	f	Primary (Prompts) Counts Accumulated	\N
575	(0054,0414)	SQ	f	Patient Gantry Relationship Code Sequence	\N
555	(0008,0014)	UI	f	Instance Creator UID	\N
589	(0054,1202)	IS	f	Transverse Mash	\N
552	(0018,9321)[<0>](0018,9324)	FD	f	CT Exposure Sequence:Estimated Dose Saving	\N
659	(0054,0412)[<0>](0008,0102)	SH	f	Patient Orientation Modifier Code Sequence:Coding Scheme Designator	\N
561	(3004,0002)	CS	f	Dose Units	\N
581	(0018,1149)	IS	f	Field of View Dimension(s)	\N
556	(300c,0002)	SQ	f	Referenced RT Plan Sequence	\N
650	(0054,0016)[<0>](0018,1079)	DT	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Stop DateTime	\N
587	(0018,0075)	IS	f	Acquisition Termination Condition Data	\N
652	(0054,0016)[<0>](0054,0304)[<1>](0008,0100)	SH	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Code Value	\N
682	(0054,0412)[<0>](0008,0104)	LO	f	Patient Orientation Modifier Code Sequence:Code Meaning	\N
663	(0054,0410)[<0>](0008,0100)	SH	f	Patient Orientation Code Sequence:Code Value	\N
554	(0010,21c0)	US	f	Pregnancy Status	\N
678	(0054,0016)[<0>](0054,0304)[<1>](0008,0104)	LO	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Code Meaning	\N
715	(0054,0016)[<0>](0018,1076)	DS	f	Radiopharmaceutical Information Sequence:Radionuclide Positron Fraction	\N
6069	(0019,"SIEMENS CT VA0  COAD",c0)	DS	t	Pulmo Water	k
4786	(0027,"GEMS_IMAG_01",44)	OB	t	CenterSCoordOfPlaneImage	k
6280	(0011,"GEMS_GENIE_1",19)	FD	t	RadiusOfRotation	k
5543	(f215,"PB group A",18)	UN	t	Unknown	d
706	(0054,0016)[<0>](0018,1071)	DS	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Volume	\N
6487	(0019,"SIEMENS CT VA0  COAD",c2)	DA	t	Pulmo Date	d
4838	(0045,"GEMS_HELIOS_01",32)	OB	t	TemporalResolution	k
123	(0008,0020)	DA	f	Study Date	\N
4783	(0019,"GEMS_ACQU_01",24)	OB	t	MidScanTime	k
819	(0020,0060)	CS	f	Laterality	\N
4801	(0043,"GEMS_PARM_01",31)	OB	t	RACoordOfTargetReconCentre	k
6279	(0013,"GEMS_GENIE_1",15)	FD	t	Fscalar	k
6173	(6000,0022)	UN	f	Overlay Description	\N
6116	(0054,0012)[<0>](0054,0013)	SQ	f	Energy Window Information Sequence:Energy Window Range Sequence	\N
4788	(0019,"GEMS_ACQU_01",03)	OB	t	CellNumberAtTheta	k
4862	(0043,"GEMS_PARM_01",40)	OB	t	TriggerOnPosition	k
6212	(6001,"SECTRA_OverlayInfo_01",01)	LO	t	Sectra Overlay	k
6458	(0029,"SIEMENS CM VA0  CMS",50)	CS	t	ArchiveCode	k
4808	(0043,"GEMS_PARM_01",45)	OB	t	DASAdInput	k
6128	(0054,0012)[<0>](0054,0018)	SH	f	Energy Window Information Sequence:Energy Window Name	\N
6171	(0054,0410)[<0>](0008,0005)	CS	f	Patient Orientation Code Sequence:Specific Character Set	\N
4844	(0045,"GEMS_HELIOS_01",0a)	OB	t	Minimum DAS value	k
4887	(0019,"GEMS_ACQU_01",27)	OB	t	GantryPeriod	k
6110	(0018,7050)	LT	f	Filter Material	\N
6144	(0054,0022)[<0>](0018,1183)	DS	f	Detector Information Sequence:X Focus Center	\N
5541	(07a3,"ELSCINT1",17)	UN	t	Unknown	d
4206	(5653,"",14)[<0>](5653,"",11)	OB	t	Unknown:Unknown	d
6523	(0023,"AMICAS0",01)	UI	t	Unknown	d
5582	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0070,0404)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Referenced Spatial Registration Sequence	k
6522	(0009,"GEMS_PETD_01",4b)	SL	t	Source Speed	k
5826	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",66)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Segmentation Display Color	k
697	(0009,"GEMS_PETD_01",0d)	LO	t	Scan Date Time	o
6521	(0009,"GEMS_PETD_01",41)	SL	t	Source 1 Holder	k
6103	(0045,"GEMS_SENO_02",56)	DS	t	Noise Reduction Sensitivity	k
6348	(0009,"FDMS 1.0",92)	SH	t	KanjiDepartmentName	k
6271	(0055,"GEMS_GENIE_1",22)[<0>](0035,"GEMS_GENIE_1",01)	FD	t	eNTEGRA Detector Information Sequence:Start Angle	k
6328	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1110)[<1>](0008,1155)	UI	t	CTVESequence:Referenced Study Sequence:Referenced SOP Instance UID	k
6483	(0029,"SIEMENS MED MG",20)	US	t	ListOfElementNumbers	k
6200	(0041,"SIEMENS MED NM",07)	FD	t	Trunnion Information for Detector 1	k
6098	(0045,"GEMS_SENO_02",51)	UI	t	Fallback Series UID (CR or SC)	h
6206	(0041,"SIEMENS MED NM",01)	SL	t	Whole Body Tomo Position Index	k
660	(0009,"GEMS_PETD_01",15)	SH	t	Landmark Abbrev	k
767	(0009,"GEMS_PETD_01",19)	SL	t	Scan Mode	k
751	(0009,"GEMS_PETD_01",27)	SL	t	Theta Compression	k
1122	(0009,"GEMS_PETD_01",0c)	SH	t	Scan Software Version	k
6140	(0054,0052)[<0>](0018,1131)	DS	f	Rotation Information Sequence:Table Traverse	\N
684	(0009,"GEMS_PETD_01",0e)	LO	t	Scan Ready	o
1819	(0028,1056)	CS	f	VOI LUT Function	\N
1809	(0018,9302)	CS	f	Acquisition Type	\N
717	(0054,1322)	DS	f	Dose Calibration Factor	\N
1825	(0040,030e)[<0>](0020,0011)	IS	f	Exposure Dose Sequence:Series Number	\N
1824	(0040,030e)[<0>](0018,1302)	IS	f	Exposure Dose Sequence:Scan Length	\N
1808	(0018,1141)	DS	f	Angular Position	\N
807	(0040,0012)	LO	f	Pre-Medication	\N
805	(0008,2111)	ST	f	Derivation Description	\N
708	(0018,1063)	DS	f	Frame Time	\N
718	(0054,1002)	CS	f	Counts Source	\N
726	(0018,1147)	CS	f	Field of View Shape	\N
724	(0018,0073)	CS	f	Acquisition Start Condition	\N
713	(0054,0016)[<0>](0018,1074)	DS	f	Radiopharmaceutical Information Sequence:Radionuclide Total Dose	\N
704	(0054,1321)	DS	f	Decay Factor	\N
806	(0008,002a)	DT	f	Acquisition DateTime	\N
703	(0054,1324)	DS	f	Dead Time Factor	\N
719	(0028,0051)	CS	f	Corrected Image	\N
714	(0054,0016)[<0>](0018,1075)	DS	f	Radiopharmaceutical Information Sequence:Radionuclide Half Life	\N
4835	(0043,"GEMS_PARM_01",10)	OB	t	WindowValue	k
4944	(0040,030e)[<0>](00e1,"ELSCINT1",37)	DS	t	Exposure Dose Sequence:Total Dose Savings	k
4823	(0027,"GEMS_IMAG_01",43)	OB	t	CenterACoordOfPlaneImage	k
4901	(0045,"GEMS_HELIOS_01",55)	CS	t	Unknown	d
1856	(0040,030e)[<0>](0018,115a)	CS	f	Exposure Dose Sequence:Radiation Mode	\N
2454	(0040,0260)[<0>](0008,010b)	CS	f	Performed Protocol Code Sequence:Context Group Extension Flag	\N
2447	(0008,1032)[<0>](0008,010b)	CS	f	Procedure Code Sequence:Context Group Extension Flag	\N
6609	(0020,1001)	IS	f	Acquisitions in Series	\N
1063	(300a,00b0)[<0>](300a,00f4)[<1>](300a,0106)	DS	f	Beam Sequence:Block Sequence:Block Data	\N
1060	(300a,0004)	ST	f	RT Plan Description	\N
3210	(2010,0140)	CS	f	Trim	\N
4874	(0019,"GEMS_ACQU_01",42)	OB	t	SegmentNumber	k
3315	(0040,a730)[<0>](0040,a168)[<1>](0008,0102)	SH	f	Content Sequence:Concept Code Sequence:Coding Scheme Designator	\N
3319	(0040,a043)[<0>](0008,0102)	SH	f	Concept Name Code Sequence:Coding Scheme Designator	\N
3320	(0040,a730)[<0>](0040,a043)[<1>](0008,0102)	SH	f	Content Sequence:Concept Name Code Sequence:Coding Scheme Designator	\N
3316	(0040,a043)[<0>](0008,0100)	SH	f	Concept Name Code Sequence:Code Value	\N
3314	(0040,a730)[<0>](0040,a168)[<1>](0008,0100)	SH	f	Content Sequence:Concept Code Sequence:Code Value	\N
3318	(0040,a730)[<0>](0040,a043)[<1>](0008,0100)	SH	f	Content Sequence:Concept Name Code Sequence:Code Value	\N
937	(3006,0010)[<0>](3006,0012)[<1>](3006,0014)[<2>](3006,0016)[<3>](0008,1150)	UI	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:RT Referenced Series Sequence:Contour Image Sequence:Referenced SOP Class UID	\N
4933	(5001,"ELSCINT1",a0)	CS	t	Unknown	d
1858	(0040,030e)[<0>](0018,9324)	FD	f	Exposure Dose Sequence:Estimated Dose Saving	\N
926	(3006,0020)[<0>](3006,0036)	CS	f	Structure Set ROI Sequence:ROI Generation Algorithm	\N
946	(300c,0060)	SQ	f	Referenced Structure Set Sequence	\N
876	(0010,2180)	SH	f	Occupation	\N
875	(0010,2160)	SH	f	Ethnic Group	\N
924	(3006,0039)[<0>](3006,0040)[<1>](3006,0042)	CS	f	ROI Contour Sequence:Contour Sequence:Contour Geometric Type	\N
1867	(0018,9352)	FL	f	Calcium Scoring Mass Factor Device	\N
922	(3006,0080)[<0>](3006,00b0)[<1>](3006,00b4)	DS	f	RT ROI Observations Sequence:ROI Physical Properties Sequence:ROI Physical Property Value	\N
1843	(0040,030e)[<0>](0008,002a)	DT	f	Exposure Dose Sequence:Acquisition DateTime	\N
1872	(0008,0041)	LO	f	Data Set Subtype	\N
1848	(0040,030e)[<0>](0018,1160)	SH	f	Exposure Dose Sequence:Filter Type	\N
905	(3006,0020)	SQ	f	Structure Set ROI Sequence	\N
929	(3006,0009)	TM	f	Structure Set Time	\N
950	(300a,00b0)[<0>](300a,0111)[<1>](300a,011a)	SQ	f	Beam Sequence:Control Point Sequence:Beam Limiting Device Position Sequence	\N
917	(3006,0080)[<0>](3006,0084)	IS	f	RT ROI Observations Sequence:Referenced ROI Number	\N
919	(3006,0039)[<0>](3006,002a)	IS	f	ROI Contour Sequence:ROI Display Color	\N
1851	(0040,030e)[<0>](0008,103e)	LO	f	Exposure Dose Sequence:Series Description	\N
1852	(0040,030e)[<0>](0020,1041)	DS	f	Exposure Dose Sequence:Slice Location	\N
1874	(0008,0040)	US	f	Data Set Type	\N
1857	(0040,030e)[<0>](0018,7050)	CS	f	Exposure Dose Sequence:Filter Material	\N
891	(0032,1064)[<0>](0008,0100)	SH	f	Requested Procedure Code Sequence:Code Value	\N
930	(3006,0010)[<0>](3006,0012)[<1>](3006,0014)[<2>](3006,0016)[<3>](0008,1155)	UI	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:RT Referenced Series Sequence:Contour Image Sequence:Referenced SOP Instance UID	\N
923	(3006,0020)[<0>](3006,002c)	DS	f	Structure Set ROI Sequence:ROI Volume	\N
935	(3006,0010)[<0>](3006,0012)[<1>](0008,1150)	UI	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:Referenced SOP Class UID	\N
906	(3006,0010)[<0>](3006,0012)[<1>](3006,0014)	SQ	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:RT Referenced Series Sequence	\N
925	(300e,0002)	CS	f	Approval Status	\N
902	(3006,0010)[<0>](3006,0012)[<1>](3006,0014)[<2>](3006,0016)	SQ	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:RT Referenced Series Sequence:Contour Image Sequence	\N
899	(0018,1201)	TM	f	Time of Last Calibration	\N
916	(3006,0020)[<0>](3006,0022)	IS	f	Structure Set ROI Sequence:ROI Number	\N
913	(3006,0004)	LO	f	Structure Set Name	\N
907	(3006,0010)	SQ	f	Referenced Frame of Reference Sequence	\N
989	(300a,00b0)[<0>](300a,0111)[<1>](300a,0129)	DS	f	Beam Sequence:Control Point Sequence:Table Top Longitudinal Position	\N
964	(300a,00b0)[<0>](300c,006a)	IS	f	Beam Sequence:Referenced Patient Setup Number	\N
1058	(300a,00b0)[<0>](300a,00f4)	SQ	f	Beam Sequence:Block Sequence	\N
1009	(300a,0006)	DA	f	RT Plan Date	\N
991	(300a,00b0)[<0>](300a,0111)[<1>](300a,012a)	DS	f	Beam Sequence:Control Point Sequence:Table Top Lateral Position	\N
1061	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00fc)	IS	f	Beam Sequence:Block Sequence:Block Number	\N
2592	(0018,1600)	CS	f	Shutter Shape	\N
5899	(7033,"CtProjectionData-MayoClinc-v1",0e)	UN	t	Unknown	d
3212	(2010,0040)	CS	f	Film Orientation	\N
1464	(3006,0024)	UI	f	Referenced Frame of Reference UID	\N
551	(0018,9321)[<0>](0018,9328)	FD	f	CT Exposure Sequence:Exposure Time in ms	\N
725	(0018,0071)	CS	f	Acquisition Termination Condition	\N
1411	(0088,0200)[<0>](0028,1202)	OW	f	Icon Image Sequence:Green Palette Color Lookup Table Data	\N
1311	(0008,1250)[<0>](0020,000e)	UI	f	Related Series Sequence:Series Instance UID	\N
1889	(0040,9096)	SQ	f	Real World Value Mapping Sequence	\N
1893	(0040,9096)[<0>](0040,08ea)[<1>](0008,0102)	SH	f	Real World Value Mapping Sequence:Measurement Units Code Sequence:Coding Scheme Designator	\N
1209	(6000,0050)	SS	f	Overlay Origin	\N
1890	(0070,0403)	FL	f	Relative Opacity	\N
1891	(0040,9096)[<0>](0040,9211)	SS	f	Real World Value Mapping Sequence:Real World Value Last Value Mapped	\N
1887	(0008,1140)[<0>](0040,a170)	SQ	f	Referenced Image Sequence:Purpose of Reference Code Sequence	\N
1892	(0040,9096)[<0>](0040,9216)	SS	f	Real World Value Mapping Sequence:Real World Value First Value Mapped	\N
1002	(300a,00b0)[<0>](300a,0111)[<1>](300a,0126)	CS	f	Beam Sequence:Control Point Sequence:Table Top Eccentric Rotation Direction	\N
958	(300a,00b0)[<0>](300a,00c0)	IS	f	Beam Sequence:Beam Number	\N
965	(300a,0070)[<0>](300a,0071)	IS	f	Fraction Group Sequence:Fraction Group Number	\N
1004	(300a,00b0)[<0>](300a,0111)[<1>](300a,0121)	CS	f	Beam Sequence:Control Point Sequence:Beam Limiting Device Rotation Direction	\N
960	(300a,0070)[<0>](300c,0004)[<1>](300c,0006)	IS	f	Fraction Group Sequence:Referenced Beam Sequence:Referenced Beam Number	\N
999	(300a,0180)[<0>](0018,5100)	CS	f	Patient Setup Sequence:Patient Position	\N
969	(300a,00b0)[<0>](300a,00ed)	IS	f	Beam Sequence:Number of Boli	\N
961	(300a,0040)[<0>](300a,0042)	IS	f	Tolerance Table Sequence:Tolerance Table Number	\N
971	(300a,0070)[<0>](300a,00a0)	IS	f	Fraction Group Sequence:Number of Brachy Application Setups	\N
979	(300a,00b0)[<0>](300a,0111)[<1>](300a,011e)	DS	f	Beam Sequence:Control Point Sequence:Gantry Angle	\N
1005	(300a,00b0)[<0>](300a,00b3)	CS	f	Beam Sequence:Primary Dosimeter Unit	\N
974	(300a,00b0)[<0>](300a,0111)[<1>](300a,011a)[<2>](300a,011c)	DS	f	Beam Sequence:Control Point Sequence:Beam Limiting Device Position Sequence:Leaf/Jaw Positions	\N
970	(300a,00b0)[<0>](300a,00d0)	IS	f	Beam Sequence:Number of Wedges	\N
3213	(0018,1508)	CS	f	Positioner Type	\N
4892	(0137,"NetRAAD",0d)	UN	t	Unknown	d
4097	(0019,"SIEMENS MR HEADER",27)	FD	t	B Matrix	k
1003	(300a,00b0)[<0>](300a,0111)[<1>](300a,011f)	CS	f	Beam Sequence:Control Point Sequence:Gantry Rotation Direction	\N
957	(300a,00b0)[<0>](300a,0111)[<1>](300a,0112)	IS	f	Beam Sequence:Control Point Sequence:Control Point Index	\N
968	(300a,00b0)[<0>](300a,00f0)	IS	f	Beam Sequence:Number of Blocks	\N
997	(300a,00b0)[<0>](300a,00ce)	CS	f	Beam Sequence:Treatment Delivery Type	\N
962	(300a,00b0)[<0>](300a,0110)	IS	f	Beam Sequence:Number of Control Points	\N
1055	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00e1)	SH	f	Beam Sequence:Block Sequence:Material ID	\N
1006	(300a,0007)	TM	f	RT Plan Time	\N
1057	(300a,00b0)[<0>](300a,0107)[<1>](300a,0108)	SH	f	Beam Sequence:Applicator Sequence:Applicator ID	\N
951	(300a,0040)	SQ	f	Tolerance Table Sequence	\N
985	(300a,00b0)[<0>](300a,0111)[<1>](300a,012c)	DS	f	Beam Sequence:Control Point Sequence:Isocenter Position	\N
990	(300a,00b0)[<0>](300a,0111)[<1>](300a,0128)	DS	f	Beam Sequence:Control Point Sequence:Table Top Vertical Position	\N
966	(300a,00b0)[<0>](300a,00b6)[<1>](300a,00bc)	IS	f	Beam Sequence:Beam Limiting Device Sequence:Number of Leaf/Jaw Pairs	\N
981	(300a,0070)[<0>](300c,0004)[<1>](300a,0084)	DS	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Dose	\N
1881	(0010,21d0)	DA	f	Last Menstrual Date	\N
1888	(0040,9096)[<0>](0040,08ea)	SQ	f	Real World Value Mapping Sequence:Measurement Units Code Sequence	\N
1079	(0032,1050)	DA	f	Study Completion Date	\N
1417	(0088,0200)[<0>](0028,0100)	US	f	Icon Image Sequence:Bits Allocated	\N
1149	(0010,21a0)	CS	f	Smoking Status	\N
723	(0054,1100)	CS	f	Randoms Correction Method	\N
559	(3004,000c)	DS	f	Grid Frame Offset Vector	\N
1166	(5000,0022)	UN	f	Curve Description	\N
1183	(5008,0005)	UN	f	Curve Dimensions	\N
1001	(300a,00b0)[<0>](300a,0111)[<1>](300a,0123)	CS	f	Beam Sequence:Control Point Sequence:Patient Support Rotation Direction	\N
665	(0054,1105)	LO	f	Scatter Correction Method	\N
1899	(0040,9096)[<0>](0028,3003)	LO	f	Real World Value Mapping Sequence:LUT Explanation	\N
1894	(0008,1140)[<0>](0040,a170)[<1>](0008,0100)	SH	f	Referenced Image Sequence:Purpose of Reference Code Sequence:Code Value	\N
1896	(0040,9096)[<0>](0040,08ea)[<1>](0008,0100)	SH	f	Real World Value Mapping Sequence:Measurement Units Code Sequence:Code Value	\N
1443	(0018,a001)[<0>](0008,1090)	LO	f	Contributing Equipment Sequence:Manufacturer's Model Name	\N
1172	(0008,0061)	CS	f	Modalities in Study	\N
56	(7fe0,0010)	OW	f	Pixel Data	\N
1059	(300a,00b0)[<0>](300a,0107)	SQ	f	Beam Sequence:Applicator Sequence	\N
1103	(0020,9056)	SH	f	Stack ID	\N
1167	(0028,0034)	IS	f	Pixel Aspect Ratio	\N
1109	(0040,0260)[<0>](0008,0102)	SH	f	Performed Protocol Code Sequence:Coding Scheme Designator	\N
1897	(0008,1140)[<0>](0040,a170)[<1>](0008,0102)	SH	f	Referenced Image Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
1077	(0032,1001)	TM	f	Scheduled Study Start Time	\N
1110	(0040,0260)[<0>](0008,0100)	SH	f	Performed Protocol Code Sequence:Code Value	\N
1101	(0020,9057)	UL	f	In-Stack Position Number	\N
1066	(300a,00b0)[<0>](300a,00f4)[<1>](300a,0100)	DS	f	Beam Sequence:Block Sequence:Block Thickness	\N
1895	(0040,9096)[<0>](0040,08ea)[<1>](0008,0103)	SH	f	Real World Value Mapping Sequence:Measurement Units Code Sequence:Coding Scheme Version	\N
1111	(0040,0260)	SQ	f	Performed Protocol Code Sequence	\N
1898	(0040,9096)[<0>](0040,9210)	SH	f	Real World Value Mapping Sequence:LUT Label	\N
1900	(0040,9096)[<0>](0040,08ea)[<1>](0008,0104)	LO	f	Real World Value Mapping Sequence:Measurement Units Code Sequence:Code Meaning	\N
1068	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00fa)	CS	f	Beam Sequence:Block Sequence:Block Divergence	\N
4781	(0019,"GEMS_ACQU_01",18)	OB	t	FirstScanRAS	k
1241	(0040,0555)[<0>](0040,a168)[<1>](0008,0100)	SH	f	Acquisition Context Sequence:Concept Code Sequence:Code Value	\N
1236	(0040,0555)[<0>](0040,a043)	SQ	f	Acquisition Context Sequence:Concept Name Code Sequence	\N
986	(300a,00b0)[<0>](300a,0111)[<1>](300a,0122)	DS	f	Beam Sequence:Control Point Sequence:Patient Support Angle	\N
928	(3006,0080)[<0>](3006,00b0)[<1>](3006,00b2)	CS	f	RT ROI Observations Sequence:ROI Physical Properties Sequence:ROI Physical Property	\N
1231	(6000,0100)	US	f	Overlay Bits Allocated	\N
1201	(500a,0022)	UN	f	Curve Description	\N
1227	(6000,0040)	CS	f	Overlay Type	\N
1202	(5008,0022)	UN	f	Curve Description	\N
1239	(0028,0109)	SS	f	Largest Pixel Value in Series	\N
1323	(0054,0016)[<0>](0054,0302)[<1>](0008,0102)	SH	f	Radiopharmaceutical Information Sequence:Administration Route Code Sequence:Coding Scheme Designator	\N
1197	(5002,0020)	UN	f	Type of Data	\N
533	(0008,1032)[<0>](0008,0100)	SH	f	Procedure Code Sequence:Code Value	\N
1249	(0018,1071)	DS	f	Radiopharmaceutical Volume	\N
588	(0054,1201)	IS	f	Axial Mash	\N
973	(300a,0070)[<0>](300a,0080)	IS	f	Fraction Group Sequence:Number of Beams	\N
911	(3006,0039)[<0>](3006,0040)[<1>](3006,0016)	SQ	f	ROI Contour Sequence:Contour Sequence:Contour Image Sequence	\N
727	(0054,0202)	CS	f	Type of Detector Motion	\N
711	(0054,0013)[<0>](0054,0015)	DS	f	Energy Window Range Sequence:Energy Window Upper Limit	\N
893	(0008,1032)[<0>](0008,0102)	SH	f	Procedure Code Sequence:Coding Scheme Designator	\N
903	(3006,0010)[<0>](3006,0012)	SQ	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence	\N
2549	(0018,9089)	FD	f	Diffusion Gradient Orientation	\N
1064	(300a,00b0)[<0>](300a,00f4)[<1>](300a,0102)	DS	f	Beam Sequence:Block Sequence:Block Transmission	\N
661	(0054,0414)[<0>](0008,0100)	SH	f	Patient Gantry Relationship Code Sequence:Code Value	\N
2555	(0018,9073)	FD	f	Acquisition Duration	\N
2548	(0018,9087)	FD	f	Diffusion b-value	\N
2559	(0040,0251)	TM	f	Performed Procedure Step End Time	\N
2556	(0008,1111)[<0>](0008,0013)	TM	f	Referenced Performed Procedure Step Sequence:Instance Creation Time	\N
4855	(0043,"GEMS_PARM_01",42)	OB	t	DASTriggerSource	k
4945	(0040,030e)[<0>](01e1,"ELSCINT1",26)	CS	t	Exposure Dose Sequence:Phantom Type	k
3590	(0019,"SIEMENS CT VA0  COAD",b1)	UN	t	Unknown	d
938	(3006,0039)[<0>](3006,0040)[<1>](3006,0016)[<2>](0008,1150)	UI	f	ROI Contour Sequence:Contour Sequence:Contour Image Sequence:Referenced SOP Class UID	\N
96	(0008,0013)	TM	f	Instance Creation Time	\N
16	(0032,1030)	LO	f	Reason for Study	\N
1923	(0018,1022)	SH	f	Video Image Format Acquired	\N
332	(0018,9305)	FD	f	Revolution Time	\N
1215	(0012,0050)	LO	f	Clinical Trial Time Point ID	\N
1242	(0040,0555)[<0>](0040,a043)[<1>](0008,0102)	SH	f	Acquisition Context Sequence:Concept Name Code Sequence:Coding Scheme Designator	\N
1312	(0008,1111)[<0>](0008,1155)	UI	f	Referenced Performed Procedure Step Sequence:Referenced SOP Instance UID	\N
1220	(0008,0080)	LO	f	Institution Name	\N
1211	(0018,1018)	LO	f	Secondary Capture Device Manufacturer's Model Name	\N
1237	(0040,0555)[<0>](0040,a168)	SQ	f	Acquisition Context Sequence:Concept Code Sequence	\N
1240	(0040,0555)[<0>](0040,a043)[<1>](0008,0100)	SH	f	Acquisition Context Sequence:Concept Name Code Sequence:Code Value	\N
1309	(0008,1111)[<0>](0008,1150)	UI	f	Referenced Performed Procedure Step Sequence:Referenced SOP Class UID	\N
1229	(6000,0011)	US	f	Overlay Columns	\N
4805	(0019,"GEMS_ACQU_01",1a)	OB	t	LastScanRAS	k
6028	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",31)	LT	t	Unknown:Unknown	d
4847	(0019,"GEMS_ACQU_01",02)	OB	t	NumberOfCellsInDetector	k
488	(0043,"GEMS_PARM_01",0b)	DS	t	PeakRateOfChangeOfGradientField	k
5933	(3f01,"INTELERAD MEDICAL SYSTEMS",14)	LO	t	Unknown	d
1151	(0020,0062)	CS	f	Image Laterality	\N
4809	(0045,"GEMS_HELIOS_01",18)	OB	t	Number of Views 1B	k
4921	(5001,"ELSCINT1",93)	UL	t	Unknown	d
4825	(0027,"GEMS_IMAG_01",51)	OB	t	TableEndLocation	k
4871	(0045,"GEMS_HELIOS_01",07)	OB	t	Z smoothing Factor	k
254	(0019,"GEMS_ACQU_01",5f)	SL	t	IncrementBetweenChannels	k
2599	(0040,0008)[<0>](0008,0100)	SH	f	Scheduled Protocol Code Sequence:Code Value	\N
2600	(0040,0008)[<0>](0008,0102)	SH	f	Scheduled Protocol Code Sequence:Coding Scheme Designator	\N
2601	(0040,0008)[<0>](0008,0104)	LO	f	Scheduled Protocol Code Sequence:Code Meaning	\N
1337	(0054,0016)[<0>](0054,0300)[<1>](0008,010f)	CS	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Context Identifier	\N
1339	(0054,0414)[<0>](0008,0105)	CS	f	Patient Gantry Relationship Code Sequence:Mapping Resource	\N
1392	(0008,1032)[<0>](0008,0103)	SH	f	Procedure Code Sequence:Coding Scheme Version	\N
683	(0054,0016)[<0>](0054,0300)[<1>](0008,0104)	LO	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Code Meaning	\N
1325	(0008,1250)[<0>](0040,a170)[<1>](0008,0104)	LO	f	Related Series Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
1432	(0018,a001)[<0>](0040,a170)[<1>](0008,0100)	SH	f	Contributing Equipment Sequence:Purpose of Reference Code Sequence:Code Value	\N
1153	(0018,1081)	IS	f	Low R-R Value	\N
531	(0032,4000)	LT	f	Study Comments	\N
98	(0040,0245)	TM	f	Performed Procedure Step Start Time	\N
980	(300a,00b0)[<0>](300a,0111)[<1>](300a,0115)	DS	f	Beam Sequence:Control Point Sequence:Dose Rate Set	\N
6	(0018,0024)	SH	f	Sequence Name	\N
19	(0018,1020)	LO	f	Software Version(s)	\N
904	(3006,0080)	SQ	f	RT ROI Observations Sequence	\N
1341	(0054,0410)[<0>](0008,0105)	CS	f	Patient Orientation Code Sequence:Mapping Resource	\N
1343	(0054,0410)[<0>](0008,010f)	CS	f	Patient Orientation Code Sequence:Context Identifier	\N
1334	(0054,0016)[<0>](0054,0300)[<1>](0008,0106)	DT	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Context Group Version	\N
1336	(0054,0414)[<0>](0008,010f)	CS	f	Patient Gantry Relationship Code Sequence:Context Identifier	\N
1444	(0028,0301)	CS	f	Burned In Annotation	\N
1967	(5000,0103)	US	f	Data Value Representation	\N
1974	(0018,6011)[<0>](0018,601a)	UL	f	Sequence of Ultrasound Regions:Region Location Min Y0	\N
1972	(0018,6011)[<0>](0018,601c)	UL	f	Sequence of Ultrasound Regions:Region Location Max X1	\N
1961	(2100,0050)	TM	f	Creation Time	\N
1985	(0018,6011)[<0>](0018,602a)	FD	f	Sequence of Ultrasound Regions:Reference Pixel Physical Value Y	\N
1966	(5000,0005)	US	f	Curve Dimensions	\N
1947	(5000,3000)	OB	f	Curve Data	\N
1984	(0018,6031)	CS	f	Transducer Type	\N
1971	(0018,6011)	SQ	f	Sequence of Ultrasound Regions	\N
1980	(0008,2120)	SH	f	Stage Name	\N
1978	(0008,2124)	IS	f	Number of Stages	\N
1982	(0040,0007)	LO	f	Scheduled Procedure Step Description	\N
1976	(0018,6011)[<0>](0018,6016)	UL	f	Sequence of Ultrasound Regions:Region Flags	\N
1981	(0040,0009)	SH	f	Scheduled Procedure Step ID	\N
1957	(5000,0020)	CS	f	Type of Data	\N
1965	(5000,0010)	US	f	Number of Points	\N
1970	(2100,0040)	DA	f	Creation Date	\N
1973	(0018,6011)[<0>](0018,6018)	UL	f	Sequence of Ultrasound Regions:Region Location Min X0	\N
1979	(0008,2122)	IS	f	Stage Number	\N
1987	(0018,6011)[<0>](0018,602c)	FD	f	Sequence of Ultrasound Regions:Physical Delta X	\N
1977	(0008,212a)	IS	f	Number of Views in Stage	\N
1986	(0018,6011)[<0>](0018,602e)	FD	f	Sequence of Ultrasound Regions:Physical Delta Y	\N
1975	(0018,6011)[<0>](0018,601e)	UL	f	Sequence of Ultrasound Regions:Region Location Max Y1	\N
1983	(0018,5010)	LO	f	Transducer Data	\N
1468	(0008,9215)	SQ	f	Derivation Code Sequence	\N
4917	(0045,"GEMS_HELIOS_01",51)	OB	t	Unknown	d
4137	(5653,"",15)	UN	t	Unknown	d
4899	(0045,"GEMS_HELIOS_01",56)	LO	t	Unknown	d
3329	(0040,a043)[<0>](0008,0104)	LO	f	Concept Name Code Sequence:Code Meaning	\N
4913	(0045,"GEMS_HELIOS_01",52)	OB	t	Unknown	d
3606	(0051,"SIEMENS MR HEADER",08)	UN	t	CSA Image Header Type	k
3615	(0051,"SIEMENS MR HEADER",13)	UN	t	Positive PCS Directions	k
2120	(0053,"GEHC_CT_ADVAPP_001",68)	IS	t	Row Number Anotation Flag	K
4554	(0071,"SIEMENS MED PT",24)	UN	t	Time Slice Duration	k
5957	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",69)[<1>](0057,"GEMS_VXTLSTATE_001",71)	IS	t	Unknown:Unknown:Unknown	d
910	(3006,0080)[<0>](3006,00b0)	SQ	f	RT ROI Observations Sequence:ROI Physical Properties Sequence	\N
39	(0020,1041)	DS	f	Slice Location	\N
4849	(0043,"GEMS_PARM_01",4e)	OB	t	DurationOfXrayOn	k
4859	(0027,"GEMS_IMAG_01",47)	OB	t	NormalSCoord	k
3616	(0019,"SIEMENS MR HEADER",16)	UN	t	Time After Start	k
2919	(2010,0010)	ST	f	Image Display Format	\N
669	(0009,"GEMS_PETD_01",37)	LO	t	Batch Description	k
728	(0018,1181)	CS	f	Collimator Type	\N
1204	(0012,0051)	ST	f	Clinical Trial Time Point Description	\N
1171	(0020,1209)	IS	f	Number of Series Related Instances	\N
172	(0018,1151)	IS	f	X-Ray Tube Current	\N
115	(0028,0106)	US	f	Smallest Image Pixel Value	\N
645	(0028,0106)	SS	f	Smallest Image Pixel Value	\N
701	(0054,0410)[<0>](0008,0104)	LO	f	Patient Orientation Code Sequence:Code Meaning	\N
988	(300a,00b0)[<0>](300a,00b4)	DS	f	Beam Sequence:Source-Axis Distance	\N
956	(300a,00b0)[<0>](0008,0070)	LO	f	Beam Sequence:Manufacturer	\N
1410	(0088,0200)[<0>](0028,1203)	OW	f	Icon Image Sequence:Blue Palette Color Lookup Table Data	\N
1321	(0008,1250)[<0>](0040,a170)[<1>](0008,0100)	SH	f	Related Series Sequence:Purpose of Reference Code Sequence:Code Value	\N
1191	(500a,0103)	UN	f	Data Value Representation	\N
1461	(3006,00c2)	UI	f	Related Frame of Reference UID	\N
1324	(0008,1250)[<0>](0040,a170)[<1>](0008,0102)	SH	f	Related Series Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
1253	(0008,1120)	SQ	f	Referenced Patient Sequence	\N
1032	(0040,0004)	DA	f	Scheduled Procedure Step End Date	\N
1096	(0018,9324)	FD	f	Estimated Dose Saving	\N
1175	(5006,0022)	UN	f	Curve Description	\N
1463	(0008,1155)	UI	f	Referenced SOP Instance UID	\N
1223	(0018,1200)	DS	f	Date of Last Calibration	\N
199	(0018,1130)	DS	f	Table Height	\N
112	(0028,0002)	US	f	Samples per Pixel	\N
975	(300a,00b0)[<0>](300a,00b6)[<1>](300a,00be)	DS	f	Beam Sequence:Beam Limiting Device Sequence:Leaf Position Boundaries	\N
702	(0054,1323)	DS	f	Scatter Fraction Factor	\N
920	(3006,0080)[<0>](3006,00a6)	PN	f	RT ROI Observations Sequence:ROI Interpreter	\N
912	(3006,0020)[<0>](3006,0026)	LO	f	Structure Set ROI Sequence:ROI Name	\N
149	(0008,2112)	SQ	f	Source Image Sequence	\N
1210	(0008,1010)	SH	f	Station Name	\N
983	(300a,00b0)[<0>](300a,0111)[<1>](300a,0125)	DS	f	Beam Sequence:Control Point Sequence:Table Top Eccentric Angle	\N
122	(0008,0022)	DA	f	Acquisition Date	\N
808	(0032,1070)	LO	f	Requested Contrast Agent	\N
707	(0054,1210)	DS	f	Coincidence Window Width	\N
1065	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00f6)	DS	f	Beam Sequence:Block Sequence:Source to Block Tray Distance	\N
1150	(0018,1121)	DS	f	Gantry/Detector Slew	\N
651	(0054,0016)[<0>](0018,1078)	DT	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Start DateTime	\N
1469	(0008,9215)[<0>](0008,0100)	SH	f	Derivation Code Sequence:Code Value	\N
2622	(0040,9096)[<0>](0040,9210)	SS	f	Real World Value Mapping Sequence:LUT Label	\N
634	(0009,"GEMS_PETD_01",cd)	FL	t	vqc_y_axis_trans	k
5917	(7039,"CtProjectionData-MayoClinc-v1",08)	UN	t	Unknown	d
978	(300a,00b0)[<0>](300a,00b6)[<1>](300a,00ba)	DS	f	Beam Sequence:Beam Limiting Device Sequence:Source to Beam Limiting Device Distance	\N
101	(0008,0018)	UI	f	SOP Instance UID	\N
4940	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7f)	UN	t	Unknown	d
541	(0038,0050)	LO	f	Special Needs	\N
583	(0054,1311)	IS	f	Secondary Counts Accumulated	\N
3613	(0051,"SIEMENS MR HEADER",19)	UN	t	Unknown	d
174	(0020,1002)	IS	f	Images in Acquisition	\N
1260	(0008,1120)[<0>](0008,1150)	UI	f	Referenced Patient Sequence:Referenced SOP Class UID	\N
1436	(0018,a001)[<0>](0040,a170)[<1>](0008,0104)	LO	f	Contributing Equipment Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
1439	(0018,a001)[<0>](0008,0080)	LO	f	Contributing Equipment Sequence:Institution Name	\N
4893	(0137,"NetRAAD",30)	UN	t	Unknown	d
1302	(0054,0016)[<0>](0054,0302)	SQ	f	Radiopharmaceutical Information Sequence:Administration Route Code Sequence	\N
1433	(0018,a001)[<0>](0040,a170)	SQ	f	Contributing Equipment Sequence:Purpose of Reference Code Sequence	\N
4907	(0053,"GEHC_CT_ADVAPP_001",6f)	UN	t	Unknown	d
2201	(2005,"Philips MR Imaging DD 001",2a)	IS	t	Patient Reference ID	k
1182	(5002,0103)	UN	f	Data Value Representation	\N
1421	(0088,0200)[<0>](0028,0102)	US	f	Icon Image Sequence:High Bit	\N
1413	(0088,0200)[<0>](0028,0004)	CS	f	Icon Image Sequence:Photometric Interpretation	\N
1342	(0054,0016)[<0>](0054,0300)[<1>](0008,0105)	CS	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Mapping Resource	\N
972	(300a,0070)[<0>](300a,0078)	IS	f	Fraction Group Sequence:Number of Fractions Planned	\N
120	(0010,0030)	DA	f	Patient's Birth Date	\N
3611	(0019,"SIEMENS MR HEADER",12)	UN	t	Table Position Origin	k
3612	(0019,"SIEMENS MR HEADER",13)	UN	t	Ima Abs Table Position	k
3774	(2005,"Philips MR Imaging DD 005",55)	FD	t	Velocity Encoding Direction	k
3614	(0019,"SIEMENS MR HEADER",0b)	UN	t	Slice Measurement Duration	k
1813	(7005,"TOSHIBA_MEC_CT3",1f)	LO	t	Volume Number	d
3335	(0040,a730)[<0>](0040,a040)	CS	f	Content Sequence:Value Type	\N
3338	(0040,a040)	CS	f	Value Type	\N
3336	(0040,a050)	CS	f	Continuity Of Content	\N
3331	(0040,a730)[<0>](0040,a168)[<1>](0008,0104)	LO	f	Content Sequence:Concept Code Sequence:Code Meaning	\N
3334	(0040,a504)[<0>](0040,db00)	CS	f	Content Template Sequence:Template Identifier	\N
3345	(0040,a032)	DT	f	Observation DateTime	\N
3333	(0040,a730)[<0>](0040,a010)	CS	f	Content Sequence:Relationship Type	\N
1116	(0054,0410)[<0>](0054,0412)[<1>](0008,0102)	SH	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Coding Scheme Designator	\N
1212	(0018,1019)	LO	f	Secondary Capture Device Software Versions	\N
947	(300a,0180)	SQ	f	Patient Setup Sequence	\N
1067	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00f8)	CS	f	Beam Sequence:Block Sequence:Block Type	\N
655	(0054,0410)[<0>](0008,0102)	SH	f	Patient Orientation Code Sequence:Coding Scheme Designator	\N
545	(0020,4000)	LT	f	Image Comments	\N
908	(3006,0039)	SQ	f	ROI Contour Sequence	\N
1307	(0008,1250)[<0>](0020,000d)	UI	f	Related Series Sequence:Study Instance UID	\N
1023	(0040,0005)	TM	f	Scheduled Procedure Step End Time	\N
1000	(300a,00b0)[<0>](300a,00c4)	CS	f	Beam Sequence:Beam Type	\N
944	(300a,00b0)[<0>](300a,00b6)	SQ	f	Beam Sequence:Beam Limiting Device Sequence	\N
116	(0028,0100)	US	f	Bits Allocated	\N
2661	(0040,2001)	LO	f	Reason for the Imaging Service Request	\N
952	(300a,00b0)	SQ	f	Beam Sequence	\N
2662	(0040,1002)	LO	f	Reason for the Requested Procedure	\N
2666	(0040,1400)	LT	f	Requested Procedure Comments	\N
2667	(0040,2400)	LT	f	Imaging Service Request Comments	\N
5955	(0057,"GEMS_VXTLSTATE_001",a4)	IS	t	Unknown	d
4031	(0019,"SIEMENS MR HEADER",0e)	UN	t	Diffusion Gradient Direction	k
193	(0028,1052)	DS	f	Rescale Intercept	\N
914	(3006,0039)[<0>](3006,0040)[<1>](3006,0046)	IS	f	ROI Contour Sequence:Contour Sequence:Number of Contour Points	\N
5936	(7005,"TOSHIBA_MEC_CT3",16)	OB	t	Volume UID	d
3267	(0051,"GEMS_CT_VES_01",01)	SQ	t	CTVESequence	k
3603	(0051,"SIEMENS MR HEADER",09)	UN	t	CSA Image Header Version	k
1228	(0018,1014)	TM	f	Time of Secondary Capture	\N
954	(300a,0003)	LO	f	RT Plan Name	\N
1222	(0008,1070)	PN	f	Operators' Name	\N
953	(300a,00b0)[<0>](300a,00c2)	LO	f	Beam Sequence:Beam Name	\N
4078	(0051,"SIEMENS MR HEADER",0b)	SH	t	Acquisition Matrix Text	k
105	(0008,1140)[<0>](0008,1150)	UI	f	Referenced Image Sequence:Referenced SOP Class UID	\N
3592	(0051,"SIEMENS MR HEADER",0b)	UN	t	Acquisition Matrix Text	k
1460	(0040,a124)	UI	f	UID	\N
1300	(0008,1250)	SQ	f	Related Series Sequence	\N
1196	(500a,0020)	UN	f	Type of Data	\N
7010	(3006,0080)[<0>](3006,0086)[<1>](0008,0103)	SH	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Coding Scheme Version	\N
898	(0018,1046)	DS	f	Contrast Flow Rate	\N
1181	(500a,0010)	UN	f	Number of Points	\N
1174	(5002,0022)	UN	f	Curve Description	\N
1219	(6000,0022)	LO	f	Overlay Description	\N
1419	(0088,0200)[<0>](0028,0010)	US	f	Icon Image Sequence:Rows	\N
1405	(0088,0140)	UI	f	Storage Media File-set UID	\N
558	(0028,0009)	AT	f	Frame Increment Pointer	\N
712	(0054,0013)[<0>](0054,0014)	DS	f	Energy Window Range Sequence:Energy Window Lower Limit	\N
705	(0054,1300)	DS	f	Frame Reference Time	\N
496	(0020,0110)	DS	f	Temporal Resolution	\N
6143	(0054,0022)[<0>](0018,1145)	DS	f	Detector Information Sequence:Center of Rotation Offset	\N
7000	(0009,"GEMS_PETD_01",f7)	SL	t	Unknown	d
948	(300a,0070)	SQ	f	Fraction Group Sequence	\N
996	(300a,000c)	CS	f	RT Plan Geometry	\N
963	(300a,0180)[<0>](300a,0182)	IS	f	Patient Setup Sequence:Patient Setup Number	\N
901	(3006,0002)	SH	f	Structure Set Label	\N
1178	(5002,0010)	UN	f	Number of Points	\N
933	(3006,0020)[<0>](3006,0024)	UI	f	Structure Set ROI Sequence:Referenced Frame of Reference UID	\N
939	(3006,0008)	DA	f	Structure Set Date	\N
41	(0010,1030)	DS	f	Patient's Weight	\N
171	(0018,1152)	IS	f	Exposure	\N
895	(0032,1064)[<0>](0008,0104)	LO	f	Requested Procedure Code Sequence:Code Meaning	\N
959	(300a,00b0)[<0>](300c,00a0)	IS	f	Beam Sequence:Referenced Tolerance Table Number	\N
48	(0010,1020)	DS	f	Patient's Size	\N
1301	(0008,1111)	SQ	f	Referenced Performed Procedure Step Sequence	\N
190	(0018,1110)	DS	f	Distance Source to Detector	\N
106	(0008,1110)[<0>](0008,1155)	UI	f	Referenced Study Sequence:Referenced SOP Instance UID	\N
949	(300a,00b0)[<0>](300a,0111)	SQ	f	Beam Sequence:Control Point Sequence	\N
1008	(300c,0060)[<0>](0008,1150)	UI	f	Referenced Structure Set Sequence:Referenced SOP Class UID	\N
656	(0054,0016)[<0>](0054,0304)[<1>](0008,0102)	SH	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Coding Scheme Designator	\N
127	(0018,0010)	LO	f	Contrast/Bolus Agent	\N
2705	(0040,2005)	TM	f	Issue Time of Imaging Service Request	\N
2713	(0040,2004)	DA	f	Issue Date of Imaging Service Request	\N
2686	(0040,0252)	CS	f	Performed Procedure Step Status	\N
5551	(2005,"Philips MR Imaging DD 006",57)	UN	t	Unknown	d
1193	(5006,0005)	UN	f	Curve Dimensions	\N
1195	(5008,0010)	UN	f	Number of Points	\N
1322	(0054,0016)[<0>](0054,0302)[<1>](0008,0100)	SH	f	Radiopharmaceutical Information Sequence:Administration Route Code Sequence:Code Value	\N
1326	(0054,0016)[<0>](0054,0302)[<1>](0008,0104)	LO	f	Radiopharmaceutical Information Sequence:Administration Route Code Sequence:Code Meaning	\N
2722	(0008,1111)[<0>](0008,0005)	CS	f	Referenced Performed Procedure Step Sequence:Specific Character Set	\N
987	(300a,00b0)[<0>](300a,0111)[<1>](300a,0120)	DS	f	Beam Sequence:Control Point Sequence:Beam Limiting Device Angle	\N
110	(0028,0107)	US	f	Largest Image Pixel Value	\N
4954	(0013,"CTP",51)	LO	t	Year of Diagnosis	k
4955	(0013,"CTP",51)	UN	t	Year of Diagnosis	k
3362	(0070,0060)[<0>](0070,0068)	LO	f	Graphic Layer Sequence:Graphic Layer Description	\N
3354	(0018,a002)	DT	f	Contribution DateTime	\N
3356	(0040,a170)[<0>](0008,0102)	SH	f	Purpose of Reference Code Sequence:Coding Scheme Designator	\N
3355	(0040,a170)[<0>](0008,0100)	SH	f	Purpose of Reference Code Sequence:Code Value	\N
3350	(0018,9327)	FD	f	Table Position	\N
1427	(0088,0200)[<0>](0028,1103)	US	f	Icon Image Sequence:Blue Palette Color Lookup Table Descriptor	\N
639	(0028,0107)	SS	f	Largest Image Pixel Value	\N
6394	(0021,"SIEMENS CT VA0  GEN",11)	IS	t	StartAngle	k
6357	(0019,"FDMS 1.0",32)	LO	t	KanjiMenuName	d
92	(0018,0023)	CS	f	MR Acquisition Type	\N
33	(0020,0011)	IS	f	Series Number	\N
1408	(0088,0200)[<0>](0028,1103)	SS	f	Icon Image Sequence:Blue Palette Color Lookup Table Descriptor	\N
1232	(6000,0051)	US	f	Image Frame Origin	\N
1192	(500a,3000)	UN	f	Curve Data	\N
1230	(6000,0010)	US	f	Overlay Rows	\N
1415	(0088,0200)[<0>](0028,0103)	US	f	Icon Image Sequence:Pixel Representation	\N
1104	(0040,0255)	LO	f	Performed Procedure Type Description	\N
2721	(0018,2010)	DS	f	Nominal Scanned Pixel Spacing	\N
7019	(0008,0110)[<0>](0008,010c)	UI	f	Coding Scheme Identification Sequence:Coding Scheme UID	\N
1434	(0018,a001)	SQ	f	Contributing Equipment Sequence	\N
7012	(0008,0123)	SQ	f	Context Group Identification Sequence	\N
7025	(0008,0124)[<0>](0008,0118)	UN	f	Mapping Resource Identification Sequence:Mapping Resource UID	\N
673	(0054,1101)	LO	f	Attenuation Correction Method	\N
7009	(0008,0110)[<0>](0008,0102)	SH	f	Coding Scheme Identification Sequence:Coding Scheme Designator	\N
7026	(0008,0123)[<0>](0008,0106)	DT	f	Context Group Identification Sequence:Context Group Version	\N
5553	(2005,"Philips MR Imaging DD 006",64)	UN	t	Unknown	d
1189	(5002,0005)	UN	f	Curve Dimensions	\N
710	(0054,1320)	DS	f	Slice Sensitivity Factor	\N
1458	(0054,1004)	CS	f	Reprojection Method	\N
6138	(0054,0022)[<0>](0020,0037)	DS	f	Detector Information Sequence:Image Orientation (Patient)	\N
733	(0054,0016)[<0>](0018,1072)	TM	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Start Time	\N
931	(3006,0010)[<0>](3006,0012)[<1>](0008,1155)	UI	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:Referenced SOP Instance UID	\N
85	(0010,0040)	CS	f	Patient's Sex	\N
982	(300a,0070)[<0>](300c,0004)[<1>](300a,0086)	DS	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Meterset	\N
877	(0054,0400)	SH	f	Image ID	\N
1238	(0040,0555)	SQ	f	Acquisition Context Sequence	\N
578	(0054,0410)	SQ	f	Patient Orientation Code Sequence	\N
557	(0028,0008)	IS	f	Number of Frames	\N
1007	(300c,0060)[<0>](0008,1155)	UI	f	Referenced Structure Set Sequence:Referenced SOP Instance UID	\N
53	(0018,0088)	DS	f	Spacing Between Slices	\N
995	(300a,00b0)[<0>](300a,0111)[<1>](300a,011a)[<2>](300a,00b8)	CS	f	Beam Sequence:Control Point Sequence:Beam Limiting Device Position Sequence:RT Beam Limiting Device Type	\N
992	(300a,00b0)[<0>](300a,010e)	DS	f	Beam Sequence:Final Cumulative Meterset Weight	\N
21	(0012,0063)	LO	f	De-identification Method	\N
585	(0018,1083)	IS	f	Intervals Acquired	\N
219	(0010,21b0)	LT	f	Additional Patient History	\N
1234	(0028,0006)	US	f	Planar Configuration	\N
993	(300a,00b0)[<0>](300a,0111)[<1>](300a,0114)	DS	f	Beam Sequence:Control Point Sequence:Nominal Beam Energy	\N
984	(300a,0070)[<0>](300c,0004)[<1>](300a,0082)	DS	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Dose Specification Point	\N
909	(3006,0039)[<0>](3006,0040)	SQ	f	ROI Contour Sequence:Contour Sequence	\N
563	(3004,0004)	CS	f	Dose Type	\N
7017	(3006,0080)[<0>](3006,0086)[<1>](0008,0105)	CS	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Mapping Resource	\N
2154	(0010,1000)	LO	f	Other Patient IDs	\N
6139	(0054,0022)[<0>](0020,0032)	DS	f	Detector Information Sequence:Image Position (Patient)	\N
2745	(0008,2112)[<0>](0040,a170)[<1>](0008,0102)	SH	f	Source Image Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
2747	(0028,2112)	DS	f	Lossy Image Compression Ratio	\N
2145	(0012,0031)	LO	f	Clinical Trial Site Name	\N
822	(0018,9321)[<0>](0018,9323)	CS	f	CT Exposure Sequence:Exposure Modulation Type	\N
1333	(0054,0410)[<0>](0054,0412)[<1>](0008,0106)	DT	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Context Group Version	\N
564	(3004,000a)	CS	f	Dose Summation Type	\N
24	(0032,1060)	LO	f	Requested Procedure Description	\N
894	(0032,1064)	SQ	f	Requested Procedure Code Sequence	\N
1188	(5004,3000)	UN	f	Curve Data	\N
1119	(0054,0410)[<0>](0054,0412)[<1>](0008,0100)	SH	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Code Value	\N
732	(0054,0016)[<0>](0018,1073)	TM	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Stop Time	\N
14	(0018,1030)	LO	f	Protocol Name	\N
38	(0028,1051)	DS	f	Window Width	\N
709	(0018,1060)	DS	f	Trigger Time	\N
17	(0028,1055)	LO	f	Window Center & Width Explanation	\N
1332	(0054,0410)[<0>](0008,0106)	DT	f	Patient Orientation Code Sequence:Context Group Version	\N
735	(0054,0081)	US	f	Number of Slices	\N
1216	(0018,1016)	LO	f	Secondary Capture Device Manufacturer	\N
44	(0018,0094)	DS	f	Percent Phase Field of View	\N
934	(3006,0010)[<0>](0020,0052)	UI	f	Referenced Frame of Reference Sequence:Frame of Reference UID	\N
6997	(0009,"GEMS_PETD_01",f8)	FL	t	Unknown	d
7038	(07a5,"ELSCINT1",00)	UN	t	Unknown	d
7008	(0045,"GEMS_HELIOS_01",60)	FL	t	Unknown	d
6991	(004b,"GEMS_CT_HINO_01",01)	DS	t	Beam Thickess	k
1812	(7005,"TOSHIBA_MEC_CT3",1c)	LO	t	Contrast/Bolus Agent for Series Record	k
3363	(0070,0041)	CS	f	Image Horizontal Flip	\N
3376	(0018,1260)	SH	f	Plate Type	\N
3379	(0018,1411)	DS	f	Exposure Index	\N
3365	(0070,0042)	US	f	Image Rotation	\N
3377	(0028,3010)[<0>](0028,3003)	LO	f	VOI LUT Sequence:LUT Explanation	\N
3371	(0028,3010)	SQ	f	VOI LUT Sequence	\N
3366	(0018,1622)	US	f	Shutter Presentation Value	\N
3364	(0070,0060)[<0>](0070,0066)	US	f	Graphic Layer Sequence:Graphic Layer Recommended Display Grayscale Value	\N
3378	(0018,1413)	DS	f	Deviation Index	\N
653	(0054,0016)[<0>](0054,0300)[<1>](0008,0100)	SH	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Code Value	\N
15	(0008,1030)	LO	f	Study Description	\N
1112	(0054,0410)[<0>](0054,0412)	SQ	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence	\N
1177	(5006,0010)	UN	f	Number of Points	\N
1198	(5008,0020)	UN	f	Type of Data	\N
457	(0018,1000)	LO	f	Device Serial Number	\N
1207	(6000,0015)	IS	f	Number of Frames in Overlay	\N
1420	(0088,0200)[<0>](0028,0002)	US	f	Icon Image Sequence:Samples per Pixel	\N
1416	(0088,0200)[<0>](0028,0101)	US	f	Icon Image Sequence:Bits Stored	\N
695	(0054,1104)	LO	f	Detector Lines of Response Used	\N
572	(0054,0412)	SQ	f	Patient Orientation Modifier Code Sequence	\N
1235	(0018,1012)	DA	f	Date of Secondary Capture	\N
1338	(0054,0410)[<0>](0054,0412)[<1>](0008,010f)	CS	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Context Identifier	\N
217	(0018,0090)	DS	f	Data Collection Diameter	\N
1078	(0032,1000)	DA	f	Scheduled Study Start Date	\N
2155	(0010,0021)	LO	f	Issuer of Patient ID	\N
2149	(0012,0020)	LO	f	Clinical Trial Protocol ID	\N
2743	(0008,2112)[<0>](0040,a170)[<1>](0008,0106)	DT	f	Source Image Sequence:Purpose of Reference Code Sequence:Context Group Version	\N
2159	(0032,1032)	PN	f	Requesting Physician	\N
2150	(0012,0040)	LO	f	Clinical Trial Subject ID	\N
2744	(0008,2112)[<0>](0040,a170)[<1>](0008,0100)	SH	f	Source Image Sequence:Purpose of Reference Code Sequence:Code Value	\N
2153	(0040,0253)	SH	f	Performed Procedure Step ID	\N
2146	(0012,0030)	LO	f	Clinical Trial Site ID	\N
2148	(0012,0010)	LO	f	Clinical Trial Sponsor Name	\N
2147	(0012,0021)	LO	f	Clinical Trial Protocol Name	\N
1176	(5004,0010)	UN	f	Number of Points	\N
1199	(5006,0020)	UN	f	Type of Data	\N
1184	(5006,3000)	UN	f	Curve Data	\N
1438	(0018,a001)[<0>](0008,1040)	LO	f	Contributing Equipment Sequence:Institutional Department Name	\N
1190	(500a,0005)	UN	f	Curve Dimensions	\N
1310	(0008,9121)[<0>](0008,1150)	UI	f	Referenced Raw Data Sequence:Referenced SOP Class UID	\N
1233	(6000,0102)	US	f	Overlay Bit Position	\N
80	(0018,0025)	CS	f	Angio Flag	\N
1148	(0008,1080)	LO	f	Admitting Diagnoses Description	\N
2742	(0008,9215)[<0>](0008,0106)	DT	f	Derivation Code Sequence:Context Group Version	\N
2741	(0008,2112)[<0>](0040,a170)	SQ	f	Source Image Sequence:Purpose of Reference Code Sequence	\N
42	(0020,0037)	DS	f	Image Orientation (Patient)	\N
37	(0018,0081)	DS	f	Echo Time	\N
2156	(0008,1060)	PN	f	Name of Physician(s) Reading Study	\N
6341	(0029,"Silhouette VRS 3.0",33)	UN	t	Unknown	d
5903	(7033,"CtProjectionData-MayoClinc-v1",63)	UN	t	Unknown	d
6526	(0023,"AMICAS0",43)	US	t	Unknown	d
5943	(7005,"TOSHIBA_MEC_CT3",18)	OB	t	Frame Number	k
1299	(0008,1250)[<0>](0040,a170)	SQ	f	Related Series Sequence:Purpose of Reference Code Sequence	\N
574	(0054,0016)[<0>](0054,0304)	SQ	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence	\N
99	(0008,0031)	TM	f	Series Time	\N
942	(300a,0002)	SH	f	RT Plan Label	\N
1471	(0008,9215)[<0>](0008,0104)	LO	f	Derivation Code Sequence:Code Meaning	\N
7016	(0008,0124)[<0>](0008,0105)	CS	f	Mapping Resource Identification Sequence:Mapping Resource	\N
1440	(0018,a001)[<0>](0008,0070)	LO	f	Contributing Equipment Sequence:Manufacturer	\N
1250	(0018,1072)	TM	f	Radiopharmaceutical Start Time	\N
1447	(0008,0054)	AE	f	Retrieve AE Title	\N
335	(0018,9310)	FD	f	Table Feed per Rotation	\N
130	(0018,1049)	DS	f	Contrast/Bolus Ingredient Concentration	\N
1139	(0054,0101)	US	f	Number of Time Slices	\N
1076	(0032,1051)	TM	f	Study Completion Time	\N
1989	(0018,6011)[<0>](0018,6012)	US	f	Sequence of Ultrasound Regions:Region Spatial Format	\N
1459	(0010,0032)	TM	f	Patient's Birth Time	\N
2755	(0040,a043)	SQ	f	Concept Name Code Sequence	\N
2748	(0008,9215)[<0>](0008,010b)	CS	f	Derivation Code Sequence:Context Group Extension Flag	\N
2754	(0008,2112)[<0>](0040,a170)[<1>](0008,0105)	CS	f	Source Image Sequence:Purpose of Reference Code Sequence:Mapping Resource	\N
1418	(0088,0200)[<0>](0028,0011)	US	f	Icon Image Sequence:Columns	\N
1425	(0088,0200)[<0>](0028,1101)	US	f	Icon Image Sequence:Red Palette Color Lookup Table Descriptor	\N
1406	(0088,0200)[<0>](0028,1101)	SS	f	Icon Image Sequence:Red Palette Color Lookup Table Descriptor	\N
897	(0018,1047)	DS	f	Contrast Flow Duration	\N
1165	(5000,0103)	UN	f	Data Value Representation	\N
2751	(0008,2112)[<0>](0040,a170)[<1>](0008,010f)	CS	f	Source Image Sequence:Purpose of Reference Code Sequence:Context Identifier	\N
1163	(5000,0005)	UN	f	Curve Dimensions	\N
2752	(0028,2114)	CS	f	Lossy Image Compression Method	\N
2760	(0042,0011)	OB	f	Encapsulated Document	\N
1169	(0028,1102)	OW	f	Green Palette Color Lookup Table Descriptor	\N
955	(300a,00b0)[<0>](0008,0080)	LO	f	Beam Sequence:Institution Name	\N
1399	(0088,0200)	SQ	f	Icon Image Sequence	\N
1170	(0028,1101)	OW	f	Red Palette Color Lookup Table Descriptor	\N
1168	(0028,1103)	OW	f	Blue Palette Color Lookup Table Descriptor	\N
1917	(0028,1202)	OW	f	Green Palette Color Lookup Table Data	\N
547	(0018,9323)	CS	f	Exposure Modulation Type	\N
6996	(0009,"GEMS_PETD_01",f3)	FL	t	Unknown	d
562	(3004,0014)	CS	f	Tissue Heterogeneity Correction	\N
1297	(0010,1040)	LO	f	Patient's Address	\N
7035	(0009,"GEMS_PETD_01",fc)	SL	t	Unknown	d
3383	(0028,0300)	CS	f	Quality Control Image	\N
3386	(0008,2112)[<0>](0028,135a)	CS	f	Source Image Sequence:Spatial Locations Preserved	\N
3388	(0018,1402)	CS	f	Cassette Orientation	\N
3381	(0018,1412)	DS	f	Target Exposure Index	\N
7004	(0045,"GEMS_HELIOS_01",64)	FL	t	Unknown	d
5561	(2005,"Philips MR Imaging DD 006",85)	UN	t	Unknown	d
6336	(0011,"GEMS_GDXE_FALCON_04",60)	CS	t	Unknown	d
918	(3006,0039)[<0>](3006,0084)	IS	f	ROI Contour Sequence:Referenced ROI Number	\N
1160	(0054,1220)	CS	f	Secondary Counts Type	\N
197	(0018,1111)	DS	f	Distance Source to Patient	\N
5563	(2005,"Philips MR Imaging DD 006",87)	UN	t	Unknown	d
1069	(300a,00b0)[<0>](300a,0107)[<1>](300a,0109)	CS	f	Beam Sequence:Applicator Sequence:Applicator Type	\N
729	(0028,2110)	CS	f	Lossy Image Compression	\N
1162	(5000,0020)	UN	f	Type of Data	\N
1161	(5000,0010)	UN	f	Number of Points	\N
1908	(0018,1023)	LO	f	Digital Image Format Acquired	\N
1904	(0008,0041)	CS	f	Data Set Subtype	\N
1915	(0028,1203)	OW	f	Blue Palette Color Lookup Table Data	\N
1992	(0018,6011)[<0>](0018,6026)	US	f	Sequence of Ultrasound Regions:Physical Units Y Direction	\N
1916	(0028,1201)	OW	f	Red Palette Color Lookup Table Data	\N
1922	(0018,1043)	TM	f	Contrast/Bolus Stop Time	\N
1993	(0018,6011)[<0>](0018,6022)	SL	f	Sequence of Ultrasound Regions:Reference Pixel Y0	\N
1919	(0028,1102)	US	f	Green Palette Color Lookup Table Descriptor	\N
1990	(0018,6011)[<0>](0018,6014)	US	f	Sequence of Ultrasound Regions:Region Data Type	\N
1994	(0018,6011)[<0>](0018,6020)	SL	f	Sequence of Ultrasound Regions:Reference Pixel X0	\N
1910	(0040,1008)	ST	f	Confidentiality Code	\N
1920	(0028,1101)	US	f	Red Palette Color Lookup Table Descriptor	\N
1991	(0018,6011)[<0>](0018,6024)	US	f	Sequence of Ultrasound Regions:Physical Units X Direction	\N
1988	(0018,6011)[<0>](0018,6028)	FD	f	Sequence of Ultrasound Regions:Reference Pixel Physical Value X	\N
1921	(0018,1042)	TM	f	Contrast/Bolus Start Time	\N
1918	(0028,1103)	US	f	Blue Palette Color Lookup Table Descriptor	\N
932	(3006,0039)[<0>](3006,0040)[<1>](3006,0016)[<2>](0008,1155)	UI	f	ROI Contour Sequence:Contour Sequence:Contour Image Sequence:Referenced SOP Instance UID	\N
540	(0018,9321)	SQ	f	CT Exposure Sequence	\N
6364	(0021,"FDMS 1.0",80)	CS	t	EquipmentTypeSpecificInformation	k
5946	(7005,"TOSHIBA_MEC_CT3",17)	OB	t	Total Frame Count in the Volume	k
7011	(0008,0110)	SQ	f	Coding Scheme Identification Sequence	\N
4968	(2001,"Philips Imaging DD 001",9f)	US	t	Pixel Processing Kernel Size	k
97	(0008,0033)	TM	f	Content Time	\N
6167	(0054,0016)[<0>](0054,0300)[<1>](0008,0005)	CS	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Specific Character Set	\N
1246	(0018,0031)	LO	f	Radiopharmaceutical	\N
1024	(0040,0003)	TM	f	Scheduled Procedure Step Start Time	\N
543	(0038,0500)	LO	f	Patient State	\N
463	(0018,1050)	DS	f	Spatial Resolution	\N
967	(300a,00b0)[<0>](300a,00e0)	IS	f	Beam Sequence:Number of Compensators	\N
576	(0054,0013)	SQ	f	Energy Window Range Sequence	\N
81	(0018,1312)	CS	f	In-plane Phase Encoding Direction	\N
943	(300a,00b0)[<0>](300a,00c3)	ST	f	Beam Sequence:Beam Description	\N
7022	(0008,0124)[<0>](0008,0122)	UN	f	Mapping Resource Identification Sequence:Mapping Resource Name	\N
976	(300a,00b0)[<0>](300a,0111)[<1>](300a,0134)	DS	f	Beam Sequence:Control Point Sequence:Cumulative Meterset Weight	\N
1186	(5004,0005)	UN	f	Curve Dimensions	\N
1412	(0088,0200)[<0>](0028,1201)	OW	f	Icon Image Sequence:Red Palette Color Lookup Table Data	\N
1180	(5002,3000)	UN	f	Curve Data	\N
1213	(0018,1010)	LO	f	Secondary Capture Device ID	\N
1187	(5008,0103)	UN	f	Data Value Representation	\N
1194	(5006,0103)	UN	f	Data Value Representation	\N
1224	(6000,3000)	OW	f	Overlay Data	\N
1261	(0008,1120)[<0>](0008,1155)	UI	f	Referenced Patient Sequence:Referenced SOP Instance UID	\N
1133	(0054,0410)[<0>](0054,0412)[<1>](0008,0104)	LO	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Code Meaning	\N
7	(0018,1251)	SH	f	Transmit Coil Name	\N
721	(0054,1102)	CS	f	Decay Correction	\N
7043	(0028,6022)	LO	f	Frame of Interest Description	\N
104	(0008,0016)	UI	f	SOP Class UID	\N
118	(0028,0011)	US	f	Columns	\N
1470	(0008,9215)[<0>](0008,0102)	SH	f	Derivation Code Sequence:Coding Scheme Designator	\N
573	(0054,0016)[<0>](0054,0300)	SQ	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence	\N
1340	(0054,0410)[<0>](0054,0412)[<1>](0008,0105)	CS	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Mapping Resource	\N
1327	(0054,0016)[<0>](0018,1070)	LO	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Route	\N
1152	(0018,1082)	IS	f	High R-R Value	\N
2016	(3004,0050)[<0>](3004,0002)	CS	f	DVH Sequence:Dose Units	\N
2019	(3004,0050)[<0>](3004,0004)	CS	f	DVH Sequence:Dose Type	\N
1998	(3006,0080)[<0>](3006,0086)	SQ	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence	\N
2008	(3004,0050)	SQ	f	DVH Sequence	\N
2000	(300e,0005)	TM	f	Review Time	\N
7003	(0045,"GEMS_HELIOS_01",62)	FL	t	Unknown	d
3390	(0018,1403)	CS	f	Cassette Size	\N
3401	(0040,a370)[<0>](0008,1110)	SQ	f	Referenced Request Sequence:Referenced Study Sequence	\N
3395	(0040,a370)[<0>](0032,1064)[<1>](0008,0100)	SH	f	Referenced Request Sequence:Requested Procedure Code Sequence:Code Value	\N
3393	(0028,3010)[<0>](0028,3002)	US	f	VOI LUT Sequence:LUT Descriptor	\N
3400	(0040,a370)[<0>](0040,1001)	SH	f	Referenced Request Sequence:Requested Procedure ID	\N
3403	(0040,a370)[<0>](0032,1064)	SQ	f	Referenced Request Sequence:Requested Procedure Code Sequence	\N
3391	(0010,2203)	CS	f	Patient's Sex Neutered	\N
7006	(0045,"GEMS_HELIOS_01",63)	FL	t	Unknown	d
7002	(0009,"GEMS_PETD_01",f5)	DA	t	Unknown	d
6995	(0009,"GEMS_PETD_01",f1)	SL	t	PET prompt gamma	k
6994	(0009,"GEMS_PETD_01",f2)	UI	t	PET tracerInjection_UID	d
7030	(0009,"GEMS_PETD_01",fb)	UN	t	Unknown	d
7005	(0045,"GEMS_HELIOS_01",61)	FL	t	Unknown	d
2007	(3004,0050)[<0>](3004,0060)	SQ	f	DVH Sequence:DVH Referenced ROI Sequence	\N
1308	(0008,9121)[<0>](0008,1155)	UI	f	Referenced Raw Data Sequence:Referenced SOP Instance UID	\N
2013	(3004,0050)[<0>](3004,0070)	DS	f	DVH Sequence:DVH Minimum Dose	\N
1997	(3006,0080)[<0>](3006,0086)[<1>](0008,0102)	SH	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Coding Scheme Designator	\N
2015	(3004,0050)[<0>](3004,0052)	DS	f	DVH Sequence:DVH Dose Scaling	\N
2011	(3004,0050)[<0>](3004,0072)	DS	f	DVH Sequence:DVH Maximum Dose	\N
1995	(3006,0080)[<0>](3006,0085)	SH	f	RT ROI Observations Sequence:ROI Observation Label	\N
1164	(5000,3000)	UN	f	Curve Data	\N
584	(0018,1084)	IS	f	Intervals Rejected	\N
6014	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",19)	LO	t	Unknown:Unknown	d
560	(3004,000e)	DS	f	Dose Grid Scaling	\N
1335	(0054,1200)	DS	f	Axial Acceptance	\N
1331	(0054,0414)[<0>](0008,0106)	DT	f	Patient Gantry Relationship Code Sequence:Context Group Version	\N
945	(300a,0070)[<0>](300c,0004)	SQ	f	Fraction Group Sequence:Referenced Beam Sequence	\N
4970	(2005,"Philips MR Imaging DD 004",71)		t	Series SP Mix	k
4056	(0029,"",20)	OB	t	Unknown	d
108	(0008,1110)[<0>](0008,1150)	UI	f	Referenced Study Sequence:Referenced SOP Class UID	\N
95	(0008,0030)	TM	f	Study Time	\N
927	(3006,0080)[<0>](3006,00a4)	CS	f	RT ROI Observations Sequence:RT ROI Interpreted Type	\N
12	(0020,1040)	LO	f	Position Reference Indicator	\N
11	(0040,0280)	ST	f	Comments on the Performed Procedure Step	\N
921	(3006,0039)[<0>](3006,0040)[<1>](3006,0050)	DS	f	ROI Contour Sequence:Contour Sequence:Contour Data	\N
936	(3006,0010)[<0>](3006,0012)[<1>](3006,0014)[<2>](0020,000e)	UI	f	Referenced Frame of Reference Sequence:RT Referenced Study Sequence:RT Referenced Series Sequence:Series Instance UID	\N
1244	(0040,0555)[<0>](0040,a168)[<1>](0008,0104)	LO	f	Acquisition Context Sequence:Concept Code Sequence:Code Meaning	\N
1173	(5004,0022)	UN	f	Curve Description	\N
1431	(0018,a001)[<0>](0040,a170)[<1>](0008,0102)	SH	f	Contributing Equipment Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
2043	(0064,0002)[<0>](0064,0005)	SQ	f	Deformable Registration Sequence:Deformable Registration Grid Sequence	\N
1442	(0018,a001)[<0>](0018,1000)	LO	f	Contributing Equipment Sequence:Device Serial Number	\N
2038	(0008,1200)[<0>](0008,1115)	SQ	f	Studies Containing Other Referenced Instances Sequence:Referenced Series Sequence	\N
2044	(0064,0002)[<0>](0070,0309)	SQ	f	Deformable Registration Sequence:Matrix Registration Sequence	\N
1185	(5004,0103)	UN	f	Data Value Representation	\N
2022	(3006,0020)[<0>](3006,0028)	ST	f	Structure Set ROI Sequence:ROI Description	\N
1426	(0088,0200)[<0>](0028,1102)	US	f	Icon Image Sequence:Green Palette Color Lookup Table Descriptor	\N
1407	(0088,0200)[<0>](0028,1102)	SS	f	Icon Image Sequence:Green Palette Color Lookup Table Descriptor	\N
2069	(0064,0002)[<0>](0008,1140)[<1>](0008,1150)	UI	f	Deformable Registration Sequence:Referenced Image Sequence:Referenced SOP Class UID	\N
2049	(0064,0002)[<0>](0008,1140)	SQ	f	Deformable Registration Sequence:Referenced Image Sequence	\N
1033	(0040,0002)	DA	f	Scheduled Procedure Step Start Date	\N
2039	(0064,0002)[<0>](0064,0010)	SQ	f	Deformable Registration Sequence:Post Deformation Matrix Registration Sequence	\N
1435	(0018,a001)[<0>](0008,0081)	ST	f	Contributing Equipment Sequence:Institution Address	\N
1409	(0088,0200)[<0>](7fe0,0010)	OW	f	Icon Image Sequence:Pixel Data	\N
2066	(0064,0002)[<0>](0064,0003)	UI	f	Deformable Registration Sequence:Source Frame of Reference UID	\N
2024	(3006,0080)[<0>](0008,0005)	CS	f	RT ROI Observations Sequence:Specific Character Set	\N
89	(0018,5100)	CS	f	Patient Position	\N
128	(0018,1041)	DS	f	Contrast/Bolus Volume	\N
164	(0018,1160)	SH	f	Filter Type	\N
2052	(0064,0002)[<0>](0064,0005)[<1>](0020,0032)	DS	f	Deformable Registration Sequence:Deformable Registration Grid Sequence:Image Position (Patient)	\N
1062	(300a,00b0)[<0>](300a,00f4)[<1>](300a,0104)	IS	f	Beam Sequence:Block Sequence:Block Number of Points	\N
657	(0054,0016)[<0>](0054,0300)[<1>](0008,0102)	SH	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Coding Scheme Designator	\N
1200	(5004,0020)	UN	f	Type of Data	\N
2046	(0008,1115)[<0>](0008,114a)	SQ	f	Referenced Series Sequence:Referenced Instance Sequence	\N
18	(0008,103e)	LO	f	Series Description	\N
114	(0028,0103)	US	f	Pixel Representation	\N
8	(0008,1140)	SQ	f	Referenced Image Sequence	\N
2042	(0008,1200)	SQ	f	Studies Containing Other Referenced Instances Sequence	\N
2057	(0064,0002)[<0>](0064,0005)[<1>](0064,0009)	OF	f	Deformable Registration Sequence:Deformable Registration Grid Sequence:Vector Grid Data	\N
2036	(0064,0002)[<0>](0070,0309)[<1>](0070,030d)[<2>](0008,0100)	SH	f	Deformable Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Code Value	\N
2025	(3006,0020)[<0>](0008,0005)	CS	f	Structure Set ROI Sequence:Specific Character Set	\N
2055	(0064,0002)[<0>](0064,000f)[<1>](3006,00c6)	DS	f	Deformable Registration Sequence:Pre Deformation Matrix Registration Sequence:Frame of Reference Transformation Matrix	\N
2041	(0064,0002)[<0>](0070,0309)[<1>](0070,030a)	SQ	f	Deformable Registration Sequence:Matrix Registration Sequence:Matrix Sequence	\N
2040	(0064,0002)	SQ	f	Deformable Registration Sequence	\N
2021	(3006,0080)[<0>](3006,0088)	ST	f	RT ROI Observations Sequence:ROI Observation Description	\N
2047	(0064,0002)[<0>](0070,0309)[<1>](0070,030d)	SQ	f	Deformable Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence	\N
3410	(0008,2218)	SQ	f	Anatomic Region Sequence	\N
941	(300a,00b0)[<0>](300a,00b2)	SH	f	Beam Sequence:Treatment Machine Name	\N
202	(0028,1053)	DS	f	Rescale Slope	\N
1056	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00f5)	SH	f	Beam Sequence:Block Sequence:Block Tray ID	\N
3411	(0054,0220)	SQ	f	View Code Sequence	\N
7014	(3006,0080)[<0>](3006,0086)[<1>](0008,010f)	CS	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Context Identifier	\N
6992	(0015,"GEMS_PETD_01",3e)	UL	t	PET Scatter Limit	k
7037	(0009,"GEMS_PETD_01",fb)	SL	t	Unknown	d
369	(0028,0120)	US	f	Pixel Padding Value	\N
276	(0028,0120)	SS	f	Pixel Padding Value	\N
31	(0020,0012)	IS	f	Acquisition Number	\N
1243	(0040,0555)[<0>](0040,a168)[<1>](0008,0102)	SH	f	Acquisition Context Sequence:Concept Code Sequence:Coding Scheme Designator	\N
83	(0018,0021)	CS	f	Sequence Variant	\N
977	(300a,00b0)[<0>](300a,0111)[<1>](300a,0130)	DS	f	Beam Sequence:Control Point Sequence:Source to Surface Distance	\N
28	(0020,0013)	IS	f	Instance Number	\N
994	(300a,00b0)[<0>](300a,00b6)[<1>](300a,00b8)	CS	f	Beam Sequence:Beam Limiting Device Sequence:RT Beam Limiting Device Type	\N
76	(0008,0005)	CS	f	Specific Character Set	\N
1441	(0018,a001)[<0>](0018,1020)	LO	f	Contributing Equipment Sequence:Software Version(s)	\N
1080	(0008,9123)	UI	f	Creator-Version UID	\N
385	(0018,1094)	IS	f	Trigger Window	\N
1	(0018,0085)	SH	f	Imaged Nucleus	\N
679	(0054,0016)[<0>](0018,0031)	LO	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical	\N
940	(300a,0040)[<0>](300a,0043)	SH	f	Tolerance Table Sequence:Tolerance Table Label	\N
125	(0008,0023)	DA	f	Content Date	\N
77	(0028,0303)	CS	f	Longitudinal Temporal Information Modified	\N
119	(0028,0101)	US	f	Bits Stored	\N
998	(300a,00b0)[<0>](300a,00c6)	CS	f	Beam Sequence:Radiation Type	\N
658	(0054,0414)[<0>](0008,0102)	SH	f	Patient Gantry Relationship Code Sequence:Coding Scheme Designator	\N
1225	(0008,0064)	CS	f	Conversion Type	\N
900	(0018,1200)	DA	f	Date of Last Calibration	\N
892	(0032,1064)[<0>](0008,0102)	SH	f	Requested Procedure Code Sequence:Coding Scheme Designator	\N
720	(0054,1001)	CS	f	Units	\N
178	(0018,1040)	LO	f	Contrast/Bolus Route	\N
722	(0054,1000)	CS	f	Series Type	\N
1245	(0040,0555)[<0>](0040,a043)[<1>](0008,0104)	LO	f	Acquisition Context Sequence:Concept Name Code Sequence:Code Meaning	\N
47	(0028,0030)	DS	f	Pixel Spacing	\N
6353	(0009,"FDMS 1.0",08)	UL	t	ImageDisplayInformationVersionNo	k
915	(3006,0080)[<0>](3006,0082)	IS	f	RT ROI Observations Sequence:Observation Number	\N
5942	(7005,"TOSHIBA_MEC_CT3",20)	OB	t	Local Series Number	k
7027	(3006,0080)[<0>](3006,0086)[<1>](0008,0106)	DT	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Context Group Version	\N
5570	(2005,"Philips MR Imaging DD 005",52)	UN	t	Original Series Instance UID	h
734	(0054,1330)	US	f	Image Index	\N
2092	(300a,0010)[<0>](300a,0026)	DS	f	Dose Reference Sequence:Target Prescription Dose	\N
2097	(300a,0010)[<0>](300a,0014)	CS	f	Dose Reference Sequence:Dose Reference Structure Type	\N
2093	(300a,0010)[<0>](300a,0023)	DS	f	Dose Reference Sequence:Delivery Maximum Dose	\N
2083	(300a,0010)[<0>](300a,0012)	IS	f	Dose Reference Sequence:Dose Reference Number	\N
2080	(300a,00b0)[<0>](300a,0111)[<1>](300c,0050)[<2>](300c,0051)	IS	f	Beam Sequence:Control Point Sequence:Referenced Dose Reference Sequence:Referenced Dose Reference Number	\N
2099	(300a,00b0)[<0>](3002,0050)[<1>](3002,0051)	CS	f	Beam Sequence:Primary Fluence Mode Sequence:Fluence Mode	\N
2088	(300a,0040)[<0>](300a,0048)[<1>](300a,004a)	DS	f	Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence:Beam Limiting Device Position Tolerance	\N
2098	(300a,0180)[<0>](300a,01b0)	CS	f	Patient Setup Sequence:Setup Technique	\N
2082	(300a,00b0)[<0>](300c,0042)[<1>](300a,00c8)	IS	f	Beam Sequence:Referenced Reference Image Sequence:Reference Image Number	\N
2076	(300a,00b0)[<0>](300a,0111)[<1>](300c,0050)	SQ	f	Beam Sequence:Control Point Sequence:Referenced Dose Reference Sequence	\N
2101	(300a,0010)[<0>](300a,0013)	UI	f	Dose Reference Sequence:Dose Reference UID	\N
2096	(300a,0010)[<0>](300a,0020)	CS	f	Dose Reference Sequence:Dose Reference Type	\N
2085	(300a,0040)[<0>](300a,004c)	DS	f	Tolerance Table Sequence:Patient Support Angle Tolerance	\N
2086	(300a,0040)[<0>](300a,0044)	DS	f	Tolerance Table Sequence:Gantry Angle Tolerance	\N
2079	(300a,0010)[<0>](300a,0016)	LO	f	Dose Reference Sequence:Dose Reference Description	\N
2078	(300a,00b0)[<0>](0008,1090)	LO	f	Beam Sequence:Manufacturer's Model Name	\N
2081	(300a,0070)[<0>](300a,0079)	IS	f	Fraction Group Sequence:Number of Fraction Pattern Digits Per Day	\N
2091	(300a,0010)[<0>](300a,0027)	DS	f	Dose Reference Sequence:Target Maximum Dose	\N
2073	(300a,0010)	SQ	f	Dose Reference Sequence	\N
2077	(300a,0180)[<0>](300a,01b2)	ST	f	Patient Setup Sequence:Setup Technique Description	\N
2102	(300a,00b0)[<0>](300c,0042)[<1>](0008,1150)	UI	f	Beam Sequence:Referenced Reference Image Sequence:Referenced SOP Class UID	\N
2094	(300a,0040)[<0>](300a,0051)	DS	f	Tolerance Table Sequence:Table Top Vertical Position Tolerance	\N
7018	(0008,0123)[<0>](0008,0105)	CS	f	Context Group Identification Sequence:Mapping Resource	\N
7024	(3006,0080)[<0>](3006,0086)[<1>](0008,0118)	UN	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Mapping Resource UID	\N
7031	(0009,"GEMS_PETD_01",fa)	UN	t	Unknown	d
7001	(0009,"GEMS_PETD_01",f6)	SL	t	Unknown	d
7036	(0009,"GEMS_PETD_01",fa)	SL	t	Unknown	d
2948	(0018,1400)	LO	f	Acquisition Device Processing Description	\N
2056	(0064,0002)[<0>](0064,0010)[<1>](3006,00c6)	DS	f	Deformable Registration Sequence:Post Deformation Matrix Registration Sequence:Frame of Reference Transformation Matrix	\N
2001	(300e,0004)	DA	f	Review Date	\N
2874	(0020,1206)	IS	f	Number of Study Related Series	\N
6692	(0040,2007)	SH	f	Filler Order Number / Imaging Service Request (Retired)	\N
3419	(0028,1041)	SS	f	Pixel Intensity Relationship Sign	\N
3415	(0018,7010)	IS	f	Exposures on Detector Since Last Calibration	\N
3422	(0054,0220)[<0>](0008,0100)	SH	f	View Code Sequence:Code Value	\N
6693	(0040,2006)	SH	f	Placer Order Number / Imaging Service Request (Retired)	\N
3416	(0018,1702)	IS	f	Collimator Left Vertical Edge	\N
5575	(0018,1320)	UN	f	B1rms	\N
2018	(3004,0050)[<0>](3004,0001)	CS	f	DVH Sequence:DVH Type	\N
2023	(3006,0039)[<0>](3006,0040)[<1>](3006,0048)	IS	f	ROI Contour Sequence:Contour Sequence:Contour Number	\N
2060	(0064,0002)[<0>](0064,0010)[<1>](0070,030c)	CS	f	Deformable Registration Sequence:Post Deformation Matrix Registration Sequence:Frame of Reference Transformation Matrix Type	\N
2012	(3004,0050)[<0>](3004,0074)	DS	f	DVH Sequence:DVH Mean Dose	\N
5909	(7033,"CtProjectionData-MayoClinc-v1",0b)	UN	t	Unknown	d
5912	(7029,"CtProjectionData-MayoClinc-v1",06)	UN	t	Unknown	d
5935	(7005,"TOSHIBA_MEC_CT3",11)	OB	t	Series Comment	d
2017	(3004,0050)[<0>](3004,0054)	CS	f	DVH Sequence:DVH Volume Units	\N
6291	(0055,"GEMS_GENIE_1",22)[<0>](0011,"GEMS_GENIE_1",24)	SL	t	eNTEGRA Detector Information Sequence:FOVMaskYCutoffAngle	k
7020	(0008,0123)[<0>](0008,0117)	UI	f	Context Group Identification Sequence:Context UID	\N
7023	(3006,0080)[<0>](3006,0086)[<1>](0008,0122)	UN	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Mapping Resource Name	\N
5579	(2005,"Philips MR Imaging DD 006",54)	UN	t	Unknown	d
2949	(0018,6000)	DS	f	Sensitivity	\N
7015	(0008,0123)[<0>](0008,010f)	CS	f	Context Group Identification Sequence:Context Identifier	\N
5577	(2005,"Philips MR Imaging DD 006",55)	UN	t	Unknown	d
2068	(0008,1200)[<0>](0008,1115)[<1>](0008,114a)[<2>](0008,1150)	UI	f	Studies Containing Other Referenced Instances Sequence:Referenced Series Sequence:Referenced Instance Sequence:Referenced SOP Class UID	\N
2051	(0064,0002)[<0>](0070,0309)[<1>](0070,030d)[<2>](0008,0104)	LO	f	Deformable Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Code Meaning	\N
1486	(3002,0022)	DS	f	Radiation Machine SAD	\N
1487	(0040,030e)[<0>](0018,9346)	SQ	f	Exposure Dose Sequence:CTDI Phantom Type Code Sequence	\N
1488	(0040,030e)[<0>](0018,0060)	DS	f	Exposure Dose Sequence:KVP	\N
1492	(0070,005a)[<0>](0008,1140)[<1>](0008,1150)	UI	f	Displayed Area Selection Sequence:Referenced Image Sequence:Referenced SOP Class UID	\N
1496	(300a,0125)	DS	f	Table Top Eccentric Angle	\N
1497	(0070,0060)[<0>](0070,0002)	CS	f	Graphic Layer Sequence:Graphic Layer	\N
1498	(3002,0026)	DS	f	RT Image SID	\N
2084	(300a,00b0)[<0>](300a,0111)[<1>](300c,0050)[<2>](300a,010c)	DS	f	Beam Sequence:Control Point Sequence:Referenced Dose Reference Sequence:Cumulative Dose Reference Coefficient	\N
7013	(0008,0124)	SQ	f	Mapping Resource Identification Sequence	\N
5578	(2005,"Philips MR Imaging DD 006",56)	UN	t	Unknown	d
6119	(0054,0012)	SQ	f	Energy Window Information Sequence	\N
1504	(0040,030e)[<0>](0018,9346)[<1>](0008,0100)	SH	f	Exposure Dose Sequence:CTDI Phantom Type Code Sequence:Code Value	\N
5580	(2005,"Philips MR Imaging DD 006",61)	UN	t	Unknown	d
1506	(0070,005a)[<0>](0008,1140)[<1>](0008,1155)	UI	f	Displayed Area Selection Sequence:Referenced Image Sequence:Referenced SOP Instance UID	\N
1507	(0040,030e)[<0>](0018,9302)	CS	f	Exposure Dose Sequence:Acquisition Type	\N
1508	(0028,3110)[<0>](0008,1140)	SQ	f	Softcopy VOI LUT Sequence:Referenced Image Sequence	\N
1511	(0040,030e)[<0>](0018,9346)[<1>](0008,0104)	LO	f	Exposure Dose Sequence:CTDI Phantom Type Code Sequence:Code Meaning	\N
1512	(0040,030e)[<0>](0018,9307)	FD	f	Exposure Dose Sequence:Total Collimation Width	\N
1513	(0028,3110)[<0>](0028,1050)	DS	f	Softcopy VOI LUT Sequence:Window Center	\N
1517	(3002,0012)	DS	f	RT Image Position	\N
1518	(300c,0002)[<0>](300c,0020)[<1>](300c,0004)	SQ	f	Referenced RT Plan Sequence:Referenced Fraction Group Sequence:Referenced Beam Sequence	\N
1521	(300a,0120)	DS	f	Beam Limiting Device Angle	\N
1526	(3002,000e)	DS	f	X-Ray Image Receptor Angle	\N
1528	(300a,0122)	DS	f	Patient Support Angle	\N
1533	(0008,1115)[<0>](0020,000e)	UI	f	Referenced Series Sequence:Series Instance UID	\N
1537	(0008,1115)[<0>](0008,1140)[<1>](0008,1150)	UI	f	Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Class UID	\N
1538	(300c,0002)[<0>](300c,0020)	SQ	f	Referenced RT Plan Sequence:Referenced Fraction Group Sequence	\N
1539	(0070,0082)	DA	f	Presentation Creation Date	\N
1542	(0070,005a)[<0>](0070,0101)	DS	f	Displayed Area Selection Sequence:Presentation Pixel Spacing	\N
1546	(0028,3110)	SQ	f	Softcopy VOI LUT Sequence	\N
1547	(3002,000c)	CS	f	RT Image Plane	\N
1549	(0040,0555)[<0>](0008,0102)	SH	f	Acquisition Context Sequence:Coding Scheme Designator	\N
1552	(0070,005a)	SQ	f	Displayed Area Selection Sequence	\N
1553	(3002,0002)	SH	f	RT Image Label	\N
1554	(0040,030e)[<0>](0018,9306)	FD	f	Exposure Dose Sequence:Single Collimation Width	\N
1556	(0040,0555)[<0>](0008,0100)	SH	f	Acquisition Context Sequence:Code Value	\N
1558	(0040,0260)[<0>](0008,0103)	SH	f	Performed Protocol Code Sequence:Coding Scheme Version	\N
1563	(0020,1208)	IS	f	Number of Study Related Instances	\N
1565	(0040,0310)	ST	f	Comments on Radiation Dose	\N
1570	(0070,0081)	LO	f	Content Description	\N
1573	(300a,011e)	DS	f	Gantry Angle	\N
1582	(0040,030e)[<0>](0018,9311)	FD	f	Exposure Dose Sequence:Spiral Pitch Factor	\N
1996	(3006,0080)[<0>](3006,0086)[<1>](0008,0100)	SH	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Code Value	\N
2089	(300a,0040)[<0>](300a,0053)	DS	f	Tolerance Table Sequence:Table Top Lateral Position Tolerance	\N
7021	(3006,0080)[<0>](3006,0086)[<1>](0008,0117)	UI	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Context UID	\N
3426	(0054,0220)[<0>](0008,0102)	SH	f	View Code Sequence:Coding Scheme Designator	\N
3437	(0018,7014)	DS	f	Detector Active Time	\N
7040	(0053,"GEHC_CT_ADVAPP_001",6d)	DS	t	Unknown	d
7039	(0053,"GEHC_CT_ADVAPP_001",6c)	DS	t	Unknown	d
7034	(0015,"GEMS_PETD_01",1a)	SL	t	Physio Gating Type	k
7033	(0009,"GEMS_PETD_01",2c)	FD	t	Axial FOV	k
3430	(0018,702b)	LO	f	Detector Manufacturer's Model Name	\N
3425	(0008,2218)[<0>](0008,0102)	SH	f	Anatomic Region Sequence:Coding Scheme Designator	\N
3428	(0018,702a)	LO	f	Detector Manufacturer Name	\N
7032	(0015,"GEMS_PETD_01",1a)	UN	t	Physio Gating Type	k
3602	(0019,"SIEMENS MR HEADER",09)	UN	t	Unknown	d
3593	(0051,"SIEMENS MR HEADER",0a)	UN	t	Unknown	d
2947	(0018,1401)	LO	f	Acquisition Device Processing Code	\N
3609	(0051,"SIEMENS MR HEADER",12)	UN	t	Unknown	d
6252	(0011,"GEMS_GENIE_1",14)	LO	t	Completion Time	k
1999	(3006,0080)[<0>](3006,0086)[<1>](0008,0104)	LO	f	RT ROI Observations Sequence:RT ROI Identification Code Sequence:Code Meaning	\N
2062	(0064,0002)[<0>](0008,1140)[<1>](0008,1155)	UI	f	Deformable Registration Sequence:Referenced Image Sequence:Referenced SOP Instance UID	\N
2059	(0064,0002)[<0>](0070,0309)[<1>](0070,030a)[<2>](0070,030c)	CS	f	Deformable Registration Sequence:Matrix Registration Sequence:Matrix Sequence:Frame of Reference Transformation Matrix Type	\N
1588	(0040,0301)	US	f	Total Number of Exposures	\N
1590	(0040,030e)[<0>](0018,9346)[<1>](0008,0102)	SH	f	Exposure Dose Sequence:CTDI Phantom Type Code Sequence:Coding Scheme Designator	\N
1592	(0070,0084)	PN	f	Content Creator's Name	\N
2950	(0018,1164)	DS	f	Imager Pixel Spacing	\N
6169	(0054,0013)[<0>](0008,0005)	CS	f	Energy Window Range Sequence:Specific Character Set	\N
3214	(2010,0100)	CS	f	Border Density	\N
1596	(0040,0555)[<0>](0008,0104)	LO	f	Acquisition Context Sequence:Code Meaning	\N
3596	(0051,"SIEMENS MR HEADER",0e)	UN	t	Unknown	d
2014	(3004,0050)[<0>](3004,0058)	DS	f	DVH Sequence:DVH Data	\N
1600	(300c,0002)[<0>](300c,0020)[<1>](300c,0022)	IS	f	Referenced RT Plan Sequence:Referenced Fraction Group Sequence:Referenced Fraction Group Number	\N
1601	(3002,0020)	SH	f	Radiation Machine Name	\N
1603	(0070,0083)	TM	f	Presentation Creation Time	\N
1605	(300c,0006)	IS	f	Referenced Beam Number	\N
1608	(0040,030e)[<0>](0018,8151)	DS	f	Exposure Dose Sequence:X-Ray Tube Current in ÂµA	\N
1611	(7fe0,0010)	OB	f	Pixel Data	\N
1612	(0070,005a)[<0>](0070,0100)	CS	f	Displayed Area Selection Sequence:Presentation Size Mode	\N
1613	(0028,3110)[<0>](0028,1051)	DS	f	Softcopy VOI LUT Sequence:Window Width	\N
1619	(0070,0060)[<0>](0070,0062)	IS	f	Graphic Layer Sequence:Graphic Layer Order	\N
1623	(0028,3110)[<0>](0008,1140)[<1>](0008,1155)	UI	f	Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced SOP Instance UID	\N
1625	(3002,0024)	DS	f	Radiation Machine SSD	\N
1626	(0040,030e)[<0>](0018,0015)	CS	f	Exposure Dose Sequence:Body Part Examined	\N
3608	(0051,"SIEMENS MR HEADER",11)	UN	t	Unknown	d
1629	(0070,005a)[<0>](0008,1140)	SQ	f	Displayed Area Selection Sequence:Referenced Image Sequence	\N
1632	(0018,9321)[<0>](0018,9445)	FD	f	CT Exposure Sequence:<undef>	\N
1637	(3002,0011)	DS	f	Image Plane Pixel Spacing	\N
1638	(0070,0080)	CS	f	Content Label	\N
1641	(0070,005a)[<0>](0070,0103)	FL	f	Displayed Area Selection Sequence:Presentation Pixel Magnification Ratio	\N
1642	(2050,0020)	CS	f	Presentation LUT Shape	\N
1643	(300a,00b0)[<0>](300a,00f2)	DS	f	Beam Sequence:Total Block Tray Factor	\N
1646	(300c,0002)[<0>](300c,0020)[<1>](300c,0004)[<2>](300c,0006)	IS	f	Referenced RT Plan Sequence:Referenced Fraction Group Sequence:Referenced Beam Sequence:Referenced Beam Number	\N
1656	(0040,2017)	LO	f	Filler Order Number / Imaging Service Request	\N
1657	(0070,005a)[<0>](0070,0053)	SL	f	Displayed Area Selection Sequence:Displayed Area Bottom Right Hand Corner	\N
1658	(0040,030e)[<0>](0018,9345)	FD	f	Exposure Dose Sequence:CTDIvol	\N
1660	(0070,005a)[<0>](0070,0052)	SL	f	Displayed Area Selection Sequence:Displayed Area Top Left Hand Corner	\N
1662	(0028,3110)[<0>](0008,1140)[<1>](0008,1150)	UI	f	Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced SOP Class UID	\N
2075	(300a,0040)[<0>](300a,0048)	SQ	f	Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence	\N
1667	(0040,030e)	SQ	f	Exposure Dose Sequence	\N
1669	(300a,00b3)	CS	f	Primary Dosimeter Unit	\N
7007	(0045,"GEMS_HELIOS_01",65)	FL	t	Unknown	d
2053	(0064,0002)[<0>](0064,0005)[<1>](0020,0037)	DS	f	Deformable Registration Sequence:Deformable Registration Grid Sequence:Image Orientation (Patient)	\N
2054	(0064,0002)[<0>](0070,0309)[<1>](0070,030a)[<2>](3006,00c6)	DS	f	Deformable Registration Sequence:Matrix Registration Sequence:Matrix Sequence:Frame of Reference Transformation Matrix	\N
2009	(3004,0050)[<0>](3004,0056)	IS	f	DVH Sequence:DVH Number of Bins	\N
2095	(300a,0040)[<0>](300a,0048)[<1>](300a,00b8)	CS	f	Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence:RT Beam Limiting Device Type	\N
2010	(3004,0050)[<0>](3004,0060)[<1>](3006,0084)	IS	f	DVH Sequence:DVH Referenced ROI Sequence:Referenced ROI Number	\N
6998	(0009,"GEMS_PETD_01",f9)	FL	t	Unknown	d
2074	(300a,00b0)[<0>](300c,0042)	SQ	f	Beam Sequence:Referenced Reference Image Sequence	\N
6993	(0015,"GEMS_PETD_01",3d)	UL	t	PET Sharp IR Flag	k
1673	(0008,1115)[<0>](0008,1140)[<1>](0008,1155)	UI	f	Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Instance UID	\N
1677	(0008,1115)[<0>](0008,1140)	SQ	f	Referenced Series Sequence:Referenced Image Sequence	\N
1678	(0040,030e)[<0>](0018,1150)	IS	f	Exposure Dose Sequence:Exposure Time	\N
1680	(0070,0060)	SQ	f	Graphic Layer Sequence	\N
3446	(0008,2218)[<0>](0008,0105)	CS	f	Anatomic Region Sequence:Mapping Resource	\N
3438	(0018,7006)	LT	f	Detector Description	\N
3451	(0040,0303)	US	f	Exposed Area	\N
6999	(0009,"GEMS_PETD_01",f4)	SL	t	Unknown	d
4325	(0008,9206)	CS	f	Volumetric Properties	\N
4993	(0028,3003)	LO	f	LUT Explanation	\N
4996	(0018,9036)	CS	f	Partial Fourier Direction	\N
7028	(0043,"GEMS_PARM_01",a8)	UN	t	Dual Drive Mode, Amplitude Attentuation and Phase Offset	k
3601	(0019,"SIEMENS MR HEADER",17)	UN	t	Slice Resolution	k
4317	(0032,1064)[<0>](0008,0103)	SH	f	Requested Procedure Code Sequence:Coding Scheme Version	\N
3620	(0019,"SIEMENS MR HEADER",0c)	UN	t	B Value	k
4989	(0028,9001)	UL	f	Data Point Rows	\N
4999	(0018,9016)	CS	f	Spoiling	\N
4995	(0008,9205)	CS	f	Pixel Presentation	\N
4992	(0018,9005)	SH	f	Pulse Sequence Name	\N
4997	(0018,9033)	CS	f	Segmented k-Space Traversal	\N
4994	(0018,9094)	CS	f	Coverage of k-Space	\N
7029	(0009,"GEMS_PETD_01",fc)	UN	t	Unknown	d
1685	(3002,000d)	DS	f	X-Ray Image Receptor Translation	\N
7041	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",aa)	SQ	t	Advanced Presentation Sequence:LUT Inverted Flag	d
1688	(0008,1115)	SQ	f	Referenced Series Sequence	\N
27	(0013,"CTP",10)	LO	t	Project Name	k
1695	(0040,0260)[<0>](0008,0104)	LO	f	Performed Protocol Code Sequence:Code Meaning	\N
2048	(0008,1200)[<0>](0008,1115)[<1>](0008,114a)	SQ	f	Studies Containing Other Referenced Instances Sequence:Referenced Series Sequence:Referenced Instance Sequence	\N
2067	(0008,1115)[<0>](0008,114a)[<1>](0008,1150)	UI	f	Referenced Series Sequence:Referenced Instance Sequence:Referenced SOP Class UID	\N
2072	(300a,00b0)[<0>](3002,0050)	SQ	f	Beam Sequence:Primary Fluence Mode Sequence	\N
2070	(0008,1200)[<0>](0008,1115)[<1>](0020,000e)	UI	f	Studies Containing Other Referenced Instances Sequence:Referenced Series Sequence:Series Instance UID	\N
1903	(0040,9096)[<0>](0040,9224)	FD	f	Real World Value Mapping Sequence:Real World Value Intercept	\N
7042	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",05)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Overlay Image Sequence	d
2064	(0008,1115)[<0>](0008,114a)[<1>](0008,1155)	UI	f	Referenced Series Sequence:Referenced Instance Sequence:Referenced SOP Instance UID	\N
2087	(300a,0040)[<0>](300a,0046)	DS	f	Tolerance Table Sequence:Beam Limiting Device Angle Tolerance	\N
2063	(0008,1200)[<0>](0008,1115)[<1>](0008,114a)[<2>](0008,1155)	UI	f	Studies Containing Other Referenced Instances Sequence:Referenced Series Sequence:Referenced Instance Sequence:Referenced SOP Instance UID	\N
1902	(0040,9096)[<0>](0040,9225)	FD	f	Real World Value Mapping Sequence:Real World Value Slope	\N
1901	(0008,1140)[<0>](0040,a170)[<1>](0008,0104)	LO	f	Referenced Image Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
5587	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Referenced Frames Sequence	k
2045	(0064,0002)[<0>](0064,000f)	SQ	f	Deformable Registration Sequence:Pre Deformation Matrix Registration Sequence	\N
3211	(2010,0030)	CS	f	Annotation Display Format ID	\N
5676	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)[<4>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",94)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence:Measurement Evaluation Value	k
2061	(0064,0002)[<0>](0064,0005)[<1>](0064,0008)	FD	f	Deformable Registration Sequence:Deformable Registration Grid Sequence:Grid Resolution	\N
3622	(0029,"MITRA MARKUP 1.0",03)	UN	t	Markup4	d
3803	(0033,"",0c)	UN	t	Unknown	d
3800	(0033,"",04)	UN	t	Unknown	d
3784	(0043,"GEMS_PARM_01",a5)	UN	t	Duration of the label or control pulse	d
4328	(0018,1411)	CS	f	Exposure Index	\N
2065	(0008,1200)[<0>](0020,000d)	UI	f	Studies Containing Other Referenced Instances Sequence:Study Instance UID	\N
2090	(300a,0040)[<0>](300a,0052)	DS	f	Tolerance Table Sequence:Table Top Longitudinal Position Tolerance	\N
2020	(3004,0050)[<0>](3004,0060)[<1>](3004,0062)	CS	f	DVH Sequence:DVH Referenced ROI Sequence:DVH ROI Contribution Type	\N
2058	(0064,0002)[<0>](0064,000f)[<1>](0070,030c)	CS	f	Deformable Registration Sequence:Pre Deformation Matrix Registration Sequence:Frame of Reference Transformation Matrix Type	\N
2100	(300a,00b0)[<0>](300c,0042)[<1>](0008,1155)	UI	f	Beam Sequence:Referenced Reference Image Sequence:Referenced SOP Instance UID	\N
2050	(0064,0002)[<0>](0064,0005)[<1>](0064,0007)	UL	f	Deformable Registration Sequence:Deformable Registration Grid Sequence:Grid Dimensions	\N
2037	(0064,0002)[<0>](0070,0309)[<1>](0070,030d)[<2>](0008,0102)	SH	f	Deformable Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Coding Scheme Designator	\N
5013	(0018,9026)	CS	f	Spectrally Selected Excitation	\N
5003	(0018,9081)	CS	f	Partial Fourier	\N
5014	(0018,9008)	CS	f	Echo Pulse Sequence	\N
5006	(0018,9011)	CS	f	Multiple Spin Echo	\N
5004	(0018,9012)	CS	f	Multi-planar Excitation	\N
5009	(0018,9059)	CS	f	De-coupling	\N
5011	(0018,9021)	CS	f	T2 Preparation	\N
3472	(0040,a730)[<0>](0040,a730)[<1>](0040,a050)	CS	f	Content Sequence:Content Sequence:Continuity Of Content	\N
3470	(0040,a493)	CS	f	Verification Flag	\N
3467	(0040,a730)[<0>](0040,a730)[<1>](0040,a010)	CS	f	Content Sequence:Content Sequence:Relationship Type	\N
4334	(0018,8151)	DS	f	X-Ray Tube Current in ÂµA	\N
4329	(0018,1413)	CS	f	Deviation Index	\N
3463	(0040,a730)[<0>](0040,a730)[<1>](0040,a043)[<2>](0008,0104)	LO	f	Content Sequence:Content Sequence:Concept Name Code Sequence:Code Meaning	\N
3468	(0040,a730)[<0>](0040,a050)	CS	f	Content Sequence:Continuity Of Content	\N
3455	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a043)[<3>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Code Value	\N
4330	(0018,1412)	CS	f	Target Exposure Index	\N
5000	(0018,9034)	CS	f	Rectilinear Phase Encode Reordering	\N
5001	(0018,9014)	CS	f	Phase Contrast	\N
4332	(0018,5021)	LO	f	Postprocessing Function	\N
5005	(0018,9024)	CS	f	Saturation Recovery	\N
4333	(0018,8150)	DS	f	Exposure Time in ÂµS	\N
4331	(0018,5020)	LO	f	Processing Function	\N
3303	(0019,"SIEMENS CT VA0  COAD",b0)	OB	t	Feed per Rotation	k
3304	(0019,"SIEMENS CT VA0  COAD",92)	OB	t	OsteoRegressionLineSlope	k
5589	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence	k
3305	(0019,"SIEMENS CT VA0  COAD",90)	OB	t	OsteoOffset	k
3306	(0019,"SIEMENS CT VA0  COAD",96)	OB	t	OsteoPhantomNumber	k
3307	(0019,"SIEMENS CT VA0  COAD",93)	OB	t	OsteoRegressionLineIntercept	k
3309	(0021,"SIEMENS MED",11)	OB	t	Target	k
253	(0043,"GEMS_PARM_01",44)	SL	t	DASOutputSource	k
5591	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence	k
7050	(0018,1086)	IS	f	Skip Beats	\N
7051	(0018,1610)	IS	f	Center of Circular Shutter	\N
7052	(0018,1604)	IS	f	Shutter Right Vertical Edge	\N
7047	(0018,1608)	IS	f	Shutter Lower Horizontal Edge	\N
7048	(0018,1606)	IS	f	Shutter Upper Horizontal Edge	\N
3380	(0019,"Agfa ADC NX",f6)	DS	t	Plate Sensitivity	k
3382	(0019,"Agfa ADC NX",f7)	DS	t	Plate Erasability	k
7049	(0018,1612)	IS	f	Radius of Circular Shutter	\N
7053	(0018,1602)	IS	f	Shutter Left Vertical Edge	\N
7045	(5181,"Unnamed Private Block - 01",78)	US	t	Unknown	d
3512	(0018,7060)	CS	f	Exposure Control Mode	\N
7046	(5181,"Unnamed Private Block - 01",75)	US	t	Unknown	d
5590	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)	SQ	t	Advanced Presentation Sequence	k
5683	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)[<4>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",95)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence:Measurement Evaluation ID	k
7044	(5181,"Unnamed Private Block - 01",73)	DS	t	Unknown	d
3884	(0021,"",59)	UN	t	Unknown	d
5414	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)[<2>](0028,0011)	US	t	Unknown:Unknown:Unknown:Columns	d
3816	(0051,"",08)	UN	t	Unknown	d
5386	(0071,"BLACKFORD",04)[<0>](0020,0011)	IS	t	Unknown:Series Number	d
3819	(0019,"",0f)	UN	t	Unknown	d
437	(0043,"GEMS_PARM_01",04)	SS	t	GradientOffsetInZ	k
3322	(0040,a730)[<0>](0008,1199)	SQ	f	Content Sequence:Referenced SOP Sequence	\N
3440	(0028,1040)	CS	f	Pixel Intensity Relationship	\N
3423	(0018,700a)	SH	f	Detector ID	\N
3404	(0040,a370)[<0>](0032,1060)	LO	f	Referenced Request Sequence:Requested Procedure Description	\N
3421	(0008,2218)[<0>](0008,0106)	DT	f	Anatomic Region Sequence:Context Group Version	\N
3405	(0040,a370)[<0>](0032,1064)[<1>](0008,0104)	LO	f	Referenced Request Sequence:Requested Procedure Code Sequence:Code Meaning	\N
3392	(0028,3010)[<0>](0028,3006)	US	f	VOI LUT Sequence:LUT Data	\N
3397	(0040,a370)[<0>](0040,2017)	SH	f	Referenced Request Sequence:Filler Order Number / Imaging Service Request	\N
3341	(0040,a730)[<0>](0008,1199)[<1>](0008,1155)	UI	f	Content Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
3337	(0040,a504)[<0>](0008,0105)	CS	f	Content Template Sequence:Mapping Resource	\N
3435	(0040,8302)	DS	f	Entrance Dose in mGy	\N
3427	(0008,2218)[<0>](0008,0104)	LO	f	Anatomic Region Sequence:Code Meaning	\N
3402	(0040,a370)	SQ	f	Referenced Request Sequence	\N
3439	(0018,7008)	LT	f	Detector Mode	\N
3396	(0040,a370)[<0>](0032,1064)[<1>](0008,0102)	SH	f	Referenced Request Sequence:Requested Procedure Code Sequence:Coding Scheme Designator	\N
3406	(0040,a370)[<0>](0008,1110)[<1>](0008,0016)	UI	f	Referenced Request Sequence:Referenced Study Sequence:SOP Class UID	\N
3429	(0054,0220)[<0>](0008,0104)	LO	f	View Code Sequence:Code Meaning	\N
3323	(0040,a730)[<0>](0040,a043)	SQ	f	Content Sequence:Concept Name Code Sequence	\N
3469	(0040,a730)[<0>](0040,a730)[<1>](0040,a040)	CS	f	Content Sequence:Content Sequence:Value Type	\N
3339	(0040,a730)[<0>](0008,1199)[<1>](0008,1150)	UI	f	Content Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
3360	(0070,005a)[<0>](0070,0102)	IS	f	Displayed Area Selection Sequence:Presentation Pixel Aspect Ratio	\N
3344	(0040,a375)[<0>](0020,000d)	UI	f	Current Requested Procedure Evidence Sequence:Study Instance UID	\N
5019	(0018,9174)	CS	f	Applicable Safety Standard Agency	\N
5015	(0018,9200)	CS	f	MR Spectroscopy Acquisition Type	\N
5024	(0018,9027)	CS	f	Spatial Pre-saturation	\N
5026	(0018,9028)	CS	f	Tagging	\N
5017	(0018,9078)	CS	f	Parallel Acquisition Technique	\N
5028	(0018,9020)	CS	f	Magnetization Transfer	\N
5016	(0018,9180)	CS	f	Gradient Output Type	\N
5020	(0018,9179)	CS	f	Specific Absorption Rate Definition	\N
3473	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a040)	CS	f	Content Sequence:Content Sequence:Content Sequence:Value Type	\N
6529	(07a1,"ELSCINT1",18)		t	Unknown	d
3346	(0029,"MITRA PRESENTATION 1.0",03)	IS	t	Invert	k
3417	(0018,1706)	IS	f	Collimator Upper Horizontal Edge	\N
3449	(0018,1700)	CS	f	Collimator Shape	\N
3399	(0040,a370)[<0>](0008,0050)	SH	f	Referenced Request Sequence:Accession Number	\N
3361	(0028,3110)[<0>](0028,1055)	LO	f	Softcopy VOI LUT Sequence:Window Center & Width Explanation	\N
3433	(0018,7022)	DS	f	Detector Element Spacing	\N
3408	(0040,a370)[<0>](0008,1110)[<1>](0008,0018)	UI	f	Referenced Request Sequence:Referenced Study Sequence:SOP Instance UID	\N
3436	(0018,701a)	DS	f	Detector Binning	\N
3343	(0040,a375)[<0>](0008,1115)[<1>](0020,000e)	UI	f	Current Requested Procedure Evidence Sequence:Referenced Series Sequence:Series Instance UID	\N
3444	(0018,113a)	CS	f	Table Type	\N
3414	(0018,1405)	IS	f	Relative X-Ray Exposure	\N
3326	(0040,a730)[<0>](0040,a168)	SQ	f	Content Sequence:Concept Code Sequence	\N
3324	(0040,a375)[<0>](0008,1115)[<1>](0008,1199)	SQ	f	Current Requested Procedure Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence	\N
3460	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)	SQ	f	Content Sequence:Content Sequence:Content Sequence	\N
3454	(0040,a730)[<0>](0040,a730)[<1>](0040,a043)[<2>](0008,0100)	SH	f	Content Sequence:Content Sequence:Concept Name Code Sequence:Code Value	\N
3328	(0040,a375)[<0>](0008,1115)	SQ	f	Current Requested Procedure Evidence Sequence:Referenced Series Sequence	\N
3443	(0018,7005)	CS	f	Detector Configuration	\N
3441	(0008,0068)	CS	f	Presentation Intent Type	\N
3447	(0054,0220)[<0>](0008,0105)	CS	f	View Code Sequence:Mapping Resource	\N
3321	(0040,a375)	SQ	f	Current Requested Procedure Evidence Sequence	\N
3456	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a043)[<3>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Coding Scheme Designator	\N
3461	(0040,a730)[<0>](0040,a730)[<1>](0040,a043)	SQ	f	Content Sequence:Content Sequence:Concept Name Code Sequence	\N
3418	(0018,1153)	IS	f	Exposure in ÂµAs	\N
3358	(0070,005a)[<0>](0008,1140)[<1>](0008,1160)	IS	f	Displayed Area Selection Sequence:Referenced Image Sequence:Referenced Frame Number	\N
3327	(0040,a504)	SQ	f	Content Template Sequence	\N
3330	(0040,a730)[<0>](0040,a043)[<1>](0008,0104)	LO	f	Content Sequence:Concept Name Code Sequence:Code Meaning	\N
3459	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a043)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence	\N
3424	(0008,2218)[<0>](0008,0100)	SH	f	Anatomic Region Sequence:Code Value	\N
3432	(0018,7001)	DS	f	Detector Temperature	\N
3340	(0040,a375)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1150)	UI	f	Current Requested Procedure Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
3466	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a010)	CS	f	Content Sequence:Content Sequence:Content Sequence:Relationship Type	\N
3453	(0018,700c)	DA	f	Date of Last Detector Calibration	\N
3442	(0018,7004)	CS	f	Detector Type	\N
3342	(0040,a375)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1155)	UI	f	Current Requested Procedure Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
3452	(0040,0302)	US	f	Entrance Dose	\N
3398	(0040,a370)[<0>](0040,2016)	SH	f	Referenced Request Sequence:Placer Order Number / Imaging Service Request	\N
3347	(0029,"MITRA PRESENTATION 1.0",01)	LO	t	Window Width	k
3348	(0029,"MITRA PRESENTATION 1.0",02)	LO	t	Window Centre	k
7084	(5001,0010)	LO	f	Number of Points	\N
7077	(01f3,0010)	LO	f	<undef>	\N
7080	(07a5,0010)	LO	f	<undef>	\N
7076	(01f1,0010)	LO	f	<undef>	\N
7079	(07a3,0010)	LO	f	<undef>	\N
7078	(00e1,0010)	LO	f	<undef>	\N
6759	(0008,1140)[<0>](0008,0008)	CS	f	Referenced Image Sequence:Image Type	\N
6760	(0032,1064)[<0>](0008,0008)	CS	f	Requested Procedure Code Sequence:Image Type	\N
6761	(0008,1032)[<0>](0008,0008)	CS	f	Procedure Code Sequence:Image Type	\N
6758	(0008,1110)[<0>](0008,0008)	CS	f	Referenced Study Sequence:Image Type	\N
3594	(0019,"SIEMENS MR HEADER",18)	UN	t	Real Dwell Time	k
3600	(0019,"SIEMENS MR HEADER",0f)	UN	t	Gradient Mode	k
5416	(0071,"BLACKFORD",04)[<0>](0010,0030)	DA	t	Unknown:Patient's Birth Date	d
5037	(0018,9182)	FD	f	Gradient Output	\N
5041	(0020,9254)	FD	f	Respiratory Interval Time	\N
5042	(0018,9091)	FD	f	Velocity Encoding Minimum Value	\N
5030	(0018,9171)	CS	f	Respiratory Signal Source	\N
5034	(0018,9168)	FD	f	Parallel Reduction Factor Second In-plane	\N
5031	(0018,9037)	CS	f	Cardiac Synchronization Technique	\N
5033	(0018,9032)	CS	f	Geometry of k-Space Traversal	\N
5029	(0018,9172)	CS	f	Bulk Motion Compensation Technique	\N
6331	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1032)[<1>](0008,0100)	SH	t	CTVESequence:Procedure Code Sequence:Code Value	k
7065	(0137,0050)	LO	f	<undef>	\N
7062	(0905,0010)	LO	f	<undef>	\N
3413	(0018,1704)	IS	f	Collimator Right Vertical Edge	\N
3445	(0054,0220)[<0>](0008,010f)	CS	f	View Code Sequence:Context Identifier	\N
3458	(0040,a730)[<0>](0040,a730)	SQ	f	Content Sequence:Content Sequence	\N
3353	(0040,a170)	SQ	f	Purpose of Reference Code Sequence	\N
7066	(0019,0010)	LO	f	<undef>	\N
7069	(0031,0011)	LO	f	<undef>	\N
5594	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence	k
7072	(0033,0010)	LO	f	<undef>	\N
7073	(07a1,0010)	LO	f	<undef>	\N
3457	(0040,a730)[<0>](0040,a730)[<1>](0040,a043)[<2>](0008,0102)	SH	f	Content Sequence:Content Sequence:Concept Name Code Sequence:Coding Scheme Designator	\N
3431	(0018,115e)	DS	f	Image and Fluoroscopy Area Dose Product	\N
3420	(0054,0220)[<0>](0008,0106)	DT	f	View Code Sequence:Context Group Version	\N
3325	(0040,a730)	SQ	f	Content Sequence	\N
3359	(0008,1115)[<0>](0008,1140)[<1>](0008,1160)	IS	f	Referenced Series Sequence:Referenced Image Sequence:Referenced Frame Number	\N
3434	(0018,7020)	DS	f	Detector Element Physical Size	\N
3475	(0040,a730)[<0>](0040,a730)[<1>](0040,a124)	UI	f	Content Sequence:Content Sequence:UID	\N
3448	(0008,2218)[<0>](0008,010f)	CS	f	Anatomic Region Sequence:Context Identifier	\N
3357	(0028,3110)[<0>](0008,1140)[<1>](0008,1160)	IS	f	Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced Frame Number	\N
3462	(0040,a372)	SQ	f	Performed Procedure Code Sequence	\N
3474	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a124)	UI	f	Content Sequence:Content Sequence:Content Sequence:UID	\N
3351	(0018,9303)	FD	f	Tube Angle	\N
3476	(0040,2016)	LO	f	Placer Order Number / Imaging Service Request	\N
3407	(0040,a370)[<0>](0020,000d)	UI	f	Referenced Request Sequence:Study Instance UID	\N
3450	(0018,700e)	TM	f	Time of Last Detector Calibration	\N
3465	(0040,a730)[<0>](0040,a730)[<1>](0040,a160)	UT	f	Content Sequence:Content Sequence:Text Value	\N
3349	(0018,9334)	CS	f	Fluoroscopy Flag	\N
3464	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a043)[<3>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Code Meaning	\N
3412	(0018,1708)	IS	f	Collimator Lower Horizontal Edge	\N
3471	(0040,a491)	CS	f	Completion Flag	\N
5595	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence	k
5588	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence	k
7054	(0091,0011)	LO	f	<undef>	\N
7059	(0093,0010)	LO	f	<undef>	\N
7060	(0023,0010)	LO	f	<undef>	\N
3317	(0035,"AGFA KOSD 1.0",00)	SH	t	Unknown	d
4339	(00e1,"ELSCINT1",36)	CS	t	Unknown	d
7056	(0029,0010)	LO	f	<undef>	\N
4341	(00e1,"ELSCINT1",c4)	DS	t	Unknown	d
7071	(0031,0010)	LO	f	<undef>	\N
4348	(01f7,"ELSCINT1",97)	OW	t	Unknown	d
4350	(01f1,"ELSCINT1",56)	LO	t	Unknown	d
7070	(0029,0012)	LO	f	<undef>	\N
7075	(7fdf,0010)	LO	f	<undef>	\N
7067	(0009,0011)	LO	f	<undef>	\N
7058	(0093,0011)	LO	f	<undef>	\N
7063	(0009,0010)	LO	f	<undef>	\N
7074	(01f7,0010)	LO	f	<undef>	\N
7057	(0051,0010)	LO	f	<undef>	\N
7068	(0021,0010)	LO	f	<undef>	\N
7061	(0025,0010)	LO	f	<undef>	\N
6793	(5200,9230)[<0>](0018,9114)	SQ	f	Per-frame Functional Groups Sequence:MR Echo Sequence	\N
6792	(5200,9229)[<0>](0018,9115)	SQ	f	Shared Functional Groups Sequence:MR Modifier Sequence	\N
7055	(0091,0010)	LO	f	<undef>	\N
7064	(0029,0011)	LO	f	<undef>	\N
4367	(0015,"GEMS_PETD_01",1f)	UL	t	PET Recon Parameters Exists	k
3610	(0019,"SIEMENS MR HEADER",15)	UN	t	Slice Position PCS	k
3621	(0019,"SIEMENS MR HEADER",28)	UN	t	Bandwidth per Pixel Phase Encode	k
4486	(0043,"GEMS_PARM_01",68)	US	t	XT Correction Indicator	k
5048	(0018,9240)	US	f	RF Echo Train Length	\N
5045	(0018,9231)	US	f	MR Acquisition Phase Encoding Steps in-plane	\N
5049	(0018,9058)	US	f	MR Acquisition Frequency Encoding Steps	\N
5046	(0018,9093)	US	f	Number of k-Space Trajectories	\N
5047	(0018,9241)	US	f	Gradient Echo Train Length	\N
7081	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<3>](0029,0010)	LO	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Referenced Frames Sequence:<undef>	d
1357	(01f1,"ELSCINT1",4a)	SH	t	Unknown	d
3656	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",aa)	SQ	t	Presentation State Sequence:Unknown	d
5426	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0070,030d)[<2>](0008,0100)	SH	t	Unknown:Deformable Registration Sequence:Registration Type Code Sequence:Code Value	d
302	(0043,"GEMS_PARM_01",21)	SS	t	CorrectedAfterglowTerms	k
6800	(5200,9229)[<0>](0020,9071)	SQ	f	Shared Functional Groups Sequence:Frame Anatomy Sequence	\N
6798	(5200,9229)[<0>](0018,9006)	SQ	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence	\N
6825	(0008,9092)[<0>](0020,000d)	UI	f	Referenced Image Evidence Sequence:Study Instance UID	\N
6820	(5200,9229)[<0>](0008,1140)[<1>](0008,1150)	UI	f	Shared Functional Groups Sequence:Referenced Image Sequence:Referenced SOP Class UID	\N
6818	(5200,9229)[<0>](0008,1140)[<1>](0008,1160)	IS	f	Shared Functional Groups Sequence:Referenced Image Sequence:Referenced Frame Number	\N
6795	(5200,9229)[<0>](0008,1140)	SQ	f	Shared Functional Groups Sequence:Referenced Image Sequence	\N
3598	(0019,"SIEMENS MR HEADER",11)	UN	t	Flow Compensation	k
3604	(0019,"SIEMENS MR HEADER",14)	UN	t	Ima Rel Table Position	k
4400	(5200,9230)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0102)	SH	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Coding Scheme Designator	\N
4407	(5200,9229)[<0>](0028,9110)[<1>](0018,0088)	DS	f	Shared Functional Groups Sequence:Pixel Measures Sequence:Spacing Between Slices	\N
4406	(0012,0071)	LO	f	Clinical Trial Series ID	\N
4410	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)[<4>](0040,08ea)[<5>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Code Value	\N
4399	(5200,9230)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0100)	SH	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Code Value	\N
4408	(0062,0002)[<0>](0062,000d)	US	f	Segment Sequence:Recommended Display CIELab Value	\N
4412	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a168)[<3>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Code Value	\N
4404	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0104)	LO	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
4391	(5200,9230)[<0>](0062,000a)	SQ	f	Per-frame Functional Groups Sequence:Segment Identification Sequence	\N
4395	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)	SQ	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence	\N
4398	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0100)	SH	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Code Value	\N
4401	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0102)	SH	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
4403	(5200,9230)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0104)	LO	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Code Meaning	\N
4402	(0020,9222)[<0>](0020,9421)	LO	f	Dimension Index Sequence:Dimension Description Label	\N
4397	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0008,1150)	UI	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Referenced SOP Class UID	\N
4351	(0040,1008)	LO	f	Confidentiality Code	\N
4413	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a043)[<4>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Code Value	\N
4393	(5200,9230)[<0>](0008,9124)	SQ	f	Per-frame Functional Groups Sequence:Derivation Image Sequence	\N
4411	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)[<3>](0040,08ea)[<4>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Code Value	\N
4405	(0012,0060)	LO	f	Clinical Trial Coordinating Center Name	\N
4394	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)	SQ	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence	\N
4386	(0015,"GEMS_PETD_01",3c)	US	t	Recon Matrix Size	k
7082	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0029,0010)	LO	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:<undef>	d
7083	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<4>](0029,0010)	LO	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Referenced Frames Sequence:<undef>	d
4423	(0040,a730)[<0>](0040,a504)	SQ	f	Content Sequence:Content Template Sequence	\N
4415	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a168)[<3>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Coding Scheme Designator	\N
4422	(0040,a073)	SQ	f	Verifying Observer Sequence	\N
4428	(0040,a730)[<0>](0040,a730)[<1>](0040,a504)	SQ	f	Content Sequence:Content Sequence:Content Template Sequence	\N
4429	(0040,a073)[<0>](0040,a088)	SQ	f	Verifying Observer Sequence:Verifying Observer Identification Code Sequence	\N
5069	(2005,"Philips MR Imaging DD 001",80)	OB	t	Series PlanScan	k
5603	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0008,1140)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Referenced Image Sequence	k
5602	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5e)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Slice Spacing Sequence	k
5601	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)	SQ	t	Advanced Presentation Sequence:Time Point Sequence	k
5338	(0015,"GEMS_PETD_01",34)	UN	t	Emission Random Flag	k
7086	(0008,0110)[<0>](0008,0116)	ST	f	Coding Scheme Identification Sequence:Coding Scheme Responsible Organization	\N
7089	(7fd1,0010)	LO	f	<undef>	\N
7087	(0073,0010)	LO	f	<undef>	\N
5206	(2005,"Philips MR Imaging DD 005",0b)	OB	t	Rescale Type Original	k
7090	(f215,0010)	LO	f	<undef>	\N
7088	(0095,0010)	LO	f	<undef>	\N
7085	(0008,0110)[<0>](0008,0115)	ST	f	Coding Scheme Identification Sequence:Coding Scheme Name	\N
4553	(0071,"SIEMENS MED PT",22)	UN	t	Decay Correction DateTime	o
7092	(0027,0010)	LO	f	<undef>	\N
7094	(0907,0010)	LO	f	<undef>	\N
7093	(0903,0010)	LO	f	<undef>	\N
7091	(0053,"GEHC_CT_ADVAPP_001",6f)	IS	t	Unknown	
5071	(2001,"Philips Imaging DD 001",81)	OB	t	NumberOfDynamicScans	k
5063	(2005,"Philips MR Imaging DD 004",71)	OB	t	Series SP Mix	k
2977	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",63)	OB	t	Unknown:Unknown	d
5412	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0008,1140)[<2>](0008,1150)	UI	t	Unknown:Unknown:Referenced Image Sequence:Referenced SOP Class UID	d
5422	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0070,030d)	SQ	t	Unknown:Deformable Registration Sequence:Registration Type Code Sequence	d
7095	(1099,0010)	LO	\N	\N	\N
5382	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030d)[<3>](0008,0104)	LO	t	Unknown:Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Code Meaning	d
5408	(0071,"BLACKFORD",04)[<0>](0020,0052)	UI	t	Unknown:Frame of Reference UID	d
5450	(0021,"SIEMENS MED",20)	US	t	ROIMask	d
7096	(3006,0020)[<0>](3263,0010)	LO	\N	\N	\N
601	(0009,"GEMS_PETD_01",a2)	FL	t	Axial Spacing	k
67	(0019,"SIEMENS MR HEADER",18)	OB	t	Real Dwell Time	k
6833	(5200,9229)[<0>](0018,9049)[<1>](0018,1251)	SH	f	Shared Functional Groups Sequence:MR Transmit Coil Sequence:Transmit Coil Name	\N
6866	(5200,9229)[<0>](0018,9112)[<1>](0018,9239)[<2>](0018,9179)	CS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Specific Absorption Rate Sequence:Specific Absorption Rate Definition	\N
4425	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence	\N
4416	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)[<4>](0040,08ea)[<5>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Coding Scheme Designator	\N
3619	(0019,"SIEMENS MR HEADER",0d)	UN	t	Diffusion Directionality	k
4418	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a168)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence	\N
4424	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence	\N
5606	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,1115)[<2>](0008,1140)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence	k
5616	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<4>](0028,0008)	IS	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Referenced Frames Sequence:Number of Frames	k
5609	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0008,1140)[<3>](0008,1160)	IS	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Referenced Image Sequence:Referenced Frame Number	k
5617	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0070,0103)	FL	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Presentation Pixel Magnification Ratio	k
5362	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030d)[<3>](0008,0102)	SH	t	Unknown:Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Coding Scheme Designator	d
5611	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<4>](0008,1160)	IS	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Referenced Frames Sequence:Referenced Frame Number	k
5615	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<3>](0028,0008)	IS	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Referenced Frames Sequence:Number of Frames	k
5605	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence	k
5608	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Referenced Frames Sequence	k
5620	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0008,1140)[<3>](0008,1155)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Referenced Image Sequence:Referenced SOP Instance UID	h
5109	(2005,"Philips MR Imaging DD 003",52)	OB	t	Number of Study Patient Contrast Allergies	k
5612	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0020,0013)	IS	t	Advanced Presentation Sequence:Presentation State Sequence:Instance Number	k
5610	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0008,1140)[<3>](0008,1160)	IS	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced Frame Number	k
5619	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0008,1140)[<3>](0008,1155)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced SOP Instance UID	h
5613	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<3>](0008,1160)	IS	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Referenced Frames Sequence:Referenced Frame Number	k
5618	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,1115)[<2>](0008,1140)[<3>](0008,1155)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Instance UID	h
5098	(2005,"Philips MR Imaging DD 001",86)	OB	t	Number of Geometry	k
5113	(2005,"Philips MR Imaging DD 001",25)	OB	t	Number of Volumes	k
5087	(2001,"Philips Imaging DD 001",13)	OB	t	EPIFactor	k
1445	(7053,"Philips PET Private Group",09)	DS	t	Activity Concentration Scale Factor	k
1290	(0029,"SIEMENS MEDCOM HEADER",40)[<0>](0029,"SIEMENS MEDCOM HEADER",44)	OB	t	ApplicationHeaderSequence:ApplicationHeaderInfo	na
5346	(0077,"TERARECON AQUARIUS",50)	UN	t	First Binary Data	d
1818	(00e1,"ELSCINT1",14)	CS	t	Unknown	d
461	(0019,"GEMS_ACQU_01",84)	DS	t	PeakSAR	k
210	(0029,"GEMS_IMPS_01",05)	DS	t	LowerRangeOfPixels	k
6882	(5200,9229)[<0>](0018,9006)[<1>](0018,9028)	CS	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence:Tagging	\N
6886	(5200,9229)[<0>](0018,9042)[<1>](0018,9043)	CS	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Receive Coil Type	\N
5642	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0028,1051)	DS	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Window Width	k
4873	(0023,"GEMS_STDY_01",70)	OB	t	StartTimeSecsInFirstAxial	d
5627	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0020,000d)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Study Instance UID	h
5636	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)[<4>](0008,0104)	LO	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence:Code Meaning	k
5635	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0018,9525)	LO	t	Advanced Presentation Sequence:Application Version	k
5641	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,1053)	DS	t	Advanced Presentation Sequence:Presentation State Sequence:Rescale Slope	k
5626	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0020,000d)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Study Instance UID	h
5628	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,0016)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:SOP Class UID	k
5637	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,1054)	LO	t	Advanced Presentation Sequence:Presentation State Sequence:Rescale Type	k
5639	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0084)	PN	t	Advanced Presentation Sequence:Presentation State Sequence:Content Creator's Name	d
5640	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0028,1050)	DS	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Window Center	k
5629	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,1115)[<2>](0020,000e)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Referenced Series Sequence:Series Instance UID	h
5630	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)[<4>](0020,000e)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence:Series Instance UID	h
5624	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0008,1140)[<3>](0008,1150)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Referenced Image Sequence:Referenced SOP Class UID	k
2598	(0040,0008)[<0>](0008,0103)	SH	f	Scheduled Protocol Code Sequence:Coding Scheme Version	\N
2581	(0008,1111)[<0>](0008,0012)	DA	f	Referenced Performed Procedure Step Sequence:Instance Creation Date	\N
5168	(2001,"Philips Imaging DD 001",14)	OB	t	NumberOfEchoes	k
2756	(0042,0013)	SQ	f	Source Instance Sequence	\N
2757	(0042,0010)	ST	f	Document Title	\N
6909	(3002,0030)[<0>](0018,0060)	DS	f	Exposure Sequence:KVP	\N
6896	(5200,9229)[<0>](0018,9112)[<1>](0018,9240)	US	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:RF Echo Train Length	\N
6904	(3002,0004)	ST	f	RT Image Description	\N
6905	(3002,0030)[<0>](300a,00b6)[<1>](300a,00bc)	IS	f	Exposure Sequence:Beam Limiting Device Sequence:Number of Leaf/Jaw Pairs	\N
6901	(5200,9229)[<0>](0018,9115)[<1>](0018,9079)	FD	f	Shared Functional Groups Sequence:MR Modifier Sequence:Inversion Times	\N
6897	(5200,9229)[<0>](0018,9112)[<1>](0018,9241)	US	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Gradient Echo Train Length	\N
6895	(5200,9229)[<0>](0018,9125)[<1>](0018,9232)	US	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:MR Acquisition Phase Encoding Steps out-of-plane	\N
5452	(0018,9360)	SQ	f	CT Additional X-Ray Source Sequence	\N
5463	(0028,6010)	US	f	Representative Frame Number	\N
5459	(0018,9360)[<0>](0018,7050)	CS	f	CT Additional X-Ray Source Sequence:Filter Material	\N
5462	(0008,0103)	SH	f	Coding Scheme Version	\N
5455	(0018,9360)[<0>](0018,1160)	SH	f	CT Additional X-Ray Source Sequence:Filter Type	\N
5167	(2005,"Philips MR Imaging DD 001",20)	OB	t	NumberOfChemicalShifts	k
3247	(300a,0010)[<0>](300d,"TOMO_HA_01",10)	UN	t	Dose Reference Sequence:Unknown	d
5460	(0018,9360)[<0>](0018,9332)	FD	f	CT Additional X-Ray Source Sequence:Exposure in mAs	\N
5461	(0018,9360)[<0>](0018,9330)	FD	f	CT Additional X-Ray Source Sequence:X-Ray Tube Current in mA	\N
5454	(0018,9360)[<0>](0018,9353)	FL	f	CT Additional X-Ray Source Sequence:Energy Weighting Factor	\N
5453	(0018,9353)	FL	f	Energy Weighting Factor	\N
5456	(0018,9360)[<0>](0018,0060)	DS	f	CT Additional X-Ray Source Sequence:KVP	\N
5457	(0018,9360)[<0>](0018,0090)	DS	f	CT Additional X-Ray Source Sequence:Data Collection Diameter	\N
5646	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5e)[<2>](0072,0510)	CS	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Slice Spacing Sequence:Reformatting Operation Type	k
5458	(0018,9360)[<0>](0018,1190)	DS	f	CT Additional X-Ray Source Sequence:Focal Spot(s)	\N
5665	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",19)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Realtime Flag	k
2782	(0053,"GEHC_CT_ADVAPP_001",63)	CS	t	Image Position Patient Setting	k
441	(0019,"GEMS_ACQU_01",c1)	SS	t	SurfaceCoilIntensityCorrectionFlag	k
5649	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0041)	CS	t	Advanced Presentation Sequence:Presentation State Sequence:Image Horizontal Flip	k
5652	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](2050,0020)	CS	t	Advanced Presentation Sequence:Presentation State Sequence:Presentation LUT Shape	k
5662	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",18)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Strategy	k
2750	(0008,9215)[<0>](0008,010f)	CS	f	Derivation Code Sequence:Context Identifier	\N
5658	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0028,0011)	US	t	Advanced Presentation Sequence:Columns	k
2749	(0008,2112)[<0>](0040,a170)[<1>](0008,010b)	CS	f	Source Image Sequence:Purpose of Reference Code Sequence:Context Group Extension Flag	\N
5645	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0072,0510)	CS	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Reformatting Operation Type	k
5655	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0083)	TM	t	Advanced Presentation Sequence:Presentation State Sequence:Presentation Creation Time	k
371	(0053,"GEHC_CT_ADVAPP_001",62)	SH	t	Respiratory Flag	k
5651	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0080)	CS	t	Advanced Presentation Sequence:Presentation State Sequence:Content Label	k
5657	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0042)	US	t	Advanced Presentation Sequence:Presentation State Sequence:Image Rotation	k
5654	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,0033)	TM	t	Advanced Presentation Sequence:Presentation State Sequence:Content Time	k
2906	(00e1,"ELSCINT1",39)[<0>](0032,1064)[<1>](0008,0104)	LO	t	Unknown:Requested Procedure Code Sequence:Code Meaning	d
5656	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0028,0010)	US	t	Advanced Presentation Sequence:Rows	k
5650	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0070,0100)	CS	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Presentation Size Mode	k
66	(0019,"SIEMENS MR HEADER",0f)	OB	t	Gradient Mode	k
5183	(2005,"Philips MR Imaging DD 003",01)	OB	t	Number of Film Consumption	k
5644	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,1052)	DS	t	Advanced Presentation Sequence:Presentation State Sequence:Rescale Intercept	k
4984	(2005,"Philips MR Imaging DD 005",0e)[<0>](0008,0014)	UI	t	Private Shared Sequence:Instance Creator UID	na
5660	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",86)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Parallel Epiped	k
5647	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0072,0510)	CS	t	Advanced Presentation Sequence:Presentation Module Sequence:Reformatting Operation Type	k
628	(0009,"GEMS_PETD_01",ab)	FL	t	bp_center_x	k
5212	(2005,"Philips MR Imaging DD 001",2c)	OB	t	Phase Encode Reordering	k
5316	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",5d)	CS	t	Series Volume:Volume Type	k
2758	(0042,0012)	LO	f	MIME Type of Encapsulated Document	\N
2597	(0040,0008)	SQ	f	Scheduled Protocol Code Sequence	\N
796	(0009,"GEMS_PETD_01",16)	SL	t	Patient Position	k
5179	(7fd1,"GEIIS",10)	OB	t	Compression Type	d
1624	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",55)	UN	t	Unknown	d
4149	(5653,"Vital Images SW 3.4",14)[<0>](5653,"Vital Images SW 3.4",12)	OB	t	Saved Workflow File Sequence:Saved Workflow File Data	d
3058	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",60)	OB	t	Unknown:Unknown	d
1644	(0043,"GEMS_PARM_01",62)	SH	t	Unknown	d
783	(0009,"GEMS_PETD_01",17)	SL	t	Scan Perspective	k
194	(0019,"GEMS_ACQU_01",19)	DS	t	FirstScanLocation	k
6924	(0043,"GEMS_PARM_01",75)	US	t	Number of Active Volumes	d
6922	(0043,"GEMS_PARM_01",7c)	FL	t	Delay After Slice Group	d
6921	(0043,"GEMS_PARM_01",7b)	FL	t	Regressor Values	k
6925	(0043,"GEMS_PARM_01",74)	US	t	Number of Rest Volumes	k
6927	(0043,"GEMS_PARM_01",7a)	US	t	Expected Time Points	k
6928	(0043,"GEMS_PARM_01",73)	US	t	Experiment Type	k
6931	(0008,2112)[<0>](0008,0008)	CS	f	Source Image Sequence:Image Type	\N
5668	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",32)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Type	k
5666	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",49)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Field of View	k
5671	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",53)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Material	k
5232	(2005,"Philips MR Imaging DD 001",3b)	OB	t	Time Reversed Steady State	k
5203	(2005,"Philips MR Imaging DD 001",6e)	OB	t	Scanning Sequence	k
5667	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",49)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Field of View	k
5292	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](0070,0101)	DS	t	Presentation State Sequence:Displayed Area Selection Sequence:Presentation Pixel Spacing	k
5669	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Image Minimum Height	k
5196	(2005,"Philips MR Imaging DD 004",98)	OB	t	Mobiview Enabled	k
5672	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a8)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Presentation Module Type	k
5245	(2005,"Philips MR Imaging DD 005",4f)	OB	t	Volume Select	k
2759	(0028,0a04)	LO	f	Pixel Spacing Calibration Description	\N
5305	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)		t	Presentation State Sequence:Viewing Protocol	na
2582	(0040,0250)	DA	f	Performed Procedure Step End Date	\N
2746	(0008,2112)[<0>](0040,a170)[<1>](0008,0104)	LO	f	Source Image Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
2753	(0008,9215)[<0>](0008,0105)	CS	f	Derivation Code Sequence:Mapping Resource	\N
5224	(2005,"Philips MR Imaging DD 001",12)	OB	t	Cardiac Gating	k
3196	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
5234	(2005,"Philips MR Imaging DD 001",28)	OB	t	Partial Fourier Frequency	k
5237	(2005,"Philips MR Imaging DD 005",35)	OB	t	Spectro Examcard	k
5258	(2001,"Philips Imaging DD 001",86)	OB	t	Number of Phase Encoding Steps	k
5248	(2005,"Philips MR Imaging DD 001",27)	OB	t	Package Mode	k
5096	(2005,"Philips MR Imaging DD 001",1a)	OB	t	Label Syntax	k
1043	(0053,"GEHC_CT_ADVAPP_001",71)	UN	t	MultiEnergyScanType	k
5288	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 129",00)		t	Presentation State Sequence:Presentation State Sequence	na
388	(0043,"GEMS_PARM_01",34)	IS	t	OffsetFrequency	k
5254	(2005,"Philips MR Imaging DD 005",1b)	OB	t	Version Number Deleted Images	k
764	(0009,"GEMS_PETD_01",4d)	SL	t	Emission Present	k
5053	(2005,"Philips MR Imaging DD 001",0f)	OB	t	Window Center	k
617	(0009,"GEMS_PETD_01",bf)	FL	t	AC BP Filt Cutoff	k
3240	(300a,00b0)[<0>](300d,"TOMO_HA_01",80)	UN	t	Beam Sequence:Unknown	d
5673	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",1a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Unknown	d
303	(0019,"GEMS_ACQU_01",58)	SS	t	CTBoneNumber	k
520	(0021,"GEMS_RELA_01",58)	SL	t	IntegerSlop	k
4959	(2005,"Philips MR Imaging DD 003",81)	UI	t	Default Image UID	d
3723	(0021,"Siemens: Thorax/Multix FD Post Processing",05)	SS	t	Unknown	d
1344	(0009,"GEMS_PETD_01",82)	UI	t	Color Map ID	d
6951	(0018,9050)	LO	f	Transmit Coil Manufacturer Name	\N
6966	(0018,9010)	CS	f	Flow Compensation	\N
6949	(0018,9151)	DT	f	Frame Reference DateTime	\N
6950	(0018,9045)[<0>](0018,9047)	SH	f	Multi-Coil Definition Sequence:Multi-Coil Element Name	\N
6938	(0018,9045)	SQ	f	Multi-Coil Definition Sequence	\N
4675	(300a,03a2)[<0>](300a,0308)	CS	f	Ion Beam Sequence:Scan Mode	\N
5678	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",f0)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence:Unknown	d
5674	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5d)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",45)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Thickness Sequence:Camera Thickness	k
5266	(2005,"Philips MR Imaging DD 001",2a)	OB	t	Patient Reference ID	d
636	(0009,"GEMS_PETD_01",8d)	FL	t	Attenuation Coefficient	k
5677	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5f)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Sampling Distance	k
5315	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",5e)	CS	t	Series Volume:Volume View Axis	k
5675	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",60)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Initial Sampling Distance	k
5269	(2005,"Philips MR Imaging DD 001",1e)	OB	t	MIPProtocol	k
5263	(2005,"Philips MR Imaging DD 001",2d)	OB	t	NumberOfStackSlices	k
1275	(0009,"GEIIS",10)[<0>](0028,0002)	US	t	GE Private Image Thumbnail Sequence:Samples per Pixel	na
4983	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,0018)	UI	t	Private Per-Frame Sequence:SOP Instance UID	na
535	(0053,"GEHC_CT_ADVAPP_001",40)	SH	t	Iterative Recon Annotation	k
6988	(0018,9079)	FD	f	Inversion Times	\N
6989	(0018,9075)	CS	f	Diffusion Directionality	\N
6972	(0018,9098)	FD	f	Transmitter Frequency	\N
6985	(0040,9224)	FD	f	Real World Value Intercept	\N
6975	(0018,9232)	US	f	MR Acquisition Phase Encoding Steps out-of-plane	\N
5074	(2005,"Philips MR Imaging DD 005",12)	OB	t	Diffusion B Value Number	k
522	(0029,"GEMS_IMPS_01",18)	SL	t	UpperRangeOfPixels	k
6973	(0018,9218)	FD	f	Tag Spacing Second Dimension	\N
6977	(0040,08ea)	SQ	f	Measurement Units Code Sequence	\N
743	(0009,"GEMS_PETD_01",25)	SL	t	Axial Acceptance	k
6983	(0020,9222)[<0>](0020,9238)	LO	f	Dimension Index Sequence:Functional Group Private Creator	\N
6979	(0040,08ea)[<0>](0008,0100)	SH	f	Measurement Units Code Sequence:Code Value	\N
6981	(0040,08ea)[<0>](0008,0104)	LO	f	Measurement Units Code Sequence:Code Meaning	\N
6982	(0020,9222)[<0>](0020,9213)	LO	f	Dimension Index Sequence:Dimension Index Private Creator	\N
6976	(0020,9163)	US	f	In-concatenation Total Number	\N
6986	(0040,9216)	US	f	Real World Value First Value Mapped	\N
6987	(0040,9211)	US	f	Real World Value Last Value Mapped	\N
6980	(0040,08ea)[<0>](0008,0102)	SH	f	Measurement Units Code Sequence:Coding Scheme Designator	\N
6974	(0018,9220)	FD	f	Frame Acquisition Duration	\N
4981	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",91)	SQ	t	Presentation State Sequence:Original Modality LUT Sequence	d
6978	(0040,08ea)[<0>](0008,0117)	UI	f	Measurement Units Code Sequence:Context UID	\N
6990	(0020,9256)	FD	f	Respiratory Trigger Delay Threshold	\N
6984	(0040,9225)	FD	f	Real World Value Slope	\N
6970	(0018,9030)	FD	f	Tag Spacing First Dimension	\N
5060	(2005,"Philips MR Imaging DD 004",42)	OB	t	Signal Type	k
6971	(0018,9239)[<0>](0018,9181)	FD	f	Specific Absorption Rate Sequence:Specific Absorption Rate Value	\N
5123	(2005,"Philips MR Imaging DD 004",39)	OB	t	Search Interval for Peaks	k
5492	(07a3,"ELSCINT1",f7)	LO	t	Unknown	d
5681	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fd)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Application Type ID	d
5283	(2005,"Philips MR Imaging DD 001",3d)	OB	t	Number of RR Interval Ranges	k
5301	(0070,0060)[<0>](0070,0401)	US	f	Graphic Layer Sequence:Graphic Layer Recommended Display CIELab Value	\N
5482	(0032,1064)[<0>](0008,010f)	CS	f	Requested Procedure Code Sequence:Context Identifier	\N
5483	(0008,1032)[<0>](0008,010f)	CS	f	Procedure Code Sequence:Context Identifier	\N
5471	(0008,0040)	SS	f	Data Set Type	\N
5470	(0012,0042)	LO	f	Clinical Trial Subject Reading ID	\N
5473	(0040,1001)	SH	f	Requested Procedure ID	\N
5302	(0070,0060)[<0>](0070,0067)	US	f	Graphic Layer Sequence:Graphic Layer Recommended Display RGB Value	\N
750	(0009,"GEMS_PETD_01",73)	SL	t	frame_valid	k
5056	(2005,"Philips MR Imaging DD 005",13)	OB	t	Gradient Orientation Number	k
5238	(2005,"Philips MR Imaging DD 001",16)	OB	t	Flow Compensation	k
5312	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",5c)	FL	t	Series Volume:Volume Offcentre RL	k
1375	(01f7,"ELSCINT1",11)	OW	t	Unknown	d
3192	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
599	(0009,"GEMS_PETD_01",cc)	FL	t	vqc_x_axis_tilt	k
250	(0025,"GEMS_SERS_01",07)	SL	t	ImagesInSeries	k
5228	(2005,"Philips MR Imaging DD 005",3f)	OB	t	Active Implantable Medical Device Limits Applied	k
5331	(0015,"GEMS_PETD_01",29)	UN	t	Decay Flag	k
348	(0045,"GEMS_HELIOS_01",03)	SS	t	DAS type	k
3028	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
778	(0009,"GEMS_PETD_01",34)	SL	t	Triggers Acquired	k
825	(01f1,"ELSCINT1",02)	CS	t	Focal Spot Resolution	k
3289	(3773,"Unnamed Private Block - 01",31)	SQ	t	Unknown	d
5521	(0018,9169)	CS	f	Cardiac Beat Rejection Technique	\N
5520	(0018,9085)	CS	f	Cardiac Signal Source	\N
4223	(0011,"ULTRAVISUAL_TAG_SET1",12)	UN	t	Unknown	d
431	(0019,"GEMS_ACQU_01",a1)	SS	t	ExtremityCoilFlag	k
4039	(0019,"",09)	LO	t	Unknown	d
3789	(0019,"",09)	UN	t	Unknown	d
3130	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2907	(00e1,"ELSCINT1",39)[<0>](0040,0260)[<1>](0008,0104)	LO	t	Unknown:Performed Protocol Code Sequence:Code Meaning	d
3767	(0079,"Unnamed Private Block - 10",0c)	DS	t	Unknown	d
4242	(0077,"NIL_CoReg_ATT",04)	SS	t	Unknown	d
2975	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",63)	OB	t	Unknown:Unknown	d
2121	(3773,"MIM Software Inc.",0c)	UN	t	Unknown	d
2872	(00e1,"ELSCINT1",07)	IS	t	Unknown	d
6607	(0019,"SIEMENS MR VA0  GEN",45)	IS	t	ArrayCoilADCPairNumber	d
6635	(0011,"SIEMENS CM VA0  CMS",23)	DS	t	UsedPatientWeight	d
6610	(0019,"SIEMENS MR VA0  COAD",21)	IS	t	NumberOfTransmitterAmplitudes	k
6600	(0021,"SIEMENS MR VA0  GEN",40)	IS	t	NumberOfSlicesNominal	k
6579	(07a3,"ELSCINT1",13)	UN	t	Unknown	d
6643	(0019,"SIEMENS MR VA0  GEN",12)	DS	t	StartDelayTime	k
6578	(07a3,"ELSCINT1",15)	UN	t	Unknown	d
6625	(0021,"SIEMENS MR VA0  GEN",24)	IS	t	PhaseCorrectionColumnsReconstruction	k
5337	(0015,"GEMS_PETD_01",1d)	UN	t	Phase Matched Series	k
5686	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Is Camera Required Flag	k
5685	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Directional Light Usage Flag	k
5684	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",85)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Rotation Center Usage Flag	k
5687	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",17)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line-Z-Blend Flag	k
5688	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",51)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Thickness Usage Flag	k
871	(0009,"GEMS_PETD_01",9d)	SL	t	Radial Filter 3D	k
647	(0009,"GEMS_PETD_01",9d)	SS	t	Radial Filter 3D	k
6656	(0021,"SIEMENS MR VA0  RAW",04)	DS	t	VOIPosition	k
5286	(2005,"Philips MR Imaging DD 001",60)	OB	t	Study Sequence Number	k
856	(0017,"GEMS_PETD_01",04)	DT	t	cal_datetime	o
4440	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a040)	CS	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Value Type	\N
5116	(2005,"Philips MR Imaging DD 005",06)	OB	t	Number of PS Specific Character Sets	k
5141	(2001,"Philips Imaging DD 001",1a)	OB	t	PCVelocity	k
5335	(0015,"GEMS_PETD_01",1f)	UN	t	PET Recon Parameters Exists	k
5323	(0015,"GEMS_PETD_01",32)	UN	t	Normalization Flag	k
1659	(0019,"SIEMENS MR HEADER",11)	SH	t	Flow Compensation	k
5308	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",55)	FL	t	Series Volume:Volume Angulation FH	k
347	(0021,"GEMS_RELA_01",36)	SS	t	ImageFromWhichPrescribed	k
5330	(0015,"GEMS_PETD_01",37)	UN	t	Unknown	d
5894	(0021,"GEMS_RELA_01",15)	US	t	Unknown	d
2126	(0009,"GEMS_GENIE_1",01)	SH	t	Unknown	d
3919	(0019,"",ae)	UN	t	Unknown	d
5893	(0021,"GEMS_RELA_01",16)	SS	t	Unknown	d
5895	(0095,"SIENET",20)	UN	t	RIS Patient Name	d
1387	(01f7,"ELSCINT1",2b)	OW	t	Unknown	d
1391	(00e1,"ELSCINT1",3f)	CS	t	Unknown	d
2905	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0008)[<2>](0008,0104)	LO	t	Unknown:Request Attributes Sequence:Scheduled Protocol Code Sequence:Code Meaning	d
5325	(0015,"GEMS_PETD_01",36)	UN	t	Unknown	d
2827	(01f7,"ELSCINT1",2b)	OB	t	Unknown	d
3631	(0045,"GEMS_FALCON_03",72)	IS	t	Collimator Width	d
5036	(0018,9181)	FD	f	Specific Absorption Rate Value	\N
4991	(0040,9210)	SH	f	LUT Label	\N
5343	(300a,0070)[<0>](300c,006a)	IS	f	Fraction Group Sequence:Referenced Patient Setup Number	\N
5318	(0008,1115)[<0>](0008,0054)	AE	f	Referenced Series Sequence:Retrieve AE Title	\N
5317	(0018,9183)	CS	f	Flow Compensation Direction	\N
4448	(0040,a730)[<0>](0040,a730)[<1>](0040,a504)[<2>](0008,0118)	UI	f	Content Sequence:Content Sequence:Content Template Sequence:Mapping Resource UID	\N
4435	(0040,a073)[<0>](0040,a075)	PN	f	Verifying Observer Sequence:Verifying Observer Name	\N
4436	(0040,a730)[<0>](0040,a123)	PN	f	Content Sequence:Person Name	\N
4433	(0040,a073)[<0>](0040,a027)	LO	f	Verifying Observer Sequence:Verifying Organization	\N
3633	(0018,704c)	DS	f	Grid Focal Distance	\N
4432	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)[<3>](0040,08ea)[<4>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Code Meaning	\N
4445	(0040,a730)[<0>](0040,a504)[<1>](0008,0105)	CS	f	Content Sequence:Content Template Sequence:Mapping Resource	\N
4437	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a160)	UT	f	Content Sequence:Content Sequence:Content Sequence:Text Value	\N
4444	(0040,a730)[<0>](0040,a730)[<1>](0040,a504)[<2>](0008,0105)	CS	f	Content Sequence:Content Sequence:Content Template Sequence:Mapping Resource	\N
4443	(0040,a730)[<0>](0040,a504)[<1>](0040,db00)	CS	f	Content Sequence:Content Template Sequence:Template Identifier	\N
424	(0019,"GEMS_ACQU_01",90)	SS	t	PauseInterval	k
261	(0019,"GEMS_ACQU_01",2c)	SL	t	NumberOfTriggers	k
849	(0009,"GEMS_PETD_01",ad)	UI	t	trans_frame_id	h
5689	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Rotation Axis Usage Flag	k
5692	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5b)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Do Depth Test Flag 	k
5919	(7039,"CtProjectionData-MayoClinc-v1",04)	UN	t	Unknown	d
5040	(0018,9090)	FD	f	Velocity Encoding Direction	\N
5923	(7029,"CtProjectionData-MayoClinc-v1",0b)	UN	t	Unknown	d
5922	(7039,"CtProjectionData-MayoClinc-v1",03)	UN	t	Unknown	d
5924	(7037,"CtProjectionData-MayoClinc-v1",0a)	UN	t	Unknown	d
5921	(7039,"CtProjectionData-MayoClinc-v1",09)	UN	t	Unknown	d
5691	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Rotation Axis Usage Flag	k
5690	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",85)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Rotation Center Usage Flag	k
389	(0027,"GEMS_IMAG_01",62)	FL	t	NumberOfExcitations	k
5002	(0018,9101)	CS	f	Frequency Correction	\N
5918	(7039,"CtProjectionData-MayoClinc-v1",07)	UN	t	Unknown	d
5920	(7039,"CtProjectionData-MayoClinc-v1",06)	UN	t	Unknown	d
470	(0019,"GEMS_ACQU_01",91)	DS	t	PulseTime	k
813	(01f1,"ELSCINT1",27)	DS	t	Rotation Time	k
1454	(0009,"GEIIS",0d)	UN	t	Unknown	d
384	(0043,"GEMS_PARM_01",60)	IS	t	Unknown	d
1595	(0029,"MITRA OBJECT DOCUMENT 1.0",00)	LO	t	IMPAX Object Document	d
5008	(0018,9199)	CS	f	Water Referenced Phase Correction	\N
3970	(0009,"",e3)	UN	t	Unknown	d
3659	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",aa)[<1>](0008,0018)	UI	t	Presentation State Sequence:Unknown:SOP Instance UID	d
2846	(01f1,"ELSCINT1",27)	OB	t	Rotation Time	d
4213	(0077,"",02)	SS	t	Unknown	d
4171	(0023,"GEMS_STDY_01",80)[<0>](0032,1064)[<1>](0008,0103)	SH	t	Has MPPS Related Tags:Requested Procedure Code Sequence:Coding Scheme Version	d
5027	(0008,9207)	CS	f	Volume Based Calculation Technique	\N
2893	(00e1,"ELSCINT1",39)[<0>](0008,0050)	SH	t	Unknown:Accession Number	d
1577	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",52)	UN	t	Unknown	d
5035	(0018,9155)	FD	f	Parallel Reduction Factor out-of-plane	\N
4230	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Presentation State Sequence:Softcopy VOI LUT Sequence:Linear Modality GL Transform	d
5043	(0018,9035)	FD	f	Tag Thickness	\N
2163	(7fd1,"GEIIS",60)	UL	t	Subband Bytecounts	k
245	(0043,"GEMS_PARM_01",11)	US	t	TotalInputViews	k
1264	(0009,"GEIIS",10)[<0>](0028,1052)	DS	t	GE Private Image Thumbnail Sequence:Rescale Intercept	na
5158	(2005,"Philips MR Imaging DD 005",4c)	OB	t	First Echo Time	k
236	(0027,"GEMS_IMAG_01",45)	FL	t	NormalRCoord	k
4986	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,0013)	TM	t	Private Per-Frame Sequence:Instance Creation Time	na
4990	(0028,9002)	UL	f	Data Point Columns	\N
5023	(0018,9170)	CS	f	Respiratory Motion Compensation Technique	\N
4460	(0028,1102)	SS	f	Green Palette Color Lookup Table Descriptor	\N
3657	(0040,0320)	SQ	f	Billing Procedure Step Sequence	\N
4449	(0040,a730)[<0>](0040,a504)[<1>](0008,0118)	UI	f	Content Sequence:Content Template Sequence:Mapping Resource UID	\N
4452	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a121)	DA	f	Content Sequence:Content Sequence:Content Sequence:Date	\N
4458	(0012,0064)[<0>](0008,0103)	SH	f	De-identification Method Code Sequence:Coding Scheme Version	\N
4457	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a168)[<4>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Code Meaning	\N
4456	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a168)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence	\N
4453	(0040,a073)[<0>](0040,a030)	DT	f	Verifying Observer Sequence:Verification DateTime	\N
4451	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0008,1199)[<3>](0062,000b)	US	f	Content Sequence:Content Sequence:Content Sequence:Referenced SOP Sequence:Referenced Segment Number	\N
4450	(0040,a504)[<0>](0008,0118)	UI	f	Content Template Sequence:Mapping Resource UID	\N
4461	(0028,1101)	SS	f	Red Palette Color Lookup Table Descriptor	\N
4459	(0028,1103)	SS	f	Blue Palette Color Lookup Table Descriptor	\N
5695	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4b)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Image Maximum Height	k
5697	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",09)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence:Measurement UID	h
5693	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3d)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Line Show Center Flag	k
5025	(0018,9025)	CS	f	Spectrally Selected Suppression	\N
3681	(0040,030e)[<0>](0018,0010)	LO	f	Exposure Dose Sequence:Contrast/Bolus Agent	\N
6714	(7001,"GEMS_MR_RAW_01",08)	UN	t	rdb_raw_data	d
6728	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",5b)	UN	t	Unknown	d
5012	(0018,9018)	CS	f	Echo Planar Pulse Sequence	\N
5925	(0010,0024)	SQ	f	Issuer of Patient ID Qualifiers Sequence	\N
5928	(0008,0051)	SQ	f	Issuer of Accession Number Sequence	\N
5930	(0008,0051)[<0>](0040,0031)	UT	f	Issuer of Accession Number Sequence:Local Namespace Entity ID	\N
5926	(0010,0024)[<0>](0040,0032)	UT	f	Issuer of Patient ID Qualifiers Sequence:Universal Entity ID	\N
5927	(0010,0024)[<0>](0040,0033)	CS	f	Issuer of Patient ID Qualifiers Sequence:Universal Entity ID Type	\N
5108	(2005,"Philips MR Imaging DD 004",82)	OB	t	Number of Procedure Codes	k
255	(0043,"GEMS_PARM_01",48)	SL	t	DASRegXm	k
815	(01f1,"ELSCINT1",26)	DS	t	Pitch	k
5038	(0018,9053)	FD	f	Chemical Shift Reference	\N
1292	(0029,"SIEMENS MEDCOM HEADER",40)[<0>](0029,"SIEMENS MEDCOM HEADER",43)	LO	t	ApplicationHeaderSequence:ApplicationHeaderVersion	na
3142	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",81)	OB	t	Unknown:Unknown	d
3149	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",34)	OB	t	Unknown:Unknown	d
2984	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3692	(0040,030e)[<0>](01e3,"ELSCINT1",04)	UN	t	Exposure Dose Sequence:Unknown	d
2976	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",63)	OB	t	Unknown:Unknown	d
4318	(0137,"NetRAAD",20)	LO	t	Unknown	d
4198	(0043,"GEMS_PARM_01",7f)	DS	t	Reserved	d
3677	(0040,030e)[<0>](0040,0310)	ST	f	Exposure Dose Sequence:Comments on Radiation Dose	\N
3685	(0040,030e)[<0>](0018,9330)	FD	f	Exposure Dose Sequence:X-Ray Tube Current in mA	\N
4479	(0038,0030)	DA	f	Discharge Date	\N
3682	(0040,030e)[<0>](0018,1030)	LO	f	Exposure Dose Sequence:Protocol Name	\N
4471	(4008,0212)	CS	f	Interpretation Status ID	\N
3679	(0040,030e)[<0>](0018,1151)	IS	f	Exposure Dose Sequence:X-Ray Tube Current	\N
3678	(0040,030e)[<0>](0018,1152)	IS	f	Exposure Dose Sequence:Exposure	\N
4462	(3006,0020)[<0>](3006,0038)	LO	f	Structure Set ROI Sequence:ROI Generation Description	\N
3686	(0040,030e)[<0>](0018,9073)	FD	f	Exposure Dose Sequence:Acquisition Duration	\N
4470	(4008,0210)	CS	f	Interpretation Type ID	\N
4465	(0020,0019)	IS	f	Item Number	\N
3680	(0040,030e)[<0>](0008,3010)	UI	f	Exposure Dose Sequence:Irradiation Event UID	\N
2735	(0008,1111)[<0>](2005,"Philips MR Imaging DD 005",04)	SS	t	Referenced Performed Procedure Step Sequence:Unknown	d
5977	(0057,"GEMS_VXTLSTATE_001",99)	FL	t	Unknown	d
5976	(0057,"GEMS_VXTLSTATE_001",9b)	FL	t	Unknown	d
5980	(0057,"GEMS_VXTLSTATE_001",9c)	FL	t	Unknown	d
5978	(0057,"GEMS_VXTLSTATE_001",9d)	FL	t	Unknown	d
5982	(0057,"GEMS_VXTLSTATE_001",98)	FL	t	Unknown	d
5115	(2005,"Philips MR Imaging DD 005",4a)	OB	t	Data Window Duration	k
5309	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",57)	FL	t	Series Volume:Volume FOV AP	k
5975	(0057,"GEMS_VXTLSTATE_001",96)	FL	t	Unknown	d
5985	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",88)	FL	t	Unknown:Unknown	d
5698	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",08)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",09)	UN	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Measurement Sequence:Measurement UID	h
5699	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b7)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence:Measurement Evaluation Text Position Vector	k
5278	(2005,"Philips MR Imaging DD 005",15)	OB	t	Number of Diffusion Gradient Orientations	k
5262	(2005,"Philips MR Imaging DD 004",92)	OB	t	Geolink ID	k
2780	(0020,9128)	UL	f	Temporal Position Index	\N
2967	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
4998	(0018,9051)	CS	f	Transmit Coil Type	\N
3709	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0d)	FL	t	Harmonization Gain	d
3710	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",15)	SS	t	Unknown	d
1287	(0009,"GEMS_GENIE_1",46)	UN	t	Unknown	d
3770	(0079,"Unnamed Private Block - 10",14)	DS	t	Unknown	d
3850	(0021,"",57)	UN	t	Unknown	d
3861	(0019,"",b6)	UN	t	Unknown	d
5981	(0057,"GEMS_VXTLSTATE_001",95)	FL	t	Unknown	d
5983	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",55)	FL	t	Unknown:Unknown	d
5344	(300a,00b0)[<0>](300a,00b6)[<1>](300a,011c)	DS	f	Beam Sequence:Beam Limiting Device Sequence:Leaf/Jaw Positions	\N
5979	(0057,"GEMS_VXTLSTATE_001",97)	FL	t	Unknown	d
5984	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",13)	FL	t	Unknown:Unknown	d
497	(0019,"GEMS_ACQU_01",df)	DS	t	UserData	d
766	(0009,"GEMS_PETD_01",20)	SL	t	Collect Count Rate	k
3712	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0e)	SS	t	Edge Enhancement Kernel	d
3711	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",11)	SS	t	Unknown	d
873	(0009,"GEMS_PETD_01",c1)	SL	t	AC Img Smooth	k
2332	(0008,1111)[<0>](2005,"Philips MR Imaging DD 005",06)	SS	t	Referenced Performed Procedure Step Sequence:Number of PS Specific Character Sets	k
2606	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",13)	IS	t	Unknown:Unknown	na
2605	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",15)[<1>](0023,"Unnamed Private Block - 20",16)	IS	t	Unknown:Unknown:Unknown	na
2170	(0009,"GEIIS",10)[<0>](0028,0006)	US	t	GE Private Image Thumbnail Sequence:Planar Configuration	k
5021	(0020,9072)	CS	f	Frame Laterality	\N
5044	(0018,9069)	FD	f	Parallel Reduction Factor In-plane	\N
1359	(01f1,"ELSCINT1",47)	SH	t	Unknown	d
2845	(01f1,"ELSCINT1",47)	OB	t	Unknown	d
1384	(01f7,"ELSCINT1",70)	OW	t	Unknown	d
2824	(01f7,"ELSCINT1",70)	OB	t	Unknown	d
5345	(300a,0070)[<0>](300a,00c6)	CS	f	Fraction Group Sequence:Radiation Type	\N
5484	(07a3,"ELSCINT1",fa)	DT	t	Unknown	d
4088	(700d,"TOSHIBA_MEC_MR3",02)	DS	t	Orientation Vector	d
5007	(0018,9022)	CS	f	Blood Signal Nulling	\N
646	(0009,"GEMS_PETD_01",c1)	SS	t	AC Img Smooth	k
6754	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",50)	UN	t	Unknown	d
6735	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",20)	UN	t	Unknown	d
6752	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",62)	UN	t	Unknown	d
5997	(0057,"GEMS_VXTLSTATE_001",66)	FL	t	Unknown	d
4380	(0015,"GEMS_PETD_01",31)	UL	t	Recon Algorithm	k
2169	(0009,"GEIIS",10)[<0>](0028,0120)	SS	t	GE Private Image Thumbnail Sequence:Pixel Padding Value	k
5702	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",01)	UN	t	Advanced Presentation Sequence:Presentation Type	k
2589	(0019,"SIEMENS DLR.01",90)	LO	t	PLAOfSecondaryDestination	k
233	(0021,"GEMS_RELA_01",92)	FL	t	BiopsyTLocation	k
5213	(2005,"Philips MR Imaging DD 001",36)	OB	t	StackType	k
1293	(0029,"SIEMENS MEDCOM HEADER",40)[<0>](0029,"SIEMENS MEDCOM HEADER",42)	LO	t	ApplicationHeaderSequence:ApplicationHeaderID	na
1878	(0009,"EMAGEON STUDY HOME",00)	UN	t	Unknown	d
4387	(0015,"GEMS_PETD_01",25)	SL	t	BP3d Filter OrderU	k
6770	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 001",60)	IS	t	Presentation State Sequence:Study Sequence Number	d
6781	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Presentation State Sequence:Linear Modality GL Transform:Linear Modality GL Transform	d
5032	(0018,9029)	CS	f	Oversampling Phase	\N
5018	(0018,9017)	CS	f	Steady State Pulse Sequence	\N
2777	(0029,"MITRA PRESENTATION 1.0",02)	UN	t	Window Centre	k
2776	(0029,"MITRA PRESENTATION 1.0",03)	LO	t	Invert	k
2624	(0051,"GEMS_FUNCTOOL_01",01)	UN	t	Group Name	k
1876	(0009,"EMAGEON STUDY HOME",01)	UN	t	Unknown	d
2629	(0051,"GEMS_FUNCTOOL_01",02)	UN	t	Function Name	k
2262	(2001,"Philips Imaging DD 001",09)	FL	t	Image Prepulse Delay	k
2626	(0051,"GEMS_FUNCTOOL_01",04)	UN	t	Scale	k
2218	(2001,"Philips Imaging DD 001",02)	IS	t	ChemicalShiftNumberMR	k
2288	(2001,"Philips Imaging DD 001",03)	FL	t	DiffusionB-Factor	k
2500	(2001,"Philips Imaging DD 001",07)	CS	t	ImageTypeEDES	k
2480	(2001,"Philips Imaging DD 001",0c)	CS	t	Arrhythmia Rejection	k
2631	(0051,"GEMS_FUNCTOOL_01",05)	UN	t	Parameter Count	k
2627	(0051,"GEMS_FUNCTOOL_01",06)	UN	t	Parameters	k
2628	(0051,"GEMS_FUNCTOOL_01",07)	UN	t	Version	k
2633	(0051,"GEMS_FUNCTOOL_01",08)	UN	t	Color Ramp Index	k
2625	(0051,"GEMS_FUNCTOOL_01",0b)	UN	t	B-Value	k
2483	(2001,"Philips Imaging DD 001",0e)	CS	t	Cardiac Cycled	k
2280	(2001,"Philips Imaging DD 001",11)	FL	t	DiffusionEchoTime	k
2461	(2001,"Philips Imaging DD 001",12)	CS	t	DynamicSeries	k
2572	(2001,"Philips Imaging DD 001",13)	SL	t	EPIFactor	k
2335	(2001,"Philips Imaging DD 001",16)	SS	t	NumberOfPCDirections	k
2569	(2001,"Philips Imaging DD 001",17)	SL	t	NumberOfPhasesMR	k
2580	(2001,"Philips Imaging DD 001",18)	SL	t	NumberOfSlicesMR	k
2761	(0009,"IMBIO JSON REPORT CONTENTS",00)	UN	t	Unknown	d
459	(0019,"GEMS_ACQU_01",9c)	LO	t	PulseSequenceName	k
804	(0009,"GEMS_PETD_01",8b)	SL	t	ReconMethod	k
275	(0043,"GEMS_PARM_01",47)	SL	t	DASCalFrequency	k
889	(0043,"GEMS_PARM_01",8a)	CS	t	Private In-Plane Phase Encoding Direction	k
168	(0027,"GEMS_IMAG_01",40)	SH	t	RASLetterOfImageLocation	k
208	(0019,"GEMS_ACQU_01",de)	DS	t	DynamicZAlphaValue	k
1120	(0009,"GEMS_PETD_01",7a)	SH	t	Image Set Software Version	k
748	(0009,"GEMS_PETD_01",c7)	SL	t	overlap	k
1134	(0009,"GEMS_PETD_01",7b)	LO	t	Image Set Date Time	o
1159	(0009,"GEMS_PETD_01",7b)	DT	t	Image Set Date Time	o
3728	(0018,1180)	SH	f	Collimator/grid Name	\N
4372	(0015,"GEMS_PETD_01",26)	UL	t	BP3d Filter FlagV	k
4488	(0043,"GEMS_PARM_01",6b)	US	t	L-MDK Correction Indicator	k
4382	(0015,"GEMS_PETD_01",21)	FL	t	IR Loop Filter Ratio	k
4524	(0040,0275)[<0>](0020,000d)	UI	f	Request Attributes Sequence:Study Instance UID	\N
4521	(0040,0275)[<0>](0008,1110)	SQ	f	Request Attributes Sequence:Referenced Study Sequence	\N
5039	(0020,9255)	FD	f	Nominal Respiratory Trigger Delay Time	\N
1021	(7005,"TOSHIBA_MEC_CT3",09)	LO	t	Number of Detector rows to Reconstruct	k
5704	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",44)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Near Clip Plane	k
5703	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",15)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Frame Rate	k
6900	(0021,"SIEMENS MR VA0  GEN",36)	IS	t	Actual3DImagePartitionNumber	d
6912	(0019,"SIEMENS MR VA0  COAD",c4)	IS	t	EPISwitchHardwareCode	d
6915	(0019,"SIEMENS MR VA0  COAD",c5)	DS	t	EPISwitchDelayTime	k
6913	(0019,"SIEMENS MR VA0  COAD",c3)	IS	t	EPISwitchConfigurationCode	k
6917	(0019,"SIEMENS MR VA0  COAD",c2)	DS	t	EPIInductance	k
6945	(2005,"Philips MR Imaging DD 005",11)	UI	t	MF Private Referenced SOP Instance UID	h
6916	(0019,"SIEMENS MR VA0  COAD",c1)	DS	t	EPICapacity	k
6947	(2005,"Philips MR Imaging DD 005",07)	SS	t	Number of Specific Character Set	k
6918	(0019,"SIEMENS MR VA0  GEN",a0)	DS	t	EPIReconstructionPhase	k
6919	(0019,"SIEMENS MR VA0  GEN",a1)	DS	t	EPIReconstructionSlope	k
6914	(0019,"SIEMENS CM VA0  ACQU",14)	LO	t	EPIFileName	d
6930	(0043,"GEMS_PARM_01",93)	DS	t	Spectro Quantitation Values	d
6929	(0043,"GEMS_PARM_01",94)	DS	t	Spectro Ratio Values	k
5204	(2001,"Philips Imaging DD 001",18)	OB	t	NumberOfSlicesMR	k
6823	(5200,9229)[<0>](0008,1140)[<1>](2005,"Philips MR Imaging DD 005",11)	UI	t	Shared Functional Groups Sequence:Referenced Image Sequence:MF Private Referenced SOP Instance UID	d
5133	(2005,"Philips MR Imaging DD 003",53)	OB	t	Number of Study Patient Medical Alerts	k
1880	(0099,"SIENET",05)	SL	t	Unknown	d
5010	(0018,9015)	CS	f	Time of Flight Contrast	\N
5022	(0018,9077)	CS	f	Parallel Acquisition	\N
2455	(2001,"Philips Imaging DD 001",19)	CS	t	PartialMatrixScanned	k
2259	(2001,"Philips Imaging DD 001",1b)	FL	t	PrepulseDelay	k
2421	(2001,"Philips Imaging DD 001",1c)	CS	t	PrepulseType	k
2205	(2001,"Philips Imaging DD 001",1d)	IS	t	ReconstructionNumberMR	k
6037	(0018,2001)	IS	f	Page Number Vector	\N
6044	(0020,9162)	US	f	In-concatenation Number	\N
6043	(0020,0242)	UI	f	SOP Instance UID of Concatenation Source	\N
6041	(0020,9228)	UL	f	Concatenation Frame Offset Number	\N
6038	(0054,0080)	US	f	Slice Vector	\N
6042	(0020,9161)	UI	f	Concatenation UID	\N
5118	(2005,"Philips MR Imaging DD 004",26)	OB	t	Spectro B0 Echo Top Position	k
5222	(2005,"Philips MR Imaging DD 005",3b)	OB	t	Is Coil Survey	k
4052	(0031,"",00)	CS	t	Unknown	d
3820	(0031,"",00)	UN	t	Unknown	d
4060	(0051,"",15)	SH	t	Unknown	d
3824	(0051,"",15)	UN	t	Unknown	d
3787	(0051,"",09)	UN	t	Unknown	d
3742	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",02)	US	t	Unknown	d
5300	(0008,1115)[<0>](2001,"Philips Imaging DD 001",c1)	LO	t	Referenced Series Sequence:Linear Modality GL Transform	d
4536	(0040,0275)[<0>](0032,1060)	LO	f	Request Attributes Sequence:Requested Procedure Description	\N
4527	(0040,0275)[<0>](0032,1064)[<1>](0008,0102)	SH	f	Request Attributes Sequence:Requested Procedure Code Sequence:Coding Scheme Designator	\N
3735	(0021,"Siemens: Thorax/Multix FD Post Processing",0e)	US	t	Dose Control Value	d
3897	(0043,"",37)	UN	t	Unknown	d
1855	(01f7,"ELSCINT1",73)	OW	t	Unknown	d
4538	(0008,1050)	PN	f	Performing Physician's Name	\N
1935	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",80)	US	t	Unknown:Unknown	d
1937	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",78)	SL	t	Unknown:Unknown:Unknown	d
1877	(0013,"CTP",20)	UN	t	Unknown	d
3863	(0043,"",89)	UN	t	Unknown	d
4537	(0010,1080)	LO	f	Military Rank	\N
4532	(0040,0275)[<0>](0032,1064)[<1>](0008,0100)	SH	f	Request Attributes Sequence:Requested Procedure Code Sequence:Code Value	\N
4519	(0040,0275)	SQ	f	Request Attributes Sequence	\N
4530	(0040,0275)[<0>](0040,0008)[<1>](0008,0100)	SH	f	Request Attributes Sequence:Scheduled Protocol Code Sequence:Code Value	\N
5066	(2005,"Philips MR Imaging DD 001",9e)	OB	t	Series Geometry	k
6864	(5200,9230)[<0>](0018,9226)[<1>](0008,9208)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Complex Image Component	\N
4541	(0088,0200)[<0>](0028,1101)	OW	f	Icon Image Sequence:Red Palette Color Lookup Table Descriptor	\N
3763	(0010,1001)	PN	f	Other Patient Names	\N
6872	(5200,9229)[<0>](0018,9006)[<1>](0018,9022)	CS	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence:Blood Signal Nulling	\N
6835	(5200,9229)[<0>](0008,1140)[<1>](0040,a170)[<2>](0008,0102)	SH	f	Shared Functional Groups Sequence:Referenced Image Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
4371	(0015,"GEMS_PETD_01",34)	UL	t	Emission Random Flag	k
4487	(0043,"GEMS_PARM_01",69)	US	t	Q-cal Correction Indicator	k
6829	(5200,9229)[<0>](0008,1140)[<1>](0040,a170)[<2>](0008,0100)	SH	f	Shared Functional Groups Sequence:Referenced Image Sequence:Purpose of Reference Code Sequence:Code Value	\N
286	(0043,"GEMS_PARM_01",14)	SS	t	CalibrationParameters	k
6857	(5200,9230)[<0>](0018,9226)[<1>](0008,9205)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Pixel Presentation	\N
1664	(00e1,"ELSCINT1",39)		t	Unknown	d
6861	(5200,9229)[<0>](0018,9115)[<1>](0018,9078)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Parallel Acquisition Technique	\N
6819	(5200,9229)[<0>](0018,9112)[<1>](0018,0091)	IS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Echo Train Length	\N
4974	(2005,"Philips MR Imaging DD 001",9e)		t	Series Geometry	k
1708	(0051,"GEMS_FUNCTOOL_01",03)	SL	t	Bias	k
4370	(0015,"GEMS_PETD_01",32)	UL	t	Normalization Flag	k
3780	(0040,9096)[<0>](0040,9211)	US	f	Real World Value Mapping Sequence:Real World Value Last Value Mapped	\N
3781	(0040,9096)[<0>](0040,9216)	US	f	Real World Value Mapping Sequence:Real World Value First Value Mapped	\N
6883	(5200,9229)[<0>](0018,9115)[<1>](0018,9183)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Flow Compensation Direction	\N
5164	(2005,"Philips MR Imaging DD 005",28)	OB	t	Number of Label Types	k
4540	(0088,0200)[<0>](7fe0,0010)	OB	f	Icon Image Sequence:Pixel Data	\N
6674	(0019,"SIEMENS MR VA0  COAD",50)	DS	t	ReceiverTotalGain	k
2653	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 005",36)	UI	t	Series Reference:Referenced Series Instance UID	h
2182	(2005,"Philips MR Imaging DD 001",85)	SQ	t	Series Volume	k
2689	(2005,"Philips MR Imaging DD 001",9f)	CS	t	SeriesSpectral Selective Excitation Pulse	k
2285	(2005,"Philips MR Imaging DD 001",a0)	FL	t	Dynamic Scan Begin Time	k
2519	(2005,"Philips MR Imaging DD 001",a9)	CS	t	Geometry Correction	k
2291	(2005,"Philips MR Imaging DD 001",b1)	FL	t	Diffusion Direction AP	k
2192	(2005,"Philips MR Imaging DD 002",99)	UL	t	Number of Request Excerpts	k
2199	(2005,"Philips MR Imaging DD 003",01)	UL	t	Number of Film Consumption	k
2336	(2005,"Philips MR Imaging DD 003",51)	SS	t	Number of Study Admitting Diagnostic Description	k
2310	(2005,"Philips MR Imaging DD 003",52)	SS	t	Number of Study Patient Contrast Allergies	k
2313	(2005,"Philips MR Imaging DD 003",53)	SS	t	Number of Study Patient Medical Alerts	k
4483	(0043,"GEMS_PARM_01",6e)	SH	t	Auto mA Mode	k
4369	(0015,"GEMS_PETD_01",29)	UL	t	Decay Flag	k
4481	(0043,"GEMS_PARM_01",6c)	IS	t	Detector Row	k
3773	(0040,0006)	PN	f	Scheduled Performing Physician's Name	\N
4542	(0088,0200)[<0>](0028,1102)	OW	f	Icon Image Sequence:Green Palette Color Lookup Table Descriptor	\N
3772	(0008,1040)	LO	f	Institutional Department Name	\N
6049	(0008,1031)	UN	f	<undef>	\N
5257	(2005,"Philips MR Imaging DD 005",1c)	OB	t	Version Number Deleted Spectra	k
4539	(0008,0081)	ST	f	Institution Address	\N
3756	(0008,0201)	SH	f	Timezone Offset From UTC	\N
4543	(0088,0200)[<0>](0028,1103)	OW	f	Icon Image Sequence:Blue Palette Color Lookup Table Descriptor	\N
3775	(0040,0241)	AE	f	Performed Station AE Title	\N
4359	(07a1,"ELSCINT1",58)	UN	t	Unknown	d
4478	(1111,"2.16.840.1.114330.1.1.1.1",13)	SL	t	Unknown	d
4368	(0015,"GEMS_PETD_01",33)	UL	t	Emission Deadtime Flag	k
4378	(0015,"GEMS_PETD_01",2e)	UL	t	Image filter 3d flag	k
4384	(0015,"GEMS_PETD_01",27)	FL	t	BP3d Filter OrderV	k
4502	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",08)	OB	t	Unknown	d
3136	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",a3)	OB	t	Unknown:Unknown	d
2864	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",03)	OB	t	Unknown:Unknown	d
4474	(1111,"2.16.840.1.114330.1.1.1.1",12)	FD	t	Unknown	d
4512	(5001,"vRad PACS",73)	UN	t	Unknown	d
4517	(5001,"vRad PACS",55)	UN	t	Unknown	d
4511	(0095,"SIENET",0c)	UL	t	Unknown	d
528	(0021,"GEMS_RELA_01",59)	SL	t	IntegerSlop	k
1221	(0013,"CTP",12)	LO	t	Site Name	k
5707	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",48)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Projection Type	k
3882	(0019,"",90)	UN	t	Unknown	d
3065	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",52)	OB	t	Unknown:Unknown	d
3894	(0043,"",90)	UN	t	Unknown	d
6063	(7005,"TOSHIBA_MEC_CT3",15)	OB	t	Special Helical Acquisition Number	k
6064	(7005,"TOSHIBA_MEC_CT3",21)	OB	t	Decrease in Artifact Filter	k
396	(0019,"GEMS_ACQU_01",8a)	SS	t	ActualReceiveGainAnalog	k
352	(0045,"GEMS_HELIOS_01",22)	SS	t	PeristalticFlag	k
6062	(7005,"TOSHIBA_MEC_CT3",40)	OB	t	DLP	k
6065	(7005,"TOSHIBA_MEC_CT3",22)	OB	t	Reconstruction Interval	k
6892	(5200,9230)[<0>](0018,9114)[<1>](0018,9082)	FD	f	Per-frame Functional Groups Sequence:MR Echo Sequence:Effective Echo Time	\N
5093	(2005,"Philips MR Imaging DD 001",15)	OB	t	Fat Saturation	k
6934	(0008,9121)[<0>](0020,000d)	UI	f	Referenced Raw Data Sequence:Study Instance UID	\N
6845	(5200,9230)[<0>](0028,9145)[<1>](0028,1052)	DS	f	Per-frame Functional Groups Sequence:Pixel Value Transformation Sequence:Rescale Intercept	\N
4390	(0015,"GEMS_PETD_01",1d)	SL	t	Phase Matched Series	k
6868	(5200,9229)[<0>](0020,9071)[<1>](0020,9072)	CS	f	Shared Functional Groups Sequence:Frame Anatomy Sequence:Frame Laterality	\N
399	(0019,"GEMS_ACQU_01",98)	SS	t	CenterFrequencyMethod	k
284	(0019,"GEMS_ACQU_01",11)	SS	t	SeriesContrast	k
6846	(5200,9229)[<0>](0018,9112)[<1>](0018,0080)	DS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Repetition Time	\N
5137	(2005,"Philips MR Imaging DD 005",03)	OB	t	Number of SPS Codes	k
6869	(0018,9004)	CS	f	Content Qualification	\N
1072	(0019,"SIEMENS CT VA0  COAD",93)	DS	t	OsteoRegressionLineIntercept	k
6859	(0008,9209)	CS	f	Acquisition Contrast	\N
879	(0043,"GEMS_PARM_01",97)	LO	t	Image Filtering Parameters	k
421	(0019,"GEMS_ACQU_01",88)	SS	t	ImagesPerCardiacCycle	k
6880	(5200,9229)[<0>](0018,9115)[<1>](0018,9027)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Spatial Pre-saturation	\N
1559	(0025,"GEMS_SERS_01",18)	SL	t	NumberOfImagesArchived	k
6839	(5200,9229)[<0>](0008,1140)[<1>](0040,a170)[<2>](0008,0104)	LO	f	Shared Functional Groups Sequence:Referenced Image Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
6936	(0008,9121)[<0>](0008,1115)[<1>](0020,000e)	UI	f	Referenced Raw Data Sequence:Referenced Series Sequence:Series Instance UID	\N
1266	(0009,"GEIIS",10)[<0>](0028,1051)	DS	t	GE Private Image Thumbnail Sequence:Window Width	na
5089	(2005,"Philips MR Imaging DD 001",29)	OB	t	PartialFourierPhase	k
5191	(2001,"Philips Imaging DD 001",1f)	OB	t	RespirationSync	k
6878	(0018,9100)	CS	f	Resonant Nucleus	\N
307	(0019,"GEMS_ACQU_01",15)	SS	t	StartNumberForEnhancedScans	k
1280	(0009,"GEMS_IDEN_01",05)	UN	t	Unknown	d
1314	(00e1,"ELSCINT1",c2)	UI	t	Unknown	d
3073	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3291	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0030)	DS	t	Unknown:Unknown:Pixel Spacing	d
3905	(0043,"",08)	UN	t	Unknown	d
4063	(0051,"",0a)	LO	t	Unknown	d
3672	(2001,"Philips Imaging DD 002",6d)	UN	t	Unknown	d
769	(0009,"GEMS_PETD_01",7e)	SL	t	Image Set Type	k
308	(0019,"GEMS_ACQU_01",71)	SS	t	SetIfFatqEstimatesWereUsed	k
5075	(2001,"Philips Imaging DD 001",88)	OB	t	Number of Averages	k
2138	(0009,"GEMS_GENIE_1",41)	SL	t	PatientFlags	d
3184	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",96)	OB	t	Unknown:Unknown	d
4547	(0054,0016)[<0>](0054,0304)[<1>](0008,0106)	DT	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Context Group Version	\N
4550	(0008,1250)[<0>](0040,a170)[<1>](0008,0105)	CS	f	Related Series Sequence:Purpose of Reference Code Sequence:Mapping Resource	\N
4559	(0008,3001)[<0>](0008,0018)	UI	f	Alternate Representation Sequence:SOP Instance UID	\N
4557	(0008,3001)	SQ	f	Alternate Representation Sequence	\N
4560	(0008,3001)[<0>](0020,000e)	UI	f	Alternate Representation Sequence:Series Instance UID	\N
4485	(0043,"GEMS_PARM_01",6a)	US	t	AV Correction Indicator	k
6850	(5200,9230)[<0>](0028,9145)[<1>](0028,1053)	DS	f	Per-frame Functional Groups Sequence:Pixel Value Transformation Sequence:Rescale Slope	\N
6874	(5200,9229)[<0>](0018,9115)[<1>](0018,9009)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Inversion Recovery	\N
2602	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",15)	SQ	t	Unknown:Unknown	na
1811	(0009,"GEIIS",10)[<0>](7fe0,0010)	OB	t	GE Private Image Thumbnail Sequence:Pixel Data	na
1016	(7005,"TOSHIBA_MEC_CT3",12)	SH	t	Position (supine or prone)	k
1029	(7005,"TOSHIBA_MEC_CT3",13)	US	t	Expert Plan Number	k
1579	(0025,"GEMS_SERS_01",19)	SL	t	LastImageNumberUsed	k
810	(01f1,"ELSCINT1",0c)	DS	t	Scanner Relative Center	k
6805	(5200,9229)[<0>](0008,1140)[<1>](0040,a170)	SQ	f	Shared Functional Groups Sequence:Referenced Image Sequence:Purpose of Reference Code Sequence	\N
6964	(0018,9239)[<0>](0018,9179)	CS	f	Specific Absorption Rate Sequence:Specific Absorption Rate Definition	\N
6856	(5200,9229)[<0>](0018,9112)[<1>](0018,9180)	CS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Gradient Output Type	\N
6831	(5200,9229)[<0>](0020,9071)[<1>](0008,2218)[<2>](0008,0100)	SH	f	Shared Functional Groups Sequence:Frame Anatomy Sequence:Anatomic Region Sequence:Code Value	\N
397	(0019,"GEMS_ACQU_01",94)	SS	t	TransmitGain	k
6965	(0018,9045)[<0>](0018,9048)	CS	f	Multi-Coil Definition Sequence:Multi-Coil Element Used	\N
6832	(5200,9229)[<0>](0020,9071)[<1>](0008,2218)[<2>](0008,0102)	SH	f	Shared Functional Groups Sequence:Frame Anatomy Sequence:Anatomic Region Sequence:Coding Scheme Designator	\N
6814	(5200,9230)[<0>](0028,9110)	SQ	f	Per-frame Functional Groups Sequence:Pixel Measures Sequence	\N
6826	(0008,9092)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1155)	UI	f	Referenced Image Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
1854	(00e1,"ELSCINT1",21)	DS	t	DLP Total	k
6797	(5200,9229)[<0>](0018,9125)	SQ	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence	\N
6935	(0008,9121)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1150)	UI	f	Referenced Raw Data Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
6685	(0019,"SIEMENS MR VA0  GEN",85)	CS	t	FilterTypeForPhaseCorrection	d
513	(0021,"GEMS_RELA_01",51)	DS	t	RotationFromSourceXRot	k
3630	(0045,"GEMS_FALCON_03",73)	IS	t	Collimator Height	d
2603	(0009,"EMAGEON JPEG2K INFO",00)	SQ	t	Unknown	d
4503	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",06)	OB	t	Unknown	d
2326	(2005,"Philips MR Imaging DD 004",57)	SS	t	Spectro Spectral BW	k
2403	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9018)	CS	t	Private Per-Frame Sequence:Echo Planar Pulse Sequence	na
2698	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9019)	FD	t	Private Per-Frame Sequence:Tag Angle First Axis	na
2396	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9051)	CS	t	Private Per-Frame Sequence:Transmit Coil Type	na
2289	(2005,"Philips MR Imaging DD 005",43)	FL	t	Active Implantable Medical Device dbDt Limit	k
2720	(4453,"DR Systems, Inc.",0c)[<0>](0008,1115)[<1>](0020,000e)	UI	t	Original Instance UID Sequence:Referenced Series Sequence:Series Instance UID	na
2718	(4453,"DR Systems, Inc.",0c)[<0>](0020,000d)	UI	t	Original Instance UID Sequence:Study Instance UID	na
779	(0009,"GEMS_PETD_01",c3)	SL	t	Scatter Method	k
1013	(7005,"TOSHIBA_MEC_CT3",0b)	SH	t	Filter	k
2802	(01f1,"ELSCINT1",0c)	OB	t	Scanner Relative Center	d
6075	(0020,3403)	DA	f	Modified Image Date	\N
6084	(0054,0220)[<0>](0054,0222)	SQ	f	View Code Sequence:View Modifier Code Sequence	\N
6078	(0018,1131)	DS	f	Table Traverse	\N
6073	(0020,3405)	TM	f	Modified Image Time	\N
6067	(0020,5002)	LO	f	Original Image Identification Nomenclature	\N
6072	(0020,0080)	CS	f	Masking Image	\N
6077	(0018,0070)	IS	f	Counts Accumulated	\N
6068	(0028,0050)	LO	f	Manipulated Image	\N
6066	(0020,5000)	AT	f	Original Image Identification	\N
6099	(0054,0220)[<0>](0054,0222)[<1>](0008,0102)	SH	f	View Code Sequence:View Modifier Code Sequence:Coding Scheme Designator	\N
6076	(0018,1243)	IS	f	Count Rate	\N
6071	(0020,3402)	CS	f	Modified Image ID	\N
6074	(0020,3100)	UN	f	<undef>	\N
1361	(07a1,"ELSCINT1",10)	LO	t	Unknown	d
2795	(07a1,"ELSCINT1",10)	OB	t	Unknown	d
1788	(00e1,"ELSCINT1",24)	CS	t	Unknown	d
4029	(0029,"",10)	CS	t	Unknown	d
3811	(0029,"",10)	UN	t	Unknown	d
3121	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",41)	OB	t	Unknown:Unknown	d
3977	(0043,"",38)	UN	t	Unknown	d
1784	(00e1,"ELSCINT1",25)	CS	t	Unknown	d
1820	(01f3,"ELSCINT1",11)	SQ	t	Unknown	d
5281	(2005,"Philips MR Imaging DD 005",1a)	OB	t	Fat Saturation Technique	k
6889	(5200,9229)[<0>](0018,9115)[<1>](0018,9069)	FD	f	Shared Functional Groups Sequence:MR Modifier Sequence:Parallel Reduction Factor In-plane	\N
1051	(0053,"GEHC_CT_ADVAPP_001",7b)	UN	t	MultiEnergyNoiseReduced	k
1140	(0009,"GEMS_PETD_01",76)	SL	t	compression	k
6842	(5200,9230)[<0>](0028,9132)[<1>](0028,1051)	DS	f	Per-frame Functional Groups Sequence:Frame VOI LUT Sequence:Window Width	\N
6920	(5200,9229)[<0>](0018,9115)[<1>](0018,9016)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Spoiling	\N
6822	(0008,9092)[<0>](0008,1115)[<1>](0020,000e)	UI	f	Referenced Image Evidence Sequence:Referenced Series Sequence:Series Instance UID	\N
6813	(5200,9229)[<0>](0018,9119)	SQ	f	Shared Functional Groups Sequence:MR Averages Sequence	\N
228	(0027,"GEMS_IMAG_01",47)	FL	t	NormalSCoord	k
6958	(0018,9060)	CS	f	De-coupled Nucleus	\N
6841	(5200,9230)[<0>](0020,9116)[<1>](0020,0037)	DS	f	Per-frame Functional Groups Sequence:Plane Orientation Sequence:Image Orientation (Patient)	\N
4561	(0071,"SIEMENS MED PT",22)	DT	t	Decay Correction DateTime	o
2165	(7fd1,"GEIIS",50)	UL	t	Subband Columns	k
6848	(5200,9229)[<0>](0018,9112)[<1>](0018,1314)	DS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Flip Angle	\N
5710	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4d)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Parallel Shift Interval MM	k
6811	(5200,9230)[<0>](0020,9116)	SQ	f	Per-frame Functional Groups Sequence:Plane Orientation Sequence	\N
6939	(0018,9239)	SQ	f	Specific Absorption Rate Sequence	\N
1681	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",66)	UN	t	Unknown	d
1745	(0009,"EMAGEON STUDY HOME",00)	LO	t	Unknown	d
1744	(0009,"EMAGEON STUDY HOME",01)	LO	t	Unknown	d
2168	(0009,"GEIIS",12)	IS	t	Unknown	d
6602	(0021,"SIEMENS MR VA0  GEN",41)	IS	t	NumberOfSlicesCurrent	d
5712	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a6)	UN	t	Advanced Presentation Sequence:Presentation Version Identifier	k
3181	(0009,"FDMS 1.0",90)	OB	t	DistributionCode	d
4011	(0019,"",a1)	UN	t	Unknown	d
2859	(01f3,"ELSCINT1",23)	OB	t	Unknown	d
3841	(0043,"",1c)	UN	t	Unknown	d
2778	(0029,"MITRA PRESENTATION 1.0",01)	UN	t	Window Width	k
2594	(0029,"SIEMENS MED DISPLAY",10)	US	t	RowsOfSubmatrix	k
2593	(0029,"SIEMENS MED DISPLAY",11)	US	t	ColumnsOfSubmatrix	k
2595	(0029,"SIEMENS MED DISPLAY",50)	US	t	OriginOfSubmatrix	k
1853	(0040,030e)[<0>](00e1,"ELSCINT1",21)	DS	t	Exposure Dose Sequence:DLP Total	k
2890	(00e1,"ELSCINT1",39)[<0>](0008,1032)[<1>](0008,0102)	SH	t	Unknown:Procedure Code Sequence:Coding Scheme Designator	d
3997	(0043,"",0e)	UN	t	Unknown	d
1627	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",5b)	UN	t	Unknown	d
2691	(2001,"Philips Imaging DD 001",04)	CS	t	DiffusionDirection	k
2678	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",4d)	CS	t	Series Reference:Referenced Image Type	k
2534	(2005,"Philips MR Imaging DD 004",35)	CS	t	Physical Quantity Spatial	k
2327	(2005,"Philips MR Imaging DD 004",39)	SS	t	Search Interval for Peaks	k
2417	(2005,"Philips MR Imaging DD 004",64)	CS	t	Volume Selection	k
2329	(2005,"Philips MR Imaging DD 004",70)	SS	t	Number Mixes Spectro	k
2381	(2005,"Philips MR Imaging DD 005",09)	DS	t	Rescale Intercept Original	k
2392	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9036)	CS	t	Private Per-Frame Sequence:Partial Fourier Direction	na
2398	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9077)	CS	t	Private Per-Frame Sequence:Parallel Acquisition	na
2358	(2005,"Philips MR Imaging DD 005",0f)[<0>](0028,3003)	LO	t	Private Per-Frame Sequence:LUT Explanation	na
2774	(2005,"Philips MR Imaging DD 005",1e)	UL	t	LUT1 Offset	k
6113	(6000,1500)	LO	f	Overlay Label	\N
6118	(0054,0052)	SQ	f	Rotation Information Sequence	\N
6114	(0018,4000)	LO	f	Acquisition Comments	\N
6115	(0018,0026)	SQ	f	Intervention Drug Information Sequence	\N
6120	(0054,0022)[<0>](0018,1149)	IS	f	Detector Information Sequence:Field of View Dimension(s)	\N
6121	(0054,0022)[<0>](0018,1182)	IS	f	Detector Information Sequence:Focal Distance	\N
6117	(0054,0022)	SQ	f	Detector Information Sequence	\N
3737	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0b)	US	t	Unknown	d
1647	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",63)	UN	t	Unknown	d
2665	(0040,9096)[<0>](2001,"Philips Imaging DD 001",c1)	LO	t	Real World Value Mapping Sequence:Linear Modality GL Transform	k
6932	(0008,9121)[<0>](0008,1115)	SQ	f	Referenced Raw Data Sequence:Referenced Series Sequence	\N
6837	(5200,9229)[<0>](0018,9042)[<1>](0018,9041)	LO	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Receive Coil Manufacturer Name	\N
241	(0043,"GEMS_PARM_01",4e)	FL	t	DurationOfXrayOn	k
5716	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",aa)	UN	t	Advanced Presentation Sequence:LUT Inverted Flag	k
328	(0045,"GEMS_HELIOS_01",3b)	LO	t	NoiseReductionImageFilterDesc	k
281	(0043,"GEMS_PARM_01",12)	SS	t	XrayChain	k
5717	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer PWL TransferFunction Sequence	k
6961	(0018,9062)	CS	f	De-coupling Method	\N
266	(0027,"GEMS_IMAG_01",1e)	SL	t	VmaMod	k
5272	(2005,"Philips MR Imaging DD 004",28)	OB	t	Spectro Data Origin	k
6933	(0008,9121)[<0>](0008,1115)[<1>](0008,1199)	SQ	f	Referenced Raw Data Sequence:Referenced Series Sequence:Referenced SOP Sequence	\N
1702	(0051,"GEMS_FUNCTOOL_01",02)	LO	t	Function Name	k
1698	(0051,"GEMS_FUNCTOOL_01",04)	FL	t	Scale	k
1706	(0051,"GEMS_FUNCTOOL_01",05)	SL	t	Parameter Count	k
1092	(0053,"GEHC_CT_ADVAPP_001",01)	UN	t	MultiEnergyNoiseRedBlendingFact	k
1705	(0051,"GEMS_FUNCTOOL_01",06)	LT	t	Parameters	k
1699	(0051,"GEMS_FUNCTOOL_01",0b)	FL	t	B-Value	k
5077	(2005,"Philips MR Imaging DD 005",2a)	OB	t	Exam Print Status	k
6858	(5200,9230)[<0>](0018,9226)[<1>](0008,9007)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Frame Type	\N
361	(0045,"GEMS_HELIOS_01",08)	SS	t	View Weighting Mode	k
3886	(0019,"",b4)	UN	t	Unknown	d
6799	(5200,9230)[<0>](0028,9132)	SQ	f	Per-frame Functional Groups Sequence:Frame VOI LUT Sequence	\N
1810	(0053,"GEHC_CT_ADVAPP_001",66)	LO	t	Image Browser Annotation	k
6853	(5200,9230)[<0>](0028,9110)[<1>](0018,0050)	DS	f	Per-frame Functional Groups Sequence:Pixel Measures Sequence:Slice Thickness	\N
817	(00e1,"ELSCINT1",23)	DS	t	Presentation Relative Part	k
291	(0019,"GEMS_ACQU_01",41)	SS	t	ComputeType	k
2275	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",6d)	FL	t	Unknown:Slab FOV FH	na
2264	(2005,"Philips MR Imaging DD 001",b2)	FL	t	Diffusion Direction FH	k
2191	(2005,"Philips MR Imaging DD 003",13)	UL	t	Number of Codes	k
2282	(2005,"Philips MR Imaging DD 004",61)	FL	t	Spectro Vertical Window	k
2226	(2005,"Philips MR Imaging DD 004",81)	IS	t	ScanoGram Survey Number of Images	k
2198	(2005,"Philips MR Imaging DD 005",0f)[<0>](0028,9002)	UL	t	Private Per-Frame Sequence:Data Point Columns	na
2210	(2005,"Philips MR Imaging DD 005",13)	IS	t	Gradient Orientation Number	k
2272	(2005,"Philips MR Imaging DD 005",42)	FL	t	Active Implantable Medical Device B1 RMS Limit	k
2263	(2005,"Philips MR Imaging DD 005",47)	FL	t	Power Optimization	k
2276	(2005,"Philips MR Imaging DD 005",4a)	FL	t	Data Window Duration	k
2287	(2005,"Philips MR Imaging DD 005",4b)	FL	t	Mixing Time	k
687	(0019,"GEMS_PETD_01",04)	LO	t	cal_datetime	o
854	(0019,"GEMS_PETD_01",04)	DT	t	cal_datetime	o
508	(0021,"GEMS_RELA_01",82)	DS	t	AutoWindowLevelBeta	k
416	(0043,"GEMS_PARM_01",09)	SS	t	RespiratoryTriggerPoint	k
6130	(0018,0026)[<0>](0018,0034)	LO	f	Intervention Drug Information Sequence:Intervention Drug Name	\N
6136	(0054,0052)[<0>](0018,1143)	DS	f	Rotation Information Sequence:Scan Arc	\N
6141	(0054,0052)[<0>](0018,1144)	DS	f	Rotation Information Sequence:Angular Step	\N
4417	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)[<3>](0040,08ea)[<4>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Coding Scheme Designator	\N
6145	(0018,0026)[<0>](0018,0028)	DS	f	Intervention Drug Information Sequence:Intervention Drug Dose	\N
6122	(0054,0052)[<0>](0018,1242)	IS	f	Rotation Information Sequence:Actual Frame Duration	\N
6137	(0054,0022)[<0>](0028,0031)	DS	f	Detector Information Sequence:Zoom Factor	\N
4251	(5200,9229)[<0>](0028,9110)	SQ	f	Shared Functional Groups Sequence:Pixel Measures Sequence	\N
6135	(0054,0022)[<0>](0018,1142)	DS	f	Detector Information Sequence:Radial Position	\N
4373	(0015,"GEMS_PETD_01",35)	UL	t	Blank Scan Flag	k
6129	(0054,0022)[<0>](0018,1180)	SH	f	Detector Information Sequence:Collimator/grid Name	\N
6134	(0054,0052)[<0>](0018,1142)	DS	f	Rotation Information Sequence:Radial Position	\N
4096	(0019,"SIEMENS MR HEADER",29)	FD	t	Mosaic Ref Acq Times	d
3878	(0027,"",33)	UN	t	Unknown	d
3906	(0025,"",1b)	UN	t	Unknown	d
4024	(0051,"",11)	UN	t	Unknown	d
4116	(0019,"SIEMENS MR HEADER",29)	UN	t	Mosaic Ref Acq Times	d
1536	(0019,"SIEMENS MR HEADER",29)	OB	t	Mosaic Ref Acq Times	d
2979	(0009,"FDMS 1.0",10)	OB	t	ExposureUnitTypeCode	d
313	(0025,"GEMS_SERS_01",11)	SS	t	NumberOfAcquisitions	k
5173	(2005,"Philips MR Imaging DD 004",63)	OB	t	Spectrum Pitch	k
6877	(5200,9229)[<0>](0018,9115)[<1>](0018,9077)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Parallel Acquisition	\N
6812	(5200,9229)[<0>](0018,9049)	SQ	f	Shared Functional Groups Sequence:MR Transmit Coil Sequence	\N
6852	(5200,9229)[<0>](0018,9125)[<1>](0018,0093)	DS	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:Percent Sampling	\N
864	(0009,"GEMS_PETD_01",c6)	SL	t	seg_qc_parm	k
5150	(2005,"Philips MR Imaging DD 005",41)	OB	t	Active Implantable Medical Device Whole Body SAR Limit	k
6968	(0018,9082)	FD	f	Effective Echo Time	\N
6957	(0018,9176)[<0>](0018,9178)	CS	f	Operating Mode Sequence:Operating Mode	\N
4278	(5200,9229)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0102)	SH	f	Shared Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Coding Scheme Designator	\N
6836	(5200,9229)[<0>](0018,9049)[<1>](0018,9050)	LO	f	Shared Functional Groups Sequence:MR Transmit Coil Sequence:Transmit Coil Manufacturer Name	\N
5172	(2005,"Philips MR Imaging DD 004",31)	OB	t	Number of Spectra Acquired	k
6946	(0008,2218)[<0>](0008,0117)	UI	f	Anatomic Region Sequence:Context UID	\N
6969	(0018,9019)	FD	f	Tag Angle First Axis	\N
6865	(5200,9229)[<0>](0018,9049)[<1>](0018,9051)	CS	f	Shared Functional Groups Sequence:MR Transmit Coil Sequence:Transmit Coil Type	\N
6881	(5200,9230)[<0>](0018,9226)[<1>](0008,9207)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Volume Based Calculation Technique	\N
6899	(5200,9229)[<0>](0018,9125)[<1>](0018,9058)	US	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:MR Acquisition Frequency Encoding Steps	\N
443	(0043,"GEMS_PARM_01",06)	SS	t	NumberOfEPIShots	k
6894	(5200,9229)[<0>](0018,9115)[<1>](0018,9168)	FD	f	Shared Functional Groups Sequence:MR Modifier Sequence:Parallel Reduction Factor Second In-plane	\N
6806	(5200,9229)[<0>](0018,9112)	SQ	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence	\N
642	(0009,"GEMS_PETD_01",b6)	SS	t	IR Loop Filter	k
446	(0019,"GEMS_ACQU_01",cf)	SS	t	PrescanStatus	k
2359	(2005,"Philips MR Imaging DD 004",97)	LO	t	Anatomic Region Code Value	k
2334	(2001,"Philips Imaging DD 001",0f)	SS	t	Cardiac Gate Width	k
2315	(2001,"Philips Imaging DD 001",15)	SS	t	NumberOfLocations	k
2340	(2001,"Philips Imaging DD 001",5f)[<0>](2001,"Philips Imaging DD 001",2d)	SS	t	StackSequence:StackNumberOfSlices	k
2350	(2001,"Philips Imaging DD 001",8b)	SH	t	Transmitting Coil	k
2300	(2001,"Philips Imaging DD 129",00)[<0>](0008,0018)	UI	t	Presentation State Sequence:SOP Instance UID	na
2308	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](0008,1140)[<2>](0008,1150)	UI	t	Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Class UID	na
2316	(2005,"Philips MR Imaging DD 001",1d)	SS	t	Measurement Scan Resolution	k
2356	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,0104)	LO	t	Unknown:Code Meaning	na
2301	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,010d)	UI	t	Unknown:Context Group Extension Creator UID	na
2354	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9041)	LO	t	Private Per-Frame Sequence:Receive Coil Manufacturer Name	na
2590	(0019,"SIEMENS SIENET",01)	DS	t	Unknown	d
5062	(2005,"Philips MR Imaging DD 001",6f)	OB	t	Acquisition Type	k
1095	(7005,"TOSHIBA_MEC_CT3",0a)	DS	t	Table Speed in mm/rot	k
3726	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",12)	SS	t	Unknown	d
3001	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
6146	(0054,0022)[<0>](0054,0200)	DS	f	Detector Information Sequence:Start Angle	\N
6151	(0054,0052)[<0>](0018,1140)	CS	f	Rotation Information Sequence:Rotation Direction	\N
6150	(0054,0022)[<0>](0018,1181)	CS	f	Detector Information Sequence:Collimator Type	\N
6152	(0018,0026)[<0>](0018,0035)	TM	f	Intervention Drug Information Sequence:Intervention Drug Start Time	\N
4528	(0040,0275)[<0>](0008,0050)	SH	f	Request Attributes Sequence:Accession Number	\N
4265	(0020,9222)[<0>](0020,9167)	AT	f	Dimension Index Sequence:Functional Group Pointer	\N
4146	(0019,"",0a)	US	t	Unknown	d
4442	(0040,a730)[<0>](0040,a730)[<1>](0040,a504)[<2>](0040,db00)	CS	f	Content Sequence:Content Sequence:Content Template Sequence:Template Identifier	\N
4280	(0062,0002)[<0>](0008,2218)[<1>](0008,0102)	SH	f	Segment Sequence:Anatomic Region Sequence:Coding Scheme Designator	\N
319	(0043,"GEMS_PARM_01",19)	SS	t	NumberOfBBHChainsToBlend	k
3893	(0019,"",f2)	UN	t	Unknown	d
6884	(5200,9229)[<0>](0018,9115)[<1>](0018,9026)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Spectrally Selected Excitation	\N
5336	(0015,"GEMS_PETD_01",25)	UN	t	BP3d Filter OrderU	k
322	(0043,"GEMS_PARM_01",15)	SS	t	TotalOutputViews	k
6827	(5200,9230)[<0>](0020,9111)[<1>](0018,9151)	DT	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Frame Reference DateTime	\N
195	(0019,"GEMS_ACQU_01",1b)	DS	t	LastScanLocation	k
6855	(5200,9229)[<0>](0018,9125)[<1>](0018,1312)	CS	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:In-plane Phase Encoding Direction	\N
6953	(0040,a170)[<0>](0008,0104)	LO	f	Purpose of Reference Code Sequence:Code Meaning	\N
6796	(5200,9230)[<0>](0018,9226)	SQ	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence	\N
6817	(5200,9230)[<0>](0020,9111)[<1>](0020,9128)	UL	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Temporal Position Index	\N
3898	(0019,"",7f)	UN	t	Unknown	d
6844	(5200,9229)[<0>](0018,9006)[<1>](0018,0095)	DS	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence:Pixel Bandwidth	\N
6940	(0018,9176)	SQ	f	Operating Mode Sequence	\N
6794	(5200,9230)[<0>](0018,9152)	SQ	f	Per-frame Functional Groups Sequence:MR Metabolite Map Sequence	\N
6875	(0018,9064)	CS	f	k-space Filtering	\N
6572	(0013,"Posda",01)	LO	t	Unknown	d
6571	(0013,"Posda",01)	UN	t	Unknown	d
6815	(5200,9229)[<0>](0018,9042)	SQ	f	Shared Functional Groups Sequence:MR Receive Coil Sequence	\N
6898	(5200,9229)[<0>](0018,9125)[<1>](0018,9231)	US	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:MR Acquisition Phase Encoding Steps in-plane	\N
6963	(0018,9065)	CS	f	Time Domain Filtering	\N
6824	(5200,9229)[<0>](0008,1140)[<1>](0008,1155)	UI	f	Shared Functional Groups Sequence:Referenced Image Sequence:Referenced SOP Instance UID	\N
6952	(0018,9041)	LO	f	Receive Coil Manufacturer Name	\N
6851	(5200,9229)[<0>](0018,9125)[<1>](0018,0094)	DS	f	Shared Functional Groups Sequence:MR FOV/Geometry Sequence:Percent Phase Field of View	\N
4270	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0008,1150)	UI	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Referenced SOP Class UID	\N
4447	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0008,1199)[<3>](0008,1150)	UI	f	Content Sequence:Content Sequence:Content Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
4275	(5200,9229)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0100)	SH	f	Shared Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Code Value	\N
4298	(0040,a372)[<0>](0008,0103)	SH	f	Performed Procedure Code Sequence:Coding Scheme Version	\N
6156	(0054,0011)	US	f	Number of Energy Windows	\N
2506	(2005,"Philips MR Imaging DD 001",a1)	CS	t	SyncraScanType	k
2467	(2005,"Philips MR Imaging DD 001",38)	CS	t	Spoiled	k
2452	(2005,"Philips MR Imaging DD 001",a2)	CS	t	Is COCA	k
2426	(2005,"Philips MR Imaging DD 004",27)	CS	t	Spectro Complex Component	k
2432	(2005,"Philips MR Imaging DD 004",42)	CS	t	Signal Type	k
2401	(2005,"Philips MR Imaging DD 004",96)	CS	t	Flow Images Present	k
2457	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,010b)	CS	t	Unknown:Context Group Extension Flag	na
2425	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9208)	CS	t	Private Per-Frame Sequence:Complex Image Component	na
2377	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,1041)	DS	t	Private Per-Frame Sequence:Contrast/Bolus Volume	na
2415	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9021)	CS	t	Private Per-Frame Sequence:T2 Preparation	na
2410	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9022)	CS	t	Private Per-Frame Sequence:Blood Signal Nulling	na
2409	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9024)	CS	t	Private Per-Frame Sequence:Saturation Recovery	na
2424	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9064)	CS	t	Private Per-Frame Sequence:k-space Filtering	na
2438	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9147)	CS	t	Private Per-Frame Sequence:Diffusion Anisotropy Type	na
2434	(2005,"Philips MR Imaging DD 005",16)	CS	t	Plan Mode	k
2479	(2005,"Philips MR Imaging DD 005",35)	CS	t	Spectro Examcard	k
4439	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)[<3>](0040,a30a)	DS	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Numeric Value	\N
6162	(0054,0016)[<0>](0054,0300)[<1>](0008,0104)	SH	f	Radiopharmaceutical Information Sequence:Radionuclide Code Sequence:Code Meaning	\N
6157	(0054,0021)	US	f	Number of Detectors	\N
6166	(0054,0414)[<0>](0008,0005)	CS	f	Patient Gantry Relationship Code Sequence:Specific Character Set	\N
6163	(0018,1061)	LO	f	Trigger Source or Type	\N
6165	(0054,0016)[<0>](0008,0005)	CS	f	Radiopharmaceutical Information Sequence:Specific Character Set	\N
6155	(0054,0052)[<0>](0054,0053)	US	f	Rotation Information Sequence:Number of Frames in Rotation	\N
1860	(01f3,"ELSCINT1",15)	US	t	Unknown	d
1836	(01f3,"ELSCINT1",16)	FL	t	Unknown	d
1838	(01f3,"ELSCINT1",19)	FL	t	Unknown	d
4050	(0051,"",08)	CS	t	Unknown	d
4158	(0028,041b)	UN	f	<undef>	\N
789	(0009,"GEMS_PETD_01",c0)	SL	t	AC BP Filt Order	k
4388	(0015,"GEMS_PETD_01",28)	SL	t	BP3d Filter CutoffV	k
6911	(3002,0030)[<0>](300a,00b6)[<1>](300a,00b8)	CS	f	Exposure Sequence:Beam Limiting Device Sequence:RT Beam Limiting Device Type	\N
4163	(0040,a370)[<0>](0040,2017)	LO	f	Referenced Request Sequence:Filler Order Number / Imaging Service Request	\N
6821	(0008,9092)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1150)	UI	f	Referenced Image Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Class UID	\N
1704	(0043,"GEMS_PARM_01",95)	DS	t	Prescan Reuse String	k
1701	(0051,"GEMS_FUNCTOOL_01",01)	LO	t	Group Name	k
1713	(01f1,"ELSCINT1",28)	DS	t	Table Increment	k
1711	(01f1,"ELSCINT1",33)	DS	t	Cycle Time	k
6907	(3002,0003)	LO	f	RT Image Name	\N
6962	(0028,9108)	CS	f	Data Representation	\N
262	(0029,"GEMS_IMPS_01",07)	SL	t	LowerRangeOfPixels	k
823	(01f1,"ELSCINT1",04)	CS	t	Angular Sampling Density	k
6943	(0008,1160)	IS	f	Referenced Frame Number	\N
6809	(5200,9229)[<0>](0020,9071)[<1>](0008,2218)	SQ	f	Shared Functional Groups Sequence:Frame Anatomy Sequence:Anatomic Region Sequence	\N
4100	(0028,1201)	US	f	Red Palette Color Lookup Table Data	\N
440	(0043,"GEMS_PARM_01",2f)	SS	t	RawDataType	k
4086	(0028,0108)	SS	f	Smallest Pixel Value in Series	\N
4419	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a300)[<3>](0040,08ea)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence	\N
4533	(0040,0275)[<0>](0040,0007)	LO	f	Request Attributes Sequence:Scheduled Procedure Step Description	\N
4120	(0008,9007)	CS	f	Frame Type	\N
4475	(1111,"2.16.840.1.114330.1.1.1.1",24)	FD	t	Unknown	d
4534	(0040,0275)[<0>](0032,1064)[<1>](0008,0104)	LO	f	Request Attributes Sequence:Requested Procedure Code Sequence:Code Meaning	\N
1716	(07a1,"ELSCINT1",02)	UL	t	Unknown	d
4141	(0028,1199)	UI	f	Palette Color Lookup Table UID	\N
1728	(07a1,"ELSCINT1",42)	SH	t	Unknown	d
4245	(0062,0002)[<0>](0008,2218)	SQ	f	Segment Sequence:Anatomic Region Sequence	\N
4529	(0040,0275)[<0>](0040,0009)	SH	f	Request Attributes Sequence:Scheduled Procedure Step ID	\N
4549	(0008,1250)[<0>](0040,a170)[<1>](0008,010f)	CS	f	Related Series Sequence:Purpose of Reference Code Sequence:Context Identifier	\N
4420	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a043)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence	\N
4260	(5200,9230)[<0>](0020,9111)	SQ	f	Per-frame Functional Groups Sequence:Frame Content Sequence	\N
4274	(5200,9230)[<0>](0020,9111)[<1>](0020,9056)	SH	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Stack ID	\N
4531	(0040,0275)[<0>](0040,1001)	SH	f	Request Attributes Sequence:Requested Procedure ID	\N
4161	(0040,a370)[<0>](0008,1111)	SQ	f	Referenced Request Sequence:Referenced Performed Procedure Step Sequence	\N
4264	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0008,1160)	IS	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Referenced Frame Number	\N
4286	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0104)	LO	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Code Meaning	\N
4535	(0040,0275)[<0>](0040,0008)[<1>](0008,0104)	LO	f	Request Attributes Sequence:Scheduled Protocol Code Sequence:Code Meaning	\N
4104	(0032,1031)	SQ	f	Requesting Physician Identification Sequence	\N
4257	(5200,9230)[<0>](0020,9113)	SQ	f	Per-frame Functional Groups Sequence:Plane Position Sequence	\N
4548	(0008,1250)[<0>](0040,a170)[<1>](0008,0106)	DT	f	Related Series Sequence:Purpose of Reference Code Sequence:Context Group Version	\N
4106	(0040,a123)	PN	f	Person Name	\N
4159	(0028,041c)	UN	f	<undef>	\N
2538	(2005,"Philips MR Imaging DD 004",34)	CS	t	Physical Quantity for Chemical Shift	k
2512	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9207)	CS	t	Private Per-Frame Sequence:Volume Based Calculation Technique	na
2509	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9017)	CS	t	Private Per-Frame Sequence:Steady State Pulse Sequence	na
2554	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9035)	FD	t	Private Per-Frame Sequence:Tag Thickness	na
2560	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9240)	US	t	Private Per-Frame Sequence:RF Echo Train Length	na
2565	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9241)	US	t	Private Per-Frame Sequence:Gradient Echo Train Length	na
2527	(2005,"Philips MR Imaging DD 005",2b)	CS	t	Exam Export Status	k
4107	(31bc,e638)	UN	f	<undef>	\N
4108	(0038,0020)	DA	f	Admitting Date	\N
4099	(0028,1203)	US	f	Blue Palette Color Lookup Table Data	\N
4166	(0018,9402)	FL	f	Distance Source to Isocenter	\N
4105	(300a,0182)	IS	f	Patient Setup Number	\N
4160	(0040,a372)[<0>](0008,0100)	SH	f	Performed Procedure Code Sequence:Code Value	\N
6174	(6000,0040)	UN	f	Overlay Type	\N
6177	(6000,0100)	UN	f	Overlay Bits Allocated	\N
6176	(6000,0011)	UN	f	Overlay Columns	\N
6175	(6000,3000)	UN	f	Overlay Data	\N
6178	(6000,0010)	UN	f	Overlay Rows	\N
6179	(6000,0050)	UN	f	Overlay Origin	\N
6172	(0054,0410)[<0>](0054,0412)[<1>](0008,0005)	CS	f	Patient Orientation Code Sequence:Patient Orientation Modifier Code Sequence:Specific Character Set	\N
6180	(6000,0102)	UN	f	Overlay Bit Position	\N
1741	(07a1,"ELSCINT1",58)	CS	t	Unknown	d
1735	(07a1,"ELSCINT1",5f)	CS	t	Unknown	d
1849	(07a1,"ELSCINT1",71)	SH	t	Unknown	d
2798	(01f1,"ELSCINT1",04)	OB	t	Angular Sampling Density	d
2712	(0008,1111)[<0>](2005,"Philips MR Imaging DD 005",04)	UN	t	Referenced Performed Procedure Step Sequence:Unknown	d
6960	(0018,9147)	CS	f	Diffusion Anisotropy Type	\N
4484	(0043,"GEMS_PARM_01",66)	US	t	Helical Correction Indicator	k
4414	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a043)[<4>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Coding Scheme Designator	\N
6959	(0028,9003)	CS	f	Signal Domain Columns	\N
6862	(5200,9229)[<0>](0018,9112)[<1>](0018,9176)[<2>](0018,9177)	CS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Operating Mode Sequence:Operating Mode Type	\N
1583	(0019,"SIEMENS MR HEADER",14)	IS	t	Ima Rel Table Position	k
3741	(0021,"Siemens: Thorax/Multix FD Post Processing",0f)	US	t	Unknown	d
2608	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",15)[<1>](0023,"Unnamed Private Block - 20",18)	FL	t	Unknown:Unknown:Unknown	na
2604	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",15)[<1>](0023,"Unnamed Private Block - 20",19)	IS	t	Unknown:Unknown:Unknown	na
6838	(5200,9229)[<0>](0020,9071)[<1>](0008,2218)[<2>](0008,0104)	LO	f	Shared Functional Groups Sequence:Frame Anatomy Sequence:Anatomic Region Sequence:Code Meaning	\N
1873	(0011,"SPI RELEASE 1",10)	LO	t	Organ	k
6942	(0020,9157)	UL	f	Dimension Index Values	\N
4446	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0008,1199)[<3>](0008,1155)	UI	f	Content Sequence:Content Sequence:Content Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	\N
1909	(0043,"GEMS_PARM_01",88)	UI	t	PURE Acquisition Calibration Series UID	h
2634	(0043,"GEMS_PARM_01",99)	LO	t	Extended Options	k
2632	(0051,"GEMS_FUNCTOOL_01",03)	UN	t	Bias	k
2623	(0051,"GEMS_FUNCTOOL_01",09)	UN	t	Window Width	k
6941	(0018,9080)	ST	f	Metabolite Map Description	\N
6910	(3002,0030)[<0>](3002,0032)	DS	f	Exposure Sequence:Meterset Exposure	\N
6574	(0040,0318)	CS	f	Organ Exposed	\N
6830	(5200,9229)[<0>](0018,9042)[<1>](0018,9045)[<2>](0018,9047)	SH	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Multi-Coil Definition Sequence:Multi-Coil Element Name	\N
6804	(0008,9092)[<0>](0008,1115)[<1>](0008,1199)	SQ	f	Referenced Image Evidence Sequence:Referenced Series Sequence:Referenced SOP Sequence	\N
6849	(5200,9230)[<0>](0028,9110)[<1>](0028,0030)	DS	f	Per-frame Functional Groups Sequence:Pixel Measures Sequence:Pixel Spacing	\N
6948	(0018,9074)	DT	f	Frame Acquisition DateTime	\N
4520	(0040,0275)[<0>](0032,1064)	SQ	f	Request Attributes Sequence:Requested Procedure Code Sequence	\N
4438	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)[<4>](0040,a30a)	DS	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Numeric Value	\N
2637	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",65)	IS	t	Series Reference:Reference Reconstruction Number	k
2670	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",68)	CS	t	Series Reference:Reference Type	k
2656	(2005,"Philips MR Imaging DD 003",56)	SS	t	Number of SC Software Versions	k
2664	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9050)	LO	t	Private Per-Frame Sequence:Transmit Coil Manufacturer Name	na
2674	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9094)	CS	t	Private Per-Frame Sequence:Coverage of k-Space	na
2701	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9602)	FD	t	Private Per-Frame Sequence:Diffusion b-value XX	na
2651	(2005,"Philips MR Imaging DD 005",2e)	FL	t	dBdt	k
4268	(0020,9221)[<0>](0020,9164)	UI	f	Dimension Organization Sequence:Dimension Organization UID	\N
2785	(0009,"GEMS_PETD_01",89)	FL	t	Window Level Min	k
1870	(0009,"SPI RELEASE 1",15)	LO	t	SPIImageUID	d
2779	(0009,"Unnamed Private Block - 10",00)	UN	t	Unknown	d
2607	(0009,"EMAGEON JPEG2K INFO",00)[<0>](0023,"Unnamed Private Block - 20",15)[<1>](0023,"Unnamed Private Block - 20",17)	FL	t	Unknown:Unknown:Unknown	na
5202	(2005,"Philips MR Imaging DD 001",c0)	OB	t	Scan Sequence	k
6802	(5200,9229)[<0>](0018,9112)[<1>](0018,9176)	SQ	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Operating Mode Sequence	\N
6871	(5200,9229)[<0>](0018,9115)[<1>](0018,9021)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:T2 Preparation	\N
6885	(5200,9230)[<0>](0018,9226)[<1>](0008,9206)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Volumetric Properties	\N
2630	(0051,"GEMS_FUNCTOOL_01",0a)	UN	t	Window Level	k
6888	(5200,9229)[<0>](0018,9006)[<1>](0018,9098)	FD	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence:Transmitter Frequency	\N
4269	(0020,9222)[<0>](0020,9164)	UI	f	Dimension Index Sequence:Dimension Organization UID	\N
6807	(5200,9230)[<0>](0028,9145)	SQ	f	Per-frame Functional Groups Sequence:Pixel Value Transformation Sequence	\N
4277	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0102)	SH	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Coding Scheme Designator	\N
5105	(2001,"Philips Imaging DD 001",17)	OB	t	NumberOfPhasesMR	k
4455	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a168)[<4>](0008,0100)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Code Value	\N
609	(0009,"GEMS_PETD_01",b9)	FL	t	Response Filt Param	k
4421	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)[<4>](0040,08ea)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence	\N
4276	(0062,0002)[<0>](0062,000f)[<1>](0008,0100)	SH	f	Segment Sequence:Segmented Property Type Code Sequence:Code Value	\N
6741	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",5a)	UN	t	Unknown	d
2609	(0009,"EMAGEON JPEG2K INFO",01)	DT	t	Unknown	d
4261	(5200,9229)[<0>](0008,9124)[<1>](0008,9215)	SQ	f	Shared Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence	\N
5271	(2001,"Philips Imaging DD 001",25)	OB	t	EchoTimeDisplayMR	k
75	(0019,"SIEMENS MR HEADER",14)	OB	t	Ima Rel Table Position	k
1587	(0025,"GEMS_SERS_01",14)	SL	t	IndicatesNumberOfUpdatesToHeader	k
4229	(0018,9117)[<0>](0018,9087)	FD	f	MR Diffusion Sequence:Diffusion b-value	\N
2267	(2001,"Philips Imaging DD 001",01)	FL	t	ChemicalShift	k
2484	(2001,"Philips Imaging DD 001",06)	CS	t	ImageEnhanced	k
2204	(2001,"Philips Imaging DD 001",08)	IS	t	PhaseNumber	k
2200	(2001,"Philips Imaging DD 001",0a)	IS	t	SliceNumberMR	k
4236	(0018,a001)[<0>](0008,0081)	LO	f	Contributing Equipment Sequence:Institution Address	\N
4228	(0018,9117)[<0>](0018,9075)	CS	f	MR Diffusion Sequence:Diffusion Directionality	\N
4227	(0018,9117)	SQ	f	MR Diffusion Sequence	\N
4526	(0040,0275)[<0>](0040,0008)[<1>](0008,0102)	SH	f	Request Attributes Sequence:Scheduled Protocol Code Sequence:Coding Scheme Designator	\N
2531	(2001,"Philips Imaging DD 001",0b)	CS	t	SliceOrientation	k
2422	(2001,"Philips Imaging DD 001",10)	CS	t	Cardiac Sync	k
2571	(2001,"Philips Imaging DD 001",14)	SL	t	NumberOfEchoes	k
2257	(2001,"Philips Imaging DD 001",1a)	FL	t	PCVelocity	k
2681	(2001,"Philips Imaging DD 001",1e)	CS	t	Reformat Accuracy	k
2187	(2005,"Philips MR Imaging DD 001",9e)	SQ	t	Series Geometry	k
2338	(2005,"Philips MR Imaging DD 003",45)	SS	t	Number of Software Version	k
2458	(2005,"Philips MR Imaging DD 004",25)	CS	t	Spectro SI B0 Correction	k
2404	(2005,"Philips MR Imaging DD 004",45)	CS	t	Spectro Echo Acquisition	k
2318	(2005,"Philips MR Imaging DD 005",06)	SS	t	Number of PS Specific Character Sets	k
2305	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9123)	UI	t	Private Per-Frame Sequence:Creator-Version UID	na
2399	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9012)	CS	t	Private Per-Frame Sequence:Multi-planar Excitation	na
2514	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9020)	CS	t	Private Per-Frame Sequence:Magnetization Transfer	na
2521	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9028)	CS	t	Private Per-Frame Sequence:Tagging	na
2497	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9029)	CS	t	Private Per-Frame Sequence:Oversampling Phase	na
2540	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9032)	CS	t	Private Per-Frame Sequence:Geometry of k-Space Traversal	na
2490	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9033)	CS	t	Private Per-Frame Sequence:Segmented k-Space Traversal	na
2687	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9062)	CS	t	Private Per-Frame Sequence:De-coupling Method	na
4552	(0054,0016)[<0>](0054,0304)[<1>](0008,010f)	CS	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Context Identifier	\N
4434	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a300)[<4>](0040,08ea)[<5>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Measured Value Sequence:Measurement Units Code Sequence:Code Meaning	\N
3697	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",06)	FL	t	Unknown	d
4525	(0040,0275)[<0>](0008,1110)[<1>](0008,1150)	UI	f	Request Attributes Sequence:Referenced Study Sequence:Referenced SOP Class UID	\N
4101	(0028,1202)	US	f	Green Palette Color Lookup Table Data	\N
4551	(0054,0016)[<0>](0054,0304)[<1>](0008,0105)	CS	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Mapping Resource	\N
6195	(0054,0052)[<0>](0018,1130)	DS	f	Rotation Information Sequence:Table Height	\N
2765	(0029,"MITRA MARKUP 1.0",01)	LO	t	Markup2	d
2762	(0029,"MITRA OBJECT DOCUMENT 1.0",00)	OB	t	IMPAX Object Document	d
1737	(07a5,"ELSCINT1",56)	CS	t	Unknown	d
6854	(5200,9229)[<0>](0018,9112)[<1>](0018,9176)[<2>](0018,9178)	CS	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Operating Mode Sequence:Operating Mode	\N
3963	(0009,"",31)	UN	t	Unknown	d
6828	(5200,9230)[<0>](0020,9111)[<1>](0018,9074)	DT	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Frame Acquisition DateTime	\N
6834	(5200,9229)[<0>](0018,9042)[<1>](0018,1250)	SH	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Receive Coil Name	\N
6954	(0018,9176)[<0>](0018,9177)	CS	f	Operating Mode Sequence:Operating Mode Type	\N
1905	(0008,1111)[<0>](2001,"Philips Imaging DD 001",c1)	LO	t	Referenced Performed Procedure Step Sequence:Linear Modality GL Transform	k
5319	(0015,"GEMS_PETD_01",33)	UN	t	Emission Deadtime Flag	k
273	(0029,"GEMS_IMPS_01",04)	SL	t	LowerRangeOfPixels	k
6876	(5200,9229)[<0>](0018,9042)[<1>](0018,9045)[<2>](0018,9048)	CS	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Multi-Coil Definition Sequence:Multi-Coil Element Used	\N
6810	(0008,9092)	SQ	f	Referenced Image Evidence Sequence	\N
6944	(0040,a170)[<0>](0008,0117)	UI	f	Purpose of Reference Code Sequence:Context UID	\N
6840	(5200,9230)[<0>](0028,9145)[<1>](0028,1054)	LO	f	Per-frame Functional Groups Sequence:Pixel Value Transformation Sequence:Rescale Type	\N
6908	(3002,0030)[<0>](300a,00b6)[<1>](300a,011c)	DS	f	Exposure Sequence:Beam Limiting Device Sequence:Leaf/Jaw Positions	\N
6847	(5200,9229)[<0>](0018,9119)[<1>](0018,0083)	DS	f	Shared Functional Groups Sequence:MR Averages Sequence:Number of Averages	\N
6903	(3002,0030)[<0>](300a,00b6)	SQ	f	Exposure Sequence:Beam Limiting Device Sequence	\N
5200	(2005,"Philips MR Imaging DD 004",30)	OB	t	InPlane Transforms	k
1700	(0043,"GEMS_PARM_01",98)	UI	t	ASSET Acquisition Calibration Series UID	h
1703	(0051,"GEMS_FUNCTOOL_01",07)	LO	t	Version	k
1709	(0051,"GEMS_FUNCTOOL_01",08)	SL	t	Color Ramp Index	k
1707	(0051,"GEMS_FUNCTOOL_01",09)	SL	t	Window Width	k
1710	(0051,"GEMS_FUNCTOOL_01",0a)	SL	t	Window Level	k
1906	(0054,0016)[<0>](2001,"Philips Imaging DD 001",c1)	LO	t	Radiopharmaceutical Information Sequence:Linear Modality GL Transform	k
1869	(0099,"SIENET",02)	UL	t	DataObjectAttributes	k
2402	(2001,"Philips Imaging DD 001",1f)	CS	t	RespirationSync	k
2363	(2001,"Philips Imaging DD 001",20)	LO	t	Scanning Technique	k
2473	(2001,"Philips Imaging DD 001",21)	CS	t	SPIR	k
2551	(2005,"Philips MR Imaging DD 005",0f)[<0>](0020,9254)	FD	t	Private Per-Frame Sequence:Respiratory Interval Time	na
2639	(2005,"Philips MR Imaging DD 005",10)	IS	t	MF Conv Treat Spectro Mix Number	k
2573	(2005,"Philips MR Imaging DD 005",14)	SL	t	Number of Diffusion B Values	k
2648	(2005,"Philips MR Imaging DD 005",30)	FL	t	Non Proton SAR	k
2470	(2005,"Philips MR Imaging DD 005",3f)	CS	t	Active Implantable Medical Device Limits Applied	k
2650	(2005,"Philips MR Imaging DD 005",48)	FL	t	Coil Q	k
2270	(2005,"Philips MR Imaging DD 005",4c)	FL	t	First Echo Time	k
2460	(2005,"Philips MR Imaging DD 005",4e)	CS	t	Is B1 Series	k
6196	(0054,0022)[<0>](0018,1147)	CS	f	Detector Information Sequence:Field of View Shape	\N
4258	(0062,0002)[<0>](0062,000f)	SQ	f	Segment Sequence:Segmented Property Type Code Sequence	\N
4273	(0062,0002)[<0>](0008,2218)[<1>](0008,0100)	SH	f	Segment Sequence:Anatomic Region Sequence:Code Value	\N
4250	(5200,9229)[<0>](0008,9124)	SQ	f	Shared Functional Groups Sequence:Derivation Image Sequence	\N
4255	(0020,9222)	SQ	f	Dimension Index Sequence	\N
4272	(0062,0002)[<0>](0062,0003)[<1>](0008,0100)	SH	f	Segment Sequence:Segmented Property Category Code Sequence:Code Value	\N
4262	(5200,9230)[<0>](0020,9111)[<1>](0020,9057)	UL	f	Per-frame Functional Groups Sequence:Frame Content Sequence:In-Stack Position Number	\N
4244	(0062,0002)[<0>](0062,0006)	ST	f	Segment Sequence:Segment Description	\N
4253	(0062,0002)	SQ	f	Segment Sequence	\N
4256	(5200,9229)[<0>](0020,9116)	SQ	f	Shared Functional Groups Sequence:Plane Orientation Sequence	\N
4246	(5200,9230)	SQ	f	Per-frame Functional Groups Sequence	\N
4263	(5200,9230)[<0>](0020,9111)[<1>](0020,9157)	UL	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Dimension Index Values	\N
4266	(0020,9222)[<0>](0020,9165)	AT	f	Dimension Index Sequence:Dimension Index Pointer	\N
4259	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)	SQ	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence	\N
4248	(0020,9221)	SQ	f	Dimension Organization Sequence	\N
4249	(0062,0002)[<0>](0062,0003)	SQ	f	Segment Sequence:Segmented Property Category Code Sequence	\N
4252	(5200,9229)	SQ	f	Shared Functional Groups Sequence	\N
246	(0043,"GEMS_PARM_01",10)	US	t	WindowValue	k
6902	(3002,0030)	SQ	f	Exposure Sequence	\N
3101	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",13)	OB	t	Unknown:Unknown	d
2243	(2001,"Philips Imaging DD 001",22)	FL	t	WaterFatShift	k
2366	(2001,"Philips Imaging DD 001",23)	DS	t	FlipAnglePhilips	k
2459	(2001,"Philips Imaging DD 001",24)	CS	t	Series is Interactive	k
2345	(2001,"Philips Imaging DD 001",25)	SH	t	EchoTimeDisplayMR	k
2671	(2001,"Philips Imaging DD 001",4e)	CS	t	Window Smoothing Taste	k
2177	(2001,"Philips Imaging DD 001",5f)	SQ	t	StackSequence	k
2281	(2001,"Philips Imaging DD 001",5f)[<0>](2001,"Philips Imaging DD 001",32)	FL	t	StackSequence:StackRadialAngle	k
2429	(2001,"Philips Imaging DD 001",5f)[<0>](2001,"Philips Imaging DD 001",33)	CS	t	StackSequence:StackRadialAxis	k
2314	(2001,"Philips Imaging DD 001",5f)[<0>](2001,"Philips Imaging DD 001",35)	SS	t	StackSequence:StackSliceNumber	k
2507	(2001,"Philips Imaging DD 001",5f)[<0>](2001,"Philips Imaging DD 001",36)	CS	t	StackSequence:StackType	k
2241	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",71)	FL	t	StackSequence:Stack Angulation AP	k
2244	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",72)	FL	t	StackSequence:Stack Angulation FH	k
2294	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",73)	FL	t	StackSequence:Stack Angulation RL	k
2252	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",74)	FL	t	StackSequence:Stack FOV AP	k
2251	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",75)	FL	t	StackSequence:Stack FOV FH	k
2298	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",76)	FL	t	StackSequence:Stack FOV RL	k
2293	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",78)	FL	t	StackSequence:Stack Offcentre AP	k
2250	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",79)	FL	t	StackSequence:Stack Offcentre FH	k
2297	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",7a)	FL	t	StackSequence:Stack Offcentre RL	k
2390	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",7b)	CS	t	StackSequence:Stack Preparation Direction	k
2245	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",7e)	FL	t	StackSequence:Stack Slice Distance	k
2498	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",81)	CS	t	StackSequence:Stack View Axis	k
6923	(0043,"GEMS_PARM_01",79)	US	t	Slices Per Volume	k
5124	(2005,"Philips MR Imaging DD 004",38)	OB	t	Sample Pitch	k
2227	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",a3)	IS	t	StackSequence:Stack Coil ID	k
2213	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",a4)	IS	t	StackSequence:Stack CBB Coil 1	k
2219	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",a5)	IS	t	StackSequence:Stack CBB Coil 2	k
2223	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",a6)	IS	t	StackSequence:Stack Channel Combination Bitmask	k
2522	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 001",a7)	CS	t	StackSequence:Stack Coil Connection	k
2494	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 004",90)	CS	t	StackSequence:Stack Coil Function	k
2322	(2005,"Philips MR Imaging DD 001",86)	SS	t	Number of Geometry	k
2380	(2005,"Philips MR Imaging DD 001",a8)	DS	t	Inversion Time	k
2271	(2005,"Philips MR Imaging DD 001",b0)	FL	t	Diffusion Direction RL	k
2194	(2005,"Philips MR Imaging DD 005",03)	UL	t	Number of SPS Codes	k
2440	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9007)	CS	t	Private Per-Frame Sequence:Frame Type	na
6201	(0054,0090)	US	f	Angular View Vector	\N
5329	(0015,"GEMS_PETD_01",30)	UN	t	Emission Scatter Flag	k
2391	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9209)	CS	t	Private Per-Frame Sequence:Acquisition Contrast	na
2353	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9005)	SH	t	Private Per-Frame Sequence:Pulse Sequence Name	na
2491	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9008)	CS	t	Private Per-Frame Sequence:Echo Pulse Sequence	na
2408	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9014)	CS	t	Private Per-Frame Sequence:Phase Contrast	na
2532	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9027)	CS	t	Private Per-Frame Sequence:Spatial Pre-saturation	na
2535	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9034)	CS	t	Private Per-Frame Sequence:Rectilinear Phase Encode Reordering	na
2530	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9043)	CS	t	Private Per-Frame Sequence:Receive Coil Type	na
4283	(0062,0002)[<0>](0062,0009)	LO	f	Segment Sequence:Segment Algorithm Name	\N
4295	(5200,9229)[<0>](0062,000a)[<1>](0062,000b)	US	f	Shared Functional Groups Sequence:Segment Identification Sequence:Referenced Segment Number	\N
4281	(0062,0002)[<0>](0062,0003)[<1>](0008,0102)	SH	f	Segment Sequence:Segmented Property Category Code Sequence:Coding Scheme Designator	\N
4296	(0062,0002)[<0>](0062,0004)	US	f	Segment Sequence:Segment Number	\N
4284	(0062,0002)[<0>](0008,2218)[<1>](0008,0104)	LO	f	Segment Sequence:Anatomic Region Sequence:Code Meaning	\N
4297	(0040,a372)[<0>](0008,0102)	SH	f	Performed Procedure Code Sequence:Coding Scheme Designator	\N
4294	(0062,0001)	CS	f	Segmentation Type	\N
4292	(5200,9229)[<0>](0028,9110)[<1>](0018,0050)	DS	f	Shared Functional Groups Sequence:Pixel Measures Sequence:Slice Thickness	\N
4285	(0062,0002)[<0>](0062,0003)[<1>](0008,0104)	LO	f	Segment Sequence:Segmented Property Category Code Sequence:Code Meaning	\N
4288	(0062,0002)[<0>](0062,000f)[<1>](0008,0104)	LO	f	Segment Sequence:Segmented Property Type Code Sequence:Code Meaning	\N
4293	(0062,0002)[<0>](0062,0008)	CS	f	Segment Sequence:Segment Algorithm Type	\N
4287	(0062,0002)[<0>](0062,0005)	LO	f	Segment Sequence:Segment Label	\N
4279	(0062,0002)[<0>](0062,000f)[<1>](0008,0102)	SH	f	Segment Sequence:Segmented Property Type Code Sequence:Coding Scheme Designator	\N
4289	(5200,9230)[<0>](0020,9113)[<1>](0020,0032)	DS	f	Per-frame Functional Groups Sequence:Plane Position Sequence:Image Position (Patient)	\N
5723	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",42)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Orientation	k
5724	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",46)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera ViewPort Size	k
4309	(0062,0002)[<0>](0062,000f)[<1>](0008,2220)[<2>](0008,0100)	SH	f	Segment Sequence:Segmented Property Type Code Sequence:Anatomic Region Modifier Sequence:Code Value	\N
2237	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 005",3c)	FL	t	StackSequence:Stack Table Position Longitudinal	k
2236	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 005",3d)	FL	t	StackSequence:Stack Table Position Lateral	k
6870	(5200,9229)[<0>](0018,9115)[<1>](0018,9081)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Partial Fourier	\N
6843	(5200,9230)[<0>](0028,9132)[<1>](0028,1050)	DS	f	Per-frame Functional Groups Sequence:Frame VOI LUT Sequence:Window Center	\N
360	(0045,"GEMS_HELIOS_01",09)	SS	t	Sigma Row number	k
489	(0021,"GEMS_RELA_01",83)	DS	t	AutoWindowLevelWindow	k
6860	(5200,9230)[<0>](0018,9226)[<1>](0008,9209)	CS	f	Per-frame Functional Groups Sequence:MR Image Frame Type Sequence:Acquisition Contrast	\N
5198	(2001,"Philips Imaging DD 001",1c)	OB	t	PrepulseType	k
2238	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 005",3e)	FL	t	StackSequence:Stack Posterior Coil Position	k
2574	(2001,"Philips Imaging DD 001",60)	SL	t	NumberOfStacks	k
2444	(2001,"Philips Imaging DD 001",61)	CS	t	SeriesTransmitted	k
2488	(2005,"Philips MR Imaging DD 001",c0)	CS	t	Scan Sequence	k
296	(0027,"GEMS_IMAG_01",10)	SS	t	ScoutType	k
2996	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
2193	(2005,"Philips MR Imaging DD 003",00)	UL	t	Number of SOP Common	k
2374	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,1049)	DS	t	Private Per-Frame Sequence:Contrast/Bolus Ingredient Concentration	na
2504	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9011)	CS	t	Private Per-Frame Sequence:Multiple Spin Echo	na
2406	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9015)	CS	t	Private Per-Frame Sequence:Time of Flight Contrast	na
2515	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9016)	CS	t	Private Per-Frame Sequence:Spoiling	na
2703	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9030)	FD	t	Private Per-Frame Sequence:Tag Spacing First Dimension	na
2419	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9044)	CS	t	Private Per-Frame Sequence:Quadrature Receive Coil	na
2351	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9047)	SH	t	Private Per-Frame Sequence:Multi-Coil Element Name	na
2672	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9065)	CS	t	Private Per-Frame Sequence:Time Domain Filtering	na
2544	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9069)	FD	t	Private Per-Frame Sequence:Parallel Reduction Factor In-plane	na
2690	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9078)	CS	t	Private Per-Frame Sequence:Parallel Acquisition Technique	na
2400	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9081)	CS	t	Private Per-Frame Sequence:Partial Fourier	na
2552	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9091)	FD	t	Private Per-Frame Sequence:Velocity Encoding Minimum Value	na
2543	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9168)	FD	t	Private Per-Frame Sequence:Parallel Reduction Factor Second In-plane	na
2673	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9169)	CS	t	Private Per-Frame Sequence:Cardiac Beat Rejection Technique	na
2517	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9171)	CS	t	Private Per-Frame Sequence:Respiratory Signal Source	na
2655	(2005,"Philips MR Imaging DD 005",0f)[<0>](0040,9210)	SS	t	Private Per-Frame Sequence:LUT Label	na
2108	(3006,0020)[<0>](3263,"Varian Medical Systems VISION 3263",00)	UN	t	Structure Set ROI Sequence:Unknown	d
2151	(0021,"SIEMENS MED ECAT FILE INFO",00)	OB	t	ECAT_Main_Header	d
3947	(0027,"",60)	UN	t	Unknown	d
6203	(0054,0020)	US	f	Detector Vector	\N
6202	(0054,0010)	US	f	Energy Window Vector	\N
6204	(0054,0050)	US	f	Rotation Vector	\N
662	(0009,"GEMS_PETD_01",3e)	SH	t	Radio Nuclide Name	k
3982	(0043,"",03)	UN	t	Unknown	d
4301	(0040,a370)[<0>](0008,1110)[<1>](0008,1155)	UI	f	Referenced Request Sequence:Referenced Study Sequence:Referenced SOP Instance UID	\N
4306	(0008,0202)	LO	f	<undef>	\N
4312	(0062,0002)[<0>](0062,000f)[<1>](0008,2220)[<2>](0008,0104)	LO	f	Segment Sequence:Segmented Property Type Code Sequence:Anatomic Region Modifier Sequence:Code Meaning	\N
4300	(0040,a370)[<0>](0008,1110)[<1>](0008,1150)	UI	f	Referenced Request Sequence:Referenced Study Sequence:Referenced SOP Class UID	\N
4308	(0054,0051)	US	f	Number of Rotations	\N
4383	(0015,"GEMS_PETD_01",24)	FL	t	BP3d Filter CutoffU	k
4310	(0062,0002)[<0>](0062,000f)[<1>](0008,2220)[<2>](0008,0102)	SH	f	Segment Sequence:Segmented Property Type Code Sequence:Anatomic Region Modifier Sequence:Coding Scheme Designator	\N
4311	(0062,0002)[<0>](0062,000f)[<1>](0008,2220)	SQ	f	Segment Sequence:Segmented Property Type Code Sequence:Anatomic Region Modifier Sequence	\N
4307	(0008,0202)	UN	f	<undef>	\N
4162	(0040,a372)[<0>](0008,0104)	LO	f	Performed Procedure Code Sequence:Code Meaning	\N
791	(0009,"GEMS_PETD_01",95)	SL	t	Angle Smooth Param	k
5334	(0015,"GEMS_PETD_01",2e)	UN	t	Image filter 3d flag	k
5185	(2005,"Philips MR Imaging DD 001",00)	OB	t	Image Angulation AP	k
6955	(0018,9044)	CS	f	Quadrature Receive Coil	\N
4385	(0015,"GEMS_PETD_01",22)	FL	t	IR Loop Filter Correction	k
64	(0019,"SIEMENS MR HEADER",13)	OB	t	Ima Abs Table Position	k
6879	(5200,9229)[<0>](0018,9006)[<1>](0018,9020)	CS	f	Shared Functional Groups Sequence:MR Imaging Modifier Sequence:Magnetization Transfer	\N
6816	(5200,9230)[<0>](0018,9152)[<1>](0018,9080)	ST	f	Per-frame Functional Groups Sequence:MR Metabolite Map Sequence:Metabolite Map Description	\N
2786	(0009,"GEMS_PETD_01",8a)	FL	t	Window Level Max	k
170	(0009,"GEMS_IDEN_01",02)	SH	t	SuiteId	d
518	(0027,"GEMS_IMAG_01",36)	SL	t	ObliquePlane	k
6801	(5200,9229)[<0>](0018,9042)[<1>](0018,9045)	SQ	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Multi-Coil Definition Sequence	\N
6863	(0008,9208)	CS	f	Complex Image Component	\N
602	(0009,"GEMS_PETD_01",9a)	FL	t	CAC Edge Threshold	k
288	(0019,"GEMS_ACQU_01",70)	SS	t	ValueOfBackProjectionButton	k
419	(0019,"GEMS_ACQU_01",a0)	SS	t	SurfaceCoilType	k
6956	(0018,9009)	CS	f	Inversion Recovery	\N
2481	(2001,"Philips Imaging DD 001",62)	CS	t	SeriesCommitted	k
2676	(2001,"Philips Imaging DD 001",77)	CS	t	GL Transform Type	k
2652	(2001,"Philips Imaging DD 001",7a)	FL	t	Window Rounding Factor	k
2225	(2001,"Philips Imaging DD 001",7b)	IS	t	AcquisitionNumber	k
2203	(2001,"Philips Imaging DD 001",81)	IS	t	NumberOfDynamicScans	k
2224	(2001,"Philips Imaging DD 001",82)	IS	t	Echo Train Length	k
2372	(2001,"Philips Imaging DD 001",83)	DS	t	Imaging Frequency	k
2367	(2005,"Philips MR Imaging DD 005",0a)	DS	t	Rescale Slope Original	k
2375	(2001,"Philips Imaging DD 001",84)	DS	t	Inversion Time	k
2382	(2001,"Philips Imaging DD 001",85)	DS	t	Magnetic Field Strength	k
2214	(2001,"Philips Imaging DD 001",86)	IS	t	Number of Phase Encoding Steps	k
2362	(2005,"Philips MR Imaging DD 005",0b)	LO	t	Rescale Type Original	k
2389	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9205)	CS	t	Private Per-Frame Sequence:Pixel Presentation	na
2420	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9009)	CS	t	Private Per-Frame Sequence:Inversion Recovery	na
2511	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9025)	CS	t	Private Per-Frame Sequence:Spectrally Selected Suppression	na
2510	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9037)	CS	t	Private Per-Frame Sequence:Cardiac Synchronization Technique	na
2561	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9058)	US	t	Private Per-Frame Sequence:MR Acquisition Frequency Encoding Steps	na
2190	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9080)	ST	t	Private Per-Frame Sequence:Metabolite Map Description	na
2700	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9087)	FD	t	Private Per-Frame Sequence:Diffusion b-value	na
2546	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9181)	FD	t	Private Per-Frame Sequence:Specific Absorption Rate Value	na
2695	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9603)	FD	t	Private Per-Frame Sequence:Diffusion b-value XY	na
2702	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9605)	FD	t	Private Per-Frame Sequence:Diffusion b-value YY	na
2499	(2005,"Philips MR Imaging DD 005",0f)[<0>](0020,9072)	CS	t	Private Per-Frame Sequence:Frame Laterality	na
2696	(2005,"Philips MR Imaging DD 005",0f)[<0>](0020,9256)	FD	t	Private Per-Frame Sequence:Respiratory Trigger Delay Threshold	na
2679	(2005,"Philips MR Imaging DD 005",0f)[<0>](0028,9108)	CS	t	Private Per-Frame Sequence:Data Representation	na
883	(0043,"GEMS_PARM_01",90)	LO	t	SAR Definition	k
301	(0043,"GEMS_PARM_01",1c)	SS	t	GEImageIntegrity	k
3958	(0019,"",a2)	UN	t	Unknown	d
1665	(0019,"SIEMENS MR HEADER",13)	SL	t	Ima Abs Table Position	k
1457	(0009,"GEIIS",05)	UN	t	Unknown	d
2915	(00e1,"ELSCINT1",39)[<0>](00e1,"ELSCINT1",3b)	IS	t	Unknown:Unknown	d
4396	(5200,9230)[<0>](0008,9124)[<1>](0008,2112)[<2>](0008,1155)	UI	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Referenced SOP Instance UID	\N
4247	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)	SQ	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence	\N
4290	(5200,9229)[<0>](0028,9110)[<1>](0028,0030)	DS	f	Shared Functional Groups Sequence:Pixel Measures Sequence:Pixel Spacing	\N
5250	(2005,"Philips MR Imaging DD 001",11)	OB	t	Image Type	k
4426	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0008,1199)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Referenced SOP Sequence	\N
1090	(0053,"GEHC_CT_ADVAPP_001",02)	UN	t	MultiEnergyNoiseRedScaleFact	k
2991	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",83)	OB	t	Unknown:Unknown	d
3749	(0021,"Siemens: Thorax/Multix FD Post Processing",0a)	SL	t	Auto Window Width	d
454	(0019,"GEMS_ACQU_01",d3)	SH	t	ProjectionAlgorithm	k
282	(0019,"GEMS_ACQU_01",6a)	SS	t	DependantOnNumberOfViewsProcessed	k
6890	(5200,9230)[<0>](0020,9111)[<1>](0018,9220)	FD	f	Per-frame Functional Groups Sequence:Frame Content Sequence:Frame Acquisition Duration	\N
1035	(0053,"GEHC_CT_ADVAPP_001",8b)	UN	t	MaterialType#2	k
5171	(2005,"Philips MR Imaging DD 004",44)	OB	t	Spectro Display Ranges	k
6891	(5200,9229)[<0>](0018,9112)[<1>](0018,9239)[<2>](0018,9181)	FD	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Specific Absorption Rate Sequence:Specific Absorption Rate Value	\N
5726	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",35)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Application Number	k
5058	(2001,"Philips Imaging DD 001",07)	OB	t	ImageTypeEDES	k
3660	(200b,"Philips RAD Imaging DD 097",96)	SH	t	Unknown	d
5252	(2001,"Philips Imaging DD 001",84)	OB	t	Inversion Time	k
5214	(2005,"Philips MR Imaging DD 001",a2)	OB	t	Is COCA	k
1270	(0009,"GEIIS",10)[<0>](0028,0011)	US	t	GE Private Image Thumbnail Sequence:Columns	na
3265	(3f01,"INTELERAD MEDICAL SYSTEMS",09)	LO	t	Unknown	d
6967	(0018,9043)	CS	f	Receive Coil Type	\N
2349	(2001,"Philips Imaging DD 001",87)	SH	t	Imaged Nucleus	k
2383	(2001,"Philips Imaging DD 001",88)	DS	t	Number of Averages	k
2379	(2001,"Philips Imaging DD 001",89)	DS	t	Phase FOV Percent	k
2636	(2001,"Philips Imaging DD 001",cc)	ST	t	Derivation Description	k
2277	(2001,"Philips Imaging DD 001",f1)	FL	t	Prospective Motion Correction	k
2647	(2001,"Philips Imaging DD 001",f2)	FL	t	Retrospective Motion Correction	k
2501	(2001,"Philips Imaging DD 129",00)[<0>](0008,0005)	CS	t	Presentation State Sequence:Specific Character Set	na
2583	(2001,"Philips Imaging DD 129",00)[<0>](0008,0012)	DA	t	Presentation State Sequence:Instance Creation Date	na
2557	(2001,"Philips Imaging DD 129",00)[<0>](0008,0013)	TM	t	Presentation State Sequence:Instance Creation Time	na
2309	(2001,"Philips Imaging DD 129",00)[<0>](0008,0014)	UI	t	Presentation State Sequence:Instance Creator UID	na
2307	(2001,"Philips Imaging DD 129",00)[<0>](0008,0016)	UI	t	Presentation State Sequence:SOP Class UID	na
2178	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)	SQ	t	Presentation State Sequence:Referenced Series Sequence	na
2175	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](0008,1140)	SQ	t	Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence	na
2303	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](0008,1140)[<2>](0008,1155)	UI	t	Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Instance UID	na
2306	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](0020,000e)	UI	t	Presentation State Sequence:Referenced Series Sequence:Series Instance UID	na
2564	(2001,"Philips Imaging DD 129",00)[<0>](0018,1622)	US	t	Presentation State Sequence:Shutter Presentation Value	na
2209	(2001,"Philips Imaging DD 129",00)[<0>](0020,0013)	IS	t	Presentation State Sequence:Instance Number	na
2173	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)	SQ	t	Presentation State Sequence:Softcopy VOI LUT Sequence	na
2371	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)[<1>](0028,1050)	DS	t	Presentation State Sequence:Softcopy VOI LUT Sequence:Window Center	na
2369	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)[<1>](0028,1051)	DS	t	Presentation State Sequence:Softcopy VOI LUT Sequence:Window Width	na
2465	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)[<1>](2001,"Philips Imaging DD 001",53)	CS	t	Presentation State Sequence:Softcopy VOI LUT Sequence:Presentation GL Transform Invert	na
2493	(2001,"Philips Imaging DD 129",00)[<0>](0028,3110)[<1>](2001,"Philips Imaging DD 001",77)	CS	t	Presentation State Sequence:Softcopy VOI LUT Sequence:GL Transform Type	na
2176	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)	SQ	t	Presentation State Sequence:Displayed Area Selection Sequence	na
2568	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](0070,0052)	SL	t	Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Top Left Hand Corner	na
2579	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](0070,0053)	SL	t	Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Bottom Right Hand Corner	na
2502	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](0070,0100)	CS	t	Presentation State Sequence:Displayed Area Selection Sequence:Presentation Size Mode	na
2207	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](0070,0102)	IS	t	Presentation State Sequence:Displayed Area Selection Sequence:Presentation Pixel Aspect Ratio	na
2397	(2001,"Philips Imaging DD 129",00)[<0>](0070,005a)[<1>](2001,"Philips Imaging DD 001",3f)	CS	t	Presentation State Sequence:Displayed Area Selection Sequence:ZoomMode	na
2427	(2001,"Philips Imaging DD 129",00)[<0>](0070,0080)	CS	t	Presentation State Sequence:Content Label	na
2357	(2001,"Philips Imaging DD 129",00)[<0>](0070,0081)	LO	t	Presentation State Sequence:Content Description	na
2657	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,002a)	DT	t	Private Per-Frame Sequence:Acquisition DateTime	na
5231	(2005,"Philips MR Imaging DD 001",37)	OB	t	Is Spectro	k
5333	(0015,"GEMS_PETD_01",21)	UN	t	IR Loop Filter Ratio	k
3743	(0019,"Siemens: Thorax/Multix FD Lab Settings",05)	US	t	Unknown	d
3205	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
2930	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",10)	SQ	t	Unknown:Unknown	d
1907	(2001,"Philips Imaging DD 001",de)	UN	t	Unknown	d
2708	(2001,"Philips Imaging DD 002",6b)	UN	t	Unknown	d
2179	(2001,"Philips Imaging DD 129",00)	SQ	t	Presentation State Sequence	d
2584	(2001,"Philips Imaging DD 129",00)[<0>](0070,0082)	DA	t	Presentation State Sequence:Presentation Creation Date	na
2558	(2001,"Philips Imaging DD 129",00)[<0>](0070,0083)	TM	t	Presentation State Sequence:Presentation Creation Time	na
2365	(2001,"Philips Imaging DD 129",00)[<0>](0070,0084)	PN	t	Presentation State Sequence:Content Creator's Name	na
2456	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",26)	CS	t	Presentation State Sequence:Presentation State Subtraction Active	na
2436	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",67)	CS	t	Presentation State Sequence:Linear Presentation GL Transform Shape Sub	na
2180	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)	SQ	t	Presentation State Sequence:Linear Modality GL Transform	na
2376	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)[<1>](0028,1052)	DS	t	Presentation State Sequence:Linear Modality GL Transform:Rescale Intercept	na
2373	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)[<1>](0028,1053)	DS	t	Presentation State Sequence:Linear Modality GL Transform:Rescale Slope	na
2361	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)[<1>](0028,1054)	LO	t	Presentation State Sequence:Linear Modality GL Transform:Rescale Type	na
2492	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",68)[<1>](2001,"Philips Imaging DD 001",77)	CS	t	Presentation State Sequence:Linear Modality GL Transform:GL Transform Type	na
2525	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",77)	CS	t	Presentation State Sequence:GL Transform Type	na
2566	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",9f)	US	t	Presentation State Sequence:Pixel Processing Kernel Size	na
2186	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 129",00)	SQ	t	Presentation State Sequence:Presentation State Sequence	na
2575	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",34)	SL	t	Presentation State Sequence:Number of Image Per Series Ref	na
2320	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",57)	SS	t	Presentation State Sequence:Number of Running Attributes	na
2302	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",81)	UI	t	Presentation State Sequence:Default Image UID	na
2439	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",82)	CS	t	Presentation State Sequence:Running Attributes	na
2185	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)	SQ	t	Presentation State Sequence:Viewing Protocol	na
2330	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",06)	SS	t	Presentation State Sequence:Number of PS Specific Character Sets	na
2523	(2001,"Philips Imaging DD 129",00)[<0>](2050,0020)	CS	t	Presentation State Sequence:Presentation LUT Shape	na
2242	(2005,"Philips MR Imaging DD 001",00)	FL	t	Image Angulation AP	k
2240	(2005,"Philips MR Imaging DD 001",01)	FL	t	Image Angulation FH	k
2295	(2005,"Philips MR Imaging DD 001",02)	FL	t	Image Angulation RL	k
2518	(2005,"Philips MR Imaging DD 001",04)	CS	t	Image Display Orientation	k
2231	(2005,"Philips MR Imaging DD 001",08)	FL	t	Image Offcenter AP	k
2234	(2005,"Philips MR Imaging DD 001",09)	FL	t	Image Offcenter FH	k
2232	(2005,"Philips MR Imaging DD 001",0a)	FL	t	Image OffCentre RL	k
2235	(2005,"Philips MR Imaging DD 001",0b)	FL	t	Max FP	k
2290	(2005,"Philips MR Imaging DD 001",0c)	FL	t	Min FP	k
2292	(2005,"Philips MR Imaging DD 001",0d)	FL	t	Scale Intercept	k
2247	(2005,"Philips MR Imaging DD 001",0e)	FL	t	Scale Slope	k
2370	(2005,"Philips MR Imaging DD 001",0f)	DS	t	Window Center	k
2368	(2005,"Philips MR Imaging DD 001",10)	DS	t	Window Width	k
2423	(2005,"Philips MR Imaging DD 001",11)	CS	t	Image Type	k
2466	(2005,"Philips MR Imaging DD 001",12)	CS	t	Cardiac Gating	k
2405	(2005,"Philips MR Imaging DD 001",13)	CS	t	Development Mode	k
2443	(2005,"Philips MR Imaging DD 001",14)	CS	t	Diffusion	k
2451	(2005,"Philips MR Imaging DD 001",15)	CS	t	Fat Saturation	k
2482	(2005,"Philips MR Imaging DD 001",16)	CS	t	Flow Compensation	k
2448	(2005,"Philips MR Imaging DD 001",17)	CS	t	Fourier Interpolation	k
2659	(2005,"Philips MR Imaging DD 001",18)	LO	t	Hardcopy Protocol	k
2476	(2005,"Philips MR Imaging DD 001",19)	CS	t	Inverse Reconstructed	k
2317	(2005,"Philips MR Imaging DD 001",1a)	SS	t	Label Syntax	k
2464	(2005,"Philips MR Imaging DD 001",1b)	CS	t	Magnetization Prepared	k
2446	(2005,"Philips MR Imaging DD 001",1c)	CS	t	Magnetization Transfer Contrast	k
2348	(2005,"Philips MR Imaging DD 001",1e)	SH	t	MIPProtocol	k
2347	(2005,"Philips MR Imaging DD 001",1f)	SH	t	MPRProtocol	k
2578	(2005,"Philips MR Imaging DD 001",20)	SL	t	NumberOfChemicalShifts	k
2311	(2005,"Philips MR Imaging DD 001",21)	SS	t	Number of Mixes	k
2220	(2005,"Philips MR Imaging DD 001",22)	IS	t	Number of References	k
2312	(2005,"Philips MR Imaging DD 001",23)	SS	t	Number of Slabs	k
2333	(2005,"Philips MR Imaging DD 001",25)	SS	t	Number of Volumes	k
2385	(2005,"Philips MR Imaging DD 001",26)	CS	t	Over Sampling Phase	k
2394	(2005,"Philips MR Imaging DD 001",27)	CS	t	Package Mode	k
2477	(2005,"Philips MR Imaging DD 001",28)	CS	t	Partial Fourier Frequency	k
2478	(2005,"Philips MR Imaging DD 001",29)	CS	t	PartialFourierPhase	k
2339	(2005,"Philips MR Imaging DD 001",2b)	SS	t	Percent Scan Complete	k
2449	(2005,"Philips MR Imaging DD 001",2c)	CS	t	Phase Encode Reordering	k
2216	(2005,"Philips MR Imaging DD 001",2d)	IS	t	NumberOfStackSlices	k
2472	(2005,"Philips MR Imaging DD 001",2e)	CS	t	PPG PPU Gating	k
2388	(2005,"Philips MR Imaging DD 001",2f)	CS	t	Spatial Presaturation	k
2299	(2005,"Philips MR Imaging DD 001",30)	FL	t	Repetition Time	k
2462	(2005,"Philips MR Imaging DD 001",31)	CS	t	Respiratory Gating	k
2688	(2005,"Philips MR Imaging DD 001",32)	CS	t	StackRadialAngle	k
2296	(2005,"Philips MR Imaging DD 001",33)	FL	t	StackRadialAxis	k
3907	(0019,"",c9)	UN	t	Unknown	d
2387	(2005,"Philips MR Imaging DD 001",34)	CS	t	Segmented KSpace	k
2486	(2005,"Philips MR Imaging DD 001",35)	CS	t	StackSliceNumber	k
2450	(2005,"Philips MR Imaging DD 001",36)	CS	t	StackType	k
2474	(2005,"Philips MR Imaging DD 001",37)	CS	t	Is Spectro	k
2442	(2005,"Philips MR Imaging DD 001",39)	CS	t	Steady State	k
2658	(2005,"Philips MR Imaging DD 001",3a)	SH	t	Sub Anatomy	k
2475	(2005,"Philips MR Imaging DD 001",3b)	CS	t	Time Reversed Steady State	k
2453	(2005,"Philips MR Imaging DD 001",3c)	CS	t	Tilt Optimized Nonsaturated Excitation	k
2337	(2005,"Philips MR Imaging DD 001",3d)	SS	t	Number of RR Interval Ranges	k
2576	(2005,"Philips MR Imaging DD 001",3e)	SL	t	RR Intervals Distribution	k
2537	(2005,"Philips MR Imaging DD 001",5f)	CS	t	StackSequence	k
2228	(2005,"Philips MR Imaging DD 001",60)	IS	t	Study Sequence Number	k
2413	(2005,"Philips MR Imaging DD 001",61)	CS	t	Prepulse Type	k
2325	(2005,"Philips MR Imaging DD 001",63)	SS	t	fMRI Status Indication	k
2489	(2005,"Philips MR Imaging DD 001",6e)	CS	t	Scanning Sequence	k
2441	(2005,"Philips MR Imaging DD 001",6f)	CS	t	Acquisition Type	k
2660	(2005,"Philips MR Imaging DD 001",70)	LO	t	Hardcopy Protocol EasyVision	k
2189	(2005,"Philips MR Imaging DD 001",80)	SQ	t	Series PlanScan	k
2677	(2005,"Philips MR Imaging DD 001",81)	CS	t	Stack View Axis	k
2258	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",4e)	FL	t	Unknown:Slab FOV RL	na
2239	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",4f)	FL	t	Unknown:Slab Offcentre AP	na
2249	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",50)	FL	t	Unknown:Slab Offcentre FH	na
2230	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",51)	FL	t	Unknown:Slab Offcentre RL	na
2533	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",52)	CS	t	Unknown:Slab Type	na
2430	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",53)	CS	t	Unknown:Slab View Axis	na
2253	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",69)	FL	t	Unknown:Slab Angulation AP	na
2255	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",6a)	FL	t	Unknown:Slab Angulation FH	na
2254	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",6b)	FL	t	Unknown:Slab Angulation RL	na
2233	(2005,"Philips MR Imaging DD 001",83)[<0>](2005,"Philips MR Imaging DD 001",6c)	FL	t	Unknown:Slab FOV AP	na
2188	(2005,"Philips MR Imaging DD 001",84)	SQ	t	Series Reference	k
2638	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",48)	IS	t	Series Reference:Referenced Acquisition Number	k
2643	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",49)	IS	t	Series Reference:Referenced Chemical Shift Number	k
2641	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",4a)	IS	t	Series Reference:Referenced Dynamic Scan Number	k
2640	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",4b)	IS	t	Series Reference:Referenced Echo Number	k
2668	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",4c)	CS	t	Series Reference:Referenced Entity	k
2644	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",64)	IS	t	Series Reference:Reference Phase Number	k
2685	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",66)	CS	t	Series Reference:Reference Scanning Sequence	k
2642	(2005,"Philips MR Imaging DD 001",84)[<0>](2005,"Philips MR Imaging DD 001",67)	IS	t	Series Reference:Reference Slice Number	k
2278	(2005,"Philips MR Imaging DD 004",26)	FL	t	Spectro B0 Echo Top Position	k
2428	(2005,"Philips MR Imaging DD 004",28)	CS	t	Spectro Data Origin	k
2246	(2005,"Philips MR Imaging DD 004",29)	FL	t	Spectro Echo Top Position	k
2487	(2005,"Philips MR Imaging DD 004",30)	CS	t	InPlane Transforms	k
2324	(2005,"Philips MR Imaging DD 004",31)	SS	t	Number of Spectra Acquired	k
2283	(2005,"Philips MR Imaging DD 004",33)	FL	t	Phase Encoding Echo Top Positions	k
2261	(2005,"Philips MR Imaging DD 004",36)	FL	t	Reference Frequency	k
2266	(2005,"Philips MR Imaging DD 004",37)	FL	t	Sample Offset	k
2286	(2005,"Philips MR Imaging DD 004",38)	FL	t	Sample Pitch	k
2395	(2005,"Philips MR Imaging DD 004",40)	CS	t	Signal Domain for Chemical Shift	k
2536	(2005,"Philips MR Imaging DD 004",41)	CS	t	Signal Domain Spatial	k
2386	(2005,"Philips MR Imaging DD 004",43)	CS	t	Spectro Additional Rotations	k
2323	(2005,"Philips MR Imaging DD 004",44)	SS	t	Spectro Display Ranges	k
2524	(2005,"Philips MR Imaging DD 004",46)	CS	t	Spectro Frequency Unit	k
2269	(2005,"Philips MR Imaging DD 004",47)	FL	t	Spectro Gamma	k
2539	(2005,"Philips MR Imaging DD 004",48)	CS	t	Spectro Hidden Line Removal	k
2256	(2005,"Philips MR Imaging DD 004",49)	FL	t	Spectro Horizontal Shift	k
2274	(2005,"Philips MR Imaging DD 004",50)	FL	t	Spectro Horizontal Window	k
2328	(2005,"Philips MR Imaging DD 004",51)	SS	t	Spectro Number of Display Ranges	k
2319	(2005,"Philips MR Imaging DD 004",52)	SS	t	Spectro Number of Echo Pulses	k
2683	(2005,"Philips MR Imaging DD 004",54)	CS	t	Spectro Scan Type	k
2268	(2005,"Philips MR Imaging DD 004",55)	FL	t	Spectro SI CS Intervals	k
2414	(2005,"Philips MR Imaging DD 004",56)	CS	t	Spectro SI Mode	k
2663	(2005,"Philips MR Imaging DD 004",58)	LO	t	Spectro Title Line	k
2248	(2005,"Philips MR Imaging DD 004",59)	FL	t	Spectro Turbo Echo Spacing	k
2273	(2005,"Philips MR Imaging DD 004",60)	FL	t	Spectro Vertical Shift	k
2284	(2005,"Philips MR Imaging DD 004",62)	FL	t	Spectro Offset	k
2279	(2005,"Philips MR Imaging DD 004",63)	FL	t	Spectrum Pitch	k
2181	(2005,"Philips MR Imaging DD 004",71)	SQ	t	Series SP Mix	k
2197	(2005,"Philips MR Imaging DD 004",82)	UL	t	Number of Procedure Codes	k
1203	(0073,"STENTOR",03)	ST	t	Unknown	d
2222	(2005,"Philips MR Imaging DD 004",92)	IS	t	Geolink ID	k
2229	(2005,"Philips MR Imaging DD 004",93)	IS	t	Station Number	k
2723	(2005,"Philips MR Imaging DD 004",95)	ST	t	View Procedure String	k
2654	(2005,"Philips MR Imaging DD 004",95)	UI	t	View Procedure String	k
2411	(2005,"Philips MR Imaging DD 004",98)	CS	t	Mobiview Enabled	k
2418	(2005,"Philips MR Imaging DD 004",99)	CS	t	IViewBold Enabled	k
2505	(2005,"Philips MR Imaging DD 005",00)	CS	t	Volume View Enabled	k
2196	(2005,"Philips MR Imaging DD 005",01)	UL	t	Number of Study Reference	k
2341	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,0100)	SH	t	Unknown:Code Value	na
2343	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,0102)	SH	t	Unknown:Coding Scheme Designator	na
2344	(2005,"Philips MR Imaging DD 005",02)[<0>](0008,0103)	SH	t	Unknown:Coding Scheme Version	na
2433	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,9206)	CS	t	Private Per-Frame Sequence:Volumetric Properties	na
2431	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9026)	CS	t	Private Per-Frame Sequence:Spectrally Selected Excitation	na
2503	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9048)	CS	t	Private Per-Frame Sequence:Multi-Coil Element Used	na
2545	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9053)	FD	t	Private Per-Frame Sequence:Chemical Shift Reference	na
2407	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9059)	CS	t	Private Per-Frame Sequence:De-coupling	na
2675	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9060)	CS	t	Private Per-Frame Sequence:De-coupled Nucleus	na
2520	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9075)	CS	t	Private Per-Frame Sequence:Diffusion Directionality	na
2547	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9079)	FD	t	Private Per-Frame Sequence:Inversion Times	na
2680	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9085)	CS	t	Private Per-Frame Sequence:Cardiac Signal Source	na
2694	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9089)	FD	t	Private Per-Frame Sequence:Diffusion Gradient Orientation	na
2550	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9090)	FD	t	Private Per-Frame Sequence:Velocity Encoding Direction	na
2567	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9093)	US	t	Private Per-Frame Sequence:Number of k-Space Trajectories	na
2416	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9101)	CS	t	Private Per-Frame Sequence:Frequency Correction	na
2542	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9155)	FD	t	Private Per-Frame Sequence:Parallel Reduction Factor out-of-plane	na
2513	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9170)	CS	t	Private Per-Frame Sequence:Respiratory Motion Compensation Technique	na
2516	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9172)	CS	t	Private Per-Frame Sequence:Bulk Motion Compensation Technique	na
2495	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9174)	CS	t	Private Per-Frame Sequence:Applicable Safety Standard Agency	na
2635	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9176)	SQ	t	Private Per-Frame Sequence:Operating Mode Sequence	na
2669	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9176)[<1>](0018,9177)	CS	t	Private Per-Frame Sequence:Operating Mode Sequence:Operating Mode Type	na
2692	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9176)[<1>](0018,9178)	CS	t	Private Per-Frame Sequence:Operating Mode Sequence:Operating Mode	na
2496	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9179)	CS	t	Private Per-Frame Sequence:Specific Absorption Rate Definition	na
2485	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9180)	CS	t	Private Per-Frame Sequence:Gradient Output Type	na
2541	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9182)	FD	t	Private Per-Frame Sequence:Gradient Output	na
2585	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9183)	CS	t	Private Per-Frame Sequence:Flow Compensation Direction	na
2412	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9199)	CS	t	Private Per-Frame Sequence:Water Referenced Phase Correction	na
2437	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9200)	CS	t	Private Per-Frame Sequence:MR Spectroscopy Acquisition Type	na
2562	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9231)	US	t	Private Per-Frame Sequence:MR Acquisition Phase Encoding Steps in-plane	na
2563	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9232)	US	t	Private Per-Frame Sequence:MR Acquisition Phase Encoding Steps out-of-plane	na
2704	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9604)	FD	t	Private Per-Frame Sequence:Diffusion b-value XZ	na
2699	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9606)	FD	t	Private Per-Frame Sequence:Diffusion b-value YZ	na
2697	(2005,"Philips MR Imaging DD 005",0f)[<0>](0018,9607)	FD	t	Private Per-Frame Sequence:Diffusion b-value ZZ	na
2553	(2005,"Philips MR Imaging DD 005",0f)[<0>](0020,9255)	FD	t	Private Per-Frame Sequence:Nominal Respiratory Trigger Delay Time	na
2195	(2005,"Philips MR Imaging DD 005",0f)[<0>](0028,9001)	UL	t	Private Per-Frame Sequence:Data Point Rows	na
2682	(2005,"Philips MR Imaging DD 005",0f)[<0>](0028,9003)	CS	t	Private Per-Frame Sequence:Signal Domain Columns	na
2346	(2005,"Philips MR Imaging DD 005",0f)[<0>](0040,9210)	SH	t	Private Per-Frame Sequence:LUT Label	na
2206	(2005,"Philips MR Imaging DD 005",12)	IS	t	Diffusion B Value Number	k
2570	(2005,"Philips MR Imaging DD 005",15)	SL	t	Number of Diffusion Gradient Orientations	k
2393	(2005,"Philips MR Imaging DD 005",18)	CS	t	Operating Mode Type	k
2435	(2005,"Philips MR Imaging DD 005",19)	CS	t	Operating Mode	k
2693	(2005,"Philips MR Imaging DD 005",1a)	CS	t	Fat Saturation Technique	k
2221	(2005,"Philips MR Imaging DD 005",1b)	IS	t	Version Number Deleted Images	k
2211	(2005,"Philips MR Imaging DD 005",1c)	IS	t	Version Number Deleted Spectra	k
2215	(2005,"Philips MR Imaging DD 005",1d)	IS	t	Version Number Deleted Blobsets	k
2768	(2005,"Philips MR Imaging DD 005",1f)	UL	t	LUT1 Range	k
2775	(2005,"Philips MR Imaging DD 005",20)	UL	t	LUT1 Begin Color	k
2769	(2005,"Philips MR Imaging DD 005",21)	UL	t	LUT1 End Color	k
2773	(2005,"Philips MR Imaging DD 005",22)	UL	t	LUT2 Offset	k
2772	(2005,"Philips MR Imaging DD 005",23)	UL	t	LUT2 Range	k
749	(0009,"GEMS_PETD_01",1f)	SL	t	Collect Singles	k
593	(0009,"GEMS_PETD_01",b4)	FL	t	IR Recon FOV	k
6887	(5200,9229)[<0>](0018,9112)[<1>](0018,9182)	FD	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Gradient Output	\N
6808	(0008,9092)[<0>](0008,1115)	SQ	f	Referenced Image Evidence Sequence:Referenced Series Sequence	\N
1050	(0053,"GEHC_CT_ADVAPP_001",85)	UN	t	CommandedFirstmA	k
481	(0019,"GEMS_ACQU_01",d9)	DS	t	ConcatenatedSAT	k
1265	(0009,"GEIIS",10)[<0>](0028,1053)	DS	t	GE Private Image Thumbnail Sequence:Rescale Slope	na
5091	(2005,"Philips MR Imaging DD 004",43)	OB	t	Spectro Additional Rotations	k
3926	(0021,"",5c)	UN	t	Unknown	d
6873	(5200,9229)[<0>](0018,9042)[<1>](0018,9044)	CS	f	Shared Functional Groups Sequence:MR Receive Coil Sequence:Quadrature Receive Coil	\N
6937	(0018,9315)	CS	f	Reconstruction Algorithm	\N
5728	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",21)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Index Auto Navigation Skipping Degree	k
2770	(2005,"Philips MR Imaging DD 005",24)	UL	t	LUT2 Begin Color	k
2771	(2005,"Philips MR Imaging DD 005",25)	UL	t	LUT2 End Color	k
2445	(2005,"Philips MR Imaging DD 005",26)	CS	t	Viewing Hardcopy Only	k
2577	(2005,"Philips MR Imaging DD 005",28)	SL	t	Number of Label Types	k
2739	(2005,"Philips MR Imaging DD 005",29)	CS	t	Label Type	k
2707	(2005,"Philips MR Imaging DD 005",29)	UN	t	Label Type	k
2529	(2005,"Philips MR Imaging DD 005",2a)	CS	t	Exam Print Status	k
2526	(2005,"Philips MR Imaging DD 005",2c)	CS	t	Exam Storage Commit Status	k
2528	(2005,"Philips MR Imaging DD 005",2d)	CS	t	Exam Media Write Status	k
2646	(2005,"Philips MR Imaging DD 005",2f)	FL	t	Proton SAR	k
2649	(2005,"Philips MR Imaging DD 005",31)	FL	t	Local SAR	k
2468	(2005,"Philips MR Imaging DD 005",32)	CS	t	Safety Override Mode	k
2684	(2005,"Philips MR Imaging DD 005",37)	CS	t	Color LUT Type	k
2384	(2005,"Philips MR Imaging DD 005",3a)	LT	t	Data Dictionary Contents Version	k
2463	(2005,"Philips MR Imaging DD 005",3b)	CS	t	Is Coil Survey	k
2260	(2005,"Philips MR Imaging DD 005",40)	FL	t	Active Implantable Medical Device Head SAR Limit	k
2265	(2005,"Philips MR Imaging DD 005",41)	FL	t	Active Implantable Medical Device Whole Body SAR Limit	k
2217	(2005,"Philips MR Imaging DD 005",44)	IS	t	TFE Factor	k
2471	(2005,"Philips MR Imaging DD 005",45)	CS	t	Attenuation Correction	k
2645	(2005,"Philips MR Imaging DD 005",46)	FL	t	FWHM Shim	k
2469	(2005,"Philips MR Imaging DD 005",4d)	CS	t	Is B0 Series	k
2508	(2005,"Philips MR Imaging DD 005",4f)	CS	t	Volume Select	k
2321	(2005,"Philips MR Imaging DD 005",50)	SS	t	Number of Patient Other IDs	k
6893	(5200,9229)[<0>](0018,9115)[<1>](0018,9155)	FD	f	Shared Functional Groups Sequence:MR Modifier Sequence:Parallel Reduction Factor out-of-plane	\N
6906	(3002,0030)[<0>](300a,00f0)	IS	f	Exposure Sequence:Number of Blocks	\N
6867	(5200,9229)[<0>](0018,9115)[<1>](0018,9010)	CS	f	Shared Functional Groups Sequence:MR Modifier Sequence:Flow Compensation	\N
6803	(5200,9229)[<0>](0018,9112)[<1>](0018,9239)	SQ	f	Shared Functional Groups Sequence:MR Timing and Related Parameters Sequence:Specific Absorption Rate Sequence	\N
6657	(0019,"SIEMENS MR VA0  COAD",a5)	DS	t	SpecificAbsorptionRateWholeBody	k
6786	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",2d)	CS	t	Presentation State Sequence:Exam Media Write Status	d
6726	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",31)	UN	t	Unknown	d
637	(0009,"GEMS_PETD_01",cf)	FL	t	vqc_z_axis_trans	k
3931	(0021,"",5b)	UN	t	Unknown	d
6229	(0054,0022)[<0>](0054,0220)[<1>](0008,0102)	SH	f	Detector Information Sequence:View Code Sequence:Coding Scheme Designator	\N
6227	(0054,0022)[<0>](0054,0220)	SQ	f	Detector Information Sequence:View Code Sequence	\N
6230	(0054,0022)[<0>](0054,0220)[<1>](0008,0104)	LO	f	Detector Information Sequence:View Code Sequence:Code Meaning	\N
6228	(0054,0022)[<0>](0054,0220)[<1>](0008,0100)	SH	f	Detector Information Sequence:View Code Sequence:Code Value	\N
5284	(2001,"Philips Imaging DD 001",85)	OB	t	Magnetic Field Strength	k
3099	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",93)	OB	t	Unknown:Unknown	d
2714	(4453,"DR Systems, Inc.",0c)[<0>](0008,1115)[<1>](0008,1199)	SQ	t	Original Instance UID Sequence:Referenced Series Sequence:Referenced SOP Sequence	na
2719	(4453,"DR Systems, Inc.",0c)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1150)	UI	t	Original Instance UID Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Class UID	na
2717	(4453,"DR Systems, Inc.",0c)[<0>](0008,1115)[<1>](0008,1199)[<2>](0008,1155)	UI	t	Original Instance UID Sequence:Referenced Series Sequence:Referenced SOP Sequence:Referenced SOP Instance UID	na
1814	(7005,"TOSHIBA_MEC_CT3",11)	LT	t	Series Comment	k
1815	(7005,"TOSHIBA_MEC_CT3",15)	US	t	Special Helical Acquisition Number	k
5128	(2005,"Philips MR Imaging DD 004",51)	OB	t	Spectro Number of Display Ranges	k
5117	(2005,"Philips MR Imaging DD 004",52)	OB	t	Spectro Number of Echo Pulses	k
392	(0027,"GEMS_IMAG_01",60)	FL	t	ImageDimensionX	k
6638	(0021,"SIEMENS MR VA0  GEN",56)	DS	t	RepetitionTimeEffective	k
5080	(2005,"Philips MR Imaging DD 005",2c)	OB	t	Exam Storage Commit Status	k
6709	(2005,"Philips MR Imaging DD 003",44)	UN	t	No Time of Last Calibration	d
5095	(2005,"Philips MR Imaging DD 005",18)	OB	t	Operating Mode Type	k
6666	(0019,"SIEMENS MR VA0  COAD",24)	DS	t	TransmitterCalibration	k
6615	(0021,"SIEMENS MR VA0  RAW",06)	IS	t	CSIMatrixSizeOriginal	k
5306	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",54)	FL	t	Series Volume:Volume Angulation AP	k
6611	(0021,"SIEMENS MR VA0  GEN",70)	IS	t	NumberOfEchoes	k
5732	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",10)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Thickness	k
212	(0019,"GEMS_ACQU_01",75)	DS	t	AvgOfRightRefChannelsOverViews	k
6766	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",01)	UL	t	Presentation State Sequence:Number of Study Reference	d
1123	(0009,"GEMS_PETD_01",04)	SH	t	Patient Software Version	k
744	(0009,"GEMS_PETD_01",8c)	SL	t	Attenuation	k
6626	(0019,"SIEMENS MR VA0  COAD",d6)	IS	t	3DPhaseOversamplingPartitions	d
6738	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",63)	UN	t	Unknown	d
6618	(0019,"SIEMENS MR VA0  GEN",90)	IS	t	NumberOfSaturationRegions	k
6723	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",52)	UN	t	Unknown	d
6623	(0021,"SIEMENS MR VA0  GEN",30)	IS	t	NumberOf3DRawPartitionsNominal	d
6628	(0021,"SIEMENS CM VA0  CMS",82)	SH	t	StudyType	k
6595	(0021,"SIEMENS MR VA0  RAW",01)	IS	t	VectorSizeOriginal	k
382	(0043,"GEMS_PARM_01",35)	UL	t	UserUsageTag	k
5132	(2005,"Philips MR Imaging DD 001",0e)	OB	t	Scale Slope	k
5119	(0903,"GEIIS PACS",11)	OB	t	Significant Flag	k
5122	(2005,"Philips MR Imaging DD 004",62)	OB	t	Spectro Offset	k
3973	(0019,"",7d)	UN	t	Unknown	d
6706	(2005,"Philips MR Imaging DD 003",55)	UN	t	Number of Study Physicians Reading Study	d
5736	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",46)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera ViewPort Size	k
5733	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",47)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Aspect Ratio	k
6736	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",51)	UN	t	Unknown	d
6593	(0019,"SIEMENS MR VA0  GEN",21)	IS	t	NumberOfFourierLinesCurrent	d
5092	(2005,"Philips MR Imaging DD 001",34)	OB	t	Segmented KSpace	k
5059	(2005,"Philips MR Imaging DD 004",46)	OB	t	Spectro Frequency Unit	k
6630	(0051,"SIEMENS CM VA0  CMS",10)	LO	t	ImageText	d
6732	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",42)	UN	t	Unknown	d
6665	(0019,"SIEMENS MR VA0  GEN",10)	DS	t	TotalMeasurementTimeNominal	k
869	(0009,"GEMS_PETD_01",c4)	SL	t	Scatter Num Iter	k
5731	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",12)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Shadow Y Offset	k
5730	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",17)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Realtime Speed	k
5735	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",15)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Stipple Pattern	k
5734	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",14)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Direction	k
638	(0009,"GEMS_PETD_01",c4)	SS	t	Scatter Num Iter	k
1048	(0053,"GEHC_CT_ADVAPP_001",7c)	UN	t	MultiEnergyNoiseReducdeMethod	k
401	(0019,"GEMS_ACQU_01",c0)	SS	t	SaturationPlanes	k
1303	(7053,"Philips PET Private Group",03)	ST	t	Original File Name	d
6242	(6000,0045)	LO	f	Overlay Subtype	\N
6248	(0018,1302)	IS	f	Scan Length	\N
3981	(0019,"",87)	UN	t	Unknown	d
2932	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",60)	SQ	t	Unknown:Unknown	d
4008	(0025,"",18)	UN	t	Unknown	d
2972	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",94)	OB	t	Unknown:Unknown	d
3158	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",42)	OB	t	Unknown:Unknown	d
4022	(0019,"",88)	UN	t	Unknown	d
2856	(01f3,"ELSCINT1",13)	OB	t	Unknown	d
3831	(0027,"",62)	UN	t	Unknown	d
2923	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",40)	SQ	t	Unknown:Unknown	d
4282	(5200,9229)[<0>](0008,9124)[<1>](0008,9215)[<2>](0008,0104)	LO	f	Shared Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence:Code Meaning	\N
4254	(5200,9229)[<0>](0062,000a)	SQ	f	Shared Functional Groups Sequence:Segment Identification Sequence	\N
4523	(0040,0275)[<0>](0008,1110)[<1>](0008,1155)	UI	f	Request Attributes Sequence:Referenced Study Sequence:Referenced SOP Instance UID	\N
4454	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a168)[<4>](0008,0102)	SH	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Coding Scheme Designator	\N
2162	(0013,"CTP",26)	LT	t	Unknown	d
5161	(2005,"Philips MR Imaging DD 005",42)	OB	t	Active Implantable Medical Device B1 RMS Limit	k
6250	(0011,"GEMS_GENIE_1",0d)	LO	t	RadioNuclideName	k
800	(0009,"GEMS_PETD_01",4e)	SL	t	Lower Axial Acc	k
6725	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",58)	UN	t	Unknown	d
512	(0043,"GEMS_PARM_01",0c)	DS	t	LimitsInUnitsOfPercent	k
6771	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,010d)	UI	t	Presentation State Sequence:Unknown:Context Group Extension Creator UID	d
325	(0019,"GEMS_ACQU_01",57)	SS	t	CTWaterNumber	k
6581	(2001,"Philips Imaging DD 129",00)[<0>](0028,3006)	US	t	Presentation State Sequence:LUT Data	d
5744	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ac)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Bottom Right Hand Corner Fractional	k
5750	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b6)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence:Measurement Link Evaluation Text Flag	k
5743	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ad)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Top Left Hand Corner Fractional	k
5129	(2005,"Philips MR Imaging DD 003",13)	OB	t	Number of Codes	k
6682	(0019,"SIEMENS MR VA0  COAD",d2)	CS	t	CalculationSubmode	d
5745	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",08)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Foreground Color	k
6733	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",5c)	UN	t	Unknown	d
5742	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",07)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Background Color	k
6711	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",45)	UN	t	Series PlanScan:PlanScan Survey Reconstruction Number	d
5277	(2001,"Philips Imaging DD 001",0b)	OB	t	SliceOrientation	k
6718	(7001,"GEMS_MR_RAW_01",03)	UN	t	rdr_hdr_unlock_raw	d
6729	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",67)	UN	t	Unknown	d
6746	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",35)	UN	t	Unknown	d
1044	(0053,"GEHC_CT_ADVAPP_001",75)	UN	t	MonchromaticEnergy	k
6594	(0019,"SIEMENS MR VA0  GEN",70)	IS	t	NumberOfPrescans	d
6742	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",57)	UN	t	Unknown	d
6784	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",2c)	CS	t	Presentation State Sequence:Exam Storage Commit Status	d
6651	(0021,"SIEMENS MR VA0  GEN",39)	DS	t	SlabThickness	k
232	(0043,"GEMS_PARM_01",4d)	FL	t	StartScanToXrayOnDelay	k
6750	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",5e)	UN	t	Unknown	d
6773	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",53)	SS	t	Presentation State Sequence:Number of Study Patient Medical Alerts	d
6720	(7001,"GEMS_MR_RAW_01",04)	UN	t	rdb_hdr_data_acq_tab	d
569	(0053,"GEHC_CT_ADVAPP_001",65)	IS	t	Shutter Mode Percent	k
6637	(0019,"SIEMENS MR VA0  COAD",54)	DS	t	ReceiverCableAttenuation	k
2981	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
4070	(0019,"",15)	FD	t	Unknown	d
6596	(0019,"SIEMENS MR VA0  GEN",31)	IS	t	ReconstructionColumns	k
6688	(0009,"SIEMENS CM VA0  CMS",14)	UN	t	Unknown	d
6747	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",34)	UN	t	Unknown	d
6633	(0019,"SIEMENS CM VA0  ACQU",11)	LO	t	SequenceFileName	d
6603	(0021,"SIEMENS MR VA0  GEN",43)	IS	t	CurrentGroupNumber	k
5260	(2005,"Philips MR Imaging DD 005",1d)	OB	t	Version Number Deleted Blobsets	k
5088	(2001,"Philips Imaging DD 001",21)	OB	t	SPIR	k
5111	(2001,"Philips Imaging DD 001",5f)	OB	t	StackSequence	k
4985	(2005,"Philips MR Imaging DD 005",0e)[<0>](2005,"Philips MR Imaging DD 005",27)	CS	t	Private Shared Sequence:Unknown	na
5328	(0015,"GEMS_PETD_01",23)	UN	t	BP3d Filter FlagU	k
222	(0027,"GEMS_IMAG_01",4d)	FL	t	SCoordOfBottomRightCorner	k
5341	(0015,"GEMS_PETD_01",2f)	UN	t	WCC Cal Flag	k
215	(0019,"GEMS_ACQU_01",1e)	DS	t	DisplayFieldOfView	k
354	(0045,"GEMS_HELIOS_01",10)	SS	t	Start View 2A	k
4015	(0019,"",be)	UN	t	Unknown	d
6264	(0018,1300)	DS	f	Scan Velocity	\N
6263	(0054,0022)[<0>](0028,0032)	DS	f	Detector Information Sequence:Zoom Center	\N
6268	(0018,1301)	CS	f	Whole Body Technique	\N
6265	(0054,0022)[<0>](0018,1120)	DS	f	Detector Information Sequence:Gantry/Detector Tilt	\N
5270	(2001,"Philips Imaging DD 001",8b)	OB	t	Transmitting Coil	k
4982	(2005,"Philips MR Imaging DD 005",0e)[<0>](0008,0016)	UI	t	Private Shared Sequence:SOP Class UID	na
1353	(01f1,"ELSCINT1",4c)	SH	t	Unknown	d
3798	(0019,"",15)	UN	t	Unknown	d
623	(0009,"GEMS_PETD_01",eb)	FL	t	Unknown	d
5749	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",b5)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ff)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Evaluation Text Position Sequence:Unknown	d
3034	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",52)	OB	t	Unknown:Unknown	d
5752	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",88)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Min Zoom In Factor	k
6272	(0055,"GEMS_GENIE_1",22)[<0>](0013,"GEMS_GENIE_1",19)	FD	t	eNTEGRA Detector Information Sequence:TransmissionMaskWidth	k
6273	(0055,"GEMS_GENIE_1",22)[<0>](0013,"GEMS_GENIE_1",18)	FD	t	eNTEGRA Detector Information Sequence:TransmissionScanTime	k
6277	(0011,"GEMS_GENIE_1",55)	FD	t	Period	k
6274	(0011,"GEMS_GENIE_1",2d)	FD	t	View Y Adjustment	k
6276	(0011,"GEMS_GENIE_1",3c)	FD	t	PixelOffset	k
6275	(0011,"GEMS_GENIE_1",2c)	FD	t	View X Adjustment	k
6749	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",5f)	UN	t	Unknown	d
6647	(0021,"SIEMENS MR VA0  RAW",03)	DS	t	AcquiredSpectralRange	k
6617	(0021,"SIEMENS MR VA0  GEN",34)	IS	t	NumberOf3DImagePartitions	k
6629	(0009,"SPI RELEASE 1",41)	SH	t	DataObjectSubtype	d
668	(0009,"GEMS_PETD_01",14)	LO	t	Landmark Name	k
5076	(2005,"Philips MR Imaging DD 005",2b)	OB	t	Exam Export Status	k
4976	(2005,"Philips MR Imaging DD 001",85)		t	Series Volume	k
6765	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",03)	UL	t	Presentation State Sequence:Number of SPS Codes	d
6583	(0019,"SIEMENS MR VA0  GEN",96)	UL	t	CoilIDMask	k
6753	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",12)	UN	t	Unknown	d
776	(0009,"GEMS_PETD_01",94)	SL	t	Atten Smooth Param	k
594	(0009,"GEMS_PETD_01",3f)	FL	t	Half Life	k
1018	(7005,"TOSHIBA_MEC_CT3",20)	UL	t	Local Series Number	k
1366	(01f7,"ELSCINT1",29)	OW	t	Unknown	d
2805	(01f7,"ELSCINT1",29)	OB	t	Unknown	d
6587	(0019,"SIEMENS MR VA0  GEN",16)	UL	t	SequenceControlMask	k
6780	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,0104)	LO	t	Presentation State Sequence:Unknown:Code Meaning	k
6724	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",21)	UN	t	Unknown	d
6690	(2005,"Philips MR Imaging DD 001",80)[<0>](0008,1155)	UI	t	Series PlanScan:Referenced SOP Instance UID	h
6621	(0021,"SIEMENS MR VA0  GEN",22)	IS	t	PhaseCorrectionRowsReconstruction	d
6719	(7001,"GEMS_MR_RAW_01",07)	UN	t	rdb_hdr_tool	d
6613	(0019,"SIEMENS MR VA0  GEN",14)	IS	t	NumberOfPhases	k
6740	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",64)	UN	t	Unknown	d
6649	(0019,"SIEMENS MR VA0  COAD",70)	DS	t	PhaseGradientAmplitude	k
6631	(0019,"SIEMENS CM VA0  ACQU",12)	LO	t	SequenceFileOwner	d
6582	(0019,"SIEMENS MR VA0  GEN",18)	UL	t	MeasurementStatusMask	k
6696	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",46)	UN	t	Series PlanScan:PlanScan Survey Scanning Sequence	k
6588	(0019,"SIEMENS MR VA0  GEN",97)	UL	t	CoilClassMask	k
6704	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",41)	UN	t	Series PlanScan:PlanScan Survey Dynamic Scan Number	d
6701	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",44)	UN	t	Series PlanScan:PlanScan Survey Phase Number	d
6691	(2005,"Philips MR Imaging DD 001",80)[<0>](0008,1150)	UI	t	Series PlanScan:Referenced SOP Class UID	k
5067	(2005,"Philips MR Imaging DD 001",85)	OB	t	Series Volume	k
448	(0021,"GEMS_RELA_01",4f)	SS	t	LocationsInAcquisition	k
6605	(0019,"SIEMENS MR VA0  COAD",d7)	IS	t	EchoLinePosition	k
5197	(2001,"Philips Imaging DD 001",10)	OB	t	Cardiac Sync	k
5339	(0015,"GEMS_PETD_01",22)	UN	t	IR Loop Filter Correction	k
466	(0019,"GEMS_ACQU_01",87)	DS	t	CardiacRepetition Time	k
3096	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
1295	(0029,"SIEMENS MEDCOM HEADER",40)[<0>](0029,"SIEMENS MEDCOM HEADER",41)	CS	t	ApplicationHeaderSequence:ApplicationHeaderType	na
688	(0009,"GEMS_PETD_01",39)	LO	t	Measured Date Time	o
858	(0009,"GEMS_PETD_01",39)	DT	t	Measured Date Time	o
3755	(0079,"Unnamed Private Block - 10",0d)	SH	t	Unknown	d
1465	(0009,"SECTRA_Ident_01",01)	SH	t	Request number	d
2784	(0009,"SECTRA_Ident_01",01)	LO	t	Request number	d
2847	(0009,"SECTRA_Ident_01",01)	OB	t	Request number	d
2876	(00e1,"ELSCINT1",39)[<0>](0040,0260)	SQ	t	Unknown:Performed Protocol Code Sequence	d
4319	(0137,"NetRAAD",10)	PN	t	Unknown	d
3714	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",01)	SS	t	Gamma LUT	d
3995	(0021,"",81)	UN	t	Unknown	d
3915	(0019,"",b9)	UN	t	Unknown	d
2945	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",60)	SQ	t	Unknown:Unknown	d
3721	(0021,"Siemens: Thorax/Multix FD Post Processing",01)	SS	t	Unknown	d
1108	(0029,"SIEMENS MEDCOM HEADER",34)	CS	t	PMTFInformation4	d
200	(0019,"GEMS_ACQU_01",2b)	DS	t	XrayOffPosition	k
428	(0019,"GEMS_ACQU_01",d7)	SS	t	CardiacPhases	k
1562	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",34)	UN	t	Unknown	d
1567	(0047,"GEMS_3DSTATE_001",ea)	DS	t	Unknown	d
853	(0009,"GEMS_PETD_01",0e)	DT	t	Scan Ready	o
529	(0021,"GEMS_RELA_01",5a)	SL	t	IntegerSlop	k
1589	(0019,"SIEMENS MR HEADER",18)	IS	t	Real Dwell Time	k
2166	(7fd1,"GEIIS",30)	UL	t	Multi-Resolution Levels	k
299	(0027,"GEMS_IMAG_01",20)	SS	t	SmartScanOnOffFlag	k
786	(0009,"GEMS_PETD_01",93)	SL	t	Atten Smooth	k
792	(0009,"GEMS_PETD_01",1b)	SL	t	Start Condition Data	k
1267	(0009,"GEIIS",10)[<0>](0028,1050)	DS	t	GE Private Image Thumbnail Sequence:Window Center	na
3174	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3736	(0021,"Siemens: Thorax/Multix FD Post Processing",08)	US	t	Auto Window Flag	d
3921	(0043,"",1d)	UN	t	Unknown	d
6654	(0019,"SIEMENS MR VA0  GEN",98)	DS	t	CoilPosition	k
5756	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",00)	UN	t	Advanced Presentation Sequence:Presentation Name	k
4098	(0019,"SIEMENS MR HEADER",0e)	FD	t	Diffusion Gradient Direction	k
5754	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",80)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Rotation Axis	k
6669	(0019,"SIEMENS MR VA0  COAD",55)	DS	t	ReceiverReferenceGain	k
5759	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a0)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Image Rotation Fractional	k
6763	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",82)	UL	t	Presentation State Sequence:Number of Procedure Codes	d
6730	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",68)	UN	t	Unknown	d
6627	(0019,"SIEMENS MR VA0  COAD",d4)	IS	t	BaseRawMatrixSize	k
6708	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",47)	UN	t	Series PlanScan:PlanScan Survey Slice Number	d
6591	(0021,"SIEMENS MR VA0  GEN",50)	UL	t	SignalMask	d
5758	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",78)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Unknown	d
4089	(700d,"TOSHIBA_MEC_MR3",00)	DS	t	Scale Factor	d
4143	(0019,"",27)	FD	t	Unknown	d
4112	(0077,"",02)	UN	t	Unknown	d
4123	(0019,"",25)	UN	t	Unknown	d
4173	(0029,"",02)	UN	t	Unknown	d
6653	(0021,"SIEMENS MR VA0  RAW",05)	DS	t	VOISize	k
6707	(2005,"Philips MR Imaging DD 003",47)	UN	t	Number of Patient Other Names	d
6782	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",91)	PN	t	Presentation State Sequence:Patient Name Job In Params	d
6739	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",54)	UN	t	Unknown	d
6687	(0009,"SPI RELEASE 1",40)	US	t	DataObjectType	d
6586	(0019,"SIEMENS MR VA0  GEN",41)	UL	t	ArrayCoilElementSelectMask	d
6716	(7001,"GEMS_MR_RAW_01",01)	UN	t	rdb_hdr_rec	d
6757	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",55)	UN	t	Unknown	
6619	(0021,"SIEMENS MR VA0  RAW",07)	IS	t	CSIMatrixSizeExtended	k
6717	(7001,"GEMS_MR_RAW_01",02)	UN	t	rdb_hdr_per_pass_tab	k
6678	(0021,"SIEMENS MR VA0  GEN",4f)	CS	t	OrderofSlices	k
6622	(0021,"SIEMENS MR VA0  GEN",31)	IS	t	NumberOf3DRawPartitionsCurrent	k
4192	(0043,"dcm4che/archive",43)	SL	t	Unknown	d
4153	(5653,"Vital Images SW 3.4",14)[<0>](5653,"Vital Images SW 3.4",11)	LO	t	Saved Workflow File Sequence:Saved Workflow File Name	d
6673	(0019,"SIEMENS MR VA0  COAD",26)	DS	t	TransmitterReference	k
6778	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,0100)	SH	t	Presentation State Sequence:Unknown:Code Value	d
6608	(0019,"SIEMENS MR VA0  COAD",a0)	IS	t	RFWatchdogMask	d
6634	(0009,"SPI RELEASE 1",10)	LO	t	Comments	d
6599	(0019,"SIEMENS MR VA0  GEN",26)	IS	t	NumberOfFourierLinesAfterZero	k
6683	(0019,"SIEMENS MR VA0  GEN",87)	CS	t	NormalizationFilterTypeForImageData	k
6601	(0021,"SIEMENS MR VA0  GEN",42)	IS	t	CurrentSliceNumber	k
6755	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",66)	UN	t	Unknown	k
6660	(0019,"SIEMENS MR VA0  COAD",14)	DS	t	ADCVoltage	k
4144	(0019,"",0e)	FD	t	Unknown	d
4061	(0051,"",0f)	LO	t	Unknown	d
4167	(0029,"SIEMENS CSA REPORT",09)	LO	t	Report Version	d
4083	(700d,"TOSHIBA_MEC_MR3",01)	OB	t	Acquisition Order	d
4062	(0051,"",11)	LO	t	Unknown	d
4081	(700d,"TOSHIBA_MEC_MR3",04)	OB	t	Rotate Information	d
4154	(5653,"Vital Images SW 3.4",15)[<0>](0020,0032)	DS	t	Image Sequence:Image Position (Patient)	d
2865	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",12)	OB	t	Unknown:Unknown	d
3159	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",50)	OB	t	Unknown:Unknown	d
5342	(0015,"GEMS_PETD_01",38)	UN	t	Unknown	d
1306	(7053,"Philips PET Private Group",06)	OB	t	Unknown	d
4126	(0019,"",16)	DS	t	Unknown	d
4177	(0043,"dcm4che/archive",4e)	FL	t	Unknown	d
4189	(0043,"dcm4che/archive",64)	CS	t	Unknown	d
4179	(0043,"dcm4che/archive",4d)	FL	t	Unknown	d
4145	(0019,"",29)	FD	t	Unknown	d
4072	(0019,"",12)	SL	t	Unknown	d
6785	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",2a)	CS	t	Presentation State Sequence:Exam Print Status	d
6664	(0019,"SIEMENS MR VA0  GEN",11)	DS	t	TotalMeasurementTimeCurrent	k
6677	(0019,"SIEMENS CM VA0  CMS",20)	CS	t	MeasurementMode	k
6624	(0019,"SIEMENS CM VA0  CMS",50)	IS	t	NoiseLevel	k
6686	(0021,"SIEMENS CM VA0  CMS",65)	US	t	ImagePositioningHistoryMask	k
6663	(0021,"SIEMENS MR VA0  RAW",09)	DS	t	SignalLimitsMinimum	k
4174	(0029,"",03)	UN	t	Unknown	d
4138	(0043,"GEMS_PARM_01",a5)	IS	t	Duration of the label or control pulse	d
6337	(0008,1140)[<0>](0008,0005)	CS	f	Referenced Image Sequence:Specific Character Set	\N
6338	(0018,5104)	SQ	f	Projection Eponymous Name Code Sequence	\N
6339	(0018,1114)	DS	f	Estimated Radiographic Magnification Factor	\N
6323	(0028,0109)	US	f	Largest Pixel Value in Series	\N
1115	(0009,"GEMS_PETD_01",86)	FL	t	Zoom	k
4322	(0023,"GEMS_STDY_01",80)[<0>](0008,1120)	SQ	t	Has MPPS Related Tags:Referenced Patient Sequence	k
503	(0019,"GEMS_ACQU_01",7f)	DS	t	TableDelta	k
2158	(0013,"CTP",14)	LO	t	Visibility	k
521	(0021,"GEMS_RELA_01",56)	SL	t	IntegerSlop	k
6374	(50f1,"FDMS 1.0",10)	CS	t	Film Output Format	k
6783	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,010b)	CS	t	Presentation State Sequence:Unknown:Context Group Extension Flag	d
468	(0021,"GEMS_RELA_01",84)	DS	t	AutoWindowLevelLevel	k
6779	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,0102)	SH	t	Presentation State Sequence:Unknown:Coding Scheme Designator	d
6661	(0019,"SIEMENS MR VA0  GEN",94)	DS	t	ImageRotationAngle	k
5135	(2005,"Philips MR Imaging DD 005",4b)	OB	t	Mixing Time	k
6658	(0019,"SIEMENS MR VA0  COAD",22)	DS	t	TransmitterAttenuator	k
6775	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",51)	SS	t	Presentation State Sequence:Number of Study Admitting Diagnostic Description	d
6644	(0019,"SIEMENS MR VA0  COAD",16)	DS	t	ADCOffset	k
6698	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",40)	UN	t	Series PlanScan:PlanScan Survey Chemical Shift Number	d
6662	(0019,"SIEMENS MR VA0  COAD",d1)	DS	t	FlowSensitivity	k
6604	(0019,"SIEMENS MR VA0  COAD",d8)	IS	t	EchoColumnPosition	k
1137	(0009,"GEMS_PETD_01",12)	LO	t	Manufacturer	k
6699	(2005,"Philips MR Imaging DD 003",48)	UN	t	Number of Req Recipe of Results	d
6689	(0009,"SIEMENS CM VA0  CMS",13)	UN	t	Unknown	d
6700	(2005,"Philips MR Imaging DD 003",46)	UN	t	Unknown	d
6641	(0019,"SIEMENS MR VA0  COAD",a6)	DS	t	SpecificEnergyDose	k
6577	(0009,"GEMS_IDEN_01",e8)	UL	t	Unknown	d
383	(0043,"GEMS_PARM_01",39)	IS	t	SlopInteger6ToSlopInteger9	k
6672	(0019,"SIEMENS MR VA0  COAD",60)	DS	t	ReconstructionScaleFactor	k
6612	(0029,"SIEMENS CM VA0  CMS",52)	IS	t	SortCode	k
6584	(0019,"SIEMENS MR VA0  GEN",46)	UL	t	ArrayCoilCombinationMask	d
182	(0019,"GEMS_ACQU_01",2e)	DS	t	AngleOfFirstView	k
6737	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",13)	UN	t	Unknown	d
6751	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",60)	UN	t	Unknown	d
6744	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",53)	UN	t	Unknown	d
3100	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3796	(0019,"",16)	UN	t	Unknown	d
3054	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",81)	OB	t	Unknown:Unknown	d
3183	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",96)	OB	t	Unknown:Unknown	d
6597	(0021,"SIEMENS MR VA0  RAW",02)	IS	t	VectorSizeExtended	k
6727	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",59)	UN	t	Unknown	d
6772	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",45)	SS	t	Presentation State Sequence:Number of Software Version	d
4441	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a010)	CS	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Relationship Type	\N
6695	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",43)	UN	t	Series PlanScan:PlanScan Survey Image Type	d
6777	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)[<1>](0008,0103)	SH	t	Presentation State Sequence:Unknown:Coding Scheme Version	d
6606	(0019,"SIEMENS MR VA0  GEN",28)	IS	t	FirstMeasuredFourierLine	k
5437	(0020,0050)	DS	f	Location	\N
5440	(0020,0030)	DS	f	Image Position	\N
5445	(0028,0060)	CS	f	Compression Code	\N
4267	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0008,1155)	UI	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Referenced SOP Instance UID	\N
4164	(0040,a370)[<0>](0040,2016)	LO	f	Referenced Request Sequence:Placer Order Number / Imaging Service Request	\N
5449	(0028,0200)	US	f	Image Location	\N
4431	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a168)[<3>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Concept Code Sequence:Code Meaning	\N
4546	(0008,1110)[<0>](0008,0005)	CS	f	Referenced Study Sequence:Specific Character Set	\N
4430	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)[<3>](0040,a043)[<4>](0008,0104)	LO	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence:Concept Name Code Sequence:Code Meaning	\N
4392	(5200,9230)[<0>](0008,9124)[<1>](0008,9215)	SQ	f	Per-frame Functional Groups Sequence:Derivation Image Sequence:Derivation Code Sequence	\N
4427	(0040,a730)[<0>](0040,a730)[<1>](0040,a730)[<2>](0040,a730)	SQ	f	Content Sequence:Content Sequence:Content Sequence:Content Sequence	\N
4271	(5200,9229)[<0>](0008,9124)[<1>](0008,2112)[<2>](0040,a170)[<3>](0008,0100)	SH	f	Shared Functional Groups Sequence:Derivation Image Sequence:Source Image Sequence:Purpose of Reference Code Sequence:Code Value	\N
4409	(5200,9230)[<0>](0062,000a)[<1>](0062,000b)	US	f	Per-frame Functional Groups Sequence:Segment Identification Sequence:Referenced Segment Number	\N
4291	(5200,9229)[<0>](0020,9116)[<1>](0020,0037)	DS	f	Shared Functional Groups Sequence:Plane Orientation Sequence:Image Orientation (Patient)	\N
4522	(0040,0275)[<0>](0040,0008)	SQ	f	Request Attributes Sequence:Scheduled Protocol Code Sequence	\N
5436	(0020,0070)	LO	f	Image Geometry Type	\N
5441	(0020,0035)	DS	f	Image Orientation	\N
5448	(0028,0005)	US	f	Image Dimensions	\N
5444	(0028,0040)	CS	f	Image Format	\N
868	(0009,"GEMS_PETD_01",bc)	SL	t	IR Regularize	k
6375	(2020,0010)	US	f	Image Box Position	\N
465	(0021,"GEMS_RELA_01",5d)	DS	t	FloatSlop	k
4563	(0008,1048)	PN	f	Physician(s) of Record	\N
4568	(300a,03a2)[<0>](300a,0420)[<1>](300a,0421)	SH	f	Ion Beam Sequence:General Accessory Sequence:General Accessory ID	\N
644	(0009,"GEMS_PETD_01",bc)	SS	t	IR Regularize	k
802	(0009,"GEMS_PETD_01",55)	SL	t	Lower Energy Limit	k
3248	(300d,"TOMO_HA_01",a9)	UN	t	Unknown	d
2960	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",15)	OB	t	Unknown:Unknown	d
5434	(0019,"SIEMENS MR VA0  COAD",d9)	IS	t	LinesPerSegment	d
3872	(0019,"",9f)	UN	t	Unknown	d
3725	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",16)	SS	t	Unknown	d
4304	(0009,"CTP",02)	UN	t	Unknown	d
4376	(0015,"GEMS_PETD_01",30)	UL	t	Emission Scatter Flag	k
6748	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",61)	UN	t	Unknown	d
4562	(0071,"SIEMENS MED PT",24)	CS	t	Time Slice Duration	d
6702	(2005,"Philips MR Imaging DD 003",50)	UN	t	Number of Series Performing Physicians Name	d
4381	(0015,"GEMS_PETD_01",2f)	UL	t	WCC Cal Flag	k
6769	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",01)	UL	t	Presentation State Sequence:Number of Film Consumption	d
4489	(0043,"GEMS_PARM_01",6d)	US	t	Area Size	k
4375	(0015,"GEMS_PETD_01",23)	UL	t	BP3d Filter FlagU	k
6645	(0019,"SIEMENS MR VA0  COAD",80)	DS	t	GradientDelayTime	k
6789	(0019,"SIEMENS MR VA0  GEN",82)	DS	t	FilterParameterForRawData	k
6767	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 002",99)	UL	t	Presentation State Sequence:Number of Request Excerpts	d
6675	(0019,"SIEMENS MR VA0  COAD",da)	CS	t	PhaseCodingDirection	k
6632	(0019,"SIEMENS CM VA0  ACQU",10)	LO	t	ParameterFileName	d
6671	(0019,"SIEMENS MR VA0  COAD",82)	DS	t	TotalGradientDelayTime	k
6710	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",3f)	UN	t	Series PlanScan:PlanScan Acquisition Number	d
6762	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",02)	SQ	t	Presentation State Sequence:Unknown	k
6636	(0019,"SIEMENS MR VA0  COAD",a2)	DS	t	RFPowerErrorIndicator	k
6791	(5200,9230)[<0>](2005,"Philips MR Imaging DD 005",0f)		t	Per-frame Functional Groups Sequence:Private Per-Frame Sequence	d
6590	(0009,"SIEMENS CM VA0  CMS",12)	UL	t	EvaluationMaskImage	d
6703	(2005,"Philips MR Imaging DD 003",43)	UN	t	No Date of Last Calibration	d
6734	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",30)	UN	t	Unknown	d
6731	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",10)	UN	t	Unknown	d
6705	(2005,"Philips MR Imaging DD 001",80)[<0>](2005,"Philips MR Imaging DD 001",42)	UN	t	Series PlanScan:PlanScan Survey Echo Number	d
6680	(0019,"SIEMENS MR VA0  GEN",83)	CS	t	FilterTypeForImageData	k
6576	(0009,"SIENET",10)	UN	t	Unknown	d
6790	(5200,9229)[<0>](2005,"Philips MR Imaging DD 005",0e)		t	Shared Functional Groups Sequence:Private Shared Sequence	d
6642	(0021,"SIEMENS MR VA0  RAW",31)	DS	t	ArrayCoilPreamplifierGain	k
6648	(0021,"SIEMENS MR VA0  RAW",11)	DS	t	SpecInfoMask	d
6774	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",52)	SS	t	Presentation State Sequence:Number of Study Patient Contrast Allergies	d
6787	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",2b)	CS	t	Presentation State Sequence:Exam Export Status	d
6655	(0021,"SIEMENS MR VA0  RAW",08)	DS	t	SpatialGridShift	k
6646	(0019,"SIEMENS MR VA0  COAD",20)	DS	t	TransmitterAmplitude	k
6743	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",56)	UN	t	Unknown	d
6616	(0019,"SIEMENS MR VA0  GEN",40)	IS	t	ArrayCoilElementNumber	k
6679	(0019,"SIEMENS CM VA0  CMS",30)	CS	t	CalculationMode	k
6620	(0019,"SIEMENS MR VA0  COAD",d5)	IS	t	2DOversamplingLines	k
6585	(0019,"SIEMENS MR VA0  GEN",42)	UL	t	ArrayCoilElementDataMask	d
6745	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",36)	UN	t	Unknown	d
6768	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",13)	UL	t	Presentation State Sequence:Number of Codes	d
6668	(0019,"SIEMENS MR VA0  COAD",56)	DS	t	ReceiverFilterFrequency	k
6639	(0019,"SIEMENS MR VA0  COAD",72)	DS	t	SelectionGradientAmplitude	k
6926	(0043,"GEMS_PARM_01",76)	US	t	Number of Dummy Scans	d
6764	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",00)	UL	t	Presentation State Sequence:Number of SOP Common	h
6592	(0019,"SIEMENS MR VA0  GEN",20)	IS	t	NumberOfFourierLinesNominal	k
6713	(7001,"GEMS_MR_RAW_01",06)	UN	t	rdb_hdr_nex_abort_tab	d
6715	(7001,"GEMS_MR_RAW_01",05)	UN	t	rdb_hdr_nex_tab	d
6652	(0021,"SIEMENS MR VA0  RAW",10)	DS	t	SignalLimitsMaximum	k
6684	(0019,"SIEMENS MR VA0  GEN",81)	CS	t	FilterTypeForRawData	k
6589	(0019,"SIEMENS MR VA0  COAD",b0)	UL	t	AdjustmentStatusMask	k
6614	(0019,"SIEMENS MR VA0  GEN",50)	IS	t	NumberOfAverages	k
5764	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Image Plane Distance	k
6756	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",65)	UN	t	Unknown	d
5763	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4a)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Image Plane Distance	k
6580	(07a3,"ELSCINT1",18)	UN	t	Unknown	d
6670	(0019,"SIEMENS MR VA0  COAD",51)	DS	t	ReceiverAmplifierGain	k
6721	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",40)	UN	t	Unknown	d
6650	(0019,"SIEMENS MR VA0  COAD",71)	DS	t	ReadoutGradientAmplitude	k
6659	(0019,"SIEMENS MR VA0  GEN",13)	DS	t	DwellTime	k
6676	(0021,"SIEMENS MR VA0  RAW",00)	CS	t	SequenceType	k
6776	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 003",49)	SS	t	Presentation State Sequence:Number of Series Operators Name	d
6640	(0019,"SIEMENS MR VA0  COAD",62)	DS	t	ReferenceScaleFactor	k
6598	(0019,"SIEMENS MR VA0  GEN",30)	IS	t	AcquisitionColumns	k
6697	(2005,"Philips MR Imaging DD 003",54)	UN	t	Number of Study Physicians of Record	d
4473	(1111,"2.16.840.1.114330.1.1.1.1",0f)	FD	t	Unknown	d
4356	(07a1,"ELSCINT1",88)	UN	t	Unknown	d
4466	(1111,"2.16.840.1.114330.1.1.1.1",04)	IS	t	Unknown	d
698	(0017,"GEMS_PETD_01",04)	LO	t	cal_datetime	o
4469	(1111,"2.16.840.1.114330.1.1.1.1",1f)	SS	t	Unknown	d
4491	(0021,"BRIT Systems, Inc.",a0)	SQ	t	Object Action Sequence	d
6722	(0011,"PICKER PQ2000+ CT IMAGE PRIVATE DATA",33)	UN	t	Unknown	d
5768	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",16)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Anti Aliasing	k
6694	(2005,"Philips MR Imaging DD 004",53)	LO	t	Spectro Processing History	d
5769	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",52)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Threshold	k
6712	(0021,"0021,1000",4f)	UN	t	Unknown	d
6788	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 001",5f)	CS	t	Presentation State Sequence:StackSequence	d
6667	(0019,"SIEMENS MR VA0  COAD",52)	DS	t	ReceiverPreamplifierGain	k
6681	(0029,"SIEMENS CM VA0  CMS",20)	CS	t	PixelQualityCode	K
6418	(0028,0200)	SS	f	Image Location	\N
6419	(0028,0005)	SS	f	Image Dimensions	\N
412	(0019,"GEMS_ACQU_01",c3)	SS	t	SATLocationL	k
351	(0045,"GEMS_HELIOS_01",11)	SS	t	Number of Views 2A	k
1628	(0023,"GEMS_STDY_01",74)	SL	t	NumberOfUpdatesToHeader	k
761	(0009,"GEMS_PETD_01",e2)	SL	t	rest_stress	k
772	(0009,"GEMS_PETD_01",35)	SL	t	Triggers Rejected	k
5143	(2005,"Philips MR Imaging DD 005",50)	OB	t	Number of Patient Other IDs	k
5421	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)	SQ	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence	d
5447	(0095,"SIENET",12)	UN	t	Unknown	d
5432	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)[<2>](0064,0008)	FD	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence:Grid Resolution	d
5428	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0070,030d)[<2>](0008,0104)	LO	t	Unknown:Deformable Registration Sequence:Registration Type Code Sequence:Code Meaning	d
5443	(0021,"SIEMENS MR VA0  GEN",44)	DS	t	CurrentSliceDistanceFactor	d
5429	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)[<2>](0020,0032)	DS	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence:Image Position (Patient)	d
5438	(0019,"SIEMENS MR VA0  GEN",60)	DS	t	FlipAngle	d
5451	(0019,"SIEMENS CM VA0  ACQU",13)	LO	t	SequenceDescription	d
5439	(0019,"SIEMENS MR VA0  COAD",12)	DS	t	MagneticFieldStrength	d
5415	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)[<2>](0028,0010)	US	t	Unknown:Unknown:Unknown:Rows	d
5418	(0071,"BLACKFORD",04)[<0>](0008,0023)	DA	t	Unknown:Content Date	d
5420	(0071,"BLACKFORD",04)[<0>](0064,0002)	SQ	t	Unknown:Deformable Registration Sequence	d
5446	(0009,"SIEMENS CM VA0  CMS",10)	CS	t	StorageMode	d
5435	(0011,"SIEMENS ISI",0a)	LO	t	CaseID	d
2139	(0009,"GEMS_GENIE_1",21)	SL	t	SeriesFlags	d
359	(0045,"GEMS_HELIOS_01",13)	SS	t	Sigma Mode	k
1404	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",04)	OB	t	Unknown	d
5072	(2001,"Philips Imaging DD 001",08)	OB	t	PhaseNumber	k
4578	(300a,03a2)	SQ	f	Ion Beam Sequence	\N
4622	(300a,03a2)[<0>](300a,00e0)	IS	f	Ion Beam Sequence:Number of Compensators	\N
4673	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0142)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Pitch Rotation Direction	\N
4646	(300a,03a0)[<0>](300a,0052)	DS	f	Ion Tolerance Table Sequence:Table Top Longitudinal Position Tolerance	\N
4610	(300a,03a2)[<0>](300a,0312)	IS	f	Ion Beam Sequence:Number of Range Shifters	\N
4584	(300a,03a2)[<0>](300a,0342)	SQ	f	Ion Beam Sequence:Range Modulator Sequence	\N
4592	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0370)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence:Lateral Spreading Device Settings Sequence	\N
4583	(300a,03a2)[<0>](300a,0332)	SQ	f	Ion Beam Sequence:Lateral Spreading Device Sequence	\N
4629	(300a,03a2)[<0>](300c,00a0)	IS	f	Ion Beam Sequence:Referenced Tolerance Table Number	\N
4602	(300a,03a2)[<0>](300a,0354)	LO	f	Ion Beam Sequence:Patient Support Accessory Code	\N
4596	(300a,03a2)[<0>](0008,0070)	LO	f	Ion Beam Sequence:Manufacturer	\N
4577	(300a,03a2)[<0>](300a,02ea)	SQ	f	Ion Beam Sequence:Ion Range Compensator Sequence	\N
4667	(300a,03a2)[<0>](300a,0350)	CS	f	Ion Beam Sequence:Patient Support Type	\N
4597	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00f9)	LO	f	Beam Sequence:Block Sequence:Accessory Code	\N
4641	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0129)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Longitudinal Position	\N
4581	(300a,03a2)[<0>](300a,03a8)[<1>](300c,0050)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence:Referenced Dose Reference Sequence	\N
4650	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0120)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Beam Limiting Device Angle	\N
4619	(300a,03a2)[<0>](300a,0340)	IS	f	Ion Beam Sequence:Number of Range Modulators	\N
4636	(300a,03a2)[<0>](300a,03a6)[<1>](300a,0106)	DS	f	Ion Beam Sequence:Ion Block Sequence:Block Data	\N
4590	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0360)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence:Range Shifter Settings Sequence	\N
4659	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00fa)	CS	f	Ion Beam Sequence:Ion Block Sequence:Block Divergence	\N
4634	(300a,03a2)[<0>](300a,03a8)[<1>](300a,012c)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Isocenter Position	\N
4615	(300a,03a2)[<0>](300a,03a8)[<1>](300c,0050)[<2>](300c,0051)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Referenced Dose Reference Sequence:Referenced Dose Reference Number	\N
4601	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00fe)	LO	f	Ion Beam Sequence:Ion Block Sequence:Block Name	\N
4645	(300a,03a2)[<0>](300a,03a8)[<1>](300a,012a)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Lateral Position	\N
4621	(300a,03a2)[<0>](300a,0342)[<1>](300a,0344)	IS	f	Ion Beam Sequence:Range Modulator Sequence:Range Modulator Number	\N
4608	(300a,03a2)[<0>](300a,0332)[<1>](300a,0334)	IS	f	Ion Beam Sequence:Lateral Spreading Device Sequence:Lateral Spreading Device Number	\N
4658	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e0)	CS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Divergence	\N
4611	(300a,03a2)[<0>](300a,0330)	IS	f	Ion Beam Sequence:Number of Lateral Spreading Devices	\N
4606	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e8)	IS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Columns	\N
4593	(300a,00b0)[<0>](0018,1000)	LO	f	Beam Sequence:Device Serial Number	\N
4571	(300a,03a2)[<0>](300a,0332)[<1>](300a,0336)	SH	f	Ion Beam Sequence:Lateral Spreading Device Sequence:Lateral Spreading Device ID	\N
4617	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e4)	IS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Number	\N
4628	(300a,03a0)[<0>](300a,0042)	IS	f	Ion Tolerance Table Sequence:Tolerance Table Number	\N
4631	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e7)	IS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Rows	\N
4642	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0134)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Cumulative Meterset Weight	\N
4625	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0112)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Control Point Index	\N
4595	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0360)[<2>](300a,0362)	LO	f	Ion Beam Sequence:Ion Control Point Sequence:Range Shifter Settings Sequence:Range Shifter Setting	\N
4600	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00fe)	LO	f	Beam Sequence:Block Sequence:Block Name	\N
4618	(300a,03a2)[<0>](300a,00f0)	IS	f	Ion Beam Sequence:Number of Blocks	\N
4582	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence	\N
4647	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0128)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Vertical Position	\N
4656	(300a,03a2)[<0>](300a,00ce)	CS	f	Ion Beam Sequence:Treatment Delivery Type	\N
4624	(300a,03a2)[<0>](300c,0042)[<1>](300a,00c8)	IS	f	Ion Beam Sequence:Referenced Reference Image Sequence:Reference Image Number	\N
4664	(300a,03a2)[<0>](300a,0342)[<1>](300a,0348)	CS	f	Ion Beam Sequence:Range Modulator Sequence:Range Modulator Type	\N
4607	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0370)[<2>](300c,0102)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Lateral Spreading Device Settings Sequence:Referenced Lateral Spreading Device Number	\N
4661	(300a,03a2)[<0>](300a,00c4)	CS	f	Ion Beam Sequence:Beam Type	\N
4632	(300a,03a2)[<0>](300a,03a8)[<1>](300a,011e)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Gantry Angle	\N
4603	(300a,00b0)[<0>](0008,1040)	LO	f	Beam Sequence:Institutional Department Name	\N
4670	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00fb)	CS	f	Ion Beam Sequence:Ion Block Sequence:Block Mounting Position	\N
4574	(300a,03a2)[<0>](300a,030c)[<1>](300a,030f)	SH	f	Ion Beam Sequence:Snout Sequence:Snout ID	\N
4666	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0015)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Nominal Beam Energy Unit	\N
3074	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",60)	OB	t	Unknown:Unknown	d
527	(0029,"GEMS_IMPS_01",17)	SL	t	LowerRangeOfPixels	k
4684	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0360)[<2>](300a,0366)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Shifter Settings Sequence:Range Shifter Water Equivalent Thickness	\N
4685	(300a,03a0)[<0>](300a,004f)	FL	f	Ion Tolerance Table Sequence:Table Top Pitch Angle Tolerance	\N
4755	(300a,03a2)[<0>](300a,0342)[<1>](300a,034c)	SH	f	Ion Beam Sequence:Range Modulator Sequence:Beam Current Modulation ID	\N
4726	(300a,00b0)[<0>](300a,00ca)[<1>](300a,00cc)	LO	f	Beam Sequence:Planned Verification Image Sequence:Imaging Device-Specific Acquisition Parameters	\N
4772	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00ea)	DS	f	Beam Sequence:Compensator Sequence:Compensator Position	\N
4725	(300a,00b0)[<0>](300a,00ca)	SQ	f	Beam Sequence:Planned Verification Image Sequence	\N
4758	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00f9)	LO	f	Ion Beam Sequence:Ion Range Compensator Sequence:Accessory Code	\N
4696	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0370)[<2>](300a,0374)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Lateral Spreading Device Settings Sequence:Isocenter to Lateral Spreading Device Distance	\N
4765	(300a,03a2)[<0>](300a,03a4)[<1>](300a,00bb)	FL	f	Ion Beam Sequence:Ion Beam Limiting Device Sequence:Isocenter to Beam Limiting Device Distance	\N
4768	(300a,00b0)[<0>](300a,00e3)	SQ	f	Beam Sequence:Compensator Sequence	\N
4697	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300a,0388)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Range Modulator Gating Stop Water Equivalent Thickness	\N
4694	(300a,03a2)[<0>](300a,03a8)[<1>](300a,035a)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Meterset Rate	\N
4713	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0392)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Number of Scan Spot Positions	\N
4719	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0394)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Scan Spot Position Map	\N
4767	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e1)	SH	f	Beam Sequence:Compensator Sequence:Material ID	\N
4692	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00f7)	FL	f	Ion Beam Sequence:Ion Block Sequence:Isocenter to Block Tray Distance	\N
4691	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0140)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Pitch Angle	\N
4686	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0360)[<2>](300a,0364)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Shifter Settings Sequence:Isocenter to Range Shifter Distance	\N
4690	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300a,0382)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Range Modulator Gating Start Value	\N
4756	(300a,03a2)[<0>](300a,03a8)[<1>](300a,011a)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence:Beam Limiting Device Position Sequence	\N
4750	(300a,00b0)[<0>](300a,0111)[<1>](300a,014c)	CS	f	Beam Sequence:Control Point Sequence:Gantry Pitch Rotation Direction	\N
4700	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300a,038a)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Isocenter to Range Modulator Distance	\N
4687	(300a,03a2)[<0>](300a,03a8)[<1>](300a,014a)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Gantry Pitch Angle	\N
4751	(300a,0070)[<0>](300c,0004)[<1>](300a,0089)	FL	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Dose Point Equivalent Depth	\N
4764	(300a,03a2)[<0>](300a,03a8)[<1>](300a,011a)[<2>](300a,00b8)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Beam Limiting Device Position Sequence:RT Beam Limiting Device Type	\N
4701	(300a,03a2)[<0>](300c,0042)[<1>](0008,1150)	UI	f	Ion Beam Sequence:Referenced Reference Image Sequence:Referenced SOP Class UID	\N
4773	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e6)	DS	f	Beam Sequence:Compensator Sequence:Source to Compensator Tray Distance	\N
4757	(300a,03a2)[<0>](300a,03a4)	SQ	f	Ion Beam Sequence:Ion Beam Limiting Device Sequence	\N
4760	(300a,03a2)[<0>](300a,03a4)[<1>](300a,00be)	DS	f	Ion Beam Sequence:Ion Beam Limiting Device Sequence:Leaf Position Boundaries	\N
4728	(300a,00b0)[<0>](300a,00ca)[<1>](3002,000e)	DS	f	Beam Sequence:Planned Verification Image Sequence:X-Ray Image Receptor Angle	\N
4761	(300a,03a2)[<0>](300a,03a8)[<1>](300a,011a)[<2>](300a,011c)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Beam Limiting Device Position Sequence:Leaf/Jaw Positions	\N
4689	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e5)	FL	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Column Offset	\N
4759	(300a,03a2)[<0>](300a,03a4)[<1>](300a,00bc)	IS	f	Ion Beam Sequence:Ion Beam Limiting Device Sequence:Number of Leaf/Jaw Pairs	\N
4775	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e9)	DS	f	Beam Sequence:Compensator Sequence:Compensator Pixel Spacing	\N
4688	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0144)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Roll Angle	\N
4771	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e4)	IS	f	Beam Sequence:Compensator Sequence:Compensator Number	\N
4733	(300a,0180)[<0>](300a,0410)[<1>](0018,9171)	CS	f	Patient Setup Sequence:Motion Synchronization Sequence:Respiratory Signal Source	\N
4727	(300a,00b0)[<0>](300a,00ca)[<1>](3002,0012)	DS	f	Beam Sequence:Planned Verification Image Sequence:RT Image Position	\N
4730	(300a,00b0)[<0>](300a,00ca)[<1>](3002,000c)	CS	f	Beam Sequence:Planned Verification Image Sequence:RT Image Plane	\N
4716	(300a,0180)[<0>](300a,01d6)	DS	f	Patient Setup Sequence:Table Top Lateral Setup Displacement	\N
4780	(300a,00b0)[<0>](300c,00b0)[<1>](300a,00dc)	SH	f	Beam Sequence:Referenced Bolus Sequence:Bolus ID	\N
4711	(300a,03a2)[<0>](300a,00c3)	ST	f	Ion Beam Sequence:Beam Description	\N
4766	(300a,03a2)[<0>](0008,0080)	LO	f	Ion Beam Sequence:Institution Name	\N
4763	(300a,03a2)[<0>](300a,03a4)[<1>](300a,00b8)	CS	f	Ion Beam Sequence:Ion Beam Limiting Device Sequence:RT Beam Limiting Device Type	\N
4698	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300a,0386)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Range Modulator Gating Start Water Equivalent Thickness	\N
6501	(6002,3000)	OW	f	Overlay Data	\N
6472	(0019,"SIEMENS CT VA0  GEN",71)	CS	t	Unknown	d
6473	(0009,"SIEMENS CT VA0  IDE",30)	CS	t	Unknown	d
6475	(0019,"SIEMENS CT VA0  COAD",aa)	CS	t	Unknown	d
6465	(0029,"SIEMENS CM VA0  CMS",11)	CS	t	Unknown	d
6508	(6002,0100)	US	f	Overlay Bits Allocated	\N
6503	(6002,0040)	CS	f	Overlay Type	\N
6498	(6002,0050)	SS	f	Overlay Origin	\N
6495	(0028,0108)	US	f	Smallest Pixel Value in Series	\N
6499	(6002,0022)	LO	f	Overlay Description	\N
6471	(0021,"SIEMENS CT VA0  RAW",50)	CS	t	Unknown	d
214	(0019,"GEMS_ACQU_01",db)	DS	t	BackProjectorCoefficient	k
5223	(2005,"Philips MR Imaging DD 001",1b)	OB	t	Magnetization Prepared	k
6479	(0009,"SIEMENS CT VA0  IDE",51)	TM	t	Unknown	d
6470	(0019,"SIEMENS CT VA0  COAD",a2)	CS	t	Unknown	d
6474	(0021,"SIEMENS CT VA0  GEN",a2)	CS	t	Unknown	d
6466	(0029,"SIEMENS CM VA0  CMS",10)	CS	t	WindowStyle	k
6480	(0029,"SIEMENS MED MG",10)	US	t	ListOfGroupNumbers	k
6467	(0021,"SIEMENS CM VA0  CMS",71)	CS	t	PatientOrientationSet2	k
6478	(0009,"SIEMENS CM VA0  CMS",27)	TM	t	LastMoveTime	k
6468	(0021,"SIEMENS CM VA0  CMS",32)	CS	t	PatientRestDirection	k
6477	(0011,"SIEMENS CM VA0  CMS",11)	TM	t	RegistrationTime	k
6469	(0021,"SIEMENS CM VA0  CMS",30)	CS	t	ViewDirection	k
6476	(0019,"SIEMENS CT VA0  COAD",c3)	TM	t	Pulmo Time	k
6482	(0029,"SIEMENS MED MG",60)	US	t	ListOfTextPosition	k
6481	(0029,"SIEMENS MED MG",30)	US	t	ListOfTotalDisplayLength	k
6488	(0008,2112)[<0>](0008,0016)	UI	f	Source Image Sequence:SOP Class UID	\N
340	(0045,"GEMS_HELIOS_01",0b)	FL	t	Maximum Offset Value	k
504	(0019,"GEMS_ACQU_01",b4)	DS	t	UserData	d
5409	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0020,0052)	UI	t	Unknown:Registration Sequence:Frame of Reference UID	d
5366	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)	SQ	t	Unknown:Registration Sequence:Matrix Registration Sequence	d
5372	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)	SQ	t	Unknown:Unknown:Unknown	d
5363	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030d)[<3>](0008,0100)	SH	t	Unknown:Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence:Code Value	d
5392	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",03)	DS	t	Unknown:Unknown:Unknown	d
5390	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030a)[<3>](3006,00c6)	DS	t	Unknown:Registration Sequence:Matrix Registration Sequence:Matrix Sequence:Frame of Reference Transformation Matrix	d
5399	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030a)[<3>](0070,030c)	CS	t	Unknown:Registration Sequence:Matrix Registration Sequence:Matrix Sequence:Frame of Reference Transformation Matrix Type	d
5374	(0071,"BLACKFORD",04)[<0>](0008,1090)	LO	t	Unknown:Manufacturer's Model Name	d
5358	(0077,"TERARECON AQUARIUS",90)	UN	t	COF Refinement Level	d
6509	(6002,0102)	US	f	Overlay Bit Position	\N
6507	(6002,0011)	US	f	Overlay Columns	\N
6489	(0008,2112)[<0>](0008,0018)	UI	f	Source Image Sequence:SOP Instance UID	\N
6506	(6002,0010)	US	f	Overlay Rows	\N
4906	(0010,9910)	PN	f	<undef>	\N
4898	(0010,9910)	UN	f	<undef>	\N
1545	(0019,"SIEMENS MR HEADER",0f)	SH	t	Gradient Mode	k
363	(0045,"GEMS_HELIOS_01",21)	SS	t	Iterbone Flag	k
5215	(2005,"Philips MR Imaging DD 001",3c)	OB	t	Tilt Optimized Nonsaturated Excitation	k
169	(0027,"GEMS_IMAG_01",54)	SH	t	RASLetterForScoutStartLoc	k
4819	(0027,"GEMS_IMAG_01",42)	OB	t	CenterRCoordOfPlaneImage	k
5951	(0057,"GEMS_VXTLSTATE_001",05)	SQ	t	Unknown	d
5907	(7031,"CtProjectionData-MayoClinc-v1",31)	UN	t	Unknown	d
4807	(0043,"GEMS_PARM_01",43)	OB	t	DASFpaGain	k
4789	(0019,"GEMS_ACQU_01",2f)	OB	t	TriggerFrequency	k
4806	(0045,"GEMS_HELIOS_01",04)	OB	t	DAS gain	k
5897	(7033,"CtProjectionData-MayoClinc-v1",67)	UN	t	Unknown	d
4800	(0053,"GEHC_CT_ADVAPP_001",64)	OB	t	Shutter Mode	k
4790	(0045,"GEMS_HELIOS_01",06)	OB	t	Table Direction	k
5952	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",06)	SQ	t	Unknown:Unknown	d
5911	(7033,"CtProjectionData-MayoClinc-v1",65)	UN	t	Unknown	d
4826	(0019,"GEMS_ACQU_01",11)	OB	t	SeriesContrast	k
5904	(7031,"CtProjectionData-MayoClinc-v1",33)	UN	t	Unknown	d
5956	(0057,"GEMS_VXTLSTATE_001",a8)	IS	t	Unknown	d
5898	(7031,"CtProjectionData-MayoClinc-v1",02)	UN	t	Unknown	d
4824	(0045,"GEMS_HELIOS_01",03)	OB	t	DAS type	k
4791	(0053,"GEHC_CT_ADVAPP_001",43)	OB	t	Iterative Recon Level	k
5929	(3f01,"INTELERAD MEDICAL SYSTEMS",12)	UL	t	Unknown	d
5905	(7033,"CtProjectionData-MayoClinc-v1",0d)	UN	t	Unknown	d
5913	(7033,"CtProjectionData-MayoClinc-v1",13)	UN	t	Unknown	d
5939	(7005,"TOSHIBA_MEC_CT3",30)	OB	t	Main Modality in Study	k
5944	(7005,"TOSHIBA_MEC_CT3",1a)	OB	t	Frame Sort Order	k
1102	(0043,"GEMS_PARM_01",9a)	IS	t	Rx Stack Identification	k
598	(0009,"GEMS_PETD_01",3c)	FL	t	Post Injected Activity	k
4779	(300a,00b0)[<0>](3283,"Varian Medical Systems VISION 3283",60)	UN	t	Beam Sequence:Unknown	d
5932	(3f01,"INTELERAD MEDICAL SYSTEMS",13)	LO	t	Unknown	d
5896	(7031,"CtProjectionData-MayoClinc-v1",01)	UN	t	Unknown	d
5910	(7033,"CtProjectionData-MayoClinc-v1",0c)	UN	t	Unknown	d
5948	(07a1,"ELSCINT1",72)	IS	t	Unknown	d
5931	(3f01,"INTELERAD MEDICAL SYSTEMS",10)	SH	t	Unknown	d
5900	(7037,"CtProjectionData-MayoClinc-v1",09)	UN	t	Unknown	d
5954	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)	SQ	t	Unknown:Unknown	d
5949	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",69)	SQ	t	Unknown:Unknown	d
5901	(7041,"CtProjectionData-MayoClinc-v1",01)	UN	t	Unknown	d
5950	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",21)	SQ	t	Unknown:Unknown	d
5934	(3f01,"INTELERAD MEDICAL SYSTEMS",11)	US	t	Unknown	d
5938	(7005,"TOSHIBA_MEC_CT3",0e)	OB	t	File Type Remarks	k
5940	(7005,"TOSHIBA_MEC_CT3",12)	OB	t	Position (supine or prone)	k
5945	(7005,"TOSHIBA_MEC_CT3",19)	OB	t	Frame Sort Key	k
5937	(7005,"TOSHIBA_MEC_CT3",1c)	OB	t	Contrast/Bolus Agent for Series Record	k
5941	(7005,"TOSHIBA_MEC_CT3",1f)	OB	t	Volume Number	d
5947	(7005,"TOSHIBA_MEC_CT3",0d)	OB	t	Organ	d
4799	(0053,"GEHC_CT_ADVAPP_001",9d)	OB	t	Unknown	d
4793	(0019,"GEMS_ACQU_01",0f)	OB	t	HorizontalFrameOfReference	d
4952	(0008,9215)[<0>](0008,0103)	SH	f	Derivation Code Sequence:Coding Scheme Version	\N
4739	(01e1,"ELSCINT1",1e)	UN	t	Unknown	d
4723	(300a,03a2)[<0>](300b,"RAYSEARCHLABS 1.0",02)	UN	t	Ion Beam Sequence:Unknown	d
4754	(3006,0080)[<0>](4001,"RAYSEARCHLABS 2.0",10)	UN	t	RT ROI Observations Sequence:Unknown	d
4738	(01f1,"ELSCINT1",41)	UN	t	Unknown	d
4731	(300a,0070)[<0>](300c,0004)[<1>](3249,"Varian Medical Systems VISION 3249",10)	UI	t	Fraction Group Sequence:Referenced Beam Sequence:Unknown	d
4707	(300a,03a2)[<0>](300b,"IMPAC",02)	UN	t	Ion Beam Sequence:Unknown	d
4746	(300a,03a2)[<0>](300b,"IMPAC",04)	FL	t	Ion Beam Sequence:Unknown	d
4737	(01e1,"ELSCINT1",1c)	UN	t	Unknown	d
4946	(0018,1261)	LO	f	Phosphor Type	\N
4953	(0018,1080)	CS	f	Beat Rejection Flag	\N
4938	(0008,001b)	UI	f	Original Specialized SOP Class UID	\N
4947	(0018,7065)	DS	f	Phototimer Setting	\N
4942	(0008,1150)	UI	f	Referenced SOP Class UID	\N
4837	(0043,"GEMS_PARM_01",4d)	OB	t	StartScanToXrayOnDelay	k
4832	(0043,"GEMS_PARM_01",1f)	OB	t	MaxOverrangesInAView	k
5969	(0057,"GEMS_VXTLSTATE_001",a9)	IS	t	Unknown	d
4856	(0045,"GEMS_HELIOS_01",08)	OB	t	View Weighting Mode	k
5971	(0057,"GEMS_VXTLSTATE_001",67)	IS	t	Unknown	d
5964	(0057,"GEMS_VXTLSTATE_001",a7)	IS	t	Unknown	d
4866	(0043,"GEMS_PARM_01",46)	OB	t	DASCalMode	k
5960	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",80)	IS	t	Unknown:Unknown:Unknown	d
5967	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",81)	IS	t	Unknown:Unknown:Unknown	d
4878	(0009,"GEMS_IDEN_01",02)	OB	t	SuiteId	d
4883	(0053,"GEHC_CT_ADVAPP_001",62)	OB	t	Respiratory Flag	k
4857	(0019,"GEMS_ACQU_01",39)	OB	t	ScanFOVType	k
4868	(0045,"GEMS_HELIOS_01",0f)	OB	t	Z tracking Error	k
5970	(0057,"GEMS_VXTLSTATE_001",a3)	IS	t	Unknown	d
4851	(0045,"GEMS_HELIOS_01",13)	OB	t	Sigma Mode	k
5958	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",aa)	IS	t	Unknown:Unknown:Unknown	d
5962	(0057,"GEMS_VXTLSTATE_001",a0)	IS	t	Unknown	d
4865	(0027,"GEMS_IMAG_01",20)	OB	t	SmartScanOnOffFlag	k
5963	(0057,"GEMS_VXTLSTATE_001",32)	IS	t	Unknown	d
4877	(0019,"GEMS_ACQU_01",23)	OB	t	TableSpeed	k
4863	(0027,"GEMS_IMAG_01",50)	OB	t	TableStartLocation	k
4888	(0053,"GEHC_CT_ADVAPP_001",41)	OB	t	Iterative Recon Mode	k
4843	(0043,"GEMS_PARM_01",25)	OB	t	ReferenceChannels	k
5972	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",29)	UT	t	Unknown:Unknown	d
5968	(0057,"GEMS_VXTLSTATE_001",68)	IS	t	Unknown	d
4880	(0019,"GEMS_ACQU_01",2e)	OB	t	AngleOfFirstView	k
5966	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",16)	IS	t	Unknown:Unknown:Unknown	d
5961	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",59)	IS	t	Unknown:Unknown:Unknown	d
5959	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",52)	IS	t	Unknown:Unknown	d
5973	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",23)	FL	t	Unknown:Unknown	d
4939	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)	UN	t	Advanced Presentation Sequence	k
4879	(0043,"GEMS_PARM_01",27)	OB	t	ScanPitchRatio	k
5965	(0057,"GEMS_VXTLSTATE_001",a6)	IS	t	Unknown	d
4848	(0043,"GEMS_PARM_01",21)	OB	t	CorrectedAfterglowTerms	k
4846	(0019,"GEMS_ACQU_01",26)	OB	t	DegreesOfAzimuth	k
342	(0045,"GEMS_HELIOS_01",0f)	FL	t	Z tracking Error	k
438	(0027,"GEMS_IMAG_01",32)	SS	t	PulseSequence	k
158	(0029,"GEMS_IMPS_01",08)	SH	t	LowerRangeOfPixels	k
1585	(0019,"SIEMENS MR HEADER",0d)	CS	t	Diffusion Directionality	k
69	(0019,"SIEMENS MR HEADER",0d)	OB	t	Diffusion Directionality	k
4897	(0137,"NetRAAD",01)	UN	t	Unknown	d
4904	(0045,"GEMS_HELIOS_01",51)	FD	t	Unknown	d
4905	(0045,"GEMS_HELIOS_01",53)	FD	t	Unknown	d
4894	(0137,"NetRAAD",10)	UN	t	Unknown	d
4891	(0137,"NetRAAD",20)	UN	t	Unknown	d
4911	(0045,"GEMS_HELIOS_01",55)	OB	t	Unknown	d
4566	(300a,03a2)[<0>](300a,0342)[<1>](300a,0346)	SH	f	Ion Beam Sequence:Range Modulator Sequence:Range Modulator ID	\N
4576	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00e1)	SH	f	Ion Beam Sequence:Ion Block Sequence:Material ID	\N
4930	(5001,"ELSCINT1",a1)	CS	t	Unknown	d
4919	(0053,"GEHC_CT_ADVAPP_001",6a)	OB	t	Unknown	d
4034	(0051,"",17)	SH	t	Unknown	d
3972	(0043,"",9a)	UN	t	Unknown	d
4854	(0019,"GEMS_ACQU_01",6a)	OB	t	DependantOnNumberOfViewsProcessed	d
1358	(01f1,"ELSCINT1",4b)	SH	t	Unknown	d
4889	(0019,"SIEMENS CT VA0  COAD",b1)	SH	t	Unknown	d
499	(0019,"GEMS_ACQU_01",b7)	DS	t	UserData	d
3179	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
4923	(5001,"ELSCINT1",94)	FL	t	Unknown	d
1424	(0009,"GEMS_PETD_01",32)	SL	t	Lower Reject Limit	d
793	(0009,"GEMS_PETD_01",ec)	SL	t	Unknown	d
3180	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
5999	(0057,"GEMS_VXTLSTATE_001",65)	FL	t	Unknown	d
5974	(0057,"GEMS_VXTLSTATE_001",9a)	FL	t	Unknown	d
4676	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0121)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Beam Limiting Device Rotation Direction	\N
4653	(300a,03a0)[<0>](300a,0053)	DS	f	Ion Tolerance Table Sequence:Table Top Lateral Position Tolerance	\N
474	(0019,"GEMS_ACQU_01",e2)	DS	t	VelocityEncodeScale	k
4609	(300a,03a2)[<0>](300a,0314)[<1>](300a,0316)	IS	f	Ion Beam Sequence:Range Shifter Sequence:Range Shifter Number	\N
5773	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",47)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Aspect Ratio	k
4572	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e5)	SH	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator ID	\N
4633	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00ea)	DS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Position	\N
4616	(300a,03a2)[<0>](300a,00c0)	IS	f	Ion Beam Sequence:Beam Number	\N
4598	(300a,03a2)[<0>](300a,00c2)	LO	f	Ion Beam Sequence:Beam Name	\N
5293	(2001,"Philips Imaging DD 129",00)[<0>](0070,0060)[<1>](0070,0002)	CS	t	Presentation State Sequence:Graphic Layer Sequence:Graphic Layer	na
4662	(300a,03a2)[<0>](300a,00b3)	CS	f	Ion Beam Sequence:Primary Dosimeter Unit	\N
4589	(300a,03a2)[<0>](300a,030c)	SQ	f	Ion Beam Sequence:Snout Sequence	\N
4569	(300a,03a0)[<0>](300a,0043)	SH	f	Ion Tolerance Table Sequence:Tolerance Table Label	\N
4963	(2001,"Philips Imaging DD 001",26)	CS	t	Presentation State Subtraction Active	k
4599	(300a,00b0)[<0>](300a,0107)[<1>](300a,00f9)	LO	f	Beam Sequence:Applicator Sequence:Accessory Code	\N
4663	(300a,03a2)[<0>](300a,0420)[<1>](300a,0423)	CS	f	Ion Beam Sequence:General Accessory Sequence:General Accessory Type	\N
4669	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e1)	CS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Mounting Position	\N
4665	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00f8)	CS	f	Ion Beam Sequence:Ion Block Sequence:Block Type	\N
4643	(300a,03a2)[<0>](300a,010e)	DS	f	Ion Beam Sequence:Final Cumulative Meterset Weight	\N
4579	(300a,03a2)[<0>](300a,03a6)	SQ	f	Ion Beam Sequence:Ion Block Sequence	\N
4678	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0123)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Patient Support Rotation Direction	\N
4564	(300e,0008)	PN	f	Reviewer Name	\N
4722	(300a,0070)[<0>](300c,0004)[<1>](300a,008a)	FL	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Dose Point SSD	\N
4769	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e8)	IS	f	Beam Sequence:Compensator Sequence:Compensator Columns	\N
1346	(0009,"GEMS_PETD_01",a9)	SL	t	other_atts_size	k
487	(0019,"GEMS_ACQU_01",be)	DS	t	ProjectionAngle	k
4732	(300a,0180)[<0>](300a,0410)	SQ	f	Patient Setup Sequence:Motion Synchronization Sequence	\N
4594	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0370)[<2>](300a,0372)	LO	f	Ion Beam Sequence:Ion Control Point Sequence:Lateral Spreading Device Settings Sequence:Lateral Spreading Device Setting	\N
3098	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",82)	OB	t	Unknown:Unknown	d
4654	(300a,03a0)[<0>](300a,0051)	DS	f	Ion Tolerance Table Sequence:Table Top Vertical Position Tolerance	\N
758	(0009,"GEMS_PETD_01",74)	SL	t	validity_info	k
1097	(7005,"TOSHIBA_MEC_CT3",22)	UN	t	Reconstruction Interval	k
3655	(200b,"Philips RAD Imaging DD 097",aa)	SQ	t	Unknown	d
3644	(0011,"GEMS_GDXE_FALCON_04",64)	UN	t	Unknown	d
4630	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00fc)	IS	f	Ion Beam Sequence:Ion Block Sequence:Block Number	\N
4587	(300a,03a0)	SQ	f	Ion Tolerance Table Sequence	\N
4710	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0390)	SH	f	Ion Beam Sequence:Ion Control Point Sequence:Scan Spot Tune ID	\N
4657	(300a,03a0)[<0>](300a,0048)[<1>](300a,00b8)	CS	f	Ion Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence:RT Beam Limiting Device Type	\N
4762	(300a,0010)[<0>](300a,0018)	DS	f	Dose Reference Sequence:Dose Reference Point Coordinates	\N
4660	(300a,03a2)[<0>](300a,00c6)	CS	f	Ion Beam Sequence:Radiation Type	\N
4680	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0370)[<2>](300a,033c)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Lateral Spreading Device Settings Sequence:Lateral Spreading Device Water Equivalent Thickness	\N
4635	(300a,03a0)[<0>](300a,0048)[<1>](300a,004a)	DS	f	Ion Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence:Beam Limiting Device Position Tolerance	\N
4612	(300a,03a2)[<0>](300c,006a)	IS	f	Ion Beam Sequence:Referenced Patient Setup Number	\N
4774	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00eb)	DS	f	Beam Sequence:Compensator Sequence:Compensator Transmission Data	\N
4672	(300a,03a2)[<0>](300a,0332)[<1>](300a,0338)	CS	f	Ion Beam Sequence:Lateral Spreading Device Sequence:Lateral Spreading Device Type	\N
4747	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e8)	FL	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Milling Tool Diameter	\N
4718	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0396)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Scan Spot Meterset Weights	\N
1379	(01f7,"ELSCINT1",75)	OW	t	Unknown	d
4239	(0077,"NIL_nICE_ATT",01)	FL	t	Unknown	d
4693	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e4)	FL	f	Ion Beam Sequence:Ion Range Compensator Sequence:Isocenter to Compensator Tray Distance	\N
4712	(300a,0009)	LO	f	Treatment Protocols	\N
4591	(300a,03a2)[<0>](300a,03a8)	SQ	f	Ion Beam Sequence:Ion Control Point Sequence	\N
4637	(300a,03a2)[<0>](300a,03a8)[<1>](300c,0050)[<2>](300a,010c)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Referenced Dose Reference Sequence:Cumulative Dose Reference Coefficient	\N
6001	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",06)[<1>](0008,1155)	UI	t	Unknown:Unknown:Referenced SOP Instance UID	d
4679	(300a,03a2)[<0>](300a,030a)	FL	f	Ion Beam Sequence:Virtual Source-Axis Distances	\N
4655	(300a,03a2)[<0>](300a,03a8)[<1>](300a,014c)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Gantry Pitch Rotation Direction	\N
4614	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0360)[<2>](300c,0100)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Range Shifter Settings Sequence:Referenced Range Shifter Number	\N
4729	(300a,00b0)[<0>](300a,00ca)[<1>](3002,0026)	DS	f	Beam Sequence:Planned Verification Image Sequence:RT Image SID	\N
4580	(300a,03a2)[<0>](300a,0314)	SQ	f	Ion Beam Sequence:Range Shifter Sequence	\N
4586	(300a,03a2)[<0>](300a,0420)	SQ	f	Ion Beam Sequence:General Accessory Sequence	\N
4573	(300a,03a2)[<0>](300a,0352)	SH	f	Ion Beam Sequence:Patient Support ID	\N
4681	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300a,0384)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Range Modulator Gating Stop Value	\N
4585	(300a,03a0)[<0>](300a,0048)	SQ	f	Ion Tolerance Table Sequence:Beam Limiting Device Tolerance Sequence	\N
4721	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0398)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Scanning Spot Size	\N
4605	(300a,03a2)[<0>](300a,03a6)[<1>](300a,0104)	IS	f	Ion Beam Sequence:Ion Block Sequence:Block Number of Points	\N
4671	(300a,00b0)[<0>](300a,00f4)[<1>](300a,00fb)	CS	f	Beam Sequence:Block Sequence:Block Mounting Position	\N
4777	(300a,0040)[<0>](300a,0050)	FL	f	Tolerance Table Sequence:Table Top Roll Angle Tolerance	\N
4717	(300a,0180)[<0>](300a,01d4)	DS	f	Patient Setup Sequence:Table Top Longitudinal Setup Displacement	\N
4575	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e1)	SH	f	Ion Beam Sequence:Ion Range Compensator Sequence:Material ID	\N
4626	(300a,03a2)[<0>](300a,00d0)	IS	f	Ion Beam Sequence:Number of Wedges	\N
4648	(300a,03a0)[<0>](300a,0044)	DS	f	Ion Tolerance Table Sequence:Gantry Angle Tolerance	\N
4770	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00e7)	IS	f	Beam Sequence:Compensator Sequence:Compensator Rows	\N
4683	(300a,03a0)[<0>](300a,0050)	FL	f	Ion Tolerance Table Sequence:Table Top Roll Angle Tolerance	\N
4776	(300a,00b0)[<0>](300a,00e3)[<1>](300a,00ee)	CS	f	Beam Sequence:Compensator Sequence:Compensator Type	\N
4604	(300a,03a2)[<0>](0008,1090)	LO	f	Ion Beam Sequence:Manufacturer's Model Name	\N
4720	(300a,0070)[<0>](300c,0004)[<1>](300a,0088)	FL	f	Fraction Group Sequence:Referenced Beam Sequence:Beam Dose Point Depth	\N
4640	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00ec)	DS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Thickness Data	\N
4752	(300a,00b0)[<0>](300a,0111)[<1>](300a,014a)	FL	f	Beam Sequence:Control Point Sequence:Gantry Pitch Angle	\N
4651	(300a,03a2)[<0>](300a,02ea)[<1>](300a,00e9)	DS	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Pixel Spacing	\N
4695	(300a,03a2)[<0>](300a,03a8)[<1>](300a,030d)	FL	f	Ion Beam Sequence:Ion Control Point Sequence:Snout Position	\N
4743	(300a,03a2)[<0>](0008,1040)	LO	f	Ion Beam Sequence:Institutional Department Name	\N
4620	(300a,03a2)[<0>](300a,0420)[<1>](300a,0424)	IS	f	Ion Beam Sequence:General Accessory Sequence:General Accessory Number	\N
4588	(300a,03a2)[<0>](300c,0042)	SQ	f	Ion Beam Sequence:Referenced Reference Image Sequence	\N
4702	(300a,03a2)[<0>](300c,0042)[<1>](0008,1155)	UI	f	Ion Beam Sequence:Referenced Reference Image Sequence:Referenced SOP Instance UID	\N
4649	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0122)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Patient Support Angle	\N
4677	(300a,03a2)[<0>](300a,03a8)[<1>](300a,011f)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Gantry Rotation Direction	\N
4668	(300a,03a2)[<0>](300a,0314)[<1>](300a,0320)	CS	f	Ion Beam Sequence:Range Shifter Sequence:Range Shifter Type	\N
4623	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0380)[<2>](300c,0104)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Range Modulator Settings Sequence:Referenced Range Modulator Number	\N
4682	(300a,03a0)[<0>](300a,004b)	FL	f	Ion Tolerance Table Sequence:Snout Position Tolerance	\N
4639	(300a,03a0)[<0>](300a,0046)	DS	f	Ion Tolerance Table Sequence:Beam Limiting Device Angle Tolerance	\N
4627	(300a,03a2)[<0>](300a,00ed)	IS	f	Ion Beam Sequence:Number of Boli	\N
4638	(300a,03a0)[<0>](300a,004c)	DS	f	Ion Tolerance Table Sequence:Patient Support Angle Tolerance	\N
4674	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0146)	CS	f	Ion Beam Sequence:Ion Control Point Sequence:Table Top Roll Rotation Direction	\N
5776	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,0023)	DA	t	Advanced Presentation Sequence:Presentation State Sequence:Content Date	o
5778	(0018,1138)	DS	f	Table Angle	\N
5785	(0018,1320)	FL	f	B1rms	\N
5799	(2005,"Philips MR Imaging DD 006",81)	CS	t	Unknown	d
3957	(0019,"",b7)	UN	t	Unknown	d
4699	(300a,03a2)[<0>](300a,02ea)[<1>](300a,02e7)	FL	f	Ion Beam Sequence:Ion Range Compensator Sequence:Compensator Relative Stopping Power Ratio	\N
4613	(300a,03a2)[<0>](300a,0110)	IS	f	Ion Beam Sequence:Number of Control Points	\N
5255	(2001,"Philips Imaging DD 001",8a)	OB	t	Sampling Percent	k
5995	(0057,"GEMS_VXTLSTATE_001",82)	FL	t	Unknown	d
4714	(300a,03a2)[<0>](300a,03a8)[<1>](300a,039a)	IS	f	Ion Beam Sequence:Ion Control Point Sequence:Number of Paintings	\N
6002	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0020,000e)	UI	t	Unknown:Series Instance UID	d
4715	(300a,0180)[<0>](300a,01d2)	DS	f	Patient Setup Sequence:Table Top Vertical Setup Displacement	\N
5176	(2005,"Philips MR Imaging DD 004",70)	OB	t	Number Mixes Spectro	k
4734	(300a,0180)[<0>](300a,0410)[<1>](0018,9170)	CS	f	Patient Setup Sequence:Motion Synchronization Sequence:Respiratory Motion Compensation Technique	\N
4644	(300a,03a2)[<0>](300a,03a8)[<1>](300a,0114)	DS	f	Ion Beam Sequence:Ion Control Point Sequence:Nominal Beam Energy	\N
4652	(300a,03a2)[<0>](300a,03a6)[<1>](300a,0100)	DS	f	Ion Beam Sequence:Ion Block Sequence:Block Thickness	\N
4778	(300a,0040)[<0>](300a,004f)	FL	f	Tolerance Table Sequence:Table Top Pitch Angle Tolerance	\N
6003	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",06)[<1>](0008,1150)	UI	t	Unknown:Unknown:Referenced SOP Class UID	d
5990	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",92)	FL	t	Unknown:Unknown	d
4567	(300a,03a2)[<0>](300a,00b2)	SH	f	Ion Beam Sequence:Treatment Machine Name	\N
4570	(300a,03a2)[<0>](300a,03a6)[<1>](300a,00f5)	SH	f	Ion Beam Sequence:Ion Block Sequence:Block Tray ID	\N
4565	(300a,03a2)[<0>](300a,0314)[<1>](300a,0318)	SH	f	Ion Beam Sequence:Range Shifter Sequence:Range Shifter ID	\N
5987	(0057,"GEMS_VXTLSTATE_001",61)	FL	t	Unknown	d
5988	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",12)	FL	t	Unknown:Unknown	d
5991	(0057,"GEMS_VXTLSTATE_001",9f)	FL	t	Unknown	d
5989	(0057,"GEMS_VXTLSTATE_001",64)	FL	t	Unknown	d
5994	(0057,"GEMS_VXTLSTATE_001",63)	FL	t	Unknown	d
267	(0043,"GEMS_PARM_01",42)	SL	t	DASTriggerSource	k
5992	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",87)	FL	t	Unknown:Unknown	d
5809	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0020,000e)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:Series Instance UID	h
5993	(0057,"GEMS_VXTLSTATE_001",62)	FL	t	Unknown	d
5986	(0057,"GEMS_VXTLSTATE_001",9e)	FL	t	Unknown	d
326	(0019,"GEMS_ACQU_01",6b)	SS	t	FieldOfViewInDetectorCells	k
740	(0009,"GEMS_PETD_01",d8)	SL	t	frame_number	k
6004	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",08)	DT	t	Unknown:Unknown	d
1271	(0009,"GEIIS",10)[<0>](0028,0010)	US	t	GE Private Image Thumbnail Sequence:Rows	na
5800	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",69)	SQ	t	Presentation State Sequence:Display Shutter	k
5805	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence	k
5803	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",69)[<1>](0018,1600)	CS	t	Presentation State Sequence:Display Shutter:Shutter Shape	k
5085	(2005,"Philips MR Imaging DD 001",5f)	OB	t	StackSequence	k
5210	(2005,"Philips MR Imaging DD 001",1c)	OB	t	Magnetization Transfer Contrast	k
1135	(0009,"GEMS_PETD_01",c9)	LO	t	ovlp_trans_frm_id	d
1156	(0009,"GEMS_PETD_01",c9)	UI	t	ovlp_trans_frm_id	d
2854	(01f3,"ELSCINT1",15)	OB	t	Unknown	d
1428	(0009,"GEMS_IDEN_01",7b)	UN	t	Unknown	d
1289	(0029,"SIEMENS MEDCOM HEADER",40)	SQ	t	ApplicationHeaderSequence	d
3738	(0021,"Siemens: Thorax/Multix FD Post Processing",10)	US	t	Unknown	d
5802	(0018,1620)	IS	f	Vertices of the Polygonal Shutter	\N
3993	(0019,"",19)	UN	t	Unknown	d
3818	(0029,"",20)	UN	t	Unknown	d
3031	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",93)	OB	t	Unknown:Unknown	d
3700	(0021,"Siemens: Thorax/Multix FD Post Processing",06)	FL	t	Unknown	d
6006	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",09)	DT	t	Unknown:Unknown	d
6009	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",69)[<1>](0057,"GEMS_VXTLSTATE_001",70)	LO	t	Unknown:Unknown:Unknown	d
6007	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",07)	DT	t	Unknown:Unknown	d
6010	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",18)	LO	t	Unknown:Unknown:Unknown	d
6005	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",10)	DT	t	Unknown:Unknown	d
782	(0009,"GEMS_PETD_01",80)	SL	t	Multi Patient	k
5230	(2005,"Philips MR Imaging DD 001",2e)	OB	t	PPG PPU Gating	k
5084	(2005,"Philips MR Imaging DD 004",41)	OB	t	Signal Domain Spatial	k
5190	(2005,"Philips MR Imaging DD 004",56)	OB	t	Spectro SI Mode	k
5050	(2005,"Philips MR Imaging DD 001",0c)	OB	t	Min FP	k
5139	(2005,"Philips MR Imaging DD 001",0d)	OB	t	Scale Intercept	k
295	(0029,"GEMS_IMPS_01",0a)	SS	t	LowerRangeOfPixels	k
3108	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",a1)	OB	t	Unknown:Unknown	d
3952	(0021,"",5a)	UN	t	Unknown	d
4165	(0023,"Unnamed Private Block - 20",80)	UN	t	Unknown	d
2895	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0008)[<2>](0008,0100)	SH	t	Unknown:Request Attributes Sequence:Scheduled Protocol Code Sequence:Code Value	d
3116	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",71)	OB	t	Unknown:Unknown	d
1634	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",31)	UN	t	Unknown	d
1126	(0009,"GEMS_PETD_01",08)	SH	t	Exam Compatible Version	k
5211	(2005,"Philips MR Imaging DD 001",17)	OB	t	Fourier Interpolation	k
5156	(2005,"Philips MR Imaging DD 004",55)	OB	t	Spectro SI CS Intervals	k
23	(0013,"CTP",13)	LO	t	Site ID	k
878	(0043,"GEMS_PARM_01",89)	LO	t	Governing Body, dB/dt, and SAR definition	k
526	(0019,"GEMS_ACQU_01",92)	SL	t	SliceOffsetOnFrequencyAxis	k
605	(0009,"GEMS_PETD_01",91)	FL	t	BP Filter Center I	k
597	(0009,"GEMS_PETD_01",d6)	FL	t	image_one_loc	k
5253	(2001,"Philips Imaging DD 001",02)	OB	t	ChemicalShiftNumberMR	k
1129	(0009,"GEMS_PETD_01",a4)	SH	t	compatible_version	k
1025	(7005,"TOSHIBA_MEC_CT3",16)	UI	t	Volume UID	h
237	(0027,"GEMS_IMAG_01",46)	FL	t	NormalACoord	k
5259	(2001,"Philips Imaging DD 001",89)	OB	t	Phase FOV Percent	k
1319	(7053,"Philips PET Private Group",15)	SS	t	Unknown	d
3125	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3979	(0029,"",35)	UN	t	Unknown	d
3998	(0019,"",ba)	UN	t	Unknown	d
2851	(01f3,"ELSCINT1",19)	OB	t	Unknown	d
1522	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",54)	UN	t	Unknown	d
1525	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",33)	UN	t	Unknown	d
338	(0045,"GEMS_HELIOS_01",07)	FL	t	Z smoothing Factor	k
2957	(0019,"FDMS 1.0",91)	OB	t	FilmAnnotationCharacterString2	d
1453	(0009,"GEIIS",39)	UN	t	Unknown	d
6013	(0057,"GEMS_VXTLSTATE_001",14)	LO	t	Unknown	d
6015	(0057,"GEMS_VXTLSTATE_001",36)	LO	t	Unknown	d
1269	(0009,"GEIIS",10)[<0>](0028,0004)	CS	t	GE Private Image Thumbnail Sequence:Photometric Interpretation	na
6012	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",91)	LO	t	Unknown:Unknown	d
5209	(2005,"Philips MR Imaging DD 005",26)	OB	t	Viewing Hardcopy Only	k
356	(0045,"GEMS_HELIOS_01",17)	SS	t	Start View 1B	k
620	(0009,"GEMS_PETD_01",a1)	FL	t	Axial Start	k
746	(0009,"GEMS_PETD_01",7d)	SL	t	Image Set Contents	k
775	(0009,"GEMS_PETD_01",6b)	SL	t	acq_delay	k
752	(0009,"GEMS_PETD_01",21)	SL	t	Count Rate Period	k
5240	(2001,"Philips Imaging DD 001",0e)	OB	t	Cardiac Cycled	k
536	(0053,"GEHC_CT_ADVAPP_001",41)	SH	t	Iterative Recon Mode	k
614	(0009,"GEMS_PETD_01",e6)	FL	t	posterior shift	k
206	(0019,"GEMS_ACQU_01",72)	DS	t	ZChannelAvgOverViews	k
225	(0027,"GEMS_IMAG_01",44)	FL	t	CenterSCoordOfPlaneImage	k
350	(0045,"GEMS_HELIOS_01",04)	SS	t	DAS gain	k
5099	(2001,"Philips Imaging DD 001",1b)	OB	t	PrepulseDelay	k
1028	(7005,"TOSHIBA_MEC_CT3",18)	US	t	Frame Number	k
290	(0019,"GEMS_ACQU_01",25)	SS	t	MidScanFlag	k
1273	(0009,"GEIIS",10)[<0>](0028,0107)	US	t	GE Private Image Thumbnail Sequence:Largest Image Pixel Value	na
1630	(0019,"SIEMENS MR HEADER",0c)	IS	t	B Value	k
71	(0019,"SIEMENS MR HEADER",0c)	OB	t	B Value	k
866	(0009,"GEMS_PETD_01",ba)	SL	t	Post Filter	k
640	(0009,"GEMS_PETD_01",ba)	SS	t	Post Filter	k
671	(0009,"GEMS_PETD_01",97)	LO	t	Trans Scan ID	h
846	(0009,"GEMS_PETD_01",97)	UI	t	Trans Scan ID	h
739	(0009,"GEMS_PETD_01",2b)	SL	t	Scan FOV	k
5256	(2005,"Philips MR Imaging DD 001",22)	OB	t	Number of References	k
315	(0027,"GEMS_IMAG_01",1d)	SS	t	VmaPhase	k
5170	(2001,"Philips Imaging DD 001",f1)	OB	t	Prospective Motion Correction	k
784	(0009,"GEMS_PETD_01",23)	SL	t	Delayed Bias	k
5246	(2005,"Philips MR Imaging DD 001",a9)	OB	t	Geometry Correction	k
306	(0043,"GEMS_PARM_01",4c)	SS	t	TGGCTriggerMode	k
3648	(0011,"GEMS_GDXE_FALCON_04",69)	UN	t	Unknown	d
1535	(0009,"GEMS_IDEN_01",e9)	SL	t	ActualSeriesDataTimeStamp	oi
5155	(2005,"Philips MR Imaging DD 001",33)	OB	t	StackRadialAxis	k
1037	(0053,"GEHC_CT_ADVAPP_001",79)	UN	t	MultiEnergyAcqMethod	k
3032	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3834	(0043,"",82)	UN	t	Unknown	d
3752	(0031,"AGFA EPR PROCEDURE CODE",01)	SH	t	Unknown	d
1490	(0029,"MITRA MARKUP 1.0",02)	OB	t	Markup3	d
3870	(0009,"",27)	UN	t	Unknown	d
613	(0009,"GEMS_PETD_01",e7)	FL	t	superior shift	k
6030	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",38)	LT	t	Unknown:Unknown:Unknown	d
6029	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",86)	LT	t	Unknown:Unknown	d
5264	(2005,"Philips MR Imaging DD 001",a8)	OB	t	Inversion Time	k
5822	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",50)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer PWL TransferFunction Sequence:Renderer Vertex Is Characteristic Flag	k
5182	(2005,"Philips MR Imaging DD 001",3e)	OB	t	RR Intervals Distribution	k
6027	(0057,"GEMS_VXTLSTATE_001",51)	LT	t	Unknown	d
5100	(2005,"Philips MR Imaging DD 005",40)	OB	t	Active Implantable Medical Device Head SAR Limit	k
5247	(2005,"Philips MR Imaging DD 001",04)	OB	t	Image Display Orientation	k
742	(0009,"GEMS_PETD_01",50)	SL	t	Lower Coinc Limit	k
285	(0043,"GEMS_PARM_01",2b)	SS	t	PrivateScanOptions	k
5287	(2005,"Philips MR Imaging DD 004",93)	OB	t	Station Number	k
209	(0029,"GEMS_IMPS_01",06)	DS	t	LowerRangeOfPixels	k
1693	(0019,"SIEMENS MR HEADER",17)	DS	t	Slice Resolution	k
1255	(0009,"GEIIS",10)[<0>](0029,"GEIIS",10)	UL	t	GE Private Image Thumbnail Sequence:Shift Count	na
58	(0019,"SIEMENS MR HEADER",17)	OB	t	Slice Resolution	k
5236	(2001,"Philips Imaging DD 001",0c)	OB	t	Arrhythmia Rejection	k
5102	(2001,"Philips Imaging DD 001",09)	OB	t	Image Prepulse Delay	k
374	(0053,"GEHC_CT_ADVAPP_001",65)	UN	t	Shutter Mode Percent	k
537	(0053,"GEHC_CT_ADVAPP_001",42)	LO	t	Iterative Recon Configuration	k
324	(0021,"GEMS_RELA_01",90)	SS	t	TubeFocalSpotPosition	k
759	(0009,"GEMS_PETD_01",54)	SL	t	Upper Energy Limit	k
1030	(7005,"TOSHIBA_MEC_CT3",17)	US	t	Total Frame Count in the Volume	k
258	(0019,"GEMS_ACQU_01",61)	SL	t	NumberOfViews	k
432	(0019,"GEMS_ACQU_01",d8)	SS	t	VariableEchoFlag	k
5825	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",7c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Unknown	d
3083	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",95)	OB	t	Unknown:Unknown	d
5817	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",58)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer PWL TransferFunction Sequence:Renderer PWL Vertex Index	k
5106	(2005,"Philips MR Imaging DD 001",21)	OB	t	Number of Mixes	k
5820	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer Directional Light Usage Flag	k
5815	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",59)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer PWL TransferFunction Sequence:Renderer PWL Vertex Color	k
5819	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",55)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer DirectionalLight Direction	k
4030	(0029,"",12)	CS	t	Unknown	d
3669	(200b,"Philips RAD Imaging DD 099",37)	UN	t	Unknown	d
3949	(0025,"",1a)	UN	t	Unknown	d
5814	(0018,1511)	DS	f	Positioner Secondary Angle	\N
1388	(01f1,"ELSCINT1",44)	OW	t	Unknown	d
2828	(01f1,"ELSCINT1",44)	OB	t	Unknown	d
6017	(0057,"GEMS_VXTLSTATE_001",33)	LO	t	Unknown	d
1040	(0053,"GEHC_CT_ADVAPP_001",8d)	UN	t	MonoWindowLow	k
341	(0045,"GEMS_HELIOS_01",0a)	FL	t	Minimum DAS value	k
6020	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",20)	LO	t	Unknown:Unknown:Unknown	d
6032	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0028,0051)	CS	t	Unknown:Corrected Image	d
6035	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",a5)	FD	t	Unknown:Unknown	d
6023	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",06)[<1>](0057,"GEMS_VXTLSTATE_001",90)	LT	t	Unknown:Unknown:Unknown	d
5165	(2005,"Philips MR Imaging DD 004",60)	OB	t	Spectro Vertical Shift	k
6031	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",17)	OW	t	Unknown:Unknown:Unknown	d
6036	(0029,"INTELERAD MEDICAL SYSTEMS",26)	DS	t	Unknown	d
6018	(0057,"GEMS_VXTLSTATE_001",35)	LO	t	Unknown	d
6016	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",60)	LO	t	Unknown:Unknown:Unknown	d
6033	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0054,1001)	CS	t	Unknown:Units	d
6019	(0057,"GEMS_VXTLSTATE_001",34)	LO	t	Unknown	d
6021	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0010,1020)	DS	t	Unknown:Patient's Size	d
1651	(07a3,"ELSCINT1",03)	CS	t	Unknown	d
3739	(0021,"Siemens: Thorax/Multix FD Post Processing",17)	US	t	System Type	d
2978	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",84)	OB	t	Unknown:Unknown	d
1661	(07a3,"ELSCINT1",34)	SH	t	Unknown	d
3640	(0011,"GEMS_GDXE_FALCON_04",7e)	UN	t	Unknown	d
2132	(0009,"GEMS_GENIE_1",40)	PN	t	Unknown	d
2938	(0023,"FDMS 1.0",30)	SQ	t	Unknown	d
3642	(0011,"GEMS_GDXE_FALCON_04",7d)	UN	t	Unknown	d
6022	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0010,1030)	DS	t	Unknown:Patient's Weight	d
6034	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0010,0040)	CS	t	Unknown:Patient's Sex	d
331	(0043,"GEMS_PARM_01",64)	CS	t	Image Filter	k
753	(0009,"GEMS_PETD_01",1a)	SL	t	Start Condition	k
394	(0027,"GEMS_IMAG_01",61)	FL	t	ImageDimensionY	k
1038	(0053,"GEHC_CT_ADVAPP_001",86)	UN	t	CommandedSecondkVp	k
670	(0009,"GEMS_PETD_01",6c)	LO	t	acq_start	o
855	(0009,"GEMS_PETD_01",6c)	DT	t	acq_start	o
265	(0043,"GEMS_PARM_01",4b)	SL	t	DASXmPattern	k
4960	(2005,"Philips MR Imaging DD 003",57)	SS	t	Number of Running Attributes	k
269	(0043,"GEMS_PARM_01",49)	SL	t	DASAutoZero	k
1039	(0053,"GEHC_CT_ADVAPP_001",89)	UN	t	MultiEnergyKVUnitLabel	k
716	(0009,"GEMS_PETD_01",7f)	DS	t	Image Set Reference	k
626	(0009,"GEMS_PETD_01",c6)	FL	t	seg_qc_parm	k
1395	(0903,"GEIIS PACS",11)	US	t	Significant Flag	k
400	(0043,"GEMS_PARM_01",32)	SS	t	RawDataType	k
500	(0021,"GEMS_RELA_01",5f)	DS	t	FloatSlop	k
5079	(2005,"Philips MR Imaging DD 005",19)	OB	t	Operating Mode	k
5090	(2005,"Philips MR Imaging DD 001",14)	OB	t	Diffusion	k
5291	(2001,"Philips Imaging DD 129",00)[<0>](0070,0060)[<1>](0070,0062)	IS	t	Presentation State Sequence:Graphic Layer Sequence:Graphic Layer Order	na
3072	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",70)	OB	t	Unknown:Unknown	d
1580	(0047,"GEMS_3DSTATE_001",ed)	CS	t	Unknown	d
1105	(0029,"SIEMENS MEDCOM HEADER",32)	UL	t	PMTFInformation2	d
4045	(0033,"",13)	PN	t	Unknown	d
3815	(0033,"",13)	UN	t	Unknown	d
4971	(2005,"Philips MR Imaging DD 001",83)		t	Unknown	d
5064	(2005,"Philips MR Imaging DD 001",83)	OB	t	Unknown	d
3131	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",60)	OB	t	Unknown:Unknown	d
458	(0043,"GEMS_PARM_01",61)	LO	t	Unknown	d
6211	(0071,"Unnamed Private Block - 60",20)	UN	t	Unknown	d
1251	(0009,"GEMS_PETD_01",e0)	US	t	num_of_time_slices	k
6080	(0037,"MAROTECH Inc.",23)	OB	t	Unknown	d
6213	(3109,"Unnamed Private Block - 10",08)	UN	t	Unknown	d
6189	(0033,"SIEMENS MED NM",19)	FL	t	NCO Data for detector 2	k
6170	(0011,"GEMS_PETD_01",01)[<0>](0008,0005)	CS	t	Unknown:Specific Character Set	d
6047	(07a1,"ELSCINT1",4a)	SH	t	Unknown	d
6081	(0037,"MAROTECH Inc.",22)	US	t	Unknown	d
6083	(0097,"SIENET",03)	SL	t	Unknown	d
6168	(0013,"GEMS_PETD_01",01)[<0>](0008,0005)	CS	t	Unknown:Specific Character Set	d
6106	(0045,"GEMS_SENO_02",67)	DS	t	Unknown	d
6107	(0045,"GEMS_SENO_02",73)	DS	t	Unknown	d
6092	(0045,"GEMS_SENO_02",69)	IS	t	Unknown	d
6100	(0045,"GEMS_SENO_02",70)	DS	t	Unknown	d
6096	(0045,"GEMS_SENO_02",74)	UI	t	Unknown	d
6210	(0071,"Unnamed Private Block - 60",10)	UN	t	Unknown	d
6209	(0071,"Unnamed Private Block - 60",30)	UN	t	Unknown	d
6045	(0009,"MORPHING REPLAY INFO",00)	SQ	t	Unknown	d
6039	(07a1,"ELSCINT1",d9)	LO	t	Unknown	d
6046	(0009,"MORPHING REPLAY INFO",00)[<0>](0009,"MORPHING REPLAY INFO",00)	UN	t	Unknown:Unknown	d
6040	(07a1,"ELSCINT1",de)	DT	t	Unknown	d
6123	(0033,"SIEMENS MED NM",31)	FL	t	Camera Config Angle	k
6055	(7005,"TOSHIBA_MEC_CT3",13)	OB	t	Expert Plan Number	d
6192	(0033,"SIEMENS MED NM",22)	SS	t	Bed U/D correction data	k
6191	(0033,"SIEMENS MED NM",15)	FL	t	MHR ( Y-Shift) data for detector 2	k
6159	(0091,"SIENET",20)	PN	t	RIS Patient Name	d
6089	(0045,"GEMS_SENO_02",63)	IS	t	User Window Width	k
6095	(0045,"GEMS_SENO_02",26)	OB	t	MAOBuffer	k
6127	(0055,"SIEMENS MED NM",c0)	SS	t	Useful Field of View	k
6205	(0033,"SIEMENS MED NM",37)	SL	t	Starburst flags at image acq time	k
6090	(0045,"GEMS_SENO_02",65)	IS	t	Detector Entrance Dose	k
6153	(0043,"SIEMENS MED NM",02)	FD	t	Transformation Matrix	k
6185	(0033,"SIEMENS MED NM",10)	FL	t	COR Data for Detector 1	k
6053	(7005,"TOSHIBA_MEC_CT3",09)	OB	t	Number of Detector rows to Reconstruct	k
6154	(0041,"SIEMENS MED NM",0a)	FD	t	Original Wholebody Position	k
6056	(7005,"TOSHIBA_MEC_CT3",1e)	OB	t	Raw Data Number	k
6198	(0041,"SIEMENS MED NM",05)	FD	t	Long Linear Drive Information for Detector 1	k
6186	(0033,"SIEMENS MED NM",24)	FL	t	BackProjection Correction angle head 1	k
6108	(0045,"GEMS_SENO_02",72)	DS	t	Image Crop Point	k
6158	(0019,"SIEMENS MED NM",0f)	SL	t	Siemens ICON Data Type	k
6112	(0045,"GEMS_SENO_02",1b)	CS	t	Clinical View	k
2951	(0009,"FDMS 1.0",80)	OB	t	KanjiHospitalName	d
4155	(5653,"Vital Images SW 3.4",15)[<0>](0020,0037)	DS	t	Image Sequence:Image Orientation (Patient)	d
4026	(0023,"GEMS_STDY_01",80)[<0>](0032,1064)[<1>](0008,0104)	LO	t	Has MPPS Related Tags:Requested Procedure Code Sequence:Code Meaning	d
6310	(0009,"GEMS_GENIE_1",27)	SL	t	NumberDetectors	k
6306	(0011,"GEMS_GENIE_1",17)	SL	t	RRIntervalWindowNumber	k
6282	(0055,"GEMS_GENIE_1",22)[<0>](0013,"GEMS_GENIE_1",1a)	FD	t	eNTEGRA Detector Information Sequence:CopperAttenuatorThickness	k
794	(0009,"GEMS_PETD_01",7c)	SL	t	Image Set Source	k
6216	(0019,"Array DICOM private elements version1.0",11)	UN	t	Unknown	d
6222	(0019,"Array DICOM private elements version1.0",17)	UN	t	Unknown	d
6224	(0019,"Array DICOM private elements version1.0",10)	UN	t	Unknown	d
6214	(3109,"Unnamed Private Block - 10",09)	UN	t	Unknown	d
6246	(0055,"GEMS_GENIE_1",65)	SQ	t	Unknown	d
6236	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0a)	OB	t	Unknown	d
6309	(0009,"GEMS_GENIE_1",2a)	SL	t	Unknown	d
6286	(0055,"GEMS_GENIE_1",65)[<0>](0013,"GEMS_GENIE_1",14)	SL	t	Unknown:Original Image Number	d
6220	(0019,"Array DICOM private elements version1.0",16)	UN	t	Unknown	d
6241	(0019,"SIEMENS MED NM",16)	SS	t	Unknown	d
6219	(0019,"Array DICOM private elements version1.0",12)	UN	t	Unknown	d
6226	(0019,"Array DICOM private elements version1.0",13)	UN	t	Unknown	d
6239	(0009,"eMed Compression Tags",10)	UN	t	Unknown	d
6324	(004b,"GEIIS",13)	IS	t	Unknown	d
6302	(0013,"GEMS_GENIE_1",12)	SL	t	Unknown	d
6215	(3109,"Unnamed Private Block - 10",0b)	UN	t	Unknown	d
6240	(0009,"eMed Compression Tags",11)	UN	t	Unknown	d
6225	(00ff,"Array DICOM private elements version1.0",ff)	UN	t	Unknown	d
6247	(0019,"GEMS_GENIE_1",5f)	SQ	t	Unknown	d
6223	(0019,"Array DICOM private elements version1.0",14)	UN	t	Unknown	d
6303	(0009,"GEMS_GENIE_1",29)	SL	t	Unknown	d
6218	(0019,"Array DICOM private elements version1.0",15)	UN	t	Unknown	d
6255	(0011,"GEMS_GENIE_1",30)	LO	t	Unknown	d
6238	(0013,"GEMS_GENIE_1",11)	SL	t	Unknown	d
6244	(0055,"GEMS_GENIE_1",12)	SQ	t	eNTEGRA Energy Window Information Sequence	k
6295	(0055,"GEMS_GENIE_1",12)[<0>](0055,"GEMS_GENIE_1",13)[<1>](0013,"GEMS_GENIE_1",17)	SL	t	eNTEGRA Energy Window Information Sequence:eNTEGRA Energy Window Range Sequence:AutoTrackWidth	k
6235	(4453,"DR Systems, Inc.",02)	UN	t	Image Type	k
6258	(0011,"GEMS_GENIE_1",33)	LO	t	EnergyCorrectName	k
6289	(0009,"GEMS_GENIE_1",25)	SL	t	InitiationCountRate	k
6307	(0009,"GEMS_GENIE_1",2f)	SL	t	Table Direction	k
6300	(0009,"GEMS_GENIE_1",24)	SL	t	InitiationDelay	k
6284	(0011,"GEMS_GENIE_1",38)	SL	t	ByteOrder	k
6251	(0009,"GEMS_GENIE_1",2c)	LO	t	SeriesComments	d
6270	(0011,"GEMS_GENIE_1",3b)	FD	t	PixelScale	k
6234	(4453,"DR Systems, Inc.",04)	UN	t	File Type	k
6298	(0009,"GEMS_GENIE_1",23)	SL	t	InitiationType	k
6231	(0009,"GEIIS",10)[<0>](0028,0008)	IS	t	GE Private Image Thumbnail Sequence:Number of Frames	k
6243	(0055,"GEMS_GENIE_1",12)[<0>](0055,"GEMS_GENIE_1",13)	SQ	t	eNTEGRA Energy Window Information Sequence:eNTEGRA Energy Window Range Sequence	k
6283	(0011,"GEMS_GENIE_1",42)	FD	t	Rotation Angle	k
6294	(0055,"GEMS_GENIE_1",22)[<0>](0011,"GEMS_GENIE_1",23)	SL	t	eNTEGRA Detector Information Sequence:UseFOVMask	k
6260	(0011,"GEMS_GENIE_1",35)	LO	t	TuningCalibName	k
6299	(0011,"GEMS_GENIE_1",43)	SL	t	Window Inverse Flag	k
6261	(0011,"GEMS_GENIE_1",40)	LO	t	Viewing Object Name	k
1480	(0009,"Unnamed Private Block - 10",0e)	UN	t	Unknown	d
6329	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1110)[<1>](0008,1150)	UI	t	CTVESequence:Referenced Study Sequence:Referenced SOP Class UID	k
6366	(0029,"FDMS 1.0",30)	CS	t	ExtendedReadingSizeValue	k
6393	(0019,"SIEMENS CT VA0  COAD",21)	IS	t	MeanChannelNumber	k
339	(0045,"GEMS_HELIOS_01",0e)	FL	t	Mean Z error	k
1117	(0009,"GEMS_PETD_01",0b)	SH	t	Scan Compatible Version	k
6383	(0021,"SIEMENS CT VA0  RAW",40)	UL	t	Unknown	d
6382	(0019,"SIEMENS CT VA0  GEN",44)	UL	t	Unknown	d
6346	(0065,"ISG Image",11)	UN	t	Unknown	d
6381	(0019,"SIEMENS CT VA0  COAD",a6)	UL	t	Unknown	d
6340	(0029,"Silhouette VRS 3.0",36)	US	t	Unknown	d
6343	(0029,"Silhouette VRS 3.0",37)	UN	t	Unknown	d
6385	(0019,"SIEMENS CT VA0  COAD",a8)	UL	t	Unknown	d
6390	(0021,"SIEMENS CT VA0  RAW",42)	UL	t	Unknown	d
6380	(0019,"SIEMENS CT VA0  GEN",45)	UL	t	Unknown	d
6388	(0019,"SIEMENS CT VA0  COAD",a7)	UL	t	Unknown	d
6392	(0019,"SIEMENS CT VA0  COAD",c4)	UL	t	Unknown	d
6391	(0021,"SIEMENS CT VA0  RAW",41)	UL	t	Unknown	d
6345	(0065,"Viewing Protocol",99)	UN	t	Unknown	d
6342	(0029,"Silhouette VRS 3.0",34)	UN	t	Unknown	d
6359	(0009,"FDMS 1.0",06)	OW	t	RouteImage UID	h
6322	(0011,"GEMS_GENIE_1",3a)	SL	t	PictureFormat	k
6360	(0009,"FDMS 1.0",0c)	OW	t	Film UID	h
6351	(0009,"FDMS 1.0",04)	SH	t	ImageControlUnit	d
6372	(0021,"FDMS 1.0",50)	CS	t	PairProcessingInformation	k
6313	(0011,"GEMS_GENIE_1",11)	SL	t	Dataset Modified	k
6361	(0009,"FDMS 1.0",05)	OW	t	ImageUID	h
6330	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1032)[<1>](0008,0102)	SH	t	CTVESequence:Procedure Code Sequence:Coding Scheme Designator	k
6315	(0011,"GEMS_GENIE_1",2e)	SL	t	Pixel Overflow Flag	k
6320	(0011,"GEMS_GENIE_1",41)	SL	t	Orientation Angle	k
6371	(0019,"FDMS 1.0",40)	CS	t	ImageProcessingType	k
6332	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1032)[<1>](0008,0104)	LO	t	CTVESequence:Procedure Code Sequence:Code Meaning	k
6321	(0011,"GEMS_GENIE_1",0c)	SL	t	NumBeats	k
6376	(0025,"FDMS 1.0",10)	US	t	RelativeLightEmissionAmountSk	k
6384	(0021,"SIEMENS CT VA0  RAW",20)	UL	t	EvaluationMask	k
6317	(0011,"GEMS_GENIE_1",26)	SL	t	TableOrientation	k
6326	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1110)	SQ	t	CTVESequence:Referenced Study Sequence	k
6358	(0021,"FDMS 1.0",40)	IS	t	ImageNoInTheSet	k
6327	(0051,"GEMS_CT_VES_01",01)[<0>](0008,1032)	SQ	t	CTVESequence:Procedure Code Sequence	k
6379	(0029,"FDMS 1.0",34)	US	t	MagnificationReductionRatio	k
6369	(0029,"FDMS 1.0",20)	CS	t	ImageScanningDirection	k
6356	(0019,"FDMS 1.0",15)	LO	t	KanjiBodyPartForExposure	d
5833	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8c)	FL	t	Unknown	d
6398	(0019,"SIEMENS CT VA0  COAD",c5)	IS	t	Unknown	d
6399	(0019,"SIEMENS CT VA0  COAD",ae)	IS	t	Unknown	d
6402	(0021,"SIEMENS CT VA0  GEN",a0)	IS	t	Unknown	d
6440	(0019,"SIEMENS CT VA0  COAD",a5)	DS	t	Unknown	d
6400	(0019,"SIEMENS CT VA0  GEN",88)	IS	t	Unknown	d
5829	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",54)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer DirectionalLight Color	k
6412	(0019,"SIEMENS CT VA0  GEN",75)	IS	t	NumberOfBytes	k
6407	(0019,"SIEMENS CT VA0  COAD",ac)	IS	t	Unknown	d
6409	(0019,"SIEMENS CT VA0  COAD",ad)	IS	t	Unknown	d
6408	(0019,"SIEMENS CT VA0  COAD",ab)	IS	t	Unknown	d
6413	(0019,"SIEMENS CT VA0  COAD",a9)	IS	t	Unknown	d
6403	(0019,"SIEMENS CT VA0  GEN",70)	IS	t	NumberOfReadings	k
6411	(0021,"SIEMENS CT VA0  GEN",10)	IS	t	RotationAngle	k
6441	(0021,"SIEMENS CM VA0  CMS",20)	DS	t	FoV	k
6395	(0011,"SIEMENS CM VA0  CMS",40)	IS	t	OrganCode	k
6444	(0021,"SIEMENS CT VA0  GEN",32)	DS	t	LengthOfTopogram	k
6396	(0019,"SIEMENS CT VA0  GEN",74)	IS	t	NumberOfProjections	k
6405	(0019,"SIEMENS CT VA0  COAD",20)	IS	t	NumberOfPossibleChannels	k
6406	(0019,"SIEMENS CT VA0  GEN",62)	IS	t	NumberOfVirtuellChannels	k
6442	(0019,"SIEMENS CT VA0  COAD",23)	DS	t	DetectorCenter	k
5835	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",28)	FL	t	Unknown	d
5843	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",55)	SS	t	Unknown	d
5842	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",20)	SS	t	Unknown	d
5844	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4d)	SS	t	Unknown	d
5837	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8d)	FL	t	Unknown	d
5839	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",53)	SS	t	Unknown	d
5834	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",29)	FL	t	Unknown	d
5838	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",54)	SS	t	Unknown	d
5840	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",52)	SS	t	Unknown	d
5845	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",49)	SS	t	Unknown	d
5836	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0d)	FL	t	Unknown	d
5832	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",51)	FL	t	Unknown	d
1649	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",58)	UN	t	Unknown	d
3849	(0043,"",62)	UN	t	Unknown	d
2142	(0011,"GEMS_GENIE_1",3f)	SL	t	DatasetFlags	d
1354	(01f1,"ELSCINT1",42)	SH	t	Unknown	d
2838	(01f1,"ELSCINT1",42)	OB	t	Unknown	d
3892	(0043,"",0a)	UN	t	Unknown	d
1380	(01f7,"ELSCINT1",1f)	OW	t	Unknown	d
2818	(01f7,"ELSCINT1",1f)	OB	t	Unknown	d
6446	(0021,"SIEMENS CM VA0  CMS",24)	DS	t	ImageScrollOffset	k
6445	(0021,"SIEMENS CM VA0  CMS",61)	DS	t	ImageNormal	k
6397	(0019,"SIEMENS CT VA0  GEN",21)	IS	t	ExposureCurrent	k
6447	(0021,"SIEMENS CM VA0  CMS",6b)	DS	t	ImageColumn	k
6415	(0019,"SIEMENS CT VA0  COAD",10)	IS	t	DistanceSourceToSourceSideCollimator	k
6401	(0019,"SIEMENS CT VA0  COAD",11)	IS	t	DistanceSourceToDetectorSideCollimator	k
6414	(0021,"SIEMENS CM VA0  CMS",26)	IS	t	ImagePixelOffset	k
6443	(0021,"SIEMENS CM VA0  CMS",6a)	DS	t	ImageRow	k
6404	(0019,"SIEMENS CM VA0  CMS",10)	IS	t	NetFrequency	k
6410	(0019,"SIEMENS CT VA0  COAD",94)	IS	t	OsteoStandardizationCode	k
297	(0019,"GEMS_ACQU_01",40)	SS	t	StatReconFlag	k
223	(0027,"GEMS_IMAG_01",4a)	FL	t	SCoordOfTopRightCorner	k
344	(0045,"GEMS_HELIOS_01",32)	FL	t	TemporalResolution	k
407	(0019,"GEMS_ACQU_01",9f)	SS	t	TransmittingCoil	k
6486	(0009,"SIEMENS CT VA0  IDE",50)	DA	t	Unknown	d
6493	(0023,"AMICAS0",16)	UN	t	Unknown	d
6432	(0009,"SIEMENS CT VA0  IDE",40)	LO	t	Unknown	d
6424	(0021,"SIEMENS CT VA0  GEN",a7)	LO	t	Unknown	d
6497	(01f1,"ELSCINT1",45)	IS	t	Unknown	d
6500	(00e1,"ELSCINT1",41)	DS	t	Unknown	d
6485	(0009,"SIEMENS CM VA0  CMS",26)	DA	t	LastMoveDate	d
6460	(0019,"SIEMENS CT VA0  COAD",82)	CS	t	PatientPhaseOfLife	k
6484	(0011,"SIEMENS CM VA0  CMS",10)	DA	t	RegistrationDate	d
6434	(0009,"SIEMENS CM VA0  LAB",14)	LO	t	DASIdentificationLabel	d
6457	(0029,"SIEMENS CM VA0  CMS",53)	CS	t	Unknown	d
6494	(0023,"AMICAS0",19)	UN	t	Unknown	d
6462	(0029,"SIEMENS CM VA0  CMS",13)	CS	t	Unknown	d
6435	(0009,"SIEMENS CT VA0  IDE",42)	LO	t	Unknown	d
6425	(0009,"SIEMENS CM VA0  LAB",12)	LO	t	X-RayTubeIdentificationLabel	d
6450	(0019,"SIEMENS CT VA0  COAD",22)	DS	t	DetectorSpacing	k
6430	(0009,"SIEMENS CM VA0  LAB",16)	LO	t	CPUIdentificationLabel	d
6459	(0029,"SIEMENS CM VA0  CMS",51)	CS	t	ExposureCode	k
6421	(0009,"SIEMENS CM VA0  LAB",20)	SH	t	HeaderVersion	k
6427	(0029,"SIEMENS MED MG",50)	LO	t	ListOfDisplayPostfix	k
6436	(0009,"SIEMENS CM VA0  LAB",15)	LO	t	SMIIdentificationLabel	k
6437	(0021,"SIEMENS CM VA0  CMS",60)	DS	t	ImagePosition	k
6454	(0021,"SIEMENS CM VA0  CMS",22)	DS	t	ImageMagnificationFactor	k
6448	(0019,"SIEMENS CT VA0  COAD",24)	DS	t	ReadingIntegrationTime	k
6416	(0019,"SIEMENS CT VA0  GEN",20)	IS	t	ExposureTime	k
6426	(0029,"SIEMENS MED MG",40)	LO	t	ListOfDisplayPrefix	k
6456	(0021,"SIEMENS MED",10)	DS	t	Zoom	k
6429	(0009,"SIEMENS CM VA0  LAB",10)	LO	t	GeneratorIdentificationLabel	k
6438	(0021,"SIEMENS CM VA0  CMS",63)	DS	t	ImageDistance	k
6428	(0029,"SIEMENS MED MG",15)	LO	t	ListOfShadowOwnerCodes	k
6464	(0019,"SIEMENS CT VA0  COAD",80)	CS	t	PatientRegion	k
6463	(0021,"SIEMENS CM VA0  CMS",70)	CS	t	PatientOrientationSet1	k
886	(0043,"GEMS_PARM_01",91)	DS	t	SAR Value	k
238	(0027,"GEMS_IMAG_01",43)	FL	t	CenterACoordOfPlaneImage	k
239	(0027,"GEMS_IMAG_01",51)	FL	t	TableEndLocation	k
737	(0009,"GEMS_PETD_01",a6)	SL	t	slice_number	k
6504	(6001,"ELSCINT1",10)	UN	t	Unknown	d
6453	(0019,"SIEMENS CT VA0  COAD",54)	DS	t	Unknown	d
6420	(0009,"SIEMENS CT VA0  IDE",32)	SH	t	Unknown	d
6490	(0023,"AMICAS0",10)	UN	t	Unknown	d
6505	(6003,"ELSCINT1",10)	UN	t	Unknown	d
6492	(0023,"AMICAS0",08)	UN	t	Unknown	d
6449	(0019,"SIEMENS CT VA0  COAD",52)	DS	t	Unknown	d
6452	(0019,"SIEMENS CT VA0  COAD",a0)	DS	t	Unknown	d
289	(0019,"GEMS_ACQU_01",dd)	SS	t	OverrangeCorrectionUsed	k
6431	(0009,"SIEMENS CT VA0  IDE",10)	LO	t	Unknown	d
5849	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0c)	SS	t	Unknown	d
5848	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1f)	SS	t	Unknown	d
5846	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0a)	SS	t	Unknown	d
2896	(00e1,"ELSCINT1",39)[<0>](0008,1032)[<1>](0008,0100)	SH	t	Unknown:Procedure Code Sequence:Code Value	d
2830	(01f7,"ELSCINT1",74)	OB	t	Unknown	d
3111	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",34)	OB	t	Unknown:Unknown	d
3113	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",72)	OB	t	Unknown:Unknown	d
3022	(0029,"FDMS 1.0",50)	OB	t	DataCompressionCode	d
3000	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
6461	(0019,"SIEMENS CT VA0  COAD",a3)	CS	t	Unknown	d
6439	(0019,"SIEMENS CT VA0  COAD",a1)	DS	t	Unknown	d
6451	(0019,"SIEMENS CT VA0  COAD",a4)	DS	t	Unknown	d
6496	(0023,"AMICAS0",43)	UN	t	Unknown	d
6455	(0019,"SIEMENS CT VA0  COAD",af)	DS	t	Unknown	d
6502	(00e1,"ELSCINT1",60)	CS	t	Unknown	d
6510	(01f7,"ELSCINT1",2e)	OW	t	Unknown	d
6011	(0057,"GEMS_VXTLSTATE_001",77)	LO	t	Unknown	d
6025	(0057,"GEMS_VXTLSTATE_001",26)[<0>](0057,"GEMS_VXTLSTATE_001",27)	LT	t	Unknown:Unknown	d
6000	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",93)	FL	t	Unknown:Unknown:Unknown	d
6058	(0051,"GEMS_CT_VES_01",01)	OB	t	CTVESequence	d
5878	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1c)	US	t	Image Crop Lower Left	k
5858	(0021,"Siemens: Thorax/Multix FD Post Processing",15)	UN	t	Auto Window Shift	k
5866	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1b)	US	t	Image Crop Upper Right	k
5865	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1d)	US	t	Image Crop Lower Right	k
298	(0021,"GEMS_RELA_01",91)	SS	t	BiopsyPosition	k
5267	(2001,"Philips Imaging DD 001",87)	OB	t	Imaged Nucleus	k
1125	(0009,"GEMS_PETD_01",a5)	SH	t	software_version	k
619	(0009,"GEMS_PETD_01",c5)	FL	t	Scatter Parm	k
666	(0009,"GEMS_PETD_01",5d)	LO	t	scan_id	h
841	(0009,"GEMS_PETD_01",5d)	UI	t	scan_id	h
5873	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1b)	US	t	Unknown	d
5864	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",26)	US	t	Unknown	d
5881	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",25)	US	t	Unknown	d
5882	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",66)	US	t	Unknown	d
5870	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",17)	US	t	Unknown	d
5871	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",89)	US	t	Unknown	d
5853	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4f)	LO	t	Unknown	d
5883	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8b)	US	t	Unknown	d
5875	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",23)	US	t	Unknown	d
5868	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",86)	US	t	Unknown	d
6149	(0054,0012)[<0>](0054,0013)[<1>](0054,0014)	DS	f	Energy Window Information Sequence:Energy Window Range Sequence:Energy Window Lower Limit	\N
6148	(0054,0012)[<0>](0054,0013)[<1>](0054,0015)	DS	f	Energy Window Information Sequence:Energy Window Range Sequence:Energy Window Upper Limit	\N
5880	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",16)	US	t	Unknown	d
4132	(5653,"",18)	UN	t	Unknown	d
5856	(0018,115a)	CS	f	Radiation Mode	\N
5855	(0018,1155)	CS	f	Radiation Setting	\N
6111	(0045,"GEMS_SENO_02",68)	CS	t	Unknown	d
6008	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",15)[<1>](0057,"GEMS_VXTLSTATE_001",58)	LO	t	Unknown:Unknown:Unknown	d
6190	(0033,"SIEMENS MED NM",14)	FL	t	MHR ( Y-Shift) data for detector 1	k
6245	(0055,"GEMS_GENIE_1",22)	SQ	t	eNTEGRA Detector Information Sequence	k
6109	(0045,"GEMS_SENO_02",54)	DS	t	Exponent	k
6051	(7005,"TOSHIBA_MEC_CT3",0f)	OB	t	Direction (head or feet first)	k
2781	(0053,"GEHC_CT_ADVAPP_001",63)	UN	t	Image Position Patient Setting	k
5713	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8b)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Surface Normal	k
5670	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Image Minimum Height	k
5874	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",1a)	US	t	Image Crop Upper Left	k
5604	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence	k
5775	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0070,0052)	SL	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Top Left Hand Corner	k
872	(0009,"GEMS_PETD_01",b6)	SL	t	IR Loop Filter	k
6052	(7005,"TOSHIBA_MEC_CT3",24)	OB	t	AcquisitionDateOfNRA	o
5583	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0008,114b)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Referenced Real World Value Mapping Instance Sequence	k
5807	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer PWL TransferFunction Sequence	k
5761	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",20)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Index Navigation Current Index	k
5622	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0008,1140)[<3>](0008,1150)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Referenced Image Sequence:Referenced SOP Class UID	k
5827	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)[<4>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",58)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer PWL TransferFunction Sequence:Renderer PWL Vertex Index	k
5664	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0009,"SIEMENS SYNGO INDEX SERVICE",50)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Hidden Instance	k
5891	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8f)	US	t	Unknown	d
5885	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1e)	US	t	Unknown	d
5892	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1a)	US	t	Unknown	d
3661	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](0008,1140)[<2>](2001,"Philips Imaging DD 001",c1)	LO	t	Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence:Linear Modality GL Transform	d
4344	(07a3,"ELSCINT1",4d)	ST	t	Unknown	d
4965	(2001,"Philips Imaging DD 001",67)	CS	t	Linear Presentation GL Transform Shape Sub	d
2998	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
6024	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",21)[<1>](0057,"GEMS_VXTLSTATE_001",22)	LT	t	Unknown:Unknown:Unknown	d
6079	(0037,"MAROTECH Inc.",01)	LO	t	Unknown	d
6102	(0045,"GEMS_SENO_02",29)	DS	t	WindowingParameters	k
6126	(0055,"SIEMENS MED NM",7f)	FL	t	Collimator Angular Resolution radians	k
6088	(0045,"GEMS_SENO_02",53)	IS	t	Raw Diagnostic High	k
6262	(0011,"GEMS_GENIE_1",32)	LO	t	Processing Parent UID	h
6054	(7005,"TOSHIBA_MEC_CT3",08)	OB	t	Detector Slice Thickness in mm	k
5801	(2001,"Philips Imaging DD 129",00)[<0>](2001,"Philips Imaging DD 001",69)[<1>](0018,1620)	IS	t	Presentation State Sequence:Display Shutter:Vertices of the Polygonal Shutter	k
5751	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",88)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Min Zoom In Factor	k
5767	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",56)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer DirectionalLight TwoSide Usage Flag	k
5621	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)[<4>](0008,1140)[<5>](0008,1155)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Instance UID	h
5564	(2005,"Philips MR Imaging DD 006",74)	UN	t	Unknown	d
5729	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",11)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Shadow X Offset	k
5721	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",16)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Auto Navigation Mode	k
5643	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0070,0101)	DS	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Presentation Pixel Spacing	k
5755	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",80)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Rotation Axis	k
5740	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",54)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer DirectionalLight Color	k
5682	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",55)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer DirectionalLight Direction	k
5746	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",96)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Data Points	k
5663	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8d)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation DataRole ID	h
5816	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",64)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Segmentation Display Parameter Type	k
5632	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)[<4>](0008,0100)	SH	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence:Code Value	k
5653	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5e)[<2>](0072,0514)	FD	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Slice Spacing Sequence:Reformatting Interval	k
5857	(0021,"Siemens: Thorax/Multix FD Post Processing",16)	UN	t	Auto Window Expansion	k
5737	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",99)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Data Slice Thickness	k
5725	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",ab)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Viewing Index	k
680	(0009,"GEMS_PETD_01",5c)	LO	t	frame_id	h
3828	(0019,"",d3)	UN	t	Unknown	d
6221	(0019,"Array DICOM private elements version1.0",20)	UN	t	Unknown	d
6297	(0011,"GEMS_GENIE_1",27)	SL	t	ROITopLeft	k
780	(0009,"GEMS_PETD_01",22)	SL	t	Delayed Events	k
5722	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",42)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Orientation	k
6278	(0009,"GEMS_GENIE_1",2e)	FD	t	DistancePrescribed	k
6188	(0033,"SIEMENS MED NM",18)	FL	t	NCO Data for detector 1	k
6181	(0043,"SIEMENS MED NM",01)	FL	t	Detector View Angle	k
6094	(0045,"GEMS_SENO_02",2a)	IS	t	CrosshairCursorXCoordinates	k
6183	(0043,"SIEMENS MED NM",03)	FL	t	View Dependent Y Shift MHR For Detector 1	k
6194	(0033,"SIEMENS MED NM",30)	LO	t	Preset name used for acquisition	k
6085	(0045,"GEMS_SENO_02",62)	IS	t	User Window Center	k
6312	(0011,"GEMS_GENIE_1",0b)	SL	t	EffectiveSeriesDuration	k
4214	(0019,"",98)	UN	t	Unknown	d
5727	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",41)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Position	k
5700	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",8e)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Algorithm Type	k
5772	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",13)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Shadow Style	k
5709	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",84)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Rotation Center	k
5592	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence	k
5806	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer PWL TransferFunction Sequence	k
5596	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5d)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Thickness Sequence	k
5818	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",57)[<4>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",59)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer PWL TransferFunction Sequence:Renderer PWL Vertex Color	k
5708	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",84)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Rotation Center	k
5586	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence	k
5559	(2005,"Philips MR Imaging DD 005",51)	UN	t	Original Series Number	k
5757	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",36)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Application Number Prefix Text	k
5715	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",43)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Far Clip Plane	k
755	(0009,"GEMS_PETD_01",28)	SL	t	Axial Compression	k
6511	(0009,"GEMS_PETD_01",4a)	FL	t	Source 2 Half Life	k
5813	(0018,1510)	DS	f	Positioner Primary Angle	\N
5648	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",5d)[<2>](0072,0510)	CS	t	Advanced Presentation Sequence:Presentation Module Sequence:Renderer Thickness Sequence:Reformatting Operation Type	k
5718	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)	UN	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence	k
5597	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,1115)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Referenced Series Sequence	k
5585	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)[<4>](0008,1140)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence:Referenced Image Sequence	k
5771	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",87)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Max Zoom In Factor	k
5696	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",09)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement UID	h
5808	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence	k
5701	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",13)	UN	t	Advanced Presentation Sequence:Navigation Sequence:Navigation Name	k
5774	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0070,0053)	SL	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Displayed Area Bottom Right Hand Corner	k
5770	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",87)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Max Zoom In Factor	k
5599	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",08)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Measurement Sequence	k
5823	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",65)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Segmentation Display Visibility	k
5631	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",93)[<4>](0008,0102)	SH	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Evaluation Sequence:Coding Scheme Designator	k
5661	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",86)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Parallel Epiped	k
5747	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",14)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Shadow Color	k
4969	(2005,"Philips MR Imaging DD 003",34)	SL	t	Number of Image Per Series Ref	k
5321	(0015,"GEMS_PETD_01",24)	UN	t	BP3d Filter CutoffU	k
1648	(0019,"SIEMENS MR HEADER",0b)	DS	t	Slice Measurement Duration	k
60	(0019,"SIEMENS MR HEADER",0b)	OB	t	Slice Measurement Duration	k
798	(0009,"GEMS_PETD_01",4f)	SL	t	Upper Axial Acc	k
6048	(07a1,"ELSCINT1",73)	IS	t	Unknown	d
5714	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",43)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Far Clip Plane	k
6288	(0011,"GEMS_GENIE_1",2f)	SL	t	Overflow Level	k
6059	(7005,"TOSHIBA_MEC_CT3",23)	OB	t	Pitch Factor	k
6305	(0011,"GEMS_GENIE_1",1a)	SL	t	DetectorCountZone	k
6233	(4453,"DR Systems, Inc.",01)	UN	t	Exam ID	d
6296	(0055,"GEMS_GENIE_1",12)[<0>](0055,"GEMS_GENIE_1",13)[<1>](0011,"GEMS_GENIE_1",1d)	SL	t	eNTEGRA Energy Window Information Sequence:eNTEGRA Energy Window Range Sequence:EnergyRange	k
6514	(0009,"GEMS_PETD_01",42)	FL	t	Source 1 Activity	k
6311	(0055,"GEMS_GENIE_1",22)[<0>](0011,"GEMS_GENIE_1",25)	SL	t	eNTEGRA Detector Information Sequence:FOVMaskCutoffAngle	k
6097	(0045,"GEMS_SENO_02",50)	UI	t	Fallback Instance UID (CR or SC)	h
5810	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0008,0018)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:SOP Instance UID	h
5584	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",12)	SQ	t	Advanced Presentation Sequence:Navigation Sequence	k
5607	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0008,1140)	SQ	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Referenced Image Sequence	k
5634	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0028,3110)[<2>](0028,1055)	LO	t	Advanced Presentation Sequence:Presentation State Sequence:Softcopy VOI LUT Sequence:Window Center & Width Explanation	k
5812	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0008,0016)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:SOP Class UID	k
5720	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",05)	UN	t	Advanced Presentation Sequence:Time Point Sequence:Overlay Image Sequence	k
5777	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0082)	DA	t	Advanced Presentation Sequence:Presentation State Sequence:Presentation Creation Date	o
5821	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",67)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Segmentation Display is Selected Flag 	k
5625	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0008,1115)[<2>](0008,1140)[<3>](0008,1150)	UI	t	Advanced Presentation Sequence:Presentation State Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Class UID	k
5753	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",33)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Frame of Reference UID	h
5711	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4d)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Parallel Shift Interval MM	k
5593	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)	SQ	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence	k
5623	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)[<4>](0008,1140)[<5>](0008,1150)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced SOP Class UID	k
5762	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",09)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Line Type	k
5811	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0020,000d)	UI	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:Study Instance UID	h
6217	(0019,"Array DICOM private elements version1.0",00)	UN	t	Unknown	d
5996	(0057,"GEMS_VXTLSTATE_001",05)[<0>](0057,"GEMS_VXTLSTATE_001",11)	FL	t	Unknown:Unknown	d
6093	(0045,"GEMS_SENO_02",2b)	IS	t	CrosshairCursorYCoordinates	k
6304	(0011,"GEMS_GENIE_1",28)	SL	t	ROIBottomRight	k
6368	(0019,"FDMS 1.0",50)	CS	t	EDRMode	k
6208	(0033,"SIEMENS MED NM",28)	SL	t	MHR calibrations	k
6249	(0009,"GEMS_GENIE_1",22)	SH	t	UserOrientation	k
6193	(0033,"SIEMENS MED NM",23)	SS	t	Gantry L/R Correction Data	k
6377	(0025,"FDMS 1.0",11)	US	t	TermOfCorrectionForEachIPTypeSt	k
6267	(0011,"GEMS_GENIE_1",37)	LT	t	AcquisitionSpecificCorrectName	k
6259	(0011,"GEMS_GENIE_1",36)	LO	t	UniformityCorrectName	k
153	(0019,"SIEMENS MR HEADER",0e)	OB	t	Diffusion Gradient Direction	d
279	(0043,"GEMS_PARM_01",25)	SS	t	ReferenceChannels	k
478	(0021,"GEMS_RELA_01",5e)	DS	t	FloatSlop	k
5659	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",41)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Position	k
5830	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",63)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",53)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Parameter Sequence:Renderer Material	k
5694	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",3f)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",4b)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Camera Home Settings Sequence:Camera Image Maximum Height	k
5804	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)	SQ	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence	k
5614	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",cf)[<3>](0008,1115)[<4>](0008,1140)[<5>](0008,1160)	IS	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Image Sequence:Referenced Series Sequence:Referenced Image Sequence:Referenced Frame Number	k
887	(0043,"GEMS_PARM_01",83)	DS	t	Asset R Factors	k
216	(0043,"GEMS_PARM_01",20)	DS	t	AvgOverrangesAllViews	k
1127	(0009,"GEMS_PETD_01",79)	SH	t	Image Set Compatible Version	k
700	(0009,"GEMS_PETD_01",56)	LO	t	Normal Cal ID	h
844	(0009,"GEMS_PETD_01",56)	UI	t	Normal Cal ID	h
762	(0009,"GEMS_PETD_01",2e)	SL	t	Mask Width	k
525	(0029,"GEMS_IMPS_01",16)	SL	t	LowerRangeOfPixels	k
156	(0029,"GEMS_IMPS_01",09)	SH	t	LowerRangeOfPixels	k
811	(01f1,"ELSCINT1",07)	DS	t	Table Velocity	k
592	(0009,"GEMS_PETD_01",cb)	FL	t	vqc_x_axis_trans	k
803	(0009,"GEMS_PETD_01",2c)	SL	t	Axial FOV	k
821	(01f1,"ELSCINT1",01)	CS	t	Acquisition Type	k
2902	(00e1,"ELSCINT1",39)[<0>](0040,0254)	LO	t	Unknown:Performed Procedure Step Description	d
1329	(0013,"CTP",01)	SQ	t	Unknown	d
248	(0019,"GEMS_ACQU_01",5e)	SL	t	NumberOfChannels1To512	k
165	(0043,"GEMS_PARM_01",27)	SH	t	ScanPitchRatio	k
1291	(0029,"SIEMENS CSA HEADER",10)	OB	t	CSAImageHeaderInfo	d
145	(0019,"SIEMENS MR HEADER",09)	OB	t	Unknown	d
3976	(0019,"",bc)	UN	t	Unknown	d
3007	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
2794	(01f1,"ELSCINT1",05)	OB	t	Reconstruction Arc	d
3170	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3124	(0009,"FDMS 1.0",0c)	OB	t	Film UID	d
1378	(01f7,"ELSCINT1",2d)	OW	t	Unknown	d
4217	(0009,"EMAGEON JPEG2K INFO",00)	UN	t	Unknown	d
4225	(0011,"ULTRAVISUAL_TAG_SET1",18)	UN	t	Unknown	d
4093	(0019,"",0a)	UN	t	Unknown	d
1086	(0053,"GEHC_CT_ADVAPP_001",9e)	UN	t	MultiEnergyNumNoiseRedPair	k
616	(0009,"GEMS_PETD_01",b8)	FL	t	IR Loop Filt Param	k
863	(0009,"GEMS_PETD_01",b8)	SL	t	IR Loop Filt Param	k
5282	(2005,"Philips MR Imaging DD 005",2d)	OB	t	Exam Media Write Status	k
3671	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](2001,"Philips Imaging DD 001",cb)	UN	t	Presentation State Sequence:Graphic Annotation Sequence:Unknown	d
1602	(0025,"GEMS_SERS_01",1a)	SH	t	PrimaryReceiverSuiteAndHost	d
1609	(0029,"MITRA MARKUP 1.0",01)	OB	t	Markup2	d
4042	(0033,"",0c)	LO	t	Unknown	d
3747	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",18)	US	t	Auto Gain	d
2908	(00e1,"ELSCINT1",39)[<0>](0008,1030)	LO	t	Unknown:Study Description	d
3990	(0019,"",96)	UN	t	Unknown	d
68	(0051,"SIEMENS MR HEADER",0b)	OB	t	Acquisition Matrix Text	d
1655	(0051,"SIEMENS MR HEADER",0b)	LO	t	Acquisition Matrix Text	d
1091	(0053,"GEHC_CT_ADVAPP_001",8f)	UN	t	MD1AttenuationCurve	k
5313	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",5b)	FL	t	Series Volume:Volume Offcentre FH	k
5103	(2005,"Philips MR Imaging DD 001",63)	OB	t	fMRI Status Indication	k
379	(0043,"GEMS_PARM_01",37)	UL	t	UserFillMapLSW	k
157	(0027,"GEMS_IMAG_01",30)	SH	t	ForeignImageRevision	k
621	(0009,"GEMS_PETD_01",92)	FL	t	BP Filter Center P	k
1268	(0009,"GEIIS",10)[<0>](7fe0,0010)	OW	t	GE Private Image Thumbnail Sequence:Pixel Data	na
1277	(0009,"GEIIS",10)[<0>](0028,0100)	US	t	GE Private Image Thumbnail Sequence:Bits Allocated	na
5324	(0015,"GEMS_PETD_01",26)	UN	t	BP3d Filter FlagV	k
1082	(0053,"GEHC_CT_ADVAPP_001",92)	UN	t	MD1intercept	k
435	(0021,"GEMS_RELA_01",50)	SS	t	GraphicallyPrescribed	k
187	(0019,"GEMS_ACQU_01",0f)	DS	t	HorizontalFrameOfReference	k
567	(0053,"GEHC_CT_ADVAPP_001",61)	SH	t	High Resolution Flag	k
376	(0053,"GEHC_CT_ADVAPP_001",61)	UN	t	High Resolution Flag	k
413	(0019,"GEMS_ACQU_01",c4)	SS	t	SATLocationA	k
414	(0019,"GEMS_ACQU_01",c6)	SS	t	SATLocationH	k
1288	(0009,"GEMS_IDEN_01",27)	SL	t	ImageActualDate	oi
5151	(2005,"Philips MR Imaging DD 004",37)	OB	t	Sample Offset	k
240	(0027,"GEMS_IMAG_01",49)	FL	t	ACoordOfTopRightCorner	k
1142	(0009,"GEMS_PETD_01",85)	SL	t	Flip	k
1026	(7005,"TOSHIBA_MEC_CT3",30)	UN	t	Main Modality in Study	k
738	(0009,"GEMS_PETD_01",52)	SL	t	Coinc Delay Offset	k
330	(0045,"GEMS_HELIOS_01",06)	CS	t	Table Direction	k
5177	(2001,"Philips Imaging DD 001",03)	OB	t	DiffusionB-Factor	k
4978	(2005,"Philips MR Imaging DD 001",80)		t	Series PlanScan	k
1036	(0053,"GEHC_CT_ADVAPP_001",7a)	UN	t	MultiEnergyFeatAnnotName	k
885	(0043,"GEMS_PARM_01",81)	LO	t	GE Coil Name	k
1523	(0025,"GEMS_SERS_01",17)	SL	t	SeriesCompleteFlag	k
411	(0019,"GEMS_ACQU_01",c5)	SS	t	SATLocationP	k
368	(0043,"GEMS_PARM_01",65)	US	t	Motion Correction Indicator	k
418	(0019,"GEMS_ACQU_01",c9)	SS	t	SATThicknessAP	k
1094	(7005,"TOSHIBA_MEC_CT3",07)	DS	t	Reconstruction Center	k
1020	(7005,"TOSHIBA_MEC_CT3",19)	UL	t	Frame Sort Key	k
1256	(7fd1,"GEIIS",10)	UL	t	Compression Type	k
417	(0019,"GEMS_ACQU_01",a4)	SS	t	SATFatWaterBone	k
292	(0019,"GEMS_ACQU_01",52)	SS	t	ReconPostProcessingFlag	k
5112	(2005,"Philips MR Imaging DD 003",00)	OB	t	Number of SOP Common	k
1099	(7005,"TOSHIBA_MEC_CT3",21)	UN	t	Decrease in Artifact Filter	k
4006	(0021,"",36)	UN	t	Unknown	d
65	(0019,"SIEMENS MR HEADER",11)	OB	t	Flow Compensation	k
4018	(0021,"",58)	UN	t	Unknown	d
4019	(0019,"",d2)	UN	t	Unknown	d
3832	(0019,"",aa)	UN	t	Unknown	d
59	(0051,"SIEMENS MR HEADER",08)	OB	t	CSA Image Header Type	d
1639	(0019,"SIEMENS MR HEADER",16)	DS	t	Time After Start	k
57	(0019,"SIEMENS MR HEADER",16)	OB	t	Time After Start	k
1485	(0051,"SIEMENS MR HEADER",08)	CS	t	CSA Image Header Type	k
154	(0009,"GEMS_IDEN_01",04)	SH	t	ProductId	k
485	(0043,"GEMS_PARM_01",0e)	DS	t	PSDEstimatedLimitInTeslaPerSecond	k
367	(0043,"GEMS_PARM_01",67)	US	t	IBO Correction Indicator	k
861	(0009,"GEMS_PETD_01",0d)	DT	t	Scan Date Time	o
5320	(0015,"GEMS_PETD_01",28)	UN	t	BP3d Filter CutoffV	k
300	(0019,"GEMS_ACQU_01",14)	SS	t	End NumberForBaseline	k
5121	(2005,"Philips MR Imaging DD 004",33)	OB	t	Phase Encoding Echo Top Positions	k
5126	(2005,"Philips MR Imaging DD 001",30)	OB	t	Repetition Time	k
5127	(2005,"Philips MR Imaging DD 005",01)	OB	t	Number of Study Reference	k
5078	(2005,"Philips MR Imaging DD 004",29)	OB	t	Spectro Echo Top Position	k
741	(0009,"GEMS_PETD_01",51)	SL	t	Upper Coinc Limit	k
1088	(0053,"GEHC_CT_ADVAPP_001",9f)	UN	t	MultiEnergyNoiseRedPairString	k
5194	(2005,"Philips MR Imaging DD 004",99)	OB	t	IViewBold Enabled	k
699	(0009,"GEMS_PETD_01",98)	LO	t	Norm Cal ID	h
843	(0009,"GEMS_PETD_01",98)	UI	t	Norm Cal ID	h
5201	(2005,"Philips MR Imaging DD 005",3a)	OB	t	Data Dictionary Contents Version	k
346	(0045,"GEMS_HELIOS_01",01)	SS	t	Number of Macro Rows in Detector	k
632	(0009,"GEMS_PETD_01",d7)	FL	t	image_index_loc	k
595	(0009,"GEMS_PETD_01",67)	FL	t	table_z_position	k
5154	(2005,"Philips MR Imaging DD 004",59)	OB	t	Spectro Turbo Echo Spacing	k
865	(0009,"GEMS_PETD_01",be)	SL	t	AC BP Filter	k
641	(0009,"GEMS_PETD_01",be)	SS	t	AC BP Filter	k
5251	(2005,"Philips MR Imaging DD 005",44)	OB	t	TFE Factor	k
1047	(0053,"GEHC_CT_ADVAPP_001",8c)	UN	t	GSIScanModePreset	k
1100	(7005,"TOSHIBA_MEC_CT3",40)	UN	t	DLP	k
353	(0045,"GEMS_HELIOS_01",18)	SS	t	Number of Views 1B	k
1494	(0053,"GEHC_CT_ADVAPP_001",66)	UN	t	Image Browser Annotation	k
393	(0019,"GEMS_ACQU_01",5a)	FL	t	AcquisitionDuration	k
4074	(0043,"GEMS_PARM_01",8f)	DS	t	Spectro Parameters	d
3966	(0019,"",ce)	UN	t	Unknown	d
4111	(0077,"",03)	UN	t	Unknown	d
1084	(0053,"GEHC_CT_ADVAPP_001",99)	UN	t	MD2slope	k
409	(0019,"GEMS_ACQU_01",7e)	SS	t	NumberOfEchos	k
5082	(2005,"Philips MR Imaging DD 004",97)	OB	t	Anatomic Region Code Value	k
4973	(2001,"Philips Imaging DD 001",5f)		t	StackSequence	k
591	(0009,"GEMS_PETD_01",6a)	FL	t	start_location	k
820	(01f1,"ELSCINT1",03)	CS	t	Concurrent Slices Generation	k
596	(0009,"GEMS_PETD_01",40)	FL	t	Positron Fraction	k
1093	(7005,"TOSHIBA_MEC_CT3",1d)	UL	t	Reconstruction Number	k
2157	(0013,"CTP",15)	LO	t	Batch	k
5205	(2005,"Philips MR Imaging DD 005",16)	OB	t	Plan Mode	k
1015	(7005,"TOSHIBA_MEC_CT3",0f)	SH	t	Direction (head or feet first)	k
227	(0043,"GEMS_PARM_01",40)	FL	t	TriggerOnPosition	k
177	(0021,"GEMS_RELA_01",4a)	LO	t	AnatomicalReferenceForScout	k
1128	(0009,"GEMS_PETD_01",03)	SH	t	Patient Compatible Version	k
1085	(0053,"GEHC_CT_ADVAPP_001",93)	UN	t	MD1slope	k
5104	(2005,"Philips MR Imaging DD 001",b2)	OB	t	Diffusion Direction FH	k
471	(0019,"GEMS_ACQU_01",7d)	DS	t	SecondEcho	k
410	(0019,"GEMS_ACQU_01",c7)	SS	t	SATLocationF	k
618	(0009,"GEMS_PETD_01",9e)	FL	t	Radial Cutoff 3D	k
460	(0019,"GEMS_ACQU_01",9e)	LO	t	InternalPulseSequenceName	k
5184	(2005,"Philips MR Imaging DD 003",51)	OB	t	Number of Study Admitting Diagnostic Description	k
4207	(5653,"",19)	OB	t	Unknown	d
251	(0019,"GEMS_ACQU_01",62)	SL	t	IncrementBetweenViews	k
1254	(0009,"GEIIS",10)[<0>](0029,"GEIIS",14)	UL	t	GE Private Image Thumbnail Sequence:Actual Frame Number	na
519	(0029,"GEMS_IMPS_01",15)	SL	t	LowerRangeOfPixels	k
5217	(2001,"Philips Imaging DD 001",24)	OB	t	Series is Interactive	k
693	(0009,"GEMS_PETD_01",ae)	LO	t	tpluse_frame_id	k
850	(0009,"GEMS_PETD_01",ae)	UI	t	tpluse_frame_id	k
1027	(7005,"TOSHIBA_MEC_CT3",24)	UN	t	AcquisitionDateOfNRA	o
3019	(0019,"FDMS 1.0",90)	OB	t	FilmAnnotationCharacterString1	d
1305	(7053,"Philips PET Private Group",02)	OB	t	Private Data	d
5227	(2005,"Philips MR Imaging DD 005",4d)	OB	t	Is B0 Series	k
4047	(0033,"",1c)	PN	t	Unknown	d
5233	(2005,"Philips MR Imaging DD 001",19)	OB	t	Inverse Reconstructed	k
355	(0045,"GEMS_HELIOS_01",0c)	SS	t	Number of Views shifted	k
280	(0019,"GEMS_ACQU_01",17)	SS	t	SeriesPlane	k
5268	(2005,"Philips MR Imaging DD 001",1f)	OB	t	MPRProtocol	k
1130	(0009,"GEMS_PETD_01",07)	LO	t	Exam ID	h
1144	(0009,"GEMS_PETD_01",75)	SL	t	archived	k
1155	(0009,"GEMS_PETD_01",07)	UI	t	Exam ID	h
5120	(2005,"Philips MR Imaging DD 004",61)	OB	t	Spectro Vertical Window	k
183	(0019,"GEMS_ACQU_01",03)	DS	t	CellNumberAtTheta	k
1042	(0053,"GEHC_CT_ADVAPP_001",7e)	UN	t	MultiEnergyHighLowRatio	k
5193	(2005,"Philips MR Imaging DD 001",13)	OB	t	Development Mode	k
5208	(2001,"Philips Imaging DD 001",61)	OB	t	SeriesTransmitted	k
5146	(2005,"Philips MR Imaging DD 001",1d)	OB	t	Measurement Scan Resolution	k
426	(0019,"GEMS_ACQU_01",cc)	SS	t	VelocityEncoding	k
672	(0009,"GEMS_PETD_01",57)	LO	t	Normal 2D Cal ID	h
845	(0009,"GEMS_PETD_01",57)	UI	t	Normal 2D Cal ID	h
196	(0019,"GEMS_ACQU_01",2f)	DS	t	TriggerFrequency	k
514	(0021,"GEMS_RELA_01",52)	DS	t	RotationFromSourceYRot	k
612	(0009,"GEMS_PETD_01",c2)	FL	t	AC Img Smooth Parm	k
745	(0009,"GEMS_PETD_01",db)	SL	t	ir_z_filter_flag	k
310	(0019,"GEMS_ACQU_01",43)	SS	t	TotalSegmentsRequested	k
5189	(2005,"Philips MR Imaging DD 004",96)	OB	t	Flow Images Present	k
881	(0043,"GEMS_PARM_01",84)	LO	t	Additional Asset Data	k
483	(0043,"GEMS_PARM_01",0d)	DS	t	PSDEstimatedLimit	k
570	(0053,"GEHC_CT_ADVAPP_001",64)	IS	t	Shutter Mode	k
375	(0053,"GEHC_CT_ADVAPP_001",64)	UN	t	Shutter Mode	k
365	(0045,"GEMS_HELIOS_01",0d)	SS	t	Z tracking Flag	k
1070	(0027,"GEMS_IMAG_01",33)	SL	t	ImagingOptions	k
378	(0027,"GEMS_IMAG_01",33)	UL	t	ImagingOptions	k
1145	(0009,"GEMS_PETD_01",88)	SL	t	PanY	k
867	(0009,"GEMS_PETD_01",b5)	SL	t	IR Corr Model	k
643	(0009,"GEMS_PETD_01",b5)	SS	t	IR Corr Model	k
633	(0009,"GEMS_PETD_01",66)	FL	t	table_height	k
2848	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",02)	OB	t	Unknown:Unknown	d
476	(0019,"GEMS_ACQU_01",ba)	DS	t	UserData	d
5166	(2001,"Philips Imaging DD 001",60)	OB	t	NumberOfStacks	k
1113	(0009,"GEMS_PETD_01",0f)	ST	t	Scan Description	d
257	(0027,"GEMS_IMAG_01",1c)	SL	t	VmaMamp	k
316	(0019,"GEMS_ACQU_01",13)	SS	t	StartNumberForBaseline	k
189	(0043,"GEMS_PARM_01",17)	DS	t	IBHImageScaleFactors	k
5327	(0015,"GEMS_PETD_01",27)	UN	t	BP3d Filter OrderV	k
247	(0019,"GEMS_ACQU_01",60)	SL	t	StartingView	k
283	(0043,"GEMS_PARM_01",13)	SS	t	ReconKernelParameters	k
320	(0019,"GEMS_ACQU_01",4a)	SS	t	TotalNumberOfRefChannels	k
1022	(7005,"TOSHIBA_MEC_CT3",08)	DS	t	Detector Slice Thickness in mm	k
343	(0045,"GEMS_HELIOS_01",02)	FL	t	Macro width at ISO Center	k
5180	(2001,"Philips Imaging DD 001",16)	OB	t	NumberOfPCDirections	k
607	(0009,"GEMS_PETD_01",b7)	FL	t	IR Pre Filt Param	k
5243	(2005,"Philips MR Imaging DD 005",00)	OB	t	Volume View Enabled	k
689	(0009,"GEMS_PETD_01",68)	LO	t	landmark_datetime	o
852	(0009,"GEMS_PETD_01",68)	DT	t	landmark_datetime	o
1274	(0009,"GEIIS",10)[<0>](0028,0103)	US	t	GE Private Image Thumbnail Sequence:Pixel Representation	na
456	(0009,"GEMS_IDEN_01",e3)	LO	t	EquipmentUID	h
345	(0009,"GEMS_IDEN_01",e3)	UI	t	EquipmentUID	h
5125	(2005,"Philips MR Imaging DD 001",a0)	OB	t	Dynamic Scan Begin Time	k
1138	(0009,"GEMS_PETD_01",01)	LO	t	Implementation Version Name	k
270	(0029,"GEMS_IMPS_01",34)	SL	t	AdvantageCompOverflow	k
185	(0019,"GEMS_ACQU_01",44)	DS	t	InterscanDelay	k
5149	(2001,"Philips Imaging DD 001",22)	OB	t	WaterFatShift	k
774	(0009,"GEMS_PETD_01",a3)	SL	t	Axial Angles Used	k
260	(0019,"GEMS_ACQU_01",4b)	SL	t	DataSizeForScanData	k
624	(0009,"GEMS_PETD_01",bd)	FL	t	IR Regularize Param	k
167	(0027,"GEMS_IMAG_01",55)	SH	t	RASLetterForScoutEndLoc	k
747	(0009,"GEMS_PETD_01",24)	SL	t	Word Size	k
4324	(0023,"GEMS_STDY_01",80)[<0>](0008,1120)[<1>](0008,1150)	UI	t	Has MPPS Related Tags:Referenced Patient Sequence:Referenced SOP Class UID	k
229	(0027,"GEMS_IMAG_01",4c)	FL	t	ACoordOfBottomRightCorner	k
674	(0009,"GEMS_PETD_01",5e)	LO	t	exam_id	h
837	(0009,"GEMS_PETD_01",5e)	UI	t	exam_id	h
1010	(0053,"GEHC_CT_ADVAPP_001",68)	UN	t	Row Number Anotation Flag	k
362	(0045,"GEMS_HELIOS_01",14)	SS	t	Number of Views 1A	k
294	(0043,"GEMS_PARM_01",4a)	SS	t	StartingChannelOfView	k
420	(0019,"GEMS_ACQU_01",d2)	SS	t	ProjectionAlgorithm	k
1510	(3109,"Applicare/RadWorks/Version 5.0",02)	SH	t	NEW/SEEN Status	d
436	(0019,"GEMS_ACQU_01",12)	SS	t	LastPseq	k
2823	(01f7,"ELSCINT1",28)	OB	t	Unknown	d
3286	(01f7,"ELSCINT1",94)	UN	t	Unknown	d
1146	(0009,"GEMS_PETD_01",87)	SL	t	PanX	k
760	(0009,"GEMS_PETD_01",53)	SL	t	Coinc Output Mode	k
364	(0045,"GEMS_HELIOS_01",12)	SS	t	Start View 1A	k
403	(0019,"GEMS_ACQU_01",81)	SS	t	Contiguous	k
677	(0009,"GEMS_PETD_01",36)	LO	t	Tracer Name	k
370	(0053,"GEHC_CT_ADVAPP_001",60)	SH	t	Recon Flip RotateA nno	k
305	(0019,"GEMS_ACQU_01",16)	SS	t	EndNumberForEnhancedScans	k
442	(0019,"GEMS_ACQU_01",cd)	SS	t	ThicknessDisclaimer	k
5055	(2005,"Philips MR Imaging DD 004",40)	OB	t	Signal Domain for Chemical Shift	k
198	(0043,"GEMS_PARM_01",31)	DS	t	RACoordOfTargetReconCentre	k
1393	(0903,"GEIIS PACS",10)	US	t	Reject Image Flag	k
880	(0043,"GEMS_PARM_01",95)	LO	t	Prescan Reuse String	k
1049	(0053,"GEHC_CT_ADVAPP_001",87)	UN	t	CommandedSecondmA	k
235	(0021,"GEMS_RELA_01",93)	FL	t	BiopsyRefLocation	k
256	(0027,"GEMS_IMAG_01",1f)	SL	t	VmaClip	k
5081	(2005,"Philips MR Imaging DD 005",0a)	OB	t	Rescale Slope Original	k
5101	(2005,"Philips MR Imaging DD 001",01)	OB	t	Image Angulation FH	k
1466	(0009,"SECTRA_Ident_01",02)	SH	t	Examination number	k
323	(0019,"GEMS_ACQU_01",47)	SS	t	ViewCompressionFactor	k
4958	(2005,"Philips MR Imaging DD 004",89)		t	Viewing Protocol	k
5110	(2005,"Philips MR Imaging DD 001",02)	OB	t	Image Angulation RL	k
799	(0009,"GEMS_PETD_01",26)	SL	t	Axial Angle 3D	k
272	(0029,"GEMS_IMPS_01",35)	SL	t	AdvantageCompUnderflow	k
5229	(2005,"Philips MR Imaging DD 005",45)	OB	t	Attenuation Correction	k
5130	(2005,"Philips MR Imaging DD 002",99)	OB	t	Number of Request Excerpts	k
5244	(2001,"Philips Imaging DD 001",7b)	OB	t	AcquisitionNumber	k
795	(0009,"GEMS_PETD_01",1d)	SL	t	Sel Stop Condition Data	k
1073	(0019,"SIEMENS CT VA0  COAD",92)	DS	t	OsteoRegressionLineSlope	k
801	(0009,"GEMS_PETD_01",69)	SL	t	slice_count	k
406	(0019,"GEMS_ACQU_01",9b)	SS	t	PulseSequenceMode	k
1098	(7005,"TOSHIBA_MEC_CT3",23)	UN	t	Pitch Factor	k
249	(0043,"GEMS_PARM_01",1a)	SL	t	StartingChannelNumber	k
627	(0009,"GEMS_PETD_01",a7)	FL	t	total_counts	k
756	(0009,"GEMS_PETD_01",1e)	SL	t	Collect Deadtime	k
205	(0019,"GEMS_ACQU_01",76)	DS	t	MaxRightChannelOverViews	k
2793	(01f1,"ELSCINT1",4d)	OB	t	Unknown	d
3909	(0023,"",7d)	UN	t	Unknown	d
1576	(0011,"GEMS_PETD_01",01)		t	Unknown	d
6518	(0009,"GEMS_PETD_01",49)	SH	t	Source 2 Radio Nuclide	k
6517	(0009,"GEMS_PETD_01",43)	DT	t	Source 1 Meas DT	d
163	(0027,"GEMS_IMAG_01",53)	SH	t	RASLetterForAnteriorPosterior	k
524	(0019,"GEMS_ACQU_01",97)	SL	t	BitmapDefiningCVs	k
5054	(2005,"Philips MR Imaging DD 001",0b)	OB	t	Max FP	k
5131	(2005,"Philips MR Imaging DD 001",08)	OB	t	Image Offcenter AP	k
5145	(2005,"Philips MR Imaging DD 004",36)	OB	t	Reference Frequency	k
5265	(2005,"Philips MR Imaging DD 004",48)	OB	t	Spectro Hidden Line Removal	k
5322	(0015,"GEMS_PETD_01",3c)	UN	t	Recon Matrix Size	k
244	(0043,"GEMS_PARM_01",26)	US	t	NoViewsRefChannelsBlocked	k
5181	(2005,"Philips MR Imaging DD 001",b1)	OB	t	Diffusion Direction AP	k
625	(0009,"GEMS_PETD_01",e5)	FL	t	left shift	k
159	(0021,"GEMS_RELA_01",18)	SH	t	GenesisVersionNow	k
447	(0043,"GEMS_PARM_01",07)	SS	t	ViewsPerSegment	k
509	(0021,"GEMS_RELA_01",5b)	DS	t	FloatSlop	k
5144	(2005,"Philips MR Imaging DD 001",0a)	OB	t	Image OffCentre RL	k
5157	(2005,"Philips MR Imaging DD 004",47)	OB	t	Spectro Gamma	k
5219	(2001,"Philips Imaging DD 001",12)	OB	t	DynamicSeries	k
5218	(2005,"Philips MR Imaging DD 005",4e)	OB	t	Is B1 Series	k
816	(01f1,"ELSCINT1",08)	DS	t	Acquisition Length	k
692	(0009,"GEMS_PETD_01",ad)	LO	t	trans_frame_id	h
1075	(0021,"SIEMENS MED",11)	DS	t	Target	k
5073	(2001,"Philips Imaging DD 001",1d)	OB	t	ReconstructionNumberMR	k
390	(0043,"GEMS_PARM_01",33)	FL	t	NegScanSpacing	k
785	(0009,"GEMS_PETD_01",90)	SL	t	BP Filter Order	k
5307	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",59)	FL	t	Series Volume:Volume FOV RL	k
754	(0009,"GEMS_PETD_01",1c)	SL	t	Sel Stop Condition	k
773	(0009,"GEMS_PETD_01",18)	SL	t	Scan Type	k
516	(0019,"GEMS_ACQU_01",f9)	DS	t	TransmissionGain	k
5187	(2001,"Philips Imaging DD 001",82)	OB	t	Echo Train Length	k
287	(0029,"GEMS_IMPS_01",26)	SS	t	VersionOfHeaderStructure	k
1276	(0009,"GEIIS",10)[<0>](0028,0101)	US	t	GE Private Image Thumbnail Sequence:Bits Stored	na
765	(0009,"GEMS_PETD_01",2a)	SL	t	Collimation	k
252	(0043,"GEMS_PARM_01",45)	SL	t	DASAdInput	k
3933	(0029,"",17)	UN	t	Unknown	d
73	(0051,"SIEMENS MR HEADER",13)	OB	t	Positive PCS Directions	d
5160	(2005,"Philips MR Imaging DD 005",55)	OB	t	Velocity Encoding Direction	d
395	(0019,"GEMS_ACQU_01",95)	SS	t	AnalogReceiverGain	k
293	(0019,"GEMS_ACQU_01",dc)	SS	t	PrimarySpeedCorrectionUsed	k
1074	(0019,"SIEMENS CT VA0  COAD",90)	DS	t	OsteoOffset	k
5134	(2005,"Philips MR Imaging DD 005",14)	OB	t	Number of Diffusion B Values	k
1046	(0053,"GEHC_CT_ADVAPP_001",83)	UN	t	AnnotationmA	k
5142	(2005,"Philips MR Imaging DD 004",49)	OB	t	Spectro Horizontal Shift	k
278	(0027,"GEMS_IMAG_01",35)	SS	t	PlaneType	k
603	(0009,"GEMS_PETD_01",9b)	FL	t	CAC Skull Offset	k
408	(0027,"GEMS_IMAG_01",31)	SS	t	ImagingMode	k
4956	(2005,"Philips MR Imaging DD 005",55)	UN	t	Velocity Encoding Direction	k
391	(0043,"GEMS_PARM_01",38)	FL	t	User25ToUser48	k
231	(0027,"GEMS_IMAG_01",4b)	FL	t	RCoordOfBottomRightCorner	k
1147	(0009,"GEMS_PETD_01",77)	SL	t	uncompressed_size	k
1214	(0029,"SIEMENS MEDCOM HEADER2",60)	LO	t	SeriesWorkflowStatus	k
74	(0029,"SIEMENS MEDCOM HEADER2",60)	OB	t	SeriesWorkflowStatus	k
1578	(0051,"SIEMENS MR HEADER",13)	SH	t	Positive PCS Directions	k
896	(0019,"SIEMENS CT VA0  COAD",b0)	DS	t	Feed per Rotation	k
314	(0043,"GEMS_PARM_01",1b)	SS	t	PPScanParameters	k
523	(0021,"GEMS_RELA_01",57)	SL	t	IntegerSlop	k
5114	(2005,"Philips MR Imaging DD 004",50)	OB	t	Spectro Horizontal Window	k
380	(0043,"GEMS_PARM_01",36)	UL	t	UserFillMapMSW	k
1272	(0009,"GEIIS",10)[<0>](0028,0102)	US	t	GE Private Image Thumbnail Sequence:High Bit	na
5221	(2005,"Philips MR Imaging DD 001",31)	OB	t	Respiratory Gating	k
790	(0009,"GEMS_PETD_01",2d)	SL	t	Event Separation	k
1017	(7005,"TOSHIBA_MEC_CT3",1b)	SH	t	Convolution Kernel for Series Record	k
824	(01f1,"ELSCINT1",32)	CS	t	Image View Convention	k
404	(0019,"GEMS_ACQU_01",d5)	SS	t	FractionalEcho	k
321	(0043,"GEMS_PARM_01",1d)	SS	t	LevelValue	k
175	(0019,"GEMS_ACQU_01",18)	LO	t	FirstScanRAS	k
452	(0043,"GEMS_PARM_01",2d)	SH	t	StringSlopField1	k
1499	(0029,"SIEMENS CSA HEADER",19)	LO	t	CSASeriesHeaderVersion	d
143	(0029,"SIEMENS CSA HEADER",19)	OB	t	CSASeriesHeaderVersion	d
152	(0019,"SIEMENS MR HEADER",27)	OB	t	B Matrix	d
70	(0051,"SIEMENS MR HEADER",0f)	OB	t	Coil String	d
857	(0009,"GEMS_PETD_01",05)	DT	t	Patient DateTime	o
631	(0009,"GEMS_PETD_01",bb)	FL	t	Post Filter Param	k
211	(0019,"GEMS_ACQU_01",74)	DS	t	MaxLeftChannelOverViews	k
5136	(2001,"Philips Imaging DD 001",0f)	OB	t	Cardiac Gate Width	k
1054	(0053,"GEHC_CT_ADVAPP_001",84)	UN	t	CommandedFirstkVp	k
434	(0043,"GEMS_PARM_01",08)	SS	t	RespiratoryRateInBPM	k
606	(0009,"GEMS_PETD_01",3a)	FL	t	Pre Inj Volume	k
874	(0009,"GEMS_PETD_01",b2)	SL	t	IR Num Iterations	k
648	(0009,"GEMS_PETD_01",b2)	SS	t	IR Num Iterations	k
1071	(0019,"SIEMENS CT VA0  COAD",96)	IS	t	OsteoPhantomNumber	k
5199	(2005,"Philips MR Imaging DD 004",27)	OB	t	Spectro Complex Component	k
5186	(2001,"Philips Imaging DD 001",15)	OB	t	NumberOfLocations	k
5148	(2005,"Philips MR Imaging DD 004",57)	OB	t	Spectro Spectral BW	k
1652	(0051,"SIEMENS MR HEADER",0f)	LO	t	Coil String	k
317	(0019,"GEMS_ACQU_01",39)	SS	t	ScanFOVType	k
4323	(0023,"GEMS_STDY_01",80)[<0>](0008,1120)[<1>](0008,1155)	UI	t	Has MPPS Related Tags:Referenced Patient Sequence:Referenced SOP Instance UID	h
511	(0021,"GEMS_RELA_01",5c)	DS	t	FloatSlop	k
635	(0009,"GEMS_PETD_01",dc)	FL	t	ir_z_filter_ratio	k
263	(0043,"GEMS_PARM_01",43)	SL	t	DASFpaGain	k
610	(0009,"GEMS_PETD_01",ac)	FL	t	bp_center_y	k
425	(0019,"GEMS_ACQU_01",c8)	SS	t	SATThicknessRL	k
184	(0043,"GEMS_PARM_01",1e)	DS	t	DeltaStartTime	k
5340	(0015,"GEMS_PETD_01",31)	UN	t	Recon Algorithm	k
5086	(2005,"Philips MR Imaging DD 004",34)	OB	t	Physical Quantity for Chemical Shift	k
1258	(0009,"GEIIS",10)[<0>](7fd1,"GEIIS",10)	UL	t	GE Private Image Thumbnail Sequence:Compression Type	na
2164	(7fd1,"GEIIS",40)	UL	t	Subband Rows	k
4048	(0033,"",16)	PN	t	Unknown	d
696	(0009,"GEMS_PETD_01",05)	LO	t	Patient DateTime	o
3805	(0033,"",16)	UN	t	Unknown	d
3048	(0025,"FDMS 1.0",12)	OB	t	ReadingGainGp	d
5241	(2001,"Philips Imaging DD 001",06)	OB	t	ImageEnhanced	k
604	(0009,"GEMS_PETD_01",e9)	FL	t	acq_bin_dur_percent	k
862	(0009,"GEMS_PETD_01",e9)	SL	t	acq_bin_dur_percent	k
1041	(0053,"GEHC_CT_ADVAPP_001",70)	UN	t	MultiEnergySourceCount	k
1034	(0053,"GEHC_CT_ADVAPP_001",8e)	UN	t	MonoWindoHigh	k
517	(0019,"GEMS_ACQU_01",a2)	SL	t	RawDataRunNumber	k
5225	(2005,"Philips MR Imaging DD 001",38)	OB	t	Spoiled	k
506	(0019,"GEMS_ACQU_01",8d)	DS	t	DelayAfterTrigger	k
271	(0025,"GEMS_SERS_01",10)	SL	t	LandmarkCounter	k
422	(0043,"GEMS_PARM_01",02)	SS	t	GradientOffsetInX	k
427	(0019,"GEMS_ACQU_01",cb)	SS	t	PrescribedFlowAxis	k
1114	(0009,"GEMS_PETD_01",84)	FL	t	Rotate	k
5273	(2001,"Philips Imaging DD 001",23)	OB	t	FlipAnglePhilips	k
192	(0019,"GEMS_ACQU_01",23)	DS	t	TableSpeed	k
1675	(0019,"SIEMENS MR HEADER",12)	SL	t	Table Position Origin	k
63	(0019,"SIEMENS MR HEADER",12)	OB	t	Table Position Origin	k
1676	(0019,"SIEMENS MR HEADER",15)	FD	t	Slice Position PCS	k
62	(0019,"SIEMENS MR HEADER",15)	OB	t	Slice Position PCS	k
274	(0043,"GEMS_PARM_01",46)	SL	t	DASCalMode	k
890	(0043,"GEMS_PARM_01",7d)	US	t	Recon Mode Flag Word	k
4987	(2005,"Philips MR Imaging DD 005",0f)[<0>](0008,0012)	DA	t	Private Per-Frame Sequence:Instance Creation Date	na
5239	(2001,"Philips Imaging DD 001",62)	OB	t	SeriesCommitted	k
770	(0009,"GEMS_PETD_01",8e)	SL	t	BP Filter	k
5083	(2005,"Philips MR Imaging DD 004",35)	OB	t	Physical Quantity Spatial	k
430	(0019,"GEMS_ACQU_01",ca)	SS	t	SATThicknessHF	k
226	(0043,"GEMS_PARM_01",41)	FL	t	DegreeOfRotation	k
5169	(2005,"Philips MR Imaging DD 001",23)	OB	t	Number of Slabs	k
398	(0019,"GEMS_ACQU_01",ce)	SS	t	PrescanType	k
1045	(0053,"GEHC_CT_ADVAPP_001",72)	UN	t	MultiEnergyReconType	k
622	(0009,"GEMS_PETD_01",a0)	FL	t	Axial Cutoff 3D	k
451	(0043,"GEMS_PARM_01",2e)	SH	t	StringSlopField2	k
840	(0009,"GEMS_PETD_01",59)	UI	t	WC Cal ID	h
5249	(2001,"Philips Imaging DD 001",04)	OB	t	DiffusionDirection	k
686	(0009,"GEMS_PETD_01",59)	LO	t	WC Cal ID	h
358	(0045,"GEMS_HELIOS_01",15)	SS	t	Start View 2B	k
812	(01f1,"ELSCINT1",05)	DS	t	Reconstruction Arc	k
5051	(2001,"Philips Imaging DD 001",0a)	OB	t	SliceNumberMR	k
1089	(0053,"GEHC_CT_ADVAPP_001",9b)	UN	t	MD2attenuationCurve	k
3885	(0019,"",c4)	UN	t	Unknown	d
3890	(0019,"",bd)	UN	t	Unknown	d
4058	(0019,"",11)	SH	t	Unknown	d
3792	(0019,"",11)	UN	t	Unknown	d
6334	(0011,"GEMS_GDXE_FALCON_04",59)	CS	t	Unknown	d
6386	(0021,"SIEMENS CT VA0  RAW",43)	UL	t	Unknown	d
6333	(0093,"SIENET",02)	LO	t	Unknown	d
6160	(0093,"SIENET",02)	UN	t	Unknown	d
6344	(0065,"Viewing Protocol",98)	UN	t	Unknown	d
6387	(0021,"SIEMENS CT VA0  RAW",44)	UL	t	Unknown	d
5906	(7031,"CtProjectionData-MayoClinc-v1",03)	UN	t	Unknown	d
6026	(0057,"GEMS_ADWSoft_3D2",04)	LT	t	Unknown	d
6325	(004b,"GEIIS",15)	LT	t	Unknown	d
6057	(7005,"TOSHIBA_MEC_CT3",1b)	OB	t	Convolution Kernel for Series Record	k
6253	(0009,"GEMS_GENIE_1",2b)	LO	t	Trigger History UID	h
6070	(0019,"SIEMENS CT VA0  COAD",c1)	DS	t	Pulmo Air	k
6363	(0021,"FDMS 1.0",30)	CS	t	SetNo	k
6199	(0041,"SIEMENS MED NM",08)	FD	t	Trunnion Information for Detector 2	k
6378	(0025,"FDMS 1.0",12)	US	t	ReadingGainGp	k
6293	(0011,"GEMS_GENIE_1",15)	SL	t	DetectorNumber	k
6125	(0033,"SIEMENS MED NM",29)	FL	t	Crystal thickness	k
6182	(0043,"SIEMENS MED NM",04)	FL	t	View Dependent Y Shift MHR For Detector 2	k
6254	(0011,"GEMS_GENIE_1",50)	LO	t	Where Object Name	k
6256	(0011,"GEMS_GENIE_1",31)	LO	t	Acquisition Parent UID	h
6347	(0019,"FDMS 1.0",60)	SH	t	RadiographersCode	k
179	(0009,"GEMS_IDEN_01",01)	LO	t	FullFidelity	k
5188	(2005,"Philips MR Imaging DD 001",61)	OB	t	Prepulse Type	k
5310	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",56)	FL	t	Series Volume:Volume Angulation RL	k
1446	(7053,"Philips PET Private Group",00)	DS	t	SUV Factor	k
4964	(2005,"Philips MR Imaging DD 003",82)	CS	t	Running Attributes	k
166	(0027,"GEMS_IMAG_01",52)	SH	t	RASLetterForSideOfImage	k
242	(0027,"GEMS_IMAG_01",50)	FL	t	TableStartLocation	k
402	(0043,"GEMS_PARM_01",0a)	SS	t	TypeOfReceiverUsed	k
694	(0009,"GEMS_PETD_01",13)	LO	t	FOR Identifier	h
851	(0009,"GEMS_PETD_01",13)	UI	t	FOR Identifier	h
445	(0043,"GEMS_PARM_01",2c)	SS	t	EffectiveEchoSpacing	k
1081	(0053,"GEHC_CT_ADVAPP_001",98)	UN	t	MD2intercept	k
3189	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
6164	(0054,0016)[<0>](0054,0304)[<1>](0008,0005)	CS	f	Radiopharmaceutical Information Sequence:Radiopharmaceutical Code Sequence:Specific Character Set	\N
6142	(0054,0022)[<0>](0018,1184)	DS	f	Detector Information Sequence:Y Focus Center	\N
268	(0019,"GEMS_ACQU_01",26)	SL	t	DegreesOfAzimuth	k
160	(0009,"GEMS_IDEN_01",e6)	SH	t	GenesisVersionNow	k
757	(0009,"GEMS_PETD_01",6d)	SL	t	acq_duration	k
429	(0019,"GEMS_ACQU_01",8f)	SS	t	SwapPhaseFrequency	k
5242	(2005,"Philips MR Imaging DD 001",35)	OB	t	StackSliceNumber	k
818	(00e1,"ELSCINT1",50)	DS	t	Acquisition Duration	k
814	(00e1,"ELSCINT1",22)	DS	t	Presentation Relative Center	k
768	(0009,"GEMS_PETD_01",81)	SL	t	Number of Normals	k
1604	(0019,"SIEMENS MR HEADER",28)	FD	t	Bandwidth per Pixel Phase Encode	k
61	(0019,"SIEMENS MR HEADER",28)	OB	t	Bandwidth per Pixel Phase Encode	k
2812	(01f7,"ELSCINT1",25)	OB	t	Unknown	d
6147	(0054,0052)[<0>](0054,0200)	DS	f	Rotation Information Sequence:Start Angle	\N
181	(0019,"GEMS_ACQU_01",24)	DS	t	MidScanTime	k
5178	(2005,"Philips MR Imaging DD 005",43)	OB	t	Active Implantable Medical Device dbDt Limit	k
797	(0009,"GEMS_PETD_01",9f)	SL	t	Axial Filter 3D	k
453	(0019,"GEMS_ACQU_01",9d)	SH	t	PulseSequenceDate	o
530	(0019,"GEMS_ACQU_01",9d)	DT	t	PulseSequenceDate	o
491	(0021,"GEMS_RELA_01",81)	DS	t	AutoWindowLevelAlpha	k
611	(0009,"GEMS_PETD_01",29)	FL	t	Gantry Tilt Angle	k
681	(0009,"GEMS_PETD_01",3d)	LO	t	Post Injected Date Time	o
859	(0009,"GEMS_PETD_01",3d)	DT	t	Post Injected Date Time	o
357	(0045,"GEMS_HELIOS_01",16)	SS	t	Number Views 2B	k
1014	(7005,"TOSHIBA_MEC_CT3",0e)	SH	t	File Type Remarks	k
5235	(2005,"Philips MR Imaging DD 001",2f)	OB	t	Spatial Presaturation	k
449	(0019,"GEMS_ACQU_01",96)	SS	t	DigitalReceiverGain	k
259	(0019,"GEMS_ACQU_01",02)	SL	t	NumberOfCellsInDetector	k
433	(0019,"GEMS_ACQU_01",f2)	SS	t	FastPhases	k
781	(0009,"GEMS_PETD_01",70)	SL	t	actual_stop_cond	k
1124	(0009,"GEMS_PETD_01",09)	SH	t	Exam Software Version	k
534	(0053,"GEHC_CT_ADVAPP_001",43)	SH	t	Iterative Recon Level	k
372	(0053,"GEHC_CT_ADVAPP_001",20)	IS	t	Shuttle Flag	k
1121	(0009,"GEMS_PETD_01",61)	SH	t	software_version	k
234	(0027,"GEMS_IMAG_01",42)	FL	t	CenterRCoordOfPlaneImage	k
5280	(2005,"Philips MR Imaging DD 001",a1)	OB	t	SyncraScanType	k
826	(00e1,"ELSCINT1",01)	US	t	Data Dictionary Version	k
1141	(0009,"GEMS_PETD_01",aa)	SL	t	archived	k
381	(0019,"GEMS_ACQU_01",a3)	UL	t	CalibratedFieldStrength	k
1083	(0053,"GEHC_CT_ADVAPP_001",9c)	UN	t	GSIdataVersion	k
827	(01f1,"ELSCINT1",0a)	US	t	Edge Enhancement Weight	k
5261	(2005,"Philips MR Imaging DD 005",09)	OB	t	Rescale Intercept Original	k
1132	(0009,"GEMS_PETD_01",11)	LO	t	Scanner Description	k
1052	(0053,"GEHC_CT_ADVAPP_001",8a)	UN	t	MaterialType#1	k
188	(0043,"GEMS_PARM_01",18)	DS	t	BBH Coefficients	k
608	(0009,"GEMS_PETD_01",d5)	FL	t	loop_filter_parm	k
304	(0019,"GEMS_ACQU_01",da)	SS	t	ReferenceChannelUsed	k
1053	(0053,"GEHC_CT_ADVAPP_001",73)	UN	t	MultiEnergyImageType	k
5311	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",58)	FL	t	Series Volume:Volume FOV FH	k
176	(0019,"GEMS_ACQU_01",1a)	LO	t	LastScanRAS	k
515	(0021,"GEMS_RELA_01",53)	DS	t	RotationFromSourceZRot	k
787	(0009,"GEMS_PETD_01",5a)	SL	t	Derived	k
5220	(2005,"Philips MR Imaging DD 001",26)	OB	t	Over Sampling Phase	k
5285	(2005,"Philips MR Imaging DD 004",81)	OB	t	ScanoGram Survey Number of Images	k
464	(0019,"GEMS_ACQU_01",93)	DS	t	CenterFrequency	k
5207	(2005,"Philips MR Imaging DD 001",39)	OB	t	Steady State	k
5275	(2005,"Philips MR Imaging DD 001",2b)	OB	t	Percent Scan Complete	k
1257	(0009,"GEIIS",10)[<0>](0029,"GEIIS",12)	UL	t	GE Private Image Thumbnail Sequence:Offset	na
5226	(2005,"Philips MR Imaging DD 005",32)	OB	t	Safety Override Mode	k
630	(0009,"GEMS_PETD_01",38)	FL	t	Tracer Activity	k
309	(0043,"GEMS_PARM_01",16)	SS	t	NumberOfOverranges	k
5195	(2005,"Philips MR Imaging DD 004",64)	OB	t	Volume Selection	k
1031	(7005,"TOSHIBA_MEC_CT3",1a)	US	t	Frame Sort Order	k
5052	(2005,"Philips MR Imaging DD 001",10)	OB	t	Window Width	k
5147	(2005,"Philips MR Imaging DD 005",47)	OB	t	Power Optimization	k
690	(0009,"GEMS_PETD_01",9c)	LO	t	Emiss Sub ID	h
847	(0009,"GEMS_PETD_01",9c)	UI	t	Emiss Sub ID	h
809	(01f1,"ELSCINT1",0d)	DS	t	Rotation Angle	k
5216	(2005,"Philips MR Imaging DD 004",25)	OB	t	Spectro SI B0 Correction	k
311	(0019,"GEMS_ACQU_01",42)	SS	t	SegmentNumber	k
5057	(2001,"Philips Imaging DD 001",83)	OB	t	Imaging Frequency	k
5279	(2001,"Philips Imaging DD 001",20)	OB	t	Scanning Technique	k
213	(0019,"GEMS_ACQU_01",73)	DS	t	AvgOfLeftRefChannelsOverViews	k
230	(0027,"GEMS_IMAG_01",48)	FL	t	RCoordOfTopRightCorner	k
1087	(0053,"GEHC_CT_ADVAPP_001",03)	UN	t	MultiEnergyMDTransformEnergies	k
312	(0025,"GEMS_SERS_01",06)	SS	t	LastPulseSequenceUsed	k
5061	(2005,"Philips MR Imaging DD 001",09)	OB	t	Image Offcenter FH	k
5192	(2005,"Philips MR Imaging DD 004",45)	OB	t	Spectro Echo Acquisition	k
218	(0019,"GEMS_ACQU_01",2a)	DS	t	XrayOnPosition	k
1019	(7005,"TOSHIBA_MEC_CT3",1e)	UL	t	Raw Data Number	k
571	(0053,"GEHC_CT_ADVAPP_001",67)	IS	t	Overlapped Recon Flag	k
377	(0053,"GEHC_CT_ADVAPP_001",67)	UN	t	Overlapped Recon Flag	k
405	(0019,"GEMS_ACQU_01",85)	SS	t	MonitorSAR	k
629	(0009,"GEMS_PETD_01",ce)	FL	t	vqc_y_axis_swivel	k
1118	(0009,"GEMS_PETD_01",60)	SH	t	compatible_version	k
4979	(2005,"Philips MR Imaging DD 001",84)		t	Series Reference	k
5070	(2005,"Philips MR Imaging DD 001",84)	OB	t	Series Reference	k
600	(0009,"GEMS_PETD_01",d0)	FL	t	vqc_z_axis_roll	k
5326	(0015,"GEMS_PETD_01",35)	UN	t	Blank Scan Flag	k
667	(0009,"GEMS_PETD_01",0a)	LO	t	Scan ID	h
842	(0009,"GEMS_PETD_01",0a)	UI	t	Scan ID	h
224	(0027,"GEMS_IMAG_01",41)	FL	t	ImageLocation	k
444	(0043,"GEMS_PARM_01",03)	SS	t	GradientOffsetInY	k
736	(0009,"GEMS_PETD_01",df)	US	t	num_of_slices	k
450	(0019,"GEMS_ACQU_01",8b)	SS	t	ActualReceiveGainDigital	k
5152	(2001,"Philips Imaging DD 001",01)	OB	t	ChemicalShift	k
462	(0043,"GEMS_PARM_01",0f)	DS	t	SARAvgHead	k
5094	(2001,"Philips Imaging DD 001",19)	OB	t	PartialMatrixScanned	k
1618	(07a1,"ELSCINT1",56)	US	t	Unknown	d
1679	(0051,"SIEMENS MR HEADER",09)	LO	t	CSA Image Header Version	k
5097	(2005,"Philips MR Imaging DD 003",45)	OB	t	Number of Software Version	k
1502	(0011,"GEMS_PATI_01",10)	SS	t	PatientStatus	k
1218	(0013,"CTP",11)	LO	t	Trial Name	k
675	(0009,"GEMS_PETD_01",3b)	LO	t	Administered Date Time	o
860	(0009,"GEMS_PETD_01",3b)	DT	t	Administered Date Time	o
264	(0043,"GEMS_PARM_01",1f)	SL	t	MaxOverrangesInAView	k
870	(0009,"GEMS_PETD_01",b3)	SL	t	IR Num Subsets	k
649	(0009,"GEMS_PETD_01",b3)	SS	t	IR Num Subsets	k
186	(0019,"GEMS_ACQU_01",27)	DS	t	GantryPeriod	k
1394	(0903,"GEIIS PACS",12)	US	t	Confidential Flag	k
5138	(0903,"GEIIS PACS",12)	OB	t	Confidential Flag	k
1396	(3711,"A.L.I. Technologies, Inc.",0c)	UI	t	Original Study UID	h
423	(0043,"GEMS_PARM_01",01)	SS	t	BitmapOfPrescanOptions	k
5159	(2005,"Philips MR Imaging DD 001",b0)	OB	t	Diffusion Direction RL	k
201	(0019,"GEMS_ACQU_01",04)	DS	t	CellSpacing	k
888	(0043,"GEMS_PARM_01",96)	CS	t	Content Qualification	k
5314	(2005,"Philips MR Imaging DD 001",85)[<0>](2005,"Philips MR Imaging DD 001",5a)	FL	t	Series Volume:Volume Offcentre AP	k
5174	(2001,"Philips Imaging DD 001",11)	OB	t	DiffusionEchoTime	k
415	(0019,"GEMS_ACQU_01",c2)	SS	t	SATLocationR	k
615	(0009,"GEMS_PETD_01",8f)	FL	t	BP Filter Cutoff	k
838	(0009,"GEMS_PETD_01",5c)	UI	t	frame_id	h
5163	(0008,1111)[<0>](2005,"Philips MR Imaging DD 005",06)	OB	t	Referenced Performed Procedure Step Sequence:Number of PS Specific Character Sets	k
3140	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",41)	OB	t	Unknown:Unknown	d
1106	(0029,"SIEMENS MEDCOM HEADER",33)	UL	t	PMTFInformation3	d
2974	(0021,"FDMS 1.0",40)	OB	t	ImageNoInTheSet	d
2860	(01f3,"ELSCINT1",14)	OB	t	Unknown	d
1503	(0029,"MITRA MARKUP 1.0",04)	OB	t	Markup5	d
3043	(0009,"FDMS 1.0",05)	OB	t	ImageUID	d
3856	(0029,"",26)	UN	t	Unknown	d
3047	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",73)	OB	t	Unknown:Unknown	d
2885	(00e1,"ELSCINT1",39)[<0>](0008,1110)[<1>](0008,1150)	UI	t	Unknown:Referenced Study Sequence:Referenced SOP Class UID	d
3895	(0043,"",2a)	UN	t	Unknown	d
1551	(07a1,"ELSCINT1",85)	UL	t	Unknown	d
731	(0009,"GEMS_PETD_01",72)	FD	t	total_delays	d
1402	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",19)	OB	t	Unknown	d
3707	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",03)	FL	t	Unknown	d
1450	(0009,"GEIIS",0e)	UN	t	Unknown	d
4299	(0009,"Unnamed Private Block - 77",70)	UT	t	Unknown	d
2857	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",04)	OB	t	Unknown:Unknown	d
4059	(0051,"",12)	SH	t	Unknown	d
3808	(0029,"",60)	UN	t	Unknown	d
3081	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3943	(0019,"",95)	UN	t	Unknown	d
3243	(300d,"TOMO_HA_01",a4)	UN	t	Unknown	d
691	(0009,"GEMS_PETD_01",99)	LO	t	Blnk Cal ID	d
221	(0023,"GEMS_STDY_01",70)	FD	t	StartTimeSecsInFirstAxial	oi
72	(0051,"SIEMENS MR HEADER",09)	OB	t	CSA Image Header Version	d
6535	(0009,"SPI-P Release 1",15)	LO	t	UniqueIdentifier	d
6513	(0009,"GEMS_PETD_01",47)	FL	t	Source 2 Activity	k
6547	(2001,"Philips Imaging DD 001",58)	UN	t	Contrast Transfer Taste	k
6519	(0009,"GEMS_PETD_01",44)	SH	t	Source 1 Radio Nuclide	k
6567	(6000,3004)	UN	f	<undef>	\N
6569	(6000,3003)	UN	f	<undef>	\N
6553	(0009,"GEMS_PETD_01",29)	SL	t	Gantry Tilt Angle	k
6564	(0009,"GEIIS",10)[<0>](0029,"SIEMENS MEDCOM HEADER",35)	UL	t	GE Private Image Thumbnail Sequence:PMTFInformation5	d
6533	(0009,"SPI-P Release 1",04)	LO	t	ImageDataConsistence	k
6566	(0021,"SIEMENS CT VA0  GEN",30)	IS	t	TopogramTubePosition	k
6551	(5653,"Vital Images SW 3.4",22)	UI	t	Volume Series Instance UID	h
6565	(0009,"GEIIS",10)[<0>](0029,"SIEMENS MEDCOM HEADER",31)	LO	t	GE Private Image Thumbnail Sequence:PMTFInformation1	k
6512	(0009,"GEMS_PETD_01",45)	FL	t	Source 1 Half Life	k
6570	(6000,3002)	UN	f	<undef>	\N
6537	(0029,"SPI-P Release 1",25)	LO	t	ProcessedPixelDataQuality	k
6515	(0009,"GEMS_PETD_01",4c)	FL	t	Source Location	k
6552	(0008,1140)[<0>](0008,0016)	UI	f	Referenced Image Sequence:SOP Class UID	\N
6520	(0009,"GEMS_PETD_01",46)	SL	t	Source 2 Holder	k
6550	(0008,1140)[<0>](0008,0018)	UI	f	Referenced Image Sequence:SOP Instance UID	\N
6516	(0009,"GEMS_PETD_01",48)	DT	t	Source 2 Meas DT	d
6568	(6000,3005)	UN	f	<undef>	\N
5516	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",40)	LO	t	Blob Data Object Array:Version String	d
4929	(5001,"ELSCINT1",92)	CS	t	Unknown	d
2843	(01f1,"ELSCINT1",01)	OB	t	Acquisition Type	d
4895	(0137,"NetRAAD",02)	UN	t	Unknown	d
5364	(0071,"BLACKFORD",04)[<0>](0008,0050)	SH	t	Unknown:Accession Number	d
4949	(0031,"AGFA CD BURNING ATTRIBUTES 1.0",01)	UN	t	Unknown	d
5389	(0071,"BLACKFORD",04)[<0>](0008,0090)	PN	t	Unknown:Referring Physician's Name	d
4910	(0045,"GEMS_HELIOS_01",56)	OB	t	Unknown	d
5352	(0077,"TERARECON AQUARIUS",10)	UN	t	Original Series/Study UID	d
3238	(300d,"TOMO_HA_01",14)	UN	t	Unknown	d
3270	(0051,"GEMS_CT_VES_01",01)[<0>](0040,1001)	SH	t	CTVESequence:Requested Procedure ID	d
4924	(5001,"ELSCINT1",9f)	LO	t	Unknown	d
4193	(0043,"dcm4che/archive",45)	SL	t	Unknown	d
4057	(0019,"",0f)	SH	t	Unknown	d
4706	(300a,03a0)[<0>](300b,"IMPAC",11)	UN	t	Ion Tolerance Table Sequence:Unknown	d
4794	(0053,"GEHC_CT_ADVAPP_001",66)	OB	t	Image Browser Annotation	d
4900	(0045,"GEMS_HELIOS_01",52)	CS	t	Unknown	d
4931	(5001,"ELSCINT1",b4)	CS	t	Unknown	d
4912	(0053,"GEHC_CT_ADVAPP_001",68)	OB	t	Row Number Anotation Flag	d
5380	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](3006,00c8)	LO	t	Unknown:Registration Sequence:Matrix Registration Sequence:Frame of Reference Transformation Comment	d
4936	(5001,"ELSCINT1",a6)	US	t	Unknown	d
3830	(0019,"",cc)	UN	t	Unknown	d
4708	(300a,03a2)[<0>](300b,"IMPAC",0e)	UN	t	Ion Beam Sequence:Unknown	d
4749	(00e1,"ELSCINT1",40)	CS	t	Image Label	d
4735	(01e1,"ELSCINT1",21)	ST	t	Unknown	d
1451	(0009,"GEIIS",68)	UN	t	Unknown	d
4903	(0045,"GEMS_HELIOS_01",50)	FD	t	Unknown	d
5538	(07a3,"ELSCINT1",14)	UN	t	Unknown	d
4920	(5001,"ELSCINT1",90)	ST	t	Unknown	d
4753	(300a,00b0)[<0>](4001,"RAYSEARCHLABS 2.0",01)	UN	t	Beam Sequence:Unknown	d
4926	(5001,"ELSCINT1",a3)	LO	t	Unknown	d
4840	(0009,"GEMS_IDEN_01",27)	OB	t	ImageActualDate	d
4928	(5001,"ELSCINT1",a2)	CS	t	Unknown	d
4741	(01f7,"ELSCINT1",86)	UN	t	Unknown	d
5510	(07a1,"ELSCINT1",87)	LT	t	Unknown	d
5539	(07a5,"ELSCINT1",54)	UN	t	Unknown	d
5535	(0009,"GEMS_PETD_01",f6)	UN	t	Unknown	d
6527	(0023,"AMICAS0",19)	US	t	Unknown	d
6539	(0029,"SPI-P-Private_ICS Release 1",67)	LO	t	Unknown	d
6541	(0029,"SPI-P-Private_ICS Release 1;5",50)	CS	t	Unknown	d
5536	(0015,"GEMS_PETD_01",3d)	UN	t	PET Sharp IR Flag	d
5537	(07a1,"ELSCINT1",a7)	UN	t	Unknown	d
2964	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
4025	(0019,"SIEMENS MR HEADER",0a)	US	t	Number of Images in Mosaic	d
4748	(300a,03a2)[<0>](300a,03a8)[<1>](300b,"IMPAC",17)	UN	t	Ion Beam Sequence:Ion Control Point Sequence:Unknown	d
2955	(0009,"FDMS 1.0",92)	OB	t	KanjiDepartmentName	d
777	(0009,"GEMS_PETD_01",06)	SL	t	Patient Type	d
4740	(01e1,"ELSCINT1",19)	UN	t	Unknown	d
4811	(0045,"GEMS_HELIOS_01",17)	OB	t	Start View 1B	d
2113	(01e1,"ELSCINT1",41)	OW	t	Unknown	d
4703	(300b,"IMPAC",08)	UN	t	Unknown	d
3241	(300a,0010)[<0>](300d,"TOMO_HA_01",17)	UN	t	Dose Reference Sequence:Unknown	d
4934	(5001,"ELSCINT1",c5)	CS	t	Unknown	d
4023	(0043,"",2c)	UN	t	Unknown	d
4925	(5001,"ELSCINT1",a7)	LO	t	Unknown	d
4941	(00e1,"ELSCINT1",84)	OB	t	Unknown	d
4129	(0019,"",27)	UN	t	Unknown	d
4875	(0021,"GEMS_RELA_01",35)	OB	t	SeriesFromWhichPrescribed	d
4916	(0045,"GEMS_HELIOS_01",53)	OB	t	Unknown	d
4820	(0043,"GEMS_PARM_01",2b)	OB	t	PrivateScanOptions	d
4948	(0031,"KONICA1.0",ff)	UN	t	Private Data Sequence	d
4902	(0045,"GEMS_HELIOS_01",54)	FD	t	Unknown	d
4814	(0021,"GEMS_RELA_01",03)	OB	t	SeriesFromWhichPrescribed	d
4927	(5001,"ELSCINT1",9c)	LO	t	Unknown	d
4705	(300a,03a0)[<0>](300b,"IMPAC",01)	UN	t	Ion Tolerance Table Sequence:Unknown	d
3515	(0011,"GEMS_GDXE_FALCON_04",04)	CS	t	Acquisition Type	d
5530	(0009,"GEMS_PETD_01",f4)	UN	t	Unknown	d
5527	(0009,"GEMS_PETD_01",f5)	UN	t	Unknown	d
5524	(0095,"SIENET",fa)	UN	t	Unknown	d
5523	(0095,"SIENET",04)	UL	t	FolderReportedStatus	d
5532	(0009,"GEMS_PETD_01",f9)	UN	t	Unknown	d
5526	(0009,"GEMS_PETD_01",f2)	UN	t	PET tracerInjection_UID	d
5525	(0095,"SIENET",0c)	SL	t	Unknown	d
4736	(01f1,"ELSCINT1",39)	LO	t	Unknown	d
4724	(300a,03a2)[<0>](4001,"RAYSEARCHLABS 2.0",01)	UN	t	Ion Beam Sequence:Unknown	d
4742	(01e1,"ELSCINT1",1b)	UN	t	Unknown	d
4709	(300a,03a2)[<0>](300b,"IMPAC",04)	UN	t	Ion Beam Sequence:Unknown	d
4745	(300a,03a2)[<0>](300b,"IMPAC",02)	FL	t	Ion Beam Sequence:Unknown	d
5544	(01f3,"ELSCINT1",11)		t	Unknown	d
5542	(f215,"PB group A",17)	UN	t	Unknown	d
4704	(300a,03a2)[<0>](300a,0420)[<1>](3291,"Varian Medical Systems VISION 3291",00)	UN	t	Ion Beam Sequence:General Accessory Sequence:Unknown	d
5533	(0009,"GEMS_PETD_01",f3)	UN	t	Unknown	d
4744	(300a,03a2)[<0>](300b,"IMPAC",0e)	FL	t	Ion Beam Sequence:Unknown	d
4890	(0137,"NetRAAD",0e)	UN	t	Unknown	d
5534	(0009,"GEMS_PETD_01",f1)	UN	t	PET prompt gamma	d
5540	(07a5,"ELSCINT1",98)	UN	t	Unknown	d
4914	(0045,"GEMS_HELIOS_01",54)	OB	t	Unknown	d
5545	(01f3,"ELSCINT1",01)		t	Unknown	d
3567	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",01)	CS	t	Presentation State Sequence:Unknown	d
3562	(200b,"Philips RAD Imaging DD 097",89)	LT	t	Unknown	d
3569	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",75)	CS	t	Presentation State Sequence:Unknown	d
3568	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0004)	CS	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Anchor Point Annotation Units	d
3564	(200b,"Philips RAD Imaging DD 097",a0)	LT	t	Unknown	d
3561	(200b,"Philips RAD Imaging DD 097",60)	LT	t	Unknown	d
5391	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)[<2>](0020,0032)	DS	t	Unknown:Unknown:Unknown:Image Position (Patient)	d
3918	(0009,"",e7)	UN	t	Unknown	d
4943	(01f1,"ELSCINT1",31)	CS	t	Unknown	d
4922	(5001,"ELSCINT1",9d)	FL	t	Unknown	d
4935	(5001,"ELSCINT1",a4)	US	t	Unknown	d
4908	(01f1,"ELSCINT1",40)	CS	t	Unknown	d
3566	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0015)	CS	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Anchor Point Visibility	d
3563	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",a0)	LT	t	Presentation State Sequence:Unknown	d
3565	(200b,"Philips RAD Imaging DD 097",88)	CS	t	Unknown	d
4918	(0053,"GEHC_CT_ADVAPP_001",6b)	OB	t	Unknown	d
5531	(0015,"GEMS_PETD_01",3e)	UN	t	PET Scatter Limit	d
5528	(0009,"GEMS_PETD_01",f7)	UN	t	Unknown	d
5529	(0009,"GEMS_PETD_01",f8)	UN	t	Unknown	d
4812	(0021,"GEMS_RELA_01",36)	OB	t	ImageFromWhichPrescribed	d
4932	(5001,"ELSCINT1",a5)	CS	t	Unknown	d
4792	(0009,"GEMS_IDEN_01",04)	OB	t	ProductId	d
4951	(0031,"AGFA CD BURNING ATTRIBUTES 1.0",00)	UN	t	Unknown	d
3571	(200b,"Philips RAD Imaging DD 001",52)	CS	t	Unknown	d
3570	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0002)	CS	t	Presentation State Sequence:Graphic Annotation Sequence:Graphic Layer	d
4170	(0029,"SIEMENS CSA REPORT",15)	US	t	SR Variant	d
1568	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",64)	UN	t	Unknown	d
2927	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",80)	SQ	t	Unknown:Unknown	d
3618	(0051,"SIEMENS MR HEADER",15)	UN	t	Unknown	d
5548	(00e1,"ELSCINT1",e3)	US	t	Unknown	d
5552	(2005,"Philips MR Imaging DD 006",63)	UN	t	Unknown	d
3617	(0029,"MITRA MARKUP 1.0",02)	UN	t	Markup3	d
5549	(2005,"Philips MR Imaging DD 006",62)	UN	t	Unknown	d
3623	(0029,"MITRA MARKUP 1.0",08)	UN	t	Markup9	d
3624	(0029,"MITRA MARKUP 1.0",09)	UN	t	Markup10	d
3628	(0029,"MITRA MARKUP 1.0",06)	UN	t	Markup7	d
3625	(0029,"MITRA MARKUP 1.0",04)	UN	t	Markup5	d
3626	(0029,"MITRA MARKUP 1.0",0a)	UN	t	Unknown	d
3627	(0029,"MITRA MARKUP 1.0",07)	UN	t	Markup8	d
5554	(2005,"Philips MR Imaging DD 006",86)	UN	t	Unknown	d
5556	(2005,"Philips MR Imaging DD 006",76)	UN	t	Unknown	d
5555	(2005,"Philips MR Imaging DD 006",83)	UN	t	Unknown	d
5557	(2005,"Philips MR Imaging DD 006",81)	UN	t	Unknown	d
4169	(0029,"SIEMENS CSA REPORT",17)	UI	t	SC SOP Instance UID	d
4010	(0043,"",10)	UN	t	Unknown	d
3494	(0011,"GEMS_GDXE_FALCON_04",35)	DS	t	Uncompensated Detector Exposure	d
3498	(0011,"GEMS_GDXE_FALCON_04",19)	DS	t	Film Speed Selection	d
3480	(0045,"GEMS_FALCON_03",69)	IS	t	Collimator Rotation	d
3482	(0045,"GEMS_FALCON_03",63)	IS	t	User Window Width	d
3477	(0011,"GEMS_GDXE_FALCON_04",31)	IS	t	Detected Field of View	d
3478	(0011,"GEMS_GDXE_FALCON_04",32)	IS	t	Adjusted Field of View	d
3927	(0043,"",8a)	UN	t	Unknown	d
4002	(0019,"",9c)	UN	t	Unknown	d
3504	(0045,"GEMS_FALCON_03",67)	DS	t	VOI LUT Assymmetry Parameter Beta	d
3517	(0011,"GEMS_GDXE_FALCON_04",44)	CS	t	Receptor Type	d
1370	(01f7,"ELSCINT1",15)	OW	t	Unknown	d
5565	(2005,"Philips MR Imaging DD 006",73)	UN	t	Unknown	d
5566	(2005,"Philips MR Imaging DD 006",82)	UN	t	Unknown	d
4053	(0033,"",04)	CS	t	Unknown	d
3531	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",78)	IS	t	Presentation State Sequence:Unknown	d
3532	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",7d)	IS	t	Presentation State Sequence:Unknown	d
3526	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0006)	ST	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Unformatted Text Value	d
3528	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",54)	ST	t	Presentation State Sequence:Unknown	d
3533	(200b,"Philips RAD Imaging DD 001",05)	IS	t	Unknown	d
5567	(2005,"Philips MR Imaging DD 006",71)	UN	t	Unknown	d
3537	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0014)	FL	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Anchor Point	d
5371	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030d)	SQ	t	Unknown:Registration Sequence:Matrix Registration Sequence:Registration Type Code Sequence	d
5573	(2005,"Philips MR Imaging DD 006",72)	UN	t	Unknown	d
5572	(2005,"Philips MR Imaging DD 006",66)	UN	t	Unknown	d
3545	(200b,"Philips RAD Imaging DD 001",27)	DT	t	Unknown	d
3550	(200b,"Philips RAD Imaging DD 001",4c)	SH	t	Unknown	d
3544	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",02)	SS	t	Presentation State Sequence:Unknown	d
3549	(2001,"Philips Imaging DD 001",6e)	SH	t	Series Type	d
5569	(2005,"Philips MR Imaging DD 006",75)	UN	t	Unknown	d
3551	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",82)	LO	t	Presentation State Sequence:Unknown	d
5576	(2005,"Philips MR Imaging DD 006",59)	UN	t	Unknown	d
3540	(200b,"Philips RAD Imaging DD 097",9f)[<0>](0008,0018)	UI	t	Unknown:SOP Instance UID	d
5430	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)[<2>](0020,0037)	DS	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence:Image Orientation (Patient)	d
5581	(2005,"Philips MR Imaging DD 006",58)	UN	t	Unknown	d
5431	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)[<2>](0064,0009)	OF	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence:Vector Grid Data	d
3575	(200b,"Philips RAD Imaging DD 001",2e)	UN	t	Unknown	d
3586	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0c)	LO	t	Unknown	d
3573	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",72)	FD	t	Presentation State Sequence:Unknown	d
2995	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1389	(01f7,"ELSCINT1",74)	OW	t	Unknown	d
5393	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)[<2>](0028,0030)	DS	t	Unknown:Unknown:Unknown:Pixel Spacing	d
4545	(0043,"GEMS_PARM_01",b1)	UN	t	Unknown	d
5349	(0077,"TERARECON AQUARIUS",98)	UN	t	Unknown	d
4505	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",03)	UN	t	Unknown	d
3308	(0035,"AGFA STUDY COMMENTS 1.0",00)	LT	t	Unknown	d
3311	(0029,"MITRA PRESENTATION 1.0",12)	CS	t	Unknown	d
3312	(0029,"MITRA PRESENTATION 1.0",10)	CS	t	Unknown	d
5388	(0071,"BLACKFORD",04)[<0>](0010,0010)	PN	t	Unknown:Patient's Name	d
3313	(0029,"MITRA PRESENTATION 1.0",11)	CS	t	Unknown	d
3352	(0035,"AGFA KOSD 1.0",01)	UN	t	Unknown	d
3369	(0029,"MITRA PRESENTATION 1.0",10)	UN	t	Unknown	d
3370	(0029,"MITRA PRESENTATION 1.0",11)	UN	t	Unknown	d
3373	(0019,"Agfa ADC NX",fa)	IS	t	Unknown	d
3374	(0019,"Agfa ADC NX",fb)	FL	t	Unknown	d
3375	(0019,"Agfa ADC NX",21)	FL	t	Unknown	d
3384	(0019,"Agfa ADC NX",fd)	CS	t	Unknown	d
3385	(0019,"Agfa ADC NX",28)	CS	t	Unknown	d
3387	(0019,"Agfa ADC NX",07)	CS	t	Unknown	d
3389	(0019,"Agfa ADC NX",fe)	CS	t	Unknown	d
3394	(0035,"AGFA STUDY COMMENTS 1.0",00)	UN	t	Unknown	d
3409	(0029,"MITRA MARKUP 1.0",05)	UN	t	Markup6	d
3813	(0051,"",19)	UN	t	Unknown	d
3821	(0051,"",0a)	UN	t	Unknown	d
3310	(0029,"MITRA PRESENTATION 1.0",13)	CS	t	Unknown	d
3332	(0035,"AGFA KOSD 1.0",03)	LT	t	Unknown	d
3548	(200b,"Philips RAD Imaging DD 001",48)	SH	t	Unknown	d
3367	(0029,"MITRA PRESENTATION 1.0",13)	UN	t	Unknown	d
3368	(0029,"MITRA PRESENTATION 1.0",12)	UN	t	Unknown	d
3372	(0019,"Agfa ADC NX",fc)	IS	t	Unknown	d
3553	(200b,"Philips RAD Imaging DD 001",11)	LO	t	Unknown	d
3605	(0019,"SIEMENS MR HEADER",08)	UN	t	Unknown	d
3530	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",85)	IS	t	Presentation State Sequence:Unknown	d
3542	(200b,"Philips RAD Imaging DD 097",7e)	UI	t	Unknown	d
3491	(0045,"GEMS_FALCON_03",55)	DS	t	A_Coefficients used in Multiresolution Algorithm	d
3520	(0011,"GEMS_GDXE_FALCON_04",10)	SL	t	Total Exposures	d
3543	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",65)	SS	t	Presentation State Sequence:Unknown	d
3572	(200b,"Philips RAD Imaging DD 001",2c)	TM	t	Unknown	d
3521	(0011,"GEMS_GDXE_FALCON_04",40)	SL	t	Pasting Overlap	d
3524	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)	SQ	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence	d
3560	(200b,"Philips RAD Imaging DD 097",63)	LT	t	Unknown	d
3492	(0011,"GEMS_GDXE_FALCON_04",33)	DS	t	Detector Exposure Index	d
3576	(200b,"Philips RAD Imaging DD 001",30)	UN	t	Unknown	d
3489	(0011,"GEMS_GDXE_FALCON_04",42)	LO	t	View IP	d
3497	(0011,"GEMS_GDXE_FALCON_04",15)	DS	t	Detector ARC Gain	d
3523	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)	SQ	t	Presentation State Sequence:Graphic Annotation Sequence	d
3536	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0010)	FL	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Bounding Box Top Left Hand Corner	d
3519	(0011,"GEMS_GDXE_FALCON_04",17)	UN	t	Override Mode	d
3483	(0011,"GEMS_GDXE_FALCON_04",13)	UI	t	SPS UID	d
3541	(200b,"Philips RAD Imaging DD 001",42)	UI	t	Unknown	d
3589	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",13)	PN	t	Unknown	d
3582	(200b,"Philips RAD Imaging DD 001",01)	US	t	Unknown	d
3607	(0051,"SIEMENS MR HEADER",17)	UN	t	Unknown	d
3547	(200b,"Philips RAD Imaging DD 001",41)	SH	t	Unknown	d
3508	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",11)	LT	t	Pixel Data References (temporary)	d
3578	(200b,"Philips RAD Imaging DD 001",2f)	UN	t	Unknown	d
3595	(0051,"SIEMENS MR HEADER",16)	UN	t	Unknown	d
3535	(200b,"Philips RAD Imaging DD 097",7a)	IS	t	Unknown	d
3581	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",7c)	US	t	Presentation State Sequence:Unknown	d
3588	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",19)	PN	t	Unknown	d
3505	(0011,"GEMS_GDXE_FALCON_04",16)	LT	t	Processing Debug Info	d
3539	(200b,"Philips RAD Imaging DD 097",9f)[<0>](0008,0016)	UI	t	Unknown:SOP Class UID	d
3490	(0011,"GEMS_GDXE_FALCON_04",37)	DS	t	DEI Lower & Upper Limit Values	d
4316	(0137,"NetRAAD",01)	SH	t	Unknown	d
2844	(01f1,"ELSCINT1",4a)	OB	t	Unknown	d
3814	(0051,"",17)	UN	t	Unknown	d
4366	(07a1,"ELSCINT1",02)	UN	t	Unknown	d
3484	(0011,"GEMS_GDXE_FALCON_04",05)	UI	t	Acquisition UID	d
3495	(0011,"GEMS_GDXE_FALCON_04",34)	DS	t	Compensated Detector Exposure	d
3496	(0011,"GEMS_GDXE_FALCON_04",36)	DS	t	Median Anatomy Count Value	d
3580	(200b,"Philips RAD Imaging DD 001",02)	US	t	Unknown	d
3585	(200b,"Philips RAD Imaging DD 001",47)	DA	t	Unknown	d
3525	(200b,"Philips RAD Imaging DD 097",9f)	SQ	t	Unknown	d
3486	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",20)	SS	t	Auto Push Tag	d
3488	(0011,"GEMS_GDXE_FALCON_04",46)	LO	t	Unknown	d
3516	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",25)	CS	t	PPS Status	d
3556	(200b,"Philips RAD Imaging DD 001",00)	PN	t	Unknown	d
3538	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](0070,0011)	FL	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Bounding Box Bottom Right Hand Corner	d
3546	(200b,"Philips RAD Imaging DD 001",4f)	DT	t	Unknown	d
3522	(0011,"GEMS_GDXE_FALCON_04",09)	SL	t	Non-Digital Exposures	d
3552	(200b,"Philips RAD Imaging DD 001",3b)	LO	t	Unknown	d
3599	(0051,"SIEMENS MR HEADER",0c)	UN	t	Unknown	d
3584	(200b,"Philips RAD Imaging DD 001",2b)	DA	t	Unknown	d
3502	(0011,"GEMS_GDXE_FALCON_04",47)	DS	t	Unknown	d
3587	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",16)	PN	t	Unknown	d
3591	(0051,"SIEMENS MR HEADER",0d)	UN	t	Unknown	d
3506	(7fdf,"GEMS_GDXE_ATHENAV2_INTERNAL_USE",10)	LT	t	Pixel Data References	d
3485	(0011,"GEMS_GDXE_FALCON_04",03)	UI	t	Processed Series UID	d
3583	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",7b)	US	t	Presentation State Sequence:Unknown	d
5410	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0020,000e)	UI	t	Unknown:Unknown:Series Instance UID	d
4203	(5653,"",17)	OB	t	Unknown	d
3769	(0079,"Unnamed Private Block - 10",13)	DS	t	Unknown	d
2939	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",70)	SQ	t	Unknown:Unknown	d
3558	(200b,"Philips RAD Imaging DD 001",29)	DS	t	Unknown	d
3092	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",61)	OB	t	Unknown:Unknown	d
4482	(0043,"GEMS_PARM_01",63)	SH	t	Raw Data ID	d
3527	(200b,"Philips RAD Imaging DD 097",00)	ST	t	Unknown	d
3479	(0045,"GEMS_FALCON_03",62)	IS	t	User Window Center	d
3579	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",a1)	UN	t	Presentation State Sequence:Unknown	d
3577	(200b,"Philips RAD Imaging DD 097",b7)	UN	t	Unknown	d
3529	(200b,"Philips RAD Imaging DD 001",2a)	UL	t	Unknown	d
3554	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](2001,"Philips Imaging DD 001",6d)	LO	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Text Font	d
3555	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",81)	LO	t	Presentation State Sequence:Unknown	d
3559	(200b,"Philips RAD Imaging DD 001",28)	DS	t	Unknown	d
3574	(200b,"Philips RAD Imaging DD 097",b9)	UN	t	Unknown	d
3507	(0011,"GEMS_GDXE_FALCON_04",12)	LT	t	Patient Size String	d
3557	(200b,"Philips RAD Imaging DD 097",90)	DS	t	Unknown	d
3534	(200b,"Philips RAD Imaging DD 097",79)	IS	t	Unknown	d
4518	(5001,"vRad PACS",54)	UN	t	Unknown	d
4477	(1111,"2.16.840.1.114330.1.1.1.1",11)	SL	t	Unknown	d
5370	(0071,"BLACKFORD",04)[<0>](0070,0308)[<1>](0070,0309)[<2>](0070,030a)	SQ	t	Unknown:Registration Sequence:Matrix Registration Sequence:Matrix Sequence	d
5518	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",44)	OW	t	Blob Data Object Array:Blob Data	d
3597	(0051,"SIEMENS MR HEADER",0f)	UN	t	Coil String	k
5423	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0005)[<2>](0064,0007)	UL	t	Unknown:Deformable Registration Sequence:Deformable Registration Grid Sequence:Grid Dimensions	d
3139	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2886	(00e1,"ELSCINT1",39)[<0>](0008,1110)[<1>](0008,1155)	UI	t	Unknown:Referenced Study Sequence:Referenced SOP Instance UID	d
3145	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",70)	OB	t	Unknown:Unknown	d
3024	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3117	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",42)	OB	t	Unknown:Unknown	d
3287	(300a,00b0)[<0>](3243,"Varian Medical Systems VISION 3243",09)	UN	t	Beam Sequence:Unknown	d
5638	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0070,0084)	PN	t	Advanced Presentation Sequence:Content Creator's Name	d
5633	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,0081)	LO	t	Advanced Presentation Sequence:Presentation State Sequence:Content Description	d
3176	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
1640	(0047,"GEMS_3DSTATE_001",eb)	DS	t	Unknown	d
5464	(00e1,"ELSCINT1",c4)	UN	t	Unknown	d
2944	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",10)	SQ	t	Unknown:Unknown	d
5298	(2005,"Philips MR Imaging DD 005",91)	UN	t	Original Modality LUT Sequence	d
5465	(01f7,"ELSCINT1",92)	UN	t	Unknown	d
1483	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",30)	UN	t	Unknown	d
1476	(0009,"Unnamed Private Block - 10",3b)	UN	t	Unknown	d
5140	(2005,"Philips MR Imaging DD 005",02)	OB	t	Unknown	d
2855	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",14)	OB	t	Unknown:Unknown	d
4037	(0051,"",09)	LO	t	Unknown	d
5467	(01f1,"ELSCINT1",56)	UN	t	Unknown	d
5469	(00e1,"ELSCINT1",46)	UN	t	Unknown	d
2940	(0023,"FDMS 1.0",10)	SQ	t	Unknown	d
4231	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)[<1>](2005,"Philips MR Imaging DD 004",83)	UN	t	Presentation State Sequence:Viewing Protocol:Sort Attributes	d
2946	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",30)	SQ	t	Unknown:Unknown	d
3120	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",80)	OB	t	Unknown:Unknown	d
4180	(0043,"dcm4che/archive",41)	FL	t	Unknown	d
4235	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)[<1>](2005,"Philips MR Imaging DD 004",87)	UN	t	Presentation State Sequence:Viewing Protocol:Display Layout Number of Columns	d
3160	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3011	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
2888	(00e1,"ELSCINT1",39)[<0>](0008,1111)[<1>](0008,1150)	UI	t	Unknown:Referenced Performed Procedure Step Sequence:Referenced SOP Class UID	d
2983	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3641	(0011,"GEMS_GDXE_FALCON_04",66)	UN	t	Unknown	d
1617	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",59)	UN	t	Unknown	d
3740	(0021,"Siemens: Thorax/Multix FD Post Processing",14)	US	t	Anatomic Correct View	d
3662	(2001,"Philips Imaging DD 129",00)[<0>](0070,0001)[<1>](0070,0008)[<2>](2001,"Philips Imaging DD 001",c1)	LO	t	Presentation State Sequence:Graphic Annotation Sequence:Text Object Sequence:Linear Modality GL Transform	d
5680	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",38)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Referenced Frames Sequence:Referenced Syngo UID	d
3201	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
5488	(07a1,"ELSCINT1",8c)	ST	t	Unknown	d
5303	(2001,"Philips Imaging DD 002",76)	UN	t	Unknown	d
5477	(3711,"A.L.I. Technologies, Inc.",0e)	CS	t	Anonymization Status	d
5466	(01f1,"ELSCINT1",54)	UN	t	Unknown	d
3691	(0040,030e)[<0>](01e1,"ELSCINT1",26)	UN	t	Exposure Dose Sequence:Phantom Type	d
5485	(07a3,"ELSCINT1",f5)	LO	t	Unknown	d
5486	(07a1,"ELSCINT1",92)	ST	t	Unknown	d
5107	(0009,"GEIIS",10)	OB	t	GE Private Image Thumbnail Sequence	d
5274	(2001,"Philips Imaging DD 001",63)	OB	t	ExaminationSource	d
2892	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0008)[<2>](0008,0102)	SH	t	Unknown:Request Attributes Sequence:Scheduled Protocol Code Sequence:Coding Scheme Designator	d
1484	(0019,"SIEMENS MR HEADER",08)	CS	t	Unknown	d
2966	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3768	(0079,"Unnamed Private Block - 10",0a)	DS	t	Unknown	d
5487	(07a1,"ELSCINT1",9b)	ST	t	Unknown	d
1584	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",20)	UN	t	Unknown	d
5478	(07a3,"ELSCINT1",fb)	DT	t	Unknown	d
2999	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
4233	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)[<1>](2005,"Philips MR Imaging DD 004",85)	UN	t	Presentation State Sequence:Viewing Protocol:Image Display Direction	d
3202	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
5494	(07a3,"ELSCINT1",f3)	CS	t	Unknown	d
5481	(07a3,"ELSCINT1",f2)	CS	t	Unknown	d
5522	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",43)	SL	t	Blob Data Object Array:Actual Blob Size	d
5519	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",47)	CS	t	Blob Data Object Array:Blob Flag	d
3987	(0029,"",34)	UN	t	Unknown	d
2997	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3288	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)	SQ	t	Unknown:Unknown	d
2804	(01f1,"ELSCINT1",02)	OB	t	Focal Spot Resolution	d
1939	(01f1,"ELSCINT1",38)	LO	t	Unknown	d
5513	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",37)	LO	t	Blob Data Object Array:Blob Name	d
5515	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",41)	LO	t	Blob Data Object Array:Comment String	d
5514	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",38)	LO	t	Blob Data Object Array:Application Name	d
5517	(2005,"Philips MR Imaging DD 002",32)[<0>](2005,"Philips MR Imaging DD 002",39)	LO	t	Blob Data Object Array:Type Name	d
5512	(2005,"Philips MR Imaging DD 002",32)	SQ	t	Blob Data Object Array	d
4044	(0051,"",0c)	LO	t	Unknown	d
3793	(0051,"",0c)	UN	t	Unknown	d
480	(0019,"GEMS_ACQU_01",b9)	DS	t	UserData	d
1284	(0009,"GEMS_IDEN_01",0d)	UN	t	Unknown	d
3696	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",09)	FL	t	Unknown	d
3854	(0019,"",8b)	UN	t	Unknown	d
2993	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",83)	OB	t	Unknown:Unknown	d
1821	(01f3,"ELSCINT1",01)	SQ	t	Unknown	d
1697	(0013,"CTP",20)	LO	t	Unknown	d
2961	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",15)	OB	t	Unknown:Unknown	d
2587	(0013,"CTP",50)	UN	t	Unknown	d
4364	(07a3,"ELSCINT1",5c)	UN	t	Unknown	d
4463	(2111,"Viztek OPALRAD PrivateGroup",10)	UT	t	Unknown	d
2766	(0031,"AGFA PACS Archive Mirroring 1.0",00)	LT	t	Unknown	d
1882	(0073,"STENTOR",04)	ST	t	Unknown	d
1879	(0097,"SIENET",03)	UN	t	Unknown	d
3086	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",31)	OB	t	Unknown:Unknown	d
2884	(00e1,"ELSCINT1",39)[<0>](0008,1111)[<1>](0008,1155)	UI	t	Unknown:Referenced Performed Procedure Step Sequence:Referenced SOP Instance UID	d
4320	(0137,"NetRAAD",40)	CS	t	Unknown	d
3104	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",73)	OB	t	Unknown:Unknown	d
1362	(01f1,"ELSCINT1",4e)	LO	t	Unknown	d
4168	(0029,"SIEMENS CSA REPORT",08)	CS	t	Report Type	d
3951	(0021,"",83)	UN	t	Unknown	d
4232	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)[<1>](2005,"Philips MR Imaging DD 004",86)	UN	t	Presentation State Sequence:Viewing Protocol:Inset Scanogram	d
3257	(0029,"INTELERAD MEDICAL SYSTEMS",01)	UN	t	ImageCompressionFraction	d
4343	(01f1,"ELSCINT1",0f)	CS	t	Unknown	d
5468	(01f1,"ELSCINT1",0f)	UN	t	Unknown	d
3762	(0079,"Unnamed Private Block - 10",0b)	IS	t	Unknown	d
1635	(07a1,"ELSCINT1",43)	IS	t	Unknown	d
4085	(700d,"TOSHIBA_MEC_MR3",09)	SS	t	Original Data Flag	d
3731	(0021,"Siemens: Thorax/Multix FD Post Processing",16)	DS	t	Auto Window Expansion	d
4358	(07a3,"ELSCINT1",b9)	UN	t	Unknown	d
4363	(07a5,"ELSCINT1",ae)	UN	t	Unknown	d
3989	(0019,"",1a)	UN	t	Unknown	d
1226	(0029,"SIEMENS MEDCOM OOG",08)	CS	t	MEDCOMOOGType	d
5476	(0013,"GEMS_PETD_01",01)		t	Unknown	d
5475	(0013,"GEMS_PETD_01",01)	SQ	t	Unknown	d
4004	(0019,"",df)	UN	t	Unknown	d
4243	(0077,"NIL_nICE_ATT",03)	SS	t	Unknown	d
3855	(0019,"",81)	UN	t	Unknown	d
4476	(1111,"2.16.840.1.114330.1.1.1.1",23)	FD	t	Unknown	d
4496	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",91)	LO	t	Object Action Sequence:Software Title	d
3750	(0021,"Siemens: Thorax/Multix FD Post Processing",09)	SL	t	Auto Window Center	d
3873	(0025,"",11)	UN	t	Unknown	d
3868	(0021,"",37)	UN	t	Unknown	d
3046	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",72)	OB	t	Unknown:Unknown	d
3090	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",61)	OB	t	Unknown:Unknown	d
3094	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",51)	OB	t	Unknown:Unknown	d
3807	(0051,"",0f)	UN	t	Unknown	d
5332	(0015,"GEMS_PETD_01",20)	UN	t	First Packet Number	d
3748	(0019,"Siemens: Thorax/Multix FD Lab Settings",08)	US	t	Ortho Step Distance	d
4209	(5653,"",15)[<0>](0020,0032)	DS	t	Unknown:Image Position (Patient)	d
4492	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a1)	ST	t	Object Action Sequence:Object Action	d
4501	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a2)	DA	t	Object Action Sequence:Object Action Date	d
2994	(0029,"FDMS 1.0",30)	OB	t	ExtendedReadingSizeValue	d
3827	(0027,"",30)	UN	t	Unknown	d
3206	(0019,"FDMS 1.0",40)	OB	t	ImageProcessingType	d
3719	(0021,"Siemens: Thorax/Multix FD Post Processing",0b)	SS	t	Filter ID	d
3135	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",a1)	OB	t	Unknown:Unknown	d
4507	(0009,"HMC - CT - ID",01)	OB	t	Image ID Information Patient Comment	d
2880	(00e1,"ELSCINT1",39)	SQ	t	Unknown	d
2736	(2001,"Philips Imaging DD 002",6b)	LO	t	Unknown	d
2709	(2005,"Philips MR Imaging DD 002",34)	UN	t	Series Transaction UID	d
2738	(2005,"Philips MR Imaging DD 002",34)	LT	t	Series Transaction UID	d
2331	(2005,"Philips MR Imaging DD 003",49)	SS	t	Number of Series Operators Name	d
2877	(00e1,"ELSCINT1",39)[<0>](0008,1110)	SQ	t	Unknown:Referenced Study Sequence	d
4506	(0019,"SIEMENS CT VA0  COAD",b1)	LO	t	Unknown	d
4504	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",02)	OB	t	Unknown	d
4494	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",92)	SH	t	Object Action Sequence:Software Version	d
4353	(07a5,"ELSCINT1",56)	UN	t	Unknown	d
4355	(07a1,"ELSCINT1",98)	UN	t	Unknown	d
4361	(07a5,"ELSCINT1",69)	UN	t	Unknown	d
4468	(1111,"2.16.840.1.114330.1.1.1.1",19)	SS	t	Unknown	d
4490	(2111,"Viztek OPALRAD PrivateGroup",10)	UN	t	Unknown	d
4514	(5001,"vRad PACS",71)	UN	t	Unknown	d
4467	(1111,"2.16.840.1.114330.1.1.1.1",01)	UT	t	Unknown	d
4480	(07a1,"ELSCINT1",36)	AE	t	Unknown	d
1524	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",5c)	UN	t	Unknown	d
3881	(0019,"",c8)	UN	t	Unknown	d
3025	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3061	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",90)	OB	t	Unknown:Unknown	d
3636	(0011,"GEMS_GDXE_FALCON_04",76)	UN	t	Unknown	d
3645	(0011,"GEMS_GDXE_FALCON_04",65)	UN	t	Unknown	d
3008	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3010	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1279	(0009,"GEMS_IDEN_01",3b)	UN	t	Unknown	d
2986	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",74)	OB	t	Unknown:Unknown	d
3154	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",90)	OB	t	Unknown:Unknown	d
3285	(01f7,"ELSCINT1",93)	UN	t	Unknown	d
3191	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3239	(300a,0010)[<0>](300d,"TOMO_HA_01",16)	UN	t	Dose Reference Sequence:Unknown	d
3204	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
4194	(0043,"dcm4che/archive",44)	SL	t	Unknown	d
3035	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",33)	OB	t	Unknown:Unknown	d
1282	(0009,"GEMS_IDEN_01",68)	UN	t	Unknown	d
3653	(0011,"GEMS_GDXE_FALCON_04",72)	UN	t	Unknown	d
3244	(300a,00b0)[<0>](300d,"TOMO_HA_01",60)	UN	t	Beam Sequence:Unknown	d
4040	(0051,"",0b)	LO	t	Unknown	d
3822	(0051,"",0b)	UN	t	Unknown	d
4472	(1111,"2.16.840.1.114330.1.1.1.1",10)	FD	t	Unknown	d
3026	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
2921	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",50)	SQ	t	Unknown:Unknown	d
1835	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",16)	FL	t	Unknown:Unknown	d
1839	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",19)	FL	t	Unknown:Unknown	d
1841	(01f3,"ELSCINT1",12)	SS	t	Unknown	d
1789	(07a1,"ELSCINT1",47)	CS	t	Unknown	d
1934	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7a)	US	t	Unknown:Unknown:Unknown	d
1776	(07a3,"ELSCINT1",62)[<0>](07a3,"ELSCINT1",61)	LT	t	Unknown:Unknown	d
1953	(07a3,"ELSCINT1",80)[<0>](0070,0101)	DS	t	Unknown:Presentation Pixel Spacing	d
1912	(07a3,"ELSCINT1",8f)	CS	t	Unknown	d
1738	(07a3,"ELSCINT1",b9)	CS	t	Unknown	d
1733	(07a3,"ELSCINT1",bb)	CS	t	Unknown	d
1750	(07a3,"ELSCINT1",c0)	SQ	t	Unknown	d
1779	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c3)	CS	t	Unknown:Unknown	d
1761	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c5)	LO	t	Unknown:Unknown	d
1758	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c1)	LO	t	Unknown:Unknown	d
3937	(0043,"",34)	UN	t	Unknown	d
2943	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",40)	SQ	t	Unknown:Unknown	d
1452	(0019,"Unnamed Private Block - 10",04)	UN	t	Unknown	d
3702	(0021,"Siemens: Thorax/Multix FD Post Processing",07)	FL	t	Unknown	d
155	(0009,"GEMS_IDEN_01",30)	SH	t	ServiceId	d
4509	(0019,"SET WINDOW",00)	SH	t	Set Window Image Filter	d
3939	(0019,"",d7)	UN	t	Unknown	d
3938	(0043,"",0c)	UN	t	Unknown	d
3935	(0025,"",14)	UN	t	Unknown	d
3053	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3157	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2140	(0009,"GEMS_GENIE_1",11)	SL	t	StudyFlags	d
4555	(0043,"GEMS_PARM_01",b3)	UN	t	Unknown	d
3699	(0021,"Siemens: Thorax/Multix FD Post Processing",0c)	FL	t	Unknown	d
3141	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",70)	OB	t	Unknown:Unknown	d
2611	(0023,"GEMS_STDY_01",80)[<0>](0032,1064)	SQ	t	Has MPPS Related Tags:Requested Procedure Code Sequence	d
2613	(0023,"GEMS_STDY_01",80)[<0>](0032,1064)[<1>](0008,0100)	SH	t	Has MPPS Related Tags:Requested Procedure Code Sequence:Code Value	d
2612	(0023,"GEMS_STDY_01",80)[<0>](0032,1064)[<1>](0008,0102)	SH	t	Has MPPS Related Tags:Requested Procedure Code Sequence:Coding Scheme Designator	d
2619	(0023,"GEMS_STDY_01",80)[<0>](0040,0255)	LO	t	Has MPPS Related Tags:Performed Procedure Type Description	d
2616	(0023,"GEMS_STDY_01",80)[<0>](0040,2016)	LO	t	Has MPPS Related Tags:Placer Order Number / Imaging Service Request	d
2617	(0023,"GEMS_STDY_01",80)[<0>](0040,2017)	LO	t	Has MPPS Related Tags:Filler Order Number / Imaging Service Request	d
4000	(0019,"",1e)	UN	t	Unknown	d
2134	(0011,"GEMS_GENIE_1",45)	FD	t	ThresholdWidth	d
2767	(0031,"AGFA PACS Archive Mirroring 1.0",01)	LT	t	Unknown	d
1714	(01f1,"ELSCINT1",30)	US	t	Unknown	d
1739	(07a1,"ELSCINT1",40)	CS	t	Unknown	d
2171	(2005,"Philips MR Imaging DD 005",02)	SQ	t	Unknown	d
2184	(2005,"Philips MR Imaging DD 005",0e)	SQ	t	Private Shared Sequence	d
4558	(07a5,"ELSCINT1",ae)	IS	t	Unknown	d
4516	(5001,"vRad PACS",53)	UN	t	Unknown	d
4556	(07a1,"ELSCINT1",c0)	ST	t	Unknown	d
4365	(07a1,"ELSCINT1",5d)	UN	t	Unknown	d
4544	(0043,"GEMS_PARM_01",aa)	UN	t	Unknown	d
1474	(0009,"Unnamed Private Block - 10",0d)	UN	t	Unknown	d
5304	(0070,005a)[<0>](0008,1140)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Displayed Area Selection Sequence:Referenced Image Sequence:Linear Modality GL Transform	d
2788	(00e1,"ELSCINT1",23)	OB	t	Presentation Relative Part	d
3067	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",33)	OB	t	Unknown:Unknown	d
1548	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",1c)	PN	t	Unknown	d
1792	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c2)	CS	t	Unknown:Unknown	d
2029	(3241,"Varian Medical Systems VISION 3241",05)	UN	t	Unknown	d
3293	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0054,0081)	US	t	Unknown:Unknown:Number of Slices	d
3302	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",1c)	UN	t	Unknown	d
2992	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",83)	OB	t	Unknown:Unknown	d
1520	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",50)	UN	t	Unknown	d
4379	(0015,"GEMS_PETD_01",38)	UL	t	Unknown	d
4360	(07a5,"ELSCINT1",c8)	UN	t	Unknown	d
4513	(5001,"vRad PACS",77)	UN	t	Unknown	d
5294	(2001,"Philips Imaging DD 001",52)	UI	t	Image Presentation State UID	d
1942	(01f1,"ELSCINT1",31)	UN	t	Unknown	d
1941	(01f1,"ELSCINT1",36)	CS	t	Unknown	d
1940	(01f1,"ELSCINT1",37)	DS	t	Unknown	d
4988	(2005,"Philips MR Imaging DD 002",32)		t	Blob Data Object Array	d
3734	(0019,"Siemens: Thorax/Multix FD Lab Settings",06)	FD	t	Table Object Distance	d
2118	(0053,"GEHC_CT_ADVAPP_001",6b)	IS	t	Unknown	d
1011	(0053,"GEHC_CT_ADVAPP_001",6b)	UN	t	Unknown	d
1840	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",02)	SS	t	Unknown:Unknown	d
3148	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",30)	OB	t	Unknown:Unknown	d
1828	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",03)	FL	t	Unknown:Unknown	d
2931	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",70)	SQ	t	Unknown:Unknown	d
1842	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",12)	SS	t	Unknown:Unknown	d
1831	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",14)	FL	t	Unknown:Unknown	d
1859	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",15)	US	t	Unknown:Unknown	d
1834	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",17)	FL	t	Unknown:Unknown	d
1846	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",18)	SH	t	Unknown:Unknown	d
1826	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",24)	IS	t	Unknown:Unknown	d
2861	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",17)	OB	t	Unknown:Unknown	d
1829	(01f3,"ELSCINT1",13)	FL	t	Unknown	d
1833	(01f3,"ELSCINT1",14)	FL	t	Unknown	d
1845	(01f3,"ELSCINT1",18)	SH	t	Unknown	d
1861	(01f3,"ELSCINT1",23)	US	t	Unknown	d
1827	(01f3,"ELSCINT1",24)	IS	t	Unknown	d
1844	(07a1,"ELSCINT1",70)	SH	t	Unknown	d
1930	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7b)	LT	t	Unknown:Unknown:Unknown	d
1928	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7c)	UL	t	Unknown:Unknown:Unknown	d
1924	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7e)	SQ	t	Unknown:Unknown:Unknown	d
1927	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a3,"ELSCINT1",41)	UL	t	Unknown:Unknown:Unknown	d
1753	(07a3,"ELSCINT1",62)	SQ	t	Unknown	d
1791	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c2)	CS	t	Unknown:Unknown	d
1936	(07a1,"ELSCINT1",82)[<0>](07a3,"ELSCINT1",28)	US	t	Unknown:Unknown	d
4957	(2005,"Philips MR Imaging DD 005",02)		t	Unknown	d
1672	(07a1,"ELSCINT1",50)	US	t	Unknown	d
2809	(01f7,"ELSCINT1",2c)	OB	t	Unknown	d
2803	(01f1,"ELSCINT1",08)	OB	t	Acquisition Length	d
4150	(5653,"Vital Images SW 3.4",19)	UI	t	Volume Study Instance UID	d
3701	(0021,"Siemens: Thorax/Multix FD Post Processing",02)	FL	t	Unknown	d
1932	(07a1,"ELSCINT1",82)[<0>](07a3,"ELSCINT1",29)	US	t	Unknown:Unknown	d
1734	(07a1,"ELSCINT1",98)	CS	t	Unknown	d
1727	(07a1,"ELSCINT1",a7)	SH	t	Unknown	d
1868	(07a1,"ELSCINT1",c2)	ST	t	Unknown	d
1755	(07a1,"ELSCINT1",d0)	LO	t	Unknown	d
1948	(07a3,"ELSCINT1",04)[<0>](0008,0018)	UI	t	Unknown:SOP Instance UID	d
1951	(07a3,"ELSCINT1",04)[<0>](0020,000e)	UI	t	Unknown:Series Instance UID	d
1963	(07a3,"ELSCINT1",04)[<0>](0028,0010)	US	t	Unknown:Rows	d
1962	(07a3,"ELSCINT1",04)[<0>](0028,0011)	US	t	Unknown:Columns	d
1950	(07a3,"ELSCINT1",04)[<0>](07a3,"ELSCINT1",08)	UI	t	Unknown:Unknown	d
1886	(07a3,"ELSCINT1",04)[<0>](07a3,"ELSCINT1",0d)	DS	t	Unknown:Unknown	d
1949	(07a3,"ELSCINT1",04)[<0>](07a3,"ELSCINT1",67)	UI	t	Unknown:Unknown	d
1945	(07a3,"ELSCINT1",04)[<0>](07a3,"ELSCINT1",b8)	IS	t	Unknown:Unknown	d
1729	(07a3,"ELSCINT1",13)	SH	t	Unknown	d
1719	(07a3,"ELSCINT1",14)	ST	t	Unknown	d
1823	(07a3,"ELSCINT1",15)	ST	t	Unknown	d
1847	(07a3,"ELSCINT1",17)	SH	t	Unknown	d
1722	(07a3,"ELSCINT1",18)	ST	t	Unknown	d
1720	(07a3,"ELSCINT1",1b)	ST	t	Unknown	d
4510	(0019,"SET WINDOW",01)	US	t	Set Window Magnification Power	d
1724	(07a3,"ELSCINT1",1c)	ST	t	Unknown	d
1725	(07a3,"ELSCINT1",1d)	ST	t	Unknown	d
1721	(07a3,"ELSCINT1",1e)	ST	t	Unknown	d
1723	(07a3,"ELSCINT1",1f)	ST	t	Unknown	d
1822	(07a3,"ELSCINT1",22)	ST	t	Unknown	d
1717	(07a3,"ELSCINT1",23)	ST	t	Unknown	d
1865	(07a3,"ELSCINT1",24)	ST	t	Unknown	d
1969	(07a3,"ELSCINT1",80)[<0>](0070,0052)	SL	t	Unknown:Displayed Area Top Left Hand Corner	d
1960	(07a3,"ELSCINT1",26)	CS	t	Unknown	d
1774	(07a3,"ELSCINT1",43)	DS	t	Unknown	d
1968	(07a3,"ELSCINT1",80)[<0>](0070,0053)	SL	t	Unknown:Displayed Area Bottom Right Hand Corner	d
1944	(07a3,"ELSCINT1",b6)	IS	t	Unknown	d
1796	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c8)	AE	t	Unknown:Unknown	d
1786	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c9)	CS	t	Unknown:Unknown	d
1752	(07a3,"ELSCINT1",c6)	SQ	t	Unknown	d
1794	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c2)	CS	t	Unknown:Unknown	d
1778	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c3)	CS	t	Unknown:Unknown	d
4497	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a3)	TM	t	Object Action Sequence:Object Action Time	d
1760	(07a1,"ELSCINT1",75)	LO	t	Unknown	d
1925	(07a1,"ELSCINT1",82)	SQ	t	Unknown	d
1926	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)	SQ	t	Unknown:Unknown	d
1929	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",79)	SS	t	Unknown:Unknown:Unknown	d
1933	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7d)	US	t	Unknown:Unknown:Unknown	d
1736	(07a1,"ELSCINT1",88)	CS	t	Unknown	d
1911	(07a3,"ELSCINT1",5c)	ST	t	Unknown	d
1783	(07a3,"ELSCINT1",65)	CS	t	Unknown	d
2610	(0023,"GEMS_STDY_01",80)	SQ	t	Has MPPS Related Tags	d
2764	(0029,"MITRA MARKUP 1.0",00)	LO	t	Markup1	d
1875	(0091,"SIENET",20)	UN	t	RIS Patient Name	d
1871	(0095,"SIENET",01)	LO	t	ExaminationFolderID	d
1914	(01f1,"ELSCINT1",43)	LO	t	Unknown	d
1837	(01f3,"ELSCINT1",17)	FL	t	Unknown	d
1816	(07a1,"ELSCINT1",5d)	DT	t	Unknown	d
1938	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",78)	SL	t	Unknown:Unknown	d
1885	(07a3,"ELSCINT1",04)	SQ	t	Unknown	d
1863	(07a3,"ELSCINT1",19)	ST	t	Unknown	d
1864	(07a3,"ELSCINT1",1a)	ST	t	Unknown	d
1806	(07a3,"ELSCINT1",b4)	US	t	Unknown	d
1770	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c4)	LO	t	Unknown:Unknown	d
1764	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c5)	LO	t	Unknown:Unknown	d
1799	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c8)	AE	t	Unknown:Unknown	d
1787	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",c9)	CS	t	Unknown:Unknown	d
1749	(07a3,"ELSCINT1",ca)	SQ	t	Unknown	d
1759	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c1)	LO	t	Unknown:Unknown	d
1793	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c2)	CS	t	Unknown:Unknown	d
1781	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c3)	CS	t	Unknown:Unknown	d
1769	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c4)	LO	t	Unknown:Unknown	d
1763	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c5)	LO	t	Unknown:Unknown	d
1798	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c8)	AE	t	Unknown:Unknown	d
1782	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",c9)	CS	t	Unknown:Unknown	d
1765	(07a3,"ELSCINT1",ca)[<0>](07a3,"ELSCINT1",cc)	LO	t	Unknown:Unknown	d
1751	(07a3,"ELSCINT1",cb)	SQ	t	Unknown	d
1756	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c1)	LO	t	Unknown:Unknown	d
1780	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c3)	CS	t	Unknown:Unknown	d
1771	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c4)	LO	t	Unknown:Unknown	d
1762	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c5)	LO	t	Unknown:Unknown	d
1797	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c8)	AE	t	Unknown:Unknown	d
1785	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",c9)	CS	t	Unknown:Unknown	d
1754	(07a3,"ELSCINT1",ce)	SQ	t	Unknown	d
1795	(07a3,"ELSCINT1",ce)[<0>](0028,0004)	CS	t	Unknown:Photometric Interpretation	d
1800	(07a3,"ELSCINT1",ce)[<0>](0028,0010)	US	t	Unknown:Rows	d
1801	(07a3,"ELSCINT1",ce)[<0>](0028,0011)	US	t	Unknown:Columns	d
1773	(07a3,"ELSCINT1",ce)[<0>](0028,0034)	IS	t	Unknown:Pixel Aspect Ratio	d
1804	(07a3,"ELSCINT1",ce)[<0>](0028,0100)	US	t	Unknown:Bits Allocated	d
1777	(07a3,"ELSCINT1",ce)[<0>](7fe0,0010)	OB	t	Unknown:Pixel Data	d
1726	(07a5,"ELSCINT1",54)	DT	t	Unknown	d
2729	(2005,"Philips MR Imaging DD 006",58)	FL	t	Unknown	d
2026	(3006,0080)[<0>](3773,"MIM Software Inc.",05)	UN	t	RT ROI Observations Sequence:Unknown	d
2028	(3241,"Varian Medical Systems VISION 3241",00)	UN	t	Unknown	d
2034	(3241,"Varian Medical Systems VISION 3241",06)	UN	t	Unknown	d
2071	(3773,"Unnamed Private Block - 01",30)	UN	t	Unknown	d
2615	(4453,"DR Systems, Inc.",00)	LO	t	Exam ?	d
3020	(50f1,"FDMS 1.0",20)	OB	t	Image Processing Modification Flag	d
1850	(07a5,"ELSCINT1",62)	LO	t	Unknown	d
1790	(07a5,"ELSCINT1",63)	CS	t	Unknown	d
3776	(0043,"GEMS_PARM_01",aa)	LO	t	Unknown	d
4362	(07a1,"ELSCINT1",42)	UN	t	Unknown	d
3097	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",91)	OB	t	Unknown:Unknown	d
3922	(0021,"",35)	UN	t	Unknown	d
1817	(07a5,"ELSCINT1",69)	LO	t	Unknown	d
1718	(07a5,"ELSCINT1",98)	ST	t	Unknown	d
1913	(07a5,"ELSCINT1",c8)	CS	t	Unknown	d
1884	(1001,"Philips Imaging DD 001",12)	UN	t	Unknown	d
4220	(0011,"ULTRAVISUAL_TAG_SET1",1a)	UN	t	Unknown	d
3920	(0019,"",8f)	UN	t	Unknown	d
3917	(0009,"",02)	UN	t	Unknown	d
4084	(700d,"TOSHIBA_MEC_MR3",08)	OB	t	Original Data	d
1952	(00e1,"ELSCINT1",51)	SH	t	Unknown	d
1832	(01f3,"ELSCINT1",01)[<0>](01f3,"ELSCINT1",04)	FL	t	Unknown:Unknown	d
1830	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",13)	FL	t	Unknown:Unknown	d
1862	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",23)	US	t	Unknown:Unknown	d
1956	(07a1,"ELSCINT1",2b)	CS	t	Unknown	d
1964	(07a1,"ELSCINT1",3d)	US	t	Unknown	d
1931	(07a1,"ELSCINT1",82)[<0>](07a1,"ELSCINT1",81)[<1>](07a1,"ELSCINT1",7e)[<2>](07a1,"ELSCINT1",7f)	FD	t	Unknown:Unknown:Unknown:Unknown	d
1955	(07a3,"ELSCINT1",05)	CS	t	Unknown	d
1959	(07a3,"ELSCINT1",06)	CS	t	Unknown	d
1943	(07a3,"ELSCINT1",80)	SQ	t	Unknown	d
1958	(07a3,"ELSCINT1",80)[<0>](0070,0100)	CS	t	Unknown:Presentation Size Mode	d
1946	(07a3,"ELSCINT1",b5)	IS	t	Unknown	d
1954	(07a3,"ELSCINT1",b7)	LT	t	Unknown	d
1757	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c1)	LO	t	Unknown:Unknown	d
1772	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",c4)	LO	t	Unknown:Unknown	d
1767	(07a3,"ELSCINT1",c0)[<0>](07a3,"ELSCINT1",cc)	LO	t	Unknown:Unknown	d
1766	(07a3,"ELSCINT1",c6)[<0>](07a3,"ELSCINT1",cc)	LO	t	Unknown:Unknown	d
1768	(07a3,"ELSCINT1",cb)[<0>](07a3,"ELSCINT1",cc)	LO	t	Unknown:Unknown	d
1805	(07a3,"ELSCINT1",ce)[<0>](0028,0002)	US	t	Unknown:Samples per Pixel	d
1803	(07a3,"ELSCINT1",ce)[<0>](0028,0101)	US	t	Unknown:Bits Stored	d
1802	(07a3,"ELSCINT1",ce)[<0>](0028,0102)	US	t	Unknown:High Bit	d
1807	(07a3,"ELSCINT1",ce)[<0>](0028,0103)	US	t	Unknown:Pixel Representation	d
1866	(07a5,"ELSCINT1",59)	IS	t	Unknown	d
2737	(2005,"Philips MR Imaging DD 006",62)	LT	t	Unknown	d
2104	(300a,0010)[<0>](3267,"Varian Medical Systems VISION 3267",00)	UN	t	Dose Reference Sequence:Unknown	d
2105	(300a,0070)[<0>](300c,0004)[<1>](3249,"Varian Medical Systems VISION 3249",00)	UN	t	Fraction Group Sequence:Referenced Beam Sequence:Unknown	d
2103	(300a,0070)[<0>](300c,0004)[<1>](3249,"Varian Medical Systems VISION 3249",10)	UN	t	Fraction Group Sequence:Referenced Beam Sequence:Unknown	d
2106	(300a,00b0)[<0>](3285,"Varian Medical Systems VISION 3285",00)	UN	t	Beam Sequence:Unknown	d
2032	(3241,"Varian Medical Systems VISION 3241",02)	UN	t	Unknown	d
2031	(3241,"Varian Medical Systems VISION 3241",04)	UN	t	Unknown	d
2925	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",10)	SQ	t	Unknown:Unknown	d
1610	(07a3,"ELSCINT1",01)	LO	t	Unknown	d
1572	(3109,"Applicare/RadWorks/Version 5.0",0a)	DA	t	Receive Date	d
2763	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",16)	OB	t	Unknown	d
2970	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3014	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3954	(0019,"",93)	UN	t	Unknown	d
2596	(0013,"CTP",50)	LO	t	Unknown	d
2710	(2005,"Philips MR Imaging DD 005",04)	UN	t	Unknown	d
2734	(2005,"Philips MR Imaging DD 005",04)	SS	t	Unknown	d
2174	(2005,"Philips MR Imaging DD 005",0f)	SQ	t	Private Per-Frame Sequence	d
3913	(0019,"",bb)	UN	t	Unknown	d
4080	(0051,"SIEMENS MR HEADER",0c)	SH	t	Unknown	d
1690	(0051,"SIEMENS MR HEADER",0c)	LO	t	Unknown	d
134	(0051,"SIEMENS MR HEADER",0c)	OB	t	Unknown	d
4021	(0021,"",5f)	UN	t	Unknown	d
2987	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",74)	OB	t	Unknown:Unknown	d
3300	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0011)	US	t	Unknown:Unknown:Columns	d
1883	(2001,"Philips Imaging DD 001",63)	CS	t	ExaminationSource	d
3185	(0029,"FDMS 1.0",20)	OB	t	ImageScanningDirection	d
3038	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",40)	OB	t	Unknown:Unknown	d
3857	(0023,"",74)	UN	t	Unknown	d
2866	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",16)	OB	t	Unknown:Unknown	d
1509	(0011,"GEMS_GENIE_1",13)	SL	t	DatasetType	d
1351	(00e1,"ELSCINT1",63)	SH	t	Patient Language	d
2834	(00e1,"ELSCINT1",63)	OB	t	Patient Language	d
3209	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",43)	OB	t	Unknown:Unknown	d
3187	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",84)	OB	t	Unknown:Unknown	d
4012	(0019,"",8d)	UN	t	Unknown	d
4515	(5001,"vRad PACS",72)	UN	t	Unknown	d
4352	(07a3,"ELSCINT1",bb)	UN	t	Unknown	d
4357	(07a1,"ELSCINT1",5f)	UN	t	Unknown	d
3651	(0011,"GEMS_GDXE_FALCON_04",6b)	UN	t	Unknown	d
2360	(2001,"Philips Imaging DD 001",c8)	LO	t	Exam Card Name	d
2706	(2001,"Philips Imaging DD 001",c8)	UN	t	Exam Card Name	d
2172	(2005,"Philips MR Imaging DD 001",83)	SQ	t	Unknown	d
2364	(2005,"Philips MR Imaging DD 004",91)	PN	t	Patient Name Job In Params	d
3720	(0021,"Siemens: Thorax/Multix FD Post Processing",15)	SS	t	Auto Window Shift	d
2733	(2005,"Philips MR Imaging DD 005",92)	FL	t	Unknown	d
2711	(2005,"Philips MR Imaging DD 005",92)	UN	t	Unknown	d
2730	(2005,"Philips MR Imaging DD 006",53)	FL	t	Unknown	d
2728	(2005,"Philips MR Imaging DD 006",54)	FL	t	Unknown	d
2727	(2005,"Philips MR Imaging DD 006",55)	FL	t	Unknown	d
2731	(2005,"Philips MR Imaging DD 006",56)	FL	t	Unknown	d
2740	(2005,"Philips MR Imaging DD 006",57)	CS	t	Unknown	d
2726	(2005,"Philips MR Imaging DD 006",59)	FL	t	Unknown	d
2725	(2005,"Philips MR Imaging DD 006",60)	IS	t	Unknown	d
2732	(2005,"Philips MR Imaging DD 006",61)	FL	t	Unknown	d
2724	(2005,"Philips MR Imaging DD 006",68)	IS	t	Unknown	d
2030	(3253,"Varian Medical Systems VISION 3253",00)	UN	t	Unknown	d
2033	(3253,"Varian Medical Systems VISION 3253",01)	UN	t	Unknown	d
2035	(3253,"Varian Medical Systems VISION 3253",02)	UN	t	Unknown	d
2107	(3287,"Varian Medical Systems VISION 3287",00)	UN	t	Unknown	d
2002	(3773,"MIM Software Inc.",07)	SQ	t	Unknown	d
2005	(3773,"MIM Software Inc.",07)[<0>](0020,000d)	UI	t	Unknown:Study Instance UID	d
2006	(3773,"MIM Software Inc.",07)[<0>](0020,000e)	UI	t	Unknown:Series Instance UID	d
2027	(3773,"MIM Software Inc.",18)	UN	t	Unknown	d
2003	(3773,"Unnamed Private Block - 01",20)	ST	t	Unknown	d
2004	(3773,"Unnamed Private Block - 01",22)	FL	t	Unknown	d
2620	(4453,"DR Systems, Inc.",01)	LO	t	Exam ID	d
3637	(0011,"GEMS_GDXE_FALCON_04",80)	UN	t	Unknown	d
1581	(0029,"MITRA MARKUP 1.0",03)	OB	t	Markup4	d
2715	(4453,"DR Systems, Inc.",0c)	SQ	t	Original Instance UID Sequence	d
2716	(4453,"DR Systems, Inc.",0c)[<0>](0008,1115)	SQ	t	Original Instance UID Sequence:Referenced Series Sequence	d
763	(0009,"GEMS_PETD_01",ea)	SL	t	Unknown	d
1278	(0017,"Unnamed Private Block - 10",04)	UN	t	Unknown	d
2789	(01f1,"ELSCINT1",43)	OB	t	Unknown	d
5738	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a9)[<1>](0070,005a)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a4)	UN	t	Advanced Presentation Sequence:Presentation State Sequence:Displayed Area Selection Sequence:Unknown	d
3235	(300a,00b0)[<0>](300a,0111)[<1>](300d,"TOMO_HA_01",a7)	UN	t	Beam Sequence:Control Point Sequence:Unknown	d
439	(0043,"GEMS_PARM_01",30)	SS	t	RawDataType	d
3167	(0021,"FDMS 1.0",50)	OB	t	PairProcessingInformation	d
4082	(700d,"TOSHIBA_MEC_MR3",07)	OB	t	Image Information	d
3018	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3199	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
2837	(01f1,"ELSCINT1",4c)	OB	t	Unknown	d
2125	(1099,"TABLE_HEIGHT",99)	CS	t	Unknown	d
1500	(0903,"GEIIS PACS",20)	CS	t	Unknown	d
2831	(01f7,"ELSCINT1",16)	OB	t	Unknown	d
1390	(01f7,"ELSCINT1",16)	OW	t	Unknown	d
3015	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3062	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",61)	OB	t	Unknown:Unknown	d
3837	(0043,"",81)	UN	t	Unknown	d
2137	(0013,"CTP",26)	UN	t	Unknown	d
3851	(0019,"",1b)	UN	t	Unknown	d
2889	(00e1,"ELSCINT1",39)[<0>](0032,1064)[<1>](0008,0102)	SH	t	Unknown:Requested Procedure Code Sequence:Coding Scheme Designator	d
2797	(01f1,"ELSCINT1",26)	OB	t	Pitch	d
1515	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",53)	UN	t	Unknown	d
495	(0019,"GEMS_ACQU_01",b0)	DS	t	UserData	d
2836	(0029,"SECTRA_ImageInfo_01",04)	OB	t	Image info new	d
3675	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",aa)[<1>](200b,"Philips RAD Imaging DD 097",ac)	UN	t	Presentation State Sequence:Unknown:Unknown	d
5433	(0019,"SIEMENS CM VA0  CMS",60)	IS	t	NumberOfDataBytes	d
4152	(5653,"Vital Images SW 3.4",18)	SH	t	Saved Workflow Mark	d
2621	(4453,"DR Systems, Inc.",04)	LO	t	File Type	k
2614	(4453,"DR Systems, Inc.",05)	LO	t	File Suffix	k
2618	(4453,"DR Systems, Inc.",02)	LO	t	Image Type	k
5424	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0064,0003)	UI	t	Unknown:Deformable Registration Sequence:Source Frame of Reference UID	d
5425	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](0070,030d)[<2>](0008,0102)	SH	t	Unknown:Deformable Registration Sequence:Registration Type Code Sequence:Coding Scheme Designator	d
2918	(00e1,"ELSCINT1",39)[<0>](0008,1140)[<1>](0008,1150)	UI	t	Unknown:Referenced Image Sequence:Referenced SOP Class UID	d
2796	(01f1,"ELSCINT1",4b)	OB	t	Unknown	d
4216	(0009,"EMAGEON JPEG2K INFO",01)	UN	t	Unknown	d
3077	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3082	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",32)	OB	t	Unknown:Unknown	d
3013	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3722	(0021,"Siemens: Thorax/Multix FD Post Processing",13)	SS	t	Unknown	d
4493	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a6)	SH	t	Object Action Sequence:Local IP Address	d
4495	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a8)	SH	t	Object Action Sequence:Remote IP Address	d
4498	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a7)	AE	t	Object Action Sequence:Remote AE Title	d
4500	(0021,"BRIT Systems, Inc.",a0)[<0>](0021,"BRIT Systems, Inc.",a5)	AE	t	Object Action Sequence:Local AE Title	d
4374	(0015,"GEMS_PETD_01",36)	UL	t	Unknown	d
4354	(07a3,"ELSCINT1",8f)	UN	t	Unknown	d
4464	(1111,"2.16.840.1.114330.1.1.1.1",0e)	UL	t	Unknown	d
4499	(0021,"BRIT Systems, Inc.",90)	AE	t	Original Sender AE Title	d
4508	(0009,"HMC - CT - ID",00)	OB	t	Image ID Information Patient Name ID	d
4377	(0015,"GEMS_PETD_01",37)	UL	t	Unknown	d
4389	(0015,"GEMS_PETD_01",20)	SL	t	First Packet Number	d
5376	(0071,"BLACKFORD",04)[<0>](0010,0020)	LO	t	Unknown:Patient ID	d
5405	(0071,"BLACKFORD",04)[<0>](0008,0018)	UI	t	Unknown:SOP Instance UID	d
5347	(0077,"TERARECON AQUARIUS",70)	UN	t	Algorithm ID	d
5379	(0071,"BLACKFORD",04)[<0>](0008,103e)	LO	t	Unknown:Series Description	d
5411	(0071,"BLACKFORD",04)[<0>](0008,9123)	UI	t	Unknown:Creator-Version UID	d
5400	(0071,"BLACKFORD",04)[<0>](0008,0060)	CS	t	Unknown:Modality	d
5387	(0071,"BLACKFORD",04)[<0>](0070,0084)	PN	t	Unknown:Content Creator's Name	d
5765	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",77)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Unknown	d
5360	(0077,"TERARECON AQUARIUS",26)	UN	t	Number of Binary Data	d
5368	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0008,1140)	SQ	t	Unknown:Unknown:Referenced Image Sequence	d
5407	(0071,"BLACKFORD",04)[<0>](0008,0016)	UI	t	Unknown:SOP Class UID	d
5398	(0071,"BLACKFORD",04)[<0>](0070,0080)	CS	t	Unknown:Content Label	d
5369	(0071,"BLACKFORD",04)[<0>](0070,0308)	SQ	t	Unknown:Registration Sequence	d
5356	(0077,"TERARECON AQUARIUS",16)	UN	t	Binary Data Name SCS	d
5413	(0071,"BLACKFORD",04)[<0>](0020,000d)	UI	t	Unknown:Study Instance UID	d
5375	(0071,"BLACKFORD",04)[<0>](0018,1020)	LO	t	Unknown:Software Version(s)	d
5354	(0077,"TERARECON AQUARIUS",14)	UN	t	Referenced Volume ID	d
5361	(0071,"BLACKFORD",04)[<0>](0020,0010)	SH	t	Unknown:Study ID	d
5401	(0071,"BLACKFORD",04)[<0>](0008,0031)	TM	t	Unknown:Series Time	d
5397	(0071,"BLACKFORD",04)[<0>](0020,0060)	CS	t	Unknown:Laterality	d
5367	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)	SQ	t	Unknown:Unknown	d
5406	(0071,"BLACKFORD",04)[<0>](0020,000e)	UI	t	Unknown:Series Instance UID	d
5365	(0071,"BLACKFORD",04)	SQ	t	Unknown	d
5383	(0071,"BLACKFORD",04)[<0>](0008,0070)	LO	t	Unknown:Manufacturer	d
5404	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0008,1140)[<2>](0008,1155)	UI	t	Unknown:Unknown:Referenced Image Sequence:Referenced SOP Instance UID	d
5403	(0071,"BLACKFORD",04)[<0>](0008,0030)	TM	t	Unknown:Study Time	d
5402	(0071,"BLACKFORD",04)[<0>](0008,0033)	TM	t	Unknown:Content Time	d
5381	(0071,"BLACKFORD",04)[<0>](0070,0081)	LO	t	Unknown:Content Description	d
5359	(0077,"TERARECON AQUARIUS",30)	UN	t	Binary Data Size	d
5351	(0077,"TERARECON AQUARIUS",40)	UN	t	Additional Information	d
5384	(0071,"BLACKFORD",04)[<0>](0018,1000)	LO	t	Unknown:Device Serial Number	d
5348	(0077,"TERARECON AQUARIUS",32)	UN	t	Binary Data SubType	d
5395	(0071,"BLACKFORD",04)[<0>](0008,0005)	CS	t	Unknown:Specific Character Set	d
5357	(0077,"TERARECON AQUARIUS",28)	UN	t	Binary Data Type	d
5377	(0071,"BLACKFORD",04)[<0>](0008,1030)	LO	t	Unknown:Study Description	d
5396	(0071,"BLACKFORD",04)[<0>](0010,0040)	CS	t	Unknown:Patient's Sex	d
5373	(0071,"BLACKFORD",04)[<0>](0020,1040)	LO	t	Unknown:Position Reference Indicator	d
5378	(0071,"BLACKFORD",04)[<0>](0010,0021)	LO	t	Unknown:Issuer of Patient ID	d
5353	(0077,"TERARECON AQUARIUS",80)	UN	t	Volume ID	d
5385	(0071,"BLACKFORD",04)[<0>](0020,0013)	IS	t	Unknown:Instance Number	d
2129	(0033,"GEMS_GENIE_1",07)	LO	t	Original SOP Instance UID	d
3744	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",19)	US	t	Ortho Subsampling	d
5427	(0071,"BLACKFORD",04)[<0>](0064,0002)[<1>](3006,00c8)	LO	t	Unknown:Deformable Registration Sequence:Frame of Reference Transformation Comment	d
5419	(0071,"BLACKFORD",04)[<0>](0008,0020)	DA	t	Unknown:Study Date	d
5442	(0019,"SIEMENS MR VA0  COAD",d3)	DS	t	FieldOfViewRatio	d
5417	(0071,"BLACKFORD",04)[<0>](0008,0021)	DA	t	Unknown:Series Date	d
3664	(2001,"Philips Imaging DD 129",00)[<0>](0008,1115)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Presentation State Sequence:Referenced Series Sequence:Linear Modality GL Transform	d
3777	(0043,"GEMS_PARM_01",a8)	DS	t	Dual Drive Mode, Amplitude Attentuation and Phase Offset	d
4234	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 004",89)[<1>](2005,"Philips MR Imaging DD 004",88)	UN	t	Presentation State Sequence:Viewing Protocol:Display Layout Number of Rows	d
2127	(0011,"GEMS_GENIE_1",10)	LO	t	Unknown	d
3876	(0021,"",50)	UN	t	Unknown	d
3765	(0079,"Unnamed Private Block - 10",15)	DS	t	Unknown	d
1318	(7053,"Philips PET Private Group",16)	SS	t	Unknown	d
1544	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",04)	CS	t	Unknown	d
5394	(0071,"BLACKFORD",04)[<0>](0071,"BLACKFORD",01)[<1>](0071,"BLACKFORD",02)[<2>](0020,0037)	DS	t	Unknown:Unknown:Unknown:Image Orientation (Patient)	d
5355	(0077,"TERARECON AQUARIUS",20)	UN	t	Binary Data Name	d
5350	(0077,"TERARECON AQUARIUS",24)	UN	t	Number of Series Instance UID	d
3903	(0019,"",ad)	UN	t	Unknown	d
4142	(0019,"",0c)	IS	t	Unknown	d
3050	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",30)	OB	t	Unknown:Unknown	d
2813	(01f7,"ELSCINT1",11)	OB	t	Unknown	d
472	(0019,"GEMS_ACQU_01",aa)	DS	t	UserData	d
2863	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",13)	OB	t	Unknown:Unknown	d
1571	(0051,"SIEMENS MR HEADER",17)	SH	t	Unknown	d
146	(0051,"SIEMENS MR HEADER",17)	OB	t	Unknown	d
2869	(01f3,"ELSCINT1",17)	OB	t	Unknown	d
3924	(0021,"",82)	UN	t	Unknown	d
835	(01f7,"ELSCINT1",95)	UN	t	Unknown	d
4347	(01f7,"ELSCINT1",95)	OW	t	Unknown	d
1606	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",12)	UN	t	Unknown	d
2973	(0021,"FDMS 1.0",10)	OB	t	FCRImageID	d
3950	(0027,"",31)	UN	t	Unknown	d
2894	(00e1,"ELSCINT1",39)[<0>](0032,1064)[<1>](0008,0100)	SH	t	Unknown:Requested Procedure Code Sequence:Code Value	d
5297	(2005,"Philips MR Imaging DD 005",90)	UN	t	Original VOI LUT Sequence	d
1593	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",65)	UN	t	Unknown	d
1429	(0009,"GEMS_IDEN_01",5f)	UN	t	Unknown	d
5795	(2005,"Philips MR Imaging DD 006",63)	CS	t	Unknown	d
5798	(2005,"Philips MR Imaging DD 006",78)	CS	t	Unknown	d
5794	(2005,"Philips MR Imaging DD 006",66)	CS	t	Unknown	d
5791	(2005,"Philips MR Imaging DD 006",83)	LT	t	Unknown	d
5783	(2005,"Philips MR Imaging DD 006",71)	IS	t	Unknown	d
5797	(2005,"Philips MR Imaging DD 006",64)	CS	t	Unknown	d
5781	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 006",67)	IS	t	StackSequence:Unknown	d
5789	(2005,"Philips MR Imaging DD 006",75)	DS	t	Unknown	d
5786	(2005,"Philips MR Imaging DD 006",85)	DS	t	Unknown	d
5796	(2005,"Philips MR Imaging DD 006",79)	CS	t	Unknown	d
5792	(2005,"Philips MR Imaging DD 006",76)	LT	t	Unknown	d
5784	(2005,"Philips MR Imaging DD 006",72)	FL	t	Unknown	d
5793	(2005,"Philips MR Imaging DD 006",65)	CS	t	Unknown	d
5782	(2005,"Philips MR Imaging DD 006",82)	IS	t	Unknown	d
5790	(2005,"Philips MR Imaging DD 006",86)	LT	t	Unknown	d
5779	(7005,"TOSHIBA_MEC_CT3",79)	UN	t	Unknown	d
5787	(2005,"Philips MR Imaging DD 006",87)	DS	t	Unknown	d
5780	(2005,"Philips MR Imaging DD 006",73)	IS	t	Unknown	d
3297	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0103)	US	t	Unknown:Unknown:Pixel Representation	d
3041	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",53)	OB	t	Unknown:Unknown	d
3853	(0025,"",19)	UN	t	Unknown	d
4064	(0029,"",19)	LO	t	Unknown	d
3298	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0102)	US	t	Unknown:Unknown:High Bit	d
4342	(01f7,"ELSCINT1",91)	OW	t	Unknown	d
2109	(3006,0020)[<0>](3263,"Unnamed Private Block - 10",00)	UN	t	Structure Set ROI Sequence:Unknown	d
1653	(0029,"SIEMENS MEDCOM HEADER",40)		t	ApplicationHeaderSequence	d
4103	(0019,"",0c)	UN	t	Unknown	d
1564	(07a1,"ELSCINT1",11)	CS	t	Unknown	d
1296	(0029,"SIEMENS CSA HEADER",08)	CS	t	CSAImageHeaderType	d
2953	(0019,"FDMS 1.0",32)	OB	t	KanjiMenuName	d
1414	(0031,"AGFA PACS Archive Mirroring 1.0",00)	CS	t	Unknown	d
477	(0019,"GEMS_ACQU_01",b6)	DS	t	UserData	d
484	(0019,"GEMS_ACQU_01",bd)	DS	t	UserData	d
3693	(0040,030e)[<0>](01e3,"ELSCINT1",02)	UN	t	Exposure Dose Sequence:Unknown	d
3705	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",08)	FL	t	Unknown	d
148	(0029,"SIEMENS MEDCOM HEADER",20)	OB	t	MedComHistoryInformation	d
3673	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",b1)	UN	t	Presentation State Sequence:Unknown	d
3929	(0019,"",c7)	UN	t	Unknown	d
4335	(01f1,"ELSCINT1",54)	IS	t	Unknown	d
2111	(7005,"TOSHIBA_MEC_CT3",43)	UN	t	Volume Vector	d
2161	(3115,"http://www.gemedicalsystems.com/it_solutions/rad_pacs/",01)	UT	t	Unknown	d
3114	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",53)	OB	t	Unknown:Unknown	d
2926	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",60)	SQ	t	Unknown:Unknown	d
2871	(00e1,"ELSCINT1",05)	IS	t	Unknown	d
3713	(0021,"Siemens: Thorax/Multix FD Post Processing",11)	SS	t	Unknown	d
3129	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",52)	OB	t	Unknown:Unknown	d
3166	(0019,"FDMS 1.0",81)	OB	t	ReadingSensitivityCenter	d
137	(0029,"SIEMENS CSA HEADER",08)	OB	t	CSAImageHeaderType	d
3663	(2001,"Philips Imaging DD 001",c1)	LO	t	Linear Modality GL Transform	d
2117	(7005,"TOSHIBA_MEC_CT3",41)	UN	t	Row Slice Information	d
3911	(0043,"",06)	UN	t	Unknown	d
3708	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",05)	FL	t	Unknown	d
3044	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",91)	OB	t	Unknown:Unknown	d
1403	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0c)	OB	t	Unknown	d
4095	(0019,"",29)	UN	t	Unknown	d
4321	(0137,"NetRAAD",30)	DA	t	Unknown	d
3879	(0019,"",7e)	UN	t	Unknown	d
4977	(2001,"Philips Imaging DD 129",00)		t	Presentation State Sequence	d
5299	(2001,"Philips Imaging DD 129",00)	OB	t	Presentation State Sequence	d
4079	(0051,"SIEMENS MR HEADER",0a)	SH	t	Unknown	d
1543	(0051,"SIEMENS MR HEADER",0a)	LO	t	Unknown	d
141	(0051,"SIEMENS MR HEADER",0a)	OB	t	Unknown	d
3186	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",84)	OB	t	Unknown:Unknown	d
3195	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
2799	(01f1,"ELSCINT1",49)	OB	t	Unknown	d
3859	(0043,"",07)	UN	t	Unknown	d
1481	(0009,"SIEMENS CT VA1 DUMMY",01)	UN	t	Unknown	d
1364	(01f1,"ELSCINT1",49)	DS	t	Unknown	d
2937	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",80)	SQ	t	Unknown:Unknown	d
884	(0043,"GEMS_PARM_01",80)	LO	t	Coil ID Data	d
3296	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0002)	US	t	Unknown:Unknown:Samples per Pixel	d
3208	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",43)	OB	t	Unknown:Unknown	d
1599	(7fdf,"ELSCINT1",ff)	SH	t	Unknown	d
2135	(0011,"GEMS_GENIE_1",44)	FD	t	ThresholdCenter	d
3004	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
2822	(01f7,"ELSCINT1",1e)	OB	t	Unknown	d
3825	(0019,"",12)	UN	t	Unknown	d
4055	(0019,"",14)	IS	t	Unknown	d
3790	(0019,"",14)	UN	t	Unknown	d
1383	(01f7,"ELSCINT1",1e)	OW	t	Unknown	d
3991	(0029,"",15)	UN	t	Unknown	d
2954	(0021,"FDMS 1.0",80)	OB	t	EquipmentTypeSpecificInformation	d
1670	(0047,"GEMS_3DSTATE_001",e9)	FL	t	Unknown	d
3761	(0079,"Unnamed Private Block - 10",09)	IS	t	Unknown	d
1682	(0073,"STENTOR",04)	UN	t	Unknown	d
3650	(0011,"GEMS_GDXE_FALCON_04",60)	UN	t	Unknown	d
2910	(00e1,"ELSCINT1",39)[<0>](0008,0090)	PN	t	Unknown:Referring Physician's Name	d
2136	(0011,"GEMS_GENIE_1",57)	FD	t	FOV	d
3883	(0027,"",41)	UN	t	Unknown	d
3057	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",40)	OB	t	Unknown:Unknown	d
467	(0019,"GEMS_ACQU_01",ae)	DS	t	UserData	d
4182	(0043,"dcm4che/archive",12)	SS	t	Series Pk	d
1283	(0009,"GEMS_IDEN_01",3d)	UN	t	Unknown	d
4028	(0029,"",11)	CS	t	Unknown	d
882	(0043,"GEMS_PARM_01",82)	LO	t	System Configuration Information	d
2980	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
2119	(0053,"GEHC_CT_ADVAPP_001",6a)	IS	t	Unknown	d
1012	(0053,"GEHC_CT_ADVAPP_001",6a)	UN	t	Unknown	d
3200	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
848	(0009,"GEMS_PETD_01",99)	UI	t	Blnk Cal ID	d
1206	(0073,"STENTOR",02)	ST	t	Unknown	d
1262	(0009,"GEMS_GENIE_1",1e)	UI	t	Unknown	d
3946	(0043,"",01)	UN	t	Unknown	d
3779	(0051,"GEMS_FUNCTOOL_01",06)	LO	t	Parameters	d
4240	(0077,"NIL_CoReg_ATT",02)	UI	t	Unknown	d
3091	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",82)	OB	t	Unknown:Unknown	d
3706	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0f)	FL	t	Edge Enhancement Gain	d
243	(0043,"GEMS_PARM_01",61)	UI	t	Unknown	d
2985	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",74)	OB	t	Unknown:Unknown	d
1616	(0051,"SIEMENS MR HEADER",11)	LO	t	Unknown	d
144	(0051,"SIEMENS MR HEADER",11)	OB	t	Unknown	d
832	(01f7,"ELSCINT1",97)	UN	t	Unknown	d
1687	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",42)	UN	t	Unknown	d
3860	(0043,"",2d)	UN	t	Unknown	d
3867	(0043,"",84)	UN	t	Unknown	d
3871	(0027,"",06)	UN	t	Unknown	d
4175	(0029,"",01)	UN	t	Unknown	d
1620	(0009,"GEMS_IDEN_01",31)	SH	t	MobileLocationNumber	d
3005	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
2958	(0009,"FDMS 1.0",04)	OB	t	ImageControlUnit	d
1363	(00e1,"ELSCINT1",61)	LO	t	Protocol File Name	d
2833	(00e1,"ELSCINT1",61)	OB	t	Protocol File Name	d
2115	(7005,"TOSHIBA_MEC_CT3",0d)	CS	t	Organ	d
3975	(0043,"",09)	UN	t	Unknown	d
3901	(0019,"",97)	UN	t	Unknown	d
3649	(0011,"GEMS_GDXE_FALCON_04",68)	UN	t	Unknown	d
828	(00e1,"ELSCINT1",36)	UN	t	Unknown	d
5860	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",64)	US	t	Unknown	d
5884	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",a0)	US	t	Unknown	d
5859	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",14)	US	t	Unknown	d
5850	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0f)	LO	t	Unknown	d
5862	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",19)	US	t	Unknown	d
5872	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",68)	US	t	Unknown	d
5854	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",5c)	OW	t	Unknown	d
5876	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",24)	US	t	Unknown	d
5851	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0e)	LO	t	Unknown	d
4204	(5653,"",18)	OB	t	Unknown	d
3865	(0009,"",30)	UN	t	Unknown	d
3869	(0019,"",9e)	UN	t	Unknown	d
3727	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",13)	SS	t	Unknown	d
277	(0021,"GEMS_RELA_01",03)	SS	t	SeriesFromWhichPrescribed	d
2965	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",94)	OB	t	Unknown:Unknown	d
3771	(0079,"Unnamed Private Block - 10",06)	DS	t	Unknown	d
2112	(7005,"TOSHIBA_MEC_CT3",63)	UN	t	CTDIw	d
4121	(2001,"Philips Imaging DD 129",00)[<0>](0028,3002)	US	t	Presentation State Sequence:LUT Descriptor	d
2879	(00e1,"ELSCINT1",39)[<0>](0040,0275)	SQ	t	Unknown:Request Attributes Sequence	d
3138	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2969	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",42)	OB	t	Unknown:Unknown	d
5562	(2001,"Philips Imaging DD 001",5f)[<0>](2005,"Philips MR Imaging DD 006",67)	UN	t	StackSequence:Unknown	d
5890	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",21)	US	t	Unknown	d
5889	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",85)	US	t	Unknown	d
3667	(2001,"Philips Imaging DD 129",00)[<0>](200b,"Philips RAD Imaging DD 097",aa)[<1>](200b,"Philips RAD Imaging DD 097",ab)	UN	t	Presentation State Sequence:Unknown:Unknown	d
5867	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",1c)	US	t	Unknown	d
5887	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",88)	US	t	Unknown	d
5886	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",27)	US	t	Unknown	d
5888	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",18)	US	t	Unknown	d
4338	(01f1,"ELSCINT1",4e)	SH	t	Unknown	d
2922	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",20)	SQ	t	Unknown:Unknown	d
318	(0021,"GEMS_RELA_01",37)	SS	t	ScreenFormat	d
5788	(2005,"Philips MR Imaging DD 006",74)	DS	t	Unknown	d
5877	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",87)	US	t	Unknown	d
5847	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",50)	SS	t	Unknown	d
5828	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",61)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",62)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Segmentation Display Data Sequence:Segmentation Display Data UID	d
5879	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",67)	US	t	Unknown	d
5748	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",1c)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Unknown	d
5571	(2005,"Philips MR Imaging DD 006",65)	UN	t	Unknown	d
5558	(2005,"Philips MR Imaging DD 006",68)	UN	t	Unknown	d
5550	(2005,"Philips MR Imaging DD 006",78)	UN	t	Unknown	d
5679	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",91)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",9a)[<4>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",38)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Evaluation DataRole Sequence:Measurement Referenced Frames Sequence:Referenced Syngo UID	d
5863	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8a)	US	t	Unknown	d
5841	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",0b)	SS	t	Unknown	d
5568	(2005,"Philips MR Imaging DD 006",60)	UN	t	Unknown	d
3299	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0010)	US	t	Unknown:Unknown:Rows	d
5831	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",03)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",04)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",10)[<3>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",11)	UN	t	Advanced Presentation Sequence:Time Point Sequence:Base Image Sequence:Segmentation Sequence:Segmentation UID	d
5560	(2005,"Philips MR Imaging DD 006",79)	UN	t	Unknown	d
5760	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",76)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Unknown	d
5739	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",fb)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Clinical Finding ID	d
3246	(300a,00b0)[<0>](300d,"TOMO_HA_01",40)	UN	t	Beam Sequence:Unknown	d
5574	(2005,"Philips MR Imaging DD 006",53)	UN	t	Unknown	d
3133	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",93)	OB	t	Unknown:Unknown	d
1154	(0009,"GEMS_PETD_01",58)	UI	t	Blank Cal ID	d
5741	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0071,"SIEMENS SYNGO OBJECT GRAPHICS",1b)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Unknown	d
5719	(0029,"SIEMENS SYNGO ADVANCED PRESENTATION",02)[<0>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",a7)[<1>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",31)[<2>](0029,"SIEMENS SYNGO ADVANCED PRESENTATION",30)	UN	t	Advanced Presentation Sequence:Presentation Module Sequence:Measurement Data Sequence:Measurement Application Name	d
5852	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",4e)	LO	t	Unknown	d
5861	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",8e)	US	t	Unknown	d
5869	(0017,"SIEMENS_FLCOMPACT_VA01A_PROC",22)	US	t	Unknown	d
3033	(0009,"FDMS 1.0",08)	OB	t	ImageDisplayInformationVersionNo	d
2817	(01f7,"ELSCINT1",2d)	OB	t	Unknown	d
2835	(01f1,"ELSCINT1",07)	OB	t	Table Velocity	d
1550	(0013,"CTP",01)	UN	t	Unknown	d
1561	(07a1,"ELSCINT1",13)	UL	t	Unknown	d
1575	(0051,"SIEMENS MR HEADER",12)	SH	t	Unknown	d
139	(0051,"SIEMENS MR HEADER",12)	OB	t	Unknown	d
3084	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",13)	OB	t	Unknown:Unknown	d
3207	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",43)	OB	t	Unknown:Unknown	d
3236	(300a,0010)[<0>](300d,"TOMO_HA_01",12)	UN	t	Dose Reference Sequence:Unknown	d
4013	(0025,"",06)	UN	t	Unknown	d
2152	(0021,"SIEMENS MED ECAT FILE INFO",01)	OB	t	ECAT_Image_Subheader	d
3178	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
475	(0019,"GEMS_ACQU_01",a8)	DS	t	UserData	d
501	(0019,"GEMS_ACQU_01",ac)	DS	t	UserData	d
1569	(0019,"SIEMENS MR HEADER",09)	LO	t	Unknown	d
3188	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
2897	(00e1,"ELSCINT1",39)[<0>](0040,0253)	SH	t	Unknown:Performed Procedure Step ID	d
3634	(0011,"GEMS_GDXE_FALCON_04",11)	LT	t	ROI	d
2870	(01f7,"ELSCINT1",73)	OB	t	Unknown	d
1345	(0009,"GEMS_PETD_01",83)	SL	t	Window Level Type	d
4305	(0009,"CTP",04)	UN	t	Unknown	d
1614	(0051,"SIEMENS MR HEADER",0d)	SH	t	Unknown	d
132	(0051,"SIEMENS MR HEADER",0d)	OB	t	Unknown	d
3969	(0043,"",60)	UN	t	Unknown	d
1247	(0009,"GEMS_PETD_01",02)	LO	t	Patient ID	d
3980	(0021,"",53)	UN	t	Unknown	d
3261	(0031,"MITRA LINKED ATTRIBUTES 1.0",20)	IS	t	Unknown	d
1671	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",40)	UN	t	Unknown	d
1674	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",5e)	UN	t	Unknown	d
1666	(0031,"MITRA LINKED ATTRIBUTES 1.0",20)	LO	t	Unknown	d
3151	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",31)	OB	t	Unknown:Unknown	d
4016	(0009,"",04)	UN	t	Unknown	d
4188	(0043,"dcm4che/archive",31)	DS	t	Unknown	d
3757	(0079,"Unnamed Private Block - 10",01)	LO	t	Unknown	d
3042	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",95)	OB	t	Unknown:Unknown	d
1369	(01f7,"ELSCINT1",19)	OW	t	Unknown	d
1136	(0009,"GEMS_PETD_01",ca)	LO	t	ovlp_tpulse_frm_id	d
1217	(0029,"SIEMENS MEDCOM OOG",09)	LO	t	MEDCOMOOGVersion	d
2807	(01f7,"ELSCINT1",19)	OB	t	Unknown	d
3862	(0019,"",a3)	UN	t	Unknown	d
1158	(0009,"GEMS_PETD_01",ca)	UI	t	ovlp_tpulse_frm_id	d
3064	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",51)	OB	t	Unknown:Unknown	d
3070	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",50)	OB	t	Unknown:Unknown	d
685	(0009,"GEMS_PETD_01",96)	LO	t	Well CounterCal ID	d
839	(0009,"GEMS_PETD_01",96)	UI	t	Well CounterCal ID	d
3912	(0019,"",a7)	UN	t	Unknown	d
3914	(0021,"",52)	UN	t	Unknown	d
4966	(0028,3110)[<0>](2001,"Philips Imaging DD 001",77)	CS	t	Softcopy VOI LUT Sequence:GL Transform Type	d
3085	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",a2)	OB	t	Unknown:Unknown	d
3930	(0019,"",b5)	UN	t	Unknown	d
3934	(0019,"",b0)	UN	t	Unknown	d
3940	(0043,"",96)	UN	t	Unknown	d
3105	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",32)	OB	t	Unknown:Unknown	d
3724	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0c)	SS	t	Harmonization Kernel	d
4003	(0019,"",cb)	UN	t	Unknown	d
1631	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",60)	UN	t	Unknown	d
507	(0043,"GEMS_PARM_01",6f)	DS	t	Unknown	d
4212	(0077,"",03)	SS	t	Unknown	d
3152	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",a3)	OB	t	Unknown:Unknown	d
4148	(5653,"Vital Images SW 3.4",15)	SQ	t	Image Sequence	d
3847	(0019,"",a0)	UN	t	Unknown	d
1449	(0009,"GEIIS",6c)	UN	t	Unknown	d
3683	(0040,030e)[<0>](01f1,"ELSCINT1",4e)	LO	t	Exposure Dose Sequence:Unknown	d
4130	(0019,"",0e)	UN	t	Unknown	d
1529	(07a1,"ELSCINT1",2a)	CS	t	Unknown	d
1531	(0011,"GEMS_GENIE_1",0a)	SL	t	SeriesType	d
3889	(0019,"",c5)	UN	t	Unknown	d
3292	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0018,0050)	DS	t	Unknown:Unknown:Slice Thickness	d
3658	(200b,"Philips RAD Imaging DD 097",aa)[<0>](0008,0018)	UI	t	Unknown:SOP Instance UID	d
3002	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1281	(0009,"GEMS_IDEN_01",0e)	UN	t	Unknown	d
1560	(7fdf,"ELSCINT1",f0)	OB	t	Unknown	d
3759	(0079,"Unnamed Private Block - 10",02)	IS	t	Unknown	d
2916	(00e1,"ELSCINT1",39)[<0>](00e1,"ELSCINT1",3e)	IS	t	Unknown:Unknown	d
3908	(0025,"",17)	UN	t	Unknown	d
3079	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",95)	OB	t	Unknown:Unknown	d
1477	(0009,"Unnamed Private Block - 10",6c)	UN	t	Unknown	d
2929	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",80)	SQ	t	Unknown:Unknown	d
2941	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",30)	SQ	t	Unknown:Unknown	d
4238	(0077,"NIL_CoReg_ATT",01)	FL	t	Unknown	d
3654	(200b,"Philips RAD Imaging DD 001",40)	SH	t	Unknown	d
3953	(0043,"",04)	UN	t	Unknown	d
2116	(7005,"TOSHIBA_MEC_CT3",14)	US	t	Reconstruction ROI Number	d
4127	(0019,"",0d)	CS	t	Unknown	d
3961	(0019,"",cd)	UN	t	Unknown	d
3955	(0043,"",61)	UN	t	Unknown	d
4102	(0019,"",0d)	UN	t	Unknown	d
4041	(0051,"",19)	LO	t	Unknown	d
1381	(01f7,"ELSCINT1",1c)	OW	t	Unknown	d
4092	(700d,"TOSHIBA_MEC_MR3",06)	US	t	Image Matrix	d
3968	(0027,"",61)	UN	t	Unknown	d
2819	(01f7,"ELSCINT1",1c)	OB	t	Unknown	d
2873	(00e1,"ELSCINT1",06)	IS	t	Unknown	d
4157	(5653,"Vital Images SW 3.4",16)	SL	t	Volume Interpolated Slices	d
4140	(0043,"GEMS_PARM_01",a3)	CS	t	ASL Contrast technique	d
3782	(0043,"GEMS_PARM_01",a3)	UN	t	ASL Contrast technique	d
3753	(0043,"dcm4che/archive",14)	AE	t	Calling AE Title	d
1143	(0009,"GEMS_PETD_01",65)	SL	t	patient_entry	d
4195	(0043,"dcm4che/archive",42)	SL	t	Unknown	d
4007	(0025,"",07)	UN	t	Unknown	d
2912	(00e1,"ELSCINT1",37)	DS	t	Total Dose Savings	d
1313	(7053,"Philips PET Private Group",c2)	UI	t	Unknown	d
3237	(300a,0010)[<0>](300d,"TOMO_HA_01",18)	UN	t	Dose Reference Sequence:Unknown	d
3716	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",00)	SS	t	Raw Image Amplification	d
4345	(07a5,"ELSCINT1",00)	LO	t	Unknown	d
3193	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3666	(200b,"Philips RAD Imaging DD 097",aa)[<0>](200b,"Philips RAD Imaging DD 097",ab)	UN	t	Unknown:Unknown	d
2852	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",19)	OB	t	Unknown:Unknown	d
3788	(0033,"",1c)	UN	t	Unknown	d
3095	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",34)	OB	t	Unknown:Unknown	d
3942	(0023,"",70)	UN	t	Unknown	d
3016	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3115	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2791	(01f1,"ELSCINT1",03)	OB	t	Concurrent Slices Generation	d
3118	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",31)	OB	t	Unknown:Unknown	d
3127	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",30)	OB	t	Unknown:Unknown	d
3128	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",72)	OB	t	Unknown:Unknown	d
3132	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3161	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
4197	(0043,"dcm4che/archive",46)	SL	t	Unknown	d
3689	(0040,030e)[<0>](01e3,"ELSCINT1",0a)	UN	t	Exposure Dose Sequence:Unknown	d
3809	(0019,"",13)	UN	t	Unknown	d
4071	(0019,"",13)	SL	t	Unknown	d
1686	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",10)	UN	t	Unknown	d
4178	(0043,"dcm4che/archive",40)	FL	t	Unknown	d
4346	(01f7,"ELSCINT1",92)	OW	t	Unknown	d
3833	(0019,"",a8)	UN	t	Unknown	d
3846	(0019,"",84)	UN	t	Unknown	d
3040	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",51)	OB	t	Unknown:Unknown	d
3932	(0019,"",ab)	UN	t	Unknown	d
3194	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3638	(0011,"GEMS_GDXE_FALCON_04",6d)	UN	t	Unknown	d
3012	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
4200	(5653,"",14)	SQ	t	Unknown	d
4135	(5653,"",14)	UN	t	Unknown	d
3017	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
2962	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",15)	OB	t	Unknown:Unknown	d
4961	(0028,3110)[<0>](2001,"Philips Imaging DD 001",c1)	LO	t	Softcopy VOI LUT Sequence:Linear Modality GL Transform	d
4043	(0051,"",16)	LO	t	Unknown	d
3791	(0051,"",16)	UN	t	Unknown	d
3066	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",92)	OB	t	Unknown:Unknown	d
2934	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",50)	SQ	t	Unknown:Unknown	d
1259	(0043,"GEMS_PARM_01",28)	OB	t	UniqueImageIdentifier	d
3902	(0019,"",b2)	UN	t	Unknown	d
4221	(0011,"ULTRAVISUAL_TAG_SET1",1d)	UN	t	Unknown	d
3076	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",a0)	OB	t	Unknown:Unknown	d
498	(0019,"GEMS_ACQU_01",e0)	DS	t	UserData	d
4975	(2005,"Philips MR Imaging DD 005",0f)		t	Private Per-Frame Sequence	d
5175	(2005,"Philips MR Imaging DD 005",0f)	OB	t	Private Per-Frame Sequence	d
3698	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",04)	FL	t	Unknown	d
833	(01f7,"ELSCINT1",7f)	UN	t	Unknown	d
2114	(01f7,"ELSCINT1",7f)	OW	t	Unknown	d
3925	(0043,"",39)	UN	t	Unknown	d
473	(0019,"GEMS_ACQU_01",bb)	DS	t	UserData	d
4134	(5653,"",19)	UN	t	Unknown	d
3962	(0019,"",c0)	UN	t	Unknown	d
3690	(0040,030e)[<0>](01e3,"ELSCINT1",0c)	UN	t	Exposure Dose Sequence:Unknown	d
3173	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
2862	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",23)	OB	t	Unknown:Unknown	d
1320	(7053,"Philips PET Private Group",14)	SS	t	Unknown	d
1472	(0009,"GEMS_IDEN_01",67)	UN	t	Unknown	d
4326	(0043,"GEMS_PARM_01",9b)	DS	t	NPW factor	d
1349	(01f1,"ELSCINT1",0e)	FL	t	Unknown	d
4090	(700d,"TOSHIBA_MEC_MR3",05)	DS	t	FOV	d
1692	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0e)	LT	t	Unknown	d
4017	(0019,"",a4)	UN	t	Unknown	d
1691	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",51)	UN	t	Unknown	d
1491	(0043,"GEMS_PARM_01",2a)	OB	t	UserDefinedData	d
3284	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",0e)	OB	t	Unknown	d
3203	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
1495	(0073,"STENTOR",06)	LO	t	Unknown	d
1467	(0073,"STENTOR",06)	UN	t	Unknown	d
3172	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3670	(200b,"Philips RAD Imaging DD 099",35)	UN	t	Unknown	d
3171	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
492	(0019,"GEMS_ACQU_01",b8)	DS	t	UserData	d
4314	(0137,"NetRAAD",0e)	UI	t	Unknown	d
3059	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3688	(0040,030e)[<0>](01e3,"ELSCINT1",01)	UN	t	Exposure Dose Sequence:Unknown	d
3063	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",80)	OB	t	Unknown:Unknown	d
3071	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",91)	OB	t	Unknown:Unknown	d
5162	(2005,"Philips MR Imaging DD 003",49)	OB	t	Number of Series Operators Name	d
4035	(0051,"",13)	SH	t	Unknown	d
3801	(0051,"",13)	UN	t	Unknown	d
4066	(0019,"",0b)	DS	t	Unknown	d
3899	(0019,"",f9)	UN	t	Unknown	d
3806	(0019,"",17)	UN	t	Unknown	d
3075	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",80)	OB	t	Unknown:Unknown	d
3804	(0019,"",0b)	UN	t	Unknown	d
4067	(0019,"",17)	DS	t	Unknown	d
3936	(0043,"",83)	UN	t	Unknown	d
3103	(0009,"FDMS 1.0",09)	OB	t	PatientInformationVersionNo	d
3112	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",20)	OB	t	Unknown:Unknown	d
4222	(0011,"ULTRAVISUAL_TAG_SET1",08)	UN	t	Unknown	d
2904	(00e1,"ELSCINT1",39)[<0>](0032,1060)	LO	t	Unknown:Requested Procedure Description	d
3974	(0019,"",c2)	UN	t	Unknown	d
3198	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3746	(0021,"Siemens: Thorax/Multix FD Post Processing",04)	US	t	Unknown	d
3259	(0029,"INTELERAD MEDICAL SYSTEMS",22)	US	t	HistogramPercentileValues	d
3150	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",a0)	OB	t	Unknown:Unknown	d
3146	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",60)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3695	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",0a)	FL	t	Unknown	d
1482	(3109,"Applicare/RadWorks/Version 5.0",08)	LO	t	Receive Origin	d
4131	(5653,"",17)	UN	t	Unknown	d
3190	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
3967	(0043,"",0d)	UN	t	Unknown	d
3971	(0043,"",6f)	UN	t	Unknown	d
1519	(01f7,"ELSCINT1",28)	OW	t	Unknown	d
2141	(0009,"GEMS_GENIE_1",12)	SL	t	StudyType	d
1541	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",21)	UN	t	Unknown	d
3694	(0040,030e)[<0>](01e1,"ELSCINT1",52)	UN	t	Exposure Dose Sequence:Unknown	d
3900	(0043,"",33)	UN	t	Unknown	d
2806	(01f7,"ELSCINT1",17)	OB	t	Unknown	d
3754	(0043,"dcm4che/archive",15)	AE	t	Called AE Title	d
3023	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1367	(01f7,"ELSCINT1",17)	OW	t	Unknown	d
4114	(0907,"GEIIS",10)	UI	t	Original Study Instance UID	d
4302	(0009,"CTP",06)	UN	t	Unknown	d
2988	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",82)	OB	t	Unknown:Unknown	d
3168	(0029,"FDMS 1.0",44)	OB	t	LineDensityCode	d
4337	(00e1,"ELSCINT1",46)	OB	t	Unknown	d
3647	(0011,"GEMS_GDXE_FALCON_04",67)	UN	t	Unknown	d
5489	(07a1,"ELSCINT1",8d)	ST	t	Unknown	d
5290	(2001,"Philips Imaging DD 129",00)[<0>](0070,0060)	SQ	t	Presentation State Sequence:Graphic Layer Sequence	d
3751	(0031,"AGFA PACS Archive Mirroring 1.0",01)	SH	t	Unknown	d
1400	(0031,"AGFA PACS Archive Mirroring 1.0",01)	UL	t	Unknown	d
4110	(0019,"SIEMENS MR HEADER",25)	FD	t	Unknown	d
479	(0019,"GEMS_ACQU_01",ab)	DS	t	UserData	d
3994	(0021,"",51)	UN	t	Unknown	d
4125	(0019,"SIEMENS MR HEADER",25)	UN	t	Unknown	d
4001	(0043,"",91)	UN	t	Unknown	d
3147	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
1456	(0009,"GEIIS",3d)	UN	t	Unknown	d
4133	(5653,"",22)	UN	t	Unknown	d
4205	(5653,"",22)	OB	t	Unknown	d
3839	(0019,"",ca)	UN	t	Unknown	d
3003	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3266	(3f01,"INTELERAD MEDICAL SYSTEMS",10)	UN	t	Unknown	d
4046	(0033,"",19)	PN	t	Unknown	d
3799	(0033,"",19)	UN	t	Unknown	d
730	(0009,"GEMS_PETD_01",71)	FD	t	total_prompts	d
3852	(0043,"",32)	UN	t	Unknown	d
3027	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1501	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",61)	UN	t	Unknown	d
3052	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",a3)	OB	t	Unknown:Unknown	d
1479	(0009,"Unnamed Private Block - 10",05)	UN	t	Unknown	d
3643	(0011,"GEMS_GDXE_FALCON_04",82)	UN	t	Unknown	d
1534	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",36)	UN	t	Unknown	d
1376	(01f7,"ELSCINT1",27)	OW	t	Unknown	d
2924	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",20)	SQ	t	Unknown:Unknown	d
2815	(01f7,"ELSCINT1",27)	OB	t	Unknown	d
3169	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
1330	(0011,"GEMS_PETD_01",01)	SQ	t	Unknown	d
3087	(0025,"FDMS 1.0",10)	OB	t	RelativeLightEmissionAmountSk	d
1598	(0021,"GEMS_RELA_01",19)	UL	t	AcqReconRecordChecksum	d
4065	(0029,"",09)	LO	t	Unknown	d
3794	(0029,"",09)	UN	t	Unknown	d
4226	(0011,"ULTRAVISUAL_TAG_SET1",10)	UN	t	Unknown	d
3941	(0043,"",88)	UN	t	Unknown	d
2942	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",50)	SQ	t	Unknown:Unknown	d
3107	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",a2)	OB	t	Unknown:Unknown	d
4027	(0029,"",13)	CS	t	Unknown	d
1294	(0029,"SIEMENS CSA HEADER",09)	LO	t	CSAImageHeaderVersion	d
142	(0029,"SIEMENS CSA HEADER",09)	OB	t	CSAImageHeaderVersion	d
4211	(0077,"",01)	FL	t	Unknown	d
4113	(0077,"",01)	UN	t	Unknown	d
1636	(0051,"SIEMENS MR HEADER",19)	LO	t	Unknown	d
136	(0051,"SIEMENS MR HEADER",19)	OB	t	Unknown	d
3126	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",41)	OB	t	Unknown:Unknown	d
1650	(3109,"Applicare/RadWorks/Version 5.0",0b)	TM	t	Receive Time	d
5296	(2001,"Philips Imaging DD 129",01)		t	PresentationStateSequence	d
5153	(0903,"GEIIS PACS",10)	OB	t	Reject Image Flag	d
3175	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
4181	(0043,"dcm4che/archive",2b)	SS	t	Unknown	d
1684	(0051,"SIEMENS MR HEADER",15)	SH	t	Unknown	d
133	(0051,"SIEMENS MR HEADER",15)	OB	t	Unknown	d
4128	(0019,"",28)	FD	t	Unknown	d
4094	(0019,"",28)	UN	t	Unknown	d
4118	(2001,"Philips Imaging DD 129",00)[<0>](0028,3003)	LO	t	Presentation State Sequence:LUT Explanation	d
2783	(0009,"SECTRA_Ident_01",02)	LO	t	Examination number	d
2840	(0009,"SECTRA_Ident_01",02)	OB	t	Examination number	d
1131	(0009,"GEMS_PETD_01",c8)	LO	t	ovlp_frm_id	d
1157	(0009,"GEMS_PETD_01",c8)	UI	t	ovlp_frm_id	d
3036	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",21)	OB	t	Unknown:Unknown	d
4069	(0029,"",18)	CS	t	Unknown	d
4208	(5653,"",16)	OB	t	Unknown	d
4136	(5653,"",16)	UN	t	Unknown	d
3797	(0029,"",18)	UN	t	Unknown	d
4340	(00e1,"ELSCINT1",02)	SH	t	Unknown	d
829	(00e1,"ELSCINT1",02)	UN	t	Unknown	d
2891	(00e1,"ELSCINT1",39)[<0>](0040,0260)[<1>](0008,0102)	SH	t	Unknown:Performed Protocol Code Sequence:Coding Scheme Designator	d
3049	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",50)	OB	t	Unknown:Unknown	d
3866	(0019,"",e0)	UN	t	Unknown	d
3056	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",21)	OB	t	Unknown:Unknown	d
3887	(0019,"",5a)	UN	t	Unknown	d
3891	(0019,"",ac)	UN	t	Unknown	d
4303	(0009,"CTP",08)	UN	t	Unknown	d
3652	(0011,"GEMS_GDXE_FALCON_04",71)	UN	t	Unknown	d
3829	(0043,"",2e)	UN	t	Unknown	d
502	(0019,"GEMS_ACQU_01",bc)	DS	t	UserData	d
1423	(0009,"GEMS_PETD_01",33)	SL	t	Upper Reject Limit	d
1555	(07a3,"ELSCINT1",55)	SH	t	Unknown	d
1356	(01f1,"ELSCINT1",4d)	SH	t	Unknown	d
3948	(0019,"",d9)	UN	t	Unknown	d
2982	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
1615	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",5a)	UN	t	Unknown	d
4241	(0077,"NIL_nICE_ATT",02)	SS	t	Unknown	d
505	(0019,"GEMS_ACQU_01",b5)	DS	t	UserData	d
4049	(0033,"",0e)	LT	t	Unknown	d
3197	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
3992	(0043,"",29)	UN	t	Unknown	d
4210	(5653,"",15)[<0>](0020,0037)	DS	t	Unknown:Image Orientation (Patient)	d
3999	(0025,"",10)	UN	t	Unknown	d
4224	(0011,"ULTRAVISUAL_TAG_SET1",1b)	UN	t	Unknown	d
1371	(01f7,"ELSCINT1",2c)	OW	t	Unknown	d
3635	(0011,"GEMS_GDXE_FALCON_04",81)	UN	t	Unknown	d
4014	(0019,"",a9)	UN	t	Unknown	d
3182	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",96)	OB	t	Unknown:Unknown	d
3029	(50f1,"FDMS 1.0",10)	OB	t	Film Output Format	d
2878	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0008)	SQ	t	Unknown:Request Attributes Sequence:Scheduled Protocol Code Sequence	d
3732	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",10)	LT	t	Internal Value	d
4313	(0137,"NetRAAD",0d)	UI	t	Unknown	d
1530	(3109,"Applicare/RadWorks/Version 6.0/Summary",12)	ST	t	Receive Origin Description	d
4051	(0019,"",08)	CS	t	Unknown	d
3786	(0019,"",08)	UN	t	Unknown	d
3068	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",21)	OB	t	Unknown:Unknown	d
2933	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",40)	SQ	t	Unknown:Unknown	d
771	(0009,"GEMS_PETD_01",63)	SL	t	frame_size	d
2143	(0011,"GEMS_GENIE_1",46)	SL	t	InterpolationType	d
3729	(0019,"Siemens: Thorax/Multix FD Lab Settings",02)	LO	t	Total Dose Area Product uGy*cm*cm	d
493	(0019,"GEMS_ACQU_01",a9)	DS	t	UserData	d
1622	(0043,"GEMS_PARM_01",29)	OB	t	HistogramTables	d
3006	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
3632	(0011,"GEMS_GDXE_FALCON_04",06)	DS	t	Image Dose	d
3294	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0100)	US	t	Unknown:Unknown:Bits Allocated	d
4122	(0019,"",26)	UN	t	Unknown	d
3164	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",62)	OB	t	Unknown:Unknown	d
4336	(01f7,"ELSCINT1",9b)	IS	t	Unknown	d
830	(01f7,"ELSCINT1",9b)	UN	t	Unknown	d
4237	(0029,"",00)	UN	t	Unknown	d
3163	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",62)	OB	t	Unknown:Unknown	d
3996	(0043,"",28)	UN	t	Unknown	d
3021	(0019,"FDMS 1.0",80)	OB	t	ReadingPositionSpecification	d
510	(0019,"GEMS_ACQU_01",b2)	DS	t	UserData	d
3730	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",17)	LO	t	Unknown	d
2868	(01f3,"ELSCINT1",12)	OB	t	Unknown	d
4199	(5653,"",15)	SQ	t	Unknown	d
4077	(0051,"SIEMENS MR HEADER",0e)	SH	t	Unknown	d
1694	(0051,"SIEMENS MR HEADER",0e)	LO	t	Unknown	d
131	(0051,"SIEMENS MR HEADER",0e)	OB	t	Unknown	d
4020	(0027,"",40)	UN	t	Unknown	d
3156	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",40)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
1489	(0009,"GEIIS",10)		t	GE Private Image Thumbnail Sequence	d
1252	(0009,"GEIIS",10)	SQ	t	GE Private Image Thumbnail Sequence	d
4187	(0043,"dcm4che/archive",1e)	DS	t	Unknown	d
490	(0019,"GEMS_ACQU_01",b3)	DS	t	UserData	d
1505	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",5f)	UN	t	Unknown	d
4201	(5653,"",14)[<0>](5653,"",12)	OB	t	Unknown:Unknown	d
3045	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3704	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",07)	FL	t	Unknown	d
5480	(07a5,"ELSCINT1",1c)	LO	t	Unknown	d
3864	(0027,"",10)	UN	t	Unknown	d
3877	(0019,"",c6)	UN	t	Unknown	d
3718	(0021,"Siemens: Thorax/Multix FD Post Processing",12)	SS	t	Unknown	d
4202	(5653,"",14)[<0>](5653,"",13)	OB	t	Unknown:Unknown	d
1540	(0047,"GEMS_3DSTATE_001",ec)	FL	t	Unknown	d
1377	(01f7,"ELSCINT1",23)	OW	t	Unknown	d
2167	(0009,"GEMS_IDEN_01",40)	UN	t	Unknown	d
2816	(01f7,"ELSCINT1",23)	OB	t	Unknown	d
4147	(5653,"Vital Images SW 3.4",14)	SQ	t	Saved Workflow File Sequence	d
1355	(00e1,"ELSCINT1",40)	SH	t	Image Label	d
2842	(00e1,"ELSCINT1",40)	OB	t	Image Label	d
3080	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",20)	OB	t	Unknown:Unknown	d
3687	(0040,030e)[<0>](01e3,"ELSCINT1",09)	UN	t	Exposure Dose Sequence:Unknown	d
4068	(0029,"",08)	CS	t	Unknown	d
3165	(0019,"FDMS 1.0",50)	OB	t	EDRMode	d
3817	(0029,"",08)	UN	t	Unknown	d
3923	(0009,"",e9)	UN	t	Unknown	d
3258	(0029,"INTELERAD MEDICAL SYSTEMS",02)	UN	t	ImageQuality	d
3093	(0025,"FDMS 1.0",11)	OB	t	TermOfCorrectionForEachIPTypeSt	d
1304	(7053,"Philips PET Private Group",01)	OB	t	Private Data	d
1437	(00e1,"ELSCINT1",a0)	LO	t	Unknown	d
3944	(0019,"",cf)	UN	t	Unknown	d
3684	(0040,030e)[<0>](01f1,"ELSCINT1",27)	DS	t	Exposure Dose Sequence:Rotation Time	d
2963	(50f1,"FDMS 1.0",0a)	OB	t	FNC Parameters	d
3733	(0019,"Siemens: Thorax/Multix FD Lab Settings",07)	FD	t	Table Detector Distance	d
580	(0009,"GEMS_PETD_01",62)	ST	t	where_is_frame	d
1285	(0009,"GEMS_IDEN_01",39)	UN	t	Unknown	d
3646	(0011,"GEMS_GDXE_FALCON_04",59)	UN	t	Unknown	d
2903	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0007)	LO	t	Unknown:Request Attributes Sequence:Scheduled Procedure Step Description	d
2801	(01f1,"ELSCINT1",32)	OB	t	Image View Convention	d
3985	(0019,"",d5)	UN	t	Unknown	d
3256	(0029,"INTELERAD MEDICAL SYSTEMS",03)	UN	t	ImageBytesTransferred	d
1654	(07a3,"ELSCINT1",9c)	CS	t	Unknown	d
1398	(0009,"GEMS_IDEN_01",37)	UN	t	Unknown	d
4327	(0043,"GEMS_PARM_01",b3)	DS	t	Unknown	d
4005	(0019,"",af)	UN	t	Unknown	d
1208	(0029,"SIEMENS MEDCOM OOG",10)	OB	t	MEDCOMOOGInfo	d
1689	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",35)	UN	t	Unknown	d
3155	(0021,"FDMS 1.0",30)	OB	t	SetNo	d
3674	(200b,"Philips RAD Imaging DD 097",aa)[<0>](200b,"Philips RAD Imaging DD 097",ac)	UN	t	Unknown:Unknown	d
4115	(0019,"SIEMENS MR HEADER",0a)	UN	t	Number of Images in Mosaic	d
1696	(0019,"SIEMENS MR HEADER",0a)	OB	t	Number of Images in Mosaic	d
1286	(0009,"GEMS_IDEN_01",6c)	UN	t	Unknown	d
2128	(0009,"GEMS_GENIE_1",10)	LO	t	Unknown	d
3039	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",a2)	OB	t	Unknown:Unknown	d
4962	(0028,3110)[<0>](2001,"Philips Imaging DD 001",53)	CS	t	Softcopy VOI LUT Sequence:Presentation GL Transform Invert	d
3639	(0011,"GEMS_GDXE_FALCON_04",70)	UN	t	Unknown	d
1514	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",13)	UN	t	Unknown	d
1347	(01f7,"ELSCINT1",10)	OB	t	Unknown	d
1532	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",56)	UN	t	Unknown	d
4186	(0043,"dcm4che/archive",27)	SH	t	Unknown	d
3060	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",71)	OB	t	Unknown:Unknown	d
3888	(0019,"",91)	UN	t	Unknown	d
4196	(0043,"dcm4che/archive",1f)	SL	t	Unknown	d
2956	(0019,"FDMS 1.0",60)	OB	t	RadiographersCode	d
482	(0019,"GEMS_ACQU_01",b1)	DS	t	UserData	d
3665	(2001,"Philips Imaging DD 002",6c)	UN	t	Unknown	d
3268	(0051,"GEMS_CT_VES_01",01)[<0>](0020,000d)	UI	t	CTVESequence:Study Instance UID	d
4109	(0019,"SIEMENS MR HEADER",26)	FD	t	Unknown	d
4124	(0019,"SIEMENS MR HEADER",26)	UN	t	Unknown	d
3810	(0051,"",12)	UN	t	Unknown	d
834	(01e1,"ELSCINT1",41)	UN	t	Unknown	d
3928	(0043,"",7d)	UN	t	Unknown	d
3760	(0079,"Unnamed Private Block - 10",17)	IS	t	Unknown	d
4218	(0011,"ULTRAVISUAL_TAG_SET1",11)	UN	t	Unknown	d
2990	(0009,"FDMS 1.0",f0)	OB	t	Blackening Process Flag	d
1263	(0905,"GEIIS",30)	LO	t	Assigning Authority For Patient ID	d
4073	(0043,"GEMS_PARM_01",8d)	DS	t	SAT Band Locations	d
1607	(0029,"SIEMENS CSA HEADER",20)	OB	t	CSASeriesHeaderInfo	d
3965	(0043,"",0b)	UN	t	Unknown	d
5276	(0905,"GEIIS",30)	OB	t	Assigning Authority For Patient ID	d
2989	(0009,"FDMS 1.0",f1)	OB	t	Processing Information Flag	d
1633	(0029,"MITRA MARKUP 1.0",00)	OB	t	Markup1	d
2971	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a0)	OB	t	Unknown:Unknown:Unknown	d
1473	(0009,"Unnamed Private Block - 10",3d)	UN	t	Unknown	d
1368	(01f7,"ELSCINT1",26)	OW	t	Unknown	d
2858	(01f7,"ELSCINT1",26)	OB	t	Unknown	d
4156	(5653,"Vital Images SW 3.4",14)[<0>](5653,"Vital Images SW 3.4",13)	SL	t	Saved Workflow File Sequence:Saved Workflow File Length	d
3144	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",92)	OB	t	Unknown:Unknown	d
2811	(01f7,"ELSCINT1",14)	OB	t	Unknown	d
4009	(0043,"",36)	UN	t	Unknown	d
1683	(07a3,"ELSCINT1",99)	CS	t	Unknown	d
1373	(01f7,"ELSCINT1",14)	OW	t	Unknown	d
4176	(0043,"dcm4che/archive",28)	OB	t	Unknown	d
4076	(0043,"GEMS_PARM_01",8c)	DS	t	Voxel Location	d
2936	(0023,"FDMS 1.0",20)	SQ	t	Unknown	d
2917	(00e1,"ELSCINT1",39)[<0>](0008,1140)[<1>](0008,1155)	UI	t	Unknown:Referenced Image Sequence:Referenced SOP Instance UID	d
4219	(0011,"ULTRAVISUAL_TAG_SET1",1c)	UN	t	Unknown	d
2144	(0009,"GEMS_GENIE_1",42)	DA	t	PatientCreationDate	d
2131	(0011,"GEMS_GENIE_1",12)	LO	t	DatasetName	d
3840	(0043,"",30)	UN	t	Unknown	d
3844	(0021,"",4f)	UN	t	Unknown	d
4151	(5653,"Vital Images SW 3.4",17)	UI	t	Volume SOP Instance UID	d
3177	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",20)[<1>](0027,"FDMS 1.0",a2)	OB	t	Unknown:Unknown:Unknown	d
5295	(0008,1115)[<0>](0008,1140)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Referenced Series Sequence:Referenced Image Sequence:Linear Modality GL Transform	d
3778	(0051,"GEMS_FUNCTOOL_01",03)	FL	t	Bias	d
138	(0019,"SIEMENS MR HEADER",08)	OB	t	Unknown	d
4972	(2005,"Philips MR Imaging DD 005",0e)		t	Private Shared Sequence	d
5065	(2005,"Philips MR Imaging DD 005",0e)	OB	t	Private Shared Sequence	d
5491	(07a1,"ELSCINT1",97)	SH	t	Unknown	d
2920	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",70)	SQ	t	Unknown:Unknown	d
3916	(0021,"",5e)	UN	t	Unknown	d
3629	(0045,"GEMS_FALCON_03",65)	IS	t	Requested Detector Entrance Dose	d
2935	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",30)	SQ	t	Unknown:Unknown	d
4036	(0051,"",0e)	LO	t	Unknown	d
3785	(0051,"",0e)	UN	t	Unknown	d
1597	(0009,"GEMS_PETD_01",10)	LO	t	Hospital Name	d
1360	(00e1,"ELSCINT1",42)	LO	t	Unknown	d
4091	(700d,"TOSHIBA_MEC_MR3",0c)	UN	t	Unknown	d
3110	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",13)	OB	t	Unknown:Unknown	d
2911	(00e1,"ELSCINT1",39)[<0>](0032,1032)	PN	t	Unknown:Requesting Physician	d
2898	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,1001)	SH	t	Unknown:Request Attributes Sequence:Requested Procedure ID	d
3122	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",73)	OB	t	Unknown:Unknown	d
2882	(00e1,"ELSCINT1",39)[<0>](0008,1032)	SQ	t	Unknown:Procedure Code Sequence	d
3676	(200b,"Philips RAD Imaging DD 097",a4)	UN	t	Unknown	d
4038	(0029,"",60)	LO	t	Unknown	d
3812	(0029,"",19)	UN	t	Unknown	d
3875	(0043,"",2f)	UN	t	Unknown	d
4185	(0043,"dcm4che/archive",16)	SS	t	Instance Updated	d
2849	(01f3,"ELSCINT1",18)	OB	t	Unknown	d
3069	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",20)	OB	t	Unknown:Unknown	d
3758	(0079,"Unnamed Private Block - 10",07)	LO	t	Unknown	d
4033	(0051,"",0d)	SH	t	Unknown	d
3802	(0051,"",0d)	UN	t	Unknown	d
3764	(0079,"Unnamed Private Block - 10",04)	DS	t	Unknown	d
5479	(07a3,"ELSCINT1",e3)	LO	t	Unknown	d
579	(0009,"GEMS_PETD_01",e4)	ST	t	Unknown	d
3910	(0027,"",32)	UN	t	Unknown	d
349	(0021,"GEMS_RELA_01",35)	SS	t	SeriesFromWhichPrescribed	d
4184	(0043,"dcm4che/archive",25)	SS	t	Unknown	d
3089	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",71)	OB	t	Unknown:Unknown	d
2952	(0019,"FDMS 1.0",15)	OB	t	KanjiBodyPartForExposure	d
5289	(0028,3110)[<0>](0008,1140)[<1>](2001,"Philips Imaging DD 001",c1)	LO	t	Softcopy VOI LUT Sequence:Referenced Image Sequence:Linear Modality GL Transform	d
3102	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",a1)	OB	t	Unknown:Unknown	d
4191	(0043,"dcm4che/archive",10)	US	t	Patient Pk	d
4087	(700d,"TOSHIBA_MEC_MR3",03)	SS	t	Flip Flag	d
486	(0019,"GEMS_ACQU_01",af)	DS	t	UserData	d
3123	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",70)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
4117	(0019,"SIEMENS MR HEADER",27)	UN	t	B Matrix	k
1645	(0029,"SIEMENS CSA HEADER",18)	CS	t	CSASeriesHeaderType	d
140	(0029,"SIEMENS CSA HEADER",18)	OB	t	CSASeriesHeaderType	d
3986	(0043,"",02)	UN	t	Unknown	d
4054	(0019,"",18)	IS	t	Unknown	d
3823	(0019,"",18)	UN	t	Unknown	d
3037	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",50)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2901	(00e1,"ELSCINT1",39)[<0>](0020,0010)	SH	t	Unknown:Study ID	d
3848	(0043,"",97)	UN	t	Unknown	d
3271	(0051,"GEMS_CT_VES_01",01)[<0>](0032,1060)	LO	t	CTVESequence:Requested Procedure Description	d
1478	(0009,"Unnamed Private Block - 10",68)	UN	t	Unknown	d
2133	(0009,"GEMS_GENIE_1",43)	TM	t	PatientCreationTime	d
3715	(0025,"Siemens: Thorax/Multix FD Raw Image Settings",14)	SS	t	Unknown	d
3055	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
5068	(2005,"Philips MR Imaging DD 004",91)	OB	t	Patient Name Job In Params	d
5474	(0095,"SIENET",12)	LO	t	Unknown	d
4075	(0043,"GEMS_PARM_01",8e)	DS	t	Spectro Prescan Values	d
3766	(0079,"Unnamed Private Block - 10",11)	DS	t	Unknown	d
1566	(0025,"GEMS_SERS_01",1b)	OB	t	Protocol Data Block (compressed)	d
3078	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",a0)	OB	t	Unknown:Unknown	d
1315	(7053,"Philips PET Private Group",13)	SS	t	Unknown	d
1574	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",57)	UN	t	Unknown	d
5495	(07a1,"ELSCINT1",96)	DA	t	Unknown	d
4215	(0043,"",99)	UN	t	Unknown	d
831	(01f7,"ELSCINT1",99)	UN	t	Unknown	d
4349	(01f7,"ELSCINT1",99)	OW	t	Unknown	d
4032	(0031,"",01)	UL	t	Unknown	d
3795	(0031,"",01)	UN	t	Unknown	d
3106	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",33)	OB	t	Unknown:Unknown	d
3945	(0043,"",95)	UN	t	Unknown	d
2790	(7fdf,"ELSCINT1",ff)	OB	t	Unknown	d
2928	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",20)	SQ	t	Unknown:Unknown	d
1663	(0009,"GEMS_IDEN_01",e7)	UL	t	ExamRecordChecksum	d
2867	(01f3,"ELSCINT1",16)	OB	t	Unknown	d
4967	(0070,005a)[<0>](2001,"Philips Imaging DD 001",3f)	CS	t	Displayed Area Selection Sequence:ZoomMode	d
3242	(300a,0010)[<0>](300d,"TOMO_HA_01",19)	UN	t	Dose Reference Sequence:Unknown	d
2800	(00e1,"ELSCINT1",50)	OB	t	Acquisition Duration	d
3153	(0023,"FDMS 1.0",10)[<0>](0027,"FDMS 1.0",30)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
2826	(01f7,"ELSCINT1",30)	OB	t	Unknown	d
1386	(01f7,"ELSCINT1",30)	OW	t	Unknown	d
2841	(00e1,"ELSCINT1",22)	OB	t	Presentation Relative Center	d
1374	(01f7,"ELSCINT1",25)	OW	t	Unknown	d
2913	(00e1,"ELSCINT1",39)[<0>](0008,1140)	SQ	t	Unknown:Referenced Image Sequence	d
3030	(0023,"FDMS 1.0",10)[<0>](0025,"FDMS 1.0",81)	OB	t	Unknown:Unknown	d
3838	(0019,"",e2)	UN	t	Unknown	d
3845	(0019,"",d8)	UN	t	Unknown	d
2821	(01f7,"ELSCINT1",31)	OB	t	Unknown	d
1397	(01f7,"ELSCINT1",31)	OW	t	Unknown	d
2887	(00e1,"ELSCINT1",39)[<0>](0020,000d)	UI	t	Unknown:Study Instance UID	d
2909	(00e1,"ELSCINT1",39)[<0>](0008,1032)[<1>](0008,0104)	LO	t	Unknown:Procedure Code Sequence:Code Meaning	d
1352	(01f1,"ELSCINT1",53)	SH	t	Unknown	d
1316	(7053,"Philips PET Private Group",18)	SS	t	Unknown	d
2883	(00e1,"ELSCINT1",39)[<0>](0008,1111)	SQ	t	Unknown:Referenced Performed Procedure Step Sequence	d
3290	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](7fe0,0010)	OB	t	Unknown:Unknown:Pixel Data	d
3896	(0019,"",b1)	UN	t	Unknown	d
4172	(0023,"GEMS_STDY_01",80)	UN	t	Has MPPS Related Tags	d
4139	(0043,"GEMS_PARM_01",a4)	LO	t	Detailed text for ASL labeling technique	d
3783	(0043,"GEMS_PARM_01",a4)	UN	t	Detailed text for ASL labeling technique	d
2808	(01f7,"ELSCINT1",15)	OB	t	Unknown	d
788	(0009,"GEMS_PETD_01",64)	SL	t	file_exists	d
1594	(0029,"MITRA PRESENTATION 1.0",00)	CS	t	Rotation	d
3959	(0021,"",5d)	UN	t	Unknown	d
3960	(0019,"",94)	UN	t	Unknown	d
4980	(2001,"Philips Imaging DD 129",00)[<0>](2005,"Philips MR Imaging DD 005",90)	SQ	t	Presentation State Sequence:Original VOI LUT Sequence	d
3009	(0023,"FDMS 1.0",30)[<0>](0027,"FDMS 1.0",10)[<1>](0027,"FDMS 1.0",a1)	OB	t	Unknown:Unknown:Unknown	d
1385	(01f7,"ELSCINT1",1b)	OW	t	Unknown	d
2825	(01f7,"ELSCINT1",1b)	OB	t	Unknown	d
1422	(0009,"GEMS_PETD_01",d2)	UI	t	image_set_id	d
3978	(0043,"",35)	UN	t	Unknown	d
2899	(00e1,"ELSCINT1",39)[<0>](0040,0275)[<1>](0040,0009)	SH	t	Unknown:Request Attributes Sequence:Scheduled Procedure Step ID	d
3983	(0043,"",80)	UN	t	Unknown	d
2814	(00e1,"ELSCINT1",01)	OB	t	Data Dictionary Version	d
3134	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",40)	OB	t	Unknown:Unknown	d
2900	(00e1,"ELSCINT1",39)[<0>](0040,0260)[<1>](0008,0100)	SH	t	Unknown:Performed Protocol Code Sequence:Code Value	d
2829	(01f1,"ELSCINT1",0a)	OB	t	Edge Enhancement Weight	d
3143	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",92)	OB	t	Unknown:Unknown	d
1668	(07a1,"ELSCINT1",36)	UN	t	Unknown	d
3295	(3773,"Unnamed Private Block - 01",31)[<0>](3773,"Unnamed Private Block - 01",32)[<1>](0028,0101)	US	t	Unknown:Unknown:Bits Stored	d
2968	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",94)	OB	t	Unknown:Unknown	d
3836	(0021,"",84)	UN	t	Unknown	d
3245	(300a,0010)[<0>](300d,"TOMO_HA_01",1b)	UN	t	Dose Reference Sequence:Unknown	d
1317	(7053,"Philips PET Private Group",17)	SS	t	Unknown	d
494	(0019,"GEMS_ACQU_01",ad)	DS	t	UserData	d
2881	(00e1,"ELSCINT1",39)[<0>](0032,1064)	SQ	t	Unknown:Requested Procedure Code Sequence	d
3051	(0023,"FDMS 1.0",20)[<0>](0027,"FDMS 1.0",80)[<1>](0027,"FDMS 1.0",a3)	OB	t	Unknown:Unknown:Unknown	d
3874	(0019,"",c3)	UN	t	Unknown	d
3880	(0027,"",35)	UN	t	Unknown	d
5490	(07a3,"ELSCINT1",fc)	DT	t	Unknown	d
1527	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",62)	UN	t	Unknown	d
3904	(0043,"",98)	UN	t	Unknown	d
3260	(0029,"INTELERAD MEDICAL SYSTEMS",21)	US	t	HistogramPercentileLabels	d
4315	(0137,"NetRAAD",02)	SH	t	Unknown	d
3088	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",32)	OB	t	Unknown:Unknown	d
1591	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",68)	UN	t	Unknown	d
2130	(0009,"GEMS_GENIE_1",20)	LO	t	Unknown	d
2959	(0029,"FDMS 1.0",34)	OB	t	MagnificationReductionRatio	d
1621	(0021,"GEMS_RELA_01",07)	UL	t	SeriesRecordChecksum	d
4190	(0043,"dcm4che/archive",26)	US	t	Unknown	d
1455	(0009,"GEIIS",3b)	UN	t	Unknown	d
3119	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",53)	OB	t	Unknown:Unknown	d
1348	(01f1,"ELSCINT1",46)	FL	t	Unknown	d
2832	(01f1,"ELSCINT1",46)	OB	t	Unknown	d
3988	(0019,"",8a)	UN	t	Unknown	d
3745	(0021,"Siemens: Thorax/Multix FD Post Processing",00)	US	t	Unknown	d
2839	(01f1,"ELSCINT1",0d)	OB	t	Rotation Angle	d
3717	(0021,"Siemens: Thorax/Multix FD Post Processing",0d)	SS	t	Unknown	d
3668	(200b,"Philips RAD Imaging DD 099",36)	UN	t	Unknown	d
3162	(0023,"FDMS 1.0",30)[<0>](0025,"FDMS 1.0",62)	OB	t	Unknown:Unknown	d
1107	(0029,"SIEMENS MEDCOM HEADER",31)	LO	t	PMTFInformation1	d
3843	(0019,"",b8)	UN	t	Unknown	d
1493	(0011,"IPKCREP 2Q00+0C  TMIGA ERPVITA EADAT",67)	UN	t	Unknown	d
1365	(01f7,"ELSCINT1",13)	OW	t	Unknown	d
2792	(01f7,"ELSCINT1",13)	OB	t	Unknown	d
3858	(0021,"",56)	UN	t	Unknown	d
5493	(07a1,"ELSCINT1",9a)	LT	t	Unknown	d
1516	(0027,"GEMS_IMAG_01",06)	SL	t	ImageArchiveFlag	d
1401	(0033,"MITRA OBJECT UTF8 ATTRIBUTES 1.0",13)	OB	t	Unknown	d
3703	(0021,"Siemens: Thorax/Multix FD Post Processing",03)	FL	t	Unknown	d
1557	(0051,"SIEMENS MR HEADER",16)	LO	t	Unknown	d
135	(0051,"SIEMENS MR HEADER",16)	OB	t	Unknown	d
2853	(01f3,"ELSCINT1",11)[<0>](01f3,"ELSCINT1",15)	OB	t	Unknown:Unknown	d
469	(0019,"GEMS_ACQU_01",a7)	DS	t	UserData	d
2810	(01f7,"ELSCINT1",18)	OB	t	Unknown	d
1372	(01f7,"ELSCINT1",18)	OW	t	Unknown	d
3109	(0009,"FDMS 1.0",06)	OB	t	RouteImage UID	d
3956	(0019,"",9d)	UN	t	Unknown	d
1205	(0073,"STENTOR",01)	ST	t	Unknown	d
3964	(0019,"",9b)	UN	t	Unknown	d
1248	(0009,"GEMS_PETD_01",5f)	LO	t	patient_id	d
2820	(01f7,"ELSCINT1",1a)	OB	t	Unknown	d
1382	(01f7,"ELSCINT1",1a)	OW	t	Unknown	d
4119	(2001,"Philips Imaging DD 129",00)[<0>](0028,3006)	OW	t	Presentation State Sequence:LUT Data	d
1475	(0009,"Unnamed Private Block - 10",39)	UN	t	Unknown	d
3984	(0019,"",92)	UN	t	Unknown	d
1350	(01f7,"ELSCINT1",22)	UI	t	Unknown	d
2787	(01f7,"ELSCINT1",22)	OB	t	Unknown	d
2914	(00e1,"ELSCINT1",39)[<0>](00e1,"ELSCINT1",3a)	IS	t	Unknown:Unknown	d
568	(0053,"GEHC_CT_ADVAPP_001",9d)	LO	t	Unknown	d
373	(0053,"GEHC_CT_ADVAPP_001",9d)	UN	t	Unknown	d
3137	(0023,"FDMS 1.0",20)[<0>](0025,"FDMS 1.0",90)	OB	t	Unknown:Unknown	d
1328	(7053,"Philips PET Private Group",05)	LO	t	Worklist Info File Name	d
5472	(0099,"SIENET",02)	SL	t	DataObjectAttributes	k
\.


--
-- Name: element_seen_element_seen_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('public.element_seen_element_seen_id_seq', 7096, true);


--
-- PostgreSQL database dump complete
--

\connect posda_files

insert into public.import_control values (
	'waiting to go inservice', 	-- status
	null, 				-- processor_pid
	10, 				-- idle_seconds
	null, 				-- pending_change_request
	50 				-- files_per_round
);

alter database posda_files set search_path = public, dbif_config, dicom_conv;

refresh materialized view public.file_imports_over_time;
refresh materialized view public.files_without_type;
\connect posda_files
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 10.8 (Ubuntu 10.8-0ubuntu0.18.04.1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Data for Name: background_buttons; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.background_buttons (background_button_id, operation_name, object_class, button_text, tags) FROM stdin;
25	QuickCheckPublicPosdaConsistLike	Posda::ProcessPopup	Quick Public Posda Like Collection	{public_posda_consistency}
29	UpdateActivityTimepoint	Posda::ProcessPopup	Update Activity Timepoint	{activity_timepoints}
27	CreateActivityTimepointFromCollectionSite	Posda::ProcessPopup	Create Activity Timepoint	{activity_timepoints}
28	FixBadSopInstanceLungFusedCtPathology	Posda::ProcessPopup	Fix Bad SOP Instances in Lung-Fused-CT-Pathology	{"Curation of Lung-Fused-CT-Pathology"}
30	VisualReviewFromTimepoint	Posda::ProcessPopup	Schedule Visual Review	{activity_timepoints}
31	PhiReviewFromTimepoint	Posda::ProcessPopup	Schedule PHI Scan	{activity_timepoints}
32	ConsistencyFromTimePoint	Posda::ProcessPopup	Check Consistency	{activity_timepoints}
33	LinkRtFromTimepoint	Posda::ProcessPopup	Link RT Data for ItcTools	{activity_timepoints}
34	CheckStructLinkagesTp	Posda::ProcessPopup	Check Structure Set Linkages	{activity_timepoints}
35	DispositionNeededWorksheet	Posda::ProcessPopup	Make Worksheet for Diapositions Needed	{phi_maint}
36	PhiPublicScanTp	Posda::ProcessPopup	Public Phi Scan Based on Current TP by Activity	{activity_timepoints}
37	SummarizeStructLinkage	Posda::ProcessPopup	Summarize Structure Set Linkages for a File	{activity_timepoint_support}
38	BackgroundDciodvfyTp	Posda::ProcessPopup	Run Dciodvfy for Time Point	{activity_timepoints}
39	CondensedActivityTimepointReport	Posda::ProcessPopup	Produce Condensed Activity Timepoint Report	{activity_timepoints}
26	AnalyzeSeriesDuplicates	Posda::ProcessPopup	Analyze Series With Duplicates	{"ACRIN-FMISO-Brain Duplicate Elimination",dup_sops,activity_timepoint_support}
40	FilesInTpNotInPublic	Posda::ProcessPopup	Find Files in Tp, not in Public	{activity_timepoints}
41	CompareSopsInTpToPublic	Posda::ProcessPopup	Compare Corresponding SOPs in Time Point to Public	{activity_timepoints}
42	AnalyzeSeriesDuplicatesForTimepoint	Posda::ProcessPopup	Analyze Series In Time Point with Duplicates	{activity_timepoint_support}
43	CompareSopsTpPosdaPublic	Posda::ProcessPopup	Compare Sops in Timepoint, Posda, and Public	{activity_timepoint_support}
44	FixFilesWithNullNumberOfFrames	Posda::ProcessPopup	Fix Files With Null Number of Frames	{Exceptional-Responders_NCI_Oct2018_curation}
45	FixCtInExceptionalRespondersWithNullNumberOfFrames	Posda::ProcessPopup	Fix CT Files in Exceptional-Responders with Null Number of Frames	{Exceptional-Responders_NCI_Oct2018_curation}
46	PrivateTagReports	Posda::ProcessPopup	Create Private Tag Vr and Disposition Reports	{phi_maint}
47	BackgroundPrivateDispositionsTp	Posda::ProcessPopup	Apply Background Dispositions To Timepoint (non baseline date)	{activity_timepoints}
48	BackgroundPrivateDispositionsTpBaseline	Posda::ProcessPopup	Apply Background Dispositions To Timepoint (baseline date)	{activity_timepoints}
49	MakeWeeklyFilesReport	Posda::ProcessPopup	Generate Report of File Uploads By Type By Week	{downloads_by_date}
50	CompareSopsTpPosdaPublicLike	Posda::ProcessPopup	Compare Sops in Timepoint, Posda, and Public like Collection	{activity_timepoint_support}
1	ImportFromDicomFileEdit	Posda::ProcessPopup	Import Edits	{edit_files}
2	CheckPublicMissingFilesInSeriesByCollection	Posda::ProcessPopup	Check Missing Files Public	{bills_test}
3	CopyCollectionToStaging	Posda::ProcessPopup	Copy Files To Dir	{bills_test}
4	CheckStructLinkagesByCollectionSite	Posda::ProcessPopup	Check Struct Links	{struct_linkages}
5	CheckPosdaPublicConsistency	Posda::ProcessPopup	Check Public Posda	{public_posda_consistency}
6	BackOutEdit	Posda::ProcessPopup	Backout Import Edits	{edit_files}
7	QuickCheckPosdaPublicConsistency	Posda::ProcessPopup	Quick Check Posda PUblic	{public_posda_consistency}
8	SetUpPublicToPosdaCopy	Posda::ProcessPopup	Set Up Copy of Collection From Public To Posda	{public_posda_consistency}
9	StartPublicToPosdaCopy	Posda::ProcessPopup	Start a waiting Public to Posda Copy	{public_posda_consistency}
10	DciodvfyReport	Posda::ProcessPopup	Dciodvfy Report	{dciodvfy}
11	StartFixPublicToPosdaCopy	Posda::ProcessPopup	Retry failed Public Copy	{public_posda_consistency}
12	LookForDupSopsInPublicByCollectionSite	Posda::ProcessPopup	Look for Conflicting Sops already in Public By Collection, Site	{comparing_posda_to_public}
13	DeletePvtExceptCtp	Posda::ProcessPopup	Copy Collection to Scratch Deleting All Private tags exept CTP tags	{bills_test}
14	CheckRtReferenceChain	Posda::ProcessPopup	Check Rt Linkage Chain	{struct_linkages}
20	RejectEdits	Posda::ProcessPopup	Reject Edits	{find_patients,check_edits}
21	ImportEdits	Posda::ProcessPopup	Import Edits	{find_patients,check_edits}
22	CheckEditCurrent	Posda::ProcessPopup	Check If Edits Current	{find_patients,check_edits}
24	NonDicomPhiScan	Posda::ProcessPopup	Phi Scan of Non-Dicom Files	{non_dicom_phi}
18	ProcessVisualReview	Posda::ProcessPopup	Process Visual Review Results	{visual_review_new_workflow,visual_review_reports}
51	CompareSopsTpPosdaPublicCollectionLikeSiteEqual	Posda::ProcessPopup	Compare Sops in Timpoint, Posda, and Public like Collection for Site	{activity_timepoint_support}
52	AdHocReportForTracy	Posda::ProcessPopup	Make CPTAC Report	{clin_qual}
53	HideFilesVisbleInBadEquivalenceClassesByVisualReviewId	Posda::ProcessPopup	Hide Files in Equivalence Classes Marked Bad	{visual_review_status}
54	BackgroundLinkActivityToTemp	Posda::ProcessPopup	Link Files in Activity to Temp Directory	{send_series}
19	RepealEdits	Posda::ProcessPopup	Repeal Edits	{find_patients,check_edits,edit_status}
16	FirstPassPhiByCollection	Posda::ProcessPopup	First Pass Phi By Collection	{phi_status,simple_phi}
15	FirstPassPhiScanAndReport	Posda::ProcessPopup	First Pass Phi by collection, site and (optional) batch	{phi_status,simple_phi}
17	FullPhiById	Posda::ProcessPopup	Full Phi Report by Scan Id	{phi_status,simple_phi}
23	PhiPublicScan	Posda::ProcessPopup	Public Scan By Collection, Site	{phi_status,simple_phi}
55	CreateActivityTimepointFromImportName	Posda::ProcessPopup	Create Activity Timepoint From Import Description	{activity_timepoints}
\.


--
-- Data for Name: chained_query; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.chained_query (chained_query_id, from_query, to_query, caption) FROM stdin;
1	PixelTypes	FileIdByPixelType	files
2	HideEvents	HideEventInfo	Info
3	WhatHasComeInRecentlyWithSubject	ToExamineRecentFiles	files
4	CtSeriesWithCtImageInfoByCollection	CtImageDataConsistencyAcrossSeries	Image Data Consistent?
5	CtSeriesWithCtImageInfoByCollection	SeriesReport	rpt
6	QueriesRunning	GetQuery	drill
7	VisibleColSiteWithCtpLikeSite	DistinctSeriesByCollectionSite	Get Series
8	VisualReviewScanInstances	VisualReviewStatusById	Details
9	ListActivities	InboxContentByActivityId	Details
10	VisualReviewStatusById	VisualReviewStatusDetails	Details
11	ListOpenActivities	InboxContentByActivityId	Details
12	ListOpenActivities	CloseActivity	close
13	ListOpenActivitiesWithItems	InboxContentByActivityId	Details
14	ListOpenActivitiesWithItems	CloseActivity	close
15	ListClosedActivities	InboxContentByActivityId	Details
16	ListClosedActivitiesWithItems	ReOpenActivity	re-open
17	ListClosedActivitiesWithItems	InboxContentByActivityId	Details
18	ListClosedActivities	ReOpenActivity	re-open
19	ActivityStuffMoreWithEmailByUser	LinkEmailToActivity	file
20	ActivityStuffMoreWithEmailByUser	UnlinkEmailFromActivity	unfile
21	ActivityStuffMoreWithEmailByUserDateRange	LinkEmailToActivity	file
22	ActivityStuffMoreWithEmailByUserDateRange	UnlinkEmailFromActivity	unfile
\.


--
-- Data for Name: chained_query_cols_to_params; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.chained_query_cols_to_params (chained_query_id, from_column_name, to_parameter_name) FROM stdin;
1	samples_per_pixel	samples_per_pixel
1	bits_allocated	bits_allocated
1	bits_stored	bits_stored
1	high_bit	high_bit
1	pixel_representation	pixel_representation
1	planar_configuration	planar_configuration
1	photometric_interpretation	photometric_interpretation
2	when_done	day_of_change
2	reason_for	reason_for
2	user_name	user_name
3	subj	patient_id
3	time	import_time_1
3	time	import_time_2
4	series_instance_uid	series_instance_uid
5	series_instance_uid	series_instance_uid
6	pid	pid
7	collection	project_name
7	site	site_name
8	id	id
9	activity_id	activity_id
12	activity_id	activity_id
12	activity_id	activity_id
13	activity_id	activity_id
14	activity_id	activity_id
15	activity_id	activity_id
16	activity_id	activity_id
17	activity_id	activity_id
10	review_status	review_status
10	processing_status	processing_status
10	id	visual_review_instance_id
10	dicom_file_type	dicom_file_type
11	activity_id	activity_id
18	activity_id	activity_id
19	user_inbox_content_id	user_inbox_content_id
20	activity_id	activity_id
20	user_inbox_content_id	user_inbox_content_id
21	activity_id	activity_id
21	user_inbox_content_id	user_inbox_content_id
22	activity_id	activity_id
22	user_inbox_content_id	user_inbox_content_id
\.


--
-- Data for Name: popup_buttons; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.popup_buttons (popup_button_id, name, object_class, btn_col, is_full_table, btn_name) FROM stdin;
2	SopsDupsInDifferentSeriesByCollectionSite	Posda::PopupImageViewer	file_id	f	View
3	SopsDupsInDifferentSeriesByCollectionSite	Posda::PopupCompare	sop_instance_uid	f	Compare
1	%EditResults%	Posda::PopupCompareFilesPath	\N	f	Compare Files
4	DupSopsByCollectionSiteDateRange	Posda::PopupCompare	sop_instance_uid	f	Compare
5	DuplicateFilesBySop	Posda::PopupCompare	sop_instance_uid	f	Compare
6	DuplicateFilesBySop	Posda::PopupCompare	sop_instance_uid	f	Compare
7	DuplicateFilesBySop	Posda::PopupCompare	sop_instance_uid	f	Compare
9	GetSimilarDupContourCounts	Posda::PopupCompare	\N	t	Compare
10	DistinctSeriesByCollection	Posda::ProcessPopup	\N	t	BackgroundPhiScan
11	DistinctSeriesByCollection	Posda::ProcessPopup	\N	t	BackgroundDciodvfySeries
12	DistinctSeriesByCollection	Posda::ProcessPopup	\N	t	DciodvfySeriesReport
13	DistinctStudySeriesByCollection	Posda::ProcessPopup	\N	t	BackgroundApplyPrivateDispositions
14	GetDoses	Posda::ProcessPopup	\N	t	BackgroundDoseLinkageCheck
15	GetPlans	Posda::ProcessPopup	\N	t	BackgroundPlanLinkageCheck
16	GetSsByCollection	Posda::ProcessPopup	\N	t	BackgroundStructLinkageCheck
17	DistinctStudySeriesByCollectionSite	Posda::ProcessPopup	\N	t	BackgroundApplyPrivateDispositions
18	DistinctSeriesByCollectionSite	Posda::ProcessPopup	\N	t	BackgroundPhiScan
19	DistinctSeriesByCollectionSite	Posda::ProcessPopup	\N	t	BackgroundDciodvfySeries
20	DistinctSeriesByCollectionSite	Posda::ProcessPopup	\N	t	DciodvfySeriesReport
21	DistinctSeriesByCollectionSitePublic	Posda::ProcessPopup	\N	t	BackgroundPhiScan
22	%	Quince	series_instance_uid	f	view
8	%	choose	file_id	f	view
73	foo	Posda::TestPopup	id	\N	test
74	VisualReviewStatusById	Posda::TestRedirectPopup	id	\N	review
67	VisualReviewScanInstances	Posda::ProcessPopup	fubar	f	CreateActivityTimepoint
36	ColSiteDetails	Posda::ProcessPopup	\N	t	PhiScan
37	DistinctSeriesByPatient	Posda::ProcessPopup	\N	t	LinkSeries
38	DistinctSeriesByPatient	Posda::ProcessPopup	\N	t	PhiScan
39	DistinctSeriesByPatientAdvanced	Posda::ProcessPopup	\N	t	CheckConsistency
40	DistinctSeriesByPatientAdvanced	Posda::ProcessPopup	\N	t	DicomValidation
41	DistinctSeriesByPatientAdvanced	Posda::ProcessPopup	\N	t	LinkForDownload
42	DistinctSeriesByPatientAdvanced	Posda::ProcessPopup	\N	t	PrivateDispositions
43	PatientDetailsWithBlankCtp	Posda::ProcessPopup	\N	t	InitialAnonymizerCommands
44	PatientDetailsWithNoCtp	Posda::ProcessPopup	\N	t	InitialAnonymizerCommands
45	SummaryOfToFiles	Posda::ProcessPopup	\N	t	LinkSeries
46	SummaryOfToFilesForPatient	Posda::ProcessPopup	\N	t	LinkSeries
63	InboxContentByActivityId	DbIf::ShowSubprocessLines	sub_id	\N	view
47	GetZipUploadEventsByDateRangeNonDicomOnly	Posda::ProcessPopup	\N	t	ProcessRADCOMPUpload
49	GetXlsToConvert	Posda::ProcessPopup	\N	t	XlsConverter
50	GetXlsxToConvert	Posda::ProcessPopup	\N	t	XlsxConverter
48	GetDocxToConvert	Posda::ProcessPopup	\N	t	RadcompSubmissionConverter
51	GeFromToFilesFromNonDicomEditCompare	choose_to	to_file_id	f	view
52	GeFromToFilesFromNonDicomEditCompare	choose_from	from_file_id	f	view
53	AllPatientDetailsWithNoCtpLike	Posda::ProcessPopup	\N	t	InitialAnonymizerCommands
55	DistinctSeriesByCollectionSite	Posda::ProcessPopup	\N	t	VisualReview
56	SeriesWithDupSopsByCollectionSiteNew	Posda::ProcessPopup	\N	t	AnalyzeSeriesDuplicates
57	GetFilesWithNoSeriesInfoByCollection	Posda::ProcessPopup	\N	t	BackgroundProcessModules
58	InboxContentAll	Posda::ProcessPopup	\N	t	FileAndDismissNotifications
59	VisualReviewStatusById	Posda::ProcessPopup	\N	t	MakePassThru
61	VisualReviewStatusById	Posda::ProcessPopup	\N	t	ProcessVisualReview
62	VisualReviewStatusById	Posda::ProcessPopup	\N	t	SendBlankToDest
64	VisualReviewStatusDetails	Posda::ProcessPopup	\N	t	RetryFailedProjections
54	InboxContentByActivityId	choose_spreadsheet	spreadsheet_file_id	\N	view
60	VisualReviewStatusDetails	Posda::ProcessPopup	\N	t	HideEquivalenceClasses
65	VisualReviewStatusDetails	Posda::ProcessPopup	\N	t	ChangeReviewStatus
66	VisualReviewStatusById	Posda::ProcessPopup	\N	t	ApplyDispositions
68	DistinctVisibleSeriesByCollectionSite	Posda::ProcessPopup	\N	t	CreateActivityTimepointFromSeriesList
69	DistinctSeriesByPatientId	Posda::ProcessPopup	\N	t	CreateActivityTimepointFromSeriesList
70	ListSrPublic	DbIf::ShowSr	dicom_file_uri	\N	view
71	ListSrPosda	DbIf::ShowSr	file_path	\N	view
72	ListSrPosdaHidden	DbIf::ShowSr	file_path	\N	view
75	GetEditStatusByDisposition	DbIf::EditStatus	id	f	info
35	AllPatientDetailsWithNoCtp%	Posda::ProcessPopup	\N	t	InitialAnonymizerCommands
\.


--
-- Data for Name: query_tabs; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.query_tabs (query_tab_name, query_tab_description, defines_dropdown, sort_order, defines_search_engine) FROM stdin;
count_check	for checking counts	t	10	f
curation	queries used in curation	t	20	f
scripting	queries used in scripts	t	50	f
db_admin	queries used for db_maintenance	t	30	f
legacy	compatable with old interface	t	90	f
bills_test_queries	Bills testing ground	t	100	f
Consistency	Consistency Checks	t	50	f
DicomValidation	DICOM validation (dciodvfy)	t	40	f
Finalize	Finalize, download, etc	t	60	f
PHI	used for PHI scans etc	t	30	f
Phi	Phi scanning and review operations	t	30	f
UploadedData	Operations on uploaded data	t	10	f
VisualReview	Visual review related operations	t	20	f
initial_upload	used in initial uploads of tar files	t	10	f
Activities	Operartions related to reviewing Acivities	t	60	f
View Structured Reports	View Structured Reports	t	1	f
Status	Collects Status Related Filters	t	60	f
\.


--
-- Data for Name: query_tabs_query_tag_filter; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.query_tabs_query_tag_filter (query_tab_name, filter_name, sort_order) FROM stdin;
count_check	view_posda_backlog	1
count_check	downloads_by_date	2
count_check	counts_patient_status	3
curation	duplicate_sop_evaluation	1
curation	duplicate_sop_resolution	2
curation	linkage_check	3
curation	consistency_check	4
scripting	used_in	1
curation	phi_review	5
curation	dicom_batch_file_editing	6
curation	send_data_via_dicom	6
db_admin	db_stats	10
curation	visual_review_scheduling	7
scripting	for_popups	2
db_admin	db_config	20
curation	dciodvfy	8
bills_test_queries	under_development	1
legacy	.Unlimited	1
legacy	.Show No Tags	1
legacy	universal	3
bills_test_queries	old_queries	10
bills_test_queries	linkage	3
scripting	for_public_posda_compare	3
bills_test_queries	posda_db_populate	4
bills_test_queries	copy_from_public	5
bills_test_queries	comparing_public_to_posda	6
db_admin	postgres_stats	30
bills_test_queries	for_ct_evaluation	50
bills_test_queries	subprocess	60
bills_test_queries	non_dicom_editing	70
bills_test_queries	database_fixup	80
UploadedData	with_ctp_anonymization	10
UploadedData	without_ctp_anonymization	20
bills_test_queries	bills_ad_hoc_scripts	90
VisualReview	select_for_visual_review	20
VisualReview	visual_review_status	30
VisualReview	visual_review_reports	40
bills_test_queries	activities	100
bills_test_queries	activity_based	200
Activities	activities	1
bills_test_queries	trace_edits	300
Phi	PhiStatus	1
Activities	activity_timepoints	2
View Structured Reports	View Structured Reports	1
scripting	dicom_file_table	4
Activities	activity_based	3
Status	edit_status	10
Status	visual_review_status	5
Status	phi_status	7
\.


--
-- Data for Name: query_tag_filter; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.query_tag_filter (filter_name, tags_enabled) FROM stdin;
.Show No Tags	{}
.Unlimited	{}
for_popups	{universal,used_in_process_popup}
view_posda_backlog	{backlog_analysis_reporting_tools,backlog_round_history,backlog_status,universal}
review_roles	{universal,roles}
visual_review_tracking_processing	{visual_review_results,universal}
send_data_via_dicom	{universal,search_series,send_series,send_directory}
manage_posda_backlog	{universal,backlog_status,backlog}
db_config	{query_tags,query_tabs,popups}
counts_patient_status	{universal,count_queries,patient_status,adding_ctp}
dciodvfy	{dciodvfy,universal}
duplicate_sop_evaluation	{universal,dup_sops,sops_different_series,series_report}
dicom_batch_file_editing	{hash_unhashed,hide_files,apply_disposition,universal,edit_files,show_hidden}
monthly_report_queries	{universal,end_of_month}
for_ct_evaluation	{ct_image_consistency}
database_fixup	{dicom_file_type,reimport_queries}
linkage_check	{universal,plan_linkages,dose_linkages,struct_linkages,dose_linkages}
used_in	{universal,used_in_simple_phi,used_in_file_import_into_posda,used_in_import_edited_files,used_in_reconcile_tag_names,used_processing_structure_set_linkages,used_in_phi_maint,used_in_background_processing,used_in_dciodvfy,used_in_file_migration,used_in_linkage_check}
visual_review_scheduling	{universal,visual_review,visual_review_new_workflow}
for_public_posda_compare	{public_posda_counts}
linkage	{used_in_dose_linkage_check,used_in_plan_linkage_check,used_in_structure_linkage_check,old_linkage_checks,used_in_struct_linkage_check}
subprocess	{subprocess}
consistency_check	{series_consistency,study_consistency,universal,public_posda_consistency}
old_queries	{for_bill,for_bill_counts,for_bill_study_consistency,for_bill_series_consistency,old_visibility}
posda_db_populate	{posda_db_populate}
copy_from_public	{copy_from_public}
comparing_public_to_posda	{comparing_posda_to_public}
db_stats	{q_stats,q_stats_by_date,q_list,queries,query_tags,universal,schema}
phi_review	{universal,phi_schedule,simple_phi,phi_maint,meta_q_queries,scan_status}
duplicate_sop_resolution	{universal,dup_sops,hide_dup_sops,distinguished_digest}
phi_status	{phi_status}
select_for_phi	{select_for_phi}
series_for_phi	{series_selection}
phi_reports	{phi_reports}
find_patients	{find_patients,mapping_tables,for_scripting}
download_results	{patient_queries}
visual_review_status	{visual_review_status,visual_review_new_workflow}
trace_edits	{trace_edits}
non_dicom_editing	{non_dicom_edit,non_dicom_phi,non_dicom_phi_status,non_dicom_import,non_dicom_reject,radcomp}
bills_ad_hoc_scripts	{bills_ad_hoc_scripts}
select_for_visual_review	{visual_review_selection}
visual_review_reports	{visual_review_reports}
with_ctp_anonymization	{ctp_patients,ctp_col_site,ctp_details,check_edits,hide,check_dups}
PhiStatus	{scan_status}
activities	{activities,activity_support}
without_ctp_anonymization	{no_ctp_patients,no_ctp_details,patient_mapping,insert_pat_mapping,import_event}
View Structured Reports	{view_structured_reports}
under_development	{universal,hide_events,bills_test,for_tracy,radcomp,non_dicom_phi,non_dicom_phi_status,non_dicom_edit,testing_edit_objects}
dicom_file_table	{adding_pixels_to_dicom_file}
downloads_by_date	{downloads_by_date,import_events,universal}
edit_status	{edit_status}
activity_timepoints	{activity_timepoints,activity_timepoint_support,compare_series,clin_qual,manifests}
activity_based	{"ACRIN-FMISO-Brain Duplicate Elimination","Curation of Lung-Fused-CT-Pathology","CPTAC Bolus September 2018","ACRIN-NSCLC-FDG-PET Curation",Exceptional-Responders_NCI_Oct2018_curation,"Test Case based on Soft-tissue-Sarcoma",QIN-GBM-DSC-MRI-DRO/Barrow,"Reconcile Public and Posda for CPTAC"}
postgres_stats	{database_size,table_size,postgres_query_stats,invoking_user}
\.


--
-- Data for Name: role; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.role (role_name) FROM stdin;
legacy_bbennett
legacy_ksmith01
legacy_priorf
legacy_rddobbins
legacy_smberryman
legacy_tracyn
workflow_1
curator
developer
SrViewer
\.


--
-- Data for Name: role_tabs; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.role_tabs (role_name, query_tab_name, sort_order) FROM stdin;
legacy_bbennett	UploadedData	10
legacy_bbennett	bills_test_queries	20
legacy_bbennett	count_check	30
legacy_bbennett	curation	40
legacy_bbennett	db_admin	50
legacy_bbennett	legacy	60
legacy_bbennett	scripting	70
legacy_ksmith01	bills_test_queries	10
legacy_ksmith01	count_check	20
legacy_ksmith01	curation	30
legacy_ksmith01	db_admin	40
legacy_ksmith01	legacy	50
legacy_ksmith01	scripting	60
legacy_priorf	count_check	10
legacy_priorf	curation	20
legacy_priorf	legacy	30
legacy_priorf	scripting	40
legacy_rddobbins	count_check	10
legacy_rddobbins	curation	20
legacy_rddobbins	db_admin	30
legacy_rddobbins	legacy	40
legacy_rddobbins	scripting	50
legacy_smberryman	curation	10
legacy_smberryman	legacy	20
legacy_tracyn	bills_test_queries	10
legacy_tracyn	count_check	20
legacy_tracyn	curation	30
legacy_tracyn	legacy	40
legacy_tracyn	scripting	50
curator	UploadedData	10
curator	VisualReview	20
curator	Phi	30
developer	bills_test_queries	20
developer	count_check	30
developer	curation	40
developer	db_admin	50
developer	legacy	60
developer	scripting	70
curator	Activities	40
SrViewer	View Structured Reports	1
curator	Status	30
\.


--
-- Data for Name: spreadsheet_operation; Type: TABLE DATA; Schema: dbif_config; Owner: -
--

COPY dbif_config.spreadsheet_operation (operation_name, command_line, operation_type, input_line_format, tags) FROM stdin;
CompareDuplicateSops	CompareDupSopList.pl	legacy	<sop_instance_uid>	{dup_sops}
ScanPhi	PhiScan.pl <type> "<description>"	legacy	<series_instance_uid>, <signature>	{phi_review}
LinkDirectory	MakeLinkedDirectory.pl <target_dir>	legacy	<path>, <sop_instance_uid>	{send_series}
AddInitialStatus	PopulatePatStat.pl	legacy	<patient_id>, <status>	{patient_status}
ChangePatientStatus	UpdatePatStat.pl <who> "<why>"	legacy	<patient_id>, <old_status>, <new_status>	{patient_status}
SendSeriesToDestination	SendSetOfSeriesToDestination.pl <host> <port> <called> <calling> <user> "<reason>"	legacy	<series_instance_uid>	{send_series}
SeriesConsistency	CheckSeriesConsistency.pl <series_instance_uid>	legacy	\N	\N
StudyConsistency	CheckStudyConsistency.pl <study_instance_uid>	legacy	\N	\N
PatConsistency	CheckPatConsistency.pl "<collection>" <patient_id>	legacy	\N	\N
OnlyIn	OnlyIn.pl Posda Intake	legacy	<SeriesInPosda>, <SeriesInIntake>	\N
TestCommand	TestCommand.pl <host> <port> <called> <calling> <series_instance_uid>	legacy	\N	\N
PipeCommand1	PipeCommand1.pl <var1> <var2> 1 2 3	legacy	<vals1>,<vals2>,<vals3>	\N
SymLinkToIntake	SymLinkToIntake.pl /cache/bbennett/Symlinks	legacy	<PID>, <Modality>, <SopInstance>, <FilePath>	\N
UpdateKnowlegeBase	UpdateKnowledgeBase.pl <who> "<why>"	legacy	<Tag>^<VR>^<Disposition>^<NameChain>	\N
LinkFileHierarchy	LinkFileHierarchy.pl <Destination>	legacy	<patient_id>  <study_instance_uid> <series_instance_uid>	\N
CreatePublicDispositionTable	CreatePublicDispositionTable.pl <sop_class_uid> "<Description>" <who>	legacy	<Tag>^<VR>^<Disposition>^<NameChain>	\N
UpdateCollectionPrio	UpdateBacklogPriorities.pl	legacy	<collection>&<priority>	{backlog_status}
ApplyPublicPrivateDisposition	CsvApplyPublicAndPrivateDisposition.pl <dest_dir> <uid_root> <offset> <low_date> <high_date> <sop_class_uid> "<name>"	legacy	<patient_id>&<study_instance_uid>&<series_instance_uid>	\N
ApplyPrivateDispositionIntake	CsvApplyPrivateDispositionIntake.pl <dest_dir> <uid_root> <offset> <low_date> <high_date>	legacy	<patient_id>&<study_instance_uid>&<series_instance_uid>	\N
ExtractZ	ExtractZ.pl	legacy	<file_id>&<unique_pixel_data_id>&<ipp>	\N
AddPublicHierarchy	AddHierarchyToSpreadsheetByPublicSop.pl <new_root>	legacy	<file>&<Element>&<OldValue>&<NewValue>	\N
ApplyHnsccEdits	ApplyHnsccEdits.pl	legacy	<new_file>&<element>&<new_value>	\N
CompareIntakeFilesToPublicFiles	CompareIntakeFilesToPublicFiles.pl <report_file> <notify>	legacy	<sop_instance_uid> <file_in_intake> <file_in_public>	{compare_collection_site}
CompareDuplicateSopFirstInSeries	CompareDupSopSeriesList.pl	legacy	<series_instance_uid>	{dup_sops}
BackgroundCompareDupSops	BackgroundCompareDupSopList.pl <file_name> "<notify>"	legacy	<sop_instance_uid>&<file_id>&<path>&<first_loaded>	{dup_sops}
BackgroundCompareDuplicateSopFirstInSeries	BackgroundCompareDupSopSeriesList.pl <file_name> "<notify>"	legacy	<series_instance_uid>	{dup_sops}
TdrAndPhiReports	PrepareTdrAndPhiReport.pl	legacy	<id>&<TdrReportFile>&<PhiReportFile>&<notify>	{phi_review}
EquivalenceClasses	BatchCreateSeriesEquivalenceClasses.pl <notify>	legacy	<series_instance_uid>	{visual_review}
BackgroundCompareSopsInMultipleSeries	BackgroundCompareSopsInMultipleSeries.pl <file_name> "<notify>"	legacy	<series_instance_uid>&<sop_instance_uid>&<file_id>&<file_path>	{sops_different_series}
BulkHashStructUids	BulkHashStructUids.pl <dir> <uid_root> <notify>	legacy	<sop_instance_uid>	{hash_unhashed}
BulkHashDoseLinks	BulkHashDoseLinks.pl <dir> <uid_root> <notify>	legacy	<sop_instance_uid>	{hash_unhashed}
ScanDirPhi	PhiDirScan.pl <dir> "<description>"	legacy		{phi_review}
UpdatePrivateDispositions	UpdatePrivateDisposition.pl <who> "<why>"	legacy	<element_signature>&<vr>&<disposition>	{phi_maint}
SimplePhiScan	PhiSimpleScan.pl "<description>" <file_query_name> <notify>	legacy	<series_instance_uid>	{simple_phi}
MakeWeeklyFilesReport	MakeWeeklyLoadReport.pl <?bkgrnd_id?> <notify> <from> <to>	background_process	\N	{downloads_by_date}
BackgroundDciodvfySeries	BackgroundDciodvfySeries.pl <?bkgrnd_id?> "<description>" <type> <notify>	background_process	<series_instance_uid>	{dciodvfy}
UpdateSimplePrivateDisposition	UpdateSimplePrivateDisposition.pl <who> "<why>"	legacy	<id>&<disp>	{phi_maint}
HideSeriesWithStatus	HideBatchSeriesWithStatus.pl <who> "<why>"	legacy	<series_instance_uid>	{hide_files,hide_dup_sops}
HideEarlyDupSopsInSeries	HideBatchEarlySopDupsInSeries.pl <who> "<why>"	legacy	<series_instance_uid>	{hide_files,hide_dup_sops}
BackgroundPhiScan	PhiBackgroundScan.pl <?bkgrnd_id?> "<description>" <file_query_name> <notify>	background_process	<series_instance_uid>	{background,simple_phi}
BackgroundCompareFromTo	BackgroundCompareFromToFiles.pl <?bkgrnd_id?> <notify>	background_process	<sop_instance_uid>&<from_file>&<to_file>	{dup_sops,edit_files}
FindSeriesInScanWithPhi	FindSeriesInScanWithPhi.pl <?bkgrnd_id?> <scan_id> <notify>	background_process	<element>&<vr>&<value>&<description>	{simple_phi}
ApplyPrivateDisposition	CsvApplyPrivateDisposition.pl <dest_dir> <uid_root> <offset> <low_date> <high_date>	legacy	<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series,apply_disposition}
MakeSelectedTagValueReport	MakeSelectedTagValueReport.pl /cache/UserData/DbIf/PreparedReports/<report_file_name> <notify>	legacy	<element_signature>&<vr>&<disposition>&<name_chain>&<num_phi_values>&<num_simple_phi_values>	{phi_maint}
MakeEditProposal	MakeEditProposal.pl <?bkgrnd_id?> <scan_id> <notify>	background_process	<element>&<vr>&<value>&<description>	{simple_phi}
BatchEditBySop	BatchEditDicomFile.pl <?bkgrnd_id?> /nas/public/posda/edited/<rel_dest_root> <who> "<edit_description>" <notify>	background_process	<command>&<arg1>&<arg2>&<arg3>&<arg4>	{edit_files}
HideFilesWithStatus	HideFilesWithStatus.pl <who> "<why>"	legacy	<file_id>&<old_visibility>	{hide_files,hide_dup_sops}
UnHideFilesWithStatus	UnHideFilesWithStatus.pl <who> "<why>"	legacy	<file_id>&<old_visibility>	{hide_files,hide_dup_sops}
SplitPdxPilot	GeneratePdxEdits.pl <?bkgrnd_id?> <rel_dest_root> <notify>	background_process	<patient_id>&<new_patient_id>&<new_study_desc>&<new_series_desc>	{bills_test}
CheckCounts1	CompareCounts1.pl <?bkgrnd_id?> "<collection>" <uid_root> "<site>" "<notify>"	background_process	<id>&<study_instance_uid>&<series_instance_uid>&<num_files>	{bills_test}
BackgroundDoseLinkageCheck	BackgroundDoseLinkageCheck.pl <?bkgrnd_id?> <notify_email>	background_process	<file_id>&<collection>&<site>&<patient_id>&<series_instance_uid>	{background}
DciodvfySeriesReport	BackgroundDciodvfySeriesReport.pl <?bkgrnd_id?> "<description>" <scan_id> /cache/UserData/DbIf/PreparedReports/<report_file_name> <notify>	background_process	<series_instance_uid>	{dciodvfy}
CopyBySeriesToScratch	CopyBySeriesToScratch.pl <to_dir> <notify>	legacy	<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series,apply_disposition}
BackgroundPlanLinkageCheck	BackgroundPlanLinkageCheck.pl <?bkgrnd_id?> <notify_email>	background_process	<file_id>&<collection>&<site>&<patient_id>&<series_instance_uid>	{background}
CompareSpreadsheetToPosda	compare_spreadsheet_to_posda.py <?bkgrnd_id?> "<collection>" "<site>" "<notify>"	background_process	<filename>,<collection>,<site>,<patient>,<series>,<sop>,<md5sum>,<size>	{background}
SendPublicSeriesToDestination	SendPublicSetOfSeriesToDestination.pl <host> <port> <called> <calling>	legacy	<series_instance_uid>	{send_series}
CompareSpreadsheetToIntake	compare_spreadsheet_to_intake.py <?bkgrnd_id?> "<collection>" "<site>" "<notify>"	background_process	<filename>,<collection>,<site>,<patient>,<series>,<sop>,<md5sum>,<size>	{background}
BatchEditBySop2	BatchEditDicomFile2.pl <?bkgrnd_id?> /cache/UserData/DbIf/PreparedReports/<report_file> /nas/public/posda/edited/<rel_dest_root> <who> "<edit_description>" <notify>	background_process	<command>&<arg1>&<arg2>&<arg3>&<arg4>	{edit_files}
BackgroundStructLinkageCheck	BackgroundStructLinkageCheck.pl <?bkgrnd_id?> <notify_email>	background_process	<file_id>&<collection>&<site>&<patient_id>&<series_instance_uid>	{background}
BackgroundApplyPrivateDispositions	BackgroundApplyPrivateDispositions.pl <?bkgrnd_id?> <to_dir> <uid_root> <offset> <notify>	background_process	<patient_id>&<study_uid>&<series_uid>	{edit,send_series}
SumPatients	SumPatients.pl <?bkgrnd_id?> "/cache/UserData/DbIf/PreparedReports/<report_file>" <notify>	background_process	<id>&<study>&<series>&<num_files>	{bills_test}
BackgroundUpdatePrivatedDispositonVr	BackgroundUpdatePrivateDispositionsVr.pl <?bkgrnd_id?> "<why>" <notify>	background_process	<element_sig_pattern>&<vr>&<disp>	{phi_maint}
TestNewDicomCompare	TestNewDicomCompare.pl <?bkgrnd_id?> <edit_file_id> <notify>	background_process	<sop_instance_uid>&<from_file>&<to_file>	{bills_test}
CheckCounts	CompareCounts.pl <?bkgrnd_id?> "<collection>" "<site>" <notify>	background_process	<id>&<study>&<series>&<num_files>	{bills_test}
ImportEditedFiles	ImportEditedFiles.pl <?bkgrnd_id?> <report_file_id> "/cache/UserData/DbIf/PreparedReports/<import_report>" "<edit_comment>" <notify>	background_process	<sop_instance_uid>&<from_digest>&<to_file>&<to_digest>&<status>	{edit_files}
CheckCounts2	CompareCounts2.pl  <?bkgrnd_id?> "<collection>" <uid_root> "<site>" "<notify>"	background_process	<id>&<study_instance_uid>&<series_instance_uid>&<num_files>	{bills_test}
FixAcrinFiles	CsvFixAcrin.pl <?bkgrnd_id?> <to_dir> <uid_root> <low_date> <high_date> <notify>	background_process	<patient_id>&<study_uid>&<series_uid>&<offset_pat_id>&<offset>	{bills_test}
CheckPublicMissingFilesInSeriesByCollection	CheckPublicMissingFilesInSeriesByCollection.pl <?bkgrnd_id?> "<collection>" <notify>	background_process	\N	{bills_test}
AnnotateCountsSpreadsheet	AnnotateCountsSpreadsheet.pl <?bkgrnd_id?> "<notify>"	background_process	<PID>|<ImageType>|<Modality>|<Images>|<StudyDate>|<StudyDescription>|<SeriesDescription>|<SeriesNumber>|<StudyInstanceUID>|<SeriesInstanceUID>|<Mfr>|<Model>|<software_versions>	{bills_test}
ImportFromDicomFileEdit	ImportEditedFilesFromDicomEditCompare.pl <?bkgrnd_id?> <sub_invoc_id> <files_per_round> <max_queue_size> <notify>	background_process	\N	{edit_files}
MakePatHierachy	GetHierarchyFromSeries.pl <?bkgrnd_id?> <notify>	background_process	<series_instance_uid>	{bills_test}
CopyCollectionToStaging	CopyCollectionToStaging.pl <?bkgrnd_id?> <collection> "/nas/public/posda/scratch/staging/<rel_dir>" <notify>	background_process	\N	{bills_test}
CheckStructLinkagesByCollectionSite	CheckStructLinkages.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	\N	{struct_linkages}
CheckPosdaPublicConsistency	PublicPosdaCompare.pl <?bkgrnd_id?> <collection>  <notify>	background_process	\N	{public_posda_consistency}
NewFixAcrinFiles	CsvNewFixAcrin.pl <?bkgrnd_id?> <to_dir> <uid_root> <low_date> <high_date> <notify>	background_process	<patient_id>&<study_uid>&<series_uid>&<sop_instance_uid>&<file_id>&<offset_pat_id>&<offset>	{bills_test}
BackOutEdit	BackOutFromDicomEditCompare.pl <?bkgrnd_id?> <sub_invoc_id> <user> <notify>	background_process	\N	{edit_files}
PrepareAcrinEdits	PrepareAcrinEdits.pl <?bkgrnd_id?> <notify>	background_process	<ele_pattern>&<value>&<series_instance_uid>	{bills_test}
PhiPublicScan	PhiPublicScan.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	\N	{simple_phi}
QuickCheckPosdaPublicConsistency	QuickPublicPosdaCompare.pl <?bkgrnd_id?> "<collection>"  <notify>	background_process	\N	{public_posda_consistency}
BackgroundEditBySop	BackgroundEditDicomFile.pl  <?bkgrnd_id?> /nas/public/posda/edited/<rel_dest_root> <who> "<edit_description>" <notify>	background_process	 <command>&<arg1>&<arg2>&<arg3>&<arg4>	{obsolete}
NewerFixAcrinFiles	CsvNewerFixAcrin.pl <?bkgrnd_id?> <to_dir> <uid_root> <low_date> <high_date> <notify>	background_process	<patient_id>&<study_uid>&<series_uid>&<offset_pat_id>&<offset>	{bills_test}
CountFilesInSeries	TotalFilesForSelectedSeries.pl <?bkgrnd_id?> <notify>	background_process	<series_instance_uid>	{bills_test}
FixCtpFileRow	FixCtpFileRow.pl <?bkgrnd_id?> <notify>	background_process	<file_id>&<file_path>	{bills_test}
BackgroundDoProposedEdits	BackgroundDoProposedEdits.pl <?bkgrnd_id?> /nas/public/posda/edited/<rel_dest_root> "<description>" <notify>	background_process	<unmapped_id>&<mapped_id>&<series_instance_uid>&<num_files>&<operations>&<tag>&<val1>&<val2>	{edit_files}
SetUpPublicToPosdaCopy	SetUpPublicToPosdaCopy.pl <?bkgrnd_id?> <collection> <notify> "<why_done>"	background_process	\N	{pubic_posda_consistency}
StartPublicToPosdaCopy	BackgroundPublicToPosdaCopy.pl <?bkgrnd_id?> <copy_id> "<why>" <notify>	background_process	\N	{pubic_posda_consistency}
MakeHierarcyBySeries	GetSeriesHierarchyBySeries.pl <?bkgrnd_id?> <notify>	background_process	<series_instance_uid>	{bills_test}
UnHideSeriesWithStatus	UnhideBatchSeriesWithStatus.pl <who> "<why>"	legacy	<series_instance_uid>	{hide_files}
DciodvfyReport	BackgroundDciodvfyReport.pl <?bkgrnd_id?> <scan_id> <notify>	background_process	\N	{dciodvfy}
StartFixPublicToPosdaCopy	BackgroundFixPublicToPosdaCopy.pl <?bkgrnd_id?> <copy_id> "<why>", <notify>	background_process	\N	{public_posda_consistency}
LookForDupSopsInPublicByCollectionSite	LookForPublicDupSops.pl <?bkgrnd_id?> "<collection>" "<site>" <notify>	background_process	\N	{comparing_posda_to_public}
BuildUidMap	BuildUidMap.pl <?bkgrnd_id?> <notify>	background_process	<unmapped_uid>	{bills_test}
BackgroundLinkSeriesToStaging	BackgroundLinkSeriesToStaging.pl <?bkgrnd_id?> /nas/public/posda/scratch/staging/<to_rel_dir> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series}
AnonymizerToEditor	AnonymizerToEditor.pl <?bkgrnd_id?> <notify>	background_process	<operation_scope>&<operation>&<tag>&<value1>&<value2>&<patient_id>&<study_instance_uid>&<series_instance_uid>&<unmapped_uid>&<mapped_uid>	{bills_test}
DeletePvtExceptCtp	DeletePrivateFromCollection.pl <?bkgrnd_id?> <collection> /nas/public/posda/scratch/converted/<rel_to_dir> <notify>	background_process	\N	{bills_test}
HidePatientWithStatus	HideBatchPatientWithStatus.pl <who> "<why>"	legacy	<patient_id>	{hide_files,hide_dup_sops}
MakeRtReport	MakeRtReport.pl <?bkgrnd_id?> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>&<modality>&<num_files>	{bills_test}
BackgroundOnlyEditDicomSeries	BackgroundOnlyEditDicomSeries.pl <?bkgrnd_id?> "/nas/public/posda/scratch/staging/<rel_dest_root>" "<desciption>" <notify>	background_process	<unmapped_uid>&<mapped_uid>&<series_instance_uid>&<operation>&<tag>&<val1>&<val2>	{bills_test}
BackgroundCopySeriesToStaging	BackgroundCopySeriesToStaging.pl <?bkgrnd_id?> /nas/public/posda/scratch/staging/<to_rel_dir> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series}
CheckCollectionAgainstPatientId	CheckCollectionAgainstPatientId.pl <?bkgrnd_id?> <notify>	background_process	<collection>&<patient_id>	{bills_test}
BackgroundLinkPublicSeries	BackgroundLinkPublicSeries.pl <?bkgrnd_id?> /nas/public/posda/scratch/staging/<to_rel_dir> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series}
BackgroundPrivateDispositionsTp	BackgroundPrivateDispositionsTp.pl <?bkgrnd_id?> <activity_id> <uid_root> <offset> <notify>	background_process	\N	{activity_timepoints}
CheckRtReferenceChain	CheckRtReferenceChain.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	\N	{struct_linkages}
MakeRtReport1	MakeRtReport1.pl <?bkgrnd_id?> <notify>	background_process	<collection>&<site>&<patient_id>&<study_uid>&<series_uid>&<file_type>&<modality>&<num_files>	{bills_test}
FirstPassPhiScanAndReport	FirstPassPhiScanAndReport.pl <?bkgrnd_id?> <collection> <site> "<batch_no>" <notify>	background_process	\N	{bills_test}
FirstPassPhiByCollection	FirstPassPhiByCollection.pl <?bkgrnd_id?> <collection> <notify>	background_process	\N	{bills_test}
FullPhiById	FullPhiById.pl <?bkgrnd_id?> <scan_id> <notify> <max_rows>\n	background_process	\N	{bills_test}
BackgroundCreateEquivalenceClasses	BackgroundCreateSeriesEquivalenceClasses.pl <?bkgrnd_id?> "<why>" <notify>	background_process	<series_instance_uid>	{visual_review}
BackgroundEdit	BackgroundEditor.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<series_instance_uid>&<op>&<tag>&<val1>&<val2>	{activity_timepoints}
AdHocReportForTracy	MakeCptacReport.pl <?bkgrnd_id?> <notify>	background_process	\N	{clin_qual}
RepealEdits	RepealEdits.pl <?bkgrnd_id?> <subprocess_invoc_id> <notify>	background_process	\N	{find_patients}
RejectEdits	RejectEdits.pl <?bkgrnd_id?> <subprocess_invoc_id> <notify>	background_process	\N	{find_patients}
ImportEdits	ImportEdits.pl <?bkgrnd_id?> <subprocess_invoc_id> <notify>	background_process	\N	{find_patients}
LinkSeries	BackgroundLinkSeries.pl <?bkgrnd_id?> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{patient_queries}
VisualReview	ScheduleVisualReview.pl <?bkgrnd_id?> "<why>" <notify>	background_process	<series_instance_uid>	{visual_review}
MakeHierarchyBySeries	GetSeriesHierarchyBySeriesWithFileTypeAndModality.pl <?bkgrnd_id?> <notify>	background_process	<series_jnstance_uid>	{bills_test,activity_timepoints}
PhiScan	NewPhiScan.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<series_instance_uid>	{scan_status,phi_status,new_phi}
InsertPatientMapping	ProcessCollectionSiteWorksheet.pl <?bkgrnd_id?>	background_process	<site_code>&<collection_code>&<site_id>&<site_name>&<collection_name>	{bills_test,mapping_tables,patient_mapping}
ProcessRADCOMPUpload	CategorizeRadcompFiles.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	<import_event_id>	{radcomp}
RadcompSubmissionConverter	RadcompSubmissionConverter.pl <?bkgrnd_id?> <notify>	background_process	<file_id>	{radcomp}
XlsConverter	XlsConverter.pl <?bkgrnd_id?> <notify>	background_process	<file_id>	{radcomp}
NewFirstPassPhi	NewFirstPassPhiScan.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<series_instance_uid>	{bills_test,new_workflow}
XlsxConverter	XlsxConverter.pl <?bkgrnd_id?> <notify>	background_process	<file_id>	{radcomp}
NonDicomPhiScan	NonDicomPhiScan.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	\N	{non_dicom_phi}
ProposeCsvEdits	ProposeCsvEdits.pl <?bkgrnd_id?> <scan_id> "<description>" <notify>	background_process	<type>&<path>&<q_value>&<num_files>&<p_op>&<q_arg1>&<q_arg2>&<q_arg3>	{non_dicom_edit}
ProposeJsonEdits	ProposeJsonEdits.pl <?bkgrnd_id?> <scan_id> "<description>" <notify>	background_process	<type>&<path>&<q_value>&<num_files>&<p_op>&<q_arg1>&<q_arg2>&<q_arg3>	{non_dicom_edit}
BackgroundCsvEdit	BackgroundCsvEditor.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<file_id>&<op>&<path>&<val1>&<val2>&<val3>	{edit,non_dicom_edit}
BackgroundJsonEdit	BackgroundJsonEditor.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<file_id>&<op>&<path>&<val1>&<val2>&<val3>	{edit,non_dicom_edit}
NewPhiScanAll	NewPhiScanAll.pl <?bkgrnd_id?> "<description>" <db> <max_lines> <notify>	background_process	<series_uid>	{bills_test,new_workflow}
FileAndDismissNotifications	FileAndDismissNotification.pl <?bkgrnd_id?> <activity_id> "<description>" <notify>	background_process	<id>	{activity_support}
ImportNonDicomEdits	ImportNonDicomEditedFiles.pl <?bkgrnd_id?> <subprocess_invoc_id> <notify>	background_process	\N	{non_dicom_edit}
GenerateYearOfDiagnosisEdits	GenerateEditsForYearsOfDiagnosis.pl <?bkgrnd_id?> <notify>	background_process	<patient_id>&<year>	{bills_ad_hoc_scripts}
RadcompPrivateDisp	BackgroundPrivateDispositionsByPatShift.pl <?bkgrnd_id?> <to_dir> <uid_root> <notify>	background_process	<patient_id>&<study_uid>&<series_uid>&<offset>	{bills_test}
MakeHierarchyByPat	GetHierarchyFromPatientId.pl <?bkgrnd_id?> <notify>	background_process	<patient_id>	{bills_test}
QuickCheckPublicPosdaConsistLike	QuickPublicPosdaCompareLikeCollection.pl <?bkgrnd_id?> "<collection_pat>"  <notify>	background_process	\N	{public_posda_consistency}
ProposeAdHocMelanomaEdits	ProposeAdHocMelanomaEdits.pl <?bkgrnd_id?> <shift> <old_uid_root> <new_uid_root> <notify>	background_process	<patient_id>&<series_uid>&<study_date>&<num_files>&<pat_id_for_diag_date>&<diag_date>	{bills_test,bills_ad_hoc_scripts}
BackgroundPrivateDispositionsTpBaseline	BackgroundPrivateDispositionsTpBaseline.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{activity_timepoints}
HideLateDupSopsInSeries	HideBatchLateSopDupsInSeries.pl <who> "<why>"	legacy	<series_instance_uid>	{hide_files,hide_dup_sops}
BackgroundProcessModules	BackgroundProcessModules.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<file_id>	{dicom_file_type}
HideEquivalenceClasses	HideEquivalenceClasses.pl <?bkgrnd_id?> <notify>	background_process	<image_equivalence_class_id>&<processing_status>&<review_status>	{visual_review_status}
CreateActivityTimepointFromCollectionSite	CreateActivityTimepointFromCollectionSite.pl <?bkgrnd_id?> <collection> <site> <activity_id> "<comment>" <notify>	background_process	\N	{timepoint_buttons}
MakePassThru	MakePassThru.pl <?bkgrnd_id?> <visual_review_id> <notify>	background_process	<processing_status>&<review_status>&<dicom_file_type>	{visual_review_status}
RetryFailedProjections	RetryFailedProjections.pl <?bkgrnd_id?> <notify>	background_process	<image_equivalence_class_id>&<processing_status>&<review_status>	{visual_review_status}
ChangeReviewStatus	ChangeReviewStatus.pl <?bkgrnd_id?> <review_status> <processing_status> <notify>	background_process	<image_equivalence_class_id>&<processing_status>&<review_status>	{visual_review_status}
ApplyDispositions	BackgroundApplyDispositionsFromVisualScan.pl <?bkgrnd_id?> <dest_dir> <uid_root> <date_offset> <notify>	background_process	<id>&<processing_status>&<review_status>&<dicom_file_type>	{visual_review_status}
CreateActivityTimepoint	CreateActivityTimepoint.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	\N	{visual_review_status}
ProcessVisualReview	ProcessVisualReview.pl <?bkgrnd_id?> <scan_id> <notify>	background_process	\N	{visual_review_new_workflow}
BackgroundHideFiles	BackgroundHideFilesWithStatus.pl <?bkgrnd_id?> <notify> "<reason>"	background_process	<file_id>	{compare_series}
CreateActivityTimepointFromSeriesList	CreateActivityTimepointFromSeriesList.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	<series_instance_uid>	{activity_timepoints}
LinkPublicCollection	LinkPublicCollection.pl <?bkgrnd_id?> <directory> <notify>	background_process	<collection>&<patient_id>&<series_instance_uid>&<dicom_file_uri>	{activity_timepoints,send_series,bills_test}
ListOfAnnotatedFiles	InsertListOfAnnotatedFiles.pl <?bkgrnd_id?> "<comment>" <notify>	background_process	<file_id>&<file_name>&<mime_type>&<description>	{activity_timepoints,send_series_via_dicom,bills_test}
FixBadSopInstanceLungFusedCtPathology	FixBadSopInstancesLungFusedCtPathology.pl <?bkgrnd_id?> <notify>	background_process	\N	{"Curation of Lung-Fused-CT-Pathology"}
BackgroundPrivateDispositions	BackgroundPrivateDispositions.pl <?bkgrnd_id?> <to_dir> <uid_root> <offset> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{edit,send_series}
BackgroundPrivateDispositionsBaseline	BackgroundPrivateDispositionsBaseline.pl <?bkgrnd_id?> <to_dir> <notify>	background_process	<patient_id>&<study_instance_uid>&<series_instance_uid>	{edit,send_series}
MakeDownloadableDirectory	MakeDownloadableDirectory.pl <?bkgrnd_id?> <sub_dir> <notify>	background_process	<collection>&<patient_id>&<study_instance_uid>&<series_instance_uid>	{send_series}
BackgroundHideSeries	BackgroundHideSeriesWithIndividualStatus.pl <?bkgrnd_id?> <notify>	background_process	<series_uid>&<reason_to_hide>	{bills_test,new_workflow,activity_support}
AnalyzeSeriesDuplicatesForTimepoint	AnalyzeTpSeriesDuplicates.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{activity_timepoint_support}
VisualReviewFromTimepoint	ScheduleVisualReviewFromActivityTimepoint.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{visual_review}
PhiReviewFromTimepoint	SchedulePhiReviewFromActivityTimepoint.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{visual_review}
CompareSopsTpPosdaPublic	CompareSopsTpPosdaPublic.pl <?bkgrnd_id?> "<collection>" <activity_id> <notify>	background_process	\N	{activity_timepoint_support}
BackgroundHideEarlyDupSops	BackgroundHideEarlyDupSopsInSeries.pl <?bkgrnd_id?> <notify> "<reason>"	background_process	<series_instance_uid>	{activity_timepoint_support}
AdHocTestSetConversion	AdHocSecondaryCaptureConverter.pl <?bkgrnd_id?> <notify> <source_dir> <dest_dir>	background_process	<pat_code>&<anon_pat_id>&<uid_root>&<pat_sex>	{"Bills Test"}
BackgroundUpdatePrivateDispositionEle	BackgroundUpdatePrivateDispositionsEle.pl <?bkgrnd_id?> "<why>" <notify>	background_process	<element_sig_pattern>&<disp>	{phi_maint}
DispositionNeededWorksheet	DispositionsNeededWorksheet.pl <?bkgrnd_id?> <notify>	background_process	\N	{phi_maint}
AnalyzeSeriesDuplicates	AnalyzeSeriesDuplicates.pl <?bkgrnd_id?> "<collection>" <site> <notify>	background_process	\N	{"ACRIN-FMISO-Brain Duplicate Elimination",dup_sops,activity_timepoint_support}
BackgroundHideSeriesByCollection	BackgroundHideSeriesByCollection.pl <?bkgrnd_id?> "<reason>" <collection> <notify>	background_process	<series_instance_uid>	{activity_timepoint_support}
BackgroundUpdatePrivateDisposition	BackgroundUpdatePrivateDispositions.pl <?bkgrnd_id?> "<why>" <notify>	background_process	<id>&<disp>	{phi_maint}
SummarizeStructLinkage	SummarizeStructLinkagesByFileId.pl <?bkgrnd_id?> <file_id> <notify>	background_process	\N	{activity_timepoint_support}
BackgroundDciodvfyTp	BackgroundDciodvfyTp.pl <?bkgrnd_id?> <act_id> <type> <notify>	background_process	\N	{activity_timepoint}
DeleteSeriesFromActivityTimepoint	DeleteSeriesFromActivityTimepoint.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	<series_instance_uid>	{activity_timepoints}
FilesInTpNotInPublic	FilesInLatestActivityNotInPublic.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{activity_timepoints_support}
BackgroundUnhideFiles	BackgroundUnhideFilesWithStatus.pl <?bkgrnd_id?> <notify> "<reason>"	background_process	<file_id>&<old_visibility>	{activity_timepoint_support}
FixFilesWithNullNumberOfFrames	FixFilesWithNullNumberOfFrames.pl <?bkgrnd_id?> "<comment>" <notify>	background_process	\N	{Exceptional-Responders_NCI_Oct2018_curation}
FixCtInExceptionalRespondersWithNullNumberOfFrames	FixCtErwWithNullNumberOfFrames.pl <?bkgrnd_id?> "<comment>" <notify>	background_process	\N	{Exceptional-Responders_NCI_Oct2018_curation}
AddSeriesToActivityTimepoint	AddSeriesToActivityTimepoint.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	<series_instance_uid>	{activity_timepoint_support}
BackgroundEditByStudy	BackgroundEditStudy.pl <?bkgrnd_id?> "<description>" <notify>	background_process	<study_instance_uid>&<op>&<tag>&<val1>&<val2>	{activity_timepoints}
CompareSopsInTpToPublic	CompareSopsInTpToPublic.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{activity_timepoints_support}
TestProcessEditByFile	TestProcessBackgroundEditFileInstructions.pl <?bkgrnd_id?> <notify>	background_process	<file_id>&<op>&<tag>&<val1>&<val2>	{testing_edit_objects}
ModifySeriesInActivityTp	ModifySeriesInActivityTimepoint.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	<series_instance_uid>&<function>	{activity_timepoints}
UpdateActivityTimepoint	UpdateActivityTimepointForChange.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	\N	{timepoint_buttons}
ConsistencyFromTimePoint	AnalyzeStudySeriesConsistencyByActivity.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{timepoint_buttons}
LinkRtFromTimepoint	LinkRtByActivityTimepoint.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{timepoint_buttons}
CheckStructLinkagesTp	CheckStructLinkagesTpId.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{timepoint_buttons}
CondensedActivityTimepointReport	CondensedActivityTimepointReport.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{timepoint_buttons}
ImportPatientMapping	ImportPatientMapping.pl <?bkgrnd_id?> <notify>	background_process	<from_patient_id>&<to_patient_id>&<to_patient_name>&<collection_name>&<site_name>&<batch_number>&<date_shift>&<diagnosis_date>&<baseline_date>&<uid_root>	{bills_test,mapping_tables,patient_mapping}
PrivateTagReports	PrivateElementReports.pl <?bkgrnd_id?> <notify>	background_process	\N	{phi_maint}
CompareSopsTpPosdaPublicLike	CompareSopsTpPosdaPublicLike.pl <?bkgrnd_id?> "<collection_like>" <activity_id> <notify>	background_process	\N	{activity_timepoint_support}
CreateActivityTimepointFromPatientList	CreateActivityTimepointFromPatientList.pl <?bkgrnd_id?> <activity_id> "<comment>" <notify>	background_process	<collection>&<site>&<patient_id>	{activity_timepoints}
CompareSopsTpPosdaPublicCollectionLikeSiteEqual	CompareSopsTpPosdaPublicLikeEq.pl <?bkgrnd_id?> "<collection_like>" "<site>" <activity_id> <notify>	background_process	\N	{activity_timepoint_support}
InitialAnonymizerCommands	ProduceInitialAnonymizerCommands.pl <?bkgrnd_id?> <collection> <site> <notify>	background_process	<series_instance_uid>&<patient_id>&<patient_name>	{initial_anonymization,patient_mapping}
UpdateQualifiedPatients	UpdateQualifiedPatients.pl <?bkgrnd_id?> <notify>	background_process	<collection>&<site>&<patient_id>&<qualified>	{activity_timepoint_support}
HideFilesVisbleInBadEquivalenceClassesByVisualReviewId	HideVisibleFilesInBadIecs.pl <?bkgrnd_id?> <visual_review_instance_id> <notify>	background_process	\N	{visual_review_status}
TestProcessEditByStudy	TestProcessBackgroundEditStudyInstructions.pl <?bkgrnd_id?> <notify>	background_process	<study_instance_uid>&<op>&<tag>&<val1><val2>	{testing_edit_objects}
BackgroundLinkActivityToTemp	BackgroundLinkActivityToTemp.pl <?bkgrnd_id?> <activity_id> <notify>	background_process	\N	{send_series}
PhiPublicScanTp	PhiPublicScanTp.pl <?bkgrnd_id?> <activity_id> <max_rows> <notify>	background_process	\N	{simple_phi}
BackgroundFixRtstruct	BackgroundFixStructLinkages.pl <?bkgrnd_id?> "<comment>" <notify>	background_process	<img_series>&<struct_file_id>	{activity_timepoints}
ProposeEdits	NewProposeEdits.pl <?bkgrnd_id?> <scan_id> <notify>	background_process	<element>%<vr>%<q_value>%<num_series>%<p_op>%<q_arg1>%<q_arg2>	{simple_phi,activity_timepoints}
PopulateFileImport	PopulateFileImportForImportEvent.pl <?bkgrnd_id?> <import_event_id> <notify>	background_process	<file_name>&<digest>	{QIN-GBM-DSC-MRI-DRO/Barrow}
BackgroundUnhideSeries	BackgroundUnhideSeriesWithIndividualStatus.pl <?bkgrnd_id?> <notify>	background_process	<series_uid>&<reason_to_unhide>	{bills_test,new_workflow,activity_support}
SimpleBackgroundTestProcess	SimpleBackgroundTestSubprocess.pl <?bkgrnd_id?> "<message>" <notify>	background_process	<column1>&<column2>&<column3>	{bills_test}
CreateActivityTimepointFromImportName	CreateActivityTimepointFromImportName.pl <?bkgrnd_id?> "<import_name>" <activity_id> "<comment>" <notify>	background_process	\N	{activity_timepoints}
\.


--
-- Name: background_buttons_background_button_id_seq; Type: SEQUENCE SET; Schema: dbif_config; Owner: -
--

SELECT pg_catalog.setval('dbif_config.background_buttons_background_button_id_seq', 55, true);


--
-- Name: chained_query_chained_query_id_seq; Type: SEQUENCE SET; Schema: dbif_config; Owner: -
--

SELECT pg_catalog.setval('dbif_config.chained_query_chained_query_id_seq', 22, true);


--
-- Name: popup_buttons_popup_button_id_seq1; Type: SEQUENCE SET; Schema: dbif_config; Owner: -
--

SELECT pg_catalog.setval('dbif_config.popup_buttons_popup_button_id_seq1', 75, true);


--
-- PostgreSQL database dump complete
--

set search_path to public, dbif_config;
truncate table queries;

            insert into queries
            values ('SubprocessesByUserWhichGeneratedEmail', 'select 
  distinct subprocess_invocation_id, when_script_started, when_background_entered,
  when_script_ended, user_to_notify, button_name, operation_name, command_line,
  user_inbox_content_id, activity_id, brief_description as activity_description
from
  subprocess_invocation natural left join background_subprocess natural left join 
  background_subprocess_report natural left join user_inbox_content natural left join
  activity_inbox_content left join activity using (activity_id)
where
  invoking_user = ? and background_subprocess_report.name = ''Email''
order by subprocess_invocation_id desc;', ARRAY['invoking_user'], 
                    ARRAY['subprocess_invocation_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'user_to_notify', 'button_name', 'operation_name', 'user_inbox_content_id', 'activity_id', 'activity_description', 'command_line'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('PatientReportByPatientOnly', 'select
  distinct project_name as collection,
  site_name as site,
  site_id,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description,
  count(distinct file_id) as num_files,
  min(import_time) as earliest_upload,
  max(import_time) as latest_upload,
  count(distinct import_event_id) as num_uploads
from
  file_patient natural join file_study natural join
  file_series natural join ctp_file natural join
  file_import natural join import_event
where
  patient_id = ?
  and visibility is null
group by 
  collection, site, site_id,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description
order by
  study_instance_uid, series_instance_uid, num_files', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'site_id', 'study_instance_uid', 'study_description', 'series_instance_uid', 'series_description', 'num_files', 'earliest_upload', 'latest_upload', 'num_uploads'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetListStructureSets', 'select 
  distinct project_name, site_name, patient_id, sop_instance_uid
from
  file_sop_common natural join ctp_file natural join dicom_file natural join file_patient
where
  dicom_file_type = ''RT Structure Set Storage'' and visibility is null
order by project_name, site_name, patient_id', '{}', 
                    ARRAY['project_name', 'patient_id', 'site_name', 'sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set List

')
        ;

            insert into queries
            values ('FinalizeSimpleScanInstance', 'update phi_scan_instance set
  end_time = now()
where
  phi_scan_instance_id = ?', ARRAY['id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Finalize PHI Scan')
        ;

            insert into queries
            values ('UnhideFile', 'update
  ctp_file
set
  visibility = null
where
  file_id = ?
', ARRAY['file_id'], 
                    '{}', ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Hide a file
')
        ;

            insert into queries
            values ('CreateDciodvfyUnitScan', 'insert into dciodvfy_unit_scan(
  type_of_unit,
  unit_uid,
  unit_id,
  num_file_in_unit,
  start_time
) values( ?, ?, ?, ?, now())', ARRAY['type_of_unit', 'unit_uid', 'unit_id', 'num_file_in_unit'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_unit_scan row')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteStatusNotGood', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status != ''Good''
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('BackgroundProcessStatsWithInvokerLikeProgram', 'select
  distinct command_executed, invoking_user as invoker, 
  max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null and command_executed like ?
group by command_executed, invoker', ARRAY['command_executed_like'], 
                    ARRAY['command_executed', 'invoker', 'longest', 'shortest', 'avg', 'times_invoked', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('InsertFileImportLong', 'insert into file_import(
  import_event_id, file_id,  rel_path, rel_dir, file_name
) values (
  ?, ?, ?, ?, ?
)
', ARRAY['import_event_id', 'file_id', 'rel_path', 'rel_dir', 'file_name'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Create an import_event')
        ;

            insert into queries
            values ('GetCountSsVolumeByPatientId', 'select
  distinct sop_instance_uid, count(distinct sop_instance_link) as num_links 
from (
  select 
    sop_instance_uid, for_uid, study_instance_uid, series_instance_uid,
    sop_class as sop_class_uid, sop_instance as sop_instance_link
  from
    ss_for natural join ss_volume natural join
    file_structure_set join file_sop_common using (file_id)
  where structure_set_id in (
    select 
      structure_set_id 
    from
      file_structure_set fs, file_sop_common sc
    where
      sc.file_id = fs.file_id and sop_instance_uid in (
         select distinct sop_instance_uid 
         from file_sop_common natural join file_patient
         where patient_id = ?
     )
  )
) as foo 
group by sop_instance_uid', ARRAY['patient_id'], 
                    ARRAY['sop_instance_uid', 'num_links'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('LookingForMissingHeadNeckPetCT', 'select distinct series_instance_uid, visibility, count(distinct file_id) as num_files, count(distinct import_event_id) as num_uploads, count(distinct sop_instance_uid) as num_sops
, max(import_time) as last_load, min(import_time) as earliest_load from file_series join ctp_file using(file_id) join file_sop_common using(file_id) join file_import using (file_id) join import_event using(import_event_id)
where project_name = ''Head-Neck-PET-CT'' and import_time > ''2018-04-01'' group by series_instance_uid, visibility;', '{}', 
                    ARRAY['series_instance_uid', 'visibility', 'num_files', 'num_uploads', 'num_sops', 'last_load', 'earliest_load'], ARRAY['meta', 'test', 'hello', 'bills_test', 'bills_ad_hoc_scripts', 'for_tracy'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ShowPopUps', 'select * from popup_buttons
 ', '{}', 
                    ARRAY['popup_button_id', 'name', 'object_class', 'btn_col', 'is_full_table', 'btn_name'], ARRAY['AllCollections', 'universal'], 'posda_queries', 'Get a list of configured pop-up buttons')
        ;

            insert into queries
            values ('GetDciodvfyWarningUnrecognizedDT', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''UnrecognizedDefinedTerm''
  and warning_tag = ?
  and warning_value = ?
  and warning_index = ?
', ARRAY['warning_tag', 'warning_value', 'warning_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_warning row where subtype = UnrecognizedDefinedTerm')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSiteSubject', 'select distinct patient_id, series_instance_uid, dicom_file_type, modality, count(*)
from (
select distinct patient_id, series_instance_uid, sop_instance_uid, dicom_file_type, modality from (
select
   distinct patient_id, series_instance_uid, modality, sop_instance_uid,
   file_id, dicom_file_type
 from file_series natural join file_sop_common
   natural join file_patient
   natural join ctp_file natural join dicom_file
where
  project_name = ? and site_name = ? and patient_id = ?
  and visibility is null)
as foo
group by patient_id, series_instance_uid, sop_instance_uid, dicom_file_type, modality)
as foo
group by patient_id, series_instance_uid, dicom_file_type, modality
', ARRAY['project_name', 'site_name', 'patient_id'], 
                    ARRAY['patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('PixelInfoBySopInstance', 'select
  f.file_id, root_path || ''/'' || rel_path as file, file_offset, size, 
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation,
  planar_configuration, modality
from
  file_image f natural join image natural join unique_pixel_data
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
  natural join file_series 
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
    select distinct file_id
    from file_sop_common where sop_instance_uid = ?
  )
', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'planar_configuration', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for a particular image id
')
        ;

            insert into queries
            values ('GetIdOfNewCopyFromPublicRow', 'select currval(''copy_from_public_copy_from_public_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ListClosedActivitiesWithItems', 'select
  distinct activity_id,
  brief_description,
  when_created,
  who_created,
  when_closed,
  count(distinct user_inbox_content_id) as num_items
from
  activity natural join activity_inbox_content
where when_closed is not null
group by activity_id, brief_description, when_created, who_created, when_closed
order by activity_id', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed', 'num_items'], ARRAY['AllCollections', 'queries', 'activities'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetPlans', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from plan p natural join file_plan)', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('AddInsertedToFileCopyFromPublic', 'update file_copy_from_public set
  inserted_file_id = ?
where copy_from_public_id = ? and sop_instance_uid = ?', ARRAY['inserted_file_id', 'copy_from_public_id', 'sop_instance_uid'], 
                    '{}', ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('VisualReviewStatusByIdWithVisibility', 'select
  distinct processing_status, review_status, dicom_file_type,  visibility,
  count(distinct image_equivalence_class_id) as num_equiv, count(distinct series_instance_uid) as num_series                                                               from
  image_equivalence_class natural join image_equivalence_class_input_image 
  natural join dicom_file natural join ctp_file
where
  visual_review_instance_id = ?
group by processing_status, review_status, dicom_file_type, visibility', ARRAY['id'], 
                    ARRAY['processing_status', 'review_status', 'dicom_file_type', 'visibility', 'num_equiv', 'num_series'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_reports', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('AllPixelInfo', 'select
  f.file_id as file_id, root_path || ''/'' || rel_path as file,
  file_offset, size, modality,
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  file_image f natural join image natural join unique_pixel_data
  natural join file_series
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
  select distinct file_id
  from ctp_file
  where visibility is null
)
', '{}', 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for all files
')
        ;

            insert into queries
            values ('GetInfoForDupFilesByCollection', 'select
  file_id, image_id, patient_id, study_instance_uid, series_instance_uid,
   sop_instance_uid, modality
from
  file_patient natural join file_series natural join file_study
  natural join file_sop_common natural join file_image
where file_id in (
  select file_id
  from (
    select image_id, file_id
    from file_image
    where image_id in (
      select image_id
      from (
        select distinct image_id, count(*)
        from (
          select distinct image_id, file_id
          from file_image
          where file_id in (
            select
              distinct file_id
              from ctp_file
              where project_name = ? and visibility is null
          )
        ) as foo
        group by image_id
      ) as foo 
      where count > 1
    )
  ) as foo
);
', ARRAY['collection'], 
                    ARRAY['file_id', 'image_id', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'modality'], '{}', 'posda_files', 'Get information related to duplicate files by collection
')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollection', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  date_trunc(''day'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, patient_id, series_instance_uid, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetNonDicomPathSeenId', 'select
  currval(''non_dicom_file_scan_non_dicom_file_scan_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('InsertIntoPosdaPublicCompare', 'insert into posda_public_compare(
  compare_public_to_posda_instance_id,
  sop_instance_uid,
  posda_file_id,
  posda_file_path,
  public_file_path,
  short_report_file_id,
  long_report_file_id
) values ( ?, ?, ?, ?, ?, ?, ?)', ARRAY['compare_public_to_posda_instance_id', 'sop_instance_uid', 'posda_file_id', 'posda_file_path', 'public_file_path', 'short_report_file_id', 'long_report_file_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'public_posda_counts'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('SummaryOfSingleFileImportEventsByDateRange', 'select 
  distinct import_type, import_comment, min(import_time) as earliest, max(import_time) as latest,
  count(distinct import_event_id) as num_imports
from (
  select * 
  from (
    select
      distinct import_event_id, import_time, import_type, import_comment, count(distinct file_id)
    from
      import_event natural join file_import 
    where
      import_time > ?
      and import_time < ?
     group by import_event_id, import_time, import_type, import_comment
     order by import_time desc
  ) as foo where count = 1
) as foo 
group by import_type, import_comment;', ARRAY['from', 'to'], 
                    ARRAY['import_type', 'import_comment', 'earliest', 'latest', 'num_imports'], ARRAY['downloads_by_date', 'import_events'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AddPhiElement', 'insert into element_signature (
  element_signature,
  vr,
  is_private,
  private_disposition,
  name_chain
) values (
  ?, ?, ?, ?, ?
)
', ARRAY['element_signature', 'vr', 'is_private', 'private_disposition', 'name_chain'], 
                    '{}', ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi', 'Add an element_signature row to posda_phi')
        ;

            insert into queries
            values ('GetQualifiedCTQPByLikeCollectionSiteWithFIleCount', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id)
where collection like ? and site = ? and qualified
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('SeriesWithDuplicatePixelDataTest', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  count(distinct file_id) as num_files
from 
  file_series natural join file_image
  natural join file_patient
  natural join ctp_file
where 
  visibility is null 
  and image_id in (
select image_id from (
  select distinct image_id, count(*)
  from (
    select distinct image_id, file_id
    from (
      select
        file_id, image_id, patient_id, study_instance_uid, 
        series_instance_uid, sop_instance_uid, modality
      from
        file_patient natural join file_series natural join 
        file_study natural join file_sop_common
        natural join file_image
      where file_id in (
        select file_id
        from (
          select image_id, file_id 
          from file_image 
          where image_id in (
            select image_id
            from (
              select distinct image_id, count(distinct file_id)
              from file_image natural join ctp_file
              where project_name = ? and visibility is null
              group by image_id
            ) as foo 
            where count > 1
          )
        ) as foo
      )
    ) as foo
  ) as foo
  group by image_id
) as foo 
where count > 1
) group by collection, site, patient_id, series_instance_uid
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'series_instance_uid', 'patient_id', 'num_files'], ARRAY['pixel_duplicates'], 'posda_files', 'Return a list of files with duplicate pixel data,
restricted to those files which have parsed DICOM data
representations in Database.
')
        ;

            insert into queries
            values ('PixelTypesWithRowsColumns', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_rows,
  pixel_columns,
  number_of_frames,
  pixel_representation,
  planar_configuration,
  modality,
  count(*)
from
  image natural join file_image natural join file_series
group by
  photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_rows,
  pixel_columns,
  number_of_frames,
  pixel_representation,
  planar_configuration,
  modality
order by
  count desc', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_rows', 'pixel_columns', 'number_of_frames', 'pixel_representation', 'planar_configuration', 'modality', 'count'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('LookingForMissingHeadNeckPetCT2', 'select 
  distinct series_instance_uid, modality, 
  count(distinct file_id) as num_files, min(import_time) as first_load, max(import_time) as last_load
from
  file_series
  join file_import using(file_id)
  join import_event using(import_event_id)
where file_id in (      
  select
     distinct file_id
  from
    file_series join ctp_file using(file_id)
    join file_sop_common using(file_id) 
    join file_import using (file_id)
    join import_event using(import_event_id)
  where 
    project_name = ''Head-Neck-PET-CT'' and import_time > ''2018-04-01''
  )
group by series_instance_uid, modality', '{}', 
                    ARRAY['study_instance_uid', 'series_instance_uid', 'modality', 'num_files', 'first_load', 'last_load'], ARRAY['meta', 'test', 'hello', 'bills_test', 'bills_ad_hoc_scripts', 'for_tracy'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CountsByPatientId', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  patient_id = ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DualFileNameReportByImportEvent', 'select
  file_id, patient_id,
  study_instance_uid, study_date, study_description, series_instance_uid,
  modality, series_date, series_description, dicom_file_type, file_name,
  root_path || ''/'' || l.rel_path as path 
from
  file_import natural join file_patient natural join file_series natural join
  file_study natural join dicom_file join file_location l using(file_id) natural join
  file_storage_root
where
  import_event_id = ?
order by file_name', ARRAY['import_event_id'], 
                    ARRAY['file_id', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'modality', 'series_date', 'series_description', 'dicom_file_type', 'file_name', 'path'], ARRAY['import_events'], 'posda_files', 'List of values seen in scan by ElementSignature with VR and count
')
        ;

            insert into queries
            values ('GetSeenValue', 'select * from seen_value where value = ?
', ARRAY['value'], 
                    ARRAY['seen_value_id', 'value'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Get Seen Value Id')
        ;

            insert into queries
            values ('GetPosdaPhiSimpleElementSigInfo', 'select
  element_sig_pattern,
  vr,
  is_private,
  private_disposition,
  tag_name
from element_seen

', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'is_private', 'private_disposition', 'name_chain'], ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Get the relevant features of an element_signature in posda_phi_simple schema')
        ;

            insert into queries
            values ('FileWithInfoBySopInPosda', 'select 
  file_for.for_uid as frame_of_ref,
  iop, 
  ipp,
  pixel_spacing,
  pixel_rows,
  pixel_columns
from
  file_sop_common natural join ctp_file
  natural join file_for natural join file_image
  join image_geometry using (image_id)
  join image using (image_id)
where
  sop_instance_uid = ?
  and visibility is null', ARRAY['sop_instance_uid'], 
                    ARRAY['frame_of_ref', 'iop', 'ipp', 'pixel_spacing', 'pixel_rows', 'pixel_columns'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSiteExt', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  count (distinct file_id) as num_files
from
  file_study natural join
  ctp_file natural join
  dicom_file natural join
  file_series natural join
  file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and
    visibility is null
  )
group by patient_id, study_instance_uid, series_instance_uid,
  dicom_file_type, modality
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['Hierarchy', 'phi_simple', 'simple_phi'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('CreateElementSignature', 'insert into element_signature(element_signature, vr, is_private) values(?, ?, ?)
', ARRAY['element_signature', 'vr', 'is_private'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create New Element Signature Id')
        ;

            insert into queries
            values ('AverageSecondsPerFile', 'select avg(seconds_per_file) from (
  select (send_ended - send_started)/number_of_files as seconds_per_file 
  from dicom_send_event where send_ended is not null and number_of_files > 0
  and send_started > ? and send_ended < ?
) as foo
', ARRAY['from_date', 'to_date'], 
                    ARRAY['avg'], ARRAY['send_to_intake'], 'posda_files', 'Average Time to send a file between times
')
        ;

            insert into queries
            values ('LookUpTagEle', 'select
  tag, name, keyword, vr, vm, is_retired, comments
from 
  dicom_element
where
  tag = ?', ARRAY['tag'], 
                    ARRAY['tag', 'name', 'keyword', 'vr', 'vm', 'is_retired', 'comments'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'dicom_dd', 'Get tag from name or keyword')
        ;

            insert into queries
            values ('RoundSummary1Recent', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups),
  ((round_end - round_start) / sum(num_entered + num_dups)) as sec_per_file
from
  round natural join round_collection
where
  round_end is not null and (now() - round_end) < ''24:00''
group by 
  round_id, round_start, duration, round_end 
order by round_id', '{}', 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum', 'sec_per_file'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('DistinctPatientStudySeriesByCollection', 'select distinct
  patient_id, 
  study_instance_uid,
  series_instance_uid, 
  dicom_file_type,
  modality, 
  count(distinct file_id) as num_files
from
  ctp_file
  natural join dicom_file
  natural join file_study
  natural join file_series
  natural join file_patient
where
  project_name = ? and
  visibility is null
group by
  patient_id, 
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality
  ', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('DupSopsByImportEventByPatLike', 'select
  distinct sop_instance_uid, count(distinct file_id) as num_files
from (
  select distinct sop_instance_uid, file_id 
  from file_sop_common 
  where file_id in (
    select
      distinct file_id from file_import where import_event_id in (select import_event_id from (
        select
          distinct import_event_id, import_time,  import_type, count(distinct file_id) as num_files
        from
          import_event natural join file_import natural join file_patient
        where
          import_type = ''multi file import'' and
          patient_id like ?
         group by import_event_id, import_time, import_type
       ) as foo
    )
  )
)as foo
group by sop_instance_uid
', ARRAY['patient_id_like'], 
                    ARRAY['sop_instance_uid', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetDupsFromSimilarDupContourCounts', 'select distinct roi_id, count(*) from file_roi_image_linkage where
contour_digest in (select contour_digest from (select
  distinct contour_digest, count(*) from
(select
  distinct
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  sop_class_uid,
  file_id,
  contour_digest
from
   ctp_file
   natural join file_patient
   natural join file_series
   natural join file_sop_common
  natural join file_roi_image_linkage
where file_id in (
  select distinct file_id from (
    select 
      distinct file_id, count(*) as num_dup_contours
    from
      file_roi_image_linkage 
    where 
      contour_digest in (
      select contour_digest
     from (
        select 
          distinct contour_digest, count(*)
        from
          file_roi_image_linkage group by contour_digest
     ) as foo
      where count > 1
    ) group by file_id order by num_dup_contours desc
  ) as foo
  where num_dup_contours = ?
)
) as foo
group by contour_digest)
as foo where count > 1)
group by roi_id order by count desc
', ARRAY['num_dup_contours'], 
                    ARRAY['roi_id', 'count'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dup_contours'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('UnHideFile', 'update
  ctp_file
set
  visibility = null
where
  file_id = ?
', ARRAY['file_id'], 
                    '{}', ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Hide a file
')
        ;

            insert into queries
            values ('GetCTQPByCollectionSite', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id
where collection = ? and site = ?', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('TotalDiskSpace', 'select
  sum(size) as total_bytes
from
  file
where
  file_id in (
  select distinct file_id
  from ctp_file
  )
', '{}', 
                    ARRAY['total_bytes'], ARRAY['all', 'posda_files', 'storage_used'], 'posda_files', 'Get total disk space used
')
        ;

            insert into queries
            values ('DistinctSeriesByCollection', 'select distinct series_instance_uid, patient_id, dicom_file_type, modality, count(*)
from (
select distinct series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality from (
select
   distinct series_instance_uid, patient_id, modality, sop_instance_uid,
   file_id, dicom_file_type
 from file_series natural join file_sop_common
   natural join ctp_file natural join dicom_file natural join file_patient
where
  project_name = ?
  and visibility is null)
as foo
group by series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality)
as foo
group by series_instance_uid, patient_id, dicom_file_type, modality
', ARRAY['collection'], 
                    ARRAY['series_instance_uid', 'patient_id', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi', 'dciodvfy'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('LastFilesInSeries', 'select root_path || ''/'' || rel_path as path
from file_location natural join file_storage_root
where file_id in (
select file_id from 
  (
  select 
    distinct sop_instance_uid, max(file_id) as file_id
  from 
    file_series natural join ctp_file 
    natural join file_sop_common
  where 
    series_instance_uid = ?
    and visibility is null
  group by sop_instance_uid
) as foo);
', ARRAY['series_instance_uid'], 
                    ARRAY['path'], ARRAY['by_series'], 'posda_files', 'Last files uploaded by series
')
        ;

            insert into queries
            values ('FileSizeByCollection', 'select project_name as collection,sum(size) as total_disc_used from file natural join ctp_file group by project_name order by total_disc_used desc', '{}', 
                    ARRAY['collection', 'total_disc_used'], ARRAY['AllCollections', 'queries'], 'posda_files', 'Get a list of available queries')
        ;

            insert into queries
            values ('HideFile', 'update
  ctp_file
set
  visibility = ''hidden''
where
  file_id = ?
', ARRAY['file_id'], 
                    '{}', ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Hide a file
')
        ;

            insert into queries
            values ('DupSopCountsByCSS', 'select
  distinct sop_instance_uid, min, max, count
from (
  select
    distinct sop_instance_uid, min(file_id),
    max(file_id),count(*)
  from (
    select
      distinct sop_instance_uid, file_id
    from
      file_sop_common 
    where sop_instance_uid in (
      select
        distinct sop_instance_uid
      from
        file_sop_common natural join ctp_file
        natural join file_patient
      where
        project_name = ? and site_name = ? 
        and patient_id = ? and visibility is null
    )
  ) as foo natural join ctp_file
  where visibility is null
  group by sop_instance_uid
)as foo where count > 1
', ARRAY['collection', 'site', 'subject'], 
                    ARRAY['sop_instance_uid', 'min', 'max', 'count'], '{}', 'posda_files', 'Counts of DuplicateSops By Collection, Site, Subject
')
        ;

            insert into queries
            values ('StorageRootIdByClass', 'select file_storage_root_id as id from file_storage_root where
storage_class = ?', ARRAY['storage_class'], 
                    ARRAY['id'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get file storage root by storage class

Used in file migration; should return a single row. If not, error in database configuration.')
        ;

            insert into queries
            values ('CountsByCollectionSiteExt', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type, dicom_file_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files'], ARRAY['counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('BackgroundersByDateRange', 'select
  distinct operation_name, count(distinct subprocess_invocation_id) as num_invocations
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null and operation_name is not null and
  when_script_started > ? and when_script_ended < ? and
  when_script_ended is not null
group by operation_name
order by num_invocations desc', ARRAY['from', 'to'], 
                    ARRAY['operation_name', 'num_invocations'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('SimplePhiReportAllPrivateOnlyMetaQuote', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, 
  ''<'' || value || ''>'' as q_value, tag_name as description, private_disposition as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and is_private
group by element_sig_pattern, vr, value, val_length, description, disp
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'disp', 'q_value', 'description', 'num_series'], ARRAY['adding_ctp', 'for_scripting', 'phi_reports'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('GoInServicePosdaImport', 'update import_control
set status = ''service process running'',
  processor_pid = ?', ARRAY['pid'], 
                    '{}', ARRAY['NotInteractive', 'PosdaImport'], 'posda_files', 'Claim control of posda_import')
        ;

            insert into queries
            values ('GetBackgroundSubprocessId', 'select currval(''background_subprocess_background_subprocess_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Get the id of the background_subprocess row just created')
        ;

            insert into queries
            values ('UpdatePatientImportStatus', 'update patient_import_status set 
  patient_import_status = ?
where patient_id = ?
', ARRAY['patient_id', 'status'], 
                    NULL, ARRAY['NotInteractive', 'PatientStatus', 'Update'], 'posda_files', 'Update Patient Status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('CountRowsInDicomFileWithPopulatedPixelInfo', 'select 
 count(*) from dicom_file where has_pixel_data is not null', '{}', 
                    ARRAY['count'], ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'count rows in dicom_file with unpopulated pixel info')
        ;

            insert into queries
            values ('GetFilesToEditBySopForLGCP', 'select
  file_id, root_path || ''/'' || rel_path as path
from 
  file_sop_common natural join file_series natural join
  file_location natural join file_storage_root natural join ctp_file
where 
  sop_instance_uid = ? and series_instance_uid != ?
  and visibility is null
', ARRAY['sop_instance_uid', 'series_instance_uid'], 
                    ARRAY['file_id', 'path'], ARRAY['Curation of Lung-Fused-CT-Pathology'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('StatusOfDciodvfyScans', 'select 
  dciodvfy_scan_instance_id as id,
  type_of_unit,
  description_of_scan,
  number_units,
  scanned_so_far,
  start_time,
  end_time
from 
  dciodvfy_scan_instance
order by id
  ', '{}', 
                    ARRAY['id', 'type_of_unit', 'description_of_scan', 'number_units', 'scanned_so_far', 'start_time', 'end_time'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('GetLinkedSopsByStructureSetFileId', 'select
  distinct sop_instance
from contour_image natural join  file_structure_set natural join roi natural join roi_contour
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of SOP''s linked in SS

')
        ;

            insert into queries
            values ('PosdaTotals', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files,
    sum(total_sops) as total_sops
from (
  select
    distinct project_name, site_name, patient_id,
    count(*) as num_studies, sum(num_series) as num_series, 
    sum(total_files) as total_files,
    sum(total_sops) as total_sops
  from (
    select
       distinct project_name, site_name, patient_id, 
       study_instance_uid, count(*) as num_series,
       sum(num_sops) as total_sops,
       sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid,
        count(distinct file_id) as num_files,
        count(distinct sop_instance_uid) as num_sops
      from (
        select
          distinct project_name, site_name, patient_id,
          study_instance_uid, series_instance_uid, sop_instance_uid,
          file_id
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common
           natural join file_patient
        where
          visibility is null
      ) as foo
      group by
        project_name, site_name, patient_id, 
        study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', '{}', 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files', 'total_sops'], '{}', 'posda_files', 'Produce total counts for all collections currently in Posda
')
        ;

            insert into queries
            values ('GetPixelDescriptorByDigestNew', 'select
  samples_per_pixel, 
  number_of_frames, 
  pixel_rows,
  pixel_columns,
  bits_stored,
  bits_allocated,
  high_bit, 
  pixel_data_offset, 
  pixel_data_length,
  root_path || ''/'' || rel_path as path
from
  image natural join file_image
  natural join dicom_file natural join file_location
  natural join file_storage_root where pixel_data_digest = ?
limit 1', ARRAY['pixel_data_digest'], 
                    ARRAY['samples_per_pixel', 'number_of_frames', 'pixel_rows', 'pixel_columns', 'bits_stored', 'bits_allocated', 'high_bit', 'pixel_data_offset', 'pixel_data_length', 'path'], ARRAY['meta', 'test', 'hello'], 'posda_files', 'Find Duplicated Pixel Digest')
        ;

            insert into queries
            values ('GetPtInfoBySeries', 'select 
  distinct 
  pti_radiopharmaceutical as radiopharmaceutical, 
  pti_radionuclide_total_dose as total_dose,
  pti_radionuclide_half_life as half_life,
  pti_radionuclide_positron_fraction as positron_fraction, 
  pti_fov_shape as fov_shape,
  pti_fov_dimensions as fov_dim,
  pti_collimator_type as coll_type,
  pti_reconstruction_diameter as recon_diam
from file_pt_image natural join file_patient natural join file_series natural join ctp_file 
where series_instance_uid = ? and visibility is null', ARRAY['series_instance_uid'], 
                    ARRAY['radiopharmaceutical', 'total_dose', 'half_life', 'positron_fraction', 'fov_shape', 'fov_dim', 'coll_type', 'recon_diam'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('ListOfQueriesPerformedByUserByDate', 'select
  query_invoked_by_dbif_id as id,
  query_name,
  query_end_time - query_start_time as duration,
  invoking_user as invoked_by,
  query_start_time as at, 
  number_of_rows
from
  query_invoked_by_dbif
where
  invoking_user = ? and
  query_start_time > ? and query_end_time < ?
order by query_start_time', ARRAY['user', 'from', 'to'], 
                    ARRAY['id', 'query_name', 'duration', 'invoked_by', 'at', 'number_of_rows'], ARRAY['AllCollections', 'q_stats_by_date'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetDciodvfyWarningMissingDicomDir', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''MissingForDicomDir''
  and warning_tag = ?
 ', ARRAY['warning_tag'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('Checking Duplicate Series', 'select 
  distinct project_name as collection, site_name as site, patient_id,
  dicom_file_type, pixel_data_digest, sop_instance_uid
from
  file_series natural join file_patient natural join ctp_file natural join
  file_sop_common natural join dicom_file
where
  visibility is null and series_instance_uid = ?
order by sop_instance_uid', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'dicom_file_type', 'pixel_data_digest', 'sop_instance_uid'], ARRAY['CPTAC Bolus September 2018'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('ColSiteDetails', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series natural left join
  ctp_file
where
  project_name = ? and site_name = ? and visibility is null
group by
  project_name, site_name, 
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  project_name, site_name, patient_id, study_date,
  modality
', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'ctp_details'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetDciodvfyErrorUnrecogEnum', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''UnrecognizedEnumeratedValue''
  and error_value = ?
  and error_tag = ?
  and error_index = ?', ARRAY['error_value', 'error_tag', 'error_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('RecordPatientStatusChange', 'insert into patient_import_status_change(
  patient_id, when_pat_stat_changed,
  pat_stat_change_who, pat_stat_change_why,
  old_pat_status, new_pat_status
) values (
  ?, now(),
  ?, ?,
  ?, ?
)
', ARRAY['patient_id', 'who', 'why', 'old_status', 'new_status'], 
                    NULL, ARRAY['NotInteractive', 'PatientStatus', 'Update'], 'posda_files', 'Record a change to Patient Import Status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetScanElementId', 'select currval(''scan_element_scan_element_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'UsedInPhiSeriesScan'], 'posda_phi', 'Get current value of ScanElementId Sequence
')
        ;

            insert into queries
            values ('FromFileWithVisibilityBySopFromDicomEditCompare', 'select 
  sop_instance_uid,
  file_id as from_file_id,
  visibility as from_file_visibility
from
  ctp_file natural join file natural join file_sop_common,
  dicom_edit_compare
where
  from_file_digest = file.digest and
  subprocess_invocation_id = ?
order by sop_instance_uid', ARRAY['subprocess_invocation_id'], 
                    ARRAY['sop_instance_uid', 'from_file_id', 'from_file_visibility'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSsVolumeForStudySeriesCount', 'select 
  distinct for_uid, study_instance_uid, series_instance_uid,
  sop_class as sop_class_uid, count(distinct sop_instance) as num_sops
  from ss_for natural join ss_volume where structure_set_id in (
    select 
      structure_set_id 
    from
      file_structure_set fs, file_sop_common sc
    where
      sc.file_id = fs.file_id and sop_instance_uid = ?
)
group by for_uid, study_instance_uid, series_instance_uid, sop_class
', ARRAY['sop_instance_uid'], 
                    ARRAY['for_uid', 'study_instance_uid', 'series_instance_uid', 'sop_class_uid', 'num_sops'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('EquipmentByPrivateTag', 'select distinct equipment_signature from (
select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ? and is_private ) as foo
where element_signature = ?
order by equipment_signature;
', ARRAY['scan_id', 'element_signature'], 
                    ARRAY['equipment_signature'], ARRAY['tag_usage'], 'posda_phi', 'Which equipment signatures for which private tags
')
        ;

            insert into queries
            values ('Series In Posda By PatientId', 'select 
  distinct series_instance_uid
from
  file_series natural join file_patient natural join ctp_file
where 
  visibility is null and patient_id = ?

', ARRAY['patient_id'], 
                    ARRAY['series_instance_uid'], ARRAY['Reconcile Public and Posda for CPTAC'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('GetSeriesByVisualReviewIdAndStatus', 'select 
  distinct series_instance_uid
from
  image_equivalence_class
where
  visual_review_instance_id = ? and review_status = ?', ARRAY['visual_review_instance_id', 'review_status'], 
                    ARRAY['series_instance_uid'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of Series By Visual Review Id and Status
')
        ;

            insert into queries
            values ('ByDistinguishedDigest', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id as subject,
  series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops
from 
  ctp_file natural join
  file_patient natural join
  file_sop_common natural join
  file_series
where file_id in (
  select 
    file_id
  from
    file_image
    join image using(image_id)
    join unique_pixel_data using(unique_pixel_data_id)
  where digest = ?
  ) and visibility is null 
group by 
  collection,
  site,
  series_instance_uid,
  subject
order by
  collection,
  site,
  subject', ARRAY['pixel_digest'], 
                    ARRAY['collection', 'site', 'subject', 'series_instance_uid', 'num_sops'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FilesInSeriesWithPath', 'select
  distinct root_path || ''/'' || rel_path as file
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_series
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('GetBackgroundButtons', 'select
    background_button_id,
    operation_name,
    object_class,
    button_text
from background_buttons

', '{}', 
                    ARRAY['background_button_id', 'operation_name', 'object_class', 'button_text'], ARRAY['NotInteractive', 'used_in_process_popup'], 'posda_queries', 'N
o
n
e')
        ;

            insert into queries
            values ('DicomFilesMissingThingsByDateRange', 'select
	dicom_file.file_id,
	project_name as collection,
	site_name as site,
	case when file_sop_common.file_id is null
		then ''X''
		else ''''
	end as file_sop_common_missing,
	case when file_patient.file_id is null
		then ''X''
		else ''''
	end as file_patient_missing,
	case when file_study.file_id is null
		then ''X''
		else ''''
	end as file_study_missing,
	case when file_series.file_id is null
		then ''X''
		else ''''
	end as file_series_missing,
	case when file_equipment.file_id is null
		then ''X''
		else ''''
	end as file_equipment_missing


from dicom_file
natural join import_event
natural join file_import
natural left join ctp_file
left join file_patient
	on dicom_file.file_id = file_patient.file_id
left join file_sop_common
	on dicom_file.file_id = file_sop_common.file_id
left join file_series
	on dicom_file.file_id = file_series.file_id
left join file_equipment
	on dicom_file.file_id = file_equipment.file_id
left join file_study
	on dicom_file.file_id = file_study.file_id

where 
	import_time >= ?
	and import_time < ?
	and (
		file_patient.file_id is null
		or file_sop_common.file_id is null
		or file_series.file_id is null
		or file_equipment.file_id is null
	)
', ARRAY['from', 'to'], 
                    ARRAY['file_id', 'collection', 'site', 'file_sop_common_missing', 'file_patient_missing', 'file_study_missing', 'file_series_missing', 'file_equipment_missing'], '{}', 'posda_files', 'List DICOM files which are missing one of:

* file_patient
* file_sop_common
* file_series
* file_equipment

Note that these could be missing due to a failure to fully 
parse the DICOM file. If that is the case, the CTP information
may also have failed (or been missing). Collection and Site
are included in this query but may be missing!')
        ;

            insert into queries
            values ('ListOfValuesByElementInScan', 'select element_signature, value                  
from element_signature natural join scan_element natural join seen_value natural join series_scan natural join scan_event where element_signature = ? and scan_event_id = ?;', ARRAY['element_signature', 'scan_id'], 
                    ARRAY['element_signature', 'value'], ARRAY['ElementDisposition'], 'posda_phi', 'Get List of Values for Private Element based on element_signature_id')
        ;

            insert into queries
            values ('UpdateStatusVisualReviewInstance', 'update visual_review_instance set
  visual_review_num_series_done = ?,
  visual_review_num_equiv_class = ?
where
  visual_review_instance_id = ?', ARRAY['visual_review_num_series_done', 'visual_review_num_equiv_class', 'visual_review_instance_id'], 
                    '{}', ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Get Id of Visual Review Instance')
        ;

            insert into queries
            values ('VisualReviewStatusWithCollectionByIdWithVisibility', 'select 
  distinct project_name as collection, site_name as site, 
  series_instance_uid, visibility, review_status, modality, series_description,
  series_date, count(distinct image_equivalence_class_id) as num_equiv_classes, 
  count(distinct file_id) as num_files
from
  visual_review_instance natural join image_equivalence_class natural join
  image_equivalence_class_input_image natural join
  file_series natural join ctp_file
where
  visual_review_instance_id = ? and review_status = ?
group by collection, site, series_instance_uid, visibility, review_status, modality, series_description, series_date;', ARRAY['visual_review_instance_id', 'review_status'], 
                    ARRAY['collection', 'site', 'series_instance_uid', 'review_status', 'visibility', 'modality', 'series_description', 'series_date', 'num_equiv_classes', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetContourData', 'select
  contour_data
from
  roi_contour
where roi_contour_id = ?', ARRAY['roi_contour_id'], 
                    ARRAY['contour_data'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Contour Data by roi_contour_id
')
        ;

            insert into queries
            values ('GetMaxFileId', 'select
  max(file_id) as file_id
from
  file
', '{}', 
                    ARRAY['file_id'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('DistinctSopsInSeriesForCompare', 'select distinct sop_instance_uid, dicom_file_type, sop_class_uid, modality, file_id
from file_sop_common natural join dicom_file  natural join file_series
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'dicom_file_type', 'sop_class_uid', 'modality', 'file_id'], ARRAY['compare_series'], 'posda_files', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('GetPatientMappingExperimental', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  date_shift,
  ''<'' || diagnosis_date || ''>'' as diagnosis_date,
  ''<'' || baseline_date || ''>'' as baseline_date,
  ''<'' || date_trunc(''year'', diagnosis_date) || ''>'' as year_of_diagnosis,
  baseline_date - diagnosis_date as computed_shift
from
  patient_mapping
  ', '{}', 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift', 'diagnosis_date', 'baseline_date', 'year_of_diagnosis', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('SsWithClosedContoursWithNoLinkage', 'select 
  distinct project_name as collection,
  site_name as site, patient_id, series_instance_uid, file_id
from ctp_file natural join file_patient natural join file_series 
where project_name = ? and visibility is null
  and file_id in (
  select distinct file_id from file_structure_set where structure_set_id in (
    select distinct structure_set_id from roi where roi_id in (
      select distinct roi_id from roi_contour where roi_contour_id in (
        select distinct roi_id from roi r where exists (
          select * from roi_contour c where r.roi_id = c.roi_id and geometric_type = ''CLOSED_PLANAR'') 
          and roi_id in (     
            select distinct roi_id from roi r where not exists (
              select * from file_roi_image_linkage l where l.roi_id = r.roi_id
            )
         )
       )
     )
   )
)', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'series_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('NonDicomFileInPosdaByScanPathValue', 'select 
  distinct posda_file_id as file_id, non_dicom_file_type as type, ''<'' ||non_dicom_path || ''>'' as path,
  ''<'' || value || ''>'' as q_value
from
  non_dicom_path_value_occurrance natural join
  non_dicom_path_seen natural join
  value_seen natural join
  non_dicom_file_scan natural join
  phi_non_dicom_scan_instance
where 
  phi_non_dicom_scan_instance_id = ? and 
  file_type = ? and 
  non_dicom_path = ? and 
  value = ?
order by type, path, q_value', ARRAY['scan_id', 'file_type', 'non_dicom_path', 'value'], 
                    ARRAY['file_id', 'type', 'path', 'q_value', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('DuplicateSopsInSeriesExperimental', 'select 
  sop_instance_uid, first_f as early_file, last_f as late_file
from (
  select 
    distinct sop_instance_uid, min(file_id) as first_f, max(file_id) as last_f
  from
     file_series natural join file_sop_common natural join ctp_file
  where
     series_instance_uid = ? and visibility is null
  group by sop_instance_uid
) as foo
where first_f < last_f', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'early_file', 'late_file'], ARRAY['by_series', 'dup_sops', 'ACRIN-FMISO-Brain Duplicate Elimination'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('DeleteFilterFromTab', 'delere from query_tabs_query_tag_filter
where query_tab_name = ? and filter_name = ?', ARRAY['query_tab_name', 'filter_name'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tabs'], 'posda_queries', 'Remove a filter from a tab')
        ;

            insert into queries
            values ('GetSeriesWithImageByCollectionSiteDateRange', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series natural join file_sop_common
  natural join file_patient
  natural join file_image natural join ctp_file
  natural join file_import natural join import_event
where project_name = ? and site_name = ? and visibility is null
  and import_time > ? and import_time < ?
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('GetAllFilesAndDigests', 'select 
  received_file_path, file_digest
from 
  request

', '{}', 
                    ARRAY['received_file_path', 'digest'], ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Get all files with digests in backlog')
        ;

            insert into queries
            values ('GetSeriesWithImageByCollectionSite', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series natural join file_sop_common
  natural join file_patient
  natural join file_image natural join ctp_file
  natural join file_import natural join import_event
where project_name = ? and site_name = ? and visibility is null
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('DispositionsVersusChanges', 'select 
  element_sig_pattern, tag_name, element_seen_id, private_disposition, when_changed, new_disposition
from element_seen natural join element_disposition_changed 
order by element_sig_pattern, when_changed', '{}', 
                    ARRAY['element_sig_pattern', 'tag_name', 'element_seen_id', 'private_disposition', 'when_changed', 'new_disposition'], ARRAY['tag_usage', 'used_in_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('PatientsWithNoCtpLike', 'select
  distinct patient_id,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files,
  min(import_time) as first_import,
  max(import_time) as last_import
from
  file_patient sc natural join file_series
  natural join file_import natural join import_event
where
  not exists (select file_id from ctp_file c where sc.file_id = c.file_id) and patient_id like ?
group by patient_id;', ARRAY['patient_match'], 
                    ARRAY['patient_id', 'num_series', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('FilesIdsInSeriesWithVisibility', 'select
  file_id, visibility
from
  ctp_file
  natural join file_series
where
  series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'visibility'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('DoseLinkageToPlanByCollectionSite', 'select
  sop_instance_uid as referencing_dose,
  rt_dose_referenced_plan_uid as referenced_plan
from
  rt_dose natural join file_dose natural join file_sop_common natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['referencing_dose', 'referenced_plan'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages', 'dose_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('CountsByCollectionLikeDateRangePlus', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name like ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['from', 'to', 'collection_like'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DistinctVrByScan', 'select 
  distinct vr, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? 
group by vr', ARRAY['scan_id'], 
                    ARRAY['vr', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('SubjectsWithDupSops', 'select
  distinct collection, site, patient_id, count(*)
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(*) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'count'], ARRAY['duplicates', 'dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('UpdateDicomEditCompareDispositionStatus', 'update dicom_edit_compare_disposition set
  current_disposition = ?,
  last_updated = now()
where
  subprocess_invocation_id = ?
', ARRAY['current_disposition', 'subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Update status of an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('GetVisualReviewInstanceId', 'select currval(''visual_review_instance_visual_review_instance_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Get Id of Visual Review Instance')
        ;

            insert into queries
            values ('GetSeriesByPatId', 'select
  distinct series_instance_uid, count(distinct file_id) as num_files
from
  file_series natural join file_patient natural join ctp_file
where
  patient_id = ? and
  visibility is null
group by series_instance_uid', ARRAY['patient_id'], 
                    ARRAY['series_instance_uid', 'num_files'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'See if ctp_file_row exists')
        ;

            insert into queries
            values ('FileStorageTotalBytes', 'select
  sum(size) as total_bytes
from file
', '{}', 
                    ARRAY['total_bytes'], ARRAY['AllCollections', 'postgres_stats', 'database_size'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('ShowAllHideEventsByCollectionSite', 'select
  file_id,
  user_name,
  time_of_change,
  prior_visibility,
  new_visibility,
  reason_for
from
   file_visibility_change 
where file_id in (
  select file_id 
  from ctp_file 
  where project_name = ? and site_name = ? 
)', ARRAY['collection', 'site'], 
                    ARRAY['file_id', 'user_name', 'time_of_change', 'prior_visibility', 'new_visibility', 'reason_for'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('CreateActivity', 'insert into activity(brief_description, when_created, who_created) values (
?, now(), ?);', ARRAY['description', 'user'], 
                    '{}', ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetSsReferencingKnownImages', 'select
  project_name as collection,
  site_name as site,
  patient_id, file_id
from
  ctp_file natural join file_patient
where file_id in (
  select
    distinct ss_file_id as file_id 
  from (
    select
      sop_instance_uid, ss_file_id 
    from (
      select 
        distinct
           linked_sop_instance_uid as sop_instance_uid,
           file_id as ss_file_id
      from
        file_roi_image_linkage
    ) foo left join file_sop_common using(sop_instance_uid)
    join ctp_file using(file_id)
  where
    visibility is null
  ) as foo
)
order by collection, site, patient_id, file_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('SeriesInHierarchyBySeriesWithFileTypeModality', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  count(distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  dicom_file natural join 
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
group by collection, site, patient_id, 
  study_instance_uid, series_instance_uid,
  dicom_file_type, modality
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('FindUnpopulatedPetsWithCount', 'select
  file_id, root_path || ''/'' || rel_path as file_path
from file_location natural join file_storage_root
where file_id in
(
  select distinct file_id from dicom_file df
  where dicom_file_type = ''Positron Emission Tomography Image Storage''
  and not exists (select file_id from file_pt_image pti where pti.file_id = df.file_id)
)
limit ?', ARRAY['n'], 
                    ARRAY['file_id', 'file_path'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Get''s all files which are PET''s which haven''t been imported into file_pt_image yet.<br>

Ok to run this interactively, but use small n')
        ;

            insert into queries
            values ('SubjectLoadDaysByCollection', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
  and collection = ?
group by collection, site, subj, time order by time desc, collection, site, subj', ARRAY['interval_type', 'from', 'to', 'collection'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['find_series', 'for_tracy', 'backlog_round_history'], 'posda_backlog', 'Get List of Series by Subject Name')
        ;

            insert into queries
            values ('InsertIntoPatientMappingBaselineBatch', 'insert into patient_mapping(
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  diagnosis_date,
  baseline_date) values (
  ?, ?, ?, ?, ?, ?, ?, ?)', ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'insert_pat_mapping'], 'posda_files', 'Make an entry into the patient_mapping table with batch, diagnosis_date, and baseline_date')
        ;

            insert into queries
            values ('CreateNonDicomPathSeen', 'insert into non_dicom_path_seen(
  non_dicom_file_type,
  non_dicom_path
) values (
  ?, ?
)', ARRAY['non_dicom_file_type', 'non_dicom_path'], 
                    '{}', ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('DuplicateSopsInSeriesDistinct', 'select
  distinct sop_instance_uid,
  count(distinct file_id) as num_files,
  min(import_time) as earliest,
  max(import_time) as latest
from 
  file_sop_common
  natural join file_import natural join import_event
where sop_instance_uid in (
select sop_instance_uid from (
select
  distinct sop_instance_uid, count(distinct file_id) 
from
  file_sop_common natural join file_series natural join ctp_file
where
  series_instance_uid = ? and visibility is null
group by sop_instance_uid
) as foo
where count > 1
)
group by sop_instance_uid
order by sop_instance_uid', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'num_files', 'earliest', 'latest'], ARRAY['by_series', 'dup_sops'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('FindInconsistentSeriesWithSubjectAndStudy', 'select distinct patient_id, study_instance_uid, series_instance_uid
from file_patient natural join file_study natural join file_series
where series_instance_uid in (
select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name = ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
)', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['consistency', 'find_series', 'for_bill_series_consistency'], 'posda_files', 'Find Inconsistent Series
')
        ;

            insert into queries
            values ('SubjectCountsDateRangeSummaryByCollectionSite', 'select 
  distinct patient_id,
  min(import_time) as from,
  max(import_time) as to,
  count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops
from 
  ctp_file natural join 
  file_sop_common natural join
  file_patient natural join 
  file_import natural join 
  import_event
where
  project_name = ? and site_name = ? and visibility is null
group by patient_id
order by patient_id', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'from', 'to', 'num_files', 'num_sops'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('CreateTableSequenceIndex', 'insert into sequence_index(
  scan_element_id, sequence_level, item_number
) values (?, ?, ?)
', ARRAY['scan_element_id', 'sequence_level', 'item_number'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create Table Sequence Id')
        ;

            insert into queries
            values ('GetRoiIdFromFileIdRoiNum', 'select
  roi_id
from
  roi natural join structure_set natural join file_structure_set
where 
  file_id =? and roi_num = ?', ARRAY['file_id', 'roi_num'], 
                    ARRAY['roi_id'], ARRAY['NotInteractive', 'used_in_processing_structure_set_linkages'], 'posda_files', 'Get the file_storage root for newly created files')
        ;

            insert into queries
            values ('PixelTypesWithGeo', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration,
  iop
from
  image natural join image_geometry
order by photometric_interpretation
', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'planar_configuration', 'iop'], ARRAY['find_pixel_types', 'image_geometry', 'posda_files'], 'posda_files', 'Get distinct pixel types with geometry
')
        ;

            insert into queries
            values ('UpdateCollectionBacklogPrio', 'update
  collection_count_per_round
set
  file_count = ?
where
  collection = ?

', ARRAY['priority', 'collection'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Update the priority of a collection in a backlog ')
        ;

            insert into queries
            values ('InboxEmailToUsername', 'select user_name
from user_inbox
where user_email_addr = ?

', ARRAY['user_email_addr'], 
                    ARRAY['user_name'], ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Convert an email address to a username')
        ;

            insert into queries
            values ('GetPublicSopsForCompareCollectionLike', 'select
  i.patient_id,
  i.study_instance_uid,
  s.series_instance_uid,
  sop_instance_uid,
  sop_class_uid,
  s.modality,
  i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp,
  general_series s
where  
  i.trial_dp_pk_id = tdp.trial_dp_pk_id 
  and tdp.project like ?
  and i.general_series_pk_id = s.general_series_pk_id', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_uri'], ARRAY['public_posda_counts'], 'public', 'Generate a long list of all unhidden SOPs for a collection in public<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('FinishActivityTaskStatus', 'update activity_task_status set
  status_text = ?,
  expected_remaining_time = null,
  end_time = now(),
  last_updated = now()
where
  activity_id = ? and
  subprocess_invocation_id = ?', ARRAY['status_text', 'activity_id', 'subprocess_invocation_id'], 
                    '{}', ARRAY['NotInteractive', 'Update'], 'posda_files', 'Update status_text and end_timee in activity_task_status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewedInSeriesNew', 'select 
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from (
  select 
    distinct project_name as collection,
    site_name as site,
    patient_id,
    series_instance_uid,
    dicom_file_type,
    modality,
    review_status,
    processing_status,
    visibility,
    file_id
  from 
    dicom_file natural join 
    file_series natural join 
    file_patient natural join
    ctp_file natural join 
  (
    select file_id, review_status, processing_status
    from
      image_equivalence_class_input_image natural join
      image_equivalence_class join
      ctp_file using(file_id)
    where
      series_instance_uid = ?
  ) as foo
) as foo
where
  visibility is null and 
  review_status != ''Good'' and
  review_status != ''PassThrough''
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'visibility', 'file_id'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('DistinctVisibleFileReportByPatient', 'select distinct
  project_name as collection, site_name as site, patient_id, study_instance_uid,
  series_instance_uid, sop_instance_uid, dicom_file_type, modality, file_id
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
  natural join dicom_file natural join ctp_file
where
  patient_id = ? and visibility is null
order by series_instance_uid', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_type', 'modality', 'file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetFilePath', 'select
  root_path || ''/'' || rel_path as path
from
  file_location natural join file_storage_root
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['path'], ARRAY['AllCollections', 'universal', 'public_posda_consistency'], 'posda_files', 'Get path to file by id')
        ;

            insert into queries
            values ('SeriesWithDupSops', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, count(*)
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(*) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, study_instance_uid, series_instance_uid
', '{}', 
                    ARRAY['collection', 'site', 'subj_id', 'count', 'study_instance_uid', 'series_instance_uid'], ARRAY['duplicates'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('IncrementSimpleSeriesScanned', 'update phi_scan_instance set
  num_series_scanned = num_series_scanned + 1
where
  phi_scan_instance_id = ?', ARRAY['id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Increment series scanned')
        ;

            insert into queries
            values ('FindingImportEvent', 'select
  import_event_id, import_time, count(distinct file_id) as num_files
from import_event natural join file_import
where import_event_id in (
  select distinct import_event_id from import_event natural join file_import
  where file_id in (
    select file_id from file_patient where patient_id = ?
  )
) group by import_event_id, import_time order by import_time desc limit 100', ARRAY['patient_id'], 
                    ARRAY['import_event_id', 'import_time', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('SummaryOfToFilesForPatient', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_date,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  visibility,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  ctp_file natural join
  file_patient natural join
  file_sop_common natural join
  file_study natural join
  file_series natural join
  dicom_file
where file_id in (
  select
    file_id 
  from
    file_patient natural left join ctp_file
  where
    patient_id  = ? and visibility is null
  )
group by collection, site, patient_id, study_date, study_instance_uid, 
  series_instance_uid, dicom_file_type, modality, visibility
order by collection, site, patient_id, study_date, study_instance_uid, modality', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_date', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'visibility', 'num_sops', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'patient_queries'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Normally there should be no file_id (i.e. file has not been imported)')
        ;

            insert into queries
            values ('GetSeriesByVisualReviewIdWithNullStatus', 'select 
  distinct series_instance_uid
from
  image_equivalence_class
where
  visual_review_instance_id = ? and review_status is null', ARRAY['visual_review_instance_id'], 
                    ARRAY['series_instance_uid'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of Series By Visual Review Id and Status
')
        ;

            insert into queries
            values ('ListOfCollectionsAndSites', 'select
    project_name,
	site_name,
	count(*) 
from 
	ctp_file 
where
  visibility is null

group by project_name, site_name
order by project_name, site_name', '{}', 
                    ARRAY['project_name', 'site_name', 'count'], ARRAY['AllCollections', 'universal'], 'posda_files', 'Get a list of collections and sites

optimized by Quasar on 2018-08-08')
        ;

            insert into queries
            values ('FilesByModalityByCollectionSiteIntake', 'select
  distinct i.patient_id, modality, s.series_instance_uid, sop_instance_uid, dicom_file_uri
from
  general_image i, trial_data_provenance tdp, general_series s
where
  s.general_series_pk_id = i.general_series_pk_id and 
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and 
  modality = ? and
  tdp.project = ? and 
  tdp.dp_site_name = ?', ARRAY['modality', 'project_name', 'site_name'], 
                    ARRAY['patient_id', 'modality', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_uri'], ARRAY['FindSubjects', 'intake', 'FindFiles'], 'intake', 'Find All Files with given modality in Collection, Site on Intake
')
        ;

            insert into queries
            values ('MultifileImportsExceptEdits', 'select
  distinct import_type, import_comment, import_time,
  count(distinct import_event_id) as num_imports, sum(num_files) as total_files
from (
  select * from (
    select
      distinct import_event_id, import_time, import_type, import_comment, count(distinct file_id) as num_files 
    from
      import_event natural join file_import
    where import_time > ? and import_time < ?
    group by import_event_id, import_time, import_type, import_comment order by import_time desc
  ) as foo
  where num_files > 1 and import_comment not like ''%dicom_edit_compare%''
) as foo
group by import_type, import_time, import_comment', ARRAY['from', 'to'], 
                    ARRAY['import_type', 'import_comment', 'num_imports', 'import_time', 'total_files'], ARRAY['downloads_by_date', 'import_events'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('SetDciodvfyScanInstanceNumScanned', 'update dciodvfy_scan_instance set
  scanned_so_far = ?
where
  dciodvfy_scan_instance_id = ?', ARRAY['scanned_so_far', 'dciodvfy_scan_instance_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('PublicSeriesByCollectionVisibilityMetadata', 'select
  p.patient_id as PID,
  s.modality as Modality,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions,
   count(distinct  i.sop_instance_uid) as Images
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and 
  tdp.project = ? and
  s.visibility = ?
group by PID, StudyDate, Modality
', ARRAY['collection', 'visibility'], 
                    ARRAY['PID', 'Modality', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions', 'Images'], ARRAY['public'], 'public', 'List of all Series By Collection, Site on Public with metadata
')
        ;

            insert into queries
            values ('PatientIdMappingByFromPatientId', 'select
  from_patient_id, to_patient_id, to_patient_name, collection_name, site_name,
  batch_number, diagnosis_date, baseline_date, date_shift, uid_root
from 
  patient_mapping
where
  from_patient_id = ?', ARRAY['from_patient_id'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'uid_root'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('TagLocations', 'select
  query_tab_name,
  filter_name, 
  tag
from (
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
where tag = ?', ARRAY['tag'], 
                    ARRAY['query_tab_name', 'filter_name', 'tag'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FindingImageProblem', 'select
  distinct dicom_file_type, project_name,  
  patient_id, min(import_time), max(import_time), count(distinct file_id) 
from
  ctp_file natural join dicom_file natural join
  file_patient natural join file_import natural join 
  import_event 
where file_id in (
  select file_id 
  from (
    select file_id, image_id 
    from pixel_location left join image using(unique_pixel_data_id)
    where file_id in (
      select
         distinct file_id from file_import natural join import_event natural join dicom_file
      where import_time > ''2018-09-17''
    )
  ) as foo where image_id is null
) 
and visibility is null
group by dicom_file_type, project_name, patient_id
order by patient_id', '{}', 
                    ARRAY['dicom_file_type', 'project_name', 'patient_id', 'min', 'max', 'count'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('ListOfPrivateElementsFromDD', 'select
  pt_signature as tag,
  pt_consensus_vr as vr,
  pt_consensus_vm as vm,
  pt_consensus_name as name
from
  pt', '{}', 
                    ARRAY['tag', 'vr', 'vm', 'name'], ARRAY['ElementDisposition'], 'posda_private_tag', 'Get List of Private Tags from DD')
        ;

            insert into queries
            values ('GetFilePathWithCollSitePatientStudySeries', 'select
  root_path || ''/'' || rel_path as path,
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_location natural join file_storage_root natural join
  ctp_file natural join file_patient natural join file_study natural join file_series
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['path', 'collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['AllCollections', 'universal', 'public_posda_consistency'], 'posda_files', 'Get path to file by id')
        ;

            insert into queries
            values ('GetHiddenFilesBySeriesAndVisualReviewId', 'select
  file_id
from ctp_file
where visibility is not null and file_id in (
  select
    file_id
  from
    image_equivalence_class natural join image_equivalence_class_input_image
  where
    visual_review_instance_id = ? and series_instance_uid = ?
)', ARRAY['visual_review_instance_id', 'series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['signature', 'phi_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of files which are hidden by series id and visual review id')
        ;

            insert into queries
            values ('GetNotQualifiedCTQPByLikeCollectionSiteWithNoFiles', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id p
where collection like ? and site = ? and not qualified and
  not exists (select file_id from file_patient f where f.patient_id = p.patient_id)
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('UpdateUserBoundVariable', 'update user_variable_binding set
  bound_value = ?
where
  binding_user = ?
  and bound_variable_name = ?
 ', ARRAY['value', 'user', 'variable_name'], 
                    ARRAY['user', 'variable', 'binding'], ARRAY['AllCollections', 'queries', 'activity_support', 'variabler_binding'], 'posda_queries', 'Get list of variables with bindings for a user')
        ;

            insert into queries
            values ('ListSrPosdaHidden', 'select 
  distinct project_name as collection, site_name as site,
  patient_id, study_instance_uid, series_instance_uid,
  file_id, root_path || ''/'' || rel_path as file_path
from
  dicom_file natural join file_patient natural join file_series
  natural join file_study natural join ctp_file
  join file_location using (file_id) natural join file_storage_root
where
  visibility is not null and dicom_file_type like ''%SR%'' and
  project_name like ?', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'file_id', 'file_path'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'view_structured_reports'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetDciodvfyWarningNonStd', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''NonStandardAttribute''
  and warning_tag = ?
  and warning_desc = ?
  and warning_iod = ?

 ', ARRAY['warning_tag', 'warning_desc', 'warning_iod'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionWithFIleCountAndLoadTimes', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join import_event using(import_event_id)
where collection like ?
group by collection, site, patient_id, qualified', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PatientStudySopCountByCollectionSite', 'select 
  distinct patient_id, study_instance_uid, 
  count(distinct sop_instance_uid) as num_sops
from 
  ctp_file natural join 
  file_sop_common natural join
  file_patient natural join 
  file_study
where
  project_name = ? and site_name = ? and visibility is null
group by patient_id, study_instance_uid
order by patient_id', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'num_sops'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'For every patient in collection site, get a list of studies with a count of distinct SOPs in each study')
        ;

            insert into queries
            values ('HowManyRowsInCopyFromPublic', 'select
  count(*) as num_copies_total
from file_copy_from_public c
where
  c.copy_from_public_id = ? ', ARRAY['copy_from_public_id'], 
                    ARRAY['num_copies_total'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ImageFrameOfReferenceBySeriesPosda', 'select 
  distinct for_uid, count(*) as num_files
from
  file_series natural join file_sop_common natural join file_for natural join ctp_file
where 
  series_instance_uid = ? and visibility is null
group by for_uid', ARRAY['series_instance_uid'], 
                    ARRAY['for_uid', 'num_files'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('PatientDetailsWithBlankCtp', 'select
  distinct project_name as collection,
  site_name as site,
  visibility,
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where
  project_name = ''UNKNOWN'' and visibility is null
group by
  project_name, site_name, visibility, 
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  project_name, site_name, patient_id, study_date,
  modality
', '{}', 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('DistinctPatientStudySeriesByCollectionSite', 'select distinct
  patient_id, 
  study_instance_uid,
  series_instance_uid, 
  dicom_file_type,
  modality, 
  count(distinct file_id) as num_files
from
  ctp_file
  natural join dicom_file
  natural join file_study
  natural join file_series
  natural join file_patient
where
  project_name = ? and
  site_name = ? and
  visibility is null
group by
  patient_id, 
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality
  ', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('FilesByCollectionSitePatientWithVisibility', 'select
  distinct
  file_id,
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  sop_instance_uid,
  file_id,
  visibility
from
  ctp_file
  join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
where 
  project_name = ?
  and site_name = ?
  and patient_id = ?', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'visibility'], ARRAY['hide_events'], 'posda_files', 'Get List of files for Collection, Site with visibility')
        ;

            insert into queries
            values ('ShowAllHideEventsByCollectionSiteAlt', 'select
 distinct
  user_name,
  date_trunc(''hour'',time_of_change) as hour_of_change,
  prior_visibility,
  new_visibility,
  reason_for,
  count(distinct file_id) as num_files
from
   file_visibility_change 
where file_id in (
  select file_id 
  from ctp_file 
  where project_name = ? and site_name = ?
  and visibility = ''hidden'' 
)
group by user_name, hour_of_change, prior_visibility, new_visibility, reason_for', ARRAY['collection', 'site'], 
                    ARRAY['user_name', 'hour_of_change', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('PrivateTagsWhichArentMarked', 'select 
  distinct 
  element_seen_id as id, 
  element_sig_pattern,
  vr,
  tag_name,
  private_disposition as disp
from
  element_seen
where
  is_private is null and 
  element_sig_pattern like ''%"%''
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name', 'disp'], ARRAY['tag_usage', 'simple_phi', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('GetCurrentAdverseFileEvent', 'select currval(''adverse_file_event_adverse_file_event_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Get current dicom_edit_event_id
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('RelinquishControlPosdaImport', 'update import_control
set status = ''idle'',
  processor_pid =  null,
  pending_change_request = null', '{}', 
                    '{}', ARRAY['NotInteractive', 'PosdaImport'], 'posda_files', 'relese control of posda_import')
        ;

            insert into queries
            values ('TagsSeenSimple', 'select
  element_sig_pattern, vr, is_private, private_disposition, tag_name
from
  element_seen order by element_sig_pattern', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'is_private', 'private_disposition', 'tag_name'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi_simple', 'Get all the data from tags_seen in posda_phi_simple database
')
        ;

            insert into queries
            values ('GetDicomObjectTypeBySeries', 'select 
  distinct 
  dicom_file_type as dicom_object_type
from dicom_file natural join file_series natural join ctp_file 
where series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['dicom_object_type'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('GetContourImageLinksByFileId', 'select
  distinct roi_id,
  linked_sop_instance_uid as sop_instance_uid,
  linked_sop_class_uid as sop_class_uid,
  contour_type,
  count(distinct contour_digest) as num_contours,
  sum(num_points) as num_points
from
 file_roi_image_linkage
where file_id = ?
group by roi_id, linked_sop_instance_uid, linked_sop_class_uid, contour_type', ARRAY['file_id'], 
                    ARRAY['roi_id', 'sop_instance_uid', 'sop_class_uid', 'contour_type', 'num_contours', 'num_points'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('PixelTypes', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  coalesce(number_of_frames,1) > 1 as is_multi_frame,
  pixel_representation,
  planar_configuration,
  modality,
  dicom_file_type,
  count(distinct file_id)
from
  image natural join file_image natural join file_series
  natural join dicom_file
group by
  photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  is_multi_frame,
  pixel_representation,
  planar_configuration,
  modality,
  dicom_file_type
order by
  count desc', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'is_multi_frame', 'pixel_representation', 'planar_configuration', 'modality', 'dicom_file_type', 'count'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('GetDciodvfyErrorInvalidEleLen', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''InvalidElementLength''
  and error_tag = ?
  and error_value = ?
  and error_subtype = ?
  and error_reason = ?
  and error_index = ?
', ARRAY['error_tag', 'error_value', 'error_subtype', 'error_reason', 'error_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_tag where error_type = ''InvalidElementLength''')
        ;

            insert into queries
            values ('DistinctSeriesByPatientId', 'select distinct 
  project_name as collection, site_name as site, patient_id, study_instance_uid,
  series_instance_uid, dicom_file_type, modality, count(distinct file_id)
from
  file_study natural join file_series natural join
  file_patient natural join
  dicom_file natural join ctp_file
where
  patient_id = ? and visibility is null
group by 
  collection, site, patient_id, study_instance_uid,
  series_instance_uid, dicom_file_type, modality
', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'modality', 'dicom_file_type', 'count'], ARRAY['dciodvfy', 'select_for_phi', 'visual_review_selection', 'activity_timepoint_support'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('FilesInSeriesWithVisibility', 'select
  distinct root_path || ''/'' || rel_path as file
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_series
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('GetSeriesBasedOnErrorId', 'select 
  distinct unit_uid as series_instance_uid
from 
  dciodvfy_unit_scan natural join dciodvfy_unit_scan_error
where
  dciodvfy_error_id = ?
order by dciodvfy_error_id', ARRAY['dciodvfy_error_id'], 
                    ARRAY['series_instance_uid'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'find series for a particular dciodvfy_error')
        ;

            insert into queries
            values ('GetFilePathPublic', 'select
 dicom_file_uri as path
from
  general_image
where
  sop_instance_uid = ?', ARRAY['sop_instance_uid'], 
                    ARRAY['path'], ARRAY['AllCollections', 'universal', 'public_posda_consistency'], 'public', 'Get path to file by id')
        ;

            insert into queries
            values ('DistinctUnhiddenFilesInSeries', 'select
  distinct file_id
from
  file_series natural join file_sop_common natural join ctp_file
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['by_series_instance_uid', 'file_ids', 'posda_files'], 'posda_files', 'Get Distinct Unhidden Files in Series
')
        ;

            insert into queries
            values ('FindInconsistentStudy', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name = ? and visibility is null
    group by
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'for_bill_study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('BackgroundersByDateRangeWithInvoker', 'select
  distinct operation_name, invoking_user, count(distinct subprocess_invocation_id) as num_invocations
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null and operation_name is not null and
  when_script_started > ? and when_script_ended < ? and
  when_script_ended is not null
group by operation_name, invoking_user
order by num_invocations desc', ARRAY['from', 'to'], 
                    ARRAY['operation_name', 'invoking_user', 'num_invocations'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetSsByFileId', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id
from
  ctp_file natural join file_patient natural join file_structure_set
where file_id = ? and visibility is null', ARRAY['file_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('ShowImportsBySopInstance', 'select 
  file_id, import_time, import_comment 
from 
  import_event natural join file_import 
where file_id in (
  select file_id from file_sop_common where sop_instance_uid = ?
)
order by import_time', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'import_time', 'import_type', 'import_comment'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionByHourNoSeriesOrPatient', 'select 
  distinct project_name as collection,
  site_name as site,
  date_trunc(''hour'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, 
  count (distinct patient_id) as num_patients,
  count (distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files,
  count (distinct series_instance_uid) as num_series
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_patients', 'num_series', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events', 'show_hidden'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionPublicTest', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
group by series_instance_uid, modality', ARRAY['project_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'intake', 'compare_collection_site', 'simple_phi'], 'public', 'Get Series in A Collection, Site
')
        ;

            insert into queries
            values ('FindDuplicatedPixelDigests', 'select
  distinct pixel_digest, num_files
from (
  select
    distinct digest as pixel_digest, count(distinct file_id) as num_files
  from
    file_image
    join image using(image_id)
    join unique_pixel_data using (unique_pixel_data_id)
  group by digest
) as foo
where num_files > 3
order by num_files desc

', '{}', 
                    ARRAY['pixel_digest', 'num_files'], ARRAY['meta', 'test', 'hello'], 'posda_files', 'Find Duplicated Pixel Digest')
        ;

            insert into queries
            values ('BackgroundProcessStatsWithInvokerNullComand', 'select
  distinct operation_name, command_executed, invoking_user as invoker, 
  max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null and operation_name is null
group by operation_name, command_executed, invoker', '{}', 
                    ARRAY['operation_name', 'command_executed', 'invoker', 'longest', 'shortest', 'avg', 'times_invoked', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('FilesInStudy', 'select
  distinct root_path || ''/'' || rel_path as path, 
  sop_instance_uid, modality
from
  file_location natural join file_storage_root 
  natural join ctp_file natural join file_series
  natural join file_sop_common
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition'], 'posda_files', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('FilesByPatientForApplicationOfPrivateDisposition', 'select
  distinct root_path || ''/'' || rel_path as path, 
  sop_instance_uid, modality
from
  file_location natural join file_storage_root 
  natural join ctp_file natural join file_series
  natural join file_patient
  natural join file_sop_common
where
 patient_id = ? and visibility is null
', ARRAY['patient_id'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition', 'edit_files'], 'posda_files', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('GetSubProcessInvocationId', 'select currval(''subprocess_invocation_subprocess_invocation_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Get the id of the subprocess_invocation row just created')
        ;

            insert into queries
            values ('UpdPosdaPhiSimplePrivDisp', 'update
  element_seen
set
  private_disposition = ?
where
  element_sig_pattern = ? and
  vr = ?

', ARRAY['private_disposition', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Update name_chain in element_seen')
        ;

            insert into queries
            values ('GetImageGeoBySop', 'select 
  distinct sop_instance_uid, iop as image_orientation_patient,
  ipp as image_position_patient,
  pixel_spacing,
  pixel_rows as i_rows,
  pixel_columns as i_columns
from
  file_sop_common join
  ctp_file using(file_id) join
  file_patient using (file_id) join
  file_image using (file_id) join 
  file_series using (file_id) join
  file_study using (file_id) join
  image using (image_id) join
  file_image_geometry using (file_id) join
  image_geometry using (image_geometry_id) 
where 
  sop_instance_uid = ? and visibility is null
', ARRAY['sop_instance_uid'], 
                    ARRAY['sop_instance_uid', 'image_orientation_patient', 'image_position_patient', 'pixel_spacing', 'i_rows', 'i_columns'], ARRAY['LinkageChecks', 'BySopInstance'], 'posda_files', 'Get Geometric Information by Sop Instance UID from posda')
        ;

            insert into queries
            values ('GetPatientStatus', 'select
  patient_import_status as status
from
  patient_import_status
where
  patient_id = ?
', ARRAY['patient_id'], 
                    ARRAY['status'], ARRAY['NotInteractive', 'PatientStatus', 'Update'], 'posda_files', 'Get Patient Status')
        ;

            insert into queries
            values ('GetVisualReviewStatusBothCountsById', 'select 
  distinct review_status, processing_status, count(distinct series_instance_uid) as num_series
from
  image_equivalence_class
where
  visual_review_instance_id = ?
group by review_status, processing_status', ARRAY['visual_review_instance_id'], 
                    ARRAY['review_status', 'processing_status', 'num_series'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of Series By Visual Review Id and Status
')
        ;

            insert into queries
            values ('ValueSeenByElementSeen', 'select value from value_seen where value_seen_id in (
  select  value_seen_id
  from element_value_occurance
where
    element_seen_id in (
      select element_seen_id
      from
        element_seen
      where
        element_sig_pattern = ?
    )
)', ARRAY['element_sig_pattern'], 
                    ARRAY['value'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('ValuesByVr', 'select distinct value, count(*) from (
  select
    distinct value, element_signature, vr
  from
    scan_event natural join series_scan natural join seen_value
    natural join element_signature natural join scan_element
  where
    scan_event_id = ? and vr = ?
) as foo
group by value
order by value
', ARRAY['scan_id', 'vr'], 
                    ARRAY['value', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('GetSiteCodes', 'select
  site_name, site_code
from
  site_codes
  ', '{}', 
                    ARRAY['site_name', 'site_code'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('ListOpenActivitiesWithItemCount', 'select
  distinct activity_id,
  brief_description,
  when_created,
  who_created,
  count(distinct user_inbox_content_id) as num_items
from
  activity natural left join activity_inbox_content
where when_closed is null
group by activity_id, brief_description, when_created, who_created
order by activity_id desc', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'num_items'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('PatientDetailsWithNoCtp', 'select
  distinct 
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series f
where
  patient_id = ?
  and not exists (select file_id from ctp_file c where c.file_id = f.file_id)
group by
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  patient_id, study_date,
  modality
', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_details'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('InsertPublicDisposition', 'insert into public_disposition(
  element_signature_id, sop_class_uid, name, disposition
) values (
  ?, ?, ?, ?
)

', ARRAY['element_signature_id', 'sop_class_uid', 'name', 'disposition'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Insert a public disposition')
        ;

            insert into queries
            values ('GetPhiNonDicomScanInstanceById', 'select
  phi_non_dicom_scan_instance_id,
  pndsi_description as description,
  pndsi_start_time as start_time,
  pndsi_num_files as num_files,
  pndsi_num_files_scanned as num_files_scanned,
  pndsi_end_time as end_time
from
  phi_non_dicom_scan_instance
where
  phi_non_dicom_scan_instance_id = ?', ARRAY['phi_non_dicom_scan_instance_id'], 
                    ARRAY['phi_non_dicom_scan_instance_id', 'description', 'start_time', 'num_files', 'num_files_scanned', 'end_time'], ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('RecordElementDispositionChangeSimple', 'insert into element_disposition_changed(
  element_seen_id,
  when_changed,
  who_changed,
  why_changed,
  new_disposition
) values (
  ?, now(), ?, ?, ?)', ARRAY['id', 'who', 'why', 'disp'], 
                    '{}', ARRAY['tag_usage', 'simple_phi', 'used_in_phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('StudyConsistency', 'select distinct
  study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag, count(*)
from
  file_study natural join ctp_file
where study_instance_uid = ? and visibility is null
group by
  study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag
', ARRAY['study_instance_uid'], 
                    ARRAY['study_instance_uid', 'count', 'study_description', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'phys_of_record', 'phys_reading', 'admitting_diag'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Check a Study for Consistency
')
        ;

            insert into queries
            values ('UpdateCopyInformation', 'update copy_from_public set 
  status_of_copy = ?,
  pid_of_running_process = ?
where copy_from_public_id = ?', ARRAY['status_of_copy', 'pid_of_running_process', 'copy_from_public_id'], 
                    '{}', ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PatientStatusCounts', 'select
  distinct project_name as collection, patient_import_status as status,
  count(distinct patient_id) as num_patients
from
  patient_import_status natural join file_patient natural join ctp_file
where
  visibility is null
group by collection, status
order by collection, status
', '{}', 
                    ARRAY['collection', 'status', 'num_patients'], ARRAY['FindSubjects', 'PatientStatus'], 'posda_files', 'Find All Subjects which have at least one visible file
')
        ;

            insert into queries
            values ('DuplicatePixelDataByProject', 'select image_id, file_id
from file_image where image_id in (
  select image_id
  from (
    select distinct image_id, count(*)
    from (
      select distinct image_id, file_id 
      from file_image
      where file_id in (
        select
          distinct file_id 
        from ctp_file
        where project_name = ? and visibility is null
      )
    ) as foo
    group by image_id
  ) as foo
  where count > 1
)
order by image_id;
', ARRAY['collection'], 
                    ARRAY['image_id', 'file_id'], ARRAY['pixel_duplicates'], 'posda_files', 'Return a list of files with duplicate pixel data
')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionLikePatient', 'select distinct patient_id, series_instance_uid, modality, count(*)
from (
select distinct patient_id, series_instance_uid, sop_instance_uid, modality from (
select
   distinct patient_id, series_instance_uid, modality, sop_instance_uid,
   file_id
 from file_series natural join file_sop_common natural join file_patient
   natural join ctp_file
where
  project_name = ? and patient_id like ?
  and visibility is null)
as foo
group by patient_id, series_instance_uid, sop_instance_uid, modality)
as foo
group by patient_id, series_instance_uid, modality
', ARRAY['project_name', 'patient_id_like'], 
                    ARRAY['patient_id', 'series_instance_uid', 'modality', 'count'], ARRAY['by_collection', 'find_series'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('RoiWithForAndFileIdByCollectionSite', 'select
  distinct for_uid, roi_num, roi_name, file_id
from
  roi natural join file_structure_set natural join ctp_file
where 
  project_name = ? and site_name = ? and visibility is null
order by file_id, for_uid', ARRAY['collection', 'site'], 
                    ARRAY['for_uid', 'roi_num', 'roi_name', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSite', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ?
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetFilesWithNoStudyInfoByCollection', 'select
  file_id,
  root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location
where file_id in (
select 
  distinct file_id
from 
 ctp_file c
where
  project_name = ? and 
  visibility is null and 
  not exists (
    select
      file_id 
    from
      file_study s 
    where
      s.file_id = c.file_id
  )
)', ARRAY['collection'], 
                    ARRAY['file_id', 'path'], ARRAY['reimport_queries', 'dicom_file_type'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('GetDupContourCountsExtended', 'select
  project_name as collection,
  site_name as site,
  patient_id,
  file_id,
  num_dup_contours
from (
  select 
    distinct file_id, count(*) as num_dup_contours
  from
    file_roi_image_linkage 
  where 
    contour_digest in (
    select contour_digest
    from (
      select 
        distinct contour_digest, count(*)
      from
        file_roi_image_linkage group by contour_digest
    ) as foo
    where count > 1
  ) group by file_id 
) foo join ctp_file using (file_id) join file_patient using(file_id)
order by num_dup_contours desc', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'num_dup_contours'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dup_contours'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('FindInconsistentSeriesIgnoringTimeCollectionLike', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name like ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection_like'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series', 'series_consistency'], 'posda_files', 'Find Inconsistent Series by Collection Site
')
        ;

            insert into queries
            values ('SummaryOfToFiles', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_date,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  visibility,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  ctp_file natural join
  file_patient natural join
  file_sop_common natural join
  file_study natural join
  file_series natural join
  dicom_file
where file_id in (
  select
    file_id 
  from
    file f, dicom_edit_compare dec 
  where
    f.digest = dec.to_file_digest and dec.subprocess_invocation_id = ?
  )
group by collection, site, patient_id, study_date, study_instance_uid, 
  series_instance_uid, dicom_file_type, modality, visibility
order by collection, site, patient_id, study_date, study_instance_uid, modality', ARRAY['subprocess_invocation_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_date', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'visibility', 'num_sops', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'patient_queries'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Normally there should be no file_id (i.e. file has not been imported)')
        ;

            insert into queries
            values ('PosdaTotalsHidden', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files,
    sum(total_sops) as total_sops
from (
  select
    distinct project_name, site_name, patient_id,
    count(*) as num_studies, sum(num_series) as num_series, 
    sum(total_files) as total_files,
    sum(total_sops) as total_sops
  from (
    select
       distinct project_name, site_name, patient_id, 
       study_instance_uid, count(*) as num_series,
       sum(num_sops) as total_sops,
       sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid,
        count(distinct file_id) as num_files,
        count(distinct sop_instance_uid) as num_sops
      from (
        select
          distinct project_name, site_name, patient_id,
          study_instance_uid, series_instance_uid, sop_instance_uid,
          file_id
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common
           natural join file_patient
        where
          visibility = ''hidden''
      ) as foo
      group by
        project_name, site_name, patient_id, 
        study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', '{}', 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files', 'total_sops'], '{}', 'posda_files', 'Get totals of files hidden in Posda
')
        ;

            insert into queries
            values ('VisualReviewStatusByCollection', 'select 
  distinct series_instance_uid, visibility, review_status, modality, series_description,
  series_date, count(distinct image_equivalence_class_id) as num_equiv_classes, 
  count(distinct file_id) as num_files
from
  image_equivalence_class natural join
  image_equivalence_class_input_image natural join
  file_series natural join ctp_file
where
  project_name = ? and visibility is null and review_status = ?
group by series_instance_uid, visibility, review_status, modality, series_description, series_date;', ARRAY['collection', 'review_status'], 
                    ARRAY['series_instance_uid', 'review_status', 'visibility', 'modality', 'series_description', 'series_date', 'num_equiv_classes', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('SopInstanceFilePathCountAndLoadTimesBySeries', 'select
  distinct sop_instance_uid, file_id,
  root_path || ''/'' || file_location.rel_path as path,
  min(import_time) as first_loaded,
  count(distinct import_time) as times_loaded,
  max(import_time) as last_loaded
from
  file_location
  natural join file_storage_root
  join file_import using(file_id)
  join import_event using (import_event_id)
  natural join file_sop_common
  natural join file_series
where series_instance_uid = ?
group by sop_instance_uid, file_id, path
order by sop_instance_uid, first_loaded', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'file_id', 'path', 'first_loaded', 'times_loaded', 'last_loaded'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send', 'for_comparing_dups', 'dup_sops'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('GetPosdaQueueSize', 'select
 count(*) as num_files
from
  file 
where
  is_dicom_file is null and
  ready_to_process and
  processing_priority is not null

', '{}', 
                    ARRAY['num_files'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_files', 'Get size of queue  in Posda
Removed by Quasar on 2018-11-25. Results are not identical but it is more than 500 times faster
NATURAL JOIN file_location NATURAL JOIN file_storage_root')
        ;

            insert into queries
            values ('PosdaPublicDifferenceReportByEditId', 'select
  distinct short_report_file_id, long_report_file_id, count(distinct sop_instance_uid) as num_files
from public_to_posda_file_comparison
where compare_public_to_posda_instance_id =?
group by short_report_file_id, long_report_file_id order by short_report_file_id', ARRAY['compare_public_to_posda_instance_id'], 
                    ARRAY['short_report_file_id', 'long_report_file_id', 'num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('LookUpTag', 'select
  tag, name, keyword, vr, vm, is_retired, comments
from 
  dicom_element
where
  name = ? or
  keyword = ?', ARRAY['name', 'keyword'], 
                    ARRAY['tag', 'name', 'keyword', 'vr', 'vm', 'is_retired', 'comments'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'dicom_dd', 'Get tag from name or keyword')
        ;

            insert into queries
            values ('SeriesListByStudyInstanceUid', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality, 
  dicom_file_type, 
  count(distinct file_id) as num_files
from 
  file_patient natural join
  file_series natural join
  file_study natural join
  dicom_file natural join
  ctp_file
where 
  study_instance_uid = ?
  and visibility is null
group by 
  collection,
  site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality,
  dicom_file_type;', ARRAY['study_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'series_date', 'series_description', 'modality', 'dicom_file_type', 'num_files'], ARRAY['find_series', 'for_tracy'], 'posda_files', 'Get List of Series by Study Instance UID')
        ;

            insert into queries
            values ('NumEquipSigsForTagSigs', 'select distinct element_signature, count(*) from (
select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ?) as foo
group by element_signature
order by element_signature
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'Number of Equipment signatures in which tags are featured
')
        ;

            insert into queries
            values ('FilesWithIndicesByElementScanId', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, sequence_level,
  item_number
from
  series_scan natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  scan_element_id = ?
', ARRAY['scan_element_id'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'sequence_level', 'item_number'], ARRAY['tag_usage'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('ShowFilesHiddenByUserDateRange', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  reason_for as reason,
  prior_visibility as before,
  new_visibility as after,
  min(time_of_change) as earliest,
  max(time_of_change) as latest,
  count(distinct file_id) as num_files
from 
  file_visibility_change natural join
  file_patient natural join
  file_study natural join
  file_series natural join 
  ctp_file
where
  user_name = ? and
  time_of_change > ? and time_of_change < ?
group by
   collection, site, 
   patient_id, study_instance_uid,
   series_instance_uid, reason, before, after
order by
  patient_id, study_instance_uid, series_instance_uid', ARRAY['user', 'from', 'to'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'reason', 'before', 'after', 'num_files', 'earliest', 'latest'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'old_hidden'], 'posda_files', 'Show Files Hidden By User Date Range')
        ;

            insert into queries
            values ('GlobalUnhiddenSOPDuplicatesSummary', 'select 
  distinct project_name as collection, site_name as site, patient_id,
  study_instance_uid, series_instance_uid,
  sop_instance_uid, min(import_time) as first_upload, max(import_time) as
  last_upload, count(distinct file_id) as num_dup_sops,
  count(*) as num_uploads from (
select
  distinct project_name as collection,
  site_name as site, patient_id,
  study_instance_uid, series_instance_uid, sop_instance_uid, file_id
from file_sop_common natural join ctp_file natural join file_patient
  natural join file_study natural join file_series
where visibility is null and sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
      select distinct file_id, sop_instance_uid 
      from
        ctp_file natural join file_sop_common
        natural join file_study natural join file_series
        natural join file_patient
      where visibility is null
    ) as foo
    group by sop_instance_uid order by count desc
  ) as foo where count > 1
) group by project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid, sop_instance_uid, file_id
) as foo
natural join file_sop_common natural join file_series natural join file_study
natural join ctp_file natural join file_patient natural join file_import
natural join import_event
group by project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid,
  sop_instance_uid
order by project_name, site_name, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'num_dup_sops', 'num_uploads', 'first_upload', 'last_upload'], ARRAY['receive_reports'], 'posda_files', 'Return a report of visible duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('RoiInfoByFileId', 'select
  distinct roi_id, for_uid,
  max_x, max_y, max_z,
  min_x, min_y, min_z,
  roi_name, roi_description , roi_interpreted_type
from
  roi natural join file_structure_set
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['roi_id', 'for_uid', 'max_x', 'max_y', 'max_z', 'min_x', 'min_y', 'min_z', 'roi_name', 'roi_description', 'roi_interpreted_type'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('FirstFileInSeriesPublic', 'select
  dicom_file_uri as path
from
  general_image
where
  series_instance_uid =  ?
limit 1
', ARRAY['series_instance_uid'], 
                    ARRAY['path'], ARRAY['by_series', 'UsedInPhiSeriesScan', 'public'], 'public', 'First files in series in Public
')
        ;

            insert into queries
            values ('GetRoiCounts', 'select 
   distinct sop_instance_uid, count(distinct roi_id)
from 
  roi natural join structure_set natural join file_structure_set 
  join file_sop_common using(file_id)
group by sop_instance_uid
order by count desc
', '{}', 
                    ARRAY['sop_instance_uid', 'count'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of ROI''s in a structure Set

')
        ;

            insert into queries
            values ('GetZipUploadEventsByDateRangeNonDicomOnly', 'select distinct import_event_id, import_time, count (distinct file_id) as num_files from (
  select import_event_id, file_id, import_time, rel_path, file_type
  from file_import natural join import_event join file using(file_id)
  where import_time > ? and import_time < ? and import_comment = ''zip''
  and (rel_path like ''%.docx'' or rel_path like ''%.xls'' or rel_path like ''%.xlsx'' or rel_path like ''%.csv'')
) as foo
group by import_event_id, import_time', ARRAY['from', 'to'], 
                    ARRAY['import_event_id', 'num_files'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ChangeFileStorageRootIdByFileIdAndOldStorageRootId', 'update
  file_location
set file_storage_root_id = ?
where file_storage_root_id = ?
and file_id = ?', ARRAY['new_file_storage_root_id', 'old_file_storage_root_id', 'file_id'], 
                    '{}', ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get root_path for a file_storage_root
')
        ;

            insert into queries
            values ('DoesDoseReferenceGoodPlan', 'select
  sop_instance_uid
from
  file_sop_common fsc, rt_dose d natural join file_dose f
where
  f.file_id = ? and d.rt_dose_referenced_plan_uid = fsc.sop_instance_uid', ARRAY['file_id'], 
                    ARRAY['sop_instance_uid'], ARRAY['LinkageChecks', 'used_in_dose_linkage_check'], 'posda_files', 'Determine whether an RTDOSE references a known plan

')
        ;

            insert into queries
            values ('DciodvfyErrorIdsBySeriesAndScanInstance', 'select                                                    
  dciodvfy_error_id
from dciodvfy_error 
where  dciodvfy_error_id in (
  select distinct dciodvfy_error_id
  from (
    select
      distinct unit_uid, dciodvfy_error_id
    from
      dciodvfy_unit_scan
      natural join dciodvfy_unit_scan_error
    where
      dciodvfy_scan_instance_id = ? and unit_uid =?
  )
 as foo
)', ARRAY['dciodvfy_scan_instance_id', 'series_instance_uid'], 
                    ARRAY['dciodvfy_error_id'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('PrivateTagUsage', 'select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ? and is_private
order by element_signature;
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'equipment_signature'], ARRAY['tag_usage'], 'posda_phi', 'Which equipment signatures for which private tags
')
        ;

            insert into queries
            values ('GetDosesAndPlanReferences', 'select
  sop_instance_uid as dose_referencing,
  rt_dose_referenced_plan_uid as plan_referenced
from
  rt_dose natural join file_dose join file_sop_common using (file_id)', '{}', 
                    ARRAY['dose_referencing', 'plan_referenced'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get list of dose and plan sops where dose references plan
')
        ;

            insert into queries
            values ('CountsByCollectionSiteDateRangePlus', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name = ? and site_name = ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['from', 'to', 'collection', 'site'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DupSopsByCollectionDateRange', 'select
  distinct collection, site, subj_id, 
  sop_instance_uid,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid 
      from (
        select distinct sop_instance_uid, count(distinct file_id)
        from file_sop_common natural join ctp_file
        where visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from file_sop_common natural join ctp_file
            join file_import using(file_id) 
            join import_event using(import_event_id)
          where project_name = ?  and
             visibility is null and import_time > ?
              and import_time < ?
        ) group by sop_instance_uid
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, sop_instance_uid

', ARRAY['collection', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj_id', 'sop_instance_uid', 'num_files'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'check_dups'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('GetPosdaFileIdByDigest', 'select
 file_id
from
  file
where
  digest = ?

', ARRAY['digest'], 
                    ARRAY['file_id'], ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Get posda file id of file by file_digest')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSitePublic', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and tdp.dp_site_name = ?
group by series_instance_uid, modality', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'intake', 'compare_collection_site', 'simple_phi'], 'public', 'Get Series in A Collection, Site
')
        ;

            insert into queries
            values ('GetLoadWeeks', 'select 
  distinct load_week from (
  select 
    distinct file_id, date_trunc(''week'', min(import_time)) as load_week
  from 
    file_import natural join import_event
  where
    import_time >= ? and import_time < ?
  group by file_id
) as foo 
order by load_week;', ARRAY['from', 'to'], 
                    ARRAY['load_week'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('InsertEditImportEvent', 'insert into import_event(
  import_type, import_comment, import_time
) values (
  ?, ?, now()
)', ARRAY['import_type', 'import_comment'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Insert an Import Event for an Edited File')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionByHour', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  date_trunc(''hour'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, patient_id, series_instance_uid, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events', 'show_hidden'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('RoundCountsByCollection2', 'select
  round_id, collection,
  round_created,
  round_start,  
  round_end,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where collection = ?
order by round_id, collection', ARRAY['collection'], 
                    ARRAY['round_id', 'collection', 'num_dups', 'round_created', 'round_start', 'round_end', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('ListOfRepeatingPrivateElementsFromDD', 'select
  ptrg_signature_masked as tag,
  ptrg_base_grp as base_grp,
  ptrg_grp_mask as id_mask,
  ptrg_grp_ext_mask as ext_mask,
  ptrg_grp_ext_shift as ext_shift,
  ptrg_consensus_vr as vr,
  ptrg_consensus_vm as vm,
  ptrg_consensus_name as name 
from ptrg', '{}', 
                    ARRAY['tag', 'base_grp', 'id_mask', 'ext_mask', 'ext_shift', 'vr', 'vm', 'name'], ARRAY['ElementDisposition'], 'posda_private_tag', 'Get List of Repeating Private Tags from DD')
        ;

            insert into queries
            values ('FinalizeComparePublicToPosdaInstance', 'update compare_public_to_posda_instance set
  status_of_compare = ''Comparisons In Progress'',
  when_compare_completed = now(),
  last_updated = now()
where
  compare_public_to_posda_instance_id = ?
', ARRAY['compare_public_to_posda_instance_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('GetSsReferencingUnknownImagesByCollection', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, series_instance_uid, file_id
from
  ctp_file natural join file_patient natural join file_series
where file_id in (
select
  distinct ss_file_id as file_id from 
(select
  sop_instance_uid, ss_file_id 
from (
  select 
    distinct linked_sop_instance_uid as sop_instance_uid, file_id as ss_file_id
  from
    file_roi_image_linkage
  ) foo left join file_sop_common using(sop_instance_uid)
  where
  file_id is null
) as foo
)
and project_name = ? and visibility is null
order by collection, site, patient_id, file_id
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetDciodvfyErrorUncat', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''Uncategorized''
  and error_text = ?', ARRAY['error_text'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('GetDciodvfyErrorInvalidValueForVr', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''InvalidValueForVr''
  and error_tag = ? and
  error_index = ? and
  error_value = ? and
  error_reason = ? and
  error_subtype = ?
', ARRAY['error_tag', 'error_index', 'error_value', 'error_reason', 'error_desc'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_tag where error_type = ''InvalidValueForVr''')
        ;

            insert into queries
            values ('HideEvents', 'select
  distinct date_trunc(''day'', time_of_change) as when_done, 
  reason_for,
  user_name, 
  count(*) as num_files
from
  file_visibility_change
group by when_done, reason_for, user_name
order by when_done desc', '{}', 
                    ARRAY['when_done', 'reason_for', 'user_name', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SimplePhiReportAllMetaQuotes', 'select 
  distinct ''<'' || element_sig_pattern || ''>'' as element, vr, 
  ''<'' || value || ''>'' as q_value, tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ?
group by element_sig_pattern, vr, value, description
order by vr, element, q_value
', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'q_value', 'description', 'num_series'], ARRAY['adding_ctp', 'for_scripting', 'phi_reports'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('CreateBackgroundReport', 'insert into background_subprocess_report(
  background_subprocess_id,
  file_id,
  name
) values (
  ?, ?, ?
)
returning background_subprocess_report_id
', ARRAY['background_subprocess_id', 'file_id', 'name'], 
                    NULL, ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create a new entry in background_subprocess_report table')
        ;

            insert into queries
            values ('PublicCollectionCounts', 'select
        tdp.project as Collection,''|'',
        group_concat(distinct s.modality) as Modalities,''|'',
        count(distinct p.patient_id) as Pts,''|'',
        count(distinct t.study_instance_uid) as Studies,''|'',
        count(distinct s.series_instance_uid) as Series,''|'',
        count(distinct i.sop_instance_uid) as Images, ''|'',
        format(sum(i.dicom_size)/1000000000,1) as GBytes
 
     from
        general_image i,
        general_series s,
        study t,
        patient p,
        trial_data_provenance tdp
 
     where
        i.general_series_pk_id = s.general_series_pk_id and
        s.study_pk_id = t.study_pk_id and
        t.patient_pk_id = p.patient_pk_id and
        p.trial_dp_pk_id = tdp.trial_dp_pk_id and
        tdp.project =? and
        s.visibility = ?
 
     group by tdp.project', ARRAY['collection', 'visibility'], 
                    ARRAY['Collection', 'Modalities', 'Pts', 'Studies', 'Series', 'Images', 'GBytes'], ARRAY['AllCollections', 'DateRange', 'Kirk', 'Totals', 'count_queries', 'end_of_month'], 'public', 'Get public totals for collection

Used to fill in "Detailed description" on public Wiki page

')
        ;

            insert into queries
            values ('PatientIdMappingByToPatientId', 'select
  from_patient_id, to_patient_id, to_patient_name, collection_name, site_name,
  batch_number, diagnosis_date, baseline_date, date_shift, uid_root,
  baseline_date - diagnosis_date + interval ''1 day'' as computed_shift,
  site_code
from 
  patient_mapping
where
  to_patient_id = ?', ARRAY['to_patient_id'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'uid_root', 'computed_shift', 'site_code'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('ListActivities', 'select
  activity_id,
  brief_description,
  when_created,
  who_created,
  when_closed
from
  activity
order by activity_id desc', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('CreateNonDicomFileChangeRow', 'insert into non_dicom_file_change(
  file_id, file_type, file_sub_type, collection, site, subject, visibility, when_categorized,
  when_recategorized, who_recategorized, why_recategorized)
values(
  ?, ?, ?, ?, ?, ?, ?, ?,
  now(), ?, ?
)
', ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized', 'who', 'why'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SimplePhiReportPrivateOnlyByScanVrScreenDeletedPT', 'select 
  distinct element_sig_pattern as element, vr, value, 
  tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and vr = ? and
  is_private and
  private_disposition in (''k'', ''oi'', ''h'', ''o'')
group by element_sig_pattern, vr, value, tag_name', ARRAY['scan_id', 'vr'], 
                    ARRAY['element', 'vr', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('FindingFilesWithImageProblem', 'select file_id, root_path || ''/'' || rel_path as path
from (
  select file_id, image_id 
  from pixel_location left join image using(unique_pixel_data_id)
  where file_id in (
    select
       distinct file_id from file_import natural join import_event natural join dicom_file
    where import_time > ''2018-09-17''
  )
) as foo natural join ctp_file natural join file_location natural join file_storage_root
where image_id is null and visibility is null
', '{}', 
                    ARRAY['file_id', 'path'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('GetDciodvfyUnitScanErrorId', 'select currval(''dciodvfy_unit_scan_error_dciodvfy_unit_scan_error_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('FilesIdsVisibleInSeries', 'select
  distinct file_id
from
  file_series natural join file_sop_common natural join ctp_file
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['by_series_instance_uid', 'file_ids', 'posda_files'], 'posda_files', 'Get Distinct Unhidden Files in Series
')
        ;

            insert into queries
            values ('RequestShutdown', 'update control_status
  set pending_change_request = ''shutdown'',
  source_pending_change_request = ''DbIf'',
  request_time = now()', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'request a shutdown of Backlog processing')
        ;

            insert into queries
            values ('GetPixelPaddingInfo', 'select
  distinct modality, pixel_pad, slope, intercept, manufacturer, 
  image_type, pixel_representation as signed, count(*)
from                                           
  file_series natural join file_equipment natural join 
  file_slope_intercept natural join slope_intercept natural join file_image natural join image
where                                                 
  modality = ''CT''
group by 
  modality, pixel_pad, slope, intercept, manufacturer, image_type, signed
', '{}', 
                    ARRAY['modality', 'pixel_pad', 'slope', 'intercept', 'manufacturer', 'image_type', 'signed', 'count'], ARRAY['PixelPadding'], 'posda_files', 'Get Pixel Padding Summary Info
')
        ;

            insert into queries
            values ('ListHiddenFilesByCollectionPatient', 'select
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id,
  visibility as old_visibility
from
  ctp_file natural join
  file_patient natural join
  file_series
where
  visibility is not null and
  project_name = ? and
  patient_id = ?', ARRAY['collection', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id', 'old_visibility'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'old_visibility'], 'posda_files', 'Show Received before date by collection, site')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionPublic', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
group by series_instance_uid, modality', ARRAY['project_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'public'], 'public', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('DciodvfyErrorsStringBySeriesAndScanInstance', 'select                                                    
  dciodvfy_error_id || ''|'' ||
  error_type || ''|'' ||                                                                                                                                                                                                                   
  error_tag || ''|'' ||
  coalesce(error_value, ''[null]'') || ''|'' ||
  coalesce(error_subtype, ''[null]'') || ''|'' ||
  coalesce(error_module, ''[null]'') || ''|'' ||
  coalesce(error_reason, ''[null]'') || ''|'' ||
  coalesce(error_index, ''[null]'') || ''|'' ||
  coalesce(error_text, ''[null]'') as error_string
from dciodvfy_error 
where  dciodvfy_error_id in (
  select distinct dciodvfy_error_id
  from (
    select
      distinct unit_uid, dciodvfy_error_id
    from
      dciodvfy_unit_scan
      natural join dciodvfy_unit_scan_error
    where
      dciodvfy_scan_instance_id = ? and unit_uid =?
  )
 as foo
)', ARRAY['dciodvfy_scan_instance_id', 'series_instance_uid'], 
                    ARRAY['error_string'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('DistinctSeriesByImportEventByPatLike', 'select
  distinct series_instance_uid, count(distinct file_id) as num_files
from (
  select distinct series_instance_uid, file_id 
  from file_series 
  where file_id in (
    select
      distinct file_id from file_import where import_event_id in (select import_event_id from (
        select
          distinct import_event_id, import_time,  import_type, count(distinct file_id) as num_files
        from
          import_event natural join file_import natural join file_patient
        where
          import_type = ''multi file import'' and
          patient_id like ?
         group by import_event_id, import_time, import_type
       ) as foo
    )
  )
)as foo
group by series_instance_uid
', ARRAY['patient_id_like'], 
                    ARRAY['series_instance_uid', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetSeriesWithSignature', 'select distinct
  series_instance_uid, dicom_file_type, 
  modality|| '':'' || coalesce(manufacturer, ''<undef>'') || '':'' 
  || coalesce(manuf_model_name, ''<undef>'') ||
  '':'' || coalesce(software_versions, ''<undef>'') as signature,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from
  file_series natural join file_equipment natural join ctp_file
  natural join dicom_file
where project_name = ? and visibility is null
group by series_instance_uid, dicom_file_type, signature
', ARRAY['collection'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'signature', 'num_series', 'num_files'], ARRAY['signature'], 'posda_files', 'Get a list of Series with Signatures by Collection
')
        ;

            insert into queries
            values ('SeriesByNotLikeDescriptionAndCollectionSite', 'select distinct
  series_instance_uid, series_description
from
  file_series natural join ctp_file
where 
  project_name = ? and site_name = ? and 
  visibility is null and
  series_description not like ?
', ARRAY['collection', 'site', 'pattern'], 
                    ARRAY['series_instance_uid', 'series_description'], ARRAY['find_series'], 'posda_files', 'Get a list of Series by Collection, Site not matching Series Description
')
        ;

            insert into queries
            values ('HideEventInfo', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  count(distinct file_id) as num_files
from 
  ctp_file natural join
  file_series natural join 
  file_patient
where file_id in (
select
  distinct file_id
from
  file_visibility_change
where
  date_trunc(''day'', time_of_change) = ? and
  reason_for = ? and
  user_name = ?
)
group by
  collection, site, patient_id, series_instance_uid
order by
  collection, site, patient_id, series_instance_uid', ARRAY['day_of_change', 'reason_for', 'user_name'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SeriesInHierarchyBySeriesExtended', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_description,
  series_date,
  modality,
  count(distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
group by
  collection, site, patient_id, study_instance_uid, study_date,
  study_description, series_instance_uid, series_description,
  series_date, modality
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'series_description', 'series_date', 'modality', 'num_files'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('DupSopsByCollection', 'select distinct sop_instance_uid, min(latest) as earliest, max(latest) as latest
from (
  select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo
group by sop_instance_uid', ARRAY['collection'], 
                    ARRAY['sop_instance_uid', 'earliest', 'latest'], ARRAY['meta', 'test', 'hello', 'bills_test', 'check_dups'], 'posda_files', 'List of duplicate sops with file_ids and latest load date')
        ;

            insert into queries
            values ('GetSimpleSeriesScanId', 'select currval(''series_scan_instance_series_scan_instance_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Get id of newly created series_scan_instance')
        ;

            insert into queries
            values ('AddPhiSimpleElement', 'insert into element_seen (
  element_sig_pattern,
  vr,
  is_private,
  private_disposition,
  tag_name
) values (
  ?, ?, ?, ?, ?
)
', ARRAY['element_signature', 'vr', 'is_private', 'private_disposition', 'name_chain'], 
                    '{}', ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Add an element_seen row to posda_phi_simple')
        ;

            insert into queries
            values ('CreateFileSend', 'insert into dicom_file_send(
  dicom_send_event_id, file_path, status, file_id_sent
) values (
  ?, ?, ?, ?
)
', ARRAY['id', 'path', 'status', 'file_id'], 
                    NULL, ARRAY['NotInteractive', 'SeriesSendEvent'], 'posda_files', 'Add a file send row
For use in scripts.
Not meant for interactive use
')
        ;

            insert into queries
            values ('GetEditStatus', 'select
  subprocess_invocation_id as id,
  start_creation_time, end_creation_time - start_creation_time as duration,
  number_edits_scheduled as to_edit,
  number_compares_with_diffs as changed,
  number_compares_without_diffs as not_changed,
  current_disposition as disposition,
  dest_dir
from
  dicom_edit_compare_disposition
order by start_creation_time desc', '{}', 
                    ARRAY['id', 'start_creation_time', 'duration', 'to_edit', 'changed', 'not_changed', 'disposition', 'dest_dir'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits', 'testing_edit_objects', 'edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('CreateBackgroundInputLine', 'insert into background_input_line(
  background_subprocess_id,
  line_number,
  line
) values (
  ?, ?, ?
)', ARRAY['background_subprocess_id', 'param_index', 'param_value'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create row in background_input_line table

Used by background subprocess')
        ;

            insert into queries
            values ('PhiNonDicomScanStatusInProgress', 'select 
   phi_non_dicom_scan_instance_id as id,
   pndsi_description as description,
   pndsi_start_time as start_time,
   pndsi_num_files as num_files_to_scan,
   pndsi_num_files_scanned as num_files_scanned,
   now() - pndsi_start_time as time_running
from
  phi_non_dicom_scan_instance
where pndsi_end_time is null
order by start_time', '{}', 
                    ARRAY['id', 'description', 'start_time', 'num_files_to_scan', 'num_files_scanned', 'time_running'], ARRAY['tag_usage', 'non_dicom_phi_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('SeriesWithExactlyNEquivalenceClasses', 'select series_instance_uid, count from (
select distinct series_instance_uid, count(*) from image_equivalence_class group by series_instance_uid) as foo where count = ?', ARRAY['count'], 
                    ARRAY['series_instance_uid', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency'], 'posda_files', 'Find Series with exactly n equivalence classes')
        ;

            insert into queries
            values ('GetPosdaFilesImportControl', 'select
  status,
  processor_pid,
  idle_seconds,
  pending_change_request,
  files_per_round
from
  import_control', '{}', 
                    ARRAY['status', 'processor_pid', 'idle_seconds', 'pending_change_request', 'files_per_round'], ARRAY['NotInteractive', 'PosdaImport'], 'posda_files', 'Get import control status from posda_files database')
        ;

            insert into queries
            values ('AllValuesByElementSig', 'select distinct value, vr, element_signature, equipment_signature, count(*)
from (
select
  distinct series_instance_uid, element_signature, value, vr,
  equipment_signature
from
  scan_event natural join series_scan
  natural join scan_element natural join element_signature
  natural join equipment_signature
  natural join seen_value
where
  scan_event_id = ? and
  element_signature = ?
) as foo
group by value, element_signature, vr, equipment_signature
order by value, element_signature, vr, equipment_signature
', ARRAY['scan_id', 'tag_signature'], 
                    ARRAY['value', 'vr', 'element_signature', 'equipment_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan by ElementSignature with VR and count
')
        ;

            insert into queries
            values ('GetDicomEditCompareDisposition', 'select
  number_edits_scheduled,
  number_compares_with_diffs,
  number_compares_without_diffs,
  current_disposition,
  dest_dir
from
  dicom_edit_compare_disposition
where
  subprocess_invocation_id = ?
  ', ARRAY['subprocess_invocation_id'], 
                    ARRAY['number_edits_scheduled', 'number_compares_with_diffs', 'number_compares_without_diffs', 'current_disposition', 'dest_dir'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('SeriesCollectionSite', 'select distinct
  series_instance_uid
from
  file_series natural join ctp_file
where project_name = ? and site_name = ? and visibility is null
', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid'], ARRAY['find_series'], 'posda_files', 'Get a list of Series by Collection, Site
')
        ;

            insert into queries
            values ('GetStartOfWeek', 'select 
  date_trunc(''week'', to_timestamp(?, ''yyyy-mm-dd'')) as start_week
 ', ARRAY['from'], 
                    ARRAY['start_week'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionForHiddenFiles', 'select
  distinct project_name as collection, 
  site_name as site, patient_id,
  user_name, 
  date_trunc(''hour'',time_of_change) as time, 
  reason_for, count(*)
from
  file_visibility_change natural join
  ctp_file natural join 
  file_patient natural join 
  file_series
where
  project_name = ? and
  visibility is not null
group by collection, site, patient_id, user_name, time, reason_for
order by time, collection, site, patient_id', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'user_name', 'time', 'reason_for', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files', 'old_hidden'], 'posda_files', 'Show Received before date by collection, site')
        ;

            insert into queries
            values ('CreateSubprocessInvocationButton', 'insert into subprocess_invocation (
  from_spreadsheet,
  from_button,
  query_invoked_by_dbif_id,
  button_name,
  command_line,
  invoking_user,
  when_invoked,
  operation_name
) values (
  false, true, ?, ?, ?, ?, now(), ?
)
returning subprocess_invocation_id
', ARRAY['query_invoked_by_dbif_id', 'btn_name', 'command_line', 'invoking_user', 'operation_name'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create a row in subprocess_invocation table

Used when invoking a spreadsheet operation from a button')
        ;

            insert into queries
            values ('InsertIntoSeriesScan', 'insert into series_scan(
  scan_event_id, equipment_signature_id, series_instance_uid,
  series_scan_status, series_scanned_file
) values (
  ?, ?, ?, ''In Process'', ?)', ARRAY['scan_id', 'equipment_signature_id', 'series_instance_uid', 'series_scanned_file'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('TestThisOne', 'select
  patient_id, patient_import_status,
  count(distinct file_id) as total_files,
  min(import_time) min_time, max(import_time) as max_time,
  count(distinct study_instance_uid) as num_studies,
  count(distinct series_instance_uid) as num_series
from
  ctp_file natural join file natural join
  file_import natural join import_event natural join
  file_study natural join file_series natural join file_patient
  natural join patient_import_status
where
  project_name = ? and site_name = ? and visibility is null
group by patient_id, patient_import_status
', ARRAY['project_name', 'site_name', 'PatientStatus'], 
                    ARRAY['patient_id', 'patient_import_status', 'total_files', 'min_time', 'max_time', 'num_studies', 'num_series'], '{}', 'posda_files', '')
        ;

            insert into queries
            values ('ListOfPrivateElementsWithNullDispositions', 'select
  distinct element_signature, vr , private_disposition as disposition,
  element_signature_id, name_chain
from
  element_signature natural join scan_element natural join series_scan
where
  is_private and private_disposition is null
order by element_signature
', '{}', 
                    ARRAY['element_signature', 'vr', 'disposition', 'element_signature_id', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('ImportEventsByMatchingNameAndType', 'select
  import_event_id, import_type,
  import_comment, import_time, import_close_time - import_time as duration, 
  count(distinct file_id) as num_images
from 
  import_event natural join file_import
where
  import_comment like ? and import_type like ?
group by import_event_id, import_type, import_comment, import_time, import_close_time', ARRAY['import_comment_like', 'import_type_like'], 
                    ARRAY['import_event_id', 'import_type', 'import_comment', 'import_time', 'duration', 'num_images'], ARRAY['import_events'], 'posda_files', 'Get Import Events by matching comment')
        ;

            insert into queries
            values ('GetSeriesForPhiInfo', 'select 
  series_instance_uid
from 
  series_scan_instance 
where series_scan_instance_id in (
  select series_scan_instance_id 
  from element_value_occurance 
  where element_seen_id in (
    select 
      element_seen_id 
    from element_seen 
    where element_sig_pattern = ? and vr = ?
  )
  and value_seen_id in (
    select value_seen_id 
    from value_seen
    where value = ?
  )
  and phi_scan_instance_id = ?
)', ARRAY['element', 'vr', 'value', 'scan_id'], 
                    ARRAY['series_instance_uid'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Get an element_seen row by element, vr (if present)')
        ;

            insert into queries
            values ('GetElementSignature', 'select * from element_signature
  where element_signature = ? and vr = ?
', ARRAY['element_signature', 'vr'], 
                    ARRAY['element_signature_id', 'element_signature', 'is_private', 'vr'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive', 'ElementDisposition'], 'posda_phi', 'Get Element Signature By Signature (pattern) and VR')
        ;

            insert into queries
            values ('ActiveQueriesRunning', 'select 
  datname, pid,
  now() - query_start as time_query_running, 
  query
from pg_stat_activity
where
  state = ''active''
order by datname, state
', '{}', 
                    ARRAY['datname', 'pid', 'time_query_running', 'query'], ARRAY['AllCollections', 'postgres_stats', 'postgres_query_stats'], 'posda_backlog', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('AllVrsByElementSig', 'select distinct vr, element_signature, equipment_signature, count(*)
from (
select
  distinct series_instance_uid, element_signature, vr,
  equipment_signature
from
  scan_event natural join series_scan
  natural join scan_element natural join element_signature
  natural join equipment_signature
where
  scan_event_id = ? and
  element_signature = ?
) as foo
group by element_signature, vr, equipment_signature
order by element_signature, vr, equipment_signature
', ARRAY['scan_id', 'tag_signature'], 
                    ARRAY['vr', 'element_signature', 'equipment_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan by ElementSignature with VR and count
')
        ;

            insert into queries
            values ('GetListStructureSetsByCollectionSite', 'select 
  distinct project_name, site_name, patient_id, sop_instance_uid
from
  file_sop_common natural join ctp_file natural join dicom_file natural join file_patient
where
  dicom_file_type = ''RT Structure Set Storage'' and visibility is null
  and project_name = ? and site_name = ?
order by project_name, site_name, patient_id', ARRAY['collection', 'site'], 
                    ARRAY['project_name', 'patient_id', 'site_name', 'sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set List

')
        ;

            insert into queries
            values ('GetPosdaDupSopCounts', 'select sop_instance_uid, num_files from (
select distinct sop_instance_uid, count(distinct file_id) as num_files from (
select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name = ? 
  and visibility is null
) as foo group by sop_instance_uid
) as foo where num_files > 1', ARRAY['collection'], 
                    ARRAY['sop_instance_uid', 'num_files'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('DuplicateSopsInSeriesFast', 'select * from (
  select
    distinct sop_instance_uid, count(*) as num_sops
  from file_sop_common where file_id in (
    select distinct file_id
    from file_series natural join ctp_file 
    where series_instance_uid = ? and visibility is null
  ) group by sop_instance_uid
) as foo where num_sops > 1
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'num_sops'], ARRAY['by_series', 'dup_sops', 'ACRIN-FMISO-Brain Duplicate Elimination'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('SeriesReportForStructLinkageTest', 'select
  file_id, (
    select root_path 
    from file_storage_root
    where file_storage_root.file_storage_root_id = file_location.file_storage_root_id
  ) || ''/'' || rel_path as file_name,
  sop_instance_uid, sop_class_uid,
  study_instance_uid, series_instance_uid,
  for_uid, iop, ipp
from
  file_location
  natural join file_series 
  natural join file_study
  natural join file_sop_common
  left join file_image_geometry using(file_id) 
  left join image_geometry using(image_geometry_id)
where file_id in (
  select file_id from file_series natural join ctp_file
  where series_instance_uid = ?
    and visibility is null
)', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'file_name', 'sop_instance_uid', 'sop_class_uid', 'study_instance_uid', 'series_instance_uid', 'for_uid', 'iop', 'ipp'], ARRAY['by_series_instance_uid', 'duplicates', 'posda_files', 'sops', 'series_report'], 'posda_files', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('DuplicateSopsInSeries', 'select
  sop_instance_uid, import_time, file_id
from 
  file_sop_common
  natural join file_import natural join import_event
where sop_instance_uid in (
select sop_instance_uid from (
select
  distinct sop_instance_uid, count(distinct file_id) 
from
  file_sop_common natural join file_series natural join ctp_file
where
  series_instance_uid = ? and visibility is null
group by sop_instance_uid
) as foo
where count > 1
)
order by sop_instance_uid, import_time
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'import_time', 'file_id'], ARRAY['by_series', 'dup_sops', 'ACRIN-FMISO-Brain Duplicate Elimination'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('ListOfAvailableQueriesForDescEditBySchema', 'select
  name, description, query,
  array_to_string(tags, '','') as tags
from queries
where schema = ?
order by name', ARRAY['schema'], 
                    ARRAY['name', 'description', 'query', 'tags'], ARRAY['AllCollections', 'schema'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('EquivalenceClassStatusSummary', 'select 
  distinct patient_id, study_instance_uid, series_instance_uid,
  processing_status, count(*) 
from 
  image_equivalence_class natural join image_equivalence_class_input_image 
  natural join file_study natural join file_series natural join file_patient
group by 
  patient_id, study_instance_uid, series_instance_uid, processing_status
order by 
  patient_id, study_instance_uid, series_instance_uid, processing_status', '{}', 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'processing_status', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Find Series with more than n equivalence class')
        ;

            insert into queries
            values ('ElementScanIdByScanValueTag', 'select 
  distinct scan_element_id
from
  scan_element natural join element_signature
  natural join series_scan natural join seen_value
  natural join scan_event
where
  scan_event_id = ? and
  value = ? and
  element_signature = ?
', ARRAY['scan_id', 'value', 'tag'], 
                    ARRAY['scan_element_id'], ARRAY['tag_usage'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('FinalizeDciodvfyScanInstance', 'update dciodvfy_scan_instance set
  end_time = now()
where
  dciodvfy_scan_instance_id = ?', ARRAY['dciodvfy_scan_instance_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('GetEditList', 'select * from dicom_edit_event', '{}', 
                    ARRAY['dicom_edit_event_id', 'from_dicom_file', 'to_dicom_file', 'edit_desc_file', 'when_done', 'performing_user'], ARRAY['ImageEdit'], 'posda_files', 'Get list of dicom_edit_event')
        ;

            insert into queries
            values ('GetUnkQualifiedCTQPByLikeCollectionSiteWithNoFiles', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id p
where collection like ? and site = ? and qualified is null and
  not exists (select file_id from file_patient f where f.patient_id = p.patient_id)
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('RoundSummary1DateRange', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups),
  ((round_end - round_start) / sum(num_entered + num_dups)) as sec_per_file
from
  round natural join round_collection
where
  round_end is not null and round_start > ? and round_end < ?
group by 
  round_id, round_start, duration, round_end 
order by round_id', ARRAY['from', 'to'], 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum', 'sec_per_file'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('WhatHasComeInRecently', 'select
  distinct collection, site, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
group by collection, site, time order by time desc, collection, site', ARRAY['interval', 'from', 'to'], 
                    ARRAY['collection', 'site', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history', 'for_bill_counts'], 'posda_backlog', 'A query to tell you what has been recently received:<ul>
  <li>interval = ''year'' | ''month'' | ''week'' | ''day'' | ''hour'' | ''minute'' | ''sec''</li>
  <li>from = start date/time (midnight if time not included)</li>
  <li>to = end date/time (midnight if time not included)</li>
</ul>')
        ;

            insert into queries
            values ('FileNamesBySeriesAndImportId', 'select file_id, file_name
from file_import natural join import_event natural join file_series
where import_event_id = ? and series_instance_uid = ?', ARRAY['import_event_id', 'series_instance_uid'], 
                    ARRAY['file_id', 'file_name'], ARRAY['downloads_by_date', 'import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('FilesByScanValueTag', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, value, sequence_level,
  item_number
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  scan_event_id = ? and value = ? and element_signature = ?
order by series_instance_uid, file
', ARRAY['scan_id', 'value', 'tag'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'value', 'sequence_level', 'item_number'], ARRAY['tag_usage', 'phi_review'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('InboxContentAllByUser', 'select
 user_name, user_inbox_content_id as id, operation_name,
  current_status,
  activity_id, brief_description,
  when_script_started as when, 
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural left join subprocess_invocation
  natural left join spreadsheet_uploaded
  natural left join activity_inbox_content natural left join
  activity
where user_name = ?
order by user_inbox_content_id desc', ARRAY['user_name'], 
                    ARRAY['user_name', 'id', 'operation_name', 'current_status', 'activity_id', 'brief_description', 'when', 'file_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('NewSopsReceivedBetweenDatesByCollection', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
            natural join ctp_file
          where import_time > ? and import_time < ? and
            project_name = ? and visibility is null
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
where num_uploads = 1
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time', 'collection'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates with sops without duplicates
')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionNotMatchingSeriesDesc', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file natural join file_series
    where project_name = ? and visibility is null and series_description not like ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'exclude_series_descriptions_matching'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of series in a collection in a Patient, Study, Series Hierarchy excluding matching SeriesDescriptons')
        ;

            insert into queries
            values ('SummaryOfMultipleFileImportEventsWithEarliestLatestEtc', 'select 
  distinct import_type,
  min(import_time) as earliest,
  max(import_time) as latest,
  count(distinct import_event_id) as num_imports,
  sum(num_files) as total_files
from (
  select
    distinct import_event_id,
    import_time, import_type,
    import_comment,
    count(distinct file_id) as num_files
  from
    import_event natural join file_import
  group by import_event_id, import_time, import_type, import_comment
) as foo
where num_files > 1 group by import_type', '{}', 
                    ARRAY['import_type', 'earliest', 'latest', 'num_imports', 'total_files'], ARRAY['downloads_by_date', 'import_events'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DuplicateSopsInSeriesNew', 'select
  sop_instance_uid, date_trunc(''day'',import_time) as import_day, file_id
from 
  file_sop_common
  natural join file_import natural join import_event
where sop_instance_uid in (
select sop_instance_uid from (
select
  distinct sop_instance_uid, count(distinct file_id) 
from
  file_sop_common natural join file_series natural join ctp_file
where
  series_instance_uid = ? and visibility is null
group by sop_instance_uid
) as foo
where count > 1
)
order by sop_instance_uid, import_day, file_id
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'import_day', 'file_id'], ARRAY['by_series', 'dup_sops', 'ACRIN-FMISO-Brain Duplicate Elimination'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('UpdateElementDisposition', 'update element_signature set 
  private_disposition = ?,
  name_chain = ?
where
  element_signature = ? and
  vr = ?
', ARRAY['private_disposition', 'name_chain', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Update Element Disposition
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('InsertDistinguishedDigest', 'insert into distinguished_pixel_digests(
  pixel_digest,
  type_of_pixel_data,
  sample_per_pixel,
  number_of_frames,
  pixel_rows,
  pixel_columns,
  bits_stored,
  bits_allocated,
  high_bit,
  pixel_mask,
  num_distinct_pixel_values) values (
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?
);', ARRAY['pixel_digest', 'type_of_pixel_data', 'sample_per_pixel', 'number_of_frames', 'pixel_rows', 'pixel_columns', 'bits_stored', 'bits_allocated', 'high_bit', 'pixel_mask', 'num_distinct_pixel_values'], 
                    '{}', ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'insert distinguished pixel digest')
        ;

            insert into queries
            values ('GetDoses', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select distinct file_id from rt_dose d natural join file_dose)', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dose_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetUnreadInboxItems', 'select
  user_inbox_content_id,
  background_subprocess_report_id,
  current_status,
  date_entered
from user_inbox_content 
natural join user_inbox 
where date_dismissed is null
  and user_name = ?
', ARRAY['user_name'], 
                    ARRAY['user_inbox_content_id', 'background_subprocess_report_id', 'current_status', 'date_entered'], '{}', 'posda_queries', 'Get a list of unread messages from the user''s inbox.')
        ;

            insert into queries
            values ('StopTransaction', 'commit', '{}', 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('FindInconsistentStudyIgnoringStudyTimeByCollectionSite', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name = ? and site_name = ? and visibility is null
    group by
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection', 'site'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('AddHocQuery1', 'select 
  distinct project_name as collection, site_name as site, patient_id,
  study_instance_uid, series_instance_uid, dicom_file_type, modality,
  count(distinct file_id) as num_files, count(distinct sop_instance_uid) as num_sops,
  min(import_time) as earliest, max(import_time) as latest
from
  ctp_file natural join file_patient natural join dicom_file natural join file_series natural join
  file_sop_common natural join
  file_study join file_import using(file_id) join import_event using (import_event_id)
where file_id in(
  select distinct file_id from file_patient where patient_id = ''ER-1125''
) and visibility is null 
group by collection, site, patient_id, study_instance_uid, series_instance_uid, dicom_file_type, modality', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files', 'num_sops', 'earliest', 'latest'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PosdaTotalsWithHidden', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
from (
  select
    distinct project_name, site_name, patient_id, count(*) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
  from (
    select
       distinct project_name, site_name, patient_id, study_instance_uid, 
       count(*) as num_series, sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id, study_instance_uid, 
        series_instance_uid, count(*) as num_files 
      from (
        select
          distinct project_name, site_name, patient_id, study_instance_uid,
          series_instance_uid, sop_instance_uid 
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common natural join file_patient
       ) as foo
       group by
         project_name, site_name, patient_id, 
         study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
  order by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', '{}', 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], '{}', 'posda_files', 'Get total posda files including hidden
')
        ;

            insert into queries
            values ('GetSeriesWithImageByCollection', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series natural join file_sop_common
  natural join file_patient
  natural join file_image natural join ctp_file
  natural join file_import natural join import_event
where project_name = ? and visibility is null
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('AllManifests', 'select
  distinct file_id, import_time, size, root_path || ''/'' || l.rel_path as path, i.file_name as alt_path
from
  file_location l join file_storage_root using(file_storage_root_id) 
  join file_import i using (file_id) natural join file join import_event using(import_event_id)
where
  file_type like ''%ASCII%'' and
  l.rel_path like ''%/Manifests/%''
order by import_time', '{}', 
                    ARRAY['file_id', 'import_time', 'size', 'path', 'alt_path'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ListOfAvailableQueriesBySchema', 'select
  name, description,
  array_to_string(tags, '','') as tags
from queries
where schema = ?
order by name', ARRAY['schema'], 
                    ARRAY['name', 'description', 'tags'], ARRAY['AllCollections', 'schema'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetGeometricInfoPublic', 'select
  sop_instance_uid, image_orientation_patient, image_position_patient,
  pixel_spacing, i_rows, i_columns
from
  general_image
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['sop_instance_uid', 'image_orientation_patient', 'image_position_patient', 'pixel_spacing', 'i_rows', 'i_columns'], ARRAY['LinkageChecks', 'BySopInstance'], 'public', 'Get Geometric Information by Sop Instance UID from public')
        ;

            insert into queries
            values ('PatientReportDateRange', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description,
  count(distinct file_id) as num_files,
  min(import_time) as earliest_upload,
  max(import_time) as latest_upload,
  count(distinct import_event_id) as num_uploads
from
  file_patient natural join file_study natural join
  file_series natural join ctp_file natural join
  file_import natural join import_event
where
  project_name = ? and
  site_name = ? and
  patient_id = ? and
  import_time > ? and
  import_time < ? and
  visibility is null
group by 
  collection, site,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description
order by
  study_instance_uid, series_instance_uid, num_files', ARRAY['collection', 'site', 'patient_id', 'start_time', 'end_time'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_description', 'series_instance_uid', 'series_description', 'num_files', 'earliest_upload', 'latest_upload', 'num_uploads'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('InsertIntoSiteCodes', 'insert into site_codes(site_name, site_code)
values (?, ?)', ARRAY['site_name', 'site_code'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'for_scripting'], 'posda_files', 'Make an entry into the site_codes table')
        ;

            insert into queries
            values ('DupSopsReceivedBetweenDates', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   sum(num_files) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
          where import_time > ? and import_time < ?
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
where num_uploads > 1
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'num_files', 'num_uploads', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates with duplicate sops
')
        ;

            insert into queries
            values ('UpdateDicomEditCompareDisposition', 'update dicom_edit_compare_disposition set
  number_edits_scheduled = ?,
  number_compares_with_diffs = ?,
  number_compares_without_diffs = ?,
  current_disposition = ''Comparisons In Progress'',
  last_updated = now()
where
  subprocess_invocation_id = ?
', ARRAY['number_edits_scheduled', 'number_compares_with_diffs', 'number_compares_without_diffs', 'subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('InsertFileStudy', 'insert into file_study(
  file_id, study_instance_uid, study_date,
  study_time, referring_phy_name, study_id,
  accession_number, study_description, phys_of_record,
  phys_reading, admitting_diag
) values (
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?
)', ARRAY['file_id', 'study_instance_uid', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'study_description', 'phys_of_record', 'phys_reading', 'admitting_diag'], 
                    '{}', ARRAY['bills_test', 'posda_db_populate'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DismissActivityTaskStatus', 'update activity_task_status set
  dismissed_time = now(),
  dismissed_by = ?
where
  activity_id = ? and
  subprocess_invocation_id = ?', ARRAY['dismissed_by', 'activity_id', 'subprocess_invocation_id'], 
                    '{}', ARRAY['NotInteractive', 'Update'], 'posda_files', 'Update status_text and expected_completion_time in activity_task_status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetSimpleElementSeenIndex', 'select currval(''element_seen_element_seen_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Get index of newly created element_seen')
        ;

            insert into queries
            values ('SimplePhiReportAllPublicOnly', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, value, tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and not is_private
group by element_sig_pattern, vr, value, val_length, description
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetPublicFeaturesBySignature', 'select
  name, vr
from dicom_element
where tag = ?', ARRAY['element_signature'], 
                    ARRAY['name', 'vr'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive', 'ElementDisposition'], 'dicom_dd', 'Get Element Signature By Signature (pattern) and VR')
        ;

            insert into queries
            values ('GetVisualReviewStatusCountsById', 'select 
  distinct review_status, count(distinct series_instance_uid) as num_series
from
  image_equivalence_class
where
  visual_review_instance_id = ?
group by review_status', ARRAY['visual_review_instance_id'], 
                    ARRAY['review_status', 'num_series'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of Series By Visual Review Id and Status
')
        ;

            insert into queries
            values ('GetCountFilesToImportFromEdit', 'select
  count(*) as num_files
from
  dicom_edit_compare
where 
  from_file_digest in 
  (
    select from_file_digest from 
    (
      select distinct from_file_digest 
      from dicom_edit_compare dec, file f natural join ctp_file
      where dec.from_file_digest = f.digest and visibility is null and subprocess_invocation_id = ?
      intersect
      select from_file_digest from dicom_edit_compare dec
      where not exists
      (
        select file_id from file f where dec.to_file_digest = f.digest
       ) 
       and subprocess_invocation_id = ?
    ) as foo
  )
  and subprocess_invocation_id = ?
', ARRAY['command_file_id', 'command_file_id_1', 'command_file_id_2'], 
                    ARRAY['num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('AllVisibleSubjectsByCollection', 'select
  distinct patient_id,
  patient_import_status as status,
  project_name, site_name,
  count(*) as num_files
from
  file_patient natural join ctp_file natural join patient_import_status
where
  patient_id in (
    select patient_id 
    from
      file_patient natural join ctp_file 
    where
      project_name = ? and
      visibility is null
  ) and
  visibility is null
group by patient_id, status, project_name, site_name
order by project_name, status, site_name, patient_id;
', ARRAY['collection'], 
                    ARRAY['patient_id', 'status', 'project_name', 'site_name', 'num_files'], ARRAY['FindSubjects', 'PatientStatus'], 'posda_files', 'Find All Subjects which have at least one visible file
')
        ;

            insert into queries
            values ('DistinctFileReportByCollectionSite', 'select distinct
  project_name as collection, site_name as site, patient_id, study_instance_uid,
  series_instance_uid, sop_instance_uid, dicom_file_type, modality, file_id, visibility
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
  natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ?
order by series_instance_uid', ARRAY['project_name', 'site_name'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_type', 'modality', 'file_id', 'visibility'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('FindInconsistentStudyIgnoringStudyTimeIncludingPatientId', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      patient_id, study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join file_patient natural join ctp_file
    where
      project_name = ? and visibility is null
    group by
      patient_id, study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('GetPosdaSopsForCompareCollectionLike', 'select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name like ? 
  and visibility is null', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'file_path', 'file_id'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('PatientStatusChange', 'select
  patient_id, old_pat_status as from,
  new_pat_status as to, pat_stat_change_who as by,
  pat_stat_change_why as why,
  when_pat_stat_changed as when
from patient_import_status_change
where patient_id in(
  select distinct patient_id
  from file_patient natural join ctp_file
  where visibility is null
)
order by patient_id, when_pat_stat_changed
', '{}', 
                    ARRAY['patient_id', 'from', 'to', 'by', 'why', 'when'], ARRAY['PatientStatus'], 'posda_files', 'Get History of Patient Status Changes by Collection
')
        ;

            insert into queries
            values ('SeriesListBySubjectNameByDateRange', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality, 
  dicom_file_type, 
  count(distinct file_id) as num_files
from 
  file_patient natural join
  file_series natural join
  file_study natural join
  dicom_file natural join
  ctp_file join file_import using(file_id)
  join import_event using(import_event_id)
where 
  patient_id = ?
  and visibility is null
  and import_time > ? 
  and import_time < ?
group by 
  collection,
  site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality,
  dicom_file_type;', ARRAY['patient_id', 'from', 'to'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'series_date', 'series_description', 'modality', 'dicom_file_type', 'num_files'], ARRAY['find_series', 'for_tracy', 'backlog_round_history'], 'posda_files', 'Get List of Series by Subject Name')
        ;

            insert into queries
            values ('CtpFilesSummary', 'select
 distinct project_name as collection,
 trial_name,
 site_name as site,
 site_id,
 visibility,
 count(distinct file_id) as num_files
from ctp_file
group by 
  collection,
  trial_name,
  site,
  site_id,
  visibility
order by
  collection, trial_name, site, site_id, visibility', '{}', 
                    ARRAY['collection', 'trial_name', 'site', 'site_id', 'visibility', 'num_files'], ARRAY['adding_ctp'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetContoursFromRoiId', 'select
  roi_contour_id, contour_num, geometric_type, 
  number_of_points, sop_class as linked_image_sop_class,
  sop_instance as linked_image_sop_instance, 
  frame_number as linked_image_frame_number
from
  roi_contour natural left join contour_image
where roi_id = ?', ARRAY['roi_id'], 
                    ARRAY['roi_contour_id', 'contour_num', 'geometric_type', 'number_of_points', 'linked_image_sop_class', 'linked_image_sop_instance', 'linked_image_frame_number'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of ROI''s in a structure Set

')
        ;

            insert into queries
            values ('PatientStatusChangeByPatient', 'select
  patient_id, old_pat_status as from,
  new_pat_status as to, pat_stat_change_who as by,
  pat_stat_change_why as why,
  when_pat_stat_changed as when
from patient_import_status_change
where patient_id = ?
order by when
', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'from', 'to', 'by', 'why', 'when'], ARRAY['PatientStatus'], 'posda_files', 'Get History of Patient Status Changes by Patient Id
')
        ;

            insert into queries
            values ('ImageIdByFileId', 'select
  distinct file_id, image_id
from
  file_image
where
  file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_id', 'image_id'], ARRAY['by_file_id', 'image_id', 'posda_files'], 'posda_files', 'Get image_id for file_id 
')
        ;

            insert into queries
            values ('DuplicatePixelDataThatMatters', 'select image_id, count from (
  select distinct image_id, count(*)
  from (
    select distinct image_id, file_id
    from (
      select
        file_id, image_id, patient_id, study_instance_uid, 
        series_instance_uid, sop_instance_uid, modality
      from
        file_patient natural join file_series natural join 
        file_study natural join file_sop_common
        natural join file_image
      where file_id in (
        select file_id
        from (
          select image_id, file_id 
          from file_image 
          where image_id in (
            select image_id
            from (
              select distinct image_id, count(*)
              from (
                select distinct image_id, file_id
                from file_image where file_id in (
                  select distinct file_id
                  from ctp_file
                  where project_name = ? and visibility is null
                )
              ) as foo
              group by image_id
            ) as foo 
            where count > 1
          )
        ) as foo
      )
    ) as foo
  ) as foo
  group by image_id
) as foo 
where count > 1;
', ARRAY['collection'], 
                    ARRAY['image_id', 'count'], ARRAY['pixel_duplicates'], 'posda_files', 'Return a list of files with duplicate pixel data,
restricted to those files which have parsed DICOM data
representations in Database.
')
        ;

            insert into queries
            values ('TableSizePosdaFiles', 'select *, pg_size_pretty(total_bytes) AS total
    , pg_size_pretty(index_bytes) AS INDEX
    , pg_size_pretty(toast_bytes) AS toast
    , pg_size_pretty(table_bytes) AS TABLE
  FROM (
  SELECT *, total_bytes-index_bytes-COALESCE(toast_bytes,0) AS table_bytes FROM (
      SELECT c.oid,nspname AS table_schema, relname AS TABLE_NAME
              , c.reltuples AS row_estimate
              , pg_total_relation_size(c.oid) AS total_bytes
              , pg_indexes_size(c.oid) AS index_bytes
              , pg_total_relation_size(reltoastrelid) AS toast_bytes
          FROM pg_class c
          LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
          WHERE relkind = ''r''
  ) a
) a where
  table_schema = ''public'' or table_schema = ''dbif_config'' or table_schema = ''dicom_conv''
order by total_bytes desc', '{}', 
                    ARRAY['oid', 'table_schema', 'table_name', 'row_estimate', 'total_bytes', 'index_bytes', 'total', 'toast_bytes', 'index', 'toast', 'table'], ARRAY['AllCollections', 'postgres_stats', 'table_size'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('LockDicomEditCompareDisposition', 'lock dicom_edit_compare_disposition
', '{}', 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Lock table dicom_edit_compare_disposition

From script only.  Don''t run from user interface.')
        ;

            insert into queries
            values ('TagsSeenSimplePrivate', 'select
  element_sig_pattern, vr, private_disposition, tag_name
from
  element_seen
where
  is_private
order by element_sig_pattern', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'private_disposition', 'tag_name'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi_simple', 'Get all the data from tags_seen in posda_phi_simple database
')
        ;

            insert into queries
            values ('DistinctFilesByTagAndValue', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  element_signature = ? and value = ?
order by series_instance_uid, file
', ARRAY['tag', 'value'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature'], ARRAY['tag_usage'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('GetSeriesWithOutImageByCollectionSite', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series
  natural join file_sop_common
  natural join file_patient
  natural join ctp_file ctp
  natural join file_import natural join import_event
where project_name = ? and site_name = ? and visibility is null
  and not exists (select image_id from file_image fi where ctp.file_id = fi.file_id)
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('GetSsVolumeReferencingKnownImages', 'select 
  project_name as collection, 
  site_name as site, patient_id, 
  file_id 
from 
  ctp_file natural join file_patient 
where file_id in (
   select
    distinct file_id from ss_volume v 
    join ss_for using(ss_for_id) 
    join file_structure_set using (structure_set_id) 
  where 
     exists (
       select file_id 
       from file_sop_common s 
       where s.sop_instance_uid = v.sop_instance
  )
)
order by collection, site, patient_id', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('FilesWithNoCtpByPatientId', 'select
  distinct file_id
from
  file_patient p
where
  not exists(
  select file_id from ctp_file c
  where c.file_id = p.file_id
)
and patient_id = ?
', ARRAY['patient_id'], 
                    ARRAY['file_id'], ARRAY['adding_ctp'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('WhereSopSitsIntake', 'select distinct
  tdp.project as collection,
  tdp.dp_site_name as site,
  p.patient_id,
  i.study_instance_uid,
  i.series_instance_uid
from
  general_image i,
  patient p,
  trial_data_provenance tdp
where
  sop_instance_uid = ?
  and i.patient_pk_id = p.patient_pk_id
  and i.trial_dp_pk_id = tdp.trial_dp_pk_id
', ARRAY['sop_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['posda_files', 'sops', 'BySopInstance'], 'intake', 'Get Collection, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('DistinctSeriesBySubjectIntake', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.patient_id = ? and i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
group by series_instance_uid, modality
', ARRAY['subject_id', 'project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_subject', 'find_series', 'intake'], 'intake', 'Get Series in A Collection, Site, Subject
')
        ;

            insert into queries
            values ('SopsDupsInDifferentSeriesByCollectionSite', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, sop_instance_uid,
  file_id, file_path
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id, root_path ||''/'' || rel_path as file_path
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
    join file_location using(file_id) join file_storage_root using(file_storage_root_id)
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
order by sop_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'file_path'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('ImportIntoFileStudy', 'insert into file_study
  (file_id, study_instance_uid, study_date,
   study_time, referring_phy_name, study_id,
   accession_number, study_description, phys_of_record,
   phys_reading, admitting_diag)
values
  (?, ?, ?,
   ?, ?, ?,
   ?, ?, ?,
   ?, ?)
', ARRAY['file_id', 'study_instance_uid', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'study_description', 'phys_of_record', 'phys_reading', 'admitting_diag'], 
                    '{}', ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('GetUnreadInboxCount', 'select count(*) as count
from user_inbox_content 
natural join user_inbox 
where date_dismissed is null
  and user_name = ?
', ARRAY['user_name'], 
                    ARRAY['count'], '{}', 'posda_queries', 'Get a count of unread messages from the user''s inbox.')
        ;

            insert into queries
            values ('InboxContentAll', 'select
 user_name, user_inbox_content_id as id, operation_name,
  current_status,
  activity_id, brief_description,
  when_script_started as when, 
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural left join subprocess_invocation
  natural left join spreadsheet_uploaded
  natural left join activity_inbox_content natural left join
  activity 
order by user_inbox_content_id desc', '{}', 
                    ARRAY['user_name', 'id', 'operation_name', 'current_status', 'activity_id', 'brief_description', 'when', 'file_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('StorageRootIdById', 'select root_path from file_storage_root where
file_storage_root_id = ?', ARRAY['file_storage_root_id'], 
                    ARRAY['root_path'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get root_path for a file_storage_root
')
        ;

            insert into queries
            values ('UpdateFileIsPresent', 'update file_location set file_is_present = true where file_is_present is null', '{}', 
                    '{}', ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'Default file_is_present to true')
        ;

            insert into queries
            values ('DciodvfyErrorsStringByErrorId', 'select                                                    
  dciodvfy_error_id || ''|'' ||
  error_type || ''|'' ||                                                                                                                                                                                                                   
  coalesce(error_tag, ''[null]'') || ''|'' ||
  coalesce(error_value, ''[null]'') || ''|'' ||
  coalesce(error_subtype, ''[null]'') || ''|'' ||
  coalesce(error_module, ''[null]'') || ''|'' ||
  coalesce(error_reason, ''[null]'') || ''|'' ||
  coalesce(error_index, ''[null]'') || ''|'' ||
  coalesce(error_text, ''[null]'') as error_string
from dciodvfy_error 
where  dciodvfy_error_id = ?', ARRAY['dciodvfy_error_id'], 
                    ARRAY['error_string'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('GetVisibleFilesByEquivalenceClass', 'select
  file_id, visibility
from ctp_file
where visibility is null and file_id in (
  select
    file_id
  from
    image_equivalence_class natural join image_equivalence_class_input_image
  where
    image_equivalence_class_id = ?
)', ARRAY['image_equivalence_class_id'], 
                    ARRAY['file_id', 'visibility'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of files which are hidden by series id and visual review id')
        ;

            insert into queries
            values ('DupSopsOnlyAfterDate', 'select distinct sop_instance_uid from (
  select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo where latest >= ?
except
select distinct sop_instance_uid from (
select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo where latest < ?', ARRAY['collection', 'break_date', 'collection_1', 'break_date_1'], 
                    ARRAY['sop_instance_uid'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'List of duplicate sops with file_ids and latest load date only after cut date')
        ;

            insert into queries
            values ('StudyConsistencyWithPatientId', 'select distinct
  patient_id, study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag, count(distinct file_id)
from
  file_study natural join file_patient natural join ctp_file
where study_instance_uid = ? and visibility is null
group by
  patient_id, study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag
', ARRAY['study_instance_uid'], 
                    ARRAY['patient_id', 'study_instance_uid', 'count', 'study_description', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'phys_of_record', 'phys_reading', 'admitting_diag'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Check a Study for Consistency
')
        ;

            insert into queries
            values ('background_subprocesses_by_date_op_name', 'select 
  background_subprocess_id as bkgrnd_id, subprocess_invocation_id as invoc_id,
  operation_name, command_line, invoking_user, when_script_started
from
  background_subprocess natural left join subprocess_invocation where invoking_user = ?
  and when_script_ended is not null
  and when_script_started > ? and when_script_started < ? and operation_name = ?
order by when_script_started desc', ARRAY['invoking_user', 'from', 'to', 'operation_name'], 
                    ARRAY['bkgrnd_id', 'invoc_id', 'operation_name', 'command_line', 'invoking_user', 'when_script_started'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SimplePhiReportByScanVr', 'select 
  distinct element_sig_pattern as element, vr, value, 
  tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and vr = ?
group by element_sig_pattern, vr, value, tag_name', ARRAY['scan_id', 'vr'], 
                    ARRAY['element', 'vr', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetSsReferencingUnknownImages', 'select
  project_name as collection,
  site_name as site,
  patient_id, file_id
from
  ctp_file natural join file_patient
where file_id in (
select
  distinct ss_file_id as file_id from 
(select
  sop_instance_uid, ss_file_id 
from (
  select 
    distinct linked_sop_instance_uid as sop_instance_uid, file_id as ss_file_id
  from
    file_roi_image_linkage
  ) foo left join file_sop_common using(sop_instance_uid)
  where
  file_id is null
) as foo
)
order by collection, site, patient_id, file_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetPosdaSimplePhiPrivateElements', 'select
  element_sig_pattern,
  vr,
  is_private,
  private_disposition,
  tag_name
from element_seen

', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'is_private', 'private_disposition', 'name_chain'], ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Get the relevant features of an element_signature in posda_phi_simple schema')
        ;

            insert into queries
            values ('AbortRound', 'update round
  set round_aborted = now()
where
  round_id = ?
', ARRAY['round_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Close row in round (set end time)')
        ;

            insert into queries
            values ('TableSizePosdaPhiSimple', 'select *, pg_size_pretty(total_bytes) AS total
    , pg_size_pretty(index_bytes) AS INDEX
    , pg_size_pretty(toast_bytes) AS toast
    , pg_size_pretty(table_bytes) AS TABLE
  FROM (
  SELECT *, total_bytes-index_bytes-COALESCE(toast_bytes,0) AS table_bytes FROM (
      SELECT c.oid,nspname AS table_schema, relname AS TABLE_NAME
              , c.reltuples AS row_estimate
              , pg_total_relation_size(c.oid) AS total_bytes
              , pg_indexes_size(c.oid) AS index_bytes
              , pg_total_relation_size(reltoastrelid) AS toast_bytes
          FROM pg_class c
          LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
          WHERE relkind = ''r''
  ) a
) a where table_schema = ''public'' order by total_bytes desc', '{}', 
                    ARRAY['table_schema', 'table_name', 'row_estimate', 'total_bytes', 'index_bytes', 'total', 'toast_bytes', 'index', 'toast', 'table'], ARRAY['AllCollections', 'postgres_stats', 'table_size'], 'posda_phi_simple', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetFileIdAndVisibilityByDigest', 'select
  f.file_id as id,
  c.file_id as ctp_file_id,
  c.visibility as visibility
from
  file f left join ctp_file c
  using(file_id)
where
  f.file_id in (
  select file_id
  from
     file
  where
     digest = ?
)', ARRAY['digest'], 
                    ARRAY['id', 'ctp_file_id', 'visibility'], ARRAY['NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Get file_id, and current visibility by digest
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('PatientByImportEventIdHiddenFiles', 'select
  distinct patient_id, count(distinct file_id) as num_files
from file_patient
where file_id in (
  select distinct file_id
  from file_import natural join import_event natural left join ctp_file
  where import_event_id = ? and visibility = ''hidden''
) group by patient_id order by patient_id', ARRAY['import_event_id'], 
                    ARRAY['patient_id', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('SelectPtInfoSummaryByCollection', 'select 
  distinct 
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  pti_radiopharmaceutical as radiopharmaceutical, 
  pti_radionuclide_total_dose as total_dose,
  pti_radionuclide_half_life as half_life,
  pti_radionuclide_positron_fraction as positron_fraction, 
  pti_fov_shape as fov_shape,
  pti_fov_dimensions as fov_dim,
  pti_collimator_type as coll_type,
  pti_reconstruction_diameter as recon_diam, 
  count(*) as num_files
from file_pt_image natural join file_patient natural join file_series natural join ctp_file 
where project_name = ? and visibility is null
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  radiopharmaceutical,
  total_dose,
  half_life,
  positron_fraction,
  fov_shape,
  fov_dim,
  coll_type,
  recon_diam
order by patient_id', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'radiopharmaceutical', 'total_dose', 'half_life', 'positron_fraction', 'fov_shape', 'fov_dim', 'coll_type', 'recon_diam', 'num_files'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('PatientsWithNoCtp', 'select
  distinct patient_id,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files,
  min(import_time) as first_import,
  max(import_time) as last_import
from
  file_patient sc natural join file_series
  natural join file_import natural join import_event
where
  not exists (select file_id from ctp_file c where sc.file_id = c.file_id)
group by patient_id;', '{}', 
                    ARRAY['patient_id', 'num_series', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('files_to_copy_from_public', 'select 
  dp_site_name as site, 
  sop_instance_uid, 
  dicom_file_uri 
from general_image, trial_data_provenance
where 
  general_image.trial_dp_pk_id = trial_data_provenance.trial_dp_pk_id and 
  trial_data_provenance.project = ? and
  trial_data_provenance.dp_site_name = ?', ARRAY['collection', 'site'], 
                    ARRAY['site', 'sop_instance_uid', 'dicom_file_uri'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'public', 'Files to copy from Public (to Posda)')
        ;

            insert into queries
            values ('FilesInSeriesWithPositionPixelDig', 'select
  distinct file_id, image_id, unique_pixel_data_id, ipp, instance_number
from
  file_series natural join file_image natural join ctp_file natural join file_sop_common
  natural join image natural join image_geometry
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'image_id', 'unique_pixel_data_id', 'ipp', 'instance_number'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send'], 'posda_files', 'Get file info from series for comparison of dup_series')
        ;

            insert into queries
            values ('UpdateCopyFromPublic', 'update copy_from_public
  set when_file_rows_populated = now(),
  num_file_rows_populated = ?,
  status_of_copy = ?
where
  copy_from_public_id = ?', ARRAY['num_file_rows_populated', 'status_of_copy', 'copy_id'], 
                    '{}', ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('LongestRunningNQueriesByDate', 'select * from (
select query_invoked_by_dbif_id as id, query_name, query_end_time - query_start_time as duration,
invoking_user, query_start_time, number_of_rows
from query_invoked_by_dbif
where query_end_time is not null and
query_start_time > ? and query_end_time < ?
order by duration desc) as foo
limit ?', ARRAY['from', 'to', 'n'], 
                    ARRAY['id', 'query_name', 'duration', 'invoking_user', 'query_start_time', 'number_of_rows'], ARRAY['AllCollections', 'q_stats_by_date'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('TagUsage', 'select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ?
order by element_signature;
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'equipment_signature'], ARRAY['tag_usage'], 'posda_phi', 'Which equipment signatures for which tags
')
        ;

            insert into queries
            values ('GetSeriesInfoById', 'select
  file_id,
  modality,
  series_instance_uid,
  series_number,
  laterality,
  series_date,
  series_time,
  performing_phys,
  protocol_name,
  series_description,
  operators_name,
  body_part_examined,
  patient_position,
  smallest_pixel_value,
  largest_pixel_value,
  performed_procedure_step_id,
  performed_procedure_step_start_date,
  performed_procedure_step_start_time,
  performed_procedure_step_desc, 
  performed_procedure_step_comments,
  date_fixed
from file_series
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'modality', 'series_instance_uid', 'series_number', 'laterality', 'series_date', 'series_time', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_start_time', 'performed_procedure_step_desc', 'performed_procedure_step_comments', 'performed_procedure_step_comments', 'date_fixed'], ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('GetBacklogControl', 'select
  status, processor_pid,
  idle_poll_interval,
  last_service, pending_change_request,
  source_pending_change_request,
  request_time, num_files_per_round,
  target_queue_size,
  (now() - request_time) as time_pending
from control_status
', '{}', 
                    ARRAY['status', 'processor_pid', 'idle_poll_interval', 'last_service', 'pending_change_request', 'source_pending_change_request', 'request_time', 'num_files_per_round', 'target_queue_size', 'time_pending'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Get control status from backlog database')
        ;

            insert into queries
            values ('GetUnkQualifiedCTQPByLikeCollectionSiteWithFIleCountAndLoadTimes', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files,
  min(import_time) as earliest, max(import_time) as latest
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join import_event using(import_event_id)
where collection like ? and site = ? and qualified is null
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'earliest', 'latest'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('LinkAFEtoEditEvent', 'insert into dicom_edit_event_adverse_file_event(
  dicom_edit_event_id, adverse_file_event_id
) values (?, ?)
', ARRAY['dicom_edit_event_id', 'adverse_file_event_id'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Insert row linking adverse_file_edit_event to dicom_edit_event
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetDciodvfyWarningWrongExpVr', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''WrongExplicitVr''
  and warning_tag = ?
  and warning_desc = ?
  and warning_comment = ?
  and warning_value = ?
  and warning_reason = ?
 ', ARRAY['warning_tag', 'warning_desc', 'warning_comment', 'warning_value', 'warning_reason'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('CreateSimpleElementSeen', 'insert into 
   element_seen(element_sig_pattern, vr)
   values(?, ?)
', ARRAY['element_sig_pattern', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'used_in_simple_phi_maint', 'used_in_phi_maint'], 'posda_phi_simple', 'Create a new Simple PHI scan')
        ;

            insert into queries
            values ('GetGeometricInfoIntake', 'select
  sop_instance_uid, image_orientation_patient, image_position_patient,
  pixel_spacing, i_rows, i_columns
from
  general_image
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['sop_instance_uid', 'image_orientation_patient', 'image_position_patient', 'pixel_spacing', 'i_rows', 'i_columns'], ARRAY['LinkageChecks', 'BySopInstance'], 'intake', 'Get Geometric Information by Sop Instance UID from intake')
        ;

            insert into queries
            values ('GetSeriesVisibilityCountsBySeriesAndVisualReviewId', 'select
  distinct series_instance_uid, coalesce(visibility, ''<undef>''), modality,
  count(distinct file_id) as num_files
from file_series natural join ctp_file
where file_id in (
  select
    file_id
  from
    image_equivalence_class natural join image_equivalence_class_input_image
  where
    visual_review_instance_id = ? and series_instance_uid = ?
)
group by series_instance_uid, visibility, modality', ARRAY['visual_review_instance_id', 'series_instance_uid'], 
                    ARRAY['series_instance_uid', 'visibility', 'modality', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of files which are hidden by series id and visual review id')
        ;

            insert into queries
            values ('CreateNonDicomEditCompareDisposition', 'insert into non_dicom_edit_compare_disposition(
  subprocess_invocation_id, start_creation_time, current_disposition, process_pid, dest_dir
)values (
  ?, now(), ''Starting Up'', ?, ?
)', ARRAY['subprocess_invocation_id', 'process_pid', 'dest_dir'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_edit'], 'posda_files', 'Create an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('EndTransactionPosda', 'commit
', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'End a transaction in Posda files')
        ;

            insert into queries
            values ('background_subprocesses', 'select 
  background_subprocess_id as id, 
  operation_name, command_executed, invoking_user, when_script_started
from
  background_subprocess natural left join subprocess_invocation where invoking_user = ?
 and when_script_ended is not null
order by when_script_started desc', ARRAY['invoking_user'], 
                    ARRAY['id', 'operation_name', 'command_executed', 'invoking_user', 'when_script_started'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PublicFileListByCollection', 'select 
  distinct tdp.project as collection, s.patient_id, s.series_instance_uid, dicom_file_uri
from
  trial_data_provenance tdp, general_image i, general_series s
where
  s.general_series_pk_id = i.general_series_pk_id and i.trial_dp_pk_id = tdp.trial_dp_pk_id
  and tdp.project = ?', ARRAY['collection'], 
                    ARRAY['collection', 'patient_id', 'series_instance_uid', 'dicom_file_uri'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi'], 'public', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('CountsByCollectionLikeSite', 'select
  distinct
    project_name as collection, site_name as site,
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
  ) and project_name like ?  and site_name = ? 
group by
  collection, site, patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  collection, site, patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection like pattern
')
        ;

            insert into queries
            values ('FilesInHierarchyBySeries', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  file_id
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('GetRoiCountsBySeriesInstanceUid', 'select 
   distinct sop_instance_uid, count(distinct roi_id)
from 
  roi natural join structure_set natural join file_structure_set 
  join file_sop_common using(file_id)
where sop_instance_uid in (
  select distinct sop_instance_uid from file_sop_common natural join file_series
  where series_instance_uid = ?
)
group by sop_instance_uid
order by count desc
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'count'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of ROI''s in a structure Set

')
        ;

            insert into queries
            values ('GetBackgroundButtonsByTag', 'select
    background_button_id,
    operation_name,
    object_class,
    button_text
from background_buttons
where tags && ?

', ARRAY['tags'], 
                    ARRAY['background_button_id', 'operation_name', 'object_class', 'button_text'], ARRAY['NotInteractive', 'used_in_process_popup'], 'posda_queries', '')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionLikeSeriesDescription', 'select 
  distinct collection, 
  site, patient_id, series_instance_uid, 
  series_description,
  dicom_file_type, modality, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
  from (
    select
     distinct project_name as collection,
     site_name as site,
     patient_id, 
     series_instance_uid, 
     series_description,
     dicom_file_type, 
     modality, sop_instance_uid,
     file_id
    from 
     file_series
     natural join dicom_file
     natural join file_sop_common 
     natural join file_patient
     natural join ctp_file
  where
    project_name = ? 
    and site_name = ? 
    and series_description like ?
    and visibility is null
) as foo
group by collection, site, patient_id, 
  series_instance_uid, series_description, dicom_file_type, modality
', ARRAY['collection', 'site', 'description'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'series_description', 'dicom_file_type', 'modality', 'num_sops', 'num_files'], ARRAY['by_collection', 'find_series'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('CountsByCollectionSite', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and visibility is null
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files'], ARRAY['counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('CreateComparePublicToPosdaInstance', 'insert into compare_public_to_posda_instance(
  when_compare_started, status_of_compare, number_of_sops
)values (
  now(), ''Starting Up'', ?
)', ARRAY['num_sops'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Create an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('GetFilesToImportFromEdit', 'select
  subprocess_invocation_id,
  from_file_digest,
  to_file_digest,
  to_file_path
from
  dicom_edit_compare
where 
  from_file_digest in 
  (
    select from_file_digest from 
    (
      select distinct from_file_digest 
      from dicom_edit_compare dec, file f natural join ctp_file
      where dec.from_file_digest = f.digest and visibility is null and subprocess_invocation_id = ?
      intersect
      select from_file_digest from dicom_edit_compare dec
      where not exists
      (
        select file_id from file f where dec.to_file_digest = f.digest
       ) 
       and subprocess_invocation_id = ?
    ) as foo
  )
  and subprocess_invocation_id = ?
limit ?', ARRAY['subprocess_invocation_id', 'subprocess_invocation_id_1', 'subprocess_invocation_id_2', 'limit'], 
                    ARRAY['subprocess_invocation_id', 'from_file_digest', 'to_file_digest', 'to_file_path'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('TableSizePosdaBacklog', 'select *, pg_size_pretty(total_bytes) AS total
    , pg_size_pretty(index_bytes) AS INDEX
    , pg_size_pretty(toast_bytes) AS toast
    , pg_size_pretty(table_bytes) AS TABLE
  FROM (
  SELECT *, total_bytes-index_bytes-COALESCE(toast_bytes,0) AS table_bytes FROM (
      SELECT c.oid,nspname AS table_schema, relname AS TABLE_NAME
              , c.reltuples AS row_estimate
              , pg_total_relation_size(c.oid) AS total_bytes
              , pg_indexes_size(c.oid) AS index_bytes
              , pg_total_relation_size(reltoastrelid) AS toast_bytes
          FROM pg_class c
          LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
          WHERE relkind = ''r''
  ) a
) a where table_schema = ''public'' order by total_bytes desc', '{}', 
                    ARRAY['table_schema', 'table_name', 'row_estimate', 'total_bytes', 'index_bytes', 'total', 'toast_bytes', 'index', 'toast', 'table'], ARRAY['AllCollections', 'postgres_stats', 'table_size'], 'posda_backlog', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('DicomFileTypes', 'select 
  distinct dicom_file_type, count(distinct file_id)
from
  dicom_file natural join ctp_file
where
  visibility is null  
group by dicom_file_type
order by count desc', '{}', 
                    ARRAY['dicom_file_type', 'count'], ARRAY['find_series', 'dicom_file_type'], 'posda_files', 'List of Dicom File Types with count of files in Posda
')
        ;

            insert into queries
            values ('OneFileFromSop', 'select
  distinct root_path || ''/'' || rel_path as file
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_sop_common
where
  sop_instance_uid = ? and visibility is null
limit 1
', ARRAY['sop_instance_uid'], 
                    ARRAY['file'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('ListSrPosda', 'select 
  distinct project_name as collection, site_name as site,
  patient_id, study_instance_uid, series_instance_uid,
  file_id, root_path || ''/'' || rel_path as file_path
from
  dicom_file natural join file_patient natural join file_series
  natural join file_study natural join ctp_file
  join file_location using (file_id) natural join file_storage_root
where
  visibility is null and dicom_file_type like ''%SR%'' and
  project_name like ?', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_ui', 'file_id', 'file_path'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'view_structured_reports'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('TagsSeenPrivate', 'select
  element_signature, vr, is_private, private_disposition, name_chain
from
  element_signature
where is_private
order by element_signature, vr', '{}', 
                    ARRAY['element_signature', 'vr', 'is_private', 'private_disposition', 'name_chain'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi', 'Get all the data from tags_seen in posda_phi database
')
        ;

            insert into queries
            values ('UpdateNonDicomEditCompareDispositionStatus', 'update non_dicom_edit_compare_disposition set
  current_disposition = ?,
  last_updated = now()
where
  subprocess_invocation_id = ?
', ARRAY['current_disposition', 'subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Update status of an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('NewSopsReceivedBetweenDates', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
          where import_time > ? and import_time < ?
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
where num_uploads = 1
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates with sops without duplicates
')
        ;

            insert into queries
            values ('InsertManifestRow', 'insert into ctp_manifest_row(
 file_id,
 cm_index,
 cm_collection,
 cm_site,
 cm_patient_id,
 cm_study_date,
 cm_series_instance_uid,
 cm_study_description,
 cm_series_description,
 cm_modality,
 cm_num_files ) values(
 ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?
)', ARRAY['file_id', 'cm_index', 'cm_collection', 'cm_site', 'cm_patient_id', 'cm_study_date', 'cm_series_instance_uid', 'cm_study_description', 'cm_series_description', 'cm_modality', ''], 
                    '{}', ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('InboxContentByActivityIdWithCompletion', 'select
 user_name, user_inbox_content_id as id, operation_name,
  when_script_started as when, when_script_ended as ended,
  when_script_ended - when_script_started as duration,
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  activity_inbox_content natural join user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural join subprocess_invocation
  natural left join spreadsheet_uploaded
where activity_id = ?
order by when_script_started desc', ARRAY['activity_id'], 
                    ARRAY['user_name', 'id', 'operation_name', 'when', 'ended', 'duration', 'file_id', 'sub_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('UpdateActivityTaskStatus', 'update activity_task_status set
  status_text = ?,
  last_updated = now(),
  dismissed_time = null,
  dismissed_by = null
where
  activity_id = ? and
  subprocess_invocation_id = ?', ARRAY['status_text', 'activity_id', 'subprocess_invocation_id'], 
                    '{}', ARRAY['NotInteractive', 'Update'], 'posda_files', 'Update status_text and expected_completion_time in activity_task_status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetFileIdVisibilityByImageEquivalenceClass', 'select 
  distinct file_id, visibility
from
  image_equivalence_class natural join image_equivalence_class_input_image natural join ctp_file
where image_equivalence_class_id = ?', ARRAY['image_equivalence_class_id'], 
                    ARRAY['file_id', 'visibility'], ARRAY['ImageEdit', 'edit_files'], 'posda_files', 'Get File id and visibility for all files in a series')
        ;

            insert into queries
            values ('FilesInSeries', 'select
  distinct root_path || ''/'' || rel_path as file
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_series
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('HideSeriesNotLikeWithModality', 'update ctp_file set visibility = ''hidden''
where file_id in (
  select
    file_id
  from
    file_series
  where
    series_instance_uid in (
      select
         distinct series_instance_uid
      from (
        select
         distinct
           file_id, series_instance_uid, series_description
        from
           ctp_file natural join file_series
        where
           modality = ? and project_name = ? and site_name = ?and 
           series_description not like ?
      ) as foo
    )
  )
', ARRAY['modality', 'collection', 'site', 'description_not_matching'], 
                    NULL, ARRAY['Update', 'posda_files'], 'posda_files', 'Hide series not matching pattern by modality
')
        ;

            insert into queries
            values ('CreatePhiNonDicomScanInstance', 'insert into phi_non_dicom_scan_instance(
  pndsi_description,
  pndsi_start_time,
  pndsi_num_files,
  pndsi_num_files_scanned
) values (
  ?, now(), ?, 0
)', ARRAY['description_of_scan', 'num_files'], 
                    '{}', ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('PixelDataDuplicateCounts', 'select
  distinct pixel_digest, count(*)
from (
   select 
       distinct unique_pixel_data_id, pixel_digest, project_name,
       site_name, patient_id, count(*) 
  from (
    select
      distinct unique_pixel_data_id, file_id, project_name,
      site_name, patient_id, 
      unique_pixel_data.digest as pixel_digest 
    from
      image join file_image using(image_id)
      join ctp_file using(file_id)
      join file_patient fq using(file_id)
      join unique_pixel_data using(unique_pixel_data_id)
    where visibility is null
  ) as foo 
  group by 
    unique_pixel_data_id, project_name, pixel_digest,
    site_name, patient_id
) as foo 
group by pixel_digest', '{}', 
                    ARRAY['pixel_digest', 'count'], ARRAY['pix_data_dups', 'pixel_duplicates'], 'posda_files', 'Find digest with counts of files
')
        ;

            insert into queries
            values ('PrivateTagsToBeDeleted', 'select distinct element_sig_pattern as tag from element_seen where is_private and private_disposition = ''d'' order by element_sig_pattern;

', '{}', 
                    ARRAY['tag'], ARRAY['AllCollections', 'queries', 'phi_maint'], 'posda_phi_simple', 'Private tags to be deleted')
        ;

            insert into queries
            values ('ListAllActivities', 'select
  activity_id,
  brief_description,
  when_created,
  who_created,
  when_closed
from
  activity 
order by activity_id', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activities'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('PhiNonDicomScanStatusComplete', 'select 
   phi_non_dicom_scan_instance_id as id,
   pndsi_description as description,
   pndsi_start_time as start_time,
   pndsi_num_files as num_files_to_scan,
   pndsi_num_files_scanned as num_files_scanned,
   pndsi_end_time - pndsi_start_time as duration
from
  phi_non_dicom_scan_instance
where pndsi_end_time is not null
order by start_time', '{}', 
                    ARRAY['id', 'description', 'start_time', 'num_files_to_scan', 'num_files_scanned', 'duration'], ARRAY['tag_usage', 'non_dicom_phi_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('DistinctStudySeriesByCollection', 'select distinct study_instance_uid as study_uid, series_instance_uid as series_uid, patient_id, dicom_file_type, modality, count(*)
from (
select distinct study_instance_uid, series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality from (
select
   distinct study_instance_uid, series_instance_uid, patient_id, modality, sop_instance_uid,
   file_id, dicom_file_type
 from file_series natural join file_sop_common
   natural join ctp_file natural join dicom_file natural join file_patient natural join file_study
where
  project_name = ?
  and visibility is null)
as foo
group by study_instance_uid, series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality)
as foo
group by study_uid, series_uid, patient_id, dicom_file_type, modality
', ARRAY['collection'], 
                    ARRAY['study_uid', 'series_uid', 'patient_id', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionSiteWithFIleCountAndLoadTimes', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files,
  min(import_time) as earliest, max(import_time) as latest
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join import_event using(import_event_id)
where collection like ? and site = ?
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'earliest', 'latest'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PatientStudySeriesForFile', 'select
  patient_id, study_instance_uid, series_instance_uid, root_path || ''/'' || rel_path as path
from
  file_patient natural join file_series natural join
  file_study natural join file_location natural join file_storage_root
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'path'], ARRAY['activity_timepoint_support'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('GetNfilesToCopyOnly', 'select
  sop_instance_uid,
  copy_file_path 
from file_copy_from_public
where copy_from_public_id =  ? and inserted_file_id is null 
limit ?', ARRAY['copy_from_public_id', 'count'], 
                    ARRAY['sop_instance_uid', 'copy_file_path'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CurrentPatientStatiiByCollectionSite', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  patient_import_status
from 
  ctp_file natural join file_patient natural left join patient_import_status
where
  visibility is null and project_name = ? and site_name = ?', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'patient_import_status'], ARRAY['counts', 'patient_status', 'for_bill_counts'], 'posda_files', 'Get the current status of all patients')
        ;

            insert into queries
            values ('DistinctFilesByScanTag', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  scan_event_id = ? and element_signature = ?
order by series_instance_uid, file
', ARRAY['scan_id', 'tag'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'value', 'sequence_level', 'item_number'], ARRAY['tag_usage', 'phi_review'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('RecentUploadsTest1', 'select
        project_name,
        site_name,
        dicom_file_type,
        count(*),
        (extract(epoch from now() - max(import_time)) / 60)::int as minutes_ago,
        to_char(max(import_time), ''HH24:MI'') as time

    from (
        select 
          project_name,
          site_name,
          dicom_file_type,
          sop_instance_uid,
          import_time

        from 
          file_import
          natural join import_event
          natural join ctp_file
          natural join dicom_file
          natural join file_sop_common
          natural join file_patient

        where import_time > now() - interval ''1'' day
          and visibility is null
    ) as foo
    group by
        project_name,
        site_name,
        dicom_file_type
    order by minutes_ago asc;', '{}', 
                    ARRAY['project_name', 'site_name', 'dicom_file_type', 'count', 'minutes_ago', 'time'], ARRAY['files'], 'posda_files', 'Show files received by Posda in the past day.')
        ;

            insert into queries
            values ('SeriesWithDistinguishedDigests', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  count(distinct sop_instance_uid) as num_sops
from
  ctp_file natural join
  file_patient natural
  join file_series natural
  join file_sop_common
where file_id in(
  select file_id 
  from
    file_image
    join image using (image_id)
    join unique_pixel_data using (unique_pixel_data_id)
  where digest in (
    select distinct pixel_digest as digest 
    from distinguished_pixel_digests
  )
) group by collection, site, patient_id, series_instance_uid', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'num_sops'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'show series with distinguished digests and counts')
        ;

            insert into queries
            values ('ListOfSchemas', 'select
 distinct schema
from queries
order by schema', '{}', 
                    ARRAY['schema'], ARRAY['AllCollections', 'schema'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('SimplePhiReportByScanVrPublicOnly', 'select 
  distinct element_sig_pattern as element, vr, value, 
  tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and vr = ?
  and not is_private
group by element_sig_pattern, vr, value, tag_name', ARRAY['scan_id', 'vr'], 
                    ARRAY['element', 'vr', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetPrivateTagFeaturesBySignature', 'select
  pt_consensus_name as name,
  pt_consensus_vr as vr,
  pt_consensus_disposition as disposition
from pt
where pt_signature = ?
', ARRAY['signature'], 
                    ARRAY['name', 'vr', 'disposition'], ARRAY['DispositionReport', 'NotInteractive'], 'posda_private_tag', 'Get the relevant features of a private tag by signature
Used in DispositionReport.pl - not for interactive use
')
        ;

            insert into queries
            values ('LookingForMissingHeadNeckPetCT1', 'select 
  distinct patient_id, study_instance_uid, series_instance_uid, modality, 
  count(distinct file_id) as num_files, min(import_time) as first_load, max(import_time) as last_load
from
  file_patient natural join file_study 
  natural join file_series
  join file_import using(file_id)
  join import_event using(import_event_id)
where file_id in (      
  select
     distinct file_id
  from
    file_series join ctp_file using(file_id)
    join file_sop_common using(file_id) 
    join file_import using (file_id)
    join import_event using(import_event_id)
  where 
    project_name = ''Head-Neck-PET-CT'' and import_time > ''2018-04-01''
  )
group by patient_id, study_instance_uid, series_instance_uid, modality', '{}', 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'modality', 'num_files', 'first_load', 'last_load'], ARRAY['meta', 'test', 'hello', 'bills_test', 'bills_ad_hoc_scripts', 'for_tracy'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FindingStructureSetsForTest', 'select
  distinct project_name as collection, patient_id, series_description, sop_instance_uid, file_id,
  dicom_file_type
from
  ctp_file natural join dicom_file natural join file_study natural join file_series
  natural join file_patient natural join file_sop_common
where 
  dicom_file_type = ''RT Structure Set Storage'' and visibility is null and project_name = ''Soft-tissue-Sarcoma''', '{}', 
                    ARRAY['collection', 'patient_id', 'file_id', 'dicom_file_type', 'series_description'], ARRAY['Test Case based on Soft-tissue-Sarcoma'], 'posda_files', 'Find All of the Structure Sets In Soft-tissue-Sarcoma')
        ;

            insert into queries
            values ('GetComparePublicToPosdaInstanceId', 'select currval(''compare_public_to_posda_insta_compare_public_to_posda_insta_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetBacklogQueueSizeWithCollection', 'select
 distinct collection, count(*) as num_files
from
  request natural join submitter
where
  file_in_posda is false
group by collection

', '{}', 
                    ARRAY['collection', 'num_files'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Get size of queue  in PosdaBacklog')
        ;

            insert into queries
            values ('SeriesListBySubjectName', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality, 
  dicom_file_type, 
  count(distinct file_id) as num_files
from 
  file_patient natural join
  file_series natural join
  file_study natural join
  dicom_file natural join
  ctp_file
where 
  patient_id = ?
  and visibility is null
group by 
  collection,
  site,
  patient_id,
  study_instance_uid,
  study_date,
  study_description,
  series_instance_uid,
  series_date,
  series_description,
  modality,
  dicom_file_type;', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'series_date', 'series_description', 'modality', 'dicom_file_type', 'num_files'], ARRAY['find_series', 'for_tracy'], 'posda_files', 'Get List of Series by Subject Name')
        ;

            insert into queries
            values ('PhiSimpleScanStatus', 'select
  phi_scan_instance_id as id,
  start_time,
  end_time,
  end_time - start_time as duration,
  description,
  num_series as to_scan,
  num_series_scanned as scanned
from 
  phi_scan_instance
order by id desc
', '{}', 
                    ARRAY['id', 'start_time', 'end_time', 'duration', 'description', 'to_scan', 'scanned', 'phi_status'], ARRAY['tag_usage', 'simple_phi', 'scan_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('HideEarlyFilesCSP', 'update ctp_file set visibility = ''hidden'' where file_id in (
  select min as file_id
  from (
    select
      distinct sop_instance_uid, min, max, count
    from (
      select
        distinct sop_instance_uid, min(file_id),
        max(file_id),count(*)
      from (
        select
          distinct sop_instance_uid, file_id
        from
          file_sop_common 
        where sop_instance_uid in (
          select
            distinct sop_instance_uid
          from
            file_sop_common natural join ctp_file
            natural join file_patient
          where
            project_name = ? and site_name = ? 
            and patient_id = ? and visibility is null
        )
      ) as foo natural join ctp_file
      where visibility is null
      group by sop_instance_uid
    )as foo where count > 1
  ) as foo
);
', ARRAY['collection', 'site', 'subject'], 
                    NULL, '{}', 'posda_files', 'Hide earliest submission of a file:
  Note:    uses sequencing of file_id to determine earliest
           file, not import_time
')
        ;

            insert into queries
            values ('ActivityTimepointForOpenActivitiesByDescLike', 'select
  activity_id, a.when_created as activity_created,
  brief_description as activity_description, activity_timepoint_id,
  t.when_created as timepoint_created, 
  comment, creating_user
from
  activity a join activity_timepoint t using(activity_id)
where
  a.when_closed is null and
  brief_description like ?', ARRAY['description_like'], 
                    ARRAY['activity_id', 'activity_created', 'activity_description', 'activity_timepoint_id', 'timepoint_created', 'comment', 'creating_user'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_queries', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('DistinctSeriesByDicomFileType', 'select 
  distinct series_instance_uid, dicom_file_type, count(distinct file_id)
from
  file_series natural join dicom_file natural join ctp_file
where
  dicom_file_type = ? and
  visibility is null  
group by series_instance_uid, dicom_file_type', ARRAY['dicom_file_type'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'count'], ARRAY['find_series', 'dicom_file_type'], 'posda_files', 'List of Distinct Series By Dicom File Type
')
        ;

            insert into queries
            values ('ShowQueryTabHierarchyWithCounts', 'select 
  query_tab_name, filter_name, tag, count(distinct query_name) as num_queries
from(
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
natural join(
  select
     name as query_name,
     unnest(tags) as tag
from queries
) as fie
group by query_tab_name, filter_name, tag
order by 
  query_tab_name, filter_name, tag', '{}', 
                    ARRAY['query_tab_name', 'filter_name', 'tag', 'num_queries'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SimpleSeriesCountsByCollectioin', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  count(distinct file_id)as num_files,
  sum(size) as num_bytes
from
  ctp_file natural join
  file natural join
  dicom_file natural join
  file_patient natural join
  file_series
where
  visibility is null and
  project_name = ?
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files', 'num_bytes'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection like pattern
')
        ;

            insert into queries
            values ('WhereFilesInTimePointSit', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural left join
  ctp_file
where file_id in(
  select file_id from activity_timepoint_file
  where activity_timepoint_id = ?
)', ARRAY['activity_timepoint_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid'], ARRAY['posda_files', 'sops', 'BySopInstance', 'by_file'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('DistinctSopsInCollectionByStorageClass', 'select distinct sop_instance_uid, rel_path
from
  file_sop_common natural join file_location natural join file_storage_root
where file_id in (
  select
    distinct file_id
  from
    ctp_file natural join file_location natural join file_storage_root
  where
    project_name = ? and visibility is null and storage_class = ?
) and current
order by sop_instance_uid
', ARRAY['collection', 'storage_class'], 
                    ARRAY['sop_instance_uid', 'rel_path'], ARRAY['by_collection', 'posda_files', 'sops'], 'posda_files', 'Get Distinct SOPs in Collection with number files
Only visible files
')
        ;

            insert into queries
            values ('DistinctVisibleSopsAndFilesInSeriesWithPatAndStudy', 'select distinct
  patient_id, study_instance_uid, series_instance_uid,
  sop_instance_uid, file_id
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
where file_id in 
  (select
    distinct file_id
  from
    file_series natural join file_sop_common natural join ctp_file
  where
    series_instance_uid = ? and visibility is null)
', ARRAY['series_instance_uid'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id'], ARRAY['by_series_instance_uid', 'file_ids', 'posda_files'], 'posda_files', 'Get Distinct Unhidden Files in Series
')
        ;

            insert into queries
            values ('GetXlsxToConvert', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
 collection = ? and file_type = ''xlsx'' and visibility is null', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('StudiesInCollectionSite', 'select
  distinct study_instance_uid
from
  file_study natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null
', ARRAY['project_name', 'site_name'], 
                    ARRAY['study_instance_uid'], ARRAY['find_studies'], 'posda_files', 'Get Studies in A Collection, Site
')
        ;

            insert into queries
            values ('GetToday', 'select 
  date_trunc(''day'',now()) as today
 ', '{}', 
                    ARRAY['today'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetBacklogQueueSize', 'select
 count(*) as num_files
from
  request
where
  file_in_posda is false 

', '{}', 
                    ARRAY['num_files'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Get size of queue  in PosdaBacklog')
        ;

            insert into queries
            values ('GetDoseReferencingNoPlan', 'select
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from rt_dose natural join file_dose  where
rt_dose_referenced_plan_uid is null)', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'sop_instance_uid', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dose_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('ContourTypesByRoi', 'select
  distinct geometric_type,
  count(distinct roi_contour_id) as num_contours,
  sum(number_of_points) as total_points
from
 roi_contour
where roi_id = ?
group by geometric_type', ARRAY['roi_id'], 
                    ARRAY['geometric_type', 'num_contours', 'total_points'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('AllPatientDetailsWithNoCtp', 'select
  distinct 
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series f
where
 not exists (select file_id from ctp_file c where c.file_id = f.file_id)
group by
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  patient_id, study_date,
  modality
', '{}', 
                    ARRAY['patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_details'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('FilesInCollectionSiteForSend', 'select
  distinct file_id, root_path || ''/'' || rel_path as path, 
  xfer_syntax, sop_class_uid,
  data_set_size, data_set_start, sop_instance_uid, digest
from
  file_location natural join file_storage_root
  natural join dicom_file natural join ctp_file
  natural join file_sop_common natural join file_series
  natural join file_meta natural join file
where
  project_name = ? and site_name = ? and visibility is null
', ARRAY['collection', 'site'], 
                    ARRAY['file_id', 'path', 'xfer_syntax', 'sop_class_uid', 'data_set_size', 'data_set_start', 'sop_instance_uid', 'digest'], ARRAY['by_collection_site', 'find_files', 'for_send'], 'posda_files', 'Get everything you need to negotiate a presentation_context
for all files in a Collection Site
')
        ;

            insert into queries
            values ('AddPidToSubprocessInvocation', 'update subprocess_invocation set
  process_pid = ?
where
  subprocess_invocation_id = ?
', ARRAY['pid', 'subprocess_invocation_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Add a pid to a subprocess_invocation row

used in DbIf after subprocess invoked')
        ;

            insert into queries
            values ('GetListCollectionPrios', 'select collection, file_count as priority
from collection_count_per_round
order by collection

', '{}', 
                    ARRAY['collection', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Get a list of all collections defined in backlog with priorities.')
        ;

            insert into queries
            values ('StudiesWithMultiplePatientIds', 'select
  distinct study_instance_uid,
  patient_id
from
  file_study natural join file_patient natural join ctp_file                                                      
where study_instance_uid in (                                                                                                                                                        
  select distinct study_instance_uid from (                                                                                                                                                                                    
     select * from (
        select distinct study_instance_uid, count(*) from (
          select distinct study_instance_uid, patient_id
          from file_study natural join file_patient natural join ctp_file
          where project_name = ? and visibility is null
        ) as foo group by study_instance_uid
      ) as foo where count > 1
   ) as foo
) and
visibility is null', ARRAY['collection'], 
                    ARRAY['study_instance_uid', 'patient_id'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('GetDciodvfyErrorMayNotBePres', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''MayNotBePresent''
  and error_tag = ?
  and error_reason = ?', ARRAY['error_tag', 'error_reason'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('GetFilesNotImportedInDicomFileCompare', 'select
  count(*)
from
  dicom_edit_compare
where 
  from_file_digest in 
  (
    select from_file_digest from 
    (
      select from_file_digest from dicom_edit_compare dec
      where not exists
      (
        select file_id from file f where dec.to_file_digest = f.digest
       ) 
       and edit_command_file_id = ?
      except
      select distinct from_file_digest 
      from dicom_edit_compare dec, file f natural join ctp_file
      where dec.from_file_digest = f.digest and visibility is null and edit_command_file_id = ?

    ) as foo
  )
  and edit_command_file_id = ?
', ARRAY['command_file_id', 'command_file_id_1', 'command_file_id_2'], 
                    ARRAY['count'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get Files hidden but replacement not imported')
        ;

            insert into queries
            values ('CountsByCollectionSiteExcludingSeriesByDescription', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and visibility is null and
  series_description not like ?
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site', 'series_description_exclusion_pattern'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files'], ARRAY['counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('background_emails', 'select 
  background_subprocess_report_id as id, 
  button_name, operation_name, invoking_user, when_invoked, file_id, name
from background_subprocess_report natural join background_subprocess natural join subprocess_invocation where invoking_user = ? and name = ''Email''
order by when_invoked desc', ARRAY['invoking_user'], 
                    ARRAY['id', 'button_name', 'operation_name', 'invoking_user', 'when_invoked', 'file_id', 'name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetLoadPathByImportEventIdAndFileId', 'select file_name from file_import where file_id = ? and import_event_id = ?', ARRAY['file_id', 'import_event_id'], 
                    ARRAY['file_name'], ARRAY['import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSiteModality', 'select distinct series_instance_uid, dicom_file_type, modality, count(*)
from (
select distinct series_instance_uid, sop_instance_uid, dicom_file_type, modality from (
select
   distinct series_instance_uid, modality, sop_instance_uid,
   file_id, dicom_file_type
 from file_series natural join file_sop_common
   natural join ctp_file natural join dicom_file
where
  project_name = ? and site_name = ? and modality = ?
  and visibility is null)
as foo
group by series_instance_uid, sop_instance_uid, dicom_file_type, modality)
as foo
group by series_instance_uid, dicom_file_type, modality
', ARRAY['project_name', 'site_name', 'modality'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('ListOfUncategorizedDciodvfyWarnings', 'select distinct warning_text, count(*)  as num_occurances from dciodvfy_warning
where
  warning_type = ''Uncategorized''
group by 
warning_text', '{}', 
                    ARRAY['warning_text', 'num_occurances'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'All dciodvfy uncategorized warnings in DB')
        ;

            insert into queries
            values ('InsertActivityTimepointFile', 'insert into activity_timepoint_file(
  activity_timepoint_id, file_id
) values (
  ?, ?
)', ARRAY['actiity_id', 'file_id'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('FilesIdsInSeriesWithVisibilityAndCollection', 'select
  file_id, project_name as collection, visibility
from
  ctp_file
  natural join file_series
where
  series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'collection', 'visibility'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteStatusVisible', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status = ?
  and visibility is null
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name', 'status'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetBackgroundReportFilename', 'select root_path || ''/'' || rel_path as filename
from file
natural join file_location
natural join file_storage_root
where file_id = ?
', ARRAY['file_id'], 
                    ARRAY['filename'], '{}', 'posda_files', 'Get the filename of a background report, by file_id')
        ;

            insert into queries
            values ('CountsCollectionDateRangeBySubject', 'select
  distinct
    patient_id,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name = ? and visibility is null
group by
  patient_id
order by
  patient_id
', ARRAY['from', 'to', 'collection'], 
                    ARRAY['patient_id', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AllPixelInfoByBitDepth', 'select
  f.file_id as file_id, root_path || ''/'' || rel_path as file,
  file_offset, size, modality,
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  file_image f natural join image natural join unique_pixel_data
  natural join file_series
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
  select distinct file_id
  from
    ctp_file natural join file_image natural join image
  where visibility is null and bits_allocated = ?
)
', ARRAY['bits_allocated'], 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for all files
')
        ;

            insert into queries
            values ('SubjectsWithModalityByCollectionSite', 'select
  distinct patient_id, count(*) as num_files
from
  ctp_file natural join file_patient natural join file_series
where
  modality = ? and project_name = ? and site_name = ?
group by patient_id
order by patient_id
', ARRAY['modality', 'project_name', 'site_name'], 
                    ARRAY['patient_id', 'num_files'], ARRAY['FindSubjects'], 'posda_files', 'Find All Subjects with given modality in Collection, Site
')
        ;

            insert into queries
            values ('InsertIntoFileRoiImageLinkage', 'insert into file_roi_image_linkage(
  file_id,
  roi_id,
  linked_sop_instance_uid,
  linked_sop_class_uid,
  contour_file_offset,
  contour_length,
  contour_digest,
  num_points,
  contour_type
) values (
  ?, ?, ?, ?, ?, ?, ?, ?, ?
)', ARRAY['file_id', 'roi_id', 'linked_sop_instance_uid', 'linked_sop_class_uid', 'contour_file_offset', 'contour_length', 'contour_digest', 'num_points', 'contour_type'], 
                    '{}', ARRAY['NotInteractive', 'used_in_processing_structure_set_linkages'], 'posda_files', 'Get the file_storage root for newly created files')
        ;

            insert into queries
            values ('SopsDupsInDifferentSeriesByLikeCollection', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, sop_instance_uid,
  file_id, file_path
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id, root_path ||''/'' || rel_path as file_path
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
    join file_location using(file_id) join file_storage_root using(file_storage_root_id)
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name like ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
order by sop_instance_uid

', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'subj_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'file_path'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('GetDicomFilesByImportName', 'select
  distinct file_id                                                                                                                                                                                                                                                                                                                                                                                                                                from
  import_event natural join file_import natural join dicom_file
where
  import_type = ''posda-api import'' and import_comment = ?', ARRAY['import_name'], 
                    ARRAY['file_id'], ARRAY['posda_files', 'sops', 'BySopInstance', 'by_file'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('RoundInfoById', 'select
  round_id, collection,
  round_created,
  round_start,  
  round_end,
  round_aborted,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where round_id = ?
order by round_id, collection', ARRAY['round_id'], 
                    ARRAY['round_id', 'collection', 'round_created', 'round_start', 'round_end', 'round_aborted', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Summary of round by id')
        ;

            insert into queries
            values ('CreateVisualReviewInstance', 'insert into visual_review_instance(
  visual_review_reason,
  visual_review_scheduler,
  visual_review_num_series,
  when_visual_review_scheduled
) values (
  ?, ?, ?, now()
)', ARRAY['visual_review_reason', 'visual_review_scheduler', 'visual_review_num_series'], 
                    '{}', ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Create a visual review instance')
        ;

            insert into queries
            values ('SeriesNotLikeWithModality', 'select
   distinct series_instance_uid, series_description, count(*)
from (
  select
   distinct
     file_id, series_instance_uid, series_description
  from
     ctp_file natural join file_series
  where
     modality = ? and project_name = ? and site_name = ? and 
     series_description not like ? and visibility is null
) as foo
group by series_instance_uid, series_description
', ARRAY['modality', 'collection', 'site', 'description_not_matching'], 
                    ARRAY['series_instance_uid', 'series_description', 'count'], ARRAY['find_series', 'pattern', 'posda_files'], 'posda_files', 'Select series not matching pattern by modality
')
        ;

            insert into queries
            values ('SeriesListByCollectionSiteModalityVisualReviewStatus', 'select 
  distinct
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and
  review_status = ?
  and modality = ?
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
', ARRAY['project_name', 'site_name', 'review_status', 'modality'], 
                    ARRAY['dicom_file_type', 'modality', 'review_status', 'num_series', 'num_files', 'series_instance_uid'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetNonDicomEditCompareToFiles', 'select 
  path,
  file_id,
  collection,
  visibility
from 
  (
    select to_file_path as path, to_file_digest as digest
    from non_dicom_edit_compare
    where subprocess_invocation_id = ?
  ) as foo natural left join
  file natural left join non_dicom_file', ARRAY['subprocess_invocation_id'], 
                    ARRAY['path', 'file_id', 'collection', 'visibility'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Before import:
       There should be no file_id (i.e. file has not been imported)  And there should be no collection.
       (i.e. normally file_id, collection, and visibility are all null).')
        ;

            insert into queries
            values ('CloseDicomFileEditEvent', 'update dicom_edit_event
  set time_completed = now(),
  report_file = ?,
  notification_sent = ?
where
  dicom_edit_event_id = ?', ARRAY['report_file_id', 'notify', 'dicom_edit_event_id'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Increment edits done in dicom_edit_event table
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteSummary', 'select 
  distinct
  dicom_file_type,
  modality,
  review_status,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and visibility is null
group by
  dicom_file_type,
  modality,
  review_status
', ARRAY['project_name', 'site_name'], 
                    ARRAY['dicom_file_type', 'modality', 'review_status', 'num_series', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('SeriesByLikeDescriptionAndCollection', 'select distinct
  series_instance_uid, series_description
from
  file_series natural join ctp_file
where project_name = ? and series_description like ?
', ARRAY['collection', 'pattern'], 
                    ARRAY['series_instance_uid', 'series_description'], ARRAY['find_series'], 'posda_files', 'Get a list of Series by Collection matching Series Description
')
        ;

            insert into queries
            values ('LatestActivityTimepointsForActivity', 'select
  activity_id, a.when_created as activity_created,
  brief_description as activity_description, activity_timepoint_id,
  t.when_created as timepoint_created, 
  comment, creating_user
from
  activity a join activity_timepoint t using(activity_id)
where
  a.when_closed is null and
  activity_id = ?
order by activity_timepoint_id desc limit 1', ARRAY['activity_id'], 
                    ARRAY['activity_id', 'activity_created', 'activity_description', 'activity_timepoint_id', 'timepoint_created', 'comment', 'creating_user'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('FilesByModalityByCollectionSiteDateRange', 'select
  distinct patient_id, modality, series_instance_uid, sop_instance_uid, 
  root_path || ''/'' || file_location.rel_path as path,
  min(import_time) as earliest,
  max(import_time) as latest
from
  file_patient natural join file_series natural join file_sop_common natural join ctp_file
  natural join file_location natural join file_storage_root
  join file_import using(file_id) join import_event using(import_event_id)
where
  modality = ? and
  project_name = ? and 
  site_name = ? and
  import_time > ? and import_time < ? and
  visibility is null
group by patient_id, modality, series_instance_uid, sop_instance_uid, path', ARRAY['modality', 'collection', 'site', 'from', 'to'], 
                    ARRAY['patient_id', 'modality', 'series_instance_uid', 'sop_instance_uid', 'path', 'earliest', 'latest'], ARRAY['FindSubjects', 'intake', 'FindFiles'], 'posda_files', 'Find All Files with given modality in Collection, Site')
        ;

            insert into queries
            values ('SubjectCountByCollectionSite', 'select
  distinct
    patient_id, count(distinct file_id)
from
  ctp_file natural join file_patient
where
  project_name = ? and site_name = ? and visibility is null
group by
  patient_id 
order by
  patient_id
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'count'], ARRAY['counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('IntakeFilesInSeries', 'select
  dicom_file_uri as file_path
from
  general_image
where
  series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['file_path'], ARRAY['intake', 'used_in_simple_phi'], 'intake', 'List of all Series By Collection, Site on Intake
')
        ;

            insert into queries
            values ('ReviewEditsBySiteCollectionLike', 'select
  distinct project_name,
  site_name,
  series_instance_uid, 
  new_visibility, 
  reason_for,
  min(time_of_change) as earliest,
  max(time_of_change) as latest,
  count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join
  file_series
where 
  site_name = ? and project_name like ?
group by 
  project_name, site_name, series_instance_uid, new_visibility, reason_for', ARRAY['site', 'CollectionLike'], 
                    ARRAY['project_name', 'site_name', 'series_instance_uid', 'new_visibility', 'reason_for', 'earliest', 'latest', 'num_files'], ARRAY['Hierarchy', 'review_visibility_changes'], 'posda_files', 'Show all file visibility changes by series for site')
        ;

            insert into queries
            values ('GetSubprocessLines', 'select
  line
from subprocess_lines
where
  subprocess_invocation_id = ?
order by line_number
', ARRAY['subprocess_invocation_id'], 
                    ARRAY['line'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('OneFileInSeries', 'select
  distinct root_path || ''/'' || rel_path as file
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_series
where
  series_instance_uid = ? and visibility is null
limit 1
', ARRAY['series_instance_uid'], 
                    ARRAY['file'], ARRAY['by_series', 'find_files', 'used_in_simple_phi'], 'posda_files', 'Get files in a series from posda database
')
        ;

            insert into queries
            values ('DistinctStudySeriesByCollectionSite', 'select distinct study_instance_uid as study_uid, series_instance_uid as series_uid, patient_id, dicom_file_type, modality, count(*)
from (
select distinct study_instance_uid, series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality from (
select
   distinct study_instance_uid, series_instance_uid, patient_id, modality, sop_instance_uid,
   file_id, dicom_file_type
 from file_series natural join file_sop_common
   natural join ctp_file natural join dicom_file natural join file_patient natural join file_study
where
  project_name = ? and site_name = ?
  and visibility is null)
as foo
group by study_instance_uid, series_instance_uid, patient_id, sop_instance_uid, dicom_file_type, modality)
as foo
group by study_uid, series_uid, patient_id, dicom_file_type, modality
', ARRAY['collection', 'site'], 
                    ARRAY['study_uid', 'series_uid', 'patient_id', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('CollectionSiteWithDicomFileTypesNotProcessed', 'select 
  distinct project_name as collection, site_name as site, dicom_file_type, count(distinct file_id)
from
  dicom_file d natural join ctp_file
where
  visibility is null  and
  not exists (
    select file_id 
    from file_series s
    where s.file_id = d.file_id
  )
group by project_name, site_name, dicom_file_type', '{}', 
                    ARRAY['collection', 'site', 'dicom_file_type', 'count'], ARRAY['dicom_file_type'], 'posda_files', 'List of Distinct Collection, Site, Dicom File Types which have unprocessed DICOM files
')
        ;

            insert into queries
            values ('PublicFilesInSeries', 'select
  dicom_file_uri as file_path
from
  general_image
where
  series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['file_path'], ARRAY['public', 'used_in_simple_phi'], 'public', 'List of all Series By Collection, Site on Intake
')
        ;

            insert into queries
            values ('GetNonDicomEditCompareDisposition', 'select
  num_edits_scheduled,
  num_compares_with_diffs,
  num_compares_without_diffs,
  current_disposition,
  dest_dir
from
  non_dicom_edit_compare_disposition
where
  subprocess_invocation_id = ?
  ', ARRAY['subprocess_invocation_id'], 
                    ARRAY['num_edits_scheduled', 'num_compares_with_diffs', 'num_compares_without_diffs', 'current_disposition', 'dest_dir'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('MarkDicomFileAsNotHavingPixelData', 'update dicom_file set has_pixel_data = false where file_id = ?', ARRAY['file_id'], 
                    '{}', ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'see name')
        ;

            insert into queries
            values ('SimplePublicPhiReportSelectedVR', 'select 
  distinct element_sig_pattern as element, vr, value, tag_name, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and
  not is_private and
  vr in (''SH'', ''OB'', ''PN'', ''DA'', ''ST'', ''AS'', ''DT'', ''LO'', ''UI'', ''CS'', ''AE'', ''LT'', ''ST'', ''UC'', ''UN'', ''UR'', ''UT'')
group by element_sig_pattern, vr, value, tag_name
order by vr, element_sig_pattern, value', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'tag_name', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('TotalsByDateRange', 'select distinct
	project_name,
	site_name,

	count(distinct patient_id) as num_subjects,
	count(distinct study_instance_uid) as num_studies,
	count(distinct series_instance_uid) as num_series,
	count(distinct sop_instance_uid) as total_files
from
	import_event
	natural join file_import
	natural join ctp_file
	natural join file_study
	natural join file_series
	natural join file_sop_common
	natural join file_patient

where
	visibility is null
	and import_time between ? and ? 

group by
	project_name,
	site_name
', ARRAY['from', 'to'], 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], ARRAY['AllCollections', 'DateRange', 'Kirk', 'Totals', 'count_queries', 'end_of_month'], 'posda_files', 'Get posda totals by date range

**WARNING:**  This query can run for a **LONG** time if you give it a large date range.
It is intended for short date ranges (i.e. "What came in last night?" or "What came in last month?")
')
        ;

            insert into queries
            values ('ApiImportEvents', 'select
  import_event_id, import_comment, import_time,
  import_close_time - import_time as duration, 
  count(distinct file_id) as num_images,
  (import_close_time - import_time) / count(distinct file_id) as per_sec
from 
  import_event natural join file_import
where
  import_comment like ? and import_type = ''posda-api import''
group by import_event_id, import_comment, import_time, import_close_time', ARRAY['import_comment_like'], 
                    ARRAY['import_event_id', 'import_comment', 'import_time', 'duration', 'num_images', 'per_sec'], ARRAY['import_events'], 'posda_files', 'Get Import Events by matching comment')
        ;

            insert into queries
            values ('ListOfPrivateElementsWithNullDispositionsByScanId', 'select
  distinct element_signature, vr , private_disposition as disposition,
  element_signature_id, name_chain
from
  element_signature natural join scan_element natural join series_scan
where
  is_private and scan_event_id = ? and private_disposition is null
order by element_signature
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'vr', 'disposition', 'element_signature_id', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('PrivateTagCountValueList', 'select 
  distinct element_signature, vr, value, private_disposition as disposition, count(*) as num_files
from
  element_signature natural join scan_element natural join seen_value
where
  is_private
group by element_signature, vr, value, private_disposition
order by element_signature, vr, value', '{}', 
                    ARRAY['vr', 'value', 'element_signature', 'num_files', 'disposition'], ARRAY['postgres_status', 'PrivateTagKb', 'NotInteractive'], 'posda_phi', 'Get List of Private Tags with All Values
')
        ;

            insert into queries
            values ('dicom_files_with_no_ctp_file', 'select distinct patient_id, dicom_file_type, modality, count(distinct file_id) as num_files
from dicom_file d natural join file_patient natural join file_series
where not exists (select file_id from ctp_file c where c.file_id = d.file_id) 
group by patient_id, dicom_file_type, modality', '{}', 
                    ARRAY['patient_id', 'dicom_file_type', 'modality', 'num_files'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetNonDicomFileById', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FinalizeVisualReviewScheduling', 'update visual_review_instance set
  when_visual_review_sched_complete = now()
where
  visual_review_instance_id = ?', ARRAY['visual_review_instance_id'], 
                    '{}', ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Get Id of Visual Review Instance')
        ;

            insert into queries
            values ('GetNLocationsAndDigestsByFileStorageRootId', 'select
  file_id, digest, rel_path
from file_location natural join file
where
  file_storage_root_id = ?
limit ?', ARRAY['file_storage_root_id', 'n'], 
                    ARRAY['file_id', 'digest', 'rel_path'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get root_path for a file_storage_root
')
        ;

            insert into queries
            values ('CreateDciodvfyScanInstance', 'insert into dciodvfy_scan_instance(
  type_of_unit,
  description_of_scan,
  number_units,
  scanned_so_far,
  start_time
) values (
  ?, ?, ?, 0, now()
)', ARRAY['type_of_unit', 'description_of_scan', 'number_units'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('GetPopupDefinition', 'select
  command_line, input_line_format,
  operation_name, operation_type,
  tags
from 
  spreadsheet_operation
where
  operation_name = ?
', ARRAY['operation_name'], 
                    NULL, ARRAY['NotInteractive', 'used_in_process_popup'], 'posda_queries', 'N
o
n
e')
        ;

            insert into queries
            values ('SeriesFileCount', 'select
  count(distinct file_id) as num_files
from
  file_series natural join
  ctp_file
where 
    series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['num_files'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('RoiInfoByFileIdWithCounts', 'select
  distinct roi_id, for_uid, linked_sop_instance_uid,
  max_x, max_y, max_z,
  min_x, min_y, min_z,
  roi_name, roi_description , roi_interpreted_type,
  count(*) as num_contours
from
  roi natural join file_roi_image_linkage 
where file_id = ?
group by 
  roi_id, for_uid, linked_sop_instance_uid,
  max_x, max_y, max_z,
  min_x, min_y, min_z,
  roi_name,
  roi_description, roi_interpreted_type', ARRAY['file_id'], 
                    ARRAY['roi_id', 'for_uid', 'linked_sop_instance_uid', 'max_x', 'max_y', 'max_z', 'min_x', 'min_y', 'min_z', 'roi_name', 'roi_description', 'roi_interpreted_type', 'num_contours'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('PatientStudySeriesFileHierarchyByCollectionSiteExt', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  count(*)
from
  file_study natural join
  dicom_file natural join
  ctp_file natural join
  file_series natural join 
  file_patient natural join
  file_sop_common
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and visibility is null
  )
group by
  patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series, with Modality of file')
        ;

            insert into queries
            values ('FindFilesInStudyWithDescriptionByStudyUID', 'select distinct
  study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag, count(*)
from
  file_study natural join ctp_file
where study_instance_uid = ? and visibility is null
group by
  study_instance_uid, study_date, study_time,
  referring_phy_name, study_id, accession_number,
  study_description, phys_of_record, phys_reading,
  admitting_diag
', ARRAY['study_instance_uid'], 
                    ARRAY['study_instance_uid', 'count', 'study_description', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'phys_of_record', 'phys_reading', 'admitting_diag'], ARRAY['by_study', 'consistency'], 'posda_files', 'Find SopInstanceUID and Description for All Files In Study
')
        ;

            insert into queries
            values ('VisibleImagesWithDetailsAndFileIdByVisualId', 'select 
  distinct patient_id, study_instance_uid, series_instance_uid, sop_instance_uid, modality, 
  file_id
from 
  file_patient natural join file_study natural join file_series natural join 
  file_sop_common natural join ctp_file
where series_instance_uid in (
  select
    distinct series_instance_uid
  from
    image_equivalence_class natural join file_series natural join
    image_equivalence_class_input_image natural join dicom_file natural join ctp_file
  where
    visual_review_instance_id = ? 
)
and visibility is null', ARRAY['visual_review_instance_id'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'modality', 'file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetSsVolume', 'select 
  for_uid, study_instance_uid, series_instance_uid,
  sop_class as sop_class_uid, sop_instance as sop_instance_uid
  from ss_for natural join ss_volume where structure_set_id in (
    select 
      structure_set_id 
    from
      file_structure_set fs, file_sop_common sc
    where
      sc.file_id = fs.file_id and sop_instance_uid = ?
)
', ARRAY['sop_instance_uid'], 
                    ARRAY['for_uid', 'study_instance_uid', 'series_instance_uid', 'sop_class_uid', 'sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('VisualReviewStatusDetailsOld', 'select 
  distinct image_equivalence_class_id, series_instance_uid, processing_status, review_status
from 
  image_equivalence_class natural join image_equivalence_class_input_image natural join dicom_file
where 
  visual_review_instance_id = ? and processing_status = ? and 
  (review_status= ?  or review_status is null)  and dicom_file_type = ?', ARRAY['visual_review_instance_id', 'processing_status', 'review_status', 'dicom_file_type'], 
                    ARRAY['image_equivalence_class_id', 'series_instance_uid', 'processing_status', 'review_status'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('SimplePhiReportAllRelevantPrivateOnlyWithMetaQuotes', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element,
  vr, ''<'' || value || ''>'' as q_value, tag_name as description, private_disposition as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and is_private and private_disposition not in (''d'', ''na'', ''o'', ''h'')
group by element_sig_pattern, vr, value, description, disp
order by vr, element', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'q_value', 'description', 'disp', 'num_series'], ARRAY['adding_ctp', 'for_scripting', 'phi_reports'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('GetCtpFileRow', 'select file_id from ctp_file where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'See if ctp_file_row exists')
        ;

            insert into queries
            values ('TagsSeenPrivateWithCount', 'select
  distinct element_signature, 
  vr, 
  private_disposition, 
  name_chain, 
  count(distinct value) as num_values
from
  element_signature natural left join
  scan_element natural left join
  seen_value
where is_private
group by element_signature, vr, private_disposition, name_chain
order by element_signature, vr', '{}', 
                    ARRAY['element_signature', 'vr', 'private_disposition', 'name_chain', 'num_values'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi', 'Get all the data from tags_seen in posda_phi database
')
        ;

            insert into queries
            values ('GetSpreadsheetInfoForRadcompDisp', 'select
  distinct patient_id,
  study_instance_uid as study_uid, 
  series_instance_uid as series_uid,
  baseline_date - diagnosis_date + interval ''1 day'' as shift,
  count(distinct file_id) as num_files
from
  file_patient natural join file_series natural join file_study natural join ctp_file,
  patient_mapping
where
  patient_id = to_patient_id and
  ctp_file.project_name = ? and ctp_file.visibility is null
group by
  patient_id, study_uid, series_uid, shift', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_uid', 'series_uid', 'num_files', 'shift'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('UpdateEquivalenceClassReviewStatus', 'update image_equivalence_class
set review_status = ?
where image_equivalence_class_id = ?
', ARRAY['processing_status', 'image_equivalence_class_id'], 
                    '{}', ARRAY['consistency', 'find_series', 'equivalence_classes', 'NotInteractive'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('GetElementDispositionVR', 'select
  element_signature_id, element_signature, vr, private_disposition as disposition, name_chain
from
  element_signature
where
  element_signature = ? and vr = ?
', ARRAY['element_signature', 'vr'], 
                    ARRAY['element_signature_id', 'element_signature', 'vr', 'disposition', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('GetPixelDescriptorByDigest', 'select
  samples_per_pixel, 
  number_of_frames, 
  pixel_rows,
  pixel_columns,
  bits_stored,
  bits_allocated,
  high_bit, 
  file_offset,
  root_path || ''/'' || rel_path as path
from
  image
  natural join unique_pixel_data
  natural join pixel_location
  join file_location using (file_id)
  join file_storage_root using (file_storage_root_id)
where digest = ?
limit 1', ARRAY['pixel_digest'], 
                    ARRAY['samples_per_pixel', 'number_of_frames', 'pixel_rows', 'pixel_columns', 'bits_stored', 'bits_allocated', 'high_bit', 'file_offset', 'path'], ARRAY['meta', 'test', 'hello'], 'posda_files', 'Find Duplicated Pixel Digest')
        ;

            insert into queries
            values ('GetFileSizeAndPathById', 'select
  root_path || ''/'' || rel_path as path,
  size
from
  file_storage_root natural join file_location natural join file 
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['path', 'size'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('RoundSummary1', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups),
  ((round_end - round_start) / sum(num_entered + num_dups)) as sec_per_file
from
  round natural join round_collection
where
  round_end is not null 
group by 
  round_id, round_start, duration, round_end 
order by round_id', '{}', 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum', 'sec_per_file'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('GetNonDicomConversionInfoById', 'select
  root_path || ''/'' || rel_path as path,
  non_dicom_file.file_type,
  file_sub_type,
  collection, site, subject, visibility, size,
  date_last_categorized
from
  file_storage_root natural join file_location natural join non_dicom_file join file using(file_id)
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['path', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'size', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('TagsNotInAnyFilter', 'select
  distinct tag
from(
  select unnest(tags) as tag
  from queries
) as tag_q
where tag not in (select tag
from (
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
) ', '{}', 
                    ARRAY['tag'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('BackgroundProcessStatsWithInvokerLikeComand', 'select
  distinct operation_name, command_executed, invoking_user as invoker, 
  max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null and operation_name like ?
group by operation_name, command_executed, invoker', ARRAY['operation_name_like'], 
                    ARRAY['operation_name', 'command_executed', 'invoker', 'longest', 'shortest', 'avg', 'times_invoked', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetEditStatusByDisposition', 'select
  subprocess_invocation_id as id,
  start_creation_time, end_creation_time - start_creation_time as duration,
  number_edits_scheduled as to_edit,
  number_compares_with_diffs as changed,
  number_compares_without_diffs as not_changed,
  current_disposition as disposition,
  dest_dir
from
  dicom_edit_compare_disposition
where 
  current_disposition like ?
order by start_creation_time desc', ARRAY['disposition'], 
                    ARRAY['id', 'start_creation_time', 'duration', 'to_edit', 'changed', 'not_changed', 'disposition', 'dest_dir'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits', 'testing_edit_objects', 'edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('AllSubjectsWithNoStatus', 'select
  distinct patient_id, project_name, site_name,
  count(*) as num_files
from
  file_patient natural join ctp_file
where
  patient_id in (
    select 
      distinct patient_id
    from
      file_patient p
    where
       not exists (
         select
           patient_id
         from
            patient_import_status s
         where
            p.patient_id = s.patient_id
       )
  ) 
  and visibility is null
group by patient_id, project_name, site_name
order by project_name, site_name, patient_id
', '{}', 
                    ARRAY['patient_id', 'project_name', 'site_name', 'num_files'], ARRAY['FindSubjects', 'PatientStatus'], 'posda_files', 'All Subjects With No Patient Import Status
')
        ;

            insert into queries
            values ('GetSpreadsheetInfoForRadcompDispWithModality', 'select
  distinct patient_id,
  study_instance_uid as study_uid, 
  series_instance_uid as series_uid,
  modality,
  baseline_date - diagnosis_date + interval ''1 day'' as shift,
  count(distinct file_id) as num_files
from
  file_patient natural join file_series natural join file_study natural join ctp_file,
  patient_mapping
where
  patient_id = to_patient_id and
  ctp_file.project_name = ? and ctp_file.visibility is null
group by
  patient_id, study_uid, series_uid, modality, shift', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_uid', 'series_uid', 'modality', 'num_files', 'shift'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('RecordReportInsertion', 'insert into report_inserted(
  report_file_in_posda, report_rows_generated, background_subprocess_id
)values(
  ?, ?, ?
)', ARRAY['posda_id_of_report_file', 'rows_in_report', 'background_subprocess_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Record the upload of a report file by a background subprocess

used in a background subprocess when a report file is uploaded')
        ;

            insert into queries
            values ('GetOpenActivities', 'select
  activity_id, brief_description, when_created, who_created, when_closed
from activity
where when_closed is null

', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('SummaryOfImportsFromEditByDateRange', 'select
  distinct import_type, min(import_time) as earliest,
  max(import_time) as latest, count(distinct import_event_id) as num_imports,
  sum(num_files) as total_files
from (
  select * from (
    select distinct import_event_id, import_time, import_type, import_comment, count(distinct file_id) as num_files
    from import_event natural join file_import
    where import_time > ? and import_time < ?
    group by import_event_id, import_time, import_type, import_comment
    order by import_time desc
  ) as foo
  where num_files > 1 and import_comment like ''%dicom_edit_compare%''
) as foo 
group by import_type;', ARRAY['from', 'to'], 
                    ARRAY['import_type', 'earliest', 'latest', 'num_imports', 'total_files'], ARRAY['downloads_by_date', 'import_events'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('NullPatientAgeByCollection', 'select
  file_id, root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location natural join ctp_file natural join file_patient
where
  project_name = ? and visibility is null and patient_age is null', ARRAY['collection'], 
                    ARRAY['file_id', 'path'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetValuesByEleVr', 'select
  distinct value
from
  element_signature
  join scan_element using(element_signature_id)
  join seen_value using (seen_value_id)
where
  element_signature = ? and vr = ?
', ARRAY['element_signature', 'vr'], 
                    ARRAY['value'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get All  values in posda_phi by element, vr')
        ;

            insert into queries
            values ('ElementsWithMultipleVRs', 'select element_signature, count from (
  select element_signature, count(*)
  from (
    select
      distinct element_signature, vr
    from
      scan_event natural join series_scan
      natural join scan_element natural join element_signature
      natural join equipment_signature
    where
      scan_event_id = ?
  ) as foo
  group by element_signature
) as foo
where count > 1
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of Elements with multiple VRs seen
')
        ;

            insert into queries
            values ('SeriesWithRGB', 'select
  distinct series_instance_uid
from
  image natural join file_image
  natural join file_series
  natural join ctp_file
where
  photometric_interpretation = ''RGB''
  and visibility is null
', '{}', 
                    ARRAY['series_instance_uid'], ARRAY['find_series', 'posda_files', 'rgb'], 'posda_files', 'Get distinct pixel types with geometry and rgb
')
        ;

            insert into queries
            values ('ActivityStuffMoreBySubprocessInvocationId', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where subprocess_invocation_id = ?', ARRAY['subprocess_invocation_id'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('UpdateEquivalenceClassProcessingStatus', 'update image_equivalence_class
set processing_status = ?
where image_equivalence_class_id = ?
', ARRAY['processing_status', 'image_equivalence_class_id'], 
                    '{}', ARRAY['consistency', 'find_series', 'equivalence_classes', 'NotInteractive'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('TotalsByDateRangeAndCollection', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
from (
  select
    distinct project_name, site_name, patient_id, count(*) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
  from (
    select
       distinct project_name, site_name, patient_id, study_instance_uid, 
       count(*) as num_series, sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id, study_instance_uid, 
        series_instance_uid, count(*) as num_files 
      from (
        select
          distinct project_name, site_name, patient_id, study_instance_uid,
          series_instance_uid, sop_instance_uid 
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common natural join file_patient
           natural join file_import natural join import_event
        where
          visibility is null and import_time >= ? and
          import_time < ? and project_name = ?
      ) as foo
      group by
        project_name, site_name, patient_id, 
        study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', ARRAY['start_time', 'end_time', 'project_name'], 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], ARRAY['DateRange', 'Kirk', 'Totals', 'end_of_month'], 'posda_files', 'Get posda totals by date range
')
        ;

            insert into queries
            values ('FilePathByFileId', 'select
  root_path || ''/'' || rel_path as path
from
  file_location natural join file_storage_root
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['path'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send', 'for_comparing_dups', 'used_in_file_import_into_posda', 'reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('FilesSeriesSopsVisibilityInTimepoint', 'select 
  file_id, patient_id, study_instance_uid, series_instance_uid, sop_instance_uid, 
  project_name as collection, site_name as site, visibility, modality,
  dicom_file_type as type
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
  natural join dicom_file
  natural join ctp_file
where file_id in (
  select file_id from activity_timepoint natural join activity_timepoint_file where activity_timepoint_id = ?)', ARRAY['activity_timepoint_id'], 
                    ARRAY['file_id', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'collection', 'site', 'visibility', 'modality', 'type'], ARRAY['compare_series'], 'posda_files', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('PossiblyRunningSubprocesses', 'select
  subprocess_invocation_id, command_line, invoking_user,
  when_invoked, now() - when_invoked as duration
from
  subprocess_invocation natural left join background_subprocess
where
  when_background_entered is null and subprocess_invocation_id != 0 and
  scrash is null and process_pid is null
order by subprocess_invocation_id', '{}', 
                    ARRAY['subprocess_invocation_id', 'command_line', 'invoking_user', 'when_invoked', 'duration'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FinalizeNonDicomEditCompareDisposition', 'update non_dicom_edit_compare_disposition set
  end_creation_time = now(),
  last_updated = now(),
  current_disposition = ''Comparisons Complete''
where
  subprocess_invocation_id = ?
', ARRAY['subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_edit'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition to indicate its done.

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('SubjectCountsDateRangeSummaryByCollectionSiteDateRange', 'select 
  distinct patient_id,
  min(import_time) as from,
  max(import_time) as to,
  count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops
from 
  ctp_file natural join file_patient natural join file_import natural join import_event
  natural join file_sop_common
where
  project_name = ? and site_name = ? and import_time > ? and
  import_time < ?
group by patient_id
order by patient_id', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['patient_id', 'from', 'to', 'num_files', 'num_sops'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AAA_import_test_query1', 'select ''2492183'' as file_id
union
select ''4372774'' as file_id
', '{}', 
                    ARRAY['file_id'], ARRAY['AllCollections', 'DateRange', 'Kirk', 'Totals', 'count_queries', 'end_of_month'], 'posda_files', 'Get posda totals by date range

**WARNING:**  This query can run for a **LONG** time if you give it a large date range.
It is intended for short date ranges (i.e. "What came in last night?" or "What came in last month?")
(Ignore this line, it is a test!)
')
        ;

            insert into queries
            values ('TableSizePosdaQueries', 'select *, pg_size_pretty(total_bytes) AS total
    , pg_size_pretty(index_bytes) AS INDEX
    , pg_size_pretty(toast_bytes) AS toast
    , pg_size_pretty(table_bytes) AS TABLE
  FROM (
  SELECT *, total_bytes-index_bytes-COALESCE(toast_bytes,0) AS table_bytes FROM (
      SELECT c.oid,nspname AS table_schema, relname AS TABLE_NAME
              , c.reltuples AS row_estimate
              , pg_total_relation_size(c.oid) AS total_bytes
              , pg_indexes_size(c.oid) AS index_bytes
              , pg_total_relation_size(reltoastrelid) AS toast_bytes
          FROM pg_class c
          LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
          WHERE relkind = ''r''
  ) a
) a where table_schema = ''public'' order by total_bytes desc', '{}', 
                    ARRAY['table_schema', 'table_name', 'row_estimate', 'total_bytes', 'index_bytes', 'total', 'toast_bytes', 'index', 'toast', 'table'], ARRAY['AllCollections', 'postgres_stats', 'table_size'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('AllPatientDetailsWithNoCtpLike', 'select
  distinct 
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series f
where
 not exists (select file_id from ctp_file c where c.file_id = f.file_id)
 and patient_id like ?
group by
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  patient_id, study_date,
  modality
', ARRAY['patient_id_like'], 
                    ARRAY['patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_details'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetGeometricInfo', 'select 
  distinct sop_instance_uid, iop as image_orientation_patient,
  ipp as image_position_patient,
  pixel_spacing,
  pixel_rows as i_rows,
  pixel_columns as i_columns
from
  file_sop_common join 
  file_patient using (file_id) join
  file_image using (file_id) join 
  file_series using (file_id) join
  file_study using (file_id) join
  image using (image_id) join
  file_image_geometry using (file_id) join
  image_geometry using (image_geometry_id) 
where 
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['sop_instance_uid', 'image_orientation_patient', 'image_position_patient', 'pixel_spacing', 'i_rows', 'i_columns'], ARRAY['LinkageChecks', 'BySopInstance'], 'posda_files', 'Get Geometric Information by Sop Instance UID from posda')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSite', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and
    visibility is null
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy', 'apply_disposition'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('GetListOfUnprocessedStructureSets', 'select
  file_id,
  root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location
where file_id in (
  select distinct file_id
  from dicom_file df natural join ctp_file
  where 
  dicom_file_type = ''RT Structure Set Storage''
  and visibility is null and has_no_roi_linkages is null
  and not exists (
    select file_id from file_roi_image_linkage r where r.file_id = df.file_id
  )
) ', '{}', 
                    ARRAY['file_id', 'path'], ARRAY['NotInteractive', 'used_in_processing_structure_set_linkages'], 'posda_files', 'Get the file_storage root for newly created files')
        ;

            insert into queries
            values ('GetModuleToTableArgs', 'select *
from 
  dicom_tag_parm_column_table natural left join tag_preparation
where posda_table_name = ?', ARRAY['table_name'], 
                    ARRAY['tag_cannonical_name', 'tag', 'posda_table_name', 'column_name', 'preparation_description'], ARRAY['bills_test', 'posda_db_populate'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DuplicateCtpFile', 'select
  distinct project_name as collection,
  site_name as site,
  dicom_file_type,
  count(distinct file_id) as num_files,
  min(import_time) as first,
  max(import_time) as last,
  count(*) as num_imports,
  max(import_time) - min(import_time) as duration
from
   ctp_file natural join dicom_file natural join file_import natural join import_event
where file_id in (
  select file_id from (
    select distinct file_id, count(*) from dicom_file group by file_id 
  ) as foo where count > 1
) group by collection, site, dicom_file_type order by collection, site;', '{}', 
                    ARRAY['collection', 'site', 'dicom_file_type', 'num_files', 'first', 'last', 'num_imports', 'duration'], ARRAY['AllCollections', 'queries'], 'posda_files', 'Get a list of available queries')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionIntake', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
group by series_instance_uid, modality', ARRAY['project_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'intake'], 'intake', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('DistinctVisibleFileReportByPatientCollectionSite', 'select distinct
  project_name as collection, site_name as site, patient_id, study_instance_uid,
  series_instance_uid, sop_instance_uid, dicom_file_type, modality, file_id
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
  natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ? and patient_id = ? and visibility is null
order by series_instance_uid', ARRAY['project_name', 'site_name', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_type', 'modality', 'file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('MarkEquivalenceClassForRetry', 'update image_equivalence_class set
  processing_status = ''ReadyToProcess'',
  review_status = null
where image_equivalence_class_id = ?', ARRAY['image_equivalence_class_id'], 
                    '{}', ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('RecordFileConversion', 'insert into non_dicom_conversion(from_file_id, to_file_id, conversion_event_id)
values(?, ?, ?)', ARRAY['from_file_id', 'to_file_id', 'conversion_event_id'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetHiddenToFiles', 'select 
  f.file_id as file_id,
  c.visibility as visibility 
from
  dicom_edit_compare dec,
  file f,
  ctp_file c
where
  dec.to_file_digest = f.digest and
  f.file_id = c.file_id and 
  c.visibility is not null and
  dec.subprocess_invocation_id = ?', ARRAY['subprocess_invocation_id'], 
                    ARRAY['file_id', 'visibility'], ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Insert edit_event
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('BackgroundProcessStats', 'select
  distinct command_executed, max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  count(distinct invoking_user) as num_invokers,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null
group by command_executed
order by last desc, times_invoked desc', '{}', 
                    ARRAY['command_executed', 'longest', 'shortest', 'avg', 'times_invoked', 'num_invokers', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('ComplexDuplicatePixelDataNew', 'select distinct project_name as collection,
site_name as site,
patient_id as patient,
series_instance_uid, count(distinct file_id) as num_files
from
ctp_file natural join file_patient
natural join file_series where file_id in (
select file_id from 
file_image join image using(image_id) 
join unique_pixel_data using (unique_pixel_data_id)
where digest in (
select distinct pixel_digest as digest from (
select
  distinct pixel_digest, count(*) as num_pix_dups
from (
   select 
       distinct unique_pixel_data_id, pixel_digest, project_name,
       site_name, patient_id, count(*) 
  from (
    select
      distinct unique_pixel_data_id, file_id, project_name,
      site_name, patient_id, 
      unique_pixel_data.digest as pixel_digest 
    from
      image join file_image using(image_id)
      join ctp_file using(file_id)
      join file_patient fq using(file_id)
      join unique_pixel_data using(unique_pixel_data_id)
    where visibility is null
  ) as foo 
  group by 
    unique_pixel_data_id, project_name, pixel_digest,
    site_name, patient_id
) as foo 
group by pixel_digest) as foo
where num_pix_dups = ?))
group by collection, site, patient, series_instance_uid
order by num_files desc', ARRAY['num_pix_dups'], 
                    ARRAY['collection', 'site', 'patient', 'series_instance_uid', 'num_files'], ARRAY['pix_data_dups', 'pixel_duplicates'], 'posda_files', 'Find series with duplicate pixel count of <n>
')
        ;

            insert into queries
            values ('GetFileIdByFileId', 'select
  file_id
from
  file
where
  file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_id'], ARRAY['by_file_id', 'posda_files', 'slope_intercept'], 'posda_files', 'Get a Slope, Intercept for a particular file 
')
        ;

            insert into queries
            values ('GetModuleToPosdaTable', 'select * from dicom_module_to_posda_table', '{}', 
                    ARRAY['dicom_module_name', 'create_row_query', 'table_name'], ARRAY['bills_test', 'posda_db_populate'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FilesInSeriesForSend', 'select
  distinct file_id, root_path || ''/'' || rel_path as path, xfer_syntax, sop_class_uid,
  data_set_size, data_set_start, sop_instance_uid, digest
from
  file_location natural join file_storage_root
  natural join dicom_file natural join ctp_file
  natural join file_sop_common natural join file_series
  natural join file_meta natural join file
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'path', 'xfer_syntax', 'sop_class_uid', 'data_set_size', 'data_set_start', 'sop_instance_uid', 'digest'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send'], 'posda_files', 'Get everything you need to negotiate a presentation_context
for all files in a series
')
        ;

            insert into queries
            values ('ClosedPlanarContoursWithoutLinksByFile', 'select
  distinct roi_id,
  roi_name
from
  file_structure_set natural join
  structure_set natural join
  roi natural join 
  roi_contour r
where
  file_id =? and 
  geometric_type = ''CLOSED_PLANAR'' and 
  not exists (
    select roi_contour_id from contour_image ci where ci.roi_contour_id = r.roi_contour_id
  )', ARRAY['file_id'], 
                    ARRAY['roi_id', 'roi_name'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('FinalizeDciodvfyUnitScan', 'update dciodvfy_unit_scan set
  num_errors_in_unit = ?,
  num_warnings_in_unit = ?,
  end_time = now()
where
  dciodvfy_unit_scan_id = ?
 ', ARRAY['num_errors_in_unit', 'num_warnings_in_unit', 'unit_scan_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_unit_scan row')
        ;

            insert into queries
            values ('ListOpenActivitiesWithItems', 'select
  distinct activity_id,
  brief_description,
  when_created,
  who_created,
  count(distinct user_inbox_content_id) as num_items
from
  activity natural join activity_inbox_content
where when_closed is null
group by activity_id, brief_description, when_created, who_created
order by activity_id desc', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'num_items'], ARRAY['AllCollections', 'queries', 'activities'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('UnlinkEmailFromActivity', 'delete from activity_inbox_content
where activity_id = ? and user_inbox_content_id = ?', ARRAY['activity_id', 'user_inbox_content_id'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteVisible', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and visibility is null
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('AllQueryTabs', 'select 
   distinct  query_tab_name
from
  query_tabs', '{}', 
                    ARRAY['query_tab_name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PatientStudySeriesFileHierarchyByCollection', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  root_path || ''/'' || rel_path as path
from
  file_study natural join ctp_file natural join file_series natural join file_patient
  natural join file_sop_common natural join file_location
  natural join file_storage_root
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and visibility is null
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'path'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('GetSopModalityPathDigest', 'select 
  sop_instance_uid, modality,
  root_path || ''/'' || rel_path as path,
  digest
from
  file natural join file_series natural join file_sop_common natural join file_location natural join file_storage_root
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance_uid', 'modality', 'path', 'digest'], ARRAY['bills_test', 'comparing_posda_to_public'], 'posda_files', 'get sop_instance, modality, and path to file by file_id')
        ;

            insert into queries
            values ('GetSopOfSsReferenceByPlan', 'select
  distinct ss_referenced_from_plan as sop_instance_uid
from
  plan natural join file_plan
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance_uid'], ARRAY['LinkageChecks', 'used_in_plan_linkage_check'], 'posda_files', 'Get Plan Reference Info for RTDOSE by file_id
')
        ;

            insert into queries
            values ('AddTagToQuery', 'update queries
set tags = array_append(tags, ?)
where name = ?', ARRAY['tag', 'name'], 
                    '{}', ARRAY['query_tags', 'meta', 'test', 'hello'], 'posda_queries', 'Add a tag to a query')
        ;

            insert into queries
            values ('GetConversionId', 'select currval(''conversion_event_conversion_event_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PixelInfoByImageId', 'select
  root_path || ''/'' || rel_path as file, file_offset, size, 
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  image natural join unique_pixel_data natural join pixel_location
  natural join file_location natural join file_storage_root
where image_id = ?
', ARRAY['image_id'], 
                    ARRAY['file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation'], '{}', 'posda_files', 'Get pixel descriptors for a particular image id
')
        ;

            insert into queries
            values ('CountsByCollectionDateRange', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and visibility is null
  and import_time > ? and import_time < ?
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'from', 'to'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('StudyNickname', 'select
  project_name, site_name, subj_id, study_nickname
from
  study_nickname
where
  study_instance_uid = ?
', ARRAY['study_instance_uid'], 
                    ARRAY['project_name', 'site_name', 'subj_id', 'study_nickname'], '{}', 'posda_nicknames', 'Get a nickname, etc for a particular study uid
')
        ;

            insert into queries
            values ('GetPublicTagDispositionBySignature', 'select
  disposition
from public_tag_disposition
where tag_name = ?
', ARRAY['signature'], 
                    ARRAY['disposition'], ARRAY['DispositionReport', 'NotInteractive'], 'posda_public_tag', 'Get the disposition of a public tag by signature
Used in DispositionReport.pl - not for interactive use
')
        ;

            insert into queries
            values ('DistinctPatientStudySeriesByCollectionDateRange', 'select distinct
  patient_id, 
  study_instance_uid,
  series_instance_uid, 
  dicom_file_type,
  modality, 
  count(distinct file_id) as num_files
from
  ctp_file
  natural join dicom_file
  natural join file_study
  natural join file_series
  natural join file_patient
  natural join file_import
  natural join import_event
where
  project_name = ? and
  visibility is null and
  import_time > ?
  and import_time < ?
group by
  patient_id, 
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality
  ', ARRAY['collection', 'from', 'to'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('InsertIntoNonDicomAttachments', 'insert into non_dicom_attachments(
  non_dicom_file_id,
  dicom_file_id,
  patient_id,
  manifest_uid,
  study_instance_uid,
  series_instance_uid,
  manifest_date,
  version
)values(
  ?, ?, ?, ?, ?, ?, ?, ?
)
', ARRAY['non_dicom_file_id', 'dicom_file_id', 'patient_id', 'manifest_uid', 'study_instance_uid', 'series_instance_uid', 'manifest_date', 'version'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetDciodvfyWarningUnrecog', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''UnrecognizedTag''
  and warning_tag = ?
  and warning_comment = ?
 ', ARRAY['warning_tag', 'warning_comment'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('GetDicomEditCompareToFiles', 'select 
  path,
  file_id,
  project_name,
  visibility
from 
  (
    select to_file_path as path, to_file_digest as digest
    from dicom_edit_compare
    where subprocess_invocation_id = ?
  ) as foo natural left join
  file natural left join ctp_file', ARRAY['subprocess_invocation_id'], 
                    ARRAY['path', 'file_id', 'project_name', 'visibility'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Normally there should be no file_id (i.e. file has not been imported)')
        ;

            insert into queries
            values ('GetPlansReferencingBadSS', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from plan p natural join file_plan  where
not exists (select sop_instance_uid from file_sop_common fsc where p.ss_referenced_from_plan 
= fsc.sop_instance_uid))', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetPhiNonDicomScanId', 'select
  currval(''phi_non_dicom_scan_instance_phi_non_dicom_scan_instance_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('VisualReviewStatusWithCollectionById', 'select 
  distinct project_name as collection, site_name as site, 
  series_instance_uid, review_status, modality, series_description,
  series_date, count(distinct image_equivalence_class_id) as num_equiv_classes, 
  count(distinct file_id) as num_files
from
  visual_review_instance natural join image_equivalence_class natural join
  image_equivalence_class_input_image natural join
  file_series natural join ctp_file
where
  visual_review_instance_id = ? and review_status = ? and visibility is null
group by collection, site, series_instance_uid, review_status, modality, series_description, series_date;', ARRAY['visual_review_instance_id', 'review_status'], 
                    ARRAY['collection', 'site', 'series_instance_uid', 'review_status', 'modality', 'series_description', 'series_date', 'num_equiv_classes', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionWithoutFurtherBreakdown', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  date_trunc(''day'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, patient_id, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetDatasetStart', 'select
  data_set_start
from
  file_meta
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['data_set_start'], ARRAY['AllCollections', 'universal', 'public_posda_consistency'], 'posda_files', 'Get path to file by id')
        ;

            insert into queries
            values ('SeriesWithMultiplePatientIds', 'select
  distinct series_instance_uid,
  patient_id
from
  file_series natural join file_patient natural join ctp_file                                                      
where series_instance_uid in (                                                                                                                                                        
  select distinct series_instance_uid from (                                                                                                                                                                                    
     select * from (
        select distinct series_instance_uid, count(*) from (
          select distinct series_instance_uid, patient_id
          from file_series natural join file_patient natural join ctp_file
          where project_name = ? and visibility is null
        ) as foo group by series_instance_uid
      ) as foo where count > 1
   ) as foo
) and
visibility is null', ARRAY['collection'], 
                    ARRAY['series_instance_uid', 'patient_id'], ARRAY['by_study', 'consistency', 'series_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('PhiScanStatusInProcess', 'select
  scan_event_id as id,
  scan_started as start_time,
  scan_ended as end_time,
  scan_ended - scan_started as duration,
  scan_status as status,
  scan_description as description,
  num_series_to_scan as to_scan,
  num_series_scanned as scanned,
  (((now() - scan_started) / num_series_scanned) * (num_series_to_scan -
  num_series_scanned)) + now() as projected_completion,
  (cast(num_series_scanned as float) / 
    cast(num_series_to_scan as float)) * 100.0 as percentage
from
  scan_event
where
   num_series_to_scan > num_series_scanned
   and num_series_scanned > 0
order by id
', '{}', 
                    ARRAY['id', 'description', 'start_time', 'end_time', 'duration', 'status', 'to_scan', 'scanned', 'percentage', 'projected_completion'], ARRAY['tag_usage', 'obsolete'], 'posda_phi', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetDoseReferencingGoodPlan', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from rt_dose d  natural join file_dose  where
exists (select sop_instance_uid from file_sop_common fsc where d.rt_dose_referenced_plan_uid
= fsc.sop_instance_uid))', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['LinkageChecks', 'dose_linkages'], 'posda_files', 'Get list of plan which reference known SOPs

')
        ;

            insert into queries
            values ('GetSopsInSeriesforLGCP', 'select
  sop_instance_uid, file_id, for_uid
from 
  file_series natural join file_for natural join ctp_file
  natural join file_sop_common
where series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'file_id', 'for_uid'], ARRAY['Curation of Lung-Fused-CT-Pathology'], 'posda_files', 'Get SOP instance uid, file_id, and path for each file in series')
        ;

            insert into queries
            values ('CreateRound', 'insert into round(
  round_created
) values (
  now()
)
', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Create a row in round table to record files_imported in this round')
        ;

            insert into queries
            values ('GetVisibilityByFileId', 'select
  file_id, visibility
from
   ctp_file
where
   file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_id', 'visibility'], ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Get Visibility for a file by file_id
')
        ;

            insert into queries
            values ('ImportsLikeType', 'select
  distinct import_type, import_comment, import_time,
  sum(num_files) as total_files
from (
  select * from (
    select
      distinct import_event_id, import_time, import_type, import_comment, count(distinct file_id) as num_files 
    from
      import_event natural join file_import
    where import_time > ? and import_time < ?
    group by import_event_id, import_time, import_type, import_comment order by import_time desc
  ) as foo
  where num_files > 1 and import_type like ?
) as foo
group by import_type, import_time, import_comment', ARRAY['from', 'to', 'type_like'], 
                    ARRAY['import_type', 'import_comment', 'import_time', 'total_files'], ARRAY['downloads_by_date', 'import_events'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetSsReferencingKnownImagesByCollection', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  ctp_file natural join file_patient natural join file_series
where file_id in (
  select
    distinct ss_file_id as file_id 
  from (
    select
      sop_instance_uid, ss_file_id 
    from (
      select 
        distinct
           linked_sop_instance_uid as sop_instance_uid,
           file_id as ss_file_id
      from
        file_roi_image_linkage
    ) foo left join file_sop_common using(sop_instance_uid)
    join ctp_file using(file_id)
  where
    visibility is null
  ) as foo
)
and project_name = ? and visibility is null
order by collection, site, patient_id, file_id
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of RTSTRUCT which reference known SOPs by Collection

')
        ;

            insert into queries
            values ('SeriesForPhi', 'select 
  series_instance_uid 
from 
  series_scan_instance
where series_scan_instance_id in (
  select series_scan_instance_id from (
    select * from element_value_occurance 
    where
      phi_scan_instance_id = ? and
      element_seen_id in (
        select element_seen_id from element_seen
        where element_sig_pattern = ?
      ) and 
      value_seen_id in (
        select value_seen_id from value_seen
        where value = ?
      )
  ) as foo
)', ARRAY['scan_id', 'element_sig_pattern', 'value'], 
                    ARRAY['series_instance_uid'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('background_subprocesses_by_date', 'select 
  background_subprocess_id as bkgrnd_id, subprocess_invocation_id as invoc_id,
  operation_name, command_line, invoking_user, when_script_started
from
  background_subprocess natural left join subprocess_invocation where invoking_user = ?
  and when_script_ended is not null
  and when_script_started > ? and when_script_started < ?
order by when_script_started desc', ARRAY['invoking_user', 'from', 'to'], 
                    ARRAY['bkgrnd_id', 'invoc_id', 'operation_name', 'command_line', 'invoking_user', 'when_script_started'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CurrentPatientStatii', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  patient_import_status
from 
  ctp_file natural join file_patient natural left join patient_import_status
where 
  visibility is null', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'patient_import_status'], ARRAY['counts', 'patient_status', 'for_bill_counts'], 'posda_files', 'Get the current status of all patients')
        ;

            insert into queries
            values ('AllPixelInfoByPhotometricInterp', 'select
  f.file_id as file_id, root_path || ''/'' || rel_path as file,
  file_offset, size, modality,
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  file_image f natural join image natural join unique_pixel_data
  natural join file_series
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
  select distinct file_id
  from
    ctp_file natural join file_image natural join image
  where visibility is null and photometric_interpretation = ?
)
', ARRAY['bits_allocated'], 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for all files
')
        ;

            insert into queries
            values ('GetPatientMapping', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  diagnosis_date,
  baseline_date,
  date_shift,
  baseline_date - diagnosis_date + interval ''1 day'' as computed_shift
from
  patient_mapping
  ', '{}', 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('SeriesNickname', 'select
  project_name, site_name, subj_id, series_nickname
from
  series_nickname
where
  series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['project_name', 'site_name', 'subj_id', 'series_nickname'], '{}', 'posda_nicknames', 'Get a nickname, etc for a particular series uid
')
        ;

            insert into queries
            values ('GetFileVisibilityByDigest', 'select distinct file_id,  visibility from file natural join ctp_file where digest = ?', ARRAY['digest'], 
                    ARRAY['file_id', 'visibility'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get current visibility by file_id
')
        ;

            insert into queries
            values ('ActivityStuffMoreByUser', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where invoking_user = ?
order by subprocess_invocation_id desc
', ARRAY['user'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ListOfUncategorizedDciodvfyErrors', 'select distinct error_text, count(*)  as num_occurances from dciodvfy_error
where
  error_type = ''Uncategorized''
group by 
error_text', '{}', 
                    ARRAY['error_text', 'num_occurances'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'All dciodvfy uncategorized warnings in DB')
        ;

            insert into queries
            values ('PatientIdAndMappingByNonDicomFileId', 'select
  from_patient_id, to_patient_id, to_patient_name, collection_name, site_name,
  batch_number, diagnosis_date, baseline_date, date_shift, uid_root,
  baseline_date - diagnosis_date + interval ''1 day'' as computed_shift
from 
  patient_mapping pm, non_dicom_file ndf
where
  pm.from_patient_id = ndf.subject and
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'uid_root', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('SeriesWithDuplicatePixelDataThatMatters', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  count(distinct file_id) as num_files
from 
  file_series natural join file_image
  natural join file_patient
  natural join ctp_file
where 
  visibility is null 
  and image_id in (
select image_id from (
  select distinct image_id, count(*)
  from (
    select distinct image_id, file_id
    from (
      select
        file_id, image_id, patient_id, study_instance_uid, 
        series_instance_uid, sop_instance_uid, modality
      from
        file_patient natural join file_series natural join 
        file_study natural join file_sop_common
        natural join file_image
      where file_id in (
        select file_id
        from (
          select image_id, file_id 
          from file_image 
          where image_id in (
            select image_id
            from (
              select distinct image_id, count(*)
              from (
                select distinct image_id, file_id
                from file_image where file_id in (
                  select distinct file_id
                  from ctp_file
                  where project_name = ? and visibility is null
                )
              ) as foo
              group by image_id
            ) as foo 
            where count > 1
          )
        ) as foo
      )
    ) as foo
  ) as foo
  group by image_id
) as foo 
where count > 1
) group by collection, site, patient_id, series_instance_uid
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'series_instance_uid', 'patient_id', 'num_files'], ARRAY['pixel_duplicates'], 'posda_files', 'Return a list of files with duplicate pixel data,
restricted to those files which have parsed DICOM data
representations in Database.
')
        ;

            insert into queries
            values ('AllPatientDetailsWithNoCtpByImportEvent', 'select
  distinct 
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series f
where
 not exists (select file_id from ctp_file c where c.file_id = f.file_id)
 and file_id in (select file_id from file_import where import_event_id = ?)
group by
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  patient_id, study_date,
  modality
', ARRAY['import_event_id'], 
                    ARRAY['patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_details'], 'posda_files', 'List patient details without CTP, selected by import event
')
        ;

            insert into queries
            values ('FindingImageProblemCT', 'select
  distinct dicom_file_type, project_name,  
  patient_id, min(import_time), max(import_time), count(distinct file_id) 
from
  ctp_file natural join dicom_file natural join
  file_patient natural join file_import natural join 
  import_event 
where file_id in (
  select file_id 
  from (
    select file_id, image_id 
    from ctp_file natural join file_series left join file_image using(file_id)
    where modality = ''CT'' and project_name = ''Exceptional-Responders'' and file_id in (
      select
         distinct file_id from file_import natural join import_event natural join dicom_file
      where import_time > ''2018-09-17''
    )
  ) as foo where image_id is null
) 
and visibility is null
group by dicom_file_type, project_name, patient_id
order by patient_id', '{}', 
                    ARRAY['dicom_file_type', 'project_name', 'patient_id', 'min', 'max', 'count'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('DistinctSopsInCollectionIntake', 'select
  distinct i.sop_instance_uid
from
  general_image i,
  trial_data_provenance tdp
where
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
order by sop_instance_uid
', ARRAY['collection'], 
                    ARRAY['sop_instance_uid'], ARRAY['by_collection', 'intake', 'sops'], 'intake', 'Get Distinct SOPs in Collection with number files
Only visible files
')
        ;

            insert into queries
            values ('StudiesInPublicHnsccWithMostCtAndRt', 'select
 patient_id, study_instance_uid, num_images as num_cts
from (
  select 
    distinct i.patient_id, t.study_instance_uid,
    s.series_instance_uid, 
    t.study_desc, series_desc, count(*) as num_images
  from 
    general_image i, trial_data_provenance tdp, general_series s, study t
  where
    i.study_pk_id = t.study_pk_id and i.trial_dp_pk_id = tdp.trial_dp_pk_id and 
    i.general_series_pk_id = s.general_series_pk_id and tdp.project = ''HNSCC'' and
    modality = ''CT'' and t.study_desc = ''RT SIMULATION'' 
  group by series_instance_uid
) as foo order by num_images desc', '{}', 
                    ARRAY['patient_id', 'study_instance_uid', 'num_cts'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'public', 'Name says it all')
        ;

            insert into queries
            values ('PatientIdByNonDicomFileId', 'select subject from non_dicom_file where file_id = ?', ARRAY['file_id'], 
                    ARRAY['subject'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('QueryByName', 'select
  name, description, query,
  array_to_string(tags, '','') as tags
from queries
where name = ?
', ARRAY['name'], 
                    ARRAY['name', 'description', 'query', 'tags'], ARRAY['AllCollections', 'queries'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('SeriesConsistencyExtended', 'select distinct
  series_instance_uid, modality, series_number, laterality, series_date, dicom_file_type,
  series_time, performing_phys, protocol_name, series_description,
  operators_name, body_part_examined, patient_position,
  smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
  performed_procedure_step_start_date, performed_procedure_step_start_time,
  performed_procedure_step_desc, performed_procedure_step_comments, image_type,
  iop, pixel_rows, pixel_columns,
  count(*)
from
  file_series natural join ctp_file natural join dicom_file
  left join file_image using(file_id)
  left join image using (image_id)
  left join image_geometry using (image_id)
where series_instance_uid = ? and visibility is null
group by
  series_instance_uid, dicom_file_type, modality, series_number, laterality,
  series_date, image_type, iop, pixel_rows, pixel_columns,
  series_time, performing_phys, protocol_name, series_description,
  operators_name, body_part_examined, patient_position,
  smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
  performed_procedure_step_start_date, performed_procedure_step_start_time,
  performed_procedure_step_desc, performed_procedure_step_comments
', ARRAY['series_instance_uid'], 
                    ARRAY['series_instance_uid', 'count', 'dicom_file_type', 'modality', 'laterality', 'series_number', 'series_date', 'image_type', 'series_time', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_start_time', 'performed_procedure_step_desc', 'performed_procedure_step_comments', 'iop', 'pixel_rows', 'pixel_columns'], ARRAY['by_series', 'consistency'], 'posda_files', 'Check a Series for Consistency (including Image Type)
')
        ;

            insert into queries
            values ('ApiImportEventsForPatient', 'select
  import_event_id, import_comment, import_time,
  import_close_time - import_time as duration, patient_id,
  count(distinct file_id) as num_images
from 
  import_event natural join file_import natural join file_patient
where
  import_comment like ? and import_type = ''posda-api import'' and patient_id like ?
group by import_event_id, import_comment, import_time, import_close_time, patient_id', ARRAY['import_comment_like', 'patient_id_like'], 
                    ARRAY['import_event_id', 'import_comment', 'import_time', 'duration', 'patient_id', 'num_images'], ARRAY['import_events'], 'posda_files', 'Get Import Events by matching comment')
        ;

            insert into queries
            values ('ImportEvents', 'select
  distinct import_event_id, import_time,  count(distinct file_id) as num_files
from
  import_event natural join file_import
where
  import_type = ''single file import'' and 
  import_time > ? and import_time < ?
group by import_event_id, import_time', ARRAY['from', 'to'], 
                    ARRAY['import_event_id', 'import_time', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetFilePathPublicBySopInst', 'select
  dicom_file_uri
from
  general_image
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['dicom_file_uri'], ARRAY['posda_files', 'sops', 'BySopInstance'], 'public', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('SeriesReport', 'select 
  file_id, sop_instance_uid, modality, cast(instance_number as int) inst_num, iop, ipp
from 
  file_series natural join file_sop_common 
  left join file_image_geometry using(file_id) 
  left join image_geometry using(image_geometry_id)
where file_id in (
  select 
  file_id from file_series natural join ctp_file
  where series_instance_uid = ?
    and visibility is null
) order by inst_num;', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'modality', 'inst_num', 'iop', 'ipp', 'sop_instance_uid'], ARRAY['by_series_instance_uid', 'duplicates', 'posda_files', 'sops', 'series_report'], 'posda_files', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('SeriesForFile', 'select series_instance_uid from file_series where file_id = ?', ARRAY['file_id'], 
                    ARRAY['series_instance_uid'], ARRAY['activity_timepoint_support'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ListOfQueriesPerformedAllWithLatestAndCountAndUser', 'select
  distinct invoking_user, query_name,
  max(query_start_time) as last_invocation, 
  count(query_invoked_by_dbif_id) as num_invocations,
  sum(query_end_time - query_start_time) as total_query_time,
  avg(query_end_time - query_start_time) as avg_query_time
from 
  query_invoked_by_dbif
group by invoking_user, query_name
order by last_invocation  desc', '{}', 
                    ARRAY['invoking_user', 'query_name', 'last_invocation', 'num_invocations', 'total_query_time', 'avg_query_time'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('FinalizeDicomEditCompareDisposition', 'update dicom_edit_compare_disposition set
  end_creation_time = now(),
  current_disposition = ''Comparisons Complete''
where
  subprocess_invocation_id = ?
', ARRAY['subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition to indicate its done.

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteStatusNotGoodExtended', 'select
  distinct patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  series_modality as modality,
  review_status,
  num_files
from (
select 
  distinct series_instance_uid,
  dicom_file_type,
  modality as series_modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status != ''Good''
  and visibility is null
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
) as foo
  join file_series using (series_instance_uid)
  join file_study using (file_id) 
  join file_patient using(file_id)
  join ctp_file using(file_id)
where
  visibility is null
order by patient_id, study_instance_uid, series_instance_uid
', ARRAY['project_name', 'site_name'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('PatientStatusCountsByCollection', 'select
  distinct project_name as collection, patient_import_status as status,
  count(distinct patient_id) as num_patients
from
  patient_import_status natural join file_patient natural join ctp_file
where project_name = ? and visibility is null
group by collection, status
', ARRAY['collection'], 
                    ARRAY['collection', 'status', 'num_patients'], ARRAY['FindSubjects', 'PatientStatus'], 'posda_files', 'Find All Subjects which have at least one visible file
')
        ;

            insert into queries
            values ('InsertFileFrameOfRef', 'insert into file_for(file_id, for_uid, position_ref_indicator) values(?, ?, ?)', ARRAY['file_id', 'for_uid', 'position_ref_indicator'], 
                    '{}', ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('UpdateElementDispositionOnly', 'update element_signature set 
  private_disposition = ?
where
  element_signature = ? and
  vr = ?
', ARRAY['private_disposition', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Update Element Disposition
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetDoseReferencingBadPlan', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from rt_dose d natural join file_dose  where
not exists (select sop_instance_uid from file_sop_common fsc where d.rt_dose_referenced_plan_uid
= fsc.sop_instance_uid))', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['LinkageChecks', 'dose_linkages'], 'posda_files', 'Get list of RTDOSE which reference unknown SOPs

')
        ;

            insert into queries
            values ('IntakeCountsOld', 'select
        p.patient_id as PID,
        i.image_type as ImageType,
        s.modality as Modality,
        count(i.sop_instance_uid) as Images,
        t.study_date as StudyDate,
        t.study_desc as StudyDescription,
        s.series_desc as SeriesDescription,
        s.series_number as SeriesNumber,
        t.study_instance_uid as StudyInstanceUID,
        s.series_instance_uid as SeriesInstanceUID,
        q.manufacturer as Mfr,
        q.manufacturer_model_name as Model,
        q.software_versions,
        c.reconstruction_diameter as ReconstructionDiameter,
        c.kvp as KVP,
        i.slice_thickness as SliceThickness
     from
        general_image i,
        general_series s,
        study t,
        patient p,
        trial_data_provenance tdp,
        general_equipment q,
        ct_image c
     where
        i.general_series_pk_id = s.general_series_pk_id and
        s.study_pk_id = t.study_pk_id and
        s.general_equipment_pk_id = q.general_equipment_pk_id and
        t.patient_pk_id = p.patient_pk_id and
        p.trial_dp_pk_id = tdp.trial_dp_pk_id and
        tdp.project = ? and
        tdp.dp_site_name = ? and
        c.image_pk_id = i.image_pk_id
    group by p.patient_id, i.image_type, s.series_instance_uid, t.study_instance_uid
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'Modality', 'Images', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions', 'ImageType', 'ReconstructionDiameter', 'KVP', 'SliceThickness'], ARRAY['intake'], 'intake', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('GetCurrentPosdaFileId', 'select  currval(''file_file_id_seq'') as id
', '{}', 
                    ARRAY['file_id'], ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Get posda file id of created file row')
        ;

            insert into queries
            values ('InsertSendEvent', 'insert into dicom_send_event(
  destination_host, destination_port,
  called_ae, calling_ae,
  send_started, invoking_user,
  reason_for_send, number_of_files,
  is_series_send, series_to_send
)values(
  ?, ?,
  ?, ?,
  now(), ?,
  ?, ?,
  true, ?
)
', ARRAY['host', 'port', 'called', 'calling', 'who', 'why', 'num_files', 'series'], 
                    NULL, ARRAY['NotInteractive', 'SeriesSendEvent'], 'posda_files', 'Create a DICOM Series Send Event
For use in scripts.
Not meant for interactive use
')
        ;

            insert into queries
            values ('ClearPublicDispositions', 'delete from public_disposition where
  sop_class_uid = ? and name = ?

', ARRAY['sop_class_uid', 'name'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Clear all public dispositions for a give sop_class and name')
        ;

            insert into queries
            values ('SubjectsWithDupSopsByCollection', 'select
  distinct collection, site, subj_id, 
  count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops,
  min(import_time) as earliest,
  max(import_time) as latest
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    file_id, sop_instance_uid, import_time
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_import
    natural join import_event
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(*) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            project_name = ? and visibility is null
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'subj_id', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('WhichSeriesInCollectionSiteAreNotVisuallyReviewed', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
   series_instance_uid,
  dicom_file_type,
  modality,
  ''Not submitted for review'' as review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series ser natural join
  file_patient natural join  
  ctp_file
where
  project_name = ? and
  site_name = ?
  and visibility is null
  and not exists (
    select * from image_equivalence_class iec
    where iec.series_instance_uid = ser.series_instance_uid
  )
group by
  collection, site, patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetScanEventById', 'select * from scan_event where scan_event_id = ?
', ARRAY['scan_id'], 
                    ARRAY['scan_event_id', 'scan_started', 'scan_ended', 'scan_status', 'scan_description', 'num_series_to_scan', 'num_series_scanned'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('GetNonDicomFileTypeSubTypeCollectionSiteSubjectById', 'select 
  file_type,
  file_sub_type,
  collection,
  site,
  subject
from 
  non_dicom_file
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_type', 'file_sub_type', 'collection', 'site', 'subject'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Get stuff from non_dicom_file by id
')
        ;

            insert into queries
            values ('VisibilityChangeEventsBySeries', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  date_trunc(''hour'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files,
  count (distinct series_instance_uid) as num_series
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where series_instance_uid = ?
group by
 collection, site, patient_id, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files', 'num_series'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events', 'show_hidden'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CountsByCollection', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and visibility is null
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files'], ARRAY['counts'], 'posda_files', 'Counts query by Collection
')
        ;

            insert into queries
            values ('VisibleSeriesVisualReviewResultsByCollectionSiteStatus', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status = ?
  and visibility is null
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name', 'status'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('RoundSummaryWithCollectionDateRange', 'select
  distinct round_id, collection,
  round_start, 
  round_end - round_start as duration, 
  round_end
from
  round natural join round_collection
where
  round_end is not null and round_start > ? and round_end < ?
group by 
  round_id, collection, round_start, duration, round_end 
order by round_id', ARRAY['from', 'to'], 
                    ARRAY['round_id', 'collection', 'round_start', 'duration', 'round_end'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('ListOfCollectionsBySite', 'select 
    distinct project_name as collection, site_name, count(*) 
from 
   ctp_file natural join file_study natural join
   file_series
where
  visibility is null and site_name = ?
group by project_name, site_name
order by project_name, site_name
', ARRAY['site'], 
                    ARRAY['collection', 'site_name', 'count'], ARRAY['AllCollections', 'universal'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('ActivityTimepointsForActivityWithFileCount', 'select
  distinct activity_id, a.when_created as activity_created,
  brief_description as activity_description, activity_timepoint_id,
  t.when_created as timepoint_created, 
  comment, creating_user, count(distinct file_id) as file_count
from
  activity a join activity_timepoint t using(activity_id)
  left join activity_timepoint_file using (activity_timepoint_id)
where
  activity_id = ?
group by activity_id, a.when_created, brief_description,
  activity_timepoint_id, t.when_created, comment, creating_user
order by t.when_created desc', ARRAY['activity_id'], 
                    ARRAY['activity_id', 'activity_created', 'activity_description', 'activity_timepoint_id', 'timepoint_created', 'comment', 'creating_user', 'file_count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_queries', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetStructureSetVolumeByFileId', 'select
  distinct sop_instance
from
  ss_volume natural join ss_for natural join file_structure_set
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of SOP''s linked in SS

')
        ;

            insert into queries
            values ('VisualReviewSeriesByIdReviewStatusProcessingStatusAndDicomFileType', 'select 
  distinct image_equivalence_class_id, series_instance_uid
from
  visual_review_instance natural join image_equivalence_class natural join
  image_equivalence_class_input_image natural join dicom_file natural join 
  file_series natural join ctp_file
where
  visual_review_instance_id = ? and review_status = ? and processing_status = ? and dicom_file_type = ?
', ARRAY['visual_review_instance_id', 'review_status', 'processing_status', 'dicom_file_type'], 
                    ARRAY['image_equivalence_class_id', 'series_instance_uid'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('FileReportByImportEvent', 'select
  distinct project_name as collection, site_name as site, patient_id,
  study_instance_uid, study_date, study_description, series_instance_uid,
  modality, series_date, dicom_file_type, count(distinct file_id) as num_files
from
  file_import natural join file_patient natural join file_series natural join
  file_study natural join dicom_file natural left join ctp_file
where
  import_event_id = ?
group by
  collection, site, patient_id, study_instance_uid, study_date,
  study_description, series_instance_uid, modality, series_date, dicom_file_type;', ARRAY['import_event_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'modality', 'series_date', 'dicom_file_type', 'num_files'], ARRAY['import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DispositonsSimple', 'select 
  distinct 
  element_seen_id as id, 
  element_sig_pattern,
  vr,
  tag_name,
  private_disposition as disposition
from
  element_seen
where
  is_private
order by element_sig_pattern
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name', 'disposition'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionModality', 'select distinct series_instance_uid, patient_id, dicom_file_type, modality, count(distinct file_id) as num_files
 from file_series natural join file_sop_common
   natural join ctp_file natural join dicom_file natural join file_patient
where
  project_name = ? and modality = ?
  and visibility is null
group by series_instance_uid, patient_id, dicom_file_type, modality', ARRAY['collection', 'modality'], 
                    ARRAY['series_instance_uid', 'patient_id', 'dicom_file_type', 'modality', 'num_files'], ARRAY['by_collection', 'find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi', 'dciodvfy', 'edit_files'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetMaxProcessedFileId', 'select
  max(file_id) as file_id
from
  file
where
  is_dicom_file is not null
', '{}', 
                    ARRAY['file_id'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('UpdateSeriesFinished', 'update scan_event 
set scan_status = ''finished'',
  scan_ended = now()
where scan_event_id = ?', ARRAY['scan_event_id'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Update status to finished in scan event
')
        ;

            insert into queries
            values ('IsThisSeriesNotVisuallyReviewed', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  ''Not submitted for review'' as review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series ser natural join 
  ctp_file
where
  series_instance_uid = ?
  and visibility is null
  and not exists (
    select * from image_equivalence_class iec
    where iec.series_instance_uid = ser.series_instance_uid
  )
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['series_instance_uid'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('FilesInSeriesForApplicationOfPrivateDispositionIntake', 'select
  i.dicom_file_uri as path, i.sop_instance_uid, s.modality
from
  general_image i, general_series s
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.series_instance_uid = ?', ARRAY['series_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition', 'intake'], 'intake', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('FilesInSeriesForApplyingPrivateDisposition', 'select
  distinct file_id, root_path || ''/'' || rel_path as path, sop_instance_uid, 
  modality
from
  file_location natural join file_storage_root
  natural join ctp_file
  natural join file_sop_common natural join file_series
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'ApplyDisposition'], 'posda_files', 'Get Sop Instance UID, file_path, modality for all files in a series')
        ;

            insert into queries
            values ('LongestRunningNQueries', 'select * from (
select query_invoked_by_dbif_id as id, query_name, query_end_time - query_start_time as duration,
invoking_user, query_start_time, number_of_rows
from query_invoked_by_dbif
where query_end_time is not null
order by duration desc) as foo
limit ?', ARRAY['n'], 
                    ARRAY['id', 'query_name', 'duration', 'invoking_user', 'query_start_time', 'number_of_rows'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetElementByPrivateDisposition', 'select
  element_signature, private_disposition as disposition
from
  element_signature
where
  is_private and private_disposition = ?
', ARRAY['private_disposition'], 
                    ARRAY['element_signature', 'disposition'], ARRAY['NotInteractive', 'ElementDisposition'], 'posda_phi', 'Get List of Private Elements By Disposition')
        ;

            insert into queries
            values ('ToFilesFilesImportedByEditId', 'select
  count(distinct file_id) as files_imported
from (
    select distinct file_id from file f, dicom_edit_compare dec
     where f.digest = dec.to_file_digest and 
        subprocess_invocation_id = ?
  ) as foo
', ARRAY['subprocess_invocation_id'], 
                    ARRAY['files_imported'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits', 'edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('GetCTQP', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('IntakePatientsByCollectionSite', 'select
  distinct p.patient_id as PID, count(distinct i.image_pk_id) as num_images
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
group by PID
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'num_images'], ARRAY['intake'], 'intake', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('GetStudyInfoById', 'select
  file_id,
  study_instance_uid,
  study_date,
  study_time,
  referring_phy_name,
  study_id,
  accession_number,
  study_description,
  phys_of_record,
  phys_reading,
  admitting_diag
from file_study
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'study_instance_uid', 'study_date', 'study_time', 'referring_phy_name', 'study_id', 'accession_number', 'study_description', 'phys_of_record', 'phys_reading', 'phys_reading', 'admitting_diag'], ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('DciodvfyErrorIdByValue', 'select 
  distinct dciodvfy_error_id
from 
  dciodvfy_error
where
  error_value = ?', ARRAY['error_value'], 
                    ARRAY['dciodvfy_error_id'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'find dciodvfy_error_id by contents of error_value')
        ;

            insert into queries
            values ('GetActivityTimepointId', 'select currval(''activity_timepoint_activity_timepoint_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['by_collection', 'activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ReOpenActivity', 'update activity set
  when_closed = null
where
  activity_id = ?', ARRAY['activity_id'], 
                    '{}', ARRAY['activity_timepoint_support', 'activity_support'], 'posda_queries', 'Close an activity

')
        ;

            insert into queries
            values ('GetWinLev', 'select
  window_width, window_center, win_lev_desc, wl_index
from
  file_win_lev natural join window_level
where
  file_id = ?
order by wl_index desc;
', ARRAY['file_id'], 
                    ARRAY['window_width', 'window_center', 'win_lev_desc', 'wl_index'], ARRAY['by_file_id', 'posda_files', 'window_level'], 'posda_files', 'Get a Window, Level(s) for a particular file 
')
        ;

            insert into queries
            values ('GetNfilesToCopy', 'select
  c.sop_instance_uid,
  c.replace_file_id,
  c.copy_file_path
from file_copy_from_public c, ctp_file p
where
  c.copy_from_public_id = ? and
  (p.file_id = c.replace_file_id and p.visibility is null) and 
  (inserted_file_id is null)
limit ?', ARRAY['copy_from_public_id', 'count'], 
                    ARRAY['sop_instance_uid', 'replace_file_id', 'copy_file_path'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ShowQueryTabHierarchyByTabWithQueries', 'select
  query_tab_name, filter_name, tag, query_name
from (
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
  where query_tab_name = ?
) as foo
natural join(
  select name as query_name, unnest(tags) as tag
from queries
) as fie
order by filter_name, tag, query_name', ARRAY['query_tab_name'], 
                    ARRAY['query_tab_name', 'filter_name', 'tag', 'query_name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetNonSquareImageIds', 'select file_id from image natural join file_image  where pixel_rows != pixel_columns
offset ? limit ?', ARRAY['offset', 'limit'], 
                    ARRAY['file_id'], ARRAY['ImageEdit'], 'posda_files', 'Get list of dicom_edit_event')
        ;

            insert into queries
            values ('GetVisualReviewInstanceInfo', 'select 
  visual_review_reason
from
  visual_review_instance
where
  visual_review_instance_id = ?', ARRAY['visual_review_instance_id'], 
                    ARRAY['visual_review_reason'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of Series By Visual Review Id and Status
')
        ;

            insert into queries
            values ('VisibilityChangesByCollectionSite', 'select
  distinct project_name as collection, 
  site_name as site,
  user_name, prior_visibility, new_visibility,
  date_trunc(''hour'',time_of_change) as time, 
  reason_for, count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join 
  file_patient natural join 
  file_series
where
  project_name = ? and site_name = ?
group by 
  collection, site, user_name, prior_visibility, new_visibility,
  time, reason_for
order by time, collection, site', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'user_name', 'prior_visibility', 'new_visibility', 'time', 'reason_for', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('FindInconsistentStudyIgnoringStudyTime', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name = ? and visibility is null
    group by
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('InsertIntoPatientMappingBaselineNoBatch', 'insert into patient_mapping(
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  diagnosis_date,
  baseline_date) values (
  ?, ?, ?, ?, ?, ?, ?)', ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'diagnosis_date', 'baseline_date'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'insert_pat_mapping'], 'posda_files', 'Make an entry into the patient_mapping table with no batch and diagnosis_date, and baseline_date')
        ;

            insert into queries
            values ('CreateNonDicomFileById', 'insert into non_dicom_file(
  file_id, file_type, file_sub_type, collection, site, subject, date_last_categorized
)values(
  ?, ?, ?, ?, ?, ?, now()
)
', ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSeriesFileCountsByPatientId', 'select
  series_instance_uid, modality, dicom_file_type, count(distinct sop_instance_uid) as num_sops
from
  file_series natural join file_patient natural join 
  dicom_file natural join file_sop_common
where
  patient_id = ?
group by series_instance_uid, modality, dicom_file_type
', ARRAY['patient_id'], 
                    ARRAY['series_instance_uid', 'modality', 'dicom_file_type', 'num_sops'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Counts in file_series by patient_id

')
        ;

            insert into queries
            values ('DoesDoseReferenceNoPlan', 'select
  file_id
from
  rt_dose  natural join file_dose
where
  rt_dose_referenced_plan_uid is null
  and file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'used_in_dose_linkage_check'], 'posda_files', 'Return a row if file references no plan

')
        ;

            insert into queries
            values ('CreateSeenValue', 'insert into seen_value(value)values(?)', ARRAY['value'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create New Seen Value')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewedInSeriesExperiment', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  visibility,
  file_id
from 
  dicom_file natural join 
  file_series natural join 
  file_patient natural join
  ctp_file natural join 
(
  select file_id, review_status, processing_status
  from
    image_equivalence_class_input_image natural join
    image_equivalence_class join
    ctp_file using(file_id)
  where
    series_instance_uid = ?
) as foo

', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'visibility', 'file_id'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('RoundStatsWithCollectionForDateRange', 'select
  distinct collection, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
group by collection, time order by time desc, collection', ARRAY['interval', 'from', 'to'], 
                    ARRAY['collection', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('ListOfQueriesPerformedByUserWithLatestAndCount', 'select
  distinct query_name, query,
  max(query_start_time) as last_invocation, 
  count(query_invoked_by_dbif_id) as num_invocations,
  sum(query_end_time - query_start_time) as total_query_time,
  avg(query_end_time - query_start_time) as avg_query_time
from 
  query_invoked_by_dbif i, queries q
where invoking_user = ? and i.query_name = q.name
group by query_name, query
order by last_invocation  desc', ARRAY['user'], 
                    ARRAY['query_name', 'query', 'last_invocation', 'num_invocations', 'total_query_time', 'avg_query_time'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('AllManifestsBySite', 'select
  distinct file_id, import_time, size, root_path || ''/'' || l.rel_path as path, i.file_name as alt_path
from
  file_location l join file_storage_root using(file_storage_root_id) 
  join file_import i using (file_id) natural join file join import_event using(import_event_id)
where
  file_id in (
    select distinct file_id from ctp_manifest_row where cm_site = ?
  )', ARRAY['site'], 
                    ARRAY['file_id', 'import_time', 'size', 'path', 'alt_path'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('InsertAdverseFileEvent', 'insert into adverse_file_event(
  file_id, event_description, when_occured
) values (?, ?, now())
', ARRAY['file_id', 'event_description'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Insert adverse_file_event row
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetPosdaSopCountByPatientId', 'select
  distinct patient_id,
  count(distinct sop_instance_uid) as num_sops
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  patient_id = ? 
  and visibility is null
group by patient_id', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'num_sops'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('GetNonDicomFileIdTypeAndPathByCollectionSite', 'select
  file_id, non_dicom_file.file_type as file_type, file_sub_type,
  root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location natural join non_dicom_file
where
  collection = ? and site = ?
  and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'path'], ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_files', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('DupSopsWithConflictingPixels', 'select distinct sop_instance_uid, count
  from (
    select
      distinct sop_instance_uid, count(*)
    from (
      select
        sop_instance_uid, unique_pixel_data.digest as pixel_digest
      from
        file_sop_common natural join file natural join file_image join
        image using (image_id) join unique_pixel_data using (unique_pixel_data_id)
    )as foo group by sop_instance_uid
  ) as foo where count > 1', '{}', 
                    ARRAY['sop_instance_uid', 'count'], ARRAY['pix_data_dups'], 'posda_files', 'Find list of series with SOP with duplicate pixel data')
        ;

            insert into queries
            values ('WhereFileSitsExt', 'select distinct
  project_name as collection,
  site_name as site,
  visibility,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || file_location.rel_path as path,
  date_trunc(''day'',  min(import_time)) as earliest_import_day,
  date_trunc(''day'', max(import_time)) as latest_import_day
from
  dicom_file natural join
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  file_import natural join
  import_event 
  natural left join ctp_file
  join file_location using(file_id)
  natural join file_storage_root
where file_id = ?
group by 
  project_name, site_name, visibility,
  patient_id, study_instance_uid, series_instance_uid,
  sop_instance_uid, sop_class_uid, modality, dicom_file_type, path', ARRAY['file_id'], 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'path', 'earliest_import_day', 'latest_import_day'], ARRAY['posda_files', 'sops', 'BySopInstance', 'by_file'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('SeriesEquipmentByValueSignature', 'select
  distinct series_instance_uid, element_signature, value, vr,
  equipment_signature
from
  scan_event natural join series_scan
  natural join scan_element natural join element_signature
  natural join equipment_signature
  natural join seen_value
where
  scan_event_id = ? and
  value = ? and
  element_signature = ?
order by value, element_signature, vr
', ARRAY['scan_id', 'value', 'tag_signature'], 
                    ARRAY['series_instance_uid', 'value', 'vr', 'element_signature', 'equipment_signature'], ARRAY['tag_usage'], 'posda_phi', 'List of series, values, vr seen in scan with equipment signature
')
        ;

            insert into queries
            values ('RowsInDicomFileWithNoPixelInfoRecent', 'select 
  file_id, root_path || ''/'' || rel_path as path
from dicom_file natural join file_location natural join file_storage_root
where has_pixel_data is null 
order by file_id desc limit ?', ARRAY['num_rows'], 
                    ARRAY['file_id', 'path'], ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'List of files (id, path) which are dicom_files with undefined pixel info')
        ;

            insert into queries
            values ('VisibleFilesByCollectionSitePatient', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id, visibility
from
  ctp_file natural join file_patient
where
  project_name = ? and
  site_name = ? and
  patient_id = ? and
  visibility is null
order by collection, site, patient_id

', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'visibility'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('CountRowsInDicomFileWithUnpopulatedPixelInfo', 'select 
 count(*) from dicom_file where has_pixel_data is null', '{}', 
                    ARRAY['count'], ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'count rows in dicom_file with unpopulated pixel info')
        ;

            insert into queries
            values ('RoundCountsByCollection2DateRange', 'select
  round_id, collection,
  round_created,
  round_start,  
  round_end - round_start as duration,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where collection = ? and round_start > ? and round_end < ?
order by round_id, collection', ARRAY['collection', 'from', 'to'], 
                    ARRAY['round_id', 'collection', 'num_dups', 'round_created', 'round_start', 'duration', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('CtWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''CT Image Storage'' and 
  visibility is null and
  modality != ''CT''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('ActivityStuffMoreWithEmailByUserDateRange', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where invoking_user = ? and background_subprocess_report.name = ''Email''
  and when_script_started >= ? and when_script_ended <=?
order by subprocess_invocation_id desc
', ARRAY['user', 'from', 'to'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ShowFilesHiddenByCollectionSite', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  reason_for as reason,
  prior_visibility as before,
  new_visibility as after,
  user_name as user,
  count(distinct file_id) as num_files,
  min(time_of_change) as earliest,
  max(time_of_change) as latest
from 
  file_visibility_change natural join
  file_patient natural join
  ctp_file
where
  project_name = ? and site_name = ?
group by
   collection, site, 
   patient_id,
   reason, before, after, user_name
order by
  earliest, patient_id', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'reason', 'before', 'after', 'user', 'num_files', 'earliest', 'latest'], ARRAY['old_hidden'], 'posda_files', 'Show Files Hidden By User Date Range')
        ;

            insert into queries
            values ('InsertFileLocation', 'insert into file_location(
  file_id, file_storage_root_id, rel_path
) values ( ?, ?, ?)', ARRAY['file_id', 'file_storage_root_id', 'rel_path'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('GetDciodvfyWarningQuestionable', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''QuestionableValue''
  and warning_reason = ?
  and warning_tag = ?
  and warning_index = ?
 ', ARRAY['warning_reason', 'warning_tag', 'warning_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('VisibleColSiteWithCtpLikeSite', 'select
  distinct project_name as collection, site_name as site, count(*) as num_files
from ctp_file
where visibility is null and project_name like ?
group by collection, site order by collection', ARRAY['pattern'], 
                    ARRAY['collection', 'site', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'ctp_col_site', 'select_for_phi'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('WhereSeriesSits', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  count(distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
group by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_files'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('InsertFileCopyFromPublicRow', 'insert into file_copy_from_public(
  copy_from_public_id, sop_instance_uid, replace_file_id, copy_file_path
) values (
  ?, ?, ?, ?
)', ARRAY['copy_from_public_id', 'sop_instance_uid', 'replace_file_id', 'copy_file_path'], 
                    '{}', ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetPatientMappingByCollection', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  date_shift,
  ''<'' || diagnosis_date || ''>'' as diagnosis_date,
  ''<'' || baseline_date || ''>'' as baseline_date,
  ''<'' || date_trunc(''year'', diagnosis_date) || ''>'' as year_of_diagnosis,
  baseline_date - diagnosis_date as computed_shift
from
  patient_mapping
where collection_name = ?
  ', ARRAY['collection_name'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift', 'diagnosis_date', 'baseline_date', 'year_of_diagnosis', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping', 'ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('CtSeriesWithCtImageInfoByCollection', 'select
  distinct series_instance_uid, count(distinct file_id) as num_files
from file_series natural join file_ct_image natural join ctp_file
where kvp is not null and visibility is null and project_name = ? group by series_instance_uid', ARRAY['collection'], 
                    ARRAY['series_instance_uid', 'num_files'], ARRAY['populate_posda_files', 'bills_test', 'ct_image_consistency'], 'posda_files', 'Get CT Series with CT Image Info by collection

')
        ;

            insert into queries
            values ('FromDigestToDigestFromDicomEditCompare', 'select 
  from_file_digest, to_file_digest
from
  dicom_edit_compare
where
  subprocess_invocation_id = ?', ARRAY['subprocess_invocation_id'], 
                    ARRAY['from_file_digest', 'to_file_digest'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('MsrkEquivalenceClassForRetry', 'update image_equivalence_class set
  processing_status = ''ReadyToProcess'',
  review_status = null
where image_equivalence_class_id = ?', ARRAY['image_equivalence_class_id'], 
                    '{}', ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetSopModalityPath', 'select 
  sop_instance_uid, modality,
  root_path || ''/'' || rel_path as path
from
  file_series natural join file_sop_common natural join file_location natural join file_storage_root
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance_uid', 'modality', 'path'], ARRAY['bills_test', 'comparing_posda_to_public'], 'posda_files', 'get sop_instance, modality, and path to file by file_id')
        ;

            insert into queries
            values ('ImportEventsWithTypeAndPatientId', 'select
  distinct import_event_id, import_time,  import_type, count(distinct file_id) as num_files
from
  import_event natural join file_import natural join file_patient
where
  import_type = ''multi file import'' and 
  patient_id like ?
group by import_event_id, import_time, import_type', ARRAY['patient_id_like'], 
                    ARRAY['import_event_id', 'import_time', 'import_type', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('CreateBackgroundSubprocessParam', 'insert into background_subprocess_params(
  background_subprocess_id,
  param_index,
  param_value
) values (
  ?, ?, ?
)', ARRAY['background_subprocess_id', 'param_index', 'param_value'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create row in background_subprocess_params table

Used by background subprocess')
        ;

            insert into queries
            values ('GetNotQualifiedCTQPByLikeCollectionSiteWithFIleCount', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id)
where collection like ? and site = ? and not qualified
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('BackgroundProcessStatsNew', 'select
  distinct operation_name, max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  count(distinct invoking_user) as num_invokers,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null
group by operation_name
order by last desc, times_invoked desc', '{}', 
                    ARRAY['operation_name', 'longest', 'shortest', 'avg', 'times_invoked', 'num_invokers', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('InsCTQP', 'insert into clinical_trial_qualified_patient_id(
  collection, site, patient_id, qualified
) values (
  ?, ?, ?, ?
)
', ARRAY['collection', 'site', 'patient_id', 'qualified'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('InsertIntoDicomEditCompare', 'insert into dicom_edit_compare(
  edit_command_file_id,
  from_file_digest,
  to_file_digest,
  short_report_file_id,
  long_report_file_id
) values ( ?, ?, ?, ?, ?)', ARRAY['edit_command_file_id', 'from_file_digest', 'to_file_digest', 'short_report_file_id', 'long_report_file_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('SeriesConsistency', 'select distinct
  series_instance_uid, modality, series_number, laterality, series_date,
  series_time, performing_phys, protocol_name, series_description,
  operators_name, body_part_examined, patient_position,
  smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
  performed_procedure_step_start_date, performed_procedure_step_start_time,
  performed_procedure_step_desc, performed_procedure_step_comments,
  count(*)
from
  file_series natural join ctp_file
where series_instance_uid = ? and visibility is null
group by
  series_instance_uid, modality, series_number, laterality, series_date,
  series_time, performing_phys, protocol_name, series_description,
  operators_name, body_part_examined, patient_position,
  smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
  performed_procedure_step_start_date, performed_procedure_step_start_time,
  performed_procedure_step_desc, performed_procedure_step_comments
', ARRAY['series_instance_uid'], 
                    ARRAY['series_instance_uid', 'count', 'modality', 'series_number', 'laterality', 'series_date', 'series_time', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_start_time', 'performed_procedure_step_desc', 'performed_procedure_step_comments'], ARRAY['by_series', 'consistency', 'series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('CtImageDataConsistencyAcrossSeries', 'select 
  distinct kvp, scan_options, data_collection_diameter, reconstruction_diameter,
  dist_source_to_detect, dist_source_to_pat,gantry_tilt, table_height,
  rotation_dir, exposure_time, exposure, filter_type, generator_power, convolution_kernal,
  count(distinct file_id) as num_files
from file_ct_image where file_id in (
  select file_id from file_series natural join ctp_file where series_instance_uid = ?
)
group by
  kvp, scan_options, data_collection_diameter, reconstruction_diameter,
  dist_source_to_detect, dist_source_to_pat,gantry_tilt, table_height,
  rotation_dir, exposure_time, exposure, filter_type, generator_power, convolution_kernal
', ARRAY['series_instance_uid'], 
                    ARRAY['kvp', 'scan_options', 'data_collection_diameter', 'reconstruction_diameter', 'dist_source_to_detect', 'dist_source_to_pat', 'gantry_tilt', 'table_height', 'rotation_dir', 'exposure_time', 'filter_type', 'generator_power', 'convolution_kernal', 'num_files'], ARRAY['populate_posda_files', 'ct_image_consistency'], 'posda_files', 'Get CT Series with CT Image Info by collection

')
        ;

            insert into queries
            values ('ActivityStuffMoreWithEmailForAll', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where background_subprocess_report.name = ''Email''
order by subprocess_invocation_id desc
', '{}', 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PosdaImagesByCollectionSite', 'select distinct
  patient_id as "PID",
  modality as "Modality",
  sop_instance_uid as "SopInstance",
  study_date as "StudyDate",
  study_description as "StudyDescription",
  series_description as "SeriesDescription",
  study_instance_uid as "StudyInstanceUID",
  series_instance_uid as "SeriesInstanceUID",
  manufacturer as "Mfr",
  manuf_model_name as "Model",
  software_versions
from
  file_patient natural join file_series natural join
  file_sop_common natural join file_study natural join
  file_equipment natural join ctp_file
where
  file_id in (
  select distinct file_id from ctp_file
  where project_name = ? and site_name = ? and visibility is null)
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'Modality', 'SopInstance', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions'], ARRAY['posda_files'], 'posda_files', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByLikeCollectionSiteSummary', 'select 
  distinct
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name like  ? and
  visibility is null
group by
  dicom_file_type,
  modality,
  review_status,
  processing_status
', ARRAY['project_name'], 
                    ARRAY['dicom_file_type', 'modality', 'review_status', 'processing_status', 'num_series', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetDciodvfyErrorId', 'select currval(''dciodvfy_error_dciodvfy_error_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a id of newly created dciodvfy_error row')
        ;

            insert into queries
            values ('SetLoadPathByImportEventIdAndFileId', 'update file_import set file_name = ? where file_id = ? and import_event_id = ?', ARRAY['file_name', 'file_id', 'import_event_id'], 
                    '{}', ARRAY['import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetSsByCollection', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id
from
  ctp_file natural join file_patient
where file_id in (
 select distinct file_id from file_structure_set
)
and project_name = ? and visibility is null
order by collection, site, patient_id, file_id
', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetDciodvfyErrorBadVm', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''BadValueMultiplicity''
  and error_tag = ?
  and error_value = ?
  and error_index = ?
  and error_module = ?
', ARRAY['error_tag', 'error_value', 'error_index', 'error_module'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewedInSeriesTest', 'select 
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from (
  select 
    distinct project_name as collection,
    site_name as site,
    patient_id,
    series_instance_uid,
    dicom_file_type,
    modality,
    review_status,
    processing_status,
    visibility,
    file_id
  from 
    dicom_file natural join 
    file_series natural join 
    file_patient natural join
    ctp_file natural join 
  (
    select file_id, review_status, processing_status
    from
      image_equivalence_class_input_image natural join
      image_equivalence_class join
      ctp_file using(file_id)
    where
      series_instance_uid = ?
  ) as foo
) as foo
where
  visibility is null 
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'visibility', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetActivityTaskStatus', 'select
  subprocess_invocation_id,
  operation_name,
  start_time,
  last_updated,
  status_text,
  expected_remaining_time,
  end_time
from
  activity_task_status natural join subprocess_invocation
where
  activity_id = ? and dismissed_time is null', ARRAY['activity_id'], 
                    ARRAY['operation_name', 'start_time', 'last_updated', 'status_text', 'expected_remaining_time', '  end_time'], ARRAY['Insert', 'NotInteractive'], 'posda_files', 'Insert Initial Patient Status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('DeleteLastTagFromQuery', 'update queries 
  set tags = tags[1:(array_upper(tags,1) -1)]
where name = ?', ARRAY['name'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tags'], 'posda_queries', 'Add a tag to a query')
        ;

            insert into queries
            values ('GetDciodvfyUnitScanWarningId', 'select currval(''dciodvfy_unit_scan_warning_dciodvfy_unit_scan_warning_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('ShowAllVisibilityChangesBySeriesInstance', 'select
  distinct
  user_name,
  time_of_change,
  prior_visibility,
  new_visibility,
  reason_for,
  count (distinct file_id) as num_files
from
   file_visibility_change 
where file_id in (
  select distinct file_id 
  from file_series
  where series_instance_uid = ?
)
group by user_name, time_of_change,
  prior_visibility, new_visibility, reason_for
order by time_of_change', ARRAY['series_instance_uid'], 
                    ARRAY['user_name', 'time_of_change', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('StudySeriesForFile', 'select study_instance_uid, series_instance_uid from file_series natural join file_study where file_id = ?', ARRAY['file_id'], 
                    ARRAY['study_instance_uid', 'series_instance_uid'], ARRAY['activity_timepoint_support'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('RoundStatsForDateRange', 'select
  date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request
where time_received > ? and time_received < ?
group by time order by time desc', ARRAY['interval', 'from', 'to'], 
                    ARRAY['time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('ValuesWithVrTagAndCount', 'select
    distinct vr, value, element_signature, private_disposition, count(*)  as num_files
from
    scan_event natural join series_scan natural join seen_value
    natural join element_signature natural join scan_element
where
    scan_event_id = ?
group by value, element_signature, vr, private_disposition
', ARRAY['scan_id'], 
                    ARRAY['vr', 'value', 'element_signature', 'private_disposition', 'num_files'], ARRAY['tag_usage', 'PrivateTagKb'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('GetSimpleValuesByEleVr', 'select
  distinct value
from
  element_seen
  join element_value_occurance using(element_seen_id)
  join value_seen using(value_seen_id)
where element_sig_pattern = ? and vr = ?
', ARRAY['tag', 'vr'], 
                    ARRAY['value'], ARRAY['tag_values'], 'posda_phi_simple', 'Find Values for a given tag, vr in posda_phi_simple
')
        ;

            insert into queries
            values ('GetSeriesWithImageByCollectionSitePatient', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series natural join file_sop_common
  natural join file_patient
  natural join file_image natural join ctp_file
  natural join file_import natural join import_event
where 
  project_name = ? and 
  site_name = ? and 
  patient_id = ? and
  visibility is null
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('ImportEventsByMatchingName', 'select
  import_event_id, import_comment, import_time, import_close_time, count(distinct file_id) as num_images
from 
  import_event natural join file_import
where
  import_comment like ?
group by import_event_id, import_comment, import_time, import_close_time', ARRAY['import_comment_like'], 
                    ARRAY['import_event_id', 'import_comment', 'import_time', 'import_close_time', 'num_images'], ARRAY['import_events'], 'posda_files', 'Get Import Events by matching comment')
        ;

            insert into queries
            values ('TagsInMultipleTagFilters', 'select distinct tag, count(*) as num_locations
from (
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
group by tag
order by num_locations desc', '{}', 
                    ARRAY['tag', 'num_locations'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SeriesInHierarchyBySeries', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('RTDOSEWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''RT Dose Storage'' and 
  visibility is null and
  modality != ''RTDOSE''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('ImportEventsWithMultiFileLikePatientId', 'select
  distinct import_event_id, import_time,  import_type, patient_id, count(distinct file_id) as num_files
from
  import_event natural join file_import natural join file_patient
where
  import_type = ''multi file import'' and 
  import_time > ? and import_time < ?
group by import_event_id, import_time, import_type, patient_id', ARRAY['from', 'to'], 
                    ARRAY['import_event_id', 'import_time', 'import_type', 'patient_id', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('SimpleCountQuery', 'select
  distinct
    patient_id, dicom_file_type, modality,
    study_instance_uid, series_instance_uid,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
where
  project_name = ?  and site_name = ? and visibility is null
group by
  patient_id, dicom_file_type, modality,
  study_instance_uid, series_instance_uid
order by
  patient_id, study_instance_uid, series_instance_uid,
  modality
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'dicom_file_type', 'modality', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('PatientsWithEditedFiles', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  ctp_file natural join
  file_patient natural join
  file_sop_common
where file_id in (
  select 
    distinct file_id 
  from 
    file f natural join dicom_edit_compare dec
  where
    f.digest = dec.to_file_digest and subprocess_invocation_id in (
      select distinct subprocess_invocation_id
      from dicom_edit_compare_disposition
      where current_disposition like ''Import Complete%''
    )
)
group by collection, site, patient_id
order by collection, site, patient_id', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'num_sops', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'patient_queries'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Normally there should be no file_id (i.e. file has not been imported)')
        ;

            insert into queries
            values ('GetSlopeIntercept', 'select
  slope, intercept, si_units
from
  file_slope_intercept natural join slope_intercept
where
  file_id = ?
', ARRAY['file_id'], 
                    ARRAY['slope', 'intercept', 'si_units'], ARRAY['by_file_id', 'posda_files', 'slope_intercept'], 'posda_files', 'Get a Slope, Intercept for a particular file 
')
        ;

            insert into queries
            values ('CreateDciodvfyUnitScanWarning', 'insert into dciodvfy_unit_scan_warning(
  dciodvfy_scan_instance_id,
  dciodvfy_unit_scan_id,
  dciodvfy_warning_id
)values (?, ?, ?)', ARRAY[' dicodvfy_scan_instance_id', 'dciodvfy_unit_scan_id', 'dciodvfy_warning_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_unit_scan_error row')
        ;

            insert into queries
            values ('WhatHasComeInRecentlyByCollectionLikeAndFileInPosdaCount', 'select
  distinct collection, site, date_trunc(?, time_received) as time,
  count(*) as number_of_files, count(distinct posda_file_id) as num_files_in_posda,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
and collection like ?
group by collection, site, time order by time desc, collection, site', ARRAY['interval', 'from', 'to', 'collection_like'], 
                    ARRAY['collection', 'site', 'time', 'number_of_files', 'num_files_in_posda', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('NumEquipSigsForPrivateTagSigs', 'select distinct element_signature, count(*) from (
select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ? and is_private) as foo
group by element_signature
order by element_signature
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'Number of Equipment signatures in which tags are featured
')
        ;

            insert into queries
            values ('GetElementSignatureId', 'select currval(''element_signature_element_signature_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'UsedInPhiSeriesScan', 'ElementDisposition'], 'posda_phi', 'Get current value of ElementSignatureId Sequence
')
        ;

            insert into queries
            values ('InsertFilePosdaReturnID', 'insert into file( digest, size, processing_priority, ready_to_process) values ( ?, ?, 1, false) on conflict  do nothing returning file_id;', ARRAY['digest', 'size'], 
                    ARRAY['file_id'], ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Insert a file without locking the table')
        ;

            insert into queries
            values ('FileNameReportByImportEventWithMrData', 'select
  file_id, patient_id,
  study_instance_uid, study_date, study_description, series_instance_uid,
  modality, series_date, series_description, dicom_file_type, file_name,
  mr_scanning_seq, mr_scanning_var, mr_scan_options,
  mr_acq_type, mr_slice_thickness, mr_repetition_time,
  mr_echo_time, mr_magnetic_field_strength, mr_spacing_between_slices,
  mr_echo_train_length, mr_software_version, mr_flip_angle
from
  file_import natural join file_patient natural join file_series natural join
  file_study natural join dicom_file natural left join file_mr
where
  import_event_id = ?
order by file_name', ARRAY['import_event_id'], 
                    ARRAY['file_id', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'modality', 'series_date', 'series_description', 'dicom_file_type', 'file_name', 'mr_scanning_seq', 'mr_scanning_var', 'mr_scan_options', 'mr_acq_type', 'mr_slice_thickness', 'mr_repetition_time', 'mr_echo_time', 'mr_magnetic_field_strength', 'mr_spacing_between_slices', 'mr_echo_train_length', 'mr_software_version', 'mr_flip_angle'], ARRAY['import_events'], 'posda_files', 'List of values seen in scan by ElementSignature with VR and count
')
        ;

            insert into queries
            values ('TagsSeenSimplePrivateWithCount', 'select 
  distinct element_sig_pattern,
  vr,
  private_disposition, tag_name,
  count(distinct value) as num_values
from
  element_seen natural left join
  element_value_occurance
  natural left join value_seen
where
  is_private 
group by element_sig_pattern, vr, private_disposition, tag_name
order by element_sig_pattern;', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'private_disposition', 'tag_name', 'num_values'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi_simple', 'Get all the data from tags_seen in posda_phi_simple database
')
        ;

            insert into queries
            values ('GetImageGeoBySop1', 'select
  iop, ipp, for_uid, series_instance_uid
from
  image_geometry natural join file_image_geometry natural join file_series
where
  file_id in 
  (
    select 
      file_id 
    from
      file_sop_common natural join ctp_file
    where
      sop_instance_uid = ? and visibility is null
  )', ARRAY['sop_instance_uid'], 
                    ARRAY['iop', 'ipp', 'for_uid', 'series_instance_uid'], ARRAY['LinkageChecks', 'BySopInstance'], 'posda_files', 'Get Geometric Information by Sop Instance UID from posda')
        ;

            insert into queries
            values ('PixDupsByCollecton', 'select 
  distinct series_instance_uid, count(*)
from 
  ctp_file natural join file_series 
where 
  project_name = ? and visibility is null
  and file_id in (
    select 
      distinct file_id
    from
      file_image natural join image natural join unique_pixel_data
      natural join ctp_file
    where digest in (
      select
        distinct pixel_digest
      from (
        select
          distinct pixel_digest, count(*)
        from (
          select 
            distinct unique_pixel_data_id, pixel_digest, project_name,
            site_name, patient_id, count(*) 
          from (
            select
              distinct unique_pixel_data_id, file_id, project_name,
              site_name, patient_id, 
              unique_pixel_data.digest as pixel_digest 
            from
              image natural join file_image natural join 
              ctp_file natural join file_patient fq
              join unique_pixel_data using(unique_pixel_data_id)
            where visibility is null
          ) as foo 
          group by 
            unique_pixel_data_id, project_name, pixel_digest,
            site_name, patient_id
        ) as foo 
        group by pixel_digest
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) 
group by series_instance_uid
order by count desc;
', ARRAY['collection'], 
                    ARRAY['series_instance_uid', 'count'], ARRAY['pix_data_dups'], 'posda_files', 'Counts of duplicate pixel data in series by Collection
')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSiteWithCounts', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  count(distinct file_id) as num_files
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and
    visibility is null
  )
group by patient_id, study_instance_uid, series_instance_uid
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'num_files'], ARRAY['Hierarchy', 'apply_disposition'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('DismissInboxItem', '
update user_inbox_content
set date_dismissed = now()
where user_inbox_content_id = ?

', ARRAY['user_inbox_content_id'], 
                    '{}', '{}', 'posda_queries', 'Set the date_dismissed value on an Inbox item')
        ;

            insert into queries
            values ('ListOfAvailableQueriesByNameLike', 'select schema, name, description, tags from (
  select
    schema, name, description,
    array_to_string(tags, '','') as tags
  from queries
) as foo
where name like ?
order by name', ARRAY['name_like'], 
                    ARRAY['schema', 'name', 'description', 'tags'], ARRAY['AllCollections', 'q_list'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('FilesInHierarchyByPatient', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  study_date,
  count (distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_patient natural join ctp_file
  where
    patient_id = ? and visibility is null
)
group by collection, site, patient_id, 
  study_instance_uid, series_instance_uid, study_date
order by
  project_name, site_name, patient_id,
  study_instance_uid, series_instance_uid
', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'study_date', 'num_files'], ARRAY['by_series_instance_uid', 'posda_files', 'sops'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('LockErrors', 'lock table dciodvfy_error', '{}', 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('SummaryOfSeriesInUnhiddenBadEquivalenceClasses', 'select distinct project_name as collection, site_name as site, patient_id, series_instance_uid, modality, dicom_file_type, count(distinct file_id) as num_files from
ctp_file natural join file_patient natural join file_series natural join dicom_file where file_id in (
select distinct file_id from file_sop_common natural join ctp_file where visibility is null and sop_instance_uid in (
select sop_instance_uid from file_sop_common where file_id in (
select distinct file_id from image_equivalence_class natural join image_equivalence_class_input_image where visual_review_instance_id = ? and review_status = ''Bad'' ))) group by collection, site, patient_id, series_instance_uid, modality, dicom_file_type', ARRAY['visual_review_instance_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_status'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('AllManifestsByCollectionLike', 'select
  distinct file_id, import_time, size, root_path || ''/'' || l.rel_path as path, i.file_name as alt_path
from
  file_location l join file_storage_root using(file_storage_root_id) 
  join file_import i using (file_id) natural join file join import_event using(import_event_id)
where
  file_id in (
    select distinct file_id from ctp_manifest_row where cm_collection like ?
  )', ARRAY['collection_like'], 
                    ARRAY['file_id', 'import_time', 'size', 'path', 'alt_path'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ReviewEditsByTimeSpan', 'select
  distinct project_name,
  site_name,
  series_instance_uid,
  new_visibility,
  reason_for,
  min(time_of_change) as earliest,
  max(time_of_change) as latest,
  count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join
  file_series
where
  time_of_change > ? and time_of_change < ?
group by
  project_name,
  site_name,
  series_instance_uid,
  new_visibility,
  reason_for', ARRAY['from', 'to'], 
                    ARRAY['project_name', 'site_name', 'series_instance_uid', 'new_visibility', 'reason_for', 'earliest', 'latest', 'num_files'], ARRAY['Hierarchy', 'review_visibility_changes'], 'posda_files', 'Show all file visibility changes by series over a time range')
        ;

            insert into queries
            values ('FirstFileInSeriesPosda', 'select root_path || ''/'' || rel_path as path
from file_location natural join file_storage_root
where file_id in (
select file_id from 
  (
  select 
    distinct sop_instance_uid, min(file_id) as file_id
  from 
    file_series natural join ctp_file 
    natural join file_sop_common
  where 
    series_instance_uid = ?
    and visibility is null
  group by sop_instance_uid
) as foo)
limit 1
', ARRAY['series_instance_uid'], 
                    ARRAY['path'], ARRAY['by_series', 'UsedInPhiSeriesScan'], 'posda_files', 'First files in series in Posda
')
        ;

            insert into queries
            values ('PixelTypesWithSlopeCT', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration,
  modality,
  slope,
  intercept,
  count(*)
from
  image natural join file_image natural join file_series
  natural join file_slope_intercept natural join slope_intercept
where
  modality = ''CT''
group by
  photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration,
  modality,
  slope,
  intercept
order by
  photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration,
  modality,
  slope,
  intercept
', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'planar_configuration', 'modality', 'slope', 'intercept', 'count'], '{}', 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('SelectPtInfoSummary', 'select 
  distinct pti_radiopharmaceutical as radiopharmaceutical, 
  pti_radionuclide_total_dose as total_dose,
  pti_radionuclide_half_life as half_life,
  pti_radionuclide_positron_fraction as positron_fraction, 
  pti_fov_shape as fov_shape,
  pti_fov_dimensions as fov_dim,
  pti_collimator_type as coll_type,
  pti_reconstruction_diameter as recon_diam, 
  count(*) as num_files
from file_pt_image 
group by 
  radiopharmaceutical,
  total_dose,
  half_life,
  positron_fraction,
  fov_shape,
  fov_dim,
  coll_type,
  recon_diam', '{}', 
                    ARRAY['radiopharmaceutical', 'total_dose', 'half_life', 'positron_fraction', 'fov_shape', 'fov_dim', 'coll_type', 'recon_diam', 'num_files'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('PixelInfoByFileId', 'select
  root_path || ''/'' || rel_path as file, file_offset, size, 
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  file_image f natural join image natural join unique_pixel_data
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  f.file_id = ? and pl.file_id = fl.file_id
  and f.file_id = pl.file_id
', ARRAY['image_id'], 
                    ARRAY['file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation'], '{}', 'posda_files', 'Get pixel descriptors for a particular image id
')
        ;

            insert into queries
            values ('DupSopsByCollectionSiteDateRange', 'select
  distinct collection, site, subj_id, 
  sop_instance_uid,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid 
      from (
        select distinct sop_instance_uid, count(distinct file_id)
        from file_sop_common natural join ctp_file
        where visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from file_sop_common natural join ctp_file
            join file_import using(file_id) 
            join import_event using(import_event_id)
          where project_name = ? and site_name = ? and
             visibility is null and import_time > ?
              and import_time < ?
        ) group by sop_instance_uid
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, sop_instance_uid

', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj_id', 'sop_instance_uid', 'num_files'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('PublicSeriesByCollectionMetadata', 'select
  p.patient_id as PID,
  s.modality as Modality,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions,
   count( i.sop_instance_uid) as Images
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and 
  tdp.project = ? 
group by PID, StudyDate, Modality
', ARRAY['collection'], 
                    ARRAY['PID', 'Modality', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions', 'Images'], ARRAY['public'], 'public', 'List of all Series By Collection, Site on Public with metadata
')
        ;

            insert into queries
            values ('ActivityStuffMoreByUserByDateRange', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where invoking_user = ? and when_script_started >= ? and when_script_ended <= ?
order by subprocess_invocation_id desc
', ARRAY['user', 'from', 'to'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('SeriesSopsForCollectionSiteReport', 'select 
  distinct project_name as collection, site_name as site, count(distinct patient_id) as num_subjects,
  count(distinct series_instance_uid) as num_series, count(distinct sop_instance_uid) as num_images
from
  ctp_file natural join file_patient natural join file_series natural join file_sop_common natural join file_image
where visibility is null
group by collection, site
order by num_images desc', '{}', 
                    ARRAY['collection', 'site', 'num_subjects', 'num_series', 'num_images'], ARRAY['AllCollections', 'q_stats'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('ProjectCompletion', 'select
  ((now() - ?) / ?) * (cast(? as float) - cast(? as float)) + now() as projected_completion', ARRAY['start_time', 'num_done_1', 'num_to_do', 'num_done_2'], 
                    ARRAY['projected_completion'], ARRAY['bills_test'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('DciodvfyErrorsBySeriesAndScanInstance', 'select
  dciodvfy_error_id,
  error_type,
  error_tag,
  error_value,
  error_subtype,
  error_module,
  error_reason,
  error_index,
  error_text
from dciodvfy_error 
where  dciodvfy_error_id in (
  select distinct dciodvfy_error_id
  from (
    select
      distinct unit_uid, dciodvfy_error_id
    from
      dciodvfy_unit_scan
      natural join dciodvfy_unit_scan_error
    where
      dciodvfy_scan_instance_id = ? and unit_uid =?
  )
 as foo
)', ARRAY['dciodvfy_scan_instance_id', 'series_instance_uid'], 
                    ARRAY['dciodvfy_error_id', 'error_type', 'error_tag', 'error_value', 'error_subtype', 'error_module', 'error_reason', 'error_index', 'error_text'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('SsSopToForByCollectionSite', 'select 
  distinct patient_id,  sop_instance_uid, 
  for_uid
from 
  roi natural join file_structure_set join file_sop_common using(file_id) join file_patient using (file_id)
where
  file_id in (
    select file_id 
    from ctp_file natural join file_structure_set 
    where project_name = ? and site_name = ? and visibility is null
  )
order by patient_id', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'sop_instance_uid', 'for_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('RoundCountsByCollection', 'select 
  round_id, num_requests
from round natural join round_counts
where collection = ?', ARRAY['collection'], 
                    ARRAY['round_id', 'num_requests'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('DismissInboxContenIItem', 'update user_inbox_content
set date_dismissed = now(),
current_status = ''dismissed''
where user_inbox_content_id = ?

', ARRAY['user_inbox_content_id'], 
                    '{}', '{}', 'posda_queries', 'Set the date_dismissed value on an Inbox item')
        ;

            insert into queries
            values ('RecordElementDispositionChange', 'insert into element_signature_change(
  element_signature_id, when_sig_changed,
  who_changed_sig, why_sig_changed,
  old_disposition, new_disposition,
  old_name_chain, new_name_chain
) values (
  ?, now(),
  ?, ?,
  ?, ?,
  ?, ?
)
', ARRAY['element_signature_id', 'who_changed_sig', 'why_sig_changed', 'old_disposition', 'new_disposition', 'old_name_chain', 'new_name_chain'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Record a change to Element Disposition
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('FindingImageProblemWithSeries', 'select
  distinct dicom_file_type, project_name,  
  patient_id, series_instance_uid, min(import_time), max(import_time), count(distinct file_id) 
from
  ctp_file natural join dicom_file natural join file_series natural join
  file_patient natural join file_import natural join 
  import_event 
where file_id in (
  select file_id 
  from (
    select file_id, image_id 
    from pixel_location left join image using(unique_pixel_data_id)
    where file_id in (
      select
         distinct file_id from file_import natural join import_event natural join dicom_file
      where import_time > ''2018-09-17''
    )
  ) as foo where image_id is null
) and visibility is null
 group by dicom_file_type, project_name, patient_id, series_instance_uid
order by patient_id', '{}', 
                    ARRAY['dicom_file_type', 'project_name', 'patient_id', 'series_instance_uid', 'min', 'max', 'count'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('MarkPrivateTags', 'update element_seen set
  is_private = true
where
  is_private is null and 
  element_sig_pattern like ''%"%''
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name', 'disp'], ARRAY['tag_usage', 'simple_phi', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('GetPatientMappingByPatientId', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  uid_root,
  diagnosis_date,
  baseline_date,
  date_shift,
  baseline_date - diagnosis_date + interval ''1 day'' as computed_shift
from
  patient_mapping
where
  to_patient_id = ?
  ', ARRAY['patient_id'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'uid_root', 'diagnosis_date', 'baseline_date', 'date_shift', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('SeeIfDigestIsAlreadyKnownDistinguished', 'select count(*) from distinguished_pixel_digests where pixel_digest = ?', ARRAY['pixel_digest'], 
                    ARRAY['count'], ARRAY['meta', 'test', 'hello'], 'posda_files', 'Find Duplicated Pixel Digest')
        ;

            insert into queries
            values ('LockWarnings', 'lock table dciodvfy_warning', '{}', 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('CreateEquivalenceInputClass', 'insert into image_equivalence_class_input_image(
  image_equivalence_class_id,  file_id
) values (
  ?, ?
)
', ARRAY['image_equivlence_class_id', 'file_id'], 
                    '{}', ARRAY['consistency', 'equivalence_classes', 'NotInteractive'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('SeriesWithDupSopsByCollectionSiteNew', 'select
  distinct collection, site, subj_id, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id,  series_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['ACRIN-FMISO-Brain Duplicate Elimination', 'dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('AddHocQueryForHeadNeckPETCT', 'select
  distinct patient_id, study_instance_uid as study_uid, series_instance_uid as series_uid,
  count(distinct file_id) as num_files
from
  file_patient natural join file_study natural join file_series natural join ctp_file
where
  patient_id in
   (''HN-CHUM-050'', ''HN-CHUM-052'', ''HN-CHUM-054'', ''HN-CHUM-056'', ''HN-CHUM-030'', ''HN-CHUM-034'')
  and visibility is null
group by patient_id, study_uid, series_uid', '{}', 
                    ARRAY['patient_id', 'study_uid', 'series_uid', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetDciodvfyScanInstanceId', 'select currval(''dciodvfy_scan_instance_dciodvfy_scan_instance_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('GetSimpleValueSeen', 'select
  value_seen_id as id
from 
  value_seen
where
  value = ?', ARRAY['value'], 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('SeriesEquivalenceClassNoByProcessingStatus', 'select 
  distinct series_instance_uid, equivalence_class_number, count(*) 
from 
  image_equivalence_class natural join image_equivalence_class_input_image
where
  processing_status = ?
group by series_instance_uid, equivalence_class_number
order by series_instance_uid, equivalence_class_number', ARRAY['processing_status'], 
                    ARRAY['series_instance_uid', 'equivalence_class_number', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency'], 'posda_files', 'Find Series with more than n equivalence class')
        ;

            insert into queries
            values ('CountsByCollectionDateRangePlus', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name = ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['from', 'to', 'collection'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetFilesWithNoSeriesInfoByCollection', 'select
  file_id,
  root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location
where file_id in (
select 
  distinct file_id
from 
 ctp_file c
where
  project_name = ? and 
  visibility is null and 
  not exists (
    select
      file_id 
    from
      file_series s 
    where
      s.file_id = c.file_id
  )
)', ARRAY['collection'], 
                    ARRAY['file_id', 'path'], ARRAY['reimport_queries', 'dicom_file_type'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('SeriesFileByCollectionWithNoEquivalenceClass', 'select distinct
  series_instance_uid
from
  file_series s
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and visibility is null
  )
  and not exists (
    select 
      series_instance_uid
   from
      image_equivalence_class e
   where
      e.series_instance_uid = s.series_instance_uid
 )', ARRAY['collection'], 
                    ARRAY['series_instance_uid'], ARRAY['equivalence_classes'], 'posda_files', 'Construct list of series in a collection where no image_equivalence_class exists')
        ;

            insert into queries
            values ('CreateScanEvent', 'insert into scan_event(
  scan_started, scan_status, scan_description,
  num_series_to_scan, num_series_scanned
) values (
  now(), ''In Process'', ?,
  ?, 0
)

', ARRAY['description', 'num_series_to_scan'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create Scan Element')
        ;

            insert into queries
            values ('GetScanInstanceById', 'select
  phi_scan_instance_id,
  start_time,
  end_time,
  description,
  num_series,
  num_series_scanned,
  file_query
from 
  phi_scan_instance
where phi_scan_instance_id = ?', ARRAY['phi_scan_instance_id'], 
                    ARRAY['phi_scan_instance_id', 'start_time', 'end_time', 'description', 'num_series', 'num_series_scanned', 'file_query'], ARRAY['adding_ctp', 'for_scripting', 'scan_status'], 'posda_phi_simple', 'Get a query_scan_instance by instance_id')
        ;

            insert into queries
            values ('GetBasicImageGeometry', 'select
  iop, ipp
from
  file_series
  join file_image using (file_id)
  join image_geometry using (image_id)
where 
  series_instance_uid = ?', ARRAY['series_instance_uid'], 
                    ARRAY['iop', 'ipp'], ARRAY['NotInteractive', 'used_in_import_edited_files', 'used_in_check_circular_view'], 'posda_files', 'Get file_id, and current visibility by digest
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('IntakeSeriesByCollectionSite', 'select
  p.patient_id as PID,
  s.modality as Modality,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions
from
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'Modality', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions'], ARRAY['intake'], 'intake', 'List of all Series By Collection, Site on Intake
')
        ;

            insert into queries
            values ('IntakePatientStudySeriesHierarchyByCollectionSite', 'select
  p.patient_id as patient_id,
  t.study_instance_uid as study_instance_uid,
  s.series_instance_uid as series_instance_uid
from
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp
where
  s.study_pk_id = t.study_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['intake', 'Hierarchy'], 'intake', 'Patient, study, series hierarchy by Collection, Site on Intake
')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollection', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and visibility is null
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionWithModality', 'select 
  distinct project_name as collection,
  site_name as site,
  modality,
  date_trunc(''day'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, modality, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'modality', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ImageFrameOfReferenceBySeriesPublic', 'select
  distinct frame_of_reference_uid as for_uid,
  count(distinct sop_instance_uid) as num_files
from
  general_image i, general_series s
where
  s.general_series_pk_id = i.general_series_pk_id and s.series_instance_uid = ?
group by frame_of_reference_uid;', ARRAY['series_instance_uid'], 
                    ARRAY['for_uid', 'num_files'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'public', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('MakeBacklogReadyForProcessing', 'update control_status
  set status = ''waiting to go inservice''
', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Mark Backlog as ready for Processor')
        ;

            insert into queries
            values ('GetStudyByFileId', 'select file_id from file_study where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id'], ARRAY['bills_test', 'posda_db_populate'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SummaryOfFromFiles', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  study_date,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  visibility,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  ctp_file natural join
  file_patient natural join
  file_sop_common natural join
  file_study natural join
  file_series natural join
  dicom_file
where file_id in (
  select
    file_id 
  from
    file f, dicom_edit_compare dec 
  where
    f.digest = dec.from_file_digest and dec.subprocess_invocation_id = ?
  )
group by collection, site, patient_id, study_date, study_instance_uid, series_instance_uid, 
  dicom_file_type, modality, visibility
order by collection, site, patient_id, study_date, study_instance_uid, modality', ARRAY['subprocess_invocation_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_date', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'visibility', 'num_sops', 'num_files'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Get a list of to files from the dicom_edit_compare table for a particular edit instance, with file_id and visibility

NB: Normally there should be no file_id (i.e. file has not been imported)')
        ;

            insert into queries
            values ('StartTransactionPosda', 'begin
', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Start a transaction in Posda files')
        ;

            insert into queries
            values ('RawFilesFromDate', 'select 
  file_type, max(file_id) as max_file_id, min(file_id) as min_file_id, 
  count(*) as num_files, max(size) as largest, min(size) as smallest,
  sum(size) as total_size, avg(size) as avg_size
from file
where file_id in (
  select
    file_id from (
      select
        distinct file_id, date_trunc(?, min(import_time)) as load_week
      from
        file_import natural join import_event
      group by file_id
  ) as foo
  where
    load_week >=? and load_week <  (now() + interval ''24:00:00'')
) 
group by file_type', ARRAY['date_type', 'from'], 
                    ARRAY['file_type', 'max_file_id', 'min_file_id', 'num_files', 'largest', 'smallest', 'total_size', 'avg_size'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AllProcessedManifestsByCollectionLikeWithDate', 'select
  distinct file_id, import_time as date, cm_collection, cm_site,  sum(cm_num_files) as total_files
from
  ctp_manifest_row natural join file_import natural join import_event
where
  cm_collection like ?
group by file_id, date, cm_collection, cm_site', ARRAY['collection_like'], 
                    ARRAY['file_id', 'date', 'cm_collection', 'cm_site', 'total_files'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('GetInputFormatForAllCommands', 'select
  operation_name, input_line_format, command_line
from
  spreadsheet_operation
where input_line_format is not null and operation_type = ''background_process''
  and can_chain', '{}', 
                    ARRAY['operation_name', 'input_line_format', 'command_line'], ARRAY['spreadsheet_operations'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('GetCollectionCodes', 'select
 collection_name, collection_code
from
  collection_codes
  ', '{}', 
                    ARRAY['collection_name', 'collection_code'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('GetVisibleFilesBySeriesAndVisualReviewId', 'select
  file_id
from ctp_file
where visibility is null and file_id in (
  select
    file_id
  from
    image_equivalence_class natural join image_equivalence_class_input_image
  where
    visual_review_instance_id = ? and series_instance_uid = ?
)', ARRAY['visual_review_instance_id', 'series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of files which are hidden by series id and visual review id')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewedInSeries', 'select 
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from (
  select 
    distinct project_name as collection,
    site_name as site,
    patient_id,
    series_instance_uid,
    dicom_file_type,
    modality,
    review_status,
    processing_status,
    visibility,
    file_id
  from 
    dicom_file natural join 
    file_series natural join 
    file_patient natural join
    ctp_file natural join 
  (
    select file_id, review_status, processing_status
    from
      image_equivalence_class_input_image natural join
      image_equivalence_class join
      ctp_file using(file_id)
    where
      series_instance_uid = ?
  ) as foo
) as foo
where
  visibility is null and 
  review_status != ''Good'' and
  review_status != ''PassThrough''
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'visibility', 'file_id'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetPublicSopsForCompare', 'select
  i.patient_id,
  i.study_instance_uid,
  s.series_instance_uid,
  sop_instance_uid,
  sop_class_uid,
  s.modality,
  i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp,
  general_series s
where  
  i.trial_dp_pk_id = tdp.trial_dp_pk_id 
  and tdp.project = ?
  and i.general_series_pk_id = s.general_series_pk_id', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_uri'], ARRAY['public_posda_counts'], 'public', 'Generate a long list of all unhidden SOPs for a collection in public<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('LockFilePosda', 'select 1', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('AllPixelInfoByModality', 'select
  f.file_id as file_id, root_path || ''/'' || rel_path as file,
  file_offset, size, modality,
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation
from
  file_image f natural join image natural join unique_pixel_data
  natural join file_series
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
  select distinct file_id
  from
    ctp_file natural join file_series 
  where visibility is null and modality = ?
)
', ARRAY['bits_allocated'], 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for all files
')
        ;

            insert into queries
            values ('GetActivityInfo', 'select
  activity_id, brief_description, when_created, who_created, when_closed
from 
  activity
where
  activity_id = ?

', ARRAY['activity_id'], 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('InsertNewRootPath', 'insert into file_storage_root  (root_path, current, storage_class) values ( ? , true, ''imported from File List Importer'') returning file_storage_root_id ', ARRAY['root_path'], 
                    ARRAY['file_storage_root_id'], ARRAY['Universal'], 'posda_files', 'Checks for the local environment''s ID for a certain root path. Used by python_import_csv_filelist.py to insert file info into local development environments for files physically stored and referenced in internal posda production. 

(import list will have the root path for a file in prod, this will find the local id for that path)')
        ;

            insert into queries
            values ('GetSopOfPlanReferenceByDose', 'select
  distinct rt_dose_referenced_plan_uid as sop_instance_uid,
  rt_dose_referenced_plan_class as sop_class_uid
from
  rt_dose natural join file_dose
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance_uid', 'sop_class_uid'], ARRAY['LinkageChecks', 'used_in_dose_linkage_check'], 'posda_files', 'Get Plan Reference Info for RTDOSE by file_id
')
        ;

            insert into queries
            values ('AgesAndStudyDates', 'select
  distinct patient_id, study_date, patient_age, count(distinct series_instance_uid) as num_series
from
  file_patient natural join file_series natural join file_study natural join ctp_file
where
  project_name = ? and visibility is null
group by
  patient_id, study_date, patient_age order by patient_id', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_date', 'patient_age', 'num_series'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('HowManyFilesToCopyInCopyFromPublic', 'select
  count(*) as num_to_copy
from file_copy_from_public
where
  copy_from_public_id = ? and
  inserted_file_id is null', ARRAY['copy_from_public_id'], 
                    ARRAY['num_to_copy'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SubjectCountsDateRangeSummaryByCollectionSiteSubject', 'select 
  distinct patient_id,
  study_instance_uid,
  series_instance_uid,
  study_date, 
  min(import_time) as from,
  max(import_time) as to,
  count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops
from 
  ctp_file natural join 
  file_sop_common natural join
  file_study natural join
  file_series natural join
  file_patient natural join 
  file_import natural join 
  import_event
where
  project_name = ? and site_name = ? and visibility is null and patient_id = ?
group by patient_id, study_instance_uid, series_instance_uid, study_date
order by patient_id, study_date', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'study_date', 'from', 'to', 'num_files', 'num_sops'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetNumPixDups', 'select distinct num_pix_dups, count(*) as num_pix_digs
from (
select
  distinct pixel_digest, count(*) as num_pix_dups
from (
   select 
       distinct unique_pixel_data_id, pixel_digest, project_name,
       site_name, patient_id, count(*) 
  from (
    select
      distinct unique_pixel_data_id, file_id, project_name,
      site_name, patient_id, 
      unique_pixel_data.digest as pixel_digest 
    from
      image join file_image using(image_id)
      join ctp_file using(file_id)
      join file_patient fq using(file_id)
      join unique_pixel_data using(unique_pixel_data_id)
    where visibility is null
  ) as foo 
  group by 
    unique_pixel_data_id, project_name, pixel_digest,
    site_name, patient_id
) as foo 
group by pixel_digest) as foo
group by num_pix_dups
order by num_pix_digs desc', '{}', 
                    ARRAY['num_pix_dups', 'num_pix_digs'], ARRAY['pix_data_dups', 'pixel_duplicates'], 'posda_files', 'Find series with duplicate pixel count of <n>
')
        ;

            insert into queries
            values ('SimplePhiReportSelectedVR', 'select 
  distinct element_sig_pattern as element, vr, value, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and
  vr in (''SH'', ''OB'', ''PN'', ''DA'', ''ST'', ''AS'', ''DT'', ''LO'', ''UI'', ''CS'', ''AE'', ''LT'', ''ST'', ''UC'', ''UN'', ''UR'', ''UT'')
group by element_sig_pattern, vr, value;', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('SendEventsByReason', 'select
  send_started, send_ended - send_started as duration,
  destination_host, destination_port,
  number_of_files as to_send, files_sent,
  invoking_user, reason_for_send
from (
  select
    distinct dicom_send_event_id,
    count(distinct file_path) as files_sent
  from
    dicom_send_event natural join dicom_file_send
  where
    reason_for_send = ?
  group by dicom_send_event_id
) as foo
natural join dicom_send_event
order by send_started
', ARRAY['reason'], 
                    ARRAY['send_started', 'duration', 'destination_host', 'destination_port', 'to_send', 'files_sent', 'invoking_user', 'reason_for_send'], ARRAY['send_to_intake'], 'posda_files', 'List of Send Events By Reason
')
        ;

            insert into queries
            values ('DuplicateDownloadsByCollection', 'select distinct patient_id, series_instance_uid, count(*)
from file_series natural join file_patient
where file_id in (
  select file_id from (
    select
      distinct file_id, count(*)
    from file_import
    where file_id in (
      select
        distinct file_id
      from 
        file_patient natural join ctp_file
      where
        project_name = ? 
        and site_name = ? and visibility is null
    )
    group by file_id
  ) as foo
  where count > 1
)
group by patient_id, series_instance_uid
order by patient_id
', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'count'], ARRAY['by_collection', 'duplicates', 'find_series'], 'posda_files', 'Number of files for a subject which have been downloaded more than once
')
        ;

            insert into queries
            values ('SimplePhiReportAllPrivateOnly', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, value, tag_name as description, private_disposition as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and is_private
group by element_sig_pattern, vr, value, val_length, description, disp
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'disp', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetNonDicomFilesByPatientId', 'select 
  file_id, non_dicom_file.file_type, file_sub_type, 
  collection, site, subject, visibility, date_last_categorized,
  size, digest, root_path || ''/'' || rel_path as path
from
  non_dicom_file join file using (file_id) natural join file_location natural join file_storage_root
where
  visibility is null
  and subject = ?
', ARRAY['patient_id'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized', 'size', 'digest', 'path'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('AddHocQuery3', 'select distinct series_instance_uid, body_part_examined, count(distinct file_id) as num_files from file_series where file_id in (
select distinct file_id from import_event natural join file_import natural left join ctp_file where import_event_id in (9535631, 9543872, 9535664) and visibility is null) group by series_instance_uid, body_part_examined
', '{}', 
                    ARRAY['series_instance_uid', 'body_part_examined', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'bills_ad_hoc_scripts'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SopNickname', 'select
  project_name, site_name, subj_id, sop_nickname, modality,
  has_modality_conflict
from
  sop_nickname
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['project_name', 'site_name', 'subj_id', 'sop_nickname', 'modality', 'has_modality_conflict'], '{}', 'posda_nicknames', 'Get a nickname, etc for a particular SOP Instance  uid
')
        ;

            insert into queries
            values ('StudyHierarchyByStudyUIDWithAcessionNoAndNumFiles', 'select distinct
  study_instance_uid, study_description,
  series_instance_uid, series_description,
  modality,
  ''<'' || accession_number || ''>'' as accession_number,
  count(distinct sop_instance_uid) as num_files
from
  file_study natural join ctp_file natural join file_series natural join file_sop_common
where study_instance_uid = ? and visibility is null
group by
  study_instance_uid, study_description,
  series_instance_uid, series_description, modality,accession_number
order by accession_number', ARRAY['study_instance_uid'], 
                    ARRAY['study_instance_uid', 'study_description', 'series_instance_uid', 'series_description', 'modality', 'accession_number', 'num_files'], ARRAY['by_study', 'Hierarchy'], 'posda_files', 'Show List of Study Descriptions, Series UID, Series Descriptions, and Count of SOPS for a given Study Instance UID')
        ;

            insert into queries
            values ('ReportOnStudiesWithSomeMissingStudyDates', 'select
  distinct patient_id, study_instance_uid, study_date, study_description, series_instance_uid,series_date,
  series_description, dicom_file_type, modality, count(distinct file_id) as num_files
from
  file_patient natural join file_study natural join file_series natural join dicom_file
where file_id in (
 select file_id from file_study natural join activity_timepoint_file 
 where activity_timepoint_id = ? and study_instance_uid in (
    select distinct study_instance_uid from (
      select distinct study_date, study_instance_uid
      from ctp_file natural join file_series natural join file_study natural join activity_timepoint_file
      where activity_timepoint_id = ? and visibility is null
    ) as foo 
    where study_date is null
  )
)
group by
  patient_id, study_instance_uid, study_date, study_description, series_instance_uid, series_date,
  series_description, dicom_file_type, modality
order by patient_id, modality', ARRAY['activity_timepoint_id', 'activity_timepoint_id_1'], 
                    ARRAY['patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'series_date', 'series_description', 'dicom_file_type', 'modality', 'num_files'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation', 'New_HNSCC_Investigation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('GetPosdaFileCreationRoot', 'select file_storage_root_id, root_path from file_storage_root where current and storage_class = ''created''', '{}', 
                    ARRAY['file_storage_root_id', 'root_path'], ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Get the file_storage root for newly created files')
        ;

            insert into queries
            values ('GetInboxItem', 'select
	current_status,
	statuts_note,
	date_entered,
	date_dismissed,
	file_id
from user_inbox_content
natural join background_subprocess_report
where user_inbox_content_id = ?

', ARRAY['user_inbox_content_id'], 
                    ARRAY['current_status', 'status_note', 'date_entered', 'date_dismissed', 'file_id'], '{}', 'posda_queries', 'Get the details of a single Inbox item.')
        ;

            insert into queries
            values ('DistinctVisibleSeriesByCollectionSite', 'select distinct series_instance_uid, dicom_file_type, modality, count(distinct file_id)
from
  file_series natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null
group by series_instance_uid, dicom_file_type, modality
', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('FilesInSeriesForApplicationOfPrivateDisposition', 'select
  distinct root_path || ''/'' || rel_path as path, 
  sop_instance_uid, modality
from
  file_location natural join file_storage_root 
  natural join ctp_file natural join file_series
  natural join file_sop_common
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition'], 'posda_files', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('GetMaxStudyDate', 'select
   max(study_date) as study_date
from 
  file_patient natural join ctp_file natural join file_study
where
  patient_id = ?', ARRAY['patient_id'], 
                    ARRAY['study_date'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('FilesInSeriesForApplicationOfPrivateDispositionPublic', 'select
  i.dicom_file_uri as path, i.sop_instance_uid, s.modality
from
  general_image i, general_series s
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.series_instance_uid = ?', ARRAY['series_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition', 'intake'], 'public', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('PatientByImportEventIdVisibleFiles', 'select
  distinct patient_id, count(distinct file_id) as num_files
from file_patient
where file_id in (
  select distinct file_id
  from file_import natural join import_event natural left join ctp_file
  where import_event_id = ? and visibility is null
) group by patient_id order by patient_id', ARRAY['import_event_id'], 
                    ARRAY['patient_id', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('GetPublicCopyInfoBySop', 'select dicom_file_uri, tdp.project, dp_site_name as site_name, dp_site_id as site_id
from general_image i, trial_data_provenance tdp 
where tdp.trial_dp_pk_id = i.trial_dp_pk_id and sop_instance_uid = ?', ARRAY['sop_instance_uid'], 
                    ARRAY['dicom_file_uri', 'project', 'site_name', 'site_id'], ARRAY['bills_test', 'copy_from_public'], 'public', 'Add a filter to a tab')
        ;

            insert into queries
            values ('SeriesWithMoreThanNEquivalenceClasses', 'select series_instance_uid, count from (
select distinct series_instance_uid, count(*) from image_equivalence_class group by series_instance_uid) as foo where count > ?', ARRAY['count'], 
                    ARRAY['series_instance_uid', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency'], 'posda_files', 'Find Series with more than n equivalence class')
        ;

            insert into queries
            values ('WhereSopSitsPublic', 'select distinct
  tdp.project as collection,
  tdp.dp_site_name as site,
  p.patient_id,
  i.study_instance_uid,
  i.series_instance_uid
from
  general_image i,
  patient p,
  trial_data_provenance tdp
where
  sop_instance_uid = ?
  and i.patient_pk_id = p.patient_pk_id
  and i.trial_dp_pk_id = tdp.trial_dp_pk_id
', ARRAY['sop_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['posda_files', 'sops', 'BySopInstance'], 'public', 'Get Collection, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('GetCTQPByLikeCollectionSite', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id
where collection like ? and site = ?', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('DuplicateSopsInSeriesExperimentalSub', 'select 
    distinct sop_instance_uid, min(file_id) as first_f, max(file_id) as last_f
  from
     file_series natural join file_sop_common natural join ctp_file
  where
     series_instance_uid = ? and visibility is null
  group by sop_instance_uid', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'first_f', 'last_f'], ARRAY['by_series', 'dup_sops', 'ACRIN-FMISO-Brain Duplicate Elimination'], 'posda_files', 'List of Actual duplicate SOPs (i.e. different files, same SOP)
in a series
')
        ;

            insert into queries
            values ('DifferentDupSopsReceivedBetweenDatesByCollection', 'select * from (
select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   sum(num_files) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
             natural join ctp_file
          where import_time > ? and import_time < ?
            and project_name = ? and visibility is null
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
where num_uploads > 1
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
) as foo where num_sops != num_files
', ARRAY['start_time', 'end_time', 'collection'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'num_files', 'num_uploads', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates with duplicate sops
')
        ;

            insert into queries
            values ('SimplePhiReportAllRelevantPrivateOnly', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, value, tag_name as description, private_disposition as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and is_private and private_disposition not in (''d'', ''na'')
group by element_sig_pattern, vr, value, val_length, description, disp
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'description', 'disp', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('DuplicateDownloadsBySubject', 'select count(*) from (
  select
    distinct file_id, count(*)
  from file_import
  where file_id in (
    select
      distinct file_id
    from 
      file_patient natural join ctp_file
    where
      patient_id = ? and project_name = ? 
      and site_name = ? and visibility is null
  )
  group by file_id
) as foo
where count > 1
', ARRAY['subject_id', 'project_name', 'site_name'], 
                    ARRAY['count'], ARRAY['by_subject', 'duplicates', 'find_series'], 'posda_files', 'Number of files for a subject which have been downloaded more than once
')
        ;

            insert into queries
            values ('FilesInStudyForEdit', 'select
  distinct root_path || ''/'' || rel_path as path, 
  sop_instance_uid, modality
from
  file_location natural join file_storage_root 
  natural join ctp_file natural join file_series
  natural join file_study
  natural join file_sop_common
where
  study_instance_uid = ? and visibility is null
', ARRAY['study_instance_uid'], 
                    ARRAY['path', 'sop_instance_uid', 'modality'], ARRAY['find_files', 'ApplyDisposition'], 'posda_files', 'Get path, sop_instance_uid, and modality for all files in a series
')
        ;

            insert into queries
            values ('GetPosdaSopsForCompareLikeCollectionEqualSite', 'select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name like ? and site_name = ?
  and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'file_path', 'file_id'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionWithFileCountAndLoadTimesOnlySinceDate', 'select * from (select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files, count (distinct sop_instance_uid) as num_sops,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join file_sop_common using(file_id)
  join import_event using(import_event_id)
where collection like ?
group by collection, site, patient_id, qualified) as foo where earliest_day >= ? ', ARRAY['collection_like', 'from'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'num_sops', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('InsertVisibilityChange', 'insert into file_visibility_change(
  file_id, user_name, time_of_change,
  prior_visibility, new_visibility, reason_for
)values(
  ?, ?, now(),
  ?, ?, ?
)
', ARRAY['file_id', 'user_name', 'prior_visibility', 'new_visibility', 'reason'], 
                    '{}', ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Insert Image Visibility Change

')
        ;

            insert into queries
            values ('IsFileProcessed', 'select is_dicom_file is not null as processed
from file
where file_id = ?
', ARRAY['file_id'], 
                    ARRAY['processed'], '{}', 'posda_files', '
')
        ;

            insert into queries
            values ('CreateSimpleSeriesScanInstance', 'insert into series_scan_instance(
scan_instance_id, series_instance_uid, start_time
)values(?, ?, now())', ARRAY['scan_instance_id', 'series_instance_uid'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Create a new Simple PHI scan')
        ;

            insert into queries
            values ('FileIdsVisibleInSeries', 'select
  distinct file_id
from
  file_series natural join file_sop_common natural join ctp_file
where
  series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['by_series_instance_uid', 'file_ids', 'posda_files'], 'posda_files', 'Get Distinct Unhidden Files in Series
')
        ;

            insert into queries
            values ('DicomFileTypesNotProcessedAll', 'select 
  distinct dicom_file_type, count(distinct file_id)
from
  dicom_file d
where
  not exists (
    select file_id 
    from file_series s
    where s.file_id = d.file_id
  )
group by dicom_file_type', '{}', 
                    ARRAY['dicom_file_type', 'count'], ARRAY['dicom_file_type'], 'posda_files', 'List of Distinct Dicom File Types which have unprocessed DICOM files
')
        ;

            insert into queries
            values ('GetElemenSeenIdBySigVr', 'select element_seen_id
from element_seen
where element_sig_pattern = ? and vr = ?', ARRAY['element_sig_pattern', 'vr'], 
                    ARRAY['element_seen_id'], ARRAY['NotInteractive', 'ElementDisposition', 'phi_maint'], 'posda_phi_simple', 'Get List of Private Elements By Disposition')
        ;

            insert into queries
            values ('GetReferencedButUnknownSsSops', 'select
  sop_instance_uid, 
  ss_referenced_from_plan as ss_sop_instance_uid 
from 
  plan p natural join file_plan join file_sop_common using(file_id)
where
  not exists (
  select
    sop_instance_uid 
  from
    file_sop_common fsc
  where
    p.ss_referenced_from_plan  = fsc.sop_instance_uid
)', '{}', 
                    ARRAY['sop_instance_uid', 'ss_sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('ShowQueryTabHierarchy', 'select 
  query_tab_name, filter_name, tag, count(distinct query_name) as num_queries
from(
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
natural join(
  select
     name as query_name,
     unnest(tags) as tag
from queries
) as fie
group by query_tab_name, filter_name, tag
order by 
  query_tab_name, filter_name, tag', '{}', 
                    ARRAY['query_tab_name', 'filter_name', 'tag', 'num_queries'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DistinctSeriesByImportEvent', 'select
  distinct project_name as collection, site_name as site, 
  patient_id, patient_name, study_instance_uid, series_instance_uid, 
  dicom_file_type, modality, count(distinct file_id)
from
  file_patient natural join file_study natural join file_series natural join dicom_file
  natural left join ctp_file
where
  file_id in (
    select distinct file_id from file_import where import_event_id = ?
  )
group by collection, site, patient_id, patient_name,
  study_instance_uid, series_instance_uid, dicom_file_type, modality', ARRAY['import_event_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'patient_name', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['select_for_phi', 'visual_review_selection'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('DiskSpaceByCollection', 'select
  distinct project_name as collection, sum(size) as total_bytes
from
  ctp_file natural join file
where
  file_id in (
  select distinct file_id
  from ctp_file
  where project_name = ?
  )
group by project_name
', ARRAY['collection'], 
                    ARRAY['collection', 'total_bytes'], ARRAY['by_collection', 'posda_files', 'storage_used'], 'posda_files', 'Get disk space used by collection
')
        ;

            insert into queries
            values ('UpdateActivityTaskStatusAndCompletionTime', 'update activity_task_status set
  status_text = ?,
  expected_remaining_time = ?,
  last_updated = now(),
  dismissed_time = null,
  dismissed_by = null
where
  activity_id = ? and
  subprocess_invocation_id = ?', ARRAY['status_text', 'expected_completion_time', 'activity_id', 'subprocess_invocation_id'], 
                    '{}', ARRAY['NotInteractive', 'Update'], 'posda_files', 'Update status_text and expected_completion_time in activity_task_status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('TagsSeenSimplePrivateWithCountAndNullDisp', 'select 
  distinct element_sig_pattern,
  vr,
  private_disposition, tag_name,
  count(distinct value) as num_values
from
  element_seen natural left join
  element_value_occurance
  natural left join value_seen
where
  is_private and private_disposition is null
group by element_sig_pattern, vr, private_disposition, tag_name
order by element_sig_pattern;', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'private_disposition', 'tag_name', 'num_values'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi_simple', 'Get all the data from tags_seen in posda_phi_simple database
')
        ;

            insert into queries
            values ('FindStudiesWithMatchingDescriptionByCollection', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name = ? and visibility is null and study_description = ?
    group by
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection', 'description'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency'], 'posda_files', 'Find Studies by Collection with Null Study Description
')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsExtendedByCollectionSiteStatus', 'select 
  distinct 
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  equivalence_class_number,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join
  file_patient natural join
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status = ? and visibility is null
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  equivalence_class_number
order by
  series_instance_uid', ARRAY['project_name', 'site_name', 'status'], 
                    ARRAY['collection', 'site', 'series_instance_uid', 'patient_id', 'dicom_file_type', 'modality', 'review_status', 'num_files', 'equivalence_class_number'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('SeriesEquivalenceClassResults', 'select
  distinct series_instance_uid,
  equivalence_class_number, 
  review_status,
  count(distinct file_id) as files_in_class
from
  image_equivalence_class
  natural join image_equivalence_class_input_image
where series_instance_uid in (
  select 
    distinct series_instance_uid
  from
    ctp_file
    natural join file_series 
    join image_equivalence_class using(series_instance_uid) 
  where project_name = ? and visibility is null and review_status = ?
) group by
   series_instance_uid,
   equivalence_class_number,
   review_status
order by series_instance_uid, equivalence_class_number', ARRAY['project_name', 'status'], 
                    ARRAY['series_instance_uid', 'equivalence_class_number', 'review_status', 'files_in_class'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('DuplicateSopsWithLastLoadDateByCollection', 'select
  distinct sop_instance_uid, file_id, max(import_time) latest
from file_location join file_import using(file_id) join import_event using (import_event_id)  
  join file_sop_common using(file_id) join ctp_file using (file_id)
where sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(distinct file_id)
    from file_sop_common natural join ctp_file
    where project_name = ? and visibility is null group by sop_instance_uid
    ) as foo
  where count > 1
  ) and visibility is null
group by sop_instance_uid, file_id', ARRAY['collection'], 
                    ARRAY['collection'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'List of duplicate sops with file_ids and latest load date<br><br>
<bold>Warning: may generate a lot of output</bold>')
        ;

            insert into queries
            values ('DistinctSeriesBySubject', 'select distinct series_instance_uid, modality, count(*)
from (
select distinct series_instance_uid, sop_instance_uid, modality from (
select
   distinct series_instance_uid, modality, sop_instance_uid,
   file_id
 from file_series natural join file_sop_common
   natural join file_patient natural join ctp_file
where
  patient_id = ? and project_name = ? 
  and site_name = ? and visibility is null)
as foo
group by series_instance_uid, sop_instance_uid, modality)
as foo
group by series_instance_uid, modality
', ARRAY['subject_id', 'project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'modality', 'count'], ARRAY['by_subject', 'find_series'], 'posda_files', 'Get Series in A Collection, Site, Subject
')
        ;

            insert into queries
            values ('DistinctVisibleFileReportByCollectionSite', 'select distinct
  project_name as collection, site_name as site, patient_id, study_instance_uid,
  series_instance_uid, sop_instance_uid, dicom_file_type, modality, file_id
from
  file_patient natural join file_study natural join file_series natural join file_sop_common
  natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null
order by series_instance_uid', ARRAY['project_name', 'site_name'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_type', 'modality', 'file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('CreateNonDicomPathValueOccurance', 'insert into non_dicom_path_value_occurrance(
  non_dicom_path_seen_id,
  value_seen_id,
  non_dicom_file_scan_id
) values (
  ?, ?, ?
)', ARRAY['non_dicom_path_seen_id', 'value_seen_id', 'non_dicom_file_scan_id'], 
                    '{}', ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('PatientByImportEventId', 'select
  distinct patient_id, visibility, count(distinct file_id) as num_files
from file_patient natural left join ctp_file
where file_id in (
  select distinct file_id
  from file_import natural join import_event 
  where import_event_id = ?
) group by patient_id, visibility order by patient_id, visibility', ARRAY['import_event_id'], 
                    ARRAY['patient_id', 'visibility', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('StartTransaction', 'begin', '{}', 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('CreateEquipmentSignature', 'insert into equipment_signature(equipment_signature)values(?)
', ARRAY['equipment_signature'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create New Equipment Signature Id')
        ;

            insert into queries
            values ('SimplePhiReportByScanVrPrivateOnly', 'select 
  distinct element_sig_pattern as element, vr, value, 
  tag_name as description, private_disposition as disposition,
  count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and vr = ?
  and is_private
group by element_sig_pattern, vr, value, tag_name, private_disposition', ARRAY['scan_id', 'vr'], 
                    ARRAY['element', 'vr', 'value', 'description', 'disposition', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('ListOfPrivateElementsValues', 'select
  distinct value
from
  scan_element natural join seen_value
where
  element_signature_id = ?
order by value
', ARRAY['element_signature_id'], 
                    ARRAY['value'], ARRAY['ElementDisposition'], 'posda_phi', 'Get List of Values for Private Element based on element_signature_id')
        ;

            insert into queries
            values ('GetRoiList', 'select 
   roi_id, roi_num ,roi_name
from 
  roi natural join structure_set natural join file_structure_set 
  join file_sop_common using(file_id)
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['roi_id', 'roi_num', 'roi_name'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of ROI''s in a structure Set

')
        ;

            insert into queries
            values ('RtstructSopsByCollectionSiteDateRange', 'select distinct
  sop_instance_uid
from
  file_series natural join ctp_file natural join file_sop_common
  natural join file_import natural join import_event
where 
  project_name = ? and site_name = ?
  and visibility is null and import_time > ? and 
  import_time < ?
  and modality = ''RTSTRUCT''', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['sop_instance_uid'], ARRAY['Hierarchy', 'apply_disposition', 'hash_unhashed'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('InsertRowFileMr', 'insert into file_mr(
  mr_scanning_seq, mr_scanning_var, mr_scan_options,
  mr_acq_type, mr_slice_thickness, mr_repetition_time,
  mr_echo_time,  mr_magnetic_field_strength, mr_spacing_between_slices,
  mr_echo_train_length, mr_software_version, mr_flip_angle,
  mr_nominal_pixel_spacing, mr_patient_position, mr_acquisition_number,
  mr_instance_number, mr_smallest_pixel, mr_largest_value,
  mr_window_center, mr_window_width, mr_rescale_intercept,
  mr_rescale_slope, mr_rescale_type, file_id
) values (
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?,
  ?, ?, ?
)

', ARRAY['mr_scanning_seq', 'mr_scanning_var', 'mr_scan_options', 'mr_acq_type', 'mr_slice_thickness', 'mr_repetition_time', 'mr_echo_time', 'mr_magnetic_field_strength', 'mr_spacing_between_slices', 'mr_echo_train_length', 'mr_software_version', 'mr_flip_angle', 'mr_nominal_pixel_spacing', 'mr_patient_position', 'mr_acquisition_number', 'mr_instance_number', 'mr_smallest_pixel', 'mr_largest_pixel', 'mr_window_center', 'mr_window_width', 'mr_rescale_intercept', 'mr_rescale_slope', 'mr_rescale_type', 'file_id'], 
                    '{}', ARRAY['mr_images'], 'posda_files', 'Insert a Row in file_mr
')
        ;

            insert into queries
            values ('GetPlansReferencingGoodSS', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from plan p natural join file_plan  where
exists (select sop_instance_uid from file_sop_common fsc where p.ss_referenced_from_plan 
= fsc.sop_instance_uid))', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetRoundId', 'select  currval(''round_round_id_seq'') as id
', '{}', 
                    ARRAY['file_id'], ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Get posda file id of created round row')
        ;

            insert into queries
            values ('ChangeEquivalenceClassStatus', 'update image_equivalence_class set
  review_status = ?,
  processing_status = ?
where
  image_equivalence_class_id = ?', ARRAY['review_status', 'processing_status', 'image_equivalence_class_id'], 
                    '{}', ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('DicomEditCompareDispositionStatus', 'select 
  subprocess_invocation_id as id, 
  current_disposition as status,
  date_trunc(''minute'', start_creation_time) as started_at,
  date_trunc(''second'', last_updated - start_creation_time) as run_time,
  date_trunc(''second'', now() - last_updated) as since_update, 
  process_pid as pid,
  number_edits_scheduled as total_edits,
  number_edits_scheduled - (number_compares_with_diffs + number_compares_without_diffs) as remaining
from
dicom_edit_compare_disposition', '{}', 
                    ARRAY['id', 'status', 'started_at', 'run_time', 'since_update', 'pid', 'total_edits', 'remaining'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Status of entries in dicom_edit_comparison')
        ;

            insert into queries
            values ('SsRoiForsBySopInstance', 'select 
  distinct for_uid
from
  roi natural join file_structure_set
where
  file_id in (
    select file_id 
    from file_sop_common natural join ctp_file
    where sop_instance_uid = ? and visibility is null
  )', ARRAY['sop_instance_uid'], 
                    ARRAY['for_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetSeriesWithSignatureByCollectionSiteDateRange', 'select distinct
  series_instance_uid, dicom_file_type, 
  modality|| '':'' || coalesce(manufacturer, ''<undef>'') || '':'' 
  || coalesce(manuf_model_name, ''<undef>'') ||
  '':'' || coalesce(software_versions, ''<undef>'') as signature,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from
  file_series natural join file_equipment natural join ctp_file
  natural join dicom_file join file_import using(file_id)
  join import_event using(import_event_id)
where project_name = ? and site_name = ? and visibility is null
  and import_time > ? and import_time < ?
group by series_instance_uid, dicom_file_type, signature
', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'signature', 'num_series', 'num_files'], ARRAY['signature', 'phi_review'], 'posda_files', 'Get a list of Series with Signatures by Collection
')
        ;

            insert into queries
            values ('UpdateElementDispositionSimple', 'update
  element_seen
set
  private_disposition = ?
where
  element_seen_id = ?', ARRAY['disp', 'id'], 
                    '{}', ARRAY['tag_usage', 'used_in_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('FindStructureSets', 'select
  distinct dicom_file_type, project_name,  
  patient_id, min(import_time), max(import_time), count(distinct file_id) 
from
  ctp_file natural join dicom_file natural join
  file_patient natural join file_import natural join 
  import_event 
where file_id in (
  select file_id 
  from (
    select file_id, image_id 
    from ctp_file natural join file_series left join file_image using(file_id)
    where modality = ''CT'' and project_name = ''Exceptional-Responders'' and file_id in (
      select
         distinct file_id from file_import natural join import_event natural join dicom_file
      where import_time > ''2018-09-17''
    )
  ) as foo where image_id is null
) 
and visibility is null
group by dicom_file_type, project_name, patient_id
order by patient_id', '{}', 
                    ARRAY['dicom_file_type', 'project_name', 'patient_id', 'min', 'max', 'count'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('GetDciodvfyErrorUnrecogPub', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''UnrecognizedPublicTag''
  and error_tag = ?
', ARRAY['error_tag'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_tag where error_type = ''UnrecognizedPublicTag''')
        ;

            insert into queries
            values ('GetSeriesWithSignatureIntake', 'select
  distinct  s.series_instance_uid,
  concat(
    COALESCE(e.manufacturer, ''''), 
    ''_'',
    COALESCE(e.manufacturer_model_name, ''''),
     ''_'',
    COALESCE(e.software_versions, '''') 
  ) as signature
from
  general_series s, general_equipment e
where
  s.general_equipment_pk_id = e.general_equipment_pk_id and
  s.general_series_pk_id in (
    select
      distinct i.general_series_pk_id
    from
      general_image i, trial_data_provenance tdp
    where
      i.trial_dp_pk_id = tdp.trial_dp_pk_id and
      tdp.project = ? and tdp.dp_site_name = ?
  )', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid', 'signature'], ARRAY['signature'], 'intake', 'Get a list of Series with Signatures by Collection Intake
')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionWithFileCountAndLoadTimesSinceDate', 'select * from (select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join import_event using(import_event_id)
where collection like ?
group by collection, site, patient_id, qualified) as foo where latest_day >= ? ', ARRAY['collection_like', 'from'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PixelDataIdByFileId', 'select
  distinct file_id, image_id, unique_pixel_data_id
from
  file_image natural join image
where
  file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_id', 'image_id', 'unique_pixel_data_id'], ARRAY['by_file_id', 'pixel_data_id', 'posda_files'], 'posda_files', 'Get unique_pixel_data_id for file_id 
')
        ;

            insert into queries
            values ('FindStudiesWithNullDescriptionByCollection', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name = ? and visibility is null and study_description is null
    group by
      study_instance_uid, study_date, study_time,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency'], 'posda_files', 'Find Studies by Collection with Null Study Description
')
        ;

            insert into queries
            values ('IntakeImagesByCollectionSiteSubj', 'select
  p.patient_id as PID,
  s.modality as Modality,
  i.dicom_file_uri as FilePath,
  i.sop_instance_uid as SopInstance,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ? and
  p.patient_id = ?
', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['PID', 'Modality', 'SopInstance', 'FilePath'], ARRAY['SymLink', 'intake'], 'intake', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('PixelInfoBySeries', 'select
  f.file_id as file_id, root_path || ''/'' || rel_path as file,
  file_offset, size, modality,
  bits_stored, bits_allocated, pixel_representation, number_of_frames,
  samples_per_pixel, pixel_rows, pixel_columns, photometric_interpretation,
  planar_configuration
from
  file_image f natural join image natural join unique_pixel_data
  natural join file_series
  join pixel_location pl using(unique_pixel_data_id), 
  file_location fl natural join file_storage_root
where
  pl.file_id = fl.file_id
  and f.file_id = pl.file_id
  and f.file_id in (
  select distinct file_id
  from file_series natural join ctp_file
  where series_instance_uid = ? and visibility is null
)
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'file', 'file_offset', 'size', 'bits_stored', 'bits_allocated', 'pixel_representation', 'number_of_frames', 'samples_per_pixel', 'pixel_rows', 'pixel_columns', 'photometric_interpretation', 'planar_configuration', 'modality'], '{}', 'posda_files', 'Get pixel descriptors for all files in a series
')
        ;

            insert into queries
            values ('GetFilesNotHiddenInDicomFileCompare', 'select
  distinct from_file_digest
from
  dicom_edit_compare
where
  from_file_digest in 
  (
    select from_file_digest from 
    (
      select distinct from_file_digest 
      from dicom_edit_compare dec, file f natural join ctp_file
      where dec.from_file_digest = f.digest and visibility is null and edit_command_file_id = ?
      except
      select from_file_digest from dicom_edit_compare dec
      where not exists
      (
        select file_id from file f where dec.to_file_digest = f.digest
       ) 
       and edit_command_file_id = ?
    ) as foo
  )
  and edit_command_file_id = ?
', ARRAY['command_file_id', 'command_file_id_1', 'command_file_id_2'], 
                    ARRAY['from_file_digest'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get Files not hidden but replacement imported')
        ;

            insert into queries
            values ('RoundSummary1AvoidingCrash', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups)
from
  round natural join round_collection
where
  round_end is not null 
group by 
  round_id, round_start, duration, round_end 
order by round_id', '{}', 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('FindInconsistentSeriesExtended', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    image_type, count(*)
  from
    file_series natural join ctp_file
    left join file_image using(file_id)
    left join image using(image_id)
  where
    project_name = ? and visibility is null
  group by
    series_instance_uid, image_type,
    modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series'], 'posda_files', 'Find Inconsistent Series Extended to include image type
')
        ;

            insert into queries
            values ('GetTheBaseCtSeriesForLGCP', 'select
  patient_id, series_instance_uid, count(distinct file_id) as num_files
from 
  file_series natural join file_patient natural join ctp_file
where series_instance_uid in (
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.983508919695337135620677418685'',
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.170224599052836213374813274674'',
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.124599233476878991434251967746'',
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.122505729234908340647352438768'',
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.246380096059125471917249164954'',
 ''1.3.6.1.4.1.14519.5.2.1.5826.1402.199118463594923165410399883739'')
 and visibility is null
group by patient_id, series_instance_uid', '{}', 
                    ARRAY['patient_id', 'series_instance_uid', 'num_files'], ARRAY['Curation of Lung-Fused-CT-Pathology'], 'posda_files', 'Get the list of series which serve as a basis for fixing SOP instance UID''s in Lung-Fused-CT-Pathology')
        ;

            insert into queries
            values ('RoiInfoByFileIdWithCountsAndOffsets', 'select
  roi_id, for_uid, linked_sop_instance_uid,
  max_x, max_y, max_z,
  min_x, min_y, min_z,
  roi_name, roi_description , roi_interpreted_type,
  contour_file_offset + coalesce (data_set_start, 0) as contour_real_file_offset,
  contour_length,
  root_path || ''/'' || rel_path as path
from
  roi natural join file_roi_image_linkage natural join file_location natural join file_storage_root natural join file_meta
where file_id = ?
', ARRAY['file_id'], 
                    ARRAY['roi_id', 'for_uid', 'linked_sop_instance_uid', 'max_x', 'max_y', 'max_z', 'min_x', 'min_y', 'min_z', 'roi_name', 'roi_description', 'roi_interpreted_type', 'contour_real_file_offset', 'contour_length', 'path'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('GetNonDicomFilesByCollection', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
  collection = ? and
  visibility is null
', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('InsertActivityTaskStatus', 'insert into activity_task_status(
  activity_id,
  subprocess_invocation_id,
  start_time,
  status_text,
  last_updated
) values (
  ?,
  ?,
  now(),
   ''Initializing'',
  now()
)', ARRAY['activity_id', 'subprocess_invocation_id'], 
                    '{}', ARRAY['Insert', 'NotInteractive'], 'posda_files', 'Insert Initial Patient Status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('ConflictingDispositions', 'select
  element_sig_pattern, vr, tag_name, private_disposition
 from 
  element_seen 
where element_sig_pattern in (
  select 
    distinct element_sig_pattern 
  from (
    select 
      distinct element_sig_pattern, count(distinct private_disposition) 
    from element_seen 
    group by element_sig_pattern 
    order by count desc
  ) as foo 
  where count > 1
) order by element_sig_pattern;', '{}', 
                    ARRAY['element_sig_pattern', 'vr', 'tag_name', 'private_disposition'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('CreateCopyFromPublicEntry', 'insert into copy_from_public(
  who, why, when_row_created, status_of_copy
) values (
  ?, ?, now(), ?
)', ARRAY['who', 'why', 'status_of_copy'], 
                    '{}', ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('TagsSeenPrivateWithCountNullDisp', 'select
  distinct element_signature, 
  vr, 
  private_disposition, 
  name_chain, 
  count(distinct value) as num_values
from
  element_signature natural left join
  scan_element natural left join
  seen_value
where is_private and private_disposition is null
group by element_signature, vr, private_disposition, name_chain
order by element_signature, vr', '{}', 
                    ARRAY['element_signature', 'vr', 'private_disposition', 'name_chain', 'num_values'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi', 'Get all the data from tags_seen in posda_phi database
')
        ;

            insert into queries
            values ('FileStorageRootSummary', 'select 
  distinct file_storage_root_id,
  root_path,
  storage_class,
  count(distinct file_id) as num_files
from
  file_storage_root
  natural join file_location
group by file_storage_root_id, root_path, storage_class;', '{}', 
                    ARRAY['file_storage_root_id', 'root_path', 'storage_class', 'num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('ListOfPrivateElementsWithDispositions', 'select
  element_signature, vr , private_disposition as disposition, element_signature_id, name_chain
from
  element_signature
where
  is_private
order by element_signature
', '{}', 
                    ARRAY['element_signature', 'vr', 'disposition', 'element_signature_id', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('FindPotentialDistinguishedPixelDigests', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  digest as pixel_digest,
  pixel_rows,
  pixel_columns,
  bits_allocated,
  count(*)
from
  ctp_file
  natural join file_patient
  natural join file_series
  natural join file_image
  natural join dicom_file
  join image using (image_id)
  join unique_pixel_data using(unique_pixel_data_id)
where
  file_id in 
  (select 
    distinct file_id 
  from
    file_image 
  where
    image_id in
    (select
       image_id from 
       (select
         distinct image_id, count(distinct file_id) 
       from
         file_image 
       group by image_id
       ) as foo
     where count > 10
  )
) and visibility is null 
group by collection, site, patient_id, series_instance_uid,
modality, dicom_file_type,
digest, pixel_rows, pixel_columns, bits_allocated
order by digest, collection, site, patient_id

', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'pixel_digest', 'pixel_rows', 'pixel_columns', 'bits_allocated', 'count'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('PixelTypesWithNoGeo', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration
from
  image i where image_id not in (
    select image_id from image_geometry g where g.image_id = i.image_id
  )
order by photometric_interpretation
', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'planar_configuration'], ARRAY['find_pixel_types', 'image_geometry', 'posda_files'], 'posda_files', 'Get pixel types with no geometry
')
        ;

            insert into queries
            values ('LockNonDicomEditCompareDisposition', 'lock non_dicom_edit_compare_disposition
', '{}', 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Lock table non_dicom_edit_compare_disposition

From script only.  Don''t run from user interface.')
        ;

            insert into queries
            values ('PatientStudySeriesEquivalenceClassNoByProcessingStatus', 'select 
  distinct patient_id, study_instance_uid, series_instance_uid, equivalence_class_number, count(*) 
from 
  image_equivalence_class natural join image_equivalence_class_input_image natural join
  file_study natural join file_series natural join file_patient
where
  processing_status = ?
group by patient_id, study_instance_uid, series_instance_uid, equivalence_class_number
order by patient_id, study_instance_uid, series_instance_uid, equivalence_class_number', ARRAY['processing_status'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'equivalence_class_number', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Find Series with more than n equivalence class')
        ;

            insert into queries
            values ('FileIdByPixelType', 'select
  distinct file_id
from
  image natural join file_image
where
  photometric_interpretation = ? and
  samples_per_pixel = ? and
  bits_allocated = ? and
  bits_stored = ? and
  high_bit = ? and
  (pixel_representation = ?  or pixel_representation is null) and
  (planar_configuration = ? or planar_configuration is null)
limit 100', ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'planar_configuration'], 
                    ARRAY['file_id'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('CountOfFilesRemainingToBeHiddenByScanInstance', 'select
  count(distinct file_id) as num_files
from
  file_sop_common natural
  join ctp_file
where
  visibility is null and
  sop_instance_uid in (
    select
      sop_instance_uid
    from
      file_sop_common
      where file_id in (
          select
            distinct file_id
          from
             image_equivalence_class natural join
             image_equivalence_class_input_image
           where
             visual_review_instance_id = ? and
             review_status = ''Bad''
        )
     )', ARRAY['visual_review_instance_id'], 
                    ARRAY['num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_status'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('RoundSummary1ByDateRange', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups),
  ((round_end - round_start) / sum(num_entered + num_dups)) as sec_per_file
from
  round natural join round_collection
where
  round_end is not null and round_end > ? and round_end < ?
group by 
  round_id, round_start, duration, round_end 
order by round_id', ARRAY['from', 'to'], 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum', 'sec_per_file'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('GetDciodvfyWarningRetiredAttr', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''RetiredAttribute''
  and warning_tag = ?
  and warning_desc = ?', ARRAY['warning_tag', 'warning_desc'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_warnings row where warning_type = GetDciodvfyWarningRetiredAttr')
        ;

            insert into queries
            values ('ShowAllVisibilityChangesBySopInstance', 'select
  file_id,
  user_name,
  time_of_change,
  prior_visibility,
  new_visibility,
  reason_for
from
   file_visibility_change 
where file_id in (
  select file_id 
  from file_sop_common
  where sop_instance_uid = ?
)
order by time_of_change', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'user_name', 'time_of_change', 'prior_visibility', 'new_visibility', 'reason_for'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('AllPrivateDispositions', 'select 
  distinct element_sig_pattern, vr, tag_name, element_seen_id, private_disposition
from 
  element_seen
where
  is_private
order by element_sig_pattern,vr', '{}', 
                    ARRAY['element_sig_pattern', 'tag_name', 'vr', 'element_seen_id', 'private_disposition'], ARRAY['tag_usage', 'used_in_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('DuplicateSOPInstanceUIDs', 'select
  sop_instance_uid, min(file_id) as first,
  max(file_id) as last, count(*)
from file_sop_common
where sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
      select distinct file_id, sop_instance_uid 
      from
        ctp_file natural join file_sop_common
        natural join file_patient
      where project_name = ? and site_name = ? and patient_id = ?
    ) as foo natural join ctp_file
    where visibility is null
    group by sop_instance_uid order by count desc
  ) as foo where count > 1
) group by sop_instance_uid;
', ARRAY['collection', 'site', 'subject'], 
                    ARRAY['sop_instance_uid', 'first', 'last', 'count'], ARRAY['duplicates'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('GetDciodvfyWarningAttrSpecWithValue', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''AttributeSpecificWarningWithValue''
  and warning_tag = ?
  and warning_desc = ?
  and warning_value = ?


  ', ARRAY['warning_tag', 'warning_desc', 'warning_value'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_warning row where subtype = AttributeSpecificWarningWithValue')
        ;

            insert into queries
            values ('ShowQueryTabHierarchyByTabWithQueryCounts', 'select distinct query_tab_name, filter_name, tag, count(distinct query_name) as num_queries
from(
select
  query_tab_name, filter_name, tag, query_name
from (
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
  where query_tab_name = ?
) as foo
natural join(
  select name as query_name, unnest(tags) as tag
from queries
) as fie
) as foo
group by query_tab_name, filter_name, tag
order by filter_name, tag', ARRAY['query_tab_name'], 
                    ARRAY['query_tab_name', 'filter_name', 'tag', 'num_queries'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('QueryArgsByQueryId', 'select
  arg_index as num, arg_name as name, arg_value as value
from
  dbif_query_args
where
  query_invoked_by_dbif_id = ?
order by arg_index', ARRAY['id'], 
                    ARRAY['num', 'name', 'value'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetNonDicomPathSeen', 'select
  non_dicom_path_seen_id 
from
  non_dicom_path_seen
where
  non_dicom_file_type = ? and
  non_dicom_path = ?', ARRAY['file_type', 'path'], 
                    '{}', ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('WhereSeriesSitsQuick', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_patient natural join
  file_study natural join
  file_series natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
  limit 1
)', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['by_series_instance_uid', 'posda_files', 'sops', 'used_in_simple_phi'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which series resides
')
        ;

            insert into queries
            values ('DiskSpaceByCollectionSummaryWithDups', 'select
  distinct project_name as collection, sum(size) as total_bytes
from
  ctp_file natural join file natural join file_import
where
  file_id in (
  select distinct file_id
  from ctp_file
  )
group by project_name
order by total_bytes
', '{}', 
                    ARRAY['collection', 'total_bytes'], ARRAY['by_collection', 'posda_files', 'storage_used', 'summary'], 'posda_files', 'Get disk space used for all collections
')
        ;

            insert into queries
            values ('GetFileVisibility', 'select distinct visibility from ctp_file where file_id = ?', ARRAY['file_id'], 
                    ARRAY['visibility'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get current visibility by file_id
')
        ;

            insert into queries
            values ('PatientIdMappingByPatientId', 'select
  from_patient_id, to_patient_id, to_patient_name, collection_name, site_name,
  batch_number, diagnosis_date, baseline_date, date_shift, uid_root
from 
  patient_mapping
where
  from_patient_id = ?', ARRAY['from_patient_id'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'uid_root'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_files', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('InsertIntoNonDicomEditCompareFixed', 'insert into non_dicom_edit_compare(
  subprocess_invocation_id,
  from_file_digest,
  to_file_digest,
  report_file_id,
  to_file_path
) values ( ?, ?, ?, ?, ?)', ARRAY['subprocess_invocation_id', 'from_file_digest', 'to_file_digest', 'report_file_id', 'to_file_path'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda', 'public_posda_counts', 'non_dicom_edit'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('GetDciodvfyWarningAttrSpec', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''AttributeSpecificWarning''
  and warning_tag = ?
  and warning_desc= ?', ARRAY['warning_tag', 'warning_desc'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_warning row where subtype = AttributeSpecificWarning')
        ;

            insert into queries
            values ('GetPatientInfoById', 'select
  file_id,
  patient_name,
  patient_id,
  id_issuer,
  dob,
  sex,
  time_ob,
  other_ids
  other_name,
  ethnic_group,
  comments
from file_patient
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'modality', 'series_instance_uid', 'series_number', 'laterality', 'series_date', 'series_time', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_start_time', 'performed_procedure_step_desc', 'performed_procedure_step_comments', 'performed_procedure_step_comments', 'date_fixed'], ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('CreateCtpFileRow', 'insert into ctp_file(
  file_id, project_name, site_name, site_id, file_visibility, batch, study_year
) values (
  ?, ?, ?, ?, ?, ?, ?
)', ARRAY['file_id', 'project_name', 'site_name', 'site_id', 'file_visibility', 'batch', 'study_year'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'create ctp_file row')
        ;

            insert into queries
            values ('InsertIntoDicomEditCompareFixed', 'insert into dicom_edit_compare(
  subprocess_invocation_id,
  from_file_digest,
  to_file_digest,
  short_report_file_id,
  long_report_file_id,
  to_file_path
) values ( ?, ?, ?, ?, ?, ?)', ARRAY['subprocess_invocation_id', 'from_file_digest', 'to_file_digest', 'short_report_file_id', 'long_report_file_id', 'to_file_path'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda', 'public_posda_counts'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('AddFilterToTab', 'insert into query_tabs_query_tag_filter(query_tab_name, filter_name, sort_order)
values(?, ?, ?)', ARRAY['query_tab_name', 'filter_name', 'sort_order'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PixelTypesWithGeoRGB', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  pixel_representation,
  planar_configuration,
  iop, count(distinct image_id) as num_images
from
  image natural left join image_geometry
where
  photometric_interpretation = ''RGB''
group by photometric_interpretation,
  samples_per_pixel, bits_allocated, bits_stored, high_bit, pixel_representation,
  planar_configuration, iop
order by photometric_interpretation
', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'planar_configuration', 'iop', 'num_images'], ARRAY['find_pixel_types', 'image_geometry', 'posda_files', 'rgb'], 'posda_files', 'Get distinct pixel types with geometry and rgb
')
        ;

            insert into queries
            values ('CreateActivityTimepoint', 'insert into activity_timepoint(
  activity_id, when_created, who_created, comment, creating_user
) values (
  ?, now(), ?, ?, ?
)', ARRAY['actiity_id', 'who_created', 'comment', 'creating_user'], 
                    '{}', ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('RoundStatsWithSubjByCollectionForDateRange', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ? and collection = ?
group by collection, site, subj, time order by time desc, collection', ARRAY['interval', 'from', 'to', 'collection'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('PhiNonDicomScanStatus', 'select 
   phi_non_dicom_scan_instance_id as id,
   pndsi_description as description,
   pndsi_start_time as start_time,
   pndsi_num_files as num_files_to_scan,
   pndsi_num_files_scanned as num_files_scanned,
   pndsi_end_time as end_time
from
  phi_non_dicom_scan_instance
order by start_time
', '{}', 
                    ARRAY['id', 'description', 'start_time', 'num_files_to_scan', 'num_files_scanned', 'end_time'], ARRAY['tag_usage', 'non_dicom_phi_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('PatientStudySeriesFileHierarchyByCollectionSite', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  modality
from
  file_study natural join ctp_file natural join file_series natural join file_patient
  natural join file_sop_common
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and visibility is null
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'modality'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series, with Modality of file')
        ;

            insert into queries
            values ('CreateNonDicomFileScanInstance', 'insert into non_dicom_file_scan(
  phi_non_dicom_scan_instance_id,
  file_type,
  file_in_posda,
  posda_file_id
) values (
  ?, ?, true, ?
)', ARRAY['phi_non_dicom_scan_instance_id', 'file_type', 'posda_file_id'], 
                    '{}', ARRAY['NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('GetUnpopulatedMrFiles', 'select
  distinct file_id, root_path || ''/'' || rel_path as path
from 
  file_storage_root natural join file_location
where
  file_id in (
    select file_id from dicom_file d natural left join ctp_file
    where visibility is null and dicom_file_type = ''MR Image Storage''
    and not exists (
      select file_id from file_mr m where m.file_id = d.file_id
    )
  )', '{}', 
                    ARRAY['file_id', 'path'], ARRAY['mr_images'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AllManifestsByCollection', 'select
  distinct file_id, import_time, size, root_path || ''/'' || l.rel_path as path, i.file_name as alt_path
from
  file_location l join file_storage_root using(file_storage_root_id) 
  join file_import i using (file_id) natural join file join import_event using(import_event_id)
where
  file_id in (
    select distinct file_id from ctp_manifest_row where cm_collection = ?
  )', ARRAY['collection'], 
                    ARRAY['file_id', 'import_time', 'size', 'path', 'alt_path'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('InsertInitialDicomDD', 'insert into dicom_element(tag, name, keyword, vr, vm, is_retired, comments)
values (?,?,?,?,?,?,?)', ARRAY['tag', 'name', 'keyword', 'vr', 'vm', 'is_retired', 'comments'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'dicom_dd'], 'dicom_dd', 'Insert row into dicom_dd database')
        ;

            insert into queries
            values ('VolumeReferencedByStruct', 'select 
  distinct for_uid, study_instance_uid, series_instance_uid, count(distinct sop_instance) as num_sops
from
  ss_volume natural join ss_for natural join file_structure_set
where
  file_id = ?
group by
  for_uid, study_instance_uid, series_instance_uid', ARRAY['file_id'], 
                    ARRAY['for_uid', 'study_instance_uid', 'series_instance_uid', 'num_sops'], ARRAY['Test Case based on Soft-tissue-Sarcoma'], 'posda_files', 'Find All of the Structure Sets In Soft-tissue-Sarcoma')
        ;

            insert into queries
            values ('FirstFileForSopPosda', 'select
  root_path || ''/'' || rel_path as path,
  modality
from 
  file_location natural join file_storage_root
  natural join file_sop_common
  natural join file_series
  natural join ctp_file
where
  sop_instance_uid = ? and visibility is null
limit 1', ARRAY['sop_instance_uid'], 
                    ARRAY['path', 'modality'], ARRAY['by_series', 'UsedInPhiSeriesScan'], 'posda_files', 'First files in series in Posda
')
        ;

            insert into queries
            values ('GetAllInboxItems', 'select
  user_inbox_content_id,
  background_subprocess_report_id,
  current_status,
  date_entered
from user_inbox_content 
natural join user_inbox
where user_name = ?
order by date_entered desc
', ARRAY['user_name'], 
                    ARRAY['user_inbox_content_id', 'background_subprocess_report_id', 'current_status', 'date_entered'], '{}', 'posda_queries', 'Get a list of all messages from the user''s inbox.')
        ;

            insert into queries
            values ('GetDciodvfyWarningUnrecogTag', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''UnrecognizedTag''
  and warning_tag = ?
  and warning_comment = ?
 ', ARRAY['warning_tag', 'warning_comment'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('DupReport', 'select
  distinct collection,
  sum(num_entered) num_files,
  sum(num_dups) num_dups,
  (cast(sum(num_dups) as float)/cast((sum(num_entered) + sum(num_dups)) as float))*100.0 as
   percent_dups
from
  round_collection
group by collection
order by percent_dups desc', '{}', 
                    ARRAY['collection', 'num_files', 'num_dups', 'percent_dups'], ARRAY['Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools'], 'posda_backlog', 'Report on Percentage of duplicates by collection')
        ;

            insert into queries
            values ('InsertActivityInboxContent', 'insert into activity_inbox_content(
 activity_id, user_inbox_content_id
) values (
  ?, ?
)
', ARRAY['activity_id', 'user_inbox_content_id'], 
                    '{}', ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetPosdaSopsForCompare', 'select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name = ? 
  and visibility is null', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'file_path', 'file_id'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('DistinctSopsInCollectionSiteIntakeWithFile', 'select
  distinct i.sop_instance_uid, i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp
where
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and tdp.dp_site_name = ?
order by sop_instance_uid
', ARRAY['collection', 'site'], 
                    ARRAY['sop_instance_uid', 'dicom_file_uri'], ARRAY['by_collection', 'files', 'intake', 'sops', 'compare_collection_site'], 'intake', 'Get Distinct SOPs in Collection with number files
')
        ;

            insert into queries
            values ('DuplicateSOPInstanceUIDsByCollectionWithoutHidden1', 'select
  distinct project_name as collection,
  site_name as site, patient_id,
  study_instance_uid, series_instance_uid
from file_sop_common natural join ctp_file natural join file_patient
  natural join file_study natural join file_series
where sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
      select distinct file_id, sop_instance_uid 
      from
        ctp_file natural join file_sop_common
        natural join file_patient
    ) as foo natural join ctp_file
    group by sop_instance_uid order by count desc
  ) as foo where count > 1
) group by project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['receive_reports'], 'posda_files', 'Return a count of visible duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('UploadCountsBetweenDatesByCollection', 'select distinct 
  project_name, site_name, patient_id, 
  study_instance_uid, series_instance_uid,
  count(*)
from
  ctp_file natural join file_study
  natural join file_series
  natural join file_patient
where file_id in (
  select file_id
  from
    file_import natural join import_event
    natural join ctp_file
  where
    import_time > ? and import_time < ? 
    and project_name = ?
)
group by
  project_name, site_name, patient_id, 
  study_instance_uid, series_instance_uid
order by 
  project_name, site_name, patient_id, 
  study_instance_uid, series_instance_uid
 ', ARRAY['start_time', 'end_time', 'collection'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'count'], ARRAY['receive_reports'], 'posda_files', 'Counts of uploads received between dates for a collection
Organized by Subject, Study, Series, count of files_uploaded
')
        ;

            insert into queries
            values ('RelinquishBacklogControl', 'update control_status
set status = ''idle'',
  processor_pid =  null,
  pending_change_request = null,
  source_pending_change_request = null,
  request_time = null', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'relese control of posda_backlog')
        ;

            insert into queries
            values ('missing file_study', 'select distinct patient_id, dicom_file_type, series_instance_uid, modality, count(distinct file_id) as num_files,
  min(import_time) as earliest, max(import_time) as latest
from 
file_patient natural join dicom_file natural join file_series
natural join file_import natural join import_event
where file_id in (
select file_id from 
ctp_file where project_name =? and site_name = ? and visibility is null and not exists (select file_id from file_study where file_study.file_id = ctp_file.file_id)) group by patient_id, dicom_file_type, series_instance_uid, modality', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'dicom_file_type', 'series_instance_uid', 'modality', 'num_files', 'earliest', 'latest'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FindInconsistentSeriesByCollectionSite', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name = ? and site_name = ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series'], 'posda_files', 'Find Inconsistent Series
')
        ;

            insert into queries
            values ('GeFromToFilesFromNonDicomEditCompare', 'select 
  file_id as from_file_id, 
  foo.to_file_id 
from 
  file, 
  (
    select 
      from_file_digest, 
      file_id as to_file_id
    from 
      file,
       non_dicom_edit_compare 
    where 
      to_file_digest = digest
      and subprocess_invocation_id = ?
  ) as foo
where 
  from_file_digest = digest;', ARRAY['subprocess_invocation_id'], 
                    ARRAY['from_file_id', 'to_file_id'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('SimplePhiReportAll', 'select 
  distinct element_sig_pattern as element, vr, value, tag_name as description, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ?
group by element_sig_pattern, vr, value, description
order by vr, element, value', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'description', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('FileNameReportByImportEvent', 'select
  file_id, patient_id,
  study_instance_uid, study_date, study_description, series_instance_uid,
  modality, series_date, series_description, dicom_file_type, file_name
from
  file_import natural join file_patient natural join file_series natural join
  file_study natural join dicom_file
where
  import_event_id = ?
order by file_name', ARRAY['import_event_id'], 
                    ARRAY['file_id', 'patient_id', 'study_instance_uid', 'study_date', 'study_description', 'series_instance_uid', 'modality', 'series_date', 'series_description', 'dicom_file_type', 'file_name'], ARRAY['import_events'], 'posda_files', 'List of values seen in scan by ElementSignature with VR and count
')
        ;

            insert into queries
            values ('IncrementPhiNonDicomFilesScanned', 'update phi_non_dicom_scan_instance
set pndsi_num_files_scanned = pndsi_num_files_scanned + 1
where phi_non_dicom_scan_instance_id = ?', ARRAY['phi_non_dicom_scan_instance_id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('GetElementByPublicDisposition', 'select
  element_signature, disposition
from
  element_signature natural join public_disposition
where
  sop_class_uid = ? and name = ? and
  not is_private and disposition = ?
', ARRAY['sop_class_uid', 'name', 'disposition'], 
                    ARRAY['element_signature', 'disposition'], ARRAY['NotInteractive', 'ElementDisposition'], 'posda_phi', 'Get List of Public Elements By Disposition, Sop Class, and name')
        ;

            insert into queries
            values ('PotentialDuplicateSopSeriesByCollectionSite', 'select distinct collection, site, subj_id, study_instance_uid, series_instance_uid, 
count(distinct sop_instance_uid)
from
(select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, sop_instance_uid,
  file_id, file_path
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id, root_path ||''/'' || rel_path as file_path
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
    join file_location using(file_id) join file_storage_root using(file_storage_root_id)
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
order by sop_instance_uid
) as foo
group by collection, site, subj_id, study_instance_uid, series_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'study_instance_uid', 'series_instance_uid', 'count'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('GetQualifiedCTQPByLikeCollectionSiteWithNoFiles', 'select 
  collection, site, patient_id, qualified
from
  clinical_trial_qualified_patient_id p
where collection like ? and site = ? and qualified and
  not exists (select file_id from file_patient f where f.patient_id = p.patient_id)
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PixelTypesWithSOP', 'select
  distinct photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  coalesce(number_of_frames,1) > 1 as is_multi_frame,
  pixel_representation,
  planar_configuration,
  modality,
  dicom_file_type,
  count(*)
from
  image natural join file_image natural join file_series natural join dicom_file
group by
  photometric_interpretation,
  samples_per_pixel,
  bits_allocated,
  bits_stored,
  high_bit,
  is_multi_frame,
  pixel_representation,
  planar_configuration,
  modality,
  dicom_file_type
order by
  count desc', '{}', 
                    ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'is_multi_frame', 'pixel_representation', 'planar_configuration', 'modality', 'dicom_file_type', 'count'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('InsertInitialPatientStatus', 'insert into patient_import_status(
  patient_id, patient_import_status
) values (?, ?)
', ARRAY['patient_id', 'status'], 
                    NULL, ARRAY['Insert', 'NotInteractive', 'PatientStatus'], 'posda_files', 'Insert Initial Patient Status
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('ColumnsInTable', 'select attname as column_name
FROM pg_attribute,pg_class 
WHERE attrelid=pg_class.oid 
AND relname= ?
AND attstattarget <>0; 
', ARRAY['table_name'], 
                    ARRAY['column_name'], ARRAY['AllCollections', 'postgres_stats', 'table_size'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSiteExtMore', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  dicom_file_type,
  modality,
  count (distinct file_id) as num_files,
  min(import_time) as first_loaded,
  max(import_time) as last_loaded
from
  file_study natural join
  ctp_file natural join
  dicom_file natural join
  file_series natural join
  file_patient join
  file_import using(file_id) join
  import_event using(import_event_id)
where 
  file_id in (
    select distinct file_id
    from ctp_file
    where project_name = ? and site_name = ? and
    visibility is null
  )
group by patient_id, study_instance_uid, series_instance_uid,
  dicom_file_type, modality
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'dicom_file_type', 'modality', 'num_files', 'first_loaded', 'last_loaded'], ARRAY['Hierarchy', 'phi_simple', 'simple_phi'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('SubjectsWithDupSopsByCollectionSite', 'select
  distinct collection, site, subj_id, 
  count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops,
  min(import_time) as earliest,
  max(import_time) as latest
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    file_id, sop_instance_uid, import_time
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_import
    natural join import_event
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(*) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            project_name = ? and site_name = ?
            and visibility is null
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id
', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('NonDicomDifferenceReportByEditId', 'select
  distinct report_file_id, count(distinct to_file_path) as num_files
from non_dicom_edit_compare
where subprocess_invocation_id =?
group by report_file_id
order by report_file_id', ARRAY['subprocess_invocation_id'], 
                    ARRAY['report_file_id', 'num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration', 'non_dicom_edit'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('SeriesSentToIntakeByDate', 'select
  series_to_send as series_instance_uid,
  send_started, send_ended - send_started as duration,
  destination_host, destination_port,
  number_of_files as to_send, files_sent,
  invoking_user, reason_for_send
from (
  select
    distinct dicom_send_event_id,
    count(distinct file_path) as files_sent
  from
    dicom_send_event natural join dicom_file_send
  where
    send_started > ? and send_started < ?
  group by dicom_send_event_id
) as foo
natural join dicom_send_event
order by send_started
', ARRAY['from_date', 'to_date'], 
                    ARRAY['send_started', 'duration', 'series_instance_uid', 'destination_host', 'destination_port', 'to_send', 'files_sent', 'invoking_user', 'reason_for_send'], ARRAY['send_to_intake'], 'posda_files', 'List of Series Sent To Intake By Date
')
        ;

            insert into queries
            values ('FileIdsByActivityTimepointId', 'select
 file_id
from
  activity_timepoint_file
where
  activity_timepoint_id = ?', ARRAY['activity_timepoint_id'], 
                    ARRAY['file_id'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Get files in an activity_timepoint')
        ;

            insert into queries
            values ('GetPixelPaddingInfoByCollection', 'select
  distinct modality, pixel_pad, slope, intercept, manufacturer, 
  image_type, pixel_representation as signed, count(*)
from                                           
  file_series natural join file_equipment natural join ctp_file natural join
  file_slope_intercept natural join slope_intercept natural join file_image natural join image
where                                                 
  modality = ''CT'' and project_name = ? and visibility is null
group by 
  modality, pixel_pad, slope, intercept, manufacturer, image_type, signed
', ARRAY['collection'], 
                    ARRAY['modality', 'pixel_pad', 'slope', 'intercept', 'manufacturer', 'image_type', 'signed', 'count'], ARRAY['PixelPadding'], 'posda_files', 'Get Pixel Padding Summary Info
')
        ;

            insert into queries
            values ('AllPublicSignaturesByScanId', 'select distinct element_signature as public_signature
from
  scan_event natural join series_scan
  natural join scan_element natural join element_signature
where
  scan_event_id = ? 
  and not is_private
order by public_signature', ARRAY['scan_id'], 
                    ARRAY['public_signature'], ARRAY['tag_usage'], 'posda_phi', 'List of non-private Element Signatures seen by Scan')
        ;

            insert into queries
            values ('GetCopyFromPublicInfo', 'select
  copy_from_public_id,
  when_row_created,
  who,
  why, 
  num_file_rows_populated as num_files,
  status_of_copy,
  pid_of_running_process
from
  copy_from_public
', '{}', 
                    ARRAY['copy_from_public_id', 'when_row_created', 'who', 'why', 'num_files', 'status_of_copy', 'pid_of_running_process'], ARRAY['bills_test', 'copy_from_public', 'public_posda_consistency'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FilesInCollectionSiteForApplicationOfPrivateDisposition', 'select
  distinct file_id, root_path || ''/'' || rel_path as path, 
  patient_id, study_instance_uid, series_instance_uid,
  sop_instance_uid
from
  file_location natural join file_storage_root natural join file_patient
  natural join ctp_file natural join file_study 
  natural join file_sop_common natural join file_series
  
where
  project_name = ? and site_name = ? and visibility is null
', ARRAY['collection', 'site'], 
                    ARRAY['file_id', 'path', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid'], ARRAY['by_collection_site', 'find_files'], 'posda_files', 'Get everything you need to negotiate a presentation_context
for all files in a Collection Site
')
        ;

            insert into queries
            values ('HiddenCountsByCollectionSiteDateRangePlus', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select distinct file_id 
    from file_import natural join import_event natural join ctp_file
    where import_time > ? and import_time < ?
    and project_name = ? and site_name = ? and visibility = ''hidden'')
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['from', 'to', 'collection', 'site'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('InsertIntoPatientMappingIntBatch', 'insert into patient_mapping(
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  date_shift) values (
  ?, ?, ?, ?, ?, ?, interval ?)', ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'insert_pat_mapping'], 'posda_files', 'Make an entry into the patient_mapping table with batch and interval')
        ;

            insert into queries
            values ('NonDicomPhiReportJsonMetaQuotes', 'select 
  distinct non_dicom_file_type as type, ''<'' ||non_dicom_path || ''>'' as path,
  ''<'' || value || ''>'' as q_value, count(distinct posda_file_id) as num_files
from 
  non_dicom_path_value_occurrance natural join
  non_dicom_path_seen natural join
  value_seen natural join
  non_dicom_file_scan natural join
  phi_non_dicom_scan_instance
where 
  phi_non_dicom_scan_instance_id = ? and file_type = ''json''
group by type, path, q_value
order by type, path, q_value', ARRAY['scan_id'], 
                    ARRAY['type', 'path', 'q_value', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('HideFileWithNoCtp', 'insert into ctp_file(file_id, project_name, trial_name, site_name, visibility)
values(?, ''UNKNOWN'', ''UNKNOWN'', ''UNKNOWN'', ''hidden'')', ARRAY['file_id'], 
                    '{}', ARRAY['ImageEdit', 'NotInteractive'], 'posda_files', 'Hide a file which currently has no ctp_file row

Insert a ctp_file row with:
project_name = ''UNKNOWN''
site_name = ''UNKNOWN''
visibility = ''hidden''
')
        ;

            insert into queries
            values ('GetExistenceClassModalityUniquenessOfReferencedFile', 'select
  distinct file_id,
  project_name as collection,
  site_name as site,
  patient_id,
  dicom_file_type as sop_class,
  modality,
  sop_class_uid,
  series_instance_uid
from
  file_sop_common natural join
  dicom_file natural join
  file_series natural join
  file_patient natural join
  ctp_file 
where
  sop_instance_uid = ? and visibility is null', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'collection', 'site', 'patient_id', 'sop_class', 'modality', 'sop_class_uid', 'series_instance_uid'], ARRAY['LinkageChecks', 'used_in_dose_linkage_check', 'used_in_plan_linkage_check'], 'posda_files', 'Get Information related to uniqueness, modality, sop_class of a file reference by Sop Instance')
        ;

            insert into queries
            values ('InsertFileImport', 'insert into file_import(
  import_event_id, file_id,  file_name
) values (
  currval(''import_event_import_event_id_seq''),?, ?
)
', ARRAY['file_id', 'file_name'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_files', 'Create an import_event')
        ;

            insert into queries
            values ('ImportIntoFileSeries', 'insert into file_series
  (file_id, modality, series_instance_uid,
   series_number, laterality, series_date,
   series_time, performing_phys, protocol_name,
   series_description, operators_name, body_part_examined,
   patient_position, smallest_pixel_value, largest_pixel_value,
   performed_procedure_step_id, performed_procedure_step_start_date,
       performed_procedure_step_start_time,
   performed_procedure_step_desc, performed_procedure_step_comments)
values
  (?, ?, ?,
   ?, ?, ?,
   ?, ?, ?,
   ?, ?, ?,
   ?, ?, ?,
   ?, ?, ?,
   ?, ?)
', ARRAY['file_id', 'modality', 'series_instance_uid', 'series_number', 'laterality', 'series_date', 'series_time', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_start_time', 'performed_procedure_step_desc', 'performed_procedure_step_comments'], 
                    '{}', ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('FilesByCollectionSiteWithVisibility', 'select
  distinct
  file_id,
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  sop_instance_uid,
  file_id,
  visibility
from
  ctp_file
  join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
where 
  project_name = ?', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'visibility'], ARRAY['hide_files'], 'posda_files', 'Get List of files for Collection, Site with visibility')
        ;

            insert into queries
            values ('RoisInStructureSetByFileId', 'select file_id, roi_num, roi_name, roi_interpreted_type
from roi natural join file_structure_set where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'roi_num', 'roi_name', 'roi_interpreted_type'], ARRAY['Test Case based on Soft-tissue-Sarcoma'], 'posda_files', 'Find All of the Structure Sets In Soft-tissue-Sarcoma')
        ;

            insert into queries
            values ('PublicFileBySopInstanceUid', 'select
  dicom_file_uri as file_path
from
  general_image
where
  sop_instance_uid = ?
', ARRAY['sop_instance_uid'], 
                    ARRAY['file_path'], ARRAY['public', 'used_in_simple_phi'], 'public', 'List of all Series By Collection, Site on Intake
')
        ;

            insert into queries
            values ('PosdaTotalsWithDateRangeWithHidden', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
from (
  select
    distinct project_name, site_name, patient_id, count(*) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
  from (
    select
       distinct project_name, site_name, patient_id, study_instance_uid, 
       count(*) as num_series, sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id, study_instance_uid, 
        series_instance_uid, count(*) as num_files 
      from (
        select
          distinct project_name, site_name, patient_id, study_instance_uid,
          series_instance_uid, sop_instance_uid 
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common natural join file_patient
           natural join file_import natural join import_event
        where
          import_time >= ? and
          import_time < ? 
      ) as foo
      group by
        project_name, site_name, patient_id, 
        study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', ARRAY['start_time', 'end_time'], 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], '{}', 'posda_files', 'Get posda totals by date range
')
        ;

            insert into queries
            values ('InsertIntoCollectionCodes', 'insert into collection_codes(collection_name, collection_code)
values (?, ?)', ARRAY['collection_name', 'collection_code'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'for_scripting'], 'posda_files', 'Make an entry into the collection_codes table')
        ;

            insert into queries
            values ('MRWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''MR Image Storage'' and 
  visibility is null and
  modality != ''MR''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('GetPublicTagNameAndVrBySignature', 'select
  name,
  vr
from dicom_element
where tag = ?
', ARRAY['tag'], 
                    ARRAY['name', 'vr'], ARRAY['DispositionReport', 'NotInteractive', 'used_in_reconcile_tag_names'], 'dicom_dd', 'Get the relevant features of a private tag by signature
Used in DispositionReport.pl - not for interactive use
')
        ;

            insert into queries
            values ('FileTypeAndIsDicom', 'select file_type, is_dicom_file
from file
where file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_type', 'is_dicom_file'], ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_files', 'Get the file_type of a file, by file_id
')
        ;

            insert into queries
            values ('SimplePhiReportAllPublicOnlyMetaQuote', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, ''<'' || value || ''>'' as q_value, tag_name as description, ''k'' as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and not is_private
group by element_sig_pattern, vr, value, val_length, description
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'disp', 'q_value', 'description', 'num_series'], ARRAY['adding_ctp', 'for_scripting', 'phi_reports'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('FastCurrentPatientStatii', 'select 
  patient_id,
  patient_import_status
from 
  patient_import_status
', '{}', 
                    ARRAY['patient_id', 'patient_import_status'], ARRAY['counts', 'patient_status', 'for_bill_counts'], 'posda_files', 'Get the current status of all patients')
        ;

            insert into queries
            values ('MakePosdaFileReadyToProcess', 'update file
  set ready_to_process = true
where file_id = ?', ARRAY['file_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('WhatHasComeInRecentlyWithSubjectByCollectionLike', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
and collection like ?
group by collection, site, subj, time order by time desc, collection, site, subj', ARRAY['interval', 'from', 'to', 'collection_like'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('NumFilesInSeries', 'select count(distinct file_id) as num_files from file_series natural join ctp_file where 
series_instance_uid = ? and visibility is null', ARRAY['series_instance_uid'], 
                    ARRAY['num_files'], ARRAY['bills_test'], 'posda_files', 'Get number of files in series')
        ;

            insert into queries
            values ('ContourInfoByRoiIdAndSopInst', 'select
  contour_file_offset,
  contour_length,
  contour_digest,
  num_points,
  contour_type
from
 file_roi_image_linkage 
where
  linked_sop_instance_uid =? and roi_id = ?
', ARRAY['linked_sop_instance_uid', 'roi_id'], 
                    ARRAY['contour_file_offset', 'contour_length', 'contour_digest', 'num_points', 'contour_type'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewedInSeriesBad', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  file_patient natural join
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  series_instance_uid = ?
  and visibility is null and 
  review_status != ''Good'' and
  review_status != ''PassThrough''
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('ListOfQueriesPerformed', 'select
  query_invoked_by_dbif_id as id,
  query_name,
  query_end_time - query_start_time as duration,
  invoking_user as invoked_by,
  query_start_time as at, 
  number_of_rows
from
  query_invoked_by_dbif
', '{}', 
                    ARRAY['id', 'query_name', 'duration', 'invoked_by', 'at', 'number_of_rows'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('DifferenceReportByEditId', 'select
  distinct short_report_file_id, long_report_file_id, count(distinct to_file_path) as num_files
from dicom_edit_compare
where subprocess_invocation_id =?
group by short_report_file_id, long_report_file_id order by short_report_file_id', ARRAY['subprocess_invocation_id'], 
                    ARRAY['short_report_file_id', 'long_report_file_id', 'num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('GetListCollectionsWithNoDefinedCounts', 'select distinct collection
from submitter s
where collection not in (
  select collection from collection_count_per_round c
  where s.collection = c.collection
)
', '{}', 
                    ARRAY['collection'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Get a list of all collections in backlog with no defined counts')
        ;

            insert into queries
            values ('FindNumUnpopulatedPets', 'select
  count(distinct file_id) as num_unimported_pets
from file_location natural join file_storage_root
where file_id in
(
  select distinct file_id from dicom_file df
  where dicom_file_type = ''Positron Emission Tomography Image Storage''
  and not exists (select file_id from file_pt_image pti where pti.file_id = df.file_id)
)', '{}', 
                    ARRAY['num_unimported_pets'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('GetDicomEditCompareFromFiles', 'select 
  file_id,
  project_name,
  visibility
from 
  file natural left join ctp_file
where
  file_id in (
    select file_id from file f, dicom_edit_compare dec
    where f.digest = dec.from_file_digest and subprocess_invocation_id = ?
  )', ARRAY['subprocess_invocation_id'], 
                    ARRAY['file_id', 'project_name', 'visibility'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Get a list of from files from the dicom_edit_compare table for a particular edit instance, with visibility

NB: project_name will be null if there is no ctp_file row (so to hide the file you need to create a row with
       project_name = ''UNKNOWN'', site_name = ''UNKNOWN'' and visibility = ''hidden'' (if you want to hide the file)')
        ;

            insert into queries
            values ('UpdateCountsDb', 'insert into totals_by_collection_site(
  count_report_id,
  collection_name, site_name,
  num_subjects, num_studies, num_series, num_sops
) values (
  currval(''count_report_count_report_id_seq''),
  ?, ?,
  ?, ?, ?, ?
)
', ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'num_files'], 
                    NULL, ARRAY['intake', 'posda_counts'], 'posda_counts', '')
        ;

            insert into queries
            values ('GetEditStatusByEditId', 'select
  subprocess_invocation_id as id,
  start_creation_time, end_creation_time - start_creation_time as duration,
  number_edits_scheduled as to_edit,
  number_compares_with_diffs as changed,
  number_compares_without_diffs as not_changed,
  current_disposition as disposition,
  dest_dir
from
  dicom_edit_compare_disposition
where
  subprocess_invocation_id = ?
order by start_creation_time desc', ARRAY['edit_id'], 
                    ARRAY['id', 'start_creation_time', 'duration', 'to_edit', 'changed', 'not_changed', 'disposition', 'dest_dir'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits', 'edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('FilesByScanValueLikeTag', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, value, sequence_level,
  item_number
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  scan_event_id = ? and value like ? and element_signature = ?
order by series_instance_uid, file
', ARRAY['scan_id', 'value', 'tag'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'value', 'sequence_level', 'item_number'], ARRAY['tag_usage', 'phi_review'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('FilesByTagWithValue', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, value
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  element_signature = ?
order by series_instance_uid, file, value
', ARRAY['tag'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'value'], ARRAY['tag_usage'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('RawFilesByDateRange', 'select 
  file_type, max(file_id) as max_file_id, min(file_id) as min_file_id, 
  count(*) as num_files, max(size) as largest, min(size) as smallest,
  sum(size) as total_size, avg(size) as avg_size
from file
where file_id in (
  select
    file_id from (
      select
        distinct file_id, date_trunc(?, min(import_time)) as load_week
      from
        file_import natural join import_event
      group by file_id
  ) as foo
  where
    load_week >=? and load_week <  ?
) 
group by file_type', ARRAY['date_type', 'from', 'to'], 
                    ARRAY['file_type', 'max_file_id', 'min_file_id', 'num_files', 'largest', 'smallest', 'total_size', 'avg_size'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('ListOfFirstNFilesByImportEventId', 'select
  file_id, root_path || ''/'' || rel_path as path
from
  file_storage_root natural join file_location
where file_id in (
  select file_id from file_import where import_event_id = ?
  limit ?
)', ARRAY['import_event_id', 'limit'], 
                    ARRAY['file_id', 'path'], ARRAY['import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AddNewDataToRoiTable', 'update roi set
  max_x = ?,
  max_y = ?,
  max_z = ?,
  min_x = ?,
  min_y = ?,
  min_z = ?,
  roi_interpreted_type = ?,
  roi_obser_desc = ?,
  roi_obser_label = ?
where
  roi_id = ?', ARRAY['max_x', 'max_y', 'max_z', 'min_x', 'min_y', 'min_z', 'roi_interpreted_type', 'roi_obser_desc', 'roi_obser_label', 'roi_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_processing_structure_set_linkages'], 'posda_files', 'Get the file_storage root for newly created files')
        ;

            insert into queries
            values ('FindInconsistentSeriesIgnoringTime', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name = ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series', 'series_consistency'], 'posda_files', 'Find Inconsistent Series
')
        ;

            insert into queries
            values ('AgesStudyDatesSeriesByCollection', 'select
  distinct patient_id, study_date, patient_age, series_instance_uid, modality
from
  file_patient natural join file_series natural join file_study natural join ctp_file
where
  project_name = ? and visibility is null

', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_date', 'patient_age', 'series_instance_uid', 'modality'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('UpdateNonDicomFileTypeSubTypeCollectionSiteSubjectById', 'update non_dicom_file set
  file_type = ?,
  file_sub_type = ?,
  collection = ?,
  site = ?,
  subject = ?
where file_id = ?', ARRAY['file_type', 'file_sub_type', 'collection', 'site', 'subject', 'file_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Get stuff from non_dicom_file by id
')
        ;

            insert into queries
            values ('WhereSopSits', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  ctp_file
where file_id in (
  select
    distinct file_id
  from
    file_sop_common natural join ctp_file
  where
    sop_instance_uid = ? and visibility is null
)
', ARRAY['sop_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['posda_files', 'sops', 'BySopInstance'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('SimplePhiScanStatusInProcess', 'select
  phi_scan_instance_id as id,
  start_time,
  now() - start_time as duration,
  description,
  num_series as to_scan,
  num_series_scanned as scanned,
  (((now() - start_time) / num_series_scanned) * (num_series -
  num_series_scanned)) + now() as projected_completion,
  (cast(num_series_scanned as float) / 
    cast(num_series as float)) * 100.0 as percentage,
  file_query
from
  phi_scan_instance
where
   num_series > num_series_scanned
   and num_series_scanned > 0
order by id
', '{}', 
                    ARRAY['id', 'description', 'start_time', 'duration', 'to_scan', 'scanned', 'percentage', 'projected_completion', 'file_query'], ARRAY['tag_usage', 'simple_phi', 'phi_status', 'scan_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('InsertIntoPatientMappingIntNoBatch', 'insert into patient_mapping(
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  date_shift) values (
  ?, ?, ?, ?, ?, interval ?)', ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'date_shift'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'insert_pat_mapping'], 'posda_files', 'Make an entry into the patient_mapping table with no batch and interval')
        ;

            insert into queries
            values ('DupSopsReceivedBetweenDatesByCollection', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   sum(num_files) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
             natural join ctp_file
          where import_time > ? and import_time < ?
            and project_name = ? and visibility is null
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
where num_uploads > 1
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time', 'collection'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'num_files', 'num_uploads', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates with duplicate sops
')
        ;

            insert into queries
            values ('GetFileIdVisibilityByPatientId', 'select distinct file_id, visibility
from file_patient natural left join ctp_file
where patient_id = ?', ARRAY['patient_id'], 
                    ARRAY['file_id', 'visibility'], ARRAY['ImageEdit', 'edit_files'], 'posda_files', 'Get File id and visibility for all files in a series')
        ;

            insert into queries
            values ('GetFromFileIdGivenToFileId', 'select file_id as from_file_id from file where digest = (
select from_file_digest as digest from dicom_edit_compare where to_file_digest = (select digest as to_file_digest from file where file_id = ?))', ARRAY['to_file_id'], 
                    ARRAY['from_file_id'], ARRAY['edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('UpdateNonDicomFileById', 'update non_dicom_file set
  file_type = ?, 
  file_sub_type = ?, 
  collection = ?,
  site = ?,
  subject = ?,
  visibility = ?,
  date_last_categorized = now()
where 
  file_id = ?', ARRAY['file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'file_id'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSimplePhiScanId', 'select currval(''phi_scan_instance_phi_scan_instance_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Create a new Simple PHI scan')
        ;

            insert into queries
            values ('DistinctSopsInCollectionSitePublicWithFile', 'select
  distinct i.sop_instance_uid, i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp
where
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and tdp.dp_site_name = ?
order by sop_instance_uid
', ARRAY['collection', 'site'], 
                    ARRAY['sop_instance_uid', 'dicom_file_uri'], ARRAY['by_collection', 'files', 'intake', 'sops', 'compare_collection_site'], 'public', 'Get Distinct SOPs in Collection with number files
')
        ;

            insert into queries
            values ('HowManyFilesHiddenInCopyFromPublic', 'select
  count(*) as num_hidden
from file_copy_from_public c, ctp_file p
where
  c.copy_from_public_id = ? and
  (p.file_id = c.replace_file_id and p.visibility is not null) ', ARRAY['copy_from_public_id'], 
                    ARRAY['num_hidden'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('QueriesRunning', 'select 
  datname, pid,
  now() - backend_start as time_backend_running,
  now() - query_start as time_query_running, 
  now() - state_change as time_since_state_change,
  state
from pg_stat_activity
  order by datname, state', '{}', 
                    ARRAY['datname', 'pid', 'time_backend_running', 'time_query_running', 'time_since_state_change', 'state'], ARRAY['AllCollections', 'postgres_stats', 'postgres_query_stats'], 'posda_backlog', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('FindQueryNameMatching', 'select
  distinct name
from
  queries
where
  name ~ ?
order by name', ARRAY['name_matching'], 
                    ARRAY['name'], ARRAY['meta', 'test', 'hello'], 'posda_queries', 'Find all queries with name matching arg')
        ;

            insert into queries
            values ('FromFilesVisibilitySummaryByEditId', 'select
  distinct visibility, count(distinct file_id) as num_files
from ctp_file
where 
  file_id in (
    select distinct file_id from file f, dicom_edit_compare dec
     where f.digest = dec.from_file_digest and 
        subprocess_invocation_id = ?
  )
group by visibility', ARRAY['subprocess_invocation_id'], 
                    ARRAY['visibility', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('GetFilesAndSopsByStudy', 'select 
  distinct patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  file_id, 
  root_path || ''/'' || rel_path as path
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  file_location natural join
  file_storage_root natural left join
  ctp_file
where 
  study_instance_uid = ? and
  visibility is null', ARRAY['study_instance_uid'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'path'], ARRAY['ImageEdit', 'edit_files'], 'posda_files', 'Get File id and visibility for all files in a series')
        ;

            insert into queries
            values ('GetVisibleFilePathPosdaBySopInst', 'select
  root_path || ''/'' || rel_path as path
from
  file_location natural join file_storage_root
where
  file_id in (
    select file_id from file_sop_common natural join ctp_file
    where sop_instance_uid = ? and visibility is null
)', ARRAY['sop_instance_uid'], 
                    ARRAY['path'], ARRAY['posda_files', 'sops', 'BySopInstance'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('GetDciodvfyWarningUncat', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''Uncategorized''
  and warning_text = ?', ARRAY['warning_text'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('GetDupContourCounts', 'select 
  distinct file_id, count(*) as num_dup_contours
from
  file_roi_image_linkage 
where 
  contour_digest in (
  select contour_digest
  from (
    select 
      distinct contour_digest, count(*)
    from
      file_roi_image_linkage group by contour_digest
  ) as foo
  where count > 1
) group by file_id order by num_dup_contours desc', '{}', 
                    ARRAY['file_id', 'num_dup_contours'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dup_contours'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('StudyHierarchyByStudyUID', 'select distinct
  study_instance_uid, study_description,
  series_instance_uid, series_description,
  modality,
  count(distinct sop_instance_uid) as number_of_sops
from
  file_study natural join ctp_file natural join file_series natural join file_sop_common
where study_instance_uid = ? and visibility is null
group by
  study_instance_uid, study_description,
  series_instance_uid, series_description, modality', ARRAY['study_instance_uid'], 
                    ARRAY['study_instance_uid', 'study_description', 'series_instance_uid', 'series_description', 'modality', 'number_of_sops'], ARRAY['by_study', 'Hierarchy'], 'posda_files', 'Show List of Study Descriptions, Series UID, Series Descriptions, and Count of SOPS for a given Study Instance UID')
        ;

            insert into queries
            values ('PrivateTagCountReport', 'select 
  distinct element_signature, vr, count(*) as times_seen,
  count(distinct value) as num_distinct_values 
from
  element_signature natural join scan_element natural join seen_value
where
  is_private
group by element_signature, vr
order by element_signature, vr, times_seen, num_distinct_values;
', '{}', 
                    ARRAY['element_signature', 'vr', 'times_seen', 'num_distinct_values'], ARRAY['postgres_status', 'PrivateTagKb'], 'posda_phi', 'Get List of all Private Tags ever scanned with occurance and distinct value counts')
        ;

            insert into queries
            values ('GetAttachmentFiles', 'select 
  fl.file_id,
  root_path || ''/'' || rel_path as path,
  ndf.file_type as ext
from
  non_dicom_file ndf,
  file_location as fl natural join file_storage_root,
  non_dicom_attachments a
where
  a.non_dicom_file_id = ndf.file_id and 
  a.non_dicom_file_id = fl.file_id and
  ndf.collection = ?', ARRAY['collection'], 
                    ARRAY['file_id', 'path', 'ext'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSsByCollectionSite', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id
from
  ctp_file natural join file_patient
where file_id in (
 select distinct file_id from file_structure_set
)
and project_name = ? and site_name = ? and visibility is null
order by collection, site, patient_id, file_id
', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetDciodvfyWarningDubious', 'select
  dciodvfy_warning_id as id
from 
  dciodvfy_warning
where
  warning_type = ''DubiousValue''
  and warning_tag = ?
  and warning_desc = ?
  and warning_value = ?
  and warning_reason = ?', ARRAY['warning_tag', 'warning_desc', 'warning_value', 'warning_reason'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_warnings row by warning_text (if present)')
        ;

            insert into queries
            values ('GetDciodvfyWarningId', 'select currval(''dciodvfy_warning_dciodvfy_warning_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get id of recently created dciodvfy_warnings row')
        ;

            insert into queries
            values ('AllProcessedManifests', 'select
  distinct file_id, cm_collection, cm_site, cm_patient_id, sum(cm_num_files) as total_files
from
  ctp_manifest_row
group by file_id, cm_collection, cm_site, cm_patient_id', '{}', 
                    ARRAY['file_id', 'cm_collection', 'cm_site', 'cm_patient_id', 'total_files'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('DiskSpaceByCollectionSiteSummary', 'select
  distinct project_name as collection, site_name as site, sum(size) as total_bytes
from
  ctp_file natural join file
where
  file_id in (
  select distinct file_id
  from ctp_file
  )
group by project_name, site_name
order by total_bytes
', '{}', 
                    ARRAY['collection', 'site', 'total_bytes'], ARRAY['by_collection', 'posda_files', 'storage_used', 'summary'], 'posda_files', 'Get disk space used for all collections, sites
')
        ;

            insert into queries
            values ('GetDciodvfyErrorAttrSpec', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''AttributeSpecificError''
  and error_tag = ?
  and error_subtype= ?', ARRAY['error_tag', 'error_subtype'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_errors row where subtype = AttributeSpecificError')
        ;

            insert into queries
            values ('GetFileIdByDigest', 'select file_id from file where digest = ?', ARRAY['digest'], 
                    ARRAY['file_id'], ARRAY['import_events', 'QIN-GBM-DSC-MRI-DRO/Barrow'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('AllProcessedManifestsByCollectionLikeWithPatientAndQualAndDate', 'select
  distinct file_id, import_time as date, cm_collection, collection, cm_site, site, cm_patient_id, qualified,
  sum(cm_num_files) as total_files
from
  ctp_manifest_row m natural join file_import natural join import_event, clinical_trial_qualified_patient_id c
where
  cm_collection like ? and m.cm_patient_id = c.patient_id
group by file_id, date, cm_collection, collection, cm_site, site, cm_patient_id, qualified
order by date', ARRAY['collection_like'], 
                    ARRAY['file_id', 'date', 'cm_collection', 'collection', 'cm_site', 'site', 'cm_patient_id', 'qualified', 'total_files'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PopulatePixelInfoInDicomFile', 'update dicom_file set
  has_pixel_data = true,
  pixel_data_digest = ?,
  pixel_data_offset = ?,
  pixel_data_length = ?
where file_id = ?', ARRAY['pixel_data_digest', 'pixel_data_offset', 'pixel_data_length', 'file_id'], 
                    '{}', ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'see name')
        ;

            insert into queries
            values ('GetDocxToConvert', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
 collection = ? and file_type = ''docx'' and visibility is null', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetImportEventId', 'select  currval(''import_event_import_event_id_seq'') as id
', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'Backlog', 'used_in_file_import_into_posda'], 'posda_files', 'Get posda file id of created import_event row')
        ;

            insert into queries
            values ('KnownBlankImagesInSeries', 'select distinct pixel_digest, count(*) as num_files from (
  select file_id, digest as pixel_digest
  from
    file_image join image using (image_id) join unique_pixel_data using (unique_pixel_data_id)
  where file_id in (select file_id from file_series natural join ctp_file where series_instance_uid = ?)
)
as foo group by pixel_digest', ARRAY['series_instance_uid'], 
                    ARRAY['pixel_digest', 'num_files'], ARRAY['by_series'], 'posda_files', 'List of SOPs, files, and import times in a series
')
        ;

            insert into queries
            values ('InsertIntoPatientMappingNew', 'insert into patient_mapping(
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  date_shift,
  diagnosis_date, baseline_date, uid_root) values (
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift', 'diagnosis_date', 'baseline_date', 'uid_root'], 
                    '{}', ARRAY['adding_ctp', 'mapping_tables', 'insert_pat_mapping', 'non_dicom_edit'], 'posda_files', 'Make an entry into the patient_mapping table with no batch and interval')
        ;

            insert into queries
            values ('GetNonDicomFiles', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
  visibility is null
', '{}', 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FindingCtFilesWithImageProblem', 'select distinct file_id, root_path || ''/'' || rel_path as path
from (
  select file_id, image_id 
  from file natural left join file_image
  where file_id in (
    select
       distinct file_id from file_import natural join import_event
       natural join ctp_file natural join file_series
    where import_time > ''2018-09-17'' and visibility is null and
      project_name = ''Exceptional-Responders'' and modality = ''CT''
  )
) as foo natural join file_location natural join file_storage_root
where image_id is null
', '{}', 
                    ARRAY['file_id', 'path'], ARRAY['Exceptional-Responders_NCI_Oct2018_curation'], 'posda_files', 'Find files which have unique_pixel_data_id but no image_id, then find out where the hell they came from')
        ;

            insert into queries
            values ('GetValueForTagAllScans', 'select
  distinct element_signature as tag, value
from
  scan_element natural join series_scan natural join
  seen_value natural join element_signature
where element_signature = ?
order by value', ARRAY['tag'], 
                    ARRAY['tag', 'value'], ARRAY['tag_values'], 'posda_phi', 'Find Values for a given tag for all scanned series in a phi scan instance
')
        ;

            insert into queries
            values ('GetPosdaFileStorageRoots', 'select
 file_storage_root_id as id, root_path as root, current, storage_class
from
  file_storage_root
', '{}', 
                    ARRAY['id', 'root', 'current', 'storage_class'], ARRAY['NotInteractive', 'Backlog'], 'posda_files', 'Get Posda File Storage Roots')
        ;

            insert into queries
            values ('CreateEquivalenceClassNew', 'insert into image_equivalence_class(
  series_instance_uid,
  equivalence_class_number,
  visual_review_instance_id,
  processing_status
) values (
  ?, ?, ?, ''Preparing''
)
', ARRAY['series_instance_uid', 'equivalence_class_number', 'visual_review_instance_id'], 
                    '{}', ARRAY['consistency', 'find_series', 'equivalence_classes', 'NotInteractive'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('FilesByScanWithValue', 'select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, value
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  scan_event_id = ? and element_signature = ?
order by series_instance_uid, file, value
', ARRAY['scan_id', 'tag'], 
                    ARRAY['series_instance_uid', 'file', 'element_signature', 'value'], ARRAY['tag_usage'], 'posda_phi', 'Find out where specific value, tag combinations occur in a scan
')
        ;

            insert into queries
            values ('AbreviatedCountsByCollectionLike', 'select
  distinct
    project_name as collection, site_name as site,
    patient_id, 
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
  ) and project_name like ? and visibility is null
group by
  collection, site, patient_id
order by
  collection, site, patient_id
', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection like pattern
')
        ;

            insert into queries
            values ('GetElementByPrivateDispositionSimple', 'select
  element_sig_pattern as element_signature, private_disposition as disposition
from
  element_seen
where
  is_private and private_disposition = ?
', ARRAY['private_disposition'], 
                    ARRAY['element_signature', 'disposition'], ARRAY['NotInteractive', 'ElementDisposition'], 'posda_phi_simple', 'Get List of Private Elements By Disposition')
        ;

            insert into queries
            values ('GetSubmissionFormsToConvert', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
 collection = ? and file_type = ''docx'' and file_sub_type = ''radcomp data submittal form'' and visibility is null', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSeriesSignature', 'select distinct
  dicom_file_type, modality|| '':'' || coalesce(manufacturer, ''<undef>'') || '':'' 
  || coalesce(manuf_model_name, ''<undef>'') ||
  '':'' || coalesce(software_versions, ''<undef>'') as signature,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from
  file_series natural join file_equipment natural join ctp_file
  natural join dicom_file
where project_name = ?
group by dicom_file_type, signature
', ARRAY['collection'], 
                    ARRAY['dicom_file_type', 'signature', 'num_series', 'num_files'], ARRAY['signature'], 'posda_files', 'Get a list of Series Signatures by Collection
')
        ;

            insert into queries
            values ('RoundInfoLastCompleteRound', 'select
  round_id, collection,
  round_created,
  round_start,  
  round_end,
  round_aborted,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where round_id in (
  select max(round_id) as round_id from round where round_end is not null
)
order by round_id, collection', '{}', 
                    ARRAY['round_id', 'collection', 'round_created', 'round_start', 'round_end', 'round_aborted', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of round by id')
        ;

            insert into queries
            values ('StructVolByFileId', 'select
  distinct sop_instance,
  sop_class,
  study_instance_uid,
  series_instance_uid,
  for_uid
from
  file_structure_set natural join
  ss_for natural join
  ss_volume
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['sop_instance', 'sop_class', 'study_instance_uid', 'series_instance_uid', 'for_uid'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('ActivityStuffMoreWithEmailByUser', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where invoking_user = ? and background_subprocess_report.name = ''Email''
order by subprocess_invocation_id desc
', ARRAY['user'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('FilesByCollectionSitePatientVisibility', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id, visibility
from
  ctp_file natural join file_patient
where
  project_name = ? and
  site_name = ? and
  patient_id = ? and visibility = ?
order by collection, site, patient_id

', ARRAY['collection', 'site', 'patient_id', 'visibility'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'visibility'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('ListOfQueriesPerformedByDate', 'select
  query_invoked_by_dbif_id as id,
  query_name,
  query_end_time - query_start_time as duration,
  invoking_user as invoked_by,
  query_start_time as at, 
  number_of_rows
from
  query_invoked_by_dbif
where query_start_time > ? and query_end_time < ?
', ARRAY['from', 'to'], 
                    ARRAY['id', 'query_name', 'duration', 'invoked_by', 'at', 'number_of_rows'], ARRAY['AllCollections', 'q_stats_by_date'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetScanEventEventId', 'select currval(''scan_event_scan_event_id_seq'') as id
', '{}', 
                    ARRAY['num_series_scanned', 'id'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Get current value of scan_event_id')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSite', 'select distinct series_instance_uid, dicom_file_type, modality, count(distinct file_id)
from
  file_series natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null
group by series_instance_uid, dicom_file_type, modality
', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetSimpleValueSeenId', 'select currval(''value_seen_value_seen_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Get index of newly created value_seen')
        ;

            insert into queries
            values ('ToFileWithVisibilityBySopFromDicomEditCompare', 'select 
  sop_instance_uid,
  file_id as to_file_id,
  visibility as to_file_visibility
from
  ctp_file natural join file natural join file_sop_common,
  dicom_edit_compare
where
  to_file_digest = file.digest and
  subprocess_invocation_id = ?
order by sop_instance_uid', ARRAY['subprocess_invocation_id'], 
                    ARRAY['sop_instance_uid', 'to_file_id', 'to_file_visibility'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ReviewEditsBySite', 'select
  distinct project_name,
  site_name,
  series_instance_uid, 
  new_visibility, 
  reason_for,
  min(time_of_change) as earliest,
  max(time_of_change) as latest,
  count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join
  file_series
where 
  site_name = ?
group by 
  project_name, site_name, series_instance_uid, new_visibility, reason_for', ARRAY['site'], 
                    ARRAY['project_name', 'site_name', 'series_instance_uid', 'new_visibility', 'reason_for', 'earliest', 'latest', 'num_files'], ARRAY['Hierarchy', 'review_visibility_changes'], 'posda_files', 'Show all file visibility changes by series for site')
        ;

            insert into queries
            values ('ImportEventsWithType', 'select
  distinct import_event_id, import_time,  import_type, count(distinct file_id) as num_files
from
  import_event natural join file_import
where
  import_type = ''multi file import'' and 
  import_time > ? and import_time < ?
group by import_event_id, import_time, import_type', ARRAY['from', 'to'], 
                    ARRAY['import_event_id', 'import_time', 'import_type', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('RoundStatsWithCollectionSiteForDateRange', 'select
  distinct collection, site, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
group by collection, site, time order by time desc, collection, site', ARRAY['interval', 'from', 'to'], 
                    ARRAY['collection', 'site', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('SeriesSendEventsByReason', 'select
  series_to_send as series_instance_uid,
  send_started, send_ended - send_started as duration,
  destination_host, destination_port,
  number_of_files as to_send, files_sent,
  invoking_user, reason_for_send
from (
  select
    distinct dicom_send_event_id,
    count(distinct file_path) as files_sent
  from
    dicom_send_event natural join dicom_file_send
  where
    reason_for_send = ?
  group by dicom_send_event_id
) as foo
natural join dicom_send_event
order by send_started
', ARRAY['reason'], 
                    ARRAY['series_instance_uid', 'send_started', 'duration', 'destination_host', 'destination_port', 'to_send', 'files_sent', 'invoking_user', 'reason_for_send'], ARRAY['send_to_intake'], 'posda_files', 'List of Send Events By Reason
')
        ;

            insert into queries
            values ('SlopeInterceptByPixelType', 'select 
  distinct slope, intercept, count(*)
from (select
    distinct photometric_interpretation,
    samples_per_pixel,
    bits_allocated,
    bits_stored,
    high_bit,
    coalesce(number_of_frames,1) > 1 as is_multi_frame,
    pixel_representation,
    planar_configuration,
    modality,
    file_id
  from
    image natural join file_image natural join file_series
  ) as foo natural join file_slope_intercept natural join slope_intercept
where
  photometric_interpretation = ? and
  samples_per_pixel = ? and
  bits_allocated = ? and
  bits_stored = ? and
  high_bit = ? and
  pixel_representation = ? and
  modality = ?
group by slope, intercept
', ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'modality'], 
                    ARRAY['slope', 'intercept', 'count'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('AddPatientAge', 'update file_patient set
  patient_age = ?
where file_id = ?', ARRAY['age', 'file_id'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CreateSubprocessInvocationSpreadsheet', 'insert into subprocess_invocation(
 from_spreadsheet, from_button,
 spreadsheet_uploaded_id, command_line, invoking_user, when_invoked
) values (
  true, false, ?, ?, ?, now()
)', ARRAY['spreadsheet_uploaded_id', 'command_line', 'invoking_user'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create a row in subprocess_invocation table

Used when invoking a spreadsheet operation from a spreadsheet')
        ;

            insert into queries
            values ('CreateDciodvfyWarning', 'insert into dciodvfy_warning(
  warning_type,
  warning_tag,
  warning_desc,
  warning_iod,
  warning_comment,
  warning_value,
  warning_reason,
  warning_index,
  warning_text
) values (
  ?, ?, ?, ?,
  ?, ?, ?, ?,
  ?
)', ARRAY['warning_type', 'warning_tag', 'warning_desc', 'warning_iod', 'warning_comment', 'warning_value', 'warning_reason', 'warning_index', 'warning_text'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_warnings row')
        ;

            insert into queries
            values ('GetQueryArgs', 'select args from queries where name = ?', ARRAY['name'], 
                    ARRAY['args'], ARRAY['bills_test', 'posda_db_populate'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSeriesListByDciodvyScanInstance', 'select distinct(unit_uid) as series_instance_uid from dciodvfy_unit_scan natural join dciodvfy_unit_scan_warning  where dciodvfy_scan_instance_id = ? union 
select distinct(unit_uid) as series_instance_uid from dciodvfy_unit_scan natural join dciodvfy_unit_scan_error  where dciodvfy_scan_instance_id = ?
', ARRAY['dciodvfy_scan_instance_id', 'repeat_scan_instance_id'], 
                    ARRAY['series_instance_uid'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Show all the dciodvfy scans')
        ;

            insert into queries
            values ('GetCtInfoBySeries', 'select 
  distinct 
  kvp,
  scan_options,
  data_collection_diameter,
  reconstruction_diameter,
  dist_source_to_detect,
  dist_source_to_pat,
  gantry_tilt,
  rotation_dir,
  exposure_time,
  filter_type,
  generator_power, 
  convolution_kernal,
  table_feed_per_rot
from file_ct_image natural join file_patient natural join file_series natural join ctp_file 
where series_instance_uid = ? and visibility is null
', ARRAY['series_instance_uid'], 
                    ARRAY['kvp', 'scan_options', 'data_collection_diameter', 'reconstruction_diameter', 'dist_source_to_detect', 'dist_source_to_pat', 'gantry_tilt', 'rotation_dir', 'exposure_time', 'filter_type', 'generator_power', 'convolution_kernal', 'table_feed_per_rot'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('SubprocessesByUser', 'select
  distinct subprocess_invocation_id, 
  when_script_started, when_background_entered, when_script_ended, user_to_notify, 
  button_name, operation_name, count(distinct background_subprocess_report_id) as num_reports 
from
  subprocess_invocation natural left join background_subprocess natural left join
  background_subprocess_report
where invoking_user = ?
group by
  subprocess_invocation_id, when_script_started, when_background_entered,
  when_script_ended, user_to_notify, button_name, operation_name
order by subprocess_invocation_id desc', ARRAY['invoking_user'], 
                    ARRAY['subprocess_invocation_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'user_to_notify', 'button_name', 'operation_name', 'num_reports'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('UpdateSeriesScanned', 'update scan_event
set num_series_scanned = ?
where scan_event_id = ?', ARRAY['num_series_scanned', 'scan_event_id'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Update Series Scanned in scan event
')
        ;

            insert into queries
            values ('ListOfDciodvfyWarningsWithCounts', 'select distinct warning_type, warning_tag, warning_desc, warning_iod, warning_comment, warning_value, warning_reason, warning_index, count(distinct dciodvfy_unit_scan_id)  as num_scan_units from dciodvfy_warning
natural join dciodvfy_unit_scan_error group by 
warning_type, warning_tag, warning_desc, warning_iod, warning_comment, warning_value, warning_reason, warning_index
order by warning_type, warning_tag, warning_desc, warning_iod, warning_comment, warning_value, warning_reason, warning_index', '{}', 
                    ARRAY['warning_type', 'warning_tag', 'warning_desc', 'warning_iod', 'warning_comment', 'warning_value', 'warning_reason', 'warning_index', 'num_scan_units'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'All dciodvfy warnings in DB')
        ;

            insert into queries
            values ('GetPatientIdsByDateRangeLikeCollection', 'select 
  distinct patient_id, import_type
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) 
  join file_import using(file_id)
  join import_event using(import_event_id)
where 
  collection like ? and import_time > ? and import_time < ? and import_type not like ''script%''', ARRAY['collection_like', 'from', 'to'], 
                    ARRAY['patient_id', 'import_type'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('VisibilityChangesBySeries', 'select
  distinct project_name as collection, 
  site_name as site, patient_id,
  user_name, prior_visibility, new_visibility,
  date_trunc(''hour'',time_of_change) as time, 
  reason_for, series_instance_uid, count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join 
  file_patient natural join 
  file_series
where
  project_name = ? and site_name = ? and
  series_instance_uid = ?
group by 
  collection, site, patient_id, user_name, prior_visibility, new_visibility,
  time, reason_for, series_instance_uid
order by time, collection, site, patient_id, series_instance_uid
', ARRAY['collection', 'site', 'series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'user_name', 'prior_visibility', 'new_visibility', 'time', 'reason_for', 'series_instance_uid', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionLikePublic', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project like ?
group by series_instance_uid, modality', ARRAY['collection_like'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'public'], 'public', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('FilesByModalityByCollectionSite', 'select
  distinct patient_id, modality, series_instance_uid, sop_instance_uid, root_path || ''/'' || rel_path as path
from
  file_patient natural join file_series natural join file_sop_common natural join ctp_file
  natural join file_location natural join file_storage_root
where
  modality = ? and
  project_name = ? and 
  site_name = ? and
  visibility is null', ARRAY['modality', 'project_name', 'site_name'], 
                    ARRAY['patient_id', 'modality', 'series_instance_uid', 'sop_instance_uid', 'path'], ARRAY['FindSubjects', 'intake', 'FindFiles'], 'posda_files', 'Find All Files with given modality in Collection, Site')
        ;

            insert into queries
            values ('PrivsteTagsDispositionsAndValuesByScanId', 'select 
  distinct element_seen_id, element_sig_pattern, tag_name, private_disposition, value
from
  element_value_occurance natural join element_seen natural join value_seen 
where
  phi_scan_instance_id = ? and element_sig_pattern like ''%"%''
order by element_sig_pattern;
', ARRAY['phi_scan_instance_id'], 
                    ARRAY['element_seen_id', 'element_sig_pattern', 'tag_name', 'private_disposition', 'value'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('PopulateFilePtImageRow', 'insert into file_pt_image(
  file_id,
  pti_trigger_time,
  pti_frame_time,
  pti_intervals_acquired,
  pti_intervals_rejected,
  pti_reconstruction_diameter,
  pti_gantry_detector_tilt,
  pti_table_height,
  pti_fov_shape,
  pti_fov_dimensions,
  pti_collimator_type,
  pti_convoution_kernal,
  pti_actual_frame_duration,
  pti_energy_range_lower_limit,
  pti_energy_range_upper_limit,
  pti_radiopharmaceutical,
  pti_radiopharmaceutical_volume,
  pti_radiopharmaceutical_start_time,
  pti_radiopharmaceutical_stop_time,
  pti_radionuclide_total_dose,
  pti_radionuclide_half_life,
  pti_radionuclide_positron_fraction,
  pti_number_of_slices,
  pti_number_of_time_slices,
  pti_type_of_detector_motion,
  pti_image_id,
  pti_series_type,
  pti_units,
  pti_counts_source,
  pti_reprojection_method,
  pti_randoms_correction_method,
  pti_attenuation_correction_method,
  pti_decay_correction,
  pti_reconstruction_method,
  pti_detector_lines_of_response_used,
  pti_scatter_correction_method,
  pti_axial_mash,
  pti_transverse_mash,
  pti_coincidence_window_width,
  pti_secondary_counts_type,
  pti_frame_reference_time,
  pti_primary_counts_accumulated,
  pti_secondary_counts_accumulated,
  pti_slice_sensitivity_factor,
  pti_decay_factor,
  pti_dose_calibration_factor,
  pti_scatter_fraction_factor,
  pti_dead_time_factor,
  pti_image_index
) values (
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,
  ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,
  ?, ?, ?, ?, ?, ?, ?, ?, ?
)', ARRAY['file_id', 'pti_trigger_time', 'pti_frame_time', 'pti_intervals_acquired', 'pti_intervals_rejected', 'pti_reconstruction_diameter', 'pti_gantry_detector_tilt', 'pti_table_height', 'pti_fov_shape', 'pti_fov_dimensions', 'pti_collimator_type', 'pti_convoution_kernal', 'pti_actual_frame_duration', 'pti_energy_range_lower_limit', 'pti_energy_range_upper_limit', 'pti_radiopharmaceutical', 'pti_radiopharmaceutical_volume', 'pti_radiopharmaceutical_start_time', 'pti_radiopharmaceutical_stop_time', 'pti_radionuclide_total_dose', 'pti_radionuclide_half_life', 'pti_radionuclide_positron_fraction', 'pti_number_of_slices', 'pti_number_of_time_slices', 'pti_type_of_detector_motion', 'pti_image_id', 'pti_series_type', 'pti_units', 'pti_counts_source', 'pti_reprojection_method', 'pti_randoms_correction_method', 'pti_attenuation_correction_method', 'pti_decay_correction', 'pti_reconstruction_method', 'pti_detector_lines_of_response_used', 'pti_scatter_correction_method', 'pti_axial_mash', 'pti_transverse_mash', 'pti_coincidence_window_width', 'pti_secondary_counts_type', 'pti_frame_reference_time', 'pti_primary_counts_accumulated', 'pti_secondary_counts_accumulated', 'pti_slice_sensitivity_factor', 'pti_decay_factor', 'pti_dose_calibration_factor', 'pti_scatter_fraction_factor', 'pti_dead_time_factor', 'pti_image_index'], 
                    '{}', ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetQuery', 'select 
 query
from pg_stat_activity
where pid = ?', ARRAY['pid'], 
                    ARRAY['query'], ARRAY['AllCollections', 'postgres_stats', 'postgres_query_stats'], 'posda_backlog', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetPatientMappingByCollectionSiteSimple', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  diagnosis_date,
  baseline_date,
  date_shift,
  baseline_date - diagnosis_date + interval ''1 day'' as computed_shift
from
  patient_mapping
where
  collection_name = ?
  and site_name = ?
  ', ARRAY['collection_name', 'site_name'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'diagnosis_date', 'baseline_date', 'date_shift', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionForAllFiles', 'select
  distinct project_name as collection, 
  site_name as site,
  user_name, 
  date_trunc(''hour'',time_of_change) as time, 
  reason_for, count(distinct file_id)
from
  file_visibility_change natural join
  ctp_file
where
  project_name = ?
group by collection, site, user_name, time, reason_for
order by time, collection, site', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'user_name', 'time', 'reason_for', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files', 'old_hidden'], 'posda_files', 'Show Received before date by collection, site')
        ;

            insert into queries
            values ('ListOpenActivities', 'select
  distinct activity_id,
  brief_description,
  when_created,
  who_created,
  count(distinct user_inbox_content_id) as num_items
from
  activity natural left join activity_inbox_content
where when_closed is null
group by activity_id, brief_description, when_created, who_created
order by activity_id desc', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'num_items'], ARRAY['AllCollections', 'queries', 'activities'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetInsertedSendId', 'select currval(''dicom_send_event_dicom_send_event_id_seq'') as id
', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'SeriesSendEvent'], 'posda_files', 'Get dicom_send_event_id after creation
For use in scripts.
Not meant for interactive use
')
        ;

            insert into queries
            values ('LinkEmailToActivity', 'insert into activity_inbox_content(
 activity_id, user_inbox_content_id
) values (
  ?, ?
)', ARRAY['activity_id', 'user_inbox_content_id'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('GetNonDicomEditCompareFromFiles', 'select 
  file_id,
  collection,
  visibility
from 
  file join non_dicom_file using(file_id)
where
  file_id in (
    select file_id from file f, non_dicom_edit_compare ndec
    where f.digest = ndec.from_file_digest and subprocess_invocation_id = ?
  )', ARRAY['subprocess_invocation_id'], 
                    ARRAY['file_id', 'collection', 'visibility'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_import'], 'posda_files', 'Get a list of from files from the non_dicom_edit_compare table for a particular edit instance, with visibility

NB: collection will be null if there is no non_dicom_file row.  This shouldn''t ever happen.  ever!  abort and investigate
       visibility, on the other hand, should always be null.  ')
        ;

            insert into queries
            values ('IncrementEditsDone', 'update dicom_edit_event
  set edits_done = edits_done + 1
where
  dicom_edit_event_id = ?', ARRAY['dicom_edit_event_id'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Increment edits done in dicom_edit_event table
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('AllSopsReceivedBetweenDatesByCollection', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
            natural join ctp_file
          where import_time > ? and import_time < ? and
            project_name = ? and visibility is null
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time', 'collection'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates regardless of duplicates
')
        ;

            insert into queries
            values ('DatesOfUploadByCollectionSiteVisible', 'select distinct date_trunc as date, count(*) as num_uploads from (
 select 
  date_trunc(''day'', import_time),
  file_id
from file_import natural join import_event natural join file_sop_common
  natural join ctp_file
where project_name = ? and site_name = ? and visibility is null
) as foo
group by date
order by date
', ARRAY['collection', 'site'], 
                    ARRAY['date', 'num_uploads'], ARRAY['receive_reports'], 'posda_files', 'Show me the dates with uploads for Collection from Site
')
        ;

            insert into queries
            values ('SeriesWithDupSopsByCollectionSite', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, study_instance_uid, series_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'num_sops', 'num_files', 'study_instance_uid', 'series_instance_uid'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FinalizeSimpleSeriesScan', 'update series_scan_instance set
  num_files = ?,
  end_time = now()
where
  series_scan_instance_id = ?', ARRAY['num_files', 'id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Finalize Series Scan')
        ;

            insert into queries
            values ('InsertFilePosda', 'insert into file(
  digest, size, processing_priority, ready_to_process
) values ( ?, ?, 1, ''false'')', ARRAY['digest', 'size'], 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction', 'used_in_file_import_into_posda'], 'posda_files', 'Lock the file table in posda_files')
        ;

            insert into queries
            values ('UpdateComparePublicToPosdaInstance', 'update compare_public_to_posda_instance set
  number_compares_completed = ?,
  num_failed = ?,
  status_of_compare = ''Comparisons In Progress'',
  last_updated = now()
where
  compare_public_to_posda_instance_id = ?
', ARRAY['number_compares_complete', 'num_failed', 'compare_public_to_posda_instance_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('FindInconsistentSeriesIgnoringTimeAll', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', '{}', 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series', 'series_consistency'], 'posda_files', 'Find Inconsistent Series
')
        ;

            insert into queries
            values ('UpdPosdaPhiEleName', 'update
  element_signature
set
  name_chain = ?
where
  element_signature = ? and
  vr = ?

', ARRAY['name', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi', 'Update name_chain in element signature')
        ;

            insert into queries
            values ('DupSopsByImportEvent', 'select sop_instance_uid, num_files from (
  select
    distinct sop_instance_uid, count(distinct file_id) as num_files
  from (
    select distinct sop_instance_uid, file_id, visibility
    from file_sop_common natural left join ctp_file
    where file_id in (
      select
        distinct file_id from file_import where import_event_id in (select import_event_id from (
          select
            distinct import_event_id, import_time,  import_type, count(distinct file_id) as num_files
          from
            import_event natural join file_import natural join file_patient
          where
            import_event_id = ?
           group by import_event_id, import_time, import_type
         ) as foo
      )
    )
  ) as foo where visibility is null
  group by sop_instance_uid
) as foo
where num_files > 1
', ARRAY['import_event_id'], 
                    ARRAY['sop_instance_uid', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_patients', 'import_event'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetCopyInformation', 'select
  status_of_copy,
  pid_of_running_process
from
  copy_from_public
where copy_from_public_id = ?', ARRAY['copy_from_public_id'], 
                    ARRAY['status_of_copy', 'pid_of_running_process'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('patient_id_and_collection_by_like_collection', 'select distinct project_name as collection, patient_id from file_patient natural join ctp_file where project_name like ? and visibility is null', ARRAY['like_collection'], 
                    ARRAY['collection', 'patient_id'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('UpdateNameChain', 'update element_signature set 
  name_chain = ?
where
  element_signature = ? and
  vr = ?
', ARRAY['name_chain', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Update Element Disposition
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('FindInconsistentSeriesIgnoringTimeCollectionSite', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name = ? and site_name = ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series', 'series_consistency'], 'posda_files', 'Find Inconsistent Series by Collection Site
')
        ;

            insert into queries
            values ('ListVisualReviewInstances', 'select
  visual_review_instance_id, visual_review_reason,
  visual_review_scheduler,
  visual_review_num_series,
  when_visual_review_scheduled, 
  visual_review_num_series_done,
  visual_review_num_equiv_class,
  when_visual_review_sched_complete
from visual_review_instance', '{}', 
                    ARRAY['visual_review_instance_id', 'visual_review_reason', 'visual_review_scheduler', 'visual_review_num_series', 'when_visual_review_scheduled', 'visual_review_num_series_done', 'visual_review_num_equiv_class', 'when_visual_review_sched_complete'], ARRAY['signature', 'phi_review', 'visual_review', 'visual_review_new_workflow'], 'posda_files', 'Get a list of files which are hidden by series id and visual review id')
        ;

            insert into queries
            values ('FileIdPathTimesLoadedCountsBySopInstance', 'select
  distinct file_id,
  root_path || ''/'' || file_location.rel_path as path,
  min(import_time) as first_loaded,
  count(distinct import_time) as times_loaded,
  max(import_time) as last_loaded
from
  file_location
  natural join file_storage_root
  join file_import using(file_id)
  join import_event using (import_event_id)
  natural join file_sop_common where sop_instance_uid = ?
group by file_id, path
order by first_loaded', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'path', 'first_loaded', 'times_loaded', 'last_loaded'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('GetStructureSetsByActivityTimepoint', 'select 
  file_id, root_path || ''/'' || rel_path as path, patient_id
from
  file_structure_set natural join activity_timepoint_file natural join file_location natural join file_storage_root
  natural join file_patient
where
  activity_timepoint_id = ?', ARRAY['activity_timepoint_id'], 
                    ARRAY['file_id', 'path', 'patient_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get List of file_ids for structure sets in an activity timepoint
')
        ;

            insert into queries
            values ('RoundSummary2', 'select
  round_id,
  round_created,
  round_start,  
  round_end,
  round_aborted,
  wait_count,
  process_count
from
  round
order by round_id', '{}', 
                    ARRAY['round_id', 'round_created', 'round_start', 'round_end', 'round_aborted', 'wait_count', 'process_count'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('ActivityStuffByUser', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, user_to_notify, button_name,
  operation_name, count(distinct background_subprocess_report_id) as num_reports
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where invoking_user = ?
group by
  subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  activity_id, when_script_started, when_background_entered,
  when_script_ended, user_to_notify, button_name, operation_name
order by subprocess_invocation_id desc', ARRAY['user'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'user_to_notify', 'button_name', 'operation_name', 'num_reports'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ListOfDciodvfyErrors', 'select 
  distinct error_type,
  error_tag, 
  error_value,
  error_subtype,
  error_module, 
  error_reason,
  error_index,
  count(distinct dciodvfy_unit_scan_id)  as num_scan_units 
from 
  dciodvfy_error
  natural join dciodvfy_unit_scan_error
group by 
  error_type,
  error_tag, 
  error_value,
  error_subtype,
  error_module, 
  error_reason,
  error_index
order by
  error_type,
  error_tag, 
  error_value,
  error_subtype,
  error_module, 
  error_reason,
  error_index', '{}', 
                    ARRAY['error_type', 'error_tag', 'error_value', 'error_subtype', 'error_module', 'error_reason', 'error_index', 'num_scan_units'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'All dciodvfy errors in DB')
        ;

            insert into queries
            values ('ReviewEditsByCollectionSite', 'select
  distinct project_name,
  site_name,
  series_instance_uid, 
  new_visibility, 
  reason_for,
  min(time_of_change) as earliest,
  max(time_of_change) as latest,
  count(*) as num_files
from
  file_visibility_change natural join
  ctp_file natural join
  file_series
where 
  project_name = ? and site_name = ?
group by 
  project_name, site_name, series_instance_uid, new_visibility, reason_for', ARRAY['collection', 'site'], 
                    ARRAY['project_name', 'site_name', 'series_instance_uid', 'new_visibility', 'reason_for', 'earliest', 'latest', 'num_files'], ARRAY['Hierarchy', 'review_visibility_changes'], 'posda_files', 'Show all file visibility changes by series for collection, site')
        ;

            insert into queries
            values ('SeriesWithMultipleSopsByVisualReviewId', 'select 
  distinct series_instance_uid, dicom_file_type, modality, visibility, count(distinct file_id) as num_files
from file_series natural join dicom_file natural join ctp_file
where series_instance_uid in (
  select series_instance_uid from (
    select
      distinct series_instance_uid, count(distinct dicom_file_type) as num_types, 
      count(distinct modality) as num_modalities 
    from (
      select 
        distinct series_instance_uid, dicom_file_type, modality
      from 
        file_series natural join dicom_file natural join image_equivalence_class
      where visual_review_instance_id = ?
     ) as foo
    group by series_instance_uid
  ) as foo 
  where num_types > 1 or num_modalities > 1
) group by series_instance_uid, dicom_file_type, modality, visibility order by series_instance_uid', ARRAY['visual_review_instance_id'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'visibility', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetReferencedButUnknownPlanSops', 'select
  sop_instance_uid, 
  rt_dose_referenced_plan_uid as plan_sop_instance_uid 
from 
  rt_dose d natural join file_dose join file_sop_common using(file_id)
where
  not exists (
  select
    sop_instance_uid 
  from
    file_sop_common fsc
  where
    d.rt_dose_referenced_plan_uid = fsc.sop_instance_uid
)', '{}', 
                    ARRAY['sop_instance_uid', 'plan_sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get list of doses which reference unknown SOPs

')
        ;

            insert into queries
            values ('ListOfDciodvfyWarnings', 'select distinct warning_type, warning_tag, warning_desc, warning_iod, warning_comment, warning_value, warning_reason, warning_index
 from dciodvfy_warning
order by warning_type, warning_tag, warning_desc, warning_iod, warning_comment, warning_value, warning_reason, warning_index', '{}', 
                    ARRAY['warning_type', 'warning_tag', 'warning_desc', 'warning_iod', 'warning_comment', 'warning_value', 'warning_reason', 'warning_index'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'All dciodvfy warnings in DB')
        ;

            insert into queries
            values ('AddWaitCount', 'update round
  set wait_count = ?
where
  round_id = ?
', ARRAY['wait_count', 'round_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Set wait_count in round')
        ;

            insert into queries
            values ('SubprocessInvocationByUser', 'select 
  distinct subprocess_invocation_id, 
  background_subprocess_id, spreadsheet_uploaded_id, query_invoked_by_dbif_id,
  button_name, invoking_user, when_invoked, operation_name,
  max(line_number) as num_lines
from 
  subprocess_invocation natural left join subprocess_lines
  natural left join background_subprocess
where 
  invoking_user = ?
group by 
  subprocess_invocation_id, 
  background_subprocess_id, spreadsheet_uploaded_id, query_invoked_by_dbif_id,
  button_name, invoking_user, when_invoked, operation_name
order by when_invoked desc', ARRAY['invoking_user'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'spreadsheet_uploaded_id', 'query_invoked_by_dbif_id', 'button_name', 'invoking_user', 'when_invoked', 'operation_name', 'num_lines'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DistinctValuesByTagWithFileCount', 'select distinct element_signature, value, count(*) as num_files
from (
select
  distinct series_instance_uid,
  series_scanned_file as file, 
  element_signature, value
from
  scan_event natural join series_scan natural join seen_value
  natural join element_signature natural join 
  scan_element natural left join sequence_index
where
  element_signature = ?
order by series_instance_uid, file, value
) as foo
group by element_signature, value
', ARRAY['tag'], 
                    ARRAY['element_signature', 'value', 'num_files'], ARRAY['tag_usage'], 'posda_phi', 'Distinct values for a tag with file count
')
        ;

            insert into queries
            values ('DatesOfUpload', 'select 
  distinct project_name as collection, site_name as site,
  date_trunc as date, count(*) as num_uploads from (
   select 
    project_name,
    site_name,
    date_trunc(''day'', import_time),
    file_id
  from file_import natural join import_event
    natural join ctp_file 
) as foo
group by project_name, site_name, date
order by date, project_name, site_name', '{}', 
                    ARRAY['collection', 'site', 'date', 'num_uploads'], ARRAY['receive_reports'], 'posda_files', 'Show me the dates with uploads for Collection from Site
')
        ;

            insert into queries
            values ('GetSimilarDupContourCounts', 'select
  distinct
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  sop_instance_uid,
  file_id
from
   ctp_file
   natural join file_patient
   natural join file_series
   natural join file_sop_common
where file_id in (
  select distinct file_id from (
    select 
      distinct file_id, count(*) as num_dup_contours
    from
      file_roi_image_linkage 
    where 
      contour_digest in (
      select contour_digest
     from (
        select 
          distinct contour_digest, count(*)
        from
          file_roi_image_linkage group by contour_digest
     ) as foo
      where count > 1
    ) group by file_id order by num_dup_contours desc
  ) as foo
  where num_dup_contours = ?
)
', ARRAY['num_dup_contours'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'sop_instance_uid', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dup_contours'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('VisualReviewStatusDetails', 'select distinct image_equivalence_class_id, series_instance_uid, processing_status, review_status, visibility, count(distinct file_id) as num_files
from image_equivalence_class natural join image_equivalence_class_input_image natural join dicom_file natural join ctp_file
where visual_review_instance_id = ? and dicom_file_type = ? and
  processing_status = ? and (review_status is null or review_status = ?) group by image_equivalence_class_id, series_instance_uid, processing_status, review_status, visibility;
', ARRAY['visual_review_instance_id', 'dicom_file_type', 'processing_status', 'review_status'], 
                    ARRAY['image_equivalence_class_id', 'series_instance_uid', 'processing_status', 'review_status', 'visibility', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('Sops In Public By Series', 'select 
  tdp.project as collection, dp_site_name as site, patient_id,
  study_instance_uid, series_instance_uid, sop_instance_uid 
from
  general_image i, trial_data_provenance tdp
where
  tdp.trial_dp_pk_id = i.trial_dp_pk_id and series_instance_uid = ?
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid'], ARRAY['Reconcile Public and Posda for CPTAC'], 'public', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('RowsInDicomFileWithNoPixelInfo', 'select 
  file_id, root_path || ''/'' || rel_path as path
from dicom_file natural join file_location natural join file_storage_root
where has_pixel_data is null limit ?', ARRAY['num_rows'], 
                    ARRAY['file_id', 'path'], ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'List of files (id, path) which are dicom_files with undefined pixel info')
        ;

            insert into queries
            values ('AllSeenValuesByElementVr', 'select distinct value 
from element_value_occurance natural join value_seen natural join element_seen
where element_sig_pattern = ? and vr = ? order by value', ARRAY['element_sig_pattern', 'vr'], 
                    ARRAY['value'], ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Get the relevant features of an element_signature in posda_phi_simple schema')
        ;

            insert into queries
            values ('TagsSeen', 'select
  element_signature, vr, is_private, private_disposition, name_chain
from
  element_signature order by element_signature', '{}', 
                    ARRAY['element_signature', 'vr', 'is_private', 'private_disposition', 'name_chain'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'phi_maint'], 'posda_phi', 'Get all the data from tags_seen in posda_phi database
')
        ;

            insert into queries
            values ('CountsByCollectionSiteSubjectDateRange', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and patient_id = ? and visibility is null
  and import_time > ? and import_time < ?
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site', 'subject', 'from', 'to'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetDciodvfyScanDesc', 'select 
  type_of_unit,
  description_of_scan,
  number_units,
  scanned_so_far,
  start_time,
  end_time
from 
  dciodvfy_scan_instance
where dciodvfy_scan_instance_id = ?
', ARRAY['scan_id'], 
                    ARRAY['type_of_unit', 'description_of_scan', 'number_units', 'scanned_so_far', 'start_time', 'end_time'], ARRAY['tag_usage', 'dciodvfy'], 'posda_phi_simple', 'Get info about a dciodvfy scan')
        ;

            insert into queries
            values ('WhereFileSits', 'select distinct
  project_name as collection,
  site_name as site,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural left join
  ctp_file
where file_id = ? and visibility is null', ARRAY['file_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid'], ARRAY['posda_files', 'sops', 'BySopInstance', 'by_file'], 'posda_files', 'Get Collection, Site, Patient, Study Hierarchy in which SOP resides
')
        ;

            insert into queries
            values ('AllValuesByElementSigIdAndScanId', 'select
  distinct value
from
  seen_value natural join scan_element
where
  element_signature_id = ? and series_scan_id in (
  select
    series_scan_id 
  from 
    series_scan
  where 
    scan_event_id = ?
  )
order by value
', ARRAY['element_signature_id', 'scan_id'], 
                    ARRAY['value'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan with specified tag
')
        ;

            insert into queries
            values ('MarkFileAsInPosda', 'update request
set
  file_in_posda = true,
  time_entered = now(),
  posda_file_id = ?
where
  request_id = ?

', ARRAY['posda_file_id', 'request_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Update a request status to indicate file in Posda')
        ;

            insert into queries
            values ('ListOfPrivateElementsWithDispositionsByScanId', 'select
  distinct element_signature, vr , private_disposition as disposition,
  element_signature_id, name_chain
from
  element_signature natural join scan_element natural join series_scan
where
  is_private and scan_event_id = ?
order by element_signature
', ARRAY['scan_id'], 
                    ARRAY['element_signature', 'vr', 'disposition', 'element_signature_id', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('DistinctSopsInCollection', 'select distinct sop_instance_uid
from
  file_sop_common
where file_id in (
  select
    distinct file_id
  from
    ctp_file
  where
    project_name = ? and visibility is null
)
order by sop_instance_uid
', ARRAY['collection'], 
                    ARRAY['sop_instance_uid'], ARRAY['by_collection', 'posda_files', 'sops'], 'posda_files', 'Get Distinct SOPs in Collection with number files
Only visible files
')
        ;

            insert into queries
            values ('PatientStudySeriesFileHierarchyByCollectionExcludingSeriesByDescription', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  root_path || ''/'' || rel_path as path
from
  file_study natural join ctp_file natural join file_series natural join file_patient
  natural join file_sop_common natural join file_location
  natural join file_storage_root
where 
  file_id in (
    select distinct file_id
    from ctp_file natural join file_series
    where project_name = ? and visibility is null and series_description not like ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'exclude_series_descriptions_matching'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'path'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection in a Patient, Study, Series Hierarchy excluding series by series_description')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionWithFileCountAndLoadTimesAndStudyDateOnlySinceDate', 'select * from (select 
  collection, site, patient_id, qualified, study_date,
  count(distinct file_id) as num_files, count (distinct sop_instance_uid) as num_sops,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) 
  join file_study using(file_id) join file_import using(file_id)
  join file_sop_common using(file_id)
  join import_event using(import_event_id)
where collection like ?
group by collection, site, patient_id, qualified, study_date) as foo where earliest_day >= ? ', ARRAY['collection_like', 'from'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'num_sops', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('PatientStudySeriesFileHierarchyByCollectionIncludingSeriesByDescription', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  root_path || ''/'' || rel_path as path
from
  file_study natural join ctp_file natural join file_series natural join file_patient
  natural join file_sop_common natural join file_location
  natural join file_storage_root
where 
  file_id in (
    select distinct file_id
    from ctp_file natural join file_series
    where project_name = ? and visibility is null and series_description like ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'exclude_series_descriptions_matching'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'path'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of files in a collection in a Patient, Study, Series Hierarchy excluding series by series_description')
        ;

            insert into queries
            values ('DuplicateSOPInstanceUIDsGlobalWithHidden', 'select distinct collection, site, patient_id, count(*)
from (
select 
  distinct collection, site, patient_id, sop_instance_uid, count(*)
  as dups
from (
select
  distinct project_name as collection,
  site_name as site, patient_id,
  study_instance_uid, series_instance_uid, sop_instance_uid, file_id
from file_sop_common natural join ctp_file natural join file_patient
  natural join file_study natural join file_series
where sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
      select distinct file_id, sop_instance_uid 
      from
        ctp_file natural join file_sop_common
        natural join file_patient
    ) as foo
    group by sop_instance_uid order by count desc
  ) as foo where count > 1
) group by project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid, sop_instance_uid, file_id
) as foo
group by collection, site, patient_id, sop_instance_uid
) as foo where dups > 1
group by collection, site, patient_id
order by collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'count'], ARRAY['receive_reports'], 'posda_files', 'Return a report of duplicate SOP Instance UIDs ignoring visibility
')
        ;

            insert into queries
            values ('FindQueryByTag', 'select
  distinct name from (
  select name, unnest(tags) as tag
  from queries) as foo
where
  tag = ?', ARRAY['tag_name'], 
                    ARRAY['name'], ARRAY['meta', 'test', 'hello'], 'posda_queries', 'Find all queries matching tag')
        ;

            insert into queries
            values ('DistinctVisibleFileReportBySeries', 'select distinct
	coalesce(project_name, ''UNKNOWN'') as collection,
	coalesce(site_name, ''UNKNOWN'') as site,
	patient_id,
	study_instance_uid,
	series_instance_uid,
	sop_instance_uid,
	dicom_file_type,
	modality,
	file_id
from
	file_patient
	natural join file_study
	natural join file_series
	natural join file_sop_common
	natural join dicom_file
	natural left join ctp_file
where
	series_instance_uid = ?
	and visibility is null
order by series_instance_uid
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'dicom_file_type', 'modality', 'file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('SubjectsWithDupSopsWithStudySeries', 'select 
  distinct project_name, site_name, patient_id, count(distinct file_id)
from
  ctp_file natural join file_sop_common natural join file_patient
where sop_instance_uid in (
  select distinct sop_instance_uid
  from (
    select
      distinct sop_instance_uid, count(*)
    from (
      select
        sop_instance_uid, study_instance_uid, series_instance_uid
      from
        file_sop_common natural join file_series natural join file_study
    )as foo group by sop_instance_uid
  ) as foo where count > 1
)
group by
  project_name, site_name, patient_id
order by 
  project_name, site_name, patient_id, count desc
  ', '{}', 
                    ARRAY['project_name', 'site_name', 'patient_id', 'count'], ARRAY['pix_data_dups'], 'posda_files', 'Find list of series with SOP with conflicting study or series')
        ;

            insert into queries
            values ('GetScanEventId', 'select currval(''series_scan_series_scan_id_seq'') as id', '{}', 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('GetCountSsVolumeBySeriesUid', 'select
  distinct sop_instance_uid, count(distinct sop_instance_link) as num_links 
from (
  select 
    sop_instance_uid, for_uid, study_instance_uid, series_instance_uid,
    sop_class as sop_class_uid, sop_instance as sop_instance_link
  from
    ss_for natural join ss_volume natural join
    file_structure_set join file_sop_common using (file_id)
  where structure_set_id in (
    select 
      structure_set_id 
    from
      file_structure_set fs, file_sop_common sc
    where
      sc.file_id = fs.file_id and sop_instance_uid in (
         select distinct sop_instance_uid from file_sop_common natural join file_series
         where series_instance_uid = ?
     )
  )
) as foo 
group by sop_instance_uid', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'num_links'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('tags_by_role', 'select
  filter_name as role, unnest(tags_enabled) as tag
from query_tag_filter where filter_name = ?', ARRAY['role'], 
                    ARRAY['role', 'tag'], ARRAY['roles'], 'posda_queries', 'Show a complete list of associated tags for a role
')
        ;

            insert into queries
            values ('AddBackgroundTimeAndRowsToBackgroundProcess', 'update background_subprocess set
  when_background_entered = now(),
  input_rows_processed = ?,
  background_pid = ?
where
  background_subprocess_id = ?

', ARRAY['input_rows', 'background_pid', 'background_subprocess_id'], 
                    NULL, ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'N
o
n
e')
        ;

            insert into queries
            values ('ActivityTimepointsForActivity', 'select
  distinct activity_id, a.when_created as activity_created,
  brief_description as activity_description, activity_timepoint_id,
  t.when_created as timepoint_created, 
  comment, creating_user, count(distinct file_id) as num_files
from
  activity a join activity_timepoint t using(activity_id) join 
  activity_timepoint_file using(activity_timepoint_id)
where
  activity_id = ?
group by
  activity_id, activity_created, activity_description, activity_timepoint_id,
  timepoint_created, comment, creating_user
order by activity_timepoint_id desc', ARRAY['activity_id'], 
                    ARRAY['activity_id', 'activity_created', 'activity_description', 'activity_timepoint_id', 'timepoint_created', 'comment', 'creating_user', 'num_files'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_selection', 'activity_timepoints'], 'posda_queries', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('SelectCtInfoSummaryByCollection', 'select 
  distinct 
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  kvp,
  scan_options,
  data_collection_diameter,
  reconstruction_diameter,
  dist_source_to_detect,
  dist_source_to_pat,
  gantry_tilt,
  rotation_dir,
  exposure_time,
  filter_type,
  generator_power, 
  convolution_kernal,
  table_feed_per_rot,
  count(*) as num_files
from file_ct_image natural join file_patient natural join file_series natural join ctp_file 
where project_name = ? and visibility is null
group by
  collection,
  site,
  patient_id,
  series_instance_uid,
  kvp,
  scan_options,
  data_collection_diameter,
  reconstruction_diameter,
  dist_source_to_detect,
  dist_source_to_pat,
  gantry_tilt,
  rotation_dir,
  exposure_time,
  filter_type,
  generator_power, 
  convolution_kernal,
  table_feed_per_rot
order by patient_id', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'kvp', 'scan_options', 'data_collection_diameter', 'reconstruction_diameter', 'dist_source_to_detect', 'dist_source_to_pat', 'gantry_tilt', 'rotation_dir', 'exposure_time', 'filter_type', 'generator_power', 'convolution_kernal', 'table_feed_per_rot'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Gets count of all files which are PET''s which haven''t been imported into file_pt_image yet.

')
        ;

            insert into queries
            values ('EquivalenceClassStatusSummaryByCollection', 'select
  distinct project_name as collection,
  processing_status,
  review_status, count(distinct image_equivalence_class_id)
from
  image_equivalence_class join file_series using(series_instance_uid) join ctp_file using(file_id)
where project_name = ?
group by collection, processing_status, review_status', ARRAY['collection'], 
                    ARRAY['collection', 'processing_status', 'review_status', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review'], 'posda_files', 'Find Series with more than n equivalence class')
        ;

            insert into queries
            values ('PatientReport', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description,
  count(distinct file_id) as num_files,
  min(import_time) as earliest_upload,
  max(import_time) as latest_upload,
  count(distinct import_event_id) as num_uploads
from
  file_patient natural join file_study natural join
  file_series natural join ctp_file natural join
  file_import natural join import_event
where
  project_name = ? and
  site_name = ? and
  patient_id = ?
  and visibility is null
group by 
  collection, site,
  patient_id, study_instance_uid, study_description,
  series_instance_uid, series_description
order by
  study_instance_uid, series_instance_uid, num_files', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'study_description', 'series_instance_uid', 'series_description', 'num_files', 'earliest_upload', 'latest_upload', 'num_uploads'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('VisualReviewScanInstances', 'select 
  visual_review_instance_id as id, visual_review_reason as reason,
  visual_review_scheduler as who_by, visual_review_num_series as num_series,
  when_visual_review_scheduled as when_scheduled,
  visual_review_num_series_done as num_done,
  visual_review_num_equiv_class as num_equiv,
  when_visual_review_sched_complete as sched_finish_time
from visual_review_instance
  order by when_scheduled desc', '{}', 
                    ARRAY['id', 'reason', 'who_by', 'num_series', 'when_scheduled', 'num_done', 'num_equiv', 'sched_finish_time'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_status'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetUsersBoundVariables', 'select
  binding_user as user,
  bound_variable_name as variable,
  bound_value as  value
from
  user_variable_binding
where
  binding_user = ?

', ARRAY['user'], 
                    ARRAY['user', 'variable', 'binding'], ARRAY['AllCollections', 'queries', 'activity_support', 'variabler_binding'], 'posda_queries', 'Get list of variables with bindings for a user')
        ;

            insert into queries
            values ('HowManyFilesToHideInCopyFromPublic', 'select
  count(*) as num_to_hide
from file_copy_from_public c, ctp_file p
where
  c.copy_from_public_id = ? and
  (p.file_id = c.replace_file_id and p.visibility is null) ', ARRAY['copy_from_public_id'], 
                    ARRAY['num_to_hide'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PosdaTotalsWithDateRange', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
from (
  select
    distinct project_name, site_name, patient_id, count(*) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
  from (
    select
       distinct project_name, site_name, patient_id, study_instance_uid, 
       count(*) as num_series, sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id, study_instance_uid, 
        series_instance_uid, count(*) as num_files 
      from (
        select
          distinct project_name, site_name, patient_id, study_instance_uid,
          series_instance_uid, sop_instance_uid 
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common natural join file_patient
           natural join file_import natural join import_event
        where
          visibility is null and import_time >= ? and
          import_time < ? 
      ) as foo
      group by
        project_name, site_name, patient_id, 
        study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', ARRAY['start_time', 'end_time'], 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], '{}', 'posda_files', 'Get posda totals by date range
')
        ;

            insert into queries
            values ('CreateBackgroundSubprocessError', 'insert into background_subprocess(
  subprocess_invocation_id,
  input_rows_processed,
  command_executed,
  foreground_pid,
  background_pid,
  when_script_started,
  when_background_entered,
  user_to_notify,
  process_error
) values (
  ?, ?, ?, ?, ?, ?, now(), ?, ?
)', ARRAY['subprocess_invocation_id', 'input_rows_processed', 'command_executed', 'foreground_pid', 'background_pid', 'when_script_started', 'user_to_notify', 'process_error'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create row in background_subprocess table with an error in initialization

Used by background subprocess')
        ;

            insert into queries
            values ('ListOpenActivitiesOld', 'select
  activity_id,
  brief_description,
  when_created,
  who_created
from
  activity
where when_closed is null
order by activity_id desc', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSiteWithDateRange', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join 
  ctp_file natural join 
  file_series natural join 
  file_patient
where 
  file_id in (
    select distinct file_id
    from 
      ctp_file  natural join
      file_import natural join
      import_event
    where project_name = ? and site_name = ? and
    visibility is null and
    import_time > ? and import_time < ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy', 'apply_disposition'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy with upload times within a date range')
        ;

            insert into queries
            values ('GetZipUploadEventsByDateRange', 'select distinct import_event_id, count(distinct file_id)  as num_files 
from file_import natural join import_event
where
import_time > ? and import_time < ? and import_comment = ''zip''
group by import_event_id', ARRAY['from', 'to'], 
                    ARRAY['import_event_id', 'num_files'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetFilesAndSopsBySeries', 'select 
  distinct patient_id,
  study_instance_uid,
  series_instance_uid,
  sop_instance_uid,
  file_id, 
  root_path || ''/'' || rel_path as path
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  file_location natural join
  file_storage_root natural left join
  ctp_file
where 
  series_instance_uid = ? and
  visibility is null', ARRAY['series_instance_uid'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'path'], ARRAY['ImageEdit', 'edit_files'], 'posda_files', 'Get File id and visibility for all files in a series')
        ;

            insert into queries
            values ('PublicSeriesByCollection', 'select
  p.patient_id as PID,
  s.modality as Modality,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions
from
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? 
', ARRAY['collection'], 
                    ARRAY['PID', 'Modality', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions'], ARRAY['public'], 'public', 'List of all Series By Collection, Site on Public
')
        ;

            insert into queries
            values ('FirstFilesInSeries', 'select root_path || ''/'' || rel_path as path
from file_location natural join file_storage_root
where file_id in (
select file_id from 
  (
  select 
    distinct sop_instance_uid, min(file_id) as file_id
  from 
    file_series natural join ctp_file 
    natural join file_sop_common
  where 
    series_instance_uid = ?
    and visibility is null
  group by sop_instance_uid
) as foo);
', ARRAY['series_instance_uid'], 
                    ARRAY['path'], ARRAY['by_series'], 'posda_files', 'First files uploaded by series
')
        ;

            insert into queries
            values ('GetEquipmentSignature', 'select * from equipment_signature where equipment_signature = ?
', ARRAY['equipment_signature'], 
                    ARRAY['equipment_signature_id', 'equipment_signature'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Get Equipment Signature Id')
        ;

            insert into queries
            values ('GetElemenSeenIdBySig', 'select element_seen_id
from element_seen
where element_sig_pattern = ?', ARRAY['element_sig_pattern'], 
                    ARRAY['element_seen_id'], ARRAY['NotInteractive', 'ElementDisposition', 'phi_maint'], 'posda_phi_simple', 'Get List of Private Elements By Disposition')
        ;

            insert into queries
            values ('BackgroundSubprocessBySubprocessId', 'select 
  background_subprocess_id, subprocess_invocation_id, 
  input_rows_processed,  when_script_started, when_background_entered,
  when_script_ended, user_to_notify, process_error
from 
  background_subprocess
where 
  subprocess_invocation_id = ?
order by when_script_started desc', ARRAY['subprocess_invocaton_id'], 
                    ARRAY['background_subprocess_id', 'subprocess_invocation_id', 'input_rows_processed', 'when_script_started', 'when_background_entered', 'when_script_ended', 'user_to_notify', 'process_error'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSiteBatch', 'select distinct series_instance_uid, dicom_file_type, modality, count(distinct file_id)
from
  file_study natural join file_series natural join dicom_file natural join ctp_file
where
  project_name = ? and site_name = ? and batch = ? and visibility is null
group by series_instance_uid, dicom_file_type, modality
', ARRAY['project_name', 'site_name', 'batch'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'count'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetFilesWithSeriesButNoStudy', 'select 
  distinct file_id
from
  file_series se natural join ctp_file
where
  not exists (
    select file_id from file_study st where st.file_id = se.file_id
  ) and
  visibility is null
  and project_name = ?', ARRAY['collection'], 
                    ARRAY['file_id'], ARRAY['posda_db_populate', 'dicom_file_type'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetWeeksRangeByDate', 'select 
  date_trunc(''week'', foo) as start_week,
  date_trunc(''week'', foo + interval ''7 days'') as end_week,
  date_trunc(''day'', foo + interval ''1 day'') as end_partial_week
where foo in (
  select to_timestamp(?, ''yyyy-mm-dd'') as foo
)', ARRAY['from'], 
                    ARRAY['start_week', 'end_week', 'end_partial_week'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('FindTagsInQueries', 'select
  distinct tag from (
  select name, unnest(tags) as tag
  from queries) as foo
order by tag', '{}', 
                    ARRAY['tag'], ARRAY['meta', 'test', 'hello', 'query_tags'], 'posda_queries', 'Find all queries matching tag')
        ;

            insert into queries
            values ('FindQueryMatching', 'select
  distinct name
from
  queries
where
  query ~ ?
order by name', ARRAY['query_matching'], 
                    ARRAY['name'], ARRAY['meta', 'test', 'hello'], 'posda_queries', 'Find all queries with name matching arg')
        ;

            insert into queries
            values ('DuplicateSOPInstanceUIDsGlobalWithoutHidden', 'select
  distinct project_name as collection,
  site_name as site, patient_id,
  study_instance_uid, series_instance_uid, sop_instance_uid, file_id
from file_sop_common natural join ctp_file natural join file_patient
  natural join file_study natural join file_series
where visibility is null and sop_instance_uid in (
  select distinct sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
      select distinct file_id, sop_instance_uid 
      from
        ctp_file natural join file_sop_common
        natural join file_study natural join file_series
        natural join file_patient
      where visibility is null
    ) as foo
    group by sop_instance_uid order by count desc
  ) as foo where count > 1
) group by project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid, sop_instance_uid, file_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id'], ARRAY['receive_reports'], 'posda_files', 'Return a report of visible duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('ActivityStuffMoreForAllByDateRange', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
where when_script_started >= ? and when_script_ended <= ?
order by subprocess_invocation_id desc
', ARRAY['from', 'to'], 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('subprocess_invocations', 'select command_line, when_invoked, spreadsheet_uploaded_id from subprocess_invocation
where from_spreadsheet
order by when_invoked', '{}', 
                    ARRAY['command_line', 'when_invoked', 'spreadsheet_uploaded_id'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ValuesWithVrTagAndCountLimited', 'select distinct vr, value, element_signature, num_files from (
  select
    distinct vr, value, element_signature, count(*)  as num_files
  from
    scan_event natural join series_scan natural join seen_value
    natural join element_signature natural join scan_element
  where
    scan_event_id = ? and
    vr not in (
      ''AE'', ''AT'', ''DS'', ''FL'', ''FD'', ''IS'', ''OD'', ''OF'', ''OL'', ''OW'',
      ''SL'', ''SQ'', ''SS'', ''TM'', ''UL'', ''US''
    )
  group by value, element_signature, vr
) as foo
order by vr, value
', ARRAY['scan_id'], 
                    ARRAY['vr', 'value', 'element_signature', 'num_files'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('PossiblyRunningBackgroundSubprocesses', 'select
  subprocess_invocation_id, background_subprocess_id,
  when_script_started, when_background_entered, command_line,
  now()-when_background_entered as time_in_background, background_pid
from
  subprocess_invocation natural join background_subprocess
where
  when_background_entered is not null and when_script_ended is null and
  subprocess_invocation_id != 0 and crash is null
order by subprocess_invocation_id', '{}', 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'when_script_started', 'when_background_entered', 'command_line', 'time_in_background', 'background_pid'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionMatchingSeriesDesc', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file natural join file_series
    where project_name = ? and visibility is null and series_description like ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'series_descriptions_matching'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of series in a collection in a Patient, Study, Series Hierarchy excluding matching SeriesDescriptons')
        ;

            insert into queries
            values ('ListOfQueriesPerformedAllWithLatestAndCount', 'select
  query_name,
  max(query_start_time) as last_invocation, 
  count(query_invoked_by_dbif_id) as num_invocations,
  sum(query_end_time - query_start_time) as total_query_time,
  avg(query_end_time - query_start_time) as avg_query_time
from 
  query_invoked_by_dbif
group by query_name
order by last_invocation  desc', '{}', 
                    ARRAY['query_name', 'last_invocation', 'num_invocations', 'total_query_time', 'avg_query_time'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('SeriesByDistinguishedDigest', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  count(distinct sop_instance_uid) as num_sops
from
  ctp_file natural join
  file_patient natural
  join file_series natural
  join file_sop_common
where file_id in(
  select file_id 
  from
    file_image
    join image using (image_id)
    join unique_pixel_data using (unique_pixel_data_id)
  where digest = ?
  ) and visibility is null
group by collection, site, patient_id, series_instance_uid
order by collection, site, patient_id', ARRAY['distinguished_pixel_digest'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'num_sops'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'show series with distinguished digests and counts')
        ;

            insert into queries
            values ('PublicDifferenceReportBySubprocessId', 'select
  distinct short_report_file_id, long_report_file_id,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct from_file_id) as num_files
from posda_public_compare
where background_subprocess_id =?
group by short_report_file_id, long_report_file_id order by short_report_file_id', ARRAY['subprocess_invocation_id'], 
                    ARRAY['short_report_file_id', 'long_report_file_id', 'num_sops', 'num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('DatabaseSizes', 'select d.datname AS Name,  pg_catalog.pg_get_userbyid(d.datdba) AS Owner,
    CASE WHEN pg_catalog.has_database_privilege(d.datname, ''CONNECT'')
        THEN pg_catalog.pg_size_pretty(pg_catalog.pg_database_size(d.datname))
        ELSE ''No Access''
    END AS SIZE
FROM pg_catalog.pg_database d
    ORDER BY
    CASE WHEN pg_catalog.has_database_privilege(d.datname, ''CONNECT'')
        THEN pg_catalog.pg_database_size(d.datname)
        ELSE NULL
    END DESC -- nulls first
    LIMIT 20
', '{}', 
                    ARRAY['name', 'owner', 'size'], ARRAY['AllCollections', 'postgres_stats', 'database_size'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('CreateDicomEditCompareDisposition', 'insert into dicom_edit_compare_disposition(
  subprocess_invocation_id, start_creation_time, current_disposition, process_pid, dest_dir
)values (
  ?, now(), ''Starting Up'', ?, ?
)', ARRAY['subprocess_invocation_id', 'process_pid', 'dest_dir'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'Create an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('FilePathComponentsByFileId', 'select
  root_path, rel_path
from
  file_location natural join file_storage_root
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['root_path', 'rel_path'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send', 'for_comparing_dups', 'used_in_file_import_into_posda'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('dicom_files_ids_with_no_ctp_file_like_pat', 'select 
  distinct patient_id,
  dicom_file_type, 
  modality, 
  file_id,
  root_path || ''/'' || rel_path as file_path
from
  dicom_file d natural join
  file_patient natural join 
  file_series natural join
  file_location natural join
  file_storage_root
where not exists (select file_id from ctp_file c where c.file_id = d.file_id) and patient_id like ?
', ARRAY['patient_id_pattern'], 
                    ARRAY['patient_id', 'dicom_file_type', 'modality', 'file_id', 'file_path'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionByHourNoSeries', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  date_trunc(''hour'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files,
  count (distinct series_instance_uid) as num_series
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where project_name = ?
group by
 collection, site, patient_id, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files', 'num_series'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events', 'show_hidden'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CreateDciodvfyUnitScanError', 'insert into dciodvfy_unit_scan_error(
  dciodvfy_scan_instance_id,
  dciodvfy_unit_scan_id,
  dciodvfy_error_id
)values (?, ?, ?)', ARRAY[' dicodvfy_scan_instance_id', 'dciodvfy_unit_scan_id', 'dciodvfy_error_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_unit_scan_error row')
        ;

            insert into queries
            values ('FilePathCountAndLoadTimesBySopInstance', 'select
  distinct file_id,
  root_path || ''/'' || file_location.rel_path as path,
  min(import_time) as first_loaded,
  count(distinct import_time) as times_loaded,
  max(import_time) as last_loaded
from
  file_location
  natural join file_storage_root
  join file_import using(file_id)
  join import_event using (import_event_id)
  natural join file_sop_common
where sop_instance_uid = ?
group by file_id, path;', ARRAY['sop_instance_uid'], 
                    ARRAY['file_id', 'path', 'first_loaded', 'times_loaded', 'last_loaded'], ARRAY['SeriesSendEvent', 'by_series', 'find_files', 'for_send', 'for_comparing_dups'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('SimplePhiReportAllRelevantPrivateOnlyNew', 'select 
  distinct ''<'' || element_sig_pattern || ''>''  as element, length(value) as val_length,
  vr, value, tag_name as description, private_disposition as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and is_private and private_disposition not in (''d'', ''na'', ''h'', ''o'', ''oi'')
group by element_sig_pattern, vr, value, val_length, description, disp
order by vr, element, val_length', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'value', 'description', 'disp', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('PatientStatusChangeByCollection', 'select
  patient_id, old_pat_status as from,
  new_pat_status as to, pat_stat_change_who as by,
  pat_stat_change_why as why,
  when_pat_stat_changed as when
from patient_import_status_change
where patient_id in(
  select distinct patient_id
  from file_patient natural join ctp_file
  where project_name = ? and visibility is null
)
order by patient_id, when_pat_stat_changed
', ARRAY['collection'], 
                    ARRAY['patient_id', 'from', 'to', 'by', 'why', 'when'], ARRAY['PatientStatus'], 'posda_files', 'Get History of Patient Status Changes by Collection
')
        ;

            insert into queries
            values ('FindInconsistentStudyIgnoringStudyTimeByCollectionLike', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join ctp_file
    where
      project_name like ? and visibility is null
    group by
      study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', ARRAY['collection_like'], 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('Sops In Posda By Series', 'select 
  distinct project_name as collection, site_name as site, patient_id,
  study_instance_uid, series_instance_uid,
  modality, sop_instance_uid
from
  file_series natural join file_patient natural join ctp_file natural join
  file_sop_common natural join file_study
where file_id in (
  select
    file_id
from
    file_series natural join ctp_file
  where 
    visibility is null and series_instance_uid = ?
  )
', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'modality', 'sop_instance_uid'], ARRAY['Reconcile Public and Posda for CPTAC'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('background_emails_by_date', 'select 
  background_subprocess_report_id as id, 
  button_name, operation_name, invoking_user, when_invoked, file_id, name
from background_subprocess_report natural join background_subprocess natural join subprocess_invocation where invoking_user = ? and name = ''Email'' and when_invoked > ? and when_invoked < ?
order by when_invoked desc', ARRAY['invoking_user', 'from', 'to'], 
                    ARRAY['id', 'button_name', 'operation_name', 'invoking_user', 'when_invoked', 'file_id', 'name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FileStorageRootSummaryExtended', 'select 
  distinct file_storage_root_id,
  root_path,
  storage_class,
  count(distinct file_id) as num_files,
  sum(size) as total_bytes
from
  file_storage_root
  natural join file_location
  natural join file
group by file_storage_root_id, root_path, storage_class;', '{}', 
                    ARRAY['file_storage_root_id', 'root_path', 'storage_class', 'num_files', 'total_bytes'], ARRAY['used_in_file_import_into_posda', 'bills_test'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('GetUnkQualifiedCTQPByLikeCollectionSiteWithFIleCount', 'select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id)
where collection like ? and site = ? and qualified is null
group by collection, site, patient_id, qualified', ARRAY['collection_like', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('GetToFileIdGivenFromFileId', 'select file_id as to_file_id from file where digest in (
select to_file_digest as digest from dicom_edit_compare where from_file_digest in
(select digest as from_file_digest from file where file_id = ?))', ARRAY['from_file_id'], 
                    ARRAY['to_file_id'], ARRAY['edit_status'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('SeriesNotScheduledForVisualReviewByCollectionSiteSummary', 'select 
  distinct
  series_instance_uid,
  dicom_file_type,
  modality,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file
where
  file_id in (
    select file_id from file_series
    where series_instance_uid in
    (
       select distinct series_instance_uid
       from file_series fs natural join ctp_file
       where
         project_name = ? and
         site_name = ? and visibility is null
         and not exists (
           select series_instance_uid
           from image_equivalence_class ie
           where ie.series_instance_uid = fs.series_instance_uid
         )
    )
  )
group by
  series_instance_uid,
  dicom_file_type,
  modality', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get Series which have no image_equivalence class by collection, site')
        ;

            insert into queries
            values ('SimplePublicPhiReportSelectedVrWithMetaquotes', 'select 
  distinct ''<'' || element_sig_pattern || ''>'' as element, vr, ''<'' || value || ''>'' as q_value, tag_name as description, 
  '' '' as disp, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and
  not is_private and
  vr in (''SH'', ''OB'', ''PN'', ''DA'', ''ST'', ''AS'', ''DT'', ''LO'', ''UI'', ''CS'', ''AE'', ''LT'', ''ST'', ''UC'', ''UN'', ''UR'', ''UT'')
group by element, vr, q_value, tag_name, disp
order by vr, element, q_value', ARRAY['scan_id'], 
                    ARRAY['element', 'vr', 'q_value', 'description', 'disp', 'num_series'], ARRAY['adding_ctp', 'for_scripting', 'phi_reports'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('SendEventSummary', 'select
  reason_for_send, num_events, files_sent, earliest_send,
  finished, finished - earliest_send as duration
from (
  select
    distinct reason_for_send, count(*) as num_events, sum(number_of_files) as files_sent,
    min(send_started) as earliest_send, max(send_ended) as finished
  from dicom_send_event
  group by reason_for_send
  order by earliest_send
) as foo
', '{}', 
                    ARRAY['reason_for_send', 'num_events', 'files_sent', 'earliest_send', 'finished', 'duration'], ARRAY['send_to_intake'], 'posda_files', 'Summary of SendEvents by Reason
')
        ;

            insert into queries
            values ('PatientStudySeriesHierarchyByCollectionSiteMatchingSeriesDesc', 'select distinct
  patient_id,
  study_instance_uid,
  series_instance_uid
from
  file_study natural join ctp_file natural join file_series natural join file_patient
where 
  file_id in (
    select distinct file_id
    from ctp_file natural join file_series
    where project_name = ? and site_name = ? 
    and visibility is null and series_description like ?
  )
order by patient_id, study_instance_uid, series_instance_uid', ARRAY['collection', 'site', 'series_descriptions_matching'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['Hierarchy'], 'posda_files', 'Construct list of series in a collection in a Patient, Study, Series Hierarchy excluding matching SeriesDescriptons')
        ;

            insert into queries
            values ('GetLoadPathByImportEventId', 'select file_id, rel_path from file_import where import_event_id = ?', ARRAY['import_event_id'], 
                    ARRAY['file_id', 'rel_path'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('AllHiddenSubjects', 'select
  distinct patient_id, project_name, site_name,
  count(*) as num_files
from
  file_patient natural join ctp_file
where patient_id in (
    select distinct patient_id 
    from file_patient
  except 
    select patient_id 
    from
      file_patient natural join ctp_file 
    where
      visibility is null
) group by patient_id, project_name, site_name
order by project_name, site_name, patient_id;
', '{}', 
                    ARRAY['patient_id', 'project_name', 'site_name', 'num_files'], ARRAY['FindSubjects'], 'posda_files', 'Find All Subjects which have only hidden files
')
        ;

            insert into queries
            values ('Checking Duplicate Pixel Data By Series', 'select 
  distinct project_name as collection, site_name as site, patient_id,
  dicom_file_type, pixel_data_digest, sop_instance_uid
from
  file_series natural join file_patient natural join ctp_file natural join
  file_sop_common natural join dicom_file
where pixel_data_digest in (
  select
    distinct pixel_data_digest
  from
    file_series natural join ctp_file natural join dicom_file
  where 
    visibility is null and series_instance_uid = ?
  )
order by pixel_data_digest', ARRAY['series_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'dicom_file_type', 'pixel_data_digest', 'sop_instance_uid'], ARRAY['CPTAC Bolus September 2018'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('SubjectsWithModalityByCollectionSiteIntake', 'select
  distinct i.patient_id, modality, count(*) as num_files
from
  general_image i, trial_data_provenance tdp, general_series s
where
  s.general_series_pk_id = i.general_series_pk_id and 
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and 
  modality = ? and
  tdp.project = ? and 
  tdp.dp_site_name = ?
group by patient_id, modality
', ARRAY['modality', 'project_name', 'site_name'], 
                    ARRAY['patient_id', 'modality', 'num_files'], ARRAY['FindSubjects', 'SymLink', 'intake'], 'intake', 'Find All Subjects with given modality in Collection, Site
')
        ;

            insert into queries
            values ('ListOfAvailableQueriesForDescEdit', 'select
  name, description, query,
  array_to_string(tags, '','') as tags
from queries
order by name', '{}', 
                    ARRAY['name', 'description', 'query', 'tags'], ARRAY['AllCollections', 'q_list'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('StartRound', 'update round
  set round_start = now()
where
  round_id = ?
', ARRAY['round_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Close row in round (set end time)')
        ;

            insert into queries
            values ('PrivateTagValuesWithVrTagAndCountWhereDispositionIsNull', 'select
  distinct vr , value, element_signature, private_disposition, count(*) as num_files
from
  element_signature natural left join scan_element natural left join series_scan natural left join seen_value
where
  is_private and private_disposition is null
group by
  vr, value, element_signature, private_disposition
', '{}', 
                    ARRAY['vr', 'value', 'element_signature', 'private_disposition', 'count'], ARRAY['DispositionReport', 'NotInteractive'], 'posda_phi', 'Get the disposition of a public tag by signature
Used in DispositionReport.pl - not for interactive use
')
        ;

            insert into queries
            values ('GetPosdaPhiElementSigInfo', 'select
  element_signature,
  vr,
  is_private,
  private_disposition,
  name_chain
from element_signature

', '{}', 
                    ARRAY['element_signature', 'vr', 'is_private', 'private_disposition', 'name_chain'], ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi', 'Get the relevant features of an element_signature in posda_phi schema')
        ;

            insert into queries
            values ('GetNonDicomFileScanId', 'select
  currval(''non_dicom_file_scan_non_dicom_file_scan_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('InsertRoundCollection', 'insert into round_collection(
  round_id, collection,
  num_entered, num_failed,
  num_dups
) values (
  ?, ?,
  ?, ?,
  ?
)
', ARRAY['round_id', 'collection', 'num_entered', 'num_failed', 'num_dups'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Insert a row into round_collection')
        ;

            insert into queries
            values ('InsertIntoPublicPosdaFileComparison', 'insert into public_to_posda_file_comparison(
  compare_public_to_posda_instance_id,
  sop_instance_uid,
  posda_file_id,
  posda_file_path,
  public_file_path,
  short_report_file_id,
  long_report_file_id   
)values(
  ?, ?, ?, ?,
  ?, ?, ?
)
', ARRAY['compare_public_to_posda_instance_id', 'sop_instance_uid', 'posda_file_id', 'posda_file_path', 'public_file_path', 'short_report_file_id', 'long_report_file_id'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_files', 'Insert a column into public_to_posda_file_comparison')
        ;

            insert into queries
            values ('get_file_to_fix_ctp', 'select
  file_id, root_path || ''/'' || file_location.rel_path as file_path 
from
  file_patient  natural join
  file_import natural join
  import_event join file_location using(file_id) join file_storage_root using (file_storage_root_id)
where 
  import_time > ? and not exists
  (select file_id from ctp_file where ctp_file.file_id = file_patient.file_id)
limit ?', ARRAY['from', 'limit'], 
                    ARRAY['file_id', 'file_path'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetEquipmentSignatureId', 'select currval(''equipment_signature_equipment_signature_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'UsedInPhiSeriesScan'], 'posda_phi', 'Get current value of EquipmentSignatureId Sequence
')
        ;

            insert into queries
            values ('HowManyFilesCopiedInCopyFromPublic', 'select
  count(*) as num_copied
from file_copy_from_public
where
  copy_from_public_id = ? and
  inserted_file_id is not null', ARRAY['copy_from_public_id'], 
                    ARRAY['num_copied'], ARRAY['bills_test', 'copy_from_public'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CancelQueryByPid', 'select 
  pg_cancel_backend(?)', ARRAY['pid'], 
                    ARRAY['pg_cancel_backend'], ARRAY['AllCollections', 'postgres_stats', 'postgres_query_stats'], 'posda_backlog', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('list_of_roles', 'select
  filter_name as role
from query_tag_filter', '{}', 
                    ARRAY['role'], ARRAY['roles'], 'posda_queries', 'Show a complete list of roles
')
        ;

            insert into queries
            values ('FilesVisibilityByCollectionSitePatient', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id, file_id, visibility
from
  ctp_file natural join file_patient
where
  project_name = ? and
  site_name = ? and
  patient_id = ?
order by collection, site, patient_id

', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'visibility'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FilesWithNoCtp', 'select
  distinct file_id
from
  file_patient p
where
  not exists(
  select file_id from ctp_file c
  where c.file_id = p.file_id
)
', '{}', 
                    ARRAY['file_id'], ARRAY['adding_ctp'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('background_reports', 'select 
  background_subprocess_report_id as id, 
  button_name, operation_name, invoking_user, when_invoked, file_id, name
from background_subprocess_report natural join background_subprocess natural join subprocess_invocation where invoking_user = ?
order by when_invoked desc', ARRAY['invoking_user'], 
                    ARRAY['id', 'button_name', 'operation_name', 'invoking_user', 'when_invoked', 'file_id', 'name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'subprocess'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('InsertRoundCounts', 'insert into round_counts(
  round_id, collection,
  num_requests, priority
) values (
  ?, ?,
  ?, ?
)
', ARRAY['round_id', 'collection', 'num_requests', 'priority'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Insert a row into round_counts')
        ;

            insert into queries
            values ('ListOfAvailableQueries', 'select
  schema, name, description,
  array_to_string(tags, '','') as tags
from queries
order by name', '{}', 
                    ARRAY['schema', 'name', 'description', 'tags'], ARRAY['AllCollections', 'q_list'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('TotalsLike', 'select 
    distinct project_name, site_name, count(*) as num_subjects,
    sum(num_studies) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
from (
  select
    distinct project_name, site_name, patient_id, count(*) as num_studies,
    sum(num_series) as num_series, sum(total_files) as total_files
  from (
    select
       distinct project_name, site_name, patient_id, study_instance_uid, 
       count(*) as num_series, sum(num_files) as total_files
    from (
      select
        distinct project_name, site_name, patient_id, study_instance_uid, 
        series_instance_uid, count(*) as num_files 
      from (
        select
          distinct project_name, site_name, patient_id, study_instance_uid,
          series_instance_uid, sop_instance_uid 
        from
           ctp_file natural join file_study natural join
           file_series natural join file_sop_common natural join file_patient
         where
           project_name like ? and visibility is null
       ) as foo
       group by
         project_name, site_name, patient_id, 
         study_instance_uid, series_instance_uid
    ) as foo
    group by project_name, site_name, patient_id, study_instance_uid
  ) as foo
  group by project_name, site_name, patient_id
  order by project_name, site_name, patient_id
) as foo
group by project_name, site_name
order by project_name, site_name
', ARRAY['pattern'], 
                    ARRAY['project_name', 'site_name', 'num_subjects', 'num_studies', 'num_series', 'total_files'], '{}', 'posda_files', 'Get Posda totals for with collection matching pattern
')
        ;

            insert into queries
            values ('RoiForBySopInstanceUid', 'select 
  distinct for_uid, count(*) as num_files
from
  file_series natural join file_sop_common natural join file_for natural join ctp_file
where 
  series_instance_uid = ? and visibility is null
group by for_uid', ARRAY['series_instance_uid'], 
                    ARRAY['for_uid', 'num_files'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('WhatHasComeInRecentlyWithSubject', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
group by collection, site, subj, time order by time desc, collection, site, subj', ARRAY['interval', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('FindTagsInQuery', 'select
  tag from (
  select name, unnest(tags) as tag
  from queries) as foo
where
  name = ?', ARRAY['name'], 
                    ARRAY['tag'], ARRAY['meta', 'test', 'hello', 'query_tags'], 'posda_queries', 'Find all queries matching tag')
        ;

            insert into queries
            values ('GetPublicSopsForCompareLikeCollection', 'select
  i.patient_id,
  i.study_instance_uid,
  s.series_instance_uid,
  sop_instance_uid,
  sop_class_uid,
  s.modality,
  i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp,
  general_series s
where  
  i.trial_dp_pk_id = tdp.trial_dp_pk_id 
  and tdp.project like ?
  and i.general_series_pk_id = s.general_series_pk_id', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_uri'], ARRAY['public_posda_counts'], 'public', 'Generate a long list of all unhidden SOPs for a collection in public<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('InboxContentByActivityId', 'select
 user_name, user_inbox_content_id as id, operation_name,
  when_script_started as when, 
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  activity_inbox_content natural join user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural join subprocess_invocation
  natural left join spreadsheet_uploaded
where activity_id = ?
order by when_script_started desc', ARRAY['activity_id'], 
                    ARRAY['user_name', 'id', 'operation_name', 'when', 'file_id', 'sub_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetFileStorageRootByStorageClass', 'select
  root_path
from
  file_storage_root
where 
 storage_class = ?
  and current', ARRAY['storage_class'], 
                    ARRAY['root_path'], ARRAY['NotInteractive', 'used_in_import_edited_files', 'used_in_check_circular_view'], 'posda_files', 'Get root path for a storage_class')
        ;

            insert into queries
            values ('VisualReviewSeriesByIdProcessingStatusAndDicomFileTypeWhereReviewStatusIsNull', 'select 
  distinct image_equivalence_class_id, series_instance_uid
from
  visual_review_instance natural join image_equivalence_class natural join
  image_equivalence_class_input_image natural join dicom_file natural join 
  file_series natural join ctp_file
where
  visual_review_instance_id = ? and review_status is null and processing_status = ? and dicom_file_type = ?
', ARRAY['visual_review_instance_id', 'processing_status', 'dicom_file_type'], 
                    ARRAY['image_equivalence_class_id', 'series_instance_uid'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('GetDciodvfyUnitScanId', 'select currval(''dciodvfy_unit_scan_dciodvfy_unit_scan_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_scan_instance row')
        ;

            insert into queries
            values ('FromAndToFileIdWithVisibilityFromDigests', 'select 
(select file_id from file where digest = ?) as from_file_id,
(select file_id from file where digest = ?) as to_file_id,
(select visibility as from_file_visibility from ctp_file natural join file where digest = ?) as from_visibility,
(select visibility as from_file_visibility from ctp_file natural join file where digest = ?) as to_visibility', ARRAY['from_digest_1', 'to_digest_1', 'from_digest_2', 'to_digest_2'], 
                    ARRAY['from_file_id', 'to_file_id', 'from_visibility', 'to_visibility'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ExportFilepathAndSize', 'select 
  root_path,
  rel_path,
  size,
  digest 
from file 
  natural join file_location 
  natural join file_storage_root 
  natural join ctp_file 
where project_name = ? 
  and site_name = ? and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['root_path', 'rel_path', 'size', 'digest'], ARRAY['Universal'], 'posda_files', 'Creates an export list for importing with python_import_csv_filelist.py')
        ;

            insert into queries
            values ('FilesAndLoadTimesInSeries', 'select
  distinct sop_instance_uid, file_id, import_time
from
  file_sop_common natural join file_series
  natural join file_import natural join import_event
where
  series_instance_uid = ?
order by 
  sop_instance_uid, import_time, file_id
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'import_time', 'file_id'], ARRAY['by_series'], 'posda_files', 'List of SOPs, files, and import times in a series
')
        ;

            insert into queries
            values ('InsertDistinguishedValue', 'insert into distinguished_pixel_digest_pixel_value(
  pixel_digest, pixel_value, num_occurances
  ) values (
  ?, ?, ?
)', ARRAY['pixel_digest', 'value', 'num_occurances'], 
                    '{}', ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'insert distinguished pixel digest')
        ;

            insert into queries
            values ('GetFileCountByLikeLoadPath', 'select distinct import_event_id, count(distinct file_id)  as num_files from file_import where rel_path like ? group by import_event_id;', ARRAY['like_rel_path'], 
                    ARRAY['import_event_id', 'num_files'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('CreateConversionEvent', 'insert into conversion_event(
  time_of_conversion, who_invoked_conversion, conversion_program
) values (
  now(), ?, ?
)
', ARRAY['who_invoked_conversion', 'conversion_program'], 
                    '{}', ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSsVolumeReferencingKnownImagesByCollection', 'select 
  distinct project_name as collection, 
  site_name as site, patient_id, 
  file_id 
from 
  ctp_file natural join file_patient 
where file_id in (
   select
    distinct file_id from ss_volume v 
    join ss_for using(ss_for_id) 
    join file_structure_set using (structure_set_id) 
  where 
     exists (
       select file_id 
       from file_sop_common s 
       where s.sop_instance_uid = v.sop_instance
  )
)
and project_name = ?
and visibility is null
order by collection, site, patient_id', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('NonDicomPhiReportCsvMetaQuotesLimit', 'select 
  distinct non_dicom_file_type as type, ''<'' ||non_dicom_path || ''>'' as path,
  ''<'' || value || ''>'' as q_value, count(distinct posda_file_id) as num_files
from 
  non_dicom_path_value_occurrance natural join
  non_dicom_path_seen natural join
  value_seen natural join
  non_dicom_file_scan natural join
  phi_non_dicom_scan_instance
where 
  phi_non_dicom_scan_instance_id = ? and file_type = ''csv''
group by type, path, q_value
order by type, path, q_value
limit ?', ARRAY['scan_id', 'limit'], 
                    ARRAY['type', 'path', 'q_value', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('CountsByCollectionSiteDateRange', 'select
  distinct
    patient_id, image_type, modality, study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and visibility is null
  and import_time > ? and import_time < ?
group by
  patient_id, image_type, modality, study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['patient_id', 'image_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'for_bill_counts'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('CreateEquivalenceClass', 'insert into image_equivalence_class(
  series_instance_uid, equivalence_class_number,
  processing_status
) values (
  ?, ?, ''Preparing''
)
', ARRAY['series_instance_uid', 'equivalence_class_number'], 
                    '{}', ARRAY['consistency', 'find_series', 'equivalence_classes', 'NotInteractive'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionExceptModality', 'select distinct series_instance_uid, modality, count(*)
from (
select distinct series_instance_uid, sop_instance_uid, modality from (
select
   distinct series_instance_uid, modality, sop_instance_uid,
   file_id
 from file_series natural join file_sop_common
   natural join ctp_file
where
  project_name = ? and modality != ?
  and visibility is null)
as foo
group by series_instance_uid, sop_instance_uid, modality)
as foo
group by series_instance_uid, modality
', ARRAY['project_name', 'modality'], 
                    ARRAY['series_instance_uid', 'modality', 'count'], ARRAY['by_collection', 'find_series'], 'posda_files', 'Get Series in A Collection with modality other than specified
')
        ;

            insert into queries
            values ('GetPublicHierarchyBySopInstance', 'select
  i.patient_id, s.study_instance_uid, s.series_instance_uid, modality, sop_instance_uid
from 
  general_image i, general_series s where sop_instance_uid = ? and
  s.general_series_pk_id = i.general_series_pk_id', ARRAY['sop_instance_uid'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'modality', 'sop_instance_uid'], ARRAY['Hierarchy'], 'public', 'Get Patient, Study, Series, Modality, Sop Instance by sop_instance from public database')
        ;

            insert into queries
            values ('DatesOfUploadByCollectionSite', 'select distinct date_trunc as date, count(*) as num_uploads from (
 select 
  date_trunc(''day'', import_time),
  file_id
from file_import natural join import_event
  natural join ctp_file
where project_name = ? and site_name = ? 
) as foo
group by date
order by date
', ARRAY['collection', 'site'], 
                    ARRAY['date', 'num_uploads'], ARRAY['receive_reports'], 'posda_files', 'Show me the dates with uploads for Collection from Site
')
        ;

            insert into queries
            values ('CreateScanElement', 'insert into scan_element(
  element_signature_id, seen_value_id, series_scan_id
)values(
  ?, ?, ?)
', ARRAY['element_signature_id', 'seen_value_id', 'series_scan_id'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Create Scan Element')
        ;

            insert into queries
            values ('VisibilityChangeEventsByCollectionDateRangeForHiddenFilesWithSeries', 'select
  distinct project_name as collection, 
  site_name as site, patient_id,
  user_name, prior_visibility, new_visibility,
  date_trunc(''hour'',time_of_change) as time, 
  reason_for, series_instance_uid, count(*)
from
  file_visibility_change natural join
  ctp_file natural join 
  file_patient natural join 
  file_series
where
  project_name = ? and
  visibility is not null and
  time_of_change > ? and time_of_change < ?
group by 
  collection, site, patient_id, user_name, prior_visibility, new_visibility,
  time, reason_for, series_instance_uid
order by time, collection, site, patient_id, series_instance_uid', ARRAY['collection', 'from', 'to'], 
                    ARRAY['collection', 'site', 'patient_id', 'user_name', 'prior_visibility', 'new_visibility', 'time', 'series_instance_uid', 'reason_for', 'count'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files', 'old_hidden'], 'posda_files', 'Show Received before date by collection, site')
        ;

            insert into queries
            values ('GetFiletypes', 'select distinct file_type, count(*) as num_files from file group by file_type
 ', '{}', 
                    ARRAY['file_type', 'num_files'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('ComplexDuplicatePixelData', 'select 
  distinct project_name, site_name, patient_id, series_instance_uid, count(*)
from 
  ctp_file natural join file_patient natural join file_series 
where 
  file_id in (
    select 
      distinct file_id
    from
      file_image natural join image natural join unique_pixel_data
      natural join ctp_file
    where digest in (
      select
        distinct pixel_digest
      from (
        select
          distinct pixel_digest, count(*)
        from (
          select 
            distinct unique_pixel_data_id, pixel_digest, project_name,
            site_name, patient_id, count(*) 
          from (
            select
              distinct unique_pixel_data_id, file_id, project_name,
              site_name, patient_id, 
              unique_pixel_data.digest as pixel_digest 
            from
              image natural join file_image natural join 
              ctp_file natural join file_patient fq
              join unique_pixel_data using(unique_pixel_data_id)
            where visibility is null
          ) as foo 
          group by 
            unique_pixel_data_id, project_name, pixel_digest,
            site_name, patient_id
        ) as foo 
        group by pixel_digest
      ) as foo 
      where count = ?
    )
    and visibility is null
  ) 
group by project_name, site_name, patient_id, series_instance_uid
order by count desc;
', ARRAY['count'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'series_instance_uid', 'count'], ARRAY['pix_data_dups', 'pixel_duplicates'], 'posda_files', 'Find series with duplicate pixel count of <n>
')
        ;

            insert into queries
            values ('DicomFileSummaryByImportEvent', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id as patient,
  study_instance_uid as study,
  series_instance_uid as series,
  dicom_file_type as file_type,
  modality,
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_patient natural join
  file_study natural join
  file_series natural join
  file_sop_common natural join
  dicom_file natural left join
  ctp_file
where file_id in (
  select distinct file_id from import_event natural join file_import where import_event_id = ?
)
group by collection, site, patient, study, series, file_type, modality
order by collection, site, patient, series, file_type', ARRAY['import_event_id'], 
                    ARRAY['collection', 'site', 'patient', 'study', 'series', 'file_type', 'modality', 'num_sops', 'num_files'], ARRAY['adding_ctp', 'for_scripting'], 'posda_files', 'A summary of DICOM files in a particular upload')
        ;

            insert into queries
            values ('AddErrorToBackgroundProcess', 'update background_subprocess set
  process_error = ?
where
 subprocess_invocation_id = ?
', ARRAY['process_error', 'background_subprocess_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Add a error to a background_subprocess  row

used in a background subprocess when an error occurs')
        ;

            insert into queries
            values ('IntakeImagesByCollectionSitePlus', 'select
  p.patient_id,
  i.sop_instance_uid,
  t.study_instance_uid,
  s.series_instance_uid
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?

', ARRAY['collection', 'site'], 
                    NULL, ARRAY['intake'], 'intake', 'N
o
n
e')
        ;

            insert into queries
            values ('ActiveQueriesOld', 'select
  datname as db_name, procpid as pid,
  usesysid as user_id, usename as user,
  waiting, now() - xact_start as since_xact_start,
  now() - query_start as since_query_start,
  now() - backend_start as since_back_end_start,
  current_query
from
  pg_stat_activity
where
  datname = ?
', ARRAY['db_name'], 
                    ARRAY['db_name', 'pid', 'user_id', 'user', 'waiting', 'since_xact_start', 'since_query_start', 'since_back_end_start', 'current_query'], ARRAY['postgres_status'], 'posda_files', 'Show active queries for a database
Works for PostgreSQL 8.4.20 (Current Linux)
')
        ;

            insert into queries
            values ('DupSopsBeforeDateForHiding', 'select distinct file_id, latest from (
  select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo where latest < ?', ARRAY['collection', 'break_date'], 
                    ARRAY['file_id', 'latest'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'List of duplicate sops with file_ids and latest load date<br><br>
<bold>Warning: may generate a lot of output</bold>')
        ;

            insert into queries
            values ('GetSimpleElementSeen', 'select
  element_seen_id as id
from 
  element_seen
where
  element_sig_pattern = ? and
  vr = ?', ARRAY['element_sig_pattern', 'vr'], 
                    ARRAY['id'], ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Get an element_seen row by element, vr (if present)')
        ;

            insert into queries
            values ('PTWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''Positron Emission Tomography Image Storage'' and 
  visibility is null and
  modality != ''PT''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('AllPatientDetails', 'select
  distinct project_name as collection,
  site_name as site,
  visibility,
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series natural left join
  ctp_file
where
  project_name is null and site_name is null and visibility is null
group by
  project_name, site_name, visibility, 
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  project_name, site_name, patient_id, study_date,
  modality
', '{}', 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('SeriesWithDupSopsByCollectionSiteDateRange', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid 
      from (
        select distinct sop_instance_uid, count(distinct file_id)
        from file_sop_common natural join ctp_file
        where visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from file_sop_common natural join ctp_file
            join file_import using(file_id) 
            join import_event using(import_event_id)
          where project_name = ? and site_name = ? and
             visibility is null and import_time > ?
              and import_time < ?
        ) group by sop_instance_uid
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, study_instance_uid, series_instance_uid

', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj_id', 'num_sops', 'num_files', 'study_instance_uid', 'series_instance_uid'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FileTypeModalityCountsByImportIdWithPatId', 'select
  distinct  patient_id, dicom_file_type, modality, count(*) as num_files
from file_series natural join dicom_file natural join file_patient
where file_id in (
  select distinct file_id
  from file_import natural join import_event
  where import_event_id = ?
) and modality = ?
group by patient_id, dicom_file_type, modality', ARRAY['import_event_id', 'modality'], 
                    ARRAY['patient_id', 'dicom_file_type', 'modality', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('RoundRunningTimeCurrentRound', 'select now() - round_start as running_time from round where round_id in (
select round_id from round where round_end is null and round_start is not null)', '{}', 
                    ARRAY['running_time'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of round by id')
        ;

            insert into queries
            values ('FileSizeByPublic', 'select distinct project as collection, sum(dicom_size) as total_disc_used from general_image group by project order by total_disc_used desc', '{}', 
                    ARRAY['collection', 'total_disc_used'], ARRAY['AllCollections', 'queries'], 'public', 'Get a list of available queries')
        ;

            insert into queries
            values ('MakeEquivClassPassThrough', 'update image_equivalence_class set
  review_status = ''PassThrough'',
  processing_status = ''Reviewed''
where
  image_equivalence_class_id = ?', ARRAY['image_equivalence_class_id'], 
                    '{}', ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('ReviewSummaryForCollection', 'select 
  distinct project_name as collection,
  site_name as site,
  dicom_file_type,
  modality,
  coalesce(visibility, ''visable'') as visiblity,
  review_status,
  count(distinct series_instance_uid) as num_series 
from
  image_equivalence_class natural join file_series
  natural join ctp_file natural join dicom_file
where
  project_name = ? 
group by project_name, site, dicom_file_type, modality, visibility, review_status;', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'dicom_file_type', 'modality', 'visibility', 'review_status', 'num_series'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('VisiblePatientsWithCtp', 'select
  distinct project_name as collection, site_name as site, patient_id,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files,
  min(import_time) as first_import,
  max(import_time) as last_import
from
  file_patient sc natural join file_series
  natural join file_import natural join import_event
  natural join ctp_file
where
  visibility is null
group by collection, site, patient_id', '{}', 
                    ARRAY['patient_id', 'num_series', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'ctp_patients', 'select_for_phi'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('GetPatientMappingByCollectionSite', 'select
  from_patient_id,
  to_patient_id,
  to_patient_name,
  collection_name,
  site_name,
  batch_number,
  date_shift,
  ''<'' || diagnosis_date || ''>'' as diagnosis_date,
  ''<'' || baseline_date || ''>'' as baseline_date,
  ''<'' || date_trunc(''year'', diagnosis_date) || ''>'' as year_of_diagnosis,
  baseline_date - diagnosis_date as computed_shift
from
  patient_mapping
where collection_name = ? and site_name = ?
  ', ARRAY['collection_name', 'site_name'], 
                    ARRAY['from_patient_id', 'to_patient_id', 'to_patient_name', 'collection_name', 'site_name', 'batch_number', 'date_shift', 'diagnosis_date', 'baseline_date', 'year_of_diagnosis', 'computed_shift'], ARRAY['adding_ctp', 'for_scripting', 'patient_mapping', 'ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Retrieve entries from patient_mapping table')
        ;

            insert into queries
            values ('GetAllQualifiedCTQPByLikeCollectionWithFileCountAndLoadTimesSinceDateWithEarlier', 'select * from (select 
  collection, site, patient_id, qualified, count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) join file_import using(file_id)
  join file_sop_common using(file_id)
  join import_event using(import_event_id)
where collection like ?
group by collection, site, patient_id, qualified) as foo where latest_day >= ? and earliest_day < ?', ARRAY['collection_like', 'from', 'from_again'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'num_files', 'num_sops', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('FindPotentialDistinguishedSops', 'select 
  distinct project_name as collection,
  site_name as site, 
  patient_id, 
  image_id,
  count(*)
from
  ctp_file
  natural join file_patient
  natural join file_image
where
  file_id in 
  (select 
    distinct file_id 
  from
    file_image 
  where
    image_id in
    (select
       image_id from 
       (select
         distinct image_id, count(distinct file_id) 
       from
         file_image 
       group by image_id
       ) as foo
     where count > 1000
  )
) group by collection, site, patient_id, image_id
order by collection, site, image_id, patient_id

', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'image_id', 'count'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('GetDosesReferencingBadPlans', 'select
  sop_instance_uid
from
  file_sop_common
where file_id in (
  select 
    file_id
  from
    rt_dose d natural join file_dose  
  where
    not exists (
      select
        sop_instance_uid 
      from
        file_sop_common fsc 
      where d.rt_dose_referenced_plan_uid = fsc.sop_instance_uid
  )
)', '{}', 
                    ARRAY['sop_instance_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('RollbackPosda', 'rollback', '{}', 
                    '{}', ARRAY['NotInteractive', 'Backlog', 'Transaction'], 'posda_files', 'Abort a transaction in Posda files')
        ;

            insert into queries
            values ('AllSopsReceivedBetweenDates', 'select
   distinct project_name, site_name, patient_id,
   study_instance_uid, series_instance_uid, count(*) as num_sops,
   min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
from (
  select 
    distinct project_name, site_name, patient_id,
    study_instance_uid, series_instance_uid, sop_instance_uid,
    count(*) as num_files, sum(num_uploads) as num_uploads,
    min(first_loaded) as first_loaded, max(last_loaded) as last_loaded
  from (
    select
      distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, count(*) as num_uploads, max(import_time) as last_loaded,
         min(import_time) as first_loaded
    from (
      select
        distinct project_name, site_name, patient_id,
        study_instance_uid, series_instance_uid, sop_instance_uid,
        file_id, import_time
      from
        ctp_file natural join file_patient natural join
        file_study natural join file_series natural join
        file_sop_common natural join file_import natural join
        import_event
      where
        visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from 
            file_import natural join import_event natural join file_sop_common
          where import_time > ? and import_time < ?
        )
      ) as foo
    group by
      project_name, site_name, patient_id, study_instance_uid, 
      series_instance_uid, sop_instance_uid, file_id
  )as foo
  group by 
    project_name, site_name, patient_id, study_instance_uid, 
    series_instance_uid, sop_instance_uid
) as foo
group by 
  project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid
', ARRAY['start_time', 'end_time'], 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'num_sops', 'first_loaded', 'last_loaded'], ARRAY['receive_reports'], 'posda_files', 'Series received between dates regardless of duplicates
')
        ;

            insert into queries
            values ('CountsBySeriesInstanceUidPlusNoImageType', 'select
  distinct
    patient_id, study_date, series_instance_uid, modality,
    study_description, series_description,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_series
    where series_instance_uid  = ?
  ) and project_name = ? and visibility is null
group by
  patient_id, study_date, series_instance_uid, study_description, series_description, modality
order by
  patient_id, study_date, modality, series_description, series_instance_uid,
  study_description
', ARRAY['SeriesInstanceUid', 'collection'], 
                    ARRAY['patient_id', 'study_date', 'modality', 'series_description', 'series_date', 'study_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetPublicSopCountByPatientId', 'select
  distinct i.patient_id,
  count(distinct sop_instance_uid) as num_sops
from
  general_image i,
  trial_data_provenance tdp,
  general_series s
where  
  i.trial_dp_pk_id = tdp.trial_dp_pk_id 
  and i.patient_id = ?
  and i.general_series_pk_id = s.general_series_pk_id
group by i.patient_id', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'num_sops'], ARRAY['public_posda_counts'], 'public', 'Generate a long list of all unhidden SOPs for a collection in public<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('GoInService', 'update control_status
set status = ''service process running'',
  processor_pid = ?', ARRAY['pid'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Claim control of posda_backlog')
        ;

            insert into queries
            values ('UpdPosdaPhiSimpleEleName', 'update
  element_seen
set
  tag_name = ?,
  is_private = ?
where
  element_sig_pattern = ? and
  vr = ?

', ARRAY['name', 'is_private', 'element_signature', 'vr'], 
                    '{}', ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Update name_chain in element_seen')
        ;

            insert into queries
            values ('PatientDetails', 'select
  distinct project_name as collection,
  site_name as site,
  visibility,
  patient_id,
  patient_name,
  study_instance_uid,
  study_date,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_study natural left join
  file_series natural left join
  ctp_file
where
  patient_id = ?
group by
  project_name, site_name, visibility, 
  patient_id, patient_name, study_instance_uid, study_date,
  series_instance_uid, modality
order by 
  project_name, site_name, patient_id, study_date,
  modality
', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'patient_name', 'study_instance_uid', 'study_date', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'no_ctp_details', 'ctp_details'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('LastNPhiScans', 'select
  phi_scan_instance_id as id,
  start_time,
  end_time,
  end_time - start_time as duration,
  description,
  num_series as to_scan,
  num_series_scanned as scanned
from 
  phi_scan_instance
order by id desc
  limit ?
', ARRAY['n'], 
                    ARRAY['id', 'start_time', 'end_time', 'duration', 'description', 'to_scan', 'scanned'], ARRAY['tag_usage', 'simple_phi', 'phi_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('AddProcessCount', 'update round
  set process_count = ?
where
  round_id = ?
', ARRAY['process_count', 'round_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Set Process Count in round')
        ;

            insert into queries
            values ('CountsByCollectionDateRangePlusNoImageType', 'select
  distinct
    patient_id, study_date, series_instance_uid, modality,
    study_description, series_description,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name = ? and visibility is null
group by
  patient_id, study_date, series_instance_uid, study_description, series_description, modality
order by
  patient_id, study_date, modality, series_description, series_instance_uid,
  study_description
', ARRAY['from', 'to', 'collection'], 
                    ARRAY['patient_id', 'study_date', 'series_instance_uid', 'modality', 'study_description', 'series_description', 'num_sops', 'num_files', 'latest', 'earliest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('GetDciodvfyErrorAttrPres', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''AttributesPresentWhenConditionNotSatisfied''
  and error_tag = ?
  and error_module = ?', ARRAY['error_tag', 'error_module'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('VisibleColSiteWithCtp', 'select
  distinct project_name as collection, site_name as site,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files,
  min(import_time) as first_import,
  max(import_time) as last_import
from
  file_series
  natural join file_import natural join import_event
  natural join ctp_file
where
  visibility is null
group by collection, site', '{}', 
                    ARRAY['collection', 'site', 'num_series', 'num_files'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'ctp_col_site', 'select_for_phi'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('FileWithInfoBySopInPublic', 'select
  frame_of_reference_uid as frame_of_ref,
  image_orientation_patient as iop,
  image_position_patient as ipp,
  pixel_spacing,
  i_rows as pixel_rows,
  i_columns as pixel_columns
from
  general_image i, general_series s
where
  i.general_series_pk_id = s.general_series_pk_id and
  sop_instance_uid = ?', ARRAY['sop_instance_uid'], 
                    ARRAY['frame_of_ref', 'iop', 'ipp', 'pixel_spacing', 'pixel_rows', 'pixel_columns'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'public', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('InboxContentByDateRange', 'select
  activity_id, brief_description as activity_description,
  user_name, user_inbox_content_id, operation_name,
  when_script_started as when, 
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  activity natural join activity_inbox_content natural join user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural join subprocess_invocation
  natural left join spreadsheet_uploaded
where 
  when_script_started > ? and when_script_started < ?
order by activity_id, when_script_started', ARRAY['from', 'to'], 
                    ARRAY['activity_id', 'activity_description', 'user_name', 'user_inbox_content_id', 'operation_name', 'when', 'file_id', 'sub_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('ShowQueryTabHierarchyWithQueries', 'select 
  distinct query_tab_name, filter_name, tag, query_name
from(
  select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
) as foo
natural join(
  select
     name as query_name,
     unnest(tags) as tag
from queries
) as fie
order by 
  query_tab_name, filter_name, tag, query_name', '{}', 
                    ARRAY['query_tab_name', 'filter_name', 'tag', 'query_name'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ListOfCollectionsAndSitesLikeCollection', 'select 
    distinct project_name, site_name, count(*) 
from 
   ctp_file natural join file_study natural join
   file_series
where
  visibility is null and project_name like ?
group by project_name, site_name
order by project_name, site_name
', ARRAY['CollectionLike'], 
                    ARRAY['project_name', 'site_name', 'count'], ARRAY['AllCollections', 'universal'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('RemoveTagFromQuery', 'update queries
set tags = array_remove(tags, ?::text)
where name = ?', ARRAY['tag_name', 'query_name'], 
                    '{}', ARRAY['meta'], 'posda_queries', 'Remove a tag from a query')
        ;

            insert into queries
            values ('DeleteFirstTagFromQuery', 'update queries 
  set tags = tags[(array_lower(tags,1) + 1):(array_upper(tags,1))]
where name = ?', ARRAY['name'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tags'], 'posda_queries', 'Add a tag to a query')
        ;

            insert into queries
            values ('ValuesByVrWithTagAndCount', 'select distinct value, element_signature, private_disposition, num_files from (
  select
    distinct value, element_signature, private_disposition, vr, count(*)  as num_files
  from
    scan_event natural join series_scan natural join seen_value
    natural join element_signature natural join scan_element
  where
    scan_event_id = ? and vr = ?
  group by value, element_signature, vr
) as foo
order by value
', ARRAY['scan_id', 'vr'], 
                    ARRAY['value', 'element_signature', 'private_disposition', 'num_files'], ARRAY['tag_usage'], 'posda_phi', 'List of values seen in scan by VR (with count of elements)
')
        ;

            insert into queries
            values ('CreateNewQueryTab', 'insert into query_tabs (
  query_tab_name,
  query_tab_description, 
  defines_dropdown,
  sort_order,
  defines_search_engine)
values(
  ?, ?, true, ?, false
)', ARRAY['query_tab_name', 'query_tab_description', 'sort_order'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tabs'], 'posda_queries', 'Create a new query tab')
        ;

            insert into queries
            values ('AddHocQuery', 'select
  distinct patient_id, study_instance_uid as study_uid, series_instance_uid as series_uid,
  count(distinct file_id) as num_files
from
  file_patient natural join file_study natural join file_series natural join ctp_file
where
  patient_id in
   (''HN-CHUM-050'', ''HN-CHUM-052'', ''HN-CHUM-054'', ''HN-CHUM-056'', ''HN-CHUM-030'', ''HN-CHUM-032'')
  and visibility is null
group by patient_id, study_uid, series_uid', '{}', 
                    ARRAY['patient_id', 'study_uid', 'series_uid', 'num_files'], ARRAY['meta', 'test', 'hello', 'bills_test', 'bills_ad_hoc_scripts'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetEquivalenceClassId', 'select currval(''image_equivalence_class_image_equivalence_class_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'equivalence_classes'], 'posda_files', 'Get current value of EquivalenceClassId Sequence
')
        ;

            insert into queries
            values ('GetActivities', 'select
  activity_id, brief_description, when_created, who_created, when_closed
from activity

', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('FilesEarlierThanDateByCollectionSite', 'select 
  distinct file_id, visibility as old_visibility
from 
  ctp_file natural join file_import natural join import_event
where
  project_name = ? and site_name = ? and visibility is null
  and import_time < ?
 ', ARRAY['collection', 'site', 'before'], 
                    ARRAY['file_id', 'old_visibility'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Show Received before date by collection, site')
        ;

            insert into queries
            values ('InsertEditEventRow', 'insert into dicom_edit_event(
  edit_desc_file, time_started, edit_comment, num_files, process_id, edits_done
) values (?, now(), ?, ?, ?, 0)
', ARRAY['edit_desc_file', 'edit_comment', 'num_files', 'process_id'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Insert edit_event
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('ListClosedActivities', 'select
  activity_id,
  brief_description,
  when_created,
  who_created,
  when_closed
from
  activity 
where when_closed is not null
order by activity_id', '{}', 
                    ARRAY['activity_id', 'brief_description', 'when_created', 'who_created', 'when_closed'], ARRAY['AllCollections', 'queries', 'activities'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('GetSopListByCollectionSite', 'select 
  distinct project_name as collection, site_name as site,
  patient_id, study_instance_uid, series_instance_uid,
  sop_instance_uid
from
  ctp_file natural join file_patient natural join
  file_study natural join file_series natural join file_sop_common
where
  project_name = ? and site_name = ? and visibility is null;', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid'], ARRAY['bills_test', 'comparing_posda_to_public'], 'posda_files', 'Get a full list of sops with collection, site, patient, study_instance_uid and series_instance_uid
by collection, site

<bold>This may generate a large number of rows</bold>')
        ;

            insert into queries
            values ('GetEndOfWeek', 'select 
  date_trunc(''week'', to_timestamp(?, ''yyyy-mm-dd'') + interval ''1 week'') as end_week
 ', ARRAY['from'], 
                    ARRAY['end_week'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DupSopsWithFileIdByCollectionSiteDateRange', 'select
  distinct collection, site, subj_id, 
  sop_instance_uid,
  file_id,
  visibility
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id,
    visibility
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid 
      from (
        select distinct sop_instance_uid, count(distinct file_id)
        from file_sop_common natural join ctp_file
        where visibility is null and sop_instance_uid in (
          select distinct sop_instance_uid
          from file_sop_common natural join ctp_file
            join file_import using(file_id) 
            join import_event using(import_event_id)
          where project_name = ? and site_name = ? and
             visibility is null and import_time > ?
              and import_time < ?
        ) group by sop_instance_uid
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
order by sop_instance_uid


', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj_id', 'sop_instance_uid', 'file_id', 'visibility'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('CreateSimpleValueSeen', 'insert into value_seen(
value
)values(?)', ARRAY['value'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Create a new Simple Value Seen')
        ;

            insert into queries
            values ('GetReportOnSeriesWithNoStudy', 'select 
  distinct project_name as collection,
  site_name as site, patient_id, series_instance_uid, visibility, count(*) as num_files
from ctp_file natural join file natural join file_patient natural join file_series  where digest in (
select digest from file where file_id in (
select file_id from file_series where not exists(select file_id from file_study where file_series.file_id = file_study.file_id))) group by project_name, site_name, patient_id, series_instance_uid,visibility;', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'visibility', 'num_files'], ARRAY['posda_db_populate', 'dicom_file_type'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PixelDataIdByFileIdWithOtherFileId', 'select
  distinct f.file_id as file_id, image_id, unique_pixel_data_id, 
  l.file_id as other_file_id
from
  file_image f natural join image natural join unique_pixel_data
  join pixel_location l using(unique_pixel_data_id)
where
  f.file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_id', 'image_id', 'unique_pixel_data_id', 'other_file_id'], ARRAY['by_file_id', 'duplicates', 'pixel_data_id', 'posda_files'], 'posda_files', 'Get unique_pixel_data_id for file_id 
')
        ;

            insert into queries
            values ('CreateBackgroundSubprocess', 'insert into background_subprocess(
  subprocess_invocation_id,
  command_executed,
  foreground_pid,
  when_script_started,
  user_to_notify
) values (
  ?, ?, ?, now(), ?
)
returning background_subprocess_id', ARRAY['subprocess_invocation_id', 'command_executed', 'foreground_pid', 'user_to_notify'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create row in background_subprocess table

Used by background subprocess')
        ;

            insert into queries
            values ('GetFileHierarchyByCollection', 'select 
  distinct root_path || ''/'' || rel_path as path,
  patient_id,
  study_instance_uid,
  series_instance_uid,
  file_id 
from 
  ctp_file natural join
  file_patient natural join
  file_study natural join
  file_series natural join
  file_location natural join
  file_storage_root
where
  project_name = ?
  and visibility is null', ARRAY['collection'], 
                    ARRAY['path', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'file_id'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get root_path for a file_storage_root
')
        ;

            insert into queries
            values ('SeriesLike', 'select
   distinct collection, site, pat_id,
   series_instance_uid, series_description, count(*)
from (
  select
   distinct
     project_name as collection, site_name as site,
     file_id, series_instance_uid, patient_id as pat_id,
     series_description
  from
     ctp_file natural join file_series natural join file_patient
  where
     project_name = ? and site_name = ? and 
     series_description like ?
) as foo
group by collection, site, pat_id, series_instance_uid, series_description
order by collection, site, pat_id
', ARRAY['collection', 'site', 'description_matching'], 
                    ARRAY['collection', 'site', 'pat_id', 'series_instance_uid', 'series_description', 'count'], ARRAY['find_series', 'pattern', 'posda_files'], 'posda_files', 'Select series not matching pattern
')
        ;

            insert into queries
            values ('NonDicomPhiReportCsvMetaQuotes', 'select 
  distinct non_dicom_file_type as type, ''<'' ||non_dicom_path || ''>'' as path,
  ''<'' || value || ''>'' as q_value, count(distinct posda_file_id) as num_files
from 
  non_dicom_path_value_occurrance natural join
  non_dicom_path_seen natural join
  value_seen natural join
  non_dicom_file_scan natural join
  phi_non_dicom_scan_instance
where 
  phi_non_dicom_scan_instance_id = ? and file_type = ''csv''
group by type, path, q_value
order by type, path, q_value
', ARRAY['scan_id'], 
                    ARRAY['type', 'path', 'q_value', 'num_files'], ARRAY['adding_ctp', 'for_scripting', 'non_dicom_phi', 'non_dicom_edit'], 'posda_phi_simple', 'Simple Phi Report with Meta Quotes')
        ;

            insert into queries
            values ('GetValuesForTag', 'select
  distinct element_signature as tag, value
from
  scan_element natural join series_scan natural join
  seen_value natural join element_signature
where element_signature = ? and scan_event_id = ?
', ARRAY['tag', 'scan_id'], 
                    ARRAY['tag', 'value'], ARRAY['tag_values'], 'posda_phi', 'Find Values for a given tag for all scanned series in a phi scan instance
')
        ;

            insert into queries
            values ('DatabaseSize', 'SELECT d.datname AS Name,  pg_catalog.pg_get_userbyid(d.datdba) AS Owner,
    CASE WHEN pg_catalog.has_database_privilege(d.datname, ''CONNECT'')
        THEN pg_catalog.pg_size_pretty(pg_catalog.pg_database_size(d.datname))
        ELSE ''No Access''
    END AS SIZE
FROM pg_catalog.pg_database d
    ORDER BY
    CASE WHEN pg_catalog.has_database_privilege(d.datname, ''CONNECT'')
        THEN pg_catalog.pg_database_size(d.datname)
        ELSE NULL
    END DESC -- nulls first
    LIMIT 20;
', '{}', 
                    ARRAY['Name', 'Owner', 'Size'], ARRAY['postgres_status'], 'posda_files', 'Show active queries for a database
Works for PostgreSQL 9.4.5 (Current Mac)
')
        ;

            insert into queries
            values ('GetSsVolumeReferencingUnknownImages', 'select 
  project_name as collection, 
  site_name as site, patient_id, 
  file_id 
from 
  ctp_file natural join file_patient 
where file_id in (
   select
    distinct file_id from ss_volume v 
    join ss_for using(ss_for_id) 
    join file_structure_set using (structure_set_id) 
  where 
     not exists (
       select file_id 
       from file_sop_common s 
       where s.sop_instance_uid = v.sop_instance
  )
)
order by collection, site, patient_id', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetFullCopyFromPublicInfo', 'select 
  copy_from_public_id as id, who, why, 
  num_file_rows_populated as num_files, 
  (
    select count(*) as num_waiting 
    from file_copy_from_public fc 
    where fc.copy_from_public_id = copy_from_public.copy_from_public_id and 
       not exists
       (
         select file_id from ctp_file where ctp_file.file_id = fc.replace_file_id and visibility is not null
       )
  ),
  (
    select count(*) as num_copied
    from file_copy_from_public fc
    where fc.copy_from_public_id = copy_from_public.copy_from_public_id and
    fc.inserted_file_id is not null
  )
from
  copy_from_public 
where copy_from_public_id = ?', ARRAY['copy_from_public_id'], 
                    ARRAY['id', 'who', 'why', 'num_files', 'num_waiting', 'num_copied'], ARRAY['bills_test', 'copy_from_public', 'public_posda_consistency'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('PlanSopToForByCollectionSite', 'select 
  distinct patient_id,  sop_instance_uid, 
  for_uid
from 
  file_for natural join file_plan join file_sop_common using(file_id) join file_patient using (file_id)
where
  file_id in (
    select file_id 
    from ctp_file natural join file_plan 
    where project_name = ? and site_name = ? and visibility is null
  )
order by patient_id', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'sop_instance_uid', 'for_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('CountsByCollectionLike', 'select
  distinct
    project_name as collection, site_name as site,
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
  ) and project_name like ? and visibility is null
group by
  collection, site, patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  collection, site, patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection like pattern
')
        ;

            insert into queries
            values ('WhatHasComeInRecentlyByCollectionLike', 'select
  distinct collection, site, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
and collection like ?
group by collection, site, time order by time desc, collection, site', ARRAY['interval', 'from', 'to', 'collection_like'], 
                    ARRAY['collection', 'site', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('SeriesWithMultipleDupSopsByCollectionSite', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(*) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 2
    )
    and visibility is null
  ) as foo
group by collection, site, subj_id, study_instance_uid, series_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'num_sops', 'num_files', 'study_instance_uid', 'series_instance_uid'], ARRAY['duplicates'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FindDuplicatedPixelDigestsNew', 'select
  distinct pixel_digest, num_files
from (
  select
    distinct pixel_data_digest as pixel_digest, count(distinct file_id) as num_files
  from
    dicom_file
  where 
    has_pixel_data
    group by pixel_data_digest
) as foo 
where num_files > 3
order by num_files desc', '{}', 
                    ARRAY['pixel_digest', 'num_files'], ARRAY['meta', 'test', 'hello'], 'posda_files', 'Find Duplicated Pixel Digest')
        ;

            insert into queries
            values ('ForConstructingSeriesEquivalenceClasses', 'select distinct 
 series_instance_uid, modality, series_number, laterality, series_date, dicom_file_type,
  performing_phys, protocol_name, series_description,
  operators_name, body_part_examined, patient_position,
  smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
  performed_procedure_step_start_date,
  performed_procedure_step_desc, performed_procedure_step_comments, image_type,
  iop, pixel_rows, pixel_columns,
  file_id,ipp
from
  file_series natural join ctp_file natural join dicom_file
  left join file_image using(file_id)
  left join image using (image_id)
  left join file_image_geometry using (file_id)
  left join image_geometry using (image_geometry_id)
where series_instance_uid = ? and visibility is null
 


', ARRAY['series_instance_uid'], 
                    ARRAY['series_instance_uid', 'modality', 'series_number', 'laterality', 'series_date', 'dicom_file_type', 'performing_phys', 'protocol_name', 'series_description', 'operators_name', 'body_part_examined', 'patient_position', 'smallest_pixel_value', 'largest_pixel_value', 'performed_procedure_step_id', 'performed_procedure_step_start_date', 'performed_procedure_step_desc', 'performed_procedure_step_comments', 'image_type', 'iop', 'pixel_rows', 'pixel_columns', 'file_id', 'ipp'], ARRAY['consistency', 'find_series', 'equivalence_classes'], 'posda_files', 'For building series equivalence classes')
        ;

            insert into queries
            values ('PublicPatientsByCollectionSite', 'select
  distinct p.patient_id as PID, count(distinct i.image_pk_id) as num_images
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
group by PID
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'num_images'], ARRAY['public'], 'public', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('RTPLANWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''RT Plan Storage'' and 
  visibility is null and
  modality != ''RTPLAN''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('DistinguishedDigests', 'select
   pixel_digest as distinguished_pixel_digest,
   type_of_pixel_data,
   sample_per_pixel,
   number_of_frames,
   pixel_rows,
   pixel_columns,
   bits_stored,
   bits_allocated,
   high_bit,
   pixel_mask,
   num_distinct_pixel_values,
   pixel_value,
   num_occurances
from 
  distinguished_pixel_digests natural join
  distinguished_pixel_digest_pixel_value', '{}', 
                    ARRAY['distinguished_pixel_digest', 'type_of_pixel_data', 'sample_per_pixel', 'number_of_frames', 'pixel_rows', 'pixel_columns', 'bits_stored', 'bits_allocated', 'high_bit', 'pixel_mask', 'num_distinct_values', 'pixel_value', 'num_occurances'], ARRAY['duplicates', 'distinguished_digest'], 'posda_files', 'show series with distinguished digests and counts')
        ;

            insert into queries
            values ('GetDciodvfyErrorCantBeNegative', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''CantBeNegative''
  and error_tag = ?
  and error_value = ?
', ARRAY['error_tag', 'error_value'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_tag where error_type = ''CantBeNegative''')
        ;

            insert into queries
            values ('DicomFileTypesNotProcessed', 'select 
  distinct dicom_file_type, count(distinct file_id)
from
  dicom_file d natural join ctp_file
where
  visibility is null  and
  not exists (
    select file_id 
    from file_series s
    where s.file_id = d.file_id
  )
group by dicom_file_type', '{}', 
                    ARRAY['dicom_file_type', 'count'], ARRAY['dicom_file_type'], 'posda_files', 'List of Distinct Dicom File Types which have unprocessed DICOM files
')
        ;

            insert into queries
            values ('ManifestsByFileId', 'select
  cm_collection,
  cm_site,
  cm_patient_id,
  cm_study_date,
  cm_series_instance_uid,
  cm_study_description,
  cm_series_description,
  cm_modality,
  cm_num_files
from
  ctp_manifest_row
where
  file_id = ?
order by 
  cm_index', ARRAY['file_id'], 
                    ARRAY['cm_collection', 'cm_site', 'cm_patient_id', 'cm_study_date', 'cm_series_instance_uid', 'cm_study_description', 'cm_series_description', 'cm_modality', 'cm_num_files'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Get a manifest from database

')
        ;

            insert into queries
            values ('GetMatchingRootID', 'select file_storage_root_id from file_storage_root where root_path = ?', ARRAY['root_path'], 
                    ARRAY['file_storage_root_id'], ARRAY['Universal'], 'posda_files', 'Checks for the local environment''s ID for a certain root path. Used by python_import_csv_filelist.py to insert file info into local development environments for files physically stored and referenced in internal posda production. 

(import list will have the root path for a file in prod, this will find the local id for that path)')
        ;

            insert into queries
            values ('GetNonDicomFilesByCollectionWithPath', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized, rel_path
from
  non_dicom_file natural join file_import
where
  collection = ? and
  visibility is null
', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized', 'rel_path'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('IntakeImagesByCollectionSite', 'select
  p.patient_id as PID,
  s.modality as Modality,
  i.sop_instance_uid as SopInstance,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as SeriesInstanceUID,
  q.manufacturer as Mfr,
  q.manufacturer_model_name as Model,
  q.software_versions
from
  general_image i,
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  i.general_series_pk_id = s.general_series_pk_id and
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
', ARRAY['collection', 'site'], 
                    ARRAY['PID', 'Modality', 'SopInstance', 'ImageType', 'StudyDate', 'StudyDescription', 'SeriesDescription', 'SeriesNumber', 'StudyInstanceUID', 'SeriesInstanceUID', 'Mfr', 'Model', 'software_versions'], ARRAY['intake'], 'intake', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('GetSeriesWithSignatureByCollectionSite', 'select distinct
  series_instance_uid, dicom_file_type, 
  modality|| '':'' || coalesce(manufacturer, ''<undef>'') || '':'' 
  || coalesce(manuf_model_name, ''<undef>'') ||
  '':'' || coalesce(software_versions, ''<undef>'') as signature,
  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from
  file_series natural join file_equipment natural join ctp_file
  natural join dicom_file
where project_name = ? and site_name = ? and visibility is null
group by series_instance_uid, dicom_file_type, signature
', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'signature', 'num_series', 'num_files'], ARRAY['signature', 'phi_review'], 'posda_files', 'Get a list of Series with Signatures by Collection
')
        ;

            insert into queries
            values ('AllVisibleSubjects', 'select
  distinct patient_id,
  patient_import_status as status,
  project_name, site_name,
  count(*) as num_files
from
  file_patient natural join ctp_file natural join patient_import_status
where
  patient_id in (
    select patient_id 
    from
      file_patient natural join ctp_file 
    where
      visibility is null
  ) and
  visibility is null
group by patient_id, status, project_name, site_name
order by project_name, status, site_name, patient_id;
', '{}', 
                    ARRAY['patient_id', 'status', 'project_name', 'site_name', 'num_files'], ARRAY['FindSubjects', 'PatientStatus'], 'posda_files', 'Find All Subjects which have at least one visible file
')
        ;

            insert into queries
            values ('SafeToHideDupSopsBeforeDate', 'select distinct sop_instance_uid from (
  select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo where latest < ?
except
select distinct sop_instance_uid from (
  select
    distinct sop_instance_uid, file_id, max(import_time) latest
  from file_location join file_import using(file_id) join import_event using (import_event_id)  
    join file_sop_common using(file_id) join ctp_file using (file_id)
  where sop_instance_uid in (
    select distinct sop_instance_uid from (
      select distinct sop_instance_uid, count(distinct file_id)
      from file_sop_common natural join ctp_file
      where project_name = ? and visibility is null group by sop_instance_uid
      ) as foo
    where count > 1
    ) and visibility is null
  group by sop_instance_uid, file_id
) as foo where latest >= ?', ARRAY['collection', 'break_date', 'collection_1', 'break_date_1'], 
                    ARRAY['collection'], ARRAY['meta', 'test', 'hello', 'bills_test'], 'posda_files', 'List of duplicate sops with file_ids and latest load date<br><br>
<bold>Warning: may generate a lot of output</bold>')
        ;

            insert into queries
            values ('UpdateNonDicomEditCompareDisposition', 'update non_dicom_edit_compare_disposition set
  num_edits_scheduled = ?,
  num_compares_with_diffs = ?,
  num_compares_without_diffs = ?,
  current_disposition = ''Comparisons In Progress'',
  last_updated = now()
where
  subprocess_invocation_id = ?
', ARRAY['number_edits_scheduled', 'number_compares_with_diffs', 'number_compares_without_diffs', 'subprocess_invocation_id'], 
                    '{}', ARRAY['adding_ctp', 'for_scripting', 'non_dicom_edit'], 'posda_files', 'Update an entry in dicom_edit_compare_disposition

From script only.  Don''t run from user interface (needs valid subprocess_invocation_id)')
        ;

            insert into queries
            values ('GetDciodvfyErrorUnrecog', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''UnrecognizedEnumeratedValue''
  and error_value = ?
  and error_tag = ?
  and error_index = ?', ARRAY['error_value', 'error_tag', 'error_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('DispositonsNeededSimple', 'select 
  distinct 
  element_seen_id as id, 
  element_sig_pattern,
  vr,
  tag_name,
  value
from
  element_seen
  natural join element_value_occurance
  natural join value_seen
where
  is_private and 
  private_disposition is null
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name', 'value'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('BackgroundProcessStatsWithInvoker', 'select
  distinct command_executed, invoking_user as invoker, 
  max(when_script_ended - when_script_started) as longest,
  min(when_script_ended - when_script_started) as shortest,
  avg(when_script_ended - when_script_started) as avg, count(*) as times_invoked,
  min(when_script_started) as first, max(when_script_started) as last
from
  background_subprocess natural join subprocess_invocation
where
  when_script_ended is not null
group by command_executed, invoker', '{}', 
                    ARRAY['command_executed', 'invoker', 'longest', 'shortest', 'avg', 'times_invoked', 'first', 'last'], ARRAY['invoking_user'], 'posda_files', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('AllProcessedManifestsBySite', 'select
  distinct file_id, cm_collection, cm_site,  sum(cm_num_files) as total_files
from
  ctp_manifest_row
where
  cm_site = ?
group by file_id, cm_collection, cm_site', ARRAY['site'], 
                    ARRAY['file_id', 'cm_collection', 'cm_site', 'total_files'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ListOfAvailableQueriesByTag', 'select tag, name, description from (
  select
    unnest(tags) as tag,
    name, description
  from queries
) as foo
where tag = ?
order by name', ARRAY['tag'], 
                    ARRAY['tag', 'name', 'description'], ARRAY['AllCollections', 'q_list'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('CloseActivity', 'update activity set
  when_closed = now()
where
  activity_id = ?', ARRAY['activity_id'], 
                    '{}', ARRAY['activity_timepoint_support', 'activity_support'], 'posda_queries', 'Close an activity

')
        ;

            insert into queries
            values ('RTSTRUCTWithBadModality', 'select distinct
  project_name as collection,
  site_name as site, 
  patient_id,
  series_instance_uid,
  modality,
  dicom_file_type,
  count(distinct file_id) as num_files
from
  file_series natural join ctp_file natural join file_patient
  natural join dicom_file
where 
  dicom_file_type = ''RT Structure Set Storage'' and 
  visibility is null and
  modality != ''RTSTRUCT''
group by
  collection, site, patient_id, series_instance_uid, modality, dicom_file_type
order by
  collection, site, patient_id
', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'modality', 'dicom_file_type', 'num_files'], ARRAY['by_series', 'consistency', 'for_bill_series_consistency'], 'posda_files', 'Check a Series for Consistency
')
        ;

            insert into queries
            values ('ListSrPublic', 'select 
  tdp.project as collection, dp_site_name as site, i.patient_id, dicom_file_uri 
from
  general_image i, general_series s, trial_data_provenance tdp
where
  tdp.trial_dp_pk_id = i.trial_dp_pk_id and s.modality = ''SR'' and s.general_series_pk_id = i.general_series_pk_id
  and tdp.project like ?', ARRAY['collection_like'], 
                    ARRAY['collection', 'site', 'patient_id', 'dicom_file_uri'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test', 'view_structured_reports'], 'public', 'Add a filter to a tab')
        ;

            insert into queries
            values ('ListOfAvailableQueriesByTagLike', 'select distinct name, description, tags from (
  select
    unnest(tags) as tag,
    name, description,
    array_to_string(tags, '','') as tags
  from queries
) as foo
where tag like ?
order by name', ARRAY['tag'], 
                    ARRAY['name', 'description', 'tags'], ARRAY['AllCollections', 'q_list'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('ListOfPublicElementsWithDispositionsBySopClassName', 'select
  element_signature, vr , disposition, name_chain
from
  element_signature natural join public_disposition
where
  sop_class_uid = ? and name = ?
order by element_signature
', ARRAY['sop_class_uid', 'name'], 
                    ARRAY['element_signature', 'vr', 'disposition', 'name_chain'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Public Disposition of element by sig and VR for SOP Class and name')
        ;

            insert into queries
            values ('PrependTagToQuery', 'update queries
set tags = array_prepend(?, tags)
where name = ?', ARRAY['tag', 'name'], 
                    '{}', ARRAY['meta', 'test', 'hello', 'query_tags'], 'posda_queries', 'Add a tag to a query')
        ;

            insert into queries
            values ('VisualReviewStatusById', 'select
  distinct visual_review_instance_id as id, processing_status, review_status, dicom_file_type,
  count(distinct image_equivalence_class_id) as num_equiv, 
  count(distinct series_instance_uid) as num_series
from
  image_equivalence_class natural join image_equivalence_class_input_image 
  natural join dicom_file natural join ctp_file
where
  visual_review_instance_id = ?
group by id, processing_status, review_status, dicom_file_type', ARRAY['id'], 
                    ARRAY['id', 'processing_status', 'review_status', 'dicom_file_type', 'num_equiv', 'num_series'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_reports', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('SubjectsWithDupSopsWithConflictingPixels', 'select 
  distinct project_name, site_name, patient_id, count(distinct file_id)
from
  ctp_file natural join file_sop_common natural join file_patient
where sop_instance_uid in (
  select distinct sop_instance_uid
  from (
    select
      distinct sop_instance_uid, count(*)
    from (
      select
        sop_instance_uid, unique_pixel_data.digest as pixel_digest
      from
        file_sop_common natural join file natural join file_image join
        image using (image_id) join unique_pixel_data using (unique_pixel_data_id)
    )as foo group by sop_instance_uid
  ) as foo where count > 1
)
group by
  project_name, site_name, patient_id
order by 
  project_name, site_name, patient_id, count desc
  ', '{}', 
                    ARRAY['project_name', 'site_name', 'patient_id', 'count'], ARRAY['pix_data_dups'], 'posda_files', 'Find list of series with SOP with duplicate pixel data')
        ;

            insert into queries
            values ('ShowQueryTabHierarchyByTab', 'select 
     query_tab_name,
      filter_name,
      unnest(tags_enabled) as tag
  from
    query_tabs join query_tabs_query_tag_filter using(query_tab_name)
    natural join query_tag_filter
  where query_tab_name = ?
', ARRAY['query_tab_name'], 
                    ARRAY['query_tab_name', 'filter_name', 'tag'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_queries', 'Add a filter to a tab')
        ;

            insert into queries
            values ('DoesDoseReferenceBadPlan', 'select
  distinct project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  file_id
from
  file_series natural join
  file_patient natural join ctp_file
where
  project_name = ? and
  visibility is null and
  file_id in (
select file_id from rt_dose d natural join file_dose  where
not exists (select sop_instance_uid from file_sop_common fsc where d.rt_dose_referenced_plan_uid
= fsc.sop_instance_uid))', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'file_id'], ARRAY['LinkageChecks', 'used_in_dose_linkage_check'], 'posda_files', 'Get list of RTDOSE which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetPosdaSopsForCompareLikeCollectionForSite', 'select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name like ? and site_name = ?
  and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'file_path', 'file_id'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('SimplePhiReportByScanVrScreenDeletedPT', 'select 
  distinct element_sig_pattern as element, vr, value, 
  tag_name as description, 
  private_disposition as disposition, count(*) as num_series
from element_value_occurance natural join element_seen natural join value_seen
where 
  phi_scan_instance_id = ? and vr = ? and
  private_disposition in (''k'', ''oi'', ''h'', ''o'', null)
group by element_sig_pattern, vr, value, tag_name, private_disposition', ARRAY['scan_id', 'vr'], 
                    ARRAY['element', 'vr', 'value', 'description', 'disposition', 'num_series'], ARRAY['tag_usage', 'simple_phi'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('GetPublicSopsForCompareByPatientId', 'select
  distinct i.patient_id,
  i.study_instance_uid,
  s.series_instance_uid,
  sop_instance_uid,
  sop_class_uid,
  s.modality,
  count(*) as num_files
from
  general_image i,
  trial_data_provenance tdp,
  general_series s
where  
  i.trial_dp_pk_id = tdp.trial_dp_pk_id 
  and i.general_series_pk_id = s.general_series_pk_id
  and i.patient_id = ?', ARRAY['patient_id'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'num_files'], ARRAY['public_posda_counts'], 'public', 'Generate a long list of all unhidden SOPs for a collection in public<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('InboxContentAllByUserToDismiss', 'select
 user_name, user_inbox_content_id as id, operation_name,
  current_status,
  activity_id, brief_description,
  when_script_started as when, 
  file_id, subprocess_invocation_id as sub_id,
  command_line,
  file_id_in_posda as spreadsheet_file_id
from 
  user_inbox natural join
  user_inbox_content natural join background_subprocess_report
  natural join background_subprocess natural left join subprocess_invocation
  natural left join spreadsheet_uploaded
  natural left join activity_inbox_content natural left join
  activity
where user_name = ? and activity_id is null and current_status != ''dismissed''
order by user_inbox_content_id desc', ARRAY['user_name'], 
                    ARRAY['user_name', 'id', 'operation_name', 'current_status', 'activity_id', 'brief_description', 'when', 'file_id', 'command_line', 'spreadsheet_file_id'], ARRAY['AllCollections', 'queries', 'activity_support'], 'posda_queries', 'Get a list of available queries')
        ;

            insert into queries
            values ('InsertCollectionCountPerRound', 'insert into collection_count_per_round(
  collection, file_count
) values (
  ?, ?
)
', ARRAY['collection', 'num_files'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Insert a row into collection count per round')
        ;

            insert into queries
            values ('DistinctSopsInSeriesForComparePublic', 'select 
  sop_instance_uid, sop_class_uid, i.patient_id, modality
from
  general_image i, general_series s
where
  s.series_instance_uid = i.series_instance_uid and s.series_instance_uid = ?', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'sop_class_uid', 'modality', 'count'], ARRAY['compare_series'], 'public', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('DoseSopToForByCollectionSite', 'select 
  distinct patient_id,  sop_instance_uid, 
  for_uid
from 
  file_for natural join file_dose join file_sop_common using(file_id) join file_patient using (file_id)
where
  file_id in (
    select file_id 
    from ctp_file natural join file_dose 
    where project_name = ? and site_name = ? and visibility is null
  )
order by patient_id', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'sop_instance_uid', 'for_uid'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dose_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('GetFilePathAndModality', 'select
  root_path || ''/'' || rel_path as path, modality
from
  file_location natural join file_storage_root join file_series using(file_id)
where
  file_id = ?', ARRAY['file_id'], 
                    ARRAY['path', 'modality'], ARRAY['AllCollections', 'universal', 'public_posda_consistency'], 'posda_files', 'Get path to file by id')
        ;

            insert into queries
            values ('GetCollectionSitePatientStudyDateFileCountMaxMinLoadDateForPatientsByDateRange', 'select * from (select 
  collection, site, patient_id, qualified, study_date,
  count(distinct file_id) as num_files, count (distinct sop_instance_uid) as num_sops,
  min(date_trunc(''day'',import_time)) as earliest_day, max(date_trunc(''day'', import_time)) as latest_day
from
  clinical_trial_qualified_patient_id join file_patient using (patient_id) 
  join file_study using(file_id) join file_import using(file_id)
  join file_sop_common using(file_id)
  join import_event using(import_event_id)
where patient_id in (
  select 
    distinct patient_id
  from
    clinical_trial_qualified_patient_id join file_patient using (patient_id) 
    join file_import using(file_id)
    join import_event using(import_event_id)
  where 
    collection like ? and import_time > ? and import_time < ? and import_type not like ''script%''
)
group by collection, site, patient_id, qualified, study_date) as foo
where earliest_day < ?', ARRAY['collection_like', 'from', 'to', 'to_again'], 
                    ARRAY['collection', 'site', 'patient_id', 'qualified', 'study_date', 'num_files', 'num_sops', 'earliest_day', 'latest_day'], ARRAY['clin_qual'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('RoundSummary1VeryRecent', 'select
  distinct round_id,
  round_start, 
  round_end - round_start as duration, 
  round_end, 
  sum(num_entered + num_dups),
  ((round_end - round_start) / sum(num_entered + num_dups)) as sec_per_file
from
  round natural join round_collection
where
  round_end is not null and (now() - round_end) < ''1:00''
group by 
  round_id, round_start, duration, round_end 
order by round_id', '{}', 
                    ARRAY['round_id', 'round_start', 'duration', 'round_end', 'sum', 'sec_per_file'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('UnHideFilesCSP', 'update ctp_file set visibility = null where file_id in (
  select
    distinct file_id
  from
    ctp_file natural join file_patient
  where
    project_name = ? and site_name = ?
    and visibility = ''hidden'' and patient_id = ?
);
', ARRAY['collection', 'site', 'subject'], 
                    NULL, '{}', 'posda_files', 'UnHide all files hidden by Collection, Site, Subject
')
        ;

            insert into queries
            values ('FindUnpopulatedPets', 'select
  file_id, root_path || ''/'' || rel_path as file_path
from file_location natural join file_storage_root
where file_id in
(
  select distinct file_id from dicom_file df
  where dicom_file_type = ''Positron Emission Tomography Image Storage''
  and not exists (select file_id from file_pt_image pti where pti.file_id = df.file_id)
)', '{}', 
                    ARRAY['file_id', 'file_path'], ARRAY['populate_posda_files', 'bills_test'], 'posda_files', 'Get''s all files which are PET''s which haven''t been imported into file_pt_image yet.

<bold>Don''t run interactively</bold>')
        ;

            insert into queries
            values ('GetAdverseFileEventsByEditEventId', 'select
  adverse_file_event_id,
  file_id,
  event_description,
  when_occured
from
  adverse_file_event natural join
  dicom_edit_event_adverse_file_event
where
  dicom_edit_event_id = ?', ARRAY['dicom_edit_event_id'], 
                    ARRAY['adverse_file_event_id', 'file_id', 'event_description', 'when_occured'], ARRAY['NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Get List of Adverse File Events for a given dicom_edit_event
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('UpdCTQP', 'update clinical_trial_qualified_patient_id
  set qualified = ?
where
  collection = ? and site = ? and patient_id = ?
 ', ARRAY['qualified', 'collection', 'site', 'patient_id'], 
                    '{}', ARRAY['activity_timepoint_support'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ShowAllHideEventsByCollectionSiteModality', 'select
  file_id,
  user_name,
  time_of_change,
  prior_visibility,
  new_visibility,
  reason_for
from
   file_visibility_change 
where file_id in (
  select file_id 
  from ctp_file natural join file_series
  where project_name = ? and site_name = ? and
  modality = ?
)', ARRAY['collection', 'site', 'modality'], 
                    ARRAY['file_id', 'user_name', 'time_of_change', 'prior_visibility', 'new_visibility', 'reason_for'], ARRAY['old_hidden'], 'posda_files', 'Show All Hide Events by Collection, Site')
        ;

            insert into queries
            values ('SeriesInCollectionSiteForApplicationOfPrivateDisposition', 'select
  distinct 
  patient_id, study_instance_uid, series_instance_uid
from
  file_patient natural join ctp_file natural join file_study 
  natural join file_sop_common natural join file_series
where
  collection = ? and site = ? and visibility is null
', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['by_collection_site', 'find_files'], 'posda_files', 'Get a patient, study, series hierarchy by collection, site')
        ;

            insert into queries
            values ('DismissInboxContentItem', 'update user_inbox_content
set date_dismissed = now(),
current_status = ''dismissed''
where user_inbox_content_id = ?

', ARRAY['user_inbox_content_id'], 
                    '{}', '{}', 'posda_queries', 'Set the date_dismissed value on an Inbox item')
        ;

            insert into queries
            values ('FindInconsistentSeries', 'select series_instance_uid from (
select distinct series_instance_uid, count(*) from (
  select distinct
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments,
    count(*)
  from
    file_series natural join ctp_file
  where
    project_name = ? and visibility is null
  group by
    series_instance_uid, modality, series_number, laterality, series_date,
    series_time, performing_phys, protocol_name, series_description,
    operators_name, body_part_examined, patient_position,
    smallest_pixel_value, largest_pixel_value, performed_procedure_step_id,
    performed_procedure_step_start_date, performed_procedure_step_start_time,
    performed_procedure_step_desc, performed_procedure_step_comments
) as foo
group by series_instance_uid
) as foo
where count > 1
', ARRAY['collection'], 
                    ARRAY['series_instance_uid'], ARRAY['consistency', 'find_series', 'for_bill_series_consistency'], 'posda_files', 'Find Inconsistent Series
')
        ;

            insert into queries
            values ('PrivateTagsByEquipment', 'select distinct element_signature from (
select
  distinct element_signature, equipment_signature
from 
  equipment_signature natural join series_scan
  natural join scan_element natural join element_signature
  natural join scan_event
where scan_event_id = ? and is_private ) as foo
where equipment_signature = ?
order by element_signature;
', ARRAY['scan_id', 'equipment_signature'], 
                    ARRAY['element_signature'], ARRAY['tag_usage'], 'posda_phi', 'Which equipment signatures for which private tags
')
        ;

            insert into queries
            values ('FirstFileInSeriesIntake', 'select
  dicom_file_uri as path
from
  general_image
where
  series_instance_uid =  ?
limit 1
', ARRAY['series_instance_uid'], 
                    ARRAY['path'], ARRAY['by_series', 'intake', 'UsedInPhiSeriesScan'], 'intake', 'First files in series in Intake
')
        ;

            insert into queries
            values ('DistinctSopsInCollectionIntakeWithFile', 'select
  distinct i.sop_instance_uid, i.dicom_file_uri
from
  general_image i,
  trial_data_provenance tdp
where
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
order by sop_instance_uid
', ARRAY['collection'], 
                    ARRAY['sop_instance_uid', 'dicom_file_uri'], ARRAY['by_collection', 'files', 'intake', 'sops'], 'intake', 'Get Distinct SOPs in Collection with number files
Only visible files
')
        ;

            insert into queries
            values ('CreateSimplePhiScanRow', 'insert into phi_scan_instance(
description, num_series, start_time, num_series_scanned,file_query
)values(?, ?,now(), 0,?)', ARRAY['description', 'num_series', 'file_query'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Create a new Simple PHI scan')
        ;

            insert into queries
            values ('CreateDicomFileEditRow', 'insert into dicom_file_edit(
  dicom_edit_event_id, from_file_digest, to_file_digest
) values (?, ?, ?)
', ARRAY['dicom_edit_event_id', 'from_file_digest', 'to_file_digest'], 
                    '{}', ARRAY['Insert', 'NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Insert dicom_edit_event row
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('Series In Public By PatientId', 'select 
  distinct series_instance_uid
from
  general_image i, trial_data_provenance tdp
where
  tdp.trial_dp_pk_id = i.trial_dp_pk_id and patient_id = ?
', ARRAY['patient_id'], 
                    ARRAY['series_instance_uid'], ARRAY['Reconcile Public and Posda for CPTAC'], 'public', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('PlansWithNoFrameOfRef', 'select 
  file_id,
  root_path || ''/'' || rel_path as path
from
  file_location natural join file_storage_root natural join ctp_file
where 
  file_id in (
    select file_id 
    from file_plan p
    where not exists (select for_uid from file_for f where f.file_id = p.file_id)
  )', '{}', 
                    ARRAY['file_id', 'path'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('SeriesWithDupSopsWithConflictingPixels', 'select 
  distinct project_name, site_name, patient_id, study_instance_uid, 
  series_instance_uid, count(distinct file_id)
from
  ctp_file natural join file_sop_common natural join file_patient natural join 
  file_study natural join file_series 
where sop_instance_uid in (
  select distinct sop_instance_uid
  from (
    select
      distinct sop_instance_uid, count(*)
    from (
      select
        sop_instance_uid, unique_pixel_data.digest as pixel_digest
      from
        file_sop_common natural join file natural join file_image join
        image using (image_id) join unique_pixel_data using (unique_pixel_data_id)
    )as foo group by sop_instance_uid
  ) as foo where count > 1
)
group by
  project_name, site_name, patient_id, study_instance_uid, series_instance_uid
order by 
  project_name, site_name, patient_id, count desc
  ', '{}', 
                    ARRAY['project_name', 'site_name', 'patient_id', 'study_instance_uid', 'series_instance_uid', 'count'], ARRAY['pix_data_dups'], 'posda_files', 'Find list of series with SOP with duplicate pixel data')
        ;

            insert into queries
            values ('RoundStatsByCollectionForDateRange', 'select
  distinct collection, site, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ? and collection = ?
group by collection, site, time order by time desc, collection', ARRAY['interval', 'from', 'to', 'collection'], 
                    ARRAY['collection', 'site', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('DistinctSeriesBySubjectPublic', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.patient_id = ? and i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
group by series_instance_uid, modality
', ARRAY['subject_id', 'project_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_subject', 'find_series', 'public'], 'public', 'Get Series in A Collection, Site, Subject
')
        ;

            insert into queries
            values ('GetBacklogCountAndPrioritySummary', 'select
  distinct collection, file_count as priority, count(*) as num_requests
from
  submitter natural join request natural join collection_count_per_round
where
  not file_in_posda
group by collection, file_count
', '{}', 
                    ARRAY['collection', 'priority', 'num_requests'], ARRAY['NotInteractive', 'Backlog', 'backlog_status'], 'posda_backlog', 'Get List of Collections with Backlog and Priority Counts')
        ;

            insert into queries
            values ('ListOfPublicDispositionTables', 'select
  distinct sop_class_uid, name, count(*)
from
  public_disposition
group by
  sop_class_uid, name
order by
  sop_class_uid, name', '{}', 
                    ARRAY['sop_class_uid', 'name', 'count'], ARRAY['NotInteractive', 'ElementDisposition'], 'posda_phi', 'Get List of Public Disposition Tables')
        ;

            insert into queries
            values ('EquipmentByValueSignature', 'select distinct value, vr, element_signature, equipment_signature, count(*)
from (
select
  distinct series_instance_uid, element_signature, value, vr,
  equipment_signature
from
  scan_event natural join series_scan
  natural join scan_element natural join element_signature
  natural join equipment_signature
  natural join seen_value
where
  scan_event_id = ? and
  value = ? and
  element_signature = ?
) as foo
group by value, element_signature, vr, equipment_signature
order by value, element_signature, vr, equipment_signature
', ARRAY['scan_id', 'value', 'tag_signature'], 
                    ARRAY['value', 'vr', 'element_signature', 'equipment_signature', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of equipment, values seen in scan by VR with count
')
        ;

            insert into queries
            values ('SubjectsWithDuplicateSopsWithConflictingGeometricInfo', 'select distinct patient_id, study_instance_uid, series_instance_uid, count(*)
from
  file_patient natural join file_sop_common natural join file_series natural join file_study
where sop_instance_uid in (
  select sop_instance_uid from (
    select distinct sop_instance_uid, count(*) from (
    select 
      distinct sop_instance_uid, iop as image_orientation_patient,
      ipp as image_position_patient,
      pixel_spacing,
      pixel_rows as i_rows,
      pixel_columns as i_columns
    from
      file_sop_common join 
      file_patient using (file_id) join
      file_image using (file_id) join 
      file_series using (file_id) join
      file_study using (file_id) join
      image using (image_id) join
      file_image_geometry using (file_id) join
      image_geometry using (image_geometry_id) 
    ) as foo 
    group by sop_instance_uid
  ) as foo where count > 1
) group by patient_id, study_instance_uid, series_instance_uid', '{}', 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'count'], ARRAY['duplicates'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs with conflicting Geometric Information by Patient Id, study, series
')
        ;

            insert into queries
            values ('GetPrivateTagNameAndVrBySignature', 'select
  pt_consensus_name as name,
  pt_consensus_vr as vr
from pt
where pt_signature = ?
', ARRAY['signature'], 
                    ARRAY['name', 'vr'], ARRAY['DispositionReport', 'NotInteractive', 'used_in_reconcile_tag_names'], 'posda_private_tag', 'Get the relevant features of a private tag by signature
Used in DispositionReport.pl - not for interactive use
')
        ;

            insert into queries
            values ('insert_list_of_roles', 'update query_tag_filter
set tags_enabled = ?
where filter_name = ?', ARRAY['tag_list', 'role'], 
                    '{}', ARRAY['roles'], 'posda_queries', 'Insert a list of tags for a role
')
        ;

            insert into queries
            values ('WindowLevelByPixelType', 'select 
  distinct window_width, window_center, count(*)
from (select
    distinct photometric_interpretation,
    samples_per_pixel,
    bits_allocated,
    bits_stored,
    high_bit,
    coalesce(number_of_frames,1) > 1 as is_multi_frame,
    pixel_representation,
    planar_configuration,
    modality,
    file_id
  from
    image natural join file_image natural join file_series
  ) as foo natural join file_win_lev natural join window_level
where
  photometric_interpretation = ? and
  samples_per_pixel = ? and
  bits_allocated = ? and
  bits_stored = ? and
  high_bit = ? and
  pixel_representation = ? and
  modality = ?
group by window_width, window_center
', ARRAY['photometric_interpretation', 'samples_per_pixel', 'bits_allocated', 'bits_stored', 'high_bit', 'pixel_representation', 'modality'], 
                    ARRAY['window_width', 'window_center', 'count'], ARRAY['all', 'find_pixel_types', 'posda_files'], 'posda_files', 'Get distinct pixel types
')
        ;

            insert into queries
            values ('WhatHasComeInRecentlyWithSubjectByCollectionLikeAndFileInPosdaCount', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files, count(distinct posda_file_id) as num_files_in_posda,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
and collection like ?
group by collection, site, subj, time order by time desc, collection, site, subj', ARRAY['interval', 'from', 'to', 'collection_like'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'num_files_in_posda', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('DistinctSeriesByCollectionSiteIntake', 'select
  distinct s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and tdp.dp_site_name = ?
group by series_instance_uid, modality', ARRAY['project_name', 'site_name'], 
                    ARRAY['series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'intake', 'compare_collection_site', 'simple_phi'], 'intake', 'Get Series in A Collection, Site
')
        ;

            insert into queries
            values ('FinalizePhiNonDicomInstance', 'update phi_non_dicom_scan_instance
set pndsi_end_time = now()
where phi_non_dicom_scan_instance_id = ?', ARRAY['phi_non_dicom_scan_instance_id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive', 'non_dicom_phi'], 'posda_phi_simple', 'Get value seen if exists')
        ;

            insert into queries
            values ('GetThisWeeksRange', 'select 
  date_trunc(''week'', now()) as start_week,
  date_trunc(''week'', now() + interval ''7 days'') as end_week,
  date_trunc(''day'', now() + interval ''1 day'') as end_partial_week,
  date_trunc(''day'', now()) as today
', '{}', 
                    ARRAY['start_week', 'end_week', 'end_partial_week', 'today'], ARRAY['downloads_by_date'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('IntakeSeriesWithSignatureByCollectionSite', 'select
  p.patient_id as PID,
  s.modality as Modality,
  t.study_date as StudyDate,
  t.study_desc as StudyDescription,
  s.series_desc as SeriesDescription,
  s.series_number as SeriesNumber,
  t.study_instance_uid as StudyInstanceUID,
  s.series_instance_uid as series_instance_uid,
  concat(q.manufacturer, ":", q.manufacturer_model_name, ":",
  q.software_versions) as signature
from
  general_series s,
  study t,
  patient p,
  trial_data_provenance tdp,
  general_equipment q
where
  s.study_pk_id = t.study_pk_id and
  s.general_equipment_pk_id = q.general_equipment_pk_id and
  t.patient_pk_id = p.patient_pk_id and
  p.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ? and
  tdp.dp_site_name = ?
', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid', 'Modality', 'signature'], ARRAY['intake'], 'intake', 'List of all Series By Collection, Site on Intake
')
        ;

            insert into queries
            values ('RowsInDicomFileWithNoPixelInfoEarliest', 'select 
  file_id, root_path || ''/'' || rel_path as path
from dicom_file natural join file_location natural join file_storage_root
where has_pixel_data is null and file_is_present
order by file_id limit ?', ARRAY['num_rows'], 
                    ARRAY['file_id', 'path'], ARRAY['adding_pixels_to_dicom_file'], 'posda_files', 'List of files (id, path) which are dicom_files with undefined pixel info')
        ;

            insert into queries
            values ('CloseRound', 'update round
  set round_end = now()
where
  round_id = ?
', ARRAY['round_id'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Close row in round (set end time)')
        ;

            insert into queries
            values ('GetSsVolumeReferencingUnknownImagesByCollection', 'select 
  distinct project_name as collection, 
  site_name as site, patient_id, 
  file_id 
from 
  ctp_file natural join file_patient 
where file_id in (
   select
    distinct file_id from ss_volume v 
    join ss_for using(ss_for_id) 
    join file_structure_set using (structure_set_id) 
  where 
     not exists (
       select file_id 
       from file_sop_common s 
       where s.sop_instance_uid = v.sop_instance
  )
)
and project_name = ?
and visibility is null
order by collection, site, patient_id', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('ImageFrameOfReferenceBySeries', 'select 
  distinct for_uid, count(*) as num_files
from
  file_series natural join file_sop_common natural join file_for natural join ctp_file
where 
  series_instance_uid = ? and visibility is null
group by for_uid', ARRAY['series_instance_uid'], 
                    ARRAY['for_uid', 'num_files'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('RtdoseSopsByCollectionSiteDateRange', 'select distinct
  sop_instance_uid
from
  file_series natural join ctp_file natural join file_sop_common
  natural join file_import natural join import_event
where 
  project_name = ? and site_name = ?
  and visibility is null and import_time > ? and 
  import_time < ?
  and modality = ''RTDOSE''', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['sop_instance_uid'], ARRAY['Hierarchy', 'apply_disposition', 'hash_unhashed'], 'posda_files', 'Construct list of files in a collection, site in a Patient, Study, Series Hierarchy')
        ;

            insert into queries
            values ('GetRoiContoursAndFiles', 'select distinct root_path || ''/'' || rel_path as file_path, roi_id, roi_contour_id, roi_num, contour_num, geometric_type, number_of_points 
from roi_contour natural join roi natural join structure_set natural join file_structure_set natural join file_storage_root natural join file_location
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_path', 'roi_id', 'roi_contour_id', 'roi_num', 'contour_num', 'geometric_type', 'number_of_points'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('GetFileIdVisibilityBySeriesInstanceUid', 'select distinct file_id, visibility
from file_series natural left join ctp_file
where series_instance_uid = ?', ARRAY['series_instance_uid'], 
                    ARRAY['file_id', 'visibility'], ARRAY['ImageEdit', 'edit_files'], 'posda_files', 'Get File id and visibility for all files in a series')
        ;

            insert into queries
            values ('PosdaImagesByCollectionSitePlus', 'select distinct
  patient_id,
  sop_instance_uid,
  study_instance_uid,
  series_instance_uid,
  digest
from
  file
  natural join  file_patient
  natural join file_series
  natural join file_sop_common
  natural join file_study
   natural join ctp_file
where
  file_id in (
  select distinct file_id from ctp_file
  where project_name = ? and site_name = ? and visibility is null)

', ARRAY['collection', 'site'], 
                    ARRAY['patient_id', 'sop_instance_uid', 'study_instance_uid', 'series_instance_uid', 'digest'], ARRAY['posda_files'], 'posda_files', 'List of all Files Images By Collection, Site
')
        ;

            insert into queries
            values ('GetDciodvfyErrorMissingAttr', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''MissingAttributes''
  and error_subtype = ?
  and error_tag = ?
  and error_module = ?', ARRAY['error_subtype', 'error_tag', 'error_module'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get an dciodvfy_errors row by error_text (if present)')
        ;

            insert into queries
            values ('VisibilityChangeEventsByReasonFor', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  date_trunc(''hour'', time_of_change) as when_done,
  user_name, prior_visibility, new_visibility, reason_for, count(distinct file_id) as num_files,
  count (distinct series_instance_uid) as num_series
from
   ctp_file natural join file_patient natural join file_series natural join file_visibility_change 
where reason_for = ?
group by
 collection, site, patient_id, when_done, user_name, prior_visibility, new_visibility, reason_for
order by when_done desc', ARRAY['reason_for'], 
                    ARRAY['collection', 'site', 'patient_id', 'when_done', 'user_name', 'prior_visibility', 'new_visibility', 'reason_for', 'num_files', 'num_series'], ARRAY['meta', 'test', 'hello', 'bills_test', 'hide_events', 'show_hidden'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('GetSeriesWithImageAndNoEquivalenceClassByCollectionSiteDateRange', 'select distinct
  project_name as collection, site_name as site,
  patient_id, modality, series_instance_uid, 
  count(distinct sop_instance_uid) as num_sops,
  count(distinct file_id) as num_files
from
  file_series fs natural join file_sop_common
  natural join file_patient
  natural join file_image natural join ctp_file
  natural join file_import natural join import_event
where project_name = ? and site_name = ? and visibility is null
  and import_time > ? and import_time < ?
  and (
    select count(*) 
    from image_equivalence_class ie
    where ie.series_instance_uid = fs.series_instance_uid
  ) = 0
group by
  collection, site, patient_id, modality, series_instance_uid
', ARRAY['collection', 'site', 'from', 'to'], 
                    ARRAY['collection', 'site', 'patient_id', 'modality', 'series_instance_uid', 'num_sops', 'num_files'], ARRAY['signature', 'phi_review', 'visual_review'], 'posda_files', 'Get a list of Series with images by CollectionSite
')
        ;

            insert into queries
            values ('RoundWithIntervalOverlap', 'select
  round_id, collection,
  round_created,
  round_start,  
  round_end - round_start as duration,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where collection = ? and 
  round_end > ? and round_start < ?
order by round_id, collection', ARRAY['collection', 'from', 'to'], 
                    ARRAY['round_id', 'collection', 'num_dups', 'round_created', 'round_start', 'duration', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_analysis_reporting_tools', 'backlog_round_history'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('RoundCountsByCollection2Recent', 'select
  round_id, collection,
  round_created,
  round_start - round_created as q_time,  
  round_end - round_created as duration,
  wait_count,
  process_count,
  num_entered,
  num_failed,
  num_dups,
  num_requests,
  priority
from
  round natural join round_counts natural join round_collection
where collection = ? and (now() - round_end) < ''1:00''
order by round_id, collection', ARRAY['collection'], 
                    ARRAY['round_id', 'collection', 'round_created', 'q_time', 'duration', 'wait_count', 'process_count', 'num_entered', 'num_failed', 'num_dups', 'num_requests', 'priority'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'backlog_status'], 'posda_backlog', 'Summary of rounds')
        ;

            insert into queries
            values ('FileTypeModalityCountsByImportId', 'select
  distinct  dicom_file_type, modality, count(*) as num_files
from file_series natural join dicom_file
where file_id in (
  select distinct file_id
  from file_import natural join import_event
  where import_event_id = ?
) group by dicom_file_type, modality', ARRAY['import_event_id'], 
                    ARRAY['dicom_file_type', 'modality', 'num_files'], ARRAY['ACRIN-NSCLC-FDG-PET Curation'], 'posda_files', 'Get the list of files by sop, excluding base series')
        ;

            insert into queries
            values ('GetValueForTagBySeries', 'select
  distinct series_instance_uid, element_signature as tag, value
from
  series_scan natural join scan_element natural join seen_value natural join element_signature
where
  series_instance_uid = ? and element_signature = ?', ARRAY['series_instance_uid', 'tag'], 
                    ARRAY['series_instance_uid', 'tag', 'value'], ARRAY['tag_values'], 'posda_phi', 'Find Distinct value for a given tag for a particular scanned series
')
        ;

            insert into queries
            values ('CreateSubprocessLine', 'insert into subprocess_lines(
 subprocess_invocation_id,
 line_number,
 line
) values (
  ?, ?, ?
)', ARRAY['subprocess_invocation_id', 'line_number', 'line'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Create a row in subprocess_lines table

Used when invoking a spreadsheet operation from a either a button or a spreadsheet 
to record data retrieved from subprocess (i.e response displayed on screen)')
        ;

            insert into queries
            values ('GetNRequestsForCollection', 'select 
  distinct request_id, collection, received_file_path, file_digest, time_received, size
from 
  request natural join submitter
where
  collection = ? and not file_in_posda 
order by time_received 
limit ?
', ARRAY['collection', 'num_rows'], 
                    ARRAY['request_id', 'collection', 'received_file_path', 'file_digest', 'time_received', 'size'], ARRAY['NotInteractive', 'Backlog'], 'posda_backlog', 'Get N Requests for a Given Collection')
        ;

            insert into queries
            values ('GetSimpleValuesForTag', 'select
  distinct value
from
  element_seen natural join
  element_value_occurance natural join
  value_seen
where element_sig_pattern = ? and vr = ?
', ARRAY['tag', 'vr'], 
                    ARRAY['value'], ARRAY['tag_values'], 'posda_phi_simple', 'Find Values for a given tag, vr in posda_phi_simple
')
        ;

            insert into queries
            values ('SentToIntakeByDate', 'select
  send_started, send_ended - send_started as duration,
  destination_host, destination_port,
  number_of_files as to_send, files_sent,
  invoking_user, reason_for_send
from (
  select
    distinct dicom_send_event_id,
    count(distinct file_path) as files_sent
  from
    dicom_send_event natural join dicom_file_send
  where
    send_started > ? and send_started < ?
  group by dicom_send_event_id
) as foo
natural join dicom_send_event
order by send_started
', ARRAY['from_date', 'to_date'], 
                    ARRAY['send_started', 'duration', 'destination_host', 'destination_port', 'to_send', 'files_sent', 'invoking_user', 'reason_for_send'], ARRAY['send_to_intake'], 'posda_files', 'List of Files Sent To Intake By Date
')
        ;

            insert into queries
            values ('GetPublicInfoBySop', 'select 
  tdp.project, dp_site_name as site_name, dp_site_id as site_id,
  patient_id, study_instance_uid, series_instance_uid
from 
  general_image i, trial_data_provenance tdp 
where 
  tdp.trial_dp_pk_id = i.trial_dp_pk_id and sop_instance_uid = ?', ARRAY['sop_instance_uid'], 
                    ARRAY['project', 'site_name', 'site_id', 'patient_id', 'study_instance_uid', 'series_instance_uid'], ARRAY['bills_test', 'comparing_posda_to_public'], 'public', 'Add a filter to a tab')
        ;

            insert into queries
            values ('FileType', 'select file_type
from file
where file_id = ?
', ARRAY['file_id'], 
                    ARRAY['file_type'], ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_files', 'Get the file_type of a file, by file_id
')
        ;

            insert into queries
            values ('FilesByReviewStatusByCollectionSiteWithVisibility', 'select
  distinct
  file_id,
  project_name as collection,
  site_name as site,
  patient_id,
  series_instance_uid,
  sop_instance_uid,
  file_id,
  visibility
from
  image_equivalence_class_input_image
  join ctp_file using(file_id)
  join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
where 
  image_equivalence_class_id in (
    select
      image_equivalence_class_id 
    from
      image_equivalence_class 
      join file_series using(series_instance_uid)
      join ctp_file using(file_id)
    where 
      project_name = ? and site_name = ?
      and review_status = ?
)', ARRAY['collection', 'site', 'status'], 
                    ARRAY['collection', 'site', 'patient_id', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'visibility'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('InsertImportEvent', '  insert into import_event(
    import_type, import_time
  ) values (
    ''Processing Backlog'', ?
  )', ARRAY['time_tag'], 
                    '{}', ARRAY['NotInteractive', 'Backlog'], 'posda_files', 'Create an import_event')
        ;

            insert into queries
            values ('DistinctDispositionsNeededSimple', 'select 
  distinct 
  element_seen_id as id, 
  element_sig_pattern,
  vr,
  tag_name
from
  element_seen
  natural join element_value_occurance
  natural join value_seen
where
  is_private and 
  private_disposition is null
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('CurrentPatientWithoutStatii', 'select 
  distinct project_name as collection,
  site_name as site,
  patient_id,
  ''<undef>'' as patient_import_status
from 
  ctp_file natural join file_patient p
where 
  visibility is null and
  not exists (select * from patient_import_status s where p.patient_id = s.patient_id)', '{}', 
                    ARRAY['collection', 'site', 'patient_id', 'patient_import_status'], ARRAY['counts', 'patient_status', 'for_bill_counts'], 'posda_files', 'Get the current status of all patients')
        ;

            insert into queries
            values ('UpdateSendEvent', 'update dicom_send_event
  set send_ended = now()
where dicom_send_event_id = ?
', ARRAY['id'], 
                    NULL, ARRAY['NotInteractive', 'SeriesSendEvent'], 'posda_files', 'Update dicom_send_event_id after creation and completion of send
For use in scripts.
Not meant for interactive use
')
        ;

            insert into queries
            values ('PlanToSsLinkageByCollectionSite', 'select
  sop_instance_uid as referencing_plan, ss_referenced_from_plan as referenced_ss
from
  file_plan natural join plan join file_sop_common using(file_id) natural join ctp_file
where
  project_name = ? and site_name = ? and visibility is null', ARRAY['collection', 'site'], 
                    ARRAY['referencing_plan', 'referenced_ss'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'plan_linkages', 'struct_linkages'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('CountsBySiteCollectionLikeDateRangePlus', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, series_date,
    study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files,
    min(import_time) as earliest,
    max(import_time) as latest
from
  ctp_file join file_patient using(file_id)
  join dicom_file using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  join file_import using(file_id)
  join import_event using(import_event_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  file_id in (
    select file_id 
    from file_import natural join import_event
    where import_time > ? and import_time < ?
  ) and project_name like ? and site_name like ? and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality, study_date, 
  series_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  modality, study_date, series_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['from', 'to', 'collection_like', 'site'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'series_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files', 'earliest', 'latest'], ARRAY['counts', 'count_queries'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('UpdateSeriesScan', 'update series_scan
  set series_scan_status = ?
where series_scan_id = ?', ARRAY['series_scan_status', 'series_scan_id'], 
                    '{}', ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Update Series Scan to set status
')
        ;

            insert into queries
            values ('ActivityStuffMoreForAll', 'select
  distinct subprocess_invocation_id, background_subprocess_id, user_inbox_content_id,
  background_subprocess_report_id, file_id,
  background_subprocess_report.name as report_type,
  activity_id, when_script_started,
  when_background_entered, when_script_ended, 
  invoking_user, user_to_notify, button_name,
  operation_name, command_line
from
  subprocess_invocation natural left join background_subprocess natural left join background_subprocess_report
  natural left join user_inbox_content natural left join activity_inbox_content
order by subprocess_invocation_id desc
', '{}', 
                    ARRAY['subprocess_invocation_id', 'background_subprocess_id', 'user_inbox_content_id', 'background_subprocess_report_id', 'file_id', 'report_type', 'activity_id', 'when_script_started', 'when_background_entered', 'when_script_ended', 'invoking_user', 'user_to_notify', 'button_name', 'operation_name', 'command_line'], ARRAY['activity_timepoint_support'], 'posda_queries', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('GetCurrentEditEventRowId', 'select currval(''dicom_edit_event_dicom_edit_event_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_import_edited_files'], 'posda_files', 'Get current dicom_edit_event_id
For use in scripts
Not really intended for interactive use
')
        ;

            insert into queries
            values ('GetSeenValueId', 'select currval(''seen_value_seen_value_id_seq'') as id', '{}', 
                    ARRAY['id'], ARRAY['UsedInPhiSeriesScan', 'NotInteractive'], 'posda_phi', 'Get current value of seen_value_id sequence')
        ;

            insert into queries
            values ('InsertUserBoundVariable', 'insert into user_variable_binding(
  binding_user, bound_variable_name, bound_value
) values (
  ?, ?, ?
)
 ', ARRAY['user', 'variable_name', 'value'], 
                    ARRAY['user', 'variable', 'binding'], ARRAY['AllCollections', 'queries', 'activity_support', 'variabler_binding'], 'posda_queries', 'Get list of variables with bindings for a user')
        ;

            insert into queries
            values ('DistinctDispositonsNeededSimple', 'select 
  distinct 
  element_seen_id as id, 
  element_sig_pattern,
  vr,
  tag_name
from
  element_seen
  natural join element_value_occurance
  natural join value_seen
where
  is_private and 
  private_disposition is null
', '{}', 
                    ARRAY['id', 'element_sig_pattern', 'vr', 'tag_name'], ARRAY['tag_usage', 'simple_phi_maint', 'phi_maint'], 'posda_phi_simple', 'Private tags with no disposition with values in phi_simple')
        ;

            insert into queries
            values ('AddCompletionTimeToBackgroundProcess', 'update background_subprocess set
  when_script_ended = now()
where
  background_subprocess_id = ?
', ARRAY['background_subprocess_id'], 
                    '{}', ARRAY['NotInteractive', 'used_in_background_processing'], 'posda_queries', 'Add when_script_ended to a background_subprocess  row

used in a background subprocess when complete')
        ;

            insert into queries
            values ('ListOfQueriesPerformedByUser', 'select
  query_invoked_by_dbif_id as id,
  query_name,
  query_end_time - query_start_time as duration,
  invoking_user as invoked_by,
  query_start_time as at, 
  number_of_rows
from
  query_invoked_by_dbif
where
  invoking_user = ?', ARRAY['user'], 
                    ARRAY['id', 'query_name', 'duration', 'invoked_by', 'at', 'number_of_rows'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('DuplicatesInDifferentSeriesByCollectionSite', 'select
  distinct collection, site, subj_id, study_instance_uid, series_instance_uid, sop_instance_uid,
  file_id, file_path
from (
  select
    distinct project_name as collection,
    site_name as site, patient_id as subj_id,
    study_instance_uid, series_instance_uid,
    sop_instance_uid,
    file_id, root_path ||''/'' || rel_path as file_path
  from
    ctp_file natural join file_sop_common
    natural join file_patient natural join file_study natural join file_series
    join file_location using(file_id) join file_storage_root using(file_storage_root_id)
  where
    sop_instance_uid in (
      select distinct sop_instance_uid from (
        select distinct sop_instance_uid, count(distinct file_id) from (
          select distinct file_id, sop_instance_uid 
          from
            ctp_file natural join file_sop_common
            natural join file_patient
          where
            visibility is null and project_name = ? and site_name = ?
        ) as foo group by sop_instance_uid order by count desc
      ) as foo 
      where count > 1
    )
    and visibility is null
  ) as foo
order by sop_instance_uid

', ARRAY['collection', 'site'], 
                    ARRAY['collection', 'site', 'subj_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'file_id', 'file_path'], ARRAY['duplicates', 'dup_sops', 'hide_dup_sops', 'sops_different_series'], 'posda_files', 'Return a count of duplicate SOP Instance UIDs
')
        ;

            insert into queries
            values ('FilesRemainingToBeHiddenByScanInstance', 'select
  distinct file_id
from
  file_sop_common natural
  join ctp_file
where
  visibility is null and
  sop_instance_uid in (
    select
      sop_instance_uid
    from
      file_sop_common
      where file_id in (
          select
            distinct file_id
          from
             image_equivalence_class natural join
             image_equivalence_class_input_image
           where
             visual_review_instance_id = ? and
             review_status = ''Bad''
        )
     )', ARRAY['visual_review_instance_id'], 
                    ARRAY['file_id'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_status'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('TotalPosdaSeriesCounts', 'select
  distinct project_name as collection, site_name as site,  count(distinct series_instance_uid) as num_series,
  count(distinct file_id) as num_files
from 
  ctp_file natural join file_series 
where
  visibility is null group by collection, site           
order by collection, site', '{}', 
                    ARRAY['collection', 'site', 'num_series', 'num_files'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Files for a specific patient which were first received after a specific time')
        ;

            insert into queries
            values ('CountsByCollectionSiteSubject', 'select
  distinct
    patient_id, image_type, dicom_file_type, modality,
    study_date, study_description,
    series_description, study_instance_uid, series_instance_uid,
    manufacturer, manuf_model_name, software_versions,
    count(distinct sop_instance_uid) as num_sops,
    count(distinct file_id) as num_files
from
  ctp_file join file_patient using(file_id)
  join file_series using(file_id)
  join file_sop_common using(file_id)
  join dicom_file using(file_id)
  join file_study using(file_id)
  join file_equipment using(file_id)
  left join file_image using(file_id)
  left join image using (image_id)
where
  project_name = ? and site_name = ? and patient_id = ?
  and visibility is null
group by
  patient_id, image_type, dicom_file_type, modality,
  study_date, study_description,
  series_description, study_instance_uid, series_instance_uid,
  manufacturer, manuf_model_name, software_versions
order by
  patient_id, study_instance_uid, series_instance_uid, image_type,
  dicom_file_type, modality, study_date, study_description,
  series_description,
  manufacturer, manuf_model_name, software_versions
', ARRAY['collection', 'site', 'patient_id'], 
                    ARRAY['patient_id', 'image_type', 'dicom_file_type', 'modality', 'study_date', 'study_description', 'series_description', 'study_instance_uid', 'series_instance_uid', 'manufacturer', 'manuf_model_name', 'software_versions', 'num_sops', 'num_files'], ARRAY['counts'], 'posda_files', 'Counts query by Collection, Site, Subject
')
        ;

            insert into queries
            values ('GetPosdaSopsForCompareLikeCollection', 'select
  distinct patient_id,
  study_instance_uid, 
  series_instance_uid, 
  sop_instance_uid,
  sop_class_uid,
  modality,
  dicom_file_type,
  root_path || ''/'' || rel_path as file_path,
  file_id
from
  ctp_file
  natural join dicom_file
  natural join file_patient
  natural join file_study
  natural join file_series
  natural join file_sop_common
  natural join file_location
  natural join file_storage_root
where
  project_name like ? 
  and visibility is null', ARRAY['collection'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'sop_class_uid', 'modality', 'dicom_file_type', 'file_path', 'file_id'], ARRAY['public_posda_counts'], 'posda_files', 'Generate a long list of all unhidden SOPs for a collection in posda<br>
<em>This can generate a long list</em>')
        ;

            insert into queries
            values ('DistinctHiddenFilesInSeries', 'select
  distinct file_id
from
  file_series natural join file_sop_common natural join ctp_file
where
  series_instance_uid = ? and visibility is not null
', ARRAY['series_instance_uid'], 
                    ARRAY['file_id'], ARRAY['by_series_instance_uid', 'file_ids', 'posda_files'], 'posda_files', 'Get Distinct Unhidden Files in Series
')
        ;

            insert into queries
            values ('DistinctSopsInSeries', 'select distinct sop_instance_uid, count(*)
from file_sop_common
where file_id in (
  select
    distinct file_id
  from
    file_series natural join ctp_file
  where
    series_instance_uid = ? and visibility is null
)
group by sop_instance_uid
order by count desc
', ARRAY['series_instance_uid'], 
                    ARRAY['sop_instance_uid', 'count'], ARRAY['by_series_instance_uid', 'duplicates', 'posda_files', 'sops'], 'posda_files', 'Get Distinct SOPs in Series with number files
Only visible filess
')
        ;

            insert into queries
            values ('AreVisibleFilesMarkedAsBadOrUnreviewed', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ?
  and visibility is null
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  processing_status
order by
  series_instance_uid', ARRAY['collection', 'site'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'processing_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_events'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('SeriesVisualReviewResultsByCollectionSiteStatus', 'select 
  distinct series_instance_uid,
  dicom_file_type,
  modality,
  review_status,
  count(distinct file_id) as num_files
from 
  dicom_file natural join 
  file_series natural join 
  ctp_file join 
  image_equivalence_class using(series_instance_uid)
where
  project_name = ? and
  site_name = ? and review_status = ?
group by
  series_instance_uid,
  dicom_file_type,
  modality,
  review_status
order by
  series_instance_uid', ARRAY['project_name', 'site_name', 'status'], 
                    ARRAY['series_instance_uid', 'dicom_file_type', 'modality', 'review_status', 'num_files'], ARRAY['find_series', 'equivalence_classes', 'consistency', 'visual_review_results', 'hide_files'], 'posda_files', 'Get visual review status report by series for Collection, Site')
        ;

            insert into queries
            values ('GetCountSsVolume', 'select count(distinct sop_instance_uid) as num_links from 
(select 
  for_uid, study_instance_uid, series_instance_uid,
  sop_class as sop_class_uid, sop_instance as sop_instance_uid
  from ss_for natural join ss_volume where structure_set_id in (
    select 
      structure_set_id 
    from
      file_structure_set fs, file_sop_common sc
    where
      sc.file_id = fs.file_id and sop_instance_uid = ?
)
) as foo;', ARRAY['sop_instance_uid'], 
                    ARRAY['num_links'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get Structure Set Volume

')
        ;

            insert into queries
            values ('WherePatientSits', 'select
  distinct project_name as collection,
  site_name as site,
  visibility,
  patient_id,
  patient_name,
  series_instance_uid,
  modality,
  count (distinct file_id) as num_files
from
  file_patient natural left join
  file_series natural left join
  ctp_file
where
  patient_id = ?
group by
  project_name, site_name, visibility, 
  patient_id, patient_name,
  series_instance_uid, modality
order by 
  project_name, site_name, patient_id,
  modality
', ARRAY['patient_id'], 
                    ARRAY['collection', 'site', 'visibility', 'patient_id', 'patient_name', 'series_instance_uid', 'modality', 'num_files'], ARRAY['adding_ctp'], 'posda_files', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('GetEditStatusExt', 'select
  subprocess_invocation_id as id,
  start_creation_time, end_creation_time - start_creation_time as duration,
  number_edits_scheduled as to_edit,
  number_compares_with_diffs as changed,
  number_compares_without_diffs as not_changed,
  current_disposition as disposition,
  dest_dir, command_line, b.crash
from
  dicom_edit_compare_disposition  join subprocess_invocation using (subprocess_invocation_id)
  join background_subprocess b using(subprocess_invocation_id)
order by start_creation_time desc', '{}', 
                    ARRAY['id', 'start_creation_time', 'duration', 'to_edit', 'changed', 'not_changed', 'disposition', 'dest_dir', 'command_line', 'crash'], ARRAY['adding_ctp', 'find_patients', 'series_selection', 'check_edits', 'testing_edit_objects', 'edit_status', 'crash'], 'posda_files', 'Get List of visible patients with CTP data')
        ;

            insert into queries
            values ('CreateSimpleElementValueOccurance', 'insert into element_value_occurance(
element_seen_id, value_seen_id, series_scan_instance_id, phi_scan_instance_id
)values(?, ?, ?, ?)', ARRAY['element_seen_id', 'value_seen_id', 'series_scan_instance_id', 'scan_instance_id'], 
                    '{}', ARRAY['used_in_simple_phi', 'NotInteractive'], 'posda_phi_simple', 'Create a new scanned value instance')
        ;

            insert into queries
            values ('GetFromToDigestsEditCompare', 'select from_file_digest, to_file_digest from dicom_edit_compare where subprocess_invocation_id = ?', ARRAY['subprocess_invocation_id'], 
                    ARRAY['from_file_digest', 'to_file_digest'], ARRAY['bills_test', 'posda_db_populate'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('VrsSeen', 'select distinct vr, count(*) from (
  select
    distinct value, element_signature, vr
  from
    scan_event natural join series_scan natural join seen_value
    natural join element_signature natural join scan_element
  where
    scan_event_id = ?
) as foo
group by vr
order by vr
', ARRAY['scan_id'], 
                    ARRAY['vr', 'count'], ARRAY['tag_usage'], 'posda_phi', 'List of VR''s seen in scan (with count)
')
        ;

            insert into queries
            values ('NumFilesToMigrate', 'select
  count(*) as num_files
from
  file_location natural join file_storage_root
where
  storage_class = ?', ARRAY['storage_class'], 
                    ARRAY['num_files'], ARRAY['used_in_file_import_into_posda', 'used_in_file_migration'], 'posda_files', 'Get count of files relative to storage root')
        ;

            insert into queries
            values ('GetDupContourCountsExtendedByCollection', 'select
  project_name as collection,
  site_name as site,
  patient_id,
  file_id,
  num_dup_contours
from (
  select 
    distinct file_id, count(*) as num_dup_contours
  from
    file_roi_image_linkage 
  where 
    contour_digest in (
    select contour_digest
    from (
      select 
        distinct contour_digest, count(*)
      from
        file_roi_image_linkage group by contour_digest
    ) as foo
    where count > 1
  ) group by file_id 
) foo join ctp_file using (file_id) join file_patient using(file_id)
where project_name = ? and visibility is null
order by num_dup_contours desc', ARRAY['collection'], 
                    ARRAY['collection', 'site', 'patient_id', 'file_id', 'num_dup_contours'], ARRAY['Structure Sets', 'sops', 'LinkageChecks', 'dup_contours'], 'posda_files', 'Get list of plan which reference unknown SOPs

')
        ;

            insert into queries
            values ('ListOfQueriesPerformedByQueryName', 'select
  query_invoked_by_dbif_id as id,
  query_name,
  query_end_time - query_start_time as duration,
  invoking_user as invoked_by,
  query_start_time as at, 
  number_of_rows
from
  query_invoked_by_dbif
where
 query_name = ?', ARRAY['query_name'], 
                    ARRAY['id', 'query_name', 'duration', 'invoked_by', 'at', 'number_of_rows'], ARRAY['AllCollections', 'q_stats'], 'posda_queries', 'Get a list of collections and sites
')
        ;

            insert into queries
            values ('GetPosdaPhiSimplePrivateElements', 'select
  element_seen_id,
  element_sig_pattern,
  vr,
  is_private,
  private_disposition,
  tag_name
from element_seen
where element_sig_pattern like ''%"%''

', '{}', 
                    ARRAY['element_seen_id', 'element_sig_pattern', 'vr', 'is_private', 'private_disposition', 'tag_name'], ARRAY['NotInteractive', 'used_in_reconcile_tag_names'], 'posda_phi_simple', 'Get the relevant features of an element_signature in posda_phi_simple schema')
        ;

            insert into queries
            values ('ListOfElementSignaturesAndVrs', 'select
  distinct element_signature, vr, name_chain, count(*)
from
  element_signature
group by element_signature, vr, name_chain
', '{}', 
                    ARRAY['element_signature', 'vr', 'name_chain', 'count'], ARRAY['NotInteractive', 'Update', 'ElementDisposition'], 'posda_phi', 'Get Disposition of element by sig and VR')
        ;

            insert into queries
            values ('DuplicateFilesBySop', 'select
  distinct
    project_name as collection, site_name as site,
    patient_id, sop_instance_uid, modality, file_id,
    root_path || ''/'' || file_location.rel_path as file_path,
    count(*) as num_uploads,
    min(import_time) as first_upload, 
    max(import_time) as last_upload
from
  file_patient left join ctp_file using(file_id)
  join file_sop_common using(file_id)
  join file_series using(file_id)
  join file_location using(file_id)
  join file_storage_root using(file_storage_root_id)
  join file_import using (file_id)
  join import_event using (import_event_id)
where
  sop_instance_uid = ?
  and visibility is null
group by
  project_name, site_name, patient_id, sop_instance_uid, modality, 
  file_id, file_path
order by
  collection, site, patient_id, sop_instance_uid, modality
', ARRAY['sop_instance_uid'], 
                    ARRAY['collection', 'site', 'patient_id', 'sop_instance_uid', 'modality', 'file_id', 'file_path', 'num_uploads', 'first_upload', 'last_upload'], ARRAY['duplicates'], 'posda_files', 'Counts query by Collection, Site
')
        ;

            insert into queries
            values ('DistinctSeriesByPatient', 'select distinct series_instance_uid, patient_id, count(distinct file_id) as num_files,
  count(distinct sop_instance_uid) as num_sops
from
  file_series natural join file_patient natural join file_sop_common
  natural left join ctp_file
where
  patient_id = ? and visibility is null
group by series_instance_uid, patient_id

', ARRAY['patient_id'], 
                    ARRAY['series_instance_uid', 'patient_id', 'num_files', 'num_sops'], ARRAY['find_series', 'search_series', 'send_series', 'phi_simple', 'simple_phi', 'dciodvfy', 'series_selection', 'ctp_details'], 'posda_files', 'Get Series in for a patient
')
        ;

            insert into queries
            values ('GetEquipmentInfoById', 'select
  file_id,
  manufacturer,
  institution_name,
  institution_addr,
  station_name,
  inst_dept_name,
  manuf_model_name,
  dev_serial_num,
  software_versions,
  spatial_resolution,
  last_calib_date,
  last_calib_time,
  pixel_pad
from file_equipment
where file_id = ?', ARRAY['file_id'], 
                    ARRAY['file_id', 'manufacturer', 'institution_name', 'institution_addr', 'station_name', 'inst_dept_name', 'manuf_model_name', 'dev_serial_num', 'software_versions', 'spatial_resolution', 'last_calib_date', 'last_calib_time', 'pixel_pad'], ARRAY['reimport_queries'], 'posda_files', 'Get file path from id')
        ;

            insert into queries
            values ('CreateDciodvfyError', 'insert into dciodvfy_error(
  error_type, error_tag, error_subtype, error_module,
  error_reason, error_index, error_value, error_text
) values (
  ?, ?, ?, ?,
  ?, ?, ?, ?
)', ARRAY['error_type', 'error_tag', 'error_subtype', 'error_module', 'error_reason', 'error_index', 'error_value', 'error_text'], 
                    '{}', ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Create a dciodvfy_errors row by error_text ')
        ;

            insert into queries
            values ('GetXlsToConvert', 'select 
  file_id, file_type, file_sub_type, collection, site, subject, visibility, date_last_categorized
from
  non_dicom_file
where
 collection = ? and file_type = ''xls'' and visibility is null', ARRAY['collection'], 
                    ARRAY['file_id', 'file_type', 'file_sub_type', 'collection', 'site', 'subject', 'visibility', 'date_last_categorized'], ARRAY['radcomp'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('dicom_files_with_no_ctp_file_like_pat', 'select 
  distinct patient_id,
  dicom_file_type, 
  modality, 
  count(distinct file_id) as num_files, 
  min(import_time) as earliest, 
  max(import_time) as latest 
from
  dicom_file d natural join
  file_patient natural join 
  file_series natural join
  file_import natural join
  import_event
where not exists (select file_id from ctp_file c where c.file_id = d.file_id) and patient_id like ?
group by patient_id, dicom_file_type, modality', ARRAY['patient_id_pattern'], 
                    ARRAY['patient_id', 'dicom_file_type', 'modality', 'num_files', 'earliest', 'latest'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Add a filter to a tab')
        ;

            insert into queries
            values ('VisibleImagesWithDetailsByVisualIdAndTypeAndStatus', 'select 
  distinct patient_id, study_instance_uid, series_instance_uid, sop_instance_uid, modality, 
  root_path || ''/'' || rel_path as path
from 
  file_patient natural join file_study natural join file_series natural join 
  file_location natural join file_storage_root natural join
  file_sop_common natural join ctp_file
where series_instance_uid in (
  select
    distinct series_instance_uid
  from
    image_equivalence_class natural join file_series natural join
    image_equivalence_class_input_image natural join dicom_file natural join ctp_file
  where
    visual_review_instance_id = ? and 
    processing_status = ? and review_status = ? and 
    dicom_file_type = ?
)
and visibility is null', ARRAY['visual_review_instance_id', 'processing_status', 'review_status', 'dicom_file_type'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'sop_instance_uid', 'modality', 'path'], ARRAY['by_collection', 'find_series', 'compare_collection_site', 'search_series', 'edit_files', 'simple_phi', 'dciodvfy', 'ctp_details', 'select_for_phi', 'visual_review_new_workflow'], 'posda_files', 'Get Series in A Collection, site with dicom_file_type, modality, and sop_count
')
        ;

            insert into queries
            values ('RoiLinkagesByFileId', 'select
  distinct roi_id,
  linked_sop_instance_uid as sop_instance_uid,
  contour_type
from
  file_roi_image_linkage
where file_id =?', ARRAY['file_id'], 
                    ARRAY['roi_id', 'sop_instance_uid', 'contour_type'], ARRAY['LinkageChecks', 'used_in_struct_linkage_check'], 'posda_files', 'Get list of Roi with info by file_id

')
        ;

            insert into queries
            values ('GetDciodvfyErrorAttrSpecWithIndex', 'select
  dciodvfy_error_id as id
from 
  dciodvfy_error
where
  error_type = ''AttributeSpecificErrorWithIndex''
  and error_tag = ?
  and error_subtype= ?
  and error_index = ?', ARRAY['error_tag', 'error_subtype', 'error_index'], 
                    ARRAY['id'], ARRAY['NotInteractive', 'used_in_dciodvfy'], 'posda_phi_simple', 'Get dciodvfy_errors row where subtype = AttributeSpecificErrorWithIndex')
        ;

            insert into queries
            values ('GetPlansAndSSReferences', 'select sop_instance_uid as plan_referencing,
ss_referenced_from_plan as ss_referenced
from plan natural join file_plan join file_sop_common using(file_id)', '{}', 
                    ARRAY['plan_referencing', 'ss_referenced'], ARRAY['Structure Sets', 'sops', 'LinkageChecks'], 'posda_files', 'Get list of plan and ss sops where plan references ss

')
        ;

            insert into queries
            values ('DiskSpaceByCollectionSummary', 'select
  distinct project_name as collection, sum(size) as total_bytes
from
  ctp_file natural join file
where
  file_id in (
  select distinct file_id
  from ctp_file
  )
group by project_name
order by total_bytes
', '{}', 
                    ARRAY['collection', 'total_bytes'], ARRAY['by_collection', 'posda_files', 'storage_used', 'summary'], 'posda_files', 'Get disk space used for all collections
')
        ;

            insert into queries
            values ('FindInconsistentStudyIgnoringStudyTimeIncludingPatientIdAll', 'select distinct study_instance_uid from (
  select distinct study_instance_uid, count(*) from (
    select distinct
      patient_id, study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
    from
      file_study natural join file_patient natural join ctp_file
    where
      visibility is null
    group by
      patient_id, study_instance_uid, study_date,
      referring_phy_name, study_id, accession_number,
      study_description, phys_of_record, phys_reading,
      admitting_diag
  ) as foo
  group by study_instance_uid
) as foo
where count > 1
', '{}', 
                    ARRAY['study_instance_uid'], ARRAY['by_study', 'consistency', 'study_consistency'], 'posda_files', 'Find Inconsistent Studies
')
        ;

            insert into queries
            values ('PhiScanStatus', 'select
  phi_scan_instance_id as id,
  start_time,
  end_time,
  end_time - start_time as duration,
  description,
  num_series as to_scan,
  num_series_scanned as scanned
from 
  phi_scan_instance
order by id
', '{}', 
                    ARRAY['id', 'start_time', 'end_time', 'duration', 'description', 'to_scan', 'scanned'], ARRAY['tag_usage', 'phi_review', 'phi_status', 'scan_status'], 'posda_phi_simple', 'Status of PHI scans
')
        ;

            insert into queries
            values ('ManifestsByDate', 'select
  distinct file_id, import_time, size, root_path || ''/'' || l.rel_path as path, i.file_name as alt_path
from
  file_location l join file_storage_root using(file_storage_root_id) 
  join file_import i using (file_id) natural join file join import_event using(import_event_id)
where
  import_time >?and import_time < ? and
  file_type like ''%ASCII%'' and
  l.rel_path like ''%/Manifests/%''
order by import_time', ARRAY['from', 'to'], 
                    ARRAY['file_id', 'import_time', 'size', 'path', 'alt_path'], ARRAY['activity_timepoint_support', 'manifests'], 'posda_files', 'Create An Activity Timepoint

')
        ;

            insert into queries
            values ('ToExamineRecentFiles', 'select 
  file_id, project_name as collection, site_name as site,
  patient_id, series_instance_uid, dicom_file_type, modality
from
  ctp_file natural join file_patient natural join dicom_file natural join file_series where file_id in 
  (
     select file_id from 
     (  
        select 
           distinct file_id, min(import_time) as import_time 
        from 
          file_import natural join import_event 
        where file_id in 
        (
          select 
            distinct file_id 
          from 
             ctp_file natural join file_import natural join import_event
             natural join file_patient 
           where patient_id =? and import_time > ?
         ) group by file_id
      ) as foo
      where import_time > ?
  )', ARRAY['patient_id', 'import_time_1', 'import_time_2'], 
                    ARRAY['file_id', 'collection', 'site', 'patient_id', 'series_instance_uid', 'dicom_file_type', 'modality'], ARRAY['meta', 'test', 'hello', 'query_tabs', 'bills_test'], 'posda_files', 'Files for a specific patient which were first received after a specific time')
        ;

            insert into queries
            values ('DistinctSeriesHierarchyByCollectionPublic', 'select
  distinct i. patient_id, i.study_instance_uid, s.series_instance_uid, modality, count(*) as num_images
from
  general_image i, general_series s,
  trial_data_provenance tdp
where
  s.general_series_pk_id = i.general_series_pk_id and
  i.trial_dp_pk_id = tdp.trial_dp_pk_id and
  tdp.project = ?
group by patient_id, study_instance_uid, series_instance_uid, modality', ARRAY['project_name'], 
                    ARRAY['patient_id', 'study_instance_uid', 'series_instance_uid', 'modality', 'num_images'], ARRAY['by_collection', 'find_series', 'public', 'series_search'], 'public', 'Get Series in A Collection
')
        ;

            insert into queries
            values ('RoundStatsWithCollectionSiteSubjectForDateRange', 'select
  distinct collection, site, subj, date_trunc(?, time_received) as time,
  count(*) as number_of_files,
  max(time_entered - time_received) as max_delay,
  min(time_entered - time_received) as min_delay
from request natural join submitter
where time_received > ? and time_received < ?
group by collection, site, subj, time order by time desc, collection, site, subj', ARRAY['interval', 'from', 'to'], 
                    ARRAY['collection', 'site', 'subj', 'time', 'number_of_files', 'max_delay', 'min_delay'], ARRAY['NotInteractive', 'Backlog', 'Backlog Monitor', 'for_bill'], 'posda_backlog', 'Summary of rounds')
        ;
