#!/usr/bin/perl -w
#
#
#Copyright 2008, Bill Bennett
# Part of the Posda package
# Posda may be copied only under the terms of either the Artistic License or the
# GNU General Public License, which may be found in the Posda Distribution,
# or at http://posda.com/License.html
#
use Posda::DataDict;
package Posda::ElementNames;
use vars qw( $SigToName $NameToSig );
my $dd = Posda::DataDict->new;
$SigToName = {
  "(0008,0001)" => "LengthToEnd",
  "(0008,0005)" => "SpecificCharacterSet",
  "(0008,0008)" => "ImageType",
  "(0008,0010)" => "RecognitionCode",
  "(0008,0012)" => "InstanceCreationDate",
  "(0008,0013)" => "InstanceCreationTime",
  "(0008,0014)" => "InstanceCreatorUID",
  "(0008,0016)" => "SOPClassUID",
  "(0008,0018)" => "SOPInstanceUID",
  "(0008,001a)" => "RelatedGeneralSOPClassUID",
  "(0008,001b)" => "OriginalSpecializedSOPClassUID",
  "(0008,0020)" => "StudyDate",
  "(0008,0021)" => "SeriesDate",
  "(0008,0022)" => "AcquisitionDate",
  "(0008,0023)" => "ContentDate",
  "(0008,0024)" => "OverlayDate",
  "(0008,0025)" => "CurveDate",
  "(0008,002a)" => "AcquisitionDateTime",
  "(0008,0030)" => "StudyTime",
  "(0008,0031)" => "SeriesTime",
  "(0008,0032)" => "AcquisitionTime",
  "(0008,0033)" => "ContentTime",
  "(0008,0034)" => "OverlayTime",
  "(0008,0035)" => "CurveTime",
  "(0008,0040)" => "OldDataSetType",
  "(0008,0041)" => "OldDataSetSubtype",
  "(0008,0042)" => "NuclearMedicineSeriesTypeRetired",
  "(0008,0050)" => "AccessionNumber",
  "(0008,0051)" => "IssuerOfAccessionNumberSequence",
  "(0008,0052)" => "QueryRetrieveLevel",
  "(0008,0054)" => "RetrieveAETitle",
  "(0008,0056)" => "InstanceAvailability",
  "(0008,0058)" => "FailedSOPInstanceUIDList",
  "(0008,0060)" => "Modality",
  "(0008,0061)" => "ModalitiesInStudy",
  "(0008,0062)" => "SOPClassesInStudy",
  "(0008,0064)" => "ConversionType",
  "(0008,0068)" => "PresentationIntentType",
  "(0008,0070)" => "Manufacturer",
  "(0008,0080)" => "InstitutionName",
  "(0008,0081)" => "InstitutionAddress",
  "(0008,0082)" => "InstitutionCodeSequence",
  "(0008,0090)" => "ReferringPhysicianName",
  "(0008,0092)" => "ReferringPhysicianAddress",
  "(0008,0094)" => "ReferringPhysicianTelephoneNumber",
  "(0008,0096)" => "ReferringPhysicianIdentificationSequence",
  "(0008,0100)" => "CodeValue",
  "(0008,0102)" => "CodingSchemeDesignator",
  "(0008,0103)" => "CodingSchemeVersion",
  "(0008,0104)" => "CodeMeaning",
  "(0008,0105)" => "MappingResource",
  "(0008,0106)" => "ContextGroupVersion",
  "(0008,0107)" => "ContextGroupLocalVersion",
  "(0008,010b)" => "ContextGroupExtensionFlag",
  "(0008,010c)" => "CodingSchemeUID",
  "(0008,010d)" => "ContextGroupExtensionCreatorUID",
  "(0008,010f)" => "ContextIdentifier",
  "(0008,0110)" => "CodingSchemeIdentificationSequence",
  "(0008,0112)" => "CodingSchemeRegistry",
  "(0008,0114)" => "CodingSchemeExternalID",
  "(0008,0115)" => "CodingSchemeName",
  "(0008,0116)" => "CodingSchemeResponsibleOrganization",
  "(0008,0117)" => "ContextUID",
  "(0008,0201)" => "TimezoneOffsetFromUTC",
  "(0008,1000)" => "NetworkID",
  "(0008,1010)" => "StationName",
  "(0008,1030)" => "StudyDescription",
  "(0008,1032)" => "ProcedureCodeSequence",
  "(0008,103e)" => "SeriesDescription",
  "(0008,1040)" => "InstitutionalDepartmentName",
  "(0008,1048)" => "PhysicianOfRecord",
  "(0008,1049)" => "PhysicianOfRecordIdentificationSequence",
  "(0008,1050)" => "PerformingPhysicianName",
  "(0008,1052)" => "PerformingPhysicianIdentificationSequence",
  "(0008,1060)" => "PhysicianReadingStudy",
  "(0008,1062)" => "PhysicianReadingStudyIdentificationSequence",
  "(0008,1070)" => "OperatorsName",
  "(0008,1072)" => "OperatorIdentificationSequence",
  "(0008,1080)" => "AdmittingDiagnosesDescription",
  "(0008,1084)" => "AdmittingDiagnosesCodeSequence",
  "(0008,1090)" => "ManufacturerModelName",
  "(0008,1100)" => "ReferencedResultsSequence",
  "(0008,1110)" => "ReferencedStudySequence",
  "(0008,1111)" => "ReferencedPerformedProcedureStepSequence",
  "(0008,1115)" => "ReferencedSeriesSequence",
  "(0008,1120)" => "ReferencedPatientSequence",
  "(0008,1125)" => "ReferencedVisitSequence",
  "(0008,1130)" => "ReferencedOverlaySequence",
  "(0008,113a)" => "ReferencedWaveformSequence",
  "(0008,1140)" => "ReferencedImageSequence",
  "(0008,1145)" => "ReferencedCurveSequence",
  "(0008,114a)" => "ReferencedInstanceSequence",
  "(0008,114b)" => "ReferencedRealWorldValueMappingInstanceSequence",
  "(0008,1150)" => "ReferencedSOPClassUID",
  "(0008,1155)" => "ReferencedSOPInstanceUID",
  "(0008,115a)" => "SOPClassesSupported",
  "(0008,1160)" => "ReferencedFrameNumber",
  "(0008,1195)" => "TransactionUID",
  "(0008,1197)" => "FailureReason",
  "(0008,1198)" => "FailedSOPSequence",
  "(0008,1199)" => "ReferencedSOPSequence",
  "(0008,1200)" => "StudiesContainingOtherReferencedInstancesSequence",
  "(0008,1250)" => "RelatedSeriesSequence",
  "(0008,2110)" => "OldLossyImageCompression",
  "(0008,2111)" => "DerivationDescription",
  "(0008,2112)" => "SourceImageSequence",
  "(0008,2120)" => "StageName",
  "(0008,2122)" => "StageNumber",
  "(0008,2124)" => "NumberOfStages",
  "(0008,2127)" => "ViewName",
  "(0008,2128)" => "ViewNumber",
  "(0008,2129)" => "NumberOfEventTimers",
  "(0008,212a)" => "NumberOfViewsInStage",
  "(0008,2130)" => "EventElapsedTime",
  "(0008,2132)" => "EventTimerName",
  "(0008,2142)" => "StartTrim",
  "(0008,2143)" => "StopTrim",
  "(0008,2144)" => "RecommendedDisplayFrameRate",
  "(0008,2200)" => "TransducerPosition",
  "(0008,2204)" => "TransducerOrientation",
  "(0008,2208)" => "AnatomicStructure",
  "(0008,2218)" => "AnatomicRegionSequence",
  "(0008,2220)" => "AnatomicRegionModifierSequence",
  "(0008,2228)" => "PrimaryAnatomicStructureSequence",
  "(0008,2229)" => "AnatomicStructureSpaceOrRegionSequence",
  "(0008,2230)" => "PrimaryAnatomicStructureModifierSequence",
  "(0008,2240)" => "TransducerPositionSequence",
  "(0008,2242)" => "TransducerPositionModifierSequence",
  "(0008,2244)" => "TransducerOrientationSequence",
  "(0008,2246)" => "TransducerOrientationModifierSequence",
  "(0008,2251)" => "AnatomicStructureSpaceOrRegionCodeSequenceTrial",
  "(0008,2253)" => "AnatomicPortalOfEntranceCodeSequenceTrial",
  "(0008,2255)" => "AnatomicApproachDirectionCodeSequenceTrial",
  "(0008,2256)" => "AnatomicPerspectiveDescriptionTrial",
  "(0008,2257)" => "AnatomicPerspectiveCodeSequenceTrial",
  "(0008,2258)" => "AnatomicLocationOfExaminingInstrumentDescriptionTrial",
  "(0008,2259)" => "AnatomicLocationOfExaminingInstrumentCodeSequenceTrial",
  "(0008,225a)" => "AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial",
  "(0008,225c)" => "OnAxisBackgroundAnatomicStructureCodeSequenceTrial",
  "(0008,3001)" => "AlternateRepresentationSequence",
  "(0008,3010)" => "IrradiationEventUID",
  "(0008,4000)" => "IdentifyingComments",
  "(0008,9007)" => "FrameType",
  "(0008,9092)" => "ReferencedImageEvidenceSequence",
  "(0008,9121)" => "ReferencedRawDataSequence",
  "(0008,9123)" => "CreatorVersionUID",
  "(0008,9124)" => "DerivationImageSequence",
  "(0008,9154)" => "SourceImageEvidenceSequence",
  "(0008,9205)" => "PixelPresentation",
  "(0008,9206)" => "VolumetricProperties",
  "(0008,9207)" => "VolumeBasedCalculationTechnique",
  "(0008,9208)" => "ComplexImageComponent",
  "(0008,9209)" => "AcquisitionContrast",
  "(0008,9215)" => "DerivationCodeSequence",
  "(0008,9237)" => "ReferencedGrayscalePresentationStateSequence",
  "(0008,9410)" => "ReferencedOtherPlaneSequence",
  "(0008,9458)" => "FrameDisplaySequence",
  "(0008,9459)" => "RecommendedDisplayFrameRateInFloat",
  "(0008,9460)" => "SkipFrameRangeFlag",
  "(0010,0010)" => "PatientName",
  "(0010,0020)" => "PatientID",
  "(0010,0021)" => "IssuerOfPatientID",
  "(0010,0022)" => "TypeOfPatientID",
  "(0010,0024)" => "IssuerOfPatientIDQualifiersSequence",
  "(0010,0030)" => "PatientBirthDate",
  "(0010,0032)" => "PatientBirthTime",
  "(0010,0040)" => "PatientSex",
  "(0010,0050)" => "PatientInsurancePlanCodeSequence",
  "(0010,0101)" => "PatientPrimaryLanguageCodeSequence",
  "(0010,0102)" => "PatientPrimaryLanguageModifierCodeSequence",
  "(0010,1000)" => "OtherPatientID",
  "(0010,1001)" => "OtherPatientName",
  "(0010,1002)" => "OtherPatientIDSequence",
  "(0010,1005)" => "PatientBirthName",
  "(0010,1010)" => "PatientAge",
  "(0010,1020)" => "PatientSize",
  "(0010,1030)" => "PatientWeight",
  "(0010,1040)" => "PatientAddress",
  "(0010,1050)" => "InsurancePlanIdentification",
  "(0010,1060)" => "PatientMotherBirthName",
  "(0010,1080)" => "MilitaryRank",
  "(0010,1081)" => "BranchOfService",
  "(0010,1090)" => "MedicalRecordLocator",
  "(0010,2000)" => "MedicalAlerts",
  "(0010,2110)" => "Allergies",
  "(0010,2150)" => "CountryOfResidence",
  "(0010,2152)" => "RegionOfResidence",
  "(0010,2154)" => "PatientTelephoneNumber",
  "(0010,2160)" => "EthnicGroup",
  "(0010,2180)" => "Occupation",
  "(0010,21a0)" => "SmokingStatus",
  "(0010,21b0)" => "AdditionalPatientHistory",
  "(0010,21c0)" => "PregnancyStatus",
  "(0010,21d0)" => "LastMenstrualDate",
  "(0010,21f0)" => "PatientReligiousPreference",
  "(0010,2201)" => "PatientSpeciesDescription",
  "(0010,2202)" => "PatientSpeciesCodeSequence",
  "(0010,2203)" => "PatientSexNeutered",
  "(0010,2292)" => "PatientBreedDescription",
  "(0010,2293)" => "PatientBreedCodeSequence",
  "(0010,2294)" => "BreedRegistrationSequence",
  "(0010,2295)" => "BreedRegistrationNumber",
  "(0010,2296)" => "BreedRegistryCodeSequence",
  "(0010,2297)" => "ResponsiblePerson",
  "(0010,2298)" => "ResponsiblePersonRole",
  "(0010,2299)" => "ResponsibleOrganization",
  "(0010,4000)" => "PatientComments",
  "(0010,9431)" => "ExaminedBodyThickness",
  "(0012,0010)" => "ClinicalTrialSponsorName",
  "(0012,0020)" => "ClinicalTrialProtocolID",
  "(0012,0021)" => "ClinicalTrialProtocolName",
  "(0012,0030)" => "ClinicalTrialSiteID",
  "(0012,0031)" => "ClinicalTrialSiteName",
  "(0012,0040)" => "ClinicalTrialSubjectID",
  "(0012,0042)" => "ClinicalTrialSubjectReadingID",
  "(0012,0050)" => "ClinicalTrialTimePointID",
  "(0012,0051)" => "ClinicalTrialTimePointDescription",
  "(0012,0060)" => "ClinicalTrialCoordinatingCenterName",
  "(0012,0062)" => "PatientIdentityRemoved",
  "(0012,0063)" => "DeidentificationMethod",
  "(0012,0064)" => "DeidentificationMethodCodeSequence",
  "(0012,0071)" => "ClinicalTrialSeriesID",
  "(0012,0072)" => "ClinicalTrialSeriesDescription",
  "(0018,0010)" => "ContrastBolusAgent",
  "(0018,0012)" => "ContrastBolusAgentSequence",
  "(0018,0014)" => "ContrastBolusAdministrationRouteSequence",
  "(0018,0015)" => "BodyPartExamined",
  "(0018,0020)" => "ScanningSequence",
  "(0018,0021)" => "SequenceVariant",
  "(0018,0022)" => "ScanOptions",
  "(0018,0023)" => "MRAcquisitionType",
  "(0018,0024)" => "SequenceName",
  "(0018,0025)" => "AngioFlag",
  "(0018,0026)" => "InterventionDrugInformationSequence",
  "(0018,0027)" => "InterventionDrugStopTime",
  "(0018,0028)" => "InterventionDrugDose",
  "(0018,0029)" => "InterventionDrugCodeSequence",
  "(0018,002a)" => "AdditionalDrugSequence",
  "(0018,0030)" => "Radionuclide",
  "(0018,0031)" => "Radiopharmaceutical",
  "(0018,0032)" => "EnergyWindowCenterline",
  "(0018,0033)" => "EnergyWindowTotalWidth",
  "(0018,0034)" => "InterventionDrugName",
  "(0018,0035)" => "InterventionDrugStartTime",
  "(0018,0036)" => "InterventionSequence",
  "(0018,0037)" => "TherapyType",
  "(0018,0038)" => "InterventionStatus",
  "(0018,0039)" => "TherapyDescription",
  "(0018,003a)" => "InterventionDescription",
  "(0018,0040)" => "CineRate",
  "(0018,0050)" => "SliceThickness",
  "(0018,0060)" => "KVP",
  "(0018,0070)" => "CountsAccumulated",
  "(0018,0071)" => "AcquisitionTerminationCondition",
  "(0018,0072)" => "EffectiveDuration",
  "(0018,0073)" => "AcquisitionStartCondition",
  "(0018,0074)" => "AcquisitionStartConditionData",
  "(0018,0075)" => "AcquisitionTerminationConditionData",
  "(0018,0080)" => "RepetitionTime",
  "(0018,0081)" => "EchoTime",
  "(0018,0082)" => "InversionTime",
  "(0018,0083)" => "NumberOfAverages",
  "(0018,0084)" => "ImagingFrequency",
  "(0018,0085)" => "ImagedNucleus",
  "(0018,0086)" => "EchoNumber",
  "(0018,0087)" => "MagneticFieldStrength",
  "(0018,0088)" => "SpacingBetweenSlices",
  "(0018,0089)" => "NumberOfPhaseEncodingSteps",
  "(0018,0090)" => "DataCollectionDiameter",
  "(0018,0091)" => "EchoTrainLength",
  "(0018,0093)" => "PercentSampling",
  "(0018,0094)" => "PercentPhaseFieldOfView",
  "(0018,0095)" => "PixelBandwidth",
  "(0018,1000)" => "DeviceSerialNumber",
  "(0018,1002)" => "DeviceUID",
  "(0018,1004)" => "PlateID",
  "(0018,1005)" => "GeneratorID",
  "(0018,1006)" => "GridID",
  "(0018,1007)" => "CassetteID",
  "(0018,1008)" => "GantryID",
  "(0018,1010)" => "SecondaryCaptureDeviceID",
  "(0018,1011)" => "HardcopyCreationDeviceID",
  "(0018,1012)" => "DateOfSecondaryCapture",
  "(0018,1014)" => "TimeOfSecondaryCapture",
  "(0018,1016)" => "SecondaryCaptureDeviceManufacturer",
  "(0018,1017)" => "HardcopyDeviceManufacturer",
  "(0018,1018)" => "SecondaryCaptureDeviceManufacturerModelName",
  "(0018,1019)" => "SecondaryCaptureDeviceSoftwareVersion",
  "(0018,101a)" => "HardcopyDeviceSoftwareVersion",
  "(0018,101b)" => "HardcopyDeviceManufacturerModelName",
  "(0018,1020)" => "SoftwareVersion",
  "(0018,1022)" => "VideoImageFormatAcquired",
  "(0018,1023)" => "DigitalImageFormatAcquired",
  "(0018,1030)" => "ProtocolName",
  "(0018,1040)" => "ContrastBolusRoute",
  "(0018,1041)" => "ContrastBolusVolume",
  "(0018,1042)" => "ContrastBolusStartTime",
  "(0018,1043)" => "ContrastBolusStopTime",
  "(0018,1044)" => "ContrastBolusTotalDose",
  "(0018,1045)" => "SyringeCounts",
  "(0018,1046)" => "ContrastFlowRate",
  "(0018,1047)" => "ContrastFlowDuration",
  "(0018,1048)" => "ContrastBolusIngredient",
  "(0018,1049)" => "ContrastBolusIngredientConcentration",
  "(0018,1050)" => "SpatialResolution",
  "(0018,1060)" => "TriggerTime",
  "(0018,1061)" => "TriggerSourceOrType",
  "(0018,1062)" => "NominalInterval",
  "(0018,1063)" => "FrameTime",
  "(0018,1064)" => "CardiacFramingType",
  "(0018,1065)" => "FrameTimeVector",
  "(0018,1066)" => "FrameDelay",
  "(0018,1067)" => "ImageTriggerDelay",
  "(0018,1068)" => "MultiplexGroupTimeOffset",
  "(0018,1069)" => "TriggerTimeOffset",
  "(0018,106a)" => "SynchronizationTrigger",
  "(0018,106c)" => "SynchronizationChannel",
  "(0018,106e)" => "TriggerSamplePosition",
  "(0018,1070)" => "RadiopharmaceuticalRoute",
  "(0018,1071)" => "RadiopharmaceuticalVolume",
  "(0018,1072)" => "RadiopharmaceuticalStartTime",
  "(0018,1073)" => "RadiopharmaceuticalStopTime",
  "(0018,1074)" => "RadionuclideTotalDose",
  "(0018,1075)" => "RadionuclideHalfLife",
  "(0018,1076)" => "RadionuclidePositronFraction",
  "(0018,1077)" => "RadiopharmaceuticalSpecificActivity",
  "(0018,1078)" => "RadiopharmaceuticalStartDateTime",
  "(0018,1079)" => "RadiopharmaceuticalStopDateTime",
  "(0018,1080)" => "BeatRejectionFlag",
  "(0018,1081)" => "LowRRValue",
  "(0018,1082)" => "HighRRValue",
  "(0018,1083)" => "IntervalsAcquired",
  "(0018,1084)" => "IntervalsRejected",
  "(0018,1085)" => "PVCRejection",
  "(0018,1086)" => "SkipBeats",
  "(0018,1088)" => "HeartRate",
  "(0018,1090)" => "CardiacNumberOfImages",
  "(0018,1094)" => "TriggerWindow",
  "(0018,1100)" => "ReconstructionDiameter",
  "(0018,1110)" => "DistanceSourceToDetector",
  "(0018,1111)" => "DistanceSourceToPatient",
  "(0018,1114)" => "EstimatedRadiographicMagnificationFactor",
  "(0018,1120)" => "GantryDetectorTilt",
  "(0018,1121)" => "GantryDetectorSlew",
  "(0018,1130)" => "TableHeight",
  "(0018,1131)" => "TableTraverse",
  "(0018,1134)" => "TableMotion",
  "(0018,1135)" => "TableVerticalIncrement",
  "(0018,1136)" => "TableLateralIncrement",
  "(0018,1137)" => "TableLongitudinalIncrement",
  "(0018,1138)" => "TableAngle",
  "(0018,113a)" => "TableType",
  "(0018,1140)" => "RotationDirection",
  "(0018,1141)" => "AngularPosition",
  "(0018,1142)" => "RadialPosition",
  "(0018,1143)" => "ScanArc",
  "(0018,1144)" => "AngularStep",
  "(0018,1145)" => "CenterOfRotationOffset",
  "(0018,1146)" => "RotationOffset",
  "(0018,1147)" => "FieldOfViewShape",
  "(0018,1149)" => "FieldOfViewDimensions",
  "(0018,1150)" => "ExposureTime",
  "(0018,1151)" => "XRayTubeCurrent",
  "(0018,1152)" => "Exposure",
  "(0018,1153)" => "ExposureInuAs",
  "(0018,1154)" => "AveragePulseWidth",
  "(0018,1155)" => "RadiationSetting",
  "(0018,1156)" => "RectificationType",
  "(0018,115a)" => "RadiationMode",
  "(0018,115e)" => "ImageAndFluoroscopyAreaDoseProduct",
  "(0018,1160)" => "FilterType",
  "(0018,1161)" => "TypeOfFilters",
  "(0018,1162)" => "IntensifierSize",
  "(0018,1164)" => "ImagerPixelSpacing",
  "(0018,1166)" => "Grid",
  "(0018,1170)" => "GeneratorPower",
  "(0018,1180)" => "CollimatorGridName",
  "(0018,1181)" => "CollimatorType",
  "(0018,1182)" => "FocalDistance",
  "(0018,1183)" => "XFocusCenter",
  "(0018,1184)" => "YFocusCenter",
  "(0018,1190)" => "FocalSpot",
  "(0018,1191)" => "AnodeTargetMaterial",
  "(0018,11a0)" => "BodyPartThickness",
  "(0018,11a2)" => "CompressionForce",
  "(0018,1200)" => "DateOfLastCalibration",
  "(0018,1201)" => "TimeOfLastCalibration",
  "(0018,1210)" => "ConvolutionKernel",
  "(0018,1240)" => "UpperLowerPixelValues",
  "(0018,1242)" => "ActualFrameDuration",
  "(0018,1243)" => "CountRate",
  "(0018,1244)" => "PreferredPlaybackSequencing",
  "(0018,1250)" => "ReceiveCoilName",
  "(0018,1251)" => "TransmitCoilName",
  "(0018,1260)" => "PlateType",
  "(0018,1261)" => "PhosphorType",
  "(0018,1300)" => "ScanVelocity",
  "(0018,1301)" => "WholeBodyTechnique",
  "(0018,1302)" => "ScanLength",
  "(0018,1310)" => "AcquisitionMatrix",
  "(0018,1312)" => "InPlanePhaseEncodingDirection",
  "(0018,1314)" => "FlipAngle",
  "(0018,1315)" => "VariableFlipAngleFlag",
  "(0018,1316)" => "SAR",
  "(0018,1318)" => "dBdt",
  "(0018,1400)" => "AcquisitionDeviceProcessingDescription",
  "(0018,1401)" => "AcquisitionDeviceProcessingCode",
  "(0018,1402)" => "CassetteOrientation",
  "(0018,1403)" => "CassetteSize",
  "(0018,1404)" => "ExposuresOnPlate",
  "(0018,1405)" => "RelativeXRayExposure",
  "(0018,1450)" => "ColumnAngulation",
  "(0018,1460)" => "TomoLayerHeight",
  "(0018,1470)" => "TomoAngle",
  "(0018,1480)" => "TomoTime",
  "(0018,1490)" => "TomoType",
  "(0018,1491)" => "TomoClass",
  "(0018,1495)" => "NumberOfTomosynthesisSourceImages",
  "(0018,1500)" => "PositionerMotion",
  "(0018,1508)" => "PositionerType",
  "(0018,1510)" => "PositionerPrimaryAngle",
  "(0018,1511)" => "PositionerSecondaryAngle",
  "(0018,1520)" => "PositionerPrimaryAngleIncrement",
  "(0018,1521)" => "PositionerSecondaryAngleIncrement",
  "(0018,1530)" => "DetectorPrimaryAngle",
  "(0018,1531)" => "DetectorSecondaryAngle",
  "(0018,1600)" => "ShutterShape",
  "(0018,1602)" => "ShutterLeftVerticalEdge",
  "(0018,1604)" => "ShutterRightVerticalEdge",
  "(0018,1606)" => "ShutterUpperHorizontalEdge",
  "(0018,1608)" => "ShutterLowerHorizontalEdge",
  "(0018,1610)" => "CenterOfCircularShutter",
  "(0018,1612)" => "RadiusOfCircularShutter",
  "(0018,1620)" => "VerticesOfPolygonalShutter",
  "(0018,1622)" => "ShutterPresentationValue",
  "(0018,1623)" => "ShutterOverlayGroup",
  "(0018,1624)" => "ShutterPresentationColorCIELabValue",
  "(0018,1700)" => "CollimatorShape",
  "(0018,1702)" => "CollimatorLeftVerticalEdge",
  "(0018,1704)" => "CollimatorRightVerticalEdge",
  "(0018,1706)" => "CollimatorUpperHorizontalEdge",
  "(0018,1708)" => "CollimatorLowerHorizontalEdge",
  "(0018,1710)" => "CenterOfCircularCollimator",
  "(0018,1712)" => "RadiusOfCircularCollimator",
  "(0018,1720)" => "VerticesOfPolygonalCollimator",
  "(0018,1800)" => "AcquisitionTimeSynchronized",
  "(0018,1801)" => "TimeSource",
  "(0018,1802)" => "TimeDistributionProtocol",
  "(0018,1803)" => "NTPSourceAddress",
  "(0018,2001)" => "PageNumberVector",
  "(0018,2002)" => "FrameLabelVector",
  "(0018,2003)" => "FramePrimaryAngleVector",
  "(0018,2004)" => "FrameSecondaryAngleVector",
  "(0018,2005)" => "SliceLocationVector",
  "(0018,2006)" => "DisplayWindowLabelVector",
  "(0018,2010)" => "NominalScannedPixelSpacing",
  "(0018,2020)" => "DigitizingDeviceTransportDirection",
  "(0018,2030)" => "RotationOfScannedFilm",
  "(0018,3100)" => "IVUSAcquisition",
  "(0018,3101)" => "IVUSPullbackRate",
  "(0018,3102)" => "IVUSGatedRate",
  "(0018,3103)" => "IVUSPullbackStartFrameNumber",
  "(0018,3104)" => "IVUSPullbackStopFrameNumber",
  "(0018,3105)" => "LesionNumber",
  "(0018,4000)" => "AcquisitionComments",
  "(0018,5000)" => "OutputPower",
  "(0018,5010)" => "TransducerData",
  "(0018,5012)" => "FocusDepth",
  "(0018,5020)" => "ProcessingFunction",
  "(0018,5021)" => "PostprocessingFunction",
  "(0018,5022)" => "MechanicalIndex",
  "(0018,5024)" => "BoneThermalIndex",
  "(0018,5026)" => "CranialThermalIndex",
  "(0018,5027)" => "SoftTissueThermalIndex",
  "(0018,5028)" => "SoftTissueFocusThermalIndex",
  "(0018,5029)" => "SoftTissueSurfaceThermalIndex",
  "(0018,5030)" => "DynamicRange",
  "(0018,5040)" => "TotalGain",
  "(0018,5050)" => "DepthOfScanField",
  "(0018,5100)" => "PatientPosition",
  "(0018,5101)" => "ViewPosition",
  "(0018,5104)" => "ProjectionEponymousNameCodeSequence",
  "(0018,5210)" => "ImageTransformationMatrix",
  "(0018,5212)" => "ImageTranslationVector",
  "(0018,6000)" => "Sensitivity",
  "(0018,6011)" => "SequenceOfUltrasoundRegions",
  "(0018,6012)" => "RegionSpatialFormat",
  "(0018,6014)" => "RegionDataType",
  "(0018,6016)" => "RegionFlags",
  "(0018,6018)" => "RegionLocationMinX0",
  "(0018,601a)" => "RegionLocationMinY0",
  "(0018,601c)" => "RegionLocationMaxX1",
  "(0018,601e)" => "RegionLocationMaxY1",
  "(0018,6020)" => "ReferencePixelX0",
  "(0018,6022)" => "ReferencePixelY0",
  "(0018,6024)" => "PhysicalUnitsXDirection",
  "(0018,6026)" => "PhysicalUnitsYDirection",
  "(0018,6028)" => "ReferencePixelPhysicalValueX",
  "(0018,602a)" => "ReferencePixelPhysicalValueY",
  "(0018,602c)" => "PhysicalDeltaX",
  "(0018,602e)" => "PhysicalDeltaY",
  "(0018,6030)" => "TransducerFrequency",
  "(0018,6031)" => "TransducerType",
  "(0018,6032)" => "PulseRepetitionFrequency",
  "(0018,6034)" => "DopplerCorrectionAngle",
  "(0018,6036)" => "SteeringAngle",
  "(0018,6038)" => "DopplerSampleVolumeXPositionRetired",
  "(0018,6039)" => "DopplerSampleVolumeXPosition",
  "(0018,603a)" => "DopplerSampleVolumeYPositionRetired",
  "(0018,603b)" => "DopplerSampleVolumeYPosition",
  "(0018,603c)" => "TMLinePositionX0Retired",
  "(0018,603d)" => "TMLinePositionX0",
  "(0018,603e)" => "TMLinePositionY0Retired",
  "(0018,603f)" => "TMLinePositionY0",
  "(0018,6040)" => "TMLinePositionX1Retired",
  "(0018,6041)" => "TMLinePositionX1",
  "(0018,6042)" => "TMLinePositionY1Retired",
  "(0018,6043)" => "TMLinePositionY1",
  "(0018,6044)" => "PixelComponentOrganization",
  "(0018,6046)" => "PixelComponentMask",
  "(0018,6048)" => "PixelComponentRangeStart",
  "(0018,604a)" => "PixelComponentRangeStop",
  "(0018,604c)" => "PixelComponentPhysicalUnits",
  "(0018,604e)" => "PixelComponentDataType",
  "(0018,6050)" => "NumberOfTableBreakPoints",
  "(0018,6052)" => "TableOfXBreakPoints",
  "(0018,6054)" => "TableOfYBreakPoints",
  "(0018,6056)" => "NumberOfTableEntries",
  "(0018,6058)" => "TableOfPixelValues",
  "(0018,605a)" => "TableOfParameterValues",
  "(0018,6060)" => "RWaveTimeVector",
  "(0018,7000)" => "DetectorConditionsNominalFlag",
  "(0018,7001)" => "DetectorTemperature",
  "(0018,7004)" => "DetectorType",
  "(0018,7005)" => "DetectorConfiguration",
  "(0018,7006)" => "DetectorDescription",
  "(0018,7008)" => "DetectorMode",
  "(0018,700a)" => "DetectorID",
  "(0018,700c)" => "DateOfLastDetectorCalibration",
  "(0018,700e)" => "TimeOfLastDetectorCalibration",
  "(0018,7010)" => "ExposuresOnDetectorSinceLastCalibration",
  "(0018,7011)" => "ExposuresOnDetectorSinceManufactured",
  "(0018,7012)" => "DetectorTimeSinceLastExposure",
  "(0018,7014)" => "DetectorActiveTime",
  "(0018,7016)" => "DetectorActivationOffsetFromExposure",
  "(0018,701a)" => "DetectorBinning",
  "(0018,7020)" => "DetectorElementPhysicalSize",
  "(0018,7022)" => "DetectorElementSpacing",
  "(0018,7024)" => "DetectorActiveShape",
  "(0018,7026)" => "DetectorActiveDimensions",
  "(0018,7028)" => "DetectorActiveOrigin",
  "(0018,702a)" => "DetectorManufacturerName",
  "(0018,702b)" => "DetectorManufacturerModelName",
  "(0018,7030)" => "FieldOfViewOrigin",
  "(0018,7032)" => "FieldOfViewRotation",
  "(0018,7034)" => "FieldOfViewHorizontalFlip",
  "(0018,7040)" => "GridAbsorbingMaterial",
  "(0018,7041)" => "GridSpacingMaterial",
  "(0018,7042)" => "GridThickness",
  "(0018,7044)" => "GridPitch",
  "(0018,7046)" => "GridAspectRatio",
  "(0018,7048)" => "GridPeriod",
  "(0018,704c)" => "GridFocalDistance",
  "(0018,7050)" => "FilterMaterial",
  "(0018,7052)" => "FilterThicknessMinimum",
  "(0018,7054)" => "FilterThicknessMaximum",
  "(0018,7060)" => "ExposureControlMode",
  "(0018,7062)" => "ExposureControlModeDescription",
  "(0018,7064)" => "ExposureStatus",
  "(0018,7065)" => "PhototimerSetting",
  "(0018,8150)" => "ExposureTimeInuS",
  "(0018,8151)" => "XRayTubeCurrentInuA",
  "(0018,9004)" => "ContentQualification",
  "(0018,9005)" => "PulseSequenceName",
  "(0018,9006)" => "MRImagingModifierSequence",
  "(0018,9008)" => "EchoPulseSequence",
  "(0018,9009)" => "InversionRecovery",
  "(0018,9010)" => "FlowCompensation",
  "(0018,9011)" => "MultipleSpinEcho",
  "(0018,9012)" => "MultiplanarExcitation",
  "(0018,9014)" => "PhaseContrast",
  "(0018,9015)" => "TimeOfFlightContrast",
  "(0018,9016)" => "Spoiling",
  "(0018,9017)" => "SteadyStatePulseSequence",
  "(0018,9018)" => "EchoPlanarPulseSequence",
  "(0018,9019)" => "TagAngleFirstAxis",
  "(0018,9020)" => "MagnetizationTransfer",
  "(0018,9021)" => "T2Preparation",
  "(0018,9022)" => "BloodSignalNulling",
  "(0018,9024)" => "SaturationRecovery",
  "(0018,9025)" => "SpectrallySelectedSuppression",
  "(0018,9026)" => "SpectrallySelectedExcitation",
  "(0018,9027)" => "SpatialPresaturation",
  "(0018,9028)" => "Tagging",
  "(0018,9029)" => "OversamplingPhase",
  "(0018,9030)" => "TagSpacingFirstDimension",
  "(0018,9032)" => "GeometryOfKSpaceTraversal",
  "(0018,9033)" => "SegmentedKSpaceTraversal",
  "(0018,9034)" => "RectilinearPhaseEncodeReordering",
  "(0018,9035)" => "TagThickness",
  "(0018,9036)" => "PartialFourierDirection",
  "(0018,9037)" => "CardiacSynchronizationTechnique",
  "(0018,9041)" => "ReceiveCoilManufacturerName",
  "(0018,9042)" => "MRReceiveCoilSequence",
  "(0018,9043)" => "ReceiveCoilType",
  "(0018,9044)" => "QuadratureReceiveCoil",
  "(0018,9045)" => "MultiCoilDefinitionSequence",
  "(0018,9046)" => "MultiCoilConfiguration",
  "(0018,9047)" => "MultiCoilElementName",
  "(0018,9048)" => "MultiCoilElementUsed",
  "(0018,9049)" => "MRTransmitCoilSequence",
  "(0018,9050)" => "TransmitCoilManufacturerName",
  "(0018,9051)" => "TransmitCoilType",
  "(0018,9052)" => "SpectralWidth",
  "(0018,9053)" => "ChemicalShiftReference",
  "(0018,9054)" => "VolumeLocalizationTechnique",
  "(0018,9058)" => "MRAcquisitionFrequencyEncodingSteps",
  "(0018,9059)" => "Decoupling",
  "(0018,9060)" => "DecoupledNucleus",
  "(0018,9061)" => "DecouplingFrequency",
  "(0018,9062)" => "DecouplingMethod",
  "(0018,9063)" => "DecouplingChemicalShiftReference",
  "(0018,9064)" => "KSpaceFiltering",
  "(0018,9065)" => "TimeDomainFiltering",
  "(0018,9066)" => "NumberOfZeroFills",
  "(0018,9067)" => "BaselineCorrection",
  "(0018,9069)" => "ParallelReductionFactorInPlane",
  "(0018,9070)" => "CardiacRRIntervalSpecified",
  "(0018,9073)" => "AcquisitionDuration",
  "(0018,9074)" => "FrameAcquisitionDateTime",
  "(0018,9075)" => "DiffusionDirectionality",
  "(0018,9076)" => "DiffusionGradientDirectionSequence",
  "(0018,9077)" => "ParallelAcquisition",
  "(0018,9078)" => "ParallelAcquisitionTechnique",
  "(0018,9079)" => "InversionTimes",
  "(0018,9080)" => "MetaboliteMapDescription",
  "(0018,9081)" => "PartialFourier",
  "(0018,9082)" => "EffectiveEchoTime",
  "(0018,9083)" => "MetaboliteCodeSequence",
  "(0018,9084)" => "ChemicalShiftSequence",
  "(0018,9085)" => "CardiacSignalSource",
  "(0018,9087)" => "DiffusionBValue",
  "(0018,9089)" => "DiffusionGradientOrientation",
  "(0018,9090)" => "VelocityEncodingDirection",
  "(0018,9091)" => "VelocityEncodingMinimumValue",
  "(0018,9093)" => "NumberOfKSpaceTrajectories",
  "(0018,9094)" => "CoverageOfKSpace",
  "(0018,9095)" => "SpectroscopyAcquisitionPhaseRows",
  "(0018,9096)" => "ParallelReductionFactorInPlaneRetired",
  "(0018,9098)" => "TransmitterFrequency",
  "(0018,9100)" => "ResonantNucleus",
  "(0018,9101)" => "FrequencyCorrection",
  "(0018,9103)" => "MRSpectroscopyFOVGeometrySequence",
  "(0018,9104)" => "SlabThickness",
  "(0018,9105)" => "SlabOrientation",
  "(0018,9106)" => "MidSlabPosition",
  "(0018,9107)" => "MRSpatialSaturationSequence",
  "(0018,9112)" => "MRTimingAndRelatedParametersSequence",
  "(0018,9114)" => "MREchoSequence",
  "(0018,9115)" => "MRModifierSequence",
  "(0018,9117)" => "MRDiffusionSequence",
  "(0018,9118)" => "CardiacSynchronizationSequence",
  "(0018,9119)" => "MRAveragesSequence",
  "(0018,9125)" => "MRFOVGeometrySequence",
  "(0018,9126)" => "VolumeLocalizationSequence",
  "(0018,9127)" => "SpectroscopyAcquisitionDataColumns",
  "(0018,9147)" => "DiffusionAnisotropyType",
  "(0018,9151)" => "FrameReferenceDateTime",
  "(0018,9152)" => "MRMetaboliteMapSequence",
  "(0018,9155)" => "ParallelReductionFactorOutOfPlane",
  "(0018,9159)" => "SpectroscopyAcquisitionOutOfPlanePhaseSteps",
  "(0018,9166)" => "BulkMotionStatus",
  "(0018,9168)" => "ParallelReductionFactorSecondInPlane",
  "(0018,9169)" => "CardiacBeatRejectionTechnique",
  "(0018,9170)" => "RespiratoryMotionCompensationTechnique",
  "(0018,9171)" => "RespiratorySignalSource",
  "(0018,9172)" => "BulkMotionCompensationTechnique",
  "(0018,9173)" => "BulkMotionSignalSource",
  "(0018,9174)" => "ApplicableSafetyStandardAgency",
  "(0018,9175)" => "ApplicableSafetyStandardDescription",
  "(0018,9176)" => "OperatingModeSequence",
  "(0018,9177)" => "OperatingModeType",
  "(0018,9178)" => "OperatingMode",
  "(0018,9179)" => "SpecificAbsorptionRateDefinition",
  "(0018,9180)" => "GradientOutputType",
  "(0018,9181)" => "SpecificAbsorptionRateValue",
  "(0018,9182)" => "GradientOutput",
  "(0018,9183)" => "FlowCompensationDirection",
  "(0018,9184)" => "TaggingDelay",
  "(0018,9185)" => "RespiratoryMotionCompensationTechniqueDescription",
  "(0018,9186)" => "RespiratorySignalSourceID",
  "(0018,9195)" => "ChemicalShiftMinimumIntegrationLimitInHz",
  "(0018,9196)" => "ChemicalShiftMaximumIntegrationLimitInHz",
  "(0018,9197)" => "MRVelocityEncodingSequence",
  "(0018,9198)" => "FirstOrderPhaseCorrection",
  "(0018,9199)" => "WaterReferencedPhaseCorrection",
  "(0018,9200)" => "MRSpectroscopyAcquisitionType",
  "(0018,9214)" => "RespiratoryCyclePosition",
  "(0018,9217)" => "VelocityEncodingMaximumValue",
  "(0018,9218)" => "TagSpacingSecondDimension",
  "(0018,9219)" => "TagAngleSecondAxis",
  "(0018,9220)" => "FrameAcquisitionDuration",
  "(0018,9226)" => "MRImageFrameTypeSequence",
  "(0018,9227)" => "MRSpectroscopyFrameTypeSequence",
  "(0018,9231)" => "MRAcquisitionPhaseEncodingStepsInPlane",
  "(0018,9232)" => "MRAcquisitionPhaseEncodingStepsOutOfPlane",
  "(0018,9234)" => "SpectroscopyAcquisitionPhaseColumns",
  "(0018,9236)" => "CardiacCyclePosition",
  "(0018,9239)" => "SpecificAbsorptionRateSequence",
  "(0018,9240)" => "RFEchoTrainLength",
  "(0018,9241)" => "GradientEchoTrainLength",
  "(0018,9295)" => "ChemicalShiftMinimumIntegrationLimitInPPM",
  "(0018,9296)" => "ChemicalShiftMaximumIntegrationLimitInPPM",
  "(0018,9301)" => "CTAcquisitionTypeSequence",
  "(0018,9302)" => "AcquisitionType",
  "(0018,9303)" => "TubeAngle",
  "(0018,9304)" => "CTAcquisitionDetailsSequence",
  "(0018,9305)" => "RevolutionTime",
  "(0018,9306)" => "SingleCollimationWidth",
  "(0018,9307)" => "TotalCollimationWidth",
  "(0018,9308)" => "CTTableDynamicsSequence",
  "(0018,9309)" => "TableSpeed",
  "(0018,9310)" => "TableFeedPerRotation",
  "(0018,9311)" => "SpiralPitchFactor",
  "(0018,9312)" => "CTGeometrySequence",
  "(0018,9313)" => "DataCollectionCenterPatient",
  "(0018,9314)" => "CTReconstructionSequence",
  "(0018,9315)" => "ReconstructionAlgorithm",
  "(0018,9316)" => "ConvolutionKernelGroup",
  "(0018,9317)" => "ReconstructionFieldOfView",
  "(0018,9318)" => "ReconstructionTargetCenterPatient",
  "(0018,9319)" => "ReconstructionAngle",
  "(0018,9320)" => "ImageFilter",
  "(0018,9321)" => "CTExposureSequence",
  "(0018,9322)" => "ReconstructionPixelSpacing",
  "(0018,9323)" => "ExposureModulationType",
  "(0018,9324)" => "EstimatedDoseSaving",
  "(0018,9325)" => "CTXRayDetailsSequence",
  "(0018,9326)" => "CTPositionSequence",
  "(0018,9327)" => "TablePosition",
  "(0018,9328)" => "ExposureTimeInms",
  "(0018,9329)" => "CTImageFrameTypeSequence",
  "(0018,9330)" => "XRayTubeCurrentInmA",
  "(0018,9332)" => "ExposureInmAs",
  "(0018,9333)" => "ConstantVolumeFlag",
  "(0018,9334)" => "FluoroscopyFlag",
  "(0018,9335)" => "DistanceSourceToDataCollectionCenter",
  "(0018,9337)" => "ContrastBolusAgentNumber",
  "(0018,9338)" => "ContrastBolusIngredientCodeSequence",
  "(0018,9340)" => "ContrastAdministrationProfileSequence",
  "(0018,9341)" => "ContrastBolusUsageSequence",
  "(0018,9342)" => "ContrastBolusAgentAdministered",
  "(0018,9343)" => "ContrastBolusAgentDetected",
  "(0018,9344)" => "ContrastBolusAgentPhase",
  "(0018,9345)" => "CTDIvol",
  "(0018,9346)" => "CTDIPhantomTypeCodeSequence",
  "(0018,9351)" => "CalciumScoringMassFactorPatient",
  "(0018,9352)" => "CalciumScoringMassFactorDevice",
  "(0018,9360)" => "CTAdditionalXRaySourceSequence",
  "(0018,9401)" => "ProjectionPixelCalibrationSequence",
  "(0018,9402)" => "DistanceSourceToIsocenter",
  "(0018,9403)" => "DistanceObjectToTableTop",
  "(0018,9404)" => "ObjectPixelSpacingInCenterOfBeam",
  "(0018,9405)" => "PositionerPositionSequence",
  "(0018,9406)" => "TablePositionSequence",
  "(0018,9407)" => "CollimatorShapeSequence",
  "(0018,9412)" => "XAXRFFrameCharacteristicsSequence",
  "(0018,9417)" => "FrameAcquisitionSequence",
  "(0018,9420)" => "XRayReceptorType",
  "(0018,9423)" => "AcquisitionProtocolName",
  "(0018,9424)" => "AcquisitionProtocolDescription",
  "(0018,9425)" => "ContrastBolusIngredientOpaque",
  "(0018,9426)" => "DistanceReceptorPlaneToDetectorHousing",
  "(0018,9427)" => "IntensifierActiveShape",
  "(0018,9428)" => "IntensifierActiveDimensions",
  "(0018,9429)" => "PhysicalDetectorSize",
  "(0018,9430)" => "PositionOfIsocenterProjection",
  "(0018,9432)" => "FieldOfViewSequence",
  "(0018,9433)" => "FieldOfViewDescription",
  "(0018,9434)" => "ExposureControlSensingRegionsSequence",
  "(0018,9435)" => "ExposureControlSensingRegionShape",
  "(0018,9436)" => "ExposureControlSensingRegionLeftVerticalEdge",
  "(0018,9437)" => "ExposureControlSensingRegionRightVerticalEdge",
  "(0018,9438)" => "ExposureControlSensingRegionUpperHorizontalEdge",
  "(0018,9439)" => "ExposureControlSensingRegionLowerHorizontalEdge",
  "(0018,9440)" => "CenterOfCircularExposureControlSensingRegion",
  "(0018,9441)" => "RadiusOfCircularExposureControlSensingRegion",
  "(0018,9442)" => "VerticesOfPolygonalExposureControlSensingRegion",
  "(0018,9447)" => "ColumnAngulationPatient",
  "(0018,9449)" => "BeamAngle",
  "(0018,9451)" => "FrameDetectorParametersSequence",
  "(0018,9452)" => "CalculatedAnatomyThickness",
  "(0018,9455)" => "CalibrationSequence",
  "(0018,9456)" => "ObjectThicknessSequence",
  "(0018,9457)" => "PlaneIdentification",
  "(0018,9461)" => "FieldOfViewDimensionsInFloat",
  "(0018,9462)" => "IsocenterReferenceSystemSequence",
  "(0018,9463)" => "PositionerIsocenterPrimaryAngle",
  "(0018,9464)" => "PositionerIsocenterSecondaryAngle",
  "(0018,9465)" => "PositionerIsocenterDetectorRotationAngle",
  "(0018,9466)" => "TableXPositionToIsocenter",
  "(0018,9467)" => "TableYPositionToIsocenter",
  "(0018,9468)" => "TableZPositionToIsocenter",
  "(0018,9469)" => "TableHorizontalRotationAngle",
  "(0018,9470)" => "TableHeadTiltAngle",
  "(0018,9471)" => "TableCradleTiltAngle",
  "(0018,9472)" => "FrameDisplayShutterSequence",
  "(0018,9473)" => "AcquiredImageAreaDoseProduct",
  "(0018,9474)" => "CArmPositionerTabletopRelationship",
  "(0018,9476)" => "XRayGeometrySequence",
  "(0018,9477)" => "IrradiationEventIdentificationSequence",
  "(0018,9504)" => "XRay3DFrameTypeSequence",
  "(0018,9506)" => "ContributingSourcesSequence",
  "(0018,9507)" => "XRay3DAcquisitionSequence",
  "(0018,9508)" => "PrimaryPositionerScanArc",
  "(0018,9509)" => "SecondaryPositionerScanArc",
  "(0018,9510)" => "PrimaryPositionerScanStartAngle",
  "(0018,9511)" => "SecondaryPositionerScanStartAngle",
  "(0018,9514)" => "PrimaryPositionerIncrement",
  "(0018,9515)" => "SecondaryPositionerIncrement",
  "(0018,9516)" => "StartAcquisitionDateTime",
  "(0018,9517)" => "EndAcquisitionDateTime",
  "(0018,9524)" => "ApplicationName",
  "(0018,9525)" => "ApplicationVersion",
  "(0018,9526)" => "ApplicationManufacturer",
  "(0018,9527)" => "AlgorithmType",
  "(0018,9528)" => "AlgorithmDescription",
  "(0018,9530)" => "XRay3DReconstructionSequence",
  "(0018,9531)" => "ReconstructionDescription",
  "(0018,9538)" => "PerProjectionAcquisitionSequence",
  "(0018,9601)" => "DiffusionBMatrixSequence",
  "(0018,9602)" => "DiffusionBMatrixValueXX",
  "(0018,9603)" => "DiffusionBMatrixValueXY",
  "(0018,9604)" => "DiffusionBMatrixValueXZ",
  "(0018,9605)" => "DiffusionBMatrixValueYY",
  "(0018,9606)" => "DiffusionBMatrixValueYZ",
  "(0018,9607)" => "DiffusionBMatrixValueZZ",
  "(0018,a001)" => "ContributingEquipmentSequence",
  "(0018,a002)" => "ContributionDateTime",
  "(0018,a003)" => "ContributionDescription",
  "(0020,000d)" => "StudyInstanceUID",
  "(0020,000e)" => "SeriesInstanceUID",
  "(0020,0010)" => "StudyID",
  "(0020,0011)" => "SeriesNumber",
  "(0020,0012)" => "AcquisitionNumber",
  "(0020,0013)" => "InstanceNumber",
  "(0020,0014)" => "IsotopeNumber",
  "(0020,0015)" => "PhaseNumber",
  "(0020,0016)" => "IntervalNumber",
  "(0020,0017)" => "TimeSlotNumber",
  "(0020,0018)" => "AngleNumber",
  "(0020,0019)" => "ItemNumber",
  "(0020,0020)" => "PatientOrientation",
  "(0020,0022)" => "OverlayNumber",
  "(0020,0024)" => "CurveNumber",
  "(0020,0026)" => "LUTNumber",
  "(0020,0030)" => "ImagePosition",
  "(0020,0032)" => "ImagePositionPatient",
  "(0020,0035)" => "ImageOrientation",
  "(0020,0037)" => "ImageOrientationPatient",
  "(0020,0050)" => "Location",
  "(0020,0052)" => "FrameOfReferenceUID",
  "(0020,0060)" => "Laterality",
  "(0020,0062)" => "ImageLaterality",
  "(0020,0070)" => "ImageGeometryType",
  "(0020,0080)" => "MaskingImage",
  "(0020,00aa)" => "ReportNumberTrial",
  "(0020,0100)" => "TemporalPositionIdentifier",
  "(0020,0105)" => "NumberOfTemporalPositions",
  "(0020,0110)" => "TemporalResolution",
  "(0020,0200)" => "SynchronizationFrameOfReferenceUID",
  "(0020,1000)" => "SeriesInStudy",
  "(0020,1001)" => "AcquisitionsInSeries",
  "(0020,1002)" => "ImagesInAcquisition",
  "(0020,1003)" => "ImagesInSeries",
  "(0020,1004)" => "AcquisitionsInStudy",
  "(0020,1005)" => "ImagesInStudy",
  "(0020,1020)" => "Reference",
  "(0020,1040)" => "PositionReferenceIndicator",
  "(0020,1041)" => "SliceLocation",
  "(0020,1070)" => "OtherStudyNumbers",
  "(0020,1200)" => "NumberOfPatientRelatedStudies",
  "(0020,1202)" => "NumberOfPatientRelatedSeries",
  "(0020,1204)" => "NumberOfPatientRelatedInstances",
  "(0020,1206)" => "NumberOfStudyRelatedSeries",
  "(0020,1208)" => "NumberOfStudyRelatedInstances",
  "(0020,1209)" => "NumberOfSeriesRelatedInstances",
  "(0020,3401)" => "ModifyingDeviceID",
  "(0020,3402)" => "ModifiedImageID",
  "(0020,3403)" => "ModifiedImageDate",
  "(0020,3404)" => "ModifyingDeviceManufacturer",
  "(0020,3405)" => "ModifiedImageTime",
  "(0020,3406)" => "ModifiedImageDescription",
  "(0020,4000)" => "ImageComments",
  "(0020,5000)" => "OriginalImageIdentification",
  "(0020,5002)" => "OriginalImageIdentificationNomenclature",
  "(0020,9056)" => "StackID",
  "(0020,9057)" => "InStackPositionNumber",
  "(0020,9071)" => "FrameAnatomySequence",
  "(0020,9072)" => "FrameLaterality",
  "(0020,9111)" => "FrameContentSequence",
  "(0020,9113)" => "PlanePositionSequence",
  "(0020,9116)" => "PlaneOrientationSequence",
  "(0020,9128)" => "TemporalPositionIndex",
  "(0020,9153)" => "NominalCardiacTriggerDelayTime",
  "(0020,9156)" => "FrameAcquisitionNumber",
  "(0020,9157)" => "DimensionIndexValues",
  "(0020,9158)" => "FrameComments",
  "(0020,9161)" => "ConcatenationUID",
  "(0020,9162)" => "InConcatenationNumber",
  "(0020,9163)" => "InConcatenationTotalNumber",
  "(0020,9164)" => "DimensionOrganizationUID",
  "(0020,9165)" => "DimensionIndexPointer",
  "(0020,9167)" => "FunctionalGroupPointer",
  "(0020,9213)" => "DimensionIndexPrivateCreator",
  "(0020,9221)" => "DimensionOrganizationSequence",
  "(0020,9222)" => "DimensionIndexSequence",
  "(0020,9228)" => "ConcatenationFrameOffsetNumber",
  "(0020,9238)" => "FunctionalGroupPrivateCreator",
  "(0020,9241)" => "NominalPercentageOfCardiacPhase",
  "(0020,9245)" => "NominalPercentageOfRespiratoryPhase",
  "(0020,9246)" => "StartingRespiratoryAmplitude",
  "(0020,9247)" => "StartingRespiratoryPhase",
  "(0020,9248)" => "EndingRespiratoryAmplitude",
  "(0020,9249)" => "EndingRespiratoryPhase",
  "(0020,9250)" => "RespiratoryTriggerType",
  "(0020,9251)" => "RRIntervalTimeNominal",
  "(0020,9252)" => "ActualCardiacTriggerDelayTime",
  "(0020,9253)" => "RespiratorySynchronizationSequence",
  "(0020,9254)" => "RespiratoryIntervalTime",
  "(0020,9255)" => "NominalRespiratoryTriggerDelayTime",
  "(0020,9256)" => "RespiratoryTriggerDelayThreshold",
  "(0020,9257)" => "ActualRespiratoryTriggerDelayTime",
  "(0020,9421)" => "DimensionDescriptionLabel",
  "(0020,9450)" => "PatientOrientationInFrameSequence",
  "(0020,9453)" => "FrameLabel",
  "(0020,9518)" => "AcquisitionIndex",
  "(0020,9529)" => "ContributingSOPInstancesReferenceSequence",
  "(0020,9536)" => "ReconstructionIndex",
  "(0022,0001)" => "LightPathFilterPassThroughWavelength",
  "(0022,0002)" => "LightPathFilterPassBand",
  "(0022,0003)" => "ImagePathFilterPassThroughWavelength",
  "(0022,0004)" => "ImagePathFilterPassBand",
  "(0022,0005)" => "PatientEyeMovementCommanded",
  "(0022,0006)" => "PatientEyeMovementCommandedCodeSequence",
  "(0022,0007)" => "SphericalLensPower",
  "(0022,0008)" => "CylinderLensPower",
  "(0022,0009)" => "CylinderAxis",
  "(0022,000a)" => "EmmetropicMagnification",
  "(0022,000b)" => "IntraOcularPressure",
  "(0022,000c)" => "HorizontalFieldOfView",
  "(0022,000d)" => "PupilDilated",
  "(0022,000e)" => "DegreeOfDilation",
  "(0022,0010)" => "StereoBaselineAngle",
  "(0022,0011)" => "StereoBaselineDisplacement",
  "(0022,0012)" => "StereoHorizontalPixelOffset",
  "(0022,0013)" => "StereoVerticalPixelOffset",
  "(0022,0014)" => "StereoRotation",
  "(0022,0015)" => "AcquisitionDeviceTypeCodeSequence",
  "(0022,0016)" => "IlluminationTypeCodeSequence",
  "(0022,0017)" => "LightPathFilterTypeStackCodeSequence",
  "(0022,0018)" => "ImagePathFilterTypeStackCodeSequence",
  "(0022,0019)" => "LensesCodeSequence",
  "(0022,001a)" => "ChannelDescriptionCodeSequence",
  "(0022,001b)" => "RefractiveStateSequence",
  "(0022,001c)" => "MydriaticAgentCodeSequence",
  "(0022,001d)" => "RelativeImagePositionCodeSequence",
  "(0022,0020)" => "StereoPairsSequence",
  "(0022,0021)" => "LeftImageSequence",
  "(0022,0022)" => "RightImageSequence",
  "(0022,0030)" => "AxialLengthOfEye",
  "(0022,0031)" => "OphthalmicFrameLocationSequence",
  "(0022,0032)" => "ReferenceCoordinates",
  "(0022,0035)" => "DepthSpatialResolution",
  "(0022,0036)" => "MaximumDepthDistortion",
  "(0022,0037)" => "AlongScanSpatialResolution",
  "(0022,0038)" => "MaximumAlongScanDistortion",
  "(0022,0039)" => "OphthalmicImageOrientation",
  "(0022,0041)" => "DepthOfTransverseImage",
  "(0022,0042)" => "MydriaticAgentConcentrationUnitsSequence",
  "(0022,0048)" => "AcrossScanSpatialResolution",
  "(0022,0049)" => "MaximumAcrossScanDistortion",
  "(0022,004e)" => "MydriaticAgentConcentration",
  "(0022,0055)" => "IlluminationWaveLength",
  "(0022,0056)" => "IlluminationPower",
  "(0022,0057)" => "IlluminationBandwidth",
  "(0022,0058)" => "MydriaticAgentSequence",
  "(0028,0002)" => "SamplesPerPixel",
  "(0028,0003)" => "SamplesPerPixelUsed",
  "(0028,0004)" => "PhotometricInterpretation",
  "(0028,0005)" => "ImageDimensions",
  "(0028,0006)" => "PlanarConfiguration",
  "(0028,0008)" => "NumberOfFrames",
  "(0028,0009)" => "FrameIncrementPointer",
  "(0028,000a)" => "FrameDimensionPointer",
  "(0028,0010)" => "Rows",
  "(0028,0011)" => "Columns",
  "(0028,0012)" => "Planes",
  "(0028,0014)" => "UltrasoundColorDataPresent",
  "(0028,0030)" => "PixelSpacing",
  "(0028,0031)" => "ZoomFactor",
  "(0028,0032)" => "ZoomCenter",
  "(0028,0034)" => "PixelAspectRatio",
  "(0028,0040)" => "ImageFormat",
  "(0028,0050)" => "ManipulatedImage",
  "(0028,0051)" => "CorrectedImage",
  "(0028,005f)" => "CompressionRecognitionCode",
  "(0028,0060)" => "CompressionCode",
  "(0028,0061)" => "CompressionOriginator",
  "(0028,0062)" => "CompressionLabel",
  "(0028,0063)" => "CompressionDescription",
  "(0028,0065)" => "CompressionSequence",
  "(0028,0066)" => "CompressionStepPointers",
  "(0028,0068)" => "RepeatInterval",
  "(0028,0069)" => "BitsGrouped",
  "(0028,0070)" => "PerimeterTable",
  "(0028,0071)" => "PerimeterValue",
  "(0028,0080)" => "PredictorRows",
  "(0028,0081)" => "PredictorColumns",
  "(0028,0082)" => "PredictorConstants",
  "(0028,0090)" => "BlockedPixels",
  "(0028,0091)" => "BlockRows",
  "(0028,0092)" => "BlockColumns",
  "(0028,0093)" => "RowOverlap",
  "(0028,0094)" => "ColumnOverlap",
  "(0028,0100)" => "BitsAllocated",
  "(0028,0101)" => "BitsStored",
  "(0028,0102)" => "HighBit",
  "(0028,0103)" => "PixelRepresentation",
  "(0028,0104)" => "SmallestValidPixelValue",
  "(0028,0105)" => "LargestValidPixelValue",
  "(0028,0106)" => "SmallestImagePixelValue",
  "(0028,0107)" => "LargestImagePixelValue",
  "(0028,0108)" => "SmallestPixelValueInSeries",
  "(0028,0109)" => "LargestPixelValueInSeries",
  "(0028,0110)" => "SmallestPixelValueInPlane",
  "(0028,0111)" => "LargestPixelValueInPlane",
  "(0028,0120)" => "PixelPaddingValue",
  "(0028,0121)" => "PixelPaddingRangeLimit",
  "(0028,0200)" => "ImageLocation",
  "(0028,0300)" => "QualityControlImage",
  "(0028,0301)" => "BurnedInAnnotation",
  "(0028,0400)" => "TransformLabel",
  "(0028,0401)" => "TransformVersionNumber",
  "(0028,0403)" => "SequenceOfCompressedData",
  "(0028,0700)" => "DCTLabel",
  "(0028,0701)" => "DataBlockDescription",
  "(0028,0702)" => "DataBlock",
  "(0028,0710)" => "NormalizationFactorFormat",
  "(0028,0720)" => "ZonalMapNumberFormat",
  "(0028,0721)" => "ZonalMapLocation",
  "(0028,0722)" => "ZonalMapFormat",
  "(0028,0730)" => "AdaptiveMapFormat",
  "(0028,0740)" => "CodeNumberFormat",
  "(0028,0a02)" => "PixelSpacingCalibrationType",
  "(0028,0a04)" => "PixelSpacingCalibrationDescription",
  "(0028,1040)" => "PixelIntensityRelationship",
  "(0028,1041)" => "PixelIntensityRelationshipSign",
  "(0028,1050)" => "WindowCenter",
  "(0028,1051)" => "WindowWidth",
  "(0028,1052)" => "RescaleIntercept",
  "(0028,1053)" => "RescaleSlope",
  "(0028,1054)" => "RescaleType",
  "(0028,1055)" => "WindowCenterWidthExplanation",
  "(0028,1056)" => "VOILUTFunction",
  "(0028,1080)" => "GrayScale",
  "(0028,1090)" => "RecommendedViewingMode",
  "(0028,1100)" => "GrayLookupTableDescriptor",
  "(0028,1101)" => "RedPaletteColorLookupTableDescriptor",
  "(0028,1102)" => "GreenPaletteColorLookupTableDescriptor",
  "(0028,1103)" => "BluePaletteColorLookupTableDescriptor",
  "(0028,1111)" => "LargeRedPaletteColorLookupTableDescriptor",
  "(0028,1112)" => "LargeGreenPaletteColorLookupTableDescriptor",
  "(0028,1113)" => "LargeBluePaletteColorLookupTableDescriptor",
  "(0028,1199)" => "PaletteColorLookupTableUID",
  "(0028,1200)" => "GrayLookupTableData",
  "(0028,1201)" => "RedPaletteColorLookupTableData",
  "(0028,1202)" => "GreenPaletteColorLookupTableData",
  "(0028,1203)" => "BluePaletteColorLookupTableData",
  "(0028,1211)" => "LargeRedPaletteColorLookupTableData",
  "(0028,1212)" => "LargeGreenPaletteColorLookupTableData",
  "(0028,1213)" => "LargeBluePaletteColorLookupTableData",
  "(0028,1214)" => "LargePaletteColorLookupTableUID",
  "(0028,1221)" => "SegmentedRedPaletteColorLookupTableData",
  "(0028,1222)" => "SegmentedGreenPaletteColorLookupTableData",
  "(0028,1223)" => "SegmentedBluePaletteColorLookupTableData",
  "(0028,1300)" => "ImplantPresent",
  "(0028,1350)" => "PartialView",
  "(0028,1351)" => "PartialViewDescription",
  "(0028,1352)" => "PartialViewCodeSequence",
  "(0028,135a)" => "SpatialLocationsPreserved",
  "(0028,2000)" => "ICCProfile",
  "(0028,2110)" => "LossyImageCompression",
  "(0028,2112)" => "LossyImageCompressionRatio",
  "(0028,2114)" => "LossyImageCompressionMethod",
  "(0028,3000)" => "ModalityLUTSequence",
  "(0028,3002)" => "LUTDescriptor",
  "(0028,3003)" => "LUTExplanation",
  "(0028,3004)" => "ModalityLUTType",
  "(0028,3006)" => "LUTData",
  "(0028,3010)" => "VOILUTSequence",
  "(0028,3110)" => "SoftcopyVOILUTSequence",
  "(0028,4000)" => "ImagePresentationComments",
  "(0028,5000)" => "BiplaneAcquisitionSequence",
  "(0028,6010)" => "RepresentativeFrameNumber",
  "(0028,6020)" => "FrameNumbersOfInterest",
  "(0028,6022)" => "FrameOfInterestDescription",
  "(0028,6023)" => "FrameOfInterestType",
  "(0028,6030)" => "MaskPointer",
  "(0028,6040)" => "RWavePointer",
  "(0028,6100)" => "MaskSubtractionSequence",
  "(0028,6101)" => "MaskOperation",
  "(0028,6102)" => "ApplicableFrameRange",
  "(0028,6110)" => "MaskFrameNumbers",
  "(0028,6112)" => "ContrastFrameAveraging",
  "(0028,6114)" => "MaskSubPixelShift",
  "(0028,6120)" => "TIDOffset",
  "(0028,6190)" => "MaskOperationExplanation",
  "(0028,7fe0)" => "PixelDataProviderURL",
  "(0028,9001)" => "DataPointRows",
  "(0028,9002)" => "DataPointColumns",
  "(0028,9003)" => "SignalDomainColumns",
  "(0028,9099)" => "LargestMonochromePixelValue",
  "(0028,9108)" => "DataRepresentation",
  "(0028,9110)" => "PixelMeasuresSequence",
  "(0028,9132)" => "FrameVOILUTSequence",
  "(0028,9145)" => "PixelValueTransformationSequence",
  "(0028,9235)" => "SignalDomainRows",
  "(0028,9411)" => "DisplayFilterPercentage",
  "(0028,9415)" => "FramePixelShiftSequence",
  "(0028,9416)" => "SubtractionItemID",
  "(0028,9422)" => "PixelIntensityRelationshipLUTSequence",
  "(0028,9443)" => "FramePixelDataPropertiesSequence",
  "(0028,9444)" => "GeometricalProperties",
  "(0028,9445)" => "GeometricMaximumDistortion",
  "(0028,9446)" => "ImageProcessingApplied",
  "(0028,9454)" => "MaskSelectionMode",
  "(0028,9474)" => "LUTFunction",
  "(0028,9478)" => "MaskVisibilityPercentage",
  "(0028,9520)" => "ImageToEquipmentMappingMatrix",
  "(0028,9537)" => "EquipmentCoordinateSystemIdentification",
  "(0032,000a)" => "StudyStatusID",
  "(0032,000c)" => "StudyPriorityID",
  "(0032,0012)" => "StudyIDIssuer",
  "(0032,0032)" => "StudyVerifiedDate",
  "(0032,0033)" => "StudyVerifiedTime",
  "(0032,0034)" => "StudyReadDate",
  "(0032,0035)" => "StudyReadTime",
  "(0032,1000)" => "ScheduledStudyStartDate",
  "(0032,1001)" => "ScheduledStudyStartTime",
  "(0032,1010)" => "ScheduledStudyStopDate",
  "(0032,1011)" => "ScheduledStudyStopTime",
  "(0032,1020)" => "ScheduledStudyLocation",
  "(0032,1021)" => "ScheduledStudyLocationAETitle",
  "(0032,1030)" => "ReasonForStudy",
  "(0032,1031)" => "RequestingPhysicianIdentificationSequence",
  "(0032,1032)" => "RequestingPhysician",
  "(0032,1033)" => "RequestingService",
  "(0032,1040)" => "StudyArrivalDate",
  "(0032,1041)" => "StudyArrivalTime",
  "(0032,1050)" => "StudyCompletionDate",
  "(0032,1051)" => "StudyCompletionTime",
  "(0032,1055)" => "StudyComponentStatusID",
  "(0032,1060)" => "RequestedProcedureDescription",
  "(0032,1064)" => "RequestedProcedureCodeSequence",
  "(0032,1070)" => "RequestedContrastAgent",
  "(0032,4000)" => "StudyComments",
  "(0038,0004)" => "ReferencedPatientAliasSequence",
  "(0038,0008)" => "VisitStatusID",
  "(0038,0010)" => "AdmissionID",
  "(0038,0011)" => "IssuerOfAdmissionID",
  "(0038,0014)" => "IssuerOfAdmissionIDSequence",
  "(0038,0016)" => "RouteOfAdmissions",
  "(0038,001a)" => "ScheduledAdmissionDate",
  "(0038,001b)" => "ScheduledAdmissionTime",
  "(0038,001c)" => "ScheduledDischargeDate",
  "(0038,001d)" => "ScheduledDischargeTime",
  "(0038,001e)" => "ScheduledPatientInstitutionResidence",
  "(0038,0020)" => "AdmittingDate",
  "(0038,0021)" => "AdmittingTime",
  "(0038,0030)" => "DischargeDate",
  "(0038,0032)" => "DischargeTime",
  "(0038,0040)" => "DischargeDiagnosisDescription",
  "(0038,0044)" => "DischargeDiagnosisCodeSequence",
  "(0038,0050)" => "SpecialNeeds",
  "(0038,0060)" => "ServiceEpisodeID",
  "(0038,0061)" => "IssuerOfServiceEpisodeID",
  "(0038,0062)" => "ServiceEpisodeDescription",
  "(0038,0064)" => "IssuerOfServiceEpisodeIDSequence",
  "(0038,0100)" => "PertinentDocumentsSequence",
  "(0038,0300)" => "CurrentPatientLocation",
  "(0038,0400)" => "PatientInstitutionResidence",
  "(0038,0500)" => "PatientState",
  "(0038,0502)" => "PatientClinicalTrialParticipationSequence",
  "(0038,4000)" => "VisitComments",
  "(003a,0004)" => "WaveformOriginality",
  "(003a,0005)" => "NumberOfWaveformChannels",
  "(003a,0010)" => "NumberOfWaveformSamples",
  "(003a,001a)" => "SamplingFrequency",
  "(003a,0020)" => "MultiplexGroupLabel",
  "(003a,0200)" => "ChannelDefinitionSequence",
  "(003a,0202)" => "WaveformChannelNumber",
  "(003a,0203)" => "ChannelLabel",
  "(003a,0205)" => "ChannelStatus",
  "(003a,0208)" => "ChannelSourceSequence",
  "(003a,0209)" => "ChannelSourceModifiersSequence",
  "(003a,020a)" => "SourceWaveformSequence",
  "(003a,020c)" => "ChannelDerivationDescription",
  "(003a,0210)" => "ChannelSensitivity",
  "(003a,0211)" => "ChannelSensitivityUnitsSequence",
  "(003a,0212)" => "ChannelSensitivityCorrectionFactor",
  "(003a,0213)" => "ChannelBaseline",
  "(003a,0214)" => "ChannelTimeSkew",
  "(003a,0215)" => "ChannelSampleSkew",
  "(003a,0218)" => "ChannelOffset",
  "(003a,021a)" => "WaveformBitsStored",
  "(003a,0220)" => "FilterLowFrequency",
  "(003a,0221)" => "FilterHighFrequency",
  "(003a,0222)" => "NotchFilterFrequency",
  "(003a,0223)" => "NotchFilterBandwidth",
  "(003a,0230)" => "WaveformDataDisplayScale",
  "(003a,0231)" => "WaveformDisplayBackgroundCIELabValue",
  "(003a,0240)" => "WaveformPresentationGroupSequence",
  "(003a,0241)" => "PresentationGroupNumber",
  "(003a,0242)" => "ChannelDisplaySequence",
  "(003a,0244)" => "ChannelRecommendedDisplayCIELabValue",
  "(003a,0245)" => "ChannelPosition",
  "(003a,0246)" => "DisplayShadingFlag",
  "(003a,0247)" => "FractionalChannelDisplayScale",
  "(003a,0248)" => "AbsoluteChannelDisplayScale",
  "(003a,0300)" => "MultiplexedAudioChannelsDescriptionCodeSequence",
  "(003a,0301)" => "ChannelIdentificationCode",
  "(003a,0302)" => "ChannelMode",
  "(0040,0001)" => "ScheduledStationAETitle",
  "(0040,0002)" => "ScheduledProcedureStepStartDate",
  "(0040,0003)" => "ScheduledProcedureStepStartTime",
  "(0040,0004)" => "ScheduledProcedureStepEndDate",
  "(0040,0005)" => "ScheduledProcedureStepEndTime",
  "(0040,0006)" => "ScheduledPerformingPhysicianName",
  "(0040,0007)" => "ScheduledProcedureStepDescription",
  "(0040,0008)" => "ScheduledProtocolCodeSequence",
  "(0040,0009)" => "ScheduledProcedureStepID",
  "(0040,000a)" => "StageCodeSequence",
  "(0040,000b)" => "ScheduledPerformingPhysicianIdentificationSequence",
  "(0040,0010)" => "ScheduledStationName",
  "(0040,0011)" => "ScheduledProcedureStepLocation",
  "(0040,0012)" => "PreMedication",
  "(0040,0020)" => "ScheduledProcedureStepStatus",
  "(0040,0026)" => "OrderPlacerIdentifierSequence",
  "(0040,0027)" => "OrderFillerIdentifierSequence",
  "(0040,0031)" => "LocalNamespaceEntityID",
  "(0040,0032)" => "UniversalEntityID",
  "(0040,0033)" => "UniversalEntityIDType",
  "(0040,0035)" => "IdentifierTypeCode",
  "(0040,0036)" => "AssigningFacilitySequence",
  "(0040,0039)" => "AssigningJurisdictionCodeSequence",
  "(0040,003a)" => "AssigningAgencyOrDepartmentCodeSequence",
  "(0040,0100)" => "ScheduledProcedureStepSequence",
  "(0040,0220)" => "ReferencedNonImageCompositeSOPInstanceSequence",
  "(0040,0241)" => "PerformedStationAETitle",
  "(0040,0242)" => "PerformedStationName",
  "(0040,0243)" => "PerformedLocation",
  "(0040,0244)" => "PerformedProcedureStepStartDate",
  "(0040,0245)" => "PerformedProcedureStepStartTime",
  "(0040,0250)" => "PerformedProcedureStepEndDate",
  "(0040,0251)" => "PerformedProcedureStepEndTime",
  "(0040,0252)" => "PerformedProcedureStepStatus",
  "(0040,0253)" => "PerformedProcedureStepID",
  "(0040,0254)" => "PerformedProcedureStepDescription",
  "(0040,0255)" => "PerformedProcedureTypeDescription",
  "(0040,0260)" => "PerformedProtocolCodeSequence",
  "(0040,0270)" => "ScheduledStepAttributesSequence",
  "(0040,0275)" => "RequestAttributesSequence",
  "(0040,0280)" => "CommentsOnPerformedProcedureStep",
  "(0040,0281)" => "PerformedProcedureStepDiscontinuationReasonCodeSequence",
  "(0040,0293)" => "QuantitySequence",
  "(0040,0294)" => "Quantity",
  "(0040,0295)" => "MeasuringUnitsSequence",
  "(0040,0296)" => "BillingItemSequence",
  "(0040,0300)" => "TotalTimeOfFluoroscopy",
  "(0040,0301)" => "TotalNumberOfExposures",
  "(0040,0302)" => "EntranceDose",
  "(0040,0303)" => "ExposedArea",
  "(0040,0306)" => "DistanceSourceToEntrance",
  "(0040,0307)" => "DistanceSourceToSupport",
  "(0040,030e)" => "ExposureDoseSequence",
  "(0040,0310)" => "CommentsOnRadiationDose",
  "(0040,0312)" => "XRayOutput",
  "(0040,0314)" => "HalfValueLayer",
  "(0040,0316)" => "OrganDose",
  "(0040,0318)" => "OrganExposed",
  "(0040,0320)" => "BillingProcedureStepSequence",
  "(0040,0321)" => "FilmConsumptionSequence",
  "(0040,0324)" => "BillingSuppliesAndDevicesSequence",
  "(0040,0330)" => "ReferencedProcedureStepSequence",
  "(0040,0340)" => "PerformedSeriesSequence",
  "(0040,0400)" => "CommentsOnScheduledProcedureStep",
  "(0040,0440)" => "ProtocolContextSequence",
  "(0040,0441)" => "ContentItemModifierSequence",
  "(0040,050a)" => "SpecimenAccessionNumber",
  "(0040,0550)" => "SpecimenSequence",
  "(0040,0551)" => "SpecimenIdentifier",
  "(0040,0552)" => "SpecimenDescriptionSequenceTrial",
  "(0040,0553)" => "SpecimenDescriptionTrial",
  "(0040,0555)" => "AcquisitionContextSequence",
  "(0040,0556)" => "AcquisitionContextDescription",
  "(0040,059a)" => "SpecimenTypeCodeSequence",
  "(0040,06fa)" => "SlideIdentifier",
  "(0040,071a)" => "ImageCenterPointCoordinatesSequence",
  "(0040,072a)" => "XOffsetInSlideCoordinateSystem",
  "(0040,073a)" => "YOffsetInSlideCoordinateSystem",
  "(0040,074a)" => "ZOffsetInSlideCoordinateSystem",
  "(0040,08d8)" => "PixelSpacingSequence",
  "(0040,08da)" => "CoordinateSystemAxisCodeSequence",
  "(0040,08ea)" => "MeasurementUnitsCodeSequence",
  "(0040,09f8)" => "VitalStainCodeSequenceTrial",
  "(0040,1001)" => "RequestedProcedureID",
  "(0040,1002)" => "ReasonForRequestedProcedure",
  "(0040,1003)" => "RequestedProcedurePriority",
  "(0040,1004)" => "PatientTransportArrangements",
  "(0040,1005)" => "RequestedProcedureLocation",
  "(0040,1006)" => "PlacerOrderNumberOfProcedure",
  "(0040,1007)" => "FillerOrderNumberOfProcedure",
  "(0040,1008)" => "ConfidentialityCode",
  "(0040,1009)" => "ReportingPriority",
  "(0040,100a)" => "ReasonForRequestedProcedureCodeSequence",
  "(0040,1010)" => "NamesOfIntendedRecipientsOfResults",
  "(0040,1011)" => "IntendedRecipientsOfResultsIdentificationSequence",
  "(0040,1101)" => "PersonIdentificationCodeSequence",
  "(0040,1102)" => "PersonAddress",
  "(0040,1103)" => "PersonTelephoneNumbers",
  "(0040,1400)" => "RequestedProcedureComments",
  "(0040,2001)" => "ReasonForImagingServiceRequest",
  "(0040,2004)" => "IssueDateOfImagingServiceRequest",
  "(0040,2005)" => "IssueTimeOfImagingServiceRequest",
  "(0040,2006)" => "PlacerOrderNumberOfImagingServiceRequestRetired",
  "(0040,2007)" => "FillerOrderNumberOfImagingServiceRequestRetired",
  "(0040,2008)" => "OrderEnteredBy",
  "(0040,2009)" => "OrderEntererLocation",
  "(0040,2010)" => "OrderCallbackPhoneNumber",
  "(0040,2016)" => "PlacerOrderNumberOfImagingServiceRequest",
  "(0040,2017)" => "FillerOrderNumberOfImagingServiceRequest",
  "(0040,2400)" => "ImagingServiceRequestComments",
  "(0040,3001)" => "ConfidentialityConstraintOnPatientDataDescription",
  "(0040,4001)" => "GeneralPurposeScheduledProcedureStepStatus",
  "(0040,4002)" => "GeneralPurposePerformedProcedureStepStatus",
  "(0040,4003)" => "GeneralPurposeScheduledProcedureStepPriority",
  "(0040,4004)" => "ScheduledProcessingApplicationsCodeSequence",
  "(0040,4005)" => "ScheduledProcedureStepStartDateAndTime",
  "(0040,4006)" => "MultipleCopiesFlag",
  "(0040,4007)" => "PerformedProcessingApplicationsCodeSequence",
  "(0040,4009)" => "HumanPerformerCodeSequence",
  "(0040,4010)" => "ScheduledProcedureStepModificationDateAndTime",
  "(0040,4011)" => "ExpectedCompletionDateAndTime",
  "(0040,4015)" => "ResultingGeneralPurposePerformedProcedureStepsSequence",
  "(0040,4016)" => "ReferencedGeneralPurposeScheduledProcedureStepSequence",
  "(0040,4018)" => "ScheduledWorkitemCodeSequence",
  "(0040,4019)" => "PerformedWorkitemCodeSequence",
  "(0040,4020)" => "InputAvailabilityFlag",
  "(0040,4021)" => "InputInformationSequence",
  "(0040,4022)" => "RelevantInformationSequence",
  "(0040,4023)" => "ReferencedGeneralPurposeScheduledProcedureStepTransactionUID",
  "(0040,4025)" => "ScheduledStationNameCodeSequence",
  "(0040,4026)" => "ScheduledStationClassCodeSequence",
  "(0040,4027)" => "ScheduledStationGeographicLocationCodeSequence",
  "(0040,4028)" => "PerformedStationNameCodeSequence",
  "(0040,4029)" => "PerformedStationClassCodeSequence",
  "(0040,4030)" => "PerformedStationGeographicLocationCodeSequence",
  "(0040,4031)" => "RequestedSubsequentWorkitemCodeSequence",
  "(0040,4032)" => "NonDICOMOutputCodeSequence",
  "(0040,4033)" => "OutputInformationSequence",
  "(0040,4034)" => "ScheduledHumanPerformersSequence",
  "(0040,4035)" => "ActualHumanPerformersSequence",
  "(0040,4036)" => "HumanPerformersOrganization",
  "(0040,4037)" => "HumanPerformersName",
  "(0040,8302)" => "EntranceDoseInmGy",
  "(0040,9094)" => "ReferencedImageRealWorldValueMappingSequence",
  "(0040,9096)" => "RealWorldValueMappingSequence",
  "(0040,9098)" => "PixelValueMappingCodeSequence",
  "(0040,9210)" => "LUTLabel",
  "(0040,9211)" => "RealWorldValueLastValueMapped",
  "(0040,9212)" => "RealWorldValueLUTData",
  "(0040,9216)" => "RealWorldValueFirstValueMapped",
  "(0040,9224)" => "RealWorldValueIntercept",
  "(0040,9225)" => "RealWorldValueSlope",
  "(0040,a007)" => "FindingsFlagTrial",
  "(0040,a010)" => "RelationshipType",
  "(0040,a020)" => "FindingsSequenceTrial",
  "(0040,a021)" => "FindingsGroupUIDTrial",
  "(0040,a022)" => "ReferencedFindingsGroupUIDTrial",
  "(0040,a023)" => "FindingsGroupRecordingDateTrial",
  "(0040,a024)" => "FindingsGroupRecordingTimeTrial",
  "(0040,a026)" => "FindingsSourceCategoryCodeSequenceTrial",
  "(0040,a027)" => "VerifyingOrganization",
  "(0040,a028)" => "DocumentingOrganizationIdentifierCodeSequenceTrial",
  "(0040,a030)" => "VerificationDateTime",
  "(0040,a032)" => "ObservationDateTime",
  "(0040,a040)" => "ValueType",
  "(0040,a043)" => "ConceptNameCodeSequence",
  "(0040,a047)" => "MeasurementPrecisionDescriptionTrial",
  "(0040,a050)" => "ContinuityOfContent",
  "(0040,a057)" => "UrgencyOrPriorityAlertsTrial",
  "(0040,a060)" => "SequencingIndicatorTrial",
  "(0040,a066)" => "DocumentIdentifierCodeSequenceTrial",
  "(0040,a067)" => "DocumentAuthorTrial",
  "(0040,a068)" => "DocumentAuthorIdentifierCodeSequenceTrial",
  "(0040,a070)" => "IdentifierCodeSequenceTrial",
  "(0040,a073)" => "VerifyingObserverSequence",
  "(0040,a074)" => "ObjectBinaryIdentifierTrial",
  "(0040,a075)" => "VerifyingObserverName",
  "(0040,a076)" => "DocumentingObserverIdentifierCodeSequenceTrial",
  "(0040,a078)" => "AuthorObserverSequence",
  "(0040,a07a)" => "ParticipantSequence",
  "(0040,a07c)" => "CustodialOrganizationSequence",
  "(0040,a080)" => "ParticipationType",
  "(0040,a082)" => "ParticipationDateTime",
  "(0040,a084)" => "ObserverType",
  "(0040,a085)" => "ProcedureIdentifierCodeSequenceTrial",
  "(0040,a088)" => "VerifyingObserverIdentificationCodeSequence",
  "(0040,a089)" => "ObjectDirectoryBinaryIdentifierTrial",
  "(0040,a090)" => "EquivalentCDADocumentSequence",
  "(0040,a0b0)" => "ReferencedWaveformChannels",
  "(0040,a110)" => "DateOfDocumentOrVerbalTransactionTrial",
  "(0040,a112)" => "TimeOfDocumentCreationOrVerbalTransactionTrial",
  "(0040,a120)" => "DateTime",
  "(0040,a121)" => "Date",
  "(0040,a122)" => "Time",
  "(0040,a123)" => "PersonName",
  "(0040,a124)" => "UID",
  "(0040,a125)" => "ReportStatusIDTrial",
  "(0040,a130)" => "TemporalRangeType",
  "(0040,a132)" => "ReferencedSamplePositions",
  "(0040,a136)" => "ReferencedFrameNumbers",
  "(0040,a138)" => "ReferencedTimeOffsets",
  "(0040,a13a)" => "ReferencedDateTime",
  "(0040,a160)" => "TextValue",
  "(0040,a167)" => "ObservationCategoryCodeSequenceTrial",
  "(0040,a168)" => "ConceptCodeSequence",
  "(0040,a16a)" => "BibliographicCitationTrial",
  "(0040,a170)" => "PurposeOfReferenceCodeSequence",
  "(0040,a171)" => "ObservationUIDTrial",
  "(0040,a172)" => "ReferencedObservationUIDTrial",
  "(0040,a173)" => "ReferencedObservationClassTrial",
  "(0040,a174)" => "ReferencedObjectObservationClassTrial",
  "(0040,a180)" => "AnnotationGroupNumber",
  "(0040,a192)" => "ObservationDateTrial",
  "(0040,a193)" => "ObservationTimeTrial",
  "(0040,a194)" => "MeasurementAutomationTrial",
  "(0040,a195)" => "ModifierCodeSequence",
  "(0040,a224)" => "IdentificationDescriptionTrial",
  "(0040,a290)" => "CoordinatesSetGeometricTypeTrial",
  "(0040,a296)" => "AlgorithmCodeSequenceTrial",
  "(0040,a297)" => "AlgorithmDescriptionTrial",
  "(0040,a29a)" => "PixelCoordinatesSetTrial",
  "(0040,a300)" => "MeasuredValueSequence",
  "(0040,a301)" => "NumericValueQualifierCodeSequence",
  "(0040,a307)" => "CurrentObserverTrial",
  "(0040,a30a)" => "NumericValue",
  "(0040,a313)" => "ReferencedAccessionSequenceTrial",
  "(0040,a33a)" => "ReportStatusCommentTrial",
  "(0040,a340)" => "ProcedureContextSequenceTrial",
  "(0040,a352)" => "VerbalSourceTrial",
  "(0040,a353)" => "AddressTrial",
  "(0040,a354)" => "TelephoneNumberTrial",
  "(0040,a358)" => "VerbalSourceIdentifierCodeSequenceTrial",
  "(0040,a360)" => "PredecessorDocumentsSequence",
  "(0040,a370)" => "ReferencedRequestSequence",
  "(0040,a372)" => "PerformedProcedureCodeSequence",
  "(0040,a375)" => "CurrentRequestedProcedureEvidenceSequence",
  "(0040,a380)" => "ReportDetailSequenceTrial",
  "(0040,a385)" => "PertinentOtherEvidenceSequence",
  "(0040,a390)" => "HL7StructuredDocumentReferenceSequence",
  "(0040,a402)" => "ObservationSubjectUIDTrial",
  "(0040,a403)" => "ObservationSubjectClassTrial",
  "(0040,a404)" => "ObservationSubjectTypeCodeSequenceTrial",
  "(0040,a491)" => "CompletionFlag",
  "(0040,a492)" => "CompletionFlagDescription",
  "(0040,a493)" => "VerificationFlag",
  "(0040,a494)" => "ArchiveRequested",
  "(0040,a504)" => "ContentTemplateSequence",
  "(0040,a525)" => "IdenticalDocumentsSequence",
  "(0040,a600)" => "ObservationSubjectContextFlagTrial",
  "(0040,a601)" => "ObserverContextFlagTrial",
  "(0040,a603)" => "ProcedureContextFlagTrial",
  "(0040,a730)" => "ContentSequence",
  "(0040,a731)" => "RelationshipSequenceTrial",
  "(0040,a732)" => "RelationshipTypeCodeSequenceTrial",
  "(0040,a744)" => "LanguageCodeSequenceTrial",
  "(0040,a992)" => "UniformResourceLocatorTrial",
  "(0040,b020)" => "AnnotationSequence",
  "(0040,db00)" => "TemplateIdentifier",
  "(0040,db06)" => "TemplateVersion",
  "(0040,db07)" => "TemplateLocalVersion",
  "(0040,db0b)" => "TemplateExtensionFlag",
  "(0040,db0c)" => "TemplateExtensionOrganizationUID",
  "(0040,db0d)" => "TemplateExtensionCreatorUID",
  "(0040,db73)" => "RelationshipTypeCodeSequenceModifierTrial",
  "(0040,db73)" => "ReferencedContentItemIdentifier",
  "(0040,e001)" => "HL7InstanceIdentifier",
  "(0040,e004)" => "HL7DocumentEffectiveTime",
  "(0040,e006)" => "HL7DocumentTypeCodeSequence",
  "(0040,e010)" => "RetrieveURI",
  "(0042,0010)" => "DocumentTitle",
  "(0042,0011)" => "EncapsulatedDocument",
  "(0042,0012)" => "MIMETypeOfEncapsulatedDocument",
  "(0042,0013)" => "SourceInstanceSequence",
  "(0042,0014)" => "ListOfMIMETypes",
  "(0044,0001)" => "ProductPackageIdentifier",
  "(0044,0002)" => "SubstanceAdministrationApproval",
  "(0044,0003)" => "ApprovalStatusFurtherDescription",
  "(0044,0004)" => "ApprovalStatusDateTime",
  "(0044,0007)" => "ProductTypeCodeSequence",
  "(0044,0008)" => "ProductName",
  "(0044,0009)" => "ProductDescription",
  "(0044,000a)" => "ProductLotIdentifier",
  "(0044,000b)" => "ProductExpirationDateTime",
  "(0044,0010)" => "SubstanceAdministrationDateTime",
  "(0044,0011)" => "SubstanceAdministrationNotes",
  "(0044,0012)" => "SubstanceAdministrationDeviceID",
  "(0044,0013)" => "ProductParameterSequence",
  "(0044,0019)" => "SubstanceAdministrationParameterSequence",
  "(0050,0004)" => "CalibrationImage",
  "(0050,0010)" => "DeviceSequence",
  "(0050,0014)" => "DeviceLength",
  "(0050,0016)" => "DeviceDiameter",
  "(0050,0017)" => "DeviceDiameterUnits",
  "(0050,0018)" => "DeviceVolume",
  "(0050,0019)" => "InterMarkerDistance",
  "(0050,0020)" => "DeviceDescription",
  "(0054,0010)" => "EnergyWindowVector",
  "(0054,0011)" => "NumberOfEnergyWindows",
  "(0054,0012)" => "EnergyWindowInformationSequence",
  "(0054,0013)" => "EnergyWindowRangeSequence",
  "(0054,0014)" => "EnergyWindowLowerLimit",
  "(0054,0015)" => "EnergyWindowUpperLimit",
  "(0054,0016)" => "RadiopharmaceuticalInformationSequence",
  "(0054,0017)" => "ResidualSyringeCounts",
  "(0054,0018)" => "EnergyWindowName",
  "(0054,0020)" => "DetectorVector",
  "(0054,0021)" => "NumberOfDetectors",
  "(0054,0022)" => "DetectorInformationSequence",
  "(0054,0030)" => "PhaseVector",
  "(0054,0031)" => "NumberOfPhases",
  "(0054,0032)" => "PhaseInformationSequence",
  "(0054,0033)" => "NumberOfFramesInPhase",
  "(0054,0036)" => "PhaseDelay",
  "(0054,0038)" => "PauseBetweenFrames",
  "(0054,0039)" => "PhaseDescription",
  "(0054,0050)" => "RotationVector",
  "(0054,0051)" => "NumberOfRotations",
  "(0054,0052)" => "RotationInformationSequence",
  "(0054,0053)" => "NumberOfFramesInRotation",
  "(0054,0060)" => "RRIntervalVector",
  "(0054,0061)" => "NumberOfRRIntervals",
  "(0054,0062)" => "GatedInformationSequence",
  "(0054,0063)" => "DataInformationSequence",
  "(0054,0070)" => "TimeSlotVector",
  "(0054,0071)" => "NumberOfTimeSlots",
  "(0054,0072)" => "TimeSlotInformationSequence",
  "(0054,0073)" => "TimeSlotTime",
  "(0054,0080)" => "SliceVector",
  "(0054,0081)" => "NumberOfSlices",
  "(0054,0090)" => "AngularViewVector",
  "(0054,0100)" => "TimeSliceVector",
  "(0054,0101)" => "NumberOfTimeSlices",
  "(0054,0200)" => "StartAngle",
  "(0054,0202)" => "TypeOfDetectorMotion",
  "(0054,0210)" => "TriggerVector",
  "(0054,0211)" => "NumberOfTriggersInPhase",
  "(0054,0220)" => "ViewCodeSequence",
  "(0054,0222)" => "ViewModifierCodeSequence",
  "(0054,0300)" => "RadionuclideCodeSequence",
  "(0054,0302)" => "AdministrationRouteCodeSequence",
  "(0054,0304)" => "RadiopharmaceuticalCodeSequence",
  "(0054,0306)" => "CalibrationDataSequence",
  "(0054,0308)" => "EnergyWindowNumber",
  "(0054,0400)" => "ImageID",
  "(0054,0410)" => "PatientOrientationCodeSequence",
  "(0054,0412)" => "PatientOrientationModifierCodeSequence",
  "(0054,0414)" => "PatientGantryRelationshipCodeSequence",
  "(0054,0500)" => "SliceProgressionDirection",
  "(0054,1000)" => "SeriesType",
  "(0054,1001)" => "Units",
  "(0054,1002)" => "CountsSource",
  "(0054,1004)" => "ReprojectionMethod",
  "(0054,1100)" => "RandomsCorrectionMethod",
  "(0054,1101)" => "AttenuationCorrectionMethod",
  "(0054,1102)" => "DecayCorrection",
  "(0054,1103)" => "ReconstructionMethod",
  "(0054,1104)" => "DetectorLinesOfResponseUsed",
  "(0054,1105)" => "ScatterCorrectionMethod",
  "(0054,1200)" => "AxialAcceptance",
  "(0054,1201)" => "AxialMash",
  "(0054,1202)" => "TransverseMash",
  "(0054,1203)" => "DetectorElementSize",
  "(0054,1210)" => "CoincidenceWindowWidth",
  "(0054,1220)" => "SecondaryCountsType",
  "(0054,1300)" => "FrameReferenceTime",
  "(0054,1310)" => "PrimaryPromptsCountsAccumulated",
  "(0054,1311)" => "SecondaryCountsAccumulated",
  "(0054,1320)" => "SliceSensitivityFactor",
  "(0054,1321)" => "DecayFactor",
  "(0054,1322)" => "DoseCalibrationFactor",
  "(0054,1323)" => "ScatterFractionFactor",
  "(0054,1324)" => "DeadTimeFactor",
  "(0054,1330)" => "ImageIndex",
  "(0054,1400)" => "CountsIncluded",
  "(0054,1401)" => "DeadTimeCorrectionFlag",
  "(0060,3000)" => "HistogramSequence",
  "(0060,3002)" => "HistogramNumberOfBins",
  "(0060,3004)" => "HistogramFirstBinValue",
  "(0060,3006)" => "HistogramLastBinValue",
  "(0060,3008)" => "HistogramBinWidth",
  "(0060,3010)" => "HistogramExplanation",
  "(0060,3020)" => "HistogramData",
  "(0062,0001)" => "SegmentationType",
  "(0062,0002)" => "SegmentSequence",
  "(0062,0003)" => "SegmentedPropertyCategoryCodeSequence",
  "(0062,0004)" => "SegmentNumber",
  "(0062,0005)" => "SegmentLabel",
  "(0062,0006)" => "SegmentDescription",
  "(0062,0008)" => "SegmentAlgorithmType",
  "(0062,0009)" => "SegmentAlgorithmName",
  "(0062,000a)" => "SegmentIdentificationSequence",
  "(0062,000b)" => "ReferencedSegmentNumber",
  "(0062,000c)" => "RecommendedDisplayGrayscaleValue",
  "(0062,000d)" => "RecommendedDisplayCIELabValue",
  "(0062,000e)" => "MaximumFractionalValue",
  "(0062,000f)" => "SegmentedPropertyTypeCodeSequence",
  "(0062,0010)" => "SegmentationFractionalType",
  "(0064,0002)" => "DeformableRegistrationSequence",
  "(0064,0003)" => "SourceFrameOfReferenceUID",
  "(0064,0005)" => "DeformableRegistrationGridSequence",
  "(0064,0007)" => "GridDimensions",
  "(0064,0008)" => "GridResolution",
  "(0064,0009)" => "VectorGridData",
  "(0064,000f)" => "PreDeformationMatrixRegistrationSequence",
  "(0064,0010)" => "PostDeformationMatrixRegistrationSequence",
  "(0070,0001)" => "GraphicAnnotationSequence",
  "(0070,0002)" => "GraphicLayer",
  "(0070,0003)" => "BoundingBoxAnnotationUnits",
  "(0070,0004)" => "AnchorPointAnnotationUnits",
  "(0070,0005)" => "GraphicAnnotationUnits",
  "(0070,0006)" => "UnformattedTextValue",
  "(0070,0008)" => "TextObjectSequence",
  "(0070,0009)" => "GraphicObjectSequence",
  "(0070,0010)" => "BoundingBoxTopLeftHandCorner",
  "(0070,0011)" => "BoundingBoxBottomRightHandCorner",
  "(0070,0012)" => "BoundingBoxTextHorizontalJustification",
  "(0070,0014)" => "AnchorPoint",
  "(0070,0015)" => "AnchorPointVisibility",
  "(0070,0020)" => "GraphicDimensions",
  "(0070,0021)" => "NumberOfGraphicPoints",
  "(0070,0022)" => "GraphicData",
  "(0070,0023)" => "GraphicType",
  "(0070,0024)" => "GraphicFilled",
  "(0070,0040)" => "ImageRotationTrial",
  "(0070,0041)" => "ImageHorizontalFlip",
  "(0070,0042)" => "ImageRotation",
  "(0070,0050)" => "DisplayedAreaTopLeftHandCornerTrial",
  "(0070,0051)" => "DisplayedAreaBottomRightHandCornerTrial",
  "(0070,0052)" => "DisplayedAreaTopLeftHandCorner",
  "(0070,0053)" => "DisplayedAreaBottomRightHandCorner",
  "(0070,005a)" => "DisplayedAreaSelectionSequence",
  "(0070,0060)" => "GraphicLayerSequence",
  "(0070,0062)" => "GraphicLayerOrder",
  "(0070,0066)" => "GraphicLayerRecommendedDisplayGrayscaleValue",
  "(0070,0067)" => "GraphicLayerRecommendedDisplayRGBValue",
  "(0070,0068)" => "GraphicLayerDescription",
  "(0070,0080)" => "ContentLabel",
  "(0070,0081)" => "ContentDescription",
  "(0070,0082)" => "PresentationCreationDate",
  "(0070,0083)" => "PresentationCreationTime",
  "(0070,0084)" => "ContentCreatorsName",
  "(0070,0086)" => "ContentCreatorsIdentificationCodeSequence",
  "(0070,0100)" => "PresentationSizeMode",
  "(0070,0101)" => "PresentationPixelSpacing",
  "(0070,0102)" => "PresentationPixelAspectRatio",
  "(0070,0103)" => "PresentationPixelMagnificationRatio",
  "(0070,0306)" => "ShapeType",
  "(0070,0308)" => "RegistrationSequence",
  "(0070,0309)" => "MatrixRegistrationSequence",
  "(0070,030a)" => "MatrixSequence",
  "(0070,030c)" => "FrameOfReferenceTransformationMatrixType",
  "(0070,030d)" => "RegistrationTypeCodeSequence",
  "(0070,030f)" => "FiducialDescription",
  "(0070,0310)" => "FiducialIdentifier",
  "(0070,0311)" => "FiducialIdentifierCodeSequence",
  "(0070,0312)" => "ContourUncertaintyRadius",
  "(0070,0314)" => "UsedFiducialsSequence",
  "(0070,0318)" => "GraphicCoordinatesDataSequence",
  "(0070,031a)" => "FiducialUID",
  "(0070,031c)" => "FiducialSetSequence",
  "(0070,031e)" => "FiducialSequence",
  "(0070,0401)" => "GraphicLayerRecommendedDisplayCIELabValue",
  "(0070,0402)" => "BlendingSequence",
  "(0070,0403)" => "RelativeOpacity",
  "(0070,0404)" => "ReferencedSpatialRegistrationSequence",
  "(0070,0405)" => "BlendingPosition",
  "(0072,0002)" => "HangingProtocolName",
  "(0072,0004)" => "HangingProtocolDescription",
  "(0072,0006)" => "HangingProtocolLevel",
  "(0072,0008)" => "HangingProtocolCreator",
  "(0072,000a)" => "HangingProtocolCreationDateTime",
  "(0072,000c)" => "HangingProtocolDefinitionSequence",
  "(0072,000e)" => "HangingProtocolUserIdentificationCodeSequence",
  "(0072,0010)" => "HangingProtocolUserGroupName",
  "(0072,0012)" => "SourceHangingProtocolSequence",
  "(0072,0014)" => "NumberOfPriorsReferenced",
  "(0072,0020)" => "ImageSetsSequence",
  "(0072,0022)" => "ImageSetSelectorSequence",
  "(0072,0024)" => "ImageSetSelectorUsageFlag",
  "(0072,0026)" => "SelectorAttribute",
  "(0072,0028)" => "SelectorValueNumber",
  "(0072,0030)" => "TimeBasedImageSetsSequence",
  "(0072,0032)" => "ImageSetNumber",
  "(0072,0034)" => "ImageSetSelectorCategory",
  "(0072,0038)" => "RelativeTime",
  "(0072,003a)" => "RelativeTimeUnits",
  "(0072,003c)" => "AbstractPriorValue",
  "(0072,003e)" => "AbstractPriorCodeSequence",
  "(0072,0040)" => "ImageSetLabel",
  "(0072,0050)" => "SelectorAttributeVR",
  "(0072,0052)" => "SelectorSequencePointer",
  "(0072,0054)" => "SelectorSequencePointerPrivateCreator",
  "(0072,0056)" => "SelectorAttributePrivateCreator",
  "(0072,0060)" => "SelectorATValue",
  "(0072,0062)" => "SelectorCSValue",
  "(0072,0064)" => "SelectorISValue",
  "(0072,0066)" => "SelectorLOValue",
  "(0072,0068)" => "SelectorLTValue",
  "(0072,006a)" => "SelectorPNValue",
  "(0072,006c)" => "SelectorSHValue",
  "(0072,006e)" => "SelectorSTValue",
  "(0072,0070)" => "SelectorUTValue",
  "(0072,0072)" => "SelectorDSValue",
  "(0072,0074)" => "SelectorFDValue",
  "(0072,0076)" => "SelectorFLValue",
  "(0072,0078)" => "SelectorULValue",
  "(0072,007a)" => "SelectorUSValue",
  "(0072,007c)" => "SelectorSLValue",
  "(0072,007e)" => "SelectorSSValue",
  "(0072,0080)" => "SelectorCodeSequenceValue",
  "(0072,0100)" => "NumberOfScreens",
  "(0072,0102)" => "NominalScreenDefinitionSequence",
  "(0072,0104)" => "NumberOfVerticalPixels",
  "(0072,0106)" => "NumberOfHorizontalPixels",
  "(0072,0108)" => "DisplayEnvironmentSpatialPosition",
  "(0072,010a)" => "ScreenMinimumGrayscaleBitDepth",
  "(0072,010c)" => "ScreenMinimumColorBitDepth",
  "(0072,010e)" => "ApplicationMaximumRepaintTime",
  "(0072,0200)" => "DisplaySetsSequence",
  "(0072,0202)" => "DisplaySetNumber",
  "(0072,0203)" => "DisplaySetLabel",
  "(0072,0204)" => "DisplaySetPresentationGroup",
  "(0072,0206)" => "DisplaySetPresentationGroupDescription",
  "(0072,0208)" => "PartialDataDisplayHandling",
  "(0072,0210)" => "SynchronizedScrollingSequence",
  "(0072,0212)" => "DisplaySetScrollingGroup",
  "(0072,0214)" => "NavigationIndicatorSequence",
  "(0072,0216)" => "NavigationDisplaySet",
  "(0072,0218)" => "ReferenceDisplaySets",
  "(0072,0300)" => "ImageBoxesSequence",
  "(0072,0302)" => "ImageBoxNumber",
  "(0072,0304)" => "ImageBoxLayoutType",
  "(0072,0306)" => "ImageBoxTileHorizontalDimension",
  "(0072,0308)" => "ImageBoxTileVerticalDimension",
  "(0072,0310)" => "ImageBoxScrollDirection",
  "(0072,0312)" => "ImageBoxSmallScrollType",
  "(0072,0314)" => "ImageBoxSmallScrollAmount",
  "(0072,0316)" => "ImageBoxLargeScrollType",
  "(0072,0318)" => "ImageBoxLargeScrollAmount",
  "(0072,0320)" => "ImageBoxOverlapPriority",
  "(0072,0330)" => "CineRelativeToRealTime",
  "(0072,0400)" => "FilterOperationsSequence",
  "(0072,0402)" => "FilterByCategory",
  "(0072,0404)" => "FilterByAttributePresence",
  "(0072,0406)" => "FilterByOperator",
  "(0072,0500)" => "BlendingOperationType",
  "(0072,0510)" => "ReformattingOperationType",
  "(0072,0512)" => "ReformattingThickness",
  "(0072,0514)" => "ReformattingInterval",
  "(0072,0516)" => "ReformattingOperationInitialViewDirection",
  "(0072,0520)" => "ThreeDRenderingType",
  "(0072,0600)" => "SortingOperationsSequence",
  "(0072,0602)" => "SortByCategory",
  "(0072,0604)" => "SortingDirection",
  "(0072,0700)" => "DisplaySetPatientOrientation",
  "(0072,0702)" => "VOIType",
  "(0072,0704)" => "PseudocolorType",
  "(0072,0706)" => "ShowGrayscaleInverted",
  "(0072,0710)" => "ShowImageTrueSizeFlag",
  "(0072,0712)" => "ShowGraphicAnnotationFlag",
  "(0072,0714)" => "ShowPatientDemographicsFlag",
  "(0072,0716)" => "ShowAcquisitionTechniquesFlag",
  "(0072,0717)" => "DisplaySetHorizontalJustification",
  "(0072,0718)" => "DisplaySetVerticalJustification",
  "(0088,0130)" => "StorageMediaFileSetID",
  "(0088,0140)" => "StorageMediaFileSetUID",
  "(0088,0200)" => "IconImageSequence",
  "(0088,0904)" => "TopicTitle",
  "(0088,0906)" => "TopicSubject",
  "(0088,0910)" => "TopicAuthor",
  "(0088,0912)" => "TopicKeyWords",
  "(0100,0410)" => "SOPInstanceStatus",
  "(0100,0420)" => "SOPAuthorizationDateAndTime",
  "(0100,0424)" => "SOPAuthorizationComment",
  "(0100,0426)" => "AuthorizationEquipmentCertificationNumber",
  "(0400,0005)" => "MACIDNumber",
  "(0400,0010)" => "MACCalculationTransferSyntaxUID",
  "(0400,0015)" => "MACAlgorithm",
  "(0400,0020)" => "DataElementsSigned",
  "(0400,0100)" => "DigitalSignatureUID",
  "(0400,0105)" => "DigitalSignatureDateTime",
  "(0400,0110)" => "CertificateType",
  "(0400,0115)" => "CertificateOfSigner",
  "(0400,0120)" => "Signature",
  "(0400,0305)" => "CertifiedTimestampType",
  "(0400,0310)" => "CertifiedTimestamp",
  "(0400,0401)" => "DigitalSignaturePurposeCodeSequence",
  "(0400,0402)" => "ReferencedDigitalSignatureSequence",
  "(0400,0403)" => "ReferencedSOPInstanceMACSequence",
  "(0400,0404)" => "MAC",
  "(0400,0500)" => "EncryptedAttributesSequence",
  "(0400,0510)" => "EncryptedContentTransferSyntaxUID",
  "(0400,0520)" => "EncryptedContent",
  "(0400,0550)" => "ModifiedAttributesSequence",
  "(0400,0561)" => "OriginalAttributesSequence",
  "(0400,0562)" => "AttributeModificationDateTime",
  "(0400,0563)" => "ModifyingSystem",
  "(0400,0564)" => "SourceOfPreviousValues",
  "(0400,0565)" => "ReasonForTheAttributeModification",
  "(2000,0010)" => "NumberOfCopies",
  "(2000,001e)" => "PrinterConfigurationSequence",
  "(2000,0020)" => "PrintPriority",
  "(2000,0030)" => "MediumType",
  "(2000,0040)" => "FilmDestination",
  "(2000,0050)" => "FilmSessionLabel",
  "(2000,0060)" => "MemoryAllocation",
  "(2000,0061)" => "MaximumMemoryAllocation",
  "(2000,0062)" => "ColorImagePrintingFlag",
  "(2000,0063)" => "CollationFlag",
  "(2000,0065)" => "AnnotationFlag",
  "(2000,0067)" => "ImageOverlayFlag",
  "(2000,0069)" => "PresentationLUTFlag",
  "(2000,006a)" => "ImageBoxPresentationLUTFlag",
  "(2000,00a0)" => "MemoryBitDepth",
  "(2000,00a1)" => "PrintingBitDepth",
  "(2000,00a2)" => "MediaInstalledSequence",
  "(2000,00a4)" => "OtherMediaAvailableSequence",
  "(2000,00a8)" => "SupportedImageDisplayFormatsSequence",
  "(2000,0500)" => "ReferencedFilmBoxSequence",
  "(2000,0510)" => "ReferencedStoredPrintSequence",
  "(2010,0010)" => "ImageDisplayFormat",
  "(2010,0030)" => "AnnotationDisplayFormatID",
  "(2010,0040)" => "FilmOrientation",
  "(2010,0050)" => "FilmSizeID",
  "(2010,0052)" => "PrinterResolutionID",
  "(2010,0054)" => "DefaultPrinterResolutionID",
  "(2010,0060)" => "MagnificationType",
  "(2010,0080)" => "SmoothingType",
  "(2010,00a6)" => "DefaultMagnificationType",
  "(2010,00a7)" => "OtherMagnificationTypesAvailable",
  "(2010,00a8)" => "DefaultSmoothingType",
  "(2010,00a9)" => "OtherSmoothingTypesAvailable",
  "(2010,0100)" => "BorderDensity",
  "(2010,0110)" => "EmptyImageDensity",
  "(2010,0120)" => "MinDensity",
  "(2010,0130)" => "MaxDensity",
  "(2010,0140)" => "Trim",
  "(2010,0150)" => "ConfigurationInformation",
  "(2010,0152)" => "ConfigurationInformationDescription",
  "(2010,0154)" => "MaximumCollatedFilms",
  "(2010,015e)" => "Illumination",
  "(2010,0160)" => "ReflectedAmbientLight",
  "(2010,0376)" => "PrinterPixelSpacing",
  "(2010,0500)" => "ReferencedFilmSessionSequence",
  "(2010,0510)" => "ReferencedImageBoxSequence",
  "(2010,0520)" => "ReferencedBasicAnnotationBoxSequence",
  "(2020,0010)" => "ImageBoxPosition",
  "(2020,0020)" => "Polarity",
  "(2020,0030)" => "RequestedImageSize",
  "(2020,0040)" => "RequestedDecimateCropBehavior",
  "(2020,0050)" => "RequestedResolutionID",
  "(2020,00a0)" => "RequestedImageSizeFlag",
  "(2020,00a2)" => "DecimateCropResult",
  "(2020,0110)" => "BasicGrayscaleImageSequence",
  "(2020,0111)" => "BasicColorImageSequence",
  "(2020,0130)" => "ReferencedImageOverlayBoxSequence",
  "(2020,0140)" => "ReferencedVOILUTBoxSequence",
  "(2030,0010)" => "AnnotationPosition",
  "(2030,0020)" => "TextString",
  "(2040,0010)" => "ReferencedOverlayPlaneSequence",
  "(2040,0011)" => "ReferencedOverlayPlaneGroups",
  "(2040,0020)" => "OverlayPixelDataSequence",
  "(2040,0060)" => "OverlayMagnificationType",
  "(2040,0070)" => "OverlaySmoothingType",
  "(2040,0072)" => "OverlayOrImageMagnification",
  "(2040,0074)" => "MagnifyToNumberOfColumns",
  "(2040,0080)" => "OverlayForegroundDensity",
  "(2040,0082)" => "OverlayBackgroundDensity",
  "(2040,0090)" => "OverlayMode",
  "(2040,0100)" => "ThresholdDensity",
  "(2040,0500)" => "ReferencedOverlayImageBoxSequence",
  "(2050,0010)" => "PresentationLUTSequence",
  "(2050,0020)" => "PresentationLUTShape",
  "(2050,0500)" => "ReferencedPresentationLUTSequence",
  "(2100,0010)" => "PrintJobID",
  "(2100,0020)" => "ExecutionStatus",
  "(2100,0030)" => "ExecutionStatusInfo",
  "(2100,0040)" => "CreationDate",
  "(2100,0050)" => "CreationTime",
  "(2100,0070)" => "Originator",
  "(2100,0140)" => "DestinationAE",
  "(2100,0160)" => "OwnerID",
  "(2100,0170)" => "NumberOfFilms",
  "(2100,0500)" => "ReferencedPrintJobSequencePull",
  "(2110,0010)" => "PrinterStatus",
  "(2110,0020)" => "PrinterStatusInfo",
  "(2110,0030)" => "PrinterName",
  "(2110,0099)" => "PrintQueueID",
  "(2120,0010)" => "QueueStatus",
  "(2120,0050)" => "PrintJobDescriptionSequence",
  "(2120,0070)" => "ReferencedPrintJobSequenceQueue",
  "(2130,0010)" => "PrintManagementCapabilitiesSequence",
  "(2130,0015)" => "PrinterCharacteristicsSequence",
  "(2130,0030)" => "FilmBoxContentSequence",
  "(2130,0040)" => "ImageBoxContentSequence",
  "(2130,0050)" => "AnnotationContentSequence",
  "(2130,0060)" => "ImageOverlayBoxContentSequence",
  "(2130,0080)" => "PresentationLUTContentSequence",
  "(2130,00a0)" => "ProposedStudySequence",
  "(2130,00c0)" => "OriginalImageSequence",
  "(2200,0001)" => "LabelUsingInformationExtractedFromInstances",
  "(2200,0002)" => "LabelText",
  "(2200,0003)" => "LabelStyleSelection",
  "(2200,0004)" => "MediaDisposition",
  "(2200,0005)" => "BarcodeValue",
  "(2200,0006)" => "BarcodeSymbology",
  "(2200,0007)" => "AllowMediaSplitting",
  "(2200,0008)" => "IncludeNonDICOMObjects",
  "(2200,0009)" => "IncludeDisplayApplication",
  "(2200,000a)" => "PreserveCompositeInstancesAfterMediaCreation",
  "(2200,000b)" => "TotalNumberOfPiecesOfMediaCreated",
  "(2200,000c)" => "RequestedMediaApplicationProfile",
  "(2200,000d)" => "ReferencedStorageMediaSequence",
  "(2200,000e)" => "FailureAttributes",
  "(2200,000f)" => "AllowLossyCompression",
  "(2200,0020)" => "RequestPriority",
  "(3002,0002)" => "RTImageLabel",
  "(3002,0003)" => "RTImageName",
  "(3002,0004)" => "RTImageDescription",
  "(3002,000a)" => "ReportedValuesOrigin",
  "(3002,000c)" => "RTImagePlane",
  "(3002,000d)" => "XRayImageReceptorTranslation",
  "(3002,000e)" => "XRayImageReceptorAngle",
  "(3002,0010)" => "RTImageOrientation",
  "(3002,0011)" => "ImagePlanePixelSpacing",
  "(3002,0012)" => "RTImagePosition",
  "(3002,0020)" => "RadiationMachineName",
  "(3002,0022)" => "RadiationMachineSAD",
  "(3002,0024)" => "RadiationMachineSSD",
  "(3002,0026)" => "RTImageSID",
  "(3002,0028)" => "SourceToReferenceObjectDistance",
  "(3002,0029)" => "FractionNumber",
  "(3002,0030)" => "ExposureSequence",
  "(3002,0032)" => "MetersetExposure",
  "(3002,0034)" => "DiaphragmPosition",
  "(3002,0040)" => "FluenceMapSequence",
  "(3002,0041)" => "FluenceDataSource",
  "(3002,0042)" => "FluenceDataScale",
  "(3004,0001)" => "DVHType",
  "(3004,0002)" => "DoseUnits",
  "(3004,0004)" => "DoseType",
  "(3004,0006)" => "DoseComment",
  "(3004,0008)" => "NormalizationPoint",
  "(3004,000a)" => "DoseSummationType",
  "(3004,000c)" => "GridFrameOffsetVector",
  "(3004,000e)" => "DoseGridScaling",
  "(3004,0010)" => "RTDoseROISequence",
  "(3004,0012)" => "DoseValue",
  "(3004,0014)" => "TissueHeterogeneityCorrection",
  "(3004,0040)" => "DVHNormalizationPoint",
  "(3004,0042)" => "DVHNormalizationDoseValue",
  "(3004,0050)" => "DVHSequence",
  "(3004,0052)" => "DVHDoseScaling",
  "(3004,0054)" => "DVHVolumeUnits",
  "(3004,0056)" => "DVHNumberOfBins",
  "(3004,0058)" => "DVHData",
  "(3004,0060)" => "DVHReferencedROISequence",
  "(3004,0062)" => "DVHROIContributionType",
  "(3004,0070)" => "DVHMinimumDose",
  "(3004,0072)" => "DVHMaximumDose",
  "(3004,0074)" => "DVHMeanDose",
  "(3006,0002)" => "StructureSetLabel",
  "(3006,0004)" => "StructureSetName",
  "(3006,0006)" => "StructureSetDescription",
  "(3006,0008)" => "StructureSetDate",
  "(3006,0009)" => "StructureSetTime",
  "(3006,0010)" => "ReferencedFrameOfReferenceSequence",
  "(3006,0012)" => "RTReferencedStudySequence",
  "(3006,0014)" => "RTReferencedSeriesSequence",
  "(3006,0016)" => "ContourImageSequence",
  "(3006,0020)" => "StructureSetROISequence",
  "(3006,0022)" => "ROINumber",
  "(3006,0024)" => "ReferencedFrameOfReferenceUID",
  "(3006,0026)" => "ROIName",
  "(3006,0028)" => "ROIDescription",
  "(3006,002a)" => "ROIDisplayColor",
  "(3006,002c)" => "ROIVolume",
  "(3006,0030)" => "RTRelatedROISequence",
  "(3006,0033)" => "RTROIRelationship",
  "(3006,0036)" => "ROIGenerationAlgorithm",
  "(3006,0038)" => "ROIGenerationDescription",
  "(3006,0039)" => "ROIContourSequence",
  "(3006,0040)" => "ContourSequence",
  "(3006,0042)" => "ContourGeometricType",
  "(3006,0044)" => "ContourSlabThickness",
  "(3006,0045)" => "ContourOffsetVector",
  "(3006,0046)" => "NumberOfContourPoints",
  "(3006,0048)" => "ContourNumber",
  "(3006,0049)" => "AttachedContours",
  "(3006,0050)" => "ContourData",
  "(3006,0080)" => "RTROIObservationsSequence",
  "(3006,0082)" => "ObservationNumber",
  "(3006,0084)" => "ReferencedROINumber",
  "(3006,0085)" => "ROIObservationLabel",
  "(3006,0086)" => "RTROIIdentificationCodeSequence",
  "(3006,0088)" => "ROIObservationDescription",
  "(3006,00a0)" => "RelatedRTROIObservationsSequence",
  "(3006,00a4)" => "RTROIInterpretedType",
  "(3006,00a6)" => "ROIInterpreter",
  "(3006,00b0)" => "ROIPhysicalPropertiesSequence",
  "(3006,00b2)" => "ROIPhysicalProperty",
  "(3006,00b4)" => "ROIPhysicalPropertyValue",
  "(3006,00b6)" => "ROIElementalCompositionSequence",
  "(3006,00b7)" => "ROIElementalCompositionAtomicNumber",
  "(3006,00b8)" => "ROIElementalCompositionAtomicMassFraction",
  "(3006,00c0)" => "FrameOfReferenceRelationshipSequence",
  "(3006,00c2)" => "RelatedFrameOfReferenceUID",
  "(3006,00c4)" => "FrameOfReferenceTransformationType",
  "(3006,00c6)" => "FrameOfReferenceTransformationMatrix",
  "(3006,00c8)" => "FrameOfReferenceTransformationComment",
  "(3008,0010)" => "MeasuredDoseReferenceSequence",
  "(3008,0012)" => "MeasuredDoseDescription",
  "(3008,0014)" => "MeasuredDoseType",
  "(3008,0016)" => "MeasuredDoseValue",
  "(3008,0020)" => "TreatmentSessionBeamSequence",
  "(3008,0021)" => "TreatmentSessionIonBeamSequence",
  "(3008,0022)" => "CurrentFractionNumber",
  "(3008,0024)" => "TreatmentControlPointDate",
  "(3008,0025)" => "TreatmentControlPointTime",
  "(3008,002a)" => "TreatmentTerminationStatus",
  "(3008,002b)" => "TreatmentTerminationCode",
  "(3008,002c)" => "TreatmentVerificationStatus",
  "(3008,0030)" => "ReferencedTreatmentRecordSequence",
  "(3008,0032)" => "SpecifiedPrimaryMeterset",
  "(3008,0033)" => "SpecifiedSecondaryMeterset",
  "(3008,0036)" => "DeliveredPrimaryMeterset",
  "(3008,0037)" => "DeliveredSecondaryMeterset",
  "(3008,003a)" => "SpecifiedTreatmentTime",
  "(3008,003b)" => "DeliveredTreatmentTime",
  "(3008,0040)" => "ControlPointDeliverySequence",
  "(3008,0041)" => "IonControlPointDeliverySequence",
  "(3008,0042)" => "SpecifiedMeterset",
  "(3008,0044)" => "DeliveredMeterset",
  "(3008,0045)" => "MetersetRateSet",
  "(3008,0046)" => "MetersetRateDelivered",
  "(3008,0047)" => "ScanSpotMetersetsDelivered",
  "(3008,0048)" => "DoseRateDelivered",
  "(3008,0050)" => "TreatmentSummaryCalculatedDoseReferenceSequence",
  "(3008,0052)" => "CumulativeDoseToDoseReference",
  "(3008,0054)" => "FirstTreatmentDate",
  "(3008,0056)" => "MostRecentTreatmentDate",
  "(3008,005a)" => "NumberOfFractionsDelivered",
  "(3008,0060)" => "OverrideSequence",
  "(3008,0061)" => "ParameterSequencePointer",
  "(3008,0062)" => "OverrideParameterPointer",
  "(3008,0063)" => "ParameterItemIndex",
  "(3008,0064)" => "MeasuredDoseReferenceNumber",
  "(3008,0065)" => "ParameterPointer",
  "(3008,0066)" => "OverrideReason",
  "(3008,0068)" => "CorrectedParameterSequence",
  "(3008,006a)" => "CorrectionValue",
  "(3008,0070)" => "CalculatedDoseReferenceSequence",
  "(3008,0072)" => "CalculatedDoseReferenceNumber",
  "(3008,0074)" => "CalculatedDoseReferenceDescription",
  "(3008,0076)" => "CalculatedDoseReferenceDoseValue",
  "(3008,0078)" => "StartMeterset",
  "(3008,007a)" => "EndMeterset",
  "(3008,0080)" => "ReferencedMeasuredDoseReferenceSequence",
  "(3008,0082)" => "ReferencedMeasuredDoseReferenceNumber",
  "(3008,0090)" => "ReferencedCalculatedDoseReferenceSequence",
  "(3008,0092)" => "ReferencedCalculatedDoseReferenceNumber",
  "(3008,00a0)" => "BeamLimitingDeviceLeafPairsSequence",
  "(3008,00b0)" => "RecordedWedgeSequence",
  "(3008,00c0)" => "RecordedCompensatorSequence",
  "(3008,00d0)" => "RecordedBlockSequence",
  "(3008,00e0)" => "TreatmentSummaryMeasuredDoseReferenceSequence",
  "(3008,00f0)" => "RecordedSnoutSequence",
  "(3008,00f2)" => "RecordedRangeShifterSequence",
  "(3008,00f4)" => "RecordedLateralSpreadingDeviceSequence",
  "(3008,00f6)" => "RecordedRangeModulatorSequence",
  "(3008,0100)" => "RecordedSourceSequence",
  "(3008,0105)" => "SourceSerialNumber",
  "(3008,0110)" => "TreatmentSessionApplicationSetupSequence",
  "(3008,0116)" => "ApplicationSetupCheck",
  "(3008,0120)" => "RecordedBrachyAccessoryDeviceSequence",
  "(3008,0122)" => "ReferencedBrachyAccessoryDeviceNumber",
  "(3008,0130)" => "RecordedChannelSequence",
  "(3008,0132)" => "SpecifiedChannelTotalTime",
  "(3008,0134)" => "DeliveredChannelTotalTime",
  "(3008,0136)" => "SpecifiedNumberOfPulses",
  "(3008,0138)" => "DeliveredNumberOfPulses",
  "(3008,013a)" => "SpecifiedPulseRepetitionInterval",
  "(3008,013c)" => "DeliveredPulseRepetitionInterval",
  "(3008,0140)" => "RecordedSourceApplicatorSequence",
  "(3008,0142)" => "ReferencedSourceApplicatorNumber",
  "(3008,0150)" => "RecordedChannelShieldSequence",
  "(3008,0152)" => "ReferencedChannelShieldNumber",
  "(3008,0160)" => "BrachyControlPointDeliveredSequence",
  "(3008,0162)" => "SafePositionExitDate",
  "(3008,0164)" => "SafePositionExitTime",
  "(3008,0166)" => "SafePositionReturnDate",
  "(3008,0168)" => "SafePositionReturnTime",
  "(3008,0200)" => "CurrentTreatmentStatus",
  "(3008,0202)" => "TreatmentStatusComment",
  "(3008,0220)" => "FractionGroupSummarySequence",
  "(3008,0223)" => "ReferencedFractionNumber",
  "(3008,0224)" => "FractionGroupType",
  "(3008,0230)" => "BeamStopperPosition",
  "(3008,0240)" => "FractionStatusSummarySequence",
  "(3008,0250)" => "TreatmentDate",
  "(3008,0251)" => "TreatmentTime",
  "(300a,0002)" => "RTPlanLabel",
  "(300a,0003)" => "RTPlanName",
  "(300a,0004)" => "RTPlanDescription",
  "(300a,0006)" => "RTPlanDate",
  "(300a,0007)" => "RTPlanTime",
  "(300a,0009)" => "TreatmentProtocols",
  "(300a,000a)" => "PlanIntent",
  "(300a,000b)" => "TreatmentSites",
  "(300a,000c)" => "RTPlanGeometry",
  "(300a,000e)" => "PrescriptionDescription",
  "(300a,0010)" => "DoseReferenceSequence",
  "(300a,0012)" => "DoseReferenceNumber",
  "(300a,0013)" => "DoseReferenceUID",
  "(300a,0014)" => "DoseReferenceStructureType",
  "(300a,0015)" => "NominalBeamEnergyUnit",
  "(300a,0016)" => "DoseReferenceDescription",
  "(300a,0018)" => "DoseReferencePointCoordinates",
  "(300a,001a)" => "NominalPriorDose",
  "(300a,0020)" => "DoseReferenceType",
  "(300a,0021)" => "ConstraintWeight",
  "(300a,0022)" => "DeliveryWarningDose",
  "(300a,0023)" => "DeliveryMaximumDose",
  "(300a,0025)" => "TargetMinimumDose",
  "(300a,0026)" => "TargetPrescriptionDose",
  "(300a,0027)" => "TargetMaximumDose",
  "(300a,0028)" => "TargetUnderdoseVolumeFraction",
  "(300a,002a)" => "OrganAtRiskFullVolumeDose",
  "(300a,002b)" => "OrganAtRiskLimitDose",
  "(300a,002c)" => "OrganAtRiskMaximumDose",
  "(300a,002d)" => "OrganAtRiskOverdoseVolumeFraction",
  "(300a,0040)" => "ToleranceTableSequence",
  "(300a,0042)" => "ToleranceTableNumber",
  "(300a,0043)" => "ToleranceTableLabel",
  "(300a,0044)" => "GantryAngleTolerance",
  "(300a,0046)" => "BeamLimitingDeviceAngleTolerance",
  "(300a,0048)" => "BeamLimitingDeviceToleranceSequence",
  "(300a,004a)" => "BeamLimitingDevicePositionTolerance",
  "(300a,004b)" => "SnoutPositionTolerance",
  "(300a,004c)" => "PatientSupportAngleTolerance",
  "(300a,004e)" => "TableTopEccentricAngleTolerance",
  "(300a,004f)" => "TableTopPitchAngleTolerance",
  "(300a,0050)" => "TableTopRollAngleTolerance",
  "(300a,0051)" => "TableTopVerticalPositionTolerance",
  "(300a,0052)" => "TableTopLongitudinalPositionTolerance",
  "(300a,0053)" => "TableTopLateralPositionTolerance",
  "(300a,0055)" => "RTPlanRelationship",
  "(300a,0070)" => "FractionGroupSequence",
  "(300a,0071)" => "FractionGroupNumber",
  "(300a,0072)" => "FractionGroupDescription",
  "(300a,0078)" => "NumberOfFractionsPlanned",
  "(300a,0079)" => "NumberOfFractionPatternDigitsPerDay",
  "(300a,007a)" => "RepeatFractionCycleLength",
  "(300a,007b)" => "FractionPattern",
  "(300a,0080)" => "NumberOfBeams",
  "(300a,0082)" => "BeamDoseSpecificationPoint",
  "(300a,0084)" => "BeamDose",
  "(300a,0086)" => "BeamMeterset",
  "(300a,0088)" => "BeamDosePointDepth",
  "(300a,0089)" => "BeamDosePointEquivalentDepth",
  "(300a,008a)" => "BeamDosePointSSD",
  "(300a,00a0)" => "NumberOfBrachyApplicationSetups",
  "(300a,00a2)" => "BrachyApplicationSetupDoseSpecificationPoint",
  "(300a,00a4)" => "BrachyApplicationSetupDose",
  "(300a,00b0)" => "BeamSequence",
  "(300a,00b2)" => "TreatmentMachineName",
  "(300a,00b3)" => "PrimaryDosimeterUnit",
  "(300a,00b4)" => "SourceAxisDistance",
  "(300a,00b6)" => "BeamLimitingDeviceSequence",
  "(300a,00b8)" => "RTBeamLimitingDeviceType",
  "(300a,00ba)" => "SourceToBeamLimitingDeviceDistance",
  "(300a,00bb)" => "IsocenterToBeamLimitingDeviceDistance",
  "(300a,00bc)" => "NumberOfLeafJawPairs",
  "(300a,00be)" => "LeafPositionBoundaries",
  "(300a,00c0)" => "BeamNumber",
  "(300a,00c2)" => "BeamName",
  "(300a,00c3)" => "BeamDescription",
  "(300a,00c4)" => "BeamType",
  "(300a,00c6)" => "RadiationType",
  "(300a,00c7)" => "HighDoseTechniqueType",
  "(300a,00c8)" => "ReferenceImageNumber",
  "(300a,00ca)" => "PlannedVerificationImageSequence",
  "(300a,00cc)" => "ImagingDeviceSpecificAcquisitionParameters",
  "(300a,00ce)" => "TreatmentDeliveryType",
  "(300a,00d0)" => "NumberOfWedges",
  "(300a,00d1)" => "WedgeSequence",
  "(300a,00d2)" => "WedgeNumber",
  "(300a,00d3)" => "WedgeType",
  "(300a,00d4)" => "WedgeID",
  "(300a,00d5)" => "WedgeAngle",
  "(300a,00d6)" => "WedgeFactor",
  "(300a,00d7)" => "TotalWedgeTrayWaterEquivalentThickness",
  "(300a,00d8)" => "WedgeOrientation",
  "(300a,00d9)" => "IsocenterToWedgeTrayDistance",
  "(300a,00da)" => "SourceToWedgeTrayDistance",
  "(300a,00db)" => "WedgeThinEdgePosition",
  "(300a,00dc)" => "BolusID",
  "(300a,00dd)" => "BolusDescription",
  "(300a,00e0)" => "NumberOfCompensators",
  "(300a,00e1)" => "MaterialID",
  "(300a,00e2)" => "TotalCompensatorTrayFactor",
  "(300a,00e3)" => "CompensatorSequence",
  "(300a,00e4)" => "CompensatorNumber",
  "(300a,00e5)" => "CompensatorID",
  "(300a,00e6)" => "SourceToCompensatorTrayDistance",
  "(300a,00e7)" => "CompensatorRows",
  "(300a,00e8)" => "CompensatorColumns",
  "(300a,00e9)" => "CompensatorPixelSpacing",
  "(300a,00ea)" => "CompensatorPosition",
  "(300a,00eb)" => "CompensatorTransmissionData",
  "(300a,00ec)" => "CompensatorThicknessData",
  "(300a,00ed)" => "NumberOfBoli",
  "(300a,00ee)" => "CompensatorType",
  "(300a,00f0)" => "NumberOfBlocks",
  "(300a,00f2)" => "TotalBlockTrayFactor",
  "(300a,00f3)" => "TotalBlockTrayWaterEquivalentThickness",
  "(300a,00f4)" => "BlockSequence",
  "(300a,00f5)" => "BlockTrayID",
  "(300a,00f6)" => "SourceToBlockTrayDistance",
  "(300a,00f7)" => "IsocenterToBlockTrayDistance",
  "(300a,00f8)" => "BlockType",
  "(300a,00f9)" => "AccessoryCode",
  "(300a,00fa)" => "BlockDivergence",
  "(300a,00fb)" => "BlockMountingPosition",
  "(300a,00fc)" => "BlockNumber",
  "(300a,00fe)" => "BlockName",
  "(300a,0100)" => "BlockThickness",
  "(300a,0102)" => "BlockTransmission",
  "(300a,0104)" => "BlockNumberOfPoints",
  "(300a,0106)" => "BlockData",
  "(300a,0107)" => "ApplicatorSequence",
  "(300a,0108)" => "ApplicatorID",
  "(300a,0109)" => "ApplicatorType",
  "(300a,010a)" => "ApplicatorDescription",
  "(300a,010c)" => "CumulativeDoseReferenceCoefficient",
  "(300a,010e)" => "FinalCumulativeMetersetWeight",
  "(300a,0110)" => "NumberOfControlPoints",
  "(300a,0111)" => "ControlPointSequence",
  "(300a,0112)" => "ControlPointIndex",
  "(300a,0114)" => "NominalBeamEnergy",
  "(300a,0115)" => "DoseRateSet",
  "(300a,0116)" => "WedgePositionSequence",
  "(300a,0118)" => "WedgePosition",
  "(300a,011a)" => "BeamLimitingDevicePositionSequence",
  "(300a,011c)" => "LeafJawPositions",
  "(300a,011e)" => "GantryAngle",
  "(300a,011f)" => "GantryRotationDirection",
  "(300a,0120)" => "BeamLimitingDeviceAngle",
  "(300a,0121)" => "BeamLimitingDeviceRotationDirection",
  "(300a,0122)" => "PatientSupportAngle",
  "(300a,0123)" => "PatientSupportRotationDirection",
  "(300a,0124)" => "TableTopEccentricAxisDistance",
  "(300a,0125)" => "TableTopEccentricAngle",
  "(300a,0126)" => "TableTopEccentricRotationDirection",
  "(300a,0128)" => "TableTopVerticalPosition",
  "(300a,0129)" => "TableTopLongitudinalPosition",
  "(300a,012a)" => "TableTopLateralPosition",
  "(300a,012c)" => "IsocenterPosition",
  "(300a,012e)" => "SurfaceEntryPoint",
  "(300a,0130)" => "SourceToSurfaceDistance",
  "(300a,0134)" => "CumulativeMetersetWeight",
  "(300a,0140)" => "TableTopPitchAngle",
  "(300a,0142)" => "TableTopPitchRotationDirection",
  "(300a,0144)" => "TableTopRollAngle",
  "(300a,0146)" => "TableTopRollRotationDirection",
  "(300a,0148)" => "HeadFixationAngle",
  "(300a,014a)" => "GantryPitchAngle",
  "(300a,014c)" => "GantryPitchRotationDirection",
  "(300a,014e)" => "GantryPitchAngleTolerance",
  "(300a,0180)" => "PatientSetupSequence",
  "(300a,0182)" => "PatientSetupNumber",
  "(300a,0183)" => "PatientSetupLabel",
  "(300a,0184)" => "PatientAdditionalPosition",
  "(300a,0190)" => "FixationDeviceSequence",
  "(300a,0192)" => "FixationDeviceType",
  "(300a,0194)" => "FixationDeviceLabel",
  "(300a,0196)" => "FixationDeviceDescription",
  "(300a,0198)" => "FixationDevicePosition",
  "(300a,0199)" => "FixationDevicePitchAngle",
  "(300a,019a)" => "FixationDeviceRollAngle",
  "(300a,01a0)" => "ShieldingDeviceSequence",
  "(300a,01a2)" => "ShieldingDeviceType",
  "(300a,01a4)" => "ShieldingDeviceLabel",
  "(300a,01a6)" => "ShieldingDeviceDescription",
  "(300a,01a8)" => "ShieldingDevicePosition",
  "(300a,01b0)" => "SetupTechnique",
  "(300a,01b2)" => "SetupTechniqueDescription",
  "(300a,01b4)" => "SetupDeviceSequence",
  "(300a,01b6)" => "SetupDeviceType",
  "(300a,01b8)" => "SetupDeviceLabel",
  "(300a,01ba)" => "SetupDeviceDescription",
  "(300a,01bc)" => "SetupDeviceParameter",
  "(300a,01d0)" => "SetupReferenceDescription",
  "(300a,01d2)" => "TableTopVerticalSetupDisplacement",
  "(300a,01d4)" => "TableTopLongitudinalSetupDisplacement",
  "(300a,01d6)" => "TableTopLateralSetupDisplacement",
  "(300a,0200)" => "BrachyTreatmentTechnique",
  "(300a,0202)" => "BrachyTreatmentType",
  "(300a,0206)" => "TreatmentMachineSequence",
  "(300a,0210)" => "SourceSequence",
  "(300a,0212)" => "SourceNumber",
  "(300a,0214)" => "SourceType",
  "(300a,0216)" => "SourceManufacturer",
  "(300a,0218)" => "ActiveSourceDiameter",
  "(300a,021a)" => "ActiveSourceLength",
  "(300a,0222)" => "SourceEncapsulationNominalThickness",
  "(300a,0224)" => "SourceEncapsulationNominalTransmission",
  "(300a,0226)" => "SourceIsotopeName",
  "(300a,0228)" => "SourceIsotopeHalfLife",
  "(300a,0229)" => "SourceStrengthUnits",
  "(300a,022a)" => "ReferenceAirKermaRate",
  "(300a,022b)" => "SourceStrength",
  "(300a,022c)" => "SourceStrengthReferenceDate",
  "(300a,022e)" => "SourceStrengthReferenceTime",
  "(300a,0230)" => "ApplicationSetupSequence",
  "(300a,0232)" => "ApplicationSetupType",
  "(300a,0234)" => "ApplicationSetupNumber",
  "(300a,0236)" => "ApplicationSetupName",
  "(300a,0238)" => "ApplicationSetupManufacturer",
  "(300a,0240)" => "TemplateNumber",
  "(300a,0242)" => "TemplateType",
  "(300a,0244)" => "TemplateName",
  "(300a,0250)" => "TotalReferenceAirKerma",
  "(300a,0260)" => "BrachyAccessoryDeviceSequence",
  "(300a,0262)" => "BrachyAccessoryDeviceNumber",
  "(300a,0263)" => "BrachyAccessoryDeviceID",
  "(300a,0264)" => "BrachyAccessoryDeviceType",
  "(300a,0266)" => "BrachyAccessoryDeviceName",
  "(300a,026a)" => "BrachyAccessoryDeviceNominalThickness",
  "(300a,026c)" => "BrachyAccessoryDeviceNominalTransmission",
  "(300a,0280)" => "ChannelSequence",
  "(300a,0282)" => "ChannelNumber",
  "(300a,0284)" => "ChannelLength",
  "(300a,0286)" => "ChannelTotalTime",
  "(300a,0288)" => "SourceMovementType",
  "(300a,028a)" => "NumberOfPulses",
  "(300a,028c)" => "PulseRepetitionInterval",
  "(300a,0290)" => "SourceApplicatorNumber",
  "(300a,0291)" => "SourceApplicatorID",
  "(300a,0292)" => "SourceApplicatorType",
  "(300a,0294)" => "SourceApplicatorName",
  "(300a,0296)" => "SourceApplicatorLength",
  "(300a,0298)" => "SourceApplicatorManufacturer",
  "(300a,029c)" => "SourceApplicatorWallNominalThickness",
  "(300a,029e)" => "SourceApplicatorWallNominalTransmission",
  "(300a,02a0)" => "SourceApplicatorStepSize",
  "(300a,02a2)" => "TransferTubeNumber",
  "(300a,02a4)" => "TransferTubeLength",
  "(300a,02b0)" => "ChannelShieldSequence",
  "(300a,02b2)" => "ChannelShieldNumber",
  "(300a,02b3)" => "ChannelShieldID",
  "(300a,02b4)" => "ChannelShieldName",
  "(300a,02b8)" => "ChannelShieldNominalThickness",
  "(300a,02ba)" => "ChannelShieldNominalTransmission",
  "(300a,02c8)" => "FinalCumulativeTimeWeight",
  "(300a,02d0)" => "BrachyControlPointSequence",
  "(300a,02d2)" => "ControlPointRelativePosition",
  "(300a,02d4)" => "ControlPoint3DPosition",
  "(300a,02d6)" => "CumulativeTimeWeight",
  "(300a,02e0)" => "CompensatorDivergence",
  "(300a,02e1)" => "CompensatorMountingPosition",
  "(300a,02e2)" => "SourceToCompensatorDistance",
  "(300a,02e3)" => "TotalCompensatorTrayWaterEquivalentThickness",
  "(300a,02e4)" => "IsocenterToCompensatorTrayDistance",
  "(300a,02e5)" => "CompensatorColumnOffset",
  "(300a,02e6)" => "IsocenterToCompensatorDistances",
  "(300a,02e7)" => "CompensatorRelativeStoppingPowerRatio",
  "(300a,02e8)" => "CompensatorMillingToolDiameter",
  "(300a,02ea)" => "IonRangeCompensatorSequence",
  "(300a,02eb)" => "CompensatorDescription",
  "(300a,0302)" => "RadiationMassNumber",
  "(300a,0304)" => "RadiationAtomicNumber",
  "(300a,0306)" => "RadiationChargeState",
  "(300a,0308)" => "ScanMode",
  "(300a,030a)" => "VirtualSourceAxisDistances",
  "(300a,030c)" => "SnoutSequence",
  "(300a,030d)" => "SnoutPosition",
  "(300a,030f)" => "SnoutID",
  "(300a,0312)" => "NumberOfRangeShifters",
  "(300a,0314)" => "RangeShifterSequence",
  "(300a,0316)" => "RangeShifterNumber",
  "(300a,0318)" => "RangeShifterID",
  "(300a,0320)" => "RangeShifterType",
  "(300a,0322)" => "RangeShifterDescription",
  "(300a,0330)" => "NumberOfLateralSpreadingDevices",
  "(300a,0332)" => "LateralSpreadingDeviceSequence",
  "(300a,0334)" => "LateralSpreadingDeviceNumber",
  "(300a,0336)" => "LateralSpreadingDeviceID",
  "(300a,0338)" => "LateralSpreadingDeviceType",
  "(300a,033a)" => "LateralSpreadingDeviceDescription",
  "(300a,033c)" => "LateralSpreadingDeviceWaterEquivalentThickness",
  "(300a,0340)" => "NumberOfRangeModulators",
  "(300a,0342)" => "RangeModulatorSequence",
  "(300a,0344)" => "RangeModulatorNumber",
  "(300a,0346)" => "RangeModulatorID",
  "(300a,0348)" => "RangeModulatorType",
  "(300a,034a)" => "RangeModulatorDescription",
  "(300a,034c)" => "BeamCurrentModulationID",
  "(300a,0350)" => "PatientSupportType",
  "(300a,0352)" => "PatientSupportID",
  "(300a,0354)" => "PatientSupportAccessoryCode",
  "(300a,0356)" => "FixationLightAzimuthalAngle",
  "(300a,0358)" => "FixationLightPolarAngle",
  "(300a,035a)" => "MetersetRate",
  "(300a,0360)" => "RangeShifterSettingsSequence",
  "(300a,0362)" => "RangeShifterSetting",
  "(300a,0364)" => "IsocenterToRangeShifterDistance",
  "(300a,0366)" => "RangeShifterWaterEquivalentThickness",
  "(300a,0370)" => "LateralSpreadingDeviceSettingsSequence",
  "(300a,0372)" => "LateralSpreadingDeviceSetting",
  "(300a,0374)" => "IsocenterToLateralSpreadingDeviceDistance",
  "(300a,0380)" => "RangeModulatorSettingsSequence",
  "(300a,0382)" => "RangeModulatorGatingStartValue",
  "(300a,0384)" => "RangeModulatorGatingStopValue",
  "(300a,0386)" => "RangeModulatorGatingStartWaterEquivalentThickness",
  "(300a,0388)" => "RangeModulatorGatingStopWaterEquivalentThickness",
  "(300a,038a)" => "IsocenterToRangeModulatorDistance",
  "(300a,0390)" => "ScanSpotTuneID",
  "(300a,0392)" => "NumberOfScanSpotPositions",
  "(300a,0394)" => "ScanSpotPositionMap",
  "(300a,0396)" => "ScanSpotMetersetWeights",
  "(300a,0398)" => "ScanningSpotSize",
  "(300a,039a)" => "NumberOfPaintings",
  "(300a,03a0)" => "IonToleranceTableSequence",
  "(300a,03a2)" => "IonBeamSequence",
  "(300a,03a4)" => "IonBeamLimitingDeviceSequence",
  "(300a,03a6)" => "IonBlockSequence",
  "(300a,03a8)" => "IonControlPointSequence",
  "(300a,03aa)" => "IonWedgeSequence",
  "(300a,03ac)" => "IonWedgePositionSequence",
  "(300a,0401)" => "ReferencedSetupImageSequence",
  "(300a,0402)" => "SetupImageComment",
  "(300a,0410)" => "MotionSynchronizationSequence",
  "(300a,0412)" => "ControlPointOrientation",
  "(300a,0420)" => "GeneralAccessorySequence",
  "(300a,0421)" => "GeneralAccessoryID",
  "(300a,0422)" => "GeneralAccessoryDescription",
  "(300a,0423)" => "GeneralAccessoryType",
  "(300a,0424)" => "GeneralAccessoryNumber",
  "(300c,0002)" => "ReferencedRTPlanSequence",
  "(300c,0004)" => "ReferencedBeamSequence",
  "(300c,0006)" => "ReferencedBeamNumber",
  "(300c,0007)" => "ReferencedReferenceImageNumber",
  "(300c,0008)" => "StartCumulativeMetersetWeight",
  "(300c,0009)" => "EndCumulativeMetersetWeight",
  "(300c,000a)" => "ReferencedBrachyApplicationSetupSequence",
  "(300c,000c)" => "ReferencedBrachyApplicationSetupNumber",
  "(300c,000e)" => "ReferencedSourceNumber",
  "(300c,0020)" => "ReferencedFractionGroupSequence",
  "(300c,0022)" => "ReferencedFractionGroupNumber",
  "(300c,0040)" => "ReferencedVerificationImageSequence",
  "(300c,0042)" => "ReferencedReferenceImageSequence",
  "(300c,0050)" => "ReferencedDoseReferenceSequence",
  "(300c,0051)" => "ReferencedDoseReferenceNumber",
  "(300c,0055)" => "BrachyReferencedDoseReferenceSequence",
  "(300c,0060)" => "ReferencedStructureSetSequence",
  "(300c,006a)" => "ReferencedPatientSetupNumber",
  "(300c,0080)" => "ReferencedDoseSequence",
  "(300c,00a0)" => "ReferencedToleranceTableNumber",
  "(300c,00b0)" => "ReferencedBolusSequence",
  "(300c,00c0)" => "ReferencedWedgeNumber",
  "(300c,00d0)" => "ReferencedCompensatorNumber",
  "(300c,00e0)" => "ReferencedBlockNumber",
  "(300c,00f0)" => "ReferencedControlPointIndex",
  "(300c,00f2)" => "ReferencedControlPointSequence",
  "(300c,00f4)" => "ReferencedStartControlPointIndex",
  "(300c,00f6)" => "ReferencedStopControlPointIndex",
  "(300c,0100)" => "ReferencedRangeShifterNumber",
  "(300c,0102)" => "ReferencedLateralSpreadingDeviceNumber",
  "(300c,0104)" => "ReferencedRangeModulatorNumber",
  "(300e,0002)" => "ApprovalStatus",
  "(300e,0004)" => "ReviewDate",
  "(300e,0005)" => "ReviewTime",
  "(300e,0008)" => "ReviewerName",
  "(4000,0010)" => "Arbitrary",
  "(4000,4000)" => "TextComments",
  "(4008,0040)" => "ResultsID",
  "(4008,0042)" => "ResultsIDIssuer",
  "(4008,0050)" => "ReferencedInterpretationSequence",
  "(4008,00ff)" => "ReportProductionStatusTrial",
  "(4008,0100)" => "InterpretationRecordedDate",
  "(4008,0101)" => "InterpretationRecordedTime",
  "(4008,0102)" => "InterpretationRecorder",
  "(4008,0103)" => "ReferenceToRecordedSound",
  "(4008,0108)" => "InterpretationTranscriptionDate",
  "(4008,0109)" => "InterpretationTranscriptionTime",
  "(4008,010a)" => "InterpretationTranscriber",
  "(4008,010b)" => "InterpretationText",
  "(4008,010c)" => "InterpretationAuthor",
  "(4008,0111)" => "InterpretationApproverSequence",
  "(4008,0112)" => "InterpretationApprovalDate",
  "(4008,0113)" => "InterpretationApprovalTime",
  "(4008,0114)" => "PhysicianApprovingInterpretation",
  "(4008,0115)" => "InterpretationDiagnosisDescription",
  "(4008,0117)" => "InterpretationDiagnosisCodeSequence",
  "(4008,0118)" => "ResultsDistributionListSequence",
  "(4008,0119)" => "DistributionName",
  "(4008,011a)" => "DistributionAddress",
  "(4008,0200)" => "InterpretationID",
  "(4008,0202)" => "InterpretationIDIssuer",
  "(4008,0210)" => "InterpretationTypeID",
  "(4008,0212)" => "InterpretationStatusID",
  "(4008,0300)" => "Impressions",
  "(4008,4000)" => "ResultsComments",
  "(4ffe,0001)" => "MACParametersSequence",
  "(5200,9229)" => "SharedFunctionalGroupsSequence",
  "(5200,9230)" => "PerFrameFunctionalGroupsSequence",
  "(5400,0100)" => "WaveformSequence",
  "(5400,0110)" => "ChannelMinimumValue",
  "(5400,0112)" => "ChannelMaximumValue",
  "(5400,1004)" => "WaveformBitsAllocated",
  "(5400,1006)" => "WaveformSampleInterpretation",
  "(5400,100a)" => "WaveformPaddingValue",
  "(5400,1010)" => "WaveformData",
  "(5600,0010)" => "FirstOrderPhaseCorrectionAngle",
  "(5600,0020)" => "SpectroscopyData",
  "(7fe0,0010)" => "PixelData",
  "(7fe0,0020)" => "CoefficientsSDVN",
  "(7fe0,0030)" => "CoefficientsSDHN",
  "(7fe0,0040)" => "CoefficientsSDDN",
  "(fffa,fffa)" => "DigitalSignaturesSequence",
  "(fffc,fffc)" => "DataSetTrailingPadding",
  "(fffe,e000)" => "Item",
  "(fffe,e00d)" => "ItemDelimitationItem",
  "(fffe,e0dd)" => "SequenceDelimitationItem",
};
$NameToSig = {
  LengthToEnd => "(0008,0001)",
  SpecificCharacterSet => "(0008,0005)",
  ImageType => "(0008,0008)",
  RecognitionCode => "(0008,0010)",
  InstanceCreationDate => "(0008,0012)",
  InstanceCreationTime => "(0008,0013)",
  InstanceCreatorUID => "(0008,0014)",
  SOPClassUID => "(0008,0016)",
  SOPInstanceUID => "(0008,0018)",
  RelatedGeneralSOPClassUID => "(0008,001a)",
  OriginalSpecializedSOPClassUID => "(0008,001b)",
  StudyDate => "(0008,0020)",
  SeriesDate => "(0008,0021)",
  AcquisitionDate => "(0008,0022)",
  ContentDate => "(0008,0023)",
  OverlayDate => "(0008,0024)",
  CurveDate => "(0008,0025)",
  AcquisitionDateTime => "(0008,002a)",
  StudyTime => "(0008,0030)",
  SeriesTime => "(0008,0031)",
  AcquisitionTime => "(0008,0032)",
  ContentTime => "(0008,0033)",
  OverlayTime => "(0008,0034)",
  CurveTime => "(0008,0035)",
  OldDataSetType => "(0008,0040)",
  OldDataSetSubtype => "(0008,0041)",
  NuclearMedicineSeriesTypeRetired => "(0008,0042)",
  AccessionNumber => "(0008,0050)",
  IssuerOfAccessionNumberSequence => "(0008,0051)",
  QueryRetrieveLevel => "(0008,0052)",
  RetrieveAETitle => "(0008,0054)",
  InstanceAvailability => "(0008,0056)",
  FailedSOPInstanceUIDList => "(0008,0058)",
  Modality => "(0008,0060)",
  ModalitiesInStudy => "(0008,0061)",
  SOPClassesInStudy => "(0008,0062)",
  ConversionType => "(0008,0064)",
  PresentationIntentType => "(0008,0068)",
  Manufacturer => "(0008,0070)",
  InstitutionName => "(0008,0080)",
  InstitutionAddress => "(0008,0081)",
  InstitutionCodeSequence => "(0008,0082)",
  ReferringPhysicianName => "(0008,0090)",
  ReferringPhysicianAddress => "(0008,0092)",
  ReferringPhysicianTelephoneNumber => "(0008,0094)",
  ReferringPhysicianIdentificationSequence => "(0008,0096)",
  CodeValue => "(0008,0100)",
  CodingSchemeDesignator => "(0008,0102)",
  CodingSchemeVersion => "(0008,0103)",
  CodeMeaning => "(0008,0104)",
  MappingResource => "(0008,0105)",
  ContextGroupVersion => "(0008,0106)",
  ContextGroupLocalVersion => "(0008,0107)",
  ContextGroupExtensionFlag => "(0008,010b)",
  CodingSchemeUID => "(0008,010c)",
  ContextGroupExtensionCreatorUID => "(0008,010d)",
  ContextIdentifier => "(0008,010f)",
  CodingSchemeIdentificationSequence => "(0008,0110)",
  CodingSchemeRegistry => "(0008,0112)",
  CodingSchemeExternalID => "(0008,0114)",
  CodingSchemeName => "(0008,0115)",
  CodingSchemeResponsibleOrganization => "(0008,0116)",
  ContextUID => "(0008,0117)",
  TimezoneOffsetFromUTC => "(0008,0201)",
  NetworkID => "(0008,1000)",
  StationName => "(0008,1010)",
  StudyDescription => "(0008,1030)",
  ProcedureCodeSequence => "(0008,1032)",
  SeriesDescription => "(0008,103e)",
  InstitutionalDepartmentName => "(0008,1040)",
  PhysicianOfRecord => "(0008,1048)",
  PhysicianOfRecordIdentificationSequence => "(0008,1049)",
  PerformingPhysicianName => "(0008,1050)",
  PerformingPhysicianIdentificationSequence => "(0008,1052)",
  PhysicianReadingStudy => "(0008,1060)",
  PhysicianReadingStudyIdentificationSequence => "(0008,1062)",
  OperatorsName => "(0008,1070)",
  OperatorIdentificationSequence => "(0008,1072)",
  AdmittingDiagnosesDescription => "(0008,1080)",
  AdmittingDiagnosesCodeSequence => "(0008,1084)",
  ManufacturerModelName => "(0008,1090)",
  ReferencedResultsSequence => "(0008,1100)",
  ReferencedStudySequence => "(0008,1110)",
  ReferencedPerformedProcedureStepSequence => "(0008,1111)",
  ReferencedSeriesSequence => "(0008,1115)",
  ReferencedPatientSequence => "(0008,1120)",
  ReferencedVisitSequence => "(0008,1125)",
  ReferencedOverlaySequence => "(0008,1130)",
  ReferencedWaveformSequence => "(0008,113a)",
  ReferencedImageSequence => "(0008,1140)",
  ReferencedCurveSequence => "(0008,1145)",
  ReferencedInstanceSequence => "(0008,114a)",
  ReferencedRealWorldValueMappingInstanceSequence => "(0008,114b)",
  ReferencedSOPClassUID => "(0008,1150)",
  ReferencedSOPInstanceUID => "(0008,1155)",
  SOPClassesSupported => "(0008,115a)",
  ReferencedFrameNumber => "(0008,1160)",
  TransactionUID => "(0008,1195)",
  FailureReason => "(0008,1197)",
  FailedSOPSequence => "(0008,1198)",
  ReferencedSOPSequence => "(0008,1199)",
  StudiesContainingOtherReferencedInstancesSequence => "(0008,1200)",
  RelatedSeriesSequence => "(0008,1250)",
  OldLossyImageCompression => "(0008,2110)",
  DerivationDescription => "(0008,2111)",
  SourceImageSequence => "(0008,2112)",
  StageName => "(0008,2120)",
  StageNumber => "(0008,2122)",
  NumberOfStages => "(0008,2124)",
  ViewName => "(0008,2127)",
  ViewNumber => "(0008,2128)",
  NumberOfEventTimers => "(0008,2129)",
  NumberOfViewsInStage => "(0008,212a)",
  EventElapsedTime => "(0008,2130)",
  EventTimerName => "(0008,2132)",
  StartTrim => "(0008,2142)",
  StopTrim => "(0008,2143)",
  RecommendedDisplayFrameRate => "(0008,2144)",
  TransducerPosition => "(0008,2200)",
  TransducerOrientation => "(0008,2204)",
  AnatomicStructure => "(0008,2208)",
  AnatomicRegionSequence => "(0008,2218)",
  AnatomicRegionModifierSequence => "(0008,2220)",
  PrimaryAnatomicStructureSequence => "(0008,2228)",
  AnatomicStructureSpaceOrRegionSequence => "(0008,2229)",
  PrimaryAnatomicStructureModifierSequence => "(0008,2230)",
  TransducerPositionSequence => "(0008,2240)",
  TransducerPositionModifierSequence => "(0008,2242)",
  TransducerOrientationSequence => "(0008,2244)",
  TransducerOrientationModifierSequence => "(0008,2246)",
  AnatomicStructureSpaceOrRegionCodeSequenceTrial => "(0008,2251)",
  AnatomicPortalOfEntranceCodeSequenceTrial => "(0008,2253)",
  AnatomicApproachDirectionCodeSequenceTrial => "(0008,2255)",
  AnatomicPerspectiveDescriptionTrial => "(0008,2256)",
  AnatomicPerspectiveCodeSequenceTrial => "(0008,2257)",
  AnatomicLocationOfExaminingInstrumentDescriptionTrial => "(0008,2258)",
  AnatomicLocationOfExaminingInstrumentCodeSequenceTrial => "(0008,2259)",
  AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial => "(0008,225a)",
  OnAxisBackgroundAnatomicStructureCodeSequenceTrial => "(0008,225c)",
  AlternateRepresentationSequence => "(0008,3001)",
  IrradiationEventUID => "(0008,3010)",
  IdentifyingComments => "(0008,4000)",
  FrameType => "(0008,9007)",
  ReferencedImageEvidenceSequence => "(0008,9092)",
  ReferencedRawDataSequence => "(0008,9121)",
  CreatorVersionUID => "(0008,9123)",
  DerivationImageSequence => "(0008,9124)",
  SourceImageEvidenceSequence => "(0008,9154)",
  PixelPresentation => "(0008,9205)",
  VolumetricProperties => "(0008,9206)",
  VolumeBasedCalculationTechnique => "(0008,9207)",
  ComplexImageComponent => "(0008,9208)",
  AcquisitionContrast => "(0008,9209)",
  DerivationCodeSequence => "(0008,9215)",
  ReferencedGrayscalePresentationStateSequence => "(0008,9237)",
  ReferencedOtherPlaneSequence => "(0008,9410)",
  FrameDisplaySequence => "(0008,9458)",
  RecommendedDisplayFrameRateInFloat => "(0008,9459)",
  SkipFrameRangeFlag => "(0008,9460)",
  PatientName => "(0010,0010)",
  PatientID => "(0010,0020)",
  IssuerOfPatientID => "(0010,0021)",
  TypeOfPatientID => "(0010,0022)",
  IssuerOfPatientIDQualifiersSequence => "(0010,0024)",
  PatientBirthDate => "(0010,0030)",
  PatientBirthTime => "(0010,0032)",
  PatientSex => "(0010,0040)",
  PatientInsurancePlanCodeSequence => "(0010,0050)",
  PatientPrimaryLanguageCodeSequence => "(0010,0101)",
  PatientPrimaryLanguageModifierCodeSequence => "(0010,0102)",
  OtherPatientID => "(0010,1000)",
  OtherPatientName => "(0010,1001)",
  OtherPatientIDSequence => "(0010,1002)",
  PatientBirthName => "(0010,1005)",
  PatientAge => "(0010,1010)",
  PatientSize => "(0010,1020)",
  PatientWeight => "(0010,1030)",
  PatientAddress => "(0010,1040)",
  InsurancePlanIdentification => "(0010,1050)",
  PatientMotherBirthName => "(0010,1060)",
  MilitaryRank => "(0010,1080)",
  BranchOfService => "(0010,1081)",
  MedicalRecordLocator => "(0010,1090)",
  MedicalAlerts => "(0010,2000)",
  Allergies => "(0010,2110)",
  CountryOfResidence => "(0010,2150)",
  RegionOfResidence => "(0010,2152)",
  PatientTelephoneNumber => "(0010,2154)",
  EthnicGroup => "(0010,2160)",
  Occupation => "(0010,2180)",
  SmokingStatus => "(0010,21a0)",
  AdditionalPatientHistory => "(0010,21b0)",
  PregnancyStatus => "(0010,21c0)",
  LastMenstrualDate => "(0010,21d0)",
  PatientReligiousPreference => "(0010,21f0)",
  PatientSpeciesDescription => "(0010,2201)",
  PatientSpeciesCodeSequence => "(0010,2202)",
  PatientSexNeutered => "(0010,2203)",
  PatientBreedDescription => "(0010,2292)",
  PatientBreedCodeSequence => "(0010,2293)",
  BreedRegistrationSequence => "(0010,2294)",
  BreedRegistrationNumber => "(0010,2295)",
  BreedRegistryCodeSequence => "(0010,2296)",
  ResponsiblePerson => "(0010,2297)",
  ResponsiblePersonRole => "(0010,2298)",
  ResponsibleOrganization => "(0010,2299)",
  PatientComments => "(0010,4000)",
  ExaminedBodyThickness => "(0010,9431)",
  ClinicalTrialSponsorName => "(0012,0010)",
  ClinicalTrialProtocolID => "(0012,0020)",
  ClinicalTrialProtocolName => "(0012,0021)",
  ClinicalTrialSiteID => "(0012,0030)",
  ClinicalTrialSiteName => "(0012,0031)",
  ClinicalTrialSubjectID => "(0012,0040)",
  ClinicalTrialSubjectReadingID => "(0012,0042)",
  ClinicalTrialTimePointID => "(0012,0050)",
  ClinicalTrialTimePointDescription => "(0012,0051)",
  ClinicalTrialCoordinatingCenterName => "(0012,0060)",
  PatientIdentityRemoved => "(0012,0062)",
  DeidentificationMethod => "(0012,0063)",
  DeidentificationMethodCodeSequence => "(0012,0064)",
  ClinicalTrialSeriesID => "(0012,0071)",
  ClinicalTrialSeriesDescription => "(0012,0072)",
  ContrastBolusAgent => "(0018,0010)",
  ContrastBolusAgentSequence => "(0018,0012)",
  ContrastBolusAdministrationRouteSequence => "(0018,0014)",
  BodyPartExamined => "(0018,0015)",
  ScanningSequence => "(0018,0020)",
  SequenceVariant => "(0018,0021)",
  ScanOptions => "(0018,0022)",
  MRAcquisitionType => "(0018,0023)",
  SequenceName => "(0018,0024)",
  AngioFlag => "(0018,0025)",
  InterventionDrugInformationSequence => "(0018,0026)",
  InterventionDrugStopTime => "(0018,0027)",
  InterventionDrugDose => "(0018,0028)",
  InterventionDrugCodeSequence => "(0018,0029)",
  AdditionalDrugSequence => "(0018,002a)",
  Radionuclide => "(0018,0030)",
  Radiopharmaceutical => "(0018,0031)",
  EnergyWindowCenterline => "(0018,0032)",
  EnergyWindowTotalWidth => "(0018,0033)",
  InterventionDrugName => "(0018,0034)",
  InterventionDrugStartTime => "(0018,0035)",
  InterventionSequence => "(0018,0036)",
  TherapyType => "(0018,0037)",
  InterventionStatus => "(0018,0038)",
  TherapyDescription => "(0018,0039)",
  InterventionDescription => "(0018,003a)",
  CineRate => "(0018,0040)",
  SliceThickness => "(0018,0050)",
  KVP => "(0018,0060)",
  CountsAccumulated => "(0018,0070)",
  AcquisitionTerminationCondition => "(0018,0071)",
  EffectiveDuration => "(0018,0072)",
  AcquisitionStartCondition => "(0018,0073)",
  AcquisitionStartConditionData => "(0018,0074)",
  AcquisitionTerminationConditionData => "(0018,0075)",
  RepetitionTime => "(0018,0080)",
  EchoTime => "(0018,0081)",
  InversionTime => "(0018,0082)",
  NumberOfAverages => "(0018,0083)",
  ImagingFrequency => "(0018,0084)",
  ImagedNucleus => "(0018,0085)",
  EchoNumber => "(0018,0086)",
  MagneticFieldStrength => "(0018,0087)",
  SpacingBetweenSlices => "(0018,0088)",
  NumberOfPhaseEncodingSteps => "(0018,0089)",
  DataCollectionDiameter => "(0018,0090)",
  EchoTrainLength => "(0018,0091)",
  PercentSampling => "(0018,0093)",
  PercentPhaseFieldOfView => "(0018,0094)",
  PixelBandwidth => "(0018,0095)",
  DeviceSerialNumber => "(0018,1000)",
  DeviceUID => "(0018,1002)",
  PlateID => "(0018,1004)",
  GeneratorID => "(0018,1005)",
  GridID => "(0018,1006)",
  CassetteID => "(0018,1007)",
  GantryID => "(0018,1008)",
  SecondaryCaptureDeviceID => "(0018,1010)",
  HardcopyCreationDeviceID => "(0018,1011)",
  DateOfSecondaryCapture => "(0018,1012)",
  TimeOfSecondaryCapture => "(0018,1014)",
  SecondaryCaptureDeviceManufacturer => "(0018,1016)",
  HardcopyDeviceManufacturer => "(0018,1017)",
  SecondaryCaptureDeviceManufacturerModelName => "(0018,1018)",
  SecondaryCaptureDeviceSoftwareVersion => "(0018,1019)",
  HardcopyDeviceSoftwareVersion => "(0018,101a)",
  HardcopyDeviceManufacturerModelName => "(0018,101b)",
  SoftwareVersion => "(0018,1020)",
  VideoImageFormatAcquired => "(0018,1022)",
  DigitalImageFormatAcquired => "(0018,1023)",
  ProtocolName => "(0018,1030)",
  ContrastBolusRoute => "(0018,1040)",
  ContrastBolusVolume => "(0018,1041)",
  ContrastBolusStartTime => "(0018,1042)",
  ContrastBolusStopTime => "(0018,1043)",
  ContrastBolusTotalDose => "(0018,1044)",
  SyringeCounts => "(0018,1045)",
  ContrastFlowRate => "(0018,1046)",
  ContrastFlowDuration => "(0018,1047)",
  ContrastBolusIngredient => "(0018,1048)",
  ContrastBolusIngredientConcentration => "(0018,1049)",
  SpatialResolution => "(0018,1050)",
  TriggerTime => "(0018,1060)",
  TriggerSourceOrType => "(0018,1061)",
  NominalInterval => "(0018,1062)",
  FrameTime => "(0018,1063)",
  CardiacFramingType => "(0018,1064)",
  FrameTimeVector => "(0018,1065)",
  FrameDelay => "(0018,1066)",
  ImageTriggerDelay => "(0018,1067)",
  MultiplexGroupTimeOffset => "(0018,1068)",
  TriggerTimeOffset => "(0018,1069)",
  SynchronizationTrigger => "(0018,106a)",
  SynchronizationChannel => "(0018,106c)",
  TriggerSamplePosition => "(0018,106e)",
  RadiopharmaceuticalRoute => "(0018,1070)",
  RadiopharmaceuticalVolume => "(0018,1071)",
  RadiopharmaceuticalStartTime => "(0018,1072)",
  RadiopharmaceuticalStopTime => "(0018,1073)",
  RadionuclideTotalDose => "(0018,1074)",
  RadionuclideHalfLife => "(0018,1075)",
  RadionuclidePositronFraction => "(0018,1076)",
  RadiopharmaceuticalSpecificActivity => "(0018,1077)",
  RadiopharmaceuticalStartDateTime => "(0018,1078)",
  RadiopharmaceuticalStopDateTime => "(0018,1079)",
  BeatRejectionFlag => "(0018,1080)",
  LowRRValue => "(0018,1081)",
  HighRRValue => "(0018,1082)",
  IntervalsAcquired => "(0018,1083)",
  IntervalsRejected => "(0018,1084)",
  PVCRejection => "(0018,1085)",
  SkipBeats => "(0018,1086)",
  HeartRate => "(0018,1088)",
  CardiacNumberOfImages => "(0018,1090)",
  TriggerWindow => "(0018,1094)",
  ReconstructionDiameter => "(0018,1100)",
  DistanceSourceToDetector => "(0018,1110)",
  DistanceSourceToPatient => "(0018,1111)",
  EstimatedRadiographicMagnificationFactor => "(0018,1114)",
  GantryDetectorTilt => "(0018,1120)",
  GantryDetectorSlew => "(0018,1121)",
  TableHeight => "(0018,1130)",
  TableTraverse => "(0018,1131)",
  TableMotion => "(0018,1134)",
  TableVerticalIncrement => "(0018,1135)",
  TableLateralIncrement => "(0018,1136)",
  TableLongitudinalIncrement => "(0018,1137)",
  TableAngle => "(0018,1138)",
  TableType => "(0018,113a)",
  RotationDirection => "(0018,1140)",
  AngularPosition => "(0018,1141)",
  RadialPosition => "(0018,1142)",
  ScanArc => "(0018,1143)",
  AngularStep => "(0018,1144)",
  CenterOfRotationOffset => "(0018,1145)",
  RotationOffset => "(0018,1146)",
  FieldOfViewShape => "(0018,1147)",
  FieldOfViewDimensions => "(0018,1149)",
  ExposureTime => "(0018,1150)",
  XRayTubeCurrent => "(0018,1151)",
  Exposure => "(0018,1152)",
  ExposureInuAs => "(0018,1153)",
  AveragePulseWidth => "(0018,1154)",
  RadiationSetting => "(0018,1155)",
  RectificationType => "(0018,1156)",
  RadiationMode => "(0018,115a)",
  ImageAndFluoroscopyAreaDoseProduct => "(0018,115e)",
  FilterType => "(0018,1160)",
  TypeOfFilters => "(0018,1161)",
  IntensifierSize => "(0018,1162)",
  ImagerPixelSpacing => "(0018,1164)",
  Grid => "(0018,1166)",
  GeneratorPower => "(0018,1170)",
  CollimatorGridName => "(0018,1180)",
  CollimatorType => "(0018,1181)",
  FocalDistance => "(0018,1182)",
  XFocusCenter => "(0018,1183)",
  YFocusCenter => "(0018,1184)",
  FocalSpot => "(0018,1190)",
  AnodeTargetMaterial => "(0018,1191)",
  BodyPartThickness => "(0018,11a0)",
  CompressionForce => "(0018,11a2)",
  DateOfLastCalibration => "(0018,1200)",
  TimeOfLastCalibration => "(0018,1201)",
  ConvolutionKernel => "(0018,1210)",
  UpperLowerPixelValues => "(0018,1240)",
  ActualFrameDuration => "(0018,1242)",
  CountRate => "(0018,1243)",
  PreferredPlaybackSequencing => "(0018,1244)",
  ReceiveCoilName => "(0018,1250)",
  TransmitCoilName => "(0018,1251)",
  PlateType => "(0018,1260)",
  PhosphorType => "(0018,1261)",
  ScanVelocity => "(0018,1300)",
  WholeBodyTechnique => "(0018,1301)",
  ScanLength => "(0018,1302)",
  AcquisitionMatrix => "(0018,1310)",
  InPlanePhaseEncodingDirection => "(0018,1312)",
  FlipAngle => "(0018,1314)",
  VariableFlipAngleFlag => "(0018,1315)",
  SAR => "(0018,1316)",
  dBdt => "(0018,1318)",
  AcquisitionDeviceProcessingDescription => "(0018,1400)",
  AcquisitionDeviceProcessingCode => "(0018,1401)",
  CassetteOrientation => "(0018,1402)",
  CassetteSize => "(0018,1403)",
  ExposuresOnPlate => "(0018,1404)",
  RelativeXRayExposure => "(0018,1405)",
  ColumnAngulation => "(0018,1450)",
  TomoLayerHeight => "(0018,1460)",
  TomoAngle => "(0018,1470)",
  TomoTime => "(0018,1480)",
  TomoType => "(0018,1490)",
  TomoClass => "(0018,1491)",
  NumberOfTomosynthesisSourceImages => "(0018,1495)",
  PositionerMotion => "(0018,1500)",
  PositionerType => "(0018,1508)",
  PositionerPrimaryAngle => "(0018,1510)",
  PositionerSecondaryAngle => "(0018,1511)",
  PositionerPrimaryAngleIncrement => "(0018,1520)",
  PositionerSecondaryAngleIncrement => "(0018,1521)",
  DetectorPrimaryAngle => "(0018,1530)",
  DetectorSecondaryAngle => "(0018,1531)",
  ShutterShape => "(0018,1600)",
  ShutterLeftVerticalEdge => "(0018,1602)",
  ShutterRightVerticalEdge => "(0018,1604)",
  ShutterUpperHorizontalEdge => "(0018,1606)",
  ShutterLowerHorizontalEdge => "(0018,1608)",
  CenterOfCircularShutter => "(0018,1610)",
  RadiusOfCircularShutter => "(0018,1612)",
  VerticesOfPolygonalShutter => "(0018,1620)",
  ShutterPresentationValue => "(0018,1622)",
  ShutterOverlayGroup => "(0018,1623)",
  ShutterPresentationColorCIELabValue => "(0018,1624)",
  CollimatorShape => "(0018,1700)",
  CollimatorLeftVerticalEdge => "(0018,1702)",
  CollimatorRightVerticalEdge => "(0018,1704)",
  CollimatorUpperHorizontalEdge => "(0018,1706)",
  CollimatorLowerHorizontalEdge => "(0018,1708)",
  CenterOfCircularCollimator => "(0018,1710)",
  RadiusOfCircularCollimator => "(0018,1712)",
  VerticesOfPolygonalCollimator => "(0018,1720)",
  AcquisitionTimeSynchronized => "(0018,1800)",
  TimeSource => "(0018,1801)",
  TimeDistributionProtocol => "(0018,1802)",
  NTPSourceAddress => "(0018,1803)",
  PageNumberVector => "(0018,2001)",
  FrameLabelVector => "(0018,2002)",
  FramePrimaryAngleVector => "(0018,2003)",
  FrameSecondaryAngleVector => "(0018,2004)",
  SliceLocationVector => "(0018,2005)",
  DisplayWindowLabelVector => "(0018,2006)",
  NominalScannedPixelSpacing => "(0018,2010)",
  DigitizingDeviceTransportDirection => "(0018,2020)",
  RotationOfScannedFilm => "(0018,2030)",
  IVUSAcquisition => "(0018,3100)",
  IVUSPullbackRate => "(0018,3101)",
  IVUSGatedRate => "(0018,3102)",
  IVUSPullbackStartFrameNumber => "(0018,3103)",
  IVUSPullbackStopFrameNumber => "(0018,3104)",
  LesionNumber => "(0018,3105)",
  AcquisitionComments => "(0018,4000)",
  OutputPower => "(0018,5000)",
  TransducerData => "(0018,5010)",
  FocusDepth => "(0018,5012)",
  ProcessingFunction => "(0018,5020)",
  PostprocessingFunction => "(0018,5021)",
  MechanicalIndex => "(0018,5022)",
  BoneThermalIndex => "(0018,5024)",
  CranialThermalIndex => "(0018,5026)",
  SoftTissueThermalIndex => "(0018,5027)",
  SoftTissueFocusThermalIndex => "(0018,5028)",
  SoftTissueSurfaceThermalIndex => "(0018,5029)",
  DynamicRange => "(0018,5030)",
  TotalGain => "(0018,5040)",
  DepthOfScanField => "(0018,5050)",
  PatientPosition => "(0018,5100)",
  ViewPosition => "(0018,5101)",
  ProjectionEponymousNameCodeSequence => "(0018,5104)",
  ImageTransformationMatrix => "(0018,5210)",
  ImageTranslationVector => "(0018,5212)",
  Sensitivity => "(0018,6000)",
  SequenceOfUltrasoundRegions => "(0018,6011)",
  RegionSpatialFormat => "(0018,6012)",
  RegionDataType => "(0018,6014)",
  RegionFlags => "(0018,6016)",
  RegionLocationMinX0 => "(0018,6018)",
  RegionLocationMinY0 => "(0018,601a)",
  RegionLocationMaxX1 => "(0018,601c)",
  RegionLocationMaxY1 => "(0018,601e)",
  ReferencePixelX0 => "(0018,6020)",
  ReferencePixelY0 => "(0018,6022)",
  PhysicalUnitsXDirection => "(0018,6024)",
  PhysicalUnitsYDirection => "(0018,6026)",
  ReferencePixelPhysicalValueX => "(0018,6028)",
  ReferencePixelPhysicalValueY => "(0018,602a)",
  PhysicalDeltaX => "(0018,602c)",
  PhysicalDeltaY => "(0018,602e)",
  TransducerFrequency => "(0018,6030)",
  TransducerType => "(0018,6031)",
  PulseRepetitionFrequency => "(0018,6032)",
  DopplerCorrectionAngle => "(0018,6034)",
  SteeringAngle => "(0018,6036)",
  DopplerSampleVolumeXPositionRetired => "(0018,6038)",
  DopplerSampleVolumeXPosition => "(0018,6039)",
  DopplerSampleVolumeYPositionRetired => "(0018,603a)",
  DopplerSampleVolumeYPosition => "(0018,603b)",
  TMLinePositionX0Retired => "(0018,603c)",
  TMLinePositionX0 => "(0018,603d)",
  TMLinePositionY0Retired => "(0018,603e)",
  TMLinePositionY0 => "(0018,603f)",
  TMLinePositionX1Retired => "(0018,6040)",
  TMLinePositionX1 => "(0018,6041)",
  TMLinePositionY1Retired => "(0018,6042)",
  TMLinePositionY1 => "(0018,6043)",
  PixelComponentOrganization => "(0018,6044)",
  PixelComponentMask => "(0018,6046)",
  PixelComponentRangeStart => "(0018,6048)",
  PixelComponentRangeStop => "(0018,604a)",
  PixelComponentPhysicalUnits => "(0018,604c)",
  PixelComponentDataType => "(0018,604e)",
  NumberOfTableBreakPoints => "(0018,6050)",
  TableOfXBreakPoints => "(0018,6052)",
  TableOfYBreakPoints => "(0018,6054)",
  NumberOfTableEntries => "(0018,6056)",
  TableOfPixelValues => "(0018,6058)",
  TableOfParameterValues => "(0018,605a)",
  RWaveTimeVector => "(0018,6060)",
  DetectorConditionsNominalFlag => "(0018,7000)",
  DetectorTemperature => "(0018,7001)",
  DetectorType => "(0018,7004)",
  DetectorConfiguration => "(0018,7005)",
  DetectorDescription => "(0018,7006)",
  DetectorMode => "(0018,7008)",
  DetectorID => "(0018,700a)",
  DateOfLastDetectorCalibration => "(0018,700c)",
  TimeOfLastDetectorCalibration => "(0018,700e)",
  ExposuresOnDetectorSinceLastCalibration => "(0018,7010)",
  ExposuresOnDetectorSinceManufactured => "(0018,7011)",
  DetectorTimeSinceLastExposure => "(0018,7012)",
  DetectorActiveTime => "(0018,7014)",
  DetectorActivationOffsetFromExposure => "(0018,7016)",
  DetectorBinning => "(0018,701a)",
  DetectorElementPhysicalSize => "(0018,7020)",
  DetectorElementSpacing => "(0018,7022)",
  DetectorActiveShape => "(0018,7024)",
  DetectorActiveDimensions => "(0018,7026)",
  DetectorActiveOrigin => "(0018,7028)",
  DetectorManufacturerName => "(0018,702a)",
  DetectorManufacturerModelName => "(0018,702b)",
  FieldOfViewOrigin => "(0018,7030)",
  FieldOfViewRotation => "(0018,7032)",
  FieldOfViewHorizontalFlip => "(0018,7034)",
  GridAbsorbingMaterial => "(0018,7040)",
  GridSpacingMaterial => "(0018,7041)",
  GridThickness => "(0018,7042)",
  GridPitch => "(0018,7044)",
  GridAspectRatio => "(0018,7046)",
  GridPeriod => "(0018,7048)",
  GridFocalDistance => "(0018,704c)",
  FilterMaterial => "(0018,7050)",
  FilterThicknessMinimum => "(0018,7052)",
  FilterThicknessMaximum => "(0018,7054)",
  ExposureControlMode => "(0018,7060)",
  ExposureControlModeDescription => "(0018,7062)",
  ExposureStatus => "(0018,7064)",
  PhototimerSetting => "(0018,7065)",
  ExposureTimeInuS => "(0018,8150)",
  XRayTubeCurrentInuA => "(0018,8151)",
  ContentQualification => "(0018,9004)",
  PulseSequenceName => "(0018,9005)",
  MRImagingModifierSequence => "(0018,9006)",
  EchoPulseSequence => "(0018,9008)",
  InversionRecovery => "(0018,9009)",
  FlowCompensation => "(0018,9010)",
  MultipleSpinEcho => "(0018,9011)",
  MultiplanarExcitation => "(0018,9012)",
  PhaseContrast => "(0018,9014)",
  TimeOfFlightContrast => "(0018,9015)",
  Spoiling => "(0018,9016)",
  SteadyStatePulseSequence => "(0018,9017)",
  EchoPlanarPulseSequence => "(0018,9018)",
  TagAngleFirstAxis => "(0018,9019)",
  MagnetizationTransfer => "(0018,9020)",
  T2Preparation => "(0018,9021)",
  BloodSignalNulling => "(0018,9022)",
  SaturationRecovery => "(0018,9024)",
  SpectrallySelectedSuppression => "(0018,9025)",
  SpectrallySelectedExcitation => "(0018,9026)",
  SpatialPresaturation => "(0018,9027)",
  Tagging => "(0018,9028)",
  OversamplingPhase => "(0018,9029)",
  TagSpacingFirstDimension => "(0018,9030)",
  GeometryOfKSpaceTraversal => "(0018,9032)",
  SegmentedKSpaceTraversal => "(0018,9033)",
  RectilinearPhaseEncodeReordering => "(0018,9034)",
  TagThickness => "(0018,9035)",
  PartialFourierDirection => "(0018,9036)",
  CardiacSynchronizationTechnique => "(0018,9037)",
  ReceiveCoilManufacturerName => "(0018,9041)",
  MRReceiveCoilSequence => "(0018,9042)",
  ReceiveCoilType => "(0018,9043)",
  QuadratureReceiveCoil => "(0018,9044)",
  MultiCoilDefinitionSequence => "(0018,9045)",
  MultiCoilConfiguration => "(0018,9046)",
  MultiCoilElementName => "(0018,9047)",
  MultiCoilElementUsed => "(0018,9048)",
  MRTransmitCoilSequence => "(0018,9049)",
  TransmitCoilManufacturerName => "(0018,9050)",
  TransmitCoilType => "(0018,9051)",
  SpectralWidth => "(0018,9052)",
  ChemicalShiftReference => "(0018,9053)",
  VolumeLocalizationTechnique => "(0018,9054)",
  MRAcquisitionFrequencyEncodingSteps => "(0018,9058)",
  Decoupling => "(0018,9059)",
  DecoupledNucleus => "(0018,9060)",
  DecouplingFrequency => "(0018,9061)",
  DecouplingMethod => "(0018,9062)",
  DecouplingChemicalShiftReference => "(0018,9063)",
  KSpaceFiltering => "(0018,9064)",
  TimeDomainFiltering => "(0018,9065)",
  NumberOfZeroFills => "(0018,9066)",
  BaselineCorrection => "(0018,9067)",
  ParallelReductionFactorInPlane => "(0018,9069)",
  CardiacRRIntervalSpecified => "(0018,9070)",
  AcquisitionDuration => "(0018,9073)",
  FrameAcquisitionDateTime => "(0018,9074)",
  DiffusionDirectionality => "(0018,9075)",
  DiffusionGradientDirectionSequence => "(0018,9076)",
  ParallelAcquisition => "(0018,9077)",
  ParallelAcquisitionTechnique => "(0018,9078)",
  InversionTimes => "(0018,9079)",
  MetaboliteMapDescription => "(0018,9080)",
  PartialFourier => "(0018,9081)",
  EffectiveEchoTime => "(0018,9082)",
  MetaboliteCodeSequence => "(0018,9083)",
  ChemicalShiftSequence => "(0018,9084)",
  CardiacSignalSource => "(0018,9085)",
  DiffusionBValue => "(0018,9087)",
  DiffusionGradientOrientation => "(0018,9089)",
  VelocityEncodingDirection => "(0018,9090)",
  VelocityEncodingMinimumValue => "(0018,9091)",
  NumberOfKSpaceTrajectories => "(0018,9093)",
  CoverageOfKSpace => "(0018,9094)",
  SpectroscopyAcquisitionPhaseRows => "(0018,9095)",
  ParallelReductionFactorInPlaneRetired => "(0018,9096)",
  TransmitterFrequency => "(0018,9098)",
  ResonantNucleus => "(0018,9100)",
  FrequencyCorrection => "(0018,9101)",
  MRSpectroscopyFOVGeometrySequence => "(0018,9103)",
  SlabThickness => "(0018,9104)",
  SlabOrientation => "(0018,9105)",
  MidSlabPosition => "(0018,9106)",
  MRSpatialSaturationSequence => "(0018,9107)",
  MRTimingAndRelatedParametersSequence => "(0018,9112)",
  MREchoSequence => "(0018,9114)",
  MRModifierSequence => "(0018,9115)",
  MRDiffusionSequence => "(0018,9117)",
  CardiacSynchronizationSequence => "(0018,9118)",
  MRAveragesSequence => "(0018,9119)",
  MRFOVGeometrySequence => "(0018,9125)",
  VolumeLocalizationSequence => "(0018,9126)",
  SpectroscopyAcquisitionDataColumns => "(0018,9127)",
  DiffusionAnisotropyType => "(0018,9147)",
  FrameReferenceDateTime => "(0018,9151)",
  MRMetaboliteMapSequence => "(0018,9152)",
  ParallelReductionFactorOutOfPlane => "(0018,9155)",
  SpectroscopyAcquisitionOutOfPlanePhaseSteps => "(0018,9159)",
  BulkMotionStatus => "(0018,9166)",
  ParallelReductionFactorSecondInPlane => "(0018,9168)",
  CardiacBeatRejectionTechnique => "(0018,9169)",
  RespiratoryMotionCompensationTechnique => "(0018,9170)",
  RespiratorySignalSource => "(0018,9171)",
  BulkMotionCompensationTechnique => "(0018,9172)",
  BulkMotionSignalSource => "(0018,9173)",
  ApplicableSafetyStandardAgency => "(0018,9174)",
  ApplicableSafetyStandardDescription => "(0018,9175)",
  OperatingModeSequence => "(0018,9176)",
  OperatingModeType => "(0018,9177)",
  OperatingMode => "(0018,9178)",
  SpecificAbsorptionRateDefinition => "(0018,9179)",
  GradientOutputType => "(0018,9180)",
  SpecificAbsorptionRateValue => "(0018,9181)",
  GradientOutput => "(0018,9182)",
  FlowCompensationDirection => "(0018,9183)",
  TaggingDelay => "(0018,9184)",
  RespiratoryMotionCompensationTechniqueDescription => "(0018,9185)",
  RespiratorySignalSourceID => "(0018,9186)",
  ChemicalShiftMinimumIntegrationLimitInHz => "(0018,9195)",
  ChemicalShiftMaximumIntegrationLimitInHz => "(0018,9196)",
  MRVelocityEncodingSequence => "(0018,9197)",
  FirstOrderPhaseCorrection => "(0018,9198)",
  WaterReferencedPhaseCorrection => "(0018,9199)",
  MRSpectroscopyAcquisitionType => "(0018,9200)",
  RespiratoryCyclePosition => "(0018,9214)",
  VelocityEncodingMaximumValue => "(0018,9217)",
  TagSpacingSecondDimension => "(0018,9218)",
  TagAngleSecondAxis => "(0018,9219)",
  FrameAcquisitionDuration => "(0018,9220)",
  MRImageFrameTypeSequence => "(0018,9226)",
  MRSpectroscopyFrameTypeSequence => "(0018,9227)",
  MRAcquisitionPhaseEncodingStepsInPlane => "(0018,9231)",
  MRAcquisitionPhaseEncodingStepsOutOfPlane => "(0018,9232)",
  SpectroscopyAcquisitionPhaseColumns => "(0018,9234)",
  CardiacCyclePosition => "(0018,9236)",
  SpecificAbsorptionRateSequence => "(0018,9239)",
  RFEchoTrainLength => "(0018,9240)",
  GradientEchoTrainLength => "(0018,9241)",
  ChemicalShiftMinimumIntegrationLimitInPPM => "(0018,9295)",
  ChemicalShiftMaximumIntegrationLimitInPPM => "(0018,9296)",
  CTAcquisitionTypeSequence => "(0018,9301)",
  AcquisitionType => "(0018,9302)",
  TubeAngle => "(0018,9303)",
  CTAcquisitionDetailsSequence => "(0018,9304)",
  RevolutionTime => "(0018,9305)",
  SingleCollimationWidth => "(0018,9306)",
  TotalCollimationWidth => "(0018,9307)",
  CTTableDynamicsSequence => "(0018,9308)",
  TableSpeed => "(0018,9309)",
  TableFeedPerRotation => "(0018,9310)",
  SpiralPitchFactor => "(0018,9311)",
  CTGeometrySequence => "(0018,9312)",
  DataCollectionCenterPatient => "(0018,9313)",
  CTReconstructionSequence => "(0018,9314)",
  ReconstructionAlgorithm => "(0018,9315)",
  ConvolutionKernelGroup => "(0018,9316)",
  ReconstructionFieldOfView => "(0018,9317)",
  ReconstructionTargetCenterPatient => "(0018,9318)",
  ReconstructionAngle => "(0018,9319)",
  ImageFilter => "(0018,9320)",
  CTExposureSequence => "(0018,9321)",
  ReconstructionPixelSpacing => "(0018,9322)",
  ExposureModulationType => "(0018,9323)",
  EstimatedDoseSaving => "(0018,9324)",
  CTXRayDetailsSequence => "(0018,9325)",
  CTPositionSequence => "(0018,9326)",
  TablePosition => "(0018,9327)",
  ExposureTimeInms => "(0018,9328)",
  CTImageFrameTypeSequence => "(0018,9329)",
  XRayTubeCurrentInmA => "(0018,9330)",
  ExposureInmAs => "(0018,9332)",
  ConstantVolumeFlag => "(0018,9333)",
  FluoroscopyFlag => "(0018,9334)",
  DistanceSourceToDataCollectionCenter => "(0018,9335)",
  ContrastBolusAgentNumber => "(0018,9337)",
  ContrastBolusIngredientCodeSequence => "(0018,9338)",
  ContrastAdministrationProfileSequence => "(0018,9340)",
  ContrastBolusUsageSequence => "(0018,9341)",
  ContrastBolusAgentAdministered => "(0018,9342)",
  ContrastBolusAgentDetected => "(0018,9343)",
  ContrastBolusAgentPhase => "(0018,9344)",
  CTDIvol => "(0018,9345)",
  CTDIPhantomTypeCodeSequence => "(0018,9346)",
  CalciumScoringMassFactorPatient => "(0018,9351)",
  CalciumScoringMassFactorDevice => "(0018,9352)",
  CTAdditionalXRaySourceSequence => "(0018,9360)",
  ProjectionPixelCalibrationSequence => "(0018,9401)",
  DistanceSourceToIsocenter => "(0018,9402)",
  DistanceObjectToTableTop => "(0018,9403)",
  ObjectPixelSpacingInCenterOfBeam => "(0018,9404)",
  PositionerPositionSequence => "(0018,9405)",
  TablePositionSequence => "(0018,9406)",
  CollimatorShapeSequence => "(0018,9407)",
  XAXRFFrameCharacteristicsSequence => "(0018,9412)",
  FrameAcquisitionSequence => "(0018,9417)",
  XRayReceptorType => "(0018,9420)",
  AcquisitionProtocolName => "(0018,9423)",
  AcquisitionProtocolDescription => "(0018,9424)",
  ContrastBolusIngredientOpaque => "(0018,9425)",
  DistanceReceptorPlaneToDetectorHousing => "(0018,9426)",
  IntensifierActiveShape => "(0018,9427)",
  IntensifierActiveDimensions => "(0018,9428)",
  PhysicalDetectorSize => "(0018,9429)",
  PositionOfIsocenterProjection => "(0018,9430)",
  FieldOfViewSequence => "(0018,9432)",
  FieldOfViewDescription => "(0018,9433)",
  ExposureControlSensingRegionsSequence => "(0018,9434)",
  ExposureControlSensingRegionShape => "(0018,9435)",
  ExposureControlSensingRegionLeftVerticalEdge => "(0018,9436)",
  ExposureControlSensingRegionRightVerticalEdge => "(0018,9437)",
  ExposureControlSensingRegionUpperHorizontalEdge => "(0018,9438)",
  ExposureControlSensingRegionLowerHorizontalEdge => "(0018,9439)",
  CenterOfCircularExposureControlSensingRegion => "(0018,9440)",
  RadiusOfCircularExposureControlSensingRegion => "(0018,9441)",
  VerticesOfPolygonalExposureControlSensingRegion => "(0018,9442)",
  ColumnAngulationPatient => "(0018,9447)",
  BeamAngle => "(0018,9449)",
  FrameDetectorParametersSequence => "(0018,9451)",
  CalculatedAnatomyThickness => "(0018,9452)",
  CalibrationSequence => "(0018,9455)",
  ObjectThicknessSequence => "(0018,9456)",
  PlaneIdentification => "(0018,9457)",
  FieldOfViewDimensionsInFloat => "(0018,9461)",
  IsocenterReferenceSystemSequence => "(0018,9462)",
  PositionerIsocenterPrimaryAngle => "(0018,9463)",
  PositionerIsocenterSecondaryAngle => "(0018,9464)",
  PositionerIsocenterDetectorRotationAngle => "(0018,9465)",
  TableXPositionToIsocenter => "(0018,9466)",
  TableYPositionToIsocenter => "(0018,9467)",
  TableZPositionToIsocenter => "(0018,9468)",
  TableHorizontalRotationAngle => "(0018,9469)",
  TableHeadTiltAngle => "(0018,9470)",
  TableCradleTiltAngle => "(0018,9471)",
  FrameDisplayShutterSequence => "(0018,9472)",
  AcquiredImageAreaDoseProduct => "(0018,9473)",
  CArmPositionerTabletopRelationship => "(0018,9474)",
  XRayGeometrySequence => "(0018,9476)",
  IrradiationEventIdentificationSequence => "(0018,9477)",
  XRay3DFrameTypeSequence => "(0018,9504)",
  ContributingSourcesSequence => "(0018,9506)",
  XRay3DAcquisitionSequence => "(0018,9507)",
  PrimaryPositionerScanArc => "(0018,9508)",
  SecondaryPositionerScanArc => "(0018,9509)",
  PrimaryPositionerScanStartAngle => "(0018,9510)",
  SecondaryPositionerScanStartAngle => "(0018,9511)",
  PrimaryPositionerIncrement => "(0018,9514)",
  SecondaryPositionerIncrement => "(0018,9515)",
  StartAcquisitionDateTime => "(0018,9516)",
  EndAcquisitionDateTime => "(0018,9517)",
  ApplicationName => "(0018,9524)",
  ApplicationVersion => "(0018,9525)",
  ApplicationManufacturer => "(0018,9526)",
  AlgorithmType => "(0018,9527)",
  AlgorithmDescription => "(0018,9528)",
  XRay3DReconstructionSequence => "(0018,9530)",
  ReconstructionDescription => "(0018,9531)",
  PerProjectionAcquisitionSequence => "(0018,9538)",
  DiffusionBMatrixSequence => "(0018,9601)",
  DiffusionBMatrixValueXX => "(0018,9602)",
  DiffusionBMatrixValueXY => "(0018,9603)",
  DiffusionBMatrixValueXZ => "(0018,9604)",
  DiffusionBMatrixValueYY => "(0018,9605)",
  DiffusionBMatrixValueYZ => "(0018,9606)",
  DiffusionBMatrixValueZZ => "(0018,9607)",
  ContributingEquipmentSequence => "(0018,a001)",
  ContributionDateTime => "(0018,a002)",
  ContributionDescription => "(0018,a003)",
  StudyInstanceUID => "(0020,000d)",
  SeriesInstanceUID => "(0020,000e)",
  StudyID => "(0020,0010)",
  SeriesNumber => "(0020,0011)",
  AcquisitionNumber => "(0020,0012)",
  InstanceNumber => "(0020,0013)",
  IsotopeNumber => "(0020,0014)",
  PhaseNumber => "(0020,0015)",
  IntervalNumber => "(0020,0016)",
  TimeSlotNumber => "(0020,0017)",
  AngleNumber => "(0020,0018)",
  ItemNumber => "(0020,0019)",
  PatientOrientation => "(0020,0020)",
  OverlayNumber => "(0020,0022)",
  CurveNumber => "(0020,0024)",
  LUTNumber => "(0020,0026)",
  ImagePosition => "(0020,0030)",
  ImagePositionPatient => "(0020,0032)",
  ImageOrientation => "(0020,0035)",
  ImageOrientationPatient => "(0020,0037)",
  Location => "(0020,0050)",
  FrameOfReferenceUID => "(0020,0052)",
  Laterality => "(0020,0060)",
  ImageLaterality => "(0020,0062)",
  ImageGeometryType => "(0020,0070)",
  MaskingImage => "(0020,0080)",
  ReportNumberTrial => "(0020,00aa)",
  TemporalPositionIdentifier => "(0020,0100)",
  NumberOfTemporalPositions => "(0020,0105)",
  TemporalResolution => "(0020,0110)",
  SynchronizationFrameOfReferenceUID => "(0020,0200)",
  SeriesInStudy => "(0020,1000)",
  AcquisitionsInSeries => "(0020,1001)",
  ImagesInAcquisition => "(0020,1002)",
  ImagesInSeries => "(0020,1003)",
  AcquisitionsInStudy => "(0020,1004)",
  ImagesInStudy => "(0020,1005)",
  Reference => "(0020,1020)",
  PositionReferenceIndicator => "(0020,1040)",
  SliceLocation => "(0020,1041)",
  OtherStudyNumbers => "(0020,1070)",
  NumberOfPatientRelatedStudies => "(0020,1200)",
  NumberOfPatientRelatedSeries => "(0020,1202)",
  NumberOfPatientRelatedInstances => "(0020,1204)",
  NumberOfStudyRelatedSeries => "(0020,1206)",
  NumberOfStudyRelatedInstances => "(0020,1208)",
  NumberOfSeriesRelatedInstances => "(0020,1209)",
  ModifyingDeviceID => "(0020,3401)",
  ModifiedImageID => "(0020,3402)",
  ModifiedImageDate => "(0020,3403)",
  ModifyingDeviceManufacturer => "(0020,3404)",
  ModifiedImageTime => "(0020,3405)",
  ModifiedImageDescription => "(0020,3406)",
  ImageComments => "(0020,4000)",
  OriginalImageIdentification => "(0020,5000)",
  OriginalImageIdentificationNomenclature => "(0020,5002)",
  StackID => "(0020,9056)",
  InStackPositionNumber => "(0020,9057)",
  FrameAnatomySequence => "(0020,9071)",
  FrameLaterality => "(0020,9072)",
  FrameContentSequence => "(0020,9111)",
  PlanePositionSequence => "(0020,9113)",
  PlaneOrientationSequence => "(0020,9116)",
  TemporalPositionIndex => "(0020,9128)",
  NominalCardiacTriggerDelayTime => "(0020,9153)",
  FrameAcquisitionNumber => "(0020,9156)",
  DimensionIndexValues => "(0020,9157)",
  FrameComments => "(0020,9158)",
  ConcatenationUID => "(0020,9161)",
  InConcatenationNumber => "(0020,9162)",
  InConcatenationTotalNumber => "(0020,9163)",
  DimensionOrganizationUID => "(0020,9164)",
  DimensionIndexPointer => "(0020,9165)",
  FunctionalGroupPointer => "(0020,9167)",
  DimensionIndexPrivateCreator => "(0020,9213)",
  DimensionOrganizationSequence => "(0020,9221)",
  DimensionIndexSequence => "(0020,9222)",
  ConcatenationFrameOffsetNumber => "(0020,9228)",
  FunctionalGroupPrivateCreator => "(0020,9238)",
  NominalPercentageOfCardiacPhase => "(0020,9241)",
  NominalPercentageOfRespiratoryPhase => "(0020,9245)",
  StartingRespiratoryAmplitude => "(0020,9246)",
  StartingRespiratoryPhase => "(0020,9247)",
  EndingRespiratoryAmplitude => "(0020,9248)",
  EndingRespiratoryPhase => "(0020,9249)",
  RespiratoryTriggerType => "(0020,9250)",
  RRIntervalTimeNominal => "(0020,9251)",
  ActualCardiacTriggerDelayTime => "(0020,9252)",
  RespiratorySynchronizationSequence => "(0020,9253)",
  RespiratoryIntervalTime => "(0020,9254)",
  NominalRespiratoryTriggerDelayTime => "(0020,9255)",
  RespiratoryTriggerDelayThreshold => "(0020,9256)",
  ActualRespiratoryTriggerDelayTime => "(0020,9257)",
  DimensionDescriptionLabel => "(0020,9421)",
  PatientOrientationInFrameSequence => "(0020,9450)",
  FrameLabel => "(0020,9453)",
  AcquisitionIndex => "(0020,9518)",
  ContributingSOPInstancesReferenceSequence => "(0020,9529)",
  ReconstructionIndex => "(0020,9536)",
  LightPathFilterPassThroughWavelength => "(0022,0001)",
  LightPathFilterPassBand => "(0022,0002)",
  ImagePathFilterPassThroughWavelength => "(0022,0003)",
  ImagePathFilterPassBand => "(0022,0004)",
  PatientEyeMovementCommanded => "(0022,0005)",
  PatientEyeMovementCommandedCodeSequence => "(0022,0006)",
  SphericalLensPower => "(0022,0007)",
  CylinderLensPower => "(0022,0008)",
  CylinderAxis => "(0022,0009)",
  EmmetropicMagnification => "(0022,000a)",
  IntraOcularPressure => "(0022,000b)",
  HorizontalFieldOfView => "(0022,000c)",
  PupilDilated => "(0022,000d)",
  DegreeOfDilation => "(0022,000e)",
  StereoBaselineAngle => "(0022,0010)",
  StereoBaselineDisplacement => "(0022,0011)",
  StereoHorizontalPixelOffset => "(0022,0012)",
  StereoVerticalPixelOffset => "(0022,0013)",
  StereoRotation => "(0022,0014)",
  AcquisitionDeviceTypeCodeSequence => "(0022,0015)",
  IlluminationTypeCodeSequence => "(0022,0016)",
  LightPathFilterTypeStackCodeSequence => "(0022,0017)",
  ImagePathFilterTypeStackCodeSequence => "(0022,0018)",
  LensesCodeSequence => "(0022,0019)",
  ChannelDescriptionCodeSequence => "(0022,001a)",
  RefractiveStateSequence => "(0022,001b)",
  MydriaticAgentCodeSequence => "(0022,001c)",
  RelativeImagePositionCodeSequence => "(0022,001d)",
  StereoPairsSequence => "(0022,0020)",
  LeftImageSequence => "(0022,0021)",
  RightImageSequence => "(0022,0022)",
  AxialLengthOfEye => "(0022,0030)",
  OphthalmicFrameLocationSequence => "(0022,0031)",
  ReferenceCoordinates => "(0022,0032)",
  DepthSpatialResolution => "(0022,0035)",
  MaximumDepthDistortion => "(0022,0036)",
  AlongScanSpatialResolution => "(0022,0037)",
  MaximumAlongScanDistortion => "(0022,0038)",
  OphthalmicImageOrientation => "(0022,0039)",
  DepthOfTransverseImage => "(0022,0041)",
  MydriaticAgentConcentrationUnitsSequence => "(0022,0042)",
  AcrossScanSpatialResolution => "(0022,0048)",
  MaximumAcrossScanDistortion => "(0022,0049)",
  MydriaticAgentConcentration => "(0022,004e)",
  IlluminationWaveLength => "(0022,0055)",
  IlluminationPower => "(0022,0056)",
  IlluminationBandwidth => "(0022,0057)",
  MydriaticAgentSequence => "(0022,0058)",
  SamplesPerPixel => "(0028,0002)",
  SamplesPerPixelUsed => "(0028,0003)",
  PhotometricInterpretation => "(0028,0004)",
  ImageDimensions => "(0028,0005)",
  PlanarConfiguration => "(0028,0006)",
  NumberOfFrames => "(0028,0008)",
  FrameIncrementPointer => "(0028,0009)",
  FrameDimensionPointer => "(0028,000a)",
  Rows => "(0028,0010)",
  Columns => "(0028,0011)",
  Planes => "(0028,0012)",
  UltrasoundColorDataPresent => "(0028,0014)",
  PixelSpacing => "(0028,0030)",
  ZoomFactor => "(0028,0031)",
  ZoomCenter => "(0028,0032)",
  PixelAspectRatio => "(0028,0034)",
  ImageFormat => "(0028,0040)",
  ManipulatedImage => "(0028,0050)",
  CorrectedImage => "(0028,0051)",
  CompressionRecognitionCode => "(0028,005f)",
  CompressionCode => "(0028,0060)",
  CompressionOriginator => "(0028,0061)",
  CompressionLabel => "(0028,0062)",
  CompressionDescription => "(0028,0063)",
  CompressionSequence => "(0028,0065)",
  CompressionStepPointers => "(0028,0066)",
  RepeatInterval => "(0028,0068)",
  BitsGrouped => "(0028,0069)",
  PerimeterTable => "(0028,0070)",
  PerimeterValue => "(0028,0071)",
  PredictorRows => "(0028,0080)",
  PredictorColumns => "(0028,0081)",
  PredictorConstants => "(0028,0082)",
  BlockedPixels => "(0028,0090)",
  BlockRows => "(0028,0091)",
  BlockColumns => "(0028,0092)",
  RowOverlap => "(0028,0093)",
  ColumnOverlap => "(0028,0094)",
  BitsAllocated => "(0028,0100)",
  BitsStored => "(0028,0101)",
  HighBit => "(0028,0102)",
  PixelRepresentation => "(0028,0103)",
  SmallestValidPixelValue => "(0028,0104)",
  LargestValidPixelValue => "(0028,0105)",
  SmallestImagePixelValue => "(0028,0106)",
  LargestImagePixelValue => "(0028,0107)",
  SmallestPixelValueInSeries => "(0028,0108)",
  LargestPixelValueInSeries => "(0028,0109)",
  SmallestPixelValueInPlane => "(0028,0110)",
  LargestPixelValueInPlane => "(0028,0111)",
  PixelPaddingValue => "(0028,0120)",
  PixelPaddingRangeLimit => "(0028,0121)",
  ImageLocation => "(0028,0200)",
  QualityControlImage => "(0028,0300)",
  BurnedInAnnotation => "(0028,0301)",
  TransformLabel => "(0028,0400)",
  TransformVersionNumber => "(0028,0401)",
  SequenceOfCompressedData => "(0028,0403)",
  DCTLabel => "(0028,0700)",
  DataBlockDescription => "(0028,0701)",
  DataBlock => "(0028,0702)",
  NormalizationFactorFormat => "(0028,0710)",
  ZonalMapNumberFormat => "(0028,0720)",
  ZonalMapLocation => "(0028,0721)",
  ZonalMapFormat => "(0028,0722)",
  AdaptiveMapFormat => "(0028,0730)",
  CodeNumberFormat => "(0028,0740)",
  PixelSpacingCalibrationType => "(0028,0a02)",
  PixelSpacingCalibrationDescription => "(0028,0a04)",
  PixelIntensityRelationship => "(0028,1040)",
  PixelIntensityRelationshipSign => "(0028,1041)",
  WindowCenter => "(0028,1050)",
  WindowWidth => "(0028,1051)",
  RescaleIntercept => "(0028,1052)",
  RescaleSlope => "(0028,1053)",
  RescaleType => "(0028,1054)",
  WindowCenterWidthExplanation => "(0028,1055)",
  VOILUTFunction => "(0028,1056)",
  GrayScale => "(0028,1080)",
  RecommendedViewingMode => "(0028,1090)",
  GrayLookupTableDescriptor => "(0028,1100)",
  RedPaletteColorLookupTableDescriptor => "(0028,1101)",
  GreenPaletteColorLookupTableDescriptor => "(0028,1102)",
  BluePaletteColorLookupTableDescriptor => "(0028,1103)",
  LargeRedPaletteColorLookupTableDescriptor => "(0028,1111)",
  LargeGreenPaletteColorLookupTableDescriptor => "(0028,1112)",
  LargeBluePaletteColorLookupTableDescriptor => "(0028,1113)",
  PaletteColorLookupTableUID => "(0028,1199)",
  GrayLookupTableData => "(0028,1200)",
  RedPaletteColorLookupTableData => "(0028,1201)",
  GreenPaletteColorLookupTableData => "(0028,1202)",
  BluePaletteColorLookupTableData => "(0028,1203)",
  LargeRedPaletteColorLookupTableData => "(0028,1211)",
  LargeGreenPaletteColorLookupTableData => "(0028,1212)",
  LargeBluePaletteColorLookupTableData => "(0028,1213)",
  LargePaletteColorLookupTableUID => "(0028,1214)",
  SegmentedRedPaletteColorLookupTableData => "(0028,1221)",
  SegmentedGreenPaletteColorLookupTableData => "(0028,1222)",
  SegmentedBluePaletteColorLookupTableData => "(0028,1223)",
  ImplantPresent => "(0028,1300)",
  PartialView => "(0028,1350)",
  PartialViewDescription => "(0028,1351)",
  PartialViewCodeSequence => "(0028,1352)",
  SpatialLocationsPreserved => "(0028,135a)",
  ICCProfile => "(0028,2000)",
  LossyImageCompression => "(0028,2110)",
  LossyImageCompressionRatio => "(0028,2112)",
  LossyImageCompressionMethod => "(0028,2114)",
  ModalityLUTSequence => "(0028,3000)",
  LUTDescriptor => "(0028,3002)",
  LUTExplanation => "(0028,3003)",
  ModalityLUTType => "(0028,3004)",
  LUTData => "(0028,3006)",
  VOILUTSequence => "(0028,3010)",
  SoftcopyVOILUTSequence => "(0028,3110)",
  ImagePresentationComments => "(0028,4000)",
  BiplaneAcquisitionSequence => "(0028,5000)",
  RepresentativeFrameNumber => "(0028,6010)",
  FrameNumbersOfInterest => "(0028,6020)",
  FrameOfInterestDescription => "(0028,6022)",
  FrameOfInterestType => "(0028,6023)",
  MaskPointer => "(0028,6030)",
  RWavePointer => "(0028,6040)",
  MaskSubtractionSequence => "(0028,6100)",
  MaskOperation => "(0028,6101)",
  ApplicableFrameRange => "(0028,6102)",
  MaskFrameNumbers => "(0028,6110)",
  ContrastFrameAveraging => "(0028,6112)",
  MaskSubPixelShift => "(0028,6114)",
  TIDOffset => "(0028,6120)",
  MaskOperationExplanation => "(0028,6190)",
  PixelDataProviderURL => "(0028,7fe0)",
  DataPointRows => "(0028,9001)",
  DataPointColumns => "(0028,9002)",
  SignalDomainColumns => "(0028,9003)",
  LargestMonochromePixelValue => "(0028,9099)",
  DataRepresentation => "(0028,9108)",
  PixelMeasuresSequence => "(0028,9110)",
  FrameVOILUTSequence => "(0028,9132)",
  PixelValueTransformationSequence => "(0028,9145)",
  SignalDomainRows => "(0028,9235)",
  DisplayFilterPercentage => "(0028,9411)",
  FramePixelShiftSequence => "(0028,9415)",
  SubtractionItemID => "(0028,9416)",
  PixelIntensityRelationshipLUTSequence => "(0028,9422)",
  FramePixelDataPropertiesSequence => "(0028,9443)",
  GeometricalProperties => "(0028,9444)",
  GeometricMaximumDistortion => "(0028,9445)",
  ImageProcessingApplied => "(0028,9446)",
  MaskSelectionMode => "(0028,9454)",
  LUTFunction => "(0028,9474)",
  MaskVisibilityPercentage => "(0028,9478)",
  ImageToEquipmentMappingMatrix => "(0028,9520)",
  EquipmentCoordinateSystemIdentification => "(0028,9537)",
  StudyStatusID => "(0032,000a)",
  StudyPriorityID => "(0032,000c)",
  StudyIDIssuer => "(0032,0012)",
  StudyVerifiedDate => "(0032,0032)",
  StudyVerifiedTime => "(0032,0033)",
  StudyReadDate => "(0032,0034)",
  StudyReadTime => "(0032,0035)",
  ScheduledStudyStartDate => "(0032,1000)",
  ScheduledStudyStartTime => "(0032,1001)",
  ScheduledStudyStopDate => "(0032,1010)",
  ScheduledStudyStopTime => "(0032,1011)",
  ScheduledStudyLocation => "(0032,1020)",
  ScheduledStudyLocationAETitle => "(0032,1021)",
  ReasonForStudy => "(0032,1030)",
  RequestingPhysicianIdentificationSequence => "(0032,1031)",
  RequestingPhysician => "(0032,1032)",
  RequestingService => "(0032,1033)",
  StudyArrivalDate => "(0032,1040)",
  StudyArrivalTime => "(0032,1041)",
  StudyCompletionDate => "(0032,1050)",
  StudyCompletionTime => "(0032,1051)",
  StudyComponentStatusID => "(0032,1055)",
  RequestedProcedureDescription => "(0032,1060)",
  RequestedProcedureCodeSequence => "(0032,1064)",
  RequestedContrastAgent => "(0032,1070)",
  StudyComments => "(0032,4000)",
  ReferencedPatientAliasSequence => "(0038,0004)",
  VisitStatusID => "(0038,0008)",
  AdmissionID => "(0038,0010)",
  IssuerOfAdmissionID => "(0038,0011)",
  IssuerOfAdmissionIDSequence => "(0038,0014)",
  RouteOfAdmissions => "(0038,0016)",
  ScheduledAdmissionDate => "(0038,001a)",
  ScheduledAdmissionTime => "(0038,001b)",
  ScheduledDischargeDate => "(0038,001c)",
  ScheduledDischargeTime => "(0038,001d)",
  ScheduledPatientInstitutionResidence => "(0038,001e)",
  AdmittingDate => "(0038,0020)",
  AdmittingTime => "(0038,0021)",
  DischargeDate => "(0038,0030)",
  DischargeTime => "(0038,0032)",
  DischargeDiagnosisDescription => "(0038,0040)",
  DischargeDiagnosisCodeSequence => "(0038,0044)",
  SpecialNeeds => "(0038,0050)",
  ServiceEpisodeID => "(0038,0060)",
  IssuerOfServiceEpisodeID => "(0038,0061)",
  ServiceEpisodeDescription => "(0038,0062)",
  IssuerOfServiceEpisodeIDSequence => "(0038,0064)",
  PertinentDocumentsSequence => "(0038,0100)",
  CurrentPatientLocation => "(0038,0300)",
  PatientInstitutionResidence => "(0038,0400)",
  PatientState => "(0038,0500)",
  PatientClinicalTrialParticipationSequence => "(0038,0502)",
  VisitComments => "(0038,4000)",
  WaveformOriginality => "(003a,0004)",
  NumberOfWaveformChannels => "(003a,0005)",
  NumberOfWaveformSamples => "(003a,0010)",
  SamplingFrequency => "(003a,001a)",
  MultiplexGroupLabel => "(003a,0020)",
  ChannelDefinitionSequence => "(003a,0200)",
  WaveformChannelNumber => "(003a,0202)",
  ChannelLabel => "(003a,0203)",
  ChannelStatus => "(003a,0205)",
  ChannelSourceSequence => "(003a,0208)",
  ChannelSourceModifiersSequence => "(003a,0209)",
  SourceWaveformSequence => "(003a,020a)",
  ChannelDerivationDescription => "(003a,020c)",
  ChannelSensitivity => "(003a,0210)",
  ChannelSensitivityUnitsSequence => "(003a,0211)",
  ChannelSensitivityCorrectionFactor => "(003a,0212)",
  ChannelBaseline => "(003a,0213)",
  ChannelTimeSkew => "(003a,0214)",
  ChannelSampleSkew => "(003a,0215)",
  ChannelOffset => "(003a,0218)",
  WaveformBitsStored => "(003a,021a)",
  FilterLowFrequency => "(003a,0220)",
  FilterHighFrequency => "(003a,0221)",
  NotchFilterFrequency => "(003a,0222)",
  NotchFilterBandwidth => "(003a,0223)",
  WaveformDataDisplayScale => "(003a,0230)",
  WaveformDisplayBackgroundCIELabValue => "(003a,0231)",
  WaveformPresentationGroupSequence => "(003a,0240)",
  PresentationGroupNumber => "(003a,0241)",
  ChannelDisplaySequence => "(003a,0242)",
  ChannelRecommendedDisplayCIELabValue => "(003a,0244)",
  ChannelPosition => "(003a,0245)",
  DisplayShadingFlag => "(003a,0246)",
  FractionalChannelDisplayScale => "(003a,0247)",
  AbsoluteChannelDisplayScale => "(003a,0248)",
  MultiplexedAudioChannelsDescriptionCodeSequence => "(003a,0300)",
  ChannelIdentificationCode => "(003a,0301)",
  ChannelMode => "(003a,0302)",
  ScheduledStationAETitle => "(0040,0001)",
  ScheduledProcedureStepStartDate => "(0040,0002)",
  ScheduledProcedureStepStartTime => "(0040,0003)",
  ScheduledProcedureStepEndDate => "(0040,0004)",
  ScheduledProcedureStepEndTime => "(0040,0005)",
  ScheduledPerformingPhysicianName => "(0040,0006)",
  ScheduledProcedureStepDescription => "(0040,0007)",
  ScheduledProtocolCodeSequence => "(0040,0008)",
  ScheduledProcedureStepID => "(0040,0009)",
  StageCodeSequence => "(0040,000a)",
  ScheduledPerformingPhysicianIdentificationSequence => "(0040,000b)",
  ScheduledStationName => "(0040,0010)",
  ScheduledProcedureStepLocation => "(0040,0011)",
  PreMedication => "(0040,0012)",
  ScheduledProcedureStepStatus => "(0040,0020)",
  OrderPlacerIdentifierSequence => "(0040,0026)",
  OrderFillerIdentifierSequence => "(0040,0027)",
  LocalNamespaceEntityID => "(0040,0031)",
  UniversalEntityID => "(0040,0032)",
  UniversalEntityIDType => "(0040,0033)",
  IdentifierTypeCode => "(0040,0035)",
  AssigningFacilitySequence => "(0040,0036)",
  AssigningJurisdictionCodeSequence => "(0040,0039)",
  AssigningAgencyOrDepartmentCodeSequence => "(0040,003a)",
  ScheduledProcedureStepSequence => "(0040,0100)",
  ReferencedNonImageCompositeSOPInstanceSequence => "(0040,0220)",
  PerformedStationAETitle => "(0040,0241)",
  PerformedStationName => "(0040,0242)",
  PerformedLocation => "(0040,0243)",
  PerformedProcedureStepStartDate => "(0040,0244)",
  PerformedProcedureStepStartTime => "(0040,0245)",
  PerformedProcedureStepEndDate => "(0040,0250)",
  PerformedProcedureStepEndTime => "(0040,0251)",
  PerformedProcedureStepStatus => "(0040,0252)",
  PerformedProcedureStepID => "(0040,0253)",
  PerformedProcedureStepDescription => "(0040,0254)",
  PerformedProcedureTypeDescription => "(0040,0255)",
  PerformedProtocolCodeSequence => "(0040,0260)",
  ScheduledStepAttributesSequence => "(0040,0270)",
  RequestAttributesSequence => "(0040,0275)",
  CommentsOnPerformedProcedureStep => "(0040,0280)",
  PerformedProcedureStepDiscontinuationReasonCodeSequence => "(0040,0281)",
  QuantitySequence => "(0040,0293)",
  Quantity => "(0040,0294)",
  MeasuringUnitsSequence => "(0040,0295)",
  BillingItemSequence => "(0040,0296)",
  TotalTimeOfFluoroscopy => "(0040,0300)",
  TotalNumberOfExposures => "(0040,0301)",
  EntranceDose => "(0040,0302)",
  ExposedArea => "(0040,0303)",
  DistanceSourceToEntrance => "(0040,0306)",
  DistanceSourceToSupport => "(0040,0307)",
  ExposureDoseSequence => "(0040,030e)",
  CommentsOnRadiationDose => "(0040,0310)",
  XRayOutput => "(0040,0312)",
  HalfValueLayer => "(0040,0314)",
  OrganDose => "(0040,0316)",
  OrganExposed => "(0040,0318)",
  BillingProcedureStepSequence => "(0040,0320)",
  FilmConsumptionSequence => "(0040,0321)",
  BillingSuppliesAndDevicesSequence => "(0040,0324)",
  ReferencedProcedureStepSequence => "(0040,0330)",
  PerformedSeriesSequence => "(0040,0340)",
  CommentsOnScheduledProcedureStep => "(0040,0400)",
  ProtocolContextSequence => "(0040,0440)",
  ContentItemModifierSequence => "(0040,0441)",
  SpecimenAccessionNumber => "(0040,050a)",
  SpecimenSequence => "(0040,0550)",
  SpecimenIdentifier => "(0040,0551)",
  SpecimenDescriptionSequenceTrial => "(0040,0552)",
  SpecimenDescriptionTrial => "(0040,0553)",
  AcquisitionContextSequence => "(0040,0555)",
  AcquisitionContextDescription => "(0040,0556)",
  SpecimenTypeCodeSequence => "(0040,059a)",
  SlideIdentifier => "(0040,06fa)",
  ImageCenterPointCoordinatesSequence => "(0040,071a)",
  XOffsetInSlideCoordinateSystem => "(0040,072a)",
  YOffsetInSlideCoordinateSystem => "(0040,073a)",
  ZOffsetInSlideCoordinateSystem => "(0040,074a)",
  PixelSpacingSequence => "(0040,08d8)",
  CoordinateSystemAxisCodeSequence => "(0040,08da)",
  MeasurementUnitsCodeSequence => "(0040,08ea)",
  VitalStainCodeSequenceTrial => "(0040,09f8)",
  RequestedProcedureID => "(0040,1001)",
  ReasonForRequestedProcedure => "(0040,1002)",
  RequestedProcedurePriority => "(0040,1003)",
  PatientTransportArrangements => "(0040,1004)",
  RequestedProcedureLocation => "(0040,1005)",
  PlacerOrderNumberOfProcedure => "(0040,1006)",
  FillerOrderNumberOfProcedure => "(0040,1007)",
  ConfidentialityCode => "(0040,1008)",
  ReportingPriority => "(0040,1009)",
  ReasonForRequestedProcedureCodeSequence => "(0040,100a)",
  NamesOfIntendedRecipientsOfResults => "(0040,1010)",
  IntendedRecipientsOfResultsIdentificationSequence => "(0040,1011)",
  PersonIdentificationCodeSequence => "(0040,1101)",
  PersonAddress => "(0040,1102)",
  PersonTelephoneNumbers => "(0040,1103)",
  RequestedProcedureComments => "(0040,1400)",
  ReasonForImagingServiceRequest => "(0040,2001)",
  IssueDateOfImagingServiceRequest => "(0040,2004)",
  IssueTimeOfImagingServiceRequest => "(0040,2005)",
  PlacerOrderNumberOfImagingServiceRequestRetired => "(0040,2006)",
  FillerOrderNumberOfImagingServiceRequestRetired => "(0040,2007)",
  OrderEnteredBy => "(0040,2008)",
  OrderEntererLocation => "(0040,2009)",
  OrderCallbackPhoneNumber => "(0040,2010)",
  PlacerOrderNumberOfImagingServiceRequest => "(0040,2016)",
  FillerOrderNumberOfImagingServiceRequest => "(0040,2017)",
  ImagingServiceRequestComments => "(0040,2400)",
  ConfidentialityConstraintOnPatientDataDescription => "(0040,3001)",
  GeneralPurposeScheduledProcedureStepStatus => "(0040,4001)",
  GeneralPurposePerformedProcedureStepStatus => "(0040,4002)",
  GeneralPurposeScheduledProcedureStepPriority => "(0040,4003)",
  ScheduledProcessingApplicationsCodeSequence => "(0040,4004)",
  ScheduledProcedureStepStartDateAndTime => "(0040,4005)",
  MultipleCopiesFlag => "(0040,4006)",
  PerformedProcessingApplicationsCodeSequence => "(0040,4007)",
  HumanPerformerCodeSequence => "(0040,4009)",
  ScheduledProcedureStepModificationDateAndTime => "(0040,4010)",
  ExpectedCompletionDateAndTime => "(0040,4011)",
  ResultingGeneralPurposePerformedProcedureStepsSequence => "(0040,4015)",
  ReferencedGeneralPurposeScheduledProcedureStepSequence => "(0040,4016)",
  ScheduledWorkitemCodeSequence => "(0040,4018)",
  PerformedWorkitemCodeSequence => "(0040,4019)",
  InputAvailabilityFlag => "(0040,4020)",
  InputInformationSequence => "(0040,4021)",
  RelevantInformationSequence => "(0040,4022)",
  ReferencedGeneralPurposeScheduledProcedureStepTransactionUID => "(0040,4023)",
  ScheduledStationNameCodeSequence => "(0040,4025)",
  ScheduledStationClassCodeSequence => "(0040,4026)",
  ScheduledStationGeographicLocationCodeSequence => "(0040,4027)",
  PerformedStationNameCodeSequence => "(0040,4028)",
  PerformedStationClassCodeSequence => "(0040,4029)",
  PerformedStationGeographicLocationCodeSequence => "(0040,4030)",
  RequestedSubsequentWorkitemCodeSequence => "(0040,4031)",
  NonDICOMOutputCodeSequence => "(0040,4032)",
  OutputInformationSequence => "(0040,4033)",
  ScheduledHumanPerformersSequence => "(0040,4034)",
  ActualHumanPerformersSequence => "(0040,4035)",
  HumanPerformersOrganization => "(0040,4036)",
  HumanPerformersName => "(0040,4037)",
  EntranceDoseInmGy => "(0040,8302)",
  ReferencedImageRealWorldValueMappingSequence => "(0040,9094)",
  RealWorldValueMappingSequence => "(0040,9096)",
  PixelValueMappingCodeSequence => "(0040,9098)",
  LUTLabel => "(0040,9210)",
  RealWorldValueLastValueMapped => "(0040,9211)",
  RealWorldValueLUTData => "(0040,9212)",
  RealWorldValueFirstValueMapped => "(0040,9216)",
  RealWorldValueIntercept => "(0040,9224)",
  RealWorldValueSlope => "(0040,9225)",
  FindingsFlagTrial => "(0040,a007)",
  RelationshipType => "(0040,a010)",
  FindingsSequenceTrial => "(0040,a020)",
  FindingsGroupUIDTrial => "(0040,a021)",
  ReferencedFindingsGroupUIDTrial => "(0040,a022)",
  FindingsGroupRecordingDateTrial => "(0040,a023)",
  FindingsGroupRecordingTimeTrial => "(0040,a024)",
  FindingsSourceCategoryCodeSequenceTrial => "(0040,a026)",
  VerifyingOrganization => "(0040,a027)",
  DocumentingOrganizationIdentifierCodeSequenceTrial => "(0040,a028)",
  VerificationDateTime => "(0040,a030)",
  ObservationDateTime => "(0040,a032)",
  ValueType => "(0040,a040)",
  ConceptNameCodeSequence => "(0040,a043)",
  MeasurementPrecisionDescriptionTrial => "(0040,a047)",
  ContinuityOfContent => "(0040,a050)",
  UrgencyOrPriorityAlertsTrial => "(0040,a057)",
  SequencingIndicatorTrial => "(0040,a060)",
  DocumentIdentifierCodeSequenceTrial => "(0040,a066)",
  DocumentAuthorTrial => "(0040,a067)",
  DocumentAuthorIdentifierCodeSequenceTrial => "(0040,a068)",
  IdentifierCodeSequenceTrial => "(0040,a070)",
  VerifyingObserverSequence => "(0040,a073)",
  ObjectBinaryIdentifierTrial => "(0040,a074)",
  VerifyingObserverName => "(0040,a075)",
  DocumentingObserverIdentifierCodeSequenceTrial => "(0040,a076)",
  AuthorObserverSequence => "(0040,a078)",
  ParticipantSequence => "(0040,a07a)",
  CustodialOrganizationSequence => "(0040,a07c)",
  ParticipationType => "(0040,a080)",
  ParticipationDateTime => "(0040,a082)",
  ObserverType => "(0040,a084)",
  ProcedureIdentifierCodeSequenceTrial => "(0040,a085)",
  VerifyingObserverIdentificationCodeSequence => "(0040,a088)",
  ObjectDirectoryBinaryIdentifierTrial => "(0040,a089)",
  EquivalentCDADocumentSequence => "(0040,a090)",
  ReferencedWaveformChannels => "(0040,a0b0)",
  DateOfDocumentOrVerbalTransactionTrial => "(0040,a110)",
  TimeOfDocumentCreationOrVerbalTransactionTrial => "(0040,a112)",
  DateTime => "(0040,a120)",
  Date => "(0040,a121)",
  Time => "(0040,a122)",
  PersonName => "(0040,a123)",
  UID => "(0040,a124)",
  ReportStatusIDTrial => "(0040,a125)",
  TemporalRangeType => "(0040,a130)",
  ReferencedSamplePositions => "(0040,a132)",
  ReferencedFrameNumbers => "(0040,a136)",
  ReferencedTimeOffsets => "(0040,a138)",
  ReferencedDateTime => "(0040,a13a)",
  TextValue => "(0040,a160)",
  ObservationCategoryCodeSequenceTrial => "(0040,a167)",
  ConceptCodeSequence => "(0040,a168)",
  BibliographicCitationTrial => "(0040,a16a)",
  PurposeOfReferenceCodeSequence => "(0040,a170)",
  ObservationUIDTrial => "(0040,a171)",
  ReferencedObservationUIDTrial => "(0040,a172)",
  ReferencedObservationClassTrial => "(0040,a173)",
  ReferencedObjectObservationClassTrial => "(0040,a174)",
  AnnotationGroupNumber => "(0040,a180)",
  ObservationDateTrial => "(0040,a192)",
  ObservationTimeTrial => "(0040,a193)",
  MeasurementAutomationTrial => "(0040,a194)",
  ModifierCodeSequence => "(0040,a195)",
  IdentificationDescriptionTrial => "(0040,a224)",
  CoordinatesSetGeometricTypeTrial => "(0040,a290)",
  AlgorithmCodeSequenceTrial => "(0040,a296)",
  AlgorithmDescriptionTrial => "(0040,a297)",
  PixelCoordinatesSetTrial => "(0040,a29a)",
  MeasuredValueSequence => "(0040,a300)",
  NumericValueQualifierCodeSequence => "(0040,a301)",
  CurrentObserverTrial => "(0040,a307)",
  NumericValue => "(0040,a30a)",
  ReferencedAccessionSequenceTrial => "(0040,a313)",
  ReportStatusCommentTrial => "(0040,a33a)",
  ProcedureContextSequenceTrial => "(0040,a340)",
  VerbalSourceTrial => "(0040,a352)",
  AddressTrial => "(0040,a353)",
  TelephoneNumberTrial => "(0040,a354)",
  VerbalSourceIdentifierCodeSequenceTrial => "(0040,a358)",
  PredecessorDocumentsSequence => "(0040,a360)",
  ReferencedRequestSequence => "(0040,a370)",
  PerformedProcedureCodeSequence => "(0040,a372)",
  CurrentRequestedProcedureEvidenceSequence => "(0040,a375)",
  ReportDetailSequenceTrial => "(0040,a380)",
  PertinentOtherEvidenceSequence => "(0040,a385)",
  HL7StructuredDocumentReferenceSequence => "(0040,a390)",
  ObservationSubjectUIDTrial => "(0040,a402)",
  ObservationSubjectClassTrial => "(0040,a403)",
  ObservationSubjectTypeCodeSequenceTrial => "(0040,a404)",
  CompletionFlag => "(0040,a491)",
  CompletionFlagDescription => "(0040,a492)",
  VerificationFlag => "(0040,a493)",
  ArchiveRequested => "(0040,a494)",
  ContentTemplateSequence => "(0040,a504)",
  IdenticalDocumentsSequence => "(0040,a525)",
  ObservationSubjectContextFlagTrial => "(0040,a600)",
  ObserverContextFlagTrial => "(0040,a601)",
  ProcedureContextFlagTrial => "(0040,a603)",
  ContentSequence => "(0040,a730)",
  RelationshipSequenceTrial => "(0040,a731)",
  RelationshipTypeCodeSequenceTrial => "(0040,a732)",
  LanguageCodeSequenceTrial => "(0040,a744)",
  UniformResourceLocatorTrial => "(0040,a992)",
  AnnotationSequence => "(0040,b020)",
  TemplateIdentifier => "(0040,db00)",
  TemplateVersion => "(0040,db06)",
  TemplateLocalVersion => "(0040,db07)",
  TemplateExtensionFlag => "(0040,db0b)",
  TemplateExtensionOrganizationUID => "(0040,db0c)",
  TemplateExtensionCreatorUID => "(0040,db0d)",
  RelationshipTypeCodeSequenceModifierTrial => "(0040,db73)",
  ReferencedContentItemIdentifier => "(0040,db73)",
  HL7InstanceIdentifier => "(0040,e001)",
  HL7DocumentEffectiveTime => "(0040,e004)",
  HL7DocumentTypeCodeSequence => "(0040,e006)",
  RetrieveURI => "(0040,e010)",
  DocumentTitle => "(0042,0010)",
  EncapsulatedDocument => "(0042,0011)",
  MIMETypeOfEncapsulatedDocument => "(0042,0012)",
  SourceInstanceSequence => "(0042,0013)",
  ListOfMIMETypes => "(0042,0014)",
  ProductPackageIdentifier => "(0044,0001)",
  SubstanceAdministrationApproval => "(0044,0002)",
  ApprovalStatusFurtherDescription => "(0044,0003)",
  ApprovalStatusDateTime => "(0044,0004)",
  ProductTypeCodeSequence => "(0044,0007)",
  ProductName => "(0044,0008)",
  ProductDescription => "(0044,0009)",
  ProductLotIdentifier => "(0044,000a)",
  ProductExpirationDateTime => "(0044,000b)",
  SubstanceAdministrationDateTime => "(0044,0010)",
  SubstanceAdministrationNotes => "(0044,0011)",
  SubstanceAdministrationDeviceID => "(0044,0012)",
  ProductParameterSequence => "(0044,0013)",
  SubstanceAdministrationParameterSequence => "(0044,0019)",
  CalibrationImage => "(0050,0004)",
  DeviceSequence => "(0050,0010)",
  DeviceLength => "(0050,0014)",
  DeviceDiameter => "(0050,0016)",
  DeviceDiameterUnits => "(0050,0017)",
  DeviceVolume => "(0050,0018)",
  InterMarkerDistance => "(0050,0019)",
  DeviceDescription => "(0050,0020)",
  EnergyWindowVector => "(0054,0010)",
  NumberOfEnergyWindows => "(0054,0011)",
  EnergyWindowInformationSequence => "(0054,0012)",
  EnergyWindowRangeSequence => "(0054,0013)",
  EnergyWindowLowerLimit => "(0054,0014)",
  EnergyWindowUpperLimit => "(0054,0015)",
  RadiopharmaceuticalInformationSequence => "(0054,0016)",
  ResidualSyringeCounts => "(0054,0017)",
  EnergyWindowName => "(0054,0018)",
  DetectorVector => "(0054,0020)",
  NumberOfDetectors => "(0054,0021)",
  DetectorInformationSequence => "(0054,0022)",
  PhaseVector => "(0054,0030)",
  NumberOfPhases => "(0054,0031)",
  PhaseInformationSequence => "(0054,0032)",
  NumberOfFramesInPhase => "(0054,0033)",
  PhaseDelay => "(0054,0036)",
  PauseBetweenFrames => "(0054,0038)",
  PhaseDescription => "(0054,0039)",
  RotationVector => "(0054,0050)",
  NumberOfRotations => "(0054,0051)",
  RotationInformationSequence => "(0054,0052)",
  NumberOfFramesInRotation => "(0054,0053)",
  RRIntervalVector => "(0054,0060)",
  NumberOfRRIntervals => "(0054,0061)",
  GatedInformationSequence => "(0054,0062)",
  DataInformationSequence => "(0054,0063)",
  TimeSlotVector => "(0054,0070)",
  NumberOfTimeSlots => "(0054,0071)",
  TimeSlotInformationSequence => "(0054,0072)",
  TimeSlotTime => "(0054,0073)",
  SliceVector => "(0054,0080)",
  NumberOfSlices => "(0054,0081)",
  AngularViewVector => "(0054,0090)",
  TimeSliceVector => "(0054,0100)",
  NumberOfTimeSlices => "(0054,0101)",
  StartAngle => "(0054,0200)",
  TypeOfDetectorMotion => "(0054,0202)",
  TriggerVector => "(0054,0210)",
  NumberOfTriggersInPhase => "(0054,0211)",
  ViewCodeSequence => "(0054,0220)",
  ViewModifierCodeSequence => "(0054,0222)",
  RadionuclideCodeSequence => "(0054,0300)",
  AdministrationRouteCodeSequence => "(0054,0302)",
  RadiopharmaceuticalCodeSequence => "(0054,0304)",
  CalibrationDataSequence => "(0054,0306)",
  EnergyWindowNumber => "(0054,0308)",
  ImageID => "(0054,0400)",
  PatientOrientationCodeSequence => "(0054,0410)",
  PatientOrientationModifierCodeSequence => "(0054,0412)",
  PatientGantryRelationshipCodeSequence => "(0054,0414)",
  SliceProgressionDirection => "(0054,0500)",
  SeriesType => "(0054,1000)",
  Units => "(0054,1001)",
  CountsSource => "(0054,1002)",
  ReprojectionMethod => "(0054,1004)",
  RandomsCorrectionMethod => "(0054,1100)",
  AttenuationCorrectionMethod => "(0054,1101)",
  DecayCorrection => "(0054,1102)",
  ReconstructionMethod => "(0054,1103)",
  DetectorLinesOfResponseUsed => "(0054,1104)",
  ScatterCorrectionMethod => "(0054,1105)",
  AxialAcceptance => "(0054,1200)",
  AxialMash => "(0054,1201)",
  TransverseMash => "(0054,1202)",
  DetectorElementSize => "(0054,1203)",
  CoincidenceWindowWidth => "(0054,1210)",
  SecondaryCountsType => "(0054,1220)",
  FrameReferenceTime => "(0054,1300)",
  PrimaryPromptsCountsAccumulated => "(0054,1310)",
  SecondaryCountsAccumulated => "(0054,1311)",
  SliceSensitivityFactor => "(0054,1320)",
  DecayFactor => "(0054,1321)",
  DoseCalibrationFactor => "(0054,1322)",
  ScatterFractionFactor => "(0054,1323)",
  DeadTimeFactor => "(0054,1324)",
  ImageIndex => "(0054,1330)",
  CountsIncluded => "(0054,1400)",
  DeadTimeCorrectionFlag => "(0054,1401)",
  HistogramSequence => "(0060,3000)",
  HistogramNumberOfBins => "(0060,3002)",
  HistogramFirstBinValue => "(0060,3004)",
  HistogramLastBinValue => "(0060,3006)",
  HistogramBinWidth => "(0060,3008)",
  HistogramExplanation => "(0060,3010)",
  HistogramData => "(0060,3020)",
  SegmentationType => "(0062,0001)",
  SegmentSequence => "(0062,0002)",
  SegmentedPropertyCategoryCodeSequence => "(0062,0003)",
  SegmentNumber => "(0062,0004)",
  SegmentLabel => "(0062,0005)",
  SegmentDescription => "(0062,0006)",
  SegmentAlgorithmType => "(0062,0008)",
  SegmentAlgorithmName => "(0062,0009)",
  SegmentIdentificationSequence => "(0062,000a)",
  ReferencedSegmentNumber => "(0062,000b)",
  RecommendedDisplayGrayscaleValue => "(0062,000c)",
  RecommendedDisplayCIELabValue => "(0062,000d)",
  MaximumFractionalValue => "(0062,000e)",
  SegmentedPropertyTypeCodeSequence => "(0062,000f)",
  SegmentationFractionalType => "(0062,0010)",
  DeformableRegistrationSequence => "(0064,0002)",
  SourceFrameOfReferenceUID => "(0064,0003)",
  DeformableRegistrationGridSequence => "(0064,0005)",
  GridDimensions => "(0064,0007)",
  GridResolution => "(0064,0008)",
  VectorGridData => "(0064,0009)",
  PreDeformationMatrixRegistrationSequence => "(0064,000f)",
  PostDeformationMatrixRegistrationSequence => "(0064,0010)",
  GraphicAnnotationSequence => "(0070,0001)",
  GraphicLayer => "(0070,0002)",
  BoundingBoxAnnotationUnits => "(0070,0003)",
  AnchorPointAnnotationUnits => "(0070,0004)",
  GraphicAnnotationUnits => "(0070,0005)",
  UnformattedTextValue => "(0070,0006)",
  TextObjectSequence => "(0070,0008)",
  GraphicObjectSequence => "(0070,0009)",
  BoundingBoxTopLeftHandCorner => "(0070,0010)",
  BoundingBoxBottomRightHandCorner => "(0070,0011)",
  BoundingBoxTextHorizontalJustification => "(0070,0012)",
  AnchorPoint => "(0070,0014)",
  AnchorPointVisibility => "(0070,0015)",
  GraphicDimensions => "(0070,0020)",
  NumberOfGraphicPoints => "(0070,0021)",
  GraphicData => "(0070,0022)",
  GraphicType => "(0070,0023)",
  GraphicFilled => "(0070,0024)",
  ImageRotationTrial => "(0070,0040)",
  ImageHorizontalFlip => "(0070,0041)",
  ImageRotation => "(0070,0042)",
  DisplayedAreaTopLeftHandCornerTrial => "(0070,0050)",
  DisplayedAreaBottomRightHandCornerTrial => "(0070,0051)",
  DisplayedAreaTopLeftHandCorner => "(0070,0052)",
  DisplayedAreaBottomRightHandCorner => "(0070,0053)",
  DisplayedAreaSelectionSequence => "(0070,005a)",
  GraphicLayerSequence => "(0070,0060)",
  GraphicLayerOrder => "(0070,0062)",
  GraphicLayerRecommendedDisplayGrayscaleValue => "(0070,0066)",
  GraphicLayerRecommendedDisplayRGBValue => "(0070,0067)",
  GraphicLayerDescription => "(0070,0068)",
  ContentLabel => "(0070,0080)",
  ContentDescription => "(0070,0081)",
  PresentationCreationDate => "(0070,0082)",
  PresentationCreationTime => "(0070,0083)",
  ContentCreatorsName => "(0070,0084)",
  ContentCreatorsIdentificationCodeSequence => "(0070,0086)",
  PresentationSizeMode => "(0070,0100)",
  PresentationPixelSpacing => "(0070,0101)",
  PresentationPixelAspectRatio => "(0070,0102)",
  PresentationPixelMagnificationRatio => "(0070,0103)",
  ShapeType => "(0070,0306)",
  RegistrationSequence => "(0070,0308)",
  MatrixRegistrationSequence => "(0070,0309)",
  MatrixSequence => "(0070,030a)",
  FrameOfReferenceTransformationMatrixType => "(0070,030c)",
  RegistrationTypeCodeSequence => "(0070,030d)",
  FiducialDescription => "(0070,030f)",
  FiducialIdentifier => "(0070,0310)",
  FiducialIdentifierCodeSequence => "(0070,0311)",
  ContourUncertaintyRadius => "(0070,0312)",
  UsedFiducialsSequence => "(0070,0314)",
  GraphicCoordinatesDataSequence => "(0070,0318)",
  FiducialUID => "(0070,031a)",
  FiducialSetSequence => "(0070,031c)",
  FiducialSequence => "(0070,031e)",
  GraphicLayerRecommendedDisplayCIELabValue => "(0070,0401)",
  BlendingSequence => "(0070,0402)",
  RelativeOpacity => "(0070,0403)",
  ReferencedSpatialRegistrationSequence => "(0070,0404)",
  BlendingPosition => "(0070,0405)",
  HangingProtocolName => "(0072,0002)",
  HangingProtocolDescription => "(0072,0004)",
  HangingProtocolLevel => "(0072,0006)",
  HangingProtocolCreator => "(0072,0008)",
  HangingProtocolCreationDateTime => "(0072,000a)",
  HangingProtocolDefinitionSequence => "(0072,000c)",
  HangingProtocolUserIdentificationCodeSequence => "(0072,000e)",
  HangingProtocolUserGroupName => "(0072,0010)",
  SourceHangingProtocolSequence => "(0072,0012)",
  NumberOfPriorsReferenced => "(0072,0014)",
  ImageSetsSequence => "(0072,0020)",
  ImageSetSelectorSequence => "(0072,0022)",
  ImageSetSelectorUsageFlag => "(0072,0024)",
  SelectorAttribute => "(0072,0026)",
  SelectorValueNumber => "(0072,0028)",
  TimeBasedImageSetsSequence => "(0072,0030)",
  ImageSetNumber => "(0072,0032)",
  ImageSetSelectorCategory => "(0072,0034)",
  RelativeTime => "(0072,0038)",
  RelativeTimeUnits => "(0072,003a)",
  AbstractPriorValue => "(0072,003c)",
  AbstractPriorCodeSequence => "(0072,003e)",
  ImageSetLabel => "(0072,0040)",
  SelectorAttributeVR => "(0072,0050)",
  SelectorSequencePointer => "(0072,0052)",
  SelectorSequencePointerPrivateCreator => "(0072,0054)",
  SelectorAttributePrivateCreator => "(0072,0056)",
  SelectorATValue => "(0072,0060)",
  SelectorCSValue => "(0072,0062)",
  SelectorISValue => "(0072,0064)",
  SelectorLOValue => "(0072,0066)",
  SelectorLTValue => "(0072,0068)",
  SelectorPNValue => "(0072,006a)",
  SelectorSHValue => "(0072,006c)",
  SelectorSTValue => "(0072,006e)",
  SelectorUTValue => "(0072,0070)",
  SelectorDSValue => "(0072,0072)",
  SelectorFDValue => "(0072,0074)",
  SelectorFLValue => "(0072,0076)",
  SelectorULValue => "(0072,0078)",
  SelectorUSValue => "(0072,007a)",
  SelectorSLValue => "(0072,007c)",
  SelectorSSValue => "(0072,007e)",
  SelectorCodeSequenceValue => "(0072,0080)",
  NumberOfScreens => "(0072,0100)",
  NominalScreenDefinitionSequence => "(0072,0102)",
  NumberOfVerticalPixels => "(0072,0104)",
  NumberOfHorizontalPixels => "(0072,0106)",
  DisplayEnvironmentSpatialPosition => "(0072,0108)",
  ScreenMinimumGrayscaleBitDepth => "(0072,010a)",
  ScreenMinimumColorBitDepth => "(0072,010c)",
  ApplicationMaximumRepaintTime => "(0072,010e)",
  DisplaySetsSequence => "(0072,0200)",
  DisplaySetNumber => "(0072,0202)",
  DisplaySetLabel => "(0072,0203)",
  DisplaySetPresentationGroup => "(0072,0204)",
  DisplaySetPresentationGroupDescription => "(0072,0206)",
  PartialDataDisplayHandling => "(0072,0208)",
  SynchronizedScrollingSequence => "(0072,0210)",
  DisplaySetScrollingGroup => "(0072,0212)",
  NavigationIndicatorSequence => "(0072,0214)",
  NavigationDisplaySet => "(0072,0216)",
  ReferenceDisplaySets => "(0072,0218)",
  ImageBoxesSequence => "(0072,0300)",
  ImageBoxNumber => "(0072,0302)",
  ImageBoxLayoutType => "(0072,0304)",
  ImageBoxTileHorizontalDimension => "(0072,0306)",
  ImageBoxTileVerticalDimension => "(0072,0308)",
  ImageBoxScrollDirection => "(0072,0310)",
  ImageBoxSmallScrollType => "(0072,0312)",
  ImageBoxSmallScrollAmount => "(0072,0314)",
  ImageBoxLargeScrollType => "(0072,0316)",
  ImageBoxLargeScrollAmount => "(0072,0318)",
  ImageBoxOverlapPriority => "(0072,0320)",
  CineRelativeToRealTime => "(0072,0330)",
  FilterOperationsSequence => "(0072,0400)",
  FilterByCategory => "(0072,0402)",
  FilterByAttributePresence => "(0072,0404)",
  FilterByOperator => "(0072,0406)",
  BlendingOperationType => "(0072,0500)",
  ReformattingOperationType => "(0072,0510)",
  ReformattingThickness => "(0072,0512)",
  ReformattingInterval => "(0072,0514)",
  ReformattingOperationInitialViewDirection => "(0072,0516)",
  ThreeDRenderingType => "(0072,0520)",
  SortingOperationsSequence => "(0072,0600)",
  SortByCategory => "(0072,0602)",
  SortingDirection => "(0072,0604)",
  DisplaySetPatientOrientation => "(0072,0700)",
  VOIType => "(0072,0702)",
  PseudocolorType => "(0072,0704)",
  ShowGrayscaleInverted => "(0072,0706)",
  ShowImageTrueSizeFlag => "(0072,0710)",
  ShowGraphicAnnotationFlag => "(0072,0712)",
  ShowPatientDemographicsFlag => "(0072,0714)",
  ShowAcquisitionTechniquesFlag => "(0072,0716)",
  DisplaySetHorizontalJustification => "(0072,0717)",
  DisplaySetVerticalJustification => "(0072,0718)",
  StorageMediaFileSetID => "(0088,0130)",
  StorageMediaFileSetUID => "(0088,0140)",
  IconImageSequence => "(0088,0200)",
  TopicTitle => "(0088,0904)",
  TopicSubject => "(0088,0906)",
  TopicAuthor => "(0088,0910)",
  TopicKeyWords => "(0088,0912)",
  SOPInstanceStatus => "(0100,0410)",
  SOPAuthorizationDateAndTime => "(0100,0420)",
  SOPAuthorizationComment => "(0100,0424)",
  AuthorizationEquipmentCertificationNumber => "(0100,0426)",
  MACIDNumber => "(0400,0005)",
  MACCalculationTransferSyntaxUID => "(0400,0010)",
  MACAlgorithm => "(0400,0015)",
  DataElementsSigned => "(0400,0020)",
  DigitalSignatureUID => "(0400,0100)",
  DigitalSignatureDateTime => "(0400,0105)",
  CertificateType => "(0400,0110)",
  CertificateOfSigner => "(0400,0115)",
  Signature => "(0400,0120)",
  CertifiedTimestampType => "(0400,0305)",
  CertifiedTimestamp => "(0400,0310)",
  DigitalSignaturePurposeCodeSequence => "(0400,0401)",
  ReferencedDigitalSignatureSequence => "(0400,0402)",
  ReferencedSOPInstanceMACSequence => "(0400,0403)",
  MAC => "(0400,0404)",
  EncryptedAttributesSequence => "(0400,0500)",
  EncryptedContentTransferSyntaxUID => "(0400,0510)",
  EncryptedContent => "(0400,0520)",
  ModifiedAttributesSequence => "(0400,0550)",
  OriginalAttributesSequence => "(0400,0561)",
  AttributeModificationDateTime => "(0400,0562)",
  ModifyingSystem => "(0400,0563)",
  SourceOfPreviousValues => "(0400,0564)",
  ReasonForTheAttributeModification => "(0400,0565)",
  NumberOfCopies => "(2000,0010)",
  PrinterConfigurationSequence => "(2000,001e)",
  PrintPriority => "(2000,0020)",
  MediumType => "(2000,0030)",
  FilmDestination => "(2000,0040)",
  FilmSessionLabel => "(2000,0050)",
  MemoryAllocation => "(2000,0060)",
  MaximumMemoryAllocation => "(2000,0061)",
  ColorImagePrintingFlag => "(2000,0062)",
  CollationFlag => "(2000,0063)",
  AnnotationFlag => "(2000,0065)",
  ImageOverlayFlag => "(2000,0067)",
  PresentationLUTFlag => "(2000,0069)",
  ImageBoxPresentationLUTFlag => "(2000,006a)",
  MemoryBitDepth => "(2000,00a0)",
  PrintingBitDepth => "(2000,00a1)",
  MediaInstalledSequence => "(2000,00a2)",
  OtherMediaAvailableSequence => "(2000,00a4)",
  SupportedImageDisplayFormatsSequence => "(2000,00a8)",
  ReferencedFilmBoxSequence => "(2000,0500)",
  ReferencedStoredPrintSequence => "(2000,0510)",
  ImageDisplayFormat => "(2010,0010)",
  AnnotationDisplayFormatID => "(2010,0030)",
  FilmOrientation => "(2010,0040)",
  FilmSizeID => "(2010,0050)",
  PrinterResolutionID => "(2010,0052)",
  DefaultPrinterResolutionID => "(2010,0054)",
  MagnificationType => "(2010,0060)",
  SmoothingType => "(2010,0080)",
  DefaultMagnificationType => "(2010,00a6)",
  OtherMagnificationTypesAvailable => "(2010,00a7)",
  DefaultSmoothingType => "(2010,00a8)",
  OtherSmoothingTypesAvailable => "(2010,00a9)",
  BorderDensity => "(2010,0100)",
  EmptyImageDensity => "(2010,0110)",
  MinDensity => "(2010,0120)",
  MaxDensity => "(2010,0130)",
  Trim => "(2010,0140)",
  ConfigurationInformation => "(2010,0150)",
  ConfigurationInformationDescription => "(2010,0152)",
  MaximumCollatedFilms => "(2010,0154)",
  Illumination => "(2010,015e)",
  ReflectedAmbientLight => "(2010,0160)",
  PrinterPixelSpacing => "(2010,0376)",
  ReferencedFilmSessionSequence => "(2010,0500)",
  ReferencedImageBoxSequence => "(2010,0510)",
  ReferencedBasicAnnotationBoxSequence => "(2010,0520)",
  ImageBoxPosition => "(2020,0010)",
  Polarity => "(2020,0020)",
  RequestedImageSize => "(2020,0030)",
  RequestedDecimateCropBehavior => "(2020,0040)",
  RequestedResolutionID => "(2020,0050)",
  RequestedImageSizeFlag => "(2020,00a0)",
  DecimateCropResult => "(2020,00a2)",
  BasicGrayscaleImageSequence => "(2020,0110)",
  BasicColorImageSequence => "(2020,0111)",
  ReferencedImageOverlayBoxSequence => "(2020,0130)",
  ReferencedVOILUTBoxSequence => "(2020,0140)",
  AnnotationPosition => "(2030,0010)",
  TextString => "(2030,0020)",
  ReferencedOverlayPlaneSequence => "(2040,0010)",
  ReferencedOverlayPlaneGroups => "(2040,0011)",
  OverlayPixelDataSequence => "(2040,0020)",
  OverlayMagnificationType => "(2040,0060)",
  OverlaySmoothingType => "(2040,0070)",
  OverlayOrImageMagnification => "(2040,0072)",
  MagnifyToNumberOfColumns => "(2040,0074)",
  OverlayForegroundDensity => "(2040,0080)",
  OverlayBackgroundDensity => "(2040,0082)",
  OverlayMode => "(2040,0090)",
  ThresholdDensity => "(2040,0100)",
  ReferencedOverlayImageBoxSequence => "(2040,0500)",
  PresentationLUTSequence => "(2050,0010)",
  PresentationLUTShape => "(2050,0020)",
  ReferencedPresentationLUTSequence => "(2050,0500)",
  PrintJobID => "(2100,0010)",
  ExecutionStatus => "(2100,0020)",
  ExecutionStatusInfo => "(2100,0030)",
  CreationDate => "(2100,0040)",
  CreationTime => "(2100,0050)",
  Originator => "(2100,0070)",
  DestinationAE => "(2100,0140)",
  OwnerID => "(2100,0160)",
  NumberOfFilms => "(2100,0170)",
  ReferencedPrintJobSequencePull => "(2100,0500)",
  PrinterStatus => "(2110,0010)",
  PrinterStatusInfo => "(2110,0020)",
  PrinterName => "(2110,0030)",
  PrintQueueID => "(2110,0099)",
  QueueStatus => "(2120,0010)",
  PrintJobDescriptionSequence => "(2120,0050)",
  ReferencedPrintJobSequenceQueue => "(2120,0070)",
  PrintManagementCapabilitiesSequence => "(2130,0010)",
  PrinterCharacteristicsSequence => "(2130,0015)",
  FilmBoxContentSequence => "(2130,0030)",
  ImageBoxContentSequence => "(2130,0040)",
  AnnotationContentSequence => "(2130,0050)",
  ImageOverlayBoxContentSequence => "(2130,0060)",
  PresentationLUTContentSequence => "(2130,0080)",
  ProposedStudySequence => "(2130,00a0)",
  OriginalImageSequence => "(2130,00c0)",
  LabelUsingInformationExtractedFromInstances => "(2200,0001)",
  LabelText => "(2200,0002)",
  LabelStyleSelection => "(2200,0003)",
  MediaDisposition => "(2200,0004)",
  BarcodeValue => "(2200,0005)",
  BarcodeSymbology => "(2200,0006)",
  AllowMediaSplitting => "(2200,0007)",
  IncludeNonDICOMObjects => "(2200,0008)",
  IncludeDisplayApplication => "(2200,0009)",
  PreserveCompositeInstancesAfterMediaCreation => "(2200,000a)",
  TotalNumberOfPiecesOfMediaCreated => "(2200,000b)",
  RequestedMediaApplicationProfile => "(2200,000c)",
  ReferencedStorageMediaSequence => "(2200,000d)",
  FailureAttributes => "(2200,000e)",
  AllowLossyCompression => "(2200,000f)",
  RequestPriority => "(2200,0020)",
  RTImageLabel => "(3002,0002)",
  RTImageName => "(3002,0003)",
  RTImageDescription => "(3002,0004)",
  ReportedValuesOrigin => "(3002,000a)",
  RTImagePlane => "(3002,000c)",
  XRayImageReceptorTranslation => "(3002,000d)",
  XRayImageReceptorAngle => "(3002,000e)",
  RTImageOrientation => "(3002,0010)",
  ImagePlanePixelSpacing => "(3002,0011)",
  RTImagePosition => "(3002,0012)",
  RadiationMachineName => "(3002,0020)",
  RadiationMachineSAD => "(3002,0022)",
  RadiationMachineSSD => "(3002,0024)",
  RTImageSID => "(3002,0026)",
  SourceToReferenceObjectDistance => "(3002,0028)",
  FractionNumber => "(3002,0029)",
  ExposureSequence => "(3002,0030)",
  MetersetExposure => "(3002,0032)",
  DiaphragmPosition => "(3002,0034)",
  FluenceMapSequence => "(3002,0040)",
  FluenceDataSource => "(3002,0041)",
  FluenceDataScale => "(3002,0042)",
  DVHType => "(3004,0001)",
  DoseUnits => "(3004,0002)",
  DoseType => "(3004,0004)",
  DoseComment => "(3004,0006)",
  NormalizationPoint => "(3004,0008)",
  DoseSummationType => "(3004,000a)",
  GridFrameOffsetVector => "(3004,000c)",
  DoseGridScaling => "(3004,000e)",
  RTDoseROISequence => "(3004,0010)",
  DoseValue => "(3004,0012)",
  TissueHeterogeneityCorrection => "(3004,0014)",
  DVHNormalizationPoint => "(3004,0040)",
  DVHNormalizationDoseValue => "(3004,0042)",
  DVHSequence => "(3004,0050)",
  DVHDoseScaling => "(3004,0052)",
  DVHVolumeUnits => "(3004,0054)",
  DVHNumberOfBins => "(3004,0056)",
  DVHData => "(3004,0058)",
  DVHReferencedROISequence => "(3004,0060)",
  DVHROIContributionType => "(3004,0062)",
  DVHMinimumDose => "(3004,0070)",
  DVHMaximumDose => "(3004,0072)",
  DVHMeanDose => "(3004,0074)",
  StructureSetLabel => "(3006,0002)",
  StructureSetName => "(3006,0004)",
  StructureSetDescription => "(3006,0006)",
  StructureSetDate => "(3006,0008)",
  StructureSetTime => "(3006,0009)",
  ReferencedFrameOfReferenceSequence => "(3006,0010)",
  RTReferencedStudySequence => "(3006,0012)",
  RTReferencedSeriesSequence => "(3006,0014)",
  ContourImageSequence => "(3006,0016)",
  StructureSetROISequence => "(3006,0020)",
  ROINumber => "(3006,0022)",
  ReferencedFrameOfReferenceUID => "(3006,0024)",
  ROIName => "(3006,0026)",
  ROIDescription => "(3006,0028)",
  ROIDisplayColor => "(3006,002a)",
  ROIVolume => "(3006,002c)",
  RTRelatedROISequence => "(3006,0030)",
  RTROIRelationship => "(3006,0033)",
  ROIGenerationAlgorithm => "(3006,0036)",
  ROIGenerationDescription => "(3006,0038)",
  ROIContourSequence => "(3006,0039)",
  ContourSequence => "(3006,0040)",
  ContourGeometricType => "(3006,0042)",
  ContourSlabThickness => "(3006,0044)",
  ContourOffsetVector => "(3006,0045)",
  NumberOfContourPoints => "(3006,0046)",
  ContourNumber => "(3006,0048)",
  AttachedContours => "(3006,0049)",
  ContourData => "(3006,0050)",
  RTROIObservationsSequence => "(3006,0080)",
  ObservationNumber => "(3006,0082)",
  ReferencedROINumber => "(3006,0084)",
  ROIObservationLabel => "(3006,0085)",
  RTROIIdentificationCodeSequence => "(3006,0086)",
  ROIObservationDescription => "(3006,0088)",
  RelatedRTROIObservationsSequence => "(3006,00a0)",
  RTROIInterpretedType => "(3006,00a4)",
  ROIInterpreter => "(3006,00a6)",
  ROIPhysicalPropertiesSequence => "(3006,00b0)",
  ROIPhysicalProperty => "(3006,00b2)",
  ROIPhysicalPropertyValue => "(3006,00b4)",
  ROIElementalCompositionSequence => "(3006,00b6)",
  ROIElementalCompositionAtomicNumber => "(3006,00b7)",
  ROIElementalCompositionAtomicMassFraction => "(3006,00b8)",
  FrameOfReferenceRelationshipSequence => "(3006,00c0)",
  RelatedFrameOfReferenceUID => "(3006,00c2)",
  FrameOfReferenceTransformationType => "(3006,00c4)",
  FrameOfReferenceTransformationMatrix => "(3006,00c6)",
  FrameOfReferenceTransformationComment => "(3006,00c8)",
  MeasuredDoseReferenceSequence => "(3008,0010)",
  MeasuredDoseDescription => "(3008,0012)",
  MeasuredDoseType => "(3008,0014)",
  MeasuredDoseValue => "(3008,0016)",
  TreatmentSessionBeamSequence => "(3008,0020)",
  TreatmentSessionIonBeamSequence => "(3008,0021)",
  CurrentFractionNumber => "(3008,0022)",
  TreatmentControlPointDate => "(3008,0024)",
  TreatmentControlPointTime => "(3008,0025)",
  TreatmentTerminationStatus => "(3008,002a)",
  TreatmentTerminationCode => "(3008,002b)",
  TreatmentVerificationStatus => "(3008,002c)",
  ReferencedTreatmentRecordSequence => "(3008,0030)",
  SpecifiedPrimaryMeterset => "(3008,0032)",
  SpecifiedSecondaryMeterset => "(3008,0033)",
  DeliveredPrimaryMeterset => "(3008,0036)",
  DeliveredSecondaryMeterset => "(3008,0037)",
  SpecifiedTreatmentTime => "(3008,003a)",
  DeliveredTreatmentTime => "(3008,003b)",
  ControlPointDeliverySequence => "(3008,0040)",
  IonControlPointDeliverySequence => "(3008,0041)",
  SpecifiedMeterset => "(3008,0042)",
  DeliveredMeterset => "(3008,0044)",
  MetersetRateSet => "(3008,0045)",
  MetersetRateDelivered => "(3008,0046)",
  ScanSpotMetersetsDelivered => "(3008,0047)",
  DoseRateDelivered => "(3008,0048)",
  TreatmentSummaryCalculatedDoseReferenceSequence => "(3008,0050)",
  CumulativeDoseToDoseReference => "(3008,0052)",
  FirstTreatmentDate => "(3008,0054)",
  MostRecentTreatmentDate => "(3008,0056)",
  NumberOfFractionsDelivered => "(3008,005a)",
  OverrideSequence => "(3008,0060)",
  ParameterSequencePointer => "(3008,0061)",
  OverrideParameterPointer => "(3008,0062)",
  ParameterItemIndex => "(3008,0063)",
  MeasuredDoseReferenceNumber => "(3008,0064)",
  ParameterPointer => "(3008,0065)",
  OverrideReason => "(3008,0066)",
  CorrectedParameterSequence => "(3008,0068)",
  CorrectionValue => "(3008,006a)",
  CalculatedDoseReferenceSequence => "(3008,0070)",
  CalculatedDoseReferenceNumber => "(3008,0072)",
  CalculatedDoseReferenceDescription => "(3008,0074)",
  CalculatedDoseReferenceDoseValue => "(3008,0076)",
  StartMeterset => "(3008,0078)",
  EndMeterset => "(3008,007a)",
  ReferencedMeasuredDoseReferenceSequence => "(3008,0080)",
  ReferencedMeasuredDoseReferenceNumber => "(3008,0082)",
  ReferencedCalculatedDoseReferenceSequence => "(3008,0090)",
  ReferencedCalculatedDoseReferenceNumber => "(3008,0092)",
  BeamLimitingDeviceLeafPairsSequence => "(3008,00a0)",
  RecordedWedgeSequence => "(3008,00b0)",
  RecordedCompensatorSequence => "(3008,00c0)",
  RecordedBlockSequence => "(3008,00d0)",
  TreatmentSummaryMeasuredDoseReferenceSequence => "(3008,00e0)",
  RecordedSnoutSequence => "(3008,00f0)",
  RecordedRangeShifterSequence => "(3008,00f2)",
  RecordedLateralSpreadingDeviceSequence => "(3008,00f4)",
  RecordedRangeModulatorSequence => "(3008,00f6)",
  RecordedSourceSequence => "(3008,0100)",
  SourceSerialNumber => "(3008,0105)",
  TreatmentSessionApplicationSetupSequence => "(3008,0110)",
  ApplicationSetupCheck => "(3008,0116)",
  RecordedBrachyAccessoryDeviceSequence => "(3008,0120)",
  ReferencedBrachyAccessoryDeviceNumber => "(3008,0122)",
  RecordedChannelSequence => "(3008,0130)",
  SpecifiedChannelTotalTime => "(3008,0132)",
  DeliveredChannelTotalTime => "(3008,0134)",
  SpecifiedNumberOfPulses => "(3008,0136)",
  DeliveredNumberOfPulses => "(3008,0138)",
  SpecifiedPulseRepetitionInterval => "(3008,013a)",
  DeliveredPulseRepetitionInterval => "(3008,013c)",
  RecordedSourceApplicatorSequence => "(3008,0140)",
  ReferencedSourceApplicatorNumber => "(3008,0142)",
  RecordedChannelShieldSequence => "(3008,0150)",
  ReferencedChannelShieldNumber => "(3008,0152)",
  BrachyControlPointDeliveredSequence => "(3008,0160)",
  SafePositionExitDate => "(3008,0162)",
  SafePositionExitTime => "(3008,0164)",
  SafePositionReturnDate => "(3008,0166)",
  SafePositionReturnTime => "(3008,0168)",
  CurrentTreatmentStatus => "(3008,0200)",
  TreatmentStatusComment => "(3008,0202)",
  FractionGroupSummarySequence => "(3008,0220)",
  ReferencedFractionNumber => "(3008,0223)",
  FractionGroupType => "(3008,0224)",
  BeamStopperPosition => "(3008,0230)",
  FractionStatusSummarySequence => "(3008,0240)",
  TreatmentDate => "(3008,0250)",
  TreatmentTime => "(3008,0251)",
  RTPlanLabel => "(300a,0002)",
  RTPlanName => "(300a,0003)",
  RTPlanDescription => "(300a,0004)",
  RTPlanDate => "(300a,0006)",
  RTPlanTime => "(300a,0007)",
  TreatmentProtocols => "(300a,0009)",
  PlanIntent => "(300a,000a)",
  TreatmentSites => "(300a,000b)",
  RTPlanGeometry => "(300a,000c)",
  PrescriptionDescription => "(300a,000e)",
  DoseReferenceSequence => "(300a,0010)",
  DoseReferenceNumber => "(300a,0012)",
  DoseReferenceUID => "(300a,0013)",
  DoseReferenceStructureType => "(300a,0014)",
  NominalBeamEnergyUnit => "(300a,0015)",
  DoseReferenceDescription => "(300a,0016)",
  DoseReferencePointCoordinates => "(300a,0018)",
  NominalPriorDose => "(300a,001a)",
  DoseReferenceType => "(300a,0020)",
  ConstraintWeight => "(300a,0021)",
  DeliveryWarningDose => "(300a,0022)",
  DeliveryMaximumDose => "(300a,0023)",
  TargetMinimumDose => "(300a,0025)",
  TargetPrescriptionDose => "(300a,0026)",
  TargetMaximumDose => "(300a,0027)",
  TargetUnderdoseVolumeFraction => "(300a,0028)",
  OrganAtRiskFullVolumeDose => "(300a,002a)",
  OrganAtRiskLimitDose => "(300a,002b)",
  OrganAtRiskMaximumDose => "(300a,002c)",
  OrganAtRiskOverdoseVolumeFraction => "(300a,002d)",
  ToleranceTableSequence => "(300a,0040)",
  ToleranceTableNumber => "(300a,0042)",
  ToleranceTableLabel => "(300a,0043)",
  GantryAngleTolerance => "(300a,0044)",
  BeamLimitingDeviceAngleTolerance => "(300a,0046)",
  BeamLimitingDeviceToleranceSequence => "(300a,0048)",
  BeamLimitingDevicePositionTolerance => "(300a,004a)",
  SnoutPositionTolerance => "(300a,004b)",
  PatientSupportAngleTolerance => "(300a,004c)",
  TableTopEccentricAngleTolerance => "(300a,004e)",
  TableTopPitchAngleTolerance => "(300a,004f)",
  TableTopRollAngleTolerance => "(300a,0050)",
  TableTopVerticalPositionTolerance => "(300a,0051)",
  TableTopLongitudinalPositionTolerance => "(300a,0052)",
  TableTopLateralPositionTolerance => "(300a,0053)",
  RTPlanRelationship => "(300a,0055)",
  FractionGroupSequence => "(300a,0070)",
  FractionGroupNumber => "(300a,0071)",
  FractionGroupDescription => "(300a,0072)",
  NumberOfFractionsPlanned => "(300a,0078)",
  NumberOfFractionPatternDigitsPerDay => "(300a,0079)",
  RepeatFractionCycleLength => "(300a,007a)",
  FractionPattern => "(300a,007b)",
  NumberOfBeams => "(300a,0080)",
  BeamDoseSpecificationPoint => "(300a,0082)",
  BeamDose => "(300a,0084)",
  BeamMeterset => "(300a,0086)",
  BeamDosePointDepth => "(300a,0088)",
  BeamDosePointEquivalentDepth => "(300a,0089)",
  BeamDosePointSSD => "(300a,008a)",
  NumberOfBrachyApplicationSetups => "(300a,00a0)",
  BrachyApplicationSetupDoseSpecificationPoint => "(300a,00a2)",
  BrachyApplicationSetupDose => "(300a,00a4)",
  BeamSequence => "(300a,00b0)",
  TreatmentMachineName => "(300a,00b2)",
  PrimaryDosimeterUnit => "(300a,00b3)",
  SourceAxisDistance => "(300a,00b4)",
  BeamLimitingDeviceSequence => "(300a,00b6)",
  RTBeamLimitingDeviceType => "(300a,00b8)",
  SourceToBeamLimitingDeviceDistance => "(300a,00ba)",
  IsocenterToBeamLimitingDeviceDistance => "(300a,00bb)",
  NumberOfLeafJawPairs => "(300a,00bc)",
  LeafPositionBoundaries => "(300a,00be)",
  BeamNumber => "(300a,00c0)",
  BeamName => "(300a,00c2)",
  BeamDescription => "(300a,00c3)",
  BeamType => "(300a,00c4)",
  RadiationType => "(300a,00c6)",
  HighDoseTechniqueType => "(300a,00c7)",
  ReferenceImageNumber => "(300a,00c8)",
  PlannedVerificationImageSequence => "(300a,00ca)",
  ImagingDeviceSpecificAcquisitionParameters => "(300a,00cc)",
  TreatmentDeliveryType => "(300a,00ce)",
  NumberOfWedges => "(300a,00d0)",
  WedgeSequence => "(300a,00d1)",
  WedgeNumber => "(300a,00d2)",
  WedgeType => "(300a,00d3)",
  WedgeID => "(300a,00d4)",
  WedgeAngle => "(300a,00d5)",
  WedgeFactor => "(300a,00d6)",
  TotalWedgeTrayWaterEquivalentThickness => "(300a,00d7)",
  WedgeOrientation => "(300a,00d8)",
  IsocenterToWedgeTrayDistance => "(300a,00d9)",
  SourceToWedgeTrayDistance => "(300a,00da)",
  WedgeThinEdgePosition => "(300a,00db)",
  BolusID => "(300a,00dc)",
  BolusDescription => "(300a,00dd)",
  NumberOfCompensators => "(300a,00e0)",
  MaterialID => "(300a,00e1)",
  TotalCompensatorTrayFactor => "(300a,00e2)",
  CompensatorSequence => "(300a,00e3)",
  CompensatorNumber => "(300a,00e4)",
  CompensatorID => "(300a,00e5)",
  SourceToCompensatorTrayDistance => "(300a,00e6)",
  CompensatorRows => "(300a,00e7)",
  CompensatorColumns => "(300a,00e8)",
  CompensatorPixelSpacing => "(300a,00e9)",
  CompensatorPosition => "(300a,00ea)",
  CompensatorTransmissionData => "(300a,00eb)",
  CompensatorThicknessData => "(300a,00ec)",
  NumberOfBoli => "(300a,00ed)",
  CompensatorType => "(300a,00ee)",
  NumberOfBlocks => "(300a,00f0)",
  TotalBlockTrayFactor => "(300a,00f2)",
  TotalBlockTrayWaterEquivalentThickness => "(300a,00f3)",
  BlockSequence => "(300a,00f4)",
  BlockTrayID => "(300a,00f5)",
  SourceToBlockTrayDistance => "(300a,00f6)",
  IsocenterToBlockTrayDistance => "(300a,00f7)",
  BlockType => "(300a,00f8)",
  AccessoryCode => "(300a,00f9)",
  BlockDivergence => "(300a,00fa)",
  BlockMountingPosition => "(300a,00fb)",
  BlockNumber => "(300a,00fc)",
  BlockName => "(300a,00fe)",
  BlockThickness => "(300a,0100)",
  BlockTransmission => "(300a,0102)",
  BlockNumberOfPoints => "(300a,0104)",
  BlockData => "(300a,0106)",
  ApplicatorSequence => "(300a,0107)",
  ApplicatorID => "(300a,0108)",
  ApplicatorType => "(300a,0109)",
  ApplicatorDescription => "(300a,010a)",
  CumulativeDoseReferenceCoefficient => "(300a,010c)",
  FinalCumulativeMetersetWeight => "(300a,010e)",
  NumberOfControlPoints => "(300a,0110)",
  ControlPointSequence => "(300a,0111)",
  ControlPointIndex => "(300a,0112)",
  NominalBeamEnergy => "(300a,0114)",
  DoseRateSet => "(300a,0115)",
  WedgePositionSequence => "(300a,0116)",
  WedgePosition => "(300a,0118)",
  BeamLimitingDevicePositionSequence => "(300a,011a)",
  LeafJawPositions => "(300a,011c)",
  GantryAngle => "(300a,011e)",
  GantryRotationDirection => "(300a,011f)",
  BeamLimitingDeviceAngle => "(300a,0120)",
  BeamLimitingDeviceRotationDirection => "(300a,0121)",
  PatientSupportAngle => "(300a,0122)",
  PatientSupportRotationDirection => "(300a,0123)",
  TableTopEccentricAxisDistance => "(300a,0124)",
  TableTopEccentricAngle => "(300a,0125)",
  TableTopEccentricRotationDirection => "(300a,0126)",
  TableTopVerticalPosition => "(300a,0128)",
  TableTopLongitudinalPosition => "(300a,0129)",
  TableTopLateralPosition => "(300a,012a)",
  IsocenterPosition => "(300a,012c)",
  SurfaceEntryPoint => "(300a,012e)",
  SourceToSurfaceDistance => "(300a,0130)",
  CumulativeMetersetWeight => "(300a,0134)",
  TableTopPitchAngle => "(300a,0140)",
  TableTopPitchRotationDirection => "(300a,0142)",
  TableTopRollAngle => "(300a,0144)",
  TableTopRollRotationDirection => "(300a,0146)",
  HeadFixationAngle => "(300a,0148)",
  GantryPitchAngle => "(300a,014a)",
  GantryPitchRotationDirection => "(300a,014c)",
  GantryPitchAngleTolerance => "(300a,014e)",
  PatientSetupSequence => "(300a,0180)",
  PatientSetupNumber => "(300a,0182)",
  PatientSetupLabel => "(300a,0183)",
  PatientAdditionalPosition => "(300a,0184)",
  FixationDeviceSequence => "(300a,0190)",
  FixationDeviceType => "(300a,0192)",
  FixationDeviceLabel => "(300a,0194)",
  FixationDeviceDescription => "(300a,0196)",
  FixationDevicePosition => "(300a,0198)",
  FixationDevicePitchAngle => "(300a,0199)",
  FixationDeviceRollAngle => "(300a,019a)",
  ShieldingDeviceSequence => "(300a,01a0)",
  ShieldingDeviceType => "(300a,01a2)",
  ShieldingDeviceLabel => "(300a,01a4)",
  ShieldingDeviceDescription => "(300a,01a6)",
  ShieldingDevicePosition => "(300a,01a8)",
  SetupTechnique => "(300a,01b0)",
  SetupTechniqueDescription => "(300a,01b2)",
  SetupDeviceSequence => "(300a,01b4)",
  SetupDeviceType => "(300a,01b6)",
  SetupDeviceLabel => "(300a,01b8)",
  SetupDeviceDescription => "(300a,01ba)",
  SetupDeviceParameter => "(300a,01bc)",
  SetupReferenceDescription => "(300a,01d0)",
  TableTopVerticalSetupDisplacement => "(300a,01d2)",
  TableTopLongitudinalSetupDisplacement => "(300a,01d4)",
  TableTopLateralSetupDisplacement => "(300a,01d6)",
  BrachyTreatmentTechnique => "(300a,0200)",
  BrachyTreatmentType => "(300a,0202)",
  TreatmentMachineSequence => "(300a,0206)",
  SourceSequence => "(300a,0210)",
  SourceNumber => "(300a,0212)",
  SourceType => "(300a,0214)",
  SourceManufacturer => "(300a,0216)",
  ActiveSourceDiameter => "(300a,0218)",
  ActiveSourceLength => "(300a,021a)",
  SourceEncapsulationNominalThickness => "(300a,0222)",
  SourceEncapsulationNominalTransmission => "(300a,0224)",
  SourceIsotopeName => "(300a,0226)",
  SourceIsotopeHalfLife => "(300a,0228)",
  SourceStrengthUnits => "(300a,0229)",
  ReferenceAirKermaRate => "(300a,022a)",
  SourceStrength => "(300a,022b)",
  SourceStrengthReferenceDate => "(300a,022c)",
  SourceStrengthReferenceTime => "(300a,022e)",
  ApplicationSetupSequence => "(300a,0230)",
  ApplicationSetupType => "(300a,0232)",
  ApplicationSetupNumber => "(300a,0234)",
  ApplicationSetupName => "(300a,0236)",
  ApplicationSetupManufacturer => "(300a,0238)",
  TemplateNumber => "(300a,0240)",
  TemplateType => "(300a,0242)",
  TemplateName => "(300a,0244)",
  TotalReferenceAirKerma => "(300a,0250)",
  BrachyAccessoryDeviceSequence => "(300a,0260)",
  BrachyAccessoryDeviceNumber => "(300a,0262)",
  BrachyAccessoryDeviceID => "(300a,0263)",
  BrachyAccessoryDeviceType => "(300a,0264)",
  BrachyAccessoryDeviceName => "(300a,0266)",
  BrachyAccessoryDeviceNominalThickness => "(300a,026a)",
  BrachyAccessoryDeviceNominalTransmission => "(300a,026c)",
  ChannelSequence => "(300a,0280)",
  ChannelNumber => "(300a,0282)",
  ChannelLength => "(300a,0284)",
  ChannelTotalTime => "(300a,0286)",
  SourceMovementType => "(300a,0288)",
  NumberOfPulses => "(300a,028a)",
  PulseRepetitionInterval => "(300a,028c)",
  SourceApplicatorNumber => "(300a,0290)",
  SourceApplicatorID => "(300a,0291)",
  SourceApplicatorType => "(300a,0292)",
  SourceApplicatorName => "(300a,0294)",
  SourceApplicatorLength => "(300a,0296)",
  SourceApplicatorManufacturer => "(300a,0298)",
  SourceApplicatorWallNominalThickness => "(300a,029c)",
  SourceApplicatorWallNominalTransmission => "(300a,029e)",
  SourceApplicatorStepSize => "(300a,02a0)",
  TransferTubeNumber => "(300a,02a2)",
  TransferTubeLength => "(300a,02a4)",
  ChannelShieldSequence => "(300a,02b0)",
  ChannelShieldNumber => "(300a,02b2)",
  ChannelShieldID => "(300a,02b3)",
  ChannelShieldName => "(300a,02b4)",
  ChannelShieldNominalThickness => "(300a,02b8)",
  ChannelShieldNominalTransmission => "(300a,02ba)",
  FinalCumulativeTimeWeight => "(300a,02c8)",
  BrachyControlPointSequence => "(300a,02d0)",
  ControlPointRelativePosition => "(300a,02d2)",
  ControlPoint3DPosition => "(300a,02d4)",
  CumulativeTimeWeight => "(300a,02d6)",
  CompensatorDivergence => "(300a,02e0)",
  CompensatorMountingPosition => "(300a,02e1)",
  SourceToCompensatorDistance => "(300a,02e2)",
  TotalCompensatorTrayWaterEquivalentThickness => "(300a,02e3)",
  IsocenterToCompensatorTrayDistance => "(300a,02e4)",
  CompensatorColumnOffset => "(300a,02e5)",
  IsocenterToCompensatorDistances => "(300a,02e6)",
  CompensatorRelativeStoppingPowerRatio => "(300a,02e7)",
  CompensatorMillingToolDiameter => "(300a,02e8)",
  IonRangeCompensatorSequence => "(300a,02ea)",
  CompensatorDescription => "(300a,02eb)",
  RadiationMassNumber => "(300a,0302)",
  RadiationAtomicNumber => "(300a,0304)",
  RadiationChargeState => "(300a,0306)",
  ScanMode => "(300a,0308)",
  VirtualSourceAxisDistances => "(300a,030a)",
  SnoutSequence => "(300a,030c)",
  SnoutPosition => "(300a,030d)",
  SnoutID => "(300a,030f)",
  NumberOfRangeShifters => "(300a,0312)",
  RangeShifterSequence => "(300a,0314)",
  RangeShifterNumber => "(300a,0316)",
  RangeShifterID => "(300a,0318)",
  RangeShifterType => "(300a,0320)",
  RangeShifterDescription => "(300a,0322)",
  NumberOfLateralSpreadingDevices => "(300a,0330)",
  LateralSpreadingDeviceSequence => "(300a,0332)",
  LateralSpreadingDeviceNumber => "(300a,0334)",
  LateralSpreadingDeviceID => "(300a,0336)",
  LateralSpreadingDeviceType => "(300a,0338)",
  LateralSpreadingDeviceDescription => "(300a,033a)",
  LateralSpreadingDeviceWaterEquivalentThickness => "(300a,033c)",
  NumberOfRangeModulators => "(300a,0340)",
  RangeModulatorSequence => "(300a,0342)",
  RangeModulatorNumber => "(300a,0344)",
  RangeModulatorID => "(300a,0346)",
  RangeModulatorType => "(300a,0348)",
  RangeModulatorDescription => "(300a,034a)",
  BeamCurrentModulationID => "(300a,034c)",
  PatientSupportType => "(300a,0350)",
  PatientSupportID => "(300a,0352)",
  PatientSupportAccessoryCode => "(300a,0354)",
  FixationLightAzimuthalAngle => "(300a,0356)",
  FixationLightPolarAngle => "(300a,0358)",
  MetersetRate => "(300a,035a)",
  RangeShifterSettingsSequence => "(300a,0360)",
  RangeShifterSetting => "(300a,0362)",
  IsocenterToRangeShifterDistance => "(300a,0364)",
  RangeShifterWaterEquivalentThickness => "(300a,0366)",
  LateralSpreadingDeviceSettingsSequence => "(300a,0370)",
  LateralSpreadingDeviceSetting => "(300a,0372)",
  IsocenterToLateralSpreadingDeviceDistance => "(300a,0374)",
  RangeModulatorSettingsSequence => "(300a,0380)",
  RangeModulatorGatingStartValue => "(300a,0382)",
  RangeModulatorGatingStopValue => "(300a,0384)",
  RangeModulatorGatingStartWaterEquivalentThickness => "(300a,0386)",
  RangeModulatorGatingStopWaterEquivalentThickness => "(300a,0388)",
  IsocenterToRangeModulatorDistance => "(300a,038a)",
  ScanSpotTuneID => "(300a,0390)",
  NumberOfScanSpotPositions => "(300a,0392)",
  ScanSpotPositionMap => "(300a,0394)",
  ScanSpotMetersetWeights => "(300a,0396)",
  ScanningSpotSize => "(300a,0398)",
  NumberOfPaintings => "(300a,039a)",
  IonToleranceTableSequence => "(300a,03a0)",
  IonBeamSequence => "(300a,03a2)",
  IonBeamLimitingDeviceSequence => "(300a,03a4)",
  IonBlockSequence => "(300a,03a6)",
  IonControlPointSequence => "(300a,03a8)",
  IonWedgeSequence => "(300a,03aa)",
  IonWedgePositionSequence => "(300a,03ac)",
  ReferencedSetupImageSequence => "(300a,0401)",
  SetupImageComment => "(300a,0402)",
  MotionSynchronizationSequence => "(300a,0410)",
  ControlPointOrientation => "(300a,0412)",
  GeneralAccessorySequence => "(300a,0420)",
  GeneralAccessoryID => "(300a,0421)",
  GeneralAccessoryDescription => "(300a,0422)",
  GeneralAccessoryType => "(300a,0423)",
  GeneralAccessoryNumber => "(300a,0424)",
  ReferencedRTPlanSequence => "(300c,0002)",
  ReferencedBeamSequence => "(300c,0004)",
  ReferencedBeamNumber => "(300c,0006)",
  ReferencedReferenceImageNumber => "(300c,0007)",
  StartCumulativeMetersetWeight => "(300c,0008)",
  EndCumulativeMetersetWeight => "(300c,0009)",
  ReferencedBrachyApplicationSetupSequence => "(300c,000a)",
  ReferencedBrachyApplicationSetupNumber => "(300c,000c)",
  ReferencedSourceNumber => "(300c,000e)",
  ReferencedFractionGroupSequence => "(300c,0020)",
  ReferencedFractionGroupNumber => "(300c,0022)",
  ReferencedVerificationImageSequence => "(300c,0040)",
  ReferencedReferenceImageSequence => "(300c,0042)",
  ReferencedDoseReferenceSequence => "(300c,0050)",
  ReferencedDoseReferenceNumber => "(300c,0051)",
  BrachyReferencedDoseReferenceSequence => "(300c,0055)",
  ReferencedStructureSetSequence => "(300c,0060)",
  ReferencedPatientSetupNumber => "(300c,006a)",
  ReferencedDoseSequence => "(300c,0080)",
  ReferencedToleranceTableNumber => "(300c,00a0)",
  ReferencedBolusSequence => "(300c,00b0)",
  ReferencedWedgeNumber => "(300c,00c0)",
  ReferencedCompensatorNumber => "(300c,00d0)",
  ReferencedBlockNumber => "(300c,00e0)",
  ReferencedControlPointIndex => "(300c,00f0)",
  ReferencedControlPointSequence => "(300c,00f2)",
  ReferencedStartControlPointIndex => "(300c,00f4)",
  ReferencedStopControlPointIndex => "(300c,00f6)",
  ReferencedRangeShifterNumber => "(300c,0100)",
  ReferencedLateralSpreadingDeviceNumber => "(300c,0102)",
  ReferencedRangeModulatorNumber => "(300c,0104)",
  ApprovalStatus => "(300e,0002)",
  ReviewDate => "(300e,0004)",
  ReviewTime => "(300e,0005)",
  ReviewerName => "(300e,0008)",
  Arbitrary => "(4000,0010)",
  TextComments => "(4000,4000)",
  ResultsID => "(4008,0040)",
  ResultsIDIssuer => "(4008,0042)",
  ReferencedInterpretationSequence => "(4008,0050)",
  ReportProductionStatusTrial => "(4008,00ff)",
  InterpretationRecordedDate => "(4008,0100)",
  InterpretationRecordedTime => "(4008,0101)",
  InterpretationRecorder => "(4008,0102)",
  ReferenceToRecordedSound => "(4008,0103)",
  InterpretationTranscriptionDate => "(4008,0108)",
  InterpretationTranscriptionTime => "(4008,0109)",
  InterpretationTranscriber => "(4008,010a)",
  InterpretationText => "(4008,010b)",
  InterpretationAuthor => "(4008,010c)",
  InterpretationApproverSequence => "(4008,0111)",
  InterpretationApprovalDate => "(4008,0112)",
  InterpretationApprovalTime => "(4008,0113)",
  PhysicianApprovingInterpretation => "(4008,0114)",
  InterpretationDiagnosisDescription => "(4008,0115)",
  InterpretationDiagnosisCodeSequence => "(4008,0117)",
  ResultsDistributionListSequence => "(4008,0118)",
  DistributionName => "(4008,0119)",
  DistributionAddress => "(4008,011a)",
  InterpretationID => "(4008,0200)",
  InterpretationIDIssuer => "(4008,0202)",
  InterpretationTypeID => "(4008,0210)",
  InterpretationStatusID => "(4008,0212)",
  Impressions => "(4008,0300)",
  ResultsComments => "(4008,4000)",
  MACParametersSequence => "(4ffe,0001)",
  SharedFunctionalGroupsSequence => "(5200,9229)",
  PerFrameFunctionalGroupsSequence => "(5200,9230)",
  WaveformSequence => "(5400,0100)",
  ChannelMinimumValue => "(5400,0110)",
  ChannelMaximumValue => "(5400,0112)",
  WaveformBitsAllocated => "(5400,1004)",
  WaveformSampleInterpretation => "(5400,1006)",
  WaveformPaddingValue => "(5400,100a)",
  WaveformData => "(5400,1010)",
  FirstOrderPhaseCorrectionAngle => "(5600,0010)",
  SpectroscopyData => "(5600,0020)",
  PixelData => "(7fe0,0010)",
  CoefficientsSDVN => "(7fe0,0020)",
  CoefficientsSDHN => "(7fe0,0030)",
  CoefficientsSDDN => "(7fe0,0040)",
  DigitalSignaturesSequence => "(fffa,fffa)",
  DataSetTrailingPadding => "(fffc,fffc)",
  Item => "(fffe,e000)",
  ItemDelimitationItem => "(fffe,e00d)",
  SequenceDelimitationItem => "(fffe,e0dd)",
};
sub FromSig{
  my($sig) = @_;
  my $exp = "";
  my $remain = $sig;
  while($remain){
    if($remain =~/^(\(....,....\))$/){
      my $ge = $1;
      $remain = "";
      if(exists $SigToName->{$ge}){
        $exp .= $SigToName->{$ge};
      } else {
        $exp .= $ge;
      }
    } elsif($remain =~ /^(\(....,....\))(\[\d+\])(.*)$/){
      my $ge = $1;
      my $idx = $2;
      $remain = $3;
      if(exists $SigToName->{$ge}){
        $exp .= $SigToName->{$ge};
      } else {
        $exp .= $ge;
      }
      $exp .= $idx;
    } elsif($remain =~ /^\(....,\"[^\"]+\",..\)$/) {
      my $ele;
      my $ele_name;
      eval {$ele = $dd->get_ele_by_sig($sig)};
      if($@){
        $ele_name = "UnknownPrivateName";
      } else {
        if(defined $ele && ref($ele) eq "HASH"){ $ele_name = $ele->{Name} }
        else { $ele_name = "UnknownPrivateName" }
      }
      $exp .= $ele_name;
      $remain = "";
    } elsif($remain =~ /^\((....),\"([^\"]+)\",(..)\)\[(\d+)\](.*)$/) {
      my $g = $1;
      my $o = $2;
      my $e = $3;
      my $i = $4;
      $remain = $5;
      my $psig = "($g,\"$o\",$e)";
      my $ele;
      my $ele_name;
      eval {$ele = $dd->get_ele_by_sig($psig)};
      if($@){
        $ele_name = "UnknownPrivateName";
      } else {
        if(defined $ele && ref($ele) eq "HASH"){ $ele_name = $ele->{Name} }
        else { $ele_name = "UnknownPrivateName" }
      }
      $exp .= "$ele_name" . "[" . $i . "]";
    } else {
      die "non-matching tag:\n\tso_far: $exp\n\tremaining: $remain\n\t\t--";
    }
  }
  return $exp;
}
sub FromPat{
  my($pat) = @_;
  my $exp = "";
  my $remain = $pat;
  while($remain){
    if($remain =~/^(\(....,....\))$/){
      my $ge = $1;
      $remain = "";
      if(exists $SigToName->{$ge}){
        $exp .= $SigToName->{$ge};
      } else {
        $exp .= $ge;
      }
    } elsif($remain =~ /^(\(....,....\))(\[[<>\d]+\])(.*)$/){
      my $ge = $1;
      my $idx = $2;
      $remain = $3;
      if(exists $SigToName->{$ge}){
        $exp .= $SigToName->{$ge};
      } else {
        $exp .= $ge;
      }
      $exp .= $idx;
    } elsif($remain =~ /^\(....,\"[^\"]+\",..\)$/) {
      my $ele;
      my $ele_name;
      eval {$ele = $dd->get_ele_by_sig($sig)};
      if($@){
        $ele_name = "UnknownPrivateName";
      } else {
        if(defined $ele && ref($ele) eq "HASH"){ $ele_name = $ele->{Name} }
        else { $ele_name = "UnknownPrivateName" }
      }
      $exp .= $ele_name;
      $remain = "";
    } elsif($remain =~ /^\((....),\"([^\"]+)\",(..)\)\[([<>\d]+)\](.*)$/) {
      my $g = $1;
      my $o = $2;
      my $e = $3;
      my $i = $4;
      $remain = $5;
      my $sig = "($g,\"$o\",$e)";
      my $ele;
      my $ele_name;
      eval {$ele = $dd->get_ele_by_sig($sig)};
      if($@){
        $ele_name = "UnknownPrivateName";
      } else {
        if(defined $ele && ref($ele) eq "HASH"){ $ele_name = $ele->{Name} }
        else { $ele_name = "UnknownPrivateName" }
      }
      $exp .= "$ele_name" . "[" . $i . "]";
    } else {
      die "non-matching pattern:\n\tso_far: $exp\n\tremaining: $remain\n\t\t--";
    }
  }
  return $exp;
}
sub ShortFromSig{
  my($sig) = @_;
  my $name = "&lt;unknown&gt;";
  if($sig =~ /\((....),(....)\)$/){
    my $group = hex($1);
    my $ele = hex($2);
#    if(exists $SigToName->{$ssig}){
#      return "$SigToName->{$ssig}";
#    }
     if(exists $Posda::Dataset::DD->{Dict}->{$group}->{$ele}->{Name}){
       $name = $Posda::Dataset::DD->{Dict}->{$group}->{$ele}->{Name};
     }
  } elsif ($sig =~ /\((....),\"([^\"]+)\",(..)\)$/){
    my $group = hex($1);
    my $owner = $2;
    my $ele = hex($3);
    if(exists $Posda::Dataset::DD->{PvtDict}->{$owner}->{$group}->{$ele}){
      $name = $Posda::Dataset::DD->{PvtDict}->{$owner}->{$group}->{$ele};
    }
  }
  return $name;
}
sub ToSig{
  my($exp) = @_;
  my $sig = "";
  my $remain = $exp;
  while($remain){
    if($remain =~ /^[A-Za-z0-9]+$/){
      if(exists $NameToSig->{$remain}){
        $sig .= $NameToSig->{$remain};
        $remain = "";
      } else {
        die "$remain is not a DICOM element name";
      }
    } elsif($remain =~ /^(\(....,....\))$/) {
      my $name = $1;
      $remain = "";
      if(exists $NameToSig->{$name}){
        $sig .= $NameToSig->{$name};
      } else {
        die "$name is not a DICOM element name"
      }
    } elsif($remain =~ /^(\(....,....\))(\[\d+\])(.*)$/) {
      my $eg = $1;
      my $idx = $2;
      $remain = $3;
      $sig .= "$eg$idx";
    } elsif($remain =~ /^([A-Za-z0-9]+)(\[\d+\])(.*)$/){
      my $name = $1;
      my $idx = $2;
      $remain = $3;
      if(exists $NameToSig->{$name}){
        $sig .= "$NameToSig->{$name}$idx";
      } else {
        die "$name is not a DICOM element name"
      }
    }
  }
  return $sig;
}
1;
